#!/usr/bin/env node
/*
 * Copyright IBM Corp. 2023, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
const require = (await import("node:module")).createRequire(import.meta.url);
const __filename = (await import("node:url")).fileURLToPath(import.meta.url);
const __dirname = (await import("node:path")).dirname(__filename);

var ZJt=Object.create;var Boe=Object.defineProperty;var eqt=Object.getOwnPropertyDescriptor;var tqt=Object.getOwnPropertyNames;var rqt=Object.getPrototypeOf,nqt=Object.prototype.hasOwnProperty;var Bu=(u=>typeof require<"u"?require:typeof Proxy<"u"?new Proxy(u,{get:(c,f)=>(typeof require<"u"?require:c)[f]}):u)(function(u){if(typeof require<"u")return require.apply(this,arguments);throw Error('Dynamic require of "'+u+'" is not supported')});var kc=(u,c)=>()=>(u&&(c=u(u=0)),c);var At=(u,c)=>()=>(c||u((c={exports:{}}).exports,c),c.exports),iXe=(u,c)=>{for(var f in c)Boe(u,f,{get:c[f],enumerable:!0})},sXe=(u,c,f,v)=>{if(c&&typeof c=="object"||typeof c=="function")for(let x of tqt(c))!nqt.call(u,x)&&x!==f&&Boe(u,x,{get:()=>c[x],enumerable:!(v=eqt(c,x))||v.enumerable});return u};var cf=(u,c,f)=>(f=u!=null?ZJt(rqt(u)):{},sXe(c||!u||!u.__esModule?Boe(f,"default",{value:u,enumerable:!0}):f,u)),tl=u=>sXe(Boe({},"__esModule",{value:!0}),u);var O$=At(Pke=>{var Uoe=class extends Error{constructor(c,f,v){super(v),Error.captureStackTrace(this,this.constructor),this.name=this.constructor.name,this.code=f,this.exitCode=c,this.nestedError=void 0}},kke=class extends Uoe{constructor(c){super(1,"commander.invalidArgument",c),Error.captureStackTrace(this,this.constructor),this.name=this.constructor.name}};Pke.CommanderError=Uoe;Pke.InvalidArgumentError=kke});var Voe=At(Dke=>{var{InvalidArgumentError:iqt}=O$(),Nke=class{constructor(c,f){switch(this.description=f||"",this.variadic=!1,this.parseArg=void 0,this.defaultValue=void 0,this.defaultValueDescription=void 0,this.argChoices=void 0,c[0]){case"<":this.required=!0,this._name=c.slice(1,-1);break;case"[":this.required=!1,this._name=c.slice(1,-1);break;default:this.required=!0,this._name=c;break}this._name.length>3&&this._name.slice(-3)==="..."&&(this.variadic=!0,this._name=this._name.slice(0,-3))}name(){return this._name}_concatValue(c,f){return f===this.defaultValue||!Array.isArray(f)?[c]:f.concat(c)}default(c,f){return this.defaultValue=c,this.defaultValueDescription=f,this}argParser(c){return this.parseArg=c,this}choices(c){return this.argChoices=c.slice(),this.parseArg=(f,v)=>{if(!this.argChoices.includes(f))throw new iqt(`Allowed choices are ${this.argChoices.join(", ")}.`);return this.variadic?this._concatValue(f,v):f},this}argRequired(){return this.required=!0,this}argOptional(){return this.required=!1,this}};function sqt(u){let c=u.name()+(u.variadic===!0?"...":"");return u.required?"<"+c+">":"["+c+"]"}Dke.Argument=Nke;Dke.humanReadableArgName=sqt});var wke=At(aXe=>{var{humanReadableArgName:aqt}=Voe(),Ike=class{constructor(){this.helpWidth=void 0,this.sortSubcommands=!1,this.sortOptions=!1,this.showGlobalOptions=!1}visibleCommands(c){let f=c.commands.filter(x=>!x._hidden),v=c._getHelpCommand();return v&&!v._hidden&&f.push(v),this.sortSubcommands&&f.sort((x,w)=>x.name().localeCompare(w.name())),f}compareOptions(c,f){let v=x=>x.short?x.short.replace(/^-/,""):x.long.replace(/^--/,"");return v(c).localeCompare(v(f))}visibleOptions(c){let f=c.options.filter(x=>!x.hidden),v=c._getHelpOption();if(v&&!v.hidden){let x=v.short&&c._findOption(v.short),w=v.long&&c._findOption(v.long);!x&&!w?f.push(v):v.long&&!w?f.push(c.createOption(v.long,v.description)):v.short&&!x&&f.push(c.createOption(v.short,v.description))}return this.sortOptions&&f.sort(this.compareOptions),f}visibleGlobalOptions(c){if(!this.showGlobalOptions)return[];let f=[];for(let v=c.parent;v;v=v.parent){let x=v.options.filter(w=>!w.hidden);f.push(...x)}return this.sortOptions&&f.sort(this.compareOptions),f}visibleArguments(c){return c._argsDescription&&c.registeredArguments.forEach(f=>{f.description=f.description||c._argsDescription[f.name()]||""}),c.registeredArguments.find(f=>f.description)?c.registeredArguments:[]}subcommandTerm(c){let f=c.registeredArguments.map(v=>aqt(v)).join(" ");return c._name+(c._aliases[0]?"|"+c._aliases[0]:"")+(c.options.length?" [options]":"")+(f?" "+f:"")}optionTerm(c){return c.flags}argumentTerm(c){return c.name()}longestSubcommandTermLength(c,f){return f.visibleCommands(c).reduce((v,x)=>Math.max(v,f.subcommandTerm(x).length),0)}longestOptionTermLength(c,f){return f.visibleOptions(c).reduce((v,x)=>Math.max(v,f.optionTerm(x).length),0)}longestGlobalOptionTermLength(c,f){return f.visibleGlobalOptions(c).reduce((v,x)=>Math.max(v,f.optionTerm(x).length),0)}longestArgumentTermLength(c,f){return f.visibleArguments(c).reduce((v,x)=>Math.max(v,f.argumentTerm(x).length),0)}commandUsage(c){let f=c._name;c._aliases[0]&&(f=f+"|"+c._aliases[0]);let v="";for(let x=c.parent;x;x=x.parent)v=x.name()+" "+v;return v+f+" "+c.usage()}commandDescription(c){return c.description()}subcommandDescription(c){return c.summary()||c.description()}optionDescription(c){let f=[];return c.argChoices&&f.push(`choices: ${c.argChoices.map(v=>JSON.stringify(v)).join(", ")}`),c.defaultValue!==void 0&&(c.required||c.optional||c.isBoolean()&&typeof c.defaultValue=="boolean")&&f.push(`default: ${c.defaultValueDescription||JSON.stringify(c.defaultValue)}`),c.presetArg!==void 0&&c.optional&&f.push(`preset: ${JSON.stringify(c.presetArg)}`),c.envVar!==void 0&&f.push(`env: ${c.envVar}`),f.length>0?`${c.description} (${f.join(", ")})`:c.description}argumentDescription(c){let f=[];if(c.argChoices&&f.push(`choices: ${c.argChoices.map(v=>JSON.stringify(v)).join(", ")}`),c.defaultValue!==void 0&&f.push(`default: ${c.defaultValueDescription||JSON.stringify(c.defaultValue)}`),f.length>0){let v=`(${f.join(", ")})`;return c.description?`${c.description} ${v}`:v}return c.description}formatHelp(c,f){let v=f.padWidth(c,f),x=f.helpWidth||80,w=2,F=2;function ee(xr,en){if(en){let zn=`${xr.padEnd(v+F)}${en}`;return f.wrap(zn,x-w,v+F)}return xr}function me(xr){return xr.join(`
`).replace(/^/gm," ".repeat(w))}let de=[`Usage: ${f.commandUsage(c)}`,""],Te=f.commandDescription(c);Te.length>0&&(de=de.concat([f.wrap(Te,x,0),""]));let ut=f.visibleArguments(c).map(xr=>ee(f.argumentTerm(xr),f.argumentDescription(xr)));ut.length>0&&(de=de.concat(["Arguments:",me(ut),""]));let Ct=f.visibleOptions(c).map(xr=>ee(f.optionTerm(xr),f.optionDescription(xr)));if(Ct.length>0&&(de=de.concat(["Options:",me(Ct),""])),this.showGlobalOptions){let xr=f.visibleGlobalOptions(c).map(en=>ee(f.optionTerm(en),f.optionDescription(en)));xr.length>0&&(de=de.concat(["Global Options:",me(xr),""]))}let Kt=f.visibleCommands(c).map(xr=>ee(f.subcommandTerm(xr),f.subcommandDescription(xr)));return Kt.length>0&&(de=de.concat(["Commands:",me(Kt),""])),de.join(`
`)}padWidth(c,f){return Math.max(f.longestOptionTermLength(c,f),f.longestGlobalOptionTermLength(c,f),f.longestSubcommandTermLength(c,f),f.longestArgumentTermLength(c,f))}wrap(c,f,v,x=40){let w=" \\f\\t\\v\xA0\u1680\u2000-\u200A\u202F\u205F\u3000\uFEFF",F=new RegExp(`[\\n][${w}]+`);if(c.match(F))return c;let ee=f-v;if(ee<x)return c;let me=c.slice(0,v),de=c.slice(v).replace(`\r
`,`
`),Te=" ".repeat(v),Ct="\\s\u200B",Kt=new RegExp(`
|.{1,${ee-1}}([${Ct}]|$)|[^${Ct}]+?([${Ct}]|$)`,"g"),xr=de.match(Kt)||[];return me+xr.map((en,zn)=>en===`
`?"":(zn>0?Te:"")+en.trimEnd()).join(`
`)}};aXe.Help=Ike});var Lke=At(Mke=>{var{InvalidArgumentError:oqt}=O$(),Oke=class{constructor(c,f){this.flags=c,this.description=f||"",this.required=c.includes("<"),this.optional=c.includes("["),this.variadic=/\w\.\.\.[>\]]$/.test(c),this.mandatory=!1;let v=lqt(c);this.short=v.shortFlag,this.long=v.longFlag,this.negate=!1,this.long&&(this.negate=this.long.startsWith("--no-")),this.defaultValue=void 0,this.defaultValueDescription=void 0,this.presetArg=void 0,this.envVar=void 0,this.parseArg=void 0,this.hidden=!1,this.argChoices=void 0,this.conflictsWith=[],this.implied=void 0}default(c,f){return this.defaultValue=c,this.defaultValueDescription=f,this}preset(c){return this.presetArg=c,this}conflicts(c){return this.conflictsWith=this.conflictsWith.concat(c),this}implies(c){let f=c;return typeof c=="string"&&(f={[c]:!0}),this.implied=Object.assign(this.implied||{},f),this}env(c){return this.envVar=c,this}argParser(c){return this.parseArg=c,this}makeOptionMandatory(c=!0){return this.mandatory=!!c,this}hideHelp(c=!0){return this.hidden=!!c,this}_concatValue(c,f){return f===this.defaultValue||!Array.isArray(f)?[c]:f.concat(c)}choices(c){return this.argChoices=c.slice(),this.parseArg=(f,v)=>{if(!this.argChoices.includes(f))throw new oqt(`Allowed choices are ${this.argChoices.join(", ")}.`);return this.variadic?this._concatValue(f,v):f},this}name(){return this.long?this.long.replace(/^--/,""):this.short.replace(/^-/,"")}attributeName(){return cqt(this.name().replace(/^no-/,""))}is(c){return this.short===c||this.long===c}isBoolean(){return!this.required&&!this.optional&&!this.negate}},Rke=class{constructor(c){this.positiveOptions=new Map,this.negativeOptions=new Map,this.dualOptions=new Set,c.forEach(f=>{f.negate?this.negativeOptions.set(f.attributeName(),f):this.positiveOptions.set(f.attributeName(),f)}),this.negativeOptions.forEach((f,v)=>{this.positiveOptions.has(v)&&this.dualOptions.add(v)})}valueFromOption(c,f){let v=f.attributeName();if(!this.dualOptions.has(v))return!0;let x=this.negativeOptions.get(v).presetArg,w=x!==void 0?x:!1;return f.negate===(w===c)}};function cqt(u){return u.split("-").reduce((c,f)=>c+f[0].toUpperCase()+f.slice(1))}function lqt(u){let c,f,v=u.split(/[ |,]+/);return v.length>1&&!/^[[<]/.test(v[1])&&(c=v.shift()),f=v.shift(),!c&&/^-[^-]$/.test(f)&&(c=f,f=void 0),{shortFlag:c,longFlag:f}}Mke.Option=Oke;Mke.DualOptions=Rke});var cXe=At(oXe=>{function uqt(u,c){if(Math.abs(u.length-c.length)>3)return Math.max(u.length,c.length);let f=[];for(let v=0;v<=u.length;v++)f[v]=[v];for(let v=0;v<=c.length;v++)f[0][v]=v;for(let v=1;v<=c.length;v++)for(let x=1;x<=u.length;x++){let w=1;u[x-1]===c[v-1]?w=0:w=1,f[x][v]=Math.min(f[x-1][v]+1,f[x][v-1]+1,f[x-1][v-1]+w),x>1&&v>1&&u[x-1]===c[v-2]&&u[x-2]===c[v-1]&&(f[x][v]=Math.min(f[x][v],f[x-2][v-2]+1))}return f[u.length][c.length]}function _qt(u,c){if(!c||c.length===0)return"";c=Array.from(new Set(c));let f=u.startsWith("--");f&&(u=u.slice(2),c=c.map(F=>F.slice(2)));let v=[],x=3,w=.4;return c.forEach(F=>{if(F.length<=1)return;let ee=uqt(u,F),me=Math.max(u.length,F.length);(me-ee)/me>w&&(ee<x?(x=ee,v=[F]):ee===x&&v.push(F))}),v.sort((F,ee)=>F.localeCompare(ee)),f&&(v=v.map(F=>`--${F}`)),v.length>1?`
(Did you mean one of ${v.join(", ")}?)`:v.length===1?`
(Did you mean ${v[0]}?)`:""}oXe.suggestSimilar=_qt});var pXe=At(fXe=>{var fqt=Bu("events").EventEmitter,Fke=Bu("child_process"),gP=Bu("path"),jke=Bu("fs"),Yd=Bu("process"),{Argument:pqt,humanReadableArgName:dqt}=Voe(),{CommanderError:Bke}=O$(),{Help:mqt}=wke(),{Option:lXe,DualOptions:gqt}=Lke(),{suggestSimilar:uXe}=cXe(),Uke=class u extends fqt{constructor(c){super(),this.commands=[],this.options=[],this.parent=null,this._allowUnknownOption=!1,this._allowExcessArguments=!0,this.registeredArguments=[],this._args=this.registeredArguments,this.args=[],this.rawArgs=[],this.processedArgs=[],this._scriptPath=null,this._name=c||"",this._optionValues={},this._optionValueSources={},this._storeOptionsAsProperties=!1,this._actionHandler=null,this._executableHandler=!1,this._executableFile=null,this._executableDir=null,this._defaultCommandName=null,this._exitCallback=null,this._aliases=[],this._combineFlagAndOptionalValue=!0,this._description="",this._summary="",this._argsDescription=void 0,this._enablePositionalOptions=!1,this._passThroughOptions=!1,this._lifeCycleHooks={},this._showHelpAfterError=!1,this._showSuggestionAfterError=!0,this._outputConfiguration={writeOut:f=>Yd.stdout.write(f),writeErr:f=>Yd.stderr.write(f),getOutHelpWidth:()=>Yd.stdout.isTTY?Yd.stdout.columns:void 0,getErrHelpWidth:()=>Yd.stderr.isTTY?Yd.stderr.columns:void 0,outputError:(f,v)=>v(f)},this._hidden=!1,this._helpOption=void 0,this._addImplicitHelpCommand=void 0,this._helpCommand=void 0,this._helpConfiguration={}}copyInheritedSettings(c){return this._outputConfiguration=c._outputConfiguration,this._helpOption=c._helpOption,this._helpCommand=c._helpCommand,this._helpConfiguration=c._helpConfiguration,this._exitCallback=c._exitCallback,this._storeOptionsAsProperties=c._storeOptionsAsProperties,this._combineFlagAndOptionalValue=c._combineFlagAndOptionalValue,this._allowExcessArguments=c._allowExcessArguments,this._enablePositionalOptions=c._enablePositionalOptions,this._showHelpAfterError=c._showHelpAfterError,this._showSuggestionAfterError=c._showSuggestionAfterError,this}_getCommandAndAncestors(){let c=[];for(let f=this;f;f=f.parent)c.push(f);return c}command(c,f,v){let x=f,w=v;typeof x=="object"&&x!==null&&(w=x,x=null),w=w||{};let[,F,ee]=c.match(/([^ ]+) *(.*)/),me=this.createCommand(F);return x&&(me.description(x),me._executableHandler=!0),w.isDefault&&(this._defaultCommandName=me._name),me._hidden=!!(w.noHelp||w.hidden),me._executableFile=w.executableFile||null,ee&&me.arguments(ee),this._registerCommand(me),me.parent=this,me.copyInheritedSettings(this),x?this:me}createCommand(c){return new u(c)}createHelp(){return Object.assign(new mqt,this.configureHelp())}configureHelp(c){return c===void 0?this._helpConfiguration:(this._helpConfiguration=c,this)}configureOutput(c){return c===void 0?this._outputConfiguration:(Object.assign(this._outputConfiguration,c),this)}showHelpAfterError(c=!0){return typeof c!="string"&&(c=!!c),this._showHelpAfterError=c,this}showSuggestionAfterError(c=!0){return this._showSuggestionAfterError=!!c,this}addCommand(c,f){if(!c._name)throw new Error(`Command passed to .addCommand() must have a name
- specify the name in Command constructor or using .name()`);return f=f||{},f.isDefault&&(this._defaultCommandName=c._name),(f.noHelp||f.hidden)&&(c._hidden=!0),this._registerCommand(c),c.parent=this,c._checkForBrokenPassThrough(),this}createArgument(c,f){return new pqt(c,f)}argument(c,f,v,x){let w=this.createArgument(c,f);return typeof v=="function"?w.default(x).argParser(v):w.default(v),this.addArgument(w),this}arguments(c){return c.trim().split(/ +/).forEach(f=>{this.argument(f)}),this}addArgument(c){let f=this.registeredArguments.slice(-1)[0];if(f&&f.variadic)throw new Error(`only the last argument can be variadic '${f.name()}'`);if(c.required&&c.defaultValue!==void 0&&c.parseArg===void 0)throw new Error(`a default value for a required argument is never used: '${c.name()}'`);return this.registeredArguments.push(c),this}helpCommand(c,f){if(typeof c=="boolean")return this._addImplicitHelpCommand=c,this;c=c??"help [command]";let[,v,x]=c.match(/([^ ]+) *(.*)/),w=f??"display help for command",F=this.createCommand(v);return F.helpOption(!1),x&&F.arguments(x),w&&F.description(w),this._addImplicitHelpCommand=!0,this._helpCommand=F,this}addHelpCommand(c,f){return typeof c!="object"?(this.helpCommand(c,f),this):(this._addImplicitHelpCommand=!0,this._helpCommand=c,this)}_getHelpCommand(){return this._addImplicitHelpCommand??(this.commands.length&&!this._actionHandler&&!this._findCommand("help"))?(this._helpCommand===void 0&&this.helpCommand(void 0,void 0),this._helpCommand):null}hook(c,f){let v=["preSubcommand","preAction","postAction"];if(!v.includes(c))throw new Error(`Unexpected value for event passed to hook : '${c}'.
Expecting one of '${v.join("', '")}'`);return this._lifeCycleHooks[c]?this._lifeCycleHooks[c].push(f):this._lifeCycleHooks[c]=[f],this}exitOverride(c){return c?this._exitCallback=c:this._exitCallback=f=>{if(f.code!=="commander.executeSubCommandAsync")throw f},this}_exit(c,f,v){this._exitCallback&&this._exitCallback(new Bke(c,f,v)),Yd.exit(c)}action(c){let f=v=>{let x=this.registeredArguments.length,w=v.slice(0,x);return this._storeOptionsAsProperties?w[x]=this:w[x]=this.opts(),w.push(this),c.apply(this,w)};return this._actionHandler=f,this}createOption(c,f){return new lXe(c,f)}_callParseArg(c,f,v,x){try{return c.parseArg(f,v)}catch(w){if(w.code==="commander.invalidArgument"){let F=`${x} ${w.message}`;this.error(F,{exitCode:w.exitCode,code:w.code})}throw w}}_registerOption(c){let f=c.short&&this._findOption(c.short)||c.long&&this._findOption(c.long);if(f){let v=c.long&&this._findOption(c.long)?c.long:c.short;throw new Error(`Cannot add option '${c.flags}'${this._name&&` to command '${this._name}'`} due to conflicting flag '${v}'
-  already used by option '${f.flags}'`)}this.options.push(c)}_registerCommand(c){let f=x=>[x.name()].concat(x.aliases()),v=f(c).find(x=>this._findCommand(x));if(v){let x=f(this._findCommand(v)).join("|"),w=f(c).join("|");throw new Error(`cannot add command '${w}' as already have command '${x}'`)}this.commands.push(c)}addOption(c){this._registerOption(c);let f=c.name(),v=c.attributeName();if(c.negate){let w=c.long.replace(/^--no-/,"--");this._findOption(w)||this.setOptionValueWithSource(v,c.defaultValue===void 0?!0:c.defaultValue,"default")}else c.defaultValue!==void 0&&this.setOptionValueWithSource(v,c.defaultValue,"default");let x=(w,F,ee)=>{w==null&&c.presetArg!==void 0&&(w=c.presetArg);let me=this.getOptionValue(v);w!==null&&c.parseArg?w=this._callParseArg(c,w,me,F):w!==null&&c.variadic&&(w=c._concatValue(w,me)),w==null&&(c.negate?w=!1:c.isBoolean()||c.optional?w=!0:w=""),this.setOptionValueWithSource(v,w,ee)};return this.on("option:"+f,w=>{let F=`error: option '${c.flags}' argument '${w}' is invalid.`;x(w,F,"cli")}),c.envVar&&this.on("optionEnv:"+f,w=>{let F=`error: option '${c.flags}' value '${w}' from env '${c.envVar}' is invalid.`;x(w,F,"env")}),this}_optionEx(c,f,v,x,w){if(typeof f=="object"&&f instanceof lXe)throw new Error("To add an Option object use addOption() instead of option() or requiredOption()");let F=this.createOption(f,v);if(F.makeOptionMandatory(!!c.mandatory),typeof x=="function")F.default(w).argParser(x);else if(x instanceof RegExp){let ee=x;x=(me,de)=>{let Te=ee.exec(me);return Te?Te[0]:de},F.default(w).argParser(x)}else F.default(x);return this.addOption(F)}option(c,f,v,x){return this._optionEx({},c,f,v,x)}requiredOption(c,f,v,x){return this._optionEx({mandatory:!0},c,f,v,x)}combineFlagAndOptionalValue(c=!0){return this._combineFlagAndOptionalValue=!!c,this}allowUnknownOption(c=!0){return this._allowUnknownOption=!!c,this}allowExcessArguments(c=!0){return this._allowExcessArguments=!!c,this}enablePositionalOptions(c=!0){return this._enablePositionalOptions=!!c,this}passThroughOptions(c=!0){return this._passThroughOptions=!!c,this._checkForBrokenPassThrough(),this}_checkForBrokenPassThrough(){if(this.parent&&this._passThroughOptions&&!this.parent._enablePositionalOptions)throw new Error(`passThroughOptions cannot be used for '${this._name}' without turning on enablePositionalOptions for parent command(s)`)}storeOptionsAsProperties(c=!0){if(this.options.length)throw new Error("call .storeOptionsAsProperties() before adding options");if(Object.keys(this._optionValues).length)throw new Error("call .storeOptionsAsProperties() before setting option values");return this._storeOptionsAsProperties=!!c,this}getOptionValue(c){return this._storeOptionsAsProperties?this[c]:this._optionValues[c]}setOptionValue(c,f){return this.setOptionValueWithSource(c,f,void 0)}setOptionValueWithSource(c,f,v){return this._storeOptionsAsProperties?this[c]=f:this._optionValues[c]=f,this._optionValueSources[c]=v,this}getOptionValueSource(c){return this._optionValueSources[c]}getOptionValueSourceWithGlobals(c){let f;return this._getCommandAndAncestors().forEach(v=>{v.getOptionValueSource(c)!==void 0&&(f=v.getOptionValueSource(c))}),f}_prepareUserArgs(c,f){if(c!==void 0&&!Array.isArray(c))throw new Error("first parameter to parse must be array or undefined");if(f=f||{},c===void 0&&f.from===void 0){Yd.versions?.electron&&(f.from="electron");let x=Yd.execArgv??[];(x.includes("-e")||x.includes("--eval")||x.includes("-p")||x.includes("--print"))&&(f.from="eval")}c===void 0&&(c=Yd.argv),this.rawArgs=c.slice();let v;switch(f.from){case void 0:case"node":this._scriptPath=c[1],v=c.slice(2);break;case"electron":Yd.defaultApp?(this._scriptPath=c[1],v=c.slice(2)):v=c.slice(1);break;case"user":v=c.slice(0);break;case"eval":v=c.slice(1);break;default:throw new Error(`unexpected parse option { from: '${f.from}' }`)}return!this._name&&this._scriptPath&&this.nameFromFilename(this._scriptPath),this._name=this._name||"program",v}parse(c,f){let v=this._prepareUserArgs(c,f);return this._parseCommand([],v),this}async parseAsync(c,f){let v=this._prepareUserArgs(c,f);return await this._parseCommand([],v),this}_executeSubCommand(c,f){f=f.slice();let v=!1,x=[".js",".ts",".tsx",".mjs",".cjs"];function w(Te,ut){let Ct=gP.resolve(Te,ut);if(jke.existsSync(Ct))return Ct;if(x.includes(gP.extname(ut)))return;let Kt=x.find(xr=>jke.existsSync(`${Ct}${xr}`));if(Kt)return`${Ct}${Kt}`}this._checkForMissingMandatoryOptions(),this._checkForConflictingOptions();let F=c._executableFile||`${this._name}-${c._name}`,ee=this._executableDir||"";if(this._scriptPath){let Te;try{Te=jke.realpathSync(this._scriptPath)}catch{Te=this._scriptPath}ee=gP.resolve(gP.dirname(Te),ee)}if(ee){let Te=w(ee,F);if(!Te&&!c._executableFile&&this._scriptPath){let ut=gP.basename(this._scriptPath,gP.extname(this._scriptPath));ut!==this._name&&(Te=w(ee,`${ut}-${c._name}`))}F=Te||F}v=x.includes(gP.extname(F));let me;Yd.platform!=="win32"?v?(f.unshift(F),f=_Xe(Yd.execArgv).concat(f),me=Fke.spawn(Yd.argv[0],f,{stdio:"inherit"})):me=Fke.spawn(F,f,{stdio:"inherit"}):(f.unshift(F),f=_Xe(Yd.execArgv).concat(f),me=Fke.spawn(Yd.execPath,f,{stdio:"inherit"})),me.killed||["SIGUSR1","SIGUSR2","SIGTERM","SIGINT","SIGHUP"].forEach(ut=>{Yd.on(ut,()=>{me.killed===!1&&me.exitCode===null&&me.kill(ut)})});let de=this._exitCallback;me.on("close",Te=>{Te=Te??1,de?de(new Bke(Te,"commander.executeSubCommandAsync","(close)")):Yd.exit(Te)}),me.on("error",Te=>{if(Te.code==="ENOENT"){let ut=ee?`searched for local subcommand relative to directory '${ee}'`:"no directory for search for local subcommand, use .executableDir() to supply a custom directory",Ct=`'${F}' does not exist
 - if '${c._name}' is not meant to be an executable command, remove description parameter from '.command()' and use '.description()' instead
 - if the default executable name is not suitable, use the executableFile option to supply a custom name or path
 - ${ut}`;throw new Error(Ct)}else if(Te.code==="EACCES")throw new Error(`'${F}' not executable`);if(!de)Yd.exit(1);else{let ut=new Bke(1,"commander.executeSubCommandAsync","(error)");ut.nestedError=Te,de(ut)}}),this.runningCommand=me}_dispatchSubcommand(c,f,v){let x=this._findCommand(c);x||this.help({error:!0});let w;return w=this._chainOrCallSubCommandHook(w,x,"preSubcommand"),w=this._chainOrCall(w,()=>{if(x._executableHandler)this._executeSubCommand(x,f.concat(v));else return x._parseCommand(f,v)}),w}_dispatchHelpCommand(c){c||this.help();let f=this._findCommand(c);return f&&!f._executableHandler&&f.help(),this._dispatchSubcommand(c,[],[this._getHelpOption()?.long??this._getHelpOption()?.short??"--help"])}_checkNumberOfArguments(){this.registeredArguments.forEach((c,f)=>{c.required&&this.args[f]==null&&this.missingArgument(c.name())}),!(this.registeredArguments.length>0&&this.registeredArguments[this.registeredArguments.length-1].variadic)&&this.args.length>this.registeredArguments.length&&this._excessArguments(this.args)}_processArguments(){let c=(v,x,w)=>{let F=x;if(x!==null&&v.parseArg){let ee=`error: command-argument value '${x}' is invalid for argument '${v.name()}'.`;F=this._callParseArg(v,x,w,ee)}return F};this._checkNumberOfArguments();let f=[];this.registeredArguments.forEach((v,x)=>{let w=v.defaultValue;v.variadic?x<this.args.length?(w=this.args.slice(x),v.parseArg&&(w=w.reduce((F,ee)=>c(v,ee,F),v.defaultValue))):w===void 0&&(w=[]):x<this.args.length&&(w=this.args[x],v.parseArg&&(w=c(v,w,v.defaultValue))),f[x]=w}),this.processedArgs=f}_chainOrCall(c,f){return c&&c.then&&typeof c.then=="function"?c.then(()=>f()):f()}_chainOrCallHooks(c,f){let v=c,x=[];return this._getCommandAndAncestors().reverse().filter(w=>w._lifeCycleHooks[f]!==void 0).forEach(w=>{w._lifeCycleHooks[f].forEach(F=>{x.push({hookedCommand:w,callback:F})})}),f==="postAction"&&x.reverse(),x.forEach(w=>{v=this._chainOrCall(v,()=>w.callback(w.hookedCommand,this))}),v}_chainOrCallSubCommandHook(c,f,v){let x=c;return this._lifeCycleHooks[v]!==void 0&&this._lifeCycleHooks[v].forEach(w=>{x=this._chainOrCall(x,()=>w(this,f))}),x}_parseCommand(c,f){let v=this.parseOptions(f);if(this._parseOptionsEnv(),this._parseOptionsImplied(),c=c.concat(v.operands),f=v.unknown,this.args=c.concat(f),c&&this._findCommand(c[0]))return this._dispatchSubcommand(c[0],c.slice(1),f);if(this._getHelpCommand()&&c[0]===this._getHelpCommand().name())return this._dispatchHelpCommand(c[1]);if(this._defaultCommandName)return this._outputHelpIfRequested(f),this._dispatchSubcommand(this._defaultCommandName,c,f);this.commands.length&&this.args.length===0&&!this._actionHandler&&!this._defaultCommandName&&this.help({error:!0}),this._outputHelpIfRequested(v.unknown),this._checkForMissingMandatoryOptions(),this._checkForConflictingOptions();let x=()=>{v.unknown.length>0&&this.unknownOption(v.unknown[0])},w=`command:${this.name()}`;if(this._actionHandler){x(),this._processArguments();let F;return F=this._chainOrCallHooks(F,"preAction"),F=this._chainOrCall(F,()=>this._actionHandler(this.processedArgs)),this.parent&&(F=this._chainOrCall(F,()=>{this.parent.emit(w,c,f)})),F=this._chainOrCallHooks(F,"postAction"),F}if(this.parent&&this.parent.listenerCount(w))x(),this._processArguments(),this.parent.emit(w,c,f);else if(c.length){if(this._findCommand("*"))return this._dispatchSubcommand("*",c,f);this.listenerCount("command:*")?this.emit("command:*",c,f):this.commands.length?this.unknownCommand():(x(),this._processArguments())}else this.commands.length?(x(),this.help({error:!0})):(x(),this._processArguments())}_findCommand(c){if(c)return this.commands.find(f=>f._name===c||f._aliases.includes(c))}_findOption(c){return this.options.find(f=>f.is(c))}_checkForMissingMandatoryOptions(){this._getCommandAndAncestors().forEach(c=>{c.options.forEach(f=>{f.mandatory&&c.getOptionValue(f.attributeName())===void 0&&c.missingMandatoryOptionValue(f)})})}_checkForConflictingLocalOptions(){let c=this.options.filter(v=>{let x=v.attributeName();return this.getOptionValue(x)===void 0?!1:this.getOptionValueSource(x)!=="default"});c.filter(v=>v.conflictsWith.length>0).forEach(v=>{let x=c.find(w=>v.conflictsWith.includes(w.attributeName()));x&&this._conflictingOption(v,x)})}_checkForConflictingOptions(){this._getCommandAndAncestors().forEach(c=>{c._checkForConflictingLocalOptions()})}parseOptions(c){let f=[],v=[],x=f,w=c.slice();function F(me){return me.length>1&&me[0]==="-"}let ee=null;for(;w.length;){let me=w.shift();if(me==="--"){x===v&&x.push(me),x.push(...w);break}if(ee&&!F(me)){this.emit(`option:${ee.name()}`,me);continue}if(ee=null,F(me)){let de=this._findOption(me);if(de){if(de.required){let Te=w.shift();Te===void 0&&this.optionMissingArgument(de),this.emit(`option:${de.name()}`,Te)}else if(de.optional){let Te=null;w.length>0&&!F(w[0])&&(Te=w.shift()),this.emit(`option:${de.name()}`,Te)}else this.emit(`option:${de.name()}`);ee=de.variadic?de:null;continue}}if(me.length>2&&me[0]==="-"&&me[1]!=="-"){let de=this._findOption(`-${me[1]}`);if(de){de.required||de.optional&&this._combineFlagAndOptionalValue?this.emit(`option:${de.name()}`,me.slice(2)):(this.emit(`option:${de.name()}`),w.unshift(`-${me.slice(2)}`));continue}}if(/^--[^=]+=/.test(me)){let de=me.indexOf("="),Te=this._findOption(me.slice(0,de));if(Te&&(Te.required||Te.optional)){this.emit(`option:${Te.name()}`,me.slice(de+1));continue}}if(F(me)&&(x=v),(this._enablePositionalOptions||this._passThroughOptions)&&f.length===0&&v.length===0){if(this._findCommand(me)){f.push(me),w.length>0&&v.push(...w);break}else if(this._getHelpCommand()&&me===this._getHelpCommand().name()){f.push(me),w.length>0&&f.push(...w);break}else if(this._defaultCommandName){v.push(me),w.length>0&&v.push(...w);break}}if(this._passThroughOptions){x.push(me),w.length>0&&x.push(...w);break}x.push(me)}return{operands:f,unknown:v}}opts(){if(this._storeOptionsAsProperties){let c={},f=this.options.length;for(let v=0;v<f;v++){let x=this.options[v].attributeName();c[x]=x===this._versionOptionName?this._version:this[x]}return c}return this._optionValues}optsWithGlobals(){return this._getCommandAndAncestors().reduce((c,f)=>Object.assign(c,f.opts()),{})}error(c,f){this._outputConfiguration.outputError(`${c}
`,this._outputConfiguration.writeErr),typeof this._showHelpAfterError=="string"?this._outputConfiguration.writeErr(`${this._showHelpAfterError}
`):this._showHelpAfterError&&(this._outputConfiguration.writeErr(`
`),this.outputHelp({error:!0}));let v=f||{},x=v.exitCode||1,w=v.code||"commander.error";this._exit(x,w,c)}_parseOptionsEnv(){this.options.forEach(c=>{if(c.envVar&&c.envVar in Yd.env){let f=c.attributeName();(this.getOptionValue(f)===void 0||["default","config","env"].includes(this.getOptionValueSource(f)))&&(c.required||c.optional?this.emit(`optionEnv:${c.name()}`,Yd.env[c.envVar]):this.emit(`optionEnv:${c.name()}`))}})}_parseOptionsImplied(){let c=new gqt(this.options),f=v=>this.getOptionValue(v)!==void 0&&!["default","implied"].includes(this.getOptionValueSource(v));this.options.filter(v=>v.implied!==void 0&&f(v.attributeName())&&c.valueFromOption(this.getOptionValue(v.attributeName()),v)).forEach(v=>{Object.keys(v.implied).filter(x=>!f(x)).forEach(x=>{this.setOptionValueWithSource(x,v.implied[x],"implied")})})}missingArgument(c){let f=`error: missing required argument '${c}'`;this.error(f,{code:"commander.missingArgument"})}optionMissingArgument(c){let f=`error: option '${c.flags}' argument missing`;this.error(f,{code:"commander.optionMissingArgument"})}missingMandatoryOptionValue(c){let f=`error: required option '${c.flags}' not specified`;this.error(f,{code:"commander.missingMandatoryOptionValue"})}_conflictingOption(c,f){let v=F=>{let ee=F.attributeName(),me=this.getOptionValue(ee),de=this.options.find(ut=>ut.negate&&ee===ut.attributeName()),Te=this.options.find(ut=>!ut.negate&&ee===ut.attributeName());return de&&(de.presetArg===void 0&&me===!1||de.presetArg!==void 0&&me===de.presetArg)?de:Te||F},x=F=>{let ee=v(F),me=ee.attributeName();return this.getOptionValueSource(me)==="env"?`environment variable '${ee.envVar}'`:`option '${ee.flags}'`},w=`error: ${x(c)} cannot be used with ${x(f)}`;this.error(w,{code:"commander.conflictingOption"})}unknownOption(c){if(this._allowUnknownOption)return;let f="";if(c.startsWith("--")&&this._showSuggestionAfterError){let x=[],w=this;do{let F=w.createHelp().visibleOptions(w).filter(ee=>ee.long).map(ee=>ee.long);x=x.concat(F),w=w.parent}while(w&&!w._enablePositionalOptions);f=uXe(c,x)}let v=`error: unknown option '${c}'${f}`;this.error(v,{code:"commander.unknownOption"})}_excessArguments(c){if(this._allowExcessArguments)return;let f=this.registeredArguments.length,v=f===1?"":"s",w=`error: too many arguments${this.parent?` for '${this.name()}'`:""}. Expected ${f} argument${v} but got ${c.length}.`;this.error(w,{code:"commander.excessArguments"})}unknownCommand(){let c=this.args[0],f="";if(this._showSuggestionAfterError){let x=[];this.createHelp().visibleCommands(this).forEach(w=>{x.push(w.name()),w.alias()&&x.push(w.alias())}),f=uXe(c,x)}let v=`error: unknown command '${c}'${f}`;this.error(v,{code:"commander.unknownCommand"})}version(c,f,v){if(c===void 0)return this._version;this._version=c,f=f||"-V, --version",v=v||"output the version number";let x=this.createOption(f,v);return this._versionOptionName=x.attributeName(),this._registerOption(x),this.on("option:"+x.name(),()=>{this._outputConfiguration.writeOut(`${c}
`),this._exit(0,"commander.version",c)}),this}description(c,f){return c===void 0&&f===void 0?this._description:(this._description=c,f&&(this._argsDescription=f),this)}summary(c){return c===void 0?this._summary:(this._summary=c,this)}alias(c){if(c===void 0)return this._aliases[0];let f=this;if(this.commands.length!==0&&this.commands[this.commands.length-1]._executableHandler&&(f=this.commands[this.commands.length-1]),c===f._name)throw new Error("Command alias can't be the same as its name");let v=this.parent?._findCommand(c);if(v){let x=[v.name()].concat(v.aliases()).join("|");throw new Error(`cannot add alias '${c}' to command '${this.name()}' as already have command '${x}'`)}return f._aliases.push(c),this}aliases(c){return c===void 0?this._aliases:(c.forEach(f=>this.alias(f)),this)}usage(c){if(c===void 0){if(this._usage)return this._usage;let f=this.registeredArguments.map(v=>dqt(v));return[].concat(this.options.length||this._helpOption!==null?"[options]":[],this.commands.length?"[command]":[],this.registeredArguments.length?f:[]).join(" ")}return this._usage=c,this}name(c){return c===void 0?this._name:(this._name=c,this)}nameFromFilename(c){return this._name=gP.basename(c,gP.extname(c)),this}executableDir(c){return c===void 0?this._executableDir:(this._executableDir=c,this)}helpInformation(c){let f=this.createHelp();return f.helpWidth===void 0&&(f.helpWidth=c&&c.error?this._outputConfiguration.getErrHelpWidth():this._outputConfiguration.getOutHelpWidth()),f.formatHelp(this,f)}_getHelpContext(c){c=c||{};let f={error:!!c.error},v;return f.error?v=x=>this._outputConfiguration.writeErr(x):v=x=>this._outputConfiguration.writeOut(x),f.write=c.write||v,f.command=this,f}outputHelp(c){let f;typeof c=="function"&&(f=c,c=void 0);let v=this._getHelpContext(c);this._getCommandAndAncestors().reverse().forEach(w=>w.emit("beforeAllHelp",v)),this.emit("beforeHelp",v);let x=this.helpInformation(v);if(f&&(x=f(x),typeof x!="string"&&!Buffer.isBuffer(x)))throw new Error("outputHelp callback must return a string or a Buffer");v.write(x),this._getHelpOption()?.long&&this.emit(this._getHelpOption().long),this.emit("afterHelp",v),this._getCommandAndAncestors().forEach(w=>w.emit("afterAllHelp",v))}helpOption(c,f){return typeof c=="boolean"?(c?this._helpOption=this._helpOption??void 0:this._helpOption=null,this):(c=c??"-h, --help",f=f??"display help for command",this._helpOption=this.createOption(c,f),this)}_getHelpOption(){return this._helpOption===void 0&&this.helpOption(void 0,void 0),this._helpOption}addHelpOption(c){return this._helpOption=c,this}help(c){this.outputHelp(c);let f=Yd.exitCode||0;f===0&&c&&typeof c!="function"&&c.error&&(f=1),this._exit(f,"commander.help","(outputHelp)")}addHelpText(c,f){let v=["beforeAll","before","after","afterAll"];if(!v.includes(c))throw new Error(`Unexpected value for position to addHelpText.
Expecting one of '${v.join("', '")}'`);let x=`${c}Help`;return this.on(x,w=>{let F;typeof f=="function"?F=f({error:w.error,command:w.command}):F=f,F&&w.write(`${F}
`)}),this}_outputHelpIfRequested(c){let f=this._getHelpOption();f&&c.find(x=>f.is(x))&&(this.outputHelp(),this._exit(0,"commander.helpDisplayed","(outputHelp)"))}};function _Xe(u){return u.map(c=>{if(!c.startsWith("--inspect"))return c;let f,v="127.0.0.1",x="9229",w;return(w=c.match(/^(--inspect(-brk)?)$/))!==null?f=w[1]:(w=c.match(/^(--inspect(-brk|-port)?)=([^:]+)$/))!==null?(f=w[1],/^\d+$/.test(w[3])?x=w[3]:v=w[3]):(w=c.match(/^(--inspect(-brk|-port)?)=([^:]+):(\d+)$/))!==null&&(f=w[1],v=w[3],x=w[4]),f&&x!=="0"?`${f}=${v}:${parseInt(x)+1}`:c})}fXe.Command=Uke});var hXe=At(bb=>{var{Argument:dXe}=Voe(),{Command:Vke}=pXe(),{CommanderError:hqt,InvalidArgumentError:mXe}=O$(),{Help:yqt}=wke(),{Option:gXe}=Lke();bb.program=new Vke;bb.createCommand=u=>new Vke(u);bb.createOption=(u,c)=>new gXe(u,c);bb.createArgument=(u,c)=>new dXe(u,c);bb.Command=Vke;bb.Option=gXe;bb.Argument=dXe;bb.Help=yqt;bb.CommanderError=hqt;bb.InvalidArgumentError=mXe;bb.InvalidOptionArgumentError=mXe});var SXe,TXe=kc(()=>{SXe=typeof globalThis=="object"?globalThis:global});var bXe=kc(()=>{TXe()});var EXe=kc(()=>{bXe()});var hP,qke=kc(()=>{hP="1.8.0"});function Iqt(u){var c=new Set([u]),f=new Set,v=u.match(xXe);if(!v)return function(){return!1};var x={major:+v[1],minor:+v[2],patch:+v[3],prerelease:v[4]};if(x.prerelease!=null)return function(me){return me===u};function w(ee){return f.add(ee),!1}function F(ee){return c.add(ee),!0}return function(me){if(c.has(me))return!0;if(f.has(me))return!1;var de=me.match(xXe);if(!de)return w(me);var Te={major:+de[1],minor:+de[2],patch:+de[3],prerelease:de[4]};return Te.prerelease!=null||x.major!==Te.major?w(me):x.major===0?x.minor===Te.minor&&x.patch<=Te.patch?F(me):w(me):x.minor<=Te.minor?F(me):w(me)}}var xXe,CXe,AXe=kc(()=>{qke();xXe=/^(\d+)\.(\d+)\.(\d+)(-(.+))?$/;CXe=Iqt(hP)});function RC(u,c,f,v){var x;v===void 0&&(v=!1);var w=M$[R$]=(x=M$[R$])!==null&&x!==void 0?x:{version:hP};if(!v&&w[u]){var F=new Error("@opentelemetry/api: Attempted duplicate registration of API: "+u);return f.error(F.stack||F.message),!1}if(w.version!==hP){var F=new Error("@opentelemetry/api: Registration of version v"+w.version+" for "+u+" does not match previously registered API v"+hP);return f.error(F.stack||F.message),!1}return w[u]=c,f.debug("@opentelemetry/api: Registered a global for "+u+" v"+hP+"."),!0}function KS(u){var c,f,v=(c=M$[R$])===null||c===void 0?void 0:c.version;if(!(!v||!CXe(v)))return(f=M$[R$])===null||f===void 0?void 0:f[u]}function MC(u,c){c.debug("@opentelemetry/api: Unregistering a global for "+u+" v"+hP+".");var f=M$[R$];f&&delete f[u]}var wqt,R$,M$,F4=kc(()=>{EXe();qke();AXe();wqt=hP.split(".")[0],R$=Symbol.for("opentelemetry.js.api."+wqt),M$=SXe});function L$(u,c,f){var v=KS("diag");if(v)return f.unshift(c),v[u].apply(v,Rqt([],Oqt(f),!1))}var Oqt,Rqt,kXe,PXe=kc(()=>{F4();Oqt=function(u,c){var f=typeof Symbol=="function"&&u[Symbol.iterator];if(!f)return u;var v=f.call(u),x,w=[],F;try{for(;(c===void 0||c-- >0)&&!(x=v.next()).done;)w.push(x.value)}catch(ee){F={error:ee}}finally{try{x&&!x.done&&(f=v.return)&&f.call(v)}finally{if(F)throw F.error}}return w},Rqt=function(u,c,f){if(f||arguments.length===2)for(var v=0,x=c.length,w;v<x;v++)(w||!(v in c))&&(w||(w=Array.prototype.slice.call(c,0,v)),w[v]=c[v]);return u.concat(w||Array.prototype.slice.call(c))},kXe=function(){function u(c){this._namespace=c.namespace||"DiagComponentLogger"}return u.prototype.debug=function(){for(var c=[],f=0;f<arguments.length;f++)c[f]=arguments[f];return L$("debug",this._namespace,c)},u.prototype.error=function(){for(var c=[],f=0;f<arguments.length;f++)c[f]=arguments[f];return L$("error",this._namespace,c)},u.prototype.info=function(){for(var c=[],f=0;f<arguments.length;f++)c[f]=arguments[f];return L$("info",this._namespace,c)},u.prototype.warn=function(){for(var c=[],f=0;f<arguments.length;f++)c[f]=arguments[f];return L$("warn",this._namespace,c)},u.prototype.verbose=function(){for(var c=[],f=0;f<arguments.length;f++)c[f]=arguments[f];return L$("verbose",this._namespace,c)},u}()});var f0,Joe=kc(()=>{(function(u){u[u.NONE=0]="NONE",u[u.ERROR=30]="ERROR",u[u.WARN=50]="WARN",u[u.INFO=60]="INFO",u[u.DEBUG=70]="DEBUG",u[u.VERBOSE=80]="VERBOSE",u[u.ALL=9999]="ALL"})(f0||(f0={}))});function NXe(u,c){u<f0.NONE?u=f0.NONE:u>f0.ALL&&(u=f0.ALL),c=c||{};function f(v,x){var w=c[v];return typeof w=="function"&&u>=x?w.bind(c):function(){}}return{error:f("error",f0.ERROR),warn:f("warn",f0.WARN),info:f("info",f0.INFO),debug:f("debug",f0.DEBUG),verbose:f("verbose",f0.VERBOSE)}}var DXe=kc(()=>{Joe()});var Mqt,Lqt,Fqt,ty,j4=kc(()=>{PXe();DXe();Joe();F4();Mqt=function(u,c){var f=typeof Symbol=="function"&&u[Symbol.iterator];if(!f)return u;var v=f.call(u),x,w=[],F;try{for(;(c===void 0||c-- >0)&&!(x=v.next()).done;)w.push(x.value)}catch(ee){F={error:ee}}finally{try{x&&!x.done&&(f=v.return)&&f.call(v)}finally{if(F)throw F.error}}return w},Lqt=function(u,c,f){if(f||arguments.length===2)for(var v=0,x=c.length,w;v<x;v++)(w||!(v in c))&&(w||(w=Array.prototype.slice.call(c,0,v)),w[v]=c[v]);return u.concat(w||Array.prototype.slice.call(c))},Fqt="diag",ty=function(){function u(){function c(x){return function(){for(var w=[],F=0;F<arguments.length;F++)w[F]=arguments[F];var ee=KS("diag");if(ee)return ee[x].apply(ee,Lqt([],Mqt(w),!1))}}var f=this,v=function(x,w){var F,ee,me;if(w===void 0&&(w={logLevel:f0.INFO}),x===f){var de=new Error("Cannot use diag as the logger for itself. Please use a DiagLogger implementation like ConsoleDiagLogger or a custom implementation");return f.error((F=de.stack)!==null&&F!==void 0?F:de.message),!1}typeof w=="number"&&(w={logLevel:w});var Te=KS("diag"),ut=NXe((ee=w.logLevel)!==null&&ee!==void 0?ee:f0.INFO,x);if(Te&&!w.suppressOverrideMessage){var Ct=(me=new Error().stack)!==null&&me!==void 0?me:"<failed to generate stacktrace>";Te.warn("Current logger will be overwritten from "+Ct),ut.warn("Current logger will overwrite one already registered from "+Ct)}return RC("diag",ut,f,!0)};f.setLogger=v,f.disable=function(){MC(Fqt,f)},f.createComponentLogger=function(x){return new kXe(x)},f.verbose=c("verbose"),f.debug=c("debug"),f.info=c("info"),f.warn=c("warn"),f.error=c("error")}return u.instance=function(){return this._instance||(this._instance=new u),this._instance},u}()});var jqt,Bqt,IXe,wXe=kc(()=>{jqt=function(u,c){var f=typeof Symbol=="function"&&u[Symbol.iterator];if(!f)return u;var v=f.call(u),x,w=[],F;try{for(;(c===void 0||c-- >0)&&!(x=v.next()).done;)w.push(x.value)}catch(ee){F={error:ee}}finally{try{x&&!x.done&&(f=v.return)&&f.call(v)}finally{if(F)throw F.error}}return w},Bqt=function(u){var c=typeof Symbol=="function"&&Symbol.iterator,f=c&&u[c],v=0;if(f)return f.call(u);if(u&&typeof u.length=="number")return{next:function(){return u&&v>=u.length&&(u=void 0),{value:u&&u[v++],done:!u}}};throw new TypeError(c?"Object is not iterable.":"Symbol.iterator is not defined.")},IXe=function(){function u(c){this._entries=c?new Map(c):new Map}return u.prototype.getEntry=function(c){var f=this._entries.get(c);if(f)return Object.assign({},f)},u.prototype.getAllEntries=function(){return Array.from(this._entries.entries()).map(function(c){var f=jqt(c,2),v=f[0],x=f[1];return[v,x]})},u.prototype.setEntry=function(c,f){var v=new u(this._entries);return v._entries.set(c,f),v},u.prototype.removeEntry=function(c){var f=new u(this._entries);return f._entries.delete(c),f},u.prototype.removeEntries=function(){for(var c,f,v=[],x=0;x<arguments.length;x++)v[x]=arguments[x];var w=new u(this._entries);try{for(var F=Bqt(v),ee=F.next();!ee.done;ee=F.next()){var me=ee.value;w._entries.delete(me)}}catch(de){c={error:de}}finally{try{ee&&!ee.done&&(f=F.return)&&f.call(F)}finally{if(c)throw c.error}}return w},u.prototype.clear=function(){return new u},u}()});var OXe,RXe=kc(()=>{OXe=Symbol("BaggageEntryMetadata")});function MXe(u){return u===void 0&&(u={}),new IXe(new Map(Object.entries(u)))}function LXe(u){return typeof u!="string"&&(Uqt.error("Cannot create baggage metadata from unknown type: "+typeof u),u=""),{__TYPE__:OXe,toString:function(){return u}}}var Uqt,zke=kc(()=>{j4();wXe();RXe();Uqt=ty.instance()});function eF(u){return Symbol.for(u)}var Vqt,qoe,F$=kc(()=>{Vqt=function(){function u(c){var f=this;f._currentContext=c?new Map(c):new Map,f.getValue=function(v){return f._currentContext.get(v)},f.setValue=function(v,x){var w=new u(f._currentContext);return w._currentContext.set(v,x),w},f.deleteValue=function(v){var x=new u(f._currentContext);return x._currentContext.delete(v),x}}return u}(),qoe=new Vqt});var $ke,FXe,jXe=kc(()=>{$ke=[{n:"error",c:"error"},{n:"warn",c:"warn"},{n:"info",c:"info"},{n:"debug",c:"debug"},{n:"verbose",c:"trace"}],FXe=function(){function u(){function c(v){return function(){for(var x=[],w=0;w<arguments.length;w++)x[w]=arguments[w];if(console){var F=console[v];if(typeof F!="function"&&(F=console.log),typeof F=="function")return F.apply(console,x)}}}for(var f=0;f<$ke.length;f++)this[$ke[f].n]=c($ke[f].c)}return u}()});function BXe(){return Hke}var tF,Jqt,Wke,qqt,zqt,$qt,Gke,Wqt,Gqt,Hqt,Hke,Yqt,Xqt,Kqt,Qqt,Zqt,ezt,Yke=kc(()=>{tF=function(){var u=function(c,f){return u=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(v,x){v.__proto__=x}||function(v,x){for(var w in x)Object.prototype.hasOwnProperty.call(x,w)&&(v[w]=x[w])},u(c,f)};return function(c,f){if(typeof f!="function"&&f!==null)throw new TypeError("Class extends value "+String(f)+" is not a constructor or null");u(c,f);function v(){this.constructor=c}c.prototype=f===null?Object.create(f):(v.prototype=f.prototype,new v)}}(),Jqt=function(){function u(){}return u.prototype.createHistogram=function(c,f){return Xqt},u.prototype.createCounter=function(c,f){return Yqt},u.prototype.createUpDownCounter=function(c,f){return Kqt},u.prototype.createObservableGauge=function(c,f){return Zqt},u.prototype.createObservableCounter=function(c,f){return Qqt},u.prototype.createObservableUpDownCounter=function(c,f){return ezt},u.prototype.addBatchObservableCallback=function(c,f){},u.prototype.removeBatchObservableCallback=function(c){},u}(),Wke=function(){function u(){}return u}(),qqt=function(u){tF(c,u);function c(){return u!==null&&u.apply(this,arguments)||this}return c.prototype.add=function(f,v){},c}(Wke),zqt=function(u){tF(c,u);function c(){return u!==null&&u.apply(this,arguments)||this}return c.prototype.add=function(f,v){},c}(Wke),$qt=function(u){tF(c,u);function c(){return u!==null&&u.apply(this,arguments)||this}return c.prototype.record=function(f,v){},c}(Wke),Gke=function(){function u(){}return u.prototype.addCallback=function(c){},u.prototype.removeCallback=function(c){},u}(),Wqt=function(u){tF(c,u);function c(){return u!==null&&u.apply(this,arguments)||this}return c}(Gke),Gqt=function(u){tF(c,u);function c(){return u!==null&&u.apply(this,arguments)||this}return c}(Gke),Hqt=function(u){tF(c,u);function c(){return u!==null&&u.apply(this,arguments)||this}return c}(Gke),Hke=new Jqt,Yqt=new qqt,Xqt=new $qt,Kqt=new zqt,Qqt=new Wqt,Zqt=new Gqt,ezt=new Hqt});var rF,UXe=kc(()=>{(function(u){u[u.INT=0]="INT",u[u.DOUBLE=1]="DOUBLE"})(rF||(rF={}))});var zoe,$oe,Xke=kc(()=>{zoe={get:function(u,c){if(u!=null)return u[c]},keys:function(u){return u==null?[]:Object.keys(u)}},$oe={set:function(u,c,f){u!=null&&(u[c]=f)}}});var tzt,rzt,VXe,JXe=kc(()=>{F$();tzt=function(u,c){var f=typeof Symbol=="function"&&u[Symbol.iterator];if(!f)return u;var v=f.call(u),x,w=[],F;try{for(;(c===void 0||c-- >0)&&!(x=v.next()).done;)w.push(x.value)}catch(ee){F={error:ee}}finally{try{x&&!x.done&&(f=v.return)&&f.call(v)}finally{if(F)throw F.error}}return w},rzt=function(u,c,f){if(f||arguments.length===2)for(var v=0,x=c.length,w;v<x;v++)(w||!(v in c))&&(w||(w=Array.prototype.slice.call(c,0,v)),w[v]=c[v]);return u.concat(w||Array.prototype.slice.call(c))},VXe=function(){function u(){}return u.prototype.active=function(){return qoe},u.prototype.with=function(c,f,v){for(var x=[],w=3;w<arguments.length;w++)x[w-3]=arguments[w];return f.call.apply(f,rzt([v],tzt(x),!1))},u.prototype.bind=function(c,f){return f},u.prototype.enable=function(){return this},u.prototype.disable=function(){return this},u}()});var nzt,izt,Kke,szt,VI,j$=kc(()=>{JXe();F4();j4();nzt=function(u,c){var f=typeof Symbol=="function"&&u[Symbol.iterator];if(!f)return u;var v=f.call(u),x,w=[],F;try{for(;(c===void 0||c-- >0)&&!(x=v.next()).done;)w.push(x.value)}catch(ee){F={error:ee}}finally{try{x&&!x.done&&(f=v.return)&&f.call(v)}finally{if(F)throw F.error}}return w},izt=function(u,c,f){if(f||arguments.length===2)for(var v=0,x=c.length,w;v<x;v++)(w||!(v in c))&&(w||(w=Array.prototype.slice.call(c,0,v)),w[v]=c[v]);return u.concat(w||Array.prototype.slice.call(c))},Kke="context",szt=new VXe,VI=function(){function u(){}return u.getInstance=function(){return this._instance||(this._instance=new u),this._instance},u.prototype.setGlobalContextManager=function(c){return RC(Kke,c,ty.instance())},u.prototype.active=function(){return this._getContextManager().active()},u.prototype.with=function(c,f,v){for(var x,w=[],F=3;F<arguments.length;F++)w[F-3]=arguments[F];return(x=this._getContextManager()).with.apply(x,izt([c,f,v],nzt(w),!1))},u.prototype.bind=function(c,f){return this._getContextManager().bind(c,f)},u.prototype._getContextManager=function(){return KS(Kke)||szt},u.prototype.disable=function(){this._getContextManager().disable(),MC(Kke,ty.instance())},u}()});var nF,Qke=kc(()=>{(function(u){u[u.NONE=0]="NONE",u[u.SAMPLED=1]="SAMPLED"})(nF||(nF={}))});var B$,U$,Woe,Goe=kc(()=>{Qke();B$="0000000000000000",U$="00000000000000000000000000000000",Woe={traceId:U$,spanId:B$,traceFlags:nF.NONE}});var JI,Hoe=kc(()=>{Goe();JI=function(){function u(c){c===void 0&&(c=Woe),this._spanContext=c}return u.prototype.spanContext=function(){return this._spanContext},u.prototype.setAttribute=function(c,f){return this},u.prototype.setAttributes=function(c){return this},u.prototype.addEvent=function(c,f){return this},u.prototype.setStatus=function(c){return this},u.prototype.updateName=function(c){return this},u.prototype.end=function(c){},u.prototype.isRecording=function(){return!1},u.prototype.recordException=function(c,f){},u}()});function Yoe(u){return u.getValue(Zke)||void 0}function qXe(){return Yoe(VI.getInstance().active())}function V$(u,c){return u.setValue(Zke,c)}function zXe(u){return u.deleteValue(Zke)}function $Xe(u,c){return V$(u,new JI(c))}function Xoe(u){var c;return(c=Yoe(u))===null||c===void 0?void 0:c.spanContext()}var Zke,ePe=kc(()=>{F$();Hoe();j$();Zke=eF("OpenTelemetry Context Key SPAN")});function tPe(u){return azt.test(u)&&u!==U$}function rPe(u){return ozt.test(u)&&u!==B$}function iF(u){return tPe(u.traceId)&&rPe(u.spanId)}function WXe(u){return new JI(u)}var azt,ozt,Koe=kc(()=>{Goe();Hoe();azt=/^([0-9a-f]{32})$/i,ozt=/^[0-9a-f]{16}$/i});function czt(u){return typeof u=="object"&&typeof u.spanId=="string"&&typeof u.traceId=="string"&&typeof u.traceFlags=="number"}var nPe,Qoe,iPe=kc(()=>{j$();ePe();Hoe();Koe();nPe=VI.getInstance(),Qoe=function(){function u(){}return u.prototype.startSpan=function(c,f,v){v===void 0&&(v=nPe.active());var x=!!f?.root;if(x)return new JI;var w=v&&Xoe(v);return czt(w)&&iF(w)?new JI(w):new JI},u.prototype.startActiveSpan=function(c,f,v,x){var w,F,ee;if(!(arguments.length<2)){arguments.length===2?ee=f:arguments.length===3?(w=f,ee=v):(w=f,F=v,ee=x);var me=F??nPe.active(),de=this.startSpan(c,w,me),Te=V$(me,de);return nPe.with(Te,ee,void 0,de)}},u}()});var lzt,Zoe,sPe=kc(()=>{iPe();lzt=new Qoe,Zoe=function(){function u(c,f,v,x){this._provider=c,this.name=f,this.version=v,this.options=x}return u.prototype.startSpan=function(c,f,v){return this._getTracer().startSpan(c,f,v)},u.prototype.startActiveSpan=function(c,f,v,x){var w=this._getTracer();return Reflect.apply(w.startActiveSpan,w,arguments)},u.prototype._getTracer=function(){if(this._delegate)return this._delegate;var c=this._provider.getDelegateTracer(this.name,this.version,this.options);return c?(this._delegate=c,this._delegate):lzt},u}()});var GXe,HXe=kc(()=>{iPe();GXe=function(){function u(){}return u.prototype.getTracer=function(c,f,v){return new Qoe},u}()});var uzt,J$,aPe=kc(()=>{sPe();HXe();uzt=new GXe,J$=function(){function u(){}return u.prototype.getTracer=function(c,f,v){var x;return(x=this.getDelegateTracer(c,f,v))!==null&&x!==void 0?x:new Zoe(this,c,f,v)},u.prototype.getDelegate=function(){var c;return(c=this._delegate)!==null&&c!==void 0?c:uzt},u.prototype.setDelegate=function(c){this._delegate=c},u.prototype.getDelegateTracer=function(c,f,v){var x;return(x=this._delegate)===null||x===void 0?void 0:x.getTracer(c,f,v)},u}()});var ece,YXe=kc(()=>{(function(u){u[u.NOT_RECORD=0]="NOT_RECORD",u[u.RECORD=1]="RECORD",u[u.RECORD_AND_SAMPLED=2]="RECORD_AND_SAMPLED"})(ece||(ece={}))});var tce,XXe=kc(()=>{(function(u){u[u.INTERNAL=0]="INTERNAL",u[u.SERVER=1]="SERVER",u[u.CLIENT=2]="CLIENT",u[u.PRODUCER=3]="PRODUCER",u[u.CONSUMER=4]="CONSUMER"})(tce||(tce={}))});var rce,KXe=kc(()=>{(function(u){u[u.UNSET=0]="UNSET",u[u.OK=1]="OK",u[u.ERROR=2]="ERROR"})(rce||(rce={}))});function QXe(u){return pzt.test(u)}function ZXe(u){return dzt.test(u)&&!mzt.test(u)}var oPe,_zt,fzt,pzt,dzt,mzt,eKe=kc(()=>{oPe="[_0-9a-z-*/]",_zt="[a-z]"+oPe+"{0,255}",fzt="[a-z0-9]"+oPe+"{0,240}@[a-z]"+oPe+"{0,13}",pzt=new RegExp("^(?:"+_zt+"|"+fzt+")$"),dzt=/^[ -~]{0,255}[!-~]$/,mzt=/,|=/});var tKe,gzt,rKe,nKe,iKe,sKe=kc(()=>{eKe();tKe=32,gzt=512,rKe=",",nKe="=",iKe=function(){function u(c){this._internalState=new Map,c&&this._parse(c)}return u.prototype.set=function(c,f){var v=this._clone();return v._internalState.has(c)&&v._internalState.delete(c),v._internalState.set(c,f),v},u.prototype.unset=function(c){var f=this._clone();return f._internalState.delete(c),f},u.prototype.get=function(c){return this._internalState.get(c)},u.prototype.serialize=function(){var c=this;return this._keys().reduce(function(f,v){return f.push(v+nKe+c.get(v)),f},[]).join(rKe)},u.prototype._parse=function(c){c.length>gzt||(this._internalState=c.split(rKe).reverse().reduce(function(f,v){var x=v.trim(),w=x.indexOf(nKe);if(w!==-1){var F=x.slice(0,w),ee=x.slice(w+1,v.length);QXe(F)&&ZXe(ee)&&f.set(F,ee)}return f},new Map),this._internalState.size>tKe&&(this._internalState=new Map(Array.from(this._internalState.entries()).reverse().slice(0,tKe))))},u.prototype._keys=function(){return Array.from(this._internalState.keys()).reverse()},u.prototype._clone=function(){var c=new u;return c._internalState=new Map(this._internalState),c},u}()});function aKe(u){return new iKe(u)}var oKe=kc(()=>{sKe()});var cPe,cKe=kc(()=>{j$();cPe=VI.getInstance()});var lPe,lKe=kc(()=>{j4();lPe=ty.instance()});var hzt,uKe,_Ke=kc(()=>{Yke();hzt=function(){function u(){}return u.prototype.getMeter=function(c,f,v){return Hke},u}(),uKe=new hzt});var uPe,fKe,pKe=kc(()=>{_Ke();F4();j4();uPe="metrics",fKe=function(){function u(){}return u.getInstance=function(){return this._instance||(this._instance=new u),this._instance},u.prototype.setGlobalMeterProvider=function(c){return RC(uPe,c,ty.instance())},u.prototype.getMeterProvider=function(){return KS(uPe)||uKe},u.prototype.getMeter=function(c,f,v){return this.getMeterProvider().getMeter(c,f,v)},u.prototype.disable=function(){MC(uPe,ty.instance())},u}()});var _Pe,dKe=kc(()=>{pKe();_Pe=fKe.getInstance()});var mKe,gKe=kc(()=>{mKe=function(){function u(){}return u.prototype.inject=function(c,f){},u.prototype.extract=function(c,f){return c},u.prototype.fields=function(){return[]},u}()});function pPe(u){return u.getValue(fPe)||void 0}function hKe(){return pPe(VI.getInstance().active())}function yKe(u,c){return u.setValue(fPe,c)}function vKe(u){return u.deleteValue(fPe)}var fPe,SKe=kc(()=>{j$();F$();fPe=eF("OpenTelemetry Baggage Key")});var dPe,yzt,TKe,bKe=kc(()=>{F4();gKe();Xke();SKe();zke();j4();dPe="propagation",yzt=new mKe,TKe=function(){function u(){this.createBaggage=MXe,this.getBaggage=pPe,this.getActiveBaggage=hKe,this.setBaggage=yKe,this.deleteBaggage=vKe}return u.getInstance=function(){return this._instance||(this._instance=new u),this._instance},u.prototype.setGlobalPropagator=function(c){return RC(dPe,c,ty.instance())},u.prototype.inject=function(c,f,v){return v===void 0&&(v=$oe),this._getGlobalPropagator().inject(c,f,v)},u.prototype.extract=function(c,f,v){return v===void 0&&(v=zoe),this._getGlobalPropagator().extract(c,f,v)},u.prototype.fields=function(){return this._getGlobalPropagator().fields()},u.prototype.disable=function(){MC(dPe,ty.instance())},u.prototype._getGlobalPropagator=function(){return KS(dPe)||yzt},u}()});var mPe,EKe=kc(()=>{bKe();mPe=TKe.getInstance()});var gPe,xKe,CKe=kc(()=>{F4();aPe();Koe();ePe();j4();gPe="trace",xKe=function(){function u(){this._proxyTracerProvider=new J$,this.wrapSpanContext=WXe,this.isSpanContextValid=iF,this.deleteSpan=zXe,this.getSpan=Yoe,this.getActiveSpan=qXe,this.getSpanContext=Xoe,this.setSpan=V$,this.setSpanContext=$Xe}return u.getInstance=function(){return this._instance||(this._instance=new u),this._instance},u.prototype.setGlobalTracerProvider=function(c){var f=RC(gPe,this._proxyTracerProvider,ty.instance());return f&&this._proxyTracerProvider.setDelegate(c),f},u.prototype.getTracerProvider=function(){return KS(gPe)||this._proxyTracerProvider},u.prototype.getTracer=function(c,f){return this.getTracerProvider().getTracer(c,f)},u.prototype.disable=function(){MC(gPe,ty.instance()),this._proxyTracerProvider=new J$},u}()});var hPe,AKe=kc(()=>{CKe();hPe=xKe.getInstance()});var Gc={};iXe(Gc,{DiagConsoleLogger:()=>FXe,DiagLogLevel:()=>f0,INVALID_SPANID:()=>B$,INVALID_SPAN_CONTEXT:()=>Woe,INVALID_TRACEID:()=>U$,ProxyTracer:()=>Zoe,ProxyTracerProvider:()=>J$,ROOT_CONTEXT:()=>qoe,SamplingDecision:()=>ece,SpanKind:()=>tce,SpanStatusCode:()=>rce,TraceFlags:()=>nF,ValueType:()=>rF,baggageEntryMetadataFromString:()=>LXe,context:()=>cPe,createContextKey:()=>eF,createNoopMeter:()=>BXe,createTraceState:()=>aKe,default:()=>vzt,defaultTextMapGetter:()=>zoe,defaultTextMapSetter:()=>$oe,diag:()=>lPe,isSpanContextValid:()=>iF,isValidSpanId:()=>rPe,isValidTraceId:()=>tPe,metrics:()=>_Pe,propagation:()=>mPe,trace:()=>hPe});var vzt,jc=kc(()=>{zke();F$();jXe();Joe();Yke();UXe();Xke();sPe();aPe();YXe();XXe();KXe();Qke();oKe();Koe();Goe();cKe();lKe();dKe();EKe();AKe();vzt={context:cPe,diag:lPe,metrics:_Pe,propagation:mPe,trace:hPe}});var q$=At(qI=>{"use strict";Object.defineProperty(qI,"__esModule",{value:!0});qI.isTracingSuppressed=qI.unsuppressTracing=qI.suppressTracing=void 0;var Szt=(jc(),tl(Gc)),yPe=(0,Szt.createContextKey)("OpenTelemetry SDK Context Key SUPPRESS_TRACING");function Tzt(u){return u.setValue(yPe,!0)}qI.suppressTracing=Tzt;function bzt(u){return u.deleteValue(yPe)}qI.unsuppressTracing=bzt;function Ezt(u){return u.getValue(yPe)===!0}qI.isTracingSuppressed=Ezt});var vPe=At(ry=>{"use strict";Object.defineProperty(ry,"__esModule",{value:!0});ry.BAGGAGE_MAX_TOTAL_LENGTH=ry.BAGGAGE_MAX_PER_NAME_VALUE_PAIRS=ry.BAGGAGE_MAX_NAME_VALUE_PAIRS=ry.BAGGAGE_HEADER=ry.BAGGAGE_ITEMS_SEPARATOR=ry.BAGGAGE_PROPERTIES_SEPARATOR=ry.BAGGAGE_KEY_PAIR_SEPARATOR=void 0;ry.BAGGAGE_KEY_PAIR_SEPARATOR="=";ry.BAGGAGE_PROPERTIES_SEPARATOR=";";ry.BAGGAGE_ITEMS_SEPARATOR=",";ry.BAGGAGE_HEADER="baggage";ry.BAGGAGE_MAX_NAME_VALUE_PAIRS=180;ry.BAGGAGE_MAX_PER_NAME_VALUE_PAIRS=4096;ry.BAGGAGE_MAX_TOTAL_LENGTH=8192});var SPe=At(LC=>{"use strict";Object.defineProperty(LC,"__esModule",{value:!0});LC.parseKeyPairsIntoRecord=LC.parsePairKeyValue=LC.getKeyPairs=LC.serializeKeyPairs=void 0;var xzt=(jc(),tl(Gc)),B4=vPe();function Czt(u){return u.reduce((c,f)=>{let v=`${c}${c!==""?B4.BAGGAGE_ITEMS_SEPARATOR:""}${f}`;return v.length>B4.BAGGAGE_MAX_TOTAL_LENGTH?c:v},"")}LC.serializeKeyPairs=Czt;function Azt(u){return u.getAllEntries().map(([c,f])=>{let v=`${encodeURIComponent(c)}=${encodeURIComponent(f.value)}`;return f.metadata!==void 0&&(v+=B4.BAGGAGE_PROPERTIES_SEPARATOR+f.metadata.toString()),v})}LC.getKeyPairs=Azt;function kKe(u){let c=u.split(B4.BAGGAGE_PROPERTIES_SEPARATOR);if(c.length<=0)return;let f=c.shift();if(!f)return;let v=f.indexOf(B4.BAGGAGE_KEY_PAIR_SEPARATOR);if(v<=0)return;let x=decodeURIComponent(f.substring(0,v).trim()),w=decodeURIComponent(f.substring(v+1).trim()),F;return c.length>0&&(F=(0,xzt.baggageEntryMetadataFromString)(c.join(B4.BAGGAGE_PROPERTIES_SEPARATOR))),{key:x,value:w,metadata:F}}LC.parsePairKeyValue=kKe;function kzt(u){return typeof u!="string"||u.length===0?{}:u.split(B4.BAGGAGE_ITEMS_SEPARATOR).map(c=>kKe(c)).filter(c=>c!==void 0&&c.value.length>0).reduce((c,f)=>(c[f.key]=f.value,c),{})}LC.parseKeyPairsIntoRecord=kzt});var PKe=At(nce=>{"use strict";Object.defineProperty(nce,"__esModule",{value:!0});nce.W3CBaggagePropagator=void 0;var TPe=(jc(),tl(Gc)),Pzt=q$(),U4=vPe(),bPe=SPe(),EPe=class{inject(c,f,v){let x=TPe.propagation.getBaggage(c);if(!x||(0,Pzt.isTracingSuppressed)(c))return;let w=(0,bPe.getKeyPairs)(x).filter(ee=>ee.length<=U4.BAGGAGE_MAX_PER_NAME_VALUE_PAIRS).slice(0,U4.BAGGAGE_MAX_NAME_VALUE_PAIRS),F=(0,bPe.serializeKeyPairs)(w);F.length>0&&v.set(f,U4.BAGGAGE_HEADER,F)}extract(c,f,v){let x=v.get(f,U4.BAGGAGE_HEADER),w=Array.isArray(x)?x.join(U4.BAGGAGE_ITEMS_SEPARATOR):x;if(!w)return c;let F={};return w.length===0||(w.split(U4.BAGGAGE_ITEMS_SEPARATOR).forEach(me=>{let de=(0,bPe.parsePairKeyValue)(me);if(de){let Te={value:de.value};de.metadata&&(Te.metadata=de.metadata),F[de.key]=Te}}),Object.entries(F).length===0)?c:TPe.propagation.setBaggage(c,TPe.propagation.createBaggage(F))}fields(){return[U4.BAGGAGE_HEADER]}};nce.W3CBaggagePropagator=EPe});var NKe=At(ice=>{"use strict";Object.defineProperty(ice,"__esModule",{value:!0});ice.AnchoredClock=void 0;var xPe=class{constructor(c,f){this._monotonicClock=f,this._epochMillis=c.now(),this._performanceMillis=f.now()}now(){let c=this._monotonicClock.now()-this._performanceMillis;return this._epochMillis+c}};ice.AnchoredClock=xPe});var RKe=At(zI=>{"use strict";Object.defineProperty(zI,"__esModule",{value:!0});zI.isAttributeValue=zI.isAttributeKey=zI.sanitizeAttributes=void 0;var DKe=(jc(),tl(Gc));function Nzt(u){let c={};if(typeof u!="object"||u==null)return c;for(let[f,v]of Object.entries(u)){if(!IKe(f)){DKe.diag.warn(`Invalid attribute key: ${f}`);continue}if(!wKe(v)){DKe.diag.warn(`Invalid attribute value set for key: ${f}`);continue}Array.isArray(v)?c[f]=v.slice():c[f]=v}return c}zI.sanitizeAttributes=Nzt;function IKe(u){return typeof u=="string"&&u.length>0}zI.isAttributeKey=IKe;function wKe(u){return u==null?!0:Array.isArray(u)?Dzt(u):OKe(u)}zI.isAttributeValue=wKe;function Dzt(u){let c;for(let f of u)if(f!=null){if(!c){if(OKe(f)){c=typeof f;continue}return!1}if(typeof f!==c)return!1}return!0}function OKe(u){switch(typeof u){case"number":case"boolean":case"string":return!0}return!1}});var CPe=At(sce=>{"use strict";Object.defineProperty(sce,"__esModule",{value:!0});sce.loggingErrorHandler=void 0;var Izt=(jc(),tl(Gc));function wzt(){return u=>{Izt.diag.error(Ozt(u))}}sce.loggingErrorHandler=wzt;function Ozt(u){return typeof u=="string"?u:JSON.stringify(Rzt(u))}function Rzt(u){let c={},f=u;for(;f!==null;)Object.getOwnPropertyNames(f).forEach(v=>{if(c[v])return;let x=f[v];x&&(c[v]=String(x))}),f=Object.getPrototypeOf(f);return c}});var APe=At(sF=>{"use strict";Object.defineProperty(sF,"__esModule",{value:!0});sF.globalErrorHandler=sF.setGlobalErrorHandler=void 0;var Mzt=CPe(),MKe=(0,Mzt.loggingErrorHandler)();function Lzt(u){MKe=u}sF.setGlobalErrorHandler=Lzt;function Fzt(u){try{MKe(u)}catch{}}sF.globalErrorHandler=Fzt});var kPe=At(z$=>{"use strict";Object.defineProperty(z$,"__esModule",{value:!0});z$.TracesSamplerValues=void 0;var jzt;(function(u){u.AlwaysOff="always_off",u.AlwaysOn="always_on",u.ParentBasedAlwaysOff="parentbased_always_off",u.ParentBasedAlwaysOn="parentbased_always_on",u.ParentBasedTraceIdRatio="parentbased_traceidratio",u.TraceIdRatio="traceidratio"})(jzt=z$.TracesSamplerValues||(z$.TracesSamplerValues={}))});var PPe=At(Ed=>{"use strict";Object.defineProperty(Ed,"__esModule",{value:!0});Ed.parseEnvironment=Ed.DEFAULT_ENVIRONMENT=Ed.DEFAULT_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT=Ed.DEFAULT_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT=Ed.DEFAULT_ATTRIBUTE_COUNT_LIMIT=Ed.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT=void 0;var $I=(jc(),tl(Gc)),Bzt=kPe(),Uzt=",",Vzt=["OTEL_SDK_DISABLED"];function Jzt(u){return Vzt.indexOf(u)>-1}var qzt=["OTEL_BSP_EXPORT_TIMEOUT","OTEL_BSP_MAX_EXPORT_BATCH_SIZE","OTEL_BSP_MAX_QUEUE_SIZE","OTEL_BSP_SCHEDULE_DELAY","OTEL_BLRP_EXPORT_TIMEOUT","OTEL_BLRP_MAX_EXPORT_BATCH_SIZE","OTEL_BLRP_MAX_QUEUE_SIZE","OTEL_BLRP_SCHEDULE_DELAY","OTEL_ATTRIBUTE_VALUE_LENGTH_LIMIT","OTEL_ATTRIBUTE_COUNT_LIMIT","OTEL_SPAN_ATTRIBUTE_VALUE_LENGTH_LIMIT","OTEL_SPAN_ATTRIBUTE_COUNT_LIMIT","OTEL_LOGRECORD_ATTRIBUTE_VALUE_LENGTH_LIMIT","OTEL_LOGRECORD_ATTRIBUTE_COUNT_LIMIT","OTEL_SPAN_EVENT_COUNT_LIMIT","OTEL_SPAN_LINK_COUNT_LIMIT","OTEL_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT","OTEL_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT","OTEL_EXPORTER_OTLP_TIMEOUT","OTEL_EXPORTER_OTLP_TRACES_TIMEOUT","OTEL_EXPORTER_OTLP_METRICS_TIMEOUT","OTEL_EXPORTER_OTLP_LOGS_TIMEOUT","OTEL_EXPORTER_JAEGER_AGENT_PORT"];function zzt(u){return qzt.indexOf(u)>-1}var $zt=["OTEL_NO_PATCH_MODULES","OTEL_PROPAGATORS"];function Wzt(u){return $zt.indexOf(u)>-1}Ed.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT=1/0;Ed.DEFAULT_ATTRIBUTE_COUNT_LIMIT=128;Ed.DEFAULT_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT=128;Ed.DEFAULT_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT=128;Ed.DEFAULT_ENVIRONMENT={OTEL_SDK_DISABLED:!1,CONTAINER_NAME:"",ECS_CONTAINER_METADATA_URI_V4:"",ECS_CONTAINER_METADATA_URI:"",HOSTNAME:"",KUBERNETES_SERVICE_HOST:"",NAMESPACE:"",OTEL_BSP_EXPORT_TIMEOUT:3e4,OTEL_BSP_MAX_EXPORT_BATCH_SIZE:512,OTEL_BSP_MAX_QUEUE_SIZE:2048,OTEL_BSP_SCHEDULE_DELAY:5e3,OTEL_BLRP_EXPORT_TIMEOUT:3e4,OTEL_BLRP_MAX_EXPORT_BATCH_SIZE:512,OTEL_BLRP_MAX_QUEUE_SIZE:2048,OTEL_BLRP_SCHEDULE_DELAY:5e3,OTEL_EXPORTER_JAEGER_AGENT_HOST:"",OTEL_EXPORTER_JAEGER_AGENT_PORT:6832,OTEL_EXPORTER_JAEGER_ENDPOINT:"",OTEL_EXPORTER_JAEGER_PASSWORD:"",OTEL_EXPORTER_JAEGER_USER:"",OTEL_EXPORTER_OTLP_ENDPOINT:"",OTEL_EXPORTER_OTLP_TRACES_ENDPOINT:"",OTEL_EXPORTER_OTLP_METRICS_ENDPOINT:"",OTEL_EXPORTER_OTLP_LOGS_ENDPOINT:"",OTEL_EXPORTER_OTLP_HEADERS:"",OTEL_EXPORTER_OTLP_TRACES_HEADERS:"",OTEL_EXPORTER_OTLP_METRICS_HEADERS:"",OTEL_EXPORTER_OTLP_LOGS_HEADERS:"",OTEL_EXPORTER_OTLP_TIMEOUT:1e4,OTEL_EXPORTER_OTLP_TRACES_TIMEOUT:1e4,OTEL_EXPORTER_OTLP_METRICS_TIMEOUT:1e4,OTEL_EXPORTER_OTLP_LOGS_TIMEOUT:1e4,OTEL_EXPORTER_ZIPKIN_ENDPOINT:"http://localhost:9411/api/v2/spans",OTEL_LOG_LEVEL:$I.DiagLogLevel.INFO,OTEL_NO_PATCH_MODULES:[],OTEL_PROPAGATORS:["tracecontext","baggage"],OTEL_RESOURCE_ATTRIBUTES:"",OTEL_SERVICE_NAME:"",OTEL_ATTRIBUTE_VALUE_LENGTH_LIMIT:Ed.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT,OTEL_ATTRIBUTE_COUNT_LIMIT:Ed.DEFAULT_ATTRIBUTE_COUNT_LIMIT,OTEL_SPAN_ATTRIBUTE_VALUE_LENGTH_LIMIT:Ed.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT,OTEL_SPAN_ATTRIBUTE_COUNT_LIMIT:Ed.DEFAULT_ATTRIBUTE_COUNT_LIMIT,OTEL_LOGRECORD_ATTRIBUTE_VALUE_LENGTH_LIMIT:Ed.DEFAULT_ATTRIBUTE_VALUE_LENGTH_LIMIT,OTEL_LOGRECORD_ATTRIBUTE_COUNT_LIMIT:Ed.DEFAULT_ATTRIBUTE_COUNT_LIMIT,OTEL_SPAN_EVENT_COUNT_LIMIT:128,OTEL_SPAN_LINK_COUNT_LIMIT:128,OTEL_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT:Ed.DEFAULT_SPAN_ATTRIBUTE_PER_EVENT_COUNT_LIMIT,OTEL_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT:Ed.DEFAULT_SPAN_ATTRIBUTE_PER_LINK_COUNT_LIMIT,OTEL_TRACES_EXPORTER:"",OTEL_TRACES_SAMPLER:Bzt.TracesSamplerValues.ParentBasedAlwaysOn,OTEL_TRACES_SAMPLER_ARG:"",OTEL_LOGS_EXPORTER:"",OTEL_EXPORTER_OTLP_INSECURE:"",OTEL_EXPORTER_OTLP_TRACES_INSECURE:"",OTEL_EXPORTER_OTLP_METRICS_INSECURE:"",OTEL_EXPORTER_OTLP_LOGS_INSECURE:"",OTEL_EXPORTER_OTLP_CERTIFICATE:"",OTEL_EXPORTER_OTLP_TRACES_CERTIFICATE:"",OTEL_EXPORTER_OTLP_METRICS_CERTIFICATE:"",OTEL_EXPORTER_OTLP_LOGS_CERTIFICATE:"",OTEL_EXPORTER_OTLP_COMPRESSION:"",OTEL_EXPORTER_OTLP_TRACES_COMPRESSION:"",OTEL_EXPORTER_OTLP_METRICS_COMPRESSION:"",OTEL_EXPORTER_OTLP_LOGS_COMPRESSION:"",OTEL_EXPORTER_OTLP_CLIENT_KEY:"",OTEL_EXPORTER_OTLP_TRACES_CLIENT_KEY:"",OTEL_EXPORTER_OTLP_METRICS_CLIENT_KEY:"",OTEL_EXPORTER_OTLP_LOGS_CLIENT_KEY:"",OTEL_EXPORTER_OTLP_CLIENT_CERTIFICATE:"",OTEL_EXPORTER_OTLP_TRACES_CLIENT_CERTIFICATE:"",OTEL_EXPORTER_OTLP_METRICS_CLIENT_CERTIFICATE:"",OTEL_EXPORTER_OTLP_LOGS_CLIENT_CERTIFICATE:"",OTEL_EXPORTER_OTLP_PROTOCOL:"http/protobuf",OTEL_EXPORTER_OTLP_TRACES_PROTOCOL:"http/protobuf",OTEL_EXPORTER_OTLP_METRICS_PROTOCOL:"http/protobuf",OTEL_EXPORTER_OTLP_LOGS_PROTOCOL:"http/protobuf",OTEL_EXPORTER_OTLP_METRICS_TEMPORALITY_PREFERENCE:"cumulative"};function Gzt(u,c,f){if(typeof f[u]>"u")return;let v=String(f[u]);c[u]=v.toLowerCase()==="true"}function Hzt(u,c,f,v=-1/0,x=1/0){if(typeof f[u]<"u"){let w=Number(f[u]);isNaN(w)||(w<v?c[u]=v:w>x?c[u]=x:c[u]=w)}}function Yzt(u,c,f,v=Uzt){let x=f[u];typeof x=="string"&&(c[u]=x.split(v).map(w=>w.trim()))}var Xzt={ALL:$I.DiagLogLevel.ALL,VERBOSE:$I.DiagLogLevel.VERBOSE,DEBUG:$I.DiagLogLevel.DEBUG,INFO:$I.DiagLogLevel.INFO,WARN:$I.DiagLogLevel.WARN,ERROR:$I.DiagLogLevel.ERROR,NONE:$I.DiagLogLevel.NONE};function Kzt(u,c,f){let v=f[u];if(typeof v=="string"){let x=Xzt[v.toUpperCase()];x!=null&&(c[u]=x)}}function Qzt(u){let c={};for(let f in Ed.DEFAULT_ENVIRONMENT){let v=f;switch(v){case"OTEL_LOG_LEVEL":Kzt(v,c,u);break;default:if(Jzt(v))Gzt(v,c,u);else if(zzt(v))Hzt(v,c,u);else if(Wzt(v))Yzt(v,c,u);else{let x=u[v];typeof x<"u"&&x!==null&&(c[v]=String(x))}}}return c}Ed.parseEnvironment=Qzt});var LKe=At(aF=>{"use strict";Object.defineProperty(aF,"__esModule",{value:!0});aF.getEnvWithoutDefaults=aF.getEnv=void 0;var NPe=PPe();function Zzt(){let u=(0,NPe.parseEnvironment)(process.env);return Object.assign({},NPe.DEFAULT_ENVIRONMENT,u)}aF.getEnv=Zzt;function e$t(){return(0,NPe.parseEnvironment)(process.env)}aF.getEnvWithoutDefaults=e$t});var FKe=At(ace=>{"use strict";Object.defineProperty(ace,"__esModule",{value:!0});ace._globalThis=void 0;ace._globalThis=typeof globalThis=="object"?globalThis:global});var DPe=At(oce=>{"use strict";Object.defineProperty(oce,"__esModule",{value:!0});oce.hexToBinary=void 0;function jKe(u){return u>=48&&u<=57?u-48:u>=97&&u<=102?u-87:u-55}function t$t(u){let c=new Uint8Array(u.length/2),f=0;for(let v=0;v<u.length;v+=2){let x=jKe(u.charCodeAt(v)),w=jKe(u.charCodeAt(v+1));c[f++]=x<<4|w}return c}oce.hexToBinary=t$t});var BKe=At(cce=>{"use strict";Object.defineProperty(cce,"__esModule",{value:!0});cce.hexToBase64=void 0;var r$t=DPe();function n$t(u){return Buffer.from((0,r$t.hexToBinary)(u)).toString("base64")}cce.hexToBase64=n$t});var JKe=At(uce=>{"use strict";Object.defineProperty(uce,"__esModule",{value:!0});uce.RandomIdGenerator=void 0;var i$t=8,VKe=16,IPe=class{constructor(){this.generateTraceId=UKe(VKe),this.generateSpanId=UKe(i$t)}};uce.RandomIdGenerator=IPe;var lce=Buffer.allocUnsafe(VKe);function UKe(u){return function(){for(let f=0;f<u/4;f++)lce.writeUInt32BE(Math.random()*2**32>>>0,f*4);for(let f=0;f<u&&!(lce[f]>0);f++)f===u-1&&(lce[u-1]=1);return lce.toString("hex",0,u)}}});var qKe=At(_ce=>{"use strict";Object.defineProperty(_ce,"__esModule",{value:!0});_ce.otperformance=void 0;var s$t=Bu("perf_hooks");_ce.otperformance=s$t.performance});var wPe=At(fce=>{"use strict";Object.defineProperty(fce,"__esModule",{value:!0});fce.VERSION=void 0;fce.VERSION="1.24.1"});var OPe=At(pce=>{"use strict";Object.defineProperty(pce,"__esModule",{value:!0});pce.createConstMap=void 0;function a$t(u){let c={},f=u.length;for(let v=0;v<f;v++){let x=u[v];x&&(c[String(x).toUpperCase().replace(/[-.]/g,"_")]=x)}return c}pce.createConstMap=a$t});var Mrt=At(Fe=>{"use strict";Object.defineProperty(Fe,"__esModule",{value:!0});Fe.SEMATTRS_NET_HOST_CARRIER_ICC=Fe.SEMATTRS_NET_HOST_CARRIER_MNC=Fe.SEMATTRS_NET_HOST_CARRIER_MCC=Fe.SEMATTRS_NET_HOST_CARRIER_NAME=Fe.SEMATTRS_NET_HOST_CONNECTION_SUBTYPE=Fe.SEMATTRS_NET_HOST_CONNECTION_TYPE=Fe.SEMATTRS_NET_HOST_NAME=Fe.SEMATTRS_NET_HOST_PORT=Fe.SEMATTRS_NET_HOST_IP=Fe.SEMATTRS_NET_PEER_NAME=Fe.SEMATTRS_NET_PEER_PORT=Fe.SEMATTRS_NET_PEER_IP=Fe.SEMATTRS_NET_TRANSPORT=Fe.SEMATTRS_FAAS_INVOKED_REGION=Fe.SEMATTRS_FAAS_INVOKED_PROVIDER=Fe.SEMATTRS_FAAS_INVOKED_NAME=Fe.SEMATTRS_FAAS_COLDSTART=Fe.SEMATTRS_FAAS_CRON=Fe.SEMATTRS_FAAS_TIME=Fe.SEMATTRS_FAAS_DOCUMENT_NAME=Fe.SEMATTRS_FAAS_DOCUMENT_TIME=Fe.SEMATTRS_FAAS_DOCUMENT_OPERATION=Fe.SEMATTRS_FAAS_DOCUMENT_COLLECTION=Fe.SEMATTRS_FAAS_EXECUTION=Fe.SEMATTRS_FAAS_TRIGGER=Fe.SEMATTRS_EXCEPTION_ESCAPED=Fe.SEMATTRS_EXCEPTION_STACKTRACE=Fe.SEMATTRS_EXCEPTION_MESSAGE=Fe.SEMATTRS_EXCEPTION_TYPE=Fe.SEMATTRS_DB_SQL_TABLE=Fe.SEMATTRS_DB_MONGODB_COLLECTION=Fe.SEMATTRS_DB_REDIS_DATABASE_INDEX=Fe.SEMATTRS_DB_HBASE_NAMESPACE=Fe.SEMATTRS_DB_CASSANDRA_COORDINATOR_DC=Fe.SEMATTRS_DB_CASSANDRA_COORDINATOR_ID=Fe.SEMATTRS_DB_CASSANDRA_SPECULATIVE_EXECUTION_COUNT=Fe.SEMATTRS_DB_CASSANDRA_IDEMPOTENCE=Fe.SEMATTRS_DB_CASSANDRA_TABLE=Fe.SEMATTRS_DB_CASSANDRA_CONSISTENCY_LEVEL=Fe.SEMATTRS_DB_CASSANDRA_PAGE_SIZE=Fe.SEMATTRS_DB_CASSANDRA_KEYSPACE=Fe.SEMATTRS_DB_MSSQL_INSTANCE_NAME=Fe.SEMATTRS_DB_OPERATION=Fe.SEMATTRS_DB_STATEMENT=Fe.SEMATTRS_DB_NAME=Fe.SEMATTRS_DB_JDBC_DRIVER_CLASSNAME=Fe.SEMATTRS_DB_USER=Fe.SEMATTRS_DB_CONNECTION_STRING=Fe.SEMATTRS_DB_SYSTEM=Fe.SEMATTRS_AWS_LAMBDA_INVOKED_ARN=void 0;Fe.SEMATTRS_MESSAGING_DESTINATION_KIND=Fe.SEMATTRS_MESSAGING_DESTINATION=Fe.SEMATTRS_MESSAGING_SYSTEM=Fe.SEMATTRS_AWS_DYNAMODB_GLOBAL_SECONDARY_INDEX_UPDATES=Fe.SEMATTRS_AWS_DYNAMODB_ATTRIBUTE_DEFINITIONS=Fe.SEMATTRS_AWS_DYNAMODB_SCANNED_COUNT=Fe.SEMATTRS_AWS_DYNAMODB_COUNT=Fe.SEMATTRS_AWS_DYNAMODB_TOTAL_SEGMENTS=Fe.SEMATTRS_AWS_DYNAMODB_SEGMENT=Fe.SEMATTRS_AWS_DYNAMODB_SCAN_FORWARD=Fe.SEMATTRS_AWS_DYNAMODB_TABLE_COUNT=Fe.SEMATTRS_AWS_DYNAMODB_EXCLUSIVE_START_TABLE=Fe.SEMATTRS_AWS_DYNAMODB_LOCAL_SECONDARY_INDEXES=Fe.SEMATTRS_AWS_DYNAMODB_GLOBAL_SECONDARY_INDEXES=Fe.SEMATTRS_AWS_DYNAMODB_SELECT=Fe.SEMATTRS_AWS_DYNAMODB_INDEX_NAME=Fe.SEMATTRS_AWS_DYNAMODB_ATTRIBUTES_TO_GET=Fe.SEMATTRS_AWS_DYNAMODB_LIMIT=Fe.SEMATTRS_AWS_DYNAMODB_PROJECTION=Fe.SEMATTRS_AWS_DYNAMODB_CONSISTENT_READ=Fe.SEMATTRS_AWS_DYNAMODB_PROVISIONED_WRITE_CAPACITY=Fe.SEMATTRS_AWS_DYNAMODB_PROVISIONED_READ_CAPACITY=Fe.SEMATTRS_AWS_DYNAMODB_ITEM_COLLECTION_METRICS=Fe.SEMATTRS_AWS_DYNAMODB_CONSUMED_CAPACITY=Fe.SEMATTRS_AWS_DYNAMODB_TABLE_NAMES=Fe.SEMATTRS_HTTP_CLIENT_IP=Fe.SEMATTRS_HTTP_ROUTE=Fe.SEMATTRS_HTTP_SERVER_NAME=Fe.SEMATTRS_HTTP_RESPONSE_CONTENT_LENGTH_UNCOMPRESSED=Fe.SEMATTRS_HTTP_RESPONSE_CONTENT_LENGTH=Fe.SEMATTRS_HTTP_REQUEST_CONTENT_LENGTH_UNCOMPRESSED=Fe.SEMATTRS_HTTP_REQUEST_CONTENT_LENGTH=Fe.SEMATTRS_HTTP_USER_AGENT=Fe.SEMATTRS_HTTP_FLAVOR=Fe.SEMATTRS_HTTP_STATUS_CODE=Fe.SEMATTRS_HTTP_SCHEME=Fe.SEMATTRS_HTTP_HOST=Fe.SEMATTRS_HTTP_TARGET=Fe.SEMATTRS_HTTP_URL=Fe.SEMATTRS_HTTP_METHOD=Fe.SEMATTRS_CODE_LINENO=Fe.SEMATTRS_CODE_FILEPATH=Fe.SEMATTRS_CODE_NAMESPACE=Fe.SEMATTRS_CODE_FUNCTION=Fe.SEMATTRS_THREAD_NAME=Fe.SEMATTRS_THREAD_ID=Fe.SEMATTRS_ENDUSER_SCOPE=Fe.SEMATTRS_ENDUSER_ROLE=Fe.SEMATTRS_ENDUSER_ID=Fe.SEMATTRS_PEER_SERVICE=void 0;Fe.DBSYSTEMVALUES_FILEMAKER=Fe.DBSYSTEMVALUES_DERBY=Fe.DBSYSTEMVALUES_FIREBIRD=Fe.DBSYSTEMVALUES_ADABAS=Fe.DBSYSTEMVALUES_CACHE=Fe.DBSYSTEMVALUES_EDB=Fe.DBSYSTEMVALUES_FIRSTSQL=Fe.DBSYSTEMVALUES_INGRES=Fe.DBSYSTEMVALUES_HANADB=Fe.DBSYSTEMVALUES_MAXDB=Fe.DBSYSTEMVALUES_PROGRESS=Fe.DBSYSTEMVALUES_HSQLDB=Fe.DBSYSTEMVALUES_CLOUDSCAPE=Fe.DBSYSTEMVALUES_HIVE=Fe.DBSYSTEMVALUES_REDSHIFT=Fe.DBSYSTEMVALUES_POSTGRESQL=Fe.DBSYSTEMVALUES_DB2=Fe.DBSYSTEMVALUES_ORACLE=Fe.DBSYSTEMVALUES_MYSQL=Fe.DBSYSTEMVALUES_MSSQL=Fe.DBSYSTEMVALUES_OTHER_SQL=Fe.SemanticAttributes=Fe.SEMATTRS_MESSAGE_UNCOMPRESSED_SIZE=Fe.SEMATTRS_MESSAGE_COMPRESSED_SIZE=Fe.SEMATTRS_MESSAGE_ID=Fe.SEMATTRS_MESSAGE_TYPE=Fe.SEMATTRS_RPC_JSONRPC_ERROR_MESSAGE=Fe.SEMATTRS_RPC_JSONRPC_ERROR_CODE=Fe.SEMATTRS_RPC_JSONRPC_REQUEST_ID=Fe.SEMATTRS_RPC_JSONRPC_VERSION=Fe.SEMATTRS_RPC_GRPC_STATUS_CODE=Fe.SEMATTRS_RPC_METHOD=Fe.SEMATTRS_RPC_SERVICE=Fe.SEMATTRS_RPC_SYSTEM=Fe.SEMATTRS_MESSAGING_KAFKA_TOMBSTONE=Fe.SEMATTRS_MESSAGING_KAFKA_PARTITION=Fe.SEMATTRS_MESSAGING_KAFKA_CLIENT_ID=Fe.SEMATTRS_MESSAGING_KAFKA_CONSUMER_GROUP=Fe.SEMATTRS_MESSAGING_KAFKA_MESSAGE_KEY=Fe.SEMATTRS_MESSAGING_RABBITMQ_ROUTING_KEY=Fe.SEMATTRS_MESSAGING_CONSUMER_ID=Fe.SEMATTRS_MESSAGING_OPERATION=Fe.SEMATTRS_MESSAGING_MESSAGE_PAYLOAD_COMPRESSED_SIZE_BYTES=Fe.SEMATTRS_MESSAGING_MESSAGE_PAYLOAD_SIZE_BYTES=Fe.SEMATTRS_MESSAGING_CONVERSATION_ID=Fe.SEMATTRS_MESSAGING_MESSAGE_ID=Fe.SEMATTRS_MESSAGING_URL=Fe.SEMATTRS_MESSAGING_PROTOCOL_VERSION=Fe.SEMATTRS_MESSAGING_PROTOCOL=Fe.SEMATTRS_MESSAGING_TEMP_DESTINATION=void 0;Fe.FAASINVOKEDPROVIDERVALUES_ALIBABA_CLOUD=Fe.FaasDocumentOperationValues=Fe.FAASDOCUMENTOPERATIONVALUES_DELETE=Fe.FAASDOCUMENTOPERATIONVALUES_EDIT=Fe.FAASDOCUMENTOPERATIONVALUES_INSERT=Fe.FaasTriggerValues=Fe.FAASTRIGGERVALUES_OTHER=Fe.FAASTRIGGERVALUES_TIMER=Fe.FAASTRIGGERVALUES_PUBSUB=Fe.FAASTRIGGERVALUES_HTTP=Fe.FAASTRIGGERVALUES_DATASOURCE=Fe.DbCassandraConsistencyLevelValues=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_LOCAL_SERIAL=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_SERIAL=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_ANY=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_LOCAL_ONE=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_THREE=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_TWO=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_ONE=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_LOCAL_QUORUM=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_QUORUM=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_EACH_QUORUM=Fe.DBCASSANDRACONSISTENCYLEVELVALUES_ALL=Fe.DbSystemValues=Fe.DBSYSTEMVALUES_COCKROACHDB=Fe.DBSYSTEMVALUES_MEMCACHED=Fe.DBSYSTEMVALUES_ELASTICSEARCH=Fe.DBSYSTEMVALUES_GEODE=Fe.DBSYSTEMVALUES_NEO4J=Fe.DBSYSTEMVALUES_DYNAMODB=Fe.DBSYSTEMVALUES_COSMOSDB=Fe.DBSYSTEMVALUES_COUCHDB=Fe.DBSYSTEMVALUES_COUCHBASE=Fe.DBSYSTEMVALUES_REDIS=Fe.DBSYSTEMVALUES_MONGODB=Fe.DBSYSTEMVALUES_HBASE=Fe.DBSYSTEMVALUES_CASSANDRA=Fe.DBSYSTEMVALUES_COLDFUSION=Fe.DBSYSTEMVALUES_H2=Fe.DBSYSTEMVALUES_VERTICA=Fe.DBSYSTEMVALUES_TERADATA=Fe.DBSYSTEMVALUES_SYBASE=Fe.DBSYSTEMVALUES_SQLITE=Fe.DBSYSTEMVALUES_POINTBASE=Fe.DBSYSTEMVALUES_PERVASIVE=Fe.DBSYSTEMVALUES_NETEZZA=Fe.DBSYSTEMVALUES_MARIADB=Fe.DBSYSTEMVALUES_INTERBASE=Fe.DBSYSTEMVALUES_INSTANTDB=Fe.DBSYSTEMVALUES_INFORMIX=void 0;Fe.MESSAGINGOPERATIONVALUES_RECEIVE=Fe.MessagingDestinationKindValues=Fe.MESSAGINGDESTINATIONKINDVALUES_TOPIC=Fe.MESSAGINGDESTINATIONKINDVALUES_QUEUE=Fe.HttpFlavorValues=Fe.HTTPFLAVORVALUES_QUIC=Fe.HTTPFLAVORVALUES_SPDY=Fe.HTTPFLAVORVALUES_HTTP_2_0=Fe.HTTPFLAVORVALUES_HTTP_1_1=Fe.HTTPFLAVORVALUES_HTTP_1_0=Fe.NetHostConnectionSubtypeValues=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_LTE_CA=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_NRNSA=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_NR=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_IWLAN=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_TD_SCDMA=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_GSM=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_HSPAP=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_EHRPD=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_LTE=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_EVDO_B=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_IDEN=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_HSPA=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_HSUPA=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_HSDPA=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_CDMA2000_1XRTT=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_EVDO_A=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_EVDO_0=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_CDMA=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_UMTS=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_EDGE=Fe.NETHOSTCONNECTIONSUBTYPEVALUES_GPRS=Fe.NetHostConnectionTypeValues=Fe.NETHOSTCONNECTIONTYPEVALUES_UNKNOWN=Fe.NETHOSTCONNECTIONTYPEVALUES_UNAVAILABLE=Fe.NETHOSTCONNECTIONTYPEVALUES_CELL=Fe.NETHOSTCONNECTIONTYPEVALUES_WIRED=Fe.NETHOSTCONNECTIONTYPEVALUES_WIFI=Fe.NetTransportValues=Fe.NETTRANSPORTVALUES_OTHER=Fe.NETTRANSPORTVALUES_INPROC=Fe.NETTRANSPORTVALUES_PIPE=Fe.NETTRANSPORTVALUES_UNIX=Fe.NETTRANSPORTVALUES_IP=Fe.NETTRANSPORTVALUES_IP_UDP=Fe.NETTRANSPORTVALUES_IP_TCP=Fe.FaasInvokedProviderValues=Fe.FAASINVOKEDPROVIDERVALUES_GCP=Fe.FAASINVOKEDPROVIDERVALUES_AZURE=Fe.FAASINVOKEDPROVIDERVALUES_AWS=void 0;Fe.MessageTypeValues=Fe.MESSAGETYPEVALUES_RECEIVED=Fe.MESSAGETYPEVALUES_SENT=Fe.RpcGrpcStatusCodeValues=Fe.RPCGRPCSTATUSCODEVALUES_UNAUTHENTICATED=Fe.RPCGRPCSTATUSCODEVALUES_DATA_LOSS=Fe.RPCGRPCSTATUSCODEVALUES_UNAVAILABLE=Fe.RPCGRPCSTATUSCODEVALUES_INTERNAL=Fe.RPCGRPCSTATUSCODEVALUES_UNIMPLEMENTED=Fe.RPCGRPCSTATUSCODEVALUES_OUT_OF_RANGE=Fe.RPCGRPCSTATUSCODEVALUES_ABORTED=Fe.RPCGRPCSTATUSCODEVALUES_FAILED_PRECONDITION=Fe.RPCGRPCSTATUSCODEVALUES_RESOURCE_EXHAUSTED=Fe.RPCGRPCSTATUSCODEVALUES_PERMISSION_DENIED=Fe.RPCGRPCSTATUSCODEVALUES_ALREADY_EXISTS=Fe.RPCGRPCSTATUSCODEVALUES_NOT_FOUND=Fe.RPCGRPCSTATUSCODEVALUES_DEADLINE_EXCEEDED=Fe.RPCGRPCSTATUSCODEVALUES_INVALID_ARGUMENT=Fe.RPCGRPCSTATUSCODEVALUES_UNKNOWN=Fe.RPCGRPCSTATUSCODEVALUES_CANCELLED=Fe.RPCGRPCSTATUSCODEVALUES_OK=Fe.MessagingOperationValues=Fe.MESSAGINGOPERATIONVALUES_PROCESS=void 0;var Eb=OPe(),zKe="aws.lambda.invoked_arn",$Ke="db.system",WKe="db.connection_string",GKe="db.user",HKe="db.jdbc.driver_classname",YKe="db.name",XKe="db.statement",KKe="db.operation",QKe="db.mssql.instance_name",ZKe="db.cassandra.keyspace",eQe="db.cassandra.page_size",tQe="db.cassandra.consistency_level",rQe="db.cassandra.table",nQe="db.cassandra.idempotence",iQe="db.cassandra.speculative_execution_count",sQe="db.cassandra.coordinator.id",aQe="db.cassandra.coordinator.dc",oQe="db.hbase.namespace",cQe="db.redis.database_index",lQe="db.mongodb.collection",uQe="db.sql.table",_Qe="exception.type",fQe="exception.message",pQe="exception.stacktrace",dQe="exception.escaped",mQe="faas.trigger",gQe="faas.execution",hQe="faas.document.collection",yQe="faas.document.operation",vQe="faas.document.time",SQe="faas.document.name",TQe="faas.time",bQe="faas.cron",EQe="faas.coldstart",xQe="faas.invoked_name",CQe="faas.invoked_provider",AQe="faas.invoked_region",kQe="net.transport",PQe="net.peer.ip",NQe="net.peer.port",DQe="net.peer.name",IQe="net.host.ip",wQe="net.host.port",OQe="net.host.name",RQe="net.host.connection.type",MQe="net.host.connection.subtype",LQe="net.host.carrier.name",FQe="net.host.carrier.mcc",jQe="net.host.carrier.mnc",BQe="net.host.carrier.icc",UQe="peer.service",VQe="enduser.id",JQe="enduser.role",qQe="enduser.scope",zQe="thread.id",$Qe="thread.name",WQe="code.function",GQe="code.namespace",HQe="code.filepath",YQe="code.lineno",XQe="http.method",KQe="http.url",QQe="http.target",ZQe="http.host",eZe="http.scheme",tZe="http.status_code",rZe="http.flavor",nZe="http.user_agent",iZe="http.request_content_length",sZe="http.request_content_length_uncompressed",aZe="http.response_content_length",oZe="http.response_content_length_uncompressed",cZe="http.server_name",lZe="http.route",uZe="http.client_ip",_Ze="aws.dynamodb.table_names",fZe="aws.dynamodb.consumed_capacity",pZe="aws.dynamodb.item_collection_metrics",dZe="aws.dynamodb.provisioned_read_capacity",mZe="aws.dynamodb.provisioned_write_capacity",gZe="aws.dynamodb.consistent_read",hZe="aws.dynamodb.projection",yZe="aws.dynamodb.limit",vZe="aws.dynamodb.attributes_to_get",SZe="aws.dynamodb.index_name",TZe="aws.dynamodb.select",bZe="aws.dynamodb.global_secondary_indexes",EZe="aws.dynamodb.local_secondary_indexes",xZe="aws.dynamodb.exclusive_start_table",CZe="aws.dynamodb.table_count",AZe="aws.dynamodb.scan_forward",kZe="aws.dynamodb.segment",PZe="aws.dynamodb.total_segments",NZe="aws.dynamodb.count",DZe="aws.dynamodb.scanned_count",IZe="aws.dynamodb.attribute_definitions",wZe="aws.dynamodb.global_secondary_index_updates",OZe="messaging.system",RZe="messaging.destination",MZe="messaging.destination_kind",LZe="messaging.temp_destination",FZe="messaging.protocol",jZe="messaging.protocol_version",BZe="messaging.url",UZe="messaging.message_id",VZe="messaging.conversation_id",JZe="messaging.message_payload_size_bytes",qZe="messaging.message_payload_compressed_size_bytes",zZe="messaging.operation",$Ze="messaging.consumer_id",WZe="messaging.rabbitmq.routing_key",GZe="messaging.kafka.message_key",HZe="messaging.kafka.consumer_group",YZe="messaging.kafka.client_id",XZe="messaging.kafka.partition",KZe="messaging.kafka.tombstone",QZe="rpc.system",ZZe="rpc.service",eet="rpc.method",tet="rpc.grpc.status_code",ret="rpc.jsonrpc.version",net="rpc.jsonrpc.request_id",iet="rpc.jsonrpc.error_code",set="rpc.jsonrpc.error_message",aet="message.type",oet="message.id",cet="message.compressed_size",uet="message.uncompressed_size";Fe.SEMATTRS_AWS_LAMBDA_INVOKED_ARN=zKe;Fe.SEMATTRS_DB_SYSTEM=$Ke;Fe.SEMATTRS_DB_CONNECTION_STRING=WKe;Fe.SEMATTRS_DB_USER=GKe;Fe.SEMATTRS_DB_JDBC_DRIVER_CLASSNAME=HKe;Fe.SEMATTRS_DB_NAME=YKe;Fe.SEMATTRS_DB_STATEMENT=XKe;Fe.SEMATTRS_DB_OPERATION=KKe;Fe.SEMATTRS_DB_MSSQL_INSTANCE_NAME=QKe;Fe.SEMATTRS_DB_CASSANDRA_KEYSPACE=ZKe;Fe.SEMATTRS_DB_CASSANDRA_PAGE_SIZE=eQe;Fe.SEMATTRS_DB_CASSANDRA_CONSISTENCY_LEVEL=tQe;Fe.SEMATTRS_DB_CASSANDRA_TABLE=rQe;Fe.SEMATTRS_DB_CASSANDRA_IDEMPOTENCE=nQe;Fe.SEMATTRS_DB_CASSANDRA_SPECULATIVE_EXECUTION_COUNT=iQe;Fe.SEMATTRS_DB_CASSANDRA_COORDINATOR_ID=sQe;Fe.SEMATTRS_DB_CASSANDRA_COORDINATOR_DC=aQe;Fe.SEMATTRS_DB_HBASE_NAMESPACE=oQe;Fe.SEMATTRS_DB_REDIS_DATABASE_INDEX=cQe;Fe.SEMATTRS_DB_MONGODB_COLLECTION=lQe;Fe.SEMATTRS_DB_SQL_TABLE=uQe;Fe.SEMATTRS_EXCEPTION_TYPE=_Qe;Fe.SEMATTRS_EXCEPTION_MESSAGE=fQe;Fe.SEMATTRS_EXCEPTION_STACKTRACE=pQe;Fe.SEMATTRS_EXCEPTION_ESCAPED=dQe;Fe.SEMATTRS_FAAS_TRIGGER=mQe;Fe.SEMATTRS_FAAS_EXECUTION=gQe;Fe.SEMATTRS_FAAS_DOCUMENT_COLLECTION=hQe;Fe.SEMATTRS_FAAS_DOCUMENT_OPERATION=yQe;Fe.SEMATTRS_FAAS_DOCUMENT_TIME=vQe;Fe.SEMATTRS_FAAS_DOCUMENT_NAME=SQe;Fe.SEMATTRS_FAAS_TIME=TQe;Fe.SEMATTRS_FAAS_CRON=bQe;Fe.SEMATTRS_FAAS_COLDSTART=EQe;Fe.SEMATTRS_FAAS_INVOKED_NAME=xQe;Fe.SEMATTRS_FAAS_INVOKED_PROVIDER=CQe;Fe.SEMATTRS_FAAS_INVOKED_REGION=AQe;Fe.SEMATTRS_NET_TRANSPORT=kQe;Fe.SEMATTRS_NET_PEER_IP=PQe;Fe.SEMATTRS_NET_PEER_PORT=NQe;Fe.SEMATTRS_NET_PEER_NAME=DQe;Fe.SEMATTRS_NET_HOST_IP=IQe;Fe.SEMATTRS_NET_HOST_PORT=wQe;Fe.SEMATTRS_NET_HOST_NAME=OQe;Fe.SEMATTRS_NET_HOST_CONNECTION_TYPE=RQe;Fe.SEMATTRS_NET_HOST_CONNECTION_SUBTYPE=MQe;Fe.SEMATTRS_NET_HOST_CARRIER_NAME=LQe;Fe.SEMATTRS_NET_HOST_CARRIER_MCC=FQe;Fe.SEMATTRS_NET_HOST_CARRIER_MNC=jQe;Fe.SEMATTRS_NET_HOST_CARRIER_ICC=BQe;Fe.SEMATTRS_PEER_SERVICE=UQe;Fe.SEMATTRS_ENDUSER_ID=VQe;Fe.SEMATTRS_ENDUSER_ROLE=JQe;Fe.SEMATTRS_ENDUSER_SCOPE=qQe;Fe.SEMATTRS_THREAD_ID=zQe;Fe.SEMATTRS_THREAD_NAME=$Qe;Fe.SEMATTRS_CODE_FUNCTION=WQe;Fe.SEMATTRS_CODE_NAMESPACE=GQe;Fe.SEMATTRS_CODE_FILEPATH=HQe;Fe.SEMATTRS_CODE_LINENO=YQe;Fe.SEMATTRS_HTTP_METHOD=XQe;Fe.SEMATTRS_HTTP_URL=KQe;Fe.SEMATTRS_HTTP_TARGET=QQe;Fe.SEMATTRS_HTTP_HOST=ZQe;Fe.SEMATTRS_HTTP_SCHEME=eZe;Fe.SEMATTRS_HTTP_STATUS_CODE=tZe;Fe.SEMATTRS_HTTP_FLAVOR=rZe;Fe.SEMATTRS_HTTP_USER_AGENT=nZe;Fe.SEMATTRS_HTTP_REQUEST_CONTENT_LENGTH=iZe;Fe.SEMATTRS_HTTP_REQUEST_CONTENT_LENGTH_UNCOMPRESSED=sZe;Fe.SEMATTRS_HTTP_RESPONSE_CONTENT_LENGTH=aZe;Fe.SEMATTRS_HTTP_RESPONSE_CONTENT_LENGTH_UNCOMPRESSED=oZe;Fe.SEMATTRS_HTTP_SERVER_NAME=cZe;Fe.SEMATTRS_HTTP_ROUTE=lZe;Fe.SEMATTRS_HTTP_CLIENT_IP=uZe;Fe.SEMATTRS_AWS_DYNAMODB_TABLE_NAMES=_Ze;Fe.SEMATTRS_AWS_DYNAMODB_CONSUMED_CAPACITY=fZe;Fe.SEMATTRS_AWS_DYNAMODB_ITEM_COLLECTION_METRICS=pZe;Fe.SEMATTRS_AWS_DYNAMODB_PROVISIONED_READ_CAPACITY=dZe;Fe.SEMATTRS_AWS_DYNAMODB_PROVISIONED_WRITE_CAPACITY=mZe;Fe.SEMATTRS_AWS_DYNAMODB_CONSISTENT_READ=gZe;Fe.SEMATTRS_AWS_DYNAMODB_PROJECTION=hZe;Fe.SEMATTRS_AWS_DYNAMODB_LIMIT=yZe;Fe.SEMATTRS_AWS_DYNAMODB_ATTRIBUTES_TO_GET=vZe;Fe.SEMATTRS_AWS_DYNAMODB_INDEX_NAME=SZe;Fe.SEMATTRS_AWS_DYNAMODB_SELECT=TZe;Fe.SEMATTRS_AWS_DYNAMODB_GLOBAL_SECONDARY_INDEXES=bZe;Fe.SEMATTRS_AWS_DYNAMODB_LOCAL_SECONDARY_INDEXES=EZe;Fe.SEMATTRS_AWS_DYNAMODB_EXCLUSIVE_START_TABLE=xZe;Fe.SEMATTRS_AWS_DYNAMODB_TABLE_COUNT=CZe;Fe.SEMATTRS_AWS_DYNAMODB_SCAN_FORWARD=AZe;Fe.SEMATTRS_AWS_DYNAMODB_SEGMENT=kZe;Fe.SEMATTRS_AWS_DYNAMODB_TOTAL_SEGMENTS=PZe;Fe.SEMATTRS_AWS_DYNAMODB_COUNT=NZe;Fe.SEMATTRS_AWS_DYNAMODB_SCANNED_COUNT=DZe;Fe.SEMATTRS_AWS_DYNAMODB_ATTRIBUTE_DEFINITIONS=IZe;Fe.SEMATTRS_AWS_DYNAMODB_GLOBAL_SECONDARY_INDEX_UPDATES=wZe;Fe.SEMATTRS_MESSAGING_SYSTEM=OZe;Fe.SEMATTRS_MESSAGING_DESTINATION=RZe;Fe.SEMATTRS_MESSAGING_DESTINATION_KIND=MZe;Fe.SEMATTRS_MESSAGING_TEMP_DESTINATION=LZe;Fe.SEMATTRS_MESSAGING_PROTOCOL=FZe;Fe.SEMATTRS_MESSAGING_PROTOCOL_VERSION=jZe;Fe.SEMATTRS_MESSAGING_URL=BZe;Fe.SEMATTRS_MESSAGING_MESSAGE_ID=UZe;Fe.SEMATTRS_MESSAGING_CONVERSATION_ID=VZe;Fe.SEMATTRS_MESSAGING_MESSAGE_PAYLOAD_SIZE_BYTES=JZe;Fe.SEMATTRS_MESSAGING_MESSAGE_PAYLOAD_COMPRESSED_SIZE_BYTES=qZe;Fe.SEMATTRS_MESSAGING_OPERATION=zZe;Fe.SEMATTRS_MESSAGING_CONSUMER_ID=$Ze;Fe.SEMATTRS_MESSAGING_RABBITMQ_ROUTING_KEY=WZe;Fe.SEMATTRS_MESSAGING_KAFKA_MESSAGE_KEY=GZe;Fe.SEMATTRS_MESSAGING_KAFKA_CONSUMER_GROUP=HZe;Fe.SEMATTRS_MESSAGING_KAFKA_CLIENT_ID=YZe;Fe.SEMATTRS_MESSAGING_KAFKA_PARTITION=XZe;Fe.SEMATTRS_MESSAGING_KAFKA_TOMBSTONE=KZe;Fe.SEMATTRS_RPC_SYSTEM=QZe;Fe.SEMATTRS_RPC_SERVICE=ZZe;Fe.SEMATTRS_RPC_METHOD=eet;Fe.SEMATTRS_RPC_GRPC_STATUS_CODE=tet;Fe.SEMATTRS_RPC_JSONRPC_VERSION=ret;Fe.SEMATTRS_RPC_JSONRPC_REQUEST_ID=net;Fe.SEMATTRS_RPC_JSONRPC_ERROR_CODE=iet;Fe.SEMATTRS_RPC_JSONRPC_ERROR_MESSAGE=set;Fe.SEMATTRS_MESSAGE_TYPE=aet;Fe.SEMATTRS_MESSAGE_ID=oet;Fe.SEMATTRS_MESSAGE_COMPRESSED_SIZE=cet;Fe.SEMATTRS_MESSAGE_UNCOMPRESSED_SIZE=uet;Fe.SemanticAttributes=(0,Eb.createConstMap)([zKe,$Ke,WKe,GKe,HKe,YKe,XKe,KKe,QKe,ZKe,eQe,tQe,rQe,nQe,iQe,sQe,aQe,oQe,cQe,lQe,uQe,_Qe,fQe,pQe,dQe,mQe,gQe,hQe,yQe,vQe,SQe,TQe,bQe,EQe,xQe,CQe,AQe,kQe,PQe,NQe,DQe,IQe,wQe,OQe,RQe,MQe,LQe,FQe,jQe,BQe,UQe,VQe,JQe,qQe,zQe,$Qe,WQe,GQe,HQe,YQe,XQe,KQe,QQe,ZQe,eZe,tZe,rZe,nZe,iZe,sZe,aZe,oZe,cZe,lZe,uZe,_Ze,fZe,pZe,dZe,mZe,gZe,hZe,yZe,vZe,SZe,TZe,bZe,EZe,xZe,CZe,AZe,kZe,PZe,NZe,DZe,IZe,wZe,OZe,RZe,MZe,LZe,FZe,jZe,BZe,UZe,VZe,JZe,qZe,zZe,$Ze,WZe,GZe,HZe,YZe,XZe,KZe,QZe,ZZe,eet,tet,ret,net,iet,set,aet,oet,cet,uet]);var _et="other_sql",fet="mssql",pet="mysql",det="oracle",met="db2",get="postgresql",het="redshift",yet="hive",vet="cloudscape",Tet="hsqldb",bet="progress",Eet="maxdb",xet="hanadb",Cet="ingres",Aet="firstsql",ket="edb",Pet="cache",Net="adabas",Det="firebird",Iet="derby",wet="filemaker",Oet="informix",Ret="instantdb",Met="interbase",Let="mariadb",Fet="netezza",jet="pervasive",Bet="pointbase",Uet="sqlite",Vet="sybase",Jet="teradata",qet="vertica",zet="h2",$et="coldfusion",Wet="cassandra",Get="hbase",Het="mongodb",Yet="redis",Xet="couchbase",Ket="couchdb",Qet="cosmosdb",Zet="dynamodb",ett="neo4j",ttt="geode",rtt="elasticsearch",ntt="memcached",itt="cockroachdb";Fe.DBSYSTEMVALUES_OTHER_SQL=_et;Fe.DBSYSTEMVALUES_MSSQL=fet;Fe.DBSYSTEMVALUES_MYSQL=pet;Fe.DBSYSTEMVALUES_ORACLE=det;Fe.DBSYSTEMVALUES_DB2=met;Fe.DBSYSTEMVALUES_POSTGRESQL=get;Fe.DBSYSTEMVALUES_REDSHIFT=het;Fe.DBSYSTEMVALUES_HIVE=yet;Fe.DBSYSTEMVALUES_CLOUDSCAPE=vet;Fe.DBSYSTEMVALUES_HSQLDB=Tet;Fe.DBSYSTEMVALUES_PROGRESS=bet;Fe.DBSYSTEMVALUES_MAXDB=Eet;Fe.DBSYSTEMVALUES_HANADB=xet;Fe.DBSYSTEMVALUES_INGRES=Cet;Fe.DBSYSTEMVALUES_FIRSTSQL=Aet;Fe.DBSYSTEMVALUES_EDB=ket;Fe.DBSYSTEMVALUES_CACHE=Pet;Fe.DBSYSTEMVALUES_ADABAS=Net;Fe.DBSYSTEMVALUES_FIREBIRD=Det;Fe.DBSYSTEMVALUES_DERBY=Iet;Fe.DBSYSTEMVALUES_FILEMAKER=wet;Fe.DBSYSTEMVALUES_INFORMIX=Oet;Fe.DBSYSTEMVALUES_INSTANTDB=Ret;Fe.DBSYSTEMVALUES_INTERBASE=Met;Fe.DBSYSTEMVALUES_MARIADB=Let;Fe.DBSYSTEMVALUES_NETEZZA=Fet;Fe.DBSYSTEMVALUES_PERVASIVE=jet;Fe.DBSYSTEMVALUES_POINTBASE=Bet;Fe.DBSYSTEMVALUES_SQLITE=Uet;Fe.DBSYSTEMVALUES_SYBASE=Vet;Fe.DBSYSTEMVALUES_TERADATA=Jet;Fe.DBSYSTEMVALUES_VERTICA=qet;Fe.DBSYSTEMVALUES_H2=zet;Fe.DBSYSTEMVALUES_COLDFUSION=$et;Fe.DBSYSTEMVALUES_CASSANDRA=Wet;Fe.DBSYSTEMVALUES_HBASE=Get;Fe.DBSYSTEMVALUES_MONGODB=Het;Fe.DBSYSTEMVALUES_REDIS=Yet;Fe.DBSYSTEMVALUES_COUCHBASE=Xet;Fe.DBSYSTEMVALUES_COUCHDB=Ket;Fe.DBSYSTEMVALUES_COSMOSDB=Qet;Fe.DBSYSTEMVALUES_DYNAMODB=Zet;Fe.DBSYSTEMVALUES_NEO4J=ett;Fe.DBSYSTEMVALUES_GEODE=ttt;Fe.DBSYSTEMVALUES_ELASTICSEARCH=rtt;Fe.DBSYSTEMVALUES_MEMCACHED=ntt;Fe.DBSYSTEMVALUES_COCKROACHDB=itt;Fe.DbSystemValues=(0,Eb.createConstMap)([_et,fet,pet,det,met,get,het,yet,vet,Tet,bet,Eet,xet,Cet,Aet,ket,Pet,Net,Det,Iet,wet,Oet,Ret,Met,Let,Fet,jet,Bet,Uet,Vet,Jet,qet,zet,$et,Wet,Get,Het,Yet,Xet,Ket,Qet,Zet,ett,ttt,rtt,ntt,itt]);var stt="all",att="each_quorum",ott="quorum",ctt="local_quorum",ltt="one",utt="two",_tt="three",ftt="local_one",ptt="any",dtt="serial",mtt="local_serial";Fe.DBCASSANDRACONSISTENCYLEVELVALUES_ALL=stt;Fe.DBCASSANDRACONSISTENCYLEVELVALUES_EACH_QUORUM=att;Fe.DBCASSANDRACONSISTENCYLEVELVALUES_QUORUM=ott;Fe.DBCASSANDRACONSISTENCYLEVELVALUES_LOCAL_QUORUM=ctt;Fe.DBCASSANDRACONSISTENCYLEVELVALUES_ONE=ltt;Fe.DBCASSANDRACONSISTENCYLEVELVALUES_TWO=utt;Fe.DBCASSANDRACONSISTENCYLEVELVALUES_THREE=_tt;Fe.DBCASSANDRACONSISTENCYLEVELVALUES_LOCAL_ONE=ftt;Fe.DBCASSANDRACONSISTENCYLEVELVALUES_ANY=ptt;Fe.DBCASSANDRACONSISTENCYLEVELVALUES_SERIAL=dtt;Fe.DBCASSANDRACONSISTENCYLEVELVALUES_LOCAL_SERIAL=mtt;Fe.DbCassandraConsistencyLevelValues=(0,Eb.createConstMap)([stt,att,ott,ctt,ltt,utt,_tt,ftt,ptt,dtt,mtt]);var gtt="datasource",htt="http",ytt="pubsub",vtt="timer",Stt="other";Fe.FAASTRIGGERVALUES_DATASOURCE=gtt;Fe.FAASTRIGGERVALUES_HTTP=htt;Fe.FAASTRIGGERVALUES_PUBSUB=ytt;Fe.FAASTRIGGERVALUES_TIMER=vtt;Fe.FAASTRIGGERVALUES_OTHER=Stt;Fe.FaasTriggerValues=(0,Eb.createConstMap)([gtt,htt,ytt,vtt,Stt]);var Ttt="insert",btt="edit",Ett="delete";Fe.FAASDOCUMENTOPERATIONVALUES_INSERT=Ttt;Fe.FAASDOCUMENTOPERATIONVALUES_EDIT=btt;Fe.FAASDOCUMENTOPERATIONVALUES_DELETE=Ett;Fe.FaasDocumentOperationValues=(0,Eb.createConstMap)([Ttt,btt,Ett]);var xtt="alibaba_cloud",Ctt="aws",Att="azure",ktt="gcp";Fe.FAASINVOKEDPROVIDERVALUES_ALIBABA_CLOUD=xtt;Fe.FAASINVOKEDPROVIDERVALUES_AWS=Ctt;Fe.FAASINVOKEDPROVIDERVALUES_AZURE=Att;Fe.FAASINVOKEDPROVIDERVALUES_GCP=ktt;Fe.FaasInvokedProviderValues=(0,Eb.createConstMap)([xtt,Ctt,Att,ktt]);var Ptt="ip_tcp",Ntt="ip_udp",Dtt="ip",Itt="unix",wtt="pipe",Ott="inproc",Rtt="other";Fe.NETTRANSPORTVALUES_IP_TCP=Ptt;Fe.NETTRANSPORTVALUES_IP_UDP=Ntt;Fe.NETTRANSPORTVALUES_IP=Dtt;Fe.NETTRANSPORTVALUES_UNIX=Itt;Fe.NETTRANSPORTVALUES_PIPE=wtt;Fe.NETTRANSPORTVALUES_INPROC=Ott;Fe.NETTRANSPORTVALUES_OTHER=Rtt;Fe.NetTransportValues=(0,Eb.createConstMap)([Ptt,Ntt,Dtt,Itt,wtt,Ott,Rtt]);var Mtt="wifi",Ltt="wired",Ftt="cell",jtt="unavailable",Btt="unknown";Fe.NETHOSTCONNECTIONTYPEVALUES_WIFI=Mtt;Fe.NETHOSTCONNECTIONTYPEVALUES_WIRED=Ltt;Fe.NETHOSTCONNECTIONTYPEVALUES_CELL=Ftt;Fe.NETHOSTCONNECTIONTYPEVALUES_UNAVAILABLE=jtt;Fe.NETHOSTCONNECTIONTYPEVALUES_UNKNOWN=Btt;Fe.NetHostConnectionTypeValues=(0,Eb.createConstMap)([Mtt,Ltt,Ftt,jtt,Btt]);var Utt="gprs",Vtt="edge",Jtt="umts",qtt="cdma",ztt="evdo_0",$tt="evdo_a",Wtt="cdma2000_1xrtt",Gtt="hsdpa",Htt="hsupa",Ytt="hspa",Xtt="iden",Ktt="evdo_b",Qtt="lte",Ztt="ehrpd",ert="hspap",trt="gsm",rrt="td_scdma",nrt="iwlan",irt="nr",srt="nrnsa",art="lte_ca";Fe.NETHOSTCONNECTIONSUBTYPEVALUES_GPRS=Utt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_EDGE=Vtt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_UMTS=Jtt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_CDMA=qtt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_EVDO_0=ztt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_EVDO_A=$tt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_CDMA2000_1XRTT=Wtt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_HSDPA=Gtt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_HSUPA=Htt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_HSPA=Ytt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_IDEN=Xtt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_EVDO_B=Ktt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_LTE=Qtt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_EHRPD=Ztt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_HSPAP=ert;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_GSM=trt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_TD_SCDMA=rrt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_IWLAN=nrt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_NR=irt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_NRNSA=srt;Fe.NETHOSTCONNECTIONSUBTYPEVALUES_LTE_CA=art;Fe.NetHostConnectionSubtypeValues=(0,Eb.createConstMap)([Utt,Vtt,Jtt,qtt,ztt,$tt,Wtt,Gtt,Htt,Ytt,Xtt,Ktt,Qtt,Ztt,ert,trt,rrt,nrt,irt,srt,art]);var ort="1.0",crt="1.1",lrt="2.0",urt="SPDY",_rt="QUIC";Fe.HTTPFLAVORVALUES_HTTP_1_0=ort;Fe.HTTPFLAVORVALUES_HTTP_1_1=crt;Fe.HTTPFLAVORVALUES_HTTP_2_0=lrt;Fe.HTTPFLAVORVALUES_SPDY=urt;Fe.HTTPFLAVORVALUES_QUIC=_rt;Fe.HttpFlavorValues={HTTP_1_0:ort,HTTP_1_1:crt,HTTP_2_0:lrt,SPDY:urt,QUIC:_rt};var frt="queue",prt="topic";Fe.MESSAGINGDESTINATIONKINDVALUES_QUEUE=frt;Fe.MESSAGINGDESTINATIONKINDVALUES_TOPIC=prt;Fe.MessagingDestinationKindValues=(0,Eb.createConstMap)([frt,prt]);var drt="receive",mrt="process";Fe.MESSAGINGOPERATIONVALUES_RECEIVE=drt;Fe.MESSAGINGOPERATIONVALUES_PROCESS=mrt;Fe.MessagingOperationValues=(0,Eb.createConstMap)([drt,mrt]);var grt=0,hrt=1,yrt=2,vrt=3,Srt=4,Trt=5,brt=6,Ert=7,xrt=8,Crt=9,Art=10,krt=11,Prt=12,Nrt=13,Drt=14,Irt=15,wrt=16;Fe.RPCGRPCSTATUSCODEVALUES_OK=grt;Fe.RPCGRPCSTATUSCODEVALUES_CANCELLED=hrt;Fe.RPCGRPCSTATUSCODEVALUES_UNKNOWN=yrt;Fe.RPCGRPCSTATUSCODEVALUES_INVALID_ARGUMENT=vrt;Fe.RPCGRPCSTATUSCODEVALUES_DEADLINE_EXCEEDED=Srt;Fe.RPCGRPCSTATUSCODEVALUES_NOT_FOUND=Trt;Fe.RPCGRPCSTATUSCODEVALUES_ALREADY_EXISTS=brt;Fe.RPCGRPCSTATUSCODEVALUES_PERMISSION_DENIED=Ert;Fe.RPCGRPCSTATUSCODEVALUES_RESOURCE_EXHAUSTED=xrt;Fe.RPCGRPCSTATUSCODEVALUES_FAILED_PRECONDITION=Crt;Fe.RPCGRPCSTATUSCODEVALUES_ABORTED=Art;Fe.RPCGRPCSTATUSCODEVALUES_OUT_OF_RANGE=krt;Fe.RPCGRPCSTATUSCODEVALUES_UNIMPLEMENTED=Prt;Fe.RPCGRPCSTATUSCODEVALUES_INTERNAL=Nrt;Fe.RPCGRPCSTATUSCODEVALUES_UNAVAILABLE=Drt;Fe.RPCGRPCSTATUSCODEVALUES_DATA_LOSS=Irt;Fe.RPCGRPCSTATUSCODEVALUES_UNAUTHENTICATED=wrt;Fe.RpcGrpcStatusCodeValues={OK:grt,CANCELLED:hrt,UNKNOWN:yrt,INVALID_ARGUMENT:vrt,DEADLINE_EXCEEDED:Srt,NOT_FOUND:Trt,ALREADY_EXISTS:brt,PERMISSION_DENIED:Ert,RESOURCE_EXHAUSTED:xrt,FAILED_PRECONDITION:Crt,ABORTED:Art,OUT_OF_RANGE:krt,UNIMPLEMENTED:Prt,INTERNAL:Nrt,UNAVAILABLE:Drt,DATA_LOSS:Irt,UNAUTHENTICATED:wrt};var Ort="SENT",Rrt="RECEIVED";Fe.MESSAGETYPEVALUES_SENT=Ort;Fe.MESSAGETYPEVALUES_RECEIVED=Rrt;Fe.MessageTypeValues=(0,Eb.createConstMap)([Ort,Rrt])});var Lrt=At(V4=>{"use strict";var o$t=V4&&V4.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),c$t=V4&&V4.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&o$t(c,u,f)};Object.defineProperty(V4,"__esModule",{value:!0});c$t(Mrt(),V4)});var ost=At(qt=>{"use strict";Object.defineProperty(qt,"__esModule",{value:!0});qt.SEMRESATTRS_K8S_STATEFULSET_NAME=qt.SEMRESATTRS_K8S_STATEFULSET_UID=qt.SEMRESATTRS_K8S_DEPLOYMENT_NAME=qt.SEMRESATTRS_K8S_DEPLOYMENT_UID=qt.SEMRESATTRS_K8S_REPLICASET_NAME=qt.SEMRESATTRS_K8S_REPLICASET_UID=qt.SEMRESATTRS_K8S_CONTAINER_NAME=qt.SEMRESATTRS_K8S_POD_NAME=qt.SEMRESATTRS_K8S_POD_UID=qt.SEMRESATTRS_K8S_NAMESPACE_NAME=qt.SEMRESATTRS_K8S_NODE_UID=qt.SEMRESATTRS_K8S_NODE_NAME=qt.SEMRESATTRS_K8S_CLUSTER_NAME=qt.SEMRESATTRS_HOST_IMAGE_VERSION=qt.SEMRESATTRS_HOST_IMAGE_ID=qt.SEMRESATTRS_HOST_IMAGE_NAME=qt.SEMRESATTRS_HOST_ARCH=qt.SEMRESATTRS_HOST_TYPE=qt.SEMRESATTRS_HOST_NAME=qt.SEMRESATTRS_HOST_ID=qt.SEMRESATTRS_FAAS_MAX_MEMORY=qt.SEMRESATTRS_FAAS_INSTANCE=qt.SEMRESATTRS_FAAS_VERSION=qt.SEMRESATTRS_FAAS_ID=qt.SEMRESATTRS_FAAS_NAME=qt.SEMRESATTRS_DEVICE_MODEL_NAME=qt.SEMRESATTRS_DEVICE_MODEL_IDENTIFIER=qt.SEMRESATTRS_DEVICE_ID=qt.SEMRESATTRS_DEPLOYMENT_ENVIRONMENT=qt.SEMRESATTRS_CONTAINER_IMAGE_TAG=qt.SEMRESATTRS_CONTAINER_IMAGE_NAME=qt.SEMRESATTRS_CONTAINER_RUNTIME=qt.SEMRESATTRS_CONTAINER_ID=qt.SEMRESATTRS_CONTAINER_NAME=qt.SEMRESATTRS_AWS_LOG_STREAM_ARNS=qt.SEMRESATTRS_AWS_LOG_STREAM_NAMES=qt.SEMRESATTRS_AWS_LOG_GROUP_ARNS=qt.SEMRESATTRS_AWS_LOG_GROUP_NAMES=qt.SEMRESATTRS_AWS_EKS_CLUSTER_ARN=qt.SEMRESATTRS_AWS_ECS_TASK_REVISION=qt.SEMRESATTRS_AWS_ECS_TASK_FAMILY=qt.SEMRESATTRS_AWS_ECS_TASK_ARN=qt.SEMRESATTRS_AWS_ECS_LAUNCHTYPE=qt.SEMRESATTRS_AWS_ECS_CLUSTER_ARN=qt.SEMRESATTRS_AWS_ECS_CONTAINER_ARN=qt.SEMRESATTRS_CLOUD_PLATFORM=qt.SEMRESATTRS_CLOUD_AVAILABILITY_ZONE=qt.SEMRESATTRS_CLOUD_REGION=qt.SEMRESATTRS_CLOUD_ACCOUNT_ID=qt.SEMRESATTRS_CLOUD_PROVIDER=void 0;qt.CLOUDPLATFORMVALUES_GCP_COMPUTE_ENGINE=qt.CLOUDPLATFORMVALUES_AZURE_APP_SERVICE=qt.CLOUDPLATFORMVALUES_AZURE_FUNCTIONS=qt.CLOUDPLATFORMVALUES_AZURE_AKS=qt.CLOUDPLATFORMVALUES_AZURE_CONTAINER_INSTANCES=qt.CLOUDPLATFORMVALUES_AZURE_VM=qt.CLOUDPLATFORMVALUES_AWS_ELASTIC_BEANSTALK=qt.CLOUDPLATFORMVALUES_AWS_LAMBDA=qt.CLOUDPLATFORMVALUES_AWS_EKS=qt.CLOUDPLATFORMVALUES_AWS_ECS=qt.CLOUDPLATFORMVALUES_AWS_EC2=qt.CLOUDPLATFORMVALUES_ALIBABA_CLOUD_FC=qt.CLOUDPLATFORMVALUES_ALIBABA_CLOUD_ECS=qt.CloudProviderValues=qt.CLOUDPROVIDERVALUES_GCP=qt.CLOUDPROVIDERVALUES_AZURE=qt.CLOUDPROVIDERVALUES_AWS=qt.CLOUDPROVIDERVALUES_ALIBABA_CLOUD=qt.SemanticResourceAttributes=qt.SEMRESATTRS_WEBENGINE_DESCRIPTION=qt.SEMRESATTRS_WEBENGINE_VERSION=qt.SEMRESATTRS_WEBENGINE_NAME=qt.SEMRESATTRS_TELEMETRY_AUTO_VERSION=qt.SEMRESATTRS_TELEMETRY_SDK_VERSION=qt.SEMRESATTRS_TELEMETRY_SDK_LANGUAGE=qt.SEMRESATTRS_TELEMETRY_SDK_NAME=qt.SEMRESATTRS_SERVICE_VERSION=qt.SEMRESATTRS_SERVICE_INSTANCE_ID=qt.SEMRESATTRS_SERVICE_NAMESPACE=qt.SEMRESATTRS_SERVICE_NAME=qt.SEMRESATTRS_PROCESS_RUNTIME_DESCRIPTION=qt.SEMRESATTRS_PROCESS_RUNTIME_VERSION=qt.SEMRESATTRS_PROCESS_RUNTIME_NAME=qt.SEMRESATTRS_PROCESS_OWNER=qt.SEMRESATTRS_PROCESS_COMMAND_ARGS=qt.SEMRESATTRS_PROCESS_COMMAND_LINE=qt.SEMRESATTRS_PROCESS_COMMAND=qt.SEMRESATTRS_PROCESS_EXECUTABLE_PATH=qt.SEMRESATTRS_PROCESS_EXECUTABLE_NAME=qt.SEMRESATTRS_PROCESS_PID=qt.SEMRESATTRS_OS_VERSION=qt.SEMRESATTRS_OS_NAME=qt.SEMRESATTRS_OS_DESCRIPTION=qt.SEMRESATTRS_OS_TYPE=qt.SEMRESATTRS_K8S_CRONJOB_NAME=qt.SEMRESATTRS_K8S_CRONJOB_UID=qt.SEMRESATTRS_K8S_JOB_NAME=qt.SEMRESATTRS_K8S_JOB_UID=qt.SEMRESATTRS_K8S_DAEMONSET_NAME=qt.SEMRESATTRS_K8S_DAEMONSET_UID=void 0;qt.TelemetrySdkLanguageValues=qt.TELEMETRYSDKLANGUAGEVALUES_WEBJS=qt.TELEMETRYSDKLANGUAGEVALUES_RUBY=qt.TELEMETRYSDKLANGUAGEVALUES_PYTHON=qt.TELEMETRYSDKLANGUAGEVALUES_PHP=qt.TELEMETRYSDKLANGUAGEVALUES_NODEJS=qt.TELEMETRYSDKLANGUAGEVALUES_JAVA=qt.TELEMETRYSDKLANGUAGEVALUES_GO=qt.TELEMETRYSDKLANGUAGEVALUES_ERLANG=qt.TELEMETRYSDKLANGUAGEVALUES_DOTNET=qt.TELEMETRYSDKLANGUAGEVALUES_CPP=qt.OsTypeValues=qt.OSTYPEVALUES_Z_OS=qt.OSTYPEVALUES_SOLARIS=qt.OSTYPEVALUES_AIX=qt.OSTYPEVALUES_HPUX=qt.OSTYPEVALUES_DRAGONFLYBSD=qt.OSTYPEVALUES_OPENBSD=qt.OSTYPEVALUES_NETBSD=qt.OSTYPEVALUES_FREEBSD=qt.OSTYPEVALUES_DARWIN=qt.OSTYPEVALUES_LINUX=qt.OSTYPEVALUES_WINDOWS=qt.HostArchValues=qt.HOSTARCHVALUES_X86=qt.HOSTARCHVALUES_PPC64=qt.HOSTARCHVALUES_PPC32=qt.HOSTARCHVALUES_IA64=qt.HOSTARCHVALUES_ARM64=qt.HOSTARCHVALUES_ARM32=qt.HOSTARCHVALUES_AMD64=qt.AwsEcsLaunchtypeValues=qt.AWSECSLAUNCHTYPEVALUES_FARGATE=qt.AWSECSLAUNCHTYPEVALUES_EC2=qt.CloudPlatformValues=qt.CLOUDPLATFORMVALUES_GCP_APP_ENGINE=qt.CLOUDPLATFORMVALUES_GCP_CLOUD_FUNCTIONS=qt.CLOUDPLATFORMVALUES_GCP_KUBERNETES_ENGINE=qt.CLOUDPLATFORMVALUES_GCP_CLOUD_RUN=void 0;var J4=OPe(),Frt="cloud.provider",jrt="cloud.account.id",Brt="cloud.region",Urt="cloud.availability_zone",Vrt="cloud.platform",Jrt="aws.ecs.container.arn",qrt="aws.ecs.cluster.arn",zrt="aws.ecs.launchtype",$rt="aws.ecs.task.arn",Wrt="aws.ecs.task.family",Grt="aws.ecs.task.revision",Hrt="aws.eks.cluster.arn",Yrt="aws.log.group.names",Xrt="aws.log.group.arns",Krt="aws.log.stream.names",Qrt="aws.log.stream.arns",Zrt="container.name",ent="container.id",tnt="container.runtime",rnt="container.image.name",nnt="container.image.tag",int="deployment.environment",snt="device.id",ant="device.model.identifier",ont="device.model.name",cnt="faas.name",lnt="faas.id",unt="faas.version",_nt="faas.instance",fnt="faas.max_memory",pnt="host.id",dnt="host.name",mnt="host.type",gnt="host.arch",hnt="host.image.name",ynt="host.image.id",vnt="host.image.version",Snt="k8s.cluster.name",Tnt="k8s.node.name",bnt="k8s.node.uid",Ent="k8s.namespace.name",xnt="k8s.pod.uid",Cnt="k8s.pod.name",Ant="k8s.container.name",knt="k8s.replicaset.uid",Pnt="k8s.replicaset.name",Nnt="k8s.deployment.uid",Dnt="k8s.deployment.name",Int="k8s.statefulset.uid",wnt="k8s.statefulset.name",Ont="k8s.daemonset.uid",Rnt="k8s.daemonset.name",Mnt="k8s.job.uid",Lnt="k8s.job.name",Fnt="k8s.cronjob.uid",jnt="k8s.cronjob.name",Bnt="os.type",Unt="os.description",Vnt="os.name",Jnt="os.version",qnt="process.pid",znt="process.executable.name",$nt="process.executable.path",Wnt="process.command",Gnt="process.command_line",Hnt="process.command_args",Ynt="process.owner",Xnt="process.runtime.name",Knt="process.runtime.version",Qnt="process.runtime.description",Znt="service.name",eit="service.namespace",tit="service.instance.id",rit="service.version",nit="telemetry.sdk.name",iit="telemetry.sdk.language",sit="telemetry.sdk.version",ait="telemetry.auto.version",oit="webengine.name",cit="webengine.version",lit="webengine.description";qt.SEMRESATTRS_CLOUD_PROVIDER=Frt;qt.SEMRESATTRS_CLOUD_ACCOUNT_ID=jrt;qt.SEMRESATTRS_CLOUD_REGION=Brt;qt.SEMRESATTRS_CLOUD_AVAILABILITY_ZONE=Urt;qt.SEMRESATTRS_CLOUD_PLATFORM=Vrt;qt.SEMRESATTRS_AWS_ECS_CONTAINER_ARN=Jrt;qt.SEMRESATTRS_AWS_ECS_CLUSTER_ARN=qrt;qt.SEMRESATTRS_AWS_ECS_LAUNCHTYPE=zrt;qt.SEMRESATTRS_AWS_ECS_TASK_ARN=$rt;qt.SEMRESATTRS_AWS_ECS_TASK_FAMILY=Wrt;qt.SEMRESATTRS_AWS_ECS_TASK_REVISION=Grt;qt.SEMRESATTRS_AWS_EKS_CLUSTER_ARN=Hrt;qt.SEMRESATTRS_AWS_LOG_GROUP_NAMES=Yrt;qt.SEMRESATTRS_AWS_LOG_GROUP_ARNS=Xrt;qt.SEMRESATTRS_AWS_LOG_STREAM_NAMES=Krt;qt.SEMRESATTRS_AWS_LOG_STREAM_ARNS=Qrt;qt.SEMRESATTRS_CONTAINER_NAME=Zrt;qt.SEMRESATTRS_CONTAINER_ID=ent;qt.SEMRESATTRS_CONTAINER_RUNTIME=tnt;qt.SEMRESATTRS_CONTAINER_IMAGE_NAME=rnt;qt.SEMRESATTRS_CONTAINER_IMAGE_TAG=nnt;qt.SEMRESATTRS_DEPLOYMENT_ENVIRONMENT=int;qt.SEMRESATTRS_DEVICE_ID=snt;qt.SEMRESATTRS_DEVICE_MODEL_IDENTIFIER=ant;qt.SEMRESATTRS_DEVICE_MODEL_NAME=ont;qt.SEMRESATTRS_FAAS_NAME=cnt;qt.SEMRESATTRS_FAAS_ID=lnt;qt.SEMRESATTRS_FAAS_VERSION=unt;qt.SEMRESATTRS_FAAS_INSTANCE=_nt;qt.SEMRESATTRS_FAAS_MAX_MEMORY=fnt;qt.SEMRESATTRS_HOST_ID=pnt;qt.SEMRESATTRS_HOST_NAME=dnt;qt.SEMRESATTRS_HOST_TYPE=mnt;qt.SEMRESATTRS_HOST_ARCH=gnt;qt.SEMRESATTRS_HOST_IMAGE_NAME=hnt;qt.SEMRESATTRS_HOST_IMAGE_ID=ynt;qt.SEMRESATTRS_HOST_IMAGE_VERSION=vnt;qt.SEMRESATTRS_K8S_CLUSTER_NAME=Snt;qt.SEMRESATTRS_K8S_NODE_NAME=Tnt;qt.SEMRESATTRS_K8S_NODE_UID=bnt;qt.SEMRESATTRS_K8S_NAMESPACE_NAME=Ent;qt.SEMRESATTRS_K8S_POD_UID=xnt;qt.SEMRESATTRS_K8S_POD_NAME=Cnt;qt.SEMRESATTRS_K8S_CONTAINER_NAME=Ant;qt.SEMRESATTRS_K8S_REPLICASET_UID=knt;qt.SEMRESATTRS_K8S_REPLICASET_NAME=Pnt;qt.SEMRESATTRS_K8S_DEPLOYMENT_UID=Nnt;qt.SEMRESATTRS_K8S_DEPLOYMENT_NAME=Dnt;qt.SEMRESATTRS_K8S_STATEFULSET_UID=Int;qt.SEMRESATTRS_K8S_STATEFULSET_NAME=wnt;qt.SEMRESATTRS_K8S_DAEMONSET_UID=Ont;qt.SEMRESATTRS_K8S_DAEMONSET_NAME=Rnt;qt.SEMRESATTRS_K8S_JOB_UID=Mnt;qt.SEMRESATTRS_K8S_JOB_NAME=Lnt;qt.SEMRESATTRS_K8S_CRONJOB_UID=Fnt;qt.SEMRESATTRS_K8S_CRONJOB_NAME=jnt;qt.SEMRESATTRS_OS_TYPE=Bnt;qt.SEMRESATTRS_OS_DESCRIPTION=Unt;qt.SEMRESATTRS_OS_NAME=Vnt;qt.SEMRESATTRS_OS_VERSION=Jnt;qt.SEMRESATTRS_PROCESS_PID=qnt;qt.SEMRESATTRS_PROCESS_EXECUTABLE_NAME=znt;qt.SEMRESATTRS_PROCESS_EXECUTABLE_PATH=$nt;qt.SEMRESATTRS_PROCESS_COMMAND=Wnt;qt.SEMRESATTRS_PROCESS_COMMAND_LINE=Gnt;qt.SEMRESATTRS_PROCESS_COMMAND_ARGS=Hnt;qt.SEMRESATTRS_PROCESS_OWNER=Ynt;qt.SEMRESATTRS_PROCESS_RUNTIME_NAME=Xnt;qt.SEMRESATTRS_PROCESS_RUNTIME_VERSION=Knt;qt.SEMRESATTRS_PROCESS_RUNTIME_DESCRIPTION=Qnt;qt.SEMRESATTRS_SERVICE_NAME=Znt;qt.SEMRESATTRS_SERVICE_NAMESPACE=eit;qt.SEMRESATTRS_SERVICE_INSTANCE_ID=tit;qt.SEMRESATTRS_SERVICE_VERSION=rit;qt.SEMRESATTRS_TELEMETRY_SDK_NAME=nit;qt.SEMRESATTRS_TELEMETRY_SDK_LANGUAGE=iit;qt.SEMRESATTRS_TELEMETRY_SDK_VERSION=sit;qt.SEMRESATTRS_TELEMETRY_AUTO_VERSION=ait;qt.SEMRESATTRS_WEBENGINE_NAME=oit;qt.SEMRESATTRS_WEBENGINE_VERSION=cit;qt.SEMRESATTRS_WEBENGINE_DESCRIPTION=lit;qt.SemanticResourceAttributes=(0,J4.createConstMap)([Frt,jrt,Brt,Urt,Vrt,Jrt,qrt,zrt,$rt,Wrt,Grt,Hrt,Yrt,Xrt,Krt,Qrt,Zrt,ent,tnt,rnt,nnt,int,snt,ant,ont,cnt,lnt,unt,_nt,fnt,pnt,dnt,mnt,gnt,hnt,ynt,vnt,Snt,Tnt,bnt,Ent,xnt,Cnt,Ant,knt,Pnt,Nnt,Dnt,Int,wnt,Ont,Rnt,Mnt,Lnt,Fnt,jnt,Bnt,Unt,Vnt,Jnt,qnt,znt,$nt,Wnt,Gnt,Hnt,Ynt,Xnt,Knt,Qnt,Znt,eit,tit,rit,nit,iit,sit,ait,oit,cit,lit]);var uit="alibaba_cloud",_it="aws",fit="azure",pit="gcp";qt.CLOUDPROVIDERVALUES_ALIBABA_CLOUD=uit;qt.CLOUDPROVIDERVALUES_AWS=_it;qt.CLOUDPROVIDERVALUES_AZURE=fit;qt.CLOUDPROVIDERVALUES_GCP=pit;qt.CloudProviderValues=(0,J4.createConstMap)([uit,_it,fit,pit]);var dit="alibaba_cloud_ecs",mit="alibaba_cloud_fc",git="aws_ec2",hit="aws_ecs",yit="aws_eks",vit="aws_lambda",Sit="aws_elastic_beanstalk",Tit="azure_vm",bit="azure_container_instances",Eit="azure_aks",xit="azure_functions",Cit="azure_app_service",Ait="gcp_compute_engine",kit="gcp_cloud_run",Pit="gcp_kubernetes_engine",Nit="gcp_cloud_functions",Dit="gcp_app_engine";qt.CLOUDPLATFORMVALUES_ALIBABA_CLOUD_ECS=dit;qt.CLOUDPLATFORMVALUES_ALIBABA_CLOUD_FC=mit;qt.CLOUDPLATFORMVALUES_AWS_EC2=git;qt.CLOUDPLATFORMVALUES_AWS_ECS=hit;qt.CLOUDPLATFORMVALUES_AWS_EKS=yit;qt.CLOUDPLATFORMVALUES_AWS_LAMBDA=vit;qt.CLOUDPLATFORMVALUES_AWS_ELASTIC_BEANSTALK=Sit;qt.CLOUDPLATFORMVALUES_AZURE_VM=Tit;qt.CLOUDPLATFORMVALUES_AZURE_CONTAINER_INSTANCES=bit;qt.CLOUDPLATFORMVALUES_AZURE_AKS=Eit;qt.CLOUDPLATFORMVALUES_AZURE_FUNCTIONS=xit;qt.CLOUDPLATFORMVALUES_AZURE_APP_SERVICE=Cit;qt.CLOUDPLATFORMVALUES_GCP_COMPUTE_ENGINE=Ait;qt.CLOUDPLATFORMVALUES_GCP_CLOUD_RUN=kit;qt.CLOUDPLATFORMVALUES_GCP_KUBERNETES_ENGINE=Pit;qt.CLOUDPLATFORMVALUES_GCP_CLOUD_FUNCTIONS=Nit;qt.CLOUDPLATFORMVALUES_GCP_APP_ENGINE=Dit;qt.CloudPlatformValues=(0,J4.createConstMap)([dit,mit,git,hit,yit,vit,Sit,Tit,bit,Eit,xit,Cit,Ait,kit,Pit,Nit,Dit]);var Iit="ec2",wit="fargate";qt.AWSECSLAUNCHTYPEVALUES_EC2=Iit;qt.AWSECSLAUNCHTYPEVALUES_FARGATE=wit;qt.AwsEcsLaunchtypeValues=(0,J4.createConstMap)([Iit,wit]);var Oit="amd64",Rit="arm32",Mit="arm64",Lit="ia64",Fit="ppc32",jit="ppc64",Bit="x86";qt.HOSTARCHVALUES_AMD64=Oit;qt.HOSTARCHVALUES_ARM32=Rit;qt.HOSTARCHVALUES_ARM64=Mit;qt.HOSTARCHVALUES_IA64=Lit;qt.HOSTARCHVALUES_PPC32=Fit;qt.HOSTARCHVALUES_PPC64=jit;qt.HOSTARCHVALUES_X86=Bit;qt.HostArchValues=(0,J4.createConstMap)([Oit,Rit,Mit,Lit,Fit,jit,Bit]);var Uit="windows",Vit="linux",Jit="darwin",qit="freebsd",zit="netbsd",$it="openbsd",Wit="dragonflybsd",Git="hpux",Hit="aix",Yit="solaris",Xit="z_os";qt.OSTYPEVALUES_WINDOWS=Uit;qt.OSTYPEVALUES_LINUX=Vit;qt.OSTYPEVALUES_DARWIN=Jit;qt.OSTYPEVALUES_FREEBSD=qit;qt.OSTYPEVALUES_NETBSD=zit;qt.OSTYPEVALUES_OPENBSD=$it;qt.OSTYPEVALUES_DRAGONFLYBSD=Wit;qt.OSTYPEVALUES_HPUX=Git;qt.OSTYPEVALUES_AIX=Hit;qt.OSTYPEVALUES_SOLARIS=Yit;qt.OSTYPEVALUES_Z_OS=Xit;qt.OsTypeValues=(0,J4.createConstMap)([Uit,Vit,Jit,qit,zit,$it,Wit,Git,Hit,Yit,Xit]);var Kit="cpp",Qit="dotnet",Zit="erlang",est="go",tst="java",rst="nodejs",nst="php",ist="python",sst="ruby",ast="webjs";qt.TELEMETRYSDKLANGUAGEVALUES_CPP=Kit;qt.TELEMETRYSDKLANGUAGEVALUES_DOTNET=Qit;qt.TELEMETRYSDKLANGUAGEVALUES_ERLANG=Zit;qt.TELEMETRYSDKLANGUAGEVALUES_GO=est;qt.TELEMETRYSDKLANGUAGEVALUES_JAVA=tst;qt.TELEMETRYSDKLANGUAGEVALUES_NODEJS=rst;qt.TELEMETRYSDKLANGUAGEVALUES_PHP=nst;qt.TELEMETRYSDKLANGUAGEVALUES_PYTHON=ist;qt.TELEMETRYSDKLANGUAGEVALUES_RUBY=sst;qt.TELEMETRYSDKLANGUAGEVALUES_WEBJS=ast;qt.TelemetrySdkLanguageValues=(0,J4.createConstMap)([Kit,Qit,Zit,est,tst,rst,nst,ist,sst,ast])});var cst=At(q4=>{"use strict";var l$t=q4&&q4.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),u$t=q4&&q4.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&l$t(c,u,f)};Object.defineProperty(q4,"__esModule",{value:!0});u$t(ost(),q4)});var FC=At(WI=>{"use strict";var _$t=WI&&WI.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),lst=WI&&WI.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&_$t(c,u,f)};Object.defineProperty(WI,"__esModule",{value:!0});lst(Lrt(),WI);lst(cst(),WI)});var ust=At(dce=>{"use strict";Object.defineProperty(dce,"__esModule",{value:!0});dce.SDK_INFO=void 0;var f$t=wPe(),$$=FC();dce.SDK_INFO={[$$.SemanticResourceAttributes.TELEMETRY_SDK_NAME]:"opentelemetry",[$$.SemanticResourceAttributes.PROCESS_RUNTIME_NAME]:"node",[$$.SemanticResourceAttributes.TELEMETRY_SDK_LANGUAGE]:$$.TelemetrySdkLanguageValues.NODEJS,[$$.SemanticResourceAttributes.TELEMETRY_SDK_VERSION]:f$t.VERSION}});var _st=At(mce=>{"use strict";Object.defineProperty(mce,"__esModule",{value:!0});mce.unrefTimer=void 0;function p$t(u){u.unref()}mce.unrefTimer=p$t});var pst=At(ny=>{"use strict";var d$t=ny&&ny.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),oF=ny&&ny.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&d$t(c,u,f)};Object.defineProperty(ny,"__esModule",{value:!0});ny.getEnv=ny.getEnvWithoutDefaults=void 0;var fst=LKe();Object.defineProperty(ny,"getEnvWithoutDefaults",{enumerable:!0,get:function(){return fst.getEnvWithoutDefaults}});Object.defineProperty(ny,"getEnv",{enumerable:!0,get:function(){return fst.getEnv}});oF(FKe(),ny);oF(BKe(),ny);oF(JKe(),ny);oF(qKe(),ny);oF(ust(),ny);oF(_st(),ny)});var RPe=At(z4=>{"use strict";var m$t=z4&&z4.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),g$t=z4&&z4.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&m$t(c,u,f)};Object.defineProperty(z4,"__esModule",{value:!0});g$t(pst(),z4)});var hst=At(np=>{"use strict";Object.defineProperty(np,"__esModule",{value:!0});np.addHrTimes=np.isTimeInput=np.isTimeInputHrTime=np.hrTimeToMicroseconds=np.hrTimeToMilliseconds=np.hrTimeToNanoseconds=np.hrTimeToTimeStamp=np.hrTimeDuration=np.timeInputToHrTime=np.hrTime=np.getTimeOrigin=np.millisToHrTime=void 0;var MPe=RPe(),dst=9,h$t=6,y$t=Math.pow(10,h$t),gce=Math.pow(10,dst);function W$(u){let c=u/1e3,f=Math.trunc(c),v=Math.round(u%1e3*y$t);return[f,v]}np.millisToHrTime=W$;function LPe(){let u=MPe.otperformance.timeOrigin;if(typeof u!="number"){let c=MPe.otperformance;u=c.timing&&c.timing.fetchStart}return u}np.getTimeOrigin=LPe;function mst(u){let c=W$(LPe()),f=W$(typeof u=="number"?u:MPe.otperformance.now());return gst(c,f)}np.hrTime=mst;function v$t(u){if(FPe(u))return u;if(typeof u=="number")return u<LPe()?mst(u):W$(u);if(u instanceof Date)return W$(u.getTime());throw TypeError("Invalid input type")}np.timeInputToHrTime=v$t;function S$t(u,c){let f=c[0]-u[0],v=c[1]-u[1];return v<0&&(f-=1,v+=gce),[f,v]}np.hrTimeDuration=S$t;function T$t(u){let c=dst,f=`${"0".repeat(c)}${u[1]}Z`,v=f.substr(f.length-c-1);return new Date(u[0]*1e3).toISOString().replace("000Z",v)}np.hrTimeToTimeStamp=T$t;function b$t(u){return u[0]*gce+u[1]}np.hrTimeToNanoseconds=b$t;function E$t(u){return u[0]*1e3+u[1]/1e6}np.hrTimeToMilliseconds=E$t;function x$t(u){return u[0]*1e6+u[1]/1e3}np.hrTimeToMicroseconds=x$t;function FPe(u){return Array.isArray(u)&&u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"}np.isTimeInputHrTime=FPe;function C$t(u){return FPe(u)||typeof u=="number"||u instanceof Date}np.isTimeInput=C$t;function gst(u,c){let f=[u[0]+c[0],u[1]+c[1]];return f[1]>=gce&&(f[1]-=gce,f[0]+=1),f}np.addHrTimes=gst});var vst=At(yst=>{"use strict";Object.defineProperty(yst,"__esModule",{value:!0})});var Sst=At(G$=>{"use strict";Object.defineProperty(G$,"__esModule",{value:!0});G$.ExportResultCode=void 0;var A$t;(function(u){u[u.SUCCESS=0]="SUCCESS",u[u.FAILED=1]="FAILED"})(A$t=G$.ExportResultCode||(G$.ExportResultCode={}))});var bst=At(hce=>{"use strict";Object.defineProperty(hce,"__esModule",{value:!0});hce.CompositePropagator=void 0;var Tst=(jc(),tl(Gc)),jPe=class{constructor(c={}){var f;this._propagators=(f=c.propagators)!==null&&f!==void 0?f:[],this._fields=Array.from(new Set(this._propagators.map(v=>typeof v.fields=="function"?v.fields():[]).reduce((v,x)=>v.concat(x),[])))}inject(c,f,v){for(let x of this._propagators)try{x.inject(c,f,v)}catch(w){Tst.diag.warn(`Failed to inject with ${x.constructor.name}. Err: ${w.message}`)}}extract(c,f,v){return this._propagators.reduce((x,w)=>{try{return w.extract(x,f,v)}catch(F){Tst.diag.warn(`Failed to inject with ${w.constructor.name}. Err: ${F.message}`)}return x},c)}fields(){return this._fields.slice()}};hce.CompositePropagator=jPe});var Est=At(cF=>{"use strict";Object.defineProperty(cF,"__esModule",{value:!0});cF.validateValue=cF.validateKey=void 0;var BPe="[_0-9a-z-*/]",k$t=`[a-z]${BPe}{0,255}`,P$t=`[a-z0-9]${BPe}{0,240}@[a-z]${BPe}{0,13}`,N$t=new RegExp(`^(?:${k$t}|${P$t})$`),D$t=/^[ -~]{0,255}[!-~]$/,I$t=/,|=/;function w$t(u){return N$t.test(u)}cF.validateKey=w$t;function O$t(u){return D$t.test(u)&&!I$t.test(u)}cF.validateValue=O$t});var VPe=At(yce=>{"use strict";Object.defineProperty(yce,"__esModule",{value:!0});yce.TraceState=void 0;var xst=Est(),Cst=32,R$t=512,Ast=",",kst="=",UPe=class u{constructor(c){this._internalState=new Map,c&&this._parse(c)}set(c,f){let v=this._clone();return v._internalState.has(c)&&v._internalState.delete(c),v._internalState.set(c,f),v}unset(c){let f=this._clone();return f._internalState.delete(c),f}get(c){return this._internalState.get(c)}serialize(){return this._keys().reduce((c,f)=>(c.push(f+kst+this.get(f)),c),[]).join(Ast)}_parse(c){c.length>R$t||(this._internalState=c.split(Ast).reverse().reduce((f,v)=>{let x=v.trim(),w=x.indexOf(kst);if(w!==-1){let F=x.slice(0,w),ee=x.slice(w+1,v.length);(0,xst.validateKey)(F)&&(0,xst.validateValue)(ee)&&f.set(F,ee)}return f},new Map),this._internalState.size>Cst&&(this._internalState=new Map(Array.from(this._internalState.entries()).reverse().slice(0,Cst))))}_keys(){return Array.from(this._internalState.keys()).reverse()}_clone(){let c=new u;return c._internalState=new Map(this._internalState),c}};yce.TraceState=UPe});var Nst=At(iy=>{"use strict";Object.defineProperty(iy,"__esModule",{value:!0});iy.W3CTraceContextPropagator=iy.parseTraceParent=iy.TRACE_STATE_HEADER=iy.TRACE_PARENT_HEADER=void 0;var vce=(jc(),tl(Gc)),M$t=q$(),L$t=VPe();iy.TRACE_PARENT_HEADER="traceparent";iy.TRACE_STATE_HEADER="tracestate";var F$t="00",j$t="(?!ff)[\\da-f]{2}",B$t="(?![0]{32})[\\da-f]{32}",U$t="(?![0]{16})[\\da-f]{16}",V$t="[\\da-f]{2}",J$t=new RegExp(`^\\s?(${j$t})-(${B$t})-(${U$t})-(${V$t})(-.*)?\\s?$`);function Pst(u){let c=J$t.exec(u);return!c||c[1]==="00"&&c[5]?null:{traceId:c[2],spanId:c[3],traceFlags:parseInt(c[4],16)}}iy.parseTraceParent=Pst;var JPe=class{inject(c,f,v){let x=vce.trace.getSpanContext(c);if(!x||(0,M$t.isTracingSuppressed)(c)||!(0,vce.isSpanContextValid)(x))return;let w=`${F$t}-${x.traceId}-${x.spanId}-0${Number(x.traceFlags||vce.TraceFlags.NONE).toString(16)}`;v.set(f,iy.TRACE_PARENT_HEADER,w),x.traceState&&v.set(f,iy.TRACE_STATE_HEADER,x.traceState.serialize())}extract(c,f,v){let x=v.get(f,iy.TRACE_PARENT_HEADER);if(!x)return c;let w=Array.isArray(x)?x[0]:x;if(typeof w!="string")return c;let F=Pst(w);if(!F)return c;F.isRemote=!0;let ee=v.get(f,iy.TRACE_STATE_HEADER);if(ee){let me=Array.isArray(ee)?ee.join(","):ee;F.traceState=new L$t.TraceState(typeof me=="string"?me:void 0)}return vce.trace.setSpanContext(c,F)}fields(){return[iy.TRACE_PARENT_HEADER,iy.TRACE_STATE_HEADER]}};iy.W3CTraceContextPropagator=JPe});var Ist=At(Dst=>{"use strict";Object.defineProperty(Dst,"__esModule",{value:!0})});var wst=At(d2=>{"use strict";Object.defineProperty(d2,"__esModule",{value:!0});d2.getRPCMetadata=d2.deleteRPCMetadata=d2.setRPCMetadata=d2.RPCType=void 0;var q$t=(jc(),tl(Gc)),qPe=(0,q$t.createContextKey)("OpenTelemetry SDK Context Key RPC_METADATA"),z$t;(function(u){u.HTTP="http"})(z$t=d2.RPCType||(d2.RPCType={}));function $$t(u,c){return u.setValue(qPe,c)}d2.setRPCMetadata=$$t;function W$t(u){return u.deleteValue(qPe)}d2.deleteRPCMetadata=W$t;function G$t(u){return u.getValue(qPe)}d2.getRPCMetadata=G$t});var $Pe=At(Sce=>{"use strict";Object.defineProperty(Sce,"__esModule",{value:!0});Sce.AlwaysOffSampler=void 0;var H$t=(jc(),tl(Gc)),zPe=class{shouldSample(){return{decision:H$t.SamplingDecision.NOT_RECORD}}toString(){return"AlwaysOffSampler"}};Sce.AlwaysOffSampler=zPe});var GPe=At(Tce=>{"use strict";Object.defineProperty(Tce,"__esModule",{value:!0});Tce.AlwaysOnSampler=void 0;var Y$t=(jc(),tl(Gc)),WPe=class{shouldSample(){return{decision:Y$t.SamplingDecision.RECORD_AND_SAMPLED}}toString(){return"AlwaysOnSampler"}};Tce.AlwaysOnSampler=WPe});var Rst=At(Ece=>{"use strict";Object.defineProperty(Ece,"__esModule",{value:!0});Ece.ParentBasedSampler=void 0;var bce=(jc(),tl(Gc)),X$t=APe(),Ost=$Pe(),HPe=GPe(),YPe=class{constructor(c){var f,v,x,w;this._root=c.root,this._root||((0,X$t.globalErrorHandler)(new Error("ParentBasedSampler must have a root sampler configured")),this._root=new HPe.AlwaysOnSampler),this._remoteParentSampled=(f=c.remoteParentSampled)!==null&&f!==void 0?f:new HPe.AlwaysOnSampler,this._remoteParentNotSampled=(v=c.remoteParentNotSampled)!==null&&v!==void 0?v:new Ost.AlwaysOffSampler,this._localParentSampled=(x=c.localParentSampled)!==null&&x!==void 0?x:new HPe.AlwaysOnSampler,this._localParentNotSampled=(w=c.localParentNotSampled)!==null&&w!==void 0?w:new Ost.AlwaysOffSampler}shouldSample(c,f,v,x,w,F){let ee=bce.trace.getSpanContext(c);return!ee||!(0,bce.isSpanContextValid)(ee)?this._root.shouldSample(c,f,v,x,w,F):ee.isRemote?ee.traceFlags&bce.TraceFlags.SAMPLED?this._remoteParentSampled.shouldSample(c,f,v,x,w,F):this._remoteParentNotSampled.shouldSample(c,f,v,x,w,F):ee.traceFlags&bce.TraceFlags.SAMPLED?this._localParentSampled.shouldSample(c,f,v,x,w,F):this._localParentNotSampled.shouldSample(c,f,v,x,w,F)}toString(){return`ParentBased{root=${this._root.toString()}, remoteParentSampled=${this._remoteParentSampled.toString()}, remoteParentNotSampled=${this._remoteParentNotSampled.toString()}, localParentSampled=${this._localParentSampled.toString()}, localParentNotSampled=${this._localParentNotSampled.toString()}}`}};Ece.ParentBasedSampler=YPe});var Mst=At(xce=>{"use strict";Object.defineProperty(xce,"__esModule",{value:!0});xce.TraceIdRatioBasedSampler=void 0;var XPe=(jc(),tl(Gc)),KPe=class{constructor(c=0){this._ratio=c,this._ratio=this._normalize(c),this._upperBound=Math.floor(this._ratio*4294967295)}shouldSample(c,f){return{decision:(0,XPe.isValidTraceId)(f)&&this._accumulate(f)<this._upperBound?XPe.SamplingDecision.RECORD_AND_SAMPLED:XPe.SamplingDecision.NOT_RECORD}}toString(){return`TraceIdRatioBased{${this._ratio}}`}_normalize(c){return typeof c!="number"||isNaN(c)?0:c>=1?1:c<=0?0:c}_accumulate(c){let f=0;for(let v=0;v<c.length/8;v++){let x=v*8,w=parseInt(c.slice(x,x+8),16);f=(f^w)>>>0}return f}};xce.TraceIdRatioBasedSampler=KPe});var Ust=At(Cce=>{"use strict";Object.defineProperty(Cce,"__esModule",{value:!0});Cce.isPlainObject=void 0;var K$t="[object Object]",Q$t="[object Null]",Z$t="[object Undefined]",eWt=Function.prototype,Lst=eWt.toString,tWt=Lst.call(Object),rWt=nWt(Object.getPrototypeOf,Object),Fst=Object.prototype,jst=Fst.hasOwnProperty,$4=Symbol?Symbol.toStringTag:void 0,Bst=Fst.toString;function nWt(u,c){return function(f){return u(c(f))}}function iWt(u){if(!sWt(u)||aWt(u)!==K$t)return!1;let c=rWt(u);if(c===null)return!0;let f=jst.call(c,"constructor")&&c.constructor;return typeof f=="function"&&f instanceof f&&Lst.call(f)===tWt}Cce.isPlainObject=iWt;function sWt(u){return u!=null&&typeof u=="object"}function aWt(u){return u==null?u===void 0?Z$t:Q$t:$4&&$4 in Object(u)?oWt(u):cWt(u)}function oWt(u){let c=jst.call(u,$4),f=u[$4],v=!1;try{u[$4]=void 0,v=!0}catch{}let x=Bst.call(u);return v&&(c?u[$4]=f:delete u[$4]),x}function cWt(u){return Bst.call(u)}});var $st=At(Pce=>{"use strict";Object.defineProperty(Pce,"__esModule",{value:!0});Pce.merge=void 0;var Vst=Ust(),lWt=20;function uWt(...u){let c=u.shift(),f=new WeakMap;for(;u.length>0;)c=qst(c,u.shift(),0,f);return c}Pce.merge=uWt;function QPe(u){return kce(u)?u.slice():u}function qst(u,c,f=0,v){let x;if(!(f>lWt)){if(f++,Ace(u)||Ace(c)||zst(c))x=QPe(c);else if(kce(u)){if(x=u.slice(),kce(c))for(let w=0,F=c.length;w<F;w++)x.push(QPe(c[w]));else if(H$(c)){let w=Object.keys(c);for(let F=0,ee=w.length;F<ee;F++){let me=w[F];x[me]=QPe(c[me])}}}else if(H$(u))if(H$(c)){if(!_Wt(u,c))return c;x=Object.assign({},u);let w=Object.keys(c);for(let F=0,ee=w.length;F<ee;F++){let me=w[F],de=c[me];if(Ace(de))typeof de>"u"?delete x[me]:x[me]=de;else{let Te=x[me],ut=de;if(Jst(u,me,v)||Jst(c,me,v))delete x[me];else{if(H$(Te)&&H$(ut)){let Ct=v.get(Te)||[],Kt=v.get(ut)||[];Ct.push({obj:u,key:me}),Kt.push({obj:c,key:me}),v.set(Te,Ct),v.set(ut,Kt)}x[me]=qst(x[me],de,f,v)}}}}else x=c;return x}}function Jst(u,c,f){let v=f.get(u[c])||[];for(let x=0,w=v.length;x<w;x++){let F=v[x];if(F.key===c&&F.obj===u)return!0}return!1}function kce(u){return Array.isArray(u)}function zst(u){return typeof u=="function"}function H$(u){return!Ace(u)&&!kce(u)&&!zst(u)&&typeof u=="object"}function Ace(u){return typeof u=="string"||typeof u=="number"||typeof u=="boolean"||typeof u>"u"||u instanceof Date||u instanceof RegExp||u===null}function _Wt(u,c){return!(!(0,Vst.isPlainObject)(u)||!(0,Vst.isPlainObject)(c))}});var Wst=At(lF=>{"use strict";Object.defineProperty(lF,"__esModule",{value:!0});lF.callWithTimeout=lF.TimeoutError=void 0;var Nce=class u extends Error{constructor(c){super(c),Object.setPrototypeOf(this,u.prototype)}};lF.TimeoutError=Nce;function fWt(u,c){let f,v=new Promise(function(w,F){f=setTimeout(function(){F(new Nce("Operation timed out."))},c)});return Promise.race([u,v]).then(x=>(clearTimeout(f),x),x=>{throw clearTimeout(f),x})}lF.callWithTimeout=fWt});var Hst=At(uF=>{"use strict";Object.defineProperty(uF,"__esModule",{value:!0});uF.isUrlIgnored=uF.urlMatches=void 0;function Gst(u,c){return typeof c=="string"?u===c:!!u.match(c)}uF.urlMatches=Gst;function pWt(u,c){if(!c)return!1;for(let f of c)if(Gst(u,f))return!0;return!1}uF.isUrlIgnored=pWt});var Yst=At(Dce=>{"use strict";Object.defineProperty(Dce,"__esModule",{value:!0});Dce.isWrapped=void 0;function dWt(u){return typeof u=="function"&&typeof u.__original=="function"&&typeof u.__unwrap=="function"&&u.__wrapped===!0}Dce.isWrapped=dWt});var Xst=At(Ice=>{"use strict";Object.defineProperty(Ice,"__esModule",{value:!0});Ice.Deferred=void 0;var ZPe=class{constructor(){this._promise=new Promise((c,f)=>{this._resolve=c,this._reject=f})}get promise(){return this._promise}resolve(c){this._resolve(c)}reject(c){this._reject(c)}};Ice.Deferred=ZPe});var Kst=At(wce=>{"use strict";Object.defineProperty(wce,"__esModule",{value:!0});wce.BindOnceFuture=void 0;var mWt=Xst(),eNe=class{constructor(c,f){this._callback=c,this._that=f,this._isCalled=!1,this._deferred=new mWt.Deferred}get isCalled(){return this._isCalled}get promise(){return this._deferred.promise}call(...c){if(!this._isCalled){this._isCalled=!0;try{Promise.resolve(this._callback.call(this._that,...c)).then(f=>this._deferred.resolve(f),f=>this._deferred.reject(f))}catch(f){this._deferred.reject(f)}}return this._deferred.promise}};wce.BindOnceFuture=eNe});var Zst=At(Oce=>{"use strict";Object.defineProperty(Oce,"__esModule",{value:!0});Oce._export=void 0;var Qst=(jc(),tl(Gc)),gWt=q$();function hWt(u,c){return new Promise(f=>{Qst.context.with((0,gWt.suppressTracing)(Qst.context.active()),()=>{u.export(c,v=>{f(v)})})})}Oce._export=hWt});var p0=At(Wl=>{"use strict";var yWt=Wl&&Wl.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),Ef=Wl&&Wl.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&yWt(c,u,f)};Object.defineProperty(Wl,"__esModule",{value:!0});Wl.internal=Wl.baggageUtils=void 0;Ef(PKe(),Wl);Ef(NKe(),Wl);Ef(RKe(),Wl);Ef(APe(),Wl);Ef(CPe(),Wl);Ef(hst(),Wl);Ef(vst(),Wl);Ef(DPe(),Wl);Ef(Sst(),Wl);Wl.baggageUtils=SPe();Ef(RPe(),Wl);Ef(bst(),Wl);Ef(Nst(),Wl);Ef(Ist(),Wl);Ef(wst(),Wl);Ef($Pe(),Wl);Ef(GPe(),Wl);Ef(Rst(),Wl);Ef(Mst(),Wl);Ef(q$(),Wl);Ef(VPe(),Wl);Ef(PPe(),Wl);Ef($st(),Wl);Ef(kPe(),Wl);Ef(Wst(),Wl);Ef(Hst(),Wl);Ef(Yst(),Wl);Ef(Kst(),Wl);Ef(wPe(),Wl);var vWt=Zst();Wl.internal={_export:vWt._export}});var Rce=At(Y$=>{"use strict";Object.defineProperty(Y$,"__esModule",{value:!0});Y$.AggregationTemporality=void 0;var SWt;(function(u){u[u.DELTA=0]="DELTA",u[u.CUMULATIVE=1]="CUMULATIVE"})(SWt=Y$.AggregationTemporality||(Y$.AggregationTemporality={}))});var _F=At(X$=>{"use strict";Object.defineProperty(X$,"__esModule",{value:!0});X$.DataPointType=void 0;var TWt;(function(u){u[u.HISTOGRAM=0]="HISTOGRAM",u[u.EXPONENTIAL_HISTOGRAM=1]="EXPONENTIAL_HISTOGRAM",u[u.GAUGE=2]="GAUGE",u[u.SUM=3]="SUM"})(TWt=X$.DataPointType||(X$.DataPointType={}))});var jC=At(Kp=>{"use strict";Object.defineProperty(Kp,"__esModule",{value:!0});Kp.equalsCaseInsensitive=Kp.binarySearchLB=Kp.setEquals=Kp.FlatMap=Kp.isPromiseAllSettledRejectionResult=Kp.PromiseAllSettled=Kp.callWithTimeout=Kp.TimeoutError=Kp.instrumentationScopeId=Kp.hashAttributes=Kp.isNotNullish=void 0;function bWt(u){return u!=null}Kp.isNotNullish=bWt;function EWt(u){let c=Object.keys(u);return c.length===0?"":(c=c.sort(),JSON.stringify(c.map(f=>[f,u[f]])))}Kp.hashAttributes=EWt;function xWt(u){var c,f;return`${u.name}:${(c=u.version)!==null&&c!==void 0?c:""}:${(f=u.schemaUrl)!==null&&f!==void 0?f:""}`}Kp.instrumentationScopeId=xWt;var Mce=class u extends Error{constructor(c){super(c),Object.setPrototypeOf(this,u.prototype)}};Kp.TimeoutError=Mce;function CWt(u,c){let f,v=new Promise(function(w,F){f=setTimeout(function(){F(new Mce("Operation timed out."))},c)});return Promise.race([u,v]).then(x=>(clearTimeout(f),x),x=>{throw clearTimeout(f),x})}Kp.callWithTimeout=CWt;async function AWt(u){return Promise.all(u.map(async c=>{try{return{status:"fulfilled",value:await c}}catch(f){return{status:"rejected",reason:f}}}))}Kp.PromiseAllSettled=AWt;function kWt(u){return u.status==="rejected"}Kp.isPromiseAllSettledRejectionResult=kWt;function PWt(u,c){let f=[];return u.forEach(v=>{f.push(...c(v))}),f}Kp.FlatMap=PWt;function NWt(u,c){if(u.size!==c.size)return!1;for(let f of u)if(!c.has(f))return!1;return!0}Kp.setEquals=NWt;function DWt(u,c){let f=0,v=u.length-1;for(;v-f>1;){let x=Math.trunc((v+f)/2);u[x]<=c?f=x:v=x-1}return u[v]<=c?v:u[f]<=c?f:-1}Kp.binarySearchLB=DWt;function IWt(u,c){return u.toLowerCase()===c.toLowerCase()}Kp.equalsCaseInsensitive=IWt});var fF=At(K$=>{"use strict";Object.defineProperty(K$,"__esModule",{value:!0});K$.AggregatorKind=void 0;var wWt;(function(u){u[u.DROP=0]="DROP",u[u.SUM=1]="SUM",u[u.LAST_VALUE=2]="LAST_VALUE",u[u.HISTOGRAM=3]="HISTOGRAM",u[u.EXPONENTIAL_HISTOGRAM=4]="EXPONENTIAL_HISTOGRAM"})(wWt=K$.AggregatorKind||(K$.AggregatorKind={}))});var eat=At(Lce=>{"use strict";Object.defineProperty(Lce,"__esModule",{value:!0});Lce.DropAggregator=void 0;var OWt=fF(),tNe=class{constructor(){this.kind=OWt.AggregatorKind.DROP}createAccumulation(){}merge(c,f){}diff(c,f){}toMetricData(c,f,v,x){}};Lce.DropAggregator=tNe});var yP=At(QS=>{"use strict";Object.defineProperty(QS,"__esModule",{value:!0});QS.isValidName=QS.isDescriptorCompatibleWith=QS.createInstrumentDescriptorWithView=QS.createInstrumentDescriptor=QS.InstrumentType=void 0;var tat=(jc(),tl(Gc)),RWt=jC(),MWt;(function(u){u.COUNTER="COUNTER",u.GAUGE="GAUGE",u.HISTOGRAM="HISTOGRAM",u.UP_DOWN_COUNTER="UP_DOWN_COUNTER",u.OBSERVABLE_COUNTER="OBSERVABLE_COUNTER",u.OBSERVABLE_GAUGE="OBSERVABLE_GAUGE",u.OBSERVABLE_UP_DOWN_COUNTER="OBSERVABLE_UP_DOWN_COUNTER"})(MWt=QS.InstrumentType||(QS.InstrumentType={}));function LWt(u,c,f){var v,x,w,F;return rat(u)||tat.diag.warn(`Invalid metric name: "${u}". The metric name should be a ASCII string with a length no greater than 255 characters.`),{name:u,type:c,description:(v=f?.description)!==null&&v!==void 0?v:"",unit:(x=f?.unit)!==null&&x!==void 0?x:"",valueType:(w=f?.valueType)!==null&&w!==void 0?w:tat.ValueType.DOUBLE,advice:(F=f?.advice)!==null&&F!==void 0?F:{}}}QS.createInstrumentDescriptor=LWt;function FWt(u,c){var f,v;return{name:(f=u.name)!==null&&f!==void 0?f:c.name,description:(v=u.description)!==null&&v!==void 0?v:c.description,type:c.type,unit:c.unit,valueType:c.valueType,advice:c.advice}}QS.createInstrumentDescriptorWithView=FWt;function jWt(u,c){return(0,RWt.equalsCaseInsensitive)(u.name,c.name)&&u.unit===c.unit&&u.type===c.type&&u.valueType===c.valueType}QS.isDescriptorCompatibleWith=jWt;var BWt=/^[a-z][a-z0-9_.\-/]{0,254}$/i;function rat(u){return u.match(BWt)!=null}QS.isValidName=rat});var nat=At(dF=>{"use strict";Object.defineProperty(dF,"__esModule",{value:!0});dF.HistogramAggregator=dF.HistogramAccumulation=void 0;var UWt=fF(),VWt=_F(),Fce=yP(),JWt=jC();function qWt(u){let c=u.map(()=>0);return c.push(0),{buckets:{boundaries:u,counts:c},sum:0,count:0,hasMinMax:!1,min:1/0,max:-1/0}}var pF=class{constructor(c,f,v=!0,x=qWt(f)){this.startTime=c,this._boundaries=f,this._recordMinMax=v,this._current=x}record(c){if(Number.isNaN(c))return;this._current.count+=1,this._current.sum+=c,this._recordMinMax&&(this._current.min=Math.min(c,this._current.min),this._current.max=Math.max(c,this._current.max),this._current.hasMinMax=!0);let f=(0,JWt.binarySearchLB)(this._boundaries,c);this._current.buckets.counts[f+1]+=1}setStartTime(c){this.startTime=c}toPointValue(){return this._current}};dF.HistogramAccumulation=pF;var rNe=class{constructor(c,f){this._boundaries=c,this._recordMinMax=f,this.kind=UWt.AggregatorKind.HISTOGRAM}createAccumulation(c){return new pF(c,this._boundaries,this._recordMinMax)}merge(c,f){let v=c.toPointValue(),x=f.toPointValue(),w=v.buckets.counts,F=x.buckets.counts,ee=new Array(w.length);for(let Te=0;Te<w.length;Te++)ee[Te]=w[Te]+F[Te];let me=1/0,de=-1/0;return this._recordMinMax&&(v.hasMinMax&&x.hasMinMax?(me=Math.min(v.min,x.min),de=Math.max(v.max,x.max)):v.hasMinMax?(me=v.min,de=v.max):x.hasMinMax&&(me=x.min,de=x.max)),new pF(c.startTime,v.buckets.boundaries,this._recordMinMax,{buckets:{boundaries:v.buckets.boundaries,counts:ee},count:v.count+x.count,sum:v.sum+x.sum,hasMinMax:this._recordMinMax&&(v.hasMinMax||x.hasMinMax),min:me,max:de})}diff(c,f){let v=c.toPointValue(),x=f.toPointValue(),w=v.buckets.counts,F=x.buckets.counts,ee=new Array(w.length);for(let me=0;me<w.length;me++)ee[me]=F[me]-w[me];return new pF(f.startTime,v.buckets.boundaries,this._recordMinMax,{buckets:{boundaries:v.buckets.boundaries,counts:ee},count:x.count-v.count,sum:x.sum-v.sum,hasMinMax:!1,min:1/0,max:-1/0})}toMetricData(c,f,v,x){return{descriptor:c,aggregationTemporality:f,dataPointType:VWt.DataPointType.HISTOGRAM,dataPoints:v.map(([w,F])=>{let ee=F.toPointValue(),me=c.type===Fce.InstrumentType.GAUGE||c.type===Fce.InstrumentType.UP_DOWN_COUNTER||c.type===Fce.InstrumentType.OBSERVABLE_GAUGE||c.type===Fce.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER;return{attributes:w,startTime:F.startTime,endTime:x,value:{min:ee.hasMinMax?ee.min:void 0,max:ee.hasMinMax?ee.max:void 0,sum:me?void 0:ee.sum,buckets:ee.buckets,count:ee.count}}})}}};dF.HistogramAggregator=rNe});var iat=At(jce=>{"use strict";Object.defineProperty(jce,"__esModule",{value:!0});jce.Buckets=void 0;var nNe=class u{constructor(c=new iNe,f=0,v=0,x=0){this.backing=c,this.indexBase=f,this.indexStart=v,this.indexEnd=x}get offset(){return this.indexStart}get length(){return this.backing.length===0||this.indexEnd===this.indexStart&&this.at(0)===0?0:this.indexEnd-this.indexStart+1}counts(){return Array.from({length:this.length},(c,f)=>this.at(f))}at(c){let f=this.indexBase-this.indexStart;return c<f&&(c+=this.backing.length),c-=f,this.backing.countAt(c)}incrementBucket(c,f){this.backing.increment(c,f)}decrementBucket(c,f){this.backing.decrement(c,f)}trim(){for(let c=0;c<this.length;c++)if(this.at(c)!==0){this.indexStart+=c;break}else if(c===this.length-1){this.indexStart=this.indexEnd=this.indexBase=0;return}for(let c=this.length-1;c>=0;c--)if(this.at(c)!==0){this.indexEnd-=this.length-c-1;break}this._rotate()}downscale(c){this._rotate();let f=1+this.indexEnd-this.indexStart,v=1<<c,x=0,w=0;for(let F=this.indexStart;F<=this.indexEnd;){let ee=F%v;ee<0&&(ee+=v);for(let me=ee;me<v&&x<f;me++)this._relocateBucket(w,x),x++,F++;w++}this.indexStart>>=c,this.indexEnd>>=c,this.indexBase=this.indexStart}clone(){return new u(this.backing.clone(),this.indexBase,this.indexStart,this.indexEnd)}_rotate(){let c=this.indexBase-this.indexStart;c!==0&&(c>0?(this.backing.reverse(0,this.backing.length),this.backing.reverse(0,c),this.backing.reverse(c,this.backing.length)):(this.backing.reverse(0,this.backing.length),this.backing.reverse(0,this.backing.length+c)),this.indexBase=this.indexStart)}_relocateBucket(c,f){c!==f&&this.incrementBucket(c,this.backing.emptyBucket(f))}};jce.Buckets=nNe;var iNe=class u{constructor(c=[0]){this._counts=c}get length(){return this._counts.length}countAt(c){return this._counts[c]}growTo(c,f,v){let x=new Array(c).fill(0);x.splice(v,this._counts.length-f,...this._counts.slice(f)),x.splice(0,f,...this._counts.slice(0,f)),this._counts=x}reverse(c,f){let v=Math.floor((c+f)/2)-c;for(let x=0;x<v;x++){let w=this._counts[c+x];this._counts[c+x]=this._counts[f-x-1],this._counts[f-x-1]=w}}emptyBucket(c){let f=this._counts[c];return this._counts[c]=0,f}increment(c,f){this._counts[c]+=f}decrement(c,f){this._counts[c]>=f?this._counts[c]-=f:this._counts[c]=0}clone(){return new u([...this._counts])}}});var aNe=At(fv=>{"use strict";Object.defineProperty(fv,"__esModule",{value:!0});fv.getSignificand=fv.getNormalBase2=fv.MIN_VALUE=fv.MAX_NORMAL_EXPONENT=fv.MIN_NORMAL_EXPONENT=fv.SIGNIFICAND_WIDTH=void 0;fv.SIGNIFICAND_WIDTH=52;var zWt=2146435072,$Wt=1048575,sNe=1023;fv.MIN_NORMAL_EXPONENT=-sNe+1;fv.MAX_NORMAL_EXPONENT=sNe;fv.MIN_VALUE=Math.pow(2,-1022);function WWt(u){let c=new DataView(new ArrayBuffer(8));return c.setFloat64(0,u),((c.getUint32(0)&zWt)>>20)-sNe}fv.getNormalBase2=WWt;function GWt(u){let c=new DataView(new ArrayBuffer(8));c.setFloat64(0,u);let f=c.getUint32(0),v=c.getUint32(4);return(f&$Wt)*Math.pow(2,32)+v}fv.getSignificand=GWt});var Bce=At(mF=>{"use strict";Object.defineProperty(mF,"__esModule",{value:!0});mF.nextGreaterSquare=mF.ldexp=void 0;function HWt(u,c){return u===0||u===Number.POSITIVE_INFINITY||u===Number.NEGATIVE_INFINITY||Number.isNaN(u)?u:u*Math.pow(2,c)}mF.ldexp=HWt;function YWt(u){return u--,u|=u>>1,u|=u>>2,u|=u>>4,u|=u>>8,u|=u>>16,u++,u}mF.nextGreaterSquare=YWt});var Vce=At(Uce=>{"use strict";Object.defineProperty(Uce,"__esModule",{value:!0});Uce.MappingError=void 0;var oNe=class extends Error{};Uce.MappingError=oNe});var aat=At(Jce=>{"use strict";Object.defineProperty(Jce,"__esModule",{value:!0});Jce.ExponentMapping=void 0;var gF=aNe(),XWt=Bce(),sat=Vce(),cNe=class{constructor(c){this._shift=-c}mapToIndex(c){if(c<gF.MIN_VALUE)return this._minNormalLowerBoundaryIndex();let f=gF.getNormalBase2(c),v=this._rightShift(gF.getSignificand(c)-1,gF.SIGNIFICAND_WIDTH);return f+v>>this._shift}lowerBoundary(c){let f=this._minNormalLowerBoundaryIndex();if(c<f)throw new sat.MappingError(`underflow: ${c} is < minimum lower boundary: ${f}`);let v=this._maxNormalLowerBoundaryIndex();if(c>v)throw new sat.MappingError(`overflow: ${c} is > maximum lower boundary: ${v}`);return XWt.ldexp(1,c<<this._shift)}get scale(){return this._shift===0?0:-this._shift}_minNormalLowerBoundaryIndex(){let c=gF.MIN_NORMAL_EXPONENT>>this._shift;return this._shift<2&&c--,c}_maxNormalLowerBoundaryIndex(){return gF.MAX_NORMAL_EXPONENT>>this._shift}_rightShift(c,f){return Math.floor(c*Math.pow(2,-f))}};Jce.ExponentMapping=cNe});var lat=At(qce=>{"use strict";Object.defineProperty(qce,"__esModule",{value:!0});qce.LogarithmMapping=void 0;var hF=aNe(),oat=Bce(),cat=Vce(),lNe=class{constructor(c){this._scale=c,this._scaleFactor=oat.ldexp(Math.LOG2E,c),this._inverseFactor=oat.ldexp(Math.LN2,-c)}mapToIndex(c){if(c<=hF.MIN_VALUE)return this._minNormalLowerBoundaryIndex()-1;if(hF.getSignificand(c)===0)return(hF.getNormalBase2(c)<<this._scale)-1;let f=Math.floor(Math.log(c)*this._scaleFactor),v=this._maxNormalLowerBoundaryIndex();return f>=v?v:f}lowerBoundary(c){let f=this._maxNormalLowerBoundaryIndex();if(c>=f){if(c===f)return 2*Math.exp((c-(1<<this._scale))/this._scaleFactor);throw new cat.MappingError(`overflow: ${c} is > maximum lower boundary: ${f}`)}let v=this._minNormalLowerBoundaryIndex();if(c<=v){if(c===v)return hF.MIN_VALUE;if(c===v-1)return Math.exp((c+(1<<this._scale))/this._scaleFactor)/2;throw new cat.MappingError(`overflow: ${c} is < minimum lower boundary: ${v}`)}return Math.exp(c*this._inverseFactor)}get scale(){return this._scale}_minNormalLowerBoundaryIndex(){return hF.MIN_NORMAL_EXPONENT<<this._scale}_maxNormalLowerBoundaryIndex(){return(hF.MAX_NORMAL_EXPONENT+1<<this._scale)-1}};qce.LogarithmMapping=lNe});var fat=At(zce=>{"use strict";Object.defineProperty(zce,"__esModule",{value:!0});zce.getMapping=void 0;var KWt=aat(),QWt=lat(),ZWt=Vce(),uat=-10,_at=20,eGt=Array.from({length:31},(u,c)=>c>10?new QWt.LogarithmMapping(c-10):new KWt.ExponentMapping(c-10));function tGt(u){if(u>_at||u<uat)throw new ZWt.MappingError(`expected scale >= ${uat} && <= ${_at}, got: ${u}`);return eGt[u+10]}zce.getMapping=tGt});var mat=At(vF=>{"use strict";Object.defineProperty(vF,"__esModule",{value:!0});vF.ExponentialHistogramAggregator=vF.ExponentialHistogramAccumulation=void 0;var rGt=fF(),nGt=_F(),iGt=(jc(),tl(Gc)),$ce=yP(),pat=iat(),dat=fat(),sGt=Bce(),yF=class u{constructor(c,f){this.low=c,this.high=f}static combine(c,f){return new u(Math.min(c.low,f.low),Math.max(c.high,f.high))}},aGt=20,oGt=160,uNe=2,Wce=class u{constructor(c=c,f=oGt,v=!0,x=0,w=0,F=0,ee=Number.POSITIVE_INFINITY,me=Number.NEGATIVE_INFINITY,de=new pat.Buckets,Te=new pat.Buckets,ut=(0,dat.getMapping)(aGt)){this.startTime=c,this._maxSize=f,this._recordMinMax=v,this._sum=x,this._count=w,this._zeroCount=F,this._min=ee,this._max=me,this._positive=de,this._negative=Te,this._mapping=ut,this._maxSize<uNe&&(iGt.diag.warn(`Exponential Histogram Max Size set to ${this._maxSize},                 changing to the minimum size of: ${uNe}`),this._maxSize=uNe)}record(c){this.updateByIncrement(c,1)}setStartTime(c){this.startTime=c}toPointValue(){return{hasMinMax:this._recordMinMax,min:this.min,max:this.max,sum:this.sum,positive:{offset:this.positive.offset,bucketCounts:this.positive.counts()},negative:{offset:this.negative.offset,bucketCounts:this.negative.counts()},count:this.count,scale:this.scale,zeroCount:this.zeroCount}}get sum(){return this._sum}get min(){return this._min}get max(){return this._max}get count(){return this._count}get zeroCount(){return this._zeroCount}get scale(){return this._count===this._zeroCount?0:this._mapping.scale}get positive(){return this._positive}get negative(){return this._negative}updateByIncrement(c,f){if(!Number.isNaN(c)){if(c>this._max&&(this._max=c),c<this._min&&(this._min=c),this._count+=f,c===0){this._zeroCount+=f;return}this._sum+=c*f,c>0?this._updateBuckets(this._positive,c,f):this._updateBuckets(this._negative,-c,f)}}merge(c){this._count===0?(this._min=c.min,this._max=c.max):c.count!==0&&(c.min<this.min&&(this._min=c.min),c.max>this.max&&(this._max=c.max)),this.startTime=c.startTime,this._sum+=c.sum,this._count+=c.count,this._zeroCount+=c.zeroCount;let f=this._minScale(c);this._downscale(this.scale-f),this._mergeBuckets(this.positive,c,c.positive,f),this._mergeBuckets(this.negative,c,c.negative,f)}diff(c){this._min=1/0,this._max=-1/0,this._sum-=c.sum,this._count-=c.count,this._zeroCount-=c.zeroCount;let f=this._minScale(c);this._downscale(this.scale-f),this._diffBuckets(this.positive,c,c.positive,f),this._diffBuckets(this.negative,c,c.negative,f)}clone(){return new u(this.startTime,this._maxSize,this._recordMinMax,this._sum,this._count,this._zeroCount,this._min,this._max,this.positive.clone(),this.negative.clone(),this._mapping)}_updateBuckets(c,f,v){let x=this._mapping.mapToIndex(f),w=!1,F=0,ee=0;if(c.length===0?(c.indexStart=x,c.indexEnd=c.indexStart,c.indexBase=c.indexStart):x<c.indexStart&&c.indexEnd-x>=this._maxSize?(w=!0,ee=x,F=c.indexEnd):x>c.indexEnd&&x-c.indexStart>=this._maxSize&&(w=!0,ee=c.indexStart,F=x),w){let me=this._changeScale(F,ee);this._downscale(me),x=this._mapping.mapToIndex(f)}this._incrementIndexBy(c,x,v)}_incrementIndexBy(c,f,v){if(v===0)return;if(c.length===0&&(c.indexStart=c.indexEnd=c.indexBase=f),f<c.indexStart){let w=c.indexEnd-f;w>=c.backing.length&&this._grow(c,w+1),c.indexStart=f}else if(f>c.indexEnd){let w=f-c.indexStart;w>=c.backing.length&&this._grow(c,w+1),c.indexEnd=f}let x=f-c.indexBase;x<0&&(x+=c.backing.length),c.incrementBucket(x,v)}_grow(c,f){let v=c.backing.length,x=c.indexBase-c.indexStart,w=v-x,F=(0,sGt.nextGreaterSquare)(f);F>this._maxSize&&(F=this._maxSize);let ee=F-x;c.backing.growTo(F,w,ee)}_changeScale(c,f){let v=0;for(;c-f>=this._maxSize;)c>>=1,f>>=1,v++;return v}_downscale(c){if(c===0)return;if(c<0)throw new Error(`impossible change of scale: ${this.scale}`);let f=this._mapping.scale-c;this._positive.downscale(c),this._negative.downscale(c),this._mapping=(0,dat.getMapping)(f)}_minScale(c){let f=Math.min(this.scale,c.scale),v=yF.combine(this._highLowAtScale(this.positive,this.scale,f),this._highLowAtScale(c.positive,c.scale,f)),x=yF.combine(this._highLowAtScale(this.negative,this.scale,f),this._highLowAtScale(c.negative,c.scale,f));return Math.min(f-this._changeScale(v.high,v.low),f-this._changeScale(x.high,x.low))}_highLowAtScale(c,f,v){if(c.length===0)return new yF(0,-1);let x=f-v;return new yF(c.indexStart>>x,c.indexEnd>>x)}_mergeBuckets(c,f,v,x){let w=v.offset,F=f.scale-x;for(let ee=0;ee<v.length;ee++)this._incrementIndexBy(c,w+ee>>F,v.at(ee))}_diffBuckets(c,f,v,x){let w=v.offset,F=f.scale-x;for(let ee=0;ee<v.length;ee++){let de=(w+ee>>F)-c.indexBase;de<0&&(de+=c.backing.length),c.decrementBucket(de,v.at(ee))}c.trim()}};vF.ExponentialHistogramAccumulation=Wce;var _Ne=class{constructor(c,f){this._maxSize=c,this._recordMinMax=f,this.kind=rGt.AggregatorKind.EXPONENTIAL_HISTOGRAM}createAccumulation(c){return new Wce(c,this._maxSize,this._recordMinMax)}merge(c,f){let v=f.clone();return v.merge(c),v}diff(c,f){let v=f.clone();return v.diff(c),v}toMetricData(c,f,v,x){return{descriptor:c,aggregationTemporality:f,dataPointType:nGt.DataPointType.EXPONENTIAL_HISTOGRAM,dataPoints:v.map(([w,F])=>{let ee=F.toPointValue(),me=c.type===$ce.InstrumentType.GAUGE||c.type===$ce.InstrumentType.UP_DOWN_COUNTER||c.type===$ce.InstrumentType.OBSERVABLE_GAUGE||c.type===$ce.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER;return{attributes:w,startTime:F.startTime,endTime:x,value:{min:ee.hasMinMax?ee.min:void 0,max:ee.hasMinMax?ee.max:void 0,sum:me?void 0:ee.sum,positive:{offset:ee.positive.offset,bucketCounts:ee.positive.bucketCounts},negative:{offset:ee.negative.offset,bucketCounts:ee.negative.bucketCounts},count:ee.count,scale:ee.scale,zeroCount:ee.zeroCount}}})}}};vF.ExponentialHistogramAggregator=_Ne});var gat=At(TF=>{"use strict";Object.defineProperty(TF,"__esModule",{value:!0});TF.LastValueAggregator=TF.LastValueAccumulation=void 0;var cGt=fF(),Q$=p0(),lGt=_F(),SF=class{constructor(c,f=0,v=[0,0]){this.startTime=c,this._current=f,this.sampleTime=v}record(c){this._current=c,this.sampleTime=(0,Q$.millisToHrTime)(Date.now())}setStartTime(c){this.startTime=c}toPointValue(){return this._current}};TF.LastValueAccumulation=SF;var fNe=class{constructor(){this.kind=cGt.AggregatorKind.LAST_VALUE}createAccumulation(c){return new SF(c)}merge(c,f){let v=(0,Q$.hrTimeToMicroseconds)(f.sampleTime)>=(0,Q$.hrTimeToMicroseconds)(c.sampleTime)?f:c;return new SF(c.startTime,v.toPointValue(),v.sampleTime)}diff(c,f){let v=(0,Q$.hrTimeToMicroseconds)(f.sampleTime)>=(0,Q$.hrTimeToMicroseconds)(c.sampleTime)?f:c;return new SF(f.startTime,v.toPointValue(),v.sampleTime)}toMetricData(c,f,v,x){return{descriptor:c,aggregationTemporality:f,dataPointType:lGt.DataPointType.GAUGE,dataPoints:v.map(([w,F])=>({attributes:w,startTime:F.startTime,endTime:x,value:F.toPointValue()}))}}};TF.LastValueAggregator=fNe});var hat=At(bF=>{"use strict";Object.defineProperty(bF,"__esModule",{value:!0});bF.SumAggregator=bF.SumAccumulation=void 0;var uGt=fF(),_Gt=_F(),GI=class{constructor(c,f,v=0,x=!1){this.startTime=c,this.monotonic=f,this._current=v,this.reset=x}record(c){this.monotonic&&c<0||(this._current+=c)}setStartTime(c){this.startTime=c}toPointValue(){return this._current}};bF.SumAccumulation=GI;var pNe=class{constructor(c){this.monotonic=c,this.kind=uGt.AggregatorKind.SUM}createAccumulation(c){return new GI(c,this.monotonic)}merge(c,f){let v=c.toPointValue(),x=f.toPointValue();return f.reset?new GI(f.startTime,this.monotonic,x,f.reset):new GI(c.startTime,this.monotonic,v+x)}diff(c,f){let v=c.toPointValue(),x=f.toPointValue();return this.monotonic&&v>x?new GI(f.startTime,this.monotonic,x,!0):new GI(f.startTime,this.monotonic,x-v)}toMetricData(c,f,v,x){return{descriptor:c,aggregationTemporality:f,dataPointType:_Gt.DataPointType.SUM,dataPoints:v.map(([w,F])=>({attributes:w,startTime:F.startTime,endTime:x,value:F.toPointValue()})),isMonotonic:this.monotonic}}};bF.SumAggregator=pNe});var yat=At(m2=>{"use strict";var fGt=m2&&m2.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),Z$=m2&&m2.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&fGt(c,u,f)};Object.defineProperty(m2,"__esModule",{value:!0});Z$(eat(),m2);Z$(nat(),m2);Z$(mat(),m2);Z$(gat(),m2);Z$(hat(),m2)});var Xce=At(Ch=>{"use strict";Object.defineProperty(Ch,"__esModule",{value:!0});Ch.DefaultAggregation=Ch.ExponentialHistogramAggregation=Ch.ExplicitBucketHistogramAggregation=Ch.HistogramAggregation=Ch.LastValueAggregation=Ch.SumAggregation=Ch.DropAggregation=Ch.Aggregation=void 0;var pGt=(jc(),tl(Gc)),W4=yat(),BC=yP(),UC=class{static Drop(){return vat}static Sum(){return Sat}static LastValue(){return Tat}static Histogram(){return bat}static ExponentialHistogram(){return dGt}static Default(){return mGt}};Ch.Aggregation=UC;var eW=class u extends UC{createAggregator(c){return u.DEFAULT_INSTANCE}};Ch.DropAggregation=eW;eW.DEFAULT_INSTANCE=new W4.DropAggregator;var EF=class u extends UC{createAggregator(c){switch(c.type){case BC.InstrumentType.COUNTER:case BC.InstrumentType.OBSERVABLE_COUNTER:case BC.InstrumentType.HISTOGRAM:return u.MONOTONIC_INSTANCE;default:return u.NON_MONOTONIC_INSTANCE}}};Ch.SumAggregation=EF;EF.MONOTONIC_INSTANCE=new W4.SumAggregator(!0);EF.NON_MONOTONIC_INSTANCE=new W4.SumAggregator(!1);var tW=class u extends UC{createAggregator(c){return u.DEFAULT_INSTANCE}};Ch.LastValueAggregation=tW;tW.DEFAULT_INSTANCE=new W4.LastValueAggregator;var rW=class u extends UC{createAggregator(c){return u.DEFAULT_INSTANCE}};Ch.HistogramAggregation=rW;rW.DEFAULT_INSTANCE=new W4.HistogramAggregator([0,5,10,25,50,75,100,250,500,750,1e3,2500,5e3,7500,1e4],!0);var Gce=class extends UC{constructor(c,f=!0){if(super(),this._recordMinMax=f,c==null)throw new Error("ExplicitBucketHistogramAggregation should be created with explicit boundaries, if a single bucket histogram is required, please pass an empty array");c=c.concat(),c=c.sort((w,F)=>w-F);let v=c.lastIndexOf(-1/0),x=c.indexOf(1/0);x===-1&&(x=void 0),this._boundaries=c.slice(v+1,x)}createAggregator(c){return new W4.HistogramAggregator(this._boundaries,this._recordMinMax)}};Ch.ExplicitBucketHistogramAggregation=Gce;var Hce=class extends UC{constructor(c=160,f=!0){super(),this._maxSize=c,this._recordMinMax=f}createAggregator(c){return new W4.ExponentialHistogramAggregator(this._maxSize,this._recordMinMax)}};Ch.ExponentialHistogramAggregation=Hce;var Yce=class extends UC{_resolve(c){switch(c.type){case BC.InstrumentType.COUNTER:case BC.InstrumentType.UP_DOWN_COUNTER:case BC.InstrumentType.OBSERVABLE_COUNTER:case BC.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER:return Sat;case BC.InstrumentType.GAUGE:case BC.InstrumentType.OBSERVABLE_GAUGE:return Tat;case BC.InstrumentType.HISTOGRAM:return c.advice.explicitBucketBoundaries?new Gce(c.advice.explicitBucketBoundaries):bat}return pGt.diag.warn(`Unable to recognize instrument type: ${c.type}`),vat}createAggregator(c){return this._resolve(c).createAggregator(c)}};Ch.DefaultAggregation=Yce;var vat=new eW,Sat=new EF,Tat=new tW,bat=new rW,dGt=new Hce,mGt=new Yce});var dNe=At(xF=>{"use strict";Object.defineProperty(xF,"__esModule",{value:!0});xF.DEFAULT_AGGREGATION_TEMPORALITY_SELECTOR=xF.DEFAULT_AGGREGATION_SELECTOR=void 0;var gGt=Xce(),hGt=Rce(),yGt=u=>gGt.Aggregation.Default();xF.DEFAULT_AGGREGATION_SELECTOR=yGt;var vGt=u=>hGt.AggregationTemporality.CUMULATIVE;xF.DEFAULT_AGGREGATION_TEMPORALITY_SELECTOR=vGt});var gNe=At(Qce=>{"use strict";Object.defineProperty(Qce,"__esModule",{value:!0});Qce.MetricReader=void 0;var Eat=(jc(),tl(Gc)),Kce=jC(),xat=dNe(),mNe=class{constructor(c){var f,v,x;this._shutdown=!1,this._aggregationSelector=(f=c?.aggregationSelector)!==null&&f!==void 0?f:xat.DEFAULT_AGGREGATION_SELECTOR,this._aggregationTemporalitySelector=(v=c?.aggregationTemporalitySelector)!==null&&v!==void 0?v:xat.DEFAULT_AGGREGATION_TEMPORALITY_SELECTOR,this._metricProducers=(x=c?.metricProducers)!==null&&x!==void 0?x:[]}setMetricProducer(c){if(this._sdkMetricProducer)throw new Error("MetricReader can not be bound to a MeterProvider again.");this._sdkMetricProducer=c,this.onInitialized()}selectAggregation(c){return this._aggregationSelector(c)}selectAggregationTemporality(c){return this._aggregationTemporalitySelector(c)}onInitialized(){}async collect(c){if(this._sdkMetricProducer===void 0)throw new Error("MetricReader is not bound to a MetricProducer");if(this._shutdown)throw new Error("MetricReader is shutdown");let[f,...v]=await Promise.all([this._sdkMetricProducer.collect({timeoutMillis:c?.timeoutMillis}),...this._metricProducers.map(ee=>ee.collect({timeoutMillis:c?.timeoutMillis}))]),x=f.errors.concat((0,Kce.FlatMap)(v,ee=>ee.errors)),w=f.resourceMetrics.resource,F=f.resourceMetrics.scopeMetrics.concat((0,Kce.FlatMap)(v,ee=>ee.resourceMetrics.scopeMetrics));return{resourceMetrics:{resource:w,scopeMetrics:F},errors:x}}async shutdown(c){if(this._shutdown){Eat.diag.error("Cannot call shutdown twice.");return}c?.timeoutMillis==null?await this.onShutdown():await(0,Kce.callWithTimeout)(this.onShutdown(),c.timeoutMillis),this._shutdown=!0}async forceFlush(c){if(this._shutdown){Eat.diag.warn("Cannot forceFlush on already shutdown MetricReader.");return}if(c?.timeoutMillis==null){await this.onForceFlush();return}await(0,Kce.callWithTimeout)(this.onForceFlush(),c.timeoutMillis)}};Qce.MetricReader=mNe});var kat=At(ele=>{"use strict";Object.defineProperty(ele,"__esModule",{value:!0});ele.PeriodicExportingMetricReader=void 0;var Cat=(jc(),tl(Gc)),Zce=p0(),SGt=gNe(),Aat=jC(),TGt=(jc(),tl(Gc)),hNe=class extends SGt.MetricReader{constructor(c){var f,v,x,w;if(super({aggregationSelector:(f=c.exporter.selectAggregation)===null||f===void 0?void 0:f.bind(c.exporter),aggregationTemporalitySelector:(v=c.exporter.selectAggregationTemporality)===null||v===void 0?void 0:v.bind(c.exporter),metricProducers:c.metricProducers}),c.exportIntervalMillis!==void 0&&c.exportIntervalMillis<=0)throw Error("exportIntervalMillis must be greater than 0");if(c.exportTimeoutMillis!==void 0&&c.exportTimeoutMillis<=0)throw Error("exportTimeoutMillis must be greater than 0");if(c.exportTimeoutMillis!==void 0&&c.exportIntervalMillis!==void 0&&c.exportIntervalMillis<c.exportTimeoutMillis)throw Error("exportIntervalMillis must be greater than or equal to exportTimeoutMillis");this._exportInterval=(x=c.exportIntervalMillis)!==null&&x!==void 0?x:6e4,this._exportTimeout=(w=c.exportTimeoutMillis)!==null&&w!==void 0?w:3e4,this._exporter=c.exporter}async _runOnce(){try{await(0,Aat.callWithTimeout)(this._doRun(),this._exportTimeout)}catch(c){if(c instanceof Aat.TimeoutError){Cat.diag.error("Export took longer than %s milliseconds and timed out.",this._exportTimeout);return}(0,Zce.globalErrorHandler)(c)}}async _doRun(){var c,f;let{resourceMetrics:v,errors:x}=await this.collect({timeoutMillis:this._exportTimeout});x.length>0&&Cat.diag.error("PeriodicExportingMetricReader: metrics collection errors",...x);let w=async()=>{let F=await Zce.internal._export(this._exporter,v);if(F.code!==Zce.ExportResultCode.SUCCESS)throw new Error(`PeriodicExportingMetricReader: metrics export failed (error ${F.error})`)};v.resource.asyncAttributesPending?(f=(c=v.resource).waitForAsyncAttributes)===null||f===void 0||f.call(c).then(w,F=>TGt.diag.debug("Error while resolving async portion of resource: ",F)):await w()}onInitialized(){this._interval=setInterval(()=>{this._runOnce()},this._exportInterval),(0,Zce.unrefTimer)(this._interval)}async onForceFlush(){await this._runOnce(),await this._exporter.forceFlush()}async onShutdown(){this._interval&&clearInterval(this._interval),await this._exporter.shutdown()}};ele.PeriodicExportingMetricReader=hNe});var Nat=At(tle=>{"use strict";Object.defineProperty(tle,"__esModule",{value:!0});tle.InMemoryMetricExporter=void 0;var Pat=p0(),yNe=class{constructor(c){this._shutdown=!1,this._metrics=[],this._aggregationTemporality=c}export(c,f){if(this._shutdown){setTimeout(()=>f({code:Pat.ExportResultCode.FAILED}),0);return}this._metrics.push(c),setTimeout(()=>f({code:Pat.ExportResultCode.SUCCESS}),0)}getMetrics(){return this._metrics}forceFlush(){return Promise.resolve()}reset(){this._metrics=[]}selectAggregationTemporality(c){return this._aggregationTemporality}shutdown(){return this._shutdown=!0,Promise.resolve()}};tle.InMemoryMetricExporter=yNe});var Iat=At(rle=>{"use strict";Object.defineProperty(rle,"__esModule",{value:!0});rle.ConsoleMetricExporter=void 0;var Dat=p0(),bGt=dNe(),vNe=class u{constructor(c){var f;this._shutdown=!1,this._temporalitySelector=(f=c?.temporalitySelector)!==null&&f!==void 0?f:bGt.DEFAULT_AGGREGATION_TEMPORALITY_SELECTOR}export(c,f){if(this._shutdown){setImmediate(f,{code:Dat.ExportResultCode.FAILED});return}return u._sendMetrics(c,f)}forceFlush(){return Promise.resolve()}selectAggregationTemporality(c){return this._temporalitySelector(c)}shutdown(){return this._shutdown=!0,Promise.resolve()}static _sendMetrics(c,f){for(let v of c.scopeMetrics)for(let x of v.metrics)console.dir({descriptor:x.descriptor,dataPointType:x.dataPointType,dataPoints:x.dataPoints},{depth:null});f({code:Dat.ExportResultCode.SUCCESS})}};rle.ConsoleMetricExporter=vNe});var wat=At(nle=>{"use strict";Object.defineProperty(nle,"__esModule",{value:!0});nle.defaultServiceName=void 0;function EGt(){return`unknown_service:${process.argv0}`}nle.defaultServiceName=EGt});var Oat=At(ile=>{"use strict";Object.defineProperty(ile,"__esModule",{value:!0});ile.defaultServiceName=void 0;var xGt=wat();Object.defineProperty(ile,"defaultServiceName",{enumerable:!0,get:function(){return xGt.defaultServiceName}})});var SNe=At(sle=>{"use strict";Object.defineProperty(sle,"__esModule",{value:!0});sle.defaultServiceName=void 0;var CGt=Oat();Object.defineProperty(sle,"defaultServiceName",{enumerable:!0,get:function(){return CGt.defaultServiceName}})});var vP=At(ale=>{"use strict";Object.defineProperty(ale,"__esModule",{value:!0});ale.Resource=void 0;var Rat=(jc(),tl(Gc)),G4=FC(),TNe=p0(),AGt=SNe(),nW=class u{constructor(c,f){var v;this._attributes=c,this.asyncAttributesPending=f!=null,this._syncAttributes=(v=this._attributes)!==null&&v!==void 0?v:{},this._asyncAttributesPromise=f?.then(x=>(this._attributes=Object.assign({},this._attributes,x),this.asyncAttributesPending=!1,x),x=>(Rat.diag.debug("a resource's async attributes promise rejected: %s",x),this.asyncAttributesPending=!1,{}))}static empty(){return u.EMPTY}static default(){return new u({[G4.SEMRESATTRS_SERVICE_NAME]:(0,AGt.defaultServiceName)(),[G4.SEMRESATTRS_TELEMETRY_SDK_LANGUAGE]:TNe.SDK_INFO[G4.SEMRESATTRS_TELEMETRY_SDK_LANGUAGE],[G4.SEMRESATTRS_TELEMETRY_SDK_NAME]:TNe.SDK_INFO[G4.SEMRESATTRS_TELEMETRY_SDK_NAME],[G4.SEMRESATTRS_TELEMETRY_SDK_VERSION]:TNe.SDK_INFO[G4.SEMRESATTRS_TELEMETRY_SDK_VERSION]})}get attributes(){var c;return this.asyncAttributesPending&&Rat.diag.error("Accessing resource attributes before async attributes settled"),(c=this._attributes)!==null&&c!==void 0?c:{}}async waitForAsyncAttributes(){this.asyncAttributesPending&&await this._asyncAttributesPromise}merge(c){var f;if(!c)return this;let v=Object.assign(Object.assign({},this._syncAttributes),(f=c._syncAttributes)!==null&&f!==void 0?f:c.attributes);if(!this._asyncAttributesPromise&&!c._asyncAttributesPromise)return new u(v);let x=Promise.all([this._asyncAttributesPromise,c._asyncAttributesPromise]).then(([w,F])=>{var ee;return Object.assign(Object.assign(Object.assign(Object.assign({},this._syncAttributes),w),(ee=c._syncAttributes)!==null&&ee!==void 0?ee:c.attributes),F)});return new u(v,x)}};ale.Resource=nW;nW.EMPTY=new nW({})});var bNe=At(CF=>{"use strict";Object.defineProperty(CF,"__esModule",{value:!0});CF.normalizeType=CF.normalizeArch=void 0;var kGt=u=>{switch(u){case"arm":return"arm32";case"ppc":return"ppc32";case"x64":return"amd64";default:return u}};CF.normalizeArch=kGt;var PGt=u=>{switch(u){case"sunos":return"solaris";case"win32":return"windows";default:return u}};CF.normalizeType=PGt});var cle=At(ole=>{"use strict";Object.defineProperty(ole,"__esModule",{value:!0});ole.execAsync=void 0;var NGt=Bu("child_process"),DGt=Bu("util");ole.execAsync=DGt.promisify(NGt.exec)});var Mat=At(lle=>{"use strict";Object.defineProperty(lle,"__esModule",{value:!0});lle.getMachineId=void 0;var IGt=cle(),wGt=(jc(),tl(Gc));async function OGt(){try{let c=(await(0,IGt.execAsync)('ioreg -rd1 -c "IOPlatformExpertDevice"')).stdout.split(`
`).find(v=>v.includes("IOPlatformUUID"));if(!c)return"";let f=c.split('" = "');if(f.length===2)return f[1].slice(0,-1)}catch(u){wGt.diag.debug(`error reading machine id: ${u}`)}return""}lle.getMachineId=OGt});var Lat=At(ule=>{"use strict";Object.defineProperty(ule,"__esModule",{value:!0});ule.getMachineId=void 0;var RGt=Bu("fs"),MGt=(jc(),tl(Gc));async function LGt(){let u=["/etc/machine-id","/var/lib/dbus/machine-id"];for(let c of u)try{return(await RGt.promises.readFile(c,{encoding:"utf8"})).trim()}catch(f){MGt.diag.debug(`error reading machine id: ${f}`)}return""}ule.getMachineId=LGt});var jat=At(_le=>{"use strict";Object.defineProperty(_le,"__esModule",{value:!0});_le.getMachineId=void 0;var FGt=Bu("fs"),jGt=cle(),Fat=(jc(),tl(Gc));async function BGt(){try{return(await FGt.promises.readFile("/etc/hostid",{encoding:"utf8"})).trim()}catch(u){Fat.diag.debug(`error reading machine id: ${u}`)}try{return(await(0,jGt.execAsync)("kenv -q smbios.system.uuid")).stdout.trim()}catch(u){Fat.diag.debug(`error reading machine id: ${u}`)}return""}_le.getMachineId=BGt});var Uat=At(fle=>{"use strict";Object.defineProperty(fle,"__esModule",{value:!0});fle.getMachineId=void 0;var Bat=Bu("process"),UGt=cle(),VGt=(jc(),tl(Gc));async function JGt(){let u="QUERY HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Cryptography /v MachineGuid",c="%windir%\\System32\\REG.exe";Bat.arch==="ia32"&&"PROCESSOR_ARCHITEW6432"in Bat.env&&(c="%windir%\\sysnative\\cmd.exe /c "+c);try{let v=(await(0,UGt.execAsync)(`${c} ${u}`)).stdout.split("REG_SZ");if(v.length===2)return v[1].trim()}catch(f){VGt.diag.debug(`error reading machine id: ${f}`)}return""}fle.getMachineId=JGt});var Vat=At(ple=>{"use strict";Object.defineProperty(ple,"__esModule",{value:!0});ple.getMachineId=void 0;var qGt=(jc(),tl(Gc));async function zGt(){return qGt.diag.debug("could not read machine-id: unsupported platform"),""}ple.getMachineId=zGt});var Jat=At(SP=>{"use strict";Object.defineProperty(SP,"__esModule",{value:!0});SP.getMachineId=void 0;var $Gt=Bu("process"),AF;SP.getMachineId=AF;switch($Gt.platform){case"darwin":SP.getMachineId=AF=Mat().getMachineId;break;case"linux":SP.getMachineId=AF=Lat().getMachineId;break;case"freebsd":SP.getMachineId=AF=jat().getMachineId;break;case"win32":SP.getMachineId=AF=Uat().getMachineId;break;default:SP.getMachineId=AF=Vat().getMachineId}});var CNe=At(dle=>{"use strict";Object.defineProperty(dle,"__esModule",{value:!0});dle.hostDetectorSync=void 0;var ENe=FC(),WGt=vP(),qat=Bu("os"),GGt=bNe(),HGt=Jat(),xNe=class{detect(c){let f={[ENe.SemanticResourceAttributes.HOST_NAME]:(0,qat.hostname)(),[ENe.SemanticResourceAttributes.HOST_ARCH]:(0,GGt.normalizeArch)((0,qat.arch)())};return new WGt.Resource(f,this._getAsyncAttributes())}_getAsyncAttributes(){return(0,HGt.getMachineId)().then(c=>{let f={};return c&&(f[ENe.SemanticResourceAttributes.HOST_ID]=c),f})}};dle.hostDetectorSync=new xNe});var zat=At(mle=>{"use strict";Object.defineProperty(mle,"__esModule",{value:!0});mle.hostDetector=void 0;var YGt=CNe(),ANe=class{detect(c){return Promise.resolve(YGt.hostDetectorSync.detect(c))}};mle.hostDetector=new ANe});var PNe=At(gle=>{"use strict";Object.defineProperty(gle,"__esModule",{value:!0});gle.osDetectorSync=void 0;var $at=FC(),XGt=vP(),Wat=Bu("os"),KGt=bNe(),kNe=class{detect(c){let f={[$at.SemanticResourceAttributes.OS_TYPE]:(0,KGt.normalizeType)((0,Wat.platform)()),[$at.SemanticResourceAttributes.OS_VERSION]:(0,Wat.release)()};return new XGt.Resource(f)}};gle.osDetectorSync=new kNe});var Gat=At(hle=>{"use strict";Object.defineProperty(hle,"__esModule",{value:!0});hle.osDetector=void 0;var QGt=PNe(),NNe=class{detect(c){return Promise.resolve(QGt.osDetectorSync.detect(c))}};hle.osDetector=new NNe});var INe=At(yle=>{"use strict";Object.defineProperty(yle,"__esModule",{value:!0});yle.processDetectorSync=void 0;var ZGt=(jc(),tl(Gc)),TP=FC(),eHt=vP(),tHt=Bu("os"),DNe=class{detect(c){let f={[TP.SemanticResourceAttributes.PROCESS_PID]:process.pid,[TP.SemanticResourceAttributes.PROCESS_EXECUTABLE_NAME]:process.title,[TP.SemanticResourceAttributes.PROCESS_EXECUTABLE_PATH]:process.execPath,[TP.SemanticResourceAttributes.PROCESS_COMMAND_ARGS]:[process.argv[0],...process.execArgv,...process.argv.slice(1)],[TP.SemanticResourceAttributes.PROCESS_RUNTIME_VERSION]:process.versions.node,[TP.SemanticResourceAttributes.PROCESS_RUNTIME_NAME]:"nodejs",[TP.SemanticResourceAttributes.PROCESS_RUNTIME_DESCRIPTION]:"Node.js"};process.argv.length>1&&(f[TP.SemanticResourceAttributes.PROCESS_COMMAND]=process.argv[1]);try{let v=tHt.userInfo();f[TP.SemanticResourceAttributes.PROCESS_OWNER]=v.username}catch(v){ZGt.diag.debug(`error obtaining process owner: ${v}`)}return new eHt.Resource(f)}};yle.processDetectorSync=new DNe});var Hat=At(vle=>{"use strict";Object.defineProperty(vle,"__esModule",{value:!0});vle.processDetector=void 0;var rHt=INe(),wNe=class{detect(c){return Promise.resolve(rHt.processDetectorSync.detect(c))}};vle.processDetector=new wNe});var Yat=At(Sle=>{"use strict";Object.defineProperty(Sle,"__esModule",{value:!0});Sle.serviceInstanceIdDetectorSync=void 0;var nHt=FC(),iHt=vP(),sHt=Bu("crypto"),ONe=class{detect(c){let f={[nHt.SEMRESATTRS_SERVICE_INSTANCE_ID]:(0,sHt.randomUUID)()};return new iHt.Resource(f)}};Sle.serviceInstanceIdDetectorSync=new ONe});var Xat=At(sy=>{"use strict";Object.defineProperty(sy,"__esModule",{value:!0});sy.serviceInstanceIdDetectorSync=sy.processDetectorSync=sy.processDetector=sy.osDetectorSync=sy.osDetector=sy.hostDetectorSync=sy.hostDetector=void 0;var aHt=zat();Object.defineProperty(sy,"hostDetector",{enumerable:!0,get:function(){return aHt.hostDetector}});var oHt=CNe();Object.defineProperty(sy,"hostDetectorSync",{enumerable:!0,get:function(){return oHt.hostDetectorSync}});var cHt=Gat();Object.defineProperty(sy,"osDetector",{enumerable:!0,get:function(){return cHt.osDetector}});var lHt=PNe();Object.defineProperty(sy,"osDetectorSync",{enumerable:!0,get:function(){return lHt.osDetectorSync}});var uHt=Hat();Object.defineProperty(sy,"processDetector",{enumerable:!0,get:function(){return uHt.processDetector}});var _Ht=INe();Object.defineProperty(sy,"processDetectorSync",{enumerable:!0,get:function(){return _Ht.processDetectorSync}});var fHt=Yat();Object.defineProperty(sy,"serviceInstanceIdDetectorSync",{enumerable:!0,get:function(){return fHt.serviceInstanceIdDetectorSync}})});var Kat=At(ay=>{"use strict";Object.defineProperty(ay,"__esModule",{value:!0});ay.serviceInstanceIdDetectorSync=ay.processDetectorSync=ay.processDetector=ay.osDetectorSync=ay.osDetector=ay.hostDetectorSync=ay.hostDetector=void 0;var H4=Xat();Object.defineProperty(ay,"hostDetector",{enumerable:!0,get:function(){return H4.hostDetector}});Object.defineProperty(ay,"hostDetectorSync",{enumerable:!0,get:function(){return H4.hostDetectorSync}});Object.defineProperty(ay,"osDetector",{enumerable:!0,get:function(){return H4.osDetector}});Object.defineProperty(ay,"osDetectorSync",{enumerable:!0,get:function(){return H4.osDetectorSync}});Object.defineProperty(ay,"processDetector",{enumerable:!0,get:function(){return H4.processDetector}});Object.defineProperty(ay,"processDetectorSync",{enumerable:!0,get:function(){return H4.processDetectorSync}});Object.defineProperty(ay,"serviceInstanceIdDetectorSync",{enumerable:!0,get:function(){return H4.serviceInstanceIdDetectorSync}})});var LNe=At(ble=>{"use strict";Object.defineProperty(ble,"__esModule",{value:!0});ble.browserDetectorSync=void 0;var Tle=FC(),pHt=(jc(),tl(Gc)),RNe=vP(),MNe=class{detect(c){var f,v,x;if(!(typeof navigator<"u"&&((v=(f=global.process)===null||f===void 0?void 0:f.versions)===null||v===void 0?void 0:v.node)===void 0&&((x=global.Bun)===null||x===void 0?void 0:x.version)===void 0))return RNe.Resource.empty();let F={[Tle.SemanticResourceAttributes.PROCESS_RUNTIME_NAME]:"browser",[Tle.SemanticResourceAttributes.PROCESS_RUNTIME_DESCRIPTION]:"Web Browser",[Tle.SemanticResourceAttributes.PROCESS_RUNTIME_VERSION]:navigator.userAgent};return this._getResourceAttributes(F,c)}_getResourceAttributes(c,f){return c[Tle.SemanticResourceAttributes.PROCESS_RUNTIME_VERSION]===""?(pHt.diag.debug("BrowserDetector failed: Unable to find required browser resources. "),RNe.Resource.empty()):new RNe.Resource(Object.assign({},c))}};ble.browserDetectorSync=new MNe});var Qat=At(Ele=>{"use strict";Object.defineProperty(Ele,"__esModule",{value:!0});Ele.browserDetector=void 0;var dHt=LNe(),FNe=class{detect(c){return Promise.resolve(dHt.browserDetectorSync.detect(c))}};Ele.browserDetector=new FNe});var BNe=At(xle=>{"use strict";Object.defineProperty(xle,"__esModule",{value:!0});xle.envDetectorSync=void 0;var mHt=(jc(),tl(Gc)),gHt=p0(),hHt=FC(),yHt=vP(),jNe=class{constructor(){this._MAX_LENGTH=255,this._COMMA_SEPARATOR=",",this._LABEL_KEY_VALUE_SPLITTER="=",this._ERROR_MESSAGE_INVALID_CHARS="should be a ASCII string with a length greater than 0 and not exceed "+this._MAX_LENGTH+" characters.",this._ERROR_MESSAGE_INVALID_VALUE="should be a ASCII string with a length not exceed "+this._MAX_LENGTH+" characters."}detect(c){let f={},v=(0,gHt.getEnv)(),x=v.OTEL_RESOURCE_ATTRIBUTES,w=v.OTEL_SERVICE_NAME;if(x)try{let F=this._parseResourceAttributes(x);Object.assign(f,F)}catch(F){mHt.diag.debug(`EnvDetector failed: ${F.message}`)}return w&&(f[hHt.SEMRESATTRS_SERVICE_NAME]=w),new yHt.Resource(f)}_parseResourceAttributes(c){if(!c)return{};let f={},v=c.split(this._COMMA_SEPARATOR,-1);for(let x of v){let w=x.split(this._LABEL_KEY_VALUE_SPLITTER,-1);if(w.length!==2)continue;let[F,ee]=w;if(F=F.trim(),ee=ee.trim().split(/^"|"$/).join(""),!this._isValidAndNotEmpty(F))throw new Error(`Attribute key ${this._ERROR_MESSAGE_INVALID_CHARS}`);if(!this._isValid(ee))throw new Error(`Attribute value ${this._ERROR_MESSAGE_INVALID_VALUE}`);f[F]=decodeURIComponent(ee)}return f}_isValid(c){return c.length<=this._MAX_LENGTH&&this._isBaggageOctetString(c)}_isBaggageOctetString(c){for(let f=0;f<c.length;f++){let v=c.charCodeAt(f);if(v<33||v===44||v===59||v===92||v>126)return!1}return!0}_isValidAndNotEmpty(c){return c.length>0&&this._isValid(c)}};xle.envDetectorSync=new jNe});var Zat=At(Cle=>{"use strict";Object.defineProperty(Cle,"__esModule",{value:!0});Cle.envDetector=void 0;var vHt=BNe(),UNe=class{detect(c){return Promise.resolve(vHt.envDetectorSync.detect(c))}};Cle.envDetector=new UNe});var eot=At(Qp=>{"use strict";Object.defineProperty(Qp,"__esModule",{value:!0});Qp.envDetectorSync=Qp.browserDetectorSync=Qp.envDetector=Qp.browserDetector=Qp.serviceInstanceIdDetectorSync=Qp.processDetectorSync=Qp.processDetector=Qp.osDetectorSync=Qp.osDetector=Qp.hostDetectorSync=Qp.hostDetector=void 0;var Y4=Kat();Object.defineProperty(Qp,"hostDetector",{enumerable:!0,get:function(){return Y4.hostDetector}});Object.defineProperty(Qp,"hostDetectorSync",{enumerable:!0,get:function(){return Y4.hostDetectorSync}});Object.defineProperty(Qp,"osDetector",{enumerable:!0,get:function(){return Y4.osDetector}});Object.defineProperty(Qp,"osDetectorSync",{enumerable:!0,get:function(){return Y4.osDetectorSync}});Object.defineProperty(Qp,"processDetector",{enumerable:!0,get:function(){return Y4.processDetector}});Object.defineProperty(Qp,"processDetectorSync",{enumerable:!0,get:function(){return Y4.processDetectorSync}});Object.defineProperty(Qp,"serviceInstanceIdDetectorSync",{enumerable:!0,get:function(){return Y4.serviceInstanceIdDetectorSync}});var SHt=Qat();Object.defineProperty(Qp,"browserDetector",{enumerable:!0,get:function(){return SHt.browserDetector}});var THt=Zat();Object.defineProperty(Qp,"envDetector",{enumerable:!0,get:function(){return THt.envDetector}});var bHt=LNe();Object.defineProperty(Qp,"browserDetectorSync",{enumerable:!0,get:function(){return bHt.browserDetectorSync}});var EHt=BNe();Object.defineProperty(Qp,"envDetectorSync",{enumerable:!0,get:function(){return EHt.envDetectorSync}})});var tot=At(Ale=>{"use strict";Object.defineProperty(Ale,"__esModule",{value:!0});Ale.isPromiseLike=void 0;var xHt=u=>u!==null&&typeof u=="object"&&typeof u.then=="function";Ale.isPromiseLike=xHt});var not=At(PF=>{"use strict";Object.defineProperty(PF,"__esModule",{value:!0});PF.detectResourcesSync=PF.detectResources=void 0;var iW=vP(),kF=(jc(),tl(Gc)),CHt=tot(),AHt=async(u={})=>{let c=await Promise.all((u.detectors||[]).map(async f=>{try{let v=await f.detect(u);return kF.diag.debug(`${f.constructor.name} found resource.`,v),v}catch(v){return kF.diag.debug(`${f.constructor.name} failed: ${v.message}`),iW.Resource.empty()}}));return rot(c),c.reduce((f,v)=>f.merge(v),iW.Resource.empty())};PF.detectResources=AHt;var kHt=(u={})=>{var c;let f=((c=u.detectors)!==null&&c!==void 0?c:[]).map(x=>{try{let w=x.detect(u),F;if((0,CHt.isPromiseLike)(w)){let ee=async()=>(await w).attributes;F=new iW.Resource({},ee())}else F=w;return F.waitForAsyncAttributes?F.waitForAsyncAttributes().then(()=>kF.diag.debug(`${x.constructor.name} found resource.`,F)):kF.diag.debug(`${x.constructor.name} found resource.`,F),F}catch(w){return kF.diag.error(`${x.constructor.name} failed: ${w.message}`),iW.Resource.empty()}}),v=f.reduce((x,w)=>x.merge(w),iW.Resource.empty());return v.waitForAsyncAttributes&&v.waitForAsyncAttributes().then(()=>{rot(f)}),v};PF.detectResourcesSync=kHt;var rot=u=>{u.forEach(c=>{if(Object.keys(c.attributes).length>0){let f=JSON.stringify(c.attributes,null,4);kF.diag.verbose(f)}})}});var VNe=At(p_=>{"use strict";Object.defineProperty(p_,"__esModule",{value:!0});p_.detectResources=p_.detectResourcesSync=p_.serviceInstanceIdDetectorSync=p_.processDetectorSync=p_.processDetector=p_.osDetectorSync=p_.osDetector=p_.hostDetectorSync=p_.hostDetector=p_.envDetectorSync=p_.envDetector=p_.browserDetectorSync=p_.browserDetector=p_.defaultServiceName=p_.Resource=void 0;var PHt=vP();Object.defineProperty(p_,"Resource",{enumerable:!0,get:function(){return PHt.Resource}});var NHt=SNe();Object.defineProperty(p_,"defaultServiceName",{enumerable:!0,get:function(){return NHt.defaultServiceName}});var g2=eot();Object.defineProperty(p_,"browserDetector",{enumerable:!0,get:function(){return g2.browserDetector}});Object.defineProperty(p_,"browserDetectorSync",{enumerable:!0,get:function(){return g2.browserDetectorSync}});Object.defineProperty(p_,"envDetector",{enumerable:!0,get:function(){return g2.envDetector}});Object.defineProperty(p_,"envDetectorSync",{enumerable:!0,get:function(){return g2.envDetectorSync}});Object.defineProperty(p_,"hostDetector",{enumerable:!0,get:function(){return g2.hostDetector}});Object.defineProperty(p_,"hostDetectorSync",{enumerable:!0,get:function(){return g2.hostDetectorSync}});Object.defineProperty(p_,"osDetector",{enumerable:!0,get:function(){return g2.osDetector}});Object.defineProperty(p_,"osDetectorSync",{enumerable:!0,get:function(){return g2.osDetectorSync}});Object.defineProperty(p_,"processDetector",{enumerable:!0,get:function(){return g2.processDetector}});Object.defineProperty(p_,"processDetectorSync",{enumerable:!0,get:function(){return g2.processDetectorSync}});Object.defineProperty(p_,"serviceInstanceIdDetectorSync",{enumerable:!0,get:function(){return g2.serviceInstanceIdDetectorSync}});var iot=not();Object.defineProperty(p_,"detectResourcesSync",{enumerable:!0,get:function(){return iot.detectResourcesSync}});Object.defineProperty(p_,"detectResources",{enumerable:!0,get:function(){return iot.detectResources}})});var sot=At(kle=>{"use strict";Object.defineProperty(kle,"__esModule",{value:!0});kle.ViewRegistry=void 0;var JNe=class{constructor(){this._registeredViews=[]}addView(c){this._registeredViews.push(c)}findViews(c,f){return this._registeredViews.filter(x=>this._matchInstrument(x.instrumentSelector,c)&&this._matchMeter(x.meterSelector,f))}_matchInstrument(c,f){return(c.getType()===void 0||f.type===c.getType())&&c.getNameFilter().match(f.name)&&c.getUnitFilter().match(f.unit)}_matchMeter(c,f){return c.getNameFilter().match(f.name)&&(f.version===void 0||c.getVersionFilter().match(f.version))&&(f.schemaUrl===void 0||c.getSchemaUrlFilter().match(f.schemaUrl))}};kle.ViewRegistry=JNe});var Ple=At(Xd=>{"use strict";Object.defineProperty(Xd,"__esModule",{value:!0});Xd.isObservableInstrument=Xd.ObservableUpDownCounterInstrument=Xd.ObservableGaugeInstrument=Xd.ObservableCounterInstrument=Xd.ObservableInstrument=Xd.HistogramInstrument=Xd.GaugeInstrument=Xd.CounterInstrument=Xd.UpDownCounterInstrument=Xd.SyncInstrument=void 0;var NF=(jc(),tl(Gc)),DHt=p0(),X4=class{constructor(c,f){this._writableMetricStorage=c,this._descriptor=f}_record(c,f={},v=NF.context.active()){if(typeof c!="number"){NF.diag.warn(`non-number value provided to metric ${this._descriptor.name}: ${c}`);return}this._descriptor.valueType===NF.ValueType.INT&&!Number.isInteger(c)&&(NF.diag.warn(`INT value type cannot accept a floating-point value for ${this._descriptor.name}, ignoring the fractional digits.`),c=Math.trunc(c),!Number.isInteger(c))||this._writableMetricStorage.record(c,f,v,(0,DHt.millisToHrTime)(Date.now()))}};Xd.SyncInstrument=X4;var qNe=class extends X4{add(c,f,v){this._record(c,f,v)}};Xd.UpDownCounterInstrument=qNe;var zNe=class extends X4{add(c,f,v){if(c<0){NF.diag.warn(`negative value provided to counter ${this._descriptor.name}: ${c}`);return}this._record(c,f,v)}};Xd.CounterInstrument=zNe;var $Ne=class extends X4{record(c,f,v){this._record(c,f,v)}};Xd.GaugeInstrument=$Ne;var WNe=class extends X4{record(c,f,v){if(c<0){NF.diag.warn(`negative value provided to histogram ${this._descriptor.name}: ${c}`);return}this._record(c,f,v)}};Xd.HistogramInstrument=WNe;var K4=class{constructor(c,f,v){this._observableRegistry=v,this._descriptor=c,this._metricStorages=f}addCallback(c){this._observableRegistry.addCallback(c,this)}removeCallback(c){this._observableRegistry.removeCallback(c,this)}};Xd.ObservableInstrument=K4;var GNe=class extends K4{};Xd.ObservableCounterInstrument=GNe;var HNe=class extends K4{};Xd.ObservableGaugeInstrument=HNe;var YNe=class extends K4{};Xd.ObservableUpDownCounterInstrument=YNe;function IHt(u){return u instanceof K4}Xd.isObservableInstrument=IHt});var aot=At(Nle=>{"use strict";Object.defineProperty(Nle,"__esModule",{value:!0});Nle.Meter=void 0;var pv=yP(),Q4=Ple(),XNe=class{constructor(c){this._meterSharedState=c}createGauge(c,f){let v=(0,pv.createInstrumentDescriptor)(c,pv.InstrumentType.GAUGE,f),x=this._meterSharedState.registerMetricStorage(v);return new Q4.GaugeInstrument(x,v)}createHistogram(c,f){let v=(0,pv.createInstrumentDescriptor)(c,pv.InstrumentType.HISTOGRAM,f),x=this._meterSharedState.registerMetricStorage(v);return new Q4.HistogramInstrument(x,v)}createCounter(c,f){let v=(0,pv.createInstrumentDescriptor)(c,pv.InstrumentType.COUNTER,f),x=this._meterSharedState.registerMetricStorage(v);return new Q4.CounterInstrument(x,v)}createUpDownCounter(c,f){let v=(0,pv.createInstrumentDescriptor)(c,pv.InstrumentType.UP_DOWN_COUNTER,f),x=this._meterSharedState.registerMetricStorage(v);return new Q4.UpDownCounterInstrument(x,v)}createObservableGauge(c,f){let v=(0,pv.createInstrumentDescriptor)(c,pv.InstrumentType.OBSERVABLE_GAUGE,f),x=this._meterSharedState.registerAsyncMetricStorage(v);return new Q4.ObservableGaugeInstrument(v,x,this._meterSharedState.observableRegistry)}createObservableCounter(c,f){let v=(0,pv.createInstrumentDescriptor)(c,pv.InstrumentType.OBSERVABLE_COUNTER,f),x=this._meterSharedState.registerAsyncMetricStorage(v);return new Q4.ObservableCounterInstrument(v,x,this._meterSharedState.observableRegistry)}createObservableUpDownCounter(c,f){let v=(0,pv.createInstrumentDescriptor)(c,pv.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER,f),x=this._meterSharedState.registerAsyncMetricStorage(v);return new Q4.ObservableUpDownCounterInstrument(v,x,this._meterSharedState.observableRegistry)}addBatchObservableCallback(c,f){this._meterSharedState.observableRegistry.addBatchCallback(c,f)}removeBatchObservableCallback(c,f){this._meterSharedState.observableRegistry.removeBatchCallback(c,f)}};Nle.Meter=XNe});var QNe=At(Dle=>{"use strict";Object.defineProperty(Dle,"__esModule",{value:!0});Dle.MetricStorage=void 0;var wHt=yP(),KNe=class{constructor(c){this._instrumentDescriptor=c}getInstrumentDescriptor(){return this._instrumentDescriptor}updateDescription(c){this._instrumentDescriptor=(0,wHt.createInstrumentDescriptor)(this._instrumentDescriptor.name,this._instrumentDescriptor.type,{description:c,valueType:this._instrumentDescriptor.valueType,unit:this._instrumentDescriptor.unit,advice:this._instrumentDescriptor.advice})}};Dle.MetricStorage=KNe});var sW=At(DF=>{"use strict";Object.defineProperty(DF,"__esModule",{value:!0});DF.AttributeHashMap=DF.HashMap=void 0;var OHt=jC(),Ile=class{constructor(c){this._hash=c,this._valueMap=new Map,this._keyMap=new Map}get(c,f){return f??(f=this._hash(c)),this._valueMap.get(f)}getOrDefault(c,f){let v=this._hash(c);if(this._valueMap.has(v))return this._valueMap.get(v);let x=f();return this._keyMap.has(v)||this._keyMap.set(v,c),this._valueMap.set(v,x),x}set(c,f,v){v??(v=this._hash(c)),this._keyMap.has(v)||this._keyMap.set(v,c),this._valueMap.set(v,f)}has(c,f){return f??(f=this._hash(c)),this._valueMap.has(f)}*keys(){let c=this._keyMap.entries(),f=c.next();for(;f.done!==!0;)yield[f.value[1],f.value[0]],f=c.next()}*entries(){let c=this._valueMap.entries(),f=c.next();for(;f.done!==!0;)yield[this._keyMap.get(f.value[0]),f.value[1],f.value[0]],f=c.next()}get size(){return this._valueMap.size}};DF.HashMap=Ile;var ZNe=class extends Ile{constructor(){super(OHt.hashAttributes)}};DF.AttributeHashMap=ZNe});var rDe=At(wle=>{"use strict";Object.defineProperty(wle,"__esModule",{value:!0});wle.DeltaMetricProcessor=void 0;var eDe=sW(),tDe=class{constructor(c){this._aggregator=c,this._activeCollectionStorage=new eDe.AttributeHashMap,this._cumulativeMemoStorage=new eDe.AttributeHashMap}record(c,f,v,x){let w=this._activeCollectionStorage.getOrDefault(f,()=>this._aggregator.createAccumulation(x));w?.record(c)}batchCumulate(c,f){Array.from(c.entries()).forEach(([v,x,w])=>{let F=this._aggregator.createAccumulation(f);F?.record(x);let ee=F;if(this._cumulativeMemoStorage.has(v,w)){let me=this._cumulativeMemoStorage.get(v,w);ee=this._aggregator.diff(me,F)}if(this._activeCollectionStorage.has(v,w)){let me=this._activeCollectionStorage.get(v,w);ee=this._aggregator.merge(me,ee)}this._cumulativeMemoStorage.set(v,F,w),this._activeCollectionStorage.set(v,ee,w)})}collect(){let c=this._activeCollectionStorage;return this._activeCollectionStorage=new eDe.AttributeHashMap,c}};wle.DeltaMetricProcessor=tDe});var iDe=At(Ole=>{"use strict";Object.defineProperty(Ole,"__esModule",{value:!0});Ole.TemporalMetricProcessor=void 0;var RHt=Rce(),MHt=sW(),nDe=class u{constructor(c,f){this._aggregator=c,this._unreportedAccumulations=new Map,this._reportHistory=new Map,f.forEach(v=>{this._unreportedAccumulations.set(v,[])})}buildMetrics(c,f,v,x){this._stashAccumulations(v);let w=this._getMergedUnreportedAccumulations(c),F=w,ee;if(this._reportHistory.has(c)){let de=this._reportHistory.get(c),Te=de.collectionTime;ee=de.aggregationTemporality,ee===RHt.AggregationTemporality.CUMULATIVE?F=u.merge(de.accumulations,w,this._aggregator):F=u.calibrateStartTime(de.accumulations,w,Te)}else ee=c.selectAggregationTemporality(f.type);this._reportHistory.set(c,{accumulations:F,collectionTime:x,aggregationTemporality:ee});let me=LHt(F);if(me.length!==0)return this._aggregator.toMetricData(f,ee,me,x)}_stashAccumulations(c){let f=this._unreportedAccumulations.keys();for(let v of f){let x=this._unreportedAccumulations.get(v);x===void 0&&(x=[],this._unreportedAccumulations.set(v,x)),x.push(c)}}_getMergedUnreportedAccumulations(c){let f=new MHt.AttributeHashMap,v=this._unreportedAccumulations.get(c);if(this._unreportedAccumulations.set(c,[]),v===void 0)return f;for(let x of v)f=u.merge(f,x,this._aggregator);return f}static merge(c,f,v){let x=c,w=f.entries(),F=w.next();for(;F.done!==!0;){let[ee,me,de]=F.value;if(c.has(ee,de)){let Te=c.get(ee,de),ut=v.merge(Te,me);x.set(ee,ut,de)}else x.set(ee,me,de);F=w.next()}return x}static calibrateStartTime(c,f,v){for(let[x,w]of c.keys()){let F=f.get(x,w);F?.setStartTime(v)}return f}};Ole.TemporalMetricProcessor=nDe;function LHt(u){return Array.from(u.entries())}});var oot=At(Rle=>{"use strict";Object.defineProperty(Rle,"__esModule",{value:!0});Rle.AsyncMetricStorage=void 0;var FHt=QNe(),jHt=rDe(),BHt=iDe(),UHt=sW(),sDe=class extends FHt.MetricStorage{constructor(c,f,v,x){super(c),this._attributesProcessor=v,this._deltaMetricStorage=new jHt.DeltaMetricProcessor(f),this._temporalMetricStorage=new BHt.TemporalMetricProcessor(f,x)}record(c,f){let v=new UHt.AttributeHashMap;Array.from(c.entries()).forEach(([x,w])=>{v.set(this._attributesProcessor.process(x),w)}),this._deltaMetricStorage.batchCumulate(v,f)}collect(c,f){let v=this._deltaMetricStorage.collect();return this._temporalMetricStorage.buildMetrics(c,this._instrumentDescriptor,v,f)}};Rle.AsyncMetricStorage=sDe});var fot=At(dv=>{"use strict";Object.defineProperty(dv,"__esModule",{value:!0});dv.getConflictResolutionRecipe=dv.getDescriptionResolutionRecipe=dv.getTypeConflictResolutionRecipe=dv.getUnitConflictResolutionRecipe=dv.getValueTypeConflictResolutionRecipe=dv.getIncompatibilityDetails=void 0;function VHt(u,c){let f="";return u.unit!==c.unit&&(f+=`	- Unit '${u.unit}' does not match '${c.unit}'
`),u.type!==c.type&&(f+=`	- Type '${u.type}' does not match '${c.type}'
`),u.valueType!==c.valueType&&(f+=`	- Value Type '${u.valueType}' does not match '${c.valueType}'
`),u.description!==c.description&&(f+=`	- Description '${u.description}' does not match '${c.description}'
`),f}dv.getIncompatibilityDetails=VHt;function cot(u,c){return`	- use valueType '${u.valueType}' on instrument creation or use an instrument name other than '${c.name}'`}dv.getValueTypeConflictResolutionRecipe=cot;function lot(u,c){return`	- use unit '${u.unit}' on instrument creation or use an instrument name other than '${c.name}'`}dv.getUnitConflictResolutionRecipe=lot;function uot(u,c){let f={name:c.name,type:c.type,unit:c.unit},v=JSON.stringify(f);return`	- create a new view with a name other than '${u.name}' and InstrumentSelector '${v}'`}dv.getTypeConflictResolutionRecipe=uot;function _ot(u,c){let f={name:c.name,type:c.type,unit:c.unit},v=JSON.stringify(f);return`	- create a new view with a name other than '${u.name}' and InstrumentSelector '${v}'
    	- OR - create a new view with the name ${u.name} and description '${u.description}' and InstrumentSelector ${v}
    	- OR - create a new view with the name ${c.name} and description '${u.description}' and InstrumentSelector ${v}`}dv.getDescriptionResolutionRecipe=_ot;function JHt(u,c){return u.valueType!==c.valueType?cot(u,c):u.unit!==c.unit?lot(u,c):u.type!==c.type?uot(u,c):u.description!==c.description?_ot(u,c):""}dv.getConflictResolutionRecipe=JHt});var dot=At(Lle=>{"use strict";Object.defineProperty(Lle,"__esModule",{value:!0});Lle.MetricStorageRegistry=void 0;var qHt=yP(),pot=(jc(),tl(Gc)),Mle=fot(),aDe=class u{constructor(){this._sharedRegistry=new Map,this._perCollectorRegistry=new Map}static create(){return new u}getStorages(c){let f=[];for(let x of this._sharedRegistry.values())f=f.concat(x);let v=this._perCollectorRegistry.get(c);if(v!=null)for(let x of v.values())f=f.concat(x);return f}register(c){this._registerStorage(c,this._sharedRegistry)}registerForCollector(c,f){let v=this._perCollectorRegistry.get(c);v==null&&(v=new Map,this._perCollectorRegistry.set(c,v)),this._registerStorage(f,v)}findOrUpdateCompatibleStorage(c){let f=this._sharedRegistry.get(c.name);return f===void 0?null:this._findOrUpdateCompatibleStorage(c,f)}findOrUpdateCompatibleCollectorStorage(c,f){let v=this._perCollectorRegistry.get(c);if(v===void 0)return null;let x=v.get(f.name);return x===void 0?null:this._findOrUpdateCompatibleStorage(f,x)}_registerStorage(c,f){let v=c.getInstrumentDescriptor(),x=f.get(v.name);if(x===void 0){f.set(v.name,[c]);return}x.push(c)}_findOrUpdateCompatibleStorage(c,f){let v=null;for(let x of f){let w=x.getInstrumentDescriptor();(0,qHt.isDescriptorCompatibleWith)(w,c)?(w.description!==c.description&&(c.description.length>w.description.length&&x.updateDescription(c.description),pot.diag.warn("A view or instrument with the name ",c.name,` has already been registered, but has a different description and is incompatible with another registered view.
`,`Details:
`,(0,Mle.getIncompatibilityDetails)(w,c),`The longer description will be used.
To resolve the conflict:`,(0,Mle.getConflictResolutionRecipe)(w,c))),v=x):pot.diag.warn("A view or instrument with the name ",c.name,` has already been registered and is incompatible with another registered view.
`,`Details:
`,(0,Mle.getIncompatibilityDetails)(w,c),`To resolve the conflict:
`,(0,Mle.getConflictResolutionRecipe)(w,c))}return v}};Lle.MetricStorageRegistry=aDe});var mot=At(Fle=>{"use strict";Object.defineProperty(Fle,"__esModule",{value:!0});Fle.MultiMetricStorage=void 0;var oDe=class{constructor(c){this._backingStorages=c}record(c,f,v,x){this._backingStorages.forEach(w=>{w.record(c,f,v,x)})}};Fle.MultiMetricStorage=oDe});var hot=At(wF=>{"use strict";Object.defineProperty(wF,"__esModule",{value:!0});wF.BatchObservableResultImpl=wF.ObservableResultImpl=void 0;var IF=(jc(),tl(Gc)),got=sW(),zHt=Ple(),cDe=class{constructor(c,f){this._instrumentName=c,this._valueType=f,this._buffer=new got.AttributeHashMap}observe(c,f={}){if(typeof c!="number"){IF.diag.warn(`non-number value provided to metric ${this._instrumentName}: ${c}`);return}this._valueType===IF.ValueType.INT&&!Number.isInteger(c)&&(IF.diag.warn(`INT value type cannot accept a floating-point value for ${this._instrumentName}, ignoring the fractional digits.`),c=Math.trunc(c),!Number.isInteger(c))||this._buffer.set(f,c)}};wF.ObservableResultImpl=cDe;var lDe=class{constructor(){this._buffer=new Map}observe(c,f,v={}){if(!(0,zHt.isObservableInstrument)(c))return;let x=this._buffer.get(c);if(x==null&&(x=new got.AttributeHashMap,this._buffer.set(c,x)),typeof f!="number"){IF.diag.warn(`non-number value provided to metric ${c._descriptor.name}: ${f}`);return}c._descriptor.valueType===IF.ValueType.INT&&!Number.isInteger(f)&&(IF.diag.warn(`INT value type cannot accept a floating-point value for ${c._descriptor.name}, ignoring the fractional digits.`),f=Math.trunc(f),!Number.isInteger(f))||x.set(v,f)}};wF.BatchObservableResultImpl=lDe});var Sot=At(jle=>{"use strict";Object.defineProperty(jle,"__esModule",{value:!0});jle.ObservableRegistry=void 0;var $Ht=(jc(),tl(Gc)),yot=Ple(),vot=hot(),aW=jC(),uDe=class{constructor(){this._callbacks=[],this._batchCallbacks=[]}addCallback(c,f){this._findCallback(c,f)>=0||this._callbacks.push({callback:c,instrument:f})}removeCallback(c,f){let v=this._findCallback(c,f);v<0||this._callbacks.splice(v,1)}addBatchCallback(c,f){let v=new Set(f.filter(yot.isObservableInstrument));if(v.size===0){$Ht.diag.error("BatchObservableCallback is not associated with valid instruments",f);return}this._findBatchCallback(c,v)>=0||this._batchCallbacks.push({callback:c,instruments:v})}removeBatchCallback(c,f){let v=new Set(f.filter(yot.isObservableInstrument)),x=this._findBatchCallback(c,v);x<0||this._batchCallbacks.splice(x,1)}async observe(c,f){let v=this._observeCallbacks(c,f),x=this._observeBatchCallbacks(c,f);return(await(0,aW.PromiseAllSettled)([...v,...x])).filter(aW.isPromiseAllSettledRejectionResult).map(ee=>ee.reason)}_observeCallbacks(c,f){return this._callbacks.map(async({callback:v,instrument:x})=>{let w=new vot.ObservableResultImpl(x._descriptor.name,x._descriptor.valueType),F=Promise.resolve(v(w));f!=null&&(F=(0,aW.callWithTimeout)(F,f)),await F,x._metricStorages.forEach(ee=>{ee.record(w._buffer,c)})})}_observeBatchCallbacks(c,f){return this._batchCallbacks.map(async({callback:v,instruments:x})=>{let w=new vot.BatchObservableResultImpl,F=Promise.resolve(v(w));f!=null&&(F=(0,aW.callWithTimeout)(F,f)),await F,x.forEach(ee=>{let me=w._buffer.get(ee);me!=null&&ee._metricStorages.forEach(de=>{de.record(me,c)})})})}_findCallback(c,f){return this._callbacks.findIndex(v=>v.callback===c&&v.instrument===f)}_findBatchCallback(c,f){return this._batchCallbacks.findIndex(v=>v.callback===c&&(0,aW.setEquals)(v.instruments,f))}};jle.ObservableRegistry=uDe});var Tot=At(Ble=>{"use strict";Object.defineProperty(Ble,"__esModule",{value:!0});Ble.SyncMetricStorage=void 0;var WHt=QNe(),GHt=rDe(),HHt=iDe(),_De=class extends WHt.MetricStorage{constructor(c,f,v,x){super(c),this._attributesProcessor=v,this._deltaMetricStorage=new GHt.DeltaMetricProcessor(f),this._temporalMetricStorage=new HHt.TemporalMetricProcessor(f,x)}record(c,f,v,x){f=this._attributesProcessor.process(f,v),this._deltaMetricStorage.record(c,f,v,x)}collect(c,f){let v=this._deltaMetricStorage.collect();return this._temporalMetricStorage.buildMetrics(c,this._instrumentDescriptor,v,f)}};Ble.SyncMetricStorage=_De});var pDe=At(HI=>{"use strict";Object.defineProperty(HI,"__esModule",{value:!0});HI.FilteringAttributesProcessor=HI.NoopAttributesProcessor=HI.AttributesProcessor=void 0;var oW=class{static Noop(){return YHt}};HI.AttributesProcessor=oW;var Ule=class extends oW{process(c,f){return c}};HI.NoopAttributesProcessor=Ule;var fDe=class extends oW{constructor(c){super(),this._allowedAttributeNames=c}process(c,f){let v={};return Object.keys(c).filter(x=>this._allowedAttributeNames.includes(x)).forEach(x=>v[x]=c[x]),v}};HI.FilteringAttributesProcessor=fDe;var YHt=new Ule});var bot=At(Vle=>{"use strict";Object.defineProperty(Vle,"__esModule",{value:!0});Vle.MeterSharedState=void 0;var XHt=yP(),KHt=aot(),QHt=jC(),ZHt=oot(),eYt=dot(),tYt=mot(),rYt=Sot(),nYt=Tot(),iYt=pDe(),dDe=class{constructor(c,f){this._meterProviderSharedState=c,this._instrumentationScope=f,this.metricStorageRegistry=new eYt.MetricStorageRegistry,this.observableRegistry=new rYt.ObservableRegistry,this.meter=new KHt.Meter(this)}registerMetricStorage(c){let f=this._registerMetricStorage(c,nYt.SyncMetricStorage);return f.length===1?f[0]:new tYt.MultiMetricStorage(f)}registerAsyncMetricStorage(c){return this._registerMetricStorage(c,ZHt.AsyncMetricStorage)}async collect(c,f,v){let x=await this.observableRegistry.observe(f,v?.timeoutMillis),w=this.metricStorageRegistry.getStorages(c);if(w.length===0)return null;let F=w.map(ee=>ee.collect(c,f)).filter(QHt.isNotNullish);return F.length===0?{errors:x}:{scopeMetrics:{scope:this._instrumentationScope,metrics:F},errors:x}}_registerMetricStorage(c,f){let x=this._meterProviderSharedState.viewRegistry.findViews(c,this._instrumentationScope).map(w=>{let F=(0,XHt.createInstrumentDescriptorWithView)(w,c),ee=this.metricStorageRegistry.findOrUpdateCompatibleStorage(F);if(ee!=null)return ee;let me=w.aggregation.createAggregator(F),de=new f(F,me,w.attributesProcessor,this._meterProviderSharedState.metricCollectors);return this.metricStorageRegistry.register(de),de});if(x.length===0){let F=this._meterProviderSharedState.selectAggregations(c.type).map(([ee,me])=>{let de=this.metricStorageRegistry.findOrUpdateCompatibleCollectorStorage(ee,c);if(de!=null)return de;let Te=me.createAggregator(c),ut=new f(c,Te,iYt.AttributesProcessor.Noop(),[ee]);return this.metricStorageRegistry.registerForCollector(ee,ut),ut});x=x.concat(F)}return x}};Vle.MeterSharedState=dDe});var Eot=At(Jle=>{"use strict";Object.defineProperty(Jle,"__esModule",{value:!0});Jle.MeterProviderSharedState=void 0;var sYt=jC(),aYt=sot(),oYt=bot(),mDe=class{constructor(c){this.resource=c,this.viewRegistry=new aYt.ViewRegistry,this.metricCollectors=[],this.meterSharedStates=new Map}getMeterSharedState(c){let f=(0,sYt.instrumentationScopeId)(c),v=this.meterSharedStates.get(f);return v==null&&(v=new oYt.MeterSharedState(this,c),this.meterSharedStates.set(f,v)),v}selectAggregations(c){let f=[];for(let v of this.metricCollectors)f.push([v,v.selectAggregation(c)]);return f}};Jle.MeterProviderSharedState=mDe});var xot=At(qle=>{"use strict";Object.defineProperty(qle,"__esModule",{value:!0});qle.MetricCollector=void 0;var cYt=p0(),gDe=class{constructor(c,f){this._sharedState=c,this._metricReader=f}async collect(c){let f=(0,cYt.millisToHrTime)(Date.now()),v=[],x=[],w=Array.from(this._sharedState.meterSharedStates.values()).map(async F=>{let ee=await F.collect(this,f,c);ee?.scopeMetrics!=null&&v.push(ee.scopeMetrics),ee?.errors!=null&&x.push(...ee.errors)});return await Promise.all(w),{resourceMetrics:{resource:this._sharedState.resource,scopeMetrics:v},errors:x}}async forceFlush(c){await this._metricReader.forceFlush(c)}async shutdown(c){await this._metricReader.shutdown(c)}selectAggregationTemporality(c){return this._metricReader.selectAggregationTemporality(c)}selectAggregation(c){return this._metricReader.selectAggregation(c)}};qle.MetricCollector=gDe});var Aot=At($le=>{"use strict";Object.defineProperty($le,"__esModule",{value:!0});$le.MeterProvider=void 0;var zle=(jc(),tl(Gc)),Cot=VNe(),lYt=Eot(),uYt=xot(),hDe=class{constructor(c){var f;this._shutdown=!1;let v=Cot.Resource.default().merge((f=c?.resource)!==null&&f!==void 0?f:Cot.Resource.empty());if(this._sharedState=new lYt.MeterProviderSharedState(v),c?.views!=null&&c.views.length>0)for(let x of c.views)this._sharedState.viewRegistry.addView(x);if(c?.readers!=null&&c.readers.length>0)for(let x of c.readers)this.addMetricReader(x)}getMeter(c,f="",v={}){return this._shutdown?(zle.diag.warn("A shutdown MeterProvider cannot provide a Meter"),(0,zle.createNoopMeter)()):this._sharedState.getMeterSharedState({name:c,version:f,schemaUrl:v.schemaUrl}).meter}addMetricReader(c){let f=new uYt.MetricCollector(this._sharedState,c);c.setMetricProducer(f),this._sharedState.metricCollectors.push(f)}async shutdown(c){if(this._shutdown){zle.diag.warn("shutdown may only be called once per MeterProvider");return}this._shutdown=!0,await Promise.all(this._sharedState.metricCollectors.map(f=>f.shutdown(c)))}async forceFlush(c){if(this._shutdown){zle.diag.warn("invalid attempt to force flush after MeterProvider shutdown");return}await Promise.all(this._sharedState.metricCollectors.map(f=>f.forceFlush(c)))}};$le.MeterProvider=hDe});var Wle=At(OF=>{"use strict";Object.defineProperty(OF,"__esModule",{value:!0});OF.ExactPredicate=OF.PatternPredicate=void 0;var _Yt=/[\^$\\.+?()[\]{}|]/g,yDe=class u{constructor(c){c==="*"?(this._matchAll=!0,this._regexp=/.*/):(this._matchAll=!1,this._regexp=new RegExp(u.escapePattern(c)))}match(c){return this._matchAll?!0:this._regexp.test(c)}static escapePattern(c){return`^${c.replace(_Yt,"\\$&").replace("*",".*")}$`}static hasWildcard(c){return c.includes("*")}};OF.PatternPredicate=yDe;var vDe=class{constructor(c){this._matchAll=c===void 0,this._pattern=c}match(c){return!!(this._matchAll||c===this._pattern)}};OF.ExactPredicate=vDe});var Pot=At(Gle=>{"use strict";Object.defineProperty(Gle,"__esModule",{value:!0});Gle.InstrumentSelector=void 0;var kot=Wle(),SDe=class{constructor(c){var f;this._nameFilter=new kot.PatternPredicate((f=c?.name)!==null&&f!==void 0?f:"*"),this._type=c?.type,this._unitFilter=new kot.ExactPredicate(c?.unit)}getType(){return this._type}getNameFilter(){return this._nameFilter}getUnitFilter(){return this._unitFilter}};Gle.InstrumentSelector=SDe});var Not=At(Hle=>{"use strict";Object.defineProperty(Hle,"__esModule",{value:!0});Hle.MeterSelector=void 0;var TDe=Wle(),bDe=class{constructor(c){this._nameFilter=new TDe.ExactPredicate(c?.name),this._versionFilter=new TDe.ExactPredicate(c?.version),this._schemaUrlFilter=new TDe.ExactPredicate(c?.schemaUrl)}getNameFilter(){return this._nameFilter}getVersionFilter(){return this._versionFilter}getSchemaUrlFilter(){return this._schemaUrlFilter}};Hle.MeterSelector=bDe});var Iot=At(Yle=>{"use strict";Object.defineProperty(Yle,"__esModule",{value:!0});Yle.View=void 0;var fYt=Wle(),Dot=pDe(),pYt=Pot(),dYt=Not(),mYt=Xce();function gYt(u){return u.instrumentName==null&&u.instrumentType==null&&u.instrumentUnit==null&&u.meterName==null&&u.meterVersion==null&&u.meterSchemaUrl==null}var EDe=class{constructor(c){var f;if(gYt(c))throw new Error("Cannot create view with no selector arguments supplied");if(c.name!=null&&(c?.instrumentName==null||fYt.PatternPredicate.hasWildcard(c.instrumentName)))throw new Error("Views with a specified name must be declared with an instrument selector that selects at most one instrument per meter.");c.attributeKeys!=null?this.attributesProcessor=new Dot.FilteringAttributesProcessor(c.attributeKeys):this.attributesProcessor=Dot.AttributesProcessor.Noop(),this.name=c.name,this.description=c.description,this.aggregation=(f=c.aggregation)!==null&&f!==void 0?f:mYt.Aggregation.Default(),this.instrumentSelector=new pYt.InstrumentSelector({name:c.instrumentName,type:c.instrumentType,unit:c.instrumentUnit}),this.meterSelector=new dYt.MeterSelector({name:c.meterName,version:c.meterVersion,schemaUrl:c.meterSchemaUrl})}};Yle.View=EDe});var RF=At(Gl=>{"use strict";Object.defineProperty(Gl,"__esModule",{value:!0});Gl.TimeoutError=Gl.View=Gl.Aggregation=Gl.SumAggregation=Gl.LastValueAggregation=Gl.HistogramAggregation=Gl.DropAggregation=Gl.ExponentialHistogramAggregation=Gl.ExplicitBucketHistogramAggregation=Gl.DefaultAggregation=Gl.MeterProvider=Gl.InstrumentType=Gl.ConsoleMetricExporter=Gl.InMemoryMetricExporter=Gl.PeriodicExportingMetricReader=Gl.MetricReader=Gl.DataPointType=Gl.AggregationTemporality=void 0;var hYt=Rce();Object.defineProperty(Gl,"AggregationTemporality",{enumerable:!0,get:function(){return hYt.AggregationTemporality}});var yYt=_F();Object.defineProperty(Gl,"DataPointType",{enumerable:!0,get:function(){return yYt.DataPointType}});var vYt=gNe();Object.defineProperty(Gl,"MetricReader",{enumerable:!0,get:function(){return vYt.MetricReader}});var SYt=kat();Object.defineProperty(Gl,"PeriodicExportingMetricReader",{enumerable:!0,get:function(){return SYt.PeriodicExportingMetricReader}});var TYt=Nat();Object.defineProperty(Gl,"InMemoryMetricExporter",{enumerable:!0,get:function(){return TYt.InMemoryMetricExporter}});var bYt=Iat();Object.defineProperty(Gl,"ConsoleMetricExporter",{enumerable:!0,get:function(){return bYt.ConsoleMetricExporter}});var EYt=yP();Object.defineProperty(Gl,"InstrumentType",{enumerable:!0,get:function(){return EYt.InstrumentType}});var xYt=Aot();Object.defineProperty(Gl,"MeterProvider",{enumerable:!0,get:function(){return xYt.MeterProvider}});var YI=Xce();Object.defineProperty(Gl,"DefaultAggregation",{enumerable:!0,get:function(){return YI.DefaultAggregation}});Object.defineProperty(Gl,"ExplicitBucketHistogramAggregation",{enumerable:!0,get:function(){return YI.ExplicitBucketHistogramAggregation}});Object.defineProperty(Gl,"ExponentialHistogramAggregation",{enumerable:!0,get:function(){return YI.ExponentialHistogramAggregation}});Object.defineProperty(Gl,"DropAggregation",{enumerable:!0,get:function(){return YI.DropAggregation}});Object.defineProperty(Gl,"HistogramAggregation",{enumerable:!0,get:function(){return YI.HistogramAggregation}});Object.defineProperty(Gl,"LastValueAggregation",{enumerable:!0,get:function(){return YI.LastValueAggregation}});Object.defineProperty(Gl,"SumAggregation",{enumerable:!0,get:function(){return YI.SumAggregation}});Object.defineProperty(Gl,"Aggregation",{enumerable:!0,get:function(){return YI.Aggregation}});var CYt=Iot();Object.defineProperty(Gl,"View",{enumerable:!0,get:function(){return CYt.View}});var AYt=jC();Object.defineProperty(Gl,"TimeoutError",{enumerable:!0,get:function(){return AYt.TimeoutError}})});var xDe=At(cW=>{"use strict";Object.defineProperty(cW,"__esModule",{value:!0});cW.AggregationTemporalityPreference=void 0;var kYt;(function(u){u[u.DELTA=0]="DELTA",u[u.CUMULATIVE=1]="CUMULATIVE",u[u.LOWMEMORY=2]="LOWMEMORY"})(kYt=cW.AggregationTemporalityPreference||(cW.AggregationTemporalityPreference={}))});var ADe=At(d0=>{"use strict";Object.defineProperty(d0,"__esModule",{value:!0});d0.OTLPMetricExporterBase=d0.LowMemoryTemporalitySelector=d0.DeltaTemporalitySelector=d0.CumulativeTemporalitySelector=void 0;var PYt=p0(),sg=RF(),wot=xDe(),NYt=(jc(),tl(Gc)),DYt=()=>sg.AggregationTemporality.CUMULATIVE;d0.CumulativeTemporalitySelector=DYt;var IYt=u=>{switch(u){case sg.InstrumentType.COUNTER:case sg.InstrumentType.OBSERVABLE_COUNTER:case sg.InstrumentType.GAUGE:case sg.InstrumentType.HISTOGRAM:case sg.InstrumentType.OBSERVABLE_GAUGE:return sg.AggregationTemporality.DELTA;case sg.InstrumentType.UP_DOWN_COUNTER:case sg.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER:return sg.AggregationTemporality.CUMULATIVE}};d0.DeltaTemporalitySelector=IYt;var wYt=u=>{switch(u){case sg.InstrumentType.COUNTER:case sg.InstrumentType.HISTOGRAM:return sg.AggregationTemporality.DELTA;case sg.InstrumentType.GAUGE:case sg.InstrumentType.UP_DOWN_COUNTER:case sg.InstrumentType.OBSERVABLE_UP_DOWN_COUNTER:case sg.InstrumentType.OBSERVABLE_COUNTER:case sg.InstrumentType.OBSERVABLE_GAUGE:return sg.AggregationTemporality.CUMULATIVE}};d0.LowMemoryTemporalitySelector=wYt;function OYt(){let u=(0,PYt.getEnv)(),c=u.OTEL_EXPORTER_OTLP_METRICS_TEMPORALITY_PREFERENCE.trim().toLowerCase();return c==="cumulative"?d0.CumulativeTemporalitySelector:c==="delta"?d0.DeltaTemporalitySelector:c==="lowmemory"?d0.LowMemoryTemporalitySelector:(NYt.diag.warn(`OTEL_EXPORTER_OTLP_METRICS_TEMPORALITY_PREFERENCE is set to '${u.OTEL_EXPORTER_OTLP_METRICS_TEMPORALITY_PREFERENCE}', but only 'cumulative' and 'delta' are allowed. Using default ('cumulative') instead.`),d0.CumulativeTemporalitySelector)}function RYt(u){return u!=null?u===wot.AggregationTemporalityPreference.DELTA?d0.DeltaTemporalitySelector:u===wot.AggregationTemporalityPreference.LOWMEMORY?d0.LowMemoryTemporalitySelector:d0.CumulativeTemporalitySelector:OYt()}function MYt(u){return u?.aggregationPreference?u.aggregationPreference:c=>sg.Aggregation.Default()}var CDe=class{constructor(c,f){this._otlpExporter=c,this._aggregationSelector=MYt(f),this._aggregationTemporalitySelector=RYt(f?.temporalityPreference)}export(c,f){this._otlpExporter.export([c],f)}async shutdown(){await this._otlpExporter.shutdown()}forceFlush(){return Promise.resolve()}selectAggregation(c){return this._aggregationSelector(c)}selectAggregationTemporality(c){return this._aggregationTemporalitySelector(c)}};d0.OTLPMetricExporterBase=CDe});var Z4=At(Zp=>{"use strict";Object.defineProperty(Zp,"__esModule",{value:!0});Zp.parseRetryAfterToMills=Zp.isExportRetryable=Zp.invalidTimeout=Zp.configureExporterTimeout=Zp.appendRootPathToUrlIfNeeded=Zp.appendResourcePathToUrl=Zp.parseHeaders=Zp.DEFAULT_EXPORT_BACKOFF_MULTIPLIER=Zp.DEFAULT_EXPORT_MAX_BACKOFF=Zp.DEFAULT_EXPORT_INITIAL_BACKOFF=Zp.DEFAULT_EXPORT_MAX_ATTEMPTS=void 0;var kDe=(jc(),tl(Gc)),Oot=p0(),Rot=1e4;Zp.DEFAULT_EXPORT_MAX_ATTEMPTS=5;Zp.DEFAULT_EXPORT_INITIAL_BACKOFF=1e3;Zp.DEFAULT_EXPORT_MAX_BACKOFF=5e3;Zp.DEFAULT_EXPORT_BACKOFF_MULTIPLIER=1.5;function LYt(u={}){let c={};return Object.entries(u).forEach(([f,v])=>{typeof v<"u"?c[f]=String(v):kDe.diag.warn(`Header "${f}" has invalid value (${v}) and will be ignored`)}),c}Zp.parseHeaders=LYt;function FYt(u,c){return u.endsWith("/")||(u=u+"/"),u+c}Zp.appendResourcePathToUrl=FYt;function jYt(u){try{let c=new URL(u);return c.pathname===""&&(c.pathname=c.pathname+"/"),c.toString()}catch{return kDe.diag.warn(`Could not parse export URL: '${u}'`),u}}Zp.appendRootPathToUrlIfNeeded=jYt;function BYt(u){return typeof u=="number"?u<=0?PDe(u,Rot):u:UYt()}Zp.configureExporterTimeout=BYt;function UYt(){var u;let c=Number((u=(0,Oot.getEnv)().OTEL_EXPORTER_OTLP_TRACES_TIMEOUT)!==null&&u!==void 0?u:(0,Oot.getEnv)().OTEL_EXPORTER_OTLP_TIMEOUT);return c<=0?PDe(c,Rot):c}function PDe(u,c){return kDe.diag.warn("Timeout must be greater than 0",u),c}Zp.invalidTimeout=PDe;function VYt(u){return[429,502,503,504].includes(u)}Zp.isExportRetryable=VYt;function JYt(u){if(u==null)return-1;let c=Number.parseInt(u,10);if(Number.isInteger(c))return c>0?c*1e3:-1;let f=new Date(u).getTime()-Date.now();return f>=0?f:0}Zp.parseRetryAfterToMills=JYt});var Kle=At(Xle=>{"use strict";Object.defineProperty(Xle,"__esModule",{value:!0});Xle.OTLPExporterBase=void 0;var Mot=(jc(),tl(Gc)),lW=p0(),qYt=Z4(),NDe=class{constructor(c={}){this._sendingPromises=[],this.url=this.getDefaultUrl(c),typeof c.hostname=="string"&&(this.hostname=c.hostname),this.shutdown=this.shutdown.bind(this),this._shutdownOnce=new lW.BindOnceFuture(this._shutdown,this),this._concurrencyLimit=typeof c.concurrencyLimit=="number"?c.concurrencyLimit:30,this.timeoutMillis=(0,qYt.configureExporterTimeout)(c.timeoutMillis),this.onInit(c)}export(c,f){if(this._shutdownOnce.isCalled){f({code:lW.ExportResultCode.FAILED,error:new Error("Exporter has been shutdown")});return}if(this._sendingPromises.length>=this._concurrencyLimit){f({code:lW.ExportResultCode.FAILED,error:new Error("Concurrent export limit reached")});return}this._export(c).then(()=>{f({code:lW.ExportResultCode.SUCCESS})}).catch(v=>{f({code:lW.ExportResultCode.FAILED,error:v})})}_export(c){return new Promise((f,v)=>{try{Mot.diag.debug("items to be sent",c),this.send(c,f,v)}catch(x){v(x)}})}shutdown(){return this._shutdownOnce.call()}forceFlush(){return Promise.all(this._sendingPromises).then(()=>{})}_shutdown(){return Mot.diag.debug("shutdown started"),this.onShutdown(),this.forceFlush()}};Xle.OTLPExporterBase=NDe});var DDe=At(uW=>{"use strict";Object.defineProperty(uW,"__esModule",{value:!0});uW.CompressionAlgorithm=void 0;var zYt;(function(u){u.NONE="none",u.GZIP="gzip"})(zYt=uW.CompressionAlgorithm||(uW.CompressionAlgorithm={}))});var Zle=At(Qle=>{"use strict";Object.defineProperty(Qle,"__esModule",{value:!0});Qle.OTLPExporterError=void 0;var IDe=class extends Error{constructor(c,f,v){super(c),this.name="OTLPExporterError",this.data=v,this.code=f}};Qle.OTLPExporterError=IDe});var ODe=At(XI=>{"use strict";Object.defineProperty(XI,"__esModule",{value:!0});XI.configureCompression=XI.createHttpAgent=XI.sendWithHttp=void 0;var Fot=Bu("url"),jot=Bu("http"),Bot=Bu("https"),$Yt=Bu("zlib"),WYt=Bu("stream"),wDe=(jc(),tl(Gc)),eue=DDe(),Lot=p0(),_W=Zle(),MF=Z4();function GYt(u,c,f,v,x){let w=u.timeoutMillis,F=new Fot.URL(u.url),ee=Number(process.versions.node.split(".")[0]),me,de,Te=!1,ut=setTimeout(()=>{if(clearTimeout(me),Te=!0,de.destroyed){let en=new _W.OTLPExporterError("Request Timeout");x(en)}else ee>=14?de.destroy():de.abort()},w),Ct={hostname:F.hostname,port:F.port,path:F.pathname,method:"POST",headers:Object.assign({"Content-Type":f},u.headers),agent:u.agent},Kt=F.protocol==="http:"?jot.request:Bot.request,xr=(en=MF.DEFAULT_EXPORT_MAX_ATTEMPTS,zn=MF.DEFAULT_EXPORT_INITIAL_BACKOFF)=>{switch(de=Kt(Ct,yr=>{let mr="";yr.on("data",Da=>mr+=Da),yr.on("aborted",()=>{if(Te){let Da=new _W.OTLPExporterError("Request Timeout");x(Da)}}),yr.on("end",()=>{if(Te===!1)if(yr.statusCode&&yr.statusCode<299)wDe.diag.debug(`statusCode: ${yr.statusCode}`,mr),v(),clearTimeout(ut),clearTimeout(me);else if(yr.statusCode&&(0,MF.isExportRetryable)(yr.statusCode)&&en>0){let Da;zn=MF.DEFAULT_EXPORT_BACKOFF_MULTIPLIER*zn,yr.headers["retry-after"]?Da=(0,MF.parseRetryAfterToMills)(yr.headers["retry-after"]):Da=Math.round(Math.random()*(MF.DEFAULT_EXPORT_MAX_BACKOFF-zn)+zn),me=setTimeout(()=>{xr(en-1,zn)},Da)}else{let Da=new _W.OTLPExporterError(yr.statusMessage,yr.statusCode,mr);x(Da),clearTimeout(ut),clearTimeout(me)}})}),de.on("error",yr=>{if(Te){let mr=new _W.OTLPExporterError("Request Timeout",yr.code);x(mr)}else x(yr);clearTimeout(ut),clearTimeout(me)}),de.on("abort",()=>{if(Te){let yr=new _W.OTLPExporterError("Request Timeout");x(yr)}clearTimeout(ut),clearTimeout(me)}),u.compression){case eue.CompressionAlgorithm.GZIP:{de.setHeader("Content-Encoding","gzip"),HYt(c).on("error",x).pipe($Yt.createGzip()).on("error",x).pipe(de);break}default:de.end(c);break}};xr()}XI.sendWithHttp=GYt;function HYt(u){let c=new WYt.Readable;return c.push(u),c.push(null),c}function YYt(u){if(u.httpAgentOptions&&u.keepAlive===!1){wDe.diag.warn("httpAgentOptions is used only when keepAlive is true");return}if(!(u.keepAlive===!1||!u.url))try{let f=new Fot.URL(u.url).protocol==="http:"?jot.Agent:Bot.Agent;return new f(Object.assign({keepAlive:!0},u.httpAgentOptions))}catch(c){wDe.diag.error(`collector exporter failed to create http agent. err: ${c.message}`);return}}XI.createHttpAgent=YYt;function XYt(u){return u||(((0,Lot.getEnv)().OTEL_EXPORTER_OTLP_TRACES_COMPRESSION||(0,Lot.getEnv)().OTEL_EXPORTER_OTLP_COMPRESSION)===eue.CompressionAlgorithm.GZIP?eue.CompressionAlgorithm.GZIP:eue.CompressionAlgorithm.NONE)}XI.configureCompression=XYt});var Jot=At(tue=>{"use strict";Object.defineProperty(tue,"__esModule",{value:!0});tue.OTLPExporterNodeBase=void 0;var KYt=Kle(),QYt=Z4(),RDe=ODe(),Uot=(jc(),tl(Gc)),Vot=p0(),MDe=class extends KYt.OTLPExporterBase{constructor(c={}){super(c),this.DEFAULT_HEADERS={},c.metadata&&Uot.diag.warn("Metadata cannot be set when using http"),this.headers=Object.assign(this.DEFAULT_HEADERS,(0,QYt.parseHeaders)(c.headers),Vot.baggageUtils.parseKeyPairsIntoRecord((0,Vot.getEnv)().OTEL_EXPORTER_OTLP_HEADERS)),this.agent=(0,RDe.createHttpAgent)(c),this.compression=(0,RDe.configureCompression)(c.compression)}onInit(c){}send(c,f,v){if(this._shutdownOnce.isCalled){Uot.diag.debug("Shutdown already started. Cannot send objects");return}let x=this.convert(c),w=new Promise((ee,me)=>{(0,RDe.sendWithHttp)(this,JSON.stringify(x),"application/json",ee,me)}).then(f,v);this._sendingPromises.push(w);let F=()=>{let ee=this._sendingPromises.indexOf(w);this._sendingPromises.splice(ee,1)};w.then(F,F)}onShutdown(){}};tue.OTLPExporterNodeBase=MDe});var qot=At(xb=>{"use strict";Object.defineProperty(xb,"__esModule",{value:!0});xb.CompressionAlgorithm=xb.configureCompression=xb.createHttpAgent=xb.sendWithHttp=xb.OTLPExporterNodeBase=void 0;var ZYt=Jot();Object.defineProperty(xb,"OTLPExporterNodeBase",{enumerable:!0,get:function(){return ZYt.OTLPExporterNodeBase}});var LDe=ODe();Object.defineProperty(xb,"sendWithHttp",{enumerable:!0,get:function(){return LDe.sendWithHttp}});Object.defineProperty(xb,"createHttpAgent",{enumerable:!0,get:function(){return LDe.createHttpAgent}});Object.defineProperty(xb,"configureCompression",{enumerable:!0,get:function(){return LDe.configureCompression}});var eXt=DDe();Object.defineProperty(xb,"CompressionAlgorithm",{enumerable:!0,get:function(){return eXt.CompressionAlgorithm}})});var FDe=At(FF=>{"use strict";Object.defineProperty(FF,"__esModule",{value:!0});FF.sendWithXhr=FF.sendWithBeacon=void 0;var zot=(jc(),tl(Gc)),fW=Zle(),LF=Z4();function tXt(u,c,f,v,x){if(navigator.sendBeacon(c,new Blob([u],f)))zot.diag.debug("sendBeacon - can send",u),v();else{let w=new fW.OTLPExporterError(`sendBeacon - cannot send ${u}`);x(w)}}FF.sendWithBeacon=tXt;function rXt(u,c,f,v,x,w){let F,ee,me=!1,de=setTimeout(()=>{if(clearTimeout(F),me=!0,ee.readyState===XMLHttpRequest.DONE){let ut=new fW.OTLPExporterError("Request Timeout");w(ut)}else ee.abort()},v),Te=(ut=LF.DEFAULT_EXPORT_MAX_ATTEMPTS,Ct=LF.DEFAULT_EXPORT_INITIAL_BACKOFF)=>{ee=new XMLHttpRequest,ee.open("POST",c),Object.entries(Object.assign(Object.assign({},{Accept:"application/json","Content-Type":"application/json"}),f)).forEach(([xr,en])=>{ee.setRequestHeader(xr,en)}),ee.send(u),ee.onreadystatechange=()=>{if(ee.readyState===XMLHttpRequest.DONE&&me===!1)if(ee.status>=200&&ee.status<=299)zot.diag.debug("xhr success",u),x(),clearTimeout(de),clearTimeout(F);else if(ee.status&&(0,LF.isExportRetryable)(ee.status)&&ut>0){let xr;Ct=LF.DEFAULT_EXPORT_BACKOFF_MULTIPLIER*Ct,ee.getResponseHeader("Retry-After")?xr=(0,LF.parseRetryAfterToMills)(ee.getResponseHeader("Retry-After")):xr=Math.round(Math.random()*(LF.DEFAULT_EXPORT_MAX_BACKOFF-Ct)+Ct),F=setTimeout(()=>{Te(ut-1,Ct)},xr)}else{let xr=new fW.OTLPExporterError(`Failed to export with XHR (status: ${ee.status})`,ee.status);w(xr),clearTimeout(de),clearTimeout(F)}},ee.onabort=()=>{if(me){let xr=new fW.OTLPExporterError("Request Timeout");w(xr)}clearTimeout(de),clearTimeout(F)},ee.onerror=()=>{if(me){let xr=new fW.OTLPExporterError("Request Timeout");w(xr)}clearTimeout(de),clearTimeout(F)}};Te()}FF.sendWithXhr=rXt});var Got=At(rue=>{"use strict";Object.defineProperty(rue,"__esModule",{value:!0});rue.OTLPExporterBrowserBase=void 0;var nXt=Kle(),iXt=Z4(),$ot=FDe(),sXt=(jc(),tl(Gc)),Wot=p0(),jDe=class extends nXt.OTLPExporterBase{constructor(c={}){super(c),this._useXHR=!1,this._useXHR=!!c.headers||typeof navigator.sendBeacon!="function",this._useXHR?this._headers=Object.assign({},(0,iXt.parseHeaders)(c.headers),Wot.baggageUtils.parseKeyPairsIntoRecord((0,Wot.getEnv)().OTEL_EXPORTER_OTLP_HEADERS)):this._headers={}}onInit(){}onShutdown(){}send(c,f,v){if(this._shutdownOnce.isCalled){sXt.diag.debug("Shutdown already started. Cannot send objects");return}let x=this.convert(c),w=JSON.stringify(x),F=new Promise((me,de)=>{this._useXHR?(0,$ot.sendWithXhr)(w,this.url,this._headers,this.timeoutMillis,me,de):(0,$ot.sendWithBeacon)(w,this.url,{type:"application/json"},me,de)}).then(f,v);this._sendingPromises.push(F);let ee=()=>{let me=this._sendingPromises.indexOf(F);this._sendingPromises.splice(me,1)};F.then(ee,ee)}};rue.OTLPExporterBrowserBase=jDe});var Hot=At(jF=>{"use strict";Object.defineProperty(jF,"__esModule",{value:!0});jF.sendWithXhr=jF.OTLPExporterBrowserBase=void 0;var aXt=Got();Object.defineProperty(jF,"OTLPExporterBrowserBase",{enumerable:!0,get:function(){return aXt.OTLPExporterBrowserBase}});var oXt=FDe();Object.defineProperty(jF,"sendWithXhr",{enumerable:!0,get:function(){return oXt.sendWithXhr}})});var Xot=At(oy=>{"use strict";Object.defineProperty(oy,"__esModule",{value:!0});oy.sendWithXhr=oy.OTLPExporterBrowserBase=oy.CompressionAlgorithm=oy.configureCompression=oy.createHttpAgent=oy.sendWithHttp=oy.OTLPExporterNodeBase=void 0;var pW=qot();Object.defineProperty(oy,"OTLPExporterNodeBase",{enumerable:!0,get:function(){return pW.OTLPExporterNodeBase}});Object.defineProperty(oy,"sendWithHttp",{enumerable:!0,get:function(){return pW.sendWithHttp}});Object.defineProperty(oy,"createHttpAgent",{enumerable:!0,get:function(){return pW.createHttpAgent}});Object.defineProperty(oy,"configureCompression",{enumerable:!0,get:function(){return pW.configureCompression}});Object.defineProperty(oy,"CompressionAlgorithm",{enumerable:!0,get:function(){return pW.CompressionAlgorithm}});var Yot=Hot();Object.defineProperty(oy,"OTLPExporterBrowserBase",{enumerable:!0,get:function(){return Yot.OTLPExporterBrowserBase}});Object.defineProperty(oy,"sendWithXhr",{enumerable:!0,get:function(){return Yot.sendWithXhr}})});var BDe=At(xm=>{"use strict";var cXt=xm&&xm.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),lXt=xm&&xm.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&cXt(c,u,f)};Object.defineProperty(xm,"__esModule",{value:!0});xm.invalidTimeout=xm.configureExporterTimeout=xm.appendRootPathToUrlIfNeeded=xm.appendResourcePathToUrl=xm.parseHeaders=xm.OTLPExporterError=xm.OTLPExporterBase=void 0;lXt(Xot(),xm);var uXt=Kle();Object.defineProperty(xm,"OTLPExporterBase",{enumerable:!0,get:function(){return uXt.OTLPExporterBase}});var _Xt=Zle();Object.defineProperty(xm,"OTLPExporterError",{enumerable:!0,get:function(){return _Xt.OTLPExporterError}});var dW=Z4();Object.defineProperty(xm,"parseHeaders",{enumerable:!0,get:function(){return dW.parseHeaders}});Object.defineProperty(xm,"appendResourcePathToUrl",{enumerable:!0,get:function(){return dW.appendResourcePathToUrl}});Object.defineProperty(xm,"appendRootPathToUrlIfNeeded",{enumerable:!0,get:function(){return dW.appendRootPathToUrlIfNeeded}});Object.defineProperty(xm,"configureExporterTimeout",{enumerable:!0,get:function(){return dW.configureExporterTimeout}});Object.defineProperty(xm,"invalidTimeout",{enumerable:!0,get:function(){return dW.invalidTimeout}})});var Qot=At(Kot=>{"use strict";Object.defineProperty(Kot,"__esModule",{value:!0})});var mW=At(Cb=>{"use strict";Object.defineProperty(Cb,"__esModule",{value:!0});Cb.getOtlpEncoder=Cb.encodeAsString=Cb.encodeAsLongBits=Cb.toLongBits=Cb.hrTimeToNanos=void 0;var nue=p0();function UDe(u){let c=BigInt(1e9);return BigInt(u[0])*c+BigInt(u[1])}Cb.hrTimeToNanos=UDe;function ect(u){let c=Number(BigInt.asUintN(32,u)),f=Number(BigInt.asUintN(32,u>>BigInt(32)));return{low:c,high:f}}Cb.toLongBits=ect;function VDe(u){let c=UDe(u);return ect(c)}Cb.encodeAsLongBits=VDe;function tct(u){return UDe(u).toString()}Cb.encodeAsString=tct;var fXt=typeof BigInt<"u"?tct:nue.hrTimeToNanoseconds;function Zot(u){return u}function rct(u){if(u!==void 0)return(0,nue.hexToBinary)(u)}var pXt={encodeHrTime:VDe,encodeSpanContext:nue.hexToBinary,encodeOptionalSpanContext:rct};function dXt(u){var c,f;if(u===void 0)return pXt;let v=(c=u.useLongBits)!==null&&c!==void 0?c:!0,x=(f=u.useHex)!==null&&f!==void 0?f:!1;return{encodeHrTime:v?VDe:fXt,encodeSpanContext:x?Zot:nue.hexToBinary,encodeOptionalSpanContext:x?Zot:rct}}Cb.getOtlpEncoder=dXt});var ict=At(nct=>{"use strict";Object.defineProperty(nct,"__esModule",{value:!0})});var act=At(sct=>{"use strict";Object.defineProperty(sct,"__esModule",{value:!0})});var oct=At(gW=>{"use strict";Object.defineProperty(gW,"__esModule",{value:!0});gW.ESpanKind=void 0;var mXt;(function(u){u[u.SPAN_KIND_UNSPECIFIED=0]="SPAN_KIND_UNSPECIFIED",u[u.SPAN_KIND_INTERNAL=1]="SPAN_KIND_INTERNAL",u[u.SPAN_KIND_SERVER=2]="SPAN_KIND_SERVER",u[u.SPAN_KIND_CLIENT=3]="SPAN_KIND_CLIENT",u[u.SPAN_KIND_PRODUCER=4]="SPAN_KIND_PRODUCER",u[u.SPAN_KIND_CONSUMER=5]="SPAN_KIND_CONSUMER"})(mXt=gW.ESpanKind||(gW.ESpanKind={}))});var lct=At(cct=>{"use strict";Object.defineProperty(cct,"__esModule",{value:!0})});var BF=At(VC=>{"use strict";Object.defineProperty(VC,"__esModule",{value:!0});VC.toAnyValue=VC.toKeyValue=VC.toAttributes=VC.createInstrumentationScope=void 0;function gXt(u){return{name:u.name,version:u.version}}VC.createInstrumentationScope=gXt;function hXt(u){return Object.keys(u).map(c=>JDe(c,u[c]))}VC.toAttributes=hXt;function JDe(u,c){return{key:u,value:qDe(c)}}VC.toKeyValue=JDe;function qDe(u){let c=typeof u;return c==="string"?{stringValue:u}:c==="number"?Number.isInteger(u)?{intValue:u}:{doubleValue:u}:c==="boolean"?{boolValue:u}:u instanceof Uint8Array?{bytesValue:u}:Array.isArray(u)?{arrayValue:{values:u.map(qDe)}}:c==="object"&&u!=null?{kvlistValue:{values:Object.entries(u).map(([f,v])=>JDe(f,v))}}:{}}VC.toAnyValue=qDe});var fct=At(KI=>{"use strict";Object.defineProperty(KI,"__esModule",{value:!0});KI.toOtlpSpanEvent=KI.toOtlpLink=KI.sdkSpanToOtlpSpan=void 0;var zDe=BF();function yXt(u,c){var f;let v=u.spanContext(),x=u.status;return{traceId:c.encodeSpanContext(v.traceId),spanId:c.encodeSpanContext(v.spanId),parentSpanId:c.encodeOptionalSpanContext(u.parentSpanId),traceState:(f=v.traceState)===null||f===void 0?void 0:f.serialize(),name:u.name,kind:u.kind==null?0:u.kind+1,startTimeUnixNano:c.encodeHrTime(u.startTime),endTimeUnixNano:c.encodeHrTime(u.endTime),attributes:(0,zDe.toAttributes)(u.attributes),droppedAttributesCount:u.droppedAttributesCount,events:u.events.map(w=>_ct(w,c)),droppedEventsCount:u.droppedEventsCount,status:{code:x.code,message:x.message},links:u.links.map(w=>uct(w,c)),droppedLinksCount:u.droppedLinksCount}}KI.sdkSpanToOtlpSpan=yXt;function uct(u,c){var f;return{attributes:u.attributes?(0,zDe.toAttributes)(u.attributes):[],spanId:c.encodeSpanContext(u.context.spanId),traceId:c.encodeSpanContext(u.context.traceId),traceState:(f=u.context.traceState)===null||f===void 0?void 0:f.serialize(),droppedAttributesCount:u.droppedAttributesCount||0}}KI.toOtlpLink=uct;function _ct(u,c){return{attributes:u.attributes?(0,zDe.toAttributes)(u.attributes):[],name:u.name,timeUnixNano:c.encodeHrTime(u.time),droppedAttributesCount:u.droppedAttributesCount||0}}KI.toOtlpSpanEvent=_ct});var sue=At(iue=>{"use strict";Object.defineProperty(iue,"__esModule",{value:!0});iue.createResource=void 0;var vXt=BF();function SXt(u){return{attributes:(0,vXt.toAttributes)(u.attributes),droppedAttributesCount:0}}iue.createResource=SXt});var pct=At(aue=>{"use strict";Object.defineProperty(aue,"__esModule",{value:!0});aue.createExportTraceServiceRequest=void 0;var TXt=fct(),bXt=mW(),EXt=BF(),xXt=sue();function CXt(u,c){let f=(0,bXt.getOtlpEncoder)(c);return{resourceSpans:kXt(u,f)}}aue.createExportTraceServiceRequest=CXt;function AXt(u){let c=new Map;for(let f of u){let v=c.get(f.resource);v||(v=new Map,c.set(f.resource,v));let x=`${f.instrumentationLibrary.name}@${f.instrumentationLibrary.version||""}:${f.instrumentationLibrary.schemaUrl||""}`,w=v.get(x);w||(w=[],v.set(x,w)),w.push(f)}return c}function kXt(u,c){let f=AXt(u),v=[],x=f.entries(),w=x.next();for(;!w.done;){let[F,ee]=w.value,me=[],de=ee.values(),Te=de.next();for(;!Te.done;){let Ct=Te.value;if(Ct.length>0){let Kt=Ct.map(xr=>(0,TXt.sdkSpanToOtlpSpan)(xr,c));me.push({scope:(0,EXt.createInstrumentationScope)(Ct[0].instrumentationLibrary),spans:Kt,schemaUrl:Ct[0].instrumentationLibrary.schemaUrl})}Te=de.next()}let ut={resource:(0,xXt.createResource)(F),scopeSpans:me,schemaUrl:void 0};v.push(ut),w=x.next()}return v}});var yct=At(QI=>{"use strict";Object.defineProperty(QI,"__esModule",{value:!0});QI.toMetric=QI.toScopeMetrics=QI.toResourceMetrics=void 0;var dct=(jc(),tl(Gc)),UF=RF(),PXt=mW(),oue=BF(),NXt=sue();function DXt(u,c){let f=(0,PXt.getOtlpEncoder)(c);return{resource:(0,NXt.createResource)(u.resource),schemaUrl:void 0,scopeMetrics:gct(u.scopeMetrics,f)}}QI.toResourceMetrics=DXt;function gct(u,c){return Array.from(u.map(f=>({scope:(0,oue.createInstrumentationScope)(f.scope),metrics:f.metrics.map(v=>hct(v,c)),schemaUrl:f.scope.schemaUrl})))}QI.toScopeMetrics=gct;function hct(u,c){let f={name:u.descriptor.name,description:u.descriptor.description,unit:u.descriptor.unit},v=RXt(u.aggregationTemporality);switch(u.dataPointType){case UF.DataPointType.SUM:f.sum={aggregationTemporality:v,isMonotonic:u.isMonotonic,dataPoints:mct(u,c)};break;case UF.DataPointType.GAUGE:f.gauge={dataPoints:mct(u,c)};break;case UF.DataPointType.HISTOGRAM:f.histogram={aggregationTemporality:v,dataPoints:wXt(u,c)};break;case UF.DataPointType.EXPONENTIAL_HISTOGRAM:f.exponentialHistogram={aggregationTemporality:v,dataPoints:OXt(u,c)};break}return f}QI.toMetric=hct;function IXt(u,c,f){let v={attributes:(0,oue.toAttributes)(u.attributes),startTimeUnixNano:f.encodeHrTime(u.startTime),timeUnixNano:f.encodeHrTime(u.endTime)};switch(c){case dct.ValueType.INT:v.asInt=u.value;break;case dct.ValueType.DOUBLE:v.asDouble=u.value;break}return v}function mct(u,c){return u.dataPoints.map(f=>IXt(f,u.descriptor.valueType,c))}function wXt(u,c){return u.dataPoints.map(f=>{let v=f.value;return{attributes:(0,oue.toAttributes)(f.attributes),bucketCounts:v.buckets.counts,explicitBounds:v.buckets.boundaries,count:v.count,sum:v.sum,min:v.min,max:v.max,startTimeUnixNano:c.encodeHrTime(f.startTime),timeUnixNano:c.encodeHrTime(f.endTime)}})}function OXt(u,c){return u.dataPoints.map(f=>{let v=f.value;return{attributes:(0,oue.toAttributes)(f.attributes),count:v.count,min:v.min,max:v.max,sum:v.sum,positive:{offset:v.positive.offset,bucketCounts:v.positive.bucketCounts},negative:{offset:v.negative.offset,bucketCounts:v.negative.bucketCounts},scale:v.scale,zeroCount:v.zeroCount,startTimeUnixNano:c.encodeHrTime(f.startTime),timeUnixNano:c.encodeHrTime(f.endTime)}})}function RXt(u){switch(u){case UF.AggregationTemporality.DELTA:return 1;case UF.AggregationTemporality.CUMULATIVE:return 2}}});var vct=At(cue=>{"use strict";Object.defineProperty(cue,"__esModule",{value:!0});cue.createExportMetricsServiceRequest=void 0;var MXt=yct();function LXt(u,c){return{resourceMetrics:u.map(f=>(0,MXt.toResourceMetrics)(f,c))}}cue.createExportMetricsServiceRequest=LXt});var Tct=At(VF=>{"use strict";Object.defineProperty(VF,"__esModule",{value:!0});VF.toLogAttributes=VF.createExportLogsServiceRequest=void 0;var FXt=mW(),$De=BF(),jXt=sue();function BXt(u,c){let f=(0,FXt.getOtlpEncoder)(c);return{resourceLogs:VXt(u,f)}}VF.createExportLogsServiceRequest=BXt;function UXt(u){let c=new Map;for(let f of u){let{resource:v,instrumentationScope:{name:x,version:w="",schemaUrl:F=""}}=f,ee=c.get(v);ee||(ee=new Map,c.set(v,ee));let me=`${x}@${w}:${F}`,de=ee.get(me);de||(de=[],ee.set(me,de)),de.push(f)}return c}function VXt(u,c){let f=UXt(u);return Array.from(f,([v,x])=>({resource:(0,jXt.createResource)(v),scopeLogs:Array.from(x,([,w])=>({scope:(0,$De.createInstrumentationScope)(w[0].instrumentationScope),logRecords:w.map(F=>JXt(F,c)),schemaUrl:w[0].instrumentationScope.schemaUrl})),schemaUrl:void 0}))}function JXt(u,c){var f,v,x;return{timeUnixNano:c.encodeHrTime(u.hrTime),observedTimeUnixNano:c.encodeHrTime(u.hrTimeObserved),severityNumber:u.severityNumber,severityText:u.severityText,body:(0,$De.toAnyValue)(u.body),attributes:Sct(u.attributes),droppedAttributesCount:u.droppedAttributesCount,flags:(f=u.spanContext)===null||f===void 0?void 0:f.traceFlags,traceId:c.encodeOptionalSpanContext((v=u.spanContext)===null||v===void 0?void 0:v.traceId),spanId:c.encodeOptionalSpanContext((x=u.spanContext)===null||x===void 0?void 0:x.spanId)}}function Sct(u){return Object.keys(u).map(c=>(0,$De.toKeyValue)(c,u[c]))}VF.toLogAttributes=Sct});var bct=At(Ah=>{"use strict";var qXt=Ah&&Ah.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),JF=Ah&&Ah.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&qXt(c,u,f)};Object.defineProperty(Ah,"__esModule",{value:!0});Ah.createExportLogsServiceRequest=Ah.createExportMetricsServiceRequest=Ah.createExportTraceServiceRequest=void 0;JF(Qot(),Ah);JF(mW(),Ah);JF(ict(),Ah);JF(act(),Ah);JF(oct(),Ah);JF(lct(),Ah);var zXt=pct();Object.defineProperty(Ah,"createExportTraceServiceRequest",{enumerable:!0,get:function(){return zXt.createExportTraceServiceRequest}});var $Xt=vct();Object.defineProperty(Ah,"createExportMetricsServiceRequest",{enumerable:!0,get:function(){return $Xt.createExportMetricsServiceRequest}});var WXt=Tct();Object.defineProperty(Ah,"createExportLogsServiceRequest",{enumerable:!0,get:function(){return WXt.createExportLogsServiceRequest}})});var Ect=At(lue=>{"use strict";Object.defineProperty(lue,"__esModule",{value:!0});lue.VERSION=void 0;lue.VERSION="0.51.1"});var Cct=At(_ue=>{"use strict";Object.defineProperty(_ue,"__esModule",{value:!0});_ue.OTLPMetricExporter=void 0;var qF=p0(),GXt=ADe(),uue=BDe(),HXt=bct(),YXt=Ect(),xct="v1/metrics",XXt=`http://localhost:4318/${xct}`,KXt={"User-Agent":`OTel-OTLP-Exporter-JavaScript/${YXt.VERSION}`},WDe=class extends uue.OTLPExporterNodeBase{constructor(c){super(c),this.headers=Object.assign(Object.assign(Object.assign(Object.assign({},this.headers),KXt),qF.baggageUtils.parseKeyPairsIntoRecord((0,qF.getEnv)().OTEL_EXPORTER_OTLP_METRICS_HEADERS)),(0,uue.parseHeaders)(c?.headers))}convert(c){return(0,HXt.createExportMetricsServiceRequest)(c,{useLongBits:!1})}getDefaultUrl(c){return typeof c.url=="string"?c.url:(0,qF.getEnv)().OTEL_EXPORTER_OTLP_METRICS_ENDPOINT.length>0?(0,uue.appendRootPathToUrlIfNeeded)((0,qF.getEnv)().OTEL_EXPORTER_OTLP_METRICS_ENDPOINT):(0,qF.getEnv)().OTEL_EXPORTER_OTLP_ENDPOINT.length>0?(0,uue.appendResourcePathToUrl)((0,qF.getEnv)().OTEL_EXPORTER_OTLP_ENDPOINT,xct):XXt}},GDe=class extends GXt.OTLPMetricExporterBase{constructor(c){super(new WDe(c),c)}};_ue.OTLPMetricExporter=GDe});var Act=At(e3=>{"use strict";var QXt=e3&&e3.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),ZXt=e3&&e3.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&QXt(c,u,f)};Object.defineProperty(e3,"__esModule",{value:!0});ZXt(Cct(),e3)});var kct=At(t3=>{"use strict";var eKt=t3&&t3.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),tKt=t3&&t3.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&eKt(c,u,f)};Object.defineProperty(t3,"__esModule",{value:!0});tKt(Act(),t3)});var Pct=At(bP=>{"use strict";var rKt=bP&&bP.__createBinding||(Object.create?function(u,c,f,v){v===void 0&&(v=f),Object.defineProperty(u,v,{enumerable:!0,get:function(){return c[f]}})}:function(u,c,f,v){v===void 0&&(v=f),u[v]=c[f]}),HDe=bP&&bP.__exportStar||function(u,c){for(var f in u)f!=="default"&&!Object.prototype.hasOwnProperty.call(c,f)&&rKt(c,u,f)};Object.defineProperty(bP,"__esModule",{value:!0});HDe(kct(),bP);HDe(xDe(),bP);HDe(ADe(),bP)});var vW=At(Ku=>{"use strict";Object.defineProperty(Ku,"__esModule",{value:!0});Ku.regexpCode=Ku.getEsmExportName=Ku.getProperty=Ku.safeStringify=Ku.stringify=Ku.strConcat=Ku.addCodeArg=Ku.str=Ku._=Ku.nil=Ku._Code=Ku.Name=Ku.IDENTIFIER=Ku._CodeOrName=void 0;var hW=class{};Ku._CodeOrName=hW;Ku.IDENTIFIER=/^[a-z$_][a-z$_0-9]*$/i;var r3=class extends hW{constructor(c){if(super(),!Ku.IDENTIFIER.test(c))throw new Error("CodeGen: name must be a valid identifier");this.str=c}toString(){return this.str}emptyStr(){return!1}get names(){return{[this.str]:1}}};Ku.Name=r3;var Ab=class extends hW{constructor(c){super(),this._items=typeof c=="string"?[c]:c}toString(){return this.str}emptyStr(){if(this._items.length>1)return!1;let c=this._items[0];return c===""||c==='""'}get str(){var c;return(c=this._str)!==null&&c!==void 0?c:this._str=this._items.reduce((f,v)=>`${f}${v}`,"")}get names(){var c;return(c=this._names)!==null&&c!==void 0?c:this._names=this._items.reduce((f,v)=>(v instanceof r3&&(f[v.str]=(f[v.str]||0)+1),f),{})}};Ku._Code=Ab;Ku.nil=new Ab("");function Dct(u,...c){let f=[u[0]],v=0;for(;v<c.length;)XDe(f,c[v]),f.push(u[++v]);return new Ab(f)}Ku._=Dct;var YDe=new Ab("+");function Ict(u,...c){let f=[yW(u[0])],v=0;for(;v<c.length;)f.push(YDe),XDe(f,c[v]),f.push(YDe,yW(u[++v]));return nKt(f),new Ab(f)}Ku.str=Ict;function XDe(u,c){c instanceof Ab?u.push(...c._items):c instanceof r3?u.push(c):u.push(aKt(c))}Ku.addCodeArg=XDe;function nKt(u){let c=1;for(;c<u.length-1;){if(u[c]===YDe){let f=iKt(u[c-1],u[c+1]);if(f!==void 0){u.splice(c-1,3,f);continue}u[c++]="+"}c++}}function iKt(u,c){if(c==='""')return u;if(u==='""')return c;if(typeof u=="string")return c instanceof r3||u[u.length-1]!=='"'?void 0:typeof c!="string"?`${u.slice(0,-1)}${c}"`:c[0]==='"'?u.slice(0,-1)+c.slice(1):void 0;if(typeof c=="string"&&c[0]==='"'&&!(u instanceof r3))return`"${u}${c.slice(1)}`}function sKt(u,c){return c.emptyStr()?u:u.emptyStr()?c:Ict`${u}${c}`}Ku.strConcat=sKt;function aKt(u){return typeof u=="number"||typeof u=="boolean"||u===null?u:yW(Array.isArray(u)?u.join(","):u)}function oKt(u){return new Ab(yW(u))}Ku.stringify=oKt;function yW(u){return JSON.stringify(u).replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029")}Ku.safeStringify=yW;function cKt(u){return typeof u=="string"&&Ku.IDENTIFIER.test(u)?new Ab(`.${u}`):Dct`[${u}]`}Ku.getProperty=cKt;function lKt(u){if(typeof u=="string"&&Ku.IDENTIFIER.test(u))return new Ab(`${u}`);throw new Error(`CodeGen: invalid export name: ${u}, use explicit $id name mapping`)}Ku.getEsmExportName=lKt;function uKt(u){return new Ab(u.toString())}Ku.regexpCode=uKt});var ZDe=At(gv=>{"use strict";Object.defineProperty(gv,"__esModule",{value:!0});gv.ValueScope=gv.ValueScopeName=gv.Scope=gv.varKinds=gv.UsedValueState=void 0;var mv=vW(),KDe=class extends Error{constructor(c){super(`CodeGen: "code" for ${c} not defined`),this.value=c.value}},fue;(function(u){u[u.Started=0]="Started",u[u.Completed=1]="Completed"})(fue||(gv.UsedValueState=fue={}));gv.varKinds={const:new mv.Name("const"),let:new mv.Name("let"),var:new mv.Name("var")};var pue=class{constructor({prefixes:c,parent:f}={}){this._names={},this._prefixes=c,this._parent=f}toName(c){return c instanceof mv.Name?c:this.name(c)}name(c){return new mv.Name(this._newName(c))}_newName(c){let f=this._names[c]||this._nameGroup(c);return`${c}${f.index++}`}_nameGroup(c){var f,v;if(!((v=(f=this._parent)===null||f===void 0?void 0:f._prefixes)===null||v===void 0)&&v.has(c)||this._prefixes&&!this._prefixes.has(c))throw new Error(`CodeGen: prefix "${c}" is not allowed in this scope`);return this._names[c]={prefix:c,index:0}}};gv.Scope=pue;var due=class extends mv.Name{constructor(c,f){super(f),this.prefix=c}setValue(c,{property:f,itemIndex:v}){this.value=c,this.scopePath=(0,mv._)`.${new mv.Name(f)}[${v}]`}};gv.ValueScopeName=due;var _Kt=(0,mv._)`\n`,QDe=class extends pue{constructor(c){super(c),this._values={},this._scope=c.scope,this.opts={...c,_n:c.lines?_Kt:mv.nil}}get(){return this._scope}name(c){return new due(c,this._newName(c))}value(c,f){var v;if(f.ref===void 0)throw new Error("CodeGen: ref must be passed in value");let x=this.toName(c),{prefix:w}=x,F=(v=f.key)!==null&&v!==void 0?v:f.ref,ee=this._values[w];if(ee){let Te=ee.get(F);if(Te)return Te}else ee=this._values[w]=new Map;ee.set(F,x);let me=this._scope[w]||(this._scope[w]=[]),de=me.length;return me[de]=f.ref,x.setValue(f,{property:w,itemIndex:de}),x}getValue(c,f){let v=this._values[c];if(v)return v.get(f)}scopeRefs(c,f=this._values){return this._reduceValues(f,v=>{if(v.scopePath===void 0)throw new Error(`CodeGen: name "${v}" has no value`);return(0,mv._)`${c}${v.scopePath}`})}scopeCode(c=this._values,f,v){return this._reduceValues(c,x=>{if(x.value===void 0)throw new Error(`CodeGen: name "${x}" has no value`);return x.value.code},f,v)}_reduceValues(c,f,v={},x){let w=mv.nil;for(let F in c){let ee=c[F];if(!ee)continue;let me=v[F]=v[F]||new Map;ee.forEach(de=>{if(me.has(de))return;me.set(de,fue.Started);let Te=f(de);if(Te){let ut=this.opts.es5?gv.varKinds.var:gv.varKinds.const;w=(0,mv._)`${w}${ut} ${de} = ${Te};${this.opts._n}`}else if(Te=x?.(de))w=(0,mv._)`${w}${Te}${this.opts._n}`;else throw new KDe(de);me.set(de,fue.Completed)})}return w}};gv.ValueScope=QDe});var Hl=At(Ol=>{"use strict";Object.defineProperty(Ol,"__esModule",{value:!0});Ol.or=Ol.and=Ol.not=Ol.CodeGen=Ol.operators=Ol.varKinds=Ol.ValueScopeName=Ol.ValueScope=Ol.Scope=Ol.Name=Ol.regexpCode=Ol.stringify=Ol.getProperty=Ol.nil=Ol.strConcat=Ol.str=Ol._=void 0;var Au=vW(),h2=ZDe(),ZI=vW();Object.defineProperty(Ol,"_",{enumerable:!0,get:function(){return ZI._}});Object.defineProperty(Ol,"str",{enumerable:!0,get:function(){return ZI.str}});Object.defineProperty(Ol,"strConcat",{enumerable:!0,get:function(){return ZI.strConcat}});Object.defineProperty(Ol,"nil",{enumerable:!0,get:function(){return ZI.nil}});Object.defineProperty(Ol,"getProperty",{enumerable:!0,get:function(){return ZI.getProperty}});Object.defineProperty(Ol,"stringify",{enumerable:!0,get:function(){return ZI.stringify}});Object.defineProperty(Ol,"regexpCode",{enumerable:!0,get:function(){return ZI.regexpCode}});Object.defineProperty(Ol,"Name",{enumerable:!0,get:function(){return ZI.Name}});var yue=ZDe();Object.defineProperty(Ol,"Scope",{enumerable:!0,get:function(){return yue.Scope}});Object.defineProperty(Ol,"ValueScope",{enumerable:!0,get:function(){return yue.ValueScope}});Object.defineProperty(Ol,"ValueScopeName",{enumerable:!0,get:function(){return yue.ValueScopeName}});Object.defineProperty(Ol,"varKinds",{enumerable:!0,get:function(){return yue.varKinds}});Ol.operators={GT:new Au._Code(">"),GTE:new Au._Code(">="),LT:new Au._Code("<"),LTE:new Au._Code("<="),EQ:new Au._Code("==="),NEQ:new Au._Code("!=="),NOT:new Au._Code("!"),OR:new Au._Code("||"),AND:new Au._Code("&&"),ADD:new Au._Code("+")};var EP=class{optimizeNodes(){return this}optimizeNames(c,f){return this}},eIe=class extends EP{constructor(c,f,v){super(),this.varKind=c,this.name=f,this.rhs=v}render({es5:c,_n:f}){let v=c?h2.varKinds.var:this.varKind,x=this.rhs===void 0?"":` = ${this.rhs}`;return`${v} ${this.name}${x};`+f}optimizeNames(c,f){if(c[this.name.str])return this.rhs&&(this.rhs=$F(this.rhs,c,f)),this}get names(){return this.rhs instanceof Au._CodeOrName?this.rhs.names:{}}},mue=class extends EP{constructor(c,f,v){super(),this.lhs=c,this.rhs=f,this.sideEffects=v}render({_n:c}){return`${this.lhs} = ${this.rhs};`+c}optimizeNames(c,f){if(!(this.lhs instanceof Au.Name&&!c[this.lhs.str]&&!this.sideEffects))return this.rhs=$F(this.rhs,c,f),this}get names(){let c=this.lhs instanceof Au.Name?{}:{...this.lhs.names};return hue(c,this.rhs)}},tIe=class extends mue{constructor(c,f,v,x){super(c,v,x),this.op=f}render({_n:c}){return`${this.lhs} ${this.op}= ${this.rhs};`+c}},rIe=class extends EP{constructor(c){super(),this.label=c,this.names={}}render({_n:c}){return`${this.label}:`+c}},nIe=class extends EP{constructor(c){super(),this.label=c,this.names={}}render({_n:c}){return`break${this.label?` ${this.label}`:""};`+c}},iIe=class extends EP{constructor(c){super(),this.error=c}render({_n:c}){return`throw ${this.error};`+c}get names(){return this.error.names}},sIe=class extends EP{constructor(c){super(),this.code=c}render({_n:c}){return`${this.code};`+c}optimizeNodes(){return`${this.code}`?this:void 0}optimizeNames(c,f){return this.code=$F(this.code,c,f),this}get names(){return this.code instanceof Au._CodeOrName?this.code.names:{}}},SW=class extends EP{constructor(c=[]){super(),this.nodes=c}render(c){return this.nodes.reduce((f,v)=>f+v.render(c),"")}optimizeNodes(){let{nodes:c}=this,f=c.length;for(;f--;){let v=c[f].optimizeNodes();Array.isArray(v)?c.splice(f,1,...v):v?c[f]=v:c.splice(f,1)}return c.length>0?this:void 0}optimizeNames(c,f){let{nodes:v}=this,x=v.length;for(;x--;){let w=v[x];w.optimizeNames(c,f)||(fKt(c,w.names),v.splice(x,1))}return v.length>0?this:void 0}get names(){return this.nodes.reduce((c,f)=>s3(c,f.names),{})}},xP=class extends SW{render(c){return"{"+c._n+super.render(c)+"}"+c._n}},aIe=class extends SW{},zF=class extends xP{};zF.kind="else";var n3=class u extends xP{constructor(c,f){super(f),this.condition=c}render(c){let f=`if(${this.condition})`+super.render(c);return this.else&&(f+="else "+this.else.render(c)),f}optimizeNodes(){super.optimizeNodes();let c=this.condition;if(c===!0)return this.nodes;let f=this.else;if(f){let v=f.optimizeNodes();f=this.else=Array.isArray(v)?new zF(v):v}if(f)return c===!1?f instanceof u?f:f.nodes:this.nodes.length?this:new u(wct(c),f instanceof u?[f]:f.nodes);if(!(c===!1||!this.nodes.length))return this}optimizeNames(c,f){var v;if(this.else=(v=this.else)===null||v===void 0?void 0:v.optimizeNames(c,f),!!(super.optimizeNames(c,f)||this.else))return this.condition=$F(this.condition,c,f),this}get names(){let c=super.names;return hue(c,this.condition),this.else&&s3(c,this.else.names),c}};n3.kind="if";var i3=class extends xP{};i3.kind="for";var oIe=class extends i3{constructor(c){super(),this.iteration=c}render(c){return`for(${this.iteration})`+super.render(c)}optimizeNames(c,f){if(super.optimizeNames(c,f))return this.iteration=$F(this.iteration,c,f),this}get names(){return s3(super.names,this.iteration.names)}},cIe=class extends i3{constructor(c,f,v,x){super(),this.varKind=c,this.name=f,this.from=v,this.to=x}render(c){let f=c.es5?h2.varKinds.var:this.varKind,{name:v,from:x,to:w}=this;return`for(${f} ${v}=${x}; ${v}<${w}; ${v}++)`+super.render(c)}get names(){let c=hue(super.names,this.from);return hue(c,this.to)}},gue=class extends i3{constructor(c,f,v,x){super(),this.loop=c,this.varKind=f,this.name=v,this.iterable=x}render(c){return`for(${this.varKind} ${this.name} ${this.loop} ${this.iterable})`+super.render(c)}optimizeNames(c,f){if(super.optimizeNames(c,f))return this.iterable=$F(this.iterable,c,f),this}get names(){return s3(super.names,this.iterable.names)}},TW=class extends xP{constructor(c,f,v){super(),this.name=c,this.args=f,this.async=v}render(c){return`${this.async?"async ":""}function ${this.name}(${this.args})`+super.render(c)}};TW.kind="func";var bW=class extends SW{render(c){return"return "+super.render(c)}};bW.kind="return";var lIe=class extends xP{render(c){let f="try"+super.render(c);return this.catch&&(f+=this.catch.render(c)),this.finally&&(f+=this.finally.render(c)),f}optimizeNodes(){var c,f;return super.optimizeNodes(),(c=this.catch)===null||c===void 0||c.optimizeNodes(),(f=this.finally)===null||f===void 0||f.optimizeNodes(),this}optimizeNames(c,f){var v,x;return super.optimizeNames(c,f),(v=this.catch)===null||v===void 0||v.optimizeNames(c,f),(x=this.finally)===null||x===void 0||x.optimizeNames(c,f),this}get names(){let c=super.names;return this.catch&&s3(c,this.catch.names),this.finally&&s3(c,this.finally.names),c}},EW=class extends xP{constructor(c){super(),this.error=c}render(c){return`catch(${this.error})`+super.render(c)}};EW.kind="catch";var xW=class extends xP{render(c){return"finally"+super.render(c)}};xW.kind="finally";var uIe=class{constructor(c,f={}){this._values={},this._blockStarts=[],this._constants={},this.opts={...f,_n:f.lines?`
`:""},this._extScope=c,this._scope=new h2.Scope({parent:c}),this._nodes=[new aIe]}toString(){return this._root.render(this.opts)}name(c){return this._scope.name(c)}scopeName(c){return this._extScope.name(c)}scopeValue(c,f){let v=this._extScope.value(c,f);return(this._values[v.prefix]||(this._values[v.prefix]=new Set)).add(v),v}getScopeValue(c,f){return this._extScope.getValue(c,f)}scopeRefs(c){return this._extScope.scopeRefs(c,this._values)}scopeCode(){return this._extScope.scopeCode(this._values)}_def(c,f,v,x){let w=this._scope.toName(f);return v!==void 0&&x&&(this._constants[w.str]=v),this._leafNode(new eIe(c,w,v)),w}const(c,f,v){return this._def(h2.varKinds.const,c,f,v)}let(c,f,v){return this._def(h2.varKinds.let,c,f,v)}var(c,f,v){return this._def(h2.varKinds.var,c,f,v)}assign(c,f,v){return this._leafNode(new mue(c,f,v))}add(c,f){return this._leafNode(new tIe(c,Ol.operators.ADD,f))}code(c){return typeof c=="function"?c():c!==Au.nil&&this._leafNode(new sIe(c)),this}object(...c){let f=["{"];for(let[v,x]of c)f.length>1&&f.push(","),f.push(v),(v!==x||this.opts.es5)&&(f.push(":"),(0,Au.addCodeArg)(f,x));return f.push("}"),new Au._Code(f)}if(c,f,v){if(this._blockNode(new n3(c)),f&&v)this.code(f).else().code(v).endIf();else if(f)this.code(f).endIf();else if(v)throw new Error('CodeGen: "else" body without "then" body');return this}elseIf(c){return this._elseNode(new n3(c))}else(){return this._elseNode(new zF)}endIf(){return this._endBlockNode(n3,zF)}_for(c,f){return this._blockNode(c),f&&this.code(f).endFor(),this}for(c,f){return this._for(new oIe(c),f)}forRange(c,f,v,x,w=this.opts.es5?h2.varKinds.var:h2.varKinds.let){let F=this._scope.toName(c);return this._for(new cIe(w,F,f,v),()=>x(F))}forOf(c,f,v,x=h2.varKinds.const){let w=this._scope.toName(c);if(this.opts.es5){let F=f instanceof Au.Name?f:this.var("_arr",f);return this.forRange("_i",0,(0,Au._)`${F}.length`,ee=>{this.var(w,(0,Au._)`${F}[${ee}]`),v(w)})}return this._for(new gue("of",x,w,f),()=>v(w))}forIn(c,f,v,x=this.opts.es5?h2.varKinds.var:h2.varKinds.const){if(this.opts.ownProperties)return this.forOf(c,(0,Au._)`Object.keys(${f})`,v);let w=this._scope.toName(c);return this._for(new gue("in",x,w,f),()=>v(w))}endFor(){return this._endBlockNode(i3)}label(c){return this._leafNode(new rIe(c))}break(c){return this._leafNode(new nIe(c))}return(c){let f=new bW;if(this._blockNode(f),this.code(c),f.nodes.length!==1)throw new Error('CodeGen: "return" should have one node');return this._endBlockNode(bW)}try(c,f,v){if(!f&&!v)throw new Error('CodeGen: "try" without "catch" and "finally"');let x=new lIe;if(this._blockNode(x),this.code(c),f){let w=this.name("e");this._currNode=x.catch=new EW(w),f(w)}return v&&(this._currNode=x.finally=new xW,this.code(v)),this._endBlockNode(EW,xW)}throw(c){return this._leafNode(new iIe(c))}block(c,f){return this._blockStarts.push(this._nodes.length),c&&this.code(c).endBlock(f),this}endBlock(c){let f=this._blockStarts.pop();if(f===void 0)throw new Error("CodeGen: not in self-balancing block");let v=this._nodes.length-f;if(v<0||c!==void 0&&v!==c)throw new Error(`CodeGen: wrong number of nodes: ${v} vs ${c} expected`);return this._nodes.length=f,this}func(c,f=Au.nil,v,x){return this._blockNode(new TW(c,f,v)),x&&this.code(x).endFunc(),this}endFunc(){return this._endBlockNode(TW)}optimize(c=1){for(;c-- >0;)this._root.optimizeNodes(),this._root.optimizeNames(this._root.names,this._constants)}_leafNode(c){return this._currNode.nodes.push(c),this}_blockNode(c){this._currNode.nodes.push(c),this._nodes.push(c)}_endBlockNode(c,f){let v=this._currNode;if(v instanceof c||f&&v instanceof f)return this._nodes.pop(),this;throw new Error(`CodeGen: not in block "${f?`${c.kind}/${f.kind}`:c.kind}"`)}_elseNode(c){let f=this._currNode;if(!(f instanceof n3))throw new Error('CodeGen: "else" without "if"');return this._currNode=f.else=c,this}get _root(){return this._nodes[0]}get _currNode(){let c=this._nodes;return c[c.length-1]}set _currNode(c){let f=this._nodes;f[f.length-1]=c}};Ol.CodeGen=uIe;function s3(u,c){for(let f in c)u[f]=(u[f]||0)+(c[f]||0);return u}function hue(u,c){return c instanceof Au._CodeOrName?s3(u,c.names):u}function $F(u,c,f){if(u instanceof Au.Name)return v(u);if(!x(u))return u;return new Au._Code(u._items.reduce((w,F)=>(F instanceof Au.Name&&(F=v(F)),F instanceof Au._Code?w.push(...F._items):w.push(F),w),[]));function v(w){let F=f[w.str];return F===void 0||c[w.str]!==1?w:(delete c[w.str],F)}function x(w){return w instanceof Au._Code&&w._items.some(F=>F instanceof Au.Name&&c[F.str]===1&&f[F.str]!==void 0)}}function fKt(u,c){for(let f in c)u[f]=(u[f]||0)-(c[f]||0)}function wct(u){return typeof u=="boolean"||typeof u=="number"||u===null?!u:(0,Au._)`!${_Ie(u)}`}Ol.not=wct;var pKt=Oct(Ol.operators.AND);function dKt(...u){return u.reduce(pKt)}Ol.and=dKt;var mKt=Oct(Ol.operators.OR);function gKt(...u){return u.reduce(mKt)}Ol.or=gKt;function Oct(u){return(c,f)=>c===Au.nil?f:f===Au.nil?c:(0,Au._)`${_Ie(c)} ${u} ${_Ie(f)}`}function _Ie(u){return u instanceof Au.Name?u:(0,Au._)`(${u})`}});var Qu=At(Yl=>{"use strict";Object.defineProperty(Yl,"__esModule",{value:!0});Yl.checkStrictMode=Yl.getErrorPath=Yl.Type=Yl.useFunc=Yl.setEvaluated=Yl.evaluatedPropsToName=Yl.mergeEvaluated=Yl.eachItem=Yl.unescapeJsonPointer=Yl.escapeJsonPointer=Yl.escapeFragment=Yl.unescapeFragment=Yl.schemaRefOrVal=Yl.schemaHasRulesButRef=Yl.schemaHasRules=Yl.checkUnknownRules=Yl.alwaysValidSchema=Yl.toHash=void 0;var Vf=Hl(),hKt=vW();function yKt(u){let c={};for(let f of u)c[f]=!0;return c}Yl.toHash=yKt;function vKt(u,c){return typeof c=="boolean"?c:Object.keys(c).length===0?!0:(Lct(u,c),!Fct(c,u.self.RULES.all))}Yl.alwaysValidSchema=vKt;function Lct(u,c=u.schema){let{opts:f,self:v}=u;if(!f.strictSchema||typeof c=="boolean")return;let x=v.RULES.keywords;for(let w in c)x[w]||Uct(u,`unknown keyword: "${w}"`)}Yl.checkUnknownRules=Lct;function Fct(u,c){if(typeof u=="boolean")return!u;for(let f in u)if(c[f])return!0;return!1}Yl.schemaHasRules=Fct;function SKt(u,c){if(typeof u=="boolean")return!u;for(let f in u)if(f!=="$ref"&&c.all[f])return!0;return!1}Yl.schemaHasRulesButRef=SKt;function TKt({topSchemaRef:u,schemaPath:c},f,v,x){if(!x){if(typeof f=="number"||typeof f=="boolean")return f;if(typeof f=="string")return(0,Vf._)`${f}`}return(0,Vf._)`${u}${c}${(0,Vf.getProperty)(v)}`}Yl.schemaRefOrVal=TKt;function bKt(u){return jct(decodeURIComponent(u))}Yl.unescapeFragment=bKt;function EKt(u){return encodeURIComponent(pIe(u))}Yl.escapeFragment=EKt;function pIe(u){return typeof u=="number"?`${u}`:u.replace(/~/g,"~0").replace(/\//g,"~1")}Yl.escapeJsonPointer=pIe;function jct(u){return u.replace(/~1/g,"/").replace(/~0/g,"~")}Yl.unescapeJsonPointer=jct;function xKt(u,c){if(Array.isArray(u))for(let f of u)c(f);else c(u)}Yl.eachItem=xKt;function Rct({mergeNames:u,mergeToName:c,mergeValues:f,resultToName:v}){return(x,w,F,ee)=>{let me=F===void 0?w:F instanceof Vf.Name?(w instanceof Vf.Name?u(x,w,F):c(x,w,F),F):w instanceof Vf.Name?(c(x,F,w),w):f(w,F);return ee===Vf.Name&&!(me instanceof Vf.Name)?v(x,me):me}}Yl.mergeEvaluated={props:Rct({mergeNames:(u,c,f)=>u.if((0,Vf._)`${f} !== true && ${c} !== undefined`,()=>{u.if((0,Vf._)`${c} === true`,()=>u.assign(f,!0),()=>u.assign(f,(0,Vf._)`${f} || {}`).code((0,Vf._)`Object.assign(${f}, ${c})`))}),mergeToName:(u,c,f)=>u.if((0,Vf._)`${f} !== true`,()=>{c===!0?u.assign(f,!0):(u.assign(f,(0,Vf._)`${f} || {}`),dIe(u,f,c))}),mergeValues:(u,c)=>u===!0?!0:{...u,...c},resultToName:Bct}),items:Rct({mergeNames:(u,c,f)=>u.if((0,Vf._)`${f} !== true && ${c} !== undefined`,()=>u.assign(f,(0,Vf._)`${c} === true ? true : ${f} > ${c} ? ${f} : ${c}`)),mergeToName:(u,c,f)=>u.if((0,Vf._)`${f} !== true`,()=>u.assign(f,c===!0?!0:(0,Vf._)`${f} > ${c} ? ${f} : ${c}`)),mergeValues:(u,c)=>u===!0?!0:Math.max(u,c),resultToName:(u,c)=>u.var("items",c)})};function Bct(u,c){if(c===!0)return u.var("props",!0);let f=u.var("props",(0,Vf._)`{}`);return c!==void 0&&dIe(u,f,c),f}Yl.evaluatedPropsToName=Bct;function dIe(u,c,f){Object.keys(f).forEach(v=>u.assign((0,Vf._)`${c}${(0,Vf.getProperty)(v)}`,!0))}Yl.setEvaluated=dIe;var Mct={};function CKt(u,c){return u.scopeValue("func",{ref:c,code:Mct[c.code]||(Mct[c.code]=new hKt._Code(c.code))})}Yl.useFunc=CKt;var fIe;(function(u){u[u.Num=0]="Num",u[u.Str=1]="Str"})(fIe||(Yl.Type=fIe={}));function AKt(u,c,f){if(u instanceof Vf.Name){let v=c===fIe.Num;return f?v?(0,Vf._)`"[" + ${u} + "]"`:(0,Vf._)`"['" + ${u} + "']"`:v?(0,Vf._)`"/" + ${u}`:(0,Vf._)`"/" + ${u}.replace(/~/g, "~0").replace(/\\//g, "~1")`}return f?(0,Vf.getProperty)(u).toString():"/"+pIe(u)}Yl.getErrorPath=AKt;function Uct(u,c,f=u.opts.strictSchema){if(f){if(c=`strict mode: ${c}`,f===!0)throw new Error(c);u.self.logger.warn(c)}}Yl.checkStrictMode=Uct});var CP=At(mIe=>{"use strict";Object.defineProperty(mIe,"__esModule",{value:!0});var cy=Hl(),kKt={data:new cy.Name("data"),valCxt:new cy.Name("valCxt"),instancePath:new cy.Name("instancePath"),parentData:new cy.Name("parentData"),parentDataProperty:new cy.Name("parentDataProperty"),rootData:new cy.Name("rootData"),dynamicAnchors:new cy.Name("dynamicAnchors"),vErrors:new cy.Name("vErrors"),errors:new cy.Name("errors"),this:new cy.Name("this"),self:new cy.Name("self"),scope:new cy.Name("scope"),json:new cy.Name("json"),jsonPos:new cy.Name("jsonPos"),jsonLen:new cy.Name("jsonLen"),jsonPart:new cy.Name("jsonPart")};mIe.default=kKt});var CW=At(ly=>{"use strict";Object.defineProperty(ly,"__esModule",{value:!0});ly.extendErrors=ly.resetErrorsCount=ly.reportExtraError=ly.reportError=ly.keyword$DataError=ly.keywordError=void 0;var Uu=Hl(),vue=Qu(),u1=CP();ly.keywordError={message:({keyword:u})=>(0,Uu.str)`must pass "${u}" keyword validation`};ly.keyword$DataError={message:({keyword:u,schemaType:c})=>c?(0,Uu.str)`"${u}" keyword must be ${c} ($data)`:(0,Uu.str)`"${u}" keyword is invalid ($data)`};function PKt(u,c=ly.keywordError,f,v){let{it:x}=u,{gen:w,compositeRule:F,allErrors:ee}=x,me=qct(u,c,f);v??(F||ee)?Vct(w,me):Jct(x,(0,Uu._)`[${me}]`)}ly.reportError=PKt;function NKt(u,c=ly.keywordError,f){let{it:v}=u,{gen:x,compositeRule:w,allErrors:F}=v,ee=qct(u,c,f);Vct(x,ee),w||F||Jct(v,u1.default.vErrors)}ly.reportExtraError=NKt;function DKt(u,c){u.assign(u1.default.errors,c),u.if((0,Uu._)`${u1.default.vErrors} !== null`,()=>u.if(c,()=>u.assign((0,Uu._)`${u1.default.vErrors}.length`,c),()=>u.assign(u1.default.vErrors,null)))}ly.resetErrorsCount=DKt;function IKt({gen:u,keyword:c,schemaValue:f,data:v,errsCount:x,it:w}){if(x===void 0)throw new Error("ajv implementation error");let F=u.name("err");u.forRange("i",x,u1.default.errors,ee=>{u.const(F,(0,Uu._)`${u1.default.vErrors}[${ee}]`),u.if((0,Uu._)`${F}.instancePath === undefined`,()=>u.assign((0,Uu._)`${F}.instancePath`,(0,Uu.strConcat)(u1.default.instancePath,w.errorPath))),u.assign((0,Uu._)`${F}.schemaPath`,(0,Uu.str)`${w.errSchemaPath}/${c}`),w.opts.verbose&&(u.assign((0,Uu._)`${F}.schema`,f),u.assign((0,Uu._)`${F}.data`,v))})}ly.extendErrors=IKt;function Vct(u,c){let f=u.const("err",c);u.if((0,Uu._)`${u1.default.vErrors} === null`,()=>u.assign(u1.default.vErrors,(0,Uu._)`[${f}]`),(0,Uu._)`${u1.default.vErrors}.push(${f})`),u.code((0,Uu._)`${u1.default.errors}++`)}function Jct(u,c){let{gen:f,validateName:v,schemaEnv:x}=u;x.$async?f.throw((0,Uu._)`new ${u.ValidationError}(${c})`):(f.assign((0,Uu._)`${v}.errors`,c),f.return(!1))}var a3={keyword:new Uu.Name("keyword"),schemaPath:new Uu.Name("schemaPath"),params:new Uu.Name("params"),propertyName:new Uu.Name("propertyName"),message:new Uu.Name("message"),schema:new Uu.Name("schema"),parentSchema:new Uu.Name("parentSchema")};function qct(u,c,f){let{createErrors:v}=u.it;return v===!1?(0,Uu._)`{}`:wKt(u,c,f)}function wKt(u,c,f={}){let{gen:v,it:x}=u,w=[OKt(x,f),RKt(u,f)];return MKt(u,c,w),v.object(...w)}function OKt({errorPath:u},{instancePath:c}){let f=c?(0,Uu.str)`${u}${(0,vue.getErrorPath)(c,vue.Type.Str)}`:u;return[u1.default.instancePath,(0,Uu.strConcat)(u1.default.instancePath,f)]}function RKt({keyword:u,it:{errSchemaPath:c}},{schemaPath:f,parentSchema:v}){let x=v?c:(0,Uu.str)`${c}/${u}`;return f&&(x=(0,Uu.str)`${x}${(0,vue.getErrorPath)(f,vue.Type.Str)}`),[a3.schemaPath,x]}function MKt(u,{params:c,message:f},v){let{keyword:x,data:w,schemaValue:F,it:ee}=u,{opts:me,propertyName:de,topSchemaRef:Te,schemaPath:ut}=ee;v.push([a3.keyword,x],[a3.params,typeof c=="function"?c(u):c||(0,Uu._)`{}`]),me.messages&&v.push([a3.message,typeof f=="function"?f(u):f]),me.verbose&&v.push([a3.schema,F],[a3.parentSchema,(0,Uu._)`${Te}${ut}`],[u1.default.data,w]),de&&v.push([a3.propertyName,de])}});var $ct=At(WF=>{"use strict";Object.defineProperty(WF,"__esModule",{value:!0});WF.boolOrEmptySchema=WF.topBoolOrEmptySchema=void 0;var LKt=CW(),FKt=Hl(),jKt=CP(),BKt={message:"boolean schema is false"};function UKt(u){let{gen:c,schema:f,validateName:v}=u;f===!1?zct(u,!1):typeof f=="object"&&f.$async===!0?c.return(jKt.default.data):(c.assign((0,FKt._)`${v}.errors`,null),c.return(!0))}WF.topBoolOrEmptySchema=UKt;function VKt(u,c){let{gen:f,schema:v}=u;v===!1?(f.var(c,!1),zct(u)):f.var(c,!0)}WF.boolOrEmptySchema=VKt;function zct(u,c){let{gen:f,data:v}=u,x={gen:f,keyword:"false schema",data:v,schema:!1,schemaCode:!1,schemaValue:!1,params:{},it:u};(0,LKt.reportError)(x,BKt,void 0,c)}});var gIe=At(GF=>{"use strict";Object.defineProperty(GF,"__esModule",{value:!0});GF.getRules=GF.isJSONType=void 0;var JKt=["string","number","integer","boolean","null","object","array"],qKt=new Set(JKt);function zKt(u){return typeof u=="string"&&qKt.has(u)}GF.isJSONType=zKt;function $Kt(){let u={number:{type:"number",rules:[]},string:{type:"string",rules:[]},array:{type:"array",rules:[]},object:{type:"object",rules:[]}};return{types:{...u,integer:!0,boolean:!0,null:!0},rules:[{rules:[]},u.number,u.string,u.array,u.object],post:{rules:[]},all:{},keywords:{}}}GF.getRules=$Kt});var hIe=At(ew=>{"use strict";Object.defineProperty(ew,"__esModule",{value:!0});ew.shouldUseRule=ew.shouldUseGroup=ew.schemaHasRulesForType=void 0;function WKt({schema:u,self:c},f){let v=c.RULES.types[f];return v&&v!==!0&&Wct(u,v)}ew.schemaHasRulesForType=WKt;function Wct(u,c){return c.rules.some(f=>Gct(u,f))}ew.shouldUseGroup=Wct;function Gct(u,c){var f;return u[c.keyword]!==void 0||((f=c.definition.implements)===null||f===void 0?void 0:f.some(v=>u[v]!==void 0))}ew.shouldUseRule=Gct});var AW=At(uy=>{"use strict";Object.defineProperty(uy,"__esModule",{value:!0});uy.reportTypeError=uy.checkDataTypes=uy.checkDataType=uy.coerceAndCheckDataType=uy.getJSONTypes=uy.getSchemaTypes=uy.DataType=void 0;var GKt=gIe(),HKt=hIe(),YKt=CW(),ml=Hl(),Hct=Qu(),HF;(function(u){u[u.Correct=0]="Correct",u[u.Wrong=1]="Wrong"})(HF||(uy.DataType=HF={}));function XKt(u){let c=Yct(u.type);if(c.includes("null")){if(u.nullable===!1)throw new Error("type: null contradicts nullable: false")}else{if(!c.length&&u.nullable!==void 0)throw new Error('"nullable" cannot be used without "type"');u.nullable===!0&&c.push("null")}return c}uy.getSchemaTypes=XKt;function Yct(u){let c=Array.isArray(u)?u:u?[u]:[];if(c.every(GKt.isJSONType))return c;throw new Error("type must be JSONType or JSONType[]: "+c.join(","))}uy.getJSONTypes=Yct;function KKt(u,c){let{gen:f,data:v,opts:x}=u,w=QKt(c,x.coerceTypes),F=c.length>0&&!(w.length===0&&c.length===1&&(0,HKt.schemaHasRulesForType)(u,c[0]));if(F){let ee=vIe(c,v,x.strictNumbers,HF.Wrong);f.if(ee,()=>{w.length?ZKt(u,c,w):SIe(u)})}return F}uy.coerceAndCheckDataType=KKt;var Xct=new Set(["string","number","integer","boolean","null"]);function QKt(u,c){return c?u.filter(f=>Xct.has(f)||c==="array"&&f==="array"):[]}function ZKt(u,c,f){let{gen:v,data:x,opts:w}=u,F=v.let("dataType",(0,ml._)`typeof ${x}`),ee=v.let("coerced",(0,ml._)`undefined`);w.coerceTypes==="array"&&v.if((0,ml._)`${F} == 'object' && Array.isArray(${x}) && ${x}.length == 1`,()=>v.assign(x,(0,ml._)`${x}[0]`).assign(F,(0,ml._)`typeof ${x}`).if(vIe(c,x,w.strictNumbers),()=>v.assign(ee,x))),v.if((0,ml._)`${ee} !== undefined`);for(let de of f)(Xct.has(de)||de==="array"&&w.coerceTypes==="array")&&me(de);v.else(),SIe(u),v.endIf(),v.if((0,ml._)`${ee} !== undefined`,()=>{v.assign(x,ee),eQt(u,ee)});function me(de){switch(de){case"string":v.elseIf((0,ml._)`${F} == "number" || ${F} == "boolean"`).assign(ee,(0,ml._)`"" + ${x}`).elseIf((0,ml._)`${x} === null`).assign(ee,(0,ml._)`""`);return;case"number":v.elseIf((0,ml._)`${F} == "boolean" || ${x} === null
              || (${F} == "string" && ${x} && ${x} == +${x})`).assign(ee,(0,ml._)`+${x}`);return;case"integer":v.elseIf((0,ml._)`${F} === "boolean" || ${x} === null
              || (${F} === "string" && ${x} && ${x} == +${x} && !(${x} % 1))`).assign(ee,(0,ml._)`+${x}`);return;case"boolean":v.elseIf((0,ml._)`${x} === "false" || ${x} === 0 || ${x} === null`).assign(ee,!1).elseIf((0,ml._)`${x} === "true" || ${x} === 1`).assign(ee,!0);return;case"null":v.elseIf((0,ml._)`${x} === "" || ${x} === 0 || ${x} === false`),v.assign(ee,null);return;case"array":v.elseIf((0,ml._)`${F} === "string" || ${F} === "number"
              || ${F} === "boolean" || ${x} === null`).assign(ee,(0,ml._)`[${x}]`)}}}function eQt({gen:u,parentData:c,parentDataProperty:f},v){u.if((0,ml._)`${c} !== undefined`,()=>u.assign((0,ml._)`${c}[${f}]`,v))}function yIe(u,c,f,v=HF.Correct){let x=v===HF.Correct?ml.operators.EQ:ml.operators.NEQ,w;switch(u){case"null":return(0,ml._)`${c} ${x} null`;case"array":w=(0,ml._)`Array.isArray(${c})`;break;case"object":w=(0,ml._)`${c} && typeof ${c} == "object" && !Array.isArray(${c})`;break;case"integer":w=F((0,ml._)`!(${c} % 1) && !isNaN(${c})`);break;case"number":w=F();break;default:return(0,ml._)`typeof ${c} ${x} ${u}`}return v===HF.Correct?w:(0,ml.not)(w);function F(ee=ml.nil){return(0,ml.and)((0,ml._)`typeof ${c} == "number"`,ee,f?(0,ml._)`isFinite(${c})`:ml.nil)}}uy.checkDataType=yIe;function vIe(u,c,f,v){if(u.length===1)return yIe(u[0],c,f,v);let x,w=(0,Hct.toHash)(u);if(w.array&&w.object){let F=(0,ml._)`typeof ${c} != "object"`;x=w.null?F:(0,ml._)`!${c} || ${F}`,delete w.null,delete w.array,delete w.object}else x=ml.nil;w.number&&delete w.integer;for(let F in w)x=(0,ml.and)(x,yIe(F,c,f,v));return x}uy.checkDataTypes=vIe;var tQt={message:({schema:u})=>`must be ${u}`,params:({schema:u,schemaValue:c})=>typeof u=="string"?(0,ml._)`{type: ${u}}`:(0,ml._)`{type: ${c}}`};function SIe(u){let c=rQt(u);(0,YKt.reportError)(c,tQt)}uy.reportTypeError=SIe;function rQt(u){let{gen:c,data:f,schema:v}=u,x=(0,Hct.schemaRefOrVal)(u,v,"type");return{gen:c,keyword:"type",data:f,schema:v.type,schemaCode:x,schemaValue:x,parentSchema:v,params:{},it:u}}});var Qct=At(Sue=>{"use strict";Object.defineProperty(Sue,"__esModule",{value:!0});Sue.assignDefaults=void 0;var YF=Hl(),nQt=Qu();function iQt(u,c){let{properties:f,items:v}=u.schema;if(c==="object"&&f)for(let x in f)Kct(u,x,f[x].default);else c==="array"&&Array.isArray(v)&&v.forEach((x,w)=>Kct(u,w,x.default))}Sue.assignDefaults=iQt;function Kct(u,c,f){let{gen:v,compositeRule:x,data:w,opts:F}=u;if(f===void 0)return;let ee=(0,YF._)`${w}${(0,YF.getProperty)(c)}`;if(x){(0,nQt.checkStrictMode)(u,`default is ignored for: ${ee}`);return}let me=(0,YF._)`${ee} === undefined`;F.useDefaults==="empty"&&(me=(0,YF._)`${me} || ${ee} === null || ${ee} === ""`),v.if(me,(0,YF._)`${ee} = ${(0,YF.stringify)(f)}`)}});var kb=At(xf=>{"use strict";Object.defineProperty(xf,"__esModule",{value:!0});xf.validateUnion=xf.validateArray=xf.usePattern=xf.callValidateCode=xf.schemaProperties=xf.allSchemaProperties=xf.noPropertyInData=xf.propertyInData=xf.isOwnProperty=xf.hasPropFunc=xf.reportMissingProp=xf.checkMissingProp=xf.checkReportMissingProp=void 0;var Np=Hl(),TIe=Qu(),tw=CP(),sQt=Qu();function aQt(u,c){let{gen:f,data:v,it:x}=u;f.if(EIe(f,v,c,x.opts.ownProperties),()=>{u.setParams({missingProperty:(0,Np._)`${c}`},!0),u.error()})}xf.checkReportMissingProp=aQt;function oQt({gen:u,data:c,it:{opts:f}},v,x){return(0,Np.or)(...v.map(w=>(0,Np.and)(EIe(u,c,w,f.ownProperties),(0,Np._)`${x} = ${w}`)))}xf.checkMissingProp=oQt;function cQt(u,c){u.setParams({missingProperty:c},!0),u.error()}xf.reportMissingProp=cQt;function Zct(u){return u.scopeValue("func",{ref:Object.prototype.hasOwnProperty,code:(0,Np._)`Object.prototype.hasOwnProperty`})}xf.hasPropFunc=Zct;function bIe(u,c,f){return(0,Np._)`${Zct(u)}.call(${c}, ${f})`}xf.isOwnProperty=bIe;function lQt(u,c,f,v){let x=(0,Np._)`${c}${(0,Np.getProperty)(f)} !== undefined`;return v?(0,Np._)`${x} && ${bIe(u,c,f)}`:x}xf.propertyInData=lQt;function EIe(u,c,f,v){let x=(0,Np._)`${c}${(0,Np.getProperty)(f)} === undefined`;return v?(0,Np.or)(x,(0,Np.not)(bIe(u,c,f))):x}xf.noPropertyInData=EIe;function elt(u){return u?Object.keys(u).filter(c=>c!=="__proto__"):[]}xf.allSchemaProperties=elt;function uQt(u,c){return elt(c).filter(f=>!(0,TIe.alwaysValidSchema)(u,c[f]))}xf.schemaProperties=uQt;function _Qt({schemaCode:u,data:c,it:{gen:f,topSchemaRef:v,schemaPath:x,errorPath:w},it:F},ee,me,de){let Te=de?(0,Np._)`${u}, ${c}, ${v}${x}`:c,ut=[[tw.default.instancePath,(0,Np.strConcat)(tw.default.instancePath,w)],[tw.default.parentData,F.parentData],[tw.default.parentDataProperty,F.parentDataProperty],[tw.default.rootData,tw.default.rootData]];F.opts.dynamicRef&&ut.push([tw.default.dynamicAnchors,tw.default.dynamicAnchors]);let Ct=(0,Np._)`${Te}, ${f.object(...ut)}`;return me!==Np.nil?(0,Np._)`${ee}.call(${me}, ${Ct})`:(0,Np._)`${ee}(${Ct})`}xf.callValidateCode=_Qt;var fQt=(0,Np._)`new RegExp`;function pQt({gen:u,it:{opts:c}},f){let v=c.unicodeRegExp?"u":"",{regExp:x}=c.code,w=x(f,v);return u.scopeValue("pattern",{key:w.toString(),ref:w,code:(0,Np._)`${x.code==="new RegExp"?fQt:(0,sQt.useFunc)(u,x)}(${f}, ${v})`})}xf.usePattern=pQt;function dQt(u){let{gen:c,data:f,keyword:v,it:x}=u,w=c.name("valid");if(x.allErrors){let ee=c.let("valid",!0);return F(()=>c.assign(ee,!1)),ee}return c.var(w,!0),F(()=>c.break()),w;function F(ee){let me=c.const("len",(0,Np._)`${f}.length`);c.forRange("i",0,me,de=>{u.subschema({keyword:v,dataProp:de,dataPropType:TIe.Type.Num},w),c.if((0,Np.not)(w),ee)})}}xf.validateArray=dQt;function mQt(u){let{gen:c,schema:f,keyword:v,it:x}=u;if(!Array.isArray(f))throw new Error("ajv implementation error");if(f.some(me=>(0,TIe.alwaysValidSchema)(x,me))&&!x.opts.unevaluated)return;let F=c.let("valid",!1),ee=c.name("_valid");c.block(()=>f.forEach((me,de)=>{let Te=u.subschema({keyword:v,schemaProp:de,compositeRule:!0},ee);c.assign(F,(0,Np._)`${F} || ${ee}`),u.mergeValidEvaluated(Te,ee)||c.if((0,Np.not)(F))})),u.result(F,()=>u.reset(),()=>u.error(!0))}xf.validateUnion=mQt});var nlt=At(qC=>{"use strict";Object.defineProperty(qC,"__esModule",{value:!0});qC.validateKeywordUsage=qC.validSchemaType=qC.funcKeywordCode=qC.macroKeywordCode=void 0;var _1=Hl(),o3=CP(),gQt=kb(),hQt=CW();function yQt(u,c){let{gen:f,keyword:v,schema:x,parentSchema:w,it:F}=u,ee=c.macro.call(F.self,x,w,F),me=rlt(f,v,ee);F.opts.validateSchema!==!1&&F.self.validateSchema(ee,!0);let de=f.name("valid");u.subschema({schema:ee,schemaPath:_1.nil,errSchemaPath:`${F.errSchemaPath}/${v}`,topSchemaRef:me,compositeRule:!0},de),u.pass(de,()=>u.error(!0))}qC.macroKeywordCode=yQt;function vQt(u,c){var f;let{gen:v,keyword:x,schema:w,parentSchema:F,$data:ee,it:me}=u;TQt(me,c);let de=!ee&&c.compile?c.compile.call(me.self,w,F,me):c.validate,Te=rlt(v,x,de),ut=v.let("valid");u.block$data(ut,Ct),u.ok((f=c.valid)!==null&&f!==void 0?f:ut);function Ct(){if(c.errors===!1)en(),c.modifying&&tlt(u),zn(()=>u.error());else{let yr=c.async?Kt():xr();c.modifying&&tlt(u),zn(()=>SQt(u,yr))}}function Kt(){let yr=v.let("ruleErrs",null);return v.try(()=>en((0,_1._)`await `),mr=>v.assign(ut,!1).if((0,_1._)`${mr} instanceof ${me.ValidationError}`,()=>v.assign(yr,(0,_1._)`${mr}.errors`),()=>v.throw(mr))),yr}function xr(){let yr=(0,_1._)`${Te}.errors`;return v.assign(yr,null),en(_1.nil),yr}function en(yr=c.async?(0,_1._)`await `:_1.nil){let mr=me.opts.passContext?o3.default.this:o3.default.self,Da=!("compile"in c&&!ee||c.schema===!1);v.assign(ut,(0,_1._)`${yr}${(0,gQt.callValidateCode)(u,Te,mr,Da)}`,c.modifying)}function zn(yr){var mr;v.if((0,_1.not)((mr=c.valid)!==null&&mr!==void 0?mr:ut),yr)}}qC.funcKeywordCode=vQt;function tlt(u){let{gen:c,data:f,it:v}=u;c.if(v.parentData,()=>c.assign(f,(0,_1._)`${v.parentData}[${v.parentDataProperty}]`))}function SQt(u,c){let{gen:f}=u;f.if((0,_1._)`Array.isArray(${c})`,()=>{f.assign(o3.default.vErrors,(0,_1._)`${o3.default.vErrors} === null ? ${c} : ${o3.default.vErrors}.concat(${c})`).assign(o3.default.errors,(0,_1._)`${o3.default.vErrors}.length`),(0,hQt.extendErrors)(u)},()=>u.error())}function TQt({schemaEnv:u},c){if(c.async&&!u.$async)throw new Error("async keyword in sync schema")}function rlt(u,c,f){if(f===void 0)throw new Error(`keyword "${c}" failed to compile`);return u.scopeValue("keyword",typeof f=="function"?{ref:f}:{ref:f,code:(0,_1.stringify)(f)})}function bQt(u,c,f=!1){return!c.length||c.some(v=>v==="array"?Array.isArray(u):v==="object"?u&&typeof u=="object"&&!Array.isArray(u):typeof u==v||f&&typeof u>"u")}qC.validSchemaType=bQt;function EQt({schema:u,opts:c,self:f,errSchemaPath:v},x,w){if(Array.isArray(x.keyword)?!x.keyword.includes(w):x.keyword!==w)throw new Error("ajv implementation error");let F=x.dependencies;if(F?.some(ee=>!Object.prototype.hasOwnProperty.call(u,ee)))throw new Error(`parent schema must have dependencies of ${w}: ${F.join(",")}`);if(x.validateSchema&&!x.validateSchema(u[w])){let me=`keyword "${w}" value is invalid at path "${v}": `+f.errorsText(x.validateSchema.errors);if(c.validateSchema==="log")f.logger.error(me);else throw new Error(me)}}qC.validateKeywordUsage=EQt});var slt=At(rw=>{"use strict";Object.defineProperty(rw,"__esModule",{value:!0});rw.extendSubschemaMode=rw.extendSubschemaData=rw.getSubschema=void 0;var zC=Hl(),ilt=Qu();function xQt(u,{keyword:c,schemaProp:f,schema:v,schemaPath:x,errSchemaPath:w,topSchemaRef:F}){if(c!==void 0&&v!==void 0)throw new Error('both "keyword" and "schema" passed, only one allowed');if(c!==void 0){let ee=u.schema[c];return f===void 0?{schema:ee,schemaPath:(0,zC._)`${u.schemaPath}${(0,zC.getProperty)(c)}`,errSchemaPath:`${u.errSchemaPath}/${c}`}:{schema:ee[f],schemaPath:(0,zC._)`${u.schemaPath}${(0,zC.getProperty)(c)}${(0,zC.getProperty)(f)}`,errSchemaPath:`${u.errSchemaPath}/${c}/${(0,ilt.escapeFragment)(f)}`}}if(v!==void 0){if(x===void 0||w===void 0||F===void 0)throw new Error('"schemaPath", "errSchemaPath" and "topSchemaRef" are required with "schema"');return{schema:v,schemaPath:x,topSchemaRef:F,errSchemaPath:w}}throw new Error('either "keyword" or "schema" must be passed')}rw.getSubschema=xQt;function CQt(u,c,{dataProp:f,dataPropType:v,data:x,dataTypes:w,propertyName:F}){if(x!==void 0&&f!==void 0)throw new Error('both "data" and "dataProp" passed, only one allowed');let{gen:ee}=c;if(f!==void 0){let{errorPath:de,dataPathArr:Te,opts:ut}=c,Ct=ee.let("data",(0,zC._)`${c.data}${(0,zC.getProperty)(f)}`,!0);me(Ct),u.errorPath=(0,zC.str)`${de}${(0,ilt.getErrorPath)(f,v,ut.jsPropertySyntax)}`,u.parentDataProperty=(0,zC._)`${f}`,u.dataPathArr=[...Te,u.parentDataProperty]}if(x!==void 0){let de=x instanceof zC.Name?x:ee.let("data",x,!0);me(de),F!==void 0&&(u.propertyName=F)}w&&(u.dataTypes=w);function me(de){u.data=de,u.dataLevel=c.dataLevel+1,u.dataTypes=[],c.definedProperties=new Set,u.parentData=c.data,u.dataNames=[...c.dataNames,de]}}rw.extendSubschemaData=CQt;function AQt(u,{jtdDiscriminator:c,jtdMetadata:f,compositeRule:v,createErrors:x,allErrors:w}){v!==void 0&&(u.compositeRule=v),x!==void 0&&(u.createErrors=x),w!==void 0&&(u.allErrors=w),u.jtdDiscriminator=c,u.jtdMetadata=f}rw.extendSubschemaMode=AQt});var xIe=At((yhr,alt)=>{"use strict";alt.exports=function u(c,f){if(c===f)return!0;if(c&&f&&typeof c=="object"&&typeof f=="object"){if(c.constructor!==f.constructor)return!1;var v,x,w;if(Array.isArray(c)){if(v=c.length,v!=f.length)return!1;for(x=v;x--!==0;)if(!u(c[x],f[x]))return!1;return!0}if(c.constructor===RegExp)return c.source===f.source&&c.flags===f.flags;if(c.valueOf!==Object.prototype.valueOf)return c.valueOf()===f.valueOf();if(c.toString!==Object.prototype.toString)return c.toString()===f.toString();if(w=Object.keys(c),v=w.length,v!==Object.keys(f).length)return!1;for(x=v;x--!==0;)if(!Object.prototype.hasOwnProperty.call(f,w[x]))return!1;for(x=v;x--!==0;){var F=w[x];if(!u(c[F],f[F]))return!1}return!0}return c!==c&&f!==f}});var clt=At((vhr,olt)=>{"use strict";var nw=olt.exports=function(u,c,f){typeof c=="function"&&(f=c,c={}),f=c.cb||f;var v=typeof f=="function"?f:f.pre||function(){},x=f.post||function(){};Tue(c,v,x,u,"",u)};nw.keywords={additionalItems:!0,items:!0,contains:!0,additionalProperties:!0,propertyNames:!0,not:!0,if:!0,then:!0,else:!0};nw.arrayKeywords={items:!0,allOf:!0,anyOf:!0,oneOf:!0};nw.propsKeywords={$defs:!0,definitions:!0,properties:!0,patternProperties:!0,dependencies:!0};nw.skipKeywords={default:!0,enum:!0,const:!0,required:!0,maximum:!0,minimum:!0,exclusiveMaximum:!0,exclusiveMinimum:!0,multipleOf:!0,maxLength:!0,minLength:!0,pattern:!0,format:!0,maxItems:!0,minItems:!0,uniqueItems:!0,maxProperties:!0,minProperties:!0};function Tue(u,c,f,v,x,w,F,ee,me,de){if(v&&typeof v=="object"&&!Array.isArray(v)){c(v,x,w,F,ee,me,de);for(var Te in v){var ut=v[Te];if(Array.isArray(ut)){if(Te in nw.arrayKeywords)for(var Ct=0;Ct<ut.length;Ct++)Tue(u,c,f,ut[Ct],x+"/"+Te+"/"+Ct,w,x,Te,v,Ct)}else if(Te in nw.propsKeywords){if(ut&&typeof ut=="object")for(var Kt in ut)Tue(u,c,f,ut[Kt],x+"/"+Te+"/"+kQt(Kt),w,x,Te,v,Kt)}else(Te in nw.keywords||u.allKeys&&!(Te in nw.skipKeywords))&&Tue(u,c,f,ut,x+"/"+Te,w,x,Te,v)}f(v,x,w,F,ee,me,de)}}function kQt(u){return u.replace(/~/g,"~0").replace(/\//g,"~1")}});var kW=At(hv=>{"use strict";Object.defineProperty(hv,"__esModule",{value:!0});hv.getSchemaRefs=hv.resolveUrl=hv.normalizeId=hv._getFullPath=hv.getFullPath=hv.inlineRef=void 0;var PQt=Qu(),NQt=xIe(),DQt=clt(),IQt=new Set(["type","format","pattern","maxLength","minLength","maxProperties","minProperties","maxItems","minItems","maximum","minimum","uniqueItems","multipleOf","required","enum","const"]);function wQt(u,c=!0){return typeof u=="boolean"?!0:c===!0?!CIe(u):c?llt(u)<=c:!1}hv.inlineRef=wQt;var OQt=new Set(["$ref","$recursiveRef","$recursiveAnchor","$dynamicRef","$dynamicAnchor"]);function CIe(u){for(let c in u){if(OQt.has(c))return!0;let f=u[c];if(Array.isArray(f)&&f.some(CIe)||typeof f=="object"&&CIe(f))return!0}return!1}function llt(u){let c=0;for(let f in u){if(f==="$ref")return 1/0;if(c++,!IQt.has(f)&&(typeof u[f]=="object"&&(0,PQt.eachItem)(u[f],v=>c+=llt(v)),c===1/0))return 1/0}return c}function ult(u,c="",f){f!==!1&&(c=XF(c));let v=u.parse(c);return _lt(u,v)}hv.getFullPath=ult;function _lt(u,c){return u.serialize(c).split("#")[0]+"#"}hv._getFullPath=_lt;var RQt=/#\/?$/;function XF(u){return u?u.replace(RQt,""):""}hv.normalizeId=XF;function MQt(u,c,f){return f=XF(f),u.resolve(c,f)}hv.resolveUrl=MQt;var LQt=/^[a-z_][-a-z0-9._]*$/i;function FQt(u,c){if(typeof u=="boolean")return{};let{schemaId:f,uriResolver:v}=this.opts,x=XF(u[f]||c),w={"":x},F=ult(v,x,!1),ee={},me=new Set;return DQt(u,{allKeys:!0},(ut,Ct,Kt,xr)=>{if(xr===void 0)return;let en=F+Ct,zn=w[xr];typeof ut[f]=="string"&&(zn=yr.call(this,ut[f])),mr.call(this,ut.$anchor),mr.call(this,ut.$dynamicAnchor),w[Ct]=zn;function yr(Da){let oa=this.opts.uriResolver.resolve;if(Da=XF(zn?oa(zn,Da):Da),me.has(Da))throw Te(Da);me.add(Da);let no=this.refs[Da];return typeof no=="string"&&(no=this.refs[no]),typeof no=="object"?de(ut,no.schema,Da):Da!==XF(en)&&(Da[0]==="#"?(de(ut,ee[Da],Da),ee[Da]=ut):this.refs[Da]=en),Da}function mr(Da){if(typeof Da=="string"){if(!LQt.test(Da))throw new Error(`invalid anchor "${Da}"`);yr.call(this,`#${Da}`)}}}),ee;function de(ut,Ct,Kt){if(Ct!==void 0&&!NQt(ut,Ct))throw Te(Kt)}function Te(ut){return new Error(`reference "${ut}" resolves to more than one schema`)}}hv.getSchemaRefs=FQt});var DW=At(iw=>{"use strict";Object.defineProperty(iw,"__esModule",{value:!0});iw.getData=iw.KeywordCxt=iw.validateFunctionCode=void 0;var glt=$ct(),flt=AW(),kIe=hIe(),bue=AW(),jQt=Qct(),NW=nlt(),AIe=slt(),No=Hl(),Rc=CP(),BQt=kW(),AP=Qu(),PW=CW();function UQt(u){if(vlt(u)&&(Slt(u),ylt(u))){qQt(u);return}hlt(u,()=>(0,glt.topBoolOrEmptySchema)(u))}iw.validateFunctionCode=UQt;function hlt({gen:u,validateName:c,schema:f,schemaEnv:v,opts:x},w){x.code.es5?u.func(c,(0,No._)`${Rc.default.data}, ${Rc.default.valCxt}`,v.$async,()=>{u.code((0,No._)`"use strict"; ${plt(f,x)}`),JQt(u,x),u.code(w)}):u.func(c,(0,No._)`${Rc.default.data}, ${VQt(x)}`,v.$async,()=>u.code(plt(f,x)).code(w))}function VQt(u){return(0,No._)`{${Rc.default.instancePath}="", ${Rc.default.parentData}, ${Rc.default.parentDataProperty}, ${Rc.default.rootData}=${Rc.default.data}${u.dynamicRef?(0,No._)`, ${Rc.default.dynamicAnchors}={}`:No.nil}}={}`}function JQt(u,c){u.if(Rc.default.valCxt,()=>{u.var(Rc.default.instancePath,(0,No._)`${Rc.default.valCxt}.${Rc.default.instancePath}`),u.var(Rc.default.parentData,(0,No._)`${Rc.default.valCxt}.${Rc.default.parentData}`),u.var(Rc.default.parentDataProperty,(0,No._)`${Rc.default.valCxt}.${Rc.default.parentDataProperty}`),u.var(Rc.default.rootData,(0,No._)`${Rc.default.valCxt}.${Rc.default.rootData}`),c.dynamicRef&&u.var(Rc.default.dynamicAnchors,(0,No._)`${Rc.default.valCxt}.${Rc.default.dynamicAnchors}`)},()=>{u.var(Rc.default.instancePath,(0,No._)`""`),u.var(Rc.default.parentData,(0,No._)`undefined`),u.var(Rc.default.parentDataProperty,(0,No._)`undefined`),u.var(Rc.default.rootData,Rc.default.data),c.dynamicRef&&u.var(Rc.default.dynamicAnchors,(0,No._)`{}`)})}function qQt(u){let{schema:c,opts:f,gen:v}=u;hlt(u,()=>{f.$comment&&c.$comment&&blt(u),HQt(u),v.let(Rc.default.vErrors,null),v.let(Rc.default.errors,0),f.unevaluated&&zQt(u),Tlt(u),KQt(u)})}function zQt(u){let{gen:c,validateName:f}=u;u.evaluated=c.const("evaluated",(0,No._)`${f}.evaluated`),c.if((0,No._)`${u.evaluated}.dynamicProps`,()=>c.assign((0,No._)`${u.evaluated}.props`,(0,No._)`undefined`)),c.if((0,No._)`${u.evaluated}.dynamicItems`,()=>c.assign((0,No._)`${u.evaluated}.items`,(0,No._)`undefined`))}function plt(u,c){let f=typeof u=="object"&&u[c.schemaId];return f&&(c.code.source||c.code.process)?(0,No._)`/*# sourceURL=${f} */`:No.nil}function $Qt(u,c){if(vlt(u)&&(Slt(u),ylt(u))){WQt(u,c);return}(0,glt.boolOrEmptySchema)(u,c)}function ylt({schema:u,self:c}){if(typeof u=="boolean")return!u;for(let f in u)if(c.RULES.all[f])return!0;return!1}function vlt(u){return typeof u.schema!="boolean"}function WQt(u,c){let{schema:f,gen:v,opts:x}=u;x.$comment&&f.$comment&&blt(u),YQt(u),XQt(u);let w=v.const("_errs",Rc.default.errors);Tlt(u,w),v.var(c,(0,No._)`${w} === ${Rc.default.errors}`)}function Slt(u){(0,AP.checkUnknownRules)(u),GQt(u)}function Tlt(u,c){if(u.opts.jtd)return dlt(u,[],!1,c);let f=(0,flt.getSchemaTypes)(u.schema),v=(0,flt.coerceAndCheckDataType)(u,f);dlt(u,f,!v,c)}function GQt(u){let{schema:c,errSchemaPath:f,opts:v,self:x}=u;c.$ref&&v.ignoreKeywordsWithRef&&(0,AP.schemaHasRulesButRef)(c,x.RULES)&&x.logger.warn(`$ref: keywords ignored in schema at path "${f}"`)}function HQt(u){let{schema:c,opts:f}=u;c.default!==void 0&&f.useDefaults&&f.strictSchema&&(0,AP.checkStrictMode)(u,"default is ignored in the schema root")}function YQt(u){let c=u.schema[u.opts.schemaId];c&&(u.baseId=(0,BQt.resolveUrl)(u.opts.uriResolver,u.baseId,c))}function XQt(u){if(u.schema.$async&&!u.schemaEnv.$async)throw new Error("async schema in sync schema")}function blt({gen:u,schemaEnv:c,schema:f,errSchemaPath:v,opts:x}){let w=f.$comment;if(x.$comment===!0)u.code((0,No._)`${Rc.default.self}.logger.log(${w})`);else if(typeof x.$comment=="function"){let F=(0,No.str)`${v}/$comment`,ee=u.scopeValue("root",{ref:c.root});u.code((0,No._)`${Rc.default.self}.opts.$comment(${w}, ${F}, ${ee}.schema)`)}}function KQt(u){let{gen:c,schemaEnv:f,validateName:v,ValidationError:x,opts:w}=u;f.$async?c.if((0,No._)`${Rc.default.errors} === 0`,()=>c.return(Rc.default.data),()=>c.throw((0,No._)`new ${x}(${Rc.default.vErrors})`)):(c.assign((0,No._)`${v}.errors`,Rc.default.vErrors),w.unevaluated&&QQt(u),c.return((0,No._)`${Rc.default.errors} === 0`))}function QQt({gen:u,evaluated:c,props:f,items:v}){f instanceof No.Name&&u.assign((0,No._)`${c}.props`,f),v instanceof No.Name&&u.assign((0,No._)`${c}.items`,v)}function dlt(u,c,f,v){let{gen:x,schema:w,data:F,allErrors:ee,opts:me,self:de}=u,{RULES:Te}=de;if(w.$ref&&(me.ignoreKeywordsWithRef||!(0,AP.schemaHasRulesButRef)(w,Te))){x.block(()=>xlt(u,"$ref",Te.all.$ref.definition));return}me.jtd||ZQt(u,c),x.block(()=>{for(let Ct of Te.rules)ut(Ct);ut(Te.post)});function ut(Ct){(0,kIe.shouldUseGroup)(w,Ct)&&(Ct.type?(x.if((0,bue.checkDataType)(Ct.type,F,me.strictNumbers)),mlt(u,Ct),c.length===1&&c[0]===Ct.type&&f&&(x.else(),(0,bue.reportTypeError)(u)),x.endIf()):mlt(u,Ct),ee||x.if((0,No._)`${Rc.default.errors} === ${v||0}`))}}function mlt(u,c){let{gen:f,schema:v,opts:{useDefaults:x}}=u;x&&(0,jQt.assignDefaults)(u,c.type),f.block(()=>{for(let w of c.rules)(0,kIe.shouldUseRule)(v,w)&&xlt(u,w.keyword,w.definition,c.type)})}function ZQt(u,c){u.schemaEnv.meta||!u.opts.strictTypes||(eZt(u,c),u.opts.allowUnionTypes||tZt(u,c),rZt(u,u.dataTypes))}function eZt(u,c){if(c.length){if(!u.dataTypes.length){u.dataTypes=c;return}c.forEach(f=>{Elt(u.dataTypes,f)||PIe(u,`type "${f}" not allowed by context "${u.dataTypes.join(",")}"`)}),iZt(u,c)}}function tZt(u,c){c.length>1&&!(c.length===2&&c.includes("null"))&&PIe(u,"use allowUnionTypes to allow union type keyword")}function rZt(u,c){let f=u.self.RULES.all;for(let v in f){let x=f[v];if(typeof x=="object"&&(0,kIe.shouldUseRule)(u.schema,x)){let{type:w}=x.definition;w.length&&!w.some(F=>nZt(c,F))&&PIe(u,`missing type "${w.join(",")}" for keyword "${v}"`)}}}function nZt(u,c){return u.includes(c)||c==="number"&&u.includes("integer")}function Elt(u,c){return u.includes(c)||c==="integer"&&u.includes("number")}function iZt(u,c){let f=[];for(let v of u.dataTypes)Elt(c,v)?f.push(v):c.includes("integer")&&v==="number"&&f.push("integer");u.dataTypes=f}function PIe(u,c){let f=u.schemaEnv.baseId+u.errSchemaPath;c+=` at "${f}" (strictTypes)`,(0,AP.checkStrictMode)(u,c,u.opts.strictTypes)}var Eue=class{constructor(c,f,v){if((0,NW.validateKeywordUsage)(c,f,v),this.gen=c.gen,this.allErrors=c.allErrors,this.keyword=v,this.data=c.data,this.schema=c.schema[v],this.$data=f.$data&&c.opts.$data&&this.schema&&this.schema.$data,this.schemaValue=(0,AP.schemaRefOrVal)(c,this.schema,v,this.$data),this.schemaType=f.schemaType,this.parentSchema=c.schema,this.params={},this.it=c,this.def=f,this.$data)this.schemaCode=c.gen.const("vSchema",Clt(this.$data,c));else if(this.schemaCode=this.schemaValue,!(0,NW.validSchemaType)(this.schema,f.schemaType,f.allowUndefined))throw new Error(`${v} value must be ${JSON.stringify(f.schemaType)}`);("code"in f?f.trackErrors:f.errors!==!1)&&(this.errsCount=c.gen.const("_errs",Rc.default.errors))}result(c,f,v){this.failResult((0,No.not)(c),f,v)}failResult(c,f,v){this.gen.if(c),v?v():this.error(),f?(this.gen.else(),f(),this.allErrors&&this.gen.endIf()):this.allErrors?this.gen.endIf():this.gen.else()}pass(c,f){this.failResult((0,No.not)(c),void 0,f)}fail(c){if(c===void 0){this.error(),this.allErrors||this.gen.if(!1);return}this.gen.if(c),this.error(),this.allErrors?this.gen.endIf():this.gen.else()}fail$data(c){if(!this.$data)return this.fail(c);let{schemaCode:f}=this;this.fail((0,No._)`${f} !== undefined && (${(0,No.or)(this.invalid$data(),c)})`)}error(c,f,v){if(f){this.setParams(f),this._error(c,v),this.setParams({});return}this._error(c,v)}_error(c,f){(c?PW.reportExtraError:PW.reportError)(this,this.def.error,f)}$dataError(){(0,PW.reportError)(this,this.def.$dataError||PW.keyword$DataError)}reset(){if(this.errsCount===void 0)throw new Error('add "trackErrors" to keyword definition');(0,PW.resetErrorsCount)(this.gen,this.errsCount)}ok(c){this.allErrors||this.gen.if(c)}setParams(c,f){f?Object.assign(this.params,c):this.params=c}block$data(c,f,v=No.nil){this.gen.block(()=>{this.check$data(c,v),f()})}check$data(c=No.nil,f=No.nil){if(!this.$data)return;let{gen:v,schemaCode:x,schemaType:w,def:F}=this;v.if((0,No.or)((0,No._)`${x} === undefined`,f)),c!==No.nil&&v.assign(c,!0),(w.length||F.validateSchema)&&(v.elseIf(this.invalid$data()),this.$dataError(),c!==No.nil&&v.assign(c,!1)),v.else()}invalid$data(){let{gen:c,schemaCode:f,schemaType:v,def:x,it:w}=this;return(0,No.or)(F(),ee());function F(){if(v.length){if(!(f instanceof No.Name))throw new Error("ajv implementation error");let me=Array.isArray(v)?v:[v];return(0,No._)`${(0,bue.checkDataTypes)(me,f,w.opts.strictNumbers,bue.DataType.Wrong)}`}return No.nil}function ee(){if(x.validateSchema){let me=c.scopeValue("validate$data",{ref:x.validateSchema});return(0,No._)`!${me}(${f})`}return No.nil}}subschema(c,f){let v=(0,AIe.getSubschema)(this.it,c);(0,AIe.extendSubschemaData)(v,this.it,c),(0,AIe.extendSubschemaMode)(v,c);let x={...this.it,...v,items:void 0,props:void 0};return $Qt(x,f),x}mergeEvaluated(c,f){let{it:v,gen:x}=this;v.opts.unevaluated&&(v.props!==!0&&c.props!==void 0&&(v.props=AP.mergeEvaluated.props(x,c.props,v.props,f)),v.items!==!0&&c.items!==void 0&&(v.items=AP.mergeEvaluated.items(x,c.items,v.items,f)))}mergeValidEvaluated(c,f){let{it:v,gen:x}=this;if(v.opts.unevaluated&&(v.props!==!0||v.items!==!0))return x.if(f,()=>this.mergeEvaluated(c,No.Name)),!0}};iw.KeywordCxt=Eue;function xlt(u,c,f,v){let x=new Eue(u,f,c);"code"in f?f.code(x,v):x.$data&&f.validate?(0,NW.funcKeywordCode)(x,f):"macro"in f?(0,NW.macroKeywordCode)(x,f):(f.compile||f.validate)&&(0,NW.funcKeywordCode)(x,f)}var sZt=/^\/(?:[^~]|~0|~1)*$/,aZt=/^([0-9]+)(#|\/(?:[^~]|~0|~1)*)?$/;function Clt(u,{dataLevel:c,dataNames:f,dataPathArr:v}){let x,w;if(u==="")return Rc.default.rootData;if(u[0]==="/"){if(!sZt.test(u))throw new Error(`Invalid JSON-pointer: ${u}`);x=u,w=Rc.default.rootData}else{let de=aZt.exec(u);if(!de)throw new Error(`Invalid JSON-pointer: ${u}`);let Te=+de[1];if(x=de[2],x==="#"){if(Te>=c)throw new Error(me("property/index",Te));return v[c-Te]}if(Te>c)throw new Error(me("data",Te));if(w=f[c-Te],!x)return w}let F=w,ee=x.split("/");for(let de of ee)de&&(w=(0,No._)`${w}${(0,No.getProperty)((0,AP.unescapeJsonPointer)(de))}`,F=(0,No._)`${F} && ${w}`);return F;function me(de,Te){return`Cannot access ${de} ${Te} levels up, current level is ${c}`}}iw.getData=Clt});var xue=At(DIe=>{"use strict";Object.defineProperty(DIe,"__esModule",{value:!0});var NIe=class extends Error{constructor(c){super("validation failed"),this.errors=c,this.ajv=this.validation=!0}};DIe.default=NIe});var Cue=At(OIe=>{"use strict";Object.defineProperty(OIe,"__esModule",{value:!0});var IIe=kW(),wIe=class extends Error{constructor(c,f,v,x){super(x||`can't resolve reference ${v} from id ${f}`),this.missingRef=(0,IIe.resolveUrl)(c,f,v),this.missingSchema=(0,IIe.normalizeId)((0,IIe.getFullPath)(c,this.missingRef))}};OIe.default=wIe});var kue=At(Pb=>{"use strict";Object.defineProperty(Pb,"__esModule",{value:!0});Pb.resolveSchema=Pb.getCompilingSchema=Pb.resolveRef=Pb.compileSchema=Pb.SchemaEnv=void 0;var y2=Hl(),oZt=xue(),c3=CP(),v2=kW(),Alt=Qu(),cZt=DW(),KF=class{constructor(c){var f;this.refs={},this.dynamicAnchors={};let v;typeof c.schema=="object"&&(v=c.schema),this.schema=c.schema,this.schemaId=c.schemaId,this.root=c.root||this,this.baseId=(f=c.baseId)!==null&&f!==void 0?f:(0,v2.normalizeId)(v?.[c.schemaId||"$id"]),this.schemaPath=c.schemaPath,this.localRefs=c.localRefs,this.meta=c.meta,this.$async=v?.$async,this.refs={}}};Pb.SchemaEnv=KF;function MIe(u){let c=klt.call(this,u);if(c)return c;let f=(0,v2.getFullPath)(this.opts.uriResolver,u.root.baseId),{es5:v,lines:x}=this.opts.code,{ownProperties:w}=this.opts,F=new y2.CodeGen(this.scope,{es5:v,lines:x,ownProperties:w}),ee;u.$async&&(ee=F.scopeValue("Error",{ref:oZt.default,code:(0,y2._)`require("ajv/dist/runtime/validation_error").default`}));let me=F.scopeName("validate");u.validateName=me;let de={gen:F,allErrors:this.opts.allErrors,data:c3.default.data,parentData:c3.default.parentData,parentDataProperty:c3.default.parentDataProperty,dataNames:[c3.default.data],dataPathArr:[y2.nil],dataLevel:0,dataTypes:[],definedProperties:new Set,topSchemaRef:F.scopeValue("schema",this.opts.code.source===!0?{ref:u.schema,code:(0,y2.stringify)(u.schema)}:{ref:u.schema}),validateName:me,ValidationError:ee,schema:u.schema,schemaEnv:u,rootId:f,baseId:u.baseId||f,schemaPath:y2.nil,errSchemaPath:u.schemaPath||(this.opts.jtd?"":"#"),errorPath:(0,y2._)`""`,opts:this.opts,self:this},Te;try{this._compilations.add(u),(0,cZt.validateFunctionCode)(de),F.optimize(this.opts.code.optimize);let ut=F.toString();Te=`${F.scopeRefs(c3.default.scope)}return ${ut}`,this.opts.code.process&&(Te=this.opts.code.process(Te,u));let Kt=new Function(`${c3.default.self}`,`${c3.default.scope}`,Te)(this,this.scope.get());if(this.scope.value(me,{ref:Kt}),Kt.errors=null,Kt.schema=u.schema,Kt.schemaEnv=u,u.$async&&(Kt.$async=!0),this.opts.code.source===!0&&(Kt.source={validateName:me,validateCode:ut,scopeValues:F._values}),this.opts.unevaluated){let{props:xr,items:en}=de;Kt.evaluated={props:xr instanceof y2.Name?void 0:xr,items:en instanceof y2.Name?void 0:en,dynamicProps:xr instanceof y2.Name,dynamicItems:en instanceof y2.Name},Kt.source&&(Kt.source.evaluated=(0,y2.stringify)(Kt.evaluated))}return u.validate=Kt,u}catch(ut){throw delete u.validate,delete u.validateName,Te&&this.logger.error("Error compiling schema, function code:",Te),ut}finally{this._compilations.delete(u)}}Pb.compileSchema=MIe;function lZt(u,c,f){var v;f=(0,v2.resolveUrl)(this.opts.uriResolver,c,f);let x=u.refs[f];if(x)return x;let w=fZt.call(this,u,f);if(w===void 0){let F=(v=u.localRefs)===null||v===void 0?void 0:v[f],{schemaId:ee}=this.opts;F&&(w=new KF({schema:F,schemaId:ee,root:u,baseId:c}))}if(w!==void 0)return u.refs[f]=uZt.call(this,w)}Pb.resolveRef=lZt;function uZt(u){return(0,v2.inlineRef)(u.schema,this.opts.inlineRefs)?u.schema:u.validate?u:MIe.call(this,u)}function klt(u){for(let c of this._compilations)if(_Zt(c,u))return c}Pb.getCompilingSchema=klt;function _Zt(u,c){return u.schema===c.schema&&u.root===c.root&&u.baseId===c.baseId}function fZt(u,c){let f;for(;typeof(f=this.refs[c])=="string";)c=f;return f||this.schemas[c]||Aue.call(this,u,c)}function Aue(u,c){let f=this.opts.uriResolver.parse(c),v=(0,v2._getFullPath)(this.opts.uriResolver,f),x=(0,v2.getFullPath)(this.opts.uriResolver,u.baseId,void 0);if(Object.keys(u.schema).length>0&&v===x)return RIe.call(this,f,u);let w=(0,v2.normalizeId)(v),F=this.refs[w]||this.schemas[w];if(typeof F=="string"){let ee=Aue.call(this,u,F);return typeof ee?.schema!="object"?void 0:RIe.call(this,f,ee)}if(typeof F?.schema=="object"){if(F.validate||MIe.call(this,F),w===(0,v2.normalizeId)(c)){let{schema:ee}=F,{schemaId:me}=this.opts,de=ee[me];return de&&(x=(0,v2.resolveUrl)(this.opts.uriResolver,x,de)),new KF({schema:ee,schemaId:me,root:u,baseId:x})}return RIe.call(this,f,F)}}Pb.resolveSchema=Aue;var pZt=new Set(["properties","patternProperties","enum","dependencies","definitions"]);function RIe(u,{baseId:c,schema:f,root:v}){var x;if(((x=u.fragment)===null||x===void 0?void 0:x[0])!=="/")return;for(let ee of u.fragment.slice(1).split("/")){if(typeof f=="boolean")return;let me=f[(0,Alt.unescapeFragment)(ee)];if(me===void 0)return;f=me;let de=typeof f=="object"&&f[this.opts.schemaId];!pZt.has(ee)&&de&&(c=(0,v2.resolveUrl)(this.opts.uriResolver,c,de))}let w;if(typeof f!="boolean"&&f.$ref&&!(0,Alt.schemaHasRulesButRef)(f,this.RULES)){let ee=(0,v2.resolveUrl)(this.opts.uriResolver,c,f.$ref);w=Aue.call(this,v,ee)}let{schemaId:F}=this.opts;if(w=w||new KF({schema:f,schemaId:F,root:v,baseId:c}),w.schema!==w.root.schema)return w}});var Plt=At((Chr,dZt)=>{dZt.exports={$id:"https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#",description:"Meta-schema for $data reference (JSON AnySchema extension proposal)",type:"object",required:["$data"],properties:{$data:{type:"string",anyOf:[{format:"relative-json-pointer"},{format:"json-pointer"}]}},additionalProperties:!1}});var Dlt=At((Pue,Nlt)=>{(function(u,c){typeof Pue=="object"&&typeof Nlt<"u"?c(Pue):typeof define=="function"&&define.amd?define(["exports"],c):c(u.URI=u.URI||{})})(Pue,function(u){"use strict";function c(){for(var Ar=arguments.length,Vt=Array(Ar),Vr=0;Vr<Ar;Vr++)Vt[Vr]=arguments[Vr];if(Vt.length>1){Vt[0]=Vt[0].slice(0,-1);for(var Mn=Vt.length-1,Xn=1;Xn<Mn;++Xn)Vt[Xn]=Vt[Xn].slice(1,-1);return Vt[Mn]=Vt[Mn].slice(1),Vt.join("")}else return Vt[0]}function f(Ar){return"(?:"+Ar+")"}function v(Ar){return Ar===void 0?"undefined":Ar===null?"null":Object.prototype.toString.call(Ar).split(" ").pop().split("]").shift().toLowerCase()}function x(Ar){return Ar.toUpperCase()}function w(Ar){return Ar!=null?Ar instanceof Array?Ar:typeof Ar.length!="number"||Ar.split||Ar.setInterval||Ar.call?[Ar]:Array.prototype.slice.call(Ar):[]}function F(Ar,Vt){var Vr=Ar;if(Vt)for(var Mn in Vt)Vr[Mn]=Vt[Mn];return Vr}function ee(Ar){var Vt="[A-Za-z]",Vr="[\\x0D]",Mn="[0-9]",Xn="[\\x22]",In=c(Mn,"[A-Fa-f]"),ec="[\\x0A]",Kl="[\\x20]",il=f(f("%[EFef]"+In+"%"+In+In+"%"+In+In)+"|"+f("%[89A-Fa-f]"+In+"%"+In+In)+"|"+f("%"+In+In)),Rp="[\\:\\/\\?\\#\\[\\]\\@]",_l="[\\!\\$\\&\\'\\(\\)\\*\\+\\,\\;\\=]",m_=c(Rp,_l),Jf=Ar?"[\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]":"[]",q_=Ar?"[\\uE000-\\uF8FF]":"[]",Ml=c(Vt,Mn,"[\\-\\.\\_\\~]",Jf),uf=f(Vt+c(Vt,Mn,"[\\+\\-\\.]")+"*"),rs=f(f(il+"|"+c(Ml,_l,"[\\:]"))+"*"),g_=f(f("25[0-5]")+"|"+f("2[0-4]"+Mn)+"|"+f("1"+Mn+Mn)+"|"+f("[1-9]"+Mn)+"|"+Mn),my=f(f("25[0-5]")+"|"+f("2[0-4]"+Mn)+"|"+f("1"+Mn+Mn)+"|"+f("0?[1-9]"+Mn)+"|0?0?"+Mn),v1=f(my+"\\."+my+"\\."+my+"\\."+my),Pu=f(In+"{1,4}"),Ug=f(f(Pu+"\\:"+Pu)+"|"+v1),os=f(f(Pu+"\\:")+"{6}"+Ug),Pm=f("\\:\\:"+f(Pu+"\\:")+"{5}"+Ug),vs=f(f(Pu)+"?\\:\\:"+f(Pu+"\\:")+"{4}"+Ug),Mp=f(f(f(Pu+"\\:")+"{0,1}"+Pu)+"?\\:\\:"+f(Pu+"\\:")+"{3}"+Ug),ii=f(f(f(Pu+"\\:")+"{0,2}"+Pu)+"?\\:\\:"+f(Pu+"\\:")+"{2}"+Ug),ta=f(f(f(Pu+"\\:")+"{0,3}"+Pu)+"?\\:\\:"+Pu+"\\:"+Ug),ja=f(f(f(Pu+"\\:")+"{0,4}"+Pu)+"?\\:\\:"+Ug),qf=f(f(f(Pu+"\\:")+"{0,5}"+Pu)+"?\\:\\:"+Pu),em=f(f(f(Pu+"\\:")+"{0,6}"+Pu)+"?\\:\\:"),xd=f([os,Pm,vs,Mp,ii,ta,ja,qf,em].join("|")),Mo=f(f(Ml+"|"+il)+"+"),gw=f(xd+"\\%25"+Mo),sp=f(xd+f("\\%25|\\%(?!"+In+"{2})")+Mo),Ks=f("[vV]"+In+"+\\."+c(Ml,_l,"[\\:]")+"+"),D_=f("\\["+f(sp+"|"+xd+"|"+Ks)+"\\]"),Nm=f(f(il+"|"+c(Ml,_l))+"*"),RP=f(D_+"|"+v1+"(?!"+Nm+")|"+Nm),aA=f(Mn+"*"),F5=f(f(rs+"@")+"?"+RP+f("\\:"+aA)+"?"),Dm=f(il+"|"+c(Ml,_l,"[\\:\\@]")),S1=f(Dm+"*"),Av=f(Dm+"+"),EG=f(f(il+"|"+c(Ml,_l,"[\\@]"))+"+"),To=f(f("\\/"+S1)+"*"),iT=f("\\/"+f(Av+To)+"?"),MP=f(EG+To),D2=f(Av+To),I2="(?!"+Dm+")",h_=f(To+"|"+iT+"|"+MP+"|"+D2+"|"+I2),gy=f(f(Dm+"|"+c("[\\/\\?]",q_))+"*"),oA=f(f(Dm+"|[\\/\\?]")+"*"),A3=f(f("\\/\\/"+F5+To)+"|"+iT+"|"+D2+"|"+I2),LP=f(uf+"\\:"+A3+f("\\?"+gy)+"?"+f("\\#"+oA)+"?"),j5=f(f("\\/\\/"+F5+To)+"|"+iT+"|"+MP+"|"+I2),hy=f(j5+f("\\?"+gy)+"?"+f("\\#"+oA)+"?"),FP=f(LP+"|"+hy),eOe=f(uf+"\\:"+A3+f("\\?"+gy)+"?"),Mc="^("+uf+")\\:"+f(f("\\/\\/("+f("("+rs+")@")+"?("+RP+")"+f("\\:("+aA+")")+"?)")+"?("+To+"|"+iT+"|"+D2+"|"+I2+")")+f("\\?("+gy+")")+"?"+f("\\#("+oA+")")+"?$",cA="^(){0}"+f(f("\\/\\/("+f("("+rs+")@")+"?("+RP+")"+f("\\:("+aA+")")+"?)")+"?("+To+"|"+iT+"|"+MP+"|"+I2+")")+f("\\?("+gy+")")+"?"+f("\\#("+oA+")")+"?$",xG="^("+uf+")\\:"+f(f("\\/\\/("+f("("+rs+")@")+"?("+RP+")"+f("\\:("+aA+")")+"?)")+"?("+To+"|"+iT+"|"+D2+"|"+I2+")")+f("\\?("+gy+")")+"?$",B5="^"+f("\\#("+oA+")")+"?$",lA="^"+f("("+rs+")@")+"?("+RP+")"+f("\\:("+aA+")")+"?$";return{NOT_SCHEME:new RegExp(c("[^]",Vt,Mn,"[\\+\\-\\.]"),"g"),NOT_USERINFO:new RegExp(c("[^\\%\\:]",Ml,_l),"g"),NOT_HOST:new RegExp(c("[^\\%\\[\\]\\:]",Ml,_l),"g"),NOT_PATH:new RegExp(c("[^\\%\\/\\:\\@]",Ml,_l),"g"),NOT_PATH_NOSCHEME:new RegExp(c("[^\\%\\/\\@]",Ml,_l),"g"),NOT_QUERY:new RegExp(c("[^\\%]",Ml,_l,"[\\:\\@\\/\\?]",q_),"g"),NOT_FRAGMENT:new RegExp(c("[^\\%]",Ml,_l,"[\\:\\@\\/\\?]"),"g"),ESCAPE:new RegExp(c("[^]",Ml,_l),"g"),UNRESERVED:new RegExp(Ml,"g"),OTHER_CHARS:new RegExp(c("[^\\%]",Ml,m_),"g"),PCT_ENCODED:new RegExp(il,"g"),IPV4ADDRESS:new RegExp("^("+v1+")$"),IPV6ADDRESS:new RegExp("^\\[?("+xd+")"+f(f("\\%25|\\%(?!"+In+"{2})")+"("+Mo+")")+"?\\]?$")}}var me=ee(!1),de=ee(!0),Te=function(){function Ar(Vt,Vr){var Mn=[],Xn=!0,In=!1,ec=void 0;try{for(var Kl=Vt[Symbol.iterator](),il;!(Xn=(il=Kl.next()).done)&&(Mn.push(il.value),!(Vr&&Mn.length===Vr));Xn=!0);}catch(Rp){In=!0,ec=Rp}finally{try{!Xn&&Kl.return&&Kl.return()}finally{if(In)throw ec}}return Mn}return function(Vt,Vr){if(Array.isArray(Vt))return Vt;if(Symbol.iterator in Object(Vt))return Ar(Vt,Vr);throw new TypeError("Invalid attempt to destructure non-iterable instance")}}(),ut=function(Ar){if(Array.isArray(Ar)){for(var Vt=0,Vr=Array(Ar.length);Vt<Ar.length;Vt++)Vr[Vt]=Ar[Vt];return Vr}else return Array.from(Ar)},Ct=2147483647,Kt=36,xr=1,en=26,zn=38,yr=700,mr=72,Da=128,oa="-",no=/^xn--/,Cf=/[^\0-\x7E]/,hs=/[\x2E\u3002\uFF0E\uFF61]/g,Am={overflow:"Overflow: input needs wider integers to process","not-basic":"Illegal input >= 0x80 (not a basic code point)","invalid-input":"Invalid input"},v0=Kt-xr,mu=Math.floor,Fn=String.fromCharCode;function Nh(Ar){throw new RangeError(Am[Ar])}function ed(Ar,Vt){for(var Vr=[],Mn=Ar.length;Mn--;)Vr[Mn]=Vt(Ar[Mn]);return Vr}function vr(Ar,Vt){var Vr=Ar.split("@"),Mn="";Vr.length>1&&(Mn=Vr[0]+"@",Ar=Vr[1]),Ar=Ar.replace(hs,".");var Xn=Ar.split("."),In=ed(Xn,Vt).join(".");return Mn+In}function g1(Ar){for(var Vt=[],Vr=0,Mn=Ar.length;Vr<Mn;){var Xn=Ar.charCodeAt(Vr++);if(Xn>=55296&&Xn<=56319&&Vr<Mn){var In=Ar.charCodeAt(Vr++);(In&64512)==56320?Vt.push(((Xn&1023)<<10)+(In&1023)+65536):(Vt.push(Xn),Vr--)}else Vt.push(Xn)}return Vt}var ul=function(Vt){return String.fromCodePoint.apply(String,ut(Vt))},ip=function(Vt){return Vt-48<10?Vt-22:Vt-65<26?Vt-65:Vt-97<26?Vt-97:Kt},_a=function(Vt,Vr){return Vt+22+75*(Vt<26)-((Vr!=0)<<5)},bv=function(Vt,Vr,Mn){var Xn=0;for(Vt=Mn?mu(Vt/yr):Vt>>1,Vt+=mu(Vt/Vr);Vt>v0*en>>1;Xn+=Kt)Vt=mu(Vt/v0);return mu(Xn+(v0+1)*Vt/(Vt+zn))},A2=function(Vt){var Vr=[],Mn=Vt.length,Xn=0,In=Da,ec=mr,Kl=Vt.lastIndexOf(oa);Kl<0&&(Kl=0);for(var il=0;il<Kl;++il)Vt.charCodeAt(il)>=128&&Nh("not-basic"),Vr.push(Vt.charCodeAt(il));for(var Rp=Kl>0?Kl+1:0;Rp<Mn;){for(var _l=Xn,m_=1,Jf=Kt;;Jf+=Kt){Rp>=Mn&&Nh("invalid-input");var q_=ip(Vt.charCodeAt(Rp++));(q_>=Kt||q_>mu((Ct-Xn)/m_))&&Nh("overflow"),Xn+=q_*m_;var Ml=Jf<=ec?xr:Jf>=ec+en?en:Jf-ec;if(q_<Ml)break;var uf=Kt-Ml;m_>mu(Ct/uf)&&Nh("overflow"),m_*=uf}var rs=Vr.length+1;ec=bv(Xn-_l,rs,_l==0),mu(Xn/rs)>Ct-In&&Nh("overflow"),In+=mu(Xn/rs),Xn%=rs,Vr.splice(Xn++,0,In)}return String.fromCodePoint.apply(String,Vr)},nA=function(Vt){var Vr=[];Vt=g1(Vt);var Mn=Vt.length,Xn=Da,In=0,ec=mr,Kl=!0,il=!1,Rp=void 0;try{for(var _l=Vt[Symbol.iterator](),m_;!(Kl=(m_=_l.next()).done);Kl=!0){var Jf=m_.value;Jf<128&&Vr.push(Fn(Jf))}}catch(sp){il=!0,Rp=sp}finally{try{!Kl&&_l.return&&_l.return()}finally{if(il)throw Rp}}var q_=Vr.length,Ml=q_;for(q_&&Vr.push(oa);Ml<Mn;){var uf=Ct,rs=!0,g_=!1,my=void 0;try{for(var v1=Vt[Symbol.iterator](),Pu;!(rs=(Pu=v1.next()).done);rs=!0){var Ug=Pu.value;Ug>=Xn&&Ug<uf&&(uf=Ug)}}catch(sp){g_=!0,my=sp}finally{try{!rs&&v1.return&&v1.return()}finally{if(g_)throw my}}var os=Ml+1;uf-Xn>mu((Ct-In)/os)&&Nh("overflow"),In+=(uf-Xn)*os,Xn=uf;var Pm=!0,vs=!1,Mp=void 0;try{for(var ii=Vt[Symbol.iterator](),ta;!(Pm=(ta=ii.next()).done);Pm=!0){var ja=ta.value;if(ja<Xn&&++In>Ct&&Nh("overflow"),ja==Xn){for(var qf=In,em=Kt;;em+=Kt){var xd=em<=ec?xr:em>=ec+en?en:em-ec;if(qf<xd)break;var Mo=qf-xd,gw=Kt-xd;Vr.push(Fn(_a(xd+Mo%gw,0))),qf=mu(Mo/gw)}Vr.push(Fn(_a(qf,0))),ec=bv(In,os,Ml==q_),In=0,++Ml}}}catch(sp){vs=!0,Mp=sp}finally{try{!Pm&&ii.return&&ii.return()}finally{if(vs)throw Mp}}++In,++Xn}return Vr.join("")},Jo=function(Vt){return vr(Vt,function(Vr){return no.test(Vr)?A2(Vr.slice(4).toLowerCase()):Vr})},Wi=function(Vt){return vr(Vt,function(Vr){return Cf.test(Vr)?"xn--"+nA(Vr):Vr})},S0={version:"2.1.0",ucs2:{decode:g1,encode:ul},decode:A2,encode:nA,toASCII:Wi,toUnicode:Jo},Rl={};function km(Ar){var Vt=Ar.charCodeAt(0),Vr=void 0;return Vt<16?Vr="%0"+Vt.toString(16).toUpperCase():Vt<128?Vr="%"+Vt.toString(16).toUpperCase():Vt<2048?Vr="%"+(Vt>>6|192).toString(16).toUpperCase()+"%"+(Vt&63|128).toString(16).toUpperCase():Vr="%"+(Vt>>12|224).toString(16).toUpperCase()+"%"+(Vt>>6&63|128).toString(16).toUpperCase()+"%"+(Vt&63|128).toString(16).toUpperCase(),Vr}function Zd(Ar){for(var Vt="",Vr=0,Mn=Ar.length;Vr<Mn;){var Xn=parseInt(Ar.substr(Vr+1,2),16);if(Xn<128)Vt+=String.fromCharCode(Xn),Vr+=3;else if(Xn>=194&&Xn<224){if(Mn-Vr>=6){var In=parseInt(Ar.substr(Vr+4,2),16);Vt+=String.fromCharCode((Xn&31)<<6|In&63)}else Vt+=Ar.substr(Vr,6);Vr+=6}else if(Xn>=224){if(Mn-Vr>=9){var ec=parseInt(Ar.substr(Vr+4,2),16),Kl=parseInt(Ar.substr(Vr+7,2),16);Vt+=String.fromCharCode((Xn&15)<<12|(ec&63)<<6|Kl&63)}else Vt+=Ar.substr(Vr,9);Vr+=9}else Vt+=Ar.substr(Vr,3),Vr+=3}return Vt}function k2(Ar,Vt){function Vr(Mn){var Xn=Zd(Mn);return Xn.match(Vt.UNRESERVED)?Xn:Mn}return Ar.scheme&&(Ar.scheme=String(Ar.scheme).replace(Vt.PCT_ENCODED,Vr).toLowerCase().replace(Vt.NOT_SCHEME,"")),Ar.userinfo!==void 0&&(Ar.userinfo=String(Ar.userinfo).replace(Vt.PCT_ENCODED,Vr).replace(Vt.NOT_USERINFO,km).replace(Vt.PCT_ENCODED,x)),Ar.host!==void 0&&(Ar.host=String(Ar.host).replace(Vt.PCT_ENCODED,Vr).toLowerCase().replace(Vt.NOT_HOST,km).replace(Vt.PCT_ENCODED,x)),Ar.path!==void 0&&(Ar.path=String(Ar.path).replace(Vt.PCT_ENCODED,Vr).replace(Ar.scheme?Vt.NOT_PATH:Vt.NOT_PATH_NOSCHEME,km).replace(Vt.PCT_ENCODED,x)),Ar.query!==void 0&&(Ar.query=String(Ar.query).replace(Vt.PCT_ENCODED,Vr).replace(Vt.NOT_QUERY,km).replace(Vt.PCT_ENCODED,x)),Ar.fragment!==void 0&&(Ar.fragment=String(Ar.fragment).replace(Vt.PCT_ENCODED,Vr).replace(Vt.NOT_FRAGMENT,km).replace(Vt.PCT_ENCODED,x)),Ar}function P2(Ar){return Ar.replace(/^0*(.*)/,"$1")||"0"}function Fg(Ar,Vt){var Vr=Ar.match(Vt.IPV4ADDRESS)||[],Mn=Te(Vr,2),Xn=Mn[1];return Xn?Xn.split(".").map(P2).join("."):Ar}function Tt(Ar,Vt){var Vr=Ar.match(Vt.IPV6ADDRESS)||[],Mn=Te(Vr,3),Xn=Mn[1],In=Mn[2];if(Xn){for(var ec=Xn.toLowerCase().split("::").reverse(),Kl=Te(ec,2),il=Kl[0],Rp=Kl[1],_l=Rp?Rp.split(":").map(P2):[],m_=il.split(":").map(P2),Jf=Vt.IPV4ADDRESS.test(m_[m_.length-1]),q_=Jf?7:8,Ml=m_.length-q_,uf=Array(q_),rs=0;rs<q_;++rs)uf[rs]=_l[rs]||m_[Ml+rs]||"";Jf&&(uf[q_-1]=Fg(uf[q_-1],Vt));var g_=uf.reduce(function(os,Pm,vs){if(!Pm||Pm==="0"){var Mp=os[os.length-1];Mp&&Mp.index+Mp.length===vs?Mp.length++:os.push({index:vs,length:1})}return os},[]),my=g_.sort(function(os,Pm){return Pm.length-os.length})[0],v1=void 0;if(my&&my.length>1){var Pu=uf.slice(0,my.index),Ug=uf.slice(my.index+my.length);v1=Pu.join(":")+"::"+Ug.join(":")}else v1=uf.join(":");return In&&(v1+="%"+In),v1}else return Ar}var Ev=/^(?:([^:\/?#]+):)?(?:\/\/((?:([^\/?#@]*)@)?(\[[^\/?#\]]+\]|[^\/?#:]*)(?:\:(\d*))?))?([^?#]*)(?:\?([^#]*))?(?:#((?:.|\n|\r)*))?/i,ys="".match(/(){0}/)[1]===void 0;function xv(Ar){var Vt=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Vr={},Mn=Vt.iri!==!1?de:me;Vt.reference==="suffix"&&(Ar=(Vt.scheme?Vt.scheme+":":"")+"//"+Ar);var Xn=Ar.match(Ev);if(Xn){ys?(Vr.scheme=Xn[1],Vr.userinfo=Xn[3],Vr.host=Xn[4],Vr.port=parseInt(Xn[5],10),Vr.path=Xn[6]||"",Vr.query=Xn[7],Vr.fragment=Xn[8],isNaN(Vr.port)&&(Vr.port=Xn[5])):(Vr.scheme=Xn[1]||void 0,Vr.userinfo=Ar.indexOf("@")!==-1?Xn[3]:void 0,Vr.host=Ar.indexOf("//")!==-1?Xn[4]:void 0,Vr.port=parseInt(Xn[5],10),Vr.path=Xn[6]||"",Vr.query=Ar.indexOf("?")!==-1?Xn[7]:void 0,Vr.fragment=Ar.indexOf("#")!==-1?Xn[8]:void 0,isNaN(Vr.port)&&(Vr.port=Ar.match(/\/\/(?:.|\n)*\:(?:\/|\?|\#|$)/)?Xn[4]:void 0)),Vr.host&&(Vr.host=Tt(Fg(Vr.host,Mn),Mn)),Vr.scheme===void 0&&Vr.userinfo===void 0&&Vr.host===void 0&&Vr.port===void 0&&!Vr.path&&Vr.query===void 0?Vr.reference="same-document":Vr.scheme===void 0?Vr.reference="relative":Vr.fragment===void 0?Vr.reference="absolute":Vr.reference="uri",Vt.reference&&Vt.reference!=="suffix"&&Vt.reference!==Vr.reference&&(Vr.error=Vr.error||"URI is not a "+Vt.reference+" reference.");var In=Rl[(Vt.scheme||Vr.scheme||"").toLowerCase()];if(!Vt.unicodeSupport&&(!In||!In.unicodeSupport)){if(Vr.host&&(Vt.domainHost||In&&In.domainHost))try{Vr.host=S0.toASCII(Vr.host.replace(Mn.PCT_ENCODED,Zd).toLowerCase())}catch(ec){Vr.error=Vr.error||"Host's domain name can not be converted to ASCII via punycode: "+ec}k2(Vr,me)}else k2(Vr,Mn);In&&In.parse&&In.parse(Vr,Vt)}else Vr.error=Vr.error||"URI can not be parsed.";return Vr}function tT(Ar,Vt){var Vr=Vt.iri!==!1?de:me,Mn=[];return Ar.userinfo!==void 0&&(Mn.push(Ar.userinfo),Mn.push("@")),Ar.host!==void 0&&Mn.push(Tt(Fg(String(Ar.host),Vr),Vr).replace(Vr.IPV6ADDRESS,function(Xn,In,ec){return"["+In+(ec?"%25"+ec:"")+"]"})),(typeof Ar.port=="number"||typeof Ar.port=="string")&&(Mn.push(":"),Mn.push(String(Ar.port))),Mn.length?Mn.join(""):void 0}var dw=/^\.\.?\//,mw=/^\/\.(\/|$)/,Dh=/^\/\.\.(\/|$)/,C3=/^\/?(?:.|\n)*?(?=\/|$)/;function h1(Ar){for(var Vt=[];Ar.length;)if(Ar.match(dw))Ar=Ar.replace(dw,"");else if(Ar.match(mw))Ar=Ar.replace(mw,"/");else if(Ar.match(Dh))Ar=Ar.replace(Dh,"/"),Vt.pop();else if(Ar==="."||Ar==="..")Ar="";else{var Vr=Ar.match(C3);if(Vr){var Mn=Vr[0];Ar=Ar.slice(Mn.length),Vt.push(Mn)}else throw new Error("Unexpected dot segment condition")}return Vt.join("")}function lf(Ar){var Vt=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Vr=Vt.iri?de:me,Mn=[],Xn=Rl[(Vt.scheme||Ar.scheme||"").toLowerCase()];if(Xn&&Xn.serialize&&Xn.serialize(Ar,Vt),Ar.host&&!Vr.IPV6ADDRESS.test(Ar.host)){if(Vt.domainHost||Xn&&Xn.domainHost)try{Ar.host=Vt.iri?S0.toUnicode(Ar.host):S0.toASCII(Ar.host.replace(Vr.PCT_ENCODED,Zd).toLowerCase())}catch(Kl){Ar.error=Ar.error||"Host's domain name can not be converted to "+(Vt.iri?"Unicode":"ASCII")+" via punycode: "+Kl}}k2(Ar,Vr),Vt.reference!=="suffix"&&Ar.scheme&&(Mn.push(Ar.scheme),Mn.push(":"));var In=tT(Ar,Vt);if(In!==void 0&&(Vt.reference!=="suffix"&&Mn.push("//"),Mn.push(In),Ar.path&&Ar.path.charAt(0)!=="/"&&Mn.push("/")),Ar.path!==void 0){var ec=Ar.path;!Vt.absolutePath&&(!Xn||!Xn.absolutePath)&&(ec=h1(ec)),In===void 0&&(ec=ec.replace(/^\/\//,"/%2F")),Mn.push(ec)}return Ar.query!==void 0&&(Mn.push("?"),Mn.push(Ar.query)),Ar.fragment!==void 0&&(Mn.push("#"),Mn.push(Ar.fragment)),Mn.join("")}function rT(Ar,Vt){var Vr=arguments.length>2&&arguments[2]!==void 0?arguments[2]:{},Mn=arguments[3],Xn={};return Mn||(Ar=xv(lf(Ar,Vr),Vr),Vt=xv(lf(Vt,Vr),Vr)),Vr=Vr||{},!Vr.tolerant&&Vt.scheme?(Xn.scheme=Vt.scheme,Xn.userinfo=Vt.userinfo,Xn.host=Vt.host,Xn.port=Vt.port,Xn.path=h1(Vt.path||""),Xn.query=Vt.query):(Vt.userinfo!==void 0||Vt.host!==void 0||Vt.port!==void 0?(Xn.userinfo=Vt.userinfo,Xn.host=Vt.host,Xn.port=Vt.port,Xn.path=h1(Vt.path||""),Xn.query=Vt.query):(Vt.path?(Vt.path.charAt(0)==="/"?Xn.path=h1(Vt.path):((Ar.userinfo!==void 0||Ar.host!==void 0||Ar.port!==void 0)&&!Ar.path?Xn.path="/"+Vt.path:Ar.path?Xn.path=Ar.path.slice(0,Ar.path.lastIndexOf("/")+1)+Vt.path:Xn.path=Vt.path,Xn.path=h1(Xn.path)),Xn.query=Vt.query):(Xn.path=Ar.path,Vt.query!==void 0?Xn.query=Vt.query:Xn.query=Ar.query),Xn.userinfo=Ar.userinfo,Xn.host=Ar.host,Xn.port=Ar.port),Xn.scheme=Ar.scheme),Xn.fragment=Vt.fragment,Xn}function iA(Ar,Vt,Vr){var Mn=F({scheme:"null"},Vr);return lf(rT(xv(Ar,Mn),xv(Vt,Mn),Mn,!0),Mn)}function Mb(Ar,Vt){return typeof Ar=="string"?Ar=lf(xv(Ar,Vt),Vt):v(Ar)==="object"&&(Ar=xv(lf(Ar,Vt),Vt)),Ar}function td(Ar,Vt,Vr){return typeof Ar=="string"?Ar=lf(xv(Ar,Vr),Vr):v(Ar)==="object"&&(Ar=lf(Ar,Vr)),typeof Vt=="string"?Vt=lf(xv(Vt,Vr),Vr):v(Vt)==="object"&&(Vt=lf(Vt,Vr)),Ar===Vt}function y1(Ar,Vt){return Ar&&Ar.toString().replace(!Vt||!Vt.iri?me.ESCAPE:de.ESCAPE,km)}function dy(Ar,Vt){return Ar&&Ar.toString().replace(!Vt||!Vt.iri?me.PCT_ENCODED:de.PCT_ENCODED,Zd)}var Pr={scheme:"http",domainHost:!0,parse:function(Vt,Vr){return Vt.host||(Vt.error=Vt.error||"HTTP URIs must have a host."),Vt},serialize:function(Vt,Vr){var Mn=String(Vt.scheme).toLowerCase()==="https";return(Vt.port===(Mn?443:80)||Vt.port==="")&&(Vt.port=void 0),Vt.path||(Vt.path="/"),Vt}},Cv={scheme:"https",domainHost:Pr.domainHost,parse:Pr.parse,serialize:Pr.serialize};function N2(Ar){return typeof Ar.secure=="boolean"?Ar.secure:String(Ar.scheme).toLowerCase()==="wss"}var jt={scheme:"ws",domainHost:!0,parse:function(Vt,Vr){var Mn=Vt;return Mn.secure=N2(Mn),Mn.resourceName=(Mn.path||"/")+(Mn.query?"?"+Mn.query:""),Mn.path=void 0,Mn.query=void 0,Mn},serialize:function(Vt,Vr){if((Vt.port===(N2(Vt)?443:80)||Vt.port==="")&&(Vt.port=void 0),typeof Vt.secure=="boolean"&&(Vt.scheme=Vt.secure?"wss":"ws",Vt.secure=void 0),Vt.resourceName){var Mn=Vt.resourceName.split("?"),Xn=Te(Mn,2),In=Xn[0],ec=Xn[1];Vt.path=In&&In!=="/"?In:void 0,Vt.query=ec,Vt.resourceName=void 0}return Vt.fragment=void 0,Vt}},ln={scheme:"wss",domainHost:jt.domainHost,parse:jt.parse,serialize:jt.serialize},ai={},Js=!0,Fa="[A-Za-z0-9\\-\\.\\_\\~"+(Js?"\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF":"")+"]",Xl="[0-9A-Fa-f]",cu=f(f("%[EFef]"+Xl+"%"+Xl+Xl+"%"+Xl+Xl)+"|"+f("%[89A-Fa-f]"+Xl+"%"+Xl+Xl)+"|"+f("%"+Xl+Xl)),Bc="[A-Za-z0-9\\!\\$\\%\\'\\*\\+\\-\\^\\_\\`\\{\\|\\}\\~]",qi="[\\!\\$\\%\\'\\(\\)\\*\\+\\,\\-\\.0-9\\<\\>A-Z\\x5E-\\x7E]",Oa=c(qi,'[\\"\\\\]'),di="[\\!\\$\\'\\(\\)\\*\\+\\,\\;\\:\\@]",Ja=new RegExp(Fa,"g"),Is=new RegExp(cu,"g"),Rs=new RegExp(c("[^]",Bc,"[\\.]",'[\\"]',Oa),"g"),nl=new RegExp(c("[^]",Fa,di),"g"),jg=nl;function Op(Ar){var Vt=Zd(Ar);return Vt.match(Ja)?Vt:Ar}var sA={scheme:"mailto",parse:function(Vt,Vr){var Mn=Vt,Xn=Mn.to=Mn.path?Mn.path.split(","):[];if(Mn.path=void 0,Mn.query){for(var In=!1,ec={},Kl=Mn.query.split("&"),il=0,Rp=Kl.length;il<Rp;++il){var _l=Kl[il].split("=");switch(_l[0]){case"to":for(var m_=_l[1].split(","),Jf=0,q_=m_.length;Jf<q_;++Jf)Xn.push(m_[Jf]);break;case"subject":Mn.subject=dy(_l[1],Vr);break;case"body":Mn.body=dy(_l[1],Vr);break;default:In=!0,ec[dy(_l[0],Vr)]=dy(_l[1],Vr);break}}In&&(Mn.headers=ec)}Mn.query=void 0;for(var Ml=0,uf=Xn.length;Ml<uf;++Ml){var rs=Xn[Ml].split("@");if(rs[0]=dy(rs[0]),Vr.unicodeSupport)rs[1]=dy(rs[1],Vr).toLowerCase();else try{rs[1]=S0.toASCII(dy(rs[1],Vr).toLowerCase())}catch(g_){Mn.error=Mn.error||"Email address's domain name can not be converted to ASCII via punycode: "+g_}Xn[Ml]=rs.join("@")}return Mn},serialize:function(Vt,Vr){var Mn=Vt,Xn=w(Vt.to);if(Xn){for(var In=0,ec=Xn.length;In<ec;++In){var Kl=String(Xn[In]),il=Kl.lastIndexOf("@"),Rp=Kl.slice(0,il).replace(Is,Op).replace(Is,x).replace(Rs,km),_l=Kl.slice(il+1);try{_l=Vr.iri?S0.toUnicode(_l):S0.toASCII(dy(_l,Vr).toLowerCase())}catch(Ml){Mn.error=Mn.error||"Email address's domain name can not be converted to "+(Vr.iri?"Unicode":"ASCII")+" via punycode: "+Ml}Xn[In]=Rp+"@"+_l}Mn.path=Xn.join(",")}var m_=Vt.headers=Vt.headers||{};Vt.subject&&(m_.subject=Vt.subject),Vt.body&&(m_.body=Vt.body);var Jf=[];for(var q_ in m_)m_[q_]!==ai[q_]&&Jf.push(q_.replace(Is,Op).replace(Is,x).replace(nl,km)+"="+m_[q_].replace(Is,Op).replace(Is,x).replace(jg,km));return Jf.length&&(Mn.query=Jf.join("&")),Mn}},Bg=/^([^\:]+)\:(.*)/,nT={scheme:"urn",parse:function(Vt,Vr){var Mn=Vt.path&&Vt.path.match(Bg),Xn=Vt;if(Mn){var In=Vr.scheme||Xn.scheme||"urn",ec=Mn[1].toLowerCase(),Kl=Mn[2],il=In+":"+(Vr.nid||ec),Rp=Rl[il];Xn.nid=ec,Xn.nss=Kl,Xn.path=void 0,Rp&&(Xn=Rp.parse(Xn,Vr))}else Xn.error=Xn.error||"URN can not be parsed.";return Xn},serialize:function(Vt,Vr){var Mn=Vr.scheme||Vt.scheme||"urn",Xn=Vt.nid,In=Mn+":"+(Vr.nid||Xn),ec=Rl[In];ec&&(Vt=ec.serialize(Vt,Vr));var Kl=Vt,il=Vt.nss;return Kl.path=(Xn||Vr.nid)+":"+il,Kl}},d_=/^[0-9A-Fa-f]{8}(?:\-[0-9A-Fa-f]{4}){3}\-[0-9A-Fa-f]{12}$/,wo={scheme:"urn:uuid",parse:function(Vt,Vr){var Mn=Vt;return Mn.uuid=Mn.nss,Mn.nss=void 0,!Vr.tolerant&&(!Mn.uuid||!Mn.uuid.match(d_))&&(Mn.error=Mn.error||"UUID is not valid."),Mn},serialize:function(Vt,Vr){var Mn=Vt;return Mn.nss=(Vt.uuid||"").toLowerCase(),Mn}};Rl[Pr.scheme]=Pr,Rl[Cv.scheme]=Cv,Rl[jt.scheme]=jt,Rl[ln.scheme]=ln,Rl[sA.scheme]=sA,Rl[nT.scheme]=nT,Rl[wo.scheme]=wo,u.SCHEMES=Rl,u.pctEncChar=km,u.pctDecChars=Zd,u.parse=xv,u.removeDotSegments=h1,u.serialize=lf,u.resolveComponents=rT,u.resolve=iA,u.normalize=Mb,u.equal=td,u.escapeComponent=y1,u.unescapeComponent=dy,Object.defineProperty(u,"__esModule",{value:!0})})});var wlt=At(LIe=>{"use strict";Object.defineProperty(LIe,"__esModule",{value:!0});var Ilt=Dlt();Ilt.code='require("ajv/dist/runtime/uri").default';LIe.default=Ilt});var Ult=At(m0=>{"use strict";Object.defineProperty(m0,"__esModule",{value:!0});m0.CodeGen=m0.Name=m0.nil=m0.stringify=m0.str=m0._=m0.KeywordCxt=void 0;var mZt=DW();Object.defineProperty(m0,"KeywordCxt",{enumerable:!0,get:function(){return mZt.KeywordCxt}});var QF=Hl();Object.defineProperty(m0,"_",{enumerable:!0,get:function(){return QF._}});Object.defineProperty(m0,"str",{enumerable:!0,get:function(){return QF.str}});Object.defineProperty(m0,"stringify",{enumerable:!0,get:function(){return QF.stringify}});Object.defineProperty(m0,"nil",{enumerable:!0,get:function(){return QF.nil}});Object.defineProperty(m0,"Name",{enumerable:!0,get:function(){return QF.Name}});Object.defineProperty(m0,"CodeGen",{enumerable:!0,get:function(){return QF.CodeGen}});var gZt=xue(),Flt=Cue(),hZt=gIe(),IW=kue(),yZt=Hl(),wW=kW(),Nue=AW(),jIe=Qu(),Olt=Plt(),vZt=wlt(),jlt=(u,c)=>new RegExp(u,c);jlt.code="new RegExp";var SZt=["removeAdditional","useDefaults","coerceTypes"],TZt=new Set(["validate","serialize","parse","wrapper","root","schema","keyword","pattern","formats","validate$data","func","obj","Error"]),bZt={errorDataPath:"",format:"`validateFormats: false` can be used instead.",nullable:'"nullable" keyword is supported by default.',jsonPointers:"Deprecated jsPropertySyntax can be used instead.",extendRefs:"Deprecated ignoreKeywordsWithRef can be used instead.",missingRefs:"Pass empty schema with $id that should be ignored to ajv.addSchema.",processCode:"Use option `code: {process: (code, schemaEnv: object) => string}`",sourceCode:"Use option `code: {source: true}`",strictDefaults:"It is default now, see option `strict`.",strictKeywords:"It is default now, see option `strict`.",uniqueItems:'"uniqueItems" keyword is always validated.',unknownFormats:"Disable strict mode or pass `true` to `ajv.addFormat` (or `formats` option).",cache:"Map is used as cache, schema object as key.",serialize:"Map is used as cache, schema object as key.",ajvErrors:"It is default now."},EZt={ignoreKeywordsWithRef:"",jsPropertySyntax:"",unicode:'"minLength"/"maxLength" account for unicode characters by default.'},Rlt=200;function xZt(u){var c,f,v,x,w,F,ee,me,de,Te,ut,Ct,Kt,xr,en,zn,yr,mr,Da,oa,no,Cf,hs,Am,v0;let mu=u.strict,Fn=(c=u.code)===null||c===void 0?void 0:c.optimize,Nh=Fn===!0||Fn===void 0?1:Fn||0,ed=(v=(f=u.code)===null||f===void 0?void 0:f.regExp)!==null&&v!==void 0?v:jlt,vr=(x=u.uriResolver)!==null&&x!==void 0?x:vZt.default;return{strictSchema:(F=(w=u.strictSchema)!==null&&w!==void 0?w:mu)!==null&&F!==void 0?F:!0,strictNumbers:(me=(ee=u.strictNumbers)!==null&&ee!==void 0?ee:mu)!==null&&me!==void 0?me:!0,strictTypes:(Te=(de=u.strictTypes)!==null&&de!==void 0?de:mu)!==null&&Te!==void 0?Te:"log",strictTuples:(Ct=(ut=u.strictTuples)!==null&&ut!==void 0?ut:mu)!==null&&Ct!==void 0?Ct:"log",strictRequired:(xr=(Kt=u.strictRequired)!==null&&Kt!==void 0?Kt:mu)!==null&&xr!==void 0?xr:!1,code:u.code?{...u.code,optimize:Nh,regExp:ed}:{optimize:Nh,regExp:ed},loopRequired:(en=u.loopRequired)!==null&&en!==void 0?en:Rlt,loopEnum:(zn=u.loopEnum)!==null&&zn!==void 0?zn:Rlt,meta:(yr=u.meta)!==null&&yr!==void 0?yr:!0,messages:(mr=u.messages)!==null&&mr!==void 0?mr:!0,inlineRefs:(Da=u.inlineRefs)!==null&&Da!==void 0?Da:!0,schemaId:(oa=u.schemaId)!==null&&oa!==void 0?oa:"$id",addUsedSchema:(no=u.addUsedSchema)!==null&&no!==void 0?no:!0,validateSchema:(Cf=u.validateSchema)!==null&&Cf!==void 0?Cf:!0,validateFormats:(hs=u.validateFormats)!==null&&hs!==void 0?hs:!0,unicodeRegExp:(Am=u.unicodeRegExp)!==null&&Am!==void 0?Am:!0,int32range:(v0=u.int32range)!==null&&v0!==void 0?v0:!0,uriResolver:vr}}var OW=class{constructor(c={}){this.schemas={},this.refs={},this.formats={},this._compilations=new Set,this._loading={},this._cache=new Map,c=this.opts={...c,...xZt(c)};let{es5:f,lines:v}=this.opts.code;this.scope=new yZt.ValueScope({scope:{},prefixes:TZt,es5:f,lines:v}),this.logger=DZt(c.logger);let x=c.validateFormats;c.validateFormats=!1,this.RULES=(0,hZt.getRules)(),Mlt.call(this,bZt,c,"NOT SUPPORTED"),Mlt.call(this,EZt,c,"DEPRECATED","warn"),this._metaOpts=PZt.call(this),c.formats&&AZt.call(this),this._addVocabularies(),this._addDefaultMetaSchema(),c.keywords&&kZt.call(this,c.keywords),typeof c.meta=="object"&&this.addMetaSchema(c.meta),CZt.call(this),c.validateFormats=x}_addVocabularies(){this.addKeyword("$async")}_addDefaultMetaSchema(){let{$data:c,meta:f,schemaId:v}=this.opts,x=Olt;v==="id"&&(x={...Olt},x.id=x.$id,delete x.$id),f&&c&&this.addMetaSchema(x,x[v],!1)}defaultMeta(){let{meta:c,schemaId:f}=this.opts;return this.opts.defaultMeta=typeof c=="object"?c[f]||c:void 0}validate(c,f){let v;if(typeof c=="string"){if(v=this.getSchema(c),!v)throw new Error(`no schema with key or ref "${c}"`)}else v=this.compile(c);let x=v(f);return"$async"in v||(this.errors=v.errors),x}compile(c,f){let v=this._addSchema(c,f);return v.validate||this._compileSchemaEnv(v)}compileAsync(c,f){if(typeof this.opts.loadSchema!="function")throw new Error("options.loadSchema should be a function");let{loadSchema:v}=this.opts;return x.call(this,c,f);async function x(Te,ut){await w.call(this,Te.$schema);let Ct=this._addSchema(Te,ut);return Ct.validate||F.call(this,Ct)}async function w(Te){Te&&!this.getSchema(Te)&&await x.call(this,{$ref:Te},!0)}async function F(Te){try{return this._compileSchemaEnv(Te)}catch(ut){if(!(ut instanceof Flt.default))throw ut;return ee.call(this,ut),await me.call(this,ut.missingSchema),F.call(this,Te)}}function ee({missingSchema:Te,missingRef:ut}){if(this.refs[Te])throw new Error(`AnySchema ${Te} is loaded but ${ut} cannot be resolved`)}async function me(Te){let ut=await de.call(this,Te);this.refs[Te]||await w.call(this,ut.$schema),this.refs[Te]||this.addSchema(ut,Te,f)}async function de(Te){let ut=this._loading[Te];if(ut)return ut;try{return await(this._loading[Te]=v(Te))}finally{delete this._loading[Te]}}}addSchema(c,f,v,x=this.opts.validateSchema){if(Array.isArray(c)){for(let F of c)this.addSchema(F,void 0,v,x);return this}let w;if(typeof c=="object"){let{schemaId:F}=this.opts;if(w=c[F],w!==void 0&&typeof w!="string")throw new Error(`schema ${F} must be string`)}return f=(0,wW.normalizeId)(f||w),this._checkUnique(f),this.schemas[f]=this._addSchema(c,v,f,x,!0),this}addMetaSchema(c,f,v=this.opts.validateSchema){return this.addSchema(c,f,!0,v),this}validateSchema(c,f){if(typeof c=="boolean")return!0;let v;if(v=c.$schema,v!==void 0&&typeof v!="string")throw new Error("$schema must be a string");if(v=v||this.opts.defaultMeta||this.defaultMeta(),!v)return this.logger.warn("meta-schema not available"),this.errors=null,!0;let x=this.validate(v,c);if(!x&&f){let w="schema is invalid: "+this.errorsText();if(this.opts.validateSchema==="log")this.logger.error(w);else throw new Error(w)}return x}getSchema(c){let f;for(;typeof(f=Llt.call(this,c))=="string";)c=f;if(f===void 0){let{schemaId:v}=this.opts,x=new IW.SchemaEnv({schema:{},schemaId:v});if(f=IW.resolveSchema.call(this,x,c),!f)return;this.refs[c]=f}return f.validate||this._compileSchemaEnv(f)}removeSchema(c){if(c instanceof RegExp)return this._removeAllSchemas(this.schemas,c),this._removeAllSchemas(this.refs,c),this;switch(typeof c){case"undefined":return this._removeAllSchemas(this.schemas),this._removeAllSchemas(this.refs),this._cache.clear(),this;case"string":{let f=Llt.call(this,c);return typeof f=="object"&&this._cache.delete(f.schema),delete this.schemas[c],delete this.refs[c],this}case"object":{let f=c;this._cache.delete(f);let v=c[this.opts.schemaId];return v&&(v=(0,wW.normalizeId)(v),delete this.schemas[v],delete this.refs[v]),this}default:throw new Error("ajv.removeSchema: invalid parameter")}}addVocabulary(c){for(let f of c)this.addKeyword(f);return this}addKeyword(c,f){let v;if(typeof c=="string")v=c,typeof f=="object"&&(this.logger.warn("these parameters are deprecated, see docs for addKeyword"),f.keyword=v);else if(typeof c=="object"&&f===void 0){if(f=c,v=f.keyword,Array.isArray(v)&&!v.length)throw new Error("addKeywords: keyword must be string or non-empty array")}else throw new Error("invalid addKeywords parameters");if(wZt.call(this,v,f),!f)return(0,jIe.eachItem)(v,w=>FIe.call(this,w)),this;RZt.call(this,f);let x={...f,type:(0,Nue.getJSONTypes)(f.type),schemaType:(0,Nue.getJSONTypes)(f.schemaType)};return(0,jIe.eachItem)(v,x.type.length===0?w=>FIe.call(this,w,x):w=>x.type.forEach(F=>FIe.call(this,w,x,F))),this}getKeyword(c){let f=this.RULES.all[c];return typeof f=="object"?f.definition:!!f}removeKeyword(c){let{RULES:f}=this;delete f.keywords[c],delete f.all[c];for(let v of f.rules){let x=v.rules.findIndex(w=>w.keyword===c);x>=0&&v.rules.splice(x,1)}return this}addFormat(c,f){return typeof f=="string"&&(f=new RegExp(f)),this.formats[c]=f,this}errorsText(c=this.errors,{separator:f=", ",dataVar:v="data"}={}){return!c||c.length===0?"No errors":c.map(x=>`${v}${x.instancePath} ${x.message}`).reduce((x,w)=>x+f+w)}$dataMetaSchema(c,f){let v=this.RULES.all;c=JSON.parse(JSON.stringify(c));for(let x of f){let w=x.split("/").slice(1),F=c;for(let ee of w)F=F[ee];for(let ee in v){let me=v[ee];if(typeof me!="object")continue;let{$data:de}=me.definition,Te=F[ee];de&&Te&&(F[ee]=Blt(Te))}}return c}_removeAllSchemas(c,f){for(let v in c){let x=c[v];(!f||f.test(v))&&(typeof x=="string"?delete c[v]:x&&!x.meta&&(this._cache.delete(x.schema),delete c[v]))}}_addSchema(c,f,v,x=this.opts.validateSchema,w=this.opts.addUsedSchema){let F,{schemaId:ee}=this.opts;if(typeof c=="object")F=c[ee];else{if(this.opts.jtd)throw new Error("schema must be object");if(typeof c!="boolean")throw new Error("schema must be object or boolean")}let me=this._cache.get(c);if(me!==void 0)return me;v=(0,wW.normalizeId)(F||v);let de=wW.getSchemaRefs.call(this,c,v);return me=new IW.SchemaEnv({schema:c,schemaId:ee,meta:f,baseId:v,localRefs:de}),this._cache.set(me.schema,me),w&&!v.startsWith("#")&&(v&&this._checkUnique(v),this.refs[v]=me),x&&this.validateSchema(c,!0),me}_checkUnique(c){if(this.schemas[c]||this.refs[c])throw new Error(`schema with key or id "${c}" already exists`)}_compileSchemaEnv(c){if(c.meta?this._compileMetaSchema(c):IW.compileSchema.call(this,c),!c.validate)throw new Error("ajv implementation error");return c.validate}_compileMetaSchema(c){let f=this.opts;this.opts=this._metaOpts;try{IW.compileSchema.call(this,c)}finally{this.opts=f}}};OW.ValidationError=gZt.default;OW.MissingRefError=Flt.default;m0.default=OW;function Mlt(u,c,f,v="error"){for(let x in u){let w=x;w in c&&this.logger[v](`${f}: option ${x}. ${u[w]}`)}}function Llt(u){return u=(0,wW.normalizeId)(u),this.schemas[u]||this.refs[u]}function CZt(){let u=this.opts.schemas;if(u)if(Array.isArray(u))this.addSchema(u);else for(let c in u)this.addSchema(u[c],c)}function AZt(){for(let u in this.opts.formats){let c=this.opts.formats[u];c&&this.addFormat(u,c)}}function kZt(u){if(Array.isArray(u)){this.addVocabulary(u);return}this.logger.warn("keywords option as map is deprecated, pass array");for(let c in u){let f=u[c];f.keyword||(f.keyword=c),this.addKeyword(f)}}function PZt(){let u={...this.opts};for(let c of SZt)delete u[c];return u}var NZt={log(){},warn(){},error(){}};function DZt(u){if(u===!1)return NZt;if(u===void 0)return console;if(u.log&&u.warn&&u.error)return u;throw new Error("logger must implement log, warn and error methods")}var IZt=/^[a-z_$][a-z0-9_$:-]*$/i;function wZt(u,c){let{RULES:f}=this;if((0,jIe.eachItem)(u,v=>{if(f.keywords[v])throw new Error(`Keyword ${v} is already defined`);if(!IZt.test(v))throw new Error(`Keyword ${v} has invalid name`)}),!!c&&c.$data&&!("code"in c||"validate"in c))throw new Error('$data keyword must have "code" or "validate" function')}function FIe(u,c,f){var v;let x=c?.post;if(f&&x)throw new Error('keyword with "post" flag cannot have "type"');let{RULES:w}=this,F=x?w.post:w.rules.find(({type:me})=>me===f);if(F||(F={type:f,rules:[]},w.rules.push(F)),w.keywords[u]=!0,!c)return;let ee={keyword:u,definition:{...c,type:(0,Nue.getJSONTypes)(c.type),schemaType:(0,Nue.getJSONTypes)(c.schemaType)}};c.before?OZt.call(this,F,ee,c.before):F.rules.push(ee),w.all[u]=ee,(v=c.implements)===null||v===void 0||v.forEach(me=>this.addKeyword(me))}function OZt(u,c,f){let v=u.rules.findIndex(x=>x.keyword===f);v>=0?u.rules.splice(v,0,c):(u.rules.push(c),this.logger.warn(`rule ${f} is not defined`))}function RZt(u){let{metaSchema:c}=u;c!==void 0&&(u.$data&&this.opts.$data&&(c=Blt(c)),u.validateSchema=this.compile(c,!0))}var MZt={$ref:"https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#"};function Blt(u){return{anyOf:[u,MZt]}}});var Vlt=At(BIe=>{"use strict";Object.defineProperty(BIe,"__esModule",{value:!0});var LZt={keyword:"id",code(){throw new Error('NOT SUPPORTED: keyword "id", use "$id" for schema ID')}};BIe.default=LZt});var $lt=At(l3=>{"use strict";Object.defineProperty(l3,"__esModule",{value:!0});l3.callRef=l3.getValidate=void 0;var FZt=Cue(),Jlt=kb(),yv=Hl(),ZF=CP(),qlt=kue(),Due=Qu(),jZt={keyword:"$ref",schemaType:"string",code(u){let{gen:c,schema:f,it:v}=u,{baseId:x,schemaEnv:w,validateName:F,opts:ee,self:me}=v,{root:de}=w;if((f==="#"||f==="#/")&&x===de.baseId)return ut();let Te=qlt.resolveRef.call(me,de,x,f);if(Te===void 0)throw new FZt.default(v.opts.uriResolver,x,f);if(Te instanceof qlt.SchemaEnv)return Ct(Te);return Kt(Te);function ut(){if(w===de)return Iue(u,F,w,w.$async);let xr=c.scopeValue("root",{ref:de});return Iue(u,(0,yv._)`${xr}.validate`,de,de.$async)}function Ct(xr){let en=zlt(u,xr);Iue(u,en,xr,xr.$async)}function Kt(xr){let en=c.scopeValue("schema",ee.code.source===!0?{ref:xr,code:(0,yv.stringify)(xr)}:{ref:xr}),zn=c.name("valid"),yr=u.subschema({schema:xr,dataTypes:[],schemaPath:yv.nil,topSchemaRef:en,errSchemaPath:f},zn);u.mergeEvaluated(yr),u.ok(zn)}}};function zlt(u,c){let{gen:f}=u;return c.validate?f.scopeValue("validate",{ref:c.validate}):(0,yv._)`${f.scopeValue("wrapper",{ref:c})}.validate`}l3.getValidate=zlt;function Iue(u,c,f,v){let{gen:x,it:w}=u,{allErrors:F,schemaEnv:ee,opts:me}=w,de=me.passContext?ZF.default.this:yv.nil;v?Te():ut();function Te(){if(!ee.$async)throw new Error("async schema referenced by sync schema");let xr=x.let("valid");x.try(()=>{x.code((0,yv._)`await ${(0,Jlt.callValidateCode)(u,c,de)}`),Kt(c),F||x.assign(xr,!0)},en=>{x.if((0,yv._)`!(${en} instanceof ${w.ValidationError})`,()=>x.throw(en)),Ct(en),F||x.assign(xr,!1)}),u.ok(xr)}function ut(){u.result((0,Jlt.callValidateCode)(u,c,de),()=>Kt(c),()=>Ct(c))}function Ct(xr){let en=(0,yv._)`${xr}.errors`;x.assign(ZF.default.vErrors,(0,yv._)`${ZF.default.vErrors} === null ? ${en} : ${ZF.default.vErrors}.concat(${en})`),x.assign(ZF.default.errors,(0,yv._)`${ZF.default.vErrors}.length`)}function Kt(xr){var en;if(!w.opts.unevaluated)return;let zn=(en=f?.validate)===null||en===void 0?void 0:en.evaluated;if(w.props!==!0)if(zn&&!zn.dynamicProps)zn.props!==void 0&&(w.props=Due.mergeEvaluated.props(x,zn.props,w.props));else{let yr=x.var("props",(0,yv._)`${xr}.evaluated.props`);w.props=Due.mergeEvaluated.props(x,yr,w.props,yv.Name)}if(w.items!==!0)if(zn&&!zn.dynamicItems)zn.items!==void 0&&(w.items=Due.mergeEvaluated.items(x,zn.items,w.items));else{let yr=x.var("items",(0,yv._)`${xr}.evaluated.items`);w.items=Due.mergeEvaluated.items(x,yr,w.items,yv.Name)}}}l3.callRef=Iue;l3.default=jZt});var Wlt=At(UIe=>{"use strict";Object.defineProperty(UIe,"__esModule",{value:!0});var BZt=Vlt(),UZt=$lt(),VZt=["$schema","$id","$defs","$vocabulary",{keyword:"$comment"},"definitions",BZt.default,UZt.default];UIe.default=VZt});var Glt=At(VIe=>{"use strict";Object.defineProperty(VIe,"__esModule",{value:!0});var wue=Hl(),sw=wue.operators,Oue={maximum:{okStr:"<=",ok:sw.LTE,fail:sw.GT},minimum:{okStr:">=",ok:sw.GTE,fail:sw.LT},exclusiveMaximum:{okStr:"<",ok:sw.LT,fail:sw.GTE},exclusiveMinimum:{okStr:">",ok:sw.GT,fail:sw.LTE}},JZt={message:({keyword:u,schemaCode:c})=>(0,wue.str)`must be ${Oue[u].okStr} ${c}`,params:({keyword:u,schemaCode:c})=>(0,wue._)`{comparison: ${Oue[u].okStr}, limit: ${c}}`},qZt={keyword:Object.keys(Oue),type:"number",schemaType:"number",$data:!0,error:JZt,code(u){let{keyword:c,data:f,schemaCode:v}=u;u.fail$data((0,wue._)`${f} ${Oue[c].fail} ${v} || isNaN(${f})`)}};VIe.default=qZt});var Hlt=At(JIe=>{"use strict";Object.defineProperty(JIe,"__esModule",{value:!0});var RW=Hl(),zZt={message:({schemaCode:u})=>(0,RW.str)`must be multiple of ${u}`,params:({schemaCode:u})=>(0,RW._)`{multipleOf: ${u}}`},$Zt={keyword:"multipleOf",type:"number",schemaType:"number",$data:!0,error:zZt,code(u){let{gen:c,data:f,schemaCode:v,it:x}=u,w=x.opts.multipleOfPrecision,F=c.let("res"),ee=w?(0,RW._)`Math.abs(Math.round(${F}) - ${F}) > 1e-${w}`:(0,RW._)`${F} !== parseInt(${F})`;u.fail$data((0,RW._)`(${v} === 0 || (${F} = ${f}/${v}, ${ee}))`)}};JIe.default=$Zt});var Xlt=At(qIe=>{"use strict";Object.defineProperty(qIe,"__esModule",{value:!0});function Ylt(u){let c=u.length,f=0,v=0,x;for(;v<c;)f++,x=u.charCodeAt(v++),x>=55296&&x<=56319&&v<c&&(x=u.charCodeAt(v),(x&64512)===56320&&v++);return f}qIe.default=Ylt;Ylt.code='require("ajv/dist/runtime/ucs2length").default'});var Klt=At(zIe=>{"use strict";Object.defineProperty(zIe,"__esModule",{value:!0});var u3=Hl(),WZt=Qu(),GZt=Xlt(),HZt={message({keyword:u,schemaCode:c}){let f=u==="maxLength"?"more":"fewer";return(0,u3.str)`must NOT have ${f} than ${c} characters`},params:({schemaCode:u})=>(0,u3._)`{limit: ${u}}`},YZt={keyword:["maxLength","minLength"],type:"string",schemaType:"number",$data:!0,error:HZt,code(u){let{keyword:c,data:f,schemaCode:v,it:x}=u,w=c==="maxLength"?u3.operators.GT:u3.operators.LT,F=x.opts.unicode===!1?(0,u3._)`${f}.length`:(0,u3._)`${(0,WZt.useFunc)(u.gen,GZt.default)}(${f})`;u.fail$data((0,u3._)`${F} ${w} ${v}`)}};zIe.default=YZt});var Qlt=At($Ie=>{"use strict";Object.defineProperty($Ie,"__esModule",{value:!0});var XZt=kb(),Rue=Hl(),KZt={message:({schemaCode:u})=>(0,Rue.str)`must match pattern "${u}"`,params:({schemaCode:u})=>(0,Rue._)`{pattern: ${u}}`},QZt={keyword:"pattern",type:"string",schemaType:"string",$data:!0,error:KZt,code(u){let{data:c,$data:f,schema:v,schemaCode:x,it:w}=u,F=w.opts.unicodeRegExp?"u":"",ee=f?(0,Rue._)`(new RegExp(${x}, ${F}))`:(0,XZt.usePattern)(u,v);u.fail$data((0,Rue._)`!${ee}.test(${c})`)}};$Ie.default=QZt});var Zlt=At(WIe=>{"use strict";Object.defineProperty(WIe,"__esModule",{value:!0});var MW=Hl(),ZZt={message({keyword:u,schemaCode:c}){let f=u==="maxProperties"?"more":"fewer";return(0,MW.str)`must NOT have ${f} than ${c} properties`},params:({schemaCode:u})=>(0,MW._)`{limit: ${u}}`},eer={keyword:["maxProperties","minProperties"],type:"object",schemaType:"number",$data:!0,error:ZZt,code(u){let{keyword:c,data:f,schemaCode:v}=u,x=c==="maxProperties"?MW.operators.GT:MW.operators.LT;u.fail$data((0,MW._)`Object.keys(${f}).length ${x} ${v}`)}};WIe.default=eer});var eut=At(GIe=>{"use strict";Object.defineProperty(GIe,"__esModule",{value:!0});var LW=kb(),FW=Hl(),ter=Qu(),rer={message:({params:{missingProperty:u}})=>(0,FW.str)`must have required property '${u}'`,params:({params:{missingProperty:u}})=>(0,FW._)`{missingProperty: ${u}}`},ner={keyword:"required",type:"object",schemaType:"array",$data:!0,error:rer,code(u){let{gen:c,schema:f,schemaCode:v,data:x,$data:w,it:F}=u,{opts:ee}=F;if(!w&&f.length===0)return;let me=f.length>=ee.loopRequired;if(F.allErrors?de():Te(),ee.strictRequired){let Kt=u.parentSchema.properties,{definedProperties:xr}=u.it;for(let en of f)if(Kt?.[en]===void 0&&!xr.has(en)){let zn=F.schemaEnv.baseId+F.errSchemaPath,yr=`required property "${en}" is not defined at "${zn}" (strictRequired)`;(0,ter.checkStrictMode)(F,yr,F.opts.strictRequired)}}function de(){if(me||w)u.block$data(FW.nil,ut);else for(let Kt of f)(0,LW.checkReportMissingProp)(u,Kt)}function Te(){let Kt=c.let("missing");if(me||w){let xr=c.let("valid",!0);u.block$data(xr,()=>Ct(Kt,xr)),u.ok(xr)}else c.if((0,LW.checkMissingProp)(u,f,Kt)),(0,LW.reportMissingProp)(u,Kt),c.else()}function ut(){c.forOf("prop",v,Kt=>{u.setParams({missingProperty:Kt}),c.if((0,LW.noPropertyInData)(c,x,Kt,ee.ownProperties),()=>u.error())})}function Ct(Kt,xr){u.setParams({missingProperty:Kt}),c.forOf(Kt,v,()=>{c.assign(xr,(0,LW.propertyInData)(c,x,Kt,ee.ownProperties)),c.if((0,FW.not)(xr),()=>{u.error(),c.break()})},FW.nil)}}};GIe.default=ner});var tut=At(HIe=>{"use strict";Object.defineProperty(HIe,"__esModule",{value:!0});var jW=Hl(),ier={message({keyword:u,schemaCode:c}){let f=u==="maxItems"?"more":"fewer";return(0,jW.str)`must NOT have ${f} than ${c} items`},params:({schemaCode:u})=>(0,jW._)`{limit: ${u}}`},ser={keyword:["maxItems","minItems"],type:"array",schemaType:"number",$data:!0,error:ier,code(u){let{keyword:c,data:f,schemaCode:v}=u,x=c==="maxItems"?jW.operators.GT:jW.operators.LT;u.fail$data((0,jW._)`${f}.length ${x} ${v}`)}};HIe.default=ser});var Mue=At(YIe=>{"use strict";Object.defineProperty(YIe,"__esModule",{value:!0});var rut=xIe();rut.code='require("ajv/dist/runtime/equal").default';YIe.default=rut});var nut=At(KIe=>{"use strict";Object.defineProperty(KIe,"__esModule",{value:!0});var XIe=AW(),g0=Hl(),aer=Qu(),oer=Mue(),cer={message:({params:{i:u,j:c}})=>(0,g0.str)`must NOT have duplicate items (items ## ${c} and ${u} are identical)`,params:({params:{i:u,j:c}})=>(0,g0._)`{i: ${u}, j: ${c}}`},ler={keyword:"uniqueItems",type:"array",schemaType:"boolean",$data:!0,error:cer,code(u){let{gen:c,data:f,$data:v,schema:x,parentSchema:w,schemaCode:F,it:ee}=u;if(!v&&!x)return;let me=c.let("valid"),de=w.items?(0,XIe.getSchemaTypes)(w.items):[];u.block$data(me,Te,(0,g0._)`${F} === false`),u.ok(me);function Te(){let xr=c.let("i",(0,g0._)`${f}.length`),en=c.let("j");u.setParams({i:xr,j:en}),c.assign(me,!0),c.if((0,g0._)`${xr} > 1`,()=>(ut()?Ct:Kt)(xr,en))}function ut(){return de.length>0&&!de.some(xr=>xr==="object"||xr==="array")}function Ct(xr,en){let zn=c.name("item"),yr=(0,XIe.checkDataTypes)(de,zn,ee.opts.strictNumbers,XIe.DataType.Wrong),mr=c.const("indices",(0,g0._)`{}`);c.for((0,g0._)`;${xr}--;`,()=>{c.let(zn,(0,g0._)`${f}[${xr}]`),c.if(yr,(0,g0._)`continue`),de.length>1&&c.if((0,g0._)`typeof ${zn} == "string"`,(0,g0._)`${zn} += "_"`),c.if((0,g0._)`typeof ${mr}[${zn}] == "number"`,()=>{c.assign(en,(0,g0._)`${mr}[${zn}]`),u.error(),c.assign(me,!1).break()}).code((0,g0._)`${mr}[${zn}] = ${xr}`)})}function Kt(xr,en){let zn=(0,aer.useFunc)(c,oer.default),yr=c.name("outer");c.label(yr).for((0,g0._)`;${xr}--;`,()=>c.for((0,g0._)`${en} = ${xr}; ${en}--;`,()=>c.if((0,g0._)`${zn}(${f}[${xr}], ${f}[${en}])`,()=>{u.error(),c.assign(me,!1).break(yr)})))}}};KIe.default=ler});var iut=At(ZIe=>{"use strict";Object.defineProperty(ZIe,"__esModule",{value:!0});var QIe=Hl(),uer=Qu(),_er=Mue(),fer={message:"must be equal to constant",params:({schemaCode:u})=>(0,QIe._)`{allowedValue: ${u}}`},per={keyword:"const",$data:!0,error:fer,code(u){let{gen:c,data:f,$data:v,schemaCode:x,schema:w}=u;v||w&&typeof w=="object"?u.fail$data((0,QIe._)`!${(0,uer.useFunc)(c,_er.default)}(${f}, ${x})`):u.fail((0,QIe._)`${w} !== ${f}`)}};ZIe.default=per});var sut=At(ewe=>{"use strict";Object.defineProperty(ewe,"__esModule",{value:!0});var BW=Hl(),der=Qu(),mer=Mue(),ger={message:"must be equal to one of the allowed values",params:({schemaCode:u})=>(0,BW._)`{allowedValues: ${u}}`},her={keyword:"enum",schemaType:"array",$data:!0,error:ger,code(u){let{gen:c,data:f,$data:v,schema:x,schemaCode:w,it:F}=u;if(!v&&x.length===0)throw new Error("enum must have non-empty array");let ee=x.length>=F.opts.loopEnum,me,de=()=>me??(me=(0,der.useFunc)(c,mer.default)),Te;if(ee||v)Te=c.let("valid"),u.block$data(Te,ut);else{if(!Array.isArray(x))throw new Error("ajv implementation error");let Kt=c.const("vSchema",w);Te=(0,BW.or)(...x.map((xr,en)=>Ct(Kt,en)))}u.pass(Te);function ut(){c.assign(Te,!1),c.forOf("v",w,Kt=>c.if((0,BW._)`${de()}(${f}, ${Kt})`,()=>c.assign(Te,!0).break()))}function Ct(Kt,xr){let en=x[xr];return typeof en=="object"&&en!==null?(0,BW._)`${de()}(${f}, ${Kt}[${xr}])`:(0,BW._)`${f} === ${en}`}}};ewe.default=her});var aut=At(twe=>{"use strict";Object.defineProperty(twe,"__esModule",{value:!0});var yer=Glt(),ver=Hlt(),Ser=Klt(),Ter=Qlt(),ber=Zlt(),Eer=eut(),xer=tut(),Cer=nut(),Aer=iut(),ker=sut(),Per=[yer.default,ver.default,Ser.default,Ter.default,ber.default,Eer.default,xer.default,Cer.default,{keyword:"type",schemaType:["string","array"]},{keyword:"nullable",schemaType:"boolean"},Aer.default,ker.default];twe.default=Per});var nwe=At(UW=>{"use strict";Object.defineProperty(UW,"__esModule",{value:!0});UW.validateAdditionalItems=void 0;var _3=Hl(),rwe=Qu(),Ner={message:({params:{len:u}})=>(0,_3.str)`must NOT have more than ${u} items`,params:({params:{len:u}})=>(0,_3._)`{limit: ${u}}`},Der={keyword:"additionalItems",type:"array",schemaType:["boolean","object"],before:"uniqueItems",error:Ner,code(u){let{parentSchema:c,it:f}=u,{items:v}=c;if(!Array.isArray(v)){(0,rwe.checkStrictMode)(f,'"additionalItems" is ignored when "items" is not an array of schemas');return}out(u,v)}};function out(u,c){let{gen:f,schema:v,data:x,keyword:w,it:F}=u;F.items=!0;let ee=f.const("len",(0,_3._)`${x}.length`);if(v===!1)u.setParams({len:c.length}),u.pass((0,_3._)`${ee} <= ${c.length}`);else if(typeof v=="object"&&!(0,rwe.alwaysValidSchema)(F,v)){let de=f.var("valid",(0,_3._)`${ee} <= ${c.length}`);f.if((0,_3.not)(de),()=>me(de)),u.ok(de)}function me(de){f.forRange("i",c.length,ee,Te=>{u.subschema({keyword:w,dataProp:Te,dataPropType:rwe.Type.Num},de),F.allErrors||f.if((0,_3.not)(de),()=>f.break())})}}UW.validateAdditionalItems=out;UW.default=Der});var iwe=At(VW=>{"use strict";Object.defineProperty(VW,"__esModule",{value:!0});VW.validateTuple=void 0;var cut=Hl(),Lue=Qu(),Ier=kb(),wer={keyword:"items",type:"array",schemaType:["object","array","boolean"],before:"uniqueItems",code(u){let{schema:c,it:f}=u;if(Array.isArray(c))return lut(u,"additionalItems",c);f.items=!0,!(0,Lue.alwaysValidSchema)(f,c)&&u.ok((0,Ier.validateArray)(u))}};function lut(u,c,f=u.schema){let{gen:v,parentSchema:x,data:w,keyword:F,it:ee}=u;Te(x),ee.opts.unevaluated&&f.length&&ee.items!==!0&&(ee.items=Lue.mergeEvaluated.items(v,f.length,ee.items));let me=v.name("valid"),de=v.const("len",(0,cut._)`${w}.length`);f.forEach((ut,Ct)=>{(0,Lue.alwaysValidSchema)(ee,ut)||(v.if((0,cut._)`${de} > ${Ct}`,()=>u.subschema({keyword:F,schemaProp:Ct,dataProp:Ct},me)),u.ok(me))});function Te(ut){let{opts:Ct,errSchemaPath:Kt}=ee,xr=f.length,en=xr===ut.minItems&&(xr===ut.maxItems||ut[c]===!1);if(Ct.strictTuples&&!en){let zn=`"${F}" is ${xr}-tuple, but minItems or maxItems/${c} are not specified or different at path "${Kt}"`;(0,Lue.checkStrictMode)(ee,zn,Ct.strictTuples)}}}VW.validateTuple=lut;VW.default=wer});var uut=At(swe=>{"use strict";Object.defineProperty(swe,"__esModule",{value:!0});var Oer=iwe(),Rer={keyword:"prefixItems",type:"array",schemaType:["array"],before:"uniqueItems",code:u=>(0,Oer.validateTuple)(u,"items")};swe.default=Rer});var fut=At(awe=>{"use strict";Object.defineProperty(awe,"__esModule",{value:!0});var _ut=Hl(),Mer=Qu(),Ler=kb(),Fer=nwe(),jer={message:({params:{len:u}})=>(0,_ut.str)`must NOT have more than ${u} items`,params:({params:{len:u}})=>(0,_ut._)`{limit: ${u}}`},Ber={keyword:"items",type:"array",schemaType:["object","boolean"],before:"uniqueItems",error:jer,code(u){let{schema:c,parentSchema:f,it:v}=u,{prefixItems:x}=f;v.items=!0,!(0,Mer.alwaysValidSchema)(v,c)&&(x?(0,Fer.validateAdditionalItems)(u,x):u.ok((0,Ler.validateArray)(u)))}};awe.default=Ber});var put=At(owe=>{"use strict";Object.defineProperty(owe,"__esModule",{value:!0});var Nb=Hl(),Fue=Qu(),Uer={message:({params:{min:u,max:c}})=>c===void 0?(0,Nb.str)`must contain at least ${u} valid item(s)`:(0,Nb.str)`must contain at least ${u} and no more than ${c} valid item(s)`,params:({params:{min:u,max:c}})=>c===void 0?(0,Nb._)`{minContains: ${u}}`:(0,Nb._)`{minContains: ${u}, maxContains: ${c}}`},Ver={keyword:"contains",type:"array",schemaType:["object","boolean"],before:"uniqueItems",trackErrors:!0,error:Uer,code(u){let{gen:c,schema:f,parentSchema:v,data:x,it:w}=u,F,ee,{minContains:me,maxContains:de}=v;w.opts.next?(F=me===void 0?1:me,ee=de):F=1;let Te=c.const("len",(0,Nb._)`${x}.length`);if(u.setParams({min:F,max:ee}),ee===void 0&&F===0){(0,Fue.checkStrictMode)(w,'"minContains" == 0 without "maxContains": "contains" keyword ignored');return}if(ee!==void 0&&F>ee){(0,Fue.checkStrictMode)(w,'"minContains" > "maxContains" is always invalid'),u.fail();return}if((0,Fue.alwaysValidSchema)(w,f)){let en=(0,Nb._)`${Te} >= ${F}`;ee!==void 0&&(en=(0,Nb._)`${en} && ${Te} <= ${ee}`),u.pass(en);return}w.items=!0;let ut=c.name("valid");ee===void 0&&F===1?Kt(ut,()=>c.if(ut,()=>c.break())):F===0?(c.let(ut,!0),ee!==void 0&&c.if((0,Nb._)`${x}.length > 0`,Ct)):(c.let(ut,!1),Ct()),u.result(ut,()=>u.reset());function Ct(){let en=c.name("_valid"),zn=c.let("count",0);Kt(en,()=>c.if(en,()=>xr(zn)))}function Kt(en,zn){c.forRange("i",0,Te,yr=>{u.subschema({keyword:"contains",dataProp:yr,dataPropType:Fue.Type.Num,compositeRule:!0},en),zn()})}function xr(en){c.code((0,Nb._)`${en}++`),ee===void 0?c.if((0,Nb._)`${en} >= ${F}`,()=>c.assign(ut,!0).break()):(c.if((0,Nb._)`${en} > ${ee}`,()=>c.assign(ut,!1).break()),F===1?c.assign(ut,!0):c.if((0,Nb._)`${en} >= ${F}`,()=>c.assign(ut,!0)))}}};owe.default=Ver});var gut=At($C=>{"use strict";Object.defineProperty($C,"__esModule",{value:!0});$C.validateSchemaDeps=$C.validatePropertyDeps=$C.error=void 0;var cwe=Hl(),Jer=Qu(),JW=kb();$C.error={message:({params:{property:u,depsCount:c,deps:f}})=>{let v=c===1?"property":"properties";return(0,cwe.str)`must have ${v} ${f} when property ${u} is present`},params:({params:{property:u,depsCount:c,deps:f,missingProperty:v}})=>(0,cwe._)`{property: ${u},
    missingProperty: ${v},
    depsCount: ${c},
    deps: ${f}}`};var qer={keyword:"dependencies",type:"object",schemaType:"object",error:$C.error,code(u){let[c,f]=zer(u);dut(u,c),mut(u,f)}};function zer({schema:u}){let c={},f={};for(let v in u){if(v==="__proto__")continue;let x=Array.isArray(u[v])?c:f;x[v]=u[v]}return[c,f]}function dut(u,c=u.schema){let{gen:f,data:v,it:x}=u;if(Object.keys(c).length===0)return;let w=f.let("missing");for(let F in c){let ee=c[F];if(ee.length===0)continue;let me=(0,JW.propertyInData)(f,v,F,x.opts.ownProperties);u.setParams({property:F,depsCount:ee.length,deps:ee.join(", ")}),x.allErrors?f.if(me,()=>{for(let de of ee)(0,JW.checkReportMissingProp)(u,de)}):(f.if((0,cwe._)`${me} && (${(0,JW.checkMissingProp)(u,ee,w)})`),(0,JW.reportMissingProp)(u,w),f.else())}}$C.validatePropertyDeps=dut;function mut(u,c=u.schema){let{gen:f,data:v,keyword:x,it:w}=u,F=f.name("valid");for(let ee in c)(0,Jer.alwaysValidSchema)(w,c[ee])||(f.if((0,JW.propertyInData)(f,v,ee,w.opts.ownProperties),()=>{let me=u.subschema({keyword:x,schemaProp:ee},F);u.mergeValidEvaluated(me,F)},()=>f.var(F,!0)),u.ok(F))}$C.validateSchemaDeps=mut;$C.default=qer});var yut=At(lwe=>{"use strict";Object.defineProperty(lwe,"__esModule",{value:!0});var hut=Hl(),$er=Qu(),Wer={message:"property name must be valid",params:({params:u})=>(0,hut._)`{propertyName: ${u.propertyName}}`},Ger={keyword:"propertyNames",type:"object",schemaType:["object","boolean"],error:Wer,code(u){let{gen:c,schema:f,data:v,it:x}=u;if((0,$er.alwaysValidSchema)(x,f))return;let w=c.name("valid");c.forIn("key",v,F=>{u.setParams({propertyName:F}),u.subschema({keyword:"propertyNames",data:F,dataTypes:["string"],propertyName:F,compositeRule:!0},w),c.if((0,hut.not)(w),()=>{u.error(!0),x.allErrors||c.break()})}),u.ok(w)}};lwe.default=Ger});var _we=At(uwe=>{"use strict";Object.defineProperty(uwe,"__esModule",{value:!0});var jue=kb(),S2=Hl(),Her=CP(),Bue=Qu(),Yer={message:"must NOT have additional properties",params:({params:u})=>(0,S2._)`{additionalProperty: ${u.additionalProperty}}`},Xer={keyword:"additionalProperties",type:["object"],schemaType:["boolean","object"],allowUndefined:!0,trackErrors:!0,error:Yer,code(u){let{gen:c,schema:f,parentSchema:v,data:x,errsCount:w,it:F}=u;if(!w)throw new Error("ajv implementation error");let{allErrors:ee,opts:me}=F;if(F.props=!0,me.removeAdditional!=="all"&&(0,Bue.alwaysValidSchema)(F,f))return;let de=(0,jue.allSchemaProperties)(v.properties),Te=(0,jue.allSchemaProperties)(v.patternProperties);ut(),u.ok((0,S2._)`${w} === ${Her.default.errors}`);function ut(){c.forIn("key",x,zn=>{!de.length&&!Te.length?xr(zn):c.if(Ct(zn),()=>xr(zn))})}function Ct(zn){let yr;if(de.length>8){let mr=(0,Bue.schemaRefOrVal)(F,v.properties,"properties");yr=(0,jue.isOwnProperty)(c,mr,zn)}else de.length?yr=(0,S2.or)(...de.map(mr=>(0,S2._)`${zn} === ${mr}`)):yr=S2.nil;return Te.length&&(yr=(0,S2.or)(yr,...Te.map(mr=>(0,S2._)`${(0,jue.usePattern)(u,mr)}.test(${zn})`))),(0,S2.not)(yr)}function Kt(zn){c.code((0,S2._)`delete ${x}[${zn}]`)}function xr(zn){if(me.removeAdditional==="all"||me.removeAdditional&&f===!1){Kt(zn);return}if(f===!1){u.setParams({additionalProperty:zn}),u.error(),ee||c.break();return}if(typeof f=="object"&&!(0,Bue.alwaysValidSchema)(F,f)){let yr=c.name("valid");me.removeAdditional==="failing"?(en(zn,yr,!1),c.if((0,S2.not)(yr),()=>{u.reset(),Kt(zn)})):(en(zn,yr),ee||c.if((0,S2.not)(yr),()=>c.break()))}}function en(zn,yr,mr){let Da={keyword:"additionalProperties",dataProp:zn,dataPropType:Bue.Type.Str};mr===!1&&Object.assign(Da,{compositeRule:!0,createErrors:!1,allErrors:!1}),u.subschema(Da,yr)}}};uwe.default=Xer});var Tut=At(pwe=>{"use strict";Object.defineProperty(pwe,"__esModule",{value:!0});var Ker=DW(),vut=kb(),fwe=Qu(),Sut=_we(),Qer={keyword:"properties",type:"object",schemaType:"object",code(u){let{gen:c,schema:f,parentSchema:v,data:x,it:w}=u;w.opts.removeAdditional==="all"&&v.additionalProperties===void 0&&Sut.default.code(new Ker.KeywordCxt(w,Sut.default,"additionalProperties"));let F=(0,vut.allSchemaProperties)(f);for(let ut of F)w.definedProperties.add(ut);w.opts.unevaluated&&F.length&&w.props!==!0&&(w.props=fwe.mergeEvaluated.props(c,(0,fwe.toHash)(F),w.props));let ee=F.filter(ut=>!(0,fwe.alwaysValidSchema)(w,f[ut]));if(ee.length===0)return;let me=c.name("valid");for(let ut of ee)de(ut)?Te(ut):(c.if((0,vut.propertyInData)(c,x,ut,w.opts.ownProperties)),Te(ut),w.allErrors||c.else().var(me,!0),c.endIf()),u.it.definedProperties.add(ut),u.ok(me);function de(ut){return w.opts.useDefaults&&!w.compositeRule&&f[ut].default!==void 0}function Te(ut){u.subschema({keyword:"properties",schemaProp:ut,dataProp:ut},me)}}};pwe.default=Qer});var Cut=At(dwe=>{"use strict";Object.defineProperty(dwe,"__esModule",{value:!0});var but=kb(),Uue=Hl(),Eut=Qu(),xut=Qu(),Zer={keyword:"patternProperties",type:"object",schemaType:"object",code(u){let{gen:c,schema:f,data:v,parentSchema:x,it:w}=u,{opts:F}=w,ee=(0,but.allSchemaProperties)(f),me=ee.filter(en=>(0,Eut.alwaysValidSchema)(w,f[en]));if(ee.length===0||me.length===ee.length&&(!w.opts.unevaluated||w.props===!0))return;let de=F.strictSchema&&!F.allowMatchingProperties&&x.properties,Te=c.name("valid");w.props!==!0&&!(w.props instanceof Uue.Name)&&(w.props=(0,xut.evaluatedPropsToName)(c,w.props));let{props:ut}=w;Ct();function Ct(){for(let en of ee)de&&Kt(en),w.allErrors?xr(en):(c.var(Te,!0),xr(en),c.if(Te))}function Kt(en){for(let zn in de)new RegExp(en).test(zn)&&(0,Eut.checkStrictMode)(w,`property ${zn} matches pattern ${en} (use allowMatchingProperties)`)}function xr(en){c.forIn("key",v,zn=>{c.if((0,Uue._)`${(0,but.usePattern)(u,en)}.test(${zn})`,()=>{let yr=me.includes(en);yr||u.subschema({keyword:"patternProperties",schemaProp:en,dataProp:zn,dataPropType:xut.Type.Str},Te),w.opts.unevaluated&&ut!==!0?c.assign((0,Uue._)`${ut}[${zn}]`,!0):!yr&&!w.allErrors&&c.if((0,Uue.not)(Te),()=>c.break())})})}}};dwe.default=Zer});var Aut=At(mwe=>{"use strict";Object.defineProperty(mwe,"__esModule",{value:!0});var etr=Qu(),ttr={keyword:"not",schemaType:["object","boolean"],trackErrors:!0,code(u){let{gen:c,schema:f,it:v}=u;if((0,etr.alwaysValidSchema)(v,f)){u.fail();return}let x=c.name("valid");u.subschema({keyword:"not",compositeRule:!0,createErrors:!1,allErrors:!1},x),u.failResult(x,()=>u.reset(),()=>u.error())},error:{message:"must NOT be valid"}};mwe.default=ttr});var kut=At(gwe=>{"use strict";Object.defineProperty(gwe,"__esModule",{value:!0});var rtr=kb(),ntr={keyword:"anyOf",schemaType:"array",trackErrors:!0,code:rtr.validateUnion,error:{message:"must match a schema in anyOf"}};gwe.default=ntr});var Put=At(hwe=>{"use strict";Object.defineProperty(hwe,"__esModule",{value:!0});var Vue=Hl(),itr=Qu(),str={message:"must match exactly one schema in oneOf",params:({params:u})=>(0,Vue._)`{passingSchemas: ${u.passing}}`},atr={keyword:"oneOf",schemaType:"array",trackErrors:!0,error:str,code(u){let{gen:c,schema:f,parentSchema:v,it:x}=u;if(!Array.isArray(f))throw new Error("ajv implementation error");if(x.opts.discriminator&&v.discriminator)return;let w=f,F=c.let("valid",!1),ee=c.let("passing",null),me=c.name("_valid");u.setParams({passing:ee}),c.block(de),u.result(F,()=>u.reset(),()=>u.error(!0));function de(){w.forEach((Te,ut)=>{let Ct;(0,itr.alwaysValidSchema)(x,Te)?c.var(me,!0):Ct=u.subschema({keyword:"oneOf",schemaProp:ut,compositeRule:!0},me),ut>0&&c.if((0,Vue._)`${me} && ${F}`).assign(F,!1).assign(ee,(0,Vue._)`[${ee}, ${ut}]`).else(),c.if(me,()=>{c.assign(F,!0),c.assign(ee,ut),Ct&&u.mergeEvaluated(Ct,Vue.Name)})})}}};hwe.default=atr});var Nut=At(ywe=>{"use strict";Object.defineProperty(ywe,"__esModule",{value:!0});var otr=Qu(),ctr={keyword:"allOf",schemaType:"array",code(u){let{gen:c,schema:f,it:v}=u;if(!Array.isArray(f))throw new Error("ajv implementation error");let x=c.name("valid");f.forEach((w,F)=>{if((0,otr.alwaysValidSchema)(v,w))return;let ee=u.subschema({keyword:"allOf",schemaProp:F},x);u.ok(x),u.mergeEvaluated(ee)})}};ywe.default=ctr});var wut=At(vwe=>{"use strict";Object.defineProperty(vwe,"__esModule",{value:!0});var Jue=Hl(),Iut=Qu(),ltr={message:({params:u})=>(0,Jue.str)`must match "${u.ifClause}" schema`,params:({params:u})=>(0,Jue._)`{failingKeyword: ${u.ifClause}}`},utr={keyword:"if",schemaType:["object","boolean"],trackErrors:!0,error:ltr,code(u){let{gen:c,parentSchema:f,it:v}=u;f.then===void 0&&f.else===void 0&&(0,Iut.checkStrictMode)(v,'"if" without "then" and "else" is ignored');let x=Dut(v,"then"),w=Dut(v,"else");if(!x&&!w)return;let F=c.let("valid",!0),ee=c.name("_valid");if(me(),u.reset(),x&&w){let Te=c.let("ifClause");u.setParams({ifClause:Te}),c.if(ee,de("then",Te),de("else",Te))}else x?c.if(ee,de("then")):c.if((0,Jue.not)(ee),de("else"));u.pass(F,()=>u.error(!0));function me(){let Te=u.subschema({keyword:"if",compositeRule:!0,createErrors:!1,allErrors:!1},ee);u.mergeEvaluated(Te)}function de(Te,ut){return()=>{let Ct=u.subschema({keyword:Te},ee);c.assign(F,ee),u.mergeValidEvaluated(Ct,F),ut?c.assign(ut,(0,Jue._)`${Te}`):u.setParams({ifClause:Te})}}}};function Dut(u,c){let f=u.schema[c];return f!==void 0&&!(0,Iut.alwaysValidSchema)(u,f)}vwe.default=utr});var Out=At(Swe=>{"use strict";Object.defineProperty(Swe,"__esModule",{value:!0});var _tr=Qu(),ftr={keyword:["then","else"],schemaType:["object","boolean"],code({keyword:u,parentSchema:c,it:f}){c.if===void 0&&(0,_tr.checkStrictMode)(f,`"${u}" without "if" is ignored`)}};Swe.default=ftr});var Rut=At(Twe=>{"use strict";Object.defineProperty(Twe,"__esModule",{value:!0});var ptr=nwe(),dtr=uut(),mtr=iwe(),gtr=fut(),htr=put(),ytr=gut(),vtr=yut(),Str=_we(),Ttr=Tut(),btr=Cut(),Etr=Aut(),xtr=kut(),Ctr=Put(),Atr=Nut(),ktr=wut(),Ptr=Out();function Ntr(u=!1){let c=[Etr.default,xtr.default,Ctr.default,Atr.default,ktr.default,Ptr.default,vtr.default,Str.default,ytr.default,Ttr.default,btr.default];return u?c.push(dtr.default,gtr.default):c.push(ptr.default,mtr.default),c.push(htr.default),c}Twe.default=Ntr});var Mut=At(bwe=>{"use strict";Object.defineProperty(bwe,"__esModule",{value:!0});var Cm=Hl(),Dtr={message:({schemaCode:u})=>(0,Cm.str)`must match format "${u}"`,params:({schemaCode:u})=>(0,Cm._)`{format: ${u}}`},Itr={keyword:"format",type:["number","string"],schemaType:"string",$data:!0,error:Dtr,code(u,c){let{gen:f,data:v,$data:x,schema:w,schemaCode:F,it:ee}=u,{opts:me,errSchemaPath:de,schemaEnv:Te,self:ut}=ee;if(!me.validateFormats)return;x?Ct():Kt();function Ct(){let xr=f.scopeValue("formats",{ref:ut.formats,code:me.code.formats}),en=f.const("fDef",(0,Cm._)`${xr}[${F}]`),zn=f.let("fType"),yr=f.let("format");f.if((0,Cm._)`typeof ${en} == "object" && !(${en} instanceof RegExp)`,()=>f.assign(zn,(0,Cm._)`${en}.type || "string"`).assign(yr,(0,Cm._)`${en}.validate`),()=>f.assign(zn,(0,Cm._)`"string"`).assign(yr,en)),u.fail$data((0,Cm.or)(mr(),Da()));function mr(){return me.strictSchema===!1?Cm.nil:(0,Cm._)`${F} && !${yr}`}function Da(){let oa=Te.$async?(0,Cm._)`(${en}.async ? await ${yr}(${v}) : ${yr}(${v}))`:(0,Cm._)`${yr}(${v})`,no=(0,Cm._)`(typeof ${yr} == "function" ? ${oa} : ${yr}.test(${v}))`;return(0,Cm._)`${yr} && ${yr} !== true && ${zn} === ${c} && !${no}`}}function Kt(){let xr=ut.formats[w];if(!xr){mr();return}if(xr===!0)return;let[en,zn,yr]=Da(xr);en===c&&u.pass(oa());function mr(){if(me.strictSchema===!1){ut.logger.warn(no());return}throw new Error(no());function no(){return`unknown format "${w}" ignored in schema at path "${de}"`}}function Da(no){let Cf=no instanceof RegExp?(0,Cm.regexpCode)(no):me.code.formats?(0,Cm._)`${me.code.formats}${(0,Cm.getProperty)(w)}`:void 0,hs=f.scopeValue("formats",{key:w,ref:no,code:Cf});return typeof no=="object"&&!(no instanceof RegExp)?[no.type||"string",no.validate,(0,Cm._)`${hs}.validate`]:["string",no,hs]}function oa(){if(typeof xr=="object"&&!(xr instanceof RegExp)&&xr.async){if(!Te.$async)throw new Error("async format in sync schema");return(0,Cm._)`await ${yr}(${v})`}return typeof zn=="function"?(0,Cm._)`${yr}(${v})`:(0,Cm._)`${yr}.test(${v})`}}}};bwe.default=Itr});var Lut=At(Ewe=>{"use strict";Object.defineProperty(Ewe,"__esModule",{value:!0});var wtr=Mut(),Otr=[wtr.default];Ewe.default=Otr});var Fut=At(e5=>{"use strict";Object.defineProperty(e5,"__esModule",{value:!0});e5.contentVocabulary=e5.metadataVocabulary=void 0;e5.metadataVocabulary=["title","description","default","deprecated","readOnly","writeOnly","examples"];e5.contentVocabulary=["contentMediaType","contentEncoding","contentSchema"]});var But=At(xwe=>{"use strict";Object.defineProperty(xwe,"__esModule",{value:!0});var Rtr=Wlt(),Mtr=aut(),Ltr=Rut(),Ftr=Lut(),jut=Fut(),jtr=[Rtr.default,Mtr.default,(0,Ltr.default)(),Ftr.default,jut.metadataVocabulary,jut.contentVocabulary];xwe.default=jtr});var Vut=At(que=>{"use strict";Object.defineProperty(que,"__esModule",{value:!0});que.DiscrError=void 0;var Uut;(function(u){u.Tag="tag",u.Mapping="mapping"})(Uut||(que.DiscrError=Uut={}))});var qut=At(Awe=>{"use strict";Object.defineProperty(Awe,"__esModule",{value:!0});var t5=Hl(),Cwe=Vut(),Jut=kue(),Btr=Qu(),Utr={message:({params:{discrError:u,tagName:c}})=>u===Cwe.DiscrError.Tag?`tag "${c}" must be string`:`value of tag "${c}" must be in oneOf`,params:({params:{discrError:u,tag:c,tagName:f}})=>(0,t5._)`{error: ${u}, tag: ${f}, tagValue: ${c}}`},Vtr={keyword:"discriminator",type:"object",schemaType:"object",error:Utr,code(u){let{gen:c,data:f,schema:v,parentSchema:x,it:w}=u,{oneOf:F}=x;if(!w.opts.discriminator)throw new Error("discriminator: requires discriminator option");let ee=v.propertyName;if(typeof ee!="string")throw new Error("discriminator: requires propertyName");if(v.mapping)throw new Error("discriminator: mapping is not supported");if(!F)throw new Error("discriminator: requires oneOf keyword");let me=c.let("valid",!1),de=c.const("tag",(0,t5._)`${f}${(0,t5.getProperty)(ee)}`);c.if((0,t5._)`typeof ${de} == "string"`,()=>Te(),()=>u.error(!1,{discrError:Cwe.DiscrError.Tag,tag:de,tagName:ee})),u.ok(me);function Te(){let Kt=Ct();c.if(!1);for(let xr in Kt)c.elseIf((0,t5._)`${de} === ${xr}`),c.assign(me,ut(Kt[xr]));c.else(),u.error(!1,{discrError:Cwe.DiscrError.Mapping,tag:de,tagName:ee}),c.endIf()}function ut(Kt){let xr=c.name("valid"),en=u.subschema({keyword:"oneOf",schemaProp:Kt},xr);return u.mergeEvaluated(en,t5.Name),xr}function Ct(){var Kt;let xr={},en=yr(x),zn=!0;for(let oa=0;oa<F.length;oa++){let no=F[oa];no?.$ref&&!(0,Btr.schemaHasRulesButRef)(no,w.self.RULES)&&(no=Jut.resolveRef.call(w.self,w.schemaEnv.root,w.baseId,no?.$ref),no instanceof Jut.SchemaEnv&&(no=no.schema));let Cf=(Kt=no?.properties)===null||Kt===void 0?void 0:Kt[ee];if(typeof Cf!="object")throw new Error(`discriminator: oneOf subschemas (or referenced schemas) must have "properties/${ee}"`);zn=zn&&(en||yr(no)),mr(Cf,oa)}if(!zn)throw new Error(`discriminator: "${ee}" must be required`);return xr;function yr({required:oa}){return Array.isArray(oa)&&oa.includes(ee)}function mr(oa,no){if(oa.const)Da(oa.const,no);else if(oa.enum)for(let Cf of oa.enum)Da(Cf,no);else throw new Error(`discriminator: "properties/${ee}" must have "const" or "enum"`)}function Da(oa,no){if(typeof oa!="string"||oa in xr)throw new Error(`discriminator: "${ee}" values must be unique strings`);xr[oa]=no}}}};Awe.default=Vtr});var zut=At((p0r,Jtr)=>{Jtr.exports={$schema:"http://json-schema.org/draft-07/schema#",$id:"http://json-schema.org/draft-07/schema#",title:"Core schema meta-schema",definitions:{schemaArray:{type:"array",minItems:1,items:{$ref:"#"}},nonNegativeInteger:{type:"integer",minimum:0},nonNegativeIntegerDefault0:{allOf:[{$ref:"#/definitions/nonNegativeInteger"},{default:0}]},simpleTypes:{enum:["array","boolean","integer","null","number","object","string"]},stringArray:{type:"array",items:{type:"string"},uniqueItems:!0,default:[]}},type:["object","boolean"],properties:{$id:{type:"string",format:"uri-reference"},$schema:{type:"string",format:"uri"},$ref:{type:"string",format:"uri-reference"},$comment:{type:"string"},title:{type:"string"},description:{type:"string"},default:!0,readOnly:{type:"boolean",default:!1},examples:{type:"array",items:!0},multipleOf:{type:"number",exclusiveMinimum:0},maximum:{type:"number"},exclusiveMaximum:{type:"number"},minimum:{type:"number"},exclusiveMinimum:{type:"number"},maxLength:{$ref:"#/definitions/nonNegativeInteger"},minLength:{$ref:"#/definitions/nonNegativeIntegerDefault0"},pattern:{type:"string",format:"regex"},additionalItems:{$ref:"#"},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}],default:!0},maxItems:{$ref:"#/definitions/nonNegativeInteger"},minItems:{$ref:"#/definitions/nonNegativeIntegerDefault0"},uniqueItems:{type:"boolean",default:!1},contains:{$ref:"#"},maxProperties:{$ref:"#/definitions/nonNegativeInteger"},minProperties:{$ref:"#/definitions/nonNegativeIntegerDefault0"},required:{$ref:"#/definitions/stringArray"},additionalProperties:{$ref:"#"},definitions:{type:"object",additionalProperties:{$ref:"#"},default:{}},properties:{type:"object",additionalProperties:{$ref:"#"},default:{}},patternProperties:{type:"object",additionalProperties:{$ref:"#"},propertyNames:{format:"regex"},default:{}},dependencies:{type:"object",additionalProperties:{anyOf:[{$ref:"#"},{$ref:"#/definitions/stringArray"}]}},propertyNames:{$ref:"#"},const:!0,enum:{type:"array",items:!0,minItems:1,uniqueItems:!0},type:{anyOf:[{$ref:"#/definitions/simpleTypes"},{type:"array",items:{$ref:"#/definitions/simpleTypes"},minItems:1,uniqueItems:!0}]},format:{type:"string"},contentMediaType:{type:"string"},contentEncoding:{type:"string"},if:{$ref:"#"},then:{$ref:"#"},else:{$ref:"#"},allOf:{$ref:"#/definitions/schemaArray"},anyOf:{$ref:"#/definitions/schemaArray"},oneOf:{$ref:"#/definitions/schemaArray"},not:{$ref:"#"}},default:!0}});var Wut=At((Dp,kwe)=>{"use strict";Object.defineProperty(Dp,"__esModule",{value:!0});Dp.MissingRefError=Dp.ValidationError=Dp.CodeGen=Dp.Name=Dp.nil=Dp.stringify=Dp.str=Dp._=Dp.KeywordCxt=Dp.Ajv=void 0;var qtr=Ult(),ztr=But(),$tr=qut(),$ut=zut(),Wtr=["/properties"],zue="http://json-schema.org/draft-07/schema",r5=class extends qtr.default{_addVocabularies(){super._addVocabularies(),ztr.default.forEach(c=>this.addVocabulary(c)),this.opts.discriminator&&this.addKeyword($tr.default)}_addDefaultMetaSchema(){if(super._addDefaultMetaSchema(),!this.opts.meta)return;let c=this.opts.$data?this.$dataMetaSchema($ut,Wtr):$ut;this.addMetaSchema(c,zue,!1),this.refs["http://json-schema.org/schema"]=zue}defaultMeta(){return this.opts.defaultMeta=super.defaultMeta()||(this.getSchema(zue)?zue:void 0)}};Dp.Ajv=r5;kwe.exports=Dp=r5;kwe.exports.Ajv=r5;Object.defineProperty(Dp,"__esModule",{value:!0});Dp.default=r5;var Gtr=DW();Object.defineProperty(Dp,"KeywordCxt",{enumerable:!0,get:function(){return Gtr.KeywordCxt}});var n5=Hl();Object.defineProperty(Dp,"_",{enumerable:!0,get:function(){return n5._}});Object.defineProperty(Dp,"str",{enumerable:!0,get:function(){return n5.str}});Object.defineProperty(Dp,"stringify",{enumerable:!0,get:function(){return n5.stringify}});Object.defineProperty(Dp,"nil",{enumerable:!0,get:function(){return n5.nil}});Object.defineProperty(Dp,"Name",{enumerable:!0,get:function(){return n5.Name}});Object.defineProperty(Dp,"CodeGen",{enumerable:!0,get:function(){return n5.CodeGen}});var Htr=xue();Object.defineProperty(Dp,"ValidationError",{enumerable:!0,get:function(){return Htr.default}});var Ytr=Cue();Object.defineProperty(Dp,"MissingRefError",{enumerable:!0,get:function(){return Ytr.default}})});var Hut=At(()=>{var Gut;(function(u){(function(c){var f=typeof globalThis=="object"?globalThis:typeof global=="object"?global:typeof self=="object"?self:typeof this=="object"?this:ee(),v=x(u);typeof f.Reflect<"u"&&(v=x(f.Reflect,v)),c(v,f),typeof f.Reflect>"u"&&(f.Reflect=u);function x(me,de){return function(Te,ut){Object.defineProperty(me,Te,{configurable:!0,writable:!0,value:ut}),de&&de(Te,ut)}}function w(){try{return Function("return this;")()}catch{}}function F(){try{return(0,eval)("(function() { return this; })()")}catch{}}function ee(){return w()||F()}})(function(c,f){var v=Object.prototype.hasOwnProperty,x=typeof Symbol=="function",w=x&&typeof Symbol.toPrimitive<"u"?Symbol.toPrimitive:"@@toPrimitive",F=x&&typeof Symbol.iterator<"u"?Symbol.iterator:"@@iterator",ee=typeof Object.create=="function",me={__proto__:[]}instanceof Array,de=!ee&&!me,Te={create:ee?function(){return N2(Object.create(null))}:me?function(){return N2({__proto__:null})}:function(){return N2({})},has:de?function(jt,ln){return v.call(jt,ln)}:function(jt,ln){return ln in jt},get:de?function(jt,ln){return v.call(jt,ln)?jt[ln]:void 0}:function(jt,ln){return jt[ln]}},ut=Object.getPrototypeOf(Function),Ct=typeof Map=="function"&&typeof Map.prototype.entries=="function"?Map:dy(),Kt=typeof Set=="function"&&typeof Set.prototype.entries=="function"?Set:Pr(),xr=typeof WeakMap=="function"?WeakMap:Cv(),en=x?Symbol.for("@reflect-metadata:registry"):void 0,zn=iA(),yr=Mb(zn);function mr(jt,ln,ai,Js){if(Jo(ai)){if(!Tt(jt))throw new TypeError;if(!ys(ln))throw new TypeError;return Nh(jt,ln)}else{if(!Tt(jt))throw new TypeError;if(!Rl(ln))throw new TypeError;if(!Rl(Js)&&!Jo(Js)&&!Wi(Js))throw new TypeError;return Wi(Js)&&(Js=void 0),ai=Fg(ai),ed(jt,ln,ai,Js)}}c("decorate",mr);function Da(jt,ln){function ai(Js,Fa){if(!Rl(Js))throw new TypeError;if(!Jo(Fa)&&!xv(Fa))throw new TypeError;_a(jt,ln,Js,Fa)}return ai}c("metadata",Da);function oa(jt,ln,ai,Js){if(!Rl(ai))throw new TypeError;return Jo(Js)||(Js=Fg(Js)),_a(jt,ln,ai,Js)}c("defineMetadata",oa);function no(jt,ln,ai){if(!Rl(ln))throw new TypeError;return Jo(ai)||(ai=Fg(ai)),vr(jt,ln,ai)}c("hasMetadata",no);function Cf(jt,ln,ai){if(!Rl(ln))throw new TypeError;return Jo(ai)||(ai=Fg(ai)),g1(jt,ln,ai)}c("hasOwnMetadata",Cf);function hs(jt,ln,ai){if(!Rl(ln))throw new TypeError;return Jo(ai)||(ai=Fg(ai)),ul(jt,ln,ai)}c("getMetadata",hs);function Am(jt,ln,ai){if(!Rl(ln))throw new TypeError;return Jo(ai)||(ai=Fg(ai)),ip(jt,ln,ai)}c("getOwnMetadata",Am);function v0(jt,ln){if(!Rl(jt))throw new TypeError;return Jo(ln)||(ln=Fg(ln)),bv(jt,ln)}c("getMetadataKeys",v0);function mu(jt,ln){if(!Rl(jt))throw new TypeError;return Jo(ln)||(ln=Fg(ln)),A2(jt,ln)}c("getOwnMetadataKeys",mu);function Fn(jt,ln,ai){if(!Rl(ln))throw new TypeError;if(Jo(ai)||(ai=Fg(ai)),!Rl(ln))throw new TypeError;Jo(ai)||(ai=Fg(ai));var Js=y1(ln,ai,!1);return Jo(Js)?!1:Js.OrdinaryDeleteMetadata(jt,ln,ai)}c("deleteMetadata",Fn);function Nh(jt,ln){for(var ai=jt.length-1;ai>=0;--ai){var Js=jt[ai],Fa=Js(ln);if(!Jo(Fa)&&!Wi(Fa)){if(!ys(Fa))throw new TypeError;ln=Fa}}return ln}function ed(jt,ln,ai,Js){for(var Fa=jt.length-1;Fa>=0;--Fa){var Xl=jt[Fa],cu=Xl(ln,ai,Js);if(!Jo(cu)&&!Wi(cu)){if(!Rl(cu))throw new TypeError;Js=cu}}return Js}function vr(jt,ln,ai){var Js=g1(jt,ln,ai);if(Js)return!0;var Fa=lf(ln);return Wi(Fa)?!1:vr(jt,Fa,ai)}function g1(jt,ln,ai){var Js=y1(ln,ai,!1);return Jo(Js)?!1:k2(Js.OrdinaryHasOwnMetadata(jt,ln,ai))}function ul(jt,ln,ai){var Js=g1(jt,ln,ai);if(Js)return ip(jt,ln,ai);var Fa=lf(ln);if(!Wi(Fa))return ul(jt,Fa,ai)}function ip(jt,ln,ai){var Js=y1(ln,ai,!1);if(!Jo(Js))return Js.OrdinaryGetOwnMetadata(jt,ln,ai)}function _a(jt,ln,ai,Js){var Fa=y1(ai,Js,!0);Fa.OrdinaryDefineOwnMetadata(jt,ln,ai,Js)}function bv(jt,ln){var ai=A2(jt,ln),Js=lf(jt);if(Js===null)return ai;var Fa=bv(Js,ln);if(Fa.length<=0)return ai;if(ai.length<=0)return Fa;for(var Xl=new Kt,cu=[],Bc=0,qi=ai;Bc<qi.length;Bc++){var Oa=qi[Bc],di=Xl.has(Oa);di||(Xl.add(Oa),cu.push(Oa))}for(var Ja=0,Is=Fa;Ja<Is.length;Ja++){var Oa=Is[Ja],di=Xl.has(Oa);di||(Xl.add(Oa),cu.push(Oa))}return cu}function A2(jt,ln){var ai=y1(jt,ln,!1);return ai?ai.OrdinaryOwnMetadataKeys(jt,ln):[]}function nA(jt){if(jt===null)return 1;switch(typeof jt){case"undefined":return 0;case"boolean":return 2;case"string":return 3;case"symbol":return 4;case"number":return 5;case"object":return jt===null?1:6;default:return 6}}function Jo(jt){return jt===void 0}function Wi(jt){return jt===null}function S0(jt){return typeof jt=="symbol"}function Rl(jt){return typeof jt=="object"?jt!==null:typeof jt=="function"}function km(jt,ln){switch(nA(jt)){case 0:return jt;case 1:return jt;case 2:return jt;case 3:return jt;case 4:return jt;case 5:return jt}var ai=ln===3?"string":ln===5?"number":"default",Js=dw(jt,w);if(Js!==void 0){var Fa=Js.call(jt,ai);if(Rl(Fa))throw new TypeError;return Fa}return Zd(jt,ai==="default"?"number":ai)}function Zd(jt,ln){if(ln==="string"){var ai=jt.toString;if(Ev(ai)){var Js=ai.call(jt);if(!Rl(Js))return Js}var Fa=jt.valueOf;if(Ev(Fa)){var Js=Fa.call(jt);if(!Rl(Js))return Js}}else{var Fa=jt.valueOf;if(Ev(Fa)){var Js=Fa.call(jt);if(!Rl(Js))return Js}var Xl=jt.toString;if(Ev(Xl)){var Js=Xl.call(jt);if(!Rl(Js))return Js}}throw new TypeError}function k2(jt){return!!jt}function P2(jt){return""+jt}function Fg(jt){var ln=km(jt,3);return S0(ln)?ln:P2(ln)}function Tt(jt){return Array.isArray?Array.isArray(jt):jt instanceof Object?jt instanceof Array:Object.prototype.toString.call(jt)==="[object Array]"}function Ev(jt){return typeof jt=="function"}function ys(jt){return typeof jt=="function"}function xv(jt){switch(nA(jt)){case 3:return!0;case 4:return!0;default:return!1}}function tT(jt,ln){return jt===ln||jt!==jt&&ln!==ln}function dw(jt,ln){var ai=jt[ln];if(ai!=null){if(!Ev(ai))throw new TypeError;return ai}}function mw(jt){var ln=dw(jt,F);if(!Ev(ln))throw new TypeError;var ai=ln.call(jt);if(!Rl(ai))throw new TypeError;return ai}function Dh(jt){return jt.value}function C3(jt){var ln=jt.next();return ln.done?!1:ln}function h1(jt){var ln=jt.return;ln&&ln.call(jt)}function lf(jt){var ln=Object.getPrototypeOf(jt);if(typeof jt!="function"||jt===ut||ln!==ut)return ln;var ai=jt.prototype,Js=ai&&Object.getPrototypeOf(ai);if(Js==null||Js===Object.prototype)return ln;var Fa=Js.constructor;return typeof Fa!="function"||Fa===jt?ln:Fa}function rT(){var jt;!Jo(en)&&typeof f.Reflect<"u"&&!(en in f.Reflect)&&typeof f.Reflect.defineMetadata=="function"&&(jt=td(f.Reflect));var ln,ai,Js,Fa=new xr,Xl={registerProvider:cu,getProvider:qi,setProvider:di};return Xl;function cu(Ja){if(!Object.isExtensible(Xl))throw new Error("Cannot add provider to a frozen registry.");switch(!0){case jt===Ja:break;case Jo(ln):ln=Ja;break;case ln===Ja:break;case Jo(ai):ai=Ja;break;case ai===Ja:break;default:Js===void 0&&(Js=new Kt),Js.add(Ja);break}}function Bc(Ja,Is){if(!Jo(ln)){if(ln.isProviderFor(Ja,Is))return ln;if(!Jo(ai)){if(ai.isProviderFor(Ja,Is))return ln;if(!Jo(Js))for(var Rs=mw(Js);;){var nl=C3(Rs);if(!nl)return;var jg=Dh(nl);if(jg.isProviderFor(Ja,Is))return h1(Rs),jg}}}if(!Jo(jt)&&jt.isProviderFor(Ja,Is))return jt}function qi(Ja,Is){var Rs=Fa.get(Ja),nl;return Jo(Rs)||(nl=Rs.get(Is)),Jo(nl)&&(nl=Bc(Ja,Is),Jo(nl)||(Jo(Rs)&&(Rs=new Ct,Fa.set(Ja,Rs)),Rs.set(Is,nl))),nl}function Oa(Ja){if(Jo(Ja))throw new TypeError;return ln===Ja||ai===Ja||!Jo(Js)&&Js.has(Ja)}function di(Ja,Is,Rs){if(!Oa(Rs))throw new Error("Metadata provider not registered.");var nl=qi(Ja,Is);if(nl!==Rs){if(!Jo(nl))return!1;var jg=Fa.get(Ja);Jo(jg)&&(jg=new Ct,Fa.set(Ja,jg)),jg.set(Is,Rs)}return!0}}function iA(){var jt;return!Jo(en)&&Rl(f.Reflect)&&Object.isExtensible(f.Reflect)&&(jt=f.Reflect[en]),Jo(jt)&&(jt=rT()),!Jo(en)&&Rl(f.Reflect)&&Object.isExtensible(f.Reflect)&&Object.defineProperty(f.Reflect,en,{enumerable:!1,configurable:!1,writable:!1,value:jt}),jt}function Mb(jt){var ln=new xr,ai={isProviderFor:function(Oa,di){var Ja=ln.get(Oa);return Jo(Ja)?!1:Ja.has(di)},OrdinaryDefineOwnMetadata:cu,OrdinaryHasOwnMetadata:Fa,OrdinaryGetOwnMetadata:Xl,OrdinaryOwnMetadataKeys:Bc,OrdinaryDeleteMetadata:qi};return zn.registerProvider(ai),ai;function Js(Oa,di,Ja){var Is=ln.get(Oa),Rs=!1;if(Jo(Is)){if(!Ja)return;Is=new Ct,ln.set(Oa,Is),Rs=!0}var nl=Is.get(di);if(Jo(nl)){if(!Ja)return;if(nl=new Ct,Is.set(di,nl),!jt.setProvider(Oa,di,ai))throw Is.delete(di),Rs&&ln.delete(Oa),new Error("Wrong provider for target.")}return nl}function Fa(Oa,di,Ja){var Is=Js(di,Ja,!1);return Jo(Is)?!1:k2(Is.has(Oa))}function Xl(Oa,di,Ja){var Is=Js(di,Ja,!1);if(!Jo(Is))return Is.get(Oa)}function cu(Oa,di,Ja,Is){var Rs=Js(Ja,Is,!0);Rs.set(Oa,di)}function Bc(Oa,di){var Ja=[],Is=Js(Oa,di,!1);if(Jo(Is))return Ja;for(var Rs=Is.keys(),nl=mw(Rs),jg=0;;){var Op=C3(nl);if(!Op)return Ja.length=jg,Ja;var sA=Dh(Op);try{Ja[jg]=sA}catch(Bg){try{h1(nl)}finally{throw Bg}}jg++}}function qi(Oa,di,Ja){var Is=Js(di,Ja,!1);if(Jo(Is)||!Is.delete(Oa))return!1;if(Is.size===0){var Rs=ln.get(di);Jo(Rs)||(Rs.delete(Ja),Rs.size===0&&ln.delete(Rs))}return!0}}function td(jt){var ln=jt.defineMetadata,ai=jt.hasOwnMetadata,Js=jt.getOwnMetadata,Fa=jt.getOwnMetadataKeys,Xl=jt.deleteMetadata,cu=new xr,Bc={isProviderFor:function(qi,Oa){var di=cu.get(qi);return Jo(di)?Fa(qi,Oa).length?(Jo(di)&&(di=new Kt,cu.set(qi,di)),di.add(Oa),!0):!1:di.has(Oa)},OrdinaryDefineOwnMetadata:ln,OrdinaryHasOwnMetadata:ai,OrdinaryGetOwnMetadata:Js,OrdinaryOwnMetadataKeys:Fa,OrdinaryDeleteMetadata:Xl};return Bc}function y1(jt,ln,ai){var Js=zn.getProvider(jt,ln);if(!Jo(Js))return Js;if(ai){if(zn.setProvider(jt,ln,yr))return yr;throw new Error("Illegal state.")}}function dy(){var jt={},ln=[],ai=function(){function Bc(qi,Oa,di){this._index=0,this._keys=qi,this._values=Oa,this._selector=di}return Bc.prototype["@@iterator"]=function(){return this},Bc.prototype[F]=function(){return this},Bc.prototype.next=function(){var qi=this._index;if(qi>=0&&qi<this._keys.length){var Oa=this._selector(this._keys[qi],this._values[qi]);return qi+1>=this._keys.length?(this._index=-1,this._keys=ln,this._values=ln):this._index++,{value:Oa,done:!1}}return{value:void 0,done:!0}},Bc.prototype.throw=function(qi){throw this._index>=0&&(this._index=-1,this._keys=ln,this._values=ln),qi},Bc.prototype.return=function(qi){return this._index>=0&&(this._index=-1,this._keys=ln,this._values=ln),{value:qi,done:!0}},Bc}(),Js=function(){function Bc(){this._keys=[],this._values=[],this._cacheKey=jt,this._cacheIndex=-2}return Object.defineProperty(Bc.prototype,"size",{get:function(){return this._keys.length},enumerable:!0,configurable:!0}),Bc.prototype.has=function(qi){return this._find(qi,!1)>=0},Bc.prototype.get=function(qi){var Oa=this._find(qi,!1);return Oa>=0?this._values[Oa]:void 0},Bc.prototype.set=function(qi,Oa){var di=this._find(qi,!0);return this._values[di]=Oa,this},Bc.prototype.delete=function(qi){var Oa=this._find(qi,!1);if(Oa>=0){for(var di=this._keys.length,Ja=Oa+1;Ja<di;Ja++)this._keys[Ja-1]=this._keys[Ja],this._values[Ja-1]=this._values[Ja];return this._keys.length--,this._values.length--,tT(qi,this._cacheKey)&&(this._cacheKey=jt,this._cacheIndex=-2),!0}return!1},Bc.prototype.clear=function(){this._keys.length=0,this._values.length=0,this._cacheKey=jt,this._cacheIndex=-2},Bc.prototype.keys=function(){return new ai(this._keys,this._values,Fa)},Bc.prototype.values=function(){return new ai(this._keys,this._values,Xl)},Bc.prototype.entries=function(){return new ai(this._keys,this._values,cu)},Bc.prototype["@@iterator"]=function(){return this.entries()},Bc.prototype[F]=function(){return this.entries()},Bc.prototype._find=function(qi,Oa){if(!tT(this._cacheKey,qi)){this._cacheIndex=-1;for(var di=0;di<this._keys.length;di++)if(tT(this._keys[di],qi)){this._cacheIndex=di;break}}return this._cacheIndex<0&&Oa&&(this._cacheIndex=this._keys.length,this._keys.push(qi),this._values.push(void 0)),this._cacheIndex},Bc}();return Js;function Fa(Bc,qi){return Bc}function Xl(Bc,qi){return qi}function cu(Bc,qi){return[Bc,qi]}}function Pr(){var jt=function(){function ln(){this._map=new Ct}return Object.defineProperty(ln.prototype,"size",{get:function(){return this._map.size},enumerable:!0,configurable:!0}),ln.prototype.has=function(ai){return this._map.has(ai)},ln.prototype.add=function(ai){return this._map.set(ai,ai),this},ln.prototype.delete=function(ai){return this._map.delete(ai)},ln.prototype.clear=function(){this._map.clear()},ln.prototype.keys=function(){return this._map.keys()},ln.prototype.values=function(){return this._map.keys()},ln.prototype.entries=function(){return this._map.entries()},ln.prototype["@@iterator"]=function(){return this.keys()},ln.prototype[F]=function(){return this.keys()},ln}();return jt}function Cv(){var jt=16,ln=Te.create(),ai=Js();return function(){function qi(){this._key=Js()}return qi.prototype.has=function(Oa){var di=Fa(Oa,!1);return di!==void 0?Te.has(di,this._key):!1},qi.prototype.get=function(Oa){var di=Fa(Oa,!1);return di!==void 0?Te.get(di,this._key):void 0},qi.prototype.set=function(Oa,di){var Ja=Fa(Oa,!0);return Ja[this._key]=di,this},qi.prototype.delete=function(Oa){var di=Fa(Oa,!1);return di!==void 0?delete di[this._key]:!1},qi.prototype.clear=function(){this._key=Js()},qi}();function Js(){var qi;do qi="@@WeakMap@@"+Bc();while(Te.has(ln,qi));return ln[qi]=!0,qi}function Fa(qi,Oa){if(!v.call(qi,ai)){if(!Oa)return;Object.defineProperty(qi,ai,{value:Te.create()})}return qi[ai]}function Xl(qi,Oa){for(var di=0;di<Oa;++di)qi[di]=Math.random()*255|0;return qi}function cu(qi){return typeof Uint8Array=="function"?typeof crypto<"u"?crypto.getRandomValues(new Uint8Array(qi)):typeof msCrypto<"u"?msCrypto.getRandomValues(new Uint8Array(qi)):Xl(new Uint8Array(qi),qi):Xl(new Array(qi),qi)}function Bc(){var qi=cu(jt);qi[6]=qi[6]&79|64,qi[8]=qi[8]&191|128;for(var Oa="",di=0;di<jt;++di){var Ja=qi[di];(di===4||di===6||di===8)&&(Oa+="-"),Ja<16&&(Oa+="0"),Oa+=Ja.toString(16).toLowerCase()}return Oa}}function N2(jt){return jt.__=void 0,delete jt.__,jt}})})(Gut||(Gut={}))});var l_e=At((vyr,_ft)=>{var Iir=Array.isArray;_ft.exports=Iir});var pft=At((Syr,fft)=>{var wir=typeof global=="object"&&global&&global.Object===Object&&global;fft.exports=wir});var u_e=At((Tyr,dft)=>{var Oir=pft(),Rir=typeof self=="object"&&self&&self.Object===Object&&self,Mir=Oir||Rir||Function("return this")();dft.exports=Mir});var __e=At((byr,mft)=>{var Lir=u_e(),Fir=Lir.Symbol;mft.exports=Fir});var vft=At((Eyr,yft)=>{var gft=__e(),hft=Object.prototype,jir=hft.hasOwnProperty,Bir=hft.toString,ZW=gft?gft.toStringTag:void 0;function Uir(u){var c=jir.call(u,ZW),f=u[ZW];try{u[ZW]=void 0;var v=!0}catch{}var x=Bir.call(u);return v&&(c?u[ZW]=f:delete u[ZW]),x}yft.exports=Uir});var Tft=At((xyr,Sft)=>{var Vir=Object.prototype,Jir=Vir.toString;function qir(u){return Jir.call(u)}Sft.exports=qir});var Hwe=At((Cyr,xft)=>{var bft=__e(),zir=vft(),$ir=Tft(),Wir="[object Null]",Gir="[object Undefined]",Eft=bft?bft.toStringTag:void 0;function Hir(u){return u==null?u===void 0?Gir:Wir:Eft&&Eft in Object(u)?zir(u):$ir(u)}xft.exports=Hir});var Aft=At((Ayr,Cft)=>{function Yir(u){return u!=null&&typeof u=="object"}Cft.exports=Yir});var f_e=At((kyr,kft)=>{var Xir=Hwe(),Kir=Aft(),Qir="[object Symbol]";function Zir(u){return typeof u=="symbol"||Kir(u)&&Xir(u)==Qir}kft.exports=Zir});var Nft=At((Pyr,Pft)=>{var esr=l_e(),tsr=f_e(),rsr=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,nsr=/^\w*$/;function isr(u,c){if(esr(u))return!1;var f=typeof u;return f=="number"||f=="symbol"||f=="boolean"||u==null||tsr(u)?!0:nsr.test(u)||!rsr.test(u)||c!=null&&u in Object(c)}Pft.exports=isr});var Ywe=At((Nyr,Dft)=>{function ssr(u){var c=typeof u;return u!=null&&(c=="object"||c=="function")}Dft.exports=ssr});var wft=At((Dyr,Ift)=>{var asr=Hwe(),osr=Ywe(),csr="[object AsyncFunction]",lsr="[object Function]",usr="[object GeneratorFunction]",_sr="[object Proxy]";function fsr(u){if(!osr(u))return!1;var c=asr(u);return c==lsr||c==usr||c==csr||c==_sr}Ift.exports=fsr});var Rft=At((Iyr,Oft)=>{var psr=u_e(),dsr=psr["__core-js_shared__"];Oft.exports=dsr});var Fft=At((wyr,Lft)=>{var Xwe=Rft(),Mft=function(){var u=/[^.]+$/.exec(Xwe&&Xwe.keys&&Xwe.keys.IE_PROTO||"");return u?"Symbol(src)_1."+u:""}();function msr(u){return!!Mft&&Mft in u}Lft.exports=msr});var Bft=At((Oyr,jft)=>{var gsr=Function.prototype,hsr=gsr.toString;function ysr(u){if(u!=null){try{return hsr.call(u)}catch{}try{return u+""}catch{}}return""}jft.exports=ysr});var Vft=At((Ryr,Uft)=>{var vsr=wft(),Ssr=Fft(),Tsr=Ywe(),bsr=Bft(),Esr=/[\\^$.*+?()[\]{}|]/g,xsr=/^\[object .+?Constructor\]$/,Csr=Function.prototype,Asr=Object.prototype,ksr=Csr.toString,Psr=Asr.hasOwnProperty,Nsr=RegExp("^"+ksr.call(Psr).replace(Esr,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");function Dsr(u){if(!Tsr(u)||Ssr(u))return!1;var c=vsr(u)?Nsr:xsr;return c.test(bsr(u))}Uft.exports=Dsr});var qft=At((Myr,Jft)=>{function Isr(u,c){return u?.[c]}Jft.exports=Isr});var Kwe=At((Lyr,zft)=>{var wsr=Vft(),Osr=qft();function Rsr(u,c){var f=Osr(u,c);return wsr(f)?f:void 0}zft.exports=Rsr});var eG=At((Fyr,$ft)=>{var Msr=Kwe(),Lsr=Msr(Object,"create");$ft.exports=Lsr});var Hft=At((jyr,Gft)=>{var Wft=eG();function Fsr(){this.__data__=Wft?Wft(null):{},this.size=0}Gft.exports=Fsr});var Xft=At((Byr,Yft)=>{function jsr(u){var c=this.has(u)&&delete this.__data__[u];return this.size-=c?1:0,c}Yft.exports=jsr});var Qft=At((Uyr,Kft)=>{var Bsr=eG(),Usr="__lodash_hash_undefined__",Vsr=Object.prototype,Jsr=Vsr.hasOwnProperty;function qsr(u){var c=this.__data__;if(Bsr){var f=c[u];return f===Usr?void 0:f}return Jsr.call(c,u)?c[u]:void 0}Kft.exports=qsr});var ept=At((Vyr,Zft)=>{var zsr=eG(),$sr=Object.prototype,Wsr=$sr.hasOwnProperty;function Gsr(u){var c=this.__data__;return zsr?c[u]!==void 0:Wsr.call(c,u)}Zft.exports=Gsr});var rpt=At((Jyr,tpt)=>{var Hsr=eG(),Ysr="__lodash_hash_undefined__";function Xsr(u,c){var f=this.__data__;return this.size+=this.has(u)?0:1,f[u]=Hsr&&c===void 0?Ysr:c,this}tpt.exports=Xsr});var ipt=At((qyr,npt)=>{var Ksr=Hft(),Qsr=Xft(),Zsr=Qft(),ear=ept(),tar=rpt();function f5(u){var c=-1,f=u==null?0:u.length;for(this.clear();++c<f;){var v=u[c];this.set(v[0],v[1])}}f5.prototype.clear=Ksr;f5.prototype.delete=Qsr;f5.prototype.get=Zsr;f5.prototype.has=ear;f5.prototype.set=tar;npt.exports=f5});var apt=At((zyr,spt)=>{function rar(){this.__data__=[],this.size=0}spt.exports=rar});var cpt=At(($yr,opt)=>{function nar(u,c){return u===c||u!==u&&c!==c}opt.exports=nar});var tG=At((Wyr,lpt)=>{var iar=cpt();function sar(u,c){for(var f=u.length;f--;)if(iar(u[f][0],c))return f;return-1}lpt.exports=sar});var _pt=At((Gyr,upt)=>{var aar=tG(),oar=Array.prototype,car=oar.splice;function lar(u){var c=this.__data__,f=aar(c,u);if(f<0)return!1;var v=c.length-1;return f==v?c.pop():car.call(c,f,1),--this.size,!0}upt.exports=lar});var ppt=At((Hyr,fpt)=>{var uar=tG();function _ar(u){var c=this.__data__,f=uar(c,u);return f<0?void 0:c[f][1]}fpt.exports=_ar});var mpt=At((Yyr,dpt)=>{var far=tG();function par(u){return far(this.__data__,u)>-1}dpt.exports=par});var hpt=At((Xyr,gpt)=>{var dar=tG();function mar(u,c){var f=this.__data__,v=dar(f,u);return v<0?(++this.size,f.push([u,c])):f[v][1]=c,this}gpt.exports=mar});var vpt=At((Kyr,ypt)=>{var gar=apt(),har=_pt(),yar=ppt(),Sar=mpt(),Tar=hpt();function p5(u){var c=-1,f=u==null?0:u.length;for(this.clear();++c<f;){var v=u[c];this.set(v[0],v[1])}}p5.prototype.clear=gar;p5.prototype.delete=har;p5.prototype.get=yar;p5.prototype.has=Sar;p5.prototype.set=Tar;ypt.exports=p5});var Tpt=At((Qyr,Spt)=>{var bar=Kwe(),Ear=u_e(),xar=bar(Ear,"Map");Spt.exports=xar});var xpt=At((Zyr,Ept)=>{var bpt=ipt(),Car=vpt(),Aar=Tpt();function kar(){this.size=0,this.__data__={hash:new bpt,map:new(Aar||Car),string:new bpt}}Ept.exports=kar});var Apt=At((e1r,Cpt)=>{function Par(u){var c=typeof u;return c=="string"||c=="number"||c=="symbol"||c=="boolean"?u!=="__proto__":u===null}Cpt.exports=Par});var rG=At((t1r,kpt)=>{var Nar=Apt();function Dar(u,c){var f=u.__data__;return Nar(c)?f[typeof c=="string"?"string":"hash"]:f.map}kpt.exports=Dar});var Npt=At((r1r,Ppt)=>{var Iar=rG();function war(u){var c=Iar(this,u).delete(u);return this.size-=c?1:0,c}Ppt.exports=war});var Ipt=At((n1r,Dpt)=>{var Oar=rG();function Rar(u){return Oar(this,u).get(u)}Dpt.exports=Rar});var Opt=At((i1r,wpt)=>{var Mar=rG();function Lar(u){return Mar(this,u).has(u)}wpt.exports=Lar});var Mpt=At((s1r,Rpt)=>{var Far=rG();function jar(u,c){var f=Far(this,u),v=f.size;return f.set(u,c),this.size+=f.size==v?0:1,this}Rpt.exports=jar});var Fpt=At((a1r,Lpt)=>{var Bar=xpt(),Uar=Npt(),Var=Ipt(),Jar=Opt(),qar=Mpt();function d5(u){var c=-1,f=u==null?0:u.length;for(this.clear();++c<f;){var v=u[c];this.set(v[0],v[1])}}d5.prototype.clear=Bar;d5.prototype.delete=Uar;d5.prototype.get=Var;d5.prototype.has=Jar;d5.prototype.set=qar;Lpt.exports=d5});var Upt=At((o1r,Bpt)=>{var jpt=Fpt(),zar="Expected a function";function Qwe(u,c){if(typeof u!="function"||c!=null&&typeof c!="function")throw new TypeError(zar);var f=function(){var v=arguments,x=c?c.apply(this,v):v[0],w=f.cache;if(w.has(x))return w.get(x);var F=u.apply(this,v);return f.cache=w.set(x,F)||w,F};return f.cache=new(Qwe.Cache||jpt),f}Qwe.Cache=jpt;Bpt.exports=Qwe});var Jpt=At((c1r,Vpt)=>{var $ar=Upt(),War=500;function Gar(u){var c=$ar(u,function(v){return f.size===War&&f.clear(),v}),f=c.cache;return c}Vpt.exports=Gar});var zpt=At((l1r,qpt)=>{var Har=Jpt(),Yar=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,Xar=/\\(\\)?/g,Kar=Har(function(u){var c=[];return u.charCodeAt(0)===46&&c.push(""),u.replace(Yar,function(f,v,x,w){c.push(x?w.replace(Xar,"$1"):v||f)}),c});qpt.exports=Kar});var Wpt=At((u1r,$pt)=>{function Qar(u,c){for(var f=-1,v=u==null?0:u.length,x=Array(v);++f<v;)x[f]=c(u[f],f,u);return x}$pt.exports=Qar});var Qpt=At((_1r,Kpt)=>{var Gpt=__e(),Zar=Wpt(),eor=l_e(),tor=f_e(),ror=1/0,Hpt=Gpt?Gpt.prototype:void 0,Ypt=Hpt?Hpt.toString:void 0;function Xpt(u){if(typeof u=="string")return u;if(eor(u))return Zar(u,Xpt)+"";if(tor(u))return Ypt?Ypt.call(u):"";var c=u+"";return c=="0"&&1/u==-ror?"-0":c}Kpt.exports=Xpt});var edt=At((f1r,Zpt)=>{var nor=Qpt();function ior(u){return u==null?"":nor(u)}Zpt.exports=ior});var rdt=At((p1r,tdt)=>{var sor=l_e(),aor=Nft(),oor=zpt(),cor=edt();function lor(u,c){return sor(u)?u:aor(u,c)?[u]:oor(cor(u))}tdt.exports=lor});var idt=At((d1r,ndt)=>{var uor=f_e(),_or=1/0;function por(u){if(typeof u=="string"||uor(u))return u;var c=u+"";return c=="0"&&1/u==-_or?"-0":c}ndt.exports=por});var adt=At((m1r,sdt)=>{var dor=rdt(),mor=idt();function gor(u,c){c=dor(c,u);for(var f=0,v=c.length;u!=null&&f<v;)u=u[mor(c[f++])];return f&&f==v?u:void 0}sdt.exports=gor});var nG=At((g1r,odt)=>{var hor=adt();function yor(u,c,f){var v=u==null?void 0:hor(u,c);return v===void 0?f:v}odt.exports=yor});var ldt=At(Zwe=>{var cdt="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");Zwe.encode=function(u){if(0<=u&&u<cdt.length)return cdt[u];throw new TypeError("Must be between 0 and 63: "+u)};Zwe.decode=function(u){var c=65,f=90,v=97,x=122,w=48,F=57,ee=43,me=47,de=26,Te=52;return c<=u&&u<=f?u-c:v<=u&&u<=x?u-v+de:w<=u&&u<=F?u-w+Te:u==ee?62:u==me?63:-1}});var r6e=At(t6e=>{var udt=ldt(),e6e=5,_dt=1<<e6e,fdt=_dt-1,pdt=_dt;function vor(u){return u<0?(-u<<1)+1:(u<<1)+0}function Sor(u){var c=(u&1)===1,f=u>>1;return c?-f:f}t6e.encode=function(c){var f="",v,x=vor(c);do v=x&fdt,x>>>=e6e,x>0&&(v|=pdt),f+=udt.encode(v);while(x>0);return f};t6e.decode=function(c,f,v){var x=c.length,w=0,F=0,ee,me;do{if(f>=x)throw new Error("Expected more digits in base 64 VLQ value.");if(me=udt.decode(c.charCodeAt(f++)),me===-1)throw new Error("Invalid base64 digit: "+c.charAt(f-1));ee=!!(me&pdt),me&=fdt,w=w+(me<<F),F+=e6e}while(ee);v.value=Sor(w),v.rest=f}});var h5=At(fy=>{function Tor(u,c,f){if(c in u)return u[c];if(arguments.length===3)return f;throw new Error('"'+c+'" is a required argument.')}fy.getArg=Tor;var ddt=/^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.-]*)(?::(\d+))?(.*)$/,bor=/^data:.+\,.+$/;function iG(u){var c=u.match(ddt);return c?{scheme:c[1],auth:c[2],host:c[3],port:c[4],path:c[5]}:null}fy.urlParse=iG;function m5(u){var c="";return u.scheme&&(c+=u.scheme+":"),c+="//",u.auth&&(c+=u.auth+"@"),u.host&&(c+=u.host),u.port&&(c+=":"+u.port),u.path&&(c+=u.path),c}fy.urlGenerate=m5;function n6e(u){var c=u,f=iG(u);if(f){if(!f.path)return u;c=f.path}for(var v=fy.isAbsolute(c),x=c.split(/\/+/),w,F=0,ee=x.length-1;ee>=0;ee--)w=x[ee],w==="."?x.splice(ee,1):w===".."?F++:F>0&&(w===""?(x.splice(ee+1,F),F=0):(x.splice(ee,2),F--));return c=x.join("/"),c===""&&(c=v?"/":"."),f?(f.path=c,m5(f)):c}fy.normalize=n6e;function mdt(u,c){u===""&&(u="."),c===""&&(c=".");var f=iG(c),v=iG(u);if(v&&(u=v.path||"/"),f&&!f.scheme)return v&&(f.scheme=v.scheme),m5(f);if(f||c.match(bor))return c;if(v&&!v.host&&!v.path)return v.host=c,m5(v);var x=c.charAt(0)==="/"?c:n6e(u.replace(/\/+$/,"")+"/"+c);return v?(v.path=x,m5(v)):x}fy.join=mdt;fy.isAbsolute=function(u){return u.charAt(0)==="/"||ddt.test(u)};function Eor(u,c){u===""&&(u="."),u=u.replace(/\/$/,"");for(var f=0;c.indexOf(u+"/")!==0;){var v=u.lastIndexOf("/");if(v<0||(u=u.slice(0,v),u.match(/^([^\/]+:\/)?\/*$/)))return c;++f}return Array(f+1).join("../")+c.substr(u.length+1)}fy.relative=Eor;var gdt=function(){var u=Object.create(null);return!("__proto__"in u)}();function hdt(u){return u}function xor(u){return ydt(u)?"$"+u:u}fy.toSetString=gdt?hdt:xor;function Cor(u){return ydt(u)?u.slice(1):u}fy.fromSetString=gdt?hdt:Cor;function ydt(u){if(!u)return!1;var c=u.length;if(c<9||u.charCodeAt(c-1)!==95||u.charCodeAt(c-2)!==95||u.charCodeAt(c-3)!==111||u.charCodeAt(c-4)!==116||u.charCodeAt(c-5)!==111||u.charCodeAt(c-6)!==114||u.charCodeAt(c-7)!==112||u.charCodeAt(c-8)!==95||u.charCodeAt(c-9)!==95)return!1;for(var f=c-10;f>=0;f--)if(u.charCodeAt(f)!==36)return!1;return!0}function Aor(u,c,f){var v=g5(u.source,c.source);return v!==0||(v=u.originalLine-c.originalLine,v!==0)||(v=u.originalColumn-c.originalColumn,v!==0||f)||(v=u.generatedColumn-c.generatedColumn,v!==0)||(v=u.generatedLine-c.generatedLine,v!==0)?v:g5(u.name,c.name)}fy.compareByOriginalPositions=Aor;function kor(u,c,f){var v=u.generatedLine-c.generatedLine;return v!==0||(v=u.generatedColumn-c.generatedColumn,v!==0||f)||(v=g5(u.source,c.source),v!==0)||(v=u.originalLine-c.originalLine,v!==0)||(v=u.originalColumn-c.originalColumn,v!==0)?v:g5(u.name,c.name)}fy.compareByGeneratedPositionsDeflated=kor;function g5(u,c){return u===c?0:u===null?1:c===null?-1:u>c?1:-1}function Por(u,c){var f=u.generatedLine-c.generatedLine;return f!==0||(f=u.generatedColumn-c.generatedColumn,f!==0)||(f=g5(u.source,c.source),f!==0)||(f=u.originalLine-c.originalLine,f!==0)||(f=u.originalColumn-c.originalColumn,f!==0)?f:g5(u.name,c.name)}fy.compareByGeneratedPositionsInflated=Por;function Nor(u){return JSON.parse(u.replace(/^\)]}'[^\n]*\n/,""))}fy.parseSourceMapInput=Nor;function Dor(u,c,f){if(c=c||"",u&&(u[u.length-1]!=="/"&&c[0]!=="/"&&(u+="/"),c=u+c),f){var v=iG(f);if(!v)throw new Error("sourceMapURL could not be parsed");if(v.path){var x=v.path.lastIndexOf("/");x>=0&&(v.path=v.path.substring(0,x+1))}c=mdt(m5(v),c)}return n6e(c)}fy.computeSourceURL=Dor});var a6e=At(vdt=>{var i6e=h5(),s6e=Object.prototype.hasOwnProperty,m3=typeof Map<"u";function NP(){this._array=[],this._set=m3?new Map:Object.create(null)}NP.fromArray=function(c,f){for(var v=new NP,x=0,w=c.length;x<w;x++)v.add(c[x],f);return v};NP.prototype.size=function(){return m3?this._set.size:Object.getOwnPropertyNames(this._set).length};NP.prototype.add=function(c,f){var v=m3?c:i6e.toSetString(c),x=m3?this.has(c):s6e.call(this._set,v),w=this._array.length;(!x||f)&&this._array.push(c),x||(m3?this._set.set(c,w):this._set[v]=w)};NP.prototype.has=function(c){if(m3)return this._set.has(c);var f=i6e.toSetString(c);return s6e.call(this._set,f)};NP.prototype.indexOf=function(c){if(m3){var f=this._set.get(c);if(f>=0)return f}else{var v=i6e.toSetString(c);if(s6e.call(this._set,v))return this._set[v]}throw new Error('"'+c+'" is not in the set.')};NP.prototype.at=function(c){if(c>=0&&c<this._array.length)return this._array[c];throw new Error("No element indexed by "+c)};NP.prototype.toArray=function(){return this._array.slice()};vdt.ArraySet=NP});var bdt=At(Tdt=>{var Sdt=h5();function Ior(u,c){var f=u.generatedLine,v=c.generatedLine,x=u.generatedColumn,w=c.generatedColumn;return v>f||v==f&&w>=x||Sdt.compareByGeneratedPositionsInflated(u,c)<=0}function p_e(){this._array=[],this._sorted=!0,this._last={generatedLine:-1,generatedColumn:0}}p_e.prototype.unsortedForEach=function(c,f){this._array.forEach(c,f)};p_e.prototype.add=function(c){Ior(this._last,c)?(this._last=c,this._array.push(c)):(this._sorted=!1,this._array.push(c))};p_e.prototype.toArray=function(){return this._sorted||(this._array.sort(Sdt.compareByGeneratedPositionsInflated),this._sorted=!0),this._array};Tdt.MappingList=p_e});var o6e=At(Edt=>{var sG=r6e(),og=h5(),d_e=a6e().ArraySet,wor=bdt().MappingList;function Db(u){u||(u={}),this._file=og.getArg(u,"file",null),this._sourceRoot=og.getArg(u,"sourceRoot",null),this._skipValidation=og.getArg(u,"skipValidation",!1),this._sources=new d_e,this._names=new d_e,this._mappings=new wor,this._sourcesContents=null}Db.prototype._version=3;Db.fromSourceMap=function(c){var f=c.sourceRoot,v=new Db({file:c.file,sourceRoot:f});return c.eachMapping(function(x){var w={generated:{line:x.generatedLine,column:x.generatedColumn}};x.source!=null&&(w.source=x.source,f!=null&&(w.source=og.relative(f,w.source)),w.original={line:x.originalLine,column:x.originalColumn},x.name!=null&&(w.name=x.name)),v.addMapping(w)}),c.sources.forEach(function(x){var w=x;f!==null&&(w=og.relative(f,x)),v._sources.has(w)||v._sources.add(w);var F=c.sourceContentFor(x);F!=null&&v.setSourceContent(x,F)}),v};Db.prototype.addMapping=function(c){var f=og.getArg(c,"generated"),v=og.getArg(c,"original",null),x=og.getArg(c,"source",null),w=og.getArg(c,"name",null);this._skipValidation||this._validateMapping(f,v,x,w),x!=null&&(x=String(x),this._sources.has(x)||this._sources.add(x)),w!=null&&(w=String(w),this._names.has(w)||this._names.add(w)),this._mappings.add({generatedLine:f.line,generatedColumn:f.column,originalLine:v!=null&&v.line,originalColumn:v!=null&&v.column,source:x,name:w})};Db.prototype.setSourceContent=function(c,f){var v=c;this._sourceRoot!=null&&(v=og.relative(this._sourceRoot,v)),f!=null?(this._sourcesContents||(this._sourcesContents=Object.create(null)),this._sourcesContents[og.toSetString(v)]=f):this._sourcesContents&&(delete this._sourcesContents[og.toSetString(v)],Object.keys(this._sourcesContents).length===0&&(this._sourcesContents=null))};Db.prototype.applySourceMap=function(c,f,v){var x=f;if(f==null){if(c.file==null)throw new Error(`SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, or the source map's "file" property. Both were omitted.`);x=c.file}var w=this._sourceRoot;w!=null&&(x=og.relative(w,x));var F=new d_e,ee=new d_e;this._mappings.unsortedForEach(function(me){if(me.source===x&&me.originalLine!=null){var de=c.originalPositionFor({line:me.originalLine,column:me.originalColumn});de.source!=null&&(me.source=de.source,v!=null&&(me.source=og.join(v,me.source)),w!=null&&(me.source=og.relative(w,me.source)),me.originalLine=de.line,me.originalColumn=de.column,de.name!=null&&(me.name=de.name))}var Te=me.source;Te!=null&&!F.has(Te)&&F.add(Te);var ut=me.name;ut!=null&&!ee.has(ut)&&ee.add(ut)},this),this._sources=F,this._names=ee,c.sources.forEach(function(me){var de=c.sourceContentFor(me);de!=null&&(v!=null&&(me=og.join(v,me)),w!=null&&(me=og.relative(w,me)),this.setSourceContent(me,de))},this)};Db.prototype._validateMapping=function(c,f,v,x){if(f&&typeof f.line!="number"&&typeof f.column!="number")throw new Error("original.line and original.column are not numbers -- you probably meant to omit the original mapping entirely and only map the generated position. If so, pass null for the original mapping instead of an object with empty or null values.");if(!(c&&"line"in c&&"column"in c&&c.line>0&&c.column>=0&&!f&&!v&&!x)){if(c&&"line"in c&&"column"in c&&f&&"line"in f&&"column"in f&&c.line>0&&c.column>=0&&f.line>0&&f.column>=0&&v)return;throw new Error("Invalid mapping: "+JSON.stringify({generated:c,source:v,original:f,name:x}))}};Db.prototype._serializeMappings=function(){for(var c=0,f=1,v=0,x=0,w=0,F=0,ee="",me,de,Te,ut,Ct=this._mappings.toArray(),Kt=0,xr=Ct.length;Kt<xr;Kt++){if(de=Ct[Kt],me="",de.generatedLine!==f)for(c=0;de.generatedLine!==f;)me+=";",f++;else if(Kt>0){if(!og.compareByGeneratedPositionsInflated(de,Ct[Kt-1]))continue;me+=","}me+=sG.encode(de.generatedColumn-c),c=de.generatedColumn,de.source!=null&&(ut=this._sources.indexOf(de.source),me+=sG.encode(ut-F),F=ut,me+=sG.encode(de.originalLine-1-x),x=de.originalLine-1,me+=sG.encode(de.originalColumn-v),v=de.originalColumn,de.name!=null&&(Te=this._names.indexOf(de.name),me+=sG.encode(Te-w),w=Te)),ee+=me}return ee};Db.prototype._generateSourcesContent=function(c,f){return c.map(function(v){if(!this._sourcesContents)return null;f!=null&&(v=og.relative(f,v));var x=og.toSetString(v);return Object.prototype.hasOwnProperty.call(this._sourcesContents,x)?this._sourcesContents[x]:null},this)};Db.prototype.toJSON=function(){var c={version:this._version,sources:this._sources.toArray(),names:this._names.toArray(),mappings:this._serializeMappings()};return this._file!=null&&(c.file=this._file),this._sourceRoot!=null&&(c.sourceRoot=this._sourceRoot),this._sourcesContents&&(c.sourcesContent=this._generateSourcesContent(c.sources,c.sourceRoot)),c};Db.prototype.toString=function(){return JSON.stringify(this.toJSON())};Edt.SourceMapGenerator=Db});var xdt=At(g3=>{g3.GREATEST_LOWER_BOUND=1;g3.LEAST_UPPER_BOUND=2;function c6e(u,c,f,v,x,w){var F=Math.floor((c-u)/2)+u,ee=x(f,v[F],!0);return ee===0?F:ee>0?c-F>1?c6e(F,c,f,v,x,w):w==g3.LEAST_UPPER_BOUND?c<v.length?c:-1:F:F-u>1?c6e(u,F,f,v,x,w):w==g3.LEAST_UPPER_BOUND?F:u<0?-1:u}g3.search=function(c,f,v,x){if(f.length===0)return-1;var w=c6e(-1,f.length,c,f,v,x||g3.GREATEST_LOWER_BOUND);if(w<0)return-1;for(;w-1>=0&&v(f[w],f[w-1],!0)===0;)--w;return w}});var Adt=At(Cdt=>{function l6e(u,c,f){var v=u[c];u[c]=u[f],u[f]=v}function Oor(u,c){return Math.round(u+Math.random()*(c-u))}function u6e(u,c,f,v){if(f<v){var x=Oor(f,v),w=f-1;l6e(u,x,v);for(var F=u[v],ee=f;ee<v;ee++)c(u[ee],F)<=0&&(w+=1,l6e(u,w,ee));l6e(u,w+1,ee);var me=w+1;u6e(u,c,f,me-1),u6e(u,c,me+1,v)}}Cdt.quickSort=function(u,c){u6e(u,c,0,u.length-1)}});var Pdt=At(m_e=>{var lo=h5(),_6e=xdt(),y5=a6e().ArraySet,Ror=r6e(),aG=Adt().quickSort;function Ip(u,c){var f=u;return typeof u=="string"&&(f=lo.parseSourceMapInput(u)),f.sections!=null?new T2(f,c):new y0(f,c)}Ip.fromSourceMap=function(u,c){return y0.fromSourceMap(u,c)};Ip.prototype._version=3;Ip.prototype.__generatedMappings=null;Object.defineProperty(Ip.prototype,"_generatedMappings",{configurable:!0,enumerable:!0,get:function(){return this.__generatedMappings||this._parseMappings(this._mappings,this.sourceRoot),this.__generatedMappings}});Ip.prototype.__originalMappings=null;Object.defineProperty(Ip.prototype,"_originalMappings",{configurable:!0,enumerable:!0,get:function(){return this.__originalMappings||this._parseMappings(this._mappings,this.sourceRoot),this.__originalMappings}});Ip.prototype._charIsMappingSeparator=function(c,f){var v=c.charAt(f);return v===";"||v===","};Ip.prototype._parseMappings=function(c,f){throw new Error("Subclasses must implement _parseMappings")};Ip.GENERATED_ORDER=1;Ip.ORIGINAL_ORDER=2;Ip.GREATEST_LOWER_BOUND=1;Ip.LEAST_UPPER_BOUND=2;Ip.prototype.eachMapping=function(c,f,v){var x=f||null,w=v||Ip.GENERATED_ORDER,F;switch(w){case Ip.GENERATED_ORDER:F=this._generatedMappings;break;case Ip.ORIGINAL_ORDER:F=this._originalMappings;break;default:throw new Error("Unknown order of iteration.")}var ee=this.sourceRoot;F.map(function(me){var de=me.source===null?null:this._sources.at(me.source);return de=lo.computeSourceURL(ee,de,this._sourceMapURL),{source:de,generatedLine:me.generatedLine,generatedColumn:me.generatedColumn,originalLine:me.originalLine,originalColumn:me.originalColumn,name:me.name===null?null:this._names.at(me.name)}},this).forEach(c,x)};Ip.prototype.allGeneratedPositionsFor=function(c){var f=lo.getArg(c,"line"),v={source:lo.getArg(c,"source"),originalLine:f,originalColumn:lo.getArg(c,"column",0)};if(v.source=this._findSourceIndex(v.source),v.source<0)return[];var x=[],w=this._findMapping(v,this._originalMappings,"originalLine","originalColumn",lo.compareByOriginalPositions,_6e.LEAST_UPPER_BOUND);if(w>=0){var F=this._originalMappings[w];if(c.column===void 0)for(var ee=F.originalLine;F&&F.originalLine===ee;)x.push({line:lo.getArg(F,"generatedLine",null),column:lo.getArg(F,"generatedColumn",null),lastColumn:lo.getArg(F,"lastGeneratedColumn",null)}),F=this._originalMappings[++w];else for(var me=F.originalColumn;F&&F.originalLine===f&&F.originalColumn==me;)x.push({line:lo.getArg(F,"generatedLine",null),column:lo.getArg(F,"generatedColumn",null),lastColumn:lo.getArg(F,"lastGeneratedColumn",null)}),F=this._originalMappings[++w]}return x};m_e.SourceMapConsumer=Ip;function y0(u,c){var f=u;typeof u=="string"&&(f=lo.parseSourceMapInput(u));var v=lo.getArg(f,"version"),x=lo.getArg(f,"sources"),w=lo.getArg(f,"names",[]),F=lo.getArg(f,"sourceRoot",null),ee=lo.getArg(f,"sourcesContent",null),me=lo.getArg(f,"mappings"),de=lo.getArg(f,"file",null);if(v!=this._version)throw new Error("Unsupported version: "+v);F&&(F=lo.normalize(F)),x=x.map(String).map(lo.normalize).map(function(Te){return F&&lo.isAbsolute(F)&&lo.isAbsolute(Te)?lo.relative(F,Te):Te}),this._names=y5.fromArray(w.map(String),!0),this._sources=y5.fromArray(x,!0),this._absoluteSources=this._sources.toArray().map(function(Te){return lo.computeSourceURL(F,Te,c)}),this.sourceRoot=F,this.sourcesContent=ee,this._mappings=me,this._sourceMapURL=c,this.file=de}y0.prototype=Object.create(Ip.prototype);y0.prototype.consumer=Ip;y0.prototype._findSourceIndex=function(u){var c=u;if(this.sourceRoot!=null&&(c=lo.relative(this.sourceRoot,c)),this._sources.has(c))return this._sources.indexOf(c);var f;for(f=0;f<this._absoluteSources.length;++f)if(this._absoluteSources[f]==u)return f;return-1};y0.fromSourceMap=function(c,f){var v=Object.create(y0.prototype),x=v._names=y5.fromArray(c._names.toArray(),!0),w=v._sources=y5.fromArray(c._sources.toArray(),!0);v.sourceRoot=c._sourceRoot,v.sourcesContent=c._generateSourcesContent(v._sources.toArray(),v.sourceRoot),v.file=c._file,v._sourceMapURL=f,v._absoluteSources=v._sources.toArray().map(function(Kt){return lo.computeSourceURL(v.sourceRoot,Kt,f)});for(var F=c._mappings.toArray().slice(),ee=v.__generatedMappings=[],me=v.__originalMappings=[],de=0,Te=F.length;de<Te;de++){var ut=F[de],Ct=new kdt;Ct.generatedLine=ut.generatedLine,Ct.generatedColumn=ut.generatedColumn,ut.source&&(Ct.source=w.indexOf(ut.source),Ct.originalLine=ut.originalLine,Ct.originalColumn=ut.originalColumn,ut.name&&(Ct.name=x.indexOf(ut.name)),me.push(Ct)),ee.push(Ct)}return aG(v.__originalMappings,lo.compareByOriginalPositions),v};y0.prototype._version=3;Object.defineProperty(y0.prototype,"sources",{get:function(){return this._absoluteSources.slice()}});function kdt(){this.generatedLine=0,this.generatedColumn=0,this.source=null,this.originalLine=null,this.originalColumn=null,this.name=null}y0.prototype._parseMappings=function(c,f){for(var v=1,x=0,w=0,F=0,ee=0,me=0,de=c.length,Te=0,ut={},Ct={},Kt=[],xr=[],en,zn,yr,mr,Da;Te<de;)if(c.charAt(Te)===";")v++,Te++,x=0;else if(c.charAt(Te)===",")Te++;else{for(en=new kdt,en.generatedLine=v,mr=Te;mr<de&&!this._charIsMappingSeparator(c,mr);mr++);if(zn=c.slice(Te,mr),yr=ut[zn],yr)Te+=zn.length;else{for(yr=[];Te<mr;)Ror.decode(c,Te,Ct),Da=Ct.value,Te=Ct.rest,yr.push(Da);if(yr.length===2)throw new Error("Found a source, but no line and column");if(yr.length===3)throw new Error("Found a source and line, but no column");ut[zn]=yr}en.generatedColumn=x+yr[0],x=en.generatedColumn,yr.length>1&&(en.source=ee+yr[1],ee+=yr[1],en.originalLine=w+yr[2],w=en.originalLine,en.originalLine+=1,en.originalColumn=F+yr[3],F=en.originalColumn,yr.length>4&&(en.name=me+yr[4],me+=yr[4])),xr.push(en),typeof en.originalLine=="number"&&Kt.push(en)}aG(xr,lo.compareByGeneratedPositionsDeflated),this.__generatedMappings=xr,aG(Kt,lo.compareByOriginalPositions),this.__originalMappings=Kt};y0.prototype._findMapping=function(c,f,v,x,w,F){if(c[v]<=0)throw new TypeError("Line must be greater than or equal to 1, got "+c[v]);if(c[x]<0)throw new TypeError("Column must be greater than or equal to 0, got "+c[x]);return _6e.search(c,f,w,F)};y0.prototype.computeColumnSpans=function(){for(var c=0;c<this._generatedMappings.length;++c){var f=this._generatedMappings[c];if(c+1<this._generatedMappings.length){var v=this._generatedMappings[c+1];if(f.generatedLine===v.generatedLine){f.lastGeneratedColumn=v.generatedColumn-1;continue}}f.lastGeneratedColumn=1/0}};y0.prototype.originalPositionFor=function(c){var f={generatedLine:lo.getArg(c,"line"),generatedColumn:lo.getArg(c,"column")},v=this._findMapping(f,this._generatedMappings,"generatedLine","generatedColumn",lo.compareByGeneratedPositionsDeflated,lo.getArg(c,"bias",Ip.GREATEST_LOWER_BOUND));if(v>=0){var x=this._generatedMappings[v];if(x.generatedLine===f.generatedLine){var w=lo.getArg(x,"source",null);w!==null&&(w=this._sources.at(w),w=lo.computeSourceURL(this.sourceRoot,w,this._sourceMapURL));var F=lo.getArg(x,"name",null);return F!==null&&(F=this._names.at(F)),{source:w,line:lo.getArg(x,"originalLine",null),column:lo.getArg(x,"originalColumn",null),name:F}}}return{source:null,line:null,column:null,name:null}};y0.prototype.hasContentsOfAllSources=function(){return this.sourcesContent?this.sourcesContent.length>=this._sources.size()&&!this.sourcesContent.some(function(c){return c==null}):!1};y0.prototype.sourceContentFor=function(c,f){if(!this.sourcesContent)return null;var v=this._findSourceIndex(c);if(v>=0)return this.sourcesContent[v];var x=c;this.sourceRoot!=null&&(x=lo.relative(this.sourceRoot,x));var w;if(this.sourceRoot!=null&&(w=lo.urlParse(this.sourceRoot))){var F=x.replace(/^file:\/\//,"");if(w.scheme=="file"&&this._sources.has(F))return this.sourcesContent[this._sources.indexOf(F)];if((!w.path||w.path=="/")&&this._sources.has("/"+x))return this.sourcesContent[this._sources.indexOf("/"+x)]}if(f)return null;throw new Error('"'+x+'" is not in the SourceMap.')};y0.prototype.generatedPositionFor=function(c){var f=lo.getArg(c,"source");if(f=this._findSourceIndex(f),f<0)return{line:null,column:null,lastColumn:null};var v={source:f,originalLine:lo.getArg(c,"line"),originalColumn:lo.getArg(c,"column")},x=this._findMapping(v,this._originalMappings,"originalLine","originalColumn",lo.compareByOriginalPositions,lo.getArg(c,"bias",Ip.GREATEST_LOWER_BOUND));if(x>=0){var w=this._originalMappings[x];if(w.source===v.source)return{line:lo.getArg(w,"generatedLine",null),column:lo.getArg(w,"generatedColumn",null),lastColumn:lo.getArg(w,"lastGeneratedColumn",null)}}return{line:null,column:null,lastColumn:null}};m_e.BasicSourceMapConsumer=y0;function T2(u,c){var f=u;typeof u=="string"&&(f=lo.parseSourceMapInput(u));var v=lo.getArg(f,"version"),x=lo.getArg(f,"sections");if(v!=this._version)throw new Error("Unsupported version: "+v);this._sources=new y5,this._names=new y5;var w={line:-1,column:0};this._sections=x.map(function(F){if(F.url)throw new Error("Support for url field in sections not implemented.");var ee=lo.getArg(F,"offset"),me=lo.getArg(ee,"line"),de=lo.getArg(ee,"column");if(me<w.line||me===w.line&&de<w.column)throw new Error("Section offsets must be ordered and non-overlapping.");return w=ee,{generatedOffset:{generatedLine:me+1,generatedColumn:de+1},consumer:new Ip(lo.getArg(F,"map"),c)}})}T2.prototype=Object.create(Ip.prototype);T2.prototype.constructor=Ip;T2.prototype._version=3;Object.defineProperty(T2.prototype,"sources",{get:function(){for(var u=[],c=0;c<this._sections.length;c++)for(var f=0;f<this._sections[c].consumer.sources.length;f++)u.push(this._sections[c].consumer.sources[f]);return u}});T2.prototype.originalPositionFor=function(c){var f={generatedLine:lo.getArg(c,"line"),generatedColumn:lo.getArg(c,"column")},v=_6e.search(f,this._sections,function(w,F){var ee=w.generatedLine-F.generatedOffset.generatedLine;return ee||w.generatedColumn-F.generatedOffset.generatedColumn}),x=this._sections[v];return x?x.consumer.originalPositionFor({line:f.generatedLine-(x.generatedOffset.generatedLine-1),column:f.generatedColumn-(x.generatedOffset.generatedLine===f.generatedLine?x.generatedOffset.generatedColumn-1:0),bias:c.bias}):{source:null,line:null,column:null,name:null}};T2.prototype.hasContentsOfAllSources=function(){return this._sections.every(function(c){return c.consumer.hasContentsOfAllSources()})};T2.prototype.sourceContentFor=function(c,f){for(var v=0;v<this._sections.length;v++){var x=this._sections[v],w=x.consumer.sourceContentFor(c,!0);if(w)return w}if(f)return null;throw new Error('"'+c+'" is not in the SourceMap.')};T2.prototype.generatedPositionFor=function(c){for(var f=0;f<this._sections.length;f++){var v=this._sections[f];if(v.consumer._findSourceIndex(lo.getArg(c,"source"))!==-1){var x=v.consumer.generatedPositionFor(c);if(x){var w={line:x.line+(v.generatedOffset.generatedLine-1),column:x.column+(v.generatedOffset.generatedLine===x.line?v.generatedOffset.generatedColumn-1:0)};return w}}}return{line:null,column:null}};T2.prototype._parseMappings=function(c,f){this.__generatedMappings=[],this.__originalMappings=[];for(var v=0;v<this._sections.length;v++)for(var x=this._sections[v],w=x.consumer._generatedMappings,F=0;F<w.length;F++){var ee=w[F],me=x.consumer._sources.at(ee.source);me=lo.computeSourceURL(x.consumer.sourceRoot,me,this._sourceMapURL),this._sources.add(me),me=this._sources.indexOf(me);var de=null;ee.name&&(de=x.consumer._names.at(ee.name),this._names.add(de),de=this._names.indexOf(de));var Te={source:me,generatedLine:ee.generatedLine+(x.generatedOffset.generatedLine-1),generatedColumn:ee.generatedColumn+(x.generatedOffset.generatedLine===ee.generatedLine?x.generatedOffset.generatedColumn-1:0),originalLine:ee.originalLine,originalColumn:ee.originalColumn,name:de};this.__generatedMappings.push(Te),typeof Te.originalLine=="number"&&this.__originalMappings.push(Te)}aG(this.__generatedMappings,lo.compareByGeneratedPositionsDeflated),aG(this.__originalMappings,lo.compareByOriginalPositions)};m_e.IndexedSourceMapConsumer=T2});var Ddt=At(Ndt=>{var Mor=o6e().SourceMapGenerator,g_e=h5(),Lor=/(\r?\n)/,For=10,v5="$$$isSourceNode$$$";function ZS(u,c,f,v,x){this.children=[],this.sourceContents={},this.line=u??null,this.column=c??null,this.source=f??null,this.name=x??null,this[v5]=!0,v!=null&&this.add(v)}ZS.fromStringWithSourceMap=function(c,f,v){var x=new ZS,w=c.split(Lor),F=0,ee=function(){var Ct=xr(),Kt=xr()||"";return Ct+Kt;function xr(){return F<w.length?w[F++]:void 0}},me=1,de=0,Te=null;return f.eachMapping(function(Ct){if(Te!==null)if(me<Ct.generatedLine)ut(Te,ee()),me++,de=0;else{var Kt=w[F]||"",xr=Kt.substr(0,Ct.generatedColumn-de);w[F]=Kt.substr(Ct.generatedColumn-de),de=Ct.generatedColumn,ut(Te,xr),Te=Ct;return}for(;me<Ct.generatedLine;)x.add(ee()),me++;if(de<Ct.generatedColumn){var Kt=w[F]||"";x.add(Kt.substr(0,Ct.generatedColumn)),w[F]=Kt.substr(Ct.generatedColumn),de=Ct.generatedColumn}Te=Ct},this),F<w.length&&(Te&&ut(Te,ee()),x.add(w.splice(F).join(""))),f.sources.forEach(function(Ct){var Kt=f.sourceContentFor(Ct);Kt!=null&&(v!=null&&(Ct=g_e.join(v,Ct)),x.setSourceContent(Ct,Kt))}),x;function ut(Ct,Kt){if(Ct===null||Ct.source===void 0)x.add(Kt);else{var xr=v?g_e.join(v,Ct.source):Ct.source;x.add(new ZS(Ct.originalLine,Ct.originalColumn,xr,Kt,Ct.name))}}};ZS.prototype.add=function(c){if(Array.isArray(c))c.forEach(function(f){this.add(f)},this);else if(c[v5]||typeof c=="string")c&&this.children.push(c);else throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got "+c);return this};ZS.prototype.prepend=function(c){if(Array.isArray(c))for(var f=c.length-1;f>=0;f--)this.prepend(c[f]);else if(c[v5]||typeof c=="string")this.children.unshift(c);else throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got "+c);return this};ZS.prototype.walk=function(c){for(var f,v=0,x=this.children.length;v<x;v++)f=this.children[v],f[v5]?f.walk(c):f!==""&&c(f,{source:this.source,line:this.line,column:this.column,name:this.name})};ZS.prototype.join=function(c){var f,v,x=this.children.length;if(x>0){for(f=[],v=0;v<x-1;v++)f.push(this.children[v]),f.push(c);f.push(this.children[v]),this.children=f}return this};ZS.prototype.replaceRight=function(c,f){var v=this.children[this.children.length-1];return v[v5]?v.replaceRight(c,f):typeof v=="string"?this.children[this.children.length-1]=v.replace(c,f):this.children.push("".replace(c,f)),this};ZS.prototype.setSourceContent=function(c,f){this.sourceContents[g_e.toSetString(c)]=f};ZS.prototype.walkSourceContents=function(c){for(var f=0,v=this.children.length;f<v;f++)this.children[f][v5]&&this.children[f].walkSourceContents(c);for(var x=Object.keys(this.sourceContents),f=0,v=x.length;f<v;f++)c(g_e.fromSetString(x[f]),this.sourceContents[x[f]])};ZS.prototype.toString=function(){var c="";return this.walk(function(f){c+=f}),c};ZS.prototype.toStringWithSourceMap=function(c){var f={code:"",line:1,column:0},v=new Mor(c),x=!1,w=null,F=null,ee=null,me=null;return this.walk(function(de,Te){f.code+=de,Te.source!==null&&Te.line!==null&&Te.column!==null?((w!==Te.source||F!==Te.line||ee!==Te.column||me!==Te.name)&&v.addMapping({source:Te.source,original:{line:Te.line,column:Te.column},generated:{line:f.line,column:f.column},name:Te.name}),w=Te.source,F=Te.line,ee=Te.column,me=Te.name,x=!0):x&&(v.addMapping({generated:{line:f.line,column:f.column}}),w=null,x=!1);for(var ut=0,Ct=de.length;ut<Ct;ut++)de.charCodeAt(ut)===For?(f.line++,f.column=0,ut+1===Ct?(w=null,x=!1):x&&v.addMapping({source:Te.source,original:{line:Te.line,column:Te.column},generated:{line:f.line,column:f.column},name:Te.name})):f.column++}),this.walkSourceContents(function(de,Te){v.setSourceContent(de,Te)}),{code:f.code,map:v}};Ndt.SourceNode=ZS});var Idt=At(h_e=>{h_e.SourceMapGenerator=o6e().SourceMapGenerator;h_e.SourceMapConsumer=Pdt().SourceMapConsumer;h_e.SourceNode=Ddt().SourceNode});var Odt=At((P1r,wdt)=>{var jor=Object.prototype.toString,f6e=typeof Buffer<"u"&&typeof Buffer.alloc=="function"&&typeof Buffer.allocUnsafe=="function"&&typeof Buffer.from=="function";function Bor(u){return jor.call(u).slice(8,-1)==="ArrayBuffer"}function Uor(u,c,f){c>>>=0;var v=u.byteLength-c;if(v<0)throw new RangeError("'offset' is out of bounds");if(f===void 0)f=v;else if(f>>>=0,f>v)throw new RangeError("'length' is out of bounds");return f6e?Buffer.from(u.slice(c,c+f)):new Buffer(new Uint8Array(u.slice(c,c+f)))}function Vor(u,c){if((typeof c!="string"||c==="")&&(c="utf8"),!Buffer.isEncoding(c))throw new TypeError('"encoding" must be a valid string encoding');return f6e?Buffer.from(u,c):new Buffer(u,c)}function Jor(u,c,f){if(typeof u=="number")throw new TypeError('"value" argument must not be a number');return Bor(u)?Uor(u,c,f):typeof u=="string"?Vor(u,c):f6e?Buffer.from(u):new Buffer(u)}wdt.exports=Jor});var Vdt=At((y3,g6e)=>{var qor=Idt().SourceMapConsumer,p6e=Bu("path"),HC;try{HC=Bu("fs"),(!HC.existsSync||!HC.readFileSync)&&(HC=null)}catch{}var zor=Odt();function Rdt(u,c){return u.require(c)}var Mdt=!1,Ldt=!1,d6e=!1,oG="auto",h3={},cG={},$or=/^data:application\/json[^,]+base64,/,lw=[],uw=[];function h6e(){return oG==="browser"?!0:oG==="node"?!1:typeof window<"u"&&typeof XMLHttpRequest=="function"&&!(window.require&&window.module&&window.process&&window.process.type==="renderer")}function Wor(){return typeof process=="object"&&process!==null&&typeof process.on=="function"}function Gor(){return typeof process=="object"&&process!==null?process.version:""}function Hor(){if(typeof process=="object"&&process!==null)return process.stderr}function Yor(u){if(typeof process=="object"&&process!==null&&typeof process.exit=="function")return process.exit(u)}function y_e(u){return function(c){for(var f=0;f<u.length;f++){var v=u[f](c);if(v)return v}return null}}var y6e=y_e(lw);lw.push(function(u){if(u=u.trim(),/^file:/.test(u)&&(u=u.replace(/file:\/\/\/(\w:)?/,function(v,x){return x?"":"/"})),u in h3)return h3[u];var c="";try{if(HC)HC.existsSync(u)&&(c=HC.readFileSync(u,"utf8"));else{var f=new XMLHttpRequest;f.open("GET",u,!1),f.send(null),f.readyState===4&&f.status===200&&(c=f.responseText)}}catch{}return h3[u]=c});function m6e(u,c){if(!u)return c;var f=p6e.dirname(u),v=/^\w+:\/\/[^\/]*/.exec(f),x=v?v[0]:"",w=f.slice(x.length);return x&&/^\/\w\:/.test(w)?(x+="/",x+p6e.resolve(f.slice(x.length),c).replace(/\\/g,"/")):x+p6e.resolve(f.slice(x.length),c)}function Xor(u){var c;if(h6e())try{var f=new XMLHttpRequest;f.open("GET",u,!1),f.send(null),c=f.readyState===4?f.responseText:null;var v=f.getResponseHeader("SourceMap")||f.getResponseHeader("X-SourceMap");if(v)return v}catch{}c=y6e(u);for(var x=/(?:\/\/[@#][\s]*sourceMappingURL=([^\s'"]+)[\s]*$)|(?:\/\*[@#][\s]*sourceMappingURL=([^\s*'"]+)[\s]*(?:\*\/)[\s]*$)/mg,w,F;F=x.exec(c);)w=F;return w?w[1]:null}var v6e=y_e(uw);uw.push(function(u){var c=Xor(u);if(!c)return null;var f;if($or.test(c)){var v=c.slice(c.indexOf(",")+1);f=zor(v,"base64").toString(),c=u}else c=m6e(u,c),f=y6e(c);return f?{url:c,map:f}:null});function S6e(u){var c=cG[u.source];if(!c){var f=v6e(u.source);f?(c=cG[u.source]={url:f.url,map:new qor(f.map)},c.map.sourcesContent&&c.map.sources.forEach(function(x,w){var F=c.map.sourcesContent[w];if(F){var ee=m6e(c.url,x);h3[ee]=F}})):c=cG[u.source]={url:null,map:null}}if(c&&c.map&&typeof c.map.originalPositionFor=="function"){var v=c.map.originalPositionFor(u);if(v.source!==null)return v.source=m6e(c.url,v.source),v}return u}function jdt(u){var c=/^eval at ([^(]+) \((.+):(\d+):(\d+)\)$/.exec(u);if(c){var f=S6e({source:c[2],line:+c[3],column:c[4]-1});return"eval at "+c[1]+" ("+f.source+":"+f.line+":"+(f.column+1)+")"}return c=/^eval at ([^(]+) \((.+)\)$/.exec(u),c?"eval at "+c[1]+" ("+jdt(c[2])+")":u}function Kor(){var u,c="";if(this.isNative())c="native";else{u=this.getScriptNameOrSourceURL(),!u&&this.isEval()&&(c=this.getEvalOrigin(),c+=", "),u?c+=u:c+="<anonymous>";var f=this.getLineNumber();if(f!=null){c+=":"+f;var v=this.getColumnNumber();v&&(c+=":"+v)}}var x="",w=this.getFunctionName(),F=!0,ee=this.isConstructor(),me=!(this.isToplevel()||ee);if(me){var de=this.getTypeName();de==="[object Object]"&&(de="null");var Te=this.getMethodName();w?(de&&w.indexOf(de)!=0&&(x+=de+"."),x+=w,Te&&w.indexOf("."+Te)!=w.length-Te.length-1&&(x+=" [as "+Te+"]")):x+=de+"."+(Te||"<anonymous>")}else ee?x+="new "+(w||"<anonymous>"):w?x+=w:(x+=c,F=!1);return F&&(x+=" ("+c+")"),x}function Fdt(u){var c={};return Object.getOwnPropertyNames(Object.getPrototypeOf(u)).forEach(function(f){c[f]=/^(?:is|get)/.test(f)?function(){return u[f].call(u)}:u[f]}),c.toString=Kor,c}function Bdt(u,c){if(c===void 0&&(c={nextPosition:null,curPosition:null}),u.isNative())return c.curPosition=null,u;var f=u.getFileName()||u.getScriptNameOrSourceURL();if(f){var v=u.getLineNumber(),x=u.getColumnNumber()-1,w=/^v(10\.1[6-9]|10\.[2-9][0-9]|10\.[0-9]{3,}|1[2-9]\d*|[2-9]\d|\d{3,}|11\.11)/,F=w.test(Gor())?0:62;v===1&&x>F&&!h6e()&&!u.isEval()&&(x-=F);var ee=S6e({source:f,line:v,column:x});c.curPosition=ee,u=Fdt(u);var me=u.getFunctionName;return u.getFunctionName=function(){return c.nextPosition==null?me():c.nextPosition.name||me()},u.getFileName=function(){return ee.source},u.getLineNumber=function(){return ee.line},u.getColumnNumber=function(){return ee.column+1},u.getScriptNameOrSourceURL=function(){return ee.source},u}var de=u.isEval()&&u.getEvalOrigin();return de&&(de=jdt(de),u=Fdt(u),u.getEvalOrigin=function(){return de}),u}function Qor(u,c){d6e&&(h3={},cG={});for(var f=u.name||"Error",v=u.message||"",x=f+": "+v,w={nextPosition:null,curPosition:null},F=[],ee=c.length-1;ee>=0;ee--)F.push(`
    at `+Bdt(c[ee],w)),w.nextPosition=w.curPosition;return w.curPosition=w.nextPosition=null,x+F.reverse().join("")}function Udt(u){var c=/\n    at [^(]+ \((.*):(\d+):(\d+)\)/.exec(u.stack);if(c){var f=c[1],v=+c[2],x=+c[3],w=h3[f];if(!w&&HC&&HC.existsSync(f))try{w=HC.readFileSync(f,"utf8")}catch{w=""}if(w){var F=w.split(/(?:\r\n|\r|\n)/)[v-1];if(F)return f+":"+v+`
`+F+`
`+new Array(x).join(" ")+"^"}}return null}function Zor(u){var c=Udt(u),f=Hor();f&&f._handle&&f._handle.setBlocking&&f._handle.setBlocking(!0),c&&(console.error(),console.error(c)),console.error(u.stack),Yor(1)}function ecr(){var u=process.emit;process.emit=function(c){if(c==="uncaughtException"){var f=arguments[1]&&arguments[1].stack,v=this.listeners(c).length>0;if(f&&!v)return Zor(arguments[1])}return u.apply(this,arguments)}}var tcr=lw.slice(0),rcr=uw.slice(0);y3.wrapCallSite=Bdt;y3.getErrorSource=Udt;y3.mapSourcePosition=S6e;y3.retrieveSourceMap=v6e;y3.install=function(u){if(u=u||{},u.environment&&(oG=u.environment,["node","browser","auto"].indexOf(oG)===-1))throw new Error("environment "+oG+" was unknown. Available options are {auto, browser, node}");if(u.retrieveFile&&(u.overrideRetrieveFile&&(lw.length=0),lw.unshift(u.retrieveFile)),u.retrieveSourceMap&&(u.overrideRetrieveSourceMap&&(uw.length=0),uw.unshift(u.retrieveSourceMap)),u.hookRequire&&!h6e()){var c=Rdt(g6e,"module"),f=c.prototype._compile;f.__sourceMapSupport||(c.prototype._compile=function(w,F){return h3[F]=w,cG[F]=void 0,f.call(this,w,F)},c.prototype._compile.__sourceMapSupport=!0)}if(d6e||(d6e="emptyCacheBetweenOperations"in u?u.emptyCacheBetweenOperations:!1),Mdt||(Mdt=!0,Error.prepareStackTrace=Qor),!Ldt){var v="handleUncaughtExceptions"in u?u.handleUncaughtExceptions:!0;try{var x=Rdt(g6e,"worker_threads");x.isMainThread===!1&&(v=!1)}catch{}v&&Wor()&&(Ldt=!0,ecr())}};y3.resetRetrieveHandlers=function(){lw.length=0,uw.length=0,lw=tcr.slice(0),uw=rcr.slice(0),v6e=y_e(uw),y6e=y_e(lw)}});var Sv=At((N1r,lG)=>{"use strict";var ncr=(()=>{var u=Object.defineProperty,c=Object.getOwnPropertyNames,f=(e,t)=>function(){return e&&(t=(0,e[c(e)[0]])(e=0)),t},v=(e,t)=>function(){return t||(0,e[c(e)[0]])((t={exports:{}}).exports,t),t.exports},x=(e,t)=>{for(var n in t)u(e,n,{get:t[n],enumerable:!0})},w,F,ee,me=f({"src/compiler/corePublic.ts"(){"use strict";w="5.4",F="5.4.5",ee=(e=>(e[e.LessThan=-1]="LessThan",e[e.EqualTo=0]="EqualTo",e[e.GreaterThan=1]="GreaterThan",e))(ee||{})}});function de(e){return e?e.length:0}function Te(e,t){if(e)for(let n=0;n<e.length;n++){let i=t(e[n],n);if(i)return i}}function ut(e,t){if(e)for(let n=e.length-1;n>=0;n--){let i=t(e[n],n);if(i)return i}}function Ct(e,t){if(e!==void 0)for(let n=0;n<e.length;n++){let i=t(e[n],n);if(i!==void 0)return i}}function Kt(e,t){for(let n of e){let i=t(n);if(i!==void 0)return i}}function xr(e,t,n){let i=n;if(e){let s=0;for(let o of e)i=t(i,o,s),s++}return i}function en(e,t,n){let i=[];I.assertEqual(e.length,t.length);for(let s=0;s<e.length;s++)i.push(n(e[s],t[s],s));return i}function zn(e,t){if(e.length<=1)return e;let n=[];for(let i=0,s=e.length;i<s;i++)i&&n.push(t),n.push(e[i]);return n}function yr(e,t){if(e){for(let n=0;n<e.length;n++)if(!t(e[n],n))return!1}return!0}function mr(e,t,n){if(e!==void 0)for(let i=n??0;i<e.length;i++){let s=e[i];if(t(s,i))return s}}function Da(e,t,n){if(e!==void 0)for(let i=n??e.length-1;i>=0;i--){let s=e[i];if(t(s,i))return s}}function oa(e,t,n){if(e===void 0)return-1;for(let i=n??0;i<e.length;i++)if(t(e[i],i))return i;return-1}function no(e,t,n){if(e===void 0)return-1;for(let i=n??e.length-1;i>=0;i--)if(t(e[i],i))return i;return-1}function Cf(e,t){for(let n=0;n<e.length;n++){let i=t(e[n],n);if(i)return i}return I.fail()}function hs(e,t,n=Dm){if(e){for(let i of e)if(n(i,t))return!0}return!1}function Am(e,t,n=Dm){return e.length===t.length&&e.every((i,s)=>n(i,t[s]))}function v0(e,t,n){for(let i=n||0;i<e.length;i++)if(hs(t,e.charCodeAt(i)))return i;return-1}function mu(e,t){let n=0;if(e)for(let i=0;i<e.length;i++){let s=e[i];t(s,i)&&n++}return n}function Fn(e,t){if(e){let n=e.length,i=0;for(;i<n&&t(e[i]);)i++;if(i<n){let s=e.slice(0,i);for(i++;i<n;){let o=e[i];t(o)&&s.push(o),i++}return s}}return e}function Nh(e,t){let n=0;for(let i=0;i<e.length;i++)t(e[i],i,e)&&(e[n]=e[i],n++);e.length=n}function ed(e){e.length=0}function vr(e,t){let n;if(e){n=[];for(let i=0;i<e.length;i++)n.push(t(e[i],i))}return n}function*g1(e,t){for(let n of e)yield t(n)}function ul(e,t){if(e)for(let n=0;n<e.length;n++){let i=e[n],s=t(i,n);if(i!==s){let o=e.slice(0,n);for(o.push(s),n++;n<e.length;n++)o.push(t(e[n],n));return o}}return e}function ip(e){let t=[];for(let n of e)n&&(os(n)?jt(t,n):t.push(n));return t}function _a(e,t){let n;if(e)for(let i=0;i<e.length;i++){let s=t(e[i],i);s&&(os(s)?n=jt(n,s):n=Pr(n,s))}return n||tt}function bv(e,t){let n=[];if(e)for(let i=0;i<e.length;i++){let s=t(e[i],i);s&&(os(s)?jt(n,s):n.push(s))}return n}function*A2(e,t){for(let n of e){let i=t(n);i&&(yield*i)}}function nA(e,t){let n;if(e)for(let i=0;i<e.length;i++){let s=e[i],o=t(s,i);(n||s!==o||os(o))&&(n||(n=e.slice(0,i)),os(o)?jt(n,o):n.push(o))}return n||e}function Jo(e,t){let n=[];for(let i=0;i<e.length;i++){let s=t(e[i],i);if(s===void 0)return;n.push(s)}return n}function Wi(e,t){let n=[];if(e)for(let i=0;i<e.length;i++){let s=t(e[i],i);s!==void 0&&n.push(s)}return n}function*S0(e,t){for(let n of e){let i=t(n);i!==void 0&&(yield i)}}function Rl(e,t){if(!e)return;let n=new Map;return e.forEach((i,s)=>{let o=t(s,i);if(o!==void 0){let[l,p]=o;l!==void 0&&p!==void 0&&n.set(l,p)}}),n}function km(e,t,n){if(e.has(t))return e.get(t);let i=n();return e.set(t,i),i}function Zd(e,t){return e.has(t)?!1:(e.add(t),!0)}function*k2(e){yield e}function P2(e,t,n){let i;if(e){i=[];let s=e.length,o,l,p=0,m=0;for(;p<s;){for(;m<s;){let S=e[m];if(l=t(S,m),m===0)o=l;else if(l!==o)break;m++}if(p<m){let S=n(e.slice(p,m),o,p,m);S&&i.push(S),p=m}o=l,m++}}return i}function Fg(e,t){if(!e)return;let n=new Map;return e.forEach((i,s)=>{let[o,l]=t(s,i);n.set(o,l)}),n}function Tt(e,t){if(e)if(t){for(let n of e)if(t(n))return!0}else return e.length>0;return!1}function Ev(e,t,n){let i;for(let s=0;s<e.length;s++)t(e[s])?i=i===void 0?s:i:i!==void 0&&(n(i,s),i=void 0);i!==void 0&&n(i,e.length)}function ys(e,t){return Tt(t)?Tt(e)?[...e,...t]:t:e}function xv(e,t){return t}function tT(e){return e.map(xv)}function dw(e,t,n){let i=tT(e);Js(e,i,n);let s=e[i[0]],o=[i[0]];for(let l=1;l<i.length;l++){let p=i[l],m=e[p];t(s,m)||(o.push(p),s=m)}return o.sort(),o.map(l=>e[l])}function mw(e,t){let n=[];for(let i of e)ln(n,i,t);return n}function Dh(e,t,n){return e.length===0?[]:e.length===1?e.slice():n?dw(e,t,n):mw(e,t)}function C3(e,t){if(e.length===0)return tt;let n=e[0],i=[n];for(let s=1;s<e.length;s++){let o=e[s];switch(t(o,n)){case!0:case 0:continue;case-1:return I.fail("Array is unsorted.")}i.push(n=o)}return i}function h1(){return[]}function lf(e,t,n,i){if(e.length===0)return e.push(t),!0;let s=Bg(e,t,Mo,n);return s<0?(e.splice(~s,0,t),!0):i?(e.splice(s,0,t),!0):!1}function rT(e,t,n){return C3(Fa(e,t),n||t||h_)}function iA(e,t){if(e.length<2)return!0;for(let n=1,i=e.length;n<i;n++)if(t(e[n-1],e[n])===1)return!1;return!0}function Mb(e,t,n,i){let s=3;if(e.length<2)return s;let o=t(e[0]);for(let l=1,p=e.length;l<p&&s!==0;l++){let m=t(e[l]);s&1&&n(o,m)>0&&(s&=-2),s&2&&i(o,m)>0&&(s&=-3),o=m}return s}function td(e,t,n=Dm){if(!e||!t)return e===t;if(e.length!==t.length)return!1;for(let i=0;i<e.length;i++)if(!n(e[i],t[i],i))return!1;return!0}function y1(e){let t;if(e)for(let n=0;n<e.length;n++){let i=e[n];(t||!i)&&(t||(t=e.slice(0,n)),i&&t.push(i))}return t||e}function dy(e,t,n){if(!t||!e||t.length===0||e.length===0)return t;let i=[];e:for(let s=0,o=0;o<t.length;o++){o>0&&I.assertGreaterThanOrEqual(n(t[o],t[o-1]),0);t:for(let l=s;s<e.length;s++)switch(s>l&&I.assertGreaterThanOrEqual(n(e[s],e[s-1]),0),n(t[o],e[s])){case-1:i.push(t[o]);continue e;case 0:continue e;case 1:continue t}}return i}function Pr(e,t){return t===void 0?e:e===void 0?[t]:(e.push(t),e)}function Cv(e,t){return e===void 0?t:t===void 0?e:os(e)?os(t)?ys(e,t):Pr(e,t):os(t)?Pr(t,e):[e,t]}function N2(e,t){return t<0?e.length+t:t}function jt(e,t,n,i){if(t===void 0||t.length===0)return e;if(e===void 0)return t.slice(n,i);n=n===void 0?0:N2(t,n),i=i===void 0?t.length:N2(t,i);for(let s=n;s<i&&s<t.length;s++)t[s]!==void 0&&e.push(t[s]);return e}function ln(e,t,n){return hs(e,t,n)?!1:(e.push(t),!0)}function ai(e,t,n){return e?(ln(e,t,n),e):[t]}function Js(e,t,n){t.sort((i,s)=>n(e[i],e[s])||To(i,s))}function Fa(e,t){return e.length===0?e:e.slice().sort(t)}function*Xl(e){for(let t=e.length-1;t>=0;t--)yield e[t]}function cu(e,t){let n=tT(e);return Js(e,n,t),n.map(i=>e[i])}function Bc(e,t,n,i){for(;n<i;){if(e[n]!==t[n])return!1;n++}return!0}function qi(e){return e===void 0||e.length===0?void 0:e[0]}function Oa(e){if(e)for(let t of e)return t}function di(e){return I.assert(e.length!==0),e[0]}function Ja(e){for(let t of e)return t;I.fail("iterator is empty")}function Is(e){return e===void 0||e.length===0?void 0:e[e.length-1]}function Rs(e){return I.assert(e.length!==0),e[e.length-1]}function nl(e){return e&&e.length===1?e[0]:void 0}function jg(e){return I.checkDefined(nl(e))}function Op(e){return e&&e.length===1?e[0]:e}function sA(e,t,n){let i=e.slice(0);return i[t]=n,i}function Bg(e,t,n,i,s){return nT(e,n(t),n,i,s)}function nT(e,t,n,i,s){if(!Tt(e))return-1;let o=s||0,l=e.length-1;for(;o<=l;){let p=o+(l-o>>1),m=n(e[p],p);switch(i(m,t)){case-1:o=p+1;break;case 0:return p;case 1:l=p-1;break}}return~o}function d_(e,t,n,i,s){if(e&&e.length>0){let o=e.length;if(o>0){let l=i===void 0||i<0?0:i,p=s===void 0||l+s>o-1?o-1:l+s,m;for(arguments.length<=2?(m=e[l],l++):m=n;l<=p;)m=t(m,e[l],l),l++;return m}}return n}function wo(e,t){return Pv.call(e,t)}function Ar(e,t){return Pv.call(e,t)?e[t]:void 0}function Vt(e){let t=[];for(let n in e)Pv.call(e,n)&&t.push(n);return t}function Vr(e){let t=[];do{let n=Object.getOwnPropertyNames(e);for(let i of n)ln(t,i)}while(e=Object.getPrototypeOf(e));return t}function Mn(e){let t=[];for(let n in e)Pv.call(e,n)&&t.push(e[n]);return t}function Xn(e,t){let n=new Array(e);for(let i=0;i<e;i++)n[i]=t(i);return n}function In(e,t){let n=[];for(let i of e)n.push(t?t(i):i);return n}function ec(e,...t){for(let n of t)if(n!==void 0)for(let i in n)wo(n,i)&&(e[i]=n[i]);return e}function Kl(e,t,n=Dm){if(e===t)return!0;if(!e||!t)return!1;for(let i in e)if(Pv.call(e,i)&&(!Pv.call(t,i)||!n(e[i],t[i])))return!1;for(let i in t)if(Pv.call(t,i)&&!Pv.call(e,i))return!1;return!0}function il(e,t,n=Mo){let i=new Map;for(let s of e){let o=t(s);o!==void 0&&i.set(o,n(s))}return i}function Rp(e,t,n=Mo){let i=[];for(let s of e)i[t(s)]=n(s);return i}function _l(e,t,n=Mo){let i=g_();for(let s of e)i.add(t(s),n(s));return i}function m_(e,t,n=Mo){return In(_l(e,t).values(),n)}function Jf(e,t){let n={};if(e)for(let i of e){let s=`${t(i)}`;(n[s]??(n[s]=[])).push(i)}return n}function q_(e){let t={};for(let n in e)Pv.call(e,n)&&(t[n]=e[n]);return t}function Ml(e,t){let n={};for(let i in t)Pv.call(t,i)&&(n[i]=t[i]);for(let i in e)Pv.call(e,i)&&(n[i]=e[i]);return n}function uf(e,t){for(let n in t)Pv.call(t,n)&&(e[n]=t[n])}function rs(e,t){return t?t.bind(e):void 0}function g_(){let e=new Map;return e.add=my,e.remove=v1,e}function my(e,t){let n=this.get(e);return n?n.push(t):this.set(e,n=[t]),n}function v1(e,t){let n=this.get(e);n&&(uA(n,t),n.length||this.delete(e))}function Pu(e){let t=e?.slice()||[],n=0;function i(){return n===t.length}function s(...l){t.push(...l)}function o(){if(i())throw new Error("Queue is empty");let l=t[n];if(t[n]=void 0,n++,n>100&&n>t.length>>1){let p=t.length-n;t.copyWithin(0,n),t.length=p,n=0}return l}return{enqueue:s,dequeue:o,isEmpty:i}}function Ug(e,t){let n=new Map,i=0;function*s(){for(let l of n.values())os(l)?yield*l:yield l}let o={has(l){let p=e(l);if(!n.has(p))return!1;let m=n.get(p);if(!os(m))return t(m,l);for(let S of m)if(t(S,l))return!0;return!1},add(l){let p=e(l);if(n.has(p)){let m=n.get(p);if(os(m))hs(m,l,t)||(m.push(l),i++);else{let S=m;t(S,l)||(n.set(p,[S,l]),i++)}}else n.set(p,l),i++;return this},delete(l){let p=e(l);if(!n.has(p))return!1;let m=n.get(p);if(os(m)){for(let S=0;S<m.length;S++)if(t(m[S],l))return m.length===1?n.delete(p):m.length===2?n.set(p,m[1-S]):CG(m,S),i--,!0}else if(t(m,l))return n.delete(p),i--,!0;return!1},clear(){n.clear(),i=0},get size(){return i},forEach(l){for(let p of In(n.values()))if(os(p))for(let m of p)l(m,m,o);else{let m=p;l(m,m,o)}},keys(){return s()},values(){return s()},*entries(){for(let l of s())yield[l,l]},[Symbol.iterator]:()=>s(),[Symbol.toStringTag]:n[Symbol.toStringTag]};return o}function os(e){return Array.isArray(e)}function Pm(e){return os(e)?e:[e]}function vs(e){return typeof e=="string"}function Mp(e){return typeof e=="number"}function ii(e,t){return e!==void 0&&t(e)?e:void 0}function ta(e,t){return e!==void 0&&t(e)?e:I.fail(`Invalid cast. The supplied value ${e} did not pass the test '${I.getFunctionName(t)}'.`)}function ja(e){}function qf(){return!1}function em(){return!0}function xd(){}function Mo(e){return e}function gw(e){return e.toLowerCase()}function sp(e){return Afe.test(e)?e.replace(Afe,gw):e}function Ks(){throw new Error("Not implemented")}function D_(e){let t;return()=>(e&&(t=e(),e=void 0),t)}function Nm(e){let t=new Map;return n=>{let i=`${typeof n}:${n}`,s=t.get(i);return s===void 0&&!t.has(i)&&(s=e(n),t.set(i,s)),s}}function RP(e){let t=new WeakMap;return n=>{let i=t.get(n);return i===void 0&&!t.has(n)&&(i=e(n),t.set(n,i)),i}}function aA(e,t){return(...n)=>{let i=t.get(n);return i===void 0&&!t.has(n)&&(i=e(...n),t.set(n,i)),i}}function F5(e,t,n,i,s){if(s){let o=[];for(let l=0;l<arguments.length;l++)o[l]=arguments[l];return l=>d_(o,(p,m)=>m(p),l)}else return i?o=>i(n(t(e(o)))):n?o=>n(t(e(o))):t?o=>t(e(o)):e?o=>e(o):o=>o}function Dm(e,t){return e===t}function S1(e,t){return e===t||e!==void 0&&t!==void 0&&e.toUpperCase()===t.toUpperCase()}function Av(e,t){return Dm(e,t)}function EG(e,t){return e===t?0:e===void 0?-1:t===void 0?1:e<t?-1:1}function To(e,t){return EG(e,t)}function iT(e,t){return To(e?.start,t?.start)||To(e?.length,t?.length)}function MP(e,t){return d_(e,(n,i)=>t(n,i)===-1?n:i)}function D2(e,t){return e===t?0:e===void 0?-1:t===void 0?1:(e=e.toUpperCase(),t=t.toUpperCase(),e<t?-1:e>t?1:0)}function I2(e,t){return e===t?0:e===void 0?-1:t===void 0?1:(e=e.toLowerCase(),t=t.toLowerCase(),e<t?-1:e>t?1:0)}function h_(e,t){return EG(e,t)}function gy(e){return e?D2:h_}function oA(){return IG}function A3(e){IG!==e&&(IG=e,kfe=void 0)}function LP(e,t){return(kfe||(kfe=nOe(IG)))(e,t)}function j5(e,t,n,i){return e===t?0:e===void 0?-1:t===void 0?1:i(e[n],t[n])}function hy(e,t){return To(e?1:0,t?1:0)}function FP(e,t,n){let i=Math.max(2,Math.floor(e.length*.34)),s=Math.floor(e.length*.4)+1,o;for(let l of t){let p=n(l);if(p!==void 0&&Math.abs(p.length-e.length)<=i){if(p===e||p.length<3&&p.toLowerCase()!==e.toLowerCase())continue;let m=eOe(e,p,s-.1);if(m===void 0)continue;I.assert(m<s),s=m,o=l}}return o}function eOe(e,t,n){let i=new Array(t.length+1),s=new Array(t.length+1),o=n+.01;for(let p=0;p<=t.length;p++)i[p]=p;for(let p=1;p<=e.length;p++){let m=e.charCodeAt(p-1),S=Math.ceil(p>n?p-n:1),h=Math.floor(t.length>n+p?n+p:t.length);s[0]=p;let b=p;for(let k=1;k<S;k++)s[k]=o;for(let k=S;k<=h;k++){let N=e[p-1].toLowerCase()===t[k-1].toLowerCase()?i[k-1]+.1:i[k-1]+2,M=m===t.charCodeAt(k-1)?i[k-1]:Math.min(i[k]+1,s[k-1]+1,N);s[k]=M,b=Math.min(b,M)}for(let k=h+1;k<=t.length;k++)s[k]=o;if(b>n)return;let A=i;i=s,s=A}let l=i[t.length];return l>n?void 0:l}function Mc(e,t,n){let i=e.length-t.length;return i>=0&&(n?S1(e.slice(i),t):e.indexOf(t,i)===i)}function cA(e,t){return Mc(e,t)?e.slice(0,e.length-t.length):e}function xG(e,t){return Mc(e,t)?e.slice(0,e.length-t.length):void 0}function B5(e){let t=e.length;for(let n=t-1;n>0;n--){let i=e.charCodeAt(n);if(i>=48&&i<=57)do--n,i=e.charCodeAt(n);while(n>0&&i>=48&&i<=57);else if(n>4&&(i===110||i===78)){if(--n,i=e.charCodeAt(n),i!==105&&i!==73||(--n,i=e.charCodeAt(n),i!==109&&i!==77))break;--n,i=e.charCodeAt(n)}else break;if(i!==45&&i!==46)break;t=n}return t===e.length?e:e.slice(0,t)}function lA(e,t){for(let n=0;n<e.length;n++)if(e[n]===t)return kv(e,n),!0;return!1}function kv(e,t){for(let n=t;n<e.length-1;n++)e[n]=e[n+1];e.pop()}function CG(e,t){e[t]=e[e.length-1],e.pop()}function uA(e,t){return qht(e,n=>n===t)}function qht(e,t){for(let n=0;n<e.length;n++)if(t(e[n]))return CG(e,n),!0;return!1}function y_(e){return e?Mo:sp}function Tfe({prefix:e,suffix:t}){return`${e}*${t}`}function bfe(e,t){return I.assert(U5(e,t)),t.substring(e.prefix.length,t.length-e.suffix.length)}function AG(e,t,n){let i,s=-1;for(let o of e){let l=t(o);U5(l,n)&&l.prefix.length>s&&(s=l.prefix.length,i=o)}return i}function Ss(e,t,n){return n?S1(e.slice(0,t.length),t):e.lastIndexOf(t,0)===0}function hw(e,t){return Ss(e,t)?e.substr(t.length):e}function kG(e,t,n=Mo){return Ss(n(e),n(t))?e.substring(t.length):void 0}function U5({prefix:e,suffix:t},n){return n.length>=e.length+t.length&&Ss(n,e)&&Mc(n,t)}function V5(e,t){return n=>e(n)&&t(n)}function cg(...e){return(...t)=>{let n;for(let i of e)if(n=i(...t),n)return n;return n}}function J5(e){return(...t)=>!e(...t)}function tOe(e){}function _A(e){return e===void 0?void 0:[e]}function q5(e,t,n,i,s,o){o=o||ja;let l=0,p=0,m=e.length,S=t.length,h=!1;for(;l<m&&p<S;){let b=e[l],A=t[p],k=n(b,A);k===-1?(i(b),l++,h=!0):k===1?(s(A),p++,h=!0):(o(A,b),l++,p++)}for(;l<m;)i(e[l++]),h=!0;for(;p<S;)s(t[p++]),h=!0;return h}function Efe(e){let t=[];return rOe(e,t,void 0,0),t}function rOe(e,t,n,i){for(let s of e[i]){let o;n?(o=n.slice(),o.push(s)):o=[s],i===e.length-1?t.push(o):rOe(e,t,o,i+1)}}function z5(e,t){if(e){let n=e.length,i=0;for(;i<n&&t(e[i]);)i++;return e.slice(0,i)}}function xfe(e,t){if(e){let n=e.length,i=0;for(;i<n&&t(e[i]);)i++;return e.slice(i)}}function PG(){return typeof process<"u"&&!!process.nextTick&&!process.browser&&typeof lG=="object"}var tt,$5,Cfe,NG,T1,Pv,Afe,DG,nOe,kfe,IG,zht=f({"src/compiler/core.ts"(){"use strict";fa(),tt=[],$5=new Map,Cfe=new Set,NG=(e=>(e[e.None=0]="None",e[e.CaseSensitive=1]="CaseSensitive",e[e.CaseInsensitive=2]="CaseInsensitive",e[e.Both=3]="Both",e))(NG||{}),T1=Array.prototype.at?(e,t)=>e?.at(t):(e,t)=>{if(e&&(t=N2(e,t),t<e.length))return e[t]},Pv=Object.prototype.hasOwnProperty,Afe=/[^\u0130\u0131\u00DFa-z0-9\\/:\-_. ]+/g,DG=(e=>(e[e.None=0]="None",e[e.Normal=1]="Normal",e[e.Aggressive=2]="Aggressive",e[e.VeryAggressive=3]="VeryAggressive",e))(DG||{}),nOe=(()=>{return t;function e(n,i,s){if(n===i)return 0;if(n===void 0)return-1;if(i===void 0)return 1;let o=s(n,i);return o<0?-1:o>0?1:0}function t(n){let i=new Intl.Collator(n,{usage:"sort",sensitivity:"variant"}).compare;return(s,o)=>e(s,o,i)}})()}}),wG,I,$ht=f({"src/compiler/debug.ts"(){"use strict";fa(),fa(),wG=(e=>(e[e.Off=0]="Off",e[e.Error=1]="Error",e[e.Warning=2]="Warning",e[e.Info=3]="Info",e[e.Verbose=4]="Verbose",e))(wG||{}),(e=>{let t=0;e.currentLogLevel=2,e.isDebugging=!1;function n(_r){return e.currentLogLevel<=_r}e.shouldLog=n;function i(_r,rt){e.loggingHost&&n(_r)&&e.loggingHost.log(_r,rt)}function s(_r){i(3,_r)}e.log=s,(_r=>{function rt(Ni){i(1,Ni)}_r.error=rt;function zt(Ni){i(2,Ni)}_r.warn=zt;function Rr(Ni){i(3,Ni)}_r.log=Rr;function vi(Ni){i(4,Ni)}_r.trace=vi})(s=e.log||(e.log={}));let o={};function l(){return t}e.getAssertionLevel=l;function p(_r){let rt=t;if(t=_r,_r>rt)for(let zt of Vt(o)){let Rr=o[zt];Rr!==void 0&&e[zt]!==Rr.assertion&&_r>=Rr.level&&(e[zt]=Rr,o[zt]=void 0)}}e.setAssertionLevel=p;function m(_r){return t>=_r}e.shouldAssert=m;function S(_r,rt){return m(_r)?!0:(o[rt]={level:_r,assertion:e[rt]},e[rt]=ja,!1)}function h(_r,rt){debugger;let zt=new Error(_r?`Debug Failure. ${_r}`:"Debug Failure.");throw Error.captureStackTrace&&Error.captureStackTrace(zt,rt||h),zt}e.fail=h;function b(_r,rt,zt){return h(`${rt||"Unexpected node."}\r
Node ${Ee(_r.kind)} was unexpected.`,zt||b)}e.failBadSyntaxKind=b;function A(_r,rt,zt,Rr){_r||(rt=rt?`False expression: ${rt}`:"False expression.",zt&&(rt+=`\r
Verbose Debug Information: `+(typeof zt=="string"?zt:zt())),h(rt,Rr||A))}e.assert=A;function k(_r,rt,zt,Rr,vi){if(_r!==rt){let Ni=zt?Rr?`${zt} ${Rr}`:zt:"";h(`Expected ${_r} === ${rt}. ${Ni}`,vi||k)}}e.assertEqual=k;function N(_r,rt,zt,Rr){_r>=rt&&h(`Expected ${_r} < ${rt}. ${zt||""}`,Rr||N)}e.assertLessThan=N;function M(_r,rt,zt){_r>rt&&h(`Expected ${_r} <= ${rt}`,zt||M)}e.assertLessThanOrEqual=M;function O(_r,rt,zt){_r<rt&&h(`Expected ${_r} >= ${rt}`,zt||O)}e.assertGreaterThanOrEqual=O;function U(_r,rt,zt){_r==null&&h(rt,zt||U)}e.assertIsDefined=U;function H(_r,rt,zt){return U(_r,rt,zt||H),_r}e.checkDefined=H;function K(_r,rt,zt){for(let Rr of _r)U(Rr,rt,zt||K)}e.assertEachIsDefined=K;function re(_r,rt,zt){return K(_r,rt,zt||re),_r}e.checkEachDefined=re;function $(_r,rt="Illegal value:",zt){let Rr=typeof _r=="object"&&wo(_r,"kind")&&wo(_r,"pos")?"SyntaxKind: "+Ee(_r.kind):JSON.stringify(_r);return h(`${rt} ${Rr}`,zt||$)}e.assertNever=$;function pe(_r,rt,zt,Rr){S(1,"assertEachNode")&&A(rt===void 0||yr(_r,rt),zt||"Unexpected node.",()=>`Node array did not pass test '${ce(rt)}'.`,Rr||pe)}e.assertEachNode=pe;function z(_r,rt,zt,Rr){S(1,"assertNode")&&A(_r!==void 0&&(rt===void 0||rt(_r)),zt||"Unexpected node.",()=>`Node ${Ee(_r?.kind)} did not pass test '${ce(rt)}'.`,Rr||z)}e.assertNode=z;function se(_r,rt,zt,Rr){S(1,"assertNotNode")&&A(_r===void 0||rt===void 0||!rt(_r),zt||"Unexpected node.",()=>`Node ${Ee(_r.kind)} should not have passed test '${ce(rt)}'.`,Rr||se)}e.assertNotNode=se;function Se(_r,rt,zt,Rr){S(1,"assertOptionalNode")&&A(rt===void 0||_r===void 0||rt(_r),zt||"Unexpected node.",()=>`Node ${Ee(_r?.kind)} did not pass test '${ce(rt)}'.`,Rr||Se)}e.assertOptionalNode=Se;function xe(_r,rt,zt,Rr){S(1,"assertOptionalToken")&&A(rt===void 0||_r===void 0||_r.kind===rt,zt||"Unexpected node.",()=>`Node ${Ee(_r?.kind)} was not a '${Ee(rt)}' token.`,Rr||xe)}e.assertOptionalToken=xe;function Z(_r,rt,zt){S(1,"assertMissingNode")&&A(_r===void 0,rt||"Unexpected node.",()=>`Node ${Ee(_r.kind)} was unexpected'.`,zt||Z)}e.assertMissingNode=Z;function Q(_r){}e.type=Q;function ce(_r){if(typeof _r!="function")return"";if(wo(_r,"name"))return _r.name;{let rt=Function.prototype.toString.call(_r),zt=/^function\s+([\w$]+)\s*\(/.exec(rt);return zt?zt[1]:""}}e.getFunctionName=ce;function ye(_r){return`{ name: ${Zi(_r.escapedName)}; flags: ${kt(_r.flags)}; declarations: ${vr(_r.declarations,rt=>Ee(rt.kind))} }`}e.formatSymbol=ye;function we(_r=0,rt,zt){let Rr=oe(rt);if(_r===0)return Rr.length>0&&Rr[0][0]===0?Rr[0][1]:"0";if(zt){let vi=[],Ni=_r;for(let[us,Fs]of Rr){if(us>_r)break;us!==0&&us&_r&&(vi.push(Fs),Ni&=~us)}if(Ni===0)return vi.join("|")}else for(let[vi,Ni]of Rr)if(vi===_r)return Ni;return _r.toString()}e.formatEnum=we;let ve=new Map;function oe(_r){let rt=ve.get(_r);if(rt)return rt;let zt=[];for(let vi in _r){let Ni=_r[vi];typeof Ni=="number"&&zt.push([Ni,vi])}let Rr=cu(zt,(vi,Ni)=>To(vi[0],Ni[0]));return ve.set(_r,Rr),Rr}function Ee(_r){return we(_r,G5,!1)}e.formatSyntaxKind=Ee;function Me(_r){return we(_r,a9,!1)}e.formatSnippetKind=Me;function Ge(_r){return we(_r,i9,!1)}e.formatScriptKind=Ge;function Ae(_r){return we(_r,H5,!0)}e.formatNodeFlags=Ae;function Ie(_r){return we(_r,Y5,!0)}e.formatModifierFlags=Ie;function Re(_r){return we(_r,s9,!0)}e.formatTransformFlags=Re;function Ue(_r){return we(_r,o9,!0)}e.formatEmitFlags=Ue;function kt(_r){return we(_r,e9,!0)}e.formatSymbolFlags=kt;function ke(_r){return we(_r,t9,!0)}e.formatTypeFlags=ke;function $e(_r){return we(_r,n9,!0)}e.formatSignatureFlags=$e;function at(_r){return we(_r,r9,!0)}e.formatObjectFlags=at;function $t(_r){return we(_r,D3,!0)}e.formatFlowFlags=$t;function St(_r){return we(_r,X5,!0)}e.formatRelationComparisonResult=St;function Ze(_r){return we(_r,KU,!0)}e.formatCheckMode=Ze;function yt(_r){return we(_r,QU,!0)}e.formatSignatureCheckMode=yt;function ar(_r){return we(_r,XU,!0)}e.formatTypeFacts=ar;let or=!1,Fr;function rn(_r){"__debugFlowFlags"in _r||Object.defineProperties(_r,{__tsDebuggerDisplay:{value(){let rt=this.flags&2?"FlowStart":this.flags&4?"FlowBranchLabel":this.flags&8?"FlowLoopLabel":this.flags&16?"FlowAssignment":this.flags&32?"FlowTrueCondition":this.flags&64?"FlowFalseCondition":this.flags&128?"FlowSwitchClause":this.flags&256?"FlowArrayMutation":this.flags&512?"FlowCall":this.flags&1024?"FlowReduceLabel":this.flags&1?"FlowUnreachable":"UnknownFlow",zt=this.flags&-2048;return`${rt}${zt?` (${$t(zt)})`:""}`}},__debugFlowFlags:{get(){return we(this.flags,D3,!0)}},__debugToString:{value(){return On(this)}}})}function Tr(_r){or&&(typeof Object.setPrototypeOf=="function"?(Fr||(Fr=Object.create(Object.prototype),rn(Fr)),Object.setPrototypeOf(_r,Fr)):rn(_r))}e.attachFlowNodeDebugInfo=Tr;let nr;function tr(_r){"__tsDebuggerDisplay"in _r||Object.defineProperties(_r,{__tsDebuggerDisplay:{value(rt){return rt=String(rt).replace(/(?:,[\s\w\d_]+:[^,]+)+\]$/,"]"),`NodeArray ${rt}`}}})}function ki(_r){or&&(typeof Object.setPrototypeOf=="function"?(nr||(nr=Object.create(Array.prototype),tr(nr)),Object.setPrototypeOf(_r,nr)):tr(_r))}e.attachNodeArrayDebugInfo=ki;function xs(){if(or)return;let _r=new WeakMap,rt=new WeakMap;Object.defineProperties(Ju.getSymbolConstructor().prototype,{__tsDebuggerDisplay:{value(){let Rr=this.flags&33554432?"TransientSymbol":"Symbol",vi=this.flags&-33554433;return`${Rr} '${Lc(this)}'${vi?` (${kt(vi)})`:""}`}},__debugFlags:{get(){return kt(this.flags)}}}),Object.defineProperties(Ju.getTypeConstructor().prototype,{__tsDebuggerDisplay:{value(){let Rr=this.flags&67359327?`IntrinsicType ${this.intrinsicName}${this.debugIntrinsicName?` (${this.debugIntrinsicName})`:""}`:this.flags&98304?"NullableType":this.flags&384?`LiteralType ${JSON.stringify(this.value)}`:this.flags&2048?`LiteralType ${this.value.negative?"-":""}${this.value.base10Value}n`:this.flags&8192?"UniqueESSymbolType":this.flags&32?"EnumType":this.flags&1048576?"UnionType":this.flags&2097152?"IntersectionType":this.flags&4194304?"IndexType":this.flags&8388608?"IndexedAccessType":this.flags&16777216?"ConditionalType":this.flags&33554432?"SubstitutionType":this.flags&262144?"TypeParameter":this.flags&524288?this.objectFlags&3?"InterfaceType":this.objectFlags&4?"TypeReference":this.objectFlags&8?"TupleType":this.objectFlags&16?"AnonymousType":this.objectFlags&32?"MappedType":this.objectFlags&1024?"ReverseMappedType":this.objectFlags&256?"EvolvingArrayType":"ObjectType":"Type",vi=this.flags&524288?this.objectFlags&-1344:0;return`${Rr}${this.symbol?` '${Lc(this.symbol)}'`:""}${vi?` (${at(vi)})`:""}`}},__debugFlags:{get(){return ke(this.flags)}},__debugObjectFlags:{get(){return this.flags&524288?at(this.objectFlags):""}},__debugTypeToString:{value(){let Rr=_r.get(this);return Rr===void 0&&(Rr=this.checker.typeToString(this),_r.set(this,Rr)),Rr}}}),Object.defineProperties(Ju.getSignatureConstructor().prototype,{__debugFlags:{get(){return $e(this.flags)}},__debugSignatureToString:{value(){var Rr;return(Rr=this.checker)==null?void 0:Rr.signatureToString(this)}}});let zt=[Ju.getNodeConstructor(),Ju.getIdentifierConstructor(),Ju.getTokenConstructor(),Ju.getSourceFileConstructor()];for(let Rr of zt)wo(Rr.prototype,"__debugKind")||Object.defineProperties(Rr.prototype,{__tsDebuggerDisplay:{value(){return`${yc(this)?"GeneratedIdentifier":ze(this)?`Identifier '${Nn(this)}'`:is(this)?`PrivateIdentifier '${Nn(this)}'`:za(this)?`StringLiteral ${JSON.stringify(this.text.length<10?this.text:this.text.slice(10)+"...")}`:_p(this)?`NumericLiteral ${this.text}`:KB(this)?`BigIntLiteral ${this.text}n`:Nc(this)?"TypeParameterDeclaration":Ls(this)?"ParameterDeclaration":Yc(this)?"ConstructorDeclaration":sd(this)?"GetAccessorDeclaration":pp(this)?"SetAccessorDeclaration":HA(this)?"CallSignatureDeclaration":OR(this)?"ConstructSignatureDeclaration":oE(this)?"IndexSignatureDeclaration":RR(this)?"TypePredicateNode":Id(this)?"TypeReferenceNode":Vh(this)?"FunctionTypeNode":VN(this)?"ConstructorTypeNode":YA(this)?"TypeQueryNode":dp(this)?"TypeLiteralNode":MR(this)?"ArrayTypeNode":XA(this)?"TupleTypeNode":rU(this)?"OptionalTypeNode":nU(this)?"RestTypeNode":Kv(this)?"UnionTypeNode":KA(this)?"IntersectionTypeNode":QA(this)?"ConditionalTypeNode":ax(this)?"InferTypeNode":ox(this)?"ParenthesizedTypeNode":LR(this)?"ThisTypeNode":cx(this)?"TypeOperatorNode":lx(this)?"IndexedAccessTypeNode":qN(this)?"MappedTypeNode":Qv(this)?"LiteralTypeNode":JN(this)?"NamedTupleMember":M0(this)?"ImportTypeNode":Ee(this.kind)}${this.flags?` (${Ae(this.flags)})`:""}`}},__debugKind:{get(){return Ee(this.kind)}},__debugNodeFlags:{get(){return Ae(this.flags)}},__debugModifierFlags:{get(){return Ie(eme(this))}},__debugTransformFlags:{get(){return Re(this.transformFlags)}},__debugIsParseTreeNode:{get(){return Pw(this)}},__debugEmitFlags:{get(){return Ue(eo(this))}},__debugGetText:{value(vi){if(_c(this))return"";let Ni=rt.get(this);if(Ni===void 0){let us=Us(this),Fs=us&&Xr(us);Ni=Fs?Jb(Fs,us,vi):"",rt.set(this,Ni)}return Ni}}});or=!0}e.enableDebugInfo=xs;function zi(_r){let rt=_r&7,zt=rt===0?"in out":rt===3?"[bivariant]":rt===2?"in":rt===1?"out":rt===4?"[independent]":"";return _r&8?zt+=" (unmeasurable)":_r&16&&(zt+=" (unreliable)"),zt}e.formatVariance=zi;class Ms{__debugToString(){var rt;switch(this.kind){case 3:return((rt=this.debugInfo)==null?void 0:rt.call(this))||"(function mapper)";case 0:return`${this.source.__debugTypeToString()} -> ${this.target.__debugTypeToString()}`;case 1:return en(this.sources,this.targets||vr(this.sources,()=>"any"),(zt,Rr)=>`${zt.__debugTypeToString()} -> ${typeof Rr=="string"?Rr:Rr.__debugTypeToString()}`).join(", ");case 2:return en(this.sources,this.targets,(zt,Rr)=>`${zt.__debugTypeToString()} -> ${Rr().__debugTypeToString()}`).join(", ");case 5:case 4:return`m1: ${this.mapper1.__debugToString().split(`
`).join(`
    `)}
m2: ${this.mapper2.__debugToString().split(`
`).join(`
    `)}`;default:return $(this)}}}e.DebugTypeMapper=Ms;function un(_r){return e.isDebugging?Object.setPrototypeOf(_r,Ms.prototype):_r}e.attachDebugPrototypeIfDebug=un;function ri(_r){return console.log(On(_r))}e.printControlFlowGraph=ri;function On(_r){let rt=-1;function zt(le){return le.id||(le.id=rt,rt--),le.id}let Rr;(le=>{le.lr="\u2500",le.ud="\u2502",le.dr="\u256D",le.dl="\u256E",le.ul="\u256F",le.ur="\u2570",le.udr="\u251C",le.udl="\u2524",le.dlr="\u252C",le.ulr="\u2534",le.udlr="\u256B"})(Rr||(Rr={}));let vi;(le=>{le[le.None=0]="None",le[le.Up=1]="Up",le[le.Down=2]="Down",le[le.Left=4]="Left",le[le.Right=8]="Right",le[le.UpDown=3]="UpDown",le[le.LeftRight=12]="LeftRight",le[le.UpLeft=5]="UpLeft",le[le.UpRight=9]="UpRight",le[le.DownLeft=6]="DownLeft",le[le.DownRight=10]="DownRight",le[le.UpDownLeft=7]="UpDownLeft",le[le.UpDownRight=11]="UpDownRight",le[le.UpLeftRight=13]="UpLeftRight",le[le.DownLeftRight=14]="DownLeftRight",le[le.UpDownLeftRight=15]="UpDownLeftRight",le[le.NoChildren=16]="NoChildren"})(vi||(vi={}));let Ni=2032,us=882,Fs=Object.create(null),Ta=[],to=[],Nr=W(_r,new Set);for(let le of Ta)le.text=Sr(le.flowNode,le.circular),Nt(le);let qr=Ke(Nr),We=ht(qr);return Wt(Nr,0),Y();function mt(le){return!!(le.flags&128)}function dt(le){return!!(le.flags&12)&&!!le.antecedents}function Ot(le){return!!(le.flags&Ni)}function _e(le){return!!(le.flags&us)}function Ve(le){let X=[];for(let he of le.edges)he.source===le&&X.push(he.target);return X}function pt(le){let X=[];for(let he of le.edges)he.target===le&&X.push(he.source);return X}function W(le,X){let he=zt(le),qe=Fs[he];if(qe&&X.has(le))return qe.circular=!0,qe={id:-1,flowNode:le,edges:[],text:"",lane:-1,endLane:-1,level:-1,circular:"circularity"},Ta.push(qe),qe;if(X.add(le),!qe)if(Fs[he]=qe={id:he,flowNode:le,edges:[],text:"",lane:-1,endLane:-1,level:-1,circular:!1},Ta.push(qe),dt(le))for(let Le of le.antecedents)st(qe,Le,X);else Ot(le)&&st(qe,le.antecedent,X);return X.delete(le),qe}function st(le,X,he){let qe=W(X,he),Le={source:le,target:qe};to.push(Le),le.edges.push(Le),qe.edges.push(Le)}function Nt(le){if(le.level!==-1)return le.level;let X=0;for(let he of pt(le))X=Math.max(X,Nt(he)+1);return le.level=X}function Ke(le){let X=0;for(let he of Ve(le))X=Math.max(X,Ke(he));return X+1}function ht(le){let X=Lt(Array(le),0);for(let he of Ta)X[he.level]=Math.max(X[he.level],he.text.length);return X}function Wt(le,X){if(le.lane===-1){le.lane=X,le.endLane=X;let he=Ve(le);for(let qe=0;qe<he.length;qe++){qe>0&&X++;let Le=he[qe];Wt(Le,X),Le.endLane>le.endLane&&(X=Le.endLane)}le.endLane=X}}function Cr(le){if(le&2)return"Start";if(le&4)return"Branch";if(le&8)return"Loop";if(le&16)return"Assignment";if(le&32)return"True";if(le&64)return"False";if(le&128)return"SwitchClause";if(le&256)return"ArrayMutation";if(le&512)return"Call";if(le&1024)return"ReduceLabel";if(le&1)return"Unreachable";throw new Error}function hr(le){let X=Xr(le);return Jb(X,le,!1)}function Sr(le,X){let he=Cr(le.flags);if(X&&(he=`${he}#${zt(le)}`),_e(le))le.node&&(he+=` (${hr(le.node)})`);else if(mt(le)){let qe=[];for(let Le=le.clauseStart;Le<le.clauseEnd;Le++){let It=le.switchStatement.caseBlock.clauses[Le];q6(It)?qe.push("default"):qe.push(hr(It.expression))}he+=` (${qe.join(", ")})`}return X==="circularity"?`Circular(${he})`:he}function Y(){let le=We.length,X=Ta.reduce((Rt,Zt)=>Math.max(Rt,Zt.lane),0)+1,he=Lt(Array(X),""),qe=We.map(()=>Array(X)),Le=We.map(()=>Lt(Array(X),0));for(let Rt of Ta){qe[Rt.level][Rt.lane]=Rt;let Zt=Ve(Rt);for(let zr=0;zr<Zt.length;zr++){let Yr=Zt[zr],Pi=8;Yr.lane===Rt.lane&&(Pi|=4),zr>0&&(Pi|=1),zr<Zt.length-1&&(Pi|=2),Le[Rt.level][Yr.lane]|=Pi}Zt.length===0&&(Le[Rt.level][Rt.lane]|=16);let Ir=pt(Rt);for(let zr=0;zr<Ir.length;zr++){let Yr=Ir[zr],Pi=4;zr>0&&(Pi|=1),zr<Ir.length-1&&(Pi|=2),Le[Rt.level-1][Yr.lane]|=Pi}}for(let Rt=0;Rt<le;Rt++)for(let Zt=0;Zt<X;Zt++){let Ir=Rt>0?Le[Rt-1][Zt]:0,zr=Zt>0?Le[Rt][Zt-1]:0,Yr=Le[Rt][Zt];Yr||(Ir&8&&(Yr|=12),zr&2&&(Yr|=3),Le[Rt][Zt]=Yr)}for(let Rt=0;Rt<le;Rt++)for(let Zt=0;Zt<he.length;Zt++){let Ir=Le[Rt][Zt],zr=Ir&4?"\u2500":" ",Yr=qe[Rt][Zt];Yr?(It(Zt,Yr.text),Rt<le-1&&(It(Zt," "),It(Zt,B(zr,We[Rt]-Yr.text.length)))):Rt<le-1&&It(Zt,B(zr,We[Rt]+1)),It(Zt,Be(Ir)),It(Zt,Ir&8&&Rt<le-1&&!qe[Rt+1][Zt]?"\u2500":" ")}return`
${he.join(`
`)}
`;function It(Rt,Zt){he[Rt]+=Zt}}function Be(le){switch(le){case 3:return"\u2502";case 12:return"\u2500";case 5:return"\u256F";case 9:return"\u2570";case 6:return"\u256E";case 10:return"\u256D";case 7:return"\u2524";case 11:return"\u251C";case 13:return"\u2534";case 14:return"\u252C";case 15:return"\u256B"}return" "}function Lt(le,X){if(le.fill)le.fill(X);else for(let he=0;he<le.length;he++)le[he]=X;return le}function B(le,X){if(le.repeat)return X>0?le.repeat(X):"";let he="";for(;he.length<X;)he+=le;return he}}e.formatControlFlowGraph=On})(I||(I={}))}});function iOe(e){let t=aOe.exec(e);if(!t)return;let[,n,i="0",s="0",o="",l=""]=t;if(!(o&&!oOe.test(o))&&!(l&&!lOe.test(l)))return{major:parseInt(n,10),minor:parseInt(i,10),patch:parseInt(s,10),prerelease:o,build:l}}function Wht(e,t){if(e===t)return 0;if(e.length===0)return t.length===0?0:1;if(t.length===0)return-1;let n=Math.min(e.length,t.length);for(let i=0;i<n;i++){let s=e[i],o=t[i];if(s===o)continue;let l=Nfe.test(s),p=Nfe.test(o);if(l||p){if(l!==p)return l?-1:1;let m=To(+s,+o);if(m)return m}else{let m=h_(s,o);if(m)return m}}return To(e.length,t.length)}function sOe(e){let t=[];for(let n of e.trim().split(_Oe)){if(!n)continue;let i=[];n=n.trim();let s=dOe.exec(n);if(s){if(!Ght(s[1],s[2],i))return}else for(let o of n.split(fOe)){let l=mOe.exec(o.trim());if(!l||!Hht(l[1],l[2],i))return}t.push(i)}return t}function Pfe(e){let t=pOe.exec(e);if(!t)return;let[,n,i="*",s="*",o,l]=t;return{version:new Im(tm(n)?0:parseInt(n,10),tm(n)||tm(i)?0:parseInt(i,10),tm(n)||tm(i)||tm(s)?0:parseInt(s,10),o,l),major:n,minor:i,patch:s}}function Ght(e,t,n){let i=Pfe(e);if(!i)return!1;let s=Pfe(t);return s?(tm(i.major)||n.push(Ih(">=",i.version)),tm(s.major)||n.push(tm(s.minor)?Ih("<",s.version.increment("major")):tm(s.patch)?Ih("<",s.version.increment("minor")):Ih("<=",s.version)),!0):!1}function Hht(e,t,n){let i=Pfe(t);if(!i)return!1;let{version:s,major:o,minor:l,patch:p}=i;if(tm(o))(e==="<"||e===">")&&n.push(Ih("<",Im.zero));else switch(e){case"~":n.push(Ih(">=",s)),n.push(Ih("<",s.increment(tm(l)?"major":"minor")));break;case"^":n.push(Ih(">=",s)),n.push(Ih("<",s.increment(s.major>0||tm(l)?"major":s.minor>0||tm(p)?"minor":"patch")));break;case"<":case">=":n.push(tm(l)||tm(p)?Ih(e,s.with({prerelease:"0"})):Ih(e,s));break;case"<=":case">":n.push(tm(l)?Ih(e==="<="?"<":">=",s.increment("major").with({prerelease:"0"})):tm(p)?Ih(e==="<="?"<":">=",s.increment("minor").with({prerelease:"0"})):Ih(e,s));break;case"=":case void 0:tm(l)||tm(p)?(n.push(Ih(">=",s.with({prerelease:"0"}))),n.push(Ih("<",s.increment(tm(l)?"major":"minor").with({prerelease:"0"})))):n.push(Ih("=",s));break;default:return!1}return!0}function tm(e){return e==="*"||e==="x"||e==="X"}function Ih(e,t){return{operator:e,operand:t}}function Yht(e,t){if(t.length===0)return!0;for(let n of t)if(Xht(e,n))return!0;return!1}function Xht(e,t){for(let n of t)if(!Kht(e,n.operator,n.operand))return!1;return!0}function Kht(e,t,n){let i=e.compareTo(n);switch(t){case"<":return i<0;case"<=":return i<=0;case">":return i>0;case">=":return i>=0;case"=":return i===0;default:return I.assertNever(t)}}function Qht(e){return vr(e,Zht).join(" || ")||"*"}function Zht(e){return vr(e,e0t).join(" ")}function e0t(e){return`${e.operator}${e.operand}`}var aOe,oOe,cOe,lOe,uOe,Nfe,OG,Im,k3,_Oe,fOe,pOe,dOe,mOe,t0t=f({"src/compiler/semver.ts"(){"use strict";fa(),aOe=/^(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i,oOe=/^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)(?:\.(?:0|[1-9]\d*|[a-z-][a-z0-9-]*))*$/i,cOe=/^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)$/i,lOe=/^[a-z0-9-]+(?:\.[a-z0-9-]+)*$/i,uOe=/^[a-z0-9-]+$/i,Nfe=/^(0|[1-9]\d*)$/,OG=class S5{constructor(t,n=0,i=0,s="",o=""){typeof t=="string"&&({major:t,minor:n,patch:i,prerelease:s,build:o}=I.checkDefined(iOe(t),"Invalid version")),I.assert(t>=0,"Invalid argument: major"),I.assert(n>=0,"Invalid argument: minor"),I.assert(i>=0,"Invalid argument: patch");let l=s?os(s)?s:s.split("."):tt,p=o?os(o)?o:o.split("."):tt;I.assert(yr(l,m=>cOe.test(m)),"Invalid argument: prerelease"),I.assert(yr(p,m=>uOe.test(m)),"Invalid argument: build"),this.major=t,this.minor=n,this.patch=i,this.prerelease=l,this.build=p}static tryParse(t){let n=iOe(t);if(!n)return;let{major:i,minor:s,patch:o,prerelease:l,build:p}=n;return new S5(i,s,o,l,p)}compareTo(t){return this===t?0:t===void 0?1:To(this.major,t.major)||To(this.minor,t.minor)||To(this.patch,t.patch)||Wht(this.prerelease,t.prerelease)}increment(t){switch(t){case"major":return new S5(this.major+1,0,0);case"minor":return new S5(this.major,this.minor+1,0);case"patch":return new S5(this.major,this.minor,this.patch+1);default:return I.assertNever(t)}}with(t){let{major:n=this.major,minor:i=this.minor,patch:s=this.patch,prerelease:o=this.prerelease,build:l=this.build}=t;return new S5(n,i,s,o,l)}toString(){let t=`${this.major}.${this.minor}.${this.patch}`;return Tt(this.prerelease)&&(t+=`-${this.prerelease.join(".")}`),Tt(this.build)&&(t+=`+${this.build.join(".")}`),t}},OG.zero=new OG(0,0,0,["0"]),Im=OG,k3=class Jdt{constructor(t){this._alternatives=t?I.checkDefined(sOe(t),"Invalid range spec."):tt}static tryParse(t){let n=sOe(t);if(n){let i=new Jdt("");return i._alternatives=n,i}}test(t){return typeof t=="string"&&(t=new Im(t)),Yht(t,this._alternatives)}toString(){return Qht(this._alternatives)}},_Oe=/\|\|/g,fOe=/\s+/g,pOe=/^([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i,dOe=/^\s*([a-z0-9-+.*]+)\s+-\s+([a-z0-9-+.*]+)\s*$/i,mOe=/^(~|\^|<|<=|>|>=|=)?\s*([a-z0-9-+.*]+)$/i}});function gOe(e,t){return typeof e=="object"&&typeof e.timeOrigin=="number"&&typeof e.mark=="function"&&typeof e.measure=="function"&&typeof e.now=="function"&&typeof e.clearMarks=="function"&&typeof e.clearMeasures=="function"&&typeof t=="function"}function r0t(){if(typeof performance=="object"&&typeof PerformanceObserver=="function"&&gOe(performance,PerformanceObserver))return{shouldWriteNativeEvents:!0,performance,PerformanceObserver}}function n0t(){if(PG())try{let{performance:e,PerformanceObserver:t}=Bu("perf_hooks");if(gOe(e,t))return{shouldWriteNativeEvents:!1,performance:e,PerformanceObserver:t}}catch{}}function Dfe(){return RG}var RG,Ife,uc,i0t=f({"src/compiler/performanceCore.ts"(){"use strict";fa(),RG=r0t()||n0t(),Ife=RG?.performance,uc=Ife?()=>Ife.now():Date.now?Date.now:()=>+new Date}}),W5,z_,s0t=f({"src/compiler/perfLogger.ts"(){"use strict";try{let e=process.env.TS_ETW_MODULE_PATH??"./node_modules/@microsoft/typescript-etw";W5=Bu(e)}catch{W5=void 0}z_=W5?.logEvent?W5:void 0}});function hOe(e,t,n,i){return e?MG(t,n,i):LG}function MG(e,t,n){let i=0;return{enter:s,exit:o};function s(){++i===1&&mc(t)}function o(){--i===0?(mc(n),rd(e,t,n)):i<0&&I.fail("enter/exit count does not match.")}}function mc(e){if(jP){let t=yw.get(e)??0;yw.set(e,t+1),BP.set(e,uc()),w2?.mark(e),typeof onProfilerEvent=="function"&&onProfilerEvent(e)}}function rd(e,t,n){if(jP){let i=(n!==void 0?BP.get(n):void 0)??uc(),s=(t!==void 0?BP.get(t):void 0)??wfe,o=UP.get(e)||0;UP.set(e,o+(i-s)),w2?.measure(e,t,n)}}function a0t(e){return yw.get(e)||0}function o0t(e){return UP.get(e)||0}function c0t(e){UP.forEach((t,n)=>e(n,t))}function l0t(e){BP.forEach((t,n)=>e(n))}function u0t(e){e!==void 0?UP.delete(e):UP.clear(),w2?.clearMeasures(e)}function _0t(e){e!==void 0?(yw.delete(e),BP.delete(e)):(yw.clear(),BP.clear()),w2?.clearMarks(e)}function f0t(){return jP}function p0t(e=Zu){var t;return jP||(jP=!0,P3||(P3=Dfe()),P3&&(wfe=P3.performance.timeOrigin,(P3.shouldWriteNativeEvents||(t=e?.cpuProfilingEnabled)!=null&&t.call(e)||e?.debugMode)&&(w2=P3.performance))),!0}function d0t(){jP&&(BP.clear(),yw.clear(),UP.clear(),w2=void 0,jP=!1)}var P3,w2,LG,jP,wfe,BP,yw,UP,m0t=f({"src/compiler/performance.ts"(){"use strict";fa(),LG={enter:ja,exit:ja},jP=!1,wfe=uc(),BP=new Map,yw=new Map,UP=new Map}}),Ofe={};x(Ofe,{clearMarks:()=>_0t,clearMeasures:()=>u0t,createTimer:()=>MG,createTimerIf:()=>hOe,disable:()=>d0t,enable:()=>p0t,forEachMark:()=>l0t,forEachMeasure:()=>c0t,getCount:()=>a0t,getDuration:()=>o0t,isEnabled:()=>f0t,mark:()=>mc,measure:()=>rd,nullTimer:()=>LG});var O2=f({"src/compiler/_namespaces/ts.performance.ts"(){"use strict";m0t()}}),mn,N3,Rfe,Mfe,g0t=f({"src/compiler/tracing.ts"(){"use strict";fa(),O2(),(e=>{let t,n=0,i=0,s,o=[],l,p=[];function m(z,se,Se){if(I.assert(!mn,"Tracing already started"),t===void 0)try{t=Bu("fs")}catch(ye){throw new Error(`tracing requires having fs
(original error: ${ye.message||ye})`)}s=z,o.length=0,l===void 0&&(l=li(se,"legend.json")),t.existsSync(se)||t.mkdirSync(se,{recursive:!0});let xe=s==="build"?`.${process.pid}-${++n}`:s==="server"?`.${process.pid}`:"",Z=li(se,`trace${xe}.json`),Q=li(se,`types${xe}.json`);p.push({configFilePath:Se,tracePath:Z,typesPath:Q}),i=t.openSync(Z,"w"),mn=e;let ce={cat:"__metadata",ph:"M",ts:1e3*uc(),pid:1,tid:1};t.writeSync(i,`[
`+[{name:"process_name",args:{name:"tsc"},...ce},{name:"thread_name",args:{name:"Main"},...ce},{name:"TracingStartedInBrowser",...ce,cat:"disabled-by-default-devtools.timeline"}].map(ye=>JSON.stringify(ye)).join(`,
`))}e.startTracing=m;function S(){I.assert(mn,"Tracing is not in progress"),I.assert(!!o.length==(s!=="server")),t.writeSync(i,`
]
`),t.closeSync(i),mn=void 0,o.length?$(o):p[p.length-1].typesPath=void 0}e.stopTracing=S;function h(z){s!=="server"&&o.push(z)}e.recordType=h;let b;(z=>{z.Parse="parse",z.Program="program",z.Bind="bind",z.Check="check",z.CheckTypes="checkTypes",z.Emit="emit",z.Session="session"})(b=e.Phase||(e.Phase={}));function A(z,se,Se){K("I",z,se,Se,'"s":"g"')}e.instant=A;let k=[];function N(z,se,Se,xe=!1){xe&&K("B",z,se,Se),k.push({phase:z,name:se,args:Se,time:1e3*uc(),separateBeginAndEnd:xe})}e.push=N;function M(z){I.assert(k.length>0),H(k.length-1,1e3*uc(),z),k.length--}e.pop=M;function O(){let z=1e3*uc();for(let se=k.length-1;se>=0;se--)H(se,z);k.length=0}e.popAll=O;let U=1e3*10;function H(z,se,Se){let{phase:xe,name:Z,args:Q,time:ce,separateBeginAndEnd:ye}=k[z];ye?(I.assert(!Se,"`results` are not supported for events with `separateBeginAndEnd`"),K("E",xe,Z,Q,void 0,se)):U-ce%U<=se-ce&&K("X",xe,Z,{...Q,results:Se},`"dur":${se-ce}`,ce)}function K(z,se,Se,xe,Z,Q=1e3*uc()){s==="server"&&se==="checkTypes"||(mc("beginTracing"),t.writeSync(i,`,
{"pid":1,"tid":1,"ph":"${z}","cat":"${se}","ts":${Q},"name":"${Se}"`),Z&&t.writeSync(i,`,${Z}`),xe&&t.writeSync(i,`,"args":${JSON.stringify(xe)}`),t.writeSync(i,"}"),mc("endTracing"),rd("Tracing","beginTracing","endTracing"))}function re(z){let se=Xr(z);return se?{path:se.path,start:Se(Lo(se,z.pos)),end:Se(Lo(se,z.end))}:void 0;function Se(xe){return{line:xe.line+1,character:xe.character+1}}}function $(z){var se,Se,xe,Z,Q,ce,ye,we,ve,oe,Ee,Me,Ge,Ae,Ie,Re,Ue,kt,ke;mc("beginDumpTypes");let $e=p[p.length-1].typesPath,at=t.openSync($e,"w"),$t=new Map;t.writeSync(at,"[");let St=z.length;for(let Ze=0;Ze<St;Ze++){let yt=z[Ze],ar=yt.objectFlags,or=yt.aliasSymbol??yt.symbol,Fr;if(ar&16|yt.flags&2944)try{Fr=(se=yt.checker)==null?void 0:se.typeToString(yt)}catch{Fr=void 0}let rn={};if(yt.flags&8388608){let ri=yt;rn={indexedAccessObjectType:(Se=ri.objectType)==null?void 0:Se.id,indexedAccessIndexType:(xe=ri.indexType)==null?void 0:xe.id}}let Tr={};if(ar&4){let ri=yt;Tr={instantiatedType:(Z=ri.target)==null?void 0:Z.id,typeArguments:(Q=ri.resolvedTypeArguments)==null?void 0:Q.map(On=>On.id),referenceLocation:re(ri.node)}}let nr={};if(yt.flags&16777216){let ri=yt;nr={conditionalCheckType:(ce=ri.checkType)==null?void 0:ce.id,conditionalExtendsType:(ye=ri.extendsType)==null?void 0:ye.id,conditionalTrueType:((we=ri.resolvedTrueType)==null?void 0:we.id)??-1,conditionalFalseType:((ve=ri.resolvedFalseType)==null?void 0:ve.id)??-1}}let tr={};if(yt.flags&33554432){let ri=yt;tr={substitutionBaseType:(oe=ri.baseType)==null?void 0:oe.id,constraintType:(Ee=ri.constraint)==null?void 0:Ee.id}}let ki={};if(ar&1024){let ri=yt;ki={reverseMappedSourceType:(Me=ri.source)==null?void 0:Me.id,reverseMappedMappedType:(Ge=ri.mappedType)==null?void 0:Ge.id,reverseMappedConstraintType:(Ae=ri.constraintType)==null?void 0:Ae.id}}let xs={};if(ar&256){let ri=yt;xs={evolvingArrayElementType:ri.elementType.id,evolvingArrayFinalType:(Ie=ri.finalArrayType)==null?void 0:Ie.id}}let zi,Ms=yt.checker.getRecursionIdentity(yt);Ms&&(zi=$t.get(Ms),zi||(zi=$t.size,$t.set(Ms,zi)));let un={id:yt.id,intrinsicName:yt.intrinsicName,symbolName:or?.escapedName&&Zi(or.escapedName),recursionId:zi,isTuple:ar&8?!0:void 0,unionTypes:yt.flags&1048576?(Re=yt.types)==null?void 0:Re.map(ri=>ri.id):void 0,intersectionTypes:yt.flags&2097152?yt.types.map(ri=>ri.id):void 0,aliasTypeArguments:(Ue=yt.aliasTypeArguments)==null?void 0:Ue.map(ri=>ri.id),keyofType:yt.flags&4194304?(kt=yt.type)==null?void 0:kt.id:void 0,...rn,...Tr,...nr,...tr,...ki,...xs,destructuringPattern:re(yt.pattern),firstDeclaration:re((ke=or?.declarations)==null?void 0:ke[0]),flags:I.formatTypeFlags(yt.flags).split("|"),display:Fr};t.writeSync(at,JSON.stringify(un)),Ze<St-1&&t.writeSync(at,`,
`)}t.writeSync(at,`]
`),t.closeSync(at),mc("endDumpTypes"),rd("Dump types","beginDumpTypes","endDumpTypes")}function pe(){l&&t.writeFileSync(l,JSON.stringify(p))}e.dumpLegend=pe})(N3||(N3={})),Rfe=N3.startTracing,Mfe=N3.dumpLegend}});function R2(e,t=!0){let n=I3[e.category];return t?n.toLowerCase():n}var G5,H5,Y5,FG,X5,K5,jG,D3,BG,VP,Q5,UG,VG,Z5,JG,qG,zG,$G,WG,GG,HG,YG,XG,KG,QG,e9,ZG,eH,tH,rH,t9,r9,nH,iH,sH,aH,oH,cH,n9,lH,uH,_H,fH,pH,dH,I3,JP,mH,gH,hH,yH,vw,vH,SH,TH,i9,bH,EH,xH,CH,AH,s9,a9,o9,kH,PH,NH,DH,IH,wH,OH,RH,w3,MH,yOe=f({"src/compiler/types.ts"(){"use strict";G5=(e=>(e[e.Unknown=0]="Unknown",e[e.EndOfFileToken=1]="EndOfFileToken",e[e.SingleLineCommentTrivia=2]="SingleLineCommentTrivia",e[e.MultiLineCommentTrivia=3]="MultiLineCommentTrivia",e[e.NewLineTrivia=4]="NewLineTrivia",e[e.WhitespaceTrivia=5]="WhitespaceTrivia",e[e.ShebangTrivia=6]="ShebangTrivia",e[e.ConflictMarkerTrivia=7]="ConflictMarkerTrivia",e[e.NonTextFileMarkerTrivia=8]="NonTextFileMarkerTrivia",e[e.NumericLiteral=9]="NumericLiteral",e[e.BigIntLiteral=10]="BigIntLiteral",e[e.StringLiteral=11]="StringLiteral",e[e.JsxText=12]="JsxText",e[e.JsxTextAllWhiteSpaces=13]="JsxTextAllWhiteSpaces",e[e.RegularExpressionLiteral=14]="RegularExpressionLiteral",e[e.NoSubstitutionTemplateLiteral=15]="NoSubstitutionTemplateLiteral",e[e.TemplateHead=16]="TemplateHead",e[e.TemplateMiddle=17]="TemplateMiddle",e[e.TemplateTail=18]="TemplateTail",e[e.OpenBraceToken=19]="OpenBraceToken",e[e.CloseBraceToken=20]="CloseBraceToken",e[e.OpenParenToken=21]="OpenParenToken",e[e.CloseParenToken=22]="CloseParenToken",e[e.OpenBracketToken=23]="OpenBracketToken",e[e.CloseBracketToken=24]="CloseBracketToken",e[e.DotToken=25]="DotToken",e[e.DotDotDotToken=26]="DotDotDotToken",e[e.SemicolonToken=27]="SemicolonToken",e[e.CommaToken=28]="CommaToken",e[e.QuestionDotToken=29]="QuestionDotToken",e[e.LessThanToken=30]="LessThanToken",e[e.LessThanSlashToken=31]="LessThanSlashToken",e[e.GreaterThanToken=32]="GreaterThanToken",e[e.LessThanEqualsToken=33]="LessThanEqualsToken",e[e.GreaterThanEqualsToken=34]="GreaterThanEqualsToken",e[e.EqualsEqualsToken=35]="EqualsEqualsToken",e[e.ExclamationEqualsToken=36]="ExclamationEqualsToken",e[e.EqualsEqualsEqualsToken=37]="EqualsEqualsEqualsToken",e[e.ExclamationEqualsEqualsToken=38]="ExclamationEqualsEqualsToken",e[e.EqualsGreaterThanToken=39]="EqualsGreaterThanToken",e[e.PlusToken=40]="PlusToken",e[e.MinusToken=41]="MinusToken",e[e.AsteriskToken=42]="AsteriskToken",e[e.AsteriskAsteriskToken=43]="AsteriskAsteriskToken",e[e.SlashToken=44]="SlashToken",e[e.PercentToken=45]="PercentToken",e[e.PlusPlusToken=46]="PlusPlusToken",e[e.MinusMinusToken=47]="MinusMinusToken",e[e.LessThanLessThanToken=48]="LessThanLessThanToken",e[e.GreaterThanGreaterThanToken=49]="GreaterThanGreaterThanToken",e[e.GreaterThanGreaterThanGreaterThanToken=50]="GreaterThanGreaterThanGreaterThanToken",e[e.AmpersandToken=51]="AmpersandToken",e[e.BarToken=52]="BarToken",e[e.CaretToken=53]="CaretToken",e[e.ExclamationToken=54]="ExclamationToken",e[e.TildeToken=55]="TildeToken",e[e.AmpersandAmpersandToken=56]="AmpersandAmpersandToken",e[e.BarBarToken=57]="BarBarToken",e[e.QuestionToken=58]="QuestionToken",e[e.ColonToken=59]="ColonToken",e[e.AtToken=60]="AtToken",e[e.QuestionQuestionToken=61]="QuestionQuestionToken",e[e.BacktickToken=62]="BacktickToken",e[e.HashToken=63]="HashToken",e[e.EqualsToken=64]="EqualsToken",e[e.PlusEqualsToken=65]="PlusEqualsToken",e[e.MinusEqualsToken=66]="MinusEqualsToken",e[e.AsteriskEqualsToken=67]="AsteriskEqualsToken",e[e.AsteriskAsteriskEqualsToken=68]="AsteriskAsteriskEqualsToken",e[e.SlashEqualsToken=69]="SlashEqualsToken",e[e.PercentEqualsToken=70]="PercentEqualsToken",e[e.LessThanLessThanEqualsToken=71]="LessThanLessThanEqualsToken",e[e.GreaterThanGreaterThanEqualsToken=72]="GreaterThanGreaterThanEqualsToken",e[e.GreaterThanGreaterThanGreaterThanEqualsToken=73]="GreaterThanGreaterThanGreaterThanEqualsToken",e[e.AmpersandEqualsToken=74]="AmpersandEqualsToken",e[e.BarEqualsToken=75]="BarEqualsToken",e[e.BarBarEqualsToken=76]="BarBarEqualsToken",e[e.AmpersandAmpersandEqualsToken=77]="AmpersandAmpersandEqualsToken",e[e.QuestionQuestionEqualsToken=78]="QuestionQuestionEqualsToken",e[e.CaretEqualsToken=79]="CaretEqualsToken",e[e.Identifier=80]="Identifier",e[e.PrivateIdentifier=81]="PrivateIdentifier",e[e.JSDocCommentTextToken=82]="JSDocCommentTextToken",e[e.BreakKeyword=83]="BreakKeyword",e[e.CaseKeyword=84]="CaseKeyword",e[e.CatchKeyword=85]="CatchKeyword",e[e.ClassKeyword=86]="ClassKeyword",e[e.ConstKeyword=87]="ConstKeyword",e[e.ContinueKeyword=88]="ContinueKeyword",e[e.DebuggerKeyword=89]="DebuggerKeyword",e[e.DefaultKeyword=90]="DefaultKeyword",e[e.DeleteKeyword=91]="DeleteKeyword",e[e.DoKeyword=92]="DoKeyword",e[e.ElseKeyword=93]="ElseKeyword",e[e.EnumKeyword=94]="EnumKeyword",e[e.ExportKeyword=95]="ExportKeyword",e[e.ExtendsKeyword=96]="ExtendsKeyword",e[e.FalseKeyword=97]="FalseKeyword",e[e.FinallyKeyword=98]="FinallyKeyword",e[e.ForKeyword=99]="ForKeyword",e[e.FunctionKeyword=100]="FunctionKeyword",e[e.IfKeyword=101]="IfKeyword",e[e.ImportKeyword=102]="ImportKeyword",e[e.InKeyword=103]="InKeyword",e[e.InstanceOfKeyword=104]="InstanceOfKeyword",e[e.NewKeyword=105]="NewKeyword",e[e.NullKeyword=106]="NullKeyword",e[e.ReturnKeyword=107]="ReturnKeyword",e[e.SuperKeyword=108]="SuperKeyword",e[e.SwitchKeyword=109]="SwitchKeyword",e[e.ThisKeyword=110]="ThisKeyword",e[e.ThrowKeyword=111]="ThrowKeyword",e[e.TrueKeyword=112]="TrueKeyword",e[e.TryKeyword=113]="TryKeyword",e[e.TypeOfKeyword=114]="TypeOfKeyword",e[e.VarKeyword=115]="VarKeyword",e[e.VoidKeyword=116]="VoidKeyword",e[e.WhileKeyword=117]="WhileKeyword",e[e.WithKeyword=118]="WithKeyword",e[e.ImplementsKeyword=119]="ImplementsKeyword",e[e.InterfaceKeyword=120]="InterfaceKeyword",e[e.LetKeyword=121]="LetKeyword",e[e.PackageKeyword=122]="PackageKeyword",e[e.PrivateKeyword=123]="PrivateKeyword",e[e.ProtectedKeyword=124]="ProtectedKeyword",e[e.PublicKeyword=125]="PublicKeyword",e[e.StaticKeyword=126]="StaticKeyword",e[e.YieldKeyword=127]="YieldKeyword",e[e.AbstractKeyword=128]="AbstractKeyword",e[e.AccessorKeyword=129]="AccessorKeyword",e[e.AsKeyword=130]="AsKeyword",e[e.AssertsKeyword=131]="AssertsKeyword",e[e.AssertKeyword=132]="AssertKeyword",e[e.AnyKeyword=133]="AnyKeyword",e[e.AsyncKeyword=134]="AsyncKeyword",e[e.AwaitKeyword=135]="AwaitKeyword",e[e.BooleanKeyword=136]="BooleanKeyword",e[e.ConstructorKeyword=137]="ConstructorKeyword",e[e.DeclareKeyword=138]="DeclareKeyword",e[e.GetKeyword=139]="GetKeyword",e[e.InferKeyword=140]="InferKeyword",e[e.IntrinsicKeyword=141]="IntrinsicKeyword",e[e.IsKeyword=142]="IsKeyword",e[e.KeyOfKeyword=143]="KeyOfKeyword",e[e.ModuleKeyword=144]="ModuleKeyword",e[e.NamespaceKeyword=145]="NamespaceKeyword",e[e.NeverKeyword=146]="NeverKeyword",e[e.OutKeyword=147]="OutKeyword",e[e.ReadonlyKeyword=148]="ReadonlyKeyword",e[e.RequireKeyword=149]="RequireKeyword",e[e.NumberKeyword=150]="NumberKeyword",e[e.ObjectKeyword=151]="ObjectKeyword",e[e.SatisfiesKeyword=152]="SatisfiesKeyword",e[e.SetKeyword=153]="SetKeyword",e[e.StringKeyword=154]="StringKeyword",e[e.SymbolKeyword=155]="SymbolKeyword",e[e.TypeKeyword=156]="TypeKeyword",e[e.UndefinedKeyword=157]="UndefinedKeyword",e[e.UniqueKeyword=158]="UniqueKeyword",e[e.UnknownKeyword=159]="UnknownKeyword",e[e.UsingKeyword=160]="UsingKeyword",e[e.FromKeyword=161]="FromKeyword",e[e.GlobalKeyword=162]="GlobalKeyword",e[e.BigIntKeyword=163]="BigIntKeyword",e[e.OverrideKeyword=164]="OverrideKeyword",e[e.OfKeyword=165]="OfKeyword",e[e.QualifiedName=166]="QualifiedName",e[e.ComputedPropertyName=167]="ComputedPropertyName",e[e.TypeParameter=168]="TypeParameter",e[e.Parameter=169]="Parameter",e[e.Decorator=170]="Decorator",e[e.PropertySignature=171]="PropertySignature",e[e.PropertyDeclaration=172]="PropertyDeclaration",e[e.MethodSignature=173]="MethodSignature",e[e.MethodDeclaration=174]="MethodDeclaration",e[e.ClassStaticBlockDeclaration=175]="ClassStaticBlockDeclaration",e[e.Constructor=176]="Constructor",e[e.GetAccessor=177]="GetAccessor",e[e.SetAccessor=178]="SetAccessor",e[e.CallSignature=179]="CallSignature",e[e.ConstructSignature=180]="ConstructSignature",e[e.IndexSignature=181]="IndexSignature",e[e.TypePredicate=182]="TypePredicate",e[e.TypeReference=183]="TypeReference",e[e.FunctionType=184]="FunctionType",e[e.ConstructorType=185]="ConstructorType",e[e.TypeQuery=186]="TypeQuery",e[e.TypeLiteral=187]="TypeLiteral",e[e.ArrayType=188]="ArrayType",e[e.TupleType=189]="TupleType",e[e.OptionalType=190]="OptionalType",e[e.RestType=191]="RestType",e[e.UnionType=192]="UnionType",e[e.IntersectionType=193]="IntersectionType",e[e.ConditionalType=194]="ConditionalType",e[e.InferType=195]="InferType",e[e.ParenthesizedType=196]="ParenthesizedType",e[e.ThisType=197]="ThisType",e[e.TypeOperator=198]="TypeOperator",e[e.IndexedAccessType=199]="IndexedAccessType",e[e.MappedType=200]="MappedType",e[e.LiteralType=201]="LiteralType",e[e.NamedTupleMember=202]="NamedTupleMember",e[e.TemplateLiteralType=203]="TemplateLiteralType",e[e.TemplateLiteralTypeSpan=204]="TemplateLiteralTypeSpan",e[e.ImportType=205]="ImportType",e[e.ObjectBindingPattern=206]="ObjectBindingPattern",e[e.ArrayBindingPattern=207]="ArrayBindingPattern",e[e.BindingElement=208]="BindingElement",e[e.ArrayLiteralExpression=209]="ArrayLiteralExpression",e[e.ObjectLiteralExpression=210]="ObjectLiteralExpression",e[e.PropertyAccessExpression=211]="PropertyAccessExpression",e[e.ElementAccessExpression=212]="ElementAccessExpression",e[e.CallExpression=213]="CallExpression",e[e.NewExpression=214]="NewExpression",e[e.TaggedTemplateExpression=215]="TaggedTemplateExpression",e[e.TypeAssertionExpression=216]="TypeAssertionExpression",e[e.ParenthesizedExpression=217]="ParenthesizedExpression",e[e.FunctionExpression=218]="FunctionExpression",e[e.ArrowFunction=219]="ArrowFunction",e[e.DeleteExpression=220]="DeleteExpression",e[e.TypeOfExpression=221]="TypeOfExpression",e[e.VoidExpression=222]="VoidExpression",e[e.AwaitExpression=223]="AwaitExpression",e[e.PrefixUnaryExpression=224]="PrefixUnaryExpression",e[e.PostfixUnaryExpression=225]="PostfixUnaryExpression",e[e.BinaryExpression=226]="BinaryExpression",e[e.ConditionalExpression=227]="ConditionalExpression",e[e.TemplateExpression=228]="TemplateExpression",e[e.YieldExpression=229]="YieldExpression",e[e.SpreadElement=230]="SpreadElement",e[e.ClassExpression=231]="ClassExpression",e[e.OmittedExpression=232]="OmittedExpression",e[e.ExpressionWithTypeArguments=233]="ExpressionWithTypeArguments",e[e.AsExpression=234]="AsExpression",e[e.NonNullExpression=235]="NonNullExpression",e[e.MetaProperty=236]="MetaProperty",e[e.SyntheticExpression=237]="SyntheticExpression",e[e.SatisfiesExpression=238]="SatisfiesExpression",e[e.TemplateSpan=239]="TemplateSpan",e[e.SemicolonClassElement=240]="SemicolonClassElement",e[e.Block=241]="Block",e[e.EmptyStatement=242]="EmptyStatement",e[e.VariableStatement=243]="VariableStatement",e[e.ExpressionStatement=244]="ExpressionStatement",e[e.IfStatement=245]="IfStatement",e[e.DoStatement=246]="DoStatement",e[e.WhileStatement=247]="WhileStatement",e[e.ForStatement=248]="ForStatement",e[e.ForInStatement=249]="ForInStatement",e[e.ForOfStatement=250]="ForOfStatement",e[e.ContinueStatement=251]="ContinueStatement",e[e.BreakStatement=252]="BreakStatement",e[e.ReturnStatement=253]="ReturnStatement",e[e.WithStatement=254]="WithStatement",e[e.SwitchStatement=255]="SwitchStatement",e[e.LabeledStatement=256]="LabeledStatement",e[e.ThrowStatement=257]="ThrowStatement",e[e.TryStatement=258]="TryStatement",e[e.DebuggerStatement=259]="DebuggerStatement",e[e.VariableDeclaration=260]="VariableDeclaration",e[e.VariableDeclarationList=261]="VariableDeclarationList",e[e.FunctionDeclaration=262]="FunctionDeclaration",e[e.ClassDeclaration=263]="ClassDeclaration",e[e.InterfaceDeclaration=264]="InterfaceDeclaration",e[e.TypeAliasDeclaration=265]="TypeAliasDeclaration",e[e.EnumDeclaration=266]="EnumDeclaration",e[e.ModuleDeclaration=267]="ModuleDeclaration",e[e.ModuleBlock=268]="ModuleBlock",e[e.CaseBlock=269]="CaseBlock",e[e.NamespaceExportDeclaration=270]="NamespaceExportDeclaration",e[e.ImportEqualsDeclaration=271]="ImportEqualsDeclaration",e[e.ImportDeclaration=272]="ImportDeclaration",e[e.ImportClause=273]="ImportClause",e[e.NamespaceImport=274]="NamespaceImport",e[e.NamedImports=275]="NamedImports",e[e.ImportSpecifier=276]="ImportSpecifier",e[e.ExportAssignment=277]="ExportAssignment",e[e.ExportDeclaration=278]="ExportDeclaration",e[e.NamedExports=279]="NamedExports",e[e.NamespaceExport=280]="NamespaceExport",e[e.ExportSpecifier=281]="ExportSpecifier",e[e.MissingDeclaration=282]="MissingDeclaration",e[e.ExternalModuleReference=283]="ExternalModuleReference",e[e.JsxElement=284]="JsxElement",e[e.JsxSelfClosingElement=285]="JsxSelfClosingElement",e[e.JsxOpeningElement=286]="JsxOpeningElement",e[e.JsxClosingElement=287]="JsxClosingElement",e[e.JsxFragment=288]="JsxFragment",e[e.JsxOpeningFragment=289]="JsxOpeningFragment",e[e.JsxClosingFragment=290]="JsxClosingFragment",e[e.JsxAttribute=291]="JsxAttribute",e[e.JsxAttributes=292]="JsxAttributes",e[e.JsxSpreadAttribute=293]="JsxSpreadAttribute",e[e.JsxExpression=294]="JsxExpression",e[e.JsxNamespacedName=295]="JsxNamespacedName",e[e.CaseClause=296]="CaseClause",e[e.DefaultClause=297]="DefaultClause",e[e.HeritageClause=298]="HeritageClause",e[e.CatchClause=299]="CatchClause",e[e.ImportAttributes=300]="ImportAttributes",e[e.ImportAttribute=301]="ImportAttribute",e[e.AssertClause=300]="AssertClause",e[e.AssertEntry=301]="AssertEntry",e[e.ImportTypeAssertionContainer=302]="ImportTypeAssertionContainer",e[e.PropertyAssignment=303]="PropertyAssignment",e[e.ShorthandPropertyAssignment=304]="ShorthandPropertyAssignment",e[e.SpreadAssignment=305]="SpreadAssignment",e[e.EnumMember=306]="EnumMember",e[e.UnparsedPrologue=307]="UnparsedPrologue",e[e.UnparsedPrepend=308]="UnparsedPrepend",e[e.UnparsedText=309]="UnparsedText",e[e.UnparsedInternalText=310]="UnparsedInternalText",e[e.UnparsedSyntheticReference=311]="UnparsedSyntheticReference",e[e.SourceFile=312]="SourceFile",e[e.Bundle=313]="Bundle",e[e.UnparsedSource=314]="UnparsedSource",e[e.InputFiles=315]="InputFiles",e[e.JSDocTypeExpression=316]="JSDocTypeExpression",e[e.JSDocNameReference=317]="JSDocNameReference",e[e.JSDocMemberName=318]="JSDocMemberName",e[e.JSDocAllType=319]="JSDocAllType",e[e.JSDocUnknownType=320]="JSDocUnknownType",e[e.JSDocNullableType=321]="JSDocNullableType",e[e.JSDocNonNullableType=322]="JSDocNonNullableType",e[e.JSDocOptionalType=323]="JSDocOptionalType",e[e.JSDocFunctionType=324]="JSDocFunctionType",e[e.JSDocVariadicType=325]="JSDocVariadicType",e[e.JSDocNamepathType=326]="JSDocNamepathType",e[e.JSDoc=327]="JSDoc",e[e.JSDocComment=327]="JSDocComment",e[e.JSDocText=328]="JSDocText",e[e.JSDocTypeLiteral=329]="JSDocTypeLiteral",e[e.JSDocSignature=330]="JSDocSignature",e[e.JSDocLink=331]="JSDocLink",e[e.JSDocLinkCode=332]="JSDocLinkCode",e[e.JSDocLinkPlain=333]="JSDocLinkPlain",e[e.JSDocTag=334]="JSDocTag",e[e.JSDocAugmentsTag=335]="JSDocAugmentsTag",e[e.JSDocImplementsTag=336]="JSDocImplementsTag",e[e.JSDocAuthorTag=337]="JSDocAuthorTag",e[e.JSDocDeprecatedTag=338]="JSDocDeprecatedTag",e[e.JSDocClassTag=339]="JSDocClassTag",e[e.JSDocPublicTag=340]="JSDocPublicTag",e[e.JSDocPrivateTag=341]="JSDocPrivateTag",e[e.JSDocProtectedTag=342]="JSDocProtectedTag",e[e.JSDocReadonlyTag=343]="JSDocReadonlyTag",e[e.JSDocOverrideTag=344]="JSDocOverrideTag",e[e.JSDocCallbackTag=345]="JSDocCallbackTag",e[e.JSDocOverloadTag=346]="JSDocOverloadTag",e[e.JSDocEnumTag=347]="JSDocEnumTag",e[e.JSDocParameterTag=348]="JSDocParameterTag",e[e.JSDocReturnTag=349]="JSDocReturnTag",e[e.JSDocThisTag=350]="JSDocThisTag",e[e.JSDocTypeTag=351]="JSDocTypeTag",e[e.JSDocTemplateTag=352]="JSDocTemplateTag",e[e.JSDocTypedefTag=353]="JSDocTypedefTag",e[e.JSDocSeeTag=354]="JSDocSeeTag",e[e.JSDocPropertyTag=355]="JSDocPropertyTag",e[e.JSDocThrowsTag=356]="JSDocThrowsTag",e[e.JSDocSatisfiesTag=357]="JSDocSatisfiesTag",e[e.SyntaxList=358]="SyntaxList",e[e.NotEmittedStatement=359]="NotEmittedStatement",e[e.PartiallyEmittedExpression=360]="PartiallyEmittedExpression",e[e.CommaListExpression=361]="CommaListExpression",e[e.SyntheticReferenceExpression=362]="SyntheticReferenceExpression",e[e.Count=363]="Count",e[e.FirstAssignment=64]="FirstAssignment",e[e.LastAssignment=79]="LastAssignment",e[e.FirstCompoundAssignment=65]="FirstCompoundAssignment",e[e.LastCompoundAssignment=79]="LastCompoundAssignment",e[e.FirstReservedWord=83]="FirstReservedWord",e[e.LastReservedWord=118]="LastReservedWord",e[e.FirstKeyword=83]="FirstKeyword",e[e.LastKeyword=165]="LastKeyword",e[e.FirstFutureReservedWord=119]="FirstFutureReservedWord",e[e.LastFutureReservedWord=127]="LastFutureReservedWord",e[e.FirstTypeNode=182]="FirstTypeNode",e[e.LastTypeNode=205]="LastTypeNode",e[e.FirstPunctuation=19]="FirstPunctuation",e[e.LastPunctuation=79]="LastPunctuation",e[e.FirstToken=0]="FirstToken",e[e.LastToken=165]="LastToken",e[e.FirstTriviaToken=2]="FirstTriviaToken",e[e.LastTriviaToken=7]="LastTriviaToken",e[e.FirstLiteralToken=9]="FirstLiteralToken",e[e.LastLiteralToken=15]="LastLiteralToken",e[e.FirstTemplateToken=15]="FirstTemplateToken",e[e.LastTemplateToken=18]="LastTemplateToken",e[e.FirstBinaryOperator=30]="FirstBinaryOperator",e[e.LastBinaryOperator=79]="LastBinaryOperator",e[e.FirstStatement=243]="FirstStatement",e[e.LastStatement=259]="LastStatement",e[e.FirstNode=166]="FirstNode",e[e.FirstJSDocNode=316]="FirstJSDocNode",e[e.LastJSDocNode=357]="LastJSDocNode",e[e.FirstJSDocTagNode=334]="FirstJSDocTagNode",e[e.LastJSDocTagNode=357]="LastJSDocTagNode",e[e.FirstContextualKeyword=128]="FirstContextualKeyword",e[e.LastContextualKeyword=165]="LastContextualKeyword",e))(G5||{}),H5=(e=>(e[e.None=0]="None",e[e.Let=1]="Let",e[e.Const=2]="Const",e[e.Using=4]="Using",e[e.AwaitUsing=6]="AwaitUsing",e[e.NestedNamespace=8]="NestedNamespace",e[e.Synthesized=16]="Synthesized",e[e.Namespace=32]="Namespace",e[e.OptionalChain=64]="OptionalChain",e[e.ExportContext=128]="ExportContext",e[e.ContainsThis=256]="ContainsThis",e[e.HasImplicitReturn=512]="HasImplicitReturn",e[e.HasExplicitReturn=1024]="HasExplicitReturn",e[e.GlobalAugmentation=2048]="GlobalAugmentation",e[e.HasAsyncFunctions=4096]="HasAsyncFunctions",e[e.DisallowInContext=8192]="DisallowInContext",e[e.YieldContext=16384]="YieldContext",e[e.DecoratorContext=32768]="DecoratorContext",e[e.AwaitContext=65536]="AwaitContext",e[e.DisallowConditionalTypesContext=131072]="DisallowConditionalTypesContext",e[e.ThisNodeHasError=262144]="ThisNodeHasError",e[e.JavaScriptFile=524288]="JavaScriptFile",e[e.ThisNodeOrAnySubNodesHasError=1048576]="ThisNodeOrAnySubNodesHasError",e[e.HasAggregatedChildData=2097152]="HasAggregatedChildData",e[e.PossiblyContainsDynamicImport=4194304]="PossiblyContainsDynamicImport",e[e.PossiblyContainsImportMeta=8388608]="PossiblyContainsImportMeta",e[e.JSDoc=16777216]="JSDoc",e[e.Ambient=33554432]="Ambient",e[e.InWithStatement=67108864]="InWithStatement",e[e.JsonFile=134217728]="JsonFile",e[e.TypeCached=268435456]="TypeCached",e[e.Deprecated=536870912]="Deprecated",e[e.BlockScoped=7]="BlockScoped",e[e.Constant=6]="Constant",e[e.ReachabilityCheckFlags=1536]="ReachabilityCheckFlags",e[e.ReachabilityAndEmitFlags=5632]="ReachabilityAndEmitFlags",e[e.ContextFlags=101441536]="ContextFlags",e[e.TypeExcludesFlags=81920]="TypeExcludesFlags",e[e.PermanentlySetIncrementalFlags=12582912]="PermanentlySetIncrementalFlags",e[e.IdentifierHasExtendedUnicodeEscape=256]="IdentifierHasExtendedUnicodeEscape",e[e.IdentifierIsInJSDocNamespace=4096]="IdentifierIsInJSDocNamespace",e))(H5||{}),Y5=(e=>(e[e.None=0]="None",e[e.Public=1]="Public",e[e.Private=2]="Private",e[e.Protected=4]="Protected",e[e.Readonly=8]="Readonly",e[e.Override=16]="Override",e[e.Export=32]="Export",e[e.Abstract=64]="Abstract",e[e.Ambient=128]="Ambient",e[e.Static=256]="Static",e[e.Accessor=512]="Accessor",e[e.Async=1024]="Async",e[e.Default=2048]="Default",e[e.Const=4096]="Const",e[e.In=8192]="In",e[e.Out=16384]="Out",e[e.Decorator=32768]="Decorator",e[e.Deprecated=65536]="Deprecated",e[e.JSDocPublic=8388608]="JSDocPublic",e[e.JSDocPrivate=16777216]="JSDocPrivate",e[e.JSDocProtected=33554432]="JSDocProtected",e[e.JSDocReadonly=67108864]="JSDocReadonly",e[e.JSDocOverride=134217728]="JSDocOverride",e[e.SyntacticOrJSDocModifiers=31]="SyntacticOrJSDocModifiers",e[e.SyntacticOnlyModifiers=65504]="SyntacticOnlyModifiers",e[e.SyntacticModifiers=65535]="SyntacticModifiers",e[e.JSDocCacheOnlyModifiers=260046848]="JSDocCacheOnlyModifiers",e[e.JSDocOnlyModifiers=65536]="JSDocOnlyModifiers",e[e.NonCacheOnlyModifiers=131071]="NonCacheOnlyModifiers",e[e.HasComputedJSDocModifiers=268435456]="HasComputedJSDocModifiers",e[e.HasComputedFlags=536870912]="HasComputedFlags",e[e.AccessibilityModifier=7]="AccessibilityModifier",e[e.ParameterPropertyModifier=31]="ParameterPropertyModifier",e[e.NonPublicAccessibilityModifier=6]="NonPublicAccessibilityModifier",e[e.TypeScriptModifier=28895]="TypeScriptModifier",e[e.ExportDefault=2080]="ExportDefault",e[e.All=131071]="All",e[e.Modifier=98303]="Modifier",e))(Y5||{}),FG=(e=>(e[e.None=0]="None",e[e.IntrinsicNamedElement=1]="IntrinsicNamedElement",e[e.IntrinsicIndexedElement=2]="IntrinsicIndexedElement",e[e.IntrinsicElement=3]="IntrinsicElement",e))(FG||{}),X5=(e=>(e[e.None=0]="None",e[e.Succeeded=1]="Succeeded",e[e.Failed=2]="Failed",e[e.Reported=4]="Reported",e[e.ReportsUnmeasurable=8]="ReportsUnmeasurable",e[e.ReportsUnreliable=16]="ReportsUnreliable",e[e.ReportsMask=24]="ReportsMask",e))(X5||{}),K5=(e=>(e[e.None=0]="None",e[e.Auto=1]="Auto",e[e.Loop=2]="Loop",e[e.Unique=3]="Unique",e[e.Node=4]="Node",e[e.KindMask=7]="KindMask",e[e.ReservedInNestedScopes=8]="ReservedInNestedScopes",e[e.Optimistic=16]="Optimistic",e[e.FileLevel=32]="FileLevel",e[e.AllowNameSubstitution=64]="AllowNameSubstitution",e))(K5||{}),jG=(e=>(e[e.None=0]="None",e[e.PrecedingLineBreak=1]="PrecedingLineBreak",e[e.PrecedingJSDocComment=2]="PrecedingJSDocComment",e[e.Unterminated=4]="Unterminated",e[e.ExtendedUnicodeEscape=8]="ExtendedUnicodeEscape",e[e.Scientific=16]="Scientific",e[e.Octal=32]="Octal",e[e.HexSpecifier=64]="HexSpecifier",e[e.BinarySpecifier=128]="BinarySpecifier",e[e.OctalSpecifier=256]="OctalSpecifier",e[e.ContainsSeparator=512]="ContainsSeparator",e[e.UnicodeEscape=1024]="UnicodeEscape",e[e.ContainsInvalidEscape=2048]="ContainsInvalidEscape",e[e.HexEscape=4096]="HexEscape",e[e.ContainsLeadingZero=8192]="ContainsLeadingZero",e[e.ContainsInvalidSeparator=16384]="ContainsInvalidSeparator",e[e.BinaryOrOctalSpecifier=384]="BinaryOrOctalSpecifier",e[e.WithSpecifier=448]="WithSpecifier",e[e.StringLiteralFlags=7176]="StringLiteralFlags",e[e.NumericLiteralFlags=25584]="NumericLiteralFlags",e[e.TemplateLiteralLikeFlags=7176]="TemplateLiteralLikeFlags",e[e.IsInvalid=26656]="IsInvalid",e))(jG||{}),D3=(e=>(e[e.Unreachable=1]="Unreachable",e[e.Start=2]="Start",e[e.BranchLabel=4]="BranchLabel",e[e.LoopLabel=8]="LoopLabel",e[e.Assignment=16]="Assignment",e[e.TrueCondition=32]="TrueCondition",e[e.FalseCondition=64]="FalseCondition",e[e.SwitchClause=128]="SwitchClause",e[e.ArrayMutation=256]="ArrayMutation",e[e.Call=512]="Call",e[e.ReduceLabel=1024]="ReduceLabel",e[e.Referenced=2048]="Referenced",e[e.Shared=4096]="Shared",e[e.Label=12]="Label",e[e.Condition=96]="Condition",e))(D3||{}),BG=(e=>(e[e.ExpectError=0]="ExpectError",e[e.Ignore=1]="Ignore",e))(BG||{}),VP=class{},Q5=(e=>(e[e.RootFile=0]="RootFile",e[e.SourceFromProjectReference=1]="SourceFromProjectReference",e[e.OutputFromProjectReference=2]="OutputFromProjectReference",e[e.Import=3]="Import",e[e.ReferenceFile=4]="ReferenceFile",e[e.TypeReferenceDirective=5]="TypeReferenceDirective",e[e.LibFile=6]="LibFile",e[e.LibReferenceDirective=7]="LibReferenceDirective",e[e.AutomaticTypeDirectiveFile=8]="AutomaticTypeDirectiveFile",e))(Q5||{}),UG=(e=>(e[e.FilePreprocessingReferencedDiagnostic=0]="FilePreprocessingReferencedDiagnostic",e[e.FilePreprocessingFileExplainingDiagnostic=1]="FilePreprocessingFileExplainingDiagnostic",e[e.ResolutionDiagnostics=2]="ResolutionDiagnostics",e))(UG||{}),VG=(e=>(e[e.Js=0]="Js",e[e.Dts=1]="Dts",e))(VG||{}),Z5=(e=>(e[e.Not=0]="Not",e[e.SafeModules=1]="SafeModules",e[e.Completely=2]="Completely",e))(Z5||{}),JG=(e=>(e[e.Success=0]="Success",e[e.DiagnosticsPresent_OutputsSkipped=1]="DiagnosticsPresent_OutputsSkipped",e[e.DiagnosticsPresent_OutputsGenerated=2]="DiagnosticsPresent_OutputsGenerated",e[e.InvalidProject_OutputsSkipped=3]="InvalidProject_OutputsSkipped",e[e.ProjectReferenceCycle_OutputsSkipped=4]="ProjectReferenceCycle_OutputsSkipped",e))(JG||{}),qG=(e=>(e[e.Ok=0]="Ok",e[e.NeedsOverride=1]="NeedsOverride",e[e.HasInvalidOverride=2]="HasInvalidOverride",e))(qG||{}),zG=(e=>(e[e.None=0]="None",e[e.Literal=1]="Literal",e[e.Subtype=2]="Subtype",e))(zG||{}),$G=(e=>(e[e.None=0]="None",e[e.Signature=1]="Signature",e[e.NoConstraints=2]="NoConstraints",e[e.Completions=4]="Completions",e[e.SkipBindingPatterns=8]="SkipBindingPatterns",e))($G||{}),WG=(e=>(e[e.None=0]="None",e[e.NoTruncation=1]="NoTruncation",e[e.WriteArrayAsGenericType=2]="WriteArrayAsGenericType",e[e.GenerateNamesForShadowedTypeParams=4]="GenerateNamesForShadowedTypeParams",e[e.UseStructuralFallback=8]="UseStructuralFallback",e[e.ForbidIndexedAccessSymbolReferences=16]="ForbidIndexedAccessSymbolReferences",e[e.WriteTypeArgumentsOfSignature=32]="WriteTypeArgumentsOfSignature",e[e.UseFullyQualifiedType=64]="UseFullyQualifiedType",e[e.UseOnlyExternalAliasing=128]="UseOnlyExternalAliasing",e[e.SuppressAnyReturnType=256]="SuppressAnyReturnType",e[e.WriteTypeParametersInQualifiedName=512]="WriteTypeParametersInQualifiedName",e[e.MultilineObjectLiterals=1024]="MultilineObjectLiterals",e[e.WriteClassExpressionAsTypeLiteral=2048]="WriteClassExpressionAsTypeLiteral",e[e.UseTypeOfFunction=4096]="UseTypeOfFunction",e[e.OmitParameterModifiers=8192]="OmitParameterModifiers",e[e.UseAliasDefinedOutsideCurrentScope=16384]="UseAliasDefinedOutsideCurrentScope",e[e.UseSingleQuotesForStringLiteralType=268435456]="UseSingleQuotesForStringLiteralType",e[e.NoTypeReduction=536870912]="NoTypeReduction",e[e.OmitThisParameter=33554432]="OmitThisParameter",e[e.AllowThisInObjectLiteral=32768]="AllowThisInObjectLiteral",e[e.AllowQualifiedNameInPlaceOfIdentifier=65536]="AllowQualifiedNameInPlaceOfIdentifier",e[e.AllowAnonymousIdentifier=131072]="AllowAnonymousIdentifier",e[e.AllowEmptyUnionOrIntersection=262144]="AllowEmptyUnionOrIntersection",e[e.AllowEmptyTuple=524288]="AllowEmptyTuple",e[e.AllowUniqueESSymbolType=1048576]="AllowUniqueESSymbolType",e[e.AllowEmptyIndexInfoType=2097152]="AllowEmptyIndexInfoType",e[e.WriteComputedProps=1073741824]="WriteComputedProps",e[e.AllowNodeModulesRelativePaths=67108864]="AllowNodeModulesRelativePaths",e[e.DoNotIncludeSymbolChain=134217728]="DoNotIncludeSymbolChain",e[e.IgnoreErrors=70221824]="IgnoreErrors",e[e.InObjectTypeLiteral=4194304]="InObjectTypeLiteral",e[e.InTypeAlias=8388608]="InTypeAlias",e[e.InInitialEntityName=16777216]="InInitialEntityName",e))(WG||{}),GG=(e=>(e[e.None=0]="None",e[e.NoTruncation=1]="NoTruncation",e[e.WriteArrayAsGenericType=2]="WriteArrayAsGenericType",e[e.GenerateNamesForShadowedTypeParams=4]="GenerateNamesForShadowedTypeParams",e[e.UseStructuralFallback=8]="UseStructuralFallback",e[e.WriteTypeArgumentsOfSignature=32]="WriteTypeArgumentsOfSignature",e[e.UseFullyQualifiedType=64]="UseFullyQualifiedType",e[e.SuppressAnyReturnType=256]="SuppressAnyReturnType",e[e.MultilineObjectLiterals=1024]="MultilineObjectLiterals",e[e.WriteClassExpressionAsTypeLiteral=2048]="WriteClassExpressionAsTypeLiteral",e[e.UseTypeOfFunction=4096]="UseTypeOfFunction",e[e.OmitParameterModifiers=8192]="OmitParameterModifiers",e[e.UseAliasDefinedOutsideCurrentScope=16384]="UseAliasDefinedOutsideCurrentScope",e[e.UseSingleQuotesForStringLiteralType=268435456]="UseSingleQuotesForStringLiteralType",e[e.NoTypeReduction=536870912]="NoTypeReduction",e[e.OmitThisParameter=33554432]="OmitThisParameter",e[e.AllowUniqueESSymbolType=1048576]="AllowUniqueESSymbolType",e[e.AddUndefined=131072]="AddUndefined",e[e.WriteArrowStyleSignature=262144]="WriteArrowStyleSignature",e[e.InArrayType=524288]="InArrayType",e[e.InElementType=2097152]="InElementType",e[e.InFirstTypeArgument=4194304]="InFirstTypeArgument",e[e.InTypeAlias=8388608]="InTypeAlias",e[e.NodeBuilderFlagsMask=848330095]="NodeBuilderFlagsMask",e))(GG||{}),HG=(e=>(e[e.None=0]="None",e[e.WriteTypeParametersOrArguments=1]="WriteTypeParametersOrArguments",e[e.UseOnlyExternalAliasing=2]="UseOnlyExternalAliasing",e[e.AllowAnyNodeKind=4]="AllowAnyNodeKind",e[e.UseAliasDefinedOutsideCurrentScope=8]="UseAliasDefinedOutsideCurrentScope",e[e.WriteComputedProps=16]="WriteComputedProps",e[e.DoNotIncludeSymbolChain=32]="DoNotIncludeSymbolChain",e))(HG||{}),YG=(e=>(e[e.Accessible=0]="Accessible",e[e.NotAccessible=1]="NotAccessible",e[e.CannotBeNamed=2]="CannotBeNamed",e))(YG||{}),XG=(e=>(e[e.UnionOrIntersection=0]="UnionOrIntersection",e[e.Spread=1]="Spread",e))(XG||{}),KG=(e=>(e[e.This=0]="This",e[e.Identifier=1]="Identifier",e[e.AssertsThis=2]="AssertsThis",e[e.AssertsIdentifier=3]="AssertsIdentifier",e))(KG||{}),QG=(e=>(e[e.Unknown=0]="Unknown",e[e.TypeWithConstructSignatureAndValue=1]="TypeWithConstructSignatureAndValue",e[e.VoidNullableOrNeverType=2]="VoidNullableOrNeverType",e[e.NumberLikeType=3]="NumberLikeType",e[e.BigIntLikeType=4]="BigIntLikeType",e[e.StringLikeType=5]="StringLikeType",e[e.BooleanType=6]="BooleanType",e[e.ArrayLikeType=7]="ArrayLikeType",e[e.ESSymbolType=8]="ESSymbolType",e[e.Promise=9]="Promise",e[e.TypeWithCallSignature=10]="TypeWithCallSignature",e[e.ObjectType=11]="ObjectType",e))(QG||{}),e9=(e=>(e[e.None=0]="None",e[e.FunctionScopedVariable=1]="FunctionScopedVariable",e[e.BlockScopedVariable=2]="BlockScopedVariable",e[e.Property=4]="Property",e[e.EnumMember=8]="EnumMember",e[e.Function=16]="Function",e[e.Class=32]="Class",e[e.Interface=64]="Interface",e[e.ConstEnum=128]="ConstEnum",e[e.RegularEnum=256]="RegularEnum",e[e.ValueModule=512]="ValueModule",e[e.NamespaceModule=1024]="NamespaceModule",e[e.TypeLiteral=2048]="TypeLiteral",e[e.ObjectLiteral=4096]="ObjectLiteral",e[e.Method=8192]="Method",e[e.Constructor=16384]="Constructor",e[e.GetAccessor=32768]="GetAccessor",e[e.SetAccessor=65536]="SetAccessor",e[e.Signature=131072]="Signature",e[e.TypeParameter=262144]="TypeParameter",e[e.TypeAlias=524288]="TypeAlias",e[e.ExportValue=1048576]="ExportValue",e[e.Alias=2097152]="Alias",e[e.Prototype=4194304]="Prototype",e[e.ExportStar=8388608]="ExportStar",e[e.Optional=16777216]="Optional",e[e.Transient=33554432]="Transient",e[e.Assignment=67108864]="Assignment",e[e.ModuleExports=134217728]="ModuleExports",e[e.All=-1]="All",e[e.Enum=384]="Enum",e[e.Variable=3]="Variable",e[e.Value=111551]="Value",e[e.Type=788968]="Type",e[e.Namespace=1920]="Namespace",e[e.Module=1536]="Module",e[e.Accessor=98304]="Accessor",e[e.FunctionScopedVariableExcludes=111550]="FunctionScopedVariableExcludes",e[e.BlockScopedVariableExcludes=111551]="BlockScopedVariableExcludes",e[e.ParameterExcludes=111551]="ParameterExcludes",e[e.PropertyExcludes=0]="PropertyExcludes",e[e.EnumMemberExcludes=900095]="EnumMemberExcludes",e[e.FunctionExcludes=110991]="FunctionExcludes",e[e.ClassExcludes=899503]="ClassExcludes",e[e.InterfaceExcludes=788872]="InterfaceExcludes",e[e.RegularEnumExcludes=899327]="RegularEnumExcludes",e[e.ConstEnumExcludes=899967]="ConstEnumExcludes",e[e.ValueModuleExcludes=110735]="ValueModuleExcludes",e[e.NamespaceModuleExcludes=0]="NamespaceModuleExcludes",e[e.MethodExcludes=103359]="MethodExcludes",e[e.GetAccessorExcludes=46015]="GetAccessorExcludes",e[e.SetAccessorExcludes=78783]="SetAccessorExcludes",e[e.AccessorExcludes=13247]="AccessorExcludes",e[e.TypeParameterExcludes=526824]="TypeParameterExcludes",e[e.TypeAliasExcludes=788968]="TypeAliasExcludes",e[e.AliasExcludes=2097152]="AliasExcludes",e[e.ModuleMember=2623475]="ModuleMember",e[e.ExportHasLocal=944]="ExportHasLocal",e[e.BlockScoped=418]="BlockScoped",e[e.PropertyOrAccessor=98308]="PropertyOrAccessor",e[e.ClassMember=106500]="ClassMember",e[e.ExportSupportsDefaultModifier=112]="ExportSupportsDefaultModifier",e[e.ExportDoesNotSupportDefaultModifier=-113]="ExportDoesNotSupportDefaultModifier",e[e.Classifiable=2885600]="Classifiable",e[e.LateBindingContainer=6256]="LateBindingContainer",e))(e9||{}),ZG=(e=>(e[e.Numeric=0]="Numeric",e[e.Literal=1]="Literal",e))(ZG||{}),eH=(e=>(e[e.None=0]="None",e[e.Instantiated=1]="Instantiated",e[e.SyntheticProperty=2]="SyntheticProperty",e[e.SyntheticMethod=4]="SyntheticMethod",e[e.Readonly=8]="Readonly",e[e.ReadPartial=16]="ReadPartial",e[e.WritePartial=32]="WritePartial",e[e.HasNonUniformType=64]="HasNonUniformType",e[e.HasLiteralType=128]="HasLiteralType",e[e.ContainsPublic=256]="ContainsPublic",e[e.ContainsProtected=512]="ContainsProtected",e[e.ContainsPrivate=1024]="ContainsPrivate",e[e.ContainsStatic=2048]="ContainsStatic",e[e.Late=4096]="Late",e[e.ReverseMapped=8192]="ReverseMapped",e[e.OptionalParameter=16384]="OptionalParameter",e[e.RestParameter=32768]="RestParameter",e[e.DeferredType=65536]="DeferredType",e[e.HasNeverType=131072]="HasNeverType",e[e.Mapped=262144]="Mapped",e[e.StripOptional=524288]="StripOptional",e[e.Unresolved=1048576]="Unresolved",e[e.Synthetic=6]="Synthetic",e[e.Discriminant=192]="Discriminant",e[e.Partial=48]="Partial",e))(eH||{}),tH=(e=>(e.Call="__call",e.Constructor="__constructor",e.New="__new",e.Index="__index",e.ExportStar="__export",e.Global="__global",e.Missing="__missing",e.Type="__type",e.Object="__object",e.JSXAttributes="__jsxAttributes",e.Class="__class",e.Function="__function",e.Computed="__computed",e.Resolving="__resolving__",e.ExportEquals="export=",e.Default="default",e.This="this",e.InstantiationExpression="__instantiationExpression",e.ImportAttributes="__importAttributes",e))(tH||{}),rH=(e=>(e[e.None=0]="None",e[e.TypeChecked=1]="TypeChecked",e[e.LexicalThis=2]="LexicalThis",e[e.CaptureThis=4]="CaptureThis",e[e.CaptureNewTarget=8]="CaptureNewTarget",e[e.SuperInstance=16]="SuperInstance",e[e.SuperStatic=32]="SuperStatic",e[e.ContextChecked=64]="ContextChecked",e[e.MethodWithSuperPropertyAccessInAsync=128]="MethodWithSuperPropertyAccessInAsync",e[e.MethodWithSuperPropertyAssignmentInAsync=256]="MethodWithSuperPropertyAssignmentInAsync",e[e.CaptureArguments=512]="CaptureArguments",e[e.EnumValuesComputed=1024]="EnumValuesComputed",e[e.LexicalModuleMergesWithClass=2048]="LexicalModuleMergesWithClass",e[e.LoopWithCapturedBlockScopedBinding=4096]="LoopWithCapturedBlockScopedBinding",e[e.ContainsCapturedBlockScopeBinding=8192]="ContainsCapturedBlockScopeBinding",e[e.CapturedBlockScopedBinding=16384]="CapturedBlockScopedBinding",e[e.BlockScopedBindingInLoop=32768]="BlockScopedBindingInLoop",e[e.NeedsLoopOutParameter=65536]="NeedsLoopOutParameter",e[e.AssignmentsMarked=131072]="AssignmentsMarked",e[e.ContainsConstructorReference=262144]="ContainsConstructorReference",e[e.ConstructorReference=536870912]="ConstructorReference",e[e.ContainsClassWithPrivateIdentifiers=1048576]="ContainsClassWithPrivateIdentifiers",e[e.ContainsSuperPropertyInStaticInitializer=2097152]="ContainsSuperPropertyInStaticInitializer",e[e.InCheckIdentifier=4194304]="InCheckIdentifier",e))(rH||{}),t9=(e=>(e[e.Any=1]="Any",e[e.Unknown=2]="Unknown",e[e.String=4]="String",e[e.Number=8]="Number",e[e.Boolean=16]="Boolean",e[e.Enum=32]="Enum",e[e.BigInt=64]="BigInt",e[e.StringLiteral=128]="StringLiteral",e[e.NumberLiteral=256]="NumberLiteral",e[e.BooleanLiteral=512]="BooleanLiteral",e[e.EnumLiteral=1024]="EnumLiteral",e[e.BigIntLiteral=2048]="BigIntLiteral",e[e.ESSymbol=4096]="ESSymbol",e[e.UniqueESSymbol=8192]="UniqueESSymbol",e[e.Void=16384]="Void",e[e.Undefined=32768]="Undefined",e[e.Null=65536]="Null",e[e.Never=131072]="Never",e[e.TypeParameter=262144]="TypeParameter",e[e.Object=524288]="Object",e[e.Union=1048576]="Union",e[e.Intersection=2097152]="Intersection",e[e.Index=4194304]="Index",e[e.IndexedAccess=8388608]="IndexedAccess",e[e.Conditional=16777216]="Conditional",e[e.Substitution=33554432]="Substitution",e[e.NonPrimitive=67108864]="NonPrimitive",e[e.TemplateLiteral=134217728]="TemplateLiteral",e[e.StringMapping=268435456]="StringMapping",e[e.Reserved1=536870912]="Reserved1",e[e.AnyOrUnknown=3]="AnyOrUnknown",e[e.Nullable=98304]="Nullable",e[e.Literal=2944]="Literal",e[e.Unit=109472]="Unit",e[e.Freshable=2976]="Freshable",e[e.StringOrNumberLiteral=384]="StringOrNumberLiteral",e[e.StringOrNumberLiteralOrUnique=8576]="StringOrNumberLiteralOrUnique",e[e.DefinitelyFalsy=117632]="DefinitelyFalsy",e[e.PossiblyFalsy=117724]="PossiblyFalsy",e[e.Intrinsic=67359327]="Intrinsic",e[e.StringLike=402653316]="StringLike",e[e.NumberLike=296]="NumberLike",e[e.BigIntLike=2112]="BigIntLike",e[e.BooleanLike=528]="BooleanLike",e[e.EnumLike=1056]="EnumLike",e[e.ESSymbolLike=12288]="ESSymbolLike",e[e.VoidLike=49152]="VoidLike",e[e.Primitive=402784252]="Primitive",e[e.DefinitelyNonNullable=470302716]="DefinitelyNonNullable",e[e.DisjointDomains=469892092]="DisjointDomains",e[e.UnionOrIntersection=3145728]="UnionOrIntersection",e[e.StructuredType=3670016]="StructuredType",e[e.TypeVariable=8650752]="TypeVariable",e[e.InstantiableNonPrimitive=58982400]="InstantiableNonPrimitive",e[e.InstantiablePrimitive=406847488]="InstantiablePrimitive",e[e.Instantiable=465829888]="Instantiable",e[e.StructuredOrInstantiable=469499904]="StructuredOrInstantiable",e[e.ObjectFlagsType=3899393]="ObjectFlagsType",e[e.Simplifiable=25165824]="Simplifiable",e[e.Singleton=67358815]="Singleton",e[e.Narrowable=536624127]="Narrowable",e[e.IncludesMask=473694207]="IncludesMask",e[e.IncludesMissingType=262144]="IncludesMissingType",e[e.IncludesNonWideningType=4194304]="IncludesNonWideningType",e[e.IncludesWildcard=8388608]="IncludesWildcard",e[e.IncludesEmptyObject=16777216]="IncludesEmptyObject",e[e.IncludesInstantiable=33554432]="IncludesInstantiable",e[e.IncludesConstrainedTypeVariable=536870912]="IncludesConstrainedTypeVariable",e[e.NotPrimitiveUnion=36323331]="NotPrimitiveUnion",e))(t9||{}),r9=(e=>(e[e.None=0]="None",e[e.Class=1]="Class",e[e.Interface=2]="Interface",e[e.Reference=4]="Reference",e[e.Tuple=8]="Tuple",e[e.Anonymous=16]="Anonymous",e[e.Mapped=32]="Mapped",e[e.Instantiated=64]="Instantiated",e[e.ObjectLiteral=128]="ObjectLiteral",e[e.EvolvingArray=256]="EvolvingArray",e[e.ObjectLiteralPatternWithComputedProperties=512]="ObjectLiteralPatternWithComputedProperties",e[e.ReverseMapped=1024]="ReverseMapped",e[e.JsxAttributes=2048]="JsxAttributes",e[e.JSLiteral=4096]="JSLiteral",e[e.FreshLiteral=8192]="FreshLiteral",e[e.ArrayLiteral=16384]="ArrayLiteral",e[e.PrimitiveUnion=32768]="PrimitiveUnion",e[e.ContainsWideningType=65536]="ContainsWideningType",e[e.ContainsObjectOrArrayLiteral=131072]="ContainsObjectOrArrayLiteral",e[e.NonInferrableType=262144]="NonInferrableType",e[e.CouldContainTypeVariablesComputed=524288]="CouldContainTypeVariablesComputed",e[e.CouldContainTypeVariables=1048576]="CouldContainTypeVariables",e[e.ClassOrInterface=3]="ClassOrInterface",e[e.RequiresWidening=196608]="RequiresWidening",e[e.PropagatingFlags=458752]="PropagatingFlags",e[e.InstantiatedMapped=96]="InstantiatedMapped",e[e.ObjectTypeKindMask=1343]="ObjectTypeKindMask",e[e.ContainsSpread=2097152]="ContainsSpread",e[e.ObjectRestType=4194304]="ObjectRestType",e[e.InstantiationExpressionType=8388608]="InstantiationExpressionType",e[e.IsClassInstanceClone=16777216]="IsClassInstanceClone",e[e.IdenticalBaseTypeCalculated=33554432]="IdenticalBaseTypeCalculated",e[e.IdenticalBaseTypeExists=67108864]="IdenticalBaseTypeExists",e[e.IsGenericTypeComputed=2097152]="IsGenericTypeComputed",e[e.IsGenericObjectType=4194304]="IsGenericObjectType",e[e.IsGenericIndexType=8388608]="IsGenericIndexType",e[e.IsGenericType=12582912]="IsGenericType",e[e.ContainsIntersections=16777216]="ContainsIntersections",e[e.IsUnknownLikeUnionComputed=33554432]="IsUnknownLikeUnionComputed",e[e.IsUnknownLikeUnion=67108864]="IsUnknownLikeUnion",e[e.IsNeverIntersectionComputed=16777216]="IsNeverIntersectionComputed",e[e.IsNeverIntersection=33554432]="IsNeverIntersection",e[e.IsConstrainedTypeVariable=67108864]="IsConstrainedTypeVariable",e))(r9||{}),nH=(e=>(e[e.Invariant=0]="Invariant",e[e.Covariant=1]="Covariant",e[e.Contravariant=2]="Contravariant",e[e.Bivariant=3]="Bivariant",e[e.Independent=4]="Independent",e[e.VarianceMask=7]="VarianceMask",e[e.Unmeasurable=8]="Unmeasurable",e[e.Unreliable=16]="Unreliable",e[e.AllowsStructuralFallback=24]="AllowsStructuralFallback",e))(nH||{}),iH=(e=>(e[e.Required=1]="Required",e[e.Optional=2]="Optional",e[e.Rest=4]="Rest",e[e.Variadic=8]="Variadic",e[e.Fixed=3]="Fixed",e[e.Variable=12]="Variable",e[e.NonRequired=14]="NonRequired",e[e.NonRest=11]="NonRest",e))(iH||{}),sH=(e=>(e[e.None=0]="None",e[e.IncludeUndefined=1]="IncludeUndefined",e[e.NoIndexSignatures=2]="NoIndexSignatures",e[e.Writing=4]="Writing",e[e.CacheSymbol=8]="CacheSymbol",e[e.NoTupleBoundsCheck=16]="NoTupleBoundsCheck",e[e.ExpressionPosition=32]="ExpressionPosition",e[e.ReportDeprecated=64]="ReportDeprecated",e[e.SuppressNoImplicitAnyError=128]="SuppressNoImplicitAnyError",e[e.Contextual=256]="Contextual",e[e.Persistent=1]="Persistent",e))(sH||{}),aH=(e=>(e[e.None=0]="None",e[e.StringsOnly=1]="StringsOnly",e[e.NoIndexSignatures=2]="NoIndexSignatures",e[e.NoReducibleCheck=4]="NoReducibleCheck",e))(aH||{}),oH=(e=>(e[e.Component=0]="Component",e[e.Function=1]="Function",e[e.Mixed=2]="Mixed",e))(oH||{}),cH=(e=>(e[e.Call=0]="Call",e[e.Construct=1]="Construct",e))(cH||{}),n9=(e=>(e[e.None=0]="None",e[e.HasRestParameter=1]="HasRestParameter",e[e.HasLiteralTypes=2]="HasLiteralTypes",e[e.Abstract=4]="Abstract",e[e.IsInnerCallChain=8]="IsInnerCallChain",e[e.IsOuterCallChain=16]="IsOuterCallChain",e[e.IsUntypedSignatureInJSFile=32]="IsUntypedSignatureInJSFile",e[e.IsNonInferrable=64]="IsNonInferrable",e[e.IsSignatureCandidateForOverloadFailure=128]="IsSignatureCandidateForOverloadFailure",e[e.PropagatingFlags=167]="PropagatingFlags",e[e.CallChainFlags=24]="CallChainFlags",e))(n9||{}),lH=(e=>(e[e.String=0]="String",e[e.Number=1]="Number",e))(lH||{}),uH=(e=>(e[e.Simple=0]="Simple",e[e.Array=1]="Array",e[e.Deferred=2]="Deferred",e[e.Function=3]="Function",e[e.Composite=4]="Composite",e[e.Merged=5]="Merged",e))(uH||{}),_H=(e=>(e[e.None=0]="None",e[e.NakedTypeVariable=1]="NakedTypeVariable",e[e.SpeculativeTuple=2]="SpeculativeTuple",e[e.SubstituteSource=4]="SubstituteSource",e[e.HomomorphicMappedType=8]="HomomorphicMappedType",e[e.PartialHomomorphicMappedType=16]="PartialHomomorphicMappedType",e[e.MappedTypeConstraint=32]="MappedTypeConstraint",e[e.ContravariantConditional=64]="ContravariantConditional",e[e.ReturnType=128]="ReturnType",e[e.LiteralKeyof=256]="LiteralKeyof",e[e.NoConstraints=512]="NoConstraints",e[e.AlwaysStrict=1024]="AlwaysStrict",e[e.MaxValue=2048]="MaxValue",e[e.PriorityImpliesCombination=416]="PriorityImpliesCombination",e[e.Circularity=-1]="Circularity",e))(_H||{}),fH=(e=>(e[e.None=0]="None",e[e.NoDefault=1]="NoDefault",e[e.AnyDefault=2]="AnyDefault",e[e.SkippedGenericFunction=4]="SkippedGenericFunction",e))(fH||{}),pH=(e=>(e[e.False=0]="False",e[e.Unknown=1]="Unknown",e[e.Maybe=3]="Maybe",e[e.True=-1]="True",e))(pH||{}),dH=(e=>(e[e.None=0]="None",e[e.ExportsProperty=1]="ExportsProperty",e[e.ModuleExports=2]="ModuleExports",e[e.PrototypeProperty=3]="PrototypeProperty",e[e.ThisProperty=4]="ThisProperty",e[e.Property=5]="Property",e[e.Prototype=6]="Prototype",e[e.ObjectDefinePropertyValue=7]="ObjectDefinePropertyValue",e[e.ObjectDefinePropertyExports=8]="ObjectDefinePropertyExports",e[e.ObjectDefinePrototypeProperty=9]="ObjectDefinePrototypeProperty",e))(dH||{}),I3=(e=>(e[e.Warning=0]="Warning",e[e.Error=1]="Error",e[e.Suggestion=2]="Suggestion",e[e.Message=3]="Message",e))(I3||{}),JP=(e=>(e[e.Classic=1]="Classic",e[e.NodeJs=2]="NodeJs",e[e.Node10=2]="Node10",e[e.Node16=3]="Node16",e[e.NodeNext=99]="NodeNext",e[e.Bundler=100]="Bundler",e))(JP||{}),mH=(e=>(e[e.Legacy=1]="Legacy",e[e.Auto=2]="Auto",e[e.Force=3]="Force",e))(mH||{}),gH=(e=>(e[e.FixedPollingInterval=0]="FixedPollingInterval",e[e.PriorityPollingInterval=1]="PriorityPollingInterval",e[e.DynamicPriorityPolling=2]="DynamicPriorityPolling",e[e.FixedChunkSizePolling=3]="FixedChunkSizePolling",e[e.UseFsEvents=4]="UseFsEvents",e[e.UseFsEventsOnParentDirectory=5]="UseFsEventsOnParentDirectory",e))(gH||{}),hH=(e=>(e[e.UseFsEvents=0]="UseFsEvents",e[e.FixedPollingInterval=1]="FixedPollingInterval",e[e.DynamicPriorityPolling=2]="DynamicPriorityPolling",e[e.FixedChunkSizePolling=3]="FixedChunkSizePolling",e))(hH||{}),yH=(e=>(e[e.FixedInterval=0]="FixedInterval",e[e.PriorityInterval=1]="PriorityInterval",e[e.DynamicPriority=2]="DynamicPriority",e[e.FixedChunkSize=3]="FixedChunkSize",e))(yH||{}),vw=(e=>(e[e.None=0]="None",e[e.CommonJS=1]="CommonJS",e[e.AMD=2]="AMD",e[e.UMD=3]="UMD",e[e.System=4]="System",e[e.ES2015=5]="ES2015",e[e.ES2020=6]="ES2020",e[e.ES2022=7]="ES2022",e[e.ESNext=99]="ESNext",e[e.Node16=100]="Node16",e[e.NodeNext=199]="NodeNext",e[e.Preserve=200]="Preserve",e))(vw||{}),vH=(e=>(e[e.None=0]="None",e[e.Preserve=1]="Preserve",e[e.React=2]="React",e[e.ReactNative=3]="ReactNative",e[e.ReactJSX=4]="ReactJSX",e[e.ReactJSXDev=5]="ReactJSXDev",e))(vH||{}),SH=(e=>(e[e.Remove=0]="Remove",e[e.Preserve=1]="Preserve",e[e.Error=2]="Error",e))(SH||{}),TH=(e=>(e[e.CarriageReturnLineFeed=0]="CarriageReturnLineFeed",e[e.LineFeed=1]="LineFeed",e))(TH||{}),i9=(e=>(e[e.Unknown=0]="Unknown",e[e.JS=1]="JS",e[e.JSX=2]="JSX",e[e.TS=3]="TS",e[e.TSX=4]="TSX",e[e.External=5]="External",e[e.JSON=6]="JSON",e[e.Deferred=7]="Deferred",e))(i9||{}),bH=(e=>(e[e.ES3=0]="ES3",e[e.ES5=1]="ES5",e[e.ES2015=2]="ES2015",e[e.ES2016=3]="ES2016",e[e.ES2017=4]="ES2017",e[e.ES2018=5]="ES2018",e[e.ES2019=6]="ES2019",e[e.ES2020=7]="ES2020",e[e.ES2021=8]="ES2021",e[e.ES2022=9]="ES2022",e[e.ESNext=99]="ESNext",e[e.JSON=100]="JSON",e[e.Latest=99]="Latest",e))(bH||{}),EH=(e=>(e[e.Standard=0]="Standard",e[e.JSX=1]="JSX",e))(EH||{}),xH=(e=>(e[e.None=0]="None",e[e.Recursive=1]="Recursive",e))(xH||{}),CH=(e=>(e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.backtick=96]="backtick",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.hash=35]="hash",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab",e))(CH||{}),AH=(e=>(e.Ts=".ts",e.Tsx=".tsx",e.Dts=".d.ts",e.Js=".js",e.Jsx=".jsx",e.Json=".json",e.TsBuildInfo=".tsbuildinfo",e.Mjs=".mjs",e.Mts=".mts",e.Dmts=".d.mts",e.Cjs=".cjs",e.Cts=".cts",e.Dcts=".d.cts",e))(AH||{}),s9=(e=>(e[e.None=0]="None",e[e.ContainsTypeScript=1]="ContainsTypeScript",e[e.ContainsJsx=2]="ContainsJsx",e[e.ContainsESNext=4]="ContainsESNext",e[e.ContainsES2022=8]="ContainsES2022",e[e.ContainsES2021=16]="ContainsES2021",e[e.ContainsES2020=32]="ContainsES2020",e[e.ContainsES2019=64]="ContainsES2019",e[e.ContainsES2018=128]="ContainsES2018",e[e.ContainsES2017=256]="ContainsES2017",e[e.ContainsES2016=512]="ContainsES2016",e[e.ContainsES2015=1024]="ContainsES2015",e[e.ContainsGenerator=2048]="ContainsGenerator",e[e.ContainsDestructuringAssignment=4096]="ContainsDestructuringAssignment",e[e.ContainsTypeScriptClassSyntax=8192]="ContainsTypeScriptClassSyntax",e[e.ContainsLexicalThis=16384]="ContainsLexicalThis",e[e.ContainsRestOrSpread=32768]="ContainsRestOrSpread",e[e.ContainsObjectRestOrSpread=65536]="ContainsObjectRestOrSpread",e[e.ContainsComputedPropertyName=131072]="ContainsComputedPropertyName",e[e.ContainsBlockScopedBinding=262144]="ContainsBlockScopedBinding",e[e.ContainsBindingPattern=524288]="ContainsBindingPattern",e[e.ContainsYield=1048576]="ContainsYield",e[e.ContainsAwait=2097152]="ContainsAwait",e[e.ContainsHoistedDeclarationOrCompletion=4194304]="ContainsHoistedDeclarationOrCompletion",e[e.ContainsDynamicImport=8388608]="ContainsDynamicImport",e[e.ContainsClassFields=16777216]="ContainsClassFields",e[e.ContainsDecorators=33554432]="ContainsDecorators",e[e.ContainsPossibleTopLevelAwait=67108864]="ContainsPossibleTopLevelAwait",e[e.ContainsLexicalSuper=134217728]="ContainsLexicalSuper",e[e.ContainsUpdateExpressionForIdentifier=268435456]="ContainsUpdateExpressionForIdentifier",e[e.ContainsPrivateIdentifierInExpression=536870912]="ContainsPrivateIdentifierInExpression",e[e.HasComputedFlags=-2147483648]="HasComputedFlags",e[e.AssertTypeScript=1]="AssertTypeScript",e[e.AssertJsx=2]="AssertJsx",e[e.AssertESNext=4]="AssertESNext",e[e.AssertES2022=8]="AssertES2022",e[e.AssertES2021=16]="AssertES2021",e[e.AssertES2020=32]="AssertES2020",e[e.AssertES2019=64]="AssertES2019",e[e.AssertES2018=128]="AssertES2018",e[e.AssertES2017=256]="AssertES2017",e[e.AssertES2016=512]="AssertES2016",e[e.AssertES2015=1024]="AssertES2015",e[e.AssertGenerator=2048]="AssertGenerator",e[e.AssertDestructuringAssignment=4096]="AssertDestructuringAssignment",e[e.OuterExpressionExcludes=-2147483648]="OuterExpressionExcludes",e[e.PropertyAccessExcludes=-2147483648]="PropertyAccessExcludes",e[e.NodeExcludes=-2147483648]="NodeExcludes",e[e.ArrowFunctionExcludes=-2072174592]="ArrowFunctionExcludes",e[e.FunctionExcludes=-1937940480]="FunctionExcludes",e[e.ConstructorExcludes=-1937948672]="ConstructorExcludes",e[e.MethodOrAccessorExcludes=-2005057536]="MethodOrAccessorExcludes",e[e.PropertyExcludes=-2013249536]="PropertyExcludes",e[e.ClassExcludes=-2147344384]="ClassExcludes",e[e.ModuleExcludes=-1941676032]="ModuleExcludes",e[e.TypeExcludes=-2]="TypeExcludes",e[e.ObjectLiteralExcludes=-2147278848]="ObjectLiteralExcludes",e[e.ArrayLiteralOrCallOrNewExcludes=-2147450880]="ArrayLiteralOrCallOrNewExcludes",e[e.VariableDeclarationListExcludes=-2146893824]="VariableDeclarationListExcludes",e[e.ParameterExcludes=-2147483648]="ParameterExcludes",e[e.CatchClauseExcludes=-2147418112]="CatchClauseExcludes",e[e.BindingPatternExcludes=-2147450880]="BindingPatternExcludes",e[e.ContainsLexicalThisOrSuper=134234112]="ContainsLexicalThisOrSuper",e[e.PropertyNamePropagatingFlags=134234112]="PropertyNamePropagatingFlags",e))(s9||{}),a9=(e=>(e[e.TabStop=0]="TabStop",e[e.Placeholder=1]="Placeholder",e[e.Choice=2]="Choice",e[e.Variable=3]="Variable",e))(a9||{}),o9=(e=>(e[e.None=0]="None",e[e.SingleLine=1]="SingleLine",e[e.MultiLine=2]="MultiLine",e[e.AdviseOnEmitNode=4]="AdviseOnEmitNode",e[e.NoSubstitution=8]="NoSubstitution",e[e.CapturesThis=16]="CapturesThis",e[e.NoLeadingSourceMap=32]="NoLeadingSourceMap",e[e.NoTrailingSourceMap=64]="NoTrailingSourceMap",e[e.NoSourceMap=96]="NoSourceMap",e[e.NoNestedSourceMaps=128]="NoNestedSourceMaps",e[e.NoTokenLeadingSourceMaps=256]="NoTokenLeadingSourceMaps",e[e.NoTokenTrailingSourceMaps=512]="NoTokenTrailingSourceMaps",e[e.NoTokenSourceMaps=768]="NoTokenSourceMaps",e[e.NoLeadingComments=1024]="NoLeadingComments",e[e.NoTrailingComments=2048]="NoTrailingComments",e[e.NoComments=3072]="NoComments",e[e.NoNestedComments=4096]="NoNestedComments",e[e.HelperName=8192]="HelperName",e[e.ExportName=16384]="ExportName",e[e.LocalName=32768]="LocalName",e[e.InternalName=65536]="InternalName",e[e.Indented=131072]="Indented",e[e.NoIndentation=262144]="NoIndentation",e[e.AsyncFunctionBody=524288]="AsyncFunctionBody",e[e.ReuseTempVariableScope=1048576]="ReuseTempVariableScope",e[e.CustomPrologue=2097152]="CustomPrologue",e[e.NoHoisting=4194304]="NoHoisting",e[e.Iterator=8388608]="Iterator",e[e.NoAsciiEscaping=16777216]="NoAsciiEscaping",e))(o9||{}),kH=(e=>(e[e.None=0]="None",e[e.TypeScriptClassWrapper=1]="TypeScriptClassWrapper",e[e.NeverApplyImportHelper=2]="NeverApplyImportHelper",e[e.IgnoreSourceNewlines=4]="IgnoreSourceNewlines",e[e.Immutable=8]="Immutable",e[e.IndirectCall=16]="IndirectCall",e[e.TransformPrivateStaticElements=32]="TransformPrivateStaticElements",e))(kH||{}),PH=(e=>(e[e.Extends=1]="Extends",e[e.Assign=2]="Assign",e[e.Rest=4]="Rest",e[e.Decorate=8]="Decorate",e[e.ESDecorateAndRunInitializers=8]="ESDecorateAndRunInitializers",e[e.Metadata=16]="Metadata",e[e.Param=32]="Param",e[e.Awaiter=64]="Awaiter",e[e.Generator=128]="Generator",e[e.Values=256]="Values",e[e.Read=512]="Read",e[e.SpreadArray=1024]="SpreadArray",e[e.Await=2048]="Await",e[e.AsyncGenerator=4096]="AsyncGenerator",e[e.AsyncDelegator=8192]="AsyncDelegator",e[e.AsyncValues=16384]="AsyncValues",e[e.ExportStar=32768]="ExportStar",e[e.ImportStar=65536]="ImportStar",e[e.ImportDefault=131072]="ImportDefault",e[e.MakeTemplateObject=262144]="MakeTemplateObject",e[e.ClassPrivateFieldGet=524288]="ClassPrivateFieldGet",e[e.ClassPrivateFieldSet=1048576]="ClassPrivateFieldSet",e[e.ClassPrivateFieldIn=2097152]="ClassPrivateFieldIn",e[e.CreateBinding=4194304]="CreateBinding",e[e.SetFunctionName=8388608]="SetFunctionName",e[e.PropKey=16777216]="PropKey",e[e.AddDisposableResourceAndDisposeResources=33554432]="AddDisposableResourceAndDisposeResources",e[e.FirstEmitHelper=1]="FirstEmitHelper",e[e.LastEmitHelper=33554432]="LastEmitHelper",e[e.ForOfIncludes=256]="ForOfIncludes",e[e.ForAwaitOfIncludes=16384]="ForAwaitOfIncludes",e[e.AsyncGeneratorIncludes=6144]="AsyncGeneratorIncludes",e[e.AsyncDelegatorIncludes=26624]="AsyncDelegatorIncludes",e[e.SpreadIncludes=1536]="SpreadIncludes",e))(PH||{}),NH=(e=>(e[e.SourceFile=0]="SourceFile",e[e.Expression=1]="Expression",e[e.IdentifierName=2]="IdentifierName",e[e.MappedTypeParameter=3]="MappedTypeParameter",e[e.Unspecified=4]="Unspecified",e[e.EmbeddedStatement=5]="EmbeddedStatement",e[e.JsxAttributeValue=6]="JsxAttributeValue",e[e.ImportTypeNodeAttributes=7]="ImportTypeNodeAttributes",e))(NH||{}),DH=(e=>(e[e.Parentheses=1]="Parentheses",e[e.TypeAssertions=2]="TypeAssertions",e[e.NonNullAssertions=4]="NonNullAssertions",e[e.PartiallyEmittedExpressions=8]="PartiallyEmittedExpressions",e[e.Assertions=6]="Assertions",e[e.All=15]="All",e[e.ExcludeJSDocTypeAssertion=16]="ExcludeJSDocTypeAssertion",e))(DH||{}),IH=(e=>(e[e.None=0]="None",e[e.InParameters=1]="InParameters",e[e.VariablesHoistedInParameters=2]="VariablesHoistedInParameters",e))(IH||{}),wH=(e=>(e.Prologue="prologue",e.EmitHelpers="emitHelpers",e.NoDefaultLib="no-default-lib",e.Reference="reference",e.Type="type",e.TypeResolutionModeRequire="type-require",e.TypeResolutionModeImport="type-import",e.Lib="lib",e.Prepend="prepend",e.Text="text",e.Internal="internal",e))(wH||{}),OH=(e=>(e[e.None=0]="None",e[e.SingleLine=0]="SingleLine",e[e.MultiLine=1]="MultiLine",e[e.PreserveLines=2]="PreserveLines",e[e.LinesMask=3]="LinesMask",e[e.NotDelimited=0]="NotDelimited",e[e.BarDelimited=4]="BarDelimited",e[e.AmpersandDelimited=8]="AmpersandDelimited",e[e.CommaDelimited=16]="CommaDelimited",e[e.AsteriskDelimited=32]="AsteriskDelimited",e[e.DelimitersMask=60]="DelimitersMask",e[e.AllowTrailingComma=64]="AllowTrailingComma",e[e.Indented=128]="Indented",e[e.SpaceBetweenBraces=256]="SpaceBetweenBraces",e[e.SpaceBetweenSiblings=512]="SpaceBetweenSiblings",e[e.Braces=1024]="Braces",e[e.Parenthesis=2048]="Parenthesis",e[e.AngleBrackets=4096]="AngleBrackets",e[e.SquareBrackets=8192]="SquareBrackets",e[e.BracketsMask=15360]="BracketsMask",e[e.OptionalIfUndefined=16384]="OptionalIfUndefined",e[e.OptionalIfEmpty=32768]="OptionalIfEmpty",e[e.Optional=49152]="Optional",e[e.PreferNewLine=65536]="PreferNewLine",e[e.NoTrailingNewLine=131072]="NoTrailingNewLine",e[e.NoInterveningComments=262144]="NoInterveningComments",e[e.NoSpaceIfEmpty=524288]="NoSpaceIfEmpty",e[e.SingleElement=1048576]="SingleElement",e[e.SpaceAfterList=2097152]="SpaceAfterList",e[e.Modifiers=2359808]="Modifiers",e[e.HeritageClauses=512]="HeritageClauses",e[e.SingleLineTypeLiteralMembers=768]="SingleLineTypeLiteralMembers",e[e.MultiLineTypeLiteralMembers=32897]="MultiLineTypeLiteralMembers",e[e.SingleLineTupleTypeElements=528]="SingleLineTupleTypeElements",e[e.MultiLineTupleTypeElements=657]="MultiLineTupleTypeElements",e[e.UnionTypeConstituents=516]="UnionTypeConstituents",e[e.IntersectionTypeConstituents=520]="IntersectionTypeConstituents",e[e.ObjectBindingPatternElements=525136]="ObjectBindingPatternElements",e[e.ArrayBindingPatternElements=524880]="ArrayBindingPatternElements",e[e.ObjectLiteralExpressionProperties=526226]="ObjectLiteralExpressionProperties",e[e.ImportAttributes=526226]="ImportAttributes",e[e.ImportClauseEntries=526226]="ImportClauseEntries",e[e.ArrayLiteralExpressionElements=8914]="ArrayLiteralExpressionElements",e[e.CommaListElements=528]="CommaListElements",e[e.CallExpressionArguments=2576]="CallExpressionArguments",e[e.NewExpressionArguments=18960]="NewExpressionArguments",e[e.TemplateExpressionSpans=262144]="TemplateExpressionSpans",e[e.SingleLineBlockStatements=768]="SingleLineBlockStatements",e[e.MultiLineBlockStatements=129]="MultiLineBlockStatements",e[e.VariableDeclarationList=528]="VariableDeclarationList",e[e.SingleLineFunctionBodyStatements=768]="SingleLineFunctionBodyStatements",e[e.MultiLineFunctionBodyStatements=1]="MultiLineFunctionBodyStatements",e[e.ClassHeritageClauses=0]="ClassHeritageClauses",e[e.ClassMembers=129]="ClassMembers",e[e.InterfaceMembers=129]="InterfaceMembers",e[e.EnumMembers=145]="EnumMembers",e[e.CaseBlockClauses=129]="CaseBlockClauses",e[e.NamedImportsOrExportsElements=525136]="NamedImportsOrExportsElements",e[e.JsxElementOrFragmentChildren=262144]="JsxElementOrFragmentChildren",e[e.JsxElementAttributes=262656]="JsxElementAttributes",e[e.CaseOrDefaultClauseStatements=163969]="CaseOrDefaultClauseStatements",e[e.HeritageClauseTypes=528]="HeritageClauseTypes",e[e.SourceFileStatements=131073]="SourceFileStatements",e[e.Decorators=2146305]="Decorators",e[e.TypeArguments=53776]="TypeArguments",e[e.TypeParameters=53776]="TypeParameters",e[e.Parameters=2576]="Parameters",e[e.IndexSignatureParameters=8848]="IndexSignatureParameters",e[e.JSDocComment=33]="JSDocComment",e))(OH||{}),RH=(e=>(e[e.None=0]="None",e[e.TripleSlashXML=1]="TripleSlashXML",e[e.SingleLine=2]="SingleLine",e[e.MultiLine=4]="MultiLine",e[e.All=7]="All",e[e.Default=7]="Default",e))(RH||{}),w3={reference:{args:[{name:"types",optional:!0,captureSpan:!0},{name:"lib",optional:!0,captureSpan:!0},{name:"path",optional:!0,captureSpan:!0},{name:"no-default-lib",optional:!0},{name:"resolution-mode",optional:!0}],kind:1},"amd-dependency":{args:[{name:"path"},{name:"name",optional:!0}],kind:1},"amd-module":{args:[{name:"name"}],kind:1},"ts-check":{kind:2},"ts-nocheck":{kind:2},jsx:{args:[{name:"factory"}],kind:4},jsxfrag:{args:[{name:"factory"}],kind:4},jsximportsource:{args:[{name:"factory"}],kind:4},jsxruntime:{args:[{name:"factory"}],kind:4}},MH=(e=>(e[e.ParseAll=0]="ParseAll",e[e.ParseNone=1]="ParseNone",e[e.ParseForTypeErrors=2]="ParseForTypeErrors",e[e.ParseForTypeInfo=3]="ParseForTypeInfo",e))(MH||{})}});function Sw(e){let t=5381;for(let n=0;n<e.length;n++)t=(t<<5)+t+e.charCodeAt(n);return t.toString()}function vOe(){Error.stackTraceLimit<100&&(Error.stackTraceLimit=100)}function fA(e,t){return e.getModifiedTime(t)||Lp}function Lfe(e){return{250:e.Low,500:e.Medium,2e3:e.High}}function h0t(e){if(!e.getEnvironmentVariable)return;let t=s("TSC_WATCH_POLLINGINTERVAL",c9);u9=o("TSC_WATCH_POLLINGCHUNKSIZE",l9)||u9,R3=o("TSC_WATCH_UNCHANGEDPOLLTHRESHOLDS",l9)||R3;function n(l,p){return e.getEnvironmentVariable(`${l}_${p.toUpperCase()}`)}function i(l){let p;return m("Low"),m("Medium"),m("High"),p;function m(S){let h=n(l,S);h&&((p||(p={}))[S]=Number(h))}}function s(l,p){let m=i(l);if(m)return S("Low"),S("Medium"),S("High"),!0;return!1;function S(h){p[h]=m[h]||p[h]}}function o(l,p){let m=i(l);return(t||m)&&Lfe(m?{...p,...m}:p)}}function SOe(e,t,n,i,s){let o=n;for(let p=t.length;i&&p;l(),p--){let m=t[n];if(m){if(m.isClosed){t[n]=void 0;continue}}else continue;i--;let S=T0t(m,fA(e,m.fileName));if(m.isClosed){t[n]=void 0;continue}s?.(m,n,S),t[n]&&(o<n&&(t[o]=m,t[n]=void 0),o++)}return n;function l(){n++,n===t.length&&(o<n&&(t.length=o),n=0,o=0)}}function y0t(e){let t=[],n=[],i=p(250),s=p(500),o=p(2e3);return l;function l(O,U,H){let K={fileName:O,callback:U,unchangedPolls:0,mtime:fA(e,O)};return t.push(K),A(K,H),{close:()=>{K.isClosed=!0,uA(t,K)}}}function p(O){let U=[];return U.pollingInterval=O,U.pollIndex=0,U.pollScheduled=!1,U}function m(O,U){U.pollIndex=h(U,U.pollingInterval,U.pollIndex,u9[U.pollingInterval]),U.length?M(U.pollingInterval):(I.assert(U.pollIndex===0),U.pollScheduled=!1)}function S(O,U){h(n,250,0,n.length),m(O,U),!U.pollScheduled&&n.length&&M(250)}function h(O,U,H,K){return SOe(e,O,H,K,re);function re($,pe,z){z?($.unchangedPolls=0,O!==n&&(O[pe]=void 0,k($))):$.unchangedPolls!==R3[U]?$.unchangedPolls++:O===n?($.unchangedPolls=1,O[pe]=void 0,A($,250)):U!==2e3&&($.unchangedPolls++,O[pe]=void 0,A($,U===250?500:2e3))}}function b(O){switch(O){case 250:return i;case 500:return s;case 2e3:return o}}function A(O,U){b(U).push(O),N(U)}function k(O){n.push(O),N(250)}function N(O){b(O).pollScheduled||M(O)}function M(O){b(O).pollScheduled=e.setTimeout(O===250?S:m,O,O===250?"pollLowPollingIntervalQueue":"pollPollingIntervalQueue",b(O))}}function v0t(e,t,n,i){let s=g_(),o=i?new Map:void 0,l=new Map,p=y_(t);return m;function m(h,b,A,k){let N=p(h);s.add(N,b).length===1&&o&&o.set(N,n(h)||Lp);let M=hi(N)||".",O=l.get(M)||S(hi(h)||".",M,k);return O.referenceCount++,{close:()=>{O.referenceCount===1?(O.close(),l.delete(M)):O.referenceCount--,s.remove(N,b)}}}function S(h,b,A){let k=e(h,1,(N,M)=>{if(!vs(M))return;let O=Ps(M,h),U=p(O),H=O&&s.get(U);if(H){let K,re=1;if(o){let $=o.get(U);if(N==="change"&&(K=n(O)||Lp,K.getTime()===$.getTime()))return;K||(K=n(O)||Lp),o.set(U,K),$===Lp?re=0:K===Lp&&(re=2)}for(let $ of H)$(O,re,K)}},!1,500,A);return k.referenceCount=0,l.set(b,k),k}}function S0t(e){let t=[],n=0,i;return s;function s(p,m){let S={fileName:p,callback:m,mtime:fA(e,p)};return t.push(S),l(),{close:()=>{S.isClosed=!0,uA(t,S)}}}function o(){i=void 0,n=SOe(e,t,n,u9[250]),l()}function l(){!t.length||i||(i=e.setTimeout(o,2e3,"pollQueue"))}}function TOe(e,t,n,i,s){let l=y_(t)(n),p=e.get(l);return p?p.callbacks.push(i):e.set(l,{watcher:s((m,S,h)=>{var b;return(b=e.get(l))==null?void 0:b.callbacks.slice().forEach(A=>A(m,S,h))}),callbacks:[i]}),{close:()=>{let m=e.get(l);m&&(!lA(m.callbacks,i)||m.callbacks.length||(e.delete(l),Od(m)))}}}function T0t(e,t){let n=e.mtime.getTime(),i=t.getTime();return n!==i?(e.mtime=t,e.callback(e.fileName,LH(n,i),t),!0):!1}function LH(e,t){return e===0?0:t===0?2:1}function O3(e){return Ufe(e)}function Ffe(e){Ufe=e}function b0t({watchDirectory:e,useCaseSensitiveFileNames:t,getCurrentDirectory:n,getAccessibleSortedChildDirectories:i,fileSystemEntryExists:s,realpath:o,setTimeout:l,clearTimeout:p}){let m=new Map,S=g_(),h=new Map,b,A=gy(!t),k=y_(t);return(z,se,Se,xe)=>Se?N(z,xe,se):e(z,se,Se,xe);function N(z,se,Se){let xe=k(z),Z=m.get(xe);Z?Z.refCount++:(Z={watcher:e(z,ce=>{$(ce,se)||(se?.synchronousWatchDirectory?(M(xe,ce),re(z,xe,se)):O(z,xe,ce,se))},!1,se),refCount:1,childWatches:tt},m.set(xe,Z),re(z,xe,se));let Q=Se&&{dirName:z,callback:Se};return Q&&S.add(xe,Q),{dirName:z,close:()=>{let ce=I.checkDefined(m.get(xe));Q&&S.remove(xe,Q),ce.refCount--,!ce.refCount&&(m.delete(xe),Od(ce),ce.childWatches.forEach(ug))}}}function M(z,se,Se){let xe,Z;vs(se)?xe=se:Z=se,S.forEach((Q,ce)=>{if(!(Z&&Z.get(ce)===!0)&&(ce===z||Ss(z,ce)&&z[ce.length]===hc))if(Z)if(Se){let ye=Z.get(ce);ye?ye.push(...Se):Z.set(ce,Se.slice())}else Z.set(ce,!0);else Q.forEach(({callback:ye})=>ye(xe))})}function O(z,se,Se,xe){let Z=m.get(se);if(Z&&s(z,1)){U(z,se,Se,xe);return}M(se,Se),K(Z)}function U(z,se,Se,xe){let Z=h.get(se);Z?Z.fileNames.push(Se):h.set(se,{dirName:z,options:xe,fileNames:[Se]}),b&&(p(b),b=void 0),b=l(H,1e3,"timerToUpdateChildWatches")}function H(){b=void 0,O3(`sysLog:: onTimerToUpdateChildWatches:: ${h.size}`);let z=uc(),se=new Map;for(;!b&&h.size;){let xe=h.entries().next();I.assert(!xe.done);let{value:[Z,{dirName:Q,options:ce,fileNames:ye}]}=xe;h.delete(Z);let we=re(Q,Z,ce);M(Z,se,we?void 0:ye)}O3(`sysLog:: invokingWatchers:: Elapsed:: ${uc()-z}ms:: ${h.size}`),S.forEach((xe,Z)=>{let Q=se.get(Z);Q&&xe.forEach(({callback:ce,dirName:ye})=>{os(Q)?Q.forEach(ce):ce(ye)})});let Se=uc()-z;O3(`sysLog:: Elapsed:: ${Se}ms:: onTimerToUpdateChildWatches:: ${h.size} ${b}`)}function K(z){if(!z)return;let se=z.childWatches;z.childWatches=tt;for(let Se of se)Se.close(),K(m.get(k(Se.dirName)))}function re(z,se,Se){let xe=m.get(se);if(!xe)return!1;let Z,Q=q5(s(z,1)?Wi(i(z),we=>{let ve=Ps(we,z);return!$(ve,Se)&&A(ve,Ca(o(ve)))===0?ve:void 0}):tt,xe.childWatches,(we,ve)=>A(we,ve.dirName),ce,ug,ye);return xe.childWatches=Z||tt,Q;function ce(we){let ve=N(we,Se);ye(ve)}function ye(we){(Z||(Z=[])).push(we)}}function $(z,se){return Tt(M3,Se=>pe(z,Se))||bOe(z,se,t,n)}function pe(z,se){return z.includes(se)?!0:t?!1:k(z).includes(se)}}function E0t(e){return(t,n,i)=>e(n===1?"change":"rename","",i)}function x0t(e,t,n){return(i,s,o)=>{i==="rename"?(o||(o=n(e)||Lp),t(e,o!==Lp?0:2,o)):t(e,1,o)}}function bOe(e,t,n,i){return(t?.excludeDirectories||t?.excludeFiles)&&(PU(e,t?.excludeFiles,n,i())||PU(e,t?.excludeDirectories,n,i()))}function EOe(e,t,n,i,s){return(o,l)=>{if(o==="rename"){let p=l?Ca(li(e,l)):e;(!l||!bOe(p,n,i,s))&&t(p)}}}function jfe({pollingWatchFileWorker:e,getModifiedTime:t,setTimeout:n,clearTimeout:i,fsWatchWorker:s,fileSystemEntryExists:o,useCaseSensitiveFileNames:l,getCurrentDirectory:p,fsSupportsRecursiveFsWatch:m,getAccessibleSortedChildDirectories:S,realpath:h,tscWatchFile:b,useNonPollingWatchers:A,tscWatchDirectory:k,inodeWatching:N,fsWatchWithTimestamp:M,sysLog:O}){let U=new Map,H=new Map,K=new Map,re,$,pe,z,se=!1;return{watchFile:Se,watchDirectory:ye};function Se(Ae,Ie,Re,Ue){Ue=Q(Ue,A);let kt=I.checkDefined(Ue.watchFile);switch(kt){case 0:return oe(Ae,Ie,250,void 0);case 1:return oe(Ae,Ie,Re,void 0);case 2:return xe()(Ae,Ie,Re,void 0);case 3:return Z()(Ae,Ie,void 0,void 0);case 4:return Ee(Ae,0,x0t(Ae,Ie,t),!1,Re,DM(Ue));case 5:return pe||(pe=v0t(Ee,l,t,M)),pe(Ae,Ie,Re,DM(Ue));default:I.assertNever(kt)}}function xe(){return re||(re=y0t({getModifiedTime:t,setTimeout:n}))}function Z(){return $||($=S0t({getModifiedTime:t,setTimeout:n}))}function Q(Ae,Ie){if(Ae&&Ae.watchFile!==void 0)return Ae;switch(b){case"PriorityPollingInterval":return{watchFile:1};case"DynamicPriorityPolling":return{watchFile:2};case"UseFsEvents":return ce(4,1,Ae);case"UseFsEventsWithFallbackDynamicPolling":return ce(4,2,Ae);case"UseFsEventsOnParentDirectory":Ie=!0;default:return Ie?ce(5,1,Ae):{watchFile:4}}}function ce(Ae,Ie,Re){let Ue=Re?.fallbackPolling;return{watchFile:Ae,fallbackPolling:Ue===void 0?Ie:Ue}}function ye(Ae,Ie,Re,Ue){return m?Ee(Ae,1,EOe(Ae,Ie,Ue,l,p),Re,500,DM(Ue)):(z||(z=b0t({useCaseSensitiveFileNames:l,getCurrentDirectory:p,fileSystemEntryExists:o,getAccessibleSortedChildDirectories:S,watchDirectory:we,realpath:h,setTimeout:n,clearTimeout:i})),z(Ae,Ie,Re,Ue))}function we(Ae,Ie,Re,Ue){I.assert(!Re);let kt=ve(Ue),ke=I.checkDefined(kt.watchDirectory);switch(ke){case 1:return oe(Ae,()=>Ie(Ae),500,void 0);case 2:return xe()(Ae,()=>Ie(Ae),500,void 0);case 3:return Z()(Ae,()=>Ie(Ae),void 0,void 0);case 0:return Ee(Ae,1,EOe(Ae,Ie,Ue,l,p),Re,500,DM(kt));default:I.assertNever(ke)}}function ve(Ae){if(Ae&&Ae.watchDirectory!==void 0)return Ae;switch(k){case"RecursiveDirectoryUsingFsWatchFile":return{watchDirectory:1};case"RecursiveDirectoryUsingDynamicPriorityPolling":return{watchDirectory:2};default:let Ie=Ae?.fallbackPolling;return{watchDirectory:0,fallbackPolling:Ie!==void 0?Ie:void 0}}}function oe(Ae,Ie,Re,Ue){return TOe(U,l,Ae,Ie,kt=>e(Ae,kt,Re,Ue))}function Ee(Ae,Ie,Re,Ue,kt,ke){return TOe(Ue?K:H,l,Ae,Re,$e=>Me(Ae,Ie,$e,Ue,kt,ke))}function Me(Ae,Ie,Re,Ue,kt,ke){let $e,at;N&&($e=Ae.substring(Ae.lastIndexOf(hc)),at=$e.slice(hc.length));let $t=o(Ae,Ie)?Ze():or();return{close:()=>{$t&&($t.close(),$t=void 0)}};function St(Fr){$t&&(O(`sysLog:: ${Ae}:: Changing watcher to ${Fr===Ze?"Present":"Missing"}FileSystemEntryWatcher`),$t.close(),$t=Fr())}function Ze(){if(se)return O(`sysLog:: ${Ae}:: Defaulting to watchFile`),ar();try{let Fr=(Ie===1||!M?s:Ge)(Ae,Ue,N?yt:Re);return Fr.on("error",()=>{Re("rename",""),St(or)}),Fr}catch(Fr){return se||(se=Fr.code==="ENOSPC"),O(`sysLog:: ${Ae}:: Changing to watchFile`),ar()}}function yt(Fr,rn){let Tr;if(rn&&Mc(rn,"~")&&(Tr=rn,rn=rn.slice(0,rn.length-1)),Fr==="rename"&&(!rn||rn===at||Mc(rn,$e))){let nr=t(Ae)||Lp;Tr&&Re(Fr,Tr,nr),Re(Fr,rn,nr),N?St(nr===Lp?or:Ze):nr===Lp&&St(or)}else Tr&&Re(Fr,Tr),Re(Fr,rn)}function ar(){return Se(Ae,E0t(Re),kt,ke)}function or(){return Se(Ae,(Fr,rn,Tr)=>{rn===0&&(Tr||(Tr=t(Ae)||Lp),Tr!==Lp&&(Re("rename","",Tr),St(Ze)))},kt,ke)}}function Ge(Ae,Ie,Re){let Ue=t(Ae)||Lp;return s(Ae,Ie,(kt,ke,$e)=>{kt==="change"&&($e||($e=t(Ae)||Lp),$e.getTime()===Ue.getTime())||(Ue=$e||t(Ae)||Lp,Re(kt,ke,Ue))})}}function Bfe(e){let t=e.writeFile;e.writeFile=(n,i,s)=>vX(n,i,!!s,(o,l,p)=>t.call(e,o,l,p),o=>e.createDirectory(o),o=>e.directoryExists(o))}function xOe(e){Zu=e}var FH,c9,Lp,l9,u9,R3,M3,Ufe,jH,Zu,C0t=f({"src/compiler/sys.ts"(){"use strict";fa(),FH=(e=>(e[e.Created=0]="Created",e[e.Changed=1]="Changed",e[e.Deleted=2]="Deleted",e))(FH||{}),c9=(e=>(e[e.High=2e3]="High",e[e.Medium=500]="Medium",e[e.Low=250]="Low",e))(c9||{}),Lp=new Date(0),l9={Low:32,Medium:64,High:256},u9=Lfe(l9),R3=Lfe(l9),M3=["/node_modules/.","/.git","/.#"],Ufe=ja,jH=(e=>(e[e.File=0]="File",e[e.Directory=1]="Directory",e))(jH||{}),Zu=(()=>{let e="\uFEFF";function t(){let i=/^native |^\([^)]+\)$|^(internal[\\/]|[a-zA-Z0-9_\s]+(\.js)?$)/,s=Bu("fs"),o=Bu("path"),l=Bu("os"),p;try{p=Bu("crypto")}catch{p=void 0}let m,S="./profile.cpuprofile",h=Bu("buffer").Buffer,b=process.platform==="darwin",A=process.platform==="linux"||b,k=l.platform(),N=Z(),M=s.realpathSync.native?process.platform==="win32"?Ue:s.realpathSync.native:s.realpathSync,O=__filename.endsWith("sys.js")?o.join(o.dirname(__dirname),"__fake__.js"):__filename,U=process.platform==="win32"||b,H=D_(()=>process.cwd()),{watchFile:K,watchDirectory:re}=jfe({pollingWatchFileWorker:ce,getModifiedTime:ke,setTimeout,clearTimeout,fsWatchWorker:ye,useCaseSensitiveFileNames:N,getCurrentDirectory:H,fileSystemEntryExists:Ge,fsSupportsRecursiveFsWatch:U,getAccessibleSortedChildDirectories:St=>Ee(St).directories,realpath:kt,tscWatchFile:process.env.TSC_WATCHFILE,useNonPollingWatchers:!!process.env.TSC_NONPOLLING_WATCHER,tscWatchDirectory:process.env.TSC_WATCHDIRECTORY,inodeWatching:A,fsWatchWithTimestamp:b,sysLog:O3}),$={args:process.argv.slice(2),newLine:l.EOL,useCaseSensitiveFileNames:N,write(St){process.stdout.write(St)},getWidthOfTerminal(){return process.stdout.columns},writeOutputIsTTY(){return process.stdout.isTTY},readFile:ve,writeFile:oe,watchFile:K,watchDirectory:re,resolvePath:St=>o.resolve(St),fileExists:Ae,directoryExists:Ie,getAccessibleFileSystemEntries:Ee,createDirectory(St){if(!$.directoryExists(St))try{s.mkdirSync(St)}catch(Ze){if(Ze.code!=="EEXIST")throw Ze}},getExecutingFilePath(){return O},getCurrentDirectory:H,getDirectories:Re,getEnvironmentVariable(St){return process.env[St]||""},readDirectory:Me,getModifiedTime:ke,setModifiedTime:$e,deleteFile:at,createHash:p?$t:Sw,createSHA256Hash:p?$t:void 0,getMemoryUsage(){return global.gc&&global.gc(),process.memoryUsage().heapUsed},getFileSize(St){try{let Ze=pe(St);if(Ze?.isFile())return Ze.size}catch{}return 0},exit(St){Se(()=>process.exit(St))},enableCPUProfiler:z,disableCPUProfiler:Se,cpuProfilingEnabled:()=>!!m||hs(process.execArgv,"--cpu-prof")||hs(process.execArgv,"--prof"),realpath:kt,debugMode:!!process.env.NODE_INSPECTOR_IPC||!!process.env.VSCODE_INSPECTOR_OPTIONS||Tt(process.execArgv,St=>/^--(inspect|debug)(-brk)?(=\d+)?$/i.test(St))||!!process.recordreplay,tryEnableSourceMapsForHost(){try{Vdt().install()}catch{}},setTimeout,clearTimeout,clearScreen:()=>{process.stdout.write("\x1Bc")},setBlocking:()=>{var St;let Ze=(St=process.stdout)==null?void 0:St._handle;Ze&&Ze.setBlocking&&Ze.setBlocking(!0)},bufferFrom:xe,base64decode:St=>xe(St,"base64").toString("utf8"),base64encode:St=>xe(St).toString("base64"),require:(St,Ze)=>{try{let yt=Rhe(Ze,St,$);return{module:Bu(yt),modulePath:yt,error:void 0}}catch(yt){return{module:void 0,modulePath:void 0,error:yt}}}};return $;function pe(St){return s.statSync(St,{throwIfNoEntry:!1})}function z(St,Ze){if(m)return Ze(),!1;let yt=Bu("inspector");if(!yt||!yt.Session)return Ze(),!1;let ar=new yt.Session;return ar.connect(),ar.post("Profiler.enable",()=>{ar.post("Profiler.start",()=>{m=ar,S=St,Ze()})}),!0}function se(St){let Ze=0,yt=new Map,ar=v_(o.dirname(O)),or=`file://${wh(ar)===1?"":"/"}${ar}`;for(let Fr of St.nodes)if(Fr.callFrame.url){let rn=v_(Fr.callFrame.url);wm(or,rn,N)?Fr.callFrame.url=dA(or,rn,or,y_(N),!0):i.test(rn)||(Fr.callFrame.url=(yt.has(rn)?yt:yt.set(rn,`external${Ze}.js`)).get(rn),Ze++)}return St}function Se(St){if(m&&m!=="stopping"){let Ze=m;return m.post("Profiler.stop",(yt,{profile:ar})=>{var or;if(!yt){try{(or=pe(S))!=null&&or.isDirectory()&&(S=o.join(S,`${new Date().toISOString().replace(/:/g,"-")}+P${process.pid}.cpuprofile`))}catch{}try{s.mkdirSync(o.dirname(S),{recursive:!0})}catch{}s.writeFileSync(S,JSON.stringify(se(ar)))}m=void 0,Ze.disconnect(),St()}),m="stopping",!0}else return St(),!1}function xe(St,Ze){return h.from&&h.from!==Int8Array.from?h.from(St,Ze):new h(St,Ze)}function Z(){return k==="win32"||k==="win64"?!1:!Ae(Q(__filename))}function Q(St){return St.replace(/\w/g,Ze=>{let yt=Ze.toUpperCase();return Ze===yt?Ze.toLowerCase():yt})}function ce(St,Ze,yt){s.watchFile(St,{persistent:!0,interval:yt},or);let ar;return{close:()=>s.unwatchFile(St,or)};function or(Fr,rn){let Tr=+rn.mtime==0||ar===2;if(+Fr.mtime==0){if(Tr)return;ar=2}else if(Tr)ar=0;else{if(+Fr.mtime==+rn.mtime)return;ar=1}Ze(St,ar,Fr.mtime)}}function ye(St,Ze,yt){return s.watch(St,U?{persistent:!0,recursive:!!Ze}:{persistent:!0},yt)}function we(St,Ze){let yt;try{yt=s.readFileSync(St)}catch{return}let ar=yt.length;if(ar>=2&&yt[0]===254&&yt[1]===255){ar&=-2;for(let or=0;or<ar;or+=2){let Fr=yt[or];yt[or]=yt[or+1],yt[or+1]=Fr}return yt.toString("utf16le",2)}return ar>=2&&yt[0]===255&&yt[1]===254?yt.toString("utf16le",2):ar>=3&&yt[0]===239&&yt[1]===187&&yt[2]===191?yt.toString("utf8",3):yt.toString("utf8")}function ve(St,Ze){var yt,ar;(yt=z_)==null||yt.logStartReadFile(St);let or=we(St,Ze);return(ar=z_)==null||ar.logStopReadFile(),or}function oe(St,Ze,yt){var ar;(ar=z_)==null||ar.logEvent("WriteFile: "+St),yt&&(Ze=e+Ze);let or;try{or=s.openSync(St,"w"),s.writeSync(or,Ze,void 0,"utf8")}finally{or!==void 0&&s.closeSync(or)}}function Ee(St){var Ze;(Ze=z_)==null||Ze.logEvent("ReadDir: "+(St||"."));try{let yt=s.readdirSync(St||".",{withFileTypes:!0}),ar=[],or=[];for(let Fr of yt){let rn=typeof Fr=="string"?Fr:Fr.name;if(rn==="."||rn==="..")continue;let Tr;if(typeof Fr=="string"||Fr.isSymbolicLink()){let nr=li(St,rn);try{if(Tr=pe(nr),!Tr)continue}catch{continue}}else Tr=Fr;Tr.isFile()?ar.push(rn):Tr.isDirectory()&&or.push(rn)}return ar.sort(),or.sort(),{files:ar,directories:or}}catch{return yB}}function Me(St,Ze,yt,ar,or){return JX(St,Ze,yt,ar,N,process.cwd(),or,Ee,kt)}function Ge(St,Ze){let yt=Error.stackTraceLimit;Error.stackTraceLimit=0;try{let ar=pe(St);if(!ar)return!1;switch(Ze){case 0:return ar.isFile();case 1:return ar.isDirectory();default:return!1}}catch{return!1}finally{Error.stackTraceLimit=yt}}function Ae(St){return Ge(St,0)}function Ie(St){return Ge(St,1)}function Re(St){return Ee(St).directories.slice()}function Ue(St){return St.length<260?s.realpathSync.native(St):s.realpathSync(St)}function kt(St){try{return M(St)}catch{return St}}function ke(St){var Ze;let yt=Error.stackTraceLimit;Error.stackTraceLimit=0;try{return(Ze=pe(St))==null?void 0:Ze.mtime}catch{return}finally{Error.stackTraceLimit=yt}}function $e(St,Ze){try{s.utimesSync(St,Ze,Ze)}catch{return}}function at(St){try{return s.unlinkSync(St)}catch{return}}function $t(St){let Ze=p.createHash("sha256");return Ze.update(St),Ze.digest("hex")}}let n;return PG()&&(n=t()),n&&Bfe(n),n})(),Zu&&Zu.getEnvironmentVariable&&(h0t(Zu),I.setAssertionLevel(/^development$/i.test(Zu.getEnvironmentVariable("NODE_ENV"))?1:0)),Zu&&Zu.debugMode&&(I.isDebugging=!0)}});function BH(e){return e===47||e===92}function Vfe(e){return _9(e)<0}function ap(e){return _9(e)>0}function UH(e){let t=_9(e);return t>0&&t===e.length}function Tw(e){return _9(e)!==0}function Fp(e){return/^\.\.?($|[\\/])/.test(e)}function VH(e){return!Tw(e)&&!Fp(e)}function pA(e){return Cl(e).includes(".")}function Uc(e,t){return e.length>t.length&&Mc(e,t)}function Ql(e,t){for(let n of t)if(Uc(e,n))return!0;return!1}function b1(e){return e.length>0&&BH(e.charCodeAt(e.length-1))}function COe(e){return e>=97&&e<=122||e>=65&&e<=90}function A0t(e,t){let n=e.charCodeAt(t);if(n===58)return t+1;if(n===37&&e.charCodeAt(t+1)===51){let i=e.charCodeAt(t+2);if(i===97||i===65)return t+3}return-1}function _9(e){if(!e)return 0;let t=e.charCodeAt(0);if(t===47||t===92){if(e.charCodeAt(1)!==t)return 1;let i=e.indexOf(t===47?hc:B3,2);return i<0?e.length:i+1}if(COe(t)&&e.charCodeAt(1)===58){let i=e.charCodeAt(2);if(i===47||i===92)return 3;if(e.length===2)return 2}let n=e.indexOf(zfe);if(n!==-1){let i=n+zfe.length,s=e.indexOf(hc,i);if(s!==-1){let o=e.slice(0,n),l=e.slice(i,s);if(o==="file"&&(l===""||l==="localhost")&&COe(e.charCodeAt(s+1))){let p=A0t(e,s+2);if(p!==-1){if(e.charCodeAt(p)===47)return~(p+1);if(p===e.length)return~p}}return~(s+1)}return~e.length}return 0}function wh(e){let t=_9(e);return t<0?~t:t}function hi(e){e=v_(e);let t=wh(e);return t===e.length?e:(e=sT(e),e.slice(0,Math.max(t,e.lastIndexOf(hc))))}function Cl(e,t,n){if(e=v_(e),wh(e)===e.length)return"";e=sT(e);let s=e.slice(Math.max(wh(e),e.lastIndexOf(hc)+1)),o=t!==void 0&&n!==void 0?qP(s,t,n):void 0;return o?s.slice(0,s.length-o.length):s}function AOe(e,t,n){if(Ss(t,".")||(t="."+t),e.length>=t.length&&e.charCodeAt(e.length-t.length)===46){let i=e.slice(e.length-t.length);if(n(i,t))return i}}function k0t(e,t,n){if(typeof t=="string")return AOe(e,t,n)||"";for(let i of t){let s=AOe(e,i,n);if(s)return s}return""}function qP(e,t,n){if(t)return k0t(sT(e),t,n?S1:Av);let i=Cl(e),s=i.lastIndexOf(".");return s>=0?i.substring(s):""}function P0t(e,t){let n=e.substring(0,t),i=e.substring(t).split(hc);return i.length&&!Is(i)&&i.pop(),[n,...i]}function gu(e,t=""){return e=li(t,e),P0t(e,wh(e))}function Nv(e,t){return e.length===0?"":(e[0]&&hu(e[0]))+e.slice(1,t).join(hc)}function v_(e){return e.includes("\\")?e.replace(NOe,hc):e}function M2(e){if(!Tt(e))return[];let t=[e[0]];for(let n=1;n<e.length;n++){let i=e[n];if(i&&i!=="."){if(i===".."){if(t.length>1){if(t[t.length-1]!==".."){t.pop();continue}}else if(t[0])continue}t.push(i)}}return t}function li(e,...t){e&&(e=v_(e));for(let n of t)n&&(n=v_(n),!e||wh(n)!==0?e=n:e=hu(e)+n);return e}function Dv(e,...t){return Ca(Tt(t)?li(e,...t):v_(e))}function L3(e,t){return M2(gu(e,t))}function Ps(e,t){return Nv(L3(e,t))}function Ca(e){if(e=v_(e),!p9.test(e))return e;let t=e.replace(/\/\.\//g,"/").replace(/^\.\//,"");if(t!==e&&(e=t,!p9.test(e)))return e;let n=Nv(M2(gu(e)));return n&&b1(e)?hu(n):n}function N0t(e){return e.length===0?"":e.slice(1).join(hc)}function JH(e,t){return N0t(L3(e,t))}function gc(e,t,n){let i=ap(e)?Ca(e):Ps(e,t);return n(i)}function sT(e){return b1(e)?e.substr(0,e.length-1):e}function hu(e){return b1(e)?e:e+hc}function Lb(e){return!Tw(e)&&!Fp(e)?"./"+e:e}function F3(e,t,n,i){let s=n!==void 0&&i!==void 0?qP(e,n,i):qP(e);return s?e.slice(0,e.length-s.length)+(Ss(t,".")?t:"."+t):e}function Jfe(e,t){let n=lQ(e);return n?e.slice(0,e.length-n.length)+(Ss(t,".")?t:"."+t):F3(e,t)}function qfe(e,t,n){if(e===t)return 0;if(e===void 0)return-1;if(t===void 0)return 1;let i=e.substring(0,wh(e)),s=t.substring(0,wh(t)),o=D2(i,s);if(o!==0)return o;let l=e.substring(i.length),p=t.substring(s.length);if(!p9.test(l)&&!p9.test(p))return n(l,p);let m=M2(gu(e)),S=M2(gu(t)),h=Math.min(m.length,S.length);for(let b=1;b<h;b++){let A=n(m[b],S[b]);if(A!==0)return A}return To(m.length,S.length)}function kOe(e,t){return qfe(e,t,h_)}function POe(e,t){return qfe(e,t,D2)}function yy(e,t,n,i){return typeof n=="string"?(e=li(n,e),t=li(n,t)):typeof n=="boolean"&&(i=n),qfe(e,t,gy(i))}function wm(e,t,n,i){if(typeof n=="string"?(e=li(n,e),t=li(n,t)):typeof n=="boolean"&&(i=n),e===void 0||t===void 0)return!1;if(e===t)return!0;let s=M2(gu(e)),o=M2(gu(t));if(o.length<s.length)return!1;let l=i?S1:Av;for(let p=0;p<s.length;p++)if(!(p===0?S1:l)(s[p],o[p]))return!1;return!0}function qH(e,t,n){let i=n(e),s=n(t);return Ss(i,s+"/")||Ss(i,s+"\\")}function zH(e,t,n,i){let s=M2(gu(e)),o=M2(gu(t)),l;for(l=0;l<s.length&&l<o.length;l++){let S=i(s[l]),h=i(o[l]);if(!(l===0?S1:n)(S,h))break}if(l===0)return o;let p=o.slice(l),m=[];for(;l<s.length;l++)m.push("..");return["",...m,...p]}function Om(e,t,n){I.assert(wh(e)>0==wh(t)>0,"Paths must either both be absolute or both be relative");let o=zH(e,t,(typeof n=="boolean"?n:!1)?S1:Av,typeof n=="function"?n:Mo);return Nv(o)}function bw(e,t,n){return ap(e)?dA(t,e,t,n,!1):e}function j3(e,t,n){return Lb(Om(hi(e),t,n))}function dA(e,t,n,i,s){let o=zH(Dv(n,e),Dv(n,t),Av,i),l=o[0];if(s&&ap(l)){let p=l.charAt(0)===hc?"file://":"file:///";o[0]=p+l}return Nv(o)}function Rm(e,t){for(;;){let n=t(e);if(n!==void 0)return n;let i=hi(e);if(i===e)return;e=i}}function f9(e){return Mc(e,"/node_modules")}var hc,B3,zfe,NOe,p9,D0t=f({"src/compiler/path.ts"(){"use strict";fa(),hc="/",B3="\\",zfe="://",NOe=/\\/g,p9=/(?:\/\/)|(?:^|\/)\.\.?(?:$|\/)/}});function C(e,t,n,i,s,o,l){return{code:e,category:t,key:n,message:i,reportsUnnecessary:s,elidedInCompatabilityPyramid:o,reportsDeprecated:l}}var g,I0t=f({"src/compiler/diagnosticInformationMap.generated.ts"(){"use strict";yOe(),g={Unterminated_string_literal:C(1002,1,"Unterminated_string_literal_1002","Unterminated string literal."),Identifier_expected:C(1003,1,"Identifier_expected_1003","Identifier expected."),_0_expected:C(1005,1,"_0_expected_1005","'{0}' expected."),A_file_cannot_have_a_reference_to_itself:C(1006,1,"A_file_cannot_have_a_reference_to_itself_1006","A file cannot have a reference to itself."),The_parser_expected_to_find_a_1_to_match_the_0_token_here:C(1007,1,"The_parser_expected_to_find_a_1_to_match_the_0_token_here_1007","The parser expected to find a '{1}' to match the '{0}' token here."),Trailing_comma_not_allowed:C(1009,1,"Trailing_comma_not_allowed_1009","Trailing comma not allowed."),Asterisk_Slash_expected:C(1010,1,"Asterisk_Slash_expected_1010","'*/' expected."),An_element_access_expression_should_take_an_argument:C(1011,1,"An_element_access_expression_should_take_an_argument_1011","An element access expression should take an argument."),Unexpected_token:C(1012,1,"Unexpected_token_1012","Unexpected token."),A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma:C(1013,1,"A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma_1013","A rest parameter or binding pattern may not have a trailing comma."),A_rest_parameter_must_be_last_in_a_parameter_list:C(1014,1,"A_rest_parameter_must_be_last_in_a_parameter_list_1014","A rest parameter must be last in a parameter list."),Parameter_cannot_have_question_mark_and_initializer:C(1015,1,"Parameter_cannot_have_question_mark_and_initializer_1015","Parameter cannot have question mark and initializer."),A_required_parameter_cannot_follow_an_optional_parameter:C(1016,1,"A_required_parameter_cannot_follow_an_optional_parameter_1016","A required parameter cannot follow an optional parameter."),An_index_signature_cannot_have_a_rest_parameter:C(1017,1,"An_index_signature_cannot_have_a_rest_parameter_1017","An index signature cannot have a rest parameter."),An_index_signature_parameter_cannot_have_an_accessibility_modifier:C(1018,1,"An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018","An index signature parameter cannot have an accessibility modifier."),An_index_signature_parameter_cannot_have_a_question_mark:C(1019,1,"An_index_signature_parameter_cannot_have_a_question_mark_1019","An index signature parameter cannot have a question mark."),An_index_signature_parameter_cannot_have_an_initializer:C(1020,1,"An_index_signature_parameter_cannot_have_an_initializer_1020","An index signature parameter cannot have an initializer."),An_index_signature_must_have_a_type_annotation:C(1021,1,"An_index_signature_must_have_a_type_annotation_1021","An index signature must have a type annotation."),An_index_signature_parameter_must_have_a_type_annotation:C(1022,1,"An_index_signature_parameter_must_have_a_type_annotation_1022","An index signature parameter must have a type annotation."),readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature:C(1024,1,"readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature_1024","'readonly' modifier can only appear on a property declaration or index signature."),An_index_signature_cannot_have_a_trailing_comma:C(1025,1,"An_index_signature_cannot_have_a_trailing_comma_1025","An index signature cannot have a trailing comma."),Accessibility_modifier_already_seen:C(1028,1,"Accessibility_modifier_already_seen_1028","Accessibility modifier already seen."),_0_modifier_must_precede_1_modifier:C(1029,1,"_0_modifier_must_precede_1_modifier_1029","'{0}' modifier must precede '{1}' modifier."),_0_modifier_already_seen:C(1030,1,"_0_modifier_already_seen_1030","'{0}' modifier already seen."),_0_modifier_cannot_appear_on_class_elements_of_this_kind:C(1031,1,"_0_modifier_cannot_appear_on_class_elements_of_this_kind_1031","'{0}' modifier cannot appear on class elements of this kind."),super_must_be_followed_by_an_argument_list_or_member_access:C(1034,1,"super_must_be_followed_by_an_argument_list_or_member_access_1034","'super' must be followed by an argument list or member access."),Only_ambient_modules_can_use_quoted_names:C(1035,1,"Only_ambient_modules_can_use_quoted_names_1035","Only ambient modules can use quoted names."),Statements_are_not_allowed_in_ambient_contexts:C(1036,1,"Statements_are_not_allowed_in_ambient_contexts_1036","Statements are not allowed in ambient contexts."),A_declare_modifier_cannot_be_used_in_an_already_ambient_context:C(1038,1,"A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038","A 'declare' modifier cannot be used in an already ambient context."),Initializers_are_not_allowed_in_ambient_contexts:C(1039,1,"Initializers_are_not_allowed_in_ambient_contexts_1039","Initializers are not allowed in ambient contexts."),_0_modifier_cannot_be_used_in_an_ambient_context:C(1040,1,"_0_modifier_cannot_be_used_in_an_ambient_context_1040","'{0}' modifier cannot be used in an ambient context."),_0_modifier_cannot_be_used_here:C(1042,1,"_0_modifier_cannot_be_used_here_1042","'{0}' modifier cannot be used here."),_0_modifier_cannot_appear_on_a_module_or_namespace_element:C(1044,1,"_0_modifier_cannot_appear_on_a_module_or_namespace_element_1044","'{0}' modifier cannot appear on a module or namespace element."),Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier:C(1046,1,"Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier_1046","Top-level declarations in .d.ts files must start with either a 'declare' or 'export' modifier."),A_rest_parameter_cannot_be_optional:C(1047,1,"A_rest_parameter_cannot_be_optional_1047","A rest parameter cannot be optional."),A_rest_parameter_cannot_have_an_initializer:C(1048,1,"A_rest_parameter_cannot_have_an_initializer_1048","A rest parameter cannot have an initializer."),A_set_accessor_must_have_exactly_one_parameter:C(1049,1,"A_set_accessor_must_have_exactly_one_parameter_1049","A 'set' accessor must have exactly one parameter."),A_set_accessor_cannot_have_an_optional_parameter:C(1051,1,"A_set_accessor_cannot_have_an_optional_parameter_1051","A 'set' accessor cannot have an optional parameter."),A_set_accessor_parameter_cannot_have_an_initializer:C(1052,1,"A_set_accessor_parameter_cannot_have_an_initializer_1052","A 'set' accessor parameter cannot have an initializer."),A_set_accessor_cannot_have_rest_parameter:C(1053,1,"A_set_accessor_cannot_have_rest_parameter_1053","A 'set' accessor cannot have rest parameter."),A_get_accessor_cannot_have_parameters:C(1054,1,"A_get_accessor_cannot_have_parameters_1054","A 'get' accessor cannot have parameters."),Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value:C(1055,1,"Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Prom_1055","Type '{0}' is not a valid async function return type in ES5/ES3 because it does not refer to a Promise-compatible constructor value."),Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher:C(1056,1,"Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056","Accessors are only available when targeting ECMAScript 5 and higher."),The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:C(1058,1,"The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_t_1058","The return type of an async function must either be a valid promise or must not contain a callable 'then' member."),A_promise_must_have_a_then_method:C(1059,1,"A_promise_must_have_a_then_method_1059","A promise must have a 'then' method."),The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback:C(1060,1,"The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback_1060","The first parameter of the 'then' method of a promise must be a callback."),Enum_member_must_have_initializer:C(1061,1,"Enum_member_must_have_initializer_1061","Enum member must have initializer."),Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method:C(1062,1,"Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062","Type is referenced directly or indirectly in the fulfillment callback of its own 'then' method."),An_export_assignment_cannot_be_used_in_a_namespace:C(1063,1,"An_export_assignment_cannot_be_used_in_a_namespace_1063","An export assignment cannot be used in a namespace."),The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0:C(1064,1,"The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_wri_1064","The return type of an async function or method must be the global Promise<T> type. Did you mean to write 'Promise<{0}>'?"),The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type:C(1065,1,"The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_1065","The return type of an async function or method must be the global Promise<T> type."),In_ambient_enum_declarations_member_initializer_must_be_constant_expression:C(1066,1,"In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066","In ambient enum declarations member initializer must be constant expression."),Unexpected_token_A_constructor_method_accessor_or_property_was_expected:C(1068,1,"Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068","Unexpected token. A constructor, method, accessor, or property was expected."),Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces:C(1069,1,"Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces_1069","Unexpected token. A type parameter name was expected without curly braces."),_0_modifier_cannot_appear_on_a_type_member:C(1070,1,"_0_modifier_cannot_appear_on_a_type_member_1070","'{0}' modifier cannot appear on a type member."),_0_modifier_cannot_appear_on_an_index_signature:C(1071,1,"_0_modifier_cannot_appear_on_an_index_signature_1071","'{0}' modifier cannot appear on an index signature."),A_0_modifier_cannot_be_used_with_an_import_declaration:C(1079,1,"A_0_modifier_cannot_be_used_with_an_import_declaration_1079","A '{0}' modifier cannot be used with an import declaration."),Invalid_reference_directive_syntax:C(1084,1,"Invalid_reference_directive_syntax_1084","Invalid 'reference' directive syntax."),_0_modifier_cannot_appear_on_a_constructor_declaration:C(1089,1,"_0_modifier_cannot_appear_on_a_constructor_declaration_1089","'{0}' modifier cannot appear on a constructor declaration."),_0_modifier_cannot_appear_on_a_parameter:C(1090,1,"_0_modifier_cannot_appear_on_a_parameter_1090","'{0}' modifier cannot appear on a parameter."),Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement:C(1091,1,"Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091","Only a single variable declaration is allowed in a 'for...in' statement."),Type_parameters_cannot_appear_on_a_constructor_declaration:C(1092,1,"Type_parameters_cannot_appear_on_a_constructor_declaration_1092","Type parameters cannot appear on a constructor declaration."),Type_annotation_cannot_appear_on_a_constructor_declaration:C(1093,1,"Type_annotation_cannot_appear_on_a_constructor_declaration_1093","Type annotation cannot appear on a constructor declaration."),An_accessor_cannot_have_type_parameters:C(1094,1,"An_accessor_cannot_have_type_parameters_1094","An accessor cannot have type parameters."),A_set_accessor_cannot_have_a_return_type_annotation:C(1095,1,"A_set_accessor_cannot_have_a_return_type_annotation_1095","A 'set' accessor cannot have a return type annotation."),An_index_signature_must_have_exactly_one_parameter:C(1096,1,"An_index_signature_must_have_exactly_one_parameter_1096","An index signature must have exactly one parameter."),_0_list_cannot_be_empty:C(1097,1,"_0_list_cannot_be_empty_1097","'{0}' list cannot be empty."),Type_parameter_list_cannot_be_empty:C(1098,1,"Type_parameter_list_cannot_be_empty_1098","Type parameter list cannot be empty."),Type_argument_list_cannot_be_empty:C(1099,1,"Type_argument_list_cannot_be_empty_1099","Type argument list cannot be empty."),Invalid_use_of_0_in_strict_mode:C(1100,1,"Invalid_use_of_0_in_strict_mode_1100","Invalid use of '{0}' in strict mode."),with_statements_are_not_allowed_in_strict_mode:C(1101,1,"with_statements_are_not_allowed_in_strict_mode_1101","'with' statements are not allowed in strict mode."),delete_cannot_be_called_on_an_identifier_in_strict_mode:C(1102,1,"delete_cannot_be_called_on_an_identifier_in_strict_mode_1102","'delete' cannot be called on an identifier in strict mode."),for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules:C(1103,1,"for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1103","'for await' loops are only allowed within async functions and at the top levels of modules."),A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement:C(1104,1,"A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104","A 'continue' statement can only be used within an enclosing iteration statement."),A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement:C(1105,1,"A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105","A 'break' statement can only be used within an enclosing iteration or switch statement."),The_left_hand_side_of_a_for_of_statement_may_not_be_async:C(1106,1,"The_left_hand_side_of_a_for_of_statement_may_not_be_async_1106","The left-hand side of a 'for...of' statement may not be 'async'."),Jump_target_cannot_cross_function_boundary:C(1107,1,"Jump_target_cannot_cross_function_boundary_1107","Jump target cannot cross function boundary."),A_return_statement_can_only_be_used_within_a_function_body:C(1108,1,"A_return_statement_can_only_be_used_within_a_function_body_1108","A 'return' statement can only be used within a function body."),Expression_expected:C(1109,1,"Expression_expected_1109","Expression expected."),Type_expected:C(1110,1,"Type_expected_1110","Type expected."),Private_field_0_must_be_declared_in_an_enclosing_class:C(1111,1,"Private_field_0_must_be_declared_in_an_enclosing_class_1111","Private field '{0}' must be declared in an enclosing class."),A_default_clause_cannot_appear_more_than_once_in_a_switch_statement:C(1113,1,"A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113","A 'default' clause cannot appear more than once in a 'switch' statement."),Duplicate_label_0:C(1114,1,"Duplicate_label_0_1114","Duplicate label '{0}'."),A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement:C(1115,1,"A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115","A 'continue' statement can only jump to a label of an enclosing iteration statement."),A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement:C(1116,1,"A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116","A 'break' statement can only jump to a label of an enclosing statement."),An_object_literal_cannot_have_multiple_properties_with_the_same_name:C(1117,1,"An_object_literal_cannot_have_multiple_properties_with_the_same_name_1117","An object literal cannot have multiple properties with the same name."),An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name:C(1118,1,"An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118","An object literal cannot have multiple get/set accessors with the same name."),An_object_literal_cannot_have_property_and_accessor_with_the_same_name:C(1119,1,"An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119","An object literal cannot have property and accessor with the same name."),An_export_assignment_cannot_have_modifiers:C(1120,1,"An_export_assignment_cannot_have_modifiers_1120","An export assignment cannot have modifiers."),Octal_literals_are_not_allowed_Use_the_syntax_0:C(1121,1,"Octal_literals_are_not_allowed_Use_the_syntax_0_1121","Octal literals are not allowed. Use the syntax '{0}'."),Variable_declaration_list_cannot_be_empty:C(1123,1,"Variable_declaration_list_cannot_be_empty_1123","Variable declaration list cannot be empty."),Digit_expected:C(1124,1,"Digit_expected_1124","Digit expected."),Hexadecimal_digit_expected:C(1125,1,"Hexadecimal_digit_expected_1125","Hexadecimal digit expected."),Unexpected_end_of_text:C(1126,1,"Unexpected_end_of_text_1126","Unexpected end of text."),Invalid_character:C(1127,1,"Invalid_character_1127","Invalid character."),Declaration_or_statement_expected:C(1128,1,"Declaration_or_statement_expected_1128","Declaration or statement expected."),Statement_expected:C(1129,1,"Statement_expected_1129","Statement expected."),case_or_default_expected:C(1130,1,"case_or_default_expected_1130","'case' or 'default' expected."),Property_or_signature_expected:C(1131,1,"Property_or_signature_expected_1131","Property or signature expected."),Enum_member_expected:C(1132,1,"Enum_member_expected_1132","Enum member expected."),Variable_declaration_expected:C(1134,1,"Variable_declaration_expected_1134","Variable declaration expected."),Argument_expression_expected:C(1135,1,"Argument_expression_expected_1135","Argument expression expected."),Property_assignment_expected:C(1136,1,"Property_assignment_expected_1136","Property assignment expected."),Expression_or_comma_expected:C(1137,1,"Expression_or_comma_expected_1137","Expression or comma expected."),Parameter_declaration_expected:C(1138,1,"Parameter_declaration_expected_1138","Parameter declaration expected."),Type_parameter_declaration_expected:C(1139,1,"Type_parameter_declaration_expected_1139","Type parameter declaration expected."),Type_argument_expected:C(1140,1,"Type_argument_expected_1140","Type argument expected."),String_literal_expected:C(1141,1,"String_literal_expected_1141","String literal expected."),Line_break_not_permitted_here:C(1142,1,"Line_break_not_permitted_here_1142","Line break not permitted here."),or_expected:C(1144,1,"or_expected_1144","'{' or ';' expected."),or_JSX_element_expected:C(1145,1,"or_JSX_element_expected_1145","'{' or JSX element expected."),Declaration_expected:C(1146,1,"Declaration_expected_1146","Declaration expected."),Import_declarations_in_a_namespace_cannot_reference_a_module:C(1147,1,"Import_declarations_in_a_namespace_cannot_reference_a_module_1147","Import declarations in a namespace cannot reference a module."),Cannot_use_imports_exports_or_module_augmentations_when_module_is_none:C(1148,1,"Cannot_use_imports_exports_or_module_augmentations_when_module_is_none_1148","Cannot use imports, exports, or module augmentations when '--module' is 'none'."),File_name_0_differs_from_already_included_file_name_1_only_in_casing:C(1149,1,"File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149","File name '{0}' differs from already included file name '{1}' only in casing."),_0_declarations_must_be_initialized:C(1155,1,"_0_declarations_must_be_initialized_1155","'{0}' declarations must be initialized."),_0_declarations_can_only_be_declared_inside_a_block:C(1156,1,"_0_declarations_can_only_be_declared_inside_a_block_1156","'{0}' declarations can only be declared inside a block."),Unterminated_template_literal:C(1160,1,"Unterminated_template_literal_1160","Unterminated template literal."),Unterminated_regular_expression_literal:C(1161,1,"Unterminated_regular_expression_literal_1161","Unterminated regular expression literal."),An_object_member_cannot_be_declared_optional:C(1162,1,"An_object_member_cannot_be_declared_optional_1162","An object member cannot be declared optional."),A_yield_expression_is_only_allowed_in_a_generator_body:C(1163,1,"A_yield_expression_is_only_allowed_in_a_generator_body_1163","A 'yield' expression is only allowed in a generator body."),Computed_property_names_are_not_allowed_in_enums:C(1164,1,"Computed_property_names_are_not_allowed_in_enums_1164","Computed property names are not allowed in enums."),A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:C(1165,1,"A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_t_1165","A computed property name in an ambient context must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type:C(1166,1,"A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_1166","A computed property name in a class property declaration must have a simple literal type or a 'unique symbol' type."),A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:C(1168,1,"A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_ty_1168","A computed property name in a method overload must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:C(1169,1,"A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_1169","A computed property name in an interface must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type:C(1170,1,"A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type__1170","A computed property name in a type literal must refer to an expression whose type is a literal type or a 'unique symbol' type."),A_comma_expression_is_not_allowed_in_a_computed_property_name:C(1171,1,"A_comma_expression_is_not_allowed_in_a_computed_property_name_1171","A comma expression is not allowed in a computed property name."),extends_clause_already_seen:C(1172,1,"extends_clause_already_seen_1172","'extends' clause already seen."),extends_clause_must_precede_implements_clause:C(1173,1,"extends_clause_must_precede_implements_clause_1173","'extends' clause must precede 'implements' clause."),Classes_can_only_extend_a_single_class:C(1174,1,"Classes_can_only_extend_a_single_class_1174","Classes can only extend a single class."),implements_clause_already_seen:C(1175,1,"implements_clause_already_seen_1175","'implements' clause already seen."),Interface_declaration_cannot_have_implements_clause:C(1176,1,"Interface_declaration_cannot_have_implements_clause_1176","Interface declaration cannot have 'implements' clause."),Binary_digit_expected:C(1177,1,"Binary_digit_expected_1177","Binary digit expected."),Octal_digit_expected:C(1178,1,"Octal_digit_expected_1178","Octal digit expected."),Unexpected_token_expected:C(1179,1,"Unexpected_token_expected_1179","Unexpected token. '{' expected."),Property_destructuring_pattern_expected:C(1180,1,"Property_destructuring_pattern_expected_1180","Property destructuring pattern expected."),Array_element_destructuring_pattern_expected:C(1181,1,"Array_element_destructuring_pattern_expected_1181","Array element destructuring pattern expected."),A_destructuring_declaration_must_have_an_initializer:C(1182,1,"A_destructuring_declaration_must_have_an_initializer_1182","A destructuring declaration must have an initializer."),An_implementation_cannot_be_declared_in_ambient_contexts:C(1183,1,"An_implementation_cannot_be_declared_in_ambient_contexts_1183","An implementation cannot be declared in ambient contexts."),Modifiers_cannot_appear_here:C(1184,1,"Modifiers_cannot_appear_here_1184","Modifiers cannot appear here."),Merge_conflict_marker_encountered:C(1185,1,"Merge_conflict_marker_encountered_1185","Merge conflict marker encountered."),A_rest_element_cannot_have_an_initializer:C(1186,1,"A_rest_element_cannot_have_an_initializer_1186","A rest element cannot have an initializer."),A_parameter_property_may_not_be_declared_using_a_binding_pattern:C(1187,1,"A_parameter_property_may_not_be_declared_using_a_binding_pattern_1187","A parameter property may not be declared using a binding pattern."),Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement:C(1188,1,"Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188","Only a single variable declaration is allowed in a 'for...of' statement."),The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer:C(1189,1,"The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189","The variable declaration of a 'for...in' statement cannot have an initializer."),The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer:C(1190,1,"The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190","The variable declaration of a 'for...of' statement cannot have an initializer."),An_import_declaration_cannot_have_modifiers:C(1191,1,"An_import_declaration_cannot_have_modifiers_1191","An import declaration cannot have modifiers."),Module_0_has_no_default_export:C(1192,1,"Module_0_has_no_default_export_1192","Module '{0}' has no default export."),An_export_declaration_cannot_have_modifiers:C(1193,1,"An_export_declaration_cannot_have_modifiers_1193","An export declaration cannot have modifiers."),Export_declarations_are_not_permitted_in_a_namespace:C(1194,1,"Export_declarations_are_not_permitted_in_a_namespace_1194","Export declarations are not permitted in a namespace."),export_Asterisk_does_not_re_export_a_default:C(1195,1,"export_Asterisk_does_not_re_export_a_default_1195","'export *' does not re-export a default."),Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified:C(1196,1,"Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified_1196","Catch clause variable type annotation must be 'any' or 'unknown' if specified."),Catch_clause_variable_cannot_have_an_initializer:C(1197,1,"Catch_clause_variable_cannot_have_an_initializer_1197","Catch clause variable cannot have an initializer."),An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive:C(1198,1,"An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198","An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."),Unterminated_Unicode_escape_sequence:C(1199,1,"Unterminated_Unicode_escape_sequence_1199","Unterminated Unicode escape sequence."),Line_terminator_not_permitted_before_arrow:C(1200,1,"Line_terminator_not_permitted_before_arrow_1200","Line terminator not permitted before arrow."),Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead:C(1202,1,"Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_1202",`Import assignment cannot be used when targeting ECMAScript modules. Consider using 'import * as ns from "mod"', 'import {a} from "mod"', 'import d from "mod"', or another module format instead.`),Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead:C(1203,1,"Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or__1203","Export assignment cannot be used when targeting ECMAScript modules. Consider using 'export default' or another module format instead."),Re_exporting_a_type_when_0_is_enabled_requires_using_export_type:C(1205,1,"Re_exporting_a_type_when_0_is_enabled_requires_using_export_type_1205","Re-exporting a type when '{0}' is enabled requires using 'export type'."),Decorators_are_not_valid_here:C(1206,1,"Decorators_are_not_valid_here_1206","Decorators are not valid here."),Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name:C(1207,1,"Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207","Decorators cannot be applied to multiple get/set accessors of the same name."),Invalid_optional_chain_from_new_expression_Did_you_mean_to_call_0:C(1209,1,"Invalid_optional_chain_from_new_expression_Did_you_mean_to_call_0_1209","Invalid optional chain from new expression. Did you mean to call '{0}()'?"),Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode:C(1210,1,"Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of__1210","Code contained in a class is evaluated in JavaScript's strict mode which does not allow this use of '{0}'. For more information, see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Strict_mode."),A_class_declaration_without_the_default_modifier_must_have_a_name:C(1211,1,"A_class_declaration_without_the_default_modifier_must_have_a_name_1211","A class declaration without the 'default' modifier must have a name."),Identifier_expected_0_is_a_reserved_word_in_strict_mode:C(1212,1,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212","Identifier expected. '{0}' is a reserved word in strict mode."),Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode:C(1213,1,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213","Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."),Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode:C(1214,1,"Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214","Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."),Invalid_use_of_0_Modules_are_automatically_in_strict_mode:C(1215,1,"Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215","Invalid use of '{0}'. Modules are automatically in strict mode."),Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules:C(1216,1,"Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules_1216","Identifier expected. '__esModule' is reserved as an exported marker when transforming ECMAScript modules."),Export_assignment_is_not_supported_when_module_flag_is_system:C(1218,1,"Export_assignment_is_not_supported_when_module_flag_is_system_1218","Export assignment is not supported when '--module' flag is 'system'."),Generators_are_not_allowed_in_an_ambient_context:C(1221,1,"Generators_are_not_allowed_in_an_ambient_context_1221","Generators are not allowed in an ambient context."),An_overload_signature_cannot_be_declared_as_a_generator:C(1222,1,"An_overload_signature_cannot_be_declared_as_a_generator_1222","An overload signature cannot be declared as a generator."),_0_tag_already_specified:C(1223,1,"_0_tag_already_specified_1223","'{0}' tag already specified."),Signature_0_must_be_a_type_predicate:C(1224,1,"Signature_0_must_be_a_type_predicate_1224","Signature '{0}' must be a type predicate."),Cannot_find_parameter_0:C(1225,1,"Cannot_find_parameter_0_1225","Cannot find parameter '{0}'."),Type_predicate_0_is_not_assignable_to_1:C(1226,1,"Type_predicate_0_is_not_assignable_to_1_1226","Type predicate '{0}' is not assignable to '{1}'."),Parameter_0_is_not_in_the_same_position_as_parameter_1:C(1227,1,"Parameter_0_is_not_in_the_same_position_as_parameter_1_1227","Parameter '{0}' is not in the same position as parameter '{1}'."),A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods:C(1228,1,"A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228","A type predicate is only allowed in return type position for functions and methods."),A_type_predicate_cannot_reference_a_rest_parameter:C(1229,1,"A_type_predicate_cannot_reference_a_rest_parameter_1229","A type predicate cannot reference a rest parameter."),A_type_predicate_cannot_reference_element_0_in_a_binding_pattern:C(1230,1,"A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230","A type predicate cannot reference element '{0}' in a binding pattern."),An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration:C(1231,1,"An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration_1231","An export assignment must be at the top level of a file or module declaration."),An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module:C(1232,1,"An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1232","An import declaration can only be used at the top level of a namespace or module."),An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module:C(1233,1,"An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1233","An export declaration can only be used at the top level of a namespace or module."),An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file:C(1234,1,"An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234","An ambient module declaration is only allowed at the top level in a file."),A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module:C(1235,1,"A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module_1235","A namespace declaration is only allowed at the top level of a namespace or module."),The_return_type_of_a_property_decorator_function_must_be_either_void_or_any:C(1236,1,"The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236","The return type of a property decorator function must be either 'void' or 'any'."),The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any:C(1237,1,"The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237","The return type of a parameter decorator function must be either 'void' or 'any'."),Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression:C(1238,1,"Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238","Unable to resolve signature of class decorator when called as an expression."),Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression:C(1239,1,"Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239","Unable to resolve signature of parameter decorator when called as an expression."),Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression:C(1240,1,"Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240","Unable to resolve signature of property decorator when called as an expression."),Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression:C(1241,1,"Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241","Unable to resolve signature of method decorator when called as an expression."),abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration:C(1242,1,"abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration_1242","'abstract' modifier can only appear on a class, method, or property declaration."),_0_modifier_cannot_be_used_with_1_modifier:C(1243,1,"_0_modifier_cannot_be_used_with_1_modifier_1243","'{0}' modifier cannot be used with '{1}' modifier."),Abstract_methods_can_only_appear_within_an_abstract_class:C(1244,1,"Abstract_methods_can_only_appear_within_an_abstract_class_1244","Abstract methods can only appear within an abstract class."),Method_0_cannot_have_an_implementation_because_it_is_marked_abstract:C(1245,1,"Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245","Method '{0}' cannot have an implementation because it is marked abstract."),An_interface_property_cannot_have_an_initializer:C(1246,1,"An_interface_property_cannot_have_an_initializer_1246","An interface property cannot have an initializer."),A_type_literal_property_cannot_have_an_initializer:C(1247,1,"A_type_literal_property_cannot_have_an_initializer_1247","A type literal property cannot have an initializer."),A_class_member_cannot_have_the_0_keyword:C(1248,1,"A_class_member_cannot_have_the_0_keyword_1248","A class member cannot have the '{0}' keyword."),A_decorator_can_only_decorate_a_method_implementation_not_an_overload:C(1249,1,"A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249","A decorator can only decorate a method implementation, not an overload."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5:C(1250,1,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_1250","Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode:C(1251,1,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_d_1251","Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Class definitions are automatically in strict mode."),Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode:C(1252,1,"Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_1252","Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Modules are automatically in strict mode."),Abstract_properties_can_only_appear_within_an_abstract_class:C(1253,1,"Abstract_properties_can_only_appear_within_an_abstract_class_1253","Abstract properties can only appear within an abstract class."),A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference:C(1254,1,"A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_refere_1254","A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."),A_definite_assignment_assertion_is_not_permitted_in_this_context:C(1255,1,"A_definite_assignment_assertion_is_not_permitted_in_this_context_1255","A definite assignment assertion '!' is not permitted in this context."),A_required_element_cannot_follow_an_optional_element:C(1257,1,"A_required_element_cannot_follow_an_optional_element_1257","A required element cannot follow an optional element."),A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration:C(1258,1,"A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration_1258","A default export must be at the top level of a file or module declaration."),Module_0_can_only_be_default_imported_using_the_1_flag:C(1259,1,"Module_0_can_only_be_default_imported_using_the_1_flag_1259","Module '{0}' can only be default-imported using the '{1}' flag"),Keywords_cannot_contain_escape_characters:C(1260,1,"Keywords_cannot_contain_escape_characters_1260","Keywords cannot contain escape characters."),Already_included_file_name_0_differs_from_file_name_1_only_in_casing:C(1261,1,"Already_included_file_name_0_differs_from_file_name_1_only_in_casing_1261","Already included file name '{0}' differs from file name '{1}' only in casing."),Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module:C(1262,1,"Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module_1262","Identifier expected. '{0}' is a reserved word at the top-level of a module."),Declarations_with_initializers_cannot_also_have_definite_assignment_assertions:C(1263,1,"Declarations_with_initializers_cannot_also_have_definite_assignment_assertions_1263","Declarations with initializers cannot also have definite assignment assertions."),Declarations_with_definite_assignment_assertions_must_also_have_type_annotations:C(1264,1,"Declarations_with_definite_assignment_assertions_must_also_have_type_annotations_1264","Declarations with definite assignment assertions must also have type annotations."),A_rest_element_cannot_follow_another_rest_element:C(1265,1,"A_rest_element_cannot_follow_another_rest_element_1265","A rest element cannot follow another rest element."),An_optional_element_cannot_follow_a_rest_element:C(1266,1,"An_optional_element_cannot_follow_a_rest_element_1266","An optional element cannot follow a rest element."),Property_0_cannot_have_an_initializer_because_it_is_marked_abstract:C(1267,1,"Property_0_cannot_have_an_initializer_because_it_is_marked_abstract_1267","Property '{0}' cannot have an initializer because it is marked abstract."),An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type:C(1268,1,"An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type_1268","An index signature parameter type must be 'string', 'number', 'symbol', or a template literal type."),Cannot_use_export_import_on_a_type_or_type_only_namespace_when_0_is_enabled:C(1269,1,"Cannot_use_export_import_on_a_type_or_type_only_namespace_when_0_is_enabled_1269","Cannot use 'export import' on a type or type-only namespace when '{0}' is enabled."),Decorator_function_return_type_0_is_not_assignable_to_type_1:C(1270,1,"Decorator_function_return_type_0_is_not_assignable_to_type_1_1270","Decorator function return type '{0}' is not assignable to type '{1}'."),Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any:C(1271,1,"Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any_1271","Decorator function return type is '{0}' but is expected to be 'void' or 'any'."),A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled:C(1272,1,"A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_w_1272","A type referenced in a decorated signature must be imported with 'import type' or a namespace import when 'isolatedModules' and 'emitDecoratorMetadata' are enabled."),_0_modifier_cannot_appear_on_a_type_parameter:C(1273,1,"_0_modifier_cannot_appear_on_a_type_parameter_1273","'{0}' modifier cannot appear on a type parameter"),_0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias:C(1274,1,"_0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias_1274","'{0}' modifier can only appear on a type parameter of a class, interface or type alias"),accessor_modifier_can_only_appear_on_a_property_declaration:C(1275,1,"accessor_modifier_can_only_appear_on_a_property_declaration_1275","'accessor' modifier can only appear on a property declaration."),An_accessor_property_cannot_be_declared_optional:C(1276,1,"An_accessor_property_cannot_be_declared_optional_1276","An 'accessor' property cannot be declared optional."),_0_modifier_can_only_appear_on_a_type_parameter_of_a_function_method_or_class:C(1277,1,"_0_modifier_can_only_appear_on_a_type_parameter_of_a_function_method_or_class_1277","'{0}' modifier can only appear on a type parameter of a function, method or class"),The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_0:C(1278,1,"The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_0_1278","The runtime will invoke the decorator with {1} arguments, but the decorator expects {0}."),The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_at_least_0:C(1279,1,"The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_at_least_0_1279","The runtime will invoke the decorator with {1} arguments, but the decorator expects at least {0}."),Namespaces_are_not_allowed_in_global_script_files_when_0_is_enabled_If_this_file_is_not_intended_to_be_a_global_script_set_moduleDetection_to_force_or_add_an_empty_export_statement:C(1280,1,"Namespaces_are_not_allowed_in_global_script_files_when_0_is_enabled_If_this_file_is_not_intended_to__1280","Namespaces are not allowed in global script files when '{0}' is enabled. If this file is not intended to be a global script, set 'moduleDetection' to 'force' or add an empty 'export {}' statement."),Cannot_access_0_from_another_file_without_qualification_when_1_is_enabled_Use_2_instead:C(1281,1,"Cannot_access_0_from_another_file_without_qualification_when_1_is_enabled_Use_2_instead_1281","Cannot access '{0}' from another file without qualification when '{1}' is enabled. Use '{2}' instead."),An_export_declaration_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type:C(1282,1,"An_export_declaration_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers__1282","An 'export =' declaration must reference a value when 'verbatimModuleSyntax' is enabled, but '{0}' only refers to a type."),An_export_declaration_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration:C(1283,1,"An_export_declaration_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolve_1283","An 'export =' declaration must reference a real value when 'verbatimModuleSyntax' is enabled, but '{0}' resolves to a type-only declaration."),An_export_default_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type:C(1284,1,"An_export_default_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_1284","An 'export default' must reference a value when 'verbatimModuleSyntax' is enabled, but '{0}' only refers to a type."),An_export_default_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration:C(1285,1,"An_export_default_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_1285","An 'export default' must reference a real value when 'verbatimModuleSyntax' is enabled, but '{0}' resolves to a type-only declaration."),ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled:C(1286,1,"ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled_1286","ESM syntax is not allowed in a CommonJS module when 'verbatimModuleSyntax' is enabled."),A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled:C(1287,1,"A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimM_1287","A top-level 'export' modifier cannot be used on value declarations in a CommonJS module when 'verbatimModuleSyntax' is enabled."),An_import_alias_cannot_resolve_to_a_type_or_type_only_declaration_when_verbatimModuleSyntax_is_enabled:C(1288,1,"An_import_alias_cannot_resolve_to_a_type_or_type_only_declaration_when_verbatimModuleSyntax_is_enabl_1288","An import alias cannot resolve to a type or type-only declaration when 'verbatimModuleSyntax' is enabled."),_0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported:C(1289,1,"_0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_1289","'{0}' resolves to a type-only declaration and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'import type' where '{0}' is imported."),_0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default:C(1290,1,"_0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_1290","'{0}' resolves to a type-only declaration and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'export type { {0} as default }'."),_0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported:C(1291,1,"_0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enable_1291","'{0}' resolves to a type and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'import type' where '{0}' is imported."),_0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default:C(1292,1,"_0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enable_1292","'{0}' resolves to a type and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'export type { {0} as default }'."),with_statements_are_not_allowed_in_an_async_function_block:C(1300,1,"with_statements_are_not_allowed_in_an_async_function_block_1300","'with' statements are not allowed in an async function block."),await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules:C(1308,1,"await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1308","'await' expressions are only allowed within async functions and at the top levels of modules."),The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level:C(1309,1,"The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level_1309","The current file is a CommonJS module and cannot use 'await' at the top level."),Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern:C(1312,1,"Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_1312","Did you mean to use a ':'? An '=' can only follow a property name when the containing object literal is part of a destructuring pattern."),The_body_of_an_if_statement_cannot_be_the_empty_statement:C(1313,1,"The_body_of_an_if_statement_cannot_be_the_empty_statement_1313","The body of an 'if' statement cannot be the empty statement."),Global_module_exports_may_only_appear_in_module_files:C(1314,1,"Global_module_exports_may_only_appear_in_module_files_1314","Global module exports may only appear in module files."),Global_module_exports_may_only_appear_in_declaration_files:C(1315,1,"Global_module_exports_may_only_appear_in_declaration_files_1315","Global module exports may only appear in declaration files."),Global_module_exports_may_only_appear_at_top_level:C(1316,1,"Global_module_exports_may_only_appear_at_top_level_1316","Global module exports may only appear at top level."),A_parameter_property_cannot_be_declared_using_a_rest_parameter:C(1317,1,"A_parameter_property_cannot_be_declared_using_a_rest_parameter_1317","A parameter property cannot be declared using a rest parameter."),An_abstract_accessor_cannot_have_an_implementation:C(1318,1,"An_abstract_accessor_cannot_have_an_implementation_1318","An abstract accessor cannot have an implementation."),A_default_export_can_only_be_used_in_an_ECMAScript_style_module:C(1319,1,"A_default_export_can_only_be_used_in_an_ECMAScript_style_module_1319","A default export can only be used in an ECMAScript-style module."),Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:C(1320,1,"Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member_1320","Type of 'await' operand must either be a valid promise or must not contain a callable 'then' member."),Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:C(1321,1,"Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_cal_1321","Type of 'yield' operand in an async generator must either be a valid promise or must not contain a callable 'then' member."),Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:C(1322,1,"Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_con_1322","Type of iterated elements of a 'yield*' operand must either be a valid promise or must not contain a callable 'then' member."),Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext:C(1323,1,"Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd__1323","Dynamic imports are only supported when the '--module' flag is set to 'es2020', 'es2022', 'esnext', 'commonjs', 'amd', 'system', 'umd', 'node16', or 'nodenext'."),Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext:C(1324,1,"Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nod_1324","Dynamic imports only support a second argument when the '--module' option is set to 'esnext', 'node16', or 'nodenext'."),Argument_of_dynamic_import_cannot_be_spread_element:C(1325,1,"Argument_of_dynamic_import_cannot_be_spread_element_1325","Argument of dynamic import cannot be spread element."),This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments:C(1326,1,"This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot__1326","This use of 'import' is invalid. 'import()' calls can be written, but they must have parentheses and cannot have type arguments."),String_literal_with_double_quotes_expected:C(1327,1,"String_literal_with_double_quotes_expected_1327","String literal with double quotes expected."),Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal:C(1328,1,"Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_li_1328","Property value can only be string literal, numeric literal, 'true', 'false', 'null', object literal or array literal."),_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0:C(1329,1,"_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write__1329","'{0}' accepts too few arguments to be used as a decorator here. Did you mean to call it first and write '@{0}()'?"),A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly:C(1330,1,"A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly_1330","A property of an interface or type literal whose type is a 'unique symbol' type must be 'readonly'."),A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly:C(1331,1,"A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly_1331","A property of a class whose type is a 'unique symbol' type must be both 'static' and 'readonly'."),A_variable_whose_type_is_a_unique_symbol_type_must_be_const:C(1332,1,"A_variable_whose_type_is_a_unique_symbol_type_must_be_const_1332","A variable whose type is a 'unique symbol' type must be 'const'."),unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name:C(1333,1,"unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name_1333","'unique symbol' types may not be used on a variable declaration with a binding name."),unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement:C(1334,1,"unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement_1334","'unique symbol' types are only allowed on variables in a variable statement."),unique_symbol_types_are_not_allowed_here:C(1335,1,"unique_symbol_types_are_not_allowed_here_1335","'unique symbol' types are not allowed here."),An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead:C(1337,1,"An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_o_1337","An index signature parameter type cannot be a literal type or generic type. Consider using a mapped object type instead."),infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type:C(1338,1,"infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type_1338","'infer' declarations are only permitted in the 'extends' clause of a conditional type."),Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here:C(1339,1,"Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here_1339","Module '{0}' does not refer to a value, but is used as a value here."),Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0:C(1340,1,"Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0_1340","Module '{0}' does not refer to a type, but is used as a type here. Did you mean 'typeof import('{0}')'?"),Class_constructor_may_not_be_an_accessor:C(1341,1,"Class_constructor_may_not_be_an_accessor_1341","Class constructor may not be an accessor."),The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext:C(1343,1,"The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system__1343","The 'import.meta' meta-property is only allowed when the '--module' option is 'es2020', 'es2022', 'esnext', 'system', 'node16', or 'nodenext'."),A_label_is_not_allowed_here:C(1344,1,"A_label_is_not_allowed_here_1344","'A label is not allowed here."),An_expression_of_type_void_cannot_be_tested_for_truthiness:C(1345,1,"An_expression_of_type_void_cannot_be_tested_for_truthiness_1345","An expression of type 'void' cannot be tested for truthiness."),This_parameter_is_not_allowed_with_use_strict_directive:C(1346,1,"This_parameter_is_not_allowed_with_use_strict_directive_1346","This parameter is not allowed with 'use strict' directive."),use_strict_directive_cannot_be_used_with_non_simple_parameter_list:C(1347,1,"use_strict_directive_cannot_be_used_with_non_simple_parameter_list_1347","'use strict' directive cannot be used with non-simple parameter list."),Non_simple_parameter_declared_here:C(1348,1,"Non_simple_parameter_declared_here_1348","Non-simple parameter declared here."),use_strict_directive_used_here:C(1349,1,"use_strict_directive_used_here_1349","'use strict' directive used here."),Print_the_final_configuration_instead_of_building:C(1350,3,"Print_the_final_configuration_instead_of_building_1350","Print the final configuration instead of building."),An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal:C(1351,1,"An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal_1351","An identifier or keyword cannot immediately follow a numeric literal."),A_bigint_literal_cannot_use_exponential_notation:C(1352,1,"A_bigint_literal_cannot_use_exponential_notation_1352","A bigint literal cannot use exponential notation."),A_bigint_literal_must_be_an_integer:C(1353,1,"A_bigint_literal_must_be_an_integer_1353","A bigint literal must be an integer."),readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types:C(1354,1,"readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types_1354","'readonly' type modifier is only permitted on array and tuple literal types."),A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals:C(1355,1,"A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array__1355","A 'const' assertions can only be applied to references to enum members, or string, number, boolean, array, or object literals."),Did_you_mean_to_mark_this_function_as_async:C(1356,1,"Did_you_mean_to_mark_this_function_as_async_1356","Did you mean to mark this function as 'async'?"),An_enum_member_name_must_be_followed_by_a_or:C(1357,1,"An_enum_member_name_must_be_followed_by_a_or_1357","An enum member name must be followed by a ',', '=', or '}'."),Tagged_template_expressions_are_not_permitted_in_an_optional_chain:C(1358,1,"Tagged_template_expressions_are_not_permitted_in_an_optional_chain_1358","Tagged template expressions are not permitted in an optional chain."),Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here:C(1359,1,"Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here_1359","Identifier expected. '{0}' is a reserved word that cannot be used here."),Type_0_does_not_satisfy_the_expected_type_1:C(1360,1,"Type_0_does_not_satisfy_the_expected_type_1_1360","Type '{0}' does not satisfy the expected type '{1}'."),_0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type:C(1361,1,"_0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type_1361","'{0}' cannot be used as a value because it was imported using 'import type'."),_0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type:C(1362,1,"_0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type_1362","'{0}' cannot be used as a value because it was exported using 'export type'."),A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both:C(1363,1,"A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both_1363","A type-only import can specify a default import or named bindings, but not both."),Convert_to_type_only_export:C(1364,3,"Convert_to_type_only_export_1364","Convert to type-only export"),Convert_all_re_exported_types_to_type_only_exports:C(1365,3,"Convert_all_re_exported_types_to_type_only_exports_1365","Convert all re-exported types to type-only exports"),Split_into_two_separate_import_declarations:C(1366,3,"Split_into_two_separate_import_declarations_1366","Split into two separate import declarations"),Split_all_invalid_type_only_imports:C(1367,3,"Split_all_invalid_type_only_imports_1367","Split all invalid type-only imports"),Class_constructor_may_not_be_a_generator:C(1368,1,"Class_constructor_may_not_be_a_generator_1368","Class constructor may not be a generator."),Did_you_mean_0:C(1369,3,"Did_you_mean_0_1369","Did you mean '{0}'?"),This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error:C(1371,1,"This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set__1371","This import is never used as a value and must use 'import type' because 'importsNotUsedAsValues' is set to 'error'."),await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module:C(1375,1,"await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_fi_1375","'await' expressions are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),_0_was_imported_here:C(1376,3,"_0_was_imported_here_1376","'{0}' was imported here."),_0_was_exported_here:C(1377,3,"_0_was_exported_here_1377","'{0}' was exported here."),Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher:C(1378,1,"Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_n_1378","Top-level 'await' expressions are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', 'nodenext', or 'preserve', and the 'target' option is set to 'es2017' or higher."),An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type:C(1379,1,"An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type_1379","An import alias cannot reference a declaration that was exported using 'export type'."),An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type:C(1380,1,"An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type_1380","An import alias cannot reference a declaration that was imported using 'import type'."),Unexpected_token_Did_you_mean_or_rbrace:C(1381,1,"Unexpected_token_Did_you_mean_or_rbrace_1381","Unexpected token. Did you mean `{'}'}` or `&rbrace;`?"),Unexpected_token_Did_you_mean_or_gt:C(1382,1,"Unexpected_token_Did_you_mean_or_gt_1382","Unexpected token. Did you mean `{'>'}` or `&gt;`?"),Function_type_notation_must_be_parenthesized_when_used_in_a_union_type:C(1385,1,"Function_type_notation_must_be_parenthesized_when_used_in_a_union_type_1385","Function type notation must be parenthesized when used in a union type."),Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type:C(1386,1,"Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type_1386","Constructor type notation must be parenthesized when used in a union type."),Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type:C(1387,1,"Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1387","Function type notation must be parenthesized when used in an intersection type."),Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type:C(1388,1,"Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1388","Constructor type notation must be parenthesized when used in an intersection type."),_0_is_not_allowed_as_a_variable_declaration_name:C(1389,1,"_0_is_not_allowed_as_a_variable_declaration_name_1389","'{0}' is not allowed as a variable declaration name."),_0_is_not_allowed_as_a_parameter_name:C(1390,1,"_0_is_not_allowed_as_a_parameter_name_1390","'{0}' is not allowed as a parameter name."),An_import_alias_cannot_use_import_type:C(1392,1,"An_import_alias_cannot_use_import_type_1392","An import alias cannot use 'import type'"),Imported_via_0_from_file_1:C(1393,3,"Imported_via_0_from_file_1_1393","Imported via {0} from file '{1}'"),Imported_via_0_from_file_1_with_packageId_2:C(1394,3,"Imported_via_0_from_file_1_with_packageId_2_1394","Imported via {0} from file '{1}' with packageId '{2}'"),Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions:C(1395,3,"Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions_1395","Imported via {0} from file '{1}' to import 'importHelpers' as specified in compilerOptions"),Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions:C(1396,3,"Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions_1396","Imported via {0} from file '{1}' with packageId '{2}' to import 'importHelpers' as specified in compilerOptions"),Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions:C(1397,3,"Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions_1397","Imported via {0} from file '{1}' to import 'jsx' and 'jsxs' factory functions"),Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions:C(1398,3,"Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions_1398","Imported via {0} from file '{1}' with packageId '{2}' to import 'jsx' and 'jsxs' factory functions"),File_is_included_via_import_here:C(1399,3,"File_is_included_via_import_here_1399","File is included via import here."),Referenced_via_0_from_file_1:C(1400,3,"Referenced_via_0_from_file_1_1400","Referenced via '{0}' from file '{1}'"),File_is_included_via_reference_here:C(1401,3,"File_is_included_via_reference_here_1401","File is included via reference here."),Type_library_referenced_via_0_from_file_1:C(1402,3,"Type_library_referenced_via_0_from_file_1_1402","Type library referenced via '{0}' from file '{1}'"),Type_library_referenced_via_0_from_file_1_with_packageId_2:C(1403,3,"Type_library_referenced_via_0_from_file_1_with_packageId_2_1403","Type library referenced via '{0}' from file '{1}' with packageId '{2}'"),File_is_included_via_type_library_reference_here:C(1404,3,"File_is_included_via_type_library_reference_here_1404","File is included via type library reference here."),Library_referenced_via_0_from_file_1:C(1405,3,"Library_referenced_via_0_from_file_1_1405","Library referenced via '{0}' from file '{1}'"),File_is_included_via_library_reference_here:C(1406,3,"File_is_included_via_library_reference_here_1406","File is included via library reference here."),Matched_by_include_pattern_0_in_1:C(1407,3,"Matched_by_include_pattern_0_in_1_1407","Matched by include pattern '{0}' in '{1}'"),File_is_matched_by_include_pattern_specified_here:C(1408,3,"File_is_matched_by_include_pattern_specified_here_1408","File is matched by include pattern specified here."),Part_of_files_list_in_tsconfig_json:C(1409,3,"Part_of_files_list_in_tsconfig_json_1409","Part of 'files' list in tsconfig.json"),File_is_matched_by_files_list_specified_here:C(1410,3,"File_is_matched_by_files_list_specified_here_1410","File is matched by 'files' list specified here."),Output_from_referenced_project_0_included_because_1_specified:C(1411,3,"Output_from_referenced_project_0_included_because_1_specified_1411","Output from referenced project '{0}' included because '{1}' specified"),Output_from_referenced_project_0_included_because_module_is_specified_as_none:C(1412,3,"Output_from_referenced_project_0_included_because_module_is_specified_as_none_1412","Output from referenced project '{0}' included because '--module' is specified as 'none'"),File_is_output_from_referenced_project_specified_here:C(1413,3,"File_is_output_from_referenced_project_specified_here_1413","File is output from referenced project specified here."),Source_from_referenced_project_0_included_because_1_specified:C(1414,3,"Source_from_referenced_project_0_included_because_1_specified_1414","Source from referenced project '{0}' included because '{1}' specified"),Source_from_referenced_project_0_included_because_module_is_specified_as_none:C(1415,3,"Source_from_referenced_project_0_included_because_module_is_specified_as_none_1415","Source from referenced project '{0}' included because '--module' is specified as 'none'"),File_is_source_from_referenced_project_specified_here:C(1416,3,"File_is_source_from_referenced_project_specified_here_1416","File is source from referenced project specified here."),Entry_point_of_type_library_0_specified_in_compilerOptions:C(1417,3,"Entry_point_of_type_library_0_specified_in_compilerOptions_1417","Entry point of type library '{0}' specified in compilerOptions"),Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1:C(1418,3,"Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1_1418","Entry point of type library '{0}' specified in compilerOptions with packageId '{1}'"),File_is_entry_point_of_type_library_specified_here:C(1419,3,"File_is_entry_point_of_type_library_specified_here_1419","File is entry point of type library specified here."),Entry_point_for_implicit_type_library_0:C(1420,3,"Entry_point_for_implicit_type_library_0_1420","Entry point for implicit type library '{0}'"),Entry_point_for_implicit_type_library_0_with_packageId_1:C(1421,3,"Entry_point_for_implicit_type_library_0_with_packageId_1_1421","Entry point for implicit type library '{0}' with packageId '{1}'"),Library_0_specified_in_compilerOptions:C(1422,3,"Library_0_specified_in_compilerOptions_1422","Library '{0}' specified in compilerOptions"),File_is_library_specified_here:C(1423,3,"File_is_library_specified_here_1423","File is library specified here."),Default_library:C(1424,3,"Default_library_1424","Default library"),Default_library_for_target_0:C(1425,3,"Default_library_for_target_0_1425","Default library for target '{0}'"),File_is_default_library_for_target_specified_here:C(1426,3,"File_is_default_library_for_target_specified_here_1426","File is default library for target specified here."),Root_file_specified_for_compilation:C(1427,3,"Root_file_specified_for_compilation_1427","Root file specified for compilation"),File_is_output_of_project_reference_source_0:C(1428,3,"File_is_output_of_project_reference_source_0_1428","File is output of project reference source '{0}'"),File_redirects_to_file_0:C(1429,3,"File_redirects_to_file_0_1429","File redirects to file '{0}'"),The_file_is_in_the_program_because_Colon:C(1430,3,"The_file_is_in_the_program_because_Colon_1430","The file is in the program because:"),for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module:C(1431,1,"for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_1431","'for await' loops are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher:C(1432,1,"Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_nod_1432","Top-level 'for await' loops are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', 'nodenext', or 'preserve', and the 'target' option is set to 'es2017' or higher."),Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters:C(1433,1,"Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters_1433","Neither decorators nor modifiers may be applied to 'this' parameters."),Unexpected_keyword_or_identifier:C(1434,1,"Unexpected_keyword_or_identifier_1434","Unexpected keyword or identifier."),Unknown_keyword_or_identifier_Did_you_mean_0:C(1435,1,"Unknown_keyword_or_identifier_Did_you_mean_0_1435","Unknown keyword or identifier. Did you mean '{0}'?"),Decorators_must_precede_the_name_and_all_keywords_of_property_declarations:C(1436,1,"Decorators_must_precede_the_name_and_all_keywords_of_property_declarations_1436","Decorators must precede the name and all keywords of property declarations."),Namespace_must_be_given_a_name:C(1437,1,"Namespace_must_be_given_a_name_1437","Namespace must be given a name."),Interface_must_be_given_a_name:C(1438,1,"Interface_must_be_given_a_name_1438","Interface must be given a name."),Type_alias_must_be_given_a_name:C(1439,1,"Type_alias_must_be_given_a_name_1439","Type alias must be given a name."),Variable_declaration_not_allowed_at_this_location:C(1440,1,"Variable_declaration_not_allowed_at_this_location_1440","Variable declaration not allowed at this location."),Cannot_start_a_function_call_in_a_type_annotation:C(1441,1,"Cannot_start_a_function_call_in_a_type_annotation_1441","Cannot start a function call in a type annotation."),Expected_for_property_initializer:C(1442,1,"Expected_for_property_initializer_1442","Expected '=' for property initializer."),Module_declaration_names_may_only_use_or_quoted_strings:C(1443,1,"Module_declaration_names_may_only_use_or_quoted_strings_1443",`Module declaration names may only use ' or " quoted strings.`),_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled:C(1444,1,"_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedMod_1444","'{0}' is a type and must be imported using a type-only import when 'preserveValueImports' and 'isolatedModules' are both enabled."),_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled:C(1446,1,"_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveVa_1446","'{0}' resolves to a type-only declaration and must be imported using a type-only import when 'preserveValueImports' and 'isolatedModules' are both enabled."),_0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_1_is_enabled:C(1448,1,"_0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_1_is_1448","'{0}' resolves to a type-only declaration and must be re-exported using a type-only re-export when '{1}' is enabled."),Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed:C(1449,3,"Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed_1449","Preserve unused imported values in the JavaScript output that would otherwise be removed."),Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments:C(1450,3,"Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments_1450","Dynamic imports can only accept a module specifier and an optional set of attributes as arguments"),Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression:C(1451,1,"Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member__1451","Private identifiers are only allowed in class bodies and may only be used as part of a class member declaration, property access, or on the left-hand-side of an 'in' expression"),resolution_mode_should_be_either_require_or_import:C(1453,1,"resolution_mode_should_be_either_require_or_import_1453","`resolution-mode` should be either `require` or `import`."),resolution_mode_can_only_be_set_for_type_only_imports:C(1454,1,"resolution_mode_can_only_be_set_for_type_only_imports_1454","`resolution-mode` can only be set for type-only imports."),resolution_mode_is_the_only_valid_key_for_type_import_assertions:C(1455,1,"resolution_mode_is_the_only_valid_key_for_type_import_assertions_1455","`resolution-mode` is the only valid key for type import assertions."),Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require:C(1456,1,"Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require_1456","Type import assertions should have exactly one key - `resolution-mode` - with value `import` or `require`."),Matched_by_default_include_pattern_Asterisk_Asterisk_Slash_Asterisk:C(1457,3,"Matched_by_default_include_pattern_Asterisk_Asterisk_Slash_Asterisk_1457","Matched by default include pattern '**/*'"),File_is_ECMAScript_module_because_0_has_field_type_with_value_module:C(1458,3,"File_is_ECMAScript_module_because_0_has_field_type_with_value_module_1458",`File is ECMAScript module because '{0}' has field "type" with value "module"`),File_is_CommonJS_module_because_0_has_field_type_whose_value_is_not_module:C(1459,3,"File_is_CommonJS_module_because_0_has_field_type_whose_value_is_not_module_1459",`File is CommonJS module because '{0}' has field "type" whose value is not "module"`),File_is_CommonJS_module_because_0_does_not_have_field_type:C(1460,3,"File_is_CommonJS_module_because_0_does_not_have_field_type_1460",`File is CommonJS module because '{0}' does not have field "type"`),File_is_CommonJS_module_because_package_json_was_not_found:C(1461,3,"File_is_CommonJS_module_because_package_json_was_not_found_1461","File is CommonJS module because 'package.json' was not found"),resolution_mode_is_the_only_valid_key_for_type_import_attributes:C(1463,1,"resolution_mode_is_the_only_valid_key_for_type_import_attributes_1463","'resolution-mode' is the only valid key for type import attributes."),Type_import_attributes_should_have_exactly_one_key_resolution_mode_with_value_import_or_require:C(1464,1,"Type_import_attributes_should_have_exactly_one_key_resolution_mode_with_value_import_or_require_1464","Type import attributes should have exactly one key - 'resolution-mode' - with value 'import' or 'require'."),The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output:C(1470,1,"The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output_1470","The 'import.meta' meta-property is not allowed in files which will build into CommonJS output."),Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_with_require_Use_an_ECMAScript_import_instead:C(1471,1,"Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_c_1471","Module '{0}' cannot be imported using this construct. The specifier only resolves to an ES module, which cannot be imported with 'require'. Use an ECMAScript import instead."),catch_or_finally_expected:C(1472,1,"catch_or_finally_expected_1472","'catch' or 'finally' expected."),An_import_declaration_can_only_be_used_at_the_top_level_of_a_module:C(1473,1,"An_import_declaration_can_only_be_used_at_the_top_level_of_a_module_1473","An import declaration can only be used at the top level of a module."),An_export_declaration_can_only_be_used_at_the_top_level_of_a_module:C(1474,1,"An_export_declaration_can_only_be_used_at_the_top_level_of_a_module_1474","An export declaration can only be used at the top level of a module."),Control_what_method_is_used_to_detect_module_format_JS_files:C(1475,3,"Control_what_method_is_used_to_detect_module_format_JS_files_1475","Control what method is used to detect module-format JS files."),auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules:C(1476,3,"auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_w_1476",'"auto": Treat files with imports, exports, import.meta, jsx (with jsx: react-jsx), or esm format (with module: node16+) as modules.'),An_instantiation_expression_cannot_be_followed_by_a_property_access:C(1477,1,"An_instantiation_expression_cannot_be_followed_by_a_property_access_1477","An instantiation expression cannot be followed by a property access."),Identifier_or_string_literal_expected:C(1478,1,"Identifier_or_string_literal_expected_1478","Identifier or string literal expected."),The_current_file_is_a_CommonJS_module_whose_imports_will_produce_require_calls_however_the_referenced_file_is_an_ECMAScript_module_and_cannot_be_imported_with_require_Consider_writing_a_dynamic_import_0_call_instead:C(1479,1,"The_current_file_is_a_CommonJS_module_whose_imports_will_produce_require_calls_however_the_reference_1479",`The current file is a CommonJS module whose imports will produce 'require' calls; however, the referenced file is an ECMAScript module and cannot be imported with 'require'. Consider writing a dynamic 'import("{0}")' call instead.`),To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_create_a_local_package_json_file_with_type_Colon_module:C(1480,3,"To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_create_a_local_packag_1480",'To convert this file to an ECMAScript module, change its file extension to \'{0}\' or create a local package.json file with `{ "type": "module" }`.'),To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_add_the_field_type_Colon_module_to_1:C(1481,3,"To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_add_the_field_type_Co_1481",`To convert this file to an ECMAScript module, change its file extension to '{0}', or add the field \`"type": "module"\` to '{1}'.`),To_convert_this_file_to_an_ECMAScript_module_add_the_field_type_Colon_module_to_0:C(1482,3,"To_convert_this_file_to_an_ECMAScript_module_add_the_field_type_Colon_module_to_0_1482",'To convert this file to an ECMAScript module, add the field `"type": "module"` to \'{0}\'.'),To_convert_this_file_to_an_ECMAScript_module_create_a_local_package_json_file_with_type_Colon_module:C(1483,3,"To_convert_this_file_to_an_ECMAScript_module_create_a_local_package_json_file_with_type_Colon_module_1483",'To convert this file to an ECMAScript module, create a local package.json file with `{ "type": "module" }`.'),_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled:C(1484,1,"_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled_1484","'{0}' is a type and must be imported using a type-only import when 'verbatimModuleSyntax' is enabled."),_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled:C(1485,1,"_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimMo_1485","'{0}' resolves to a type-only declaration and must be imported using a type-only import when 'verbatimModuleSyntax' is enabled."),Decorator_used_before_export_here:C(1486,1,"Decorator_used_before_export_here_1486","Decorator used before 'export' here."),Octal_escape_sequences_are_not_allowed_Use_the_syntax_0:C(1487,1,"Octal_escape_sequences_are_not_allowed_Use_the_syntax_0_1487","Octal escape sequences are not allowed. Use the syntax '{0}'."),Escape_sequence_0_is_not_allowed:C(1488,1,"Escape_sequence_0_is_not_allowed_1488","Escape sequence '{0}' is not allowed."),Decimals_with_leading_zeros_are_not_allowed:C(1489,1,"Decimals_with_leading_zeros_are_not_allowed_1489","Decimals with leading zeros are not allowed."),File_appears_to_be_binary:C(1490,1,"File_appears_to_be_binary_1490","File appears to be binary."),_0_modifier_cannot_appear_on_a_using_declaration:C(1491,1,"_0_modifier_cannot_appear_on_a_using_declaration_1491","'{0}' modifier cannot appear on a 'using' declaration."),_0_declarations_may_not_have_binding_patterns:C(1492,1,"_0_declarations_may_not_have_binding_patterns_1492","'{0}' declarations may not have binding patterns."),The_left_hand_side_of_a_for_in_statement_cannot_be_a_using_declaration:C(1493,1,"The_left_hand_side_of_a_for_in_statement_cannot_be_a_using_declaration_1493","The left-hand side of a 'for...in' statement cannot be a 'using' declaration."),The_left_hand_side_of_a_for_in_statement_cannot_be_an_await_using_declaration:C(1494,1,"The_left_hand_side_of_a_for_in_statement_cannot_be_an_await_using_declaration_1494","The left-hand side of a 'for...in' statement cannot be an 'await using' declaration."),_0_modifier_cannot_appear_on_an_await_using_declaration:C(1495,1,"_0_modifier_cannot_appear_on_an_await_using_declaration_1495","'{0}' modifier cannot appear on an 'await using' declaration."),Identifier_string_literal_or_number_literal_expected:C(1496,1,"Identifier_string_literal_or_number_literal_expected_1496","Identifier, string literal, or number literal expected."),The_types_of_0_are_incompatible_between_these_types:C(2200,1,"The_types_of_0_are_incompatible_between_these_types_2200","The types of '{0}' are incompatible between these types."),The_types_returned_by_0_are_incompatible_between_these_types:C(2201,1,"The_types_returned_by_0_are_incompatible_between_these_types_2201","The types returned by '{0}' are incompatible between these types."),Call_signature_return_types_0_and_1_are_incompatible:C(2202,1,"Call_signature_return_types_0_and_1_are_incompatible_2202","Call signature return types '{0}' and '{1}' are incompatible.",void 0,!0),Construct_signature_return_types_0_and_1_are_incompatible:C(2203,1,"Construct_signature_return_types_0_and_1_are_incompatible_2203","Construct signature return types '{0}' and '{1}' are incompatible.",void 0,!0),Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1:C(2204,1,"Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2204","Call signatures with no arguments have incompatible return types '{0}' and '{1}'.",void 0,!0),Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1:C(2205,1,"Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2205","Construct signatures with no arguments have incompatible return types '{0}' and '{1}'.",void 0,!0),The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement:C(2206,1,"The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement_2206","The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement."),The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement:C(2207,1,"The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement_2207","The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement."),This_type_parameter_might_need_an_extends_0_constraint:C(2208,1,"This_type_parameter_might_need_an_extends_0_constraint_2208","This type parameter might need an `extends {0}` constraint."),The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate:C(2209,1,"The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_roo_2209","The project root is ambiguous, but is required to resolve export map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."),The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate:C(2210,1,"The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_roo_2210","The project root is ambiguous, but is required to resolve import map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."),Add_extends_constraint:C(2211,3,"Add_extends_constraint_2211","Add `extends` constraint."),Add_extends_constraint_to_all_type_parameters:C(2212,3,"Add_extends_constraint_to_all_type_parameters_2212","Add `extends` constraint to all type parameters"),Duplicate_identifier_0:C(2300,1,"Duplicate_identifier_0_2300","Duplicate identifier '{0}'."),Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor:C(2301,1,"Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301","Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),Static_members_cannot_reference_class_type_parameters:C(2302,1,"Static_members_cannot_reference_class_type_parameters_2302","Static members cannot reference class type parameters."),Circular_definition_of_import_alias_0:C(2303,1,"Circular_definition_of_import_alias_0_2303","Circular definition of import alias '{0}'."),Cannot_find_name_0:C(2304,1,"Cannot_find_name_0_2304","Cannot find name '{0}'."),Module_0_has_no_exported_member_1:C(2305,1,"Module_0_has_no_exported_member_1_2305","Module '{0}' has no exported member '{1}'."),File_0_is_not_a_module:C(2306,1,"File_0_is_not_a_module_2306","File '{0}' is not a module."),Cannot_find_module_0_or_its_corresponding_type_declarations:C(2307,1,"Cannot_find_module_0_or_its_corresponding_type_declarations_2307","Cannot find module '{0}' or its corresponding type declarations."),Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity:C(2308,1,"Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308","Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."),An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements:C(2309,1,"An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309","An export assignment cannot be used in a module with other exported elements."),Type_0_recursively_references_itself_as_a_base_type:C(2310,1,"Type_0_recursively_references_itself_as_a_base_type_2310","Type '{0}' recursively references itself as a base type."),Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function:C(2311,1,"Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function_2311","Cannot find name '{0}'. Did you mean to write this in an async function?"),An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members:C(2312,1,"An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_me_2312","An interface can only extend an object type or intersection of object types with statically known members."),Type_parameter_0_has_a_circular_constraint:C(2313,1,"Type_parameter_0_has_a_circular_constraint_2313","Type parameter '{0}' has a circular constraint."),Generic_type_0_requires_1_type_argument_s:C(2314,1,"Generic_type_0_requires_1_type_argument_s_2314","Generic type '{0}' requires {1} type argument(s)."),Type_0_is_not_generic:C(2315,1,"Type_0_is_not_generic_2315","Type '{0}' is not generic."),Global_type_0_must_be_a_class_or_interface_type:C(2316,1,"Global_type_0_must_be_a_class_or_interface_type_2316","Global type '{0}' must be a class or interface type."),Global_type_0_must_have_1_type_parameter_s:C(2317,1,"Global_type_0_must_have_1_type_parameter_s_2317","Global type '{0}' must have {1} type parameter(s)."),Cannot_find_global_type_0:C(2318,1,"Cannot_find_global_type_0_2318","Cannot find global type '{0}'."),Named_property_0_of_types_1_and_2_are_not_identical:C(2319,1,"Named_property_0_of_types_1_and_2_are_not_identical_2319","Named property '{0}' of types '{1}' and '{2}' are not identical."),Interface_0_cannot_simultaneously_extend_types_1_and_2:C(2320,1,"Interface_0_cannot_simultaneously_extend_types_1_and_2_2320","Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."),Excessive_stack_depth_comparing_types_0_and_1:C(2321,1,"Excessive_stack_depth_comparing_types_0_and_1_2321","Excessive stack depth comparing types '{0}' and '{1}'."),Type_0_is_not_assignable_to_type_1:C(2322,1,"Type_0_is_not_assignable_to_type_1_2322","Type '{0}' is not assignable to type '{1}'."),Cannot_redeclare_exported_variable_0:C(2323,1,"Cannot_redeclare_exported_variable_0_2323","Cannot redeclare exported variable '{0}'."),Property_0_is_missing_in_type_1:C(2324,1,"Property_0_is_missing_in_type_1_2324","Property '{0}' is missing in type '{1}'."),Property_0_is_private_in_type_1_but_not_in_type_2:C(2325,1,"Property_0_is_private_in_type_1_but_not_in_type_2_2325","Property '{0}' is private in type '{1}' but not in type '{2}'."),Types_of_property_0_are_incompatible:C(2326,1,"Types_of_property_0_are_incompatible_2326","Types of property '{0}' are incompatible."),Property_0_is_optional_in_type_1_but_required_in_type_2:C(2327,1,"Property_0_is_optional_in_type_1_but_required_in_type_2_2327","Property '{0}' is optional in type '{1}' but required in type '{2}'."),Types_of_parameters_0_and_1_are_incompatible:C(2328,1,"Types_of_parameters_0_and_1_are_incompatible_2328","Types of parameters '{0}' and '{1}' are incompatible."),Index_signature_for_type_0_is_missing_in_type_1:C(2329,1,"Index_signature_for_type_0_is_missing_in_type_1_2329","Index signature for type '{0}' is missing in type '{1}'."),_0_and_1_index_signatures_are_incompatible:C(2330,1,"_0_and_1_index_signatures_are_incompatible_2330","'{0}' and '{1}' index signatures are incompatible."),this_cannot_be_referenced_in_a_module_or_namespace_body:C(2331,1,"this_cannot_be_referenced_in_a_module_or_namespace_body_2331","'this' cannot be referenced in a module or namespace body."),this_cannot_be_referenced_in_current_location:C(2332,1,"this_cannot_be_referenced_in_current_location_2332","'this' cannot be referenced in current location."),this_cannot_be_referenced_in_constructor_arguments:C(2333,1,"this_cannot_be_referenced_in_constructor_arguments_2333","'this' cannot be referenced in constructor arguments."),this_cannot_be_referenced_in_a_static_property_initializer:C(2334,1,"this_cannot_be_referenced_in_a_static_property_initializer_2334","'this' cannot be referenced in a static property initializer."),super_can_only_be_referenced_in_a_derived_class:C(2335,1,"super_can_only_be_referenced_in_a_derived_class_2335","'super' can only be referenced in a derived class."),super_cannot_be_referenced_in_constructor_arguments:C(2336,1,"super_cannot_be_referenced_in_constructor_arguments_2336","'super' cannot be referenced in constructor arguments."),Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors:C(2337,1,"Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337","Super calls are not permitted outside constructors or in nested functions inside constructors."),super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class:C(2338,1,"super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338","'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."),Property_0_does_not_exist_on_type_1:C(2339,1,"Property_0_does_not_exist_on_type_1_2339","Property '{0}' does not exist on type '{1}'."),Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword:C(2340,1,"Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340","Only public and protected methods of the base class are accessible via the 'super' keyword."),Property_0_is_private_and_only_accessible_within_class_1:C(2341,1,"Property_0_is_private_and_only_accessible_within_class_1_2341","Property '{0}' is private and only accessible within class '{1}'."),This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0:C(2343,1,"This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_ve_2343","This syntax requires an imported helper named '{1}' which does not exist in '{0}'. Consider upgrading your version of '{0}'."),Type_0_does_not_satisfy_the_constraint_1:C(2344,1,"Type_0_does_not_satisfy_the_constraint_1_2344","Type '{0}' does not satisfy the constraint '{1}'."),Argument_of_type_0_is_not_assignable_to_parameter_of_type_1:C(2345,1,"Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345","Argument of type '{0}' is not assignable to parameter of type '{1}'."),Untyped_function_calls_may_not_accept_type_arguments:C(2347,1,"Untyped_function_calls_may_not_accept_type_arguments_2347","Untyped function calls may not accept type arguments."),Value_of_type_0_is_not_callable_Did_you_mean_to_include_new:C(2348,1,"Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348","Value of type '{0}' is not callable. Did you mean to include 'new'?"),This_expression_is_not_callable:C(2349,1,"This_expression_is_not_callable_2349","This expression is not callable."),Only_a_void_function_can_be_called_with_the_new_keyword:C(2350,1,"Only_a_void_function_can_be_called_with_the_new_keyword_2350","Only a void function can be called with the 'new' keyword."),This_expression_is_not_constructable:C(2351,1,"This_expression_is_not_constructable_2351","This expression is not constructable."),Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first:C(2352,1,"Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the__2352","Conversion of type '{0}' to type '{1}' may be a mistake because neither type sufficiently overlaps with the other. If this was intentional, convert the expression to 'unknown' first."),Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1:C(2353,1,"Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353","Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."),This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found:C(2354,1,"This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found_2354","This syntax requires an imported helper but module '{0}' cannot be found."),A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value:C(2355,1,"A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value_2355","A function whose declared type is neither 'undefined', 'void', nor 'any' must return a value."),An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type:C(2356,1,"An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type_2356","An arithmetic operand must be of type 'any', 'number', 'bigint' or an enum type."),The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access:C(2357,1,"The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access_2357","The operand of an increment or decrement operator must be a variable or a property access."),The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter:C(2358,1,"The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358","The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."),The_right_hand_side_of_an_instanceof_expression_must_be_either_of_type_any_a_class_function_or_other_type_assignable_to_the_Function_interface_type_or_an_object_type_with_a_Symbol_hasInstance_method:C(2359,1,"The_right_hand_side_of_an_instanceof_expression_must_be_either_of_type_any_a_class_function_or_other_2359","The right-hand side of an 'instanceof' expression must be either of type 'any', a class, function, or other type assignable to the 'Function' interface type, or an object type with a 'Symbol.hasInstance' method."),The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type:C(2362,1,"The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2362","The left-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type:C(2363,1,"The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2363","The right-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access:C(2364,1,"The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access_2364","The left-hand side of an assignment expression must be a variable or a property access."),Operator_0_cannot_be_applied_to_types_1_and_2:C(2365,1,"Operator_0_cannot_be_applied_to_types_1_and_2_2365","Operator '{0}' cannot be applied to types '{1}' and '{2}'."),Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined:C(2366,1,"Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined_2366","Function lacks ending return statement and return type does not include 'undefined'."),This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap:C(2367,1,"This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap_2367","This comparison appears to be unintentional because the types '{0}' and '{1}' have no overlap."),Type_parameter_name_cannot_be_0:C(2368,1,"Type_parameter_name_cannot_be_0_2368","Type parameter name cannot be '{0}'."),A_parameter_property_is_only_allowed_in_a_constructor_implementation:C(2369,1,"A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369","A parameter property is only allowed in a constructor implementation."),A_rest_parameter_must_be_of_an_array_type:C(2370,1,"A_rest_parameter_must_be_of_an_array_type_2370","A rest parameter must be of an array type."),A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation:C(2371,1,"A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371","A parameter initializer is only allowed in a function or constructor implementation."),Parameter_0_cannot_reference_itself:C(2372,1,"Parameter_0_cannot_reference_itself_2372","Parameter '{0}' cannot reference itself."),Parameter_0_cannot_reference_identifier_1_declared_after_it:C(2373,1,"Parameter_0_cannot_reference_identifier_1_declared_after_it_2373","Parameter '{0}' cannot reference identifier '{1}' declared after it."),Duplicate_index_signature_for_type_0:C(2374,1,"Duplicate_index_signature_for_type_0_2374","Duplicate index signature for type '{0}'."),Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties:C(2375,1,"Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2375","Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."),A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers:C(2376,1,"A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_2376","A 'super' call must be the first statement in the constructor to refer to 'super' or 'this' when a derived class contains initialized properties, parameter properties, or private identifiers."),Constructors_for_derived_classes_must_contain_a_super_call:C(2377,1,"Constructors_for_derived_classes_must_contain_a_super_call_2377","Constructors for derived classes must contain a 'super' call."),A_get_accessor_must_return_a_value:C(2378,1,"A_get_accessor_must_return_a_value_2378","A 'get' accessor must return a value."),Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties:C(2379,1,"Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_tr_2379","Argument of type '{0}' is not assignable to parameter of type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."),Overload_signatures_must_all_be_exported_or_non_exported:C(2383,1,"Overload_signatures_must_all_be_exported_or_non_exported_2383","Overload signatures must all be exported or non-exported."),Overload_signatures_must_all_be_ambient_or_non_ambient:C(2384,1,"Overload_signatures_must_all_be_ambient_or_non_ambient_2384","Overload signatures must all be ambient or non-ambient."),Overload_signatures_must_all_be_public_private_or_protected:C(2385,1,"Overload_signatures_must_all_be_public_private_or_protected_2385","Overload signatures must all be public, private or protected."),Overload_signatures_must_all_be_optional_or_required:C(2386,1,"Overload_signatures_must_all_be_optional_or_required_2386","Overload signatures must all be optional or required."),Function_overload_must_be_static:C(2387,1,"Function_overload_must_be_static_2387","Function overload must be static."),Function_overload_must_not_be_static:C(2388,1,"Function_overload_must_not_be_static_2388","Function overload must not be static."),Function_implementation_name_must_be_0:C(2389,1,"Function_implementation_name_must_be_0_2389","Function implementation name must be '{0}'."),Constructor_implementation_is_missing:C(2390,1,"Constructor_implementation_is_missing_2390","Constructor implementation is missing."),Function_implementation_is_missing_or_not_immediately_following_the_declaration:C(2391,1,"Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391","Function implementation is missing or not immediately following the declaration."),Multiple_constructor_implementations_are_not_allowed:C(2392,1,"Multiple_constructor_implementations_are_not_allowed_2392","Multiple constructor implementations are not allowed."),Duplicate_function_implementation:C(2393,1,"Duplicate_function_implementation_2393","Duplicate function implementation."),This_overload_signature_is_not_compatible_with_its_implementation_signature:C(2394,1,"This_overload_signature_is_not_compatible_with_its_implementation_signature_2394","This overload signature is not compatible with its implementation signature."),Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local:C(2395,1,"Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395","Individual declarations in merged declaration '{0}' must be all exported or all local."),Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters:C(2396,1,"Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396","Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."),Declaration_name_conflicts_with_built_in_global_identifier_0:C(2397,1,"Declaration_name_conflicts_with_built_in_global_identifier_0_2397","Declaration name conflicts with built-in global identifier '{0}'."),constructor_cannot_be_used_as_a_parameter_property_name:C(2398,1,"constructor_cannot_be_used_as_a_parameter_property_name_2398","'constructor' cannot be used as a parameter property name."),Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference:C(2399,1,"Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399","Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."),Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference:C(2400,1,"Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400","Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."),A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers:C(2401,1,"A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_in_2401","A 'super' call must be a root-level statement within a constructor of a derived class that contains initialized properties, parameter properties, or private identifiers."),Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference:C(2402,1,"Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402","Expression resolves to '_super' that compiler uses to capture base class reference."),Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2:C(2403,1,"Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403","Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."),The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation:C(2404,1,"The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404","The left-hand side of a 'for...in' statement cannot use a type annotation."),The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any:C(2405,1,"The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405","The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."),The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access:C(2406,1,"The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access_2406","The left-hand side of a 'for...in' statement must be a variable or a property access."),The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0:C(2407,1,"The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_2407","The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter, but here has type '{0}'."),Setters_cannot_return_a_value:C(2408,1,"Setters_cannot_return_a_value_2408","Setters cannot return a value."),Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class:C(2409,1,"Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409","Return type of constructor signature must be assignable to the instance type of the class."),The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any:C(2410,1,"The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any_2410","The 'with' statement is not supported. All symbols in a 'with' block will have type 'any'."),Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target:C(2412,1,"Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2412","Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the type of the target."),Property_0_of_type_1_is_not_assignable_to_2_index_type_3:C(2411,1,"Property_0_of_type_1_is_not_assignable_to_2_index_type_3_2411","Property '{0}' of type '{1}' is not assignable to '{2}' index type '{3}'."),_0_index_type_1_is_not_assignable_to_2_index_type_3:C(2413,1,"_0_index_type_1_is_not_assignable_to_2_index_type_3_2413","'{0}' index type '{1}' is not assignable to '{2}' index type '{3}'."),Class_name_cannot_be_0:C(2414,1,"Class_name_cannot_be_0_2414","Class name cannot be '{0}'."),Class_0_incorrectly_extends_base_class_1:C(2415,1,"Class_0_incorrectly_extends_base_class_1_2415","Class '{0}' incorrectly extends base class '{1}'."),Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2:C(2416,1,"Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2_2416","Property '{0}' in type '{1}' is not assignable to the same property in base type '{2}'."),Class_static_side_0_incorrectly_extends_base_class_static_side_1:C(2417,1,"Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417","Class static side '{0}' incorrectly extends base class static side '{1}'."),Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1:C(2418,1,"Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1_2418","Type of computed property's value is '{0}', which is not assignable to type '{1}'."),Types_of_construct_signatures_are_incompatible:C(2419,1,"Types_of_construct_signatures_are_incompatible_2419","Types of construct signatures are incompatible."),Class_0_incorrectly_implements_interface_1:C(2420,1,"Class_0_incorrectly_implements_interface_1_2420","Class '{0}' incorrectly implements interface '{1}'."),A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members:C(2422,1,"A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_memb_2422","A class can only implement an object type or intersection of object types with statically known members."),Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor:C(2423,1,"Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423","Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."),Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function:C(2425,1,"Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425","Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."),Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function:C(2426,1,"Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426","Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."),Interface_name_cannot_be_0:C(2427,1,"Interface_name_cannot_be_0_2427","Interface name cannot be '{0}'."),All_declarations_of_0_must_have_identical_type_parameters:C(2428,1,"All_declarations_of_0_must_have_identical_type_parameters_2428","All declarations of '{0}' must have identical type parameters."),Interface_0_incorrectly_extends_interface_1:C(2430,1,"Interface_0_incorrectly_extends_interface_1_2430","Interface '{0}' incorrectly extends interface '{1}'."),Enum_name_cannot_be_0:C(2431,1,"Enum_name_cannot_be_0_2431","Enum name cannot be '{0}'."),In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element:C(2432,1,"In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432","In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."),A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged:C(2433,1,"A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433","A namespace declaration cannot be in a different file from a class or function with which it is merged."),A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged:C(2434,1,"A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434","A namespace declaration cannot be located prior to a class or function with which it is merged."),Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces:C(2435,1,"Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435","Ambient modules cannot be nested in other modules or namespaces."),Ambient_module_declaration_cannot_specify_relative_module_name:C(2436,1,"Ambient_module_declaration_cannot_specify_relative_module_name_2436","Ambient module declaration cannot specify relative module name."),Module_0_is_hidden_by_a_local_declaration_with_the_same_name:C(2437,1,"Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437","Module '{0}' is hidden by a local declaration with the same name."),Import_name_cannot_be_0:C(2438,1,"Import_name_cannot_be_0_2438","Import name cannot be '{0}'."),Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name:C(2439,1,"Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439","Import or export declaration in an ambient module declaration cannot reference module through relative module name."),Import_declaration_conflicts_with_local_declaration_of_0:C(2440,1,"Import_declaration_conflicts_with_local_declaration_of_0_2440","Import declaration conflicts with local declaration of '{0}'."),Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module:C(2441,1,"Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441","Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."),Types_have_separate_declarations_of_a_private_property_0:C(2442,1,"Types_have_separate_declarations_of_a_private_property_0_2442","Types have separate declarations of a private property '{0}'."),Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2:C(2443,1,"Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443","Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."),Property_0_is_protected_in_type_1_but_public_in_type_2:C(2444,1,"Property_0_is_protected_in_type_1_but_public_in_type_2_2444","Property '{0}' is protected in type '{1}' but public in type '{2}'."),Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses:C(2445,1,"Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445","Property '{0}' is protected and only accessible within class '{1}' and its subclasses."),Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2:C(2446,1,"Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_cl_2446","Property '{0}' is protected and only accessible through an instance of class '{1}'. This is an instance of class '{2}'."),The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead:C(2447,1,"The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447","The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."),Block_scoped_variable_0_used_before_its_declaration:C(2448,1,"Block_scoped_variable_0_used_before_its_declaration_2448","Block-scoped variable '{0}' used before its declaration."),Class_0_used_before_its_declaration:C(2449,1,"Class_0_used_before_its_declaration_2449","Class '{0}' used before its declaration."),Enum_0_used_before_its_declaration:C(2450,1,"Enum_0_used_before_its_declaration_2450","Enum '{0}' used before its declaration."),Cannot_redeclare_block_scoped_variable_0:C(2451,1,"Cannot_redeclare_block_scoped_variable_0_2451","Cannot redeclare block-scoped variable '{0}'."),An_enum_member_cannot_have_a_numeric_name:C(2452,1,"An_enum_member_cannot_have_a_numeric_name_2452","An enum member cannot have a numeric name."),Variable_0_is_used_before_being_assigned:C(2454,1,"Variable_0_is_used_before_being_assigned_2454","Variable '{0}' is used before being assigned."),Type_alias_0_circularly_references_itself:C(2456,1,"Type_alias_0_circularly_references_itself_2456","Type alias '{0}' circularly references itself."),Type_alias_name_cannot_be_0:C(2457,1,"Type_alias_name_cannot_be_0_2457","Type alias name cannot be '{0}'."),An_AMD_module_cannot_have_multiple_name_assignments:C(2458,1,"An_AMD_module_cannot_have_multiple_name_assignments_2458","An AMD module cannot have multiple name assignments."),Module_0_declares_1_locally_but_it_is_not_exported:C(2459,1,"Module_0_declares_1_locally_but_it_is_not_exported_2459","Module '{0}' declares '{1}' locally, but it is not exported."),Module_0_declares_1_locally_but_it_is_exported_as_2:C(2460,1,"Module_0_declares_1_locally_but_it_is_exported_as_2_2460","Module '{0}' declares '{1}' locally, but it is exported as '{2}'."),Type_0_is_not_an_array_type:C(2461,1,"Type_0_is_not_an_array_type_2461","Type '{0}' is not an array type."),A_rest_element_must_be_last_in_a_destructuring_pattern:C(2462,1,"A_rest_element_must_be_last_in_a_destructuring_pattern_2462","A rest element must be last in a destructuring pattern."),A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature:C(2463,1,"A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463","A binding pattern parameter cannot be optional in an implementation signature."),A_computed_property_name_must_be_of_type_string_number_symbol_or_any:C(2464,1,"A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464","A computed property name must be of type 'string', 'number', 'symbol', or 'any'."),this_cannot_be_referenced_in_a_computed_property_name:C(2465,1,"this_cannot_be_referenced_in_a_computed_property_name_2465","'this' cannot be referenced in a computed property name."),super_cannot_be_referenced_in_a_computed_property_name:C(2466,1,"super_cannot_be_referenced_in_a_computed_property_name_2466","'super' cannot be referenced in a computed property name."),A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type:C(2467,1,"A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467","A computed property name cannot reference a type parameter from its containing type."),Cannot_find_global_value_0:C(2468,1,"Cannot_find_global_value_0_2468","Cannot find global value '{0}'."),The_0_operator_cannot_be_applied_to_type_symbol:C(2469,1,"The_0_operator_cannot_be_applied_to_type_symbol_2469","The '{0}' operator cannot be applied to type 'symbol'."),Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher:C(2472,1,"Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472","Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."),Enum_declarations_must_all_be_const_or_non_const:C(2473,1,"Enum_declarations_must_all_be_const_or_non_const_2473","Enum declarations must all be const or non-const."),const_enum_member_initializers_must_be_constant_expressions:C(2474,1,"const_enum_member_initializers_must_be_constant_expressions_2474","const enum member initializers must be constant expressions."),const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query:C(2475,1,"const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475","'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment or type query."),A_const_enum_member_can_only_be_accessed_using_a_string_literal:C(2476,1,"A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476","A const enum member can only be accessed using a string literal."),const_enum_member_initializer_was_evaluated_to_a_non_finite_value:C(2477,1,"const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477","'const' enum member initializer was evaluated to a non-finite value."),const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN:C(2478,1,"const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478","'const' enum member initializer was evaluated to disallowed value 'NaN'."),let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations:C(2480,1,"let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480","'let' is not allowed to be used as a name in 'let' or 'const' declarations."),Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1:C(2481,1,"Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481","Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."),The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation:C(2483,1,"The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483","The left-hand side of a 'for...of' statement cannot use a type annotation."),Export_declaration_conflicts_with_exported_declaration_of_0:C(2484,1,"Export_declaration_conflicts_with_exported_declaration_of_0_2484","Export declaration conflicts with exported declaration of '{0}'."),The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access:C(2487,1,"The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access_2487","The left-hand side of a 'for...of' statement must be a variable or a property access."),Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator:C(2488,1,"Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488","Type '{0}' must have a '[Symbol.iterator]()' method that returns an iterator."),An_iterator_must_have_a_next_method:C(2489,1,"An_iterator_must_have_a_next_method_2489","An iterator must have a 'next()' method."),The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property:C(2490,1,"The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property_2490","The type returned by the '{0}()' method of an iterator must have a 'value' property."),The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern:C(2491,1,"The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491","The left-hand side of a 'for...in' statement cannot be a destructuring pattern."),Cannot_redeclare_identifier_0_in_catch_clause:C(2492,1,"Cannot_redeclare_identifier_0_in_catch_clause_2492","Cannot redeclare identifier '{0}' in catch clause."),Tuple_type_0_of_length_1_has_no_element_at_index_2:C(2493,1,"Tuple_type_0_of_length_1_has_no_element_at_index_2_2493","Tuple type '{0}' of length '{1}' has no element at index '{2}'."),Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher:C(2494,1,"Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494","Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."),Type_0_is_not_an_array_type_or_a_string_type:C(2495,1,"Type_0_is_not_an_array_type_or_a_string_type_2495","Type '{0}' is not an array type or a string type."),The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression:C(2496,1,"The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_stand_2496","The 'arguments' object cannot be referenced in an arrow function in ES3 and ES5. Consider using a standard function expression."),This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export:C(2497,1,"This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_2497","This module can only be referenced with ECMAScript imports/exports by turning on the '{0}' flag and referencing its default export."),Module_0_uses_export_and_cannot_be_used_with_export_Asterisk:C(2498,1,"Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498","Module '{0}' uses 'export =' and cannot be used with 'export *'."),An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments:C(2499,1,"An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499","An interface can only extend an identifier/qualified-name with optional type arguments."),A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments:C(2500,1,"A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500","A class can only implement an identifier/qualified-name with optional type arguments."),A_rest_element_cannot_contain_a_binding_pattern:C(2501,1,"A_rest_element_cannot_contain_a_binding_pattern_2501","A rest element cannot contain a binding pattern."),_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation:C(2502,1,"_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502","'{0}' is referenced directly or indirectly in its own type annotation."),Cannot_find_namespace_0:C(2503,1,"Cannot_find_namespace_0_2503","Cannot find namespace '{0}'."),Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator:C(2504,1,"Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator_2504","Type '{0}' must have a '[Symbol.asyncIterator]()' method that returns an async iterator."),A_generator_cannot_have_a_void_type_annotation:C(2505,1,"A_generator_cannot_have_a_void_type_annotation_2505","A generator cannot have a 'void' type annotation."),_0_is_referenced_directly_or_indirectly_in_its_own_base_expression:C(2506,1,"_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506","'{0}' is referenced directly or indirectly in its own base expression."),Type_0_is_not_a_constructor_function_type:C(2507,1,"Type_0_is_not_a_constructor_function_type_2507","Type '{0}' is not a constructor function type."),No_base_constructor_has_the_specified_number_of_type_arguments:C(2508,1,"No_base_constructor_has_the_specified_number_of_type_arguments_2508","No base constructor has the specified number of type arguments."),Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members:C(2509,1,"Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_2509","Base constructor return type '{0}' is not an object type or intersection of object types with statically known members."),Base_constructors_must_all_have_the_same_return_type:C(2510,1,"Base_constructors_must_all_have_the_same_return_type_2510","Base constructors must all have the same return type."),Cannot_create_an_instance_of_an_abstract_class:C(2511,1,"Cannot_create_an_instance_of_an_abstract_class_2511","Cannot create an instance of an abstract class."),Overload_signatures_must_all_be_abstract_or_non_abstract:C(2512,1,"Overload_signatures_must_all_be_abstract_or_non_abstract_2512","Overload signatures must all be abstract or non-abstract."),Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression:C(2513,1,"Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513","Abstract method '{0}' in class '{1}' cannot be accessed via super expression."),A_tuple_type_cannot_be_indexed_with_a_negative_value:C(2514,1,"A_tuple_type_cannot_be_indexed_with_a_negative_value_2514","A tuple type cannot be indexed with a negative value."),Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2:C(2515,1,"Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515","Non-abstract class '{0}' does not implement inherited abstract member '{1}' from class '{2}'."),All_declarations_of_an_abstract_method_must_be_consecutive:C(2516,1,"All_declarations_of_an_abstract_method_must_be_consecutive_2516","All declarations of an abstract method must be consecutive."),Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type:C(2517,1,"Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517","Cannot assign an abstract constructor type to a non-abstract constructor type."),A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard:C(2518,1,"A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518","A 'this'-based type guard is not compatible with a parameter-based type guard."),An_async_iterator_must_have_a_next_method:C(2519,1,"An_async_iterator_must_have_a_next_method_2519","An async iterator must have a 'next()' method."),Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions:C(2520,1,"Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520","Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."),The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method:C(2522,1,"The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_usi_2522","The 'arguments' object cannot be referenced in an async function or method in ES3 and ES5. Consider using a standard function or method."),yield_expressions_cannot_be_used_in_a_parameter_initializer:C(2523,1,"yield_expressions_cannot_be_used_in_a_parameter_initializer_2523","'yield' expressions cannot be used in a parameter initializer."),await_expressions_cannot_be_used_in_a_parameter_initializer:C(2524,1,"await_expressions_cannot_be_used_in_a_parameter_initializer_2524","'await' expressions cannot be used in a parameter initializer."),Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value:C(2525,1,"Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525","Initializer provides no value for this binding element and the binding element has no default value."),A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface:C(2526,1,"A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526","A 'this' type is available only in a non-static member of a class or interface."),The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary:C(2527,1,"The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary_2527","The inferred type of '{0}' references an inaccessible '{1}' type. A type annotation is necessary."),A_module_cannot_have_multiple_default_exports:C(2528,1,"A_module_cannot_have_multiple_default_exports_2528","A module cannot have multiple default exports."),Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions:C(2529,1,"Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529","Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."),Property_0_is_incompatible_with_index_signature:C(2530,1,"Property_0_is_incompatible_with_index_signature_2530","Property '{0}' is incompatible with index signature."),Object_is_possibly_null:C(2531,1,"Object_is_possibly_null_2531","Object is possibly 'null'."),Object_is_possibly_undefined:C(2532,1,"Object_is_possibly_undefined_2532","Object is possibly 'undefined'."),Object_is_possibly_null_or_undefined:C(2533,1,"Object_is_possibly_null_or_undefined_2533","Object is possibly 'null' or 'undefined'."),A_function_returning_never_cannot_have_a_reachable_end_point:C(2534,1,"A_function_returning_never_cannot_have_a_reachable_end_point_2534","A function returning 'never' cannot have a reachable end point."),Type_0_cannot_be_used_to_index_type_1:C(2536,1,"Type_0_cannot_be_used_to_index_type_1_2536","Type '{0}' cannot be used to index type '{1}'."),Type_0_has_no_matching_index_signature_for_type_1:C(2537,1,"Type_0_has_no_matching_index_signature_for_type_1_2537","Type '{0}' has no matching index signature for type '{1}'."),Type_0_cannot_be_used_as_an_index_type:C(2538,1,"Type_0_cannot_be_used_as_an_index_type_2538","Type '{0}' cannot be used as an index type."),Cannot_assign_to_0_because_it_is_not_a_variable:C(2539,1,"Cannot_assign_to_0_because_it_is_not_a_variable_2539","Cannot assign to '{0}' because it is not a variable."),Cannot_assign_to_0_because_it_is_a_read_only_property:C(2540,1,"Cannot_assign_to_0_because_it_is_a_read_only_property_2540","Cannot assign to '{0}' because it is a read-only property."),Index_signature_in_type_0_only_permits_reading:C(2542,1,"Index_signature_in_type_0_only_permits_reading_2542","Index signature in type '{0}' only permits reading."),Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference:C(2543,1,"Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_me_2543","Duplicate identifier '_newTarget'. Compiler uses variable declaration '_newTarget' to capture 'new.target' meta-property reference."),Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference:C(2544,1,"Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta__2544","Expression resolves to variable declaration '_newTarget' that compiler uses to capture 'new.target' meta-property reference."),A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any:C(2545,1,"A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any_2545","A mixin class must have a constructor with a single rest parameter of type 'any[]'."),The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property:C(2547,1,"The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_pro_2547","The type returned by the '{0}()' method of an async iterator must be a promise for a type with a 'value' property."),Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:C(2548,1,"Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator_2548","Type '{0}' is not an array type or does not have a '[Symbol.iterator]()' method that returns an iterator."),Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator:C(2549,1,"Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns__2549","Type '{0}' is not an array type or a string type or does not have a '[Symbol.iterator]()' method that returns an iterator."),Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later:C(2550,1,"Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_c_2550","Property '{0}' does not exist on type '{1}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{2}' or later."),Property_0_does_not_exist_on_type_1_Did_you_mean_2:C(2551,1,"Property_0_does_not_exist_on_type_1_Did_you_mean_2_2551","Property '{0}' does not exist on type '{1}'. Did you mean '{2}'?"),Cannot_find_name_0_Did_you_mean_1:C(2552,1,"Cannot_find_name_0_Did_you_mean_1_2552","Cannot find name '{0}'. Did you mean '{1}'?"),Computed_values_are_not_permitted_in_an_enum_with_string_valued_members:C(2553,1,"Computed_values_are_not_permitted_in_an_enum_with_string_valued_members_2553","Computed values are not permitted in an enum with string valued members."),Expected_0_arguments_but_got_1:C(2554,1,"Expected_0_arguments_but_got_1_2554","Expected {0} arguments, but got {1}."),Expected_at_least_0_arguments_but_got_1:C(2555,1,"Expected_at_least_0_arguments_but_got_1_2555","Expected at least {0} arguments, but got {1}."),A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter:C(2556,1,"A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter_2556","A spread argument must either have a tuple type or be passed to a rest parameter."),Expected_0_type_arguments_but_got_1:C(2558,1,"Expected_0_type_arguments_but_got_1_2558","Expected {0} type arguments, but got {1}."),Type_0_has_no_properties_in_common_with_type_1:C(2559,1,"Type_0_has_no_properties_in_common_with_type_1_2559","Type '{0}' has no properties in common with type '{1}'."),Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it:C(2560,1,"Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it_2560","Value of type '{0}' has no properties in common with type '{1}'. Did you mean to call it?"),Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2:C(2561,1,"Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_writ_2561","Object literal may only specify known properties, but '{0}' does not exist in type '{1}'. Did you mean to write '{2}'?"),Base_class_expressions_cannot_reference_class_type_parameters:C(2562,1,"Base_class_expressions_cannot_reference_class_type_parameters_2562","Base class expressions cannot reference class type parameters."),The_containing_function_or_module_body_is_too_large_for_control_flow_analysis:C(2563,1,"The_containing_function_or_module_body_is_too_large_for_control_flow_analysis_2563","The containing function or module body is too large for control flow analysis."),Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor:C(2564,1,"Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor_2564","Property '{0}' has no initializer and is not definitely assigned in the constructor."),Property_0_is_used_before_being_assigned:C(2565,1,"Property_0_is_used_before_being_assigned_2565","Property '{0}' is used before being assigned."),A_rest_element_cannot_have_a_property_name:C(2566,1,"A_rest_element_cannot_have_a_property_name_2566","A rest element cannot have a property name."),Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations:C(2567,1,"Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations_2567","Enum declarations can only merge with namespace or other enum declarations."),Property_0_may_not_exist_on_type_1_Did_you_mean_2:C(2568,1,"Property_0_may_not_exist_on_type_1_Did_you_mean_2_2568","Property '{0}' may not exist on type '{1}'. Did you mean '{2}'?"),Could_not_find_name_0_Did_you_mean_1:C(2570,1,"Could_not_find_name_0_Did_you_mean_1_2570","Could not find name '{0}'. Did you mean '{1}'?"),Object_is_of_type_unknown:C(2571,1,"Object_is_of_type_unknown_2571","Object is of type 'unknown'."),A_rest_element_type_must_be_an_array_type:C(2574,1,"A_rest_element_type_must_be_an_array_type_2574","A rest element type must be an array type."),No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments:C(2575,1,"No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments_2575","No overload expects {0} arguments, but overloads do exist that expect either {1} or {2} arguments."),Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead:C(2576,1,"Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead_2576","Property '{0}' does not exist on type '{1}'. Did you mean to access the static member '{2}' instead?"),Return_type_annotation_circularly_references_itself:C(2577,1,"Return_type_annotation_circularly_references_itself_2577","Return type annotation circularly references itself."),Unused_ts_expect_error_directive:C(2578,1,"Unused_ts_expect_error_directive_2578","Unused '@ts-expect-error' directive."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode:C(2580,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2580","Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node`."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery:C(2581,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2581","Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery`."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha:C(2582,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2582","Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha`."),Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later:C(2583,1,"Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2583","Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{1}' or later."),Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom:C(2584,1,"Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2584","Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to include 'dom'."),_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later:C(2585,1,"_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_2585","'{0}' only refers to a type, but is being used as a value here. Do you need to change your target library? Try changing the 'lib' compiler option to es2015 or later."),Cannot_assign_to_0_because_it_is_a_constant:C(2588,1,"Cannot_assign_to_0_because_it_is_a_constant_2588","Cannot assign to '{0}' because it is a constant."),Type_instantiation_is_excessively_deep_and_possibly_infinite:C(2589,1,"Type_instantiation_is_excessively_deep_and_possibly_infinite_2589","Type instantiation is excessively deep and possibly infinite."),Expression_produces_a_union_type_that_is_too_complex_to_represent:C(2590,1,"Expression_produces_a_union_type_that_is_too_complex_to_represent_2590","Expression produces a union type that is too complex to represent."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig:C(2591,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2591","Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node` and then add 'node' to the types field in your tsconfig."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig:C(2592,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2592","Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery` and then add 'jquery' to the types field in your tsconfig."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig:C(2593,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2593","Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha` and then add 'jest' or 'mocha' to the types field in your tsconfig."),This_module_is_declared_with_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag:C(2594,1,"This_module_is_declared_with_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag_2594","This module is declared with 'export =', and can only be used with a default import when using the '{0}' flag."),_0_can_only_be_imported_by_using_a_default_import:C(2595,1,"_0_can_only_be_imported_by_using_a_default_import_2595","'{0}' can only be imported by using a default import."),_0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import:C(2596,1,"_0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import_2596","'{0}' can only be imported by turning on the 'esModuleInterop' flag and using a default import."),_0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import:C(2597,1,"_0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import_2597","'{0}' can only be imported by using a 'require' call or by using a default import."),_0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import:C(2598,1,"_0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using__2598","'{0}' can only be imported by using a 'require' call or by turning on the 'esModuleInterop' flag and using a default import."),JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist:C(2602,1,"JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602","JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."),Property_0_in_type_1_is_not_assignable_to_type_2:C(2603,1,"Property_0_in_type_1_is_not_assignable_to_type_2_2603","Property '{0}' in type '{1}' is not assignable to type '{2}'."),JSX_element_type_0_does_not_have_any_construct_or_call_signatures:C(2604,1,"JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604","JSX element type '{0}' does not have any construct or call signatures."),Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property:C(2606,1,"Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606","Property '{0}' of JSX spread attribute is not assignable to target property."),JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property:C(2607,1,"JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607","JSX element class does not support attributes because it does not have a '{0}' property."),The_global_type_JSX_0_may_not_have_more_than_one_property:C(2608,1,"The_global_type_JSX_0_may_not_have_more_than_one_property_2608","The global type 'JSX.{0}' may not have more than one property."),JSX_spread_child_must_be_an_array_type:C(2609,1,"JSX_spread_child_must_be_an_array_type_2609","JSX spread child must be an array type."),_0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property:C(2610,1,"_0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property_2610","'{0}' is defined as an accessor in class '{1}', but is overridden here in '{2}' as an instance property."),_0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor:C(2611,1,"_0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor_2611","'{0}' is defined as a property in class '{1}', but is overridden here in '{2}' as an accessor."),Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration:C(2612,1,"Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_2612","Property '{0}' will overwrite the base property in '{1}'. If this is intentional, add an initializer. Otherwise, add a 'declare' modifier or remove the redundant declaration."),Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead:C(2613,1,"Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead_2613","Module '{0}' has no default export. Did you mean to use 'import { {1} } from {0}' instead?"),Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead:C(2614,1,"Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead_2614","Module '{0}' has no exported member '{1}'. Did you mean to use 'import {1} from {0}' instead?"),Type_of_property_0_circularly_references_itself_in_mapped_type_1:C(2615,1,"Type_of_property_0_circularly_references_itself_in_mapped_type_1_2615","Type of property '{0}' circularly references itself in mapped type '{1}'."),_0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import:C(2616,1,"_0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import_2616","'{0}' can only be imported by using 'import {1} = require({2})' or a default import."),_0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import:C(2617,1,"_0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_us_2617","'{0}' can only be imported by using 'import {1} = require({2})' or by turning on the 'esModuleInterop' flag and using a default import."),Source_has_0_element_s_but_target_requires_1:C(2618,1,"Source_has_0_element_s_but_target_requires_1_2618","Source has {0} element(s) but target requires {1}."),Source_has_0_element_s_but_target_allows_only_1:C(2619,1,"Source_has_0_element_s_but_target_allows_only_1_2619","Source has {0} element(s) but target allows only {1}."),Target_requires_0_element_s_but_source_may_have_fewer:C(2620,1,"Target_requires_0_element_s_but_source_may_have_fewer_2620","Target requires {0} element(s) but source may have fewer."),Target_allows_only_0_element_s_but_source_may_have_more:C(2621,1,"Target_allows_only_0_element_s_but_source_may_have_more_2621","Target allows only {0} element(s) but source may have more."),Source_provides_no_match_for_required_element_at_position_0_in_target:C(2623,1,"Source_provides_no_match_for_required_element_at_position_0_in_target_2623","Source provides no match for required element at position {0} in target."),Source_provides_no_match_for_variadic_element_at_position_0_in_target:C(2624,1,"Source_provides_no_match_for_variadic_element_at_position_0_in_target_2624","Source provides no match for variadic element at position {0} in target."),Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target:C(2625,1,"Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target_2625","Variadic element at position {0} in source does not match element at position {1} in target."),Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target:C(2626,1,"Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target_2626","Type at position {0} in source is not compatible with type at position {1} in target."),Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target:C(2627,1,"Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target_2627","Type at positions {0} through {1} in source is not compatible with type at position {2} in target."),Cannot_assign_to_0_because_it_is_an_enum:C(2628,1,"Cannot_assign_to_0_because_it_is_an_enum_2628","Cannot assign to '{0}' because it is an enum."),Cannot_assign_to_0_because_it_is_a_class:C(2629,1,"Cannot_assign_to_0_because_it_is_a_class_2629","Cannot assign to '{0}' because it is a class."),Cannot_assign_to_0_because_it_is_a_function:C(2630,1,"Cannot_assign_to_0_because_it_is_a_function_2630","Cannot assign to '{0}' because it is a function."),Cannot_assign_to_0_because_it_is_a_namespace:C(2631,1,"Cannot_assign_to_0_because_it_is_a_namespace_2631","Cannot assign to '{0}' because it is a namespace."),Cannot_assign_to_0_because_it_is_an_import:C(2632,1,"Cannot_assign_to_0_because_it_is_an_import_2632","Cannot assign to '{0}' because it is an import."),JSX_property_access_expressions_cannot_include_JSX_namespace_names:C(2633,1,"JSX_property_access_expressions_cannot_include_JSX_namespace_names_2633","JSX property access expressions cannot include JSX namespace names"),_0_index_signatures_are_incompatible:C(2634,1,"_0_index_signatures_are_incompatible_2634","'{0}' index signatures are incompatible."),Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable:C(2635,1,"Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable_2635","Type '{0}' has no signatures for which the type argument list is applicable."),Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation:C(2636,1,"Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation_2636","Type '{0}' is not assignable to type '{1}' as implied by variance annotation."),Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types:C(2637,1,"Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_t_2637","Variance annotations are only supported in type aliases for object, function, constructor, and mapped types."),Type_0_may_represent_a_primitive_value_which_is_not_permitted_as_the_right_operand_of_the_in_operator:C(2638,1,"Type_0_may_represent_a_primitive_value_which_is_not_permitted_as_the_right_operand_of_the_in_operato_2638","Type '{0}' may represent a primitive value, which is not permitted as the right operand of the 'in' operator."),React_components_cannot_include_JSX_namespace_names:C(2639,1,"React_components_cannot_include_JSX_namespace_names_2639","React components cannot include JSX namespace names"),Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity:C(2649,1,"Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity_2649","Cannot augment module '{0}' with value exports because it resolves to a non-module entity."),A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums:C(2651,1,"A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651","A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."),Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead:C(2652,1,"Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652","Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."),Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1:C(2653,1,"Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653","Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."),JSX_expressions_must_have_one_parent_element:C(2657,1,"JSX_expressions_must_have_one_parent_element_2657","JSX expressions must have one parent element."),Type_0_provides_no_match_for_the_signature_1:C(2658,1,"Type_0_provides_no_match_for_the_signature_1_2658","Type '{0}' provides no match for the signature '{1}'."),super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher:C(2659,1,"super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659","'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."),super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions:C(2660,1,"super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660","'super' can only be referenced in members of derived classes or object literal expressions."),Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module:C(2661,1,"Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module_2661","Cannot export '{0}'. Only local declarations can be exported from a module."),Cannot_find_name_0_Did_you_mean_the_static_member_1_0:C(2662,1,"Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662","Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"),Cannot_find_name_0_Did_you_mean_the_instance_member_this_0:C(2663,1,"Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663","Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"),Invalid_module_name_in_augmentation_module_0_cannot_be_found:C(2664,1,"Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664","Invalid module name in augmentation, module '{0}' cannot be found."),Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented:C(2665,1,"Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augm_2665","Invalid module name in augmentation. Module '{0}' resolves to an untyped module at '{1}', which cannot be augmented."),Exports_and_export_assignments_are_not_permitted_in_module_augmentations:C(2666,1,"Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666","Exports and export assignments are not permitted in module augmentations."),Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module:C(2667,1,"Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667","Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."),export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible:C(2668,1,"export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668","'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."),Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations:C(2669,1,"Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669","Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."),Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context:C(2670,1,"Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670","Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."),Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity:C(2671,1,"Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671","Cannot augment module '{0}' because it resolves to a non-module entity."),Cannot_assign_a_0_constructor_type_to_a_1_constructor_type:C(2672,1,"Cannot_assign_a_0_constructor_type_to_a_1_constructor_type_2672","Cannot assign a '{0}' constructor type to a '{1}' constructor type."),Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration:C(2673,1,"Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration_2673","Constructor of class '{0}' is private and only accessible within the class declaration."),Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration:C(2674,1,"Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration_2674","Constructor of class '{0}' is protected and only accessible within the class declaration."),Cannot_extend_a_class_0_Class_constructor_is_marked_as_private:C(2675,1,"Cannot_extend_a_class_0_Class_constructor_is_marked_as_private_2675","Cannot extend a class '{0}'. Class constructor is marked as private."),Accessors_must_both_be_abstract_or_non_abstract:C(2676,1,"Accessors_must_both_be_abstract_or_non_abstract_2676","Accessors must both be abstract or non-abstract."),A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type:C(2677,1,"A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type_2677","A type predicate's type must be assignable to its parameter's type."),Type_0_is_not_comparable_to_type_1:C(2678,1,"Type_0_is_not_comparable_to_type_1_2678","Type '{0}' is not comparable to type '{1}'."),A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void:C(2679,1,"A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void_2679","A function that is called with the 'new' keyword cannot have a 'this' type that is 'void'."),A_0_parameter_must_be_the_first_parameter:C(2680,1,"A_0_parameter_must_be_the_first_parameter_2680","A '{0}' parameter must be the first parameter."),A_constructor_cannot_have_a_this_parameter:C(2681,1,"A_constructor_cannot_have_a_this_parameter_2681","A constructor cannot have a 'this' parameter."),this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation:C(2683,1,"this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_2683","'this' implicitly has type 'any' because it does not have a type annotation."),The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1:C(2684,1,"The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1_2684","The 'this' context of type '{0}' is not assignable to method's 'this' of type '{1}'."),The_this_types_of_each_signature_are_incompatible:C(2685,1,"The_this_types_of_each_signature_are_incompatible_2685","The 'this' types of each signature are incompatible."),_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead:C(2686,1,"_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead_2686","'{0}' refers to a UMD global, but the current file is a module. Consider adding an import instead."),All_declarations_of_0_must_have_identical_modifiers:C(2687,1,"All_declarations_of_0_must_have_identical_modifiers_2687","All declarations of '{0}' must have identical modifiers."),Cannot_find_type_definition_file_for_0:C(2688,1,"Cannot_find_type_definition_file_for_0_2688","Cannot find type definition file for '{0}'."),Cannot_extend_an_interface_0_Did_you_mean_implements:C(2689,1,"Cannot_extend_an_interface_0_Did_you_mean_implements_2689","Cannot extend an interface '{0}'. Did you mean 'implements'?"),_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0:C(2690,1,"_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0_2690","'{0}' only refers to a type, but is being used as a value here. Did you mean to use '{1} in {0}'?"),_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible:C(2692,1,"_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible_2692","'{0}' is a primitive, but '{1}' is a wrapper object. Prefer using '{0}' when possible."),_0_only_refers_to_a_type_but_is_being_used_as_a_value_here:C(2693,1,"_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_2693","'{0}' only refers to a type, but is being used as a value here."),Namespace_0_has_no_exported_member_1:C(2694,1,"Namespace_0_has_no_exported_member_1_2694","Namespace '{0}' has no exported member '{1}'."),Left_side_of_comma_operator_is_unused_and_has_no_side_effects:C(2695,1,"Left_side_of_comma_operator_is_unused_and_has_no_side_effects_2695","Left side of comma operator is unused and has no side effects.",!0),The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead:C(2696,1,"The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead_2696","The 'Object' type is assignable to very few other types. Did you mean to use the 'any' type instead?"),An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:C(2697,1,"An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_in_2697","An async function or method must return a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."),Spread_types_may_only_be_created_from_object_types:C(2698,1,"Spread_types_may_only_be_created_from_object_types_2698","Spread types may only be created from object types."),Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1:C(2699,1,"Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1_2699","Static property '{0}' conflicts with built-in property 'Function.{0}' of constructor function '{1}'."),Rest_types_may_only_be_created_from_object_types:C(2700,1,"Rest_types_may_only_be_created_from_object_types_2700","Rest types may only be created from object types."),The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access:C(2701,1,"The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access_2701","The target of an object rest assignment must be a variable or a property access."),_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here:C(2702,1,"_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here_2702","'{0}' only refers to a type, but is being used as a namespace here."),The_operand_of_a_delete_operator_must_be_a_property_reference:C(2703,1,"The_operand_of_a_delete_operator_must_be_a_property_reference_2703","The operand of a 'delete' operator must be a property reference."),The_operand_of_a_delete_operator_cannot_be_a_read_only_property:C(2704,1,"The_operand_of_a_delete_operator_cannot_be_a_read_only_property_2704","The operand of a 'delete' operator cannot be a read-only property."),An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:C(2705,1,"An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_de_2705","An async function or method in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."),Required_type_parameters_may_not_follow_optional_type_parameters:C(2706,1,"Required_type_parameters_may_not_follow_optional_type_parameters_2706","Required type parameters may not follow optional type parameters."),Generic_type_0_requires_between_1_and_2_type_arguments:C(2707,1,"Generic_type_0_requires_between_1_and_2_type_arguments_2707","Generic type '{0}' requires between {1} and {2} type arguments."),Cannot_use_namespace_0_as_a_value:C(2708,1,"Cannot_use_namespace_0_as_a_value_2708","Cannot use namespace '{0}' as a value."),Cannot_use_namespace_0_as_a_type:C(2709,1,"Cannot_use_namespace_0_as_a_type_2709","Cannot use namespace '{0}' as a type."),_0_are_specified_twice_The_attribute_named_0_will_be_overwritten:C(2710,1,"_0_are_specified_twice_The_attribute_named_0_will_be_overwritten_2710","'{0}' are specified twice. The attribute named '{0}' will be overwritten."),A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:C(2711,1,"A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES20_2711","A dynamic import call returns a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."),A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:C(2712,1,"A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declarat_2712","A dynamic import call in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."),Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1:C(2713,1,"Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_p_2713",`Cannot access '{0}.{1}' because '{0}' is a type, but not a namespace. Did you mean to retrieve the type of the property '{1}' in '{0}' with '{0}["{1}"]'?`),The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context:C(2714,1,"The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context_2714","The expression of an export assignment must be an identifier or qualified name in an ambient context."),Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor:C(2715,1,"Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor_2715","Abstract property '{0}' in class '{1}' cannot be accessed in the constructor."),Type_parameter_0_has_a_circular_default:C(2716,1,"Type_parameter_0_has_a_circular_default_2716","Type parameter '{0}' has a circular default."),Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2:C(2717,1,"Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_t_2717","Subsequent property declarations must have the same type.  Property '{0}' must be of type '{1}', but here has type '{2}'."),Duplicate_property_0:C(2718,1,"Duplicate_property_0_2718","Duplicate property '{0}'."),Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated:C(2719,1,"Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated_2719","Type '{0}' is not assignable to type '{1}'. Two different types with this name exist, but they are unrelated."),Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass:C(2720,1,"Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclas_2720","Class '{0}' incorrectly implements class '{1}'. Did you mean to extend '{1}' and inherit its members as a subclass?"),Cannot_invoke_an_object_which_is_possibly_null:C(2721,1,"Cannot_invoke_an_object_which_is_possibly_null_2721","Cannot invoke an object which is possibly 'null'."),Cannot_invoke_an_object_which_is_possibly_undefined:C(2722,1,"Cannot_invoke_an_object_which_is_possibly_undefined_2722","Cannot invoke an object which is possibly 'undefined'."),Cannot_invoke_an_object_which_is_possibly_null_or_undefined:C(2723,1,"Cannot_invoke_an_object_which_is_possibly_null_or_undefined_2723","Cannot invoke an object which is possibly 'null' or 'undefined'."),_0_has_no_exported_member_named_1_Did_you_mean_2:C(2724,1,"_0_has_no_exported_member_named_1_Did_you_mean_2_2724","'{0}' has no exported member named '{1}'. Did you mean '{2}'?"),Class_name_cannot_be_Object_when_targeting_ES5_with_module_0:C(2725,1,"Class_name_cannot_be_Object_when_targeting_ES5_with_module_0_2725","Class name cannot be 'Object' when targeting ES5 with module {0}."),Cannot_find_lib_definition_for_0:C(2726,1,"Cannot_find_lib_definition_for_0_2726","Cannot find lib definition for '{0}'."),Cannot_find_lib_definition_for_0_Did_you_mean_1:C(2727,1,"Cannot_find_lib_definition_for_0_Did_you_mean_1_2727","Cannot find lib definition for '{0}'. Did you mean '{1}'?"),_0_is_declared_here:C(2728,3,"_0_is_declared_here_2728","'{0}' is declared here."),Property_0_is_used_before_its_initialization:C(2729,1,"Property_0_is_used_before_its_initialization_2729","Property '{0}' is used before its initialization."),An_arrow_function_cannot_have_a_this_parameter:C(2730,1,"An_arrow_function_cannot_have_a_this_parameter_2730","An arrow function cannot have a 'this' parameter."),Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String:C(2731,1,"Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_i_2731","Implicit conversion of a 'symbol' to a 'string' will fail at runtime. Consider wrapping this expression in 'String(...)'."),Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension:C(2732,1,"Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension_2732","Cannot find module '{0}'. Consider using '--resolveJsonModule' to import module with '.json' extension."),Property_0_was_also_declared_here:C(2733,1,"Property_0_was_also_declared_here_2733","Property '{0}' was also declared here."),Are_you_missing_a_semicolon:C(2734,1,"Are_you_missing_a_semicolon_2734","Are you missing a semicolon?"),Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1:C(2735,1,"Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1_2735","Did you mean for '{0}' to be constrained to type 'new (...args: any[]) => {1}'?"),Operator_0_cannot_be_applied_to_type_1:C(2736,1,"Operator_0_cannot_be_applied_to_type_1_2736","Operator '{0}' cannot be applied to type '{1}'."),BigInt_literals_are_not_available_when_targeting_lower_than_ES2020:C(2737,1,"BigInt_literals_are_not_available_when_targeting_lower_than_ES2020_2737","BigInt literals are not available when targeting lower than ES2020."),An_outer_value_of_this_is_shadowed_by_this_container:C(2738,3,"An_outer_value_of_this_is_shadowed_by_this_container_2738","An outer value of 'this' is shadowed by this container."),Type_0_is_missing_the_following_properties_from_type_1_Colon_2:C(2739,1,"Type_0_is_missing_the_following_properties_from_type_1_Colon_2_2739","Type '{0}' is missing the following properties from type '{1}': {2}"),Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more:C(2740,1,"Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more_2740","Type '{0}' is missing the following properties from type '{1}': {2}, and {3} more."),Property_0_is_missing_in_type_1_but_required_in_type_2:C(2741,1,"Property_0_is_missing_in_type_1_but_required_in_type_2_2741","Property '{0}' is missing in type '{1}' but required in type '{2}'."),The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary:C(2742,1,"The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_a_2742","The inferred type of '{0}' cannot be named without a reference to '{1}'. This is likely not portable. A type annotation is necessary."),No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments:C(2743,1,"No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments_2743","No overload expects {0} type arguments, but overloads do exist that expect either {1} or {2} type arguments."),Type_parameter_defaults_can_only_reference_previously_declared_type_parameters:C(2744,1,"Type_parameter_defaults_can_only_reference_previously_declared_type_parameters_2744","Type parameter defaults can only reference previously declared type parameters."),This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided:C(2745,1,"This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_pr_2745","This JSX tag's '{0}' prop expects type '{1}' which requires multiple children, but only a single child was provided."),This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided:C(2746,1,"This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided_2746","This JSX tag's '{0}' prop expects a single child of type '{1}', but multiple children were provided."),_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2:C(2747,1,"_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_t_2747","'{0}' components don't accept text as child elements. Text in JSX has the type 'string', but the expected type of '{1}' is '{2}'."),Cannot_access_ambient_const_enums_when_0_is_enabled:C(2748,1,"Cannot_access_ambient_const_enums_when_0_is_enabled_2748","Cannot access ambient const enums when '{0}' is enabled."),_0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0:C(2749,1,"_0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0_2749","'{0}' refers to a value, but is being used as a type here. Did you mean 'typeof {0}'?"),The_implementation_signature_is_declared_here:C(2750,1,"The_implementation_signature_is_declared_here_2750","The implementation signature is declared here."),Circularity_originates_in_type_at_this_location:C(2751,1,"Circularity_originates_in_type_at_this_location_2751","Circularity originates in type at this location."),The_first_export_default_is_here:C(2752,1,"The_first_export_default_is_here_2752","The first export default is here."),Another_export_default_is_here:C(2753,1,"Another_export_default_is_here_2753","Another export default is here."),super_may_not_use_type_arguments:C(2754,1,"super_may_not_use_type_arguments_2754","'super' may not use type arguments."),No_constituent_of_type_0_is_callable:C(2755,1,"No_constituent_of_type_0_is_callable_2755","No constituent of type '{0}' is callable."),Not_all_constituents_of_type_0_are_callable:C(2756,1,"Not_all_constituents_of_type_0_are_callable_2756","Not all constituents of type '{0}' are callable."),Type_0_has_no_call_signatures:C(2757,1,"Type_0_has_no_call_signatures_2757","Type '{0}' has no call signatures."),Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other:C(2758,1,"Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_2758","Each member of the union type '{0}' has signatures, but none of those signatures are compatible with each other."),No_constituent_of_type_0_is_constructable:C(2759,1,"No_constituent_of_type_0_is_constructable_2759","No constituent of type '{0}' is constructable."),Not_all_constituents_of_type_0_are_constructable:C(2760,1,"Not_all_constituents_of_type_0_are_constructable_2760","Not all constituents of type '{0}' are constructable."),Type_0_has_no_construct_signatures:C(2761,1,"Type_0_has_no_construct_signatures_2761","Type '{0}' has no construct signatures."),Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other:C(2762,1,"Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_2762","Each member of the union type '{0}' has construct signatures, but none of those signatures are compatible with each other."),Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0:C(2763,1,"Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_s_2763","Cannot iterate value because the 'next' method of its iterator expects type '{1}', but for-of will always send '{0}'."),Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0:C(2764,1,"Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_al_2764","Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array spread will always send '{0}'."),Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0:C(2765,1,"Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring__2765","Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array destructuring will always send '{0}'."),Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0:C(2766,1,"Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_co_2766","Cannot delegate iteration to value because the 'next' method of its iterator expects type '{1}', but the containing generator will always send '{0}'."),The_0_property_of_an_iterator_must_be_a_method:C(2767,1,"The_0_property_of_an_iterator_must_be_a_method_2767","The '{0}' property of an iterator must be a method."),The_0_property_of_an_async_iterator_must_be_a_method:C(2768,1,"The_0_property_of_an_async_iterator_must_be_a_method_2768","The '{0}' property of an async iterator must be a method."),No_overload_matches_this_call:C(2769,1,"No_overload_matches_this_call_2769","No overload matches this call."),The_last_overload_gave_the_following_error:C(2770,1,"The_last_overload_gave_the_following_error_2770","The last overload gave the following error."),The_last_overload_is_declared_here:C(2771,1,"The_last_overload_is_declared_here_2771","The last overload is declared here."),Overload_0_of_1_2_gave_the_following_error:C(2772,1,"Overload_0_of_1_2_gave_the_following_error_2772","Overload {0} of {1}, '{2}', gave the following error."),Did_you_forget_to_use_await:C(2773,1,"Did_you_forget_to_use_await_2773","Did you forget to use 'await'?"),This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead:C(2774,1,"This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_2774","This condition will always return true since this function is always defined. Did you mean to call it instead?"),Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation:C(2775,1,"Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation_2775","Assertions require every name in the call target to be declared with an explicit type annotation."),Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name:C(2776,1,"Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name_2776","Assertions require the call target to be an identifier or qualified name."),The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access:C(2777,1,"The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access_2777","The operand of an increment or decrement operator may not be an optional property access."),The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access:C(2778,1,"The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access_2778","The target of an object rest assignment may not be an optional property access."),The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access:C(2779,1,"The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access_2779","The left-hand side of an assignment expression may not be an optional property access."),The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access:C(2780,1,"The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access_2780","The left-hand side of a 'for...in' statement may not be an optional property access."),The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access:C(2781,1,"The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access_2781","The left-hand side of a 'for...of' statement may not be an optional property access."),_0_needs_an_explicit_type_annotation:C(2782,3,"_0_needs_an_explicit_type_annotation_2782","'{0}' needs an explicit type annotation."),_0_is_specified_more_than_once_so_this_usage_will_be_overwritten:C(2783,1,"_0_is_specified_more_than_once_so_this_usage_will_be_overwritten_2783","'{0}' is specified more than once, so this usage will be overwritten."),get_and_set_accessors_cannot_declare_this_parameters:C(2784,1,"get_and_set_accessors_cannot_declare_this_parameters_2784","'get' and 'set' accessors cannot declare 'this' parameters."),This_spread_always_overwrites_this_property:C(2785,1,"This_spread_always_overwrites_this_property_2785","This spread always overwrites this property."),_0_cannot_be_used_as_a_JSX_component:C(2786,1,"_0_cannot_be_used_as_a_JSX_component_2786","'{0}' cannot be used as a JSX component."),Its_return_type_0_is_not_a_valid_JSX_element:C(2787,1,"Its_return_type_0_is_not_a_valid_JSX_element_2787","Its return type '{0}' is not a valid JSX element."),Its_instance_type_0_is_not_a_valid_JSX_element:C(2788,1,"Its_instance_type_0_is_not_a_valid_JSX_element_2788","Its instance type '{0}' is not a valid JSX element."),Its_element_type_0_is_not_a_valid_JSX_element:C(2789,1,"Its_element_type_0_is_not_a_valid_JSX_element_2789","Its element type '{0}' is not a valid JSX element."),The_operand_of_a_delete_operator_must_be_optional:C(2790,1,"The_operand_of_a_delete_operator_must_be_optional_2790","The operand of a 'delete' operator must be optional."),Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later:C(2791,1,"Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_lat_2791","Exponentiation cannot be performed on 'bigint' values unless the 'target' option is set to 'es2016' or later."),Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_to_the_paths_option:C(2792,1,"Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_t_2792","Cannot find module '{0}'. Did you mean to set the 'moduleResolution' option to 'nodenext', or to add aliases to the 'paths' option?"),The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible:C(2793,1,"The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_2793","The call would have succeeded against this implementation, but implementation signatures of overloads are not externally visible."),Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise:C(2794,1,"Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise_2794","Expected {0} arguments, but got {1}. Did you forget to include 'void' in your type argument to 'Promise'?"),The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types:C(2795,1,"The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types_2795","The 'intrinsic' keyword can only be used to declare compiler provided intrinsic types."),It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked:C(2796,1,"It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tag_2796","It is likely that you are missing a comma to separate these two template expressions. They form a tagged template expression which cannot be invoked."),A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract:C(2797,1,"A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_2797","A mixin class that extends from a type variable containing an abstract construct signature must also be declared 'abstract'."),The_declaration_was_marked_as_deprecated_here:C(2798,1,"The_declaration_was_marked_as_deprecated_here_2798","The declaration was marked as deprecated here."),Type_produces_a_tuple_type_that_is_too_large_to_represent:C(2799,1,"Type_produces_a_tuple_type_that_is_too_large_to_represent_2799","Type produces a tuple type that is too large to represent."),Expression_produces_a_tuple_type_that_is_too_large_to_represent:C(2800,1,"Expression_produces_a_tuple_type_that_is_too_large_to_represent_2800","Expression produces a tuple type that is too large to represent."),This_condition_will_always_return_true_since_this_0_is_always_defined:C(2801,1,"This_condition_will_always_return_true_since_this_0_is_always_defined_2801","This condition will always return true since this '{0}' is always defined."),Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher:C(2802,1,"Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es201_2802","Type '{0}' can only be iterated through when using the '--downlevelIteration' flag or with a '--target' of 'es2015' or higher."),Cannot_assign_to_private_method_0_Private_methods_are_not_writable:C(2803,1,"Cannot_assign_to_private_method_0_Private_methods_are_not_writable_2803","Cannot assign to private method '{0}'. Private methods are not writable."),Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name:C(2804,1,"Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name_2804","Duplicate identifier '{0}'. Static and instance elements cannot share the same private name."),Private_accessor_was_defined_without_a_getter:C(2806,1,"Private_accessor_was_defined_without_a_getter_2806","Private accessor was defined without a getter."),This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0:C(2807,1,"This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_o_2807","This syntax requires an imported helper named '{1}' with {2} parameters, which is not compatible with the one in '{0}'. Consider upgrading your version of '{0}'."),A_get_accessor_must_be_at_least_as_accessible_as_the_setter:C(2808,1,"A_get_accessor_must_be_at_least_as_accessible_as_the_setter_2808","A get accessor must be at least as accessible as the setter"),Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_whole_assignment_in_parentheses:C(2809,1,"Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_d_2809","Declaration or statement expected. This '=' follows a block of statements, so if you intended to write a destructuring assignment, you might need to wrap the whole assignment in parentheses."),Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments:C(2810,1,"Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_2810","Expected 1 argument, but got 0. 'new Promise()' needs a JSDoc hint to produce a 'resolve' that can be called without arguments."),Initializer_for_property_0:C(2811,1,"Initializer_for_property_0_2811","Initializer for property '{0}'"),Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom:C(2812,1,"Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom_2812","Property '{0}' does not exist on type '{1}'. Try changing the 'lib' compiler option to include 'dom'."),Class_declaration_cannot_implement_overload_list_for_0:C(2813,1,"Class_declaration_cannot_implement_overload_list_for_0_2813","Class declaration cannot implement overload list for '{0}'."),Function_with_bodies_can_only_merge_with_classes_that_are_ambient:C(2814,1,"Function_with_bodies_can_only_merge_with_classes_that_are_ambient_2814","Function with bodies can only merge with classes that are ambient."),arguments_cannot_be_referenced_in_property_initializers:C(2815,1,"arguments_cannot_be_referenced_in_property_initializers_2815","'arguments' cannot be referenced in property initializers."),Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class:C(2816,1,"Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class_2816","Cannot use 'this' in a static property initializer of a decorated class."),Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block:C(2817,1,"Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block_2817","Property '{0}' has no initializer and is not definitely assigned in a class static block."),Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers:C(2818,1,"Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializer_2818","Duplicate identifier '{0}'. Compiler reserves name '{1}' when emitting 'super' references in static initializers."),Namespace_name_cannot_be_0:C(2819,1,"Namespace_name_cannot_be_0_2819","Namespace name cannot be '{0}'."),Type_0_is_not_assignable_to_type_1_Did_you_mean_2:C(2820,1,"Type_0_is_not_assignable_to_type_1_Did_you_mean_2_2820","Type '{0}' is not assignable to type '{1}'. Did you mean '{2}'?"),Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve:C(2821,1,"Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve_2821","Import assertions are only supported when the '--module' option is set to 'esnext', 'nodenext', or 'preserve'."),Import_assertions_cannot_be_used_with_type_only_imports_or_exports:C(2822,1,"Import_assertions_cannot_be_used_with_type_only_imports_or_exports_2822","Import assertions cannot be used with type-only imports or exports."),Import_attributes_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve:C(2823,1,"Import_attributes_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve_2823","Import attributes are only supported when the '--module' option is set to 'esnext', 'nodenext', or 'preserve'."),Cannot_find_namespace_0_Did_you_mean_1:C(2833,1,"Cannot_find_namespace_0_Did_you_mean_1_2833","Cannot find namespace '{0}'. Did you mean '{1}'?"),Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path:C(2834,1,"Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_n_2834","Relative import paths need explicit file extensions in ECMAScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Consider adding an extension to the import path."),Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0:C(2835,1,"Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_n_2835","Relative import paths need explicit file extensions in ECMAScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Did you mean '{0}'?"),Import_assertions_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls:C(2836,1,"Import_assertions_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls_2836","Import assertions are not allowed on statements that compile to CommonJS 'require' calls."),Import_assertion_values_must_be_string_literal_expressions:C(2837,1,"Import_assertion_values_must_be_string_literal_expressions_2837","Import assertion values must be string literal expressions."),All_declarations_of_0_must_have_identical_constraints:C(2838,1,"All_declarations_of_0_must_have_identical_constraints_2838","All declarations of '{0}' must have identical constraints."),This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value:C(2839,1,"This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value_2839","This condition will always return '{0}' since JavaScript compares objects by reference, not value."),An_interface_cannot_extend_a_primitive_type_like_0_It_can_only_extend_other_named_object_types:C(2840,1,"An_interface_cannot_extend_a_primitive_type_like_0_It_can_only_extend_other_named_object_types_2840","An interface cannot extend a primitive type like '{0}'. It can only extend other named object types."),_0_is_an_unused_renaming_of_1_Did_you_intend_to_use_it_as_a_type_annotation:C(2842,1,"_0_is_an_unused_renaming_of_1_Did_you_intend_to_use_it_as_a_type_annotation_2842","'{0}' is an unused renaming of '{1}'. Did you intend to use it as a type annotation?"),We_can_only_write_a_type_for_0_by_adding_a_type_for_the_entire_parameter_here:C(2843,1,"We_can_only_write_a_type_for_0_by_adding_a_type_for_the_entire_parameter_here_2843","We can only write a type for '{0}' by adding a type for the entire parameter here."),Type_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor:C(2844,1,"Type_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2844","Type of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),This_condition_will_always_return_0:C(2845,1,"This_condition_will_always_return_0_2845","This condition will always return '{0}'."),A_declaration_file_cannot_be_imported_without_import_type_Did_you_mean_to_import_an_implementation_file_0_instead:C(2846,1,"A_declaration_file_cannot_be_imported_without_import_type_Did_you_mean_to_import_an_implementation_f_2846","A declaration file cannot be imported without 'import type'. Did you mean to import an implementation file '{0}' instead?"),The_right_hand_side_of_an_instanceof_expression_must_not_be_an_instantiation_expression:C(2848,1,"The_right_hand_side_of_an_instanceof_expression_must_not_be_an_instantiation_expression_2848","The right-hand side of an 'instanceof' expression must not be an instantiation expression."),Target_signature_provides_too_few_arguments_Expected_0_or_more_but_got_1:C(2849,1,"Target_signature_provides_too_few_arguments_Expected_0_or_more_but_got_1_2849","Target signature provides too few arguments. Expected {0} or more, but got {1}."),The_initializer_of_a_using_declaration_must_be_either_an_object_with_a_Symbol_dispose_method_or_be_null_or_undefined:C(2850,1,"The_initializer_of_a_using_declaration_must_be_either_an_object_with_a_Symbol_dispose_method_or_be_n_2850","The initializer of a 'using' declaration must be either an object with a '[Symbol.dispose]()' method, or be 'null' or 'undefined'."),The_initializer_of_an_await_using_declaration_must_be_either_an_object_with_a_Symbol_asyncDispose_or_Symbol_dispose_method_or_be_null_or_undefined:C(2851,1,"The_initializer_of_an_await_using_declaration_must_be_either_an_object_with_a_Symbol_asyncDispose_or_2851","The initializer of an 'await using' declaration must be either an object with a '[Symbol.asyncDispose]()' or '[Symbol.dispose]()' method, or be 'null' or 'undefined'."),await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules:C(2852,1,"await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_2852","'await using' statements are only allowed within async functions and at the top levels of modules."),await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module:C(2853,1,"await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_th_2853","'await using' statements are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher:C(2854,1,"Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_sys_2854","Top-level 'await using' statements are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', 'nodenext', or 'preserve', and the 'target' option is set to 'es2017' or higher."),Class_field_0_defined_by_the_parent_class_is_not_accessible_in_the_child_class_via_super:C(2855,1,"Class_field_0_defined_by_the_parent_class_is_not_accessible_in_the_child_class_via_super_2855","Class field '{0}' defined by the parent class is not accessible in the child class via super."),Import_attributes_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls:C(2856,1,"Import_attributes_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls_2856","Import attributes are not allowed on statements that compile to CommonJS 'require' calls."),Import_attributes_cannot_be_used_with_type_only_imports_or_exports:C(2857,1,"Import_attributes_cannot_be_used_with_type_only_imports_or_exports_2857","Import attributes cannot be used with type-only imports or exports."),Import_attribute_values_must_be_string_literal_expressions:C(2858,1,"Import_attribute_values_must_be_string_literal_expressions_2858","Import attribute values must be string literal expressions."),Excessive_complexity_comparing_types_0_and_1:C(2859,1,"Excessive_complexity_comparing_types_0_and_1_2859","Excessive complexity comparing types '{0}' and '{1}'."),The_left_hand_side_of_an_instanceof_expression_must_be_assignable_to_the_first_argument_of_the_right_hand_side_s_Symbol_hasInstance_method:C(2860,1,"The_left_hand_side_of_an_instanceof_expression_must_be_assignable_to_the_first_argument_of_the_right_2860","The left-hand side of an 'instanceof' expression must be assignable to the first argument of the right-hand side's '[Symbol.hasInstance]' method."),An_object_s_Symbol_hasInstance_method_must_return_a_boolean_value_for_it_to_be_used_on_the_right_hand_side_of_an_instanceof_expression:C(2861,1,"An_object_s_Symbol_hasInstance_method_must_return_a_boolean_value_for_it_to_be_used_on_the_right_han_2861","An object's '[Symbol.hasInstance]' method must return a boolean value for it to be used on the right-hand side of an 'instanceof' expression."),Type_0_is_generic_and_can_only_be_indexed_for_reading:C(2862,1,"Type_0_is_generic_and_can_only_be_indexed_for_reading_2862","Type '{0}' is generic and can only be indexed for reading."),A_class_cannot_extend_a_primitive_type_like_0_Classes_can_only_extend_constructable_values:C(2863,1,"A_class_cannot_extend_a_primitive_type_like_0_Classes_can_only_extend_constructable_values_2863","A class cannot extend a primitive type like '{0}'. Classes can only extend constructable values."),A_class_cannot_implement_a_primitive_type_like_0_It_can_only_implement_other_named_object_types:C(2864,1,"A_class_cannot_implement_a_primitive_type_like_0_It_can_only_implement_other_named_object_types_2864","A class cannot implement a primitive type like '{0}'. It can only implement other named object types."),Import_0_conflicts_with_local_value_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled:C(2865,1,"Import_0_conflicts_with_local_value_so_must_be_declared_with_a_type_only_import_when_isolatedModules_2865","Import '{0}' conflicts with local value, so must be declared with a type-only import when 'isolatedModules' is enabled."),Import_0_conflicts_with_global_value_used_in_this_file_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled:C(2866,1,"Import_0_conflicts_with_global_value_used_in_this_file_so_must_be_declared_with_a_type_only_import_w_2866","Import '{0}' conflicts with global value used in this file, so must be declared with a type-only import when 'isolatedModules' is enabled."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun:C(2867,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_2867","Cannot find name '{0}'. Do you need to install type definitions for Bun? Try `npm i --save-dev @types/bun`."),Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_and_then_add_bun_to_the_types_field_in_your_tsconfig:C(2868,1,"Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_2868","Cannot find name '{0}'. Do you need to install type definitions for Bun? Try `npm i --save-dev @types/bun` and then add 'bun' to the types field in your tsconfig."),Import_declaration_0_is_using_private_name_1:C(4e3,1,"Import_declaration_0_is_using_private_name_1_4000","Import declaration '{0}' is using private name '{1}'."),Type_parameter_0_of_exported_class_has_or_is_using_private_name_1:C(4002,1,"Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002","Type parameter '{0}' of exported class has or is using private name '{1}'."),Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1:C(4004,1,"Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004","Type parameter '{0}' of exported interface has or is using private name '{1}'."),Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1:C(4006,1,"Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006","Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1:C(4008,1,"Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008","Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:C(4010,1,"Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010","Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."),Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:C(4012,1,"Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012","Type parameter '{0}' of public method from exported class has or is using private name '{1}'."),Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1:C(4014,1,"Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014","Type parameter '{0}' of method from exported interface has or is using private name '{1}'."),Type_parameter_0_of_exported_function_has_or_is_using_private_name_1:C(4016,1,"Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016","Type parameter '{0}' of exported function has or is using private name '{1}'."),Implements_clause_of_exported_class_0_has_or_is_using_private_name_1:C(4019,1,"Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019","Implements clause of exported class '{0}' has or is using private name '{1}'."),extends_clause_of_exported_class_0_has_or_is_using_private_name_1:C(4020,1,"extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020","'extends' clause of exported class '{0}' has or is using private name '{1}'."),extends_clause_of_exported_class_has_or_is_using_private_name_0:C(4021,1,"extends_clause_of_exported_class_has_or_is_using_private_name_0_4021","'extends' clause of exported class has or is using private name '{0}'."),extends_clause_of_exported_interface_0_has_or_is_using_private_name_1:C(4022,1,"extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022","'extends' clause of exported interface '{0}' has or is using private name '{1}'."),Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4023,1,"Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023","Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."),Exported_variable_0_has_or_is_using_name_1_from_private_module_2:C(4024,1,"Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024","Exported variable '{0}' has or is using name '{1}' from private module '{2}'."),Exported_variable_0_has_or_is_using_private_name_1:C(4025,1,"Exported_variable_0_has_or_is_using_private_name_1_4025","Exported variable '{0}' has or is using private name '{1}'."),Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4026,1,"Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026","Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:C(4027,1,"Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027","Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:C(4028,1,"Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028","Public static property '{0}' of exported class has or is using private name '{1}'."),Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4029,1,"Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029","Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:C(4030,1,"Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030","Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_property_0_of_exported_class_has_or_is_using_private_name_1:C(4031,1,"Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031","Public property '{0}' of exported class has or is using private name '{1}'."),Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:C(4032,1,"Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032","Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),Property_0_of_exported_interface_has_or_is_using_private_name_1:C(4033,1,"Property_0_of_exported_interface_has_or_is_using_private_name_1_4033","Property '{0}' of exported interface has or is using private name '{1}'."),Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:C(4034,1,"Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_mod_4034","Parameter type of public static setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1:C(4035,1,"Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1_4035","Parameter type of public static setter '{0}' from exported class has or is using private name '{1}'."),Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:C(4036,1,"Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4036","Parameter type of public setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1:C(4037,1,"Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1_4037","Parameter type of public setter '{0}' from exported class has or is using private name '{1}'."),Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4038,1,"Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_modul_4038","Return type of public static getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:C(4039,1,"Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_4039","Return type of public static getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1:C(4040,1,"Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1_4040","Return type of public static getter '{0}' from exported class has or is using private name '{1}'."),Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4041,1,"Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_4041","Return type of public getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:C(4042,1,"Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4042","Return type of public getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1:C(4043,1,"Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1_4043","Return type of public getter '{0}' from exported class has or is using private name '{1}'."),Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:C(4044,1,"Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044","Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0:C(4045,1,"Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045","Return type of constructor signature from exported interface has or is using private name '{0}'."),Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:C(4046,1,"Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046","Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0:C(4047,1,"Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047","Return type of call signature from exported interface has or is using private name '{0}'."),Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:C(4048,1,"Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048","Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0:C(4049,1,"Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049","Return type of index signature from exported interface has or is using private name '{0}'."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:C(4050,1,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050","Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:C(4051,1,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051","Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."),Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0:C(4052,1,"Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052","Return type of public static method from exported class has or is using private name '{0}'."),Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:C(4053,1,"Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053","Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:C(4054,1,"Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054","Return type of public method from exported class has or is using name '{0}' from private module '{1}'."),Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0:C(4055,1,"Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055","Return type of public method from exported class has or is using private name '{0}'."),Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1:C(4056,1,"Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056","Return type of method from exported interface has or is using name '{0}' from private module '{1}'."),Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0:C(4057,1,"Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057","Return type of method from exported interface has or is using private name '{0}'."),Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:C(4058,1,"Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058","Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."),Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1:C(4059,1,"Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059","Return type of exported function has or is using name '{0}' from private module '{1}'."),Return_type_of_exported_function_has_or_is_using_private_name_0:C(4060,1,"Return_type_of_exported_function_has_or_is_using_private_name_0_4060","Return type of exported function has or is using private name '{0}'."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4061,1,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061","Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2:C(4062,1,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062","Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1:C(4063,1,"Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063","Parameter '{0}' of constructor from exported class has or is using private name '{1}'."),Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:C(4064,1,"Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064","Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1:C(4065,1,"Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065","Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:C(4066,1,"Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066","Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1:C(4067,1,"Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067","Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4068,1,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068","Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:C(4069,1,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069","Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:C(4070,1,"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070","Parameter '{0}' of public static method from exported class has or is using private name '{1}'."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4071,1,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071","Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:C(4072,1,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072","Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."),Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:C(4073,1,"Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073","Parameter '{0}' of public method from exported class has or is using private name '{1}'."),Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2:C(4074,1,"Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074","Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1:C(4075,1,"Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075","Parameter '{0}' of method from exported interface has or is using private name '{1}'."),Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4076,1,"Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076","Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."),Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2:C(4077,1,"Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077","Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."),Parameter_0_of_exported_function_has_or_is_using_private_name_1:C(4078,1,"Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078","Parameter '{0}' of exported function has or is using private name '{1}'."),Exported_type_alias_0_has_or_is_using_private_name_1:C(4081,1,"Exported_type_alias_0_has_or_is_using_private_name_1_4081","Exported type alias '{0}' has or is using private name '{1}'."),Default_export_of_the_module_has_or_is_using_private_name_0:C(4082,1,"Default_export_of_the_module_has_or_is_using_private_name_0_4082","Default export of the module has or is using private name '{0}'."),Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1:C(4083,1,"Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1_4083","Type parameter '{0}' of exported type alias has or is using private name '{1}'."),Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2:C(4084,1,"Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2_4084","Exported type alias '{0}' has or is using private name '{1}' from module {2}."),Extends_clause_for_inferred_type_0_has_or_is_using_private_name_1:C(4085,1,"Extends_clause_for_inferred_type_0_has_or_is_using_private_name_1_4085","Extends clause for inferred type '{0}' has or is using private name '{1}'."),Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict:C(4090,1,"Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_librar_4090","Conflicting definitions for '{0}' found at '{1}' and '{2}'. Consider installing a specific version of this library to resolve the conflict."),Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:C(4091,1,"Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4091","Parameter '{0}' of index signature from exported interface has or is using name '{1}' from private module '{2}'."),Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1:C(4092,1,"Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1_4092","Parameter '{0}' of index signature from exported interface has or is using private name '{1}'."),Property_0_of_exported_class_expression_may_not_be_private_or_protected:C(4094,1,"Property_0_of_exported_class_expression_may_not_be_private_or_protected_4094","Property '{0}' of exported class expression may not be private or protected."),Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4095,1,"Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_4095","Public static method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:C(4096,1,"Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4096","Public static method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_static_method_0_of_exported_class_has_or_is_using_private_name_1:C(4097,1,"Public_static_method_0_of_exported_class_has_or_is_using_private_name_1_4097","Public static method '{0}' of exported class has or is using private name '{1}'."),Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4098,1,"Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4098","Public method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:C(4099,1,"Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4099","Public method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),Public_method_0_of_exported_class_has_or_is_using_private_name_1:C(4100,1,"Public_method_0_of_exported_class_has_or_is_using_private_name_1_4100","Public method '{0}' of exported class has or is using private name '{1}'."),Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:C(4101,1,"Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4101","Method '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),Method_0_of_exported_interface_has_or_is_using_private_name_1:C(4102,1,"Method_0_of_exported_interface_has_or_is_using_private_name_1_4102","Method '{0}' of exported interface has or is using private name '{1}'."),Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1:C(4103,1,"Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1_4103","Type parameter '{0}' of exported mapped object type is using private name '{1}'."),The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1:C(4104,1,"The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1_4104","The type '{0}' is 'readonly' and cannot be assigned to the mutable type '{1}'."),Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter:C(4105,1,"Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter_4105","Private or protected member '{0}' cannot be accessed on a type parameter."),Parameter_0_of_accessor_has_or_is_using_private_name_1:C(4106,1,"Parameter_0_of_accessor_has_or_is_using_private_name_1_4106","Parameter '{0}' of accessor has or is using private name '{1}'."),Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2:C(4107,1,"Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2_4107","Parameter '{0}' of accessor has or is using name '{1}' from private module '{2}'."),Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:C(4108,1,"Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4108","Parameter '{0}' of accessor has or is using name '{1}' from external module '{2}' but cannot be named."),Type_arguments_for_0_circularly_reference_themselves:C(4109,1,"Type_arguments_for_0_circularly_reference_themselves_4109","Type arguments for '{0}' circularly reference themselves."),Tuple_type_arguments_circularly_reference_themselves:C(4110,1,"Tuple_type_arguments_circularly_reference_themselves_4110","Tuple type arguments circularly reference themselves."),Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0:C(4111,1,"Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0_4111","Property '{0}' comes from an index signature, so it must be accessed with ['{0}']."),This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class:C(4112,1,"This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another__4112","This member cannot have an 'override' modifier because its containing class '{0}' does not extend another class."),This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0:C(4113,1,"This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_4113","This member cannot have an 'override' modifier because it is not declared in the base class '{0}'."),This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0:C(4114,1,"This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0_4114","This member must have an 'override' modifier because it overrides a member in the base class '{0}'."),This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0:C(4115,1,"This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0_4115","This parameter property must have an 'override' modifier because it overrides a member in base class '{0}'."),This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0:C(4116,1,"This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared__4116","This member must have an 'override' modifier because it overrides an abstract method that is declared in the base class '{0}'."),This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1:C(4117,1,"This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you__4117","This member cannot have an 'override' modifier because it is not declared in the base class '{0}'. Did you mean '{1}'?"),The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized:C(4118,1,"The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized_4118","The type of this node cannot be serialized because its property '{0}' cannot be serialized."),This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0:C(4119,1,"This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_4119","This member must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."),This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0:C(4120,1,"This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_4120","This parameter property must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."),This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class:C(4121,1,"This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_4121","This member cannot have a JSDoc comment with an '@override' tag because its containing class '{0}' does not extend another class."),This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0:C(4122,1,"This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4122","This member cannot have a JSDoc comment with an '@override' tag because it is not declared in the base class '{0}'."),This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1:C(4123,1,"This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4123","This member cannot have a JSDoc comment with an 'override' tag because it is not declared in the base class '{0}'. Did you mean '{1}'?"),Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next:C(4124,1,"Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_w_4124","Compiler option '{0}' of value '{1}' is unstable. Use nightly TypeScript to silence this error. Try updating with 'npm install -D typescript@next'."),Each_declaration_of_0_1_differs_in_its_value_where_2_was_expected_but_3_was_given:C(4125,1,"Each_declaration_of_0_1_differs_in_its_value_where_2_was_expected_but_3_was_given_4125","Each declaration of '{0}.{1}' differs in its value, where '{2}' was expected but '{3}' was given."),One_value_of_0_1_is_the_string_2_and_the_other_is_assumed_to_be_an_unknown_numeric_value:C(4126,1,"One_value_of_0_1_is_the_string_2_and_the_other_is_assumed_to_be_an_unknown_numeric_value_4126","One value of '{0}.{1}' is the string '{2}', and the other is assumed to be an unknown numeric value."),The_current_host_does_not_support_the_0_option:C(5001,1,"The_current_host_does_not_support_the_0_option_5001","The current host does not support the '{0}' option."),Cannot_find_the_common_subdirectory_path_for_the_input_files:C(5009,1,"Cannot_find_the_common_subdirectory_path_for_the_input_files_5009","Cannot find the common subdirectory path for the input files."),File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0:C(5010,1,"File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0_5010","File specification cannot end in a recursive directory wildcard ('**'): '{0}'."),Cannot_read_file_0_Colon_1:C(5012,1,"Cannot_read_file_0_Colon_1_5012","Cannot read file '{0}': {1}."),Failed_to_parse_file_0_Colon_1:C(5014,1,"Failed_to_parse_file_0_Colon_1_5014","Failed to parse file '{0}': {1}."),Unknown_compiler_option_0:C(5023,1,"Unknown_compiler_option_0_5023","Unknown compiler option '{0}'."),Compiler_option_0_requires_a_value_of_type_1:C(5024,1,"Compiler_option_0_requires_a_value_of_type_1_5024","Compiler option '{0}' requires a value of type {1}."),Unknown_compiler_option_0_Did_you_mean_1:C(5025,1,"Unknown_compiler_option_0_Did_you_mean_1_5025","Unknown compiler option '{0}'. Did you mean '{1}'?"),Could_not_write_file_0_Colon_1:C(5033,1,"Could_not_write_file_0_Colon_1_5033","Could not write file '{0}': {1}."),Option_project_cannot_be_mixed_with_source_files_on_a_command_line:C(5042,1,"Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042","Option 'project' cannot be mixed with source files on a command line."),Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher:C(5047,1,"Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047","Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."),Option_0_cannot_be_specified_when_option_target_is_ES3:C(5048,1,"Option_0_cannot_be_specified_when_option_target_is_ES3_5048","Option '{0}' cannot be specified when option 'target' is 'ES3'."),Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided:C(5051,1,"Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided_5051","Option '{0} can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."),Option_0_cannot_be_specified_without_specifying_option_1:C(5052,1,"Option_0_cannot_be_specified_without_specifying_option_1_5052","Option '{0}' cannot be specified without specifying option '{1}'."),Option_0_cannot_be_specified_with_option_1:C(5053,1,"Option_0_cannot_be_specified_with_option_1_5053","Option '{0}' cannot be specified with option '{1}'."),A_tsconfig_json_file_is_already_defined_at_Colon_0:C(5054,1,"A_tsconfig_json_file_is_already_defined_at_Colon_0_5054","A 'tsconfig.json' file is already defined at: '{0}'."),Cannot_write_file_0_because_it_would_overwrite_input_file:C(5055,1,"Cannot_write_file_0_because_it_would_overwrite_input_file_5055","Cannot write file '{0}' because it would overwrite input file."),Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files:C(5056,1,"Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056","Cannot write file '{0}' because it would be overwritten by multiple input files."),Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0:C(5057,1,"Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057","Cannot find a tsconfig.json file at the specified directory: '{0}'."),The_specified_path_does_not_exist_Colon_0:C(5058,1,"The_specified_path_does_not_exist_Colon_0_5058","The specified path does not exist: '{0}'."),Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier:C(5059,1,"Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier_5059","Invalid value for '--reactNamespace'. '{0}' is not a valid identifier."),Pattern_0_can_have_at_most_one_Asterisk_character:C(5061,1,"Pattern_0_can_have_at_most_one_Asterisk_character_5061","Pattern '{0}' can have at most one '*' character."),Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character:C(5062,1,"Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character_5062","Substitution '{0}' in pattern '{1}' can have at most one '*' character."),Substitutions_for_pattern_0_should_be_an_array:C(5063,1,"Substitutions_for_pattern_0_should_be_an_array_5063","Substitutions for pattern '{0}' should be an array."),Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2:C(5064,1,"Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2_5064","Substitution '{0}' for pattern '{1}' has incorrect type, expected 'string', got '{2}'."),File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0:C(5065,1,"File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildca_5065","File specification cannot contain a parent directory ('..') that appears after a recursive directory wildcard ('**'): '{0}'."),Substitutions_for_pattern_0_shouldn_t_be_an_empty_array:C(5066,1,"Substitutions_for_pattern_0_shouldn_t_be_an_empty_array_5066","Substitutions for pattern '{0}' shouldn't be an empty array."),Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name:C(5067,1,"Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name_5067","Invalid value for 'jsxFactory'. '{0}' is not a valid identifier or qualified-name."),Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig:C(5068,1,"Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript__5068","Adding a tsconfig.json file will help organize projects that contain both TypeScript and JavaScript files. Learn more at https://aka.ms/tsconfig."),Option_0_cannot_be_specified_without_specifying_option_1_or_option_2:C(5069,1,"Option_0_cannot_be_specified_without_specifying_option_1_or_option_2_5069","Option '{0}' cannot be specified without specifying option '{1}' or option '{2}'."),Option_resolveJsonModule_cannot_be_specified_when_moduleResolution_is_set_to_classic:C(5070,1,"Option_resolveJsonModule_cannot_be_specified_when_moduleResolution_is_set_to_classic_5070","Option '--resolveJsonModule' cannot be specified when 'moduleResolution' is set to 'classic'."),Option_resolveJsonModule_cannot_be_specified_when_module_is_set_to_none_system_or_umd:C(5071,1,"Option_resolveJsonModule_cannot_be_specified_when_module_is_set_to_none_system_or_umd_5071","Option '--resolveJsonModule' cannot be specified when 'module' is set to 'none', 'system', or 'umd'."),Unknown_build_option_0:C(5072,1,"Unknown_build_option_0_5072","Unknown build option '{0}'."),Build_option_0_requires_a_value_of_type_1:C(5073,1,"Build_option_0_requires_a_value_of_type_1_5073","Build option '{0}' requires a value of type {1}."),Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified:C(5074,1,"Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBui_5074","Option '--incremental' can only be specified using tsconfig, emitting to single file or when option '--tsBuildInfoFile' is specified."),_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2:C(5075,1,"_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_5075","'{0}' is assignable to the constraint of type '{1}', but '{1}' could be instantiated with a different subtype of constraint '{2}'."),_0_and_1_operations_cannot_be_mixed_without_parentheses:C(5076,1,"_0_and_1_operations_cannot_be_mixed_without_parentheses_5076","'{0}' and '{1}' operations cannot be mixed without parentheses."),Unknown_build_option_0_Did_you_mean_1:C(5077,1,"Unknown_build_option_0_Did_you_mean_1_5077","Unknown build option '{0}'. Did you mean '{1}'?"),Unknown_watch_option_0:C(5078,1,"Unknown_watch_option_0_5078","Unknown watch option '{0}'."),Unknown_watch_option_0_Did_you_mean_1:C(5079,1,"Unknown_watch_option_0_Did_you_mean_1_5079","Unknown watch option '{0}'. Did you mean '{1}'?"),Watch_option_0_requires_a_value_of_type_1:C(5080,1,"Watch_option_0_requires_a_value_of_type_1_5080","Watch option '{0}' requires a value of type {1}."),Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0:C(5081,1,"Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0_5081","Cannot find a tsconfig.json file at the current directory: {0}."),_0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1:C(5082,1,"_0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1_5082","'{0}' could be instantiated with an arbitrary type which could be unrelated to '{1}'."),Cannot_read_file_0:C(5083,1,"Cannot_read_file_0_5083","Cannot read file '{0}'."),A_tuple_member_cannot_be_both_optional_and_rest:C(5085,1,"A_tuple_member_cannot_be_both_optional_and_rest_5085","A tuple member cannot be both optional and rest."),A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type:C(5086,1,"A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_c_5086","A labeled tuple element is declared as optional with a question mark after the name and before the colon, rather than after the type."),A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type:C(5087,1,"A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type_5087","A labeled tuple element is declared as rest with a '...' before the name, rather than before the type."),The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary:C(5088,1,"The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialize_5088","The inferred type of '{0}' references a type with a cyclic structure which cannot be trivially serialized. A type annotation is necessary."),Option_0_cannot_be_specified_when_option_jsx_is_1:C(5089,1,"Option_0_cannot_be_specified_when_option_jsx_is_1_5089","Option '{0}' cannot be specified when option 'jsx' is '{1}'."),Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash:C(5090,1,"Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash_5090","Non-relative paths are not allowed when 'baseUrl' is not set. Did you forget a leading './'?"),Option_preserveConstEnums_cannot_be_disabled_when_0_is_enabled:C(5091,1,"Option_preserveConstEnums_cannot_be_disabled_when_0_is_enabled_5091","Option 'preserveConstEnums' cannot be disabled when '{0}' is enabled."),The_root_value_of_a_0_file_must_be_an_object:C(5092,1,"The_root_value_of_a_0_file_must_be_an_object_5092","The root value of a '{0}' file must be an object."),Compiler_option_0_may_only_be_used_with_build:C(5093,1,"Compiler_option_0_may_only_be_used_with_build_5093","Compiler option '--{0}' may only be used with '--build'."),Compiler_option_0_may_not_be_used_with_build:C(5094,1,"Compiler_option_0_may_not_be_used_with_build_5094","Compiler option '--{0}' may not be used with '--build'."),Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later:C(5095,1,"Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later_5095","Option '{0}' can only be used when 'module' is set to 'preserve' or to 'es2015' or later."),Option_allowImportingTsExtensions_can_only_be_used_when_either_noEmit_or_emitDeclarationOnly_is_set:C(5096,1,"Option_allowImportingTsExtensions_can_only_be_used_when_either_noEmit_or_emitDeclarationOnly_is_set_5096","Option 'allowImportingTsExtensions' can only be used when either 'noEmit' or 'emitDeclarationOnly' is set."),An_import_path_can_only_end_with_a_0_extension_when_allowImportingTsExtensions_is_enabled:C(5097,1,"An_import_path_can_only_end_with_a_0_extension_when_allowImportingTsExtensions_is_enabled_5097","An import path can only end with a '{0}' extension when 'allowImportingTsExtensions' is enabled."),Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler:C(5098,1,"Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler_5098","Option '{0}' can only be used when 'moduleResolution' is set to 'node16', 'nodenext', or 'bundler'."),Option_0_is_deprecated_and_will_stop_functioning_in_TypeScript_1_Specify_compilerOption_ignoreDeprecations_Colon_2_to_silence_this_error:C(5101,1,"Option_0_is_deprecated_and_will_stop_functioning_in_TypeScript_1_Specify_compilerOption_ignoreDeprec_5101",`Option '{0}' is deprecated and will stop functioning in TypeScript {1}. Specify compilerOption '"ignoreDeprecations": "{2}"' to silence this error.`),Option_0_has_been_removed_Please_remove_it_from_your_configuration:C(5102,1,"Option_0_has_been_removed_Please_remove_it_from_your_configuration_5102","Option '{0}' has been removed. Please remove it from your configuration."),Invalid_value_for_ignoreDeprecations:C(5103,1,"Invalid_value_for_ignoreDeprecations_5103","Invalid value for '--ignoreDeprecations'."),Option_0_is_redundant_and_cannot_be_specified_with_option_1:C(5104,1,"Option_0_is_redundant_and_cannot_be_specified_with_option_1_5104","Option '{0}' is redundant and cannot be specified with option '{1}'."),Option_verbatimModuleSyntax_cannot_be_used_when_module_is_set_to_UMD_AMD_or_System:C(5105,1,"Option_verbatimModuleSyntax_cannot_be_used_when_module_is_set_to_UMD_AMD_or_System_5105","Option 'verbatimModuleSyntax' cannot be used when 'module' is set to 'UMD', 'AMD', or 'System'."),Use_0_instead:C(5106,3,"Use_0_instead_5106","Use '{0}' instead."),Option_0_1_is_deprecated_and_will_stop_functioning_in_TypeScript_2_Specify_compilerOption_ignoreDeprecations_Colon_3_to_silence_this_error:C(5107,1,"Option_0_1_is_deprecated_and_will_stop_functioning_in_TypeScript_2_Specify_compilerOption_ignoreDepr_5107",`Option '{0}={1}' is deprecated and will stop functioning in TypeScript {2}. Specify compilerOption '"ignoreDeprecations": "{3}"' to silence this error.`),Option_0_1_has_been_removed_Please_remove_it_from_your_configuration:C(5108,1,"Option_0_1_has_been_removed_Please_remove_it_from_your_configuration_5108","Option '{0}={1}' has been removed. Please remove it from your configuration."),Option_moduleResolution_must_be_set_to_0_or_left_unspecified_when_option_module_is_set_to_1:C(5109,1,"Option_moduleResolution_must_be_set_to_0_or_left_unspecified_when_option_module_is_set_to_1_5109","Option 'moduleResolution' must be set to '{0}' (or left unspecified) when option 'module' is set to '{1}'."),Option_module_must_be_set_to_0_when_option_moduleResolution_is_set_to_1:C(5110,1,"Option_module_must_be_set_to_0_when_option_moduleResolution_is_set_to_1_5110","Option 'module' must be set to '{0}' when option 'moduleResolution' is set to '{1}'."),Generates_a_sourcemap_for_each_corresponding_d_ts_file:C(6e3,3,"Generates_a_sourcemap_for_each_corresponding_d_ts_file_6000","Generates a sourcemap for each corresponding '.d.ts' file."),Concatenate_and_emit_output_to_single_file:C(6001,3,"Concatenate_and_emit_output_to_single_file_6001","Concatenate and emit output to single file."),Generates_corresponding_d_ts_file:C(6002,3,"Generates_corresponding_d_ts_file_6002","Generates corresponding '.d.ts' file."),Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations:C(6004,3,"Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004","Specify the location where debugger should locate TypeScript files instead of source locations."),Watch_input_files:C(6005,3,"Watch_input_files_6005","Watch input files."),Redirect_output_structure_to_the_directory:C(6006,3,"Redirect_output_structure_to_the_directory_6006","Redirect output structure to the directory."),Do_not_erase_const_enum_declarations_in_generated_code:C(6007,3,"Do_not_erase_const_enum_declarations_in_generated_code_6007","Do not erase const enum declarations in generated code."),Do_not_emit_outputs_if_any_errors_were_reported:C(6008,3,"Do_not_emit_outputs_if_any_errors_were_reported_6008","Do not emit outputs if any errors were reported."),Do_not_emit_comments_to_output:C(6009,3,"Do_not_emit_comments_to_output_6009","Do not emit comments to output."),Do_not_emit_outputs:C(6010,3,"Do_not_emit_outputs_6010","Do not emit outputs."),Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking:C(6011,3,"Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011","Allow default imports from modules with no default export. This does not affect code emit, just typechecking."),Skip_type_checking_of_declaration_files:C(6012,3,"Skip_type_checking_of_declaration_files_6012","Skip type checking of declaration files."),Do_not_resolve_the_real_path_of_symlinks:C(6013,3,"Do_not_resolve_the_real_path_of_symlinks_6013","Do not resolve the real path of symlinks."),Only_emit_d_ts_declaration_files:C(6014,3,"Only_emit_d_ts_declaration_files_6014","Only emit '.d.ts' declaration files."),Specify_ECMAScript_target_version:C(6015,3,"Specify_ECMAScript_target_version_6015","Specify ECMAScript target version."),Specify_module_code_generation:C(6016,3,"Specify_module_code_generation_6016","Specify module code generation."),Print_this_message:C(6017,3,"Print_this_message_6017","Print this message."),Print_the_compiler_s_version:C(6019,3,"Print_the_compiler_s_version_6019","Print the compiler's version."),Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json:C(6020,3,"Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json_6020","Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'."),Syntax_Colon_0:C(6023,3,"Syntax_Colon_0_6023","Syntax: {0}"),options:C(6024,3,"options_6024","options"),file:C(6025,3,"file_6025","file"),Examples_Colon_0:C(6026,3,"Examples_Colon_0_6026","Examples: {0}"),Options_Colon:C(6027,3,"Options_Colon_6027","Options:"),Version_0:C(6029,3,"Version_0_6029","Version {0}"),Insert_command_line_options_and_files_from_a_file:C(6030,3,"Insert_command_line_options_and_files_from_a_file_6030","Insert command line options and files from a file."),Starting_compilation_in_watch_mode:C(6031,3,"Starting_compilation_in_watch_mode_6031","Starting compilation in watch mode..."),File_change_detected_Starting_incremental_compilation:C(6032,3,"File_change_detected_Starting_incremental_compilation_6032","File change detected. Starting incremental compilation..."),KIND:C(6034,3,"KIND_6034","KIND"),FILE:C(6035,3,"FILE_6035","FILE"),VERSION:C(6036,3,"VERSION_6036","VERSION"),LOCATION:C(6037,3,"LOCATION_6037","LOCATION"),DIRECTORY:C(6038,3,"DIRECTORY_6038","DIRECTORY"),STRATEGY:C(6039,3,"STRATEGY_6039","STRATEGY"),FILE_OR_DIRECTORY:C(6040,3,"FILE_OR_DIRECTORY_6040","FILE OR DIRECTORY"),Errors_Files:C(6041,3,"Errors_Files_6041","Errors  Files"),Generates_corresponding_map_file:C(6043,3,"Generates_corresponding_map_file_6043","Generates corresponding '.map' file."),Compiler_option_0_expects_an_argument:C(6044,1,"Compiler_option_0_expects_an_argument_6044","Compiler option '{0}' expects an argument."),Unterminated_quoted_string_in_response_file_0:C(6045,1,"Unterminated_quoted_string_in_response_file_0_6045","Unterminated quoted string in response file '{0}'."),Argument_for_0_option_must_be_Colon_1:C(6046,1,"Argument_for_0_option_must_be_Colon_1_6046","Argument for '{0}' option must be: {1}."),Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1:C(6048,1,"Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048","Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."),Unable_to_open_file_0:C(6050,1,"Unable_to_open_file_0_6050","Unable to open file '{0}'."),Corrupted_locale_file_0:C(6051,1,"Corrupted_locale_file_0_6051","Corrupted locale file {0}."),Raise_error_on_expressions_and_declarations_with_an_implied_any_type:C(6052,3,"Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052","Raise error on expressions and declarations with an implied 'any' type."),File_0_not_found:C(6053,1,"File_0_not_found_6053","File '{0}' not found."),File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1:C(6054,1,"File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1_6054","File '{0}' has an unsupported extension. The only supported extensions are {1}."),Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures:C(6055,3,"Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055","Suppress noImplicitAny errors for indexing objects lacking index signatures."),Do_not_emit_declarations_for_code_that_has_an_internal_annotation:C(6056,3,"Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056","Do not emit declarations for code that has an '@internal' annotation."),Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir:C(6058,3,"Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir_6058","Specify the root directory of input files. Use to control the output directory structure with --outDir."),File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files:C(6059,1,"File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059","File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."),Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix:C(6060,3,"Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060","Specify the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."),NEWLINE:C(6061,3,"NEWLINE_6061","NEWLINE"),Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line:C(6064,1,"Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line_6064","Option '{0}' can only be specified in 'tsconfig.json' file or set to 'null' on command line."),Enables_experimental_support_for_ES7_decorators:C(6065,3,"Enables_experimental_support_for_ES7_decorators_6065","Enables experimental support for ES7 decorators."),Enables_experimental_support_for_emitting_type_metadata_for_decorators:C(6066,3,"Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066","Enables experimental support for emitting type metadata for decorators."),Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file:C(6070,3,"Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070","Initializes a TypeScript project and creates a tsconfig.json file."),Successfully_created_a_tsconfig_json_file:C(6071,3,"Successfully_created_a_tsconfig_json_file_6071","Successfully created a tsconfig.json file."),Suppress_excess_property_checks_for_object_literals:C(6072,3,"Suppress_excess_property_checks_for_object_literals_6072","Suppress excess property checks for object literals."),Stylize_errors_and_messages_using_color_and_context_experimental:C(6073,3,"Stylize_errors_and_messages_using_color_and_context_experimental_6073","Stylize errors and messages using color and context (experimental)."),Do_not_report_errors_on_unused_labels:C(6074,3,"Do_not_report_errors_on_unused_labels_6074","Do not report errors on unused labels."),Report_error_when_not_all_code_paths_in_function_return_a_value:C(6075,3,"Report_error_when_not_all_code_paths_in_function_return_a_value_6075","Report error when not all code paths in function return a value."),Report_errors_for_fallthrough_cases_in_switch_statement:C(6076,3,"Report_errors_for_fallthrough_cases_in_switch_statement_6076","Report errors for fallthrough cases in switch statement."),Do_not_report_errors_on_unreachable_code:C(6077,3,"Do_not_report_errors_on_unreachable_code_6077","Do not report errors on unreachable code."),Disallow_inconsistently_cased_references_to_the_same_file:C(6078,3,"Disallow_inconsistently_cased_references_to_the_same_file_6078","Disallow inconsistently-cased references to the same file."),Specify_library_files_to_be_included_in_the_compilation:C(6079,3,"Specify_library_files_to_be_included_in_the_compilation_6079","Specify library files to be included in the compilation."),Specify_JSX_code_generation:C(6080,3,"Specify_JSX_code_generation_6080","Specify JSX code generation."),Only_amd_and_system_modules_are_supported_alongside_0:C(6082,1,"Only_amd_and_system_modules_are_supported_alongside_0_6082","Only 'amd' and 'system' modules are supported alongside --{0}."),Base_directory_to_resolve_non_absolute_module_names:C(6083,3,"Base_directory_to_resolve_non_absolute_module_names_6083","Base directory to resolve non-absolute module names."),Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit:C(6084,3,"Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react__6084","[Deprecated] Use '--jsxFactory' instead. Specify the object invoked for createElement when targeting 'react' JSX emit"),Enable_tracing_of_the_name_resolution_process:C(6085,3,"Enable_tracing_of_the_name_resolution_process_6085","Enable tracing of the name resolution process."),Resolving_module_0_from_1:C(6086,3,"Resolving_module_0_from_1_6086","======== Resolving module '{0}' from '{1}'. ========"),Explicitly_specified_module_resolution_kind_Colon_0:C(6087,3,"Explicitly_specified_module_resolution_kind_Colon_0_6087","Explicitly specified module resolution kind: '{0}'."),Module_resolution_kind_is_not_specified_using_0:C(6088,3,"Module_resolution_kind_is_not_specified_using_0_6088","Module resolution kind is not specified, using '{0}'."),Module_name_0_was_successfully_resolved_to_1:C(6089,3,"Module_name_0_was_successfully_resolved_to_1_6089","======== Module name '{0}' was successfully resolved to '{1}'. ========"),Module_name_0_was_not_resolved:C(6090,3,"Module_name_0_was_not_resolved_6090","======== Module name '{0}' was not resolved. ========"),paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0:C(6091,3,"paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0_6091","'paths' option is specified, looking for a pattern to match module name '{0}'."),Module_name_0_matched_pattern_1:C(6092,3,"Module_name_0_matched_pattern_1_6092","Module name '{0}', matched pattern '{1}'."),Trying_substitution_0_candidate_module_location_Colon_1:C(6093,3,"Trying_substitution_0_candidate_module_location_Colon_1_6093","Trying substitution '{0}', candidate module location: '{1}'."),Resolving_module_name_0_relative_to_base_url_1_2:C(6094,3,"Resolving_module_name_0_relative_to_base_url_1_2_6094","Resolving module name '{0}' relative to base url '{1}' - '{2}'."),Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_types_Colon_1:C(6095,3,"Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_types_Colon_1_6095","Loading module as file / folder, candidate module location '{0}', target file types: {1}."),File_0_does_not_exist:C(6096,3,"File_0_does_not_exist_6096","File '{0}' does not exist."),File_0_exists_use_it_as_a_name_resolution_result:C(6097,3,"File_0_exists_use_it_as_a_name_resolution_result_6097","File '{0}' exists - use it as a name resolution result."),Loading_module_0_from_node_modules_folder_target_file_types_Colon_1:C(6098,3,"Loading_module_0_from_node_modules_folder_target_file_types_Colon_1_6098","Loading module '{0}' from 'node_modules' folder, target file types: {1}."),Found_package_json_at_0:C(6099,3,"Found_package_json_at_0_6099","Found 'package.json' at '{0}'."),package_json_does_not_have_a_0_field:C(6100,3,"package_json_does_not_have_a_0_field_6100","'package.json' does not have a '{0}' field."),package_json_has_0_field_1_that_references_2:C(6101,3,"package_json_has_0_field_1_that_references_2_6101","'package.json' has '{0}' field '{1}' that references '{2}'."),Allow_javascript_files_to_be_compiled:C(6102,3,"Allow_javascript_files_to_be_compiled_6102","Allow javascript files to be compiled."),Checking_if_0_is_the_longest_matching_prefix_for_1_2:C(6104,3,"Checking_if_0_is_the_longest_matching_prefix_for_1_2_6104","Checking if '{0}' is the longest matching prefix for '{1}' - '{2}'."),Expected_type_of_0_field_in_package_json_to_be_1_got_2:C(6105,3,"Expected_type_of_0_field_in_package_json_to_be_1_got_2_6105","Expected type of '{0}' field in 'package.json' to be '{1}', got '{2}'."),baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1:C(6106,3,"baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1_6106","'baseUrl' option is set to '{0}', using this value to resolve non-relative module name '{1}'."),rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0:C(6107,3,"rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0_6107","'rootDirs' option is set, using it to resolve relative module name '{0}'."),Longest_matching_prefix_for_0_is_1:C(6108,3,"Longest_matching_prefix_for_0_is_1_6108","Longest matching prefix for '{0}' is '{1}'."),Loading_0_from_the_root_dir_1_candidate_location_2:C(6109,3,"Loading_0_from_the_root_dir_1_candidate_location_2_6109","Loading '{0}' from the root dir '{1}', candidate location '{2}'."),Trying_other_entries_in_rootDirs:C(6110,3,"Trying_other_entries_in_rootDirs_6110","Trying other entries in 'rootDirs'."),Module_resolution_using_rootDirs_has_failed:C(6111,3,"Module_resolution_using_rootDirs_has_failed_6111","Module resolution using 'rootDirs' has failed."),Do_not_emit_use_strict_directives_in_module_output:C(6112,3,"Do_not_emit_use_strict_directives_in_module_output_6112","Do not emit 'use strict' directives in module output."),Enable_strict_null_checks:C(6113,3,"Enable_strict_null_checks_6113","Enable strict null checks."),Unknown_option_excludes_Did_you_mean_exclude:C(6114,1,"Unknown_option_excludes_Did_you_mean_exclude_6114","Unknown option 'excludes'. Did you mean 'exclude'?"),Raise_error_on_this_expressions_with_an_implied_any_type:C(6115,3,"Raise_error_on_this_expressions_with_an_implied_any_type_6115","Raise error on 'this' expressions with an implied 'any' type."),Resolving_type_reference_directive_0_containing_file_1_root_directory_2:C(6116,3,"Resolving_type_reference_directive_0_containing_file_1_root_directory_2_6116","======== Resolving type reference directive '{0}', containing file '{1}', root directory '{2}'. ========"),Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2:C(6119,3,"Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2_6119","======== Type reference directive '{0}' was successfully resolved to '{1}', primary: {2}. ========"),Type_reference_directive_0_was_not_resolved:C(6120,3,"Type_reference_directive_0_was_not_resolved_6120","======== Type reference directive '{0}' was not resolved. ========"),Resolving_with_primary_search_path_0:C(6121,3,"Resolving_with_primary_search_path_0_6121","Resolving with primary search path '{0}'."),Root_directory_cannot_be_determined_skipping_primary_search_paths:C(6122,3,"Root_directory_cannot_be_determined_skipping_primary_search_paths_6122","Root directory cannot be determined, skipping primary search paths."),Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set:C(6123,3,"Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set_6123","======== Resolving type reference directive '{0}', containing file '{1}', root directory not set. ========"),Type_declaration_files_to_be_included_in_compilation:C(6124,3,"Type_declaration_files_to_be_included_in_compilation_6124","Type declaration files to be included in compilation."),Looking_up_in_node_modules_folder_initial_location_0:C(6125,3,"Looking_up_in_node_modules_folder_initial_location_0_6125","Looking up in 'node_modules' folder, initial location '{0}'."),Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder:C(6126,3,"Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_mod_6126","Containing file is not specified and root directory cannot be determined, skipping lookup in 'node_modules' folder."),Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1:C(6127,3,"Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1_6127","======== Resolving type reference directive '{0}', containing file not set, root directory '{1}'. ========"),Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set:C(6128,3,"Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set_6128","======== Resolving type reference directive '{0}', containing file not set, root directory not set. ========"),Resolving_real_path_for_0_result_1:C(6130,3,"Resolving_real_path_for_0_result_1_6130","Resolving real path for '{0}', result '{1}'."),Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system:C(6131,1,"Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system_6131","Cannot compile modules using option '{0}' unless the '--module' flag is 'amd' or 'system'."),File_name_0_has_a_1_extension_stripping_it:C(6132,3,"File_name_0_has_a_1_extension_stripping_it_6132","File name '{0}' has a '{1}' extension - stripping it."),_0_is_declared_but_its_value_is_never_read:C(6133,1,"_0_is_declared_but_its_value_is_never_read_6133","'{0}' is declared but its value is never read.",!0),Report_errors_on_unused_locals:C(6134,3,"Report_errors_on_unused_locals_6134","Report errors on unused locals."),Report_errors_on_unused_parameters:C(6135,3,"Report_errors_on_unused_parameters_6135","Report errors on unused parameters."),The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files:C(6136,3,"The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files_6136","The maximum dependency depth to search under node_modules and load JavaScript files."),Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1:C(6137,1,"Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1_6137","Cannot import type declaration files. Consider importing '{0}' instead of '{1}'."),Property_0_is_declared_but_its_value_is_never_read:C(6138,1,"Property_0_is_declared_but_its_value_is_never_read_6138","Property '{0}' is declared but its value is never read.",!0),Import_emit_helpers_from_tslib:C(6139,3,"Import_emit_helpers_from_tslib_6139","Import emit helpers from 'tslib'."),Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2:C(6140,1,"Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using__6140","Auto discovery for typings is enabled in project '{0}'. Running extra resolution pass for module '{1}' using cache location '{2}'."),Parse_in_strict_mode_and_emit_use_strict_for_each_source_file:C(6141,3,"Parse_in_strict_mode_and_emit_use_strict_for_each_source_file_6141",'Parse in strict mode and emit "use strict" for each source file.'),Module_0_was_resolved_to_1_but_jsx_is_not_set:C(6142,1,"Module_0_was_resolved_to_1_but_jsx_is_not_set_6142","Module '{0}' was resolved to '{1}', but '--jsx' is not set."),Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1:C(6144,3,"Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1_6144","Module '{0}' was resolved as locally declared ambient module in file '{1}'."),Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified:C(6145,3,"Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified_6145","Module '{0}' was resolved as ambient module declared in '{1}' since this file was not modified."),Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h:C(6146,3,"Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h_6146","Specify the JSX factory function to use when targeting 'react' JSX emit, e.g. 'React.createElement' or 'h'."),Resolution_for_module_0_was_found_in_cache_from_location_1:C(6147,3,"Resolution_for_module_0_was_found_in_cache_from_location_1_6147","Resolution for module '{0}' was found in cache from location '{1}'."),Directory_0_does_not_exist_skipping_all_lookups_in_it:C(6148,3,"Directory_0_does_not_exist_skipping_all_lookups_in_it_6148","Directory '{0}' does not exist, skipping all lookups in it."),Show_diagnostic_information:C(6149,3,"Show_diagnostic_information_6149","Show diagnostic information."),Show_verbose_diagnostic_information:C(6150,3,"Show_verbose_diagnostic_information_6150","Show verbose diagnostic information."),Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file:C(6151,3,"Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file_6151","Emit a single file with source maps instead of having a separate file."),Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set:C(6152,3,"Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap__6152","Emit the source alongside the sourcemaps within a single file; requires '--inlineSourceMap' or '--sourceMap' to be set."),Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule:C(6153,3,"Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule_6153","Transpile each file as a separate module (similar to 'ts.transpileModule')."),Print_names_of_generated_files_part_of_the_compilation:C(6154,3,"Print_names_of_generated_files_part_of_the_compilation_6154","Print names of generated files part of the compilation."),Print_names_of_files_part_of_the_compilation:C(6155,3,"Print_names_of_files_part_of_the_compilation_6155","Print names of files part of the compilation."),The_locale_used_when_displaying_messages_to_the_user_e_g_en_us:C(6156,3,"The_locale_used_when_displaying_messages_to_the_user_e_g_en_us_6156","The locale used when displaying messages to the user (e.g. 'en-us')"),Do_not_generate_custom_helper_functions_like_extends_in_compiled_output:C(6157,3,"Do_not_generate_custom_helper_functions_like_extends_in_compiled_output_6157","Do not generate custom helper functions like '__extends' in compiled output."),Do_not_include_the_default_library_file_lib_d_ts:C(6158,3,"Do_not_include_the_default_library_file_lib_d_ts_6158","Do not include the default library file (lib.d.ts)."),Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files:C(6159,3,"Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files_6159","Do not add triple-slash references or imported modules to the list of compiled files."),Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files:C(6160,3,"Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files_6160","[Deprecated] Use '--skipLibCheck' instead. Skip type checking of default library declaration files."),List_of_folders_to_include_type_definitions_from:C(6161,3,"List_of_folders_to_include_type_definitions_from_6161","List of folders to include type definitions from."),Disable_size_limitations_on_JavaScript_projects:C(6162,3,"Disable_size_limitations_on_JavaScript_projects_6162","Disable size limitations on JavaScript projects."),The_character_set_of_the_input_files:C(6163,3,"The_character_set_of_the_input_files_6163","The character set of the input files."),Skipping_module_0_that_looks_like_an_absolute_URI_target_file_types_Colon_1:C(6164,3,"Skipping_module_0_that_looks_like_an_absolute_URI_target_file_types_Colon_1_6164","Skipping module '{0}' that looks like an absolute URI, target file types: {1}."),Do_not_truncate_error_messages:C(6165,3,"Do_not_truncate_error_messages_6165","Do not truncate error messages."),Output_directory_for_generated_declaration_files:C(6166,3,"Output_directory_for_generated_declaration_files_6166","Output directory for generated declaration files."),A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl:C(6167,3,"A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl_6167","A series of entries which re-map imports to lookup locations relative to the 'baseUrl'."),List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime:C(6168,3,"List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime_6168","List of root folders whose combined content represents the structure of the project at runtime."),Show_all_compiler_options:C(6169,3,"Show_all_compiler_options_6169","Show all compiler options."),Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file:C(6170,3,"Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file_6170","[Deprecated] Use '--outFile' instead. Concatenate and emit output to single file"),Command_line_Options:C(6171,3,"Command_line_Options_6171","Command-line Options"),Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3:C(6179,3,"Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3_6179","Provide full support for iterables in 'for-of', spread, and destructuring when targeting 'ES5' or 'ES3'."),Enable_all_strict_type_checking_options:C(6180,3,"Enable_all_strict_type_checking_options_6180","Enable all strict type-checking options."),Scoped_package_detected_looking_in_0:C(6182,3,"Scoped_package_detected_looking_in_0_6182","Scoped package detected, looking in '{0}'"),Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2:C(6183,3,"Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_6183","Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."),Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:C(6184,3,"Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package__6184","Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."),Enable_strict_checking_of_function_types:C(6186,3,"Enable_strict_checking_of_function_types_6186","Enable strict checking of function types."),Enable_strict_checking_of_property_initialization_in_classes:C(6187,3,"Enable_strict_checking_of_property_initialization_in_classes_6187","Enable strict checking of property initialization in classes."),Numeric_separators_are_not_allowed_here:C(6188,1,"Numeric_separators_are_not_allowed_here_6188","Numeric separators are not allowed here."),Multiple_consecutive_numeric_separators_are_not_permitted:C(6189,1,"Multiple_consecutive_numeric_separators_are_not_permitted_6189","Multiple consecutive numeric separators are not permitted."),Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen:C(6191,3,"Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen_6191","Whether to keep outdated console output in watch mode instead of clearing the screen."),All_imports_in_import_declaration_are_unused:C(6192,1,"All_imports_in_import_declaration_are_unused_6192","All imports in import declaration are unused.",!0),Found_1_error_Watching_for_file_changes:C(6193,3,"Found_1_error_Watching_for_file_changes_6193","Found 1 error. Watching for file changes."),Found_0_errors_Watching_for_file_changes:C(6194,3,"Found_0_errors_Watching_for_file_changes_6194","Found {0} errors. Watching for file changes."),Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols:C(6195,3,"Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols_6195","Resolve 'keyof' to string valued property names only (no numbers or symbols)."),_0_is_declared_but_never_used:C(6196,1,"_0_is_declared_but_never_used_6196","'{0}' is declared but never used.",!0),Include_modules_imported_with_json_extension:C(6197,3,"Include_modules_imported_with_json_extension_6197","Include modules imported with '.json' extension"),All_destructured_elements_are_unused:C(6198,1,"All_destructured_elements_are_unused_6198","All destructured elements are unused.",!0),All_variables_are_unused:C(6199,1,"All_variables_are_unused_6199","All variables are unused.",!0),Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0:C(6200,1,"Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0_6200","Definitions of the following identifiers conflict with those in another file: {0}"),Conflicts_are_in_this_file:C(6201,3,"Conflicts_are_in_this_file_6201","Conflicts are in this file."),Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0:C(6202,1,"Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0_6202","Project references may not form a circular graph. Cycle detected: {0}"),_0_was_also_declared_here:C(6203,3,"_0_was_also_declared_here_6203","'{0}' was also declared here."),and_here:C(6204,3,"and_here_6204","and here."),All_type_parameters_are_unused:C(6205,1,"All_type_parameters_are_unused_6205","All type parameters are unused."),package_json_has_a_typesVersions_field_with_version_specific_path_mappings:C(6206,3,"package_json_has_a_typesVersions_field_with_version_specific_path_mappings_6206","'package.json' has a 'typesVersions' field with version-specific path mappings."),package_json_does_not_have_a_typesVersions_entry_that_matches_version_0:C(6207,3,"package_json_does_not_have_a_typesVersions_entry_that_matches_version_0_6207","'package.json' does not have a 'typesVersions' entry that matches version '{0}'."),package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2:C(6208,3,"package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_ma_6208","'package.json' has a 'typesVersions' entry '{0}' that matches compiler version '{1}', looking for a pattern to match module name '{2}'."),package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range:C(6209,3,"package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range_6209","'package.json' has a 'typesVersions' entry '{0}' that is not a valid semver range."),An_argument_for_0_was_not_provided:C(6210,3,"An_argument_for_0_was_not_provided_6210","An argument for '{0}' was not provided."),An_argument_matching_this_binding_pattern_was_not_provided:C(6211,3,"An_argument_matching_this_binding_pattern_was_not_provided_6211","An argument matching this binding pattern was not provided."),Did_you_mean_to_call_this_expression:C(6212,3,"Did_you_mean_to_call_this_expression_6212","Did you mean to call this expression?"),Did_you_mean_to_use_new_with_this_expression:C(6213,3,"Did_you_mean_to_use_new_with_this_expression_6213","Did you mean to use 'new' with this expression?"),Enable_strict_bind_call_and_apply_methods_on_functions:C(6214,3,"Enable_strict_bind_call_and_apply_methods_on_functions_6214","Enable strict 'bind', 'call', and 'apply' methods on functions."),Using_compiler_options_of_project_reference_redirect_0:C(6215,3,"Using_compiler_options_of_project_reference_redirect_0_6215","Using compiler options of project reference redirect '{0}'."),Found_1_error:C(6216,3,"Found_1_error_6216","Found 1 error."),Found_0_errors:C(6217,3,"Found_0_errors_6217","Found {0} errors."),Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2:C(6218,3,"Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2_6218","======== Module name '{0}' was successfully resolved to '{1}' with Package ID '{2}'. ========"),Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3:C(6219,3,"Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3_6219","======== Type reference directive '{0}' was successfully resolved to '{1}' with Package ID '{2}', primary: {3}. ========"),package_json_had_a_falsy_0_field:C(6220,3,"package_json_had_a_falsy_0_field_6220","'package.json' had a falsy '{0}' field."),Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects:C(6221,3,"Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects_6221","Disable use of source files instead of declaration files from referenced projects."),Emit_class_fields_with_Define_instead_of_Set:C(6222,3,"Emit_class_fields_with_Define_instead_of_Set_6222","Emit class fields with Define instead of Set."),Generates_a_CPU_profile:C(6223,3,"Generates_a_CPU_profile_6223","Generates a CPU profile."),Disable_solution_searching_for_this_project:C(6224,3,"Disable_solution_searching_for_this_project_6224","Disable solution searching for this project."),Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling_UseFsEvents_UseFsEventsOnParentDirectory:C(6225,3,"Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_Dynami_6225","Specify strategy for watching file: 'FixedPollingInterval' (default), 'PriorityPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling', 'UseFsEvents', 'UseFsEventsOnParentDirectory'."),Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively_Colon_UseFsEvents_default_FixedPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling:C(6226,3,"Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively__6226","Specify strategy for watching directory on platforms that don't support recursive watching natively: 'UseFsEvents' (default), 'FixedPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling'."),Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_FixedInterval_default_PriorityInterval_DynamicPriority_FixedChunkSize:C(6227,3,"Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_6227","Specify strategy for creating a polling watch when it fails to create using file system events: 'FixedInterval' (default), 'PriorityInterval', 'DynamicPriority', 'FixedChunkSize'."),Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3:C(6229,1,"Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3_6229","Tag '{0}' expects at least '{1}' arguments, but the JSX factory '{2}' provides at most '{3}'."),Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line:C(6230,1,"Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line_6230","Option '{0}' can only be specified in 'tsconfig.json' file or set to 'false' or 'null' on command line."),Could_not_resolve_the_path_0_with_the_extensions_Colon_1:C(6231,1,"Could_not_resolve_the_path_0_with_the_extensions_Colon_1_6231","Could not resolve the path '{0}' with the extensions: {1}."),Declaration_augments_declaration_in_another_file_This_cannot_be_serialized:C(6232,1,"Declaration_augments_declaration_in_another_file_This_cannot_be_serialized_6232","Declaration augments declaration in another file. This cannot be serialized."),This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file:C(6233,1,"This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_fil_6233","This is the declaration being augmented. Consider moving the augmenting declaration into the same file."),This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without:C(6234,1,"This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without_6234","This expression is not callable because it is a 'get' accessor. Did you mean to use it without '()'?"),Disable_loading_referenced_projects:C(6235,3,"Disable_loading_referenced_projects_6235","Disable loading referenced projects."),Arguments_for_the_rest_parameter_0_were_not_provided:C(6236,1,"Arguments_for_the_rest_parameter_0_were_not_provided_6236","Arguments for the rest parameter '{0}' were not provided."),Generates_an_event_trace_and_a_list_of_types:C(6237,3,"Generates_an_event_trace_and_a_list_of_types_6237","Generates an event trace and a list of types."),Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react:C(6238,1,"Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react_6238","Specify the module specifier to be used to import the 'jsx' and 'jsxs' factory functions from. eg, react"),File_0_exists_according_to_earlier_cached_lookups:C(6239,3,"File_0_exists_according_to_earlier_cached_lookups_6239","File '{0}' exists according to earlier cached lookups."),File_0_does_not_exist_according_to_earlier_cached_lookups:C(6240,3,"File_0_does_not_exist_according_to_earlier_cached_lookups_6240","File '{0}' does not exist according to earlier cached lookups."),Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1:C(6241,3,"Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1_6241","Resolution for type reference directive '{0}' was found in cache from location '{1}'."),Resolving_type_reference_directive_0_containing_file_1:C(6242,3,"Resolving_type_reference_directive_0_containing_file_1_6242","======== Resolving type reference directive '{0}', containing file '{1}'. ========"),Interpret_optional_property_types_as_written_rather_than_adding_undefined:C(6243,3,"Interpret_optional_property_types_as_written_rather_than_adding_undefined_6243","Interpret optional property types as written, rather than adding 'undefined'."),Modules:C(6244,3,"Modules_6244","Modules"),File_Management:C(6245,3,"File_Management_6245","File Management"),Emit:C(6246,3,"Emit_6246","Emit"),JavaScript_Support:C(6247,3,"JavaScript_Support_6247","JavaScript Support"),Type_Checking:C(6248,3,"Type_Checking_6248","Type Checking"),Editor_Support:C(6249,3,"Editor_Support_6249","Editor Support"),Watch_and_Build_Modes:C(6250,3,"Watch_and_Build_Modes_6250","Watch and Build Modes"),Compiler_Diagnostics:C(6251,3,"Compiler_Diagnostics_6251","Compiler Diagnostics"),Interop_Constraints:C(6252,3,"Interop_Constraints_6252","Interop Constraints"),Backwards_Compatibility:C(6253,3,"Backwards_Compatibility_6253","Backwards Compatibility"),Language_and_Environment:C(6254,3,"Language_and_Environment_6254","Language and Environment"),Projects:C(6255,3,"Projects_6255","Projects"),Output_Formatting:C(6256,3,"Output_Formatting_6256","Output Formatting"),Completeness:C(6257,3,"Completeness_6257","Completeness"),_0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file:C(6258,1,"_0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file_6258","'{0}' should be set inside the 'compilerOptions' object of the config json file"),Found_1_error_in_0:C(6259,3,"Found_1_error_in_0_6259","Found 1 error in {0}"),Found_0_errors_in_the_same_file_starting_at_Colon_1:C(6260,3,"Found_0_errors_in_the_same_file_starting_at_Colon_1_6260","Found {0} errors in the same file, starting at: {1}"),Found_0_errors_in_1_files:C(6261,3,"Found_0_errors_in_1_files_6261","Found {0} errors in {1} files."),File_name_0_has_a_1_extension_looking_up_2_instead:C(6262,3,"File_name_0_has_a_1_extension_looking_up_2_instead_6262","File name '{0}' has a '{1}' extension - looking up '{2}' instead."),Module_0_was_resolved_to_1_but_allowArbitraryExtensions_is_not_set:C(6263,1,"Module_0_was_resolved_to_1_but_allowArbitraryExtensions_is_not_set_6263","Module '{0}' was resolved to '{1}', but '--allowArbitraryExtensions' is not set."),Enable_importing_files_with_any_extension_provided_a_declaration_file_is_present:C(6264,3,"Enable_importing_files_with_any_extension_provided_a_declaration_file_is_present_6264","Enable importing files with any extension, provided a declaration file is present."),Resolving_type_reference_directive_for_program_that_specifies_custom_typeRoots_skipping_lookup_in_node_modules_folder:C(6265,3,"Resolving_type_reference_directive_for_program_that_specifies_custom_typeRoots_skipping_lookup_in_no_6265","Resolving type reference directive for program that specifies custom typeRoots, skipping lookup in 'node_modules' folder."),Option_0_can_only_be_specified_on_command_line:C(6266,1,"Option_0_can_only_be_specified_on_command_line_6266","Option '{0}' can only be specified on command line."),Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve:C(6270,3,"Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve_6270","Directory '{0}' has no containing package.json scope. Imports will not resolve."),Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1:C(6271,3,"Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6271","Import specifier '{0}' does not exist in package.json scope at path '{1}'."),Invalid_import_specifier_0_has_no_possible_resolutions:C(6272,3,"Invalid_import_specifier_0_has_no_possible_resolutions_6272","Invalid import specifier '{0}' has no possible resolutions."),package_json_scope_0_has_no_imports_defined:C(6273,3,"package_json_scope_0_has_no_imports_defined_6273","package.json scope '{0}' has no imports defined."),package_json_scope_0_explicitly_maps_specifier_1_to_null:C(6274,3,"package_json_scope_0_explicitly_maps_specifier_1_to_null_6274","package.json scope '{0}' explicitly maps specifier '{1}' to null."),package_json_scope_0_has_invalid_type_for_target_of_specifier_1:C(6275,3,"package_json_scope_0_has_invalid_type_for_target_of_specifier_1_6275","package.json scope '{0}' has invalid type for target of specifier '{1}'"),Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1:C(6276,3,"Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6276","Export specifier '{0}' does not exist in package.json scope at path '{1}'."),Resolution_of_non_relative_name_failed_trying_with_modern_Node_resolution_features_disabled_to_see_if_npm_library_needs_configuration_update:C(6277,3,"Resolution_of_non_relative_name_failed_trying_with_modern_Node_resolution_features_disabled_to_see_i_6277","Resolution of non-relative name failed; trying with modern Node resolution features disabled to see if npm library needs configuration update."),There_are_types_at_0_but_this_result_could_not_be_resolved_when_respecting_package_json_exports_The_1_library_may_need_to_update_its_package_json_or_typings:C(6278,3,"There_are_types_at_0_but_this_result_could_not_be_resolved_when_respecting_package_json_exports_The__6278",`There are types at '{0}', but this result could not be resolved when respecting package.json "exports". The '{1}' library may need to update its package.json or typings.`),Resolution_of_non_relative_name_failed_trying_with_moduleResolution_bundler_to_see_if_project_may_need_configuration_update:C(6279,3,"Resolution_of_non_relative_name_failed_trying_with_moduleResolution_bundler_to_see_if_project_may_ne_6279","Resolution of non-relative name failed; trying with '--moduleResolution bundler' to see if project may need configuration update."),There_are_types_at_0_but_this_result_could_not_be_resolved_under_your_current_moduleResolution_setting_Consider_updating_to_node16_nodenext_or_bundler:C(6280,3,"There_are_types_at_0_but_this_result_could_not_be_resolved_under_your_current_moduleResolution_setti_6280","There are types at '{0}', but this result could not be resolved under your current 'moduleResolution' setting. Consider updating to 'node16', 'nodenext', or 'bundler'."),Enable_project_compilation:C(6302,3,"Enable_project_compilation_6302","Enable project compilation"),Composite_projects_may_not_disable_declaration_emit:C(6304,1,"Composite_projects_may_not_disable_declaration_emit_6304","Composite projects may not disable declaration emit."),Output_file_0_has_not_been_built_from_source_file_1:C(6305,1,"Output_file_0_has_not_been_built_from_source_file_1_6305","Output file '{0}' has not been built from source file '{1}'."),Referenced_project_0_must_have_setting_composite_Colon_true:C(6306,1,"Referenced_project_0_must_have_setting_composite_Colon_true_6306",`Referenced project '{0}' must have setting "composite": true.`),File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern:C(6307,1,"File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_includ_6307","File '{0}' is not listed within the file list of project '{1}'. Projects must list all files or use an 'include' pattern."),Cannot_prepend_project_0_because_it_does_not_have_outFile_set:C(6308,1,"Cannot_prepend_project_0_because_it_does_not_have_outFile_set_6308","Cannot prepend project '{0}' because it does not have 'outFile' set"),Output_file_0_from_project_1_does_not_exist:C(6309,1,"Output_file_0_from_project_1_does_not_exist_6309","Output file '{0}' from project '{1}' does not exist"),Referenced_project_0_may_not_disable_emit:C(6310,1,"Referenced_project_0_may_not_disable_emit_6310","Referenced project '{0}' may not disable emit."),Project_0_is_out_of_date_because_output_1_is_older_than_input_2:C(6350,3,"Project_0_is_out_of_date_because_output_1_is_older_than_input_2_6350","Project '{0}' is out of date because output '{1}' is older than input '{2}'"),Project_0_is_up_to_date_because_newest_input_1_is_older_than_output_2:C(6351,3,"Project_0_is_up_to_date_because_newest_input_1_is_older_than_output_2_6351","Project '{0}' is up to date because newest input '{1}' is older than output '{2}'"),Project_0_is_out_of_date_because_output_file_1_does_not_exist:C(6352,3,"Project_0_is_out_of_date_because_output_file_1_does_not_exist_6352","Project '{0}' is out of date because output file '{1}' does not exist"),Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date:C(6353,3,"Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date_6353","Project '{0}' is out of date because its dependency '{1}' is out of date"),Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies:C(6354,3,"Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies_6354","Project '{0}' is up to date with .d.ts files from its dependencies"),Projects_in_this_build_Colon_0:C(6355,3,"Projects_in_this_build_Colon_0_6355","Projects in this build: {0}"),A_non_dry_build_would_delete_the_following_files_Colon_0:C(6356,3,"A_non_dry_build_would_delete_the_following_files_Colon_0_6356","A non-dry build would delete the following files: {0}"),A_non_dry_build_would_build_project_0:C(6357,3,"A_non_dry_build_would_build_project_0_6357","A non-dry build would build project '{0}'"),Building_project_0:C(6358,3,"Building_project_0_6358","Building project '{0}'..."),Updating_output_timestamps_of_project_0:C(6359,3,"Updating_output_timestamps_of_project_0_6359","Updating output timestamps of project '{0}'..."),Project_0_is_up_to_date:C(6361,3,"Project_0_is_up_to_date_6361","Project '{0}' is up to date"),Skipping_build_of_project_0_because_its_dependency_1_has_errors:C(6362,3,"Skipping_build_of_project_0_because_its_dependency_1_has_errors_6362","Skipping build of project '{0}' because its dependency '{1}' has errors"),Project_0_can_t_be_built_because_its_dependency_1_has_errors:C(6363,3,"Project_0_can_t_be_built_because_its_dependency_1_has_errors_6363","Project '{0}' can't be built because its dependency '{1}' has errors"),Build_one_or_more_projects_and_their_dependencies_if_out_of_date:C(6364,3,"Build_one_or_more_projects_and_their_dependencies_if_out_of_date_6364","Build one or more projects and their dependencies, if out of date"),Delete_the_outputs_of_all_projects:C(6365,3,"Delete_the_outputs_of_all_projects_6365","Delete the outputs of all projects."),Show_what_would_be_built_or_deleted_if_specified_with_clean:C(6367,3,"Show_what_would_be_built_or_deleted_if_specified_with_clean_6367","Show what would be built (or deleted, if specified with '--clean')"),Option_build_must_be_the_first_command_line_argument:C(6369,1,"Option_build_must_be_the_first_command_line_argument_6369","Option '--build' must be the first command line argument."),Options_0_and_1_cannot_be_combined:C(6370,1,"Options_0_and_1_cannot_be_combined_6370","Options '{0}' and '{1}' cannot be combined."),Updating_unchanged_output_timestamps_of_project_0:C(6371,3,"Updating_unchanged_output_timestamps_of_project_0_6371","Updating unchanged output timestamps of project '{0}'..."),Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed:C(6372,3,"Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed_6372","Project '{0}' is out of date because output of its dependency '{1}' has changed"),Updating_output_of_project_0:C(6373,3,"Updating_output_of_project_0_6373","Updating output of project '{0}'..."),A_non_dry_build_would_update_timestamps_for_output_of_project_0:C(6374,3,"A_non_dry_build_would_update_timestamps_for_output_of_project_0_6374","A non-dry build would update timestamps for output of project '{0}'"),A_non_dry_build_would_update_output_of_project_0:C(6375,3,"A_non_dry_build_would_update_output_of_project_0_6375","A non-dry build would update output of project '{0}'"),Cannot_update_output_of_project_0_because_there_was_error_reading_file_1:C(6376,3,"Cannot_update_output_of_project_0_because_there_was_error_reading_file_1_6376","Cannot update output of project '{0}' because there was error reading file '{1}'"),Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1:C(6377,1,"Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1_6377","Cannot write file '{0}' because it will overwrite '.tsbuildinfo' file generated by referenced project '{1}'"),Composite_projects_may_not_disable_incremental_compilation:C(6379,1,"Composite_projects_may_not_disable_incremental_compilation_6379","Composite projects may not disable incremental compilation."),Specify_file_to_store_incremental_compilation_information:C(6380,3,"Specify_file_to_store_incremental_compilation_information_6380","Specify file to store incremental compilation information"),Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2:C(6381,3,"Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_curren_6381","Project '{0}' is out of date because output for it was generated with version '{1}' that differs with current version '{2}'"),Skipping_build_of_project_0_because_its_dependency_1_was_not_built:C(6382,3,"Skipping_build_of_project_0_because_its_dependency_1_was_not_built_6382","Skipping build of project '{0}' because its dependency '{1}' was not built"),Project_0_can_t_be_built_because_its_dependency_1_was_not_built:C(6383,3,"Project_0_can_t_be_built_because_its_dependency_1_was_not_built_6383","Project '{0}' can't be built because its dependency '{1}' was not built"),Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it:C(6384,3,"Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_di_6384","Have recompiles in '--incremental' and '--watch' assume that changes within a file will only affect files directly depending on it."),_0_is_deprecated:C(6385,2,"_0_is_deprecated_6385","'{0}' is deprecated.",void 0,void 0,!0),Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_native_implementation_of_the_Web_Performance_API_could_not_be_found:C(6386,3,"Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_nativ_6386","Performance timings for '--diagnostics' or '--extendedDiagnostics' are not available in this session. A native implementation of the Web Performance API could not be found."),The_signature_0_of_1_is_deprecated:C(6387,2,"The_signature_0_of_1_is_deprecated_6387","The signature '{0}' of '{1}' is deprecated.",void 0,void 0,!0),Project_0_is_being_forcibly_rebuilt:C(6388,3,"Project_0_is_being_forcibly_rebuilt_6388","Project '{0}' is being forcibly rebuilt"),Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved:C(6389,3,"Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved_6389","Reusing resolution of module '{0}' from '{1}' of old program, it was not resolved."),Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2:C(6390,3,"Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6390","Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."),Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:C(6391,3,"Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6391","Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."),Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved:C(6392,3,"Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved_6392","Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was not resolved."),Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3:C(6393,3,"Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6393","Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."),Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4:C(6394,3,"Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6394","Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."),Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved:C(6395,3,"Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved_6395","Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was not resolved."),Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3:C(6396,3,"Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6396","Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."),Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4:C(6397,3,"Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6397","Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."),Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_resolved:C(6398,3,"Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_re_6398","Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was not resolved."),Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_some_of_the_changes_were_not_emitted:C(6399,3,"Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_some_of_the_changes_were_not_emitte_6399","Project '{0}' is out of date because buildinfo file '{1}' indicates that some of the changes were not emitted"),Project_0_is_up_to_date_but_needs_to_update_timestamps_of_output_files_that_are_older_than_input_files:C(6400,3,"Project_0_is_up_to_date_but_needs_to_update_timestamps_of_output_files_that_are_older_than_input_fil_6400","Project '{0}' is up to date but needs to update timestamps of output files that are older than input files"),Project_0_is_out_of_date_because_there_was_error_reading_file_1:C(6401,3,"Project_0_is_out_of_date_because_there_was_error_reading_file_1_6401","Project '{0}' is out of date because there was error reading file '{1}'"),Resolving_in_0_mode_with_conditions_1:C(6402,3,"Resolving_in_0_mode_with_conditions_1_6402","Resolving in {0} mode with conditions {1}."),Matched_0_condition_1:C(6403,3,"Matched_0_condition_1_6403","Matched '{0}' condition '{1}'."),Using_0_subpath_1_with_target_2:C(6404,3,"Using_0_subpath_1_with_target_2_6404","Using '{0}' subpath '{1}' with target '{2}'."),Saw_non_matching_condition_0:C(6405,3,"Saw_non_matching_condition_0_6405","Saw non-matching condition '{0}'."),Project_0_is_out_of_date_because_buildinfo_file_1_indicates_there_is_change_in_compilerOptions:C(6406,3,"Project_0_is_out_of_date_because_buildinfo_file_1_indicates_there_is_change_in_compilerOptions_6406","Project '{0}' is out of date because buildinfo file '{1}' indicates there is change in compilerOptions"),Allow_imports_to_include_TypeScript_file_extensions_Requires_moduleResolution_bundler_and_either_noEmit_or_emitDeclarationOnly_to_be_set:C(6407,3,"Allow_imports_to_include_TypeScript_file_extensions_Requires_moduleResolution_bundler_and_either_noE_6407","Allow imports to include TypeScript file extensions. Requires '--moduleResolution bundler' and either '--noEmit' or '--emitDeclarationOnly' to be set."),Use_the_package_json_exports_field_when_resolving_package_imports:C(6408,3,"Use_the_package_json_exports_field_when_resolving_package_imports_6408","Use the package.json 'exports' field when resolving package imports."),Use_the_package_json_imports_field_when_resolving_imports:C(6409,3,"Use_the_package_json_imports_field_when_resolving_imports_6409","Use the package.json 'imports' field when resolving imports."),Conditions_to_set_in_addition_to_the_resolver_specific_defaults_when_resolving_imports:C(6410,3,"Conditions_to_set_in_addition_to_the_resolver_specific_defaults_when_resolving_imports_6410","Conditions to set in addition to the resolver-specific defaults when resolving imports."),true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false:C(6411,3,"true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false_6411","`true` when 'moduleResolution' is 'node16', 'nodenext', or 'bundler'; otherwise `false`."),Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_file_2_was_root_file_of_compilation_but_not_any_more:C(6412,3,"Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_file_2_was_root_file_of_compilation_6412","Project '{0}' is out of date because buildinfo file '{1}' indicates that file '{2}' was root file of compilation but not any more."),Entering_conditional_exports:C(6413,3,"Entering_conditional_exports_6413","Entering conditional exports."),Resolved_under_condition_0:C(6414,3,"Resolved_under_condition_0_6414","Resolved under condition '{0}'."),Failed_to_resolve_under_condition_0:C(6415,3,"Failed_to_resolve_under_condition_0_6415","Failed to resolve under condition '{0}'."),Exiting_conditional_exports:C(6416,3,"Exiting_conditional_exports_6416","Exiting conditional exports."),Searching_all_ancestor_node_modules_directories_for_preferred_extensions_Colon_0:C(6417,3,"Searching_all_ancestor_node_modules_directories_for_preferred_extensions_Colon_0_6417","Searching all ancestor node_modules directories for preferred extensions: {0}."),Searching_all_ancestor_node_modules_directories_for_fallback_extensions_Colon_0:C(6418,3,"Searching_all_ancestor_node_modules_directories_for_fallback_extensions_Colon_0_6418","Searching all ancestor node_modules directories for fallback extensions: {0}."),The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1:C(6500,3,"The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1_6500","The expected type comes from property '{0}' which is declared here on type '{1}'"),The_expected_type_comes_from_this_index_signature:C(6501,3,"The_expected_type_comes_from_this_index_signature_6501","The expected type comes from this index signature."),The_expected_type_comes_from_the_return_type_of_this_signature:C(6502,3,"The_expected_type_comes_from_the_return_type_of_this_signature_6502","The expected type comes from the return type of this signature."),Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing:C(6503,3,"Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing_6503","Print names of files that are part of the compilation and then stop processing."),File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option:C(6504,1,"File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option_6504","File '{0}' is a JavaScript file. Did you mean to enable the 'allowJs' option?"),Print_names_of_files_and_the_reason_they_are_part_of_the_compilation:C(6505,3,"Print_names_of_files_and_the_reason_they_are_part_of_the_compilation_6505","Print names of files and the reason they are part of the compilation."),Consider_adding_a_declare_modifier_to_this_class:C(6506,3,"Consider_adding_a_declare_modifier_to_this_class_6506","Consider adding a 'declare' modifier to this class."),Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files:C(6600,3,"Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these__6600","Allow JavaScript files to be a part of your program. Use the 'checkJS' option to get errors from these files."),Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export:C(6601,3,"Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export_6601","Allow 'import x from y' when a module doesn't have a default export."),Allow_accessing_UMD_globals_from_modules:C(6602,3,"Allow_accessing_UMD_globals_from_modules_6602","Allow accessing UMD globals from modules."),Disable_error_reporting_for_unreachable_code:C(6603,3,"Disable_error_reporting_for_unreachable_code_6603","Disable error reporting for unreachable code."),Disable_error_reporting_for_unused_labels:C(6604,3,"Disable_error_reporting_for_unused_labels_6604","Disable error reporting for unused labels."),Ensure_use_strict_is_always_emitted:C(6605,3,"Ensure_use_strict_is_always_emitted_6605","Ensure 'use strict' is always emitted."),Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it:C(6606,3,"Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_wi_6606","Have recompiles in projects that use 'incremental' and 'watch' mode assume that changes within a file will only affect files directly depending on it."),Specify_the_base_directory_to_resolve_non_relative_module_names:C(6607,3,"Specify_the_base_directory_to_resolve_non_relative_module_names_6607","Specify the base directory to resolve non-relative module names."),No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files:C(6608,3,"No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files_6608","No longer supported. In early versions, manually set the text encoding for reading files."),Enable_error_reporting_in_type_checked_JavaScript_files:C(6609,3,"Enable_error_reporting_in_type_checked_JavaScript_files_6609","Enable error reporting in type-checked JavaScript files."),Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references:C(6611,3,"Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references_6611","Enable constraints that allow a TypeScript project to be used with project references."),Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project:C(6612,3,"Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project_6612","Generate .d.ts files from TypeScript and JavaScript files in your project."),Specify_the_output_directory_for_generated_declaration_files:C(6613,3,"Specify_the_output_directory_for_generated_declaration_files_6613","Specify the output directory for generated declaration files."),Create_sourcemaps_for_d_ts_files:C(6614,3,"Create_sourcemaps_for_d_ts_files_6614","Create sourcemaps for d.ts files."),Output_compiler_performance_information_after_building:C(6615,3,"Output_compiler_performance_information_after_building_6615","Output compiler performance information after building."),Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project:C(6616,3,"Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project_6616","Disables inference for type acquisition by looking at filenames in a project."),Reduce_the_number_of_projects_loaded_automatically_by_TypeScript:C(6617,3,"Reduce_the_number_of_projects_loaded_automatically_by_TypeScript_6617","Reduce the number of projects loaded automatically by TypeScript."),Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server:C(6618,3,"Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server_6618","Remove the 20mb cap on total source code size for JavaScript files in the TypeScript language server."),Opt_a_project_out_of_multi_project_reference_checking_when_editing:C(6619,3,"Opt_a_project_out_of_multi_project_reference_checking_when_editing_6619","Opt a project out of multi-project reference checking when editing."),Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects:C(6620,3,"Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects_6620","Disable preferring source files instead of declaration files when referencing composite projects."),Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration:C(6621,3,"Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration_6621","Emit more compliant, but verbose and less performant JavaScript for iteration."),Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files:C(6622,3,"Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files_6622","Emit a UTF-8 Byte Order Mark (BOM) in the beginning of output files."),Only_output_d_ts_files_and_not_JavaScript_files:C(6623,3,"Only_output_d_ts_files_and_not_JavaScript_files_6623","Only output d.ts files and not JavaScript files."),Emit_design_type_metadata_for_decorated_declarations_in_source_files:C(6624,3,"Emit_design_type_metadata_for_decorated_declarations_in_source_files_6624","Emit design-type metadata for decorated declarations in source files."),Disable_the_type_acquisition_for_JavaScript_projects:C(6625,3,"Disable_the_type_acquisition_for_JavaScript_projects_6625","Disable the type acquisition for JavaScript projects"),Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility:C(6626,3,"Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheti_6626","Emit additional JavaScript to ease support for importing CommonJS modules. This enables 'allowSyntheticDefaultImports' for type compatibility."),Filters_results_from_the_include_option:C(6627,3,"Filters_results_from_the_include_option_6627","Filters results from the `include` option."),Remove_a_list_of_directories_from_the_watch_process:C(6628,3,"Remove_a_list_of_directories_from_the_watch_process_6628","Remove a list of directories from the watch process."),Remove_a_list_of_files_from_the_watch_mode_s_processing:C(6629,3,"Remove_a_list_of_files_from_the_watch_mode_s_processing_6629","Remove a list of files from the watch mode's processing."),Enable_experimental_support_for_legacy_experimental_decorators:C(6630,3,"Enable_experimental_support_for_legacy_experimental_decorators_6630","Enable experimental support for legacy experimental decorators."),Print_files_read_during_the_compilation_including_why_it_was_included:C(6631,3,"Print_files_read_during_the_compilation_including_why_it_was_included_6631","Print files read during the compilation including why it was included."),Output_more_detailed_compiler_performance_information_after_building:C(6632,3,"Output_more_detailed_compiler_performance_information_after_building_6632","Output more detailed compiler performance information after building."),Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_are_inherited:C(6633,3,"Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_a_6633","Specify one or more path or node module references to base configuration files from which settings are inherited."),Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers:C(6634,3,"Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers_6634","Specify what approach the watcher should use if the system runs out of native file watchers."),Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include:C(6635,3,"Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include_6635","Include a list of files. This does not support glob patterns, as opposed to `include`."),Build_all_projects_including_those_that_appear_to_be_up_to_date:C(6636,3,"Build_all_projects_including_those_that_appear_to_be_up_to_date_6636","Build all projects, including those that appear to be up to date."),Ensure_that_casing_is_correct_in_imports:C(6637,3,"Ensure_that_casing_is_correct_in_imports_6637","Ensure that casing is correct in imports."),Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging:C(6638,3,"Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging_6638","Emit a v8 CPU profile of the compiler run for debugging."),Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file:C(6639,3,"Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file_6639","Allow importing helper functions from tslib once per project, instead of including them per-file."),Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation:C(6641,3,"Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation_6641","Specify a list of glob patterns that match files to be included in compilation."),Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects:C(6642,3,"Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects_6642","Save .tsbuildinfo files to allow for incremental compilation of projects."),Include_sourcemap_files_inside_the_emitted_JavaScript:C(6643,3,"Include_sourcemap_files_inside_the_emitted_JavaScript_6643","Include sourcemap files inside the emitted JavaScript."),Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript:C(6644,3,"Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript_6644","Include source code in the sourcemaps inside the emitted JavaScript."),Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports:C(6645,3,"Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports_6645","Ensure that each file can be safely transpiled without relying on other imports."),Specify_what_JSX_code_is_generated:C(6646,3,"Specify_what_JSX_code_is_generated_6646","Specify what JSX code is generated."),Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h:C(6647,3,"Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h_6647","Specify the JSX factory function used when targeting React JSX emit, e.g. 'React.createElement' or 'h'."),Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment:C(6648,3,"Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragme_6648","Specify the JSX Fragment reference used for fragments when targeting React JSX emit e.g. 'React.Fragment' or 'Fragment'."),Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk:C(6649,3,"Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Ast_6649","Specify module specifier used to import the JSX factory functions when using 'jsx: react-jsx*'."),Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option:C(6650,3,"Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option_6650","Make keyof only return strings instead of string, numbers or symbols. Legacy option."),Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment:C(6651,3,"Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment_6651","Specify a set of bundled library declaration files that describe the target runtime environment."),Print_the_names_of_emitted_files_after_a_compilation:C(6652,3,"Print_the_names_of_emitted_files_after_a_compilation_6652","Print the names of emitted files after a compilation."),Print_all_of_the_files_read_during_the_compilation:C(6653,3,"Print_all_of_the_files_read_during_the_compilation_6653","Print all of the files read during the compilation."),Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit:C(6654,3,"Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit_6654","Set the language of the messaging from TypeScript. This does not affect emit."),Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations:C(6655,3,"Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6655","Specify the location where debugger should locate map files instead of generated locations."),Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs:C(6656,3,"Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicabl_6656","Specify the maximum folder depth used for checking JavaScript files from 'node_modules'. Only applicable with 'allowJs'."),Specify_what_module_code_is_generated:C(6657,3,"Specify_what_module_code_is_generated_6657","Specify what module code is generated."),Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier:C(6658,3,"Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier_6658","Specify how TypeScript looks up a file from a given module specifier."),Set_the_newline_character_for_emitting_files:C(6659,3,"Set_the_newline_character_for_emitting_files_6659","Set the newline character for emitting files."),Disable_emitting_files_from_a_compilation:C(6660,3,"Disable_emitting_files_from_a_compilation_6660","Disable emitting files from a compilation."),Disable_generating_custom_helper_functions_like_extends_in_compiled_output:C(6661,3,"Disable_generating_custom_helper_functions_like_extends_in_compiled_output_6661","Disable generating custom helper functions like '__extends' in compiled output."),Disable_emitting_files_if_any_type_checking_errors_are_reported:C(6662,3,"Disable_emitting_files_if_any_type_checking_errors_are_reported_6662","Disable emitting files if any type checking errors are reported."),Disable_truncating_types_in_error_messages:C(6663,3,"Disable_truncating_types_in_error_messages_6663","Disable truncating types in error messages."),Enable_error_reporting_for_fallthrough_cases_in_switch_statements:C(6664,3,"Enable_error_reporting_for_fallthrough_cases_in_switch_statements_6664","Enable error reporting for fallthrough cases in switch statements."),Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type:C(6665,3,"Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type_6665","Enable error reporting for expressions and declarations with an implied 'any' type."),Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier:C(6666,3,"Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier_6666","Ensure overriding members in derived classes are marked with an override modifier."),Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function:C(6667,3,"Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function_6667","Enable error reporting for codepaths that do not explicitly return in a function."),Enable_error_reporting_when_this_is_given_the_type_any:C(6668,3,"Enable_error_reporting_when_this_is_given_the_type_any_6668","Enable error reporting when 'this' is given the type 'any'."),Disable_adding_use_strict_directives_in_emitted_JavaScript_files:C(6669,3,"Disable_adding_use_strict_directives_in_emitted_JavaScript_files_6669","Disable adding 'use strict' directives in emitted JavaScript files."),Disable_including_any_library_files_including_the_default_lib_d_ts:C(6670,3,"Disable_including_any_library_files_including_the_default_lib_d_ts_6670","Disable including any library files, including the default lib.d.ts."),Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type:C(6671,3,"Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type_6671","Enforces using indexed accessors for keys declared using an indexed type."),Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project:C(6672,3,"Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add__6672","Disallow 'import's, 'require's or '<reference>'s from expanding the number of files TypeScript should add to a project."),Disable_strict_checking_of_generic_signatures_in_function_types:C(6673,3,"Disable_strict_checking_of_generic_signatures_in_function_types_6673","Disable strict checking of generic signatures in function types."),Add_undefined_to_a_type_when_accessed_using_an_index:C(6674,3,"Add_undefined_to_a_type_when_accessed_using_an_index_6674","Add 'undefined' to a type when accessed using an index."),Enable_error_reporting_when_local_variables_aren_t_read:C(6675,3,"Enable_error_reporting_when_local_variables_aren_t_read_6675","Enable error reporting when local variables aren't read."),Raise_an_error_when_a_function_parameter_isn_t_read:C(6676,3,"Raise_an_error_when_a_function_parameter_isn_t_read_6676","Raise an error when a function parameter isn't read."),Deprecated_setting_Use_outFile_instead:C(6677,3,"Deprecated_setting_Use_outFile_instead_6677","Deprecated setting. Use 'outFile' instead."),Specify_an_output_folder_for_all_emitted_files:C(6678,3,"Specify_an_output_folder_for_all_emitted_files_6678","Specify an output folder for all emitted files."),Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output:C(6679,3,"Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designa_6679","Specify a file that bundles all outputs into one JavaScript file. If 'declaration' is true, also designates a file that bundles all .d.ts output."),Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations:C(6680,3,"Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations_6680","Specify a set of entries that re-map imports to additional lookup locations."),Specify_a_list_of_language_service_plugins_to_include:C(6681,3,"Specify_a_list_of_language_service_plugins_to_include_6681","Specify a list of language service plugins to include."),Disable_erasing_const_enum_declarations_in_generated_code:C(6682,3,"Disable_erasing_const_enum_declarations_in_generated_code_6682","Disable erasing 'const enum' declarations in generated code."),Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node:C(6683,3,"Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node_6683","Disable resolving symlinks to their realpath. This correlates to the same flag in node."),Disable_wiping_the_console_in_watch_mode:C(6684,3,"Disable_wiping_the_console_in_watch_mode_6684","Disable wiping the console in watch mode."),Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read:C(6685,3,"Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read_6685","Enable color and formatting in TypeScript's output to make compiler errors easier to read."),Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit:C(6686,3,"Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit_6686","Specify the object invoked for 'createElement'. This only applies when targeting 'react' JSX emit."),Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references:C(6687,3,"Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references_6687","Specify an array of objects that specify paths for projects. Used in project references."),Disable_emitting_comments:C(6688,3,"Disable_emitting_comments_6688","Disable emitting comments."),Enable_importing_json_files:C(6689,3,"Enable_importing_json_files_6689","Enable importing .json files."),Specify_the_root_folder_within_your_source_files:C(6690,3,"Specify_the_root_folder_within_your_source_files_6690","Specify the root folder within your source files."),Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules:C(6691,3,"Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules_6691","Allow multiple folders to be treated as one when resolving modules."),Skip_type_checking_d_ts_files_that_are_included_with_TypeScript:C(6692,3,"Skip_type_checking_d_ts_files_that_are_included_with_TypeScript_6692","Skip type checking .d.ts files that are included with TypeScript."),Skip_type_checking_all_d_ts_files:C(6693,3,"Skip_type_checking_all_d_ts_files_6693","Skip type checking all .d.ts files."),Create_source_map_files_for_emitted_JavaScript_files:C(6694,3,"Create_source_map_files_for_emitted_JavaScript_files_6694","Create source map files for emitted JavaScript files."),Specify_the_root_path_for_debuggers_to_find_the_reference_source_code:C(6695,3,"Specify_the_root_path_for_debuggers_to_find_the_reference_source_code_6695","Specify the root path for debuggers to find the reference source code."),Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function:C(6697,3,"Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function_6697","Check that the arguments for 'bind', 'call', and 'apply' methods match the original function."),When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible:C(6698,3,"When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible_6698","When assigning functions, check to ensure parameters and the return values are subtype-compatible."),When_type_checking_take_into_account_null_and_undefined:C(6699,3,"When_type_checking_take_into_account_null_and_undefined_6699","When type checking, take into account 'null' and 'undefined'."),Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor:C(6700,3,"Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor_6700","Check for class properties that are declared but not set in the constructor."),Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments:C(6701,3,"Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments_6701","Disable emitting declarations that have '@internal' in their JSDoc comments."),Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals:C(6702,3,"Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals_6702","Disable reporting of excess property errors during the creation of object literals."),Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures:C(6703,3,"Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures_6703","Suppress 'noImplicitAny' errors when indexing objects that lack index signatures."),Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively:C(6704,3,"Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_supp_6704","Synchronously call callbacks and update the state of directory watchers on platforms that don`t support recursive watching natively."),Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations:C(6705,3,"Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declaratio_6705","Set the JavaScript language version for emitted JavaScript and include compatible library declarations."),Log_paths_used_during_the_moduleResolution_process:C(6706,3,"Log_paths_used_during_the_moduleResolution_process_6706","Log paths used during the 'moduleResolution' process."),Specify_the_path_to_tsbuildinfo_incremental_compilation_file:C(6707,3,"Specify_the_path_to_tsbuildinfo_incremental_compilation_file_6707","Specify the path to .tsbuildinfo incremental compilation file."),Specify_options_for_automatic_acquisition_of_declaration_files:C(6709,3,"Specify_options_for_automatic_acquisition_of_declaration_files_6709","Specify options for automatic acquisition of declaration files."),Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types:C(6710,3,"Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types_6710","Specify multiple folders that act like './node_modules/@types'."),Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file:C(6711,3,"Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file_6711","Specify type package names to be included without being referenced in a source file."),Emit_ECMAScript_standard_compliant_class_fields:C(6712,3,"Emit_ECMAScript_standard_compliant_class_fields_6712","Emit ECMAScript-standard-compliant class fields."),Enable_verbose_logging:C(6713,3,"Enable_verbose_logging_6713","Enable verbose logging."),Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality:C(6714,3,"Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality_6714","Specify how directories are watched on systems that lack recursive file-watching functionality."),Specify_how_the_TypeScript_watch_mode_works:C(6715,3,"Specify_how_the_TypeScript_watch_mode_works_6715","Specify how the TypeScript watch mode works."),Require_undeclared_properties_from_index_signatures_to_use_element_accesses:C(6717,3,"Require_undeclared_properties_from_index_signatures_to_use_element_accesses_6717","Require undeclared properties from index signatures to use element accesses."),Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types:C(6718,3,"Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types_6718","Specify emit/checking behavior for imports that are only used for types."),Default_catch_clause_variables_as_unknown_instead_of_any:C(6803,3,"Default_catch_clause_variables_as_unknown_instead_of_any_6803","Default catch clause variables as 'unknown' instead of 'any'."),Do_not_transform_or_elide_any_imports_or_exports_not_marked_as_type_only_ensuring_they_are_written_in_the_output_file_s_format_based_on_the_module_setting:C(6804,3,"Do_not_transform_or_elide_any_imports_or_exports_not_marked_as_type_only_ensuring_they_are_written_i_6804","Do not transform or elide any imports or exports not marked as type-only, ensuring they are written in the output file's format based on the 'module' setting."),one_of_Colon:C(6900,3,"one_of_Colon_6900","one of:"),one_or_more_Colon:C(6901,3,"one_or_more_Colon_6901","one or more:"),type_Colon:C(6902,3,"type_Colon_6902","type:"),default_Colon:C(6903,3,"default_Colon_6903","default:"),module_system_or_esModuleInterop:C(6904,3,"module_system_or_esModuleInterop_6904",'module === "system" or esModuleInterop'),false_unless_strict_is_set:C(6905,3,"false_unless_strict_is_set_6905","`false`, unless `strict` is set"),false_unless_composite_is_set:C(6906,3,"false_unless_composite_is_set_6906","`false`, unless `composite` is set"),node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified:C(6907,3,"node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified_6907",'`["node_modules", "bower_components", "jspm_packages"]`, plus the value of `outDir` if one is specified.'),if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk:C(6908,3,"if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk_6908",'`[]` if `files` is specified, otherwise `["**/*"]`'),true_if_composite_false_otherwise:C(6909,3,"true_if_composite_false_otherwise_6909","`true` if `composite`, `false` otherwise"),module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node:C(69010,3,"module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node_69010","module === `AMD` or `UMD` or `System` or `ES6`, then `Classic`, Otherwise `Node`"),Computed_from_the_list_of_input_files:C(6911,3,"Computed_from_the_list_of_input_files_6911","Computed from the list of input files"),Platform_specific:C(6912,3,"Platform_specific_6912","Platform specific"),You_can_learn_about_all_of_the_compiler_options_at_0:C(6913,3,"You_can_learn_about_all_of_the_compiler_options_at_0_6913","You can learn about all of the compiler options at {0}"),Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_config_watch_mode_with_Colon:C(6914,3,"Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_conf_6914","Including --watch, -w will start watching the current project for the file changes. Once set, you can config watch mode with:"),Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_trigger_building_composite_projects_which_you_can_learn_more_about_at_0:C(6915,3,"Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_tr_6915","Using --build, -b will make tsc behave more like a build orchestrator than a compiler. This is used to trigger building composite projects which you can learn more about at {0}"),COMMON_COMMANDS:C(6916,3,"COMMON_COMMANDS_6916","COMMON COMMANDS"),ALL_COMPILER_OPTIONS:C(6917,3,"ALL_COMPILER_OPTIONS_6917","ALL COMPILER OPTIONS"),WATCH_OPTIONS:C(6918,3,"WATCH_OPTIONS_6918","WATCH OPTIONS"),BUILD_OPTIONS:C(6919,3,"BUILD_OPTIONS_6919","BUILD OPTIONS"),COMMON_COMPILER_OPTIONS:C(6920,3,"COMMON_COMPILER_OPTIONS_6920","COMMON COMPILER OPTIONS"),COMMAND_LINE_FLAGS:C(6921,3,"COMMAND_LINE_FLAGS_6921","COMMAND LINE FLAGS"),tsc_Colon_The_TypeScript_Compiler:C(6922,3,"tsc_Colon_The_TypeScript_Compiler_6922","tsc: The TypeScript Compiler"),Compiles_the_current_project_tsconfig_json_in_the_working_directory:C(6923,3,"Compiles_the_current_project_tsconfig_json_in_the_working_directory_6923","Compiles the current project (tsconfig.json in the working directory.)"),Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options:C(6924,3,"Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options_6924","Ignoring tsconfig.json, compiles the specified files with default compiler options."),Build_a_composite_project_in_the_working_directory:C(6925,3,"Build_a_composite_project_in_the_working_directory_6925","Build a composite project in the working directory."),Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory:C(6926,3,"Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory_6926","Creates a tsconfig.json with the recommended settings in the working directory."),Compiles_the_TypeScript_project_located_at_the_specified_path:C(6927,3,"Compiles_the_TypeScript_project_located_at_the_specified_path_6927","Compiles the TypeScript project located at the specified path."),An_expanded_version_of_this_information_showing_all_possible_compiler_options:C(6928,3,"An_expanded_version_of_this_information_showing_all_possible_compiler_options_6928","An expanded version of this information, showing all possible compiler options"),Compiles_the_current_project_with_additional_settings:C(6929,3,"Compiles_the_current_project_with_additional_settings_6929","Compiles the current project, with additional settings."),true_for_ES2022_and_above_including_ESNext:C(6930,3,"true_for_ES2022_and_above_including_ESNext_6930","`true` for ES2022 and above, including ESNext."),List_of_file_name_suffixes_to_search_when_resolving_a_module:C(6931,1,"List_of_file_name_suffixes_to_search_when_resolving_a_module_6931","List of file name suffixes to search when resolving a module."),Variable_0_implicitly_has_an_1_type:C(7005,1,"Variable_0_implicitly_has_an_1_type_7005","Variable '{0}' implicitly has an '{1}' type."),Parameter_0_implicitly_has_an_1_type:C(7006,1,"Parameter_0_implicitly_has_an_1_type_7006","Parameter '{0}' implicitly has an '{1}' type."),Member_0_implicitly_has_an_1_type:C(7008,1,"Member_0_implicitly_has_an_1_type_7008","Member '{0}' implicitly has an '{1}' type."),new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type:C(7009,1,"new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009","'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."),_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type:C(7010,1,"_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010","'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."),Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type:C(7011,1,"Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011","Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."),This_overload_implicitly_returns_the_type_0_because_it_lacks_a_return_type_annotation:C(7012,1,"This_overload_implicitly_returns_the_type_0_because_it_lacks_a_return_type_annotation_7012","This overload implicitly returns the type '{0}' because it lacks a return type annotation."),Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type:C(7013,1,"Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013","Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."),Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type:C(7014,1,"Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7014","Function type, which lacks return-type annotation, implicitly has an '{0}' return type."),Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number:C(7015,1,"Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015","Element implicitly has an 'any' type because index expression is not of type 'number'."),Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type:C(7016,1,"Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type_7016","Could not find a declaration file for module '{0}'. '{1}' implicitly has an 'any' type."),Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature:C(7017,1,"Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_7017","Element implicitly has an 'any' type because type '{0}' has no index signature."),Object_literal_s_property_0_implicitly_has_an_1_type:C(7018,1,"Object_literal_s_property_0_implicitly_has_an_1_type_7018","Object literal's property '{0}' implicitly has an '{1}' type."),Rest_parameter_0_implicitly_has_an_any_type:C(7019,1,"Rest_parameter_0_implicitly_has_an_any_type_7019","Rest parameter '{0}' implicitly has an 'any[]' type."),Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type:C(7020,1,"Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020","Call signature, which lacks return-type annotation, implicitly has an 'any' return type."),_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer:C(7022,1,"_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022","'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."),_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions:C(7023,1,"_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023","'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions:C(7024,1,"Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024","Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation:C(7025,1,"Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_retu_7025","Generator implicitly has yield type '{0}' because it does not yield any values. Consider supplying a return type annotation."),JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists:C(7026,1,"JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026","JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists."),Unreachable_code_detected:C(7027,1,"Unreachable_code_detected_7027","Unreachable code detected.",!0),Unused_label:C(7028,1,"Unused_label_7028","Unused label.",!0),Fallthrough_case_in_switch:C(7029,1,"Fallthrough_case_in_switch_7029","Fallthrough case in switch."),Not_all_code_paths_return_a_value:C(7030,1,"Not_all_code_paths_return_a_value_7030","Not all code paths return a value."),Binding_element_0_implicitly_has_an_1_type:C(7031,1,"Binding_element_0_implicitly_has_an_1_type_7031","Binding element '{0}' implicitly has an '{1}' type."),Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation:C(7032,1,"Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation_7032","Property '{0}' implicitly has type 'any', because its set accessor lacks a parameter type annotation."),Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation:C(7033,1,"Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation_7033","Property '{0}' implicitly has type 'any', because its get accessor lacks a return type annotation."),Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined:C(7034,1,"Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined_7034","Variable '{0}' implicitly has type '{1}' in some locations where its type cannot be determined."),Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0:C(7035,1,"Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare__7035","Try `npm i --save-dev @types/{1}` if it exists or add a new declaration (.d.ts) file containing `declare module '{0}';`"),Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0:C(7036,1,"Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0_7036","Dynamic import's specifier must be of type 'string', but here has type '{0}'."),Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports:C(7037,3,"Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for__7037","Enables emit interoperability between CommonJS and ES Modules via creation of namespace objects for all imports. Implies 'allowSyntheticDefaultImports'."),Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead:C(7038,3,"Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cau_7038","Type originates at this import. A namespace-style import cannot be called or constructed, and will cause a failure at runtime. Consider using a default import or import require here instead."),Mapped_object_type_implicitly_has_an_any_template_type:C(7039,1,"Mapped_object_type_implicitly_has_an_any_template_type_7039","Mapped object type implicitly has an 'any' template type."),If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1:C(7040,1,"If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_S_7040","If the '{0}' package actually exposes this module, consider sending a pull request to amend 'https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/{1}'"),The_containing_arrow_function_captures_the_global_value_of_this:C(7041,1,"The_containing_arrow_function_captures_the_global_value_of_this_7041","The containing arrow function captures the global value of 'this'."),Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used:C(7042,1,"Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used_7042","Module '{0}' was resolved to '{1}', but '--resolveJsonModule' is not used."),Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage:C(7043,2,"Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7043","Variable '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage:C(7044,2,"Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7044","Parameter '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage:C(7045,2,"Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7045","Member '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage:C(7046,2,"Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage_7046","Variable '{0}' implicitly has type '{1}' in some locations, but a better type may be inferred from usage."),Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage:C(7047,2,"Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage_7047","Rest parameter '{0}' implicitly has an 'any[]' type, but a better type may be inferred from usage."),Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage:C(7048,2,"Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage_7048","Property '{0}' implicitly has type 'any', but a better type for its get accessor may be inferred from usage."),Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage:C(7049,2,"Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage_7049","Property '{0}' implicitly has type 'any', but a better type for its set accessor may be inferred from usage."),_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage:C(7050,2,"_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage_7050","'{0}' implicitly has an '{1}' return type, but a better type may be inferred from usage."),Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1:C(7051,1,"Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1_7051","Parameter has a name but no type. Did you mean '{0}: {1}'?"),Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1:C(7052,1,"Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1_7052","Element implicitly has an 'any' type because type '{0}' has no index signature. Did you mean to call '{1}'?"),Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1:C(7053,1,"Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1_7053","Element implicitly has an 'any' type because expression of type '{0}' can't be used to index type '{1}'."),No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1:C(7054,1,"No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1_7054","No index signature with a parameter of type '{0}' was found on type '{1}'."),_0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type:C(7055,1,"_0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type_7055","'{0}', which lacks return-type annotation, implicitly has an '{1}' yield type."),The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed:C(7056,1,"The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_ty_7056","The inferred type of this node exceeds the maximum length the compiler will serialize. An explicit type annotation is needed."),yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation:C(7057,1,"yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_t_7057","'yield' expression implicitly results in an 'any' type because its containing generator lacks a return-type annotation."),If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1:C(7058,1,"If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_decl_7058","If the '{0}' package actually exposes this module, try adding a new declaration (.d.ts) file containing `declare module '{1}';`"),This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead:C(7059,1,"This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead_7059","This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead."),This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint:C(7060,1,"This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_cons_7060","This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma or explicit constraint."),A_mapped_type_may_not_declare_properties_or_methods:C(7061,1,"A_mapped_type_may_not_declare_properties_or_methods_7061","A mapped type may not declare properties or methods."),You_cannot_rename_this_element:C(8e3,1,"You_cannot_rename_this_element_8000","You cannot rename this element."),You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library:C(8001,1,"You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001","You cannot rename elements that are defined in the standard TypeScript library."),import_can_only_be_used_in_TypeScript_files:C(8002,1,"import_can_only_be_used_in_TypeScript_files_8002","'import ... =' can only be used in TypeScript files."),export_can_only_be_used_in_TypeScript_files:C(8003,1,"export_can_only_be_used_in_TypeScript_files_8003","'export =' can only be used in TypeScript files."),Type_parameter_declarations_can_only_be_used_in_TypeScript_files:C(8004,1,"Type_parameter_declarations_can_only_be_used_in_TypeScript_files_8004","Type parameter declarations can only be used in TypeScript files."),implements_clauses_can_only_be_used_in_TypeScript_files:C(8005,1,"implements_clauses_can_only_be_used_in_TypeScript_files_8005","'implements' clauses can only be used in TypeScript files."),_0_declarations_can_only_be_used_in_TypeScript_files:C(8006,1,"_0_declarations_can_only_be_used_in_TypeScript_files_8006","'{0}' declarations can only be used in TypeScript files."),Type_aliases_can_only_be_used_in_TypeScript_files:C(8008,1,"Type_aliases_can_only_be_used_in_TypeScript_files_8008","Type aliases can only be used in TypeScript files."),The_0_modifier_can_only_be_used_in_TypeScript_files:C(8009,1,"The_0_modifier_can_only_be_used_in_TypeScript_files_8009","The '{0}' modifier can only be used in TypeScript files."),Type_annotations_can_only_be_used_in_TypeScript_files:C(8010,1,"Type_annotations_can_only_be_used_in_TypeScript_files_8010","Type annotations can only be used in TypeScript files."),Type_arguments_can_only_be_used_in_TypeScript_files:C(8011,1,"Type_arguments_can_only_be_used_in_TypeScript_files_8011","Type arguments can only be used in TypeScript files."),Parameter_modifiers_can_only_be_used_in_TypeScript_files:C(8012,1,"Parameter_modifiers_can_only_be_used_in_TypeScript_files_8012","Parameter modifiers can only be used in TypeScript files."),Non_null_assertions_can_only_be_used_in_TypeScript_files:C(8013,1,"Non_null_assertions_can_only_be_used_in_TypeScript_files_8013","Non-null assertions can only be used in TypeScript files."),Type_assertion_expressions_can_only_be_used_in_TypeScript_files:C(8016,1,"Type_assertion_expressions_can_only_be_used_in_TypeScript_files_8016","Type assertion expressions can only be used in TypeScript files."),Signature_declarations_can_only_be_used_in_TypeScript_files:C(8017,1,"Signature_declarations_can_only_be_used_in_TypeScript_files_8017","Signature declarations can only be used in TypeScript files."),Report_errors_in_js_files:C(8019,3,"Report_errors_in_js_files_8019","Report errors in .js files."),JSDoc_types_can_only_be_used_inside_documentation_comments:C(8020,1,"JSDoc_types_can_only_be_used_inside_documentation_comments_8020","JSDoc types can only be used inside documentation comments."),JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags:C(8021,1,"JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags_8021","JSDoc '@typedef' tag should either have a type annotation or be followed by '@property' or '@member' tags."),JSDoc_0_is_not_attached_to_a_class:C(8022,1,"JSDoc_0_is_not_attached_to_a_class_8022","JSDoc '@{0}' is not attached to a class."),JSDoc_0_1_does_not_match_the_extends_2_clause:C(8023,1,"JSDoc_0_1_does_not_match_the_extends_2_clause_8023","JSDoc '@{0} {1}' does not match the 'extends {2}' clause."),JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name:C(8024,1,"JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_8024","JSDoc '@param' tag has name '{0}', but there is no parameter with that name."),Class_declarations_cannot_have_more_than_one_augments_or_extends_tag:C(8025,1,"Class_declarations_cannot_have_more_than_one_augments_or_extends_tag_8025","Class declarations cannot have more than one '@augments' or '@extends' tag."),Expected_0_type_arguments_provide_these_with_an_extends_tag:C(8026,1,"Expected_0_type_arguments_provide_these_with_an_extends_tag_8026","Expected {0} type arguments; provide these with an '@extends' tag."),Expected_0_1_type_arguments_provide_these_with_an_extends_tag:C(8027,1,"Expected_0_1_type_arguments_provide_these_with_an_extends_tag_8027","Expected {0}-{1} type arguments; provide these with an '@extends' tag."),JSDoc_may_only_appear_in_the_last_parameter_of_a_signature:C(8028,1,"JSDoc_may_only_appear_in_the_last_parameter_of_a_signature_8028","JSDoc '...' may only appear in the last parameter of a signature."),JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type:C(8029,1,"JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_h_8029","JSDoc '@param' tag has name '{0}', but there is no parameter with that name. It would match 'arguments' if it had an array type."),The_type_of_a_function_declaration_must_match_the_function_s_signature:C(8030,1,"The_type_of_a_function_declaration_must_match_the_function_s_signature_8030","The type of a function declaration must match the function's signature."),You_cannot_rename_a_module_via_a_global_import:C(8031,1,"You_cannot_rename_a_module_via_a_global_import_8031","You cannot rename a module via a global import."),Qualified_name_0_is_not_allowed_without_a_leading_param_object_1:C(8032,1,"Qualified_name_0_is_not_allowed_without_a_leading_param_object_1_8032","Qualified name '{0}' is not allowed without a leading '@param {object} {1}'."),A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags:C(8033,1,"A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags_8033","A JSDoc '@typedef' comment may not contain multiple '@type' tags."),The_tag_was_first_specified_here:C(8034,1,"The_tag_was_first_specified_here_8034","The tag was first specified here."),You_cannot_rename_elements_that_are_defined_in_a_node_modules_folder:C(8035,1,"You_cannot_rename_elements_that_are_defined_in_a_node_modules_folder_8035","You cannot rename elements that are defined in a 'node_modules' folder."),You_cannot_rename_elements_that_are_defined_in_another_node_modules_folder:C(8036,1,"You_cannot_rename_elements_that_are_defined_in_another_node_modules_folder_8036","You cannot rename elements that are defined in another 'node_modules' folder."),Type_satisfaction_expressions_can_only_be_used_in_TypeScript_files:C(8037,1,"Type_satisfaction_expressions_can_only_be_used_in_TypeScript_files_8037","Type satisfaction expressions can only be used in TypeScript files."),Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export:C(8038,1,"Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export_8038","Decorators may not appear after 'export' or 'export default' if they also appear before 'export'."),A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag:C(8039,1,"A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag_8039","A JSDoc '@template' tag may not follow a '@typedef', '@callback', or '@overload' tag"),Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit:C(9005,1,"Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_9005","Declaration emit for this file requires using private name '{0}'. An explicit type annotation may unblock declaration emit."),Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit:C(9006,1,"Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotati_9006","Declaration emit for this file requires using private name '{0}' from module '{1}'. An explicit type annotation may unblock declaration emit."),JSX_attributes_must_only_be_assigned_a_non_empty_expression:C(17e3,1,"JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000","JSX attributes must only be assigned a non-empty 'expression'."),JSX_elements_cannot_have_multiple_attributes_with_the_same_name:C(17001,1,"JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001","JSX elements cannot have multiple attributes with the same name."),Expected_corresponding_JSX_closing_tag_for_0:C(17002,1,"Expected_corresponding_JSX_closing_tag_for_0_17002","Expected corresponding JSX closing tag for '{0}'."),Cannot_use_JSX_unless_the_jsx_flag_is_provided:C(17004,1,"Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004","Cannot use JSX unless the '--jsx' flag is provided."),A_constructor_cannot_contain_a_super_call_when_its_class_extends_null:C(17005,1,"A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005","A constructor cannot contain a 'super' call when its class extends 'null'."),An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses:C(17006,1,"An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006","An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses:C(17007,1,"A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007","A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),JSX_element_0_has_no_corresponding_closing_tag:C(17008,1,"JSX_element_0_has_no_corresponding_closing_tag_17008","JSX element '{0}' has no corresponding closing tag."),super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class:C(17009,1,"super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009","'super' must be called before accessing 'this' in the constructor of a derived class."),Unknown_type_acquisition_option_0:C(17010,1,"Unknown_type_acquisition_option_0_17010","Unknown type acquisition option '{0}'."),super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class:C(17011,1,"super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class_17011","'super' must be called before accessing a property of 'super' in the constructor of a derived class."),_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2:C(17012,1,"_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2_17012","'{0}' is not a valid meta-property for keyword '{1}'. Did you mean '{2}'?"),Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor:C(17013,1,"Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constru_17013","Meta-property '{0}' is only allowed in the body of a function declaration, function expression, or constructor."),JSX_fragment_has_no_corresponding_closing_tag:C(17014,1,"JSX_fragment_has_no_corresponding_closing_tag_17014","JSX fragment has no corresponding closing tag."),Expected_corresponding_closing_tag_for_JSX_fragment:C(17015,1,"Expected_corresponding_closing_tag_for_JSX_fragment_17015","Expected corresponding closing tag for JSX fragment."),The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option:C(17016,1,"The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_com_17016","The 'jsxFragmentFactory' compiler option must be provided to use JSX fragments with the 'jsxFactory' compiler option."),An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments:C(17017,1,"An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments_17017","An @jsxFrag pragma is required when using an @jsx pragma with JSX fragments."),Unknown_type_acquisition_option_0_Did_you_mean_1:C(17018,1,"Unknown_type_acquisition_option_0_Did_you_mean_1_17018","Unknown type acquisition option '{0}'. Did you mean '{1}'?"),_0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1:C(17019,1,"_0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1_17019","'{0}' at the end of a type is not valid TypeScript syntax. Did you mean to write '{1}'?"),_0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1:C(17020,1,"_0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1_17020","'{0}' at the start of a type is not valid TypeScript syntax. Did you mean to write '{1}'?"),Unicode_escape_sequence_cannot_appear_here:C(17021,1,"Unicode_escape_sequence_cannot_appear_here_17021","Unicode escape sequence cannot appear here."),Circularity_detected_while_resolving_configuration_Colon_0:C(18e3,1,"Circularity_detected_while_resolving_configuration_Colon_0_18000","Circularity detected while resolving configuration: {0}"),The_files_list_in_config_file_0_is_empty:C(18002,1,"The_files_list_in_config_file_0_is_empty_18002","The 'files' list in config file '{0}' is empty."),No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2:C(18003,1,"No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2_18003","No inputs were found in config file '{0}'. Specified 'include' paths were '{1}' and 'exclude' paths were '{2}'."),File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module:C(80001,2,"File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module_80001","File is a CommonJS module; it may be converted to an ES module."),This_constructor_function_may_be_converted_to_a_class_declaration:C(80002,2,"This_constructor_function_may_be_converted_to_a_class_declaration_80002","This constructor function may be converted to a class declaration."),Import_may_be_converted_to_a_default_import:C(80003,2,"Import_may_be_converted_to_a_default_import_80003","Import may be converted to a default import."),JSDoc_types_may_be_moved_to_TypeScript_types:C(80004,2,"JSDoc_types_may_be_moved_to_TypeScript_types_80004","JSDoc types may be moved to TypeScript types."),require_call_may_be_converted_to_an_import:C(80005,2,"require_call_may_be_converted_to_an_import_80005","'require' call may be converted to an import."),This_may_be_converted_to_an_async_function:C(80006,2,"This_may_be_converted_to_an_async_function_80006","This may be converted to an async function."),await_has_no_effect_on_the_type_of_this_expression:C(80007,2,"await_has_no_effect_on_the_type_of_this_expression_80007","'await' has no effect on the type of this expression."),Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers:C(80008,2,"Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accur_80008","Numeric literals with absolute values equal to 2^53 or greater are too large to be represented accurately as integers."),JSDoc_typedef_may_be_converted_to_TypeScript_type:C(80009,2,"JSDoc_typedef_may_be_converted_to_TypeScript_type_80009","JSDoc typedef may be converted to TypeScript type."),JSDoc_typedefs_may_be_converted_to_TypeScript_types:C(80010,2,"JSDoc_typedefs_may_be_converted_to_TypeScript_types_80010","JSDoc typedefs may be converted to TypeScript types."),Add_missing_super_call:C(90001,3,"Add_missing_super_call_90001","Add missing 'super()' call"),Make_super_call_the_first_statement_in_the_constructor:C(90002,3,"Make_super_call_the_first_statement_in_the_constructor_90002","Make 'super()' call the first statement in the constructor"),Change_extends_to_implements:C(90003,3,"Change_extends_to_implements_90003","Change 'extends' to 'implements'"),Remove_unused_declaration_for_Colon_0:C(90004,3,"Remove_unused_declaration_for_Colon_0_90004","Remove unused declaration for: '{0}'"),Remove_import_from_0:C(90005,3,"Remove_import_from_0_90005","Remove import from '{0}'"),Implement_interface_0:C(90006,3,"Implement_interface_0_90006","Implement interface '{0}'"),Implement_inherited_abstract_class:C(90007,3,"Implement_inherited_abstract_class_90007","Implement inherited abstract class"),Add_0_to_unresolved_variable:C(90008,3,"Add_0_to_unresolved_variable_90008","Add '{0}.' to unresolved variable"),Remove_variable_statement:C(90010,3,"Remove_variable_statement_90010","Remove variable statement"),Remove_template_tag:C(90011,3,"Remove_template_tag_90011","Remove template tag"),Remove_type_parameters:C(90012,3,"Remove_type_parameters_90012","Remove type parameters"),Import_0_from_1:C(90013,3,"Import_0_from_1_90013",`Import '{0}' from "{1}"`),Change_0_to_1:C(90014,3,"Change_0_to_1_90014","Change '{0}' to '{1}'"),Declare_property_0:C(90016,3,"Declare_property_0_90016","Declare property '{0}'"),Add_index_signature_for_property_0:C(90017,3,"Add_index_signature_for_property_0_90017","Add index signature for property '{0}'"),Disable_checking_for_this_file:C(90018,3,"Disable_checking_for_this_file_90018","Disable checking for this file"),Ignore_this_error_message:C(90019,3,"Ignore_this_error_message_90019","Ignore this error message"),Initialize_property_0_in_the_constructor:C(90020,3,"Initialize_property_0_in_the_constructor_90020","Initialize property '{0}' in the constructor"),Initialize_static_property_0:C(90021,3,"Initialize_static_property_0_90021","Initialize static property '{0}'"),Change_spelling_to_0:C(90022,3,"Change_spelling_to_0_90022","Change spelling to '{0}'"),Declare_method_0:C(90023,3,"Declare_method_0_90023","Declare method '{0}'"),Declare_static_method_0:C(90024,3,"Declare_static_method_0_90024","Declare static method '{0}'"),Prefix_0_with_an_underscore:C(90025,3,"Prefix_0_with_an_underscore_90025","Prefix '{0}' with an underscore"),Rewrite_as_the_indexed_access_type_0:C(90026,3,"Rewrite_as_the_indexed_access_type_0_90026","Rewrite as the indexed access type '{0}'"),Declare_static_property_0:C(90027,3,"Declare_static_property_0_90027","Declare static property '{0}'"),Call_decorator_expression:C(90028,3,"Call_decorator_expression_90028","Call decorator expression"),Add_async_modifier_to_containing_function:C(90029,3,"Add_async_modifier_to_containing_function_90029","Add async modifier to containing function"),Replace_infer_0_with_unknown:C(90030,3,"Replace_infer_0_with_unknown_90030","Replace 'infer {0}' with 'unknown'"),Replace_all_unused_infer_with_unknown:C(90031,3,"Replace_all_unused_infer_with_unknown_90031","Replace all unused 'infer' with 'unknown'"),Add_parameter_name:C(90034,3,"Add_parameter_name_90034","Add parameter name"),Declare_private_property_0:C(90035,3,"Declare_private_property_0_90035","Declare private property '{0}'"),Replace_0_with_Promise_1:C(90036,3,"Replace_0_with_Promise_1_90036","Replace '{0}' with 'Promise<{1}>'"),Fix_all_incorrect_return_type_of_an_async_functions:C(90037,3,"Fix_all_incorrect_return_type_of_an_async_functions_90037","Fix all incorrect return type of an async functions"),Declare_private_method_0:C(90038,3,"Declare_private_method_0_90038","Declare private method '{0}'"),Remove_unused_destructuring_declaration:C(90039,3,"Remove_unused_destructuring_declaration_90039","Remove unused destructuring declaration"),Remove_unused_declarations_for_Colon_0:C(90041,3,"Remove_unused_declarations_for_Colon_0_90041","Remove unused declarations for: '{0}'"),Declare_a_private_field_named_0:C(90053,3,"Declare_a_private_field_named_0_90053","Declare a private field named '{0}'."),Includes_imports_of_types_referenced_by_0:C(90054,3,"Includes_imports_of_types_referenced_by_0_90054","Includes imports of types referenced by '{0}'"),Remove_type_from_import_declaration_from_0:C(90055,3,"Remove_type_from_import_declaration_from_0_90055",`Remove 'type' from import declaration from "{0}"`),Remove_type_from_import_of_0_from_1:C(90056,3,"Remove_type_from_import_of_0_from_1_90056",`Remove 'type' from import of '{0}' from "{1}"`),Add_import_from_0:C(90057,3,"Add_import_from_0_90057",'Add import from "{0}"'),Update_import_from_0:C(90058,3,"Update_import_from_0_90058",'Update import from "{0}"'),Export_0_from_module_1:C(90059,3,"Export_0_from_module_1_90059","Export '{0}' from module '{1}'"),Export_all_referenced_locals:C(90060,3,"Export_all_referenced_locals_90060","Export all referenced locals"),Convert_function_to_an_ES2015_class:C(95001,3,"Convert_function_to_an_ES2015_class_95001","Convert function to an ES2015 class"),Convert_0_to_1_in_0:C(95003,3,"Convert_0_to_1_in_0_95003","Convert '{0}' to '{1} in {0}'"),Extract_to_0_in_1:C(95004,3,"Extract_to_0_in_1_95004","Extract to {0} in {1}"),Extract_function:C(95005,3,"Extract_function_95005","Extract function"),Extract_constant:C(95006,3,"Extract_constant_95006","Extract constant"),Extract_to_0_in_enclosing_scope:C(95007,3,"Extract_to_0_in_enclosing_scope_95007","Extract to {0} in enclosing scope"),Extract_to_0_in_1_scope:C(95008,3,"Extract_to_0_in_1_scope_95008","Extract to {0} in {1} scope"),Annotate_with_type_from_JSDoc:C(95009,3,"Annotate_with_type_from_JSDoc_95009","Annotate with type from JSDoc"),Infer_type_of_0_from_usage:C(95011,3,"Infer_type_of_0_from_usage_95011","Infer type of '{0}' from usage"),Infer_parameter_types_from_usage:C(95012,3,"Infer_parameter_types_from_usage_95012","Infer parameter types from usage"),Convert_to_default_import:C(95013,3,"Convert_to_default_import_95013","Convert to default import"),Install_0:C(95014,3,"Install_0_95014","Install '{0}'"),Replace_import_with_0:C(95015,3,"Replace_import_with_0_95015","Replace import with '{0}'."),Use_synthetic_default_member:C(95016,3,"Use_synthetic_default_member_95016","Use synthetic 'default' member."),Convert_to_ES_module:C(95017,3,"Convert_to_ES_module_95017","Convert to ES module"),Add_undefined_type_to_property_0:C(95018,3,"Add_undefined_type_to_property_0_95018","Add 'undefined' type to property '{0}'"),Add_initializer_to_property_0:C(95019,3,"Add_initializer_to_property_0_95019","Add initializer to property '{0}'"),Add_definite_assignment_assertion_to_property_0:C(95020,3,"Add_definite_assignment_assertion_to_property_0_95020","Add definite assignment assertion to property '{0}'"),Convert_all_type_literals_to_mapped_type:C(95021,3,"Convert_all_type_literals_to_mapped_type_95021","Convert all type literals to mapped type"),Add_all_missing_members:C(95022,3,"Add_all_missing_members_95022","Add all missing members"),Infer_all_types_from_usage:C(95023,3,"Infer_all_types_from_usage_95023","Infer all types from usage"),Delete_all_unused_declarations:C(95024,3,"Delete_all_unused_declarations_95024","Delete all unused declarations"),Prefix_all_unused_declarations_with_where_possible:C(95025,3,"Prefix_all_unused_declarations_with_where_possible_95025","Prefix all unused declarations with '_' where possible"),Fix_all_detected_spelling_errors:C(95026,3,"Fix_all_detected_spelling_errors_95026","Fix all detected spelling errors"),Add_initializers_to_all_uninitialized_properties:C(95027,3,"Add_initializers_to_all_uninitialized_properties_95027","Add initializers to all uninitialized properties"),Add_definite_assignment_assertions_to_all_uninitialized_properties:C(95028,3,"Add_definite_assignment_assertions_to_all_uninitialized_properties_95028","Add definite assignment assertions to all uninitialized properties"),Add_undefined_type_to_all_uninitialized_properties:C(95029,3,"Add_undefined_type_to_all_uninitialized_properties_95029","Add undefined type to all uninitialized properties"),Change_all_jsdoc_style_types_to_TypeScript:C(95030,3,"Change_all_jsdoc_style_types_to_TypeScript_95030","Change all jsdoc-style types to TypeScript"),Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types:C(95031,3,"Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types_95031","Change all jsdoc-style types to TypeScript (and add '| undefined' to nullable types)"),Implement_all_unimplemented_interfaces:C(95032,3,"Implement_all_unimplemented_interfaces_95032","Implement all unimplemented interfaces"),Install_all_missing_types_packages:C(95033,3,"Install_all_missing_types_packages_95033","Install all missing types packages"),Rewrite_all_as_indexed_access_types:C(95034,3,"Rewrite_all_as_indexed_access_types_95034","Rewrite all as indexed access types"),Convert_all_to_default_imports:C(95035,3,"Convert_all_to_default_imports_95035","Convert all to default imports"),Make_all_super_calls_the_first_statement_in_their_constructor:C(95036,3,"Make_all_super_calls_the_first_statement_in_their_constructor_95036","Make all 'super()' calls the first statement in their constructor"),Add_qualifier_to_all_unresolved_variables_matching_a_member_name:C(95037,3,"Add_qualifier_to_all_unresolved_variables_matching_a_member_name_95037","Add qualifier to all unresolved variables matching a member name"),Change_all_extended_interfaces_to_implements:C(95038,3,"Change_all_extended_interfaces_to_implements_95038","Change all extended interfaces to 'implements'"),Add_all_missing_super_calls:C(95039,3,"Add_all_missing_super_calls_95039","Add all missing super calls"),Implement_all_inherited_abstract_classes:C(95040,3,"Implement_all_inherited_abstract_classes_95040","Implement all inherited abstract classes"),Add_all_missing_async_modifiers:C(95041,3,"Add_all_missing_async_modifiers_95041","Add all missing 'async' modifiers"),Add_ts_ignore_to_all_error_messages:C(95042,3,"Add_ts_ignore_to_all_error_messages_95042","Add '@ts-ignore' to all error messages"),Annotate_everything_with_types_from_JSDoc:C(95043,3,"Annotate_everything_with_types_from_JSDoc_95043","Annotate everything with types from JSDoc"),Add_to_all_uncalled_decorators:C(95044,3,"Add_to_all_uncalled_decorators_95044","Add '()' to all uncalled decorators"),Convert_all_constructor_functions_to_classes:C(95045,3,"Convert_all_constructor_functions_to_classes_95045","Convert all constructor functions to classes"),Generate_get_and_set_accessors:C(95046,3,"Generate_get_and_set_accessors_95046","Generate 'get' and 'set' accessors"),Convert_require_to_import:C(95047,3,"Convert_require_to_import_95047","Convert 'require' to 'import'"),Convert_all_require_to_import:C(95048,3,"Convert_all_require_to_import_95048","Convert all 'require' to 'import'"),Move_to_a_new_file:C(95049,3,"Move_to_a_new_file_95049","Move to a new file"),Remove_unreachable_code:C(95050,3,"Remove_unreachable_code_95050","Remove unreachable code"),Remove_all_unreachable_code:C(95051,3,"Remove_all_unreachable_code_95051","Remove all unreachable code"),Add_missing_typeof:C(95052,3,"Add_missing_typeof_95052","Add missing 'typeof'"),Remove_unused_label:C(95053,3,"Remove_unused_label_95053","Remove unused label"),Remove_all_unused_labels:C(95054,3,"Remove_all_unused_labels_95054","Remove all unused labels"),Convert_0_to_mapped_object_type:C(95055,3,"Convert_0_to_mapped_object_type_95055","Convert '{0}' to mapped object type"),Convert_namespace_import_to_named_imports:C(95056,3,"Convert_namespace_import_to_named_imports_95056","Convert namespace import to named imports"),Convert_named_imports_to_namespace_import:C(95057,3,"Convert_named_imports_to_namespace_import_95057","Convert named imports to namespace import"),Add_or_remove_braces_in_an_arrow_function:C(95058,3,"Add_or_remove_braces_in_an_arrow_function_95058","Add or remove braces in an arrow function"),Add_braces_to_arrow_function:C(95059,3,"Add_braces_to_arrow_function_95059","Add braces to arrow function"),Remove_braces_from_arrow_function:C(95060,3,"Remove_braces_from_arrow_function_95060","Remove braces from arrow function"),Convert_default_export_to_named_export:C(95061,3,"Convert_default_export_to_named_export_95061","Convert default export to named export"),Convert_named_export_to_default_export:C(95062,3,"Convert_named_export_to_default_export_95062","Convert named export to default export"),Add_missing_enum_member_0:C(95063,3,"Add_missing_enum_member_0_95063","Add missing enum member '{0}'"),Add_all_missing_imports:C(95064,3,"Add_all_missing_imports_95064","Add all missing imports"),Convert_to_async_function:C(95065,3,"Convert_to_async_function_95065","Convert to async function"),Convert_all_to_async_functions:C(95066,3,"Convert_all_to_async_functions_95066","Convert all to async functions"),Add_missing_call_parentheses:C(95067,3,"Add_missing_call_parentheses_95067","Add missing call parentheses"),Add_all_missing_call_parentheses:C(95068,3,"Add_all_missing_call_parentheses_95068","Add all missing call parentheses"),Add_unknown_conversion_for_non_overlapping_types:C(95069,3,"Add_unknown_conversion_for_non_overlapping_types_95069","Add 'unknown' conversion for non-overlapping types"),Add_unknown_to_all_conversions_of_non_overlapping_types:C(95070,3,"Add_unknown_to_all_conversions_of_non_overlapping_types_95070","Add 'unknown' to all conversions of non-overlapping types"),Add_missing_new_operator_to_call:C(95071,3,"Add_missing_new_operator_to_call_95071","Add missing 'new' operator to call"),Add_missing_new_operator_to_all_calls:C(95072,3,"Add_missing_new_operator_to_all_calls_95072","Add missing 'new' operator to all calls"),Add_names_to_all_parameters_without_names:C(95073,3,"Add_names_to_all_parameters_without_names_95073","Add names to all parameters without names"),Enable_the_experimentalDecorators_option_in_your_configuration_file:C(95074,3,"Enable_the_experimentalDecorators_option_in_your_configuration_file_95074","Enable the 'experimentalDecorators' option in your configuration file"),Convert_parameters_to_destructured_object:C(95075,3,"Convert_parameters_to_destructured_object_95075","Convert parameters to destructured object"),Extract_type:C(95077,3,"Extract_type_95077","Extract type"),Extract_to_type_alias:C(95078,3,"Extract_to_type_alias_95078","Extract to type alias"),Extract_to_typedef:C(95079,3,"Extract_to_typedef_95079","Extract to typedef"),Infer_this_type_of_0_from_usage:C(95080,3,"Infer_this_type_of_0_from_usage_95080","Infer 'this' type of '{0}' from usage"),Add_const_to_unresolved_variable:C(95081,3,"Add_const_to_unresolved_variable_95081","Add 'const' to unresolved variable"),Add_const_to_all_unresolved_variables:C(95082,3,"Add_const_to_all_unresolved_variables_95082","Add 'const' to all unresolved variables"),Add_await:C(95083,3,"Add_await_95083","Add 'await'"),Add_await_to_initializer_for_0:C(95084,3,"Add_await_to_initializer_for_0_95084","Add 'await' to initializer for '{0}'"),Fix_all_expressions_possibly_missing_await:C(95085,3,"Fix_all_expressions_possibly_missing_await_95085","Fix all expressions possibly missing 'await'"),Remove_unnecessary_await:C(95086,3,"Remove_unnecessary_await_95086","Remove unnecessary 'await'"),Remove_all_unnecessary_uses_of_await:C(95087,3,"Remove_all_unnecessary_uses_of_await_95087","Remove all unnecessary uses of 'await'"),Enable_the_jsx_flag_in_your_configuration_file:C(95088,3,"Enable_the_jsx_flag_in_your_configuration_file_95088","Enable the '--jsx' flag in your configuration file"),Add_await_to_initializers:C(95089,3,"Add_await_to_initializers_95089","Add 'await' to initializers"),Extract_to_interface:C(95090,3,"Extract_to_interface_95090","Extract to interface"),Convert_to_a_bigint_numeric_literal:C(95091,3,"Convert_to_a_bigint_numeric_literal_95091","Convert to a bigint numeric literal"),Convert_all_to_bigint_numeric_literals:C(95092,3,"Convert_all_to_bigint_numeric_literals_95092","Convert all to bigint numeric literals"),Convert_const_to_let:C(95093,3,"Convert_const_to_let_95093","Convert 'const' to 'let'"),Prefix_with_declare:C(95094,3,"Prefix_with_declare_95094","Prefix with 'declare'"),Prefix_all_incorrect_property_declarations_with_declare:C(95095,3,"Prefix_all_incorrect_property_declarations_with_declare_95095","Prefix all incorrect property declarations with 'declare'"),Convert_to_template_string:C(95096,3,"Convert_to_template_string_95096","Convert to template string"),Add_export_to_make_this_file_into_a_module:C(95097,3,"Add_export_to_make_this_file_into_a_module_95097","Add 'export {}' to make this file into a module"),Set_the_target_option_in_your_configuration_file_to_0:C(95098,3,"Set_the_target_option_in_your_configuration_file_to_0_95098","Set the 'target' option in your configuration file to '{0}'"),Set_the_module_option_in_your_configuration_file_to_0:C(95099,3,"Set_the_module_option_in_your_configuration_file_to_0_95099","Set the 'module' option in your configuration file to '{0}'"),Convert_invalid_character_to_its_html_entity_code:C(95100,3,"Convert_invalid_character_to_its_html_entity_code_95100","Convert invalid character to its html entity code"),Convert_all_invalid_characters_to_HTML_entity_code:C(95101,3,"Convert_all_invalid_characters_to_HTML_entity_code_95101","Convert all invalid characters to HTML entity code"),Convert_all_const_to_let:C(95102,3,"Convert_all_const_to_let_95102","Convert all 'const' to 'let'"),Convert_function_expression_0_to_arrow_function:C(95105,3,"Convert_function_expression_0_to_arrow_function_95105","Convert function expression '{0}' to arrow function"),Convert_function_declaration_0_to_arrow_function:C(95106,3,"Convert_function_declaration_0_to_arrow_function_95106","Convert function declaration '{0}' to arrow function"),Fix_all_implicit_this_errors:C(95107,3,"Fix_all_implicit_this_errors_95107","Fix all implicit-'this' errors"),Wrap_invalid_character_in_an_expression_container:C(95108,3,"Wrap_invalid_character_in_an_expression_container_95108","Wrap invalid character in an expression container"),Wrap_all_invalid_characters_in_an_expression_container:C(95109,3,"Wrap_all_invalid_characters_in_an_expression_container_95109","Wrap all invalid characters in an expression container"),Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file:C(95110,3,"Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file_95110","Visit https://aka.ms/tsconfig to read more about this file"),Add_a_return_statement:C(95111,3,"Add_a_return_statement_95111","Add a return statement"),Remove_braces_from_arrow_function_body:C(95112,3,"Remove_braces_from_arrow_function_body_95112","Remove braces from arrow function body"),Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal:C(95113,3,"Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal_95113","Wrap the following body with parentheses which should be an object literal"),Add_all_missing_return_statement:C(95114,3,"Add_all_missing_return_statement_95114","Add all missing return statement"),Remove_braces_from_all_arrow_function_bodies_with_relevant_issues:C(95115,3,"Remove_braces_from_all_arrow_function_bodies_with_relevant_issues_95115","Remove braces from all arrow function bodies with relevant issues"),Wrap_all_object_literal_with_parentheses:C(95116,3,"Wrap_all_object_literal_with_parentheses_95116","Wrap all object literal with parentheses"),Move_labeled_tuple_element_modifiers_to_labels:C(95117,3,"Move_labeled_tuple_element_modifiers_to_labels_95117","Move labeled tuple element modifiers to labels"),Convert_overload_list_to_single_signature:C(95118,3,"Convert_overload_list_to_single_signature_95118","Convert overload list to single signature"),Generate_get_and_set_accessors_for_all_overriding_properties:C(95119,3,"Generate_get_and_set_accessors_for_all_overriding_properties_95119","Generate 'get' and 'set' accessors for all overriding properties"),Wrap_in_JSX_fragment:C(95120,3,"Wrap_in_JSX_fragment_95120","Wrap in JSX fragment"),Wrap_all_unparented_JSX_in_JSX_fragment:C(95121,3,"Wrap_all_unparented_JSX_in_JSX_fragment_95121","Wrap all unparented JSX in JSX fragment"),Convert_arrow_function_or_function_expression:C(95122,3,"Convert_arrow_function_or_function_expression_95122","Convert arrow function or function expression"),Convert_to_anonymous_function:C(95123,3,"Convert_to_anonymous_function_95123","Convert to anonymous function"),Convert_to_named_function:C(95124,3,"Convert_to_named_function_95124","Convert to named function"),Convert_to_arrow_function:C(95125,3,"Convert_to_arrow_function_95125","Convert to arrow function"),Remove_parentheses:C(95126,3,"Remove_parentheses_95126","Remove parentheses"),Could_not_find_a_containing_arrow_function:C(95127,3,"Could_not_find_a_containing_arrow_function_95127","Could not find a containing arrow function"),Containing_function_is_not_an_arrow_function:C(95128,3,"Containing_function_is_not_an_arrow_function_95128","Containing function is not an arrow function"),Could_not_find_export_statement:C(95129,3,"Could_not_find_export_statement_95129","Could not find export statement"),This_file_already_has_a_default_export:C(95130,3,"This_file_already_has_a_default_export_95130","This file already has a default export"),Could_not_find_import_clause:C(95131,3,"Could_not_find_import_clause_95131","Could not find import clause"),Could_not_find_namespace_import_or_named_imports:C(95132,3,"Could_not_find_namespace_import_or_named_imports_95132","Could not find namespace import or named imports"),Selection_is_not_a_valid_type_node:C(95133,3,"Selection_is_not_a_valid_type_node_95133","Selection is not a valid type node"),No_type_could_be_extracted_from_this_type_node:C(95134,3,"No_type_could_be_extracted_from_this_type_node_95134","No type could be extracted from this type node"),Could_not_find_property_for_which_to_generate_accessor:C(95135,3,"Could_not_find_property_for_which_to_generate_accessor_95135","Could not find property for which to generate accessor"),Name_is_not_valid:C(95136,3,"Name_is_not_valid_95136","Name is not valid"),Can_only_convert_property_with_modifier:C(95137,3,"Can_only_convert_property_with_modifier_95137","Can only convert property with modifier"),Switch_each_misused_0_to_1:C(95138,3,"Switch_each_misused_0_to_1_95138","Switch each misused '{0}' to '{1}'"),Convert_to_optional_chain_expression:C(95139,3,"Convert_to_optional_chain_expression_95139","Convert to optional chain expression"),Could_not_find_convertible_access_expression:C(95140,3,"Could_not_find_convertible_access_expression_95140","Could not find convertible access expression"),Could_not_find_matching_access_expressions:C(95141,3,"Could_not_find_matching_access_expressions_95141","Could not find matching access expressions"),Can_only_convert_logical_AND_access_chains:C(95142,3,"Can_only_convert_logical_AND_access_chains_95142","Can only convert logical AND access chains"),Add_void_to_Promise_resolved_without_a_value:C(95143,3,"Add_void_to_Promise_resolved_without_a_value_95143","Add 'void' to Promise resolved without a value"),Add_void_to_all_Promises_resolved_without_a_value:C(95144,3,"Add_void_to_all_Promises_resolved_without_a_value_95144","Add 'void' to all Promises resolved without a value"),Use_element_access_for_0:C(95145,3,"Use_element_access_for_0_95145","Use element access for '{0}'"),Use_element_access_for_all_undeclared_properties:C(95146,3,"Use_element_access_for_all_undeclared_properties_95146","Use element access for all undeclared properties."),Delete_all_unused_imports:C(95147,3,"Delete_all_unused_imports_95147","Delete all unused imports"),Infer_function_return_type:C(95148,3,"Infer_function_return_type_95148","Infer function return type"),Return_type_must_be_inferred_from_a_function:C(95149,3,"Return_type_must_be_inferred_from_a_function_95149","Return type must be inferred from a function"),Could_not_determine_function_return_type:C(95150,3,"Could_not_determine_function_return_type_95150","Could not determine function return type"),Could_not_convert_to_arrow_function:C(95151,3,"Could_not_convert_to_arrow_function_95151","Could not convert to arrow function"),Could_not_convert_to_named_function:C(95152,3,"Could_not_convert_to_named_function_95152","Could not convert to named function"),Could_not_convert_to_anonymous_function:C(95153,3,"Could_not_convert_to_anonymous_function_95153","Could not convert to anonymous function"),Can_only_convert_string_concatenations_and_string_literals:C(95154,3,"Can_only_convert_string_concatenations_and_string_literals_95154","Can only convert string concatenations and string literals"),Selection_is_not_a_valid_statement_or_statements:C(95155,3,"Selection_is_not_a_valid_statement_or_statements_95155","Selection is not a valid statement or statements"),Add_missing_function_declaration_0:C(95156,3,"Add_missing_function_declaration_0_95156","Add missing function declaration '{0}'"),Add_all_missing_function_declarations:C(95157,3,"Add_all_missing_function_declarations_95157","Add all missing function declarations"),Method_not_implemented:C(95158,3,"Method_not_implemented_95158","Method not implemented."),Function_not_implemented:C(95159,3,"Function_not_implemented_95159","Function not implemented."),Add_override_modifier:C(95160,3,"Add_override_modifier_95160","Add 'override' modifier"),Remove_override_modifier:C(95161,3,"Remove_override_modifier_95161","Remove 'override' modifier"),Add_all_missing_override_modifiers:C(95162,3,"Add_all_missing_override_modifiers_95162","Add all missing 'override' modifiers"),Remove_all_unnecessary_override_modifiers:C(95163,3,"Remove_all_unnecessary_override_modifiers_95163","Remove all unnecessary 'override' modifiers"),Can_only_convert_named_export:C(95164,3,"Can_only_convert_named_export_95164","Can only convert named export"),Add_missing_properties:C(95165,3,"Add_missing_properties_95165","Add missing properties"),Add_all_missing_properties:C(95166,3,"Add_all_missing_properties_95166","Add all missing properties"),Add_missing_attributes:C(95167,3,"Add_missing_attributes_95167","Add missing attributes"),Add_all_missing_attributes:C(95168,3,"Add_all_missing_attributes_95168","Add all missing attributes"),Add_undefined_to_optional_property_type:C(95169,3,"Add_undefined_to_optional_property_type_95169","Add 'undefined' to optional property type"),Convert_named_imports_to_default_import:C(95170,3,"Convert_named_imports_to_default_import_95170","Convert named imports to default import"),Delete_unused_param_tag_0:C(95171,3,"Delete_unused_param_tag_0_95171","Delete unused '@param' tag '{0}'"),Delete_all_unused_param_tags:C(95172,3,"Delete_all_unused_param_tags_95172","Delete all unused '@param' tags"),Rename_param_tag_name_0_to_1:C(95173,3,"Rename_param_tag_name_0_to_1_95173","Rename '@param' tag name '{0}' to '{1}'"),Use_0:C(95174,3,"Use_0_95174","Use `{0}`."),Use_Number_isNaN_in_all_conditions:C(95175,3,"Use_Number_isNaN_in_all_conditions_95175","Use `Number.isNaN` in all conditions."),Convert_typedef_to_TypeScript_type:C(95176,3,"Convert_typedef_to_TypeScript_type_95176","Convert typedef to TypeScript type."),Convert_all_typedef_to_TypeScript_types:C(95177,3,"Convert_all_typedef_to_TypeScript_types_95177","Convert all typedef to TypeScript types."),Move_to_file:C(95178,3,"Move_to_file_95178","Move to file"),Cannot_move_to_file_selected_file_is_invalid:C(95179,3,"Cannot_move_to_file_selected_file_is_invalid_95179","Cannot move to file, selected file is invalid"),Use_import_type:C(95180,3,"Use_import_type_95180","Use 'import type'"),Use_type_0:C(95181,3,"Use_type_0_95181","Use 'type {0}'"),Fix_all_with_type_only_imports:C(95182,3,"Fix_all_with_type_only_imports_95182","Fix all with type-only imports"),Cannot_move_statements_to_the_selected_file:C(95183,3,"Cannot_move_statements_to_the_selected_file_95183","Cannot move statements to the selected file"),Inline_variable:C(95184,3,"Inline_variable_95184","Inline variable"),Could_not_find_variable_to_inline:C(95185,3,"Could_not_find_variable_to_inline_95185","Could not find variable to inline."),Variables_with_multiple_declarations_cannot_be_inlined:C(95186,3,"Variables_with_multiple_declarations_cannot_be_inlined_95186","Variables with multiple declarations cannot be inlined."),Add_missing_comma_for_object_member_completion_0:C(95187,3,"Add_missing_comma_for_object_member_completion_0_95187","Add missing comma for object member completion '{0}'."),Add_missing_parameter_to_0:C(95188,3,"Add_missing_parameter_to_0_95188","Add missing parameter to '{0}'"),Add_missing_parameters_to_0:C(95189,3,"Add_missing_parameters_to_0_95189","Add missing parameters to '{0}'"),Add_all_missing_parameters:C(95190,3,"Add_all_missing_parameters_95190","Add all missing parameters"),Add_optional_parameter_to_0:C(95191,3,"Add_optional_parameter_to_0_95191","Add optional parameter to '{0}'"),Add_optional_parameters_to_0:C(95192,3,"Add_optional_parameters_to_0_95192","Add optional parameters to '{0}'"),Add_all_optional_parameters:C(95193,3,"Add_all_optional_parameters_95193","Add all optional parameters"),No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer:C(18004,1,"No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer_18004","No value exists in scope for the shorthand property '{0}'. Either declare one or provide an initializer."),Classes_may_not_have_a_field_named_constructor:C(18006,1,"Classes_may_not_have_a_field_named_constructor_18006","Classes may not have a field named 'constructor'."),JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array:C(18007,1,"JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array_18007","JSX expressions may not use the comma operator. Did you mean to write an array?"),Private_identifiers_cannot_be_used_as_parameters:C(18009,1,"Private_identifiers_cannot_be_used_as_parameters_18009","Private identifiers cannot be used as parameters."),An_accessibility_modifier_cannot_be_used_with_a_private_identifier:C(18010,1,"An_accessibility_modifier_cannot_be_used_with_a_private_identifier_18010","An accessibility modifier cannot be used with a private identifier."),The_operand_of_a_delete_operator_cannot_be_a_private_identifier:C(18011,1,"The_operand_of_a_delete_operator_cannot_be_a_private_identifier_18011","The operand of a 'delete' operator cannot be a private identifier."),constructor_is_a_reserved_word:C(18012,1,"constructor_is_a_reserved_word_18012","'#constructor' is a reserved word."),Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier:C(18013,1,"Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier_18013","Property '{0}' is not accessible outside class '{1}' because it has a private identifier."),The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling:C(18014,1,"The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_priv_18014","The property '{0}' cannot be accessed on type '{1}' within this class because it is shadowed by another private identifier with the same spelling."),Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2:C(18015,1,"Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2_18015","Property '{0}' in type '{1}' refers to a different member that cannot be accessed from within type '{2}'."),Private_identifiers_are_not_allowed_outside_class_bodies:C(18016,1,"Private_identifiers_are_not_allowed_outside_class_bodies_18016","Private identifiers are not allowed outside class bodies."),The_shadowing_declaration_of_0_is_defined_here:C(18017,1,"The_shadowing_declaration_of_0_is_defined_here_18017","The shadowing declaration of '{0}' is defined here"),The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here:C(18018,1,"The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here_18018","The declaration of '{0}' that you probably intended to use is defined here"),_0_modifier_cannot_be_used_with_a_private_identifier:C(18019,1,"_0_modifier_cannot_be_used_with_a_private_identifier_18019","'{0}' modifier cannot be used with a private identifier."),An_enum_member_cannot_be_named_with_a_private_identifier:C(18024,1,"An_enum_member_cannot_be_named_with_a_private_identifier_18024","An enum member cannot be named with a private identifier."),can_only_be_used_at_the_start_of_a_file:C(18026,1,"can_only_be_used_at_the_start_of_a_file_18026","'#!' can only be used at the start of a file."),Compiler_reserves_name_0_when_emitting_private_identifier_downlevel:C(18027,1,"Compiler_reserves_name_0_when_emitting_private_identifier_downlevel_18027","Compiler reserves name '{0}' when emitting private identifier downlevel."),Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher:C(18028,1,"Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher_18028","Private identifiers are only available when targeting ECMAScript 2015 and higher."),Private_identifiers_are_not_allowed_in_variable_declarations:C(18029,1,"Private_identifiers_are_not_allowed_in_variable_declarations_18029","Private identifiers are not allowed in variable declarations."),An_optional_chain_cannot_contain_private_identifiers:C(18030,1,"An_optional_chain_cannot_contain_private_identifiers_18030","An optional chain cannot contain private identifiers."),The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents:C(18031,1,"The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituent_18031","The intersection '{0}' was reduced to 'never' because property '{1}' has conflicting types in some constituents."),The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some:C(18032,1,"The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_pr_18032","The intersection '{0}' was reduced to 'never' because property '{1}' exists in multiple constituents and is private in some."),Type_0_is_not_assignable_to_type_1_as_required_for_computed_enum_member_values:C(18033,1,"Type_0_is_not_assignable_to_type_1_as_required_for_computed_enum_member_values_18033","Type '{0}' is not assignable to type '{1}' as required for computed enum member values."),Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compiler_option_is_specified_e_g_Fragment:C(18034,3,"Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compi_18034","Specify the JSX fragment factory function to use when targeting 'react' JSX emit with 'jsxFactory' compiler option is specified, e.g. 'Fragment'."),Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name:C(18035,1,"Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name_18035","Invalid value for 'jsxFragmentFactory'. '{0}' is not a valid identifier or qualified-name."),Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator:C(18036,1,"Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_dec_18036","Class decorators can't be used with static private identifier. Consider removing the experimental decorator."),await_expression_cannot_be_used_inside_a_class_static_block:C(18037,1,"await_expression_cannot_be_used_inside_a_class_static_block_18037","'await' expression cannot be used inside a class static block."),for_await_loops_cannot_be_used_inside_a_class_static_block:C(18038,1,"for_await_loops_cannot_be_used_inside_a_class_static_block_18038","'for await' loops cannot be used inside a class static block."),Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block:C(18039,1,"Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block_18039","Invalid use of '{0}'. It cannot be used inside a class static block."),A_return_statement_cannot_be_used_inside_a_class_static_block:C(18041,1,"A_return_statement_cannot_be_used_inside_a_class_static_block_18041","A 'return' statement cannot be used inside a class static block."),_0_is_a_type_and_cannot_be_imported_in_JavaScript_files_Use_1_in_a_JSDoc_type_annotation:C(18042,1,"_0_is_a_type_and_cannot_be_imported_in_JavaScript_files_Use_1_in_a_JSDoc_type_annotation_18042","'{0}' is a type and cannot be imported in JavaScript files. Use '{1}' in a JSDoc type annotation."),Types_cannot_appear_in_export_declarations_in_JavaScript_files:C(18043,1,"Types_cannot_appear_in_export_declarations_in_JavaScript_files_18043","Types cannot appear in export declarations in JavaScript files."),_0_is_automatically_exported_here:C(18044,3,"_0_is_automatically_exported_here_18044","'{0}' is automatically exported here."),Properties_with_the_accessor_modifier_are_only_available_when_targeting_ECMAScript_2015_and_higher:C(18045,1,"Properties_with_the_accessor_modifier_are_only_available_when_targeting_ECMAScript_2015_and_higher_18045","Properties with the 'accessor' modifier are only available when targeting ECMAScript 2015 and higher."),_0_is_of_type_unknown:C(18046,1,"_0_is_of_type_unknown_18046","'{0}' is of type 'unknown'."),_0_is_possibly_null:C(18047,1,"_0_is_possibly_null_18047","'{0}' is possibly 'null'."),_0_is_possibly_undefined:C(18048,1,"_0_is_possibly_undefined_18048","'{0}' is possibly 'undefined'."),_0_is_possibly_null_or_undefined:C(18049,1,"_0_is_possibly_null_or_undefined_18049","'{0}' is possibly 'null' or 'undefined'."),The_value_0_cannot_be_used_here:C(18050,1,"The_value_0_cannot_be_used_here_18050","The value '{0}' cannot be used here."),Compiler_option_0_cannot_be_given_an_empty_string:C(18051,1,"Compiler_option_0_cannot_be_given_an_empty_string_18051","Compiler option '{0}' cannot be given an empty string."),Non_abstract_class_0_does_not_implement_all_abstract_members_of_1:C(18052,1,"Non_abstract_class_0_does_not_implement_all_abstract_members_of_1_18052","Non-abstract class '{0}' does not implement all abstract members of '{1}'"),Its_type_0_is_not_a_valid_JSX_element_type:C(18053,1,"Its_type_0_is_not_a_valid_JSX_element_type_18053","Its type '{0}' is not a valid JSX element type."),await_using_statements_cannot_be_used_inside_a_class_static_block:C(18054,1,"await_using_statements_cannot_be_used_inside_a_class_static_block_18054","'await using' statements cannot be used inside a class static block.")}}});function $_(e){return e>=80}function $fe(e){return e===32||$_(e)}function U3(e,t){if(e<t[0])return!1;let n=0,i=t.length,s;for(;n+1<i;){if(s=n+(i-n)/2,s-=s%2,t[s]<=e&&e<=t[s+1])return!0;e<t[s]?i=s:n=s+2}return!1}function d9(e,t){return t>=2?U3(e,FOe):t===1?U3(e,MOe):U3(e,OOe)}function w0t(e,t){return t>=2?U3(e,jOe):t===1?U3(e,LOe):U3(e,ROe)}function O0t(e){let t=[];return e.forEach((n,i)=>{t[n]=i}),t}function Sa(e){return JOe[e]}function Fb(e){return Yfe.get(e)}function mA(e){let t=[],n=0,i=0;for(;n<e.length;){let s=e.charCodeAt(n);switch(n++,s){case 13:e.charCodeAt(n)===10&&n++;case 10:t.push(i),i=n;break;default:s>127&&I_(s)&&(t.push(i),i=n);break}}return t.push(i),t}function V3(e,t,n,i){return e.getPositionOfLineAndCharacter?e.getPositionOfLineAndCharacter(t,n,i):m9(vy(e),t,n,e.text,i)}function m9(e,t,n,i,s){(t<0||t>=e.length)&&(s?t=t<0?0:t>=e.length?e.length-1:t:I.fail(`Bad line number. Line: ${t}, lineStarts.length: ${e.length} , line map is correct? ${i!==void 0?Am(e,mA(i)):"unknown"}`));let o=e[t]+n;return s?o>e[t+1]?e[t+1]:typeof i=="string"&&o>i.length?i.length:o:(t<e.length-1?I.assert(o<e[t+1]):i!==void 0&&I.assert(o<=i.length),o)}function vy(e){return e.lineMap||(e.lineMap=mA(e.text))}function zP(e,t){let n=Ew(e,t);return{line:n,character:t-e[n]}}function Ew(e,t,n){let i=Bg(e,t,Mo,To,n);return i<0&&(i=~i-1,I.assert(i!==-1,"position cannot precede the beginning of the file")),i}function xw(e,t,n){if(t===n)return 0;let i=vy(e),s=Math.min(t,n),o=s===n,l=o?t:n,p=Ew(i,s),m=Ew(i,l,p);return o?p-m:m-p}function Lo(e,t){return zP(vy(e),t)}function Sy(e){return Vg(e)||I_(e)}function Vg(e){return e===32||e===9||e===11||e===12||e===160||e===133||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function I_(e){return e===10||e===13||e===8232||e===8233}function Cw(e){return e>=48&&e<=57}function DOe(e){return Cw(e)||e>=65&&e<=70||e>=97&&e<=102}function R0t(e){return e<=1114111}function g9(e){return e>=48&&e<=55}function Wfe(e,t){let n=e.charCodeAt(t);switch(n){case 13:case 10:case 9:case 11:case 12:case 32:case 47:case 60:case 124:case 61:case 62:return!0;case 35:return t===0;default:return n>127}}function Wa(e,t,n,i,s){if(_g(t))return t;let o=!1;for(;;){let l=e.charCodeAt(t);switch(l){case 13:e.charCodeAt(t+1)===10&&t++;case 10:if(t++,n)return t;o=!!s;continue;case 9:case 11:case 12:case 32:t++;continue;case 47:if(i)break;if(e.charCodeAt(t+1)===47){for(t+=2;t<e.length&&!I_(e.charCodeAt(t));)t++;o=!1;continue}if(e.charCodeAt(t+1)===42){for(t+=2;t<e.length;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2;break}t++}o=!1;continue}break;case 60:case 124:case 61:case 62:if(Aw(e,t)){t=J3(e,t),o=!1;continue}break;case 35:if(t===0&&$H(e,t)){t=WH(e,t),o=!1;continue}break;case 42:if(o){t++,o=!1;continue}break;default:if(l>127&&Sy(l)){t++;continue}break}return t}}function Aw(e,t){if(I.assert(t>=0),t===0||I_(e.charCodeAt(t-1))){let n=e.charCodeAt(t);if(t+y9<e.length){for(let i=0;i<y9;i++)if(e.charCodeAt(t+i)!==n)return!1;return n===61||e.charCodeAt(t+y9)===32}}return!1}function J3(e,t,n){n&&n(g.Merge_conflict_marker_encountered,t,y9);let i=e.charCodeAt(t),s=e.length;if(i===60||i===62)for(;t<s&&!I_(e.charCodeAt(t));)t++;else for(I.assert(i===124||i===61);t<s;){let o=e.charCodeAt(t);if((o===61||o===62)&&o!==i&&Aw(e,t))break;t++}return t}function $H(e,t){return I.assert(t===0),HH.test(e)}function WH(e,t){let n=HH.exec(e)[0];return t=t+n.length,t}function GH(e,t,n,i,s,o,l){let p,m,S,h,b=!1,A=i,k=l;if(n===0){A=!0;let N=h9(t);N&&(n=N.length)}e:for(;n>=0&&n<t.length;){let N=t.charCodeAt(n);switch(N){case 13:t.charCodeAt(n+1)===10&&n++;case 10:if(n++,i)break e;A=!0,b&&(h=!0);continue;case 9:case 11:case 12:case 32:n++;continue;case 47:let M=t.charCodeAt(n+1),O=!1;if(M===47||M===42){let U=M===47?2:3,H=n;if(n+=2,M===47)for(;n<t.length;){if(I_(t.charCodeAt(n))){O=!0;break}n++}else for(;n<t.length;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2;break}n++}if(A){if(b&&(k=s(p,m,S,h,o,k),!e&&k))return k;p=H,m=n,S=U,h=O,b=!0}continue}break e;default:if(N>127&&Sy(N)){b&&I_(N)&&(h=!0),n++;continue}break e}}return b&&(k=s(p,m,S,h,o,k)),k}function q3(e,t,n,i){return GH(!1,e,t,!1,n,i)}function z3(e,t,n,i){return GH(!1,e,t,!0,n,i)}function Gfe(e,t,n,i,s){return GH(!0,e,t,!1,n,i,s)}function Hfe(e,t,n,i,s){return GH(!0,e,t,!0,n,i,s)}function IOe(e,t,n,i,s,o=[]){return o.push({kind:n,pos:e,end:t,hasTrailingNewLine:i}),o}function T0(e,t){return Gfe(e,t,IOe,void 0,void 0)}function aT(e,t){return Hfe(e,t,IOe,void 0,void 0)}function h9(e){let t=HH.exec(e);if(t)return t[0]}function b0(e,t){return e>=65&&e<=90||e>=97&&e<=122||e===36||e===95||e>127&&d9(e,t)}function oT(e,t,n){return e>=65&&e<=90||e>=97&&e<=122||e>=48&&e<=57||e===36||e===95||(n===1?e===45||e===58:!1)||e>127&&w0t(e,t)}function nd(e,t,n){let i=Iv(e,0);if(!b0(i,t))return!1;for(let s=cT(i);s<e.length;s+=cT(i))if(!oT(i=Iv(e,s),t,n))return!1;return!0}function E1(e,t,n=0,i,s,o,l){var p=i,m,S,h,b,A,k,N,M,O=0,U=0,H=0;zt(p,o,l);var K={getTokenFullStart:()=>h,getStartPos:()=>h,getTokenEnd:()=>m,getTextPos:()=>m,getToken:()=>A,getTokenStart:()=>b,getTokenPos:()=>b,getTokenText:()=>p.substring(b,m),getTokenValue:()=>k,hasUnicodeEscape:()=>(N&1024)!==0,hasExtendedUnicodeEscape:()=>(N&8)!==0,hasPrecedingLineBreak:()=>(N&1)!==0,hasPrecedingJSDocComment:()=>(N&2)!==0,isIdentifier:()=>A===80||A>118,isReservedWord:()=>A>=83&&A<=118,isUnterminated:()=>(N&4)!==0,getCommentDirectives:()=>M,getNumericLiteralFlags:()=>N&25584,getTokenFlags:()=>N,reScanGreaterToken:ke,reScanAsteriskEqualsToken:$e,reScanSlashToken:at,reScanTemplateToken:Ze,reScanTemplateHeadOrNoSubstitutionTemplate:yt,scanJsxIdentifier:nr,scanJsxAttributeValue:tr,reScanJsxAttributeValue:ki,reScanJsxToken:ar,reScanLessThanToken:or,reScanHashToken:Fr,reScanQuestionToken:rn,reScanInvalidIdentifier:Ue,scanJsxToken:Tr,scanJsDocToken:zi,scanJSDocCommentTextToken:xs,scan:Ie,getText:_r,clearCommentDirectives:rt,setText:zt,setScriptTarget:vi,setLanguageVariant:Ni,setScriptKind:us,setJSDocParsingMode:Fs,setOnError:Rr,resetTokenState:Ta,setTextPos:Ta,setInJSDocType:to,tryScan:On,lookAhead:ri,scanRange:un};return I.isDebugging&&Object.defineProperty(K,"__debugShowCurrentPositionInText",{get:()=>{let Nr=K.getText();return Nr.slice(0,K.getTokenFullStart())+"\u2551"+Nr.slice(K.getTokenFullStart())}}),K;function re(Nr,qr=m,We,mt){if(s){let dt=m;m=qr,s(Nr,We||0,mt),m=dt}}function $(){let Nr=m,qr=!1,We=!1,mt="";for(;;){let dt=p.charCodeAt(m);if(dt===95){N|=512,qr?(qr=!1,We=!0,mt+=p.substring(Nr,m)):(N|=16384,re(We?g.Multiple_consecutive_numeric_separators_are_not_permitted:g.Numeric_separators_are_not_allowed_here,m,1)),m++,Nr=m;continue}if(Cw(dt)){qr=!0,We=!1,m++;continue}break}return p.charCodeAt(m-1)===95&&(N|=16384,re(g.Numeric_separators_are_not_allowed_here,m-1,1)),mt+p.substring(Nr,m)}function pe(){let Nr=m,qr;if(p.charCodeAt(m)===48)if(m++,p.charCodeAt(m)===95)N|=16896,re(g.Numeric_separators_are_not_allowed_here,m,1),m--,qr=$();else if(!se())N|=8192,qr=""+ +k;else if(!k)qr="0";else{k=""+parseInt(k,8),N|=32;let _e=A===41,Ve=(_e?"-":"")+"0o"+(+k).toString(8);return _e&&Nr--,re(g.Octal_literals_are_not_allowed_Use_the_syntax_0,Nr,m-Nr,Ve),9}else qr=$();let We,mt;p.charCodeAt(m)===46&&(m++,We=$());let dt=m;if(p.charCodeAt(m)===69||p.charCodeAt(m)===101){m++,N|=16,(p.charCodeAt(m)===43||p.charCodeAt(m)===45)&&m++;let _e=m,Ve=$();Ve?(mt=p.substring(dt,_e)+Ve,dt=m):re(g.Digit_expected)}let Ot;if(N&512?(Ot=qr,We&&(Ot+="."+We),mt&&(Ot+=mt)):Ot=p.substring(Nr,dt),N&8192)return re(g.Decimals_with_leading_zeros_are_not_allowed,Nr,dt-Nr),k=""+ +Ot,9;if(We!==void 0||N&16)return z(Nr,We===void 0&&!!(N&16)),k=""+ +Ot,9;{k=Ot;let _e=Ae();return z(Nr),_e}}function z(Nr,qr){if(!b0(Iv(p,m),e))return;let We=m,{length:mt}=Ee();mt===1&&p[We]==="n"?re(qr?g.A_bigint_literal_cannot_use_exponential_notation:g.A_bigint_literal_must_be_an_integer,Nr,We-Nr+1):(re(g.An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal,We,mt),m=We)}function se(){let Nr=m,qr=!0;for(;Cw(p.charCodeAt(m));)g9(p.charCodeAt(m))||(qr=!1),m++;return k=p.substring(Nr,m),qr}function Se(Nr,qr){let We=Z(Nr,!1,qr);return We?parseInt(We,16):-1}function xe(Nr,qr){return Z(Nr,!0,qr)}function Z(Nr,qr,We){let mt=[],dt=!1,Ot=!1;for(;mt.length<Nr||qr;){let _e=p.charCodeAt(m);if(We&&_e===95){N|=512,dt?(dt=!1,Ot=!0):re(Ot?g.Multiple_consecutive_numeric_separators_are_not_permitted:g.Numeric_separators_are_not_allowed_here,m,1),m++;continue}if(dt=We,_e>=65&&_e<=70)_e+=32;else if(!(_e>=48&&_e<=57||_e>=97&&_e<=102))break;mt.push(_e),m++,Ot=!1}return mt.length<Nr&&(mt=[]),p.charCodeAt(m-1)===95&&re(g.Numeric_separators_are_not_allowed_here,m-1,1),String.fromCharCode(...mt)}function Q(Nr=!1){let qr=p.charCodeAt(m);m++;let We="",mt=m;for(;;){if(m>=S){We+=p.substring(mt,m),N|=4,re(g.Unterminated_string_literal);break}let dt=p.charCodeAt(m);if(dt===qr){We+=p.substring(mt,m),m++;break}if(dt===92&&!Nr){We+=p.substring(mt,m),We+=ye(!0),mt=m;continue}if((dt===10||dt===13)&&!Nr){We+=p.substring(mt,m),N|=4,re(g.Unterminated_string_literal);break}m++}return We}function ce(Nr){let qr=p.charCodeAt(m)===96;m++;let We=m,mt="",dt;for(;;){if(m>=S){mt+=p.substring(We,m),N|=4,re(g.Unterminated_template_literal),dt=qr?15:18;break}let Ot=p.charCodeAt(m);if(Ot===96){mt+=p.substring(We,m),m++,dt=qr?15:18;break}if(Ot===36&&m+1<S&&p.charCodeAt(m+1)===123){mt+=p.substring(We,m),m+=2,dt=qr?16:17;break}if(Ot===92){mt+=p.substring(We,m),mt+=ye(Nr),We=m;continue}if(Ot===13){mt+=p.substring(We,m),m++,m<S&&p.charCodeAt(m)===10&&m++,mt+=`
`,We=m;continue}m++}return I.assert(dt!==void 0),k=mt,dt}function ye(Nr){let qr=m;if(m++,m>=S)return re(g.Unexpected_end_of_text),"";let We=p.charCodeAt(m);switch(m++,We){case 48:if(m>=S||!Cw(p.charCodeAt(m)))return"\0";case 49:case 50:case 51:m<S&&g9(p.charCodeAt(m))&&m++;case 52:case 53:case 54:case 55:if(m<S&&g9(p.charCodeAt(m))&&m++,N|=2048,Nr){let mt=parseInt(p.substring(qr+1,m),8);return re(g.Octal_escape_sequences_are_not_allowed_Use_the_syntax_0,qr,m-qr,"\\x"+mt.toString(16).padStart(2,"0")),String.fromCharCode(mt)}return p.substring(qr,m);case 56:case 57:return N|=2048,Nr?(re(g.Escape_sequence_0_is_not_allowed,qr,m-qr,p.substring(qr,m)),String.fromCharCode(We)):p.substring(qr,m);case 98:return"\b";case 116:return"	";case 110:return`
`;case 118:return"\v";case 102:return"\f";case 114:return"\r";case 39:return"'";case 34:return'"';case 117:if(m<S&&p.charCodeAt(m)===123){m++;let mt=xe(1,!1),dt=mt?parseInt(mt,16):-1;return dt<0?(N|=2048,Nr&&re(g.Hexadecimal_digit_expected),p.substring(qr,m)):R0t(dt)?m>=S?(N|=2048,Nr&&re(g.Unexpected_end_of_text),p.substring(qr,m)):p.charCodeAt(m)!==125?(N|=2048,Nr&&re(g.Unterminated_Unicode_escape_sequence),p.substring(qr,m)):(m++,N|=8,$P(dt)):(N|=2048,Nr&&re(g.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive),p.substring(qr,m))}for(;m<qr+6;m++)if(!(m<S&&DOe(p.charCodeAt(m))))return N|=2048,Nr&&re(g.Hexadecimal_digit_expected),p.substring(qr,m);return N|=1024,String.fromCharCode(parseInt(p.substring(qr+2,m),16));case 120:for(;m<qr+4;m++)if(!(m<S&&DOe(p.charCodeAt(m))))return N|=2048,Nr&&re(g.Hexadecimal_digit_expected),p.substring(qr,m);return N|=4096,String.fromCharCode(parseInt(p.substring(qr+2,m),16));case 13:m<S&&p.charCodeAt(m)===10&&m++;case 10:case 8232:case 8233:return"";default:return String.fromCharCode(We)}}function we(){let Nr=xe(1,!1),qr=Nr?parseInt(Nr,16):-1,We=!1;return qr<0?(re(g.Hexadecimal_digit_expected),We=!0):qr>1114111&&(re(g.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive),We=!0),m>=S?(re(g.Unexpected_end_of_text),We=!0):p.charCodeAt(m)===125?m++:(re(g.Unterminated_Unicode_escape_sequence),We=!0),We?"":$P(qr)}function ve(){if(m+5<S&&p.charCodeAt(m+1)===117){let Nr=m;m+=2;let qr=Se(4,!1);return m=Nr,qr}return-1}function oe(){if(Iv(p,m+1)===117&&Iv(p,m+2)===123){let Nr=m;m+=3;let qr=xe(1,!1),We=qr?parseInt(qr,16):-1;return m=Nr,We}return-1}function Ee(){let Nr="",qr=m;for(;m<S;){let We=Iv(p,m);if(oT(We,e))m+=cT(We);else if(We===92){if(We=oe(),We>=0&&oT(We,e)){m+=3,N|=8,Nr+=we(),qr=m;continue}if(We=ve(),!(We>=0&&oT(We,e)))break;N|=1024,Nr+=p.substring(qr,m),Nr+=$P(We),m+=6,qr=m}else break}return Nr+=p.substring(qr,m),Nr}function Me(){let Nr=k.length;if(Nr>=2&&Nr<=12){let qr=k.charCodeAt(0);if(qr>=97&&qr<=122){let We=wOe.get(k);if(We!==void 0)return A=We}}return A=80}function Ge(Nr){let qr="",We=!1,mt=!1;for(;;){let dt=p.charCodeAt(m);if(dt===95){N|=512,We?(We=!1,mt=!0):re(mt?g.Multiple_consecutive_numeric_separators_are_not_permitted:g.Numeric_separators_are_not_allowed_here,m,1),m++;continue}if(We=!0,!Cw(dt)||dt-48>=Nr)break;qr+=p[m],m++,mt=!1}return p.charCodeAt(m-1)===95&&re(g.Numeric_separators_are_not_allowed_here,m-1,1),qr}function Ae(){return p.charCodeAt(m)===110?(k+="n",N&384&&(k=v6(k)+"n"),m++,10):(k=""+(N&128?parseInt(k.slice(2),2):N&256?parseInt(k.slice(2),8):+k),9)}function Ie(){h=m,N=0;let Nr=!1;for(;;){if(b=m,m>=S)return A=1;let qr=Iv(p,m);if(m===0){if(p.slice(0,256).includes("\uFFFD"))return re(g.File_appears_to_be_binary),m=S,A=8;if(qr===35&&$H(p,m)){if(m=WH(p,m),t)continue;return A=6}}switch(qr){case 10:case 13:if(N|=1,t){m++;continue}else return qr===13&&m+1<S&&p.charCodeAt(m+1)===10?m+=2:m++,A=4;case 9:case 11:case 12:case 32:case 160:case 5760:case 8192:case 8193:case 8194:case 8195:case 8196:case 8197:case 8198:case 8199:case 8200:case 8201:case 8202:case 8203:case 8239:case 8287:case 12288:case 65279:if(t){m++;continue}else{for(;m<S&&Vg(p.charCodeAt(m));)m++;return A=5}case 33:return p.charCodeAt(m+1)===61?p.charCodeAt(m+2)===61?(m+=3,A=38):(m+=2,A=36):(m++,A=54);case 34:case 39:return k=Q(),A=11;case 96:return A=ce(!1);case 37:return p.charCodeAt(m+1)===61?(m+=2,A=70):(m++,A=45);case 38:return p.charCodeAt(m+1)===38?p.charCodeAt(m+2)===61?(m+=3,A=77):(m+=2,A=56):p.charCodeAt(m+1)===61?(m+=2,A=74):(m++,A=51);case 40:return m++,A=21;case 41:return m++,A=22;case 42:if(p.charCodeAt(m+1)===61)return m+=2,A=67;if(p.charCodeAt(m+1)===42)return p.charCodeAt(m+2)===61?(m+=3,A=68):(m+=2,A=43);if(m++,O&&!Nr&&N&1){Nr=!0;continue}return A=42;case 43:return p.charCodeAt(m+1)===43?(m+=2,A=46):p.charCodeAt(m+1)===61?(m+=2,A=65):(m++,A=40);case 44:return m++,A=28;case 45:return p.charCodeAt(m+1)===45?(m+=2,A=47):p.charCodeAt(m+1)===61?(m+=2,A=66):(m++,A=41);case 46:return Cw(p.charCodeAt(m+1))?(pe(),A=9):p.charCodeAt(m+1)===46&&p.charCodeAt(m+2)===46?(m+=3,A=26):(m++,A=25);case 47:if(p.charCodeAt(m+1)===47){for(m+=2;m<S&&!I_(p.charCodeAt(m));)m++;if(M=$t(M,p.slice(b,m),BOe,b),t)continue;return A=2}if(p.charCodeAt(m+1)===42){m+=2;let Ve=p.charCodeAt(m)===42&&p.charCodeAt(m+1)!==47,pt=!1,W=b;for(;m<S;){let st=p.charCodeAt(m);if(st===42&&p.charCodeAt(m+1)===47){m+=2,pt=!0;break}m++,I_(st)&&(W=m,N|=1)}if(Ve&&Re()&&(N|=2),M=$t(M,p.slice(W,m),UOe,W),pt||re(g.Asterisk_Slash_expected),t)continue;return pt||(N|=4),A=3}return p.charCodeAt(m+1)===61?(m+=2,A=69):(m++,A=44);case 48:if(m+2<S&&(p.charCodeAt(m+1)===88||p.charCodeAt(m+1)===120))return m+=2,k=xe(1,!0),k||(re(g.Hexadecimal_digit_expected),k="0"),k="0x"+k,N|=64,A=Ae();if(m+2<S&&(p.charCodeAt(m+1)===66||p.charCodeAt(m+1)===98))return m+=2,k=Ge(2),k||(re(g.Binary_digit_expected),k="0"),k="0b"+k,N|=128,A=Ae();if(m+2<S&&(p.charCodeAt(m+1)===79||p.charCodeAt(m+1)===111))return m+=2,k=Ge(8),k||(re(g.Octal_digit_expected),k="0"),k="0o"+k,N|=256,A=Ae();case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return A=pe();case 58:return m++,A=59;case 59:return m++,A=27;case 60:if(Aw(p,m)){if(m=J3(p,m,re),t)continue;return A=7}return p.charCodeAt(m+1)===60?p.charCodeAt(m+2)===61?(m+=3,A=71):(m+=2,A=48):p.charCodeAt(m+1)===61?(m+=2,A=33):n===1&&p.charCodeAt(m+1)===47&&p.charCodeAt(m+2)!==42?(m+=2,A=31):(m++,A=30);case 61:if(Aw(p,m)){if(m=J3(p,m,re),t)continue;return A=7}return p.charCodeAt(m+1)===61?p.charCodeAt(m+2)===61?(m+=3,A=37):(m+=2,A=35):p.charCodeAt(m+1)===62?(m+=2,A=39):(m++,A=64);case 62:if(Aw(p,m)){if(m=J3(p,m,re),t)continue;return A=7}return m++,A=32;case 63:return p.charCodeAt(m+1)===46&&!Cw(p.charCodeAt(m+2))?(m+=2,A=29):p.charCodeAt(m+1)===63?p.charCodeAt(m+2)===61?(m+=3,A=78):(m+=2,A=61):(m++,A=58);case 91:return m++,A=23;case 93:return m++,A=24;case 94:return p.charCodeAt(m+1)===61?(m+=2,A=79):(m++,A=53);case 123:return m++,A=19;case 124:if(Aw(p,m)){if(m=J3(p,m,re),t)continue;return A=7}return p.charCodeAt(m+1)===124?p.charCodeAt(m+2)===61?(m+=3,A=76):(m+=2,A=57):p.charCodeAt(m+1)===61?(m+=2,A=75):(m++,A=52);case 125:return m++,A=20;case 126:return m++,A=55;case 64:return m++,A=60;case 92:let We=oe();if(We>=0&&b0(We,e))return m+=3,N|=8,k=we()+Ee(),A=Me();let mt=ve();return mt>=0&&b0(mt,e)?(m+=6,N|=1024,k=String.fromCharCode(mt)+Ee(),A=Me()):(re(g.Invalid_character),m++,A=0);case 35:if(m!==0&&p[m+1]==="!")return re(g.can_only_be_used_at_the_start_of_a_file),m++,A=0;let dt=Iv(p,m+1);if(dt===92){m++;let Ve=oe();if(Ve>=0&&b0(Ve,e))return m+=3,N|=8,k="#"+we()+Ee(),A=81;let pt=ve();if(pt>=0&&b0(pt,e))return m+=6,N|=1024,k="#"+String.fromCharCode(pt)+Ee(),A=81;m--}return b0(dt,e)?(m++,kt(dt,e)):(k="#",re(g.Invalid_character,m++,cT(qr))),A=81;default:let Ot=kt(qr,e);if(Ot)return A=Ot;if(Vg(qr)){m+=cT(qr);continue}else if(I_(qr)){N|=1,m+=cT(qr);continue}let _e=cT(qr);return re(g.Invalid_character,m,_e),m+=_e,A=0}}}function Re(){switch(H){case 0:return!0;case 1:return!1}return U!==3&&U!==4?!0:H===3?!1:VOe.test(p.slice(h,m))}function Ue(){I.assert(A===0,"'reScanInvalidIdentifier' should only be called when the current token is 'SyntaxKind.Unknown'."),m=b=h,N=0;let Nr=Iv(p,m),qr=kt(Nr,99);return qr?A=qr:(m+=cT(Nr),A)}function kt(Nr,qr){let We=Nr;if(b0(We,qr)){for(m+=cT(We);m<S&&oT(We=Iv(p,m),qr);)m+=cT(We);return k=p.substring(b,m),We===92&&(k+=Ee()),Me()}}function ke(){if(A===32){if(p.charCodeAt(m)===62)return p.charCodeAt(m+1)===62?p.charCodeAt(m+2)===61?(m+=3,A=73):(m+=2,A=50):p.charCodeAt(m+1)===61?(m+=2,A=72):(m++,A=49);if(p.charCodeAt(m)===61)return m++,A=34}return A}function $e(){return I.assert(A===67,"'reScanAsteriskEqualsToken' should only be called on a '*='"),m=b+1,A=64}function at(){if(A===44||A===69){let Nr=b+1,qr=!1,We=!1;for(;;){if(Nr>=S){N|=4,re(g.Unterminated_regular_expression_literal);break}let mt=p.charCodeAt(Nr);if(I_(mt)){N|=4,re(g.Unterminated_regular_expression_literal);break}if(qr)qr=!1;else if(mt===47&&!We){Nr++;break}else mt===91?We=!0:mt===92?qr=!0:mt===93&&(We=!1);Nr++}for(;Nr<S&&oT(p.charCodeAt(Nr),e);)Nr++;m=Nr,k=p.substring(b,m),A=14}return A}function $t(Nr,qr,We,mt){let dt=St(qr.trimStart(),We);return dt===void 0?Nr:Pr(Nr,{range:{pos:mt,end:m},type:dt})}function St(Nr,qr){let We=qr.exec(Nr);if(We)switch(We[1]){case"ts-expect-error":return 0;case"ts-ignore":return 1}}function Ze(Nr){return m=b,A=ce(!Nr)}function yt(){return m=b,A=ce(!0)}function ar(Nr=!0){return m=b=h,A=Tr(Nr)}function or(){return A===48?(m=b+1,A=30):A}function Fr(){return A===81?(m=b+1,A=63):A}function rn(){return I.assert(A===61,"'reScanQuestionToken' should only be called on a '??'"),m=b+1,A=58}function Tr(Nr=!0){if(h=b=m,m>=S)return A=1;let qr=p.charCodeAt(m);if(qr===60)return p.charCodeAt(m+1)===47?(m+=2,A=31):(m++,A=30);if(qr===123)return m++,A=19;let We=0;for(;m<S&&(qr=p.charCodeAt(m),qr!==123);){if(qr===60){if(Aw(p,m))return m=J3(p,m,re),A=7;break}if(qr===62&&re(g.Unexpected_token_Did_you_mean_or_gt,m,1),qr===125&&re(g.Unexpected_token_Did_you_mean_or_rbrace,m,1),I_(qr)&&We===0)We=-1;else{if(!Nr&&I_(qr)&&We>0)break;Sy(qr)||(We=m)}m++}return k=p.substring(h,m),We===-1?13:12}function nr(){if($_(A)){for(;m<S;){if(p.charCodeAt(m)===45){k+="-",m++;continue}let qr=m;if(k+=Ee(),m===qr)break}return Me()}return A}function tr(){switch(h=m,p.charCodeAt(m)){case 34:case 39:return k=Q(!0),A=11;default:return Ie()}}function ki(){return m=b=h,tr()}function xs(Nr){if(h=b=m,N=0,m>=S)return A=1;for(let qr=p.charCodeAt(m);m<S&&!I_(qr)&&qr!==96;qr=Iv(p,++m))if(!Nr){if(qr===123)break;if(qr===64&&m-1>=0&&Vg(p.charCodeAt(m-1))&&!(m+1<S&&Sy(p.charCodeAt(m+1))))break}return m===b?zi():(k=p.substring(b,m),A=82)}function zi(){if(h=b=m,N=0,m>=S)return A=1;let Nr=Iv(p,m);switch(m+=cT(Nr),Nr){case 9:case 11:case 12:case 32:for(;m<S&&Vg(p.charCodeAt(m));)m++;return A=5;case 64:return A=60;case 13:p.charCodeAt(m)===10&&m++;case 10:return N|=1,A=4;case 42:return A=42;case 123:return A=19;case 125:return A=20;case 91:return A=23;case 93:return A=24;case 60:return A=30;case 62:return A=32;case 61:return A=64;case 44:return A=28;case 46:return A=25;case 96:return A=62;case 35:return A=63;case 92:m--;let qr=oe();if(qr>=0&&b0(qr,e))return m+=3,N|=8,k=we()+Ee(),A=Me();let We=ve();return We>=0&&b0(We,e)?(m+=6,N|=1024,k=String.fromCharCode(We)+Ee(),A=Me()):(m++,A=0)}if(b0(Nr,e)){let qr=Nr;for(;m<S&&oT(qr=Iv(p,m),e)||p.charCodeAt(m)===45;)m+=cT(qr);return k=p.substring(b,m),qr===92&&(k+=Ee()),A=Me()}else return A=0}function Ms(Nr,qr){let We=m,mt=h,dt=b,Ot=A,_e=k,Ve=N,pt=Nr();return(!pt||qr)&&(m=We,h=mt,b=dt,A=Ot,k=_e,N=Ve),pt}function un(Nr,qr,We){let mt=S,dt=m,Ot=h,_e=b,Ve=A,pt=k,W=N,st=M;zt(p,Nr,qr);let Nt=We();return S=mt,m=dt,h=Ot,b=_e,A=Ve,k=pt,N=W,M=st,Nt}function ri(Nr){return Ms(Nr,!0)}function On(Nr){return Ms(Nr,!1)}function _r(){return p}function rt(){M=void 0}function zt(Nr,qr,We){p=Nr||"",S=We===void 0?p.length:qr+We,Ta(qr||0)}function Rr(Nr){s=Nr}function vi(Nr){e=Nr}function Ni(Nr){n=Nr}function us(Nr){U=Nr}function Fs(Nr){H=Nr}function Ta(Nr){I.assert(Nr>=0),m=Nr,h=Nr,b=Nr,A=0,k=void 0,N=0}function to(Nr){O+=Nr?1:-1}}function Iv(e,t){return e.codePointAt(t)}function cT(e){return e>=65536?2:1}function M0t(e){if(I.assert(0<=e&&e<=1114111),e<=65535)return String.fromCharCode(e);let t=Math.floor((e-65536)/1024)+55296,n=(e-65536)%1024+56320;return String.fromCharCode(t,n)}function $P(e){return qOe(e)}var $3,wOe,Yfe,OOe,ROe,MOe,LOe,FOe,jOe,BOe,UOe,VOe,JOe,y9,HH,qOe,L0t=f({"src/compiler/scanner.ts"(){"use strict";fa(),$3={abstract:128,accessor:129,any:133,as:130,asserts:131,assert:132,bigint:163,boolean:136,break:83,case:84,catch:85,class:86,continue:88,const:87,constructor:137,debugger:89,declare:138,default:90,delete:91,do:92,else:93,enum:94,export:95,extends:96,false:97,finally:98,for:99,from:161,function:100,get:139,if:101,implements:119,import:102,in:103,infer:140,instanceof:104,interface:120,intrinsic:141,is:142,keyof:143,let:121,module:144,namespace:145,never:146,new:105,null:106,number:150,object:151,package:122,private:123,protected:124,public:125,override:164,out:147,readonly:148,require:149,global:162,return:107,satisfies:152,set:153,static:126,string:154,super:108,switch:109,symbol:155,this:110,throw:111,true:112,try:113,type:156,typeof:114,undefined:157,unique:158,unknown:159,using:160,var:115,void:116,while:117,with:118,yield:127,async:134,await:135,of:165},wOe=new Map(Object.entries($3)),Yfe=new Map(Object.entries({...$3,"{":19,"}":20,"(":21,")":22,"[":23,"]":24,".":25,"...":26,";":27,",":28,"<":30,">":32,"<=":33,">=":34,"==":35,"!=":36,"===":37,"!==":38,"=>":39,"+":40,"-":41,"**":43,"*":42,"/":44,"%":45,"++":46,"--":47,"<<":48,"</":31,">>":49,">>>":50,"&":51,"|":52,"^":53,"!":54,"~":55,"&&":56,"||":57,"?":58,"??":61,"?.":29,":":59,"=":64,"+=":65,"-=":66,"*=":67,"**=":68,"/=":69,"%=":70,"<<=":71,">>=":72,">>>=":73,"&=":74,"|=":75,"^=":79,"||=":76,"&&=":77,"??=":78,"@":60,"#":63,"`":62})),OOe=[170,170,181,181,186,186,192,214,216,246,248,543,546,563,592,685,688,696,699,705,720,721,736,740,750,750,890,890,902,902,904,906,908,908,910,929,931,974,976,983,986,1011,1024,1153,1164,1220,1223,1224,1227,1228,1232,1269,1272,1273,1329,1366,1369,1369,1377,1415,1488,1514,1520,1522,1569,1594,1600,1610,1649,1747,1749,1749,1765,1766,1786,1788,1808,1808,1810,1836,1920,1957,2309,2361,2365,2365,2384,2384,2392,2401,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2524,2525,2527,2529,2544,2545,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2699,2701,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2784,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2870,2873,2877,2877,2908,2909,2911,2913,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,2997,2999,3001,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3168,3169,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3294,3294,3296,3297,3333,3340,3342,3344,3346,3368,3370,3385,3424,3425,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3805,3840,3840,3904,3911,3913,3946,3976,3979,4096,4129,4131,4135,4137,4138,4176,4181,4256,4293,4304,4342,4352,4441,4447,4514,4520,4601,4608,4614,4616,4678,4680,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4742,4744,4744,4746,4749,4752,4782,4784,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4814,4816,4822,4824,4846,4848,4878,4880,4880,4882,4885,4888,4894,4896,4934,4936,4954,5024,5108,5121,5740,5743,5750,5761,5786,5792,5866,6016,6067,6176,6263,6272,6312,7680,7835,7840,7929,7936,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8319,8319,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8497,8499,8505,8544,8579,12293,12295,12321,12329,12337,12341,12344,12346,12353,12436,12445,12446,12449,12538,12540,12542,12549,12588,12593,12686,12704,12727,13312,19893,19968,40869,40960,42124,44032,55203,63744,64045,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65138,65140,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],ROe=[170,170,181,181,186,186,192,214,216,246,248,543,546,563,592,685,688,696,699,705,720,721,736,740,750,750,768,846,864,866,890,890,902,902,904,906,908,908,910,929,931,974,976,983,986,1011,1024,1153,1155,1158,1164,1220,1223,1224,1227,1228,1232,1269,1272,1273,1329,1366,1369,1369,1377,1415,1425,1441,1443,1465,1467,1469,1471,1471,1473,1474,1476,1476,1488,1514,1520,1522,1569,1594,1600,1621,1632,1641,1648,1747,1749,1756,1759,1768,1770,1773,1776,1788,1808,1836,1840,1866,1920,1968,2305,2307,2309,2361,2364,2381,2384,2388,2392,2403,2406,2415,2433,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2492,2494,2500,2503,2504,2507,2509,2519,2519,2524,2525,2527,2531,2534,2545,2562,2562,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2649,2652,2654,2654,2662,2676,2689,2691,2693,2699,2701,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2784,2790,2799,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2870,2873,2876,2883,2887,2888,2891,2893,2902,2903,2908,2909,2911,2913,2918,2927,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,2997,2999,3001,3006,3010,3014,3016,3018,3021,3031,3031,3047,3055,3073,3075,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3134,3140,3142,3144,3146,3149,3157,3158,3168,3169,3174,3183,3202,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3262,3268,3270,3272,3274,3277,3285,3286,3294,3294,3296,3297,3302,3311,3330,3331,3333,3340,3342,3344,3346,3368,3370,3385,3390,3395,3398,3400,3402,3405,3415,3415,3424,3425,3430,3439,3458,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3769,3771,3773,3776,3780,3782,3782,3784,3789,3792,3801,3804,3805,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3946,3953,3972,3974,3979,3984,3991,3993,4028,4038,4038,4096,4129,4131,4135,4137,4138,4140,4146,4150,4153,4160,4169,4176,4185,4256,4293,4304,4342,4352,4441,4447,4514,4520,4601,4608,4614,4616,4678,4680,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4742,4744,4744,4746,4749,4752,4782,4784,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4814,4816,4822,4824,4846,4848,4878,4880,4880,4882,4885,4888,4894,4896,4934,4936,4954,4969,4977,5024,5108,5121,5740,5743,5750,5761,5786,5792,5866,6016,6099,6112,6121,6160,6169,6176,6263,6272,6313,7680,7835,7840,7929,7936,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8255,8256,8319,8319,8400,8412,8417,8417,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8497,8499,8505,8544,8579,12293,12295,12321,12335,12337,12341,12344,12346,12353,12436,12441,12442,12445,12446,12449,12542,12549,12588,12593,12686,12704,12727,13312,19893,19968,40869,40960,42124,44032,55203,63744,64045,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65056,65059,65075,65076,65101,65103,65136,65138,65140,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65381,65470,65474,65479,65482,65487,65490,65495,65498,65500],MOe=[170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,880,884,886,887,890,893,902,902,904,906,908,908,910,929,931,1013,1015,1153,1162,1319,1329,1366,1369,1369,1377,1415,1488,1514,1520,1522,1568,1610,1646,1647,1649,1747,1749,1749,1765,1766,1774,1775,1786,1788,1791,1791,1808,1808,1810,1839,1869,1957,1969,1969,1994,2026,2036,2037,2042,2042,2048,2069,2074,2074,2084,2084,2088,2088,2112,2136,2208,2208,2210,2220,2308,2361,2365,2365,2384,2384,2392,2401,2417,2423,2425,2431,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2493,2493,2510,2510,2524,2525,2527,2529,2544,2545,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2785,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2877,2877,2908,2909,2911,2913,2929,2929,2947,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3024,3024,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3133,3133,3160,3161,3168,3169,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3261,3261,3294,3294,3296,3297,3313,3314,3333,3340,3342,3344,3346,3386,3389,3389,3406,3406,3424,3425,3450,3455,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3807,3840,3840,3904,3911,3913,3948,3976,3980,4096,4138,4159,4159,4176,4181,4186,4189,4193,4193,4197,4198,4206,4208,4213,4225,4238,4238,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4992,5007,5024,5108,5121,5740,5743,5759,5761,5786,5792,5866,5870,5872,5888,5900,5902,5905,5920,5937,5952,5969,5984,5996,5998,6e3,6016,6067,6103,6103,6108,6108,6176,6263,6272,6312,6314,6314,6320,6389,6400,6428,6480,6509,6512,6516,6528,6571,6593,6599,6656,6678,6688,6740,6823,6823,6917,6963,6981,6987,7043,7072,7086,7087,7098,7141,7168,7203,7245,7247,7258,7293,7401,7404,7406,7409,7413,7414,7424,7615,7680,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8305,8305,8319,8319,8336,8348,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11502,11506,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11648,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11823,11823,12293,12295,12321,12329,12337,12341,12344,12348,12353,12438,12445,12447,12449,12538,12540,12543,12549,12589,12593,12686,12704,12730,12784,12799,13312,19893,19968,40908,40960,42124,42192,42237,42240,42508,42512,42527,42538,42539,42560,42606,42623,42647,42656,42735,42775,42783,42786,42888,42891,42894,42896,42899,42912,42922,43e3,43009,43011,43013,43015,43018,43020,43042,43072,43123,43138,43187,43250,43255,43259,43259,43274,43301,43312,43334,43360,43388,43396,43442,43471,43471,43520,43560,43584,43586,43588,43595,43616,43638,43642,43642,43648,43695,43697,43697,43701,43702,43705,43709,43712,43712,43714,43714,43739,43741,43744,43754,43762,43764,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43968,44002,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],LOe=[170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,768,884,886,887,890,893,902,902,904,906,908,908,910,929,931,1013,1015,1153,1155,1159,1162,1319,1329,1366,1369,1369,1377,1415,1425,1469,1471,1471,1473,1474,1476,1477,1479,1479,1488,1514,1520,1522,1552,1562,1568,1641,1646,1747,1749,1756,1759,1768,1770,1788,1791,1791,1808,1866,1869,1969,1984,2037,2042,2042,2048,2093,2112,2139,2208,2208,2210,2220,2276,2302,2304,2403,2406,2415,2417,2423,2425,2431,2433,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2500,2503,2504,2507,2510,2519,2519,2524,2525,2527,2531,2534,2545,2561,2563,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2641,2641,2649,2652,2654,2654,2662,2677,2689,2691,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2787,2790,2799,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2876,2884,2887,2888,2891,2893,2902,2903,2908,2909,2911,2915,2918,2927,2929,2929,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3006,3010,3014,3016,3018,3021,3024,3024,3031,3031,3046,3055,3073,3075,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3133,3140,3142,3144,3146,3149,3157,3158,3160,3161,3168,3171,3174,3183,3202,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3260,3268,3270,3272,3274,3277,3285,3286,3294,3294,3296,3299,3302,3311,3313,3314,3330,3331,3333,3340,3342,3344,3346,3386,3389,3396,3398,3400,3402,3406,3415,3415,3424,3427,3430,3439,3450,3455,3458,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3769,3771,3773,3776,3780,3782,3782,3784,3789,3792,3801,3804,3807,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3948,3953,3972,3974,3991,3993,4028,4038,4038,4096,4169,4176,4253,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4957,4959,4992,5007,5024,5108,5121,5740,5743,5759,5761,5786,5792,5866,5870,5872,5888,5900,5902,5908,5920,5940,5952,5971,5984,5996,5998,6e3,6002,6003,6016,6099,6103,6103,6108,6109,6112,6121,6155,6157,6160,6169,6176,6263,6272,6314,6320,6389,6400,6428,6432,6443,6448,6459,6470,6509,6512,6516,6528,6571,6576,6601,6608,6617,6656,6683,6688,6750,6752,6780,6783,6793,6800,6809,6823,6823,6912,6987,6992,7001,7019,7027,7040,7155,7168,7223,7232,7241,7245,7293,7376,7378,7380,7414,7424,7654,7676,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8204,8205,8255,8256,8276,8276,8305,8305,8319,8319,8336,8348,8400,8412,8417,8417,8421,8432,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11647,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11744,11775,11823,11823,12293,12295,12321,12335,12337,12341,12344,12348,12353,12438,12441,12442,12445,12447,12449,12538,12540,12543,12549,12589,12593,12686,12704,12730,12784,12799,13312,19893,19968,40908,40960,42124,42192,42237,42240,42508,42512,42539,42560,42607,42612,42621,42623,42647,42655,42737,42775,42783,42786,42888,42891,42894,42896,42899,42912,42922,43e3,43047,43072,43123,43136,43204,43216,43225,43232,43255,43259,43259,43264,43309,43312,43347,43360,43388,43392,43456,43471,43481,43520,43574,43584,43597,43600,43609,43616,43638,43642,43643,43648,43714,43739,43741,43744,43759,43762,43766,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43968,44010,44012,44013,44016,44025,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65024,65039,65056,65062,65075,65076,65101,65103,65136,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],FOe=[65,90,97,122,170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,880,884,886,887,890,893,895,895,902,902,904,906,908,908,910,929,931,1013,1015,1153,1162,1327,1329,1366,1369,1369,1376,1416,1488,1514,1519,1522,1568,1610,1646,1647,1649,1747,1749,1749,1765,1766,1774,1775,1786,1788,1791,1791,1808,1808,1810,1839,1869,1957,1969,1969,1994,2026,2036,2037,2042,2042,2048,2069,2074,2074,2084,2084,2088,2088,2112,2136,2144,2154,2208,2228,2230,2237,2308,2361,2365,2365,2384,2384,2392,2401,2417,2432,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2493,2493,2510,2510,2524,2525,2527,2529,2544,2545,2556,2556,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2785,2809,2809,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2877,2877,2908,2909,2911,2913,2929,2929,2947,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3024,3024,3077,3084,3086,3088,3090,3112,3114,3129,3133,3133,3160,3162,3168,3169,3200,3200,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3261,3261,3294,3294,3296,3297,3313,3314,3333,3340,3342,3344,3346,3386,3389,3389,3406,3406,3412,3414,3423,3425,3450,3455,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3718,3722,3724,3747,3749,3749,3751,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3807,3840,3840,3904,3911,3913,3948,3976,3980,4096,4138,4159,4159,4176,4181,4186,4189,4193,4193,4197,4198,4206,4208,4213,4225,4238,4238,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4992,5007,5024,5109,5112,5117,5121,5740,5743,5759,5761,5786,5792,5866,5870,5880,5888,5900,5902,5905,5920,5937,5952,5969,5984,5996,5998,6e3,6016,6067,6103,6103,6108,6108,6176,6264,6272,6312,6314,6314,6320,6389,6400,6430,6480,6509,6512,6516,6528,6571,6576,6601,6656,6678,6688,6740,6823,6823,6917,6963,6981,6987,7043,7072,7086,7087,7098,7141,7168,7203,7245,7247,7258,7293,7296,7304,7312,7354,7357,7359,7401,7404,7406,7411,7413,7414,7418,7418,7424,7615,7680,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8305,8305,8319,8319,8336,8348,8450,8450,8455,8455,8458,8467,8469,8469,8472,8477,8484,8484,8486,8486,8488,8488,8490,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11502,11506,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11648,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,12293,12295,12321,12329,12337,12341,12344,12348,12353,12438,12443,12447,12449,12538,12540,12543,12549,12591,12593,12686,12704,12730,12784,12799,13312,19893,19968,40943,40960,42124,42192,42237,42240,42508,42512,42527,42538,42539,42560,42606,42623,42653,42656,42735,42775,42783,42786,42888,42891,42943,42946,42950,42999,43009,43011,43013,43015,43018,43020,43042,43072,43123,43138,43187,43250,43255,43259,43259,43261,43262,43274,43301,43312,43334,43360,43388,43396,43442,43471,43471,43488,43492,43494,43503,43514,43518,43520,43560,43584,43586,43588,43595,43616,43638,43642,43642,43646,43695,43697,43697,43701,43702,43705,43709,43712,43712,43714,43714,43739,43741,43744,43754,43762,43764,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43824,43866,43868,43879,43888,44002,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500,65536,65547,65549,65574,65576,65594,65596,65597,65599,65613,65616,65629,65664,65786,65856,65908,66176,66204,66208,66256,66304,66335,66349,66378,66384,66421,66432,66461,66464,66499,66504,66511,66513,66517,66560,66717,66736,66771,66776,66811,66816,66855,66864,66915,67072,67382,67392,67413,67424,67431,67584,67589,67592,67592,67594,67637,67639,67640,67644,67644,67647,67669,67680,67702,67712,67742,67808,67826,67828,67829,67840,67861,67872,67897,67968,68023,68030,68031,68096,68096,68112,68115,68117,68119,68121,68149,68192,68220,68224,68252,68288,68295,68297,68324,68352,68405,68416,68437,68448,68466,68480,68497,68608,68680,68736,68786,68800,68850,68864,68899,69376,69404,69415,69415,69424,69445,69600,69622,69635,69687,69763,69807,69840,69864,69891,69926,69956,69956,69968,70002,70006,70006,70019,70066,70081,70084,70106,70106,70108,70108,70144,70161,70163,70187,70272,70278,70280,70280,70282,70285,70287,70301,70303,70312,70320,70366,70405,70412,70415,70416,70419,70440,70442,70448,70450,70451,70453,70457,70461,70461,70480,70480,70493,70497,70656,70708,70727,70730,70751,70751,70784,70831,70852,70853,70855,70855,71040,71086,71128,71131,71168,71215,71236,71236,71296,71338,71352,71352,71424,71450,71680,71723,71840,71903,71935,71935,72096,72103,72106,72144,72161,72161,72163,72163,72192,72192,72203,72242,72250,72250,72272,72272,72284,72329,72349,72349,72384,72440,72704,72712,72714,72750,72768,72768,72818,72847,72960,72966,72968,72969,72971,73008,73030,73030,73056,73061,73063,73064,73066,73097,73112,73112,73440,73458,73728,74649,74752,74862,74880,75075,77824,78894,82944,83526,92160,92728,92736,92766,92880,92909,92928,92975,92992,92995,93027,93047,93053,93071,93760,93823,93952,94026,94032,94032,94099,94111,94176,94177,94179,94179,94208,100343,100352,101106,110592,110878,110928,110930,110948,110951,110960,111355,113664,113770,113776,113788,113792,113800,113808,113817,119808,119892,119894,119964,119966,119967,119970,119970,119973,119974,119977,119980,119982,119993,119995,119995,119997,120003,120005,120069,120071,120074,120077,120084,120086,120092,120094,120121,120123,120126,120128,120132,120134,120134,120138,120144,120146,120485,120488,120512,120514,120538,120540,120570,120572,120596,120598,120628,120630,120654,120656,120686,120688,120712,120714,120744,120746,120770,120772,120779,123136,123180,123191,123197,123214,123214,123584,123627,124928,125124,125184,125251,125259,125259,126464,126467,126469,126495,126497,126498,126500,126500,126503,126503,126505,126514,126516,126519,126521,126521,126523,126523,126530,126530,126535,126535,126537,126537,126539,126539,126541,126543,126545,126546,126548,126548,126551,126551,126553,126553,126555,126555,126557,126557,126559,126559,126561,126562,126564,126564,126567,126570,126572,126578,126580,126583,126585,126588,126590,126590,126592,126601,126603,126619,126625,126627,126629,126633,126635,126651,131072,173782,173824,177972,177984,178205,178208,183969,183984,191456,194560,195101],jOe=[48,57,65,90,95,95,97,122,170,170,181,181,183,183,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,768,884,886,887,890,893,895,895,902,906,908,908,910,929,931,1013,1015,1153,1155,1159,1162,1327,1329,1366,1369,1369,1376,1416,1425,1469,1471,1471,1473,1474,1476,1477,1479,1479,1488,1514,1519,1522,1552,1562,1568,1641,1646,1747,1749,1756,1759,1768,1770,1788,1791,1791,1808,1866,1869,1969,1984,2037,2042,2042,2045,2045,2048,2093,2112,2139,2144,2154,2208,2228,2230,2237,2259,2273,2275,2403,2406,2415,2417,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2500,2503,2504,2507,2510,2519,2519,2524,2525,2527,2531,2534,2545,2556,2556,2558,2558,2561,2563,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2641,2641,2649,2652,2654,2654,2662,2677,2689,2691,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2787,2790,2799,2809,2815,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2876,2884,2887,2888,2891,2893,2902,2903,2908,2909,2911,2915,2918,2927,2929,2929,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3006,3010,3014,3016,3018,3021,3024,3024,3031,3031,3046,3055,3072,3084,3086,3088,3090,3112,3114,3129,3133,3140,3142,3144,3146,3149,3157,3158,3160,3162,3168,3171,3174,3183,3200,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3260,3268,3270,3272,3274,3277,3285,3286,3294,3294,3296,3299,3302,3311,3313,3314,3328,3331,3333,3340,3342,3344,3346,3396,3398,3400,3402,3406,3412,3415,3423,3427,3430,3439,3450,3455,3458,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3558,3567,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3718,3722,3724,3747,3749,3749,3751,3773,3776,3780,3782,3782,3784,3789,3792,3801,3804,3807,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3948,3953,3972,3974,3991,3993,4028,4038,4038,4096,4169,4176,4253,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4957,4959,4969,4977,4992,5007,5024,5109,5112,5117,5121,5740,5743,5759,5761,5786,5792,5866,5870,5880,5888,5900,5902,5908,5920,5940,5952,5971,5984,5996,5998,6e3,6002,6003,6016,6099,6103,6103,6108,6109,6112,6121,6155,6157,6160,6169,6176,6264,6272,6314,6320,6389,6400,6430,6432,6443,6448,6459,6470,6509,6512,6516,6528,6571,6576,6601,6608,6618,6656,6683,6688,6750,6752,6780,6783,6793,6800,6809,6823,6823,6832,6845,6912,6987,6992,7001,7019,7027,7040,7155,7168,7223,7232,7241,7245,7293,7296,7304,7312,7354,7357,7359,7376,7378,7380,7418,7424,7673,7675,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8255,8256,8276,8276,8305,8305,8319,8319,8336,8348,8400,8412,8417,8417,8421,8432,8450,8450,8455,8455,8458,8467,8469,8469,8472,8477,8484,8484,8486,8486,8488,8488,8490,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11647,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11744,11775,12293,12295,12321,12335,12337,12341,12344,12348,12353,12438,12441,12447,12449,12538,12540,12543,12549,12591,12593,12686,12704,12730,12784,12799,13312,19893,19968,40943,40960,42124,42192,42237,42240,42508,42512,42539,42560,42607,42612,42621,42623,42737,42775,42783,42786,42888,42891,42943,42946,42950,42999,43047,43072,43123,43136,43205,43216,43225,43232,43255,43259,43259,43261,43309,43312,43347,43360,43388,43392,43456,43471,43481,43488,43518,43520,43574,43584,43597,43600,43609,43616,43638,43642,43714,43739,43741,43744,43759,43762,43766,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43824,43866,43868,43879,43888,44010,44012,44013,44016,44025,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65024,65039,65056,65071,65075,65076,65101,65103,65136,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500,65536,65547,65549,65574,65576,65594,65596,65597,65599,65613,65616,65629,65664,65786,65856,65908,66045,66045,66176,66204,66208,66256,66272,66272,66304,66335,66349,66378,66384,66426,66432,66461,66464,66499,66504,66511,66513,66517,66560,66717,66720,66729,66736,66771,66776,66811,66816,66855,66864,66915,67072,67382,67392,67413,67424,67431,67584,67589,67592,67592,67594,67637,67639,67640,67644,67644,67647,67669,67680,67702,67712,67742,67808,67826,67828,67829,67840,67861,67872,67897,67968,68023,68030,68031,68096,68099,68101,68102,68108,68115,68117,68119,68121,68149,68152,68154,68159,68159,68192,68220,68224,68252,68288,68295,68297,68326,68352,68405,68416,68437,68448,68466,68480,68497,68608,68680,68736,68786,68800,68850,68864,68903,68912,68921,69376,69404,69415,69415,69424,69456,69600,69622,69632,69702,69734,69743,69759,69818,69840,69864,69872,69881,69888,69940,69942,69951,69956,69958,69968,70003,70006,70006,70016,70084,70089,70092,70096,70106,70108,70108,70144,70161,70163,70199,70206,70206,70272,70278,70280,70280,70282,70285,70287,70301,70303,70312,70320,70378,70384,70393,70400,70403,70405,70412,70415,70416,70419,70440,70442,70448,70450,70451,70453,70457,70459,70468,70471,70472,70475,70477,70480,70480,70487,70487,70493,70499,70502,70508,70512,70516,70656,70730,70736,70745,70750,70751,70784,70853,70855,70855,70864,70873,71040,71093,71096,71104,71128,71133,71168,71232,71236,71236,71248,71257,71296,71352,71360,71369,71424,71450,71453,71467,71472,71481,71680,71738,71840,71913,71935,71935,72096,72103,72106,72151,72154,72161,72163,72164,72192,72254,72263,72263,72272,72345,72349,72349,72384,72440,72704,72712,72714,72758,72760,72768,72784,72793,72818,72847,72850,72871,72873,72886,72960,72966,72968,72969,72971,73014,73018,73018,73020,73021,73023,73031,73040,73049,73056,73061,73063,73064,73066,73102,73104,73105,73107,73112,73120,73129,73440,73462,73728,74649,74752,74862,74880,75075,77824,78894,82944,83526,92160,92728,92736,92766,92768,92777,92880,92909,92912,92916,92928,92982,92992,92995,93008,93017,93027,93047,93053,93071,93760,93823,93952,94026,94031,94087,94095,94111,94176,94177,94179,94179,94208,100343,100352,101106,110592,110878,110928,110930,110948,110951,110960,111355,113664,113770,113776,113788,113792,113800,113808,113817,113821,113822,119141,119145,119149,119154,119163,119170,119173,119179,119210,119213,119362,119364,119808,119892,119894,119964,119966,119967,119970,119970,119973,119974,119977,119980,119982,119993,119995,119995,119997,120003,120005,120069,120071,120074,120077,120084,120086,120092,120094,120121,120123,120126,120128,120132,120134,120134,120138,120144,120146,120485,120488,120512,120514,120538,120540,120570,120572,120596,120598,120628,120630,120654,120656,120686,120688,120712,120714,120744,120746,120770,120772,120779,120782,120831,121344,121398,121403,121452,121461,121461,121476,121476,121499,121503,121505,121519,122880,122886,122888,122904,122907,122913,122915,122916,122918,122922,123136,123180,123184,123197,123200,123209,123214,123214,123584,123641,124928,125124,125136,125142,125184,125259,125264,125273,126464,126467,126469,126495,126497,126498,126500,126500,126503,126503,126505,126514,126516,126519,126521,126521,126523,126523,126530,126530,126535,126535,126537,126537,126539,126539,126541,126543,126545,126546,126548,126548,126551,126551,126553,126553,126555,126555,126557,126557,126559,126559,126561,126562,126564,126564,126567,126570,126572,126578,126580,126583,126585,126588,126590,126590,126592,126601,126603,126619,126625,126627,126629,126633,126635,126651,131072,173782,173824,177972,177984,178205,178208,183969,183984,191456,194560,195101,917760,917999],BOe=/^\/\/\/?\s*@(ts-expect-error|ts-ignore)/,UOe=/^(?:\/|\*)*\s*@(ts-expect-error|ts-ignore)/,VOe=/@(?:see|link)/i,JOe=O0t(Yfe),y9=7,HH=/^#!.*/,qOe=String.fromCodePoint?e=>String.fromCodePoint(e):M0t}});function Nu(e){return Fp(e)||ap(e)}function WP(e){return rT(e,p6)}function W3(e){switch(ho(e)){case 99:return"lib.esnext.full.d.ts";case 9:return"lib.es2022.full.d.ts";case 8:return"lib.es2021.full.d.ts";case 7:return"lib.es2020.full.d.ts";case 6:return"lib.es2019.full.d.ts";case 5:return"lib.es2018.full.d.ts";case 4:return"lib.es2017.full.d.ts";case 3:return"lib.es2016.full.d.ts";case 2:return"lib.es6.d.ts";default:return"lib.d.ts"}}function gl(e){return e.start+e.length}function Xfe(e){return e.length===0}function YH(e,t){return t>=e.start&&t<gl(e)}function G3(e,t){return t>=e.pos&&t<=e.end}function Kfe(e,t){return t.start>=e.start&&gl(t)<=gl(e)}function zOe(e,t){return Qfe(e,t)!==void 0}function Qfe(e,t){let n=epe(e,t);return n&&n.length===0?void 0:n}function $Oe(e,t){return H3(e.start,e.length,t.start,t.length)}function v9(e,t,n){return H3(e.start,e.length,t,n)}function H3(e,t,n,i){let s=e+t,o=n+i;return n<=s&&o>=e}function Zfe(e,t){return t<=gl(e)&&t>=e.start}function epe(e,t){let n=Math.max(e.start,t.start),i=Math.min(gl(e),gl(t));return n<=i?Ll(n,i):void 0}function e_(e,t){if(e<0)throw new Error("start < 0");if(t<0)throw new Error("length < 0");return{start:e,length:t}}function Ll(e,t){return e_(e,t-e)}function kw(e){return e_(e.span.start,e.newLength)}function tpe(e){return Xfe(e.span)&&e.newLength===0}function Y3(e,t){if(t<0)throw new Error("newLength < 0");return{span:e,newLength:t}}function rpe(e){if(e.length===0)return _8;if(e.length===1)return e[0];let t=e[0],n=t.span.start,i=gl(t.span),s=n+t.newLength;for(let o=1;o<e.length;o++){let l=e[o],p=n,m=i,S=s,h=l.span.start,b=gl(l.span),A=h+l.newLength;n=Math.min(p,h),i=Math.max(m,m+(b-S)),s=Math.max(A,A+(S-b))}return Y3(Ll(n,i),s-n)}function WOe(e){if(e&&e.kind===168){for(let t=e;t;t=t.parent)if(ca(t)||Ti(t)||t.kind===264)return t}}function op(e,t){return Ls(e)&&ui(e,31)&&t.kind===176}function npe(e){return la(e)?yr(e.elements,ipe):!1}function ipe(e){return Su(e)?!0:npe(e.name)}function GP(e){let t=e.parent;for(;co(t.parent);)t=t.parent.parent;return t.parent}function spe(e,t){co(e)&&(e=GP(e));let n=t(e);return e.kind===260&&(e=e.parent),e&&e.kind===261&&(n|=t(e),e=e.parent),e&&e.kind===243&&(n|=t(e)),n}function lT(e){return spe(e,X_)}function XH(e){return spe(e,Zde)}function x1(e){return spe(e,F0t)}function F0t(e){return e.flags}function GOe(e,t,n){let i=e.toLowerCase(),s=/^([a-z]+)([_-]([a-z]+))?$/.exec(i);if(!s){n&&n.push(fl(g.Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1,"en","ja-jp"));return}let o=s[1],l=s[3];hs(SY,i)&&!p(o,l,n)&&p(o,void 0,n),A3(e);function p(m,S,h){let b=Ca(t.getExecutingFilePath()),A=hi(b),k=li(A,m);if(S&&(k=k+"-"+S),k=t.resolvePath(li(k,"diagnosticMessages.generated.json")),!t.fileExists(k))return!1;let N="";try{N=t.readFile(k)}catch{return h&&h.push(fl(g.Unable_to_open_file_0,k)),!1}try{Sme(JSON.parse(N))}catch{return h&&h.push(fl(g.Corrupted_locale_file_0,k)),!1}return!0}}function Hc(e,t){if(e)for(;e.original!==void 0;)e=e.original;return!e||!t||t(e)?e:void 0}function Gr(e,t){for(;e;){let n=t(e);if(n==="quit")return;if(n)return e;e=e.parent}}function Pw(e){return(e.flags&16)===0}function Us(e,t){if(e===void 0||Pw(e))return e;for(e=e.original;e;){if(Pw(e))return!t||t(e)?e:void 0;e=e.original}}function Pc(e){return e.length>=2&&e.charCodeAt(0)===95&&e.charCodeAt(1)===95?"_"+e:e}function Zi(e){let t=e;return t.length>=3&&t.charCodeAt(0)===95&&t.charCodeAt(1)===95&&t.charCodeAt(2)===95?t.substr(1):t}function Nn(e){return Zi(e.escapedText)}function uT(e){let t=Fb(e.escapedText);return t?ii(t,Nf):void 0}function Lc(e){return e.valueDeclaration&&G_(e.valueDeclaration)?Nn(e.valueDeclaration.name):Zi(e.escapedName)}function HOe(e){let t=e.parent.parent;if(t){if(O_(t))return KH(t);switch(t.kind){case 243:if(t.declarationList&&t.declarationList.declarations[0])return KH(t.declarationList.declarations[0]);break;case 244:let n=t.expression;switch(n.kind===226&&n.operatorToken.kind===64&&(n=n.left),n.kind){case 211:return n.name;case 212:let i=n.argumentExpression;if(ze(i))return i}break;case 217:return KH(t.expression);case 256:{if(O_(t.statement)||bt(t.statement))return KH(t.statement);break}}}}function KH(e){let t=qs(e);return t&&ze(t)?t:void 0}function X3(e,t){return!!(W_(e)&&ze(e.name)&&Nn(e.name)===Nn(t)||Xc(e)&&Tt(e.declarationList.declarations,n=>X3(n,t)))}function ape(e){return e.name||HOe(e)}function W_(e){return!!e.name}function S9(e){switch(e.kind){case 80:return e;case 355:case 348:{let{name:n}=e;if(n.kind===166)return n.right;break}case 213:case 226:{let n=e;switch(al(n)){case 1:case 4:case 5:case 3:return gj(n.left);case 7:case 8:case 9:return n.arguments[1];default:return}}case 353:return ape(e);case 347:return HOe(e);case 277:{let{expression:n}=e;return ze(n)?n:void 0}case 212:let t=e;if(mj(t))return t.argumentExpression}return e.name}function qs(e){if(e!==void 0)return S9(e)||(Xo(e)||rc(e)||wu(e)?T9(e):void 0)}function T9(e){if(e.parent){if(Ul(e.parent)||co(e.parent))return e.parent.name;if(bn(e.parent)&&e===e.parent.right){if(ze(e.parent.left))return e.parent.left;if(Yo(e.parent.left))return gj(e.parent.left)}else if(Gi(e.parent)&&ze(e.parent.name))return e.parent.name}else return}function wv(e){if(Ad(e))return Fn(e.modifiers,n_)}function jb(e){if(ui(e,98303))return Fn(e.modifiers,Ra)}function YOe(e,t){if(e.name)if(ze(e.name)){let n=e.name.escapedText;return Q3(e.parent,t).filter(i=>mg(i)&&ze(i.name)&&i.name.escapedText===n)}else{let n=e.parent.parameters.indexOf(e);I.assert(n>-1,"Parameters should always be in their parents' parameter list");let i=Q3(e.parent,t).filter(mg);if(n<i.length)return[i[n]]}return tt}function HP(e){return YOe(e,!1)}function ope(e){return YOe(e,!0)}function XOe(e,t){let n=e.name.escapedText;return Q3(e.parent,t).filter(i=>dm(i)&&i.typeParameters.some(s=>s.name.escapedText===n))}function cpe(e){return XOe(e,!1)}function lpe(e){return XOe(e,!0)}function upe(e){return!!rm(e,mg)}function _pe(e){return rm(e,sk)}function fpe(e){return E9(e,fU)}function QH(e){return rm(e,Fge)}function KOe(e){return rm(e,qK)}function ppe(e){return rm(e,qK,!0)}function QOe(e){return rm(e,zK)}function dpe(e){return rm(e,zK,!0)}function ZOe(e){return rm(e,$K)}function mpe(e){return rm(e,$K,!0)}function e4e(e){return rm(e,WK)}function gpe(e){return rm(e,WK,!0)}function hpe(e){return rm(e,uU,!0)}function ZH(e){return rm(e,GK)}function ype(e){return rm(e,GK,!0)}function eY(e){return rm(e,UR)}function b9(e){return rm(e,HK)}function vpe(e){return rm(e,_U)}function t4e(e){return rm(e,dm)}function tY(e){return rm(e,pU)}function _T(e){let t=rm(e,$6);if(t&&t.typeExpression&&t.typeExpression.type)return t}function fT(e){let t=rm(e,$6);return!t&&Ls(e)&&(t=mr(HP(e),n=>!!n.typeExpression)),t&&t.typeExpression&&t.typeExpression.type}function K3(e){let t=vpe(e);if(t&&t.typeExpression)return t.typeExpression.type;let n=_T(e);if(n&&n.typeExpression){let i=n.typeExpression.type;if(dp(i)){let s=mr(i.members,HA);return s&&s.type}if(Vh(i)||HN(i))return i.type}}function Q3(e,t){var n;if(!U8(e))return tt;let i=(n=e.jsDoc)==null?void 0:n.jsDocCache;if(i===void 0||t){let s=KY(e,t);I.assert(s.length<2||s[0]!==s[1]),i=_a(s,o=>dg(o)?o.tags:o),t||(e.jsDoc??(e.jsDoc=[]),e.jsDoc.jsDocCache=i)}return i}function pT(e){return Q3(e,!1)}function r4e(e){return Q3(e,!0)}function rm(e,t,n){return mr(Q3(e,n),t)}function E9(e,t){return pT(e).filter(t)}function n4e(e,t){return pT(e).filter(n=>n.kind===t)}function Z3(e){return typeof e=="string"?e:e?.map(t=>t.kind===328?t.text:j0t(t)).join("")}function j0t(e){let t=e.kind===331?"link":e.kind===332?"linkcode":"linkplain",n=e.name?cp(e.name):"",i=e.name&&e.text.startsWith("://")?"":" ";return`{@${t} ${n}${i}${e.text}}`}function Ov(e){if(PT(e)){if(YN(e.parent)){let t=yN(e.parent);if(t&&de(t.tags))return _a(t.tags,n=>dm(n)?n.typeParameters:void 0)}return tt}if(am(e))return I.assert(e.parent.kind===327),_a(e.parent.tags,t=>dm(t)?t.typeParameters:void 0);if(e.typeParameters||Hge(e)&&e.typeParameters)return e.typeParameters;if(gn(e)){let t=Dj(e);if(t.length)return t;let n=fT(e);if(n&&Vh(n)&&n.typeParameters)return n.typeParameters}return tt}function YP(e){return e.constraint?e.constraint:dm(e.parent)&&e===e.parent.typeParameters[0]?e.parent.constraint:void 0}function E0(e){return e.kind===80||e.kind===81}function x9(e){return e.kind===178||e.kind===177}function C9(e){return Hn(e)&&!!(e.flags&64)}function rY(e){return fc(e)&&!!(e.flags&64)}function L2(e){return da(e)&&!!(e.flags&64)}function w_(e){let t=e.kind;return!!(e.flags&64)&&(t===211||t===212||t===213||t===235)}function Nw(e){return w_(e)&&!ek(e)&&!!e.questionDotToken}function A9(e){return Nw(e.parent)&&e.parent.expression===e}function Dw(e){return!w_(e.parent)||Nw(e.parent)||e!==e.parent.expression}function nY(e){return e.kind===226&&e.operatorToken.kind===61}function Ty(e){return Id(e)&&ze(e.typeName)&&e.typeName.escapedText==="const"&&!e.typeArguments}function Mm(e){return vl(e,8)}function k9(e){return ek(e)&&!!(e.flags&64)}function Iw(e){return e.kind===252||e.kind===251}function iY(e){return e.kind===280||e.kind===279}function Spe(e){switch(e.kind){case 309:case 310:return!0;default:return!1}}function sY(e){return Spe(e)||e.kind===307||e.kind===311}function ww(e){return e.kind===355||e.kind===348}function i4e(e){return e8(e.kind)}function e8(e){return e>=166}function aY(e){return e>=0&&e<=165}function gA(e){return aY(e.kind)}function Bb(e){return wo(e,"pos")&&wo(e,"end")}function Ow(e){return 9<=e&&e<=15}function Ub(e){return Ow(e.kind)}function oY(e){switch(e.kind){case 210:case 209:case 14:case 218:case 231:return!0}return!1}function Rv(e){return 15<=e&&e<=18}function Tpe(e){return Rv(e.kind)}function P9(e){let t=e.kind;return t===17||t===18}function hA(e){return Gf(e)||R_(e)}function t8(e){switch(e.kind){case 276:return e.isTypeOnly||e.parent.parent.isTypeOnly;case 274:return e.parent.isTypeOnly;case 273:case 271:return e.isTypeOnly}return!1}function bpe(e){switch(e.kind){case 281:return e.isTypeOnly||e.parent.parent.isTypeOnly;case 278:return e.isTypeOnly&&!!e.moduleSpecifier&&!e.exportClause;case 280:return e.parent.isTypeOnly}return!1}function dT(e){return t8(e)||bpe(e)}function cY(e){return e.kind===11||Rv(e.kind)}function Epe(e){return za(e)||ze(e)}function yc(e){var t;return ze(e)&&((t=e.emitNode)==null?void 0:t.autoGenerate)!==void 0}function F2(e){var t;return is(e)&&((t=e.emitNode)==null?void 0:t.autoGenerate)!==void 0}function r8(e){let t=e.emitNode.autoGenerate.flags;return!!(t&32)&&!!(t&16)&&!!(t&8)}function G_(e){return(ea(e)||vA(e))&&is(e.name)}function XP(e){return Hn(e)&&is(e.name)}function C1(e){switch(e){case 128:case 129:case 134:case 87:case 138:case 90:case 95:case 103:case 125:case 123:case 124:case 148:case 126:case 147:case 164:return!0}return!1}function Rw(e){return!!(IA(e)&31)}function lY(e){return Rw(e)||e===126||e===164||e===129}function Ra(e){return C1(e.kind)}function zf(e){let t=e.kind;return t===166||t===80}function Al(e){let t=e.kind;return t===80||t===81||t===11||t===9||t===167}function j2(e){let t=e.kind;return t===80||t===206||t===207}function ca(e){return!!e&&yA(e.kind)}function KP(e){return!!e&&(yA(e.kind)||Jc(e))}function tc(e){return e&&s4e(e.kind)}function Mw(e){return e.kind===112||e.kind===97}function s4e(e){switch(e){case 262:case 174:case 176:case 177:case 178:case 218:case 219:return!0;default:return!1}}function yA(e){switch(e){case 173:case 179:case 330:case 180:case 181:case 184:case 324:case 185:return!0;default:return s4e(e)}}function uY(e){return ls(e)||Zg(e)||ra(e)&&ca(e.parent)}function Du(e){let t=e.kind;return t===176||t===172||t===174||t===177||t===178||t===181||t===175||t===240}function Ti(e){return e&&(e.kind===263||e.kind===231)}function Mv(e){return e&&(e.kind===177||e.kind===178)}function Af(e){return ea(e)&&Hg(e)}function xpe(e){return gn(e)&&lB(e)?(!Hb(e)||!zv(e.expression))&&!Y2(e,!0):e.parent&&Ti(e.parent)&&ea(e)&&!Hg(e)}function vA(e){switch(e.kind){case 174:case 177:case 178:return!0;default:return!1}}function a4e(e){switch(e.kind){case 174:case 177:case 178:case 172:return!0;default:return!1}}function vc(e){return Ra(e)||n_(e)}function B2(e){let t=e.kind;return t===180||t===179||t===171||t===173||t===181||t===177||t===178}function N9(e){return B2(e)||Du(e)}function by(e){let t=e.kind;return t===303||t===304||t===305||t===174||t===177||t===178}function es(e){return RX(e.kind)}function Cpe(e){switch(e.kind){case 184:case 185:return!0}return!1}function la(e){if(e){let t=e.kind;return t===207||t===206}return!1}function Lw(e){let t=e.kind;return t===209||t===210}function D9(e){let t=e.kind;return t===208||t===232}function n8(e){switch(e.kind){case 260:case 169:case 208:return!0}return!1}function Ape(e){return Gi(e)||Ls(e)||s8(e)||a8(e)}function i8(e){return _Y(e)||fY(e)}function _Y(e){switch(e.kind){case 206:case 210:return!0}return!1}function s8(e){switch(e.kind){case 208:case 303:case 304:case 305:return!0}return!1}function fY(e){switch(e.kind){case 207:case 209:return!0}return!1}function a8(e){switch(e.kind){case 208:case 232:case 230:case 209:case 210:case 80:case 211:case 212:return!0}return lu(e,!0)}function kpe(e){let t=e.kind;return t===211||t===166||t===205}function Ppe(e){let t=e.kind;return t===211||t===166}function pY(e){return Vb(e)||iE(e)}function Vb(e){switch(e.kind){case 286:case 285:case 213:case 214:case 215:case 170:return!0;default:return!1}}function Jg(e){return e.kind===213||e.kind===214}function SA(e){let t=e.kind;return t===228||t===15}function $f(e){return o4e(Mm(e).kind)}function o4e(e){switch(e){case 211:case 212:case 214:case 213:case 284:case 285:case 288:case 215:case 209:case 217:case 210:case 231:case 218:case 80:case 81:case 14:case 9:case 10:case 11:case 15:case 228:case 97:case 106:case 110:case 112:case 108:case 235:case 233:case 236:case 102:case 282:return!0;default:return!1}}function dY(e){return c4e(Mm(e).kind)}function c4e(e){switch(e){case 224:case 225:case 220:case 221:case 222:case 223:case 216:return!0;default:return o4e(e)}}function Npe(e){switch(e.kind){case 225:return!0;case 224:return e.operator===46||e.operator===47;default:return!1}}function Dpe(e){switch(e.kind){case 106:case 112:case 97:case 224:return!0;default:return Ub(e)}}function bt(e){return B0t(Mm(e).kind)}function B0t(e){switch(e){case 227:case 229:case 219:case 226:case 230:case 234:case 232:case 361:case 360:case 238:return!0;default:return c4e(e)}}function U2(e){let t=e.kind;return t===216||t===234}function l4e(e){return BK(e)||aU(e)}function Lv(e,t){switch(e.kind){case 248:case 249:case 250:case 246:case 247:return!0;case 256:return t&&Lv(e.statement,t)}return!1}function Ipe(e){return Kc(e)||yl(e)}function wpe(e){return Tt(e,Ipe)}function I9(e){return!g8(e)&&!Kc(e)&&!ui(e,32)&&!S_(e)}function o8(e){return g8(e)||Kc(e)||ui(e,32)}function QP(e){return e.kind===249||e.kind===250}function w9(e){return ra(e)||bt(e)}function mY(e){return ra(e)}function Cd(e){return Tu(e)||bt(e)}function Ope(e){let t=e.kind;return t===268||t===267||t===80}function u4e(e){let t=e.kind;return t===268||t===267}function _4e(e){let t=e.kind;return t===80||t===267}function gY(e){let t=e.kind;return t===275||t===274}function c8(e){return e.kind===267||e.kind===266}function qg(e){switch(e.kind){case 219:case 226:case 208:case 213:case 179:case 263:case 231:case 175:case 176:case 185:case 180:case 212:case 266:case 306:case 277:case 278:case 281:case 262:case 218:case 184:case 177:case 80:case 273:case 271:case 276:case 181:case 264:case 345:case 347:case 324:case 348:case 355:case 330:case 353:case 329:case 291:case 292:case 293:case 200:case 174:case 173:case 267:case 202:case 280:case 270:case 274:case 214:case 15:case 9:case 210:case 169:case 211:case 303:case 172:case 171:case 178:case 304:case 312:case 305:case 11:case 265:case 187:case 168:case 260:return!0;default:return!1}}function Oh(e){switch(e.kind){case 219:case 241:case 179:case 269:case 299:case 175:case 194:case 176:case 185:case 180:case 248:case 249:case 250:case 262:case 218:case 184:case 177:case 181:case 345:case 347:case 324:case 330:case 353:case 200:case 174:case 173:case 267:case 178:case 312:case 265:return!0;default:return!1}}function U0t(e){return e===219||e===208||e===263||e===231||e===175||e===176||e===266||e===306||e===281||e===262||e===218||e===177||e===273||e===271||e===276||e===264||e===291||e===174||e===173||e===267||e===270||e===274||e===280||e===169||e===303||e===172||e===171||e===178||e===304||e===265||e===168||e===260||e===353||e===345||e===355}function Rpe(e){return e===262||e===282||e===263||e===264||e===265||e===266||e===267||e===272||e===271||e===278||e===277||e===270}function Mpe(e){return e===252||e===251||e===259||e===246||e===244||e===242||e===249||e===250||e===248||e===245||e===256||e===253||e===255||e===257||e===258||e===243||e===247||e===254||e===359}function O_(e){return e.kind===168?e.parent&&e.parent.kind!==352||gn(e):U0t(e.kind)}function Lpe(e){return Rpe(e.kind)}function l8(e){return Mpe(e.kind)}function ns(e){let t=e.kind;return Mpe(t)||Rpe(t)||V0t(e)}function V0t(e){return e.kind!==241||e.parent!==void 0&&(e.parent.kind===258||e.parent.kind===299)?!1:!Wb(e)}function Fpe(e){let t=e.kind;return Mpe(t)||Rpe(t)||t===241}function jpe(e){let t=e.kind;return t===283||t===166||t===80}function Fw(e){let t=e.kind;return t===110||t===80||t===211||t===295}function u8(e){let t=e.kind;return t===284||t===294||t===285||t===12||t===288}function O9(e){let t=e.kind;return t===291||t===293}function Bpe(e){let t=e.kind;return t===11||t===294}function H_(e){let t=e.kind;return t===286||t===285}function R9(e){let t=e.kind;return t===296||t===297}function ZP(e){return e.kind>=316&&e.kind<=357}function M9(e){return e.kind===327||e.kind===326||e.kind===328||TA(e)||eN(e)||mx(e)||PT(e)}function eN(e){return e.kind>=334&&e.kind<=357}function A1(e){return e.kind===178}function Fv(e){return e.kind===177}function jp(e){if(!U8(e))return!1;let{jsDoc:t}=e;return!!t&&t.length>0}function L9(e){return!!e.type}function jv(e){return!!e.initializer}function V2(e){switch(e.kind){case 260:case 169:case 208:case 172:case 303:case 306:return!0;default:return!1}}function hY(e){return e.kind===291||e.kind===293||by(e)}function F9(e){return e.kind===183||e.kind===233}function Upe(e){let t=Vpe;for(let n of e){if(!n.length)continue;let i=0;for(;i<n.length&&i<t&&Sy(n.charCodeAt(i));i++);if(i<t&&(t=i),t===0)return 0}return t===Vpe?void 0:t}function bo(e){return e.kind===11||e.kind===15}function TA(e){return e.kind===331||e.kind===332||e.kind===333}function yY(e){let t=Is(e.parameters);return!!t&&x0(t)}function x0(e){let t=mg(e)?e.typeExpression&&e.typeExpression.type:e.type;return e.dotDotDotToken!==void 0||!!t&&t.kind===325}function f4e(e,t){return t.text.substring(e.pos,e.end).includes("@internal")}function vY(e,t){t??(t=Xr(e));let n=Us(e);if(n&&n.kind===169){let s=n.parent.parameters.indexOf(n),o=s>0?n.parent.parameters[s-1]:void 0,l=t.text,p=o?ys(aT(l,Wa(l,o.end+1,!1,!0)),T0(l,e.pos)):aT(l,Wa(l,e.pos,!1,!0));return Tt(p)&&f4e(Rs(p),t)}let i=n&&jY(n,t);return!!Te(i,s=>f4e(s,t))}var _8,SY,Vpe,J0t=f({"src/compiler/utilitiesPublic.ts"(){"use strict";fa(),_8=Y3(e_(0,0),0),SY=["cs","de","es","fr","it","ja","ko","pl","pt-br","ru","tr","zh-cn","zh-tw"],Vpe=1073741823}});function xc(e,t){let n=e.declarations;if(n){for(let i of n)if(i.kind===t)return i}}function Jpe(e,t){return Fn(e.declarations||tt,n=>n.kind===t)}function ga(e){let t=new Map;if(e)for(let n of e)t.set(n.escapedName,n);return t}function Rh(e){return(e.flags&33554432)!==0}function q0t(){var e="";let t=n=>e+=n;return{getText:()=>e,write:t,rawWrite:t,writeKeyword:t,writeOperator:t,writePunctuation:t,writeSpace:t,writeStringLiteral:t,writeLiteral:t,writeParameter:t,writeProperty:t,writeSymbol:(n,i)=>t(n),writeTrailingSemicolon:t,writeComment:t,getTextPos:()=>e.length,getLine:()=>0,getColumn:()=>0,getIndent:()=>0,isAtStartOfLine:()=>!1,hasTrailingComment:()=>!1,hasTrailingWhitespace:()=>!!e.length&&Sy(e.charCodeAt(e.length-1)),writeLine:()=>e+=" ",increaseIndent:ja,decreaseIndent:ja,clear:()=>e=""}}function j9(e,t){return e.configFilePath!==t.configFilePath||qpe(e,t)}function qpe(e,t){return tN(e,t,DU)}function zpe(e,t){return tN(e,t,NQ)}function tN(e,t,n){return e!==t&&n.some(i=>!nB(Wj(e,i),Wj(t,i)))}function $pe(e,t){for(;;){let n=t(e);if(n==="quit")return;if(n!==void 0)return n;if(ls(e))return;e=e.parent}}function yu(e,t){let n=e.entries();for(let[i,s]of n){let o=t(s,i);if(o)return o}}function Mh(e,t){let n=e.keys();for(let i of n){let s=t(i);if(s)return s}}function B9(e,t){e.forEach((n,i)=>{t.set(i,n)})}function jw(e){let t=gR.getText();try{return e(gR),gR.getText()}finally{gR.clear(),gR.writeKeyword(t)}}function f8(e){return e.end-e.pos}function TY(e,t){return e.path===t.path&&!e.prepend==!t.prepend&&!e.circular==!t.circular}function Wpe(e,t){return e===t||e.resolvedModule===t.resolvedModule||!!e.resolvedModule&&!!t.resolvedModule&&e.resolvedModule.isExternalLibraryImport===t.resolvedModule.isExternalLibraryImport&&e.resolvedModule.extension===t.resolvedModule.extension&&e.resolvedModule.resolvedFileName===t.resolvedModule.resolvedFileName&&e.resolvedModule.originalPath===t.resolvedModule.originalPath&&z0t(e.resolvedModule.packageId,t.resolvedModule.packageId)&&e.alternateResult===t.alternateResult}function U9(e,t,n,i,s){var o;let l=(o=t.getResolvedModule(e,n,i))==null?void 0:o.alternateResult,p=l&&(Q_(t.getCompilerOptions())===2?[g.There_are_types_at_0_but_this_result_could_not_be_resolved_under_your_current_moduleResolution_setting_Consider_updating_to_node16_nodenext_or_bundler,[l]]:[g.There_are_types_at_0_but_this_result_could_not_be_resolved_when_respecting_package_json_exports_The_1_library_may_need_to_update_its_package_json_or_typings,[l,l.includes(Wh+"@types/")?`@types/${cD(s)}`:s]]),m=p?Xs(void 0,p[0],...p[1]):t.typesPackageExists(s)?Xs(void 0,g.If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1,s,cD(s)):t.packageBundlesTypes(s)?Xs(void 0,g.If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1,s,n):Xs(void 0,g.Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0,n,cD(s));return m&&(m.repopulateInfo=()=>({moduleReference:n,mode:i,packageName:s===n?void 0:s})),m}function z0t(e,t){return e===t||!!e&&!!t&&e.name===t.name&&e.subModuleName===t.subModuleName&&e.version===t.version}function V9({name:e,subModuleName:t}){return t?`${e}/${t}`:e}function Bv(e){return`${V9(e)}@${e.version}`}function Gpe(e,t){return e===t||e.resolvedTypeReferenceDirective===t.resolvedTypeReferenceDirective||!!e.resolvedTypeReferenceDirective&&!!t.resolvedTypeReferenceDirective&&e.resolvedTypeReferenceDirective.resolvedFileName===t.resolvedTypeReferenceDirective.resolvedFileName&&!!e.resolvedTypeReferenceDirective.primary==!!t.resolvedTypeReferenceDirective.primary&&e.resolvedTypeReferenceDirective.originalPath===t.resolvedTypeReferenceDirective.originalPath}function bY(e,t,n,i){I.assert(e.length===t.length);for(let s=0;s<e.length;s++){let o=t[s],l=e[s],p=n(l);if(p?!o||!i(p,o):o)return!0}return!1}function rN(e){return $0t(e),(e.flags&1048576)!==0}function $0t(e){e.flags&2097152||((e.flags&262144||Qs(e,rN))&&(e.flags|=1048576),e.flags|=2097152)}function Xr(e){for(;e&&e.kind!==312;)e=e.parent;return e}function J9(e){return Xr(e.valueDeclaration||DY(e))}function p8(e,t){return!!e&&(e.scriptKind===1||e.scriptKind===2)&&!e.checkJsDirective&&t===void 0}function Hpe(e){switch(e.kind){case 241:case 269:case 248:case 249:case 250:return!0}return!1}function Uv(e,t){return I.assert(e>=0),vy(t)[e]}function p4e(e){let t=Xr(e),n=Lo(t,e.pos);return`${t.fileName}(${n.line+1},${n.character+1})`}function d8(e,t){I.assert(e>=0);let n=vy(t),i=e,s=t.text;if(i+1===n.length)return s.length-1;{let o=n[i],l=n[i+1]-1;for(I.assert(I_(s.charCodeAt(l)));o<=l&&I_(s.charCodeAt(l));)l--;return l}}function q9(e,t,n){return!(n&&n(t))&&!e.identifiers.has(t)}function sl(e){return e===void 0?!0:e.pos===e.end&&e.pos>=0&&e.kind!==1}function nm(e){return!sl(e)}function Ype(e,t){return Nc(e)?t===e.expression:Jc(e)?t===e.modifiers:fp(e)?t===e.initializer:ea(e)?t===e.questionToken&&Af(e):Ul(e)?t===e.modifiers||t===e.questionToken||t===e.exclamationToken||m8(e.modifiers,t,vc):Hf(e)?t===e.equalsToken||t===e.modifiers||t===e.questionToken||t===e.exclamationToken||m8(e.modifiers,t,vc):pl(e)?t===e.exclamationToken:Yc(e)?t===e.typeParameters||t===e.type||m8(e.typeParameters,t,Nc):sd(e)?t===e.typeParameters||m8(e.typeParameters,t,Nc):pp(e)?t===e.typeParameters||t===e.type||m8(e.typeParameters,t,Nc):BR(e)?t===e.modifiers||m8(e.modifiers,t,vc):!1}function m8(e,t,n){return!e||os(t)||!n(t)?!1:hs(e,t)}function d4e(e,t,n){if(t===void 0||t.length===0)return e;let i=0;for(;i<e.length&&n(e[i]);++i);return e.splice(i,0,...t),e}function m4e(e,t,n){if(t===void 0)return e;let i=0;for(;i<e.length&&n(e[i]);++i);return e.splice(i,0,t),e}function g4e(e){return Fm(e)||!!(eo(e)&2097152)}function C0(e,t){return d4e(e,t,Fm)}function EY(e,t){return d4e(e,t,g4e)}function h4e(e,t){return m4e(e,t,Fm)}function J2(e,t){return m4e(e,t,g4e)}function xY(e,t,n){if(e.charCodeAt(t+1)===47&&t+2<n&&e.charCodeAt(t+2)===47){let i=e.substring(t,n);return!!(eK.test(i)||tK.test(i)||i3e.test(i)||r3e.test(i)||n3e.test(i)||s3e.test(i))}return!1}function z9(e,t){return e.charCodeAt(t+1)===42&&e.charCodeAt(t+2)===33}function Xpe(e,t){let n=new Map(t.map(l=>[`${Lo(e,l.range.end).line}`,l])),i=new Map;return{getUnusedExpectations:s,markUsed:o};function s(){return In(n.entries()).filter(([l,p])=>p.type===0&&!i.get(l)).map(([l,p])=>p)}function o(l){return n.has(`${l}`)?(i.set(`${l}`,!0),!0):!1}}function mT(e,t,n){return sl(e)?e.pos:ZP(e)||e.kind===12?Wa((t||Xr(e)).text,e.pos,!1,!0):n&&jp(e)?mT(e.jsDoc[0],t):e.kind===358&&e._children.length>0?mT(e._children[0],t,n):Wa((t||Xr(e)).text,e.pos,!1,!1,k8(e))}function CY(e,t){let n=!sl(e)&&Jm(e)?Da(e.modifiers,n_):void 0;return n?Wa((t||Xr(e)).text,n.end):mT(e,t)}function Jb(e,t,n=!1){return Bw(e.text,t,n)}function W0t(e){return!!Gr(e,hE)}function $9(e){return!!(yl(e)&&e.exportClause&&qh(e.exportClause)&&e.exportClause.name.escapedText==="default")}function Bw(e,t,n=!1){if(sl(t))return"";let i=e.substring(n?t.pos:Wa(e,t.pos),t.end);return W0t(t)&&(i=i.split(/\r\n|\n|\r/).map(s=>s.replace(/^\s*\*/,"").trimStart()).join(`
`)),i}function Fl(e,t=!1){return Jb(Xr(e),e,t)}function G0t(e){return e.pos}function nN(e,t){return Bg(e,t,G0t,To)}function eo(e){let t=e.emitNode;return t&&t.flags||0}function Lm(e){let t=e.emitNode;return t&&t.internalFlags||0}function Kpe(e,t,n){if(t&&H0t(e,n))return Jb(t,e);switch(e.kind){case 11:{let i=n&2?mX:n&1||eo(e)&16777216?D0:K8;return e.singleQuote?"'"+i(e.text,39)+"'":'"'+i(e.text,34)+'"'}case 15:case 16:case 17:case 18:{let i=n&1||eo(e)&16777216?D0:K8,s=e.rawText??pX(i(e.text,96));switch(e.kind){case 15:return"`"+s+"`";case 16:return"`"+s+"${";case 17:return"}"+s+"${";case 18:return"}"+s+"`"}break}case 9:case 10:return e.text;case 14:return n&4&&e.isUnterminated?e.text+(e.text.charCodeAt(e.text.length-1)===92?" /":"/"):e.text}return I.fail(`Literal kind '${e.kind}' not accounted for.`)}function H0t(e,t){if(_c(e)||!e.parent||t&4&&e.isUnterminated)return!1;if(_p(e)){if(e.numericLiteralFlags&26656)return!1;if(e.numericLiteralFlags&512)return!!(t&8)}return!KB(e)}function Qpe(e){return vs(e)?'"'+K8(e)+'"':""+e}function Zpe(e){return Cl(e).replace(/^(\d)/,"_$1").replace(/\W/g,"_")}function AY(e){return(x1(e)&7)!==0||kY(e)}function kY(e){let t=Gg(e);return t.kind===260&&t.parent.kind===299}function S_(e){return hl(e)&&(e.name.kind===11||zg(e))}function W9(e){return hl(e)&&e.name.kind===11}function PY(e){return hl(e)&&za(e.name)}function ede(e){return hl(e)||ze(e)}function Uw(e){return Y0t(e.valueDeclaration)}function Y0t(e){return!!e&&e.kind===267&&!e.body}function tde(e){return e.kind===312||e.kind===267||KP(e)}function zg(e){return!!(e.flags&2048)}function qb(e){return S_(e)&&NY(e)}function NY(e){switch(e.parent.kind){case 312:return Pl(e.parent);case 268:return S_(e.parent.parent)&&ls(e.parent.parent.parent)&&!Pl(e.parent.parent.parent)}return!1}function DY(e){var t;return(t=e.declarations)==null?void 0:t.find(n=>!qb(n)&&!(hl(n)&&zg(n)))}function X0t(e){return e===1||e===100||e===199}function bA(e,t){return Pl(e)||X0t(T_(t))&&!!e.commonJsModuleIndicator}function IY(e,t){switch(e.scriptKind){case 1:case 3:case 2:case 4:break;default:return!1}return e.isDeclarationFile?!1:K_(t,"alwaysStrict")||zge(e.statements)?!0:Pl(e)||fm(t)?T_(t)>=5?!0:!t.noImplicitUseStrict:!1}function wY(e){return!!(e.flags&33554432)||ui(e,128)}function OY(e,t){switch(e.kind){case 312:case 269:case 299:case 267:case 248:case 249:case 250:case 176:case 174:case 177:case 178:case 262:case 218:case 219:case 172:case 175:return!0;case 241:return!KP(t)}return!1}function RY(e){switch(I.type(e),e.kind){case 345:case 353:case 330:return!0;default:return MY(e)}}function MY(e){switch(I.type(e),e.kind){case 179:case 180:case 173:case 181:case 184:case 185:case 324:case 263:case 231:case 264:case 265:case 352:case 262:case 174:case 176:case 177:case 178:case 218:case 219:return!0;default:return!1}}function q2(e){switch(e.kind){case 272:case 271:return!0;default:return!1}}function rde(e){return q2(e)||Gb(e)}function G9(e){switch(e.kind){case 272:case 271:case 243:case 263:case 262:case 267:case 265:case 264:case 266:return!0;default:return!1}}function nde(e){return g8(e)||hl(e)||M0(e)||Up(e)}function g8(e){return q2(e)||yl(e)}function LY(e){return Gr(e.parent,t=>!!(HQ(t)&1))}function Lh(e){return Gr(e.parent,t=>OY(t,t.parent))}function ide(e,t){let n=Lh(e);for(;n;)t(n),n=Lh(n)}function qo(e){return!e||f8(e)===0?"(Missing)":Fl(e)}function sde(e){return e.declaration?qo(e.declaration.parameters[0].name):void 0}function h8(e){return e.kind===167&&!id(e.expression)}function Vw(e){var t;switch(e.kind){case 80:case 81:return(t=e.emitNode)!=null&&t.autoGenerate?void 0:e.escapedText;case 11:case 9:case 15:return Pc(e.text);case 167:return id(e.expression)?Pc(e.expression.text):void 0;case 295:return FA(e);default:return I.assertNever(e)}}function iN(e){return I.checkDefined(Vw(e))}function cp(e){switch(e.kind){case 110:return"this";case 81:case 80:return f8(e)===0?Nn(e):Fl(e);case 166:return cp(e.left)+"."+cp(e.right);case 211:return ze(e.name)||is(e.name)?cp(e.expression)+"."+cp(e.name):I.assertNever(e.name);case 318:return cp(e.left)+cp(e.right);case 295:return cp(e.namespace)+":"+cp(e.name);default:return I.assertNever(e)}}function $n(e,t,...n){let i=Xr(e);return im(i,e,t,...n)}function sN(e,t,n,...i){let s=Wa(e.text,t.pos);return Iu(e,s,t.end-s,n,...i)}function im(e,t,n,...i){let s=z2(e,t);return Iu(e,s.start,s.length,n,...i)}function Ey(e,t,n,i){let s=z2(e,t);return H9(e,s.start,s.length,n,i)}function y8(e,t,n,i){let s=Wa(e.text,t.pos);return H9(e,s,t.end-s,n,i)}function ade(e,t,n){I.assertGreaterThanOrEqual(t,0),I.assertGreaterThanOrEqual(n,0),I.assertLessThanOrEqual(t,e.length),I.assertLessThanOrEqual(t+n,e.length)}function H9(e,t,n,i,s){return ade(e.text,t,n),{file:e,start:t,length:n,code:i.code,category:i.category,messageText:i.next?i:i.messageText,relatedInformation:s}}function FY(e,t,n){return{file:e,start:0,length:0,code:t.code,category:t.category,messageText:t.next?t:t.messageText,relatedInformation:n}}function ode(e){return typeof e.messageText=="string"?{code:e.code,category:e.category,messageText:e.messageText,next:e.next}:e.messageText}function cde(e,t,n){return{file:e,start:t.pos,length:t.end-t.pos,code:n.code,category:n.category,messageText:n.message}}function Fh(e,t){let n=E1(e.languageVersion,!0,e.languageVariant,e.text,void 0,t);n.scan();let i=n.getTokenStart();return Ll(i,n.getTokenEnd())}function lde(e,t){let n=E1(e.languageVersion,!0,e.languageVariant,e.text,void 0,t);return n.scan(),n.getToken()}function K0t(e,t){let n=Wa(e.text,t.pos);if(t.body&&t.body.kind===241){let{line:i}=Lo(e,t.body.pos),{line:s}=Lo(e,t.body.end);if(i<s)return e_(n,d8(i,e)-n+1)}return Ll(n,t.end)}function z2(e,t){let n=t;switch(t.kind){case 312:{let o=Wa(e.text,0,!1);return o===e.text.length?e_(0,0):Fh(e,o)}case 260:case 208:case 263:case 231:case 264:case 267:case 266:case 306:case 262:case 218:case 174:case 177:case 178:case 265:case 172:case 171:case 274:n=t.name;break;case 219:return K0t(e,t);case 296:case 297:{let o=Wa(e.text,t.pos),l=t.statements.length>0?t.statements[0].pos:t.end;return Ll(o,l)}case 253:case 229:{let o=Wa(e.text,t.pos);return Fh(e,o)}case 238:{let o=Wa(e.text,t.expression.end);return Fh(e,o)}case 357:{let o=Wa(e.text,t.tagName.pos);return Fh(e,o)}}if(n===void 0)return Fh(e,t.pos);I.assert(!dg(n));let i=sl(n),s=i||qA(t)?n.pos:Wa(e.text,n.pos);return i?(I.assert(s===n.pos,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"),I.assert(s===n.end,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809")):(I.assert(s>=n.pos,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"),I.assert(s<=n.end,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809")),Ll(s,n.end)}function Bp(e){return(e.externalModuleIndicator||e.commonJsModuleIndicator)!==void 0}function sm(e){return e.scriptKind===6}function zb(e){return!!(lT(e)&4096)}function Y9(e){return!!(lT(e)&8&&!op(e,e.parent))}function v8(e){return(x1(e)&7)===6}function S8(e){return(x1(e)&7)===4}function aN(e){return(x1(e)&7)===2}function X9(e){return(x1(e)&7)===1}function $2(e){return e.kind===213&&e.expression.kind===108}function Up(e){return e.kind===213&&e.expression.kind===102}function oN(e){return F6(e)&&e.keywordToken===102&&e.name.escapedText==="meta"}function Vv(e){return M0(e)&&Qv(e.argument)&&za(e.argument.literal)}function Fm(e){return e.kind===244&&e.expression.kind===11}function T8(e){return!!(eo(e)&2097152)}function K9(e){return T8(e)&&Zl(e)}function Q0t(e){return ze(e.name)&&!e.initializer}function Q9(e){return T8(e)&&Xc(e)&&yr(e.declarationList.declarations,Q0t)}function jY(e,t){return e.kind!==12?T0(t.text,e.pos):void 0}function BY(e,t){let n=e.kind===169||e.kind===168||e.kind===218||e.kind===219||e.kind===217||e.kind===260||e.kind===281?ys(aT(t,e.pos),T0(t,e.pos)):T0(t,e.pos);return Fn(n,i=>t.charCodeAt(i.pos+1)===42&&t.charCodeAt(i.pos+2)===42&&t.charCodeAt(i.pos+3)!==47)}function A0(e){if(182<=e.kind&&e.kind<=205)return!0;switch(e.kind){case 133:case 159:case 150:case 163:case 154:case 136:case 155:case 151:case 157:case 106:case 146:return!0;case 116:return e.parent.kind!==222;case 233:return y4e(e);case 168:return e.parent.kind===200||e.parent.kind===195;case 80:(e.parent.kind===166&&e.parent.right===e||e.parent.kind===211&&e.parent.name===e)&&(e=e.parent),I.assert(e.kind===80||e.kind===166||e.kind===211,"'node' was expected to be a qualified name, identifier or property access in 'isPartOfTypeNode'.");case 166:case 211:case 110:{let{parent:t}=e;if(t.kind===186)return!1;if(t.kind===205)return!t.isTypeOf;if(182<=t.kind&&t.kind<=205)return!0;switch(t.kind){case 233:return y4e(t);case 168:return e===t.constraint;case 352:return e===t.constraint;case 172:case 171:case 169:case 260:return e===t.type;case 262:case 218:case 219:case 176:case 174:case 173:case 177:case 178:return e===t.type;case 179:case 180:case 181:return e===t.type;case 216:return e===t.type;case 213:case 214:case 215:return hs(t.typeArguments,e)}}}return!1}function y4e(e){return fU(e.parent)||sk(e.parent)||ad(e.parent)&&!Oj(e)}function v4e(e,t){for(;e;){if(e.kind===t)return!0;e=e.parent}return!1}function $b(e,t){return n(e);function n(i){switch(i.kind){case 253:return t(i);case 269:case 241:case 245:case 246:case 247:case 248:case 249:case 250:case 254:case 255:case 296:case 297:case 256:case 258:case 299:return Qs(i,n)}}}function ude(e,t){return n(e);function n(i){switch(i.kind){case 229:t(i);let s=i.expression;s&&n(s);return;case 266:case 264:case 267:case 265:return;default:if(ca(i)){if(i.name&&i.name.kind===167){n(i.name.expression);return}}else A0(i)||Qs(i,n)}}}function UY(e){return e&&e.kind===188?e.elementType:e&&e.kind===183?nl(e.typeArguments):void 0}function _de(e){switch(e.kind){case 264:case 263:case 231:case 187:return e.members;case 210:return e.properties}}function cN(e){if(e)switch(e.kind){case 208:case 306:case 169:case 303:case 172:case 171:case 304:case 260:return!0}return!1}function fde(e){return cN(e)||Mv(e)}function Jw(e){return e.parent.kind===261&&e.parent.parent.kind===243}function pde(e){return gn(e)?Ha(e.parent)&&bn(e.parent.parent)&&al(e.parent.parent)===2||Z9(e.parent):!1}function Z9(e){return gn(e)?bn(e)&&al(e)===1:!1}function dde(e){return(Gi(e)?aN(e)&&ze(e.name)&&Jw(e):ea(e)?i6(e)&&jl(e):fp(e)&&i6(e))||Z9(e)}function mde(e){switch(e.kind){case 174:case 173:case 176:case 177:case 178:case 262:case 218:return!0}return!1}function VY(e,t){for(;;){if(t&&t(e),e.statement.kind!==256)return e.statement;e=e.statement}}function Wb(e){return e&&e.kind===241&&ca(e.parent)}function jm(e){return e&&e.kind===174&&e.parent.kind===210}function ej(e){return(e.kind===174||e.kind===177||e.kind===178)&&(e.parent.kind===210||e.parent.kind===231)}function gde(e){return e&&e.kind===1}function S4e(e){return e&&e.kind===0}function lN(e,t,n,i){return Te(e?.properties,s=>{if(!Ul(s))return;let o=Vw(s.name);return t===o||i&&i===o?n(s):void 0})}function hde(e,t,n){return lN(e,t,i=>Z_(i.initializer)?mr(i.initializer.elements,s=>za(s)&&s.text===n):void 0)}function qw(e){if(e&&e.statements.length){let t=e.statements[0].expression;return ii(t,Ha)}}function tj(e,t,n){return b8(e,t,i=>Z_(i.initializer)?mr(i.initializer.elements,s=>za(s)&&s.text===n):void 0)}function b8(e,t,n){return lN(qw(e),t,n)}function Vp(e){return Gr(e.parent,ca)}function yde(e){return Gr(e.parent,tc)}function Vu(e){return Gr(e.parent,Ti)}function vde(e){return Gr(e.parent,t=>Ti(t)||ca(t)?"quit":Jc(t))}function rj(e){return Gr(e.parent,KP)}function nj(e){let t=Gr(e.parent,n=>Ti(n)?"quit":n_(n));return t&&Ti(t.parent)?Vu(t.parent):Vu(t??e)}function kf(e,t,n){for(I.assert(e.kind!==312);;){if(e=e.parent,!e)return I.fail();switch(e.kind){case 167:if(n&&Ti(e.parent.parent))return e;e=e.parent.parent;break;case 170:e.parent.kind===169&&Du(e.parent.parent)?e=e.parent.parent:Du(e.parent)&&(e=e.parent);break;case 219:if(!t)continue;case 262:case 218:case 267:case 175:case 172:case 171:case 174:case 173:case 176:case 177:case 178:case 179:case 180:case 181:case 266:case 312:return e}}}function Sde(e){switch(e.kind){case 219:case 262:case 218:case 172:return!0;case 241:switch(e.parent.kind){case 176:case 174:case 177:case 178:return!0;default:return!1}default:return!1}}function ij(e){ze(e)&&(eu(e.parent)||Zl(e.parent))&&e.parent.name===e&&(e=e.parent);let t=kf(e,!0,!1);return ls(t)}function Tde(e){let t=kf(e,!1,!1);if(t)switch(t.kind){case 176:case 262:case 218:return t}}function E8(e,t){for(;;){if(e=e.parent,!e)return;switch(e.kind){case 167:e=e.parent;break;case 262:case 218:case 219:if(!t)continue;case 172:case 171:case 174:case 173:case 176:case 177:case 178:case 175:return e;case 170:e.parent.kind===169&&Du(e.parent.parent)?e=e.parent.parent:Du(e.parent)&&(e=e.parent);break}}}function W2(e){if(e.kind===218||e.kind===219){let t=e,n=e.parent;for(;n.kind===217;)t=n,n=n.parent;if(n.kind===213&&n.expression===t)return n}}function T4e(e){return e.kind===108||Pf(e)}function Pf(e){let t=e.kind;return(t===211||t===212)&&e.expression.kind===108}function x8(e){let t=e.kind;return(t===211||t===212)&&e.expression.kind===110}function sj(e){var t;return!!e&&Gi(e)&&((t=e.initializer)==null?void 0:t.kind)===110}function bde(e){return!!e&&(Hf(e)||Ul(e))&&bn(e.parent.parent)&&e.parent.parent.operatorToken.kind===64&&e.parent.parent.right.kind===110}function C8(e){switch(e.kind){case 183:return e.typeName;case 233:return ol(e.expression)?e.expression:void 0;case 80:case 166:return e}}function aj(e){switch(e.kind){case 215:return e.tag;case 286:case 285:return e.tagName;case 226:return e.right;default:return e.expression}}function oj(e,t,n,i){if(e&&W_(t)&&is(t.name))return!1;switch(t.kind){case 263:return!0;case 231:return!e;case 172:return n!==void 0&&(e?eu(n):Ti(n)&&!tE(t)&&!TX(t));case 177:case 178:case 174:return t.body!==void 0&&n!==void 0&&(e?eu(n):Ti(n));case 169:return e?n!==void 0&&n.body!==void 0&&(n.kind===176||n.kind===174||n.kind===178)&&Qb(n)!==t&&i!==void 0&&i.kind===263:!1}return!1}function uN(e,t,n,i){return Ad(t)&&oj(e,t,n,i)}function A8(e,t,n,i){return uN(e,t,n,i)||zw(e,t,n)}function zw(e,t,n){switch(t.kind){case 263:return Tt(t.members,i=>A8(e,i,t,n));case 231:return!e&&Tt(t.members,i=>A8(e,i,t,n));case 174:case 178:case 176:return Tt(t.parameters,i=>uN(e,i,t,n));default:return!1}}function k1(e,t){if(uN(e,t))return!0;let n=I0(t);return!!n&&zw(e,n,t)}function JY(e,t,n){let i;if(Mv(t)){let{firstAccessor:s,secondAccessor:o,setAccessor:l}=tx(n.members,t),p=Ad(s)?s:o&&Ad(o)?o:void 0;if(!p||t!==p)return!1;i=l?.parameters}else pl(t)&&(i=t.parameters);if(uN(e,t,n))return!0;if(i){for(let s of i)if(!Zb(s)&&uN(e,s,t,n))return!0}return!1}function qY(e){if(e.textSourceNode){switch(e.textSourceNode.kind){case 11:return qY(e.textSourceNode);case 15:return e.text===""}return!1}return e.text===""}function _N(e){let{parent:t}=e;return t.kind===286||t.kind===285||t.kind===287?t.tagName===e:!1}function k0(e){switch(e.kind){case 108:case 106:case 112:case 97:case 14:case 209:case 210:case 211:case 212:case 213:case 214:case 215:case 234:case 216:case 238:case 235:case 217:case 218:case 231:case 219:case 222:case 220:case 221:case 224:case 225:case 226:case 227:case 230:case 228:case 232:case 284:case 285:case 288:case 229:case 223:case 236:return!0;case 233:return!ad(e.parent)&&!sk(e.parent);case 166:for(;e.parent.kind===166;)e=e.parent;return e.parent.kind===186||TA(e.parent)||z6(e.parent)||kT(e.parent)||_N(e);case 318:for(;kT(e.parent);)e=e.parent;return e.parent.kind===186||TA(e.parent)||z6(e.parent)||kT(e.parent)||_N(e);case 81:return bn(e.parent)&&e.parent.left===e&&e.parent.operatorToken.kind===103;case 80:if(e.parent.kind===186||TA(e.parent)||z6(e.parent)||kT(e.parent)||_N(e))return!0;case 9:case 10:case 11:case 15:case 110:return cj(e);default:return!1}}function cj(e){let{parent:t}=e;switch(t.kind){case 260:case 169:case 172:case 171:case 306:case 303:case 208:return t.initializer===e;case 244:case 245:case 246:case 247:case 253:case 254:case 255:case 296:case 257:return t.expression===e;case 248:let n=t;return n.initializer===e&&n.initializer.kind!==261||n.condition===e||n.incrementor===e;case 249:case 250:let i=t;return i.initializer===e&&i.initializer.kind!==261||i.expression===e;case 216:case 234:return e===t.expression;case 239:return e===t.expression;case 167:return e===t.expression;case 170:case 294:case 293:case 305:return!0;case 233:return t.expression===e&&!A0(t);case 304:return t.objectAssignmentInitializer===e;case 238:return e===t.expression;default:return k0(t)}}function lj(e){for(;e.kind===166||e.kind===80;)e=e.parent;return e.kind===186}function Ede(e){return qh(e)&&!!e.parent.moduleSpecifier}function gT(e){return e.kind===271&&e.moduleReference.kind===283}function $w(e){return I.assert(gT(e)),e.moduleReference.expression}function zY(e){return Gb(e)&&DN(e.initializer).arguments[0]}function fN(e){return e.kind===271&&e.moduleReference.kind!==283}function Y_(e){return gn(e)}function b4e(e){return!gn(e)}function gn(e){return!!e&&!!(e.flags&524288)}function uj(e){return!!e&&!!(e.flags&134217728)}function $Y(e){return!sm(e)}function k8(e){return!!e&&!!(e.flags&16777216)}function _j(e){return Id(e)&&ze(e.typeName)&&e.typeName.escapedText==="Object"&&e.typeArguments&&e.typeArguments.length===2&&(e.typeArguments[0].kind===154||e.typeArguments[0].kind===150)}function _f(e,t){if(e.kind!==213)return!1;let{expression:n,arguments:i}=e;if(n.kind!==80||n.escapedText!=="require"||i.length!==1)return!1;let s=i[0];return!t||bo(s)}function fj(e){return E4e(e,!1)}function Gb(e){return E4e(e,!0)}function xde(e){return co(e)&&Gb(e.parent.parent)}function E4e(e,t){return Gi(e)&&!!e.initializer&&_f(t?DN(e.initializer):e.initializer,!0)}function WY(e){return Xc(e)&&e.declarationList.declarations.length>0&&yr(e.declarationList.declarations,t=>fj(t))}function P8(e){return e===39||e===34}function pj(e,t){return Jb(t,e).charCodeAt(0)===34}function Ww(e){return bn(e)||Yo(e)||ze(e)||da(e)}function N8(e){return gn(e)&&e.initializer&&bn(e.initializer)&&(e.initializer.operatorToken.kind===57||e.initializer.operatorToken.kind===61)&&e.name&&ol(e.name)&&pN(e.name,e.initializer.left)?e.initializer.right:e.initializer}function D8(e){let t=N8(e);return t&&hT(t,zv(e.name))}function Z0t(e,t){return Te(e.properties,n=>Ul(n)&&ze(n.name)&&n.name.escapedText==="value"&&n.initializer&&hT(n.initializer,t))}function EA(e){if(e&&e.parent&&bn(e.parent)&&e.parent.operatorToken.kind===64){let t=zv(e.parent.left);return hT(e.parent.right,t)||eyt(e.parent.left,e.parent.right,t)}if(e&&da(e)&&H2(e)){let t=Z0t(e.arguments[2],e.arguments[1].text==="prototype");if(t)return t}}function hT(e,t){if(da(e)){let n=Do(e.expression);return n.kind===218||n.kind===219?e:void 0}if(e.kind===218||e.kind===231||e.kind===219||Ha(e)&&(e.properties.length===0||t))return e}function eyt(e,t,n){let i=bn(t)&&(t.operatorToken.kind===57||t.operatorToken.kind===61)&&hT(t.right,n);if(i&&pN(e,t.left))return i}function Cde(e){let t=Gi(e.parent)?e.parent.name:bn(e.parent)&&e.parent.operatorToken.kind===64?e.parent.left:void 0;return t&&hT(e.right,zv(t))&&ol(t)&&pN(t,e.left)}function GY(e){if(bn(e.parent)){let t=(e.parent.operatorToken.kind===57||e.parent.operatorToken.kind===61)&&bn(e.parent.parent)?e.parent.parent:e.parent;if(t.operatorToken.kind===64&&ze(t.left))return t.left}else if(Gi(e.parent))return e.parent.name}function pN(e,t){return Wg(e)&&Wg(t)?om(e)===om(t):E0(e)&&dj(t)&&(t.expression.kind===110||ze(t.expression)&&(t.expression.escapedText==="window"||t.expression.escapedText==="self"||t.expression.escapedText==="global"))?pN(e,O8(t)):dj(e)&&dj(t)?xy(e)===xy(t)&&pN(e.expression,t.expression):!1}function I8(e){for(;lu(e,!0);)e=e.right;return e}function G2(e){return ze(e)&&e.escapedText==="exports"}function HY(e){return ze(e)&&e.escapedText==="module"}function P0(e){return(Hn(e)||w8(e))&&HY(e.expression)&&xy(e)==="exports"}function al(e){let t=tyt(e);return t===5||gn(e)?t:0}function H2(e){return de(e.arguments)===3&&Hn(e.expression)&&ze(e.expression.expression)&&Nn(e.expression.expression)==="Object"&&Nn(e.expression.name)==="defineProperty"&&id(e.arguments[1])&&Y2(e.arguments[0],!0)}function dj(e){return Hn(e)||w8(e)}function w8(e){return fc(e)&&id(e.argumentExpression)}function Hb(e,t){return Hn(e)&&(!t&&e.expression.kind===110||ze(e.name)&&Y2(e.expression,!0))||mj(e,t)}function mj(e,t){return w8(e)&&(!t&&e.expression.kind===110||ol(e.expression)||Hb(e.expression,!0))}function Y2(e,t){return ol(e)||Hb(e,t)}function O8(e){return Hn(e)?e.name:e.argumentExpression}function tyt(e){if(da(e)){if(!H2(e))return 0;let t=e.arguments[0];return G2(t)||P0(t)?8:Hb(t)&&xy(t)==="prototype"?9:7}return e.operatorToken.kind!==64||!Yo(e.left)||ryt(I8(e))?0:Y2(e.left.expression,!0)&&xy(e.left)==="prototype"&&Ha(YY(e))?6:R8(e.left)}function ryt(e){return ZA(e)&&_p(e.expression)&&e.expression.text==="0"}function gj(e){if(Hn(e))return e.name;let t=Do(e.argumentExpression);return _p(t)||bo(t)?t:e}function xy(e){let t=gj(e);if(t){if(ze(t))return t.escapedText;if(bo(t)||_p(t))return Pc(t.text)}}function R8(e){if(e.expression.kind===110)return 4;if(P0(e))return 2;if(Y2(e.expression,!0)){if(zv(e.expression))return 3;let t=e;for(;!ze(t.expression);)t=t.expression;let n=t.expression;if((n.escapedText==="exports"||n.escapedText==="module"&&xy(t)==="exports")&&Hb(e))return 1;if(Y2(e,!0)||fc(e)&&bj(e))return 5}return 0}function YY(e){for(;bn(e.right);)e=e.right;return e.right}function M8(e){return bn(e)&&al(e)===3}function Ade(e){return gn(e)&&e.parent&&e.parent.kind===244&&(!fc(e)||w8(e))&&!!_T(e.parent)}function L8(e,t){let{valueDeclaration:n}=e;(!n||!(t.flags&33554432&&!gn(t)&&!(n.flags&33554432))&&Ww(n)&&!Ww(t)||n.kind!==t.kind&&ede(n))&&(e.valueDeclaration=t)}function kde(e){if(!e||!e.valueDeclaration)return!1;let t=e.valueDeclaration;return t.kind===262||Gi(t)&&t.initializer&&ca(t.initializer)}function dN(e){var t,n;switch(e.kind){case 260:case 208:return(t=Gr(e.initializer,i=>_f(i,!0)))==null?void 0:t.arguments[0];case 272:case 278:return ii(e.moduleSpecifier,bo);case 271:return ii((n=ii(e.moduleReference,zh))==null?void 0:n.expression,bo);case 273:case 280:return ii(e.parent.moduleSpecifier,bo);case 274:case 281:return ii(e.parent.parent.moduleSpecifier,bo);case 276:return ii(e.parent.parent.parent.moduleSpecifier,bo);case 205:return Vv(e)?e.argument.literal:void 0;default:I.assertNever(e)}}function Gw(e){return F8(e)||I.failBadSyntaxKind(e.parent)}function F8(e){switch(e.parent.kind){case 272:case 278:return e.parent;case 283:return e.parent.parent;case 213:return Up(e.parent)||_f(e.parent,!1)?e.parent:void 0;case 201:return I.assert(za(e)),ii(e.parent.parent,M0);default:return}}function mN(e){switch(e.kind){case 272:case 278:return e.moduleSpecifier;case 271:return e.moduleReference.kind===283?e.moduleReference.expression:void 0;case 205:return Vv(e)?e.argument.literal:void 0;case 213:return e.arguments[0];case 267:return e.name.kind===11?e.name:void 0;default:return I.assertNever(e)}}function gN(e){switch(e.kind){case 272:return e.importClause&&ii(e.importClause.namedBindings,tS);case 271:return e;case 278:return e.exportClause&&ii(e.exportClause,qh);default:return I.assertNever(e)}}function xA(e){return e.kind===272&&!!e.importClause&&!!e.importClause.name}function hj(e,t){if(e.name){let n=t(e);if(n)return n}if(e.namedBindings){let n=tS(e.namedBindings)?t(e.namedBindings):Te(e.namedBindings.elements,t);if(n)return n}}function CA(e){if(e)switch(e.kind){case 169:case 174:case 173:case 304:case 303:case 172:case 171:return e.questionToken!==void 0}return!1}function hN(e){let t=HN(e)?qi(e.parameters):void 0,n=ii(t&&t.name,ze);return!!n&&n.escapedText==="new"}function am(e){return e.kind===353||e.kind===345||e.kind===347}function j8(e){return am(e)||Vm(e)}function nyt(e){return Ou(e)&&bn(e.expression)&&e.expression.operatorToken.kind===64?I8(e.expression):void 0}function x4e(e){return Ou(e)&&bn(e.expression)&&al(e.expression)!==0&&bn(e.expression.right)&&(e.expression.right.operatorToken.kind===57||e.expression.right.operatorToken.kind===61)?e.expression.right.right:void 0}function XY(e){switch(e.kind){case 243:let t=AA(e);return t&&t.initializer;case 172:return e.initializer;case 303:return e.initializer}}function AA(e){return Xc(e)?qi(e.declarationList.declarations):void 0}function C4e(e){return hl(e)&&e.body&&e.body.kind===267?e.body:void 0}function B8(e){if(e.kind>=243&&e.kind<=259)return!0;switch(e.kind){case 80:case 110:case 108:case 166:case 236:case 212:case 211:case 208:case 218:case 219:case 174:case 177:case 178:return!0;default:return!1}}function U8(e){switch(e.kind){case 219:case 226:case 241:case 252:case 179:case 296:case 263:case 231:case 175:case 176:case 185:case 180:case 251:case 259:case 246:case 212:case 242:case 1:case 266:case 306:case 277:case 278:case 281:case 244:case 249:case 250:case 248:case 262:case 218:case 184:case 177:case 80:case 245:case 272:case 271:case 181:case 264:case 324:case 330:case 256:case 174:case 173:case 267:case 202:case 270:case 210:case 169:case 217:case 211:case 303:case 172:case 171:case 253:case 240:case 178:case 304:case 305:case 255:case 257:case 258:case 265:case 168:case 260:case 243:case 247:case 254:return!0;default:return!1}}function KY(e,t){let n;cN(e)&&jv(e)&&jp(e.initializer)&&(n=jt(n,A4e(e,e.initializer.jsDoc)));let i=e;for(;i&&i.parent;){if(jp(i)&&(n=jt(n,A4e(e,i.jsDoc))),i.kind===169){n=jt(n,(t?ope:HP)(i));break}if(i.kind===168){n=jt(n,(t?lpe:cpe)(i));break}i=QY(i)}return n||tt}function A4e(e,t){let n=Rs(t);return _a(t,i=>{if(i===n){let s=Fn(i.tags,o=>iyt(e,o));return i.tags===s?[i]:s}else return Fn(i.tags,YN)})}function iyt(e,t){return!($6(t)||pU(t))||!t.parent||!dg(t.parent)||!Df(t.parent.parent)||t.parent.parent===e}function QY(e){let t=e.parent;if(t.kind===303||t.kind===277||t.kind===172||t.kind===244&&e.kind===211||t.kind===253||C4e(t)||lu(e))return t;if(t.parent&&(AA(t.parent)===e||lu(t)))return t.parent;if(t.parent&&t.parent.parent&&(AA(t.parent.parent)||XY(t.parent.parent)===e||x4e(t.parent.parent)))return t.parent.parent}function V8(e){if(e.symbol)return e.symbol;if(!ze(e.name))return;let t=e.name.escapedText,n=yT(e);if(!n)return;let i=mr(n.parameters,s=>s.name.kind===80&&s.name.escapedText===t);return i&&i.symbol}function yj(e){if(dg(e.parent)&&e.parent.tags){let t=mr(e.parent.tags,am);if(t)return t}return yT(e)}function ZY(e){return E9(e,YN)}function yT(e){let t=vT(e);if(t)return fp(t)&&t.type&&ca(t.type)?t.type:ca(t)?t:void 0}function vT(e){let t=X2(e);if(t)return x4e(t)||nyt(t)||XY(t)||AA(t)||C4e(t)||t}function X2(e){let t=yN(e);if(!t)return;let n=t.parent;if(n&&n.jsDoc&&t===Is(n.jsDoc))return n}function yN(e){return Gr(e.parent,dg)}function Pde(e){let t=e.name.escapedText,{typeParameters:n}=e.parent.parent.parent;return n&&mr(n,i=>i.name.escapedText===t)}function k4e(e){return!!e.typeArguments}function Nde(e){let t=e.parent;for(;;){switch(t.kind){case 226:let n=t,i=n.operatorToken.kind;return D1(i)&&n.left===e?n:void 0;case 224:case 225:let s=t,o=s.operator;return o===46||o===47?s:void 0;case 249:case 250:let l=t;return l.initializer===e?l:void 0;case 217:case 209:case 230:case 235:e=t;break;case 305:e=t.parent;break;case 304:if(t.name!==e)return;e=t.parent;break;case 303:if(t.name===e)return;e=t.parent;break;default:return}t=e.parent}}function kA(e){let t=Nde(e);if(!t)return 0;switch(t.kind){case 226:let n=t.operatorToken.kind;return n===64||s6(n)?1:2;case 224:case 225:return 2;case 249:case 250:return 1}}function N0(e){return!!Nde(e)}function syt(e){let t=Do(e.right);return t.kind===226&&iQ(t.operatorToken.kind)}function eX(e){let t=Nde(e);return!!t&&lu(t,!0)&&syt(t)}function Dde(e){switch(e.kind){case 241:case 243:case 254:case 245:case 255:case 269:case 296:case 297:case 256:case 248:case 249:case 250:case 246:case 247:case 258:case 299:return!0}return!1}function Ide(e){return Xo(e)||rc(e)||vA(e)||Zl(e)||Yc(e)}function P4e(e,t){for(;e&&e.kind===t;)e=e.parent;return e}function J8(e){return P4e(e,196)}function P1(e){return P4e(e,217)}function wde(e){let t;for(;e&&e.kind===196;)t=e,e=e.parent;return[t,e]}function q8(e){for(;ox(e);)e=e.type;return e}function Do(e,t){return vl(e,t?17:1)}function tX(e){return e.kind!==211&&e.kind!==212?!1:(e=P1(e.parent),e&&e.kind===220)}function Yb(e,t){for(;e;){if(e===t)return!0;e=e.parent}return!1}function Cy(e){return!ls(e)&&!la(e)&&O_(e.parent)&&e.parent.name===e}function Hw(e){let t=e.parent;switch(e.kind){case 11:case 15:case 9:if(uo(t))return t.parent;case 80:if(O_(t))return t.name===e?t:void 0;if(pf(t)){let n=t.parent;return mg(n)&&n.name===t?n:void 0}else{let n=t.parent;return bn(n)&&al(n)!==0&&(n.left.symbol||n.symbol)&&qs(n)===e?n:void 0}case 81:return O_(t)&&t.name===e?t:void 0;default:return}}function z8(e){return id(e)&&e.parent.kind===167&&O_(e.parent.parent)}function Ode(e){let t=e.parent;switch(t.kind){case 172:case 171:case 174:case 173:case 177:case 178:case 306:case 303:case 211:return t.name===e;case 166:return t.right===e;case 208:case 276:return t.propertyName===e;case 281:case 291:case 285:case 286:case 287:return!0}return!1}function N4e(e){return e.kind===271||e.kind===270||e.kind===273&&e.name||e.kind===274||e.kind===280||e.kind===276||e.kind===281||e.kind===277&&vN(e)?!0:gn(e)&&(bn(e)&&al(e)===2&&vN(e)||Hn(e)&&bn(e.parent)&&e.parent.left===e&&e.parent.operatorToken.kind===64&&$8(e.parent.right))}function rX(e){switch(e.parent.kind){case 273:case 276:case 274:case 281:case 277:case 271:case 280:return e.parent;case 166:do e=e.parent;while(e.parent.kind===166);return rX(e)}}function $8(e){return ol(e)||wu(e)}function vN(e){let t=nX(e);return $8(t)}function nX(e){return Kc(e)?e.expression:e.right}function Rde(e){return e.kind===304?e.name:e.kind===303?e.initializer:e.parent.right}function $g(e){let t=Xb(e);if(t&&gn(e)){let n=_pe(e);if(n)return n.class}return t}function Xb(e){let t=W8(e.heritageClauses,96);return t&&t.types.length>0?t.types[0]:void 0}function SN(e){if(gn(e))return fpe(e).map(t=>t.class);{let t=W8(e.heritageClauses,119);return t?.types}}function Yw(e){return ef(e)?Xw(e)||tt:Ti(e)&&ys(_A($g(e)),SN(e))||tt}function Xw(e){let t=W8(e.heritageClauses,96);return t?t.types:void 0}function W8(e,t){if(e){for(let n of e)if(n.token===t)return n}}function ST(e,t){for(;e;){if(e.kind===t)return e;e=e.parent}}function Nf(e){return 83<=e&&e<=165}function iX(e){return 19<=e&&e<=79}function vj(e){return Nf(e)||iX(e)}function Sj(e){return 128<=e&&e<=165}function sX(e){return Nf(e)&&!Sj(e)}function D4e(e){return 119<=e&&e<=127}function PA(e){let t=Fb(e);return t!==void 0&&sX(t)}function I4e(e){let t=Fb(e);return t!==void 0&&Nf(t)}function aX(e){let t=uT(e);return!!t&&!Sj(t)}function TN(e){return 2<=e&&e<=7}function vu(e){if(!e)return 4;let t=0;switch(e.kind){case 262:case 218:case 174:e.asteriskToken&&(t|=1);case 219:ui(e,1024)&&(t|=2);break}return e.body||(t|=4),t}function Kw(e){switch(e.kind){case 262:case 218:case 219:case 174:return e.body!==void 0&&e.asteriskToken===void 0&&ui(e,1024)}return!1}function id(e){return bo(e)||_p(e)}function Tj(e){return eS(e)&&(e.operator===40||e.operator===41)&&_p(e.operand)}function Jv(e){let t=qs(e);return!!t&&bj(t)}function bj(e){if(!(e.kind===167||e.kind===212))return!1;let t=fc(e)?Do(e.argumentExpression):e.expression;return!id(t)&&!Tj(t)}function K2(e){switch(e.kind){case 80:case 81:return e.escapedText;case 11:case 15:case 9:return Pc(e.text);case 167:let t=e.expression;return id(t)?Pc(t.text):Tj(t)?t.operator===41?Sa(t.operator)+t.operand.text:t.operand.text:void 0;case 295:return FA(e);default:return I.assertNever(e)}}function Wg(e){switch(e.kind){case 80:case 11:case 15:case 9:return!0;default:return!1}}function om(e){return E0(e)?Nn(e):pg(e)?k6(e):e.text}function Qw(e){return E0(e)?e.escapedText:pg(e)?FA(e):Pc(e.text)}function w4e(e){return`__@${Ia(e)}@${e.escapedName}`}function G8(e,t){return`__#${Ia(e)}@${t}`}function H8(e){return Ss(e.escapedName,"__@")}function Mde(e){return Ss(e.escapedName,"__#")}function O4e(e){return e.kind===80&&e.escapedText==="Symbol"}function Lde(e){return ze(e)?Nn(e)==="__proto__":za(e)&&e.text==="__proto__"}function Zw(e,t){switch(e=vl(e),e.kind){case 231:if(gZ(e))return!1;break;case 218:if(e.name)return!1;break;case 219:break;default:return!1}return typeof t=="function"?t(e):!0}function oX(e){switch(e.kind){case 303:return!Lde(e.name);case 304:return!!e.objectAssignmentInitializer;case 260:return ze(e.name)&&!!e.initializer;case 169:return ze(e.name)&&!!e.initializer&&!e.dotDotDotToken;case 208:return ze(e.name)&&!!e.initializer&&!e.dotDotDotToken;case 172:return!!e.initializer;case 226:switch(e.operatorToken.kind){case 64:case 77:case 76:case 78:return ze(e.left)}break;case 277:return!0}return!1}function lp(e,t){if(!oX(e))return!1;switch(e.kind){case 303:return Zw(e.initializer,t);case 304:return Zw(e.objectAssignmentInitializer,t);case 260:case 169:case 208:case 172:return Zw(e.initializer,t);case 226:return Zw(e.right,t);case 277:return Zw(e.expression,t)}}function cX(e){return e.escapedText==="push"||e.escapedText==="unshift"}function Kb(e){return Gg(e).kind===169}function Gg(e){for(;e.kind===208;)e=e.parent.parent;return e}function lX(e){let t=e.kind;return t===176||t===218||t===262||t===219||t===174||t===177||t===178||t===267||t===312}function _c(e){return _g(e.pos)||_g(e.end)}function R4e(e){return Us(e,ls)||e}function uX(e){let t=fX(e),n=e.kind===214&&e.arguments!==void 0;return _X(e.kind,t,n)}function _X(e,t,n){switch(e){case 214:return n?0:1;case 224:case 221:case 222:case 220:case 223:case 227:case 229:return 1;case 226:switch(t){case 43:case 64:case 65:case 66:case 68:case 67:case 69:case 70:case 71:case 72:case 73:case 74:case 79:case 75:case 76:case 77:case 78:return 1}}return 0}function e6(e){let t=fX(e),n=e.kind===214&&e.arguments!==void 0;return Y8(e.kind,t,n)}function fX(e){return e.kind===226?e.operatorToken.kind:e.kind===224||e.kind===225?e.operator:e.kind}function Y8(e,t,n){switch(e){case 361:return 0;case 230:return 1;case 229:return 2;case 227:return 4;case 226:switch(t){case 28:return 0;case 64:case 65:case 66:case 68:case 67:case 69:case 70:case 71:case 72:case 73:case 74:case 79:case 75:case 76:case 77:case 78:return 3;default:return X8(t)}case 216:case 235:case 224:case 221:case 222:case 220:case 223:return 16;case 225:return 17;case 213:return 18;case 214:return n?19:18;case 215:case 211:case 212:case 236:return 19;case 234:case 238:return 11;case 110:case 108:case 80:case 81:case 106:case 112:case 97:case 9:case 10:case 11:case 209:case 210:case 218:case 219:case 231:case 14:case 15:case 228:case 217:case 232:case 284:case 285:case 288:return 20;default:return-1}}function X8(e){switch(e){case 61:return 4;case 57:return 5;case 56:return 6;case 52:return 7;case 53:return 8;case 51:return 9;case 35:case 36:case 37:case 38:return 10;case 30:case 32:case 33:case 34:case 104:case 103:case 130:case 152:return 11;case 48:case 49:case 50:return 12;case 40:case 41:return 13;case 42:case 44:case 45:return 14;case 43:return 15}return-1}function bN(e){return Fn(e,t=>{switch(t.kind){case 294:return!!t.expression;case 12:return!t.containsOnlyTriviaWhiteSpaces;default:return!0}})}function EN(){let e=[],t=[],n=new Map,i=!1;return{add:o,lookup:s,getGlobalDiagnostics:l,getDiagnostics:p};function s(m){let S;if(m.file?S=n.get(m.file.fileName):S=e,!S)return;let h=Bg(S,m,Mo,qj);if(h>=0)return S[h]}function o(m){let S;m.file?(S=n.get(m.file.fileName),S||(S=[],n.set(m.file.fileName,S),lf(t,m.file.fileName,h_))):(i&&(i=!1,e=e.slice()),S=e),lf(S,m,qj)}function l(){return i=!0,e}function p(m){if(m)return n.get(m)||[];let S=bv(t,h=>n.get(h));return e.length&&S.unshift(...e),S}}function pX(e){return e.replace(a3e,"\\${")}function Fde(e){return!!((e.templateFlags||0)&2048)}function dX(e){return e&&!!(zA(e)?Fde(e):Fde(e.head)||Tt(e.templateSpans,t=>Fde(t.literal)))}function M4e(e){return"\\u"+("0000"+e.toString(16).toUpperCase()).slice(-4)}function ayt(e,t,n){if(e.charCodeAt(0)===0){let i=n.charCodeAt(t+e.length);return i>=48&&i<=57?"\\x00":"\\0"}return u3e.get(e)||M4e(e.charCodeAt(0))}function D0(e,t){let n=t===96?l3e:t===39?c3e:o3e;return e.replace(n,ayt)}function K8(e,t){return e=D0(e,t),Gme.test(e)?e.replace(Gme,n=>M4e(n.charCodeAt(0))):e}function oyt(e){return"&#x"+e.toString(16).toUpperCase()+";"}function cyt(e){return e.charCodeAt(0)===0?"&#0;":p3e.get(e)||oyt(e.charCodeAt(0))}function mX(e,t){let n=t===39?f3e:_3e;return e.replace(n,cyt)}function cm(e){let t=e.length;return t>=2&&e.charCodeAt(0)===e.charCodeAt(t-1)&&lyt(e.charCodeAt(0))?e.substring(1,t-1):e}function lyt(e){return e===39||e===34||e===96}function xN(e){let t=e.charCodeAt(0);return t>=97&&t<=122||e.includes("-")}function Ej(e){let t=P6[1];for(let n=P6.length;n<=e;n++)P6.push(P6[n-1]+t);return P6[e]}function CN(){return P6[1].length}function Q8(e){var t,n,i,s,o,l=!1;function p(O){let U=mA(O);U.length>1?(s=s+U.length-1,o=t.length-O.length+Rs(U),i=o-t.length===0):i=!1}function m(O){O&&O.length&&(i&&(O=Ej(n)+O,i=!1),t+=O,p(O))}function S(O){O&&(l=!1),m(O)}function h(O){O&&(l=!0),m(O)}function b(){t="",n=0,i=!0,s=0,o=0,l=!1}function A(O){O!==void 0&&(t+=O,p(O),l=!1)}function k(O){O&&O.length&&S(O)}function N(O){(!i||O)&&(t+=e,s++,o=t.length,i=!0,l=!1)}function M(){return i?t.length:t.length+e.length}return b(),{write:S,rawWrite:A,writeLiteral:k,writeLine:N,increaseIndent:()=>{n++},decreaseIndent:()=>{n--},getIndent:()=>n,getTextPos:()=>t.length,getLine:()=>s,getColumn:()=>i?n*CN():t.length-o,getText:()=>t,isAtStartOfLine:()=>i,hasTrailingComment:()=>l,hasTrailingWhitespace:()=>!!t.length&&Sy(t.charCodeAt(t.length-1)),clear:b,writeKeyword:S,writeOperator:S,writeParameter:S,writeProperty:S,writePunctuation:S,writeSpace:S,writeStringLiteral:S,writeSymbol:(O,U)=>S(O),writeTrailingSemicolon:S,writeComment:h,getTextPosWithWriteLine:M}}function gX(e){let t=!1;function n(){t&&(e.writeTrailingSemicolon(";"),t=!1)}return{...e,writeTrailingSemicolon(){t=!0},writeLiteral(i){n(),e.writeLiteral(i)},writeStringLiteral(i){n(),e.writeStringLiteral(i)},writeSymbol(i,s){n(),e.writeSymbol(i,s)},writePunctuation(i){n(),e.writePunctuation(i)},writeKeyword(i){n(),e.writeKeyword(i)},writeOperator(i){n(),e.writeOperator(i)},writeParameter(i){n(),e.writeParameter(i)},writeSpace(i){n(),e.writeSpace(i)},writeProperty(i){n(),e.writeProperty(i)},writeComment(i){n(),e.writeComment(i)},writeLine(){n(),e.writeLine()},increaseIndent(){n(),e.increaseIndent()},decreaseIndent(){n(),e.decreaseIndent()}}}function AN(e){return e.useCaseSensitiveFileNames?e.useCaseSensitiveFileNames():!1}function N1(e){return y_(AN(e))}function xj(e,t,n){return t.moduleName||hX(e,t.fileName,n&&n.fileName)}function L4e(e,t){return e.getCanonicalFileName(Ps(t,e.getCurrentDirectory()))}function jde(e,t,n){let i=t.getExternalModuleFileFromDeclaration(n);if(!i||i.isDeclarationFile)return;let s=mN(n);if(!(s&&bo(s)&&!Fp(s.text)&&!L4e(e,i.path).includes(L4e(e,hu(e.getCommonSourceDirectory())))))return xj(e,i)}function hX(e,t,n){let i=m=>e.getCanonicalFileName(m),s=gc(n?hi(n):e.getCommonSourceDirectory(),e.getCurrentDirectory(),i),o=Ps(t,e.getCurrentDirectory()),l=dA(s,o,s,i,!1),p=ff(l);return n?Lb(p):p}function Bde(e,t,n){let i=t.getCompilerOptions(),s;return i.outDir?s=ff(Pj(e,t,i.outDir)):s=ff(e),s+n}function Ude(e,t){return Cj(e,t.getCompilerOptions(),t.getCurrentDirectory(),t.getCommonSourceDirectory(),n=>t.getCanonicalFileName(n))}function Cj(e,t,n,i,s){let o=t.declarationDir||t.outDir,l=o?Nj(e,o,n,i,s):e,p=Aj(l);return ff(l)+p}function Aj(e){return Ql(e,[".mjs",".mts"])?".d.mts":Ql(e,[".cjs",".cts"])?".d.cts":Ql(e,[".json"])?".d.json.ts":".d.ts"}function Vde(e){return Ql(e,[".d.mts",".mjs",".mts"])?[".mts",".mjs"]:Ql(e,[".d.cts",".cjs",".cts"])?[".cts",".cjs"]:Ql(e,[".d.json.ts"])?[".json"]:[".tsx",".ts",".jsx",".js"]}function Wo(e){return e.outFile||e.out}function kj(e,t){var n;if(e.paths)return e.baseUrl??I.checkDefined(e.pathsBasePath||((n=t.getCurrentDirectory)==null?void 0:n.call(t)),"Encountered 'paths' without a 'baseUrl', config file, or host 'getCurrentDirectory'.")}function yX(e,t,n){let i=e.getCompilerOptions();if(Wo(i)){let s=T_(i),o=i.emitDeclarationOnly||s===2||s===4;return Fn(e.getSourceFiles(),l=>(o||!Pl(l))&&Q2(l,e,n))}else{let s=t===void 0?e.getSourceFiles():[t];return Fn(s,o=>Q2(o,e,n))}}function Q2(e,t,n){let i=t.getCompilerOptions();if(i.noEmitForJsFiles&&Y_(e)||e.isDeclarationFile||t.isSourceFileFromExternalLibrary(e))return!1;if(n)return!0;if(t.isSourceOfProjectReferenceRedirect(e.fileName))return!1;if(!sm(e))return!0;if(t.getResolvedProjectReferenceToRedirect(e.fileName))return!1;if(Wo(i))return!0;if(!i.outDir)return!1;if(i.rootDir||i.composite&&i.configFilePath){let s=Ps(gO(i,()=>[],t.getCurrentDirectory(),t.getCanonicalFileName),t.getCurrentDirectory()),o=Nj(e.fileName,i.outDir,t.getCurrentDirectory(),s,t.getCanonicalFileName);if(yy(e.fileName,o,t.getCurrentDirectory(),!t.useCaseSensitiveFileNames())===0)return!1}return!0}function Pj(e,t,n){return Nj(e,n,t.getCurrentDirectory(),t.getCommonSourceDirectory(),i=>t.getCanonicalFileName(i))}function Nj(e,t,n,i,s){let o=Ps(e,n);return o=s(o).indexOf(s(i))===0?o.substring(i.length):o,li(t,o)}function t6(e,t,n,i,s,o,l){e.writeFile(n,i,s,p=>{t.add(fl(g.Could_not_write_file_0_Colon_1,n,p))},o,l)}function F4e(e,t,n){if(e.length>wh(e)&&!n(e)){let i=hi(e);F4e(i,t,n),t(e)}}function vX(e,t,n,i,s,o){try{i(e,t,n)}catch{F4e(hi(Ca(e)),s,o),i(e,t,n)}}function r6(e,t){let n=vy(e);return Ew(n,t)}function Z2(e,t){return Ew(e,t)}function I0(e){return mr(e.members,t=>Yc(t)&&nm(t.body))}function n6(e){if(e&&e.parameters.length>0){let t=e.parameters.length===2&&Zb(e.parameters[0]);return e.parameters[t?1:0]}}function Jde(e){let t=n6(e);return t&&t.type}function Qb(e){if(e.parameters.length&&!PT(e)){let t=e.parameters[0];if(Zb(t))return t}}function Zb(e){return eE(e.name)}function eE(e){return!!e&&e.kind===80&&SX(e)}function ex(e){return!!Gr(e,t=>t.kind===186?!0:t.kind===80||t.kind===166?!1:"quit")}function NA(e){if(!eE(e))return!1;for(;pf(e.parent)&&e.parent.left===e;)e=e.parent;return e.parent.kind===186}function SX(e){return e.escapedText==="this"}function tx(e,t){let n,i,s,o;return Jv(t)?(n=t,t.kind===177?s=t:t.kind===178?o=t:I.fail("Accessor has wrong kind")):Te(e,l=>{if(Mv(l)&&pa(l)===pa(t)){let p=K2(l.name),m=K2(t.name);p===m&&(n?i||(i=l):n=l,l.kind===177&&!s&&(s=l),l.kind===178&&!o&&(o=l))}}),{firstAccessor:n,secondAccessor:i,getAccessor:s,setAccessor:o}}function t_(e){if(!gn(e)&&Zl(e))return;let t=e.type;return t||!gn(e)?t:ww(e)?e.typeExpression&&e.typeExpression.type:fT(e)}function qde(e){return e.type}function lm(e){return PT(e)?e.type&&e.type.typeExpression&&e.type.typeExpression.type:e.type||(gn(e)?K3(e):void 0)}function Dj(e){return _a(pT(e),t=>uyt(t)?t.typeParameters:void 0)}function uyt(e){return dm(e)&&!(e.parent.kind===327&&(e.parent.tags.some(am)||e.parent.tags.some(YN)))}function zde(e){let t=n6(e);return t&&t_(t)}function $de(e,t,n,i){Wde(e,t,n.pos,i)}function Wde(e,t,n,i){i&&i.length&&n!==i[0].pos&&Z2(e,n)!==Z2(e,i[0].pos)&&t.writeLine()}function Gde(e,t,n,i){n!==i&&Z2(e,n)!==Z2(e,i)&&t.writeLine()}function Hde(e,t,n,i,s,o,l,p){if(i&&i.length>0){s&&n.writeSpace(" ");let m=!1;for(let S of i)m&&(n.writeSpace(" "),m=!1),p(e,t,n,S.pos,S.end,l),S.hasTrailingNewLine?n.writeLine():m=!0;m&&o&&n.writeSpace(" ")}}function Yde(e,t,n,i,s,o,l){let p,m;if(l?s.pos===0&&(p=Fn(T0(e,s.pos),S)):p=T0(e,s.pos),p){let h=[],b;for(let A of p){if(b){let k=Z2(t,b.end);if(Z2(t,A.pos)>=k+2)break}h.push(A),b=A}if(h.length){let A=Z2(t,Rs(h).end);Z2(t,Wa(e,s.pos))>=A+2&&($de(t,n,s,p),Hde(e,t,n,h,!1,!0,o,i),m={nodePos:s.pos,detachedCommentEndPos:Rs(h).end})}}return m;function S(h){return z9(e,h.pos)}}function kN(e,t,n,i,s,o){if(e.charCodeAt(i+1)===42){let l=zP(t,i),p=t.length,m;for(let S=i,h=l.line;S<s;h++){let b=h+1===p?e.length+1:t[h+1];if(S!==i){m===void 0&&(m=j4e(e,t[l.line],i));let k=n.getIndent()*CN()-m+j4e(e,S,b);if(k>0){let N=k%CN(),M=Ej((k-N)/CN());for(n.rawWrite(M);N;)n.rawWrite(" "),N--}else n.rawWrite("")}_yt(e,s,n,o,S,b),S=b}}else n.writeComment(e.substring(i,s))}function _yt(e,t,n,i,s,o){let l=Math.min(t,o-1),p=e.substring(s,l).trim();p?(n.writeComment(p),l!==t&&n.writeLine()):n.rawWrite(i)}function j4e(e,t,n){let i=0;for(;t<n&&Vg(e.charCodeAt(t));t++)e.charCodeAt(t)===9?i+=CN()-i%CN():i++;return i}function Ij(e){return X_(e)!==0}function Xde(e){return qv(e)!==0}function up(e,t){return!!DA(e,t)}function ui(e,t){return!!Kde(e,t)}function pa(e){return Du(e)&&jl(e)||Jc(e)}function jl(e){return ui(e,256)}function wj(e){return up(e,16)}function tE(e){return ui(e,64)}function TX(e){return ui(e,128)}function Hg(e){return ui(e,512)}function i6(e){return up(e,8)}function Ad(e){return ui(e,32768)}function DA(e,t){return X_(e)&t}function Kde(e,t){return qv(e)&t}function Qde(e,t,n){return e.kind>=0&&e.kind<=165?0:(e.modifierFlagsCache&536870912||(e.modifierFlagsCache=bX(e)|536870912),n||t&&gn(e)?(!(e.modifierFlagsCache&268435456)&&e.parent&&(e.modifierFlagsCache|=B4e(e)|268435456),U4e(e.modifierFlagsCache)):fyt(e.modifierFlagsCache))}function X_(e){return Qde(e,!0)}function Zde(e){return Qde(e,!0,!0)}function qv(e){return Qde(e,!1)}function B4e(e){let t=0;return e.parent&&!Ls(e)&&(gn(e)&&(ppe(e)&&(t|=8388608),dpe(e)&&(t|=16777216),mpe(e)&&(t|=33554432),gpe(e)&&(t|=67108864),hpe(e)&&(t|=134217728)),ype(e)&&(t|=65536)),t}function fyt(e){return e&65535}function U4e(e){return e&131071|(e&260046848)>>>23}function pyt(e){return U4e(B4e(e))}function eme(e){return bX(e)|pyt(e)}function bX(e){let t=Jm(e)?Yg(e.modifiers):0;return(e.flags&8||e.kind===80&&e.flags&4096)&&(t|=32),t}function Yg(e){let t=0;if(e)for(let n of e)t|=IA(n.kind);return t}function IA(e){switch(e){case 126:return 256;case 125:return 1;case 124:return 4;case 123:return 2;case 128:return 64;case 129:return 512;case 95:return 32;case 138:return 128;case 87:return 4096;case 90:return 2048;case 134:return 1024;case 148:return 8;case 164:return 16;case 103:return 8192;case 147:return 16384;case 170:return 32768}return 0}function V4e(e){return e===57||e===56}function tme(e){return V4e(e)||e===54}function s6(e){return e===76||e===77||e===78}function EX(e){return bn(e)&&s6(e.operatorToken.kind)}function Z8(e){return V4e(e)||e===61}function eR(e){return bn(e)&&Z8(e.operatorToken.kind)}function D1(e){return e>=64&&e<=79}function xX(e){let t=CX(e);return t&&!t.isImplements?t.class:void 0}function CX(e){if(L1(e)){if(ad(e.parent)&&Ti(e.parent.parent))return{class:e.parent.parent,isImplements:e.parent.token===119};if(sk(e.parent)){let t=vT(e.parent);if(t&&Ti(t))return{class:t,isImplements:!1}}}}function lu(e,t){return bn(e)&&(t?e.operatorToken.kind===64:D1(e.operatorToken.kind))&&$f(e.left)}function J4e(e){return lu(e.parent)&&e.parent.left===e}function I1(e){if(lu(e,!0)){let t=e.left.kind;return t===210||t===209}return!1}function Oj(e){return xX(e)!==void 0}function ol(e){return e.kind===80||tR(e)}function Jp(e){switch(e.kind){case 80:return e;case 166:do e=e.left;while(e.kind!==80);return e;case 211:do e=e.expression;while(e.kind!==80);return e}}function a6(e){return e.kind===80||e.kind===110||e.kind===108||e.kind===236||e.kind===211&&a6(e.expression)||e.kind===217&&a6(e.expression)}function tR(e){return Hn(e)&&ze(e.name)&&ol(e.expression)}function rR(e){if(Hn(e)){let t=rR(e.expression);if(t!==void 0)return t+"."+cp(e.name)}else if(fc(e)){let t=rR(e.expression);if(t!==void 0&&Al(e.argumentExpression))return t+"."+K2(e.argumentExpression)}else{if(ze(e))return Zi(e.escapedText);if(pg(e))return k6(e)}}function zv(e){return Hb(e)&&xy(e)==="prototype"}function o6(e){return e.parent.kind===166&&e.parent.right===e||e.parent.kind===211&&e.parent.name===e||e.parent.kind===236&&e.parent.name===e}function AX(e){return!!e.parent&&(Hn(e.parent)&&e.parent.name===e||fc(e.parent)&&e.parent.argumentExpression===e)}function rme(e){return pf(e.parent)&&e.parent.right===e||Hn(e.parent)&&e.parent.name===e||kT(e.parent)&&e.parent.right===e}function Rj(e){return bn(e)&&e.operatorToken.kind===104}function nme(e){return Rj(e.parent)&&e===e.parent.right}function kX(e){return e.kind===210&&e.properties.length===0}function ime(e){return e.kind===209&&e.elements.length===0}function PN(e){if(!(!dyt(e)||!e.declarations)){for(let t of e.declarations)if(t.localSymbol)return t.localSymbol}}function dyt(e){return e&&de(e.declarations)>0&&ui(e.declarations[0],2048)}function Mj(e){return mr(y3e,t=>Uc(e,t))}function myt(e){let t=[],n=e.length;for(let i=0;i<n;i++){let s=e.charCodeAt(i);s<128?t.push(s):s<2048?(t.push(s>>6|192),t.push(s&63|128)):s<65536?(t.push(s>>12|224),t.push(s>>6&63|128),t.push(s&63|128)):s<131072?(t.push(s>>18|240),t.push(s>>12&63|128),t.push(s>>6&63|128),t.push(s&63|128)):I.assert(!1,"Unexpected code point")}return t}function sme(e){let t="",n=myt(e),i=0,s=n.length,o,l,p,m;for(;i<s;)o=n[i]>>2,l=(n[i]&3)<<4|n[i+1]>>4,p=(n[i+1]&15)<<2|n[i+2]>>6,m=n[i+2]&63,i+1>=s?p=m=64:i+2>=s&&(m=64),t+=nx.charAt(o)+nx.charAt(l)+nx.charAt(p)+nx.charAt(m),i+=3;return t}function gyt(e){let t="",n=0,i=e.length;for(;n<i;){let s=e[n];if(s<128)t+=String.fromCharCode(s),n++;else if((s&192)===192){let o=s&63;n++;let l=e[n];for(;(l&192)===128;)o=o<<6|l&63,n++,l=e[n];t+=String.fromCharCode(o)}else t+=String.fromCharCode(s),n++}return t}function ame(e,t){return e&&e.base64encode?e.base64encode(t):sme(t)}function ome(e,t){if(e&&e.base64decode)return e.base64decode(t);let n=t.length,i=[],s=0;for(;s<n&&t.charCodeAt(s)!==nx.charCodeAt(64);){let o=nx.indexOf(t[s]),l=nx.indexOf(t[s+1]),p=nx.indexOf(t[s+2]),m=nx.indexOf(t[s+3]),S=(o&63)<<2|l>>4&3,h=(l&15)<<4|p>>2&15,b=(p&3)<<6|m&63;h===0&&p!==0?i.push(S):b===0&&m!==0?i.push(S,h):i.push(S,h,b),s+=4}return gyt(i)}function PX(e,t){let n=vs(t)?t:t.readFile(e);if(!n)return;let i=hQ(e,n);return i.error?void 0:i.config}function c6(e,t){return PX(e,t)||{}}function Lj(e){try{return JSON.parse(e)}catch{return}}function lg(e,t){return!t.directoryExists||t.directoryExists(e)}function w1(e){switch(e.newLine){case 0:return d3e;case 1:case void 0:return m3e}}function kd(e,t=e){return I.assert(t>=e||t===-1),{pos:e,end:t}}function Fj(e,t){return kd(e.pos,t)}function TT(e,t){return kd(t,e.end)}function Ay(e){let t=Jm(e)?Da(e.modifiers,n_):void 0;return t&&!_g(t.end)?TT(e,t.end):e}function Xg(e){if(ea(e)||pl(e))return TT(e,e.name.pos);let t=Jm(e)?Is(e.modifiers):void 0;return t&&!_g(t.end)?TT(e,t.end):Ay(e)}function q4e(e){return e.pos===e.end}function NX(e,t){return kd(e,e+Sa(t).length)}function rx(e,t){return lme(e,e,t)}function jj(e,t,n){return Pd(l6(e,n,!1),l6(t,n,!1),n)}function cme(e,t,n){return Pd(e.end,t.end,n)}function lme(e,t,n){return Pd(l6(e,n,!1),t.end,n)}function nR(e,t,n){return Pd(e.end,l6(t,n,!1),n)}function DX(e,t,n,i){let s=l6(t,n,i);return xw(n,e.end,s)}function z4e(e,t,n){return xw(n,e.end,t.end)}function ume(e,t){return!Pd(e.pos,e.end,t)}function Pd(e,t,n){return xw(n,e,t)===0}function l6(e,t,n){return _g(e.pos)?-1:Wa(t.text,e.pos,!1,n)}function _me(e,t,n,i){let s=Wa(n.text,e,!1,i),o=hyt(s,t,n);return xw(n,o??t,s)}function fme(e,t,n,i){let s=Wa(n.text,e,!1,i);return xw(n,e,Math.min(t,s))}function hyt(e,t=0,n){for(;e-- >t;)if(!Sy(n.text.charCodeAt(e)))return e}function IX(e){let t=Us(e);if(t)switch(t.parent.kind){case 266:case 267:return t===t.parent.name}return!1}function u6(e){return Fn(e.declarations,iR)}function iR(e){return Gi(e)&&e.initializer!==void 0}function $4e(e){return e.watch&&wo(e,"watch")}function ug(e){e.close()}function Vc(e){return e.flags&33554432?e.links.checkFlags:0}function Nd(e,t=!1){if(e.valueDeclaration){let n=t&&e.declarations&&mr(e.declarations,pp)||e.flags&32768&&mr(e.declarations,sd)||e.valueDeclaration,i=lT(n);return e.parent&&e.parent.flags&32?i:i&-8}if(Vc(e)&6){let n=e.links.checkFlags,i=n&1024?2:n&256?1:4,s=n&2048?256:0;return i|s}return e.flags&4194304?257:0}function r_(e,t){return e.flags&2097152?t.getAliasedSymbol(e):e}function NN(e){return e.exportSymbol?e.exportSymbol.flags|e.flags:e.flags}function Bj(e){return _6(e)===1}function wA(e){return _6(e)!==0}function _6(e){let{parent:t}=e;switch(t?.kind){case 217:return _6(t);case 225:case 224:let{operator:n}=t;return n===46||n===47?2:0;case 226:let{left:i,operatorToken:s}=t;return i===e&&D1(s.kind)?s.kind===64?1:2:0;case 211:return t.name!==e?0:_6(t);case 303:{let o=_6(t.parent);return e===t.name?yyt(o):o}case 304:return e===t.objectAssignmentInitializer?0:_6(t.parent);case 209:return _6(t);default:return 0}}function yyt(e){switch(e){case 0:return 1;case 1:return 0;case 2:return 2;default:return I.assertNever(e)}}function wX(e,t){if(!e||!t||Object.keys(e).length!==Object.keys(t).length)return!1;for(let n in e)if(typeof e[n]=="object"){if(!wX(e[n],t[n]))return!1}else if(typeof e[n]!="function"&&e[n]!==t[n])return!1;return!0}function Wf(e,t){e.forEach(t),e.clear()}function w0(e,t,n){let{onDeleteValue:i,onExistingValue:s}=n;e.forEach((o,l)=>{var p;t?.has(l)?s&&s(o,(p=t.get)==null?void 0:p.call(t,l),l):(e.delete(l),i(o,l))})}function f6(e,t,n){w0(e,t,n);let{createNewValue:i}=n;t?.forEach((s,o)=>{e.has(o)||e.set(o,i(o,s))})}function pme(e){if(e.flags&32){let t=ky(e);return!!t&&ui(t,64)}return!1}function ky(e){var t;return(t=e.declarations)==null?void 0:t.find(Ti)}function Gn(e){return e.flags&3899393?e.objectFlags:0}function W4e(e,t){return!!Rm(e,n=>t(n)?!0:void 0)}function Uj(e){return!!e&&!!e.declarations&&!!e.declarations[0]&&BR(e.declarations[0])}function dme({moduleSpecifier:e}){return za(e)?e.text:Fl(e)}function OX(e){let t;return Qs(e,n=>{nm(n)&&(t=n)},n=>{for(let i=n.length-1;i>=0;i--)if(nm(n[i])){t=n[i];break}}),t}function Bm(e,t,n=!0){return e.has(t)?!1:(e.set(t,n),!0)}function OA(e){return Ti(e)||ef(e)||dp(e)}function RX(e){return e>=182&&e<=205||e===133||e===159||e===150||e===163||e===151||e===136||e===154||e===155||e===116||e===157||e===146||e===141||e===233||e===319||e===320||e===321||e===322||e===323||e===324||e===325}function Yo(e){return e.kind===211||e.kind===212}function MX(e){return e.kind===211?e.name:(I.assert(e.kind===212),e.argumentExpression)}function mme(e){switch(e.kind){case"text":case"internal":return!0;default:return!1}}function Vj(e){return e.kind===275||e.kind===279}function DN(e){for(;Yo(e);)e=e.expression;return e}function gme(e,t){if(Yo(e.parent)&&AX(e))return n(e.parent);function n(i){if(i.kind===211){let s=t(i.name);if(s!==void 0)return s}else if(i.kind===212)if(ze(i.argumentExpression)||bo(i.argumentExpression)){let s=t(i.argumentExpression);if(s!==void 0)return s}else return;if(Yo(i.expression))return n(i.expression);if(ze(i.expression))return t(i.expression)}}function IN(e,t){for(;;){switch(e.kind){case 225:e=e.operand;continue;case 226:e=e.left;continue;case 227:e=e.condition;continue;case 215:e=e.tag;continue;case 213:if(t)return e;case 234:case 212:case 211:case 235:case 360:case 238:e=e.expression;continue}return e}}function vyt(e,t){this.flags=e,this.escapedName=t,this.declarations=void 0,this.valueDeclaration=void 0,this.id=0,this.mergeId=0,this.parent=void 0,this.members=void 0,this.exports=void 0,this.exportSymbol=void 0,this.constEnumOnlyModule=void 0,this.isReferenced=void 0,this.lastAssignmentPos=void 0,this.links=void 0}function Syt(e,t){this.flags=t,(I.isDebugging||mn)&&(this.checker=e)}function Tyt(e,t){this.flags=t,I.isDebugging&&(this.checker=e)}function hme(e,t,n){this.pos=t,this.end=n,this.kind=e,this.id=0,this.flags=0,this.modifierFlagsCache=0,this.transformFlags=0,this.parent=void 0,this.original=void 0,this.emitNode=void 0}function byt(e,t,n){this.pos=t,this.end=n,this.kind=e,this.id=0,this.flags=0,this.transformFlags=0,this.parent=void 0,this.emitNode=void 0}function Eyt(e,t,n){this.pos=t,this.end=n,this.kind=e,this.id=0,this.flags=0,this.transformFlags=0,this.parent=void 0,this.original=void 0,this.emitNode=void 0}function xyt(e,t,n){this.fileName=e,this.text=t,this.skipTrivia=n||(i=>i)}function yme(e){Hme.push(e),e(Ju)}function vme(e){Object.assign(Ju,e),Te(Hme,t=>t(Ju))}function O0(e,t){return e.replace(/{(\d+)}/g,(n,i)=>""+I.checkDefined(t[+i]))}function Sme(e){dB=e}function Tme(e){!dB&&e&&(dB=e())}function Gs(e){return dB&&dB[e.key]||e.message}function wN(e,t,n,i,s,...o){n+i>t.length&&(i=t.length-n),ade(t,n,i);let l=Gs(s);return Tt(o)&&(l=O0(l,o)),{file:void 0,start:n,length:i,messageText:l,category:s.category,code:s.code,reportsUnnecessary:s.reportsUnnecessary,fileName:e}}function Cyt(e){return e.file===void 0&&e.start!==void 0&&e.length!==void 0&&typeof e.fileName=="string"}function G4e(e,t){let n=t.fileName||"",i=t.text.length;I.assertEqual(e.fileName,n),I.assertLessThanOrEqual(e.start,i),I.assertLessThanOrEqual(e.start+e.length,i);let s={file:t,start:e.start,length:e.length,messageText:e.messageText,category:e.category,code:e.code,reportsUnnecessary:e.reportsUnnecessary};if(e.relatedInformation){s.relatedInformation=[];for(let o of e.relatedInformation)Cyt(o)&&o.fileName===n?(I.assertLessThanOrEqual(o.start,i),I.assertLessThanOrEqual(o.start+o.length,i),s.relatedInformation.push(G4e(o,t))):s.relatedInformation.push(o)}return s}function RA(e,t){let n=[];for(let i of e)n.push(G4e(i,t));return n}function Iu(e,t,n,i,...s){ade(e.text,t,n);let o=Gs(i);return Tt(s)&&(o=O0(o,s)),{file:e,start:t,length:n,messageText:o,category:i.category,code:i.code,reportsUnnecessary:i.reportsUnnecessary,reportsDeprecated:i.reportsDeprecated}}function LX(e,...t){let n=Gs(e);return Tt(t)&&(n=O0(n,t)),n}function fl(e,...t){let n=Gs(e);return Tt(t)&&(n=O0(n,t)),{file:void 0,start:void 0,length:void 0,messageText:n,category:e.category,code:e.code,reportsUnnecessary:e.reportsUnnecessary,reportsDeprecated:e.reportsDeprecated}}function Jj(e,t){return{file:void 0,start:void 0,length:void 0,code:e.code,category:e.category,messageText:e.next?e:e.messageText,relatedInformation:t}}function Xs(e,t,...n){let i=Gs(t);return Tt(n)&&(i=O0(i,n)),{messageText:i,category:t.category,code:t.code,next:e===void 0||Array.isArray(e)?e:[e]}}function bme(e,t){let n=e;for(;n.next;)n=n.next[0];n.next=[t]}function H4e(e){return e.file?e.file.path:void 0}function p6(e,t){return qj(e,t)||Ayt(e,t)||0}function qj(e,t){return h_(H4e(e),H4e(t))||To(e.start,t.start)||To(e.length,t.length)||To(e.code,t.code)||Y4e(e.messageText,t.messageText)||0}function Ayt(e,t){return!e.relatedInformation&&!t.relatedInformation?0:e.relatedInformation&&t.relatedInformation?To(e.relatedInformation.length,t.relatedInformation.length)||Te(e.relatedInformation,(n,i)=>{let s=t.relatedInformation[i];return p6(n,s)})||0:e.relatedInformation?-1:1}function Y4e(e,t){if(typeof e=="string"&&typeof t=="string")return h_(e,t);if(typeof e=="string")return-1;if(typeof t=="string")return 1;let n=h_(e.messageText,t.messageText);if(n)return n;if(!e.next&&!t.next)return 0;if(!e.next)return-1;if(!t.next)return 1;let i=Math.min(e.next.length,t.next.length);for(let s=0;s<i;s++)if(n=Y4e(e.next[s],t.next[s]),n)return n;return e.next.length<t.next.length?-1:e.next.length>t.next.length?1:0}function sR(e){return e===4||e===2||e===1||e===6?1:0}function X4e(e){if(e.transformFlags&2)return H_(e)||pE(e)?e:Qs(e,X4e)}function kyt(e){return e.isDeclarationFile?void 0:X4e(e)}function Pyt(e){return(e.impliedNodeFormat===99||Ql(e.fileName,[".cjs",".cts",".mjs",".mts"]))&&!e.isDeclarationFile?!0:void 0}function aR(e){switch(aK(e)){case 3:return s=>{s.externalModuleIndicator=XR(s)||!s.isDeclarationFile||void 0};case 1:return s=>{s.externalModuleIndicator=XR(s)};case 2:let t=[XR];(e.jsx===4||e.jsx===5)&&t.push(kyt),t.push(Pyt);let n=cg(...t);return s=>void(s.externalModuleIndicator=n(s))}}function b_r(e){return e}function zj(e){return e>=5&&e<=99}function $j(e){switch(T_(e)){case 0:case 4:case 3:return!1}return!0}function FX(e){return e.verbatimModuleSyntax||e.isolatedModules&&e.preserveValueImports}function Eme(e){return e.allowUnreachableCode===!1}function xme(e){return e.allowUnusedLabels===!1}function MA(e){return e>=3&&e<=99||e===100}function K_(e,t){return e[t]===void 0?!!e.strict:!!e[t]}function Cme(e){return e.useDefineForClassFields!==!1&&ho(e)>=9}function Ame(e,t){return tN(t,e,AQ)}function kme(e,t){return tN(t,e,kQ)}function Pme(e,t){return tN(t,e,PQ)}function Wj(e,t){return t.strictFlag?K_(e,t.name):t.allowJsFlag?Hv(e):e[t.name]}function Gj(e){let t=e.jsx;return t===2||t===4||t===5}function Hj(e,t){let n=t?.pragmas.get("jsximportsource"),i=os(n)?n[n.length-1]:n;return e.jsx===4||e.jsx===5||e.jsxImportSource||i?i?.arguments.factory||e.jsxImportSource||"react":void 0}function Yj(e,t){return e?`${e}/${t.jsx===5?"jsx-dev-runtime":"jsx-runtime"}`:void 0}function jX(e){let t=!1;for(let n=0;n<e.length;n++)if(e.charCodeAt(n)===42)if(!t)t=!0;else return!1;return!0}function BX(e,t){let n,i,s,o=!1;return{getSymlinkedFiles:()=>s,getSymlinkedDirectories:()=>n,getSymlinkedDirectoriesByRealpath:()=>i,setSymlinkedFile:(p,m)=>(s||(s=new Map)).set(p,m),setSymlinkedDirectory:(p,m)=>{let S=gc(p,e,t);b6(S)||(S=hu(S),m!==!1&&!n?.has(S)&&(i||(i=g_())).add(m.realPath,p),(n||(n=new Map)).set(S,m))},setSymlinksFromResolutions(p,m,S){I.assert(!o),o=!0,p(h=>l(this,h.resolvedModule)),m(h=>l(this,h.resolvedTypeReferenceDirective)),S.forEach(h=>l(this,h.resolvedTypeReferenceDirective))},hasProcessedResolutions:()=>o};function l(p,m){if(!m||!m.originalPath||!m.resolvedFileName)return;let{resolvedFileName:S,originalPath:h}=m;p.setSymlinkedFile(gc(h,e,t),S);let[b,A]=Nyt(S,h,e,t)||tt;b&&A&&p.setSymlinkedDirectory(A,{real:hu(b),realPath:hu(gc(b,e,t))})}}function Nyt(e,t,n,i){let s=gu(Ps(e,n)),o=gu(Ps(t,n)),l=!1;for(;s.length>=2&&o.length>=2&&!K4e(s[s.length-2],i)&&!K4e(o[o.length-2],i)&&i(s[s.length-1])===i(o[o.length-1]);)s.pop(),o.pop(),l=!0;return l?[Nv(s),Nv(o)]:void 0}function K4e(e,t){return e!==void 0&&(t(e)==="node_modules"||Ss(e,"@"))}function Dyt(e){return BH(e.charCodeAt(0))?e.slice(1):void 0}function UX(e,t,n){let i=kG(e,t,n);return i===void 0?void 0:Dyt(i)}function Q4e(e){return e.replace(oK,Iyt)}function Iyt(e){return"\\"+e}function d6(e,t,n){let i=Xj(e,t,n);return!i||!i.length?void 0:`^(${i.map(l=>`(${l})`).join("|")})${n==="exclude"?"($|/)":"$"}`}function Xj(e,t,n){if(!(e===void 0||e.length===0))return _a(e,i=>i&&Kj(i,t,n,uK[n]))}function VX(e){return!/[.*?]/.test(e)}function Nme(e,t,n){let i=e&&Kj(e,t,n,uK[n]);return i&&`^(${i})${n==="exclude"?"($|/)":"$"}`}function Kj(e,t,n,{singleAsteriskRegexFragment:i,doubleAsteriskRegexFragment:s,replaceWildcardCharacter:o}=uK[n]){let l="",p=!1,m=L3(e,t),S=Rs(m);if(n!=="exclude"&&S==="**")return;m[0]=sT(m[0]),VX(S)&&m.push("**","*");let h=0;for(let b of m){if(b==="**")l+=s;else if(n==="directories"&&(l+="(",h++),p&&(l+=hc),n!=="exclude"){let A="";b.charCodeAt(0)===42?(A+="([^./]"+i+")?",b=b.substr(1)):b.charCodeAt(0)===63&&(A+="[^./]",b=b.substr(1)),A+=b.replace(oK,o),A!==b&&(l+=lK),l+=A}else l+=b.replace(oK,o);p=!0}for(;h>0;)l+=")?",h--;return l}function Dme(e,t){return e==="*"?t:e==="?"?"[^/]":"\\"+e}function Qj(e,t,n,i,s){e=Ca(e),s=Ca(s);let o=li(s,e);return{includeFilePatterns:vr(Xj(n,o,"files"),l=>`^${l}$`),includeFilePattern:d6(n,o,"files"),includeDirectoryPattern:d6(n,o,"directories"),excludePattern:d6(t,o,"exclude"),basePaths:wyt(e,n,i)}}function $v(e,t){return new RegExp(e,t?"":"i")}function JX(e,t,n,i,s,o,l,p,m){e=Ca(e),o=Ca(o);let S=Qj(e,n,i,s,o),h=S.includeFilePatterns&&S.includeFilePatterns.map(U=>$v(U,s)),b=S.includeDirectoryPattern&&$v(S.includeDirectoryPattern,s),A=S.excludePattern&&$v(S.excludePattern,s),k=h?h.map(()=>[]):[[]],N=new Map,M=y_(s);for(let U of S.basePaths)O(U,li(o,U),l);return ip(k);function O(U,H,K){let re=M(m(H));if(N.has(re))return;N.set(re,!0);let{files:$,directories:pe}=p(U);for(let z of Fa($,h_)){let se=li(U,z),Se=li(H,z);if(!(t&&!Ql(se,t))&&!(A&&A.test(Se)))if(!h)k[0].push(se);else{let xe=oa(h,Z=>Z.test(Se));xe!==-1&&k[xe].push(se)}}if(!(K!==void 0&&(K--,K===0)))for(let z of Fa(pe,h_)){let se=li(U,z),Se=li(H,z);(!b||b.test(Se))&&(!A||!A.test(Se))&&O(se,Se,K)}}}function wyt(e,t,n){let i=[e];if(t){let s=[];for(let o of t){let l=ap(o)?o:Ca(li(e,o));s.push(Oyt(l))}s.sort(gy(!n));for(let o of s)yr(i,l=>!wm(l,o,e,!n))&&i.push(o)}return i}function Oyt(e){let t=v0(e,g3e);return t<0?pA(e)?sT(hi(e)):e:e.substring(0,e.lastIndexOf(hc,t))}function Zj(e,t){return t||eB(e)||3}function eB(e){switch(e.substr(e.lastIndexOf(".")).toLowerCase()){case".js":case".cjs":case".mjs":return 1;case".jsx":return 2;case".ts":case".cts":case".mts":return 3;case".tsx":return 4;case".json":return 6;default:return 0}}function m6(e,t){let n=e&&Hv(e);if(!t||t.length===0)return n?hB:FN;let i=n?hB:FN,s=ip(i);return[...i,...Wi(t,l=>l.scriptKind===7||n&&Ryt(l.scriptKind)&&!s.includes(l.extension)?[l.extension]:void 0)]}function oR(e,t){return!e||!xT(e)?t:t===hB?v3e:t===FN?h3e:[...t,[".json"]]}function Ryt(e){return e===1||e===2}function rE(e){return Tt(jN,t=>Uc(e,t))}function LA(e){return Tt(_K,t=>Uc(e,t))}function Ime({imports:e},t=cg(rE,LA)){return Ct(e,({text:n})=>Fp(n)&&!Ql(n,SR)?t(n):void 0)||!1}function wme(e,t,n,i){let s=Q_(n),o=3<=s&&s<=99;if(e==="js"||t===99&&o)return lD(n)&&l()!==2?3:2;if(e==="minimal")return 0;if(e==="index")return 1;if(!lD(n))return Ime(i)?2:0;return l();function l(){let p=!1,m=i.imports.length?i.imports:Y_(i)?Myt(i).map(S=>S.arguments[0]):tt;for(let S of m)if(Fp(S.text)){if(o&&t===1&&JZ(i,S,n)===99||Ql(S.text,SR))continue;if(LA(S.text))return 3;rE(S.text)&&(p=!0)}return p?2:0}}function Myt(e){let t=0,n;for(let i of e.statements){if(t>3)break;WY(i)?n=ys(n,i.declarationList.declarations.map(s=>s.initializer)):Ou(i)&&_f(i.expression,!0)?n=Pr(n,i.expression):t++}return n||tt}function Ome(e,t,n){if(!e)return!1;let i=m6(t,n);for(let s of ip(oR(t,i)))if(Uc(e,s))return!0;return!1}function Z4e(e){let t=e.match(/\//g);return t?t.length:0}function cR(e,t){return To(Z4e(e),Z4e(t))}function ff(e){for(let t of dK){let n=Rme(e,t);if(n!==void 0)return n}return e}function Rme(e,t){return Uc(e,t)?lR(e,t):void 0}function lR(e,t){return e.substring(0,e.length-t.length)}function bT(e,t){return F3(e,t,dK,!1)}function ON(e){let t=e.indexOf("*");return t===-1?e:e.indexOf("*",t+1)!==-1?void 0:{prefix:e.substr(0,t),suffix:e.substr(t+1)}}function tB(e){return Wi(Vt(e),t=>ON(t))}function _g(e){return!(e>=0)}function rB(e){return e===".ts"||e===".tsx"||e===".d.ts"||e===".cts"||e===".mts"||e===".d.mts"||e===".d.cts"||Ss(e,".d.")&&Mc(e,".ts")}function g6(e){return rB(e)||e===".json"}function h6(e){let t=Py(e);return t!==void 0?t:I.fail(`File ${e} has unknown extension.`)}function e3e(e){return Py(e)!==void 0}function Py(e){return mr(dK,t=>Uc(e,t))}function uR(e,t){return e.checkJsDirective?e.checkJsDirective.enabled:t.checkJs}function qX(e,t){let n=[];for(let i of e){if(i===t)return t;vs(i)||n.push(i)}return AG(n,i=>i,t)}function zX(e,t){let n=e.indexOf(t);return I.assert(n!==-1),e.slice(n)}function Ga(e,...t){return t.length&&(e.relatedInformation||(e.relatedInformation=[]),I.assert(e.relatedInformation!==tt,"Diagnostic had empty array singleton for related info, but is still being constructed!"),e.relatedInformation.push(...t)),e}function Mme(e,t){I.assert(e.length!==0);let n=t(e[0]),i=n;for(let s=1;s<e.length;s++){let o=t(e[s]);o<n?n=o:o>i&&(i=o)}return{min:n,max:i}}function $X(e){return{pos:mT(e),end:e.end}}function WX(e,t){let n=t.pos-1,i=Math.min(e.text.length,Wa(e.text,t.end)+1);return{pos:n,end:i}}function y6(e,t,n){return t.skipLibCheck&&e.isDeclarationFile||t.skipDefaultLibCheck&&e.hasNoDefaultLib||n.isSourceOfProjectReferenceRedirect(e.fileName)}function nB(e,t){return e===t||typeof e=="object"&&e!==null&&typeof t=="object"&&t!==null&&Kl(e,t,nB)}function v6(e){let t;switch(e.charCodeAt(1)){case 98:case 66:t=1;break;case 111:case 79:t=3;break;case 120:case 88:t=4;break;default:let S=e.length-1,h=0;for(;e.charCodeAt(h)===48;)h++;return e.slice(h,S)||"0"}let n=2,i=e.length-1,s=(i-n)*t,o=new Uint16Array((s>>>4)+(s&15?1:0));for(let S=i-1,h=0;S>=n;S--,h+=t){let b=h>>>4,A=e.charCodeAt(S),N=(A<=57?A-48:10+A-(A<=70?65:97))<<(h&15);o[b]|=N;let M=N>>>16;M&&(o[b+1]|=M)}let l="",p=o.length-1,m=!0;for(;m;){let S=0;m=!1;for(let h=p;h>=0;h--){let b=S<<16|o[h],A=b/10|0;o[h]=A,S=b-A*10,A&&!m&&(p=h,m=!0)}l=S+l}return l}function nE({negative:e,base10Value:t}){return(e&&t!=="0"?"-":"")+t}function Lme(e){if(iB(e,!1))return GX(e)}function GX(e){let t=e.startsWith("-"),n=v6(`${t?e.slice(1):e}n`);return{negative:t,base10Value:n}}function iB(e,t){if(e==="")return!1;let n=E1(99,!1),i=!0;n.setOnError(()=>i=!1),n.setText(e+"n");let s=n.scan(),o=s===41;o&&(s=n.scan());let l=n.getTokenFlags();return i&&s===10&&n.getTokenEnd()===e.length+1&&!(l&512)&&(!t||e===nE({negative:o,base10Value:v6(n.getTokenValue())}))}function ET(e){return!!(e.flags&33554432)||lj(e)||jyt(e)||Fyt(e)||!(k0(e)||Lyt(e))}function Lyt(e){return ze(e)&&Hf(e.parent)&&e.parent.name===e}function Fyt(e){for(;e.kind===80||e.kind===211;)e=e.parent;if(e.kind!==167)return!1;if(ui(e.parent,64))return!0;let t=e.parent.parent.kind;return t===264||t===187}function jyt(e){if(e.kind!==80)return!1;let t=Gr(e.parent,n=>{switch(n.kind){case 298:return!0;case 211:case 233:return!1;default:return"quit"}});return t?.token===119||t?.parent.kind===264}function Fme(e){return Id(e)&&ze(e.typeName)}function jme(e,t=Dm){if(e.length<2)return!0;let n=e[0];for(let i=1,s=e.length;i<s;i++){let o=e[i];if(!t(n,o))return!1}return!0}function S6(e,t){return e.pos=t,e}function RN(e,t){return e.end=t,e}function jh(e,t,n){return RN(S6(e,t),n)}function T6(e,t,n){return jh(e,t,t+n)}function Bme(e,t){return e&&(e.flags=t),e}function io(e,t){return e&&t&&(e.parent=t),e}function MN(e,t){if(e)for(let n of e)io(n,t);return e}function Wv(e,t){if(!e)return e;return Y6(e,ZP(e)?n:s),e;function n(o,l){if(t&&o.parent===l)return"skip";io(o,l)}function i(o){if(jp(o))for(let l of o.jsDoc)n(l,o),Y6(l,n)}function s(o,l){return n(o,l)||i(o)}}function Byt(e){return!Su(e)}function HX(e){return Z_(e)&&yr(e.elements,Byt)}function Ume(e){for(I.assertIsDefined(e.parent);;){let t=e.parent;if(Df(t)){e=t;continue}if(Ou(t)||ZA(t)||_x(t)&&(t.initializer===e||t.incrementor===e))return!0;if(j6(t)){if(e!==Rs(t.elements))return!0;e=t;continue}if(bn(t)&&t.operatorToken.kind===28){if(e===t.left)return!0;e=t;continue}return!1}}function b6(e){return Tt(M3,t=>e.includes(t))}function Vme(e){if(!e.parent)return;switch(e.kind){case 168:let{parent:n}=e;return n.kind===195?void 0:n.typeParameters;case 169:return e.parent.parameters;case 204:return e.parent.templateSpans;case 239:return e.parent.templateSpans;case 170:{let{parent:i}=e;return yx(i)?i.modifiers:void 0}case 298:return e.parent.heritageClauses}let{parent:t}=e;if(eN(e))return mx(e.parent)?void 0:e.parent.tags;switch(t.kind){case 187:case 264:return B2(e)?t.members:void 0;case 192:case 193:return t.types;case 189:case 209:case 361:case 275:case 279:return t.elements;case 210:case 292:return t.properties;case 213:case 214:return es(e)?t.typeArguments:t.expression===e?void 0:t.arguments;case 284:case 288:return u8(e)?t.children:void 0;case 286:case 285:return es(e)?t.typeArguments:void 0;case 241:case 296:case 297:case 268:return t.statements;case 269:return t.clauses;case 263:case 231:return Du(e)?t.members:void 0;case 266:return gE(e)?t.members:void 0;case 312:return t.statements}}function sB(e){if(!e.typeParameters){if(Tt(e.parameters,t=>!t_(t)))return!0;if(e.kind!==219){let t=qi(e.parameters);if(!(t&&Zb(t)))return!0}}return!1}function E6(e){return e==="Infinity"||e==="-Infinity"||e==="NaN"}function Jme(e){return e.kind===260&&e.parent.kind===299}function iE(e){return e.kind===218||e.kind===219}function sE(e){return e.replace(/\$/gm,()=>"\\$")}function R0(e){return(+e).toString()===e}function aB(e,t,n,i,s){let o=s&&e==="new";return!o&&nd(e,t)?j.createIdentifier(e):!i&&!o&&R0(e)&&+e>=0?j.createNumericLiteral(+e):j.createStringLiteral(e,!!n)}function x6(e){return!!(e.flags&262144&&e.isThisType)}function oB(e){let t=0,n=0,i=0,s=0,o;(S=>{S[S.BeforeNodeModules=0]="BeforeNodeModules",S[S.NodeModules=1]="NodeModules",S[S.Scope=2]="Scope",S[S.PackageContent=3]="PackageContent"})(o||(o={}));let l=0,p=0,m=0;for(;p>=0;)switch(l=p,p=e.indexOf("/",l+1),m){case 0:e.indexOf(Wh,l)===l&&(t=l,n=p,m=1);break;case 1:case 2:m===1&&e.charAt(l+1)==="@"?m=2:(i=p,m=3);break;case 3:e.indexOf(Wh,l)===l?m=1:m=3;break}return s=l,m>1?{topLevelNodeModulesIndex:t,topLevelPackageNameIndex:n,packageRootIndex:i,fileNameIndex:s}:void 0}function t3e(e){var t;return e.kind===348?(t=e.typeExpression)==null?void 0:t.type:e.type}function LN(e){switch(e.kind){case 168:case 263:case 264:case 265:case 266:case 353:case 345:case 347:return!0;case 273:return e.isTypeOnly;case 276:case 281:return e.parent.parent.isTypeOnly;default:return!1}}function _R(e){return AT(e)||Xc(e)||Zl(e)||eu(e)||ef(e)||LN(e)||hl(e)&&!qb(e)&&!zg(e)}function fR(e){if(!ww(e))return!1;let{isBracketed:t,typeExpression:n}=e;return t||!!n&&n.type.kind===323}function YX(e,t){if(e.length===0)return!1;let n=e.charCodeAt(0);return n===35?e.length>1&&b0(e.charCodeAt(1),t):b0(n,t)}function qme(e){var t;return((t=EK(e))==null?void 0:t.kind)===0}function pR(e){return gn(e)&&(e.type&&e.type.kind===323||HP(e).some(({isBracketed:t,typeExpression:n})=>t||!!n&&n.type.kind===323))}function C6(e){switch(e.kind){case 172:case 171:return!!e.questionToken;case 169:return!!e.questionToken||pR(e);case 355:case 348:return fR(e);default:return!1}}function zme(e){let t=e.kind;return(t===211||t===212)&&ek(e.expression)}function XX(e){return gn(e)&&Df(e)&&jp(e)&&!!tY(e)}function KX(e){return I.checkDefined(cB(e))}function cB(e){let t=tY(e);return t&&t.typeExpression&&t.typeExpression.type}function A6(e){return ze(e)?e.escapedText:FA(e)}function dR(e){return ze(e)?Nn(e):k6(e)}function $me(e){let t=e.kind;return t===80||t===295}function FA(e){return`${e.namespace.escapedText}:${Nn(e.name)}`}function k6(e){return`${Nn(e.namespace)}:${Nn(e.name)}`}function QX(e){return ze(e)?Nn(e):k6(e)}function um(e){return!!(e.flags&8576)}function _m(e){return e.flags&8192?e.escapedName:e.flags&384?Pc(""+e.value):I.fail()}function lB(e){return!!e&&(Hn(e)||fc(e)||bn(e))}function Wme(e){return e===void 0?!1:!!fD(e.attributes)}function jA(e,t){return S3e.call(e,"*",t)}function uB(e){return ze(e.name)?e.name.escapedText:Pc(e.name.text)}var _B,Gv,mR,fB,gR,pB,ZX,eK,r3e,n3e,tK,i3e,s3e,rK,nK,iK,sK,a3e,o3e,c3e,l3e,u3e,Gme,_3e,f3e,p3e,P6,nx,d3e,m3e,Ju,Hme,dB,Bl,ho,T_,Q_,aK,fm,Bh,ix,mB,gB,xT,Dd,aE,N6,hR,Hv,D6,oK,g3e,cK,lK,Yme,Xme,Kme,uK,FN,_K,h3e,y3e,fK,jN,hB,v3e,yR,vR,SR,pK,dK,yB,S3e,Uyt=f({"src/compiler/utilities.ts"(){"use strict";fa(),_B=[],Gv="tslib",mR=160,fB=1e6,gR=q0t(),pB=D_(()=>new Map(Object.entries({Array:new Map(Object.entries({es2015:["find","findIndex","fill","copyWithin","entries","keys","values"],es2016:["includes"],es2019:["flat","flatMap"],es2022:["at"],es2023:["findLastIndex","findLast"]})),Iterator:new Map(Object.entries({es2015:tt})),AsyncIterator:new Map(Object.entries({es2015:tt})),Atomics:new Map(Object.entries({es2017:tt})),SharedArrayBuffer:new Map(Object.entries({es2017:tt})),AsyncIterable:new Map(Object.entries({es2018:tt})),AsyncIterableIterator:new Map(Object.entries({es2018:tt})),AsyncGenerator:new Map(Object.entries({es2018:tt})),AsyncGeneratorFunction:new Map(Object.entries({es2018:tt})),RegExp:new Map(Object.entries({es2015:["flags","sticky","unicode"],es2018:["dotAll"]})),Reflect:new Map(Object.entries({es2015:["apply","construct","defineProperty","deleteProperty","get","getOwnPropertyDescriptor","getPrototypeOf","has","isExtensible","ownKeys","preventExtensions","set","setPrototypeOf"]})),ArrayConstructor:new Map(Object.entries({es2015:["from","of"]})),ObjectConstructor:new Map(Object.entries({es2015:["assign","getOwnPropertySymbols","keys","is","setPrototypeOf"],es2017:["values","entries","getOwnPropertyDescriptors"],es2019:["fromEntries"],es2022:["hasOwn"]})),NumberConstructor:new Map(Object.entries({es2015:["isFinite","isInteger","isNaN","isSafeInteger","parseFloat","parseInt"]})),Math:new Map(Object.entries({es2015:["clz32","imul","sign","log10","log2","log1p","expm1","cosh","sinh","tanh","acosh","asinh","atanh","hypot","trunc","fround","cbrt"]})),Map:new Map(Object.entries({es2015:["entries","keys","values"]})),Set:new Map(Object.entries({es2015:["entries","keys","values"]})),PromiseConstructor:new Map(Object.entries({es2015:["all","race","reject","resolve"],es2020:["allSettled"],es2021:["any"]})),Symbol:new Map(Object.entries({es2015:["for","keyFor"],es2019:["description"]})),WeakMap:new Map(Object.entries({es2015:["entries","keys","values"]})),WeakSet:new Map(Object.entries({es2015:["entries","keys","values"]})),String:new Map(Object.entries({es2015:["codePointAt","includes","endsWith","normalize","repeat","startsWith","anchor","big","blink","bold","fixed","fontcolor","fontsize","italics","link","small","strike","sub","sup"],es2017:["padStart","padEnd"],es2019:["trimStart","trimEnd","trimLeft","trimRight"],es2020:["matchAll"],es2021:["replaceAll"],es2022:["at"]})),StringConstructor:new Map(Object.entries({es2015:["fromCodePoint","raw"]})),DateTimeFormat:new Map(Object.entries({es2017:["formatToParts"]})),Promise:new Map(Object.entries({es2015:tt,es2018:["finally"]})),RegExpMatchArray:new Map(Object.entries({es2018:["groups"]})),RegExpExecArray:new Map(Object.entries({es2018:["groups"]})),Intl:new Map(Object.entries({es2018:["PluralRules"]})),NumberFormat:new Map(Object.entries({es2018:["formatToParts"]})),SymbolConstructor:new Map(Object.entries({es2020:["matchAll"]})),DataView:new Map(Object.entries({es2020:["setBigInt64","setBigUint64","getBigInt64","getBigUint64"]})),BigInt:new Map(Object.entries({es2020:tt})),RelativeTimeFormat:new Map(Object.entries({es2020:["format","formatToParts","resolvedOptions"]})),Int8Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Uint8Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Uint8ClampedArray:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Int16Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Uint16Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Int32Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Uint32Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Float32Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),Float64Array:new Map(Object.entries({es2022:["at"],es2023:["findLastIndex","findLast"]})),BigInt64Array:new Map(Object.entries({es2020:tt,es2022:["at"],es2023:["findLastIndex","findLast"]})),BigUint64Array:new Map(Object.entries({es2020:tt,es2022:["at"],es2023:["findLastIndex","findLast"]})),Error:new Map(Object.entries({es2022:["cause"]}))}))),ZX=(e=>(e[e.None=0]="None",e[e.NeverAsciiEscape=1]="NeverAsciiEscape",e[e.JsxAttributeEscape=2]="JsxAttributeEscape",e[e.TerminateUnterminatedLiterals=4]="TerminateUnterminatedLiterals",e[e.AllowNumericSeparator=8]="AllowNumericSeparator",e))(ZX||{}),eK=/^(\/\/\/\s*<reference\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/,r3e=/^(\/\/\/\s*<reference\s+types\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/,n3e=/^(\/\/\/\s*<reference\s+lib\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/,tK=/^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/,i3e=/^\/\/\/\s*<amd-module\s+.*?\/>/,s3e=/^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)(('[^']*')|("[^"]*"))\s*\/>/,rK=(e=>(e[e.None=0]="None",e[e.Definite=1]="Definite",e[e.Compound=2]="Compound",e))(rK||{}),nK=(e=>(e[e.Normal=0]="Normal",e[e.Generator=1]="Generator",e[e.Async=2]="Async",e[e.Invalid=4]="Invalid",e[e.AsyncGenerator=3]="AsyncGenerator",e))(nK||{}),iK=(e=>(e[e.Left=0]="Left",e[e.Right=1]="Right",e))(iK||{}),sK=(e=>(e[e.Comma=0]="Comma",e[e.Spread=1]="Spread",e[e.Yield=2]="Yield",e[e.Assignment=3]="Assignment",e[e.Conditional=4]="Conditional",e[e.Coalesce=4]="Coalesce",e[e.LogicalOR=5]="LogicalOR",e[e.LogicalAND=6]="LogicalAND",e[e.BitwiseOR=7]="BitwiseOR",e[e.BitwiseXOR=8]="BitwiseXOR",e[e.BitwiseAND=9]="BitwiseAND",e[e.Equality=10]="Equality",e[e.Relational=11]="Relational",e[e.Shift=12]="Shift",e[e.Additive=13]="Additive",e[e.Multiplicative=14]="Multiplicative",e[e.Exponentiation=15]="Exponentiation",e[e.Unary=16]="Unary",e[e.Update=17]="Update",e[e.LeftHandSide=18]="LeftHandSide",e[e.Member=19]="Member",e[e.Primary=20]="Primary",e[e.Highest=20]="Highest",e[e.Lowest=0]="Lowest",e[e.Invalid=-1]="Invalid",e))(sK||{}),a3e=/\$\{/g,o3e=/[\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,c3e=/[\\'\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,l3e=/\r\n|[\\`\u0000-\u001f\t\v\f\b\r\u2028\u2029\u0085]/g,u3e=new Map(Object.entries({"	":"\\t","\v":"\\v","\f":"\\f","\b":"\\b","\r":"\\r","\n":"\\n","\\":"\\\\",'"':'\\"',"'":"\\'","`":"\\`","\u2028":"\\u2028","\u2029":"\\u2029","\x85":"\\u0085","\r\n":"\\r\\n"})),Gme=/[^\u0000-\u007F]/g,_3e=/["\u0000-\u001f\u2028\u2029\u0085]/g,f3e=/['\u0000-\u001f\u2028\u2029\u0085]/g,p3e=new Map(Object.entries({'"':"&quot;","'":"&apos;"})),P6=["","    "],nx="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",d3e=`\r
`,m3e=`
`,Ju={getNodeConstructor:()=>hme,getTokenConstructor:()=>byt,getIdentifierConstructor:()=>Eyt,getPrivateIdentifierConstructor:()=>hme,getSourceFileConstructor:()=>hme,getSymbolConstructor:()=>vyt,getTypeConstructor:()=>Syt,getSignatureConstructor:()=>Tyt,getSourceMapSourceConstructor:()=>xyt},Hme=[],Bl={target:{dependencies:["module"],computeValue:e=>e.target??(e.module===100&&9||e.module===199&&99||1)},module:{dependencies:["target"],computeValue:e=>typeof e.module=="number"?e.module:Bl.target.computeValue(e)>=2?5:1},moduleResolution:{dependencies:["module","target"],computeValue:e=>{let t=e.moduleResolution;if(t===void 0)switch(Bl.module.computeValue(e)){case 1:t=2;break;case 100:t=3;break;case 199:t=99;break;case 200:t=100;break;default:t=1;break}return t}},moduleDetection:{dependencies:["module","target"],computeValue:e=>e.moduleDetection||(Bl.module.computeValue(e)===100||Bl.module.computeValue(e)===199?3:2)},isolatedModules:{dependencies:["verbatimModuleSyntax"],computeValue:e=>!!(e.isolatedModules||e.verbatimModuleSyntax)},esModuleInterop:{dependencies:["module","target"],computeValue:e=>{if(e.esModuleInterop!==void 0)return e.esModuleInterop;switch(Bl.module.computeValue(e)){case 100:case 199:case 200:return!0}return!1}},allowSyntheticDefaultImports:{dependencies:["module","target","moduleResolution"],computeValue:e=>e.allowSyntheticDefaultImports!==void 0?e.allowSyntheticDefaultImports:Bl.esModuleInterop.computeValue(e)||Bl.module.computeValue(e)===4||Bl.moduleResolution.computeValue(e)===100},resolvePackageJsonExports:{dependencies:["moduleResolution"],computeValue:e=>{let t=Bl.moduleResolution.computeValue(e);if(!MA(t))return!1;if(e.resolvePackageJsonExports!==void 0)return e.resolvePackageJsonExports;switch(t){case 3:case 99:case 100:return!0}return!1}},resolvePackageJsonImports:{dependencies:["moduleResolution","resolvePackageJsonExports"],computeValue:e=>{let t=Bl.moduleResolution.computeValue(e);if(!MA(t))return!1;if(e.resolvePackageJsonExports!==void 0)return e.resolvePackageJsonExports;switch(t){case 3:case 99:case 100:return!0}return!1}},resolveJsonModule:{dependencies:["moduleResolution","module","target"],computeValue:e=>e.resolveJsonModule!==void 0?e.resolveJsonModule:Bl.moduleResolution.computeValue(e)===100},declaration:{dependencies:["composite"],computeValue:e=>!!(e.declaration||e.composite)},preserveConstEnums:{dependencies:["isolatedModules","verbatimModuleSyntax"],computeValue:e=>!!(e.preserveConstEnums||Bl.isolatedModules.computeValue(e))},incremental:{dependencies:["composite"],computeValue:e=>!!(e.incremental||e.composite)},declarationMap:{dependencies:["declaration","composite"],computeValue:e=>!!(e.declarationMap&&Bl.declaration.computeValue(e))},allowJs:{dependencies:["checkJs"],computeValue:e=>e.allowJs===void 0?!!e.checkJs:e.allowJs},useDefineForClassFields:{dependencies:["target","module"],computeValue:e=>e.useDefineForClassFields===void 0?Bl.target.computeValue(e)>=9:e.useDefineForClassFields},noImplicitAny:{dependencies:["strict"],computeValue:e=>K_(e,"noImplicitAny")},noImplicitThis:{dependencies:["strict"],computeValue:e=>K_(e,"noImplicitThis")},strictNullChecks:{dependencies:["strict"],computeValue:e=>K_(e,"strictNullChecks")},strictFunctionTypes:{dependencies:["strict"],computeValue:e=>K_(e,"strictFunctionTypes")},strictBindCallApply:{dependencies:["strict"],computeValue:e=>K_(e,"strictBindCallApply")},strictPropertyInitialization:{dependencies:["strict"],computeValue:e=>K_(e,"strictPropertyInitialization")},alwaysStrict:{dependencies:["strict"],computeValue:e=>K_(e,"alwaysStrict")},useUnknownInCatchVariables:{dependencies:["strict"],computeValue:e=>K_(e,"useUnknownInCatchVariables")}},ho=Bl.target.computeValue,T_=Bl.module.computeValue,Q_=Bl.moduleResolution.computeValue,aK=Bl.moduleDetection.computeValue,fm=Bl.isolatedModules.computeValue,Bh=Bl.esModuleInterop.computeValue,ix=Bl.allowSyntheticDefaultImports.computeValue,mB=Bl.resolvePackageJsonExports.computeValue,gB=Bl.resolvePackageJsonImports.computeValue,xT=Bl.resolveJsonModule.computeValue,Dd=Bl.declaration.computeValue,aE=Bl.preserveConstEnums.computeValue,N6=Bl.incremental.computeValue,hR=Bl.declarationMap.computeValue,Hv=Bl.allowJs.computeValue,D6=Bl.useDefineForClassFields.computeValue,oK=/[^\w\s/]/g,g3e=[42,63],cK=["node_modules","bower_components","jspm_packages"],lK=`(?!(${cK.join("|")})(/|$))`,Yme={singleAsteriskRegexFragment:"([^./]|(\\.(?!min\\.js$))?)*",doubleAsteriskRegexFragment:`(/${lK}[^/.][^/]*)*?`,replaceWildcardCharacter:e=>Dme(e,Yme.singleAsteriskRegexFragment)},Xme={singleAsteriskRegexFragment:"[^/]*",doubleAsteriskRegexFragment:`(/${lK}[^/.][^/]*)*?`,replaceWildcardCharacter:e=>Dme(e,Xme.singleAsteriskRegexFragment)},Kme={singleAsteriskRegexFragment:"[^/]*",doubleAsteriskRegexFragment:"(/.+?)?",replaceWildcardCharacter:e=>Dme(e,Kme.singleAsteriskRegexFragment)},uK={files:Yme,directories:Xme,exclude:Kme},FN=[[".ts",".tsx",".d.ts"],[".cts",".d.cts"],[".mts",".d.mts"]],_K=ip(FN),h3e=[...FN,[".json"]],y3e=[".d.ts",".d.cts",".d.mts",".cts",".mts",".ts",".tsx"],fK=[[".js",".jsx"],[".mjs"],[".cjs"]],jN=ip(fK),hB=[[".ts",".tsx",".d.ts",".js",".jsx"],[".cts",".d.cts",".cjs"],[".mts",".d.mts",".mjs"]],v3e=[...hB,[".json"]],yR=[".d.ts",".d.cts",".d.mts"],vR=[".ts",".cts",".mts",".tsx"],SR=[".mts",".d.mts",".mjs",".cts",".d.cts",".cjs"],pK=(e=>(e[e.Minimal=0]="Minimal",e[e.Index=1]="Index",e[e.JsExtension=2]="JsExtension",e[e.TsExtension=3]="TsExtension",e))(pK||{}),dK=[".d.ts",".d.mts",".d.cts",".mjs",".mts",".cjs",".cts",".ts",".js",".tsx",".jsx",".json"],yB={files:tt,directories:tt},S3e=String.prototype.replace}});function Qme(){let e,t,n,i,s;return{createBaseSourceFileNode:o,createBaseIdentifierNode:l,createBasePrivateIdentifierNode:p,createBaseTokenNode:m,createBaseNode:S};function o(h){return new(s||(s=Ju.getSourceFileConstructor()))(h,-1,-1)}function l(h){return new(n||(n=Ju.getIdentifierConstructor()))(h,-1,-1)}function p(h){return new(i||(i=Ju.getPrivateIdentifierConstructor()))(h,-1,-1)}function m(h){return new(t||(t=Ju.getTokenConstructor()))(h,-1,-1)}function S(h){return new(e||(e=Ju.getNodeConstructor()))(h,-1,-1)}}var Vyt=f({"src/compiler/factory/baseNodeFactory.ts"(){"use strict";fa()}});function Zme(e){let t,n;return{getParenthesizeLeftSideOfBinaryForOperator:i,getParenthesizeRightSideOfBinaryForOperator:s,parenthesizeLeftSideOfBinary:S,parenthesizeRightSideOfBinary:h,parenthesizeExpressionOfComputedPropertyName:b,parenthesizeConditionOfConditionalExpression:A,parenthesizeBranchOfConditionalExpression:k,parenthesizeExpressionOfExportDefault:N,parenthesizeExpressionOfNew:M,parenthesizeLeftSideOfAccess:O,parenthesizeOperandOfPostfixUnary:U,parenthesizeOperandOfPrefixUnary:H,parenthesizeExpressionsOfCommaDelimitedList:K,parenthesizeExpressionForDisallowedComma:re,parenthesizeExpressionOfExpressionStatement:$,parenthesizeConciseBodyOfArrowFunction:pe,parenthesizeCheckTypeOfConditionalType:z,parenthesizeExtendsTypeOfConditionalType:se,parenthesizeConstituentTypesOfUnionType:xe,parenthesizeConstituentTypeOfUnionType:Se,parenthesizeConstituentTypesOfIntersectionType:Q,parenthesizeConstituentTypeOfIntersectionType:Z,parenthesizeOperandOfTypeOperator:ce,parenthesizeOperandOfReadonlyTypeOperator:ye,parenthesizeNonArrayTypeOfPostfixType:we,parenthesizeElementTypesOfTupleType:ve,parenthesizeElementTypeOfTupleType:oe,parenthesizeTypeOfOptionalType:Me,parenthesizeTypeArguments:Ie,parenthesizeLeadingTypeArgument:Ge};function i(Re){t||(t=new Map);let Ue=t.get(Re);return Ue||(Ue=kt=>S(Re,kt),t.set(Re,Ue)),Ue}function s(Re){n||(n=new Map);let Ue=n.get(Re);return Ue||(Ue=kt=>h(Re,void 0,kt),n.set(Re,Ue)),Ue}function o(Re,Ue,kt,ke){let $e=Y8(226,Re),at=_X(226,Re),$t=Mm(Ue);if(!kt&&Ue.kind===219&&$e>3)return!0;let St=e6($t);switch(To(St,$e)){case-1:return!(!kt&&at===1&&Ue.kind===229);case 1:return!1;case 0:if(kt)return at===1;if(bn($t)&&$t.operatorToken.kind===Re){if(l(Re))return!1;if(Re===40){let yt=ke?p(ke):0;if(Ow(yt)&&yt===p($t))return!1}}return uX($t)===0}}function l(Re){return Re===42||Re===52||Re===51||Re===53||Re===28}function p(Re){if(Re=Mm(Re),Ow(Re.kind))return Re.kind;if(Re.kind===226&&Re.operatorToken.kind===40){if(Re.cachedLiteralKind!==void 0)return Re.cachedLiteralKind;let Ue=p(Re.left),kt=Ow(Ue)&&Ue===p(Re.right)?Ue:0;return Re.cachedLiteralKind=kt,kt}return 0}function m(Re,Ue,kt,ke){return Mm(Ue).kind===217?Ue:o(Re,Ue,kt,ke)?e.createParenthesizedExpression(Ue):Ue}function S(Re,Ue){return m(Re,Ue,!0)}function h(Re,Ue,kt){return m(Re,kt,!1,Ue)}function b(Re){return W6(Re)?e.createParenthesizedExpression(Re):Re}function A(Re){let Ue=Y8(227,58),kt=Mm(Re),ke=e6(kt);return To(ke,Ue)!==1?e.createParenthesizedExpression(Re):Re}function k(Re){let Ue=Mm(Re);return W6(Ue)?e.createParenthesizedExpression(Re):Re}function N(Re){let Ue=Mm(Re),kt=W6(Ue);if(!kt)switch(IN(Ue,!1).kind){case 231:case 218:kt=!0}return kt?e.createParenthesizedExpression(Re):Re}function M(Re){let Ue=IN(Re,!0);switch(Ue.kind){case 213:return e.createParenthesizedExpression(Re);case 214:return Ue.arguments?Re:e.createParenthesizedExpression(Re)}return O(Re)}function O(Re,Ue){let kt=Mm(Re);return $f(kt)&&(kt.kind!==214||kt.arguments)&&(Ue||!w_(kt))?Re:ft(e.createParenthesizedExpression(Re),Re)}function U(Re){return $f(Re)?Re:ft(e.createParenthesizedExpression(Re),Re)}function H(Re){return dY(Re)?Re:ft(e.createParenthesizedExpression(Re),Re)}function K(Re){let Ue=ul(Re,re);return ft(e.createNodeArray(Ue,Re.hasTrailingComma),Re)}function re(Re){let Ue=Mm(Re),kt=e6(Ue),ke=Y8(226,28);return kt>ke?Re:ft(e.createParenthesizedExpression(Re),Re)}function $(Re){let Ue=Mm(Re);if(da(Ue)){let ke=Ue.expression,$e=Mm(ke).kind;if($e===218||$e===219){let at=e.updateCallExpression(Ue,ft(e.createParenthesizedExpression(ke),ke),Ue.typeArguments,Ue.arguments);return e.restoreOuterExpressions(Re,at,8)}}let kt=IN(Ue,!1).kind;return kt===210||kt===218?ft(e.createParenthesizedExpression(Re),Re):Re}function pe(Re){return!ra(Re)&&(W6(Re)||IN(Re,!1).kind===210)?ft(e.createParenthesizedExpression(Re),Re):Re}function z(Re){switch(Re.kind){case 184:case 185:case 194:return e.createParenthesizedType(Re)}return Re}function se(Re){switch(Re.kind){case 194:return e.createParenthesizedType(Re)}return Re}function Se(Re){switch(Re.kind){case 192:case 193:return e.createParenthesizedType(Re)}return z(Re)}function xe(Re){return e.createNodeArray(ul(Re,Se))}function Z(Re){switch(Re.kind){case 192:case 193:return e.createParenthesizedType(Re)}return Se(Re)}function Q(Re){return e.createNodeArray(ul(Re,Z))}function ce(Re){switch(Re.kind){case 193:return e.createParenthesizedType(Re)}return Z(Re)}function ye(Re){switch(Re.kind){case 198:return e.createParenthesizedType(Re)}return ce(Re)}function we(Re){switch(Re.kind){case 195:case 198:case 186:return e.createParenthesizedType(Re)}return ce(Re)}function ve(Re){return e.createNodeArray(ul(Re,oe))}function oe(Re){return Ee(Re)?e.createParenthesizedType(Re):Re}function Ee(Re){return GN(Re)?Re.postfix:JN(Re)||Vh(Re)||VN(Re)||cx(Re)?Ee(Re.type):QA(Re)?Ee(Re.falseType):Kv(Re)||KA(Re)?Ee(Rs(Re.types)):ax(Re)?!!Re.typeParameter.constraint&&Ee(Re.typeParameter.constraint):!1}function Me(Re){return Ee(Re)?e.createParenthesizedType(Re):we(Re)}function Ge(Re){return Cpe(Re)&&Re.typeParameters?e.createParenthesizedType(Re):Re}function Ae(Re,Ue){return Ue===0?Ge(Re):Re}function Ie(Re){if(Tt(Re))return e.createNodeArray(ul(Re,Ae))}}var mK,Jyt=f({"src/compiler/factory/parenthesizerRules.ts"(){"use strict";fa(),mK={getParenthesizeLeftSideOfBinaryForOperator:e=>Mo,getParenthesizeRightSideOfBinaryForOperator:e=>Mo,parenthesizeLeftSideOfBinary:(e,t)=>t,parenthesizeRightSideOfBinary:(e,t,n)=>n,parenthesizeExpressionOfComputedPropertyName:Mo,parenthesizeConditionOfConditionalExpression:Mo,parenthesizeBranchOfConditionalExpression:Mo,parenthesizeExpressionOfExportDefault:Mo,parenthesizeExpressionOfNew:e=>ta(e,$f),parenthesizeLeftSideOfAccess:e=>ta(e,$f),parenthesizeOperandOfPostfixUnary:e=>ta(e,$f),parenthesizeOperandOfPrefixUnary:e=>ta(e,dY),parenthesizeExpressionsOfCommaDelimitedList:e=>ta(e,Bb),parenthesizeExpressionForDisallowedComma:Mo,parenthesizeExpressionOfExpressionStatement:Mo,parenthesizeConciseBodyOfArrowFunction:Mo,parenthesizeCheckTypeOfConditionalType:Mo,parenthesizeExtendsTypeOfConditionalType:Mo,parenthesizeConstituentTypesOfUnionType:e=>ta(e,Bb),parenthesizeConstituentTypeOfUnionType:Mo,parenthesizeConstituentTypesOfIntersectionType:e=>ta(e,Bb),parenthesizeConstituentTypeOfIntersectionType:Mo,parenthesizeOperandOfTypeOperator:Mo,parenthesizeOperandOfReadonlyTypeOperator:Mo,parenthesizeNonArrayTypeOfPostfixType:Mo,parenthesizeElementTypesOfTupleType:e=>ta(e,Bb),parenthesizeElementTypeOfTupleType:Mo,parenthesizeTypeOfOptionalType:Mo,parenthesizeTypeArguments:e=>e&&ta(e,Bb),parenthesizeLeadingTypeArgument:Mo}}});function ege(e){return{convertToFunctionBlock:t,convertToFunctionExpression:n,convertToClassExpression:i,convertToArrayAssignmentElement:s,convertToObjectAssignmentElement:o,convertToAssignmentPattern:l,convertToObjectAssignmentPattern:p,convertToArrayAssignmentPattern:m,convertToAssignmentElementTarget:S};function t(h,b){if(ra(h))return h;let A=e.createReturnStatement(h);ft(A,h);let k=e.createBlock([A],b);return ft(k,h),k}function n(h){var b;if(!h.body)return I.fail("Cannot convert a FunctionDeclaration without a body");let A=e.createFunctionExpression((b=jb(h))==null?void 0:b.filter(k=>!WA(k)&&!tU(k)),h.asteriskToken,h.name,h.typeParameters,h.parameters,h.type,h.body);return Un(A,h),ft(A,h),I6(h)&&TB(A,!0),A}function i(h){var b;let A=e.createClassExpression((b=h.modifiers)==null?void 0:b.filter(k=>!WA(k)&&!tU(k)),h.name,h.typeParameters,h.heritageClauses,h.members);return Un(A,h),ft(A,h),I6(h)&&TB(A,!0),A}function s(h){if(co(h)){if(h.dotDotDotToken)return I.assertNode(h.name,ze),Un(ft(e.createSpreadElement(h.name),h),h);let b=S(h.name);return h.initializer?Un(ft(e.createAssignment(b,h.initializer),h),h):b}return ta(h,bt)}function o(h){if(co(h)){if(h.dotDotDotToken)return I.assertNode(h.name,ze),Un(ft(e.createSpreadAssignment(h.name),h),h);if(h.propertyName){let b=S(h.name);return Un(ft(e.createPropertyAssignment(h.propertyName,h.initializer?e.createAssignment(b,h.initializer):b),h),h)}return I.assertNode(h.name,ze),Un(ft(e.createShorthandPropertyAssignment(h.name,h.initializer),h),h)}return ta(h,by)}function l(h){switch(h.kind){case 207:case 209:return m(h);case 206:case 210:return p(h)}}function p(h){return pm(h)?Un(ft(e.createObjectLiteralExpression(vr(h.elements,o)),h),h):ta(h,Ha)}function m(h){return cE(h)?Un(ft(e.createArrayLiteralExpression(vr(h.elements,s)),h),h):ta(h,Z_)}function S(h){return la(h)?l(h):ta(h,bt)}}var gK,qyt=f({"src/compiler/factory/nodeConverters.ts"(){"use strict";fa(),gK={convertToFunctionBlock:Ks,convertToFunctionExpression:Ks,convertToClassExpression:Ks,convertToArrayAssignmentElement:Ks,convertToObjectAssignmentElement:Ks,convertToAssignmentPattern:Ks,convertToObjectAssignmentPattern:Ks,convertToArrayAssignmentPattern:Ks,convertToAssignmentElementTarget:Ks}}});function T3e(e){rge.push(e)}function TR(e,t){let n=e&8?Mo:Un,i=D_(()=>e&1?mK:Zme(U)),s=D_(()=>e&2?gK:ege(U)),o=Nm(E=>(R,q)=>Pe(R,E,q)),l=Nm(E=>R=>ct(E,R)),p=Nm(E=>R=>Gt(R,E)),m=Nm(E=>()=>rI(E)),S=Nm(E=>R=>$x(E,R)),h=Nm(E=>(R,q)=>BE(E,R,q)),b=Nm(E=>(R,q)=>nI(E,R,q)),A=Nm(E=>(R,q)=>pc(E,R,q)),k=Nm(E=>(R,q)=>ZT(E,R,q)),N=Nm(E=>(R,q,fe)=>Bd(E,R,q,fe)),M=Nm(E=>(R,q,fe)=>TS(E,R,q,fe)),O=Nm(E=>(R,q,fe,Qe)=>bS(E,R,q,fe,Qe)),U={get parenthesizer(){return i()},get converters(){return s()},baseFactory:t,flags:e,createNodeArray:H,createNumericLiteral:pe,createBigIntLiteral:z,createStringLiteral:Se,createStringLiteralFromNode:xe,createRegularExpressionLiteral:Z,createLiteralLikeNode:Q,createIdentifier:we,createTempVariable:ve,createLoopVariable:oe,createUniqueName:Ee,getGeneratedNameForNode:Me,createPrivateIdentifier:Ae,createUniquePrivateName:Re,getGeneratedPrivateNameForNode:Ue,createToken:ke,createSuper:$e,createThis:at,createNull:$t,createTrue:St,createFalse:Ze,createModifier:yt,createModifiersFromModifierFlags:ar,createQualifiedName:or,updateQualifiedName:Fr,createComputedPropertyName:rn,updateComputedPropertyName:Tr,createTypeParameterDeclaration:nr,updateTypeParameterDeclaration:tr,createParameterDeclaration:ki,updateParameterDeclaration:xs,createDecorator:zi,updateDecorator:Ms,createPropertySignature:un,updatePropertySignature:ri,createPropertyDeclaration:_r,updatePropertyDeclaration:rt,createMethodSignature:zt,updateMethodSignature:Rr,createMethodDeclaration:vi,updateMethodDeclaration:Ni,createConstructorDeclaration:Nr,updateConstructorDeclaration:qr,createGetAccessorDeclaration:mt,updateGetAccessorDeclaration:dt,createSetAccessorDeclaration:_e,updateSetAccessorDeclaration:Ve,createCallSignature:W,updateCallSignature:st,createConstructSignature:Nt,updateConstructSignature:Ke,createIndexSignature:ht,updateIndexSignature:Wt,createClassStaticBlockDeclaration:Fs,updateClassStaticBlockDeclaration:Ta,createTemplateLiteralTypeSpan:Cr,updateTemplateLiteralTypeSpan:hr,createKeywordTypeNode:Sr,createTypePredicateNode:Y,updateTypePredicateNode:Be,createTypeReferenceNode:Lt,updateTypeReferenceNode:B,createFunctionTypeNode:le,updateFunctionTypeNode:X,createConstructorTypeNode:qe,updateConstructorTypeNode:Rt,createTypeQueryNode:zr,updateTypeQueryNode:Yr,createTypeLiteralNode:Pi,updateTypeLiteralNode:Fi,createArrayTypeNode:fn,updateArrayTypeNode:Qn,createTupleTypeNode:Ns,updateTupleTypeNode:Vi,createNamedTupleMember:ji,updateNamedTupleMember:ni,createOptionalTypeNode:js,updateOptionalTypeNode:Mr,createRestTypeNode:Qo,updateRestTypeNode:Sl,createUnionTypeNode:nc,updateUnionTypeNode:Dc,createIntersectionTypeNode:zu,updateIntersectionTypeNode:ks,createConditionalTypeNode:ya,updateConditionalTypeNode:$u,createInferTypeNode:Uo,updateInferTypeNode:$a,createImportTypeNode:Nl,updateImportTypeNode:zc,createParenthesizedType:Tc,updateParenthesizedType:$s,createThisTypeNode:cr,createTypeOperatorNode:ic,updateTypeOperatorNode:Mu,createIndexedAccessTypeNode:Wu,updateIndexedAccessTypeNode:yp,createMappedTypeNode:Go,updateMappedTypeNode:ru,createLiteralTypeNode:ge,updateLiteralTypeNode:ne,createTemplateLiteralType:Ac,updateTemplateLiteralType:Ld,createObjectBindingPattern:je,updateObjectBindingPattern:Et,createArrayBindingPattern:gr,updateArrayBindingPattern:Dn,createBindingElement:xn,updateBindingElement:Zn,createArrayLiteralExpression:Bi,updateArrayLiteralExpression:Jn,createObjectLiteralExpression:ia,updateObjectLiteralExpression:Fc,createPropertyAccessExpression:e&4?(E,R)=>Sn(sc(E,R),262144):sc,updatePropertyAccessExpression:Jl,createPropertyAccessChain:e&4?(E,R,q)=>Sn(jo(E,R,q),262144):jo,updatePropertyAccessChain:Eu,createElementAccessExpression:pu,updateElementAccessExpression:gm,createElementAccessChain:tf,updateElementAccessChain:Oe,createCallExpression:Zr,updateCallExpression:Ds,createCallChain:sa,updateCallChain:ua,createNewExpression:Tl,updateNewExpression:ql,createTaggedTemplateExpression:bc,updateTaggedTemplateExpression:Ic,createTypeAssertion:cl,updateTypeAssertion:bl,createParenthesizedExpression:xu,updateParenthesizedExpression:dd,createFunctionExpression:wf,updateFunctionExpression:hf,createArrowFunction:Fd,updateArrowFunction:ch,createDeleteExpression:Yh,updateDeleteExpression:Ly,createTypeOfExpression:A_,updateTypeOfExpression:Fy,createVoidExpression:vp,updateVoidExpression:U0,createAwaitExpression:Of,updateAwaitExpression:ie,createPrefixUnaryExpression:ct,updatePrefixUnaryExpression:Jt,createPostfixUnaryExpression:Gt,updatePostfixUnaryExpression:V,createBinaryExpression:Pe,updateBinaryExpression:Yt,createConditionalExpression:_n,updateConditionalExpression:gi,createTemplateExpression:ci,updateTemplateExpression:ds,createTemplateHead:Sp,createTemplateMiddle:Rf,createTemplateTail:_S,createNoSubstitutionTemplateLiteral:xo,createTemplateLiteralLikeNode:nu,createYieldExpression:Wm,updateYieldExpression:Gm,createSpreadElement:ts,updateSpreadElement:jy,createClassExpression:H1,updateClassExpression:Hm,createOmittedExpression:wE,createExpressionWithTypeArguments:OE,updateExpressionWithTypeArguments:md,createAsExpression:lh,updateAsExpression:gd,createNonNullExpression:By,updateNonNullExpression:Je,createSatisfiesExpression:et,updateSatisfiesExpression:Ft,createNonNullChain:Ht,updateNonNullChain:Er,createMetaProperty:nn,updateMetaProperty:br,createTemplateSpan:sn,updateTemplateSpan:Ci,createSemicolonClassElement:hn,createBlock:mi,updateBlock:Tn,createVariableStatement:aa,updateVariableStatement:ao,createEmptyStatement:B_,createExpressionStatement:Hu,updateExpressionStatement:Uy,createIfStatement:qT,updateIfStatement:Rk,createDoStatement:zT,updateDoStatement:HD,createWhileStatement:YD,updateWhileStatement:XD,createForStatement:Lx,updateForStatement:RE,createForInStatement:Mk,updateForInStatement:KD,createForOfStatement:Lk,updateForOfStatement:Fk,createContinueStatement:jk,updateContinueStatement:Bk,createBreakStatement:Fx,updateBreakStatement:Uk,createReturnStatement:ME,updateReturnStatement:LE,createWithStatement:fS,updateWithStatement:pS,createSwitchStatement:V0,updateSwitchStatement:$T,createLabeledStatement:fo,updateLabeledStatement:jx,createThrowStatement:QD,updateThrowStatement:WT,createTryStatement:Vy,updateTryStatement:Xh,createDebuggerStatement:jd,createVariableDeclaration:Mf,updateVariableDeclaration:Tp,createVariableDeclarationList:Kf,updateVariableDeclarationList:Y1,createFunctionDeclaration:Bx,updateFunctionDeclaration:ZD,createClassDeclaration:dS,updateClassDeclaration:GT,createInterfaceDeclaration:Jk,updateInterfaceDeclaration:zl,createTypeAliasDeclaration:X1,updateTypeAliasDeclaration:qk,createEnumDeclaration:yg,updateEnumDeclaration:Ux,createModuleDeclaration:He,updateModuleDeclaration:vg,createModuleBlock:Yu,updateModuleBlock:HT,createCaseBlock:zk,updateCaseBlock:mS,createNamespaceExportDeclaration:K1,updateNamespaceExportDeclaration:Q1,createImportEqualsDeclaration:oo,updateImportEqualsDeclaration:Sg,createImportDeclaration:Vx,updateImportDeclaration:Jx,createImportClause:YT,updateImportClause:qx,createAssertClause:hm,updateAssertClause:ym,createAssertEntry:Jy,updateAssertEntry:$k,createImportTypeAssertionContainer:Tg,updateImportTypeAssertionContainer:eI,createImportAttributes:FE,updateImportAttributes:as,createImportAttribute:_i,updateImportAttribute:Kh,createNamespaceImport:Lf,updateNamespaceImport:KO,createNamespaceExport:qy,updateNamespaceExport:QO,createNamedImports:gS,updateNamedImports:wc,createImportSpecifier:zp,updateImportSpecifier:J0,createExportAssignment:vm,updateExportAssignment:hS,createExportDeclaration:Ym,updateExportDeclaration:zy,createNamedExports:zx,updateNamedExports:q0,createExportSpecifier:Wk,updateExportSpecifier:z0,createMissingDeclaration:uh,createExternalModuleReference:Z1,updateExternalModuleReference:tI,get createJSDocAllType(){return m(319)},get createJSDocUnknownType(){return m(320)},get createJSDocNonNullableType(){return b(322)},get updateJSDocNonNullableType(){return A(322)},get createJSDocNullableType(){return b(321)},get updateJSDocNullableType(){return A(321)},get createJSDocOptionalType(){return S(323)},get updateJSDocOptionalType(){return h(323)},get createJSDocVariadicType(){return S(325)},get updateJSDocVariadicType(){return h(325)},get createJSDocNamepathType(){return S(326)},get updateJSDocNamepathType(){return h(326)},createJSDocFunctionType:Wx,updateJSDocFunctionType:Xm,createJSDocTypeLiteral:yS,updateJSDocTypeLiteral:iI,createJSDocTypeExpression:Gx,updateJSDocTypeExpression:ZO,createJSDocSignature:Cn,updateJSDocSignature:Lu,createJSDocTemplateTag:_h,updateJSDocTemplateTag:yn,createJSDocTypedefTag:Hx,updateJSDocTypedefTag:XT,createJSDocParameterTag:Cu,updateJSDocParameterTag:Qh,createJSDocPropertyTag:Km,updateJSDocPropertyTag:UE,createJSDocCallbackTag:VE,updateJSDocCallbackTag:vS,createJSDocOverloadTag:$y,updateJSDocOverloadTag:Yx,createJSDocAugmentsTag:Qm,updateJSDocAugmentsTag:KT,createJSDocImplementsTag:$0,updateJSDocImplementsTag:Qf,createJSDocSeeTag:SS,updateJSDocSeeTag:Gk,createJSDocNameReference:QT,updateJSDocNameReference:sI,createJSDocMemberName:JE,updateJSDocMemberName:Xx,createJSDocLink:$p,updateJSDocLink:Kx,createJSDocLinkCode:ll,updateJSDocLinkCode:du,createJSDocLinkPlain:Qx,updateJSDocLinkPlain:a_,get createJSDocTypeTag(){return M(351)},get updateJSDocTypeTag(){return O(351)},get createJSDocReturnTag(){return M(349)},get updateJSDocReturnTag(){return O(349)},get createJSDocThisTag(){return M(350)},get updateJSDocThisTag(){return O(350)},get createJSDocAuthorTag(){return k(337)},get updateJSDocAuthorTag(){return N(337)},get createJSDocClassTag(){return k(339)},get updateJSDocClassTag(){return N(339)},get createJSDocPublicTag(){return k(340)},get updateJSDocPublicTag(){return N(340)},get createJSDocPrivateTag(){return k(341)},get updateJSDocPrivateTag(){return N(341)},get createJSDocProtectedTag(){return k(342)},get updateJSDocProtectedTag(){return N(342)},get createJSDocReadonlyTag(){return k(343)},get updateJSDocReadonlyTag(){return N(343)},get createJSDocOverrideTag(){return k(344)},get updateJSDocOverrideTag(){return N(344)},get createJSDocDeprecatedTag(){return k(338)},get updateJSDocDeprecatedTag(){return N(338)},get createJSDocThrowsTag(){return M(356)},get updateJSDocThrowsTag(){return O(356)},get createJSDocSatisfiesTag(){return M(357)},get updateJSDocSatisfiesTag(){return O(357)},createJSDocEnumTag:Wp,updateJSDocEnumTag:Zx,createJSDocUnknownTag:Fu,updateJSDocUnknownTag:Hk,createJSDocText:eC,updateJSDocText:ac,createJSDocComment:aI,updateJSDocComment:eb,createJsxElement:qE,updateJsxElement:e4,createJsxSelfClosingElement:rf,updateJsxSelfClosingElement:Wy,createJsxOpeningElement:fh,updateJsxOpeningElement:Yk,createJsxClosingElement:bp,updateJsxClosingElement:Xk,createJsxFragment:Zf,createJsxText:tv,updateJsxText:tC,createJsxOpeningFragment:oI,createJsxJsxClosingFragment:cI,updateJsxFragment:Kk,createJsxAttribute:rC,updateJsxAttribute:lI,createJsxAttributes:ES,updateJsxAttributes:Ep,createJsxSpreadAttribute:Zh,updateJsxSpreadAttribute:uI,createJsxExpression:nC,updateJsxExpression:mo,createJsxNamespacedName:Rn,updateJsxNamespacedName:yd,createCaseClause:yf,updateCaseClause:zE,createDefaultClause:_I,updateDefaultClause:tb,createHeritageClause:$E,updateHeritageClause:iC,createCatchClause:W0,updateCatchClause:bg,createPropertyAssignment:vd,updatePropertyAssignment:Zm,createShorthandPropertyAssignment:G0,updateShorthandPropertyAssignment:H0,createSpreadAssignment:Dl,updateSpreadAssignment:fI,createEnumMember:Ud,updateEnumMember:e0,createSourceFile:Sd,updateSourceFile:Ho,createRedirectedSourceFile:WE,createBundle:GE,updateBundle:HE,createUnparsedSource:Hy,createUnparsedPrologue:nb,createUnparsedPrepend:D,createUnparsedTextLike:ue,createUnparsedSyntheticReference:gt,createInputFiles:lr,createSyntheticExpression:Wn,createSyntaxList:$i,createNotEmittedStatement:Di,createPartiallyEmittedExpression:fs,updatePartiallyEmittedExpression:Aa,createCommaListExpression:vf,updateCommaListExpression:Vd,createSyntheticReferenceExpression:CS,updateSyntheticReferenceExpression:Oi,cloneNode:kS,get createComma(){return o(28)},get createAssignment(){return o(64)},get createLogicalOr(){return o(57)},get createLogicalAnd(){return o(56)},get createBitwiseOr(){return o(52)},get createBitwiseXor(){return o(53)},get createBitwiseAnd(){return o(51)},get createStrictEquality(){return o(37)},get createStrictInequality(){return o(38)},get createEquality(){return o(35)},get createInequality(){return o(36)},get createLessThan(){return o(30)},get createLessThanEquals(){return o(33)},get createGreaterThan(){return o(32)},get createGreaterThanEquals(){return o(34)},get createLeftShift(){return o(48)},get createRightShift(){return o(49)},get createUnsignedRightShift(){return o(50)},get createAdd(){return o(40)},get createSubtract(){return o(41)},get createMultiply(){return o(42)},get createDivide(){return o(44)},get createModulo(){return o(45)},get createExponent(){return o(43)},get createPrefixPlus(){return l(40)},get createPrefixMinus(){return l(41)},get createPrefixIncrement(){return l(46)},get createPrefixDecrement(){return l(47)},get createBitwiseNot(){return l(55)},get createLogicalNot(){return l(54)},get createPostfixIncrement(){return p(46)},get createPostfixDecrement(){return p(47)},createImmediatelyInvokedFunctionExpression:aC,createImmediatelyInvokedArrowFunction:YE,createVoidZero:ph,createExportDefault:r0,createExternalModuleExport:pI,createTypeCheck:oC,createIsNotTypeCheck:uz,createMethodCall:PS,createGlobalMethodCall:Eg,createFunctionBindCall:lL,createFunctionCallCall:uL,createFunctionApplyCall:ib,createArraySliceCall:t4,createArrayConcatCall:n0,createObjectDefinePropertyCall:tP,createObjectGetOwnPropertyDescriptorCall:_L,createReflectGetCall:dh,createReflectSetCall:te,createPropertyDescriptor:Xe,createCallBinding:Ui,createAssignmentTargetWrapper:Ai,inlineExpressions:cs,getInternalName:zo,getLocalName:_o,getExportName:Jd,getDeclarationName:mh,getNamespaceMemberName:Y0,getExternalModuleOrNamespaceExportName:Yy,restoreOuterExpressions:Xt,restoreEnclosingLabel:Yn,createUseStrictPrologue:ep,copyPrologue:Xy,copyStandardPrologue:cC,copyCustomPrologue:dI,ensureUseStrict:r4,liftToBlock:n4,mergeLexicalEnvironment:Ky,replaceModifiers:DS,replaceDecoratorsAndModifiers:mI,replacePropertyName:Gp};return Te(rge,E=>E(U)),U;function H(E,R){if(E===void 0||E===tt)E=[];else if(Bb(E)){if(R===void 0||E.hasTrailingComma===R)return E.transformFlags===void 0&&b3e(E),I.attachNodeArrayDebugInfo(E),E;let Qe=E.slice();return Qe.pos=E.pos,Qe.end=E.end,Qe.hasTrailingComma=R,Qe.transformFlags=E.transformFlags,I.attachNodeArrayDebugInfo(Qe),Qe}let q=E.length,fe=q>=1&&q<=4?E.slice():E;return fe.pos=-1,fe.end=-1,fe.hasTrailingComma=!!R,fe.transformFlags=0,b3e(fe),I.attachNodeArrayDebugInfo(fe),fe}function K(E){return t.createBaseNode(E)}function re(E){let R=K(E);return R.symbol=void 0,R.localSymbol=void 0,R}function $(E,R){return E!==R&&(E.typeArguments=R.typeArguments),pn(E,R)}function pe(E,R=0){let q=typeof E=="number"?E+"":E;I.assert(q.charCodeAt(0)!==45,"Negative numbers should be created in combination with createPrefixUnaryExpression");let fe=re(9);return fe.text=q,fe.numericLiteralFlags=R,R&384&&(fe.transformFlags|=1024),fe}function z(E){let R=kt(10);return R.text=typeof E=="string"?E:nE(E)+"n",R.transformFlags|=32,R}function se(E,R){let q=re(11);return q.text=E,q.singleQuote=R,q}function Se(E,R,q){let fe=se(E,R);return fe.hasExtendedUnicodeEscape=q,q&&(fe.transformFlags|=1024),fe}function xe(E){let R=se(om(E),void 0);return R.textSourceNode=E,R}function Z(E){let R=kt(14);return R.text=E,R}function Q(E,R){switch(E){case 9:return pe(R,0);case 10:return z(R);case 11:return Se(R,void 0);case 12:return tv(R,!1);case 13:return tv(R,!0);case 14:return Z(R);case 15:return nu(E,R,void 0,0)}}function ce(E){let R=t.createBaseIdentifierNode(80);return R.escapedText=E,R.jsDoc=void 0,R.flowNode=void 0,R.symbol=void 0,R}function ye(E,R,q,fe){let Qe=ce(Pc(E));return kR(Qe,{flags:R,id:SB,prefix:q,suffix:fe}),SB++,Qe}function we(E,R,q){R===void 0&&E&&(R=Fb(E)),R===80&&(R=void 0);let fe=ce(Pc(E));return q&&(fe.flags|=256),fe.escapedText==="await"&&(fe.transformFlags|=67108864),fe.flags&256&&(fe.transformFlags|=1024),fe}function ve(E,R,q,fe){let Qe=1;R&&(Qe|=8);let Qt=ye("",Qe,q,fe);return E&&E(Qt),Qt}function oe(E){let R=2;return E&&(R|=8),ye("",R,void 0,void 0)}function Ee(E,R=0,q,fe){return I.assert(!(R&7),"Argument out of range: flags"),I.assert((R&48)!==32,"GeneratedIdentifierFlags.FileLevel cannot be set without also setting GeneratedIdentifierFlags.Optimistic"),ye(E,3|R,q,fe)}function Me(E,R=0,q,fe){I.assert(!(R&7),"Argument out of range: flags");let Qe=E?E0(E)?NT(!1,q,E,fe,Nn):`generated@${yo(E)}`:"";(q||fe)&&(R|=16);let Qt=ye(Qe,4|R,q,fe);return Qt.original=E,Qt}function Ge(E){let R=t.createBasePrivateIdentifierNode(81);return R.escapedText=E,R.transformFlags|=16777216,R}function Ae(E){return Ss(E,"#")||I.fail("First character of private identifier must be #: "+E),Ge(Pc(E))}function Ie(E,R,q,fe){let Qe=Ge(Pc(E));return kR(Qe,{flags:R,id:SB,prefix:q,suffix:fe}),SB++,Qe}function Re(E,R,q){E&&!Ss(E,"#")&&I.fail("First character of private identifier must be #: "+E);let fe=8|(E?3:1);return Ie(E??"",fe,R,q)}function Ue(E,R,q){let fe=E0(E)?NT(!0,R,E,q,Nn):`#generated@${yo(E)}`,Qt=Ie(fe,4|(R||q?16:0),R,q);return Qt.original=E,Qt}function kt(E){return t.createBaseTokenNode(E)}function ke(E){I.assert(E>=0&&E<=165,"Invalid token"),I.assert(E<=15||E>=18,"Invalid token. Use 'createTemplateLiteralLikeNode' to create template literals."),I.assert(E<=9||E>=15,"Invalid token. Use 'createLiteralLikeNode' to create literals."),I.assert(E!==80,"Invalid token. Use 'createIdentifier' to create identifiers");let R=kt(E),q=0;switch(E){case 134:q=384;break;case 160:q=4;break;case 125:case 123:case 124:case 148:case 128:case 138:case 87:case 133:case 150:case 163:case 146:case 151:case 103:case 147:case 164:case 154:case 136:case 155:case 116:case 159:case 157:q=1;break;case 108:q=134218752,R.flowNode=void 0;break;case 126:q=1024;break;case 129:q=16777216;break;case 110:q=16384,R.flowNode=void 0;break}return q&&(R.transformFlags|=q),R}function $e(){return ke(108)}function at(){return ke(110)}function $t(){return ke(106)}function St(){return ke(112)}function Ze(){return ke(97)}function yt(E){return ke(E)}function ar(E){let R=[];return E&32&&R.push(yt(95)),E&128&&R.push(yt(138)),E&2048&&R.push(yt(90)),E&4096&&R.push(yt(87)),E&1&&R.push(yt(125)),E&2&&R.push(yt(123)),E&4&&R.push(yt(124)),E&64&&R.push(yt(128)),E&256&&R.push(yt(126)),E&16&&R.push(yt(164)),E&8&&R.push(yt(148)),E&512&&R.push(yt(129)),E&1024&&R.push(yt(134)),E&8192&&R.push(yt(103)),E&16384&&R.push(yt(147)),R.length?R:void 0}function or(E,R){let q=K(166);return q.left=E,q.right=Il(R),q.transformFlags|=wn(q.left)|bR(q.right),q.flowNode=void 0,q}function Fr(E,R,q){return E.left!==R||E.right!==q?pn(or(R,q),E):E}function rn(E){let R=K(167);return R.expression=i().parenthesizeExpressionOfComputedPropertyName(E),R.transformFlags|=wn(R.expression)|1024|131072,R}function Tr(E,R){return E.expression!==R?pn(rn(R),E):E}function nr(E,R,q,fe){let Qe=re(168);return Qe.modifiers=ro(E),Qe.name=Il(R),Qe.constraint=q,Qe.default=fe,Qe.transformFlags=1,Qe.expression=void 0,Qe.jsDoc=void 0,Qe}function tr(E,R,q,fe,Qe){return E.modifiers!==R||E.name!==q||E.constraint!==fe||E.default!==Qe?pn(nr(R,q,fe,Qe),E):E}function ki(E,R,q,fe,Qe,Qt){let kn=re(169);return kn.modifiers=ro(E),kn.dotDotDotToken=R,kn.name=Il(q),kn.questionToken=fe,kn.type=Qe,kn.initializer=rP(Qt),eE(kn.name)?kn.transformFlags=1:kn.transformFlags=so(kn.modifiers)|wn(kn.dotDotDotToken)|Yv(kn.name)|wn(kn.questionToken)|wn(kn.initializer)|(kn.questionToken??kn.type?1:0)|(kn.dotDotDotToken??kn.initializer?1024:0)|(Yg(kn.modifiers)&31?8192:0),kn.jsDoc=void 0,kn}function xs(E,R,q,fe,Qe,Qt,kn){return E.modifiers!==R||E.dotDotDotToken!==q||E.name!==fe||E.questionToken!==Qe||E.type!==Qt||E.initializer!==kn?pn(ki(R,q,fe,Qe,Qt,kn),E):E}function zi(E){let R=K(170);return R.expression=i().parenthesizeLeftSideOfAccess(E,!1),R.transformFlags|=wn(R.expression)|1|8192|33554432,R}function Ms(E,R){return E.expression!==R?pn(zi(R),E):E}function un(E,R,q,fe){let Qe=re(171);return Qe.modifiers=ro(E),Qe.name=Il(R),Qe.type=fe,Qe.questionToken=q,Qe.transformFlags=1,Qe.initializer=void 0,Qe.jsDoc=void 0,Qe}function ri(E,R,q,fe,Qe){return E.modifiers!==R||E.name!==q||E.questionToken!==fe||E.type!==Qe?On(un(R,q,fe,Qe),E):E}function On(E,R){return E!==R&&(E.initializer=R.initializer),pn(E,R)}function _r(E,R,q,fe,Qe){let Qt=re(172);Qt.modifiers=ro(E),Qt.name=Il(R),Qt.questionToken=q&&Xv(q)?q:void 0,Qt.exclamationToken=q&&wR(q)?q:void 0,Qt.type=fe,Qt.initializer=rP(Qe);let kn=Qt.flags&33554432||Yg(Qt.modifiers)&128;return Qt.transformFlags=so(Qt.modifiers)|Yv(Qt.name)|wn(Qt.initializer)|(kn||Qt.questionToken||Qt.exclamationToken||Qt.type?1:0)|(uo(Qt.name)||Yg(Qt.modifiers)&256&&Qt.initializer?8192:0)|16777216,Qt.jsDoc=void 0,Qt}function rt(E,R,q,fe,Qe,Qt){return E.modifiers!==R||E.name!==q||E.questionToken!==(fe!==void 0&&Xv(fe)?fe:void 0)||E.exclamationToken!==(fe!==void 0&&wR(fe)?fe:void 0)||E.type!==Qe||E.initializer!==Qt?pn(_r(R,q,fe,Qe,Qt),E):E}function zt(E,R,q,fe,Qe,Qt){let kn=re(173);return kn.modifiers=ro(E),kn.name=Il(R),kn.questionToken=q,kn.typeParameters=ro(fe),kn.parameters=ro(Qe),kn.type=Qt,kn.transformFlags=1,kn.jsDoc=void 0,kn.locals=void 0,kn.nextContainer=void 0,kn.typeArguments=void 0,kn}function Rr(E,R,q,fe,Qe,Qt,kn){return E.modifiers!==R||E.name!==q||E.questionToken!==fe||E.typeParameters!==Qe||E.parameters!==Qt||E.type!==kn?$(zt(R,q,fe,Qe,Qt,kn),E):E}function vi(E,R,q,fe,Qe,Qt,kn,ps){let oc=re(174);if(oc.modifiers=ro(E),oc.asteriskToken=R,oc.name=Il(q),oc.questionToken=fe,oc.exclamationToken=void 0,oc.typeParameters=ro(Qe),oc.parameters=H(Qt),oc.type=kn,oc.body=ps,!oc.body)oc.transformFlags=1;else{let xg=Yg(oc.modifiers)&1024,wS=!!oc.asteriskToken,eg=xg&&wS;oc.transformFlags=so(oc.modifiers)|wn(oc.asteriskToken)|Yv(oc.name)|wn(oc.questionToken)|so(oc.typeParameters)|so(oc.parameters)|wn(oc.type)|wn(oc.body)&-67108865|(eg?128:xg?256:wS?2048:0)|(oc.questionToken||oc.typeParameters||oc.type?1:0)|1024}return oc.typeArguments=void 0,oc.jsDoc=void 0,oc.locals=void 0,oc.nextContainer=void 0,oc.flowNode=void 0,oc.endFlowNode=void 0,oc.returnFlowNode=void 0,oc}function Ni(E,R,q,fe,Qe,Qt,kn,ps,oc){return E.modifiers!==R||E.asteriskToken!==q||E.name!==fe||E.questionToken!==Qe||E.typeParameters!==Qt||E.parameters!==kn||E.type!==ps||E.body!==oc?us(vi(R,q,fe,Qe,Qt,kn,ps,oc),E):E}function us(E,R){return E!==R&&(E.exclamationToken=R.exclamationToken),pn(E,R)}function Fs(E){let R=re(175);return R.body=E,R.transformFlags=wn(E)|16777216,R.modifiers=void 0,R.jsDoc=void 0,R.locals=void 0,R.nextContainer=void 0,R.endFlowNode=void 0,R.returnFlowNode=void 0,R}function Ta(E,R){return E.body!==R?to(Fs(R),E):E}function to(E,R){return E!==R&&(E.modifiers=R.modifiers),pn(E,R)}function Nr(E,R,q){let fe=re(176);return fe.modifiers=ro(E),fe.parameters=H(R),fe.body=q,fe.transformFlags=so(fe.modifiers)|so(fe.parameters)|wn(fe.body)&-67108865|1024,fe.typeParameters=void 0,fe.type=void 0,fe.typeArguments=void 0,fe.jsDoc=void 0,fe.locals=void 0,fe.nextContainer=void 0,fe.endFlowNode=void 0,fe.returnFlowNode=void 0,fe}function qr(E,R,q,fe){return E.modifiers!==R||E.parameters!==q||E.body!==fe?We(Nr(R,q,fe),E):E}function We(E,R){return E!==R&&(E.typeParameters=R.typeParameters,E.type=R.type),$(E,R)}function mt(E,R,q,fe,Qe){let Qt=re(177);return Qt.modifiers=ro(E),Qt.name=Il(R),Qt.parameters=H(q),Qt.type=fe,Qt.body=Qe,Qt.body?Qt.transformFlags=so(Qt.modifiers)|Yv(Qt.name)|so(Qt.parameters)|wn(Qt.type)|wn(Qt.body)&-67108865|(Qt.type?1:0):Qt.transformFlags=1,Qt.typeArguments=void 0,Qt.typeParameters=void 0,Qt.jsDoc=void 0,Qt.locals=void 0,Qt.nextContainer=void 0,Qt.flowNode=void 0,Qt.endFlowNode=void 0,Qt.returnFlowNode=void 0,Qt}function dt(E,R,q,fe,Qe,Qt){return E.modifiers!==R||E.name!==q||E.parameters!==fe||E.type!==Qe||E.body!==Qt?Ot(mt(R,q,fe,Qe,Qt),E):E}function Ot(E,R){return E!==R&&(E.typeParameters=R.typeParameters),$(E,R)}function _e(E,R,q,fe){let Qe=re(178);return Qe.modifiers=ro(E),Qe.name=Il(R),Qe.parameters=H(q),Qe.body=fe,Qe.body?Qe.transformFlags=so(Qe.modifiers)|Yv(Qe.name)|so(Qe.parameters)|wn(Qe.body)&-67108865|(Qe.type?1:0):Qe.transformFlags=1,Qe.typeArguments=void 0,Qe.typeParameters=void 0,Qe.type=void 0,Qe.jsDoc=void 0,Qe.locals=void 0,Qe.nextContainer=void 0,Qe.flowNode=void 0,Qe.endFlowNode=void 0,Qe.returnFlowNode=void 0,Qe}function Ve(E,R,q,fe,Qe){return E.modifiers!==R||E.name!==q||E.parameters!==fe||E.body!==Qe?pt(_e(R,q,fe,Qe),E):E}function pt(E,R){return E!==R&&(E.typeParameters=R.typeParameters,E.type=R.type),$(E,R)}function W(E,R,q){let fe=re(179);return fe.typeParameters=ro(E),fe.parameters=ro(R),fe.type=q,fe.transformFlags=1,fe.jsDoc=void 0,fe.locals=void 0,fe.nextContainer=void 0,fe.typeArguments=void 0,fe}function st(E,R,q,fe){return E.typeParameters!==R||E.parameters!==q||E.type!==fe?$(W(R,q,fe),E):E}function Nt(E,R,q){let fe=re(180);return fe.typeParameters=ro(E),fe.parameters=ro(R),fe.type=q,fe.transformFlags=1,fe.jsDoc=void 0,fe.locals=void 0,fe.nextContainer=void 0,fe.typeArguments=void 0,fe}function Ke(E,R,q,fe){return E.typeParameters!==R||E.parameters!==q||E.type!==fe?$(Nt(R,q,fe),E):E}function ht(E,R,q){let fe=re(181);return fe.modifiers=ro(E),fe.parameters=ro(R),fe.type=q,fe.transformFlags=1,fe.jsDoc=void 0,fe.locals=void 0,fe.nextContainer=void 0,fe.typeArguments=void 0,fe}function Wt(E,R,q,fe){return E.parameters!==q||E.type!==fe||E.modifiers!==R?$(ht(R,q,fe),E):E}function Cr(E,R){let q=K(204);return q.type=E,q.literal=R,q.transformFlags=1,q}function hr(E,R,q){return E.type!==R||E.literal!==q?pn(Cr(R,q),E):E}function Sr(E){return ke(E)}function Y(E,R,q){let fe=K(182);return fe.assertsModifier=E,fe.parameterName=Il(R),fe.type=q,fe.transformFlags=1,fe}function Be(E,R,q,fe){return E.assertsModifier!==R||E.parameterName!==q||E.type!==fe?pn(Y(R,q,fe),E):E}function Lt(E,R){let q=K(183);return q.typeName=Il(E),q.typeArguments=R&&i().parenthesizeTypeArguments(H(R)),q.transformFlags=1,q}function B(E,R,q){return E.typeName!==R||E.typeArguments!==q?pn(Lt(R,q),E):E}function le(E,R,q){let fe=re(184);return fe.typeParameters=ro(E),fe.parameters=ro(R),fe.type=q,fe.transformFlags=1,fe.modifiers=void 0,fe.jsDoc=void 0,fe.locals=void 0,fe.nextContainer=void 0,fe.typeArguments=void 0,fe}function X(E,R,q,fe){return E.typeParameters!==R||E.parameters!==q||E.type!==fe?he(le(R,q,fe),E):E}function he(E,R){return E!==R&&(E.modifiers=R.modifiers),$(E,R)}function qe(...E){return E.length===4?Le(...E):E.length===3?It(...E):I.fail("Incorrect number of arguments specified.")}function Le(E,R,q,fe){let Qe=re(185);return Qe.modifiers=ro(E),Qe.typeParameters=ro(R),Qe.parameters=ro(q),Qe.type=fe,Qe.transformFlags=1,Qe.jsDoc=void 0,Qe.locals=void 0,Qe.nextContainer=void 0,Qe.typeArguments=void 0,Qe}function It(E,R,q){return Le(void 0,E,R,q)}function Rt(...E){return E.length===5?Zt(...E):E.length===4?Ir(...E):I.fail("Incorrect number of arguments specified.")}function Zt(E,R,q,fe,Qe){return E.modifiers!==R||E.typeParameters!==q||E.parameters!==fe||E.type!==Qe?$(qe(R,q,fe,Qe),E):E}function Ir(E,R,q,fe){return Zt(E,E.modifiers,R,q,fe)}function zr(E,R){let q=K(186);return q.exprName=E,q.typeArguments=R&&i().parenthesizeTypeArguments(R),q.transformFlags=1,q}function Yr(E,R,q){return E.exprName!==R||E.typeArguments!==q?pn(zr(R,q),E):E}function Pi(E){let R=re(187);return R.members=H(E),R.transformFlags=1,R}function Fi(E,R){return E.members!==R?pn(Pi(R),E):E}function fn(E){let R=K(188);return R.elementType=i().parenthesizeNonArrayTypeOfPostfixType(E),R.transformFlags=1,R}function Qn(E,R){return E.elementType!==R?pn(fn(R),E):E}function Ns(E){let R=K(189);return R.elements=H(i().parenthesizeElementTypesOfTupleType(E)),R.transformFlags=1,R}function Vi(E,R){return E.elements!==R?pn(Ns(R),E):E}function ji(E,R,q,fe){let Qe=re(202);return Qe.dotDotDotToken=E,Qe.name=R,Qe.questionToken=q,Qe.type=fe,Qe.transformFlags=1,Qe.jsDoc=void 0,Qe}function ni(E,R,q,fe,Qe){return E.dotDotDotToken!==R||E.name!==q||E.questionToken!==fe||E.type!==Qe?pn(ji(R,q,fe,Qe),E):E}function js(E){let R=K(190);return R.type=i().parenthesizeTypeOfOptionalType(E),R.transformFlags=1,R}function Mr(E,R){return E.type!==R?pn(js(R),E):E}function Qo(E){let R=K(191);return R.type=E,R.transformFlags=1,R}function Sl(E,R){return E.type!==R?pn(Qo(R),E):E}function zs(E,R,q){let fe=K(E);return fe.types=U.createNodeArray(q(R)),fe.transformFlags=1,fe}function Eo(E,R,q){return E.types!==R?pn(zs(E.kind,R,q),E):E}function nc(E){return zs(192,E,i().parenthesizeConstituentTypesOfUnionType)}function Dc(E,R){return Eo(E,R,i().parenthesizeConstituentTypesOfUnionType)}function zu(E){return zs(193,E,i().parenthesizeConstituentTypesOfIntersectionType)}function ks(E,R){return Eo(E,R,i().parenthesizeConstituentTypesOfIntersectionType)}function ya(E,R,q,fe){let Qe=K(194);return Qe.checkType=i().parenthesizeCheckTypeOfConditionalType(E),Qe.extendsType=i().parenthesizeExtendsTypeOfConditionalType(R),Qe.trueType=q,Qe.falseType=fe,Qe.transformFlags=1,Qe.locals=void 0,Qe.nextContainer=void 0,Qe}function $u(E,R,q,fe,Qe){return E.checkType!==R||E.extendsType!==q||E.trueType!==fe||E.falseType!==Qe?pn(ya(R,q,fe,Qe),E):E}function Uo(E){let R=K(195);return R.typeParameter=E,R.transformFlags=1,R}function $a(E,R){return E.typeParameter!==R?pn(Uo(R),E):E}function Ac(E,R){let q=K(203);return q.head=E,q.templateSpans=H(R),q.transformFlags=1,q}function Ld(E,R,q){return E.head!==R||E.templateSpans!==q?pn(Ac(R,q),E):E}function Nl(E,R,q,fe,Qe=!1){let Qt=K(205);return Qt.argument=E,Qt.attributes=R,Qt.assertions&&Qt.assertions.assertClause&&Qt.attributes&&(Qt.assertions.assertClause=Qt.attributes),Qt.qualifier=q,Qt.typeArguments=fe&&i().parenthesizeTypeArguments(fe),Qt.isTypeOf=Qe,Qt.transformFlags=1,Qt}function zc(E,R,q,fe,Qe,Qt=E.isTypeOf){return E.argument!==R||E.attributes!==q||E.qualifier!==fe||E.typeArguments!==Qe||E.isTypeOf!==Qt?pn(Nl(R,q,fe,Qe,Qt),E):E}function Tc(E){let R=K(196);return R.type=E,R.transformFlags=1,R}function $s(E,R){return E.type!==R?pn(Tc(R),E):E}function cr(){let E=K(197);return E.transformFlags=1,E}function ic(E,R){let q=K(198);return q.operator=E,q.type=E===148?i().parenthesizeOperandOfReadonlyTypeOperator(R):i().parenthesizeOperandOfTypeOperator(R),q.transformFlags=1,q}function Mu(E,R){return E.type!==R?pn(ic(E.operator,R),E):E}function Wu(E,R){let q=K(199);return q.objectType=i().parenthesizeNonArrayTypeOfPostfixType(E),q.indexType=R,q.transformFlags=1,q}function yp(E,R,q){return E.objectType!==R||E.indexType!==q?pn(Wu(R,q),E):E}function Go(E,R,q,fe,Qe,Qt){let kn=re(200);return kn.readonlyToken=E,kn.typeParameter=R,kn.nameType=q,kn.questionToken=fe,kn.type=Qe,kn.members=Qt&&H(Qt),kn.transformFlags=1,kn.locals=void 0,kn.nextContainer=void 0,kn}function ru(E,R,q,fe,Qe,Qt,kn){return E.readonlyToken!==R||E.typeParameter!==q||E.nameType!==fe||E.questionToken!==Qe||E.type!==Qt||E.members!==kn?pn(Go(R,q,fe,Qe,Qt,kn),E):E}function ge(E){let R=K(201);return R.literal=E,R.transformFlags=1,R}function ne(E,R){return E.literal!==R?pn(ge(R),E):E}function je(E){let R=K(206);return R.elements=H(E),R.transformFlags|=so(R.elements)|1024|524288,R.transformFlags&32768&&(R.transformFlags|=65664),R}function Et(E,R){return E.elements!==R?pn(je(R),E):E}function gr(E){let R=K(207);return R.elements=H(E),R.transformFlags|=so(R.elements)|1024|524288,R}function Dn(E,R){return E.elements!==R?pn(gr(R),E):E}function xn(E,R,q,fe){let Qe=re(208);return Qe.dotDotDotToken=E,Qe.propertyName=Il(R),Qe.name=Il(q),Qe.initializer=rP(fe),Qe.transformFlags|=wn(Qe.dotDotDotToken)|Yv(Qe.propertyName)|Yv(Qe.name)|wn(Qe.initializer)|(Qe.dotDotDotToken?32768:0)|1024,Qe.flowNode=void 0,Qe}function Zn(E,R,q,fe,Qe){return E.propertyName!==q||E.dotDotDotToken!==R||E.name!==fe||E.initializer!==Qe?pn(xn(R,q,fe,Qe),E):E}function Bi(E,R){let q=K(209),fe=E&&Is(E),Qe=H(E,fe&&Su(fe)?!0:void 0);return q.elements=i().parenthesizeExpressionsOfCommaDelimitedList(Qe),q.multiLine=R,q.transformFlags|=so(q.elements),q}function Jn(E,R){return E.elements!==R?pn(Bi(R,E.multiLine),E):E}function ia(E,R){let q=re(210);return q.properties=H(E),q.multiLine=R,q.transformFlags|=so(q.properties),q.jsDoc=void 0,q}function Fc(E,R){return E.properties!==R?pn(ia(R,E.multiLine),E):E}function bu(E,R,q){let fe=re(211);return fe.expression=E,fe.questionDotToken=R,fe.name=q,fe.transformFlags=wn(fe.expression)|wn(fe.questionDotToken)|(ze(fe.name)?bR(fe.name):wn(fe.name)|536870912),fe.jsDoc=void 0,fe.flowNode=void 0,fe}function sc(E,R){let q=bu(i().parenthesizeLeftSideOfAccess(E,!1),void 0,Il(R));return M6(E)&&(q.transformFlags|=384),q}function Jl(E,R,q){return C9(E)?Eu(E,R,E.questionDotToken,ta(q,ze)):E.expression!==R||E.name!==q?pn(sc(R,q),E):E}function jo(E,R,q){let fe=bu(i().parenthesizeLeftSideOfAccess(E,!0),R,Il(q));return fe.flags|=64,fe.transformFlags|=32,fe}function Eu(E,R,q,fe){return I.assert(!!(E.flags&64),"Cannot update a PropertyAccessExpression using updatePropertyAccessChain. Use updatePropertyAccess instead."),E.expression!==R||E.questionDotToken!==q||E.name!==fe?pn(jo(R,q,fe),E):E}function Xf(E,R,q){let fe=re(212);return fe.expression=E,fe.questionDotToken=R,fe.argumentExpression=q,fe.transformFlags|=wn(fe.expression)|wn(fe.questionDotToken)|wn(fe.argumentExpression),fe.jsDoc=void 0,fe.flowNode=void 0,fe}function pu(E,R){let q=Xf(i().parenthesizeLeftSideOfAccess(E,!1),void 0,ab(R));return M6(E)&&(q.transformFlags|=384),q}function gm(E,R,q){return rY(E)?Oe(E,R,E.questionDotToken,q):E.expression!==R||E.argumentExpression!==q?pn(pu(R,q),E):E}function tf(E,R,q){let fe=Xf(i().parenthesizeLeftSideOfAccess(E,!0),R,ab(q));return fe.flags|=64,fe.transformFlags|=32,fe}function Oe(E,R,q,fe){return I.assert(!!(E.flags&64),"Cannot update a ElementAccessExpression using updateElementAccessChain. Use updateElementAccess instead."),E.expression!==R||E.questionDotToken!==q||E.argumentExpression!==fe?pn(tf(R,q,fe),E):E}function Bt(E,R,q,fe){let Qe=re(213);return Qe.expression=E,Qe.questionDotToken=R,Qe.typeArguments=q,Qe.arguments=fe,Qe.transformFlags|=wn(Qe.expression)|wn(Qe.questionDotToken)|so(Qe.typeArguments)|so(Qe.arguments),Qe.typeArguments&&(Qe.transformFlags|=1),Pf(Qe.expression)&&(Qe.transformFlags|=16384),Qe}function Zr(E,R,q){let fe=Bt(i().parenthesizeLeftSideOfAccess(E,!1),void 0,ro(R),i().parenthesizeExpressionsOfCommaDelimitedList(H(q)));return L6(fe.expression)&&(fe.transformFlags|=8388608),fe}function Ds(E,R,q,fe){return L2(E)?ua(E,R,E.questionDotToken,q,fe):E.expression!==R||E.typeArguments!==q||E.arguments!==fe?pn(Zr(R,q,fe),E):E}function sa(E,R,q,fe){let Qe=Bt(i().parenthesizeLeftSideOfAccess(E,!0),R,ro(q),i().parenthesizeExpressionsOfCommaDelimitedList(H(fe)));return Qe.flags|=64,Qe.transformFlags|=32,Qe}function ua(E,R,q,fe,Qe){return I.assert(!!(E.flags&64),"Cannot update a CallExpression using updateCallChain. Use updateCall instead."),E.expression!==R||E.questionDotToken!==q||E.typeArguments!==fe||E.arguments!==Qe?pn(sa(R,q,fe,Qe),E):E}function Tl(E,R,q){let fe=re(214);return fe.expression=i().parenthesizeExpressionOfNew(E),fe.typeArguments=ro(R),fe.arguments=q?i().parenthesizeExpressionsOfCommaDelimitedList(q):void 0,fe.transformFlags|=wn(fe.expression)|so(fe.typeArguments)|so(fe.arguments)|32,fe.typeArguments&&(fe.transformFlags|=1),fe}function ql(E,R,q,fe){return E.expression!==R||E.typeArguments!==q||E.arguments!==fe?pn(Tl(R,q,fe),E):E}function bc(E,R,q){let fe=K(215);return fe.tag=i().parenthesizeLeftSideOfAccess(E,!1),fe.typeArguments=ro(R),fe.template=q,fe.transformFlags|=wn(fe.tag)|so(fe.typeArguments)|wn(fe.template)|1024,fe.typeArguments&&(fe.transformFlags|=1),dX(fe.template)&&(fe.transformFlags|=128),fe}function Ic(E,R,q,fe){return E.tag!==R||E.typeArguments!==q||E.template!==fe?pn(bc(R,q,fe),E):E}function cl(E,R){let q=K(216);return q.expression=i().parenthesizeOperandOfPrefixUnary(R),q.type=E,q.transformFlags|=wn(q.expression)|wn(q.type)|1,q}function bl(E,R,q){return E.type!==R||E.expression!==q?pn(cl(R,q),E):E}function xu(E){let R=K(217);return R.expression=E,R.transformFlags=wn(R.expression),R.jsDoc=void 0,R}function dd(E,R){return E.expression!==R?pn(xu(R),E):E}function wf(E,R,q,fe,Qe,Qt,kn){let ps=re(218);ps.modifiers=ro(E),ps.asteriskToken=R,ps.name=Il(q),ps.typeParameters=ro(fe),ps.parameters=H(Qe),ps.type=Qt,ps.body=kn;let oc=Yg(ps.modifiers)&1024,xg=!!ps.asteriskToken,wS=oc&&xg;return ps.transformFlags=so(ps.modifiers)|wn(ps.asteriskToken)|Yv(ps.name)|so(ps.typeParameters)|so(ps.parameters)|wn(ps.type)|wn(ps.body)&-67108865|(wS?128:oc?256:xg?2048:0)|(ps.typeParameters||ps.type?1:0)|4194304,ps.typeArguments=void 0,ps.jsDoc=void 0,ps.locals=void 0,ps.nextContainer=void 0,ps.flowNode=void 0,ps.endFlowNode=void 0,ps.returnFlowNode=void 0,ps}function hf(E,R,q,fe,Qe,Qt,kn,ps){return E.name!==fe||E.modifiers!==R||E.asteriskToken!==q||E.typeParameters!==Qe||E.parameters!==Qt||E.type!==kn||E.body!==ps?$(wf(R,q,fe,Qe,Qt,kn,ps),E):E}function Fd(E,R,q,fe,Qe,Qt){let kn=re(219);kn.modifiers=ro(E),kn.typeParameters=ro(R),kn.parameters=H(q),kn.type=fe,kn.equalsGreaterThanToken=Qe??ke(39),kn.body=i().parenthesizeConciseBodyOfArrowFunction(Qt);let ps=Yg(kn.modifiers)&1024;return kn.transformFlags=so(kn.modifiers)|so(kn.typeParameters)|so(kn.parameters)|wn(kn.type)|wn(kn.equalsGreaterThanToken)|wn(kn.body)&-67108865|(kn.typeParameters||kn.type?1:0)|(ps?16640:0)|1024,kn.typeArguments=void 0,kn.jsDoc=void 0,kn.locals=void 0,kn.nextContainer=void 0,kn.flowNode=void 0,kn.endFlowNode=void 0,kn.returnFlowNode=void 0,kn}function ch(E,R,q,fe,Qe,Qt,kn){return E.modifiers!==R||E.typeParameters!==q||E.parameters!==fe||E.type!==Qe||E.equalsGreaterThanToken!==Qt||E.body!==kn?$(Fd(R,q,fe,Qe,Qt,kn),E):E}function Yh(E){let R=K(220);return R.expression=i().parenthesizeOperandOfPrefixUnary(E),R.transformFlags|=wn(R.expression),R}function Ly(E,R){return E.expression!==R?pn(Yh(R),E):E}function A_(E){let R=K(221);return R.expression=i().parenthesizeOperandOfPrefixUnary(E),R.transformFlags|=wn(R.expression),R}function Fy(E,R){return E.expression!==R?pn(A_(R),E):E}function vp(E){let R=K(222);return R.expression=i().parenthesizeOperandOfPrefixUnary(E),R.transformFlags|=wn(R.expression),R}function U0(E,R){return E.expression!==R?pn(vp(R),E):E}function Of(E){let R=K(223);return R.expression=i().parenthesizeOperandOfPrefixUnary(E),R.transformFlags|=wn(R.expression)|256|128|2097152,R}function ie(E,R){return E.expression!==R?pn(Of(R),E):E}function ct(E,R){let q=K(224);return q.operator=E,q.operand=i().parenthesizeOperandOfPrefixUnary(R),q.transformFlags|=wn(q.operand),(E===46||E===47)&&ze(q.operand)&&!yc(q.operand)&&!Iy(q.operand)&&(q.transformFlags|=268435456),q}function Jt(E,R){return E.operand!==R?pn(ct(E.operator,R),E):E}function Gt(E,R){let q=K(225);return q.operator=R,q.operand=i().parenthesizeOperandOfPostfixUnary(E),q.transformFlags|=wn(q.operand),ze(q.operand)&&!yc(q.operand)&&!Iy(q.operand)&&(q.transformFlags|=268435456),q}function V(E,R){return E.operand!==R?pn(Gt(R,E.operator),E):E}function Pe(E,R,q){let fe=re(226),Qe=i4(R),Qt=Qe.kind;return fe.left=i().parenthesizeLeftSideOfBinary(Qt,E),fe.operatorToken=Qe,fe.right=i().parenthesizeRightSideOfBinary(Qt,fe.left,q),fe.transformFlags|=wn(fe.left)|wn(fe.operatorToken)|wn(fe.right),Qt===61?fe.transformFlags|=32:Qt===64?Ha(fe.left)?fe.transformFlags|=5248|ot(fe.left):Z_(fe.left)&&(fe.transformFlags|=5120|ot(fe.left)):Qt===43||Qt===68?fe.transformFlags|=512:s6(Qt)&&(fe.transformFlags|=16),Qt===103&&is(fe.left)&&(fe.transformFlags|=536870912),fe.jsDoc=void 0,fe}function ot(E){return YR(E)?65536:0}function Yt(E,R,q,fe){return E.left!==R||E.operatorToken!==q||E.right!==fe?pn(Pe(R,q,fe),E):E}function _n(E,R,q,fe,Qe){let Qt=K(227);return Qt.condition=i().parenthesizeConditionOfConditionalExpression(E),Qt.questionToken=R??ke(58),Qt.whenTrue=i().parenthesizeBranchOfConditionalExpression(q),Qt.colonToken=fe??ke(59),Qt.whenFalse=i().parenthesizeBranchOfConditionalExpression(Qe),Qt.transformFlags|=wn(Qt.condition)|wn(Qt.questionToken)|wn(Qt.whenTrue)|wn(Qt.colonToken)|wn(Qt.whenFalse),Qt}function gi(E,R,q,fe,Qe,Qt){return E.condition!==R||E.questionToken!==q||E.whenTrue!==fe||E.colonToken!==Qe||E.whenFalse!==Qt?pn(_n(R,q,fe,Qe,Qt),E):E}function ci(E,R){let q=K(228);return q.head=E,q.templateSpans=H(R),q.transformFlags|=wn(q.head)|so(q.templateSpans)|1024,q}function ds(E,R,q){return E.head!==R||E.templateSpans!==q?pn(ci(R,q),E):E}function Ya(E,R,q,fe=0){I.assert(!(fe&-7177),"Unsupported template flags.");let Qe;if(q!==void 0&&q!==R&&(Qe=zyt(E,q),typeof Qe=="object"))return I.fail("Invalid raw text");if(R===void 0){if(Qe===void 0)return I.fail("Arguments 'text' and 'rawText' may not both be undefined.");R=Qe}else Qe!==void 0&&I.assert(R===Qe,"Expected argument 'text' to be the normalized (i.e. 'cooked') version of argument 'rawText'.");return R}function Xa(E){let R=1024;return E&&(R|=128),R}function Zc(E,R,q,fe){let Qe=kt(E);return Qe.text=R,Qe.rawText=q,Qe.templateFlags=fe&7176,Qe.transformFlags=Xa(Qe.templateFlags),Qe}function Gu(E,R,q,fe){let Qe=re(E);return Qe.text=R,Qe.rawText=q,Qe.templateFlags=fe&7176,Qe.transformFlags=Xa(Qe.templateFlags),Qe}function nu(E,R,q,fe){return E===15?Gu(E,R,q,fe):Zc(E,R,q,fe)}function Sp(E,R,q){return E=Ya(16,E,R,q),nu(16,E,R,q)}function Rf(E,R,q){return E=Ya(16,E,R,q),nu(17,E,R,q)}function _S(E,R,q){return E=Ya(16,E,R,q),nu(18,E,R,q)}function xo(E,R,q){return E=Ya(16,E,R,q),Gu(15,E,R,q)}function Wm(E,R){I.assert(!E||!!R,"A `YieldExpression` with an asteriskToken must have an expression.");let q=K(229);return q.expression=R&&i().parenthesizeExpressionForDisallowedComma(R),q.asteriskToken=E,q.transformFlags|=wn(q.expression)|wn(q.asteriskToken)|1024|128|1048576,q}function Gm(E,R,q){return E.expression!==q||E.asteriskToken!==R?pn(Wm(R,q),E):E}function ts(E){let R=K(230);return R.expression=i().parenthesizeExpressionForDisallowedComma(E),R.transformFlags|=wn(R.expression)|1024|32768,R}function jy(E,R){return E.expression!==R?pn(ts(R),E):E}function H1(E,R,q,fe,Qe){let Qt=re(231);return Qt.modifiers=ro(E),Qt.name=Il(R),Qt.typeParameters=ro(q),Qt.heritageClauses=ro(fe),Qt.members=H(Qe),Qt.transformFlags|=so(Qt.modifiers)|Yv(Qt.name)|so(Qt.typeParameters)|so(Qt.heritageClauses)|so(Qt.members)|(Qt.typeParameters?1:0)|1024,Qt.jsDoc=void 0,Qt}function Hm(E,R,q,fe,Qe,Qt){return E.modifiers!==R||E.name!==q||E.typeParameters!==fe||E.heritageClauses!==Qe||E.members!==Qt?pn(H1(R,q,fe,Qe,Qt),E):E}function wE(){return K(232)}function OE(E,R){let q=K(233);return q.expression=i().parenthesizeLeftSideOfAccess(E,!1),q.typeArguments=R&&i().parenthesizeTypeArguments(R),q.transformFlags|=wn(q.expression)|so(q.typeArguments)|1024,q}function md(E,R,q){return E.expression!==R||E.typeArguments!==q?pn(OE(R,q),E):E}function lh(E,R){let q=K(234);return q.expression=E,q.type=R,q.transformFlags|=wn(q.expression)|wn(q.type)|1,q}function gd(E,R,q){return E.expression!==R||E.type!==q?pn(lh(R,q),E):E}function By(E){let R=K(235);return R.expression=i().parenthesizeLeftSideOfAccess(E,!1),R.transformFlags|=wn(R.expression)|1,R}function Je(E,R){return k9(E)?Er(E,R):E.expression!==R?pn(By(R),E):E}function et(E,R){let q=K(238);return q.expression=E,q.type=R,q.transformFlags|=wn(q.expression)|wn(q.type)|1,q}function Ft(E,R,q){return E.expression!==R||E.type!==q?pn(et(R,q),E):E}function Ht(E){let R=K(235);return R.flags|=64,R.expression=i().parenthesizeLeftSideOfAccess(E,!0),R.transformFlags|=wn(R.expression)|1,R}function Er(E,R){return I.assert(!!(E.flags&64),"Cannot update a NonNullExpression using updateNonNullChain. Use updateNonNullExpression instead."),E.expression!==R?pn(Ht(R),E):E}function nn(E,R){let q=K(236);switch(q.keywordToken=E,q.name=R,q.transformFlags|=wn(q.name),E){case 105:q.transformFlags|=1024;break;case 102:q.transformFlags|=32;break;default:return I.assertNever(E)}return q.flowNode=void 0,q}function br(E,R){return E.name!==R?pn(nn(E.keywordToken,R),E):E}function sn(E,R){let q=K(239);return q.expression=E,q.literal=R,q.transformFlags|=wn(q.expression)|wn(q.literal)|1024,q}function Ci(E,R,q){return E.expression!==R||E.literal!==q?pn(sn(R,q),E):E}function hn(){let E=K(240);return E.transformFlags|=1024,E}function mi(E,R){let q=K(241);return q.statements=H(E),q.multiLine=R,q.transformFlags|=so(q.statements),q.jsDoc=void 0,q.locals=void 0,q.nextContainer=void 0,q}function Tn(E,R){return E.statements!==R?pn(mi(R,E.multiLine),E):E}function aa(E,R){let q=K(243);return q.modifiers=ro(E),q.declarationList=os(R)?Kf(R):R,q.transformFlags|=so(q.modifiers)|wn(q.declarationList),Yg(q.modifiers)&128&&(q.transformFlags=1),q.jsDoc=void 0,q.flowNode=void 0,q}function ao(E,R,q){return E.modifiers!==R||E.declarationList!==q?pn(aa(R,q),E):E}function B_(){let E=K(242);return E.jsDoc=void 0,E}function Hu(E){let R=K(244);return R.expression=i().parenthesizeExpressionOfExpressionStatement(E),R.transformFlags|=wn(R.expression),R.jsDoc=void 0,R.flowNode=void 0,R}function Uy(E,R){return E.expression!==R?pn(Hu(R),E):E}function qT(E,R,q){let fe=K(245);return fe.expression=E,fe.thenStatement=IS(R),fe.elseStatement=IS(q),fe.transformFlags|=wn(fe.expression)|wn(fe.thenStatement)|wn(fe.elseStatement),fe.jsDoc=void 0,fe.flowNode=void 0,fe}function Rk(E,R,q,fe){return E.expression!==R||E.thenStatement!==q||E.elseStatement!==fe?pn(qT(R,q,fe),E):E}function zT(E,R){let q=K(246);return q.statement=IS(E),q.expression=R,q.transformFlags|=wn(q.statement)|wn(q.expression),q.jsDoc=void 0,q.flowNode=void 0,q}function HD(E,R,q){return E.statement!==R||E.expression!==q?pn(zT(R,q),E):E}function YD(E,R){let q=K(247);return q.expression=E,q.statement=IS(R),q.transformFlags|=wn(q.expression)|wn(q.statement),q.jsDoc=void 0,q.flowNode=void 0,q}function XD(E,R,q){return E.expression!==R||E.statement!==q?pn(YD(R,q),E):E}function Lx(E,R,q,fe){let Qe=K(248);return Qe.initializer=E,Qe.condition=R,Qe.incrementor=q,Qe.statement=IS(fe),Qe.transformFlags|=wn(Qe.initializer)|wn(Qe.condition)|wn(Qe.incrementor)|wn(Qe.statement),Qe.jsDoc=void 0,Qe.locals=void 0,Qe.nextContainer=void 0,Qe.flowNode=void 0,Qe}function RE(E,R,q,fe,Qe){return E.initializer!==R||E.condition!==q||E.incrementor!==fe||E.statement!==Qe?pn(Lx(R,q,fe,Qe),E):E}function Mk(E,R,q){let fe=K(249);return fe.initializer=E,fe.expression=R,fe.statement=IS(q),fe.transformFlags|=wn(fe.initializer)|wn(fe.expression)|wn(fe.statement),fe.jsDoc=void 0,fe.locals=void 0,fe.nextContainer=void 0,fe.flowNode=void 0,fe}function KD(E,R,q,fe){return E.initializer!==R||E.expression!==q||E.statement!==fe?pn(Mk(R,q,fe),E):E}function Lk(E,R,q,fe){let Qe=K(250);return Qe.awaitModifier=E,Qe.initializer=R,Qe.expression=i().parenthesizeExpressionForDisallowedComma(q),Qe.statement=IS(fe),Qe.transformFlags|=wn(Qe.awaitModifier)|wn(Qe.initializer)|wn(Qe.expression)|wn(Qe.statement)|1024,E&&(Qe.transformFlags|=128),Qe.jsDoc=void 0,Qe.locals=void 0,Qe.nextContainer=void 0,Qe.flowNode=void 0,Qe}function Fk(E,R,q,fe,Qe){return E.awaitModifier!==R||E.initializer!==q||E.expression!==fe||E.statement!==Qe?pn(Lk(R,q,fe,Qe),E):E}function jk(E){let R=K(251);return R.label=Il(E),R.transformFlags|=wn(R.label)|4194304,R.jsDoc=void 0,R.flowNode=void 0,R}function Bk(E,R){return E.label!==R?pn(jk(R),E):E}function Fx(E){let R=K(252);return R.label=Il(E),R.transformFlags|=wn(R.label)|4194304,R.jsDoc=void 0,R.flowNode=void 0,R}function Uk(E,R){return E.label!==R?pn(Fx(R),E):E}function ME(E){let R=K(253);return R.expression=E,R.transformFlags|=wn(R.expression)|128|4194304,R.jsDoc=void 0,R.flowNode=void 0,R}function LE(E,R){return E.expression!==R?pn(ME(R),E):E}function fS(E,R){let q=K(254);return q.expression=E,q.statement=IS(R),q.transformFlags|=wn(q.expression)|wn(q.statement),q.jsDoc=void 0,q.flowNode=void 0,q}function pS(E,R,q){return E.expression!==R||E.statement!==q?pn(fS(R,q),E):E}function V0(E,R){let q=K(255);return q.expression=i().parenthesizeExpressionForDisallowedComma(E),q.caseBlock=R,q.transformFlags|=wn(q.expression)|wn(q.caseBlock),q.jsDoc=void 0,q.flowNode=void 0,q.possiblyExhaustive=!1,q}function $T(E,R,q){return E.expression!==R||E.caseBlock!==q?pn(V0(R,q),E):E}function fo(E,R){let q=K(256);return q.label=Il(E),q.statement=IS(R),q.transformFlags|=wn(q.label)|wn(q.statement),q.jsDoc=void 0,q.flowNode=void 0,q}function jx(E,R,q){return E.label!==R||E.statement!==q?pn(fo(R,q),E):E}function QD(E){let R=K(257);return R.expression=E,R.transformFlags|=wn(R.expression),R.jsDoc=void 0,R.flowNode=void 0,R}function WT(E,R){return E.expression!==R?pn(QD(R),E):E}function Vy(E,R,q){let fe=K(258);return fe.tryBlock=E,fe.catchClause=R,fe.finallyBlock=q,fe.transformFlags|=wn(fe.tryBlock)|wn(fe.catchClause)|wn(fe.finallyBlock),fe.jsDoc=void 0,fe.flowNode=void 0,fe}function Xh(E,R,q,fe){return E.tryBlock!==R||E.catchClause!==q||E.finallyBlock!==fe?pn(Vy(R,q,fe),E):E}function jd(){let E=K(259);return E.jsDoc=void 0,E.flowNode=void 0,E}function Mf(E,R,q,fe){let Qe=re(260);return Qe.name=Il(E),Qe.exclamationToken=R,Qe.type=q,Qe.initializer=rP(fe),Qe.transformFlags|=Yv(Qe.name)|wn(Qe.initializer)|(Qe.exclamationToken??Qe.type?1:0),Qe.jsDoc=void 0,Qe}function Tp(E,R,q,fe,Qe){return E.name!==R||E.type!==fe||E.exclamationToken!==q||E.initializer!==Qe?pn(Mf(R,q,fe,Qe),E):E}function Kf(E,R=0){let q=K(261);return q.flags|=R&7,q.declarations=H(E),q.transformFlags|=so(q.declarations)|4194304,R&7&&(q.transformFlags|=263168),R&4&&(q.transformFlags|=4),q}function Y1(E,R){return E.declarations!==R?pn(Kf(R,E.flags),E):E}function Bx(E,R,q,fe,Qe,Qt,kn){let ps=re(262);if(ps.modifiers=ro(E),ps.asteriskToken=R,ps.name=Il(q),ps.typeParameters=ro(fe),ps.parameters=H(Qe),ps.type=Qt,ps.body=kn,!ps.body||Yg(ps.modifiers)&128)ps.transformFlags=1;else{let oc=Yg(ps.modifiers)&1024,xg=!!ps.asteriskToken,wS=oc&&xg;ps.transformFlags=so(ps.modifiers)|wn(ps.asteriskToken)|Yv(ps.name)|so(ps.typeParameters)|so(ps.parameters)|wn(ps.type)|wn(ps.body)&-67108865|(wS?128:oc?256:xg?2048:0)|(ps.typeParameters||ps.type?1:0)|4194304}return ps.typeArguments=void 0,ps.jsDoc=void 0,ps.locals=void 0,ps.nextContainer=void 0,ps.endFlowNode=void 0,ps.returnFlowNode=void 0,ps}function ZD(E,R,q,fe,Qe,Qt,kn,ps){return E.modifiers!==R||E.asteriskToken!==q||E.name!==fe||E.typeParameters!==Qe||E.parameters!==Qt||E.type!==kn||E.body!==ps?Vk(Bx(R,q,fe,Qe,Qt,kn,ps),E):E}function Vk(E,R){return E!==R&&E.modifiers===R.modifiers&&(E.modifiers=R.modifiers),$(E,R)}function dS(E,R,q,fe,Qe){let Qt=re(263);return Qt.modifiers=ro(E),Qt.name=Il(R),Qt.typeParameters=ro(q),Qt.heritageClauses=ro(fe),Qt.members=H(Qe),Yg(Qt.modifiers)&128?Qt.transformFlags=1:(Qt.transformFlags|=so(Qt.modifiers)|Yv(Qt.name)|so(Qt.typeParameters)|so(Qt.heritageClauses)|so(Qt.members)|(Qt.typeParameters?1:0)|1024,Qt.transformFlags&8192&&(Qt.transformFlags|=1)),Qt.jsDoc=void 0,Qt}function GT(E,R,q,fe,Qe,Qt){return E.modifiers!==R||E.name!==q||E.typeParameters!==fe||E.heritageClauses!==Qe||E.members!==Qt?pn(dS(R,q,fe,Qe,Qt),E):E}function Jk(E,R,q,fe,Qe){let Qt=re(264);return Qt.modifiers=ro(E),Qt.name=Il(R),Qt.typeParameters=ro(q),Qt.heritageClauses=ro(fe),Qt.members=H(Qe),Qt.transformFlags=1,Qt.jsDoc=void 0,Qt}function zl(E,R,q,fe,Qe,Qt){return E.modifiers!==R||E.name!==q||E.typeParameters!==fe||E.heritageClauses!==Qe||E.members!==Qt?pn(Jk(R,q,fe,Qe,Qt),E):E}function X1(E,R,q,fe){let Qe=re(265);return Qe.modifiers=ro(E),Qe.name=Il(R),Qe.typeParameters=ro(q),Qe.type=fe,Qe.transformFlags=1,Qe.jsDoc=void 0,Qe.locals=void 0,Qe.nextContainer=void 0,Qe}function qk(E,R,q,fe,Qe){return E.modifiers!==R||E.name!==q||E.typeParameters!==fe||E.type!==Qe?pn(X1(R,q,fe,Qe),E):E}function yg(E,R,q){let fe=re(266);return fe.modifiers=ro(E),fe.name=Il(R),fe.members=H(q),fe.transformFlags|=so(fe.modifiers)|wn(fe.name)|so(fe.members)|1,fe.transformFlags&=-67108865,fe.jsDoc=void 0,fe}function Ux(E,R,q,fe){return E.modifiers!==R||E.name!==q||E.members!==fe?pn(yg(R,q,fe),E):E}function He(E,R,q,fe=0){let Qe=re(267);return Qe.modifiers=ro(E),Qe.flags|=fe&2088,Qe.name=R,Qe.body=q,Yg(Qe.modifiers)&128?Qe.transformFlags=1:Qe.transformFlags|=so(Qe.modifiers)|wn(Qe.name)|wn(Qe.body)|1,Qe.transformFlags&=-67108865,Qe.jsDoc=void 0,Qe.locals=void 0,Qe.nextContainer=void 0,Qe}function vg(E,R,q,fe){return E.modifiers!==R||E.name!==q||E.body!==fe?pn(He(R,q,fe,E.flags),E):E}function Yu(E){let R=K(268);return R.statements=H(E),R.transformFlags|=so(R.statements),R.jsDoc=void 0,R}function HT(E,R){return E.statements!==R?pn(Yu(R),E):E}function zk(E){let R=K(269);return R.clauses=H(E),R.transformFlags|=so(R.clauses),R.locals=void 0,R.nextContainer=void 0,R}function mS(E,R){return E.clauses!==R?pn(zk(R),E):E}function K1(E){let R=re(270);return R.name=Il(E),R.transformFlags|=bR(R.name)|1,R.modifiers=void 0,R.jsDoc=void 0,R}function Q1(E,R){return E.name!==R?XO(K1(R),E):E}function XO(E,R){return E!==R&&(E.modifiers=R.modifiers),pn(E,R)}function oo(E,R,q,fe){let Qe=re(271);return Qe.modifiers=ro(E),Qe.name=Il(q),Qe.isTypeOnly=R,Qe.moduleReference=fe,Qe.transformFlags|=so(Qe.modifiers)|bR(Qe.name)|wn(Qe.moduleReference),zh(Qe.moduleReference)||(Qe.transformFlags|=1),Qe.transformFlags&=-67108865,Qe.jsDoc=void 0,Qe}function Sg(E,R,q,fe,Qe){return E.modifiers!==R||E.isTypeOnly!==q||E.name!==fe||E.moduleReference!==Qe?pn(oo(R,q,fe,Qe),E):E}function Vx(E,R,q,fe){let Qe=K(272);return Qe.modifiers=ro(E),Qe.importClause=R,Qe.moduleSpecifier=q,Qe.attributes=Qe.assertClause=fe,Qe.transformFlags|=wn(Qe.importClause)|wn(Qe.moduleSpecifier),Qe.transformFlags&=-67108865,Qe.jsDoc=void 0,Qe}function Jx(E,R,q,fe,Qe){return E.modifiers!==R||E.importClause!==q||E.moduleSpecifier!==fe||E.attributes!==Qe?pn(Vx(R,q,fe,Qe),E):E}function YT(E,R,q){let fe=re(273);return fe.isTypeOnly=E,fe.name=R,fe.namedBindings=q,fe.transformFlags|=wn(fe.name)|wn(fe.namedBindings),E&&(fe.transformFlags|=1),fe.transformFlags&=-67108865,fe}function qx(E,R,q,fe){return E.isTypeOnly!==R||E.name!==q||E.namedBindings!==fe?pn(YT(R,q,fe),E):E}function hm(E,R){let q=K(300);return q.elements=H(E),q.multiLine=R,q.token=132,q.transformFlags|=4,q}function ym(E,R,q){return E.elements!==R||E.multiLine!==q?pn(hm(R,q),E):E}function Jy(E,R){let q=K(301);return q.name=E,q.value=R,q.transformFlags|=4,q}function $k(E,R,q){return E.name!==R||E.value!==q?pn(Jy(R,q),E):E}function Tg(E,R){let q=K(302);return q.assertClause=E,q.multiLine=R,q}function eI(E,R,q){return E.assertClause!==R||E.multiLine!==q?pn(Tg(R,q),E):E}function FE(E,R,q){let fe=K(300);return fe.token=q??118,fe.elements=H(E),fe.multiLine=R,fe.transformFlags|=4,fe}function as(E,R,q){return E.elements!==R||E.multiLine!==q?pn(FE(R,q,E.token),E):E}function _i(E,R){let q=K(301);return q.name=E,q.value=R,q.transformFlags|=4,q}function Kh(E,R,q){return E.name!==R||E.value!==q?pn(_i(R,q),E):E}function Lf(E){let R=re(274);return R.name=E,R.transformFlags|=wn(R.name),R.transformFlags&=-67108865,R}function KO(E,R){return E.name!==R?pn(Lf(R),E):E}function qy(E){let R=re(280);return R.name=E,R.transformFlags|=wn(R.name)|32,R.transformFlags&=-67108865,R}function QO(E,R){return E.name!==R?pn(qy(R),E):E}function gS(E){let R=K(275);return R.elements=H(E),R.transformFlags|=so(R.elements),R.transformFlags&=-67108865,R}function wc(E,R){return E.elements!==R?pn(gS(R),E):E}function zp(E,R,q){let fe=re(276);return fe.isTypeOnly=E,fe.propertyName=R,fe.name=q,fe.transformFlags|=wn(fe.propertyName)|wn(fe.name),fe.transformFlags&=-67108865,fe}function J0(E,R,q,fe){return E.isTypeOnly!==R||E.propertyName!==q||E.name!==fe?pn(zp(R,q,fe),E):E}function vm(E,R,q){let fe=re(277);return fe.modifiers=ro(E),fe.isExportEquals=R,fe.expression=R?i().parenthesizeRightSideOfBinary(64,void 0,q):i().parenthesizeExpressionOfExportDefault(q),fe.transformFlags|=so(fe.modifiers)|wn(fe.expression),fe.transformFlags&=-67108865,fe.jsDoc=void 0,fe}function hS(E,R,q){return E.modifiers!==R||E.expression!==q?pn(vm(R,E.isExportEquals,q),E):E}function Ym(E,R,q,fe,Qe){let Qt=re(278);return Qt.modifiers=ro(E),Qt.isTypeOnly=R,Qt.exportClause=q,Qt.moduleSpecifier=fe,Qt.attributes=Qt.assertClause=Qe,Qt.transformFlags|=so(Qt.modifiers)|wn(Qt.exportClause)|wn(Qt.moduleSpecifier),Qt.transformFlags&=-67108865,Qt.jsDoc=void 0,Qt}function zy(E,R,q,fe,Qe,Qt){return E.modifiers!==R||E.isTypeOnly!==q||E.exportClause!==fe||E.moduleSpecifier!==Qe||E.attributes!==Qt?jE(Ym(R,q,fe,Qe,Qt),E):E}function jE(E,R){return E!==R&&E.modifiers===R.modifiers&&(E.modifiers=R.modifiers),pn(E,R)}function zx(E){let R=K(279);return R.elements=H(E),R.transformFlags|=so(R.elements),R.transformFlags&=-67108865,R}function q0(E,R){return E.elements!==R?pn(zx(R),E):E}function Wk(E,R,q){let fe=K(281);return fe.isTypeOnly=E,fe.propertyName=Il(R),fe.name=Il(q),fe.transformFlags|=wn(fe.propertyName)|wn(fe.name),fe.transformFlags&=-67108865,fe.jsDoc=void 0,fe}function z0(E,R,q,fe){return E.isTypeOnly!==R||E.propertyName!==q||E.name!==fe?pn(Wk(R,q,fe),E):E}function uh(){let E=re(282);return E.jsDoc=void 0,E}function Z1(E){let R=K(283);return R.expression=E,R.transformFlags|=wn(R.expression),R.transformFlags&=-67108865,R}function tI(E,R){return E.expression!==R?pn(Z1(R),E):E}function rI(E){return K(E)}function nI(E,R,q=!1){let fe=$x(E,q?R&&i().parenthesizeNonArrayTypeOfPostfixType(R):R);return fe.postfix=q,fe}function $x(E,R){let q=K(E);return q.type=R,q}function pc(E,R,q){return R.type!==q?pn(nI(E,q,R.postfix),R):R}function BE(E,R,q){return R.type!==q?pn($x(E,q),R):R}function Wx(E,R){let q=re(324);return q.parameters=ro(E),q.type=R,q.transformFlags=so(q.parameters)|(q.type?1:0),q.jsDoc=void 0,q.locals=void 0,q.nextContainer=void 0,q.typeArguments=void 0,q}function Xm(E,R,q){return E.parameters!==R||E.type!==q?pn(Wx(R,q),E):E}function yS(E,R=!1){let q=re(329);return q.jsDocPropertyTags=ro(E),q.isArrayType=R,q}function iI(E,R,q){return E.jsDocPropertyTags!==R||E.isArrayType!==q?pn(yS(R,q),E):E}function Gx(E){let R=K(316);return R.type=E,R}function ZO(E,R){return E.type!==R?pn(Gx(R),E):E}function Cn(E,R,q){let fe=re(330);return fe.typeParameters=ro(E),fe.parameters=H(R),fe.type=q,fe.jsDoc=void 0,fe.locals=void 0,fe.nextContainer=void 0,fe}function Lu(E,R,q,fe){return E.typeParameters!==R||E.parameters!==q||E.type!==fe?pn(Cn(R,q,fe),E):E}function _s(E){let R=hK(E.kind);return E.tagName.escapedText===Pc(R)?E.tagName:we(R)}function hd(E,R,q){let fe=K(E);return fe.tagName=R,fe.comment=q,fe}function ev(E,R,q){let fe=re(E);return fe.tagName=R,fe.comment=q,fe}function _h(E,R,q,fe){let Qe=hd(352,E??we("template"),fe);return Qe.constraint=R,Qe.typeParameters=H(q),Qe}function yn(E,R=_s(E),q,fe,Qe){return E.tagName!==R||E.constraint!==q||E.typeParameters!==fe||E.comment!==Qe?pn(_h(R,q,fe,Qe),E):E}function Hx(E,R,q,fe){let Qe=ev(353,E??we("typedef"),fe);return Qe.typeExpression=R,Qe.fullName=q,Qe.name=rQ(q),Qe.locals=void 0,Qe.nextContainer=void 0,Qe}function XT(E,R=_s(E),q,fe,Qe){return E.tagName!==R||E.typeExpression!==q||E.fullName!==fe||E.comment!==Qe?pn(Hx(R,q,fe,Qe),E):E}function Cu(E,R,q,fe,Qe,Qt){let kn=ev(348,E??we("param"),Qt);return kn.typeExpression=fe,kn.name=R,kn.isNameFirst=!!Qe,kn.isBracketed=q,kn}function Qh(E,R=_s(E),q,fe,Qe,Qt,kn){return E.tagName!==R||E.name!==q||E.isBracketed!==fe||E.typeExpression!==Qe||E.isNameFirst!==Qt||E.comment!==kn?pn(Cu(R,q,fe,Qe,Qt,kn),E):E}function Km(E,R,q,fe,Qe,Qt){let kn=ev(355,E??we("prop"),Qt);return kn.typeExpression=fe,kn.name=R,kn.isNameFirst=!!Qe,kn.isBracketed=q,kn}function UE(E,R=_s(E),q,fe,Qe,Qt,kn){return E.tagName!==R||E.name!==q||E.isBracketed!==fe||E.typeExpression!==Qe||E.isNameFirst!==Qt||E.comment!==kn?pn(Km(R,q,fe,Qe,Qt,kn),E):E}function VE(E,R,q,fe){let Qe=ev(345,E??we("callback"),fe);return Qe.typeExpression=R,Qe.fullName=q,Qe.name=rQ(q),Qe.locals=void 0,Qe.nextContainer=void 0,Qe}function vS(E,R=_s(E),q,fe,Qe){return E.tagName!==R||E.typeExpression!==q||E.fullName!==fe||E.comment!==Qe?pn(VE(R,q,fe,Qe),E):E}function $y(E,R,q){let fe=hd(346,E??we("overload"),q);return fe.typeExpression=R,fe}function Yx(E,R=_s(E),q,fe){return E.tagName!==R||E.typeExpression!==q||E.comment!==fe?pn($y(R,q,fe),E):E}function Qm(E,R,q){let fe=hd(335,E??we("augments"),q);return fe.class=R,fe}function KT(E,R=_s(E),q,fe){return E.tagName!==R||E.class!==q||E.comment!==fe?pn(Qm(R,q,fe),E):E}function $0(E,R,q){let fe=hd(336,E??we("implements"),q);return fe.class=R,fe}function SS(E,R,q){let fe=hd(354,E??we("see"),q);return fe.name=R,fe}function Gk(E,R,q,fe){return E.tagName!==R||E.name!==q||E.comment!==fe?pn(SS(R,q,fe),E):E}function QT(E){let R=K(317);return R.name=E,R}function sI(E,R){return E.name!==R?pn(QT(R),E):E}function JE(E,R){let q=K(318);return q.left=E,q.right=R,q.transformFlags|=wn(q.left)|wn(q.right),q}function Xx(E,R,q){return E.left!==R||E.right!==q?pn(JE(R,q),E):E}function $p(E,R){let q=K(331);return q.name=E,q.text=R,q}function Kx(E,R,q){return E.name!==R?pn($p(R,q),E):E}function ll(E,R){let q=K(332);return q.name=E,q.text=R,q}function du(E,R,q){return E.name!==R?pn(ll(R,q),E):E}function Qx(E,R){let q=K(333);return q.name=E,q.text=R,q}function a_(E,R,q){return E.name!==R?pn(Qx(R,q),E):E}function Qf(E,R=_s(E),q,fe){return E.tagName!==R||E.class!==q||E.comment!==fe?pn($0(R,q,fe),E):E}function ZT(E,R,q){return hd(E,R??we(hK(E)),q)}function Bd(E,R,q=_s(R),fe){return R.tagName!==q||R.comment!==fe?pn(ZT(E,q,fe),R):R}function TS(E,R,q,fe){let Qe=hd(E,R??we(hK(E)),fe);return Qe.typeExpression=q,Qe}function bS(E,R,q=_s(R),fe,Qe){return R.tagName!==q||R.typeExpression!==fe||R.comment!==Qe?pn(TS(E,q,fe,Qe),R):R}function Fu(E,R){return hd(334,E,R)}function Hk(E,R,q){return E.tagName!==R||E.comment!==q?pn(Fu(R,q),E):E}function Wp(E,R,q){let fe=ev(347,E??we(hK(347)),q);return fe.typeExpression=R,fe.locals=void 0,fe.nextContainer=void 0,fe}function Zx(E,R=_s(E),q,fe){return E.tagName!==R||E.typeExpression!==q||E.comment!==fe?pn(Wp(R,q,fe),E):E}function eC(E){let R=K(328);return R.text=E,R}function ac(E,R){return E.text!==R?pn(eC(R),E):E}function aI(E,R){let q=K(327);return q.comment=E,q.tags=ro(R),q}function eb(E,R,q){return E.comment!==R||E.tags!==q?pn(aI(R,q),E):E}function qE(E,R,q){let fe=K(284);return fe.openingElement=E,fe.children=H(R),fe.closingElement=q,fe.transformFlags|=wn(fe.openingElement)|so(fe.children)|wn(fe.closingElement)|2,fe}function e4(E,R,q,fe){return E.openingElement!==R||E.children!==q||E.closingElement!==fe?pn(qE(R,q,fe),E):E}function rf(E,R,q){let fe=K(285);return fe.tagName=E,fe.typeArguments=ro(R),fe.attributes=q,fe.transformFlags|=wn(fe.tagName)|so(fe.typeArguments)|wn(fe.attributes)|2,fe.typeArguments&&(fe.transformFlags|=1),fe}function Wy(E,R,q,fe){return E.tagName!==R||E.typeArguments!==q||E.attributes!==fe?pn(rf(R,q,fe),E):E}function fh(E,R,q){let fe=K(286);return fe.tagName=E,fe.typeArguments=ro(R),fe.attributes=q,fe.transformFlags|=wn(fe.tagName)|so(fe.typeArguments)|wn(fe.attributes)|2,R&&(fe.transformFlags|=1),fe}function Yk(E,R,q,fe){return E.tagName!==R||E.typeArguments!==q||E.attributes!==fe?pn(fh(R,q,fe),E):E}function bp(E){let R=K(287);return R.tagName=E,R.transformFlags|=wn(R.tagName)|2,R}function Xk(E,R){return E.tagName!==R?pn(bp(R),E):E}function Zf(E,R,q){let fe=K(288);return fe.openingFragment=E,fe.children=H(R),fe.closingFragment=q,fe.transformFlags|=wn(fe.openingFragment)|so(fe.children)|wn(fe.closingFragment)|2,fe}function Kk(E,R,q,fe){return E.openingFragment!==R||E.children!==q||E.closingFragment!==fe?pn(Zf(R,q,fe),E):E}function tv(E,R){let q=K(12);return q.text=E,q.containsOnlyTriviaWhiteSpaces=!!R,q.transformFlags|=2,q}function tC(E,R,q){return E.text!==R||E.containsOnlyTriviaWhiteSpaces!==q?pn(tv(R,q),E):E}function oI(){let E=K(289);return E.transformFlags|=2,E}function cI(){let E=K(290);return E.transformFlags|=2,E}function rC(E,R){let q=re(291);return q.name=E,q.initializer=R,q.transformFlags|=wn(q.name)|wn(q.initializer)|2,q}function lI(E,R,q){return E.name!==R||E.initializer!==q?pn(rC(R,q),E):E}function ES(E){let R=re(292);return R.properties=H(E),R.transformFlags|=so(R.properties)|2,R}function Ep(E,R){return E.properties!==R?pn(ES(R),E):E}function Zh(E){let R=K(293);return R.expression=E,R.transformFlags|=wn(R.expression)|2,R}function uI(E,R){return E.expression!==R?pn(Zh(R),E):E}function nC(E,R){let q=K(294);return q.dotDotDotToken=E,q.expression=R,q.transformFlags|=wn(q.dotDotDotToken)|wn(q.expression)|2,q}function mo(E,R){return E.expression!==R?pn(nC(E.dotDotDotToken,R),E):E}function Rn(E,R){let q=K(295);return q.namespace=E,q.name=R,q.transformFlags|=wn(q.namespace)|wn(q.name)|2,q}function yd(E,R,q){return E.namespace!==R||E.name!==q?pn(Rn(R,q),E):E}function yf(E,R){let q=K(296);return q.expression=i().parenthesizeExpressionForDisallowedComma(E),q.statements=H(R),q.transformFlags|=wn(q.expression)|so(q.statements),q.jsDoc=void 0,q}function zE(E,R,q){return E.expression!==R||E.statements!==q?pn(yf(R,q),E):E}function _I(E){let R=K(297);return R.statements=H(E),R.transformFlags=so(R.statements),R}function tb(E,R){return E.statements!==R?pn(_I(R),E):E}function $E(E,R){let q=K(298);switch(q.token=E,q.types=H(R),q.transformFlags|=so(q.types),E){case 96:q.transformFlags|=1024;break;case 119:q.transformFlags|=1;break;default:return I.assertNever(E)}return q}function iC(E,R){return E.types!==R?pn($E(E.token,R),E):E}function W0(E,R){let q=K(299);return q.variableDeclaration=s4(E),q.block=R,q.transformFlags|=wn(q.variableDeclaration)|wn(q.block)|(E?0:64),q.locals=void 0,q.nextContainer=void 0,q}function bg(E,R,q){return E.variableDeclaration!==R||E.block!==q?pn(W0(R,q),E):E}function vd(E,R){let q=re(303);return q.name=Il(E),q.initializer=i().parenthesizeExpressionForDisallowedComma(R),q.transformFlags|=Yv(q.name)|wn(q.initializer),q.modifiers=void 0,q.questionToken=void 0,q.exclamationToken=void 0,q.jsDoc=void 0,q}function Zm(E,R,q){return E.name!==R||E.initializer!==q?Gy(vd(R,q),E):E}function Gy(E,R){return E!==R&&(E.modifiers=R.modifiers,E.questionToken=R.questionToken,E.exclamationToken=R.exclamationToken),pn(E,R)}function G0(E,R){let q=re(304);return q.name=Il(E),q.objectAssignmentInitializer=R&&i().parenthesizeExpressionForDisallowedComma(R),q.transformFlags|=bR(q.name)|wn(q.objectAssignmentInitializer)|1024,q.equalsToken=void 0,q.modifiers=void 0,q.questionToken=void 0,q.exclamationToken=void 0,q.jsDoc=void 0,q}function H0(E,R,q){return E.name!==R||E.objectAssignmentInitializer!==q?Qk(G0(R,q),E):E}function Qk(E,R){return E!==R&&(E.modifiers=R.modifiers,E.questionToken=R.questionToken,E.exclamationToken=R.exclamationToken,E.equalsToken=R.equalsToken),pn(E,R)}function Dl(E){let R=re(305);return R.expression=i().parenthesizeExpressionForDisallowedComma(E),R.transformFlags|=wn(R.expression)|128|65536,R.jsDoc=void 0,R}function fI(E,R){return E.expression!==R?pn(Dl(R),E):E}function Ud(E,R){let q=re(306);return q.name=Il(E),q.initializer=R&&i().parenthesizeExpressionForDisallowedComma(R),q.transformFlags|=wn(q.name)|wn(q.initializer)|1,q.jsDoc=void 0,q}function e0(E,R,q){return E.name!==R||E.initializer!==q?pn(Ud(R,q),E):E}function Sd(E,R,q){let fe=t.createBaseSourceFileNode(312);return fe.statements=H(E),fe.endOfFileToken=R,fe.flags|=q,fe.text="",fe.fileName="",fe.path="",fe.resolvedPath="",fe.originalFileName="",fe.languageVersion=0,fe.languageVariant=0,fe.scriptKind=0,fe.isDeclarationFile=!1,fe.hasNoDefaultLib=!1,fe.transformFlags|=so(fe.statements)|wn(fe.endOfFileToken),fe.locals=void 0,fe.nextContainer=void 0,fe.endFlowNode=void 0,fe.nodeCount=0,fe.identifierCount=0,fe.symbolCount=0,fe.parseDiagnostics=void 0,fe.bindDiagnostics=void 0,fe.bindSuggestionDiagnostics=void 0,fe.lineMap=void 0,fe.externalModuleIndicator=void 0,fe.setExternalModuleIndicator=void 0,fe.pragmas=void 0,fe.checkJsDirective=void 0,fe.referencedFiles=void 0,fe.typeReferenceDirectives=void 0,fe.libReferenceDirectives=void 0,fe.amdDependencies=void 0,fe.commentDirectives=void 0,fe.identifiers=void 0,fe.packageJsonLocations=void 0,fe.packageJsonScope=void 0,fe.imports=void 0,fe.moduleAugmentations=void 0,fe.ambientModuleNames=void 0,fe.classifiableNames=void 0,fe.impliedNodeFormat=void 0,fe}function WE(E){let R=Object.create(E.redirectTarget);return Object.defineProperties(R,{id:{get(){return this.redirectInfo.redirectTarget.id},set(q){this.redirectInfo.redirectTarget.id=q}},symbol:{get(){return this.redirectInfo.redirectTarget.symbol},set(q){this.redirectInfo.redirectTarget.symbol=q}}}),R.redirectInfo=E,R}function rb(E){let R=WE(E.redirectInfo);return R.flags|=E.flags&-17,R.fileName=E.fileName,R.path=E.path,R.resolvedPath=E.resolvedPath,R.originalFileName=E.originalFileName,R.packageJsonLocations=E.packageJsonLocations,R.packageJsonScope=E.packageJsonScope,R.emitNode=void 0,R}function Zk(E){let R=t.createBaseSourceFileNode(312);R.flags|=E.flags&-17;for(let q in E)if(!(wo(R,q)||!wo(E,q))){if(q==="emitNode"){R.emitNode=void 0;continue}R[q]=E[q]}return R}function sC(E){let R=E.redirectInfo?rb(E):Zk(E);return n(R,E),R}function Td(E,R,q,fe,Qe,Qt,kn){let ps=sC(E);return ps.statements=H(R),ps.isDeclarationFile=q,ps.referencedFiles=fe,ps.typeReferenceDirectives=Qe,ps.hasNoDefaultLib=Qt,ps.libReferenceDirectives=kn,ps.transformFlags=so(ps.statements)|wn(ps.endOfFileToken),ps}function Ho(E,R,q=E.isDeclarationFile,fe=E.referencedFiles,Qe=E.typeReferenceDirectives,Qt=E.hasNoDefaultLib,kn=E.libReferenceDirectives){return E.statements!==R||E.isDeclarationFile!==q||E.referencedFiles!==fe||E.typeReferenceDirectives!==Qe||E.hasNoDefaultLib!==Qt||E.libReferenceDirectives!==kn?pn(Td(E,R,q,fe,Qe,Qt,kn),E):E}function GE(E,R=tt){let q=K(313);return q.prepends=R,q.sourceFiles=E,q.syntheticFileReferences=void 0,q.syntheticTypeReferences=void 0,q.syntheticLibReferences=void 0,q.hasNoDefaultLib=void 0,q}function HE(E,R,q=tt){return E.sourceFiles!==R||E.prepends!==q?pn(GE(R,q),E):E}function Hy(E,R,q){let fe=K(314);return fe.prologues=E,fe.syntheticReferences=R,fe.texts=q,fe.fileName="",fe.text="",fe.referencedFiles=tt,fe.libReferenceDirectives=tt,fe.getLineAndCharacterOfPosition=Qe=>Lo(fe,Qe),fe}function xS(E,R){let q=K(E);return q.data=R,q}function nb(E){return xS(307,E)}function D(E,R){let q=xS(308,E);return q.texts=R,q}function ue(E,R){return xS(R?310:309,E)}function gt(E){let R=K(311);return R.data=E.data,R.section=E,R}function lr(){let E=K(315);return E.javascriptText="",E.declarationText="",E}function Wn(E,R=!1,q){let fe=K(237);return fe.type=E,fe.isSpread=R,fe.tupleNameSource=q,fe}function $i(E){let R=K(358);return R._children=E,R}function Di(E){let R=K(359);return R.original=E,ft(R,E),R}function fs(E,R){let q=K(360);return q.expression=E,q.original=R,q.transformFlags|=wn(q.expression)|1,ft(q,R),q}function Aa(E,R){return E.expression!==R?pn(fs(R,E.original),E):E}function U_(E){if(_c(E)&&!Pw(E)&&!E.original&&!E.emitNode&&!E.id){if(j6(E))return E.elements;if(bn(E)&&mge(E.operatorToken))return[E.left,E.right]}return E}function vf(E){let R=K(361);return R.elements=H(nA(E,U_)),R.transformFlags|=so(R.elements),R}function Vd(E,R){return E.elements!==R?pn(vf(R),E):E}function CS(E,R){let q=K(362);return q.expression=E,q.thisArg=R,q.transformFlags|=wn(q.expression)|wn(q.thisArg),q}function Oi(E,R,q){return E.expression!==R||E.thisArg!==q?pn(CS(R,q),E):E}function t0(E){let R=ce(E.escapedText);return R.flags|=E.flags&-17,R.transformFlags=E.transformFlags,n(R,E),kR(R,{...E.emitNode.autoGenerate}),R}function Kr(E){let R=ce(E.escapedText);R.flags|=E.flags&-17,R.jsDoc=E.jsDoc,R.flowNode=E.flowNode,R.symbol=E.symbol,R.transformFlags=E.transformFlags,n(R,E);let q=sx(E);return q&&M1(R,q),R}function eP(E){let R=Ge(E.escapedText);return R.flags|=E.flags&-17,R.transformFlags=E.transformFlags,n(R,E),kR(R,{...E.emitNode.autoGenerate}),R}function AS(E){let R=Ge(E.escapedText);return R.flags|=E.flags&-17,R.transformFlags=E.transformFlags,n(R,E),R}function kS(E){if(E===void 0)return E;if(ls(E))return sC(E);if(yc(E))return t0(E);if(ze(E))return Kr(E);if(F2(E))return eP(E);if(is(E))return AS(E);let R=e8(E.kind)?t.createBaseNode(E.kind):t.createBaseTokenNode(E.kind);R.flags|=E.flags&-17,R.transformFlags=E.transformFlags,n(R,E);for(let q in E)wo(R,q)||!wo(E,q)||(R[q]=E[q]);return R}function aC(E,R,q){return Zr(wf(void 0,void 0,void 0,void 0,R?[R]:[],void 0,mi(E,!0)),void 0,q?[q]:[])}function YE(E,R,q){return Zr(Fd(void 0,void 0,R?[R]:[],void 0,void 0,mi(E,!0)),void 0,q?[q]:[])}function ph(){return vp(pe("0"))}function r0(E){return vm(void 0,!1,E)}function pI(E){return Ym(void 0,!1,zx([Wk(!1,void 0,E)]))}function oC(E,R){return R==="null"?U.createStrictEquality(E,$t()):R==="undefined"?U.createStrictEquality(E,ph()):U.createStrictEquality(A_(E),Se(R))}function uz(E,R){return R==="null"?U.createStrictInequality(E,$t()):R==="undefined"?U.createStrictInequality(E,ph()):U.createStrictInequality(A_(E),Se(R))}function PS(E,R,q){return L2(E)?sa(jo(E,void 0,R),void 0,void 0,q):Zr(sc(E,R),void 0,q)}function lL(E,R,q){return PS(E,"bind",[R,...q])}function uL(E,R,q){return PS(E,"call",[R,...q])}function ib(E,R,q){return PS(E,"apply",[R,q])}function Eg(E,R,q){return PS(we(E),R,q)}function t4(E,R){return PS(E,"slice",R===void 0?[]:[ab(R)])}function n0(E,R){return PS(E,"concat",R)}function tP(E,R,q){return Eg("Object","defineProperty",[E,ab(R),q])}function _L(E,R){return Eg("Object","getOwnPropertyDescriptor",[E,ab(R)])}function dh(E,R,q){return Eg("Reflect","get",q?[E,R,q]:[E,R])}function te(E,R,q,fe){return Eg("Reflect","set",fe?[E,R,q,fe]:[E,R,q])}function De(E,R,q){return q?(E.push(vd(R,q)),!0):!1}function Xe(E,R){let q=[];De(q,"enumerable",ab(E.enumerable)),De(q,"configurable",ab(E.configurable));let fe=De(q,"writable",ab(E.writable));fe=De(q,"value",E.value)||fe;let Qe=De(q,"get",E.get);return Qe=De(q,"set",E.set)||Qe,I.assert(!(fe&&Qe),"A PropertyDescriptor may not be both an accessor descriptor and a data descriptor."),ia(q,!R)}function Pt(E,R){switch(E.kind){case 217:return dd(E,R);case 216:return bl(E,E.type,R);case 234:return gd(E,R,E.type);case 238:return Ft(E,R,E.type);case 235:return Je(E,R);case 360:return Aa(E,R)}}function wt(E){return Df(E)&&_c(E)&&_c(R1(E))&&_c(Qg(E))&&!Tt(BN(E))&&!Tt(AR(E))}function Xt(E,R,q=15){return E&&hU(E,q)&&!wt(E)?Pt(E,Xt(E.expression,R)):R}function Yn(E,R,q){if(!R)return E;let fe=jx(R,R.label,_E(R.statement)?Yn(E,R.statement):E);return q&&q(R),fe}function Hi(E,R){let q=Do(E);switch(q.kind){case 80:return R;case 110:case 9:case 10:case 11:return!1;case 209:return q.elements.length!==0;case 210:return q.properties.length>0;default:return!0}}function Ui(E,R,q,fe=!1){let Qe=vl(E,15),Qt,kn;return Pf(Qe)?(Qt=at(),kn=Qe):M6(Qe)?(Qt=at(),kn=q!==void 0&&q<2?ft(we("_super"),Qe):Qe):eo(Qe)&8192?(Qt=ph(),kn=i().parenthesizeLeftSideOfAccess(Qe,!1)):Hn(Qe)?Hi(Qe.expression,fe)?(Qt=ve(R),kn=sc(ft(U.createAssignment(Qt,Qe.expression),Qe.expression),Qe.name),ft(kn,Qe)):(Qt=Qe.expression,kn=Qe):fc(Qe)?Hi(Qe.expression,fe)?(Qt=ve(R),kn=pu(ft(U.createAssignment(Qt,Qe.expression),Qe.expression),Qe.argumentExpression),ft(kn,Qe)):(Qt=Qe.expression,kn=Qe):(Qt=ph(),kn=i().parenthesizeLeftSideOfAccess(E,!1)),{target:kn,thisArg:Qt}}function Ai(E,R){return sc(xu(ia([_e(void 0,"value",[ki(void 0,void 0,E,void 0,void 0,void 0)],mi([Hu(R)]))])),"value")}function cs(E){return E.length>10?vf(E):d_(E,U.createComma)}function Co(E,R,q,fe=0,Qe){let Qt=Qe?E&&S9(E):qs(E);if(Qt&&ze(Qt)&&!yc(Qt)){let kn=io(ft(kS(Qt),Qt),Qt.parent);return fe|=eo(Qt),q||(fe|=96),R||(fe|=3072),fe&&Sn(kn,fe),kn}return Me(E)}function zo(E,R,q){return Co(E,R,q,98304)}function _o(E,R,q,fe){return Co(E,R,q,32768,fe)}function Jd(E,R,q){return Co(E,R,q,16384)}function mh(E,R,q){return Co(E,R,q)}function Y0(E,R,q,fe){let Qe=sc(E,_c(R)?R:kS(R));ft(Qe,R);let Qt=0;return fe||(Qt|=96),q||(Qt|=3072),Qt&&Sn(Qe,Qt),Qe}function Yy(E,R,q,fe){return E&&ui(R,32)?Y0(E,Co(R),q,fe):Jd(R,q,fe)}function Xy(E,R,q,fe){let Qe=cC(E,R,0,q);return dI(E,R,Qe,fe)}function NS(E){return za(E.expression)&&E.expression.text==="use strict"}function ep(){return M_(Hu(Se("use strict")))}function cC(E,R,q=0,fe){I.assert(R.length===0,"Prologue directives should be at the first statement in the target statements array");let Qe=!1,Qt=E.length;for(;q<Qt;){let kn=E[q];if(Fm(kn))NS(kn)&&(Qe=!0),R.push(kn);else break;q++}return fe&&!Qe&&R.push(ep()),q}function dI(E,R,q,fe,Qe=em){let Qt=E.length;for(;q!==void 0&&q<Qt;){let kn=E[q];if(eo(kn)&2097152&&Qe(kn))Pr(R,fe?nt(kn,fe,ns):kn);else break;q++}return q}function r4(E){return ZK(E)?E:ft(H([ep(),...E]),E)}function n4(E){return I.assert(yr(E,Fpe),"Cannot lift nodes to a Block."),nl(E)||mi(E)}function sb(E,R,q){let fe=q;for(;fe<E.length&&R(E[fe]);)fe++;return fe}function Ky(E,R){if(!Tt(R))return E;let q=sb(E,Fm,0),fe=sb(E,K9,q),Qe=sb(E,Q9,fe),Qt=sb(R,Fm,0),kn=sb(R,K9,Qt),ps=sb(R,Q9,kn),oc=sb(R,T8,ps);I.assert(oc===R.length,"Expected declarations to be valid standard or custom prologues");let xg=Bb(E)?E.slice():E;if(oc>ps&&xg.splice(Qe,0,...R.slice(ps,oc)),ps>kn&&xg.splice(fe,0,...R.slice(kn,ps)),kn>Qt&&xg.splice(q,0,...R.slice(Qt,kn)),Qt>0)if(q===0)xg.splice(0,0,...R.slice(0,Qt));else{let wS=new Map;for(let eg=0;eg<q;eg++){let ob=E[eg];wS.set(ob.expression.text,!0)}for(let eg=Qt-1;eg>=0;eg--){let ob=R[eg];wS.has(ob.expression.text)||xg.unshift(ob)}}return Bb(E)?ft(H(xg,E.hasTrailingComma),E):E}function DS(E,R){let q;return typeof R=="number"?q=ar(R):q=R,Nc(E)?tr(E,q,E.name,E.constraint,E.default):Ls(E)?xs(E,q,E.dotDotDotToken,E.name,E.questionToken,E.type,E.initializer):VN(E)?Zt(E,q,E.typeParameters,E.parameters,E.type):fp(E)?ri(E,q,E.name,E.questionToken,E.type):ea(E)?rt(E,q,E.name,E.questionToken??E.exclamationToken,E.type,E.initializer):Uh(E)?Rr(E,q,E.name,E.questionToken,E.typeParameters,E.parameters,E.type):pl(E)?Ni(E,q,E.asteriskToken,E.name,E.questionToken,E.typeParameters,E.parameters,E.type,E.body):Yc(E)?qr(E,q,E.parameters,E.body):sd(E)?dt(E,q,E.name,E.parameters,E.type,E.body):pp(E)?Ve(E,q,E.name,E.parameters,E.body):oE(E)?Wt(E,q,E.parameters,E.type):Xo(E)?hf(E,q,E.asteriskToken,E.name,E.typeParameters,E.parameters,E.type,E.body):rc(E)?ch(E,q,E.typeParameters,E.parameters,E.type,E.equalsGreaterThanToken,E.body):wu(E)?Hm(E,q,E.name,E.typeParameters,E.heritageClauses,E.members):Xc(E)?ao(E,q,E.declarationList):Zl(E)?ZD(E,q,E.asteriskToken,E.name,E.typeParameters,E.parameters,E.type,E.body):eu(E)?GT(E,q,E.name,E.typeParameters,E.heritageClauses,E.members):ef(E)?zl(E,q,E.name,E.typeParameters,E.heritageClauses,E.members):Vm(E)?qk(E,q,E.name,E.typeParameters,E.type):AT(E)?Ux(E,q,E.name,E.members):hl(E)?vg(E,q,E.name,E.body):Ru(E)?Sg(E,q,E.isTypeOnly,E.name,E.moduleReference):uu(E)?Jx(E,q,E.importClause,E.moduleSpecifier,E.attributes):Kc(E)?hS(E,q,E.expression):yl(E)?zy(E,q,E.isTypeOnly,E.exportClause,E.moduleSpecifier,E.attributes):I.assertNever(E)}function mI(E,R){return Ls(E)?xs(E,R,E.dotDotDotToken,E.name,E.questionToken,E.type,E.initializer):ea(E)?rt(E,R,E.name,E.questionToken??E.exclamationToken,E.type,E.initializer):pl(E)?Ni(E,R,E.asteriskToken,E.name,E.questionToken,E.typeParameters,E.parameters,E.type,E.body):sd(E)?dt(E,R,E.name,E.parameters,E.type,E.body):pp(E)?Ve(E,R,E.name,E.parameters,E.body):wu(E)?Hm(E,R,E.name,E.typeParameters,E.heritageClauses,E.members):eu(E)?GT(E,R,E.name,E.typeParameters,E.heritageClauses,E.members):I.assertNever(E)}function Gp(E,R){switch(E.kind){case 177:return dt(E,E.modifiers,R,E.parameters,E.type,E.body);case 178:return Ve(E,E.modifiers,R,E.parameters,E.body);case 174:return Ni(E,E.modifiers,E.asteriskToken,R,E.questionToken,E.typeParameters,E.parameters,E.type,E.body);case 173:return Rr(E,E.modifiers,R,E.questionToken,E.typeParameters,E.parameters,E.type);case 172:return rt(E,E.modifiers,R,E.questionToken??E.exclamationToken,E.type,E.initializer);case 171:return ri(E,E.modifiers,R,E.questionToken,E.type);case 303:return Zm(E,R,E.initializer)}}function ro(E){return E?H(E):void 0}function Il(E){return typeof E=="string"?we(E):E}function ab(E){return typeof E=="string"?Se(E):typeof E=="number"?pe(E):typeof E=="boolean"?E?St():Ze():E}function rP(E){return E&&i().parenthesizeExpressionForDisallowedComma(E)}function i4(E){return typeof E=="number"?ke(E):E}function IS(E){return E&&BK(E)?ft(n(B_(),E),E):E}function s4(E){return typeof E=="string"||E&&!Gi(E)?Mf(E,void 0,void 0,void 0):E}function pn(E,R){return E!==R&&(n(E,R),ft(E,R)),E}}function hK(e){switch(e){case 351:return"type";case 349:return"returns";case 350:return"this";case 347:return"enum";case 337:return"author";case 339:return"class";case 340:return"public";case 341:return"private";case 342:return"protected";case 343:return"readonly";case 344:return"override";case 352:return"template";case 353:return"typedef";case 348:return"param";case 355:return"prop";case 345:return"callback";case 346:return"overload";case 335:return"augments";case 336:return"implements";default:return I.fail(`Unsupported kind: ${I.formatSyntaxKind(e)}`)}}function zyt(e,t){switch(O1||(O1=E1(99,!1,0)),e){case 15:O1.setText("`"+t+"`");break;case 16:O1.setText("`"+t+"${");break;case 17:O1.setText("}"+t+"${");break;case 18:O1.setText("}"+t+"`");break}let n=O1.scan();if(n===20&&(n=O1.reScanTemplateToken(!1)),O1.isUnterminated())return O1.setText(void 0),nge;let i;switch(n){case 15:case 16:case 17:case 18:i=O1.getTokenValue();break}return i===void 0||O1.scan()!==1?(O1.setText(void 0),nge):(O1.setText(void 0),i)}function Yv(e){return e&&ze(e)?bR(e):wn(e)}function bR(e){return wn(e)&-67108865}function $yt(e,t){return t|e.transformFlags&134234112}function wn(e){if(!e)return 0;let t=e.transformFlags&~tge(e.kind);return W_(e)&&Al(e.name)?$yt(e.name,t):t}function so(e){return e?e.transformFlags:0}function b3e(e){let t=0;for(let n of e)t|=wn(n);e.transformFlags=t}function tge(e){if(e>=182&&e<=205)return-2;switch(e){case 213:case 214:case 209:return-2147450880;case 267:return-1941676032;case 169:return-2147483648;case 219:return-2072174592;case 218:case 262:return-1937940480;case 261:return-2146893824;case 263:case 231:return-2147344384;case 176:return-1937948672;case 172:return-2013249536;case 174:case 177:case 178:return-2005057536;case 133:case 150:case 163:case 146:case 154:case 151:case 136:case 155:case 116:case 168:case 171:case 173:case 179:case 180:case 181:case 264:case 265:return-2;case 210:return-2147278848;case 299:return-2147418112;case 206:case 207:return-2147450880;case 216:case 238:case 234:case 360:case 217:case 108:return-2147483648;case 211:case 212:return-2147483648;default:return-2147483648}}function vB(e){return e.flags|=16,e}function yK(e,t,n){let i,s,o,l,p,m,S,h,b,A;vs(e)?(o="",l=e,p=e.length,m=t,S=n):(I.assert(t==="js"||t==="dts"),o=(t==="js"?e.javascriptPath:e.declarationPath)||"",m=t==="js"?e.javascriptMapPath:e.declarationMapPath,h=()=>t==="js"?e.javascriptText:e.declarationText,b=()=>t==="js"?e.javascriptMapText:e.declarationMapText,p=()=>h().length,e.buildInfo&&e.buildInfo.bundle&&(I.assert(n===void 0||typeof n=="boolean"),i=n,s=t==="js"?e.buildInfo.bundle.js:e.buildInfo.bundle.dts,A=e.oldFileOfCurrentEmit));let k=A?Gyt(I.checkDefined(s)):Wyt(s,i,p);return k.fileName=o,k.sourceMapPath=m,k.oldFileOfCurrentEmit=A,h&&b?(Object.defineProperty(k,"text",{get:h}),Object.defineProperty(k,"sourceMapText",{get:b})):(I.assert(!A),k.text=l??"",k.sourceMapText=S),k}function Wyt(e,t,n){let i,s,o,l,p,m,S,h;for(let A of e?e.sections:tt)switch(A.kind){case"prologue":i=Pr(i,ft(j.createUnparsedPrologue(A.data),A));break;case"emitHelpers":s=Pr(s,kK().get(A.data));break;case"no-default-lib":h=!0;break;case"reference":o=Pr(o,{pos:-1,end:-1,fileName:A.data});break;case"type":l=Pr(l,{pos:-1,end:-1,fileName:A.data});break;case"type-import":l=Pr(l,{pos:-1,end:-1,fileName:A.data,resolutionMode:99});break;case"type-require":l=Pr(l,{pos:-1,end:-1,fileName:A.data,resolutionMode:1});break;case"lib":p=Pr(p,{pos:-1,end:-1,fileName:A.data});break;case"prepend":let k;for(let N of A.texts)(!t||N.kind!=="internal")&&(k=Pr(k,ft(j.createUnparsedTextLike(N.data,N.kind==="internal"),N)));m=jt(m,k),S=Pr(S,j.createUnparsedPrepend(A.data,k??tt));break;case"internal":if(t){S||(S=[]);break}case"text":S=Pr(S,ft(j.createUnparsedTextLike(A.data,A.kind==="internal"),A));break;default:I.assertNever(A)}if(!S){let A=j.createUnparsedTextLike(void 0,!1);T6(A,0,typeof n=="function"?n():n),S=[A]}let b=$h.createUnparsedSource(i??tt,void 0,S);return MN(i,b),MN(S,b),MN(m,b),b.hasNoDefaultLib=h,b.helpers=s,b.referencedFiles=o||tt,b.typeReferenceDirectives=l,b.libReferenceDirectives=p||tt,b}function Gyt(e){let t,n;for(let s of e.sections)switch(s.kind){case"internal":case"text":t=Pr(t,ft(j.createUnparsedTextLike(s.data,s.kind==="internal"),s));break;case"no-default-lib":case"reference":case"type":case"type-import":case"type-require":case"lib":n=Pr(n,ft(j.createUnparsedSyntheticReference(s),s));break;case"prologue":case"emitHelpers":case"prepend":break;default:I.assertNever(s)}let i=j.createUnparsedSource(tt,n,t??tt);return MN(n,i),MN(t,i),i.helpers=vr(e.sources&&e.sources.helpers,s=>kK().get(s)),i}function E3e(e,t,n,i,s,o){return vs(e)?SK(void 0,e,n,i,void 0,t,s,o):vK(e,t,n,i,s,o)}function vK(e,t,n,i,s,o,l,p){let m=$h.createInputFiles();m.javascriptPath=t,m.javascriptMapPath=n,m.declarationPath=i,m.declarationMapPath=s,m.buildInfoPath=o;let S=new Map,h=N=>{if(N===void 0)return;let M=S.get(N);return M===void 0&&(M=e(N),S.set(N,M!==void 0?M:!1)),M!==!1?M:void 0},b=N=>{let M=h(N);return M!==void 0?M:`/* Input file ${N} was missing */\r
`},A;return Object.defineProperties(m,{javascriptText:{get:()=>b(t)},javascriptMapText:{get:()=>h(n)},declarationText:{get:()=>b(I.checkDefined(i))},declarationMapText:{get:()=>h(s)},buildInfo:{get:()=>{if(A===void 0&&o)if(l?.getBuildInfo)A=l.getBuildInfo(o,p.configFilePath)??!1;else{let N=h(o);A=N!==void 0?mV(o,N)??!1:!1}return A||void 0}}}),m}function SK(e,t,n,i,s,o,l,p,m,S,h){let b=$h.createInputFiles();return b.javascriptPath=e,b.javascriptText=t,b.javascriptMapPath=n,b.javascriptMapText=i,b.declarationPath=s,b.declarationText=o,b.declarationMapPath=l,b.declarationMapText=p,b.buildInfoPath=m,b.buildInfo=S,b.oldFileOfCurrentEmit=h,b}function x3e(e,t,n){return new(A3e||(A3e=Ju.getSourceMapSourceConstructor()))(e,t,n)}function Un(e,t){if(e.original!==t&&(e.original=t,t)){let n=t.emitNode;n&&(e.emitNode=Hyt(n,e.emitNode))}return e}function Hyt(e,t){let{flags:n,internalFlags:i,leadingComments:s,trailingComments:o,commentRange:l,sourceMapRange:p,tokenSourceMapRanges:m,constantValue:S,helpers:h,startsOnNewLine:b,snippetElement:A,classThis:k,assignedName:N}=e;if(t||(t={}),n&&(t.flags=n),i&&(t.internalFlags=i&-9),s&&(t.leadingComments=jt(s.slice(),t.leadingComments)),o&&(t.trailingComments=jt(o.slice(),t.trailingComments)),l&&(t.commentRange=l),p&&(t.sourceMapRange=p),m&&(t.tokenSourceMapRanges=Yyt(m,t.tokenSourceMapRanges)),S!==void 0&&(t.constantValue=S),h)for(let M of h)t.helpers=ai(t.helpers,M);return b!==void 0&&(t.startsOnNewLine=b),A!==void 0&&(t.snippetElement=A),k&&(t.classThis=k),N&&(t.assignedName=N),t}function Yyt(e,t){t||(t=[]);for(let n in e)t[n]=e[n];return t}var SB,TK,rge,O1,nge,ER,C3e,j,A3e,Xyt=f({"src/compiler/factory/nodeFactory.ts"(){"use strict";fa(),SB=0,TK=(e=>(e[e.None=0]="None",e[e.NoParenthesizerRules=1]="NoParenthesizerRules",e[e.NoNodeConverters=2]="NoNodeConverters",e[e.NoIndentationOnFreshPropertyAccess=4]="NoIndentationOnFreshPropertyAccess",e[e.NoOriginalNode=8]="NoOriginalNode",e))(TK||{}),rge=[],nge={},ER=Qme(),C3e={createBaseSourceFileNode:e=>vB(ER.createBaseSourceFileNode(e)),createBaseIdentifierNode:e=>vB(ER.createBaseIdentifierNode(e)),createBasePrivateIdentifierNode:e=>vB(ER.createBasePrivateIdentifierNode(e)),createBaseTokenNode:e=>vB(ER.createBaseTokenNode(e)),createBaseNode:e=>vB(ER.createBaseNode(e))},j=TR(4,C3e)}});function b_(e){if(e.emitNode)I.assert(!(e.emitNode.internalFlags&8),"Invalid attempt to mutate an immutable node.");else{if(Pw(e)){if(e.kind===312)return e.emitNode={annotatedNodes:[e]};let t=Xr(Us(Xr(e)))??I.fail("Could not determine parsed source file.");b_(t).annotatedNodes.push(e)}e.emitNode={}}return e.emitNode}function bK(e){var t,n;let i=(n=(t=Xr(Us(e)))==null?void 0:t.emitNode)==null?void 0:n.annotatedNodes;if(i)for(let s of i)s.emitNode=void 0}function xR(e){let t=b_(e);return t.flags|=3072,t.leadingComments=void 0,t.trailingComments=void 0,e}function Sn(e,t){return b_(e).flags=t,e}function Kg(e,t){let n=b_(e);return n.flags=n.flags|t,e}function CR(e,t){return b_(e).internalFlags=t,e}function BA(e,t){let n=b_(e);return n.internalFlags=n.internalFlags|t,e}function R1(e){var t;return((t=e.emitNode)==null?void 0:t.sourceMapRange)??e}function qa(e,t){return b_(e).sourceMapRange=t,e}function k3e(e,t){var n,i;return(i=(n=e.emitNode)==null?void 0:n.tokenSourceMapRanges)==null?void 0:i[t]}function ige(e,t,n){let i=b_(e),s=i.tokenSourceMapRanges??(i.tokenSourceMapRanges=[]);return s[t]=n,e}function I6(e){var t;return(t=e.emitNode)==null?void 0:t.startsOnNewLine}function TB(e,t){return b_(e).startsOnNewLine=t,e}function Qg(e){var t;return((t=e.emitNode)==null?void 0:t.commentRange)??e}function kl(e,t){return b_(e).commentRange=t,e}function BN(e){var t;return(t=e.emitNode)==null?void 0:t.leadingComments}function CT(e,t){return b_(e).leadingComments=t,e}function w6(e,t,n,i){return CT(e,Pr(BN(e),{kind:t,pos:-1,end:-1,hasTrailingNewLine:i,text:n}))}function AR(e){var t;return(t=e.emitNode)==null?void 0:t.trailingComments}function UA(e,t){return b_(e).trailingComments=t,e}function bB(e,t,n,i){return UA(e,Pr(AR(e),{kind:t,pos:-1,end:-1,hasTrailingNewLine:i,text:n}))}function sge(e,t){CT(e,BN(t)),UA(e,AR(t));let n=b_(t);return n.leadingComments=void 0,n.trailingComments=void 0,e}function age(e){var t;return(t=e.emitNode)==null?void 0:t.constantValue}function oge(e,t){let n=b_(e);return n.constantValue=t,e}function VA(e,t){let n=b_(e);return n.helpers=Pr(n.helpers,t),e}function Ny(e,t){if(Tt(t)){let n=b_(e);for(let i of t)n.helpers=ai(n.helpers,i)}return e}function P3e(e,t){var n;let i=(n=e.emitNode)==null?void 0:n.helpers;return i?lA(i,t):!1}function EB(e){var t;return(t=e.emitNode)==null?void 0:t.helpers}function cge(e,t,n){let i=e.emitNode,s=i&&i.helpers;if(!Tt(s))return;let o=b_(t),l=0;for(let p=0;p<s.length;p++){let m=s[p];n(m)?(l++,o.helpers=ai(o.helpers,m)):l>0&&(s[p-l]=m)}l>0&&(s.length-=l)}function EK(e){var t;return(t=e.emitNode)==null?void 0:t.snippetElement}function xK(e,t){let n=b_(e);return n.snippetElement=t,e}function CK(e){return b_(e).internalFlags|=4,e}function lge(e,t){let n=b_(e);return n.typeNode=t,e}function uge(e){var t;return(t=e.emitNode)==null?void 0:t.typeNode}function M1(e,t){return b_(e).identifierTypeArguments=t,e}function sx(e){var t;return(t=e.emitNode)==null?void 0:t.identifierTypeArguments}function kR(e,t){return b_(e).autoGenerate=t,e}function N3e(e){var t;return(t=e.emitNode)==null?void 0:t.autoGenerate}function _ge(e,t){return b_(e).generatedImportReference=t,e}function fge(e){var t;return(t=e.emitNode)==null?void 0:t.generatedImportReference}var Kyt=f({"src/compiler/factory/emitNode.ts"(){"use strict";fa()}});function pge(e){let t=e.factory,n=D_(()=>CR(t.createTrue(),8)),i=D_(()=>CR(t.createFalse(),8));return{getUnscopedHelperName:s,createDecorateHelper:o,createMetadataHelper:l,createParamHelper:p,createESDecorateHelper:M,createRunInitializersHelper:O,createAssignHelper:U,createAwaitHelper:H,createAsyncGeneratorHelper:K,createAsyncDelegatorHelper:re,createAsyncValuesHelper:$,createRestHelper:pe,createAwaiterHelper:z,createExtendsHelper:se,createTemplateObjectHelper:Se,createSpreadArrayHelper:xe,createPropKeyHelper:Z,createSetFunctionNameHelper:Q,createValuesHelper:ce,createReadHelper:ye,createGeneratorHelper:we,createCreateBindingHelper:ve,createImportStarHelper:oe,createImportStarCallbackHelper:Ee,createImportDefaultHelper:Me,createExportStarHelper:Ge,createClassPrivateFieldGetHelper:Ae,createClassPrivateFieldSetHelper:Ie,createClassPrivateFieldInHelper:Re,createAddDisposableResourceHelper:Ue,createDisposeResourcesHelper:kt};function s(ke){return Sn(t.createIdentifier(ke),8196)}function o(ke,$e,at,$t){e.requestEmitHelper(xB);let St=[];return St.push(t.createArrayLiteralExpression(ke,!0)),St.push($e),at&&(St.push(at),$t&&St.push($t)),t.createCallExpression(s("__decorate"),void 0,St)}function l(ke,$e){return e.requestEmitHelper(CB),t.createCallExpression(s("__metadata"),void 0,[t.createStringLiteral(ke),$e])}function p(ke,$e,at){return e.requestEmitHelper(AB),ft(t.createCallExpression(s("__param"),void 0,[t.createNumericLiteral($e+""),ke]),at)}function m(ke){let $e=[t.createPropertyAssignment(t.createIdentifier("kind"),t.createStringLiteral("class")),t.createPropertyAssignment(t.createIdentifier("name"),ke.name),t.createPropertyAssignment(t.createIdentifier("metadata"),ke.metadata)];return t.createObjectLiteralExpression($e)}function S(ke){let $e=ke.computed?t.createElementAccessExpression(t.createIdentifier("obj"),ke.name):t.createPropertyAccessExpression(t.createIdentifier("obj"),ke.name);return t.createPropertyAssignment("get",t.createArrowFunction(void 0,void 0,[t.createParameterDeclaration(void 0,void 0,t.createIdentifier("obj"))],void 0,void 0,$e))}function h(ke){let $e=ke.computed?t.createElementAccessExpression(t.createIdentifier("obj"),ke.name):t.createPropertyAccessExpression(t.createIdentifier("obj"),ke.name);return t.createPropertyAssignment("set",t.createArrowFunction(void 0,void 0,[t.createParameterDeclaration(void 0,void 0,t.createIdentifier("obj")),t.createParameterDeclaration(void 0,void 0,t.createIdentifier("value"))],void 0,void 0,t.createBlock([t.createExpressionStatement(t.createAssignment($e,t.createIdentifier("value")))])))}function b(ke){let $e=ke.computed?ke.name:ze(ke.name)?t.createStringLiteralFromNode(ke.name):ke.name;return t.createPropertyAssignment("has",t.createArrowFunction(void 0,void 0,[t.createParameterDeclaration(void 0,void 0,t.createIdentifier("obj"))],void 0,void 0,t.createBinaryExpression($e,103,t.createIdentifier("obj"))))}function A(ke,$e){let at=[];return at.push(b(ke)),$e.get&&at.push(S(ke)),$e.set&&at.push(h(ke)),t.createObjectLiteralExpression(at)}function k(ke){let $e=[t.createPropertyAssignment(t.createIdentifier("kind"),t.createStringLiteral(ke.kind)),t.createPropertyAssignment(t.createIdentifier("name"),ke.name.computed?ke.name.name:t.createStringLiteralFromNode(ke.name.name)),t.createPropertyAssignment(t.createIdentifier("static"),ke.static?t.createTrue():t.createFalse()),t.createPropertyAssignment(t.createIdentifier("private"),ke.private?t.createTrue():t.createFalse()),t.createPropertyAssignment(t.createIdentifier("access"),A(ke.name,ke.access)),t.createPropertyAssignment(t.createIdentifier("metadata"),ke.metadata)];return t.createObjectLiteralExpression($e)}function N(ke){return ke.kind==="class"?m(ke):k(ke)}function M(ke,$e,at,$t,St,Ze){return e.requestEmitHelper(kB),t.createCallExpression(s("__esDecorate"),void 0,[ke??t.createNull(),$e??t.createNull(),at,N($t),St,Ze])}function O(ke,$e,at){return e.requestEmitHelper(PB),t.createCallExpression(s("__runInitializers"),void 0,at?[ke,$e,at]:[ke,$e])}function U(ke){return ho(e.getCompilerOptions())>=2?t.createCallExpression(t.createPropertyAccessExpression(t.createIdentifier("Object"),"assign"),void 0,ke):(e.requestEmitHelper(NB),t.createCallExpression(s("__assign"),void 0,ke))}function H(ke){return e.requestEmitHelper(JA),t.createCallExpression(s("__await"),void 0,[ke])}function K(ke,$e){return e.requestEmitHelper(JA),e.requestEmitHelper(DB),(ke.emitNode||(ke.emitNode={})).flags|=1572864,t.createCallExpression(s("__asyncGenerator"),void 0,[$e?t.createThis():t.createVoidZero(),t.createIdentifier("arguments"),ke])}function re(ke){return e.requestEmitHelper(JA),e.requestEmitHelper(IB),t.createCallExpression(s("__asyncDelegator"),void 0,[ke])}function $(ke){return e.requestEmitHelper(wB),t.createCallExpression(s("__asyncValues"),void 0,[ke])}function pe(ke,$e,at,$t){e.requestEmitHelper(OB);let St=[],Ze=0;for(let yt=0;yt<$e.length-1;yt++){let ar=tQ($e[yt]);if(ar)if(uo(ar)){I.assertIsDefined(at,"Encountered computed property name but 'computedTempVariables' argument was not provided.");let or=at[Ze];Ze++,St.push(t.createConditionalExpression(t.createTypeCheck(or,"symbol"),void 0,or,void 0,t.createAdd(or,t.createStringLiteral(""))))}else St.push(t.createStringLiteralFromNode(ar))}return t.createCallExpression(s("__rest"),void 0,[ke,ft(t.createArrayLiteralExpression(St),$t)])}function z(ke,$e,at,$t,St){e.requestEmitHelper(RB);let Ze=t.createFunctionExpression(void 0,t.createToken(42),void 0,void 0,$t??[],void 0,St);return(Ze.emitNode||(Ze.emitNode={})).flags|=1572864,t.createCallExpression(s("__awaiter"),void 0,[ke?t.createThis():t.createVoidZero(),$e??t.createVoidZero(),at?JR(t,at):t.createVoidZero(),Ze])}function se(ke){return e.requestEmitHelper(MB),t.createCallExpression(s("__extends"),void 0,[ke,t.createUniqueName("_super",48)])}function Se(ke,$e){return e.requestEmitHelper(LB),t.createCallExpression(s("__makeTemplateObject"),void 0,[ke,$e])}function xe(ke,$e,at){return e.requestEmitHelper(jB),t.createCallExpression(s("__spreadArray"),void 0,[ke,$e,at?n():i()])}function Z(ke){return e.requestEmitHelper(BB),t.createCallExpression(s("__propKey"),void 0,[ke])}function Q(ke,$e,at){return e.requestEmitHelper(UB),e.factory.createCallExpression(s("__setFunctionName"),void 0,at?[ke,$e,e.factory.createStringLiteral(at)]:[ke,$e])}function ce(ke){return e.requestEmitHelper(VB),t.createCallExpression(s("__values"),void 0,[ke])}function ye(ke,$e){return e.requestEmitHelper(FB),t.createCallExpression(s("__read"),void 0,$e!==void 0?[ke,t.createNumericLiteral($e+"")]:[ke])}function we(ke){return e.requestEmitHelper(JB),t.createCallExpression(s("__generator"),void 0,[t.createThis(),ke])}function ve(ke,$e,at){return e.requestEmitHelper(UN),t.createCallExpression(s("__createBinding"),void 0,[t.createIdentifier("exports"),ke,$e,...at?[at]:[]])}function oe(ke){return e.requestEmitHelper(PR),t.createCallExpression(s("__importStar"),void 0,[ke])}function Ee(){return e.requestEmitHelper(PR),s("__importStar")}function Me(ke){return e.requestEmitHelper(zB),t.createCallExpression(s("__importDefault"),void 0,[ke])}function Ge(ke,$e=t.createIdentifier("exports")){return e.requestEmitHelper($B),e.requestEmitHelper(UN),t.createCallExpression(s("__exportStar"),void 0,[ke,$e])}function Ae(ke,$e,at,$t){e.requestEmitHelper(WB);let St;return $t?St=[ke,$e,t.createStringLiteral(at),$t]:St=[ke,$e,t.createStringLiteral(at)],t.createCallExpression(s("__classPrivateFieldGet"),void 0,St)}function Ie(ke,$e,at,$t,St){e.requestEmitHelper(GB);let Ze;return St?Ze=[ke,$e,at,t.createStringLiteral($t),St]:Ze=[ke,$e,at,t.createStringLiteral($t)],t.createCallExpression(s("__classPrivateFieldSet"),void 0,Ze)}function Re(ke,$e){return e.requestEmitHelper(HB),t.createCallExpression(s("__classPrivateFieldIn"),void 0,[ke,$e])}function Ue(ke,$e,at){return e.requestEmitHelper(YB),t.createCallExpression(s("__addDisposableResource"),void 0,[ke,$e,at?t.createTrue():t.createFalse()])}function kt(ke){return e.requestEmitHelper(XB),t.createCallExpression(s("__disposeResources"),void 0,[ke])}}function dge(e,t){return e===t||e.priority===t.priority?0:e.priority===void 0?1:t.priority===void 0?-1:To(e.priority,t.priority)}function AK(e,...t){return n=>{let i="";for(let s=0;s<t.length;s++)i+=e[s],i+=n(t[s]);return i+=e[e.length-1],i}}function kK(){return D3e||(D3e=il([xB,CB,AB,kB,PB,NB,JA,DB,IB,wB,OB,RB,MB,LB,jB,VB,FB,BB,UB,JB,PR,zB,$B,WB,GB,HB,UN,qB,YB,XB],e=>e.name))}function O6(e,t){return da(e)&&ze(e.expression)&&(eo(e.expression)&8192)!==0&&e.expression.escapedText===t}var PK,xB,CB,AB,kB,PB,NB,JA,DB,IB,wB,OB,RB,MB,LB,FB,jB,BB,UB,VB,JB,UN,qB,PR,zB,$B,WB,GB,HB,YB,XB,D3e,NR,DR,Qyt=f({"src/compiler/factory/emitHelpers.ts"(){"use strict";fa(),PK=(e=>(e.Field="f",e.Method="m",e.Accessor="a",e))(PK||{}),xB={name:"typescript:decorate",importName:"__decorate",scoped:!1,priority:2,text:`
            var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
                var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
                if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
                else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
                return c > 3 && r && Object.defineProperty(target, key, r), r;
            };`},CB={name:"typescript:metadata",importName:"__metadata",scoped:!1,priority:3,text:`
            var __metadata = (this && this.__metadata) || function (k, v) {
                if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
            };`},AB={name:"typescript:param",importName:"__param",scoped:!1,priority:4,text:`
            var __param = (this && this.__param) || function (paramIndex, decorator) {
                return function (target, key) { decorator(target, key, paramIndex); }
            };`},kB={name:"typescript:esDecorate",importName:"__esDecorate",scoped:!1,priority:2,text:`
        var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
            function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
            var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
            var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
            var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
            var _, done = false;
            for (var i = decorators.length - 1; i >= 0; i--) {
                var context = {};
                for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
                for (var p in contextIn.access) context.access[p] = contextIn.access[p];
                context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
                var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
                if (kind === "accessor") {
                    if (result === void 0) continue;
                    if (result === null || typeof result !== "object") throw new TypeError("Object expected");
                    if (_ = accept(result.get)) descriptor.get = _;
                    if (_ = accept(result.set)) descriptor.set = _;
                    if (_ = accept(result.init)) initializers.unshift(_);
                }
                else if (_ = accept(result)) {
                    if (kind === "field") initializers.unshift(_);
                    else descriptor[key] = _;
                }
            }
            if (target) Object.defineProperty(target, contextIn.name, descriptor);
            done = true;
        };`},PB={name:"typescript:runInitializers",importName:"__runInitializers",scoped:!1,priority:2,text:`
        var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
            var useValue = arguments.length > 2;
            for (var i = 0; i < initializers.length; i++) {
                value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
            }
            return useValue ? value : void 0;
        };`},NB={name:"typescript:assign",importName:"__assign",scoped:!1,priority:1,text:`
            var __assign = (this && this.__assign) || function () {
                __assign = Object.assign || function(t) {
                    for (var s, i = 1, n = arguments.length; i < n; i++) {
                        s = arguments[i];
                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                            t[p] = s[p];
                    }
                    return t;
                };
                return __assign.apply(this, arguments);
            };`},JA={name:"typescript:await",importName:"__await",scoped:!1,text:`
            var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }`},DB={name:"typescript:asyncGenerator",importName:"__asyncGenerator",scoped:!1,dependencies:[JA],text:`
        var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
            if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
            var g = generator.apply(thisArg, _arguments || []), i, q = [];
            return i = {}, verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function () { return this; }, i;
            function awaitReturn(f) { return function (v) { return Promise.resolve(v).then(f, reject); }; }
            function verb(n, f) { if (g[n]) { i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; if (f) i[n] = f(i[n]); } }
            function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
            function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
            function fulfill(value) { resume("next", value); }
            function reject(value) { resume("throw", value); }
            function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
        };`},IB={name:"typescript:asyncDelegator",importName:"__asyncDelegator",scoped:!1,dependencies:[JA],text:`
            var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {
                var i, p;
                return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
                function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
            };`},wB={name:"typescript:asyncValues",importName:"__asyncValues",scoped:!1,text:`
            var __asyncValues = (this && this.__asyncValues) || function (o) {
                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
                var m = o[Symbol.asyncIterator], i;
                return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
                function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
                function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
            };`},OB={name:"typescript:rest",importName:"__rest",scoped:!1,text:`
            var __rest = (this && this.__rest) || function (s, e) {
                var t = {};
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                    t[p] = s[p];
                if (s != null && typeof Object.getOwnPropertySymbols === "function")
                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                            t[p[i]] = s[p[i]];
                    }
                return t;
            };`},RB={name:"typescript:awaiter",importName:"__awaiter",scoped:!1,priority:5,text:`
            var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            };`},MB={name:"typescript:extends",importName:"__extends",scoped:!1,priority:0,text:`
            var __extends = (this && this.__extends) || (function () {
                var extendStatics = function (d, b) {
                    extendStatics = Object.setPrototypeOf ||
                        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
                    return extendStatics(d, b);
                };

                return function (d, b) {
                    if (typeof b !== "function" && b !== null)
                        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
                    extendStatics(d, b);
                    function __() { this.constructor = d; }
                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
                };
            })();`},LB={name:"typescript:makeTemplateObject",importName:"__makeTemplateObject",scoped:!1,priority:0,text:`
            var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
                if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
                return cooked;
            };`},FB={name:"typescript:read",importName:"__read",scoped:!1,text:`
            var __read = (this && this.__read) || function (o, n) {
                var m = typeof Symbol === "function" && o[Symbol.iterator];
                if (!m) return o;
                var i = m.call(o), r, ar = [], e;
                try {
                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
                }
                catch (error) { e = { error: error }; }
                finally {
                    try {
                        if (r && !r.done && (m = i["return"])) m.call(i);
                    }
                    finally { if (e) throw e.error; }
                }
                return ar;
            };`},jB={name:"typescript:spreadArray",importName:"__spreadArray",scoped:!1,text:`
            var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
                if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
                    if (ar || !(i in from)) {
                        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                        ar[i] = from[i];
                    }
                }
                return to.concat(ar || Array.prototype.slice.call(from));
            };`},BB={name:"typescript:propKey",importName:"__propKey",scoped:!1,text:`
        var __propKey = (this && this.__propKey) || function (x) {
            return typeof x === "symbol" ? x : "".concat(x);
        };`},UB={name:"typescript:setFunctionName",importName:"__setFunctionName",scoped:!1,text:`
        var __setFunctionName = (this && this.__setFunctionName) || function (f, name, prefix) {
            if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
            return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
        };`},VB={name:"typescript:values",importName:"__values",scoped:!1,text:`
            var __values = (this && this.__values) || function(o) {
                var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
                if (m) return m.call(o);
                if (o && typeof o.length === "number") return {
                    next: function () {
                        if (o && i >= o.length) o = void 0;
                        return { value: o && o[i++], done: !o };
                    }
                };
                throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
            };`},JB={name:"typescript:generator",importName:"__generator",scoped:!1,priority:6,text:`
            var __generator = (this && this.__generator) || function (thisArg, body) {
                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
                function verb(n) { return function (v) { return step([n, v]); }; }
                function step(op) {
                    if (f) throw new TypeError("Generator is already executing.");
                    while (g && (g = 0, op[0] && (_ = 0)), _) try {
                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                        if (y = 0, t) op = [op[0] & 2, t.value];
                        switch (op[0]) {
                            case 0: case 1: t = op; break;
                            case 4: _.label++; return { value: op[1], done: false };
                            case 5: _.label++; y = op[1]; op = [0]; continue;
                            case 7: op = _.ops.pop(); _.trys.pop(); continue;
                            default:
                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                                if (t[2]) _.ops.pop();
                                _.trys.pop(); continue;
                        }
                        op = body.call(thisArg, _);
                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
                }
            };`},UN={name:"typescript:commonjscreatebinding",importName:"__createBinding",scoped:!1,priority:1,text:`
            var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
                if (k2 === undefined) k2 = k;
                var desc = Object.getOwnPropertyDescriptor(m, k);
                if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
                  desc = { enumerable: true, get: function() { return m[k]; } };
                }
                Object.defineProperty(o, k2, desc);
            }) : (function(o, m, k, k2) {
                if (k2 === undefined) k2 = k;
                o[k2] = m[k];
            }));`},qB={name:"typescript:commonjscreatevalue",importName:"__setModuleDefault",scoped:!1,priority:1,text:`
            var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
                Object.defineProperty(o, "default", { enumerable: true, value: v });
            }) : function(o, v) {
                o["default"] = v;
            });`},PR={name:"typescript:commonjsimportstar",importName:"__importStar",scoped:!1,dependencies:[UN,qB],priority:2,text:`
            var __importStar = (this && this.__importStar) || function (mod) {
                if (mod && mod.__esModule) return mod;
                var result = {};
                if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
                __setModuleDefault(result, mod);
                return result;
            };`},zB={name:"typescript:commonjsimportdefault",importName:"__importDefault",scoped:!1,text:`
            var __importDefault = (this && this.__importDefault) || function (mod) {
                return (mod && mod.__esModule) ? mod : { "default": mod };
            };`},$B={name:"typescript:export-star",importName:"__exportStar",scoped:!1,dependencies:[UN],priority:2,text:`
            var __exportStar = (this && this.__exportStar) || function(m, exports) {
                for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
            };`},WB={name:"typescript:classPrivateFieldGet",importName:"__classPrivateFieldGet",scoped:!1,text:`
            var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
                return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
            };`},GB={name:"typescript:classPrivateFieldSet",importName:"__classPrivateFieldSet",scoped:!1,text:`
            var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
                if (kind === "m") throw new TypeError("Private method is not writable");
                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
                return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
            };`},HB={name:"typescript:classPrivateFieldIn",importName:"__classPrivateFieldIn",scoped:!1,text:`
            var __classPrivateFieldIn = (this && this.__classPrivateFieldIn) || function(state, receiver) {
                if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function")) throw new TypeError("Cannot use 'in' operator on non-object");
                return typeof state === "function" ? receiver === state : state.has(receiver);
            };`},YB={name:"typescript:addDisposableResource",importName:"__addDisposableResource",scoped:!1,text:`
        var __addDisposableResource = (this && this.__addDisposableResource) || function (env, value, async) {
            if (value !== null && value !== void 0) {
                if (typeof value !== "object" && typeof value !== "function") throw new TypeError("Object expected.");
                var dispose;
                if (async) {
                    if (!Symbol.asyncDispose) throw new TypeError("Symbol.asyncDispose is not defined.");
                    dispose = value[Symbol.asyncDispose];
                }
                if (dispose === void 0) {
                    if (!Symbol.dispose) throw new TypeError("Symbol.dispose is not defined.");
                    dispose = value[Symbol.dispose];
                }
                if (typeof dispose !== "function") throw new TypeError("Object not disposable.");
                env.stack.push({ value: value, dispose: dispose, async: async });
            }
            else if (async) {
                env.stack.push({ async: true });
            }
            return value;
        };`},XB={name:"typescript:disposeResources",importName:"__disposeResources",scoped:!1,text:`
        var __disposeResources = (this && this.__disposeResources) || (function (SuppressedError) {
            return function (env) {
                function fail(e) {
                    env.error = env.hasError ? new SuppressedError(e, env.error, "An error was suppressed during disposal.") : e;
                    env.hasError = true;
                }
                function next() {
                    while (env.stack.length) {
                        var rec = env.stack.pop();
                        try {
                            var result = rec.dispose && rec.dispose.call(rec.value);
                            if (rec.async) return Promise.resolve(result).then(next, function(e) { fail(e); return next(); });
                        }
                        catch (e) {
                            fail(e);
                        }
                    }
                    if (env.hasError) throw env.error;
                }
                return next();
            };
        })(typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
            var e = new Error(message);
            return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
        });`},NR={name:"typescript:async-super",scoped:!0,text:AK`
            const ${"_superIndex"} = name => super[name];`},DR={name:"typescript:advanced-async-super",scoped:!0,text:AK`
            const ${"_superIndex"} = (function (geti, seti) {
                const cache = Object.create(null);
                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });
            })(name => super[name], (name, value) => super[name] = value);`}}});function _p(e){return e.kind===9}function KB(e){return e.kind===10}function za(e){return e.kind===11}function qA(e){return e.kind===12}function NK(e){return e.kind===14}function zA(e){return e.kind===15}function $A(e){return e.kind===16}function DK(e){return e.kind===17}function QB(e){return e.kind===18}function ZB(e){return e.kind===26}function mge(e){return e.kind===28}function IK(e){return e.kind===40}function wK(e){return e.kind===41}function IR(e){return e.kind===42}function wR(e){return e.kind===54}function Xv(e){return e.kind===58}function gge(e){return e.kind===59}function eU(e){return e.kind===29}function hge(e){return e.kind===39}function ze(e){return e.kind===80}function is(e){return e.kind===81}function WA(e){return e.kind===95}function tU(e){return e.kind===90}function R6(e){return e.kind===134}function yge(e){return e.kind===131}function OK(e){return e.kind===135}function vge(e){return e.kind===148}function GA(e){return e.kind===126}function Sge(e){return e.kind===128}function Tge(e){return e.kind===164}function bge(e){return e.kind===129}function M6(e){return e.kind===108}function L6(e){return e.kind===102}function Ege(e){return e.kind===84}function pf(e){return e.kind===166}function uo(e){return e.kind===167}function Nc(e){return e.kind===168}function Ls(e){return e.kind===169}function n_(e){return e.kind===170}function fp(e){return e.kind===171}function ea(e){return e.kind===172}function Uh(e){return e.kind===173}function pl(e){return e.kind===174}function Jc(e){return e.kind===175}function Yc(e){return e.kind===176}function sd(e){return e.kind===177}function pp(e){return e.kind===178}function HA(e){return e.kind===179}function OR(e){return e.kind===180}function oE(e){return e.kind===181}function RR(e){return e.kind===182}function Id(e){return e.kind===183}function Vh(e){return e.kind===184}function VN(e){return e.kind===185}function YA(e){return e.kind===186}function dp(e){return e.kind===187}function MR(e){return e.kind===188}function XA(e){return e.kind===189}function JN(e){return e.kind===202}function rU(e){return e.kind===190}function nU(e){return e.kind===191}function Kv(e){return e.kind===192}function KA(e){return e.kind===193}function QA(e){return e.kind===194}function ax(e){return e.kind===195}function ox(e){return e.kind===196}function LR(e){return e.kind===197}function cx(e){return e.kind===198}function lx(e){return e.kind===199}function qN(e){return e.kind===200}function Qv(e){return e.kind===201}function M0(e){return e.kind===205}function RK(e){return e.kind===204}function xge(e){return e.kind===203}function pm(e){return e.kind===206}function cE(e){return e.kind===207}function co(e){return e.kind===208}function Z_(e){return e.kind===209}function Ha(e){return e.kind===210}function Hn(e){return e.kind===211}function fc(e){return e.kind===212}function da(e){return e.kind===213}function lE(e){return e.kind===214}function uE(e){return e.kind===215}function Cge(e){return e.kind===216}function Df(e){return e.kind===217}function Xo(e){return e.kind===218}function rc(e){return e.kind===219}function Age(e){return e.kind===220}function zN(e){return e.kind===221}function ZA(e){return e.kind===222}function Zv(e){return e.kind===223}function eS(e){return e.kind===224}function MK(e){return e.kind===225}function bn(e){return e.kind===226}function $N(e){return e.kind===227}function iU(e){return e.kind===228}function sU(e){return e.kind===229}function fg(e){return e.kind===230}function wu(e){return e.kind===231}function Su(e){return e.kind===232}function L1(e){return e.kind===233}function FR(e){return e.kind===234}function LK(e){return e.kind===238}function ek(e){return e.kind===235}function F6(e){return e.kind===236}function I3e(e){return e.kind===237}function aU(e){return e.kind===360}function j6(e){return e.kind===361}function B6(e){return e.kind===239}function kge(e){return e.kind===240}function ra(e){return e.kind===241}function Xc(e){return e.kind===243}function FK(e){return e.kind===242}function Ou(e){return e.kind===244}function ux(e){return e.kind===245}function w3e(e){return e.kind===246}function O3e(e){return e.kind===247}function _x(e){return e.kind===248}function oU(e){return e.kind===249}function jR(e){return e.kind===250}function R3e(e){return e.kind===251}function M3e(e){return e.kind===252}function Um(e){return e.kind===253}function Pge(e){return e.kind===254}function U6(e){return e.kind===255}function _E(e){return e.kind===256}function jK(e){return e.kind===257}function fx(e){return e.kind===258}function L3e(e){return e.kind===259}function Gi(e){return e.kind===260}function Tu(e){return e.kind===261}function Zl(e){return e.kind===262}function eu(e){return e.kind===263}function ef(e){return e.kind===264}function Vm(e){return e.kind===265}function AT(e){return e.kind===266}function hl(e){return e.kind===267}function Zg(e){return e.kind===268}function V6(e){return e.kind===269}function BR(e){return e.kind===270}function Ru(e){return e.kind===271}function uu(e){return e.kind===272}function Jh(e){return e.kind===273}function F3e(e){return e.kind===302}function Nge(e){return e.kind===300}function j3e(e){return e.kind===301}function tk(e){return e.kind===300}function Dge(e){return e.kind===301}function tS(e){return e.kind===274}function qh(e){return e.kind===280}function Dy(e){return e.kind===275}function Gf(e){return e.kind===276}function Kc(e){return e.kind===277}function yl(e){return e.kind===278}function wd(e){return e.kind===279}function R_(e){return e.kind===281}function B3e(e){return e.kind===282}function BK(e){return e.kind===359}function rk(e){return e.kind===362}function zh(e){return e.kind===283}function L0(e){return e.kind===284}function px(e){return e.kind===285}function eh(e){return e.kind===286}function fE(e){return e.kind===287}function pE(e){return e.kind===288}function nk(e){return e.kind===289}function Ige(e){return e.kind===290}function th(e){return e.kind===291}function dE(e){return e.kind===292}function ik(e){return e.kind===293}function J6(e){return e.kind===294}function pg(e){return e.kind===295}function WN(e){return e.kind===296}function q6(e){return e.kind===297}function ad(e){return e.kind===298}function mE(e){return e.kind===299}function Ul(e){return e.kind===303}function Hf(e){return e.kind===304}function F1(e){return e.kind===305}function gE(e){return e.kind===306}function wge(e){return e.kind===308}function ls(e){return e.kind===312}function UK(e){return e.kind===313}function dx(e){return e.kind===314}function hE(e){return e.kind===316}function z6(e){return e.kind===317}function kT(e){return e.kind===318}function Oge(e){return e.kind===331}function Rge(e){return e.kind===332}function U3e(e){return e.kind===333}function Mge(e){return e.kind===319}function Lge(e){return e.kind===320}function GN(e){return e.kind===321}function cU(e){return e.kind===322}function VK(e){return e.kind===323}function HN(e){return e.kind===324}function lU(e){return e.kind===325}function V3e(e){return e.kind===326}function dg(e){return e.kind===327}function mx(e){return e.kind===329}function PT(e){return e.kind===330}function sk(e){return e.kind===335}function J3e(e){return e.kind===337}function Fge(e){return e.kind===339}function JK(e){return e.kind===345}function qK(e){return e.kind===340}function zK(e){return e.kind===341}function $K(e){return e.kind===342}function WK(e){return e.kind===343}function uU(e){return e.kind===344}function YN(e){return e.kind===346}function GK(e){return e.kind===338}function q3e(e){return e.kind===354}function UR(e){return e.kind===347}function mg(e){return e.kind===348}function _U(e){return e.kind===349}function HK(e){return e.kind===350}function $6(e){return e.kind===351}function dm(e){return e.kind===352}function gx(e){return e.kind===353}function z3e(e){return e.kind===334}function jge(e){return e.kind===355}function fU(e){return e.kind===336}function pU(e){return e.kind===357}function $3e(e){return e.kind===356}function XN(e){return e.kind===358}var Zyt=f({"src/compiler/factory/nodeTests.ts"(){"use strict";fa()}});function VR(e){return e.createExportDeclaration(void 0,!1,e.createNamedExports([]),void 0)}function hx(e,t,n,i){if(uo(n))return ft(e.createElementAccessExpression(t,n.expression),i);{let s=ft(E0(n)?e.createPropertyAccessExpression(t,n):e.createElementAccessExpression(t,n),n);return Kg(s,128),s}}function Bge(e,t){let n=$h.createIdentifier(e||"React");return io(n,Us(t)),n}function Uge(e,t,n){if(pf(t)){let i=Uge(e,t.left,n),s=e.createIdentifier(Nn(t.right));return s.escapedText=t.right.escapedText,e.createPropertyAccessExpression(i,s)}else return Bge(Nn(t),n)}function YK(e,t,n,i){return t?Uge(e,t,i):e.createPropertyAccessExpression(Bge(n,i),"createElement")}function e1t(e,t,n,i){return t?Uge(e,t,i):e.createPropertyAccessExpression(Bge(n,i),"Fragment")}function Vge(e,t,n,i,s,o){let l=[n];if(i&&l.push(i),s&&s.length>0)if(i||l.push(e.createNull()),s.length>1)for(let p of s)M_(p),l.push(p);else l.push(s[0]);return ft(e.createCallExpression(t,void 0,l),o)}function Jge(e,t,n,i,s,o,l){let m=[e1t(e,n,i,o),e.createNull()];if(s&&s.length>0)if(s.length>1)for(let S of s)M_(S),m.push(S);else m.push(s[0]);return ft(e.createCallExpression(YK(e,t,i,o),void 0,m),l)}function XK(e,t,n){if(Tu(t)){let i=di(t.declarations),s=e.updateVariableDeclaration(i,i.name,void 0,void 0,n);return ft(e.createVariableStatement(void 0,e.updateVariableDeclarationList(t,[s])),t)}else{let i=ft(e.createAssignment(t,n),t);return ft(e.createExpressionStatement(i),t)}}function W3e(e,t,n){return ra(t)?e.updateBlock(t,ft(e.createNodeArray([n,...t.statements]),t.statements)):e.createBlock(e.createNodeArray([t,n]),!0)}function JR(e,t){if(pf(t)){let n=JR(e,t.left),i=io(ft(e.cloneNode(t.right),t.right),t.right.parent);return ft(e.createPropertyAccessExpression(n,i),t)}else return io(ft(e.cloneNode(t),t),t.parent)}function KK(e,t){return ze(t)?e.createStringLiteralFromNode(t):uo(t)?io(ft(e.cloneNode(t.expression),t.expression),t.expression.parent):io(ft(e.cloneNode(t),t),t.parent)}function t1t(e,t,n,i,s){let{firstAccessor:o,getAccessor:l,setAccessor:p}=tx(t,n);if(n===o)return ft(e.createObjectDefinePropertyCall(i,KK(e,n.name),e.createPropertyDescriptor({enumerable:e.createFalse(),configurable:!0,get:l&&ft(Un(e.createFunctionExpression(jb(l),void 0,void 0,void 0,l.parameters,void 0,l.body),l),l),set:p&&ft(Un(e.createFunctionExpression(jb(p),void 0,void 0,void 0,p.parameters,void 0,p.body),p),p)},!s)),o)}function r1t(e,t,n){return Un(ft(e.createAssignment(hx(e,n,t.name,t.name),t.initializer),t),t)}function n1t(e,t,n){return Un(ft(e.createAssignment(hx(e,n,t.name,t.name),e.cloneNode(t.name)),t),t)}function i1t(e,t,n){return Un(ft(e.createAssignment(hx(e,n,t.name,t.name),Un(ft(e.createFunctionExpression(jb(t),t.asteriskToken,void 0,void 0,t.parameters,void 0,t.body),t),t)),t),t)}function qge(e,t,n,i){switch(n.name&&is(n.name)&&I.failBadSyntaxKind(n.name,"Private identifiers are not allowed in object literals."),n.kind){case 177:case 178:return t1t(e,t.properties,n,i,!!t.multiLine);case 303:return r1t(e,n,i);case 304:return n1t(e,n,i);case 174:return i1t(e,n,i)}}function dU(e,t,n,i,s){let o=t.operator;I.assert(o===46||o===47,"Expected 'node' to be a pre- or post-increment or pre- or post-decrement expression");let l=e.createTempVariable(i);n=e.createAssignment(l,n),ft(n,t.operand);let p=eS(t)?e.createPrefixUnaryExpression(o,l):e.createPostfixUnaryExpression(l,o);return ft(p,t),s&&(p=e.createAssignment(s,p),ft(p,t)),n=e.createComma(n,p),ft(n,t),MK(t)&&(n=e.createComma(n,l),ft(n,t)),n}function QK(e){return(eo(e)&65536)!==0}function Iy(e){return(eo(e)&32768)!==0}function mU(e){return(eo(e)&16384)!==0}function G3e(e){return za(e.expression)&&e.expression.text==="use strict"}function ZK(e){for(let t of e)if(Fm(t)){if(G3e(t))return t}else break}function zge(e){let t=qi(e);return t!==void 0&&Fm(t)&&G3e(t)}function qR(e){return e.kind===226&&e.operatorToken.kind===28}function W6(e){return qR(e)||j6(e)}function KN(e){return Df(e)&&gn(e)&&!!_T(e)}function gU(e){let t=fT(e);return I.assertIsDefined(t),t}function hU(e,t=15){switch(e.kind){case 217:return t&16&&KN(e)?!1:(t&1)!==0;case 216:case 234:case 233:case 238:return(t&2)!==0;case 235:return(t&4)!==0;case 360:return(t&8)!==0}return!1}function vl(e,t=15){for(;hU(e,t);)e=e.expression;return e}function $ge(e,t=15){let n=e.parent;for(;hU(n,t);)n=n.parent,I.assert(n);return n}function H3e(e){return vl(e,6)}function M_(e){return TB(e,!0)}function zR(e){let t=Hc(e,ls),n=t&&t.emitNode;return n&&n.externalHelpersModuleName}function Wge(e){let t=Hc(e,ls),n=t&&t.emitNode;return!!n&&(!!n.externalHelpersModuleName||!!n.externalHelpers)}function eQ(e,t,n,i,s,o,l){if(i.importHelpers&&bA(n,i)){let p,m=T_(i);if(m>=5&&m<=99||n.impliedNodeFormat===99){let S=EB(n);if(S){let h=[];for(let b of S)if(!b.scoped){let A=b.importName;A&&ln(h,A)}if(Tt(h)){h.sort(h_),p=e.createNamedImports(vr(h,k=>q9(n,k)?e.createImportSpecifier(!1,void 0,e.createIdentifier(k)):e.createImportSpecifier(!1,e.createIdentifier(k),t.getUnscopedHelperName(k))));let b=Hc(n,ls),A=b_(b);A.externalHelpers=!0}}}else{let S=Gge(e,n,i,s,o||l);S&&(p=e.createNamespaceImport(S))}if(p){let S=e.createImportDeclaration(void 0,e.createImportClause(!1,void 0,p),e.createStringLiteral(Gv),void 0);return BA(S,2),S}}}function Gge(e,t,n,i,s){if(n.importHelpers&&bA(t,n)){let o=zR(t);if(o)return o;let l=T_(n),p=(i||Bh(n)&&s)&&l!==4&&(l<5||t.impliedNodeFormat===1);if(!p){let m=EB(t);if(m){for(let S of m)if(!S.scoped){p=!0;break}}}if(p){let m=Hc(t,ls),S=b_(m);return S.externalHelpersModuleName||(S.externalHelpersModuleName=e.createUniqueName(Gv))}}}function QN(e,t,n){let i=gN(t);if(i&&!xA(t)&&!$9(t)){let s=i.name;return yc(s)?s:e.createIdentifier(Jb(n,s)||Nn(s))}if(t.kind===272&&t.importClause||t.kind===278&&t.moduleSpecifier)return e.getGeneratedNameForNode(t)}function ak(e,t,n,i,s,o){let l=mN(t);if(l&&za(l))return a1t(t,i,e,s,o)||s1t(e,l,n)||e.cloneNode(l)}function s1t(e,t,n){let i=n.renamedDependencies&&n.renamedDependencies.get(t.text);return i?e.createStringLiteral(i):void 0}function $R(e,t,n,i){if(t){if(t.moduleName)return e.createStringLiteral(t.moduleName);if(!t.isDeclarationFile&&Wo(i))return e.createStringLiteral(hX(n,t.fileName))}}function a1t(e,t,n,i,s){return $R(n,i.getExternalModuleFileFromDeclaration(e),t,s)}function WR(e){if(n8(e))return e.initializer;if(Ul(e)){let t=e.initializer;return lu(t,!0)?t.right:void 0}if(Hf(e))return e.objectAssignmentInitializer;if(lu(e,!0))return e.right;if(fg(e))return WR(e.expression)}function rS(e){if(n8(e))return e.name;if(by(e)){switch(e.kind){case 303:return rS(e.initializer);case 304:return e.name;case 305:return rS(e.expression)}return}return lu(e,!0)?rS(e.left):fg(e)?rS(e.expression):e}function yU(e){switch(e.kind){case 169:case 208:return e.dotDotDotToken;case 230:case 305:return e}}function tQ(e){let t=vU(e);return I.assert(!!t||F1(e),"Invalid property name for binding element."),t}function vU(e){switch(e.kind){case 208:if(e.propertyName){let n=e.propertyName;return is(n)?I.failBadSyntaxKind(n):uo(n)&&Y3e(n.expression)?n.expression:n}break;case 303:if(e.name){let n=e.name;return is(n)?I.failBadSyntaxKind(n):uo(n)&&Y3e(n.expression)?n.expression:n}break;case 305:return e.name&&is(e.name)?I.failBadSyntaxKind(e.name):e.name}let t=rS(e);if(t&&Al(t))return t}function Y3e(e){let t=e.kind;return t===11||t===9}function ZN(e){switch(e.kind){case 206:case 207:case 209:return e.elements;case 210:return e.properties}}function rQ(e){if(e){let t=e;for(;;){if(ze(t)||!t.body)return ze(t)?t:t.name;t=t.body}}}function X3e(e){let t=e.kind;return t===176||t===178}function Hge(e){let t=e.kind;return t===176||t===177||t===178}function nQ(e){let t=e.kind;return t===303||t===304||t===262||t===176||t===181||t===175||t===282||t===243||t===264||t===265||t===266||t===267||t===271||t===272||t===270||t===278||t===277}function Yge(e){let t=e.kind;return t===175||t===303||t===304||t===282||t===270}function Xge(e){return Xv(e)||wR(e)}function Kge(e){return ze(e)||LR(e)}function Qge(e){return vge(e)||IK(e)||wK(e)}function Zge(e){return Xv(e)||IK(e)||wK(e)}function ehe(e){return ze(e)||za(e)}function K3e(e){let t=e.kind;return t===106||t===112||t===97||Ub(e)||eS(e)}function o1t(e){return e===43}function c1t(e){return e===42||e===44||e===45}function l1t(e){return o1t(e)||c1t(e)}function u1t(e){return e===40||e===41}function _1t(e){return u1t(e)||l1t(e)}function f1t(e){return e===48||e===49||e===50}function iQ(e){return f1t(e)||_1t(e)}function p1t(e){return e===30||e===33||e===32||e===34||e===104||e===103}function d1t(e){return p1t(e)||iQ(e)}function m1t(e){return e===35||e===37||e===36||e===38}function g1t(e){return m1t(e)||d1t(e)}function h1t(e){return e===51||e===52||e===53}function y1t(e){return h1t(e)||g1t(e)}function v1t(e){return e===56||e===57}function S1t(e){return v1t(e)||y1t(e)}function T1t(e){return e===61||S1t(e)||D1(e)}function b1t(e){return T1t(e)||e===28}function the(e){return b1t(e.kind)}function SU(e,t,n,i,s,o){let l=new e8e(e,t,n,i,s,o);return p;function p(m,S){let h={value:void 0},b=[aQ.enter],A=[m],k=[void 0],N=0;for(;b[N]!==aQ.done;)N=b[N](l,N,b,A,k,h,S);return I.assertEqual(N,0),h.value}}function Q3e(e){return e===95||e===90}function GR(e){let t=e.kind;return Q3e(t)}function Z3e(e){let t=e.kind;return C1(t)&&!Q3e(t)}function rhe(e,t){if(t!==void 0)return t.length===0?t:ft(e.createNodeArray([],t.hasTrailingComma),t)}function HR(e){var t;let n=e.emitNode.autoGenerate;if(n.flags&4){let i=n.id,s=e,o=s.original;for(;o;){s=o;let l=(t=s.emitNode)==null?void 0:t.autoGenerate;if(E0(s)&&(l===void 0||l.flags&4&&l.id!==i))break;o=s.original}return s}return e}function eD(e,t){return typeof e=="object"?NT(!1,e.prefix,e.node,e.suffix,t):typeof e=="string"?e.length>0&&e.charCodeAt(0)===35?e.slice(1):e:""}function E1t(e,t){return typeof e=="string"?e:x1t(e,I.checkDefined(t))}function x1t(e,t){return F2(e)?t(e).slice(1):yc(e)?t(e):is(e)?e.escapedText.slice(1):Nn(e)}function NT(e,t,n,i,s){return t=eD(t,s),i=eD(i,s),n=E1t(n,s),`${e?"#":""}${t}${n}${i}`}function sQ(e,t,n,i){return e.updatePropertyDeclaration(t,n,e.getGeneratedPrivateNameForNode(t.name,void 0,"_accessor_storage"),void 0,void 0,i)}function nhe(e,t,n,i,s=e.createThis()){return e.createGetAccessorDeclaration(n,i,[],void 0,e.createBlock([e.createReturnStatement(e.createPropertyAccessExpression(s,e.getGeneratedPrivateNameForNode(t.name,void 0,"_accessor_storage")))]))}function ihe(e,t,n,i,s=e.createThis()){return e.createSetAccessorDeclaration(n,i,[e.createParameterDeclaration(void 0,void 0,"value")],e.createBlock([e.createExpressionStatement(e.createAssignment(e.createPropertyAccessExpression(s,e.getGeneratedPrivateNameForNode(t.name,void 0,"_accessor_storage")),e.createIdentifier("value")))]))}function TU(e){let t=e.expression;for(;;){if(t=vl(t),j6(t)){t=Rs(t.elements);continue}if(qR(t)){t=t.right;continue}if(lu(t,!0)&&yc(t.left))return t;break}}function C1t(e){return Df(e)&&_c(e)&&!e.emitNode}function bU(e,t){if(C1t(e))bU(e.expression,t);else if(qR(e))bU(e.left,t),bU(e.right,t);else if(j6(e))for(let n of e.elements)bU(n,t);else t.push(e)}function she(e){let t=[];return bU(e,t),t}function YR(e){if(e.transformFlags&65536)return!0;if(e.transformFlags&128)for(let t of ZN(e)){let n=rS(t);if(n&&Lw(n)&&(n.transformFlags&65536||n.transformFlags&128&&YR(n)))return!0}return!1}var aQ,e8e,A1t=f({"src/compiler/factory/utilities.ts"(){"use strict";fa(),(e=>{function t(h,b,A,k,N,M,O){let U=b>0?N[b-1]:void 0;return I.assertEqual(A[b],t),N[b]=h.onEnter(k[b],U,O),A[b]=p(h,t),b}e.enter=t;function n(h,b,A,k,N,M,O){I.assertEqual(A[b],n),I.assertIsDefined(h.onLeft),A[b]=p(h,n);let U=h.onLeft(k[b].left,N[b],k[b]);return U?(S(b,k,U),m(b,A,k,N,U)):b}e.left=n;function i(h,b,A,k,N,M,O){return I.assertEqual(A[b],i),I.assertIsDefined(h.onOperator),A[b]=p(h,i),h.onOperator(k[b].operatorToken,N[b],k[b]),b}e.operator=i;function s(h,b,A,k,N,M,O){I.assertEqual(A[b],s),I.assertIsDefined(h.onRight),A[b]=p(h,s);let U=h.onRight(k[b].right,N[b],k[b]);return U?(S(b,k,U),m(b,A,k,N,U)):b}e.right=s;function o(h,b,A,k,N,M,O){I.assertEqual(A[b],o),A[b]=p(h,o);let U=h.onExit(k[b],N[b]);if(b>0){if(b--,h.foldState){let H=A[b]===o?"right":"left";N[b]=h.foldState(N[b],U,H)}}else M.value=U;return b}e.exit=o;function l(h,b,A,k,N,M,O){return I.assertEqual(A[b],l),b}e.done=l;function p(h,b){switch(b){case t:if(h.onLeft)return n;case n:if(h.onOperator)return i;case i:if(h.onRight)return s;case s:return o;case o:return l;case l:return l;default:I.fail("Invalid state")}}e.nextState=p;function m(h,b,A,k,N){return h++,b[h]=t,A[h]=N,k[h]=void 0,h}function S(h,b,A){if(I.shouldAssert(2))for(;h>=0;)I.assert(b[h]!==A,"Circular traversal detected."),h--}})(aQ||(aQ={})),e8e=class{constructor(e,t,n,i,s,o){this.onEnter=e,this.onLeft=t,this.onOperator=n,this.onRight=i,this.onExit=s,this.foldState=o}}}});function ft(e,t){return t?jh(e,t.pos,t.end):e}function Jm(e){let t=e.kind;return t===168||t===169||t===171||t===172||t===173||t===174||t===176||t===177||t===178||t===181||t===185||t===218||t===219||t===231||t===243||t===262||t===263||t===264||t===265||t===266||t===267||t===271||t===272||t===277||t===278}function yx(e){let t=e.kind;return t===169||t===172||t===174||t===177||t===178||t===231||t===263}var k1t=f({"src/compiler/factory/utilitiesPublic.ts"(){"use strict";fa()}});function er(e,t){return t&&e(t)}function Ki(e,t,n){if(n){if(t)return t(n);for(let i of n){let s=e(i);if(s)return s}}}function oQ(e,t){return e.charCodeAt(t+1)===42&&e.charCodeAt(t+2)===42&&e.charCodeAt(t+3)!==47}function XR(e){return Te(e.statements,P1t)||N1t(e)}function P1t(e){return Jm(e)&&D1t(e,95)||Ru(e)&&zh(e.moduleReference)||uu(e)||Kc(e)||yl(e)?e:void 0}function N1t(e){return e.flags&8388608?t8e(e):void 0}function t8e(e){return I1t(e)?e:Qs(e,t8e)}function D1t(e,t){return Tt(e.modifiers,n=>n.kind===t)}function I1t(e){return F6(e)&&e.keywordToken===102&&e.name.escapedText==="meta"}function r8e(e,t,n){return Ki(t,n,e.typeParameters)||Ki(t,n,e.parameters)||er(t,e.type)}function n8e(e,t,n){return Ki(t,n,e.types)}function i8e(e,t,n){return er(t,e.type)}function s8e(e,t,n){return Ki(t,n,e.elements)}function a8e(e,t,n){return er(t,e.expression)||er(t,e.questionDotToken)||Ki(t,n,e.typeArguments)||Ki(t,n,e.arguments)}function o8e(e,t,n){return Ki(t,n,e.statements)}function c8e(e,t,n){return er(t,e.label)}function l8e(e,t,n){return Ki(t,n,e.modifiers)||er(t,e.name)||Ki(t,n,e.typeParameters)||Ki(t,n,e.heritageClauses)||Ki(t,n,e.members)}function u8e(e,t,n){return Ki(t,n,e.elements)}function _8e(e,t,n){return er(t,e.propertyName)||er(t,e.name)}function f8e(e,t,n){return er(t,e.tagName)||Ki(t,n,e.typeArguments)||er(t,e.attributes)}function G6(e,t,n){return er(t,e.type)}function p8e(e,t,n){return er(t,e.tagName)||(e.isNameFirst?er(t,e.name)||er(t,e.typeExpression):er(t,e.typeExpression)||er(t,e.name))||(typeof e.comment=="string"?void 0:Ki(t,n,e.comment))}function H6(e,t,n){return er(t,e.tagName)||er(t,e.typeExpression)||(typeof e.comment=="string"?void 0:Ki(t,n,e.comment))}function ahe(e,t,n){return er(t,e.name)}function tD(e,t,n){return er(t,e.tagName)||(typeof e.comment=="string"?void 0:Ki(t,n,e.comment))}function w1t(e,t,n){return er(t,e.expression)}function Qs(e,t,n){if(e===void 0||e.kind<=165)return;let i=E8e[e.kind];return i===void 0?void 0:i(e,t,n)}function Y6(e,t,n){let i=d8e(e),s=[];for(;s.length<i.length;)s.push(e);for(;i.length!==0;){let o=i.pop(),l=s.pop();if(os(o)){if(n){let p=n(o,l);if(p){if(p==="skip")continue;return p}}for(let p=o.length-1;p>=0;--p)i.push(o[p]),s.push(l)}else{let p=t(o,l);if(p){if(p==="skip")continue;return p}if(o.kind>=166)for(let m of d8e(o))i.push(m),s.push(o)}}}function d8e(e){let t=[];return Qs(e,n,n),t;function n(i){t.unshift(i)}}function m8e(e){e.externalModuleIndicator=XR(e)}function KR(e,t,n,i=!1,s){var o,l,p,m;(o=mn)==null||o.push(mn.Phase.Parse,"createSourceFile",{path:e},!0),mc("beforeParse");let S;(l=z_)==null||l.logStartParseSourceFile(e);let{languageVersion:h,setExternalModuleIndicator:b,impliedNodeFormat:A,jsDocParsingMode:k}=typeof n=="object"?n:{languageVersion:n};if(h===100)S=IT.parseSourceFile(e,t,h,void 0,i,6,ja,k);else{let N=A===void 0?b:M=>(M.impliedNodeFormat=A,(b||m8e)(M));S=IT.parseSourceFile(e,t,h,void 0,i,s,N,k)}return(p=z_)==null||p.logStopParseSourceFile(),mc("afterParse"),rd("Parse","beforeParse","afterParse"),(m=mn)==null||m.pop(),S}function ok(e,t){return IT.parseIsolatedEntityName(e,t)}function QR(e,t){return IT.parseJsonText(e,t)}function Pl(e){return e.externalModuleIndicator!==void 0}function cQ(e,t,n,i=!1){let s=pQ.updateSourceFile(e,t,n,i);return s.flags|=e.flags&12582912,s}function ohe(e,t,n){let i=IT.JSDocParser.parseIsolatedJSDocComment(e,t,n);return i&&i.jsDoc&&IT.fixupParentReferences(i.jsDoc),i}function g8e(e,t,n){return IT.JSDocParser.parseJSDocTypeExpressionForTests(e,t,n)}function i_(e){return lQ(e)!==void 0}function lQ(e){let t=qP(e,yR,!1);if(t)return t;if(Uc(e,".ts")){let n=Cl(e).lastIndexOf(".d.");if(n>=0)return e.substring(n)}}function O1t(e,t,n,i){if(e){if(e==="import")return 99;if(e==="require")return 1;i(t,n-t,g.resolution_mode_should_be_either_require_or_import)}}function uQ(e,t){let n=[];for(let i of T0(t,0)||tt){let s=t.substring(i.pos,i.end);M1t(n,i,s)}e.pragmas=new Map;for(let i of n){if(e.pragmas.has(i.name)){let s=e.pragmas.get(i.name);s instanceof Array?s.push(i.args):e.pragmas.set(i.name,[s,i.args]);continue}e.pragmas.set(i.name,i.args)}}function _Q(e,t){e.checkJsDirective=void 0,e.referencedFiles=[],e.typeReferenceDirectives=[],e.libReferenceDirectives=[],e.amdDependencies=[],e.hasNoDefaultLib=!1,e.pragmas.forEach((n,i)=>{switch(i){case"reference":{let s=e.referencedFiles,o=e.typeReferenceDirectives,l=e.libReferenceDirectives;Te(Pm(n),p=>{let{types:m,lib:S,path:h,["resolution-mode"]:b}=p.arguments;if(p.arguments["no-default-lib"])e.hasNoDefaultLib=!0;else if(m){let A=O1t(b,m.pos,m.end,t);o.push({pos:m.pos,end:m.end,fileName:m.value,...A?{resolutionMode:A}:{}})}else S?l.push({pos:S.pos,end:S.end,fileName:S.value}):h?s.push({pos:h.pos,end:h.end,fileName:h.value}):t(p.range.pos,p.range.end-p.range.pos,g.Invalid_reference_directive_syntax)});break}case"amd-dependency":{e.amdDependencies=vr(Pm(n),s=>({name:s.arguments.name,path:s.arguments.path}));break}case"amd-module":{if(n instanceof Array)for(let s of n)e.moduleName&&t(s.range.pos,s.range.end-s.range.pos,g.An_AMD_module_cannot_have_multiple_name_assignments),e.moduleName=s.arguments.name;else e.moduleName=n.arguments.name;break}case"ts-nocheck":case"ts-check":{Te(Pm(n),s=>{(!e.checkJsDirective||s.range.pos>e.checkJsDirective.pos)&&(e.checkJsDirective={enabled:i==="ts-check",end:s.range.end,pos:s.range.pos})});break}case"jsx":case"jsxfrag":case"jsximportsource":case"jsxruntime":return;default:I.fail("Unhandled pragma kind")}})}function R1t(e){if(dQ.has(e))return dQ.get(e);let t=new RegExp(`(\\s${e}\\s*=\\s*)(?:(?:'([^']*)')|(?:"([^"]*)"))`,"im");return dQ.set(e,t),t}function M1t(e,t,n){let i=t.kind===2&&x8e.exec(n);if(i){let o=i[1].toLowerCase(),l=w3[o];if(!l||!(l.kind&1))return;if(l.args){let p={};for(let m of l.args){let h=R1t(m.name).exec(n);if(!h&&!m.optional)return;if(h){let b=h[2]||h[3];if(m.captureSpan){let A=t.pos+h.index+h[1].length+1;p[m.name]={value:b,pos:A,end:A+b.length}}else p[m.name]=b}}e.push({name:o,args:{arguments:p,range:t}})}else e.push({name:o,args:{arguments:{},range:t}});return}let s=t.kind===2&&C8e.exec(n);if(s)return h8e(e,t,2,s);if(t.kind===3){let o=/@(\S+)(\s+.*)?$/gim,l;for(;l=o.exec(n);)h8e(e,t,4,l)}}function h8e(e,t,n,i){if(!i)return;let s=i[1].toLowerCase(),o=w3[s];if(!o||!(o.kind&n))return;let l=i[2],p=L1t(o,l);p!=="fail"&&e.push({name:s,args:{arguments:p,range:t}})}function L1t(e,t){if(!t)return{};if(!e.args)return{};let n=t.trim().split(/\s+/),i={};for(let s=0;s<e.args.length;s++){let o=e.args[s];if(!n[s]&&!o.optional)return"fail";if(o.captureSpan)return I.fail("Capture spans not yet implemented for non-xml pragmas");i[o.name]=n[s]}return i}function DT(e,t){return e.kind!==t.kind?!1:e.kind===80?e.escapedText===t.escapedText:e.kind===110?!0:e.kind===295?e.namespace.escapedText===t.namespace.escapedText&&e.name.escapedText===t.name.escapedText:e.name.escapedText===t.name.escapedText&&DT(e.expression,t.expression)}var y8e,v8e,S8e,T8e,b8e,fQ,$h,E8e,IT,pQ,dQ,x8e,C8e,F1t=f({"src/compiler/parser.ts"(){"use strict";fa(),O2(),fQ={createBaseSourceFileNode:e=>new(b8e||(b8e=Ju.getSourceFileConstructor()))(e,-1,-1),createBaseIdentifierNode:e=>new(S8e||(S8e=Ju.getIdentifierConstructor()))(e,-1,-1),createBasePrivateIdentifierNode:e=>new(T8e||(T8e=Ju.getPrivateIdentifierConstructor()))(e,-1,-1),createBaseTokenNode:e=>new(v8e||(v8e=Ju.getTokenConstructor()))(e,-1,-1),createBaseNode:e=>new(y8e||(y8e=Ju.getNodeConstructor()))(e,-1,-1)},$h=TR(1,fQ),E8e={166:function(t,n,i){return er(n,t.left)||er(n,t.right)},168:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||er(n,t.constraint)||er(n,t.default)||er(n,t.expression)},304:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||er(n,t.questionToken)||er(n,t.exclamationToken)||er(n,t.equalsToken)||er(n,t.objectAssignmentInitializer)},305:function(t,n,i){return er(n,t.expression)},169:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.dotDotDotToken)||er(n,t.name)||er(n,t.questionToken)||er(n,t.type)||er(n,t.initializer)},172:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||er(n,t.questionToken)||er(n,t.exclamationToken)||er(n,t.type)||er(n,t.initializer)},171:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||er(n,t.questionToken)||er(n,t.type)||er(n,t.initializer)},303:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||er(n,t.questionToken)||er(n,t.exclamationToken)||er(n,t.initializer)},260:function(t,n,i){return er(n,t.name)||er(n,t.exclamationToken)||er(n,t.type)||er(n,t.initializer)},208:function(t,n,i){return er(n,t.dotDotDotToken)||er(n,t.propertyName)||er(n,t.name)||er(n,t.initializer)},181:function(t,n,i){return Ki(n,i,t.modifiers)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)},185:function(t,n,i){return Ki(n,i,t.modifiers)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)},184:function(t,n,i){return Ki(n,i,t.modifiers)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)},179:r8e,180:r8e,174:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.asteriskToken)||er(n,t.name)||er(n,t.questionToken)||er(n,t.exclamationToken)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)||er(n,t.body)},173:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||er(n,t.questionToken)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)},176:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)||er(n,t.body)},177:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)||er(n,t.body)},178:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)||er(n,t.body)},262:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.asteriskToken)||er(n,t.name)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)||er(n,t.body)},218:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.asteriskToken)||er(n,t.name)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)||er(n,t.body)},219:function(t,n,i){return Ki(n,i,t.modifiers)||Ki(n,i,t.typeParameters)||Ki(n,i,t.parameters)||er(n,t.type)||er(n,t.equalsGreaterThanToken)||er(n,t.body)},175:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.body)},183:function(t,n,i){return er(n,t.typeName)||Ki(n,i,t.typeArguments)},182:function(t,n,i){return er(n,t.assertsModifier)||er(n,t.parameterName)||er(n,t.type)},186:function(t,n,i){return er(n,t.exprName)||Ki(n,i,t.typeArguments)},187:function(t,n,i){return Ki(n,i,t.members)},188:function(t,n,i){return er(n,t.elementType)},189:function(t,n,i){return Ki(n,i,t.elements)},192:n8e,193:n8e,194:function(t,n,i){return er(n,t.checkType)||er(n,t.extendsType)||er(n,t.trueType)||er(n,t.falseType)},195:function(t,n,i){return er(n,t.typeParameter)},205:function(t,n,i){return er(n,t.argument)||er(n,t.attributes)||er(n,t.qualifier)||Ki(n,i,t.typeArguments)},302:function(t,n,i){return er(n,t.assertClause)},196:i8e,198:i8e,199:function(t,n,i){return er(n,t.objectType)||er(n,t.indexType)},200:function(t,n,i){return er(n,t.readonlyToken)||er(n,t.typeParameter)||er(n,t.nameType)||er(n,t.questionToken)||er(n,t.type)||Ki(n,i,t.members)},201:function(t,n,i){return er(n,t.literal)},202:function(t,n,i){return er(n,t.dotDotDotToken)||er(n,t.name)||er(n,t.questionToken)||er(n,t.type)},206:s8e,207:s8e,209:function(t,n,i){return Ki(n,i,t.elements)},210:function(t,n,i){return Ki(n,i,t.properties)},211:function(t,n,i){return er(n,t.expression)||er(n,t.questionDotToken)||er(n,t.name)},212:function(t,n,i){return er(n,t.expression)||er(n,t.questionDotToken)||er(n,t.argumentExpression)},213:a8e,214:a8e,215:function(t,n,i){return er(n,t.tag)||er(n,t.questionDotToken)||Ki(n,i,t.typeArguments)||er(n,t.template)},216:function(t,n,i){return er(n,t.type)||er(n,t.expression)},217:function(t,n,i){return er(n,t.expression)},220:function(t,n,i){return er(n,t.expression)},221:function(t,n,i){return er(n,t.expression)},222:function(t,n,i){return er(n,t.expression)},224:function(t,n,i){return er(n,t.operand)},229:function(t,n,i){return er(n,t.asteriskToken)||er(n,t.expression)},223:function(t,n,i){return er(n,t.expression)},225:function(t,n,i){return er(n,t.operand)},226:function(t,n,i){return er(n,t.left)||er(n,t.operatorToken)||er(n,t.right)},234:function(t,n,i){return er(n,t.expression)||er(n,t.type)},235:function(t,n,i){return er(n,t.expression)},238:function(t,n,i){return er(n,t.expression)||er(n,t.type)},236:function(t,n,i){return er(n,t.name)},227:function(t,n,i){return er(n,t.condition)||er(n,t.questionToken)||er(n,t.whenTrue)||er(n,t.colonToken)||er(n,t.whenFalse)},230:function(t,n,i){return er(n,t.expression)},241:o8e,268:o8e,312:function(t,n,i){return Ki(n,i,t.statements)||er(n,t.endOfFileToken)},243:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.declarationList)},261:function(t,n,i){return Ki(n,i,t.declarations)},244:function(t,n,i){return er(n,t.expression)},245:function(t,n,i){return er(n,t.expression)||er(n,t.thenStatement)||er(n,t.elseStatement)},246:function(t,n,i){return er(n,t.statement)||er(n,t.expression)},247:function(t,n,i){return er(n,t.expression)||er(n,t.statement)},248:function(t,n,i){return er(n,t.initializer)||er(n,t.condition)||er(n,t.incrementor)||er(n,t.statement)},249:function(t,n,i){return er(n,t.initializer)||er(n,t.expression)||er(n,t.statement)},250:function(t,n,i){return er(n,t.awaitModifier)||er(n,t.initializer)||er(n,t.expression)||er(n,t.statement)},251:c8e,252:c8e,253:function(t,n,i){return er(n,t.expression)},254:function(t,n,i){return er(n,t.expression)||er(n,t.statement)},255:function(t,n,i){return er(n,t.expression)||er(n,t.caseBlock)},269:function(t,n,i){return Ki(n,i,t.clauses)},296:function(t,n,i){return er(n,t.expression)||Ki(n,i,t.statements)},297:function(t,n,i){return Ki(n,i,t.statements)},256:function(t,n,i){return er(n,t.label)||er(n,t.statement)},257:function(t,n,i){return er(n,t.expression)},258:function(t,n,i){return er(n,t.tryBlock)||er(n,t.catchClause)||er(n,t.finallyBlock)},299:function(t,n,i){return er(n,t.variableDeclaration)||er(n,t.block)},170:function(t,n,i){return er(n,t.expression)},263:l8e,231:l8e,264:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||Ki(n,i,t.typeParameters)||Ki(n,i,t.heritageClauses)||Ki(n,i,t.members)},265:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||Ki(n,i,t.typeParameters)||er(n,t.type)},266:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||Ki(n,i,t.members)},306:function(t,n,i){return er(n,t.name)||er(n,t.initializer)},267:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||er(n,t.body)},271:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)||er(n,t.moduleReference)},272:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.importClause)||er(n,t.moduleSpecifier)||er(n,t.attributes)},273:function(t,n,i){return er(n,t.name)||er(n,t.namedBindings)},300:function(t,n,i){return Ki(n,i,t.elements)},301:function(t,n,i){return er(n,t.name)||er(n,t.value)},270:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.name)},274:function(t,n,i){return er(n,t.name)},280:function(t,n,i){return er(n,t.name)},275:u8e,279:u8e,278:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.exportClause)||er(n,t.moduleSpecifier)||er(n,t.attributes)},276:_8e,281:_8e,277:function(t,n,i){return Ki(n,i,t.modifiers)||er(n,t.expression)},228:function(t,n,i){return er(n,t.head)||Ki(n,i,t.templateSpans)},239:function(t,n,i){return er(n,t.expression)||er(n,t.literal)},203:function(t,n,i){return er(n,t.head)||Ki(n,i,t.templateSpans)},204:function(t,n,i){return er(n,t.type)||er(n,t.literal)},167:function(t,n,i){return er(n,t.expression)},298:function(t,n,i){return Ki(n,i,t.types)},233:function(t,n,i){return er(n,t.expression)||Ki(n,i,t.typeArguments)},283:function(t,n,i){return er(n,t.expression)},282:function(t,n,i){return Ki(n,i,t.modifiers)},361:function(t,n,i){return Ki(n,i,t.elements)},284:function(t,n,i){return er(n,t.openingElement)||Ki(n,i,t.children)||er(n,t.closingElement)},288:function(t,n,i){return er(n,t.openingFragment)||Ki(n,i,t.children)||er(n,t.closingFragment)},285:f8e,286:f8e,292:function(t,n,i){return Ki(n,i,t.properties)},291:function(t,n,i){return er(n,t.name)||er(n,t.initializer)},293:function(t,n,i){return er(n,t.expression)},294:function(t,n,i){return er(n,t.dotDotDotToken)||er(n,t.expression)},287:function(t,n,i){return er(n,t.tagName)},295:function(t,n,i){return er(n,t.namespace)||er(n,t.name)},190:G6,191:G6,316:G6,322:G6,321:G6,323:G6,325:G6,324:function(t,n,i){return Ki(n,i,t.parameters)||er(n,t.type)},327:function(t,n,i){return(typeof t.comment=="string"?void 0:Ki(n,i,t.comment))||Ki(n,i,t.tags)},354:function(t,n,i){return er(n,t.tagName)||er(n,t.name)||(typeof t.comment=="string"?void 0:Ki(n,i,t.comment))},317:function(t,n,i){return er(n,t.name)},318:function(t,n,i){return er(n,t.left)||er(n,t.right)},348:p8e,355:p8e,337:function(t,n,i){return er(n,t.tagName)||(typeof t.comment=="string"?void 0:Ki(n,i,t.comment))},336:function(t,n,i){return er(n,t.tagName)||er(n,t.class)||(typeof t.comment=="string"?void 0:Ki(n,i,t.comment))},335:function(t,n,i){return er(n,t.tagName)||er(n,t.class)||(typeof t.comment=="string"?void 0:Ki(n,i,t.comment))},352:function(t,n,i){return er(n,t.tagName)||er(n,t.constraint)||Ki(n,i,t.typeParameters)||(typeof t.comment=="string"?void 0:Ki(n,i,t.comment))},353:function(t,n,i){return er(n,t.tagName)||(t.typeExpression&&t.typeExpression.kind===316?er(n,t.typeExpression)||er(n,t.fullName)||(typeof t.comment=="string"?void 0:Ki(n,i,t.comment)):er(n,t.fullName)||er(n,t.typeExpression)||(typeof t.comment=="string"?void 0:Ki(n,i,t.comment)))},345:function(t,n,i){return er(n,t.tagName)||er(n,t.fullName)||er(n,t.typeExpression)||(typeof t.comment=="string"?void 0:Ki(n,i,t.comment))},349:H6,351:H6,350:H6,347:H6,357:H6,356:H6,346:H6,330:function(t,n,i){return Te(t.typeParameters,n)||Te(t.parameters,n)||er(n,t.type)},331:ahe,332:ahe,333:ahe,329:function(t,n,i){return Te(t.jsDocPropertyTags,n)},334:tD,339:tD,340:tD,341:tD,342:tD,343:tD,338:tD,344:tD,360:w1t},(e=>{var t=E1(99,!0),n=40960,i,s,o,l,p;function m(te){return Ze++,te}var S={createBaseSourceFileNode:te=>m(new p(te,0,0)),createBaseIdentifierNode:te=>m(new o(te,0,0)),createBasePrivateIdentifierNode:te=>m(new l(te,0,0)),createBaseTokenNode:te=>m(new s(te,0,0)),createBaseNode:te=>m(new i(te,0,0))},h=TR(11,S),{createNodeArray:b,createNumericLiteral:A,createStringLiteral:k,createLiteralLikeNode:N,createIdentifier:M,createPrivateIdentifier:O,createToken:U,createArrayLiteralExpression:H,createObjectLiteralExpression:K,createPropertyAccessExpression:re,createPropertyAccessChain:$,createElementAccessExpression:pe,createElementAccessChain:z,createCallExpression:se,createCallChain:Se,createNewExpression:xe,createParenthesizedExpression:Z,createBlock:Q,createVariableStatement:ce,createExpressionStatement:ye,createIfStatement:we,createWhileStatement:ve,createForStatement:oe,createForOfStatement:Ee,createVariableDeclaration:Me,createVariableDeclarationList:Ge}=h,Ae,Ie,Re,Ue,kt,ke,$e,at,$t,St,Ze,yt,ar,or,Fr,rn,Tr=!0,nr=!1;function tr(te,De,Xe,Pt,wt=!1,Xt,Yn,Hi=0){var Ui;if(Xt=Zj(te,Xt),Xt===6){let cs=xs(te,De,Xe,Pt,wt);return tM(cs,(Ui=cs.statements[0])==null?void 0:Ui.expression,cs.parseDiagnostics,!1,void 0),cs.referencedFiles=tt,cs.typeReferenceDirectives=tt,cs.libReferenceDirectives=tt,cs.amdDependencies=tt,cs.hasNoDefaultLib=!1,cs.pragmas=$5,cs}zi(te,De,Xe,Pt,Xt,Hi);let Ai=un(Xe,wt,Xt,Yn||m8e,Hi);return Ms(),Ai}e.parseSourceFile=tr;function ki(te,De){zi("",te,De,void 0,1,0),Le();let Xe=ie(!0),Pt=X()===1&&!$e.length;return Ms(),Pt?Xe:void 0}e.parseIsolatedEntityName=ki;function xs(te,De,Xe=2,Pt,wt=!1){zi(te,De,Xe,Pt,6,0),Ie=rn,Le();let Xt=B(),Yn,Hi;if(X()===1)Yn=$s([],Xt,Xt),Hi=Ac();else{let cs;for(;X()!==1;){let _o;switch(X()){case 23:_o=VE();break;case 112:case 97:case 106:_o=Ac();break;case 41:Vi(()=>Le()===9&&Le()!==59)?_o=_i():_o=$y();break;case 9:case 11:if(Vi(()=>Le()!==59)){_o=ci();break}default:_o=$y();break}cs&&os(cs)?cs.push(_o):cs?cs=[cs,_o]:(cs=_o,X()!==1&&hr(g.Unexpected_token))}let Co=os(cs)?cr(H(cs),Xt):I.checkDefined(cs),zo=ye(Co);cr(zo,Xt),Yn=$s([zo],Xt),Hi=Uo(1,g.Unexpected_token)}let Ui=zt(te,2,6,!1,Yn,Hi,Ie,ja);wt&&rt(Ui),Ui.nodeCount=Ze,Ui.identifierCount=ar,Ui.identifiers=yt,Ui.parseDiagnostics=RA($e,Ui),at&&(Ui.jsDocDiagnostics=RA(at,Ui));let Ai=Ui;return Ms(),Ai}e.parseJsonText=xs;function zi(te,De,Xe,Pt,wt,Xt){switch(i=Ju.getNodeConstructor(),s=Ju.getTokenConstructor(),o=Ju.getIdentifierConstructor(),l=Ju.getPrivateIdentifierConstructor(),p=Ju.getSourceFileConstructor(),Ae=Ca(te),Re=De,Ue=Xe,$t=Pt,kt=wt,ke=sR(wt),$e=[],or=0,yt=new Map,ar=0,Ze=0,Ie=0,Tr=!0,kt){case 1:case 2:rn=524288;break;case 6:rn=134742016;break;default:rn=0;break}nr=!1,t.setText(Re),t.setOnError(Lt),t.setScriptTarget(Ue),t.setLanguageVariant(ke),t.setScriptKind(kt),t.setJSDocParsingMode(Xt)}function Ms(){t.clearCommentDirectives(),t.setText(""),t.setOnError(void 0),t.setScriptKind(0),t.setJSDocParsingMode(0),Re=void 0,Ue=void 0,$t=void 0,kt=void 0,ke=void 0,Ie=0,$e=void 0,at=void 0,or=0,yt=void 0,Fr=void 0,Tr=!0}function un(te,De,Xe,Pt,wt){let Xt=i_(Ae);Xt&&(rn|=33554432),Ie=rn,Le();let Yn=ua(0,Zf);I.assert(X()===1);let Hi=le(),Ui=On(Ac(),Hi),Ai=zt(Ae,te,Xe,Xt,Yn,Ui,Ie,Pt);return uQ(Ai,Re),_Q(Ai,cs),Ai.commentDirectives=t.getCommentDirectives(),Ai.nodeCount=Ze,Ai.identifierCount=ar,Ai.identifiers=yt,Ai.parseDiagnostics=RA($e,Ai),Ai.jsDocParsingMode=wt,at&&(Ai.jsDocDiagnostics=RA(at,Ai)),De&&rt(Ai),Ai;function cs(Co,zo,_o){$e.push(wN(Ae,Re,Co,zo,_o))}}let ri=!1;function On(te,De){if(!De)return te;I.assert(!te.jsDoc);let Xe=Wi(BY(te,Re),Pt=>dh.parseJSDocComment(te,Pt.pos,Pt.end-Pt.pos));return Xe.length&&(te.jsDoc=Xe),ri&&(ri=!1,te.flags|=536870912),te}function _r(te){let De=$t,Xe=pQ.createSyntaxCursor(te);$t={currentNode:cs};let Pt=[],wt=$e;$e=[];let Xt=0,Yn=Ui(te.statements,0);for(;Yn!==-1;){let Co=te.statements[Xt],zo=te.statements[Yn];jt(Pt,te.statements,Xt,Yn),Xt=Ai(te.statements,Yn);let _o=oa(wt,mh=>mh.start>=Co.pos),Jd=_o>=0?oa(wt,mh=>mh.start>=zo.pos,_o):-1;_o>=0&&jt($e,wt,_o,Jd>=0?Jd:void 0),Ns(()=>{let mh=rn;for(rn|=65536,t.resetTokenState(zo.pos),Le();X()!==1;){let Y0=t.getTokenFullStart(),Yy=Tl(0,Zf);if(Pt.push(Yy),Y0===t.getTokenFullStart()&&Le(),Xt>=0){let Xy=te.statements[Xt];if(Yy.end===Xy.pos)break;Yy.end>Xy.pos&&(Xt=Ai(te.statements,Xt+1))}}rn=mh},2),Yn=Xt>=0?Ui(te.statements,Xt):-1}if(Xt>=0){let Co=te.statements[Xt];jt(Pt,te.statements,Xt);let zo=oa(wt,_o=>_o.start>=Co.pos);zo>=0&&jt($e,wt,zo)}return $t=De,h.updateSourceFile(te,ft(b(Pt),te.statements));function Hi(Co){return!(Co.flags&65536)&&!!(Co.transformFlags&67108864)}function Ui(Co,zo){for(let _o=zo;_o<Co.length;_o++)if(Hi(Co[_o]))return _o;return-1}function Ai(Co,zo){for(let _o=zo;_o<Co.length;_o++)if(!Hi(Co[_o]))return _o;return-1}function cs(Co){let zo=Xe.currentNode(Co);return Tr&&zo&&Hi(zo)&&(zo.intersectsChange=!0),zo}}function rt(te){Wv(te,!0)}e.fixupParentReferences=rt;function zt(te,De,Xe,Pt,wt,Xt,Yn,Hi){let Ui=h.createSourceFile(wt,Xt,Yn);if(T6(Ui,0,Re.length),Ai(Ui),!Pt&&Pl(Ui)&&Ui.transformFlags&67108864){let cs=Ui;Ui=_r(Ui),cs!==Ui&&Ai(Ui)}return Ui;function Ai(cs){cs.text=Re,cs.bindDiagnostics=[],cs.bindSuggestionDiagnostics=void 0,cs.languageVersion=De,cs.fileName=te,cs.languageVariant=sR(Xe),cs.isDeclarationFile=Pt,cs.scriptKind=Xe,Hi(cs),cs.setExternalModuleIndicator=Hi}}function Rr(te,De){te?rn|=De:rn&=~De}function vi(te){Rr(te,8192)}function Ni(te){Rr(te,16384)}function us(te){Rr(te,32768)}function Fs(te){Rr(te,65536)}function Ta(te,De){let Xe=te&rn;if(Xe){Rr(!1,Xe);let Pt=De();return Rr(!0,Xe),Pt}return De()}function to(te,De){let Xe=te&~rn;if(Xe){Rr(!0,Xe);let Pt=De();return Rr(!1,Xe),Pt}return De()}function Nr(te){return Ta(8192,te)}function qr(te){return to(8192,te)}function We(te){return Ta(131072,te)}function mt(te){return to(131072,te)}function dt(te){return to(16384,te)}function Ot(te){return to(32768,te)}function _e(te){return to(65536,te)}function Ve(te){return Ta(65536,te)}function pt(te){return to(81920,te)}function W(te){return Ta(81920,te)}function st(te){return(rn&te)!==0}function Nt(){return st(16384)}function Ke(){return st(8192)}function ht(){return st(131072)}function Wt(){return st(32768)}function Cr(){return st(65536)}function hr(te,...De){return Y(t.getTokenStart(),t.getTokenEnd(),te,...De)}function Sr(te,De,Xe,...Pt){let wt=Is($e),Xt;return(!wt||te!==wt.start)&&(Xt=wN(Ae,Re,te,De,Xe,...Pt),$e.push(Xt)),nr=!0,Xt}function Y(te,De,Xe,...Pt){return Sr(te,De-te,Xe,...Pt)}function Be(te,De,...Xe){Y(te.pos,te.end,De,...Xe)}function Lt(te,De,Xe){Sr(t.getTokenEnd(),De,te,Xe)}function B(){return t.getTokenFullStart()}function le(){return t.hasPrecedingJSDocComment()}function X(){return St}function he(){return St=t.scan()}function qe(te){return Le(),te()}function Le(){return Nf(St)&&(t.hasUnicodeEscape()||t.hasExtendedUnicodeEscape())&&Y(t.getTokenStart(),t.getTokenEnd(),g.Keywords_cannot_contain_escape_characters),he()}function It(){return St=t.scanJsDocToken()}function Rt(te){return St=t.scanJSDocCommentTextToken(te)}function Zt(){return St=t.reScanGreaterToken()}function Ir(){return St=t.reScanSlashToken()}function zr(te){return St=t.reScanTemplateToken(te)}function Yr(){return St=t.reScanLessThanToken()}function Pi(){return St=t.reScanHashToken()}function Fi(){return St=t.scanJsxIdentifier()}function fn(){return St=t.scanJsxToken()}function Qn(){return St=t.scanJsxAttributeValue()}function Ns(te,De){let Xe=St,Pt=$e.length,wt=nr,Xt=rn,Yn=De!==0?t.lookAhead(te):t.tryScan(te);return I.assert(Xt===rn),(!Yn||De!==0)&&(St=Xe,De!==2&&($e.length=Pt),nr=wt),Yn}function Vi(te){return Ns(te,1)}function ji(te){return Ns(te,0)}function ni(){return X()===80?!0:X()>118}function js(){return X()===80?!0:X()===127&&Nt()||X()===135&&Cr()?!1:X()>118}function Mr(te,De,Xe=!0){return X()===te?(Xe&&Le(),!0):(De?hr(De):hr(g._0_expected,Sa(te)),!1)}let Qo=Object.keys($3).filter(te=>te.length>2);function Sl(te){if(uE(te)){Y(Wa(Re,te.template.pos),te.template.end,g.Module_declaration_names_may_only_use_or_quoted_strings);return}let De=ze(te)?Nn(te):void 0;if(!De||!nd(De,Ue)){hr(g._0_expected,Sa(27));return}let Xe=Wa(Re,te.pos);switch(De){case"const":case"let":case"var":Y(Xe,te.end,g.Variable_declaration_not_allowed_at_this_location);return;case"declare":return;case"interface":zs(g.Interface_name_cannot_be_0,g.Interface_must_be_given_a_name,19);return;case"is":Y(Xe,t.getTokenStart(),g.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);return;case"module":case"namespace":zs(g.Namespace_name_cannot_be_0,g.Namespace_must_be_given_a_name,19);return;case"type":zs(g.Type_alias_name_cannot_be_0,g.Type_alias_must_be_given_a_name,64);return}let Pt=FP(De,Qo,wt=>wt)??Eo(De);if(Pt){Y(Xe,te.end,g.Unknown_keyword_or_identifier_Did_you_mean_0,Pt);return}X()!==0&&Y(Xe,te.end,g.Unexpected_keyword_or_identifier)}function zs(te,De,Xe){X()===Xe?hr(De):hr(te,t.getTokenValue())}function Eo(te){for(let De of Qo)if(te.length>De.length+2&&Ss(te,De))return`${De} ${te.slice(De.length)}`}function nc(te,De,Xe){if(X()===60&&!t.hasPrecedingLineBreak()){hr(g.Decorators_must_precede_the_name_and_all_keywords_of_property_declarations);return}if(X()===21){hr(g.Cannot_start_a_function_call_in_a_type_annotation),Le();return}if(De&&!Nl()){Xe?hr(g._0_expected,Sa(27)):hr(g.Expected_for_property_initializer);return}if(!zc()){if(Xe){hr(g._0_expected,Sa(27));return}Sl(te)}}function Dc(te){return X()===te?(It(),!0):(I.assert(vj(te)),hr(g._0_expected,Sa(te)),!1)}function zu(te,De,Xe,Pt){if(X()===De){Le();return}let wt=hr(g._0_expected,Sa(De));Xe&&wt&&Ga(wt,wN(Ae,Re,Pt,1,g.The_parser_expected_to_find_a_1_to_match_the_0_token_here,Sa(te),Sa(De)))}function ks(te){return X()===te?(Le(),!0):!1}function ya(te){if(X()===te)return Ac()}function $u(te){if(X()===te)return Ld()}function Uo(te,De,Xe){return ya(te)||ic(te,!1,De||g._0_expected,Xe||Sa(te))}function $a(te){let De=$u(te);return De||(I.assert(vj(te)),ic(te,!1,g._0_expected,Sa(te)))}function Ac(){let te=B(),De=X();return Le(),cr(U(De),te)}function Ld(){let te=B(),De=X();return It(),cr(U(De),te)}function Nl(){return X()===27?!0:X()===20||X()===1||t.hasPrecedingLineBreak()}function zc(){return Nl()?(X()===27&&Le(),!0):!1}function Tc(){return zc()||Mr(27)}function $s(te,De,Xe,Pt){let wt=b(te,Pt);return jh(wt,De,Xe??t.getTokenFullStart()),wt}function cr(te,De,Xe){return jh(te,De,Xe??t.getTokenFullStart()),rn&&(te.flags|=rn),nr&&(nr=!1,te.flags|=262144),te}function ic(te,De,Xe,...Pt){De?Sr(t.getTokenFullStart(),0,Xe,...Pt):Xe&&hr(Xe,...Pt);let wt=B(),Xt=te===80?M("",void 0):Rv(te)?h.createTemplateLiteralLikeNode(te,"","",void 0):te===9?A("",void 0):te===11?k("",void 0):te===282?h.createMissingDeclaration():U(te);return cr(Xt,wt)}function Mu(te){let De=yt.get(te);return De===void 0&&yt.set(te,De=te),De}function Wu(te,De,Xe){if(te){ar++;let Hi=B(),Ui=X(),Ai=Mu(t.getTokenValue()),cs=t.hasExtendedUnicodeEscape();return he(),cr(M(Ai,Ui,cs),Hi)}if(X()===81)return hr(Xe||g.Private_identifiers_are_not_allowed_outside_class_bodies),Wu(!0);if(X()===0&&t.tryScan(()=>t.reScanInvalidIdentifier()===80))return Wu(!0);ar++;let Pt=X()===1,wt=t.isReservedWord(),Xt=t.getTokenText(),Yn=wt?g.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here:g.Identifier_expected;return ic(80,Pt,De||Yn,Xt)}function yp(te){return Wu(ni(),void 0,te)}function Go(te,De){return Wu(js(),te,De)}function ru(te){return Wu($_(X()),te)}function ge(){return(t.hasUnicodeEscape()||t.hasExtendedUnicodeEscape())&&hr(g.Unicode_escape_sequence_cannot_appear_here),Wu($_(X()))}function ne(){return $_(X())||X()===11||X()===9}function je(){return $_(X())||X()===11}function Et(te){if(X()===11||X()===9){let De=ci();return De.text=Mu(De.text),De}return te&&X()===23?Dn():X()===81?xn():ru()}function gr(){return Et(!0)}function Dn(){let te=B();Mr(23);let De=Nr(He);return Mr(24),cr(h.createComputedPropertyName(De),te)}function xn(){let te=B(),De=O(Mu(t.getTokenValue()));return Le(),cr(De,te)}function Zn(te){return X()===te&&ji(Jn)}function Bi(){return Le(),t.hasPrecedingLineBreak()?!1:sc()}function Jn(){switch(X()){case 87:return Le()===94;case 95:return Le(),X()===90?Vi(Jl):X()===156?Vi(Fc):ia();case 90:return Jl();case 126:case 139:case 153:return Le(),sc();default:return Bi()}}function ia(){return X()===60||X()!==42&&X()!==130&&X()!==19&&sc()}function Fc(){return Le(),ia()}function bu(){return C1(X())&&ji(Jn)}function sc(){return X()===23||X()===19||X()===42||X()===26||ne()}function Jl(){return Le(),X()===86||X()===100||X()===120||X()===60||X()===128&&Vi(Zx)||X()===134&&Vi(eC)}function jo(te,De){if(ql(te))return!0;switch(te){case 0:case 1:case 3:return!(X()===27&&De)&&qE();case 2:return X()===84||X()===90;case 4:return Vi(ao);case 5:return Vi(G0)||X()===27&&!De;case 6:return X()===23||ne();case 12:switch(X()){case 23:case 42:case 26:case 25:return!0;default:return ne()}case 18:return ne();case 9:return X()===23||X()===26||ne();case 24:return je();case 7:return X()===19?Vi(Eu):De?js()&&!tf():qk()&&!tf();case 8:return mo();case 10:return X()===28||X()===26||mo();case 19:return X()===103||X()===87||js();case 15:switch(X()){case 28:case 25:return!0}case 11:return X()===26||yg();case 16:return lh(!1);case 17:return lh(!0);case 20:case 21:return X()===28||V0();case 22:return D();case 23:return X()===161&&Vi(cI)?!1:$_(X());case 13:return $_(X())||X()===19;case 14:return!0;case 25:return!0;case 26:return I.fail("ParsingContext.Count used as a context");default:I.assertNever(te,"Non-exhaustive case in 'isListElement'.")}}function Eu(){if(I.assert(X()===19),Le()===20){let te=Le();return te===28||te===19||te===96||te===119}return!0}function Xf(){return Le(),js()}function pu(){return Le(),$_(X())}function gm(){return Le(),$fe(X())}function tf(){return X()===119||X()===96?Vi(Oe):!1}function Oe(){return Le(),yg()}function Bt(){return Le(),V0()}function Zr(te){if(X()===1)return!0;switch(te){case 1:case 2:case 4:case 5:case 6:case 12:case 9:case 23:case 24:return X()===20;case 3:return X()===20||X()===84||X()===90;case 7:return X()===19||X()===96||X()===119;case 8:return Ds();case 19:return X()===32||X()===21||X()===19||X()===96||X()===119;case 11:return X()===22||X()===27;case 15:case 21:case 10:return X()===24;case 17:case 16:case 18:return X()===22||X()===24;case 20:return X()!==28;case 22:return X()===19||X()===20;case 13:return X()===32||X()===44;case 14:return X()===30&&Vi(Oi);default:return!1}}function Ds(){return!!(Nl()||Jy(X())||X()===39)}function sa(){I.assert(or,"Missing parsing context");for(let te=0;te<26;te++)if(or&1<<te&&(jo(te,!0)||Zr(te)))return!0;return!1}function ua(te,De){let Xe=or;or|=1<<te;let Pt=[],wt=B();for(;!Zr(te);){if(jo(te,!1)){Pt.push(Tl(te,De));continue}if(Yh(te))break}return or=Xe,$s(Pt,wt)}function Tl(te,De){let Xe=ql(te);return Xe?bc(Xe):De()}function ql(te,De){var Xe;if(!$t||!Ic(te)||nr)return;let Pt=$t.currentNode(De??t.getTokenFullStart());if(!(sl(Pt)||Pt.intersectsChange||rN(Pt)||(Pt.flags&101441536)!==rn)&&cl(Pt,te))return U8(Pt)&&((Xe=Pt.jsDoc)!=null&&Xe.jsDocCache)&&(Pt.jsDoc.jsDocCache=void 0),Pt}function bc(te){return t.resetTokenState(te.end),Le(),te}function Ic(te){switch(te){case 5:case 2:case 0:case 1:case 3:case 6:case 4:case 8:case 17:case 16:return!0}return!1}function cl(te,De){switch(De){case 5:return bl(te);case 2:return xu(te);case 0:case 1:case 3:return dd(te);case 6:return wf(te);case 4:return hf(te);case 8:return Fd(te);case 17:case 16:return ch(te)}return!1}function bl(te){if(te)switch(te.kind){case 176:case 181:case 177:case 178:case 172:case 240:return!0;case 174:let De=te;return!(De.name.kind===80&&De.name.escapedText==="constructor")}return!1}function xu(te){if(te)switch(te.kind){case 296:case 297:return!0}return!1}function dd(te){if(te)switch(te.kind){case 262:case 243:case 241:case 245:case 244:case 257:case 253:case 255:case 252:case 251:case 249:case 250:case 248:case 247:case 254:case 242:case 258:case 256:case 246:case 259:case 272:case 271:case 278:case 277:case 267:case 263:case 264:case 266:case 265:return!0}return!1}function wf(te){return te.kind===306}function hf(te){if(te)switch(te.kind){case 180:case 173:case 181:case 171:case 179:return!0}return!1}function Fd(te){return te.kind!==260?!1:te.initializer===void 0}function ch(te){return te.kind!==169?!1:te.initializer===void 0}function Yh(te){return Ly(te),sa()?!0:(Le(),!1)}function Ly(te){switch(te){case 0:return X()===90?hr(g._0_expected,Sa(95)):hr(g.Declaration_or_statement_expected);case 1:return hr(g.Declaration_or_statement_expected);case 2:return hr(g.case_or_default_expected);case 3:return hr(g.Statement_expected);case 18:case 4:return hr(g.Property_or_signature_expected);case 5:return hr(g.Unexpected_token_A_constructor_method_accessor_or_property_was_expected);case 6:return hr(g.Enum_member_expected);case 7:return hr(g.Expression_expected);case 8:return Nf(X())?hr(g._0_is_not_allowed_as_a_variable_declaration_name,Sa(X())):hr(g.Variable_declaration_expected);case 9:return hr(g.Property_destructuring_pattern_expected);case 10:return hr(g.Array_element_destructuring_pattern_expected);case 11:return hr(g.Argument_expression_expected);case 12:return hr(g.Property_assignment_expected);case 15:return hr(g.Expression_or_comma_expected);case 17:return hr(g.Parameter_declaration_expected);case 16:return Nf(X())?hr(g._0_is_not_allowed_as_a_parameter_name,Sa(X())):hr(g.Parameter_declaration_expected);case 19:return hr(g.Type_parameter_declaration_expected);case 20:return hr(g.Type_argument_expected);case 21:return hr(g.Type_expected);case 22:return hr(g.Unexpected_token_expected);case 23:return X()===161?hr(g._0_expected,"}"):hr(g.Identifier_expected);case 13:return hr(g.Identifier_expected);case 14:return hr(g.Identifier_expected);case 24:return hr(g.Identifier_or_string_literal_expected);case 25:return hr(g.Identifier_expected);case 26:return I.fail("ParsingContext.Count used as a context");default:I.assertNever(te)}}function A_(te,De,Xe){let Pt=or;or|=1<<te;let wt=[],Xt=B(),Yn=-1;for(;;){if(jo(te,!1)){let Hi=t.getTokenFullStart(),Ui=Tl(te,De);if(!Ui){or=Pt;return}if(wt.push(Ui),Yn=t.getTokenStart(),ks(28))continue;if(Yn=-1,Zr(te))break;Mr(28,Fy(te)),Xe&&X()===27&&!t.hasPrecedingLineBreak()&&Le(),Hi===t.getTokenFullStart()&&Le();continue}if(Zr(te)||Yh(te))break}return or=Pt,$s(wt,Xt,void 0,Yn>=0)}function Fy(te){return te===6?g.An_enum_member_name_must_be_followed_by_a_or:void 0}function vp(){let te=$s([],B());return te.isMissingList=!0,te}function U0(te){return!!te.isMissingList}function Of(te,De,Xe,Pt){if(Mr(Xe)){let wt=A_(te,De);return Mr(Pt),wt}return vp()}function ie(te,De){let Xe=B(),Pt=te?ru(De):Go(De);for(;ks(25)&&X()!==30;)Pt=cr(h.createQualifiedName(Pt,Jt(te,!1,!0)),Xe);return Pt}function ct(te,De){return cr(h.createQualifiedName(te,De),te.pos)}function Jt(te,De,Xe){if(t.hasPrecedingLineBreak()&&$_(X())&&Vi(Wp))return ic(80,!0,g.Identifier_expected);if(X()===81){let Pt=xn();return De?Pt:ic(80,!0,g.Identifier_expected)}return te?Xe?ru():ge():Go()}function Gt(te){let De=B(),Xe=[],Pt;do Pt=gi(te),Xe.push(Pt);while(Pt.literal.kind===17);return $s(Xe,De)}function V(te){let De=B();return cr(h.createTemplateExpression(ds(te),Gt(te)),De)}function Pe(){let te=B();return cr(h.createTemplateLiteralType(ds(!1),ot()),te)}function ot(){let te=B(),De=[],Xe;do Xe=Yt(),De.push(Xe);while(Xe.literal.kind===17);return $s(De,te)}function Yt(){let te=B();return cr(h.createTemplateLiteralTypeSpan(zl(),_n(!1)),te)}function _n(te){return X()===20?(zr(te),Ya()):Uo(18,g._0_expected,Sa(20))}function gi(te){let De=B();return cr(h.createTemplateSpan(Nr(He),_n(te)),De)}function ci(){return Zc(X())}function ds(te){!te&&t.getTokenFlags()&26656&&zr(!1);let De=Zc(X());return I.assert(De.kind===16,"Template head has wrong token kind"),De}function Ya(){let te=Zc(X());return I.assert(te.kind===17||te.kind===18,"Template fragment has wrong token kind"),te}function Xa(te){let De=te===15||te===18,Xe=t.getTokenText();return Xe.substring(1,Xe.length-(t.isUnterminated()?0:De?1:2))}function Zc(te){let De=B(),Xe=Rv(te)?h.createTemplateLiteralLikeNode(te,t.getTokenValue(),Xa(te),t.getTokenFlags()&7176):te===9?A(t.getTokenValue(),t.getNumericLiteralFlags()):te===11?k(t.getTokenValue(),void 0,t.hasExtendedUnicodeEscape()):Ow(te)?N(te,t.getTokenValue()):I.fail();return t.hasExtendedUnicodeEscape()&&(Xe.hasExtendedUnicodeEscape=!0),t.isUnterminated()&&(Xe.isUnterminated=!0),Le(),cr(Xe,De)}function Gu(){return ie(!0,g.Type_expected)}function nu(){if(!t.hasPrecedingLineBreak()&&Yr()===30)return Of(20,zl,30,32)}function Sp(){let te=B();return cr(h.createTypeReferenceNode(Gu(),nu()),te)}function Rf(te){switch(te.kind){case 183:return sl(te.typeName);case 184:case 185:{let{parameters:De,type:Xe}=te;return U0(De)||Rf(Xe)}case 196:return Rf(te.type);default:return!1}}function _S(te){return Le(),cr(h.createTypePredicateNode(void 0,te,zl()),te.pos)}function xo(){let te=B();return Le(),cr(h.createThisTypeNode(),te)}function Wm(){let te=B();return Le(),cr(h.createJSDocAllType(),te)}function Gm(){let te=B();return Le(),cr(h.createJSDocNonNullableType(pS(),!1),te)}function ts(){let te=B();return Le(),X()===28||X()===20||X()===22||X()===32||X()===64||X()===52?cr(h.createJSDocUnknownType(),te):cr(h.createJSDocNullableType(zl(),!1),te)}function jy(){let te=B(),De=le();if(ji(Vd)){let Xe=br(36),Pt=Ht(59,!1);return On(cr(h.createJSDocFunctionType(Xe,Pt),te),De)}return cr(h.createTypeReferenceNode(ru(),void 0),te)}function H1(){let te=B(),De;return(X()===110||X()===105)&&(De=ru(),Mr(59)),cr(h.createParameterDeclaration(void 0,void 0,De,void 0,Hm(),void 0),te)}function Hm(){t.setInJSDocType(!0);let te=B();if(ks(144)){let Pt=h.createJSDocNamepathType(void 0);e:for(;;)switch(X()){case 20:case 1:case 28:case 5:break e;default:It()}return t.setInJSDocType(!1),cr(Pt,te)}let De=ks(26),Xe=dS();return t.setInJSDocType(!1),De&&(Xe=cr(h.createJSDocVariadicType(Xe),te)),X()===64?(Le(),cr(h.createJSDocOptionalType(Xe),te)):Xe}function wE(){let te=B();Mr(114);let De=ie(!0),Xe=t.hasPrecedingLineBreak()?void 0:nb();return cr(h.createTypeQueryNode(De,Xe),te)}function OE(){let te=B(),De=e0(!1,!0),Xe=Go(),Pt,wt;ks(96)&&(V0()||!yg()?Pt=zl():wt=gS());let Xt=ks(64)?zl():void 0,Yn=h.createTypeParameterDeclaration(De,Xe,Pt,Xt);return Yn.expression=wt,cr(Yn,te)}function md(){if(X()===30)return Of(19,OE,30,32)}function lh(te){return X()===26||mo()||C1(X())||X()===60||V0(!te)}function gd(te){let De=Rn(g.Private_identifiers_cannot_be_used_as_parameters);return f8(De)===0&&!Tt(te)&&C1(X())&&Le(),De}function By(){return ni()||X()===23||X()===19}function Je(te){return Ft(te)}function et(te){return Ft(te,!1)}function Ft(te,De=!0){let Xe=B(),Pt=le(),wt=te?_e(()=>e0(!0)):Ve(()=>e0(!0));if(X()===110){let Ui=h.createParameterDeclaration(wt,void 0,Wu(!0),void 0,X1(),void 0),Ai=qi(wt);return Ai&&Be(Ai,g.Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters),On(cr(Ui,Xe),Pt)}let Xt=Tr;Tr=!1;let Yn=ya(26);if(!De&&!By())return;let Hi=On(cr(h.createParameterDeclaration(wt,Yn,gd(wt),ya(58),X1(),vg()),Xe),Pt);return Tr=Xt,Hi}function Ht(te,De){if(Er(te,De))return We(dS)}function Er(te,De){return te===39?(Mr(te),!0):ks(59)?!0:De&&X()===39?(hr(g._0_expected,Sa(59)),Le(),!0):!1}function nn(te,De){let Xe=Nt(),Pt=Cr();Ni(!!(te&1)),Fs(!!(te&2));let wt=te&32?A_(17,H1):A_(16,()=>De?Je(Pt):et(Pt));return Ni(Xe),Fs(Pt),wt}function br(te){if(!Mr(21))return vp();let De=nn(te,!0);return Mr(22),De}function sn(){ks(28)||Tc()}function Ci(te){let De=B(),Xe=le();te===180&&Mr(105);let Pt=md(),wt=br(4),Xt=Ht(59,!0);sn();let Yn=te===179?h.createCallSignature(Pt,wt,Xt):h.createConstructSignature(Pt,wt,Xt);return On(cr(Yn,De),Xe)}function hn(){return X()===23&&Vi(mi)}function mi(){if(Le(),X()===26||X()===24)return!0;if(C1(X())){if(Le(),js())return!0}else if(js())Le();else return!1;return X()===59||X()===28?!0:X()!==58?!1:(Le(),X()===59||X()===28||X()===24)}function Tn(te,De,Xe){let Pt=Of(16,()=>Je(!1),23,24),wt=X1();sn();let Xt=h.createIndexSignature(Xe,Pt,wt);return On(cr(Xt,te),De)}function aa(te,De,Xe){let Pt=gr(),wt=ya(58),Xt;if(X()===21||X()===30){let Yn=md(),Hi=br(4),Ui=Ht(59,!0);Xt=h.createMethodSignature(Xe,Pt,wt,Yn,Hi,Ui)}else{let Yn=X1();Xt=h.createPropertySignature(Xe,Pt,wt,Yn),X()===64&&(Xt.initializer=vg())}return sn(),On(cr(Xt,te),De)}function ao(){if(X()===21||X()===30||X()===139||X()===153)return!0;let te=!1;for(;C1(X());)te=!0,Le();return X()===23?!0:(ne()&&(te=!0,Le()),te?X()===21||X()===30||X()===58||X()===59||X()===28||Nl():!1)}function B_(){if(X()===21||X()===30)return Ci(179);if(X()===105&&Vi(Hu))return Ci(180);let te=B(),De=le(),Xe=e0(!1);return Zn(139)?Gy(te,De,Xe,177,4):Zn(153)?Gy(te,De,Xe,178,4):hn()?Tn(te,De,Xe):aa(te,De,Xe)}function Hu(){return Le(),X()===21||X()===30}function Uy(){return Le()===25}function qT(){switch(Le()){case 21:case 30:case 25:return!0}return!1}function Rk(){let te=B();return cr(h.createTypeLiteralNode(zT()),te)}function zT(){let te;return Mr(19)?(te=ua(4,B_),Mr(20)):te=vp(),te}function HD(){return Le(),X()===40||X()===41?Le()===148:(X()===148&&Le(),X()===23&&Xf()&&Le()===103)}function YD(){let te=B(),De=ru();Mr(103);let Xe=zl();return cr(h.createTypeParameterDeclaration(void 0,De,Xe,void 0),te)}function XD(){let te=B();Mr(19);let De;(X()===148||X()===40||X()===41)&&(De=Ac(),De.kind!==148&&Mr(148)),Mr(23);let Xe=YD(),Pt=ks(130)?zl():void 0;Mr(24);let wt;(X()===58||X()===40||X()===41)&&(wt=Ac(),wt.kind!==58&&Mr(58));let Xt=X1();Tc();let Yn=ua(4,B_);return Mr(20),cr(h.createMappedTypeNode(De,Xe,Pt,wt,Xt,Yn),te)}function Lx(){let te=B();if(ks(26))return cr(h.createRestTypeNode(zl()),te);let De=zl();if(GN(De)&&De.pos===De.type.pos){let Xe=h.createOptionalTypeNode(De.type);return ft(Xe,De),Xe.flags=De.flags,Xe}return De}function RE(){return Le()===59||X()===58&&Le()===59}function Mk(){return X()===26?$_(Le())&&RE():$_(X())&&RE()}function KD(){if(Vi(Mk)){let te=B(),De=le(),Xe=ya(26),Pt=ru(),wt=ya(58);Mr(59);let Xt=Lx(),Yn=h.createNamedTupleMember(Xe,Pt,wt,Xt);return On(cr(Yn,te),De)}return Lx()}function Lk(){let te=B();return cr(h.createTupleTypeNode(Of(21,KD,23,24)),te)}function Fk(){let te=B();Mr(21);let De=zl();return Mr(22),cr(h.createParenthesizedType(De),te)}function jk(){let te;if(X()===128){let De=B();Le();let Xe=cr(U(128),De);te=$s([Xe],De)}return te}function Bk(){let te=B(),De=le(),Xe=jk(),Pt=ks(105);I.assert(!Xe||Pt,"Per isStartOfFunctionOrConstructorType, a function type cannot have modifiers.");let wt=md(),Xt=br(4),Yn=Ht(39,!1),Hi=Pt?h.createConstructorTypeNode(Xe,wt,Xt,Yn):h.createFunctionTypeNode(wt,Xt,Yn);return On(cr(Hi,te),De)}function Fx(){let te=Ac();return X()===25?void 0:te}function Uk(te){let De=B();te&&Le();let Xe=X()===112||X()===97||X()===106?Ac():Zc(X());return te&&(Xe=cr(h.createPrefixUnaryExpression(41,Xe),De)),cr(h.createLiteralTypeNode(Xe),De)}function ME(){return Le(),X()===102}function LE(){Ie|=4194304;let te=B(),De=ks(114);Mr(102),Mr(21);let Xe=zl(),Pt;if(ks(28)){let Yn=t.getTokenStart();Mr(19);let Hi=X();if(Hi===118||Hi===132?Le():hr(g._0_expected,Sa(118)),Mr(59),Pt=AS(Hi,!0),!Mr(20)){let Ui=Is($e);Ui&&Ui.code===g._0_expected.code&&Ga(Ui,wN(Ae,Re,Yn,1,g.The_parser_expected_to_find_a_1_to_match_the_0_token_here,"{","}"))}}Mr(22);let wt=ks(25)?Gu():void 0,Xt=nu();return cr(h.createImportTypeNode(Xe,Pt,wt,Xt,De),te)}function fS(){return Le(),X()===9||X()===10}function pS(){switch(X()){case 133:case 159:case 154:case 150:case 163:case 155:case 136:case 157:case 146:case 151:return ji(Fx)||Sp();case 67:t.reScanAsteriskEqualsToken();case 42:return Wm();case 61:t.reScanQuestionToken();case 58:return ts();case 100:return jy();case 54:return Gm();case 15:case 11:case 9:case 10:case 112:case 97:case 106:return Uk();case 41:return Vi(fS)?Uk(!0):Sp();case 116:return Ac();case 110:{let te=xo();return X()===142&&!t.hasPrecedingLineBreak()?_S(te):te}case 114:return Vi(ME)?LE():wE();case 19:return Vi(HD)?XD():Rk();case 23:return Lk();case 21:return Fk();case 102:return LE();case 131:return Vi(Wp)?Jk():Sp();case 16:return Pe();default:return Sp()}}function V0(te){switch(X()){case 133:case 159:case 154:case 150:case 163:case 136:case 148:case 155:case 158:case 116:case 157:case 106:case 110:case 114:case 146:case 19:case 23:case 30:case 52:case 51:case 105:case 11:case 9:case 10:case 112:case 97:case 151:case 42:case 58:case 54:case 26:case 140:case 102:case 131:case 15:case 16:return!0;case 100:return!te;case 41:return!te&&Vi(fS);case 21:return!te&&Vi($T);default:return js()}}function $T(){return Le(),X()===22||lh(!1)||V0()}function fo(){let te=B(),De=pS();for(;!t.hasPrecedingLineBreak();)switch(X()){case 54:Le(),De=cr(h.createJSDocNonNullableType(De,!0),te);break;case 58:if(Vi(Bt))return De;Le(),De=cr(h.createJSDocNullableType(De,!0),te);break;case 23:if(Mr(23),V0()){let Xe=zl();Mr(24),De=cr(h.createIndexedAccessTypeNode(De,Xe),te)}else Mr(24),De=cr(h.createArrayTypeNode(De),te);break;default:return De}return De}function jx(te){let De=B();return Mr(te),cr(h.createTypeOperatorNode(te,Xh()),De)}function QD(){if(ks(96)){let te=mt(zl);if(ht()||X()!==58)return te}}function WT(){let te=B(),De=Go(),Xe=ji(QD),Pt=h.createTypeParameterDeclaration(void 0,De,Xe);return cr(Pt,te)}function Vy(){let te=B();return Mr(140),cr(h.createInferTypeNode(WT()),te)}function Xh(){let te=X();switch(te){case 143:case 158:case 148:return jx(te);case 140:return Vy()}return We(fo)}function jd(te){if(Bx()){let De=Bk(),Xe;return Vh(De)?Xe=te?g.Function_type_notation_must_be_parenthesized_when_used_in_a_union_type:g.Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type:Xe=te?g.Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type:g.Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type,Be(De,Xe),De}}function Mf(te,De,Xe){let Pt=B(),wt=te===52,Xt=ks(te),Yn=Xt&&jd(wt)||De();if(X()===te||Xt){let Hi=[Yn];for(;ks(te);)Hi.push(jd(wt)||De());Yn=cr(Xe($s(Hi,Pt)),Pt)}return Yn}function Tp(){return Mf(51,Xh,h.createIntersectionTypeNode)}function Kf(){return Mf(52,Tp,h.createUnionTypeNode)}function Y1(){return Le(),X()===105}function Bx(){return X()===30||X()===21&&Vi(Vk)?!0:X()===105||X()===128&&Vi(Y1)}function ZD(){if(C1(X())&&e0(!1),js()||X()===110)return Le(),!0;if(X()===23||X()===19){let te=$e.length;return Rn(),te===$e.length}return!1}function Vk(){return Le(),!!(X()===22||X()===26||ZD()&&(X()===59||X()===28||X()===58||X()===64||X()===22&&(Le(),X()===39)))}function dS(){let te=B(),De=js()&&ji(GT),Xe=zl();return De?cr(h.createTypePredicateNode(void 0,De,Xe),te):Xe}function GT(){let te=Go();if(X()===142&&!t.hasPrecedingLineBreak())return Le(),te}function Jk(){let te=B(),De=Uo(131),Xe=X()===110?xo():Go(),Pt=ks(142)?zl():void 0;return cr(h.createTypePredicateNode(De,Xe,Pt),te)}function zl(){if(rn&81920)return Ta(81920,zl);if(Bx())return Bk();let te=B(),De=Kf();if(!ht()&&!t.hasPrecedingLineBreak()&&ks(96)){let Xe=mt(zl);Mr(58);let Pt=We(zl);Mr(59);let wt=We(zl);return cr(h.createConditionalTypeNode(De,Xe,Pt,wt),te)}return De}function X1(){return ks(59)?zl():void 0}function qk(){switch(X()){case 110:case 108:case 106:case 112:case 97:case 9:case 10:case 11:case 15:case 16:case 21:case 23:case 19:case 100:case 86:case 105:case 44:case 69:case 80:return!0;case 102:return Vi(qT);default:return js()}}function yg(){if(qk())return!0;switch(X()){case 40:case 41:case 55:case 54:case 91:case 114:case 116:case 46:case 47:case 30:case 135:case 127:case 81:case 60:return!0;default:return Tg()?!0:js()}}function Ux(){return X()!==19&&X()!==100&&X()!==86&&X()!==60&&yg()}function He(){let te=Wt();te&&us(!1);let De=B(),Xe=Yu(!0),Pt;for(;Pt=ya(28);)Xe=FE(Xe,Pt,Yu(!0),De);return te&&us(!0),Xe}function vg(){return ks(64)?Yu(!0):void 0}function Yu(te){if(HT())return mS();let De=Q1(te)||Vx(te);if(De)return De;let Xe=B(),Pt=le(),wt=ym(0);return wt.kind===80&&X()===39?K1(Xe,wt,te,Pt,void 0):$f(wt)&&D1(Zt())?FE(wt,Ac(),Yu(te),Xe):hm(wt,Xe,te)}function HT(){return X()===127?Nt()?!0:Vi(ac):!1}function zk(){return Le(),!t.hasPrecedingLineBreak()&&js()}function mS(){let te=B();return Le(),!t.hasPrecedingLineBreak()&&(X()===42||yg())?cr(h.createYieldExpression(ya(42),Yu(!0)),te):cr(h.createYieldExpression(void 0,void 0),te)}function K1(te,De,Xe,Pt,wt){I.assert(X()===39,"parseSimpleArrowFunctionExpression should only have been called if we had a =>");let Xt=h.createParameterDeclaration(void 0,void 0,De,void 0,void 0,void 0);cr(Xt,De.pos);let Yn=$s([Xt],Xt.pos,Xt.end),Hi=Uo(39),Ui=qx(!!wt,Xe),Ai=h.createArrowFunction(wt,void 0,Yn,void 0,Hi,Ui);return On(cr(Ai,te),Pt)}function Q1(te){let De=XO();if(De!==0)return De===1?YT(!0,!0):ji(()=>Sg(te))}function XO(){return X()===21||X()===30||X()===134?Vi(oo):X()===39?1:0}function oo(){if(X()===134&&(Le(),t.hasPrecedingLineBreak()||X()!==21&&X()!==30))return 0;let te=X(),De=Le();if(te===21){if(De===22)switch(Le()){case 39:case 59:case 19:return 1;default:return 0}if(De===23||De===19)return 2;if(De===26)return 1;if(C1(De)&&De!==134&&Vi(Xf))return Le()===130?0:1;if(!js()&&De!==110)return 0;switch(Le()){case 59:return 1;case 58:return Le(),X()===59||X()===28||X()===64||X()===22?1:0;case 28:case 64:case 22:return 2}return 0}else return I.assert(te===30),!js()&&X()!==87?0:ke===1?Vi(()=>{ks(87);let Pt=Le();if(Pt===96)switch(Le()){case 64:case 32:case 44:return!1;default:return!0}else if(Pt===28||Pt===64)return!0;return!1})?1:0:2}function Sg(te){let De=t.getTokenStart();if(Fr?.has(De))return;let Xe=YT(!1,te);return Xe||(Fr||(Fr=new Set)).add(De),Xe}function Vx(te){if(X()===134&&Vi(Jx)===1){let De=B(),Xe=le(),Pt=Sd(),wt=ym(0);return K1(De,wt,te,Xe,Pt)}}function Jx(){if(X()===134){if(Le(),t.hasPrecedingLineBreak()||X()===39)return 0;let te=ym(0);if(!t.hasPrecedingLineBreak()&&te.kind===80&&X()===39)return 1}return 0}function YT(te,De){let Xe=B(),Pt=le(),wt=Sd(),Xt=Tt(wt,R6)?2:0,Yn=md(),Hi;if(Mr(21)){if(te)Hi=nn(Xt,te);else{let Y0=nn(Xt,te);if(!Y0)return;Hi=Y0}if(!Mr(22)&&!te)return}else{if(!te)return;Hi=vp()}let Ui=X()===59,Ai=Ht(59,!1);if(Ai&&!te&&Rf(Ai))return;let cs=Ai;for(;cs?.kind===196;)cs=cs.type;let Co=cs&&HN(cs);if(!te&&X()!==39&&(Co||X()!==19))return;let zo=X(),_o=Uo(39),Jd=zo===39||zo===19?qx(Tt(wt,R6),De):Go();if(!De&&Ui&&X()!==59)return;let mh=h.createArrowFunction(wt,Yn,Hi,Ai,_o,Jd);return On(cr(mh,Xe),Pt)}function qx(te,De){if(X()===19)return SS(te?2:0);if(X()!==27&&X()!==100&&X()!==86&&qE()&&!Ux())return SS(16|(te?2:0));let Xe=Tr;Tr=!1;let Pt=te?_e(()=>Yu(De)):Ve(()=>Yu(De));return Tr=Xe,Pt}function hm(te,De,Xe){let Pt=ya(58);if(!Pt)return te;let wt;return cr(h.createConditionalExpression(te,Pt,Ta(n,()=>Yu(!1)),wt=Uo(59),nm(wt)?Yu(Xe):ic(80,!1,g._0_expected,Sa(59))),De)}function ym(te){let De=B(),Xe=gS();return $k(te,Xe,De)}function Jy(te){return te===103||te===165}function $k(te,De,Xe){for(;;){Zt();let Pt=X8(X());if(!(X()===43?Pt>=te:Pt>te)||X()===103&&Ke())break;if(X()===130||X()===152){if(t.hasPrecedingLineBreak())break;{let Xt=X();Le(),De=Xt===152?eI(De,zl()):as(De,zl())}}else De=FE(De,Ac(),ym(Pt),Xe)}return De}function Tg(){return Ke()&&X()===103?!1:X8(X())>0}function eI(te,De){return cr(h.createSatisfiesExpression(te,De),te.pos)}function FE(te,De,Xe,Pt){return cr(h.createBinaryExpression(te,De,Xe),Pt)}function as(te,De){return cr(h.createAsExpression(te,De),te.pos)}function _i(){let te=B();return cr(h.createPrefixUnaryExpression(X(),qe(wc)),te)}function Kh(){let te=B();return cr(h.createDeleteExpression(qe(wc)),te)}function Lf(){let te=B();return cr(h.createTypeOfExpression(qe(wc)),te)}function KO(){let te=B();return cr(h.createVoidExpression(qe(wc)),te)}function qy(){return X()===135?Cr()?!0:Vi(ac):!1}function QO(){let te=B();return cr(h.createAwaitExpression(qe(wc)),te)}function gS(){if(zp()){let Xe=B(),Pt=J0();return X()===43?$k(X8(X()),Pt,Xe):Pt}let te=X(),De=wc();if(X()===43){let Xe=Wa(Re,De.pos),{end:Pt}=De;De.kind===216?Y(Xe,Pt,g.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses):(I.assert(vj(te)),Y(Xe,Pt,g.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses,Sa(te)))}return De}function wc(){switch(X()){case 40:case 41:case 55:case 54:return _i();case 91:return Kh();case 114:return Lf();case 116:return KO();case 30:return ke===1?zy(!0,void 0,void 0,!0):Xm();case 135:if(qy())return QO();default:return J0()}}function zp(){switch(X()){case 40:case 41:case 55:case 54:case 91:case 114:case 116:case 135:return!1;case 30:if(ke!==1)return!1;default:return!0}}function J0(){if(X()===46||X()===47){let De=B();return cr(h.createPrefixUnaryExpression(X(),qe(vm)),De)}else if(ke===1&&X()===30&&Vi(gm))return zy(!0);let te=vm();if(I.assert($f(te)),(X()===46||X()===47)&&!t.hasPrecedingLineBreak()){let De=X();return Le(),cr(h.createPostfixUnaryExpression(te,De),te.pos)}return te}function vm(){let te=B(),De;return X()===102?Vi(Hu)?(Ie|=4194304,De=Ac()):Vi(Uy)?(Le(),Le(),De=cr(h.createMetaProperty(102,ru()),te),Ie|=8388608):De=hS():De=X()===108?Ym():hS(),ev(te,De)}function hS(){let te=B(),De=XT();return Lu(te,De,!0)}function Ym(){let te=B(),De=Ac();if(X()===30){let Xe=B(),Pt=ji(yn);Pt!==void 0&&(Y(Xe,B(),g.super_may_not_use_type_arguments),_s()||(De=h.createExpressionWithTypeArguments(De,Pt)))}return X()===21||X()===25||X()===23?De:(Uo(25,g.super_must_be_followed_by_an_argument_list_or_member_access),cr(re(De,Jt(!0,!0,!0)),te))}function zy(te,De,Xe,Pt=!1){let wt=B(),Xt=z0(te),Yn;if(Xt.kind===286){let Hi=q0(Xt),Ui,Ai=Hi[Hi.length-1];if(Ai?.kind===284&&!DT(Ai.openingElement.tagName,Ai.closingElement.tagName)&&DT(Xt.tagName,Ai.closingElement.tagName)){let cs=Ai.children.end,Co=cr(h.createJsxElement(Ai.openingElement,Ai.children,cr(h.createJsxClosingElement(cr(M(""),cs,cs)),cs,cs)),Ai.openingElement.pos,cs);Hi=$s([...Hi.slice(0,Hi.length-1),Co],Hi.pos,cs),Ui=Ai.closingElement}else Ui=BE(Xt,te),DT(Xt.tagName,Ui.tagName)||(Xe&&eh(Xe)&&DT(Ui.tagName,Xe.tagName)?Be(Xt.tagName,g.JSX_element_0_has_no_corresponding_closing_tag,Bw(Re,Xt.tagName)):Be(Ui.tagName,g.Expected_corresponding_JSX_closing_tag_for_0,Bw(Re,Xt.tagName)));Yn=cr(h.createJsxElement(Xt,Hi,Ui),wt)}else Xt.kind===289?Yn=cr(h.createJsxFragment(Xt,q0(Xt),Wx(te)),wt):(I.assert(Xt.kind===285),Yn=Xt);if(!Pt&&te&&X()===30){let Hi=typeof De>"u"?Yn.pos:De,Ui=ji(()=>zy(!0,Hi));if(Ui){let Ai=ic(28,!1);return T6(Ai,Ui.pos,0),Y(Wa(Re,Hi),Ui.end,g.JSX_expressions_must_have_one_parent_element),cr(h.createBinaryExpression(Yn,Ai,Ui),wt)}}return Yn}function jE(){let te=B(),De=h.createJsxText(t.getTokenValue(),St===13);return St=t.scanJsxToken(),cr(De,te)}function zx(te,De){switch(De){case 1:if(nk(te))Be(te,g.JSX_fragment_has_no_corresponding_closing_tag);else{let Xe=te.tagName,Pt=Math.min(Wa(Re,Xe.pos),Xe.end);Y(Pt,Xe.end,g.JSX_element_0_has_no_corresponding_closing_tag,Bw(Re,te.tagName))}return;case 31:case 7:return;case 12:case 13:return jE();case 19:return tI(!1);case 30:return zy(!1,void 0,te);default:return I.assertNever(De)}}function q0(te){let De=[],Xe=B(),Pt=or;for(or|=16384;;){let wt=zx(te,St=t.reScanJsxToken());if(!wt||(De.push(wt),eh(te)&&wt?.kind===284&&!DT(wt.openingElement.tagName,wt.closingElement.tagName)&&DT(te.tagName,wt.closingElement.tagName)))break}return or=Pt,$s(De,Xe)}function Wk(){let te=B();return cr(h.createJsxAttributes(ua(13,rI)),te)}function z0(te){let De=B();if(Mr(30),X()===32)return fn(),cr(h.createJsxOpeningFragment(),De);let Xe=uh(),Pt=rn&524288?void 0:nb(),wt=Wk(),Xt;return X()===32?(fn(),Xt=h.createJsxOpeningElement(Xe,Pt,wt)):(Mr(44),Mr(32,void 0,!1)&&(te?Le():fn()),Xt=h.createJsxSelfClosingElement(Xe,Pt,wt)),cr(Xt,De)}function uh(){let te=B(),De=Z1();if(pg(De))return De;let Xe=De;for(;ks(25);)Xe=cr(re(Xe,Jt(!0,!1,!1)),te);return Xe}function Z1(){let te=B();Fi();let De=X()===110,Xe=ge();return ks(59)?(Fi(),cr(h.createJsxNamespacedName(Xe,ge()),te)):De?cr(h.createToken(110),te):Xe}function tI(te){let De=B();if(!Mr(19))return;let Xe,Pt;return X()!==20&&(te||(Xe=ya(26)),Pt=He()),te?Mr(20):Mr(20,void 0,!1)&&fn(),cr(h.createJsxExpression(Xe,Pt),De)}function rI(){if(X()===19)return pc();let te=B();return cr(h.createJsxAttribute($x(),nI()),te)}function nI(){if(X()===64){if(Qn()===11)return ci();if(X()===19)return tI(!0);if(X()===30)return zy(!0);hr(g.or_JSX_element_expected)}}function $x(){let te=B();Fi();let De=ge();return ks(59)?(Fi(),cr(h.createJsxNamespacedName(De,ge()),te)):De}function pc(){let te=B();Mr(19),Mr(26);let De=He();return Mr(20),cr(h.createJsxSpreadAttribute(De),te)}function BE(te,De){let Xe=B();Mr(31);let Pt=uh();return Mr(32,void 0,!1)&&(De||!DT(te.tagName,Pt)?Le():fn()),cr(h.createJsxClosingElement(Pt),Xe)}function Wx(te){let De=B();return Mr(31),Mr(32,g.Expected_corresponding_closing_tag_for_JSX_fragment,!1)&&(te?Le():fn()),cr(h.createJsxJsxClosingFragment(),De)}function Xm(){I.assert(ke!==1,"Type assertions should never be parsed in JSX; they should be parsed as comparisons or JSX elements/fragments.");let te=B();Mr(30);let De=zl();Mr(32);let Xe=wc();return cr(h.createTypeAssertion(De,Xe),te)}function yS(){return Le(),$_(X())||X()===23||_s()}function iI(){return X()===29&&Vi(yS)}function Gx(te){if(te.flags&64)return!0;if(ek(te)){let De=te.expression;for(;ek(De)&&!(De.flags&64);)De=De.expression;if(De.flags&64){for(;ek(te);)te.flags|=64,te=te.expression;return!0}}return!1}function ZO(te,De,Xe){let Pt=Jt(!0,!0,!0),wt=Xe||Gx(De),Xt=wt?$(De,Xe,Pt):re(De,Pt);if(wt&&is(Xt.name)&&Be(Xt.name,g.An_optional_chain_cannot_contain_private_identifiers),L1(De)&&De.typeArguments){let Yn=De.typeArguments.pos-1,Hi=Wa(Re,De.typeArguments.end)+1;Y(Yn,Hi,g.An_instantiation_expression_cannot_be_followed_by_a_property_access)}return cr(Xt,te)}function Cn(te,De,Xe){let Pt;if(X()===24)Pt=ic(80,!0,g.An_element_access_expression_should_take_an_argument);else{let Xt=Nr(He);id(Xt)&&(Xt.text=Mu(Xt.text)),Pt=Xt}Mr(24);let wt=Xe||Gx(De)?z(De,Xe,Pt):pe(De,Pt);return cr(wt,te)}function Lu(te,De,Xe){for(;;){let Pt,wt=!1;if(Xe&&iI()?(Pt=Uo(29),wt=$_(X())):wt=ks(25),wt){De=ZO(te,De,Pt);continue}if((Pt||!Wt())&&ks(23)){De=Cn(te,De,Pt);continue}if(_s()){De=!Pt&&De.kind===233?hd(te,De.expression,Pt,De.typeArguments):hd(te,De,Pt,void 0);continue}if(!Pt){if(X()===54&&!t.hasPrecedingLineBreak()){Le(),De=cr(h.createNonNullExpression(De),te);continue}let Xt=ji(yn);if(Xt){De=cr(h.createExpressionWithTypeArguments(De,Xt),te);continue}}return De}}function _s(){return X()===15||X()===16}function hd(te,De,Xe,Pt){let wt=h.createTaggedTemplateExpression(De,Pt,X()===15?(zr(!0),ci()):V(!0));return(Xe||De.flags&64)&&(wt.flags|=64),wt.questionDotToken=Xe,cr(wt,te)}function ev(te,De){for(;;){De=Lu(te,De,!0);let Xe,Pt=ya(29);if(Pt&&(Xe=ji(yn),_s())){De=hd(te,De,Pt,Xe);continue}if(Xe||X()===21){!Pt&&De.kind===233&&(Xe=De.typeArguments,De=De.expression);let wt=_h(),Xt=Pt||Gx(De)?Se(De,Pt,Xe,wt):se(De,Xe,wt);De=cr(Xt,te);continue}if(Pt){let wt=ic(80,!1,g.Identifier_expected);De=cr($(De,Pt,wt),te)}break}return De}function _h(){Mr(21);let te=A_(11,UE);return Mr(22),te}function yn(){if(rn&524288||Yr()!==30)return;Le();let te=A_(20,zl);if(Zt()===32)return Le(),te&&Hx()?te:void 0}function Hx(){switch(X()){case 21:case 15:case 16:return!0;case 30:case 32:case 40:case 41:return!1}return t.hasPrecedingLineBreak()||Tg()||!yg()}function XT(){switch(X()){case 15:t.getTokenFlags()&26656&&zr(!1);case 9:case 10:case 11:return ci();case 110:case 108:case 106:case 112:case 97:return Ac();case 21:return Cu();case 23:return VE();case 19:return $y();case 134:if(!Vi(eC))break;return Yx();case 60:return rb();case 86:return Zk();case 100:return Yx();case 105:return KT();case 44:case 69:if(Ir()===14)return ci();break;case 16:return V(!1);case 81:return xn()}return Go(g.Expression_expected)}function Cu(){let te=B(),De=le();Mr(21);let Xe=Nr(He);return Mr(22),On(cr(Z(Xe),te),De)}function Qh(){let te=B();Mr(26);let De=Yu(!0);return cr(h.createSpreadElement(De),te)}function Km(){return X()===26?Qh():X()===28?cr(h.createOmittedExpression(),B()):Yu(!0)}function UE(){return Ta(n,Km)}function VE(){let te=B(),De=t.getTokenStart(),Xe=Mr(23),Pt=t.hasPrecedingLineBreak(),wt=A_(15,Km);return zu(23,24,Xe,De),cr(H(wt,Pt),te)}function vS(){let te=B(),De=le();if(ya(26)){let cs=Yu(!0);return On(cr(h.createSpreadAssignment(cs),te),De)}let Xe=e0(!0);if(Zn(139))return Gy(te,De,Xe,177,0);if(Zn(153))return Gy(te,De,Xe,178,0);let Pt=ya(42),wt=js(),Xt=gr(),Yn=ya(58),Hi=ya(54);if(Pt||X()===21||X()===30)return bg(te,De,Xe,Pt,Xt,Yn,Hi);let Ui;if(wt&&X()!==59){let cs=ya(64),Co=cs?Nr(()=>Yu(!0)):void 0;Ui=h.createShorthandPropertyAssignment(Xt,Co),Ui.equalsToken=cs}else{Mr(59);let cs=Nr(()=>Yu(!0));Ui=h.createPropertyAssignment(Xt,cs)}return Ui.modifiers=Xe,Ui.questionToken=Yn,Ui.exclamationToken=Hi,On(cr(Ui,te),De)}function $y(){let te=B(),De=t.getTokenStart(),Xe=Mr(19),Pt=t.hasPrecedingLineBreak(),wt=A_(12,vS,!0);return zu(19,20,Xe,De),cr(K(wt,Pt),te)}function Yx(){let te=Wt();us(!1);let De=B(),Xe=le(),Pt=e0(!1);Mr(100);let wt=ya(42),Xt=wt?1:0,Yn=Tt(Pt,R6)?2:0,Hi=Xt&&Yn?pt(Qm):Xt?dt(Qm):Yn?_e(Qm):Qm(),Ui=md(),Ai=br(Xt|Yn),cs=Ht(59,!1),Co=SS(Xt|Yn);us(te);let zo=h.createFunctionExpression(Pt,wt,Hi,Ui,Ai,cs,Co);return On(cr(zo,De),Xe)}function Qm(){return ni()?yp():void 0}function KT(){let te=B();if(Mr(105),ks(25)){let Xt=ru();return cr(h.createMetaProperty(105,Xt),te)}let De=B(),Xe=Lu(De,XT(),!1),Pt;Xe.kind===233&&(Pt=Xe.typeArguments,Xe=Xe.expression),X()===29&&hr(g.Invalid_optional_chain_from_new_expression_Did_you_mean_to_call_0,Bw(Re,Xe));let wt=X()===21?_h():void 0;return cr(xe(Xe,Pt,wt),te)}function $0(te,De){let Xe=B(),Pt=le(),wt=t.getTokenStart(),Xt=Mr(19,De);if(Xt||te){let Yn=t.hasPrecedingLineBreak(),Hi=ua(1,Zf);zu(19,20,Xt,wt);let Ui=On(cr(Q(Hi,Yn),Xe),Pt);return X()===64&&(hr(g.Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_whole_assignment_in_parentheses),Le()),Ui}else{let Yn=vp();return On(cr(Q(Yn,void 0),Xe),Pt)}}function SS(te,De){let Xe=Nt();Ni(!!(te&1));let Pt=Cr();Fs(!!(te&2));let wt=Tr;Tr=!1;let Xt=Wt();Xt&&us(!1);let Yn=$0(!!(te&16),De);return Xt&&us(!0),Tr=wt,Ni(Xe),Fs(Pt),Yn}function Gk(){let te=B(),De=le();return Mr(27),On(cr(h.createEmptyStatement(),te),De)}function QT(){let te=B(),De=le();Mr(101);let Xe=t.getTokenStart(),Pt=Mr(21),wt=Nr(He);zu(21,22,Pt,Xe);let Xt=Zf(),Yn=ks(93)?Zf():void 0;return On(cr(we(wt,Xt,Yn),te),De)}function sI(){let te=B(),De=le();Mr(92);let Xe=Zf();Mr(117);let Pt=t.getTokenStart(),wt=Mr(21),Xt=Nr(He);return zu(21,22,wt,Pt),ks(27),On(cr(h.createDoStatement(Xe,Xt),te),De)}function JE(){let te=B(),De=le();Mr(117);let Xe=t.getTokenStart(),Pt=Mr(21),wt=Nr(He);zu(21,22,Pt,Xe);let Xt=Zf();return On(cr(ve(wt,Xt),te),De)}function Xx(){let te=B(),De=le();Mr(99);let Xe=ya(135);Mr(21);let Pt;X()!==27&&(X()===115||X()===121||X()===87||X()===160&&Vi(Wy)||X()===135&&Vi(bp)?Pt=zE(!0):Pt=qr(He));let wt;if(Xe?Mr(165):ks(165)){let Xt=Nr(()=>Yu(!0));Mr(22),wt=Ee(Xe,Pt,Xt,Zf())}else if(ks(103)){let Xt=Nr(He);Mr(22),wt=h.createForInStatement(Pt,Xt,Zf())}else{Mr(27);let Xt=X()!==27&&X()!==22?Nr(He):void 0;Mr(27);let Yn=X()!==22?Nr(He):void 0;Mr(22),wt=oe(Pt,Xt,Yn,Zf())}return On(cr(wt,te),De)}function $p(te){let De=B(),Xe=le();Mr(te===252?83:88);let Pt=Nl()?void 0:Go();Tc();let wt=te===252?h.createBreakStatement(Pt):h.createContinueStatement(Pt);return On(cr(wt,De),Xe)}function Kx(){let te=B(),De=le();Mr(107);let Xe=Nl()?void 0:Nr(He);return Tc(),On(cr(h.createReturnStatement(Xe),te),De)}function ll(){let te=B(),De=le();Mr(118);let Xe=t.getTokenStart(),Pt=Mr(21),wt=Nr(He);zu(21,22,Pt,Xe);let Xt=to(67108864,Zf);return On(cr(h.createWithStatement(wt,Xt),te),De)}function du(){let te=B(),De=le();Mr(84);let Xe=Nr(He);Mr(59);let Pt=ua(3,Zf);return On(cr(h.createCaseClause(Xe,Pt),te),De)}function Qx(){let te=B();Mr(90),Mr(59);let De=ua(3,Zf);return cr(h.createDefaultClause(De),te)}function a_(){return X()===84?du():Qx()}function Qf(){let te=B();Mr(19);let De=ua(2,a_);return Mr(20),cr(h.createCaseBlock(De),te)}function ZT(){let te=B(),De=le();Mr(109),Mr(21);let Xe=Nr(He);Mr(22);let Pt=Qf();return On(cr(h.createSwitchStatement(Xe,Pt),te),De)}function Bd(){let te=B(),De=le();Mr(111);let Xe=t.hasPrecedingLineBreak()?void 0:Nr(He);return Xe===void 0&&(ar++,Xe=cr(M(""),B())),zc()||Sl(Xe),On(cr(h.createThrowStatement(Xe),te),De)}function TS(){let te=B(),De=le();Mr(113);let Xe=$0(!1),Pt=X()===85?bS():void 0,wt;return(!Pt||X()===98)&&(Mr(98,g.catch_or_finally_expected),wt=$0(!1)),On(cr(h.createTryStatement(Xe,Pt,wt),te),De)}function bS(){let te=B();Mr(85);let De;ks(21)?(De=yf(),Mr(22)):De=void 0;let Xe=$0(!1);return cr(h.createCatchClause(De,Xe),te)}function Fu(){let te=B(),De=le();return Mr(89),Tc(),On(cr(h.createDebuggerStatement(),te),De)}function Hk(){let te=B(),De=le(),Xe,Pt=X()===21,wt=Nr(He);return ze(wt)&&ks(59)?Xe=h.createLabeledStatement(wt,Zf()):(zc()||Sl(wt),Xe=ye(wt),Pt&&(De=!1)),On(cr(Xe,te),De)}function Wp(){return Le(),$_(X())&&!t.hasPrecedingLineBreak()}function Zx(){return Le(),X()===86&&!t.hasPrecedingLineBreak()}function eC(){return Le(),X()===100&&!t.hasPrecedingLineBreak()}function ac(){return Le(),($_(X())||X()===9||X()===10||X()===11)&&!t.hasPrecedingLineBreak()}function aI(){for(;;)switch(X()){case 115:case 121:case 87:case 100:case 86:case 94:return!0;case 160:return Yk();case 135:return Xk();case 120:case 156:return zk();case 144:case 145:return lI();case 128:case 129:case 134:case 138:case 123:case 124:case 125:case 148:let te=X();if(Le(),t.hasPrecedingLineBreak())return!1;if(te===138&&X()===156)return!0;continue;case 162:return Le(),X()===19||X()===80||X()===95;case 102:return Le(),X()===11||X()===42||X()===19||$_(X());case 95:let De=Le();if(De===156&&(De=Vi(Le)),De===64||De===42||De===19||De===90||De===130||De===60)return!0;continue;case 126:Le();continue;default:return!1}}function eb(){return Vi(aI)}function qE(){switch(X()){case 60:case 27:case 19:case 115:case 121:case 160:case 100:case 86:case 94:case 101:case 92:case 117:case 99:case 88:case 83:case 107:case 118:case 109:case 111:case 113:case 89:case 85:case 98:return!0;case 102:return eb()||Vi(qT);case 87:case 95:return eb();case 134:case 138:case 120:case 144:case 145:case 156:case 162:return!0;case 129:case 125:case 123:case 124:case 126:case 148:return eb()||!Vi(Wp);default:return yg()}}function e4(){return Le(),ni()||X()===19||X()===23}function rf(){return Vi(e4)}function Wy(){return fh(!0)}function fh(te){return Le(),te&&X()===165?!1:(ni()||X()===19)&&!t.hasPrecedingLineBreak()}function Yk(){return Vi(fh)}function bp(te){return Le()===160?fh(te):!1}function Xk(){return Vi(bp)}function Zf(){switch(X()){case 27:return Gk();case 19:return $0(!1);case 115:return tb(B(),le(),void 0);case 121:if(rf())return tb(B(),le(),void 0);break;case 135:if(Xk())return tb(B(),le(),void 0);break;case 160:if(Yk())return tb(B(),le(),void 0);break;case 100:return $E(B(),le(),void 0);case 86:return sC(B(),le(),void 0);case 101:return QT();case 92:return sI();case 117:return JE();case 99:return Xx();case 88:return $p(251);case 83:return $p(252);case 107:return Kx();case 118:return ll();case 109:return ZT();case 111:return Bd();case 113:case 85:case 98:return TS();case 89:return Fu();case 60:return tv();case 134:case 120:case 156:case 144:case 145:case 138:case 87:case 94:case 95:case 102:case 123:case 124:case 125:case 128:case 129:case 126:case 148:case 162:if(eb())return tv();break}return Hk()}function Kk(te){return te.kind===138}function tv(){let te=B(),De=le(),Xe=e0(!0);if(Tt(Xe,Kk)){let wt=tC(te);if(wt)return wt;for(let Xt of Xe)Xt.flags|=33554432;return to(33554432,()=>oI(te,De,Xe))}else return oI(te,De,Xe)}function tC(te){return to(33554432,()=>{let De=ql(or,te);if(De)return bc(De)})}function oI(te,De,Xe){switch(X()){case 115:case 121:case 87:case 160:case 135:return tb(te,De,Xe);case 100:return $E(te,De,Xe);case 86:return sC(te,De,Xe);case 120:return gt(te,De,Xe);case 156:return lr(te,De,Xe);case 94:return $i(te,De,Xe);case 162:case 144:case 145:return U_(te,De,Xe);case 102:return Kr(te,De,Xe);case 95:switch(Le(),X()){case 90:case 64:return n0(te,De,Xe);case 130:return t0(te,De,Xe);default:return t4(te,De,Xe)}default:if(Xe){let Pt=ic(282,!0,g.Declaration_expected);return S6(Pt,te),Pt.modifiers=Xe,Pt}return}}function cI(){return Le()===11}function rC(){return Le(),X()===161||X()===64}function lI(){return Le(),!t.hasPrecedingLineBreak()&&(js()||X()===11)}function ES(te,De){if(X()!==19){if(te&4){sn();return}if(Nl()){Tc();return}}return SS(te,De)}function Ep(){let te=B();if(X()===28)return cr(h.createOmittedExpression(),te);let De=ya(26),Xe=Rn(),Pt=vg();return cr(h.createBindingElement(De,void 0,Xe,Pt),te)}function Zh(){let te=B(),De=ya(26),Xe=ni(),Pt=gr(),wt;Xe&&X()!==59?(wt=Pt,Pt=void 0):(Mr(59),wt=Rn());let Xt=vg();return cr(h.createBindingElement(De,Pt,wt,Xt),te)}function uI(){let te=B();Mr(19);let De=Nr(()=>A_(9,Zh));return Mr(20),cr(h.createObjectBindingPattern(De),te)}function nC(){let te=B();Mr(23);let De=Nr(()=>A_(10,Ep));return Mr(24),cr(h.createArrayBindingPattern(De),te)}function mo(){return X()===19||X()===23||X()===81||ni()}function Rn(te){return X()===23?nC():X()===19?uI():yp(te)}function yd(){return yf(!0)}function yf(te){let De=B(),Xe=le(),Pt=Rn(g.Private_identifiers_are_not_allowed_in_variable_declarations),wt;te&&Pt.kind===80&&X()===54&&!t.hasPrecedingLineBreak()&&(wt=Ac());let Xt=X1(),Yn=Jy(X())?void 0:vg(),Hi=Me(Pt,wt,Xt,Yn);return On(cr(Hi,De),Xe)}function zE(te){let De=B(),Xe=0;switch(X()){case 115:break;case 121:Xe|=1;break;case 87:Xe|=2;break;case 160:Xe|=4;break;case 135:I.assert(Xk()),Xe|=6,Le();break;default:I.fail()}Le();let Pt;if(X()===165&&Vi(_I))Pt=vp();else{let wt=Ke();vi(te),Pt=A_(8,te?yf:yd),vi(wt)}return cr(Ge(Pt,Xe),De)}function _I(){return Xf()&&Le()===22}function tb(te,De,Xe){let Pt=zE(!1);Tc();let wt=ce(Xe,Pt);return On(cr(wt,te),De)}function $E(te,De,Xe){let Pt=Cr(),wt=Yg(Xe);Mr(100);let Xt=ya(42),Yn=wt&2048?Qm():yp(),Hi=Xt?1:0,Ui=wt&1024?2:0,Ai=md();wt&32&&Fs(!0);let cs=br(Hi|Ui),Co=Ht(59,!1),zo=ES(Hi|Ui,g.or_expected);Fs(Pt);let _o=h.createFunctionDeclaration(Xe,Xt,Yn,Ai,cs,Co,zo);return On(cr(_o,te),De)}function iC(){if(X()===137)return Mr(137);if(X()===11&&Vi(Le)===21)return ji(()=>{let te=ci();return te.text==="constructor"?te:void 0})}function W0(te,De,Xe){return ji(()=>{if(iC()){let Pt=md(),wt=br(0),Xt=Ht(59,!1),Yn=ES(0,g.or_expected),Hi=h.createConstructorDeclaration(Xe,wt,Yn);return Hi.typeParameters=Pt,Hi.type=Xt,On(cr(Hi,te),De)}})}function bg(te,De,Xe,Pt,wt,Xt,Yn,Hi){let Ui=Pt?1:0,Ai=Tt(Xe,R6)?2:0,cs=md(),Co=br(Ui|Ai),zo=Ht(59,!1),_o=ES(Ui|Ai,Hi),Jd=h.createMethodDeclaration(Xe,Pt,wt,Xt,cs,Co,zo,_o);return Jd.exclamationToken=Yn,On(cr(Jd,te),De)}function vd(te,De,Xe,Pt,wt){let Xt=!wt&&!t.hasPrecedingLineBreak()?ya(54):void 0,Yn=X1(),Hi=Ta(90112,vg);nc(Pt,Yn,Hi);let Ui=h.createPropertyDeclaration(Xe,Pt,wt||Xt,Yn,Hi);return On(cr(Ui,te),De)}function Zm(te,De,Xe){let Pt=ya(42),wt=gr(),Xt=ya(58);return Pt||X()===21||X()===30?bg(te,De,Xe,Pt,wt,Xt,void 0,g.or_expected):vd(te,De,Xe,wt,Xt)}function Gy(te,De,Xe,Pt,wt){let Xt=gr(),Yn=md(),Hi=br(0),Ui=Ht(59,!1),Ai=ES(wt),cs=Pt===177?h.createGetAccessorDeclaration(Xe,Xt,Hi,Ui,Ai):h.createSetAccessorDeclaration(Xe,Xt,Hi,Ai);return cs.typeParameters=Yn,pp(cs)&&(cs.type=Ui),On(cr(cs,te),De)}function G0(){let te;if(X()===60)return!0;for(;C1(X());){if(te=X(),lY(te))return!0;Le()}if(X()===42||(ne()&&(te=X(),Le()),X()===23))return!0;if(te!==void 0){if(!Nf(te)||te===153||te===139)return!0;switch(X()){case 21:case 30:case 54:case 59:case 64:case 58:return!0;default:return Nl()}}return!1}function H0(te,De,Xe){Uo(126);let Pt=Qk(),wt=On(cr(h.createClassStaticBlockDeclaration(Pt),te),De);return wt.modifiers=Xe,wt}function Qk(){let te=Nt(),De=Cr();Ni(!1),Fs(!0);let Xe=$0(!1);return Ni(te),Fs(De),Xe}function Dl(){if(Cr()&&X()===135){let te=B(),De=Go(g.Expression_expected);Le();let Xe=Lu(te,De,!0);return ev(te,Xe)}return vm()}function fI(){let te=B();if(!ks(60))return;let De=Ot(Dl);return cr(h.createDecorator(De),te)}function Ud(te,De,Xe){let Pt=B(),wt=X();if(X()===87&&De){if(!ji(Bi))return}else{if(Xe&&X()===126&&Vi(CS))return;if(te&&X()===126)return;if(!bu())return}return cr(U(wt),Pt)}function e0(te,De,Xe){let Pt=B(),wt,Xt,Yn,Hi=!1,Ui=!1,Ai=!1;if(te&&X()===60)for(;Xt=fI();)wt=Pr(wt,Xt);for(;Yn=Ud(Hi,De,Xe);)Yn.kind===126&&(Hi=!0),wt=Pr(wt,Yn),Ui=!0;if(Ui&&te&&X()===60)for(;Xt=fI();)wt=Pr(wt,Xt),Ai=!0;if(Ai)for(;Yn=Ud(Hi,De,Xe);)Yn.kind===126&&(Hi=!0),wt=Pr(wt,Yn);return wt&&$s(wt,Pt)}function Sd(){let te;if(X()===134){let De=B();Le();let Xe=cr(U(134),De);te=$s([Xe],De)}return te}function WE(){let te=B(),De=le();if(X()===27)return Le(),On(cr(h.createSemicolonClassElement(),te),De);let Xe=e0(!0,!0,!0);if(X()===126&&Vi(CS))return H0(te,De,Xe);if(Zn(139))return Gy(te,De,Xe,177,0);if(Zn(153))return Gy(te,De,Xe,178,0);if(X()===137||X()===11){let Pt=W0(te,De,Xe);if(Pt)return Pt}if(hn())return Tn(te,De,Xe);if($_(X())||X()===11||X()===9||X()===42||X()===23)if(Tt(Xe,Kk)){for(let wt of Xe)wt.flags|=33554432;return to(33554432,()=>Zm(te,De,Xe))}else return Zm(te,De,Xe);if(Xe){let Pt=ic(80,!0,g.Declaration_expected);return vd(te,De,Xe,Pt,void 0)}return I.fail("Should not have attempted to parse class member declaration.")}function rb(){let te=B(),De=le(),Xe=e0(!0);if(X()===86)return Td(te,De,Xe,231);let Pt=ic(282,!0,g.Expression_expected);return S6(Pt,te),Pt.modifiers=Xe,Pt}function Zk(){return Td(B(),le(),void 0,231)}function sC(te,De,Xe){return Td(te,De,Xe,263)}function Td(te,De,Xe,Pt){let wt=Cr();Mr(86);let Xt=Ho(),Yn=md();Tt(Xe,WA)&&Fs(!0);let Hi=HE(),Ui;Mr(19)?(Ui=ue(),Mr(20)):Ui=vp(),Fs(wt);let Ai=Pt===263?h.createClassDeclaration(Xe,Xt,Yn,Hi,Ui):h.createClassExpression(Xe,Xt,Yn,Hi,Ui);return On(cr(Ai,te),De)}function Ho(){return ni()&&!GE()?Wu(ni()):void 0}function GE(){return X()===119&&Vi(pu)}function HE(){if(D())return ua(22,Hy)}function Hy(){let te=B(),De=X();I.assert(De===96||De===119),Le();let Xe=A_(7,xS);return cr(h.createHeritageClause(De,Xe),te)}function xS(){let te=B(),De=vm();if(De.kind===233)return De;let Xe=nb();return cr(h.createExpressionWithTypeArguments(De,Xe),te)}function nb(){return X()===30?Of(20,zl,30,32):void 0}function D(){return X()===96||X()===119}function ue(){return ua(5,WE)}function gt(te,De,Xe){Mr(120);let Pt=Go(),wt=md(),Xt=HE(),Yn=zT(),Hi=h.createInterfaceDeclaration(Xe,Pt,wt,Xt,Yn);return On(cr(Hi,te),De)}function lr(te,De,Xe){Mr(156),t.hasPrecedingLineBreak()&&hr(g.Line_break_not_permitted_here);let Pt=Go(),wt=md();Mr(64);let Xt=X()===141&&ji(Fx)||zl();Tc();let Yn=h.createTypeAliasDeclaration(Xe,Pt,wt,Xt);return On(cr(Yn,te),De)}function Wn(){let te=B(),De=le(),Xe=gr(),Pt=Nr(vg);return On(cr(h.createEnumMember(Xe,Pt),te),De)}function $i(te,De,Xe){Mr(94);let Pt=Go(),wt;Mr(19)?(wt=W(()=>A_(6,Wn)),Mr(20)):wt=vp();let Xt=h.createEnumDeclaration(Xe,Pt,wt);return On(cr(Xt,te),De)}function Di(){let te=B(),De;return Mr(19)?(De=ua(1,Zf),Mr(20)):De=vp(),cr(h.createModuleBlock(De),te)}function fs(te,De,Xe,Pt){let wt=Pt&32,Xt=Pt&8?ru():Go(),Yn=ks(25)?fs(B(),!1,void 0,8|wt):Di(),Hi=h.createModuleDeclaration(Xe,Xt,Yn,Pt);return On(cr(Hi,te),De)}function Aa(te,De,Xe){let Pt=0,wt;X()===162?(wt=Go(),Pt|=2048):(wt=ci(),wt.text=Mu(wt.text));let Xt;X()===19?Xt=Di():Tc();let Yn=h.createModuleDeclaration(Xe,wt,Xt,Pt);return On(cr(Yn,te),De)}function U_(te,De,Xe){let Pt=0;if(X()===162)return Aa(te,De,Xe);if(ks(145))Pt|=32;else if(Mr(144),X()===11)return Aa(te,De,Xe);return fs(te,De,Xe,Pt)}function vf(){return X()===149&&Vi(Vd)}function Vd(){return Le()===21}function CS(){return Le()===19}function Oi(){return Le()===44}function t0(te,De,Xe){Mr(130),Mr(145);let Pt=Go();Tc();let wt=h.createNamespaceExportDeclaration(Pt);return wt.modifiers=Xe,On(cr(wt,te),De)}function Kr(te,De,Xe){Mr(102);let Pt=t.getTokenFullStart(),wt;js()&&(wt=Go());let Xt=!1;if(wt?.escapedText==="type"&&(X()!==161||js()&&Vi(rC))&&(js()||kS())&&(Xt=!0,wt=js()?Go():void 0),wt&&!aC())return YE(te,De,Xe,wt,Xt);let Yn;(wt||X()===42||X()===19)&&(Yn=ph(wt,Pt,Xt),Mr(161));let Hi=oC(),Ui=X(),Ai;(Ui===118||Ui===132)&&!t.hasPrecedingLineBreak()&&(Ai=AS(Ui)),Tc();let cs=h.createImportDeclaration(Xe,Yn,Hi,Ai);return On(cr(cs,te),De)}function eP(){let te=B(),De=$_(X())?ru():Zc(11);Mr(59);let Xe=Yu(!0);return cr(h.createImportAttribute(De,Xe),te)}function AS(te,De){let Xe=B();De||Mr(te);let Pt=t.getTokenStart();if(Mr(19)){let wt=t.hasPrecedingLineBreak(),Xt=A_(24,eP,!0);if(!Mr(20)){let Yn=Is($e);Yn&&Yn.code===g._0_expected.code&&Ga(Yn,wN(Ae,Re,Pt,1,g.The_parser_expected_to_find_a_1_to_match_the_0_token_here,"{","}"))}return cr(h.createImportAttributes(Xt,wt,te),Xe)}else{let wt=$s([],B(),void 0,!1);return cr(h.createImportAttributes(wt,!1,te),Xe)}}function kS(){return X()===42||X()===19}function aC(){return X()===28||X()===161}function YE(te,De,Xe,Pt,wt){Mr(64);let Xt=r0();Tc();let Yn=h.createImportEqualsDeclaration(Xe,wt,Pt,Xt);return On(cr(Yn,te),De)}function ph(te,De,Xe){let Pt;return(!te||ks(28))&&(Pt=X()===42?uz():PS(275)),cr(h.createImportClause(Xe,te,Pt),De)}function r0(){return vf()?pI():ie(!1)}function pI(){let te=B();Mr(149),Mr(21);let De=oC();return Mr(22),cr(h.createExternalModuleReference(De),te)}function oC(){if(X()===11){let te=ci();return te.text=Mu(te.text),te}else return He()}function uz(){let te=B();Mr(42),Mr(130);let De=Go();return cr(h.createNamespaceImport(De),te)}function PS(te){let De=B(),Xe=te===275?h.createNamedImports(Of(23,uL,19,20)):h.createNamedExports(Of(23,lL,19,20));return cr(Xe,De)}function lL(){let te=le();return On(ib(281),te)}function uL(){return ib(276)}function ib(te){let De=B(),Xe=Nf(X())&&!js(),Pt=t.getTokenStart(),wt=t.getTokenEnd(),Xt=!1,Yn,Hi=!0,Ui=ru();if(Ui.escapedText==="type")if(X()===130){let Co=ru();if(X()===130){let zo=ru();$_(X())?(Xt=!0,Yn=Co,Ui=cs(),Hi=!1):(Yn=Ui,Ui=zo,Hi=!1)}else $_(X())?(Yn=Ui,Hi=!1,Ui=cs()):(Xt=!0,Ui=Co)}else $_(X())&&(Xt=!0,Ui=cs());Hi&&X()===130&&(Yn=Ui,Mr(130),Ui=cs()),te===276&&Xe&&Y(Pt,wt,g.Identifier_expected);let Ai=te===276?h.createImportSpecifier(Xt,Yn,Ui):h.createExportSpecifier(Xt,Yn,Ui);return cr(Ai,De);function cs(){return Xe=Nf(X())&&!js(),Pt=t.getTokenStart(),wt=t.getTokenEnd(),ru()}}function Eg(te){return cr(h.createNamespaceExport(ru()),te)}function t4(te,De,Xe){let Pt=Cr();Fs(!0);let wt,Xt,Yn,Hi=ks(156),Ui=B();ks(42)?(ks(130)&&(wt=Eg(Ui)),Mr(161),Xt=oC()):(wt=PS(279),(X()===161||X()===11&&!t.hasPrecedingLineBreak())&&(Mr(161),Xt=oC()));let Ai=X();Xt&&(Ai===118||Ai===132)&&!t.hasPrecedingLineBreak()&&(Yn=AS(Ai)),Tc(),Fs(Pt);let cs=h.createExportDeclaration(Xe,Hi,wt,Xt,Yn);return On(cr(cs,te),De)}function n0(te,De,Xe){let Pt=Cr();Fs(!0);let wt;ks(64)?wt=!0:Mr(90);let Xt=Yu(!0);Tc(),Fs(Pt);let Yn=h.createExportAssignment(Xe,wt,Xt);return On(cr(Yn,te),De)}let tP;(te=>{te[te.SourceElements=0]="SourceElements",te[te.BlockStatements=1]="BlockStatements",te[te.SwitchClauses=2]="SwitchClauses",te[te.SwitchClauseStatements=3]="SwitchClauseStatements",te[te.TypeMembers=4]="TypeMembers",te[te.ClassMembers=5]="ClassMembers",te[te.EnumMembers=6]="EnumMembers",te[te.HeritageClauseElement=7]="HeritageClauseElement",te[te.VariableDeclarations=8]="VariableDeclarations",te[te.ObjectBindingElements=9]="ObjectBindingElements",te[te.ArrayBindingElements=10]="ArrayBindingElements",te[te.ArgumentExpressions=11]="ArgumentExpressions",te[te.ObjectLiteralMembers=12]="ObjectLiteralMembers",te[te.JsxAttributes=13]="JsxAttributes",te[te.JsxChildren=14]="JsxChildren",te[te.ArrayLiteralMembers=15]="ArrayLiteralMembers",te[te.Parameters=16]="Parameters",te[te.JSDocParameters=17]="JSDocParameters",te[te.RestProperties=18]="RestProperties",te[te.TypeParameters=19]="TypeParameters",te[te.TypeArguments=20]="TypeArguments",te[te.TupleElementTypes=21]="TupleElementTypes",te[te.HeritageClauses=22]="HeritageClauses",te[te.ImportOrExportSpecifiers=23]="ImportOrExportSpecifiers",te[te.ImportAttributes=24]="ImportAttributes",te[te.JSDocComment=25]="JSDocComment",te[te.Count=26]="Count"})(tP||(tP={}));let _L;(te=>{te[te.False=0]="False",te[te.True=1]="True",te[te.Unknown=2]="Unknown"})(_L||(_L={}));let dh;(te=>{function De(Ai,cs,Co){zi("file.js",Ai,99,void 0,1,0),t.setText(Ai,cs,Co),St=t.scan();let zo=Xe(),_o=zt("file.js",99,1,!1,[],U(1),0,ja),Jd=RA($e,_o);return at&&(_o.jsDocDiagnostics=RA(at,_o)),Ms(),zo?{jsDocTypeExpression:zo,diagnostics:Jd}:void 0}te.parseJSDocTypeExpressionForTests=De;function Xe(Ai){let cs=B(),Co=(Ai?ks:Mr)(19),zo=to(16777216,Hm);(!Ai||Co)&&Dc(20);let _o=h.createJSDocTypeExpression(zo);return rt(_o),cr(_o,cs)}te.parseJSDocTypeExpression=Xe;function Pt(){let Ai=B(),cs=ks(19),Co=B(),zo=ie(!1);for(;X()===81;)Pi(),It(),zo=cr(h.createJSDocMemberName(zo,Go()),Co);cs&&Dc(20);let _o=h.createJSDocNameReference(zo);return rt(_o),cr(_o,Ai)}te.parseJSDocNameReference=Pt;function wt(Ai,cs,Co){zi("",Ai,99,void 0,1,0);let zo=to(16777216,()=>Ui(cs,Co)),Jd=RA($e,{languageVariant:0,text:Ai});return Ms(),zo?{jsDoc:zo,diagnostics:Jd}:void 0}te.parseIsolatedJSDocComment=wt;function Xt(Ai,cs,Co){let zo=St,_o=$e.length,Jd=nr,mh=to(16777216,()=>Ui(cs,Co));return io(mh,Ai),rn&524288&&(at||(at=[]),jt(at,$e,_o)),St=zo,$e.length=_o,nr=Jd,mh}te.parseJSDocComment=Xt;let Yn;(Ai=>{Ai[Ai.BeginningOfLine=0]="BeginningOfLine",Ai[Ai.SawAsterisk=1]="SawAsterisk",Ai[Ai.SavingComments=2]="SavingComments",Ai[Ai.SavingBackticks=3]="SavingBackticks"})(Yn||(Yn={}));let Hi;(Ai=>{Ai[Ai.Property=1]="Property",Ai[Ai.Parameter=2]="Parameter",Ai[Ai.CallbackParameter=4]="CallbackParameter"})(Hi||(Hi={}));function Ui(Ai=0,cs){let Co=Re,zo=cs===void 0?Co.length:Ai+cs;if(cs=zo-Ai,I.assert(Ai>=0),I.assert(Ai<=zo),I.assert(zo<=Co.length),!oQ(Co,Ai))return;let _o,Jd,mh,Y0,Yy,Xy=[],NS=[],ep=or;or|=1<<25;let cC=t.scanRange(Ai+3,cs-5,dI);return or=ep,cC;function dI(){let Lr=1,Kn,qn=Ai-(Co.lastIndexOf(`
`,Ai)+1)+4;function Yi(Vo){Kn||(Kn=qn),Xy.push(Vo),qn+=Vo.length}for(It();rv(5););rv(4)&&(Lr=0,qn=0);e:for(;;){switch(X()){case 60:n4(Xy),Yy||(Yy=B()),s4(mI(qn)),Lr=0,Kn=void 0;break;case 4:Xy.push(t.getTokenText()),Lr=0,qn=0;break;case 42:let Vo=t.getTokenText();Lr===1?(Lr=2,Yi(Vo)):(I.assert(Lr===0),Lr=1,qn+=Vo.length);break;case 5:I.assert(Lr!==2,"whitespace shouldn't come from the scanner while saving top-level comment text");let V_=t.getTokenText();Kn!==void 0&&qn+V_.length>Kn&&Xy.push(V_.slice(Kn-qn)),qn+=V_.length;break;case 1:break e;case 82:Lr=2,Yi(t.getTokenValue());break;case 19:Lr=2;let i0=t.getTokenFullStart(),xp=t.getTokenEnd()-1,Cg=Il(xp);if(Cg){Y0||r4(Xy),NS.push(cr(h.createJSDocText(Xy.join("")),Y0??Ai,i0)),NS.push(Cg),Xy=[],Y0=t.getTokenEnd();break}default:Lr=2,Yi(t.getTokenText());break}Lr===2?Rt(!1):It()}let Ji=Xy.join("").trimEnd();NS.length&&Ji.length&&NS.push(cr(h.createJSDocText(Ji),Y0??Ai,Yy)),NS.length&&_o&&I.assertIsDefined(Yy,"having parsed tags implies that the end of the comment span should be set");let go=_o&&$s(_o,Jd,mh);return cr(h.createJSDocComment(NS.length?$s(NS,Ai,Yy):Ji.length?Ji:void 0,go),Ai,zo)}function r4(Lr){for(;Lr.length&&(Lr[0]===`
`||Lr[0]==="\r");)Lr.shift()}function n4(Lr){for(;Lr.length;){let Kn=Lr[Lr.length-1].trimEnd();if(Kn==="")Lr.pop();else if(Kn.length<Lr[Lr.length-1].length){Lr[Lr.length-1]=Kn;break}else break}}function sb(){for(;;){if(It(),X()===1)return!0;if(!(X()===5||X()===4))return!1}}function Ky(){if(!((X()===5||X()===4)&&Vi(sb)))for(;X()===5||X()===4;)It()}function DS(){if((X()===5||X()===4)&&Vi(sb))return"";let Lr=t.hasPrecedingLineBreak(),Kn=!1,qn="";for(;Lr&&X()===42||X()===5||X()===4;)qn+=t.getTokenText(),X()===4?(Lr=!0,Kn=!0,qn=""):X()===42&&(Lr=!1),It();return Kn?qn:""}function mI(Lr){I.assert(X()===60);let Kn=t.getTokenStart();It();let qn=lb(void 0),Yi=DS(),Ji;switch(qn.escapedText){case"author":Ji=oc(Kn,qn,Lr,Yi);break;case"implements":Ji=wS(Kn,qn,Lr,Yi);break;case"augments":case"extends":Ji=eg(Kn,qn,Lr,Yi);break;case"class":case"constructor":Ji=cb(Kn,h.createJSDocClassTag,qn,Lr,Yi);break;case"public":Ji=cb(Kn,h.createJSDocPublicTag,qn,Lr,Yi);break;case"private":Ji=cb(Kn,h.createJSDocPrivateTag,qn,Lr,Yi);break;case"protected":Ji=cb(Kn,h.createJSDocProtectedTag,qn,Lr,Yi);break;case"readonly":Ji=cb(Kn,h.createJSDocReadonlyTag,qn,Lr,Yi);break;case"override":Ji=cb(Kn,h.createJSDocOverrideTag,qn,Lr,Yi);break;case"deprecated":ri=!0,Ji=cb(Kn,h.createJSDocDeprecatedTag,qn,Lr,Yi);break;case"this":Ji=_z(Kn,qn,Lr,Yi);break;case"enum":Ji=Jse(Kn,qn,Lr,Yi);break;case"arg":case"argument":case"param":return q(Kn,qn,2,Lr);case"return":case"returns":Ji=Qe(Kn,qn,Lr,Yi);break;case"template":Ji=RS(Kn,qn,Lr,Yi);break;case"type":Ji=Qt(Kn,qn,Lr,Yi);break;case"typedef":Ji=a4(Kn,qn,Lr,Yi);break;case"callback":Ji=exe(Kn,qn,Lr,Yi);break;case"overload":Ji=txe(Kn,qn,Lr,Yi);break;case"satisfies":Ji=ob(Kn,qn,Lr,Yi);break;case"see":Ji=kn(Kn,qn,Lr,Yi);break;case"exception":case"throws":Ji=ps(Kn,qn,Lr,Yi);break;default:Ji=IS(Kn,qn,Lr,Yi);break}return Ji}function Gp(Lr,Kn,qn,Yi){return Yi||(qn+=Kn-Lr),ro(qn,Yi.slice(qn))}function ro(Lr,Kn){let qn=B(),Yi=[],Ji=[],go,Vo=0,V_;function i0(Qy){V_||(V_=Lr),Yi.push(Qy),Lr+=Qy.length}Kn!==void 0&&(Kn!==""&&i0(Kn),Vo=1);let xp=X();e:for(;;){switch(xp){case 4:Vo=0,Yi.push(t.getTokenText()),Lr=0;break;case 60:t.resetTokenState(t.getTokenEnd()-1);break e;case 1:break e;case 5:I.assert(Vo!==2&&Vo!==3,"whitespace shouldn't come from the scanner while saving comment text");let Qy=t.getTokenText();V_!==void 0&&Lr+Qy.length>V_&&(Yi.push(Qy.slice(V_-Lr)),Vo=2),Lr+=Qy.length;break;case 19:Vo=2;let Cp=t.getTokenFullStart(),yI=t.getTokenEnd()-1,fL=Il(yI);fL?(Ji.push(cr(h.createJSDocText(Yi.join("")),go??qn,Cp)),Ji.push(fL),Yi=[],go=t.getTokenEnd()):i0(t.getTokenText());break;case 62:Vo===3?Vo=2:Vo=3,i0(t.getTokenText());break;case 82:Vo!==3&&(Vo=2),i0(t.getTokenValue());break;case 42:if(Vo===0){Vo=1,Lr+=1;break}default:Vo!==3&&(Vo=2),i0(t.getTokenText());break}Vo===2||Vo===3?xp=Rt(Vo===3):xp=It()}r4(Yi);let Cg=Yi.join("").trimEnd();if(Ji.length)return Cg.length&&Ji.push(cr(h.createJSDocText(Cg),go??qn)),$s(Ji,qn,t.getTokenEnd());if(Cg.length)return Cg}function Il(Lr){let Kn=ji(rP);if(!Kn)return;It(),Ky();let qn=ab(),Yi=[];for(;X()!==20&&X()!==4&&X()!==1;)Yi.push(t.getTokenText()),It();let Ji=Kn==="link"?h.createJSDocLink:Kn==="linkcode"?h.createJSDocLinkCode:h.createJSDocLinkPlain;return cr(Ji(qn,Yi.join("")),Lr,t.getTokenEnd())}function ab(){if($_(X())){let Lr=B(),Kn=ru();for(;ks(25);)Kn=cr(h.createQualifiedName(Kn,X()===81?ic(80,!1):Go()),Lr);for(;X()===81;)Pi(),It(),Kn=cr(h.createJSDocMemberName(Kn,Go()),Lr);return Kn}}function rP(){if(DS(),X()===19&&It()===60&&$_(It())){let Lr=t.getTokenValue();if(i4(Lr))return Lr}}function i4(Lr){return Lr==="link"||Lr==="linkcode"||Lr==="linkplain"}function IS(Lr,Kn,qn,Yi){return cr(h.createJSDocUnknownTag(Kn,Gp(Lr,B(),qn,Yi)),Lr)}function s4(Lr){Lr&&(_o?_o.push(Lr):(_o=[Lr],Jd=Lr.pos),mh=Lr.end)}function pn(){return DS(),X()===19?Xe():void 0}function E(){let Lr=rv(23);Lr&&Ky();let Kn=rv(62),qn=hI();return Kn&&$a(62),Lr&&(Ky(),ya(64)&&He(),Mr(24)),{name:qn,isBracketed:Lr}}function R(Lr){switch(Lr.kind){case 151:return!0;case 188:return R(Lr.elementType);default:return Id(Lr)&&ze(Lr.typeName)&&Lr.typeName.escapedText==="Object"&&!Lr.typeArguments}}function q(Lr,Kn,qn,Yi){let Ji=pn(),go=!Ji;DS();let{name:Vo,isBracketed:V_}=E(),i0=DS();go&&!Vi(rP)&&(Ji=pn());let xp=Gp(Lr,B(),Yi,i0),Cg=fe(Ji,Vo,qn,Yi);Cg&&(Ji=Cg,go=!0);let Qy=qn===1?h.createJSDocPropertyTag(Kn,Vo,V_,Ji,go,xp):h.createJSDocParameterTag(Kn,Vo,V_,Ji,go,xp);return cr(Qy,Lr)}function fe(Lr,Kn,qn,Yi){if(Lr&&R(Lr.type)){let Ji=B(),go,Vo;for(;go=ji(()=>pz(qn,Yi,Kn));)go.kind===348||go.kind===355?Vo=Pr(Vo,go):go.kind===352&&Be(go.tagName,g.A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag);if(Vo){let V_=cr(h.createJSDocTypeLiteral(Vo,Lr.type.kind===188),Ji);return cr(h.createJSDocTypeExpression(V_),Ji)}}}function Qe(Lr,Kn,qn,Yi){Tt(_o,_U)&&Y(Kn.pos,t.getTokenStart(),g._0_tag_already_specified,Zi(Kn.escapedText));let Ji=pn();return cr(h.createJSDocReturnTag(Kn,Ji,Gp(Lr,B(),qn,Yi)),Lr)}function Qt(Lr,Kn,qn,Yi){Tt(_o,$6)&&Y(Kn.pos,t.getTokenStart(),g._0_tag_already_specified,Zi(Kn.escapedText));let Ji=Xe(!0),go=qn!==void 0&&Yi!==void 0?Gp(Lr,B(),qn,Yi):void 0;return cr(h.createJSDocTypeTag(Kn,Ji,go),Lr)}function kn(Lr,Kn,qn,Yi){let go=X()===23||Vi(()=>It()===60&&$_(It())&&i4(t.getTokenValue()))?void 0:Pt(),Vo=qn!==void 0&&Yi!==void 0?Gp(Lr,B(),qn,Yi):void 0;return cr(h.createJSDocSeeTag(Kn,go,Vo),Lr)}function ps(Lr,Kn,qn,Yi){let Ji=pn(),go=Gp(Lr,B(),qn,Yi);return cr(h.createJSDocThrowsTag(Kn,Ji,go),Lr)}function oc(Lr,Kn,qn,Yi){let Ji=B(),go=xg(),Vo=t.getTokenFullStart(),V_=Gp(Lr,Vo,qn,Yi);V_||(Vo=t.getTokenFullStart());let i0=typeof V_!="string"?$s(ys([cr(go,Ji,Vo)],V_),Ji):go.text+V_;return cr(h.createJSDocAuthorTag(Kn,i0),Lr)}function xg(){let Lr=[],Kn=!1,qn=t.getToken();for(;qn!==1&&qn!==4;){if(qn===30)Kn=!0;else{if(qn===60&&!Kn)break;if(qn===32&&Kn){Lr.push(t.getTokenText()),t.resetTokenState(t.getTokenEnd());break}}Lr.push(t.getTokenText()),qn=It()}return h.createJSDocText(Lr.join(""))}function wS(Lr,Kn,qn,Yi){let Ji=Vse();return cr(h.createJSDocImplementsTag(Kn,Ji,Gp(Lr,B(),qn,Yi)),Lr)}function eg(Lr,Kn,qn,Yi){let Ji=Vse();return cr(h.createJSDocAugmentsTag(Kn,Ji,Gp(Lr,B(),qn,Yi)),Lr)}function ob(Lr,Kn,qn,Yi){let Ji=Xe(!1),go=qn!==void 0&&Yi!==void 0?Gp(Lr,B(),qn,Yi):void 0;return cr(h.createJSDocSatisfiesTag(Kn,Ji,go),Lr)}function Vse(){let Lr=ks(19),Kn=B(),qn=Z2e();t.setInJSDocType(!0);let Yi=nb();t.setInJSDocType(!1);let Ji=h.createExpressionWithTypeArguments(qn,Yi),go=cr(Ji,Kn);return Lr&&Mr(20),go}function Z2e(){let Lr=B(),Kn=lb();for(;ks(25);){let qn=lb();Kn=cr(re(Kn,qn),Lr)}return Kn}function cb(Lr,Kn,qn,Yi,Ji){return cr(Kn(qn,Gp(Lr,B(),Yi,Ji)),Lr)}function _z(Lr,Kn,qn,Yi){let Ji=Xe(!0);return Ky(),cr(h.createJSDocThisTag(Kn,Ji,Gp(Lr,B(),qn,Yi)),Lr)}function Jse(Lr,Kn,qn,Yi){let Ji=Xe(!0);return Ky(),cr(h.createJSDocEnumTag(Kn,Ji,Gp(Lr,B(),qn,Yi)),Lr)}function a4(Lr,Kn,qn,Yi){let Ji=pn();DS();let go=fz();Ky();let Vo=ro(qn),V_;if(!Ji||R(Ji.type)){let xp,Cg,Qy,Cp=!1;for(;(xp=ji(()=>$se(qn)))&&xp.kind!==352;)if(Cp=!0,xp.kind===351)if(Cg){let yI=hr(g.A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags);yI&&Ga(yI,wN(Ae,Re,0,0,g.The_tag_was_first_specified_here));break}else Cg=xp;else Qy=Pr(Qy,xp);if(Cp){let yI=Ji&&Ji.type.kind===188,fL=h.createJSDocTypeLiteral(Qy,yI);Ji=Cg&&Cg.typeExpression&&!R(Cg.typeExpression.type)?Cg.typeExpression:cr(fL,Lr),V_=Ji.end}}V_=V_||Vo!==void 0?B():(go??Ji??Kn).end,Vo||(Vo=Gp(Lr,V_,qn,Yi));let i0=h.createJSDocTypedefTag(Kn,Ji,go,Vo);return cr(i0,Lr,V_)}function fz(Lr){let Kn=t.getTokenStart();if(!$_(X()))return;let qn=lb();if(ks(25)){let Yi=fz(!0),Ji=h.createModuleDeclaration(void 0,qn,Yi,Lr?8:void 0);return cr(Ji,Kn)}return Lr&&(qn.flags|=4096),qn}function qse(Lr){let Kn=B(),qn,Yi;for(;qn=ji(()=>pz(4,Lr));){if(qn.kind===352){Be(qn.tagName,g.A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag);break}Yi=Pr(Yi,qn)}return $s(Yi||[],Kn)}function zse(Lr,Kn){let qn=qse(Kn),Yi=ji(()=>{if(rv(60)){let Ji=mI(Kn);if(Ji&&Ji.kind===349)return Ji}});return cr(h.createJSDocSignature(void 0,qn,Yi),Lr)}function exe(Lr,Kn,qn,Yi){let Ji=fz();Ky();let go=ro(qn),Vo=zse(Lr,qn);go||(go=Gp(Lr,B(),qn,Yi));let V_=go!==void 0?B():Vo.end;return cr(h.createJSDocCallbackTag(Kn,Vo,Ji,go),Lr,V_)}function txe(Lr,Kn,qn,Yi){Ky();let Ji=ro(qn),go=zse(Lr,qn);Ji||(Ji=Gp(Lr,B(),qn,Yi));let Vo=Ji!==void 0?B():go.end;return cr(h.createJSDocOverloadTag(Kn,go,Ji),Lr,Vo)}function gI(Lr,Kn){for(;!ze(Lr)||!ze(Kn);)if(!ze(Lr)&&!ze(Kn)&&Lr.right.escapedText===Kn.right.escapedText)Lr=Lr.left,Kn=Kn.left;else return!1;return Lr.escapedText===Kn.escapedText}function $se(Lr){return pz(1,Lr)}function pz(Lr,Kn,qn){let Yi=!0,Ji=!1;for(;;)switch(It()){case 60:if(Yi){let go=XE(Lr,Kn);return go&&(go.kind===348||go.kind===355)&&qn&&(ze(go.name)||!gI(qn,go.name.left))?!1:go}Ji=!1;break;case 4:Yi=!0,Ji=!1;break;case 42:Ji&&(Yi=!1),Ji=!0;break;case 80:Yi=!1;break;case 1:return!1}}function XE(Lr,Kn){I.assert(X()===60);let qn=t.getTokenFullStart();It();let Yi=lb(),Ji=DS(),go;switch(Yi.escapedText){case"type":return Lr===1&&Qt(qn,Yi);case"prop":case"property":go=1;break;case"arg":case"argument":case"param":go=6;break;case"template":return RS(qn,Yi,Kn,Ji);case"this":return _z(qn,Yi,Kn,Ji);default:return!1}return Lr&go?q(qn,Yi,Lr,Kn):!1}function vn(){let Lr=B(),Kn=rv(23);Kn&&Ky();let qn=e0(!1,!0),Yi=lb(g.Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces),Ji;if(Kn&&(Ky(),Mr(64),Ji=to(16777216,Hm),Mr(24)),!sl(Yi))return cr(h.createTypeParameterDeclaration(qn,Yi,void 0,Ji),Lr)}function OS(){let Lr=B(),Kn=[];do{Ky();let qn=vn();qn!==void 0&&Kn.push(qn),DS()}while(rv(28));return $s(Kn,Lr)}function RS(Lr,Kn,qn,Yi){let Ji=X()===19?Xe():void 0,go=OS();return cr(h.createJSDocTemplateTag(Kn,Ji,go,Gp(Lr,B(),qn,Yi)),Lr)}function rv(Lr){return X()===Lr?(It(),!0):!1}function hI(){let Lr=lb();for(ks(23)&&Mr(24);ks(25);){let Kn=lb();ks(23)&&Mr(24),Lr=ct(Lr,Kn)}return Lr}function lb(Lr){if(!$_(X()))return ic(80,!Lr,Lr||g.Identifier_expected);ar++;let Kn=t.getTokenStart(),qn=t.getTokenEnd(),Yi=X(),Ji=Mu(t.getTokenValue()),go=cr(M(Ji,Yi),Kn,qn);return It(),go}}})(dh=e.JSDocParser||(e.JSDocParser={}))})(IT||(IT={})),(e=>{function t(k,N,M,O){if(O=O||I.shouldAssert(2),h(k,N,M,O),tpe(M))return k;if(k.statements.length===0)return IT.parseSourceFile(k.fileName,N,k.languageVersion,void 0,!0,k.scriptKind,k.setExternalModuleIndicator,k.jsDocParsingMode);let U=k;I.assert(!U.hasBeenIncrementallyParsed),U.hasBeenIncrementallyParsed=!0,IT.fixupParentReferences(U);let H=k.text,K=b(k),re=m(k,M);h(k,N,re,O),I.assert(re.span.start<=M.span.start),I.assert(gl(re.span)===gl(M.span)),I.assert(gl(kw(re))===gl(kw(M)));let $=kw(re).length-re.span.length;p(U,re.span.start,gl(re.span),gl(kw(re)),$,H,N,O);let pe=IT.parseSourceFile(k.fileName,N,k.languageVersion,K,!0,k.scriptKind,k.setExternalModuleIndicator,k.jsDocParsingMode);return pe.commentDirectives=n(k.commentDirectives,pe.commentDirectives,re.span.start,gl(re.span),$,H,N,O),pe.impliedNodeFormat=k.impliedNodeFormat,pe}e.updateSourceFile=t;function n(k,N,M,O,U,H,K,re){if(!k)return N;let $,pe=!1;for(let se of k){let{range:Se,type:xe}=se;if(Se.end<M)$=Pr($,se);else if(Se.pos>O){z();let Z={range:{pos:Se.pos+U,end:Se.end+U},type:xe};$=Pr($,Z),re&&I.assert(H.substring(Se.pos,Se.end)===K.substring(Z.range.pos,Z.range.end))}}return z(),$;function z(){pe||(pe=!0,$?N&&$.push(...N):$=N)}}function i(k,N,M,O,U,H){N?re(k):K(k);return;function K($){let pe="";if(H&&s($)&&(pe=O.substring($.pos,$.end)),$._children&&($._children=void 0),jh($,$.pos+M,$.end+M),H&&s($)&&I.assert(pe===U.substring($.pos,$.end)),Qs($,K,re),jp($))for(let z of $.jsDoc)K(z);l($,H)}function re($){$._children=void 0,jh($,$.pos+M,$.end+M);for(let pe of $)K(pe)}}function s(k){switch(k.kind){case 11:case 9:case 80:return!0}return!1}function o(k,N,M,O,U){I.assert(k.end>=N,"Adjusting an element that was entirely before the change range"),I.assert(k.pos<=M,"Adjusting an element that was entirely after the change range"),I.assert(k.pos<=k.end);let H=Math.min(k.pos,O),K=k.end>=M?k.end+U:Math.min(k.end,O);I.assert(H<=K),k.parent&&(I.assertGreaterThanOrEqual(H,k.parent.pos),I.assertLessThanOrEqual(K,k.parent.end)),jh(k,H,K)}function l(k,N){if(N){let M=k.pos,O=U=>{I.assert(U.pos>=M),M=U.end};if(jp(k))for(let U of k.jsDoc)O(U);Qs(k,O),I.assert(M<=k.end)}}function p(k,N,M,O,U,H,K,re){$(k);return;function $(z){if(I.assert(z.pos<=z.end),z.pos>M){i(z,!1,U,H,K,re);return}let se=z.end;if(se>=N){if(z.intersectsChange=!0,z._children=void 0,o(z,N,M,O,U),Qs(z,$,pe),jp(z))for(let Se of z.jsDoc)$(Se);l(z,re);return}I.assert(se<N)}function pe(z){if(I.assert(z.pos<=z.end),z.pos>M){i(z,!0,U,H,K,re);return}let se=z.end;if(se>=N){z.intersectsChange=!0,z._children=void 0,o(z,N,M,O,U);for(let Se of z)$(Se);return}I.assert(se<N)}}function m(k,N){let O=N.span.start;for(let K=0;O>0&&K<=1;K++){let re=S(k,O);I.assert(re.pos<=O);let $=re.pos;O=Math.max(0,$-1)}let U=Ll(O,gl(N.span)),H=N.newLength+(N.span.start-O);return Y3(U,H)}function S(k,N){let M=k,O;if(Qs(k,H),O){let K=U(O);K.pos>M.pos&&(M=K)}return M;function U(K){for(;;){let re=OX(K);if(re)K=re;else return K}}function H(K){if(!sl(K))if(K.pos<=N){if(K.pos>=M.pos&&(M=K),N<K.end)return Qs(K,H),!0;I.assert(K.end<=N),O=K}else return I.assert(K.pos>N),!0}}function h(k,N,M,O){let U=k.text;if(M&&(I.assert(U.length-M.span.length+M.newLength===N.length),O||I.shouldAssert(3))){let H=U.substr(0,M.span.start),K=N.substr(0,M.span.start);I.assert(H===K);let re=U.substring(gl(M.span),U.length),$=N.substring(gl(kw(M)),N.length);I.assert(re===$)}}function b(k){let N=k.statements,M=0;I.assert(M<N.length);let O=N[M],U=-1;return{currentNode(K){return K!==U&&(O&&O.end===K&&M<N.length-1&&(M++,O=N[M]),(!O||O.pos!==K)&&H(K)),U=K,I.assert(!O||O.pos===K),O}};function H(K){N=void 0,M=-1,O=void 0,Qs(k,re,$);return;function re(pe){return K>=pe.pos&&K<pe.end?(Qs(pe,re,$),!0):!1}function $(pe){if(K>=pe.pos&&K<pe.end)for(let z=0;z<pe.length;z++){let se=pe[z];if(se){if(se.pos===K)return N=pe,M=z,O=se,!0;if(se.pos<K&&K<se.end)return Qs(se,re,$),!0}}return!1}}}e.createSyntaxCursor=b;let A;(k=>{k[k.Value=-1]="Value"})(A||(A={}))})(pQ||(pQ={})),dQ=new Map,x8e=/^\/\/\/\s*<(\S+)\s.*?\/>/im,C8e=/^\/\/\/?\s*@([^\s:]+)(.*)\s*$/im}});function EU(e){let t=new Map,n=new Map;return Te(e,i=>{t.set(i.name.toLowerCase(),i),i.shortName&&n.set(i.shortName,i.name)}),{optionsNameMap:t,shortOptionNames:n}}function rD(){return lRe||(lRe=EU(F0))}function che(e){return A8e(e,fl)}function A8e(e,t){let n=In(e.type.keys()),i=(e.deprecatedKeys?n.filter(s=>!e.deprecatedKeys.has(s)):n).map(s=>`'${s}'`).join(", ");return t(g.Argument_for_0_option_must_be_Colon_1,`--${e.name}`,i)}function xU(e,t,n){return iRe(e,(t??"").trim(),n)}function lhe(e,t="",n){if(t=t.trim(),Ss(t,"-"))return;if(e.type==="listOrElement"&&!t.includes(","))return ck(e,t,n);if(t==="")return[];let i=t.split(",");switch(e.element.type){case"number":return Wi(i,s=>ck(e.element,parseInt(s),n));case"string":return Wi(i,s=>ck(e.element,s||"",n));case"boolean":case"object":return I.fail(`List of ${e.element.type} is not yet supported.`);default:return Wi(i,s=>xU(e.element,s,n))}}function k8e(e){return e.name}function uhe(e,t,n,i,s){var o;if((o=t.alternateMode)!=null&&o.getOptionsNameMap().optionsNameMap.has(e.toLowerCase()))return wT(s,i,t.alternateMode.diagnostic,e);let l=FP(e,t.optionDeclarations,k8e);return l?wT(s,i,t.unknownDidYouMeanDiagnostic,n||e,l.name):wT(s,i,t.unknownOptionDiagnostic,n||e)}function mQ(e,t,n){let i={},s,o=[],l=[];return p(t),{options:i,watchOptions:s,fileNames:o,errors:l};function p(S){let h=0;for(;h<S.length;){let b=S[h];if(h++,b.charCodeAt(0)===64)m(b.slice(1));else if(b.charCodeAt(0)===45){let A=b.slice(b.charCodeAt(1)===45?2:1),k=_he(e.getOptionsNameMap,A,!0);if(k)h=P8e(S,h,e,k,i,l);else{let N=_he(RU.getOptionsNameMap,A,!0);N?h=P8e(S,h,RU,N,s||(s={}),l):l.push(uhe(A,e,b))}}else o.push(b)}}function m(S){let h=X6(S,n||(k=>Zu.readFile(k)));if(!vs(h)){l.push(h);return}let b=[],A=0;for(;;){for(;A<h.length&&h.charCodeAt(A)<=32;)A++;if(A>=h.length)break;let k=A;if(h.charCodeAt(k)===34){for(A++;A<h.length&&h.charCodeAt(A)!==34;)A++;A<h.length?(b.push(h.substring(k+1,A)),A++):l.push(fl(g.Unterminated_quoted_string_in_response_file_0,S))}else{for(;h.charCodeAt(A)>32;)A++;b.push(h.substring(k,A))}}p(b)}}function P8e(e,t,n,i,s,o){if(i.isTSConfigOnly){let l=e[t];l==="null"?(s[i.name]=void 0,t++):i.type==="boolean"?l==="false"?(s[i.name]=ck(i,!1,o),t++):(l==="true"&&t++,o.push(fl(g.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line,i.name))):(o.push(fl(g.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line,i.name)),l&&!Ss(l,"-")&&t++)}else if(!e[t]&&i.type!=="boolean"&&o.push(fl(n.optionTypeMismatchDiagnostic,i.name,vQ(i))),e[t]!=="null")switch(i.type){case"number":s[i.name]=ck(i,parseInt(e[t]),o),t++;break;case"boolean":let l=e[t];s[i.name]=ck(i,l!=="false",o),(l==="false"||l==="true")&&t++;break;case"string":s[i.name]=ck(i,e[t]||"",o),t++;break;case"list":let p=lhe(i,e[t],o);s[i.name]=p||[],p&&t++;break;case"listOrElement":I.fail("listOrElement not supported here");break;default:s[i.name]=xU(i,e[t],o),t++;break}else s[i.name]=void 0,t++;return t}function N8e(e,t){return mQ(lM,e,t)}function gQ(e,t){return _he(rD,e,t)}function _he(e,t,n=!1){t=t.toLowerCase();let{optionsNameMap:i,shortOptionNames:s}=e();if(n){let o=s.get(t);o!==void 0&&(t=o)}return i.get(t)}function D8e(){return _Re||(_Re=EU(wU))}function I8e(e){let{options:t,watchOptions:n,fileNames:i,errors:s}=mQ(pRe,e),o=t;return i.length===0&&i.push("."),o.clean&&o.force&&s.push(fl(g.Options_0_and_1_cannot_be_combined,"clean","force")),o.clean&&o.verbose&&s.push(fl(g.Options_0_and_1_cannot_be_combined,"clean","verbose")),o.clean&&o.watch&&s.push(fl(g.Options_0_and_1_cannot_be_combined,"clean","watch")),o.watch&&o.dry&&s.push(fl(g.Options_0_and_1_cannot_be_combined,"watch","dry")),{buildOptions:o,watchOptions:n,projects:i,errors:s}}function w8e(e,...t){return ta(fl(e,...t).messageText,vs)}function ZR(e,t,n,i,s,o){let l=X6(e,S=>n.readFile(S));if(!vs(l)){n.onUnRecoverableConfigFileDiagnostic(l);return}let p=QR(e,l),m=n.getCurrentDirectory();return p.path=gc(e,m,y_(n.useCaseSensitiveFileNames)),p.resolvedPath=p.path,p.originalFileName=p.fileName,rM(p,n,Ps(hi(e),m),t,Ps(e,m),void 0,o,i,s)}function eM(e,t){let n=X6(e,t);return vs(n)?hQ(e,n):{config:{},error:n}}function hQ(e,t){let n=QR(e,t);return{config:F8e(n,n.parseDiagnostics,void 0),error:n.parseDiagnostics.length?n.parseDiagnostics[0]:void 0}}function fhe(e,t){let n=X6(e,t);return vs(n)?QR(e,n):{fileName:e,parseDiagnostics:[n]}}function X6(e,t){let n;try{n=t(e)}catch(i){return fl(g.Cannot_read_file_0_Colon_1,e,i.message)}return n===void 0?fl(g.Cannot_read_file_0,e):n}function yQ(e){return il(e,k8e)}function O8e(){return dRe||(dRe=EU(nD))}function R8e(){return mRe||(mRe=yQ(F0))}function M8e(){return gRe||(gRe=yQ(nD))}function L8e(){return hRe||(hRe=yQ(cM))}function j1t(){return khe===void 0&&(khe={name:void 0,type:"object",elementOptions:yQ([xhe,Che,Ahe,uM,{name:"references",type:"list",element:{name:"references",type:"object"},category:g.Projects},{name:"files",type:"list",element:{name:"files",type:"string"},category:g.File_Management},{name:"include",type:"list",element:{name:"include",type:"string"},category:g.File_Management,defaultValueDescription:g.if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk},{name:"exclude",type:"list",element:{name:"exclude",type:"string"},category:g.File_Management,defaultValueDescription:g.node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified},iM])}),khe}function F8e(e,t,n){var i;let s=(i=e.statements[0])==null?void 0:i.expression;if(s&&s.kind!==210){if(t.push(im(e,s,g.The_root_value_of_a_0_file_must_be_an_object,Cl(e.fileName)==="jsconfig.json"?"jsconfig.json":"tsconfig.json")),Z_(s)){let o=mr(s.elements,Ha);if(o)return tM(e,o,t,!0,n)}return{}}return tM(e,s,t,!0,n)}function phe(e,t){var n;return tM(e,(n=e.statements[0])==null?void 0:n.expression,t,!0,void 0)}function tM(e,t,n,i,s){if(!t)return i?{}:void 0;return p(t,s?.rootOptions);function o(S,h){var b;let A=i?{}:void 0;for(let k of S.properties){if(k.kind!==303){n.push(im(e,k,g.Property_assignment_expected));continue}k.questionToken&&n.push(im(e,k.questionToken,g.The_0_modifier_can_only_be_used_in_TypeScript_files,"?")),m(k.name)||n.push(im(e,k.name,g.String_literal_with_double_quotes_expected));let N=h8(k.name)?void 0:iN(k.name),M=N&&Zi(N),O=M?(b=h?.elementOptions)==null?void 0:b.get(M):void 0,U=p(k.initializer,O);typeof M<"u"&&(i&&(A[M]=U),s?.onPropertySet(M,U,k,h,O))}return A}function l(S,h){if(!i){S.forEach(b=>p(b,h));return}return Fn(S.map(b=>p(b,h)),b=>b!==void 0)}function p(S,h){switch(S.kind){case 112:return!0;case 97:return!1;case 106:return null;case 11:return m(S)||n.push(im(e,S,g.String_literal_with_double_quotes_expected)),S.text;case 9:return Number(S.text);case 224:if(S.operator!==41||S.operand.kind!==9)break;return-Number(S.operand.text);case 210:return o(S,h);case 209:return l(S.elements,h&&h.element)}h?n.push(im(e,S,g.Compiler_option_0_requires_a_value_of_type_1,h.name,vQ(h))):n.push(im(e,S,g.Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal))}function m(S){return za(S)&&pj(S,e)}}function vQ(e){return e.type==="listOrElement"?`${vQ(e.element)} or Array`:e.type==="list"?"Array":vs(e.type)?e.type:"string"}function j8e(e,t){if(e){if(nM(t))return!e.disallowNullOrUndefined;if(e.type==="list")return os(t);if(e.type==="listOrElement")return os(t)||j8e(e.element,t);let n=vs(e.type)?e.type:"string";return typeof t===n}return!1}function B8e(e,t,n){var i,s,o;let l=y_(n.useCaseSensitiveFileNames),p=vr(Fn(e.fileNames,(s=(i=e.options.configFile)==null?void 0:i.configFileSpecs)!=null&&s.validatedIncludeSpecs?U1t(t,e.options.configFile.configFileSpecs.validatedIncludeSpecs,e.options.configFile.configFileSpecs.validatedExcludeSpecs,n):em),N=>j3(Ps(t,n.getCurrentDirectory()),Ps(N,n.getCurrentDirectory()),l)),m={configFilePath:Ps(t,n.getCurrentDirectory()),useCaseSensitiveFileNames:n.useCaseSensitiveFileNames},S=AU(e.options,m),h=e.watchOptions&&V1t(e.watchOptions),b={compilerOptions:{...CU(S),showConfig:void 0,configFile:void 0,configFilePath:void 0,help:void 0,init:void 0,listFiles:void 0,listEmittedFiles:void 0,project:void 0,build:void 0,version:void 0},watchOptions:h&&CU(h),references:vr(e.projectReferences,N=>({...N,path:N.originalPath?N.originalPath:"",originalPath:void 0})),files:de(p)?p:void 0,...(o=e.options.configFile)!=null&&o.configFileSpecs?{include:B1t(e.options.configFile.configFileSpecs.validatedIncludeSpecs),exclude:e.options.configFile.configFileSpecs.validatedExcludeSpecs}:{},compileOnSave:e.compileOnSave?!0:void 0},A=new Set(S.keys()),k={};for(let N in Bl)if(!A.has(N)&&Tt(Bl[N].dependencies,M=>A.has(M))){let M=Bl[N].computeValue(e.options),O=Bl[N].computeValue({});M!==O&&(k[N]=Bl[N].computeValue(e.options))}return ec(b.compilerOptions,CU(AU(k,m))),b}function CU(e){return{...In(e.entries()).reduce((t,n)=>({...t,[n[0]]:n[1]}),{})}}function B1t(e){if(de(e)){if(de(e)!==1)return e;if(e[0]!==MU)return e}}function U1t(e,t,n,i){if(!t)return em;let s=Qj(e,n,t,i.useCaseSensitiveFileNames,i.getCurrentDirectory()),o=s.excludePattern&&$v(s.excludePattern,i.useCaseSensitiveFileNames),l=s.includeFilePattern&&$v(s.includeFilePattern,i.useCaseSensitiveFileNames);return l?o?p=>!(l.test(p)&&!o.test(p)):p=>!l.test(p):o?p=>o.test(p):em}function U8e(e){switch(e.type){case"string":case"number":case"boolean":case"object":return;case"list":case"listOrElement":return U8e(e.element);default:return e.type}}function SQ(e,t){return yu(t,(n,i)=>{if(n===e)return i})}function AU(e,t){return V8e(e,rD(),t)}function V1t(e){return V8e(e,O8e())}function V8e(e,{optionsNameMap:t},n){let i=new Map,s=n&&y_(n.useCaseSensitiveFileNames);for(let o in e)if(wo(e,o)){if(t.has(o)&&(t.get(o).category===g.Command_line_Options||t.get(o).category===g.Output_Formatting))continue;let l=e[o],p=t.get(o.toLowerCase());if(p){I.assert(p.type!=="listOrElement");let m=U8e(p);m?p.type==="list"?i.set(o,l.map(S=>SQ(S,m))):i.set(o,SQ(l,m)):n&&p.isFilePath?i.set(o,j3(n.configFilePath,Ps(l,hi(n.configFilePath)),s)):i.set(o,l)}}return i}function J8e(e,t){let n=q8e(e);return s();function i(o){return Array(o+1).join(" ")}function s(){let o=[],l=i(2);return CQ.forEach(p=>{if(!n.has(p.name))return;let m=n.get(p.name),S=She(p);m!==S?o.push(`${l}${p.name}: ${m}`):wo(OU,p.name)&&o.push(`${l}${p.name}: ${S}`)}),o.join(t)+t}}function q8e(e){let t=Ml(e,OU);return AU(t)}function z8e(e,t,n){let i=q8e(e);return l();function s(p){return Array(p+1).join(" ")}function o({category:p,name:m,isCommandLineOnly:S}){let h=[g.Command_line_Options,g.Editor_Support,g.Compiler_Diagnostics,g.Backwards_Compatibility,g.Watch_and_Build_Modes,g.Output_Formatting];return!S&&p!==void 0&&(!h.includes(p)||i.has(m))}function l(){let p=new Map;p.set(g.Projects,[]),p.set(g.Language_and_Environment,[]),p.set(g.Modules,[]),p.set(g.JavaScript_Support,[]),p.set(g.Emit,[]),p.set(g.Interop_Constraints,[]),p.set(g.Type_Checking,[]),p.set(g.Completeness,[]);for(let k of F0)if(o(k)){let N=p.get(k.category);N||p.set(k.category,N=[]),N.push(k)}let m=0,S=0,h=[];p.forEach((k,N)=>{h.length!==0&&h.push({value:""}),h.push({value:`/* ${Gs(N)} */`});for(let M of k){let O;i.has(M.name)?O=`"${M.name}": ${JSON.stringify(i.get(M.name))}${(S+=1)===i.size?"":","}`:O=`// "${M.name}": ${JSON.stringify(She(M))},`,h.push({value:O,description:`/* ${M.description&&Gs(M.description)||M.name} */`}),m=Math.max(O.length,m)}});let b=s(2),A=[];A.push("{"),A.push(`${b}"compilerOptions": {`),A.push(`${b}${b}/* ${Gs(g.Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file)} */`),A.push("");for(let k of h){let{value:N,description:M=""}=k;A.push(N&&`${b}${b}${N}${M&&s(m-N.length+2)+M}`)}if(t.length){A.push(`${b}},`),A.push(`${b}"files": [`);for(let k=0;k<t.length;k++)A.push(`${b}${b}${JSON.stringify(t[k])}${k===t.length-1?"":","}`);A.push(`${b}]`)}else A.push(`${b}}`);return A.push("}"),A.join(n)+n}}function TQ(e,t){let n={},i=rD().optionsNameMap;for(let s in e)wo(e,s)&&(n[s]=J1t(i.get(s.toLowerCase()),e[s],t));return n.configFilePath&&(n.configFilePath=t(n.configFilePath)),n}function J1t(e,t,n){if(e&&!nM(t)){if(e.type==="list"){let i=t;if(e.element.isFilePath&&i.length)return i.map(n)}else if(e.isFilePath)return n(t);I.assert(e.type!=="listOrElement")}return t}function $8e(e,t,n,i,s,o,l,p,m){return G8e(e,void 0,t,n,i,m,s,o,l,p)}function rM(e,t,n,i,s,o,l,p,m){var S,h;(S=mn)==null||S.push(mn.Phase.Parse,"parseJsonSourceFileConfigFileContent",{path:e.fileName});let b=G8e(void 0,e,t,n,i,m,s,o,l,p);return(h=mn)==null||h.pop(),b}function bQ(e,t){t&&Object.defineProperty(e,"configFile",{enumerable:!1,writable:!1,value:t})}function nM(e){return e==null}function W8e(e,t){return hi(Ps(e,t))}function G8e(e,t,n,i,s={},o,l,p=[],m=[],S){I.assert(e===void 0&&t!==void 0||e!==void 0&&t===void 0);let h=[],b=X8e(e,t,n,i,l,p,h,S),{raw:A}=b,k=Ml(s,b.options||{}),N=o&&b.watchOptions?Ml(o,b.watchOptions):b.watchOptions||o;k.configFilePath=l&&v_(l);let M=U();t&&(t.configFileSpecs=M),bQ(k,t);let O=Ca(l?W8e(l,i):i);return{options:k,watchOptions:N,fileNames:H(O),projectReferences:K(O),typeAcquisition:b.typeAcquisition||EQ(),raw:A,errors:h,wildcardDirectories:K1t(M,O,n.useCaseSensitiveFileNames),compileOnSave:!!A.compileOnSave};function U(){let se=pe("references",ve=>typeof ve=="object","object"),Se=re($("files"));if(Se){let ve=se==="no-prop"||os(se)&&se.length===0,oe=wo(A,"extends");if(Se.length===0&&ve&&!oe)if(t){let Ee=l||"tsconfig.json",Me=g.The_files_list_in_config_file_0_is_empty,Ge=b8(t,"files",Ie=>Ie.initializer),Ae=wT(t,Ge,Me,Ee);h.push(Ae)}else z(g.The_files_list_in_config_file_0_is_empty,l||"tsconfig.json")}let xe=re($("include")),Z=$("exclude"),Q=!1,ce=re(Z);if(Z==="no-prop"&&A.compilerOptions){let ve=A.compilerOptions.outDir,oe=A.compilerOptions.declarationDir;(ve||oe)&&(ce=[ve,oe].filter(Ee=>!!Ee))}Se===void 0&&xe===void 0&&(xe=[MU],Q=!0);let ye,we;return xe&&(ye=cRe(xe,h,!0,t,"include")),ce&&(we=cRe(ce,h,!1,t,"exclude")),{filesSpecs:Se,includeSpecs:xe,excludeSpecs:ce,validatedFilesSpec:Fn(Se,vs),validatedIncludeSpecs:ye,validatedExcludeSpecs:we,pathPatterns:void 0,isDefaultIncludeSpec:Q}}function H(se){let Se=Q6(M,se,k,n,m);return Y8e(Se,K6(A),p)&&h.push(H8e(M,l)),Se}function K(se){let Se,xe=pe("references",Z=>typeof Z=="object","object");if(os(xe))for(let Z of xe)typeof Z.path!="string"?z(g.Compiler_option_0_requires_a_value_of_type_1,"reference.path","string"):(Se||(Se=[])).push({path:Ps(Z.path,se),originalPath:Z.path,prepend:Z.prepend,circular:Z.circular});return Se}function re(se){return os(se)?se:void 0}function $(se){return pe(se,vs,"string")}function pe(se,Se,xe){if(wo(A,se)&&!nM(A[se]))if(os(A[se])){let Z=A[se];return!t&&!yr(Z,Se)&&h.push(fl(g.Compiler_option_0_requires_a_value_of_type_1,se,xe)),Z}else return z(g.Compiler_option_0_requires_a_value_of_type_1,se,"Array"),"not-array";return"no-prop"}function z(se,...Se){t||h.push(fl(se,...Se))}}function q1t(e){return e.code===g.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2.code}function H8e({includeSpecs:e,excludeSpecs:t},n){return fl(g.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2,n||"tsconfig.json",JSON.stringify(e||[]),JSON.stringify(t||[]))}function Y8e(e,t,n){return e.length===0&&t&&(!n||n.length===0)}function K6(e){return!wo(e,"files")&&!wo(e,"references")}function kU(e,t,n,i,s){let o=i.length;return Y8e(e,s)?i.push(H8e(n,t)):Nh(i,l=>!q1t(l)),o!==i.length}function z1t(e){return!!e.options}function X8e(e,t,n,i,s,o,l,p){var m;i=v_(i);let S=Ps(s||"",i);if(o.includes(S))return l.push(fl(g.Circularity_detected_while_resolving_configuration_Colon_0,[...o,S].join(" -> "))),{raw:e||phe(t,l)};let h=e?$1t(e,n,i,s,l):W1t(t,n,i,s,l);if((m=h.options)!=null&&m.paths&&(h.options.pathsBasePath=i),h.extendedConfigPath){o=o.concat([S]);let A={options:{}};vs(h.extendedConfigPath)?b(A,h.extendedConfigPath):h.extendedConfigPath.forEach(k=>b(A,k)),!h.raw.include&&A.include&&(h.raw.include=A.include),!h.raw.exclude&&A.exclude&&(h.raw.exclude=A.exclude),!h.raw.files&&A.files&&(h.raw.files=A.files),h.raw.compileOnSave===void 0&&A.compileOnSave&&(h.raw.compileOnSave=A.compileOnSave),t&&A.extendedSourceFiles&&(t.extendedSourceFiles=In(A.extendedSourceFiles.keys())),h.options=ec(A.options,h.options),h.watchOptions=h.watchOptions&&A.watchOptions?ec(A.watchOptions,h.watchOptions):h.watchOptions||A.watchOptions}return h;function b(A,k){let N=G1t(t,k,n,o,l,p,A);if(N&&z1t(N)){let M=N.raw,O,U=H=>{M[H]&&(A[H]=vr(M[H],K=>ap(K)?K:li(O||(O=bw(hi(k),i,y_(n.useCaseSensitiveFileNames))),K)))};U("include"),U("exclude"),U("files"),M.compileOnSave!==void 0&&(A.compileOnSave=M.compileOnSave),ec(A.options,N.options),A.watchOptions=A.watchOptions&&N.watchOptions?ec({},A.watchOptions,N.watchOptions):A.watchOptions||N.watchOptions}}}function $1t(e,t,n,i,s){wo(e,"excludes")&&s.push(fl(g.Unknown_option_excludes_Did_you_mean_exclude));let o=rRe(e.compilerOptions,n,s,i),l=nRe(e.typeAcquisition,n,s,i),p=Y1t(e.watchOptions,n,s);e.compileOnSave=H1t(e,n,s);let m=e.extends||e.extends===""?K8e(e.extends,t,n,i,s):void 0;return{raw:e,options:o,watchOptions:p,typeAcquisition:l,extendedConfigPath:m}}function K8e(e,t,n,i,s,o,l,p){let m,S=i?W8e(i,n):n;if(vs(e))m=Q8e(e,t,S,s,l,p);else if(os(e)){m=[];for(let h=0;h<e.length;h++){let b=e[h];vs(b)?m=Pr(m,Q8e(b,t,S,s,l?.elements[h],p)):vx(uM.element,e,n,s,o,l?.elements[h],p)}}else vx(uM,e,n,s,o,l,p);return m}function W1t(e,t,n,i,s){let o=tRe(i),l,p,m,S,h=j1t(),b=F8e(e,s,{rootOptions:h,onPropertySet:A});return l||(l=EQ(i)),S&&b&&b.compilerOptions===void 0&&s.push(im(e,S[0],g._0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file,iN(S[0]))),{raw:b,options:o,watchOptions:p,typeAcquisition:l,extendedConfigPath:m};function A(k,N,M,O,U){if(U&&U!==uM&&(N=vx(U,N,n,s,M,M.initializer,e)),O?.name)if(U){let H;O===xhe?H=o:O===Che?H=p??(p={}):O===Ahe?H=l??(l=EQ(i)):I.fail("Unknown option"),H[U.name]=N}else k&&O?.extraKeyDiagnostics&&(O.elementOptions?s.push(uhe(k,O.extraKeyDiagnostics,void 0,M.name,e)):s.push(im(e,M.name,O.extraKeyDiagnostics.unknownOptionDiagnostic,k)));else O===h&&(U===uM?m=K8e(N,t,n,i,s,M,M.initializer,e):U||(k==="excludes"&&s.push(im(e,M.name,g.Unknown_option_excludes_Did_you_mean_exclude)),mr(CQ,H=>H.name===k)&&(S=Pr(S,M.name))))}}function Q8e(e,t,n,i,s,o){if(e=v_(e),ap(e)||Ss(e,"./")||Ss(e,"../")){let p=Ps(e,n);if(!t.fileExists(p)&&!Mc(p,".json")&&(p=`${p}.json`,!t.fileExists(p))){i.push(wT(o,s,g.File_0_not_found,e));return}return p}let l=Fhe(e,li(n,"tsconfig.json"),t);if(l.resolvedModule)return l.resolvedModule.resolvedFileName;e===""?i.push(wT(o,s,g.Compiler_option_0_cannot_be_given_an_empty_string,"extends")):i.push(wT(o,s,g.File_0_not_found,e))}function G1t(e,t,n,i,s,o,l){let p=n.useCaseSensitiveFileNames?t:sp(t),m,S,h;if(o&&(m=o.get(p))?{extendedResult:S,extendedConfig:h}=m:(S=fhe(t,b=>n.readFile(b)),S.parseDiagnostics.length||(h=X8e(void 0,S,n,hi(t),Cl(t),i,s,o)),o&&o.set(p,{extendedResult:S,extendedConfig:h})),e&&((l.extendedSourceFiles??(l.extendedSourceFiles=new Set)).add(S.fileName),S.extendedSourceFiles))for(let b of S.extendedSourceFiles)l.extendedSourceFiles.add(b);if(S.parseDiagnostics.length){s.push(...S.parseDiagnostics);return}return h}function H1t(e,t,n){if(!wo(e,iM.name))return!1;let i=vx(iM,e.compileOnSave,t,n);return typeof i=="boolean"&&i}function Z8e(e,t,n){let i=[];return{options:rRe(e,t,i,n),errors:i}}function eRe(e,t,n){let i=[];return{options:nRe(e,t,i,n),errors:i}}function tRe(e){return e&&Cl(e)==="jsconfig.json"?{allowJs:!0,maxNodeModuleJsDepth:2,allowSyntheticDefaultImports:!0,skipLibCheck:!0,noEmit:!0}:{}}function rRe(e,t,n,i){let s=tRe(i);return dhe(R8e(),e,t,s,lM,n),i&&(s.configFilePath=v_(i)),s}function EQ(e){return{enable:!!e&&Cl(e)==="jsconfig.json",include:[],exclude:[]}}function nRe(e,t,n,i){let s=EQ(i);return dhe(L8e(),e,t,s,Ehe,n),s}function Y1t(e,t,n){return dhe(M8e(),e,t,void 0,RU,n)}function dhe(e,t,n,i,s,o){if(t){for(let l in t){let p=e.get(l);p?(i||(i={}))[p.name]=vx(p,t[l],n,o):o.push(uhe(l,s))}return i}}function wT(e,t,n,...i){return e&&t?im(e,t,n,...i):fl(n,...i)}function vx(e,t,n,i,s,o,l){if(e.isCommandLineOnly){i.push(wT(l,s?.name,g.Option_0_can_only_be_specified_on_command_line,e.name));return}if(j8e(e,t)){let p=e.type;if(p==="list"&&os(t))return sRe(e,t,n,i,s,o,l);if(p==="listOrElement")return os(t)?sRe(e,t,n,i,s,o,l):vx(e.element,t,n,i,s,o,l);if(!vs(e.type))return iRe(e,t,i,o,l);let m=ck(e,t,i,o,l);return nM(m)?m:X1t(e,n,m)}else i.push(wT(l,o,g.Compiler_option_0_requires_a_value_of_type_1,e.name,vQ(e)))}function X1t(e,t,n){return e.isFilePath&&(n=Ps(n,t),n===""&&(n=".")),n}function ck(e,t,n,i,s){var o;if(nM(t))return;let l=(o=e.extraValidation)==null?void 0:o.call(e,t);if(!l)return t;n.push(wT(s,i,...l))}function iRe(e,t,n,i,s){if(nM(t))return;let o=t.toLowerCase(),l=e.type.get(o);if(l!==void 0)return ck(e,l,n,i,s);n.push(A8e(e,(p,...m)=>wT(s,i,p,...m)))}function sRe(e,t,n,i,s,o,l){return Fn(vr(t,(p,m)=>vx(e.element,p,n,i,s,o?.elements[m],l)),p=>e.listPreserveFalsyValues?!0:!!p)}function Q6(e,t,n,i,s=tt){t=Ca(t);let o=y_(i.useCaseSensitiveFileNames),l=new Map,p=new Map,m=new Map,{validatedFilesSpec:S,validatedIncludeSpecs:h,validatedExcludeSpecs:b}=e,A=m6(n,s),k=oR(n,A);if(S)for(let U of S){let H=Ps(U,t);l.set(o(H),H)}let N;if(h&&h.length>0)for(let U of i.readDirectory(t,ip(k),b,h,void 0)){if(Uc(U,".json")){if(!N){let re=h.filter(pe=>Mc(pe,".json")),$=vr(Xj(re,t,"files"),pe=>`^${pe}$`);N=$?$.map(pe=>$v(pe,i.useCaseSensitiveFileNames)):tt}if(oa(N,re=>re.test(U))!==-1){let re=o(U);!l.has(re)&&!m.has(re)&&m.set(re,U)}continue}if(Z1t(U,l,p,A,o))continue;evt(U,p,A,o);let H=o(U);!l.has(H)&&!p.has(H)&&p.set(H,U)}let M=In(l.values()),O=In(p.values());return M.concat(O,In(m.values()))}function mhe(e,t,n,i,s){let{validatedFilesSpec:o,validatedIncludeSpecs:l,validatedExcludeSpecs:p}=t;if(!de(l)||!de(p))return!1;n=Ca(n);let m=y_(i);if(o){for(let S of o)if(m(Ps(S,n))===e)return!1}return oRe(e,p,i,s,n)}function aRe(e){let t=Ss(e,"**/")?0:e.indexOf("/**/");return t===-1?!1:(Mc(e,"/..")?e.length:e.lastIndexOf("/../"))>t}function PU(e,t,n,i){return oRe(e,Fn(t,s=>!aRe(s)),n,i)}function oRe(e,t,n,i,s){let o=d6(t,li(Ca(i),s),"exclude"),l=o&&$v(o,n);return l?l.test(e)?!0:!pA(e)&&l.test(hu(e)):!1}function cRe(e,t,n,i,s){return e.filter(l=>{if(!vs(l))return!1;let p=ghe(l,n);return p!==void 0&&t.push(o(...p)),p===void 0});function o(l,p){let m=tj(i,s,p);return wT(i,m,l,p)}}function ghe(e,t){if(I.assert(typeof e=="string"),t&&yRe.test(e))return[g.File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0,e];if(aRe(e))return[g.File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0,e]}function K1t({validatedIncludeSpecs:e,validatedExcludeSpecs:t},n,i){let s=d6(t,n,"exclude"),o=s&&new RegExp(s,i?"":"i"),l={},p=new Map;if(e!==void 0){let m=[];for(let S of e){let h=Ca(li(n,S));if(o&&o.test(h))continue;let b=Q1t(h,i);if(b){let{key:A,path:k,flags:N}=b,M=p.get(A),O=M!==void 0?l[M]:void 0;(O===void 0||O<N)&&(l[M!==void 0?M:k]=N,M===void 0&&p.set(A,k),N===1&&m.push(A))}}for(let S in l)if(wo(l,S))for(let h of m){let b=hhe(S,i);b!==h&&wm(h,b,n,!i)&&delete l[S]}}return l}function hhe(e,t){return t?e:sp(e)}function Q1t(e,t){let n=vRe.exec(e);if(n){let i=e.indexOf("?"),s=e.indexOf("*"),o=e.lastIndexOf(hc);return{key:hhe(n[0],t),path:n[0],flags:i!==-1&&i<o||s!==-1&&s<o?1:0}}if(VX(e.substring(e.lastIndexOf(hc)+1))){let i=sT(e);return{key:hhe(i,t),path:i,flags:1}}}function Z1t(e,t,n,i,s){let o=Te(i,l=>Ql(e,l)?l:void 0);if(!o)return!1;for(let l of o){if(Uc(e,l)&&(l!==".ts"||!Uc(e,".d.ts")))return!1;let p=s(bT(e,l));if(t.has(p)||n.has(p)){if(l===".d.ts"&&(Uc(e,".js")||Uc(e,".jsx")))continue;return!0}}return!1}function evt(e,t,n,i){let s=Te(n,o=>Ql(e,o)?o:void 0);if(s)for(let o=s.length-1;o>=0;o--){let l=s[o];if(Uc(e,l))return;let p=i(bT(e,l));t.delete(p)}}function yhe(e){let t={};for(let n in e)if(wo(e,n)){let i=gQ(n);i!==void 0&&(t[n]=vhe(e[n],i))}return t}function vhe(e,t){if(e===void 0)return e;switch(t.type){case"object":return"";case"string":return"";case"number":return typeof e=="number"?e:"";case"boolean":return typeof e=="boolean"?e:"";case"listOrElement":if(!os(e))return vhe(e,t.element);case"list":let n=t.element;return os(e)?Wi(e,i=>vhe(i,n)):"";default:return yu(t.type,(i,s)=>{if(i===e)return s})}}function She(e){switch(e.type){case"number":return 1;case"boolean":return!0;case"string":let t=e.defaultValueDescription;return e.isFilePath?`./${t&&typeof t=="string"?t:""}`:"";case"list":return[];case"listOrElement":return She(e.element);case"object":return{};default:let n=Oa(e.type.keys());return n!==void 0?n:I.fail("Expected 'option.type' to have entries.")}}var iM,The,Z6,bhe,sM,NU,nD,aM,oM,xQ,CQ,F0,AQ,kQ,PQ,DU,IU,NQ,DQ,IQ,wU,cM,lRe,uRe,OU,lM,_Re,fRe,pRe,Ehe,dRe,RU,mRe,gRe,hRe,uM,xhe,Che,Ahe,khe,MU,yRe,vRe,tvt=f({"src/compiler/commandLineParser.ts"(){"use strict";fa(),iM={name:"compileOnSave",type:"boolean",defaultValueDescription:!1},The=new Map(Object.entries({preserve:1,"react-native":3,react:2,"react-jsx":4,"react-jsxdev":5})),Z6=new Map(g1(The.entries(),([e,t])=>[""+t,e])),bhe=[["es5","lib.es5.d.ts"],["es6","lib.es2015.d.ts"],["es2015","lib.es2015.d.ts"],["es7","lib.es2016.d.ts"],["es2016","lib.es2016.d.ts"],["es2017","lib.es2017.d.ts"],["es2018","lib.es2018.d.ts"],["es2019","lib.es2019.d.ts"],["es2020","lib.es2020.d.ts"],["es2021","lib.es2021.d.ts"],["es2022","lib.es2022.d.ts"],["es2023","lib.es2023.d.ts"],["esnext","lib.esnext.d.ts"],["dom","lib.dom.d.ts"],["dom.iterable","lib.dom.iterable.d.ts"],["dom.asynciterable","lib.dom.asynciterable.d.ts"],["webworker","lib.webworker.d.ts"],["webworker.importscripts","lib.webworker.importscripts.d.ts"],["webworker.iterable","lib.webworker.iterable.d.ts"],["webworker.asynciterable","lib.webworker.asynciterable.d.ts"],["scripthost","lib.scripthost.d.ts"],["es2015.core","lib.es2015.core.d.ts"],["es2015.collection","lib.es2015.collection.d.ts"],["es2015.generator","lib.es2015.generator.d.ts"],["es2015.iterable","lib.es2015.iterable.d.ts"],["es2015.promise","lib.es2015.promise.d.ts"],["es2015.proxy","lib.es2015.proxy.d.ts"],["es2015.reflect","lib.es2015.reflect.d.ts"],["es2015.symbol","lib.es2015.symbol.d.ts"],["es2015.symbol.wellknown","lib.es2015.symbol.wellknown.d.ts"],["es2016.array.include","lib.es2016.array.include.d.ts"],["es2016.intl","lib.es2016.intl.d.ts"],["es2017.date","lib.es2017.date.d.ts"],["es2017.object","lib.es2017.object.d.ts"],["es2017.sharedmemory","lib.es2017.sharedmemory.d.ts"],["es2017.string","lib.es2017.string.d.ts"],["es2017.intl","lib.es2017.intl.d.ts"],["es2017.typedarrays","lib.es2017.typedarrays.d.ts"],["es2018.asyncgenerator","lib.es2018.asyncgenerator.d.ts"],["es2018.asynciterable","lib.es2018.asynciterable.d.ts"],["es2018.intl","lib.es2018.intl.d.ts"],["es2018.promise","lib.es2018.promise.d.ts"],["es2018.regexp","lib.es2018.regexp.d.ts"],["es2019.array","lib.es2019.array.d.ts"],["es2019.object","lib.es2019.object.d.ts"],["es2019.string","lib.es2019.string.d.ts"],["es2019.symbol","lib.es2019.symbol.d.ts"],["es2019.intl","lib.es2019.intl.d.ts"],["es2020.bigint","lib.es2020.bigint.d.ts"],["es2020.date","lib.es2020.date.d.ts"],["es2020.promise","lib.es2020.promise.d.ts"],["es2020.sharedmemory","lib.es2020.sharedmemory.d.ts"],["es2020.string","lib.es2020.string.d.ts"],["es2020.symbol.wellknown","lib.es2020.symbol.wellknown.d.ts"],["es2020.intl","lib.es2020.intl.d.ts"],["es2020.number","lib.es2020.number.d.ts"],["es2021.promise","lib.es2021.promise.d.ts"],["es2021.string","lib.es2021.string.d.ts"],["es2021.weakref","lib.es2021.weakref.d.ts"],["es2021.intl","lib.es2021.intl.d.ts"],["es2022.array","lib.es2022.array.d.ts"],["es2022.error","lib.es2022.error.d.ts"],["es2022.intl","lib.es2022.intl.d.ts"],["es2022.object","lib.es2022.object.d.ts"],["es2022.sharedmemory","lib.es2022.sharedmemory.d.ts"],["es2022.string","lib.es2022.string.d.ts"],["es2022.regexp","lib.es2022.regexp.d.ts"],["es2023.array","lib.es2023.array.d.ts"],["es2023.collection","lib.es2023.collection.d.ts"],["esnext.array","lib.es2023.array.d.ts"],["esnext.collection","lib.esnext.collection.d.ts"],["esnext.symbol","lib.es2019.symbol.d.ts"],["esnext.asynciterable","lib.es2018.asynciterable.d.ts"],["esnext.intl","lib.esnext.intl.d.ts"],["esnext.disposable","lib.esnext.disposable.d.ts"],["esnext.bigint","lib.es2020.bigint.d.ts"],["esnext.string","lib.es2022.string.d.ts"],["esnext.promise","lib.esnext.promise.d.ts"],["esnext.weakref","lib.es2021.weakref.d.ts"],["esnext.decorators","lib.esnext.decorators.d.ts"],["esnext.object","lib.esnext.object.d.ts"],["decorators","lib.decorators.d.ts"],["decorators.legacy","lib.decorators.legacy.d.ts"]],sM=bhe.map(e=>e[0]),NU=new Map(bhe),nD=[{name:"watchFile",type:new Map(Object.entries({fixedpollinginterval:0,prioritypollinginterval:1,dynamicprioritypolling:2,fixedchunksizepolling:3,usefsevents:4,usefseventsonparentdirectory:5})),category:g.Watch_and_Build_Modes,description:g.Specify_how_the_TypeScript_watch_mode_works,defaultValueDescription:4},{name:"watchDirectory",type:new Map(Object.entries({usefsevents:0,fixedpollinginterval:1,dynamicprioritypolling:2,fixedchunksizepolling:3})),category:g.Watch_and_Build_Modes,description:g.Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality,defaultValueDescription:0},{name:"fallbackPolling",type:new Map(Object.entries({fixedinterval:0,priorityinterval:1,dynamicpriority:2,fixedchunksize:3})),category:g.Watch_and_Build_Modes,description:g.Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers,defaultValueDescription:1},{name:"synchronousWatchDirectory",type:"boolean",category:g.Watch_and_Build_Modes,description:g.Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively,defaultValueDescription:!1},{name:"excludeDirectories",type:"list",element:{name:"excludeDirectory",type:"string",isFilePath:!0,extraValidation:ghe},category:g.Watch_and_Build_Modes,description:g.Remove_a_list_of_directories_from_the_watch_process},{name:"excludeFiles",type:"list",element:{name:"excludeFile",type:"string",isFilePath:!0,extraValidation:ghe},category:g.Watch_and_Build_Modes,description:g.Remove_a_list_of_files_from_the_watch_mode_s_processing}],aM=[{name:"help",shortName:"h",type:"boolean",showInSimplifiedHelpView:!0,isCommandLineOnly:!0,category:g.Command_line_Options,description:g.Print_this_message,defaultValueDescription:!1},{name:"help",shortName:"?",type:"boolean",isCommandLineOnly:!0,category:g.Command_line_Options,defaultValueDescription:!1},{name:"watch",shortName:"w",type:"boolean",showInSimplifiedHelpView:!0,isCommandLineOnly:!0,category:g.Command_line_Options,description:g.Watch_input_files,defaultValueDescription:!1},{name:"preserveWatchOutput",type:"boolean",showInSimplifiedHelpView:!1,category:g.Output_Formatting,description:g.Disable_wiping_the_console_in_watch_mode,defaultValueDescription:!1},{name:"listFiles",type:"boolean",category:g.Compiler_Diagnostics,description:g.Print_all_of_the_files_read_during_the_compilation,defaultValueDescription:!1},{name:"explainFiles",type:"boolean",category:g.Compiler_Diagnostics,description:g.Print_files_read_during_the_compilation_including_why_it_was_included,defaultValueDescription:!1},{name:"listEmittedFiles",type:"boolean",category:g.Compiler_Diagnostics,description:g.Print_the_names_of_emitted_files_after_a_compilation,defaultValueDescription:!1},{name:"pretty",type:"boolean",showInSimplifiedHelpView:!0,category:g.Output_Formatting,description:g.Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read,defaultValueDescription:!0},{name:"traceResolution",type:"boolean",category:g.Compiler_Diagnostics,description:g.Log_paths_used_during_the_moduleResolution_process,defaultValueDescription:!1},{name:"diagnostics",type:"boolean",category:g.Compiler_Diagnostics,description:g.Output_compiler_performance_information_after_building,defaultValueDescription:!1},{name:"extendedDiagnostics",type:"boolean",category:g.Compiler_Diagnostics,description:g.Output_more_detailed_compiler_performance_information_after_building,defaultValueDescription:!1},{name:"generateCpuProfile",type:"string",isFilePath:!0,paramType:g.FILE_OR_DIRECTORY,category:g.Compiler_Diagnostics,description:g.Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging,defaultValueDescription:"profile.cpuprofile"},{name:"generateTrace",type:"string",isFilePath:!0,isCommandLineOnly:!0,paramType:g.DIRECTORY,category:g.Compiler_Diagnostics,description:g.Generates_an_event_trace_and_a_list_of_types},{name:"incremental",shortName:"i",type:"boolean",category:g.Projects,description:g.Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects,transpileOptionValue:void 0,defaultValueDescription:g.false_unless_composite_is_set},{name:"declaration",shortName:"d",type:"boolean",affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:g.Emit,transpileOptionValue:void 0,description:g.Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project,defaultValueDescription:g.false_unless_composite_is_set},{name:"declarationMap",type:"boolean",affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:g.Emit,transpileOptionValue:void 0,defaultValueDescription:!1,description:g.Create_sourcemaps_for_d_ts_files},{name:"emitDeclarationOnly",type:"boolean",affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:g.Emit,description:g.Only_output_d_ts_files_and_not_JavaScript_files,transpileOptionValue:void 0,defaultValueDescription:!1},{name:"sourceMap",type:"boolean",affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:g.Emit,defaultValueDescription:!1,description:g.Create_source_map_files_for_emitted_JavaScript_files},{name:"inlineSourceMap",type:"boolean",affectsBuildInfo:!0,category:g.Emit,description:g.Include_sourcemap_files_inside_the_emitted_JavaScript,defaultValueDescription:!1},{name:"assumeChangesOnlyAffectDirectDependencies",type:"boolean",affectsSemanticDiagnostics:!0,affectsEmit:!0,affectsBuildInfo:!0,category:g.Watch_and_Build_Modes,description:g.Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it,defaultValueDescription:!1},{name:"locale",type:"string",category:g.Command_line_Options,isCommandLineOnly:!0,description:g.Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit,defaultValueDescription:g.Platform_specific}],oM={name:"target",shortName:"t",type:new Map(Object.entries({es3:0,es5:1,es6:2,es2015:2,es2016:3,es2017:4,es2018:5,es2019:6,es2020:7,es2021:8,es2022:9,esnext:99})),affectsSourceFile:!0,affectsModuleResolution:!0,affectsEmit:!0,affectsBuildInfo:!0,deprecatedKeys:new Set(["es3"]),paramType:g.VERSION,showInSimplifiedHelpView:!0,category:g.Language_and_Environment,description:g.Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations,defaultValueDescription:1},xQ={name:"module",shortName:"m",type:new Map(Object.entries({none:0,commonjs:1,amd:2,system:4,umd:3,es6:5,es2015:5,es2020:6,es2022:7,esnext:99,node16:100,nodenext:199,preserve:200})),affectsSourceFile:!0,affectsModuleResolution:!0,affectsEmit:!0,affectsBuildInfo:!0,paramType:g.KIND,showInSimplifiedHelpView:!0,category:g.Modules,description:g.Specify_what_module_code_is_generated,defaultValueDescription:void 0},CQ=[{name:"all",type:"boolean",showInSimplifiedHelpView:!0,category:g.Command_line_Options,description:g.Show_all_compiler_options,defaultValueDescription:!1},{name:"version",shortName:"v",type:"boolean",showInSimplifiedHelpView:!0,category:g.Command_line_Options,description:g.Print_the_compiler_s_version,defaultValueDescription:!1},{name:"init",type:"boolean",showInSimplifiedHelpView:!0,category:g.Command_line_Options,description:g.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file,defaultValueDescription:!1},{name:"project",shortName:"p",type:"string",isFilePath:!0,showInSimplifiedHelpView:!0,category:g.Command_line_Options,paramType:g.FILE_OR_DIRECTORY,description:g.Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json},{name:"build",type:"boolean",shortName:"b",showInSimplifiedHelpView:!0,category:g.Command_line_Options,description:g.Build_one_or_more_projects_and_their_dependencies_if_out_of_date,defaultValueDescription:!1},{name:"showConfig",type:"boolean",showInSimplifiedHelpView:!0,category:g.Command_line_Options,isCommandLineOnly:!0,description:g.Print_the_final_configuration_instead_of_building,defaultValueDescription:!1},{name:"listFilesOnly",type:"boolean",category:g.Command_line_Options,isCommandLineOnly:!0,description:g.Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing,defaultValueDescription:!1},oM,xQ,{name:"lib",type:"list",element:{name:"lib",type:NU,defaultValueDescription:void 0},affectsProgramStructure:!0,showInSimplifiedHelpView:!0,category:g.Language_and_Environment,description:g.Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment,transpileOptionValue:void 0},{name:"allowJs",type:"boolean",allowJsFlag:!0,affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:g.JavaScript_Support,description:g.Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files,defaultValueDescription:!1},{name:"checkJs",type:"boolean",affectsModuleResolution:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:g.JavaScript_Support,description:g.Enable_error_reporting_in_type_checked_JavaScript_files,defaultValueDescription:!1},{name:"jsx",type:The,affectsSourceFile:!0,affectsEmit:!0,affectsBuildInfo:!0,affectsModuleResolution:!0,affectsSemanticDiagnostics:!0,paramType:g.KIND,showInSimplifiedHelpView:!0,category:g.Language_and_Environment,description:g.Specify_what_JSX_code_is_generated,defaultValueDescription:void 0},{name:"outFile",type:"string",affectsEmit:!0,affectsBuildInfo:!0,affectsDeclarationPath:!0,isFilePath:!0,paramType:g.FILE,showInSimplifiedHelpView:!0,category:g.Emit,description:g.Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output,transpileOptionValue:void 0},{name:"outDir",type:"string",affectsEmit:!0,affectsBuildInfo:!0,affectsDeclarationPath:!0,isFilePath:!0,paramType:g.DIRECTORY,showInSimplifiedHelpView:!0,category:g.Emit,description:g.Specify_an_output_folder_for_all_emitted_files},{name:"rootDir",type:"string",affectsEmit:!0,affectsBuildInfo:!0,affectsDeclarationPath:!0,isFilePath:!0,paramType:g.LOCATION,category:g.Modules,description:g.Specify_the_root_folder_within_your_source_files,defaultValueDescription:g.Computed_from_the_list_of_input_files},{name:"composite",type:"boolean",affectsBuildInfo:!0,isTSConfigOnly:!0,category:g.Projects,transpileOptionValue:void 0,defaultValueDescription:!1,description:g.Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references},{name:"tsBuildInfoFile",type:"string",affectsEmit:!0,affectsBuildInfo:!0,isFilePath:!0,paramType:g.FILE,category:g.Projects,transpileOptionValue:void 0,defaultValueDescription:".tsbuildinfo",description:g.Specify_the_path_to_tsbuildinfo_incremental_compilation_file},{name:"removeComments",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:g.Emit,defaultValueDescription:!1,description:g.Disable_emitting_comments},{name:"noEmit",type:"boolean",showInSimplifiedHelpView:!0,category:g.Emit,description:g.Disable_emitting_files_from_a_compilation,transpileOptionValue:void 0,defaultValueDescription:!1},{name:"importHelpers",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:g.Emit,description:g.Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file,defaultValueDescription:!1},{name:"importsNotUsedAsValues",type:new Map(Object.entries({remove:0,preserve:1,error:2})),affectsEmit:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Emit,description:g.Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types,defaultValueDescription:0},{name:"downlevelIteration",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:g.Emit,description:g.Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration,defaultValueDescription:!1},{name:"isolatedModules",type:"boolean",category:g.Interop_Constraints,description:g.Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports,transpileOptionValue:!0,defaultValueDescription:!1},{name:"verbatimModuleSyntax",type:"boolean",category:g.Interop_Constraints,description:g.Do_not_transform_or_elide_any_imports_or_exports_not_marked_as_type_only_ensuring_they_are_written_in_the_output_file_s_format_based_on_the_module_setting,defaultValueDescription:!1},{name:"strict",type:"boolean",affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:g.Type_Checking,description:g.Enable_all_strict_type_checking_options,defaultValueDescription:!1},{name:"noImplicitAny",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:g.Type_Checking,description:g.Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type,defaultValueDescription:g.false_unless_strict_is_set},{name:"strictNullChecks",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:g.Type_Checking,description:g.When_type_checking_take_into_account_null_and_undefined,defaultValueDescription:g.false_unless_strict_is_set},{name:"strictFunctionTypes",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:g.Type_Checking,description:g.When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible,defaultValueDescription:g.false_unless_strict_is_set},{name:"strictBindCallApply",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:g.Type_Checking,description:g.Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function,defaultValueDescription:g.false_unless_strict_is_set},{name:"strictPropertyInitialization",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:g.Type_Checking,description:g.Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor,defaultValueDescription:g.false_unless_strict_is_set},{name:"noImplicitThis",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:g.Type_Checking,description:g.Enable_error_reporting_when_this_is_given_the_type_any,defaultValueDescription:g.false_unless_strict_is_set},{name:"useUnknownInCatchVariables",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,strictFlag:!0,category:g.Type_Checking,description:g.Default_catch_clause_variables_as_unknown_instead_of_any,defaultValueDescription:g.false_unless_strict_is_set},{name:"alwaysStrict",type:"boolean",affectsSourceFile:!0,affectsEmit:!0,affectsBuildInfo:!0,strictFlag:!0,category:g.Type_Checking,description:g.Ensure_use_strict_is_always_emitted,defaultValueDescription:g.false_unless_strict_is_set},{name:"noUnusedLocals",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Type_Checking,description:g.Enable_error_reporting_when_local_variables_aren_t_read,defaultValueDescription:!1},{name:"noUnusedParameters",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Type_Checking,description:g.Raise_an_error_when_a_function_parameter_isn_t_read,defaultValueDescription:!1},{name:"exactOptionalPropertyTypes",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Type_Checking,description:g.Interpret_optional_property_types_as_written_rather_than_adding_undefined,defaultValueDescription:!1},{name:"noImplicitReturns",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Type_Checking,description:g.Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function,defaultValueDescription:!1},{name:"noFallthroughCasesInSwitch",type:"boolean",affectsBindDiagnostics:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Type_Checking,description:g.Enable_error_reporting_for_fallthrough_cases_in_switch_statements,defaultValueDescription:!1},{name:"noUncheckedIndexedAccess",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Type_Checking,description:g.Add_undefined_to_a_type_when_accessed_using_an_index,defaultValueDescription:!1},{name:"noImplicitOverride",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Type_Checking,description:g.Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier,defaultValueDescription:!1},{name:"noPropertyAccessFromIndexSignature",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,showInSimplifiedHelpView:!1,category:g.Type_Checking,description:g.Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type,defaultValueDescription:!1},{name:"moduleResolution",type:new Map(Object.entries({node10:2,node:2,classic:1,node16:3,nodenext:99,bundler:100})),deprecatedKeys:new Set(["node"]),affectsSourceFile:!0,affectsModuleResolution:!0,paramType:g.STRATEGY,category:g.Modules,description:g.Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier,defaultValueDescription:g.module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node},{name:"baseUrl",type:"string",affectsModuleResolution:!0,isFilePath:!0,category:g.Modules,description:g.Specify_the_base_directory_to_resolve_non_relative_module_names},{name:"paths",type:"object",affectsModuleResolution:!0,isTSConfigOnly:!0,category:g.Modules,description:g.Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations,transpileOptionValue:void 0},{name:"rootDirs",type:"list",isTSConfigOnly:!0,element:{name:"rootDirs",type:"string",isFilePath:!0},affectsModuleResolution:!0,category:g.Modules,description:g.Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules,transpileOptionValue:void 0,defaultValueDescription:g.Computed_from_the_list_of_input_files},{name:"typeRoots",type:"list",element:{name:"typeRoots",type:"string",isFilePath:!0},affectsModuleResolution:!0,category:g.Modules,description:g.Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types},{name:"types",type:"list",element:{name:"types",type:"string"},affectsProgramStructure:!0,showInSimplifiedHelpView:!0,category:g.Modules,description:g.Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file,transpileOptionValue:void 0},{name:"allowSyntheticDefaultImports",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Interop_Constraints,description:g.Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export,defaultValueDescription:g.module_system_or_esModuleInterop},{name:"esModuleInterop",type:"boolean",affectsSemanticDiagnostics:!0,affectsEmit:!0,affectsBuildInfo:!0,showInSimplifiedHelpView:!0,category:g.Interop_Constraints,description:g.Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility,defaultValueDescription:!1},{name:"preserveSymlinks",type:"boolean",category:g.Interop_Constraints,description:g.Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node,defaultValueDescription:!1},{name:"allowUmdGlobalAccess",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Modules,description:g.Allow_accessing_UMD_globals_from_modules,defaultValueDescription:!1},{name:"moduleSuffixes",type:"list",element:{name:"suffix",type:"string"},listPreserveFalsyValues:!0,affectsModuleResolution:!0,category:g.Modules,description:g.List_of_file_name_suffixes_to_search_when_resolving_a_module},{name:"allowImportingTsExtensions",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Modules,description:g.Allow_imports_to_include_TypeScript_file_extensions_Requires_moduleResolution_bundler_and_either_noEmit_or_emitDeclarationOnly_to_be_set,defaultValueDescription:!1,transpileOptionValue:void 0},{name:"resolvePackageJsonExports",type:"boolean",affectsModuleResolution:!0,category:g.Modules,description:g.Use_the_package_json_exports_field_when_resolving_package_imports,defaultValueDescription:g.true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false},{name:"resolvePackageJsonImports",type:"boolean",affectsModuleResolution:!0,category:g.Modules,description:g.Use_the_package_json_imports_field_when_resolving_imports,defaultValueDescription:g.true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false},{name:"customConditions",type:"list",element:{name:"condition",type:"string"},affectsModuleResolution:!0,category:g.Modules,description:g.Conditions_to_set_in_addition_to_the_resolver_specific_defaults_when_resolving_imports},{name:"sourceRoot",type:"string",affectsEmit:!0,affectsBuildInfo:!0,paramType:g.LOCATION,category:g.Emit,description:g.Specify_the_root_path_for_debuggers_to_find_the_reference_source_code},{name:"mapRoot",type:"string",affectsEmit:!0,affectsBuildInfo:!0,paramType:g.LOCATION,category:g.Emit,description:g.Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations},{name:"inlineSources",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:g.Emit,description:g.Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript,defaultValueDescription:!1},{name:"experimentalDecorators",type:"boolean",affectsEmit:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Language_and_Environment,description:g.Enable_experimental_support_for_legacy_experimental_decorators,defaultValueDescription:!1},{name:"emitDecoratorMetadata",type:"boolean",affectsSemanticDiagnostics:!0,affectsEmit:!0,affectsBuildInfo:!0,category:g.Language_and_Environment,description:g.Emit_design_type_metadata_for_decorated_declarations_in_source_files,defaultValueDescription:!1},{name:"jsxFactory",type:"string",category:g.Language_and_Environment,description:g.Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h,defaultValueDescription:"`React.createElement`"},{name:"jsxFragmentFactory",type:"string",category:g.Language_and_Environment,description:g.Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment,defaultValueDescription:"React.Fragment"},{name:"jsxImportSource",type:"string",affectsSemanticDiagnostics:!0,affectsEmit:!0,affectsBuildInfo:!0,affectsModuleResolution:!0,category:g.Language_and_Environment,description:g.Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk,defaultValueDescription:"react"},{name:"resolveJsonModule",type:"boolean",affectsModuleResolution:!0,category:g.Modules,description:g.Enable_importing_json_files,defaultValueDescription:!1},{name:"allowArbitraryExtensions",type:"boolean",affectsProgramStructure:!0,category:g.Modules,description:g.Enable_importing_files_with_any_extension_provided_a_declaration_file_is_present,defaultValueDescription:!1},{name:"out",type:"string",affectsEmit:!0,affectsBuildInfo:!0,affectsDeclarationPath:!0,isFilePath:!1,category:g.Backwards_Compatibility,paramType:g.FILE,transpileOptionValue:void 0,description:g.Deprecated_setting_Use_outFile_instead},{name:"reactNamespace",type:"string",affectsEmit:!0,affectsBuildInfo:!0,category:g.Language_and_Environment,description:g.Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit,defaultValueDescription:"`React`"},{name:"skipDefaultLibCheck",type:"boolean",affectsBuildInfo:!0,category:g.Completeness,description:g.Skip_type_checking_d_ts_files_that_are_included_with_TypeScript,defaultValueDescription:!1},{name:"charset",type:"string",category:g.Backwards_Compatibility,description:g.No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files,defaultValueDescription:"utf8"},{name:"emitBOM",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:g.Emit,description:g.Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files,defaultValueDescription:!1},{name:"newLine",type:new Map(Object.entries({crlf:0,lf:1})),affectsEmit:!0,affectsBuildInfo:!0,paramType:g.NEWLINE,category:g.Emit,description:g.Set_the_newline_character_for_emitting_files,defaultValueDescription:"lf"},{name:"noErrorTruncation",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Output_Formatting,description:g.Disable_truncating_types_in_error_messages,defaultValueDescription:!1},{name:"noLib",type:"boolean",category:g.Language_and_Environment,affectsProgramStructure:!0,description:g.Disable_including_any_library_files_including_the_default_lib_d_ts,transpileOptionValue:!0,defaultValueDescription:!1},{name:"noResolve",type:"boolean",affectsModuleResolution:!0,category:g.Modules,description:g.Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project,transpileOptionValue:!0,defaultValueDescription:!1},{name:"stripInternal",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:g.Emit,description:g.Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments,defaultValueDescription:!1},{name:"disableSizeLimit",type:"boolean",affectsProgramStructure:!0,category:g.Editor_Support,description:g.Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server,defaultValueDescription:!1},{name:"disableSourceOfProjectReferenceRedirect",type:"boolean",isTSConfigOnly:!0,category:g.Projects,description:g.Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects,defaultValueDescription:!1},{name:"disableSolutionSearching",type:"boolean",isTSConfigOnly:!0,category:g.Projects,description:g.Opt_a_project_out_of_multi_project_reference_checking_when_editing,defaultValueDescription:!1},{name:"disableReferencedProjectLoad",type:"boolean",isTSConfigOnly:!0,category:g.Projects,description:g.Reduce_the_number_of_projects_loaded_automatically_by_TypeScript,defaultValueDescription:!1},{name:"noImplicitUseStrict",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Backwards_Compatibility,description:g.Disable_adding_use_strict_directives_in_emitted_JavaScript_files,defaultValueDescription:!1},{name:"noEmitHelpers",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:g.Emit,description:g.Disable_generating_custom_helper_functions_like_extends_in_compiled_output,defaultValueDescription:!1},{name:"noEmitOnError",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:g.Emit,transpileOptionValue:void 0,description:g.Disable_emitting_files_if_any_type_checking_errors_are_reported,defaultValueDescription:!1},{name:"preserveConstEnums",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:g.Emit,description:g.Disable_erasing_const_enum_declarations_in_generated_code,defaultValueDescription:!1},{name:"declarationDir",type:"string",affectsEmit:!0,affectsBuildInfo:!0,affectsDeclarationPath:!0,isFilePath:!0,paramType:g.DIRECTORY,category:g.Emit,transpileOptionValue:void 0,description:g.Specify_the_output_directory_for_generated_declaration_files},{name:"skipLibCheck",type:"boolean",affectsBuildInfo:!0,category:g.Completeness,description:g.Skip_type_checking_all_d_ts_files,defaultValueDescription:!1},{name:"allowUnusedLabels",type:"boolean",affectsBindDiagnostics:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Type_Checking,description:g.Disable_error_reporting_for_unused_labels,defaultValueDescription:void 0},{name:"allowUnreachableCode",type:"boolean",affectsBindDiagnostics:!0,affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Type_Checking,description:g.Disable_error_reporting_for_unreachable_code,defaultValueDescription:void 0},{name:"suppressExcessPropertyErrors",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Backwards_Compatibility,description:g.Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals,defaultValueDescription:!1},{name:"suppressImplicitAnyIndexErrors",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Backwards_Compatibility,description:g.Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures,defaultValueDescription:!1},{name:"forceConsistentCasingInFileNames",type:"boolean",affectsModuleResolution:!0,category:g.Interop_Constraints,description:g.Ensure_that_casing_is_correct_in_imports,defaultValueDescription:!0},{name:"maxNodeModuleJsDepth",type:"number",affectsModuleResolution:!0,category:g.JavaScript_Support,description:g.Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs,defaultValueDescription:0},{name:"noStrictGenericChecks",type:"boolean",affectsSemanticDiagnostics:!0,affectsBuildInfo:!0,category:g.Backwards_Compatibility,description:g.Disable_strict_checking_of_generic_signatures_in_function_types,defaultValueDescription:!1},{name:"useDefineForClassFields",type:"boolean",affectsSemanticDiagnostics:!0,affectsEmit:!0,affectsBuildInfo:!0,category:g.Language_and_Environment,description:g.Emit_ECMAScript_standard_compliant_class_fields,defaultValueDescription:g.true_for_ES2022_and_above_including_ESNext},{name:"preserveValueImports",type:"boolean",affectsEmit:!0,affectsBuildInfo:!0,category:g.Emit,description:g.Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed,defaultValueDescription:!1},{name:"keyofStringsOnly",type:"boolean",category:g.Backwards_Compatibility,description:g.Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option,defaultValueDescription:!1},{name:"plugins",type:"list",isTSConfigOnly:!0,element:{name:"plugin",type:"object"},description:g.Specify_a_list_of_language_service_plugins_to_include,category:g.Editor_Support},{name:"moduleDetection",type:new Map(Object.entries({auto:2,legacy:1,force:3})),affectsSourceFile:!0,affectsModuleResolution:!0,description:g.Control_what_method_is_used_to_detect_module_format_JS_files,category:g.Language_and_Environment,defaultValueDescription:g.auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules},{name:"ignoreDeprecations",type:"string",defaultValueDescription:void 0}],F0=[...aM,...CQ],AQ=F0.filter(e=>!!e.affectsSemanticDiagnostics),kQ=F0.filter(e=>!!e.affectsEmit),PQ=F0.filter(e=>!!e.affectsDeclarationPath),DU=F0.filter(e=>!!e.affectsModuleResolution),IU=F0.filter(e=>!!e.affectsSourceFile||!!e.affectsBindDiagnostics),NQ=F0.filter(e=>!!e.affectsProgramStructure),DQ=F0.filter(e=>wo(e,"transpileOptionValue")),IQ=[{name:"verbose",shortName:"v",category:g.Command_line_Options,description:g.Enable_verbose_logging,type:"boolean",defaultValueDescription:!1},{name:"dry",shortName:"d",category:g.Command_line_Options,description:g.Show_what_would_be_built_or_deleted_if_specified_with_clean,type:"boolean",defaultValueDescription:!1},{name:"force",shortName:"f",category:g.Command_line_Options,description:g.Build_all_projects_including_those_that_appear_to_be_up_to_date,type:"boolean",defaultValueDescription:!1},{name:"clean",category:g.Command_line_Options,description:g.Delete_the_outputs_of_all_projects,type:"boolean",defaultValueDescription:!1}],wU=[...aM,...IQ],cM=[{name:"enable",type:"boolean",defaultValueDescription:!1},{name:"include",type:"list",element:{name:"include",type:"string"}},{name:"exclude",type:"list",element:{name:"exclude",type:"string"}},{name:"disableFilenameBasedTypeAcquisition",type:"boolean",defaultValueDescription:!1}],uRe={diagnostic:g.Compiler_option_0_may_only_be_used_with_build,getOptionsNameMap:D8e},OU={module:1,target:3,strict:!0,esModuleInterop:!0,forceConsistentCasingInFileNames:!0,skipLibCheck:!0},lM={alternateMode:uRe,getOptionsNameMap:rD,optionDeclarations:F0,unknownOptionDiagnostic:g.Unknown_compiler_option_0,unknownDidYouMeanDiagnostic:g.Unknown_compiler_option_0_Did_you_mean_1,optionTypeMismatchDiagnostic:g.Compiler_option_0_expects_an_argument},fRe={diagnostic:g.Compiler_option_0_may_not_be_used_with_build,getOptionsNameMap:rD},pRe={alternateMode:fRe,getOptionsNameMap:D8e,optionDeclarations:wU,unknownOptionDiagnostic:g.Unknown_build_option_0,unknownDidYouMeanDiagnostic:g.Unknown_build_option_0_Did_you_mean_1,optionTypeMismatchDiagnostic:g.Build_option_0_requires_a_value_of_type_1},Ehe={optionDeclarations:cM,unknownOptionDiagnostic:g.Unknown_type_acquisition_option_0,unknownDidYouMeanDiagnostic:g.Unknown_type_acquisition_option_0_Did_you_mean_1},RU={getOptionsNameMap:O8e,optionDeclarations:nD,unknownOptionDiagnostic:g.Unknown_watch_option_0,unknownDidYouMeanDiagnostic:g.Unknown_watch_option_0_Did_you_mean_1,optionTypeMismatchDiagnostic:g.Watch_option_0_requires_a_value_of_type_1},uM={name:"extends",type:"listOrElement",element:{name:"extends",type:"string"},category:g.File_Management,disallowNullOrUndefined:!0},xhe={name:"compilerOptions",type:"object",elementOptions:R8e(),extraKeyDiagnostics:lM},Che={name:"watchOptions",type:"object",elementOptions:M8e(),extraKeyDiagnostics:RU},Ahe={name:"typeAcquisition",type:"object",elementOptions:L8e(),extraKeyDiagnostics:Ehe},MU="**/*",yRe=/(^|\/)\*\*\/?$/,vRe=/^[^*?]*(?=\/[^/]*[*?])/}});function ws(e,t,...n){e.trace(LX(t,...n))}function wy(e,t){return!!e.traceResolution&&t.trace!==void 0}function lk(e,t){let n;if(t&&e){let i=e.contents.packageJsonContent;typeof i.name=="string"&&typeof i.version=="string"&&(n={name:i.name,subModuleName:t.path.slice(e.packageDirectory.length+hc.length),version:i.version})}return t&&{path:t.path,extension:t.ext,packageId:n,resolvedUsingTsExtension:t.resolvedUsingTsExtension}}function wQ(e){return lk(void 0,e)}function SRe(e){if(e)return I.assert(e.packageId===void 0),{path:e.path,ext:e.extension,resolvedUsingTsExtension:e.resolvedUsingTsExtension}}function LU(e){let t=[];return e&1&&t.push("TypeScript"),e&2&&t.push("JavaScript"),e&4&&t.push("Declaration"),e&8&&t.push("JSON"),t.join(", ")}function rvt(e){let t=[];return e&1&&t.push(...vR),e&2&&t.push(...jN),e&4&&t.push(...yR),e&8&&t.push(".json"),t}function Phe(e){if(e)return I.assert(rB(e.extension)),{fileName:e.path,packageId:e.packageId}}function TRe(e,t,n,i,s,o,l,p,m){if(!l.resultFromCache&&!l.compilerOptions.preserveSymlinks&&t&&n&&!t.originalPath&&!Nu(e)){let{resolvedFileName:S,originalPath:h}=xRe(t.path,l.host,l.traceEnabled);h&&(t={...t,path:S,originalPath:h})}return bRe(t,n,i,s,o,l.resultFromCache,p,m)}function bRe(e,t,n,i,s,o,l,p){return o?l?.isReadonly?{...o,failedLookupLocations:Nhe(o.failedLookupLocations,n),affectingLocations:Nhe(o.affectingLocations,i),resolutionDiagnostics:Nhe(o.resolutionDiagnostics,s)}:(o.failedLookupLocations=iD(o.failedLookupLocations,n),o.affectingLocations=iD(o.affectingLocations,i),o.resolutionDiagnostics=iD(o.resolutionDiagnostics,s),o):{resolvedModule:e&&{resolvedFileName:e.path,originalPath:e.originalPath===!0?void 0:e.originalPath,extension:e.extension,isExternalLibraryImport:t,packageId:e.packageId,resolvedUsingTsExtension:!!e.resolvedUsingTsExtension},failedLookupLocations:eO(n),affectingLocations:eO(i),resolutionDiagnostics:eO(s),alternateResult:p}}function eO(e){return e.length?e:void 0}function iD(e,t){return t?.length?e?.length?(e.push(...t),e):t:e}function Nhe(e,t){return e?.length?t.length?[...e,...t]:e.slice():eO(t)}function ERe(e,t,n,i){if(!wo(e,t)){i.traceEnabled&&ws(i.host,g.package_json_does_not_have_a_0_field,t);return}let s=e[t];if(typeof s!==n||s===null){i.traceEnabled&&ws(i.host,g.Expected_type_of_0_field_in_package_json_to_be_1_got_2,t,n,s===null?"null":typeof s);return}return s}function OQ(e,t,n,i){let s=ERe(e,t,"string",i);if(s===void 0)return;if(!s){i.traceEnabled&&ws(i.host,g.package_json_had_a_falsy_0_field,t);return}let o=Ca(li(n,s));return i.traceEnabled&&ws(i.host,g.package_json_has_0_field_1_that_references_2,t,s,o),o}function nvt(e,t,n){return OQ(e,"typings",t,n)||OQ(e,"types",t,n)}function ivt(e,t,n){return OQ(e,"tsconfig",t,n)}function svt(e,t,n){return OQ(e,"main",t,n)}function avt(e,t){let n=ERe(e,"typesVersions","object",t);if(n!==void 0)return t.traceEnabled&&ws(t.host,g.package_json_has_a_typesVersions_field_with_version_specific_path_mappings),n}function ovt(e,t){let n=avt(e,t);if(n===void 0)return;if(t.traceEnabled)for(let l in n)wo(n,l)&&!k3.tryParse(l)&&ws(t.host,g.package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range,l);let i=FU(n);if(!i){t.traceEnabled&&ws(t.host,g.package_json_does_not_have_a_typesVersions_entry_that_matches_version_0,w);return}let{version:s,paths:o}=i;if(typeof o!="object"){t.traceEnabled&&ws(t.host,g.Expected_type_of_0_field_in_package_json_to_be_1_got_2,`typesVersions['${s}']`,"object",typeof o);return}return i}function FU(e){qhe||(qhe=new Im(F));for(let t in e){if(!wo(e,t))continue;let n=k3.tryParse(t);if(n!==void 0&&n.test(qhe))return{version:t,paths:e[t]}}}function tO(e,t){if(e.typeRoots)return e.typeRoots;let n;if(e.configFilePath?n=hi(e.configFilePath):t.getCurrentDirectory&&(n=t.getCurrentDirectory()),n!==void 0)return cvt(n)}function cvt(e){let t;return Rm(Ca(e),n=>{let i=li(n,WRe);(t??(t=[])).push(i)}),t}function lvt(e,t,n){let i=typeof n.useCaseSensitiveFileNames=="function"?n.useCaseSensitiveFileNames():n.useCaseSensitiveFileNames;return yy(e,t,!i)===0}function xRe(e,t,n){let i=Tvt(e,t,n),s=lvt(e,i,t);return{resolvedFileName:s?e:i,originalPath:s?void 0:e}}function CRe(e,t,n){let i=Mc(e,"/node_modules/@types")||Mc(e,"/node_modules/@types/")?qRe(t,n):t;return li(e,i)}function Dhe(e,t,n,i,s,o,l){I.assert(typeof e=="string","Non-string value passed to `ts.resolveTypeReferenceDirective`, likely by a wrapping package working with an outdated `resolveTypeReferenceDirectives` signature. This is probably not a problem in TS itself.");let p=wy(n,i);s&&(n=s.commandLine.options);let m=t?hi(t):void 0,S=m?o?.getFromDirectoryCache(e,l,m,s):void 0;if(!S&&m&&!Nu(e)&&(S=o?.getFromNonRelativeNameCache(e,l,m,s)),S)return p&&(ws(i,g.Resolving_type_reference_directive_0_containing_file_1,e,t),s&&ws(i,g.Using_compiler_options_of_project_reference_redirect_0,s.sourceFile.fileName),ws(i,g.Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1,e,m),$(S)),S;let h=tO(n,i);p&&(t===void 0?h===void 0?ws(i,g.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set,e):ws(i,g.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1,e,h):h===void 0?ws(i,g.Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set,e,t):ws(i,g.Resolving_type_reference_directive_0_containing_file_1_root_directory_2,e,t,h),s&&ws(i,g.Using_compiler_options_of_project_reference_redirect_0,s.sourceFile.fileName));let b=[],A=[],k=Ihe(n);l!==void 0&&(k|=30);let N=Q_(n);l===99&&3<=N&&N<=99&&(k|=32);let M=k&8?nS(n,l):[],O=[],U={compilerOptions:n,host:i,traceEnabled:p,failedLookupLocations:b,affectingLocations:A,packageJsonInfoCache:o,features:k,conditions:M,requestContainingDirectory:m,reportDiagnostic:se=>void O.push(se),isConfigLookup:!1,candidateIsFromPackageJsonField:!1,resolvedPackageDirectory:!1},H=pe(),K=!0;H||(H=z(),K=!1);let re;if(H){let{fileName:se,packageId:Se}=H,xe=se,Z;n.preserveSymlinks||({resolvedFileName:xe,originalPath:Z}=xRe(se,i,p)),re={primary:K,resolvedFileName:xe,originalPath:Z,packageId:Se,isExternalLibraryImport:OT(se)}}return S={resolvedTypeReferenceDirective:re,failedLookupLocations:eO(b),affectingLocations:eO(A),resolutionDiagnostics:eO(O)},m&&o&&!o.isReadonly&&(o.getOrCreateCacheForDirectory(m,s).set(e,l,S),Nu(e)||o.getOrCreateCacheForNonRelativeName(e,l,s).set(m,S)),p&&$(S),S;function $(se){var Se;(Se=se.resolvedTypeReferenceDirective)!=null&&Se.resolvedFileName?se.resolvedTypeReferenceDirective.packageId?ws(i,g.Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3,e,se.resolvedTypeReferenceDirective.resolvedFileName,Bv(se.resolvedTypeReferenceDirective.packageId),se.resolvedTypeReferenceDirective.primary):ws(i,g.Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2,e,se.resolvedTypeReferenceDirective.resolvedFileName,se.resolvedTypeReferenceDirective.primary):ws(i,g.Type_reference_directive_0_was_not_resolved,e)}function pe(){if(h&&h.length)return p&&ws(i,g.Resolving_with_primary_search_path_0,h.join(", ")),Ct(h,se=>{let Se=CRe(se,e,U),xe=lg(se,i);if(!xe&&p&&ws(i,g.Directory_0_does_not_exist_skipping_all_lookups_in_it,se),n.typeRoots){let Z=oD(4,Se,!xe,U);if(Z){let Q=fM(Z.path),ce=Q?yE(Q,!1,U):void 0;return Phe(lk(ce,Z))}}return Phe(Bhe(4,Se,!xe,U))});p&&ws(i,g.Root_directory_cannot_be_determined_skipping_primary_search_paths)}function z(){let se=t&&hi(t);if(se!==void 0){let Se;if(!n.typeRoots||!Mc(t,mD))if(p&&ws(i,g.Looking_up_in_node_modules_folder_initial_location_0,se),Nu(e)){let{path:xe}=IRe(se,e);Se=jQ(4,xe,!1,U,!0)}else{let xe=BRe(4,e,se,U,void 0,void 0);Se=xe&&xe.value}else p&&ws(i,g.Resolving_type_reference_directive_for_program_that_specifies_custom_typeRoots_skipping_lookup_in_node_modules_folder);return Phe(Se)}else p&&ws(i,g.Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder)}}function Ihe(e){let t=0;switch(Q_(e)){case 3:t=30;break;case 99:t=30;break;case 100:t=30;break}return e.resolvePackageJsonExports?t|=8:e.resolvePackageJsonExports===!1&&(t&=-9),e.resolvePackageJsonImports?t|=2:e.resolvePackageJsonImports===!1&&(t&=-3),t}function nS(e,t){let n=Q_(e);if(t===void 0){if(n===100)t=99;else if(n===2)return[]}let i=t===99?["import"]:["require"];return e.noDtsResolution||i.push("types"),n!==100&&i.push("node"),ys(i,e.customConditions)}function RQ(e,t,n,i,s){let o=pM(s?.getPackageJsonInfoCache(),i,n);return Rm(t,l=>{if(Cl(l)!=="node_modules"){let p=li(l,"node_modules"),m=li(p,e);return yE(m,!1,o)}})}function jU(e,t){if(e.types)return e.types;let n=[];if(t.directoryExists&&t.getDirectories){let i=tO(e,t);if(i){for(let s of i)if(t.directoryExists(s))for(let o of t.getDirectories(s)){let l=Ca(o),p=li(s,l,"package.json");if(!(t.fileExists(p)&&c6(p,t).typings===null)){let S=Cl(l);S.charCodeAt(0)!==46&&n.push(S)}}}}return n}function BU(e){return!!e?.contents}function whe(e){return!!e&&!e.contents}function Ohe(e){var t;if(e===null||typeof e!="object")return""+e;if(os(e))return`[${(t=e.map(i=>Ohe(i)))==null?void 0:t.join(",")}]`;let n="{";for(let i in e)wo(e,i)&&(n+=`${i}: ${Ohe(e[i])}`);return n+"}"}function MQ(e,t){return t.map(n=>Ohe(Wj(e,n))).join("|")+`|${e.pathsBasePath}`}function LQ(e,t){let n=new Map,i=new Map,s=new Map;return e&&n.set(e,s),{getMapOfCacheRedirects:o,getOrCreateMapOfCacheRedirects:l,update:p,clear:S,getOwnMap:()=>s};function o(b){return b?m(b.commandLine.options,!1):s}function l(b){return b?m(b.commandLine.options,!0):s}function p(b){e!==b&&(e?s=m(b,!0):n.set(b,s),e=b)}function m(b,A){let k=n.get(b);if(k)return k;let N=h(b);if(k=i.get(N),!k){if(e){let M=h(e);M===N?k=s:i.has(M)||i.set(M,s)}A&&(k??(k=new Map)),k&&i.set(N,k)}return k&&n.set(b,k),k}function S(){let b=e&&t.get(e);s.clear(),n.clear(),t.clear(),i.clear(),e&&(b&&t.set(e,b),n.set(e,s))}function h(b){let A=t.get(b);return A||t.set(b,A=MQ(b,DU)),A}}function uvt(e,t){let n;return{getPackageJsonInfo:i,setPackageJsonInfo:s,clear:o,getInternalMap:l};function i(p){return n?.get(gc(p,e,t))}function s(p,m){(n||(n=new Map)).set(gc(p,e,t),m)}function o(){n=void 0}function l(){return n}}function ARe(e,t,n,i){let s=e.getOrCreateMapOfCacheRedirects(t),o=s.get(n);return o||(o=i(),s.set(n,o)),o}function _vt(e,t,n,i){let s=LQ(n,i);return{getFromDirectoryCache:m,getOrCreateCacheForDirectory:p,clear:o,update:l,directoryToModuleNameMap:s};function o(){s.clear()}function l(S){s.update(S)}function p(S,h){let b=gc(S,e,t);return ARe(s,h,b,()=>uk())}function m(S,h,b,A){var k,N;let M=gc(b,e,t);return(N=(k=s.getMapOfCacheRedirects(A))==null?void 0:k.get(M))==null?void 0:N.get(S,h)}}function rO(e,t){return t===void 0?e:`${t}|${e}`}function uk(){let e=new Map,t=new Map,n={get(s,o){return e.get(i(s,o))},set(s,o,l){return e.set(i(s,o),l),n},delete(s,o){return e.delete(i(s,o)),n},has(s,o){return e.has(i(s,o))},forEach(s){return e.forEach((o,l)=>{let[p,m]=t.get(l);return s(o,p,m)})},size(){return e.size}};return n;function i(s,o){let l=rO(s,o);return t.set(l,[s,o]),l}}function fvt(e){return e.resolvedModule&&(e.resolvedModule.originalPath||e.resolvedModule.resolvedFileName)}function pvt(e){return e.resolvedTypeReferenceDirective&&(e.resolvedTypeReferenceDirective.originalPath||e.resolvedTypeReferenceDirective.resolvedFileName)}function dvt(e,t,n,i,s){let o=LQ(n,s);return{getFromNonRelativeNameCache:m,getOrCreateCacheForNonRelativeName:S,clear:l,update:p};function l(){o.clear()}function p(b){o.update(b)}function m(b,A,k,N){var M,O;return I.assert(!Nu(b)),(O=(M=o.getMapOfCacheRedirects(N))==null?void 0:M.get(rO(b,A)))==null?void 0:O.get(k)}function S(b,A,k){return I.assert(!Nu(b)),ARe(o,k,rO(b,A),h)}function h(){let b=new Map;return{get:A,set:k};function A(M){return b.get(gc(M,e,t))}function k(M,O){let U=gc(M,e,t);if(b.has(U))return;b.set(U,O);let H=i(O),K=H&&N(U,H),re=U;for(;re!==K;){let $=hi(re);if($===re||b.has($))break;b.set($,O),re=$}}function N(M,O){let U=gc(hi(O),e,t),H=0,K=Math.min(M.length,U.length);for(;H<K&&M.charCodeAt(H)===U.charCodeAt(H);)H++;if(H===M.length&&(U.length===H||U[H]===hc))return M;let re=wh(M);if(H<re)return;let $=M.lastIndexOf(hc,H-1);if($!==-1)return M.substr(0,Math.max($,re))}}}function kRe(e,t,n,i,s,o){o??(o=new Map);let l=_vt(e,t,n,o),p=dvt(e,t,n,s,o);return i??(i=uvt(e,t)),{...i,...l,...p,clear:m,update:h,getPackageJsonInfoCache:()=>i,clearAllExceptPackageJsonInfoCache:S,optionsToRedirectsKey:o};function m(){S(),i.clear()}function S(){l.clear(),p.clear()}function h(b){l.update(b),p.update(b)}}function sD(e,t,n,i,s){let o=kRe(e,t,n,i,fvt,s);return o.getOrCreateCacheForModuleName=(l,p,m)=>o.getOrCreateCacheForNonRelativeName(l,p,m),o}function UU(e,t,n,i,s){return kRe(e,t,n,i,pvt,s)}function FQ(e){return{moduleResolution:2,traceResolution:e.traceResolution}}function VU(e,t,n,i,s){return aD(e,t,FQ(n),i,s)}function PRe(e,t,n,i){let s=hi(t);return n.getFromDirectoryCache(e,i,s,void 0)}function aD(e,t,n,i,s,o,l){var p,m,S;let h=wy(n,i);o&&(n=o.commandLine.options),h&&(ws(i,g.Resolving_module_0_from_1,e,t),o&&ws(i,g.Using_compiler_options_of_project_reference_redirect_0,o.sourceFile.fileName));let b=hi(t),A=s?.getFromDirectoryCache(e,l,b,o);if(A)h&&ws(i,g.Resolution_for_module_0_was_found_in_cache_from_location_1,e,b);else{let k=n.moduleResolution;switch(k===void 0?(k=Q_(n),h&&ws(i,g.Module_resolution_kind_is_not_specified_using_0,JP[k])):h&&ws(i,g.Explicitly_specified_module_resolution_kind_Colon_0,JP[k]),(p=z_)==null||p.logStartResolveModule(e),k){case 3:A=yvt(e,t,n,i,s,o,l);break;case 99:A=vvt(e,t,n,i,s,o,l);break;case 2:A=Lhe(e,t,n,i,s,o,l?nS(n,l):void 0);break;case 1:A=Vhe(e,t,n,i,s,o);break;case 100:A=Mhe(e,t,n,i,s,o,l?nS(n,l):void 0);break;default:return I.fail(`Unexpected moduleResolution: ${k}`)}A&&A.resolvedModule&&((m=z_)==null||m.logInfoEvent(`Module "${e}" resolved to "${A.resolvedModule.resolvedFileName}"`)),(S=z_)==null||S.logStopResolveModule(A&&A.resolvedModule?""+A.resolvedModule.resolvedFileName:"null"),s&&!s.isReadonly&&(s.getOrCreateCacheForDirectory(b,o).set(e,l,A),Nu(e)||s.getOrCreateCacheForNonRelativeName(e,l,o).set(b,A))}return h&&(A.resolvedModule?A.resolvedModule.packageId?ws(i,g.Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2,e,A.resolvedModule.resolvedFileName,Bv(A.resolvedModule.packageId)):ws(i,g.Module_name_0_was_successfully_resolved_to_1,e,A.resolvedModule.resolvedFileName):ws(i,g.Module_name_0_was_not_resolved,e)),A}function NRe(e,t,n,i,s){let o=mvt(e,t,i,s);return o?o.value:Nu(t)?gvt(e,t,n,i,s):hvt(e,t,i,s)}function mvt(e,t,n,i){var s;let{baseUrl:o,paths:l,configFile:p}=i.compilerOptions;if(l&&!Fp(t)){i.traceEnabled&&(o&&ws(i.host,g.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1,o,t),ws(i.host,g.paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0,t));let m=kj(i.compilerOptions,i.host),S=p?.configFileSpecs?(s=p.configFileSpecs).pathPatterns||(s.pathPatterns=tB(l)):void 0;return Uhe(e,t,m,l,S,n,!1,i)}}function gvt(e,t,n,i,s){if(!s.compilerOptions.rootDirs)return;s.traceEnabled&&ws(s.host,g.rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0,t);let o=Ca(li(n,t)),l,p;for(let m of s.compilerOptions.rootDirs){let S=Ca(m);Mc(S,hc)||(S+=hc);let h=Ss(o,S)&&(p===void 0||p.length<S.length);s.traceEnabled&&ws(s.host,g.Checking_if_0_is_the_longest_matching_prefix_for_1_2,S,o,h),h&&(p=S,l=m)}if(p){s.traceEnabled&&ws(s.host,g.Longest_matching_prefix_for_0_is_1,o,p);let m=o.substr(p.length);s.traceEnabled&&ws(s.host,g.Loading_0_from_the_root_dir_1_candidate_location_2,m,p,o);let S=i(e,o,!lg(n,s.host),s);if(S)return S;s.traceEnabled&&ws(s.host,g.Trying_other_entries_in_rootDirs);for(let h of s.compilerOptions.rootDirs){if(h===l)continue;let b=li(Ca(h),m);s.traceEnabled&&ws(s.host,g.Loading_0_from_the_root_dir_1_candidate_location_2,m,h,b);let A=hi(b),k=i(e,b,!lg(A,s.host),s);if(k)return k}s.traceEnabled&&ws(s.host,g.Module_resolution_using_rootDirs_has_failed)}}function hvt(e,t,n,i){let{baseUrl:s}=i.compilerOptions;if(!s)return;i.traceEnabled&&ws(i.host,g.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1,s,t);let o=Ca(li(s,t));return i.traceEnabled&&ws(i.host,g.Resolving_module_name_0_relative_to_base_url_1_2,t,s,o),n(e,o,!lg(hi(o),i.host),i)}function Rhe(e,t,n){let{resolvedModule:i,failedLookupLocations:s}=Svt(e,t,n);if(!i)throw new Error(`Could not resolve JS module '${e}' starting at '${t}'. Looked in: ${s?.join(", ")}`);return i.resolvedFileName}function yvt(e,t,n,i,s,o,l){return DRe(30,e,t,n,i,s,o,l)}function vvt(e,t,n,i,s,o,l){return DRe(30,e,t,n,i,s,o,l)}function DRe(e,t,n,i,s,o,l,p,m){let S=hi(n),h=p===99?32:0,b=i.noDtsResolution?3:7;return xT(i)&&(b|=8),_M(e|h,t,S,i,s,o,b,!1,l,m)}function Svt(e,t,n){return _M(0,e,t,{moduleResolution:2,allowJs:!0},n,void 0,2,!1,void 0,void 0)}function Mhe(e,t,n,i,s,o,l){let p=hi(t),m=n.noDtsResolution?3:7;return xT(n)&&(m|=8),_M(Ihe(n),e,p,n,i,s,m,!1,o,l)}function Lhe(e,t,n,i,s,o,l,p){let m;return p?m=8:n.noDtsResolution?(m=3,xT(n)&&(m|=8)):m=xT(n)?15:7,_M(l?30:0,e,hi(t),n,i,s,m,!!p,o,l)}function Fhe(e,t,n){return _M(30,e,hi(t),{moduleResolution:99},n,void 0,8,!0,void 0,void 0)}function _M(e,t,n,i,s,o,l,p,m,S){var h,b,A,k,N;let M=wy(i,s),O=[],U=[],H=Q_(i);S??(S=nS(i,H===100||H===2?void 0:e&32?99:1));let K=[],re={compilerOptions:i,host:s,traceEnabled:M,failedLookupLocations:O,affectingLocations:U,packageJsonInfoCache:o,features:e,conditions:S??tt,requestContainingDirectory:n,reportDiagnostic:se=>void K.push(se),isConfigLookup:p,candidateIsFromPackageJsonField:!1,resolvedPackageDirectory:!1};M&&MA(H)&&ws(s,g.Resolving_in_0_mode_with_conditions_1,e&32?"ESM":"CJS",re.conditions.map(se=>`'${se}'`).join(", "));let $;if(H===2){let se=l&5,Se=l&-6;$=se&&z(se,re)||Se&&z(Se,re)||void 0}else $=z(l,re);let pe;if(re.resolvedPackageDirectory&&!p&&!Nu(t)){let se=$?.value&&l&5&&!LRe(5,$.value.resolved.extension);if((h=$?.value)!=null&&h.isExternalLibraryImport&&se&&e&8&&S?.includes("import")){iS(re,g.Resolution_of_non_relative_name_failed_trying_with_modern_Node_resolution_features_disabled_to_see_if_npm_library_needs_configuration_update);let Se={...re,features:re.features&-9,reportDiagnostic:ja},xe=z(l&5,Se);(b=xe?.value)!=null&&b.isExternalLibraryImport&&(pe=xe.value.resolved.path)}else if((!$?.value||se)&&H===2){iS(re,g.Resolution_of_non_relative_name_failed_trying_with_moduleResolution_bundler_to_see_if_project_may_need_configuration_update);let Se={...re.compilerOptions,moduleResolution:100},xe={...re,compilerOptions:Se,features:30,conditions:nS(Se),reportDiagnostic:ja},Z=z(l&5,xe);(A=Z?.value)!=null&&A.isExternalLibraryImport&&(pe=Z.value.resolved.path)}}return TRe(t,(k=$?.value)==null?void 0:k.resolved,(N=$?.value)==null?void 0:N.isExternalLibraryImport,O,U,K,re,o,pe);function z(se,Se){let Z=NRe(se,t,n,(Q,ce,ye,we)=>jQ(Q,ce,ye,we,!0),Se);if(Z)return od({resolved:Z,isExternalLibraryImport:OT(Z.path)});if(Nu(t)){let{path:Q,parts:ce}=IRe(n,t),ye=jQ(se,Q,!1,Se,!0);return ye&&od({resolved:ye,isExternalLibraryImport:hs(ce,"node_modules")})}else{let Q;if(e&2&&Ss(t,"#")&&(Q=Cvt(se,t,n,Se,o,m)),!Q&&e&4&&(Q=xvt(se,t,n,Se,o,m)),!Q){if(t.includes(":")){M&&ws(s,g.Skipping_module_0_that_looks_like_an_absolute_URI_target_file_types_Colon_1,t,LU(se));return}M&&ws(s,g.Loading_module_0_from_node_modules_folder_target_file_types_Colon_1,t,LU(se)),Q=BRe(se,t,n,Se,o,m)}return se&4&&(Q??(Q=$Re(t,Se))),Q&&{value:Q.value&&{resolved:Q.value,isExternalLibraryImport:!0}}}}}function IRe(e,t){let n=li(e,t),i=gu(n),s=Is(i);return{path:s==="."||s===".."?hu(Ca(n)):Ca(n),parts:i}}function Tvt(e,t,n){if(!t.realpath)return e;let i=Ca(t.realpath(e));return n&&ws(t,g.Resolving_real_path_for_0_result_1,e,i),i}function jQ(e,t,n,i,s){if(i.traceEnabled&&ws(i.host,g.Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_types_Colon_1,t,LU(e)),!b1(t)){if(!n){let l=hi(t);lg(l,i.host)||(i.traceEnabled&&ws(i.host,g.Directory_0_does_not_exist_skipping_all_lookups_in_it,l),n=!0)}let o=oD(e,t,n,i);if(o){let l=s?fM(o.path):void 0,p=l?yE(l,!1,i):void 0;return lk(p,o)}}if(n||lg(t,i.host)||(i.traceEnabled&&ws(i.host,g.Directory_0_does_not_exist_skipping_all_lookups_in_it,t),n=!0),!(i.features&32))return Bhe(e,t,n,i,s)}function OT(e){return e.includes(Wh)}function fM(e,t){let n=Ca(e),i=n.lastIndexOf(Wh);if(i===-1)return;let s=i+Wh.length,o=wRe(n,s,t);return n.charCodeAt(s)===64&&(o=wRe(n,o,t)),n.slice(0,o)}function wRe(e,t,n){let i=e.indexOf(hc,t+1);return i===-1?n?e.length:t:i}function jhe(e,t,n,i){return wQ(oD(e,t,n,i))}function oD(e,t,n,i){let s=ORe(e,t,n,i);if(s)return s;if(!(i.features&32)){let o=RRe(t,e,"",n,i);if(o)return o}}function ORe(e,t,n,i){if(!Cl(t).includes("."))return;let o=ff(t);o===t&&(o=t.substring(0,t.lastIndexOf(".")));let l=t.substring(o.length);return i.traceEnabled&&ws(i.host,g.File_name_0_has_a_1_extension_stripping_it,t,l),RRe(o,e,l,n,i)}function BQ(e,t,n,i){return e&1&&Ql(t,vR)||e&4&&Ql(t,yR)?UQ(t,n,i)!==void 0?{path:t,ext:Mj(t),resolvedUsingTsExtension:void 0}:void 0:i.isConfigLookup&&e===8&&Uc(t,".json")?UQ(t,n,i)!==void 0?{path:t,ext:".json",resolvedUsingTsExtension:void 0}:void 0:ORe(e,t,n,i)}function RRe(e,t,n,i,s){if(!i){let l=hi(e);l&&(i=!lg(l,s.host))}switch(n){case".mjs":case".mts":case".d.mts":return t&1&&o(".mts",n===".mts"||n===".d.mts")||t&4&&o(".d.mts",n===".mts"||n===".d.mts")||t&2&&o(".mjs")||void 0;case".cjs":case".cts":case".d.cts":return t&1&&o(".cts",n===".cts"||n===".d.cts")||t&4&&o(".d.cts",n===".cts"||n===".d.cts")||t&2&&o(".cjs")||void 0;case".json":return t&4&&o(".d.json.ts")||t&8&&o(".json")||void 0;case".tsx":case".jsx":return t&1&&(o(".tsx",n===".tsx")||o(".ts",n===".tsx"))||t&4&&o(".d.ts",n===".tsx")||t&2&&(o(".jsx")||o(".js"))||void 0;case".ts":case".d.ts":case".js":case"":return t&1&&(o(".ts",n===".ts"||n===".d.ts")||o(".tsx",n===".ts"||n===".d.ts"))||t&4&&o(".d.ts",n===".ts"||n===".d.ts")||t&2&&(o(".js")||o(".jsx"))||s.isConfigLookup&&o(".json")||void 0;default:return t&4&&!i_(e+n)&&o(`.d${n}.ts`)||void 0}function o(l,p){let m=UQ(e+l,i,s);return m===void 0?void 0:{path:m,ext:l,resolvedUsingTsExtension:!s.candidateIsFromPackageJsonField&&p}}}function UQ(e,t,n){var i;if(!((i=n.compilerOptions.moduleSuffixes)!=null&&i.length))return MRe(e,t,n);let s=Py(e)??"",o=s?lR(e,s):e;return Te(n.compilerOptions.moduleSuffixes,l=>MRe(o+l+s,t,n))}function MRe(e,t,n){var i;if(!t){if(n.host.fileExists(e))return n.traceEnabled&&ws(n.host,g.File_0_exists_use_it_as_a_name_resolution_result,e),e;n.traceEnabled&&ws(n.host,g.File_0_does_not_exist,e)}(i=n.failedLookupLocations)==null||i.push(e)}function Bhe(e,t,n,i,s=!0){let o=s?yE(t,n,i):void 0,l=o&&o.contents.packageJsonContent,p=o&&JU(o,i);return lk(o,JQ(e,t,n,i,l,p))}function VQ(e,t,n,i,s){if(!s&&e.contents.resolvedEntrypoints!==void 0)return e.contents.resolvedEntrypoints;let o,l=5|(s?2:0),p=Ihe(t),m=pM(i?.getPackageJsonInfoCache(),n,t);m.conditions=nS(t),m.requestContainingDirectory=e.packageDirectory;let S=JQ(l,e.packageDirectory,!1,m,e.contents.packageJsonContent,JU(e,m));if(o=Pr(o,S?.path),p&8&&e.contents.packageJsonContent.exports){let h=Dh([nS(t,99),nS(t,1)],td);for(let b of h){let A={...m,failedLookupLocations:[],conditions:b,host:n},k=bvt(e,e.contents.packageJsonContent.exports,A,l);if(k)for(let N of k)o=ai(o,N.path)}}return e.contents.resolvedEntrypoints=o||!1}function bvt(e,t,n,i){let s;if(os(t))for(let l of t)o(l);else if(typeof t=="object"&&t!==null&&qU(t))for(let l in t)o(t[l]);else o(t);return s;function o(l){var p,m;if(typeof l=="string"&&Ss(l,"./"))if(l.includes("*")&&n.host.readDirectory){if(l.indexOf("*")!==l.lastIndexOf("*"))return!1;n.host.readDirectory(e.packageDirectory,rvt(i),void 0,[Jfe(jA(l,"**/*"),".*")]).forEach(S=>{s=ai(s,{path:S,ext:qP(S),resolvedUsingTsExtension:void 0})})}else{let S=gu(l).slice(2);if(S.includes("..")||S.includes(".")||S.includes("node_modules"))return!1;let h=li(e.packageDirectory,l),b=Ps(h,(m=(p=n.host).getCurrentDirectory)==null?void 0:m.call(p)),A=BQ(i,b,!1,n);if(A)return s=ai(s,A,(k,N)=>k.path===N.path),!0}else if(Array.isArray(l)){for(let S of l)if(o(S))return!0}else if(typeof l=="object"&&l!==null)return Te(Vt(l),S=>{if(S==="default"||hs(n.conditions,S)||gM(n.conditions,S))return o(l[S]),!0})}}function pM(e,t,n){return{host:t,compilerOptions:n,traceEnabled:wy(n,t),failedLookupLocations:void 0,affectingLocations:void 0,packageJsonInfoCache:e,features:0,conditions:tt,requestContainingDirectory:void 0,reportDiagnostic:ja,isConfigLookup:!1,candidateIsFromPackageJsonField:!1,resolvedPackageDirectory:!1}}function dM(e,t){let n=gu(e);for(n.pop();n.length>0;){let i=yE(Nv(n),!1,t);if(i)return i;n.pop()}}function JU(e,t){return e.contents.versionPaths===void 0&&(e.contents.versionPaths=ovt(e.contents.packageJsonContent,t)||!1),e.contents.versionPaths||void 0}function yE(e,t,n){var i,s,o,l,p,m;let{host:S,traceEnabled:h}=n,b=li(e,"package.json");if(t){(i=n.failedLookupLocations)==null||i.push(b);return}let A=(s=n.packageJsonInfoCache)==null?void 0:s.getPackageJsonInfo(b);if(A!==void 0){if(BU(A))return h&&ws(S,g.File_0_exists_according_to_earlier_cached_lookups,b),(o=n.affectingLocations)==null||o.push(b),A.packageDirectory===e?A:{packageDirectory:e,contents:A.contents};A.directoryExists&&h&&ws(S,g.File_0_does_not_exist_according_to_earlier_cached_lookups,b),(l=n.failedLookupLocations)==null||l.push(b);return}let k=lg(e,S);if(k&&S.fileExists(b)){let N=c6(b,S);h&&ws(S,g.Found_package_json_at_0,b);let M={packageDirectory:e,contents:{packageJsonContent:N,versionPaths:void 0,resolvedEntrypoints:void 0}};return n.packageJsonInfoCache&&!n.packageJsonInfoCache.isReadonly&&n.packageJsonInfoCache.setPackageJsonInfo(b,M),(p=n.affectingLocations)==null||p.push(b),M}else k&&h&&ws(S,g.File_0_does_not_exist,b),n.packageJsonInfoCache&&!n.packageJsonInfoCache.isReadonly&&n.packageJsonInfoCache.setPackageJsonInfo(b,{packageDirectory:e,directoryExists:k}),(m=n.failedLookupLocations)==null||m.push(b)}function JQ(e,t,n,i,s,o){let l;s&&(i.isConfigLookup?l=ivt(s,t,i):l=e&4&&nvt(s,t,i)||e&7&&svt(s,t,i)||void 0);let p=(A,k,N,M)=>{let O=BQ(A,k,N,M);if(O)return wQ(O);let U=A===4?5:A,H=M.features,K=M.candidateIsFromPackageJsonField;M.candidateIsFromPackageJsonField=!0,s?.type!=="module"&&(M.features&=-33);let re=jQ(U,k,N,M,!1);return M.features=H,M.candidateIsFromPackageJsonField=K,re},m=l?!lg(hi(l),i.host):void 0,S=n||!lg(t,i.host),h=li(t,i.isConfigLookup?"tsconfig":"index");if(o&&(!l||wm(t,l))){let A=Om(t,l||h,!1);i.traceEnabled&&ws(i.host,g.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2,o.version,F,A);let k=Uhe(e,A,t,o.paths,void 0,p,m||S,i);if(k)return SRe(k.value)}let b=l&&SRe(p(e,l,m,i));if(b)return b;if(!(i.features&32))return oD(e,h,S,i)}function LRe(e,t){return e&2&&(t===".js"||t===".jsx"||t===".mjs"||t===".cjs")||e&1&&(t===".ts"||t===".tsx"||t===".mts"||t===".cts")||e&4&&(t===".d.ts"||t===".d.mts"||t===".d.cts")||e&8&&t===".json"||!1}function mM(e){let t=e.indexOf(hc);return e[0]==="@"&&(t=e.indexOf(hc,t+1)),t===-1?{packageName:e,rest:""}:{packageName:e.slice(0,t),rest:e.slice(t+1)}}function qU(e){return yr(Vt(e),t=>Ss(t,"."))}function Evt(e){return!Tt(Vt(e),t=>Ss(t,"."))}function xvt(e,t,n,i,s,o){var l,p;let m=Ps(li(n,"dummy"),(p=(l=i.host).getCurrentDirectory)==null?void 0:p.call(l)),S=dM(m,i);if(!S||!S.contents.packageJsonContent.exports||typeof S.contents.packageJsonContent.name!="string")return;let h=gu(t),b=gu(S.contents.packageJsonContent.name);if(!yr(b,(O,U)=>h[U]===O))return;let A=h.slice(b.length),k=de(A)?`.${hc}${A.join(hc)}`:".";if(Hv(i.compilerOptions)&&!OT(n))return qQ(S,e,k,i,s,o);let N=e&5,M=e&-6;return qQ(S,N,k,i,s,o)||qQ(S,M,k,i,s,o)}function qQ(e,t,n,i,s,o){if(e.contents.packageJsonContent.exports){if(n==="."){let l;if(typeof e.contents.packageJsonContent.exports=="string"||Array.isArray(e.contents.packageJsonContent.exports)||typeof e.contents.packageJsonContent.exports=="object"&&Evt(e.contents.packageJsonContent.exports)?l=e.contents.packageJsonContent.exports:wo(e.contents.packageJsonContent.exports,".")&&(l=e.contents.packageJsonContent.exports["."]),l)return jRe(t,i,s,o,n,e,!1)(l,"",!1,".")}else if(qU(e.contents.packageJsonContent.exports)){if(typeof e.contents.packageJsonContent.exports!="object")return i.traceEnabled&&ws(i.host,g.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1,n,e.packageDirectory),od(void 0);let l=FRe(t,i,s,o,n,e.contents.packageJsonContent.exports,e,!1);if(l)return l}return i.traceEnabled&&ws(i.host,g.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1,n,e.packageDirectory),od(void 0)}}function Cvt(e,t,n,i,s,o){var l,p;if(t==="#"||Ss(t,"#/"))return i.traceEnabled&&ws(i.host,g.Invalid_import_specifier_0_has_no_possible_resolutions,t),od(void 0);let m=Ps(li(n,"dummy"),(p=(l=i.host).getCurrentDirectory)==null?void 0:p.call(l)),S=dM(m,i);if(!S)return i.traceEnabled&&ws(i.host,g.Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve,m),od(void 0);if(!S.contents.packageJsonContent.imports)return i.traceEnabled&&ws(i.host,g.package_json_scope_0_has_no_imports_defined,S.packageDirectory),od(void 0);let h=FRe(e,i,s,o,t,S.contents.packageJsonContent.imports,S,!0);return h||(i.traceEnabled&&ws(i.host,g.Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1,t,S.packageDirectory),od(void 0))}function zQ(e,t){let n=e.indexOf("*"),i=t.indexOf("*"),s=n===-1?e.length:n+1,o=i===-1?t.length:i+1;return s>o?-1:o>s||n===-1?1:i===-1||e.length>t.length?-1:t.length>e.length?1:0}function FRe(e,t,n,i,s,o,l,p){let m=jRe(e,t,n,i,s,l,p);if(!Mc(s,hc)&&!s.includes("*")&&wo(o,s)){let b=o[s];return m(b,"",!1,s)}let S=Fa(Fn(Vt(o),b=>b.includes("*")||Mc(b,"/")),zQ);for(let b of S)if(t.features&16&&h(b,s)){let A=o[b],k=b.indexOf("*"),N=s.substring(b.substring(0,k).length,s.length-(b.length-1-k));return m(A,N,!0,b)}else if(Mc(b,"*")&&Ss(s,b.substring(0,b.length-1))){let A=o[b],k=s.substring(b.length-1);return m(A,k,!0,b)}else if(Ss(s,b)){let A=o[b],k=s.substring(b.length);return m(A,k,!1,b)}function h(b,A){if(Mc(b,"*"))return!1;let k=b.indexOf("*");return k===-1?!1:Ss(A,b.substring(0,k))&&Mc(A,b.substring(k+1))}}function jRe(e,t,n,i,s,o,l){return p;function p(m,S,h,b){if(typeof m=="string"){if(!h&&S.length>0&&!Mc(m,"/"))return t.traceEnabled&&ws(t.host,g.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),od(void 0);if(!Ss(m,"./")){if(l&&!Ss(m,"../")&&!Ss(m,"/")&&!ap(m)){let $=h?m.replace(/\*/g,S):m+S;iS(t,g.Using_0_subpath_1_with_target_2,"imports",b,$),iS(t,g.Resolving_module_0_from_1,$,o.packageDirectory+"/");let pe=_M(t.features,$,o.packageDirectory+"/",t.compilerOptions,t.host,n,e,!1,i,t.conditions);return od(pe.resolvedModule?{path:pe.resolvedModule.resolvedFileName,extension:pe.resolvedModule.extension,packageId:pe.resolvedModule.packageId,originalPath:pe.resolvedModule.originalPath,resolvedUsingTsExtension:pe.resolvedModule.resolvedUsingTsExtension}:void 0)}return t.traceEnabled&&ws(t.host,g.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),od(void 0)}let O=(Fp(m)?gu(m).slice(1):gu(m)).slice(1);if(O.includes("..")||O.includes(".")||O.includes("node_modules"))return t.traceEnabled&&ws(t.host,g.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),od(void 0);let U=li(o.packageDirectory,m),H=gu(S);if(H.includes("..")||H.includes(".")||H.includes("node_modules"))return t.traceEnabled&&ws(t.host,g.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),od(void 0);t.traceEnabled&&ws(t.host,g.Using_0_subpath_1_with_target_2,l?"imports":"exports",b,h?m.replace(/\*/g,S):m+S);let K=A(h?U.replace(/\*/g,S):U+S),re=N(K,S,li(o.packageDirectory,"package.json"),l);return re||od(lk(o,BQ(e,K,!1,t)))}else if(typeof m=="object"&&m!==null)if(Array.isArray(m)){if(!de(m))return t.traceEnabled&&ws(t.host,g.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),od(void 0);for(let M of m){let O=p(M,S,h,b);if(O)return O}}else{iS(t,g.Entering_conditional_exports);for(let M of Vt(m))if(M==="default"||t.conditions.includes(M)||gM(t.conditions,M)){iS(t,g.Matched_0_condition_1,l?"imports":"exports",M);let O=m[M],U=p(O,S,h,b);if(U)return iS(t,g.Resolved_under_condition_0,M),iS(t,g.Exiting_conditional_exports),U;iS(t,g.Failed_to_resolve_under_condition_0,M)}else iS(t,g.Saw_non_matching_condition_0,M);iS(t,g.Exiting_conditional_exports);return}else if(m===null)return t.traceEnabled&&ws(t.host,g.package_json_scope_0_explicitly_maps_specifier_1_to_null,o.packageDirectory,s),od(void 0);return t.traceEnabled&&ws(t.host,g.package_json_scope_0_has_invalid_type_for_target_of_specifier_1,o.packageDirectory,s),od(void 0);function A(M){var O,U;return M===void 0?M:Ps(M,(U=(O=t.host).getCurrentDirectory)==null?void 0:U.call(O))}function k(M,O){return hu(li(M,O))}function N(M,O,U,H){var K,re,$,pe;if(!t.isConfigLookup&&(t.compilerOptions.declarationDir||t.compilerOptions.outDir)&&!M.includes("/node_modules/")&&(!t.compilerOptions.configFile||wm(o.packageDirectory,A(t.compilerOptions.configFile.fileName),!$Q(t)))){let se=N1({useCaseSensitiveFileNames:()=>$Q(t)}),Se=[];if(t.compilerOptions.rootDir||t.compilerOptions.composite&&t.compilerOptions.configFilePath){let xe=A(gO(t.compilerOptions,()=>[],((re=(K=t.host).getCurrentDirectory)==null?void 0:re.call(K))||"",se));Se.push(xe)}else if(t.requestContainingDirectory){let xe=A(li(t.requestContainingDirectory,"index.ts")),Z=A(gO(t.compilerOptions,()=>[xe,A(U)],((pe=($=t.host).getCurrentDirectory)==null?void 0:pe.call($))||"",se));Se.push(Z);let Q=hu(Z);for(;Q&&Q.length>1;){let ce=gu(Q);ce.pop();let ye=Nv(ce);Se.unshift(ye),Q=hu(ye)}}Se.length>1&&t.reportDiagnostic(fl(H?g.The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate:g.The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate,O===""?".":O,U));for(let xe of Se){let Z=z(xe);for(let Q of Z)if(wm(Q,M,!$Q(t))){let ce=M.slice(Q.length+1),ye=li(xe,ce),we=[".mjs",".cjs",".js",".json",".d.mts",".d.cts",".d.ts"];for(let ve of we)if(Uc(ye,ve)){let oe=Vde(ye);for(let Ee of oe){if(!LRe(e,Ee))continue;let Me=F3(ye,Ee,ve,!$Q(t));if(t.host.fileExists(Me))return od(lk(o,BQ(e,Me,!1,t)))}}}}}return;function z(se){var Se,xe;let Z=t.compilerOptions.configFile?((xe=(Se=t.host).getCurrentDirectory)==null?void 0:xe.call(Se))||"":se,Q=[];return t.compilerOptions.declarationDir&&Q.push(A(k(Z,t.compilerOptions.declarationDir))),t.compilerOptions.outDir&&t.compilerOptions.outDir!==t.compilerOptions.declarationDir&&Q.push(A(k(Z,t.compilerOptions.outDir))),Q}}}}function gM(e,t){if(!e.includes("types")||!Ss(t,"types@"))return!1;let n=k3.tryParse(t.substring(6));return n?n.test(F):!1}function BRe(e,t,n,i,s,o){return URe(e,t,n,i,!1,s,o)}function Avt(e,t,n){return URe(4,e,t,n,!0,void 0,void 0)}function URe(e,t,n,i,s,o,l){let p=i.features===0?void 0:i.features&32?99:1,m=e&5,S=e&-6;if(m){iS(i,g.Searching_all_ancestor_node_modules_directories_for_preferred_extensions_Colon_0,LU(m));let b=h(m);if(b)return b}if(S&&!s)return iS(i,g.Searching_all_ancestor_node_modules_directories_for_fallback_extensions_Colon_0,LU(S)),h(S);function h(b){return Rm(v_(n),A=>{if(Cl(A)!=="node_modules"){let k=zRe(o,t,p,A,l,i);return k||od(VRe(b,t,A,i,s,o,l))}})}}function VRe(e,t,n,i,s,o,l){let p=li(n,"node_modules"),m=lg(p,i.host);if(!m&&i.traceEnabled&&ws(i.host,g.Directory_0_does_not_exist_skipping_all_lookups_in_it,p),!s){let S=JRe(e,t,p,m,i,o,l);if(S)return S}if(e&4){let S=li(p,"@types"),h=m;return m&&!lg(S,i.host)&&(i.traceEnabled&&ws(i.host,g.Directory_0_does_not_exist_skipping_all_lookups_in_it,S),h=!1),JRe(4,qRe(t,i),S,h,i,o,l)}}function JRe(e,t,n,i,s,o,l){var p,m;let S=Ca(li(n,t)),{packageName:h,rest:b}=mM(t),A=li(n,h),k,N=yE(S,!i,s);if(b!==""&&N&&(!(s.features&8)||!wo(((p=k=yE(A,!i,s))==null?void 0:p.contents.packageJsonContent)??tt,"exports"))){let U=oD(e,S,!i,s);if(U)return wQ(U);let H=JQ(e,S,!i,s,N.contents.packageJsonContent,JU(N,s));return lk(N,H)}let M=(U,H,K,re)=>{let $=(b||!(re.features&32))&&oD(U,H,K,re)||JQ(U,H,K,re,N&&N.contents.packageJsonContent,N&&JU(N,re));return!$&&N&&(N.contents.packageJsonContent.exports===void 0||N.contents.packageJsonContent.exports===null)&&re.features&32&&($=oD(U,li(H,"index.js"),K,re)),lk(N,$)};if(b!==""&&(N=k??yE(A,!i,s)),N&&(s.resolvedPackageDirectory=!0),N&&N.contents.packageJsonContent.exports&&s.features&8)return(m=qQ(N,e,li(".",b),s,o,l))==null?void 0:m.value;let O=b!==""&&N?JU(N,s):void 0;if(O){s.traceEnabled&&ws(s.host,g.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2,O.version,F,b);let U=i&&lg(A,s.host),H=Uhe(e,b,A,O.paths,void 0,M,!U,s);if(H)return H.value}return M(e,S,!i,s)}function Uhe(e,t,n,i,s,o,l,p){s||(s=tB(i));let m=qX(s,t);if(m){let S=vs(m)?void 0:bfe(m,t),h=vs(m)?m:Tfe(m);return p.traceEnabled&&ws(p.host,g.Module_name_0_matched_pattern_1,t,h),{value:Te(i[h],A=>{let k=S?jA(A,S):A,N=Ca(li(n,k));p.traceEnabled&&ws(p.host,g.Trying_substitution_0_candidate_module_location_Colon_1,A,k);let M=Py(A);if(M!==void 0){let O=UQ(N,l,p);if(O!==void 0)return wQ({path:O,ext:M,resolvedUsingTsExtension:void 0})}return o(e,N,l||!lg(hi(N),p.host),p)})}}}function qRe(e,t){let n=cD(e);return t.traceEnabled&&n!==e&&ws(t.host,g.Scoped_package_detected_looking_in_0,n),n}function zU(e){return`@types/${cD(e)}`}function cD(e){if(Ss(e,"@")){let t=e.replace(hc,GQ);if(t!==e)return t.slice(1)}return e}function nO(e){let t=hw(e,"@types/");return t!==e?hM(t):e}function hM(e){return e.includes(GQ)?"@"+e.replace(GQ,hc):e}function zRe(e,t,n,i,s,o){let l=e&&e.getFromNonRelativeNameCache(t,n,i,s);if(l)return o.traceEnabled&&ws(o.host,g.Resolution_for_module_0_was_found_in_cache_from_location_1,t,i),o.resultFromCache=l,{value:l.resolvedModule&&{path:l.resolvedModule.resolvedFileName,originalPath:l.resolvedModule.originalPath||!0,extension:l.resolvedModule.extension,packageId:l.resolvedModule.packageId,resolvedUsingTsExtension:l.resolvedModule.resolvedUsingTsExtension}}}function Vhe(e,t,n,i,s,o){let l=wy(n,i),p=[],m=[],S=hi(t),h=[],b={compilerOptions:n,host:i,traceEnabled:l,failedLookupLocations:p,affectingLocations:m,packageJsonInfoCache:s,features:0,conditions:[],requestContainingDirectory:S,reportDiagnostic:N=>void h.push(N),isConfigLookup:!1,candidateIsFromPackageJsonField:!1,resolvedPackageDirectory:!1},A=k(5)||k(2|(n.resolveJsonModule?8:0));return TRe(e,A&&A.value,A?.value&&OT(A.value.path),p,m,h,b,s);function k(N){let M=NRe(N,e,S,jhe,b);if(M)return{value:M};if(Nu(e)){let O=Ca(li(S,e));return od(jhe(N,O,!1,b))}else{let O=Rm(S,U=>{let H=zRe(s,e,void 0,U,o,b);if(H)return H;let K=Ca(li(U,e));return od(jhe(N,K,!1,b))});if(O)return O;if(N&5){let U=Avt(e,S,b);return N&4&&(U??(U=$Re(e,b))),U}}}}function $Re(e,t){if(t.compilerOptions.typeRoots)for(let n of t.compilerOptions.typeRoots){let i=CRe(n,e,t),s=lg(n,t.host);!s&&t.traceEnabled&&ws(t.host,g.Directory_0_does_not_exist_skipping_all_lookups_in_it,n);let o=oD(4,i,!s,t);if(o){let p=fM(o.path),m=p?yE(p,!1,t):void 0;return od(lk(m,o))}let l=Bhe(4,i,!s,t);if(l)return od(l)}}function lD(e,t){return!!e.allowImportingTsExtensions||t&&i_(t)}function Jhe(e,t,n,i,s,o){let l=wy(n,i);l&&ws(i,g.Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2,t,e,s);let p=[],m=[],S=[],h={compilerOptions:n,host:i,traceEnabled:l,failedLookupLocations:p,affectingLocations:m,packageJsonInfoCache:o,features:0,conditions:[],requestContainingDirectory:void 0,reportDiagnostic:A=>void S.push(A),isConfigLookup:!1,candidateIsFromPackageJsonField:!1,resolvedPackageDirectory:!1},b=VRe(4,e,s,h,!1,void 0,void 0);return bRe(b,!0,p,m,S,h.resultFromCache,void 0)}function od(e){return e!==void 0?{value:e}:void 0}function iS(e,t,...n){e.traceEnabled&&ws(e.host,t,...n)}function $Q(e){return e.host.useCaseSensitiveFileNames?typeof e.host.useCaseSensitiveFileNames=="boolean"?e.host.useCaseSensitiveFileNames:e.host.useCaseSensitiveFileNames():!0}var qhe,WRe,WQ,Wh,GQ,kvt=f({"src/compiler/moduleNameResolver.ts"(){"use strict";fa(),WRe=li("node_modules","@types"),WQ=(e=>(e[e.None=0]="None",e[e.Imports=2]="Imports",e[e.SelfName=4]="SelfName",e[e.Exports=8]="Exports",e[e.ExportsPatternTrailers=16]="ExportsPatternTrailers",e[e.AllFeatures=30]="AllFeatures",e[e.Node16Default=30]="Node16Default",e[e.NodeNextDefault=30]="NodeNextDefault",e[e.BundlerDefault=30]="BundlerDefault",e[e.EsmMode=32]="EsmMode",e))(WQ||{}),Wh="/node_modules/",GQ="__"}});function Oy(e,t){return e.body&&!e.body.parent&&(io(e.body,e),Wv(e.body,!1)),e.body?zhe(e.body,t):1}function zhe(e,t=new Map){let n=yo(e);if(t.has(n))return t.get(n)||0;t.set(n,void 0);let i=Pvt(e,t);return t.set(n,i),i}function Pvt(e,t){switch(e.kind){case 264:case 265:return 0;case 266:if(zb(e))return 2;break;case 272:case 271:if(!ui(e,32))return 0;break;case 278:let n=e;if(!n.moduleSpecifier&&n.exportClause&&n.exportClause.kind===279){let i=0;for(let s of n.exportClause.elements){let o=Nvt(s,t);if(o>i&&(i=o),i===1)return i}return i}break;case 268:{let i=0;return Qs(e,s=>{let o=zhe(s,t);switch(o){case 0:return;case 2:i=2;return;case 1:return i=1,!0;default:I.assertNever(o)}}),i}case 267:return Oy(e,t);case 80:if(e.flags&4096)return 0}return 1}function Nvt(e,t){let n=e.propertyName||e.name,i=e.parent;for(;i;){if(ra(i)||Zg(i)||ls(i)){let s=i.statements,o;for(let l of s)if(X3(l,n)){l.parent||(io(l,i),Wv(l,!1));let p=zhe(l,t);if((o===void 0||p>o)&&(o=p),o===1)return o;l.kind===271&&(o=1)}if(o!==void 0)return o}i=i.parent}return 1}function _k(e){return I.attachFlowNodeDebugInfo(e),e}function $he(e,t){var n,i;mc("beforeBind"),(n=z_)==null||n.logStartBindFile(""+e.fileName),HRe(e,t),(i=z_)==null||i.logStopBindFile(),mc("afterBind"),rd("Bind","beforeBind","afterBind")}function Dvt(){var e,t,n,i,s,o,l,p,m,S,h,b,A,k,N,M,O,U,H,K,re,$,pe=!1,z=0,se,Se,xe={flags:1},Z={flags:1},Q=Y();return ye;function ce(V,Pe,...ot){return im(Xr(V)||e,V,Pe,...ot)}function ye(V,Pe){var ot,Yt;e=V,t=Pe,n=ho(t),$=we(e,Pe),Se=new Set,z=0,se=Ju.getSymbolConstructor(),I.attachFlowNodeDebugInfo(xe),I.attachFlowNodeDebugInfo(Z),e.locals||((ot=mn)==null||ot.push(mn.Phase.Bind,"bindSourceFile",{path:e.path},!0),je(e),(Yt=mn)==null||Yt.pop(),e.symbolCount=z,e.classifiableNames=Se,zu()),e=void 0,t=void 0,n=void 0,i=void 0,s=void 0,o=void 0,l=void 0,p=void 0,m=void 0,S=!1,h=void 0,b=void 0,A=void 0,k=void 0,N=void 0,M=void 0,O=void 0,H=void 0,K=!1,pe=!1,re=0}function we(V,Pe){return K_(Pe,"alwaysStrict")&&!V.isDeclarationFile?!0:!!V.externalModuleIndicator}function ve(V,Pe){return z++,new se(V,Pe)}function oe(V,Pe,ot){V.flags|=ot,Pe.symbol=V,V.declarations=ai(V.declarations,Pe),ot&1955&&!V.exports&&(V.exports=ga()),ot&6240&&!V.members&&(V.members=ga()),V.constEnumOnlyModule&&V.flags&304&&(V.constEnumOnlyModule=!1),ot&111551&&L8(V,Pe)}function Ee(V){if(V.kind===277)return V.isExportEquals?"export=":"default";let Pe=qs(V);if(Pe){if(S_(V)){let ot=om(Pe);return zg(V)?"__global":`"${ot}"`}if(Pe.kind===167){let ot=Pe.expression;if(id(ot))return Pc(ot.text);if(Tj(ot))return Sa(ot.operator)+ot.operand.text;I.fail("Only computed properties with literal names have declaration names")}if(is(Pe)){let ot=Vu(V);if(!ot)return;let Yt=ot.symbol;return G8(Yt,Pe.escapedText)}return pg(Pe)?FA(Pe):Wg(Pe)?Qw(Pe):void 0}switch(V.kind){case 176:return"__constructor";case 184:case 179:case 330:return"__call";case 185:case 180:return"__new";case 181:return"__index";case 278:return"__export";case 312:return"export=";case 226:if(al(V)===2)return"export=";I.fail("Unknown binary declaration kind");break;case 324:return hN(V)?"__new":"__call";case 169:return I.assert(V.parent.kind===324,"Impossible parameter parent kind",()=>`parent is: ${I.formatSyntaxKind(V.parent.kind)}, expected JSDocFunctionType`),"arg"+V.parent.parameters.indexOf(V)}}function Me(V){return W_(V)?qo(V.name):Zi(I.checkDefined(Ee(V)))}function Ge(V,Pe,ot,Yt,_n,gi,ci){I.assert(ci||!Jv(ot));let ds=ui(ot,2048)||R_(ot)&&ot.name.escapedText==="default",Ya=ci?"__computed":ds&&Pe?"default":Ee(ot),Xa;if(Ya===void 0)Xa=ve(0,"__missing");else if(Xa=V.get(Ya),Yt&2885600&&Se.add(Ya),!Xa)V.set(Ya,Xa=ve(0,Ya)),gi&&(Xa.isReplaceableByMethod=!0);else{if(gi&&!Xa.isReplaceableByMethod)return Xa;if(Xa.flags&_n){if(Xa.isReplaceableByMethod)V.set(Ya,Xa=ve(0,Ya));else if(!(Yt&3&&Xa.flags&67108864)){W_(ot)&&io(ot.name,ot);let Zc=Xa.flags&2?g.Cannot_redeclare_block_scoped_variable_0:g.Duplicate_identifier_0,Gu=!0;(Xa.flags&384||Yt&384)&&(Zc=g.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations,Gu=!1);let nu=!1;de(Xa.declarations)&&(ds||Xa.declarations&&Xa.declarations.length&&ot.kind===277&&!ot.isExportEquals)&&(Zc=g.A_module_cannot_have_multiple_default_exports,Gu=!1,nu=!0);let Sp=[];Vm(ot)&&sl(ot.type)&&ui(ot,32)&&Xa.flags&2887656&&Sp.push(ce(ot,g.Did_you_mean_0,`export type { ${Zi(ot.name.escapedText)} }`));let Rf=qs(ot)||ot;Te(Xa.declarations,(xo,Wm)=>{let Gm=qs(xo)||xo,ts=Gu?ce(Gm,Zc,Me(xo)):ce(Gm,Zc);e.bindDiagnostics.push(nu?Ga(ts,ce(Rf,Wm===0?g.Another_export_default_is_here:g.and_here)):ts),nu&&Sp.push(ce(Gm,g.The_first_export_default_is_here))});let _S=Gu?ce(Rf,Zc,Me(ot)):ce(Rf,Zc);e.bindDiagnostics.push(Ga(_S,...Sp)),Xa=ve(0,Ya)}}}return oe(Xa,ot,Yt),Xa.parent?I.assert(Xa.parent===Pe,"Existing symbol parent should match new one"):Xa.parent=Pe,Xa}function Ae(V,Pe,ot){let Yt=!!(lT(V)&32)||Ie(V);if(Pe&2097152)return V.kind===281||V.kind===271&&Yt?Ge(s.symbol.exports,s.symbol,V,Pe,ot):(I.assertNode(s,Oh),Ge(s.locals,void 0,V,Pe,ot));if(am(V)&&I.assert(gn(V)),!S_(V)&&(Yt||s.flags&128)){if(!Oh(s)||!s.locals||ui(V,2048)&&!Ee(V))return Ge(s.symbol.exports,s.symbol,V,Pe,ot);let _n=Pe&111551?1048576:0,gi=Ge(s.locals,void 0,V,_n,ot);return gi.exportSymbol=Ge(s.symbol.exports,s.symbol,V,Pe,ot),V.localSymbol=gi,gi}else return I.assertNode(s,Oh),Ge(s.locals,void 0,V,Pe,ot)}function Ie(V){if(V.parent&&hl(V)&&(V=V.parent),!am(V))return!1;if(!UR(V)&&V.fullName)return!0;let Pe=qs(V);return Pe?!!(tR(Pe.parent)&&bl(Pe.parent)||O_(Pe.parent)&&lT(Pe.parent)&32):!1}function Re(V,Pe){let ot=s,Yt=o,_n=l;if(Pe&1?(V.kind!==219&&(o=s),s=l=V,Pe&32&&(s.locals=ga(),fn(s))):Pe&2&&(l=V,Pe&32&&(l.locals=void 0)),Pe&4){let gi=h,ci=b,ds=A,Ya=k,Xa=O,Zc=H,Gu=K,nu=Pe&16&&!ui(V,1024)&&!V.asteriskToken&&!!W2(V)||V.kind===175;nu||(h=_k({flags:2}),Pe&144&&(h.node=V)),k=nu||V.kind===176||gn(V)&&(V.kind===262||V.kind===218)?Fr():void 0,O=void 0,b=void 0,A=void 0,H=void 0,K=!1,$e(V),V.flags&=-5633,!(h.flags&1)&&Pe&8&&nm(V.body)&&(V.flags|=512,K&&(V.flags|=1024),V.endFlowNode=h),V.kind===312&&(V.flags|=re,V.endFlowNode=h),k&&(tr(k,h),h=un(k),(V.kind===176||V.kind===175||gn(V)&&(V.kind===262||V.kind===218))&&(V.returnFlowNode=h)),nu||(h=gi),b=ci,A=ds,k=Ya,O=Xa,H=Zc,K=Gu}else Pe&64?(S=!1,$e(V),I.assertNotNode(V,ze),V.flags=S?V.flags|256:V.flags&-257):$e(V);s=ot,o=Yt,l=_n}function Ue(V){kt(V,Pe=>Pe.kind===262?je(Pe):void 0),kt(V,Pe=>Pe.kind!==262?je(Pe):void 0)}function kt(V,Pe=je){V!==void 0&&Te(V,Pe)}function ke(V){Qs(V,je,kt)}function $e(V){let Pe=pe;if(pe=!1,Gt(V)){ke(V),Et(V),pe=Pe;return}switch(V.kind>=243&&V.kind<=259&&!t.allowUnreachableCode&&(V.flowNode=h),V.kind){case 247:us(V);break;case 246:Fs(V);break;case 248:Ta(V);break;case 249:case 250:to(V);break;case 245:Nr(V);break;case 253:case 257:qr(V);break;case 252:case 251:dt(V);break;case 258:Ot(V);break;case 255:_e(V);break;case 269:Ve(V);break;case 296:pt(V);break;case 244:W(V);break;case 256:Nt(V);break;case 224:Cr(V);break;case 225:hr(V);break;case 226:if(I1(V)){pe=Pe,Sr(V);return}Q(V);break;case 220:Be(V);break;case 227:Lt(V);break;case 260:le(V);break;case 211:case 212:Pi(V);break;case 213:Fi(V);break;case 235:Yr(V);break;case 353:case 345:case 347:Le(V);break;case 312:{Ue(V.statements),je(V.endOfFileToken);break}case 241:case 268:Ue(V.statements);break;case 208:X(V);break;case 169:he(V);break;case 210:case 209:case 303:case 230:pe=Pe;default:ke(V);break}Et(V),pe=Pe}function at(V){switch(V.kind){case 80:case 81:case 110:case 211:case 212:return St(V);case 213:return Ze(V);case 217:if(KN(V))return!1;case 235:return at(V.expression);case 226:return ar(V);case 224:return V.operator===54&&at(V.operand);case 221:return at(V.expression)}return!1}function $t(V){return a6(V)||(Hn(V)||ek(V)||Df(V))&&$t(V.expression)||bn(V)&&V.operatorToken.kind===28&&$t(V.right)||fc(V)&&(id(V.argumentExpression)||ol(V.argumentExpression))&&$t(V.expression)||lu(V)&&$t(V.left)}function St(V){return $t(V)||w_(V)&&St(V.expression)}function Ze(V){if(V.arguments){for(let Pe of V.arguments)if(St(Pe))return!0}return!!(V.expression.kind===211&&St(V.expression.expression))}function yt(V,Pe){return zN(V)&&or(V.expression)&&bo(Pe)}function ar(V){switch(V.operatorToken.kind){case 64:case 76:case 77:case 78:return St(V.left);case 35:case 36:case 37:case 38:return or(V.left)||or(V.right)||yt(V.right,V.left)||yt(V.left,V.right)||Mw(V.right)&&at(V.left)||Mw(V.left)&&at(V.right);case 104:return or(V.left);case 103:return at(V.right);case 28:return at(V.right)}return!1}function or(V){switch(V.kind){case 217:return or(V.expression);case 226:switch(V.operatorToken.kind){case 64:return or(V.left);case 28:return or(V.right)}}return St(V)}function Fr(){return _k({flags:4,antecedents:void 0})}function rn(){return _k({flags:8,antecedents:void 0})}function Tr(V,Pe,ot){return _k({flags:1024,target:V,antecedents:Pe,antecedent:ot})}function nr(V){V.flags|=V.flags&2048?4096:2048}function tr(V,Pe){!(Pe.flags&1)&&!hs(V.antecedents,Pe)&&((V.antecedents||(V.antecedents=[])).push(Pe),nr(Pe))}function ki(V,Pe,ot){return Pe.flags&1?Pe:ot?(ot.kind===112&&V&64||ot.kind===97&&V&32)&&!A9(ot)&&!nY(ot.parent)?xe:at(ot)?(nr(Pe),_k({flags:V,antecedent:Pe,node:ot})):Pe:V&32?Pe:xe}function xs(V,Pe,ot,Yt){return nr(V),_k({flags:128,antecedent:V,switchStatement:Pe,clauseStart:ot,clauseEnd:Yt})}function zi(V,Pe,ot){nr(Pe);let Yt=_k({flags:V,antecedent:Pe,node:ot});return O&&tr(O,Yt),Yt}function Ms(V,Pe){return nr(V),_k({flags:512,antecedent:V,node:Pe})}function un(V){let Pe=V.antecedents;return Pe?Pe.length===1?Pe[0]:V:xe}function ri(V){let Pe=V.parent;switch(Pe.kind){case 245:case 247:case 246:return Pe.expression===V;case 248:case 227:return Pe.condition===V}return!1}function On(V){for(;;)if(V.kind===217)V=V.expression;else if(V.kind===224&&V.operator===54)V=V.operand;else return eR(V)}function _r(V){return EX(Do(V))}function rt(V){for(;Df(V.parent)||eS(V.parent)&&V.parent.operator===54;)V=V.parent;return!ri(V)&&!On(V.parent)&&!(w_(V.parent)&&V.parent.expression===V)}function zt(V,Pe,ot,Yt){let _n=N,gi=M;N=ot,M=Yt,V(Pe),N=_n,M=gi}function Rr(V,Pe,ot){zt(je,V,Pe,ot),(!V||!_r(V)&&!On(V)&&!(w_(V)&&Dw(V)))&&(tr(Pe,ki(32,h,V)),tr(ot,ki(64,h,V)))}function vi(V,Pe,ot){let Yt=b,_n=A;b=Pe,A=ot,je(V),b=Yt,A=_n}function Ni(V,Pe){let ot=H;for(;ot&&V.parent.kind===256;)ot.continueTarget=Pe,ot=ot.next,V=V.parent;return Pe}function us(V){let Pe=Ni(V,rn()),ot=Fr(),Yt=Fr();tr(Pe,h),h=Pe,Rr(V.expression,ot,Yt),h=un(ot),vi(V.statement,Yt,Pe),tr(Pe,h),h=un(Yt)}function Fs(V){let Pe=rn(),ot=Ni(V,Fr()),Yt=Fr();tr(Pe,h),h=Pe,vi(V.statement,Yt,ot),tr(ot,h),h=un(ot),Rr(V.expression,Pe,Yt),h=un(Yt)}function Ta(V){let Pe=Ni(V,rn()),ot=Fr(),Yt=Fr();je(V.initializer),tr(Pe,h),h=Pe,Rr(V.condition,ot,Yt),h=un(ot),vi(V.statement,Yt,Pe),je(V.incrementor),tr(Pe,h),h=un(Yt)}function to(V){let Pe=Ni(V,rn()),ot=Fr();je(V.expression),tr(Pe,h),h=Pe,V.kind===250&&je(V.awaitModifier),tr(ot,h),je(V.initializer),V.initializer.kind!==261&&ht(V.initializer),vi(V.statement,ot,Pe),tr(Pe,h),h=un(ot)}function Nr(V){let Pe=Fr(),ot=Fr(),Yt=Fr();Rr(V.expression,Pe,ot),h=un(Pe),je(V.thenStatement),tr(Yt,h),h=un(ot),je(V.elseStatement),tr(Yt,h),h=un(Yt)}function qr(V){je(V.expression),V.kind===253&&(K=!0,k&&tr(k,h)),h=xe}function We(V){for(let Pe=H;Pe;Pe=Pe.next)if(Pe.name===V)return Pe}function mt(V,Pe,ot){let Yt=V.kind===252?Pe:ot;Yt&&(tr(Yt,h),h=xe)}function dt(V){if(je(V.label),V.label){let Pe=We(V.label.escapedText);Pe&&(Pe.referenced=!0,mt(V,Pe.breakTarget,Pe.continueTarget))}else mt(V,b,A)}function Ot(V){let Pe=k,ot=O,Yt=Fr(),_n=Fr(),gi=Fr();if(V.finallyBlock&&(k=_n),tr(gi,h),O=gi,je(V.tryBlock),tr(Yt,h),V.catchClause&&(h=un(gi),gi=Fr(),tr(gi,h),O=gi,je(V.catchClause),tr(Yt,h)),k=Pe,O=ot,V.finallyBlock){let ci=Fr();ci.antecedents=ys(ys(Yt.antecedents,gi.antecedents),_n.antecedents),h=ci,je(V.finallyBlock),h.flags&1?h=xe:(k&&_n.antecedents&&tr(k,Tr(ci,_n.antecedents,h)),O&&gi.antecedents&&tr(O,Tr(ci,gi.antecedents,h)),h=Yt.antecedents?Tr(ci,Yt.antecedents,h):xe)}else h=un(Yt)}function _e(V){let Pe=Fr();je(V.expression);let ot=b,Yt=U;b=Pe,U=h,je(V.caseBlock),tr(Pe,h);let _n=Te(V.caseBlock.clauses,gi=>gi.kind===297);V.possiblyExhaustive=!_n&&!Pe.antecedents,_n||tr(Pe,xs(U,V,0,0)),b=ot,U=Yt,h=un(Pe)}function Ve(V){let Pe=V.clauses,ot=V.parent.expression.kind===112||at(V.parent.expression),Yt=xe;for(let _n=0;_n<Pe.length;_n++){let gi=_n;for(;!Pe[_n].statements.length&&_n+1<Pe.length;)Yt===xe&&(h=U),je(Pe[_n]),_n++;let ci=Fr();tr(ci,ot?xs(U,V.parent,gi,_n+1):U),tr(ci,Yt),h=un(ci);let ds=Pe[_n];je(ds),Yt=h,!(h.flags&1)&&_n!==Pe.length-1&&t.noFallthroughCasesInSwitch&&(ds.fallthroughFlowNode=h)}}function pt(V){let Pe=h;h=U,je(V.expression),h=Pe,kt(V.statements)}function W(V){je(V.expression),st(V.expression)}function st(V){if(V.kind===213){let Pe=V;Pe.expression.kind!==108&&a6(Pe.expression)&&(h=Ms(h,Pe))}}function Nt(V){let Pe=Fr();H={next:H,name:V.label.escapedText,breakTarget:Pe,continueTarget:void 0,referenced:!1},je(V.label),je(V.statement),!H.referenced&&!t.allowUnusedLabels&&ru(xme(t),V.label,g.Unused_label),H=H.next,tr(Pe,h),h=un(Pe)}function Ke(V){V.kind===226&&V.operatorToken.kind===64?ht(V.left):ht(V)}function ht(V){if($t(V))h=zi(16,h,V);else if(V.kind===209)for(let Pe of V.elements)Pe.kind===230?ht(Pe.expression):Ke(Pe);else if(V.kind===210)for(let Pe of V.properties)Pe.kind===303?Ke(Pe.initializer):Pe.kind===304?ht(Pe.name):Pe.kind===305&&ht(Pe.expression)}function Wt(V,Pe,ot){let Yt=Fr();V.operatorToken.kind===56||V.operatorToken.kind===77?Rr(V.left,Yt,ot):Rr(V.left,Pe,Yt),h=un(Yt),je(V.operatorToken),s6(V.operatorToken.kind)?(zt(je,V.right,Pe,ot),ht(V.left),tr(Pe,ki(32,h,V)),tr(ot,ki(64,h,V))):Rr(V.right,Pe,ot)}function Cr(V){if(V.operator===54){let Pe=N;N=M,M=Pe,ke(V),M=N,N=Pe}else ke(V),(V.operator===46||V.operator===47)&&ht(V.operand)}function hr(V){ke(V),(V.operator===46||V.operator===47)&&ht(V.operand)}function Sr(V){pe?(pe=!1,je(V.operatorToken),je(V.right),pe=!0,je(V.left)):(pe=!0,je(V.left),pe=!1,je(V.operatorToken),je(V.right)),ht(V.left)}function Y(){return SU(V,Pe,ot,Yt,_n,void 0);function V(ci,ds){if(ds){ds.stackIndex++,io(ci,i);let Xa=$;xn(ci);let Zc=i;i=ci,ds.skip=!1,ds.inStrictModeStack[ds.stackIndex]=Xa,ds.parentStack[ds.stackIndex]=Zc}else ds={stackIndex:0,skip:!1,inStrictModeStack:[void 0],parentStack:[void 0]};let Ya=ci.operatorToken.kind;if(Z8(Ya)||s6(Ya)){if(rt(ci)){let Xa=Fr();Wt(ci,Xa,Xa),h=un(Xa)}else Wt(ci,N,M);ds.skip=!0}return ds}function Pe(ci,ds,Ya){if(!ds.skip){let Xa=gi(ci);return Ya.operatorToken.kind===28&&st(ci),Xa}}function ot(ci,ds,Ya){ds.skip||je(ci)}function Yt(ci,ds,Ya){if(!ds.skip){let Xa=gi(ci);return Ya.operatorToken.kind===28&&st(ci),Xa}}function _n(ci,ds){if(!ds.skip){let Zc=ci.operatorToken.kind;if(D1(Zc)&&!N0(ci)&&(ht(ci.left),Zc===64&&ci.left.kind===212)){let Gu=ci.left;or(Gu.expression)&&(h=zi(256,h,ci))}}let Ya=ds.inStrictModeStack[ds.stackIndex],Xa=ds.parentStack[ds.stackIndex];Ya!==void 0&&($=Ya),Xa!==void 0&&(i=Xa),ds.skip=!1,ds.stackIndex--}function gi(ci){if(ci&&bn(ci)&&!I1(ci))return ci;je(ci)}}function Be(V){ke(V),V.expression.kind===211&&ht(V.expression)}function Lt(V){let Pe=Fr(),ot=Fr(),Yt=Fr();Rr(V.condition,Pe,ot),h=un(Pe),je(V.questionToken),je(V.whenTrue),tr(Yt,h),h=un(ot),je(V.colonToken),je(V.whenFalse),tr(Yt,h),h=un(Yt)}function B(V){let Pe=Su(V)?void 0:V.name;if(la(Pe))for(let ot of Pe.elements)B(ot);else h=zi(16,h,V)}function le(V){ke(V),(V.initializer||QP(V.parent.parent))&&B(V)}function X(V){je(V.dotDotDotToken),je(V.propertyName),qe(V.initializer),je(V.name)}function he(V){kt(V.modifiers),je(V.dotDotDotToken),je(V.questionToken),je(V.type),qe(V.initializer),je(V.name)}function qe(V){if(!V)return;let Pe=h;if(je(V),Pe===xe||Pe===h)return;let ot=Fr();tr(ot,Pe),tr(ot,h),h=un(ot)}function Le(V){je(V.tagName),V.kind!==347&&V.fullName&&(io(V.fullName,V),Wv(V.fullName,!1)),typeof V.comment!="string"&&kt(V.comment)}function It(V){ke(V);let Pe=yT(V);Pe&&Pe.kind!==174&&oe(Pe.symbol,Pe,32)}function Rt(V,Pe,ot){zt(je,V,Pe,ot),(!w_(V)||Dw(V))&&(tr(Pe,ki(32,h,V)),tr(ot,ki(64,h,V)))}function Zt(V){switch(V.kind){case 211:je(V.questionDotToken),je(V.name);break;case 212:je(V.questionDotToken),je(V.argumentExpression);break;case 213:je(V.questionDotToken),kt(V.typeArguments),kt(V.arguments);break}}function Ir(V,Pe,ot){let Yt=Nw(V)?Fr():void 0;Rt(V.expression,Yt||Pe,ot),Yt&&(h=un(Yt)),zt(Zt,V,Pe,ot),Dw(V)&&(tr(Pe,ki(32,h,V)),tr(ot,ki(64,h,V)))}function zr(V){if(rt(V)){let Pe=Fr();Ir(V,Pe,Pe),h=un(Pe)}else Ir(V,N,M)}function Yr(V){w_(V)?zr(V):ke(V)}function Pi(V){w_(V)?zr(V):ke(V)}function Fi(V){if(w_(V))zr(V);else{let Pe=Do(V.expression);Pe.kind===218||Pe.kind===219?(kt(V.typeArguments),kt(V.arguments),je(V.expression)):(ke(V),V.expression.kind===108&&(h=Ms(h,V)))}if(V.expression.kind===211){let Pe=V.expression;ze(Pe.name)&&or(Pe.expression)&&cX(Pe.name)&&(h=zi(256,h,V))}}function fn(V){p&&(p.nextContainer=V),p=V}function Qn(V,Pe,ot){switch(s.kind){case 267:return Ae(V,Pe,ot);case 312:return Vi(V,Pe,ot);case 231:case 263:return Ns(V,Pe,ot);case 266:return Ge(s.symbol.exports,s.symbol,V,Pe,ot);case 187:case 329:case 210:case 264:case 292:return Ge(s.symbol.members,s.symbol,V,Pe,ot);case 184:case 185:case 179:case 180:case 330:case 181:case 174:case 173:case 176:case 177:case 178:case 262:case 218:case 219:case 324:case 175:case 265:case 200:return s.locals&&I.assertNode(s,Oh),Ge(s.locals,void 0,V,Pe,ot)}}function Ns(V,Pe,ot){return pa(V)?Ge(s.symbol.exports,s.symbol,V,Pe,ot):Ge(s.symbol.members,s.symbol,V,Pe,ot)}function Vi(V,Pe,ot){return Pl(e)?Ae(V,Pe,ot):Ge(e.locals,void 0,V,Pe,ot)}function ji(V){let Pe=ls(V)?V:ii(V.body,Zg);return!!Pe&&Pe.statements.some(ot=>yl(ot)||Kc(ot))}function ni(V){V.flags&33554432&&!ji(V)?V.flags|=128:V.flags&=-129}function js(V){if(ni(V),S_(V))if(ui(V,32)&&Go(V,g.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible),NY(V))Mr(V);else{let Pe;if(V.name.kind===11){let{text:Yt}=V.name;Pe=ON(Yt),Pe===void 0&&Go(V.name,g.Pattern_0_can_have_at_most_one_Asterisk_character,Yt)}let ot=Qn(V,512,110735);e.patternAmbientModules=Pr(e.patternAmbientModules,Pe&&!vs(Pe)?{pattern:Pe,symbol:ot}:void 0)}else{let Pe=Mr(V);if(Pe!==0){let{symbol:ot}=V;ot.constEnumOnlyModule=!(ot.flags&304)&&Pe===2&&ot.constEnumOnlyModule!==!1}}}function Mr(V){let Pe=Oy(V),ot=Pe!==0;return Qn(V,ot?512:1024,ot?110735:0),Pe}function Qo(V){let Pe=ve(131072,Ee(V));oe(Pe,V,131072);let ot=ve(2048,"__type");oe(ot,V,2048),ot.members=ga(),ot.members.set(Pe.escapedName,Pe)}function Sl(V){return nc(V,4096,"__object")}function zs(V){return nc(V,4096,"__jsxAttributes")}function Eo(V,Pe,ot){return Qn(V,Pe,ot)}function nc(V,Pe,ot){let Yt=ve(Pe,ot);return Pe&106508&&(Yt.parent=s.symbol),oe(Yt,V,Pe),Yt}function Dc(V,Pe,ot){switch(l.kind){case 267:Ae(V,Pe,ot);break;case 312:if(Bp(s)){Ae(V,Pe,ot);break}default:I.assertNode(l,Oh),l.locals||(l.locals=ga(),fn(l)),Ge(l.locals,void 0,V,Pe,ot)}}function zu(){if(!m)return;let V=s,Pe=p,ot=l,Yt=i,_n=h;for(let gi of m){let ci=gi.parent.parent;s=LY(ci)||e,l=Lh(ci)||e,h=_k({flags:2}),i=gi,je(gi.typeExpression);let ds=qs(gi);if((UR(gi)||!gi.fullName)&&ds&&tR(ds.parent)){let Ya=bl(ds.parent);if(Ya){Ic(e.symbol,ds.parent,Ya,!!Gr(ds,Zc=>Hn(Zc)&&Zc.name.escapedText==="prototype"),!1);let Xa=s;switch(R8(ds.parent)){case 1:case 2:Bp(e)?s=e:s=void 0;break;case 4:s=ds.parent.expression;break;case 3:s=ds.parent.expression.name;break;case 5:s=vE(e,ds.parent.expression)?e:Hn(ds.parent.expression)?ds.parent.expression.name:ds.parent.expression;break;case 0:return I.fail("Shouldn't have detected typedef or enum on non-assignment declaration")}s&&Ae(gi,524288,788968),s=Xa}}else UR(gi)||!gi.fullName||gi.fullName.kind===80?(i=gi.parent,Dc(gi,524288,788968)):je(gi.fullName)}s=V,p=Pe,l=ot,i=Yt,h=_n}function ks(V){if(!e.parseDiagnostics.length&&!(V.flags&33554432)&&!(V.flags&16777216)&&!Ode(V)){let Pe=uT(V);if(Pe===void 0)return;$&&Pe>=119&&Pe<=127?e.bindDiagnostics.push(ce(V,ya(V),qo(V))):Pe===135?Pl(e)&&ij(V)?e.bindDiagnostics.push(ce(V,g.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module,qo(V))):V.flags&65536&&e.bindDiagnostics.push(ce(V,g.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here,qo(V))):Pe===127&&V.flags&16384&&e.bindDiagnostics.push(ce(V,g.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here,qo(V)))}}function ya(V){return Vu(V)?g.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode:e.externalModuleIndicator?g.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode:g.Identifier_expected_0_is_a_reserved_word_in_strict_mode}function $u(V){V.escapedText==="#constructor"&&(e.parseDiagnostics.length||e.bindDiagnostics.push(ce(V,g.constructor_is_a_reserved_word,qo(V))))}function Uo(V){$&&$f(V.left)&&D1(V.operatorToken.kind)&&Nl(V,V.left)}function $a(V){$&&V.variableDeclaration&&Nl(V,V.variableDeclaration.name)}function Ac(V){if($&&V.expression.kind===80){let Pe=z2(e,V.expression);e.bindDiagnostics.push(Iu(e,Pe.start,Pe.length,g.delete_cannot_be_called_on_an_identifier_in_strict_mode))}}function Ld(V){return ze(V)&&(V.escapedText==="eval"||V.escapedText==="arguments")}function Nl(V,Pe){if(Pe&&Pe.kind===80){let ot=Pe;if(Ld(ot)){let Yt=z2(e,Pe);e.bindDiagnostics.push(Iu(e,Yt.start,Yt.length,zc(V),Nn(ot)))}}}function zc(V){return Vu(V)?g.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode:e.externalModuleIndicator?g.Invalid_use_of_0_Modules_are_automatically_in_strict_mode:g.Invalid_use_of_0_in_strict_mode}function Tc(V){$&&Nl(V,V.name)}function $s(V){return Vu(V)?g.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode:e.externalModuleIndicator?g.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode:g.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5}function cr(V){if(n<2&&l.kind!==312&&l.kind!==267&&!KP(l)){let Pe=z2(e,V);e.bindDiagnostics.push(Iu(e,Pe.start,Pe.length,$s(V)))}}function ic(V){$&&Nl(V,V.operand)}function Mu(V){$&&(V.operator===46||V.operator===47)&&Nl(V,V.operand)}function Wu(V){$&&Go(V,g.with_statements_are_not_allowed_in_strict_mode)}function yp(V){$&&ho(t)>=2&&(Lpe(V.statement)||Xc(V.statement))&&Go(V.label,g.A_label_is_not_allowed_here)}function Go(V,Pe,...ot){let Yt=Fh(e,V.pos);e.bindDiagnostics.push(Iu(e,Yt.start,Yt.length,Pe,...ot))}function ru(V,Pe,ot){ge(V,Pe,Pe,ot)}function ge(V,Pe,ot,Yt){ne(V,{pos:mT(Pe,e),end:ot.end},Yt)}function ne(V,Pe,ot){let Yt=Iu(e,Pe.pos,Pe.end-Pe.pos,ot);V?e.bindDiagnostics.push(Yt):e.bindSuggestionDiagnostics=Pr(e.bindSuggestionDiagnostics,{...Yt,category:2})}function je(V){if(!V)return;io(V,i),mn&&(V.tracingPath=e.path);let Pe=$;if(xn(V),V.kind>165){let ot=i;i=V;let Yt=HQ(V);Yt===0?$e(V):Re(V,Yt),i=ot}else{let ot=i;V.kind===1&&(i=V),Et(V),i=ot}$=Pe}function Et(V){if(jp(V))if(gn(V))for(let Pe of V.jsDoc)je(Pe);else for(let Pe of V.jsDoc)io(Pe,V),Wv(Pe,!1)}function gr(V){if(!$)for(let Pe of V){if(!Fm(Pe))return;if(Dn(Pe)){$=!0;return}}}function Dn(V){let Pe=Jb(e,V.expression);return Pe==='"use strict"'||Pe==="'use strict'"}function xn(V){switch(V.kind){case 80:if(V.flags&4096){let ci=V.parent;for(;ci&&!am(ci);)ci=ci.parent;Dc(ci,524288,788968);break}case 110:return h&&(bt(V)||i.kind===304)&&(V.flowNode=h),ks(V);case 166:h&&lj(V)&&(V.flowNode=h);break;case 236:case 108:V.flowNode=h;break;case 81:return $u(V);case 211:case 212:let Pe=V;h&&$t(Pe)&&(Pe.flowNode=h),Ade(Pe)&&Zr(Pe),gn(Pe)&&e.commonJsModuleIndicator&&P0(Pe)&&!$U(l,"module")&&Ge(e.locals,void 0,Pe.expression,134217729,111550);break;case 226:switch(al(V)){case 1:Xf(V);break;case 2:pu(V);break;case 3:ua(V.left,V);break;case 6:Ds(V);break;case 4:tf(V);break;case 5:let ci=V.left.expression;if(gn(V)&&ze(ci)){let ds=$U(l,ci.escapedText);if(sj(ds?.valueDeclaration)){tf(V);break}}ql(V);break;case 0:break;default:I.fail("Unknown binary expression special property assignment kind")}return Uo(V);case 299:return $a(V);case 220:return Ac(V);case 225:return ic(V);case 224:return Mu(V);case 254:return Wu(V);case 256:return yp(V);case 197:S=!0;return;case 182:break;case 168:return ct(V);case 169:return Fy(V);case 260:return A_(V);case 208:return V.flowNode=h,A_(V);case 172:case 171:return Zn(V);case 303:case 304:return Of(V,4,0);case 306:return Of(V,8,900095);case 179:case 180:case 181:return Qn(V,131072,0);case 174:case 173:return Of(V,8192|(V.questionToken?16777216:0),jm(V)?0:103359);case 262:return vp(V);case 176:return Qn(V,16384,0);case 177:return Of(V,32768,46015);case 178:return Of(V,65536,78783);case 184:case 324:case 330:case 185:return Qo(V);case 187:case 329:case 200:return Bi(V);case 339:return It(V);case 210:return Sl(V);case 218:case 219:return U0(V);case 213:switch(al(V)){case 7:return Tl(V);case 8:return Eu(V);case 9:return sa(V);case 0:break;default:return I.fail("Unknown call expression assignment declaration kind")}gn(V)&&ch(V);break;case 231:case 263:return $=!0,Yh(V);case 264:return Dc(V,64,788872);case 265:return Dc(V,524288,788968);case 266:return Ly(V);case 267:return js(V);case 292:return zs(V);case 291:return Eo(V,4,0);case 271:case 274:case 276:case 281:return Qn(V,2097152,2097152);case 270:return bu(V);case 273:return Jl(V);case 278:return sc(V);case 277:return Fc(V);case 312:return gr(V.statements),Jn();case 241:if(!KP(V.parent))return;case 268:return gr(V.statements);case 348:if(V.parent.kind===330)return Fy(V);if(V.parent.kind!==329)break;case 355:let _n=V,gi=_n.isBracketed||_n.typeExpression&&_n.typeExpression.type.kind===323?16777220:4;return Qn(_n,gi,0);case 353:case 345:case 347:return(m||(m=[])).push(V);case 346:return je(V.typeExpression)}}function Zn(V){let Pe=Af(V),ot=Pe?98304:4,Yt=Pe?13247:0;return Of(V,ot|(V.questionToken?16777216:0),Yt)}function Bi(V){return nc(V,2048,"__type")}function Jn(){if(ni(e),Pl(e))ia();else if(sm(e)){ia();let V=e.symbol;Ge(e.symbol.exports,e.symbol,e,4,-1),e.symbol=V}}function ia(){nc(e,512,`"${ff(e.fileName)}"`)}function Fc(V){if(!s.symbol||!s.symbol.exports)nc(V,111551,Ee(V));else{let Pe=vN(V)?2097152:4,ot=Ge(s.symbol.exports,s.symbol,V,Pe,-1);V.isExportEquals&&L8(ot,V)}}function bu(V){Tt(V.modifiers)&&e.bindDiagnostics.push(ce(V,g.Modifiers_cannot_appear_here));let Pe=ls(V.parent)?Pl(V.parent)?V.parent.isDeclarationFile?void 0:g.Global_module_exports_may_only_appear_in_declaration_files:g.Global_module_exports_may_only_appear_in_module_files:g.Global_module_exports_may_only_appear_at_top_level;Pe?e.bindDiagnostics.push(ce(V,Pe)):(e.symbol.globalExports=e.symbol.globalExports||ga(),Ge(e.symbol.globalExports,e.symbol,V,2097152,2097152))}function sc(V){!s.symbol||!s.symbol.exports?nc(V,8388608,Ee(V)):V.exportClause?qh(V.exportClause)&&(io(V.exportClause,V),Ge(s.symbol.exports,s.symbol,V.exportClause,2097152,2097152)):Ge(s.symbol.exports,s.symbol,V,8388608,0)}function Jl(V){V.name&&Qn(V,2097152,2097152)}function jo(V){return e.externalModuleIndicator&&e.externalModuleIndicator!==!0?!1:(e.commonJsModuleIndicator||(e.commonJsModuleIndicator=V,e.externalModuleIndicator||ia()),!0)}function Eu(V){if(!jo(V))return;let Pe=Fd(V.arguments[0],void 0,(ot,Yt)=>(Yt&&oe(Yt,ot,67110400),Yt));Pe&&Ge(Pe.exports,Pe,V,1048580,0)}function Xf(V){if(!jo(V))return;let Pe=Fd(V.left.expression,void 0,(ot,Yt)=>(Yt&&oe(Yt,ot,67110400),Yt));if(Pe){let Yt=$8(V.right)&&(G2(V.left.expression)||P0(V.left.expression))?2097152:1048580;io(V.left,V),Ge(Pe.exports,Pe,V.left,Yt,0)}}function pu(V){if(!jo(V))return;let Pe=I8(V.right);if(kX(Pe)||s===e&&vE(e,Pe))return;if(Ha(Pe)&&yr(Pe.properties,Hf)){Te(Pe.properties,gm);return}let ot=vN(V)?2097152:1049092,Yt=Ge(e.symbol.exports,e.symbol,V,ot|67108864,0);L8(Yt,V)}function gm(V){Ge(e.symbol.exports,e.symbol,V,69206016,0)}function tf(V){if(I.assert(gn(V)),bn(V)&&Hn(V.left)&&is(V.left.name)||Hn(V)&&is(V.name))return;let ot=kf(V,!1,!1);switch(ot.kind){case 262:case 218:let Yt=ot.symbol;if(bn(ot.parent)&&ot.parent.operatorToken.kind===64){let ci=ot.parent.left;Hb(ci)&&zv(ci.expression)&&(Yt=hf(ci.expression.expression,o))}Yt&&Yt.valueDeclaration&&(Yt.members=Yt.members||ga(),Jv(V)?Oe(V,Yt,Yt.members):Ge(Yt.members,Yt,V,67108868,0),oe(Yt,Yt.valueDeclaration,32));break;case 176:case 172:case 174:case 177:case 178:case 175:let _n=ot.parent,gi=pa(ot)?_n.symbol.exports:_n.symbol.members;Jv(V)?Oe(V,_n.symbol,gi):Ge(gi,_n.symbol,V,67108868,0,!0);break;case 312:if(Jv(V))break;ot.commonJsModuleIndicator?Ge(ot.symbol.exports,ot.symbol,V,1048580,0):Qn(V,1,111550);break;case 267:break;default:I.failBadSyntaxKind(ot)}}function Oe(V,Pe,ot){Ge(ot,Pe,V,4,0,!0,!0),Bt(V,Pe)}function Bt(V,Pe){Pe&&(Pe.assignmentDeclarationMembers||(Pe.assignmentDeclarationMembers=new Map)).set(yo(V),V)}function Zr(V){V.expression.kind===110?tf(V):Hb(V)&&V.parent.parent.kind===312&&(zv(V.expression)?ua(V,V.parent):bc(V))}function Ds(V){io(V.left,V),io(V.right,V),xu(V.left.expression,V.left,!1,!0)}function sa(V){let Pe=hf(V.arguments[0].expression);Pe&&Pe.valueDeclaration&&oe(Pe,Pe.valueDeclaration,32),cl(V,Pe,!0)}function ua(V,Pe){let ot=V.expression,Yt=ot.expression;io(Yt,ot),io(ot,V),io(V,Pe),xu(Yt,V,!0,!0)}function Tl(V){let Pe=hf(V.arguments[0]),ot=V.parent.parent.kind===312;Pe=Ic(Pe,V.arguments[0],ot,!1,!1),cl(V,Pe,!1)}function ql(V){var Pe;let ot=hf(V.left.expression,l)||hf(V.left.expression,s);if(!gn(V)&&!kde(ot))return;let Yt=DN(V.left);if(!(ze(Yt)&&((Pe=$U(s,Yt.escapedText))==null?void 0:Pe.flags)&2097152))if(io(V.left,V),io(V.right,V),ze(V.left.expression)&&s===e&&vE(e,V.left.expression))Xf(V);else if(Jv(V)){nc(V,67108868,"__computed");let _n=Ic(ot,V.left.expression,bl(V.left),!1,!1);Bt(V,_n)}else bc(ta(V.left,Y2))}function bc(V){I.assert(!ze(V)),io(V.expression,V),xu(V.expression,V,!1,!1)}function Ic(V,Pe,ot,Yt,_n){return V?.flags&2097152||(ot&&!Yt&&(V=Fd(Pe,V,(ds,Ya,Xa)=>{if(Ya)return oe(Ya,ds,67110400),Ya;{let Zc=Xa?Xa.exports:e.jsGlobalAugmentations||(e.jsGlobalAugmentations=ga());return Ge(Zc,Xa,ds,67110400,110735)}})),_n&&V&&V.valueDeclaration&&oe(V,V.valueDeclaration,32)),V}function cl(V,Pe,ot){if(!Pe||!dd(Pe))return;let Yt=ot?Pe.members||(Pe.members=ga()):Pe.exports||(Pe.exports=ga()),_n=0,gi=0;tc(EA(V))?(_n=8192,gi=103359):da(V)&&H2(V)&&(Tt(V.arguments[2].properties,ci=>{let ds=qs(ci);return!!ds&&ze(ds)&&Nn(ds)==="set"})&&(_n|=65540,gi|=78783),Tt(V.arguments[2].properties,ci=>{let ds=qs(ci);return!!ds&&ze(ds)&&Nn(ds)==="get"})&&(_n|=32772,gi|=46015)),_n===0&&(_n=4,gi=0),Ge(Yt,Pe,V,_n|67108864,gi&-67108865)}function bl(V){return bn(V.parent)?wf(V.parent).parent.kind===312:V.parent.parent.kind===312}function xu(V,Pe,ot,Yt){let _n=hf(V,l)||hf(V,s),gi=bl(Pe);_n=Ic(_n,Pe.expression,gi,ot,Yt),cl(Pe,_n,ot)}function dd(V){if(V.flags&1072)return!0;let Pe=V.valueDeclaration;if(Pe&&da(Pe))return!!EA(Pe);let ot=Pe?Gi(Pe)?Pe.initializer:bn(Pe)?Pe.right:Hn(Pe)&&bn(Pe.parent)?Pe.parent.right:void 0:void 0;if(ot=ot&&I8(ot),ot){let Yt=zv(Gi(Pe)?Pe.name:bn(Pe)?Pe.left:Pe);return!!hT(bn(ot)&&(ot.operatorToken.kind===57||ot.operatorToken.kind===61)?ot.right:ot,Yt)}return!1}function wf(V){for(;bn(V.parent);)V=V.parent;return V.parent}function hf(V,Pe=s){if(ze(V))return $U(Pe,V.escapedText);{let ot=hf(V.expression);return ot&&ot.exports&&ot.exports.get(xy(V))}}function Fd(V,Pe,ot){if(vE(e,V))return e.symbol;if(ze(V))return ot(V,hf(V),Pe);{let Yt=Fd(V.expression,Pe,ot),_n=O8(V);return is(_n)&&I.fail("unexpected PrivateIdentifier"),ot(_n,Yt&&Yt.exports&&Yt.exports.get(xy(V)),Yt)}}function ch(V){!e.commonJsModuleIndicator&&_f(V,!1)&&jo(V)}function Yh(V){if(V.kind===263)Dc(V,32,899503);else{let _n=V.name?V.name.escapedText:"__class";nc(V,32,_n),V.name&&Se.add(V.name.escapedText)}let{symbol:Pe}=V,ot=ve(4194308,"prototype"),Yt=Pe.exports.get(ot.escapedName);Yt&&(V.name&&io(V.name,V),e.bindDiagnostics.push(ce(Yt.declarations[0],g.Duplicate_identifier_0,Lc(ot)))),Pe.exports.set(ot.escapedName,ot),ot.parent=Pe}function Ly(V){return zb(V)?Dc(V,128,899967):Dc(V,256,899327)}function A_(V){if($&&Nl(V,V.name),!la(V.name)){let Pe=V.kind===260?V:V.parent.parent;gn(V)&&Gb(Pe)&&!_T(V)&&!(lT(V)&32)?Qn(V,2097152,2097152):AY(V)?Dc(V,2,111551):Kb(V)?Qn(V,1,111551):Qn(V,1,111550)}}function Fy(V){if(!(V.kind===348&&s.kind!==330)&&($&&!(V.flags&33554432)&&Nl(V,V.name),la(V.name)?nc(V,1,"__"+V.parent.parameters.indexOf(V)):Qn(V,1,111551),op(V,V.parent))){let Pe=V.parent.parent;Ge(Pe.symbol.members,Pe.symbol,V,4|(V.questionToken?16777216:0),0)}}function vp(V){!e.isDeclarationFile&&!(V.flags&33554432)&&Kw(V)&&(re|=4096),Tc(V),$?(cr(V),Dc(V,16,110991)):Qn(V,16,110991)}function U0(V){!e.isDeclarationFile&&!(V.flags&33554432)&&Kw(V)&&(re|=4096),h&&(V.flowNode=h),Tc(V);let Pe=V.name?V.name.escapedText:"__function";return nc(V,16,Pe)}function Of(V,Pe,ot){return!e.isDeclarationFile&&!(V.flags&33554432)&&Kw(V)&&(re|=4096),h&&ej(V)&&(V.flowNode=h),Jv(V)?nc(V,Pe,"__computed"):Qn(V,Pe,ot)}function ie(V){let Pe=Gr(V,ot=>ot.parent&&QA(ot.parent)&&ot.parent.extendsType===ot);return Pe&&Pe.parent}function ct(V){if(dm(V.parent)){let Pe=yj(V.parent);Pe?(I.assertNode(Pe,Oh),Pe.locals??(Pe.locals=ga()),Ge(Pe.locals,void 0,V,262144,526824)):Qn(V,262144,526824)}else if(V.parent.kind===195){let Pe=ie(V.parent);Pe?(I.assertNode(Pe,Oh),Pe.locals??(Pe.locals=ga()),Ge(Pe.locals,void 0,V,262144,526824)):nc(V,262144,Ee(V))}else Qn(V,262144,526824)}function Jt(V){let Pe=Oy(V);return Pe===1||Pe===2&&aE(t)}function Gt(V){if(!(h.flags&1))return!1;if(h===xe&&(l8(V)&&V.kind!==242||V.kind===263||V.kind===267&&Jt(V))&&(h=Z,!t.allowUnreachableCode)){let ot=Eme(t)&&!(V.flags&33554432)&&(!Xc(V)||!!(x1(V.declarationList)&7)||V.declarationList.declarations.some(Yt=>!!Yt.initializer));Ivt(V,(Yt,_n)=>ge(ot,Yt,_n,g.Unreachable_code_detected))}return!0}}function Ivt(e,t){if(ns(e)&&GRe(e)&&ra(e.parent)){let{statements:n}=e.parent,i=zX(n,e);Ev(i,GRe,(s,o)=>t(i[s],i[o-1]))}else t(e,e)}function GRe(e){return!Zl(e)&&!wvt(e)&&!AT(e)&&!(Xc(e)&&!(x1(e)&7)&&e.declarationList.declarations.some(t=>!t.initializer))}function wvt(e){switch(e.kind){case 264:case 265:return!0;case 267:return Oy(e)!==1;case 266:return ui(e,4096);default:return!1}}function vE(e,t){let n=0,i=Pu();for(i.enqueue(t);!i.isEmpty()&&n<100;){if(n++,t=i.dequeue(),G2(t)||P0(t))return!0;if(ze(t)){let s=$U(e,t.escapedText);if(s&&s.valueDeclaration&&Gi(s.valueDeclaration)&&s.valueDeclaration.initializer){let o=s.valueDeclaration.initializer;i.enqueue(o),lu(o,!0)&&(i.enqueue(o.left),i.enqueue(o.right))}}}return!1}function HQ(e){switch(e.kind){case 231:case 263:case 266:case 210:case 187:case 329:case 292:return 1;case 264:return 65;case 267:case 265:case 200:case 181:return 33;case 312:return 37;case 177:case 178:case 174:if(ej(e))return 173;case 176:case 262:case 173:case 179:case 330:case 324:case 184:case 180:case 185:case 175:return 45;case 218:case 219:return 61;case 268:return 4;case 172:return e.initializer?4:0;case 299:case 248:case 249:case 250:case 269:return 34;case 241:return ca(e.parent)||Jc(e.parent)?0:34}return 0}function $U(e,t){var n,i,s,o;let l=(i=(n=ii(e,Oh))==null?void 0:n.locals)==null?void 0:i.get(t);if(l)return l.exportSymbol??l;if(ls(e)&&e.jsGlobalAugmentations&&e.jsGlobalAugmentations.has(t))return e.jsGlobalAugmentations.get(t);if(qg(e))return(o=(s=e.symbol)==null?void 0:s.exports)==null?void 0:o.get(t)}var YQ,XQ,HRe,Ovt=f({"src/compiler/binder.ts"(){"use strict";fa(),O2(),YQ=(e=>(e[e.NonInstantiated=0]="NonInstantiated",e[e.Instantiated=1]="Instantiated",e[e.ConstEnumOnly=2]="ConstEnumOnly",e))(YQ||{}),XQ=(e=>(e[e.None=0]="None",e[e.IsContainer=1]="IsContainer",e[e.IsBlockScopedContainer=2]="IsBlockScopedContainer",e[e.IsControlFlowContainer=4]="IsControlFlowContainer",e[e.IsFunctionLike=8]="IsFunctionLike",e[e.IsFunctionExpression=16]="IsFunctionExpression",e[e.HasLocals=32]="HasLocals",e[e.IsInterface=64]="IsInterface",e[e.IsObjectLiteralOrClassExpressionMethodOrAccessor=128]="IsObjectLiteralOrClassExpressionMethodOrAccessor",e))(XQ||{}),HRe=Dvt()}});function Whe(e,t,n,i,s,o,l,p,m,S){return h;function h(b=()=>!0){let A=[],k=[];return{walkType:Se=>{try{return N(Se),{visitedTypes:Mn(A),visitedSymbols:Mn(k)}}finally{ed(A),ed(k)}},walkSymbol:Se=>{try{return se(Se),{visitedTypes:Mn(A),visitedSymbols:Mn(k)}}finally{ed(A),ed(k)}}};function N(Se){if(!(!Se||A[Se.id]||(A[Se.id]=Se,se(Se.symbol)))){if(Se.flags&524288){let Z=Se,Q=Z.objectFlags;Q&4&&M(Se),Q&32&&re(Se),Q&3&&pe(Se),Q&24&&z(Z)}Se.flags&262144&&O(Se),Se.flags&3145728&&U(Se),Se.flags&4194304&&H(Se),Se.flags&8388608&&K(Se)}}function M(Se){N(Se.target),Te(S(Se),N)}function O(Se){N(p(Se))}function U(Se){Te(Se.types,N)}function H(Se){N(Se.type)}function K(Se){N(Se.objectType),N(Se.indexType),N(Se.constraint)}function re(Se){N(Se.typeParameter),N(Se.constraintType),N(Se.templateType),N(Se.modifiersType)}function $(Se){let xe=t(Se);xe&&N(xe.type),Te(Se.typeParameters,N);for(let Z of Se.parameters)se(Z);N(e(Se)),N(n(Se))}function pe(Se){z(Se),Te(Se.typeParameters,N),Te(i(Se),N),N(Se.thisType)}function z(Se){let xe=s(Se);for(let Z of xe.indexInfos)N(Z.keyType),N(Z.type);for(let Z of xe.callSignatures)$(Z);for(let Z of xe.constructSignatures)$(Z);for(let Z of xe.properties)se(Z)}function se(Se){if(!Se)return!1;let xe=Ia(Se);if(k[xe])return!1;if(k[xe]=Se,!b(Se))return!0;let Z=o(Se);return N(Z),Se.exports&&Se.exports.forEach(se),Te(Se.declarations,Q=>{if(Q.type&&Q.type.kind===186){let ce=Q.type,ye=l(m(ce.exprName));se(ye)}}),!1}}}var Rvt=f({"src/compiler/symbolWalker.ts"(){"use strict";fa()}});function yM({importModuleSpecifierPreference:e,importModuleSpecifierEnding:t},n,i,s){let o=l();return{relativePreference:s!==void 0?Nu(s)?0:1:e==="relative"?0:e==="non-relative"?1:e==="project-relative"?3:2,getAllowedEndingsInPreferredOrder:p=>{let m=p!==i.impliedNodeFormat?l(p):o;if((p??i.impliedNodeFormat)===99)return lD(n,i.fileName)?[3,2]:[2];if(Q_(n)===1)return m===2?[2,1]:[1,2];let S=lD(n,i.fileName);switch(m){case 2:return S?[2,3,0,1]:[2,0,1];case 3:return[3,0,2,1];case 1:return S?[1,0,3,2]:[1,0,2];case 0:return S?[0,1,3,2]:[0,1,2];default:I.assertNever(m)}}};function l(p){if(s!==void 0){if(rE(s))return 2;if(Mc(s,"/index"))return 1}return wme(t,p??i.impliedNodeFormat,n,i)}}function Mvt(e,t,n,i,s,o,l={}){let p=YRe(e,t,n,i,s,yM({},e,t,o),{},l);if(p!==o)return p}function WU(e,t,n,i,s,o={}){return YRe(e,t,n,i,s,yM({},e,t),{},o)}function Lvt(e,t,n,i,s,o={}){let l=KQ(t.fileName,i),p=rMe(l,n,i,s,o);return Ct(p,m=>Hhe(m,l,t,i,e,s,!0,o.overrideImportMode))}function YRe(e,t,n,i,s,o,l,p={}){let m=KQ(n,s),S=rMe(m,i,s,l,p);return Ct(S,h=>Hhe(h,m,t,s,e,l,void 0,p.overrideImportMode))||ZRe(i,m,e,s,p.overrideImportMode||t.impliedNodeFormat,o)}function Fvt(e,t,n,i,s={}){return XRe(e,t,n,i,s)[0]}function XRe(e,t,n,i,s={}){var o;let l=J9(e);if(!l)return tt;let p=(o=n.getModuleSpecifierCache)==null?void 0:o.call(n),m=p?.get(t.path,l.path,i,s);return[m?.moduleSpecifiers,l,m?.modulePaths,p]}function KRe(e,t,n,i,s,o,l={}){return QRe(e,t,n,i,s,o,l,!1).moduleSpecifiers}function QRe(e,t,n,i,s,o,l={},p){let m=!1,S=Uvt(e,t);if(S)return{moduleSpecifiers:[S],computedWithoutCache:m};let[h,b,A,k]=XRe(e,i,s,o,l);if(h)return{moduleSpecifiers:h,computedWithoutCache:m};if(!b)return{moduleSpecifiers:tt,computedWithoutCache:m};m=!0,A||(A=nMe(KQ(i.fileName,s),b.originalFileName,s));let N=jvt(A,n,i,s,o,l,p);return k?.set(i.path,b.path,o,l,A,N),{moduleSpecifiers:N,computedWithoutCache:m}}function jvt(e,t,n,i,s,o={},l){let p=KQ(n.fileName,i),m=yM(s,t,n),S=Te(e,M=>Te(i.getFileIncludeReasons().get(gc(M.path,i.getCurrentDirectory(),p.getCanonicalFileName)),O=>{if(O.kind!==3||O.file!==n.path||n.impliedNodeFormat&&n.impliedNodeFormat!==iye(n,O.index,t))return;let U=MM(n,O.index).text;return m.relativePreference!==1||!Fp(U)?U:void 0}));if(S)return[S];let h=Tt(e,M=>M.isInNodeModules),b,A,k,N;for(let M of e){let O=M.isInNodeModules?Hhe(M,p,n,i,t,s,void 0,o.overrideImportMode):void 0;if(b=Pr(b,O),O&&M.isRedirect)return b;if(!O){let U=ZRe(M.path,p,t,i,o.overrideImportMode||n.impliedNodeFormat,m,M.isRedirect);if(!U)continue;M.isRedirect?k=Pr(k,U):VH(U)?OT(U)?N=Pr(N,U):A=Pr(A,U):(l||!h||M.isInNodeModules)&&(N=Pr(N,U))}}return A?.length?A:k?.length?k:b?.length?b:I.checkDefined(N)}function KQ(e,t){e=Ps(e,t.getCurrentDirectory());let n=y_(t.useCaseSensitiveFileNames?t.useCaseSensitiveFileNames():!0),i=hi(e);return{getCanonicalFileName:n,importingSourceFileName:e,sourceDirectory:i,canonicalSourceDirectory:n(i)}}function ZRe(e,t,n,i,s,{getAllowedEndingsInPreferredOrder:o,relativePreference:l},p){let{baseUrl:m,paths:S,rootDirs:h}=n;if(p&&!S)return;let{sourceDirectory:b,canonicalSourceDirectory:A,getCanonicalFileName:k}=t,N=o(s),M=h&&qvt(h,e,b,k,N,n)||vM(Lb(Om(b,e,k)),N,n);if(!m&&!S&&!gB(n)||l===0)return p?void 0:M;let O=Ps(kj(n,i)||m,i.getCurrentDirectory()),U=oMe(e,O,k);if(!U)return p?void 0:M;let H=p?void 0:Jvt(e,b,n,i,s),K=p||H===void 0?S&&iMe(U,S,N,i,n):void 0;if(p)return K;let re=H??(K===void 0&&m!==void 0?vM(U,N,n):K);if(!re)return M;if(l===1&&!Fp(re))return re;if(l===3&&!Fp(re)){let $=n.configFilePath?gc(hi(n.configFilePath),i.getCurrentDirectory(),t.getCanonicalFileName):t.getCanonicalFileName(i.getCurrentDirectory()),pe=gc(e,$,k),z=Ss(A,$),se=Ss(pe,$);if(z&&!se||!z&&se)return re;let Se=Ghe(i,hi(pe)),xe=Ghe(i,b),Z=!AN(i);return Bvt(Se,xe,Z)?M:re}return cMe(re)||GU(M)<GU(re)?M:re}function Bvt(e,t,n){return e===t?!0:e===void 0||t===void 0?!1:yy(e,t,n)===0}function GU(e){let t=0;for(let n=Ss(e,"./")?2:0;n<e.length;n++)e.charCodeAt(n)===47&&t++;return t}function eMe(e,t){return hy(t.isRedirect,e.isRedirect)||cR(e.path,t.path)}function Ghe(e,t){return e.getNearestAncestorDirectoryWithPackageJson?e.getNearestAncestorDirectoryWithPackageJson(t):Rm(t,n=>e.fileExists(li(n,"package.json"))?n:void 0)}function tMe(e,t,n,i,s){var o;let l=N1(n),p=n.getCurrentDirectory(),m=n.isSourceOfProjectReferenceRedirect(t)?n.getProjectReferenceRedirect(t):void 0,S=gc(t,p,l),h=n.redirectTargetsMap.get(S)||tt,A=[...m?[m]:tt,t,...h].map(U=>Ps(U,p)),k=!yr(A,b6);if(!i){let U=Te(A,H=>!(k&&b6(H))&&s(H,m===H));if(U)return U}let N=(o=n.getSymlinkCache)==null?void 0:o.call(n).getSymlinkedDirectoriesByRealpath(),M=Ps(t,p);return N&&Rm(hi(M),U=>{let H=N.get(hu(gc(U,p,l)));if(H)return qH(e,U,l)?!1:Te(A,K=>{if(!qH(K,U,l))return;let re=Om(U,K,l);for(let $ of H){let pe=Dv($,re),z=s(pe,K===m);if(k=!0,z)return z}})})||(i?Te(A,U=>k&&b6(U)?void 0:s(U,U===m)):void 0)}function rMe(e,t,n,i,s={}){var o;let l=gc(e.importingSourceFileName,n.getCurrentDirectory(),N1(n)),p=gc(t,n.getCurrentDirectory(),N1(n)),m=(o=n.getModuleSpecifierCache)==null?void 0:o.call(n);if(m){let h=m.get(l,p,i,s);if(h?.modulePaths)return h.modulePaths}let S=nMe(e,t,n);return m&&m.setModulePaths(l,p,i,s,S),S}function nMe(e,t,n){let i=new Map,s=!1;tMe(e.importingSourceFileName,t,n,!0,(l,p)=>{let m=OT(l);i.set(l,{path:e.getCanonicalFileName(l),isRedirect:p,isInNodeModules:m}),s=s||m});let o=[];for(let l=e.canonicalSourceDirectory;i.size!==0;){let p=hu(l),m;i.forEach(({path:h,isRedirect:b,isInNodeModules:A},k)=>{Ss(h,p)&&((m||(m=[])).push({path:k,isRedirect:b,isInNodeModules:A}),i.delete(k))}),m&&(m.length>1&&m.sort(eMe),o.push(...m));let S=hi(l);if(S===l)break;l=S}if(i.size){let l=In(i.entries(),([p,{isRedirect:m,isInNodeModules:S}])=>({path:p,isRedirect:m,isInNodeModules:S}));l.length>1&&l.sort(eMe),o.push(...l)}return o}function Uvt(e,t){var n;let i=(n=e.declarations)==null?void 0:n.find(l=>PY(l)&&(!qb(l)||!Nu(om(l.name))));if(i)return i.name.text;let o=Wi(e.declarations,l=>{var p,m,S,h;if(!hl(l))return;let b=M(l);if(!((p=b?.parent)!=null&&p.parent&&Zg(b.parent)&&S_(b.parent.parent)&&ls(b.parent.parent.parent)))return;let A=(h=(S=(m=b.parent.parent.symbol.exports)==null?void 0:m.get("export="))==null?void 0:S.valueDeclaration)==null?void 0:h.expression;if(!A)return;let k=t.getSymbolAtLocation(A);if(!k)return;if((k?.flags&2097152?t.getAliasedSymbol(k):k)===l.symbol)return b.parent.parent;function M(O){for(;O.flags&8;)O=O.parent;return O}})[0];if(o)return o.name.text}function iMe(e,t,n,i,s){for(let l in t)for(let p of t[l]){let m=Ca(p),S=m.indexOf("*"),h=n.map(b=>({ending:b,value:vM(e,[b],s)}));if(Py(m)&&h.push({ending:void 0,value:e}),S!==-1){let b=m.substring(0,S),A=m.substring(S+1);for(let{ending:k,value:N}of h)if(N.length>=b.length+A.length&&Ss(N,b)&&Mc(N,A)&&o({ending:k,value:N})){let M=N.substring(b.length,N.length-A.length);if(!Fp(M))return jA(l,M)}}else if(Tt(h,b=>b.ending!==0&&m===b.value)||Tt(h,b=>b.ending===0&&m===b.value&&o(b)))return l}function o({ending:l,value:p}){return l!==0||p===vM(e,[l],s,i)}}function HU(e,t,n,i,s,o,l,p,m){if(typeof o=="string"){let S=!AN(t),h=()=>t.getCommonSourceDirectory(),b=m&&kZ(n,e,S,h),A=m&&AZ(n,e,S,h),k=Ps(li(i,o),void 0),N=LA(n)?ff(n)+Xhe(n,e):void 0;switch(p){case 0:if(N&&yy(N,k,S)===0||yy(n,k,S)===0||b&&yy(b,k,S)===0||A&&yy(A,k,S)===0)return{moduleFileToTry:s};break;case 1:if(N&&wm(k,N,S)){let H=Om(k,N,!1);return{moduleFileToTry:Ps(li(li(s,o),H),void 0)}}if(wm(k,n,S)){let H=Om(k,n,!1);return{moduleFileToTry:Ps(li(li(s,o),H),void 0)}}if(b&&wm(k,b,S)){let H=Om(k,b,!1);return{moduleFileToTry:li(s,H)}}if(A&&wm(k,A,S)){let H=Om(k,A,!1);return{moduleFileToTry:li(s,H)}}break;case 2:let M=k.indexOf("*"),O=k.slice(0,M),U=k.slice(M+1);if(N&&Ss(N,O,S)&&Mc(N,U,S)){let H=N.slice(O.length,N.length-U.length);return{moduleFileToTry:jA(s,H)}}if(Ss(n,O,S)&&Mc(n,U,S)){let H=n.slice(O.length,n.length-U.length);return{moduleFileToTry:jA(s,H)}}if(b&&Ss(b,O,S)&&Mc(b,U,S)){let H=b.slice(O.length,b.length-U.length);return{moduleFileToTry:jA(s,H)}}if(A&&Ss(A,O,S)&&Mc(A,U,S)){let H=A.slice(O.length,A.length-U.length);return{moduleFileToTry:jA(s,H)}}break}}else{if(Array.isArray(o))return Te(o,S=>HU(e,t,n,i,s,S,l,p,m));if(typeof o=="object"&&o!==null){for(let S of Vt(o))if(S==="default"||l.indexOf(S)>=0||gM(l,S)){let h=o[S],b=HU(e,t,n,i,s,h,l,p,m);if(b)return b}}}}function Vvt(e,t,n,i,s,o,l){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&qU(o)?Te(Vt(o),p=>{let m=Ps(li(s,p),void 0),S=Mc(p,"/")?1:p.includes("*")?2:0;return HU(e,t,n,i,m,o[p],l,S,!1)}):HU(e,t,n,i,s,o,l,0,!1)}function Jvt(e,t,n,i,s){var o,l,p;if(!i.readFile||!gB(n))return;let m=Ghe(i,t);if(!m)return;let S=li(m,"package.json"),h=(l=(o=i.getPackageJsonInfoCache)==null?void 0:o.call(i))==null?void 0:l.getPackageJsonInfo(S);if(whe(h)||!i.fileExists(S))return;let b=h?.contents.packageJsonContent||Lj(i.readFile(S)),A=b?.imports;if(!A)return;let k=nS(n,s);return(p=Te(Vt(A),N=>{if(!Ss(N,"#")||N==="#"||Ss(N,"#/"))return;let M=Mc(N,"/")?1:N.includes("*")?2:0;return HU(n,i,e,m,N,A[N],k,M,!0)}))==null?void 0:p.moduleFileToTry}function qvt(e,t,n,i,s,o){let l=sMe(t,e,i);if(l===void 0)return;let p=sMe(n,e,i),m=_a(p,h=>vr(l,b=>Lb(Om(h,b,i)))),S=MP(m,cR);if(S)return vM(S,s,o)}function Hhe({path:e,isRedirect:t},{getCanonicalFileName:n,canonicalSourceDirectory:i},s,o,l,p,m,S){if(!o.fileExists||!o.readFile)return;let h=oB(e);if(!h)return;let A=yM(p,l,s).getAllowedEndingsInPreferredOrder(),k=e,N=!1;if(!m){let re=h.packageRootIndex,$;for(;;){let{moduleFileToTry:pe,packageRootPath:z,blockedByExports:se,verbatimFromExports:Se}=K(re);if(Q_(l)!==1){if(se)return;if(Se)return pe}if(z){k=z,N=!0;break}if($||($=pe),re=e.indexOf(hc,re+1),re===-1){k=vM($,A,l,o);break}}}if(t&&!N)return;let M=o.getGlobalTypingsCacheLocation&&o.getGlobalTypingsCacheLocation(),O=n(k.substring(0,h.topLevelNodeModulesIndex));if(!(Ss(i,O)||M&&Ss(n(M),O)))return;let U=k.substring(h.topLevelPackageNameIndex+1),H=nO(U);return Q_(l)===1&&H===U?void 0:H;function K(re){var $,pe;let z=e.substring(0,re),se=li(z,"package.json"),Se=e,xe=!1,Z=(pe=($=o.getPackageJsonInfoCache)==null?void 0:$.call(o))==null?void 0:pe.getPackageJsonInfo(se);if(BU(Z)||Z===void 0&&o.fileExists(se)){let Q=Z?.contents.packageJsonContent||Lj(o.readFile(se)),ce=S||s.impliedNodeFormat;if(mB(l)){let ve=z.substring(h.topLevelPackageNameIndex+1),oe=nO(ve),Ee=nS(l,ce),Me=Q?.exports?Vvt(l,o,e,z,oe,Q.exports,Ee):void 0;if(Me)return{...Me,verbatimFromExports:!0};if(Q?.exports)return{moduleFileToTry:e,blockedByExports:!0}}let ye=Q?.typesVersions?FU(Q.typesVersions):void 0;if(ye){let ve=e.slice(z.length+1),oe=iMe(ve,ye.paths,A,o,l);oe===void 0?xe=!0:Se=li(z,oe)}let we=Q?.typings||Q?.types||Q?.main||"index.js";if(vs(we)&&!(xe&&qX(tB(ye.paths),we))){let ve=gc(we,z,n),oe=n(Se);if(ff(ve)===ff(oe))return{packageRootPath:z,moduleFileToTry:Se};if(Q?.type!=="module"&&!Ql(oe,SR)&&Ss(oe,ve)&&hi(oe)===sT(ve)&&ff(Cl(oe))==="index")return{packageRootPath:z,moduleFileToTry:Se}}}else{let Q=n(Se.substring(h.packageRootIndex+1));if(Q==="index.d.ts"||Q==="index.js"||Q==="index.ts"||Q==="index.tsx")return{moduleFileToTry:Se,packageRootPath:z}}return{moduleFileToTry:Se}}}function zvt(e,t){if(!e.fileExists)return;let n=ip(m6({allowJs:!0},[{extension:"node",isMixedContent:!1},{extension:"json",isMixedContent:!1,scriptKind:6}]));for(let i of n){let s=t+i;if(e.fileExists(s))return s}}function sMe(e,t,n){return Wi(t,i=>{let s=oMe(e,i,n);return s!==void 0&&cMe(s)?void 0:s})}function vM(e,t,n,i){if(Ql(e,[".json",".mjs",".cjs"]))return e;let s=ff(e);if(e===s)return e;let o=t.indexOf(2),l=t.indexOf(3);if(Ql(e,[".mts",".cts"])&&l!==-1&&l<o)return e;if(Ql(e,[".d.mts",".mts",".d.cts",".cts"]))return s+Yhe(e,n);if(!Ql(e,[".d.ts"])&&Ql(e,[".ts"])&&e.includes(".d."))return aMe(e);switch(t[0]){case 0:let p=cA(s,"/index");return i&&p!==s&&zvt(i,p)?s:p;case 1:return s;case 2:return s+Yhe(e,n);case 3:if(i_(e)){let m=t.findIndex(S=>S===0||S===1);return m!==-1&&m<o?s:s+Yhe(e,n)}return e;default:return I.assertNever(t[0])}}function aMe(e){let t=Cl(e);if(!Mc(e,".ts")||!t.includes(".d.")||Ql(t,[".d.ts"]))return;let n=lR(e,".ts"),i=n.substring(n.lastIndexOf("."));return n.substring(0,n.indexOf(".d."))+i}function Yhe(e,t){return Xhe(e,t)??I.fail(`Extension ${h6(e)} is unsupported:: FileName:: ${e}`)}function Xhe(e,t){let n=Py(e);switch(n){case".ts":case".d.ts":return".js";case".tsx":return t.jsx===1?".jsx":".js";case".js":case".jsx":case".json":return n;case".d.mts":case".mts":case".mjs":return".mjs";case".d.cts":case".cts":case".cjs":return".cjs";default:return}}function oMe(e,t,n){let i=dA(t,e,t,n,!1);return ap(i)?void 0:i}function cMe(e){return Ss(e,"..")}var Khe,Qhe=f({"src/compiler/moduleSpecifiers.ts"(){"use strict";fa(),Khe=(e=>(e[e.Relative=0]="Relative",e[e.NonRelative=1]="NonRelative",e[e.Shortest=2]="Shortest",e[e.ExternalNonRelative=3]="ExternalNonRelative",e))(Khe||{})}}),SE={};x(SE,{RelativePreference:()=>Khe,countPathComponents:()=>GU,forEachFileNameOfModule:()=>tMe,getModuleSpecifier:()=>WU,getModuleSpecifierPreferences:()=>yM,getModuleSpecifiers:()=>KRe,getModuleSpecifiersWithCacheInfo:()=>QRe,getNodeModulesPackageName:()=>Lvt,tryGetJSExtensionForFile:()=>Xhe,tryGetModuleSpecifiersFromCache:()=>Fvt,tryGetRealFileNameForNonJsDeclarationFileName:()=>aMe,updateModuleSpecifier:()=>Mvt});var Zhe=f({"src/compiler/_namespaces/ts.moduleSpecifiers.ts"(){"use strict";Qhe()}});function $vt(){this.flags=0}function yo(e){return e.id||(e.id=r0e,r0e++),e.id}function Ia(e){return e.id||(e.id=t0e,t0e++),e.id}function QQ(e,t){let n=Oy(e);return n===1||t&&n===2}function e0e(e){var t=[],n=r=>{t.push(r)},i,s=new Set,o,l,p=Ju.getSymbolConstructor(),m=Ju.getTypeConstructor(),S=Ju.getSignatureConstructor(),h=0,b=0,A=0,k=0,N=0,M=0,O,U,H=!1,K=ga(),re=[1],$=e.getCompilerOptions(),pe=ho($),z=T_($),se=!!$.experimentalDecorators,Se=D6($),xe=Cme($),Z=ix($),Q=K_($,"strictNullChecks"),ce=K_($,"strictFunctionTypes"),ye=K_($,"strictBindCallApply"),we=K_($,"strictPropertyInitialization"),ve=K_($,"noImplicitAny"),oe=K_($,"noImplicitThis"),Ee=K_($,"useUnknownInCatchVariables"),Me=!!$.keyofStringsOnly,Ge=Me?1:0,Ae=$.suppressExcessPropertyErrors?0:8192,Ie=$.exactOptionalPropertyTypes,Re=Tjt(),Ue=eJt(),kt=ph(),ke=ga(),$e=oo(4,"undefined");$e.declarations=[];var at=oo(1536,"globalThis",8);at.exports=ke,at.declarations=[],ke.set(at.escapedName,at);var $t=oo(4,"arguments"),St=oo(4,"require"),Ze=$.verbatimModuleSyntax?"verbatimModuleSyntax":"isolatedModules",yt=!$.verbatimModuleSyntax||!!$.importsNotUsedAsValues,ar,or,Fr=0,rn,Tr=0;let nr={getNodeCount:()=>d_(e.getSourceFiles(),(r,a)=>r+a.nodeCount,0),getIdentifierCount:()=>d_(e.getSourceFiles(),(r,a)=>r+a.identifierCount,0),getSymbolCount:()=>d_(e.getSourceFiles(),(r,a)=>r+a.symbolCount,b),getTypeCount:()=>h,getInstantiationCount:()=>A,getRelationCacheSizes:()=>({assignable:Mf.size,identity:Kf.size,subtype:Xh.size,strictSubtype:jd.size}),isUndefinedSymbol:r=>r===$e,isArgumentsSymbol:r=>r===$t,isUnknownSymbol:r=>r===dt,getMergedSymbol:mo,getDiagnostics:DYe,getGlobalDiagnostics:gVt,getRecursionIdentity:xae,getUnmatchedProperties:DCe,getTypeOfSymbolAtLocation:(r,a)=>{let _=Us(a);return _?lFt(r,_):ht},getTypeOfSymbol:vn,getSymbolsOfParameterPropertyDeclaration:(r,a)=>{let _=Us(r,Ls);return _===void 0?I.fail("Cannot get symbols of a synthetic parameter that cannot be resolved to a parse-tree node."):(I.assert(op(_,_.parent)),KO(_,Pc(a)))},getDeclaredTypeOfSymbol:dc,getPropertiesOfType:Io,getPropertyOfType:(r,a)=>ka(r,Pc(a)),getPrivateIdentifierPropertyOfType:(r,a,_)=>{let d=Us(_);if(!d)return;let y=Pc(a),T=toe(y,d);return T?mAe(r,T):void 0},getTypeOfPropertyOfType:(r,a)=>Xe(r,Pc(a)),getIndexInfoOfType:(r,a)=>K0(r,a===0?Le:It),getIndexInfosOfType:nf,getIndexInfosOfIndexSymbol:xxe,getSignaturesOfType:na,getIndexTypeOfType:(r,a)=>_b(r,a===0?Le:It),getIndexType:r=>gh(r),getBaseTypes:Cp,getBaseTypeOfLiteralType:s1,getWidenedType:Yp,getTypeFromTypeNode:r=>{let a=Us(r,es);return a?Ri(a):ht},getParameterType:Ig,getParameterIdentifierInfoAtPosition:B9t,getPromisedTypeOfPromise:$L,getAwaitedType:r=>IC(r),getReturnTypeOfSignature:Ao,isNullableType:i$,getNullableType:Jz,getNonNullableType:a1,getNonOptionalType:Pae,getTypeArguments:cc,typeToTypeNode:kt.typeToTypeNode,indexInfoToIndexSignatureDeclaration:kt.indexInfoToIndexSignatureDeclaration,signatureToSignatureDeclaration:kt.signatureToSignatureDeclaration,symbolToEntityName:kt.symbolToEntityName,symbolToExpression:kt.symbolToExpression,symbolToNode:kt.symbolToNode,symbolToTypeParameterDeclarations:kt.symbolToTypeParameterDeclarations,symbolToParameterDeclaration:kt.symbolToParameterDeclaration,typeParameterToDeclaration:kt.typeParameterToDeclaration,getSymbolsInScope:(r,a)=>{let _=Us(r);return _?hVt(_,a):[]},getSymbolAtLocation:r=>{let a=Us(r);return a?ng(a,!0):void 0},getIndexInfosAtLocation:r=>{let a=Us(r);return a?CVt(a):void 0},getShorthandAssignmentValueSymbol:r=>{let a=Us(r);return a?AVt(a):void 0},getExportSpecifierLocalTargetSymbol:r=>{let a=Us(r,R_);return a?kVt(a):void 0},getExportSymbolOfSymbol(r){return mo(r.exportSymbol||r)},getTypeAtLocation:r=>{let a=Us(r);return a?fP(a):ht},getTypeOfAssignmentPattern:r=>{let a=Us(r,Lw);return a&&Ioe(a)||ht},getPropertySymbolOfDestructuringAssignment:r=>{let a=Us(r,ze);return a?PVt(a):void 0},signatureToString:(r,a,_,d)=>t0(r,Us(a),_,d),typeToString:(r,a,_)=>Kr(r,Us(a),_),symbolToString:(r,a,_,d)=>Oi(r,Us(a),_,d),typePredicateToString:(r,a,_)=>r0(r,Us(a),_),writeSignature:(r,a,_,d,y)=>t0(r,Us(a),_,d,y),writeType:(r,a,_,d)=>Kr(r,Us(a),_,d),writeSymbol:(r,a,_,d,y)=>Oi(r,Us(a),_,d,y),writeTypePredicate:(r,a,_,d)=>r0(r,Us(a),_,d),getAugmentedPropertiesOfType:gke,getRootSymbols:jYe,getSymbolOfExpando:uoe,getContextualType:(r,a)=>{let _=Us(r,bt);if(_)return a&4?xs(_,()=>Bf(_,a)):Bf(_,a)},getContextualTypeForObjectLiteralElement:r=>{let a=Us(r,by);return a?tAe(a,void 0):void 0},getContextualTypeForArgumentAtIndex:(r,a)=>{let _=Us(r,Vb);return _&&eAe(_,a)},getContextualTypeForJsxAttribute:r=>{let a=Us(r,O9);return a&&QWe(a,void 0)},isContextSensitive:$d,getTypeOfPropertyOfContextualType:Sb,getFullyQualifiedName:Wp,getResolvedSignature:(r,a,_)=>zi(r,a,_,0),getCandidateSignaturesForStringLiteralCompletions:tr,getResolvedSignatureForSignatureHelp:(r,a,_)=>ki(r,()=>zi(r,a,_,16)),getExpandedParameters:Zqe,hasEffectiveRestParameter:u0,containsArgumentsReference:Txe,getConstantValue:r=>{let a=Us(r,qYe);return a?hke(a):void 0},isValidPropertyAccess:(r,a)=>{let _=Us(r,kpe);return!!_&&H5t(_,Pc(a))},isValidPropertyAccessForCompletions:(r,a,_)=>{let d=Us(r,Hn);return!!d&&PGe(d,a,_)},getSignatureFromDeclaration:r=>{let a=Us(r,ca);return a?Sm(a):void 0},isImplementationOfOverload:r=>{let a=Us(r,ca);return a?VYe(a):void 0},getImmediateAliasedSymbol:aAe,getAliasedSymbol:du,getEmitResolver:X1,getExportsOfModule:tC,getExportsAndPropertiesOfModule:oI,forEachExportAndPropertyOfModule:cI,getSymbolWalker:Whe(IRt,zd,Ao,Cp,kg,vn,tg,Sf,Jp,cc),getAmbientModules:qJt,getJsxIntrinsicTagNamesAt:k5t,isOptionalParameter:r=>{let a=Us(r,Ls);return a?gL(a):!1},tryGetMemberInModuleExports:(r,a)=>rC(Pc(r),a),tryGetMemberInModuleExportsAndProperties:(r,a)=>lI(Pc(r),a),tryFindAmbientModule:r=>Xse(r,!0),tryFindAmbientModuleWithoutAugmentations:r=>Xse(r,!1),getApparentType:Tf,getUnionType:pi,isTypeAssignableTo:Na,createAnonymousType:Ho,createSignature:X0,createSymbol:oo,createIndexInfo:o0,getAnyType:()=>W,getStringType:()=>Le,getStringLiteralType:jf,getNumberType:()=>It,getNumberLiteralType:Ng,getBigIntType:()=>Rt,createPromiseType:m$,createArrayType:P_,getElementTypeOfArrayType:Vz,getBooleanType:()=>Pi,getFalseType:r=>r?Zt:Ir,getTrueType:r=>r?zr:Yr,getVoidType:()=>fn,getUndefinedType:()=>Be,getNullType:()=>he,getESSymbolType:()=>Fi,getNeverType:()=>Qn,getOptionalType:()=>X,getPromiseType:()=>Cz(!1),getPromiseLikeType:()=>Uze(!1),getAsyncIterableType:()=>{let r=aae(!1);if(r!==$s)return r},isSymbolAccessible:$i,isArrayType:Gd,isTupleType:Ka,isArrayLikeType:cv,isEmptyAnonymousObjectType:l0,isTypeInvalidDueToUnionDiscriminant:fRt,getExactOptionalProperties:B7t,getAllPossiblePropertiesOfTypes:pRt,getSuggestedSymbolForNonexistentProperty:yAe,getSuggestionForNonexistentProperty:vAe,getSuggestedSymbolForNonexistentJSXAttribute:AGe,getSuggestedSymbolForNonexistentSymbol:(r,a,_)=>SAe(r,Pc(a),_),getSuggestionForNonexistentSymbol:(r,a,_)=>z5t(r,Pc(a),_),getSuggestedSymbolForNonexistentModule:noe,getSuggestionForNonexistentExport:$5t,getSuggestedSymbolForNonexistentClassMember:CGe,getBaseConstraintOfType:k_,getDefaultFromTypeParameter:r=>r&&r.flags&262144?pC(r):void 0,resolveName(r,a,_,d){return wc(a,Pc(r),_,void 0,void 0,!1,d)},getJsxNamespace:r=>Zi(GT(r)),getJsxFragmentFactory:r=>{let a=vke(r);return a&&Zi(Jp(a).escapedText)},getAccessibleSymbolChain:xS,getTypePredicateOfSignature:zd,resolveExternalModuleName:r=>{let a=Us(r,bt);return a&&rf(a,a,!0)},resolveExternalModuleSymbol:bp,tryGetThisTypeAt:(r,a,_)=>{let d=Us(r);return d&&XCe(d,a,_)},getTypeArgumentConstraint:r=>{let a=Us(r,es);return a&&Zjt(a)},getSuggestionDiagnostics:(r,a)=>{let _=Us(r,ls)||I.fail("Could not determine parsed source file.");if(y6(_,$,e))return tt;let d;try{return i=a,dke(_),I.assert(!!(_i(_).flags&1)),d=jt(d,jx.getDiagnostics(_.fileName)),WHe(NYe(_),(y,T,P)=>{!rN(y)&&!PYe(T,!!(y.flags&33554432))&&(d||(d=[])).push({...P,category:2})}),d||tt}finally{i=void 0}},runWithCancellationToken:(r,a)=>{try{return i=r,a(nr)}finally{i=void 0}},getLocalTypeParametersOfClassOrInterfaceOrTypeAlias:qn,isDeclarationVisible:Eg,isPropertyAccessible:bAe,getTypeOnlyAliasDeclaration:Bd,getMemberOverrideModifierStatus:IUt,isTypeParameterPossiblyReferenced:wz,typeHasCallOrConstructSignatures:woe};function tr(r,a){let _=new Set,d=[];xs(a,()=>zi(r,d,void 0,0));for(let y of d)_.add(y);d.length=0,ki(a,()=>zi(r,d,void 0,0));for(let y of d)_.add(y);return In(_)}function ki(r,a){if(r=Gr(r,pY),r){let _=[],d=[];for(;r;){let T=_i(r);if(_.push([T,T.resolvedSignature]),T.resolvedSignature=void 0,iE(r)){let P=as(Rn(r)),L=P.type;d.push([P,L]),P.type=void 0}r=Gr(r.parent,pY)}let y=a();for(let[T,P]of _)T.resolvedSignature=P;for(let[T,P]of d)T.type=P;return y}return a()}function xs(r,a){let _=Gr(r,Vb);if(_){let y=r;do _i(y).skipDirectInference=!0,y=y.parent;while(y&&y!==_)}H=!0;let d=ki(r,a);if(H=!1,_){let y=r;do _i(y).skipDirectInference=void 0,y=y.parent;while(y&&y!==_)}return d}function zi(r,a,_,d){let y=Us(r,Vb);ar=_;let T=y?OI(y,a,d):void 0;return ar=void 0,T}var Ms=new Map,un=new Map,ri=new Map,On=new Map,_r=new Map,rt=new Map,zt=new Map,Rr=new Map,vi=new Map,Ni=new Map,us=new Map,Fs=new Map,Ta=new Map,to=new Map,Nr=new Map,qr=[],We=new Map,mt=new Set,dt=oo(4,"unknown"),Ot=oo(0,"__resolving__"),_e=new Map,Ve=new Map,pt=new Set,W=Dl(1,"any"),st=Dl(1,"any",262144,"auto"),Nt=Dl(1,"any",void 0,"wildcard"),Ke=Dl(1,"any",void 0,"blocked string"),ht=Dl(1,"error"),Wt=Dl(1,"unresolved"),Cr=Dl(1,"any",65536,"non-inferrable"),hr=Dl(1,"intrinsic"),Sr=Dl(2,"unknown"),Y=Dl(2,"unknown",void 0,"non-null"),Be=Dl(32768,"undefined"),Lt=Q?Be:Dl(32768,"undefined",65536,"widening"),B=Dl(32768,"undefined",void 0,"missing"),le=Ie?B:Be,X=Dl(32768,"undefined",void 0,"optional"),he=Dl(65536,"null"),qe=Q?he:Dl(65536,"null",65536,"widening"),Le=Dl(4,"string"),It=Dl(8,"number"),Rt=Dl(64,"bigint"),Zt=Dl(512,"false",void 0,"fresh"),Ir=Dl(512,"false"),zr=Dl(512,"true",void 0,"fresh"),Yr=Dl(512,"true");zr.regularType=Yr,zr.freshType=zr,Yr.regularType=Yr,Yr.freshType=zr,Zt.regularType=Ir,Zt.freshType=Zt,Ir.regularType=Ir,Ir.freshType=Zt;var Pi=pi([Ir,Yr]),Fi=Dl(4096,"symbol"),fn=Dl(16384,"void"),Qn=Dl(131072,"never"),Ns=Dl(131072,"never",262144,"silent"),Vi=Dl(131072,"never",void 0,"implicit"),ji=Dl(131072,"never",void 0,"unreachable"),ni=Dl(67108864,"object"),js=pi([Le,It]),Mr=pi([Le,It,Fi]),Qo=Me?Le:Mr,Sl=pi([It,Rt]),zs=pi([Le,It,Pi,Rt,he,Be]),Eo=mC(["",""],[It]),nc=Iz(r=>r.flags&262144?f7t(r):r,()=>"(restrictive mapper)"),Dc=Iz(r=>r.flags&262144?Nt:r,()=>"(permissive mapper)"),zu=Dl(131072,"never",void 0,"unique literal"),ks=Iz(r=>r.flags&262144?zu:r,()=>"(unique literal mapper)"),ya,$u=Iz(r=>(ya&&(r===yp||r===Go||r===ru)&&ya(!0),r),()=>"(unmeasurable reporter)"),Uo=Iz(r=>(ya&&(r===yp||r===Go||r===ru)&&ya(!1),r),()=>"(unreliable reporter)"),$a=Ho(void 0,K,tt,tt,tt),Ac=Ho(void 0,K,tt,tt,tt);Ac.objectFlags|=2048;var Ld=oo(2048,"__type");Ld.members=ga();var Nl=Ho(Ld,K,tt,tt,tt),zc=Ho(void 0,K,tt,tt,tt),Tc=Q?pi([Be,he,zc]):Sr,$s=Ho(void 0,K,tt,tt,tt);$s.instantiations=new Map;var cr=Ho(void 0,K,tt,tt,tt);cr.objectFlags|=262144;var ic=Ho(void 0,K,tt,tt,tt),Mu=Ho(void 0,K,tt,tt,tt),Wu=Ho(void 0,K,tt,tt,tt),yp=Sd(),Go=Sd();Go.constraint=yp;var ru=Sd(),ge=Sd(),ne=Sd();ne.constraint=ge;var je=Ez(1,"<<unresolved>>",0,W),Et=X0(void 0,void 0,void 0,tt,W,void 0,0,0),gr=X0(void 0,void 0,void 0,tt,ht,void 0,0,0),Dn=X0(void 0,void 0,void 0,tt,W,void 0,0,0),xn=X0(void 0,void 0,void 0,tt,Ns,void 0,0,0),Zn=o0(It,Le,!0),Bi=new Map,Jn={get yieldType(){return I.fail("Not supported")},get returnType(){return I.fail("Not supported")},get nextType(){return I.fail("Not supported")}},ia=_v(W,W,W),Fc=_v(W,W,Sr),bu=_v(Qn,W,Be),sc={iterableCacheKey:"iterationTypesOfAsyncIterable",iteratorCacheKey:"iterationTypesOfAsyncIterator",iteratorSymbolName:"asyncIterator",getGlobalIteratorType:WRt,getGlobalIterableType:aae,getGlobalIterableIteratorType:GRt,getGlobalGeneratorType:HRt,resolveIterationType:(r,a)=>IC(r,a,g.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member),mustHaveANextMethodDiagnostic:g.An_async_iterator_must_have_a_next_method,mustBeAMethodDiagnostic:g.The_0_property_of_an_async_iterator_must_be_a_method,mustHaveAValueDiagnostic:g.The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property},Jl={iterableCacheKey:"iterationTypesOfIterable",iteratorCacheKey:"iterationTypesOfIterator",iteratorSymbolName:"iterator",getGlobalIteratorType:YRt,getGlobalIterableType:Lxe,getGlobalIterableIteratorType:XRt,getGlobalGeneratorType:KRt,resolveIterationType:(r,a)=>r,mustHaveANextMethodDiagnostic:g.An_iterator_must_have_a_next_method,mustBeAMethodDiagnostic:g.The_0_property_of_an_iterator_must_be_a_method,mustHaveAValueDiagnostic:g.The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property},jo,Eu=new Map,Xf=[],pu,gm,tf,Oe,Bt,Zr,Ds,sa,ua,Tl,ql,bc,Ic,cl,bl,xu,dd,wf,hf,Fd,ch,Yh,Ly,A_,Fy,vp,U0,Of,ie,ct,Jt,Gt,V,Pe,ot,Yt,_n,gi,ci,ds,Ya,Xa,Zc,Gu,nu,Sp,Rf,_S,xo,Wm,Gm,ts,jy,H1,Hm,wE,OE,md=new Map,lh=0,gd=0,By=0,Je=!1,et=0,Ft,Ht,Er,nn=[],br=[],sn=[],Ci=0,hn=[],mi=[],Tn=0,aa=jf(""),ao=Ng(0),B_=_ae({negative:!1,base10Value:"0"}),Hu=[],Uy=[],qT=[],Rk=0,zT=!1,HD=0,YD=10,XD=[],Lx=[],RE=[],Mk=[],KD=[],Lk=[],Fk=[],jk=[],Bk=[],Fx=[],Uk=[],ME=[],LE=[],fS=[],pS=[],V0=[],$T=[],fo=EN(),jx=EN(),QD=e0(),WT,Vy,Xh=new Map,jd=new Map,Mf=new Map,Tp=new Map,Kf=new Map,Y1=new Map,Bx=ga();Bx.set($e.escapedName,$e);var ZD=[[".mts",".mjs"],[".ts",".js"],[".cts",".cjs"],[".mjs",".mjs"],[".js",".js"],[".cjs",".cjs"],[".tsx",$.jsx===1?".jsx":".js"],[".jsx",".jsx"],[".json",".json"]];return tJt(),nr;function Vk(r){return r?Nr.get(r):void 0}function dS(r,a){return r&&Nr.set(r,a),a}function GT(r){if(r){let a=Xr(r);if(a)if(nk(r)){if(a.localJsxFragmentNamespace)return a.localJsxFragmentNamespace;let _=a.pragmas.get("jsxfrag");if(_){let y=os(_)?_[0]:_;if(a.localJsxFragmentFactory=ok(y.arguments.factory,pe),nt(a.localJsxFragmentFactory,zl,zf),a.localJsxFragmentFactory)return a.localJsxFragmentNamespace=Jp(a.localJsxFragmentFactory).escapedText}let d=vke(r);if(d)return a.localJsxFragmentFactory=d,a.localJsxFragmentNamespace=Jp(d).escapedText}else{let _=Jk(a);if(_)return a.localJsxNamespace=_}}return WT||(WT="React",$.jsxFactory?(Vy=ok($.jsxFactory,pe),nt(Vy,zl),Vy&&(WT=Jp(Vy).escapedText)):$.reactNamespace&&(WT=Pc($.reactNamespace))),Vy||(Vy=j.createQualifiedName(j.createIdentifier(Zi(WT)),"createElement")),WT}function Jk(r){if(r.localJsxNamespace)return r.localJsxNamespace;let a=r.pragmas.get("jsx");if(a){let _=os(a)?a[0]:a;if(r.localJsxFactory=ok(_.arguments.factory,pe),nt(r.localJsxFactory,zl,zf),r.localJsxFactory)return r.localJsxNamespace=Jp(r.localJsxFactory).escapedText}}function zl(r){return jh(r,-1,-1),wr(r,zl,void 0)}function X1(r,a){return DYe(r,a),Ue}function qk(r,a,..._){let d=r?$n(r,a,..._):fl(a,..._),y=fo.lookup(d);return y||(fo.add(d),d)}function yg(r,a,_,...d){let y=He(a,_,...d);return y.skippedOn=r,y}function Ux(r,a,..._){return r?$n(r,a,..._):fl(a,..._)}function He(r,a,..._){let d=Ux(r,a,..._);return fo.add(d),d}function vg(r,a){r?fo.add(a):jx.add({...a,category:2})}function Yu(r,a,_,...d){if(a.pos<0||a.end<0){if(!r)return;let y=Xr(a);vg(r,"message"in _?Iu(y,0,0,_,...d):FY(y,_));return}vg(r,"message"in _?$n(a,_,...d):Ey(Xr(a),a,_))}function HT(r,a,_,...d){let y=He(r,_,...d);if(a){let T=$n(r,g.Did_you_forget_to_use_await);Ga(y,T)}return y}function zk(r,a){let _=Array.isArray(r)?Te(r,ZH):ZH(r);return _&&Ga(a,$n(_,g.The_declaration_was_marked_as_deprecated_here)),jx.add(a),a}function mS(r){let a=yf(r);return a&&de(r.declarations)>1?a.flags&64?Tt(r.declarations,K1):yr(r.declarations,K1):!!r.valueDeclaration&&K1(r.valueDeclaration)||de(r.declarations)&&yr(r.declarations,K1)}function K1(r){return!!(f2(r)&536870912)}function Q1(r,a,_){let d=$n(r,g._0_is_deprecated,_);return zk(a,d)}function XO(r,a,_,d){let y=_?$n(r,g.The_signature_0_of_1_is_deprecated,d,_):$n(r,g._0_is_deprecated,d);return zk(a,y)}function oo(r,a,_){b++;let d=new p(r|33554432,a);return d.links=new s0e,d.links.checkFlags=_||0,d}function Sg(r,a){let _=oo(1,r);return _.links.type=a,_}function Vx(r,a){let _=oo(4,r);return _.links.type=a,_}function Jx(r){let a=0;return r&2&&(a|=111551),r&1&&(a|=111550),r&4&&(a|=0),r&8&&(a|=900095),r&16&&(a|=110991),r&32&&(a|=899503),r&64&&(a|=788872),r&256&&(a|=899327),r&128&&(a|=899967),r&512&&(a|=110735),r&8192&&(a|=103359),r&32768&&(a|=46015),r&65536&&(a|=78783),r&262144&&(a|=526824),r&524288&&(a|=788968),r&2097152&&(a|=2097152),a}function YT(r,a){a.mergeId||(a.mergeId=n0e,n0e++),XD[a.mergeId]=r}function qx(r){let a=oo(r.flags,r.escapedName);return a.declarations=r.declarations?r.declarations.slice():[],a.parent=r.parent,r.valueDeclaration&&(a.valueDeclaration=r.valueDeclaration),r.constEnumOnlyModule&&(a.constEnumOnlyModule=!0),r.members&&(a.members=new Map(r.members)),r.exports&&(a.exports=new Map(r.exports)),YT(a,r),a}function hm(r,a,_=!1){if(!(r.flags&Jx(a.flags))||(a.flags|r.flags)&67108864){if(a===r)return r;if(!(r.flags&33554432)){let y=ll(r);if(y===dt)return a;r=qx(y)}a.flags&512&&r.flags&512&&r.constEnumOnlyModule&&!a.constEnumOnlyModule&&(r.constEnumOnlyModule=!1),r.flags|=a.flags,a.valueDeclaration&&L8(r,a.valueDeclaration),jt(r.declarations,a.declarations),a.members&&(r.members||(r.members=ga()),Tg(r.members,a.members,_)),a.exports&&(r.exports||(r.exports=ga()),Tg(r.exports,a.exports,_)),_||YT(r,a)}else if(r.flags&1024)r!==at&&He(a.declarations&&qs(a.declarations[0]),g.Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity,Oi(r));else{let y=!!(r.flags&384||a.flags&384),T=!!(r.flags&2||a.flags&2),P=y?g.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations:T?g.Cannot_redeclare_block_scoped_variable_0:g.Duplicate_identifier_0,L=a.declarations&&Xr(a.declarations[0]),J=r.declarations&&Xr(r.declarations[0]),G=p8(L,$.checkJs),ae=p8(J,$.checkJs),Ce=Oi(a);if(L&&J&&jo&&!y&&L!==J){let be=yy(L.path,J.path)===-1?L:J,Ye=be===L?J:L,vt=km(jo,`${be.path}|${Ye.path}`,()=>({firstFile:be,secondFile:Ye,conflictingSymbols:new Map})),Dt=km(vt.conflictingSymbols,Ce,()=>({isBlockScoped:T,firstFileLocations:[],secondFileLocations:[]}));G||d(Dt.firstFileLocations,a),ae||d(Dt.secondFileLocations,r)}else G||ym(a,P,Ce,r),ae||ym(r,P,Ce,a)}return r;function d(y,T){if(T.declarations)for(let P of T.declarations)ln(y,P)}}function ym(r,a,_,d){Te(r.declarations,y=>{Jy(y,a,_,d.declarations)})}function Jy(r,a,_,d){let y=(hT(r,!1)?GY(r):qs(r))||r,T=qk(y,a,_);for(let P of d||tt){let L=(hT(P,!1)?GY(P):qs(P))||P;if(L===y)continue;T.relatedInformation=T.relatedInformation||[];let J=$n(L,g._0_was_also_declared_here,_),G=$n(L,g.and_here);de(T.relatedInformation)>=5||Tt(T.relatedInformation,ae=>p6(ae,G)===0||p6(ae,J)===0)||Ga(T,de(T.relatedInformation)?G:J)}}function $k(r,a){if(!r?.size)return a;if(!a?.size)return r;let _=ga();return Tg(_,r),Tg(_,a),_}function Tg(r,a,_=!1){a.forEach((d,y)=>{let T=r.get(y);r.set(y,T?hm(T,d,_):mo(d))})}function eI(r){var a,_,d;let y=r.parent;if(((a=y.symbol.declarations)==null?void 0:a[0])!==y){I.assert(y.symbol.declarations.length>1);return}if(zg(y))Tg(ke,y.symbol.exports);else{let T=r.parent.parent.flags&33554432?void 0:g.Invalid_module_name_in_augmentation_module_0_cannot_be_found,P=Wy(r,r,T,!0);if(!P)return;if(P=bp(P),P.flags&1920)if(Tt(gm,L=>P===L.symbol)){let L=hm(y.symbol,P,!0);tf||(tf=new Map),tf.set(r.text,L)}else{if((_=P.exports)!=null&&_.get("__export")&&((d=y.symbol.exports)!=null&&d.size)){let L=ixe(P,"resolvedExports");for(let[J,G]of In(y.symbol.exports.entries()))L.has(J)&&!P.exports.has(J)&&hm(L.get(J),G)}hm(P,y.symbol)}else He(r,g.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity,r.text)}}function FE(r,a,_){a.forEach((y,T)=>{let P=r.get(T);P?Te(P.declarations,d(Zi(T),_)):r.set(T,y)});function d(y,T){return P=>fo.add($n(P,T,y))}}function as(r){if(r.flags&33554432)return r.links;let a=Ia(r);return Lx[a]??(Lx[a]=new s0e)}function _i(r){let a=yo(r);return RE[a]||(RE[a]=new $vt)}function Kh(r){return r.kind===312&&!Bp(r)}function Lf(r,a,_){if(_){let d=mo(r.get(a));if(d&&(I.assert((Vc(d)&1)===0,"Should never get an instantiated symbol here."),d.flags&_||d.flags&2097152&&a_(d)&_))return d}}function KO(r,a){let _=r.parent,d=r.parent.parent,y=Lf(_.locals,a,111551),T=Lf(MS(d.symbol),a,111551);return y&&T?[y,T]:I.fail("There should exist two symbols, one as property declaration and one as parameter declaration")}function qy(r,a){let _=Xr(r),d=Xr(a),y=Lh(r);if(_!==d){if(z&&(_.externalModuleIndicator||d.externalModuleIndicator)||!Wo($)||ex(a)||r.flags&33554432||P(a,r))return!0;let J=e.getSourceFiles();return J.indexOf(_)<=J.indexOf(d)}if(a.flags&16777216||ex(a)||FCe(a))return!0;if(r.pos<=a.pos&&!(ea(r)&&x8(a.parent)&&!r.initializer&&!r.exclamationToken)){if(r.kind===208){let J=ST(a,208);return J?Gr(J,co)!==Gr(r,co)||r.pos<J.pos:qy(ST(r,260),a)}else{if(r.kind===260)return!T(r,a);if(Ti(r))return!Gr(a,J=>uo(J)&&J.parent.parent===r);if(ea(r))return!L(r,a,!1);if(op(r,r.parent))return!(xe&&Vu(r)===Vu(a)&&P(a,r))}return!0}if(a.parent.kind===281||a.parent.kind===277&&a.parent.isExportEquals||a.kind===277&&a.isExportEquals)return!0;if(P(a,r))return xe&&Vu(r)&&(ea(r)||op(r,r.parent))?!L(r,a,!0):!0;return!1;function T(J,G){switch(J.parent.parent.kind){case 243:case 248:case 250:if(BE(G,J,y))return!0;break}let ae=J.parent.parent;return QP(ae)&&BE(G,ae.expression,y)}function P(J,G){return!!Gr(J,ae=>{if(ae===y)return"quit";if(ca(ae))return!0;if(Jc(ae))return G.pos<J.pos;let Ce=ii(ae.parent,ea);if(Ce&&Ce.initializer===ae){if(pa(ae.parent)){if(G.kind===174)return!0;if(ea(G)&&Vu(J)===Vu(G)){let Ye=G.name;if(ze(Ye)||is(Ye)){let vt=vn(Rn(G)),Dt=Fn(G.parent.members,Jc);if(FUt(Ye,vt,Dt,G.parent.pos,ae.pos))return!0}}}else if(!(G.kind===172&&!pa(G))||Vu(J)!==Vu(G))return!0}return!1})}function L(J,G,ae){return G.end>J.end?!1:Gr(G,be=>{if(be===J)return"quit";switch(be.kind){case 219:return!0;case 172:return ae&&(ea(J)&&be.parent===J.parent||op(J,J.parent)&&be.parent===J.parent.parent)?"quit":!0;case 241:switch(be.parent.kind){case 177:case 174:case 178:return!0;default:return!1}default:return!1}})===void 0}}function QO(r,a,_){let d=ho($),y=a;if(Ls(_)&&y.body&&r.valueDeclaration&&r.valueDeclaration.pos>=y.body.pos&&r.valueDeclaration.end<=y.body.end&&d>=2){let L=_i(y);return L.declarationRequiresScopeChange===void 0&&(L.declarationRequiresScopeChange=Te(y.parameters,T)||!1),!L.declarationRequiresScopeChange}return!1;function T(L){return P(L.name)||!!L.initializer&&P(L.initializer)}function P(L){switch(L.kind){case 219:case 218:case 262:case 176:return!1;case 174:case 177:case 178:case 303:return P(L.name);case 172:return jl(L)?!xe:P(L.name);default:return nY(L)||w_(L)?d<7:co(L)&&L.dotDotDotToken&&pm(L.parent)?d<4:es(L)?!1:Qs(L,P)||!1}}}function gS(r){return U2(r)&&Ty(r.type)||$6(r)&&Ty(r.typeExpression)}function wc(r,a,_,d,y,T,P=!1,L=!0){return zp(r,a,_,d,y,T,P,L,Lf)}function zp(r,a,_,d,y,T,P,L,J){var G,ae,Ce;let be=r,Ye,vt,Dt,ur,pr,dn=!1,Ur=r,fr,$r=!1;e:for(;r;){if(a==="const"&&gS(r))return;if(c8(r)&&vt&&r.name===vt&&(vt=r,r=r.parent),Oh(r)&&r.locals&&!Kh(r)&&(Ye=J(r.locals,a,_))){let on=!0;if(ca(r)&&vt&&vt!==r.body?(_&Ye.flags&788968&&vt.kind!==327&&(on=Ye.flags&262144?vt===r.type||vt.kind===169||vt.kind===348||vt.kind===349||vt.kind===168:!1),_&Ye.flags&3&&(QO(Ye,r,vt)?on=!1:Ye.flags&1&&(on=vt.kind===169||vt===r.type&&!!Gr(Ye.valueDeclaration,Ls)))):r.kind===194&&(on=vt===r.trueType),on)break e;Ye=void 0}switch(dn=dn||vm(r,vt),r.kind){case 312:if(!Bp(r))break;$r=!0;case 267:let on=((G=Rn(r))==null?void 0:G.exports)||K;if(r.kind===312||hl(r)&&r.flags&33554432&&!zg(r)){if(Ye=on.get("default")){let Bs=PN(Ye);if(Bs&&Ye.flags&_&&Bs.escapedName===a)break e;Ye=void 0}let cn=on.get(a);if(cn&&cn.flags===2097152&&(xc(cn,281)||xc(cn,280)))break}if(a!=="default"&&(Ye=J(on,a,_&2623475)))if(ls(r)&&r.commonJsModuleIndicator&&!((ae=Ye.declarations)!=null&&ae.some(am)))Ye=void 0;else break e;break;case 266:if(Ye=J(((Ce=Rn(r))==null?void 0:Ce.exports)||K,a,_&8)){d&&fm($)&&!(r.flags&33554432)&&Xr(r)!==Xr(Ye.valueDeclaration)&&He(Ur,g.Cannot_access_0_from_another_file_without_qualification_when_1_is_enabled_Use_2_instead,Zi(a),Ze,`${Zi(yd(r).escapedName)}.${Zi(a)}`);break e}break;case 172:if(!pa(r)){let cn=Gy(r.parent);cn&&cn.locals&&J(cn.locals,a,_&111551)&&(I.assertNode(r,ea),ur=r)}break;case 263:case 231:case 264:if(Ye=J(Rn(r).members||K,a,_&788968)){if(!zy(Ye,r)){Ye=void 0;break}if(vt&&pa(vt)){d&&He(Ur,g.Static_members_cannot_reference_class_type_parameters);return}break e}if(wu(r)&&_&32){let cn=r.name;if(cn&&a===cn.escapedText){Ye=r.symbol;break e}}break;case 233:if(vt===r.expression&&r.parent.token===96){let cn=r.parent.parent;if(Ti(cn)&&(Ye=J(Rn(cn).members,a,_&788968))){d&&He(Ur,g.Base_class_expressions_cannot_reference_class_type_parameters);return}}break;case 167:if(fr=r.parent.parent,(Ti(fr)||fr.kind===264)&&(Ye=J(Rn(fr).members,a,_&788968))){d&&He(Ur,g.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);return}break;case 219:if(ho($)>=2)break;case 174:case 176:case 177:case 178:case 262:if(_&3&&a==="arguments"){Ye=$t;break e}break;case 218:if(_&3&&a==="arguments"){Ye=$t;break e}if(_&16){let cn=r.name;if(cn&&a===cn.escapedText){Ye=r.symbol;break e}}break;case 170:r.parent&&r.parent.kind===169&&(r=r.parent),r.parent&&(Du(r.parent)||r.parent.kind===263)&&(r=r.parent);break;case 353:case 345:case 347:let Qr=yN(r);Qr&&(r=Qr.parent);break;case 169:vt&&(vt===r.initializer||vt===r.name&&la(vt))&&(pr||(pr=r));break;case 208:vt&&(vt===r.initializer||vt===r.name&&la(vt))&&Kb(r)&&!pr&&(pr=r);break;case 195:if(_&262144){let cn=r.typeParameter.name;if(cn&&a===cn.escapedText){Ye=r.typeParameter.symbol;break e}}break;case 281:vt&&vt===r.propertyName&&r.parent.parent.moduleSpecifier&&(r=r.parent.parent.parent);break}hS(r)&&(Dt=r),vt=r,r=dm(r)?yj(r)||r.parent:(mg(r)||_U(r))&&yT(r)||r.parent}if(T&&Ye&&(!Dt||Ye!==Dt.symbol)&&(Ye.isReferenced|=_),!Ye){if(vt&&(I.assertNode(vt,ls),vt.commonJsModuleIndicator&&a==="exports"&&_&vt.symbol.flags))return vt.symbol;P||(Ye=J(ke,a,_))}if(!Ye&&be&&gn(be)&&be.parent&&_f(be.parent,!1))return St;function Jr(){return ur&&!xe?(He(Ur,Ur&&ur.type&&G3(ur.type,Ur.pos)?g.Type_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor:g.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor,qo(ur.name),Ym(y)),!0):!1}if(Ye){if(d&&Jr())return}else{d&&n(()=>{if(!Ur||Ur.parent.kind!==331&&!jE(Ur,a,y)&&!Jr()&&!zx(Ur)&&!Wk(Ur,a,_)&&!Z1(Ur,a)&&!$x(Ur,a,_)&&!tI(Ur,a,_)&&!z0(Ur,a,_)){let on,Qr;if(y&&(Qr=J5t(y),Qr&&He(Ur,d,Ym(y),Qr)),!Qr&&L&&HD<YD&&(on=SAe(be,a,_),on?.valueDeclaration&&S_(on.valueDeclaration)&&zg(on.valueDeclaration)&&(on=void 0),on)){let Bs=Oi(on),Os=hAe(be,on,!1),Ys=_===1920||y&&typeof y!="string"&&_c(y)?g.Cannot_find_namespace_0_Did_you_mean_1:Os?g.Could_not_find_name_0_Did_you_mean_1:g.Cannot_find_name_0_Did_you_mean_1,As=Ux(Ur,Ys,Ym(y),Bs);vg(!Os,As),on.valueDeclaration&&Ga(As,$n(on.valueDeclaration,g._0_is_declared_here,Bs))}!on&&!Qr&&y&&He(Ur,d,Ym(y)),HD++}});return}return d&&n(()=>{var on;if(Ur&&(_&2||(_&32||_&384)&&(_&111551)===111551)){let Qr=vd(Ye);(Qr.flags&2||Qr.flags&32||Qr.flags&384)&&pc(Qr,Ur)}if(Ye&&$r&&(_&111551)===111551&&!(be.flags&16777216)){let Qr=mo(Ye);de(Qr.declarations)&&yr(Qr.declarations,cn=>BR(cn)||ls(cn)&&!!cn.symbol.globalExports)&&Yu(!$.allowUmdGlobalAccess,Ur,g._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead,Zi(a))}if(Ye&&pr&&!dn&&(_&111551)===111551){let Qr=mo(Gse(Ye)),cn=Gg(pr);Qr===Rn(pr)?He(Ur,g.Parameter_0_cannot_reference_itself,qo(pr.name)):Qr.valueDeclaration&&Qr.valueDeclaration.pos>pr.pos&&cn.parent.locals&&J(cn.parent.locals,Qr.escapedName,_)===Qr&&He(Ur,g.Parameter_0_cannot_reference_identifier_1_declared_after_it,qo(pr.name),qo(Ur))}if(Ye&&Ur&&_&111551&&Ye.flags&2097152&&!(Ye.flags&111551)&&!ET(Ur)){let Qr=Bd(Ye,111551);if(Qr){let cn=Qr.kind===281||Qr.kind===278||Qr.kind===280?g._0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type:g._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type,Bs=Zi(a);J0(He(Ur,cn,Bs),Qr,Bs)}}if($.isolatedModules&&Ye&&$r&&(_&111551)===111551){let cn=J(ke,a,_)===Ye&&ls(vt)&&vt.locals&&J(vt.locals,a,-111552);if(cn){let Bs=(on=cn.declarations)==null?void 0:on.find(Os=>Os.kind===276||Os.kind===273||Os.kind===274||Os.kind===271);Bs&&!t8(Bs)&&He(Bs,g.Import_0_conflicts_with_global_value_used_in_this_file_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled,Zi(a))}}}),Ye}function J0(r,a,_){return a?Ga(r,$n(a,a.kind===281||a.kind===278||a.kind===280?g._0_was_exported_here:g._0_was_imported_here,_)):r}function vm(r,a){return r.kind!==219&&r.kind!==218?YA(r)||(tc(r)||r.kind===172&&!pa(r))&&(!a||a!==r.name):a&&a===r.name?!1:r.asteriskToken||ui(r,1024)?!0:!W2(r)}function hS(r){switch(r.kind){case 262:case 263:case 264:case 266:case 265:case 267:return!0;default:return!1}}function Ym(r){return vs(r)?Zi(r):qo(r)}function zy(r,a){if(r.declarations){for(let _ of r.declarations)if(_.kind===168&&(dm(_.parent)?X2(_.parent):_.parent)===a)return!(dm(_.parent)&&mr(_.parent.parent.tags,am))}return!1}function jE(r,a,_){if(!ze(r)||r.escapedText!==a||IYe(r)||ex(r))return!1;let d=kf(r,!1,!1),y=d;for(;y;){if(Ti(y.parent)){let T=Rn(y.parent);if(!T)break;let P=vn(T);if(ka(P,a))return He(r,g.Cannot_find_name_0_Did_you_mean_the_static_member_1_0,Ym(_),Oi(T)),!0;if(y===d&&!pa(y)){let L=dc(T).thisType;if(ka(L,a))return He(r,g.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0,Ym(_)),!0}}y=y.parent}return!1}function zx(r){let a=q0(r);return a&&ac(a,64,!0)?(He(r,g.Cannot_extend_an_interface_0_Did_you_mean_implements,Fl(a)),!0):!1}function q0(r){switch(r.kind){case 80:case 211:return r.parent?q0(r.parent):void 0;case 233:if(ol(r.expression))return r.expression;default:return}}function Wk(r,a,_){let d=1920|(gn(r)?111551:0);if(_===d){let y=ll(wc(r,a,788968&~d,void 0,void 0,!1)),T=r.parent;if(y){if(pf(T)){I.assert(T.left===r,"Should only be resolving left side of qualified name as a namespace");let P=T.right.escapedText;if(ka(dc(y),P))return He(T,g.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1,Zi(a),Zi(P)),!0}return He(r,g._0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here,Zi(a)),!0}}return!1}function z0(r,a,_){if(_&788584){let d=ll(wc(r,a,111127,void 0,void 0,!1));if(d&&!(d.flags&1920))return He(r,g._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0,Zi(a)),!0}return!1}function uh(r){return r==="any"||r==="string"||r==="number"||r==="boolean"||r==="never"||r==="unknown"}function Z1(r,a){return uh(a)&&r.parent.kind===281?(He(r,g.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module,a),!0):!1}function tI(r,a,_){if(_&111551){if(uh(a)){let T=r.parent.parent;if(T&&T.parent&&ad(T)){let P=T.token,L=T.parent.kind;L===264&&P===96?He(r,g.An_interface_cannot_extend_a_primitive_type_like_0_It_can_only_extend_other_named_object_types,Zi(a)):L===263&&P===96?He(r,g.A_class_cannot_extend_a_primitive_type_like_0_Classes_can_only_extend_constructable_values,Zi(a)):L===263&&P===119&&He(r,g.A_class_cannot_implement_a_primitive_type_like_0_It_can_only_implement_other_named_object_types,Zi(a))}else He(r,g._0_only_refers_to_a_type_but_is_being_used_as_a_value_here,Zi(a));return!0}let d=ll(wc(r,a,788544,void 0,void 0,!1)),y=d&&a_(d);if(d&&y!==void 0&&!(y&111551)){let T=Zi(a);return nI(a)?He(r,g._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later,T):rI(r,d)?He(r,g._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0,T,T==="K"?"P":"K"):He(r,g._0_only_refers_to_a_type_but_is_being_used_as_a_value_here,T),!0}}return!1}function rI(r,a){let _=Gr(r.parent,d=>uo(d)||fp(d)?!1:dp(d)||"quit");if(_&&_.members.length===1){let d=dc(a);return!!(d.flags&1048576)&&y$(d,384,!0)}return!1}function nI(r){switch(r){case"Promise":case"Symbol":case"Map":case"WeakMap":case"Set":case"WeakSet":return!0}return!1}function $x(r,a,_){if(_&111127){if(ll(wc(r,a,1024,void 0,void 0,!1)))return He(r,g.Cannot_use_namespace_0_as_a_value,Zi(a)),!0}else if(_&788544&&ll(wc(r,a,1536,void 0,void 0,!1)))return He(r,g.Cannot_use_namespace_0_as_a_type,Zi(a)),!0;return!1}function pc(r,a){var _;if(I.assert(!!(r.flags&2||r.flags&32||r.flags&384)),r.flags&67108881&&r.flags&32)return;let d=(_=r.declarations)==null?void 0:_.find(y=>AY(y)||Ti(y)||y.kind===266);if(d===void 0)return I.fail("checkResolvedBlockScopedVariable could not find block-scoped declaration");if(!(d.flags&33554432)&&!qy(d,a)){let y,T=qo(qs(d));r.flags&2?y=He(a,g.Block_scoped_variable_0_used_before_its_declaration,T):r.flags&32?y=He(a,g.Class_0_used_before_its_declaration,T):r.flags&256?y=He(a,g.Enum_0_used_before_its_declaration,T):(I.assert(!!(r.flags&128)),fm($)&&(y=He(a,g.Enum_0_used_before_its_declaration,T))),y&&Ga(y,$n(d,g._0_is_declared_here,T))}}function BE(r,a,_){return!!a&&!!Gr(r,d=>d===a||(d===_||ca(d)&&(!W2(d)||vu(d)&3)?"quit":!1))}function Wx(r){switch(r.kind){case 271:return r;case 273:return r.parent;case 274:return r.parent.parent;case 276:return r.parent.parent.parent;default:return}}function Xm(r){return r.declarations&&Da(r.declarations,yS)}function yS(r){return r.kind===271||r.kind===270||r.kind===273&&!!r.name||r.kind===274||r.kind===280||r.kind===276||r.kind===281||r.kind===277&&vN(r)||bn(r)&&al(r)===2&&vN(r)||Yo(r)&&bn(r.parent)&&r.parent.left===r&&r.parent.operatorToken.kind===64&&iI(r.parent.right)||r.kind===304||r.kind===303&&iI(r.initializer)||r.kind===260&&Gb(r)||r.kind===208&&Gb(r.parent.parent)}function iI(r){return $8(r)||Xo(r)&&Sh(r)}function Gx(r,a){let _=SS(r);if(_){let y=DN(_.expression).arguments[0];return ze(_.name)?ll(ka(vze(y),_.name.escapedText)):void 0}if(Gi(r)||r.moduleReference.kind===283){let y=rf(r,zY(r)||$w(r)),T=bp(y);return Qf(r,y,T,!1),T}let d=Hk(r.moduleReference,a);return ZO(r,d),d}function ZO(r,a){if(Qf(r,void 0,a,!1)&&!r.isTypeOnly){let _=Bd(Rn(r)),d=_.kind===281||_.kind===278,y=d?g.An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type:g.An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type,T=d?g._0_was_exported_here:g._0_was_imported_here,P=_.kind===278?"*":Zi(_.name.escapedText);Ga(He(r.moduleReference,y),$n(_,T,P))}}function Cn(r,a,_,d){let y=r.exports.get("export="),T=y?ka(vn(y),a,!0):r.exports.get(a),P=ll(T,d);return Qf(_,T,P,!1),P}function Lu(r){return Kc(r)&&!r.isExportEquals||ui(r,2048)||R_(r)||qh(r)}function _s(r){return bo(r)?e.getModeForUsageLocation(Xr(r),r):void 0}function hd(r,a){return r===99&&a===1}function ev(r){return _s(r)===99&&Mc(r.text,".json")}function _h(r,a,_,d){let y=r&&_s(d);if(r&&y!==void 0&&100<=z&&z<=199){let T=hd(y,r.impliedNodeFormat);if(y===99||T)return T}if(!Z)return!1;if(!r||r.isDeclarationFile){let T=Cn(a,"default",void 0,!0);return!(T&&Tt(T.declarations,Lu)||Cn(a,Pc("__esModule"),void 0,_))}return Y_(r)?typeof r.externalModuleIndicator!="object"&&!Cn(a,Pc("__esModule"),void 0,_):tv(a)}function yn(r,a){let _=rf(r,r.parent.moduleSpecifier);if(_)return Hx(_,r,a)}function Hx(r,a,_){var d;let y;Uw(r)?y=r:y=Cn(r,"default",a,_);let T=(d=r.declarations)==null?void 0:d.find(ls),P=XT(a);if(!P)return y;let L=ev(P),J=_h(T,r,_,P);if(!y&&!J&&!L)if(tv(r)&&!Z){let G=z>=5?"allowSyntheticDefaultImports":"esModuleInterop",Ce=r.exports.get("export=").valueDeclaration,be=He(a.name,g.Module_0_can_only_be_default_imported_using_the_1_flag,Oi(r),G);Ce&&Ga(be,$n(Ce,g.This_module_is_declared_with_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag,G))}else Jh(a)?Cu(r,a):Yx(r,r,a,hA(a)&&a.propertyName||a.name);else if(J||L){let G=bp(r,_)||ll(r,_);return Qf(a,r,G,!1),G}return Qf(a,y,void 0,!1),y}function XT(r){switch(r.kind){case 273:return r.parent.moduleSpecifier;case 271:return zh(r.moduleReference)?r.moduleReference.expression:void 0;case 274:return r.parent.parent.moduleSpecifier;case 276:return r.parent.parent.parent.moduleSpecifier;case 281:return r.parent.parent.moduleSpecifier;default:return I.assertNever(r)}}function Cu(r,a){var _,d,y;if((_=r.exports)!=null&&_.has(a.symbol.escapedName))He(a.name,g.Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead,Oi(r),Oi(a.symbol));else{let T=He(a.name,g.Module_0_has_no_default_export,Oi(r)),P=(d=r.exports)==null?void 0:d.get("__export");if(P){let L=(y=P.declarations)==null?void 0:y.find(J=>{var G,ae;return!!(yl(J)&&J.moduleSpecifier&&((ae=(G=rf(J,J.moduleSpecifier))==null?void 0:G.exports)!=null&&ae.has("default")))});L&&Ga(T,$n(L,g.export_Asterisk_does_not_re_export_a_default))}}}function Qh(r,a){let _=r.parent.parent.moduleSpecifier,d=rf(r,_),y=Zf(d,_,a,!1);return Qf(r,d,y,!1),y}function Km(r,a){let _=r.parent.moduleSpecifier,d=_&&rf(r,_),y=_&&Zf(d,_,a,!1);return Qf(r,d,y,!1),y}function UE(r,a){if(r===dt&&a===dt)return dt;if(r.flags&790504)return r;let _=oo(r.flags|a.flags,r.escapedName);return I.assert(r.declarations||a.declarations),_.declarations=Dh(ys(r.declarations,a.declarations),Dm),_.parent=r.parent||a.parent,r.valueDeclaration&&(_.valueDeclaration=r.valueDeclaration),a.members&&(_.members=new Map(a.members)),r.exports&&(_.exports=new Map(r.exports)),_}function VE(r,a,_,d){var y;if(r.flags&1536){let T=Ep(r).get(a.escapedText),P=ll(T,d),L=(y=as(r).typeOnlyExportStarMap)==null?void 0:y.get(a.escapedText);return Qf(_,T,P,!1,L,a.escapedText),P}}function vS(r,a){if(r.flags&3){let _=r.valueDeclaration.type;if(_)return ll(ka(Ri(_),a))}}function $y(r,a,_=!1){var d;let y=zY(r)||r.moduleSpecifier,T=rf(r,y),P=!Hn(a)&&a.propertyName||a.name;if(!ze(P))return;let L=P.escapedText==="default"&&Z,J=Zf(T,y,!1,L);if(J&&P.escapedText){if(Uw(T))return T;let G;T&&T.exports&&T.exports.get("export=")?G=ka(vn(J),P.escapedText,!0):G=vS(J,P.escapedText),G=ll(G,_);let ae=VE(J,P,a,_);if(ae===void 0&&P.escapedText==="default"){let be=(d=T.declarations)==null?void 0:d.find(ls);(ev(y)||_h(be,T,_,y))&&(ae=bp(T,_)||ll(T,_))}let Ce=ae&&G&&ae!==G?UE(G,ae):ae||G;return Ce||Yx(T,J,r,P),Ce}}function Yx(r,a,_,d){var y;let T=Wp(r,_),P=qo(d),L=noe(d,a);if(L!==void 0){let J=Oi(L),G=He(d,g._0_has_no_exported_member_named_1_Did_you_mean_2,T,P,J);L.valueDeclaration&&Ga(G,$n(L.valueDeclaration,g._0_is_declared_here,J))}else(y=r.exports)!=null&&y.has("default")?He(d,g.Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead,T,P):Qm(_,d,P,r,T)}function Qm(r,a,_,d,y){var T,P;let L=(P=(T=ii(d.valueDeclaration,Oh))==null?void 0:T.locals)==null?void 0:P.get(a.escapedText),J=d.exports;if(L){let G=J?.get("export=");if(G)bg(G,L)?KT(r,a,_,y):He(a,g.Module_0_has_no_exported_member_1,y,_);else{let ae=J?mr(Sxe(J),be=>!!bg(be,L)):void 0,Ce=ae?He(a,g.Module_0_declares_1_locally_but_it_is_exported_as_2,y,_,Oi(ae)):He(a,g.Module_0_declares_1_locally_but_it_is_not_exported,y,_);L.declarations&&Ga(Ce,...vr(L.declarations,(be,Ye)=>$n(be,Ye===0?g._0_is_declared_here:g.and_here,_)))}}else He(a,g.Module_0_has_no_exported_member_1,y,_)}function KT(r,a,_,d){if(z>=5){let y=Bh($)?g._0_can_only_be_imported_by_using_a_default_import:g._0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;He(a,y,_)}else if(gn(r)){let y=Bh($)?g._0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import:g._0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;He(a,y,_)}else{let y=Bh($)?g._0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import:g._0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;He(a,y,_,_,d)}}function $0(r,a){if(Gf(r)&&Nn(r.propertyName||r.name)==="default"){let P=XT(r),L=P&&rf(r,P);if(L)return Hx(L,r,a)}let _=co(r)?Gg(r):r.parent.parent.parent,d=SS(_),y=$y(_,d||r,a),T=r.propertyName||r.name;return d&&y&&ze(T)?ll(ka(vn(y),T.escapedText),a):(Qf(r,void 0,y,!1),y)}function SS(r){if(Gi(r)&&r.initializer&&Hn(r.initializer))return r.initializer}function Gk(r,a){if(qg(r.parent)){let _=bp(r.parent.symbol,a);return Qf(r,void 0,_,!1),_}}function QT(r,a,_){if(Nn(r.propertyName||r.name)==="default"){let y=XT(r),T=y&&rf(r,y);if(T)return Hx(T,r,!!_)}let d=r.parent.parent.moduleSpecifier?$y(r.parent.parent,r,_):ac(r.propertyName||r.name,a,!1,_);return Qf(r,void 0,d,!1),d}function sI(r,a){let _=Kc(r)?r.expression:r.right,d=JE(_,a);return Qf(r,void 0,d,!1),d}function JE(r,a){if(wu(r))return xl(r).symbol;if(!zf(r)&&!ol(r))return;let _=ac(r,901119,!0,a);return _||(xl(r),_i(r).resolvedSymbol)}function Xx(r,a){if(bn(r.parent)&&r.parent.left===r&&r.parent.operatorToken.kind===64)return JE(r.parent.right,a)}function $p(r,a=!1){switch(r.kind){case 271:case 260:return Gx(r,a);case 273:return yn(r,a);case 274:return Qh(r,a);case 280:return Km(r,a);case 276:case 208:return $0(r,a);case 281:return QT(r,901119,a);case 277:case 226:return sI(r,a);case 270:return Gk(r,a);case 304:return ac(r.name,901119,!0,a);case 303:return JE(r.initializer,a);case 212:case 211:return Xx(r,a);default:return I.fail()}}function Kx(r,a=901119){return r?(r.flags&(2097152|a))===2097152||!!(r.flags&2097152&&r.flags&67108864):!1}function ll(r,a){return!a&&Kx(r)?du(r):r}function du(r){I.assert((r.flags&2097152)!==0,"Should only get Alias here.");let a=as(r);if(a.aliasTarget)a.aliasTarget===Ot&&(a.aliasTarget=dt);else{a.aliasTarget=Ot;let _=Xm(r);if(!_)return I.fail();let d=$p(_);a.aliasTarget===Ot?a.aliasTarget=d||dt:He(_,g.Circular_definition_of_import_alias_0,Oi(r))}return a.aliasTarget}function Qx(r){if(as(r).aliasTarget!==Ot)return du(r)}function a_(r,a,_){let d=a&&Bd(r),y=d&&yl(d),T=d&&(y?rf(d.moduleSpecifier,d.moduleSpecifier,!0):du(d.symbol)),P=y&&T?Zh(T):void 0,L=_?0:r.flags,J;for(;r.flags&2097152;){let G=vd(du(r));if(!y&&G===T||P?.get(G.escapedName)===G)break;if(G===dt)return-1;if(G===r||J?.has(G))break;G.flags&2097152&&(J?J.add(G):J=new Set([r,G])),L|=G.flags,r=G}return L}function Qf(r,a,_,d,y,T){if(!r||Hn(r))return!1;let P=Rn(r);if(dT(r)){let J=as(P);return J.typeOnlyDeclaration=r,!0}if(y){let J=as(P);return J.typeOnlyDeclaration=y,P.escapedName!==T&&(J.typeOnlyExportStarName=T),!0}let L=as(P);return ZT(L,a,d)||ZT(L,_,d)}function ZT(r,a,_){var d;if(a&&(r.typeOnlyDeclaration===void 0||_&&r.typeOnlyDeclaration===!1)){let y=((d=a.exports)==null?void 0:d.get("export="))??a,T=y.declarations&&mr(y.declarations,dT);r.typeOnlyDeclaration=T??as(y).typeOnlyDeclaration??!1}return!!r.typeOnlyDeclaration}function Bd(r,a){if(!(r.flags&2097152))return;let _=as(r);if(a===void 0)return _.typeOnlyDeclaration||void 0;if(_.typeOnlyDeclaration){let d=_.typeOnlyDeclaration.kind===278?ll(Zh(_.typeOnlyDeclaration.symbol.parent).get(_.typeOnlyExportStarName||r.escapedName)):du(_.typeOnlyDeclaration.symbol);return a_(d)&a?_.typeOnlyDeclaration:void 0}}function TS(r){if(!yt)return;let a=Rn(r),_=du(a);_&&(_===dt||a_(a,!0)&111551&&!KL(_))&&bS(a)}function bS(r){I.assert(yt);let a=as(r);if(!a.referenced){a.referenced=!0;let _=Xm(r);if(!_)return I.fail();fN(_)&&a_(ll(r))&111551&&xl(_.moduleReference)}}function Fu(r){let a=as(r);a.constEnumReferenced||(a.constEnumReferenced=!0)}function Hk(r,a){return r.kind===80&&o6(r)&&(r=r.parent),r.kind===80||r.parent.kind===166?ac(r,1920,!1,a):(I.assert(r.parent.kind===271),ac(r,901119,!1,a))}function Wp(r,a){return r.parent?Wp(r.parent,a)+"."+Oi(r):Oi(r,a,void 0,36)}function Zx(r){for(;pf(r.parent);)r=r.parent;return r}function eC(r){let a=Jp(r),_=wc(a,a.escapedText,111551,void 0,a,!0);if(_){for(;pf(a.parent);){let d=vn(_);if(_=ka(d,a.parent.right.escapedText),!_)return;a=a.parent}return _}}function ac(r,a,_,d,y){if(sl(r))return;let T=1920|(gn(r)?a&111551:0),P;if(r.kind===80){let L=a===T||_c(r)?g.Cannot_find_namespace_0:fWe(Jp(r)),J=gn(r)&&!_c(r)?aI(r,a):void 0;if(P=mo(wc(y||r,r.escapedText,a,_||J?void 0:L,r,!0,!1)),!P)return mo(J)}else if(r.kind===166||r.kind===211){let L=r.kind===166?r.left:r.expression,J=r.kind===166?r.right:r.name,G=ac(L,T,_,!1,y);if(!G||sl(J))return;if(G===dt)return G;if(G.valueDeclaration&&gn(G.valueDeclaration)&&Q_($)!==100&&Gi(G.valueDeclaration)&&G.valueDeclaration.initializer&&XGe(G.valueDeclaration.initializer)){let ae=G.valueDeclaration.initializer.arguments[0],Ce=rf(ae,ae);if(Ce){let be=bp(Ce);be&&(G=be)}}if(P=mo(Lf(Ep(G),J.escapedText,a)),!P&&G.flags&2097152&&(P=mo(Lf(Ep(du(G)),J.escapedText,a))),!P){if(!_){let ae=Wp(G),Ce=qo(J),be=noe(J,G);if(be){He(J,g._0_has_no_exported_member_named_1_Did_you_mean_2,ae,Ce,Oi(be));return}let Ye=pf(r)&&Zx(r);if(Oe&&a&788968&&Ye&&!zN(Ye.parent)&&eC(Ye)){He(Ye,g._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0,cp(Ye));return}if(a&1920&&pf(r.parent)){let Dt=mo(Lf(Ep(G),J.escapedText,788968));if(Dt){He(r.parent.right,g.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1,Oi(Dt),Zi(r.parent.right.escapedText));return}}He(J,g.Namespace_0_has_no_exported_member_1,ae,Ce)}return}}else I.assertNever(r,"Unknown entity name kind.");return I.assert((Vc(P)&1)===0,"Should never get an instantiated symbol here."),!_c(r)&&zf(r)&&(P.flags&2097152||r.parent.kind===277)&&Qf(rX(r),P,void 0,!0),P.flags&a||d?P:du(P)}function aI(r,a){if(iae(r.parent)){let _=eb(r.parent);if(_)return wc(_,r.escapedText,a,void 0,r,!0)}}function eb(r){if(Gr(r,y=>ZP(y)||y.flags&16777216?am(y):"quit"))return;let _=X2(r);if(_&&Ou(_)&&M8(_.expression)){let y=Rn(_.expression.left);if(y)return qE(y)}if(_&&Xo(_)&&M8(_.parent)&&Ou(_.parent.parent)){let y=Rn(_.parent.left);if(y)return qE(y)}if(_&&(jm(_)||Ul(_))&&bn(_.parent.parent)&&al(_.parent.parent)===6){let y=Rn(_.parent.parent.left);if(y)return qE(y)}let d=vT(r);if(d&&ca(d)){let y=Rn(d);return y&&y.valueDeclaration}}function qE(r){let a=r.parent.valueDeclaration;return a?(Ww(a)?EA(a):V2(a)?D8(a):void 0)||a:void 0}function e4(r){let a=r.valueDeclaration;if(!a||!gn(a)||r.flags&524288||hT(a,!1))return;let _=Gi(a)?D8(a):EA(a);if(_){let d=yd(_);if(d)return NAe(d,r)}}function rf(r,a,_){let y=Q_($)===1?g.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_to_the_paths_option:g.Cannot_find_module_0_or_its_corresponding_type_declarations;return Wy(r,a,_?void 0:y)}function Wy(r,a,_,d=!1){return bo(a)?fh(r,a.text,_,a,d):void 0}function fh(r,a,_,d,y=!1){var T,P,L,J,G,ae,Ce,be,Ye,vt,Dt;if(Ss(a,"@types/")){let cn=g.Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1,Bs=hw(a,"@types/");He(d,cn,Bs,a)}let ur=Xse(a,!0);if(ur)return ur;let pr=Xr(r),dn=bo(r)?r:((T=hl(r)?r:r.parent&&hl(r.parent)&&r.parent.name===r?r.parent:void 0)==null?void 0:T.name)||((P=Vv(r)?r:void 0)==null?void 0:P.argument.literal)||(Gi(r)&&r.initializer&&_f(r.initializer,!0)?r.initializer.arguments[0]:void 0)||((L=Gr(r,Up))==null?void 0:L.arguments[0])||((J=Gr(r,uu))==null?void 0:J.moduleSpecifier)||((G=Gr(r,gT))==null?void 0:G.moduleReference.expression)||((ae=Gr(r,yl))==null?void 0:ae.moduleSpecifier),Ur=dn&&bo(dn)?e.getModeForUsageLocation(pr,dn):pr.impliedNodeFormat,fr=Q_($),$r=(Ce=e.getResolvedModule(pr,a,Ur))==null?void 0:Ce.resolvedModule,Jr=$r&&QZ($,$r,pr),on=$r&&(!Jr||Jr===g.Module_0_was_resolved_to_1_but_jsx_is_not_set)&&e.getSourceFile($r.resolvedFileName);if(on){if(Jr&&He(d,Jr,a,$r.resolvedFileName),$r.resolvedUsingTsExtension&&i_(a)){let cn=((be=Gr(r,uu))==null?void 0:be.importClause)||Gr(r,cg(Ru,yl));(cn&&!cn.isTypeOnly||Gr(r,Up))&&He(d,g.A_declaration_file_cannot_be_imported_without_import_type_Did_you_mean_to_import_an_implementation_file_0_instead,Qr(I.checkDefined(Mj(a))))}else if($r.resolvedUsingTsExtension&&!lD($,pr.fileName)){let cn=((Ye=Gr(r,uu))==null?void 0:Ye.importClause)||Gr(r,cg(Ru,yl));if(!(cn?.isTypeOnly||Gr(r,M0))){let Bs=I.checkDefined(Mj(a));He(d,g.An_import_path_can_only_end_with_a_0_extension_when_allowImportingTsExtensions_is_enabled,Bs)}}if(on.symbol){if($r.isExternalLibraryImport&&!g6($r.extension)&&Yk(!1,d,pr,Ur,$r,a),fr===3||fr===99){let cn=pr.impliedNodeFormat===1&&!Gr(r,Up)||!!Gr(r,Ru),Bs=Gr(r,Os=>M0(Os)||yl(Os)||uu(Os));if(cn&&on.impliedNodeFormat===99&&!Wme(Bs))if(Gr(r,Ru))He(d,g.Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_with_require_Use_an_ECMAScript_import_instead,a);else{let Os,Ys=Py(pr.fileName);if(Ys===".ts"||Ys===".js"||Ys===".tsx"||Ys===".jsx"){let As=pr.packageJsonScope,su=Ys===".ts"?".mts":Ys===".js"?".mjs":void 0;As&&!As.contents.packageJsonContent.type?su?Os=Xs(void 0,g.To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_add_the_field_type_Colon_module_to_1,su,li(As.packageDirectory,"package.json")):Os=Xs(void 0,g.To_convert_this_file_to_an_ECMAScript_module_add_the_field_type_Colon_module_to_0,li(As.packageDirectory,"package.json")):su?Os=Xs(void 0,g.To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_create_a_local_package_json_file_with_type_Colon_module,su):Os=Xs(void 0,g.To_convert_this_file_to_an_ECMAScript_module_create_a_local_package_json_file_with_type_Colon_module)}fo.add(Ey(Xr(d),d,Xs(Os,g.The_current_file_is_a_CommonJS_module_whose_imports_will_produce_require_calls_however_the_referenced_file_is_an_ECMAScript_module_and_cannot_be_imported_with_require_Consider_writing_a_dynamic_import_0_call_instead,a)))}}return mo(on.symbol)}_&&He(d,g.File_0_is_not_a_module,on.fileName);return}if(gm){let cn=AG(gm,Bs=>Bs.pattern,a);if(cn){let Bs=tf&&tf.get(a);return mo(Bs||cn.symbol)}}if($r&&!g6($r.extension)&&Jr===void 0||Jr===g.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type){if(y){let cn=g.Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented;He(d,cn,a,$r.resolvedFileName)}else Yk(ve&&!!_,d,pr,Ur,$r,a);return}if(_){if($r){let cn=e.getProjectReferenceRedirect($r.resolvedFileName);if(cn){He(d,g.Output_file_0_has_not_been_built_from_source_file_1,cn,$r.resolvedFileName);return}}if(Jr)He(d,Jr,a,$r.resolvedFileName);else{let cn=Fp(a)&&!pA(a),Bs=fr===3||fr===99;if(!xT($)&&Uc(a,".json")&&fr!==1&&$j($))He(d,g.Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension,a);else if(Ur===99&&Bs&&cn){let Os=Ps(a,hi(pr.path)),Ys=(vt=ZD.find(([As,su])=>e.fileExists(Os+As)))==null?void 0:vt[1];Ys?He(d,g.Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0,a+Ys):He(d,g.Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path)}else if((Dt=e.getResolvedModule(pr,a,Ur))!=null&&Dt.alternateResult){let Os=U9(pr,e,a,Ur,a);Yu(!0,d,Xs(Os,_,a))}else He(d,_,a)}}return;function Qr(cn){let Bs=lR(a,cn);if(zj(z)||Ur===99){let Os=i_(a)&&lD($);return Bs+(cn===".mts"||cn===".d.mts"?Os?".mts":".mjs":cn===".cts"||cn===".d.mts"?Os?".cts":".cjs":Os?".ts":".js")}return Bs}}function Yk(r,a,_,d,{packageId:y,resolvedFileName:T},P){let L;!Nu(P)&&y&&(L=U9(_,e,P,d,y.name)),Yu(r,a,Xs(L,g.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type,P,T))}function bp(r,a){if(r?.exports){let _=ll(r.exports.get("export="),a),d=Xk(mo(_),mo(r));return mo(d)||r}}function Xk(r,a){if(!r||r===dt||r===a||a.exports.size===1||r.flags&2097152)return r;let _=as(r);if(_.cjsExportMerged)return _.cjsExportMerged;let d=r.flags&33554432?r:qx(r);return d.flags=d.flags|512,d.exports===void 0&&(d.exports=ga()),a.exports.forEach((y,T)=>{T!=="export="&&d.exports.set(T,d.exports.has(T)?hm(d.exports.get(T),y):y)}),d===r&&(as(d).resolvedExports=void 0,as(d).resolvedMembers=void 0),as(d).cjsExportMerged=d,_.cjsExportMerged=d}function Zf(r,a,_,d){var y;let T=bp(r,_);if(!_&&T){if(!d&&!(T.flags&1539)&&!xc(T,312)){let L=z>=5?"allowSyntheticDefaultImports":"esModuleInterop";return He(a,g.This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export,L),T}let P=a.parent;if(uu(P)&&gN(P)||Up(P)){let L=Up(P)?P.arguments[0]:P.moduleSpecifier,J=vn(T),G=HGe(J,T,r,L);if(G)return Kk(T,G,P);let ae=(y=r?.declarations)==null?void 0:y.find(ls),Ce=ae&&hd(_s(L),ae.impliedNodeFormat);if(Bh($)||Ce){let be=bz(J,0);if((!be||!be.length)&&(be=bz(J,1)),be&&be.length||ka(J,"default",!0)||Ce){let Ye=J.flags&3670016?YGe(J,T,r,L):DAe(T,T.parent);return Kk(T,Ye,P)}}}}return T}function Kk(r,a,_){let d=oo(r.flags,r.escapedName);d.declarations=r.declarations?r.declarations.slice():[],d.parent=r.parent,d.links.target=r,d.links.originatingImport=_,r.valueDeclaration&&(d.valueDeclaration=r.valueDeclaration),r.constEnumOnlyModule&&(d.constEnumOnlyModule=!0),r.members&&(d.members=new Map(r.members)),r.exports&&(d.exports=new Map(r.exports));let y=kg(a);return d.links.type=Ho(d,y.members,tt,tt,y.indexInfos),d}function tv(r){return r.exports.get("export=")!==void 0}function tC(r){return Sxe(Zh(r))}function oI(r){let a=tC(r),_=bp(r);if(_!==r){let d=vn(_);ES(d)&&jt(a,Io(d))}return a}function cI(r,a){Zh(r).forEach((y,T)=>{WE(T)||a(y,T)});let d=bp(r);if(d!==r){let y=vn(d);ES(y)&&_Rt(y,(T,P)=>{a(T,P)})}}function rC(r,a){let _=Zh(a);if(_)return _.get(r)}function lI(r,a){let _=rC(r,a);if(_)return _;let d=bp(a);if(d===a)return;let y=vn(d);return ES(y)?ka(y,r):void 0}function ES(r){return!(r.flags&402784252||Gn(r)&1||Gd(r)||Ka(r))}function Ep(r){return r.flags&6256?ixe(r,"resolvedExports"):r.flags&1536?Zh(r):r.exports||K}function Zh(r){let a=as(r);if(!a.resolvedExports){let{exports:_,typeOnlyExportStarMap:d}=nC(r);a.resolvedExports=_,a.typeOnlyExportStarMap=d}return a.resolvedExports}function uI(r,a,_,d){a&&a.forEach((y,T)=>{if(T==="default")return;let P=r.get(T);if(!P)r.set(T,y),_&&d&&_.set(T,{specifierText:Fl(d.moduleSpecifier)});else if(_&&d&&P&&ll(P)!==ll(y)){let L=_.get(T);L.exportsWithDuplicate?L.exportsWithDuplicate.push(d):L.exportsWithDuplicate=[d]}})}function nC(r){let a=[],_,d=new Set;r=bp(r);let y=T(r)||K;return _&&d.forEach(P=>_.delete(P)),{exports:y,typeOnlyExportStarMap:_};function T(P,L,J){if(!J&&P?.exports&&P.exports.forEach((Ce,be)=>d.add(be)),!(P&&P.exports&&ln(a,P)))return;let G=new Map(P.exports),ae=P.exports.get("__export");if(ae){let Ce=ga(),be=new Map;if(ae.declarations)for(let Ye of ae.declarations){let vt=rf(Ye,Ye.moduleSpecifier),Dt=T(vt,Ye,J||Ye.isTypeOnly);uI(Ce,Dt,be,Ye)}be.forEach(({exportsWithDuplicate:Ye},vt)=>{if(!(vt==="export="||!(Ye&&Ye.length)||G.has(vt)))for(let Dt of Ye)fo.add($n(Dt,g.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity,be.get(vt).specifierText,Zi(vt)))}),uI(G,Ce)}return L?.isTypeOnly&&(_??(_=new Map),G.forEach((Ce,be)=>_.set(be,L))),G}}function mo(r){let a;return r&&r.mergeId&&(a=XD[r.mergeId])?a:r}function Rn(r){return mo(r.symbol&&Gse(r.symbol))}function yd(r){return qg(r)?Rn(r):void 0}function yf(r){return mo(r.parent&&Gse(r.parent))}function zE(r){var a,_;return(((a=r.valueDeclaration)==null?void 0:a.kind)===219||((_=r.valueDeclaration)==null?void 0:_.kind)===218)&&yd(r.valueDeclaration.parent)||r}function _I(r,a){let _=Xr(a),d=yo(_),y=as(r),T;if(y.extendedContainersByFile&&(T=y.extendedContainersByFile.get(d)))return T;if(_&&_.imports){for(let L of _.imports){if(_c(L))continue;let J=rf(a,L,!0);!J||!W0(J,r)||(T=Pr(T,J))}if(de(T))return(y.extendedContainersByFile||(y.extendedContainersByFile=new Map)).set(d,T),T}if(y.extendedContainers)return y.extendedContainers;let P=e.getSourceFiles();for(let L of P){if(!Pl(L))continue;let J=Rn(L);W0(J,r)&&(T=Pr(T,J))}return y.extendedContainers=T||tt}function tb(r,a,_){let d=yf(r);if(d&&!(r.flags&262144))return J(d);let y=Wi(r.declarations,ae=>{if(!S_(ae)&&ae.parent){if(U_(ae.parent))return Rn(ae.parent);if(Zg(ae.parent)&&ae.parent.parent&&bp(Rn(ae.parent.parent))===r)return Rn(ae.parent.parent)}if(wu(ae)&&bn(ae.parent)&&ae.parent.operatorToken.kind===64&&Yo(ae.parent.left)&&ol(ae.parent.left.expression))return P0(ae.parent.left)||G2(ae.parent.left.expression)?Rn(Xr(ae)):(xl(ae.parent.left.expression),_i(ae.parent.left.expression).resolvedSymbol)});if(!de(y))return;let T=Wi(y,ae=>W0(ae,r)?ae:void 0),P=[],L=[];for(let ae of T){let[Ce,...be]=J(ae);P=Pr(P,Ce),L=jt(L,be)}return ys(P,L);function J(ae){let Ce=Wi(ae.declarations,G),be=a&&_I(r,a),Ye=$E(ae,_);if(a&&ae.flags&Hy(_)&&xS(ae,a,1920,!1))return Pr(ys(ys([ae],Ce),be),Ye);let vt=!(ae.flags&Hy(_))&&ae.flags&788968&&dc(ae).flags&524288&&_===111551?HE(a,ur=>yu(ur,pr=>{if(pr.flags&Hy(_)&&vn(pr)===dc(ae))return pr})):void 0,Dt=vt?[vt,...Ce,ae]:[...Ce,ae];return Dt=Pr(Dt,Ye),Dt=jt(Dt,be),Dt}function G(ae){return d&&iC(ae,d)}}function $E(r,a){let _=!!de(r.declarations)&&di(r.declarations);if(a&111551&&_&&_.parent&&Gi(_.parent)&&(Ha(_)&&_===_.parent.initializer||dp(_)&&_===_.parent.type))return Rn(_.parent)}function iC(r,a){let _=fs(r),d=_&&_.exports&&_.exports.get("export=");return d&&bg(d,a)?_:void 0}function W0(r,a){if(r===yf(a))return a;let _=r.exports&&r.exports.get("export=");if(_&&bg(_,a))return r;let d=Ep(r),y=d.get(a.escapedName);return y&&bg(y,a)?y:yu(d,T=>{if(bg(T,a))return T})}function bg(r,a){if(mo(ll(mo(r)))===mo(ll(mo(a))))return r}function vd(r){return mo(r&&(r.flags&1048576)!==0&&r.exportSymbol||r)}function Zm(r,a){return!!(r.flags&111551||r.flags&2097152&&a_(r,!a)&111551)}function Gy(r){let a=r.members;for(let _ of a)if(_.kind===176&&nm(_.body))return _}function G0(r){var a;let _=new m(nr,r);return h++,_.id=h,(a=mn)==null||a.recordType(_),_}function H0(r,a){let _=G0(r);return _.symbol=a,_}function Qk(r){return new m(nr,r)}function Dl(r,a,_=0,d){fI(a,d);let y=G0(r);return y.intrinsicName=a,y.debugIntrinsicName=d,y.objectFlags=_|524288|2097152|33554432|16777216,y}function fI(r,a){let _=`${r},${a??""}`;pt.has(_)&&I.fail(`Duplicate intrinsic type name ${r}${a?` (${a})`:""}; you may need to pass a name to createIntrinsicType.`),pt.add(_)}function Ud(r,a){let _=H0(524288,a);return _.objectFlags=r,_.members=void 0,_.properties=void 0,_.callSignatures=void 0,_.constructSignatures=void 0,_.indexInfos=void 0,_}function e0(){return pi(In(tZ.keys(),jf))}function Sd(r){return H0(262144,r)}function WE(r){return r.charCodeAt(0)===95&&r.charCodeAt(1)===95&&r.charCodeAt(2)!==95&&r.charCodeAt(2)!==64&&r.charCodeAt(2)!==35}function rb(r){let a;return r.forEach((_,d)=>{Zk(_,d)&&(a||(a=[])).push(_)}),a||tt}function Zk(r,a){return!WE(a)&&Zm(r)}function sC(r){let a=rb(r),_=Zse(r);return _?ys(a,[_]):a}function Td(r,a,_,d,y){let T=r;return T.members=a,T.properties=tt,T.callSignatures=_,T.constructSignatures=d,T.indexInfos=y,a!==K&&(T.properties=rb(a)),T}function Ho(r,a,_,d,y){return Td(Ud(16,r),a,_,d,y)}function GE(r){if(r.constructSignatures.length===0)return r;if(r.objectTypeWithoutAbstractConstructSignatures)return r.objectTypeWithoutAbstractConstructSignatures;let a=Fn(r.constructSignatures,d=>!(d.flags&4));if(r.constructSignatures===a)return r;let _=Ho(r.symbol,r.members,r.callSignatures,Tt(a)?a:tt,r.indexInfos);return r.objectTypeWithoutAbstractConstructSignatures=_,_.objectTypeWithoutAbstractConstructSignatures=_,_}function HE(r,a){let _;for(let d=r;d;d=d.parent){if(Oh(d)&&d.locals&&!Kh(d)&&(_=a(d.locals,void 0,!0,d)))return _;switch(d.kind){case 312:if(!Bp(d))break;case 267:let y=Rn(d);if(_=a(y?.exports||K,void 0,!0,d))return _;break;case 263:case 231:case 264:let T;if((Rn(d).members||K).forEach((P,L)=>{P.flags&788968&&(T||(T=ga())).set(L,P)}),T&&(_=a(T,void 0,!1,d)))return _;break}}return a(ke,void 0,!0)}function Hy(r){return r===111551?111551:1920}function xS(r,a,_,d,y=new Map){if(!(r&&!D(r)))return;let T=as(r),P=T.accessibleChainCache||(T.accessibleChainCache=new Map),L=HE(a,(pr,dn,Ur,fr)=>fr),J=`${d?0:1}|${L&&yo(L)}|${_}`;if(P.has(J))return P.get(J);let G=Ia(r),ae=y.get(G);ae||y.set(G,ae=[]);let Ce=HE(a,be);return P.set(J,Ce),Ce;function be(pr,dn,Ur){if(!ln(ae,pr))return;let fr=Dt(pr,dn,Ur);return ae.pop(),fr}function Ye(pr,dn){return!nb(pr,a,dn)||!!xS(pr.parent,a,Hy(dn),d,y)}function vt(pr,dn,Ur){return(r===(dn||pr)||mo(r)===mo(dn||pr))&&!Tt(pr.declarations,U_)&&(Ur||Ye(mo(pr),_))}function Dt(pr,dn,Ur){return vt(pr.get(r.escapedName),void 0,dn)?[r]:yu(pr,$r=>{if($r.flags&2097152&&$r.escapedName!=="export="&&$r.escapedName!=="default"&&!(Uj($r)&&a&&Pl(Xr(a)))&&(!d||Tt($r.declarations,gT))&&(!Ur||!Tt($r.declarations,Ede))&&(dn||!xc($r,281))){let Jr=du($r),on=ur($r,Jr,dn);if(on)return on}if($r.escapedName===r.escapedName&&$r.exportSymbol&&vt(mo($r.exportSymbol),void 0,dn))return[r]})||(pr===ke?ur(at,at,dn):void 0)}function ur(pr,dn,Ur){if(vt(pr,dn,Ur))return[pr];let fr=Ep(dn),$r=fr&&be(fr,!0);if($r&&Ye(pr,Hy(_)))return[pr].concat($r)}}function nb(r,a,_){let d=!1;return HE(a,y=>{let T=mo(y.get(r.escapedName));if(!T)return!1;if(T===r)return!0;let P=T.flags&2097152&&!xc(T,281);return T=P?du(T):T,(P?a_(T):T.flags)&_?(d=!0,!0):!1}),d}function D(r){if(r.declarations&&r.declarations.length){for(let a of r.declarations)switch(a.kind){case 172:case 174:case 177:case 178:continue;default:return!1}return!0}return!1}function ue(r,a){return Di(r,a,788968,!1,!0).accessibility===0}function gt(r,a){return Di(r,a,111551,!1,!0).accessibility===0}function lr(r,a,_){return Di(r,a,_,!1,!1).accessibility===0}function Wn(r,a,_,d,y,T){if(!de(r))return;let P,L=!1;for(let J of r){let G=xS(J,a,d,!1);if(G){P=J;let be=vf(G[0],y);if(be)return be}if(T&&Tt(J.declarations,U_)){if(y){L=!0;continue}return{accessibility:0}}let ae=tb(J,a,d),Ce=Wn(ae,a,_,_===J?Hy(d):d,y,T);if(Ce)return Ce}if(L)return{accessibility:0};if(P)return{accessibility:1,errorSymbolName:Oi(_,a,d),errorModuleName:P!==_?Oi(P,a,1920):void 0}}function $i(r,a,_,d){return Di(r,a,_,d,!0)}function Di(r,a,_,d,y){if(r&&a){let T=Wn([r],a,r,_,d,y);if(T)return T;let P=Te(r.declarations,fs);if(P){let L=fs(a);if(P!==L)return{accessibility:2,errorSymbolName:Oi(r,a,_),errorModuleName:Oi(P),errorNode:gn(a)?a:void 0}}return{accessibility:1,errorSymbolName:Oi(r,a,_)}}return{accessibility:0}}function fs(r){let a=Gr(r,Aa);return a&&Rn(a)}function Aa(r){return S_(r)||r.kind===312&&Bp(r)}function U_(r){return W9(r)||r.kind===312&&Bp(r)}function vf(r,a){let _;if(!yr(Fn(r.declarations,T=>T.kind!==80),d))return;return{accessibility:0,aliasesToMakeVisible:_};function d(T){var P,L;if(!Eg(T)){let J=Wx(T);if(J&&!ui(J,32)&&Eg(J.parent))return y(T,J);if(Gi(T)&&Xc(T.parent.parent)&&!ui(T.parent.parent,32)&&Eg(T.parent.parent.parent))return y(T,T.parent.parent);if(G9(T)&&!ui(T,32)&&Eg(T.parent))return y(T,T);if(co(T)){if(r.flags&2097152&&gn(T)&&((P=T.parent)!=null&&P.parent)&&Gi(T.parent.parent)&&((L=T.parent.parent.parent)!=null&&L.parent)&&Xc(T.parent.parent.parent.parent)&&!ui(T.parent.parent.parent.parent,32)&&T.parent.parent.parent.parent.parent&&Eg(T.parent.parent.parent.parent.parent))return y(T,T.parent.parent.parent.parent);if(r.flags&2){let G=Gr(T,Xc);return ui(G,32)?!0:Eg(G.parent)?y(T,G):!1}}return!1}return!0}function y(T,P){return a&&(_i(T).isVisible=!0,_=ai(_,P)),!0}}function Vd(r){let a;return r.parent.kind===186||r.parent.kind===233&&!A0(r.parent)||r.parent.kind===167?a=1160127:r.kind===166||r.kind===211||r.parent.kind===271||r.parent.kind===166&&r.parent.left===r||r.parent.kind===211&&r.parent.expression===r||r.parent.kind===212&&r.parent.expression===r?a=1920:a=788968,a}function CS(r,a){let _=Vd(r),d=Jp(r),y=wc(a,d.escapedText,_,void 0,void 0,!1);return y&&y.flags&262144&&_&788968?{accessibility:0}:!y&&eE(d)&&$i(Rn(kf(d,!1,!1)),d,_,!1).accessibility===0?{accessibility:0}:y&&vf(y,!0)||{accessibility:1,errorSymbolName:Fl(d),errorNode:d}}function Oi(r,a,_,d=4,y){let T=70221824;d&2&&(T|=128),d&1&&(T|=512),d&8&&(T|=16384),d&32&&(T|=134217728),d&16&&(T|=1073741824);let P=d&4?kt.symbolToNode:kt.symbolToEntityName;return y?L(y).getText():jw(L);function L(J){let G=P(r,_,a,T),ae=a?.kind===312?DZ():EE(),Ce=a&&Xr(a);return ae.writeNode(4,G,Ce,J),J}}function t0(r,a,_=0,d,y){return y?T(y).getText():jw(T);function T(P){let L;_&262144?L=d===1?185:184:L=d===1?180:179;let J=kt.signatureToSignatureDeclaration(r,L,a,aC(_)|70221824|512),G=kM(),ae=a&&Xr(a);return G.writeNode(4,J,ae,gX(P)),P}}function Kr(r,a,_=1064960,d=Q8("")){let y=$.noErrorTruncation||_&1,T=kt.typeToTypeNode(r,a,aC(_)|70221824|(y?1:0));if(T===void 0)return I.fail("should always get typenode");let P=r!==Wt?EE():NZ(),L=a&&Xr(a);P.writeNode(4,T,L,d);let J=d.getText(),G=y?fB*2:mR*2;return G&&J&&J.length>=G?J.substr(0,G-3)+"...":J}function eP(r,a){let _=kS(r.symbol)?Kr(r,r.symbol.valueDeclaration):Kr(r),d=kS(a.symbol)?Kr(a,a.symbol.valueDeclaration):Kr(a);return _===d&&(_=AS(r),d=AS(a)),[_,d]}function AS(r){return Kr(r,void 0,64)}function kS(r){return r&&!!r.valueDeclaration&&bt(r.valueDeclaration)&&!$d(r.valueDeclaration)}function aC(r=0){return r&848330095}function YE(r){return!!r.symbol&&!!(r.symbol.flags&32)&&(r===qd(r.symbol)||!!(r.flags&524288)&&!!(Gn(r)&16777216))}function ph(){return{typeToTypeNode:(_t,Ne,jr,Vn)=>a(Ne,jr,Vn,bi=>d(_t,bi)),indexInfoToIndexSignatureDeclaration:(_t,Ne,jr,Vn)=>a(Ne,jr,Vn,bi=>ae(_t,bi,void 0)),signatureToSignatureDeclaration:(_t,Ne,jr,Vn,bi)=>a(jr,Vn,bi,Mi=>Ce(_t,Ne,Mi)),symbolToEntityName:(_t,Ne,jr,Vn,bi)=>a(jr,Vn,bi,Mi=>As(_t,Mi,Ne,!1)),symbolToExpression:(_t,Ne,jr,Vn,bi)=>a(jr,Vn,bi,Mi=>su(_t,Mi,Ne)),symbolToTypeParameterDeclarations:(_t,Ne,jr,Vn)=>a(Ne,jr,Vn,bi=>$r(_t,bi)),symbolToParameterDeclaration:(_t,Ne,jr,Vn)=>a(Ne,jr,Vn,bi=>ur(_t,bi)),typeParameterToDeclaration:(_t,Ne,jr,Vn)=>a(Ne,jr,Vn,bi=>vt(_t,bi)),symbolTableToDeclarationStatements:(_t,Ne,jr,Vn,bi)=>a(Ne,jr,Vn,Mi=>Oc(_t,Mi,bi)),symbolToNode:(_t,Ne,jr,Vn,bi)=>a(jr,Vn,bi,Mi=>r(_t,Mi,Ne))};function r(_t,Ne,jr){if(Ne.flags&1073741824){if(_t.valueDeclaration){let bi=qs(_t.valueDeclaration);if(bi&&uo(bi))return bi}let Vn=as(_t).nameType;if(Vn&&Vn.flags&9216)return Ne.enclosingDeclaration=Vn.symbol.valueDeclaration,j.createComputedPropertyName(su(Vn.symbol,Ne,jr))}return su(_t,Ne,jr)}function a(_t,Ne,jr,Vn){I.assert(_t===void 0||(_t.flags&16)===0);let bi=jr?.trackSymbol?jr.moduleResolverHost:Ne&134217728?Gvt(e):void 0,Mi={enclosingDeclaration:_t,flags:Ne||0,tracker:void 0,encounteredError:!1,reportedDiagnostic:!1,visitedTypes:void 0,symbolDepth:void 0,inferTypeParameters:void 0,approximateLength:0,trackedSymbols:void 0};Mi.tracker=new rZ(Mi,jr,bi);let Li=Vn(Mi);return Mi.truncating&&Mi.flags&1&&Mi.tracker.reportTruncationError(),Mi.encounteredError?void 0:Li}function _(_t){return _t.truncating?_t.truncating:_t.truncating=_t.approximateLength>(_t.flags&1?fB:mR)}function d(_t,Ne){let jr=Ne.flags,Vn=y(_t,Ne);return Ne.flags=jr,Vn}function y(_t,Ne){var jr,Vn;i&&i.throwIfCancellationRequested&&i.throwIfCancellationRequested();let bi=Ne.flags&8388608;if(Ne.flags&=-8388609,!_t){if(!(Ne.flags&262144)){Ne.encounteredError=!0;return}return Ne.approximateLength+=3,j.createKeywordTypeNode(133)}if(Ne.flags&536870912||(_t=Pg(_t)),_t.flags&1)return _t.aliasSymbol?j.createTypeReferenceNode(cn(_t.aliasSymbol),J(_t.aliasTypeArguments,Ne)):_t===Wt?w6(j.createKeywordTypeNode(133),3,"unresolved"):(Ne.approximateLength+=3,j.createKeywordTypeNode(_t===hr?141:133));if(_t.flags&2)return j.createKeywordTypeNode(159);if(_t.flags&4)return Ne.approximateLength+=6,j.createKeywordTypeNode(154);if(_t.flags&8)return Ne.approximateLength+=6,j.createKeywordTypeNode(150);if(_t.flags&64)return Ne.approximateLength+=6,j.createKeywordTypeNode(163);if(_t.flags&16&&!_t.aliasSymbol)return Ne.approximateLength+=7,j.createKeywordTypeNode(136);if(_t.flags&1056){if(_t.symbol.flags&8){let Or=yf(_t.symbol),fi=Bs(Or,Ne,788968);if(dc(Or)===_t)return fi;let Qi=Lc(_t.symbol);return nd(Qi,0)?Ii(fi,j.createTypeReferenceNode(Qi,void 0)):M0(fi)?(fi.isTypeOf=!0,j.createIndexedAccessTypeNode(fi,j.createLiteralTypeNode(j.createStringLiteral(Qi)))):Id(fi)?j.createIndexedAccessTypeNode(j.createTypeQueryNode(fi.typeName),j.createLiteralTypeNode(j.createStringLiteral(Qi))):I.fail("Unhandled type node kind returned from `symbolToTypeNode`.")}return Bs(_t.symbol,Ne,788968)}if(_t.flags&128)return Ne.approximateLength+=_t.value.length+2,j.createLiteralTypeNode(Sn(j.createStringLiteral(_t.value,!!(Ne.flags&268435456)),16777216));if(_t.flags&256){let Or=_t.value;return Ne.approximateLength+=(""+Or).length,j.createLiteralTypeNode(Or<0?j.createPrefixUnaryExpression(41,j.createNumericLiteral(-Or)):j.createNumericLiteral(Or))}if(_t.flags&2048)return Ne.approximateLength+=nE(_t.value).length+1,j.createLiteralTypeNode(j.createBigIntLiteral(_t.value));if(_t.flags&512)return Ne.approximateLength+=_t.intrinsicName.length,j.createLiteralTypeNode(_t.intrinsicName==="true"?j.createTrue():j.createFalse());if(_t.flags&8192){if(!(Ne.flags&1048576)){if(gt(_t.symbol,Ne.enclosingDeclaration))return Ne.approximateLength+=6,Bs(_t.symbol,Ne,111551);Ne.tracker.reportInaccessibleUniqueSymbolError&&Ne.tracker.reportInaccessibleUniqueSymbolError()}return Ne.approximateLength+=13,j.createTypeOperatorNode(158,j.createKeywordTypeNode(155))}if(_t.flags&16384)return Ne.approximateLength+=4,j.createKeywordTypeNode(116);if(_t.flags&32768)return Ne.approximateLength+=9,j.createKeywordTypeNode(157);if(_t.flags&65536)return Ne.approximateLength+=4,j.createLiteralTypeNode(j.createNull());if(_t.flags&131072)return Ne.approximateLength+=5,j.createKeywordTypeNode(146);if(_t.flags&4096)return Ne.approximateLength+=6,j.createKeywordTypeNode(155);if(_t.flags&67108864)return Ne.approximateLength+=6,j.createKeywordTypeNode(151);if(x6(_t))return Ne.flags&4194304&&(!Ne.encounteredError&&!(Ne.flags&32768)&&(Ne.encounteredError=!0),(Vn=(jr=Ne.tracker).reportInaccessibleThisError)==null||Vn.call(jr)),Ne.approximateLength+=4,j.createThisTypeNode();if(!bi&&_t.aliasSymbol&&(Ne.flags&16384||ue(_t.aliasSymbol,Ne.enclosingDeclaration))){let Or=J(_t.aliasTypeArguments,Ne);return WE(_t.aliasSymbol.escapedName)&&!(_t.aliasSymbol.flags&32)?j.createTypeReferenceNode(j.createIdentifier(""),Or):de(Or)===1&&_t.aliasSymbol===sa.symbol?j.createArrayTypeNode(Or[0]):Bs(_t.aliasSymbol,Ne,788968,Or)}let Mi=Gn(_t);if(Mi&4)return I.assert(!!(_t.flags&524288)),_t.node?rr(_t,Wr):Wr(_t);if(_t.flags&262144||Mi&3){if(_t.flags&262144&&hs(Ne.inferTypeParameters,_t)){Ne.approximateLength+=Lc(_t.symbol).length+6;let fi,Qi=Sf(_t);if(Qi){let Es=Eze(_t,!0);Es&&n1(Qi,Es)||(Ne.approximateLength+=9,fi=Qi&&d(Qi,Ne))}return j.createInferTypeNode(Ye(_t,Ne,fi))}if(Ne.flags&4&&_t.flags&262144){let fi=Ys(_t,Ne);return Ne.approximateLength+=Nn(fi).length,j.createTypeReferenceNode(j.createIdentifier(Nn(fi)),void 0)}if(_t.symbol)return Bs(_t.symbol,Ne,788968);let Or=(_t===ge||_t===ne)&&U&&U.symbol?(_t===ne?"sub-":"super-")+Lc(U.symbol):"?";return j.createTypeReferenceNode(j.createIdentifier(Or),void 0)}if(_t.flags&1048576&&_t.origin&&(_t=_t.origin),_t.flags&3145728){let Or=_t.flags&1048576?pI(_t.types):_t.types;if(de(Or)===1)return d(Or[0],Ne);let fi=J(Or,Ne,!0);if(fi&&fi.length>0)return _t.flags&1048576?j.createUnionTypeNode(fi):j.createIntersectionTypeNode(fi);!Ne.encounteredError&&!(Ne.flags&262144)&&(Ne.encounteredError=!0);return}if(Mi&48)return I.assert(!!(_t.flags&524288)),sr(_t);if(_t.flags&4194304){let Or=_t.type;Ne.approximateLength+=6;let fi=d(Or,Ne);return j.createTypeOperatorNode(143,fi)}if(_t.flags&134217728){let Or=_t.texts,fi=_t.types,Qi=j.createTemplateHead(Or[0]),Es=j.createNodeArray(vr(fi,(va,$l)=>j.createTemplateLiteralTypeSpan(d(va,Ne),($l<fi.length-1?j.createTemplateMiddle:j.createTemplateTail)(Or[$l+1]))));return Ne.approximateLength+=2,j.createTemplateLiteralType(Qi,Es)}if(_t.flags&268435456){let Or=d(_t.type,Ne);return Bs(_t.symbol,Ne,788968,[Or])}if(_t.flags&8388608){let Or=d(_t.objectType,Ne),fi=d(_t.indexType,Ne);return Ne.approximateLength+=2,j.createIndexedAccessTypeNode(Or,fi)}if(_t.flags&16777216)return rr(_t,Or=>Li(Or));if(_t.flags&33554432){let Or=d(_t.baseType,Ne),fi=u4(_t)&&Oxe("NoInfer",!1);return fi?Bs(fi,Ne,788968,[Or]):Or}return I.fail("Should be unreachable.");function Li(Or){let fi=d(Or.checkType,Ne);if(Ne.approximateLength+=15,Ne.flags&4&&Or.root.isDistributive&&!(Or.checkType.flags&262144)){let Wc=Sd(oo(262144,"T")),So=Ys(Wc,Ne),au=j.createTypeReferenceNode(So);Ne.approximateLength+=37;let lc=vC(Or.root.checkType,Wc,Or.mapper),Og=Ne.inferTypeParameters;Ne.inferTypeParameters=Or.root.inferTypeParameters;let it=d(gs(Or.root.extendsType,lc),Ne);Ne.inferTypeParameters=Og;let xt=ei(gs(Ri(Or.root.node.trueType),lc)),ir=ei(gs(Ri(Or.root.node.falseType),lc));return j.createConditionalTypeNode(fi,j.createInferTypeNode(j.createTypeParameterDeclaration(void 0,j.cloneNode(au.typeName))),j.createConditionalTypeNode(j.createTypeReferenceNode(j.cloneNode(So)),d(Or.checkType,Ne),j.createConditionalTypeNode(au,it,xt,ir),j.createKeywordTypeNode(146)),j.createKeywordTypeNode(146))}let Qi=Ne.inferTypeParameters;Ne.inferTypeParameters=Or.root.inferTypeParameters;let Es=d(Or.extendsType,Ne);Ne.inferTypeParameters=Qi;let va=ei(pb(Or)),$l=ei(db(Or));return j.createConditionalTypeNode(fi,Es,va,$l)}function ei(Or){var fi,Qi,Es;return Or.flags&1048576?(fi=Ne.visitedTypes)!=null&&fi.has(sf(Or))?(Ne.flags&131072||(Ne.encounteredError=!0,(Es=(Qi=Ne.tracker)==null?void 0:Qi.reportCyclicStructureError)==null||Es.call(Qi)),T(Ne)):rr(Or,va=>d(va,Ne)):d(Or,Ne)}function Ln(Or){return!!xL(Or)}function lt(Or){return!!Or.target&&Ln(Or.target)&&!Ln(Or)}function Ut(Or){var fi;I.assert(!!(Or.flags&524288));let Qi=Or.declaration.readonlyToken?j.createToken(Or.declaration.readonlyToken.kind):void 0,Es=Or.declaration.questionToken?j.createToken(Or.declaration.questionToken.kind):void 0,va,$l,Wc=!SI(Or)&&!(uC(Or).flags&2)&&Ne.flags&4&&!(bd(Or).flags&262144&&((fi=Sf(bd(Or)))==null?void 0:fi.flags)&4194304);if(SI(Or)){if(lt(Or)&&Ne.flags&4){let xt=Sd(oo(262144,"T")),ir=Ys(xt,Ne);$l=j.createTypeReferenceNode(ir)}va=j.createTypeOperatorNode(143,$l||d(uC(Or),Ne))}else if(Wc){let xt=Sd(oo(262144,"T")),ir=Ys(xt,Ne);$l=j.createTypeReferenceNode(ir),va=$l}else va=d(bd(Or),Ne);let So=Ye(Ag(Or),Ne,va),au=Or.declaration.nameType?d(nv(Or),Ne):void 0,lc=d(WS(Zy(Or),!!(s0(Or)&4)),Ne),Og=j.createMappedTypeNode(Qi,So,au,Es,lc,void 0);Ne.approximateLength+=10;let it=Sn(Og,1);if(lt(Or)&&Ne.flags&4){let xt=gs(Sf(Ri(Or.declaration.typeParameter.constraint.type))||Sr,Or.mapper);return j.createConditionalTypeNode(d(uC(Or),Ne),j.createInferTypeNode(j.createTypeParameterDeclaration(void 0,j.cloneNode($l.typeName),xt.flags&2?void 0:d(xt,Ne))),it,j.createKeywordTypeNode(146))}else if(Wc)return j.createConditionalTypeNode(d(bd(Or),Ne),j.createInferTypeNode(j.createTypeParameterDeclaration(void 0,j.cloneNode($l.typeName),j.createTypeOperatorNode(143,d(uC(Or),Ne)))),it,j.createKeywordTypeNode(146));return it}function sr(Or){var fi,Qi;let Es=Or.id,va=Or.symbol;if(va){if(!!(Gn(Or)&8388608)){let lc=Or.node;if(YA(lc)&&Ri(lc)===Or){let Og=el(Ne,lc);if(Og)return Og}return(fi=Ne.visitedTypes)!=null&&fi.has(Es)?T(Ne):rr(Or,dr)}let So=YE(Or)?788968:111551;if(Sh(va.valueDeclaration))return Bs(va,Ne,So);if(va.flags&32&&!Jse(va)&&!(va.valueDeclaration&&Ti(va.valueDeclaration)&&Ne.flags&2048&&(!eu(va.valueDeclaration)||$i(va,Ne.enclosingDeclaration,So,!1).accessibility!==0))||va.flags&896||$l())return Bs(va,Ne,So);if((Qi=Ne.visitedTypes)!=null&&Qi.has(Es)){let au=uz(Or);return au?Bs(au,Ne,788968):T(Ne)}else return rr(Or,dr)}else return dr(Or);function $l(){var Wc;let So=!!(va.flags&8192)&&Tt(va.declarations,lc=>pa(lc)),au=!!(va.flags&16)&&(va.parent||Te(va.declarations,lc=>lc.parent.kind===312||lc.parent.kind===268));if(So||au)return(!!(Ne.flags&4096)||((Wc=Ne.visitedTypes)==null?void 0:Wc.has(Es)))&&(!(Ne.flags&8)||gt(va,Ne.enclosingDeclaration))}}function rr(Or,fi){var Qi,Es,va;let $l=Or.id,Wc=Gn(Or)&16&&Or.symbol&&Or.symbol.flags&32,So=Gn(Or)&4&&Or.node?"N"+yo(Or.node):Or.flags&16777216?"N"+yo(Or.root.node):Or.symbol?(Wc?"+":"")+Ia(Or.symbol):void 0;Ne.visitedTypes||(Ne.visitedTypes=new Set),So&&!Ne.symbolDepth&&(Ne.symbolDepth=new Map);let au=Ne.enclosingDeclaration&&_i(Ne.enclosingDeclaration),lc=`${sf(Or)}|${Ne.flags}`;au&&(au.serializedTypes||(au.serializedTypes=new Map));let Og=(Qi=au?.serializedTypes)==null?void 0:Qi.get(lc);if(Og)return(Es=Og.trackedSymbols)==null||Es.forEach(([ti,Xi,Hs])=>Ne.tracker.trackSymbol(ti,Xi,Hs)),Og.truncating&&(Ne.truncating=!0),Ne.approximateLength+=Og.addedLength,Dr(Og.node);let it;if(So){if(it=Ne.symbolDepth.get(So)||0,it>10)return T(Ne);Ne.symbolDepth.set(So,it+1)}Ne.visitedTypes.add($l);let xt=Ne.trackedSymbols;Ne.trackedSymbols=void 0;let ir=Ne.approximateLength,tn=fi(Or),jn=Ne.approximateLength-ir;return!Ne.reportedDiagnostic&&!Ne.encounteredError&&((va=au?.serializedTypes)==null||va.set(lc,{node:tn,truncating:Ne.truncating,addedLength:jn,trackedSymbols:Ne.trackedSymbols})),Ne.visitedTypes.delete($l),So&&Ne.symbolDepth.set(So,it),Ne.trackedSymbols=xt,tn;function Dr(ti){return!_c(ti)&&Us(ti)===ti?ti:ft(j.cloneNode(wr(ti,Dr,void 0,An)),ti)}function An(ti,Xi,Hs,ba,Ea){return ti&&ti.length===0?ft(j.createNodeArray(void 0,ti.hasTrailingComma),ti):Hr(ti,Xi,Hs,ba,Ea)}}function dr(Or){if(Ff(Or)||Or.containsError)return Ut(Or);let fi=kg(Or);if(!fi.properties.length&&!fi.indexInfos.length){if(!fi.callSignatures.length&&!fi.constructSignatures.length)return Ne.approximateLength+=2,Sn(j.createTypeLiteralNode(void 0),1);if(fi.callSignatures.length===1&&!fi.constructSignatures.length){let Wc=fi.callSignatures[0];return Ce(Wc,184,Ne)}if(fi.constructSignatures.length===1&&!fi.callSignatures.length){let Wc=fi.constructSignatures[0];return Ce(Wc,185,Ne)}}let Qi=Fn(fi.constructSignatures,Wc=>!!(Wc.flags&4));if(Tt(Qi)){let Wc=vr(Qi,dC);return fi.callSignatures.length+(fi.constructSignatures.length-Qi.length)+fi.indexInfos.length+(Ne.flags&2048?mu(fi.properties,au=>!(au.flags&4194304)):de(fi.properties))&&Wc.push(GE(fi)),d(Pa(Wc),Ne)}let Es=Ne.flags;Ne.flags|=4194304;let va=bs(fi);Ne.flags=Es;let $l=j.createTypeLiteralNode(va);return Ne.approximateLength+=2,Sn($l,Ne.flags&1024?0:1),$l}function Wr(Or){let fi=cc(Or);if(Or.target===sa||Or.target===ua){if(Ne.flags&2){let va=d(fi[0],Ne);return j.createTypeReferenceNode(Or.target===sa?"Array":"ReadonlyArray",[va])}let Qi=d(fi[0],Ne),Es=j.createArrayTypeNode(Qi);return Or.target===sa?Es:j.createTypeOperatorNode(148,Es)}else if(Or.target.objectFlags&8){if(fi=ul(fi,(Qi,Es)=>WS(Qi,!!(Or.target.elementFlags[Es]&2))),fi.length>0){let Qi=sv(Or),Es=J(fi.slice(0,Qi),Ne);if(Es){let{labeledElementDeclarations:va}=Or.target;for(let Wc=0;Wc<Es.length;Wc++){let So=Or.target.elementFlags[Wc],au=va?.[Wc];au?Es[Wc]=j.createNamedTupleMember(So&12?j.createToken(26):void 0,j.createIdentifier(Zi(RAe(au))),So&2?j.createToken(58):void 0,So&4?j.createArrayTypeNode(Es[Wc]):Es[Wc]):Es[Wc]=So&12?j.createRestTypeNode(So&4?j.createArrayTypeNode(Es[Wc]):Es[Wc]):So&2?j.createOptionalTypeNode(Es[Wc]):Es[Wc]}let $l=Sn(j.createTupleTypeNode(Es),1);return Or.target.readonly?j.createTypeOperatorNode(148,$l):$l}}if(Ne.encounteredError||Ne.flags&524288){let Qi=Sn(j.createTupleTypeNode([]),1);return Or.target.readonly?j.createTypeOperatorNode(148,Qi):Qi}Ne.encounteredError=!0;return}else{if(Ne.flags&2048&&Or.symbol.valueDeclaration&&Ti(Or.symbol.valueDeclaration)&&!gt(Or.symbol,Ne.enclosingDeclaration))return sr(Or);{let Qi=Or.target.outerTypeParameters,Es=0,va;if(Qi){let au=Qi.length;for(;Es<au;){let lc=Es,Og=xze(Qi[Es]);do Es++;while(Es<au&&xze(Qi[Es])===Og);if(!Bc(Qi,fi,lc,Es)){let it=J(fi.slice(lc,Es),Ne),xt=Ne.flags;Ne.flags|=16;let ir=Bs(Og,Ne,788968,it);Ne.flags=xt,va=va?Ii(va,ir):ir}}}let $l;if(fi.length>0){let au=(Or.target.typeParameters||tt).length;$l=J(fi.slice(Es,au),Ne)}let Wc=Ne.flags;Ne.flags|=16;let So=Bs(Or.symbol,Ne,788968,$l);return Ne.flags=Wc,va?Ii(va,So):So}}}function Ii(Or,fi){if(M0(Or)){let Qi=Or.typeArguments,Es=Or.qualifier;Es&&(ze(Es)?Qi!==sx(Es)&&(Es=M1(j.cloneNode(Es),Qi)):Qi!==sx(Es.right)&&(Es=j.updateQualifiedName(Es,Es.left,M1(j.cloneNode(Es.right),Qi)))),Qi=fi.typeArguments;let va=Ei(fi);for(let $l of va)Es=Es?j.createQualifiedName(Es,$l):$l;return j.updateImportTypeNode(Or,Or.argument,Or.attributes,Es,Qi,Or.isTypeOf)}else{let Qi=Or.typeArguments,Es=Or.typeName;ze(Es)?Qi!==sx(Es)&&(Es=M1(j.cloneNode(Es),Qi)):Qi!==sx(Es.right)&&(Es=j.updateQualifiedName(Es,Es.left,M1(j.cloneNode(Es.right),Qi))),Qi=fi.typeArguments;let va=Ei(fi);for(let $l of va)Es=j.createQualifiedName(Es,$l);return j.updateTypeReferenceNode(Or,Es,Qi)}}function Ei(Or){let fi=Or.typeName,Qi=[];for(;!ze(fi);)Qi.unshift(fi.right),fi=fi.left;return Qi.unshift(fi),Qi}function bs(Or){if(_(Ne))return[j.createPropertySignature(void 0,"...",void 0,void 0)];let fi=[];for(let va of Or.callSignatures)fi.push(Ce(va,179,Ne));for(let va of Or.constructSignatures)va.flags&4||fi.push(Ce(va,180,Ne));for(let va of Or.indexInfos)fi.push(ae(va,Ne,Or.objectFlags&1024?T(Ne):void 0));let Qi=Or.properties;if(!Qi)return fi;let Es=0;for(let va of Qi){if(Es++,Ne.flags&2048){if(va.flags&4194304)continue;Nd(va)&6&&Ne.tracker.reportPrivateInBaseOfClassExpression&&Ne.tracker.reportPrivateInBaseOfClassExpression(Zi(va.escapedName))}if(_(Ne)&&Es+2<Qi.length-1){fi.push(j.createPropertySignature(void 0,`... ${Qi.length-Es} more ...`,void 0,void 0)),L(Qi[Qi.length-1],Ne,fi);break}L(va,Ne,fi)}return fi.length?fi:void 0}}function T(_t){return _t.approximateLength+=3,_t.flags&1?j.createKeywordTypeNode(133):j.createTypeReferenceNode(j.createIdentifier("..."),void 0)}function P(_t,Ne){var jr;return!!(Vc(_t)&8192)&&(hs(Ne.reverseMappedStack,_t)||((jr=Ne.reverseMappedStack)==null?void 0:jr[0])&&!(Gn(Rs(Ne.reverseMappedStack).links.propertyType)&16))}function L(_t,Ne,jr){var Vn;let bi=!!(Vc(_t)&8192),Mi=P(_t,Ne)?W:OS(_t),Li=Ne.enclosingDeclaration;if(Ne.enclosingDeclaration=void 0,Ne.tracker.canTrackSymbol&&pL(_t.escapedName))if(_t.declarations){let dr=di(_t.declarations);if(gz(dr))if(bn(dr)){let Wr=qs(dr);Wr&&fc(Wr)&&tR(Wr.argumentExpression)&&dn(Wr.argumentExpression,Li,Ne)}else dn(dr.name.expression,Li,Ne)}else Ne.tracker.reportNonSerializableProperty(Oi(_t));Ne.enclosingDeclaration=_t.valueDeclaration||((Vn=_t.declarations)==null?void 0:Vn[0])||Li;let ei=Br(_t,Ne);if(Ne.enclosingDeclaration=Li,Ne.approximateLength+=Lc(_t).length+1,_t.flags&98304){let dr=XE(_t);if(Mi!==dr&&!Xt(Mi)&&!Xt(dr)){let Wr=xc(_t,177),Ii=Sm(Wr);jr.push(kl(Ce(Ii,177,Ne,{name:ei}),Wr));let Ei=xc(_t,178),bs=Sm(Ei);jr.push(kl(Ce(bs,178,Ne,{name:ei}),Ei));return}}let Ln=_t.flags&16777216?j.createToken(58):void 0;if(_t.flags&8208&&!LS(Mi).length&&!wg(_t)){let dr=na(wl(Mi,Wr=>!(Wr.flags&32768)),0);for(let Wr of dr){let Ii=Ce(Wr,173,Ne,{name:ei,questionToken:Ln});jr.push(rr(Ii))}if(dr.length||!Ln)return}let lt;P(_t,Ne)?lt=T(Ne):(bi&&(Ne.reverseMappedStack||(Ne.reverseMappedStack=[]),Ne.reverseMappedStack.push(_t)),lt=Mi?Bo(Ne,Mi,_t,Li):j.createKeywordTypeNode(133),bi&&Ne.reverseMappedStack.pop());let Ut=wg(_t)?[j.createToken(148)]:void 0;Ut&&(Ne.approximateLength+=9);let sr=j.createPropertySignature(Ut,ei,Ln,lt);jr.push(rr(sr));function rr(dr){var Wr;let Ii=(Wr=_t.declarations)==null?void 0:Wr.find(Ei=>Ei.kind===355);if(Ii){let Ei=Z3(Ii.comment);Ei&&CT(dr,[{kind:3,text:`*
 * `+Ei.replace(/\n/g,`
 * `)+`
 `,pos:-1,end:-1,hasTrailingNewLine:!0}])}else _t.valueDeclaration&&kl(dr,_t.valueDeclaration);return dr}}function J(_t,Ne,jr){if(Tt(_t)){if(_(Ne))if(jr){if(_t.length>2)return[d(_t[0],Ne),j.createTypeReferenceNode(`... ${_t.length-2} more ...`,void 0),d(_t[_t.length-1],Ne)]}else return[j.createTypeReferenceNode("...",void 0)];let bi=!(Ne.flags&64)?g_():void 0,Mi=[],Li=0;for(let ei of _t){if(Li++,_(Ne)&&Li+2<_t.length-1){Mi.push(j.createTypeReferenceNode(`... ${_t.length-Li} more ...`,void 0));let lt=d(_t[_t.length-1],Ne);lt&&Mi.push(lt);break}Ne.approximateLength+=2;let Ln=d(ei,Ne);Ln&&(Mi.push(Ln),bi&&Fme(Ln)&&bi.add(Ln.typeName.escapedText,[ei,Mi.length-1]))}if(bi){let ei=Ne.flags;Ne.flags|=64,bi.forEach(Ln=>{if(!jme(Ln,([lt],[Ut])=>G(lt,Ut)))for(let[lt,Ut]of Ln)Mi[Ut]=d(lt,Ne)}),Ne.flags=ei}return Mi}}function G(_t,Ne){return _t===Ne||!!_t.symbol&&_t.symbol===Ne.symbol||!!_t.aliasSymbol&&_t.aliasSymbol===Ne.aliasSymbol}function ae(_t,Ne,jr){let Vn=sde(_t)||"x",bi=d(_t.keyType,Ne),Mi=j.createParameterDeclaration(void 0,void 0,Vn,void 0,bi,void 0);return jr||(jr=d(_t.type||W,Ne)),!_t.type&&!(Ne.flags&2097152)&&(Ne.encounteredError=!0),Ne.approximateLength+=Vn.length+4,j.createIndexSignature(_t.isReadonly?[j.createToken(148)]:void 0,[Mi],jr)}function Ce(_t,Ne,jr,Vn){var bi;let Mi=jr.flags&256;Mi&&(jr.flags&=-257),jr.approximateLength+=3;let Li,ei;jr.flags&32&&_t.target&&_t.mapper&&_t.target.typeParameters?ei=_t.target.typeParameters.map(bs=>d(gs(bs,_t.mapper),jr)):Li=_t.typeParameters&&_t.typeParameters.map(bs=>vt(bs,jr));let Ln=Zqe(_t,!0)[0],lt;if(jr.enclosingDeclaration&&_t.declaration&&_t.declaration!==jr.enclosingDeclaration&&!gn(_t.declaration)&&(Tt(Ln)||Tt(_t.typeParameters))){let bs=function(Or,fi){I.assert(jr.enclosingDeclaration);let Qi;_i(jr.enclosingDeclaration).fakeScopeForSignatureDeclaration===Or?Qi=jr.enclosingDeclaration:jr.enclosingDeclaration.parent&&_i(jr.enclosingDeclaration.parent).fakeScopeForSignatureDeclaration===Or&&(Qi=jr.enclosingDeclaration.parent),I.assertOptionalNode(Qi,ra);let Es=Qi?.locals??ga(),va;if(fi((So,au)=>{Es.has(So)||(va=Pr(va,So),Es.set(So,au))}),!va)return;let $l=lt;function Wc(){Te(va,So=>Es.delete(So)),$l?.()}if(Qi)lt=Wc;else{let So=$h.createBlock(tt);_i(So).fakeScopeForSignatureDeclaration=Or,So.locals=Es;let au=jr.enclosingDeclaration;io(So,au),jr.enclosingDeclaration=So,lt=()=>{jr.enclosingDeclaration=au,Wc()}}};var Ut=bs;bs("params",Or=>{for(let fi of Ln)Or(fi.escapedName,fi)}),jr.flags&4&&bs("typeParams",Or=>{for(let fi of _t.typeParameters??tt){let Qi=Ys(fi,jr).escapedText;Or(Qi,fi.symbol)}})}let sr=(Tt(Ln,bs=>bs!==Ln[Ln.length-1]&&!!(Vc(bs)&32768))?_t.parameters:Ln).map(bs=>ur(bs,jr,Ne===176,Vn?.privateSymbolVisitor,Vn?.bundledImports)),rr=jr.flags&33554432?void 0:be(_t,jr);rr&&sr.unshift(rr);let dr,Wr=zd(_t);if(Wr){let bs=Wr.kind===2||Wr.kind===3?j.createToken(131):void 0,Or=Wr.kind===1||Wr.kind===3?Sn(j.createIdentifier(Wr.parameterName),16777216):j.createThisTypeNode(),fi=Wr.type&&d(Wr.type,jr);dr=j.createTypePredicateNode(bs,Or,fi)}else{let bs=Ao(_t);bs&&!(Mi&&wt(bs))?dr=Qa(jr,bs,_t,Vn?.privateSymbolVisitor,Vn?.bundledImports):Mi||(dr=j.createKeywordTypeNode(133))}let Ii=Vn?.modifiers;if(Ne===185&&_t.flags&4){let bs=Yg(Ii);Ii=j.createModifiersFromModifierFlags(bs|64)}let Ei=Ne===179?j.createCallSignature(Li,sr,dr):Ne===180?j.createConstructSignature(Li,sr,dr):Ne===173?j.createMethodSignature(Ii,Vn?.name??j.createIdentifier(""),Vn?.questionToken,Li,sr,dr):Ne===174?j.createMethodDeclaration(Ii,void 0,Vn?.name??j.createIdentifier(""),void 0,Li,sr,dr,void 0):Ne===176?j.createConstructorDeclaration(Ii,sr,void 0):Ne===177?j.createGetAccessorDeclaration(Ii,Vn?.name??j.createIdentifier(""),sr,dr,void 0):Ne===178?j.createSetAccessorDeclaration(Ii,Vn?.name??j.createIdentifier(""),sr,void 0):Ne===181?j.createIndexSignature(Ii,sr,dr):Ne===324?j.createJSDocFunctionType(sr,dr):Ne===184?j.createFunctionTypeNode(Li,sr,dr??j.createTypeReferenceNode(j.createIdentifier(""))):Ne===185?j.createConstructorTypeNode(Ii,Li,sr,dr??j.createTypeReferenceNode(j.createIdentifier(""))):Ne===262?j.createFunctionDeclaration(Ii,void 0,Vn?.name?ta(Vn.name,ze):j.createIdentifier(""),Li,sr,dr,void 0):Ne===218?j.createFunctionExpression(Ii,void 0,Vn?.name?ta(Vn.name,ze):j.createIdentifier(""),Li,sr,dr,j.createBlock([])):Ne===219?j.createArrowFunction(Ii,Li,sr,dr,void 0,j.createBlock([])):I.assertNever(Ne);if(ei&&(Ei.typeArguments=j.createNodeArray(ei)),((bi=_t.declaration)==null?void 0:bi.kind)===330&&_t.declaration.parent.kind===346){let bs=Fl(_t.declaration.parent.parent,!0).slice(2,-2).split(/\r\n|\n|\r/).map(Or=>Or.replace(/^\s+/," ")).join(`
`);w6(Ei,3,bs,!0)}return lt?.(),Ei}function be(_t,Ne){if(_t.thisParameter)return ur(_t.thisParameter,Ne);if(_t.declaration&&gn(_t.declaration)){let jr=b9(_t.declaration);if(jr&&jr.typeExpression)return j.createParameterDeclaration(void 0,void 0,"this",void 0,d(Ri(jr.typeExpression),Ne))}}function Ye(_t,Ne,jr){let Vn=Ne.flags;Ne.flags&=-513;let bi=j.createModifiersFromModifierFlags(mCe(_t)),Mi=Ys(_t,Ne),Li=pC(_t),ei=Li&&d(Li,Ne);return Ne.flags=Vn,j.createTypeParameterDeclaration(bi,Mi,jr,ei)}function vt(_t,Ne,jr=Sf(_t)){let Vn=jr&&d(jr,Ne);return Ye(_t,Ne,Vn)}function Dt(_t){let Ne=xc(_t,169);if(Ne)return Ne;if(!Rh(_t))return xc(_t,348)}function ur(_t,Ne,jr,Vn,bi){let Mi=Dt(_t),Li=vn(_t);Mi&&JYe(Mi)&&(Li=$S(Li));let ei=Bo(Ne,Li,_t,Ne.enclosingDeclaration,Vn,bi),Ln=!(Ne.flags&8192)&&jr&&Mi&&Jm(Mi)?vr(jb(Mi),j.cloneNode):void 0,Ut=Mi&&x0(Mi)||Vc(_t)&32768?j.createToken(26):void 0,sr=pr(_t,Mi,Ne),dr=Mi&&gL(Mi)||Vc(_t)&16384?j.createToken(58):void 0,Wr=j.createParameterDeclaration(Ln,Ut,sr,dr,ei,void 0);return Ne.approximateLength+=Lc(_t).length+3,Wr}function pr(_t,Ne,jr){return Ne&&Ne.name?Ne.name.kind===80?Sn(j.cloneNode(Ne.name),16777216):Ne.name.kind===166?Sn(j.cloneNode(Ne.name.right),16777216):Vn(Ne.name):Lc(_t);function Vn(bi){return Mi(bi);function Mi(Li){jr.tracker.canTrackSymbol&&uo(Li)&&nxe(Li)&&dn(Li.expression,jr.enclosingDeclaration,jr);let ei=wr(Li,Mi,void 0,void 0,Mi);return co(ei)&&(ei=j.updateBindingElement(ei,ei.dotDotDotToken,ei.propertyName,ei.name,void 0)),_c(ei)||(ei=j.cloneNode(ei)),Sn(ei,16777217)}}}function dn(_t,Ne,jr){if(!jr.tracker.canTrackSymbol)return;let Vn=Jp(_t),bi=wc(Vn,Vn.escapedText,1160127,void 0,void 0,!0);bi&&jr.tracker.trackSymbol(bi,Ne,111551)}function Ur(_t,Ne,jr,Vn){return Ne.tracker.trackSymbol(_t,Ne.enclosingDeclaration,jr),fr(_t,Ne,jr,Vn)}function fr(_t,Ne,jr,Vn){let bi;return!(_t.flags&262144)&&(Ne.enclosingDeclaration||Ne.flags&64)&&!(Ne.flags&134217728)?(bi=I.checkDefined(Li(_t,jr,!0)),I.assert(bi&&bi.length>0)):bi=[_t],bi;function Li(ei,Ln,lt){let Ut=xS(ei,Ne.enclosingDeclaration,Ln,!!(Ne.flags&128)),sr;if(!Ut||nb(Ut[0],Ne.enclosingDeclaration,Ut.length===1?Ln:Hy(Ln))){let dr=tb(Ut?Ut[0]:ei,Ne.enclosingDeclaration,Ln);if(de(dr)){sr=dr.map(Ei=>Tt(Ei.declarations,U_)?Qr(Ei,Ne):void 0);let Wr=dr.map((Ei,bs)=>bs);Wr.sort(rr);let Ii=Wr.map(Ei=>dr[Ei]);for(let Ei of Ii){let bs=Li(Ei,Hy(Ln),!1);if(bs){if(Ei.exports&&Ei.exports.get("export=")&&bg(Ei.exports.get("export="),ei)){Ut=bs;break}Ut=bs.concat(Ut||[W0(Ei,ei)||ei]);break}}}}if(Ut)return Ut;if(lt||!(ei.flags&6144))return!lt&&!Vn&&Te(ei.declarations,U_)?void 0:[ei];function rr(dr,Wr){let Ii=sr[dr],Ei=sr[Wr];if(Ii&&Ei){let bs=Fp(Ei);return Fp(Ii)===bs?GU(Ii)-GU(Ei):bs?-1:1}return 0}}}function $r(_t,Ne){let jr;return FI(_t).flags&524384&&(jr=j.createNodeArray(vr(qn(_t),bi=>vt(bi,Ne)))),jr}function Jr(_t,Ne,jr){var Vn;I.assert(_t&&0<=Ne&&Ne<_t.length);let bi=_t[Ne],Mi=Ia(bi);if((Vn=jr.typeParameterSymbolList)!=null&&Vn.has(Mi))return;(jr.typeParameterSymbolList||(jr.typeParameterSymbolList=new Set)).add(Mi);let Li;if(jr.flags&512&&Ne<_t.length-1){let ei=bi,Ln=_t[Ne+1];if(Vc(Ln)&1){let lt=Yi(ei.flags&2097152?du(ei):ei);Li=J(vr(lt,Ut=>VS(Ut,Ln.links.mapper)),jr)}else Li=$r(bi,jr)}return Li}function on(_t){return lx(_t.objectType)?on(_t.objectType):_t}function Qr(_t,Ne,jr){let Vn=xc(_t,312);if(!Vn){let lt=Ct(_t.declarations,Ut=>iC(Ut,_t));lt&&(Vn=xc(lt,312))}if(Vn&&Vn.moduleName!==void 0)return Vn.moduleName;if(!Vn){if(Ne.tracker.trackReferencedAmbientModule){let lt=Fn(_t.declarations,S_);if(de(lt))for(let Ut of lt)Ne.tracker.trackReferencedAmbientModule(Ut,_t)}if(eZ.test(_t.escapedName))return _t.escapedName.substring(1,_t.escapedName.length-1)}if(!Ne.enclosingDeclaration||!Ne.tracker.moduleResolverHost)return eZ.test(_t.escapedName)?_t.escapedName.substring(1,_t.escapedName.length-1):Xr(DY(_t)).fileName;let bi=Xr(Hc(Ne.enclosingDeclaration)),Mi=jr||bi?.impliedNodeFormat,Li=rO(bi.path,Mi),ei=as(_t),Ln=ei.specifierCache&&ei.specifierCache.get(Li);if(!Ln){let lt=!!Wo($),{moduleResolverHost:Ut}=Ne.tracker,sr=lt?{...$,baseUrl:Ut.getCommonSourceDirectory()}:$;Ln=di(KRe(_t,nr,sr,bi,Ut,{importModuleSpecifierPreference:lt?"non-relative":"project-relative",importModuleSpecifierEnding:lt?"minimal":Mi===99?"js":void 0},{overrideImportMode:jr})),ei.specifierCache??(ei.specifierCache=new Map),ei.specifierCache.set(Li,Ln)}return Ln}function cn(_t){let Ne=j.createIdentifier(Zi(_t.escapedName));return _t.parent?j.createQualifiedName(cn(_t.parent),Ne):Ne}function Bs(_t,Ne,jr,Vn){let bi=Ur(_t,Ne,jr,!(Ne.flags&16384)),Mi=jr===111551;if(Tt(bi[0].declarations,U_)){let Ln=bi.length>1?ei(bi,bi.length-1,1):void 0,lt=Vn||Jr(bi,0,Ne),Ut=Xr(Hc(Ne.enclosingDeclaration)),sr=J9(bi[0]),rr,dr;if((Q_($)===3||Q_($)===99)&&sr?.impliedNodeFormat===99&&sr.impliedNodeFormat!==Ut?.impliedNodeFormat&&(rr=Qr(bi[0],Ne,99),dr=j.createImportAttributes(j.createNodeArray([j.createImportAttribute(j.createStringLiteral("resolution-mode"),j.createStringLiteral("import"))]))),rr||(rr=Qr(bi[0],Ne)),!(Ne.flags&67108864)&&Q_($)!==1&&rr.includes("/node_modules/")){let Ii=rr;if(Q_($)===3||Q_($)===99){let Ei=Ut?.impliedNodeFormat===99?1:99;rr=Qr(bi[0],Ne,Ei),rr.includes("/node_modules/")?rr=Ii:dr=j.createImportAttributes(j.createNodeArray([j.createImportAttribute(j.createStringLiteral("resolution-mode"),j.createStringLiteral(Ei===99?"import":"require"))]))}dr||(Ne.encounteredError=!0,Ne.tracker.reportLikelyUnsafeImportRequiredError&&Ne.tracker.reportLikelyUnsafeImportRequiredError(Ii))}let Wr=j.createLiteralTypeNode(j.createStringLiteral(rr));if(Ne.tracker.trackExternalModuleSymbolOfImportTypeNode&&Ne.tracker.trackExternalModuleSymbolOfImportTypeNode(bi[0]),Ne.approximateLength+=rr.length+10,!Ln||zf(Ln)){if(Ln){let Ii=ze(Ln)?Ln:Ln.right;M1(Ii,void 0)}return j.createImportTypeNode(Wr,dr,Ln,lt,Mi)}else{let Ii=on(Ln),Ei=Ii.objectType.typeName;return j.createIndexedAccessTypeNode(j.createImportTypeNode(Wr,dr,Ei,lt,Mi),Ii.indexType)}}let Li=ei(bi,bi.length-1,0);if(lx(Li))return Li;if(Mi)return j.createTypeQueryNode(Li);{let Ln=ze(Li)?Li:Li.right,lt=sx(Ln);return M1(Ln,void 0),j.createTypeReferenceNode(Li,lt)}function ei(Ln,lt,Ut){let sr=lt===Ln.length-1?Vn:Jr(Ln,lt,Ne),rr=Ln[lt],dr=Ln[lt-1],Wr;if(lt===0)Ne.flags|=16777216,Wr=ib(rr,Ne),Ne.approximateLength+=(Wr?Wr.length:0)+1,Ne.flags^=16777216;else if(dr&&Ep(dr)){let Ei=Ep(dr);yu(Ei,(bs,Or)=>{if(bg(bs,rr)&&!pL(Or)&&Or!=="export=")return Wr=Zi(Or),!0})}if(Wr===void 0){let Ei=Ct(rr.declarations,qs);if(Ei&&uo(Ei)&&zf(Ei.expression)){let bs=ei(Ln,lt-1,Ut);return zf(bs)?j.createIndexedAccessTypeNode(j.createParenthesizedType(j.createTypeQueryNode(bs)),j.createTypeQueryNode(Ei.expression)):bs}Wr=ib(rr,Ne)}if(Ne.approximateLength+=Wr.length+1,!(Ne.flags&16)&&dr&&MS(dr)&&MS(dr).get(rr.escapedName)&&bg(MS(dr).get(rr.escapedName),rr)){let Ei=ei(Ln,lt-1,Ut);return lx(Ei)?j.createIndexedAccessTypeNode(Ei,j.createLiteralTypeNode(j.createStringLiteral(Wr))):j.createIndexedAccessTypeNode(j.createTypeReferenceNode(Ei,sr),j.createLiteralTypeNode(j.createStringLiteral(Wr)))}let Ii=Sn(j.createIdentifier(Wr),16777216);if(sr&&M1(Ii,j.createNodeArray(sr)),Ii.symbol=rr,lt>Ut){let Ei=ei(Ln,lt-1,Ut);return zf(Ei)?j.createQualifiedName(Ei,Ii):I.fail("Impossible construct - an export of an indexed access cannot be reachable")}return Ii}}function Os(_t,Ne,jr){let Vn=wc(Ne.enclosingDeclaration,_t,788968,void 0,_t,!1);return Vn&&Vn.flags&262144?Vn!==jr.symbol:!1}function Ys(_t,Ne){var jr,Vn;if(Ne.flags&4&&Ne.typeParameterNames){let Mi=Ne.typeParameterNames.get(sf(_t));if(Mi)return Mi}let bi=As(_t.symbol,Ne,788968,!0);if(!(bi.kind&80))return j.createIdentifier("(Missing type parameter)");if(Ne.flags&4){let Mi=bi.escapedText,Li=((jr=Ne.typeParameterNamesByTextNextNameCount)==null?void 0:jr.get(Mi))||0,ei=Mi;for(;(Vn=Ne.typeParameterNamesByText)!=null&&Vn.has(ei)||Os(ei,Ne,_t);)Li++,ei=`${Mi}_${Li}`;if(ei!==Mi){let Ln=sx(bi);bi=j.createIdentifier(ei),M1(bi,Ln)}(Ne.typeParameterNamesByTextNextNameCount||(Ne.typeParameterNamesByTextNextNameCount=new Map)).set(Mi,Li),(Ne.typeParameterNames||(Ne.typeParameterNames=new Map)).set(sf(_t),bi),(Ne.typeParameterNamesByText||(Ne.typeParameterNamesByText=new Set)).add(ei)}return bi}function As(_t,Ne,jr,Vn){let bi=Ur(_t,Ne,jr);return Vn&&bi.length!==1&&!Ne.encounteredError&&!(Ne.flags&65536)&&(Ne.encounteredError=!0),Mi(bi,bi.length-1);function Mi(Li,ei){let Ln=Jr(Li,ei,Ne),lt=Li[ei];ei===0&&(Ne.flags|=16777216);let Ut=ib(lt,Ne);ei===0&&(Ne.flags^=16777216);let sr=Sn(j.createIdentifier(Ut),16777216);return Ln&&M1(sr,j.createNodeArray(Ln)),sr.symbol=lt,ei>0?j.createQualifiedName(Mi(Li,ei-1),sr):sr}}function su(_t,Ne,jr){let Vn=Ur(_t,Ne,jr);return bi(Vn,Vn.length-1);function bi(Mi,Li){let ei=Jr(Mi,Li,Ne),Ln=Mi[Li];Li===0&&(Ne.flags|=16777216);let lt=ib(Ln,Ne);Li===0&&(Ne.flags^=16777216);let Ut=lt.charCodeAt(0);if(P8(Ut)&&Tt(Ln.declarations,U_))return j.createStringLiteral(Qr(Ln,Ne));if(Li===0||YX(lt,pe)){let sr=Sn(j.createIdentifier(lt),16777216);return ei&&M1(sr,j.createNodeArray(ei)),sr.symbol=Ln,Li>0?j.createPropertyAccessExpression(bi(Mi,Li-1),sr):sr}else{Ut===91&&(lt=lt.substring(1,lt.length-1),Ut=lt.charCodeAt(0));let sr;if(P8(Ut)&&!(Ln.flags&8)?sr=j.createStringLiteral(cm(lt).replace(/\\./g,rr=>rr.substring(1)),Ut===39):""+ +lt===lt&&(sr=j.createNumericLiteral(+lt)),!sr){let rr=Sn(j.createIdentifier(lt),16777216);ei&&M1(rr,j.createNodeArray(ei)),rr.symbol=Ln,sr=rr}return j.createElementAccessExpression(bi(Mi,Li-1),sr)}}}function Hd(_t){let Ne=qs(_t);return Ne?uo(Ne)?!!(Cs(Ne.expression).flags&402653316):fc(Ne)?!!(Cs(Ne.argumentExpression).flags&402653316):za(Ne):!1}function rp(_t){let Ne=qs(_t);return!!(Ne&&za(Ne)&&(Ne.singleQuote||!_c(Ne)&&Ss(Fl(Ne,!1),"'")))}function Br(_t,Ne){let jr=!!de(_t.declarations)&&yr(_t.declarations,Hd),Vn=!!de(_t.declarations)&&yr(_t.declarations,rp),bi=!!(_t.flags&8192),Mi=an(_t,Ne,Vn,jr,bi);if(Mi)return Mi;let Li=Zi(_t.escapedName);return aB(Li,ho($),Vn,jr,bi)}function an(_t,Ne,jr,Vn,bi){let Mi=as(_t).nameType;if(Mi){if(Mi.flags&384){let Li=""+Mi.value;return!nd(Li,ho($))&&(Vn||!R0(Li))?j.createStringLiteral(Li,!!jr):R0(Li)&&Ss(Li,"-")?j.createComputedPropertyName(j.createPrefixUnaryExpression(41,j.createNumericLiteral(-Li))):aB(Li,ho($),jr,Vn,bi)}if(Mi.flags&8192)return j.createComputedPropertyName(su(Mi.symbol,Ne,111551))}}function ms(_t){let Ne={..._t};return Ne.typeParameterNames&&(Ne.typeParameterNames=new Map(Ne.typeParameterNames)),Ne.typeParameterNamesByText&&(Ne.typeParameterNamesByText=new Set(Ne.typeParameterNamesByText)),Ne.typeParameterSymbolList&&(Ne.typeParameterSymbolList=new Set(Ne.typeParameterSymbolList)),Ne.tracker=new rZ(Ne,Ne.tracker.inner,Ne.tracker.moduleResolverHost),Ne}function Pn(_t,Ne){return _t.declarations&&mr(_t.declarations,jr=>!!t_(jr)&&(!Ne||!!Gr(jr,Vn=>Vn===Ne)))}function Vs(_t,Ne){return!(Gn(Ne)&4)||!Id(_t)||de(_t.typeArguments)>=a0(Ne.target.typeParameters)}function vo(_t){for(;_i(_t).fakeScopeForSignatureDeclaration;)_t=_t.parent;return _t}function Bo(_t,Ne,jr,Vn,bi,Mi){if(!Xt(Ne)&&Vn){let Ln=Pn(jr,vo(Vn));if(Ln&&!tc(Ln)&&!sd(Ln)){let lt=t_(Ln);if(N_(lt,Ln,Ne)&&Vs(lt,Ne)){let Ut=el(_t,lt,bi,Mi);if(Ut)return Ut}}}let Li=_t.flags;Ne.flags&8192&&Ne.symbol===jr&&(!_t.enclosingDeclaration||Tt(jr.declarations,Ln=>Xr(Ln)===Xr(_t.enclosingDeclaration)))&&(_t.flags|=1048576);let ei=d(Ne,_t);return _t.flags=Li,ei}function N_(_t,Ne,jr){let Vn=Ri(_t);return Vn===jr?!0:Ls(Ne)&&Ne.questionToken?Em(jr,524288)===Vn:!1}function Qa(_t,Ne,jr,Vn,bi){if(!Xt(Ne)&&_t.enclosingDeclaration){let Mi=jr.declaration&&lm(jr.declaration),Li=vo(_t.enclosingDeclaration);if(Gr(Mi,ei=>ei===Li)&&Mi){let ei=Ri(Mi);if((ei.flags&262144&&ei.isThisType?gs(ei,jr.mapper):ei)===Ne&&Vs(Mi,Ne)){let lt=el(_t,Mi,Vn,bi);if(lt)return lt}}}return d(Ne,_t)}function bf(_t,Ne,jr){let Vn=!1,bi=Jp(_t);if(gn(_t)&&(G2(bi)||P0(bi.parent)||pf(bi.parent)&&HY(bi.parent.left)&&G2(bi.parent.right)))return Vn=!0,{introducesError:Vn,node:_t};let Mi=Vd(_t),Li=ac(bi,Mi,!0,!0);if(Li&&($i(Li,Ne.enclosingDeclaration,Mi,!1).accessibility!==0?Vn=!0:(Ne.tracker.trackSymbol(Li,Ne.enclosingDeclaration,Mi),jr?.(Li)),ze(_t))){let ei=dc(Li),Ln=Li.flags&262144?Ys(ei,Ne):j.cloneNode(_t);return Ln.symbol=Li,{introducesError:Vn,node:Sn(Un(Ln,_t),16777216)}}return{introducesError:Vn,node:_t}}function el(_t,Ne,jr,Vn){i&&i.throwIfCancellationRequested&&i.throwIfCancellationRequested();let bi=!1,Mi=Xr(Ne),Li=nt(Ne,ei,es);if(bi)return;return Li===Ne?ft(j.cloneNode(Ne),Ne):Li;function ei(Ln){if(Mge(Ln)||Ln.kind===326)return j.createKeywordTypeNode(133);if(Lge(Ln))return j.createKeywordTypeNode(159);if(GN(Ln))return j.createUnionTypeNode([nt(Ln.type,ei,es),j.createLiteralTypeNode(j.createNull())]);if(VK(Ln))return j.createUnionTypeNode([nt(Ln.type,ei,es),j.createKeywordTypeNode(157)]);if(cU(Ln))return nt(Ln.type,ei);if(lU(Ln))return j.createArrayTypeNode(nt(Ln.type,ei,es));if(mx(Ln))return j.createTypeLiteralNode(vr(Ln.jsDocPropertyTags,rr=>{let dr=ze(rr.name)?rr.name:rr.name.right,Wr=Xe(Ri(Ln),dr.escapedText),Ii=Wr&&rr.typeExpression&&Ri(rr.typeExpression.type)!==Wr?d(Wr,_t):void 0;return j.createPropertySignature(void 0,dr,rr.isBracketed||rr.typeExpression&&VK(rr.typeExpression.type)?j.createToken(58):void 0,Ii||rr.typeExpression&&nt(rr.typeExpression.type,ei,es)||j.createKeywordTypeNode(133))}));if(Id(Ln)&&ze(Ln.typeName)&&Ln.typeName.escapedText==="")return Un(j.createKeywordTypeNode(133),Ln);if((L1(Ln)||Id(Ln))&&_j(Ln))return j.createTypeLiteralNode([j.createIndexSignature(void 0,[j.createParameterDeclaration(void 0,void 0,"x",void 0,nt(Ln.typeArguments[0],ei,es))],nt(Ln.typeArguments[1],ei,es))]);if(HN(Ln))if(hN(Ln)){let rr;return j.createConstructorTypeNode(void 0,Hr(Ln.typeParameters,ei,Nc),Wi(Ln.parameters,(dr,Wr)=>dr.name&&ze(dr.name)&&dr.name.escapedText==="new"?(rr=dr.type,void 0):j.createParameterDeclaration(void 0,lt(dr),Ut(dr,Wr),dr.questionToken,nt(dr.type,ei,es),void 0)),nt(rr||Ln.type,ei,es)||j.createKeywordTypeNode(133))}else return j.createFunctionTypeNode(Hr(Ln.typeParameters,ei,Nc),vr(Ln.parameters,(rr,dr)=>j.createParameterDeclaration(void 0,lt(rr),Ut(rr,dr),rr.questionToken,nt(rr.type,ei,es),void 0)),nt(Ln.type,ei,es)||j.createKeywordTypeNode(133));if(Id(Ln)&&k8(Ln)&&(!Vs(Ln,Ri(Ln))||wze(Ln)||dt===xI(Ln,788968,!0)))return Un(d(Ri(Ln),_t),Ln);if(Vv(Ln)){let rr=_i(Ln).resolvedSymbol;return k8(Ln)&&rr&&(!Ln.isTypeOf&&!(rr.flags&788968)||!(de(Ln.typeArguments)>=a0(qn(rr))))?Un(d(Ri(Ln),_t),Ln):j.updateImportTypeNode(Ln,j.updateLiteralTypeNode(Ln.argument,sr(Ln,Ln.argument.literal)),Ln.attributes,Ln.qualifier,Hr(Ln.typeArguments,ei,es),Ln.isTypeOf)}if(zf(Ln)||ol(Ln)){let{introducesError:rr,node:dr}=bf(Ln,_t,jr);if(bi=bi||rr,dr!==Ln)return dr}return Mi&&XA(Ln)&&Lo(Mi,Ln.pos).line===Lo(Mi,Ln.end).line&&Sn(Ln,1),wr(Ln,ei,void 0);function lt(rr){return rr.dotDotDotToken||(rr.type&&lU(rr.type)?j.createToken(26):void 0)}function Ut(rr,dr){return rr.name&&ze(rr.name)&&rr.name.escapedText==="this"?"this":lt(rr)?"args":`arg${dr}`}function sr(rr,dr){if(Vn){if(_t.tracker&&_t.tracker.moduleResolverHost){let Wr=Ske(rr);if(Wr){let Ei={getCanonicalFileName:y_(!!e.useCaseSensitiveFileNames),getCurrentDirectory:()=>_t.tracker.moduleResolverHost.getCurrentDirectory(),getCommonSourceDirectory:()=>_t.tracker.moduleResolverHost.getCommonSourceDirectory()},bs=xj(Ei,Wr);return j.createStringLiteral(bs)}}}else if(_t.tracker&&_t.tracker.trackExternalModuleSymbolOfImportTypeNode){let Wr=Wy(dr,dr,void 0);Wr&&_t.tracker.trackExternalModuleSymbolOfImportTypeNode(Wr)}return dr}}}function Oc(_t,Ne,jr){var Vn;let bi=ko(j.createPropertyDeclaration,174,!0),Mi=ko((Mt,Bn,xi,si)=>j.createPropertySignature(Mt,Bn,xi,si),173,!1),Li=Ne.enclosingDeclaration,ei=[],Ln=new Set,lt=[],Ut=Ne;Ne={...Ut,usedSymbolNames:new Set(Ut.usedSymbolNames),remappedSymbolNames:new Map,remappedSymbolReferences:new Map((Vn=Ut.remappedSymbolReferences)==null?void 0:Vn.entries()),tracker:void 0};let sr={...Ut.tracker.inner,trackSymbol:(Mt,Bn,xi)=>{var si,Si;if((si=Ne.remappedSymbolNames)!=null&&si.has(Ia(Mt)))return!1;if($i(Mt,Bn,xi,!1).accessibility===0){let ha=fr(Mt,Ne,xi);if(!(Mt.flags&4)){let Zs=ha[0],Zo=Xr(Ut.enclosingDeclaration);Tt(Zs.declarations,Po=>Xr(Po)===Zo)&&So(Zs)}}else if((Si=Ut.tracker.inner)!=null&&Si.trackSymbol)return Ut.tracker.inner.trackSymbol(Mt,Bn,xi);return!1}};Ne.tracker=new rZ(Ne,sr,Ut.tracker.moduleResolverHost),yu(_t,(Mt,Bn)=>{let xi=Zi(Bn);ig(Mt,xi)});let rr=!jr,dr=_t.get("export=");return dr&&_t.size>1&&dr.flags&2098688&&(_t=ga(),_t.set("export=",dr)),va(_t),fi(ei);function Wr(Mt){return!!Mt&&Mt.kind===80}function Ii(Mt){return Xc(Mt)?Fn(vr(Mt.declarationList.declarations,qs),Wr):Fn([qs(Mt)],Wr)}function Ei(Mt){let Bn=mr(Mt,Kc),xi=oa(Mt,hl),si=xi!==-1?Mt[xi]:void 0;if(si&&Bn&&Bn.isExportEquals&&ze(Bn.expression)&&ze(si.name)&&Nn(si.name)===Nn(Bn.expression)&&si.body&&Zg(si.body)){let Si=Fn(Mt,Zs=>!!(X_(Zs)&32)),po=si.name,ha=si.body;if(de(Si)&&(si=j.updateModuleDeclaration(si,si.modifiers,si.name,ha=j.updateModuleBlock(ha,j.createNodeArray([...si.body.statements,j.createExportDeclaration(void 0,!1,j.createNamedExports(vr(_a(Si,Zs=>Ii(Zs)),Zs=>j.createExportSpecifier(!1,void 0,Zs))),void 0)]))),Mt=[...Mt.slice(0,xi),si,...Mt.slice(xi+1)]),!mr(Mt,Zs=>Zs!==si&&X3(Zs,po))){ei=[];let Zs=!Tt(ha.statements,Zo=>ui(Zo,32)||Kc(Zo)||yl(Zo));Te(ha.statements,Zo=>{lc(Zo,Zs?32:0)}),Mt=[...Fn(Mt,Zo=>Zo!==si&&Zo!==Bn),...ei]}}return Mt}function bs(Mt){let Bn=Fn(Mt,si=>yl(si)&&!si.moduleSpecifier&&!!si.exportClause&&wd(si.exportClause));de(Bn)>1&&(Mt=[...Fn(Mt,Si=>!yl(Si)||!!Si.moduleSpecifier||!Si.exportClause),j.createExportDeclaration(void 0,!1,j.createNamedExports(_a(Bn,Si=>ta(Si.exportClause,wd).elements)),void 0)]);let xi=Fn(Mt,si=>yl(si)&&!!si.moduleSpecifier&&!!si.exportClause&&wd(si.exportClause));if(de(xi)>1){let si=m_(xi,Si=>za(Si.moduleSpecifier)?">"+Si.moduleSpecifier.text:">");if(si.length!==xi.length)for(let Si of si)Si.length>1&&(Mt=[...Fn(Mt,po=>!Si.includes(po)),j.createExportDeclaration(void 0,!1,j.createNamedExports(_a(Si,po=>ta(po.exportClause,wd).elements)),Si[0].moduleSpecifier)])}return Mt}function Or(Mt){let Bn=oa(Mt,xi=>yl(xi)&&!xi.moduleSpecifier&&!xi.attributes&&!!xi.exportClause&&wd(xi.exportClause));if(Bn>=0){let xi=Mt[Bn],si=Wi(xi.exportClause.elements,Si=>{if(!Si.propertyName){let po=tT(Mt),ha=Fn(po,Zs=>X3(Mt[Zs],Si.name));if(de(ha)&&yr(ha,Zs=>_R(Mt[Zs]))){for(let Zs of ha)Mt[Zs]=Qi(Mt[Zs]);return}}return Si});de(si)?Mt[Bn]=j.updateExportDeclaration(xi,xi.modifiers,xi.isTypeOnly,j.updateNamedExports(xi.exportClause,si),xi.moduleSpecifier,xi.attributes):kv(Mt,Bn)}return Mt}function fi(Mt){return Mt=Ei(Mt),Mt=bs(Mt),Mt=Or(Mt),Li&&(ls(Li)&&Bp(Li)||hl(Li))&&(!Tt(Mt,o8)||!wpe(Mt)&&Tt(Mt,I9))&&Mt.push(VR(j)),Mt}function Qi(Mt){let Bn=(X_(Mt)|32)&-129;return j.replaceModifiers(Mt,Bn)}function Es(Mt){let Bn=X_(Mt)&-33;return j.replaceModifiers(Mt,Bn)}function va(Mt,Bn,xi){Bn||lt.push(new Map),Mt.forEach(si=>{$l(si,!1,!!xi)}),Bn||(lt[lt.length-1].forEach(si=>{$l(si,!0,!!xi)}),lt.pop())}function $l(Mt,Bn,xi){let si=mo(Mt);if(Ln.has(Ia(si)))return;if(Ln.add(Ia(si)),!Bn||de(Mt.declarations)&&Tt(Mt.declarations,po=>!!Gr(po,ha=>ha===Li))){let po=Ne;Ne=ms(Ne),Wc(Mt,Bn,xi),Ne.reportedDiagnostic&&(Ut.reportedDiagnostic=Ne.reportedDiagnostic),Ne.trackedSymbols&&(po.trackedSymbols?I.assert(Ne.trackedSymbols===po.trackedSymbols):po.trackedSymbols=Ne.trackedSymbols),Ne=po}}function Wc(Mt,Bn,xi,si=Mt.escapedName){var Si,po,ha,Zs,Zo,Po;let Za=Zi(si),u_=si==="default";if(Bn&&!(Ne.flags&131072)&&PA(Za)&&!u_){Ne.encounteredError=!0;return}let __=u_&&!!(Mt.flags&-113||Mt.flags&16&&de(Io(vn(Mt))))&&!(Mt.flags&2097152),of=!__&&!Bn&&PA(Za)&&!u_;(__||of)&&(Bn=!0);let dl=(Bn?0:32)|(u_&&!__?2048:0),f_=Mt.flags&1536&&Mt.flags&7&&si!=="export=",Uf=f_&&$o(vn(Mt),Mt);if((Mt.flags&8208||Uf)&&Dr(vn(Mt),Mt,ig(Mt,Za),dl),Mt.flags&524288&&Og(Mt,Za,dl),Mt.flags&98311&&si!=="export="&&!(Mt.flags&4194304)&&!(Mt.flags&32)&&!(Mt.flags&8192)&&!Uf)if(xi)La(Mt)&&(of=!1,__=!1);else{let ju=vn(Mt),Pp=ig(Mt,Za);if(ju.symbol&&ju.symbol!==Mt&&ju.symbol.flags&16&&Tt(ju.symbol.declarations,iE)&&((Si=ju.symbol.members)!=null&&Si.size||(po=ju.symbol.exports)!=null&&po.size))Ne.remappedSymbolReferences||(Ne.remappedSymbolReferences=new Map),Ne.remappedSymbolReferences.set(Ia(ju.symbol),Mt),Wc(ju.symbol,Bn,xi,si),Ne.remappedSymbolReferences.delete(Ia(ju.symbol));else if(!(Mt.flags&16)&&$o(ju,Mt))Dr(ju,Mt,Pp,dl);else{let mP=Mt.flags&2?b4(Mt)?2:1:(ha=Mt.parent)!=null&&ha.valueDeclaration&&ls((Zs=Mt.parent)==null?void 0:Zs.valueDeclaration)?2:void 0,bh=__||!(Mt.flags&4)?Pp:Rg(Pp,Mt),YS=Mt.declarations&&mr(Mt.declarations,ZL=>Gi(ZL));YS&&Tu(YS.parent)&&YS.parent.declarations.length===1&&(YS=YS.parent.parent);let XS=(Zo=Mt.declarations)==null?void 0:Zo.find(Hn);if(XS&&bn(XS.parent)&&ze(XS.parent.right)&&((Po=ju.symbol)!=null&&Po.valueDeclaration)&&ls(ju.symbol.valueDeclaration)){let ZL=Pp===XS.parent.right.escapedText?void 0:XS.parent.right;lc(j.createExportDeclaration(void 0,!1,j.createNamedExports([j.createExportSpecifier(!1,ZL,Pp)])),0),Ne.tracker.trackSymbol(ju.symbol,Ne.enclosingDeclaration,111551)}else{let ZL=ft(j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(bh,void 0,Bo(Ne,ju,Mt,Li,So,jr))],mP)),YS);lc(ZL,bh!==Pp?dl&-33:dl),bh!==Pp&&!Bn&&(lc(j.createExportDeclaration(void 0,!1,j.createNamedExports([j.createExportSpecifier(!1,bh,Pp)])),0),of=!1,__=!1)}}}if(Mt.flags&384&&jn(Mt,Za,dl),Mt.flags&32&&(Mt.flags&4&&Mt.valueDeclaration&&bn(Mt.valueDeclaration.parent)&&wu(Mt.valueDeclaration.parent.right)?wi(Mt,ig(Mt,Za),dl):ba(Mt,ig(Mt,Za),dl)),(Mt.flags&1536&&(!f_||ir(Mt))||Uf)&&tn(Mt,Za,dl),Mt.flags&64&&!(Mt.flags&32)&&it(Mt,Za,dl),Mt.flags&2097152&&wi(Mt,ig(Mt,Za),dl),Mt.flags&4&&Mt.escapedName==="export="&&La(Mt),Mt.flags&8388608&&Mt.declarations)for(let ju of Mt.declarations){let Pp=rf(ju,ju.moduleSpecifier);Pp&&lc(j.createExportDeclaration(void 0,ju.isTypeOnly,void 0,j.createStringLiteral(Qr(Pp,Ne))),0)}__?lc(j.createExportAssignment(void 0,!1,j.createIdentifier(ig(Mt,Za))),0):of&&lc(j.createExportDeclaration(void 0,!1,j.createNamedExports([j.createExportSpecifier(!1,ig(Mt,Za),Za)])),0)}function So(Mt){if(Tt(Mt.declarations,Kb))return;I.assertIsDefined(lt[lt.length-1]),Rg(Zi(Mt.escapedName),Mt);let Bn=!!(Mt.flags&2097152)&&!Tt(Mt.declarations,xi=>!!Gr(xi,yl)||qh(xi)||Ru(xi)&&!zh(xi.moduleReference));lt[Bn?0:lt.length-1].set(Ia(Mt),Mt)}function au(Mt){return ls(Mt)&&(Bp(Mt)||sm(Mt))||S_(Mt)&&!zg(Mt)}function lc(Mt,Bn){if(Jm(Mt)){let xi=0,si=Ne.enclosingDeclaration&&(am(Ne.enclosingDeclaration)?Xr(Ne.enclosingDeclaration):Ne.enclosingDeclaration);Bn&32&&si&&(au(si)||hl(si))&&_R(Mt)&&(xi|=32),rr&&!(xi&32)&&(!si||!(si.flags&33554432))&&(AT(Mt)||Xc(Mt)||Zl(Mt)||eu(Mt)||hl(Mt))&&(xi|=128),Bn&2048&&(eu(Mt)||ef(Mt)||Zl(Mt))&&(xi|=2048),xi&&(Mt=j.replaceModifiers(Mt,xi|X_(Mt)))}ei.push(Mt)}function Og(Mt,Bn,xi){var si;let Si=Vqe(Mt),po=as(Mt).typeParameters,ha=vr(po,__=>vt(__,Ne)),Zs=(si=Mt.declarations)==null?void 0:si.find(am),Zo=Z3(Zs?Zs.comment||Zs.parent.comment:void 0),Po=Ne.flags;Ne.flags|=8388608;let Za=Ne.enclosingDeclaration;Ne.enclosingDeclaration=Zs;let u_=Zs&&Zs.typeExpression&&hE(Zs.typeExpression)&&el(Ne,Zs.typeExpression.type,So,jr)||d(Si,Ne);lc(CT(j.createTypeAliasDeclaration(void 0,ig(Mt,Bn),ha,u_),Zo?[{kind:3,text:`*
 * `+Zo.replace(/\n/g,`
 * `)+`
 `,pos:-1,end:-1,hasTrailingNewLine:!0}]:[]),xi),Ne.flags=Po,Ne.enclosingDeclaration=Za}function it(Mt,Bn,xi){let si=qd(Mt),Si=qn(Mt),po=vr(Si,of=>vt(of,Ne)),ha=Cp(si),Zs=de(ha)?Pa(ha):void 0,Zo=_a(Io(si),of=>ou(of,Zs)),Po=_0(0,si,Zs,179),Za=_0(1,si,Zs,180),u_=l1(si,Zs),__=de(ha)?[j.createHeritageClause(96,Wi(ha,of=>OC(of,111551)))]:void 0;lc(j.createInterfaceDeclaration(void 0,ig(Mt,Bn),po,__,[...u_,...Za,...Po,...Zo]),xi)}function xt(Mt){let Bn=In(Ep(Mt).values()),xi=mo(Mt);if(xi!==Mt){let si=new Set(Bn);for(let Si of Ep(xi).values())a_(ll(Si))&111551||si.add(Si);Bn=In(si)}return Fn(Bn,si=>Xi(si)&&nd(si.escapedName,99))}function ir(Mt){return yr(xt(Mt),Bn=>!(a_(ll(Bn))&111551))}function tn(Mt,Bn,xi){let si=xt(Mt),Si=_l(si,Zs=>Zs.parent&&Zs.parent===Mt?"real":"merged"),po=Si.get("real")||tt,ha=Si.get("merged")||tt;if(de(po)){let Zs=ig(Mt,Bn);ti(po,Zs,xi,!!(Mt.flags&67108880))}if(de(ha)){let Zs=Xr(Ne.enclosingDeclaration),Zo=ig(Mt,Bn),Po=j.createModuleBlock([j.createExportDeclaration(void 0,!1,j.createNamedExports(Wi(Fn(ha,Za=>Za.escapedName!=="export="),Za=>{var u_,__;let of=Zi(Za.escapedName),dl=ig(Za,of),f_=Za.declarations&&Xm(Za);if(Zs&&(f_?Zs!==Xr(f_):!Tt(Za.declarations,Pp=>Xr(Pp)===Zs))){(__=(u_=Ne.tracker)==null?void 0:u_.reportNonlocalAugmentation)==null||__.call(u_,Zs,Mt,Za);return}let Uf=f_&&$p(f_,!0);So(Uf||Za);let ju=Uf?ig(Uf,Zi(Uf.escapedName)):dl;return j.createExportSpecifier(!1,of===ju?void 0:ju,of)})))]);lc(j.createModuleDeclaration(void 0,j.createIdentifier(Zo),Po,32),0)}}function jn(Mt,Bn,xi){lc(j.createEnumDeclaration(j.createModifiersFromModifierFlags(VAe(Mt)?4096:0),ig(Mt,Bn),vr(Fn(Io(vn(Mt)),si=>!!(si.flags&8)),si=>{let Si=si.declarations&&si.declarations[0]&&gE(si.declarations[0])?hke(si.declarations[0]):void 0;return j.createEnumMember(Zi(si.escapedName),Si===void 0?void 0:typeof Si=="string"?j.createStringLiteral(Si):j.createNumericLiteral(Si))})),xi)}function Dr(Mt,Bn,xi,si){let Si=na(Mt,0);for(let po of Si){let ha=Ce(po,262,Ne,{name:j.createIdentifier(xi),privateSymbolVisitor:So,bundledImports:jr});lc(ft(ha,An(po)),si)}if(!(Bn.flags&1536&&Bn.exports&&Bn.exports.size)){let po=Fn(Io(Mt),Xi);ti(po,xi,si,!0)}}function An(Mt){if(Mt.declaration&&Mt.declaration.parent){if(bn(Mt.declaration.parent)&&al(Mt.declaration.parent)===5)return Mt.declaration.parent;if(Gi(Mt.declaration.parent)&&Mt.declaration.parent.parent)return Mt.declaration.parent.parent}return Mt.declaration}function ti(Mt,Bn,xi,si){if(de(Mt)){let po=_l(Mt,dl=>!de(dl.declarations)||Tt(dl.declarations,f_=>Xr(f_)===Xr(Ne.enclosingDeclaration))?"local":"remote").get("local")||tt,ha=$h.createModuleDeclaration(void 0,j.createIdentifier(Bn),j.createModuleBlock([]),32);io(ha,Li),ha.locals=ga(Mt),ha.symbol=Mt[0].parent;let Zs=ei;ei=[];let Zo=rr;rr=!1;let Po={...Ne,enclosingDeclaration:ha},Za=Ne;Ne=Po,va(ga(po),si,!0),Ne=Za,rr=Zo;let u_=ei;ei=Zs;let __=vr(u_,dl=>Kc(dl)&&!dl.isExportEquals&&ze(dl.expression)?j.createExportDeclaration(void 0,!1,j.createNamedExports([j.createExportSpecifier(!1,dl.expression,j.createIdentifier("default"))])):dl),of=yr(__,dl=>ui(dl,32))?vr(__,Es):__;ha=j.updateModuleDeclaration(ha,ha.modifiers,ha.name,j.createModuleBlock(of)),lc(ha,xi)}}function Xi(Mt){return!!(Mt.flags&2887656)||!(Mt.flags&4194304||Mt.escapedName==="prototype"||Mt.valueDeclaration&&pa(Mt.valueDeclaration)&&Ti(Mt.valueDeclaration.parent))}function Hs(Mt){let Bn=Wi(Mt,xi=>{let si=Ne.enclosingDeclaration;Ne.enclosingDeclaration=xi;let Si=xi.expression;if(ol(Si)){if(ze(Si)&&Nn(Si)==="")return po(void 0);let ha;if({introducesError:ha,node:Si}=bf(Si,Ne,So),ha)return po(void 0)}return po(j.createExpressionWithTypeArguments(Si,vr(xi.typeArguments,ha=>el(Ne,ha,So,jr)||d(Ri(ha),Ne))));function po(ha){return Ne.enclosingDeclaration=si,ha}});if(Bn.length===Mt.length)return Bn}function ba(Mt,Bn,xi){var si,Si;let po=(si=Mt.declarations)==null?void 0:si.find(Ti),ha=Ne.enclosingDeclaration;Ne.enclosingDeclaration=po||ha;let Zs=qn(Mt),Zo=vr(Zs,Eh=>vt(Eh,Ne)),Po=Hp(qd(Mt)),Za=Cp(Po),u_=po&&SN(po),__=u_&&Hs(u_)||Wi(Cg(Po),M4),of=vn(Mt),dl=!!((Si=of.symbol)!=null&&Si.valueDeclaration)&&Ti(of.symbol.valueDeclaration),f_=dl?xp(of):W,Uf=[...de(Za)?[j.createHeritageClause(96,vr(Za,Eh=>wC(Eh,f_,Bn)))]:[],...de(__)?[j.createHeritageClause(119,__)]:[]],ju=RUt(Po,Za,Io(Po)),Pp=Fn(ju,Eh=>{let L4=Eh.valueDeclaration;return!!L4&&!(W_(L4)&&is(L4.name))}),bh=Tt(ju,Eh=>{let L4=Eh.valueDeclaration;return!!L4&&W_(L4)&&is(L4.name)})?[j.createPropertyDeclaration(void 0,j.createPrivateIdentifier("#private"),void 0,void 0,void 0)]:tt,YS=_a(Pp,Eh=>bi(Eh,!1,Za[0])),XS=_a(Fn(Io(of),Eh=>!(Eh.flags&4194304)&&Eh.escapedName!=="prototype"&&!Xi(Eh)),Eh=>bi(Eh,!0,f_)),KJt=!dl&&!!Mt.valueDeclaration&&gn(Mt.valueDeclaration)&&!Tt(na(of,1))?[j.createConstructorDeclaration(j.createModifiersFromModifierFlags(2),[],void 0)]:_0(1,of,f_,176),QJt=l1(Po,Za[0]);Ne.enclosingDeclaration=ha,lc(ft(j.createClassDeclaration(void 0,Bn,Zo,Uf,[...QJt,...XS,...KJt,...YS,...bh]),Mt.declarations&&Fn(Mt.declarations,Eh=>eu(Eh)||wu(Eh))[0]),xi)}function Ea(Mt){return Ct(Mt,Bn=>{if(Gf(Bn)||R_(Bn))return Nn(Bn.propertyName||Bn.name);if(bn(Bn)||Kc(Bn)){let xi=Kc(Bn)?Bn.expression:Bn.right;if(Hn(xi))return Nn(xi.name)}if(yS(Bn)){let xi=qs(Bn);if(xi&&ze(xi))return Nn(xi)}})}function wi(Mt,Bn,xi){var si,Si,po,ha,Zs,Zo;let Po=Xm(Mt);if(!Po)return I.fail();let Za=mo($p(Po,!0));if(!Za)return;let u_=Uw(Za)&&Ea(Mt.declarations)||Zi(Za.escapedName);u_==="export="&&Z&&(u_="default");let __=ig(Za,u_);switch(So(Za),Po.kind){case 208:if(((Si=(si=Po.parent)==null?void 0:si.parent)==null?void 0:Si.kind)===260){let f_=Qr(Za.parent||Za,Ne),{propertyName:Uf}=Po;lc(j.createImportDeclaration(void 0,j.createImportClause(!1,void 0,j.createNamedImports([j.createImportSpecifier(!1,Uf&&ze(Uf)?j.createIdentifier(Nn(Uf)):void 0,j.createIdentifier(Bn))])),j.createStringLiteral(f_),void 0),0);break}I.failBadSyntaxKind(((po=Po.parent)==null?void 0:po.parent)||Po,"Unhandled binding element grandparent kind in declaration serialization");break;case 304:((Zs=(ha=Po.parent)==null?void 0:ha.parent)==null?void 0:Zs.kind)===226&&Ws(Zi(Mt.escapedName),__);break;case 260:if(Hn(Po.initializer)){let f_=Po.initializer,Uf=j.createUniqueName(Bn),ju=Qr(Za.parent||Za,Ne);lc(j.createImportEqualsDeclaration(void 0,!1,Uf,j.createExternalModuleReference(j.createStringLiteral(ju))),0),lc(j.createImportEqualsDeclaration(void 0,!1,j.createIdentifier(Bn),j.createQualifiedName(Uf,f_.name)),xi);break}case 271:if(Za.escapedName==="export="&&Tt(Za.declarations,f_=>ls(f_)&&sm(f_))){La(Mt);break}let of=!(Za.flags&512)&&!Gi(Po);lc(j.createImportEqualsDeclaration(void 0,!1,j.createIdentifier(Bn),of?As(Za,Ne,-1,!1):j.createExternalModuleReference(j.createStringLiteral(Qr(Za,Ne)))),of?xi:0);break;case 270:lc(j.createNamespaceExportDeclaration(Nn(Po.name)),0);break;case 273:{let f_=Qr(Za.parent||Za,Ne),Uf=jr?j.createStringLiteral(f_):Po.parent.moduleSpecifier;lc(j.createImportDeclaration(void 0,j.createImportClause(!1,j.createIdentifier(Bn),void 0),Uf,Po.parent.attributes),0);break}case 274:{let f_=Qr(Za.parent||Za,Ne),Uf=jr?j.createStringLiteral(f_):Po.parent.parent.moduleSpecifier;lc(j.createImportDeclaration(void 0,j.createImportClause(!1,void 0,j.createNamespaceImport(j.createIdentifier(Bn))),Uf,Po.parent.attributes),0);break}case 280:lc(j.createExportDeclaration(void 0,!1,j.createNamespaceExport(j.createIdentifier(Bn)),j.createStringLiteral(Qr(Za,Ne))),0);break;case 276:{let f_=Qr(Za.parent||Za,Ne),Uf=jr?j.createStringLiteral(f_):Po.parent.parent.parent.moduleSpecifier;lc(j.createImportDeclaration(void 0,j.createImportClause(!1,void 0,j.createNamedImports([j.createImportSpecifier(!1,Bn!==u_?j.createIdentifier(u_):void 0,j.createIdentifier(Bn))])),Uf,Po.parent.parent.parent.attributes),0);break}case 281:let dl=Po.parent.parent.moduleSpecifier;dl&&((Zo=Po.propertyName)==null?void 0:Zo.escapedText)==="default"&&(u_="default"),Ws(Zi(Mt.escapedName),dl?u_:__,dl&&bo(dl)?j.createStringLiteral(dl.text):void 0);break;case 277:La(Mt);break;case 226:case 211:case 212:Mt.escapedName==="default"||Mt.escapedName==="export="?La(Mt):Ws(Bn,__);break;default:return I.failBadSyntaxKind(Po,"Unhandled alias declaration kind in symbol serializer!")}}function Ws(Mt,Bn,xi){lc(j.createExportDeclaration(void 0,!1,j.createNamedExports([j.createExportSpecifier(!1,Mt!==Bn?Bn:void 0,Mt)]),xi),0)}function La(Mt){var Bn;if(Mt.flags&4194304)return!1;let xi=Zi(Mt.escapedName),si=xi==="export=",po=si||xi==="default",ha=Mt.declarations&&Xm(Mt),Zs=ha&&$p(ha,!0);if(Zs&&de(Zs.declarations)&&Tt(Zs.declarations,Zo=>Xr(Zo)===Xr(Li))){let Zo=ha&&(Kc(ha)||bn(ha)?nX(ha):Rde(ha)),Po=Zo&&ol(Zo)?HUt(Zo):void 0,Za=Po&&ac(Po,-1,!0,!0,Li);(Za||Zs)&&So(Za||Zs);let u_=Ne.tracker.disableTrackSymbol;if(Ne.tracker.disableTrackSymbol=!0,po)ei.push(j.createExportAssignment(void 0,si,su(Zs,Ne,-1)));else if(Po===Zo&&Po)Ws(xi,Nn(Po));else if(Zo&&wu(Zo))Ws(xi,ig(Zs,Lc(Zs)));else{let __=Rg(xi,Mt);lc(j.createImportEqualsDeclaration(void 0,!1,j.createIdentifier(__),As(Zs,Ne,-1,!1)),0),Ws(xi,__)}return Ne.tracker.disableTrackSymbol=u_,!0}else{let Zo=Rg(xi,Mt),Po=Yp(vn(mo(Mt)));if($o(Po,Mt))Dr(Po,Mt,Zo,po?0:32);else{let Za=((Bn=Ne.enclosingDeclaration)==null?void 0:Bn.kind)===267&&(!(Mt.flags&98304)||Mt.flags&65536)?1:2,u_=j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(Zo,void 0,Bo(Ne,Po,Mt,Li,So,jr))],Za));lc(u_,Zs&&Zs.flags&4&&Zs.escapedName==="export="?128:xi===Zo?32:0)}return po?(ei.push(j.createExportAssignment(void 0,si,j.createIdentifier(Zo))),!0):xi!==Zo?(Ws(xi,Zo),!0):!1}}function $o(Mt,Bn){let xi=Xr(Ne.enclosingDeclaration);return Gn(Mt)&48&&!de(nf(Mt))&&!YE(Mt)&&!!(de(Fn(Io(Mt),Xi))||de(na(Mt,0)))&&!de(na(Mt,1))&&!Pn(Bn,Li)&&!(Mt.symbol&&Tt(Mt.symbol.declarations,si=>Xr(si)!==xi))&&!Tt(Io(Mt),si=>pL(si.escapedName))&&!Tt(Io(Mt),si=>Tt(si.declarations,Si=>Xr(Si)!==xi))&&yr(Io(Mt),si=>nd(Lc(si),pe)?si.flags&98304?OS(si)===XE(si):!0:!1)}function ko(Mt,Bn,xi){return function(Si,po,ha){var Zs,Zo,Po,Za,u_;let __=Nd(Si),of=!!(__&2);if(po&&Si.flags&2887656)return[];if(Si.flags&4194304||Si.escapedName==="constructor"||ha&&ka(ha,Si.escapedName)&&wg(ka(ha,Si.escapedName))===wg(Si)&&(Si.flags&16777216)===(ka(ha,Si.escapedName).flags&16777216)&&n1(vn(Si),Xe(ha,Si.escapedName)))return[];let dl=__&-1025|(po?256:0),f_=Br(Si,Ne),Uf=(Zs=Si.declarations)==null?void 0:Zs.find(cg(ea,Mv,Gi,fp,bn,Hn));if(Si.flags&98304&&xi){let ju=[];if(Si.flags&65536){let Pp=Si.declarations&&Te(Si.declarations,bh=>{if(bh.kind===178)return bh;if(da(bh)&&H2(bh))return Te(bh.arguments[2].properties,YS=>{let XS=qs(YS);if(XS&&ze(XS)&&Nn(XS)==="set")return YS})});I.assert(!!Pp);let mP=tc(Pp)?Sm(Pp).parameters[0]:void 0;ju.push(ft(j.createSetAccessorDeclaration(j.createModifiersFromModifierFlags(dl),f_,[j.createParameterDeclaration(void 0,void 0,mP?pr(mP,Dt(mP),Ne):"value",void 0,of?void 0:Bo(Ne,vn(Si),Si,Li,So,jr))],void 0),((Zo=Si.declarations)==null?void 0:Zo.find(A1))||Uf))}if(Si.flags&32768){let Pp=__&2;ju.push(ft(j.createGetAccessorDeclaration(j.createModifiersFromModifierFlags(dl),f_,[],Pp?void 0:Bo(Ne,vn(Si),Si,Li,So,jr),void 0),((Po=Si.declarations)==null?void 0:Po.find(Fv))||Uf))}return ju}else if(Si.flags&98311)return ft(Mt(j.createModifiersFromModifierFlags((wg(Si)?8:0)|dl),f_,Si.flags&16777216?j.createToken(58):void 0,of?void 0:Bo(Ne,XE(Si),Si,Li,So,jr),void 0),((Za=Si.declarations)==null?void 0:Za.find(cg(ea,Gi)))||Uf);if(Si.flags&8208){let ju=vn(Si),Pp=na(ju,0);if(dl&2)return ft(Mt(j.createModifiersFromModifierFlags((wg(Si)?8:0)|dl),f_,Si.flags&16777216?j.createToken(58):void 0,void 0,void 0),((u_=Si.declarations)==null?void 0:u_.find(tc))||Pp[0]&&Pp[0].declaration||Si.declarations&&Si.declarations[0]);let mP=[];for(let bh of Pp){let YS=Ce(bh,Bn,Ne,{name:f_,questionToken:Si.flags&16777216?j.createToken(58):void 0,modifiers:dl?j.createModifiersFromModifierFlags(dl):void 0}),XS=bh.declaration&&M8(bh.declaration.parent)?bh.declaration.parent:bh.declaration;mP.push(ft(YS,XS))}return mP}return I.fail(`Unhandled class member kind! ${Si.__debugFlags||Si.flags}`)}}function ou(Mt,Bn){return Mi(Mt,!1,Bn)}function _0(Mt,Bn,xi,si){let Si=na(Bn,Mt);if(Mt===1){if(!xi&&yr(Si,Zs=>de(Zs.parameters)===0))return[];if(xi){let Zs=na(xi,1);if(!de(Zs)&&yr(Si,Zo=>de(Zo.parameters)===0))return[];if(Zs.length===Si.length){let Zo=!1;for(let Po=0;Po<Zs.length;Po++)if(!Bz(Si[Po],Zs[Po],!1,!1,!0,AL)){Zo=!0;break}if(!Zo)return[]}}let ha=0;for(let Zs of Si)Zs.declaration&&(ha|=DA(Zs.declaration,6));if(ha)return[ft(j.createConstructorDeclaration(j.createModifiersFromModifierFlags(ha),[],void 0),Si[0].declaration)]}let po=[];for(let ha of Si){let Zs=Ce(ha,si,Ne);po.push(ft(Zs,ha.declaration))}return po}function l1(Mt,Bn){let xi=[];for(let si of nf(Mt)){if(Bn){let Si=K0(Bn,si.keyType);if(Si&&n1(si.type,Si.type))continue}xi.push(ae(si,Ne,void 0))}return xi}function wC(Mt,Bn,xi){let si=OC(Mt,111551);if(si)return si;let Si=Rg(`${xi}_base`),po=j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(Si,void 0,d(Bn,Ne))],2));return lc(po,0),j.createExpressionWithTypeArguments(j.createIdentifier(Si),void 0)}function OC(Mt,Bn){let xi,si;if(Mt.target&&lr(Mt.target.symbol,Li,Bn)?(xi=vr(cc(Mt),Si=>d(Si,Ne)),si=su(Mt.target.symbol,Ne,788968)):Mt.symbol&&lr(Mt.symbol,Li,Bn)&&(si=su(Mt.symbol,Ne,788968)),si)return j.createExpressionWithTypeArguments(si,xi)}function M4(Mt){let Bn=OC(Mt,788968);if(Bn)return Bn;if(Mt.symbol)return j.createExpressionWithTypeArguments(su(Mt.symbol,Ne,788968),void 0)}function Rg(Mt,Bn){var xi,si;let Si=Bn?Ia(Bn):void 0;if(Si&&Ne.remappedSymbolNames.has(Si))return Ne.remappedSymbolNames.get(Si);Bn&&(Mt=dP(Bn,Mt));let po=0,ha=Mt;for(;(xi=Ne.usedSymbolNames)!=null&&xi.has(Mt);)po++,Mt=`${ha}_${po}`;return(si=Ne.usedSymbolNames)==null||si.add(Mt),Si&&Ne.remappedSymbolNames.set(Si,Mt),Mt}function dP(Mt,Bn){if(Bn==="default"||Bn==="__class"||Bn==="__function"){let xi=Ne.flags;Ne.flags|=16777216;let si=ib(Mt,Ne);Ne.flags=xi,Bn=si.length>0&&P8(si.charCodeAt(0))?cm(si):si}return Bn==="default"?Bn="_default":Bn==="export="&&(Bn="_exports"),Bn=nd(Bn,pe)&&!PA(Bn)?Bn:"_"+Bn.replace(/[^a-zA-Z0-9]/g,"_"),Bn}function ig(Mt,Bn){let xi=Ia(Mt);return Ne.remappedSymbolNames.has(xi)?Ne.remappedSymbolNames.get(xi):(Bn=dP(Mt,Bn),Ne.remappedSymbolNames.set(xi,Bn),Bn)}}}function r0(r,a,_=16384,d){return d?y(d).getText():jw(y);function y(T){let P=j.createTypePredicateNode(r.kind===2||r.kind===3?j.createToken(131):void 0,r.kind===1||r.kind===3?j.createIdentifier(r.parameterName):j.createThisTypeNode(),r.type&&kt.typeToTypeNode(r.type,a,aC(_)|70221824|512)),L=EE(),J=a&&Xr(a);return L.writeNode(4,P,J,T),T}}function pI(r){let a=[],_=0;for(let d=0;d<r.length;d++){let y=r[d];if(_|=y.flags,!(y.flags&98304)){if(y.flags&1568){let T=y.flags&512?Pi:Wse(y);if(T.flags&1048576){let P=T.types.length;if(d+P<=r.length&&af(r[d+P-1])===af(T.types[P-1])){a.push(T),d+=P-1;continue}}}a.push(y)}}return _&65536&&a.push(he),_&32768&&a.push(Be),a||r}function oC(r){return r===2?"private":r===4?"protected":"public"}function uz(r){if(r.symbol&&r.symbol.flags&2048&&r.symbol.declarations){let a=J8(r.symbol.declarations[0].parent);if(Vm(a))return Rn(a)}}function PS(r){return r&&r.parent&&r.parent.kind===268&&qb(r.parent.parent)}function lL(r){return r.kind===312||S_(r)}function uL(r,a){let _=as(r).nameType;if(_){if(_.flags&384){let d=""+_.value;return!nd(d,ho($))&&!R0(d)?`"${D0(d,34)}"`:R0(d)&&Ss(d,"-")?`[${d}]`:d}if(_.flags&8192)return`[${ib(_.symbol,a)}]`}}function ib(r,a){var _;if((_=a?.remappedSymbolReferences)!=null&&_.has(Ia(r))&&(r=a.remappedSymbolReferences.get(Ia(r))),a&&r.escapedName==="default"&&!(a.flags&16384)&&(!(a.flags&16777216)||!r.declarations||a.enclosingDeclaration&&Gr(r.declarations[0],lL)!==Gr(a.enclosingDeclaration,lL)))return"default";if(r.declarations&&r.declarations.length){let y=Ct(r.declarations,P=>qs(P)?P:void 0),T=y&&qs(y);if(y&&T){if(da(y)&&H2(y))return Lc(r);if(uo(T)&&!(Vc(r)&4096)){let P=as(r).nameType;if(P&&P.flags&384){let L=uL(r,a);if(L!==void 0)return L}}return qo(T)}if(y||(y=r.declarations[0]),y.parent&&y.parent.kind===260)return qo(y.parent.name);switch(y.kind){case 231:case 218:case 219:return a&&!a.encounteredError&&!(a.flags&131072)&&(a.encounteredError=!0),y.kind===231?"(Anonymous class)":"(Anonymous function)"}}let d=uL(r,a);return d!==void 0?d:Lc(r)}function Eg(r){if(r){let _=_i(r);return _.isVisible===void 0&&(_.isVisible=!!a()),_.isVisible}return!1;function a(){switch(r.kind){case 345:case 353:case 347:return!!(r.parent&&r.parent.parent&&r.parent.parent.parent&&ls(r.parent.parent.parent));case 208:return Eg(r.parent.parent);case 260:if(la(r.name)&&!r.name.elements.length)return!1;case 267:case 263:case 264:case 265:case 262:case 266:case 271:if(qb(r))return!0;let _=te(r);return!(joe(r)&32)&&!(r.kind!==271&&_.kind!==312&&_.flags&33554432)?Kh(_):Eg(_);case 172:case 171:case 177:case 178:case 174:case 173:if(up(r,6))return!1;case 176:case 180:case 179:case 181:case 169:case 268:case 184:case 185:case 187:case 183:case 188:case 189:case 192:case 193:case 196:case 202:return Eg(r.parent);case 273:case 274:case 276:return!1;case 168:case 312:case 270:return!0;case 277:return!1;default:return!1}}}function t4(r,a){let _;r.parent&&r.parent.kind===277?_=wc(r,r.escapedText,2998271,void 0,r,!1):r.parent.kind===281&&(_=QT(r.parent,2998271));let d,y;return _&&(y=new Set,y.add(Ia(_)),T(_.declarations)),d;function T(P){Te(P,L=>{let J=Wx(L)||L;if(a?_i(L).isVisible=!0:(d=d||[],ln(d,J)),fN(L)){let G=L.moduleReference,ae=Jp(G),Ce=wc(L,ae.escapedText,901119,void 0,void 0,!1);Ce&&y&&Zd(y,Ia(Ce))&&T(Ce.declarations)}})}}function n0(r,a){let _=tP(r,a);if(_>=0){let{length:d}=Hu;for(let y=_;y<d;y++)Uy[y]=!1;return!1}return Hu.push(r),Uy.push(!0),qT.push(a),!0}function tP(r,a){for(let _=Hu.length-1;_>=Rk;_--){if(_L(Hu[_],qT[_]))return-1;if(Hu[_]===r&&qT[_]===a)return _}return-1}function _L(r,a){switch(a){case 0:return!!as(r).type;case 5:return!!_i(r).resolvedEnumType;case 2:return!!as(r).declaredType;case 1:return!!r.resolvedBaseConstructorType;case 3:return!!r.resolvedReturnType;case 4:return!!r.immediateBaseConstraint;case 6:return!!r.resolvedTypeArguments;case 7:return!!r.baseTypesResolved;case 8:return!!as(r).writeType;case 9:return _i(r).parameterInitializerContainsUndefined!==void 0}return I.assertNever(a)}function dh(){return Hu.pop(),qT.pop(),Uy.pop()}function te(r){return Gr(Gg(r),a=>{switch(a.kind){case 260:case 261:case 276:case 275:case 274:case 273:return!1;default:return!0}}).parent}function De(r){let a=dc(yf(r));return a.typeParameters?iv(a,vr(a.typeParameters,_=>W)):a}function Xe(r,a){let _=ka(r,a);return _?vn(_):void 0}function Pt(r,a){var _;let d;return Xe(r,a)||(d=(_=iP(r,a))==null?void 0:_.type)&&ep(d,!0,!0)}function wt(r){return r&&(r.flags&1)!==0}function Xt(r){return r===ht||!!(r.flags&1&&r.aliasSymbol)}function Yn(r,a){if(a!==0)return cC(r,!1,a);let _=Rn(r);return _&&as(_).type||cC(r,!1,a)}function Hi(r,a,_){if(r=wl(r,J=>!(J.flags&98304)),r.flags&131072)return $a;if(r.flags&1048576)return Ec(r,J=>Hi(J,a,_));let d=pi(vr(a,av)),y=[],T=[];for(let J of Io(r)){let G=CI(J,8576);!Na(G,d)&&!(Nd(J)&6)&&uae(J)?y.push(J):T.push(G)}if(hC(r)||yC(d)){if(T.length&&(d=pi([d,...T])),d.flags&131072)return r;let J=rMt();return J?EI(J,[r,d]):ht}let P=ga();for(let J of y)P.set(J.escapedName,eCe(J,!1));let L=Ho(_,P,tt,tt,nf(r));return L.objectFlags|=4194304,L}function Ui(r){return!!(r.flags&465829888)&&$c(k_(r)||Sr,32768)}function Ai(r){let a=rg(r,Ui)?Ec(r,_=>_.flags&465829888?e1(_):_):r;return Em(a,524288)}function cs(r,a){let _=Co(r);return _?GS(_,a):a}function Co(r){let a=zo(r);if(a&&B8(a)&&a.flowNode){let _=_o(r);if(_){let d=ft($h.createStringLiteral(_),r),y=$f(a)?a:$h.createParenthesizedExpression(a),T=ft($h.createElementAccessExpression(y,d),r);return io(d,T),io(T,r),y!==a&&io(y,T),T.flowNode=a.flowNode,T}}}function zo(r){let a=r.parent.parent;switch(a.kind){case 208:case 303:return Co(a);case 209:return Co(r.parent);case 260:return a.initializer;case 226:return a.right}}function _o(r){let a=r.parent;return r.kind===208&&a.kind===206?Jd(r.propertyName||r.name):r.kind===303||r.kind===304?Jd(r.name):""+a.elements.indexOf(r)}function Jd(r){let a=av(r);return a.flags&384?""+a.value:void 0}function mh(r){let a=r.dotDotDotToken?32:0,_=Yn(r.parent.parent,a);return _&&Y0(r,_,!1)}function Y0(r,a,_){if(wt(a))return a;let d=r.parent;Q&&r.flags&33554432&&Kb(r)?a=a1(a):Q&&d.parent.initializer&&!bm(EWe(d.parent.initializer),65536)&&(a=Em(a,524288));let y;if(d.kind===206)if(r.dotDotDotToken){if(a=Pg(a),a.flags&2||!e$(a))return He(r,g.Rest_types_may_only_be_created_from_object_types),ht;let T=[];for(let P of d.elements)P.dotDotDotToken||T.push(P.propertyName||P.name);y=Hi(a,T,r.symbol)}else{let T=r.propertyName||r.name,P=av(T),L=Ap(a,P,32,T);y=cs(r,L)}else{let T=uv(65|(r.dotDotDotToken?0:128),a,Be,d),P=d.elements.indexOf(r);if(r.dotDotDotToken){let L=Ec(a,J=>J.flags&58982400?e1(J):J);y=tp(L,Ka)?Ec(L,J=>f4(J,P)):P_(T)}else if(cv(a)){let L=Ng(P),J=32|(_||E4(r)?16:0),G=BS(a,L,J,r.name)||ht;y=cs(r,G)}else y=T}return r.initializer?t_(GP(r))?Q&&!bm(C4(r,0),16777216)?Ai(y):y:moe(r,pi([Ai(y),C4(r,0)],2)):y}function Yy(r){let a=fT(r);if(a)return Ri(a)}function Xy(r){let a=Do(r,!0);return a.kind===106||a.kind===80&&tg(a)===$e}function NS(r){let a=Do(r,!0);return a.kind===209&&a.elements.length===0}function ep(r,a=!1,_=!0){return Q&&_?$S(r,a):r}function cC(r,a,_){if(Gi(r)&&r.parent.parent.kind===249){let P=gh(dAe(Cs(r.parent.parent.expression,_)));return P.flags&4456448?a$e(P):Le}if(Gi(r)&&r.parent.parent.kind===250){let P=r.parent.parent;return A$(P)||W}if(la(r.parent))return mh(r);let d=ea(r)&&!Hg(r)||fp(r)||jge(r),y=a&&C6(r),T=ps(r);if(kY(r))return T?wt(T)||T===Sr?T:ht:Ee?Sr:W;if(T)return ep(T,d,y);if((ve||gn(r))&&Gi(r)&&!la(r.name)&&!(joe(r)&32)&&!(r.flags&33554432)){if(!(f2(r)&6)&&(!r.initializer||Xy(r.initializer)))return st;if(r.initializer&&NS(r.initializer))return xu}if(Ls(r)){let P=r.parent;if(P.kind===178&&vI(P)){let G=xc(Rn(r.parent),177);if(G){let ae=Sm(G),Ce=Eke(P);return Ce&&r===Ce?(I.assert(!Ce.type),vn(ae.thisParameter)):Ao(ae)}}let L=PRt(P,r);if(L)return L;let J=r.symbol.escapedName==="this"?WWe(P):GWe(r);if(J)return ep(J,!1,y)}if(V2(r)&&r.initializer){if(gn(r)&&!Ls(r)){let L=ro(r,Rn(r),D8(r));if(L)return L}let P=moe(r,C4(r,_));return ep(P,d,y)}if(ea(r)&&(ve||gn(r)))if(jl(r)){let P=Fn(r.parent.members,Jc),L=P.length?Ky(r.symbol,P):X_(r)&128?Eae(r.symbol):void 0;return L&&ep(L,!0,y)}else{let P=Gy(r.parent),L=P?DS(r.symbol,P):X_(r)&128?Eae(r.symbol):void 0;return L&&ep(L,!0,y)}if(th(r))return zr;if(la(r.name))return R(r.name,!1,!0)}function dI(r){if(r.valueDeclaration&&bn(r.valueDeclaration)){let a=as(r);return a.isConstructorDeclaredProperty===void 0&&(a.isConstructorDeclaredProperty=!1,a.isConstructorDeclaredProperty=!!n4(r)&&yr(r.declarations,_=>bn(_)&&Hae(_)&&(_.left.kind!==212||id(_.left.argumentExpression))&&!Il(void 0,_,r,_))),a.isConstructorDeclaredProperty}return!1}function r4(r){let a=r.valueDeclaration;return a&&ea(a)&&!t_(a)&&!a.initializer&&(ve||gn(a))}function n4(r){if(r.declarations)for(let a of r.declarations){let _=kf(a,!1,!1);if(_&&(_.kind===176||Sh(_)))return _}}function sb(r){let a=Xr(r.declarations[0]),_=Zi(r.escapedName),d=r.declarations.every(T=>gn(T)&&Yo(T)&&P0(T.expression)),y=d?j.createPropertyAccessExpression(j.createPropertyAccessExpression(j.createIdentifier("module"),j.createIdentifier("exports")),_):j.createPropertyAccessExpression(j.createIdentifier("exports"),_);return d&&io(y.expression.expression,y.expression),io(y.expression,y),io(y,a),y.flowNode=a.endFlowNode,GS(y,st,Be)}function Ky(r,a){let _=Ss(r.escapedName,"__#")?j.createPrivateIdentifier(r.escapedName.split("@")[1]):Zi(r.escapedName);for(let d of a){let y=j.createPropertyAccessExpression(j.createThis(),_);io(y.expression,y),io(y,d),y.flowNode=d.returnFlowNode;let T=mI(y,r);if(ve&&(T===st||T===xu)&&He(r.valueDeclaration,g.Member_0_implicitly_has_an_1_type,Oi(r),Kr(T)),!tp(T,i$))return XL(T)}}function DS(r,a){let _=Ss(r.escapedName,"__#")?j.createPrivateIdentifier(r.escapedName.split("@")[1]):Zi(r.escapedName),d=j.createPropertyAccessExpression(j.createThis(),_);io(d.expression,d),io(d,a),d.flowNode=a.returnFlowNode;let y=mI(d,r);return ve&&(y===st||y===xu)&&He(r.valueDeclaration,g.Member_0_implicitly_has_an_1_type,Oi(r),Kr(y)),tp(y,i$)?void 0:XL(y)}function mI(r,a){let _=a?.valueDeclaration&&(!r4(a)||X_(a.valueDeclaration)&128)&&Eae(a)||Be;return GS(r,st,_)}function Gp(r,a){let _=EA(r.valueDeclaration);if(_){let L=gn(_)?_T(_):void 0;return L&&L.typeExpression?Ri(L.typeExpression):r.valueDeclaration&&ro(r.valueDeclaration,r,_)||i2(xl(_))}let d,y=!1,T=!1;if(dI(r)&&(d=DS(r,n4(r))),!d){let L;if(r.declarations){let J;for(let G of r.declarations){let ae=bn(G)||da(G)?G:Yo(G)?bn(G.parent)?G.parent:G:void 0;if(!ae)continue;let Ce=Yo(ae)?R8(ae):al(ae);(Ce===4||bn(ae)&&Hae(ae,Ce))&&(i4(ae)?y=!0:T=!0),da(ae)||(J=Il(J,ae,r,G)),J||(L||(L=[])).push(bn(ae)||da(ae)?ab(r,a,ae,Ce):Qn)}d=J}if(!d){if(!de(L))return ht;let J=y&&r.declarations?IS(L,r.declarations):void 0;if(T){let ae=Eae(r);ae&&((J||(J=[])).push(ae),y=!0)}let G=Tt(J,ae=>!!(ae.flags&-98305))?J:L;d=pi(G)}}let P=Yp(ep(d,!1,T&&!y));return r.valueDeclaration&&gn(r.valueDeclaration)&&wl(P,L=>!!(L.flags&-98305))===Qn?(hb(r.valueDeclaration,W),W):P}function ro(r,a,_){var d,y;if(!gn(r)||!_||!Ha(_)||_.properties.length)return;let T=ga();for(;bn(r)||Hn(r);){let J=yd(r);(d=J?.exports)!=null&&d.size&&Tg(T,J.exports),r=bn(r)?r.parent:r.parent.parent}let P=yd(r);(y=P?.exports)!=null&&y.size&&Tg(T,P.exports);let L=Ho(a,T,tt,tt,tt);return L.objectFlags|=4096,L}function Il(r,a,_,d){var y;let T=t_(a.parent);if(T){let P=Yp(Ri(T));if(r)!Xt(r)&&!Xt(P)&&!n1(r,P)&&KHe(void 0,r,d,P);else return P}if((y=_.parent)!=null&&y.valueDeclaration){let P=zE(_.parent);if(P.valueDeclaration){let L=t_(P.valueDeclaration);if(L){let J=ka(Ri(L),_.escapedName);if(J)return OS(J)}}}return r}function ab(r,a,_,d){if(da(_)){if(a)return vn(a);let P=xl(_.arguments[2]),L=Xe(P,"value");if(L)return L;let J=Xe(P,"get");if(J){let ae=NC(J);if(ae)return Ao(ae)}let G=Xe(P,"set");if(G){let ae=NC(G);if(ae)return MAe(ae)}return W}if(rP(_.left,_.right))return W;let y=d===1&&(Hn(_.left)||fc(_.left))&&(P0(_.left.expression)||ze(_.left.expression)&&G2(_.left.expression)),T=a?vn(a):y?af(xl(_.right)):i2(xl(_.right));if(T.flags&524288&&d===2&&r.escapedName==="export="){let P=kg(T),L=ga();B9(P.members,L);let J=L.size;a&&!a.exports&&(a.exports=ga()),(a||r).exports.forEach((ae,Ce)=>{var be;let Ye=L.get(Ce);if(Ye&&Ye!==ae&&!(ae.flags&2097152))if(ae.flags&111551&&Ye.flags&111551){if(ae.valueDeclaration&&Ye.valueDeclaration&&Xr(ae.valueDeclaration)!==Xr(Ye.valueDeclaration)){let Dt=Zi(ae.escapedName),ur=((be=ii(Ye.valueDeclaration,W_))==null?void 0:be.name)||Ye.valueDeclaration;Ga(He(ae.valueDeclaration,g.Duplicate_identifier_0,Dt),$n(ur,g._0_was_also_declared_here,Dt)),Ga(He(ur,g.Duplicate_identifier_0,Dt),$n(ae.valueDeclaration,g._0_was_also_declared_here,Dt))}let vt=oo(ae.flags|Ye.flags,Ce);vt.links.type=pi([vn(ae),vn(Ye)]),vt.valueDeclaration=Ye.valueDeclaration,vt.declarations=ys(Ye.declarations,ae.declarations),L.set(Ce,vt)}else L.set(Ce,hm(ae,Ye));else L.set(Ce,ae)});let G=Ho(J!==L.size?void 0:P.symbol,L,P.callSignatures,P.constructSignatures,P.indexInfos);if(J===L.size&&(T.aliasSymbol&&(G.aliasSymbol=T.aliasSymbol,G.aliasTypeArguments=T.aliasTypeArguments),Gn(T)&4)){G.aliasSymbol=T.symbol;let ae=cc(T);G.aliasTypeArguments=de(ae)?ae:void 0}return G.objectFlags|=Gn(T)&4096,G.symbol&&G.symbol.flags&32&&T===qd(G.symbol)&&(G.objectFlags|=16777216),G}return Cae(T)?(hb(_,bl),bl):T}function rP(r,a){return Hn(r)&&r.expression.kind===110&&Y6(a,_=>o_(r,_))}function i4(r){let a=kf(r,!1,!1);return a.kind===176||a.kind===262||a.kind===218&&!M8(a.parent)}function IS(r,a){return I.assert(r.length===a.length),r.filter((_,d)=>{let y=a[d],T=bn(y)?y:bn(y.parent)?y.parent:void 0;return T&&i4(T)})}function s4(r,a,_){if(r.initializer){let d=la(r.name)?R(r.name,!0,!1):Sr;return ep(moe(r,C4(r,_?0:1,d)))}return la(r.name)?R(r.name,a,_):(_&&!kn(r)&&hb(r,W),a?Cr:W)}function pn(r,a,_){let d=ga(),y,T=131200;Te(r.elements,L=>{let J=L.propertyName||L.name;if(L.dotDotDotToken){y=o0(Le,W,!1);return}let G=av(J);if(!um(G)){T|=512;return}let ae=_m(G),Ce=4|(L.initializer?16777216:0),be=oo(Ce,ae);be.links.type=s4(L,a,_),be.links.bindingElement=L,d.set(be.escapedName,be)});let P=Ho(void 0,d,tt,tt,y?[y]:tt);return P.objectFlags|=T,a&&(P.pattern=r,P.objectFlags|=131072),P}function E(r,a,_){let d=r.elements,y=Is(d),T=y&&y.kind===208&&y.dotDotDotToken?y:void 0;if(d.length===0||d.length===1&&T)return pe>=2?zze(W):bl;let P=vr(d,ae=>Su(ae)?W:s4(ae,a,_)),L=no(d,ae=>!(ae===T||Su(ae)||E4(ae)),d.length-1)+1,J=vr(d,(ae,Ce)=>ae===T?4:Ce>=L?2:1),G=c0(P,J);return a&&(G=Cze(G),G.pattern=r,G.objectFlags|=131072),G}function R(r,a=!1,_=!1){return r.kind===206?pn(r,a,_):E(r,a,_)}function q(r,a){return Qt(cC(r,!0,0),r,a)}function fe(r){let a=_i(r);if(!a.resolvedType){let _=oo(4096,"__importAttributes"),d=ga();Te(r.elements,T=>{let P=oo(4,uB(T));P.parent=_,P.links.type=YUt(T),P.links.target=P,d.set(P.escapedName,P)});let y=Ho(_,d,tt,tt,tt);y.objectFlags|=262272,a.resolvedType=y}return a.resolvedType}function Qe(r){let a=yd(r),_=zRt(!1);return _&&a&&a===_}function Qt(r,a,_){return r?(r.flags&4096&&Qe(a.parent)&&(r=tCe(a)),_&&Oae(a,r),r.flags&8192&&(co(a)||!a.type)&&r.symbol!==Rn(a)&&(r=Fi),Yp(r)):(r=Ls(a)&&a.dotDotDotToken?bl:W,_&&(kn(a)||hb(a,r)),r)}function kn(r){let a=Gg(r),_=a.kind===169?a.parent:a;return T$(_)}function ps(r){let a=t_(r);if(a)return Ri(a)}function oc(r){let a=r.valueDeclaration;return a?(co(a)&&(a=GP(a)),Ls(a)?gae(a.parent):!1):!1}function xg(r,a){let _=as(r);if(!_.type){let d=wS(r,a);return!_.type&&!oc(r)&&!a&&(_.type=d),d}return _.type}function wS(r,a){if(r.flags&4194304)return De(r);if(r===St)return W;if(r.flags&134217728&&r.valueDeclaration){let y=Rn(Xr(r.valueDeclaration)),T=oo(y.flags,"exports");T.declarations=y.declarations?y.declarations.slice():[],T.parent=r,T.links.target=y,y.valueDeclaration&&(T.valueDeclaration=y.valueDeclaration),y.members&&(T.members=new Map(y.members)),y.exports&&(T.exports=new Map(y.exports));let P=ga();return P.set("exports",T),Ho(r,P,tt,tt,tt)}I.assertIsDefined(r.valueDeclaration);let _=r.valueDeclaration;if(ls(_)&&sm(_))return _.statements.length?Yp(i2(Cs(_.statements[0].expression))):$a;if(Mv(_))return cb(r);if(!n0(r,0))return r.flags&512&&!(r.flags&67108864)?a4(r):co(_)&&a===1?ht:gI(r);let d;if(_.kind===277)d=Qt(ps(_)||xl(_.expression),_);else if(bn(_)||gn(_)&&(da(_)||(Hn(_)||mj(_))&&bn(_.parent)))d=Gp(r);else if(Hn(_)||fc(_)||ze(_)||bo(_)||_p(_)||eu(_)||Zl(_)||pl(_)&&!jm(_)||Uh(_)||ls(_)){if(r.flags&9136)return a4(r);d=bn(_.parent)?Gp(r):ps(_)||W}else if(Ul(_))d=ps(_)||EHe(_);else if(th(_))d=ps(_)||sGe(_);else if(Hf(_))d=ps(_)||k4(_.name,0);else if(jm(_))d=ps(_)||xHe(_,0);else if(Ls(_)||ea(_)||fp(_)||Gi(_)||co(_)||ww(_))d=q(_,!0);else if(AT(_))d=a4(r);else if(gE(_))d=qse(r);else return I.fail("Unhandled declaration kind! "+I.formatSyntaxKind(_.kind)+" for "+I.formatSymbol(r));return dh()?d:r.flags&512&&!(r.flags&67108864)?a4(r):co(_)&&a===1?d:gI(r)}function eg(r){if(r)switch(r.kind){case 177:return lm(r);case 178:return zde(r);case 172:return I.assert(Hg(r)),t_(r)}}function ob(r){let a=eg(r);return a&&Ri(a)}function Vse(r){let a=Eke(r);return a&&a.symbol}function Z2e(r){return fb(Sm(r))}function cb(r){let a=as(r);if(!a.type){if(!n0(r,0))return ht;let _=xc(r,177),d=xc(r,178),y=ii(xc(r,172),Af),T=_&&gn(_)&&Yy(_)||ob(_)||ob(d)||ob(y)||_&&_.body&&foe(_)||y&&y.initializer&&q(y,!0);T||(d&&!T$(d)?Yu(ve,d,g.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation,Oi(r)):_&&!T$(_)?Yu(ve,_,g.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation,Oi(r)):y&&!T$(y)&&Yu(ve,y,g.Member_0_implicitly_has_an_1_type,Oi(r),"any"),T=W),dh()||(eg(_)?He(_,g._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,Oi(r)):eg(d)||eg(y)?He(d,g._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,Oi(r)):_&&ve&&He(_,g._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions,Oi(r)),T=W),a.type=T}return a.type}function _z(r){let a=as(r);if(!a.writeType){if(!n0(r,8))return ht;let _=xc(r,178)??ii(xc(r,172),Af),d=ob(_);dh()||(eg(_)&&He(_,g._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,Oi(r)),d=W),a.writeType=d||cb(r)}return a.writeType}function Jse(r){let a=xp(qd(r));return a.flags&8650752?a:a.flags&2097152?mr(a.types,_=>!!(_.flags&8650752)):void 0}function a4(r){let a=as(r),_=a;if(!a.type){let d=r.valueDeclaration&&uoe(r.valueDeclaration,!1);if(d){let y=NAe(r,d);y&&(r=y,a=y.links)}_.type=a.type=fz(r)}return a.type}function fz(r){let a=r.valueDeclaration;if(r.flags&1536&&Uw(r))return W;if(a&&(a.kind===226||Yo(a)&&a.parent.kind===226))return Gp(r);if(r.flags&512&&a&&ls(a)&&a.commonJsModuleIndicator){let d=bp(r);if(d!==r){if(!n0(r,0))return ht;let y=mo(r.exports.get("export=")),T=Gp(y,y===d?void 0:d);return dh()?T:gI(r)}}let _=Ud(16,r);if(r.flags&32){let d=Jse(r);return d?Pa([_,d]):_}else return Q&&r.flags&16777216?$S(_,!0):_}function qse(r){let a=as(r);return a.type||(a.type=zqe(r))}function zse(r){let a=as(r);if(!a.type){if(!n0(r,0))return ht;let _=du(r),d=r.declarations&&$p(Xm(r),!0),y=Ct(d?.declarations,T=>Kc(T)?ps(T):void 0);if(a.type=d?.declarations&&Noe(d.declarations)&&r.declarations.length?sb(d):Noe(r.declarations)?st:y||(a_(_)&111551?vn(_):ht),!dh())return gI(d??r),a.type=ht}return a.type}function exe(r){let a=as(r);return a.type||(a.type=gs(vn(a.target),a.mapper))}function txe(r){let a=as(r);return a.writeType||(a.writeType=gs(XE(a.target),a.mapper))}function gI(r){let a=r.valueDeclaration;if(a){if(t_(a))return He(r.valueDeclaration,g._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,Oi(r)),ht;ve&&(a.kind!==169||a.initializer)&&He(r.valueDeclaration,g._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer,Oi(r))}else if(r.flags&2097152){let _=Xm(r);_&&He(_,g.Circular_definition_of_import_alias_0,Oi(r))}return W}function $se(r){let a=as(r);return a.type||(I.assertIsDefined(a.deferralParent),I.assertIsDefined(a.deferralConstituents),a.type=a.deferralParent.flags&1048576?pi(a.deferralConstituents):Pa(a.deferralConstituents)),a.type}function pz(r){let a=as(r);return!a.writeType&&a.deferralWriteConstituents&&(I.assertIsDefined(a.deferralParent),I.assertIsDefined(a.deferralConstituents),a.writeType=a.deferralParent.flags&1048576?pi(a.deferralWriteConstituents):Pa(a.deferralWriteConstituents)),a.writeType}function XE(r){let a=Vc(r);return r.flags&4?a&2?a&65536?pz(r)||$se(r):r.links.writeType||r.links.type:WS(vn(r),!!(r.flags&16777216)):r.flags&98304?a&1?txe(r):_z(r):vn(r)}function vn(r,a){let _=Vc(r);return _&65536?$se(r):_&1?exe(r):_&262144?lRt(r):_&8192?ELt(r):r.flags&7?xg(r,a):r.flags&9136?a4(r):r.flags&8?qse(r):r.flags&98304?cb(r):r.flags&2097152?zse(r):ht}function OS(r){return WS(vn(r),!!(r.flags&16777216))}function RS(r,a){return r!==void 0&&a!==void 0&&(Gn(r)&4)!==0&&r.target===a}function rv(r){return Gn(r)&4?r.target:r}function hI(r,a){return _(r);function _(d){if(Gn(d)&7){let y=rv(d);return y===a||Tt(Cp(y),_)}else if(d.flags&2097152)return Tt(d.types,_);return!1}}function lb(r,a){for(let _ of a)r=ai(r,lC(Rn(_)));return r}function Lr(r,a){for(;;){if(r=r.parent,r&&bn(r)){let _=al(r);if(_===6||_===3){let d=Rn(r.left);d&&d.parent&&!Gr(d.parent.valueDeclaration,y=>r===y)&&(r=d.parent.valueDeclaration)}}if(!r)return;switch(r.kind){case 263:case 231:case 264:case 179:case 180:case 173:case 184:case 185:case 324:case 262:case 174:case 218:case 219:case 265:case 352:case 353:case 347:case 345:case 200:case 194:{let d=Lr(r,a);if(r.kind===200)return Pr(d,lC(Rn(r.typeParameter)));if(r.kind===194)return ys(d,h$e(r));let y=lb(d,Ov(r)),T=a&&(r.kind===263||r.kind===231||r.kind===264||Sh(r))&&qd(Rn(r)).thisType;return T?Pr(y,T):y}case 348:let _=V8(r);_&&(r=_.valueDeclaration);break;case 327:{let d=Lr(r,a);return r.tags?lb(d,_a(r.tags,y=>dm(y)?y.typeParameters:void 0)):d}}}}function Kn(r){var a;let _=r.flags&32||r.flags&16?r.valueDeclaration:(a=r.declarations)==null?void 0:a.find(d=>{if(d.kind===264)return!0;if(d.kind!==260)return!1;let y=d.initializer;return!!y&&(y.kind===218||y.kind===219)});return I.assert(!!_,"Class was missing valueDeclaration -OR- non-class had no interface declarations"),Lr(_)}function qn(r){if(!r.declarations)return;let a;for(let _ of r.declarations)(_.kind===264||_.kind===263||_.kind===231||Sh(_)||j8(_))&&(a=lb(a,Ov(_)));return a}function Yi(r){return ys(Kn(r),qn(r))}function Ji(r){let a=na(r,1);if(a.length===1){let _=a[0];if(!_.typeParameters&&_.parameters.length===1&&L_(_)){let d=f$(_.parameters[0]);return wt(d)||Vz(d)===W}}return!1}function go(r){if(na(r,1).length>0)return!0;if(r.flags&8650752){let a=k_(r);return!!a&&Ji(a)}return!1}function Vo(r){let a=ky(r.symbol);return a&&$g(a)}function V_(r,a,_){let d=de(a),y=gn(_);return Fn(na(r,1),T=>(y||d>=a0(T.typeParameters))&&d<=de(T.typeParameters))}function i0(r,a,_){let d=V_(r,a,_),y=vr(a,Ri);return ul(d,T=>Tt(T.typeParameters)?hL(T,y,gn(_)):T)}function xp(r){if(!r.resolvedBaseConstructorType){let a=ky(r.symbol),_=a&&$g(a),d=Vo(r);if(!d)return r.resolvedBaseConstructorType=Be;if(!n0(r,1))return ht;let y=Cs(d.expression);if(_&&d!==_&&(I.assert(!_.typeArguments),Cs(_.expression)),y.flags&2621440&&kg(y),!dh())return He(r.symbol.valueDeclaration,g._0_is_referenced_directly_or_indirectly_in_its_own_base_expression,Oi(r.symbol)),r.resolvedBaseConstructorType=ht;if(!(y.flags&1)&&y!==qe&&!go(y)){let T=He(d.expression,g.Type_0_is_not_a_constructor_function_type,Kr(y));if(y.flags&262144){let P=l4(y),L=Sr;if(P){let J=na(P,1);J[0]&&(L=Ao(J[0]))}y.symbol.declarations&&Ga(T,$n(y.symbol.declarations[0],g.Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1,Oi(y.symbol),Kr(L)))}return r.resolvedBaseConstructorType=ht}r.resolvedBaseConstructorType=y}return r.resolvedBaseConstructorType}function Cg(r){let a=tt;if(r.symbol.declarations)for(let _ of r.symbol.declarations){let d=SN(_);if(d)for(let y of d){let T=Ri(y);Xt(T)||(a===tt?a=[T]:a.push(T))}}return a}function Qy(r,a){He(r,g.Type_0_recursively_references_itself_as_a_base_type,Kr(a,void 0,2))}function Cp(r){if(!r.baseTypesResolved){if(n0(r,7)&&(r.objectFlags&8?r.resolvedBaseTypes=[yI(r)]:r.symbol.flags&96?(r.symbol.flags&32&&fL(r),r.symbol.flags&64&&j8t(r)):I.fail("type must be class or interface"),!dh()&&r.symbol.declarations))for(let a of r.symbol.declarations)(a.kind===263||a.kind===264)&&Qy(a,r);r.baseTypesResolved=!0}return r.resolvedBaseTypes}function yI(r){let a=ul(r.typeParameters,(_,d)=>r.elementFlags[d]&8?Ap(_,It):_);return P_(pi(a||tt),r.readonly)}function fL(r){r.resolvedBaseTypes=_B;let a=Tf(xp(r));if(!(a.flags&2621441))return r.resolvedBaseTypes=tt;let _=Vo(r),d,y=a.symbol?dc(a.symbol):void 0;if(a.symbol&&a.symbol.flags&32&&F8t(y))d=Aze(_,a.symbol);else if(a.flags&1)d=a;else{let P=i0(a,_.typeArguments,_);if(!P.length)return He(_.expression,g.No_base_constructor_has_the_specified_number_of_type_arguments),r.resolvedBaseTypes=tt;d=Ao(P[0])}if(Xt(d))return r.resolvedBaseTypes=tt;let T=Pg(d);if(!dz(T)){let P=mxe(void 0,d),L=Xs(P,g.Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members,Kr(T));return fo.add(Ey(Xr(_.expression),_.expression,L)),r.resolvedBaseTypes=tt}return r===T||hI(T,r)?(He(r.symbol.valueDeclaration,g.Type_0_recursively_references_itself_as_a_base_type,Kr(r,void 0,2)),r.resolvedBaseTypes=tt):(r.resolvedBaseTypes===_B&&(r.members=void 0),r.resolvedBaseTypes=[T])}function F8t(r){let a=r.outerTypeParameters;if(a){let _=a.length-1,d=cc(r);return a[_].symbol!==d[_].symbol}return!0}function dz(r){if(r.flags&262144){let a=k_(r);if(a)return dz(a)}return!!(r.flags&67633153&&!Ff(r)||r.flags&2097152&&yr(r.types,dz))}function j8t(r){if(r.resolvedBaseTypes=r.resolvedBaseTypes||tt,r.symbol.declarations){for(let a of r.symbol.declarations)if(a.kind===264&&Xw(a))for(let _ of Xw(a)){let d=Pg(Ri(_));Xt(d)||(dz(d)?r!==d&&!hI(d,r)?r.resolvedBaseTypes===tt?r.resolvedBaseTypes=[d]:r.resolvedBaseTypes.push(d):Qy(a,r):He(_,g.An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members))}}}function B8t(r){if(!r.declarations)return!0;for(let a of r.declarations)if(a.kind===264){if(a.flags&256)return!1;let _=Xw(a);if(_){for(let d of _)if(ol(d.expression)){let y=ac(d.expression,788968,!0);if(!y||!(y.flags&64)||qd(y).thisType)return!1}}}return!0}function qd(r){let a=as(r),_=a;if(!a.declaredType){let d=r.flags&32?1:2,y=NAe(r,r.valueDeclaration&&k9t(r.valueDeclaration));y&&(r=y,a=y.links);let T=_.declaredType=a.declaredType=Ud(d,r),P=Kn(r),L=qn(r);(P||L||d===1||!B8t(r))&&(T.objectFlags|=4,T.typeParameters=ys(P,L),T.outerTypeParameters=P,T.localTypeParameters=L,T.instantiations=new Map,T.instantiations.set(Tm(T.typeParameters),T),T.target=T,T.resolvedTypeArguments=T.typeParameters,T.thisType=Sd(r),T.thisType.isThisType=!0,T.thisType.constraint=T)}return a.declaredType}function Vqe(r){var a;let _=as(r);if(!_.declaredType){if(!n0(r,2))return ht;let d=I.checkDefined((a=r.declarations)==null?void 0:a.find(j8),"Type alias symbol with no valid declaration found"),y=am(d)?d.typeExpression:d.type,T=y?Ri(y):ht;if(dh()){let P=qn(r);P&&(_.typeParameters=P,_.instantiations=new Map,_.instantiations.set(Tm(P),T))}else T=ht,d.kind===347?He(d.typeExpression.type,g.Type_alias_0_circularly_references_itself,Oi(r)):He(W_(d)&&d.name||d,g.Type_alias_0_circularly_references_itself,Oi(r));_.declaredType=T}return _.declaredType}function Wse(r){return r.flags&1056&&r.symbol.flags&8?dc(yf(r.symbol)):r}function Jqe(r){let a=as(r);if(!a.declaredType){let _=[];if(r.declarations){for(let y of r.declarations)if(y.kind===266){for(let T of y.members)if(vI(T)){let P=Rn(T),L=BI(T),J=cP(L!==void 0?i7t(L,Ia(r),P):qqe(P));as(P).declaredType=J,_.push(af(J))}}}let d=_.length?pi(_,1,r,void 0):qqe(r);d.flags&1048576&&(d.flags|=1024,d.symbol=r),a.declaredType=d}return a.declaredType}function qqe(r){let a=H0(32,r),_=H0(32,r);return a.regularType=a,a.freshType=_,_.regularType=a,_.freshType=_,a}function zqe(r){let a=as(r);if(!a.declaredType){let _=Jqe(yf(r));a.declaredType||(a.declaredType=_)}return a.declaredType}function lC(r){let a=as(r);return a.declaredType||(a.declaredType=Sd(r))}function U8t(r){let a=as(r);return a.declaredType||(a.declaredType=dc(du(r)))}function dc(r){return $qe(r)||ht}function $qe(r){if(r.flags&96)return qd(r);if(r.flags&524288)return Vqe(r);if(r.flags&262144)return lC(r);if(r.flags&384)return Jqe(r);if(r.flags&8)return zqe(r);if(r.flags&2097152)return U8t(r)}function mz(r){switch(r.kind){case 133:case 159:case 154:case 150:case 163:case 136:case 155:case 151:case 116:case 157:case 146:case 201:return!0;case 188:return mz(r.elementType);case 183:return!r.typeArguments||r.typeArguments.every(mz)}return!1}function V8t(r){let a=YP(r);return!a||mz(a)}function Wqe(r){let a=t_(r);return a?mz(a):!jv(r)}function J8t(r){let a=lm(r),_=Ov(r);return(r.kind===176||!!a&&mz(a))&&r.parameters.every(Wqe)&&_.every(V8t)}function q8t(r){if(r.declarations&&r.declarations.length===1){let a=r.declarations[0];if(a)switch(a.kind){case 172:case 171:return Wqe(a);case 174:case 173:case 176:case 177:case 178:return J8t(a)}}return!1}function Gqe(r,a,_){let d=ga();for(let y of r)d.set(y.escapedName,_&&q8t(y)?y:iCe(y,a));return d}function Hqe(r,a){for(let _ of a){if(Yqe(_))continue;let d=r.get(_.escapedName);(!d||d.valueDeclaration&&bn(d.valueDeclaration)&&!dI(d)&&!vde(d.valueDeclaration))&&(r.set(_.escapedName,_),r.set(_.escapedName,_))}}function Yqe(r){return!!r.valueDeclaration&&G_(r.valueDeclaration)&&pa(r.valueDeclaration)}function rxe(r){if(!r.declaredProperties){let a=r.symbol,_=MS(a);r.declaredProperties=rb(_),r.declaredCallSignatures=tt,r.declaredConstructSignatures=tt,r.declaredIndexInfos=tt,r.declaredCallSignatures=KE(_.get("__call")),r.declaredConstructSignatures=KE(_.get("__new")),r.declaredIndexInfos=bze(a)}return r}function nxe(r){if(!uo(r)&&!fc(r))return!1;let a=uo(r)?r.expression:r.argumentExpression;return ol(a)&&um(uo(r)?Q0(r):xl(a))}function pL(r){return r.charCodeAt(0)===95&&r.charCodeAt(1)===95&&r.charCodeAt(2)===64}function gz(r){let a=qs(r);return!!a&&nxe(a)}function vI(r){return!Jv(r)||gz(r)}function z8t(r){return bj(r)&&!nxe(r)}function $8t(r,a,_){I.assert(!!(Vc(r)&4096),"Expected a late-bound symbol."),r.flags|=_,as(a.symbol).lateSymbol=r,r.declarations?a.symbol.isReplaceableByMethod||r.declarations.push(a):r.declarations=[a],_&111551&&(!r.valueDeclaration||r.valueDeclaration.kind!==a.kind)&&(r.valueDeclaration=a)}function Xqe(r,a,_,d){I.assert(!!d.symbol,"The member is expected to have a symbol.");let y=_i(d);if(!y.resolvedSymbol){y.resolvedSymbol=d.symbol;let T=bn(d)?d.left:d.name,P=fc(T)?xl(T.argumentExpression):Q0(T);if(um(P)){let L=_m(P),J=d.symbol.flags,G=_.get(L);G||_.set(L,G=oo(0,L,4096));let ae=a&&a.get(L);if(!(r.flags&32)&&(G.flags&Jx(J)||ae)){let Ce=ae?ys(ae.declarations,G.declarations):G.declarations,be=!(P.flags&8192)&&Zi(L)||qo(T);Te(Ce,Ye=>He(qs(Ye)||Ye,g.Property_0_was_also_declared_here,be)),He(T||d,g.Duplicate_property_0,be),G=oo(0,L,4096)}return G.links.nameType=P,$8t(G,d,J),G.parent?I.assert(G.parent===r,"Existing symbol parent should match new one"):G.parent=r,y.resolvedSymbol=G}}return y.resolvedSymbol}function ixe(r,a){let _=as(r);if(!_[a]){let d=a==="resolvedExports",y=d?r.flags&1536?nC(r).exports:r.exports:r.members;_[a]=y||K;let T=ga();for(let J of r.declarations||tt){let G=_de(J);if(G)for(let ae of G)d===jl(ae)&&gz(ae)&&Xqe(r,y,T,ae)}let P=zE(r).assignmentDeclarationMembers;if(P){let J=In(P.values());for(let G of J){let ae=al(G),Ce=ae===3||bn(G)&&Hae(G,ae)||ae===9||ae===6;d===!Ce&&gz(G)&&Xqe(r,y,T,G)}}let L=$k(y,T);if(r.flags&33554432&&_.cjsExportMerged&&r.declarations)for(let J of r.declarations){let G=as(J.symbol)[a];if(!L){L=G;continue}G&&G.forEach((ae,Ce)=>{let be=L.get(Ce);if(!be)L.set(Ce,ae);else{if(be===ae)return;L.set(Ce,hm(be,ae))}})}_[a]=L||K}return _[a]}function MS(r){return r.flags&6256?ixe(r,"resolvedMembers"):r.members||K}function Gse(r){if(r.flags&106500&&r.escapedName==="__computed"){let a=as(r);if(!a.lateSymbol&&Tt(r.declarations,gz)){let _=mo(r.parent);Tt(r.declarations,jl)?Ep(_):MS(_)}return a.lateSymbol||(a.lateSymbol=r)}return r}function Hp(r,a,_){if(Gn(r)&4){let d=r.target,y=cc(r);return de(d.typeParameters)===de(y)?iv(d,ys(y,[a||d.thisType])):r}else if(r.flags&2097152){let d=ul(r.types,y=>Hp(y,a,_));return d!==r.types?Pa(d):r}return _?Tf(r):r}function Kqe(r,a,_,d){let y,T,P,L,J;Bc(_,d,0,_.length)?(T=a.symbol?MS(a.symbol):ga(a.declaredProperties),P=a.declaredCallSignatures,L=a.declaredConstructSignatures,J=a.declaredIndexInfos):(y=kp(_,d),T=Gqe(a.declaredProperties,y,_.length===1),P=dae(a.declaredCallSignatures,y),L=dae(a.declaredConstructSignatures,y),J=E$e(a.declaredIndexInfos,y));let G=Cp(a);if(G.length){if(a.symbol&&T===MS(a.symbol)){let Ce=ga(a.declaredProperties),be=Exe(a.symbol);be&&Ce.set("__index",be),T=Ce}Td(r,T,P,L,J);let ae=Is(d);for(let Ce of G){let be=ae?Hp(gs(Ce,y),ae):Ce;Hqe(T,Io(be)),P=ys(P,na(be,0)),L=ys(L,na(be,1));let Ye=be!==W?nf(be):[o0(Le,W,!1)];J=ys(J,Fn(Ye,vt=>!gxe(J,vt.keyType)))}}Td(r,T,P,L,J)}function W8t(r){Kqe(r,rxe(r),tt,tt)}function G8t(r){let a=rxe(r.target),_=ys(a.typeParameters,[a.thisType]),d=cc(r),y=d.length===_.length?d:ys(d,[r]);Kqe(r,a,_,y)}function X0(r,a,_,d,y,T,P,L){let J=new S(nr,L);return J.declaration=r,J.typeParameters=a,J.parameters=d,J.thisParameter=_,J.resolvedReturnType=y,J.resolvedTypePredicate=T,J.minArgumentCount=P,J.resolvedMinArgumentCount=void 0,J.target=void 0,J.mapper=void 0,J.compositeSignatures=void 0,J.compositeKind=void 0,J}function dL(r){let a=X0(r.declaration,r.typeParameters,r.thisParameter,r.parameters,void 0,void 0,r.minArgumentCount,r.flags&167);return a.target=r.target,a.mapper=r.mapper,a.compositeSignatures=r.compositeSignatures,a.compositeKind=r.compositeKind,a}function Qqe(r,a){let _=dL(r);return _.compositeSignatures=a,_.compositeKind=1048576,_.target=void 0,_.mapper=void 0,_}function H8t(r,a){if((r.flags&24)===a)return r;r.optionalCallSignatureCache||(r.optionalCallSignatureCache={});let _=a===8?"inner":"outer";return r.optionalCallSignatureCache[_]||(r.optionalCallSignatureCache[_]=Y8t(r,a))}function Y8t(r,a){I.assert(a===8||a===16,"An optional call signature can either be for an inner call chain or an outer call chain, but not both.");let _=dL(r);return _.flags|=a,_}function Zqe(r,a){if(L_(r)){let y=r.parameters.length-1,T=r.parameters[y].escapedName,P=vn(r.parameters[y]);if(Ka(P))return[_(P,y,T)];if(!a&&P.flags&1048576&&yr(P.types,Ka))return vr(P.types,L=>_(L,y,T))}return[r.parameters];function _(y,T,P){let L=cc(y),J=d(y,P),G=vr(L,(ae,Ce)=>{let be=J&&J[Ce]?J[Ce]:x4(r,T+Ce,y),Ye=y.target.elementFlags[Ce],vt=Ye&12?32768:Ye&2?16384:0,Dt=oo(1,be,vt);return Dt.links.type=Ye&4?P_(ae):ae,Dt});return ys(r.parameters.slice(0,T),G)}function d(y,T){let P=new Map;return vr(y.target.labeledElementDeclarations,(L,J)=>{let G=RAe(L,J,T),ae=P.get(G);return ae===void 0?(P.set(G,1),G):(P.set(G,ae+1),`${G}_${ae}`)})}}function X8t(r){let a=xp(r),_=na(a,1),d=ky(r.symbol),y=!!d&&ui(d,64);if(_.length===0)return[X0(void 0,r.localTypeParameters,void 0,tt,r,void 0,0,y?4:0)];let T=Vo(r),P=gn(T),L=xz(T),J=de(L),G=[];for(let ae of _){let Ce=a0(ae.typeParameters),be=de(ae.typeParameters);if(P||J>=Ce&&J<=be){let Ye=be?Qse(ae,FS(L,ae.typeParameters,Ce,P)):dL(ae);Ye.typeParameters=r.localTypeParameters,Ye.resolvedReturnType=r,Ye.flags=y?Ye.flags|4:Ye.flags&-5,G.push(Ye)}}return G}function Hse(r,a,_,d,y){for(let T of r)if(Bz(T,a,_,d,y,_?E7t:AL))return T}function K8t(r,a,_){if(a.typeParameters){if(_>0)return;for(let y=1;y<r.length;y++)if(!Hse(r[y],a,!1,!1,!1))return;return[a]}let d;for(let y=0;y<r.length;y++){let T=y===_?a:Hse(r[y],a,!1,!1,!0)||Hse(r[y],a,!0,!1,!0);if(!T)return;d=ai(d,T)}return d}function sxe(r){let a,_;for(let d=0;d<r.length;d++){if(r[d].length===0)return tt;r[d].length>1&&(_=_===void 0?d:-1);for(let y of r[d])if(!a||!Hse(a,y,!1,!1,!0)){let T=K8t(r,y,d);if(T){let P=y;if(T.length>1){let L=y.thisParameter,J=Te(T,G=>G.thisParameter);if(J){let G=Pa(Wi(T,ae=>ae.thisParameter&&vn(ae.thisParameter)));L=TC(J,G)}P=Qqe(y,T),P.thisParameter=L}(a||(a=[])).push(P)}}}if(!de(a)&&_!==-1){let d=r[_!==void 0?_:0],y=d.slice();for(let T of r)if(T!==d){let P=T[0];if(I.assert(!!P,"getUnionSignatures bails early on empty signature lists and should not have empty lists on second pass"),y=P.typeParameters&&Tt(y,L=>!!L.typeParameters&&!eze(P.typeParameters,L.typeParameters))?void 0:vr(y,L=>eRt(L,P)),!y)break}a=y}return a||tt}function eze(r,a){if(de(r)!==de(a))return!1;if(!r||!a)return!0;let _=kp(a,r);for(let d=0;d<r.length;d++){let y=r[d],T=a[d];if(y!==T&&!n1(l4(y)||Sr,gs(l4(T)||Sr,_)))return!1}return!0}function Q8t(r,a,_){if(!r||!a)return r||a;let d=Pa([vn(r),gs(vn(a),_)]);return TC(r,d)}function Z8t(r,a,_){let d=Xp(r),y=Xp(a),T=d>=y?r:a,P=T===r?a:r,L=T===r?d:y,J=u0(r)||u0(a),G=J&&!u0(T),ae=new Array(L+(G?1:0));for(let Ce=0;Ce<L;Ce++){let be=c2(T,Ce);T===a&&(be=gs(be,_));let Ye=c2(P,Ce)||Sr;P===a&&(Ye=gs(Ye,_));let vt=Pa([be,Ye]),Dt=J&&!G&&Ce===L-1,ur=Ce>=Th(T)&&Ce>=Th(P),pr=Ce>=d?void 0:x4(r,Ce),dn=Ce>=y?void 0:x4(a,Ce),Ur=pr===dn?pr:pr?dn?void 0:pr:dn,fr=oo(1|(ur&&!Dt?16777216:0),Ur||`arg${Ce}`,Dt?32768:ur?16384:0);fr.links.type=Dt?P_(vt):vt,ae[Ce]=fr}if(G){let Ce=oo(1,"args",32768);Ce.links.type=P_(Ig(P,L)),P===a&&(Ce.links.type=gs(Ce.links.type,_)),ae[L]=Ce}return ae}function eRt(r,a){let _=r.typeParameters||a.typeParameters,d;r.typeParameters&&a.typeParameters&&(d=kp(a.typeParameters,r.typeParameters));let y=r.declaration,T=Z8t(r,a,d),P=Q8t(r.thisParameter,a.thisParameter,d),L=Math.max(r.minArgumentCount,a.minArgumentCount),J=X0(y,_,P,T,void 0,void 0,L,(r.flags|a.flags)&167);return J.compositeKind=1048576,J.compositeSignatures=ys(r.compositeKind!==2097152&&r.compositeSignatures||[r],[a]),d?J.mapper=r.compositeKind!==2097152&&r.mapper&&r.compositeSignatures?n2(r.mapper,d):d:r.compositeKind!==2097152&&r.mapper&&r.compositeSignatures&&(J.mapper=r.mapper),J}function tze(r){let a=nf(r[0]);if(a){let _=[];for(let d of a){let y=d.keyType;yr(r,T=>!!K0(T,y))&&_.push(o0(y,pi(vr(r,T=>_b(T,y))),Tt(r,T=>K0(T,y).isReadonly)))}return _}return tt}function tRt(r){let a=sxe(vr(r.types,y=>y===Bt?[gr]:na(y,0))),_=sxe(vr(r.types,y=>na(y,1))),d=tze(r.types);Td(r,K,a,_,d)}function hz(r,a){return r?a?Pa([r,a]):r:a}function rze(r){let a=mu(r,d=>na(d,1).length>0),_=vr(r,Ji);if(a>0&&a===mu(_,d=>d)){let d=_.indexOf(!0);_[d]=!1}return _}function rRt(r,a,_,d){let y=[];for(let T=0;T<a.length;T++)T===d?y.push(r):_[T]&&y.push(Ao(na(a[T],1)[0]));return Pa(y)}function nRt(r){let a,_,d,y=r.types,T=rze(y),P=mu(T,L=>L);for(let L=0;L<y.length;L++){let J=r.types[L];if(!T[L]){let G=na(J,1);G.length&&P>0&&(G=vr(G,ae=>{let Ce=dL(ae);return Ce.resolvedReturnType=rRt(Ao(ae),y,T,L),Ce})),_=nze(_,G)}a=nze(a,na(J,0)),d=d_(nf(J),(G,ae)=>ize(G,ae,!1),d)}Td(r,K,a||tt,_||tt,d||tt)}function nze(r,a){for(let _ of a)(!r||yr(r,d=>!Bz(d,_,!1,!1,!1,AL)))&&(r=Pr(r,_));return r}function ize(r,a,_){if(r)for(let d=0;d<r.length;d++){let y=r[d];if(y.keyType===a.keyType)return r[d]=o0(y.keyType,_?pi([y.type,a.type]):Pa([y.type,a.type]),_?y.isReadonly||a.isReadonly:y.isReadonly&&a.isReadonly),r}return Pr(r,a)}function iRt(r){if(r.target){Td(r,K,tt,tt,tt);let P=Gqe(LS(r.target),r.mapper,!1),L=dae(na(r.target,0),r.mapper),J=dae(na(r.target,1),r.mapper),G=E$e(nf(r.target),r.mapper);Td(r,P,L,J,G);return}let a=mo(r.symbol);if(a.flags&2048){Td(r,K,tt,tt,tt);let P=MS(a),L=KE(P.get("__call")),J=KE(P.get("__new")),G=bze(a);Td(r,P,L,J,G);return}let _=Ep(a),d;if(a===at){let P=new Map;_.forEach(L=>{var J;!(L.flags&418)&&!(L.flags&512&&((J=L.declarations)!=null&&J.length)&&yr(L.declarations,S_))&&P.set(L.escapedName,L)}),_=P}let y;if(Td(r,_,tt,tt,tt),a.flags&32){let P=qd(a),L=xp(P);L.flags&11272192?(_=ga(sC(_)),Hqe(_,Io(L))):L===W&&(y=o0(Le,W,!1))}let T=Zse(_);if(T?d=xxe(T):(y&&(d=Pr(d,y)),a.flags&384&&(dc(a).flags&32||Tt(r.properties,P=>!!(vn(P).flags&296)))&&(d=Pr(d,Zn))),Td(r,_,tt,tt,d||tt),a.flags&8208&&(r.callSignatures=KE(a)),a.flags&32){let P=qd(a),L=a.members?KE(a.members.get("__constructor")):tt;a.flags&16&&(L=jt(L.slice(),Wi(r.callSignatures,J=>Sh(J.declaration)?X0(J.declaration,J.typeParameters,J.thisParameter,J.parameters,P,void 0,J.minArgumentCount,J.flags&167):void 0))),L.length||(L=X8t(P)),r.constructSignatures=L}}function sRt(r,a,_){return gs(r,kp([a.indexType,a.objectType],[Ng(0),c0([_])]))}function aRt(r){let a=bd(r.mappedType);if(!(a.flags&1048576||a.flags&2097152))return;let _=a.flags&1048576?a.origin:a;if(!_||!(_.flags&2097152))return;let d=Pa(_.types.filter(y=>y!==r.constraintType));return d!==Qn?d:void 0}function oRt(r){let a=K0(r.source,Le),_=s0(r.mappedType),d=!(_&1),y=_&4?0:16777216,T=a?[o0(Le,Mae(a.type,r.mappedType,r.constraintType),d&&a.isReadonly)]:tt,P=ga(),L=aRt(r);for(let J of Io(r.source)){if(L){let Ce=CI(J,8576);if(!Na(Ce,L))continue}let G=8192|(d&&wg(J)?8:0),ae=oo(4|J.flags&y,J.escapedName,G);if(ae.declarations=J.declarations,ae.links.nameType=as(J).nameType,ae.links.propertyType=vn(J),r.constraintType.type.flags&8388608&&r.constraintType.type.objectType.flags&262144&&r.constraintType.type.indexType.flags&262144){let Ce=r.constraintType.type.objectType,be=sRt(r.mappedType,r.constraintType.type,Ce);ae.links.mappedType=be,ae.links.constraintType=gh(Ce)}else ae.links.mappedType=r.mappedType,ae.links.constraintType=r.constraintType;P.set(J.escapedName,ae)}Td(r,P,tt,tt,T)}function yz(r){if(r.flags&4194304){let a=Tf(r.type);return zS(a)?Hze(a):gh(a)}if(r.flags&16777216){if(r.root.isDistributive){let a=r.checkType,_=yz(a);if(_!==a)return aCe(r,vC(r.root.checkType,_,r.mapper),!1)}return r}if(r.flags&1048576)return Ec(r,yz,!0);if(r.flags&2097152){let a=r.types;return a.length===2&&a[0].flags&76&&a[1]===Nl?r:Pa(ul(r.types,yz))}return r}function axe(r){return Vc(r)&4096}function oxe(r,a,_,d){for(let y of Io(r))d(CI(y,a));if(r.flags&1)d(Le);else for(let y of nf(r))(!_||y.keyType.flags&134217732)&&d(y.keyType)}function cRt(r){let a=ga(),_;Td(r,K,tt,tt,tt);let d=Ag(r),y=bd(r),T=r.target||r,P=nv(T),L=Yse(T)!==2,J=Zy(T),G=Tf(uC(r)),ae=s0(r),Ce=Me?128:8576;SI(r)?oxe(G,Ce,Me,be):CC(yz(y),be),Td(r,a,tt,tt,_||tt);function be(vt){let Dt=P?gs(P,EL(r.mapper,d,vt)):vt;CC(Dt,ur=>Ye(vt,ur))}function Ye(vt,Dt){if(um(Dt)){let ur=_m(Dt),pr=a.get(ur);if(pr)pr.links.nameType=pi([pr.links.nameType,Dt]),pr.links.keyType=pi([pr.links.keyType,vt]);else{let dn=um(vt)?ka(G,_m(vt)):void 0,Ur=!!(ae&4||!(ae&8)&&dn&&dn.flags&16777216),fr=!!(ae&1||!(ae&2)&&dn&&wg(dn)),$r=Q&&!Ur&&dn&&dn.flags&16777216,Jr=dn?axe(dn):0,on=oo(4|(Ur?16777216:0),ur,Jr|262144|(fr?8:0)|($r?524288:0));on.links.mappedType=r,on.links.nameType=Dt,on.links.keyType=vt,dn&&(on.links.syntheticOrigin=dn,on.declarations=L?dn.declarations:void 0),a.set(ur,on)}}else if(eae(Dt)||Dt.flags&33){let ur=Dt.flags&5?Le:Dt.flags&40?It:Dt,pr=gs(J,EL(r.mapper,d,vt)),dn=mL(G,Dt),Ur=!!(ae&1||!(ae&2)&&dn?.isReadonly),fr=o0(ur,pr,Ur);_=ize(_,fr,!0)}}}function lRt(r){if(!r.links.type){let a=r.links.mappedType;if(!n0(r,0))return a.containsError=!0,ht;let _=Zy(a.target||a),d=EL(a.mapper,Ag(a),r.links.keyType),y=gs(_,d),T=Q&&r.flags&16777216&&!$c(y,49152)?$S(y,!0):r.links.checkFlags&524288?Dae(y):y;dh()||(He(O,g.Type_of_property_0_circularly_references_itself_in_mapped_type_1,Oi(r),Kr(a)),T=ht),r.links.type=T}return r.links.type}function Ag(r){return r.typeParameter||(r.typeParameter=lC(Rn(r.declaration.typeParameter)))}function bd(r){return r.constraintType||(r.constraintType=Sf(Ag(r))||ht)}function nv(r){return r.declaration.nameType?r.nameType||(r.nameType=gs(Ri(r.declaration.nameType),r.mapper)):void 0}function Zy(r){return r.templateType||(r.templateType=r.declaration.type?gs(ep(Ri(r.declaration.type),!0,!!(s0(r)&4)),r.mapper):ht)}function sze(r){return YP(r.declaration.typeParameter)}function SI(r){let a=sze(r);return a.kind===198&&a.operator===143}function uC(r){if(!r.modifiersType)if(SI(r))r.modifiersType=gs(Ri(sze(r).type),r.mapper);else{let a=Xxe(r.declaration),_=bd(a),d=_&&_.flags&262144?Sf(_):_;r.modifiersType=d&&d.flags&4194304?gs(d.type,r.mapper):Sr}return r.modifiersType}function s0(r){let a=r.declaration;return(a.readonlyToken?a.readonlyToken.kind===41?2:1:0)|(a.questionToken?a.questionToken.kind===41?8:4:0)}function aze(r){let a=s0(r);return a&8?-1:a&4?1:0}function cxe(r){let a=aze(r),_=uC(r);return a||(Ff(_)?aze(_):0)}function uRt(r){return!!(Gn(r)&32&&s0(r)&4)}function Ff(r){if(Gn(r)&32){let a=bd(r);if(yC(a))return!0;let _=nv(r);if(_&&yC(gs(_,r2(Ag(r),a))))return!0}return!1}function Yse(r){let a=nv(r);return a?Na(a,Ag(r))?1:2:0}function kg(r){return r.members||(r.flags&524288?r.objectFlags&4?G8t(r):r.objectFlags&3?W8t(r):r.objectFlags&1024?oRt(r):r.objectFlags&16?iRt(r):r.objectFlags&32?cRt(r):I.fail("Unhandled object type "+I.formatObjectFlags(r.objectFlags)):r.flags&1048576?tRt(r):r.flags&2097152?nRt(r):I.fail("Unhandled type "+I.formatTypeFlags(r.flags))),r}function LS(r){return r.flags&524288?kg(r).properties:tt}function ub(r,a){if(r.flags&524288){let d=kg(r).members.get(a);if(d&&Zm(d))return d}}function vz(r){if(!r.resolvedProperties){let a=ga();for(let _ of r.types){for(let d of Io(_))if(!a.has(d.escapedName)){let y=Tz(r,d.escapedName,!!(r.flags&2097152));y&&a.set(d.escapedName,y)}if(r.flags&1048576&&nf(_).length===0)break}r.resolvedProperties=rb(a)}return r.resolvedProperties}function Io(r){return r=o4(r),r.flags&3145728?vz(r):LS(r)}function _Rt(r,a){r=o4(r),r.flags&3670016&&kg(r).members.forEach((_,d)=>{Zk(_,d)&&a(_,d)})}function fRt(r,a){return a.properties.some(d=>{let y=d.name&&(pg(d.name)?jf(dR(d.name)):av(d.name)),T=y&&um(y)?_m(y):void 0,P=T===void 0?void 0:Xe(r,T);return!!P&&NL(P)&&!Na(fP(d),P)})}function pRt(r){let a=pi(r);if(!(a.flags&1048576))return gke(a);let _=ga();for(let d of r)for(let{escapedName:y}of gke(d))if(!_.has(y)){let T=pze(a,y);T&&_.set(y,T)}return In(_.values())}function _C(r){return r.flags&262144?Sf(r):r.flags&8388608?mRt(r):r.flags&16777216?lze(r):k_(r)}function Sf(r){return Sz(r)?l4(r):void 0}function dRt(r,a){let _=xL(r);return!!_&&fC(_,a)}function fC(r,a=0){var _;return a<5&&!!(r&&(r.flags&262144&&Tt((_=r.symbol)==null?void 0:_.declarations,d=>ui(d,4096))||r.flags&3145728&&Tt(r.types,d=>fC(d,a))||r.flags&8388608&&fC(r.objectType,a+1)||r.flags&16777216&&fC(lze(r),a+1)||r.flags&33554432&&fC(r.baseType,a)||Gn(r)&32&&dRt(r,a)||zS(r)&&oa(ZE(r),(d,y)=>!!(r.target.elementFlags[y]&8)&&fC(d,a))>=0))}function mRt(r){return Sz(r)?gRt(r):void 0}function lxe(r){let a=r1(r,!1);return a!==r?a:_C(r)}function gRt(r){if(pxe(r))return cae(r.objectType,r.indexType);let a=lxe(r.indexType);if(a&&a!==r.indexType){let d=BS(r.objectType,a,r.accessFlags);if(d)return d}let _=lxe(r.objectType);if(_&&_!==r.objectType)return BS(_,r.indexType,r.accessFlags)}function uxe(r){if(!r.resolvedDefaultConstraint){let a=QMt(r),_=db(r);r.resolvedDefaultConstraint=wt(a)?_:wt(_)?a:pi([a,_])}return r.resolvedDefaultConstraint}function oze(r){if(r.resolvedConstraintOfDistributive!==void 0)return r.resolvedConstraintOfDistributive||void 0;if(r.root.isDistributive&&r.restrictiveInstantiation!==r){let a=r1(r.checkType,!1),_=a===r.checkType?_C(a):a;if(_&&_!==r.checkType){let d=aCe(r,vC(r.root.checkType,_,r.mapper),!0);if(!(d.flags&131072))return r.resolvedConstraintOfDistributive=d,d}}r.resolvedConstraintOfDistributive=!1}function cze(r){return oze(r)||uxe(r)}function lze(r){return Sz(r)?cze(r):void 0}function hRt(r,a){let _,d=!1;for(let y of r)if(y.flags&465829888){let T=_C(y);for(;T&&T.flags&21233664;)T=_C(T);T&&(_=Pr(_,T),a&&(_=Pr(_,y)))}else(y.flags&469892092||l0(y))&&(d=!0);if(_&&(a||d)){if(d)for(let y of r)(y.flags&469892092||l0(y))&&(_=Pr(_,y));return Lz(Pa(_),!1)}}function k_(r){if(r.flags&464781312||zS(r)){let a=_xe(r);return a!==ic&&a!==Mu?a:void 0}return r.flags&4194304?Qo:void 0}function e1(r){return k_(r)||r}function Sz(r){return _xe(r)!==Mu}function _xe(r){if(r.resolvedBaseConstraint)return r.resolvedBaseConstraint;let a=[];return r.resolvedBaseConstraint=_(r);function _(T){if(!T.immediateBaseConstraint){if(!n0(T,4))return Mu;let P,L=xae(T);if((a.length<10||a.length<50&&!hs(a,L))&&(a.push(L),P=y(r1(T,!1)),a.pop()),!dh()){if(T.flags&262144){let J=Cxe(T);if(J){let G=He(J,g.Type_parameter_0_has_a_circular_constraint,Kr(T));O&&!Yb(J,O)&&!Yb(O,J)&&Ga(G,$n(O,g.Circularity_originates_in_type_at_this_location))}}P=Mu}T.immediateBaseConstraint=P||ic}return T.immediateBaseConstraint}function d(T){let P=_(T);return P!==ic&&P!==Mu?P:void 0}function y(T){if(T.flags&262144){let P=l4(T);return T.isThisType||!P?P:d(P)}if(T.flags&3145728){let P=T.types,L=[],J=!1;for(let G of P){let ae=d(G);ae?(ae!==G&&(J=!0),L.push(ae)):J=!0}return J?T.flags&1048576&&L.length===P.length?pi(L):T.flags&2097152&&L.length?Pa(L):void 0:T}if(T.flags&4194304)return Qo;if(T.flags&134217728){let P=T.types,L=Wi(P,d);return L.length===P.length?mC(T.texts,L):Le}if(T.flags&268435456){let P=d(T.type);return P&&P!==T.type?aP(T.symbol,P):Le}if(T.flags&8388608){if(pxe(T))return d(cae(T.objectType,T.indexType));let P=d(T.objectType),L=d(T.indexType),J=P&&L&&BS(P,L,T.accessFlags);return J&&d(J)}if(T.flags&16777216){let P=cze(T);return P&&d(P)}if(T.flags&33554432)return d(Dxe(T));if(zS(T)){let P=vr(ZE(T),(L,J)=>{let G=L.flags&262144&&T.target.elementFlags[J]&8&&d(L)||L;return G!==L&&tp(G,ae=>gb(ae)&&!zS(ae))?G:L});return c0(P,T.target.elementFlags,T.target.readonly,T.target.labeledElementDeclarations)}return T}}function yRt(r,a){return r.resolvedApparentType||(r.resolvedApparentType=Hp(r,a,!0))}function fxe(r){if(r.default)r.default===Wu&&(r.default=Mu);else if(r.target){let a=fxe(r.target);r.default=a?gs(a,r.mapper):ic}else{r.default=Wu;let a=r.symbol&&Te(r.symbol.declarations,d=>Nc(d)&&d.default),_=a?Ri(a):ic;r.default===Wu&&(r.default=_)}return r.default}function pC(r){let a=fxe(r);return a!==ic&&a!==Mu?a:void 0}function vRt(r){return fxe(r)!==Mu}function uze(r){return!!(r.symbol&&Te(r.symbol.declarations,a=>Nc(a)&&a.default))}function _ze(r){return r.resolvedApparentType||(r.resolvedApparentType=SRt(r))}function SRt(r){let a=r.target??r,_=xL(a);if(_&&!a.declaration.nameType){let d=uC(r),y=Ff(d)?_ze(d):k_(d);if(y&&tp(y,T=>gb(T)||fze(T)))return gs(a,vC(_,y,r.mapper))}return r}function fze(r){return!!(r.flags&2097152)&&yr(r.types,gb)}function pxe(r){let a;return!!(r.flags&8388608&&Gn(a=r.objectType)&32&&!Ff(a)&&yC(r.indexType)&&!(s0(a)&8)&&!a.declaration.nameType)}function Tf(r){let a=r.flags&465829888?k_(r)||Sr:r,_=Gn(a);return _&32?_ze(a):_&4&&a!==r?Hp(a,r):a.flags&2097152?yRt(a,r):a.flags&402653316?Tl:a.flags&296?ql:a.flags&2112?nMt():a.flags&528?bc:a.flags&12288?Bze():a.flags&67108864?$a:a.flags&4194304?Qo:a.flags&2&&!Q?$a:a}function o4(r){return Pg(Tf(Pg(r)))}function pze(r,a,_){var d,y,T;let P,L,J,G=r.flags&1048576,ae,Ce=4,be=G?0:8,Ye=!1;for(let on of r.types){let Qr=Tf(on);if(!(Xt(Qr)||Qr.flags&131072)){let cn=ka(Qr,a,_),Bs=cn?Nd(cn):0;if(cn){if(cn.flags&106500&&(ae??(ae=G?0:16777216),G?ae|=cn.flags&16777216:ae&=cn.flags),!P)P=cn;else if(cn!==P)if((FI(cn)||cn)===(FI(P)||P)&&gCe(P,cn,(Ys,As)=>Ys===As?-1:0)===-1)Ye=!!P.parent&&!!de(qn(P.parent));else{L||(L=new Map,L.set(Ia(P),P));let Ys=Ia(cn);L.has(Ys)||L.set(Ys,cn)}G&&wg(cn)?be|=8:!G&&!wg(cn)&&(be&=-9),be|=(Bs&6?0:256)|(Bs&4?512:0)|(Bs&2?1024:0)|(Bs&256?2048:0),fAe(cn)||(Ce=2)}else if(G){let Os=!pL(a)&&iP(Qr,a);Os?(be|=32|(Os.isReadonly?8:0),J=Pr(J,Ka(Qr)?kae(Qr)||Be:Os.type)):vb(Qr)&&!(Gn(Qr)&2097152)?(be|=32,J=Pr(J,Be)):be|=16}}}if(!P||G&&(L||be&48)&&be&1536&&!(L&&TRt(L.values())))return;if(!L&&!(be&16)&&!J)if(Ye){let on=(d=ii(P,Rh))==null?void 0:d.links,Qr=TC(P,on?.type);return Qr.parent=(T=(y=P.valueDeclaration)==null?void 0:y.symbol)==null?void 0:T.parent,Qr.links.containingType=r,Qr.links.mapper=on?.mapper,Qr.links.writeType=XE(P),Qr}else return P;let vt=L?In(L.values()):[P],Dt,ur,pr,dn=[],Ur,fr,$r=!1;for(let on of vt){fr?on.valueDeclaration&&on.valueDeclaration!==fr&&($r=!0):fr=on.valueDeclaration,Dt=jt(Dt,on.declarations);let Qr=vn(on);ur||(ur=Qr,pr=as(on).nameType);let cn=XE(on);(Ur||cn!==Qr)&&(Ur=Pr(Ur||dn.slice(),cn)),Qr!==ur&&(be|=64),(NL(Qr)||gC(Qr))&&(be|=128),Qr.flags&131072&&Qr!==zu&&(be|=131072),dn.push(Qr)}jt(dn,J);let Jr=oo(4|(ae??0),a,Ce|be);return Jr.links.containingType=r,!$r&&fr&&(Jr.valueDeclaration=fr,fr.symbol.parent&&(Jr.parent=fr.symbol.parent)),Jr.declarations=Dt,Jr.links.nameType=pr,dn.length>2?(Jr.links.checkFlags|=65536,Jr.links.deferralParent=r,Jr.links.deferralConstituents=dn,Jr.links.deferralWriteConstituents=Ur):(Jr.links.type=G?pi(dn):Pa(dn),Ur&&(Jr.links.writeType=G?pi(Ur):Pa(Ur))),Jr}function dze(r,a,_){var d,y,T;let P=_?(d=r.propertyCacheWithoutObjectFunctionPropertyAugment)==null?void 0:d.get(a):(y=r.propertyCache)==null?void 0:y.get(a);return P||(P=pze(r,a,_),P&&((_?r.propertyCacheWithoutObjectFunctionPropertyAugment||(r.propertyCacheWithoutObjectFunctionPropertyAugment=ga()):r.propertyCache||(r.propertyCache=ga())).set(a,P),_&&!(Vc(P)&48)&&!((T=r.propertyCache)!=null&&T.get(a))&&(r.propertyCache||(r.propertyCache=ga())).set(a,P))),P}function TRt(r){let a;for(let _ of r){if(!_.declarations)return;if(!a){a=new Set(_.declarations);continue}if(a.forEach(d=>{hs(_.declarations,d)||a.delete(d)}),a.size===0)return}return a}function Tz(r,a,_){let d=dze(r,a,_);return d&&!(Vc(d)&16)?d:void 0}function Pg(r){return r.flags&1048576&&r.objectFlags&16777216?r.resolvedReducedType||(r.resolvedReducedType=bRt(r)):r.flags&2097152?(r.objectFlags&16777216||(r.objectFlags|=16777216|(Tt(vz(r),ERt)?33554432:0)),r.objectFlags&33554432?Qn:r):r}function bRt(r){let a=ul(r.types,Pg);if(a===r.types)return r;let _=pi(a);return _.flags&1048576&&(_.resolvedReducedType=_),_}function ERt(r){return mze(r)||gze(r)}function mze(r){return!(r.flags&16777216)&&(Vc(r)&131264)===192&&!!(vn(r).flags&131072)}function gze(r){return!r.valueDeclaration&&!!(Vc(r)&1024)}function dxe(r){return!!(r.flags&1048576&&r.objectFlags&16777216&&Tt(r.types,dxe)||r.flags&2097152&&xRt(r))}function xRt(r){let a=r.uniqueLiteralFilledInstantiation||(r.uniqueLiteralFilledInstantiation=gs(r,ks));return Pg(a)!==a}function mxe(r,a){if(a.flags&2097152&&Gn(a)&33554432){let _=mr(vz(a),mze);if(_)return Xs(r,g.The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents,Kr(a,void 0,536870912),Oi(_));let d=mr(vz(a),gze);if(d)return Xs(r,g.The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some,Kr(a,void 0,536870912),Oi(d))}return r}function ka(r,a,_,d){var y,T;if(r=o4(r),r.flags&524288){let P=kg(r),L=P.members.get(a);if(L&&!d&&((y=r.symbol)==null?void 0:y.flags)&512&&((T=as(r.symbol).typeOnlyExportStarMap)!=null&&T.has(a)))return;if(L&&Zm(L,d))return L;if(_)return;let J=P===cr?Bt:P.callSignatures.length?Zr:P.constructSignatures.length?Ds:void 0;if(J){let G=ub(J,a);if(G)return G}return ub(Oe,a)}if(r.flags&2097152){let P=Tz(r,a,!0);return P||(_?void 0:Tz(r,a,_))}if(r.flags&1048576)return Tz(r,a,_)}function bz(r,a){if(r.flags&3670016){let _=kg(r);return a===0?_.callSignatures:_.constructSignatures}return tt}function na(r,a){let _=bz(o4(r),a);if(a===0&&!de(_)&&r.flags&1048576){if(r.arrayFallbackSignatures)return r.arrayFallbackSignatures;let d;if(tp(r,y=>{var T;return!!((T=y.symbol)!=null&&T.parent)&&CRt(y.symbol.parent)&&(d?d===y.symbol.escapedName:(d=y.symbol.escapedName,!0))})){let y=Ec(r,P=>VS((hze(P.symbol.parent)?ua:sa).typeParameters[0],P.mapper)),T=P_(y,rg(r,P=>hze(P.symbol.parent)));return r.arrayFallbackSignatures=na(Xe(T,d),a)}r.arrayFallbackSignatures=_}return _}function CRt(r){return!r||!sa.symbol||!ua.symbol?!1:!!bg(r,sa.symbol)||!!bg(r,ua.symbol)}function hze(r){return!r||!ua.symbol?!1:!!bg(r,ua.symbol)}function gxe(r,a){return mr(r,_=>_.keyType===a)}function hxe(r,a){let _,d,y;for(let T of r)T.keyType===Le?_=T:nP(a,T.keyType)&&(d?(y||(y=[d])).push(T):d=T);return y?o0(Sr,Pa(vr(y,T=>T.type)),d_(y,(T,P)=>T&&P.isReadonly,!0)):d||(_&&nP(a,Le)?_:void 0)}function nP(r,a){return Na(r,a)||a===Le&&Na(r,It)||a===It&&(r===Eo||!!(r.flags&128)&&R0(r.value))}function yxe(r){return r.flags&3670016?kg(r).indexInfos:tt}function nf(r){return yxe(o4(r))}function K0(r,a){return gxe(nf(r),a)}function _b(r,a){var _;return(_=K0(r,a))==null?void 0:_.type}function vxe(r,a){return nf(r).filter(_=>nP(a,_.keyType))}function mL(r,a){return hxe(nf(r),a)}function iP(r,a){return mL(r,pL(a)?Fi:jf(Zi(a)))}function yze(r){var a;let _;for(let d of Ov(r))_=ai(_,lC(d.symbol));return _?.length?_:Zl(r)?(a=c4(r))==null?void 0:a.typeParameters:void 0}function Sxe(r){let a=[];return r.forEach((_,d)=>{WE(d)||a.push(_)}),a}function Xse(r,a){if(Nu(r))return;let _=Lf(ke,'"'+r+'"',512);return _&&a?mo(_):_}function gL(r){if(CA(r)||fR(r)||pR(r))return!0;if(r.initializer){let _=Sm(r.parent),d=r.parent.parameters.indexOf(r);return I.assert(d>=0),d>=Th(_,3)}let a=W2(r.parent);return a?!r.type&&!r.dotDotDotToken&&r.parent.parameters.indexOf(r)>=coe(a).length:!1}function ARt(r){return ea(r)&&!Hg(r)&&r.questionToken}function Ez(r,a,_,d){return{kind:r,parameterName:a,parameterIndex:_,type:d}}function a0(r){let a=0;if(r)for(let _=0;_<r.length;_++)uze(r[_])||(a=_+1);return a}function FS(r,a,_,d){let y=de(a);if(!y)return[];let T=de(r);if(d||T>=_&&T<=y){let P=r?r.slice():[];for(let J=T;J<y;J++)P[J]=ht;let L=MCe(d);for(let J=T;J<y;J++){let G=pC(a[J]);d&&G&&(n1(G,Sr)||n1(G,$a))&&(G=W),P[J]=G?gs(G,kp(a,P)):L}return P.length=a.length,P}return r&&r.slice()}function Sm(r){let a=_i(r);if(!a.resolvedSignature){let _=[],d=0,y=0,T,P=gn(r)?b9(r):void 0,L=!1,J=W2(r),G=hN(r);!J&&gn(r)&&Ide(r)&&!upe(r)&&!fT(r)&&(d|=32);for(let vt=G?1:0;vt<r.parameters.length;vt++){let Dt=r.parameters[vt];if(gn(Dt)&&HK(Dt)){P=Dt;continue}let ur=Dt.symbol,pr=mg(Dt)?Dt.typeExpression&&Dt.typeExpression.type:Dt.type;ur&&ur.flags&4&&!la(Dt.name)&&(ur=wc(Dt,ur.escapedName,111551,void 0,void 0,!1)),vt===0&&ur.escapedName==="this"?(L=!0,T=Dt.symbol):_.push(ur),pr&&pr.kind===201&&(d|=2),fR(Dt)||Dt.initializer||Dt.questionToken||x0(Dt)||J&&_.length>J.arguments.length&&!pr||pR(Dt)||(y=_.length)}if((r.kind===177||r.kind===178)&&vI(r)&&(!L||!T)){let vt=r.kind===177?178:177,Dt=xc(Rn(r),vt);Dt&&(T=Vse(Dt))}P&&P.typeExpression&&(T=TC(oo(1,"this"),Ri(P.typeExpression)));let Ce=PT(r)?vT(r):r,be=Ce&&Yc(Ce)?qd(mo(Ce.parent.symbol)):void 0,Ye=be?be.localTypeParameters:yze(r);(yY(r)||gn(r)&&kRt(r,_))&&(d|=1),(VN(r)&&ui(r,64)||Yc(r)&&ui(r.parent,64))&&(d|=4),a.resolvedSignature=X0(r,Ye,T,_,void 0,void 0,y,d)}return a.resolvedSignature}function kRt(r,a){if(PT(r)||!Txe(r))return!1;let _=Is(r.parameters),d=_?HP(_):pT(r).filter(mg),y=Ct(d,P=>P.typeExpression&&lU(P.typeExpression.type)?P.typeExpression.type:void 0),T=oo(3,"args",32768);return y?T.links.type=P_(Ri(y.type)):(T.links.checkFlags|=65536,T.links.deferralParent=Qn,T.links.deferralConstituents=[bl],T.links.deferralWriteConstituents=[bl]),y&&a.pop(),a.push(T),!0}function c4(r){if(!(gn(r)&&tc(r)))return;let a=_T(r);return a?.typeExpression&&NC(Ri(a.typeExpression))}function PRt(r,a){let _=c4(r);if(!_)return;let d=r.parameters.indexOf(a);return a.dotDotDotToken?p$(_,d):Ig(_,d)}function NRt(r){let a=c4(r);return a&&Ao(a)}function Txe(r){let a=_i(r);return a.containsArgumentsReference===void 0&&(a.flags&512?a.containsArgumentsReference=!0:a.containsArgumentsReference=_(r.body)),a.containsArgumentsReference;function _(d){if(!d)return!1;switch(d.kind){case 80:return d.escapedText===$t.escapedName&&QL(d)===$t;case 172:case 174:case 177:case 178:return d.name.kind===167&&_(d.name);case 211:case 212:return _(d.expression);case 303:return _(d.initializer);default:return!lX(d)&&!A0(d)&&!!Qs(d,_)}}}function KE(r){if(!r||!r.declarations)return tt;let a=[];for(let _=0;_<r.declarations.length;_++){let d=r.declarations[_];if(ca(d)){if(_>0&&d.body){let y=r.declarations[_-1];if(d.parent===y.parent&&d.kind===y.kind&&d.pos===y.end)continue}if(gn(d)&&d.jsDoc){let y=ZY(d);if(de(y)){for(let T of y){let P=T.typeExpression;P.type===void 0&&!Yc(d)&&hb(P,W),a.push(Sm(P))}continue}}a.push(!iE(d)&&!jm(d)&&c4(d)||Sm(d))}}return a}function vze(r){let a=rf(r,r);if(a){let _=bp(a);if(_)return vn(_)}return W}function fb(r){if(r.thisParameter)return vn(r.thisParameter)}function zd(r){if(!r.resolvedTypePredicate){if(r.target){let a=zd(r.target);r.resolvedTypePredicate=a?p7t(a,r.mapper):je}else if(r.compositeSignatures)r.resolvedTypePredicate=PMt(r.compositeSignatures,r.compositeKind)||je;else{let a=r.declaration&&lm(r.declaration),_;if(!a){let d=c4(r.declaration);d&&r!==d&&(_=zd(d))}r.resolvedTypePredicate=a&&RR(a)?DRt(a,r):_||je}I.assert(!!r.resolvedTypePredicate)}return r.resolvedTypePredicate===je?void 0:r.resolvedTypePredicate}function DRt(r,a){let _=r.parameterName,d=r.type&&Ri(r.type);return _.kind===197?Ez(r.assertsModifier?2:0,void 0,void 0,d):Ez(r.assertsModifier?3:1,_.escapedText,oa(a.parameters,y=>y.escapedName===_.escapedText),d)}function Sze(r,a,_){return a!==2097152?pi(r,_):Pa(r)}function Ao(r){if(!r.resolvedReturnType){if(!n0(r,3))return ht;let a=r.target?gs(Ao(r.target),r.mapper):r.compositeSignatures?gs(Sze(vr(r.compositeSignatures,Ao),r.compositeKind,2),r.mapper):TI(r.declaration)||(sl(r.declaration.body)?W:foe(r.declaration));if(r.flags&8?a=eWe(a):r.flags&16&&(a=$S(a)),!dh()){if(r.declaration){let _=lm(r.declaration);if(_)He(_,g.Return_type_annotation_circularly_references_itself);else if(ve){let d=r.declaration,y=qs(d);y?He(y,g._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions,qo(y)):He(d,g.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions)}}a=W}r.resolvedReturnType=a}return r.resolvedReturnType}function TI(r){if(r.kind===176)return qd(mo(r.parent.symbol));let a=lm(r);if(PT(r)){let _=yN(r);if(_&&Yc(_.parent)&&!a)return qd(mo(_.parent.parent.symbol))}if(hN(r))return Ri(r.parameters[0].type);if(a)return Ri(a);if(r.kind===177&&vI(r)){let _=gn(r)&&Yy(r);if(_)return _;let d=xc(Rn(r),178),y=ob(d);if(y)return y}return NRt(r)}function Kse(r){return r.compositeSignatures&&Tt(r.compositeSignatures,Kse)||!r.resolvedReturnType&&tP(r,3)>=0}function IRt(r){return Tze(r)||W}function Tze(r){if(L_(r)){let a=vn(r.parameters[r.parameters.length-1]),_=Ka(a)?kae(a):a;return _&&_b(_,It)}}function hL(r,a,_,d){let y=bxe(r,FS(a,r.typeParameters,a0(r.typeParameters),_));if(d){let T=OGe(Ao(y));if(T){let P=dL(T);P.typeParameters=d;let L=dL(y);return L.resolvedReturnType=dC(P),L}}return y}function bxe(r,a){let _=r.instantiations||(r.instantiations=new Map),d=Tm(a),y=_.get(d);return y||_.set(d,y=Qse(r,a)),y}function Qse(r,a){return PI(r,wRt(r,a),!0)}function wRt(r,a){return kp(r.typeParameters,a)}function yL(r){return r.typeParameters?r.erasedSignatureCache||(r.erasedSignatureCache=ORt(r)):r}function ORt(r){return PI(r,x$e(r.typeParameters),!0)}function RRt(r){return r.typeParameters?r.canonicalSignatureCache||(r.canonicalSignatureCache=MRt(r)):r}function MRt(r){return hL(r,vr(r.typeParameters,a=>a.target&&!Sf(a.target)?a.target:a),gn(r.declaration))}function LRt(r){let a=r.typeParameters;if(a){if(r.baseSignatureCache)return r.baseSignatureCache;let _=x$e(a),d=kp(a,vr(a,T=>Sf(T)||Sr)),y=vr(a,T=>gs(T,d)||Sr);for(let T=0;T<a.length-1;T++)y=ov(y,d);return y=ov(y,_),r.baseSignatureCache=PI(r,kp(a,y),!0)}return r}function dC(r){var a;if(!r.isolatedSignatureType){let _=(a=r.declaration)==null?void 0:a.kind,d=_===void 0||_===176||_===180||_===185,y=Ud(16);y.members=K,y.properties=tt,y.callSignatures=d?tt:[r],y.constructSignatures=d?[r]:tt,y.indexInfos=tt,r.isolatedSignatureType=y}return r.isolatedSignatureType}function Exe(r){return r.members?Zse(r.members):void 0}function Zse(r){return r.get("__index")}function o0(r,a,_,d){return{keyType:r,type:a,isReadonly:_,declaration:d}}function bze(r){let a=Exe(r);return a?xxe(a):tt}function xxe(r){if(r.declarations){let a=[];for(let _ of r.declarations)if(_.parameters.length===1){let d=_.parameters[0];d.type&&CC(Ri(d.type),y=>{eae(y)&&!gxe(a,y)&&a.push(o0(y,_.type?Ri(_.type):W,up(_,8),_))})}return a}return tt}function eae(r){return!!(r.flags&4108)||gC(r)||!!(r.flags&2097152)&&!AI(r)&&Tt(r.types,eae)}function Cxe(r){return Wi(Fn(r.symbol&&r.symbol.declarations,Nc),YP)[0]}function Eze(r,a){var _;let d;if((_=r.symbol)!=null&&_.declarations){for(let y of r.symbol.declarations)if(y.parent.kind===195){let[T=y.parent,P]=wde(y.parent.parent);if(P.kind===183&&!a){let L=P,J=YAe(L);if(J){let G=L.typeArguments.indexOf(T);if(G<J.length){let ae=Sf(J[G]);if(ae){let Ce=rCe(J,J.map((Ye,vt)=>()=>Kjt(L,J,vt))),be=gs(ae,Ce);be!==r&&(d=Pr(d,be))}}}}else if(P.kind===169&&P.dotDotDotToken||P.kind===191||P.kind===202&&P.dotDotDotToken)d=Pr(d,P_(Sr));else if(P.kind===204)d=Pr(d,Le);else if(P.kind===168&&P.parent.kind===200)d=Pr(d,Qo);else if(P.kind===200&&P.type&&Do(P.type)===y.parent&&P.parent.kind===194&&P.parent.extendsType===P&&P.parent.checkType.kind===200&&P.parent.checkType.type){let L=P.parent.checkType,J=Ri(L.type);d=Pr(d,gs(J,r2(lC(Rn(L.typeParameter)),L.typeParameter.constraint?Ri(L.typeParameter.constraint):Qo)))}}}return d&&Pa(d)}function l4(r){if(!r.constraint)if(r.target){let a=Sf(r.target);r.constraint=a?gs(a,r.mapper):ic}else{let a=Cxe(r);if(!a)r.constraint=Eze(r)||ic;else{let _=Ri(a);_.flags&1&&!Xt(_)&&(_=a.parent.parent.kind===200?Qo:Sr),r.constraint=_}}return r.constraint===ic?void 0:r.constraint}function xze(r){let a=xc(r.symbol,168),_=dm(a.parent)?yj(a.parent):a.parent;return _&&yd(_)}function Tm(r){let a="";if(r){let _=r.length,d=0;for(;d<_;){let y=r[d].id,T=1;for(;d+T<_&&r[d+T].id===y+T;)T++;a.length&&(a+=","),a+=y,T>1&&(a+=":"+T),d+=T}}return a}function sP(r,a){return r?`@${Ia(r)}`+(a?`:${Tm(a)}`:""):""}function tae(r,a){let _=0;for(let d of r)(a===void 0||!(d.flags&a))&&(_|=Gn(d));return _&458752}function bI(r,a){return Tt(a)&&r===$s?Sr:iv(r,a)}function iv(r,a){let _=Tm(a),d=r.instantiations.get(_);return d||(d=Ud(4,r.symbol),r.instantiations.set(_,d),d.objectFlags|=a?tae(a):0,d.target=r,d.resolvedTypeArguments=a),d}function Cze(r){let a=H0(r.flags,r.symbol);return a.objectFlags=r.objectFlags,a.target=r.target,a.resolvedTypeArguments=r.resolvedTypeArguments,a}function Axe(r,a,_,d,y){if(!d){d=oP(a);let P=kI(d);y=_?ov(P,_):P}let T=Ud(4,r.symbol);return T.target=r,T.node=a,T.mapper=_,T.aliasSymbol=d,T.aliasTypeArguments=y,T}function cc(r){var a,_;if(!r.resolvedTypeArguments){if(!n0(r,6))return((a=r.target.localTypeParameters)==null?void 0:a.map(()=>ht))||tt;let d=r.node,y=d?d.kind===183?ys(r.target.outerTypeParameters,hoe(d,r.target.localTypeParameters)):d.kind===188?[Ri(d.elementType)]:vr(d.elements,Ri):tt;dh()?r.resolvedTypeArguments=r.mapper?ov(y,r.mapper):y:(r.resolvedTypeArguments=((_=r.target.localTypeParameters)==null?void 0:_.map(()=>ht))||tt,He(r.node||O,r.target.symbol?g.Type_arguments_for_0_circularly_reference_themselves:g.Tuple_type_arguments_circularly_reference_themselves,r.target.symbol&&Oi(r.target.symbol)))}return r.resolvedTypeArguments}function sv(r){return de(r.target.typeParameters)}function Aze(r,a){let _=dc(mo(a)),d=_.localTypeParameters;if(d){let y=de(r.typeArguments),T=a0(d),P=gn(r);if(!(!ve&&P)&&(y<T||y>d.length)){let G=P&&L1(r)&&!sk(r.parent),ae=T===d.length?G?g.Expected_0_type_arguments_provide_these_with_an_extends_tag:g.Generic_type_0_requires_1_type_argument_s:G?g.Expected_0_1_type_arguments_provide_these_with_an_extends_tag:g.Generic_type_0_requires_between_1_and_2_type_arguments,Ce=Kr(_,void 0,2);if(He(r,ae,Ce,T,d.length),!P)return ht}if(r.kind===183&&Wze(r,de(r.typeArguments)!==d.length))return Axe(_,r,void 0);let J=ys(_.outerTypeParameters,FS(xz(r),d,T,P));return iv(_,J)}return QE(r,a)?_:ht}function EI(r,a,_,d){let y=dc(r);if(y===hr){let G=ZU.get(r.escapedName);if(G!==void 0&&a&&a.length===1)return G===4?kxe(a[0]):aP(r,a[0])}let T=as(r),P=T.typeParameters,L=Tm(a)+sP(_,d),J=T.instantiations.get(L);return J||T.instantiations.set(L,J=k$e(y,kp(P,FS(a,P,a0(P),gn(r.valueDeclaration))),_,d)),J}function FRt(r,a){if(Vc(a)&1048576){let y=xz(r),T=sP(a,y),P=Ve.get(T);return P||(P=Dl(1,"error",void 0,`alias ${T}`),P.aliasSymbol=a,P.aliasTypeArguments=y,Ve.set(T,P)),P}let _=dc(a),d=as(a).typeParameters;if(d){let y=de(r.typeArguments),T=a0(d);if(y<T||y>d.length)return He(r,T===d.length?g.Generic_type_0_requires_1_type_argument_s:g.Generic_type_0_requires_between_1_and_2_type_arguments,Oi(a),T,d.length),ht;let P=oP(r),L=P&&(kze(a)||!kze(P))?P:void 0,J;if(L)J=kI(L);else if(F9(r)){let G=xI(r,2097152,!0);if(G&&G!==dt){let ae=du(G);ae&&ae.flags&524288&&(L=ae,J=xz(r)||(d?[]:void 0))}}return EI(a,xz(r),L,J)}return QE(r,a)?_:ht}function kze(r){var a;let _=(a=r.declarations)==null?void 0:a.find(j8);return!!(_&&Vp(_))}function jRt(r){switch(r.kind){case 183:return r.typeName;case 233:let a=r.expression;if(ol(a))return a}}function Pze(r){return r.parent?`${Pze(r.parent)}.${r.escapedName}`:r.escapedName}function rae(r){let _=(r.kind===166?r.right:r.kind===211?r.name:r).escapedText;if(_){let d=r.kind===166?rae(r.left):r.kind===211?rae(r.expression):void 0,y=d?`${Pze(d)}.${_}`:_,T=_e.get(y);return T||(_e.set(y,T=oo(524288,_,1048576)),T.parent=d,T.links.declaredType=Wt),T}return dt}function xI(r,a,_){let d=jRt(r);if(!d)return dt;let y=ac(d,a,_);return y&&y!==dt?y:_?dt:rae(d)}function nae(r,a){if(a===dt)return ht;if(a=e4(a)||a,a.flags&96)return Aze(r,a);if(a.flags&524288)return FRt(r,a);let _=$qe(a);if(_)return QE(r,a)?af(_):ht;if(a.flags&111551&&iae(r)){let d=BRt(r,a);return d||(xI(r,788968),vn(a))}return ht}function BRt(r,a){let _=_i(r);if(!_.resolvedJSDocType){let d=vn(a),y=d;if(a.valueDeclaration){let T=r.kind===205&&r.qualifier;d.symbol&&d.symbol!==a&&T&&(y=nae(r,d.symbol))}_.resolvedJSDocType=y}return _.resolvedJSDocType}function kxe(r){return Pxe(r)?Nze(r,Sr):r}function Pxe(r){return!!(r.flags&3145728&&Tt(r.types,Pxe)||r.flags&33554432&&!u4(r)&&Pxe(r.baseType)||r.flags&524288&&!l0(r)||r.flags&432275456&&!gC(r))}function u4(r){return!!(r.flags&33554432&&r.constraint.flags&2)}function Nxe(r,a){return a.flags&3||a===r||r.flags&1?r:Nze(r,a)}function Nze(r,a){let _=`${sf(r)}>${sf(a)}`,d=Fs.get(_);if(d)return d;let y=G0(33554432);return y.baseType=r,y.constraint=a,Fs.set(_,y),y}function Dxe(r){return u4(r)?r.baseType:Pa([r.constraint,r.baseType])}function Dze(r){return r.kind===189&&r.elements.length===1}function Ize(r,a,_){return Dze(a)&&Dze(_)?Ize(r,a.elements[0],_.elements[0]):US(Ri(a))===US(r)?Ri(_):void 0}function URt(r,a){let _,d=!0;for(;a&&!ns(a)&&a.kind!==327;){let y=a.parent;if(y.kind===169&&(d=!d),(d||r.flags&8650752)&&y.kind===194&&a===y.trueType){let T=Ize(r,y.checkType,y.extendsType);T&&(_=Pr(_,T))}else if(r.flags&262144&&y.kind===200&&!y.nameType&&a===y.type){let T=Ri(y);if(Ag(T)===US(r)){let P=xL(T);if(P){let L=Sf(P);L&&tp(L,gb)&&(_=Pr(_,pi([It,Eo])))}}}a=y}return _?Nxe(r,Pa(_)):r}function iae(r){return!!(r.flags&16777216)&&(r.kind===183||r.kind===205)}function QE(r,a){return r.typeArguments?(He(r,g.Type_0_is_not_generic,a?Oi(a):r.typeName?qo(r.typeName):YU),!1):!0}function wze(r){if(ze(r.typeName)){let a=r.typeArguments;switch(r.typeName.escapedText){case"String":return QE(r),Le;case"Number":return QE(r),It;case"Boolean":return QE(r),Pi;case"Void":return QE(r),fn;case"Undefined":return QE(r),Be;case"Null":return QE(r),he;case"Function":case"function":return QE(r),Bt;case"array":return(!a||!a.length)&&!ve?bl:void 0;case"promise":return(!a||!a.length)&&!ve?m$(W):void 0;case"Object":if(a&&a.length===2){if(_j(r)){let _=Ri(a[0]),d=Ri(a[1]),y=_===Le||_===It?[o0(_,d,!1)]:tt;return Ho(void 0,K,tt,tt,y)}return W}return QE(r),ve?void 0:W}}}function VRt(r){let a=Ri(r.type);return Q?Jz(a,65536):a}function Ixe(r){let a=_i(r);if(!a.resolvedType){if(Ty(r)&&U2(r.parent))return a.resolvedSymbol=dt,a.resolvedType=xl(r.parent.expression);let _,d,y=788968;iae(r)&&(d=wze(r),d||(_=xI(r,y,!0),_===dt?_=xI(r,y|111551):xI(r,y),d=nae(r,_))),d||(_=xI(r,y),d=nae(r,_)),a.resolvedSymbol=_,a.resolvedType=d}return a.resolvedType}function xz(r){return vr(r.typeArguments,Ri)}function Oze(r){let a=_i(r);if(!a.resolvedType){let _=ZGe(r);a.resolvedType=af(Yp(_))}return a.resolvedType}function Rze(r,a){function _(y){let T=y.declarations;if(T)for(let P of T)switch(P.kind){case 263:case 264:case 266:return P}}if(!r)return a?$s:$a;let d=dc(r);return d.flags&524288?de(d.typeParameters)!==a?(He(_(r),g.Global_type_0_must_have_1_type_parameter_s,Lc(r),a),a?$s:$a):d:(He(_(r),g.Global_type_0_must_be_a_class_or_interface_type,Lc(r)),a?$s:$a)}function wxe(r,a){return _4(r,111551,a?g.Cannot_find_global_value_0:void 0)}function Oxe(r,a){return _4(r,788968,a?g.Cannot_find_global_type_0:void 0)}function sae(r,a,_){let d=_4(r,788968,_?g.Cannot_find_global_type_0:void 0);if(d&&(dc(d),de(as(d).typeParameters)!==a)){let y=d.declarations&&mr(d.declarations,Vm);He(y,g.Global_type_0_must_have_1_type_parameter_s,Lc(d),a);return}return d}function _4(r,a,_){return wc(void 0,r,a,_,r,!1,!1,!1)}function El(r,a,_){let d=Oxe(r,_);return d||_?Rze(d,a):void 0}function JRt(){return Yh||(Yh=El("TypedPropertyDescriptor",1,!0)||$s)}function qRt(){return _n||(_n=El("TemplateStringsArray",0,!0)||$a)}function Mze(){return gi||(gi=El("ImportMeta",0,!0)||$a)}function Lze(){if(!ci){let r=oo(0,"ImportMetaExpression"),a=Mze(),_=oo(4,"meta",8);_.parent=r,_.links.type=a;let d=ga([_]);r.members=d,ci=Ho(r,d,tt,tt,tt)}return ci}function Fze(r){return ds||(ds=El("ImportCallOptions",0,r))||$a}function Rxe(r){return Ya||(Ya=El("ImportAttributes",0,r))||$a}function jze(r){return hf||(hf=wxe("Symbol",r))}function zRt(r){return Fd||(Fd=Oxe("SymbolConstructor",r))}function Bze(){return ch||(ch=El("Symbol",0,!1))||$a}function Cz(r){return Ly||(Ly=El("Promise",1,r))||$s}function Uze(r){return A_||(A_=El("PromiseLike",1,r))||$s}function Mxe(r){return Fy||(Fy=wxe("Promise",r))}function $Rt(r){return vp||(vp=El("PromiseConstructorLike",0,r))||$a}function aae(r){return V||(V=El("AsyncIterable",1,r))||$s}function WRt(r){return Pe||(Pe=El("AsyncIterator",3,r))||$s}function GRt(r){return ot||(ot=El("AsyncIterableIterator",1,r))||$s}function HRt(r){return Yt||(Yt=El("AsyncGenerator",3,r))||$s}function Lxe(r){return U0||(U0=El("Iterable",1,r))||$s}function YRt(r){return Of||(Of=El("Iterator",3,r))||$s}function XRt(r){return ie||(ie=El("IterableIterator",1,r))||$s}function KRt(r){return ct||(ct=El("Generator",3,r))||$s}function QRt(r){return Jt||(Jt=El("IteratorYieldResult",1,r))||$s}function ZRt(r){return Gt||(Gt=El("IteratorReturnResult",1,r))||$s}function Vze(r){return Xa||(Xa=El("Disposable",0,r))||$a}function eMt(r){return Zc||(Zc=El("AsyncDisposable",0,r))||$a}function Jze(r,a=0){let _=_4(r,788968,void 0);return _&&Rze(_,a)}function tMt(){return Gu||(Gu=sae("Extract",2,!0)||dt),Gu===dt?void 0:Gu}function rMt(){return nu||(nu=sae("Omit",2,!0)||dt),nu===dt?void 0:nu}function Fxe(r){return Sp||(Sp=sae("Awaited",1,r)||(r?dt:void 0)),Sp===dt?void 0:Sp}function nMt(){return Rf||(Rf=El("BigInt",0,!1))||$a}function iMt(r){return Wm??(Wm=El("ClassDecoratorContext",1,r))??$s}function sMt(r){return Gm??(Gm=El("ClassMethodDecoratorContext",2,r))??$s}function aMt(r){return ts??(ts=El("ClassGetterDecoratorContext",2,r))??$s}function oMt(r){return jy??(jy=El("ClassSetterDecoratorContext",2,r))??$s}function cMt(r){return H1??(H1=El("ClassAccessorDecoratorContext",2,r))??$s}function lMt(r){return Hm??(Hm=El("ClassAccessorDecoratorTarget",2,r))??$s}function uMt(r){return wE??(wE=El("ClassAccessorDecoratorResult",2,r))??$s}function _Mt(r){return OE??(OE=El("ClassFieldDecoratorContext",2,r))??$s}function fMt(){return _S||(_S=wxe("NaN",!1))}function pMt(){return xo||(xo=sae("Record",2,!0)||dt),xo===dt?void 0:xo}function vL(r,a){return r!==$s?iv(r,a):$a}function qze(r){return vL(JRt(),[r])}function zze(r){return vL(Lxe(!0),[r])}function P_(r,a){return vL(a?ua:sa,[r])}function jxe(r){switch(r.kind){case 190:return 2;case 191:return $ze(r);case 202:return r.questionToken?2:r.dotDotDotToken?$ze(r):1;default:return 1}}function $ze(r){return Dz(r.type)?4:8}function dMt(r){let a=hMt(r.parent);if(Dz(r))return a?ua:sa;let d=vr(r.elements,jxe);return Bxe(d,a,vr(r.elements,mMt))}function mMt(r){return JN(r)||Ls(r)?r:void 0}function Wze(r,a){return!!oP(r)||Gze(r)&&(r.kind===188?jS(r.elementType):r.kind===189?Tt(r.elements,jS):a||Tt(r.typeArguments,jS))}function Gze(r){let a=r.parent;switch(a.kind){case 196:case 202:case 183:case 192:case 193:case 199:case 194:case 198:case 188:case 189:return Gze(a);case 265:return!0}return!1}function jS(r){switch(r.kind){case 183:return iae(r)||!!(xI(r,788968).flags&524288);case 186:return!0;case 198:return r.operator!==158&&jS(r.type);case 196:case 190:case 202:case 323:case 321:case 322:case 316:return jS(r.type);case 191:return r.type.kind!==188||jS(r.type.elementType);case 192:case 193:return Tt(r.types,jS);case 199:return jS(r.objectType)||jS(r.indexType);case 194:return jS(r.checkType)||jS(r.extendsType)||jS(r.trueType)||jS(r.falseType)}return!1}function gMt(r){let a=_i(r);if(!a.resolvedType){let _=dMt(r);if(_===$s)a.resolvedType=$a;else if(!(r.kind===189&&Tt(r.elements,d=>!!(jxe(d)&8)))&&Wze(r))a.resolvedType=r.kind===189&&r.elements.length===0?_:Axe(_,r,void 0);else{let d=r.kind===188?[Ri(r.elementType)]:vr(r.elements,Ri);a.resolvedType=Uxe(_,d)}}return a.resolvedType}function hMt(r){return cx(r)&&r.operator===148}function c0(r,a,_=!1,d=[]){let y=Bxe(a||vr(r,T=>1),_,d);return y===$s?$a:r.length?Uxe(y,r):y}function Bxe(r,a,_){if(r.length===1&&r[0]&4)return a?ua:sa;let d=vr(r,T=>T&1?"#":T&2?"?":T&4?".":"*").join()+(a?"R":"")+(Tt(_,T=>!!T)?","+vr(_,T=>T?yo(T):"_").join(","):""),y=Ms.get(d);return y||Ms.set(d,y=yMt(r,a,_)),y}function yMt(r,a,_){let d=r.length,y=mu(r,Ce=>!!(Ce&9)),T,P=[],L=0;if(d){T=new Array(d);for(let Ce=0;Ce<d;Ce++){let be=T[Ce]=Sd(),Ye=r[Ce];if(L|=Ye,!(L&12)){let vt=oo(4|(Ye&2?16777216:0),""+Ce,a?8:0);vt.links.tupleLabelDeclaration=_?.[Ce],vt.links.type=be,P.push(vt)}}}let J=P.length,G=oo(4,"length",a?8:0);if(L&12)G.links.type=It;else{let Ce=[];for(let be=y;be<=d;be++)Ce.push(Ng(be));G.links.type=pi(Ce)}P.push(G);let ae=Ud(12);return ae.typeParameters=T,ae.outerTypeParameters=void 0,ae.localTypeParameters=T,ae.instantiations=new Map,ae.instantiations.set(Tm(ae.typeParameters),ae),ae.target=ae,ae.resolvedTypeArguments=ae.typeParameters,ae.thisType=Sd(),ae.thisType.isThisType=!0,ae.thisType.constraint=ae,ae.declaredProperties=P,ae.declaredCallSignatures=tt,ae.declaredConstructSignatures=tt,ae.declaredIndexInfos=tt,ae.elementFlags=r,ae.minLength=y,ae.fixedLength=J,ae.hasRestElement=!!(L&12),ae.combinedFlags=L,ae.readonly=a,ae.labeledElementDeclarations=_,ae}function Uxe(r,a){return r.objectFlags&8?Vxe(r,a):iv(r,a)}function Vxe(r,a){var _,d,y,T;if(!(r.combinedFlags&14))return iv(r,a);if(r.combinedFlags&8){let vt=oa(a,(Dt,ur)=>!!(r.elementFlags[ur]&8&&Dt.flags&1179648));if(vt>=0)return kz(vr(a,(Dt,ur)=>r.elementFlags[ur]&8?Dt:Sr))?Ec(a[vt],Dt=>Vxe(r,sA(a,vt,Dt))):ht}let P=[],L=[],J=[],G=-1,ae=-1,Ce=-1;for(let vt=0;vt<a.length;vt++){let Dt=a[vt],ur=r.elementFlags[vt];if(ur&8)if(Dt.flags&1)Ye(Dt,4,(_=r.labeledElementDeclarations)==null?void 0:_[vt]);else if(Dt.flags&58982400||Ff(Dt))Ye(Dt,8,(d=r.labeledElementDeclarations)==null?void 0:d[vt]);else if(Ka(Dt)){let pr=ZE(Dt);if(pr.length+P.length>=1e4)return He(O,A0(O)?g.Type_produces_a_tuple_type_that_is_too_large_to_represent:g.Expression_produces_a_tuple_type_that_is_too_large_to_represent),ht;Te(pr,(dn,Ur)=>{var fr;return Ye(dn,Dt.target.elementFlags[Ur],(fr=Dt.target.labeledElementDeclarations)==null?void 0:fr[Ur])})}else Ye(cv(Dt)&&_b(Dt,It)||ht,4,(y=r.labeledElementDeclarations)==null?void 0:y[vt]);else Ye(Dt,ur,(T=r.labeledElementDeclarations)==null?void 0:T[vt])}for(let vt=0;vt<G;vt++)L[vt]&2&&(L[vt]=1);ae>=0&&ae<Ce&&(P[ae]=pi(ul(P.slice(ae,Ce+1),(vt,Dt)=>L[ae+Dt]&8?Ap(vt,It):vt)),P.splice(ae+1,Ce-ae),L.splice(ae+1,Ce-ae),J.splice(ae+1,Ce-ae));let be=Bxe(L,r.readonly,J);return be===$s?$a:L.length?iv(be,P):be;function Ye(vt,Dt,ur){Dt&1&&(G=L.length),Dt&4&&ae<0&&(ae=L.length),Dt&6&&(Ce=L.length),P.push(Dt&2?ep(vt,!0):vt),L.push(Dt),J.push(ur)}}function f4(r,a,_=0){let d=r.target,y=sv(r)-_;return a>d.fixedLength?iLt(r)||c0(tt):c0(cc(r).slice(a,y),d.elementFlags.slice(a,y),!1,d.labeledElementDeclarations&&d.labeledElementDeclarations.slice(a,y))}function Hze(r){return pi(Pr(Xn(r.target.fixedLength,a=>jf(""+a)),gh(r.target.readonly?ua:sa)))}function vMt(r,a){let _=oa(r.elementFlags,d=>!(d&a));return _>=0?_:r.elementFlags.length}function SL(r,a){return r.elementFlags.length-no(r.elementFlags,_=>!(_&a))-1}function Jxe(r){return r.fixedLength+SL(r,3)}function ZE(r){let a=cc(r),_=sv(r);return a.length===_?a:a.slice(0,_)}function SMt(r){return ep(Ri(r.type),!0)}function sf(r){return r.id}function t1(r,a){return Bg(r,a,sf,To)>=0}function Az(r,a){let _=Bg(r,a,sf,To);return _<0?(r.splice(~_,0,a),!0):!1}function TMt(r,a,_){let d=_.flags;if(!(d&131072))if(a|=d&473694207,d&465829888&&(a|=33554432),d&2097152&&Gn(_)&67108864&&(a|=536870912),_===Nt&&(a|=8388608),!Q&&d&98304)Gn(_)&65536||(a|=4194304);else{let y=r.length,T=y&&_.id>r[y-1].id?~y:Bg(r,_,sf,To);T<0&&r.splice(~T,0,_)}return a}function Yze(r,a,_){let d;for(let y of _)y!==d&&(a=y.flags&1048576?Yze(r,a|(kMt(y)?1048576:0),y.types):TMt(r,a,y),d=y);return a}function bMt(r,a){var _;if(r.length<2)return r;let d=Tm(r),y=Ta.get(d);if(y)return y;let T=a&&Tt(r,G=>!!(G.flags&524288)&&!Ff(G)&&uCe(kg(G))),P=r.length,L=P,J=0;for(;L>0;){L--;let G=r[L];if(T||G.flags&469499904){if(G.flags&262144&&e1(G).flags&1048576){hh(G,pi(vr(r,be=>be===G?Qn:be)),jd)&&kv(r,L);continue}let ae=G.flags&61603840?mr(Io(G),be=>Dg(vn(be))):void 0,Ce=ae&&af(vn(ae));for(let be of r)if(G!==be){if(J===1e5&&J/(P-L)*P>1e6){(_=mn)==null||_.instant(mn.Phase.CheckTypes,"removeSubtypes_DepthLimit",{typeIds:r.map(vt=>vt.id)}),He(O,g.Expression_produces_a_union_type_that_is_too_complex_to_represent);return}if(J++,ae&&be.flags&61603840){let Ye=Xe(be,ae.escapedName);if(Ye&&Dg(Ye)&&af(Ye)!==Ce)continue}if(hh(G,be,jd)&&(!(Gn(rv(G))&1)||!(Gn(rv(be))&1)||mb(G,be))){kv(r,L);break}}}}return Ta.set(d,r),r}function EMt(r,a,_){let d=r.length;for(;d>0;){d--;let y=r[d],T=y.flags;(T&402653312&&a&4||T&256&&a&8||T&2048&&a&64||T&8192&&a&4096||_&&T&32768&&a&16384||t2(y)&&t1(r,y.regularType))&&kv(r,d)}}function xMt(r){let a=Fn(r,gC);if(a.length){let _=r.length;for(;_>0;){_--;let d=r[_];d.flags&128&&Tt(a,y=>CMt(d,y))&&kv(r,_)}}}function CMt(r,a){return a.flags&134217728?Fae(r,a):Lae(r,a)}function AMt(r){let a=[];for(let _ of r)if(_.flags&2097152&&Gn(_)&67108864){let d=_.types[0].flags&8650752?0:1;ln(a,_.types[d])}for(let _ of a){let d=[];for(let T of r)if(T.flags&2097152&&Gn(T)&67108864){let P=T.types[0].flags&8650752?0:1;T.types[P]===_&&Az(d,T.types[1-P])}let y=k_(_);if(tp(y,T=>t1(d,T))){let T=r.length;for(;T>0;){T--;let P=r[T];if(P.flags&2097152&&Gn(P)&67108864){let L=P.types[0].flags&8650752?0:1;P.types[L]===_&&t1(d,P.types[1-L])&&kv(r,T)}}Az(r,_)}}}function kMt(r){return!!(r.flags&1048576&&(r.aliasSymbol||r.origin))}function Xze(r,a){for(let _ of a)if(_.flags&1048576){let d=_.origin;_.aliasSymbol||d&&!(d.flags&1048576)?ln(r,_):d&&d.flags&1048576&&Xze(r,d.types)}}function qxe(r,a){let _=Qk(r);return _.types=a,_}function pi(r,a=1,_,d,y){if(r.length===0)return Qn;if(r.length===1)return r[0];if(r.length===2&&!y&&(r[0].flags&1048576||r[1].flags&1048576)){let T=a===0?"N":a===2?"S":"L",P=r[0].id<r[1].id?0:1,L=r[P].id+T+r[1-P].id+sP(_,d),J=ri.get(L);return J||(J=Kze(r,a,_,d,void 0),ri.set(L,J)),J}return Kze(r,a,_,d,y)}function Kze(r,a,_,d,y){let T=[],P=Yze(T,0,r);if(a!==0){if(P&3)return P&1?P&8388608?Nt:W:P&65536||t1(T,Sr)?Sr:Y;if(P&32768&&T.length>=2&&T[0]===Be&&T[1]===B&&kv(T,1),(P&402664352||P&16384&&P&32768)&&EMt(T,P,!!(a&2)),P&128&&P&402653184&&xMt(T),P&536870912&&AMt(T),a===2&&(T=bMt(T,!!(P&524288)),!T))return ht;if(T.length===0)return P&65536?P&4194304?he:qe:P&32768?P&4194304?Be:Lt:Qn}if(!y&&P&1048576){let J=[];Xze(J,r);let G=[];for(let Ce of T)Tt(J,be=>t1(be.types,Ce))||G.push(Ce);if(!_&&J.length===1&&G.length===0)return J[0];if(d_(J,(Ce,be)=>Ce+be.types.length,0)+G.length===T.length){for(let Ce of J)Az(G,Ce);y=qxe(1048576,G)}}let L=(P&36323331?0:32768)|(P&2097152?16777216:0);return $xe(T,L,_,d,y)}function PMt(r,a){let _,d=[];for(let T of r){let P=zd(T);if(P){if(P.kind!==0&&P.kind!==1||_&&!zxe(_,P))return;_=P,d.push(P.type)}else{let L=a!==2097152?Ao(T):void 0;if(L!==Zt&&L!==Ir)return}}if(!_)return;let y=Sze(d,a);return Ez(_.kind,_.parameterName,_.parameterIndex,y)}function zxe(r,a){return r.kind===a.kind&&r.parameterIndex===a.parameterIndex}function $xe(r,a,_,d,y){if(r.length===0)return Qn;if(r.length===1)return r[0];let P=(y?y.flags&1048576?`|${Tm(y.types)}`:y.flags&2097152?`&${Tm(y.types)}`:`#${y.type.id}|${Tm(r)}`:Tm(r))+sP(_,d),L=un.get(P);return L||(L=G0(1048576),L.objectFlags=a|tae(r,98304),L.types=r,L.origin=y,L.aliasSymbol=_,L.aliasTypeArguments=d,r.length===2&&r[0].flags&512&&r[1].flags&512&&(L.flags|=16,L.intrinsicName="boolean"),un.set(P,L)),L}function NMt(r){let a=_i(r);if(!a.resolvedType){let _=oP(r);a.resolvedType=pi(vr(r.types,Ri),1,_,kI(_))}return a.resolvedType}function DMt(r,a,_){let d=_.flags;return d&2097152?Qze(r,a,_.types):(l0(_)?a&16777216||(a|=16777216,r.set(_.id.toString(),_)):(d&3?_===Nt&&(a|=8388608):(Q||!(d&98304))&&(_===B&&(a|=262144,_=Be),r.has(_.id.toString())||(_.flags&109472&&a&109472&&(a|=67108864),r.set(_.id.toString(),_))),a|=d&473694207),a)}function Qze(r,a,_){for(let d of _)a=DMt(r,a,af(d));return a}function IMt(r,a){let _=r.length;for(;_>0;){_--;let d=r[_];(d.flags&4&&a&402653312||d.flags&8&&a&256||d.flags&64&&a&2048||d.flags&4096&&a&8192||d.flags&16384&&a&32768||l0(d)&&a&470302716)&&kv(r,_)}}function wMt(r,a){for(let _ of r)if(!t1(_.types,a)){let d=a.flags&128?Le:a.flags&288?It:a.flags&2048?Rt:a.flags&8192?Fi:void 0;if(!d||!t1(_.types,d))return!1}return!0}function OMt(r){let a=r.length,_=Fn(r,d=>!!(d.flags&128));for(;a>0;){a--;let d=r[a];if(d.flags&402653184){for(let y of _)if(JS(y,d)){kv(r,a);break}else if(gC(d))return!0}}return!1}function Zze(r,a){for(let _=0;_<r.length;_++)r[_]=wl(r[_],d=>!(d.flags&a))}function RMt(r){let a,_=oa(r,P=>!!(Gn(P)&32768));if(_<0)return!1;let d=_+1;for(;d<r.length;){let P=r[d];Gn(P)&32768?((a||(a=[r[_]])).push(P),kv(r,d)):d++}if(!a)return!1;let y=[],T=[];for(let P of a)for(let L of P.types)Az(y,L)&&wMt(a,L)&&Az(T,L);return r[_]=$xe(T,32768),!0}function MMt(r,a,_,d){let y=G0(2097152);return y.objectFlags=a|tae(r,98304),y.types=r,y.aliasSymbol=_,y.aliasTypeArguments=d,y}function Pa(r,a,_,d){let y=new Map,T=Qze(y,0,r),P=In(y.values()),L=0;if(T&131072)return hs(P,Ns)?Ns:Qn;if(Q&&T&98304&&T&84410368||T&67108864&&T&402783228||T&402653316&&T&67238776||T&296&&T&469891796||T&2112&&T&469889980||T&12288&&T&469879804||T&49152&&T&469842940||T&402653184&&T&128&&OMt(P))return Qn;if(T&1)return T&8388608?Nt:W;if(!Q&&T&98304)return T&16777216?Qn:T&32768?Be:he;if((T&4&&T&402653312||T&8&&T&256||T&64&&T&2048||T&4096&&T&8192||T&16384&&T&32768||T&16777216&&T&470302716)&&(d||IMt(P,T)),T&262144&&(P[P.indexOf(Be)]=B),P.length===0)return Sr;if(P.length===1)return P[0];if(P.length===2){let ae=P[0].flags&8650752?0:1,Ce=P[ae],be=P[1-ae];if(Ce.flags&8650752&&(be.flags&469893116&&!u$e(be)||T&16777216)){let Ye=k_(Ce);if(Ye&&tp(Ye,vt=>!!(vt.flags&469893116)||l0(vt))){if(Oz(Ye,be))return Ce;if(!(Ye.flags&1048576&&rg(Ye,vt=>Oz(vt,be)))&&!Oz(be,Ye))return Qn;L=67108864}}}let J=Tm(P)+sP(a,_),G=On.get(J);if(!G){if(T&1048576)if(RMt(P))G=Pa(P,a,_);else if(yr(P,ae=>!!(ae.flags&1048576&&ae.types[0].flags&32768))){let ae=Tt(P,IL)?B:Be;Zze(P,32768),G=pi([Pa(P),ae],1,a,_)}else if(yr(P,ae=>!!(ae.flags&1048576&&(ae.types[0].flags&65536||ae.types[1].flags&65536))))Zze(P,65536),G=pi([Pa(P),he],1,a,_);else if(P.length>=4){let ae=Math.floor(P.length/2);G=Pa([Pa(P.slice(0,ae)),Pa(P.slice(ae))],a,_)}else{if(!kz(P))return ht;let ae=LMt(P),Ce=Tt(ae,be=>!!(be.flags&2097152))&&Wxe(ae)>Wxe(P)?qxe(2097152,P):void 0;G=pi(ae,1,a,_,Ce)}else G=MMt(P,L,a,_);On.set(J,G)}return G}function e$e(r){return d_(r,(a,_)=>_.flags&1048576?a*_.types.length:_.flags&131072?0:a,1)}function kz(r){var a;let _=e$e(r);return _>=1e5?((a=mn)==null||a.instant(mn.Phase.CheckTypes,"checkCrossProductUnion_DepthLimit",{typeIds:r.map(d=>d.id),size:_}),He(O,g.Expression_produces_a_union_type_that_is_too_complex_to_represent),!1):!0}function LMt(r){let a=e$e(r),_=[];for(let d=0;d<a;d++){let y=r.slice(),T=d;for(let L=r.length-1;L>=0;L--)if(r[L].flags&1048576){let J=r[L].types,G=J.length;y[L]=J[T%G],T=Math.floor(T/G)}let P=Pa(y);P.flags&131072||_.push(P)}return _}function t$e(r){return!(r.flags&3145728)||r.aliasSymbol?1:r.flags&1048576&&r.origin?t$e(r.origin):Wxe(r.types)}function Wxe(r){return d_(r,(a,_)=>a+t$e(_),0)}function FMt(r){let a=_i(r);if(!a.resolvedType){let _=oP(r),d=vr(r.types,Ri),y=d.length===2?d.indexOf(Nl):-1,T=y>=0?d[1-y]:Sr,P=!!(T.flags&76||T.flags&134217728&&gC(T));a.resolvedType=Pa(d,_,kI(_),P)}return a.resolvedType}function r$e(r,a){let _=G0(4194304);return _.type=r,_.indexFlags=a,_}function jMt(r){let a=Qk(4194304);return a.type=r,a}function n$e(r,a){return a&1?r.resolvedStringIndexType||(r.resolvedStringIndexType=r$e(r,1)):r.resolvedIndexType||(r.resolvedIndexType=r$e(r,0))}function i$e(r,a){let _=Ag(r),d=bd(r),y=nv(r.target||r);if(!y&&!(a&2))return d;let T=[];if(yC(d)){if(SI(r))return n$e(r,a);CC(d,L)}else if(SI(r)){let J=Tf(uC(r));oxe(J,8576,!!(a&1),L)}else CC(yz(d),L);let P=a&2?wl(pi(T),J=>!(J.flags&5)):pi(T);if(P.flags&1048576&&d.flags&1048576&&Tm(P.types)===Tm(d.types))return d;return P;function L(J){let G=y?gs(y,EL(r.mapper,_,J)):J;T.push(G===Le?js:G)}}function BMt(r){let a=Ag(r);return _(nv(r)||a);function _(d){return d.flags&470810623?!0:d.flags&16777216?d.root.isDistributive&&d.checkType===a:d.flags&137363456?yr(d.types,_):d.flags&8388608?_(d.objectType)&&_(d.indexType):d.flags&33554432?_(d.baseType)&&_(d.constraint):d.flags&268435456?_(d.type):!1}}function av(r){if(is(r))return Qn;if(_p(r))return af(Cs(r));if(uo(r))return af(Q0(r));let a=K2(r);return a!==void 0?jf(Zi(a)):bt(r)?af(Cs(r)):Qn}function CI(r,a,_){if(_||!(Nd(r)&6)){let d=as(Gse(r)).nameType;if(!d){let y=qs(r.valueDeclaration);d=r.escapedName==="default"?jf("default"):y&&av(y)||(H8(r)?void 0:jf(Lc(r)))}if(d&&d.flags&a)return d}return Qn}function s$e(r,a){return!!(r.flags&a||r.flags&2097152&&Tt(r.types,_=>s$e(_,a)))}function UMt(r,a,_){let d=_&&(Gn(r)&7||r.aliasSymbol)?jMt(r):void 0,y=vr(Io(r),P=>CI(P,a)),T=vr(nf(r),P=>P!==Zn&&s$e(P.keyType,a)?P.keyType===Le&&a&8?js:P.keyType:Qn);return pi(ys(y,T),1,void 0,void 0,d)}function Gxe(r,a=0){return!!(r.flags&58982400||zS(r)||Ff(r)&&(!BMt(r)||Yse(r)===2)||r.flags&1048576&&!(a&4)&&dxe(r)||r.flags&2097152&&$c(r,465829888)&&Tt(r.types,l0))}function gh(r,a=Ge){return r=Pg(r),u4(r)?kxe(gh(r.baseType,a)):Gxe(r,a)?n$e(r,a):r.flags&1048576?Pa(vr(r.types,_=>gh(_,a))):r.flags&2097152?pi(vr(r.types,_=>gh(_,a))):Gn(r)&32?i$e(r,a):r===Nt?Nt:r.flags&2?Qn:r.flags&131073?Qo:UMt(r,(a&2?128:402653316)|(a&1?0:12584),a===Ge)}function a$e(r){if(Me)return r;let a=tMt();return a?EI(a,[r,Le]):Le}function VMt(r){let a=a$e(gh(r));return a.flags&131072?Le:a}function JMt(r){let a=_i(r);if(!a.resolvedType)switch(r.operator){case 143:a.resolvedType=gh(Ri(r.type));break;case 158:a.resolvedType=r.type.kind===155?tCe(J8(r.parent)):ht;break;case 148:a.resolvedType=Ri(r.type);break;default:I.assertNever(r.operator)}return a.resolvedType}function qMt(r){let a=_i(r);return a.resolvedType||(a.resolvedType=mC([r.head.text,...vr(r.templateSpans,_=>_.literal.text)],vr(r.templateSpans,_=>Ri(_.type)))),a.resolvedType}function mC(r,a){let _=oa(a,G=>!!(G.flags&1179648));if(_>=0)return kz(a)?Ec(a[_],G=>mC(r,sA(a,_,G))):ht;if(hs(a,Nt))return Nt;let d=[],y=[],T=r[0];if(!J(r,a))return Le;if(d.length===0)return jf(T);if(y.push(T),yr(y,G=>G==="")){if(yr(d,G=>!!(G.flags&4)))return Le;if(d.length===1&&gC(d[0]))return d[0]}let P=`${Tm(d)}|${vr(y,G=>G.length).join(",")}|${y.join("")}`,L=Ni.get(P);return L||Ni.set(P,L=$Mt(y,d)),L;function J(G,ae){for(let Ce=0;Ce<ae.length;Ce++){let be=ae[Ce];if(be.flags&101248)T+=zMt(be)||"",T+=G[Ce+1];else if(be.flags&134217728){if(T+=be.texts[0],!J(be.texts,be.types))return!1;T+=G[Ce+1]}else if(yC(be)||Pz(be))d.push(be),y.push(T),T=G[Ce+1];else return!1}return!0}}function zMt(r){return r.flags&128?r.value:r.flags&256?""+r.value:r.flags&2048?nE(r.value):r.flags&98816?r.intrinsicName:void 0}function $Mt(r,a){let _=G0(134217728);return _.texts=r,_.types=a,_}function aP(r,a){return a.flags&1179648?Ec(a,_=>aP(r,_)):a.flags&128?jf(o$e(r,a.value)):a.flags&134217728?mC(...WMt(r,a.texts,a.types)):a.flags&268435456&&r===a.symbol?a:a.flags&268435461||yC(a)?c$e(r,a):Pz(a)?c$e(r,mC(["",""],[a])):a}function o$e(r,a){switch(ZU.get(r.escapedName)){case 0:return a.toUpperCase();case 1:return a.toLowerCase();case 2:return a.charAt(0).toUpperCase()+a.slice(1);case 3:return a.charAt(0).toLowerCase()+a.slice(1)}return a}function WMt(r,a,_){switch(ZU.get(r.escapedName)){case 0:return[a.map(d=>d.toUpperCase()),_.map(d=>aP(r,d))];case 1:return[a.map(d=>d.toLowerCase()),_.map(d=>aP(r,d))];case 2:return[a[0]===""?a:[a[0].charAt(0).toUpperCase()+a[0].slice(1),...a.slice(1)],a[0]===""?[aP(r,_[0]),..._.slice(1)]:_];case 3:return[a[0]===""?a:[a[0].charAt(0).toLowerCase()+a[0].slice(1),...a.slice(1)],a[0]===""?[aP(r,_[0]),..._.slice(1)]:_]}return[a,_]}function c$e(r,a){let _=`${Ia(r)},${sf(a)}`,d=us.get(_);return d||us.set(_,d=GMt(r,a)),d}function GMt(r,a){let _=H0(268435456,r);return _.type=a,_}function HMt(r,a,_,d,y){let T=G0(8388608);return T.objectType=r,T.indexType=a,T.accessFlags=_,T.aliasSymbol=d,T.aliasTypeArguments=y,T}function TL(r){if(ve)return!1;if(Gn(r)&4096)return!0;if(r.flags&1048576)return yr(r.types,TL);if(r.flags&2097152)return Tt(r.types,TL);if(r.flags&465829888){let a=_xe(r);return a!==r&&TL(a)}return!1}function oae(r,a){return um(r)?_m(r):a&&Al(a)?K2(a):void 0}function Hxe(r,a){if(a.flags&8208){let _=Gr(r.parent,d=>!Yo(d))||r.parent;return Vb(_)?Jg(_)&&ze(r)&&hWe(_,r):yr(a.declarations,d=>!ca(d)||K1(d))}return!0}function l$e(r,a,_,d,y,T){let P=y&&y.kind===212?y:void 0,L=y&&is(y)?void 0:oae(_,y);if(L!==void 0){if(T&256)return Sb(a,L)||W;let G=ka(a,L);if(G){if(T&64&&y&&G.declarations&&mS(G)&&Hxe(y,G)){let Ce=P?.argumentExpression??(lx(y)?y.indexType:y);Q1(Ce,G.declarations,L)}if(P){if(a$(G,P,kGe(P.expression,a.symbol)),gHe(P,G,kA(P))){He(P.argumentExpression,g.Cannot_assign_to_0_because_it_is_a_read_only_property,Oi(G));return}if(T&8&&(_i(y).resolvedSymbol=G),SGe(P,G))return st}let ae=T&4?XE(G):vn(G);return P&&kA(P)!==1?GS(P,ae):y&&lx(y)&&IL(ae)?pi([ae,Be]):ae}if(tp(a,Ka)&&R0(L)){let ae=+L;if(y&&tp(a,Ce=>!Ce.target.hasRestElement)&&!(T&16)){let Ce=Yxe(y);if(Ka(a)){if(ae<0)return He(Ce,g.A_tuple_type_cannot_be_indexed_with_a_negative_value),Be;He(Ce,g.Tuple_type_0_of_length_1_has_no_element_at_index_2,Kr(a),sv(a),Zi(L))}else He(Ce,g.Property_0_does_not_exist_on_type_1,Zi(L),Kr(a))}if(ae>=0)return J(K0(a,It)),K$e(a,ae,T&1?B:void 0)}}if(!(_.flags&98304)&&c_(_,402665900)){if(a.flags&131073)return a;let G=mL(a,_)||K0(a,Le);if(G){if(T&2&&G.keyType!==It){P&&(T&4?He(P,g.Type_0_is_generic_and_can_only_be_indexed_for_reading,Kr(r)):He(P,g.Type_0_cannot_be_used_to_index_type_1,Kr(_),Kr(r)));return}if(y&&G.keyType===Le&&!c_(_,12)){let ae=Yxe(y);return He(ae,g.Type_0_cannot_be_used_as_an_index_type,Kr(_)),T&1?pi([G.type,B]):G.type}return J(G),T&1&&!(a.symbol&&a.symbol.flags&384&&_.symbol&&_.flags&1024&&yf(_.symbol)===a.symbol)?pi([G.type,B]):G.type}if(_.flags&131072)return Qn;if(TL(a))return W;if(P&&!doe(a)){if(vb(a)){if(ve&&_.flags&384)return fo.add($n(P,g.Property_0_does_not_exist_on_type_1,_.value,Kr(a))),Be;if(_.flags&12){let ae=vr(a.properties,Ce=>vn(Ce));return pi(Pr(ae,Be))}}if(a.symbol===at&&L!==void 0&&at.exports.has(L)&&at.exports.get(L).flags&418)He(P,g.Property_0_does_not_exist_on_type_1,Zi(L),Kr(a));else if(ve&&!$.suppressImplicitAnyIndexErrors&&!(T&128))if(L!==void 0&&xGe(L,a)){let ae=Kr(a);He(P,g.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead,L,ae,ae+"["+Fl(P.argumentExpression)+"]")}else if(_b(a,It))He(P.argumentExpression,g.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number);else{let ae;if(L!==void 0&&(ae=vAe(L,a)))ae!==void 0&&He(P.argumentExpression,g.Property_0_does_not_exist_on_type_1_Did_you_mean_2,L,Kr(a),ae);else{let Ce=W5t(a,P,_);if(Ce!==void 0)He(P,g.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1,Kr(a),Ce);else{let be;if(_.flags&1024)be=Xs(void 0,g.Property_0_does_not_exist_on_type_1,"["+Kr(_)+"]",Kr(a));else if(_.flags&8192){let Ye=Wp(_.symbol,P);be=Xs(void 0,g.Property_0_does_not_exist_on_type_1,"["+Ye+"]",Kr(a))}else _.flags&128||_.flags&256?be=Xs(void 0,g.Property_0_does_not_exist_on_type_1,_.value,Kr(a)):_.flags&12&&(be=Xs(void 0,g.No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1,Kr(_),Kr(a)));be=Xs(be,g.Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1,Kr(d),Kr(a)),fo.add(Ey(Xr(P),P,be))}}}return}}if(TL(a))return W;if(y){let G=Yxe(y);_.flags&384?He(G,g.Property_0_does_not_exist_on_type_1,""+_.value,Kr(a)):_.flags&12?He(G,g.Type_0_has_no_matching_index_signature_for_type_1,Kr(a),Kr(_)):He(G,g.Type_0_cannot_be_used_as_an_index_type,Kr(_))}if(wt(_))return _;return;function J(G){G&&G.isReadonly&&P&&(N0(P)||tX(P))&&He(P,g.Index_signature_in_type_0_only_permits_reading,Kr(a))}}function Yxe(r){return r.kind===212?r.argumentExpression:r.kind===199?r.indexType:r.kind===167?r.expression:r}function Pz(r){if(r.flags&2097152){let a=!1;for(let _ of r.types)if(_.flags&101248||Pz(_))a=!0;else if(!(_.flags&524288))return!1;return a}return!!(r.flags&77)||gC(r)}function gC(r){return!!(r.flags&134217728)&&yr(r.types,Pz)||!!(r.flags&268435456)&&Pz(r.type)}function u$e(r){return!!(r.flags&402653184)&&!gC(r)}function AI(r){return!!bL(r)}function hC(r){return!!(bL(r)&4194304)}function yC(r){return!!(bL(r)&8388608)}function bL(r){return r.flags&3145728?(r.objectFlags&2097152||(r.objectFlags|=2097152|d_(r.types,(a,_)=>a|bL(_),0)),r.objectFlags&12582912):r.flags&33554432?(r.objectFlags&2097152||(r.objectFlags|=2097152|bL(r.baseType)|bL(r.constraint)),r.objectFlags&12582912):(r.flags&58982400||Ff(r)||zS(r)?4194304:0)|(r.flags&63176704||u$e(r)?8388608:0)}function r1(r,a){return r.flags&8388608?XMt(r,a):r.flags&16777216?KMt(r,a):r}function _$e(r,a,_){if(r.flags&1048576||r.flags&2097152&&!Gxe(r)){let d=vr(r.types,y=>r1(Ap(y,a),_));return r.flags&2097152||_?Pa(d):pi(d)}}function YMt(r,a,_){if(a.flags&1048576){let d=vr(a.types,y=>r1(Ap(r,y),_));return _?Pa(d):pi(d)}}function XMt(r,a){let _=a?"simplifiedForWriting":"simplifiedForReading";if(r[_])return r[_]===Mu?r:r[_];r[_]=Mu;let d=r1(r.objectType,a),y=r1(r.indexType,a),T=YMt(d,y,a);if(T)return r[_]=T;if(!(y.flags&465829888)){let P=_$e(d,y,a);if(P)return r[_]=P}if(zS(d)&&y.flags&296){let P=h4(d,y.flags&8?0:d.target.fixedLength,0,a);if(P)return r[_]=P}return Ff(d)&&Yse(d)!==2?r[_]=Ec(cae(d,r.indexType),P=>r1(P,a)):r[_]=r}function KMt(r,a){let _=r.checkType,d=r.extendsType,y=pb(r),T=db(r);if(T.flags&131072&&US(y)===US(_)){if(_.flags&1||Na(SC(_),SC(d)))return r1(y,a);if(f$e(_,d))return Qn}else if(y.flags&131072&&US(T)===US(_)){if(!(_.flags&1)&&Na(SC(_),SC(d)))return Qn;if(_.flags&1||f$e(_,d))return r1(T,a)}return r}function f$e(r,a){return!!(pi([hz(r,a),Qn]).flags&131072)}function cae(r,a){let _=kp([Ag(r)],[a]),d=n2(r.mapper,_);return gs(Zy(r.target||r),d)}function Ap(r,a,_=0,d,y,T){return BS(r,a,_,d,y,T)||(d?ht:Sr)}function p$e(r,a){return tp(r,_=>{if(_.flags&384){let d=_m(_);if(R0(d)){let y=+d;return y>=0&&y<a}}return!1})}function BS(r,a,_=0,d,y,T){if(r===Nt||a===Nt)return Nt;if(r=Pg(r),L$e(r)&&!(a.flags&98304)&&c_(a,12)&&(a=Le),$.noUncheckedIndexedAccess&&_&32&&(_|=1),yC(a)||(d&&d.kind!==199?zS(r)&&!p$e(a,Jxe(r.target)):hC(r)&&!(Ka(r)&&p$e(a,Jxe(r.target)))||dxe(r))){if(r.flags&3)return r;let L=_&1,J=r.id+","+a.id+","+L+sP(y,T),G=vi.get(J);return G||vi.set(J,G=HMt(r,a,L,y,T)),G}let P=o4(r);if(a.flags&1048576&&!(a.flags&16)){let L=[],J=!1;for(let G of a.types){let ae=l$e(r,P,G,a,d,_|(J?128:0));if(ae)L.push(ae);else if(d)J=!0;else return}return J?void 0:_&4?Pa(L,y,T):pi(L,1,y,T)}return l$e(r,P,a,a,d,_|8|64)}function d$e(r){let a=_i(r);if(!a.resolvedType){let _=Ri(r.objectType),d=Ri(r.indexType),y=oP(r);a.resolvedType=Ap(_,d,0,r,y,kI(y))}return a.resolvedType}function Xxe(r){let a=_i(r);if(!a.resolvedType){let _=Ud(32,r.symbol);_.declaration=r,_.aliasSymbol=oP(r),_.aliasTypeArguments=kI(_.aliasSymbol),a.resolvedType=_,bd(_)}return a.resolvedType}function US(r){return r.flags&33554432?US(r.baseType):r.flags&8388608&&(r.objectType.flags&33554432||r.indexType.flags&33554432)?Ap(US(r.objectType),US(r.indexType)):r}function m$e(r){return XA(r)&&de(r.elements)>0&&!Tt(r.elements,a=>rU(a)||nU(a)||JN(a)&&!!(a.questionToken||a.dotDotDotToken))}function g$e(r,a){return AI(r)||a&&Ka(r)&&Tt(ZE(r),AI)}function Kxe(r,a,_,d,y){let T,P,L=0;for(;;){if(L===1e3)return He(O,g.Type_instantiation_is_excessively_deep_and_possibly_infinite),ht;let G=gs(US(r.checkType),a),ae=gs(r.extendsType,a);if(G===ht||ae===ht)return ht;if(G===Nt||ae===Nt)return Nt;let Ce=q8(r.node.checkType),be=q8(r.node.extendsType),Ye=m$e(Ce)&&m$e(be)&&de(Ce.elements)===de(be.elements),vt=g$e(G,Ye),Dt;if(r.inferTypeParameters){let pr=OL(r.inferTypeParameters,void 0,0);a&&(pr.nonFixingMapper=n2(pr.nonFixingMapper,a)),vt||o1(pr.inferences,G,ae,1536),Dt=a?n2(pr.mapper,a):pr.mapper}let ur=Dt?gs(r.extendsType,Dt):ae;if(!vt&&!g$e(ur,Ye)){if(!(ur.flags&3)&&(G.flags&1||!Na(CL(G),CL(ur)))){(G.flags&1||_&&!(ur.flags&131072)&&rg(CL(ur),dn=>Na(dn,CL(G))))&&(P||(P=[])).push(gs(Ri(r.node.trueType),Dt||a));let pr=Ri(r.node.falseType);if(pr.flags&16777216){let dn=pr.root;if(dn.node.parent===r.node&&(!dn.isDistributive||dn.checkType===r.checkType)){r=dn;continue}if(J(pr,a))continue}T=gs(pr,a);break}if(ur.flags&3||Na(SC(G),SC(ur))){let pr=Ri(r.node.trueType),dn=Dt||a;if(J(pr,dn))continue;T=gs(pr,dn);break}}T=G0(16777216),T.root=r,T.checkType=gs(r.checkType,a),T.extendsType=gs(r.extendsType,a),T.mapper=a,T.combinedMapper=Dt,T.aliasSymbol=d||r.aliasSymbol,T.aliasTypeArguments=d?y:ov(r.aliasTypeArguments,a);break}return P?pi(Pr(P,T)):T;function J(G,ae){if(G.flags&16777216&&ae){let Ce=G.root;if(Ce.outerTypeParameters){let be=n2(G.mapper,ae),Ye=vr(Ce.outerTypeParameters,ur=>VS(ur,be)),vt=kp(Ce.outerTypeParameters,Ye),Dt=Ce.isDistributive?VS(Ce.checkType,vt):void 0;if(!Dt||Dt===Ce.checkType||!(Dt.flags&1179648))return r=Ce,a=vt,d=void 0,y=void 0,Ce.aliasSymbol&&L++,!0}}return!1}}function pb(r){return r.resolvedTrueType||(r.resolvedTrueType=gs(Ri(r.root.node.trueType),r.mapper))}function db(r){return r.resolvedFalseType||(r.resolvedFalseType=gs(Ri(r.root.node.falseType),r.mapper))}function QMt(r){return r.resolvedInferredTrueType||(r.resolvedInferredTrueType=r.combinedMapper?gs(Ri(r.root.node.trueType),r.combinedMapper):pb(r))}function h$e(r){let a;return r.locals&&r.locals.forEach(_=>{_.flags&262144&&(a=Pr(a,dc(_)))}),a}function ZMt(r){return r.isDistributive&&(wz(r.checkType,r.node.trueType)||wz(r.checkType,r.node.falseType))}function e7t(r){let a=_i(r);if(!a.resolvedType){let _=Ri(r.checkType),d=oP(r),y=kI(d),T=Lr(r,!0),P=y?T:Fn(T,J=>wz(J,r)),L={node:r,checkType:_,extendsType:Ri(r.extendsType),isDistributive:!!(_.flags&262144),inferTypeParameters:h$e(r),outerTypeParameters:P,instantiations:void 0,aliasSymbol:d,aliasTypeArguments:y};a.resolvedType=Kxe(L,void 0,!1),P&&(L.instantiations=new Map,L.instantiations.set(Tm(P),a.resolvedType))}return a.resolvedType}function t7t(r){let a=_i(r);return a.resolvedType||(a.resolvedType=lC(Rn(r.typeParameter))),a.resolvedType}function y$e(r){return ze(r)?[r]:Pr(y$e(r.left),r.right)}function r7t(r){var a;let _=_i(r);if(!_.resolvedType){if(!Vv(r))return He(r.argument,g.String_literal_expected),_.resolvedSymbol=dt,_.resolvedType=ht;let d=r.isTypeOf?111551:r.flags&16777216?900095:788968,y=rf(r,r.argument.literal);if(!y)return _.resolvedSymbol=dt,_.resolvedType=ht;let T=!!((a=y.exports)!=null&&a.get("export=")),P=bp(y,!1);if(sl(r.qualifier))if(P.flags&d)_.resolvedType=v$e(r,_,P,d);else{let L=d===111551?g.Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here:g.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0;He(r,L,r.argument.literal.text),_.resolvedSymbol=dt,_.resolvedType=ht}else{let L=y$e(r.qualifier),J=P,G;for(;G=L.shift();){let ae=L.length?1920:d,Ce=mo(ll(J)),be=r.isTypeOf||gn(r)&&T?ka(vn(Ce),G.escapedText,!1,!0):void 0,vt=(r.isTypeOf?void 0:Lf(Ep(Ce),G.escapedText,ae))??be;if(!vt)return He(G,g.Namespace_0_has_no_exported_member_1,Wp(J),qo(G)),_.resolvedType=ht;_i(G).resolvedSymbol=vt,_i(G.parent).resolvedSymbol=vt,J=vt}_.resolvedType=v$e(r,_,J,d)}}return _.resolvedType}function v$e(r,a,_,d){let y=ll(_);return a.resolvedSymbol=y,d===111551?eHe(vn(_),r):nae(r,y)}function S$e(r){let a=_i(r);if(!a.resolvedType){let _=oP(r);if(MS(r.symbol).size===0&&!_)a.resolvedType=Nl;else{let d=Ud(16,r.symbol);d.aliasSymbol=_,d.aliasTypeArguments=kI(_),mx(r)&&r.isArrayType&&(d=P_(d)),a.resolvedType=d}}return a.resolvedType}function oP(r){let a=r.parent;for(;ox(a)||hE(a)||cx(a)&&a.operator===148;)a=a.parent;return j8(a)?Rn(a):void 0}function kI(r){return r?qn(r):void 0}function lae(r){return!!(r.flags&524288)&&!Ff(r)}function Qxe(r){return i1(r)||!!(r.flags&474058748)}function Zxe(r,a){if(!(r.flags&1048576))return r;if(yr(r.types,Qxe))return mr(r.types,i1)||$a;let _=mr(r.types,T=>!Qxe(T));if(!_||mr(r.types,T=>T!==_&&!Qxe(T)))return r;return y(_);function y(T){let P=ga();for(let J of Io(T))if(!(Nd(J)&6)){if(uae(J)){let G=J.flags&65536&&!(J.flags&32768),Ce=oo(16777220,J.escapedName,axe(J)|(a?8:0));Ce.links.type=G?Be:ep(vn(J),!0),Ce.declarations=J.declarations,Ce.links.nameType=as(J).nameType,Ce.links.syntheticOrigin=J,P.set(J.escapedName,Ce)}}let L=Ho(T.symbol,P,tt,tt,nf(T));return L.objectFlags|=131200,L}}function e2(r,a,_,d,y){if(r.flags&1||a.flags&1)return W;if(r.flags&2||a.flags&2)return Sr;if(r.flags&131072)return a;if(a.flags&131072)return r;if(r=Zxe(r,y),r.flags&1048576)return kz([r,a])?Ec(r,G=>e2(G,a,_,d,y)):ht;if(a=Zxe(a,y),a.flags&1048576)return kz([r,a])?Ec(a,G=>e2(r,G,_,d,y)):ht;if(a.flags&473960444)return r;if(hC(r)||hC(a)){if(i1(r))return a;if(r.flags&2097152){let G=r.types,ae=G[G.length-1];if(lae(ae)&&lae(a))return Pa(ys(G.slice(0,G.length-1),[e2(ae,a,_,d,y)]))}return Pa([r,a])}let T=ga(),P=new Set,L=r===$a?nf(a):tze([r,a]);for(let G of Io(a))Nd(G)&6?P.add(G.escapedName):uae(G)&&T.set(G.escapedName,eCe(G,y));for(let G of Io(r))if(!(P.has(G.escapedName)||!uae(G)))if(T.has(G.escapedName)){let ae=T.get(G.escapedName),Ce=vn(ae);if(ae.flags&16777216){let be=ys(G.declarations,ae.declarations),Ye=4|G.flags&16777216,vt=oo(Ye,G.escapedName),Dt=vn(G),ur=Dae(Dt),pr=Dae(Ce);vt.links.type=ur===pr?Dt:pi([Dt,pr],2),vt.links.leftSpread=G,vt.links.rightSpread=ae,vt.declarations=be,vt.links.nameType=as(G).nameType,T.set(G.escapedName,vt)}}else T.set(G.escapedName,eCe(G,y));let J=Ho(_,T,tt,tt,ul(L,G=>n7t(G,y)));return J.objectFlags|=2228352|d,J}function uae(r){var a;return!Tt(r.declarations,G_)&&(!(r.flags&106496)||!((a=r.declarations)!=null&&a.some(_=>Ti(_.parent))))}function eCe(r,a){let _=r.flags&65536&&!(r.flags&32768);if(!_&&a===wg(r))return r;let d=4|r.flags&16777216,y=oo(d,r.escapedName,axe(r)|(a?8:0));return y.links.type=_?Be:vn(r),y.declarations=r.declarations,y.links.nameType=as(r).nameType,y.links.syntheticOrigin=r,y}function n7t(r,a){return r.isReadonly!==a?o0(r.keyType,r.type,a,r.declaration):r}function Nz(r,a,_,d){let y=H0(r,_);return y.value=a,y.regularType=d||y,y}function cP(r){if(r.flags&2976){if(!r.freshType){let a=Nz(r.flags,r.value,r.symbol,r);a.freshType=a,r.freshType=a}return r.freshType}return r}function af(r){return r.flags&2976?r.regularType:r.flags&1048576?r.regularType||(r.regularType=Ec(r,af)):r}function t2(r){return!!(r.flags&2976)&&r.freshType===r}function jf(r){let a;return _r.get(r)||(_r.set(r,a=Nz(128,r)),a)}function Ng(r){let a;return rt.get(r)||(rt.set(r,a=Nz(256,r)),a)}function _ae(r){let a,_=nE(r);return zt.get(_)||(zt.set(_,a=Nz(2048,r)),a)}function i7t(r,a,_){let d,y=`${a}${typeof r=="string"?"@":"#"}${r}`,T=1024|(typeof r=="string"?128:256);return Rr.get(y)||(Rr.set(y,d=Nz(T,r,_)),d)}function s7t(r){if(r.literal.kind===106)return he;let a=_i(r);return a.resolvedType||(a.resolvedType=af(Cs(r.literal))),a.resolvedType}function a7t(r){let a=H0(8192,r);return a.escapedName=`__@${a.symbol.escapedName}@${Ia(a.symbol)}`,a}function tCe(r){if(gn(r)&&hE(r)){let a=X2(r);a&&(r=AA(a)||a)}if(dde(r)){let a=Z9(r)?yd(r.left):yd(r);if(a){let _=as(a);return _.uniqueESSymbolType||(_.uniqueESSymbolType=a7t(a))}}return Fi}function o7t(r){let a=kf(r,!1,!1),_=a&&a.parent;if(_&&(Ti(_)||_.kind===264)&&!pa(a)&&(!Yc(a)||Yb(r,a.body)))return qd(Rn(_)).thisType;if(_&&Ha(_)&&bn(_.parent)&&al(_.parent)===6)return qd(yd(_.parent.left).parent).thisType;let d=r.flags&16777216?yT(r):void 0;return d&&Xo(d)&&bn(d.parent)&&al(d.parent)===3?qd(yd(d.parent.left).parent).thisType:Sh(a)&&Yb(r,a.body)?qd(Rn(a)).thisType:(He(r,g.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface),ht)}function fae(r){let a=_i(r);return a.resolvedType||(a.resolvedType=o7t(r)),a.resolvedType}function T$e(r){return Ri(Dz(r.type)||r.type)}function Dz(r){switch(r.kind){case 196:return Dz(r.type);case 189:if(r.elements.length===1&&(r=r.elements[0],r.kind===191||r.kind===202&&r.dotDotDotToken))return Dz(r.type);break;case 188:return r.elementType}}function c7t(r){let a=_i(r);return a.resolvedType||(a.resolvedType=r.dotDotDotToken?T$e(r):ep(Ri(r.type),!0,!!r.questionToken))}function Ri(r){return URt(b$e(r),r)}function b$e(r){switch(r.kind){case 133:case 319:case 320:return W;case 159:return Sr;case 154:return Le;case 150:return It;case 163:return Rt;case 136:return Pi;case 155:return Fi;case 116:return fn;case 157:return Be;case 106:return he;case 146:return Qn;case 151:return r.flags&524288&&!ve?W:ni;case 141:return hr;case 197:case 110:return fae(r);case 201:return s7t(r);case 183:return Ixe(r);case 182:return r.assertsModifier?fn:Pi;case 233:return Ixe(r);case 186:return Oze(r);case 188:case 189:return gMt(r);case 190:return SMt(r);case 192:return NMt(r);case 193:return FMt(r);case 321:return VRt(r);case 323:return ep(Ri(r.type));case 202:return c7t(r);case 196:case 322:case 316:return Ri(r.type);case 191:return T$e(r);case 325:return uVt(r);case 184:case 185:case 187:case 329:case 324:case 330:return S$e(r);case 198:return JMt(r);case 199:return d$e(r);case 200:return Xxe(r);case 194:return e7t(r);case 195:return t7t(r);case 203:return qMt(r);case 205:return r7t(r);case 80:case 166:case 211:let a=ng(r);return a?dc(a):ht;default:return ht}}function pae(r,a,_){if(r&&r.length)for(let d=0;d<r.length;d++){let y=r[d],T=_(y,a);if(y!==T){let P=d===0?[]:r.slice(0,d);for(P.push(T),d++;d<r.length;d++)P.push(_(r[d],a));return P}}return r}function ov(r,a){return pae(r,a,gs)}function dae(r,a){return pae(r,a,PI)}function E$e(r,a){return pae(r,a,T7t)}function kp(r,a){return r.length===1?r2(r[0],a?a[0]:W):l7t(r,a)}function VS(r,a){switch(a.kind){case 0:return r===a.source?a.target:r;case 1:{let d=a.sources,y=a.targets;for(let T=0;T<d.length;T++)if(r===d[T])return y?y[T]:W;return r}case 2:{let d=a.sources,y=a.targets;for(let T=0;T<d.length;T++)if(r===d[T])return y[T]();return r}case 3:return a.func(r);case 4:case 5:let _=VS(r,a.mapper1);return _!==r&&a.kind===4?gs(_,a.mapper2):VS(_,a.mapper2)}}function r2(r,a){return I.attachDebugPrototypeIfDebug({kind:0,source:r,target:a})}function l7t(r,a){return I.attachDebugPrototypeIfDebug({kind:1,sources:r,targets:a})}function Iz(r,a){return I.attachDebugPrototypeIfDebug({kind:3,func:r,debugInfo:I.isDebugging?a:void 0})}function rCe(r,a){return I.attachDebugPrototypeIfDebug({kind:2,sources:r,targets:a})}function mae(r,a,_){return I.attachDebugPrototypeIfDebug({kind:r,mapper1:a,mapper2:_})}function x$e(r){return kp(r,void 0)}function u7t(r,a){let _=r.inferences.slice(a);return kp(vr(_,d=>d.typeParameter),vr(_,()=>Sr))}function n2(r,a){return r?mae(4,r,a):a}function _7t(r,a){return r?mae(5,r,a):a}function vC(r,a,_){return _?mae(5,r2(r,a),_):r2(r,a)}function EL(r,a,_){return r?mae(5,r,r2(a,_)):r2(a,_)}function f7t(r){return!r.constraint&&!Cxe(r)||r.constraint===ic?r:r.restrictiveInstantiation||(r.restrictiveInstantiation=Sd(r.symbol),r.restrictiveInstantiation.constraint=ic,r.restrictiveInstantiation)}function nCe(r){let a=Sd(r.symbol);return a.target=r,a}function p7t(r,a){return Ez(r.kind,r.parameterName,r.parameterIndex,gs(r.type,a))}function PI(r,a,_){let d;if(r.typeParameters&&!_){d=vr(r.typeParameters,nCe),a=n2(kp(r.typeParameters,d),a);for(let T of d)T.mapper=a}let y=X0(r.declaration,d,r.thisParameter&&iCe(r.thisParameter,a),pae(r.parameters,a,iCe),void 0,void 0,r.minArgumentCount,r.flags&167);return y.target=r,y.mapper=a,y}function iCe(r,a){let _=as(r);if(_.type&&!yb(_.type)&&(!(r.flags&65536)||_.writeType&&!yb(_.writeType)))return r;Vc(r)&1&&(r=_.target,a=n2(_.mapper,a));let d=oo(r.flags,r.escapedName,1|Vc(r)&53256);return d.declarations=r.declarations,d.parent=r.parent,d.links.target=r,d.links.mapper=a,r.valueDeclaration&&(d.valueDeclaration=r.valueDeclaration),_.nameType&&(d.links.nameType=_.nameType),d}function d7t(r,a,_,d){let y=r.objectFlags&4||r.objectFlags&8388608?r.node:r.symbol.declarations[0],T=_i(y),P=r.objectFlags&4?T.resolvedType:r.objectFlags&64?r.target:r,L=T.outerTypeParameters;if(!L){let J=Lr(y,!0);if(Sh(y)){let ae=yze(y);J=jt(J,ae)}L=J||tt;let G=r.objectFlags&8388612?[y]:r.symbol.declarations;L=(P.objectFlags&8388612||P.symbol.flags&8192||P.symbol.flags&2048)&&!P.aliasTypeArguments?Fn(L,ae=>Tt(G,Ce=>wz(ae,Ce))):L,T.outerTypeParameters=L}if(L.length){let J=n2(r.mapper,a),G=vr(L,vt=>VS(vt,J)),ae=_||r.aliasSymbol,Ce=_?d:ov(r.aliasTypeArguments,a),be=Tm(G)+sP(ae,Ce);P.instantiations||(P.instantiations=new Map,P.instantiations.set(Tm(L)+sP(P.aliasSymbol,P.aliasTypeArguments),P));let Ye=P.instantiations.get(be);if(!Ye){let vt=kp(L,G);Ye=P.objectFlags&4?Axe(r.target,r.node,vt,ae,Ce):P.objectFlags&32?g7t(P,vt,ae,Ce):sCe(P,vt,ae,Ce),P.instantiations.set(be,Ye);let Dt=Gn(Ye);if(Ye.flags&3899393&&!(Dt&524288)){let ur=Tt(G,yb);Gn(Ye)&524288||(Dt&52?Ye.objectFlags|=524288|(ur?1048576:0):Ye.objectFlags|=ur?0:524288)}}return Ye}return r}function m7t(r){return!(r.parent.kind===183&&r.parent.typeArguments&&r===r.parent.typeName||r.parent.kind===205&&r.parent.typeArguments&&r===r.parent.qualifier)}function wz(r,a){if(r.symbol&&r.symbol.declarations&&r.symbol.declarations.length===1){let d=r.symbol.declarations[0].parent;for(let y=a;y!==d;y=y.parent)if(!y||y.kind===241||y.kind===194&&Qs(y.extendsType,_))return!0;return _(a)}return!0;function _(d){switch(d.kind){case 197:return!!r.isThisType;case 80:return!r.isThisType&&A0(d)&&m7t(d)&&b$e(d)===r;case 186:let y=d.exprName,T=Jp(y);if(!eE(T)){let P=tg(T),L=r.symbol.declarations[0],J=L.kind===168?L.parent:r.isThisType?L:void 0;if(P.declarations&&J)return Tt(P.declarations,G=>Yb(G,J))||Tt(d.typeArguments,_)}return!0;case 174:case 173:return!d.type&&!!d.body||Tt(d.typeParameters,_)||Tt(d.parameters,_)||!!d.type&&_(d.type)}return!!Qs(d,_)}}function xL(r){let a=bd(r);if(a.flags&4194304){let _=US(a.type);if(_.flags&262144)return _}}function g7t(r,a,_,d){let y=xL(r);if(y){let P=gs(y,a);if(y!==P)return kWe(Pg(P),T,_,d)}return gs(bd(r),a)===Nt?Nt:sCe(r,a,_,d);function T(P){if(P.flags&61603843&&P!==Nt&&!Xt(P)){if(!r.declaration.nameType){let L;if(Gd(P)||P.flags&1&&tP(y,4)<0&&(L=Sf(y))&&tp(L,gb))return y7t(P,r,vC(y,P,a));if(Ka(P))return h7t(P,r,y,a);if(fze(P))return Pa(vr(P.types,T))}return sCe(r,vC(y,P,a))}return P}}function C$e(r,a){return a&1?!0:a&2?!1:r}function h7t(r,a,_,d){let y=r.target.elementFlags,T=r.target.fixedLength,P=T?vC(_,r,d):d,L=vr(ZE(r),(Ce,be)=>{let Ye=y[be];return be<T?A$e(a,jf(""+be),!!(Ye&2),P):Ye&8?gs(a,vC(_,Ce,d)):Vz(gs(a,vC(_,P_(Ce),d)))??Sr}),J=s0(a),G=J&4?vr(y,Ce=>Ce&1?2:Ce):J&8?vr(y,Ce=>Ce&2?1:Ce):y,ae=C$e(r.target.readonly,s0(a));return hs(L,ht)?ht:c0(L,G,ae,r.target.labeledElementDeclarations)}function y7t(r,a,_){let d=A$e(a,It,!0,_);return Xt(d)?ht:P_(d,C$e(m4(r),s0(a)))}function A$e(r,a,_,d){let y=EL(d,Ag(r),a),T=gs(Zy(r.target||r),y),P=s0(r);return Q&&P&4&&!$c(T,49152)?$S(T,!0):Q&&P&8&&_?Em(T,524288):T}function sCe(r,a,_,d){I.assert(r.symbol,"anonymous type must have symbol to be instantiated");let y=Ud(r.objectFlags&-1572865|64,r.symbol);if(r.objectFlags&32){y.declaration=r.declaration;let T=Ag(r),P=nCe(T);y.typeParameter=P,a=n2(r2(T,P),a),P.mapper=a}return r.objectFlags&8388608&&(y.node=r.node),y.target=r,y.mapper=a,y.aliasSymbol=_||r.aliasSymbol,y.aliasTypeArguments=_?d:ov(r.aliasTypeArguments,a),y.objectFlags|=y.aliasTypeArguments?tae(y.aliasTypeArguments):0,y}function aCe(r,a,_,d,y){let T=r.root;if(T.outerTypeParameters){let P=vr(T.outerTypeParameters,G=>VS(G,a)),L=(_?"C":"")+Tm(P)+sP(d,y),J=T.instantiations.get(L);if(!J){let G=kp(T.outerTypeParameters,P),ae=T.checkType,Ce=T.isDistributive?Pg(VS(ae,G)):void 0;J=Ce&&ae!==Ce&&Ce.flags&1179648?kWe(Ce,be=>Kxe(T,vC(ae,be,G),_),d,y):Kxe(T,G,_,d,y),T.instantiations.set(L,J)}return J}return r}function gs(r,a){return r&&a?k$e(r,a,void 0,void 0):r}function k$e(r,a,_,d){var y;if(!yb(r))return r;if(N===100||k>=5e6)return(y=mn)==null||y.instant(mn.Phase.CheckTypes,"instantiateType_DepthLimit",{typeId:r.id,instantiationDepth:N,instantiationCount:k}),He(O,g.Type_instantiation_is_excessively_deep_and_possibly_infinite),ht;A++,k++,N++;let T=v7t(r,a,_,d);return N--,T}function v7t(r,a,_,d){let y=r.flags;if(y&262144)return VS(r,a);if(y&524288){let T=r.objectFlags;if(T&52){if(T&4&&!r.node){let P=r.resolvedTypeArguments,L=ov(P,a);return L!==P?Uxe(r.target,L):r}return T&1024?S7t(r,a):d7t(r,a,_,d)}return r}if(y&3145728){let T=r.flags&1048576?r.origin:void 0,P=T&&T.flags&3145728?T.types:r.types,L=ov(P,a);if(L===P&&_===r.aliasSymbol)return r;let J=_||r.aliasSymbol,G=_?d:ov(r.aliasTypeArguments,a);return y&2097152||T&&T.flags&2097152?Pa(L,J,G):pi(L,1,J,G)}if(y&4194304)return gh(gs(r.type,a));if(y&134217728)return mC(r.texts,ov(r.types,a));if(y&268435456)return aP(r.symbol,gs(r.type,a));if(y&8388608){let T=_||r.aliasSymbol,P=_?d:ov(r.aliasTypeArguments,a);return Ap(gs(r.objectType,a),gs(r.indexType,a),r.accessFlags,void 0,T,P)}if(y&16777216)return aCe(r,n2(r.mapper,a),!1,_,d);if(y&33554432){let T=gs(r.baseType,a);if(u4(r))return kxe(T);let P=gs(r.constraint,a);return T.flags&8650752&&AI(P)?Nxe(T,P):P.flags&3||Na(SC(T),SC(P))?T:T.flags&8650752?Nxe(T,P):Pa([P,T])}return r}function S7t(r,a){let _=gs(r.mappedType,a);if(!(Gn(_)&32))return r;let d=gs(r.constraintType,a);if(!(d.flags&4194304))return r;let y=sWe(gs(r.source,a),_,d);return y||r}function CL(r){return r.flags&402915327?r:r.permissiveInstantiation||(r.permissiveInstantiation=gs(r,Dc))}function SC(r){return r.flags&402915327?r:(r.restrictiveInstantiation||(r.restrictiveInstantiation=gs(r,nc),r.restrictiveInstantiation.restrictiveInstantiation=r.restrictiveInstantiation),r.restrictiveInstantiation)}function T7t(r,a){return o0(r.keyType,gs(r.type,a),r.isReadonly,r.declaration)}function $d(r){switch(I.assert(r.kind!==174||jm(r)),r.kind){case 218:case 219:case 174:case 262:return P$e(r);case 210:return Tt(r.properties,$d);case 209:return Tt(r.elements,$d);case 227:return $d(r.whenTrue)||$d(r.whenFalse);case 226:return(r.operatorToken.kind===57||r.operatorToken.kind===61)&&($d(r.left)||$d(r.right));case 303:return $d(r.initializer);case 217:return $d(r.expression);case 292:return Tt(r.properties,$d)||eh(r.parent)&&Tt(r.parent.parent.children,$d);case 291:{let{initializer:a}=r;return!!a&&$d(a)}case 294:{let{expression:a}=r;return!!a&&$d(a)}}return!1}function P$e(r){return sB(r)||b7t(r)}function b7t(r){return r.typeParameters||lm(r)||!r.body?!1:r.body.kind!==241?$d(r.body):!!$b(r.body,a=>!!a.expression&&$d(a.expression))}function gae(r){return(iE(r)||jm(r))&&P$e(r)}function N$e(r){if(r.flags&524288){let a=kg(r);if(a.constructSignatures.length||a.callSignatures.length){let _=Ud(16,r.symbol);return _.members=a.members,_.properties=a.properties,_.callSignatures=tt,_.constructSignatures=tt,_.indexInfos=tt,_}}else if(r.flags&2097152)return Pa(vr(r.types,N$e));return r}function n1(r,a){return hh(r,a,Kf)}function AL(r,a){return hh(r,a,Kf)?-1:0}function oCe(r,a){return hh(r,a,Mf)?-1:0}function E7t(r,a){return hh(r,a,Xh)?-1:0}function JS(r,a){return hh(r,a,Xh)}function Oz(r,a){return hh(r,a,jd)}function Na(r,a){return hh(r,a,Mf)}function mb(r,a){return r.flags&1048576?yr(r.types,_=>mb(_,a)):a.flags&1048576?Tt(a.types,_=>mb(r,_)):r.flags&2097152?Tt(r.types,_=>mb(_,a)):r.flags&58982400?mb(k_(r)||Sr,a):l0(a)?!!(r.flags&67633152):a===Oe?!!(r.flags&67633152)&&!l0(r):a===Bt?!!(r.flags&524288)&&UCe(r):hI(r,rv(a))||Gd(a)&&!m4(a)&&mb(r,ua)}function hae(r,a){return hh(r,a,Tp)}function Rz(r,a){return hae(r,a)||hae(a,r)}function J_(r,a,_,d,y,T){return Wd(r,a,Mf,_,d,y,T)}function qS(r,a,_,d,y,T){return cCe(r,a,Mf,_,d,y,T,void 0)}function cCe(r,a,_,d,y,T,P,L){return hh(r,a,_)?!0:!d||!kL(y,r,a,_,T,P,L)?Wd(r,a,_,d,T,P,L):!1}function D$e(r){return!!(r.flags&16777216||r.flags&2097152&&Tt(r.types,D$e))}function kL(r,a,_,d,y,T,P){if(!r||D$e(_))return!1;if(!Wd(a,_,d,void 0)&&x7t(r,a,_,d,y,T,P))return!0;switch(r.kind){case 234:if(!gS(r))break;case 294:case 217:return kL(r.expression,a,_,d,y,T,P);case 226:switch(r.operatorToken.kind){case 64:case 28:return kL(r.right,a,_,d,y,T,P)}break;case 210:return w7t(r,a,_,d,T,P);case 209:return D7t(r,a,_,d,T,P);case 292:return N7t(r,a,_,d,T,P);case 219:return C7t(r,a,_,d,T,P)}return!1}function x7t(r,a,_,d,y,T,P){let L=na(a,0),J=na(a,1);for(let G of[J,L])if(Tt(G,ae=>{let Ce=Ao(ae);return!(Ce.flags&131073)&&Wd(Ce,_,d,void 0)})){let ae=P||{};J_(a,_,r,y,T,ae);let Ce=ae.errors[ae.errors.length-1];return Ga(Ce,$n(r,G===J?g.Did_you_mean_to_use_new_with_this_expression:g.Did_you_mean_to_call_this_expression)),!0}return!1}function C7t(r,a,_,d,y,T){if(ra(r.body)||Tt(r.parameters,L9))return!1;let P=NC(a);if(!P)return!1;let L=na(_,0);if(!de(L))return!1;let J=r.body,G=Ao(P),ae=pi(vr(L,Ao));if(!Wd(G,ae,d,void 0)){let Ce=J&&kL(J,G,ae,d,void 0,y,T);if(Ce)return Ce;let be=T||{};if(Wd(G,ae,d,J,void 0,y,be),be.errors)return _.symbol&&de(_.symbol.declarations)&&Ga(be.errors[be.errors.length-1],$n(_.symbol.declarations[0],g.The_expected_type_comes_from_the_return_type_of_this_signature)),!(vu(r)&2)&&!Xe(G,"then")&&Wd(m$(G),ae,d,void 0)&&Ga(be.errors[be.errors.length-1],$n(r,g.Did_you_mean_to_mark_this_function_as_async)),!0}return!1}function I$e(r,a,_){let d=BS(a,_);if(d)return d;if(a.flags&1048576){let y=B$e(r,a);if(y)return BS(y,_)}}function w$e(r,a){Zz(r,a,!1);let _=k4(r,1);return FL(),_}function Mz(r,a,_,d,y,T){let P=!1;for(let L of r){let{errorNode:J,innerExpression:G,nameType:ae,errorMessage:Ce}=L,be=I$e(a,_,ae);if(!be||be.flags&8388608)continue;let Ye=BS(a,ae);if(!Ye)continue;let vt=oae(ae,void 0);if(!Wd(Ye,be,d,void 0)){let Dt=G&&kL(G,Ye,be,d,void 0,y,T);if(P=!0,!Dt){let ur=T||{},pr=G?w$e(G,Ye):Ye;if(Ie&&vae(pr,be)){let dn=$n(J,g.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target,Kr(pr),Kr(be));fo.add(dn),ur.errors=[dn]}else{let dn=!!(vt&&(ka(_,vt)||dt).flags&16777216),Ur=!!(vt&&(ka(a,vt)||dt).flags&16777216);be=WS(be,dn),Ye=WS(Ye,dn&&Ur),Wd(pr,be,d,J,Ce,y,ur)&&pr!==Ye&&Wd(Ye,be,d,J,Ce,y,ur)}if(ur.errors){let dn=ur.errors[ur.errors.length-1],Ur=um(ae)?_m(ae):void 0,fr=Ur!==void 0?ka(_,Ur):void 0,$r=!1;if(!fr){let Jr=mL(_,ae);Jr&&Jr.declaration&&!Xr(Jr.declaration).hasNoDefaultLib&&($r=!0,Ga(dn,$n(Jr.declaration,g.The_expected_type_comes_from_this_index_signature)))}if(!$r&&(fr&&de(fr.declarations)||_.symbol&&de(_.symbol.declarations))){let Jr=fr&&de(fr.declarations)?fr.declarations[0]:_.symbol.declarations[0];Xr(Jr).hasNoDefaultLib||Ga(dn,$n(Jr,g.The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1,Ur&&!(ae.flags&8192)?Zi(Ur):Kr(ae),Kr(_)))}}}}}return P}function A7t(r,a,_,d,y,T){let P=wl(_,Aae),L=wl(_,ae=>!Aae(ae)),J=L!==Qn?ike(13,0,L,void 0):void 0,G=!1;for(let ae=r.next();!ae.done;ae=r.next()){let{errorNode:Ce,innerExpression:be,nameType:Ye,errorMessage:vt}=ae.value,Dt=J,ur=P!==Qn?I$e(a,P,Ye):void 0;if(ur&&!(ur.flags&8388608)&&(Dt=J?pi([J,ur]):ur),!Dt)continue;let pr=BS(a,Ye);if(!pr)continue;let dn=oae(Ye,void 0);if(!Wd(pr,Dt,d,void 0)){let Ur=be&&kL(be,pr,Dt,d,void 0,y,T);if(G=!0,!Ur){let fr=T||{},$r=be?w$e(be,pr):pr;if(Ie&&vae($r,Dt)){let Jr=$n(Ce,g.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target,Kr($r),Kr(Dt));fo.add(Jr),fr.errors=[Jr]}else{let Jr=!!(dn&&(ka(P,dn)||dt).flags&16777216),on=!!(dn&&(ka(a,dn)||dt).flags&16777216);Dt=WS(Dt,Jr),pr=WS(pr,Jr&&on),Wd($r,Dt,d,Ce,vt,y,fr)&&$r!==pr&&Wd(pr,Dt,d,Ce,vt,y,fr)}}}}return G}function*k7t(r){if(de(r.properties))for(let a of r.properties)ik(a)||oAe(dR(a.name))||(yield{errorNode:a.name,innerExpression:a.initializer,nameType:jf(dR(a.name))})}function*P7t(r,a){if(!de(r.children))return;let _=0;for(let d=0;d<r.children.length;d++){let y=r.children[d],T=Ng(d-_),P=O$e(y,T,a);P?yield P:_++}}function O$e(r,a,_){switch(r.kind){case 294:return{errorNode:r,innerExpression:r.expression,nameType:a};case 12:if(r.containsOnlyTriviaWhiteSpaces)break;return{errorNode:r,innerExpression:void 0,nameType:a,errorMessage:_()};case 284:case 285:case 288:return{errorNode:r,innerExpression:r,nameType:a};default:return I.assertNever(r,"Found invalid jsx child")}}function N7t(r,a,_,d,y,T){let P=Mz(k7t(r),a,_,d,y,T),L;if(eh(r.parent)&&L0(r.parent.parent)){let G=r.parent.parent,ae=t$(kC(r)),Ce=ae===void 0?"children":Zi(ae),be=jf(Ce),Ye=Ap(_,be),vt=bN(G.children);if(!de(vt))return P;let Dt=de(vt)>1,ur,pr;if(Lxe(!1)!==$s){let Ur=zze(W);ur=wl(Ye,fr=>Na(fr,Ur)),pr=wl(Ye,fr=>!Na(fr,Ur))}else ur=wl(Ye,Aae),pr=wl(Ye,Ur=>!Aae(Ur));if(Dt){if(ur!==Qn){let Ur=c0(Qae(G,0)),fr=P7t(G,J);P=A7t(fr,Ur,ur,d,y,T)||P}else if(!hh(Ap(a,be),Ye,d)){P=!0;let Ur=He(G.openingElement.tagName,g.This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided,Ce,Kr(Ye));T&&T.skipLogging&&(T.errors||(T.errors=[])).push(Ur)}}else if(pr!==Qn){let Ur=vt[0],fr=O$e(Ur,be,J);fr&&(P=Mz(function*(){yield fr}(),a,_,d,y,T)||P)}else if(!hh(Ap(a,be),Ye,d)){P=!0;let Ur=He(G.openingElement.tagName,g.This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided,Ce,Kr(Ye));T&&T.skipLogging&&(T.errors||(T.errors=[])).push(Ur)}}return P;function J(){if(!L){let G=Fl(r.parent.tagName),ae=t$(kC(r)),Ce=ae===void 0?"children":Zi(ae),be=Ap(_,jf(Ce)),Ye=g._0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2;L={...Ye,key:"!!ALREADY FORMATTED!!",message:LX(Ye,G,Ce,Kr(be))}}return L}}function*R$e(r,a){let _=de(r.elements);if(_)for(let d=0;d<_;d++){if(g4(a)&&!ka(a,""+d))continue;let y=r.elements[d];if(Su(y))continue;let T=Ng(d),P=ooe(y);yield{errorNode:P,innerExpression:P,nameType:T}}}function D7t(r,a,_,d,y,T){if(_.flags&402915324)return!1;if(g4(a))return Mz(R$e(r,_),a,_,d,y,T);Zz(r,_,!1);let P=rGe(r,1,!0);return FL(),g4(P)?Mz(R$e(r,_),P,_,d,y,T):!1}function*I7t(r){if(de(r.properties))for(let a of r.properties){if(F1(a))continue;let _=CI(Rn(a),8576);if(!(!_||_.flags&131072))switch(a.kind){case 178:case 177:case 174:case 304:yield{errorNode:a.name,innerExpression:void 0,nameType:_};break;case 303:yield{errorNode:a.name,innerExpression:a.initializer,nameType:_,errorMessage:h8(a.name)?g.Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1:void 0};break;default:I.assertNever(a)}}}function w7t(r,a,_,d,y,T){return _.flags&402915324?!1:Mz(I7t(r),a,_,d,y,T)}function M$e(r,a,_,d,y){return Wd(r,a,Tp,_,d,y)}function O7t(r,a,_){return lCe(r,a,_?4:0,!1,void 0,void 0,oCe,void 0)!==0}function yae(r){if(!r.typeParameters&&(!r.thisParameter||wt(f$(r.thisParameter)))&&r.parameters.length===1&&L_(r)){let a=f$(r.parameters[0]);return!!((Gd(a)?cc(a)[0]:a).flags&131073&&Ao(r).flags&3)}return!1}function lCe(r,a,_,d,y,T,P,L){if(r===a||!(_&16&&yae(r))&&yae(a))return-1;if(_&16&&yae(r)&&!yae(a))return 0;let J=Xp(a);if(!u0(a)&&(_&8?u0(r)||Xp(r)>J:Th(r)>J))return d&&!(_&8)&&y(g.Target_signature_provides_too_few_arguments_Expected_0_or_more_but_got_1,Th(r),J),0;r.typeParameters&&r.typeParameters!==a.typeParameters&&(a=RRt(a),r=RGe(r,a,void 0,P));let ae=Xp(r),Ce=VL(r),be=VL(a);(Ce||be)&&gs(Ce||be,L);let Ye=a.declaration?a.declaration.kind:0,vt=!(_&3)&&ce&&Ye!==174&&Ye!==173&&Ye!==176,Dt=-1,ur=fb(r);if(ur&&ur!==fn){let Ur=fb(a);if(Ur){let fr=!vt&&P(ur,Ur,!1)||P(Ur,ur,d);if(!fr)return d&&y(g.The_this_types_of_each_signature_are_incompatible),0;Dt&=fr}}let pr=Ce||be?Math.min(ae,J):Math.max(ae,J),dn=Ce||be?pr-1:-1;for(let Ur=0;Ur<pr;Ur++){let fr=Ur===dn?iHe(r,Ur):c2(r,Ur),$r=Ur===dn?iHe(a,Ur):c2(a,Ur);if(fr&&$r){let Jr=_&3||wGe(r,Ur)?void 0:NC(a1(fr)),on=_&3||wGe(a,Ur)?void 0:NC(a1($r)),cn=Jr&&on&&!zd(Jr)&&!zd(on)&&v4(fr,50331648)===v4($r,50331648)?lCe(on,Jr,_&8|(vt?2:1),d,y,T,P,L):!(_&3)&&!vt&&P(fr,$r,!1)||P($r,fr,d);if(cn&&_&8&&Ur>=Th(r)&&Ur<Th(a)&&P(fr,$r,!1)&&(cn=0),!cn)return d&&y(g.Types_of_parameters_0_and_1_are_incompatible,Zi(x4(r,Ur)),Zi(x4(a,Ur))),0;Dt&=cn}}if(!(_&4)){let Ur=Kse(a)?W:a.declaration&&Sh(a.declaration)?qd(mo(a.declaration.symbol)):Ao(a);if(Ur===fn||Ur===W)return Dt;let fr=Kse(r)?W:r.declaration&&Sh(r.declaration)?qd(mo(r.declaration.symbol)):Ao(r),$r=zd(a);if($r){let Jr=zd(r);if(Jr)Dt&=R7t(Jr,$r,d,y,P);else if(gde($r))return d&&y(g.Signature_0_must_be_a_type_predicate,t0(r)),0}else Dt&=_&1&&P(Ur,fr,!1)||P(fr,Ur,d),!Dt&&d&&T&&T(fr,Ur)}return Dt}function R7t(r,a,_,d,y){if(r.kind!==a.kind)return _&&(d(g.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard),d(g.Type_predicate_0_is_not_assignable_to_1,r0(r),r0(a))),0;if((r.kind===1||r.kind===3)&&r.parameterIndex!==a.parameterIndex)return _&&(d(g.Parameter_0_is_not_in_the_same_position_as_parameter_1,r.parameterName,a.parameterName),d(g.Type_predicate_0_is_not_assignable_to_1,r0(r),r0(a))),0;let T=r.type===a.type?-1:r.type&&a.type?y(r.type,a.type,_):0;return T===0&&_&&d(g.Type_predicate_0_is_not_assignable_to_1,r0(r),r0(a)),T}function M7t(r,a){let _=yL(r),d=yL(a),y=Ao(_),T=Ao(d);return T===fn||hh(T,y,Mf)||hh(y,T,Mf)?O7t(_,d,!0):!1}function uCe(r){return r!==cr&&r.properties.length===0&&r.callSignatures.length===0&&r.constructSignatures.length===0&&r.indexInfos.length===0}function i1(r){return r.flags&524288?!Ff(r)&&uCe(kg(r)):r.flags&67108864?!0:r.flags&1048576?Tt(r.types,i1):r.flags&2097152?yr(r.types,i1):!1}function l0(r){return!!(Gn(r)&16&&(r.members&&uCe(r)||r.symbol&&r.symbol.flags&2048&&MS(r.symbol).size===0))}function L7t(r){if(Q&&r.flags&1048576){if(!(r.objectFlags&33554432)){let a=r.types;r.objectFlags|=33554432|(a.length>=3&&a[0].flags&32768&&a[1].flags&65536&&Tt(a,l0)?67108864:0)}return!!(r.objectFlags&67108864)}return!1}function p4(r){return!!((r.flags&1048576?r.types[0]:r).flags&32768)}function L$e(r){return r.flags&524288&&!Ff(r)&&Io(r).length===0&&nf(r).length===1&&!!K0(r,Le)||r.flags&3145728&&yr(r.types,L$e)||!1}function _Ce(r,a,_){let d=r.flags&8?yf(r):r,y=a.flags&8?yf(a):a;if(d===y)return!0;if(d.escapedName!==y.escapedName||!(d.flags&256)||!(y.flags&256))return!1;let T=Ia(d)+","+Ia(y),P=Y1.get(T);if(P!==void 0&&!(!(P&4)&&P&2&&_))return!!(P&1);let L=vn(y);for(let J of Io(vn(d)))if(J.flags&8){let G=ka(L,J.escapedName);if(!G||!(G.flags&8))return _?(_(g.Property_0_is_missing_in_type_1,Lc(J),Kr(dc(y),void 0,64)),Y1.set(T,6)):Y1.set(T,2),!1;let ae=BI(xc(J,306)),Ce=BI(xc(G,306));if(ae!==Ce){let be=typeof ae=="string",Ye=typeof Ce=="string";if(ae!==void 0&&Ce!==void 0){if(!_)Y1.set(T,2);else{let vt=be?`"${D0(ae)}"`:ae,Dt=Ye?`"${D0(Ce)}"`:Ce;_(g.Each_declaration_of_0_1_differs_in_its_value_where_2_was_expected_but_3_was_given,Lc(y),Lc(G),Dt,vt),Y1.set(T,6)}return!1}if(be||Ye){if(!_)Y1.set(T,2);else{let vt=ae??Ce;I.assert(typeof vt=="string");let Dt=`"${D0(vt)}"`;_(g.One_value_of_0_1_is_the_string_2_and_the_other_is_assumed_to_be_an_unknown_numeric_value,Lc(y),Lc(G),Dt),Y1.set(T,6)}return!1}}}return Y1.set(T,1),!0}function PL(r,a,_,d){let y=r.flags,T=a.flags;return T&1||y&131072||r===Nt||T&2&&!(_===jd&&y&1)?!0:T&131072?!1:!!(y&402653316&&T&4||y&128&&y&1024&&T&128&&!(T&1024)&&r.value===a.value||y&296&&T&8||y&256&&y&1024&&T&256&&!(T&1024)&&r.value===a.value||y&2112&&T&64||y&528&&T&16||y&12288&&T&4096||y&32&&T&32&&r.symbol.escapedName===a.symbol.escapedName&&_Ce(r.symbol,a.symbol,d)||y&1024&&T&1024&&(y&1048576&&T&1048576&&_Ce(r.symbol,a.symbol,d)||y&2944&&T&2944&&r.value===a.value&&_Ce(r.symbol,a.symbol,d))||y&32768&&(!Q&&!(T&3145728)||T&49152)||y&65536&&(!Q&&!(T&3145728)||T&65536)||y&524288&&T&67108864&&!(_===jd&&l0(r)&&!(Gn(r)&8192))||(_===Mf||_===Tp)&&(y&1||y&8&&(T&32||T&256&&T&1024)||y&256&&!(y&1024)&&(T&32||T&256&&T&1024&&r.value===a.value)||L7t(a)))}function hh(r,a,_){if(t2(r)&&(r=r.regularType),t2(a)&&(a=a.regularType),r===a)return!0;if(_!==Kf){if(_===Tp&&!(a.flags&131072)&&PL(a,r,_)||PL(r,a,_))return!0}else if(!((r.flags|a.flags)&61865984)){if(r.flags!==a.flags)return!1;if(r.flags&67358815)return!0}if(r.flags&524288&&a.flags&524288){let d=_.get(bae(r,a,0,_,!1));if(d!==void 0)return!!(d&1)}return r.flags&469499904||a.flags&469499904?Wd(r,a,_,void 0):!1}function F$e(r,a){return Gn(r)&2048&&oAe(a.escapedName)}function Lz(r,a){for(;;){let _=t2(r)?r.regularType:zS(r)?j7t(r,a):Gn(r)&4?r.node?iv(r.target,cc(r)):yCe(r)||r:r.flags&3145728?F7t(r,a):r.flags&33554432?a?r.baseType:Dxe(r):r.flags&25165824?r1(r,a):r;if(_===r)return _;r=_}}function F7t(r,a){let _=Pg(r);if(_!==r)return _;if(r.flags&2097152&&Tt(r.types,l0)){let d=ul(r.types,y=>Lz(y,a));if(d!==r.types)return Pa(d)}return r}function j7t(r,a){let _=ZE(r),d=ul(_,y=>y.flags&25165824?r1(y,a):y);return _!==d?Vxe(r.target,d):r}function Wd(r,a,_,d,y,T,P){var L;let J,G,ae,Ce,be,Ye,vt=0,Dt=0,ur=0,pr=0,dn=!1,Ur=0,fr=0,$r,Jr,on=16e6-_.size>>3;I.assert(_!==Kf||!d,"no error reporting in identity checking");let Qr=Pn(r,a,3,!!d,y);if(Jr&&Ys(),dn){let it=bae(r,a,0,_,!1);_.set(it,6),(L=mn)==null||L.instant(mn.Phase.CheckTypes,"checkTypeRelatedTo_DepthLimit",{sourceId:r.id,targetId:a.id,depth:Dt,targetDepth:ur});let xt=on<=0?g.Excessive_complexity_comparing_types_0_and_1:g.Excessive_stack_depth_comparing_types_0_and_1,ir=He(d||O,xt,Kr(r),Kr(a));P&&(P.errors||(P.errors=[])).push(ir)}else if(J){if(T){let ir=T();ir&&(bme(ir,J),J=ir)}let it;if(y&&d&&!Qr&&r.symbol){let ir=as(r.symbol);if(ir.originatingImport&&!Up(ir.originatingImport)&&Wd(vn(ir.target),a,_,void 0)){let jn=$n(ir.originatingImport,g.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead);it=Pr(it,jn)}}let xt=Ey(Xr(d),d,J,it);G&&Ga(xt,...G),P&&(P.errors||(P.errors=[])).push(xt),(!P||!P.skipLogging)&&fo.add(xt)}return d&&P&&P.skipLogging&&Qr===0&&I.assert(!!P.errors,"missed opportunity to interact with error."),Qr!==0;function cn(it){J=it.errorInfo,$r=it.lastSkippedInfo,Jr=it.incompatibleStack,Ur=it.overrideNextErrorInfo,fr=it.skipParentCounter,G=it.relatedInfo}function Bs(){return{errorInfo:J,lastSkippedInfo:$r,incompatibleStack:Jr?.slice(),overrideNextErrorInfo:Ur,skipParentCounter:fr,relatedInfo:G?.slice()}}function Os(it,...xt){Ur++,$r=void 0,(Jr||(Jr=[])).push([it,...xt])}function Ys(){let it=Jr||[];Jr=void 0;let xt=$r;if($r=void 0,it.length===1){As(...it[0]),xt&&rp(void 0,...xt);return}let ir="",tn=[];for(;it.length;){let[jn,...Dr]=it.pop();switch(jn.code){case g.Types_of_property_0_are_incompatible.code:{ir.indexOf("new ")===0&&(ir=`(${ir})`);let An=""+Dr[0];ir.length===0?ir=`${An}`:nd(An,ho($))?ir=`${ir}.${An}`:An[0]==="["&&An[An.length-1]==="]"?ir=`${ir}${An}`:ir=`${ir}[${An}]`;break}case g.Call_signature_return_types_0_and_1_are_incompatible.code:case g.Construct_signature_return_types_0_and_1_are_incompatible.code:case g.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code:case g.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code:{if(ir.length===0){let An=jn;jn.code===g.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code?An=g.Call_signature_return_types_0_and_1_are_incompatible:jn.code===g.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code&&(An=g.Construct_signature_return_types_0_and_1_are_incompatible),tn.unshift([An,Dr[0],Dr[1]])}else{let An=jn.code===g.Construct_signature_return_types_0_and_1_are_incompatible.code||jn.code===g.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code?"new ":"",ti=jn.code===g.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code||jn.code===g.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code?"":"...";ir=`${An}${ir}(${ti})`}break}case g.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target.code:{tn.unshift([g.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target,Dr[0],Dr[1]]);break}case g.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target.code:{tn.unshift([g.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target,Dr[0],Dr[1],Dr[2]]);break}default:return I.fail(`Unhandled Diagnostic: ${jn.code}`)}}ir?As(ir[ir.length-1]===")"?g.The_types_returned_by_0_are_incompatible_between_these_types:g.The_types_of_0_are_incompatible_between_these_types,ir):tn.shift();for(let[jn,...Dr]of tn){let An=jn.elidedInCompatabilityPyramid;jn.elidedInCompatabilityPyramid=!1,As(jn,...Dr),jn.elidedInCompatabilityPyramid=An}xt&&rp(void 0,...xt)}function As(it,...xt){I.assert(!!d),Jr&&Ys(),!it.elidedInCompatabilityPyramid&&(fr===0?J=Xs(J,it,...xt):fr--)}function su(it,...xt){As(it,...xt),fr++}function Hd(it){I.assert(!!J),G?G.push(it):G=[it]}function rp(it,xt,ir){Jr&&Ys();let[tn,jn]=eP(xt,ir),Dr=xt,An=tn;if(NL(xt)&&!fCe(ir)&&(Dr=s1(xt),I.assert(!Na(Dr,ir),"generalized source shouldn't be assignable"),An=AS(Dr)),(ir.flags&8388608&&!(xt.flags&8388608)?ir.objectType.flags:ir.flags)&262144&&ir!==ge&&ir!==ne){let Xi=k_(ir),Hs;Xi&&(Na(Dr,Xi)||(Hs=Na(xt,Xi)))?As(g._0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2,Hs?tn:An,jn,Kr(Xi)):(J=void 0,As(g._0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1,jn,An))}if(it)it===g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1&&Ie&&j$e(xt,ir).length&&(it=g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties);else if(_===Tp)it=g.Type_0_is_not_comparable_to_type_1;else if(tn===jn)it=g.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated;else if(Ie&&j$e(xt,ir).length)it=g.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties;else{if(xt.flags&128&&ir.flags&1048576){let Xi=G5t(xt,ir);if(Xi){As(g.Type_0_is_not_assignable_to_type_1_Did_you_mean_2,An,jn,Kr(Xi));return}}it=g.Type_0_is_not_assignable_to_type_1}As(it,An,jn)}function Br(it,xt){let ir=kS(it.symbol)?Kr(it,it.symbol.valueDeclaration):Kr(it),tn=kS(xt.symbol)?Kr(xt,xt.symbol.valueDeclaration):Kr(xt);(Tl===it&&Le===xt||ql===it&&It===xt||bc===it&&Pi===xt||Bze()===it&&Fi===xt)&&As(g._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible,tn,ir)}function an(it,xt,ir){return Ka(it)?it.target.readonly&&Uz(xt)?(ir&&As(g.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1,Kr(it),Kr(xt)),!1):gb(xt):m4(it)&&Uz(xt)?(ir&&As(g.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1,Kr(it),Kr(xt)),!1):Ka(xt)?Gd(it):!0}function ms(it,xt,ir){return Pn(it,xt,3,ir)}function Pn(it,xt,ir=3,tn=!1,jn,Dr=0){if(it===xt)return-1;if(it.flags&524288&&xt.flags&402784252)return _===Tp&&!(xt.flags&131072)&&PL(xt,it,_)||PL(it,xt,_,tn?As:void 0)?-1:(tn&&Vs(it,xt,it,xt,jn),0);let An=Lz(it,!1),ti=Lz(xt,!0);if(An===ti)return-1;if(_===Kf)return An.flags!==ti.flags?0:An.flags&67358815?-1:(vo(An,ti),Mi(An,ti,!1,0,ir));if(An.flags&262144&&_C(An)===ti)return-1;if(An.flags&470302716&&ti.flags&1048576){let Xi=ti.types,Hs=Xi.length===2&&Xi[0].flags&98304?Xi[1]:Xi.length===3&&Xi[0].flags&98304&&Xi[1].flags&98304?Xi[2]:void 0;if(Hs&&!(Hs.flags&98304)&&(ti=Lz(Hs,!0),An===ti))return-1}if(_===Tp&&!(ti.flags&131072)&&PL(ti,An,_)||PL(An,ti,_,tn?As:void 0))return-1;if(An.flags&469499904||ti.flags&469499904){if(!(Dr&2)&&vb(An)&&Gn(An)&8192&&N_(An,ti,tn))return tn&&rp(jn,An,xt.aliasSymbol?xt:ti),0;let Hs=(_!==Tp||Dg(An))&&!(Dr&2)&&An.flags&405405692&&An!==Oe&&ti.flags&2621440&&U$e(ti)&&(Io(An).length>0||woe(An)),ba=!!(Gn(An)&2048);if(Hs&&!U7t(An,ti,ba)){if(tn){let Ws=Kr(it.aliasSymbol?it:An),La=Kr(xt.aliasSymbol?xt:ti),$o=na(An,0),ko=na(An,1);$o.length>0&&Pn(Ao($o[0]),ti,1,!1)||ko.length>0&&Pn(Ao(ko[0]),ti,1,!1)?As(g.Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it,Ws,La):As(g.Type_0_has_no_properties_in_common_with_type_1,Ws,La)}return 0}vo(An,ti);let wi=An.flags&1048576&&An.types.length<4&&!(ti.flags&1048576)||ti.flags&1048576&&ti.types.length<4&&!(An.flags&469499904)?bf(An,ti,tn,Dr):Mi(An,ti,tn,Dr,ir);if(wi)return wi}return tn&&Vs(it,xt,An,ti,jn),0}function Vs(it,xt,ir,tn,jn){var Dr,An;let ti=!!yCe(it),Xi=!!yCe(xt);ir=it.aliasSymbol||ti?it:ir,tn=xt.aliasSymbol||Xi?xt:tn;let Hs=Ur>0;if(Hs&&Ur--,ir.flags&524288&&tn.flags&524288){let ba=J;an(ir,tn,!0),J!==ba&&(Hs=!!J)}if(ir.flags&524288&&tn.flags&402784252)Br(ir,tn);else if(ir.symbol&&ir.flags&524288&&Oe===ir)As(g.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);else if(Gn(ir)&2048&&tn.flags&2097152){let ba=tn.types,Ea=o2(cd.IntrinsicAttributes,d),wi=o2(cd.IntrinsicClassAttributes,d);if(!Xt(Ea)&&!Xt(wi)&&(hs(ba,Ea)||hs(ba,wi)))return}else J=mxe(J,xt);if(!jn&&Hs){$r=[ir,tn];return}if(rp(jn,ir,tn),ir.flags&262144&&((An=(Dr=ir.symbol)==null?void 0:Dr.declarations)!=null&&An[0])&&!_C(ir)){let ba=nCe(ir);if(ba.constraint=gs(tn,r2(ir,ba)),Sz(ba)){let Ea=Kr(tn,ir.symbol.declarations[0]);Hd($n(ir.symbol.declarations[0],g.This_type_parameter_might_need_an_extends_0_constraint,Ea))}}}function vo(it,xt){if(mn&&it.flags&3145728&&xt.flags&3145728){let ir=it,tn=xt;if(ir.objectFlags&tn.objectFlags&32768)return;let jn=ir.types.length,Dr=tn.types.length;jn*Dr>1e6&&mn.instant(mn.Phase.CheckTypes,"traceUnionsOrIntersectionsTooLarge_DepthLimit",{sourceId:it.id,sourceSize:jn,targetId:xt.id,targetSize:Dr,pos:d?.pos,end:d?.end})}}function Bo(it,xt){return pi(d_(it,(tn,jn)=>{var Dr;jn=Tf(jn);let An=jn.flags&3145728?Tz(jn,xt):ub(jn,xt),ti=An&&vn(An)||((Dr=iP(jn,xt))==null?void 0:Dr.type)||Be;return Pr(tn,ti)},void 0)||tt)}function N_(it,xt,ir){var tn;if(!n$(xt)||!ve&&Gn(xt)&4096)return!1;let jn=!!(Gn(it)&2048);if((_===Mf||_===Tp)&&(S4(Oe,xt)||!jn&&i1(xt)))return!1;let Dr=xt,An;xt.flags&1048576&&(Dr=nXe(it,xt,Pn)||XJt(xt),An=Dr.flags&1048576?Dr.types:[Dr]);for(let ti of Io(it))if(Qa(ti,it.symbol)&&!F$e(it,ti)){if(!uAe(Dr,ti.escapedName,jn)){if(ir){let Xi=wl(Dr,n$);if(!d)return I.fail();if(dE(d)||H_(d)||H_(d.parent)){ti.valueDeclaration&&th(ti.valueDeclaration)&&Xr(d)===Xr(ti.valueDeclaration.name)&&(d=ti.valueDeclaration.name);let Hs=Oi(ti),ba=AGe(Hs,Xi),Ea=ba?Oi(ba):void 0;Ea?As(g.Property_0_does_not_exist_on_type_1_Did_you_mean_2,Hs,Kr(Xi),Ea):As(g.Property_0_does_not_exist_on_type_1,Hs,Kr(Xi))}else{let Hs=((tn=it.symbol)==null?void 0:tn.declarations)&&qi(it.symbol.declarations),ba;if(ti.valueDeclaration&&Gr(ti.valueDeclaration,Ea=>Ea===Hs)&&Xr(Hs)===Xr(d)){let Ea=ti.valueDeclaration;I.assertNode(Ea,by);let wi=Ea.name;d=wi,ze(wi)&&(ba=vAe(wi,Xi))}ba!==void 0?su(g.Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2,Oi(ti),Kr(Xi),ba):su(g.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1,Oi(ti),Kr(Xi))}}return!0}if(An&&!Pn(vn(ti),Bo(An,ti.escapedName),3,ir))return ir&&Os(g.Types_of_property_0_are_incompatible,Oi(ti)),!0}return!1}function Qa(it,xt){return it.valueDeclaration&&xt.valueDeclaration&&it.valueDeclaration.parent===xt.valueDeclaration}function bf(it,xt,ir,tn){if(it.flags&1048576){if(xt.flags&1048576){let jn=it.origin;if(jn&&jn.flags&2097152&&xt.aliasSymbol&&hs(jn.types,xt))return-1;let Dr=xt.origin;if(Dr&&Dr.flags&1048576&&it.aliasSymbol&&hs(Dr.types,it))return-1}return _===Tp?Ne(it,xt,ir&&!(it.flags&402784252),tn):Vn(it,xt,ir&&!(it.flags&402784252),tn)}if(xt.flags&1048576)return Oc(wL(it),xt,ir&&!(it.flags&402784252)&&!(xt.flags&402784252),tn);if(xt.flags&2097152)return _t(it,xt,ir,2);if(_===Tp&&xt.flags&402784252){let jn=ul(it.types,Dr=>Dr.flags&465829888?k_(Dr)||Sr:Dr);if(jn!==it.types){if(it=Pa(jn),it.flags&131072)return 0;if(!(it.flags&2097152))return Pn(it,xt,1,!1)||Pn(xt,it,1,!1)}}return Ne(it,xt,!1,1)}function el(it,xt){let ir=-1,tn=it.types;for(let jn of tn){let Dr=Oc(jn,xt,!1,0);if(!Dr)return 0;ir&=Dr}return ir}function Oc(it,xt,ir,tn){let jn=xt.types;if(xt.flags&1048576){if(t1(jn,it))return-1;if(_!==Tp&&Gn(xt)&32768&&!(it.flags&1024)&&(it.flags&2688||(_===Xh||_===jd)&&it.flags&256)){let An=it===it.regularType?it.freshType:it.regularType,ti=it.flags&128?Le:it.flags&256?It:it.flags&2048?Rt:void 0;return ti&&t1(jn,ti)||An&&t1(jn,An)?-1:0}let Dr=mWe(xt,it);if(Dr){let An=Pn(it,Dr,2,!1,void 0,tn);if(An)return An}}for(let Dr of jn){let An=Pn(it,Dr,2,!1,void 0,tn);if(An)return An}if(ir){let Dr=B$e(it,xt,Pn);Dr&&Pn(it,Dr,2,!0,void 0,tn)}return 0}function _t(it,xt,ir,tn){let jn=-1,Dr=xt.types;for(let An of Dr){let ti=Pn(it,An,2,ir,void 0,tn);if(!ti)return 0;jn&=ti}return jn}function Ne(it,xt,ir,tn){let jn=it.types;if(it.flags&1048576&&t1(jn,xt))return-1;let Dr=jn.length;for(let An=0;An<Dr;An++){let ti=Pn(jn[An],xt,1,ir&&An===Dr-1,void 0,tn);if(ti)return ti}return 0}function jr(it,xt){return it.flags&1048576&&xt.flags&1048576&&!(it.types[0].flags&32768)&&xt.types[0].flags&32768?T4(xt,-32769):xt}function Vn(it,xt,ir,tn){let jn=-1,Dr=it.types,An=jr(it,xt);for(let ti=0;ti<Dr.length;ti++){let Xi=Dr[ti];if(An.flags&1048576&&Dr.length>=An.types.length&&Dr.length%An.types.length===0){let ba=Pn(Xi,An.types[ti%An.types.length],3,!1,void 0,tn);if(ba){jn&=ba;continue}}let Hs=Pn(Xi,xt,1,ir,void 0,tn);if(!Hs)return 0;jn&=Hs}return jn}function bi(it=tt,xt=tt,ir=tt,tn,jn){if(it.length!==xt.length&&_===Kf)return 0;let Dr=it.length<=xt.length?it.length:xt.length,An=-1;for(let ti=0;ti<Dr;ti++){let Xi=ti<ir.length?ir[ti]:1,Hs=Xi&7;if(Hs!==4){let ba=it[ti],Ea=xt[ti],wi=-1;if(Xi&8?wi=_===Kf?Pn(ba,Ea,3,!1):AL(ba,Ea):Hs===1?wi=Pn(ba,Ea,3,tn,void 0,jn):Hs===2?wi=Pn(Ea,ba,3,tn,void 0,jn):Hs===3?(wi=Pn(Ea,ba,3,!1),wi||(wi=Pn(ba,Ea,3,tn,void 0,jn))):(wi=Pn(ba,Ea,3,tn,void 0,jn),wi&&(wi&=Pn(Ea,ba,3,tn,void 0,jn))),!wi)return 0;An&=wi}}return An}function Mi(it,xt,ir,tn,jn){var Dr,An,ti;if(dn)return 0;let Xi=bae(it,xt,tn,_,!1),Hs=_.get(Xi);if(Hs!==void 0&&!(ir&&Hs&2&&!(Hs&4))){if(ya){let ko=Hs&24;ko&8&&gs(it,Uo),ko&16&&gs(it,$u)}return Hs&1?-1:0}if(on<=0)return dn=!0,0;if(!ae)ae=[],Ce=new Set,be=[],Ye=[];else{if(Ce.has(Xi))return 3;let ko=Xi.startsWith("*")?bae(it,xt,tn,_,!0):void 0;if(ko&&Ce.has(ko))return 3;if(Dt===100||ur===100)return dn=!0,0}let ba=vt;ae[vt]=Xi,Ce.add(Xi),vt++;let Ea=pr;jn&1&&(be[Dt]=it,Dt++,!(pr&1)&&d4(it,be,Dt)&&(pr|=1)),jn&2&&(Ye[ur]=xt,ur++,!(pr&2)&&d4(xt,Ye,ur)&&(pr|=2));let wi,Ws=0;ya&&(wi=ya,ya=ko=>(Ws|=ko?16:8,wi(ko)));let La;return pr===3?((Dr=mn)==null||Dr.instant(mn.Phase.CheckTypes,"recursiveTypeRelatedTo_DepthLimit",{sourceId:it.id,sourceIdStack:be.map(ko=>ko.id),targetId:xt.id,targetIdStack:Ye.map(ko=>ko.id),depth:Dt,targetDepth:ur}),La=3):((An=mn)==null||An.push(mn.Phase.CheckTypes,"structuredTypeRelatedTo",{sourceId:it.id,targetId:xt.id}),La=Li(it,xt,ir,tn),(ti=mn)==null||ti.pop()),ya&&(ya=wi),jn&1&&Dt--,jn&2&&ur--,pr=Ea,La?(La===-1||Dt===0&&ur===0)&&$o(La===-1||La===3):(_.set(Xi,(ir?4:0)|2|Ws),on--,$o(!1)),La;function $o(ko){for(let ou=ba;ou<vt;ou++)Ce.delete(ae[ou]),ko&&(_.set(ae[ou],1|Ws),on--);vt=ba}}function Li(it,xt,ir,tn){let jn=Bs(),Dr=Ln(it,xt,ir,tn,jn);if(_!==Kf){if(!Dr&&(it.flags&2097152||it.flags&262144&&xt.flags&1048576)){let An=hRt(it.flags&2097152?it.types:[it],!!(xt.flags&1048576));An&&tp(An,ti=>ti!==it)&&(Dr=Pn(An,xt,1,!1,void 0,tn))}Dr&&!(tn&2)&&xt.flags&2097152&&!hC(xt)&&it.flags&2621440?(Dr&=Ii(it,xt,ir,void 0,!1,0),Dr&&vb(it)&&Gn(it)&8192&&(Dr&=So(it,xt,!1,ir,0))):Dr&&lae(xt)&&!gb(xt)&&it.flags&2097152&&Tf(it).flags&3670016&&!Tt(it.types,An=>An===xt||!!(Gn(An)&262144))&&(Dr&=Ii(it,xt,ir,void 0,!0,tn))}return Dr&&cn(jn),Dr}function ei(it,xt){let ir=Tf(uC(xt)),tn=[];return oxe(ir,8576,!1,jn=>void tn.push(gs(it,EL(xt.mapper,Ag(xt),jn)))),pi(tn)}function Ln(it,xt,ir,tn,jn){let Dr,An,ti=!1,Xi=it.flags,Hs=xt.flags;if(_===Kf){if(Xi&3145728){let wi=el(it,xt);return wi&&(wi&=el(xt,it)),wi}if(Xi&4194304)return Pn(it.type,xt.type,3,!1);if(Xi&8388608&&(Dr=Pn(it.objectType,xt.objectType,3,!1))&&(Dr&=Pn(it.indexType,xt.indexType,3,!1))||Xi&16777216&&it.root.isDistributive===xt.root.isDistributive&&(Dr=Pn(it.checkType,xt.checkType,3,!1))&&(Dr&=Pn(it.extendsType,xt.extendsType,3,!1))&&(Dr&=Pn(pb(it),pb(xt),3,!1))&&(Dr&=Pn(db(it),db(xt),3,!1))||Xi&33554432&&(Dr=Pn(it.baseType,xt.baseType,3,!1))&&(Dr&=Pn(it.constraint,xt.constraint,3,!1)))return Dr;if(!(Xi&524288))return 0}else if(Xi&3145728||Hs&3145728){if(Dr=bf(it,xt,ir,tn))return Dr;if(!(Xi&465829888||Xi&524288&&Hs&1048576||Xi&2097152&&Hs&467402752))return 0}if(Xi&17301504&&it.aliasSymbol&&it.aliasTypeArguments&&it.aliasSymbol===xt.aliasSymbol&&!(Sae(it)||Sae(xt))){let wi=V$e(it.aliasSymbol);if(wi===tt)return 1;let Ws=as(it.aliasSymbol).typeParameters,La=a0(Ws),$o=FS(it.aliasTypeArguments,Ws,La,gn(it.aliasSymbol.valueDeclaration)),ko=FS(xt.aliasTypeArguments,Ws,La,gn(it.aliasSymbol.valueDeclaration)),ou=Ea($o,ko,wi,tn);if(ou!==void 0)return ou}if(X$e(it)&&!it.target.readonly&&(Dr=Pn(cc(it)[0],xt,1))||X$e(xt)&&(xt.target.readonly||Uz(k_(it)||it))&&(Dr=Pn(it,cc(xt)[0],2)))return Dr;if(Hs&262144){if(Gn(it)&32&&!it.declaration.nameType&&Pn(gh(xt),bd(it),3)&&!(s0(it)&4)){let wi=Zy(it),Ws=Ap(xt,Ag(it));if(Dr=Pn(wi,Ws,3,ir))return Dr}if(_===Tp&&Xi&262144){let wi=Sf(it);if(wi)for(;wi&&rg(wi,Ws=>!!(Ws.flags&262144));){if(Dr=Pn(wi,xt,1,!1))return Dr;wi=Sf(wi)}return 0}}else if(Hs&4194304){let wi=xt.type;if(Xi&4194304&&(Dr=Pn(wi,it.type,3,!1)))return Dr;if(Ka(wi)){if(Dr=Pn(it,Hze(wi),2,ir))return Dr}else{let Ws=lxe(wi);if(Ws){if(Pn(it,gh(Ws,xt.indexFlags|4),2,ir)===-1)return-1}else if(Ff(wi)){let La=nv(wi),$o=bd(wi),ko;if(La&&SI(wi)){let ou=ei(La,wi);ko=pi([ou,La])}else ko=La||$o;if(Pn(it,ko,2,ir)===-1)return-1}}}else if(Hs&8388608){if(Xi&8388608){if((Dr=Pn(it.objectType,xt.objectType,3,ir))&&(Dr&=Pn(it.indexType,xt.indexType,3,ir)),Dr)return Dr;ir&&(An=J)}if(_===Mf||_===Tp){let wi=xt.objectType,Ws=xt.indexType,La=k_(wi)||wi,$o=k_(Ws)||Ws;if(!hC(La)&&!yC($o)){let ko=4|(La!==wi?2:0),ou=BS(La,$o,ko);if(ou){if(ir&&An&&cn(jn),Dr=Pn(it,ou,2,ir,void 0,tn))return Dr;ir&&An&&J&&(J=ba([An])<=ba([J])?An:J)}}}ir&&(An=void 0)}else if(Ff(xt)&&_!==Kf){let wi=!!xt.declaration.nameType,Ws=Zy(xt),La=s0(xt);if(!(La&8)){if(!wi&&Ws.flags&8388608&&Ws.objectType===it&&Ws.indexType===Ag(xt))return-1;if(!Ff(it)){let $o=wi?nv(xt):bd(xt),ko=gh(it,2),ou=La&4,_0=ou?hz($o,ko):void 0;if(ou?!(_0.flags&131072):Pn($o,ko,3)){let l1=Zy(xt),wC=Ag(xt),OC=T4(l1,-98305);if(!wi&&OC.flags&8388608&&OC.indexType===wC){if(Dr=Pn(it,OC.objectType,2,ir))return Dr}else{let M4=wi?_0||$o:_0?Pa([_0,wC]):wC,Rg=Ap(it,M4);if(Dr=Pn(Rg,l1,3,ir))return Dr}}An=J,cn(jn)}}}else if(Hs&16777216){if(d4(xt,Ye,ur,10))return 3;let wi=xt;if(!wi.root.inferTypeParameters&&!ZMt(wi.root)&&!(it.flags&16777216&&it.root===wi.root)){let Ws=!Na(CL(wi.checkType),CL(wi.extendsType)),La=!Ws&&Na(SC(wi.checkType),SC(wi.extendsType));if((Dr=Ws?-1:Pn(it,pb(wi),2,!1,void 0,tn))&&(Dr&=La?-1:Pn(it,db(wi),2,!1,void 0,tn),Dr))return Dr}}else if(Hs&134217728){if(Xi&134217728){if(_===Tp)return ALt(it,xt)?0:-1;gs(it,$u)}if(Fae(it,xt))return-1}else if(xt.flags&268435456&&!(it.flags&268435456)&&Lae(it,xt))return-1;if(Xi&8650752){if(!(Xi&8388608&&Hs&8388608)){let wi=_C(it)||Sr;if(Dr=Pn(wi,xt,1,!1,void 0,tn))return Dr;if(Dr=Pn(Hp(wi,it),xt,1,ir&&wi!==Sr&&!(Hs&Xi&262144),void 0,tn))return Dr;if(pxe(it)){let Ws=_C(it.indexType);if(Ws&&(Dr=Pn(Ap(it.objectType,Ws),xt,1,ir)))return Dr}}}else if(Xi&4194304){let wi=Gxe(it.type,it.indexFlags)&&Gn(it.type)&32;if(Dr=Pn(Qo,xt,1,ir&&!wi))return Dr;if(wi){let Ws=it.type,La=nv(Ws),$o=La&&SI(Ws)?ei(La,Ws):La||bd(Ws);if(Dr=Pn($o,xt,1,ir))return Dr}}else if(Xi&134217728&&!(Hs&524288)){if(!(Hs&134217728)){let wi=k_(it);if(wi&&wi!==it&&(Dr=Pn(wi,xt,1,ir)))return Dr}}else if(Xi&268435456)if(Hs&268435456){if(it.symbol!==xt.symbol)return 0;if(Dr=Pn(it.type,xt.type,3,ir))return Dr}else{let wi=k_(it);if(wi&&(Dr=Pn(wi,xt,1,ir)))return Dr}else if(Xi&16777216){if(d4(it,be,Dt,10))return 3;if(Hs&16777216){let La=it.root.inferTypeParameters,$o=it.extendsType,ko;if(La){let ou=OL(La,void 0,0,ms);o1(ou.inferences,xt.extendsType,$o,1536),$o=gs($o,ou.mapper),ko=ou.mapper}if(n1($o,xt.extendsType)&&(Pn(it.checkType,xt.checkType,3)||Pn(xt.checkType,it.checkType,3))&&((Dr=Pn(gs(pb(it),ko),pb(xt),3,ir))&&(Dr&=Pn(db(it),db(xt),3,ir)),Dr))return Dr}let wi=uxe(it);if(wi&&(Dr=Pn(wi,xt,1,ir)))return Dr;let Ws=!(Hs&16777216)&&Sz(it)?oze(it):void 0;if(Ws&&(cn(jn),Dr=Pn(Ws,xt,1,ir)))return Dr}else{if(_!==Xh&&_!==jd&&uRt(xt)&&i1(it))return-1;if(Ff(xt))return Ff(it)&&(Dr=lt(it,xt,ir))?Dr:0;let wi=!!(Xi&402784252);if(_!==Kf)it=Tf(it),Xi=it.flags;else if(Ff(it))return 0;if(Gn(it)&4&&Gn(xt)&4&&it.target===xt.target&&!Ka(it)&&!(Sae(it)||Sae(xt))){if(Cae(it))return-1;let Ws=dCe(it.target);if(Ws===tt)return 1;let La=Ea(cc(it),cc(xt),Ws,tn);if(La!==void 0)return La}else{if(m4(xt)?tp(it,gb):Gd(xt)&&tp(it,Ws=>Ka(Ws)&&!Ws.target.readonly))return _!==Kf?Pn(_b(it,It)||W,_b(xt,It)||W,3,ir):0;if(zS(it)&&Ka(xt)&&!zS(xt)){let Ws=e1(it);if(Ws!==it)return Pn(Ws,xt,1,ir)}else if((_===Xh||_===jd)&&i1(xt)&&Gn(xt)&8192&&!i1(it))return 0}if(Xi&2621440&&Hs&524288){let Ws=ir&&J===jn.errorInfo&&!wi;if(Dr=Ii(it,xt,Ws,void 0,!1,tn),Dr&&(Dr&=bs(it,xt,0,Ws,tn),Dr&&(Dr&=bs(it,xt,1,Ws,tn),Dr&&(Dr&=So(it,xt,wi,Ws,tn)))),ti&&Dr)J=An||J||jn.errorInfo;else if(Dr)return Dr}if(Xi&2621440&&Hs&1048576){let Ws=T4(xt,36175872);if(Ws.flags&1048576){let La=Ut(it,Ws);if(La)return La}}}return 0;function ba(wi){return wi?d_(wi,(Ws,La)=>Ws+1+ba(La.next),0):0}function Ea(wi,Ws,La,$o){if(Dr=bi(wi,Ws,La,ir,$o))return Dr;if(Tt(La,ou=>!!(ou&24))){An=void 0,cn(jn);return}let ko=Ws&&V7t(Ws,La);if(ti=!ko,La!==tt&&!ko){if(ti&&!(ir&&Tt(La,ou=>(ou&7)===0)))return 0;An=J,cn(jn)}}}function lt(it,xt,ir){if(_===Tp||(_===Kf?s0(it)===s0(xt):cxe(it)<=cxe(xt))){let jn,Dr=bd(xt),An=gs(bd(it),cxe(it)<0?Uo:$u);if(jn=Pn(Dr,An,3,ir)){let ti=kp([Ag(it)],[Ag(xt)]);if(gs(nv(it),ti)===gs(nv(xt),ti))return jn&Pn(gs(Zy(it),ti),Zy(xt),3,ir)}}return 0}function Ut(it,xt){var ir;let tn=Io(it),jn=dWe(tn,xt);if(!jn)return 0;let Dr=1;for(let Ea of jn)if(Dr*=eFt(OS(Ea)),Dr>25)return(ir=mn)==null||ir.instant(mn.Phase.CheckTypes,"typeRelatedToDiscriminatedType_DepthLimit",{sourceId:it.id,targetId:xt.id,numCombinations:Dr}),0;let An=new Array(jn.length),ti=new Set;for(let Ea=0;Ea<jn.length;Ea++){let wi=jn[Ea],Ws=OS(wi);An[Ea]=Ws.flags&1048576?Ws.types:[Ws],ti.add(wi.escapedName)}let Xi=Efe(An),Hs=[];for(let Ea of Xi){let wi=!1;e:for(let Ws of xt.types){for(let La=0;La<jn.length;La++){let $o=jn[La],ko=ka(Ws,$o.escapedName);if(!ko)continue e;if($o===ko)continue;if(!dr(it,xt,$o,ko,_0=>Ea[La],!1,0,Q||_===Tp))continue e}ln(Hs,Ws,Dm),wi=!0}if(!wi)return 0}let ba=-1;for(let Ea of Hs)if(ba&=Ii(it,Ea,!1,ti,!1,0),ba&&(ba&=bs(it,Ea,0,!1,0),ba&&(ba&=bs(it,Ea,1,!1,0),ba&&!(Ka(it)&&Ka(Ea))&&(ba&=So(it,Ea,!1,!1,0)))),!ba)return ba;return ba}function sr(it,xt){if(!xt||it.length===0)return it;let ir;for(let tn=0;tn<it.length;tn++)xt.has(it[tn].escapedName)?ir||(ir=it.slice(0,tn)):ir&&ir.push(it[tn]);return ir||it}function rr(it,xt,ir,tn,jn){let Dr=Q&&!!(Vc(xt)&48),An=ep(OS(xt),!1,Dr),ti=ir(it);return Pn(ti,An,3,tn,void 0,jn)}function dr(it,xt,ir,tn,jn,Dr,An,ti){let Xi=Nd(ir),Hs=Nd(tn);if(Xi&2||Hs&2){if(ir.valueDeclaration!==tn.valueDeclaration)return Dr&&(Xi&2&&Hs&2?As(g.Types_have_separate_declarations_of_a_private_property_0,Oi(tn)):As(g.Property_0_is_private_in_type_1_but_not_in_type_2,Oi(tn),Kr(Xi&2?it:xt),Kr(Xi&2?xt:it))),0}else if(Hs&4){if(!W7t(ir,tn))return Dr&&As(g.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2,Oi(tn),Kr(lP(ir)||it),Kr(lP(tn)||xt)),0}else if(Xi&4)return Dr&&As(g.Property_0_is_protected_in_type_1_but_public_in_type_2,Oi(tn),Kr(it),Kr(xt)),0;if(_===jd&&wg(ir)&&!wg(tn))return 0;let ba=rr(ir,tn,jn,Dr,An);return ba?!ti&&ir.flags&16777216&&tn.flags&106500&&!(tn.flags&16777216)?(Dr&&As(g.Property_0_is_optional_in_type_1_but_required_in_type_2,Oi(tn),Kr(it),Kr(xt)),0):ba:(Dr&&Os(g.Types_of_property_0_are_incompatible,Oi(tn)),0)}function Wr(it,xt,ir,tn){let jn=!1;if(ir.valueDeclaration&&W_(ir.valueDeclaration)&&is(ir.valueDeclaration.name)&&it.symbol&&it.symbol.flags&32){let An=ir.valueDeclaration.name.escapedText,ti=G8(it.symbol,An);if(ti&&ka(it,ti)){let Xi=j.getDeclarationName(it.symbol.valueDeclaration),Hs=j.getDeclarationName(xt.symbol.valueDeclaration);As(g.Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2,Ym(An),Ym(Xi.escapedText===""?YU:Xi),Ym(Hs.escapedText===""?YU:Hs));return}}let Dr=In(DCe(it,xt,tn,!1));if((!y||y.code!==g.Class_0_incorrectly_implements_interface_1.code&&y.code!==g.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code)&&(jn=!0),Dr.length===1){let An=Oi(ir,void 0,0,20);As(g.Property_0_is_missing_in_type_1_but_required_in_type_2,An,...eP(it,xt)),de(ir.declarations)&&Hd($n(ir.declarations[0],g._0_is_declared_here,An)),jn&&J&&Ur++}else an(it,xt,!1)&&(Dr.length>5?As(g.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more,Kr(it),Kr(xt),vr(Dr.slice(0,4),An=>Oi(An)).join(", "),Dr.length-4):As(g.Type_0_is_missing_the_following_properties_from_type_1_Colon_2,Kr(it),Kr(xt),vr(Dr,An=>Oi(An)).join(", ")),jn&&J&&Ur++)}function Ii(it,xt,ir,tn,jn,Dr){if(_===Kf)return Ei(it,xt,tn);let An=-1;if(Ka(xt)){if(gb(it)){if(!xt.target.readonly&&(m4(it)||Ka(it)&&it.target.readonly))return 0;let Ea=sv(it),wi=sv(xt),Ws=Ka(it)?it.target.combinedFlags&4:4,La=xt.target.combinedFlags&4,$o=Ka(it)?it.target.minLength:0,ko=xt.target.minLength;if(!Ws&&Ea<ko)return ir&&As(g.Source_has_0_element_s_but_target_requires_1,Ea,ko),0;if(!La&&wi<$o)return ir&&As(g.Source_has_0_element_s_but_target_allows_only_1,$o,wi),0;if(!La&&(Ws||wi<Ea))return ir&&($o<ko?As(g.Target_requires_0_element_s_but_source_may_have_fewer,ko):As(g.Target_allows_only_0_element_s_but_source_may_have_more,wi)),0;let ou=cc(it),_0=cc(xt),l1=vMt(xt.target,11),wC=SL(xt.target,11),OC=xt.target.hasRestElement,M4=!!tn;for(let Rg=0;Rg<Ea;Rg++){let dP=Ka(it)?it.target.elementFlags[Rg]:4,ig=Ea-1-Rg,Mt=OC&&Rg>=l1?wi-1-Math.min(ig,wC):Rg,Bn=xt.target.elementFlags[Mt];if(Bn&8&&!(dP&8))return ir&&As(g.Source_provides_no_match_for_variadic_element_at_position_0_in_target,Mt),0;if(dP&8&&!(Bn&12))return ir&&As(g.Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target,Rg,Mt),0;if(Bn&1&&!(dP&1))return ir&&As(g.Source_provides_no_match_for_required_element_at_position_0_in_target,Mt),0;if(M4&&((dP&12||Bn&12)&&(M4=!1),M4&&tn?.has(""+Rg)))continue;let xi=WS(ou[Rg],!!(dP&Bn&2)),si=_0[Mt],Si=dP&8&&Bn&4?P_(si):WS(si,!!(Bn&2)),po=Pn(xi,Si,3,ir,void 0,Dr);if(!po)return ir&&(wi>1||Ea>1)&&(OC&&Rg>=l1&&ig>=wC&&l1!==Ea-wC-1?Os(g.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target,l1,Ea-wC-1,Mt):Os(g.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target,Rg,Mt)),0;An&=po}return An}if(xt.target.combinedFlags&12)return 0}let ti=(_===Xh||_===jd)&&!vb(it)&&!Cae(it)&&!Ka(it),Xi=ICe(it,xt,ti,!1);if(Xi)return ir&&Or(it,xt)&&Wr(it,xt,Xi,ti),0;if(vb(xt)){for(let Ea of sr(Io(it),tn))if(!ub(xt,Ea.escapedName)&&!(vn(Ea).flags&32768))return ir&&As(g.Property_0_does_not_exist_on_type_1,Oi(Ea),Kr(xt)),0}let Hs=Io(xt),ba=Ka(it)&&Ka(xt);for(let Ea of sr(Hs,tn)){let wi=Ea.escapedName;if(!(Ea.flags&4194304)&&(!ba||R0(wi)||wi==="length")&&(!jn||Ea.flags&16777216)){let Ws=ka(it,wi);if(Ws&&Ws!==Ea){let La=dr(it,xt,Ws,Ea,OS,ir,Dr,_===Tp);if(!La)return 0;An&=La}}}return An}function Ei(it,xt,ir){if(!(it.flags&524288&&xt.flags&524288))return 0;let tn=sr(LS(it),ir),jn=sr(LS(xt),ir);if(tn.length!==jn.length)return 0;let Dr=-1;for(let An of tn){let ti=ub(xt,An.escapedName);if(!ti)return 0;let Xi=gCe(An,ti,Pn);if(!Xi)return 0;Dr&=Xi}return Dr}function bs(it,xt,ir,tn,jn){var Dr,An;if(_===Kf)return va(it,xt,ir);if(xt===cr||it===cr)return-1;let ti=it.symbol&&Sh(it.symbol.valueDeclaration),Xi=xt.symbol&&Sh(xt.symbol.valueDeclaration),Hs=na(it,ti&&ir===1?0:ir),ba=na(xt,Xi&&ir===1?0:ir);if(ir===1&&Hs.length&&ba.length){let $o=!!(Hs[0].flags&4),ko=!!(ba[0].flags&4);if($o&&!ko)return tn&&As(g.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type),0;if(!Og(Hs[0],ba[0],tn))return 0}let Ea=-1,wi=ir===1?Qi:fi,Ws=Gn(it),La=Gn(xt);if(Ws&64&&La&64&&it.symbol===xt.symbol||Ws&4&&La&4&&it.target===xt.target){I.assertEqual(Hs.length,ba.length);for(let $o=0;$o<ba.length;$o++){let ko=Es(Hs[$o],ba[$o],!0,tn,jn,wi(Hs[$o],ba[$o]));if(!ko)return 0;Ea&=ko}}else if(Hs.length===1&&ba.length===1){let $o=_===Tp||!!$.noStrictGenericChecks,ko=di(Hs),ou=di(ba);if(Ea=Es(ko,ou,$o,tn,jn,wi(ko,ou)),!Ea&&tn&&ir===1&&Ws&La&&(((Dr=ou.declaration)==null?void 0:Dr.kind)===176||((An=ko.declaration)==null?void 0:An.kind)===176)){let _0=l1=>t0(l1,void 0,262144,ir);return As(g.Type_0_is_not_assignable_to_type_1,_0(ko),_0(ou)),As(g.Types_of_construct_signatures_are_incompatible),Ea}}else e:for(let $o of ba){let ko=Bs(),ou=tn;for(let _0 of Hs){let l1=Es(_0,$o,!0,ou,jn,wi(_0,$o));if(l1){Ea&=l1,cn(ko);continue e}ou=!1}return ou&&As(g.Type_0_provides_no_match_for_the_signature_1,Kr(it),t0($o,void 0,void 0,ir)),0}return Ea}function Or(it,xt){let ir=bz(it,0),tn=bz(it,1),jn=LS(it);return(ir.length||tn.length)&&!jn.length?!!(na(xt,0).length&&ir.length||na(xt,1).length&&tn.length):!0}function fi(it,xt){return it.parameters.length===0&&xt.parameters.length===0?(ir,tn)=>Os(g.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1,Kr(ir),Kr(tn)):(ir,tn)=>Os(g.Call_signature_return_types_0_and_1_are_incompatible,Kr(ir),Kr(tn))}function Qi(it,xt){return it.parameters.length===0&&xt.parameters.length===0?(ir,tn)=>Os(g.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1,Kr(ir),Kr(tn)):(ir,tn)=>Os(g.Construct_signature_return_types_0_and_1_are_incompatible,Kr(ir),Kr(tn))}function Es(it,xt,ir,tn,jn,Dr){let An=_===Xh?16:_===jd?24:0;return lCe(ir?yL(it):it,ir?yL(xt):xt,An,tn,As,Dr,ti,$u);function ti(Xi,Hs,ba){return Pn(Xi,Hs,3,ba,void 0,jn)}}function va(it,xt,ir){let tn=na(it,ir),jn=na(xt,ir);if(tn.length!==jn.length)return 0;let Dr=-1;for(let An=0;An<tn.length;An++){let ti=Bz(tn[An],jn[An],!1,!1,!1,Pn);if(!ti)return 0;Dr&=ti}return Dr}function $l(it,xt,ir,tn){let jn=-1,Dr=xt.keyType,An=it.flags&2097152?vz(it):LS(it);for(let ti of An)if(!F$e(it,ti)&&nP(CI(ti,8576),Dr)){let Xi=OS(ti),Hs=Ie||Xi.flags&32768||Dr===It||!(ti.flags&16777216)?Xi:Em(Xi,524288),ba=Pn(Hs,xt.type,3,ir,void 0,tn);if(!ba)return ir&&As(g.Property_0_is_incompatible_with_index_signature,Oi(ti)),0;jn&=ba}for(let ti of nf(it))if(nP(ti.keyType,Dr)){let Xi=Wc(ti,xt,ir,tn);if(!Xi)return 0;jn&=Xi}return jn}function Wc(it,xt,ir,tn){let jn=Pn(it.type,xt.type,3,ir,void 0,tn);return!jn&&ir&&(it.keyType===xt.keyType?As(g._0_index_signatures_are_incompatible,Kr(it.keyType)):As(g._0_and_1_index_signatures_are_incompatible,Kr(it.keyType),Kr(xt.keyType))),jn}function So(it,xt,ir,tn,jn){if(_===Kf)return lc(it,xt);let Dr=nf(xt),An=Tt(Dr,Xi=>Xi.keyType===Le),ti=-1;for(let Xi of Dr){let Hs=_!==jd&&!ir&&An&&Xi.type.flags&1?-1:Ff(it)&&An?Pn(Zy(it),Xi.type,3,tn):au(it,Xi,tn,jn);if(!Hs)return 0;ti&=Hs}return ti}function au(it,xt,ir,tn){let jn=mL(it,xt.keyType);return jn?Wc(jn,xt,ir,tn):!(tn&1)&&(_!==jd||Gn(it)&8192)&&Iae(it)?$l(it,xt,ir,tn):(ir&&As(g.Index_signature_for_type_0_is_missing_in_type_1,Kr(xt.keyType),Kr(it)),0)}function lc(it,xt){let ir=nf(it),tn=nf(xt);if(ir.length!==tn.length)return 0;for(let jn of tn){let Dr=K0(it,jn.keyType);if(!(Dr&&Pn(Dr.type,jn.type,3)&&Dr.isReadonly===jn.isReadonly))return 0}return-1}function Og(it,xt,ir){if(!it.declaration||!xt.declaration)return!0;let tn=DA(it.declaration,6),jn=DA(xt.declaration,6);return jn===2||jn===4&&tn!==2||jn!==4&&!tn?!0:(ir&&As(g.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type,oC(tn),oC(jn)),!1)}}function fCe(r){if(r.flags&16)return!1;if(r.flags&3145728)return!!Te(r.types,fCe);if(r.flags&465829888){let a=_C(r);if(a&&a!==r)return fCe(a)}return Dg(r)||!!(r.flags&134217728)||!!(r.flags&268435456)}function j$e(r,a){return Ka(r)&&Ka(a)?tt:Io(a).filter(_=>vae(Xe(r,_.escapedName),vn(_)))}function vae(r,a){return!!r&&!!a&&$c(r,32768)&&!!IL(a)}function B7t(r){return Io(r).filter(a=>IL(vn(a)))}function B$e(r,a,_=oCe){return nXe(r,a,_)||WJt(r,a)||GJt(r,a)||HJt(r,a)||YJt(r,a)}function pCe(r,a,_){let d=r.types,y=d.map(P=>P.flags&402784252?0:-1);for(let[P,L]of a){let J=!1;for(let G=0;G<d.length;G++)if(y[G]){let ae=Pt(d[G],L);ae&&_(P(),ae)?J=!0:y[G]=3}for(let G=0;G<d.length;G++)y[G]===3&&(y[G]=J?0:-1)}let T=hs(y,0)?pi(d.filter((P,L)=>y[L]),0):r;return T.flags&131072?r:T}function U$e(r){if(r.flags&524288){let a=kg(r);return a.callSignatures.length===0&&a.constructSignatures.length===0&&a.indexInfos.length===0&&a.properties.length>0&&yr(a.properties,_=>!!(_.flags&16777216))}return r.flags&2097152?yr(r.types,U$e):!1}function U7t(r,a,_){for(let d of Io(r))if(uAe(a,d.escapedName,_))return!0;return!1}function dCe(r){return r===sa||r===ua||r.objectFlags&8?re:J$e(r.symbol,r.typeParameters)}function V$e(r){return J$e(r,as(r).typeParameters)}function J$e(r,a=tt){var _,d;let y=as(r);if(!y.variances){(_=mn)==null||_.push(mn.Phase.CheckTypes,"getVariancesWorker",{arity:a.length,id:sf(dc(r))});let T=zT;zT||(zT=!0,Rk=Hu.length),y.variances=tt;let P=[];for(let L of a){let J=mCe(L),G=J&16384?J&8192?0:1:J&8192?2:void 0;if(G===void 0){let ae=!1,Ce=!1,be=ya;ya=Dt=>Dt?Ce=!0:ae=!0;let Ye=Fz(r,L,yp),vt=Fz(r,L,Go);G=(Na(vt,Ye)?1:0)|(Na(Ye,vt)?2:0),G===3&&Na(Fz(r,L,ru),Ye)&&(G=4),ya=be,(ae||Ce)&&(ae&&(G|=8),Ce&&(G|=16))}P.push(G)}T||(zT=!1,Rk=0),y.variances=P,(d=mn)==null||d.pop({variances:P.map(I.formatVariance)})}return y.variances}function Fz(r,a,_){let d=r2(a,_),y=dc(r);if(Xt(y))return y;let T=r.flags&524288?EI(r,ov(as(r).typeParameters,d)):iv(y,ov(y.typeParameters,d));return mt.add(sf(T)),T}function Sae(r){return mt.has(sf(r))}function mCe(r){var a;return d_((a=r.symbol)==null?void 0:a.declarations,(_,d)=>_|X_(d),0)&28672}function V7t(r,a){for(let _=0;_<a.length;_++)if((a[_]&7)===1&&r[_].flags&16384)return!0;return!1}function J7t(r){return r.flags&262144&&!Sf(r)}function q7t(r){return!!(Gn(r)&4)&&!r.node}function Tae(r){return q7t(r)&&Tt(cc(r),a=>!!(a.flags&262144)||Tae(a))}function z7t(r,a,_,d){let y=[],T="",P=J(r,0),L=J(a,0);return`${T}${P},${L}${_}`;function J(G,ae=0){let Ce=""+G.target.id;for(let be of cc(G)){if(be.flags&262144){if(d||J7t(be)){let Ye=y.indexOf(be);Ye<0&&(Ye=y.length,y.push(be)),Ce+="="+Ye;continue}T="*"}else if(ae<4&&Tae(be)){Ce+="<"+J(be,ae+1)+">";continue}Ce+="-"+be.id}return Ce}}function bae(r,a,_,d,y){if(d===Kf&&r.id>a.id){let P=r;r=a,a=P}let T=_?":"+_:"";return Tae(r)&&Tae(a)?z7t(r,a,T,y):`${r.id},${a.id}${T}`}function jz(r,a){if(Vc(r)&6){for(let _ of r.links.containingType.types){let d=ka(_,r.escapedName),y=d&&jz(d,a);if(y)return y}return}return a(r)}function lP(r){return r.parent&&r.parent.flags&32?dc(yf(r)):void 0}function Eae(r){let a=lP(r),_=a&&Cp(a)[0];return _&&Xe(_,r.escapedName)}function $7t(r,a){return jz(r,_=>{let d=lP(_);return d?hI(d,a):!1})}function W7t(r,a){return!jz(a,_=>Nd(_)&4?!$7t(r,lP(_)):!1)}function q$e(r,a,_){return jz(a,d=>Nd(d,_)&4?!hI(r,lP(d)):!1)?void 0:r}function d4(r,a,_,d=3){if(_>=d){if((Gn(r)&96)===96&&(r=z$e(r)),r.flags&2097152)return Tt(r.types,L=>d4(L,a,_,d));let y=xae(r),T=0,P=0;for(let L=0;L<_;L++){let J=a[L];if($$e(J,y)){if(J.id>=P&&(T++,T>=d))return!0;P=J.id}}}return!1}function z$e(r){let a;for(;(Gn(r)&96)===96&&(a=uC(r))&&(a.symbol||a.flags&2097152&&Tt(a.types,_=>!!_.symbol));)r=a;return r}function $$e(r,a){return(Gn(r)&96)===96&&(r=z$e(r)),r.flags&2097152?Tt(r.types,_=>$$e(_,a)):xae(r)===a}function xae(r){if(r.flags&524288&&!OCe(r)){if(Gn(r)&4&&r.node)return r.node;if(r.symbol&&!(Gn(r)&16&&r.symbol.flags&32))return r.symbol;if(Ka(r))return r.target}if(r.flags&262144)return r.symbol;if(r.flags&8388608){do r=r.objectType;while(r.flags&8388608);return r}return r.flags&16777216?r.root:r}function G7t(r,a){return gCe(r,a,AL)!==0}function gCe(r,a,_){if(r===a)return-1;let d=Nd(r)&6,y=Nd(a)&6;if(d!==y)return 0;if(d){if(FI(r)!==FI(a))return 0}else if((r.flags&16777216)!==(a.flags&16777216))return 0;return wg(r)!==wg(a)?0:_(vn(r),vn(a))}function H7t(r,a,_){let d=Xp(r),y=Xp(a),T=Th(r),P=Th(a),L=u0(r),J=u0(a);return!!(d===y&&T===P&&L===J||_&&T<=P)}function Bz(r,a,_,d,y,T){if(r===a)return-1;if(!H7t(r,a,_)||de(r.typeParameters)!==de(a.typeParameters))return 0;if(a.typeParameters){let J=kp(r.typeParameters,a.typeParameters);for(let G=0;G<a.typeParameters.length;G++){let ae=r.typeParameters[G],Ce=a.typeParameters[G];if(!(ae===Ce||T(gs(l4(ae),J)||Sr,l4(Ce)||Sr)&&T(gs(pC(ae),J)||Sr,pC(Ce)||Sr)))return 0}r=PI(r,J,!0)}let P=-1;if(!d){let J=fb(r);if(J){let G=fb(a);if(G){let ae=T(J,G);if(!ae)return 0;P&=ae}}}let L=Xp(a);for(let J=0;J<L;J++){let G=Ig(r,J),ae=Ig(a,J),Ce=T(ae,G);if(!Ce)return 0;P&=Ce}if(!y){let J=zd(r),G=zd(a);P&=J||G?Y7t(J,G,T):T(Ao(r),Ao(a))}return P}function Y7t(r,a,_){return r&&a&&zxe(r,a)?r.type===a.type?-1:r.type&&a.type?_(r.type,a.type):0:0}function X7t(r){let a;for(let _ of r)if(!(_.flags&131072)){let d=s1(_);if(a??(a=d),d===_||d!==a)return!1}return!0}function W$e(r){return d_(r,(a,_)=>a|(_.flags&1048576?W$e(_.types):_.flags),0)}function K7t(r){if(r.length===1)return r[0];let a=Q?ul(r,d=>wl(d,y=>!(y.flags&98304))):r,_=X7t(a)?pi(a):d_(a,(d,y)=>JS(d,y)?y:d);return a===r?_:Jz(_,W$e(r)&98304)}function Q7t(r){return d_(r,(a,_)=>JS(_,a)?_:a)}function Gd(r){return!!(Gn(r)&4)&&(r.target===sa||r.target===ua)}function m4(r){return!!(Gn(r)&4)&&r.target===ua}function gb(r){return Gd(r)||Ka(r)}function Uz(r){return Gd(r)&&!m4(r)||Ka(r)&&!r.target.readonly}function Vz(r){return Gd(r)?cc(r)[0]:void 0}function cv(r){return Gd(r)||!(r.flags&98304)&&Na(r,dd)}function hCe(r){return Uz(r)||!(r.flags&98305)&&Na(r,bl)}function yCe(r){if(!(Gn(r)&4)||!(Gn(r.target)&3))return;if(Gn(r)&33554432)return Gn(r)&67108864?r.cachedEquivalentBaseType:void 0;r.objectFlags|=33554432;let a=r.target;if(Gn(a)&1){let y=Vo(a);if(y&&y.expression.kind!==80&&y.expression.kind!==211)return}let _=Cp(a);if(_.length!==1||MS(r.symbol).size)return;let d=de(a.typeParameters)?gs(_[0],kp(a.typeParameters,cc(r).slice(0,a.typeParameters.length))):_[0];return de(cc(r))>de(a.typeParameters)&&(d=Hp(d,Rs(cc(r)))),r.objectFlags|=67108864,r.cachedEquivalentBaseType=d}function G$e(r){return Q?r===Vi:r===Lt}function Cae(r){let a=Vz(r);return!!a&&G$e(a)}function g4(r){let a;return Ka(r)||!!ka(r,"0")||cv(r)&&!!(a=Xe(r,"length"))&&tp(a,_=>!!(_.flags&256))}function Aae(r){return cv(r)||g4(r)}function Z7t(r,a){let _=Xe(r,""+a);if(_)return _;if(tp(r,Ka))return K$e(r,a,$.noUncheckedIndexedAccess?Be:void 0)}function eLt(r){return!(r.flags&240544)}function Dg(r){return!!(r.flags&109472)}function H$e(r){let a=e1(r);return a.flags&2097152?Tt(a.types,Dg):Dg(a)}function tLt(r){return r.flags&2097152&&mr(r.types,Dg)||r}function NL(r){return r.flags&16?!0:r.flags&1048576?r.flags&1024?!0:yr(r.types,Dg):Dg(r)}function s1(r){return r.flags&1056?Wse(r):r.flags&402653312?Le:r.flags&256?It:r.flags&2048?Rt:r.flags&512?Pi:r.flags&1048576?rLt(r):r}function rLt(r){let a=`B${sf(r)}`;return Vk(a)??dS(a,Ec(r,s1))}function vCe(r){return r.flags&402653312?Le:r.flags&288?It:r.flags&2048?Rt:r.flags&512?Pi:r.flags&1048576?Ec(r,vCe):r}function i2(r){return r.flags&1056&&t2(r)?Wse(r):r.flags&128&&t2(r)?Le:r.flags&256&&t2(r)?It:r.flags&2048&&t2(r)?Rt:r.flags&512&&t2(r)?Pi:r.flags&1048576?Ec(r,i2):r}function Y$e(r){return r.flags&8192?Fi:r.flags&1048576?Ec(r,Y$e):r}function SCe(r,a){return goe(r,a)||(r=Y$e(i2(r))),af(r)}function nLt(r,a,_){if(r&&Dg(r)){let d=a?_?$L(a):a:void 0;r=SCe(r,d)}return r}function TCe(r,a,_,d){if(r&&Dg(r)){let y=a?l2(_,a,d):void 0;r=SCe(r,y)}return r}function Ka(r){return!!(Gn(r)&4&&r.target.objectFlags&8)}function zS(r){return Ka(r)&&!!(r.target.combinedFlags&8)}function X$e(r){return zS(r)&&r.target.elementFlags.length===1}function kae(r){return h4(r,r.target.fixedLength)}function K$e(r,a,_){return Ec(r,d=>{let y=d,T=kae(y);return T?_&&a>=Jxe(y.target)?pi([T,_]):T:Be})}function iLt(r){let a=kae(r);return a&&P_(a)}function h4(r,a,_=0,d=!1,y=!1){let T=sv(r)-_;if(a<T){let P=cc(r),L=[];for(let J=a;J<T;J++){let G=P[J];L.push(r.target.elementFlags[J]&8?Ap(G,It):G)}return d?Pa(L):pi(L,y?0:1)}}function sLt(r,a){return sv(r)===sv(a)&&yr(r.target.elementFlags,(_,d)=>(_&12)===(a.target.elementFlags[d]&12))}function Q$e({value:r}){return r.base10Value==="0"}function Z$e(r){return wl(r,a=>bm(a,4194304))}function aLt(r){return Ec(r,oLt)}function oLt(r){return r.flags&4?aa:r.flags&8?ao:r.flags&64?B_:r===Ir||r===Zt||r.flags&114691||r.flags&128&&r.value===""||r.flags&256&&r.value===0||r.flags&2048&&Q$e(r)?r:Qn}function Jz(r,a){let _=a&~r.flags&98304;return _===0?r:pi(_===32768?[r,Be]:_===65536?[r,he]:[r,Be,he])}function $S(r,a=!1){I.assert(Q);let _=a?le:Be;return r===_||r.flags&1048576&&r.types[0]===_?r:pi([r,_])}function cLt(r){return wf||(wf=_4("NonNullable",524288,void 0)||dt),wf!==dt?EI(wf,[r]):Pa([r,$a])}function a1(r){return Q?xC(r,2097152):r}function eWe(r){return Q?pi([r,X]):r}function Pae(r){return Q?Uae(r,X):r}function Nae(r,a,_){return _?Dw(a)?$S(r):eWe(r):r}function DL(r,a){return A9(a)?a1(r):w_(a)?Pae(r):r}function WS(r,a){return Ie&&a?Uae(r,B):r}function IL(r){return r===B||!!(r.flags&1048576)&&r.types[0]===B}function Dae(r){return Ie?Uae(r,B):Em(r,524288)}function lLt(r,a){return(r.flags&524)!==0&&(a.flags&28)!==0}function Iae(r){let a=Gn(r);return r.flags&2097152?yr(r.types,Iae):!!(r.symbol&&r.symbol.flags&7040&&!(r.symbol.flags&32)&&!woe(r))||!!(a&4194304)||!!(a&1024&&Iae(r.source))}function TC(r,a){let _=oo(r.flags,r.escapedName,Vc(r)&8);_.declarations=r.declarations,_.parent=r.parent,_.links.type=a,_.links.target=r,r.valueDeclaration&&(_.valueDeclaration=r.valueDeclaration);let d=as(r).nameType;return d&&(_.links.nameType=d),_}function uLt(r,a){let _=ga();for(let d of LS(r)){let y=vn(d),T=a(y);_.set(d.escapedName,T===y?d:TC(d,T))}return _}function wL(r){if(!(vb(r)&&Gn(r)&8192))return r;let a=r.regularType;if(a)return a;let _=r,d=uLt(r,wL),y=Ho(_.symbol,d,_.callSignatures,_.constructSignatures,_.indexInfos);return y.flags=_.flags,y.objectFlags|=_.objectFlags&-8193,r.regularType=y,y}function tWe(r,a,_){return{parent:r,propertyName:a,siblings:_,resolvedProperties:void 0}}function rWe(r){if(!r.siblings){let a=[];for(let _ of rWe(r.parent))if(vb(_)){let d=ub(_,r.propertyName);d&&CC(vn(d),y=>{a.push(y)})}r.siblings=a}return r.siblings}function _Lt(r){if(!r.resolvedProperties){let a=new Map;for(let _ of rWe(r))if(vb(_)&&!(Gn(_)&2097152))for(let d of Io(_))a.set(d.escapedName,d);r.resolvedProperties=In(a.values())}return r.resolvedProperties}function fLt(r,a){if(!(r.flags&4))return r;let _=vn(r),d=a&&tWe(a,r.escapedName,void 0),y=bCe(_,d);return y===_?r:TC(r,y)}function pLt(r){let a=We.get(r.escapedName);if(a)return a;let _=TC(r,le);return _.flags|=16777216,We.set(r.escapedName,_),_}function dLt(r,a){let _=ga();for(let y of LS(r))_.set(y.escapedName,fLt(y,a));if(a)for(let y of _Lt(a))_.has(y.escapedName)||_.set(y.escapedName,pLt(y));let d=Ho(r.symbol,_,tt,tt,ul(nf(r),y=>o0(y.keyType,Yp(y.type),y.isReadonly)));return d.objectFlags|=Gn(r)&266240,d}function Yp(r){return bCe(r,void 0)}function bCe(r,a){if(Gn(r)&196608){if(a===void 0&&r.widened)return r.widened;let _;if(r.flags&98305)_=W;else if(vb(r))_=dLt(r,a);else if(r.flags&1048576){let d=a||tWe(void 0,void 0,r.types),y=ul(r.types,T=>T.flags&98304?T:bCe(T,d));_=pi(y,Tt(y,i1)?2:1)}else r.flags&2097152?_=Pa(ul(r.types,Yp)):gb(r)&&(_=iv(r.target,ul(cc(r),Yp)));return _&&a===void 0&&(r.widened=_),_||r}return r}function wae(r){let a=!1;if(Gn(r)&65536){if(r.flags&1048576)if(Tt(r.types,i1))a=!0;else for(let _ of r.types)wae(_)&&(a=!0);if(gb(r))for(let _ of cc(r))wae(_)&&(a=!0);if(vb(r))for(let _ of LS(r)){let d=vn(_);Gn(d)&65536&&(wae(d)||He(_.valueDeclaration,g.Object_literal_s_property_0_implicitly_has_an_1_type,Oi(_),Kr(Yp(d))),a=!0)}}return a}function hb(r,a,_){let d=Kr(Yp(a));if(gn(r)&&!uR(Xr(r),$))return;let y;switch(r.kind){case 226:case 172:case 171:y=ve?g.Member_0_implicitly_has_an_1_type:g.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;break;case 169:let T=r;if(ze(T.name)){let P=uT(T.name);if((HA(T.parent)||Uh(T.parent)||Vh(T.parent))&&T.parent.parameters.includes(T)&&(wc(T,T.name.escapedText,788968,void 0,T.name.escapedText,!0)||P&&RX(P))){let L="arg"+T.parent.parameters.indexOf(T),J=qo(T.name)+(T.dotDotDotToken?"[]":"");Yu(ve,r,g.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1,L,J);return}}y=r.dotDotDotToken?ve?g.Rest_parameter_0_implicitly_has_an_any_type:g.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage:ve?g.Parameter_0_implicitly_has_an_1_type:g.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;break;case 208:if(y=g.Binding_element_0_implicitly_has_an_1_type,!ve)return;break;case 324:He(r,g.Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type,d);return;case 330:ve&&YN(r.parent)&&He(r.parent.tagName,g.This_overload_implicitly_returns_the_type_0_because_it_lacks_a_return_type_annotation,d);return;case 262:case 174:case 173:case 177:case 178:case 218:case 219:if(ve&&!r.name){_===3?He(r,g.Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation,d):He(r,g.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type,d);return}y=ve?_===3?g._0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type:g._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type:g._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage;break;case 200:ve&&He(r,g.Mapped_object_type_implicitly_has_an_any_template_type);return;default:y=ve?g.Variable_0_implicitly_has_an_1_type:g.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage}Yu(ve,r,y,qo(qs(r)),d)}function Oae(r,a,_){n(()=>{ve&&Gn(a)&65536&&(!_||!iAe(r))&&(wae(a)||hb(r,a,_))})}function ECe(r,a,_){let d=Xp(r),y=Xp(a),T=UL(r),P=UL(a),L=P?y-1:y,J=T?L:Math.min(d,L),G=fb(r);if(G){let ae=fb(a);ae&&_(G,ae)}for(let ae=0;ae<J;ae++)_(Ig(r,ae),Ig(a,ae));P&&_(p$(r,J,fC(P)&&!rg(P,hCe)),P)}function xCe(r,a,_){let d=zd(r),y=zd(a);d&&y&&zxe(d,y)&&d.type&&y.type?_(d.type,y.type):_(Ao(r),Ao(a))}function OL(r,a,_,d){return CCe(r.map(kCe),a,_,d||oCe)}function mLt(r,a=0){return r&&CCe(vr(r.inferences,nWe),r.signature,r.flags|a,r.compareTypes)}function CCe(r,a,_,d){let y={inferences:r,signature:a,flags:_,compareTypes:d,mapper:Uo,nonFixingMapper:Uo};return y.mapper=gLt(y),y.nonFixingMapper=hLt(y),y}function gLt(r){return rCe(vr(r.inferences,a=>a.typeParameter),vr(r.inferences,(a,_)=>()=>(a.isFixed||(yLt(r),Rae(r.inferences),a.isFixed=!0),RCe(r,_))))}function hLt(r){return rCe(vr(r.inferences,a=>a.typeParameter),vr(r.inferences,(a,_)=>()=>RCe(r,_)))}function Rae(r){for(let a of r)a.isFixed||(a.inferredType=void 0)}function ACe(r,a,_){(r.intraExpressionInferenceSites??(r.intraExpressionInferenceSites=[])).push({node:a,type:_})}function yLt(r){if(r.intraExpressionInferenceSites){for(let{node:a,type:_}of r.intraExpressionInferenceSites){let d=a.kind===174?KWe(a,2):Bf(a,2);d&&o1(r.inferences,_,d)}r.intraExpressionInferenceSites=void 0}}function kCe(r){return{typeParameter:r,candidates:void 0,contraCandidates:void 0,inferredType:void 0,priority:void 0,topLevel:!0,isFixed:!1,impliedArity:void 0}}function nWe(r){return{typeParameter:r.typeParameter,candidates:r.candidates&&r.candidates.slice(),contraCandidates:r.contraCandidates&&r.contraCandidates.slice(),inferredType:r.inferredType,priority:r.priority,topLevel:r.topLevel,isFixed:r.isFixed,impliedArity:r.impliedArity}}function vLt(r){let a=Fn(r.inferences,MI);return a.length?CCe(vr(a,nWe),r.signature,r.flags,r.compareTypes):void 0}function PCe(r){return r&&r.mapper}function yb(r){let a=Gn(r);if(a&524288)return!!(a&1048576);let _=!!(r.flags&465829888||r.flags&524288&&!iWe(r)&&(a&4&&(r.node||Tt(cc(r),yb))||a&16&&r.symbol&&r.symbol.flags&14384&&r.symbol.declarations||a&12583968)||r.flags&3145728&&!(r.flags&1024)&&!iWe(r)&&Tt(r.types,yb));return r.flags&3899393&&(r.objectFlags|=524288|(_?1048576:0)),_}function iWe(r){if(r.aliasSymbol&&!r.aliasTypeArguments){let a=xc(r.aliasSymbol,265);return!!(a&&Gr(a.parent,_=>_.kind===312?!0:_.kind===267?!1:"quit"))}return!1}function RL(r,a,_=0){return!!(r===a||r.flags&3145728&&Tt(r.types,d=>RL(d,a,_))||_<3&&r.flags&16777216&&(RL(pb(r),a,_+1)||RL(db(r),a,_+1)))}function SLt(r,a){let _=zd(r);return _?!!_.type&&RL(_.type,a):RL(Ao(r),a)}function TLt(r){let a=ga();CC(r,d=>{if(!(d.flags&128))return;let y=Pc(d.value),T=oo(4,y);T.links.type=W,d.symbol&&(T.declarations=d.symbol.declarations,T.valueDeclaration=d.symbol.valueDeclaration),a.set(y,T)});let _=r.flags&4?[o0(Le,$a,!1)]:tt;return Ho(void 0,a,tt,tt,_)}function sWe(r,a,_){let d=r.id+","+a.id+","+_.id;if(Eu.has(d))return Eu.get(d);let y=r.id+","+(a.target||a).id;if(hs(Xf,y))return;Xf.push(y);let T=bLt(r,a,_);return Xf.pop(),Eu.set(d,T),T}function NCe(r){return!(Gn(r)&262144)||vb(r)&&Tt(Io(r),a=>NCe(vn(a)))||Ka(r)&&Tt(ZE(r),NCe)}function bLt(r,a,_){if(!(K0(r,Le)||Io(r).length!==0&&NCe(r)))return;if(Gd(r))return P_(Mae(cc(r)[0],a,_),m4(r));if(Ka(r)){let y=vr(ZE(r),P=>Mae(P,a,_)),T=s0(a)&4?ul(r.target.elementFlags,P=>P&2?1:P):r.target.elementFlags;return c0(y,T,r.target.readonly,r.target.labeledElementDeclarations)}let d=Ud(1040,void 0);return d.source=r,d.mappedType=a,d.constraintType=_,d}function ELt(r){let a=as(r);return a.type||(a.type=Mae(r.links.propertyType,r.links.mappedType,r.links.constraintType)),a.type}function Mae(r,a,_){let d=Ap(_.type,Ag(a)),y=Zy(a),T=kCe(d);return o1([T],r,y),aWe(T)||Sr}function*DCe(r,a,_,d){let y=Io(a);for(let T of y)if(!Yqe(T)&&(_||!(T.flags&16777216||Vc(T)&48))){let P=ka(r,T.escapedName);if(!P)yield T;else if(d){let L=vn(T);if(L.flags&109472){let J=vn(P);J.flags&1||af(J)===af(L)||(yield T)}}}}function ICe(r,a,_,d){return Oa(DCe(r,a,_,d))}function xLt(r,a){return!(a.target.combinedFlags&8)&&a.target.minLength>r.target.minLength||!a.target.hasRestElement&&(r.target.hasRestElement||a.target.fixedLength<r.target.fixedLength)}function CLt(r,a){return Ka(r)&&Ka(a)?xLt(r,a):!!ICe(r,a,!1,!0)&&!!ICe(a,r,!1,!1)}function aWe(r){return r.candidates?pi(r.candidates,2):r.contraCandidates?Pa(r.contraCandidates):void 0}function wCe(r){return!!_i(r).skipDirectInference}function oWe(r){return!!(r.symbol&&Tt(r.symbol.declarations,wCe))}function ALt(r,a){let _=r.texts[0],d=a.texts[0],y=r.texts[r.texts.length-1],T=a.texts[a.texts.length-1],P=Math.min(_.length,d.length),L=Math.min(y.length,T.length);return _.slice(0,P)!==d.slice(0,P)||y.slice(y.length-L)!==T.slice(T.length-L)}function cWe(r,a){if(r==="")return!1;let _=+r;return isFinite(_)&&(!a||""+_===r)}function kLt(r){return _ae(GX(r))}function Lae(r,a){if(a.flags&1)return!0;if(a.flags&134217732)return Na(r,a);if(a.flags&268435456){let _=[];for(;a.flags&268435456;)_.unshift(a.symbol),a=a.type;return d_(_,(y,T)=>aP(T,y),r)===r&&Lae(r,a)}return!1}function lWe(r,a){if(a.flags&2097152)return yr(a.types,_=>_===Nl||lWe(r,_));if(a.flags&4||Na(r,a))return!0;if(r.flags&128){let _=r.value;return!!(a.flags&8&&cWe(_,!1)||a.flags&64&&iB(_,!1)||a.flags&98816&&_===a.intrinsicName||a.flags&268435456&&Lae(jf(_),a)||a.flags&134217728&&Fae(r,a))}if(r.flags&134217728){let _=r.texts;return _.length===2&&_[0]===""&&_[1]===""&&Na(r.types[0],a)}return!1}function uWe(r,a){return r.flags&128?_We([r.value],tt,a):r.flags&134217728?Am(r.texts,a.texts)?vr(r.types,PLt):_We(r.texts,r.types,a):void 0}function Fae(r,a){let _=uWe(r,a);return!!_&&yr(_,(d,y)=>lWe(d,a.types[y]))}function PLt(r){return r.flags&402653317?r:mC(["",""],[r])}function _We(r,a,_){let d=r.length-1,y=r[0],T=r[d],P=_.texts,L=P.length-1,J=P[0],G=P[L];if(d===0&&y.length<J.length+G.length||!y.startsWith(J)||!T.endsWith(G))return;let ae=T.slice(0,T.length-G.length),Ce=[],be=0,Ye=J.length;for(let ur=1;ur<L;ur++){let pr=P[ur];if(pr.length>0){let dn=be,Ur=Ye;for(;Ur=vt(dn).indexOf(pr,Ur),!(Ur>=0);){if(dn++,dn===r.length)return;Ur=0}Dt(dn,Ur),Ye+=pr.length}else if(Ye<vt(be).length)Dt(be,Ye+1);else if(be<d)Dt(be+1,0);else return}return Dt(d,vt(d).length),Ce;function vt(ur){return ur<d?r[ur]:ae}function Dt(ur,pr){let dn=ur===be?jf(vt(ur).slice(Ye,pr)):mC([r[be].slice(Ye),...r.slice(be+1,ur),vt(ur).slice(0,pr)],a.slice(be,ur));Ce.push(dn),be=ur,Ye=pr}}function o1(r,a,_,d=0,y=!1){let T=!1,P,L=2048,J,G,ae,Ce=0;be(a,_);function be(Br,an){if(!(!yb(an)||u4(an))){if(Br===Nt||Br===Ke){let ms=P;P=Br,be(an,an),P=ms;return}if(Br.aliasSymbol&&Br.aliasSymbol===an.aliasSymbol){if(Br.aliasTypeArguments){let ms=as(Br.aliasSymbol).typeParameters,Pn=a0(ms),Vs=FS(Br.aliasTypeArguments,ms,Pn,gn(Br.aliasSymbol.valueDeclaration)),vo=FS(an.aliasTypeArguments,ms,Pn,gn(Br.aliasSymbol.valueDeclaration));dn(Vs,vo,V$e(Br.aliasSymbol))}return}if(Br===an&&Br.flags&3145728){for(let ms of Br.types)be(ms,ms);return}if(an.flags&1048576){let[ms,Pn]=pr(Br.flags&1048576?Br.types:[Br],an.types,NLt),[Vs,vo]=pr(ms,Pn,DLt);if(vo.length===0)return;if(an=pi(vo),Vs.length===0){Ye(Br,an,1);return}Br=pi(Vs)}else if(an.flags&2097152&&!yr(an.types,lae)&&!(Br.flags&1048576)){let[ms,Pn]=pr(Br.flags&2097152?Br.types:[Br],an.types,n1);if(ms.length===0||Pn.length===0)return;Br=Pa(ms),an=Pa(Pn)}if(an.flags&41943040){if(u4(an))return;an=US(an)}if(an.flags&8650752){if(oWe(Br))return;let ms=$r(an);if(ms){if(Gn(Br)&262144||Br===Cr)return;if(!ms.isFixed){let Vs=P||Br;if(Vs===Ke)return;(ms.priority===void 0||d<ms.priority)&&(ms.candidates=void 0,ms.contraCandidates=void 0,ms.topLevel=!0,ms.priority=d),d===ms.priority&&(y&&!T?hs(ms.contraCandidates,Vs)||(ms.contraCandidates=Pr(ms.contraCandidates,Vs),Rae(r)):hs(ms.candidates,Vs)||(ms.candidates=Pr(ms.candidates,Vs),Rae(r))),!(d&128)&&an.flags&262144&&ms.topLevel&&!RL(_,an)&&(ms.topLevel=!1,Rae(r))}L=Math.min(L,d);return}let Pn=r1(an,!1);if(Pn!==an)be(Br,Pn);else if(an.flags&8388608){let Vs=r1(an.indexType,!1);if(Vs.flags&465829888){let vo=_$e(r1(an.objectType,!1),Vs,!1);vo&&vo!==an&&be(Br,vo)}}}if(Gn(Br)&4&&Gn(an)&4&&(Br.target===an.target||Gd(Br)&&Gd(an))&&!(Br.node&&an.node))dn(cc(Br),cc(an),dCe(Br.target));else if(Br.flags&4194304&&an.flags&4194304)Ur(Br.type,an.type);else if((NL(Br)||Br.flags&4)&&an.flags&4194304){let ms=TLt(Br);vt(ms,an.type,256)}else if(Br.flags&8388608&&an.flags&8388608)be(Br.objectType,an.objectType),be(Br.indexType,an.indexType);else if(Br.flags&268435456&&an.flags&268435456)Br.symbol===an.symbol&&be(Br.type,an.type);else if(Br.flags&33554432)be(Br.baseType,an),Ye(Dxe(Br),an,4);else if(an.flags&16777216)ur(Br,an,cn);else if(an.flags&3145728)on(Br,an.types,an.flags);else if(Br.flags&1048576){let ms=Br.types;for(let Pn of ms)be(Pn,an)}else if(an.flags&134217728)Bs(Br,an);else{if(Br=Pg(Br),Ff(Br)&&Ff(an)&&ur(Br,an,Os),!(d&512&&Br.flags&467927040)){let ms=Tf(Br);if(ms!==Br&&!(ms.flags&2621440))return be(ms,an);Br=ms}Br.flags&2621440&&ur(Br,an,Ys)}}}function Ye(Br,an,ms){let Pn=d;d|=ms,be(Br,an),d=Pn}function vt(Br,an,ms){let Pn=d;d|=ms,Ur(Br,an),d=Pn}function Dt(Br,an,ms,Pn){let Vs=d;d|=Pn,on(Br,an,ms),d=Vs}function ur(Br,an,ms){let Pn=Br.id+","+an.id,Vs=J&&J.get(Pn);if(Vs!==void 0){L=Math.min(L,Vs);return}(J||(J=new Map)).set(Pn,-1);let vo=L;L=2048;let Bo=Ce;(G??(G=[])).push(Br),(ae??(ae=[])).push(an),d4(Br,G,G.length,2)&&(Ce|=1),d4(an,ae,ae.length,2)&&(Ce|=2),Ce!==3?ms(Br,an):L=-1,ae.pop(),G.pop(),Ce=Bo,J.set(Pn,L),L=Math.min(L,vo)}function pr(Br,an,ms){let Pn,Vs;for(let vo of an)for(let Bo of Br)ms(Bo,vo)&&(be(Bo,vo),Pn=ai(Pn,Bo),Vs=ai(Vs,vo));return[Pn?Fn(Br,vo=>!hs(Pn,vo)):Br,Vs?Fn(an,vo=>!hs(Vs,vo)):an]}function dn(Br,an,ms){let Pn=Br.length<an.length?Br.length:an.length;for(let Vs=0;Vs<Pn;Vs++)Vs<ms.length&&(ms[Vs]&7)===2?Ur(Br[Vs],an[Vs]):be(Br[Vs],an[Vs])}function Ur(Br,an){y=!y,be(Br,an),y=!y}function fr(Br,an){ce||d&1024?Ur(Br,an):be(Br,an)}function $r(Br){if(Br.flags&8650752){for(let an of r)if(Br===an.typeParameter)return an}}function Jr(Br){let an;for(let ms of Br){let Pn=ms.flags&2097152&&mr(ms.types,Vs=>!!$r(Vs));if(!Pn||an&&Pn!==an)return;an=Pn}return an}function on(Br,an,ms){let Pn=0;if(ms&1048576){let Vs,vo=Br.flags&1048576?Br.types:[Br],Bo=new Array(vo.length),N_=!1;for(let Qa of an)if($r(Qa))Vs=Qa,Pn++;else for(let bf=0;bf<vo.length;bf++){let el=L;L=2048,be(vo[bf],Qa),L===d&&(Bo[bf]=!0),N_=N_||L===-1,L=Math.min(L,el)}if(Pn===0){let Qa=Jr(an);Qa&&Ye(Br,Qa,1);return}if(Pn===1&&!N_){let Qa=_a(vo,(bf,el)=>Bo[el]?void 0:bf);if(Qa.length){be(pi(Qa),Vs);return}}}else for(let Vs of an)$r(Vs)?Pn++:be(Br,Vs);if(ms&2097152?Pn===1:Pn>0)for(let Vs of an)$r(Vs)&&Ye(Br,Vs,1)}function Qr(Br,an,ms){if(ms.flags&1048576||ms.flags&2097152){let Pn=!1;for(let Vs of ms.types)Pn=Qr(Br,an,Vs)||Pn;return Pn}if(ms.flags&4194304){let Pn=$r(ms.type);if(Pn&&!Pn.isFixed&&!oWe(Br)){let Vs=sWe(Br,an,ms);Vs&&Ye(Vs,Pn.typeParameter,Gn(Br)&262144?16:8)}return!0}if(ms.flags&262144){Ye(gh(Br,Br.pattern?2:0),ms,32);let Pn=_C(ms);if(Pn&&Qr(Br,an,Pn))return!0;let Vs=vr(Io(Br),vn),vo=vr(nf(Br),Bo=>Bo!==Zn?Bo.type:Qn);return be(pi(ys(Vs,vo)),Zy(an)),!0}return!1}function cn(Br,an){if(Br.flags&16777216)be(Br.checkType,an.checkType),be(Br.extendsType,an.extendsType),be(pb(Br),pb(an)),be(db(Br),db(an));else{let ms=[pb(an),db(an)];Dt(Br,ms,an.flags,y?64:0)}}function Bs(Br,an){let ms=uWe(Br,an),Pn=an.types;if(ms||yr(an.texts,Vs=>Vs.length===0))for(let Vs=0;Vs<Pn.length;Vs++){let vo=ms?ms[Vs]:Qn,Bo=Pn[Vs];if(vo.flags&128&&Bo.flags&8650752){let N_=$r(Bo),Qa=N_?k_(N_.typeParameter):void 0;if(Qa&&!wt(Qa)){let bf=Qa.flags&1048576?Qa.types:[Qa],el=d_(bf,(Oc,_t)=>Oc|_t.flags,0);if(!(el&4)){let Oc=vo.value;el&296&&!cWe(Oc,!0)&&(el&=-297),el&2112&&!iB(Oc,!0)&&(el&=-2113);let _t=d_(bf,(Ne,jr)=>jr.flags&el?Ne.flags&4?Ne:jr.flags&4?vo:Ne.flags&134217728?Ne:jr.flags&134217728&&Fae(vo,jr)?vo:Ne.flags&268435456?Ne:jr.flags&268435456&&Oc===o$e(jr.symbol,Oc)?vo:Ne.flags&128?Ne:jr.flags&128&&jr.value===Oc?jr:Ne.flags&8?Ne:jr.flags&8?Ng(+Oc):Ne.flags&32?Ne:jr.flags&32?Ng(+Oc):Ne.flags&256?Ne:jr.flags&256&&jr.value===+Oc?jr:Ne.flags&64?Ne:jr.flags&64?kLt(Oc):Ne.flags&2048?Ne:jr.flags&2048&&nE(jr.value)===Oc?jr:Ne.flags&16?Ne:jr.flags&16?Oc==="true"?zr:Oc==="false"?Zt:Pi:Ne.flags&512?Ne:jr.flags&512&&jr.intrinsicName===Oc?jr:Ne.flags&32768?Ne:jr.flags&32768&&jr.intrinsicName===Oc?jr:Ne.flags&65536?Ne:jr.flags&65536&&jr.intrinsicName===Oc?jr:Ne:Ne,Qn);if(!(_t.flags&131072)){be(_t,Bo);continue}}}}be(vo,Bo)}}function Os(Br,an){be(bd(Br),bd(an)),be(Zy(Br),Zy(an));let ms=nv(Br),Pn=nv(an);ms&&Pn&&be(ms,Pn)}function Ys(Br,an){var ms,Pn;if(Gn(Br)&4&&Gn(an)&4&&(Br.target===an.target||Gd(Br)&&Gd(an))){dn(cc(Br),cc(an),dCe(Br.target));return}if(Ff(Br)&&Ff(an)&&Os(Br,an),Gn(an)&32&&!an.declaration.nameType){let Vs=bd(an);if(Qr(Br,an,Vs))return}if(!CLt(Br,an)){if(gb(Br)){if(Ka(an)){let Vs=sv(Br),vo=sv(an),Bo=cc(an),N_=an.target.elementFlags;if(Ka(Br)&&sLt(Br,an)){for(let el=0;el<vo;el++)be(cc(Br)[el],Bo[el]);return}let Qa=Ka(Br)?Math.min(Br.target.fixedLength,an.target.fixedLength):0,bf=Math.min(Ka(Br)?SL(Br.target,3):0,an.target.hasRestElement?SL(an.target,3):0);for(let el=0;el<Qa;el++)be(cc(Br)[el],Bo[el]);if(!Ka(Br)||Vs-Qa-bf===1&&Br.target.elementFlags[Qa]&4){let el=cc(Br)[Qa];for(let Oc=Qa;Oc<vo-bf;Oc++)be(N_[Oc]&8?P_(el):el,Bo[Oc])}else{let el=vo-Qa-bf;if(el===2){if(N_[Qa]&N_[Qa+1]&8){let Oc=$r(Bo[Qa]);Oc&&Oc.impliedArity!==void 0&&(be(f4(Br,Qa,bf+Vs-Oc.impliedArity),Bo[Qa]),be(f4(Br,Qa+Oc.impliedArity,bf),Bo[Qa+1]))}else if(N_[Qa]&8&&N_[Qa+1]&4){let Oc=(ms=$r(Bo[Qa]))==null?void 0:ms.typeParameter,_t=Oc&&k_(Oc);if(_t&&Ka(_t)&&!_t.target.hasRestElement){let Ne=_t.target.fixedLength;be(f4(Br,Qa,Vs-(Qa+Ne)),Bo[Qa]),be(h4(Br,Qa+Ne,bf),Bo[Qa+1])}}else if(N_[Qa]&4&&N_[Qa+1]&8){let Oc=(Pn=$r(Bo[Qa+1]))==null?void 0:Pn.typeParameter,_t=Oc&&k_(Oc);if(_t&&Ka(_t)&&!_t.target.hasRestElement){let Ne=_t.target.fixedLength,jr=Vs-SL(an.target,3),Vn=jr-Ne,bi=c0(cc(Br).slice(Vn,jr),Br.target.elementFlags.slice(Vn,jr),!1,Br.target.labeledElementDeclarations&&Br.target.labeledElementDeclarations.slice(Vn,jr));be(h4(Br,Qa,bf+Ne),Bo[Qa]),be(bi,Bo[Qa+1])}}}else if(el===1&&N_[Qa]&8){let Oc=an.target.elementFlags[vo-1]&2,_t=f4(Br,Qa,bf);Ye(_t,Bo[Qa],Oc?2:0)}else if(el===1&&N_[Qa]&4){let Oc=h4(Br,Qa,bf);Oc&&be(Oc,Bo[Qa])}}for(let el=0;el<bf;el++)be(cc(Br)[Vs-el-1],Bo[vo-el-1]);return}if(Gd(an)){rp(Br,an);return}}As(Br,an),su(Br,an,0),su(Br,an,1),rp(Br,an)}}function As(Br,an){let ms=LS(an);for(let Pn of ms){let Vs=ka(Br,Pn.escapedName);Vs&&!Tt(Vs.declarations,wCe)&&be(vn(Vs),vn(Pn))}}function su(Br,an,ms){let Pn=na(Br,ms),Vs=Pn.length;if(Vs>0){let vo=na(an,ms),Bo=vo.length;for(let N_=0;N_<Bo;N_++){let Qa=Math.max(Vs-Bo+N_,0);Hd(LRt(Pn[Qa]),yL(vo[N_]))}}}function Hd(Br,an){if(!(Br.flags&64)){let ms=T,Pn=an.declaration?an.declaration.kind:0;T=T||Pn===174||Pn===173||Pn===176,ECe(Br,an,fr),T=ms}xCe(Br,an,be)}function rp(Br,an){let ms=Gn(Br)&Gn(an)&32?8:0,Pn=nf(an);if(Iae(Br))for(let Vs of Pn){let vo=[];for(let Bo of Io(Br))if(nP(CI(Bo,8576),Vs.keyType)){let N_=vn(Bo);vo.push(Bo.flags&16777216?Dae(N_):N_)}for(let Bo of nf(Br))nP(Bo.keyType,Vs.keyType)&&vo.push(Bo.type);vo.length&&Ye(pi(vo),Vs.type,ms)}for(let Vs of Pn){let vo=mL(Br,Vs.keyType);vo&&Ye(vo.type,Vs.type,ms)}}}function NLt(r,a){return a===B?r===a:n1(r,a)||!!(a.flags&4&&r.flags&128||a.flags&8&&r.flags&256)}function DLt(r,a){return!!(r.flags&524288&&a.flags&524288&&r.symbol&&r.symbol===a.symbol||r.aliasSymbol&&r.aliasTypeArguments&&r.aliasSymbol===a.aliasSymbol)}function ILt(r){let a=Sf(r);return!!a&&$c(a.flags&16777216?uxe(a):a,406978556)}function vb(r){return!!(Gn(r)&128)}function OCe(r){return!!(Gn(r)&16512)}function wLt(r){if(r.length>1){let a=Fn(r,OCe);if(a.length){let _=pi(a,2);return ys(Fn(r,d=>!OCe(d)),[_])}}return r}function OLt(r){return r.priority&416?Pa(r.contraCandidates):Q7t(r.contraCandidates)}function RLt(r,a){let _=wLt(r.candidates),d=ILt(r.typeParameter)||fC(r.typeParameter),y=!d&&r.topLevel&&(r.isFixed||!SLt(a,r.typeParameter)),T=d?ul(_,af):y?ul(_,i2):_,P=r.priority&416?pi(T,2):K7t(T);return Yp(P)}function RCe(r,a){let _=r.inferences[a];if(!_.inferredType){let d,y;if(r.signature){let P=_.candidates?RLt(_,r.signature):void 0,L=_.contraCandidates?OLt(_):void 0;if(P||L){let J=P&&(!L||!(P.flags&131072)&&Tt(_.contraCandidates,G=>JS(P,G))&&yr(r.inferences,G=>G!==_&&Sf(G.typeParameter)!==_.typeParameter||yr(G.candidates,ae=>JS(ae,P))));d=J?P:L,y=J?L:P}else if(r.flags&1)d=Ns;else{let J=pC(_.typeParameter);J&&(d=gs(J,_7t(u7t(r,a),r.nonFixingMapper)))}}else d=aWe(_);_.inferredType=d||MCe(!!(r.flags&2));let T=Sf(_.typeParameter);if(T){let P=gs(T,r.nonFixingMapper);(!d||!r.compareTypes(d,Hp(P,d)))&&(_.inferredType=y&&r.compareTypes(y,Hp(P,y))?y:P)}}return _.inferredType}function MCe(r){return r?W:Sr}function LCe(r){let a=[];for(let _=0;_<r.inferences.length;_++)a.push(RCe(r,_));return a}function fWe(r){switch(r.escapedText){case"document":case"console":return g.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom;case"$":return $.types?g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig:g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery;case"describe":case"suite":case"it":case"test":return $.types?g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig:g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha;case"process":case"require":case"Buffer":case"module":return $.types?g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig:g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode;case"Bun":return $.types?g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_and_then_add_bun_to_the_types_field_in_your_tsconfig:g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun;case"Map":case"Set":case"Promise":case"Symbol":case"WeakMap":case"WeakSet":case"Iterator":case"AsyncIterator":case"SharedArrayBuffer":case"Atomics":case"AsyncIterable":case"AsyncIterableIterator":case"AsyncGenerator":case"AsyncGeneratorFunction":case"BigInt":case"Reflect":case"BigInt64Array":case"BigUint64Array":return g.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later;case"await":if(da(r.parent))return g.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function;default:return r.parent.kind===304?g.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer:g.Cannot_find_name_0}}function tg(r){let a=_i(r);return a.resolvedSymbol||(a.resolvedSymbol=!sl(r)&&wc(r,r.escapedText,1160127,fWe(r),r,!Bj(r),!1)||dt),a.resolvedSymbol}function FCe(r){return!!(r.flags&33554432||Gr(r,a=>ef(a)||Vm(a)||dp(a)))}function jae(r,a,_,d){switch(r.kind){case 80:if(!NA(r)){let P=tg(r);return P!==dt?`${d?yo(d):"-1"}|${sf(a)}|${sf(_)}|${Ia(P)}`:void 0}case 110:return`0|${d?yo(d):"-1"}|${sf(a)}|${sf(_)}`;case 235:case 217:return jae(r.expression,a,_,d);case 166:let y=jae(r.left,a,_,d);return y&&y+"."+r.right.escapedText;case 211:case 212:let T=bC(r);if(T!==void 0){let P=jae(r.expression,a,_,d);return P&&P+"."+T}break;case 206:case 207:case 262:case 218:case 219:case 174:return`${yo(r)}#${sf(a)}`}}function o_(r,a){switch(a.kind){case 217:case 235:return o_(r,a.expression);case 226:return lu(a)&&o_(r,a.left)||bn(a)&&a.operatorToken.kind===28&&o_(r,a.right)}switch(r.kind){case 236:return a.kind===236&&r.keywordToken===a.keywordToken&&r.name.escapedText===a.name.escapedText;case 80:case 81:return NA(r)?a.kind===110:a.kind===80&&tg(r)===tg(a)||(Gi(a)||co(a))&&vd(tg(r))===Rn(a);case 110:return a.kind===110;case 108:return a.kind===108;case 235:case 217:return o_(r.expression,a);case 211:case 212:let _=bC(r),d=Yo(a)?bC(a):void 0;return _!==void 0&&d!==void 0&&d===_&&o_(r.expression,a.expression);case 166:return Yo(a)&&r.right.escapedText===bC(a)&&o_(r.left,a.expression);case 226:return bn(r)&&r.operatorToken.kind===28&&o_(r.right,a)}return!1}function bC(r){if(Hn(r))return r.name.escapedText;if(fc(r))return MLt(r);if(co(r)){let a=_o(r);return a?Pc(a):void 0}if(Ls(r))return""+r.parent.parameters.indexOf(r)}function jCe(r){return r.flags&8192?r.escapedName:r.flags&384?Pc(""+r.value):void 0}function MLt(r){return id(r.argumentExpression)?Pc(r.argumentExpression.text):ol(r.argumentExpression)?LLt(r.argumentExpression):void 0}function LLt(r){let a=ac(r,111551,!0);if(!a||!(b4(a)||a.flags&8))return;let _=a.valueDeclaration;if(_===void 0)return;let d=ps(_);if(d){let y=jCe(d);if(y!==void 0)return y}if(V2(_)&&qy(_,r)){let y=N8(_);if(y){let T=la(_.parent)?mh(_):l_(y);return T&&jCe(T)}if(gE(_))return iN(_.name)}}function pWe(r,a){for(;Yo(r);)if(r=r.expression,o_(r,a))return!0;return!1}function EC(r,a){for(;w_(r);)if(r=r.expression,o_(r,a))return!0;return!1}function y4(r,a){if(r&&r.flags&1048576){let _=dze(r,a);if(_&&Vc(_)&2)return _.links.isDiscriminantProperty===void 0&&(_.links.isDiscriminantProperty=(_.links.checkFlags&192)===192&&!AI(vn(_))),!!_.links.isDiscriminantProperty}return!1}function dWe(r,a){let _;for(let d of r)if(y4(a,d.escapedName)){if(_){_.push(d);continue}_=[d]}return _}function FLt(r,a){let _=new Map,d=0;for(let y of r)if(y.flags&61603840){let T=Xe(y,a);if(T){if(!NL(T))return;let P=!1;CC(T,L=>{let J=sf(af(L)),G=_.get(J);G?G!==Sr&&(_.set(J,Sr),P=!0):_.set(J,y)}),P||d++}}return d>=10&&d*2>=r.length?_:void 0}function qz(r){let a=r.types;if(!(a.length<10||Gn(r)&32768||mu(a,_=>!!(_.flags&59506688))<10)){if(r.keyPropertyName===void 0){let _=Te(a,y=>y.flags&59506688?Te(Io(y),T=>Dg(vn(T))?T.escapedName:void 0):void 0),d=_&&FLt(a,_);r.keyPropertyName=d?_:"",r.constituentMap=d}return r.keyPropertyName.length?r.keyPropertyName:void 0}}function zz(r,a){var _;let d=(_=r.constituentMap)==null?void 0:_.get(sf(af(a)));return d!==Sr?d:void 0}function mWe(r,a){let _=qz(r),d=_&&Xe(a,_);return d&&zz(r,d)}function jLt(r,a){let _=qz(r),d=_&&mr(a.properties,T=>T.symbol&&T.kind===303&&T.symbol.escapedName===_&&Qz(T.initializer)),y=d&&S$(d.initializer);return y&&zz(r,y)}function gWe(r,a){return o_(r,a)||pWe(r,a)}function hWe(r,a){if(r.arguments){for(let _ of r.arguments)if(gWe(a,_)||EC(_,a))return!0}return!!(r.expression.kind===211&&gWe(a,r.expression.expression))}function BCe(r){return(!r.id||r.id<0)&&(r.id=i0e,i0e++),r.id}function BLt(r,a){if(!(r.flags&1048576))return Na(r,a);for(let _ of r.types)if(Na(_,a))return!0;return!1}function ULt(r,a){if(r===a)return r;if(a.flags&131072)return a;let _=`A${sf(r)},${sf(a)}`;return Vk(_)??dS(_,VLt(r,a))}function VLt(r,a){let _=wl(r,y=>BLt(a,y)),d=a.flags&512&&t2(a)?Ec(_,cP):_;return Na(a,d)?d:r}function UCe(r){let a=kg(r);return!!(a.callSignatures.length||a.constructSignatures.length||a.members.get("bind")&&JS(r,Bt))}function v4(r,a){return VCe(r,a)&a}function bm(r,a){return v4(r,a)!==0}function VCe(r,a){r.flags&467927040&&(r=k_(r)||Sr);let _=r.flags;if(_&268435460)return Q?16317953:16776705;if(_&134217856){let d=_&128&&r.value==="";return Q?d?12123649:7929345:d?12582401:16776705}if(_&40)return Q?16317698:16776450;if(_&256){let d=r.value===0;return Q?d?12123394:7929090:d?12582146:16776450}if(_&64)return Q?16317188:16775940;if(_&2048){let d=Q$e(r);return Q?d?12122884:7928580:d?12581636:16775940}return _&16?Q?16316168:16774920:_&528?Q?r===Zt||r===Ir?12121864:7927560:r===Zt||r===Ir?12580616:16774920:_&524288?a&(Q?83427327:83886079)?Gn(r)&16&&i1(r)?Q?83427327:83886079:UCe(r)?Q?7880640:16728e3:Q?7888800:16736160:0:_&16384?9830144:_&32768?26607360:_&65536?42917664:_&12288?Q?7925520:16772880:_&67108864?Q?7888800:16736160:_&131072?0:_&1048576?d_(r.types,(d,y)=>d|VCe(y,a),0):_&2097152?JLt(r,a):83886079}function JLt(r,a){let _=$c(r,402784252),d=0,y=134217727;for(let T of r.types)if(!(_&&T.flags&524288)){let P=VCe(T,a);d|=P,y&=P}return d&8256|y&134209471}function Em(r,a){return wl(r,_=>bm(_,a))}function xC(r,a){let _=yWe(Em(Q&&r.flags&2?Tc:r,a));if(Q)switch(a){case 524288:return Ec(_,d=>bm(d,65536)?Pa([d,bm(d,131072)&&!$c(_,65536)?pi([$a,he]):$a]):d);case 1048576:return Ec(_,d=>bm(d,131072)?Pa([d,bm(d,65536)&&!$c(_,32768)?pi([$a,Be]):$a]):d);case 2097152:case 4194304:return Ec(_,d=>bm(d,262144)?cLt(d):d)}return _}function yWe(r){return r===Tc?Sr:r}function JCe(r,a){return a?pi([Ai(r),l_(a)]):r}function vWe(r,a){var _;let d=av(a);if(!um(d))return ht;let y=_m(d);return Xe(r,y)||ML((_=iP(r,y))==null?void 0:_.type)||ht}function SWe(r,a){return tp(r,g4)&&Z7t(r,a)||ML(uv(65,r,Be,void 0))||ht}function ML(r){return r&&($.noUncheckedIndexedAccess?pi([r,B]):r)}function TWe(r){return P_(uv(65,r,Be,void 0)||ht)}function qLt(r){return r.parent.kind===209&&qCe(r.parent)||r.parent.kind===303&&qCe(r.parent.parent)?JCe($z(r),r.right):l_(r.right)}function qCe(r){return r.parent.kind===226&&r.parent.left===r||r.parent.kind===250&&r.parent.initializer===r}function zLt(r,a){return SWe($z(r),r.elements.indexOf(a))}function $Lt(r){return TWe($z(r.parent))}function bWe(r){return vWe($z(r.parent),r.name)}function WLt(r){return JCe(bWe(r),r.objectAssignmentInitializer)}function $z(r){let{parent:a}=r;switch(a.kind){case 249:return Le;case 250:return A$(a)||ht;case 226:return qLt(a);case 220:return Be;case 209:return zLt(a,r);case 230:return $Lt(a);case 303:return bWe(a);case 304:return WLt(a)}return ht}function GLt(r){let a=r.parent,_=xWe(a.parent),d=a.kind===206?vWe(_,r.propertyName||r.name):r.dotDotDotToken?TWe(_):SWe(_,a.elements.indexOf(r));return JCe(d,r.initializer)}function EWe(r){return _i(r).resolvedType||l_(r)}function HLt(r){return r.initializer?EWe(r.initializer):r.parent.parent.kind===249?Le:r.parent.parent.kind===250&&A$(r.parent.parent)||ht}function xWe(r){return r.kind===260?HLt(r):GLt(r)}function YLt(r){return r.kind===260&&r.initializer&&NS(r.initializer)||r.kind!==208&&r.parent.kind===226&&NS(r.parent.right)}function s2(r){switch(r.kind){case 217:return s2(r.expression);case 226:switch(r.operatorToken.kind){case 64:case 76:case 77:case 78:return s2(r.left);case 28:return s2(r.right)}}return r}function CWe(r){let{parent:a}=r;return a.kind===217||a.kind===226&&a.operatorToken.kind===64&&a.left===r||a.kind===226&&a.operatorToken.kind===28&&a.right===r?CWe(a):r}function XLt(r){return r.kind===296?af(l_(r.expression)):Qn}function Bae(r){let a=_i(r);if(!a.switchTypes){a.switchTypes=[];for(let _ of r.caseBlock.clauses)a.switchTypes.push(XLt(_))}return a.switchTypes}function AWe(r){if(Tt(r.caseBlock.clauses,_=>_.kind===296&&!bo(_.expression)))return;let a=[];for(let _ of r.caseBlock.clauses){let d=_.kind===296?_.expression.text:void 0;a.push(d&&!hs(a,d)?d:void 0)}return a}function KLt(r,a){return r.flags&1048576?!Te(r.types,_=>!hs(a,_)):hs(a,r)}function S4(r,a){return!!(r===a||r.flags&131072||a.flags&1048576&&QLt(r,a))}function QLt(r,a){if(r.flags&1048576){for(let _ of r.types)if(!t1(a.types,_))return!1;return!0}return r.flags&1056&&Wse(r)===a?!0:t1(a.types,r)}function CC(r,a){return r.flags&1048576?Te(r.types,a):a(r)}function rg(r,a){return r.flags&1048576?Tt(r.types,a):a(r)}function tp(r,a){return r.flags&1048576?yr(r.types,a):a(r)}function ZLt(r,a){return r.flags&3145728?yr(r.types,a):a(r)}function wl(r,a){if(r.flags&1048576){let _=r.types,d=Fn(_,a);if(d===_)return r;let y=r.origin,T;if(y&&y.flags&1048576){let P=y.types,L=Fn(P,J=>!!(J.flags&1048576)||a(J));if(P.length-L.length===_.length-d.length){if(L.length===1)return L[0];T=qxe(1048576,L)}}return $xe(d,r.objectFlags&16809984,void 0,void 0,T)}return r.flags&131072||a(r)?r:Qn}function Uae(r,a){return wl(r,_=>_!==a)}function eFt(r){return r.flags&1048576?r.types.length:1}function Ec(r,a,_){if(r.flags&131072)return r;if(!(r.flags&1048576))return a(r);let d=r.origin,y=d&&d.flags&1048576?d.types:r.types,T,P=!1;for(let L of y){let J=L.flags&1048576?Ec(L,a,_):a(L);P||(P=L!==J),J&&(T?T.push(J):T=[J])}return P?T&&pi(T,_?0:1):r}function kWe(r,a,_,d){return r.flags&1048576&&_?pi(vr(r.types,a),1,_,d):Ec(r,a)}function T4(r,a){return wl(r,_=>(_.flags&a)!==0)}function PWe(r,a){return $c(r,134217804)&&$c(a,402655616)?Ec(r,_=>_.flags&4?T4(a,402653316):gC(_)&&!$c(a,402653188)?T4(a,128):_.flags&8?T4(a,264):_.flags&64?T4(a,2112):_):r}function NI(r){return r.flags===0}function AC(r){return r.flags===0?r.type:r}function DI(r,a){return a?{flags:0,type:r.flags&131072?Ns:r}:r}function tFt(r){let a=Ud(256);return a.elementType=r,a}function zCe(r){return qr[r.id]||(qr[r.id]=tFt(r))}function NWe(r,a){let _=wL(s1(S$(a)));return S4(_,r.elementType)?r:zCe(pi([r.elementType,_]))}function rFt(r){return r.flags&131072?xu:P_(r.flags&1048576?pi(r.types,2):r)}function nFt(r){return r.finalArrayType||(r.finalArrayType=rFt(r.elementType))}function Wz(r){return Gn(r)&256?nFt(r):r}function iFt(r){return Gn(r)&256?r.elementType:Qn}function sFt(r){let a=!1;for(let _ of r)if(!(_.flags&131072)){if(!(Gn(_)&256))return!1;a=!0}return a}function DWe(r){let a=CWe(r),_=a.parent,d=Hn(_)&&(_.name.escapedText==="length"||_.parent.kind===213&&ze(_.name)&&cX(_.name)),y=_.kind===212&&_.expression===a&&_.parent.kind===226&&_.parent.operatorToken.kind===64&&_.parent.left===_&&!N0(_.parent)&&c_(l_(_.argumentExpression),296);return d||y}function aFt(r){return(Gi(r)||ea(r)||fp(r)||Ls(r))&&!!(t_(r)||gn(r)&&jv(r)&&r.initializer&&iE(r.initializer)&&lm(r.initializer))}function Vae(r,a){if(r=ll(r),r.flags&8752)return vn(r);if(r.flags&7){if(Vc(r)&262144){let d=r.links.syntheticOrigin;if(d&&Vae(d))return vn(r)}let _=r.valueDeclaration;if(_){if(aFt(_))return vn(r);if(Gi(_)&&_.parent.parent.kind===250){let d=_.parent.parent,y=Gz(d.expression,void 0);if(y){let T=d.awaitModifier?15:13;return uv(T,y,Be,void 0)}}a&&Ga(a,$n(_,g._0_needs_an_explicit_type_annotation,Oi(r)))}}}function Gz(r,a){if(!(r.flags&67108864))switch(r.kind){case 80:let _=vd(tg(r));return Vae(_,a);case 110:return kFt(r);case 108:return KCe(r);case 211:{let d=Gz(r.expression,a);if(d){let y=r.name,T;if(is(y)){if(!d.symbol)return;T=ka(d,G8(d.symbol,y.escapedText))}else T=ka(d,y.escapedText);return T&&Vae(T,a)}return}case 217:return Gz(r.expression,a)}}function Hz(r){let a=_i(r),_=a.effectsSignature;if(_===void 0){let d;if(bn(r)){let P=II(r.right);d=JAe(P)}else r.parent.kind===244?d=Gz(r.expression,void 0):r.expression.kind!==108&&(w_(r)?d=yh(DL(Cs(r.expression),r.expression),r.expression):d=II(r.expression));let y=na(d&&Tf(d)||Sr,0),T=y.length===1&&!y[0].typeParameters?y[0]:Tt(y,IWe)?OI(r):void 0;_=a.effectsSignature=T&&IWe(T)?T:gr}return _===gr?void 0:_}function IWe(r){return!!(zd(r)||r.declaration&&(TI(r.declaration)||Sr).flags&131072)}function oFt(r,a){if(r.kind===1||r.kind===3)return a.arguments[r.parameterIndex];let _=Do(a.expression);return Yo(_)?Do(_.expression):void 0}function cFt(r){let a=Gr(r,uY),_=Xr(r),d=Fh(_,a.statements.pos);fo.add(Iu(_,d.start,d.length,g.The_containing_function_or_module_body_is_too_large_for_control_flow_analysis))}function Yz(r){let a=Jae(r,!1);return Ft=r,Ht=a,a}function Xz(r){let a=Do(r,!0);return a.kind===97||a.kind===226&&(a.operatorToken.kind===56&&(Xz(a.left)||Xz(a.right))||a.operatorToken.kind===57&&Xz(a.left)&&Xz(a.right))}function Jae(r,a){for(;;){if(r===Ft)return Ht;let _=r.flags;if(_&4096){if(!a){let d=BCe(r),y=Fx[d];return y!==void 0?y:Fx[d]=Jae(r,!0)}a=!1}if(_&368)r=r.antecedent;else if(_&512){let d=Hz(r.node);if(d){let y=zd(d);if(y&&y.kind===3&&!y.type){let T=r.node.arguments[y.parameterIndex];if(T&&Xz(T))return!1}if(Ao(d).flags&131072)return!1}r=r.antecedent}else{if(_&4)return Tt(r.antecedents,d=>Jae(d,!1));if(_&8){let d=r.antecedents;if(d===void 0||d.length===0)return!1;r=d[0]}else if(_&128){if(r.clauseStart===r.clauseEnd&&fHe(r.switchStatement))return!1;r=r.antecedent}else if(_&1024){Ft=void 0;let d=r.target,y=d.antecedents;d.antecedents=r.antecedents;let T=Jae(r.antecedent,!1);return d.antecedents=y,T}else return!(_&1)}}}function qae(r,a){for(;;){let _=r.flags;if(_&4096){if(!a){let d=BCe(r),y=Uk[d];return y!==void 0?y:Uk[d]=qae(r,!0)}a=!1}if(_&496)r=r.antecedent;else if(_&512){if(r.node.expression.kind===108)return!0;r=r.antecedent}else{if(_&4)return yr(r.antecedents,d=>qae(d,!1));if(_&8)r=r.antecedents[0];else if(_&1024){let d=r.target,y=d.antecedents;d.antecedents=r.antecedents;let T=qae(r.antecedent,!1);return d.antecedents=y,T}else return!!(_&1)}}}function wWe(r){switch(r.kind){case 110:return!0;case 80:if(!NA(r)){let _=tg(r);return b4(_)||$ae(_)&&!OWe(_)}break;case 211:case 212:return wWe(r.expression)&&wg(_i(r).resolvedSymbol||dt);case 206:case 207:let a=Gg(r.parent);return Ls(a)||Jme(a)?!$Ce(a):Gi(a)&&w$(a)}return!1}function GS(r,a,_=a,d,y=(T=>(T=ii(r,B8))==null?void 0:T.flowNode)()){let T,P=!1,L=0;if(Je)return ht;if(!y)return a;et++;let J=By,G=AC(be(y));By=J;let ae=Gn(G)&256&&DWe(r)?xu:Wz(G);if(ae===ji||r.parent&&r.parent.kind===235&&!(ae.flags&131072)&&Em(ae,2097152).flags&131072)return a;return ae===Y?Sr:ae;function Ce(){return P?T:(P=!0,T=jae(r,a,_,d))}function be(lt){var Ut;if(L===2e3)return(Ut=mn)==null||Ut.instant(mn.Phase.CheckTypes,"getTypeAtFlowNode_DepthLimit",{flowId:lt.id}),Je=!0,cFt(r),ht;L++;let sr;for(;;){let rr=lt.flags;if(rr&4096){for(let Wr=J;Wr<By;Wr++)if(jk[Wr]===lt)return L--,Bk[Wr];sr=lt}let dr;if(rr&16){if(dr=vt(lt),!dr){lt=lt.antecedent;continue}}else if(rr&512){if(dr=ur(lt),!dr){lt=lt.antecedent;continue}}else if(rr&96)dr=dn(lt);else if(rr&128)dr=Ur(lt);else if(rr&12){if(lt.antecedents.length===1){lt=lt.antecedents[0];continue}dr=rr&4?fr(lt):$r(lt)}else if(rr&256){if(dr=pr(lt),!dr){lt=lt.antecedent;continue}}else if(rr&1024){let Wr=lt.target,Ii=Wr.antecedents;Wr.antecedents=lt.antecedents,dr=be(lt.antecedent),Wr.antecedents=Ii}else if(rr&2){let Wr=lt.node;if(Wr&&Wr!==d&&r.kind!==211&&r.kind!==212&&!(r.kind===110&&Wr.kind!==219)){lt=Wr.flowNode;continue}dr=_}else dr=XL(a);return sr&&(jk[By]=sr,Bk[By]=dr,By++),L--,dr}}function Ye(lt){let Ut=lt.node;return WCe(Ut.kind===260||Ut.kind===208?xWe(Ut):$z(Ut),r)}function vt(lt){let Ut=lt.node;if(o_(r,Ut)){if(!Yz(lt))return ji;if(kA(Ut)===2){let rr=be(lt.antecedent);return DI(s1(AC(rr)),NI(rr))}if(a===st||a===xu){if(YLt(Ut))return zCe(Qn);let rr=i2(Ye(lt));return Na(rr,a)?rr:bl}let sr=eX(Ut)?s1(a):a;return sr.flags&1048576?ULt(sr,Ye(lt)):sr}if(pWe(r,Ut)){if(!Yz(lt))return ji;if(Gi(Ut)&&(gn(Ut)||w$(Ut))){let sr=D8(Ut);if(sr&&(sr.kind===218||sr.kind===219))return be(lt.antecedent)}return a}if(Gi(Ut)&&Ut.parent.parent.kind===249&&(o_(r,Ut.parent.parent.expression)||EC(Ut.parent.parent.expression,r)))return dAe(Wz(AC(be(lt.antecedent))))}function Dt(lt,Ut){let sr=Do(Ut,!0);if(sr.kind===97)return ji;if(sr.kind===226){if(sr.operatorToken.kind===56)return Dt(Dt(lt,sr.left),sr.right);if(sr.operatorToken.kind===57)return pi([Dt(lt,sr.left),Dt(lt,sr.right)])}return ei(lt,sr,!0)}function ur(lt){let Ut=Hz(lt.node);if(Ut){let sr=zd(Ut);if(sr&&(sr.kind===2||sr.kind===3)){let rr=be(lt.antecedent),dr=Wz(AC(rr)),Wr=sr.type?Li(dr,sr,lt.node,!0):sr.kind===3&&sr.parameterIndex>=0&&sr.parameterIndex<lt.node.arguments.length?Dt(dr,lt.node.arguments[sr.parameterIndex]):dr;return Wr===dr?rr:DI(Wr,NI(rr))}if(Ao(Ut).flags&131072)return ji}}function pr(lt){if(a===st||a===xu){let Ut=lt.node,sr=Ut.kind===213?Ut.expression.expression:Ut.left.expression;if(o_(r,s2(sr))){let rr=be(lt.antecedent),dr=AC(rr);if(Gn(dr)&256){let Wr=dr;if(Ut.kind===213)for(let Ii of Ut.arguments)Wr=NWe(Wr,Ii);else{let Ii=S$(Ut.left.argumentExpression);c_(Ii,296)&&(Wr=NWe(Wr,Ut.right))}return Wr===dr?rr:DI(Wr,NI(rr))}return rr}}}function dn(lt){let Ut=be(lt.antecedent),sr=AC(Ut);if(sr.flags&131072)return Ut;let rr=(lt.flags&32)!==0,dr=Wz(sr),Wr=ei(dr,lt.node,rr);return Wr===dr?Ut:DI(Wr,NI(Ut))}function Ur(lt){let Ut=Do(lt.switchStatement.expression),sr=be(lt.antecedent),rr=AC(sr);if(o_(r,Ut))rr=Bo(rr,lt.switchStatement,lt.clauseStart,lt.clauseEnd);else if(Ut.kind===221&&o_(r,Ut.expression))rr=bf(rr,lt.switchStatement,lt.clauseStart,lt.clauseEnd);else if(Ut.kind===112)rr=el(rr,lt.switchStatement,lt.clauseStart,lt.clauseEnd);else{Q&&(EC(Ut,r)?rr=vo(rr,lt.switchStatement,lt.clauseStart,lt.clauseEnd,Wr=>!(Wr.flags&163840)):Ut.kind===221&&EC(Ut.expression,r)&&(rr=vo(rr,lt.switchStatement,lt.clauseStart,lt.clauseEnd,Wr=>!(Wr.flags&131072||Wr.flags&128&&Wr.value==="undefined"))));let dr=Qr(Ut,rr);dr&&(rr=Os(rr,dr,lt.switchStatement,lt.clauseStart,lt.clauseEnd))}return DI(rr,NI(sr))}function fr(lt){let Ut=[],sr=!1,rr=!1,dr;for(let Wr of lt.antecedents){if(!dr&&Wr.flags&128&&Wr.clauseStart===Wr.clauseEnd){dr=Wr;continue}let Ii=be(Wr),Ei=AC(Ii);if(Ei===a&&a===_)return Ei;ln(Ut,Ei),S4(Ei,_)||(sr=!0),NI(Ii)&&(rr=!0)}if(dr){let Wr=be(dr),Ii=AC(Wr);if(!(Ii.flags&131072)&&!hs(Ut,Ii)&&!fHe(dr.switchStatement)){if(Ii===a&&a===_)return Ii;Ut.push(Ii),S4(Ii,_)||(sr=!0),NI(Wr)&&(rr=!0)}}return DI(Jr(Ut,sr?2:1),rr)}function $r(lt){let Ut=BCe(lt),sr=Mk[Ut]||(Mk[Ut]=new Map),rr=Ce();if(!rr)return a;let dr=sr.get(rr);if(dr)return dr;for(let Or=lh;Or<gd;Or++)if(KD[Or]===lt&&Lk[Or]===rr&&Fk[Or].length)return DI(Jr(Fk[Or],1),!0);let Wr=[],Ii=!1,Ei;for(let Or of lt.antecedents){let fi;if(!Ei)fi=Ei=be(Or);else{KD[gd]=lt,Lk[gd]=rr,Fk[gd]=Wr,gd++;let Es=Er;Er=void 0,fi=be(Or),Er=Es,gd--;let va=sr.get(rr);if(va)return va}let Qi=AC(fi);if(ln(Wr,Qi),S4(Qi,_)||(Ii=!0),Qi===a)break}let bs=Jr(Wr,Ii?2:1);return NI(Ei)?DI(bs,!0):(sr.set(rr,bs),bs)}function Jr(lt,Ut){if(sFt(lt))return zCe(pi(vr(lt,iFt)));let sr=yWe(pi(ul(lt,Wz),Ut));return sr!==a&&sr.flags&a.flags&1048576&&Am(sr.types,a.types)?a:sr}function on(lt){if(la(r)||iE(r)||jm(r)){if(ze(lt)){let sr=tg(lt).valueDeclaration;if(sr&&(co(sr)||Ls(sr))&&r===sr.parent&&!sr.initializer&&!sr.dotDotDotToken)return sr}}else if(Yo(lt)){if(o_(r,lt.expression))return lt}else if(ze(lt)){let Ut=tg(lt);if(b4(Ut)){let sr=Ut.valueDeclaration;if(Gi(sr)&&!sr.type&&sr.initializer&&Yo(sr.initializer)&&o_(r,sr.initializer.expression))return sr.initializer;if(co(sr)&&!sr.initializer){let rr=sr.parent.parent;if(Gi(rr)&&!rr.type&&rr.initializer&&(ze(rr.initializer)||Yo(rr.initializer))&&o_(r,rr.initializer))return sr}}}}function Qr(lt,Ut){if(a.flags&1048576||Ut.flags&1048576){let sr=on(lt);if(sr){let rr=bC(sr);if(rr){let dr=a.flags&1048576&&S4(Ut,a)?a:Ut;if(y4(dr,rr))return sr}}}}function cn(lt,Ut,sr){let rr=bC(Ut);if(rr===void 0)return lt;let dr=w_(Ut),Wr=Q&&(dr||zme(Ut))&&$c(lt,98304),Ii=Xe(Wr?Em(lt,2097152):lt,rr);if(!Ii)return lt;Ii=Wr&&dr?$S(Ii):Ii;let Ei=sr(Ii);return wl(lt,bs=>{let Or=Pt(bs,rr)||Sr;return!(Or.flags&131072)&&!(Ei.flags&131072)&&Rz(Ei,Or)})}function Bs(lt,Ut,sr,rr,dr){if((sr===37||sr===38)&&lt.flags&1048576){let Wr=qz(lt);if(Wr&&Wr===bC(Ut)){let Ii=zz(lt,l_(rr));if(Ii)return sr===(dr?37:38)?Ii:Dg(Xe(Ii,Wr)||Sr)?Uae(lt,Ii):lt}}return cn(lt,Ut,Wr=>ms(Wr,sr,rr,dr))}function Os(lt,Ut,sr,rr,dr){if(rr<dr&&lt.flags&1048576&&qz(lt)===bC(Ut)){let Wr=Bae(sr).slice(rr,dr),Ii=pi(vr(Wr,Ei=>zz(lt,Ei)||Sr));if(Ii!==Sr)return Ii}return cn(lt,Ut,Wr=>Bo(Wr,sr,rr,dr))}function Ys(lt,Ut,sr){if(o_(r,Ut))return xC(lt,sr?4194304:8388608);Q&&sr&&EC(Ut,r)&&(lt=xC(lt,2097152));let rr=Qr(Ut,lt);return rr?cn(lt,rr,dr=>Em(dr,sr?4194304:8388608)):lt}function As(lt,Ut,sr){let rr=ka(lt,Ut);return rr?!!(rr.flags&16777216||Vc(rr)&48)||sr:!!iP(lt,Ut)||!sr}function su(lt,Ut,sr){let rr=_m(Ut);if(rg(lt,Wr=>As(Wr,rr,!0)))return wl(lt,Wr=>As(Wr,rr,sr));if(sr){let Wr=pMt();if(Wr)return Pa([lt,EI(Wr,[Ut,Sr])])}return lt}function Hd(lt,Ut,sr,rr,dr){return dr=dr!==(sr.kind===112)!=(rr!==38&&rr!==36),ei(lt,Ut,dr)}function rp(lt,Ut,sr){switch(Ut.operatorToken.kind){case 64:case 76:case 77:case 78:return Ys(ei(lt,Ut.right,sr),Ut.left,sr);case 35:case 36:case 37:case 38:let rr=Ut.operatorToken.kind,dr=s2(Ut.left),Wr=s2(Ut.right);if(dr.kind===221&&bo(Wr))return Pn(lt,dr,rr,Wr,sr);if(Wr.kind===221&&bo(dr))return Pn(lt,Wr,rr,dr,sr);if(o_(r,dr))return ms(lt,rr,Wr,sr);if(o_(r,Wr))return ms(lt,rr,dr,sr);Q&&(EC(dr,r)?lt=an(lt,rr,Wr,sr):EC(Wr,r)&&(lt=an(lt,rr,dr,sr)));let Ii=Qr(dr,lt);if(Ii)return Bs(lt,Ii,rr,Wr,sr);let Ei=Qr(Wr,lt);if(Ei)return Bs(lt,Ei,rr,dr,sr);if(Oc(dr))return _t(lt,rr,Wr,sr);if(Oc(Wr))return _t(lt,rr,dr,sr);if(Mw(Wr)&&!Yo(dr))return Hd(lt,dr,Wr,rr,sr);if(Mw(dr)&&!Yo(Wr))return Hd(lt,Wr,dr,rr,sr);break;case 104:return Ne(lt,Ut,sr);case 103:if(is(Ut.left))return Br(lt,Ut,sr);let bs=s2(Ut.right);if(IL(lt)&&Yo(r)&&o_(r.expression,bs)){let Or=l_(Ut.left);if(um(Or)&&bC(r)===_m(Or))return Em(lt,sr?524288:65536)}if(o_(r,bs)){let Or=l_(Ut.left);if(um(Or))return su(lt,Or,sr)}break;case 28:return ei(lt,Ut.right,sr);case 56:return sr?ei(ei(lt,Ut.left,!0),Ut.right,!0):pi([ei(lt,Ut.left,!1),ei(lt,Ut.right,!1)]);case 57:return sr?pi([ei(lt,Ut.left,!0),ei(lt,Ut.right,!0)]):ei(ei(lt,Ut.left,!1),Ut.right,!1)}return lt}function Br(lt,Ut,sr){let rr=s2(Ut.right);if(!o_(r,rr))return lt;I.assertNode(Ut.left,is);let dr=roe(Ut.left);if(dr===void 0)return lt;let Wr=dr.parent,Ii=jl(I.checkDefined(dr.valueDeclaration,"should always have a declaration"))?vn(Wr):dc(Wr);return Vn(lt,Ii,sr,!0)}function an(lt,Ut,sr,rr){let dr=Ut===35||Ut===37,Wr=Ut===35||Ut===36?98304:32768,Ii=l_(sr);return dr!==rr&&tp(Ii,bs=>!!(bs.flags&Wr))||dr===rr&&tp(Ii,bs=>!(bs.flags&(3|Wr)))?xC(lt,2097152):lt}function ms(lt,Ut,sr,rr){if(lt.flags&1)return lt;(Ut===36||Ut===38)&&(rr=!rr);let dr=l_(sr),Wr=Ut===35||Ut===36;if(dr.flags&98304){if(!Q)return lt;let Ii=Wr?rr?262144:2097152:dr.flags&65536?rr?131072:1048576:rr?65536:524288;return xC(lt,Ii)}if(rr){if(!Wr&&(lt.flags&2||rg(lt,l0))){if(dr.flags&469893116||l0(dr))return dr;if(dr.flags&524288)return ni}let Ii=wl(lt,Ei=>Rz(Ei,dr)||Wr&&lLt(Ei,dr));return PWe(Ii,dr)}return Dg(dr)?wl(lt,Ii=>!(H$e(Ii)&&Rz(Ii,dr))):lt}function Pn(lt,Ut,sr,rr,dr){(sr===36||sr===38)&&(dr=!dr);let Wr=s2(Ut.expression);if(!o_(r,Wr)){Q&&EC(Wr,r)&&dr===(rr.text!=="undefined")&&(lt=xC(lt,2097152));let Ii=Qr(Wr,lt);return Ii?cn(lt,Ii,Ei=>Vs(Ei,rr,dr)):lt}return Vs(lt,rr,dr)}function Vs(lt,Ut,sr){return sr?N_(lt,Ut.text):xC(lt,tZ.get(Ut.text)||32768)}function vo(lt,Ut,sr,rr,dr){return sr!==rr&&yr(Bae(Ut).slice(sr,rr),dr)?Em(lt,2097152):lt}function Bo(lt,Ut,sr,rr){let dr=Bae(Ut);if(!dr.length)return lt;let Wr=dr.slice(sr,rr),Ii=sr===rr||hs(Wr,Qn);if(lt.flags&2&&!Ii){let fi;for(let Qi=0;Qi<Wr.length;Qi+=1){let Es=Wr[Qi];if(Es.flags&469893116)fi!==void 0&&fi.push(Es);else if(Es.flags&524288)fi===void 0&&(fi=Wr.slice(0,Qi)),fi.push(ni);else return lt}return pi(fi===void 0?Wr:fi)}let Ei=pi(Wr),bs=Ei.flags&131072?Qn:PWe(wl(lt,fi=>Rz(Ei,fi)),Ei);if(!Ii)return bs;let Or=wl(lt,fi=>!(H$e(fi)&&hs(dr,af(tLt(fi)))));return bs.flags&131072?Or:pi([bs,Or])}function N_(lt,Ut){switch(Ut){case"string":return Qa(lt,Le,1);case"number":return Qa(lt,It,2);case"bigint":return Qa(lt,Rt,4);case"boolean":return Qa(lt,Pi,8);case"symbol":return Qa(lt,Fi,16);case"object":return lt.flags&1?lt:pi([Qa(lt,ni,32),Qa(lt,he,131072)]);case"function":return lt.flags&1?lt:Qa(lt,Bt,64);case"undefined":return Qa(lt,Be,65536)}return Qa(lt,ni,128)}function Qa(lt,Ut,sr){return Ec(lt,rr=>hh(rr,Ut,jd)?bm(rr,sr)?rr:Qn:JS(Ut,rr)?Ut:bm(rr,sr)?Pa([rr,Ut]):Qn)}function bf(lt,Ut,sr,rr){let dr=AWe(Ut);if(!dr)return lt;let Wr=oa(Ut.caseBlock.clauses,bs=>bs.kind===297);if(sr===rr||Wr>=sr&&Wr<rr){let bs=_He(sr,rr,dr);return wl(lt,Or=>v4(Or,bs)===bs)}let Ei=dr.slice(sr,rr);return pi(vr(Ei,bs=>bs?N_(lt,bs):Qn))}function el(lt,Ut,sr,rr){let dr=oa(Ut.caseBlock.clauses,Ei=>Ei.kind===297),Wr=sr===rr||dr>=sr&&dr<rr;for(let Ei=0;Ei<sr;Ei++){let bs=Ut.caseBlock.clauses[Ei];bs.kind===296&&(lt=ei(lt,bs.expression,!1))}if(Wr){for(let Ei=rr;Ei<Ut.caseBlock.clauses.length;Ei++){let bs=Ut.caseBlock.clauses[Ei];bs.kind===296&&(lt=ei(lt,bs.expression,!1))}return lt}let Ii=Ut.caseBlock.clauses.slice(sr,rr);return pi(vr(Ii,Ei=>Ei.kind===296?ei(lt,Ei.expression,!0):Qn))}function Oc(lt){return(Hn(lt)&&Nn(lt.name)==="constructor"||fc(lt)&&bo(lt.argumentExpression)&&lt.argumentExpression.text==="constructor")&&o_(r,lt.expression)}function _t(lt,Ut,sr,rr){if(rr?Ut!==35&&Ut!==37:Ut!==36&&Ut!==38)return lt;let dr=l_(sr);if(!yke(dr)&&!go(dr))return lt;let Wr=ka(dr,"prototype");if(!Wr)return lt;let Ii=vn(Wr),Ei=wt(Ii)?void 0:Ii;if(!Ei||Ei===Oe||Ei===Bt)return lt;if(wt(lt))return Ei;return wl(lt,Or=>bs(Or,Ei));function bs(Or,fi){return Or.flags&524288&&Gn(Or)&1||fi.flags&524288&&Gn(fi)&1?Or.symbol===fi.symbol:JS(Or,fi)}}function Ne(lt,Ut,sr){let rr=s2(Ut.left);if(!o_(r,rr))return sr&&Q&&EC(rr,r)?xC(lt,2097152):lt;let dr=Ut.right,Wr=l_(dr);if(!mb(Wr,Oe))return lt;let Ii=Hz(Ut),Ei=Ii&&zd(Ii);if(Ei&&Ei.kind===1&&Ei.parameterIndex===0)return Vn(lt,Ei.type,sr,!0);if(!mb(Wr,Bt))return lt;let bs=Ec(Wr,jr);return wt(lt)&&(bs===Oe||bs===Bt)||!sr&&!(bs.flags&524288&&!l0(bs))?lt:Vn(lt,bs,sr,!0)}function jr(lt){let Ut=Xe(lt,"prototype");if(Ut&&!wt(Ut))return Ut;let sr=na(lt,1);return sr.length?pi(vr(sr,rr=>Ao(yL(rr)))):$a}function Vn(lt,Ut,sr,rr){let dr=lt.flags&1048576?`N${sf(lt)},${sf(Ut)},${(sr?1:0)|(rr?2:0)}`:void 0;return Vk(dr)??dS(dr,bi(lt,Ut,sr,rr))}function bi(lt,Ut,sr,rr){if(!sr){if(lt===Ut)return Qn;if(rr)return wl(lt,bs=>!mb(bs,Ut));let Ei=Vn(lt,Ut,!0,!1);return wl(lt,bs=>!S4(bs,Ei))}if(lt.flags&3||lt===Ut)return Ut;let dr=rr?mb:JS,Wr=lt.flags&1048576?qz(lt):void 0,Ii=Ec(Ut,Ei=>{let bs=Wr&&Xe(Ei,Wr),Or=bs&&zz(lt,bs),fi=Ec(Or||lt,rr?Qi=>mb(Qi,Ei)?Qi:mb(Ei,Qi)?Ei:Qn:Qi=>Oz(Qi,Ei)?Qi:Oz(Ei,Qi)?Ei:JS(Qi,Ei)?Qi:JS(Ei,Qi)?Ei:Qn);return fi.flags&131072?Ec(lt,Qi=>$c(Qi,465829888)&&dr(Ei,k_(Qi)||Sr)?Pa([Qi,Ei]):Qn):fi});return Ii.flags&131072?JS(Ut,lt)?Ut:Na(lt,Ut)?lt:Na(Ut,lt)?Ut:Pa([lt,Ut]):Ii}function Mi(lt,Ut,sr){if(hWe(Ut,r)){let rr=sr||!L2(Ut)?Hz(Ut):void 0,dr=rr&&zd(rr);if(dr&&(dr.kind===0||dr.kind===1))return Li(lt,dr,Ut,sr)}if(IL(lt)&&Yo(r)&&Hn(Ut.expression)){let rr=Ut.expression;if(o_(r.expression,s2(rr.expression))&&ze(rr.name)&&rr.name.escapedText==="hasOwnProperty"&&Ut.arguments.length===1){let dr=Ut.arguments[0];if(bo(dr)&&bC(r)===Pc(dr.text))return Em(lt,sr?524288:65536)}}return lt}function Li(lt,Ut,sr,rr){if(Ut.type&&!(wt(lt)&&(Ut.type===Oe||Ut.type===Bt))){let dr=oFt(Ut,sr);if(dr){if(o_(r,dr))return Vn(lt,Ut.type,rr,!1);Q&&EC(dr,r)&&(rr&&!bm(Ut.type,65536)||!rr&&tp(Ut.type,i$))&&(lt=xC(lt,2097152));let Wr=Qr(dr,lt);if(Wr)return cn(lt,Wr,Ii=>Vn(Ii,Ut.type,rr,!1))}}return lt}function ei(lt,Ut,sr){if(A9(Ut)||bn(Ut.parent)&&(Ut.parent.operatorToken.kind===61||Ut.parent.operatorToken.kind===78)&&Ut.parent.left===Ut)return Ln(lt,Ut,sr);switch(Ut.kind){case 80:if(!o_(r,Ut)&&M<5){let rr=tg(Ut);if(b4(rr)){let dr=rr.valueDeclaration;if(dr&&Gi(dr)&&!dr.type&&dr.initializer&&wWe(r)){M++;let Wr=ei(lt,dr.initializer,sr);return M--,Wr}}}case 110:case 108:case 211:case 212:return Ys(lt,Ut,sr);case 213:return Mi(lt,Ut,sr);case 217:case 235:return ei(lt,Ut.expression,sr);case 226:return rp(lt,Ut,sr);case 224:if(Ut.operator===54)return ei(lt,Ut.operand,!sr);break}return lt}function Ln(lt,Ut,sr){if(o_(r,Ut))return xC(lt,sr?2097152:262144);let rr=Qr(Ut,lt);return rr?cn(lt,rr,dr=>Em(dr,sr?2097152:262144)):lt}}function lFt(r,a){if(r=vd(r),(a.kind===80||a.kind===81)&&(o6(a)&&(a=a.parent),k0(a)&&(!N0(a)||wA(a)))){let _=Pae(wA(a)&&a.kind===211?eoe(a,void 0,!0):l_(a));if(vd(_i(a).resolvedSymbol)===r)return _}return Cy(a)&&A1(a.parent)&&eg(a.parent)?_z(a.parent.symbol):AX(a)&&wA(a.parent)?XE(r):OS(r)}function LL(r){return Gr(r.parent,a=>ca(a)&&!W2(a)||a.kind===268||a.kind===312||a.kind===172)}function OWe(r){return!RWe(r,void 0)}function RWe(r,a){let _=Gr(r.valueDeclaration,zae);if(!_)return!1;let d=_i(_);return d.flags&131072||(d.flags|=131072,uFt(_)||LWe(_)),!r.lastAssignmentPos||a&&r.lastAssignmentPos<a.pos}function $Ce(r){return I.assert(Gi(r)||Ls(r)),MWe(r.name)}function MWe(r){return r.kind===80?OWe(Rn(r.parent)):Tt(r.elements,a=>a.kind!==232&&MWe(a.name))}function uFt(r){return!!Gr(r.parent,a=>zae(a)&&!!(_i(a).flags&131072))}function zae(r){return tc(r)||ls(r)}function LWe(r){switch(r.kind){case 80:if(N0(r)){let _=tg(r);if($ae(_)&&_.lastAssignmentPos!==Number.MAX_VALUE){let d=Gr(r,zae),y=Gr(_.valueDeclaration,zae);_.lastAssignmentPos=d===y?_Ft(r,_.valueDeclaration):Number.MAX_VALUE}}return;case 281:let a=r.parent.parent;if(!r.isTypeOnly&&!a.isTypeOnly&&!a.moduleSpecifier){let _=ac(r.propertyName||r.name,111551,!0,!0);_&&$ae(_)&&(_.lastAssignmentPos=Number.MAX_VALUE)}return;case 264:case 265:case 266:return}es(r)||Qs(r,LWe)}function _Ft(r,a){let _=r.pos;for(;r&&r.pos>a.pos;){switch(r.kind){case 243:case 244:case 245:case 246:case 247:case 248:case 249:case 250:case 254:case 255:case 258:case 263:_=r.end}r=r.parent}return _}function b4(r){return r.flags&3&&(_Ae(r)&6)!==0}function $ae(r){let a=r.valueDeclaration&&Gg(r.valueDeclaration);return!!a&&(Ls(a)||Gi(a)&&(mE(a.parent)||fFt(a)))}function fFt(r){return!!(r.parent.flags&1)&&!(lT(r)&32||r.parent.parent.kind===243&&Kh(r.parent.parent.parent))}function pFt(r){let a=_i(r);if(a.parameterInitializerContainsUndefined===void 0){if(!n0(r,9))return gI(r.symbol),!0;let _=!!bm(C4(r,0),16777216);if(!dh())return gI(r.symbol),!0;a.parameterInitializerContainsUndefined=_}return a.parameterInitializerContainsUndefined}function dFt(r,a){return Q&&a.kind===169&&a.initializer&&bm(r,16777216)&&!pFt(a)?Em(r,524288):r}function mFt(r,a){let _=a.parent;return _.kind===211||_.kind===166||_.kind===213&&_.expression===a||_.kind===212&&_.expression===a&&!(rg(r,jWe)&&yC(l_(_.argumentExpression)))}function FWe(r){return r.flags&2097152?Tt(r.types,FWe):!!(r.flags&465829888&&e1(r).flags&1146880)}function jWe(r){return r.flags&2097152?Tt(r.types,jWe):!!(r.flags&465829888&&!$c(e1(r),98304))}function gFt(r,a){let _=(ze(r)||Hn(r)||fc(r))&&!((eh(r.parent)||px(r.parent))&&r.parent.tagName===r)&&(a&&a&32?Bf(r,8):Bf(r,void 0));return _&&!AI(_)}function WCe(r,a,_){return!(_&&_&2)&&rg(r,FWe)&&(mFt(r,a)||gFt(a,_))?Ec(r,e1):r}function BWe(r){return!!Gr(r,a=>{let _=a.parent;return _===void 0?"quit":Kc(_)?_.expression===a&&ol(a):R_(_)?_.name===a||_.propertyName===a:!1})}function Wae(r,a){if(yt&&Kx(r,111551)&&!ex(a)){let _=du(r);a_(r,!0)&1160127&&(fm($)||aE($)&&BWe(a)||!KL(vd(_))?bS(r):Fu(r))}}function hFt(r,a,_){var d;let y=vn(r,_),T=r.valueDeclaration;if(T){if(co(T)&&!T.initializer&&!T.dotDotDotToken&&T.parent.elements.length>=2){let P=T.parent.parent,L=Gg(P);if(L.kind===260&&f2(L)&6||L.kind===169){let J=_i(P);if(!(J.flags&4194304)){J.flags|=4194304;let G=Yn(P,0),ae=G&&Ec(G,e1);if(J.flags&=-4194305,ae&&ae.flags&1048576&&!(L.kind===169&&$Ce(L))){let Ce=T.parent,be=GS(Ce,ae,ae,void 0,a.flowNode);return be.flags&131072?Qn:Y0(T,be,!0)}}}}if(Ls(T)&&!T.type&&!T.initializer&&!T.dotDotDotToken){let P=T.parent;if(P.parameters.length>=2&&gae(P)){let L=jL(P);if(L&&L.parameters.length===1&&L_(L)){let J=o4(gs(vn(L.parameters[0]),(d=a2(P))==null?void 0:d.nonFixingMapper));if(J.flags&1048576&&tp(J,Ka)&&!Tt(P.parameters,$Ce)){let G=GS(P,J,J,void 0,a.flowNode),ae=P.parameters.indexOf(T)-(Qb(P)?1:0);return Ap(G,Ng(ae))}}}}}return y}function yFt(r,a){if(NA(r))return Kz(r);let _=tg(r);if(_===dt)return ht;if(_===$t){if(bGe(r))return He(r,g.arguments_cannot_be_referenced_in_property_initializers),ht;let fr=Vp(r);if(fr)for(pe<2&&(fr.kind===219?He(r,g.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression):ui(fr,1024)&&He(r,g.The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method)),_i(fr).flags|=512;fr&&rc(fr);)fr=Vp(fr),fr&&(_i(fr).flags|=512);return vn(_)}SFt(r)&&Wae(_,r);let d=vd(_),y=fke(d,r);mS(y)&&Hxe(r,y)&&y.declarations&&Q1(r,y.declarations,r.escapedText);let T=d.valueDeclaration;if(T&&d.flags&32&&Ti(T)&&T.name!==r){let fr=kf(r,!1,!1);for(;fr.kind!==312&&fr.parent!==T;)fr=kf(fr,!1,!1);fr.kind!==312&&(_i(T).flags|=262144,_i(fr).flags|=262144,_i(r).flags|=536870912)}EFt(r,_);let P=hFt(d,r,a),L=kA(r);if(L){if(!(d.flags&3)&&!(gn(r)&&d.flags&512)){let fr=d.flags&384?g.Cannot_assign_to_0_because_it_is_an_enum:d.flags&32?g.Cannot_assign_to_0_because_it_is_a_class:d.flags&1536?g.Cannot_assign_to_0_because_it_is_a_namespace:d.flags&16?g.Cannot_assign_to_0_because_it_is_a_function:d.flags&2097152?g.Cannot_assign_to_0_because_it_is_an_import:g.Cannot_assign_to_0_because_it_is_not_a_variable;return He(r,fr,Oi(_)),ht}if(wg(d))return d.flags&3?He(r,g.Cannot_assign_to_0_because_it_is_a_constant,Oi(_)):He(r,g.Cannot_assign_to_0_because_it_is_a_read_only_property,Oi(_)),ht}let J=d.flags&2097152;if(d.flags&3){if(L===1)return eX(r)?s1(P):P}else if(J)T=Xm(_);else return P;if(!T)return P;P=WCe(P,r,a);let G=Gg(T).kind===169,ae=LL(T),Ce=LL(r),be=Ce!==ae,Ye=r.parent&&r.parent.parent&&F1(r.parent)&&qCe(r.parent.parent),vt=_.flags&134217728,Dt=P===st||P===xu,ur=Dt&&r.parent.kind===235;for(;Ce!==ae&&(Ce.kind===218||Ce.kind===219||ej(Ce))&&(b4(d)&&P!==xu||$ae(d)&&RWe(d,r));)Ce=LL(Ce);let pr=G||J||be||Ye||vt||vFt(r,T)||P!==st&&P!==xu&&(!Q||(P.flags&16387)!==0||ex(r)||FCe(r)||r.parent.kind===281)||r.parent.kind===235||T.kind===260&&T.exclamationToken||T.flags&33554432,dn=ur?Be:pr?G?dFt(P,T):P:Dt?Be:$S(P),Ur=ur?a1(GS(r,P,dn,Ce)):GS(r,P,dn,Ce);if(!DWe(r)&&(P===st||P===xu)){if(Ur===st||Ur===xu)return ve&&(He(qs(T),g.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined,Oi(_),Kr(Ur)),He(r,g.Variable_0_implicitly_has_an_1_type,Oi(_),Kr(Ur))),XL(Ur)}else if(!pr&&!p4(P)&&p4(Ur))return He(r,g.Variable_0_is_used_before_being_assigned,Oi(_)),P;return L?s1(Ur):Ur}function vFt(r,a){if(co(a)){let _=Gr(r,co);return _&&Gg(_)===Gg(a)}}function SFt(r){var a;let _=r.parent;if(_){if(Hn(_)&&_.expression===r||R_(_)&&_.isTypeOnly)return!1;let d=(a=_.parent)==null?void 0:a.parent;if(d&&yl(d)&&d.isTypeOnly)return!1}return!0}function TFt(r,a){return!!Gr(r,_=>_===a?"quit":ca(_)||_.parent&&ea(_.parent)&&!jl(_.parent)&&_.parent.initializer===_)}function bFt(r,a){return Gr(r,_=>_===a?"quit":_===a.initializer||_===a.condition||_===a.incrementor||_===a.statement)}function GCe(r){return Gr(r,a=>!a||lX(a)?"quit":Lv(a,!1))}function EFt(r,a){if(pe>=2||!(a.flags&34)||!a.valueDeclaration||ls(a.valueDeclaration)||a.valueDeclaration.parent.kind===299)return;let _=Lh(a.valueDeclaration),d=TFt(r,_),y=GCe(_);if(y){if(d){let T=!0;if(_x(_)){let P=ST(a.valueDeclaration,261);if(P&&P.parent===_){let L=bFt(r.parent,_);if(L){let J=_i(L);J.flags|=8192;let G=J.capturedBlockScopeBindings||(J.capturedBlockScopeBindings=[]);ln(G,a),L===_.initializer&&(T=!1)}}}T&&(_i(y).flags|=4096)}if(_x(_)){let T=ST(a.valueDeclaration,261);T&&T.parent===_&&CFt(r,_)&&(_i(a.valueDeclaration).flags|=65536)}_i(a.valueDeclaration).flags|=32768}d&&(_i(a.valueDeclaration).flags|=16384)}function xFt(r,a){let _=_i(r);return!!_&&hs(_.capturedBlockScopeBindings,Rn(a))}function CFt(r,a){let _=r;for(;_.parent.kind===217;)_=_.parent;let d=!1;if(N0(_))d=!0;else if(_.parent.kind===224||_.parent.kind===225){let y=_.parent;d=y.operator===46||y.operator===47}return d?!!Gr(_,y=>y===a?"quit":y===a.statement):!1}function HCe(r,a){if(_i(r).flags|=2,a.kind===172||a.kind===176){let _=a.parent;_i(_).flags|=4}else _i(a).flags|=4}function UWe(r){return $2(r)?r:ca(r)?void 0:Qs(r,UWe)}function YCe(r){let a=Rn(r),_=dc(a);return xp(_)===qe}function VWe(r,a,_){let d=a.parent;Xb(d)&&!YCe(d)&&B8(r)&&r.flowNode&&!qae(r.flowNode,!1)&&He(r,_)}function AFt(r,a){ea(a)&&jl(a)&&se&&a.initializer&&G3(a.initializer,r.pos)&&Ad(a.parent)&&He(r,g.Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class)}function Kz(r){let a=ex(r),_=kf(r,!0,!0),d=!1,y=!1;for(_.kind===176&&VWe(r,_,g.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class);;){if(_.kind===219&&(_=kf(_,!1,!y),d=!0),_.kind===167){_=kf(_,!d,!1),y=!0;continue}break}if(AFt(r,_),y)He(r,g.this_cannot_be_referenced_in_a_computed_property_name);else switch(_.kind){case 267:He(r,g.this_cannot_be_referenced_in_a_module_or_namespace_body);break;case 266:He(r,g.this_cannot_be_referenced_in_current_location);break;case 176:JWe(r,_)&&He(r,g.this_cannot_be_referenced_in_constructor_arguments);break}!a&&d&&pe<2&&HCe(r,_);let T=XCe(r,!0,_);if(oe){let P=vn(at);if(T===P&&d)He(r,g.The_containing_arrow_function_captures_the_global_value_of_this);else if(!T){let L=He(r,g.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation);if(!ls(_)){let J=XCe(_);J&&J!==P&&Ga(L,$n(_,g.An_outer_value_of_this_is_shadowed_by_this_container))}}}return T||W}function XCe(r,a=!0,_=kf(r,!1,!1)){let d=gn(r);if(ca(_)&&(!ZCe(r)||Qb(_))){let y=Z2e(_)||d&&NFt(_);if(!y){let T=PFt(_);if(d&&T){let P=Cs(T).symbol;P&&P.members&&P.flags&16&&(y=dc(P).thisType)}else Sh(_)&&(y=dc(mo(_.symbol)).thisType);y||(y=WWe(_))}if(y)return GS(r,y)}if(Ti(_.parent)){let y=Rn(_.parent),T=pa(_)?vn(y):dc(y).thisType;return GS(r,T)}if(ls(_))if(_.commonJsModuleIndicator){let y=Rn(_);return y&&vn(y)}else{if(_.externalModuleIndicator)return Be;if(a)return vn(at)}}function kFt(r){let a=kf(r,!1,!1);if(ca(a)){let _=Sm(a);if(_.thisParameter)return Vae(_.thisParameter)}if(Ti(a.parent)){let _=Rn(a.parent);return pa(a)?vn(_):dc(_).thisType}}function PFt(r){if(r.kind===218&&bn(r.parent)&&al(r.parent)===3)return r.parent.left.expression.expression;if(r.kind===174&&r.parent.kind===210&&bn(r.parent.parent)&&al(r.parent.parent)===6)return r.parent.parent.left.expression;if(r.kind===218&&r.parent.kind===303&&r.parent.parent.kind===210&&bn(r.parent.parent.parent)&&al(r.parent.parent.parent)===6)return r.parent.parent.parent.left.expression;if(r.kind===218&&Ul(r.parent)&&ze(r.parent.name)&&(r.parent.name.escapedText==="value"||r.parent.name.escapedText==="get"||r.parent.name.escapedText==="set")&&Ha(r.parent.parent)&&da(r.parent.parent.parent)&&r.parent.parent.parent.arguments[2]===r.parent.parent&&al(r.parent.parent.parent)===9)return r.parent.parent.parent.arguments[0].expression;if(pl(r)&&ze(r.name)&&(r.name.escapedText==="value"||r.name.escapedText==="get"||r.name.escapedText==="set")&&Ha(r.parent)&&da(r.parent.parent)&&r.parent.parent.arguments[2]===r.parent&&al(r.parent.parent)===9)return r.parent.parent.arguments[0].expression}function NFt(r){let a=b9(r);if(a&&a.typeExpression)return Ri(a.typeExpression);let _=c4(r);if(_)return fb(_)}function JWe(r,a){return!!Gr(r,_=>tc(_)?"quit":_.kind===169&&_.parent===a)}function KCe(r){let a=r.parent.kind===213&&r.parent.expression===r,_=E8(r,!0),d=_,y=!1,T=!1;if(!a){for(;d&&d.kind===219;)ui(d,1024)&&(T=!0),d=E8(d,!0),y=pe<2;d&&ui(d,1024)&&(T=!0)}let P=0;if(!d||!ae(d)){let Ce=Gr(r,be=>be===d?"quit":be.kind===167);return Ce&&Ce.kind===167?He(r,g.super_cannot_be_referenced_in_a_computed_property_name):a?He(r,g.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors):!d||!d.parent||!(Ti(d.parent)||d.parent.kind===210)?He(r,g.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions):He(r,g.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class),ht}if(!a&&_.kind===176&&VWe(r,d,g.super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class),pa(d)||a?(P=32,!a&&pe>=2&&pe<=8&&(ea(d)||Jc(d))&&ide(r.parent,Ce=>{(!ls(Ce)||Bp(Ce))&&(_i(Ce).flags|=2097152)})):P=16,_i(r).flags|=P,d.kind===174&&T&&(Pf(r.parent)&&N0(r.parent)?_i(d).flags|=256:_i(d).flags|=128),y&&HCe(r.parent,d),d.parent.kind===210)return pe<2?(He(r,g.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher),ht):W;let L=d.parent;if(!Xb(L))return He(r,g.super_can_only_be_referenced_in_a_derived_class),ht;if(YCe(L))return a?ht:qe;let J=dc(Rn(L)),G=J&&Cp(J)[0];if(!G)return ht;if(d.kind===176&&JWe(r,d))return He(r,g.super_cannot_be_referenced_in_constructor_arguments),ht;return P===32?xp(J):Hp(G,J.thisType);function ae(Ce){return a?Ce.kind===176:Ti(Ce.parent)||Ce.parent.kind===210?pa(Ce)?Ce.kind===174||Ce.kind===173||Ce.kind===177||Ce.kind===178||Ce.kind===172||Ce.kind===175:Ce.kind===174||Ce.kind===173||Ce.kind===177||Ce.kind===178||Ce.kind===172||Ce.kind===171||Ce.kind===176:!1}}function qWe(r){return(r.kind===174||r.kind===177||r.kind===178)&&r.parent.kind===210?r.parent:r.kind===218&&r.parent.kind===303?r.parent.parent:void 0}function zWe(r){return Gn(r)&4&&r.target===cl?cc(r)[0]:void 0}function DFt(r){return Ec(r,a=>a.flags&2097152?Te(a.types,zWe):zWe(a))}function $We(r,a){let _=r,d=a;for(;d;){let y=DFt(d);if(y)return y;if(_.parent.kind!==303)break;_=_.parent.parent,d=Tb(_,void 0)}}function WWe(r){if(r.kind===219)return;if(gae(r)){let _=jL(r);if(_){let d=_.thisParameter;if(d)return vn(d)}}let a=gn(r);if(oe||a){let _=qWe(r);if(_){let y=Tb(_,void 0),T=$We(_,y);return T?gs(T,PCe(a2(_))):Yp(y?a1(y):xl(_))}let d=P1(r.parent);if(lu(d)){let y=d.left;if(Yo(y)){let{expression:T}=y;if(a&&ze(T)){let P=Xr(d);if(P.commonJsModuleIndicator&&tg(T)===P.symbol)return}return Yp(xl(T))}}}}function GWe(r){let a=r.parent;if(!gae(a))return;let _=W2(a);if(_&&_.arguments){let y=coe(_),T=a.parameters.indexOf(r);if(r.dotDotDotToken)return CAe(y,T,y.length,W,void 0,0);let P=_i(_),L=P.resolvedSignature;P.resolvedSignature=Et;let J=T<y.length?i2(Cs(y[T])):r.initializer?void 0:Lt;return P.resolvedSignature=L,J}let d=jL(a);if(d){let y=a.parameters.indexOf(r)-(Qb(a)?1:0);return r.dotDotDotToken&&Is(a.parameters)===r?p$(d,y):c2(d,y)}}function QCe(r,a){let _=t_(r)||(gn(r)?cB(r):void 0);if(_)return Ri(_);switch(r.kind){case 169:return GWe(r);case 208:return IFt(r,a);case 172:if(pa(r))return wFt(r,a)}}function IFt(r,a){let _=r.parent.parent,d=r.propertyName||r.name,y=QCe(_,a)||_.kind!==208&&_.initializer&&C4(_,r.dotDotDotToken?32:0);if(!y||la(d)||h8(d))return;if(_.name.kind===207){let P=nN(r.parent.elements,r);return P<0?void 0:rAe(y,P)}let T=av(d);if(um(T)){let P=_m(T);return Xe(y,P)}}function wFt(r,a){let _=bt(r.parent)&&Bf(r.parent,a);if(_)return Sb(_,Rn(r).escapedName)}function OFt(r,a){let _=r.parent;if(jv(_)&&r===_.initializer){let d=QCe(_,a);if(d)return d;if(!(a&8)&&la(_.name)&&_.name.elements.length>0)return R(_.name,!0,!1)}}function RFt(r,a){let _=Vp(r);if(_){let d=Gae(_,a);if(d){let y=vu(_);if(y&1){let T=(y&2)!==0;d.flags&1048576&&(d=wl(d,L=>!!l2(1,L,T)));let P=l2(1,d,(y&2)!==0);if(!P)return;d=P}if(y&2){let T=Ec(d,lv);return T&&pi([T,cHe(T)])}return d}}}function MFt(r,a){let _=Bf(r,a);if(_){let d=lv(_);return d&&pi([d,cHe(d)])}}function LFt(r,a){let _=Vp(r);if(_){let d=vu(_),y=Gae(_,a);if(y){let T=(d&2)!==0;return!r.asteriskToken&&y.flags&1048576&&(y=wl(y,P=>!!l2(1,P,T))),r.asteriskToken?y:l2(0,y,T)}}}function ZCe(r){let a=!1;for(;r.parent&&!ca(r.parent);){if(Ls(r.parent)&&(a||r.parent.initializer===r))return!0;co(r.parent)&&r.parent.initializer===r&&(a=!0),r=r.parent}return!1}function HWe(r,a){let _=!!(vu(a)&2),d=Gae(a,void 0);if(d)return l2(r,d,_)||void 0}function Gae(r,a){let _=TI(r);if(_)return _;let d=iAe(r);if(d&&!Kse(d)){let T=Ao(d),P=vu(r);return P&1?wl(T,L=>!!(L.flags&58998787)||WAe(L,P,void 0)):P&2?wl(T,L=>!!(L.flags&58998787)||!!P4(L)):T}let y=W2(r);if(y)return Bf(y,a)}function YWe(r,a){let d=coe(r).indexOf(a);return d===-1?void 0:eAe(r,d)}function eAe(r,a){if(Up(r))return a===0?Le:a===1?Fze(!1):W;let _=_i(r).resolvedSignature===Dn?Dn:OI(r);if(H_(r)&&a===0)return Kae(_,r);let d=_.parameters.length-1;return L_(_)&&a>=d?Ap(vn(_.parameters[d]),Ng(a-d),256):Ig(_,a)}function FFt(r){let a=jAe(r);return a?dC(a):void 0}function jFt(r,a){if(r.parent.kind===215)return YWe(r.parent,a)}function BFt(r,a){let _=r.parent,{left:d,operatorToken:y,right:T}=_;switch(y.kind){case 64:case 77:case 76:case 78:return r===T?VFt(_):void 0;case 57:case 61:let P=Bf(_,a);return r===T&&(P&&P.pattern||!P&&!Cde(_))?l_(d):P;case 56:case 28:return r===T?Bf(_,a):void 0;default:return}}function UFt(r){if(qg(r)&&r.symbol)return r.symbol;if(ze(r))return tg(r);if(Hn(r)){let _=l_(r.expression);return is(r.name)?a(_,r.name):ka(_,r.name.escapedText)}if(fc(r)){let _=xl(r.argumentExpression);if(!um(_))return;let d=l_(r.expression);return ka(d,_m(_))}return;function a(_,d){let y=toe(d.escapedText,d);return y&&mAe(_,y)}}function VFt(r){var a,_;let d=al(r);switch(d){case 0:case 4:let y=UFt(r.left),T=y&&y.valueDeclaration;if(T&&(ea(T)||fp(T))){let J=t_(T);return J&&gs(Ri(J),as(y).mapper)||(ea(T)?T.initializer&&l_(r.left):void 0)}return d===0?l_(r.left):XWe(r);case 5:if(Hae(r,d))return XWe(r);if(!qg(r.left)||!r.left.symbol)return l_(r.left);{let J=r.left.symbol.valueDeclaration;if(!J)return;let G=ta(r.left,Yo),ae=t_(J);if(ae)return Ri(ae);if(ze(G.expression)){let Ce=G.expression,be=wc(Ce,Ce.escapedText,111551,void 0,Ce.escapedText,!0);if(be){let Ye=be.valueDeclaration&&t_(be.valueDeclaration);if(Ye){let vt=xy(G);if(vt!==void 0)return Sb(Ri(Ye),vt)}return}}return gn(J)||J===r.left?void 0:l_(r.left)}case 1:case 6:case 3:case 2:let P;d!==2&&(P=qg(r.left)?(a=r.left.symbol)==null?void 0:a.valueDeclaration:void 0),P||(P=(_=r.symbol)==null?void 0:_.valueDeclaration);let L=P&&t_(P);return L?Ri(L):void 0;case 7:case 8:case 9:return I.fail("Does not apply");default:return I.assertNever(d)}}function Hae(r,a=al(r)){if(a===4)return!0;if(!gn(r)||a!==5||!ze(r.left.expression))return!1;let _=r.left.expression.escapedText,d=wc(r.left,_,111551,void 0,void 0,!0,!0);return sj(d?.valueDeclaration)}function XWe(r){if(!r.symbol)return l_(r.left);if(r.symbol.valueDeclaration){let y=t_(r.symbol.valueDeclaration);if(y){let T=Ri(y);if(T)return T}}let a=ta(r.left,Yo);if(!jm(kf(a.expression,!1,!1)))return;let _=Kz(a.expression),d=xy(a);return d!==void 0&&Sb(_,d)||void 0}function JFt(r){return!!(Vc(r)&262144&&!r.links.type&&tP(r,0)>=0)}function Sb(r,a,_){return Ec(r,d=>{var y;if(Ff(d)&&!d.declaration.nameType){let T=bd(d),P=k_(T)||T,L=_||jf(Zi(a));if(Na(L,P))return cae(d,L)}else if(d.flags&3670016){let T=ka(d,a);if(T)return JFt(T)?void 0:WS(vn(T),!!(T&&T.flags&16777216));if(Ka(d)&&R0(a)&&+a>=0){let P=h4(d,d.target.fixedLength,0,!1,!0);if(P)return P}return(y=hxe(yxe(d),_||jf(Zi(a))))==null?void 0:y.type}},!0)}function KWe(r,a){if(I.assert(jm(r)),!(r.flags&67108864))return tAe(r,a)}function tAe(r,a){let _=r.parent,d=Ul(r)&&QCe(r,a);if(d)return d;let y=Tb(_,a);if(y){if(vI(r)){let T=Rn(r);return Sb(y,T.escapedName,as(T).nameType)}if(Jv(r)){let T=qs(r);if(T&&uo(T)){let P=Cs(T.expression),L=um(P)&&Sb(y,_m(P));if(L)return L}}if(r.name){let T=av(r.name);return Ec(y,P=>{var L;return(L=hxe(yxe(P),T))==null?void 0:L.type},!0)}}}function qFt(r){let a,_;for(let d=0;d<r.length;d++)fg(r[d])&&(a??(a=d),_=d);return{first:a,last:_}}function rAe(r,a,_,d,y){return r&&Ec(r,T=>{if(Ka(T)){if((d===void 0||a<d)&&a<T.target.fixedLength)return WS(cc(T)[a],!!T.target.elementFlags[a]);let P=_!==void 0&&(y===void 0||a>y)?_-a:0,L=P>0&&T.target.hasRestElement?SL(T.target,3):0;return P>0&&P<=L?cc(T)[sv(T)-P]:h4(T,d===void 0?T.target.fixedLength:Math.min(T.target.fixedLength,d),_===void 0||y===void 0?L:Math.min(L,_-y),!1,!0)}return(!d||a<d)&&Sb(T,""+a)||nke(1,T,Be,void 0,!1)},!0)}function zFt(r,a){let _=r.parent;return r===_.whenTrue||r===_.whenFalse?Bf(_,a):void 0}function $Ft(r,a,_){let d=Tb(r.openingElement.attributes,_),y=t$(kC(r));if(!(d&&!wt(d)&&y&&y!==""))return;let T=bN(r.children),P=T.indexOf(a),L=Sb(d,y);return L&&(T.length===1?L:Ec(L,J=>cv(J)?Ap(J,Ng(P)):J,!0))}function WFt(r,a){let _=r.parent;return O9(_)?Bf(r,a):L0(_)?$Ft(_,r,a):void 0}function QWe(r,a){if(th(r)){let _=Tb(r.parent,a);return!_||wt(_)?void 0:Sb(_,A6(r.name))}else return Bf(r.parent,a)}function Qz(r){switch(r.kind){case 11:case 9:case 10:case 15:case 228:case 112:case 97:case 106:case 80:case 157:return!0;case 211:case 217:return Qz(r.expression);case 294:return!r.expression||Qz(r.expression)}return!1}function GFt(r,a){return jLt(a,r)||pCe(a,ys(vr(Fn(r.properties,_=>_.symbol?_.kind===303?Qz(_.initializer)&&y4(a,_.symbol.escapedName):_.kind===304?y4(a,_.symbol.escapedName):!1:!1),_=>[()=>S$(_.kind===303?_.initializer:_.name),_.symbol.escapedName]),vr(Fn(Io(a),_=>{var d;return!!(_.flags&16777216)&&!!((d=r?.symbol)!=null&&d.members)&&!r.symbol.members.has(_.escapedName)&&y4(a,_.escapedName)}),_=>[()=>Be,_.escapedName])),Na)}function HFt(r,a){let _=t$(kC(r));return pCe(a,ys(vr(Fn(r.properties,d=>!!d.symbol&&d.kind===291&&y4(a,d.symbol.escapedName)&&(!d.initializer||Qz(d.initializer))),d=>[d.initializer?()=>S$(d.initializer):()=>zr,d.symbol.escapedName]),vr(Fn(Io(a),d=>{var y;if(!(d.flags&16777216)||!((y=r?.symbol)!=null&&y.members))return!1;let T=r.parent.parent;return d.escapedName===_&&L0(T)&&bN(T.children).length?!1:!r.symbol.members.has(d.escapedName)&&y4(a,d.escapedName)}),d=>[()=>Be,d.escapedName])),Na)}function Tb(r,a){let _=jm(r)?KWe(r,a):Bf(r,a),d=Yae(_,r,a);if(d&&!(a&&a&2&&d.flags&8650752)){let y=Ec(d,T=>Gn(T)&32?T:Tf(T),!0);return y.flags&1048576&&Ha(r)?GFt(r,y):y.flags&1048576&&dE(r)?HFt(r,y):y}}function Yae(r,a,_){if(r&&$c(r,465829888)){let d=a2(a);if(d&&_&1&&Tt(d.inferences,Ijt))return Xae(r,d.nonFixingMapper);if(d?.returnMapper){let y=Xae(r,d.returnMapper);return y.flags&1048576&&t1(y.types,Ir)&&t1(y.types,Yr)?wl(y,T=>T!==Ir&&T!==Yr):y}}return r}function Xae(r,a){return r.flags&465829888?gs(r,a):r.flags&1048576?pi(vr(r.types,_=>Xae(_,a)),0):r.flags&2097152?Pa(vr(r.types,_=>Xae(_,a))):r}function Bf(r,a){var _;if(r.flags&67108864)return;let d=eGe(r,!a);if(d>=0)return br[d];let{parent:y}=r;switch(y.kind){case 260:case 169:case 172:case 171:case 208:return OFt(r,a);case 219:case 253:return RFt(r,a);case 229:return LFt(y,a);case 223:return MFt(y,a);case 213:case 214:return YWe(y,r);case 170:return FFt(y);case 216:case 234:return Ty(y.type)?Bf(y,a):Ri(y.type);case 226:return BFt(r,a);case 303:case 304:return tAe(y,a);case 305:return Bf(y.parent,a);case 209:{let T=y,P=Tb(T,a),L=nN(T.elements,r),J=(_=_i(T)).spreadIndices??(_.spreadIndices=qFt(T.elements));return rAe(P,L,T.elements.length,J.first,J.last)}case 227:return zFt(r,a);case 239:return I.assert(y.parent.kind===228),jFt(y.parent,r);case 217:{if(gn(y)){if(XX(y))return Ri(KX(y));let T=_T(y);if(T&&!Ty(T.typeExpression.type))return Ri(T.typeExpression.type)}return Bf(y,a)}case 235:return Bf(y,a);case 238:return Ri(y.type);case 277:return ps(y);case 294:return WFt(y,a);case 291:case 293:return QWe(y,a);case 286:case 285:return QFt(y,a);case 301:return KFt(y)}}function ZWe(r){Zz(r,Bf(r,void 0),!0)}function Zz(r,a,_){nn[Ci]=r,br[Ci]=a,sn[Ci]=_,Ci++}function FL(){Ci--}function eGe(r,a){for(let _=Ci-1;_>=0;_--)if(r===nn[_]&&(a||!sn[_]))return _;return-1}function YFt(r,a){hn[Tn]=r,mi[Tn]=a,Tn++}function XFt(){Tn--}function a2(r){for(let a=Tn-1;a>=0;a--)if(Yb(r,hn[a]))return mi[a]}function KFt(r){return Sb(Rxe(!1),uB(r))}function QFt(r,a){if(eh(r)&&a!==4){let _=eGe(r.parent,!a);if(_>=0)return br[_]}return eAe(r,0)}function Kae(r,a){return FGe(a)!==0?ZFt(r,a):r5t(r,a)}function ZFt(r,a){let _=LAe(r,Sr);_=tGe(a,kC(a),_);let d=o2(cd.IntrinsicAttributes,a);return Xt(d)||(_=hz(d,_)),_}function e5t(r,a){if(r.compositeSignatures){let d=[];for(let y of r.compositeSignatures){let T=Ao(y);if(wt(T))return T;let P=Xe(T,a);if(!P)return;d.push(P)}return Pa(d)}let _=Ao(r);return wt(_)?_:Xe(_,a)}function t5t(r){if(uP(r.tagName)){let _=uGe(r),d=loe(r,_);return dC(d)}let a=xl(r.tagName);if(a.flags&128){let _=lGe(a,r);if(!_)return ht;let d=loe(r,_);return dC(d)}return a}function tGe(r,a,_){let d=b5t(a);if(d){let y=t5t(r),T=pGe(d,gn(r),y,_);if(T)return T}return _}function r5t(r,a){let _=kC(a),d=x5t(_),y=d===void 0?LAe(r,Sr):d===""?Ao(r):e5t(r,d);if(!y)return d&&de(a.attributes.properties)&&He(a,g.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property,Zi(d)),Sr;if(y=tGe(a,_,y),wt(y))return y;{let T=y,P=o2(cd.IntrinsicClassAttributes,a);if(!Xt(P)){let J=qn(P.symbol),G=Ao(r),ae;if(J){let Ce=FS([G],J,a0(J),gn(a));ae=gs(P,kp(J,Ce))}else ae=P;T=hz(ae,T)}let L=o2(cd.IntrinsicAttributes,a);return Xt(L)||(T=hz(L,T)),T}}function n5t(r){return K_($,"noImplicitAny")?d_(r,(a,_)=>a===_||!a?a:eze(a.typeParameters,_.typeParameters)?a5t(a,_):void 0):void 0}function i5t(r,a,_){if(!r||!a)return r||a;let d=pi([vn(r),gs(vn(a),_)]);return TC(r,d)}function s5t(r,a,_){let d=Xp(r),y=Xp(a),T=d>=y?r:a,P=T===r?a:r,L=T===r?d:y,J=u0(r)||u0(a),G=J&&!u0(T),ae=new Array(L+(G?1:0));for(let Ce=0;Ce<L;Ce++){let be=c2(T,Ce);T===a&&(be=gs(be,_));let Ye=c2(P,Ce)||Sr;P===a&&(Ye=gs(Ye,_));let vt=pi([be,Ye]),Dt=J&&!G&&Ce===L-1,ur=Ce>=Th(T)&&Ce>=Th(P),pr=Ce>=d?void 0:x4(r,Ce),dn=Ce>=y?void 0:x4(a,Ce),Ur=pr===dn?pr:pr?dn?void 0:pr:dn,fr=oo(1|(ur&&!Dt?16777216:0),Ur||`arg${Ce}`);fr.links.type=Dt?P_(vt):vt,ae[Ce]=fr}if(G){let Ce=oo(1,"args");Ce.links.type=P_(Ig(P,L)),P===a&&(Ce.links.type=gs(Ce.links.type,_)),ae[L]=Ce}return ae}function a5t(r,a){let _=r.typeParameters||a.typeParameters,d;r.typeParameters&&a.typeParameters&&(d=kp(a.typeParameters,r.typeParameters));let y=r.declaration,T=s5t(r,a,d),P=i5t(r.thisParameter,a.thisParameter,d),L=Math.max(r.minArgumentCount,a.minArgumentCount),J=X0(y,_,P,T,void 0,void 0,L,(r.flags|a.flags)&167);return J.compositeKind=2097152,J.compositeSignatures=ys(r.compositeKind===2097152&&r.compositeSignatures||[r],[a]),d&&(J.mapper=r.compositeKind===2097152&&r.mapper&&r.compositeSignatures?n2(r.mapper,d):d),J}function nAe(r,a){let _=na(r,0),d=Fn(_,y=>!o5t(y,a));return d.length===1?d[0]:n5t(d)}function o5t(r,a){let _=0;for(;_<a.parameters.length;_++){let d=a.parameters[_];if(d.initializer||d.questionToken||d.dotDotDotToken||pR(d))break}return a.parameters.length&&Zb(a.parameters[0])&&_--,!u0(r)&&Xp(r)<_}function iAe(r){return iE(r)||jm(r)?jL(r):void 0}function jL(r){I.assert(r.kind!==174||jm(r));let a=c4(r);if(a)return a;let _=Tb(r,1);if(!_)return;if(!(_.flags&1048576))return nAe(_,r);let d,y=_.types;for(let T of y){let P=nAe(T,r);if(P)if(!d)d=[P];else if(Bz(d[0],P,!1,!0,!0,AL))d.push(P);else return}if(d)return d.length===1?d[0]:Qqe(d[0],d)}function c5t(r,a){pe<2&&iu(r,$.downlevelIteration?1536:1024);let _=Cs(r.expression,a);return uv(33,_,Be,r.expression)}function l5t(r){return r.isSpread?Ap(r.type,It):r.type}function E4(r){return r.kind===208&&!!r.initializer||r.kind===226&&r.operatorToken.kind===64}function u5t(r){let a=P1(r.parent);return fg(a)&&Jg(a.parent)}function rGe(r,a,_){let d=r.elements,y=d.length,T=[],P=[];ZWe(r);let L=N0(r),J=A4(r),G=Tb(r,void 0),ae=u5t(r)||!!G&&rg(G,be=>g4(be)||Ff(be)&&!be.nameType&&!!xL(be.target||be)),Ce=!1;for(let be=0;be<y;be++){let Ye=d[be];if(Ye.kind===230){pe<2&&iu(Ye,$.downlevelIteration?1536:1024);let vt=Cs(Ye.expression,a,_);if(cv(vt))T.push(vt),P.push(8);else if(L){let Dt=_b(vt,It)||nke(65,vt,Be,void 0,!1)||Sr;T.push(Dt),P.push(4)}else T.push(uv(33,vt,Be,Ye.expression)),P.push(4)}else if(Ie&&Ye.kind===232)Ce=!0,T.push(le),P.push(2);else{let vt=k4(Ye,a,_);if(T.push(ep(vt,!0,Ce)),P.push(Ce?2:1),ae&&a&&a&2&&!(a&4)&&$d(Ye)){let Dt=a2(r);I.assert(Dt),ACe(Dt,Ye,vt)}}}return FL(),L?c0(T,P):nGe(_||J||ae?c0(T,P,J&&!(G&&rg(G,hCe))):P_(T.length?pi(ul(T,(be,Ye)=>P[Ye]&8?BS(be,It)||W:be),2):Q?Vi:Lt,J))}function nGe(r){if(!(Gn(r)&4))return r;let a=r.literalType;return a||(a=r.literalType=Cze(r),a.objectFlags|=147456),a}function _5t(r){switch(r.kind){case 167:return f5t(r);case 80:return R0(r.escapedText);case 9:case 11:return R0(r.text);default:return!1}}function f5t(r){return c_(Q0(r),296)}function Q0(r){let a=_i(r.expression);if(!a.resolvedType){if((dp(r.parent.parent)||Ti(r.parent.parent)||ef(r.parent.parent))&&bn(r.expression)&&r.expression.operatorToken.kind===103&&r.parent.kind!==177&&r.parent.kind!==178)return a.resolvedType=ht;if(a.resolvedType=Cs(r.expression),ea(r.parent)&&!jl(r.parent)&&wu(r.parent.parent)){let _=Lh(r.parent.parent),d=GCe(_);d&&(_i(d).flags|=4096,_i(r).flags|=32768,_i(r.parent.parent).flags|=32768)}(a.resolvedType.flags&98304||!c_(a.resolvedType,402665900)&&!Na(a.resolvedType,Mr))&&He(r,g.A_computed_property_name_must_be_of_type_string_number_symbol_or_any)}return a.resolvedType}function p5t(r){var a;let _=(a=r.declarations)==null?void 0:a[0];return R0(r.escapedName)||_&&W_(_)&&_5t(_.name)}function iGe(r){var a;let _=(a=r.declarations)==null?void 0:a[0];return H8(r)||_&&W_(_)&&uo(_.name)&&c_(Q0(_.name),4096)}function sAe(r,a,_,d){let y=[];for(let P=a;P<_.length;P++){let L=_[P];(d===Le&&!iGe(L)||d===It&&p5t(L)||d===Fi&&iGe(L))&&y.push(vn(_[P]))}let T=y.length?pi(y,2):Be;return o0(d,T,A4(r))}function aAe(r){I.assert((r.flags&2097152)!==0,"Should only get Alias here.");let a=as(r);if(!a.immediateTarget){let _=Xm(r);if(!_)return I.fail();a.immediateTarget=$p(_,!0)}return a.immediateTarget}function d5t(r,a=0){var _;let d=N0(r);SJt(r,d);let y=Q?ga():void 0,T=ga(),P=[],L=$a;ZWe(r);let J=Tb(r,void 0),G=J&&J.pattern&&(J.pattern.kind===206||J.pattern.kind===210),ae=A4(r),Ce=ae?8:0,be=gn(r)&&!uj(r),Ye=be?eY(r):void 0,vt=!J&&be&&!Ye,Dt=Ae,ur=!1,pr=!1,dn=!1,Ur=!1;for(let Jr of r.properties)Jr.name&&uo(Jr.name)&&Q0(Jr.name);let fr=0;for(let Jr of r.properties){let on=Rn(Jr),Qr=Jr.name&&Jr.name.kind===167?Q0(Jr.name):void 0;if(Jr.kind===303||Jr.kind===304||jm(Jr)){let cn=Jr.kind===303?EHe(Jr,a):Jr.kind===304?k4(!d&&Jr.objectAssignmentInitializer?Jr.objectAssignmentInitializer:Jr.name,a):xHe(Jr,a);if(be){let Ys=Yy(Jr);Ys?(J_(cn,Ys,Jr),cn=Ys):Ye&&Ye.typeExpression&&J_(cn,Ri(Ye.typeExpression),Jr)}Dt|=Gn(cn)&458752;let Bs=Qr&&um(Qr)?Qr:void 0,Os=Bs?oo(4|on.flags,_m(Bs),Ce|4096):oo(4|on.flags,on.escapedName,Ce);if(Bs&&(Os.links.nameType=Bs),d)(Jr.kind===303&&E4(Jr.initializer)||Jr.kind===304&&Jr.objectAssignmentInitializer)&&(Os.flags|=16777216);else if(G&&!(Gn(J)&512)){let Ys=ka(J,on.escapedName);Ys?Os.flags|=Ys.flags&16777216:!$.suppressExcessPropertyErrors&&!K0(J,Le)&&He(Jr.name,g.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1,Oi(on),Kr(J))}if(Os.declarations=on.declarations,Os.parent=on.parent,on.valueDeclaration&&(Os.valueDeclaration=on.valueDeclaration),Os.links.type=cn,Os.links.target=on,on=Os,y?.set(Os.escapedName,Os),J&&a&2&&!(a&4)&&(Jr.kind===303||Jr.kind===174)&&$d(Jr)){let Ys=a2(r);I.assert(Ys);let As=Jr.kind===303?Jr.initializer:Jr;ACe(Ys,As,cn)}}else if(Jr.kind===305){pe<2&&iu(Jr,2),P.length>0&&(L=e2(L,$r(),r.symbol,Dt,ae),P=[],T=ga(),pr=!1,dn=!1,Ur=!1);let cn=Pg(Cs(Jr.expression,a&2));if(e$(cn)){let Bs=Zxe(cn,ae);if(y&&aGe(Bs,y,Jr),fr=P.length,Xt(L))continue;L=e2(L,Bs,r.symbol,Dt,ae)}else He(Jr,g.Spread_types_may_only_be_created_from_object_types),L=ht;continue}else I.assert(Jr.kind===177||Jr.kind===178),_P(Jr);Qr&&!(Qr.flags&8576)?Na(Qr,Mr)&&(Na(Qr,It)?dn=!0:Na(Qr,Fi)?Ur=!0:pr=!0,d&&(ur=!0)):T.set(on.escapedName,on),P.push(on)}if(FL(),G){let Jr=Gr(J.pattern.parent,Qr=>Qr.kind===260||Qr.kind===226||Qr.kind===169);if(Gr(r,Qr=>Qr===Jr||Qr.kind===305).kind!==305)for(let Qr of Io(J))!T.get(Qr.escapedName)&&!ka(L,Qr.escapedName)&&(Qr.flags&16777216||He(Qr.valueDeclaration||((_=ii(Qr,Rh))==null?void 0:_.links.bindingElement),g.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value),T.set(Qr.escapedName,Qr),P.push(Qr))}if(Xt(L))return ht;if(L!==$a)return P.length>0&&(L=e2(L,$r(),r.symbol,Dt,ae),P=[],T=ga(),pr=!1,dn=!1),Ec(L,Jr=>Jr===$a?$r():Jr);return $r();function $r(){let Jr=[];pr&&Jr.push(sAe(r,fr,P,Le)),dn&&Jr.push(sAe(r,fr,P,It)),Ur&&Jr.push(sAe(r,fr,P,Fi));let on=Ho(r.symbol,T,tt,tt,Jr);return on.objectFlags|=Dt|128|131072,vt&&(on.objectFlags|=4096),ur&&(on.objectFlags|=512),d&&(on.pattern=r),on}}function e$(r){let a=Z$e(Ec(r,e1));return!!(a.flags&126615553||a.flags&3145728&&yr(a.types,e$))}function m5t(r){lAe(r)}function g5t(r,a){return _P(r),r$(r)||W}function h5t(r){lAe(r.openingElement),uP(r.closingElement.tagName)?Zae(r.closingElement):Cs(r.closingElement.tagName),Qae(r)}function y5t(r,a){return _P(r),r$(r)||W}function v5t(r){lAe(r.openingFragment);let a=Xr(r);return Gj($)&&($.jsxFactory||a.pragmas.has("jsx"))&&!$.jsxFragmentFactory&&!a.pragmas.has("jsxfrag")&&He(r,$.jsxFactory?g.The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option:g.An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments),Qae(r),r$(r)||W}function oAe(r){return r.includes("-")}function uP(r){return ze(r)&&xN(r.escapedText)||pg(r)}function sGe(r,a){return r.initializer?k4(r.initializer,a):zr}function S5t(r,a=0){let _=r.attributes,d=Bf(_,0),y=Q?ga():void 0,T=ga(),P=Ac,L=!1,J,G=!1,ae=2048,Ce=t$(kC(r));for(let vt of _.properties){let Dt=vt.symbol;if(th(vt)){let ur=sGe(vt,a);ae|=Gn(ur)&458752;let pr=oo(4|Dt.flags,Dt.escapedName);if(pr.declarations=Dt.declarations,pr.parent=Dt.parent,Dt.valueDeclaration&&(pr.valueDeclaration=Dt.valueDeclaration),pr.links.type=ur,pr.links.target=Dt,T.set(pr.escapedName,pr),y?.set(pr.escapedName,pr),A6(vt.name)===Ce&&(G=!0),d){let dn=ka(d,Dt.escapedName);dn&&dn.declarations&&mS(dn)&&ze(vt.name)&&Q1(vt.name,dn.declarations,vt.name.escapedText)}if(d&&a&2&&!(a&4)&&$d(vt)){let dn=a2(_);I.assert(dn);let Ur=vt.initializer.expression;ACe(dn,Ur,ur)}}else{I.assert(vt.kind===293),T.size>0&&(P=e2(P,Ye(),_.symbol,ae,!1),T=ga());let ur=Pg(Cs(vt.expression,a&2));wt(ur)&&(L=!0),e$(ur)?(P=e2(P,ur,_.symbol,ae,!1),y&&aGe(ur,y,vt)):(He(vt.expression,g.Spread_types_may_only_be_created_from_object_types),J=J?Pa([J,ur]):ur)}}L||T.size>0&&(P=e2(P,Ye(),_.symbol,ae,!1));let be=r.parent.kind===284?r.parent:void 0;if(be&&be.openingElement===r&&bN(be.children).length>0){let vt=Qae(be,a);if(!L&&Ce&&Ce!==""){G&&He(_,g._0_are_specified_twice_The_attribute_named_0_will_be_overwritten,Zi(Ce));let Dt=Tb(r.attributes,void 0),ur=Dt&&Sb(Dt,Ce),pr=oo(4,Ce);pr.links.type=vt.length===1?vt[0]:ur&&rg(ur,g4)?c0(vt):P_(pi(vt)),pr.valueDeclaration=j.createPropertySignature(void 0,Zi(Ce),void 0,void 0),io(pr.valueDeclaration,_),pr.valueDeclaration.symbol=pr;let dn=ga();dn.set(Ce,pr),P=e2(P,Ho(_.symbol,dn,tt,tt,tt),_.symbol,ae,!1)}}if(L)return W;if(J&&P!==Ac)return Pa([J,P]);return J||(P===Ac?Ye():P);function Ye(){ae|=Ae;let vt=Ho(_.symbol,T,tt,tt,tt);return vt.objectFlags|=ae|128|131072,vt}}function Qae(r,a){let _=[];for(let d of r.children)if(d.kind===12)d.containsOnlyTriviaWhiteSpaces||_.push(Le);else{if(d.kind===294&&!d.expression)continue;_.push(k4(d,a))}return _}function aGe(r,a,_){for(let d of Io(r))if(!(d.flags&16777216)){let y=a.get(d.escapedName);if(y){let T=He(y.valueDeclaration,g._0_is_specified_more_than_once_so_this_usage_will_be_overwritten,Zi(y.escapedName));Ga(T,$n(_,g.This_spread_always_overwrites_this_property))}}}function T5t(r,a){return S5t(r.parent,a)}function o2(r,a){let _=kC(a),d=_&&Ep(_),y=d&&Lf(d,r,788968);return y?dc(y):ht}function Zae(r){let a=_i(r);if(!a.resolvedSymbol){let _=o2(cd.IntrinsicElements,r);if(Xt(_))return ve&&He(r,g.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists,Zi(cd.IntrinsicElements)),a.resolvedSymbol=dt;{if(!ze(r.tagName)&&!pg(r.tagName))return I.fail();let d=pg(r.tagName)?FA(r.tagName):r.tagName.escapedText,y=ka(_,d);if(y)return a.jsxFlags|=1,a.resolvedSymbol=y;let T=RYe(_,jf(Zi(d)));return T?(a.jsxFlags|=2,a.resolvedSymbol=T):Pt(_,d)?(a.jsxFlags|=2,a.resolvedSymbol=_.symbol):(He(r,g.Property_0_does_not_exist_on_type_1,QX(r.tagName),"JSX."+cd.IntrinsicElements),a.resolvedSymbol=dt)}}return a.resolvedSymbol}function cAe(r){let a=r&&Xr(r),_=a&&_i(a);if(_&&_.jsxImplicitImportContainer===!1)return;if(_&&_.jsxImplicitImportContainer)return _.jsxImplicitImportContainer;let d=Yj(Hj($,a),$);if(!d)return;let T=Q_($)===1?g.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_to_the_paths_option:g.Cannot_find_module_0_or_its_corresponding_type_declarations,P=$.importHelpers?1:0,L=a?.imports[P];L&&I.assert(_c(L)&&L.text===d,`Expected sourceFile.imports[${P}] to be the synthesized JSX runtime import`);let J=fh(L||r,d,T,r),G=J&&J!==dt?mo(ll(J)):void 0;return _&&(_.jsxImplicitImportContainer=G||!1),G}function kC(r){let a=r&&_i(r);if(a&&a.jsxNamespace)return a.jsxNamespace;if(!a||a.jsxNamespace!==!1){let d=cAe(r);if(!d||d===dt){let y=GT(r);d=wc(r,y,1920,void 0,y,!1)}if(d){let y=ll(Lf(Ep(ll(d)),cd.JSX,1920));if(y&&y!==dt)return a&&(a.jsxNamespace=y),y}a&&(a.jsxNamespace=!1)}let _=ll(_4(cd.JSX,1920,void 0));if(_!==dt)return _}function oGe(r,a){let _=a&&Lf(a.exports,r,788968),d=_&&dc(_),y=d&&Io(d);if(y){if(y.length===0)return"";if(y.length===1)return y[0].escapedName;y.length>1&&_.declarations&&He(_.declarations[0],g.The_global_type_JSX_0_may_not_have_more_than_one_property,Zi(r))}}function b5t(r){return r&&Lf(r.exports,cd.LibraryManagedAttributes,788968)}function E5t(r){return r&&Lf(r.exports,cd.ElementType,788968)}function x5t(r){return oGe(cd.ElementAttributesPropertyNameContainer,r)}function t$(r){return oGe(cd.ElementChildrenAttributeNameContainer,r)}function cGe(r,a){if(r.flags&4)return[Et];if(r.flags&128){let y=lGe(r,a);return y?[loe(a,y)]:(He(a,g.Property_0_does_not_exist_on_type_1,r.value,"JSX."+cd.IntrinsicElements),tt)}let _=Tf(r),d=na(_,1);return d.length===0&&(d=na(_,0)),d.length===0&&_.flags&1048576&&(d=sxe(vr(_.types,y=>cGe(y,a)))),d}function lGe(r,a){let _=o2(cd.IntrinsicElements,a);if(!Xt(_)){let d=r.value,y=ka(_,Pc(d));if(y)return vn(y);let T=_b(_,Le);return T||void 0}return W}function C5t(r,a,_){if(r===1){let y=fGe(_);y&&Wd(a,y,Mf,_.tagName,g.Its_return_type_0_is_not_a_valid_JSX_element,d)}else if(r===0){let y=_Ge(_);y&&Wd(a,y,Mf,_.tagName,g.Its_instance_type_0_is_not_a_valid_JSX_element,d)}else{let y=fGe(_),T=_Ge(_);if(!y||!T)return;let P=pi([y,T]);Wd(a,P,Mf,_.tagName,g.Its_element_type_0_is_not_a_valid_JSX_element,d)}function d(){let y=Fl(_.tagName);return Xs(void 0,g._0_cannot_be_used_as_a_JSX_component,y)}}function uGe(r){var a;I.assert(uP(r.tagName));let _=_i(r);if(!_.resolvedJsxElementAttributesType){let d=Zae(r);if(_.jsxFlags&1)return _.resolvedJsxElementAttributesType=vn(d)||ht;if(_.jsxFlags&2){let y=pg(r.tagName)?FA(r.tagName):r.tagName.escapedText;return _.resolvedJsxElementAttributesType=((a=iP(o2(cd.IntrinsicElements,r),y))==null?void 0:a.type)||ht}else return _.resolvedJsxElementAttributesType=ht}return _.resolvedJsxElementAttributesType}function _Ge(r){let a=o2(cd.ElementClass,r);if(!Xt(a))return a}function r$(r){return o2(cd.Element,r)}function fGe(r){let a=r$(r);if(a)return pi([a,he])}function A5t(r){let a=kC(r);if(!a)return;let _=E5t(a);if(!_)return;let d=pGe(_,gn(r));if(!(!d||Xt(d)))return d}function pGe(r,a,..._){let d=dc(r);if(r.flags&524288){let y=as(r).typeParameters;if(de(y)>=_.length){let T=FS(_,y,_.length,a);return de(T)===0?d:EI(r,T)}}if(de(d.typeParameters)>=_.length){let y=FS(_,d.typeParameters,_.length,a);return iv(d,y)}}function k5t(r){let a=o2(cd.IntrinsicElements,r);return a?Io(a):tt}function P5t(r){($.jsx||0)===0&&He(r,g.Cannot_use_JSX_unless_the_jsx_flag_is_provided),r$(r)===void 0&&ve&&He(r,g.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist)}function lAe(r){let a=H_(r);if(a&&TJt(r),P5t(r),!cAe(r)){let _=fo&&$.jsx===2?g.Cannot_find_name_0:void 0,d=GT(r),y=a?r.tagName:r,T;if(nk(r)&&d==="null"||(T=wc(y,d,111551,_,d,!0)),T&&(T.isReferenced=-1,yt&&T.flags&2097152&&!Bd(T)&&bS(T)),nk(r)){let P=Xr(r),L=Jk(P);L&&wc(y,L,111551,_,L,!0)}}if(a){let _=r,d=OI(_);_oe(d,r);let y=A5t(_);if(y!==void 0){let T=_.tagName,P=uP(T)?jf(QX(T)):Cs(T);Wd(P,y,Mf,T,g.Its_type_0_is_not_a_valid_JSX_element_type,()=>{let L=Fl(T);return Xs(void 0,g._0_cannot_be_used_as_a_JSX_component,L)})}else C5t(FGe(_),Ao(d),_)}}function uAe(r,a,_){if(r.flags&524288){if(ub(r,a)||iP(r,a)||pL(a)&&K0(r,Le)||_&&oAe(a))return!0}else if(r.flags&3145728&&n$(r)){for(let d of r.types)if(uAe(d,a,_))return!0}return!1}function n$(r){return!!(r.flags&524288&&!(Gn(r)&512)||r.flags&67108864||r.flags&1048576&&Tt(r.types,n$)||r.flags&2097152&&yr(r.types,n$))}function N5t(r,a){if(EJt(r),r.expression){let _=Cs(r.expression,a);return r.dotDotDotToken&&_!==W&&!Gd(_)&&He(r,g.JSX_spread_child_must_be_an_array_type),_}else return ht}function _Ae(r){return r.valueDeclaration?f2(r.valueDeclaration):0}function fAe(r){if(r.flags&8192||Vc(r)&4)return!0;if(gn(r.valueDeclaration)){let a=r.valueDeclaration.parent;return a&&bn(a)&&al(a)===3}}function pAe(r,a,_,d,y,T=!0){let P=T?r.kind===166?r.right:r.kind===205?r:r.kind===208&&r.propertyName?r.propertyName:r.name:void 0;return dGe(r,a,_,d,y,P)}function dGe(r,a,_,d,y,T){var P;let L=Nd(y,_);if(a){if(pe<2&&mGe(y))return T&&He(T,g.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword),!1;if(L&64)return T&&He(T,g.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression,Oi(y),Kr(lP(y))),!1;if(!(L&256)&&((P=y.declarations)!=null&&P.some(xpe)))return T&&He(T,g.Class_field_0_defined_by_the_parent_class_is_not_accessible_in_the_child_class_via_super,Oi(y)),!1}if(L&64&&mGe(y)&&(x8(r)||bde(r)||pm(r.parent)&&sj(r.parent.parent))){let G=ky(yf(y));if(G&&SVt(r))return T&&He(T,g.Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor,Oi(y),om(G.name)),!1}if(!(L&6))return!0;if(L&2){let G=ky(yf(y));return mke(r,G)?!0:(T&&He(T,g.Property_0_is_private_and_only_accessible_within_class_1,Oi(y),Kr(lP(y))),!1)}if(a)return!0;let J=wYe(r,G=>{let ae=dc(Rn(G));return q$e(ae,y,_)});return!J&&(J=D5t(r),J=J&&q$e(J,y,_),L&256||!J)?(T&&He(T,g.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses,Oi(y),Kr(lP(y)||d)),!1):L&256?!0:(d.flags&262144&&(d=d.isThisType?Sf(d):k_(d)),!d||!hI(d,J)?(T&&He(T,g.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2,Oi(y),Kr(J),Kr(d)),!1):!0)}function D5t(r){let a=I5t(r),_=a?.type&&Ri(a.type);if(_&&_.flags&262144&&(_=Sf(_)),_&&Gn(_)&7)return rv(_)}function I5t(r){let a=kf(r,!1,!1);return a&&ca(a)?Qb(a):void 0}function mGe(r){return!!jz(r,a=>!(a.flags&8192))}function II(r){return yh(Cs(r),r)}function i$(r){return bm(r,50331648)}function dAe(r){return i$(r)?a1(r):r}function w5t(r,a){let _=ol(r)?cp(r):void 0;if(r.kind===106){He(r,g.The_value_0_cannot_be_used_here,"null");return}if(_!==void 0&&_.length<100){if(ze(r)&&_==="undefined"){He(r,g.The_value_0_cannot_be_used_here,"undefined");return}He(r,a&16777216?a&33554432?g._0_is_possibly_null_or_undefined:g._0_is_possibly_undefined:g._0_is_possibly_null,_)}else He(r,a&16777216?a&33554432?g.Object_is_possibly_null_or_undefined:g.Object_is_possibly_undefined:g.Object_is_possibly_null)}function O5t(r,a){He(r,a&16777216?a&33554432?g.Cannot_invoke_an_object_which_is_possibly_null_or_undefined:g.Cannot_invoke_an_object_which_is_possibly_undefined:g.Cannot_invoke_an_object_which_is_possibly_null)}function gGe(r,a,_){if(Q&&r.flags&2){if(ol(a)){let y=cp(a);if(y.length<100)return He(a,g._0_is_of_type_unknown,y),ht}return He(a,g.Object_is_of_type_unknown),ht}let d=v4(r,50331648);if(d&50331648){_(a,d);let y=a1(r);return y.flags&229376?ht:y}return r}function yh(r,a){return gGe(r,a,w5t)}function hGe(r,a){let _=yh(r,a);if(_.flags&16384){if(ol(a)){let d=cp(a);if(ze(a)&&d==="undefined")return He(a,g.The_value_0_cannot_be_used_here,d),_;if(d.length<100)return He(a,g._0_is_possibly_undefined,d),_}He(a,g.Object_is_possibly_undefined)}return _}function eoe(r,a,_){return r.flags&64?R5t(r,a):gAe(r,r.expression,II(r.expression),r.name,a,_)}function R5t(r,a){let _=Cs(r.expression),d=DL(_,r.expression);return Nae(gAe(r,r.expression,yh(d,r.expression),r.name,a),r,d!==_)}function yGe(r,a){let _=lj(r)&&eE(r.left)?yh(Kz(r.left),r.left):II(r.left);return gAe(r,r.left,_,r.right,a)}function vGe(r){for(;r.parent.kind===217;)r=r.parent;return Jg(r.parent)&&r.parent.expression===r}function toe(r,a){for(let _=nj(a);_;_=Vu(_)){let{symbol:d}=_,y=G8(d,r),T=d.members&&d.members.get(y)||d.exports&&d.exports.get(y);if(T)return T}}function M5t(r){if(!Vu(r))return kr(r,g.Private_identifiers_are_not_allowed_outside_class_bodies);if(!oU(r.parent)){if(!k0(r))return kr(r,g.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression);let a=bn(r.parent)&&r.parent.operatorToken.kind===103;if(!roe(r)&&!a)return kr(r,g.Cannot_find_name_0,Nn(r))}return!1}function L5t(r){M5t(r);let a=roe(r);return a&&a$(a,void 0,!1),W}function roe(r){if(!k0(r))return;let a=_i(r);return a.resolvedSymbol===void 0&&(a.resolvedSymbol=toe(r.escapedText,r)),a.resolvedSymbol}function mAe(r,a){return ka(r,a.escapedName)}function F5t(r,a,_){let d,y=Io(r);y&&Te(y,P=>{let L=P.valueDeclaration;if(L&&W_(L)&&is(L.name)&&L.name.escapedText===a.escapedText)return d=P,!0});let T=Ym(a);if(d){let P=I.checkDefined(d.valueDeclaration),L=I.checkDefined(Vu(P));if(_?.valueDeclaration){let J=_.valueDeclaration,G=Vu(J);if(I.assert(!!G),Gr(G,ae=>L===ae)){let ae=He(a,g.The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling,T,Kr(r));return Ga(ae,$n(J,g.The_shadowing_declaration_of_0_is_defined_here,T),$n(P,g.The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here,T)),!0}}return He(a,g.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier,T,Ym(L.name||YU)),!0}return!1}function SGe(r,a){return(dI(a)||x8(r)&&r4(a))&&kf(r,!0,!1)===n4(a)}function gAe(r,a,_,d,y,T){let P=_i(a).resolvedSymbol,L=kA(r),J=Tf(L!==0||vGe(r)?Yp(_):_),G=wt(J)||J===Ns,ae;if(is(d)){pe<99&&(L!==0&&iu(r,1048576),L!==1&&iu(r,524288));let be=toe(d.escapedText,d);if(L&&be&&be.valueDeclaration&&pl(be.valueDeclaration)&&kr(d,g.Cannot_assign_to_private_method_0_Private_methods_are_not_writable,Nn(d)),G){if(be)return Xt(J)?ht:J;if(nj(d)===void 0)return kr(d,g.Private_identifiers_are_not_allowed_outside_class_bodies),W}if(ae=be&&mAe(_,be),ae===void 0){if(F5t(_,d,be))return ht;let Ye=nj(d);Ye&&p8(Xr(Ye),$.checkJs)&&kr(d,g.Private_field_0_must_be_declared_in_an_enclosing_class,Nn(d))}else ae.flags&65536&&!(ae.flags&32768)&&L!==1&&He(r,g.Private_accessor_was_defined_without_a_getter)}else{if(G)return ze(a)&&P&&Wae(P,r),Xt(J)?ht:J;ae=ka(J,d.escapedText,doe(J),r.kind===166)}ze(a)&&P&&(fm($)||!(ae&&(KL(ae)||ae.flags&8&&r.parent.kind===306))||aE($)&&BWe(r))&&Wae(P,r);let Ce;if(ae){let be=fke(ae,d);if(mS(be)&&Hxe(r,be)&&be.declarations&&Q1(d,be.declarations,d.escapedText),j5t(ae,r,d),a$(ae,r,kGe(a,P)),_i(r).resolvedSymbol=ae,pAe(r,a.kind===108,wA(r),J,ae),gHe(r,ae,L))return He(d,g.Cannot_assign_to_0_because_it_is_a_read_only_property,Nn(d)),ht;Ce=SGe(r,ae)?st:T||Bj(r)?XE(ae):vn(ae)}else{let be=!is(d)&&(L===0||!hC(_)||x6(_))?iP(J,d.escapedText):void 0;if(!(be&&be.type)){let Ye=hAe(r,_.symbol,!0);return!Ye&&TL(_)?W:_.symbol===at?(at.exports.has(d.escapedText)&&at.exports.get(d.escapedText).flags&418?He(d,g.Property_0_does_not_exist_on_type_1,Zi(d.escapedText),Kr(_)):ve&&He(d,g.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature,Kr(_)),W):(d.escapedText&&!zx(r)&&EGe(d,x6(_)?J:_,Ye),ht)}be.isReadonly&&(N0(r)||tX(r))&&He(r,g.Index_signature_in_type_0_only_permits_reading,Kr(J)),Ce=$.noUncheckedIndexedAccess&&!N0(r)?pi([be.type,B]):be.type,$.noPropertyAccessFromIndexSignature&&Hn(r)&&He(d,g.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0,Zi(d.escapedText)),be.declaration&&K1(be.declaration)&&Q1(d,[be.declaration],d.escapedText)}return TGe(r,ae,Ce,d,y)}function hAe(r,a,_){var d;let y=Xr(r);if(y&&$.checkJs===void 0&&y.checkJsDirective===void 0&&(y.scriptKind===1||y.scriptKind===2)){let T=Te(a?.declarations,Xr),P=!a?.valueDeclaration||!Ti(a.valueDeclaration)||((d=a.valueDeclaration.heritageClauses)==null?void 0:d.length)||k1(!1,a.valueDeclaration);return!(y!==T&&T&&Kh(T))&&!(_&&a&&a.flags&32&&P)&&!(r&&_&&Hn(r)&&r.expression.kind===110&&P)}return!1}function TGe(r,a,_,d,y){let T=kA(r);if(T===1)return WS(_,!!(a&&a.flags&16777216));if(a&&!(a.flags&98311)&&!(a.flags&8192&&_.flags&1048576)&&!Noe(a.declarations))return _;if(_===st)return mI(r,a);_=WCe(_,r,y);let P=!1;if(Q&&we&&Yo(r)&&r.expression.kind===110){let J=a&&a.valueDeclaration;if(J&&vYe(J)&&!pa(J)){let G=LL(r);G.kind===176&&G.parent===J.parent&&!(J.flags&33554432)&&(P=!0)}}else Q&&a&&a.valueDeclaration&&Hn(a.valueDeclaration)&&R8(a.valueDeclaration)&&LL(r)===LL(a.valueDeclaration)&&(P=!0);let L=GS(r,_,P?$S(_):_);return P&&!p4(_)&&p4(L)?(He(d,g.Property_0_is_used_before_being_assigned,Oi(a)),_):T?s1(L):L}function j5t(r,a,_){let{valueDeclaration:d}=r;if(!d||Xr(a).isDeclarationFile)return;let y,T=Nn(_);bGe(a)&&!ARt(d)&&!(Yo(a)&&Yo(a.expression))&&!qy(d,_)&&!(pl(d)&&joe(d)&256)&&(Se||!B5t(r))?y=He(_,g.Property_0_is_used_before_its_initialization,T):d.kind===263&&a.parent.kind!==183&&!(d.flags&33554432)&&!qy(d,_)&&(y=He(_,g.Class_0_used_before_its_declaration,T)),y&&Ga(y,$n(d,g._0_is_declared_here,T))}function bGe(r){return!!Gr(r,a=>{switch(a.kind){case 172:return!0;case 303:case 174:case 177:case 178:case 305:case 167:case 239:case 294:case 291:case 292:case 293:case 286:case 233:case 298:return!1;case 219:case 244:return ra(a.parent)&&Jc(a.parent.parent)?!0:"quit";default:return k0(a)?!1:"quit"}})}function B5t(r){if(!(r.parent.flags&32))return!1;let a=vn(r.parent);for(;;){if(a=a.symbol&&U5t(a),!a)return!1;let _=ka(a,r.escapedName);if(_&&_.valueDeclaration)return!0}}function U5t(r){let a=Cp(r);if(a.length!==0)return Pa(a)}function EGe(r,a,_){let d,y;if(!is(r)&&a.flags&1048576&&!(a.flags&402784252)){for(let P of a.types)if(!ka(P,r.escapedText)&&!iP(P,r.escapedText)){d=Xs(d,g.Property_0_does_not_exist_on_type_1,qo(r),Kr(P));break}}if(xGe(r.escapedText,a)){let P=qo(r),L=Kr(a);d=Xs(d,g.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead,P,L,L+"."+P)}else{let P=$L(a);if(P&&ka(P,r.escapedText))d=Xs(d,g.Property_0_does_not_exist_on_type_1,qo(r),Kr(a)),y=$n(r,g.Did_you_forget_to_use_await);else{let L=qo(r),J=Kr(a),G=q5t(L,a);if(G!==void 0)d=Xs(d,g.Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later,L,J,G);else{let ae=yAe(r,a);if(ae!==void 0){let Ce=Lc(ae),be=_?g.Property_0_may_not_exist_on_type_1_Did_you_mean_2:g.Property_0_does_not_exist_on_type_1_Did_you_mean_2;d=Xs(d,be,L,J,Ce),y=ae.valueDeclaration&&$n(ae.valueDeclaration,g._0_is_declared_here,Ce)}else{let Ce=V5t(a)?g.Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom:g.Property_0_does_not_exist_on_type_1;d=Xs(mxe(d,a),Ce,L,J)}}}}let T=Ey(Xr(r),r,d);y&&Ga(T,y),vg(!_||d.code!==g.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code,T)}function V5t(r){return $.lib&&!$.lib.includes("dom")&&ZLt(r,a=>a.symbol&&/^(EventTarget|Node|((HTML[a-zA-Z]*)?Element))$/.test(Zi(a.symbol.escapedName)))&&i1(r)}function xGe(r,a){let _=a.symbol&&ka(vn(a.symbol),r);return _!==void 0&&!!_.valueDeclaration&&pa(_.valueDeclaration)}function J5t(r){let a=Ym(r),d=pB().get(a);return d&&Ja(d.keys())}function q5t(r,a){let _=Tf(a).symbol;if(!_)return;let d=Lc(_),T=pB().get(d);if(T){for(let[P,L]of T)if(hs(L,r))return P}}function CGe(r,a){return s$(r,Io(a),106500)}function yAe(r,a){let _=Io(a);if(typeof r!="string"){let d=r.parent;Hn(d)&&(_=Fn(_,y=>PGe(d,a,y))),r=Nn(r)}return s$(r,_,111551)}function AGe(r,a){let _=vs(r)?r:Nn(r),d=Io(a);return(_==="for"?mr(d,T=>Lc(T)==="htmlFor"):_==="class"?mr(d,T=>Lc(T)==="className"):void 0)??s$(_,d,111551)}function vAe(r,a){let _=yAe(r,a);return _&&Lc(_)}function SAe(r,a,_){return I.assert(a!==void 0,"outername should always be defined"),zp(r,a,_,void 0,a,!1,!1,!0,(y,T,P)=>{I.assertEqual(a,T,"name should equal outerName");let L=Lf(y,T,P);if(L)return L;let J;return y===ke?J=Wi(["string","number","boolean","object","bigint","symbol"],ae=>y.has(ae.charAt(0).toUpperCase()+ae.slice(1))?oo(524288,ae):void 0).concat(In(y.values())):J=In(y.values()),s$(Zi(T),J,P)})}function z5t(r,a,_){let d=SAe(r,a,_);return d&&Lc(d)}function noe(r,a){return a.exports&&s$(Nn(r),tC(a),2623475)}function $5t(r,a){let _=noe(r,a);return _&&Lc(_)}function W5t(r,a,_){function d(P){let L=ub(r,P);if(L){let J=NC(vn(L));return!!J&&Th(J)>=1&&Na(_,Ig(J,0))}return!1}let y=N0(a)?"set":"get";if(!d(y))return;let T=rR(a.expression);return T===void 0?T=y:T+="."+y,T}function G5t(r,a){let _=a.types.filter(d=>!!(d.flags&128));return FP(r.value,_,d=>d.value)}function s$(r,a,_){return FP(r,a,d);function d(y){let T=Lc(y);if(!Ss(T,'"')){if(y.flags&_)return T;if(y.flags&2097152){let P=Qx(y);if(P&&P.flags&_)return T}}}}function a$(r,a,_){let d=r&&r.flags&106500&&r.valueDeclaration;if(!d)return;let y=up(d,2),T=r.valueDeclaration&&W_(r.valueDeclaration)&&is(r.valueDeclaration.name);if(!(!y&&!T)&&!(a&&Bj(a)&&!(r.flags&65536))){if(_){let P=Gr(a,tc);if(P&&P.symbol===r)return}(Vc(r)&1?as(r).target:r).isReferenced=-1}}function kGe(r,a){return r.kind===110||!!a&&ol(r)&&a===tg(Jp(r))}function H5t(r,a){switch(r.kind){case 211:return TAe(r,r.expression.kind===108,a,Yp(Cs(r.expression)));case 166:return TAe(r,!1,a,Yp(Cs(r.left)));case 205:return TAe(r,!1,a,Ri(r))}}function PGe(r,a,_){return bAe(r,r.kind===211&&r.expression.kind===108,!1,a,_)}function TAe(r,a,_,d){if(wt(d))return!0;let y=ka(d,_);return!!y&&bAe(r,a,!1,d,y)}function bAe(r,a,_,d,y){if(wt(d))return!0;if(y.valueDeclaration&&G_(y.valueDeclaration)){let T=Vu(y.valueDeclaration);return!w_(r)&&!!Gr(r,P=>P===T)}return dGe(r,a,_,d,y)}function Y5t(r){let a=r.initializer;if(a.kind===261){let _=a.declarations[0];if(_&&!la(_.name))return Rn(_)}else if(a.kind===80)return tg(a)}function X5t(r){return nf(r).length===1&&!!K0(r,It)}function K5t(r){let a=Do(r);if(a.kind===80){let _=tg(a);if(_.flags&3){let d=r,y=r.parent;for(;y;){if(y.kind===249&&d===y.statement&&Y5t(y)===_&&X5t(l_(y.expression)))return!0;d=y,y=y.parent}}}return!1}function Q5t(r,a){return r.flags&64?Z5t(r,a):NGe(r,II(r.expression),a)}function Z5t(r,a){let _=Cs(r.expression),d=DL(_,r.expression);return Nae(NGe(r,yh(d,r.expression),a),r,d!==_)}function NGe(r,a,_){let d=kA(r)!==0||vGe(r)?Yp(a):a,y=r.argumentExpression,T=Cs(y);if(Xt(d)||d===Ns)return d;if(doe(d)&&!bo(y))return He(y,g.A_const_enum_member_can_only_be_accessed_using_a_string_literal),ht;let P=K5t(y)?It:T,L=N0(r)?4|(hC(d)&&!x6(d)?2:0):32,J=BS(d,P,L,r)||ht;return FHe(TGe(r,_i(r).resolvedSymbol,J,y,_),r)}function DGe(r){return Jg(r)||uE(r)||H_(r)}function PC(r){return DGe(r)&&Te(r.typeArguments,Ba),r.kind===215?Cs(r.template):H_(r)?Cs(r.attributes):bn(r)?Cs(r.left):Jg(r)&&Te(r.arguments,a=>{Cs(a)}),Et}function vh(r){return PC(r),gr}function e9t(r,a,_){let d,y,T=0,P,L=-1,J;I.assert(!a.length);for(let G of r){let ae=G.declaration&&Rn(G.declaration),Ce=G.declaration&&G.declaration.parent;!y||ae===y?d&&Ce===d?P=P+1:(d=Ce,P=T):(P=T=a.length,d=Ce),y=ae,ZQ(G)?(L++,J=L,T++):J=P,a.splice(J,0,_?H8t(G,_):G)}}function ioe(r){return!!r&&(r.kind===230||r.kind===237&&r.isSpread)}function soe(r){return oa(r,ioe)}function IGe(r){return!!(r.flags&16384)}function t9t(r){return!!(r.flags&49155)}function aoe(r,a,_,d=!1){let y,T=!1,P=Xp(_),L=Th(_);if(r.kind===215)if(y=a.length,r.template.kind===228){let J=Rs(r.template.templateSpans);T=sl(J.literal)||!!J.literal.isUnterminated}else{let J=r.template;I.assert(J.kind===15),T=!!J.isUnterminated}else if(r.kind===170)y=BGe(r,_);else if(r.kind===226)y=1;else if(H_(r)){if(T=r.attributes.end===r.end,T)return!0;y=L===0?a.length:1,P=a.length===0?P:1,L=Math.min(L,1)}else if(r.arguments){y=d?a.length+1:a.length,T=r.arguments.end===r.end;let J=soe(a);if(J>=0)return J>=Th(_)&&(u0(_)||J<Xp(_))}else return I.assert(r.kind===214),Th(_)===0;if(!u0(_)&&y>P)return!1;if(T||y>=L)return!0;for(let J=y;J<L;J++){let G=Ig(_,J);if(wl(G,gn(r)&&!Q?t9t:IGe).flags&131072)return!1}return!0}function EAe(r,a){let _=de(r.typeParameters),d=a0(r.typeParameters);return!Tt(a)||a.length>=d&&a.length<=_}function wGe(r,a){let _;return!!(r.target&&(_=c2(r.target,a))&&AI(_))}function NC(r){return BL(r,0,!1)}function OGe(r){return BL(r,0,!1)||BL(r,1,!1)}function BL(r,a,_){if(r.flags&524288){let d=kg(r);if(_||d.properties.length===0&&d.indexInfos.length===0){if(a===0&&d.callSignatures.length===1&&d.constructSignatures.length===0)return d.callSignatures[0];if(a===1&&d.constructSignatures.length===1&&d.callSignatures.length===0)return d.constructSignatures[0]}}}function RGe(r,a,_,d){let y=OL(r.typeParameters,r,0,d),T=UL(a),P=_&&(T&&T.flags&262144?_.nonFixingMapper:_.mapper),L=P?PI(a,P):a;return ECe(L,r,(J,G)=>{o1(y.inferences,J,G)}),_||xCe(a,r,(J,G)=>{o1(y.inferences,J,G,128)}),hL(r,LCe(y),gn(a.declaration))}function r9t(r,a,_,d){let y=Kae(a,r),T=RI(r.attributes,y,d,_);return o1(d.inferences,T,y),LCe(d)}function MGe(r){if(!r)return fn;let a=Cs(r);return nme(r)?a:Nw(r.parent)?a1(a):w_(r.parent)?Pae(a):a}function xAe(r,a,_,d,y){if(H_(r))return r9t(r,a,d,y);if(r.kind!==170&&r.kind!==226){let J=yr(a.typeParameters,ae=>!!pC(ae)),G=Bf(r,J?8:0);if(G){let ae=Ao(a);if(yb(ae)){let Ce=a2(r);if(!(!J&&Bf(r,8)!==G)){let Dt=PCe(mLt(Ce,1)),ur=gs(G,Dt),pr=NC(ur),dn=pr&&pr.typeParameters?dC(bxe(pr,pr.typeParameters)):ur;o1(y.inferences,dn,ae,128)}let Ye=OL(a.typeParameters,a,y.flags),vt=gs(G,Ce&&Ce.returnMapper);o1(Ye.inferences,vt,ae),y.returnMapper=Tt(Ye.inferences,MI)?PCe(vLt(Ye)):void 0}}}let T=VL(a),P=T?Math.min(Xp(a)-1,_.length):_.length;if(T&&T.flags&262144){let J=mr(y.inferences,G=>G.typeParameter===T);J&&(J.impliedArity=oa(_,ioe,P)<0?_.length-P:void 0)}let L=fb(a);if(L&&yb(L)){let J=jGe(r);o1(y.inferences,MGe(J),L)}for(let J=0;J<P;J++){let G=_[J];if(G.kind!==232){let ae=Ig(a,J);if(yb(ae)){let Ce=RI(G,ae,y,d);o1(y.inferences,Ce,ae)}}}if(T&&yb(T)){let J=CAe(_,P,_.length,T,y,d);o1(y.inferences,J,T)}return LCe(y)}function LGe(r){return r.flags&1048576?Ec(r,LGe):r.flags&1||Uz(k_(r)||r)?r:Ka(r)?c0(ZE(r),r.target.elementFlags,!1,r.target.labeledElementDeclarations):c0([r],[8])}function CAe(r,a,_,d,y,T){let P=fC(d);if(a>=_-1){let ae=r[_-1];if(ioe(ae)){let Ce=ae.kind===237?ae.type:RI(ae.expression,d,y,T);return cv(Ce)?LGe(Ce):P_(uv(33,Ce,Be,ae.kind===230?ae.expression:ae),P)}}let L=[],J=[],G=[];for(let ae=a;ae<_;ae++){let Ce=r[ae];if(ioe(Ce)){let be=Ce.kind===237?Ce.type:Cs(Ce.expression);cv(be)?(L.push(be),J.push(8)):(L.push(uv(33,be,Be,Ce.kind===230?Ce.expression:Ce)),J.push(4))}else{let be=Ka(d)?rAe(d,ae-a,_-a)||Sr:Ap(d,Ng(ae-a),256),Ye=RI(Ce,be,y,T),vt=P||$c(be,406978556);L.push(vt?af(Ye):i2(Ye)),J.push(1)}Ce.kind===237&&Ce.tupleNameSource?G.push(Ce.tupleNameSource):G.push(void 0)}return c0(L,J,P&&!rg(d,hCe),G)}function AAe(r,a,_,d){let y=gn(r.declaration),T=r.typeParameters,P=FS(vr(a,Ri),T,a0(T),y),L;for(let J=0;J<a.length;J++){I.assert(T[J]!==void 0,"Should not call checkTypeArguments with too many type arguments");let G=Sf(T[J]);if(G){let ae=_&&d?()=>Xs(void 0,g.Type_0_does_not_satisfy_the_constraint_1):void 0,Ce=d||g.Type_0_does_not_satisfy_the_constraint_1;L||(L=kp(T,P));let be=P[J];if(!J_(be,Hp(gs(G,L),be),_?a[J]:void 0,Ce,ae))return}}return P}function FGe(r){if(uP(r.tagName))return 2;let a=Tf(Cs(r.tagName));return de(na(a,1))?0:de(na(a,0))?1:2}function n9t(r,a,_,d,y,T,P){let L=Kae(a,r),J=RI(r.attributes,L,void 0,d),G=d&4?wL(J):J;return ae()&&cCe(G,L,_,y?r.tagName:void 0,r.attributes,void 0,T,P);function ae(){var Ce;if(cAe(r))return!0;let be=(eh(r)||px(r))&&!(uP(r.tagName)||pg(r.tagName))?Cs(r.tagName):void 0;if(!be)return!0;let Ye=na(be,0);if(!de(Ye))return!0;let vt=zYe(r);if(!vt)return!0;let Dt=ac(vt,111551,!0,!1,r);if(!Dt)return!0;let ur=vn(Dt),pr=na(ur,0);if(!de(pr))return!0;let dn=!1,Ur=0;for(let $r of pr){let Jr=Ig($r,0),on=na(Jr,0);if(de(on))for(let Qr of on){if(dn=!0,u0(Qr))return!0;let cn=Xp(Qr);cn>Ur&&(Ur=cn)}}if(!dn)return!0;let fr=1/0;for(let $r of Ye){let Jr=Th($r);Jr<fr&&(fr=Jr)}if(fr<=Ur)return!0;if(y){let $r=$n(r.tagName,g.Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3,cp(r.tagName),fr,cp(vt),Ur),Jr=(Ce=ng(r.tagName))==null?void 0:Ce.valueDeclaration;Jr&&Ga($r,$n(Jr,g._0_is_declared_here,cp(r.tagName))),P&&P.skipLogging&&(P.errors||(P.errors=[])).push($r),P.skipLogging||fo.add($r)}return!1}}function ooe(r){return r=Do(r),LK(r)?Do(r.expression):r}function o$(r,a,_,d,y,T,P){let L={errors:void 0,skipLogging:!0};if(H_(r))return n9t(r,_,d,y,T,P,L)?void 0:(I.assert(!T||!!L.errors,"jsx should have errors when reporting errors"),L.errors||tt);let J=fb(_);if(J&&J!==fn&&!(lE(r)||da(r)&&Pf(r.expression))){let Ye=jGe(r),vt=MGe(Ye),Dt=T?Ye||r:void 0,ur=g.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1;if(!Wd(vt,J,d,Dt,ur,P,L))return I.assert(!T||!!L.errors,"this parameter should have errors when reporting errors"),L.errors||tt}let G=g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1,ae=VL(_),Ce=ae?Math.min(Xp(_)-1,a.length):a.length;for(let Ye=0;Ye<Ce;Ye++){let vt=a[Ye];if(vt.kind!==232){let Dt=Ig(_,Ye),ur=RI(vt,Dt,void 0,y),pr=y&4?wL(ur):ur,dn=ooe(vt);if(!cCe(pr,Dt,d,T?dn:void 0,dn,G,P,L))return I.assert(!T||!!L.errors,"parameter should have errors when reporting errors"),be(vt,pr,Dt),L.errors||tt}}if(ae){let Ye=CAe(a,Ce,a.length,ae,void 0,y),vt=a.length-Ce,Dt=T?vt===0?r:vt===1?ooe(a[Ce]):jh(c$(r,Ye),a[Ce].pos,a[a.length-1].end):void 0;if(!Wd(Ye,ae,d,Dt,G,void 0,L))return I.assert(!T||!!L.errors,"rest parameter should have errors when reporting errors"),be(Dt,Ye,ae),L.errors||tt}return;function be(Ye,vt,Dt){if(Ye&&T&&L.errors&&L.errors.length){if(P4(Dt))return;let ur=P4(vt);ur&&hh(ur,Dt,d)&&Ga(L.errors[0],$n(Ye,g.Did_you_forget_to_use_await))}}}function jGe(r){if(r.kind===226)return r.right;let a=r.kind===213?r.expression:r.kind===215?r.tag:r.kind===170&&!se?r.expression:void 0;if(a){let _=vl(a);if(Yo(_))return _.expression}}function c$(r,a,_,d){let y=$h.createSyntheticExpression(a,_,d);return ft(y,r),io(y,r),y}function coe(r){if(r.kind===215){let d=r.template,y=[c$(d,qRt())];return d.kind===228&&Te(d.templateSpans,T=>{y.push(T.expression)}),y}if(r.kind===170)return i9t(r);if(r.kind===226)return[r.left];if(H_(r))return r.attributes.properties.length>0||eh(r)&&r.parent.children.length>0?[r.attributes]:tt;let a=r.arguments||tt,_=soe(a);if(_>=0){let d=a.slice(0,_);for(let y=_;y<a.length;y++){let T=a[y],P=T.kind===230&&(gd?Cs(T.expression):xl(T.expression));P&&Ka(P)?Te(ZE(P),(L,J)=>{var G;let ae=P.target.elementFlags[J],Ce=c$(T,ae&4?P_(L):L,!!(ae&12),(G=P.target.labeledElementDeclarations)==null?void 0:G[J]);d.push(Ce)}):d.push(T)}return d}return a}function i9t(r){let a=r.expression,_=jAe(r);if(_){let d=[];for(let y of _.parameters){let T=vn(y);d.push(c$(a,T))}return d}return I.fail()}function BGe(r,a){return $.experimentalDecorators?s9t(r,a):2}function s9t(r,a){switch(r.parent.kind){case 263:case 231:return 1;case 172:return Hg(r.parent)?3:2;case 174:case 177:case 178:return pe===0||a.parameters.length<=2?2:3;case 169:return 3;default:return I.fail()}}function UGe(r){let a=Xr(r),{start:_,length:d}=z2(a,Hn(r.expression)?r.expression.name:r.expression);return{start:_,length:d,sourceFile:a}}function l$(r,a,..._){if(da(r)){let{sourceFile:d,start:y,length:T}=UGe(r);return"message"in a?Iu(d,y,T,a,..._):FY(d,a)}else return"message"in a?$n(r,a,..._):Ey(Xr(r),r,a)}function a9t(r){return Jg(r)?Hn(r.expression)?r.expression.name:r.expression:uE(r)?Hn(r.tag)?r.tag.name:r.tag:H_(r)?r.tagName:r}function o9t(r){if(!da(r)||!ze(r.expression))return!1;let a=wc(r.expression,r.expression.escapedText,111551,void 0,void 0,!1),_=a?.valueDeclaration;if(!_||!Ls(_)||!iE(_.parent)||!lE(_.parent.parent)||!ze(_.parent.parent.expression))return!1;let d=Mxe(!1);return d?ng(_.parent.parent.expression,!0)===d:!1}function VGe(r,a,_,d){var y;let T=soe(_);if(T>-1)return $n(_[T],g.A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter);let P=Number.POSITIVE_INFINITY,L=Number.NEGATIVE_INFINITY,J=Number.NEGATIVE_INFINITY,G=Number.POSITIVE_INFINITY,ae;for(let Dt of a){let ur=Th(Dt),pr=Xp(Dt);ur<P&&(P=ur,ae=Dt),L=Math.max(L,pr),ur<_.length&&ur>J&&(J=ur),_.length<pr&&pr<G&&(G=pr)}let Ce=Tt(a,u0),be=Ce?P:P<L?P+"-"+L:P,Ye=!Ce&&be===1&&_.length===0&&o9t(r);if(Ye&&gn(r))return l$(r,g.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments);let vt=n_(r)?Ce?g.The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_at_least_0:g.The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_0:Ce?g.Expected_at_least_0_arguments_but_got_1:Ye?g.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise:g.Expected_0_arguments_but_got_1;if(P<_.length&&_.length<L){if(d){let Dt=Xs(void 0,g.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments,_.length,J,G);return Dt=Xs(Dt,d),l$(r,Dt)}return l$(r,g.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments,_.length,J,G)}else if(_.length<P){let Dt;if(d){let pr=Xs(void 0,vt,be,_.length);pr=Xs(pr,d),Dt=l$(r,pr)}else Dt=l$(r,vt,be,_.length);let ur=(y=ae?.declaration)==null?void 0:y.parameters[ae.thisParameter?_.length+1:_.length];if(ur){let pr=la(ur.name)?[g.An_argument_matching_this_binding_pattern_was_not_provided]:x0(ur)?[g.Arguments_for_the_rest_parameter_0_were_not_provided,Nn(Jp(ur.name))]:[g.An_argument_for_0_was_not_provided,ur.name?Nn(Jp(ur.name)):_.length],dn=$n(ur,...pr);return Ga(Dt,dn)}return Dt}else{let Dt=j.createNodeArray(_.slice(L)),ur=di(Dt).pos,pr=Rs(Dt).end;if(pr===ur&&pr++,jh(Dt,ur,pr),d){let dn=Xs(void 0,vt,be,_.length);return dn=Xs(dn,d),y8(Xr(r),Dt,dn)}return sN(Xr(r),Dt,vt,be,_.length)}}function c9t(r,a,_,d){let y=_.length;if(a.length===1){let L=a[0],J=a0(L.typeParameters),G=de(L.typeParameters);if(d){let ae=Xs(void 0,g.Expected_0_type_arguments_but_got_1,J<G?J+"-"+G:J,y);return ae=Xs(ae,d),y8(Xr(r),_,ae)}return sN(Xr(r),_,g.Expected_0_type_arguments_but_got_1,J<G?J+"-"+G:J,y)}let T=-1/0,P=1/0;for(let L of a){let J=a0(L.typeParameters),G=de(L.typeParameters);J>y?P=Math.min(P,J):G<y&&(T=Math.max(T,G))}if(T!==-1/0&&P!==1/0){if(d){let L=Xs(void 0,g.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments,y,T,P);return L=Xs(L,d),y8(Xr(r),_,L)}return sN(Xr(r),_,g.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments,y,T,P)}if(d){let L=Xs(void 0,g.Expected_0_type_arguments_but_got_1,T===-1/0?P:T,y);return L=Xs(L,d),y8(Xr(r),_,L)}return sN(Xr(r),_,g.Expected_0_type_arguments_but_got_1,T===-1/0?P:T,y)}function wI(r,a,_,d,y,T){let P=r.kind===215,L=r.kind===170,J=H_(r),G=r.kind===226,ae=!H&&!_,Ce;!L&&!G&&!$2(r)&&(Ce=r.typeArguments,(P||J||r.expression.kind!==108)&&Te(Ce,Ba));let be=_||[];e9t(a,be,y),I.assert(be.length,"Revert #54442 and add a testcase with whatever triggered this");let Ye=coe(r),vt=be.length===1&&!be[0].typeParameters,Dt=!L&&!vt&&Tt(Ye,$d)?4:0,ur,pr,dn,Ur,fr=!!(d&16)&&r.kind===213&&r.arguments.hasTrailingComma;if(be.length>1&&(Ur=Jr(be,Xh,vt,fr)),Ur||(Ur=Jr(be,Mf,vt,fr)),Ur)return Ur;if(Ur=l9t(r,be,Ye,!!_,d),_i(r).resolvedSignature=Ur,ae)if(!T&&G&&(T=g.The_left_hand_side_of_an_instanceof_expression_must_be_assignable_to_the_first_argument_of_the_right_hand_side_s_Symbol_hasInstance_method),ur)if(ur.length===1||ur.length>3){let on=ur[ur.length-1],Qr;ur.length>3&&(Qr=Xs(Qr,g.The_last_overload_gave_the_following_error),Qr=Xs(Qr,g.No_overload_matches_this_call)),T&&(Qr=Xs(Qr,T));let cn=o$(r,Ye,on,Mf,0,!0,()=>Qr);if(cn)for(let Bs of cn)on.declaration&&ur.length>3&&Ga(Bs,$n(on.declaration,g.The_last_overload_is_declared_here)),$r(on,Bs),fo.add(Bs);else I.fail("No error for last overload signature")}else{let on=[],Qr=0,cn=Number.MAX_VALUE,Bs=0,Os=0;for(let rp of ur){let an=o$(r,Ye,rp,Mf,0,!0,()=>Xs(void 0,g.Overload_0_of_1_2_gave_the_following_error,Os+1,be.length,t0(rp)));an?(an.length<=cn&&(cn=an.length,Bs=Os),Qr=Math.max(Qr,an.length),on.push(an)):I.fail("No error for 3 or fewer overload signatures"),Os++}let Ys=Qr>1?on[Bs]:ip(on);I.assert(Ys.length>0,"No errors reported for 3 or fewer overload signatures");let As=Xs(vr(Ys,ode),g.No_overload_matches_this_call);T&&(As=Xs(As,T));let su=[..._a(Ys,rp=>rp.relatedInformation)],Hd;if(yr(Ys,rp=>rp.start===Ys[0].start&&rp.length===Ys[0].length&&rp.file===Ys[0].file)){let{file:rp,start:Br,length:an}=Ys[0];Hd={file:rp,start:Br,length:an,code:As.code,category:As.category,messageText:As,relatedInformation:su}}else Hd=Ey(Xr(r),a9t(r),As,su);$r(ur[0],Hd),fo.add(Hd)}else if(pr)fo.add(VGe(r,[pr],Ye,T));else if(dn)AAe(dn,r.typeArguments,!0,T);else{let on=Fn(a,Qr=>EAe(Qr,Ce));on.length===0?fo.add(c9t(r,a,Ce,T)):fo.add(VGe(r,on,Ye,T))}return Ur;function $r(on,Qr){var cn,Bs;let Os=ur,Ys=pr,As=dn,su=((Bs=(cn=on.declaration)==null?void 0:cn.symbol)==null?void 0:Bs.declarations)||tt,rp=su.length>1?mr(su,Br=>tc(Br)&&nm(Br.body)):void 0;if(rp){let Br=Sm(rp),an=!Br.typeParameters;Jr([Br],Mf,an)&&Ga(Qr,$n(rp,g.The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible))}ur=Os,pr=Ys,dn=As}function Jr(on,Qr,cn,Bs=!1){if(ur=void 0,pr=void 0,dn=void 0,cn){let Os=on[0];if(Tt(Ce)||!aoe(r,Ye,Os,Bs))return;if(o$(r,Ye,Os,Qr,0,!1,void 0)){ur=[Os];return}return Os}for(let Os=0;Os<on.length;Os++){let Ys=on[Os];if(!EAe(Ys,Ce)||!aoe(r,Ye,Ys,Bs))continue;let As,su;if(Ys.typeParameters){let Hd;if(Tt(Ce)){if(Hd=AAe(Ys,Ce,!1),!Hd){dn=Ys;continue}}else su=OL(Ys.typeParameters,Ys,gn(r)?2:0),Hd=xAe(r,Ys,Ye,Dt|8,su),Dt|=su.flags&4?8:0;if(As=hL(Ys,Hd,gn(Ys.declaration),su&&su.inferredTypeParameters),VL(Ys)&&!aoe(r,Ye,As,Bs)){pr=As;continue}}else As=Ys;if(o$(r,Ye,As,Qr,Dt,!1,void 0)){(ur||(ur=[])).push(As);continue}if(Dt){if(Dt=0,su){let Hd=xAe(r,Ys,Ye,Dt,su);if(As=hL(Ys,Hd,gn(Ys.declaration),su.inferredTypeParameters),VL(Ys)&&!aoe(r,Ye,As,Bs)){pr=As;continue}}if(o$(r,Ye,As,Qr,Dt,!1,void 0)){(ur||(ur=[])).push(As);continue}}return on[Os]=As,As}}}function l9t(r,a,_,d,y){return I.assert(a.length>0),_P(r),d||a.length===1||a.some(T=>!!T.typeParameters)?f9t(r,a,_,y):u9t(a)}function u9t(r){let a=Wi(r,J=>J.thisParameter),_;a.length&&(_=JGe(a,a.map(f$)));let{min:d,max:y}=Mme(r,_9t),T=[];for(let J=0;J<y;J++){let G=Wi(r,ae=>L_(ae)?J<ae.parameters.length-1?ae.parameters[J]:Rs(ae.parameters):J<ae.parameters.length?ae.parameters[J]:void 0);I.assert(G.length!==0),T.push(JGe(G,Wi(r,ae=>c2(ae,J))))}let P=Wi(r,J=>L_(J)?Rs(J.parameters):void 0),L=128;if(P.length!==0){let J=P_(pi(Wi(r,Tze),2));T.push(qGe(P,J)),L|=1}return r.some(ZQ)&&(L|=2),X0(r[0].declaration,void 0,_,T,Pa(r.map(Ao)),void 0,d,L)}function _9t(r){let a=r.parameters.length;return L_(r)?a-1:a}function JGe(r,a){return qGe(r,pi(a,2))}function qGe(r,a){return TC(di(r),a)}function f9t(r,a,_,d){let y=m9t(a,ar===void 0?_.length:ar),T=a[y],{typeParameters:P}=T;if(!P)return T;let L=DGe(r)?r.typeArguments:void 0,J=L?Qse(T,p9t(L,P,gn(r))):d9t(r,P,T,_,d);return a[y]=J,J}function p9t(r,a,_){let d=r.map(fP);for(;d.length>a.length;)d.pop();for(;d.length<a.length;)d.push(pC(a[d.length])||Sf(a[d.length])||MCe(_));return d}function d9t(r,a,_,d,y){let T=OL(a,_,gn(r)?2:0),P=xAe(r,_,d,y|4|8,T);return Qse(_,P)}function m9t(r,a){let _=-1,d=-1;for(let y=0;y<r.length;y++){let T=r[y],P=Xp(T);if(u0(T)||P>=a)return y;P>d&&(d=P,_=y)}return _}function g9t(r,a,_){if(r.expression.kind===108){let J=KCe(r.expression);if(wt(J)){for(let G of r.arguments)Cs(G);return Et}if(!Xt(J)){let G=$g(Vu(r));if(G){let ae=i0(J,G.typeArguments,G);return wI(r,ae,a,_,0)}}return PC(r)}let d,y=Cs(r.expression);if(L2(r)){let J=DL(y,r.expression);d=J===y?0:Dw(r)?16:8,y=J}else d=0;if(y=gGe(y,r.expression,O5t),y===Ns)return xn;let T=Tf(y);if(Xt(T))return vh(r);let P=na(T,0),L=na(T,1).length;if(u$(y,T,P.length,L))return!Xt(y)&&r.typeArguments&&He(r,g.Untyped_function_calls_may_not_accept_type_arguments),PC(r);if(!P.length){if(L)He(r,g.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new,Kr(y));else{let J;if(r.arguments.length===1){let G=Xr(r).text;I_(G.charCodeAt(Wa(G,r.expression.end,!0)-1))&&(J=$n(r.expression,g.Are_you_missing_a_semicolon))}PAe(r.expression,T,0,J)}return vh(r)}return _&8&&!r.typeArguments&&P.some(h9t)?(AHe(r,_),Dn):P.some(J=>gn(J.declaration)&&!!QH(J.declaration))?(He(r,g.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new,Kr(y)),vh(r)):wI(r,P,a,_,d)}function h9t(r){return!!(r.typeParameters&&yke(Ao(r)))}function u$(r,a,_,d){return wt(r)||wt(a)&&!!(r.flags&262144)||!_&&!d&&!(a.flags&1048576)&&!(Pg(a).flags&131072)&&Na(r,Bt)}function y9t(r,a,_){if(r.arguments&&pe<1){let P=soe(r.arguments);P>=0&&He(r.arguments[P],g.Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher)}let d=II(r.expression);if(d===Ns)return xn;if(d=Tf(d),Xt(d))return vh(r);if(wt(d))return r.typeArguments&&He(r,g.Untyped_function_calls_may_not_accept_type_arguments),PC(r);let y=na(d,1);if(y.length){if(!v9t(r,y[0]))return vh(r);if(zGe(y,L=>!!(L.flags&4)))return He(r,g.Cannot_create_an_instance_of_an_abstract_class),vh(r);let P=d.symbol&&ky(d.symbol);return P&&ui(P,64)?(He(r,g.Cannot_create_an_instance_of_an_abstract_class),vh(r)):wI(r,y,a,_,0)}let T=na(d,0);if(T.length){let P=wI(r,T,a,_,0);return ve||(P.declaration&&!Sh(P.declaration)&&Ao(P)!==fn&&He(r,g.Only_a_void_function_can_be_called_with_the_new_keyword),fb(P)===fn&&He(r,g.A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void)),P}return PAe(r.expression,d,1),vh(r)}function zGe(r,a){return os(r)?Tt(r,_=>zGe(_,a)):r.compositeKind===1048576?Tt(r.compositeSignatures,a):a(r)}function kAe(r,a){let _=Cp(a);if(!de(_))return!1;let d=_[0];if(d.flags&2097152){let y=d.types,T=rze(y),P=0;for(let L of d.types){if(!T[P]&&Gn(L)&3&&(L.symbol===r||kAe(r,L)))return!0;P++}return!1}return d.symbol===r?!0:kAe(r,d)}function v9t(r,a){if(!a||!a.declaration)return!0;let _=a.declaration,d=DA(_,6);if(!d||_.kind!==176)return!0;let y=ky(_.parent.symbol),T=dc(_.parent.symbol);if(!mke(r,y)){let P=Vu(r);if(P&&d&4){let L=fP(P);if(kAe(_.parent.symbol,L))return!0}return d&2&&He(r,g.Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration,Kr(T)),d&4&&He(r,g.Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration,Kr(T)),!1}return!0}function $Ge(r,a,_){let d,y=_===0,T=IC(a),P=T&&na(T,_).length>0;if(a.flags&1048576){let J=a.types,G=!1;for(let ae of J)if(na(ae,_).length!==0){if(G=!0,d)break}else if(d||(d=Xs(d,y?g.Type_0_has_no_call_signatures:g.Type_0_has_no_construct_signatures,Kr(ae)),d=Xs(d,y?g.Not_all_constituents_of_type_0_are_callable:g.Not_all_constituents_of_type_0_are_constructable,Kr(a))),G)break;G||(d=Xs(void 0,y?g.No_constituent_of_type_0_is_callable:g.No_constituent_of_type_0_is_constructable,Kr(a))),d||(d=Xs(d,y?g.Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other:g.Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other,Kr(a)))}else d=Xs(d,y?g.Type_0_has_no_call_signatures:g.Type_0_has_no_construct_signatures,Kr(a));let L=y?g.This_expression_is_not_callable:g.This_expression_is_not_constructable;if(da(r.parent)&&r.parent.arguments.length===0){let{resolvedSymbol:J}=_i(r);J&&J.flags&32768&&(L=g.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without)}return{messageChain:Xs(d,L),relatedMessage:P?g.Did_you_forget_to_use_await:void 0}}function PAe(r,a,_,d){let{messageChain:y,relatedMessage:T}=$Ge(r,a,_),P=Ey(Xr(r),r,y);if(T&&Ga(P,$n(r,T)),da(r.parent)){let{start:L,length:J}=UGe(r.parent);P.start=L,P.length=J}fo.add(P),WGe(a,_,d?Ga(P,d):P)}function WGe(r,a,_){if(!r.symbol)return;let d=as(r.symbol).originatingImport;if(d&&!Up(d)){let y=na(vn(as(r.symbol).target),a);if(!y||!y.length)return;Ga(_,$n(d,g.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead))}}function S9t(r,a,_){let d=Cs(r.tag),y=Tf(d);if(Xt(y))return vh(r);let T=na(y,0),P=na(y,1).length;if(u$(d,y,T.length,P))return PC(r);if(!T.length){if(Z_(r.parent)){let L=$n(r.tag,g.It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked);return fo.add(L),vh(r)}return PAe(r.tag,y,0),vh(r)}return wI(r,T,a,_,0)}function T9t(r){switch(r.parent.kind){case 263:case 231:return g.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;case 169:return g.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;case 172:return g.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;case 174:case 177:case 178:return g.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression;default:return I.fail()}}function b9t(r,a,_){let d=Cs(r.expression),y=Tf(d);if(Xt(y))return vh(r);let T=na(y,0),P=na(y,1).length;if(u$(d,y,T.length,P))return PC(r);if(C9t(r,T)&&!Df(r.expression)){let J=Fl(r.expression,!1);return He(r,g._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0,J),vh(r)}let L=T9t(r);if(!T.length){let J=$Ge(r.expression,y,0),G=Xs(J.messageChain,L),ae=Ey(Xr(r.expression),r.expression,G);return J.relatedMessage&&Ga(ae,$n(r.expression,J.relatedMessage)),fo.add(ae),WGe(y,0,ae),vh(r)}return wI(r,T,a,_,0,L)}function loe(r,a){let _=kC(r),d=_&&Ep(_),y=d&&Lf(d,cd.Element,788968),T=y&&kt.symbolToEntityName(y,788968,r),P=j.createFunctionTypeNode(void 0,[j.createParameterDeclaration(void 0,void 0,"props",void 0,kt.typeToTypeNode(a,r))],T?j.createTypeReferenceNode(T,void 0):j.createKeywordTypeNode(133)),L=oo(1,"props");return L.links.type=a,X0(P,void 0,void 0,[L],y?dc(y):ht,void 0,1,0)}function E9t(r,a,_){if(uP(r.tagName)){let P=uGe(r),L=loe(r,P);return qS(RI(r.attributes,Kae(L,r),void 0,0),P,r.tagName,r.attributes),de(r.typeArguments)&&(Te(r.typeArguments,Ba),fo.add(sN(Xr(r),r.typeArguments,g.Expected_0_type_arguments_but_got_1,0,de(r.typeArguments)))),L}let d=Cs(r.tagName),y=Tf(d);if(Xt(y))return vh(r);let T=cGe(d,r);return u$(d,y,T.length,0)?PC(r):T.length===0?(He(r.tagName,g.JSX_element_type_0_does_not_have_any_construct_or_call_signatures,Fl(r.tagName)),vh(r)):wI(r,T,a,_,0)}function x9t(r,a,_){let d=Cs(r.right);if(!wt(d)){let y=JAe(d);if(y){let T=Tf(y);if(Xt(T))return vh(r);let P=na(T,0),L=na(T,1);if(u$(y,T,P.length,L.length))return PC(r);if(P.length)return wI(r,P,a,_,0)}else if(!(woe(d)||JS(d,Bt)))return He(r.right,g.The_right_hand_side_of_an_instanceof_expression_must_be_either_of_type_any_a_class_function_or_other_type_assignable_to_the_Function_interface_type_or_an_object_type_with_a_Symbol_hasInstance_method),vh(r)}return Et}function C9t(r,a){return a.length&&yr(a,_=>_.minArgumentCount===0&&!L_(_)&&_.parameters.length<BGe(r,_))}function A9t(r,a,_){switch(r.kind){case 213:return g9t(r,a,_);case 214:return y9t(r,a,_);case 215:return S9t(r,a,_);case 170:return b9t(r,a,_);case 286:case 285:return E9t(r,a,_);case 226:return x9t(r,a,_)}I.assertNever(r,"Branch in 'resolveSignature' should be unreachable.")}function OI(r,a,_){let d=_i(r),y=d.resolvedSignature;if(y&&y!==Dn&&!a)return y;d.resolvedSignature=Dn;let T=A9t(r,a,_||0);return T!==Dn&&(d.resolvedSignature!==Dn&&(T=d.resolvedSignature),d.resolvedSignature=lh===gd?T:y),T}function Sh(r){var a;if(!r||!gn(r))return!1;let _=Zl(r)||Xo(r)?r:(Gi(r)||Ul(r))&&r.initializer&&Xo(r.initializer)?r.initializer:void 0;if(_){if(QH(r))return!0;if(Ul(P1(_.parent)))return!1;let d=Rn(_);return!!((a=d?.members)!=null&&a.size)}return!1}function NAe(r,a){var _,d;if(a){let y=as(a);if(!y.inferredClassSymbol||!y.inferredClassSymbol.has(Ia(r))){let T=Rh(r)?r:qx(r);return T.exports=T.exports||ga(),T.members=T.members||ga(),T.flags|=a.flags&32,(_=a.exports)!=null&&_.size&&Tg(T.exports,a.exports),(d=a.members)!=null&&d.size&&Tg(T.members,a.members),(y.inferredClassSymbol||(y.inferredClassSymbol=new Map)).set(Ia(T),T),T}return y.inferredClassSymbol.get(Ia(r))}}function k9t(r){var a;let _=r&&uoe(r,!0),d=(a=_?.exports)==null?void 0:a.get("prototype"),y=d?.valueDeclaration&&P9t(d.valueDeclaration);return y?Rn(y):void 0}function uoe(r,a){if(!r.parent)return;let _,d;if(Gi(r.parent)&&r.parent.initializer===r){if(!gn(r)&&!(w$(r.parent)&&tc(r)))return;_=r.parent.name,d=r.parent}else if(bn(r.parent)){let y=r.parent,T=r.parent.operatorToken.kind;if(T===64&&(a||y.right===r))_=y.left,d=_;else if((T===57||T===61)&&(Gi(y.parent)&&y.parent.initializer===y?(_=y.parent.name,d=y.parent):bn(y.parent)&&y.parent.operatorToken.kind===64&&(a||y.parent.right===y)&&(_=y.parent.left,d=_),!_||!Y2(_)||!pN(_,y.left)))return}else a&&Zl(r)&&(_=r.name,d=r);if(!(!d||!_||!a&&!hT(r,zv(_))))return yd(d)}function P9t(r){if(!r.parent)return!1;let a=r.parent;for(;a&&a.kind===211;)a=a.parent;if(a&&bn(a)&&zv(a.left)&&a.operatorToken.kind===64){let _=YY(a);return Ha(_)&&_}}function N9t(r,a){var _,d,y;I$(r,r.typeArguments);let T=OI(r,void 0,a);if(T===Dn)return Ns;if(_oe(T,r),r.expression.kind===108)return fn;if(r.kind===214){let L=T.declaration;if(L&&L.kind!==176&&L.kind!==180&&L.kind!==185&&!(PT(L)&&((d=(_=yN(L))==null?void 0:_.parent)==null?void 0:d.kind)===176)&&!hN(L)&&!Sh(L))return ve&&He(r,g.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type),W}if(gn(r)&&XGe(r))return vze(r.arguments[0]);let P=Ao(T);if(P.flags&12288&&GGe(r))return tCe(P1(r.parent));if(r.kind===213&&!r.questionDotToken&&r.parent.kind===244&&P.flags&16384&&zd(T)){if(!a6(r.expression))He(r.expression,g.Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name);else if(!Hz(r)){let L=He(r.expression,g.Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation);Gz(r.expression,L)}}if(gn(r)){let L=uoe(r,!1);if((y=L?.exports)!=null&&y.size){let J=Ho(L,L.exports,tt,tt,tt);return J.objectFlags|=4096,Pa([P,J])}}return P}function _oe(r,a){if(!(r.flags&128)&&r.declaration&&r.declaration.flags&536870912){let _=_$(a),d=rR(aj(a));XO(_,r.declaration,d,t0(r))}}function _$(r){switch(r=Do(r),r.kind){case 213:case 170:case 214:return _$(r.expression);case 215:return _$(r.tag);case 286:case 285:return _$(r.tagName);case 212:return r.argumentExpression;case 211:return r.name;case 183:let a=r;return pf(a.typeName)?a.typeName.right:a;default:return r}}function GGe(r){if(!da(r))return!1;let a=r.expression;if(Hn(a)&&a.name.escapedText==="for"&&(a=a.expression),!ze(a)||a.escapedText!=="Symbol")return!1;let _=jze(!1);return _?_===wc(a,"Symbol",111551,void 0,void 0,!1):!1}function D9t(r){if($Jt(r),r.arguments.length===0)return g$(r,W);let a=r.arguments[0],_=xl(a),d=r.arguments.length>1?xl(r.arguments[1]):void 0;for(let T=2;T<r.arguments.length;++T)xl(r.arguments[T]);if((_.flags&32768||_.flags&65536||!Na(_,Le))&&He(a,g.Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0,Kr(_)),d){let T=Fze(!0);T!==$a&&J_(d,Jz(T,32768),r.arguments[1])}let y=rf(r,a);if(y){let T=Zf(y,a,!0,!1);if(T)return g$(r,HGe(vn(T),T,y,a)||YGe(vn(T),T,y,a))}return g$(r,W)}function DAe(r,a,_){let d=ga(),y=oo(2097152,"default");return y.parent=a,y.links.nameType=jf("default"),y.links.aliasTarget=ll(r),d.set("default",y),Ho(_,d,tt,tt,tt)}function HGe(r,a,_,d){if(ev(d)&&r&&!Xt(r)){let T=r;if(!T.defaultOnlyType){let P=DAe(a,_);T.defaultOnlyType=P}return T.defaultOnlyType}}function YGe(r,a,_,d){var y;if(Z&&r&&!Xt(r)){let T=r;if(!T.syntheticType){let P=(y=_.declarations)==null?void 0:y.find(ls);if(_h(P,_,!1,d)){let J=oo(2048,"__type"),G=DAe(a,_,J);J.links.type=G,T.syntheticType=e$(r)?e2(r,G,J,0,!1):G}else T.syntheticType=r}return T.syntheticType}return r}function XGe(r){if(!_f(r,!0))return!1;if(!ze(r.expression))return I.fail();let a=wc(r.expression,r.expression.escapedText,111551,void 0,void 0,!0);if(a===St)return!0;if(a.flags&2097152)return!1;let _=a.flags&16?262:a.flags&3?260:0;if(_!==0){let d=xc(a,_);return!!d&&!!(d.flags&33554432)}return!1}function I9t(r){hJt(r)||I$(r,r.typeArguments),pe<2&&iu(r,262144);let a=OI(r);return _oe(a,r),Ao(a)}function w9t(r,a){if(r.kind===216){let _=Xr(r);_&&Ql(_.fileName,[".cts",".mts"])&&kr(r,g.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead)}return KGe(r,a)}function IAe(r){switch(r.kind){case 11:case 15:case 9:case 10:case 112:case 97:case 209:case 210:case 228:return!0;case 217:return IAe(r.expression);case 224:let a=r.operator,_=r.operand;return a===41&&(_.kind===9||_.kind===10)||a===40&&_.kind===9;case 211:case 212:let d=Do(r.expression),y=ol(d)?ac(d,111551,!0):void 0;return!!(y&&y.flags&384)}return!1}function KGe(r,a){let{type:_,expression:d}=QGe(r),y=Cs(d,a);if(Ty(_))return IAe(d)||He(d,g.A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals),af(y);let T=_i(r);return T.assertionExpressionType=y,Ba(_),_P(r),Ri(_)}function QGe(r){let a,_;switch(r.kind){case 234:case 216:a=r.type,_=r.expression;break;case 217:a=gU(r),_=r.expression;break}return{type:a,expression:_}}function O9t(r){let{type:a}=QGe(r),_=Df(r)?a:r,d=_i(r);I.assertIsDefined(d.assertionExpressionType);let y=wL(s1(d.assertionExpressionType)),T=Ri(a);Xt(T)||n(()=>{let P=Yp(y);hae(T,P)||M$e(y,T,_,g.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first)})}function R9t(r){let a=Cs(r.expression),_=DL(a,r.expression);return Nae(a1(_),r,_!==a)}function M9t(r){return r.flags&64?R9t(r):a1(Cs(r.expression))}function ZGe(r){if(GYe(r),Te(r.typeArguments,Ba),r.kind===233){let _=P1(r.parent);_.kind===226&&_.operatorToken.kind===104&&Yb(r,_.right)&&He(r,g.The_right_hand_side_of_an_instanceof_expression_must_not_be_an_instantiation_expression)}let a=r.kind===233?Cs(r.expression):eE(r.exprName)?Kz(r.exprName):Cs(r.exprName);return eHe(a,r)}function eHe(r,a){let _=a.typeArguments;if(r===Ns||Xt(r)||!Tt(_))return r;let d=!1,y,T=L(r),P=d?y:r;return P&&fo.add(sN(Xr(a),_,g.Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable,Kr(P))),T;function L(G){let ae=!1,Ce=!1,be=Ye(G);return d||(d=Ce),ae&&!Ce&&(y??(y=G)),be;function Ye(vt){if(vt.flags&524288){let Dt=kg(vt),ur=J(Dt.callSignatures),pr=J(Dt.constructSignatures);if(ae||(ae=Dt.callSignatures.length!==0||Dt.constructSignatures.length!==0),Ce||(Ce=ur.length!==0||pr.length!==0),ur!==Dt.callSignatures||pr!==Dt.constructSignatures){let dn=Ho(oo(0,"__instantiationExpression"),Dt.members,ur,pr,Dt.indexInfos);return dn.objectFlags|=8388608,dn.node=a,dn}}else if(vt.flags&58982400){let Dt=k_(vt);if(Dt){let ur=Ye(Dt);if(ur!==Dt)return ur}}else{if(vt.flags&1048576)return Ec(vt,L);if(vt.flags&2097152)return Pa(ul(vt.types,Ye))}return vt}}function J(G){let ae=Fn(G,Ce=>!!Ce.typeParameters&&EAe(Ce,_));return ul(ae,Ce=>{let be=AAe(Ce,_,!0);return be?hL(Ce,be,gn(Ce.declaration)):Ce})}}function L9t(r){return Ba(r.type),wAe(r.expression,r.type)}function wAe(r,a,_){let d=Cs(r,_),y=Ri(a);if(Xt(y))return y;let T=Gr(a.parent,P=>P.kind===238||P.kind===357);return qS(d,y,T,r,g.Type_0_does_not_satisfy_the_expected_type_1),d}function F9t(r){return OJt(r),r.keywordToken===105?OAe(r):r.keywordToken===102?j9t(r):I.assertNever(r.keywordToken)}function tHe(r){switch(r.keywordToken){case 102:return Lze();case 105:let a=OAe(r);return Xt(a)?ht:tjt(a);default:I.assertNever(r.keywordToken)}}function OAe(r){let a=Tde(r);if(a)if(a.kind===176){let _=Rn(a.parent);return vn(_)}else{let _=Rn(a);return vn(_)}else return He(r,g.Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor,"new.target"),ht}function j9t(r){z===100||z===199?Xr(r).impliedNodeFormat!==99&&He(r,g.The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output):z<6&&z!==4&&He(r,g.The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext);let a=Xr(r);return I.assert(!!(a.flags&8388608),"Containing file is missing import meta node flag."),r.name.escapedText==="meta"?Mze():ht}function f$(r){let a=r.valueDeclaration;return ep(vn(r),!1,!!a&&(jv(a)||C6(a)))}function RAe(r,a,_="arg"){return r?(I.assert(ze(r.name)),r.name.escapedText):`${_}_${a}`}function x4(r,a,_){let d=r.parameters.length-(L_(r)?1:0);if(a<d)return r.parameters[a].escapedName;let y=r.parameters[d]||dt,T=_||vn(y);if(Ka(T)){let P=T.target.labeledElementDeclarations,L=a-d;return RAe(P?.[L],L,y.escapedName)}return y.escapedName}function B9t(r,a){var _;if(((_=r.declaration)==null?void 0:_.kind)===324)return;let d=r.parameters.length-(L_(r)?1:0);if(a<d){let L=r.parameters[a],J=rHe(L);return J?{parameter:J,parameterName:L.escapedName,isRestParameter:!1}:void 0}let y=r.parameters[d]||dt,T=rHe(y);if(!T)return;let P=vn(y);if(Ka(P)){let L=P.target.labeledElementDeclarations,J=a-d,G=L?.[J],ae=!!G?.dotDotDotToken;return G?(I.assert(ze(G.name)),{parameter:G.name,parameterName:G.name.escapedText,isRestParameter:ae}):void 0}if(a===d)return{parameter:T,parameterName:y.escapedName,isRestParameter:!0}}function rHe(r){return r.valueDeclaration&&Ls(r.valueDeclaration)&&ze(r.valueDeclaration.name)&&r.valueDeclaration.name}function nHe(r){return r.kind===202||Ls(r)&&r.name&&ze(r.name)}function U9t(r,a){let _=r.parameters.length-(L_(r)?1:0);if(a<_){let T=r.parameters[a].valueDeclaration;return T&&nHe(T)?T:void 0}let d=r.parameters[_]||dt,y=vn(d);if(Ka(y)){let T=y.target.labeledElementDeclarations,P=a-_;return T&&T[P]}return d.valueDeclaration&&nHe(d.valueDeclaration)?d.valueDeclaration:void 0}function Ig(r,a){return c2(r,a)||W}function c2(r,a){let _=r.parameters.length-(L_(r)?1:0);if(a<_)return f$(r.parameters[a]);if(L_(r)){let d=vn(r.parameters[_]),y=a-_;if(!Ka(d)||d.target.hasRestElement||y<d.target.fixedLength)return Ap(d,Ng(y))}}function p$(r,a,_){let d=Xp(r),y=Th(r),T=UL(r);if(T&&a>=d-1)return a===d-1?T:P_(Ap(T,It));let P=[],L=[],J=[];for(let G=a;G<d;G++)!T||G<d-1?(P.push(Ig(r,G)),L.push(G<y?1:2)):(P.push(T),L.push(8)),J.push(U9t(r,G));return c0(P,L,_,J)}function iHe(r,a){let _=p$(r,a),d=_&&Vz(_);return d&&wt(d)?W:_}function Xp(r){let a=r.parameters.length;if(L_(r)){let _=vn(r.parameters[a-1]);if(Ka(_))return a+_.target.fixedLength-(_.target.hasRestElement?0:1)}return a}function Th(r,a){let _=a&1,d=a&2;if(d||r.resolvedMinArgumentCount===void 0){let y;if(L_(r)){let T=vn(r.parameters[r.parameters.length-1]);if(Ka(T)){let P=oa(T.target.elementFlags,J=>!(J&1)),L=P<0?T.target.fixedLength:P;L>0&&(y=r.parameters.length-1+L)}}if(y===void 0){if(!_&&r.flags&32)return 0;y=r.minArgumentCount}if(d)return y;for(let T=y-1;T>=0;T--){let P=Ig(r,T);if(wl(P,IGe).flags&131072)break;y=T}r.resolvedMinArgumentCount=y}return r.resolvedMinArgumentCount}function u0(r){if(L_(r)){let a=vn(r.parameters[r.parameters.length-1]);return!Ka(a)||a.target.hasRestElement}return!1}function UL(r){if(L_(r)){let a=vn(r.parameters[r.parameters.length-1]);if(!Ka(a))return wt(a)?bl:a;if(a.target.hasRestElement)return f4(a,a.target.fixedLength)}}function VL(r){let a=UL(r);return a&&!Gd(a)&&!wt(a)?a:void 0}function MAe(r){return LAe(r,Qn)}function LAe(r,a){return r.parameters.length>0?Ig(r,0):a}function sHe(r,a,_){let d=r.parameters.length-(L_(r)?1:0);for(let y=0;y<d;y++){let T=r.parameters[y].valueDeclaration,P=t_(T);if(P){let L=ep(Ri(P),!1,C6(T)),J=Ig(a,y);o1(_.inferences,L,J)}}}function V9t(r,a){if(a.typeParameters)if(!r.typeParameters)r.typeParameters=a.typeParameters;else return;if(a.thisParameter){let d=r.thisParameter;(!d||d.valueDeclaration&&!d.valueDeclaration.type)&&(d||(r.thisParameter=TC(a.thisParameter,void 0)),d$(r.thisParameter,vn(a.thisParameter)))}let _=r.parameters.length-(L_(r)?1:0);for(let d=0;d<_;d++){let y=r.parameters[d],T=y.valueDeclaration;if(!t_(T)){let P=c2(a,d);if(P&&T.initializer){let L=C4(T,0);!Na(L,P)&&Na(P,L=moe(T,L))&&(P=L)}d$(y,P)}}if(L_(r)){let d=Rs(r.parameters);if(d.valueDeclaration?!t_(d.valueDeclaration):Vc(d)&65536){let y=p$(a,_);d$(d,y)}}}function J9t(r){r.thisParameter&&d$(r.thisParameter);for(let a of r.parameters)d$(a)}function d$(r,a){let _=as(r);if(_.type)a&&I.assertEqual(_.type,a,"Parameter symbol already has a cached type which differs from newly assigned type");else{let d=r.valueDeclaration;_.type=ep(a||(d?q(d,!0):vn(r)),!1,!!d&&!d.initializer&&C6(d)),d&&d.name.kind!==80&&(_.type===Sr&&(_.type=R(d.name)),aHe(d.name,_.type))}}function aHe(r,a){for(let _ of r.elements)if(!Su(_)){let d=Y0(_,a,!1);_.name.kind===80?as(Rn(_)).type=d:aHe(_.name,d)}}function q9t(r){return bI(iMt(!0),[r])}function z9t(r,a){return bI(sMt(!0),[r,a])}function $9t(r,a){return bI(aMt(!0),[r,a])}function W9t(r,a){return bI(oMt(!0),[r,a])}function G9t(r,a){return bI(cMt(!0),[r,a])}function H9t(r,a){return bI(_Mt(!0),[r,a])}function Y9t(r,a,_){let d=`${a?"p":"P"}${_?"s":"S"}${r.id}`,y=to.get(d);if(!y){let T=ga();T.set("name",Vx("name",r)),T.set("private",Vx("private",a?zr:Zt)),T.set("static",Vx("static",_?zr:Zt)),y=Ho(void 0,T,tt,tt,tt),to.set(d,y)}return y}function oHe(r,a,_){let d=jl(r),y=is(r.name),T=y?jf(Nn(r.name)):av(r.name),P=pl(r)?z9t(a,_):sd(r)?$9t(a,_):pp(r)?W9t(a,_):Af(r)?G9t(a,_):ea(r)?H9t(a,_):I.failBadSyntaxKind(r),L=Y9t(T,y,d);return Pa([P,L])}function X9t(r,a){return bI(lMt(!0),[r,a])}function K9t(r,a){return bI(uMt(!0),[r,a])}function Q9t(r,a){let _=Sg("this",r),d=Sg("value",a);return KAe(void 0,_,[d],a,void 0,1)}function FAe(r,a,_){let d=Sg("target",r),y=Sg("context",a),T=pi([_,fn]);return GL(void 0,void 0,[d,y],T)}function Z9t(r){let{parent:a}=r,_=_i(a);if(!_.decoratorSignature)switch(_.decoratorSignature=Et,a.kind){case 263:case 231:{let y=vn(Rn(a)),T=q9t(y);_.decoratorSignature=FAe(y,T,y);break}case 174:case 177:case 178:{let d=a;if(!Ti(d.parent))break;let y=pl(d)?dC(Sm(d)):fP(d),T=jl(d)?vn(Rn(d.parent)):qd(Rn(d.parent)),P=sd(d)?UHe(y):pp(d)?VHe(y):y,L=oHe(d,T,y),J=sd(d)?UHe(y):pp(d)?VHe(y):y;_.decoratorSignature=FAe(P,L,J);break}case 172:{let d=a;if(!Ti(d.parent))break;let y=fP(d),T=jl(d)?vn(Rn(d.parent)):qd(Rn(d.parent)),P=Hg(d)?X9t(T,y):Be,L=oHe(d,T,y),J=Hg(d)?K9t(T,y):Q9t(T,y);_.decoratorSignature=FAe(P,L,J);break}}return _.decoratorSignature===Et?void 0:_.decoratorSignature}function ejt(r){let{parent:a}=r,_=_i(a);if(!_.decoratorSignature)switch(_.decoratorSignature=Et,a.kind){case 263:case 231:{let y=vn(Rn(a)),T=Sg("target",y);_.decoratorSignature=GL(void 0,void 0,[T],pi([y,fn]));break}case 169:{let d=a;if(!Yc(d.parent)&&!(pl(d.parent)||pp(d.parent)&&Ti(d.parent.parent))||Qb(d.parent)===d)break;let y=Qb(d.parent)?d.parent.parameters.indexOf(d)-1:d.parent.parameters.indexOf(d);I.assert(y>=0);let T=Yc(d.parent)?vn(Rn(d.parent.parent)):LYe(d.parent),P=Yc(d.parent)?Be:FYe(d.parent),L=Ng(y),J=Sg("target",T),G=Sg("propertyKey",P),ae=Sg("parameterIndex",L);_.decoratorSignature=GL(void 0,void 0,[J,G,ae],fn);break}case 174:case 177:case 178:case 172:{let d=a;if(!Ti(d.parent))break;let y=LYe(d),T=Sg("target",y),P=FYe(d),L=Sg("propertyKey",P),J=ea(d)?fn:qze(fP(d));if(pe!==0&&(!ea(a)||Hg(a))){let ae=qze(fP(d)),Ce=Sg("descriptor",ae);_.decoratorSignature=GL(void 0,void 0,[T,L,Ce],pi([J,fn]))}else _.decoratorSignature=GL(void 0,void 0,[T,L],pi([J,fn]));break}}return _.decoratorSignature===Et?void 0:_.decoratorSignature}function jAe(r){return se?ejt(r):Z9t(r)}function m$(r){let a=Cz(!0);return a!==$s?(r=lv(N4(r))||Sr,iv(a,[r])):Sr}function cHe(r){let a=Uze(!0);return a!==$s?(r=lv(N4(r))||Sr,iv(a,[r])):Sr}function g$(r,a){let _=m$(a);return _===Sr?(He(r,Up(r)?g.A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option:g.An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option),ht):(Mxe(!0)||He(r,Up(r)?g.A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option:g.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option),_)}function tjt(r){let a=oo(0,"NewTargetExpression"),_=oo(4,"target",8);_.parent=a,_.links.type=r;let d=ga([_]);return a.members=d,Ho(a,d,tt,tt,tt)}function foe(r,a){if(!r.body)return ht;let _=vu(r),d=(_&2)!==0,y=(_&1)!==0,T,P,L,J=fn;if(r.body.kind!==241)T=xl(r.body,a&&a&-9),d&&(T=N4(WL(T,!1,r,g.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)));else if(y){let G=dHe(r,a);G?G.length>0&&(T=pi(G,2)):J=Qn;let{yieldTypes:ae,nextTypes:Ce}=rjt(r,a);P=Tt(ae)?pi(ae,2):void 0,L=Tt(Ce)?Pa(Ce):void 0}else{let G=dHe(r,a);if(!G)return _&2?g$(r,Qn):Qn;if(G.length===0){let ae=Gae(r,void 0),Ce=ae&&(k$(ae,_)||fn).flags&32768?Be:fn;return _&2?g$(r,Ce):Ce}T=pi(G,2)}if(T||P||L){if(P&&Oae(r,P,3),T&&Oae(r,T,1),L&&Oae(r,L,2),T&&Dg(T)||P&&Dg(P)||L&&Dg(L)){let G=iAe(r),ae=G?G===Sm(r)?y?void 0:T:Yae(Ao(G),r,void 0):void 0;y?(P=TCe(P,ae,0,d),T=TCe(T,ae,1,d),L=TCe(L,ae,2,d)):T=nLt(T,ae,d)}P&&(P=Yp(P)),T&&(T=Yp(T)),L&&(L=Yp(L))}return y?lHe(P||Qn,T||J,L||HWe(2,r)||Sr,d):d?m$(T||J):T||J}function lHe(r,a,_,d){let y=d?sc:Jl,T=y.getGlobalGeneratorType(!1);if(r=y.resolveIterationType(r,void 0)||Sr,a=y.resolveIterationType(a,void 0)||Sr,_=y.resolveIterationType(_,void 0)||Sr,T===$s){let P=y.getGlobalIterableIteratorType(!1),L=P!==$s?tYe(P,y):void 0,J=L?L.returnType:W,G=L?L.nextType:Be;return Na(a,J)&&Na(G,_)?P!==$s?vL(P,[r]):(y.getGlobalIterableIteratorType(!0),$a):(y.getGlobalGeneratorType(!0),$a)}return vL(T,[r,a,_])}function rjt(r,a){let _=[],d=[],y=(vu(r)&2)!==0;return ude(r.body,T=>{let P=T.expression?Cs(T.expression,a):Lt;ln(_,uHe(T,P,W,y));let L;if(T.asteriskToken){let J=Coe(P,y?19:17,T.expression);L=J&&J.nextType}else L=Bf(T,void 0);L&&ln(d,L)}),{yieldTypes:_,nextTypes:d}}function uHe(r,a,_,d){let y=r.expression||r,T=r.asteriskToken?uv(d?19:17,a,_,y):a;return d?IC(T,y,r.asteriskToken?g.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member:g.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member):T}function _He(r,a,_){let d=0;for(let y=0;y<_.length;y++){let T=y<r||y>=a?_[y]:void 0;d|=T!==void 0?tZ.get(T)||32768:0}return d}function fHe(r){let a=_i(r);if(a.isExhaustive===void 0){a.isExhaustive=0;let _=njt(r);a.isExhaustive===0&&(a.isExhaustive=_)}else a.isExhaustive===0&&(a.isExhaustive=!1);return a.isExhaustive}function njt(r){if(r.expression.kind===221){let d=AWe(r);if(!d)return!1;let y=e1(xl(r.expression.expression)),T=_He(0,0,d);return y.flags&3?(556800&T)===556800:!rg(y,P=>v4(P,T)===T)}let a=xl(r.expression);if(!NL(a))return!1;let _=Bae(r);return!_.length||Tt(_,eLt)?!1:KLt(Ec(a,af),_)}function pHe(r){return r.endFlowNode&&Yz(r.endFlowNode)}function dHe(r,a){let _=vu(r),d=[],y=pHe(r),T=!1;if($b(r.body,P=>{let L=P.expression;if(L){if(L=Do(L,!0),_&2&&L.kind===223&&(L=Do(L.expression,!0)),L.kind===213&&L.expression.kind===80&&xl(L.expression).symbol===r.symbol){T=!0;return}let J=xl(L,a&&a&-9);_&2&&(J=N4(WL(J,!1,r,g.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member))),J.flags&131072&&(T=!0),ln(d,J)}else y=!0}),!(d.length===0&&!y&&(T||ijt(r))))return Q&&d.length&&y&&!(Sh(r)&&d.some(P=>P.symbol===r.symbol))&&ln(d,Be),d}function ijt(r){switch(r.kind){case 218:case 219:return!0;case 174:return r.parent.kind===210;default:return!1}}function BAe(r,a){n(_);return;function _(){let d=vu(r),y=a&&k$(a,d);if(y&&($c(y,16384)||y.flags&32769)||r.kind===173||sl(r.body)||r.body.kind!==241||!pHe(r))return;let T=r.flags&1024,P=lm(r)||r;if(y&&y.flags&131072)He(P,g.A_function_returning_never_cannot_have_a_reachable_end_point);else if(y&&!T)He(P,g.A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value);else if(y&&Q&&!Na(Be,y))He(P,g.Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined);else if($.noImplicitReturns){if(!y){if(!T)return;let L=Ao(Sm(r));if(lYe(r,L))return}He(P,g.Not_all_code_paths_return_a_value)}}}function mHe(r,a){if(I.assert(r.kind!==174||jm(r)),_P(r),Xo(r)&&D4(r,r.name),a&&a&4&&$d(r)){if(!lm(r)&&!sB(r)){let d=jL(r);if(d&&yb(Ao(d))){let y=_i(r);if(y.contextFreeType)return y.contextFreeType;let T=foe(r,a),P=X0(void 0,void 0,void 0,tt,T,void 0,0,64),L=Ho(r.symbol,K,[P],tt,tt);return L.objectFlags|=262144,y.contextFreeType=L}}return cr}return!Loe(r)&&r.kind===218&&Tke(r),sjt(r,a),vn(Rn(r))}function sjt(r,a){let _=_i(r);if(!(_.flags&64)){let d=jL(r);if(!(_.flags&64)){_.flags|=64;let y=qi(na(vn(Rn(r)),0));if(!y)return;if($d(r))if(d){let T=a2(r),P;if(a&&a&2){sHe(y,d,T);let L=UL(d);L&&L.flags&262144&&(P=PI(d,T.nonFixingMapper))}P||(P=T?PI(d,T.mapper):d),V9t(y,P)}else J9t(y);else if(d&&!r.typeParameters&&d.parameters.length>r.parameters.length){let T=a2(r);a&&a&2&&sHe(y,d,T)}if(d&&!TI(r)&&!y.resolvedReturnType){let T=foe(r,a);y.resolvedReturnType||(y.resolvedReturnType=T)}qL(r)}}}function ajt(r){I.assert(r.kind!==174||jm(r));let a=vu(r),_=TI(r);if(BAe(r,_),r.body)if(lm(r)||Ao(Sm(r)),r.body.kind===241)Ba(r.body);else{let d=Cs(r.body),y=_&&k$(_,a);if(y){let T=ooe(r.body);if((a&3)===2){let P=WL(d,!1,T,g.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);qS(P,y,T,T)}else qS(d,y,T,T)}}}function poe(r,a,_,d=!1){if(!Na(a,Sl)){let y=d&&P4(a);return HT(r,!!y&&Na(y,Sl),_),!1}return!0}function ojt(r){if(!da(r)||!H2(r))return!1;let a=xl(r.arguments[2]);if(Xe(a,"value")){let y=ka(a,"writable"),T=y&&vn(y);if(!T||T===Zt||T===Ir)return!0;if(y&&y.valueDeclaration&&Ul(y.valueDeclaration)){let P=y.valueDeclaration.initializer,L=Cs(P);if(L===Zt||L===Ir)return!0}return!1}return!ka(a,"set")}function wg(r){return!!(Vc(r)&8||r.flags&4&&Nd(r)&8||r.flags&3&&_Ae(r)&6||r.flags&98304&&!(r.flags&65536)||r.flags&8||Tt(r.declarations,ojt))}function gHe(r,a,_){var d,y;if(_===0)return!1;if(wg(a)){if(a.flags&4&&Yo(r)&&r.expression.kind===110){let T=Vp(r);if(!(T&&(T.kind===176||Sh(T))))return!0;if(a.valueDeclaration){let P=bn(a.valueDeclaration),L=T.parent===a.valueDeclaration.parent,J=T===a.valueDeclaration.parent,G=P&&((d=a.parent)==null?void 0:d.valueDeclaration)===T.parent,ae=P&&((y=a.parent)==null?void 0:y.valueDeclaration)===T;return!(L||J||G||ae)}}return!0}if(Yo(r)){let T=Do(r.expression);if(T.kind===80){let P=_i(T).resolvedSymbol;if(P.flags&2097152){let L=Xm(P);return!!L&&L.kind===274}}}return!1}function JL(r,a,_){let d=vl(r,7);return d.kind!==80&&!Yo(d)?(He(r,a),!1):d.flags&64?(He(r,_),!1):!0}function cjt(r){Cs(r.expression);let a=Do(r.expression);if(!Yo(a))return He(a,g.The_operand_of_a_delete_operator_must_be_a_property_reference),Pi;Hn(a)&&is(a.name)&&He(a,g.The_operand_of_a_delete_operator_cannot_be_a_private_identifier);let _=_i(a),d=vd(_.resolvedSymbol);return d&&(wg(d)?He(a,g.The_operand_of_a_delete_operator_cannot_be_a_read_only_property):ljt(a,d)),Pi}function ljt(r,a){let _=vn(a);Q&&!(_.flags&131075)&&!(Ie?a.flags&16777216:bm(_,16777216))&&He(r,g.The_operand_of_a_delete_operator_must_be_optional)}function ujt(r){return Cs(r.expression),QD}function _jt(r){return _P(r),Lt}function hHe(r){let a=!1,_=rj(r);if(_&&Jc(_)){let d=Zv(r)?g.await_expression_cannot_be_used_inside_a_class_static_block:g.await_using_statements_cannot_be_used_inside_a_class_static_block;He(r,d),a=!0}else if(!(r.flags&65536))if(ij(r)){let d=Xr(r);if(!u2(d)){let y;if(!bA(d,$)){y??(y=Fh(d,r.pos));let T=Zv(r)?g.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module:g.await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module,P=Iu(d,y.start,y.length,T);fo.add(P),a=!0}switch(z){case 100:case 199:if(d.impliedNodeFormat===1){y??(y=Fh(d,r.pos)),fo.add(Iu(d,y.start,y.length,g.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level)),a=!0;break}case 7:case 99:case 200:case 4:if(pe>=4)break;default:y??(y=Fh(d,r.pos));let T=Zv(r)?g.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher:g.Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher;fo.add(Iu(d,y.start,y.length,T)),a=!0;break}}}else{let d=Xr(r);if(!u2(d)){let y=Fh(d,r.pos),T=Zv(r)?g.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules:g.await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules,P=Iu(d,y.start,y.length,T);if(_&&_.kind!==176&&!(vu(_)&2)){let L=$n(_,g.Did_you_mean_to_mark_this_function_as_async);Ga(P,L)}fo.add(P),a=!0}}return Zv(r)&&ZCe(r)&&(He(r,g.await_expressions_cannot_be_used_in_a_parameter_initializer),a=!0),a}function fjt(r){n(()=>hHe(r));let a=Cs(r.expression),_=WL(a,!0,r,g.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);return _===a&&!Xt(_)&&!(a.flags&3)&&vg(!1,$n(r,g.await_has_no_effect_on_the_type_of_this_expression)),_}function pjt(r){let a=Cs(r.operand);if(a===Ns)return Ns;switch(r.operand.kind){case 9:switch(r.operator){case 41:return cP(Ng(-r.operand.text));case 40:return cP(Ng(+r.operand.text))}break;case 10:if(r.operator===41)return cP(_ae({negative:!0,base10Value:v6(r.operand.text)}))}switch(r.operator){case 40:case 41:case 55:return yh(a,r.operand),h$(a,12288)&&He(r.operand,g.The_0_operator_cannot_be_applied_to_type_symbol,Sa(r.operator)),r.operator===40?(h$(a,2112)&&He(r.operand,g.Operator_0_cannot_be_applied_to_type_1,Sa(r.operator),Kr(s1(a))),It):UAe(a);case 54:rke(a,r.operand);let _=v4(a,12582912);return _===4194304?Zt:_===8388608?zr:Pi;case 46:case 47:return poe(r.operand,yh(a,r.operand),g.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type)&&JL(r.operand,g.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access,g.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access),UAe(a)}return ht}function djt(r){let a=Cs(r.operand);return a===Ns?Ns:(poe(r.operand,yh(a,r.operand),g.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type)&&JL(r.operand,g.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access,g.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access),UAe(a))}function UAe(r){return $c(r,2112)?c_(r,3)||$c(r,296)?Sl:Rt:It}function h$(r,a){if($c(r,a))return!0;let _=e1(r);return!!_&&$c(_,a)}function $c(r,a){if(r.flags&a)return!0;if(r.flags&3145728){let _=r.types;for(let d of _)if($c(d,a))return!0}return!1}function c_(r,a,_){return r.flags&a?!0:_&&r.flags&114691?!1:!!(a&296)&&Na(r,It)||!!(a&2112)&&Na(r,Rt)||!!(a&402653316)&&Na(r,Le)||!!(a&528)&&Na(r,Pi)||!!(a&16384)&&Na(r,fn)||!!(a&131072)&&Na(r,Qn)||!!(a&65536)&&Na(r,he)||!!(a&32768)&&Na(r,Be)||!!(a&4096)&&Na(r,Fi)||!!(a&67108864)&&Na(r,ni)}function y$(r,a,_){return r.flags&1048576?yr(r.types,d=>y$(d,a,_)):c_(r,a,_)}function doe(r){return!!(Gn(r)&16)&&!!r.symbol&&VAe(r.symbol)}function VAe(r){return(r.flags&128)!==0}function JAe(r){let a=nYe("hasInstance"),_=ub(r,a);if(_){let d=vn(_);if(d&&na(d,0).length!==0)return d}}function mjt(r,a,_,d,y){if(_===Ns||d===Ns)return Ns;!wt(_)&&y$(_,402784252)&&He(r,g.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter),I.assert(Rj(r.parent));let T=OI(r.parent,void 0,y);if(T===Dn)return Ns;let P=Ao(T);return J_(P,Pi,a,g.An_object_s_Symbol_hasInstance_method_must_return_a_boolean_value_for_it_to_be_used_on_the_right_hand_side_of_an_instanceof_expression),Pi}function gjt(r){return rg(r,a=>a===zc||!!(a.flags&2097152)&&l0(e1(a)))}function hjt(r,a,_,d){if(_===Ns||d===Ns)return Ns;if(is(r)){if(pe<99&&iu(r,2097152),!_i(r).resolvedSymbol&&Vu(r)){let y=hAe(r,d.symbol,!0);EGe(r,d,y)}}else J_(yh(_,r),Mr,r);return J_(yh(d,a),ni,a)&&gjt(d)&&He(a,g.Type_0_may_represent_a_primitive_value_which_is_not_permitted_as_the_right_operand_of_the_in_operator,Kr(d)),Pi}function yjt(r,a,_){let d=r.properties;if(Q&&d.length===0)return yh(a,r);for(let y=0;y<d.length;y++)yHe(r,a,y,d,_);return a}function yHe(r,a,_,d,y=!1){let T=r.properties,P=T[_];if(P.kind===303||P.kind===304){let L=P.name,J=av(L);if(um(J)){let Ce=_m(J),be=ka(a,Ce);be&&(a$(be,P,y),pAe(P,!1,!0,a,be))}let G=Ap(a,J,32,L),ae=cs(P,G);return DC(P.kind===304?P:P.initializer,ae)}else if(P.kind===305)if(_<T.length-1)He(P,g.A_rest_element_must_be_last_in_a_destructuring_pattern);else{pe<99&&iu(P,4);let L=[];if(d)for(let G of d)F1(G)||L.push(G.name);let J=Hi(a,L,a.symbol);return pP(d,g.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma),DC(P.expression,J)}else He(P,g.Property_assignment_expected)}function vjt(r,a,_){let d=r.elements;pe<2&&$.downlevelIteration&&iu(r,512);let y=uv(193,a,Be,r)||ht,T=$.noUncheckedIndexedAccess?void 0:y;for(let P=0;P<d.length;P++){let L=y;r.elements[P].kind===230&&(L=T=T??(uv(65,a,Be,r)||ht)),vHe(r,a,P,L,_)}return a}function vHe(r,a,_,d,y){let T=r.elements,P=T[_];if(P.kind!==232){if(P.kind!==230){let L=Ng(_);if(cv(a)){let J=32|(E4(P)?16:0),G=BS(a,L,J,c$(P,L))||ht,ae=E4(P)?Em(G,524288):G,Ce=cs(P,ae);return DC(P,Ce,y)}return DC(P,d,y)}if(_<T.length-1)He(P,g.A_rest_element_must_be_last_in_a_destructuring_pattern);else{let L=P.expression;if(L.kind===226&&L.operatorToken.kind===64)He(L.operatorToken,g.A_rest_element_cannot_have_an_initializer);else{pP(r.elements,g.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);let J=tp(a,Ka)?Ec(a,G=>f4(G,_)):P_(d);return DC(L,J,y)}}}}function DC(r,a,_,d){let y;if(r.kind===304){let T=r;T.objectAssignmentInitializer&&(Q&&!bm(Cs(T.objectAssignmentInitializer),16777216)&&(a=Em(a,524288)),Ejt(T.name,T.equalsToken,T.objectAssignmentInitializer,_)),y=r.name}else y=r;return y.kind===226&&y.operatorToken.kind===64&&(Re(y,_),y=y.left,Q&&(a=Em(a,524288))),y.kind===210?yjt(y,a,d):y.kind===209?vjt(y,a,_):Sjt(y,a,_)}function Sjt(r,a,_){let d=Cs(r,_),y=r.parent.kind===305?g.The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access:g.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access,T=r.parent.kind===305?g.The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access:g.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access;return JL(r,y,T)&&qS(a,d,r,r),XP(r)&&iu(r.parent,1048576),a}function v$(r){switch(r=Do(r),r.kind){case 80:case 11:case 14:case 215:case 228:case 15:case 9:case 10:case 112:case 97:case 106:case 157:case 218:case 231:case 219:case 209:case 210:case 221:case 235:case 285:case 284:return!0;case 227:return v$(r.whenTrue)&&v$(r.whenFalse);case 226:return D1(r.operatorToken.kind)?!1:v$(r.left)&&v$(r.right);case 224:case 225:switch(r.operator){case 54:case 40:case 41:case 55:return!0}return!1;case 222:case 216:case 234:default:return!1}}function qAe(r,a){return(a.flags&98304)!==0||hae(r,a)}function Tjt(){let r=SU(a,_,d,y,T,P);return(be,Ye)=>{let vt=r(be,Ye);return I.assertIsDefined(vt),vt};function a(be,Ye,vt){return Ye?(Ye.stackIndex++,Ye.skip=!1,G(Ye,void 0),Ce(Ye,void 0)):Ye={checkMode:vt,skip:!1,stackIndex:0,typeStack:[void 0,void 0]},gn(be)&&EA(be)?(Ye.skip=!0,Ce(Ye,Cs(be.right,vt)),Ye):(bjt(be),be.operatorToken.kind===64&&(be.left.kind===210||be.left.kind===209)&&(Ye.skip=!0,Ce(Ye,DC(be.left,Cs(be.right,vt),vt,be.right.kind===110))),Ye)}function _(be,Ye,vt){if(!Ye.skip)return L(Ye,be)}function d(be,Ye,vt){if(!Ye.skip){let Dt=ae(Ye);I.assertIsDefined(Dt),G(Ye,Dt),Ce(Ye,void 0);let ur=be.kind;if(Z8(ur)){let pr=vt.parent;for(;pr.kind===217||eR(pr);)pr=pr.parent;(ur===56||ux(pr))&&tke(vt.left,Dt,ux(pr)?pr.thenStatement:void 0),rke(Dt,vt.left)}}}function y(be,Ye,vt){if(!Ye.skip)return L(Ye,be)}function T(be,Ye){let vt;if(Ye.skip)vt=ae(Ye);else{let Dt=J(Ye);I.assertIsDefined(Dt);let ur=ae(Ye);I.assertIsDefined(ur),vt=SHe(be.left,be.operatorToken,be.right,Dt,ur,Ye.checkMode,be)}return Ye.skip=!1,G(Ye,void 0),Ce(Ye,void 0),Ye.stackIndex--,vt}function P(be,Ye,vt){return Ce(be,Ye),be}function L(be,Ye){if(bn(Ye))return Ye;Ce(be,Cs(Ye,be.checkMode))}function J(be){return be.typeStack[be.stackIndex]}function G(be,Ye){be.typeStack[be.stackIndex]=Ye}function ae(be){return be.typeStack[be.stackIndex+1]}function Ce(be,Ye){be.typeStack[be.stackIndex+1]=Ye}}function bjt(r){let{left:a,operatorToken:_,right:d}=r;_.kind===61&&(bn(a)&&(a.operatorToken.kind===57||a.operatorToken.kind===56)&&kr(a,g._0_and_1_operations_cannot_be_mixed_without_parentheses,Sa(a.operatorToken.kind),Sa(_.kind)),bn(d)&&(d.operatorToken.kind===57||d.operatorToken.kind===56)&&kr(d,g._0_and_1_operations_cannot_be_mixed_without_parentheses,Sa(d.operatorToken.kind),Sa(_.kind)))}function Ejt(r,a,_,d,y){let T=a.kind;if(T===64&&(r.kind===210||r.kind===209))return DC(r,Cs(_,d),d,_.kind===110);let P;Z8(T)?P=I4(r,d):P=Cs(r,d);let L=Cs(_,d);return SHe(r,a,_,P,L,d,y)}function SHe(r,a,_,d,y,T,P){let L=a.kind;switch(L){case 42:case 43:case 67:case 68:case 44:case 69:case 45:case 70:case 41:case 66:case 48:case 71:case 49:case 72:case 50:case 73:case 52:case 75:case 53:case 79:case 51:case 74:if(d===Ns||y===Ns)return Ns;d=yh(d,r),y=yh(y,_);let fr;if(d.flags&528&&y.flags&528&&(fr=be(a.kind))!==void 0)return He(P||a,g.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead,Sa(a.kind),Sa(fr)),It;{let on=poe(r,d,g.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type,!0),Qr=poe(_,y,g.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type,!0),cn;if(c_(d,3)&&c_(y,3)||!($c(d,2112)||$c(y,2112)))cn=It;else if(J(d,y)){switch(L){case 50:case 73:ur();break;case 43:case 68:pe<3&&He(P,g.Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later)}cn=Rt}else ur(J),cn=ht;return on&&Qr&&Ye(cn),cn}case 40:case 65:if(d===Ns||y===Ns)return Ns;!c_(d,402653316)&&!c_(y,402653316)&&(d=yh(d,r),y=yh(y,_));let $r;return c_(d,296,!0)&&c_(y,296,!0)?$r=It:c_(d,2112,!0)&&c_(y,2112,!0)?$r=Rt:c_(d,402653316,!0)||c_(y,402653316,!0)?$r=Le:(wt(d)||wt(y))&&($r=Xt(d)||Xt(y)?ht:W),$r&&!Ce(L)?$r:$r?(L===65&&Ye($r),$r):(ur((Qr,cn)=>c_(Qr,402655727)&&c_(cn,402655727)),W);case 30:case 32:case 33:case 34:return Ce(L)&&(d=vCe(yh(d,r)),y=vCe(yh(y,_)),Dt((on,Qr)=>{if(wt(on)||wt(Qr))return!0;let cn=Na(on,Sl),Bs=Na(Qr,Sl);return cn&&Bs||!cn&&!Bs&&Rz(on,Qr)})),Pi;case 35:case 36:case 37:case 38:if(!(T&&T&64)){if((oY(r)||oY(_))&&(!gn(r)||L===37||L===38)){let on=L===35||L===37;He(P,g.This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value,on?"false":"true")}dn(P,L,r,_),Dt((on,Qr)=>qAe(on,Qr)||qAe(Qr,on))}return Pi;case 104:return mjt(r,_,d,y,T);case 103:return hjt(r,_,d,y);case 56:case 77:{let on=bm(d,4194304)?pi([aLt(Q?d:s1(y)),y]):d;return L===77&&Ye(y),on}case 57:case 76:{let on=bm(d,8388608)?pi([a1(Z$e(d)),y],2):d;return L===76&&Ye(y),on}case 61:case 78:{let on=bm(d,262144)?pi([a1(d),y],2):d;return L===78&&Ye(y),on}case 64:let Jr=bn(r.parent)?al(r.parent):0;return G(Jr,y),vt(Jr)?((!(y.flags&524288)||Jr!==2&&Jr!==6&&!i1(y)&&!UCe(y)&&!(Gn(y)&1))&&Ye(y),d):(Ye(y),y);case 28:if(!$.allowUnreachableCode&&v$(r)&&!ae(r.parent)){let on=Xr(r),Qr=on.text,cn=Wa(Qr,r.pos);on.parseDiagnostics.some(Os=>Os.code!==g.JSX_expressions_must_have_one_parent_element.code?!1:YH(Os,cn))||He(r,g.Left_side_of_comma_operator_is_unused_and_has_no_side_effects)}return y;default:return I.fail()}function J(fr,$r){return c_(fr,2112)&&c_($r,2112)}function G(fr,$r){if(fr===2)for(let Jr of LS($r)){let on=vn(Jr);if(on.symbol&&on.symbol.flags&32){let Qr=Jr.escapedName,cn=wc(Jr.valueDeclaration,Qr,788968,void 0,Qr,!1);cn?.declarations&&cn.declarations.some(gx)&&(ym(cn,g.Duplicate_identifier_0,Zi(Qr),Jr),ym(Jr,g.Duplicate_identifier_0,Zi(Qr),cn))}}}function ae(fr){return fr.parent.kind===217&&_p(fr.left)&&fr.left.text==="0"&&(da(fr.parent.parent)&&fr.parent.parent.expression===fr.parent||fr.parent.parent.kind===215)&&(Yo(fr.right)||ze(fr.right)&&fr.right.escapedText==="eval")}function Ce(fr){let $r=h$(d,12288)?r:h$(y,12288)?_:void 0;return $r?(He($r,g.The_0_operator_cannot_be_applied_to_type_symbol,Sa(fr)),!1):!0}function be(fr){switch(fr){case 52:case 75:return 57;case 53:case 79:return 38;case 51:case 74:return 56;default:return}}function Ye(fr){D1(L)&&n($r);function $r(){let Jr=d;if(sO(a.kind)&&r.kind===211&&(Jr=eoe(r,void 0,!0)),JL(r,g.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access,g.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access)){let on;if(Ie&&Hn(r)&&$c(fr,32768)){let Qr=Xe(l_(r.expression),r.name.escapedText);vae(fr,Qr)&&(on=g.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target)}qS(fr,Jr,r,_,on)}}}function vt(fr){var $r;switch(fr){case 2:return!0;case 1:case 5:case 6:case 3:case 4:let Jr=yd(r),on=EA(_);return!!on&&Ha(on)&&!!(($r=Jr?.exports)!=null&&$r.size);default:return!1}}function Dt(fr){return fr(d,y)?!1:(ur(fr),!0)}function ur(fr){let $r=!1,Jr=P||a;if(fr){let Os=lv(d),Ys=lv(y);$r=!(Os===d&&Ys===y)&&!!(Os&&Ys)&&fr(Os,Ys)}let on=d,Qr=y;!$r&&fr&&([on,Qr]=xjt(d,y,fr));let[cn,Bs]=eP(on,Qr);pr(Jr,$r,cn,Bs)||HT(Jr,$r,g.Operator_0_cannot_be_applied_to_types_1_and_2,Sa(a.kind),cn,Bs)}function pr(fr,$r,Jr,on){switch(a.kind){case 37:case 35:case 38:case 36:return HT(fr,$r,g.This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap,Jr,on);default:return}}function dn(fr,$r,Jr,on){let Qr=Ur(Do(Jr)),cn=Ur(Do(on));if(Qr||cn){let Bs=He(fr,g.This_condition_will_always_return_0,Sa($r===37||$r===35?97:112));if(Qr&&cn)return;let Os=$r===38||$r===36?Sa(54):"",Ys=Qr?on:Jr,As=Do(Ys);Ga(Bs,$n(Ys,g.Did_you_mean_0,`${Os}Number.isNaN(${ol(As)?cp(As):"..."})`))}}function Ur(fr){if(ze(fr)&&fr.escapedText==="NaN"){let $r=fMt();return!!$r&&$r===tg(fr)}return!1}}function xjt(r,a,_){let d=r,y=a,T=s1(r),P=s1(a);return _(T,P)||(d=T,y=P),[d,y]}function Cjt(r){n(be);let a=Vp(r);if(!a)return W;let _=vu(a);if(!(_&1))return W;let d=(_&2)!==0;r.asteriskToken&&(d&&pe<99&&iu(r,26624),!d&&pe<2&&$.downlevelIteration&&iu(r,256));let y=TI(a);y&&y.flags&1048576&&(y=wl(y,Ye=>WAe(Ye,_,void 0)));let T=y&&cYe(y,d),P=T&&T.yieldType||W,L=T&&T.nextType||W,J=d?IC(L)||W:L,G=r.expression?Cs(r.expression):Lt,ae=uHe(r,G,J,d);if(y&&ae&&qS(ae,P,r.expression||r,r.expression),r.asteriskToken)return ike(d?19:17,1,G,r.expression)||W;if(y)return l2(2,y,d)||W;let Ce=HWe(2,a);return Ce||(Ce=W,n(()=>{if(ve&&!Ume(r)){let Ye=Bf(r,void 0);(!Ye||wt(Ye))&&He(r,g.yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation)}})),Ce;function be(){r.flags&16384||Xu(r,g.A_yield_expression_is_only_allowed_in_a_generator_body),ZCe(r)&&He(r,g.yield_expressions_cannot_be_used_in_a_parameter_initializer)}}function Ajt(r,a){let _=I4(r.condition,a);tke(r.condition,_,r.whenTrue);let d=Cs(r.whenTrue,a),y=Cs(r.whenFalse,a);return pi([d,y],2)}function THe(r){let a=r.parent;return Df(a)&&THe(a)||fc(a)&&a.argumentExpression===r}function kjt(r){let a=[r.head.text],_=[];for(let y of r.templateSpans){let T=Cs(y.expression);h$(T,12288)&&He(y.expression,g.Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String),a.push(y.literal.text),_.push(Na(T,zs)?T:Le)}if(A4(r)||THe(r)||rg(Bf(r,void 0)||Sr,Pjt))return mC(a,_);let d=r.parent.kind!==215&&EYe(r);return d?cP(jf(d)):Le}function Pjt(r){return!!(r.flags&134217856||r.flags&58982400&&$c(k_(r)||Sr,402653316))}function Njt(r){return dE(r)&&!px(r.parent)?r.parent.parent:r}function RI(r,a,_,d){let y=Njt(r);Zz(y,a,!1),YFt(y,_);let T=Cs(r,d|1|(_?2:0));_&&_.intraExpressionInferenceSites&&(_.intraExpressionInferenceSites=void 0);let P=$c(T,2944)&&goe(T,Yae(a,r,void 0))?af(T):T;return XFt(),FL(),P}function xl(r,a){if(a)return Cs(r,a);let _=_i(r);if(!_.resolvedType){let d=lh,y=Er;lh=gd,Er=void 0,_.resolvedType=Cs(r,a),Er=y,lh=d}return _.resolvedType}function bHe(r){return r=Do(r,!0),r.kind===216||r.kind===234||KN(r)}function C4(r,a,_){let d=N8(r);if(gn(r)){let T=cB(r);if(T)return wAe(d,T,a)}let y=$Ae(d)||(_?RI(d,_,void 0,a||0):xl(d,a));return Ls(r)&&r.name.kind===207&&Ka(y)&&!y.target.hasRestElement&&sv(y)<r.name.elements.length?Djt(y,r.name):y}function Djt(r,a){let _=a.elements,d=ZE(r).slice(),y=r.target.elementFlags.slice();for(let T=sv(r);T<_.length;T++){let P=_[T];(T<_.length-1||!(P.kind===208&&P.dotDotDotToken))&&(d.push(!Su(P)&&E4(P)?s4(P,!1,!1):W),y.push(2),!Su(P)&&!E4(P)&&hb(P,W))}return c0(d,y,r.target.readonly)}function moe(r,a){let _=f2(r)&6||Y9(r)?a:i2(a);if(gn(r)){if(G$e(_))return hb(r,W),W;if(Cae(_))return hb(r,bl),bl}return _}function goe(r,a){if(a){if(a.flags&3145728){let _=a.types;return Tt(_,d=>goe(r,d))}if(a.flags&58982400){let _=k_(a)||Sr;return $c(_,4)&&$c(r,128)||$c(_,8)&&$c(r,256)||$c(_,64)&&$c(r,2048)||$c(_,4096)&&$c(r,8192)||goe(r,_)}return!!(a.flags&406847616&&$c(r,128)||a.flags&256&&$c(r,256)||a.flags&2048&&$c(r,2048)||a.flags&512&&$c(r,512)||a.flags&8192&&$c(r,8192))}return!1}function A4(r){let a=r.parent;return U2(a)&&Ty(a.type)||KN(a)&&Ty(gU(a))||IAe(r)&&fC(Bf(r,0))||(Df(a)||Z_(a)||fg(a))&&A4(a)||(Ul(a)||Hf(a)||B6(a))&&A4(a.parent)}function k4(r,a,_){let d=Cs(r,a,_);return A4(r)||pde(r)?af(d):bHe(r)?d:SCe(d,Yae(Bf(r,void 0),r,void 0))}function EHe(r,a){return r.name.kind===167&&Q0(r.name),k4(r.initializer,a)}function xHe(r,a){XYe(r),r.name.kind===167&&Q0(r.name);let _=mHe(r,a);return CHe(r,_,a)}function CHe(r,a,_){if(_&&_&10){let d=BL(a,0,!0),y=BL(a,1,!0),T=d||y;if(T&&T.typeParameters){let P=Tb(r,2);if(P){let L=BL(a1(P),d?0:1,!1);if(L&&!L.typeParameters){if(_&8)return AHe(r,_),cr;let J=a2(r),G=J.signature&&Ao(J.signature),ae=G&&OGe(G);if(ae&&!ae.typeParameters&&!yr(J.inferences,MI)){let Ce=Rjt(J,T.typeParameters),be=bxe(T,Ce),Ye=vr(J.inferences,vt=>kCe(vt.typeParameter));if(ECe(be,L,(vt,Dt)=>{o1(Ye,vt,Dt,0,!0)}),Tt(Ye,MI)&&(xCe(be,L,(vt,Dt)=>{o1(Ye,vt,Dt)}),!wjt(J.inferences,Ye)))return Ojt(J.inferences,Ye),J.inferredTypeParameters=ys(J.inferredTypeParameters,Ce),dC(be)}return dC(RGe(T,L,J))}}}}return a}function AHe(r,a){if(a&2){let _=a2(r);_.flags|=4}}function MI(r){return!!(r.candidates||r.contraCandidates)}function Ijt(r){return!!(r.candidates||r.contraCandidates||uze(r.typeParameter))}function wjt(r,a){for(let _=0;_<r.length;_++)if(MI(r[_])&&MI(a[_]))return!0;return!1}function Ojt(r,a){for(let _=0;_<r.length;_++)!MI(r[_])&&MI(a[_])&&(r[_]=a[_])}function Rjt(r,a){let _=[],d,y;for(let T of a){let P=T.symbol.escapedName;if(zAe(r.inferredTypeParameters,P)||zAe(_,P)){let L=Mjt(ys(r.inferredTypeParameters,_),P),J=oo(262144,L),G=Sd(J);G.target=T,d=Pr(d,T),y=Pr(y,G),_.push(G)}else _.push(T)}if(y){let T=kp(d,y);for(let P of y)P.mapper=T}return _}function zAe(r,a){return Tt(r,_=>_.symbol.escapedName===a)}function Mjt(r,a){let _=a.length;for(;_>1&&a.charCodeAt(_-1)>=48&&a.charCodeAt(_-1)<=57;)_--;let d=a.slice(0,_);for(let y=1;;y++){let T=d+y;if(!zAe(r,T))return T}}function kHe(r){let a=NC(r);if(a&&!a.typeParameters)return Ao(a)}function Ljt(r){let a=Cs(r.expression),_=DL(a,r.expression),d=kHe(a);return d&&Nae(d,r,_!==a)}function l_(r){let a=$Ae(r);if(a)return a;if(r.flags&268435456&&Er){let y=Er[yo(r)];if(y)return y}let _=et,d=Cs(r,64);if(et!==_){let y=Er||(Er=[]);y[yo(r)]=d,Bme(r,r.flags|268435456)}return d}function $Ae(r){let a=Do(r,!0);if(KN(a)){let _=gU(a);if(!Ty(_))return Ri(_)}if(a=Do(r),Zv(a)){let _=$Ae(a.expression);return _?IC(_):void 0}if(da(a)&&a.expression.kind!==108&&!_f(a,!0)&&!GGe(a))return L2(a)?Ljt(a):kHe(II(a.expression));if(U2(a)&&!Ty(a.type))return Ri(a.type);if(Ub(r)||Mw(r))return Cs(r)}function S$(r){let a=_i(r);if(a.contextFreeType)return a.contextFreeType;Zz(r,W,!1);let _=a.contextFreeType=Cs(r,4);return FL(),_}function Cs(r,a,_){var d,y;(d=mn)==null||d.push(mn.Phase.Check,"checkExpression",{kind:r.kind,pos:r.pos,end:r.end,path:r.tracingPath});let T=O;O=r,k=0;let P=Bjt(r,a,_),L=CHe(r,P,a);return doe(L)&&Fjt(r,L),O=T,(y=mn)==null||y.pop(),L}function Fjt(r,a){r.parent.kind===211&&r.parent.expression===r||r.parent.kind===212&&r.parent.expression===r||(r.kind===80||r.kind===166)&&Doe(r)||r.parent.kind===186&&r.parent.exprName===r||r.parent.kind===281||He(r,g.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query),fm($)&&(I.assert(!!(a.symbol.flags&128)),a.symbol.valueDeclaration.flags&33554432&&!ET(r)&&He(r,g.Cannot_access_ambient_const_enums_when_0_is_enabled,Ze))}function jjt(r,a){if(jp(r)){if(XX(r))return wAe(r.expression,KX(r),a);if(KN(r))return KGe(r,a)}return Cs(r.expression,a)}function Bjt(r,a,_){let d=r.kind;if(i)switch(d){case 231:case 218:case 219:i.throwIfCancellationRequested()}switch(d){case 80:return yFt(r,a);case 81:return L5t(r);case 110:return Kz(r);case 108:return KCe(r);case 106:return qe;case 15:case 11:return wCe(r)?Ke:cP(jf(r.text));case 9:return Cke(r),cP(Ng(+r.text));case 10:return VJt(r),cP(_ae({negative:!1,base10Value:v6(r.text)}));case 112:return zr;case 97:return Zt;case 228:return kjt(r);case 14:return Ic;case 209:return rGe(r,a,_);case 210:return d5t(r,a);case 211:return eoe(r,a);case 166:return yGe(r,a);case 212:return Q5t(r,a);case 213:if(r.expression.kind===102)return D9t(r);case 214:return N9t(r,a);case 215:return I9t(r);case 217:return jjt(r,a);case 231:return AUt(r);case 218:case 219:return mHe(r,a);case 221:return ujt(r);case 216:case 234:return w9t(r,a);case 235:return M9t(r);case 233:return ZGe(r);case 238:return L9t(r);case 236:return F9t(r);case 220:return cjt(r);case 222:return _jt(r);case 223:return fjt(r);case 224:return pjt(r);case 225:return djt(r);case 226:return Re(r,a);case 227:return Ajt(r,a);case 230:return c5t(r,a);case 232:return Lt;case 229:return Cjt(r);case 237:return l5t(r);case 294:return N5t(r,a);case 284:return y5t(r,a);case 285:return g5t(r,a);case 288:return v5t(r);case 292:return T5t(r,a);case 286:I.fail("Shouldn't ever directly check a JsxOpeningElement")}return ht}function PHe(r){ey(r),r.expression&&Xu(r.expression,g.Type_expected),Ba(r.constraint),Ba(r.default);let a=lC(Rn(r));k_(a),vRt(a)||He(r.default,g.Type_parameter_0_has_a_circular_default,Kr(a));let _=Sf(a),d=pC(a);_&&d&&J_(d,Hp(gs(_,r2(a,d)),d),r.default,g.Type_0_does_not_satisfy_the_constraint_1),_P(r),n(()=>w4(r.name,g.Type_parameter_name_cannot_be_0))}function Ujt(r){var a,_;if(ef(r.parent)||Ti(r.parent)||Vm(r.parent)){let d=lC(Rn(r)),y=mCe(d)&24576;if(y){let T=Rn(r.parent);if(Vm(r.parent)&&!(Gn(dc(T))&52))He(r,g.Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types);else if(y===8192||y===16384){(a=mn)==null||a.push(mn.Phase.CheckTypes,"checkTypeParameterDeferred",{parent:sf(dc(T)),id:sf(d)});let P=Fz(T,d,y===16384?ne:ge),L=Fz(T,d,y===16384?ge:ne),J=d;U=d,J_(P,L,r,g.Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation),U=J,(_=mn)==null||_.pop()}}}}function NHe(r){ey(r),C$(r);let a=Vp(r);ui(r,31)&&(a.kind===176&&nm(a.body)||He(r,g.A_parameter_property_is_only_allowed_in_a_constructor_implementation),a.kind===176&&ze(r.name)&&r.name.escapedText==="constructor"&&He(r.name,g.constructor_cannot_be_used_as_a_parameter_property_name)),!r.initializer&&C6(r)&&la(r.name)&&a.body&&He(r,g.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature),r.name&&ze(r.name)&&(r.name.escapedText==="this"||r.name.escapedText==="new")&&(a.parameters.indexOf(r)!==0&&He(r,g.A_0_parameter_must_be_the_first_parameter,r.name.escapedText),(a.kind===176||a.kind===180||a.kind===185)&&He(r,g.A_constructor_cannot_have_a_this_parameter),a.kind===219&&He(r,g.An_arrow_function_cannot_have_a_this_parameter),(a.kind===177||a.kind===178)&&He(r,g.get_and_set_accessors_cannot_declare_this_parameters)),r.dotDotDotToken&&!la(r.name)&&!Na(Pg(vn(r.symbol)),dd)&&He(r,g.A_rest_parameter_must_be_of_an_array_type)}function Vjt(r){let a=Jjt(r);if(!a){He(r,g.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);return}let _=Sm(a),d=zd(_);if(!d)return;Ba(r.type);let{parameterName:y}=r;if(d.kind===0||d.kind===2)fae(y);else if(d.parameterIndex>=0){if(L_(_)&&d.parameterIndex===_.parameters.length-1)He(y,g.A_type_predicate_cannot_reference_a_rest_parameter);else if(d.type){let T=()=>Xs(void 0,g.A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type);J_(d.type,vn(_.parameters[d.parameterIndex]),r.type,void 0,T)}}else if(y){let T=!1;for(let{name:P}of a.parameters)if(la(P)&&DHe(P,y,d.parameterName)){T=!0;break}T||He(r.parameterName,g.Cannot_find_parameter_0,d.parameterName)}}function Jjt(r){switch(r.parent.kind){case 219:case 179:case 262:case 218:case 184:case 174:case 173:let a=r.parent;if(r===a.type)return a}}function DHe(r,a,_){for(let d of r.elements){if(Su(d))continue;let y=d.name;if(y.kind===80&&y.escapedText===_)return He(a,g.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern,_),!0;if((y.kind===207||y.kind===206)&&DHe(y,a,_))return!0}}function qL(r){r.kind===181?mJt(r):(r.kind===184||r.kind===262||r.kind===185||r.kind===179||r.kind===176||r.kind===180)&&Loe(r);let a=vu(r);a&4||((a&3)===3&&pe<99&&iu(r,6144),(a&3)===2&&pe<4&&iu(r,64),a&3&&pe<2&&iu(r,128)),P$(Ov(r)),EUt(r),Te(r.parameters,NHe),r.type&&Ba(r.type),n(_);function _(){UBt(r);let d=lm(r),y=d;if(gn(r)){let T=_T(r);if(T&&T.typeExpression&&Id(T.typeExpression.type)){let P=NC(Ri(T.typeExpression));P&&P.declaration&&(d=lm(P.declaration),y=T.typeExpression.type)}}if(ve&&!d)switch(r.kind){case 180:He(r,g.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);break;case 179:He(r,g.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);break}if(d&&y){let T=vu(r);if((T&5)===1){let P=Ri(d);P===fn?He(y,g.A_generator_cannot_have_a_void_type_annotation):WAe(P,T,y)}else(T&3)===2&&vBt(r,d,y)}r.kind!==181&&r.kind!==324&&HS(r)}}function WAe(r,a,_){let d=l2(0,r,(a&2)!==0)||W,y=l2(1,r,(a&2)!==0)||d,T=l2(2,r,(a&2)!==0)||Sr,P=lHe(d,y,T,!!(a&2));return J_(P,r,_)}function qjt(r){let a=new Map,_=new Map,d=new Map;for(let T of r.members)if(T.kind===176)for(let P of T.parameters)op(P,T)&&!la(P.name)&&y(a,P.name,P.name.escapedText,3);else{let P=pa(T),L=T.name;if(!L)continue;let J=is(L),G=J&&P?16:0,ae=J?d:P?_:a,Ce=L&&Ake(L);if(Ce)switch(T.kind){case 177:y(ae,L,Ce,1|G);break;case 178:y(ae,L,Ce,2|G);break;case 172:y(ae,L,Ce,3|G);break;case 174:y(ae,L,Ce,8|G);break}}function y(T,P,L,J){let G=T.get(L);if(G)if((G&16)!==(J&16))He(P,g.Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name,Fl(P));else{let ae=!!(G&8),Ce=!!(J&8);ae||Ce?ae!==Ce&&He(P,g.Duplicate_identifier_0,Fl(P)):G&J&-17?He(P,g.Duplicate_identifier_0,Fl(P)):T.set(L,G|J)}else T.set(L,J)}}function zjt(r){for(let a of r.members){let _=a.name;if(pa(a)&&_){let y=Ake(_);switch(y){case"name":case"length":case"caller":case"arguments":if(Se)break;case"prototype":let T=g.Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1,P=ib(Rn(r));He(_,T,y,P);break}}}}function IHe(r){let a=new Map;for(let _ of r.members)if(_.kind===171){let d,y=_.name;switch(y.kind){case 11:case 9:d=y.text;break;case 80:d=Nn(y);break;default:continue}a.get(d)?(He(qs(_.symbol.valueDeclaration),g.Duplicate_identifier_0,d),He(_.name,g.Duplicate_identifier_0,d)):a.set(d,!0)}}function GAe(r){if(r.kind===264){let _=Rn(r);if(_.declarations&&_.declarations.length>0&&_.declarations[0]!==r)return}let a=Exe(Rn(r));if(a?.declarations){let _=new Map;for(let d of a.declarations)d.parameters.length===1&&d.parameters[0].type&&CC(Ri(d.parameters[0].type),y=>{let T=_.get(sf(y));T?T.declarations.push(d):_.set(sf(y),{type:y,declarations:[d]})});_.forEach(d=>{if(d.declarations.length>1)for(let y of d.declarations)He(y,g.Duplicate_index_signature_for_type_0,Kr(d.type))})}}function wHe(r){!ey(r)&&!FJt(r)&&Foe(r.name),C$(r),HAe(r),ui(r,64)&&r.kind===172&&r.initializer&&He(r,g.Property_0_cannot_have_an_initializer_because_it_is_marked_abstract,qo(r.name))}function $jt(r){return is(r.name)&&He(r,g.Private_identifiers_are_not_allowed_outside_class_bodies),wHe(r)}function Wjt(r){XYe(r)||Foe(r.name),pl(r)&&r.asteriskToken&&ze(r.name)&&Nn(r.name)==="constructor"&&He(r.name,g.Class_constructor_may_not_be_a_generator),$He(r),ui(r,64)&&r.kind===174&&r.body&&He(r,g.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract,qo(r.name)),is(r.name)&&!Vu(r)&&He(r,g.Private_identifiers_are_not_allowed_outside_class_bodies),HAe(r)}function HAe(r){if(is(r.name)&&pe<99){for(let a=Lh(r);a;a=Lh(a))_i(a).flags|=1048576;if(wu(r.parent)){let a=GCe(r.parent);a&&(_i(r.name).flags|=32768,_i(a).flags|=4096)}}}function Gjt(r){ey(r),Qs(r,Ba)}function Hjt(r){qL(r),MJt(r)||LJt(r),Ba(r.body);let a=Rn(r),_=xc(a,r.kind);if(r===_&&voe(a),sl(r.body))return;n(y);return;function d(T){return G_(T)?!0:T.kind===172&&!pa(T)&&!!T.initializer}function y(){let T=r.parent;if(Xb(T)){HCe(r.parent,T);let P=YCe(T),L=UWe(r.body);if(L){if(P&&He(L,g.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null),!xe&&(Tt(r.parent.members,d)||Tt(r.parameters,G=>ui(G,31))))if(!Yjt(L,r.body))He(L,g.A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers);else{let G;for(let ae of r.body.statements){if(Ou(ae)&&$2(vl(ae.expression))){G=ae;break}if(OHe(ae))break}G===void 0&&He(r,g.A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers)}}else P||He(r,g.Constructors_for_derived_classes_must_contain_a_super_call)}}}function Yjt(r,a){let _=P1(r.parent);return Ou(_)&&_.parent===a}function OHe(r){return r.kind===108||r.kind===110?!0:Sde(r)?!1:!!Qs(r,OHe)}function RHe(r){ze(r.name)&&Nn(r.name)==="constructor"&&Ti(r.parent)&&He(r.name,g.Class_constructor_may_not_be_an_accessor),n(a),Ba(r.body),HAe(r);function a(){if(!Loe(r)&&!xJt(r)&&Foe(r.name),b$(r),qL(r),r.kind===177&&!(r.flags&33554432)&&nm(r.body)&&r.flags&512&&(r.flags&1024||He(r.name,g.A_get_accessor_must_return_a_value)),r.name.kind===167&&Q0(r.name),vI(r)){let d=Rn(r),y=xc(d,177),T=xc(d,178);if(y&&T&&!(jI(y)&1)){_i(y).flags|=1;let P=X_(y),L=X_(T);(P&64)!==(L&64)&&(He(y.name,g.Accessors_must_both_be_abstract_or_non_abstract),He(T.name,g.Accessors_must_both_be_abstract_or_non_abstract)),(P&4&&!(L&6)||P&2&&!(L&2))&&(He(y.name,g.A_get_accessor_must_be_at_least_as_accessible_as_the_setter),He(T.name,g.A_get_accessor_must_be_at_least_as_accessible_as_the_setter))}}let _=cb(Rn(r));r.kind===177&&BAe(r,_)}}function Xjt(r){b$(r)}function Kjt(r,a,_){return r.typeArguments&&_<r.typeArguments.length?Ri(r.typeArguments[_]):hoe(r,a)[_]}function hoe(r,a){return FS(vr(r.typeArguments,Ri),a,a0(a),gn(r))}function MHe(r,a){let _,d,y=!0;for(let T=0;T<a.length;T++){let P=Sf(a[T]);P&&(_||(_=hoe(r,a),d=kp(a,_)),y=y&&J_(_[T],gs(P,d),r.typeArguments[T],g.Type_0_does_not_satisfy_the_constraint_1))}return y}function Qjt(r,a){if(!Xt(r))return a.flags&524288&&as(a).typeParameters||(Gn(r)&4?r.target.localTypeParameters:void 0)}function YAe(r){let a=Ri(r);if(!Xt(a)){let _=_i(r).resolvedSymbol;if(_)return Qjt(a,_)}}function XAe(r){if(I$(r,r.typeArguments),r.kind===183&&!gn(r)&&!k8(r)&&r.typeArguments&&r.typeName.end!==r.typeArguments.pos){let a=Xr(r);lde(a,r.typeName.end)===25&&_2(r,Wa(a.text,r.typeName.end),1,g.JSDoc_types_can_only_be_used_inside_documentation_comments)}Te(r.typeArguments,Ba),LHe(r)}function LHe(r){let a=Ri(r);if(!Xt(a)){r.typeArguments&&n(()=>{let d=YAe(r);d&&MHe(r,d)});let _=_i(r).resolvedSymbol;_&&Tt(_.declarations,d=>LN(d)&&!!(d.flags&536870912))&&Q1(_$(r),_.declarations,_.escapedName)}}function Zjt(r){let a=ii(r.parent,F9);if(!a)return;let _=YAe(a);if(!_)return;let d=Sf(_[a.typeArguments.indexOf(r)]);return d&&gs(d,kp(_,hoe(a,_)))}function eBt(r){Oze(r)}function tBt(r){Te(r.members,Ba),n(a);function a(){let _=S$e(r);Aoe(_,_.symbol),GAe(r),IHe(r)}}function rBt(r){Ba(r.elementType)}function nBt(r){let a=!1,_=!1;for(let d of r.elements){let y=jxe(d);if(y&8){let T=Ri(d.type);if(!cv(T)){He(d,g.A_rest_element_type_must_be_an_array_type);break}(Gd(T)||Ka(T)&&T.target.combinedFlags&4)&&(y|=4)}if(y&4){if(_){kr(d,g.A_rest_element_cannot_follow_another_rest_element);break}_=!0}else if(y&2){if(_){kr(d,g.An_optional_element_cannot_follow_a_rest_element);break}a=!0}else if(y&1&&a){kr(d,g.A_required_element_cannot_follow_an_optional_element);break}}Te(r.elements,Ba),Ri(r)}function iBt(r){Te(r.types,Ba),Ri(r)}function FHe(r,a){if(!(r.flags&8388608))return r;let _=r.objectType,d=r.indexType,y=Ff(_)&&Yse(_)===2?i$e(_,0):gh(_,0),T=!!K0(_,It);if(tp(d,P=>Na(P,y)||T&&nP(P,It)))return a.kind===212&&N0(a)&&Gn(_)&32&&s0(_)&1&&He(a,g.Index_signature_in_type_0_only_permits_reading,Kr(_)),r;if(hC(_)){let P=oae(d,a);if(P){let L=CC(Tf(_),J=>ka(J,P));if(L&&Nd(L)&6)return He(a,g.Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter,Zi(P)),ht}}return He(a,g.Type_0_cannot_be_used_to_index_type_1,Kr(d),Kr(_)),ht}function sBt(r){Ba(r.objectType),Ba(r.indexType),FHe(d$e(r),r)}function aBt(r){oBt(r),Ba(r.typeParameter),Ba(r.nameType),Ba(r.type),r.type||hb(r,W);let a=Xxe(r),_=nv(a);if(_)J_(_,Qo,r.nameType);else{let d=bd(a);J_(d,Qo,YP(r.typeParameter))}}function oBt(r){var a;if((a=r.members)!=null&&a.length)return kr(r.members[0],g.A_mapped_type_may_not_declare_properties_or_methods)}function cBt(r){fae(r)}function lBt(r){AJt(r),Ba(r.type)}function uBt(r){Qs(r,Ba)}function _Bt(r){Gr(r,_=>_.parent&&_.parent.kind===194&&_.parent.extendsType===_)||kr(r,g.infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type),Ba(r.typeParameter);let a=Rn(r.typeParameter);if(a.declarations&&a.declarations.length>1){let _=as(a);if(!_.typeParametersChecked){_.typeParametersChecked=!0;let d=lC(a),y=Jpe(a,168);if(!fYe(y,[d],T=>[T])){let T=Oi(a);for(let P of y)He(P.name,g.All_declarations_of_0_must_have_identical_constraints,T)}}}HS(r)}function fBt(r){for(let a of r.templateSpans){Ba(a.type);let _=Ri(a.type);J_(_,zs,a.type)}Ri(r)}function pBt(r){Ba(r.argument),r.attributes&&fD(r.attributes,kr),LHe(r)}function dBt(r){r.dotDotDotToken&&r.questionToken&&kr(r,g.A_tuple_member_cannot_be_both_optional_and_rest),r.type.kind===190&&kr(r.type,g.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type),r.type.kind===191&&kr(r.type,g.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type),Ba(r.type),Ri(r)}function T$(r){return(up(r,2)||G_(r))&&!!(r.flags&33554432)}function yoe(r,a){let _=joe(r);if(r.parent.kind!==264&&r.parent.kind!==263&&r.parent.kind!==231&&r.flags&33554432){let d=LY(r);d&&d.flags&128&&!(_&128)&&!(Zg(r.parent)&&hl(r.parent.parent)&&zg(r.parent.parent))&&(_|=32),_|=128}return _&a}function voe(r){n(()=>mBt(r))}function mBt(r){function a(fr,$r){return $r!==void 0&&$r.parent===fr[0].parent?$r:fr[0]}function _(fr,$r,Jr,on,Qr){if((on^Qr)!==0){let Bs=yoe(a(fr,$r),Jr);Te(fr,Os=>{let Ys=yoe(Os,Jr)^Bs;Ys&32?He(qs(Os),g.Overload_signatures_must_all_be_exported_or_non_exported):Ys&128?He(qs(Os),g.Overload_signatures_must_all_be_ambient_or_non_ambient):Ys&6?He(qs(Os)||Os,g.Overload_signatures_must_all_be_public_private_or_protected):Ys&64&&He(qs(Os),g.Overload_signatures_must_all_be_abstract_or_non_abstract)})}}function d(fr,$r,Jr,on){if(Jr!==on){let Qr=CA(a(fr,$r));Te(fr,cn=>{CA(cn)!==Qr&&He(qs(cn),g.Overload_signatures_must_all_be_optional_or_required)})}}let y=230,T=0,P=y,L=!1,J=!0,G=!1,ae,Ce,be,Ye=r.declarations,vt=(r.flags&16384)!==0;function Dt(fr){if(fr.name&&sl(fr.name))return;let $r=!1,Jr=Qs(fr.parent,Qr=>{if($r)return Qr;$r=Qr===fr});if(Jr&&Jr.pos===fr.end&&Jr.kind===fr.kind){let Qr=Jr.name||Jr,cn=Jr.name;if(fr.name&&cn&&(is(fr.name)&&is(cn)&&fr.name.escapedText===cn.escapedText||uo(fr.name)&&uo(cn)&&n1(Q0(fr.name),Q0(cn))||Wg(fr.name)&&Wg(cn)&&Qw(fr.name)===Qw(cn))){if((fr.kind===174||fr.kind===173)&&pa(fr)!==pa(Jr)){let Os=pa(fr)?g.Function_overload_must_be_static:g.Function_overload_must_not_be_static;He(Qr,Os)}return}if(nm(Jr.body)){He(Qr,g.Function_implementation_name_must_be_0,qo(fr.name));return}}let on=fr.name||fr;vt?He(on,g.Constructor_implementation_is_missing):ui(fr,64)?He(on,g.All_declarations_of_an_abstract_method_must_be_consecutive):He(on,g.Function_implementation_is_missing_or_not_immediately_following_the_declaration)}let ur=!1,pr=!1,dn=!1,Ur=[];if(Ye)for(let fr of Ye){let $r=fr,Jr=$r.flags&33554432,on=$r.parent&&($r.parent.kind===264||$r.parent.kind===187)||Jr;if(on&&(be=void 0),($r.kind===263||$r.kind===231)&&!Jr&&(dn=!0),$r.kind===262||$r.kind===174||$r.kind===173||$r.kind===176){Ur.push($r);let Qr=yoe($r,y);T|=Qr,P&=Qr,L=L||CA($r),J=J&&CA($r);let cn=nm($r.body);cn&&ae?vt?pr=!0:ur=!0:be?.parent===$r.parent&&be.end!==$r.pos&&Dt(be),cn?ae||(ae=$r):G=!0,be=$r,on||(Ce=$r)}gn(fr)&&ca(fr)&&fr.jsDoc&&(G=de(ZY(fr))>0)}if(pr&&Te(Ur,fr=>{He(fr,g.Multiple_constructor_implementations_are_not_allowed)}),ur&&Te(Ur,fr=>{He(qs(fr)||fr,g.Duplicate_function_implementation)}),dn&&!vt&&r.flags&16&&Ye){let fr=Fn(Ye,$r=>$r.kind===263).map($r=>$n($r,g.Consider_adding_a_declare_modifier_to_this_class));Te(Ye,$r=>{let Jr=$r.kind===263?g.Class_declaration_cannot_implement_overload_list_for_0:$r.kind===262?g.Function_with_bodies_can_only_merge_with_classes_that_are_ambient:void 0;Jr&&Ga(He(qs($r)||$r,Jr,Lc(r)),...fr)})}if(Ce&&!Ce.body&&!ui(Ce,64)&&!Ce.questionToken&&Dt(Ce),G&&(Ye&&(_(Ye,ae,y,T,P),d(Ye,ae,L,J)),ae)){let fr=KE(r),$r=Sm(ae);for(let Jr of fr)if(!M7t($r,Jr)){let on=Jr.declaration&&PT(Jr.declaration)?Jr.declaration.parent.tagName:Jr.declaration;Ga(He(on,g.This_overload_signature_is_not_compatible_with_its_implementation_signature),$n(ae,g.The_implementation_signature_is_declared_here));break}}}function zL(r){n(()=>gBt(r))}function gBt(r){let a=r.localSymbol;if(!a&&(a=Rn(r),!a.exportSymbol)||xc(a,r.kind)!==r)return;let _=0,d=0,y=0;for(let G of a.declarations){let ae=J(G),Ce=yoe(G,2080);Ce&32?Ce&2048?y|=ae:_|=ae:d|=ae}let T=_|d,P=_&d,L=y&T;if(P||L)for(let G of a.declarations){let ae=J(G),Ce=qs(G);ae&L?He(Ce,g.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead,qo(Ce)):ae&P&&He(Ce,g.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local,qo(Ce))}function J(G){let ae=G;switch(ae.kind){case 264:case 265:case 353:case 345:case 347:return 2;case 267:return S_(ae)||Oy(ae)!==0?5:4;case 263:case 266:case 306:return 3;case 312:return 7;case 277:case 226:let Ce=ae,be=Kc(Ce)?Ce.expression:Ce.right;if(!ol(be))return 1;ae=be;case 271:case 274:case 273:let Ye=0,vt=du(Rn(ae));return Te(vt.declarations,Dt=>{Ye|=J(Dt)}),Ye;case 260:case 208:case 262:case 276:case 80:return 1;case 173:case 171:return 2;default:return I.failBadSyntaxKind(ae)}}}function P4(r,a,_,...d){let y=$L(r,a);return y&&IC(y,a,_,...d)}function $L(r,a,_){if(wt(r))return;let d=r;if(d.promisedTypeOfPromise)return d.promisedTypeOfPromise;if(RS(r,Cz(!1)))return d.promisedTypeOfPromise=cc(r)[0];if(y$(e1(r),402915324))return;let y=Xe(r,"then");if(wt(y))return;let T=y?na(y,0):tt;if(T.length===0){a&&He(a,g.A_promise_must_have_a_then_method);return}let P,L;for(let ae of T){let Ce=fb(ae);Ce&&Ce!==fn&&!hh(r,Ce,Xh)?P=Ce:L=Pr(L,ae)}if(!L){I.assertIsDefined(P),_&&(_.value=P),a&&He(a,g.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1,Kr(r),Kr(P));return}let J=Em(pi(vr(L,MAe)),2097152);if(wt(J))return;let G=na(J,0);if(G.length===0){a&&He(a,g.The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback);return}return d.promisedTypeOfPromise=pi(vr(G,MAe),2)}function WL(r,a,_,d,...y){return(a?IC(r,_,d,...y):lv(r,_,d,...y))||ht}function jHe(r){if(y$(e1(r),402915324))return!1;let a=Xe(r,"then");return!!a&&na(Em(a,2097152),0).length>0}function Soe(r){var a;if(r.flags&16777216){let _=Fxe(!1);return!!_&&r.aliasSymbol===_&&((a=r.aliasTypeArguments)==null?void 0:a.length)===1}return!1}function N4(r){return r.flags&1048576?Ec(r,N4):Soe(r)?r.aliasTypeArguments[0]:r}function BHe(r){if(wt(r)||Soe(r))return!1;if(hC(r)){let a=k_(r);if(a?a.flags&3||i1(a)||rg(a,jHe):$c(r,8650752))return!0}return!1}function hBt(r){let a=Fxe(!0);if(a)return EI(a,[N4(r)])}function yBt(r){if(BHe(r)){let a=hBt(r);if(a)return a}return I.assert(Soe(r)||$L(r)===void 0,"type provided should not be a non-generic 'promise'-like."),r}function IC(r,a,_,...d){let y=lv(r,a,_,...d);return y&&yBt(y)}function lv(r,a,_,...d){if(wt(r)||Soe(r))return r;let y=r;if(y.awaitedTypeOfType)return y.awaitedTypeOfType;if(r.flags&1048576){if($T.lastIndexOf(r.id)>=0){a&&He(a,g.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);return}let L=a?G=>lv(G,a,_,...d):lv;$T.push(r.id);let J=Ec(r,L);return $T.pop(),y.awaitedTypeOfType=J}if(BHe(r))return y.awaitedTypeOfType=r;let T={value:void 0},P=$L(r,void 0,T);if(P){if(r.id===P.id||$T.lastIndexOf(P.id)>=0){a&&He(a,g.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);return}$T.push(r.id);let L=lv(P,a,_,...d);return $T.pop(),L?y.awaitedTypeOfType=L:void 0}if(jHe(r)){if(a){I.assertIsDefined(_);let L;T.value&&(L=Xs(L,g.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1,Kr(r),Kr(T.value))),L=Xs(L,_,...d),fo.add(Ey(Xr(a),a,L))}return}return y.awaitedTypeOfType=r}function vBt(r,a,_){let d=Ri(a);if(pe>=2){if(Xt(d))return;let T=Cz(!0);if(T!==$s&&!RS(d,T)){y(g.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0,a,_,Kr(lv(d)||fn));return}}else{if(TBt(a),Xt(d))return;let T=C8(a);if(T===void 0){y(g.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,a,_,Kr(d));return}let P=ac(T,111551,!0),L=P?vn(P):ht;if(Xt(L)){T.kind===80&&T.escapedText==="Promise"&&rv(d)===Cz(!1)?He(_,g.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option):y(g.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,a,_,cp(T));return}let J=$Rt(!0);if(J===$a){y(g.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value,a,_,cp(T));return}let G=g.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value;if(!J_(L,J,_,G,()=>a===_?void 0:Xs(void 0,g.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type)))return;let Ce=T&&Jp(T),be=Lf(r.locals,Ce.escapedText,111551);if(be){He(be.valueDeclaration,g.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions,Nn(Ce),cp(T));return}}WL(d,!1,r,g.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);function y(T,P,L,J){if(P===L)He(L,T,J);else{let G=He(L,g.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type);Ga(G,$n(P,T,J))}}}function SBt(r){let a=OI(r);_oe(a,r);let _=Ao(a);if(_.flags&1)return;let d=jAe(r);if(!d?.resolvedReturnType)return;let y,T=d.resolvedReturnType;switch(r.parent.kind){case 263:case 231:y=g.Decorator_function_return_type_0_is_not_assignable_to_type_1;break;case 172:if(!se){y=g.Decorator_function_return_type_0_is_not_assignable_to_type_1;break}case 169:y=g.Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any;break;case 174:case 177:case 178:y=g.Decorator_function_return_type_0_is_not_assignable_to_type_1;break;default:return I.failBadSyntaxKind(r.parent)}J_(_,T,r.expression,y)}function GL(r,a,_,d,y,T=_.length,P=0){let L=j.createFunctionTypeNode(void 0,tt,j.createKeywordTypeNode(133));return X0(L,r,a,_,d,y,T,P)}function KAe(r,a,_,d,y,T,P){let L=GL(r,a,_,d,y,T,P);return dC(L)}function UHe(r){return KAe(void 0,void 0,tt,r)}function VHe(r){let a=Sg("value",r);return KAe(void 0,void 0,[a],fn)}function TBt(r){JHe(r&&C8(r),!1)}function JHe(r,a){if(!r)return;let _=Jp(r),d=(r.kind===80?788968:1920)|2097152,y=wc(_,_.escapedText,d,void 0,void 0,!0);if(y&&y.flags&2097152){if(yt&&Zm(y)&&!KL(du(y))&&!Bd(y))bS(y);else if(a&&fm($)&&T_($)>=5&&!Zm(y)&&!Tt(y.declarations,dT)){let T=He(r,g.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled),P=mr(y.declarations||tt,yS);P&&Ga(T,$n(P,g._0_was_imported_here,Nn(_)))}}}function LI(r){let a=QAe(r);a&&zf(a)&&JHe(a,!0)}function QAe(r){if(r)switch(r.kind){case 193:case 192:return qHe(r.types);case 194:return qHe([r.trueType,r.falseType]);case 196:case 202:return QAe(r.type);case 183:return r.typeName}}function qHe(r){let a;for(let _ of r){for(;_.kind===196||_.kind===202;)_=_.type;if(_.kind===146||!Q&&(_.kind===201&&_.literal.kind===106||_.kind===157))continue;let d=QAe(_);if(!d)return;if(a){if(!ze(a)||!ze(d)||a.escapedText!==d.escapedText)return}else a=d}return a}function Toe(r){let a=t_(r);return x0(r)?UY(a):a}function b$(r){if(!yx(r)||!Ad(r)||!r.modifiers||!oj(se,r,r.parent,r.parent.parent))return;let a=mr(r.modifiers,n_);if(a){if(se?(iu(a,8),r.kind===169&&iu(a,32)):pe<99&&(iu(a,8),eu(r)?r.name?pYe(r)&&iu(a,8388608):iu(a,8388608):wu(r)||(is(r.name)&&(pl(r)||Mv(r)||Af(r))&&iu(a,8388608),uo(r.name)&&iu(a,16777216))),$.emitDecoratorMetadata)switch(iu(a,16),r.kind){case 263:let _=I0(r);if(_)for(let P of _.parameters)LI(Toe(P));break;case 177:case 178:let d=r.kind===177?178:177,y=xc(Rn(r),d);LI(eg(r)||y&&eg(y));break;case 174:for(let P of r.parameters)LI(Toe(P));LI(lm(r));break;case 172:LI(t_(r));break;case 169:LI(Toe(r));let T=r.parent;for(let P of T.parameters)LI(Toe(P));LI(lm(T));break}for(let _ of r.modifiers)n_(_)&&SBt(_)}}function bBt(r){n(a);function a(){$He(r),Tke(r),D4(r,r.name)}}function EBt(r){r.typeExpression||He(r.name,g.JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags),r.name&&w4(r.name,g.Type_alias_name_cannot_be_0),Ba(r.typeExpression),P$(Ov(r))}function xBt(r){Ba(r.constraint);for(let a of r.typeParameters)Ba(a)}function CBt(r){Ba(r.typeExpression)}function ABt(r){Ba(r.typeExpression);let a=vT(r);if(a){let _=E9(a,pU);if(de(_)>1)for(let d=1;d<de(_);d++){let y=_[d].tagName;He(y,g._0_tag_already_specified,Nn(y))}}}function kBt(r){r.name&&D$(r.name,!0)}function PBt(r){Ba(r.typeExpression)}function NBt(r){Ba(r.typeExpression)}function DBt(r){n(a),qL(r);function a(){!r.type&&!hN(r)&&hb(r,W)}}function IBt(r){let a=vT(r);a&&rc(a)&&He(r.tagName,g.An_arrow_function_cannot_have_a_this_parameter)}function wBt(r){let a=vT(r);(!a||!eu(a)&&!wu(a))&&He(a,g.JSDoc_0_is_not_attached_to_a_class,Nn(r.tagName))}function OBt(r){let a=vT(r);if(!a||!eu(a)&&!wu(a)){He(a,g.JSDoc_0_is_not_attached_to_a_class,Nn(r.tagName));return}let _=pT(a).filter(sk);I.assert(_.length>0),_.length>1&&He(_[1],g.Class_declarations_cannot_have_more_than_one_augments_or_extends_tag);let d=zHe(r.class.expression),y=Xb(a);if(y){let T=zHe(y.expression);T&&d.escapedText!==T.escapedText&&He(d,g.JSDoc_0_1_does_not_match_the_extends_2_clause,Nn(r.tagName),Nn(d),Nn(T))}}function RBt(r){let a=X2(r);a&&G_(a)&&He(r,g.An_accessibility_modifier_cannot_be_used_with_a_private_identifier)}function zHe(r){switch(r.kind){case 80:return r;case 211:return r.name;default:return}}function $He(r){var a;b$(r),qL(r);let _=vu(r);if(r.name&&r.name.kind===167&&Q0(r.name),vI(r)){let T=Rn(r),P=r.localSymbol||T,L=(a=P.declarations)==null?void 0:a.find(J=>J.kind===r.kind&&!(J.flags&524288));r===L&&voe(P),T.parent&&voe(T)}let d=r.kind===173?void 0:r.body;if(Ba(d),BAe(r,TI(r)),n(y),gn(r)){let T=_T(r);T&&T.typeExpression&&!nAe(Ri(T.typeExpression),r)&&He(T.typeExpression.type,g.The_type_of_a_function_declaration_must_match_the_function_s_signature)}function y(){lm(r)||(sl(d)&&!T$(r)&&hb(r,W),_&1&&nm(d)&&Ao(Sm(r)))}}function HS(r){n(a);function a(){let _=Xr(r),d=md.get(_.path);d||(d=[],md.set(_.path,d)),d.push(r)}}function WHe(r,a){for(let _ of r)switch(_.kind){case 263:case 231:MBt(_,a),ZAe(_,a);break;case 312:case 267:case 241:case 269:case 248:case 249:case 250:YHe(_,a);break;case 176:case 218:case 262:case 219:case 174:case 177:case 178:_.body&&YHe(_,a),ZAe(_,a);break;case 173:case 179:case 180:case 184:case 185:case 265:case 264:ZAe(_,a);break;case 195:LBt(_,a);break;default:I.assertNever(_,"Node should not have been registered for unused identifiers check")}}function GHe(r,a,_){let d=qs(r)||r,y=LN(r)?g._0_is_declared_but_never_used:g._0_is_declared_but_its_value_is_never_read;_(r,0,$n(d,y,a))}function HL(r){return ze(r)&&Nn(r).charCodeAt(0)===95}function MBt(r,a){for(let _ of r.members)switch(_.kind){case 174:case 172:case 177:case 178:if(_.kind===178&&_.symbol.flags&32768)break;let d=Rn(_);!d.isReferenced&&(up(_,2)||W_(_)&&is(_.name))&&!(_.flags&33554432)&&a(_,0,$n(_.name,g._0_is_declared_but_its_value_is_never_read,Oi(d)));break;case 176:for(let y of _.parameters)!y.symbol.isReferenced&&ui(y,2)&&a(y,0,$n(y.name,g.Property_0_is_declared_but_its_value_is_never_read,Lc(y.symbol)));break;case 181:case 240:case 175:break;default:I.fail("Unexpected class member")}}function LBt(r,a){let{typeParameter:_}=r;eke(_)&&a(r,1,$n(r,g._0_is_declared_but_its_value_is_never_read,Nn(_.name)))}function ZAe(r,a){let _=Rn(r).declarations;if(!_||Rs(_)!==r)return;let d=Ov(r),y=new Set;for(let T of d){if(!eke(T))continue;let P=Nn(T.name),{parent:L}=T;if(L.kind!==195&&L.typeParameters.every(eke)){if(Zd(y,L)){let J=Xr(L),G=dm(L)?$X(L):WX(J,L.typeParameters),Ce=L.typeParameters.length===1?[g._0_is_declared_but_its_value_is_never_read,P]:[g.All_type_parameters_are_unused];a(T,1,Iu(J,G.pos,G.end-G.pos,...Ce))}}else a(T,1,$n(T,g._0_is_declared_but_its_value_is_never_read,P))}}function eke(r){return!(mo(r.symbol).isReferenced&262144)&&!HL(r.name)}function E$(r,a,_,d){let y=String(d(a)),T=r.get(y);T?T[1].push(_):r.set(y,[a,[_]])}function HHe(r){return ii(Gg(r),Ls)}function FBt(r){return co(r)?pm(r.parent)?!!(r.propertyName&&HL(r.name)):HL(r.name):S_(r)||(Gi(r)&&QP(r.parent.parent)||XHe(r))&&HL(r.name)}function YHe(r,a){let _=new Map,d=new Map,y=new Map;r.locals.forEach(T=>{if(!(T.flags&262144?!(T.flags&3&&!(T.isReferenced&3)):T.isReferenced||T.exportSymbol)&&T.declarations){for(let P of T.declarations)if(!FBt(P))if(XHe(P))E$(_,BBt(P),P,yo);else if(co(P)&&pm(P.parent)){let L=Rs(P.parent.elements);(P===L||!Rs(P.parent.elements).dotDotDotToken)&&E$(d,P.parent,P,yo)}else if(Gi(P)){let L=f2(P)&7,J=qs(P);(L!==4&&L!==6||!J||!HL(J))&&E$(y,P.parent,P,yo)}else{let L=T.valueDeclaration&&HHe(T.valueDeclaration),J=T.valueDeclaration&&qs(T.valueDeclaration);L&&J?!op(L,L.parent)&&!Zb(L)&&!HL(J)&&(co(P)&&cE(P.parent)?E$(d,P.parent,P,yo):a(L,1,$n(J,g._0_is_declared_but_its_value_is_never_read,Lc(T)))):GHe(P,Lc(T),a)}}}),_.forEach(([T,P])=>{let L=T.parent;if((T.name?1:0)+(T.namedBindings?T.namedBindings.kind===274?1:T.namedBindings.elements.length:0)===P.length)a(L,0,P.length===1?$n(L,g._0_is_declared_but_its_value_is_never_read,Nn(di(P).name)):$n(L,g.All_imports_in_import_declaration_are_unused));else for(let G of P)GHe(G,Nn(G.name),a)}),d.forEach(([T,P])=>{let L=HHe(T.parent)?1:0;if(T.elements.length===P.length)P.length===1&&T.parent.kind===260&&T.parent.parent.kind===261?E$(y,T.parent.parent,T.parent,yo):a(T,L,P.length===1?$n(T,g._0_is_declared_but_its_value_is_never_read,x$(di(P).name)):$n(T,g.All_destructured_elements_are_unused));else for(let J of P)a(J,L,$n(J,g._0_is_declared_but_its_value_is_never_read,x$(J.name)))}),y.forEach(([T,P])=>{if(T.declarations.length===P.length)a(T,0,P.length===1?$n(di(P).name,g._0_is_declared_but_its_value_is_never_read,x$(di(P).name)):$n(T.parent.kind===243?T.parent:T,g.All_variables_are_unused));else for(let L of P)a(L,0,$n(L,g._0_is_declared_but_its_value_is_never_read,x$(L.name)))})}function jBt(){var r;for(let a of V0)if(!((r=Rn(a))!=null&&r.isReferenced)){let _=GP(a);I.assert(Kb(_),"Only parameter declaration should be checked here");let d=$n(a.name,g._0_is_an_unused_renaming_of_1_Did_you_intend_to_use_it_as_a_type_annotation,qo(a.name),qo(a.propertyName));_.type||Ga(d,Iu(Xr(_),_.end,1,g.We_can_only_write_a_type_for_0_by_adding_a_type_for_the_entire_parameter_here,qo(a.propertyName))),fo.add(d)}}function x$(r){switch(r.kind){case 80:return Nn(r);case 207:case 206:return x$(ta(di(r.elements),co).name);default:return I.assertNever(r)}}function XHe(r){return r.kind===273||r.kind===276||r.kind===274}function BBt(r){return r.kind===273?r:r.kind===274?r.parent:r.parent.parent}function boe(r){if(r.kind===241&&c1(r),uY(r)){let a=Je;Te(r.statements,Ba),Je=a}else Te(r.statements,Ba);r.locals&&HS(r)}function UBt(r){pe>=2||!yY(r)||r.flags&33554432||sl(r.body)||Te(r.parameters,a=>{a.name&&!la(a.name)&&a.name.escapedText===$t.escapedName&&yg("noEmit",a,g.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters)})}function YL(r,a,_){if(a?.escapedText!==_||r.kind===172||r.kind===171||r.kind===174||r.kind===173||r.kind===177||r.kind===178||r.kind===303||r.flags&33554432||(Jh(r)||Ru(r)||Gf(r))&&dT(r))return!1;let d=Gg(r);return!(Ls(d)&&sl(d.parent.body))}function VBt(r){Gr(r,a=>jI(a)&4?(r.kind!==80?He(qs(r),g.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference):He(r,g.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference),!0):!1)}function JBt(r){Gr(r,a=>jI(a)&8?(r.kind!==80?He(qs(r),g.Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference):He(r,g.Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference),!0):!1)}function qBt(r,a){if(z>=5&&!(z>=100&&Xr(r).impliedNodeFormat===1)||!a||!YL(r,a,"require")&&!YL(r,a,"exports")||hl(r)&&Oy(r)!==1)return;let _=te(r);_.kind===312&&Bp(_)&&yg("noEmit",a,g.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module,qo(a),qo(a))}function zBt(r,a){if(!a||pe>=4||!YL(r,a,"Promise")||hl(r)&&Oy(r)!==1)return;let _=te(r);_.kind===312&&Bp(_)&&_.flags&4096&&yg("noEmit",a,g.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions,qo(a),qo(a))}function $Bt(r,a){pe<=8&&(YL(r,a,"WeakMap")||YL(r,a,"WeakSet"))&&fS.push(r)}function WBt(r){let a=Lh(r);jI(a)&1048576&&(I.assert(W_(r)&&ze(r.name)&&typeof r.name.escapedText=="string","The target of a WeakMap/WeakSet collision check should be an identifier"),yg("noEmit",r,g.Compiler_reserves_name_0_when_emitting_private_identifier_downlevel,r.name.escapedText))}function GBt(r,a){a&&pe>=2&&pe<=8&&YL(r,a,"Reflect")&&pS.push(r)}function HBt(r){let a=!1;if(wu(r)){for(let _ of r.members)if(jI(_)&2097152){a=!0;break}}else if(Xo(r))jI(r)&2097152&&(a=!0);else{let _=Lh(r);_&&jI(_)&2097152&&(a=!0)}a&&(I.assert(W_(r)&&ze(r.name),"The target of a Reflect collision check should be an identifier"),yg("noEmit",r,g.Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers,qo(r.name),"Reflect"))}function D4(r,a){a&&(qBt(r,a),zBt(r,a),$Bt(r,a),GBt(r,a),Ti(r)?(w4(a,g.Class_name_cannot_be_0),r.flags&33554432||bUt(a)):AT(r)&&w4(a,g.Enum_name_cannot_be_0))}function YBt(r){if(f2(r)&7||Kb(r))return;let a=Rn(r);if(a.flags&1){if(!ze(r.name))return I.fail();let _=wc(r,r.name.escapedText,3,void 0,void 0,!1);if(_&&_!==a&&_.flags&2&&_Ae(_)&7){let d=ST(_.valueDeclaration,261),y=d.parent.kind===243&&d.parent.parent?d.parent.parent:void 0;if(!(y&&(y.kind===241&&ca(y.parent)||y.kind===268||y.kind===267||y.kind===312))){let P=Oi(_);He(r,g.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1,P,P)}}}}function XL(r){return r===st?W:r===xu?bl:r}function C$(r){var a;if(b$(r),co(r)||Ba(r.type),!r.name)return;if(r.name.kind===167&&(Q0(r.name),V2(r)&&r.initializer&&xl(r.initializer)),co(r)){if(r.propertyName&&ze(r.name)&&Kb(r)&&sl(Vp(r).body)){V0.push(r);return}pm(r.parent)&&r.dotDotDotToken&&pe<5&&iu(r,4),r.propertyName&&r.propertyName.kind===167&&Q0(r.propertyName);let y=r.parent.parent,T=r.dotDotDotToken?32:0,P=Yn(y,T),L=r.propertyName||r.name;if(P&&!la(L)){let J=av(L);if(um(J)){let G=_m(J),ae=ka(P,G);ae&&(a$(ae,void 0,!1),pAe(r,!!y.initializer&&y.initializer.kind===108,!1,P,ae))}}}if(la(r.name)&&(r.name.kind===207&&pe<2&&$.downlevelIteration&&iu(r,512),Te(r.name.elements,Ba)),r.initializer&&Kb(r)&&sl(Vp(r).body)){He(r,g.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);return}if(la(r.name)){if(FCe(r))return;let y=V2(r)&&r.initializer&&r.parent.parent.kind!==249,T=!Tt(r.name.elements,J5(Su));if(y||T){let P=q(r);if(y){let L=xl(r.initializer);Q&&T?hGe(L,r):qS(L,q(r),r,r.initializer)}T&&(cE(r.name)?uv(65,P,Be,r):Q&&hGe(P,r))}return}let _=Rn(r);if(_.flags&2097152&&(Gb(r)||xde(r))){koe(r);return}let d=XL(vn(_));if(r===_.valueDeclaration){let y=V2(r)&&N8(r);if(y&&!(gn(r)&&Ha(y)&&(y.properties.length===0||zv(r.name))&&!!((a=_.exports)!=null&&a.size))&&r.parent.parent.kind!==249){let P=xl(y);qS(P,d,r,y,void 0);let L=f2(r)&7;if(L===6){let J=eMt(!0),G=Vze(!0);if(J!==$a&&G!==$a){let ae=pi([J,G,he,Be]);J_(P,ae,y,g.The_initializer_of_an_await_using_declaration_must_be_either_an_object_with_a_Symbol_asyncDispose_or_Symbol_dispose_method_or_be_null_or_undefined)}}else if(L===4){let J=Vze(!0);if(J!==$a){let G=pi([J,he,Be]);J_(P,G,y,g.The_initializer_of_a_using_declaration_must_be_either_an_object_with_a_Symbol_dispose_method_or_be_null_or_undefined)}}}_.declarations&&_.declarations.length>1&&Tt(_.declarations,T=>T!==r&&cN(T)&&!QHe(T,r))&&He(r.name,g.All_declarations_of_0_must_have_identical_modifiers,qo(r.name))}else{let y=XL(q(r));!Xt(d)&&!Xt(y)&&!n1(d,y)&&!(_.flags&67108864)&&KHe(_.valueDeclaration,d,r,y),V2(r)&&r.initializer&&qS(xl(r.initializer),y,r,r.initializer,void 0),_.valueDeclaration&&!QHe(r,_.valueDeclaration)&&He(r.name,g.All_declarations_of_0_must_have_identical_modifiers,qo(r.name))}r.kind!==172&&r.kind!==171&&(zL(r),(r.kind===260||r.kind===208)&&YBt(r),D4(r,r.name))}function KHe(r,a,_,d){let y=qs(_),T=_.kind===172||_.kind===171?g.Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2:g.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2,P=qo(y),L=He(y,T,P,Kr(a),Kr(d));r&&Ga(L,$n(r,g._0_was_also_declared_here,P))}function QHe(r,a){if(r.kind===169&&a.kind===260||r.kind===260&&a.kind===169)return!0;if(CA(r)!==CA(a))return!1;let _=1358;return DA(r,_)===DA(a,_)}function XBt(r){var a,_;(a=mn)==null||a.push(mn.Phase.Check,"checkVariableDeclaration",{kind:r.kind,pos:r.pos,end:r.end,path:r.tracingPath}),IJt(r),C$(r),(_=mn)==null||_.pop()}function KBt(r){return PJt(r),C$(r)}function Eoe(r){let a=x1(r)&7;(a===4||a===6)&&iu(r,33554432),Te(r.declarations,Ba)}function QBt(r){!ey(r)&&!xke(r.declarationList)&&wJt(r),Eoe(r.declarationList)}function ZBt(r){c1(r),Cs(r.expression)}function eUt(r){c1(r);let a=I4(r.expression);tke(r.expression,a,r.thenStatement),Ba(r.thenStatement),r.thenStatement.kind===242&&He(r.thenStatement,g.The_body_of_an_if_statement_cannot_be_the_empty_statement),Ba(r.elseStatement)}function tke(r,a,_){if(!Q)return;d(r,_);function d(T,P){for(T=Do(T),y(T,P);bn(T)&&(T.operatorToken.kind===57||T.operatorToken.kind===61);)T=Do(T.left),y(T,P)}function y(T,P){let L=eR(T)?Do(T.right):T;if(P0(L))return;if(eR(L)){d(L,P);return}let J=L===T?a:I4(L),G=Hn(L)&&bHe(L.expression);if(!bm(J,4194304)||G)return;let ae=na(J,0),Ce=!!P4(J);if(ae.length===0&&!Ce)return;let be=ze(L)?L:Hn(L)?L.name:void 0,Ye=be&&ng(be);if(!Ye&&!Ce)return;Ye&&bn(T.parent)&&rUt(T.parent,Ye)||Ye&&P&&tUt(T,P,be,Ye)||(Ce?HT(L,!0,g.This_condition_will_always_return_true_since_this_0_is_always_defined,AS(J)):He(L,g.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead))}}function tUt(r,a,_,d){return!!Qs(a,function y(T){if(ze(T)){let P=ng(T);if(P&&P===d){if(ze(r)||ze(_)&&bn(_.parent))return!0;let L=_.parent,J=T.parent;for(;L&&J;){if(ze(L)&&ze(J)||L.kind===110&&J.kind===110)return ng(L)===ng(J);if(Hn(L)&&Hn(J)){if(ng(L.name)!==ng(J.name))return!1;J=J.expression,L=L.expression}else if(da(L)&&da(J))J=J.expression,L=L.expression;else return!1}}}return Qs(T,y)})}function rUt(r,a){for(;bn(r)&&r.operatorToken.kind===56;){if(Qs(r.right,function d(y){if(ze(y)){let T=ng(y);if(T&&T===a)return!0}return Qs(y,d)}))return!0;r=r.parent}return!1}function nUt(r){c1(r),Ba(r.statement),I4(r.expression)}function iUt(r){c1(r),I4(r.expression),Ba(r.statement)}function rke(r,a){return r.flags&16384&&He(a,g.An_expression_of_type_void_cannot_be_tested_for_truthiness),r}function I4(r,a){return rke(Cs(r,a),r)}function sUt(r){c1(r)||r.initializer&&r.initializer.kind===261&&xke(r.initializer),r.initializer&&(r.initializer.kind===261?Eoe(r.initializer):Cs(r.initializer)),r.condition&&I4(r.condition),r.incrementor&&Cs(r.incrementor),Ba(r.statement),r.locals&&HS(r)}function aUt(r){YYe(r);let a=rj(r);if(r.awaitModifier?a&&Jc(a)?kr(r.awaitModifier,g.for_await_loops_cannot_be_used_inside_a_class_static_block):(vu(a)&6)===2&&pe<99&&iu(r,16384):$.downlevelIteration&&pe<2&&iu(r,256),r.initializer.kind===261)Eoe(r.initializer);else{let _=r.initializer,d=A$(r);if(_.kind===209||_.kind===210)DC(_,d||ht);else{let y=Cs(_);JL(_,g.The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access,g.The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access),d&&qS(d,y,_,r.expression)}}Ba(r.statement),r.locals&&HS(r)}function oUt(r){YYe(r);let a=dAe(Cs(r.expression));if(r.initializer.kind===261){let _=r.initializer.declarations[0];_&&la(_.name)&&He(_.name,g.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern),Eoe(r.initializer)}else{let _=r.initializer,d=Cs(_);_.kind===209||_.kind===210?He(_,g.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern):Na(VMt(a),d)?JL(_,g.The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access,g.The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access):He(_,g.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any)}(a===Qn||!c_(a,126091264))&&He(r.expression,g.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0,Kr(a)),Ba(r.statement),r.locals&&HS(r)}function A$(r){let a=r.awaitModifier?15:13;return uv(a,II(r.expression),Be,r.expression)}function uv(r,a,_,d){return wt(a)?a:nke(r,a,_,d,!0)||W}function nke(r,a,_,d,y){let T=(r&2)!==0;if(a===Qn){cke(d,a,T);return}let P=pe>=2,L=!P&&$.downlevelIteration,J=$.noUncheckedIndexedAccess&&!!(r&128);if(P||L||T){let vt=Coe(a,r,P?d:void 0);if(y&&vt){let Dt=r&8?g.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0:r&32?g.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0:r&64?g.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0:r&16?g.Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0:void 0;Dt&&J_(_,vt.nextType,d,Dt)}if(vt||P)return J?ML(vt&&vt.yieldType):vt&&vt.yieldType}let G=a,ae=!1,Ce=!1;if(r&4){if(G.flags&1048576){let vt=a.types,Dt=Fn(vt,ur=>!(ur.flags&402653316));Dt!==vt&&(G=pi(Dt,2))}else G.flags&402653316&&(G=Qn);if(Ce=G!==a,Ce&&(pe<1&&d&&(He(d,g.Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher),ae=!0),G.flags&131072))return J?ML(Le):Le}if(!cv(G)){if(d&&!ae){let vt=!!(r&4)&&!Ce,[Dt,ur]=Ye(vt,L);HT(d,ur&&!!P4(G),Dt,Kr(G))}return Ce?J?ML(Le):Le:void 0}let be=_b(G,It);if(Ce&&be)return be.flags&402653316&&!$.noUncheckedIndexedAccess?Le:pi(J?[be,Le,Be]:[be,Le],2);return r&128?ML(be):be;function Ye(vt,Dt){var ur;return Dt?vt?[g.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator,!0]:[g.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator,!0]:ike(r,0,a,void 0)?[g.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher,!1]:cUt((ur=a.symbol)==null?void 0:ur.escapedName)?[g.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher,!0]:vt?[g.Type_0_is_not_an_array_type_or_a_string_type,!0]:[g.Type_0_is_not_an_array_type,!0]}}function cUt(r){switch(r){case"Float32Array":case"Float64Array":case"Int16Array":case"Int32Array":case"Int8Array":case"NodeList":case"Uint16Array":case"Uint32Array":case"Uint8Array":case"Uint8ClampedArray":return!0}return!1}function ike(r,a,_,d){if(wt(_))return;let y=Coe(_,r,d);return y&&y[_Me(a)]}function _v(r=Qn,a=Qn,_=Sr){if(r.flags&67359327&&a.flags&180227&&_.flags&180227){let d=Tm([r,a,_]),y=Bi.get(d);return y||(y={yieldType:r,returnType:a,nextType:_},Bi.set(d,y)),y}return{yieldType:r,returnType:a,nextType:_}}function ZHe(r){let a,_,d;for(let y of r)if(!(y===void 0||y===Jn)){if(y===ia)return ia;a=Pr(a,y.yieldType),_=Pr(_,y.returnType),d=Pr(d,y.nextType)}return a||_||d?_v(a&&pi(a),_&&pi(_),d&&Pa(d)):Jn}function xoe(r,a){return r[a]}function Z0(r,a,_){return r[a]=_}function Coe(r,a,_){var d,y;if(wt(r))return ia;if(!(r.flags&1048576)){let G=_?{errors:void 0}:void 0,ae=eYe(r,a,_,G);if(ae===Jn){if(_){let Ce=cke(_,r,!!(a&2));G?.errors&&Ga(Ce,...G.errors)}return}else if((d=G?.errors)!=null&&d.length)for(let Ce of G.errors)fo.add(Ce);return ae}let T=a&2?"iterationTypesOfAsyncIterable":"iterationTypesOfIterable",P=xoe(r,T);if(P)return P===Jn?void 0:P;let L;for(let G of r.types){let ae=_?{errors:void 0}:void 0,Ce=eYe(G,a,_,ae);if(Ce===Jn){if(_){let be=cke(_,r,!!(a&2));ae?.errors&&Ga(be,...ae.errors)}Z0(r,T,Jn);return}else if((y=ae?.errors)!=null&&y.length)for(let be of ae.errors)fo.add(be);L=Pr(L,Ce)}let J=L?ZHe(L):Jn;return Z0(r,T,J),J===Jn?void 0:J}function ske(r,a){if(r===Jn)return Jn;if(r===ia)return ia;let{yieldType:_,returnType:d,nextType:y}=r;return a&&Fxe(!0),_v(IC(_,a)||W,IC(d,a)||W,y)}function eYe(r,a,_,d){if(wt(r))return ia;let y=!1;if(a&2){let T=ake(r,sc)||rYe(r,sc);if(T)if(T===Jn&&_)y=!0;else return a&8?ske(T,_):T}if(a&1){let T=ake(r,Jl)||rYe(r,Jl);if(T)if(T===Jn&&_)y=!0;else if(a&2){if(T!==Jn)return T=ske(T,_),y?T:Z0(r,"iterationTypesOfAsyncIterable",T)}else return T}if(a&2){let T=oke(r,sc,_,d,y);if(T!==Jn)return T}if(a&1){let T=oke(r,Jl,_,d,y);if(T!==Jn)return a&2?(T=ske(T,_),y?T:Z0(r,"iterationTypesOfAsyncIterable",T)):T}return Jn}function ake(r,a){return xoe(r,a.iterableCacheKey)}function tYe(r,a){let _=ake(r,a)||oke(r,a,void 0,void 0,!1);return _===Jn?bu:_}function rYe(r,a){let _;if(RS(r,_=a.getGlobalIterableType(!1))||RS(r,_=a.getGlobalIterableIteratorType(!1))){let[d]=cc(r),{returnType:y,nextType:T}=tYe(_,a);return Z0(r,a.iterableCacheKey,_v(a.resolveIterationType(d,void 0)||d,a.resolveIterationType(y,void 0)||y,T))}if(RS(r,a.getGlobalGeneratorType(!1))){let[d,y,T]=cc(r);return Z0(r,a.iterableCacheKey,_v(a.resolveIterationType(d,void 0)||d,a.resolveIterationType(y,void 0)||y,T))}}function nYe(r){let a=jze(!1),_=a&&Xe(vn(a),Pc(r));return _&&um(_)?_m(_):`__@${r}`}function oke(r,a,_,d,y){let T=ka(r,nYe(a.iteratorSymbolName)),P=T&&!(T.flags&16777216)?vn(T):void 0;if(wt(P))return y?ia:Z0(r,a.iterableCacheKey,ia);let L=P?na(P,0):void 0;if(!Tt(L))return y?Jn:Z0(r,a.iterableCacheKey,Jn);let J=Pa(vr(L,Ao)),G=iYe(J,a,_,d,y)??Jn;return y?G:Z0(r,a.iterableCacheKey,G)}function cke(r,a,_){let d=_?g.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator:g.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator,y=!!P4(a)||!_&&jR(r.parent)&&r.parent.expression===r&&aae(!1)!==$s&&Na(a,aae(!1));return HT(r,y,d,Kr(a))}function lUt(r,a,_,d){return iYe(r,a,_,d,!1)}function iYe(r,a,_,d,y){if(wt(r))return ia;let T=sYe(r,a)||uUt(r,a);return T===Jn&&_&&(T=void 0,y=!0),T??(T=oYe(r,a,_,d,y)),T===Jn?void 0:T}function sYe(r,a){return xoe(r,a.iteratorCacheKey)}function uUt(r,a){let _=a.getGlobalIterableIteratorType(!1);if(RS(r,_)){let[d]=cc(r),y=sYe(_,a)||oYe(_,a,void 0,void 0,!1),{returnType:T,nextType:P}=y===Jn?bu:y;return Z0(r,a.iteratorCacheKey,_v(d,T,P))}if(RS(r,a.getGlobalIteratorType(!1))||RS(r,a.getGlobalGeneratorType(!1))){let[d,y,T]=cc(r);return Z0(r,a.iteratorCacheKey,_v(d,y,T))}}function aYe(r,a){let _=Xe(r,"done")||Zt;return Na(a===0?Zt:zr,_)}function _Ut(r){return aYe(r,0)}function fUt(r){return aYe(r,1)}function pUt(r){if(wt(r))return ia;let a=xoe(r,"iterationTypesOfIteratorResult");if(a)return a;if(RS(r,QRt(!1))){let P=cc(r)[0];return Z0(r,"iterationTypesOfIteratorResult",_v(P,void 0,void 0))}if(RS(r,ZRt(!1))){let P=cc(r)[0];return Z0(r,"iterationTypesOfIteratorResult",_v(void 0,P,void 0))}let _=wl(r,_Ut),d=_!==Qn?Xe(_,"value"):void 0,y=wl(r,fUt),T=y!==Qn?Xe(y,"value"):void 0;return!d&&!T?Z0(r,"iterationTypesOfIteratorResult",Jn):Z0(r,"iterationTypesOfIteratorResult",_v(d,T||fn,void 0))}function lke(r,a,_,d,y){var T,P,L,J;let G=ka(r,_);if(!G&&_!=="next")return;let ae=G&&!(_==="next"&&G.flags&16777216)?_==="next"?vn(G):Em(vn(G),2097152):void 0;if(wt(ae))return _==="next"?ia:Fc;let Ce=ae?na(ae,0):tt;if(Ce.length===0){if(d){let fr=_==="next"?a.mustHaveANextMethodDiagnostic:a.mustBeAMethodDiagnostic;y?(y.errors??(y.errors=[]),y.errors.push($n(d,fr,_))):He(d,fr,_)}return _==="next"?Jn:void 0}if(ae?.symbol&&Ce.length===1){let fr=a.getGlobalGeneratorType(!1),$r=a.getGlobalIteratorType(!1),Jr=((P=(T=fr.symbol)==null?void 0:T.members)==null?void 0:P.get(_))===ae.symbol,on=!Jr&&((J=(L=$r.symbol)==null?void 0:L.members)==null?void 0:J.get(_))===ae.symbol;if(Jr||on){let Qr=Jr?fr:$r,{mapper:cn}=ae;return _v(VS(Qr.typeParameters[0],cn),VS(Qr.typeParameters[1],cn),_==="next"?VS(Qr.typeParameters[2],cn):void 0)}}let be,Ye;for(let fr of Ce)_!=="throw"&&Tt(fr.parameters)&&(be=Pr(be,Ig(fr,0))),Ye=Pr(Ye,Ao(fr));let vt,Dt;if(_!=="throw"){let fr=be?pi(be):Sr;if(_==="next")Dt=fr;else if(_==="return"){let $r=a.resolveIterationType(fr,d)||W;vt=Pr(vt,$r)}}let ur,pr=Ye?Pa(Ye):Qn,dn=a.resolveIterationType(pr,d)||W,Ur=pUt(dn);return Ur===Jn?(d&&(y?(y.errors??(y.errors=[]),y.errors.push($n(d,a.mustHaveAValueDiagnostic,_))):He(d,a.mustHaveAValueDiagnostic,_)),ur=W,vt=Pr(vt,W)):(ur=Ur.yieldType,vt=Pr(vt,Ur.returnType)),_v(ur,pi(vt),Dt)}function oYe(r,a,_,d,y){let T=ZHe([lke(r,a,"next",_,d),lke(r,a,"return",_,d),lke(r,a,"throw",_,d)]);return y?T:Z0(r,a.iteratorCacheKey,T)}function l2(r,a,_){if(wt(a))return;let d=cYe(a,_);return d&&d[_Me(r)]}function cYe(r,a){if(wt(r))return ia;let _=a?2:1,d=a?sc:Jl;return Coe(r,_,void 0)||lUt(r,d,void 0,void 0)}function dUt(r){c1(r)||kJt(r)}function k$(r,a){let _=!!(a&1),d=!!(a&2);if(_){let y=l2(1,r,d);return y?d?lv(N4(y)):y:ht}return d?lv(r)||ht:r}function lYe(r,a){let _=k$(a,vu(r));return!!(_&&($c(_,16384)||_.flags&32769))}function mUt(r){if(c1(r))return;let a=rj(r);if(a&&Jc(a)){Xu(r,g.A_return_statement_cannot_be_used_inside_a_class_static_block);return}if(!a){Xu(r,g.A_return_statement_can_only_be_used_within_a_function_body);return}let _=Sm(a),d=Ao(_),y=vu(a);if(Q||r.expression||d.flags&131072){let T=r.expression?xl(r.expression):Be;if(a.kind===178)r.expression&&He(r,g.Setters_cannot_return_a_value);else if(a.kind===176)r.expression&&!qS(T,d,r,r.expression)&&He(r,g.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);else if(TI(a)){let P=k$(d,y)??d,L=y&2?WL(T,!1,r,g.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member):T;P&&qS(L,P,r,r.expression)}}else a.kind!==176&&$.noImplicitReturns&&!lYe(a,d)&&He(r,g.Not_all_code_paths_return_a_value)}function gUt(r){c1(r)||r.flags&65536&&Xu(r,g.with_statements_are_not_allowed_in_an_async_function_block),Cs(r.expression);let a=Xr(r);if(!u2(a)){let _=Fh(a,r.pos).start,d=r.statement.pos;_2(a,_,d-_,g.The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any)}}function hUt(r){c1(r);let a,_=!1,d=Cs(r.expression);Te(r.caseBlock.clauses,y=>{y.kind===297&&!_&&(a===void 0?a=y:(kr(y,g.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement),_=!0)),y.kind===296&&n(T(y)),Te(y.statements,Ba),$.noFallthroughCasesInSwitch&&y.fallthroughFlowNode&&Yz(y.fallthroughFlowNode)&&He(y,g.Fallthrough_case_in_switch);function T(P){return()=>{let L=Cs(P.expression);qAe(d,L)||M$e(L,d,P.expression,void 0)}}}),r.caseBlock.locals&&HS(r.caseBlock)}function yUt(r){c1(r)||Gr(r.parent,a=>ca(a)?"quit":a.kind===256&&a.label.escapedText===r.label.escapedText?(kr(r.label,g.Duplicate_label_0,Fl(r.label)),!0):!1),Ba(r.statement)}function vUt(r){c1(r)||ze(r.expression)&&!r.expression.escapedText&&JJt(r,g.Line_break_not_permitted_here),r.expression&&Cs(r.expression)}function SUt(r){c1(r),boe(r.tryBlock);let a=r.catchClause;if(a){if(a.variableDeclaration){let _=a.variableDeclaration;C$(_);let d=t_(_);if(d){let y=Ri(d);y&&!(y.flags&3)&&Xu(d,g.Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified)}else if(_.initializer)Xu(_.initializer,g.Catch_clause_variable_cannot_have_an_initializer);else{let y=a.block.locals;y&&Mh(a.locals,T=>{let P=y.get(T);P?.valueDeclaration&&P.flags&2&&kr(P.valueDeclaration,g.Cannot_redeclare_identifier_0_in_catch_clause,Zi(T))})}}boe(a.block)}r.finallyBlock&&boe(r.finallyBlock)}function Aoe(r,a,_){let d=nf(r);if(d.length===0)return;for(let T of LS(r))_&&T.flags&4194304||uYe(r,T,CI(T,8576,!0),OS(T));let y=a.valueDeclaration;if(y&&Ti(y)){for(let T of y.members)if(!pa(T)&&!vI(T)){let P=Rn(T);uYe(r,P,l_(T.name.expression),OS(P))}}if(d.length>1)for(let T of d)TUt(r,T)}function uYe(r,a,_,d){let y=a.valueDeclaration,T=qs(y);if(T&&is(T))return;let P=vxe(r,_),L=Gn(r)&2?xc(r.symbol,264):void 0,J=y&&y.kind===226||T&&T.kind===167?y:void 0,G=yf(a)===r.symbol?y:void 0;for(let ae of P){let Ce=ae.declaration&&yf(Rn(ae.declaration))===r.symbol?ae.declaration:void 0,be=G||Ce||(L&&!Tt(Cp(r),Ye=>!!ub(Ye,a.escapedName)&&!!_b(Ye,ae.keyType))?L:void 0);if(be&&!Na(d,ae.type)){let Ye=Ux(be,g.Property_0_of_type_1_is_not_assignable_to_2_index_type_3,Oi(a),Kr(d),Kr(ae.keyType),Kr(ae.type));J&&be!==J&&Ga(Ye,$n(J,g._0_is_declared_here,Oi(a))),fo.add(Ye)}}}function TUt(r,a){let _=a.declaration,d=vxe(r,a.keyType),y=Gn(r)&2?xc(r.symbol,264):void 0,T=_&&yf(Rn(_))===r.symbol?_:void 0;for(let P of d){if(P===a)continue;let L=P.declaration&&yf(Rn(P.declaration))===r.symbol?P.declaration:void 0,J=T||L||(y&&!Tt(Cp(r),G=>!!K0(G,a.keyType)&&!!_b(G,P.keyType))?y:void 0);J&&!Na(a.type,P.type)&&He(J,g._0_index_type_1_is_not_assignable_to_2_index_type_3,Kr(a.keyType),Kr(a.type),Kr(P.keyType),Kr(P.type))}}function w4(r,a){switch(r.escapedText){case"any":case"unknown":case"never":case"number":case"bigint":case"boolean":case"string":case"symbol":case"void":case"object":He(r,a,r.escapedText)}}function bUt(r){pe>=1&&r.escapedText==="Object"&&(z<5||Xr(r).impliedNodeFormat===1)&&He(r,g.Class_name_cannot_be_Object_when_targeting_ES5_with_module_0,vw[z])}function EUt(r){let a=Fn(pT(r),mg);if(!de(a))return;let _=gn(r),d=new Set,y=new Set;if(Te(r.parameters,({name:P},L)=>{ze(P)&&d.add(P.escapedText),la(P)&&y.add(L)}),Txe(r)){let P=a.length-1,L=a[P];_&&L&&ze(L.name)&&L.typeExpression&&L.typeExpression.type&&!d.has(L.name.escapedText)&&!y.has(P)&&!Gd(Ri(L.typeExpression.type))&&He(L.name,g.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type,Nn(L.name))}else Te(a,({name:P,isNameFirst:L},J)=>{y.has(J)||ze(P)&&d.has(P.escapedText)||(pf(P)?_&&He(P,g.Qualified_name_0_is_not_allowed_without_a_leading_param_object_1,cp(P),cp(P.left)):L||Yu(_,P,g.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name,Nn(P)))})}function P$(r){let a=!1;if(r)for(let d=0;d<r.length;d++){let y=r[d];PHe(y),n(_(y,d))}function _(d,y){return()=>{d.default?(a=!0,xUt(d.default,r,y)):a&&He(d,g.Required_type_parameters_may_not_follow_optional_type_parameters);for(let T=0;T<y;T++)r[T].symbol===d.symbol&&He(d.name,g.Duplicate_identifier_0,qo(d.name))}}}function xUt(r,a,_){d(r);function d(y){if(y.kind===183){let T=Ixe(y);if(T.flags&262144)for(let P=_;P<a.length;P++)T.symbol===Rn(a[P])&&He(y,g.Type_parameter_defaults_can_only_reference_previously_declared_type_parameters)}Qs(y,d)}}function _Ye(r){if(r.declarations&&r.declarations.length===1)return;let a=as(r);if(!a.typeParametersChecked){a.typeParametersChecked=!0;let _=wUt(r);if(!_||_.length<=1)return;let d=dc(r);if(!fYe(_,d.localTypeParameters,Ov)){let y=Oi(r);for(let T of _)He(T.name,g.All_declarations_of_0_must_have_identical_type_parameters,y)}}}function fYe(r,a,_){let d=de(a),y=a0(a);for(let T of r){let P=_(T),L=P.length;if(L<y||L>d)return!1;for(let J=0;J<L;J++){let G=P[J],ae=a[J];if(G.name.escapedText!==ae.symbol.escapedName)return!1;let Ce=YP(G),be=Ce&&Ri(Ce),Ye=Sf(ae);if(be&&Ye&&!n1(be,Ye))return!1;let vt=G.default&&Ri(G.default),Dt=pC(ae);if(vt&&Dt&&!n1(vt,Dt))return!1}}return!0}function pYe(r){let a=!se&&pe<99&&k1(!1,r),_=pe<=9,d=!xe;if(a||_)for(let y of r.members){if(a&&JY(!1,y,r))return qi(wv(r))??r;if(_){if(Jc(y))return y;if(pa(y)&&(G_(y)||d&&bM(y)))return y}}}function CUt(r){if(r.name)return;let a=$ge(r);if(!oX(a))return;let _=!se&&pe<99,d;_&&k1(!1,r)?d=qi(wv(r))??r:d=pYe(r),d&&(iu(d,8388608),(Ul(a)||ea(a)||co(a))&&uo(a.name)&&iu(d,16777216))}function AUt(r){return dYe(r),_P(r),CUt(r),vn(Rn(r))}function kUt(r){Te(r.members,Ba),HS(r)}function PUt(r){let a=mr(r.modifiers,n_);se&&a&&Tt(r.members,_=>jl(_)&&G_(_))&&kr(a,g.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator),!r.name&&!ui(r,2048)&&Xu(r,g.A_class_declaration_without_the_default_modifier_must_have_a_name),dYe(r),Te(r.members,Ba),HS(r)}function dYe(r){fJt(r),b$(r),D4(r,r.name),P$(Ov(r)),zL(r);let a=Rn(r),_=dc(a),d=Hp(_),y=vn(a);_Ye(a),voe(a),qjt(r),!!(r.flags&33554432)||zjt(r);let P=$g(r);if(P){Te(P.typeArguments,Ba),pe<2&&iu(P.parent,1);let G=Xb(r);G&&G!==P&&Cs(G.expression);let ae=Cp(_);ae.length&&n(()=>{let Ce=ae[0],be=xp(_),Ye=Tf(be);if(DUt(Ye,P),Ba(P.expression),Tt(P.typeArguments)){Te(P.typeArguments,Ba);for(let Dt of V_(Ye,P.typeArguments,P))if(!MHe(P,Dt.typeParameters))break}let vt=Hp(Ce,_.thisType);if(J_(d,vt,void 0)?J_(y,N$e(Ye),r.name||r,g.Class_static_side_0_incorrectly_extends_base_class_static_side_1):hYe(r,d,vt,g.Class_0_incorrectly_extends_base_class_1),be.flags&8650752&&(Ji(y)?na(be,1).some(ur=>ur.flags&4)&&!ui(r,64)&&He(r.name||r,g.A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract):He(r.name||r,g.A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any)),!(Ye.symbol&&Ye.symbol.flags&32)&&!(be.flags&8650752)){let Dt=i0(Ye,P.typeArguments,P);Te(Dt,ur=>!Sh(ur.declaration)&&!n1(Ao(ur),Ce))&&He(P.expression,g.Base_constructors_must_all_have_the_same_return_type)}OUt(_,Ce)})}NUt(r,_,d,y);let L=SN(r);if(L)for(let G of L)(!ol(G.expression)||w_(G.expression))&&He(G.expression,g.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments),XAe(G),n(J(G));n(()=>{Aoe(_,a),Aoe(y,a,!0),GAe(r),LUt(r)});function J(G){return()=>{let ae=Pg(Ri(G));if(!Xt(ae))if(dz(ae)){let Ce=ae.symbol&&ae.symbol.flags&32?g.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass:g.Class_0_incorrectly_implements_interface_1,be=Hp(ae,_.thisType);J_(d,be,void 0)||hYe(r,d,be,Ce)}else He(G,g.A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members)}}}function NUt(r,a,_,d){let T=$g(r)&&Cp(a),P=T?.length?Hp(di(T),a.thisType):void 0,L=xp(a);for(let J of r.members)TX(J)||(Yc(J)&&Te(J.parameters,G=>{op(G,J)&&mYe(r,d,L,P,a,_,G,!0)}),mYe(r,d,L,P,a,_,J,!1))}function mYe(r,a,_,d,y,T,P,L,J=!0){let G=P.name&&ng(P.name)||ng(P);return G?gYe(r,a,_,d,y,T,wj(P),tE(P),pa(P),L,Lc(G),J?P:void 0):0}function gYe(r,a,_,d,y,T,P,L,J,G,ae,Ce){let be=gn(r),Ye=!!(r.flags&33554432);if(d&&(P||$.noImplicitOverride)){let vt=Pc(ae),Dt=J?a:T,ur=J?_:d,pr=ka(Dt,vt),dn=ka(ur,vt),Ur=Kr(d);if(pr&&!dn&&P){if(Ce){let fr=CGe(ae,ur);fr?He(Ce,be?g.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1:g.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1,Ur,Oi(fr)):He(Ce,be?g.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0:g.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0,Ur)}return 2}else if(pr&&dn?.declarations&&$.noImplicitOverride&&!Ye){let fr=Tt(dn.declarations,tE);if(P)return 0;if(fr){if(L&&fr)return Ce&&He(Ce,g.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0,Ur),1}else{if(Ce){let $r=G?be?g.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0:g.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0:be?g.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0:g.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0;He(Ce,$r,Ur)}return 1}}}else if(P){if(Ce){let vt=Kr(y);He(Ce,be?g.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class:g.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class,vt)}return 2}return 0}function hYe(r,a,_,d){let y=!1;for(let T of r.members){if(pa(T))continue;let P=T.name&&ng(T.name)||ng(T);if(P){let L=ka(a,P.escapedName),J=ka(_,P.escapedName);if(L&&J){let G=()=>Xs(void 0,g.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2,Oi(P),Kr(a),Kr(_));J_(vn(L),vn(J),T.name||T,void 0,G)||(y=!0)}}}y||J_(a,_,r.name||r,d)}function DUt(r,a){let _=na(r,1);if(_.length){let d=_[0].declaration;if(d&&up(d,2)){let y=ky(r.symbol);mke(a,y)||He(a,g.Cannot_extend_a_class_0_Class_constructor_is_marked_as_private,Wp(r.symbol))}}}function IUt(r,a,_){if(!a.name)return 0;let d=Rn(r),y=dc(d),T=Hp(y),P=vn(d),J=$g(r)&&Cp(y),G=J?.length?Hp(di(J),y.thisType):void 0,ae=xp(y),Ce=a.parent?wj(a):ui(a,16);return gYe(r,P,ae,G,y,T,Ce,tE(a),pa(a),!1,Lc(_))}function FI(r){return Vc(r)&1?r.links.target:r}function wUt(r){return Fn(r.declarations,a=>a.kind===263||a.kind===264)}function OUt(r,a){var _,d,y,T;let P=Io(a),L;e:for(let J of P){let G=FI(J);if(G.flags&4194304)continue;let ae=ub(r,G.escapedName);if(!ae)continue;let Ce=FI(ae),be=Nd(G);if(I.assert(!!Ce,"derived should point to something, even if it is the base class' declaration."),Ce===G){let Ye=ky(r.symbol);if(be&64&&(!Ye||!ui(Ye,64))){for(let vt of Cp(r)){if(vt===a)continue;let Dt=ub(vt,G.escapedName),ur=Dt&&FI(Dt);if(ur&&ur!==G)continue e}L||(L=He(Ye,g.Non_abstract_class_0_does_not_implement_all_abstract_members_of_1,Kr(r),Kr(a))),Ye.kind===231?Ga(L,$n(J.valueDeclaration??(J.declarations&&di(J.declarations))??Ye,g.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1,Oi(J),Kr(a))):Ga(L,$n(J.valueDeclaration??(J.declarations&&di(J.declarations))??Ye,g.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2,Kr(r),Oi(J),Kr(a)))}}else{let Ye=Nd(Ce);if(be&2||Ye&2)continue;let vt,Dt=G.flags&98308,ur=Ce.flags&98308;if(Dt&&ur){if((Vc(G)&6?(_=G.declarations)!=null&&_.some(Ur=>yYe(Ur,be)):(d=G.declarations)!=null&&d.every(Ur=>yYe(Ur,be)))||Vc(G)&262144||Ce.valueDeclaration&&bn(Ce.valueDeclaration))continue;let pr=Dt!==4&&ur===4;if(pr||Dt===4&&ur!==4){let Ur=pr?g._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property:g._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor;He(qs(Ce.valueDeclaration)||Ce.valueDeclaration,Ur,Oi(G),Kr(a),Kr(r))}else if(Se){let Ur=(y=Ce.declarations)==null?void 0:y.find(fr=>fr.kind===172&&!fr.initializer);if(Ur&&!(Ce.flags&33554432)&&!(be&64)&&!(Ye&64)&&!((T=Ce.declarations)!=null&&T.some(fr=>!!(fr.flags&33554432)))){let fr=Gy(ky(r.symbol)),$r=Ur.name;if(Ur.exclamationToken||!fr||!ze($r)||!Q||!SYe($r,r,fr)){let Jr=g.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration;He(qs(Ce.valueDeclaration)||Ce.valueDeclaration,Jr,Oi(G),Kr(a))}}}continue}else if(fAe(G)){if(fAe(Ce)||Ce.flags&4)continue;I.assert(!!(Ce.flags&98304)),vt=g.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor}else G.flags&98304?vt=g.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function:vt=g.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function;He(qs(Ce.valueDeclaration)||Ce.valueDeclaration,vt,Kr(a),Oi(G),Kr(r))}}}function yYe(r,a){return a&64&&(!ea(r)||!r.initializer)||ef(r.parent)}function RUt(r,a,_){if(!de(a))return _;let d=new Map;Te(_,y=>{d.set(y.escapedName,y)});for(let y of a){let T=Io(Hp(y,r.thisType));for(let P of T){let L=d.get(P.escapedName);L&&P.parent===L.parent&&d.delete(P.escapedName)}}return In(d.values())}function MUt(r,a){let _=Cp(r);if(_.length<2)return!0;let d=new Map;Te(rxe(r).declaredProperties,T=>{d.set(T.escapedName,{prop:T,containingType:r})});let y=!0;for(let T of _){let P=Io(Hp(T,r.thisType));for(let L of P){let J=d.get(L.escapedName);if(!J)d.set(L.escapedName,{prop:L,containingType:T});else if(J.containingType!==r&&!G7t(J.prop,L)){y=!1;let ae=Kr(J.containingType),Ce=Kr(T),be=Xs(void 0,g.Named_property_0_of_types_1_and_2_are_not_identical,Oi(L),ae,Ce);be=Xs(be,g.Interface_0_cannot_simultaneously_extend_types_1_and_2,Kr(r),ae,Ce),fo.add(Ey(Xr(a),a,be))}}}return y}function LUt(r){if(!Q||!we||r.flags&33554432)return;let a=Gy(r);for(let _ of r.members)if(!(X_(_)&128)&&!pa(_)&&vYe(_)){let d=_.name;if(ze(d)||is(d)||uo(d)){let y=vn(Rn(_));y.flags&3||p4(y)||(!a||!SYe(d,y,a))&&He(_.name,g.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor,qo(d))}}}function vYe(r){return r.kind===172&&!tE(r)&&!r.exclamationToken&&!r.initializer}function FUt(r,a,_,d,y){for(let T of _)if(T.pos>=d&&T.pos<=y){let P=j.createPropertyAccessExpression(j.createThis(),r);io(P.expression,P),io(P,T),P.flowNode=T.returnFlowNode;let L=GS(P,a,$S(a));if(!p4(L))return!0}return!1}function SYe(r,a,_){let d=uo(r)?j.createElementAccessExpression(j.createThis(),r.expression):j.createPropertyAccessExpression(j.createThis(),r);io(d.expression,d),io(d,_),d.flowNode=_.returnFlowNode;let y=GS(d,a,$S(a));return!p4(y)}function jUt(r){ey(r)||vJt(r),P$(r.typeParameters),n(()=>{w4(r.name,g.Interface_name_cannot_be_0),zL(r);let a=Rn(r);_Ye(a);let _=xc(a,264);if(r===_){let d=dc(a),y=Hp(d);if(MUt(d,r.name)){for(let T of Cp(d))J_(y,Hp(T,d.thisType),r.name,g.Interface_0_incorrectly_extends_interface_1);Aoe(d,a)}}IHe(r)}),Te(Xw(r),a=>{(!ol(a.expression)||w_(a.expression))&&He(a.expression,g.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments),XAe(a)}),Te(r.members,Ba),n(()=>{GAe(r),HS(r)})}function BUt(r){ey(r),w4(r.name,g.Type_alias_name_cannot_be_0),zL(r),P$(r.typeParameters),r.type.kind===141?(!ZU.has(r.name.escapedText)||de(r.typeParameters)!==1)&&He(r.type,g.The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types):(Ba(r.type),HS(r))}function TYe(r){let a=_i(r);if(!(a.flags&1024)){a.flags|=1024;let _=0;for(let d of r.members){let y=UUt(d,_);_i(d).enumMemberValue=y,_=typeof y=="number"?y+1:void 0}}}function UUt(r,a){if(h8(r.name))He(r.name,g.Computed_property_names_are_not_allowed_in_enums);else{let _=iN(r.name);R0(_)&&!E6(_)&&He(r.name,g.An_enum_member_cannot_have_a_numeric_name)}if(r.initializer)return VUt(r);if(!(r.parent.flags&33554432&&!zb(r.parent))){if(a!==void 0)return a;He(r.name,g.Enum_member_must_have_initializer)}}function VUt(r){let a=zb(r.parent),_=r.initializer,d=O4(_,r);return d!==void 0?a&&typeof d=="number"&&!isFinite(d)&&He(_,isNaN(d)?g.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN:g.const_enum_member_initializer_was_evaluated_to_a_non_finite_value):a?He(_,g.const_enum_member_initializers_must_be_constant_expressions):r.parent.flags&33554432?He(_,g.In_ambient_enum_declarations_member_initializer_must_be_constant_expression):J_(Cs(_),It,_,g.Type_0_is_not_assignable_to_type_1_as_required_for_computed_enum_member_values),d}function O4(r,a){switch(r.kind){case 224:let _=O4(r.operand,a);if(typeof _=="number")switch(r.operator){case 40:return _;case 41:return-_;case 55:return~_}break;case 226:let d=O4(r.left,a),y=O4(r.right,a);if(typeof d=="number"&&typeof y=="number")switch(r.operatorToken.kind){case 52:return d|y;case 51:return d&y;case 49:return d>>y;case 50:return d>>>y;case 48:return d<<y;case 53:return d^y;case 42:return d*y;case 44:return d/y;case 40:return d+y;case 41:return d-y;case 45:return d%y;case 43:return d**y}else if((typeof d=="string"||typeof d=="number")&&(typeof y=="string"||typeof y=="number")&&r.operatorToken.kind===40)return""+d+y;break;case 11:case 15:return r.text;case 228:return EYe(r,a);case 9:return Cke(r),+r.text;case 217:return O4(r.expression,a);case 80:{let P=r;if(E6(P.escapedText)&&ac(P,111551,!0)===_4(P.escapedText,111551,void 0))return+P.escapedText}case 211:if(ol(r)){let P=ac(r,111551,!0);if(P){if(P.flags&8)return a?bYe(r,P,a):BI(P.valueDeclaration);if(b4(P)){let L=P.valueDeclaration;if(L&&Gi(L)&&!L.type&&L.initializer&&(!a||L!==a&&qy(L,a)))return O4(L.initializer,L)}}}break;case 212:let T=r.expression;if(ol(T)&&bo(r.argumentExpression)){let P=ac(T,111551,!0);if(P&&P.flags&384){let L=Pc(r.argumentExpression.text),J=P.exports.get(L);if(J)return a?bYe(r,J,a):BI(J.valueDeclaration)}}break}}function bYe(r,a,_){let d=a.valueDeclaration;if(!d||d===_){He(r,g.Property_0_is_used_before_being_assigned,Oi(a));return}return qy(d,_)?BI(d):(He(r,g.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums),0)}function EYe(r,a){let _=r.head.text;for(let d of r.templateSpans){let y=O4(d.expression,a);if(y===void 0)return;_+=y,_+=d.literal.text}return _}function JUt(r){n(()=>qUt(r))}function qUt(r){ey(r),D4(r,r.name),zL(r),r.members.forEach(zUt),TYe(r);let a=Rn(r),_=xc(a,r.kind);if(r===_){if(a.declarations&&a.declarations.length>1){let y=zb(r);Te(a.declarations,T=>{AT(T)&&zb(T)!==y&&He(qs(T),g.Enum_declarations_must_all_be_const_or_non_const)})}let d=!1;Te(a.declarations,y=>{if(y.kind!==266)return!1;let T=y;if(!T.members.length)return!1;let P=T.members[0];P.initializer||(d?He(P.name,g.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element):d=!0)})}}function zUt(r){is(r.name)&&He(r,g.An_enum_member_cannot_be_named_with_a_private_identifier),r.initializer&&Cs(r.initializer)}function $Ut(r){let a=r.declarations;if(a){for(let _ of a)if((_.kind===263||_.kind===262&&nm(_.body))&&!(_.flags&33554432))return _}}function WUt(r,a){let _=Lh(r),d=Lh(a);return Kh(_)?Kh(d):Kh(d)?!1:_===d}function GUt(r){r.body&&(Ba(r.body),zg(r)||HS(r)),n(a);function a(){var _,d;let y=zg(r),T=r.flags&33554432;y&&!T&&He(r.name,g.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);let P=S_(r),L=P?g.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file:g.A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module;if(N$(r,L))return;ey(r)||!T&&r.name.kind===11&&kr(r.name,g.Only_ambient_modules_can_use_quoted_names),ze(r.name)&&D4(r,r.name),zL(r);let J=Rn(r);if(J.flags&512&&!T&&QQ(r,aE($))){if(fm($)&&!Xr(r).externalModuleIndicator&&He(r.name,g.Namespaces_are_not_allowed_in_global_script_files_when_0_is_enabled_If_this_file_is_not_intended_to_be_a_global_script_set_moduleDetection_to_force_or_add_an_empty_export_statement,Ze),((_=J.declarations)==null?void 0:_.length)>1){let G=$Ut(J);G&&(Xr(r)!==Xr(G)?He(r.name,g.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged):r.pos<G.pos&&He(r.name,g.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged));let ae=xc(J,263);ae&&WUt(r,ae)&&(_i(r).flags|=2048)}if($.verbatimModuleSyntax&&r.parent.kind===312&&(z===1||r.parent.impliedNodeFormat===1)){let G=(d=r.modifiers)==null?void 0:d.find(ae=>ae.kind===95);G&&He(G,g.A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled)}}if(P)if(qb(r)){if((y||Rn(r).flags&33554432)&&r.body)for(let ae of r.body.statements)uke(ae,y)}else Kh(r.parent)?y?He(r.name,g.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations):Nu(om(r.name))&&He(r.name,g.Ambient_module_declaration_cannot_specify_relative_module_name):y?He(r.name,g.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations):He(r.name,g.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces)}}function uke(r,a){switch(r.kind){case 243:for(let d of r.declarationList.declarations)uke(d,a);break;case 277:case 278:Xu(r,g.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);break;case 271:case 272:Xu(r,g.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);break;case 208:case 260:let _=r.name;if(la(_)){for(let d of _.elements)uke(d,a);break}case 263:case 266:case 262:case 264:case 267:case 265:if(a)return;break}}function HUt(r){switch(r.kind){case 80:return r;case 166:do r=r.left;while(r.kind!==80);return r;case 211:do{if(P0(r.expression)&&!is(r.name))return r.name;r=r.expression}while(r.kind!==80);return r}}function _ke(r){let a=mN(r);if(!a||sl(a))return!1;if(!za(a))return He(a,g.String_literal_expected),!1;let _=r.parent.kind===268&&S_(r.parent.parent);if(r.parent.kind!==312&&!_)return He(a,r.kind===278?g.Export_declarations_are_not_permitted_in_a_namespace:g.Import_declarations_in_a_namespace_cannot_reference_a_module),!1;if(_&&Nu(a.text)&&!PS(r))return He(r,g.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name),!1;if(!Ru(r)&&r.attributes){let d=r.attributes.token===118?g.Import_attribute_values_must_be_string_literal_expressions:g.Import_assertion_values_must_be_string_literal_expressions,y=!1;for(let T of r.attributes.elements)za(T.value)||(y=!0,He(T.value,d));return!y}return!0}function koe(r){var a,_,d,y;let T=Rn(r),P=du(T);if(P!==dt){if(T=mo(T.exportSymbol||T),gn(r)&&!(P.flags&111551)&&!dT(r)){let G=hA(r)?r.propertyName||r.name:W_(r)?r.name:r;if(I.assert(r.kind!==280),r.kind===281){let ae=He(G,g.Types_cannot_appear_in_export_declarations_in_JavaScript_files),Ce=(_=(a=Xr(r).symbol)==null?void 0:a.exports)==null?void 0:_.get((r.propertyName||r.name).escapedText);if(Ce===P){let be=(d=Ce.declarations)==null?void 0:d.find(ZP);be&&Ga(ae,$n(be,g._0_is_automatically_exported_here,Zi(Ce.escapedName)))}}else{I.assert(r.kind!==260);let ae=Gr(r,cg(uu,Ru)),Ce=(ae&&((y=dN(ae))==null?void 0:y.text))??"...",be=Zi(ze(G)?G.escapedText:T.escapedName);He(G,g._0_is_a_type_and_cannot_be_imported_in_JavaScript_files_Use_1_in_a_JSDoc_type_annotation,be,`import("${Ce}").${be}`)}return}let L=a_(P),J=(T.flags&1160127?111551:0)|(T.flags&788968?788968:0)|(T.flags&1920?1920:0);if(L&J){let G=r.kind===281?g.Export_declaration_conflicts_with_exported_declaration_of_0:g.Import_declaration_conflicts_with_local_declaration_of_0;He(r,G,Oi(T))}else r.kind!==281&&$.isolatedModules&&!Gr(r,dT)&&T.flags&1160127&&He(r,g.Import_0_conflicts_with_local_value_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled,Oi(T),Ze);if(fm($)&&!dT(r)&&!(r.flags&33554432)){let G=Bd(T),ae=!(L&111551);if(ae||G)switch(r.kind){case 273:case 276:case 271:{if($.preserveValueImports||$.verbatimModuleSyntax){I.assertIsDefined(r.name,"An ImportClause with a symbol should have a name");let Ce=$.verbatimModuleSyntax&&fN(r)?g.An_import_alias_cannot_resolve_to_a_type_or_type_only_declaration_when_verbatimModuleSyntax_is_enabled:ae?$.verbatimModuleSyntax?g._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled:g._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled:$.verbatimModuleSyntax?g._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled:g._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled,be=Nn(r.kind===276&&r.propertyName||r.name);J0(He(r,Ce,be),ae?void 0:G,be)}ae&&r.kind===271&&up(r,32)&&He(r,g.Cannot_use_export_import_on_a_type_or_type_only_namespace_when_0_is_enabled,Ze);break}case 281:if($.verbatimModuleSyntax||Xr(G)!==Xr(r)){let Ce=Nn(r.propertyName||r.name),be=ae?He(r,g.Re_exporting_a_type_when_0_is_enabled_requires_using_export_type,Ze):He(r,g._0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_1_is_enabled,Ce,Ze);J0(be,ae?void 0:G,Ce);break}}$.verbatimModuleSyntax&&r.kind!==271&&!gn(r)&&(z===1||Xr(r).impliedNodeFormat===1)&&He(r,g.ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled)}if(Gf(r)){let G=fke(T,r);mS(G)&&G.declarations&&Q1(r,G.declarations,G.escapedName)}}}function fke(r,a){if(!(r.flags&2097152)||mS(r)||!Xm(r))return r;let _=du(r);if(_===dt)return _;for(;r.flags&2097152;){let d=aAe(r);if(d){if(d===_)break;if(d.declarations&&de(d.declarations))if(mS(d)){Q1(a,d.declarations,d.escapedName);break}else{if(r===_)break;r=d}}else break}return _}function Poe(r){D4(r,r.name),koe(r),r.kind===276&&Nn(r.propertyName||r.name)==="default"&&Bh($)&&z!==4&&(z<5||Xr(r).impliedNodeFormat===1)&&iu(r,131072)}function xYe(r){var a;let _=r.attributes;if(_){let d=Rxe(!0);d!==$a&&J_(fe(_),Jz(d,32768),_);let y=VZ(r),T=fD(_,y?kr:void 0),P=r.attributes.token===118;if(y&&T)return;if((z===199&&r.moduleSpecifier&&_s(r.moduleSpecifier))!==99&&z!==99&&z!==200){let J=P?z===199?g.Import_attributes_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls:g.Import_attributes_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve:z===199?g.Import_assertions_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls:g.Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve;return kr(_,J)}if(uu(r)?(a=r.importClause)!=null&&a.isTypeOnly:r.isTypeOnly)return kr(_,P?g.Import_attributes_cannot_be_used_with_type_only_imports_or_exports:g.Import_assertions_cannot_be_used_with_type_only_imports_or_exports);if(T)return kr(_,g.resolution_mode_can_only_be_set_for_type_only_imports)}}function YUt(r){return af(xl(r.value))}function XUt(r){if(!N$(r,gn(r)?g.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module:g.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)){if(!ey(r)&&Ij(r)&&Xu(r,g.An_import_declaration_cannot_have_modifiers),_ke(r)){let a=r.importClause;a&&!zJt(a)&&(a.name&&Poe(a),a.namedBindings&&(a.namedBindings.kind===274?(Poe(a.namedBindings),z!==4&&(z<5||Xr(r).impliedNodeFormat===1)&&Bh($)&&iu(r,65536)):rf(r,r.moduleSpecifier)&&Te(a.namedBindings.elements,Poe)))}xYe(r)}}function KUt(r){if(!N$(r,gn(r)?g.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module:g.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)&&(ey(r),fN(r)||_ke(r)))if(Poe(r),ui(r,32)&&TS(r),r.moduleReference.kind!==283){let a=du(Rn(r));if(a!==dt){let _=a_(a);if(_&111551){let d=Jp(r.moduleReference);ac(d,112575).flags&1920||He(d,g.Module_0_is_hidden_by_a_local_declaration_with_the_same_name,qo(d))}_&788968&&w4(r.name,g.Import_name_cannot_be_0)}r.isTypeOnly&&kr(r,g.An_import_alias_cannot_use_import_type)}else z>=5&&z!==200&&Xr(r).impliedNodeFormat===void 0&&!r.isTypeOnly&&!(r.flags&33554432)&&kr(r,g.Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead)}function QUt(r){if(!N$(r,gn(r)?g.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module:g.An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)){if(!ey(r)&&Xde(r)&&Xu(r,g.An_export_declaration_cannot_have_modifiers),r.moduleSpecifier&&r.exportClause&&wd(r.exportClause)&&de(r.exportClause.elements)&&pe===0&&iu(r,4194304),ZUt(r),!r.moduleSpecifier||_ke(r))if(r.exportClause&&!qh(r.exportClause)){Te(r.exportClause.elements,sVt);let a=r.parent.kind===268&&S_(r.parent.parent),_=!a&&r.parent.kind===268&&!r.moduleSpecifier&&r.flags&33554432;r.parent.kind!==312&&!a&&!_&&He(r,g.Export_declarations_are_not_permitted_in_a_namespace)}else{let a=rf(r,r.moduleSpecifier);a&&tv(a)?He(r.moduleSpecifier,g.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk,Oi(a)):r.exportClause&&koe(r.exportClause),z!==4&&(z<5||Xr(r).impliedNodeFormat===1)&&(r.exportClause?Bh($)&&iu(r,65536):iu(r,32768))}xYe(r)}}function ZUt(r){var a;return r.isTypeOnly&&((a=r.exportClause)==null?void 0:a.kind)===279?rXe(r.exportClause):!1}function N$(r,a){let _=r.parent.kind===312||r.parent.kind===268||r.parent.kind===267;return _||Xu(r,a),!_}function eVt(r){return hj(r,a=>!!Rn(a).isReferenced)}function tVt(r){return hj(r,a=>!!as(Rn(a)).constEnumReferenced)}function rVt(r){return uu(r)&&r.importClause&&!r.importClause.isTypeOnly&&eVt(r.importClause)&&!Roe(r.importClause,!0)&&!tVt(r.importClause)}function nVt(r){return Ru(r)&&zh(r.moduleReference)&&!r.isTypeOnly&&Rn(r).isReferenced&&!Roe(r,!1)&&!as(Rn(r)).constEnumReferenced}function iVt(r){if(yt)for(let a of r.statements)(rVt(a)||nVt(a))&&He(a,g.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error)}function sVt(r){if(koe(r),Dd($)&&t4(r.propertyName||r.name,!0),r.parent.parent.moduleSpecifier)Bh($)&&z!==4&&(z<5||Xr(r).impliedNodeFormat===1)&&Nn(r.propertyName||r.name)==="default"&&iu(r,131072);else{let a=r.propertyName||r.name,_=wc(a,a.escapedText,2998271,void 0,void 0,!0);if(_&&(_===$e||_===at||_.declarations&&Kh(te(_.declarations[0]))))He(a,g.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module,Nn(a));else{!r.isTypeOnly&&!r.parent.parent.isTypeOnly&&TS(r);let d=_&&(_.flags&2097152?du(_):_);(!d||a_(d)&111551)&&xl(r.propertyName||r.name)}}}function aVt(r){let a=r.isExportEquals?g.An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration:g.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration;if(N$(r,a))return;let _=r.parent.kind===312?r.parent:r.parent.parent;if(_.kind===267&&!S_(_)){r.isExportEquals?He(r,g.An_export_assignment_cannot_be_used_in_a_namespace):He(r,g.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);return}!ey(r)&&Ij(r)&&Xu(r,g.An_export_assignment_cannot_have_modifiers);let d=t_(r);d&&J_(xl(r.expression),Ri(d),r.expression);let y=!r.isExportEquals&&!(r.flags&33554432)&&$.verbatimModuleSyntax&&(z===1||Xr(r).impliedNodeFormat===1);if(r.expression.kind===80){let T=r.expression,P=vd(ac(T,-1,!0,!0,r));if(P){let L=Bd(P,111551);if(Wae(P,T),a_(P)&111551?(xl(T),!y&&!(r.flags&33554432)&&$.verbatimModuleSyntax&&L&&He(T,r.isExportEquals?g.An_export_declaration_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration:g.An_export_default_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration,Nn(T))):!y&&!(r.flags&33554432)&&$.verbatimModuleSyntax&&He(T,r.isExportEquals?g.An_export_declaration_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type:g.An_export_default_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type,Nn(T)),!y&&!(r.flags&33554432)&&fm($)&&!(P.flags&111551)){let J=a_(P,!1,!0);P.flags&2097152&&J&788968&&!(J&111551)&&(!L||Xr(L)!==Xr(r))?He(T,r.isExportEquals?g._0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported:g._0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default,Nn(T),Ze):L&&Xr(L)!==Xr(r)&&J0(He(T,r.isExportEquals?g._0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported:g._0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default,Nn(T),Ze),L,Nn(T))}}else xl(T);Dd($)&&t4(T,!0)}else xl(r.expression);y&&He(r,g.ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled),CYe(_),r.flags&33554432&&!ol(r.expression)&&kr(r.expression,g.The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context),r.isExportEquals&&(z>=5&&z!==200&&(r.flags&33554432&&Xr(r).impliedNodeFormat===99||!(r.flags&33554432)&&Xr(r).impliedNodeFormat!==1)?kr(r,g.Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead):z===4&&!(r.flags&33554432)&&kr(r,g.Export_assignment_is_not_supported_when_module_flag_is_system))}function oVt(r){return yu(r.exports,(a,_)=>_!=="export=")}function CYe(r){let a=Rn(r),_=as(a);if(!_.exportsChecked){let d=a.exports.get("export=");if(d&&oVt(a)){let T=Xm(d)||d.valueDeclaration;T&&!PS(T)&&!gn(T)&&He(T,g.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements)}let y=Zh(a);y&&y.forEach(({declarations:T,flags:P},L)=>{if(L==="__export"||P&1920)return;let J=mu(T,V5(fMe,J5(ef)));if(!(P&524288&&J<=2)&&J>1&&!Noe(T))for(let G of T)lMe(G)&&fo.add($n(G,g.Cannot_redeclare_exported_variable_0,Zi(L)))}),_.exportsChecked=!0}}function Noe(r){return r&&r.length>1&&r.every(a=>gn(a)&&Yo(a)&&(G2(a.expression)||P0(a.expression)))}function Ba(r){if(r){let a=O;O=r,k=0,cVt(r),O=a}}function cVt(r){U8(r)&&Te(r.jsDoc,({comment:_,tags:d})=>{AYe(_),Te(d,y=>{AYe(y.comment),gn(r)&&Ba(y)})});let a=r.kind;if(i)switch(a){case 267:case 263:case 264:case 262:i.throwIfCancellationRequested()}switch(a>=243&&a<=259&&B8(r)&&r.flowNode&&!Yz(r.flowNode)&&Yu($.allowUnreachableCode===!1,r,g.Unreachable_code_detected),a){case 168:return PHe(r);case 169:return NHe(r);case 172:return wHe(r);case 171:return $jt(r);case 185:case 184:case 179:case 180:case 181:return qL(r);case 174:case 173:return Wjt(r);case 175:return Gjt(r);case 176:return Hjt(r);case 177:case 178:return RHe(r);case 183:return XAe(r);case 182:return Vjt(r);case 186:return eBt(r);case 187:return tBt(r);case 188:return rBt(r);case 189:return nBt(r);case 192:case 193:return iBt(r);case 196:case 190:case 191:return Ba(r.type);case 197:return cBt(r);case 198:return lBt(r);case 194:return uBt(r);case 195:return _Bt(r);case 203:return fBt(r);case 205:return pBt(r);case 202:return dBt(r);case 335:return OBt(r);case 336:return wBt(r);case 353:case 345:case 347:return EBt(r);case 352:return xBt(r);case 351:return CBt(r);case 331:case 332:case 333:return kBt(r);case 348:return PBt(r);case 355:return NBt(r);case 324:DBt(r);case 322:case 321:case 319:case 320:case 329:kYe(r),Qs(r,Ba);return;case 325:lVt(r);return;case 316:return Ba(r.type);case 340:case 342:case 341:return RBt(r);case 357:return ABt(r);case 350:return IBt(r);case 199:return sBt(r);case 200:return aBt(r);case 262:return bBt(r);case 241:case 268:return boe(r);case 243:return QBt(r);case 244:return ZBt(r);case 245:return eUt(r);case 246:return nUt(r);case 247:return iUt(r);case 248:return sUt(r);case 249:return oUt(r);case 250:return aUt(r);case 251:case 252:return dUt(r);case 253:return mUt(r);case 254:return gUt(r);case 255:return hUt(r);case 256:return yUt(r);case 257:return vUt(r);case 258:return SUt(r);case 260:return XBt(r);case 208:return KBt(r);case 263:return PUt(r);case 264:return jUt(r);case 265:return BUt(r);case 266:return JUt(r);case 267:return GUt(r);case 272:return XUt(r);case 271:return KUt(r);case 278:return QUt(r);case 277:return aVt(r);case 242:case 259:c1(r);return;case 282:return Xjt(r)}}function AYe(r){os(r)&&Te(r,a=>{TA(a)&&Ba(a)})}function kYe(r){if(!gn(r))if(cU(r)||GN(r)){let a=Sa(cU(r)?54:58),_=r.postfix?g._0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1:g._0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1,d=r.type,y=Ri(d);kr(r,_,a,Kr(GN(r)&&!(y===Qn||y===fn)?pi(Pr([y,Be],r.postfix?void 0:he)):y))}else kr(r,g.JSDoc_types_can_only_be_used_inside_documentation_comments)}function lVt(r){kYe(r),Ba(r.type);let{parent:a}=r;if(Ls(a)&&HN(a.parent)){Rs(a.parent.parameters)!==a&&He(r,g.A_rest_parameter_must_be_last_in_a_parameter_list);return}hE(a)||He(r,g.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);let _=r.parent.parent;if(!mg(_)){He(r,g.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);return}let d=V8(_);if(!d)return;let y=yT(_);(!y||Rs(y.parameters).symbol!==d)&&He(r,g.A_rest_parameter_must_be_last_in_a_parameter_list)}function uVt(r){let a=Ri(r.type),{parent:_}=r,d=r.parent.parent;if(hE(r.parent)&&mg(d)){let y=yT(d),T=JK(d.parent.parent);if(y||T){let P=Is(T?d.parent.parent.typeExpression.parameters:y.parameters),L=V8(d);if(!P||L&&P.symbol===L&&x0(P))return P_(a)}}return Ls(_)&&HN(_.parent)?P_(a):ep(a)}function _P(r){let a=Xr(r),_=_i(a);_.flags&1?I.assert(!_.deferredNodes,"A type-checked file should have no deferred nodes."):(_.deferredNodes||(_.deferredNodes=new Set),_.deferredNodes.add(r))}function _Vt(r){let a=_i(r);a.deferredNodes&&a.deferredNodes.forEach(fVt),a.deferredNodes=void 0}function fVt(r){var a,_;(a=mn)==null||a.push(mn.Phase.Check,"checkDeferredNode",{kind:r.kind,pos:r.pos,end:r.end,path:r.tracingPath});let d=O;switch(O=r,k=0,r.kind){case 213:case 214:case 215:case 170:case 286:PC(r);break;case 218:case 219:case 174:case 173:ajt(r);break;case 177:case 178:RHe(r);break;case 231:kUt(r);break;case 168:Ujt(r);break;case 285:m5t(r);break;case 284:h5t(r);break;case 216:case 234:case 217:O9t(r);break;case 222:Cs(r.expression);break;case 226:Rj(r)&&PC(r);break}O=d,(_=mn)==null||_.pop()}function pVt(r){var a,_;(a=mn)==null||a.push(mn.Phase.Check,"checkSourceFile",{path:r.path},!0),mc("beforeCheck"),dVt(r),mc("afterCheck"),rd("Check","beforeCheck","afterCheck"),(_=mn)==null||_.pop()}function PYe(r,a){if(a)return!1;switch(r){case 0:return!!$.noUnusedLocals;case 1:return!!$.noUnusedParameters;default:return I.assertNever(r)}}function NYe(r){return md.get(r.path)||tt}function dVt(r){let a=_i(r);if(!(a.flags&1)){if(y6(r,$,e))return;UJt(r),ed(ME),ed(LE),ed(fS),ed(pS),ed(V0),Te(r.statements,Ba),Ba(r.endOfFileToken),_Vt(r),Bp(r)&&HS(r),n(()=>{!r.isDeclarationFile&&($.noUnusedLocals||$.noUnusedParameters)&&WHe(NYe(r),(_,d,y)=>{!rN(_)&&PYe(d,!!(_.flags&33554432))&&fo.add(y)}),r.isDeclarationFile||jBt()}),$.importsNotUsedAsValues===2&&!r.isDeclarationFile&&Pl(r)&&iVt(r),Bp(r)&&CYe(r),ME.length&&(Te(ME,VBt),ed(ME)),LE.length&&(Te(LE,JBt),ed(LE)),fS.length&&(Te(fS,WBt),ed(fS)),pS.length&&(Te(pS,HBt),ed(pS)),a.flags|=1}}function DYe(r,a){try{return i=a,mVt(r)}finally{i=void 0}}function pke(){for(let r of t)r();t=[]}function dke(r){pke();let a=n;n=_=>_(),pVt(r),n=a}function mVt(r){if(r){pke();let a=fo.getGlobalDiagnostics(),_=a.length;dke(r);let d=fo.getDiagnostics(r.fileName),y=fo.getGlobalDiagnostics();if(y!==a){let T=dy(a,y,p6);return ys(T,d)}else if(_===0&&y.length>0)return ys(y,d);return d}return Te(e.getSourceFiles(),dke),fo.getDiagnostics()}function gVt(){return pke(),fo.getGlobalDiagnostics()}function hVt(r,a){if(r.flags&67108864)return[];let _=ga(),d=!1;return y(),_.delete("this"),Sxe(_);function y(){for(;r;){switch(Oh(r)&&r.locals&&!Kh(r)&&P(r.locals,a),r.kind){case 312:if(!Pl(r))break;case 267:L(Rn(r).exports,a&2623475);break;case 266:P(Rn(r).exports,a&8);break;case 231:r.name&&T(r.symbol,a);case 263:case 264:d||P(MS(Rn(r)),a&788968);break;case 218:r.name&&T(r.symbol,a);break}mde(r)&&T($t,a),d=pa(r),r=r.parent}P(ke,a)}function T(J,G){if(NN(J)&G){let ae=J.escapedName;_.has(ae)||_.set(ae,J)}}function P(J,G){G&&J.forEach(ae=>{T(ae,G)})}function L(J,G){G&&J.forEach(ae=>{!xc(ae,281)&&!xc(ae,280)&&ae.escapedName!=="default"&&T(ae,G)})}}function yVt(r){return r.kind===80&&LN(r.parent)&&qs(r.parent)===r}function IYe(r){for(;r.parent.kind===166;)r=r.parent;return r.parent.kind===183}function vVt(r){for(;r.parent.kind===211;)r=r.parent;return r.parent.kind===233}function wYe(r,a){let _,d=Vu(r);for(;d&&!(_=a(d));)d=Vu(d);return _}function SVt(r){return!!Gr(r,a=>Yc(a)&&nm(a.body)||ea(a)?!0:Ti(a)||tc(a)?"quit":!1)}function mke(r,a){return!!wYe(r,_=>_===a)}function TVt(r){for(;r.parent.kind===166;)r=r.parent;if(r.parent.kind===271)return r.parent.moduleReference===r?r.parent:void 0;if(r.parent.kind===277)return r.parent.expression===r?r.parent:void 0}function Doe(r){return TVt(r)!==void 0}function bVt(r){switch(al(r.parent.parent)){case 1:case 3:return yd(r.parent);case 5:if(Hn(r.parent)&&DN(r.parent)===r)return;case 4:case 2:return Rn(r.parent.parent)}}function EVt(r){let a=r.parent;for(;pf(a);)r=a,a=a.parent;if(a&&a.kind===205&&a.qualifier===r)return a}function xVt(r){if(r.expression.kind===110){let a=kf(r,!1,!1);if(ca(a)){let _=qWe(a);if(_){let d=Tb(_,void 0),y=$We(_,d);return y&&!wt(y)}}}}function OYe(r){if(Cy(r))return yd(r.parent);if(gn(r)&&r.parent.kind===211&&r.parent===r.parent.parent.left&&!is(r)&&!kT(r)&&!xVt(r.parent)){let a=bVt(r);if(a)return a}if(r.parent.kind===277&&ol(r)){let a=ac(r,2998271,!0);if(a&&a!==dt)return a}else if(zf(r)&&Doe(r)){let a=ST(r,271);return I.assert(a!==void 0),Hk(r,!0)}if(zf(r)){let a=EVt(r);if(a){Ri(a);let _=_i(r).resolvedSymbol;return _===dt?void 0:_}}for(;rme(r);)r=r.parent;if(vVt(r)){let a=0;r.parent.kind===233?(a=A0(r)?788968:111551,Oj(r.parent)&&(a|=111551)):a=1920,a|=2097152;let _=ol(r)?ac(r,a,!0):void 0;if(_)return _}if(r.parent.kind===348)return V8(r.parent);if(r.parent.kind===168&&r.parent.parent.kind===352){I.assert(!gn(r));let a=Pde(r.parent);return a&&a.symbol}if(k0(r)){if(sl(r))return;let a=Gr(r,cg(TA,z6,kT)),_=a?901119:111551;if(r.kind===80){if(_N(r)&&uP(r)){let y=Zae(r.parent);return y===dt?void 0:y}let d=ac(r,_,!0,!0,yT(r));if(!d&&a){let y=Gr(r,cg(Ti,ef));if(y)return D$(r,!0,Rn(y))}if(d&&a){let y=X2(r);if(y&&gE(y)&&y===d.valueDeclaration)return ac(r,_,!0,!0,Xr(y))||d}return d}else{if(is(r))return roe(r);if(r.kind===211||r.kind===166){let d=_i(r);return d.resolvedSymbol?d.resolvedSymbol:(r.kind===211?(eoe(r,0),d.resolvedSymbol||(d.resolvedSymbol=RYe(xl(r.expression),av(r.name)))):yGe(r,0),!d.resolvedSymbol&&a&&pf(r)?D$(r):d.resolvedSymbol)}else if(kT(r))return D$(r)}}else if(IYe(r)){let a=r.parent.kind===183?788968:1920,_=ac(r,a,!1,!0);return _&&_!==dt?_:rae(r)}if(r.parent.kind===182)return ac(r,1)}function RYe(r,a){let _=vxe(r,a);if(_.length&&r.members){let d=Zse(kg(r).members);if(_===nf(r))return d;if(d){let y=as(d),T=Wi(_,L=>L.declaration),P=vr(T,yo).join(",");if(y.filteredIndexSymbolCache||(y.filteredIndexSymbolCache=new Map),y.filteredIndexSymbolCache.has(P))return y.filteredIndexSymbolCache.get(P);{let L=oo(131072,"__index");return L.declarations=Wi(_,J=>J.declaration),L.parent=r.aliasSymbol?r.aliasSymbol:r.symbol?r.symbol:ng(L.declarations[0].parent),y.filteredIndexSymbolCache.set(P,L),L}}}}function D$(r,a,_){if(zf(r)){let P=ac(r,901119,a,!0,yT(r));if(!P&&ze(r)&&_&&(P=mo(Lf(Ep(_),r.escapedText,901119))),P)return P}let d=ze(r)?_:D$(r.left,a,_),y=ze(r)?r.escapedText:r.right.escapedText;if(d){let T=d.flags&111551&&ka(vn(d),"prototype"),P=T?vn(T):dc(d);return ka(P,y)}}function ng(r,a){if(ls(r))return Pl(r)?mo(r.symbol):void 0;let{parent:_}=r,d=_.parent;if(!(r.flags&67108864)){if(uMe(r)){let y=Rn(_);return hA(r.parent)&&r.parent.propertyName===r?aAe(y):y}else if(z8(r))return Rn(_.parent);if(r.kind===80){if(Doe(r))return OYe(r);if(_.kind===208&&d.kind===206&&r===_.propertyName){let y=fP(d),T=ka(y,r.escapedText);if(T)return T}else if(F6(_)&&_.name===r)return _.keywordToken===105&&Nn(r)==="target"?OAe(_).symbol:_.keywordToken===102&&Nn(r)==="meta"?Lze().members.get("meta"):void 0}switch(r.kind){case 80:case 81:case 211:case 166:if(!NA(r))return OYe(r);case 110:let y=kf(r,!1,!1);if(ca(y)){let L=Sm(y);if(L.thisParameter)return L.thisParameter}if(cj(r))return Cs(r).symbol;case 197:return fae(r).symbol;case 108:return Cs(r).symbol;case 137:let T=r.parent;return T&&T.kind===176?T.parent.symbol:void 0;case 11:case 15:if(gT(r.parent.parent)&&$w(r.parent.parent)===r||(r.parent.kind===272||r.parent.kind===278)&&r.parent.moduleSpecifier===r||gn(r)&&_f(r.parent,!1)||Up(r.parent)||Qv(r.parent)&&Vv(r.parent.parent)&&r.parent.parent.argument===r.parent)return rf(r,r,a);if(da(_)&&H2(_)&&_.arguments[1]===r)return Rn(_);case 9:let P=fc(_)?_.argumentExpression===r?l_(_.expression):void 0:Qv(_)&&lx(d)?Ri(d.objectType):void 0;return P&&ka(P,Pc(r.text));case 90:case 100:case 39:case 86:return yd(r.parent);case 205:return Vv(r)?ng(r.argument.literal,a):void 0;case 95:return Kc(r.parent)?I.checkDefined(r.parent.symbol):void 0;case 102:case 105:return F6(r.parent)?tHe(r.parent).symbol:void 0;case 104:if(bn(r.parent)){let L=l_(r.parent.right),J=JAe(L);return J?.symbol??L.symbol}return;case 236:return Cs(r).symbol;case 295:if(_N(r)&&uP(r)){let L=Zae(r.parent);return L===dt?void 0:L}default:return}}}function CVt(r){if(ze(r)&&Hn(r.parent)&&r.parent.name===r){let a=av(r),_=l_(r.parent.expression),d=_.flags&1048576?_.types:[_];return _a(d,y=>Fn(nf(y),T=>nP(a,T.keyType)))}}function AVt(r){if(r&&r.kind===304)return ac(r.name,2208703)}function kVt(r){return R_(r)?r.parent.parent.moduleSpecifier?$y(r.parent.parent,r):ac(r.propertyName||r.name,2998271):ac(r,2998271)}function fP(r){if(ls(r)&&!Pl(r)||r.flags&67108864)return ht;let a=CX(r),_=a&&qd(Rn(a.class));if(A0(r)){let d=Ri(r);return _?Hp(d,_.thisType):d}if(k0(r))return MYe(r);if(_&&!a.isImplements){let d=qi(Cp(_));return d?Hp(d,_.thisType):ht}if(LN(r)){let d=Rn(r);return dc(d)}if(yVt(r)){let d=ng(r);return d?dc(d):ht}if(co(r))return cC(r,!0,0)||ht;if(O_(r)){let d=Rn(r);return d?vn(d):ht}if(uMe(r)){let d=ng(r);return d?vn(d):ht}if(la(r))return cC(r.parent,!0,0)||ht;if(Doe(r)){let d=ng(r);if(d){let y=dc(d);return Xt(y)?vn(d):y}}return F6(r.parent)&&r.parent.keywordToken===r.kind?tHe(r.parent):tk(r)?Rxe(!1):ht}function Ioe(r){if(I.assert(r.kind===210||r.kind===209),r.parent.kind===250){let y=A$(r.parent);return DC(r,y||ht)}if(r.parent.kind===226){let y=l_(r.parent.right);return DC(r,y||ht)}if(r.parent.kind===303){let y=ta(r.parent.parent,Ha),T=Ioe(y)||ht,P=nN(y.properties,r.parent);return yHe(y,T,P)}let a=ta(r.parent,Z_),_=Ioe(a)||ht,d=uv(65,_,Be,r.parent)||ht;return vHe(a,_,a.elements.indexOf(r),d)}function PVt(r){let a=Ioe(ta(r.parent.parent,Lw));return a&&ka(a,r.escapedText)}function MYe(r){return o6(r)&&(r=r.parent),af(l_(r))}function LYe(r){let a=yd(r.parent);return pa(r)?vn(a):dc(a)}function FYe(r){let a=r.name;switch(a.kind){case 80:return jf(Nn(a));case 9:case 11:return jf(a.text);case 167:let _=Q0(a);return c_(_,12288)?_:Le;default:return I.fail("Unsupported property name.")}}function gke(r){r=Tf(r);let a=ga(Io(r)),_=na(r,0).length?Zr:na(r,1).length?Ds:void 0;return _&&Te(Io(_),d=>{a.has(d.escapedName)||a.set(d.escapedName,d)}),rb(a)}function woe(r){return na(r,0).length!==0||na(r,1).length!==0}function jYe(r){let a=NVt(r);return a?_a(a,jYe):[r]}function NVt(r){if(Vc(r)&6)return Wi(as(r).containingType.types,a=>ka(a,r.escapedName));if(r.flags&33554432){let{links:{leftSpread:a,rightSpread:_,syntheticOrigin:d}}=r;return a?[a,_]:d?[d]:_A(DVt(r))}}function DVt(r){let a,_=r;for(;_=as(_).target;)a=_;return a}function IVt(r){if(yc(r))return!1;let a=Us(r,ze);if(!a)return!1;let _=a.parent;return _?!((Hn(_)||Ul(_))&&_.name===a)&&QL(a)===$t:!1}function wVt(r){let a=rf(r.parent,r);if(!a||Uw(a))return!0;let _=tv(a);a=bp(a);let d=as(a);return d.exportsSomeValue===void 0&&(d.exportsSomeValue=_?!!(a.flags&111551):yu(Zh(a),y)),d.exportsSomeValue;function y(T){return T=ll(T),T&&!!(a_(T)&111551)}}function OVt(r){return c8(r.parent)&&r===r.parent.name}function RVt(r,a){var _;let d=Us(r,ze);if(d){let y=QL(d,OVt(d));if(y){if(y.flags&1048576){let P=mo(y.exportSymbol);if(!a&&P.flags&944&&!(P.flags&3))return;y=P}let T=yf(y);if(T){if(T.flags&512&&((_=T.valueDeclaration)==null?void 0:_.kind)===312){let P=T.valueDeclaration,L=Xr(d);return P!==L?void 0:P}return Gr(d.parent,P=>c8(P)&&Rn(P)===T)}}}}function MVt(r){let a=fge(r);if(a)return a;let _=Us(r,ze);if(_){let d=HVt(_);if(Kx(d,111551)&&!Bd(d,111551))return Xm(d)}}function LVt(r){return r.valueDeclaration&&co(r.valueDeclaration)&&GP(r.valueDeclaration).parent.kind===299}function BYe(r){if(r.flags&418&&r.valueDeclaration&&!ls(r.valueDeclaration)){let a=as(r);if(a.isDeclarationWithCollidingName===void 0){let _=Lh(r.valueDeclaration);if(Hpe(_)||LVt(r)){let d=_i(r.valueDeclaration);if(wc(_.parent,r.escapedName,111551,void 0,void 0,!1))a.isDeclarationWithCollidingName=!0;else if(d.flags&16384){let y=d.flags&32768,T=Lv(_,!1),P=_.kind===241&&Lv(_.parent,!1);a.isDeclarationWithCollidingName=!tde(_)&&(!y||!T&&!P)}else a.isDeclarationWithCollidingName=!1}}return a.isDeclarationWithCollidingName}return!1}function FVt(r){if(!yc(r)){let a=Us(r,ze);if(a){let _=QL(a);if(_&&BYe(_))return _.valueDeclaration}}}function jVt(r){let a=Us(r,O_);if(a){let _=Rn(a);if(_)return BYe(_)}return!1}function UYe(r){switch(I.assert(yt),r.kind){case 271:return Ooe(Rn(r));case 273:case 274:case 276:case 281:let a=Rn(r);return!!a&&Ooe(a,!0);case 278:let _=r.exportClause;return!!_&&(qh(_)||Tt(_.elements,UYe));case 277:return r.expression&&r.expression.kind===80?Ooe(Rn(r),!0):!0}return!1}function BVt(r){let a=Us(r,Ru);return a===void 0||a.parent.kind!==312||!fN(a)?!1:Ooe(Rn(a))&&a.moduleReference&&!sl(a.moduleReference)}function Ooe(r,a){if(!r)return!1;let _=vd(du(r));return _===dt?!a||!Bd(r):!!(a_(r,a,!0)&111551)&&(aE($)||!KL(_))}function KL(r){return VAe(r)||!!r.constEnumOnlyModule}function Roe(r,a){if(I.assert(yt),yS(r)){let _=Rn(r),d=_&&as(_);if(d?.referenced)return!0;let y=as(_).aliasTarget;if(y&&X_(r)&32&&a_(y)&111551&&(aE($)||!KL(y)))return!0}return a?!!Qs(r,_=>Roe(_,a)):!1}function VYe(r){if(nm(r.body)){if(Fv(r)||A1(r))return!1;let a=Rn(r),_=KE(a);return _.length>1||_.length===1&&_[0].declaration!==r}return!1}function JYe(r){return!!Q&&!gL(r)&&!mg(r)&&!!r.initializer&&!ui(r,31)}function UVt(r){return Q&&gL(r)&&!r.initializer&&ui(r,31)}function VVt(r){let a=Us(r,Zl);if(!a)return!1;let _=Rn(a);return!_||!(_.flags&16)?!1:!!yu(Ep(_),d=>d.flags&111551&&lB(d.valueDeclaration))}function JVt(r){let a=Us(r,Zl);if(!a)return tt;let _=Rn(a);return _&&Io(vn(_))||tt}function jI(r){var a;let _=r.id||0;return _<0||_>=RE.length?0:((a=RE[_])==null?void 0:a.flags)||0}function BI(r){return TYe(r.parent),_i(r).enumMemberValue}function qYe(r){switch(r.kind){case 306:case 211:case 212:return!0}return!1}function hke(r){if(r.kind===306)return BI(r);let a=_i(r).resolvedSymbol;if(a&&a.flags&8){let _=a.valueDeclaration;if(zb(_.parent))return BI(_)}}function yke(r){return!!(r.flags&524288)&&na(r,0).length>0}function qVt(r,a){var _;let d=Us(r,zf);if(!d||a&&(a=Us(a),!a))return 0;let y=!1;if(pf(d)){let ae=ac(Jp(d),111551,!0,!0,a);y=!!((_=ae?.declarations)!=null&&_.every(dT))}let T=ac(d,111551,!0,!0,a),P=T&&T.flags&2097152?du(T):T;y||(y=!!(T&&Bd(T,111551)));let L=ac(d,788968,!0,!0,a),J=L&&L.flags&2097152?du(L):L;if(T||y||(y=!!(L&&Bd(L,788968))),P&&P===J){let ae=Mxe(!1);if(ae&&P===ae)return 9;let Ce=vn(P);if(Ce&&go(Ce))return y?10:1}if(!J)return y?11:0;let G=dc(J);return Xt(G)?y?11:0:G.flags&3?11:c_(G,245760)?2:c_(G,528)?6:c_(G,296)?3:c_(G,2112)?4:c_(G,402653316)?5:Ka(G)?7:c_(G,12288)?8:yke(G)?10:Gd(G)?7:11}function zVt(r,a,_,d,y){let T=Us(r,fde);if(!T)return j.createToken(133);let P=Rn(T),L=P&&!(P.flags&133120)?i2(vn(P)):ht;return L.flags&8192&&L.symbol===P&&(_|=1048576),y&&(L=$S(L)),kt.typeToTypeNode(L,a,_|1024,d)}function $Vt(r,a,_,d){let y=Us(r,ca);if(!y)return j.createToken(133);let T=Sm(y);return kt.typeToTypeNode(Ao(T),a,_|1024,d)}function WVt(r,a,_,d){let y=Us(r,bt);if(!y)return j.createToken(133);let T=Yp(MYe(y));return kt.typeToTypeNode(T,a,_|1024,d)}function GVt(r){return ke.has(Pc(r))}function QL(r,a){let _=_i(r).resolvedSymbol;if(_)return _;let d=r;if(a){let y=r.parent;O_(y)&&r===y.name&&(d=te(y))}return wc(d,r.escapedText,3257279,void 0,void 0,!0)}function HVt(r){let a=_i(r).resolvedSymbol;return a&&a!==dt?a:wc(r,r.escapedText,3257279,void 0,void 0,!0,void 0,void 0)}function YVt(r){if(!yc(r)){let a=Us(r,ze);if(a){let _=QL(a);if(_)return vd(_).valueDeclaration}}}function XVt(r){if(!yc(r)){let a=Us(r,ze);if(a){let _=QL(a);if(_)return Fn(vd(_).declarations,d=>{switch(d.kind){case 260:case 169:case 208:case 172:case 303:case 304:case 306:case 210:case 262:case 218:case 219:case 263:case 231:case 266:case 174:case 177:case 178:case 267:return!0}return!1})}}}function KVt(r){return Y9(r)||Gi(r)&&w$(r)?t2(vn(Rn(r))):!1}function QVt(r,a,_){let d=r.flags&1056?kt.symbolToExpression(r.symbol,111551,a,void 0,_):r===zr?j.createTrue():r===Zt&&j.createFalse();if(d)return d;let y=r.value;return typeof y=="object"?j.createBigIntLiteral(y):typeof y=="string"?j.createStringLiteral(y):y<0?j.createPrefixUnaryExpression(41,j.createNumericLiteral(-y)):j.createNumericLiteral(y)}function ZVt(r,a){let _=vn(Rn(r));return QVt(_,r,a)}function zYe(r){return r?(GT(r),Xr(r).localJsxFactory||Vy):Vy}function vke(r){if(r){let a=Xr(r);if(a){if(a.localJsxFragmentFactory)return a.localJsxFragmentFactory;let _=a.pragmas.get("jsxfrag"),d=os(_)?_[0]:_;if(d)return a.localJsxFragmentFactory=ok(d.arguments.factory,pe),a.localJsxFragmentFactory}}if($.jsxFragmentFactory)return ok($.jsxFragmentFactory,pe)}function eJt(){let r=e.getResolvedTypeReferenceDirectives(),a;return r&&(a=new Map,r.forEach(({resolvedTypeReferenceDirective:J},G,ae)=>{if(!J?.resolvedFileName)return;let Ce=e.getSourceFile(J.resolvedFileName);Ce&&L(Ce,G,ae)})),{getReferencedExportContainer:RVt,getReferencedImportDeclaration:MVt,getReferencedDeclarationWithCollidingName:FVt,isDeclarationWithCollidingName:jVt,isValueAliasDeclaration:J=>{let G=Us(J);return G&&yt?UYe(G):!0},hasGlobalName:GVt,isReferencedAliasDeclaration:(J,G)=>{let ae=Us(J);return ae&&yt?Roe(ae,G):!0},getNodeCheckFlags:J=>{let G=Us(J);return G?jI(G):0},isTopLevelValueImportEqualsWithEntityName:BVt,isDeclarationVisible:Eg,isImplementationOfOverload:VYe,isRequiredInitializedParameter:JYe,isOptionalUninitializedParameterProperty:UVt,isExpandoFunctionDeclaration:VVt,getPropertiesOfContainerFunction:JVt,createTypeOfDeclaration:zVt,createReturnTypeOfSignatureDeclaration:$Vt,createTypeOfExpression:WVt,createLiteralConstValue:ZVt,isSymbolAccessible:$i,isEntityNameVisible:CS,getConstantValue:J=>{let G=Us(J,qYe);return G?hke(G):void 0},collectLinkedAliases:t4,getReferencedValueDeclaration:YVt,getReferencedValueDeclarations:XVt,getTypeReferenceSerializationKind:qVt,isOptionalParameter:gL,moduleExportsSomeValue:wVt,isArgumentsLocalBinding:IVt,getExternalModuleFileFromDeclaration:J=>{let G=Us(J,nde);return G&&Ske(G)},getTypeReferenceDirectivesForEntityName:y,getTypeReferenceDirectivesForSymbol:T,isLiteralConstDeclaration:KVt,isLateBound:J=>{let G=Us(J,O_),ae=G&&Rn(G);return!!(ae&&Vc(ae)&4096)},getJsxFactoryEntity:zYe,getJsxFragmentFactoryEntity:vke,getAllAccessorDeclarations(J){J=Us(J,x9);let G=J.kind===178?177:178,ae=xc(Rn(J),G),Ce=ae&&ae.pos<J.pos?ae:J,be=ae&&ae.pos<J.pos?J:ae,Ye=J.kind===178?J:ae,vt=J.kind===177?J:ae;return{firstAccessor:Ce,secondAccessor:be,setAccessor:Ye,getAccessor:vt}},getSymbolOfExternalModuleSpecifier:J=>Wy(J,J,void 0),isBindingCapturedByNode:(J,G)=>{let ae=Us(J),Ce=Us(G);return!!ae&&!!Ce&&(Gi(Ce)||co(Ce))&&xFt(ae,Ce)},getDeclarationStatementsForSourceFile:(J,G,ae,Ce)=>{let be=Us(J);I.assert(be&&be.kind===312,"Non-sourcefile node passed into getDeclarationsForSourceFile");let Ye=Rn(J);return Ye?Ye.exports?kt.symbolTableToDeclarationStatements(Ye.exports,J,G,ae,Ce):[]:J.locals?kt.symbolTableToDeclarationStatements(J.locals,J,G,ae,Ce):[]},isImportRequiredByAugmentation:_,tryFindAmbientModule:J=>{let G=Us(J),ae=G&&bo(G)?G.text:void 0;return ae!==void 0?Xse(ae,!0):void 0}};function _(J){let G=Xr(J);if(!G.symbol)return!1;let ae=Ske(J);if(!ae||ae===G)return!1;let Ce=Zh(G.symbol);for(let be of In(Ce.values()))if(be.mergeId){let Ye=mo(be);if(Ye.declarations){for(let vt of Ye.declarations)if(Xr(vt)===ae)return!0}}return!1}function d(J){return J.parent&&J.parent.kind===233&&J.parent.parent&&J.parent.parent.kind===298}function y(J){if(!a)return;let G;J.parent.kind===167?G=1160127:(G=790504,(J.kind===80&&ex(J)||J.kind===211&&!d(J))&&(G=1160127));let ae=ac(J,G,!0);return ae&&ae!==dt?T(ae,G):void 0}function T(J,G){if(!a||!P(J))return;let ae;for(let Ce of J.declarations)if(Ce.symbol&&Ce.symbol.flags&G){let be=Xr(Ce),Ye=a.get(be.path);if(Ye)(ae||(ae=[])).push(Ye);else return}return ae}function P(J){if(!J.declarations)return!1;let G=J;for(;;){let ae=yf(G);if(ae)G=ae;else break}if(G.valueDeclaration&&G.valueDeclaration.kind===312&&G.flags&512)return!1;for(let ae of J.declarations){let Ce=Xr(ae);if(a.has(Ce.path))return!0}return!1}function L(J,G,ae){if(!a.has(J.path)){a.set(J.path,[G,ae]);for(let{fileName:Ce}of J.referencedFiles){let be=SV(Ce,J.fileName),Ye=e.getSourceFile(be);Ye&&L(Ye,G,ae||J.impliedNodeFormat)}}}}function Ske(r){let a=r.kind===267?ii(r.name,za):mN(r),_=Wy(a,a,void 0);if(_)return xc(_,312)}function tJt(){for(let a of e.getSourceFiles())$he(a,$);jo=new Map;let r;for(let a of e.getSourceFiles())if(!a.redirectInfo){if(!Bp(a)){let _=a.locals.get("globalThis");if(_?.declarations)for(let d of _.declarations)fo.add($n(d,g.Declaration_name_conflicts_with_built_in_global_identifier_0,"globalThis"));Tg(ke,a.locals)}a.jsGlobalAugmentations&&Tg(ke,a.jsGlobalAugmentations),a.patternAmbientModules&&a.patternAmbientModules.length&&(gm=ys(gm,a.patternAmbientModules)),a.moduleAugmentations.length&&(r||(r=[])).push(a.moduleAugmentations),a.symbol&&a.symbol.globalExports&&a.symbol.globalExports.forEach((d,y)=>{ke.has(y)||ke.set(y,d)})}if(r)for(let a of r)for(let _ of a)zg(_.parent)&&eI(_);if(FE(ke,Bx,g.Declaration_name_conflicts_with_built_in_global_identifier_0),as($e).type=Lt,as($t).type=El("IArguments",0,!0),as(dt).type=ht,as(at).type=Ud(16,at),sa=El("Array",1,!0),Oe=El("Object",0,!0),Bt=El("Function",0,!0),Zr=ye&&El("CallableFunction",0,!0)||Bt,Ds=ye&&El("NewableFunction",0,!0)||Bt,Tl=El("String",0,!0),ql=El("Number",0,!0),bc=El("Boolean",0,!0),Ic=El("RegExp",0,!0),bl=P_(W),xu=P_(st),xu===$a&&(xu=Ho(void 0,K,tt,tt,tt)),ua=Jze("ReadonlyArray",1)||sa,dd=ua?vL(ua,[W]):bl,cl=Jze("ThisType",1),r)for(let a of r)for(let _ of a)zg(_.parent)||eI(_);jo.forEach(({firstFile:a,secondFile:_,conflictingSymbols:d})=>{if(d.size<8)d.forEach(({isBlockScoped:y,firstFileLocations:T,secondFileLocations:P},L)=>{let J=y?g.Cannot_redeclare_block_scoped_variable_0:g.Duplicate_identifier_0;for(let G of T)Jy(G,J,L,P);for(let G of P)Jy(G,J,L,T)});else{let y=In(d.keys()).join(", ");fo.add(Ga($n(a,g.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0,y),$n(_,g.Conflicts_are_in_this_file))),fo.add(Ga($n(_,g.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0,y),$n(a,g.Conflicts_are_in_this_file)))}}),jo=void 0}function iu(r,a){if((o&a)!==a&&$.importHelpers){let _=Xr(r);if(bA(_,$)&&!(r.flags&33554432)){let d=nJt(_,r);if(d!==dt){let y=a&~o;for(let T=1;T<=33554432;T<<=1)if(y&T)for(let P of rJt(T)){if(s.has(P))continue;s.add(P);let L=ll(Lf(Zh(d),Pc(P),111551));L?T&524288?Tt(KE(L),J=>Xp(J)>3)||He(r,g.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0,Gv,P,4):T&1048576?Tt(KE(L),J=>Xp(J)>4)||He(r,g.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0,Gv,P,5):T&1024&&(Tt(KE(L),J=>Xp(J)>2)||He(r,g.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0,Gv,P,3)):He(r,g.This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0,Gv,P)}}o|=a}}}function rJt(r){switch(r){case 1:return["__extends"];case 2:return["__assign"];case 4:return["__rest"];case 8:return se?["__decorate"]:["__esDecorate","__runInitializers"];case 16:return["__metadata"];case 32:return["__param"];case 64:return["__awaiter"];case 128:return["__generator"];case 256:return["__values"];case 512:return["__read"];case 1024:return["__spreadArray"];case 2048:return["__await"];case 4096:return["__asyncGenerator"];case 8192:return["__asyncDelegator"];case 16384:return["__asyncValues"];case 32768:return["__exportStar"];case 65536:return["__importStar"];case 131072:return["__importDefault"];case 262144:return["__makeTemplateObject"];case 524288:return["__classPrivateFieldGet"];case 1048576:return["__classPrivateFieldSet"];case 2097152:return["__classPrivateFieldIn"];case 4194304:return["__createBinding"];case 8388608:return["__setFunctionName"];case 16777216:return["__propKey"];case 33554432:return["__addDisposableResource","__disposeResources"];default:return I.fail("Unrecognized helper")}}function nJt(r,a){return l||(l=fh(r,Gv,g.This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found,a)||dt),l}function ey(r){var a;let _=aJt(r)||iJt(r);if(_!==void 0)return _;if(Ls(r)&&Zb(r))return Xu(r,g.Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters);let d=Xc(r)?r.declarationList.flags&7:0,y,T,P,L,J,G=0,ae=!1,Ce=!1;for(let be of r.modifiers)if(n_(be)){if(oj(se,r,r.parent,r.parent.parent)){if(se&&(r.kind===177||r.kind===178)){let Ye=tx(r.parent.members,r);if(Ad(Ye.firstAccessor)&&r===Ye.secondAccessor)return Xu(r,g.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name)}}else return r.kind===174&&!nm(r.body)?Xu(r,g.A_decorator_can_only_decorate_a_method_implementation_not_an_overload):Xu(r,g.Decorators_are_not_valid_here);if(G&-34849)return kr(be,g.Decorators_are_not_valid_here);if(Ce&&G&98303){I.assertIsDefined(J);let Ye=Xr(be);return u2(Ye)?!1:(Ga(He(be,g.Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export),$n(J,g.Decorator_used_before_export_here)),!0)}G|=32768,G&98303?G&32&&(ae=!0):Ce=!0,J??(J=be)}else{if(be.kind!==148){if(r.kind===171||r.kind===173)return kr(be,g._0_modifier_cannot_appear_on_a_type_member,Sa(be.kind));if(r.kind===181&&(be.kind!==126||!Ti(r.parent)))return kr(be,g._0_modifier_cannot_appear_on_an_index_signature,Sa(be.kind))}if(be.kind!==103&&be.kind!==147&&be.kind!==87&&r.kind===168)return kr(be,g._0_modifier_cannot_appear_on_a_type_parameter,Sa(be.kind));switch(be.kind){case 87:{if(r.kind!==266&&r.kind!==168)return kr(r,g.A_class_member_cannot_have_the_0_keyword,Sa(87));let Dt=dm(r.parent)&&vT(r.parent)||r.parent;if(r.kind===168&&!(tc(Dt)||Ti(Dt)||Vh(Dt)||VN(Dt)||HA(Dt)||OR(Dt)||Uh(Dt)))return kr(be,g._0_modifier_can_only_appear_on_a_type_parameter_of_a_function_method_or_class,Sa(be.kind));break}case 164:if(G&16)return kr(be,g._0_modifier_already_seen,"override");if(G&128)return kr(be,g._0_modifier_cannot_be_used_with_1_modifier,"override","declare");if(G&8)return kr(be,g._0_modifier_must_precede_1_modifier,"override","readonly");if(G&512)return kr(be,g._0_modifier_must_precede_1_modifier,"override","accessor");if(G&1024)return kr(be,g._0_modifier_must_precede_1_modifier,"override","async");G|=16,L=be;break;case 125:case 124:case 123:let Ye=oC(IA(be.kind));if(G&7)return kr(be,g.Accessibility_modifier_already_seen);if(G&16)return kr(be,g._0_modifier_must_precede_1_modifier,Ye,"override");if(G&256)return kr(be,g._0_modifier_must_precede_1_modifier,Ye,"static");if(G&512)return kr(be,g._0_modifier_must_precede_1_modifier,Ye,"accessor");if(G&8)return kr(be,g._0_modifier_must_precede_1_modifier,Ye,"readonly");if(G&1024)return kr(be,g._0_modifier_must_precede_1_modifier,Ye,"async");if(r.parent.kind===268||r.parent.kind===312)return kr(be,g._0_modifier_cannot_appear_on_a_module_or_namespace_element,Ye);if(G&64)return be.kind===123?kr(be,g._0_modifier_cannot_be_used_with_1_modifier,Ye,"abstract"):kr(be,g._0_modifier_must_precede_1_modifier,Ye,"abstract");if(G_(r))return kr(be,g.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);G|=IA(be.kind);break;case 126:if(G&256)return kr(be,g._0_modifier_already_seen,"static");if(G&8)return kr(be,g._0_modifier_must_precede_1_modifier,"static","readonly");if(G&1024)return kr(be,g._0_modifier_must_precede_1_modifier,"static","async");if(G&512)return kr(be,g._0_modifier_must_precede_1_modifier,"static","accessor");if(r.parent.kind===268||r.parent.kind===312)return kr(be,g._0_modifier_cannot_appear_on_a_module_or_namespace_element,"static");if(r.kind===169)return kr(be,g._0_modifier_cannot_appear_on_a_parameter,"static");if(G&64)return kr(be,g._0_modifier_cannot_be_used_with_1_modifier,"static","abstract");if(G&16)return kr(be,g._0_modifier_must_precede_1_modifier,"static","override");G|=256,y=be;break;case 129:if(G&512)return kr(be,g._0_modifier_already_seen,"accessor");if(G&8)return kr(be,g._0_modifier_cannot_be_used_with_1_modifier,"accessor","readonly");if(G&128)return kr(be,g._0_modifier_cannot_be_used_with_1_modifier,"accessor","declare");if(r.kind!==172)return kr(be,g.accessor_modifier_can_only_appear_on_a_property_declaration);G|=512;break;case 148:if(G&8)return kr(be,g._0_modifier_already_seen,"readonly");if(r.kind!==172&&r.kind!==171&&r.kind!==181&&r.kind!==169)return kr(be,g.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);if(G&512)return kr(be,g._0_modifier_cannot_be_used_with_1_modifier,"readonly","accessor");G|=8;break;case 95:if($.verbatimModuleSyntax&&!(r.flags&33554432)&&r.kind!==265&&r.kind!==264&&r.kind!==267&&r.parent.kind===312&&(z===1||Xr(r).impliedNodeFormat===1))return kr(be,g.A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled);if(G&32)return kr(be,g._0_modifier_already_seen,"export");if(G&128)return kr(be,g._0_modifier_must_precede_1_modifier,"export","declare");if(G&64)return kr(be,g._0_modifier_must_precede_1_modifier,"export","abstract");if(G&1024)return kr(be,g._0_modifier_must_precede_1_modifier,"export","async");if(Ti(r.parent))return kr(be,g._0_modifier_cannot_appear_on_class_elements_of_this_kind,"export");if(r.kind===169)return kr(be,g._0_modifier_cannot_appear_on_a_parameter,"export");if(d===4)return kr(be,g._0_modifier_cannot_appear_on_a_using_declaration,"export");if(d===6)return kr(be,g._0_modifier_cannot_appear_on_an_await_using_declaration,"export");G|=32;break;case 90:let vt=r.parent.kind===312?r.parent:r.parent.parent;if(vt.kind===267&&!S_(vt))return kr(be,g.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);if(d===4)return kr(be,g._0_modifier_cannot_appear_on_a_using_declaration,"default");if(d===6)return kr(be,g._0_modifier_cannot_appear_on_an_await_using_declaration,"default");if(G&32){if(ae)return kr(J,g.Decorators_are_not_valid_here)}else return kr(be,g._0_modifier_must_precede_1_modifier,"export","default");G|=2048;break;case 138:if(G&128)return kr(be,g._0_modifier_already_seen,"declare");if(G&1024)return kr(be,g._0_modifier_cannot_be_used_in_an_ambient_context,"async");if(G&16)return kr(be,g._0_modifier_cannot_be_used_in_an_ambient_context,"override");if(Ti(r.parent)&&!ea(r))return kr(be,g._0_modifier_cannot_appear_on_class_elements_of_this_kind,"declare");if(r.kind===169)return kr(be,g._0_modifier_cannot_appear_on_a_parameter,"declare");if(d===4)return kr(be,g._0_modifier_cannot_appear_on_a_using_declaration,"declare");if(d===6)return kr(be,g._0_modifier_cannot_appear_on_an_await_using_declaration,"declare");if(r.parent.flags&33554432&&r.parent.kind===268)return kr(be,g.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);if(G_(r))return kr(be,g._0_modifier_cannot_be_used_with_a_private_identifier,"declare");if(G&512)return kr(be,g._0_modifier_cannot_be_used_with_1_modifier,"declare","accessor");G|=128,T=be;break;case 128:if(G&64)return kr(be,g._0_modifier_already_seen,"abstract");if(r.kind!==263&&r.kind!==185){if(r.kind!==174&&r.kind!==172&&r.kind!==177&&r.kind!==178)return kr(be,g.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);if(!(r.parent.kind===263&&ui(r.parent,64))){let Dt=r.kind===172?g.Abstract_properties_can_only_appear_within_an_abstract_class:g.Abstract_methods_can_only_appear_within_an_abstract_class;return kr(be,Dt)}if(G&256)return kr(be,g._0_modifier_cannot_be_used_with_1_modifier,"static","abstract");if(G&2)return kr(be,g._0_modifier_cannot_be_used_with_1_modifier,"private","abstract");if(G&1024&&P)return kr(P,g._0_modifier_cannot_be_used_with_1_modifier,"async","abstract");if(G&16)return kr(be,g._0_modifier_must_precede_1_modifier,"abstract","override");if(G&512)return kr(be,g._0_modifier_must_precede_1_modifier,"abstract","accessor")}if(W_(r)&&r.name.kind===81)return kr(be,g._0_modifier_cannot_be_used_with_a_private_identifier,"abstract");G|=64;break;case 134:if(G&1024)return kr(be,g._0_modifier_already_seen,"async");if(G&128||r.parent.flags&33554432)return kr(be,g._0_modifier_cannot_be_used_in_an_ambient_context,"async");if(r.kind===169)return kr(be,g._0_modifier_cannot_appear_on_a_parameter,"async");if(G&64)return kr(be,g._0_modifier_cannot_be_used_with_1_modifier,"async","abstract");G|=1024,P=be;break;case 103:case 147:{let Dt=be.kind===103?8192:16384,ur=be.kind===103?"in":"out",pr=dm(r.parent)&&(vT(r.parent)||mr((a=yN(r.parent))==null?void 0:a.tags,gx))||r.parent;if(r.kind!==168||pr&&!(ef(pr)||Ti(pr)||Vm(pr)||gx(pr)))return kr(be,g._0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias,ur);if(G&Dt)return kr(be,g._0_modifier_already_seen,ur);if(Dt&8192&&G&16384)return kr(be,g._0_modifier_must_precede_1_modifier,"in","out");G|=Dt;break}}}return r.kind===176?G&256?kr(y,g._0_modifier_cannot_appear_on_a_constructor_declaration,"static"):G&16?kr(L,g._0_modifier_cannot_appear_on_a_constructor_declaration,"override"):G&1024?kr(P,g._0_modifier_cannot_appear_on_a_constructor_declaration,"async"):!1:(r.kind===272||r.kind===271)&&G&128?kr(T,g.A_0_modifier_cannot_be_used_with_an_import_declaration,"declare"):r.kind===169&&G&31&&la(r.name)?kr(r,g.A_parameter_property_may_not_be_declared_using_a_binding_pattern):r.kind===169&&G&31&&r.dotDotDotToken?kr(r,g.A_parameter_property_cannot_be_declared_using_a_rest_parameter):G&1024?cJt(r,P):!1}function iJt(r){if(!r.modifiers)return!1;let a=sJt(r);return a&&Xu(a,g.Modifiers_cannot_appear_here)}function Moe(r,a){let _=mr(r.modifiers,Ra);return _&&_.kind!==a?_:void 0}function sJt(r){switch(r.kind){case 177:case 178:case 176:case 172:case 171:case 174:case 173:case 181:case 267:case 272:case 271:case 278:case 277:case 218:case 219:case 169:case 168:return;case 175:case 303:case 304:case 270:case 282:return mr(r.modifiers,Ra);default:if(r.parent.kind===268||r.parent.kind===312)return;switch(r.kind){case 262:return Moe(r,134);case 263:case 185:return Moe(r,128);case 231:case 264:case 265:return mr(r.modifiers,Ra);case 243:return r.declarationList.flags&4?Moe(r,135):mr(r.modifiers,Ra);case 266:return Moe(r,87);default:I.assertNever(r)}}}function aJt(r){let a=oJt(r);return a&&Xu(a,g.Decorators_are_not_valid_here)}function oJt(r){return nQ(r)?mr(r.modifiers,n_):void 0}function cJt(r,a){switch(r.kind){case 174:case 262:case 218:case 219:return!1}return kr(a,g._0_modifier_cannot_be_used_here,"async")}function pP(r,a=g.Trailing_comma_not_allowed){return r&&r.hasTrailingComma?_2(r[0],r.end-1,1,a):!1}function $Ye(r,a){if(r&&r.length===0){let _=r.pos-1,d=Wa(a.text,r.end)+1;return _2(a,_,d-_,g.Type_parameter_list_cannot_be_empty)}return!1}function lJt(r){let a=!1,_=r.length;for(let d=0;d<_;d++){let y=r[d];if(y.dotDotDotToken){if(d!==_-1)return kr(y.dotDotDotToken,g.A_rest_parameter_must_be_last_in_a_parameter_list);if(y.flags&33554432||pP(r,g.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma),y.questionToken)return kr(y.questionToken,g.A_rest_parameter_cannot_be_optional);if(y.initializer)return kr(y.name,g.A_rest_parameter_cannot_have_an_initializer)}else if(gL(y)){if(a=!0,y.questionToken&&y.initializer)return kr(y.name,g.Parameter_cannot_have_question_mark_and_initializer)}else if(a&&!y.initializer)return kr(y.name,g.A_required_parameter_cannot_follow_an_optional_parameter)}}function uJt(r){return Fn(r,a=>!!a.initializer||la(a.name)||x0(a))}function _Jt(r){if(pe>=3){let a=r.body&&ra(r.body)&&ZK(r.body.statements);if(a){let _=uJt(r.parameters);if(de(_)){Te(_,y=>{Ga(He(y,g.This_parameter_is_not_allowed_with_use_strict_directive),$n(a,g.use_strict_directive_used_here))});let d=_.map((y,T)=>T===0?$n(y,g.Non_simple_parameter_declared_here):$n(y,g.and_here));return Ga(He(a,g.use_strict_directive_cannot_be_used_with_non_simple_parameter_list),...d),!0}}}return!1}function Loe(r){let a=Xr(r);return ey(r)||$Ye(r.typeParameters,a)||lJt(r.parameters)||pJt(r,a)||tc(r)&&_Jt(r)}function fJt(r){let a=Xr(r);return yJt(r)||$Ye(r.typeParameters,a)}function pJt(r,a){if(!rc(r))return!1;r.typeParameters&&!(de(r.typeParameters)>1||r.typeParameters.hasTrailingComma||r.typeParameters[0].constraint)&&a&&Ql(a.fileName,[".mts",".cts"])&&kr(r.typeParameters[0],g.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint);let{equalsGreaterThanToken:_}=r,d=Lo(a,_.pos).line,y=Lo(a,_.end).line;return d!==y&&kr(_,g.Line_terminator_not_permitted_before_arrow)}function dJt(r){let a=r.parameters[0];if(r.parameters.length!==1)return kr(a?a.name:r,g.An_index_signature_must_have_exactly_one_parameter);if(pP(r.parameters,g.An_index_signature_cannot_have_a_trailing_comma),a.dotDotDotToken)return kr(a.dotDotDotToken,g.An_index_signature_cannot_have_a_rest_parameter);if(Ij(a))return kr(a.name,g.An_index_signature_parameter_cannot_have_an_accessibility_modifier);if(a.questionToken)return kr(a.questionToken,g.An_index_signature_parameter_cannot_have_a_question_mark);if(a.initializer)return kr(a.name,g.An_index_signature_parameter_cannot_have_an_initializer);if(!a.type)return kr(a.name,g.An_index_signature_parameter_must_have_a_type_annotation);let _=Ri(a.type);return rg(_,d=>!!(d.flags&8576))||AI(_)?kr(a.name,g.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead):tp(_,eae)?r.type?!1:kr(r,g.An_index_signature_must_have_a_type_annotation):kr(a.name,g.An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type)}function mJt(r){return ey(r)||dJt(r)}function gJt(r,a){if(a&&a.length===0){let _=Xr(r),d=a.pos-1,y=Wa(_.text,a.end)+1;return _2(_,d,y-d,g.Type_argument_list_cannot_be_empty)}return!1}function I$(r,a){return pP(a)||gJt(r,a)}function hJt(r){return r.questionDotToken||r.flags&64?kr(r.template,g.Tagged_template_expressions_are_not_permitted_in_an_optional_chain):!1}function WYe(r){let a=r.types;if(pP(a))return!0;if(a&&a.length===0){let _=Sa(r.token);return _2(r,a.pos,0,g._0_list_cannot_be_empty,_)}return Tt(a,GYe)}function GYe(r){return L1(r)&&L6(r.expression)&&r.typeArguments?kr(r,g.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments):I$(r,r.typeArguments)}function yJt(r){let a=!1,_=!1;if(!ey(r)&&r.heritageClauses)for(let d of r.heritageClauses){if(d.token===96){if(a)return Xu(d,g.extends_clause_already_seen);if(_)return Xu(d,g.extends_clause_must_precede_implements_clause);if(d.types.length>1)return Xu(d.types[1],g.Classes_can_only_extend_a_single_class);a=!0}else{if(I.assert(d.token===119),_)return Xu(d,g.implements_clause_already_seen);_=!0}WYe(d)}}function vJt(r){let a=!1;if(r.heritageClauses)for(let _ of r.heritageClauses){if(_.token===96){if(a)return Xu(_,g.extends_clause_already_seen);a=!0}else return I.assert(_.token===119),Xu(_,g.Interface_declaration_cannot_have_implements_clause);WYe(_)}return!1}function Foe(r){if(r.kind!==167)return!1;let a=r;return a.expression.kind===226&&a.expression.operatorToken.kind===28?kr(a.expression,g.A_comma_expression_is_not_allowed_in_a_computed_property_name):!1}function Tke(r){if(r.asteriskToken){if(I.assert(r.kind===262||r.kind===218||r.kind===174),r.flags&33554432)return kr(r.asteriskToken,g.Generators_are_not_allowed_in_an_ambient_context);if(!r.body)return kr(r.asteriskToken,g.An_overload_signature_cannot_be_declared_as_a_generator)}}function bke(r,a){return!!r&&kr(r,a)}function HYe(r,a){return!!r&&kr(r,a)}function SJt(r,a){let _=new Map;for(let d of r.properties){if(d.kind===305){if(a){let P=Do(d.expression);if(Z_(P)||Ha(P))return kr(d.expression,g.A_rest_element_cannot_contain_a_binding_pattern)}continue}let y=d.name;if(y.kind===167&&Foe(y),d.kind===304&&!a&&d.objectAssignmentInitializer&&kr(d.equalsToken,g.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern),y.kind===81&&kr(y,g.Private_identifiers_are_not_allowed_outside_class_bodies),Jm(d)&&d.modifiers)for(let P of d.modifiers)Ra(P)&&(P.kind!==134||d.kind!==174)&&kr(P,g._0_modifier_cannot_be_used_here,Fl(P));else if(Yge(d)&&d.modifiers)for(let P of d.modifiers)Ra(P)&&kr(P,g._0_modifier_cannot_be_used_here,Fl(P));let T;switch(d.kind){case 304:case 303:HYe(d.exclamationToken,g.A_definite_assignment_assertion_is_not_permitted_in_this_context),bke(d.questionToken,g.An_object_member_cannot_be_declared_optional),y.kind===9&&Cke(y),T=4;break;case 174:T=8;break;case 177:T=1;break;case 178:T=2;break;default:I.assertNever(d,"Unexpected syntax kind:"+d.kind)}if(!a){let P=Ake(y);if(P===void 0)continue;let L=_.get(P);if(!L)_.set(P,T);else if(T&8&&L&8)kr(y,g.Duplicate_identifier_0,Fl(y));else if(T&4&&L&4)kr(y,g.An_object_literal_cannot_have_multiple_properties_with_the_same_name,Fl(y));else if(T&3&&L&3)if(L!==3&&T!==L)_.set(P,T|L);else return kr(y,g.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name);else return kr(y,g.An_object_literal_cannot_have_property_and_accessor_with_the_same_name)}}}function TJt(r){bJt(r.tagName),I$(r,r.typeArguments);let a=new Map;for(let _ of r.attributes.properties){if(_.kind===293)continue;let{name:d,initializer:y}=_,T=A6(d);if(!a.get(T))a.set(T,!0);else return kr(d,g.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);if(y&&y.kind===294&&!y.expression)return kr(y,g.JSX_attributes_must_only_be_assigned_a_non_empty_expression)}}function bJt(r){if(Hn(r)&&pg(r.expression))return kr(r.expression,g.JSX_property_access_expressions_cannot_include_JSX_namespace_names);if(pg(r)&&Gj($)&&!xN(r.namespace.escapedText))return kr(r,g.React_components_cannot_include_JSX_namespace_names)}function EJt(r){if(r.expression&&W6(r.expression))return kr(r.expression,g.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array)}function YYe(r){if(c1(r))return!0;if(r.kind===250&&r.awaitModifier&&!(r.flags&65536)){let a=Xr(r);if(ij(r)){if(!u2(a))switch(bA(a,$)||fo.add($n(r.awaitModifier,g.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module)),z){case 100:case 199:if(a.impliedNodeFormat===1){fo.add($n(r.awaitModifier,g.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level));break}case 7:case 99:case 4:if(pe>=4)break;default:fo.add($n(r.awaitModifier,g.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher));break}}else if(!u2(a)){let _=$n(r.awaitModifier,g.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules),d=Vp(r);if(d&&d.kind!==176){I.assert((vu(d)&2)===0,"Enclosing function should never be an async function.");let y=$n(d,g.Did_you_mean_to_mark_this_function_as_async);Ga(_,y)}return fo.add(_),!0}return!1}if(jR(r)&&!(r.flags&65536)&&ze(r.initializer)&&r.initializer.escapedText==="async")return kr(r.initializer,g.The_left_hand_side_of_a_for_of_statement_may_not_be_async),!1;if(r.initializer.kind===261){let a=r.initializer;if(!xke(a)){let _=a.declarations;if(!_.length)return!1;if(_.length>1){let y=r.kind===249?g.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement:g.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;return Xu(a.declarations[1],y)}let d=_[0];if(d.initializer){let y=r.kind===249?g.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer:g.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;return kr(d.name,y)}if(d.type){let y=r.kind===249?g.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation:g.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation;return kr(d,y)}}}return!1}function xJt(r){if(!(r.flags&33554432)&&r.parent.kind!==187&&r.parent.kind!==264){if(pe<1)return kr(r.name,g.Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher);if(pe<2&&is(r.name))return kr(r.name,g.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);if(r.body===void 0&&!ui(r,64))return _2(r,r.end-1,1,g._0_expected,"{")}if(r.body){if(ui(r,64))return kr(r,g.An_abstract_accessor_cannot_have_an_implementation);if(r.parent.kind===187||r.parent.kind===264)return kr(r.body,g.An_implementation_cannot_be_declared_in_ambient_contexts)}if(r.typeParameters)return kr(r.name,g.An_accessor_cannot_have_type_parameters);if(!CJt(r))return kr(r.name,r.kind===177?g.A_get_accessor_cannot_have_parameters:g.A_set_accessor_must_have_exactly_one_parameter);if(r.kind===178){if(r.type)return kr(r.name,g.A_set_accessor_cannot_have_a_return_type_annotation);let a=I.checkDefined(n6(r),"Return value does not match parameter count assertion.");if(a.dotDotDotToken)return kr(a.dotDotDotToken,g.A_set_accessor_cannot_have_rest_parameter);if(a.questionToken)return kr(a.questionToken,g.A_set_accessor_cannot_have_an_optional_parameter);if(a.initializer)return kr(r.name,g.A_set_accessor_parameter_cannot_have_an_initializer)}return!1}function CJt(r){return Eke(r)||r.parameters.length===(r.kind===177?0:1)}function Eke(r){if(r.parameters.length===(r.kind===177?1:2))return Qb(r)}function AJt(r){if(r.operator===158){if(r.type.kind!==155)return kr(r.type,g._0_expected,Sa(155));let a=J8(r.parent);if(gn(a)&&hE(a)){let _=X2(a);_&&(a=AA(_)||_)}switch(a.kind){case 260:let _=a;if(_.name.kind!==80)return kr(r,g.unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name);if(!Jw(_))return kr(r,g.unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement);if(!(_.parent.flags&2))return kr(a.name,g.A_variable_whose_type_is_a_unique_symbol_type_must_be_const);break;case 172:if(!pa(a)||!i6(a))return kr(a.name,g.A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly);break;case 171:if(!ui(a,8))return kr(a.name,g.A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly);break;default:return kr(r,g.unique_symbol_types_are_not_allowed_here)}}else if(r.operator===148&&r.type.kind!==188&&r.type.kind!==189)return Xu(r,g.readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types,Sa(155))}function R4(r,a){if(z8t(r))return kr(r,a)}function XYe(r){if(Loe(r))return!0;if(r.kind===174){if(r.parent.kind===210){if(r.modifiers&&!(r.modifiers.length===1&&di(r.modifiers).kind===134))return Xu(r,g.Modifiers_cannot_appear_here);if(bke(r.questionToken,g.An_object_member_cannot_be_declared_optional))return!0;if(HYe(r.exclamationToken,g.A_definite_assignment_assertion_is_not_permitted_in_this_context))return!0;if(r.body===void 0)return _2(r,r.end-1,1,g._0_expected,"{")}if(Tke(r))return!0}if(Ti(r.parent)){if(pe<2&&is(r.name))return kr(r.name,g.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);if(r.flags&33554432)return R4(r.name,g.A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);if(r.kind===174&&!r.body)return R4(r.name,g.A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)}else{if(r.parent.kind===264)return R4(r.name,g.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);if(r.parent.kind===187)return R4(r.name,g.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)}}function kJt(r){let a=r;for(;a;){if(KP(a))return kr(r,g.Jump_target_cannot_cross_function_boundary);switch(a.kind){case 256:if(r.label&&a.label.escapedText===r.label.escapedText)return r.kind===251&&!Lv(a.statement,!0)?kr(r,g.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement):!1;break;case 255:if(r.kind===252&&!r.label)return!1;break;default:if(Lv(a,!1)&&!r.label)return!1;break}a=a.parent}if(r.label){let _=r.kind===252?g.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement:g.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement;return kr(r,_)}else{let _=r.kind===252?g.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement:g.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement;return kr(r,_)}}function PJt(r){if(r.dotDotDotToken){let a=r.parent.elements;if(r!==Rs(a))return kr(r,g.A_rest_element_must_be_last_in_a_destructuring_pattern);if(pP(a,g.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma),r.propertyName)return kr(r.name,g.A_rest_element_cannot_have_a_property_name)}if(r.dotDotDotToken&&r.initializer)return _2(r,r.initializer.pos-1,1,g.A_rest_element_cannot_have_an_initializer)}function KYe(r){return id(r)||r.kind===224&&r.operator===41&&r.operand.kind===9}function NJt(r){return r.kind===10||r.kind===224&&r.operator===41&&r.operand.kind===10}function DJt(r){if((Hn(r)||fc(r)&&KYe(r.argumentExpression))&&ol(r.expression))return!!(xl(r).flags&1056)}function QYe(r){let a=r.initializer;if(a){let _=!(KYe(a)||DJt(a)||a.kind===112||a.kind===97||NJt(a));if((Y9(r)||Gi(r)&&w$(r))&&!r.type){if(_)return kr(a,g.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference)}else return kr(a,g.Initializers_are_not_allowed_in_ambient_contexts)}}function IJt(r){let a=f2(r),_=a&7;if(la(r.name))switch(_){case 6:return kr(r,g._0_declarations_may_not_have_binding_patterns,"await using");case 4:return kr(r,g._0_declarations_may_not_have_binding_patterns,"using")}if(r.parent.parent.kind!==249&&r.parent.parent.kind!==250){if(a&33554432)QYe(r);else if(!r.initializer){if(la(r.name)&&!la(r.parent))return kr(r,g.A_destructuring_declaration_must_have_an_initializer);switch(_){case 6:return kr(r,g._0_declarations_must_be_initialized,"await using");case 4:return kr(r,g._0_declarations_must_be_initialized,"using");case 2:return kr(r,g._0_declarations_must_be_initialized,"const")}}}if(r.exclamationToken&&(r.parent.parent.kind!==243||!r.type||r.initializer||a&33554432)){let d=r.initializer?g.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions:r.type?g.A_definite_assignment_assertion_is_not_permitted_in_this_context:g.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations;return kr(r.exclamationToken,d)}return(z<5||Xr(r).impliedNodeFormat===1)&&z!==4&&!(r.parent.parent.flags&33554432)&&ui(r.parent.parent,32)&&ZYe(r.name),!!_&&eXe(r.name)}function ZYe(r){if(r.kind===80){if(Nn(r)==="__esModule")return RJt("noEmit",r,g.Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules)}else{let a=r.elements;for(let _ of a)if(!Su(_))return ZYe(_.name)}return!1}function eXe(r){if(r.kind===80){if(r.escapedText==="let")return kr(r,g.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations)}else{let a=r.elements;for(let _ of a)Su(_)||eXe(_.name)}return!1}function xke(r){let a=r.declarations;if(pP(r.declarations))return!0;if(!r.declarations.length)return _2(r,a.pos,a.end-a.pos,g.Variable_declaration_list_cannot_be_empty);let _=r.flags&7;return(_===4||_===6)&&oU(r.parent)?kr(r,_===4?g.The_left_hand_side_of_a_for_in_statement_cannot_be_a_using_declaration:g.The_left_hand_side_of_a_for_in_statement_cannot_be_an_await_using_declaration):_===6?hHe(r):!1}function tXe(r){switch(r.kind){case 245:case 246:case 247:case 254:case 248:case 249:case 250:return!1;case 256:return tXe(r.parent)}return!0}function wJt(r){if(!tXe(r.parent)){let a=f2(r.declarationList)&7;if(a){let _=a===1?"let":a===2?"const":a===4?"using":a===6?"await using":I.fail("Unknown BlockScope flag");return kr(r,g._0_declarations_can_only_be_declared_inside_a_block,_)}}}function OJt(r){let a=r.name.escapedText;switch(r.keywordToken){case 105:if(a!=="target")return kr(r.name,g._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2,Zi(r.name.escapedText),Sa(r.keywordToken),"target");break;case 102:if(a!=="meta")return kr(r.name,g._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2,Zi(r.name.escapedText),Sa(r.keywordToken),"meta");break}}function u2(r){return r.parseDiagnostics.length>0}function Xu(r,a,..._){let d=Xr(r);if(!u2(d)){let y=Fh(d,r.pos);return fo.add(Iu(d,y.start,y.length,a,..._)),!0}return!1}function _2(r,a,_,d,...y){let T=Xr(r);return u2(T)?!1:(fo.add(Iu(T,a,_,d,...y)),!0)}function RJt(r,a,_,...d){let y=Xr(a);return u2(y)?!1:(yg(r,a,_,...d),!0)}function kr(r,a,..._){let d=Xr(r);return u2(d)?!1:(fo.add($n(r,a,..._)),!0)}function MJt(r){let a=gn(r)?Dj(r):void 0,_=r.typeParameters||a&&qi(a);if(_){let d=_.pos===_.end?_.pos:Wa(Xr(r).text,_.pos);return _2(r,d,_.end-d,g.Type_parameters_cannot_appear_on_a_constructor_declaration)}}function LJt(r){let a=r.type||lm(r);if(a)return kr(a,g.Type_annotation_cannot_appear_on_a_constructor_declaration)}function FJt(r){if(uo(r.name)&&bn(r.name.expression)&&r.name.expression.operatorToken.kind===103)return kr(r.parent.members[0],g.A_mapped_type_may_not_declare_properties_or_methods);if(Ti(r.parent)){if(za(r.name)&&r.name.text==="constructor")return kr(r.name,g.Classes_may_not_have_a_field_named_constructor);if(R4(r.name,g.A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type))return!0;if(pe<2&&is(r.name))return kr(r.name,g.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);if(pe<2&&Af(r))return kr(r.name,g.Properties_with_the_accessor_modifier_are_only_available_when_targeting_ECMAScript_2015_and_higher);if(Af(r)&&bke(r.questionToken,g.An_accessor_property_cannot_be_declared_optional))return!0}else if(r.parent.kind===264){if(R4(r.name,g.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type))return!0;if(I.assertNode(r,fp),r.initializer)return kr(r.initializer,g.An_interface_property_cannot_have_an_initializer)}else if(dp(r.parent)){if(R4(r.name,g.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type))return!0;if(I.assertNode(r,fp),r.initializer)return kr(r.initializer,g.A_type_literal_property_cannot_have_an_initializer)}if(r.flags&33554432&&QYe(r),ea(r)&&r.exclamationToken&&(!Ti(r.parent)||!r.type||r.initializer||r.flags&33554432||pa(r)||tE(r))){let a=r.initializer?g.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions:r.type?g.A_definite_assignment_assertion_is_not_permitted_in_this_context:g.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations;return kr(r.exclamationToken,a)}}function jJt(r){return r.kind===264||r.kind===265||r.kind===272||r.kind===271||r.kind===278||r.kind===277||r.kind===270||ui(r,2208)?!1:Xu(r,g.Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier)}function BJt(r){for(let a of r.statements)if((O_(a)||a.kind===243)&&jJt(a))return!0;return!1}function UJt(r){return!!(r.flags&33554432)&&BJt(r)}function c1(r){if(r.flags&33554432){if(!_i(r).hasReportedStatementInAmbientContext&&(ca(r.parent)||Mv(r.parent)))return _i(r).hasReportedStatementInAmbientContext=Xu(r,g.An_implementation_cannot_be_declared_in_ambient_contexts);if(r.parent.kind===241||r.parent.kind===268||r.parent.kind===312){let _=_i(r.parent);if(!_.hasReportedStatementInAmbientContext)return _.hasReportedStatementInAmbientContext=Xu(r,g.Statements_are_not_allowed_in_ambient_contexts)}}return!1}function Cke(r){let a=Fl(r).includes("."),_=r.numericLiteralFlags&16;a||_||+r.text<=9007199254740991||vg(!1,$n(r,g.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers))}function VJt(r){return!!(!(Qv(r.parent)||eS(r.parent)&&Qv(r.parent.parent))&&pe<7&&kr(r,g.BigInt_literals_are_not_available_when_targeting_lower_than_ES2020))}function JJt(r,a,..._){let d=Xr(r);if(!u2(d)){let y=Fh(d,r.pos);return fo.add(Iu(d,gl(y),0,a,..._)),!0}return!1}function qJt(){return pu||(pu=[],ke.forEach((r,a)=>{eZ.test(a)&&pu.push(r)})),pu}function zJt(r){var a;return r.isTypeOnly&&r.name&&r.namedBindings?kr(r,g.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both):r.isTypeOnly&&((a=r.namedBindings)==null?void 0:a.kind)===275?rXe(r.namedBindings):!1}function rXe(r){return!!Te(r.elements,a=>{if(a.isTypeOnly)return Xu(a,a.kind===276?g.The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement:g.The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement)})}function $Jt(r){if($.verbatimModuleSyntax&&z===1)return kr(r,g.ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled);if(z===5)return kr(r,g.Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext);if(r.typeArguments)return kr(r,g.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments);let a=r.arguments;if(z!==99&&z!==199&&z!==100&&(pP(a),a.length>1)){let d=a[1];return kr(d,g.Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext)}if(a.length===0||a.length>2)return kr(r,g.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments);let _=mr(a,fg);return _?kr(_,g.Argument_of_dynamic_import_cannot_be_spread_element):!1}function WJt(r,a){let _=Gn(r);if(_&20&&a.flags&1048576)return mr(a.types,d=>{if(d.flags&524288){let y=_&Gn(d);if(y&4)return r.target===d.target;if(y&16)return!!r.aliasSymbol&&r.aliasSymbol===d.aliasSymbol}return!1})}function GJt(r,a){if(Gn(r)&128&&rg(a,cv))return mr(a.types,_=>!cv(_))}function HJt(r,a){let _=0;if(na(r,_).length>0||(_=1,na(r,_).length>0))return mr(a.types,y=>na(y,_).length>0)}function YJt(r,a){let _;if(!(r.flags&406978556)){let d=0;for(let y of a.types)if(!(y.flags&406978556)){let T=Pa([gh(r),gh(y)]);if(T.flags&4194304)return y;if(Dg(T)||T.flags&1048576){let P=T.flags&1048576?mu(T.types,Dg):1;P>=d&&(_=y,d=P)}}}return _}function XJt(r){if($c(r,67108864)){let a=wl(r,_=>!(_.flags&402784252));if(!(a.flags&131072))return a}return r}function nXe(r,a,_){if(a.flags&1048576&&r.flags&2621440){let d=mWe(a,r);if(d)return d;let y=Io(r);if(y){let T=dWe(y,a);if(T){let P=pCe(a,vr(T,L=>[()=>vn(L),L.escapedName]),_);if(P!==a)return P}}}}function Ake(r){let a=K2(r);return a||(uo(r)?jCe(l_(r.expression)):void 0)}function joe(r){return rn===r||(rn=r,Tr=lT(r)),Tr}function f2(r){return or===r||(or=r,Fr=x1(r)),Fr}function w$(r){let a=f2(r)&7;return a===2||a===4||a===6}}function Wvt(e){return!Mv(e)}function lMe(e){return e.kind!==262&&e.kind!==174||!!e.body}function uMe(e){switch(e.parent.kind){case 276:case 281:return ze(e);default:return Cy(e)}}function _Me(e){switch(e){case 0:return"yieldType";case 1:return"returnType";case 2:return"nextType"}}function L_(e){return!!(e.flags&1)}function ZQ(e){return!!(e.flags&2)}function Gvt(e){return{getCommonSourceDirectory:e.getCommonSourceDirectory?()=>e.getCommonSourceDirectory():()=>"",getCurrentDirectory:()=>e.getCurrentDirectory(),getSymlinkCache:rs(e,e.getSymlinkCache),getPackageJsonInfoCache:()=>{var t;return(t=e.getPackageJsonInfoCache)==null?void 0:t.call(e)},useCaseSensitiveFileNames:rs(e,e.useCaseSensitiveFileNames),redirectTargetsMap:e.redirectTargetsMap,getProjectReferenceRedirect:t=>e.getProjectReferenceRedirect(t),isSourceOfProjectReferenceRedirect:t=>e.isSourceOfProjectReferenceRedirect(t),fileExists:t=>e.fileExists(t),getFileIncludeReasons:()=>e.getFileIncludeReasons(),readFile:e.readFile?t=>e.readFile(t):void 0}}var eZ,YU,t0e,r0e,n0e,i0e,XU,tZ,KU,QU,fMe,ZU,s0e,cd,rZ,Hvt=f({"src/compiler/checker.ts"(){"use strict";fa(),Zhe(),O2(),eZ=/^".+"$/,YU="(anonymous)",t0e=1,r0e=1,n0e=1,i0e=1,XU=(e=>(e[e.None=0]="None",e[e.TypeofEQString=1]="TypeofEQString",e[e.TypeofEQNumber=2]="TypeofEQNumber",e[e.TypeofEQBigInt=4]="TypeofEQBigInt",e[e.TypeofEQBoolean=8]="TypeofEQBoolean",e[e.TypeofEQSymbol=16]="TypeofEQSymbol",e[e.TypeofEQObject=32]="TypeofEQObject",e[e.TypeofEQFunction=64]="TypeofEQFunction",e[e.TypeofEQHostObject=128]="TypeofEQHostObject",e[e.TypeofNEString=256]="TypeofNEString",e[e.TypeofNENumber=512]="TypeofNENumber",e[e.TypeofNEBigInt=1024]="TypeofNEBigInt",e[e.TypeofNEBoolean=2048]="TypeofNEBoolean",e[e.TypeofNESymbol=4096]="TypeofNESymbol",e[e.TypeofNEObject=8192]="TypeofNEObject",e[e.TypeofNEFunction=16384]="TypeofNEFunction",e[e.TypeofNEHostObject=32768]="TypeofNEHostObject",e[e.EQUndefined=65536]="EQUndefined",e[e.EQNull=131072]="EQNull",e[e.EQUndefinedOrNull=262144]="EQUndefinedOrNull",e[e.NEUndefined=524288]="NEUndefined",e[e.NENull=1048576]="NENull",e[e.NEUndefinedOrNull=2097152]="NEUndefinedOrNull",e[e.Truthy=4194304]="Truthy",e[e.Falsy=8388608]="Falsy",e[e.IsUndefined=16777216]="IsUndefined",e[e.IsNull=33554432]="IsNull",e[e.IsUndefinedOrNull=50331648]="IsUndefinedOrNull",e[e.All=134217727]="All",e[e.BaseStringStrictFacts=3735041]="BaseStringStrictFacts",e[e.BaseStringFacts=12582401]="BaseStringFacts",e[e.StringStrictFacts=16317953]="StringStrictFacts",e[e.StringFacts=16776705]="StringFacts",e[e.EmptyStringStrictFacts=12123649]="EmptyStringStrictFacts",e[e.EmptyStringFacts=12582401]="EmptyStringFacts",e[e.NonEmptyStringStrictFacts=7929345]="NonEmptyStringStrictFacts",e[e.NonEmptyStringFacts=16776705]="NonEmptyStringFacts",e[e.BaseNumberStrictFacts=3734786]="BaseNumberStrictFacts",e[e.BaseNumberFacts=12582146]="BaseNumberFacts",e[e.NumberStrictFacts=16317698]="NumberStrictFacts",e[e.NumberFacts=16776450]="NumberFacts",e[e.ZeroNumberStrictFacts=12123394]="ZeroNumberStrictFacts",e[e.ZeroNumberFacts=12582146]="ZeroNumberFacts",e[e.NonZeroNumberStrictFacts=7929090]="NonZeroNumberStrictFacts",e[e.NonZeroNumberFacts=16776450]="NonZeroNumberFacts",e[e.BaseBigIntStrictFacts=3734276]="BaseBigIntStrictFacts",e[e.BaseBigIntFacts=12581636]="BaseBigIntFacts",e[e.BigIntStrictFacts=16317188]="BigIntStrictFacts",e[e.BigIntFacts=16775940]="BigIntFacts",e[e.ZeroBigIntStrictFacts=12122884]="ZeroBigIntStrictFacts",e[e.ZeroBigIntFacts=12581636]="ZeroBigIntFacts",e[e.NonZeroBigIntStrictFacts=7928580]="NonZeroBigIntStrictFacts",e[e.NonZeroBigIntFacts=16775940]="NonZeroBigIntFacts",e[e.BaseBooleanStrictFacts=3733256]="BaseBooleanStrictFacts",e[e.BaseBooleanFacts=12580616]="BaseBooleanFacts",e[e.BooleanStrictFacts=16316168]="BooleanStrictFacts",e[e.BooleanFacts=16774920]="BooleanFacts",e[e.FalseStrictFacts=12121864]="FalseStrictFacts",e[e.FalseFacts=12580616]="FalseFacts",e[e.TrueStrictFacts=7927560]="TrueStrictFacts",e[e.TrueFacts=16774920]="TrueFacts",e[e.SymbolStrictFacts=7925520]="SymbolStrictFacts",e[e.SymbolFacts=16772880]="SymbolFacts",e[e.ObjectStrictFacts=7888800]="ObjectStrictFacts",e[e.ObjectFacts=16736160]="ObjectFacts",e[e.FunctionStrictFacts=7880640]="FunctionStrictFacts",e[e.FunctionFacts=16728e3]="FunctionFacts",e[e.VoidFacts=9830144]="VoidFacts",e[e.UndefinedFacts=26607360]="UndefinedFacts",e[e.NullFacts=42917664]="NullFacts",e[e.EmptyObjectStrictFacts=83427327]="EmptyObjectStrictFacts",e[e.EmptyObjectFacts=83886079]="EmptyObjectFacts",e[e.UnknownFacts=83886079]="UnknownFacts",e[e.AllTypeofNE=556800]="AllTypeofNE",e[e.OrFactsMask=8256]="OrFactsMask",e[e.AndFactsMask=134209471]="AndFactsMask",e))(XU||{}),tZ=new Map(Object.entries({string:256,number:512,bigint:1024,boolean:2048,symbol:4096,undefined:524288,object:8192,function:16384})),KU=(e=>(e[e.Normal=0]="Normal",e[e.Contextual=1]="Contextual",e[e.Inferential=2]="Inferential",e[e.SkipContextSensitive=4]="SkipContextSensitive",e[e.SkipGenericFunctions=8]="SkipGenericFunctions",e[e.IsForSignatureHelp=16]="IsForSignatureHelp",e[e.RestBindingElement=32]="RestBindingElement",e[e.TypeOnly=64]="TypeOnly",e))(KU||{}),QU=(e=>(e[e.None=0]="None",e[e.BivariantCallback=1]="BivariantCallback",e[e.StrictCallback=2]="StrictCallback",e[e.IgnoreReturnTypes=4]="IgnoreReturnTypes",e[e.StrictArity=8]="StrictArity",e[e.StrictTopSignature=16]="StrictTopSignature",e[e.Callback=3]="Callback",e))(QU||{}),fMe=V5(lMe,Wvt),ZU=new Map(Object.entries({Uppercase:0,Lowercase:1,Capitalize:2,Uncapitalize:3,NoInfer:4})),s0e=class{},(e=>{e.JSX="JSX",e.IntrinsicElements="IntrinsicElements",e.ElementClass="ElementClass",e.ElementAttributesPropertyNameContainer="ElementAttributesProperty",e.ElementChildrenAttributeNameContainer="ElementChildrenAttribute",e.Element="Element",e.ElementType="ElementType",e.IntrinsicAttributes="IntrinsicAttributes",e.IntrinsicClassAttributes="IntrinsicClassAttributes",e.LibraryManagedAttributes="LibraryManagedAttributes"})(cd||(cd={})),rZ=class qdt{constructor(t,n,i){this.moduleResolverHost=void 0,this.inner=void 0,this.disableTrackSymbol=!1;for(var s;n instanceof qdt;)n=n.inner;this.inner=n,this.moduleResolverHost=i,this.context=t,this.canTrackSymbol=!!((s=this.inner)!=null&&s.trackSymbol)}trackSymbol(t,n,i){var s,o;if((s=this.inner)!=null&&s.trackSymbol&&!this.disableTrackSymbol){if(this.inner.trackSymbol(t,n,i))return this.onDiagnosticReported(),!0;t.flags&262144||((o=this.context).trackedSymbols??(o.trackedSymbols=[])).push([t,n,i])}return!1}reportInaccessibleThisError(){var t;(t=this.inner)!=null&&t.reportInaccessibleThisError&&(this.onDiagnosticReported(),this.inner.reportInaccessibleThisError())}reportPrivateInBaseOfClassExpression(t){var n;(n=this.inner)!=null&&n.reportPrivateInBaseOfClassExpression&&(this.onDiagnosticReported(),this.inner.reportPrivateInBaseOfClassExpression(t))}reportInaccessibleUniqueSymbolError(){var t;(t=this.inner)!=null&&t.reportInaccessibleUniqueSymbolError&&(this.onDiagnosticReported(),this.inner.reportInaccessibleUniqueSymbolError())}reportCyclicStructureError(){var t;(t=this.inner)!=null&&t.reportCyclicStructureError&&(this.onDiagnosticReported(),this.inner.reportCyclicStructureError())}reportLikelyUnsafeImportRequiredError(t){var n;(n=this.inner)!=null&&n.reportLikelyUnsafeImportRequiredError&&(this.onDiagnosticReported(),this.inner.reportLikelyUnsafeImportRequiredError(t))}reportTruncationError(){var t;(t=this.inner)!=null&&t.reportTruncationError&&(this.onDiagnosticReported(),this.inner.reportTruncationError())}trackReferencedAmbientModule(t,n){var i;(i=this.inner)!=null&&i.trackReferencedAmbientModule&&(this.onDiagnosticReported(),this.inner.trackReferencedAmbientModule(t,n))}trackExternalModuleSymbolOfImportTypeNode(t){var n;(n=this.inner)!=null&&n.trackExternalModuleSymbolOfImportTypeNode&&(this.onDiagnosticReported(),this.inner.trackExternalModuleSymbolOfImportTypeNode(t))}reportNonlocalAugmentation(t,n,i){var s;(s=this.inner)!=null&&s.reportNonlocalAugmentation&&(this.onDiagnosticReported(),this.inner.reportNonlocalAugmentation(t,n,i))}reportNonSerializableProperty(t){var n;(n=this.inner)!=null&&n.reportNonSerializableProperty&&(this.onDiagnosticReported(),this.inner.reportNonSerializableProperty(t))}onDiagnosticReported(){this.context.reportedDiagnostic=!0}}}});function nt(e,t,n,i){if(e===void 0)return e;let s=t(e),o;if(s!==void 0)return os(s)?o=(i||Zvt)(s):o=s,I.assertNode(o,n),o}function Hr(e,t,n,i,s){if(e===void 0)return e;let o=e.length;(i===void 0||i<0)&&(i=0),(s===void 0||s>o-i)&&(s=o-i);let l,p=-1,m=-1;i>0||s<o?l=e.hasTrailingComma&&i+s===o:(p=e.pos,m=e.end,l=e.hasTrailingComma);let S=pMe(e,t,n,i,s);if(S!==e){let h=j.createNodeArray(S,l);return jh(h,p,m),h}return e}function SM(e,t,n,i,s){if(e===void 0)return e;let o=e.length;return(i===void 0||i<0)&&(i=0),(s===void 0||s>o-i)&&(s=o-i),pMe(e,t,n,i,s)}function pMe(e,t,n,i,s){let o,l=e.length;(i>0||s<l)&&(o=[]);for(let p=0;p<s;p++){let m=e[p+i],S=m!==void 0?t?t(m):m:void 0;if((o!==void 0||S===void 0||S!==m)&&(o===void 0&&(o=e.slice(0,p),I.assertEachNode(o,n)),S))if(os(S))for(let h of S)I.assertNode(h,n),o.push(h);else I.assertNode(S,n),o.push(S)}return o||(I.assertEachNode(e,n),e)}function nZ(e,t,n,i,s,o=Hr){return n.startLexicalEnvironment(),e=o(e,t,ns,i),s&&(e=n.factory.ensureUseStrict(e)),j.mergeLexicalEnvironment(e,n.endLexicalEnvironment())}function qc(e,t,n,i=Hr){let s;return n.startLexicalEnvironment(),e&&(n.setLexicalEnvironmentFlags(1,!0),s=i(e,t,Ls),n.getLexicalEnvironmentFlags()&2&&ho(n.getCompilerOptions())>=2&&(s=Yvt(s,n)),n.setLexicalEnvironmentFlags(1,!1)),n.suspendLexicalEnvironment(),s}function Yvt(e,t){let n;for(let i=0;i<e.length;i++){let s=e[i],o=Xvt(s,t);(n||o!==s)&&(n||(n=e.slice(0,i)),n[i]=o)}return n?ft(t.factory.createNodeArray(n,e.hasTrailingComma),e):e}function Xvt(e,t){return e.dotDotDotToken?e:la(e.name)?Kvt(e,t):e.initializer?Qvt(e,e.name,e.initializer,t):e}function Kvt(e,t){let{factory:n}=t;return t.addInitializationStatement(n.createVariableStatement(void 0,n.createVariableDeclarationList([n.createVariableDeclaration(e.name,void 0,e.type,e.initializer?n.createConditionalExpression(n.createStrictEquality(n.getGeneratedNameForNode(e),n.createVoidZero()),void 0,e.initializer,void 0,n.getGeneratedNameForNode(e)):n.getGeneratedNameForNode(e))]))),n.updateParameterDeclaration(e,e.modifiers,e.dotDotDotToken,n.getGeneratedNameForNode(e),e.questionToken,e.type,void 0)}function Qvt(e,t,n,i){let s=i.factory;return i.addInitializationStatement(s.createIfStatement(s.createTypeCheck(s.cloneNode(t),"undefined"),Sn(ft(s.createBlock([s.createExpressionStatement(Sn(ft(s.createAssignment(Sn(s.cloneNode(t),96),Sn(n,96|eo(n)|3072)),e),3072))]),e),3905))),s.updateParameterDeclaration(e,e.modifiers,e.dotDotDotToken,e.name,e.questionToken,e.type,void 0)}function ld(e,t,n,i=nt){n.resumeLexicalEnvironment();let s=i(e,t,w9),o=n.endLexicalEnvironment();if(Tt(o)){if(!s)return n.factory.createBlock(o);let l=n.factory.converters.convertToFunctionBlock(s),p=j.mergeLexicalEnvironment(l.statements,o);return n.factory.updateBlock(l,p)}return s}function df(e,t,n,i=nt){n.startBlockScope();let s=i(e,t,ns,n.factory.liftToBlock);I.assert(s);let o=n.endBlockScope();return Tt(o)?ra(s)?(o.push(...s.statements),n.factory.updateBlock(s,o)):(o.push(s),n.factory.createBlock(o)):s}function TM(e,t,n=t){if(n===t||e.length<=1)return Hr(e,t,bt);let i=0,s=e.length;return Hr(e,o=>{let l=i<s-1;return i++,l?n(o):t(o)},bt)}function wr(e,t,n=fO,i=Hr,s,o=nt){if(e===void 0)return;let l=dMe[e.kind];return l===void 0?e:l(e,t,n,i,o,s)}function Zvt(e){return I.assert(e.length<=1,"Too many nodes written to output."),nl(e)}var dMe,eSt=f({"src/compiler/visitorPublic.ts"(){"use strict";fa(),dMe={166:function(t,n,i,s,o,l){return i.factory.updateQualifiedName(t,I.checkDefined(o(t.left,n,zf)),I.checkDefined(o(t.right,n,ze)))},167:function(t,n,i,s,o,l){return i.factory.updateComputedPropertyName(t,I.checkDefined(o(t.expression,n,bt)))},168:function(t,n,i,s,o,l){return i.factory.updateTypeParameterDeclaration(t,s(t.modifiers,n,Ra),I.checkDefined(o(t.name,n,ze)),o(t.constraint,n,es),o(t.default,n,es))},169:function(t,n,i,s,o,l){return i.factory.updateParameterDeclaration(t,s(t.modifiers,n,vc),l?o(t.dotDotDotToken,l,ZB):t.dotDotDotToken,I.checkDefined(o(t.name,n,j2)),l?o(t.questionToken,l,Xv):t.questionToken,o(t.type,n,es),o(t.initializer,n,bt))},170:function(t,n,i,s,o,l){return i.factory.updateDecorator(t,I.checkDefined(o(t.expression,n,bt)))},171:function(t,n,i,s,o,l){return i.factory.updatePropertySignature(t,s(t.modifiers,n,Ra),I.checkDefined(o(t.name,n,Al)),l?o(t.questionToken,l,Xv):t.questionToken,o(t.type,n,es))},172:function(t,n,i,s,o,l){return i.factory.updatePropertyDeclaration(t,s(t.modifiers,n,vc),I.checkDefined(o(t.name,n,Al)),l?o(t.questionToken??t.exclamationToken,l,Xge):t.questionToken??t.exclamationToken,o(t.type,n,es),o(t.initializer,n,bt))},173:function(t,n,i,s,o,l){return i.factory.updateMethodSignature(t,s(t.modifiers,n,Ra),I.checkDefined(o(t.name,n,Al)),l?o(t.questionToken,l,Xv):t.questionToken,s(t.typeParameters,n,Nc),s(t.parameters,n,Ls),o(t.type,n,es))},174:function(t,n,i,s,o,l){return i.factory.updateMethodDeclaration(t,s(t.modifiers,n,vc),l?o(t.asteriskToken,l,IR):t.asteriskToken,I.checkDefined(o(t.name,n,Al)),l?o(t.questionToken,l,Xv):t.questionToken,s(t.typeParameters,n,Nc),qc(t.parameters,n,i,s),o(t.type,n,es),ld(t.body,n,i,o))},176:function(t,n,i,s,o,l){return i.factory.updateConstructorDeclaration(t,s(t.modifiers,n,vc),qc(t.parameters,n,i,s),ld(t.body,n,i,o))},177:function(t,n,i,s,o,l){return i.factory.updateGetAccessorDeclaration(t,s(t.modifiers,n,vc),I.checkDefined(o(t.name,n,Al)),qc(t.parameters,n,i,s),o(t.type,n,es),ld(t.body,n,i,o))},178:function(t,n,i,s,o,l){return i.factory.updateSetAccessorDeclaration(t,s(t.modifiers,n,vc),I.checkDefined(o(t.name,n,Al)),qc(t.parameters,n,i,s),ld(t.body,n,i,o))},175:function(t,n,i,s,o,l){return i.startLexicalEnvironment(),i.suspendLexicalEnvironment(),i.factory.updateClassStaticBlockDeclaration(t,ld(t.body,n,i,o))},179:function(t,n,i,s,o,l){return i.factory.updateCallSignature(t,s(t.typeParameters,n,Nc),s(t.parameters,n,Ls),o(t.type,n,es))},180:function(t,n,i,s,o,l){return i.factory.updateConstructSignature(t,s(t.typeParameters,n,Nc),s(t.parameters,n,Ls),o(t.type,n,es))},181:function(t,n,i,s,o,l){return i.factory.updateIndexSignature(t,s(t.modifiers,n,vc),s(t.parameters,n,Ls),I.checkDefined(o(t.type,n,es)))},182:function(t,n,i,s,o,l){return i.factory.updateTypePredicateNode(t,o(t.assertsModifier,n,yge),I.checkDefined(o(t.parameterName,n,Kge)),o(t.type,n,es))},183:function(t,n,i,s,o,l){return i.factory.updateTypeReferenceNode(t,I.checkDefined(o(t.typeName,n,zf)),s(t.typeArguments,n,es))},184:function(t,n,i,s,o,l){return i.factory.updateFunctionTypeNode(t,s(t.typeParameters,n,Nc),s(t.parameters,n,Ls),I.checkDefined(o(t.type,n,es)))},185:function(t,n,i,s,o,l){return i.factory.updateConstructorTypeNode(t,s(t.modifiers,n,Ra),s(t.typeParameters,n,Nc),s(t.parameters,n,Ls),I.checkDefined(o(t.type,n,es)))},186:function(t,n,i,s,o,l){return i.factory.updateTypeQueryNode(t,I.checkDefined(o(t.exprName,n,zf)),s(t.typeArguments,n,es))},187:function(t,n,i,s,o,l){return i.factory.updateTypeLiteralNode(t,s(t.members,n,B2))},188:function(t,n,i,s,o,l){return i.factory.updateArrayTypeNode(t,I.checkDefined(o(t.elementType,n,es)))},189:function(t,n,i,s,o,l){return i.factory.updateTupleTypeNode(t,s(t.elements,n,es))},190:function(t,n,i,s,o,l){return i.factory.updateOptionalTypeNode(t,I.checkDefined(o(t.type,n,es)))},191:function(t,n,i,s,o,l){return i.factory.updateRestTypeNode(t,I.checkDefined(o(t.type,n,es)))},192:function(t,n,i,s,o,l){return i.factory.updateUnionTypeNode(t,s(t.types,n,es))},193:function(t,n,i,s,o,l){return i.factory.updateIntersectionTypeNode(t,s(t.types,n,es))},194:function(t,n,i,s,o,l){return i.factory.updateConditionalTypeNode(t,I.checkDefined(o(t.checkType,n,es)),I.checkDefined(o(t.extendsType,n,es)),I.checkDefined(o(t.trueType,n,es)),I.checkDefined(o(t.falseType,n,es)))},195:function(t,n,i,s,o,l){return i.factory.updateInferTypeNode(t,I.checkDefined(o(t.typeParameter,n,Nc)))},205:function(t,n,i,s,o,l){return i.factory.updateImportTypeNode(t,I.checkDefined(o(t.argument,n,es)),o(t.attributes,n,tk),o(t.qualifier,n,zf),s(t.typeArguments,n,es),t.isTypeOf)},302:function(t,n,i,s,o,l){return i.factory.updateImportTypeAssertionContainer(t,I.checkDefined(o(t.assertClause,n,Nge)),t.multiLine)},202:function(t,n,i,s,o,l){return i.factory.updateNamedTupleMember(t,l?o(t.dotDotDotToken,l,ZB):t.dotDotDotToken,I.checkDefined(o(t.name,n,ze)),l?o(t.questionToken,l,Xv):t.questionToken,I.checkDefined(o(t.type,n,es)))},196:function(t,n,i,s,o,l){return i.factory.updateParenthesizedType(t,I.checkDefined(o(t.type,n,es)))},198:function(t,n,i,s,o,l){return i.factory.updateTypeOperatorNode(t,I.checkDefined(o(t.type,n,es)))},199:function(t,n,i,s,o,l){return i.factory.updateIndexedAccessTypeNode(t,I.checkDefined(o(t.objectType,n,es)),I.checkDefined(o(t.indexType,n,es)))},200:function(t,n,i,s,o,l){return i.factory.updateMappedTypeNode(t,l?o(t.readonlyToken,l,Qge):t.readonlyToken,I.checkDefined(o(t.typeParameter,n,Nc)),o(t.nameType,n,es),l?o(t.questionToken,l,Zge):t.questionToken,o(t.type,n,es),s(t.members,n,B2))},201:function(t,n,i,s,o,l){return i.factory.updateLiteralTypeNode(t,I.checkDefined(o(t.literal,n,Dpe)))},203:function(t,n,i,s,o,l){return i.factory.updateTemplateLiteralType(t,I.checkDefined(o(t.head,n,$A)),s(t.templateSpans,n,RK))},204:function(t,n,i,s,o,l){return i.factory.updateTemplateLiteralTypeSpan(t,I.checkDefined(o(t.type,n,es)),I.checkDefined(o(t.literal,n,P9)))},206:function(t,n,i,s,o,l){return i.factory.updateObjectBindingPattern(t,s(t.elements,n,co))},207:function(t,n,i,s,o,l){return i.factory.updateArrayBindingPattern(t,s(t.elements,n,D9))},208:function(t,n,i,s,o,l){return i.factory.updateBindingElement(t,l?o(t.dotDotDotToken,l,ZB):t.dotDotDotToken,o(t.propertyName,n,Al),I.checkDefined(o(t.name,n,j2)),o(t.initializer,n,bt))},209:function(t,n,i,s,o,l){return i.factory.updateArrayLiteralExpression(t,s(t.elements,n,bt))},210:function(t,n,i,s,o,l){return i.factory.updateObjectLiteralExpression(t,s(t.properties,n,by))},211:function(t,n,i,s,o,l){return C9(t)?i.factory.updatePropertyAccessChain(t,I.checkDefined(o(t.expression,n,bt)),l?o(t.questionDotToken,l,eU):t.questionDotToken,I.checkDefined(o(t.name,n,E0))):i.factory.updatePropertyAccessExpression(t,I.checkDefined(o(t.expression,n,bt)),I.checkDefined(o(t.name,n,E0)))},212:function(t,n,i,s,o,l){return rY(t)?i.factory.updateElementAccessChain(t,I.checkDefined(o(t.expression,n,bt)),l?o(t.questionDotToken,l,eU):t.questionDotToken,I.checkDefined(o(t.argumentExpression,n,bt))):i.factory.updateElementAccessExpression(t,I.checkDefined(o(t.expression,n,bt)),I.checkDefined(o(t.argumentExpression,n,bt)))},213:function(t,n,i,s,o,l){return L2(t)?i.factory.updateCallChain(t,I.checkDefined(o(t.expression,n,bt)),l?o(t.questionDotToken,l,eU):t.questionDotToken,s(t.typeArguments,n,es),s(t.arguments,n,bt)):i.factory.updateCallExpression(t,I.checkDefined(o(t.expression,n,bt)),s(t.typeArguments,n,es),s(t.arguments,n,bt))},214:function(t,n,i,s,o,l){return i.factory.updateNewExpression(t,I.checkDefined(o(t.expression,n,bt)),s(t.typeArguments,n,es),s(t.arguments,n,bt))},215:function(t,n,i,s,o,l){return i.factory.updateTaggedTemplateExpression(t,I.checkDefined(o(t.tag,n,bt)),s(t.typeArguments,n,es),I.checkDefined(o(t.template,n,SA)))},216:function(t,n,i,s,o,l){return i.factory.updateTypeAssertion(t,I.checkDefined(o(t.type,n,es)),I.checkDefined(o(t.expression,n,bt)))},217:function(t,n,i,s,o,l){return i.factory.updateParenthesizedExpression(t,I.checkDefined(o(t.expression,n,bt)))},218:function(t,n,i,s,o,l){return i.factory.updateFunctionExpression(t,s(t.modifiers,n,Ra),l?o(t.asteriskToken,l,IR):t.asteriskToken,o(t.name,n,ze),s(t.typeParameters,n,Nc),qc(t.parameters,n,i,s),o(t.type,n,es),ld(t.body,n,i,o))},219:function(t,n,i,s,o,l){return i.factory.updateArrowFunction(t,s(t.modifiers,n,Ra),s(t.typeParameters,n,Nc),qc(t.parameters,n,i,s),o(t.type,n,es),l?I.checkDefined(o(t.equalsGreaterThanToken,l,hge)):t.equalsGreaterThanToken,ld(t.body,n,i,o))},220:function(t,n,i,s,o,l){return i.factory.updateDeleteExpression(t,I.checkDefined(o(t.expression,n,bt)))},221:function(t,n,i,s,o,l){return i.factory.updateTypeOfExpression(t,I.checkDefined(o(t.expression,n,bt)))},222:function(t,n,i,s,o,l){return i.factory.updateVoidExpression(t,I.checkDefined(o(t.expression,n,bt)))},223:function(t,n,i,s,o,l){return i.factory.updateAwaitExpression(t,I.checkDefined(o(t.expression,n,bt)))},224:function(t,n,i,s,o,l){return i.factory.updatePrefixUnaryExpression(t,I.checkDefined(o(t.operand,n,bt)))},225:function(t,n,i,s,o,l){return i.factory.updatePostfixUnaryExpression(t,I.checkDefined(o(t.operand,n,bt)))},226:function(t,n,i,s,o,l){return i.factory.updateBinaryExpression(t,I.checkDefined(o(t.left,n,bt)),l?I.checkDefined(o(t.operatorToken,l,the)):t.operatorToken,I.checkDefined(o(t.right,n,bt)))},227:function(t,n,i,s,o,l){return i.factory.updateConditionalExpression(t,I.checkDefined(o(t.condition,n,bt)),l?I.checkDefined(o(t.questionToken,l,Xv)):t.questionToken,I.checkDefined(o(t.whenTrue,n,bt)),l?I.checkDefined(o(t.colonToken,l,gge)):t.colonToken,I.checkDefined(o(t.whenFalse,n,bt)))},228:function(t,n,i,s,o,l){return i.factory.updateTemplateExpression(t,I.checkDefined(o(t.head,n,$A)),s(t.templateSpans,n,B6))},229:function(t,n,i,s,o,l){return i.factory.updateYieldExpression(t,l?o(t.asteriskToken,l,IR):t.asteriskToken,o(t.expression,n,bt))},230:function(t,n,i,s,o,l){return i.factory.updateSpreadElement(t,I.checkDefined(o(t.expression,n,bt)))},231:function(t,n,i,s,o,l){return i.factory.updateClassExpression(t,s(t.modifiers,n,vc),o(t.name,n,ze),s(t.typeParameters,n,Nc),s(t.heritageClauses,n,ad),s(t.members,n,Du))},233:function(t,n,i,s,o,l){return i.factory.updateExpressionWithTypeArguments(t,I.checkDefined(o(t.expression,n,bt)),s(t.typeArguments,n,es))},234:function(t,n,i,s,o,l){return i.factory.updateAsExpression(t,I.checkDefined(o(t.expression,n,bt)),I.checkDefined(o(t.type,n,es)))},238:function(t,n,i,s,o,l){return i.factory.updateSatisfiesExpression(t,I.checkDefined(o(t.expression,n,bt)),I.checkDefined(o(t.type,n,es)))},235:function(t,n,i,s,o,l){return w_(t)?i.factory.updateNonNullChain(t,I.checkDefined(o(t.expression,n,bt))):i.factory.updateNonNullExpression(t,I.checkDefined(o(t.expression,n,bt)))},236:function(t,n,i,s,o,l){return i.factory.updateMetaProperty(t,I.checkDefined(o(t.name,n,ze)))},239:function(t,n,i,s,o,l){return i.factory.updateTemplateSpan(t,I.checkDefined(o(t.expression,n,bt)),I.checkDefined(o(t.literal,n,P9)))},241:function(t,n,i,s,o,l){return i.factory.updateBlock(t,s(t.statements,n,ns))},243:function(t,n,i,s,o,l){return i.factory.updateVariableStatement(t,s(t.modifiers,n,vc),I.checkDefined(o(t.declarationList,n,Tu)))},244:function(t,n,i,s,o,l){return i.factory.updateExpressionStatement(t,I.checkDefined(o(t.expression,n,bt)))},245:function(t,n,i,s,o,l){return i.factory.updateIfStatement(t,I.checkDefined(o(t.expression,n,bt)),I.checkDefined(o(t.thenStatement,n,ns,i.factory.liftToBlock)),o(t.elseStatement,n,ns,i.factory.liftToBlock))},246:function(t,n,i,s,o,l){return i.factory.updateDoStatement(t,df(t.statement,n,i,o),I.checkDefined(o(t.expression,n,bt)))},247:function(t,n,i,s,o,l){return i.factory.updateWhileStatement(t,I.checkDefined(o(t.expression,n,bt)),df(t.statement,n,i,o))},248:function(t,n,i,s,o,l){return i.factory.updateForStatement(t,o(t.initializer,n,Cd),o(t.condition,n,bt),o(t.incrementor,n,bt),df(t.statement,n,i,o))},249:function(t,n,i,s,o,l){return i.factory.updateForInStatement(t,I.checkDefined(o(t.initializer,n,Cd)),I.checkDefined(o(t.expression,n,bt)),df(t.statement,n,i,o))},250:function(t,n,i,s,o,l){return i.factory.updateForOfStatement(t,l?o(t.awaitModifier,l,OK):t.awaitModifier,I.checkDefined(o(t.initializer,n,Cd)),I.checkDefined(o(t.expression,n,bt)),df(t.statement,n,i,o))},251:function(t,n,i,s,o,l){return i.factory.updateContinueStatement(t,o(t.label,n,ze))},252:function(t,n,i,s,o,l){return i.factory.updateBreakStatement(t,o(t.label,n,ze))},253:function(t,n,i,s,o,l){return i.factory.updateReturnStatement(t,o(t.expression,n,bt))},254:function(t,n,i,s,o,l){return i.factory.updateWithStatement(t,I.checkDefined(o(t.expression,n,bt)),I.checkDefined(o(t.statement,n,ns,i.factory.liftToBlock)))},255:function(t,n,i,s,o,l){return i.factory.updateSwitchStatement(t,I.checkDefined(o(t.expression,n,bt)),I.checkDefined(o(t.caseBlock,n,V6)))},256:function(t,n,i,s,o,l){return i.factory.updateLabeledStatement(t,I.checkDefined(o(t.label,n,ze)),I.checkDefined(o(t.statement,n,ns,i.factory.liftToBlock)))},257:function(t,n,i,s,o,l){return i.factory.updateThrowStatement(t,I.checkDefined(o(t.expression,n,bt)))},258:function(t,n,i,s,o,l){return i.factory.updateTryStatement(t,I.checkDefined(o(t.tryBlock,n,ra)),o(t.catchClause,n,mE),o(t.finallyBlock,n,ra))},260:function(t,n,i,s,o,l){return i.factory.updateVariableDeclaration(t,I.checkDefined(o(t.name,n,j2)),l?o(t.exclamationToken,l,wR):t.exclamationToken,o(t.type,n,es),o(t.initializer,n,bt))},261:function(t,n,i,s,o,l){return i.factory.updateVariableDeclarationList(t,s(t.declarations,n,Gi))},262:function(t,n,i,s,o,l){return i.factory.updateFunctionDeclaration(t,s(t.modifiers,n,Ra),l?o(t.asteriskToken,l,IR):t.asteriskToken,o(t.name,n,ze),s(t.typeParameters,n,Nc),qc(t.parameters,n,i,s),o(t.type,n,es),ld(t.body,n,i,o))},263:function(t,n,i,s,o,l){return i.factory.updateClassDeclaration(t,s(t.modifiers,n,vc),o(t.name,n,ze),s(t.typeParameters,n,Nc),s(t.heritageClauses,n,ad),s(t.members,n,Du))},264:function(t,n,i,s,o,l){return i.factory.updateInterfaceDeclaration(t,s(t.modifiers,n,vc),I.checkDefined(o(t.name,n,ze)),s(t.typeParameters,n,Nc),s(t.heritageClauses,n,ad),s(t.members,n,B2))},265:function(t,n,i,s,o,l){return i.factory.updateTypeAliasDeclaration(t,s(t.modifiers,n,vc),I.checkDefined(o(t.name,n,ze)),s(t.typeParameters,n,Nc),I.checkDefined(o(t.type,n,es)))},266:function(t,n,i,s,o,l){return i.factory.updateEnumDeclaration(t,s(t.modifiers,n,vc),I.checkDefined(o(t.name,n,ze)),s(t.members,n,gE))},267:function(t,n,i,s,o,l){return i.factory.updateModuleDeclaration(t,s(t.modifiers,n,vc),I.checkDefined(o(t.name,n,ehe)),o(t.body,n,Ope))},268:function(t,n,i,s,o,l){return i.factory.updateModuleBlock(t,s(t.statements,n,ns))},269:function(t,n,i,s,o,l){return i.factory.updateCaseBlock(t,s(t.clauses,n,R9))},270:function(t,n,i,s,o,l){return i.factory.updateNamespaceExportDeclaration(t,I.checkDefined(o(t.name,n,ze)))},271:function(t,n,i,s,o,l){return i.factory.updateImportEqualsDeclaration(t,s(t.modifiers,n,vc),t.isTypeOnly,I.checkDefined(o(t.name,n,ze)),I.checkDefined(o(t.moduleReference,n,jpe)))},272:function(t,n,i,s,o,l){return i.factory.updateImportDeclaration(t,s(t.modifiers,n,vc),o(t.importClause,n,Jh),I.checkDefined(o(t.moduleSpecifier,n,bt)),o(t.attributes,n,tk))},300:function(t,n,i,s,o,l){return i.factory.updateImportAttributes(t,s(t.elements,n,Dge),t.multiLine)},301:function(t,n,i,s,o,l){return i.factory.updateImportAttribute(t,I.checkDefined(o(t.name,n,Epe)),I.checkDefined(o(t.value,n,bt)))},273:function(t,n,i,s,o,l){return i.factory.updateImportClause(t,t.isTypeOnly,o(t.name,n,ze),o(t.namedBindings,n,gY))},274:function(t,n,i,s,o,l){return i.factory.updateNamespaceImport(t,I.checkDefined(o(t.name,n,ze)))},280:function(t,n,i,s,o,l){return i.factory.updateNamespaceExport(t,I.checkDefined(o(t.name,n,ze)))},275:function(t,n,i,s,o,l){return i.factory.updateNamedImports(t,s(t.elements,n,Gf))},276:function(t,n,i,s,o,l){return i.factory.updateImportSpecifier(t,t.isTypeOnly,o(t.propertyName,n,ze),I.checkDefined(o(t.name,n,ze)))},277:function(t,n,i,s,o,l){return i.factory.updateExportAssignment(t,s(t.modifiers,n,vc),I.checkDefined(o(t.expression,n,bt)))},278:function(t,n,i,s,o,l){return i.factory.updateExportDeclaration(t,s(t.modifiers,n,vc),t.isTypeOnly,o(t.exportClause,n,iY),o(t.moduleSpecifier,n,bt),o(t.attributes,n,tk))},279:function(t,n,i,s,o,l){return i.factory.updateNamedExports(t,s(t.elements,n,R_))},281:function(t,n,i,s,o,l){return i.factory.updateExportSpecifier(t,t.isTypeOnly,o(t.propertyName,n,ze),I.checkDefined(o(t.name,n,ze)))},283:function(t,n,i,s,o,l){return i.factory.updateExternalModuleReference(t,I.checkDefined(o(t.expression,n,bt)))},284:function(t,n,i,s,o,l){return i.factory.updateJsxElement(t,I.checkDefined(o(t.openingElement,n,eh)),s(t.children,n,u8),I.checkDefined(o(t.closingElement,n,fE)))},285:function(t,n,i,s,o,l){return i.factory.updateJsxSelfClosingElement(t,I.checkDefined(o(t.tagName,n,Fw)),s(t.typeArguments,n,es),I.checkDefined(o(t.attributes,n,dE)))},286:function(t,n,i,s,o,l){return i.factory.updateJsxOpeningElement(t,I.checkDefined(o(t.tagName,n,Fw)),s(t.typeArguments,n,es),I.checkDefined(o(t.attributes,n,dE)))},287:function(t,n,i,s,o,l){return i.factory.updateJsxClosingElement(t,I.checkDefined(o(t.tagName,n,Fw)))},295:function(t,n,i,s,o,l){return i.factory.updateJsxNamespacedName(t,I.checkDefined(o(t.namespace,n,ze)),I.checkDefined(o(t.name,n,ze)))},288:function(t,n,i,s,o,l){return i.factory.updateJsxFragment(t,I.checkDefined(o(t.openingFragment,n,nk)),s(t.children,n,u8),I.checkDefined(o(t.closingFragment,n,Ige)))},291:function(t,n,i,s,o,l){return i.factory.updateJsxAttribute(t,I.checkDefined(o(t.name,n,$me)),o(t.initializer,n,Bpe))},292:function(t,n,i,s,o,l){return i.factory.updateJsxAttributes(t,s(t.properties,n,O9))},293:function(t,n,i,s,o,l){return i.factory.updateJsxSpreadAttribute(t,I.checkDefined(o(t.expression,n,bt)))},294:function(t,n,i,s,o,l){return i.factory.updateJsxExpression(t,o(t.expression,n,bt))},296:function(t,n,i,s,o,l){return i.factory.updateCaseClause(t,I.checkDefined(o(t.expression,n,bt)),s(t.statements,n,ns))},297:function(t,n,i,s,o,l){return i.factory.updateDefaultClause(t,s(t.statements,n,ns))},298:function(t,n,i,s,o,l){return i.factory.updateHeritageClause(t,s(t.types,n,L1))},299:function(t,n,i,s,o,l){return i.factory.updateCatchClause(t,o(t.variableDeclaration,n,Gi),I.checkDefined(o(t.block,n,ra)))},303:function(t,n,i,s,o,l){return i.factory.updatePropertyAssignment(t,I.checkDefined(o(t.name,n,Al)),I.checkDefined(o(t.initializer,n,bt)))},304:function(t,n,i,s,o,l){return i.factory.updateShorthandPropertyAssignment(t,I.checkDefined(o(t.name,n,ze)),o(t.objectAssignmentInitializer,n,bt))},305:function(t,n,i,s,o,l){return i.factory.updateSpreadAssignment(t,I.checkDefined(o(t.expression,n,bt)))},306:function(t,n,i,s,o,l){return i.factory.updateEnumMember(t,I.checkDefined(o(t.name,n,Al)),o(t.initializer,n,bt))},312:function(t,n,i,s,o,l){return i.factory.updateSourceFile(t,nZ(t.statements,n,i))},360:function(t,n,i,s,o,l){return i.factory.updatePartiallyEmittedExpression(t,I.checkDefined(o(t.expression,n,bt)))},361:function(t,n,i,s,o,l){return i.factory.updateCommaListExpression(t,s(t.elements,n,bt))}}}});function a0e(e,t,n,i,s){var{enter:o,exit:l}=s.extendedDiagnostics?MG("Source Map","beforeSourcemap","afterSourcemap"):LG,p=[],m=[],S=new Map,h,b=[],A,k=[],N="",M=0,O=0,U=0,H=0,K=0,re=0,$=!1,pe=0,z=0,se=0,Se=0,xe=0,Z=0,Q=!1,ce=!1,ye=!1;return{getSources:()=>p,addSource:we,setSourceContent:ve,addName:oe,addMapping:Ge,appendSourceMap:Ae,toJSON:ke,toString:()=>JSON.stringify(ke())};function we(at){o();let $t=dA(i,at,e.getCurrentDirectory(),e.getCanonicalFileName,!0),St=S.get($t);return St===void 0&&(St=m.length,m.push($t),p.push(at),S.set($t,St)),l(),St}function ve(at,$t){if(o(),$t!==null){for(h||(h=[]);h.length<at;)h.push(null);h[at]=$t}l()}function oe(at){o(),A||(A=new Map);let $t=A.get(at);return $t===void 0&&($t=b.length,b.push(at),A.set(at,$t)),l(),$t}function Ee(at,$t){return!Q||pe!==at||z!==$t}function Me(at,$t,St){return at!==void 0&&$t!==void 0&&St!==void 0&&se===at&&(Se>$t||Se===$t&&xe>St)}function Ge(at,$t,St,Ze,yt,ar){I.assert(at>=pe,"generatedLine cannot backtrack"),I.assert($t>=0,"generatedCharacter cannot be negative"),I.assert(St===void 0||St>=0,"sourceIndex cannot be negative"),I.assert(Ze===void 0||Ze>=0,"sourceLine cannot be negative"),I.assert(yt===void 0||yt>=0,"sourceCharacter cannot be negative"),o(),(Ee(at,$t)||Me(St,Ze,yt))&&(Ue(),pe=at,z=$t,ce=!1,ye=!1,Q=!0),St!==void 0&&Ze!==void 0&&yt!==void 0&&(se=St,Se=Ze,xe=yt,ce=!0,ar!==void 0&&(Z=ar,ye=!0)),l()}function Ae(at,$t,St,Ze,yt,ar){I.assert(at>=pe,"generatedLine cannot backtrack"),I.assert($t>=0,"generatedCharacter cannot be negative"),o();let or=[],Fr,rn=aZ(St.mappings);for(let Tr of rn){if(ar&&(Tr.generatedLine>ar.line||Tr.generatedLine===ar.line&&Tr.generatedCharacter>ar.character))break;if(yt&&(Tr.generatedLine<yt.line||yt.line===Tr.generatedLine&&Tr.generatedCharacter<yt.character))continue;let nr,tr,ki,xs;if(Tr.sourceIndex!==void 0){if(nr=or[Tr.sourceIndex],nr===void 0){let On=St.sources[Tr.sourceIndex],_r=St.sourceRoot?li(St.sourceRoot,On):On,rt=li(hi(Ze),_r);or[Tr.sourceIndex]=nr=we(rt),St.sourcesContent&&typeof St.sourcesContent[Tr.sourceIndex]=="string"&&ve(nr,St.sourcesContent[Tr.sourceIndex])}tr=Tr.sourceLine,ki=Tr.sourceCharacter,St.names&&Tr.nameIndex!==void 0&&(Fr||(Fr=[]),xs=Fr[Tr.nameIndex],xs===void 0&&(Fr[Tr.nameIndex]=xs=oe(St.names[Tr.nameIndex])))}let zi=Tr.generatedLine-(yt?yt.line:0),Ms=zi+at,un=yt&&yt.line===Tr.generatedLine?Tr.generatedCharacter-yt.character:Tr.generatedCharacter,ri=zi===0?un+$t:un;Ge(Ms,ri,nr,tr,ki,xs)}l()}function Ie(){return!$||M!==pe||O!==z||U!==se||H!==Se||K!==xe||re!==Z}function Re(at){k.push(at),k.length>=1024&&kt()}function Ue(){if(!(!Q||!Ie())){if(o(),M<pe){do Re(59),M++;while(M<pe);O=0}else I.assertEqual(M,pe,"generatedLine cannot backtrack"),$&&Re(44);$e(z-O),O=z,ce&&($e(se-U),U=se,$e(Se-H),H=Se,$e(xe-K),K=xe,ye&&($e(Z-re),re=Z)),$=!0,l()}}function kt(){k.length>0&&(N+=String.fromCharCode.apply(void 0,k),k.length=0)}function ke(){return Ue(),kt(),{version:3,file:t,sourceRoot:n,sources:m,names:b,mappings:N,sourcesContent:h}}function $e(at){at<0?at=(-at<<1)+1:at=at<<1;do{let $t=at&31;at=at>>5,at>0&&($t=$t|32),Re(rSt($t))}while(at>0)}}function iZ(e,t){return{getLineCount:()=>t.length,getLineText:n=>e.substring(t[n],t[n+1])}}function o0e(e){for(let t=e.getLineCount()-1;t>=0;t--){let n=e.getLineText(t),i=eV.exec(n);if(i)return i[1].trimEnd();if(!n.match(tV))break}}function tSt(e){return typeof e=="string"||e===null}function c0e(e){return e!==null&&typeof e=="object"&&e.version===3&&typeof e.file=="string"&&typeof e.mappings=="string"&&os(e.sources)&&yr(e.sources,vs)&&(e.sourceRoot===void 0||e.sourceRoot===null||typeof e.sourceRoot=="string")&&(e.sourcesContent===void 0||e.sourcesContent===null||os(e.sourcesContent)&&yr(e.sourcesContent,tSt))&&(e.names===void 0||e.names===null||os(e.names)&&yr(e.names,vs))}function sZ(e){try{let t=JSON.parse(e);if(c0e(t))return t}catch{}}function aZ(e){let t=!1,n=0,i=0,s=0,o=0,l=0,p=0,m=0,S;return{get pos(){return n},get error(){return S},get state(){return h(!0,!0)},next(){for(;!t&&n<e.length;){let U=e.charCodeAt(n);if(U===59){i++,s=0,n++;continue}if(U===44){n++;continue}let H=!1,K=!1;if(s+=O(),N())return b();if(s<0)return k("Invalid generatedCharacter found");if(!M()){if(H=!0,o+=O(),N())return b();if(o<0)return k("Invalid sourceIndex found");if(M())return k("Unsupported Format: No entries after sourceIndex");if(l+=O(),N())return b();if(l<0)return k("Invalid sourceLine found");if(M())return k("Unsupported Format: No entries after sourceLine");if(p+=O(),N())return b();if(p<0)return k("Invalid sourceCharacter found");if(!M()){if(K=!0,m+=O(),N())return b();if(m<0)return k("Invalid nameIndex found");if(!M())return k("Unsupported Error Format: Entries after nameIndex")}}return{value:h(H,K),done:t}}return b()},[Symbol.iterator](){return this}};function h(U,H){return{generatedLine:i,generatedCharacter:s,sourceIndex:U?o:void 0,sourceLine:U?l:void 0,sourceCharacter:U?p:void 0,nameIndex:H?m:void 0}}function b(){return t=!0,{value:void 0,done:!0}}function A(U){S===void 0&&(S=U)}function k(U){return A(U),b()}function N(){return S!==void 0}function M(){return n===e.length||e.charCodeAt(n)===44||e.charCodeAt(n)===59}function O(){let U=!0,H=0,K=0;for(;U;n++){if(n>=e.length)return A("Error in decoding base64VLQFormatDecode, past the mapping string"),-1;let re=nSt(e.charCodeAt(n));if(re===-1)return A("Invalid character in VLQ"),-1;U=(re&32)!==0,K=K|(re&31)<<H,H+=5}return K&1?(K=K>>1,K=-K):K=K>>1,K}}function mMe(e,t){return e===t||e.generatedLine===t.generatedLine&&e.generatedCharacter===t.generatedCharacter&&e.sourceIndex===t.sourceIndex&&e.sourceLine===t.sourceLine&&e.sourceCharacter===t.sourceCharacter&&e.nameIndex===t.nameIndex}function l0e(e){return e.sourceIndex!==void 0&&e.sourceLine!==void 0&&e.sourceCharacter!==void 0}function rSt(e){return e>=0&&e<26?65+e:e>=26&&e<52?97+e-26:e>=52&&e<62?48+e-52:e===62?43:e===63?47:I.fail(`${e}: not a base64 value`)}function nSt(e){return e>=65&&e<=90?e-65:e>=97&&e<=122?e-97+26:e>=48&&e<=57?e-48+52:e===43?62:e===47?63:-1}function gMe(e){return e.sourceIndex!==void 0&&e.sourcePosition!==void 0}function hMe(e,t){return e.generatedPosition===t.generatedPosition&&e.sourceIndex===t.sourceIndex&&e.sourcePosition===t.sourcePosition}function iSt(e,t){return I.assert(e.sourceIndex===t.sourceIndex),To(e.sourcePosition,t.sourcePosition)}function sSt(e,t){return To(e.generatedPosition,t.generatedPosition)}function aSt(e){return e.sourcePosition}function oSt(e){return e.generatedPosition}function u0e(e,t,n){let i=hi(n),s=t.sourceRoot?Ps(t.sourceRoot,i):i,o=Ps(t.file,i),l=e.getSourceFileLike(o),p=t.sources.map(H=>Ps(H,s)),m=new Map(p.map((H,K)=>[e.getCanonicalFileName(H),K])),S,h,b;return{getSourcePosition:U,getGeneratedPosition:O};function A(H){let K=l!==void 0?V3(l,H.generatedLine,H.generatedCharacter,!0):-1,re,$;if(l0e(H)){let pe=e.getSourceFileLike(p[H.sourceIndex]);re=t.sources[H.sourceIndex],$=pe!==void 0?V3(pe,H.sourceLine,H.sourceCharacter,!0):-1}return{generatedPosition:K,source:re,sourceIndex:H.sourceIndex,sourcePosition:$,nameIndex:H.nameIndex}}function k(){if(S===void 0){let H=aZ(t.mappings),K=In(H,A);H.error!==void 0?(e.log&&e.log(`Encountered error while decoding sourcemap: ${H.error}`),S=tt):S=K}return S}function N(H){if(b===void 0){let K=[];for(let re of k()){if(!gMe(re))continue;let $=K[re.sourceIndex];$||(K[re.sourceIndex]=$=[]),$.push(re)}b=K.map(re=>rT(re,iSt,hMe))}return b[H]}function M(){if(h===void 0){let H=[];for(let K of k())H.push(K);h=rT(H,sSt,hMe)}return h}function O(H){let K=m.get(e.getCanonicalFileName(H.fileName));if(K===void 0)return H;let re=N(K);if(!Tt(re))return H;let $=nT(re,H.pos,aSt,To);$<0&&($=~$);let pe=re[$];return pe===void 0||pe.sourceIndex!==K?H:{fileName:o,pos:pe.generatedPosition}}function U(H){let K=M();if(!Tt(K))return H;let re=nT(K,H.pos,oSt,To);re<0&&(re=~re);let $=K[re];return $===void 0||!gMe($)?H:{fileName:p[$.sourceIndex],pos:$.sourcePosition}}}var oZ,eV,tV,rV,cSt=f({"src/compiler/sourcemap.ts"(){"use strict";fa(),O2(),oZ=/\/\/[@#] source[M]appingURL=(.+)\r?\n?$/,eV=/^\/\/[@#] source[M]appingURL=(.+)\r?\n?$/,tV=/^\s*(\/\/[@#] .*)?$/,rV={getSourcePosition:Mo,getGeneratedPosition:Mo}}});function E_(e){return e=Hc(e),e?yo(e):0}function lSt(e){return!e||!Dy(e)?!1:Tt(e.elements,yMe)}function yMe(e){return e.propertyName!==void 0&&e.propertyName.escapedText==="default"}function qm(e,t){return n;function n(s){return s.kind===312?t(s):i(s)}function i(s){return e.factory.createBundle(vr(s.sourceFiles,t),s.prepends)}}function _0e(e){return!!gN(e)}function nV(e){if(gN(e))return!0;let t=e.importClause&&e.importClause.namedBindings;if(!t||!Dy(t))return!1;let n=0;for(let i of t.elements)yMe(i)&&n++;return n>0&&n!==t.elements.length||!!(t.elements.length-n)&&xA(e)}function cZ(e){return!nV(e)&&(xA(e)||!!e.importClause&&Dy(e.importClause.namedBindings)&&lSt(e.importClause.namedBindings))}function lZ(e,t){let n=e.getEmitResolver(),i=e.getCompilerOptions(),s=[],o=new pZ,l=[],p=new Map,m,S=!1,h,b=!1,A=!1,k=!1;for(let O of t.statements)switch(O.kind){case 272:s.push(O),!A&&nV(O)&&(A=!0),!k&&cZ(O)&&(k=!0);break;case 271:O.moduleReference.kind===283&&s.push(O);break;case 278:if(O.moduleSpecifier)if(!O.exportClause)s.push(O),b=!0;else if(s.push(O),wd(O.exportClause))M(O);else{let U=O.exportClause.name;p.get(Nn(U))||(iO(l,E_(O),U),p.set(Nn(U),!0),m=Pr(m,U)),A=!0}else M(O);break;case 277:O.isExportEquals&&!h&&(h=O);break;case 243:if(ui(O,32))for(let U of O.declarationList.declarations)m=vMe(U,p,m,l);break;case 262:if(ui(O,32))if(ui(O,2048))S||(iO(l,E_(O),e.factory.getDeclarationName(O)),S=!0);else{let U=O.name;p.get(Nn(U))||(iO(l,E_(O),U),p.set(Nn(U),!0),m=Pr(m,U))}break;case 263:if(ui(O,32))if(ui(O,2048))S||(iO(l,E_(O),e.factory.getDeclarationName(O)),S=!0);else{let U=O.name;U&&!p.get(Nn(U))&&(iO(l,E_(O),U),p.set(Nn(U),!0),m=Pr(m,U))}break}let N=eQ(e.factory,e.getEmitHelperFactory(),t,i,b,A,k);return N&&s.unshift(N),{externalImports:s,exportSpecifiers:o,exportEquals:h,hasExportStarsToExportValues:b,exportedBindings:l,exportedNames:m,externalHelpersImportDeclaration:N};function M(O){for(let U of ta(O.exportClause,wd).elements)if(!p.get(Nn(U.name))){let H=U.propertyName||U.name;O.moduleSpecifier||o.add(H,U);let K=n.getReferencedImportDeclaration(H)||n.getReferencedValueDeclaration(H);K&&iO(l,E_(K),U.name),p.set(Nn(U.name),!0),m=Pr(m,U.name)}}}function vMe(e,t,n,i){if(la(e.name))for(let s of e.name.elements)Su(s)||(n=vMe(s,t,n,i));else if(!yc(e.name)){let s=Nn(e.name);t.get(s)||(t.set(s,!0),n=Pr(n,e.name),Iy(e.name)&&iO(i,E_(e),e.name))}return n}function iO(e,t,n){let i=e[t];return i?i.push(n):e[t]=i=[n],i}function TE(e){return bo(e)||e.kind===9||Nf(e.kind)||ze(e)}function rh(e){return!ze(e)&&TE(e)}function sO(e){return e>=65&&e<=79}function aO(e){switch(e){case 65:return 40;case 66:return 41;case 67:return 42;case 68:return 43;case 69:return 44;case 70:return 45;case 71:return 48;case 72:return 49;case 73:return 50;case 74:return 51;case 75:return 52;case 79:return 53;case 76:return 57;case 77:return 56;case 78:return 61}}function iV(e){if(!Ou(e))return;let t=Do(e.expression);return $2(t)?t:void 0}function SMe(e,t,n){for(let i=t;i<e.length;i+=1){let s=e[i];if(iV(s))return n.unshift(i),!0;if(fx(s)&&SMe(s.tryBlock.statements,0,n))return n.unshift(i),!0}return!1}function sV(e,t){let n=[];return SMe(e,t,n),n}function uZ(e,t,n){return Fn(e.members,i=>_St(i,t,n))}function uSt(e){return fSt(e)||Jc(e)}function aV(e){return Fn(e.members,uSt)}function _St(e,t,n){return ea(e)&&(!!e.initializer||!t)&&jl(e)===n}function fSt(e){return ea(e)&&jl(e)}function bM(e){return e.kind===172&&e.initializer!==void 0}function f0e(e){return!pa(e)&&(vA(e)||Af(e))&&is(e.name)}function p0e(e){let t;if(e){let n=e.parameters,i=n.length>0&&Zb(n[0]),s=i?1:0,o=i?n.length-1:n.length;for(let l=0;l<o;l++){let p=n[l+s];(t||Ad(p))&&(t||(t=new Array(o)),t[l]=wv(p))}}return t}function _Z(e){let t=wv(e),n=p0e(I0(e));if(!(!Tt(t)&&!Tt(n)))return{decorators:t,parameters:n}}function oV(e,t,n){switch(e.kind){case 177:case 178:return n?pSt(e,t):TMe(e);case 174:return TMe(e);case 172:return dSt(e);default:return}}function pSt(e,t){if(!e.body)return;let{firstAccessor:n,secondAccessor:i,getAccessor:s,setAccessor:o}=tx(t.members,e),l=Ad(n)?n:i&&Ad(i)?i:void 0;if(!l||e!==l)return;let p=wv(l),m=p0e(o);if(!(!Tt(p)&&!Tt(m)))return{decorators:p,parameters:m,getDecorators:s&&wv(s),setDecorators:o&&wv(o)}}function TMe(e){if(!e.body)return;let t=wv(e),n=p0e(e);if(!(!Tt(t)&&!Tt(n)))return{decorators:t,parameters:n}}function dSt(e){let t=wv(e);if(Tt(t))return{decorators:t}}function d0e(e,t){for(;e;){let n=t(e);if(n!==void 0)return n;e=e.previous}}function m0e(e){return{data:e}}function fZ(e,t){var n,i;return F2(t)?(n=e?.generatedIdentifiers)==null?void 0:n.get(HR(t)):(i=e?.identifiers)==null?void 0:i.get(t.escapedText)}function Sx(e,t,n){F2(t)?(e.generatedIdentifiers??(e.generatedIdentifiers=new Map),e.generatedIdentifiers.set(HR(t),n)):(e.identifiers??(e.identifiers=new Map),e.identifiers.set(t.escapedText,n))}function g0e(e,t){return d0e(e,n=>fZ(n.privateEnv,t))}function h0e(e){return!e.initializer&&ze(e.name)}function EM(e){return yr(e,h0e)}var fk,pZ,mSt=f({"src/compiler/transformers/utilities.ts"(){"use strict";fa(),fk=class _w{constructor(){this._map=new Map}get size(){return this._map.size}has(t){return this._map.has(_w.toKey(t))}get(t){return this._map.get(_w.toKey(t))}set(t,n){return this._map.set(_w.toKey(t),n),this}delete(t){var n;return((n=this._map)==null?void 0:n.delete(_w.toKey(t)))??!1}clear(){this._map.clear()}values(){return this._map.values()}static toKey(t){if(F2(t)||yc(t)){let n=t.emitNode.autoGenerate;if((n.flags&7)===4){let i=HR(t),s=E0(i)&&i!==t?_w.toKey(i):`(generated@${yo(i)})`;return NT(!1,n.prefix,s,n.suffix,_w.toKey)}else{let i=`(auto@${n.id})`;return NT(!1,n.prefix,i,n.suffix,_w.toKey)}}return is(t)?Nn(t).slice(1):Nn(t)}},pZ=class extends fk{add(e,t){let n=this.get(e);return n?n.push(t):this.set(e,n=[t]),n}remove(e,t){let n=this.get(e);n&&(uA(n,t),n.length||this.delete(e))}}}});function Tx(e,t,n,i,s,o){let l=e,p;if(I1(e))for(p=e.right;ime(e.left)||kX(e.left);)if(I1(p))l=e=p,p=e.right;else return I.checkDefined(nt(p,t,bt));let m,S={context:n,level:i,downlevelIteration:!!n.getCompilerOptions().downlevelIteration,hoistTempVariables:!0,emitExpression:h,emitBindingOrAssignment:b,createArrayBindingOrAssignmentPattern:A=>ESt(n.factory,A),createObjectBindingOrAssignmentPattern:A=>CSt(n.factory,A),createArrayBindingOrAssignmentElement:kSt,visitor:t};if(p&&(p=nt(p,t,bt),I.assert(p),ze(p)&&y0e(e,p.escapedText)||v0e(e)?p=pk(S,p,!1,l):s?p=pk(S,p,!0,l):_c(e)&&(l=p)),oO(S,e,p,l,I1(e)),p&&s){if(!Tt(m))return p;m.push(p)}return n.factory.inlineExpressions(m)||n.factory.createOmittedExpression();function h(A){m=Pr(m,A)}function b(A,k,N,M){I.assertNode(A,o?ze:bt);let O=o?o(A,k,N):ft(n.factory.createAssignment(I.checkDefined(nt(A,t,bt)),k),N);O.original=M,h(O)}}function y0e(e,t){let n=rS(e);return i8(n)?gSt(n,t):ze(n)?n.escapedText===t:!1}function gSt(e,t){let n=ZN(e);for(let i of n)if(y0e(i,t))return!0;return!1}function v0e(e){let t=vU(e);if(t&&uo(t)&&!Ub(t.expression))return!0;let n=rS(e);return!!n&&i8(n)&&hSt(n)}function hSt(e){return!!Te(ZN(e),v0e)}function bE(e,t,n,i,s,o=!1,l){let p,m=[],S=[],h={context:n,level:i,downlevelIteration:!!n.getCompilerOptions().downlevelIteration,hoistTempVariables:o,emitExpression:b,emitBindingOrAssignment:A,createArrayBindingOrAssignmentPattern:k=>bSt(n.factory,k),createObjectBindingOrAssignmentPattern:k=>xSt(n.factory,k),createArrayBindingOrAssignmentElement:k=>ASt(n.factory,k),visitor:t};if(Gi(e)){let k=WR(e);k&&(ze(k)&&y0e(e,k.escapedText)||v0e(e))&&(k=pk(h,I.checkDefined(nt(k,h.visitor,bt)),!1,k),e=n.factory.updateVariableDeclaration(e,e.name,void 0,void 0,k))}if(oO(h,e,s,e,l),p){let k=n.factory.createTempVariable(void 0);if(o){let N=n.factory.inlineExpressions(p);p=void 0,A(k,N,void 0,void 0)}else{n.hoistVariableDeclaration(k);let N=Rs(m);N.pendingExpressions=Pr(N.pendingExpressions,n.factory.createAssignment(k,N.value)),jt(N.pendingExpressions,p),N.value=k}}for(let{pendingExpressions:k,name:N,value:M,location:O,original:U}of m){let H=n.factory.createVariableDeclaration(N,void 0,void 0,k?n.factory.inlineExpressions(Pr(k,M)):M);H.original=U,ft(H,O),S.push(H)}return S;function b(k){p=Pr(p,k)}function A(k,N,M,O){I.assertNode(k,j2),p&&(N=n.factory.inlineExpressions(Pr(p,N)),p=void 0),m.push({pendingExpressions:p,name:k,value:N,location:M,original:O})}}function oO(e,t,n,i,s){let o=rS(t);if(!s){let l=nt(WR(t),e.visitor,bt);l?n?(n=SSt(e,n,l,i),!rh(l)&&i8(o)&&(n=pk(e,n,!0,i))):n=l:n||(n=e.context.factory.createVoidZero())}_Y(o)?ySt(e,t,o,n,i):fY(o)?vSt(e,t,o,n,i):e.emitBindingOrAssignment(o,n,i,t)}function ySt(e,t,n,i,s){let o=ZN(n),l=o.length;if(l!==1){let S=!n8(t)||l!==0;i=pk(e,i,S,s)}let p,m;for(let S=0;S<l;S++){let h=o[S];if(yU(h)){if(S===l-1){p&&(e.emitBindingOrAssignment(e.createObjectBindingOrAssignmentPattern(p),i,s,n),p=void 0);let b=e.context.getEmitHelperFactory().createRestHelper(i,o,m,n);oO(e,h,b,h)}}else{let b=tQ(h);if(e.level>=1&&!(h.transformFlags&98304)&&!(rS(h).transformFlags&98304)&&!uo(b))p=Pr(p,nt(h,e.visitor,Ape));else{p&&(e.emitBindingOrAssignment(e.createObjectBindingOrAssignmentPattern(p),i,s,n),p=void 0);let A=TSt(e,i,b);uo(b)&&(m=Pr(m,A.argumentExpression)),oO(e,h,A,h)}}}p&&e.emitBindingOrAssignment(e.createObjectBindingOrAssignmentPattern(p),i,s,n)}function vSt(e,t,n,i,s){let o=ZN(n),l=o.length;if(e.level<1&&e.downlevelIteration)i=pk(e,ft(e.context.getEmitHelperFactory().createReadHelper(i,l>0&&yU(o[l-1])?void 0:l),s),!1,s);else if(l!==1&&(e.level<1||l===0)||yr(o,Su)){let S=!n8(t)||l!==0;i=pk(e,i,S,s)}let p,m;for(let S=0;S<l;S++){let h=o[S];if(e.level>=1)if(h.transformFlags&65536||e.hasTransformedPriorElement&&!bMe(h)){e.hasTransformedPriorElement=!0;let b=e.context.factory.createTempVariable(void 0);e.hoistTempVariables&&e.context.hoistVariableDeclaration(b),m=Pr(m,[b,h]),p=Pr(p,e.createArrayBindingOrAssignmentElement(b))}else p=Pr(p,h);else{if(Su(h))continue;if(yU(h)){if(S===l-1){let b=e.context.factory.createArraySliceCall(i,S);oO(e,h,b,h)}}else{let b=e.context.factory.createElementAccessExpression(i,S);oO(e,h,b,h)}}}if(p&&e.emitBindingOrAssignment(e.createArrayBindingOrAssignmentPattern(p),i,s,n),m)for(let[S,h]of m)oO(e,h,S,h)}function bMe(e){let t=rS(e);if(!t||Su(t))return!0;let n=vU(e);if(n&&!Wg(n))return!1;let i=WR(e);return i&&!rh(i)?!1:i8(t)?yr(ZN(t),bMe):ze(t)}function SSt(e,t,n,i){return t=pk(e,t,!0,i),e.context.factory.createConditionalExpression(e.context.factory.createTypeCheck(t,"undefined"),void 0,n,void 0,t)}function TSt(e,t,n){let{factory:i}=e.context;if(uo(n)){let s=pk(e,I.checkDefined(nt(n.expression,e.visitor,bt)),!1,n);return e.context.factory.createElementAccessExpression(t,s)}else if(id(n)){let s=i.cloneNode(n);return e.context.factory.createElementAccessExpression(t,s)}else{let s=e.context.factory.createIdentifier(Nn(n));return e.context.factory.createPropertyAccessExpression(t,s)}}function pk(e,t,n,i){if(ze(t)&&n)return t;{let s=e.context.factory.createTempVariable(void 0);return e.hoistTempVariables?(e.context.hoistVariableDeclaration(s),e.emitExpression(ft(e.context.factory.createAssignment(s,t),i))):e.emitBindingOrAssignment(s,t,i,void 0),s}}function bSt(e,t){return I.assertEachNode(t,D9),e.createArrayBindingPattern(t)}function ESt(e,t){return I.assertEachNode(t,a8),e.createArrayLiteralExpression(vr(t,e.converters.convertToArrayAssignmentElement))}function xSt(e,t){return I.assertEachNode(t,co),e.createObjectBindingPattern(t)}function CSt(e,t){return I.assertEachNode(t,s8),e.createObjectLiteralExpression(vr(t,e.converters.convertToObjectAssignmentElement))}function ASt(e,t){return e.createBindingElement(void 0,void 0,t)}function kSt(e){return e}var dZ,PSt=f({"src/compiler/transformers/destructuring.ts"(){"use strict";fa(),dZ=(e=>(e[e.All=0]="All",e[e.ObjectRest=1]="ObjectRest",e))(dZ||{})}});function S0e(e,t,n=e.createThis()){let i=e.createAssignment(t,n),s=e.createExpressionStatement(i),o=e.createBlock([s],!1),l=e.createClassStaticBlockDeclaration(o);return b_(l).classThis=t,l}function cO(e){var t;if(!Jc(e)||e.body.statements.length!==1)return!1;let n=e.body.statements[0];return Ou(n)&&lu(n.expression,!0)&&ze(n.expression.left)&&((t=e.emitNode)==null?void 0:t.classThis)===n.expression.left&&n.expression.right.kind===110}function mZ(e){var t;return!!((t=e.emitNode)!=null&&t.classThis)&&Tt(e.members,cO)}function T0e(e,t,n,i){if(mZ(t))return t;let s=S0e(e,n,i);t.name&&qa(s.body.statements[0],t.name);let o=e.createNodeArray([s,...t.members]);ft(o,t.members);let l=eu(t)?e.updateClassDeclaration(t,t.modifiers,t.name,t.typeParameters,t.heritageClauses,o):e.updateClassExpression(t,t.modifiers,t.name,t.typeParameters,t.heritageClauses,o);return b_(l).classThis=n,l}var NSt=f({"src/compiler/transformers/classThis.ts"(){"use strict";fa()}});function lO(e,t,n){let i=Hc(vl(n));return(eu(i)||Zl(i))&&!i.name&&ui(i,2048)?e.createStringLiteral("default"):e.createStringLiteralFromNode(t)}function EMe(e,t,n){let{factory:i}=e;if(n!==void 0)return{assignedName:i.createStringLiteral(n),name:t};if(Wg(t)||is(t))return{assignedName:i.createStringLiteralFromNode(t),name:t};if(Wg(t.expression)&&!ze(t.expression))return{assignedName:i.createStringLiteralFromNode(t.expression),name:t};let s=i.getGeneratedNameForNode(t);e.hoistVariableDeclaration(s);let o=e.getEmitHelperFactory().createPropKeyHelper(t.expression),l=i.createAssignment(s,o),p=i.updateComputedPropertyName(t,l);return{assignedName:s,name:p}}function b0e(e,t,n=e.factory.createThis()){let{factory:i}=e,s=e.getEmitHelperFactory().createSetFunctionNameHelper(n,t),o=i.createExpressionStatement(s),l=i.createBlock([o],!1),p=i.createClassStaticBlockDeclaration(l);return b_(p).assignedName=t,p}function dk(e){var t;if(!Jc(e)||e.body.statements.length!==1)return!1;let n=e.body.statements[0];return Ou(n)&&O6(n.expression,"___setFunctionName")&&n.expression.arguments.length>=2&&n.expression.arguments[1]===((t=e.emitNode)==null?void 0:t.assignedName)}function cV(e){var t;return!!((t=e.emitNode)!=null&&t.assignedName)&&Tt(e.members,dk)}function gZ(e){return!!e.name||cV(e)}function lV(e,t,n,i){if(cV(t))return t;let{factory:s}=e,o=b0e(e,n,i);t.name&&qa(o.body.statements[0],t.name);let l=oa(t.members,cO)+1,p=t.members.slice(0,l),m=t.members.slice(l),S=s.createNodeArray([...p,o,...m]);return ft(S,t.members),t=eu(t)?s.updateClassDeclaration(t,t.modifiers,t.name,t.typeParameters,t.heritageClauses,S):s.updateClassExpression(t,t.modifiers,t.name,t.typeParameters,t.heritageClauses,S),b_(t).assignedName=n,t}function uD(e,t,n,i){if(i&&za(n)&&qY(n))return t;let{factory:s}=e,o=vl(t),l=wu(o)?ta(lV(e,o,n),wu):e.getEmitHelperFactory().createSetFunctionNameHelper(o,n);return s.restoreOuterExpressions(t,l)}function DSt(e,t,n,i){let{factory:s}=e,{assignedName:o,name:l}=EMe(e,t.name,i),p=uD(e,t.initializer,o,n);return s.updatePropertyAssignment(t,l,p)}function ISt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):lO(s,t.name,t.objectAssignmentInitializer),l=uD(e,t.objectAssignmentInitializer,o,n);return s.updateShorthandPropertyAssignment(t,t.name,l)}function wSt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):lO(s,t.name,t.initializer),l=uD(e,t.initializer,o,n);return s.updateVariableDeclaration(t,t.name,t.exclamationToken,t.type,l)}function OSt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):lO(s,t.name,t.initializer),l=uD(e,t.initializer,o,n);return s.updateParameterDeclaration(t,t.modifiers,t.dotDotDotToken,t.name,t.questionToken,t.type,l)}function RSt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):lO(s,t.name,t.initializer),l=uD(e,t.initializer,o,n);return s.updateBindingElement(t,t.dotDotDotToken,t.propertyName,t.name,l)}function MSt(e,t,n,i){let{factory:s}=e,{assignedName:o,name:l}=EMe(e,t.name,i),p=uD(e,t.initializer,o,n);return s.updatePropertyDeclaration(t,t.modifiers,l,t.questionToken??t.exclamationToken,t.type,p)}function LSt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):lO(s,t.left,t.right),l=uD(e,t.right,o,n);return s.updateBinaryExpression(t,t.left,t.operatorToken,l)}function FSt(e,t,n,i){let{factory:s}=e,o=i!==void 0?s.createStringLiteral(i):s.createStringLiteral(t.isExportEquals?"":"default"),l=uD(e,t.expression,o,n);return s.updateExportAssignment(t,t.modifiers,l)}function mp(e,t,n,i){switch(t.kind){case 303:return DSt(e,t,n,i);case 304:return ISt(e,t,n,i);case 260:return wSt(e,t,n,i);case 169:return OSt(e,t,n,i);case 208:return RSt(e,t,n,i);case 172:return MSt(e,t,n,i);case 226:return LSt(e,t,n,i);case 277:return FSt(e,t,n,i)}}var jSt=f({"src/compiler/transformers/namedEvaluation.ts"(){"use strict";fa()}});function hZ(e,t,n,i,s,o){let l=nt(t.tag,n,bt);I.assert(l);let p=[void 0],m=[],S=[],h=t.template;if(o===0&&!dX(h))return wr(t,n,e);let{factory:b}=e;if(zA(h))m.push(E0e(b,h)),S.push(x0e(b,h,i));else{m.push(E0e(b,h.head)),S.push(x0e(b,h.head,i));for(let k of h.templateSpans)m.push(E0e(b,k.literal)),S.push(x0e(b,k.literal,i)),p.push(I.checkDefined(nt(k.expression,n,bt)))}let A=e.getEmitHelperFactory().createTemplateObjectHelper(b.createArrayLiteralExpression(m),b.createArrayLiteralExpression(S));if(Pl(i)){let k=b.createUniqueName("templateObject");s(k),p[0]=b.createLogicalOr(k,b.createAssignment(k,A))}else p[0]=A;return b.createCallExpression(l,void 0,p)}function E0e(e,t){return t.templateFlags&26656?e.createVoidZero():e.createStringLiteral(t.text)}function x0e(e,t,n){let i=t.rawText;if(i===void 0){I.assertIsDefined(n,"Template literal node is missing 'rawText' and does not have a source file. Possibly bad transform."),i=Jb(n,t);let s=t.kind===15||t.kind===18;i=i.substring(1,i.length-(s?1:2))}return i=i.replace(/\r\n?/g,`
`),ft(e.createStringLiteral(i),t)}var yZ,BSt=f({"src/compiler/transformers/taggedTemplate.ts"(){"use strict";fa(),yZ=(e=>(e[e.LiftRestriction=0]="LiftRestriction",e[e.All=1]="All",e))(yZ||{})}});function C0e(e){let{factory:t,getEmitHelperFactory:n,startLexicalEnvironment:i,resumeLexicalEnvironment:s,endLexicalEnvironment:o,hoistVariableDeclaration:l}=e,p=e.getEmitResolver(),m=e.getCompilerOptions(),S=ho(m),h=T_(m),b=!!m.experimentalDecorators,A=m.emitDecoratorMetadata?k0e(e):void 0,k=e.onEmitNode,N=e.onSubstituteNode;e.onEmitNode=Nl,e.onSubstituteNode=zc,e.enableSubstitution(211),e.enableSubstitution(212);let M,O,U,H,K,re,$,pe;return z;function z(ne){return ne.kind===313?se(ne):Se(ne)}function se(ne){return t.createBundle(ne.sourceFiles.map(Se),Wi(ne.prepends,je=>je.kind===315?yK(je,"js"):je))}function Se(ne){if(ne.isDeclarationFile)return ne;M=ne;let je=xe(ne,at);return Ny(je,e.readEmitHelpers()),M=void 0,je}function xe(ne,je){let Et=H,gr=K,Dn=re;Z(ne);let xn=je(ne);return H!==Et&&(K=gr),H=Et,re=Dn,xn}function Z(ne){switch(ne.kind){case 312:case 269:case 268:case 241:H=ne,K=void 0;break;case 263:case 262:if(ui(ne,128))break;ne.name?X(ne):I.assert(ne.kind===263||ui(ne,2048));break}}function Q(ne){return xe(ne,ce)}function ce(ne){return ne.transformFlags&1?$e(ne):ne}function ye(ne){return xe(ne,we)}function we(ne){switch(ne.kind){case 272:case 271:case 277:case 278:return oe(ne);default:return ce(ne)}}function ve(ne){let je=Us(ne);if(je===ne||Kc(ne))return!1;if(!je||je.kind!==ne.kind)return!0;switch(ne.kind){case 272:if(I.assertNode(je,uu),ne.importClause!==je.importClause||ne.attributes!==je.attributes)return!0;break;case 271:if(I.assertNode(je,Ru),ne.name!==je.name||ne.isTypeOnly!==je.isTypeOnly||ne.moduleReference!==je.moduleReference&&(zf(ne.moduleReference)||zf(je.moduleReference)))return!0;break;case 278:if(I.assertNode(je,yl),ne.exportClause!==je.exportClause||ne.attributes!==je.attributes)return!0;break}return!1}function oe(ne){if(ve(ne))return ne.transformFlags&1?wr(ne,Q,e):ne;switch(ne.kind){case 272:return Ir(ne);case 271:return js(ne);case 277:return Fi(ne);case 278:return fn(ne);default:I.fail("Unhandled ellided statement")}}function Ee(ne){return xe(ne,Me)}function Me(ne){if(!(ne.kind===278||ne.kind===272||ne.kind===273||ne.kind===271&&ne.moduleReference.kind===283))return ne.transformFlags&1||ui(ne,32)?$e(ne):ne}function Ge(ne){return je=>xe(je,Et=>Ae(Et,ne))}function Ae(ne,je){switch(ne.kind){case 176:return Rr(ne);case 172:return zt(ne,je);case 177:return to(ne,je);case 178:return Nr(ne,je);case 174:return Fs(ne,je);case 175:return wr(ne,Q,e);case 240:return ne;case 181:return;default:return I.failBadSyntaxKind(ne)}}function Ie(ne){return je=>xe(je,Et=>Re(Et,ne))}function Re(ne,je){switch(ne.kind){case 303:case 304:case 305:return Q(ne);case 177:return to(ne,je);case 178:return Nr(ne,je);case 174:return Fs(ne,je);default:return I.failBadSyntaxKind(ne)}}function Ue(ne){return n_(ne)?void 0:Q(ne)}function kt(ne){return Ra(ne)?void 0:Q(ne)}function ke(ne){if(!n_(ne)&&!(IA(ne.kind)&28895)&&!(O&&ne.kind===95))return ne}function $e(ne){if(ns(ne)&&ui(ne,128))return t.createNotEmittedStatement(ne);switch(ne.kind){case 95:case 90:return O?void 0:ne;case 125:case 123:case 124:case 128:case 164:case 87:case 138:case 148:case 103:case 147:case 188:case 189:case 190:case 191:case 187:case 182:case 168:case 133:case 159:case 136:case 154:case 150:case 146:case 116:case 155:case 185:case 184:case 186:case 183:case 192:case 193:case 194:case 196:case 197:case 198:case 199:case 200:case 201:case 181:return;case 265:return t.createNotEmittedStatement(ne);case 270:return;case 264:return t.createNotEmittedStatement(ne);case 263:return ar(ne);case 231:return or(ne);case 298:return On(ne);case 233:return _r(ne);case 210:return $t(ne);case 176:case 172:case 174:case 177:case 178:case 175:return I.fail("Class and object literal elements must be visited with their respective visitors");case 262:return qr(ne);case 218:return We(ne);case 219:return mt(ne);case 169:return dt(ne);case 217:return pt(ne);case 216:case 234:return W(ne);case 238:return Nt(ne);case 213:return Ke(ne);case 214:return ht(ne);case 215:return Wt(ne);case 235:return st(ne);case 266:return Y(ne);case 243:return Ot(ne);case 260:return Ve(ne);case 267:return It(ne);case 271:return js(ne);case 285:return Cr(ne);case 286:return hr(ne);default:return wr(ne,Q,e)}}function at(ne){let je=K_(m,"alwaysStrict")&&!(Pl(ne)&&h>=5)&&!sm(ne);return t.updateSourceFile(ne,nZ(ne.statements,ye,e,0,je))}function $t(ne){return t.updateObjectLiteralExpression(ne,Hr(ne.properties,Ie(ne),by))}function St(ne){let je=0;Tt(uZ(ne,!0,!0))&&(je|=1);let Et=$g(ne);return Et&&vl(Et.expression).kind!==106&&(je|=64),k1(b,ne)&&(je|=2),zw(b,ne)&&(je|=4),Mr(ne)?je|=8:zs(ne)?je|=32:Sl(ne)&&(je|=16),je}function Ze(ne){return!!(ne.transformFlags&8192)}function yt(ne){return Ad(ne)||Tt(ne.typeParameters)||Tt(ne.heritageClauses,Ze)||Tt(ne.members,Ze)}function ar(ne){let je=St(ne),Et=S<=1&&!!(je&7);if(!yt(ne)&&!k1(b,ne)&&!Mr(ne))return t.updateClassDeclaration(ne,Hr(ne.modifiers,ke,Ra),ne.name,void 0,Hr(ne.heritageClauses,Q,ad),Hr(ne.members,Ge(ne),Du));Et&&e.startLexicalEnvironment();let gr=Et||je&8,Dn=gr?Hr(ne.modifiers,kt,vc):Hr(ne.modifiers,Q,vc);je&2&&(Dn=rn(Dn,ne));let Zn=gr&&!ne.name||je&4||je&1?ne.name??t.getGeneratedNameForNode(ne):ne.name,Bi=t.updateClassDeclaration(ne,Dn,Zn,void 0,Hr(ne.heritageClauses,Q,ad),Fr(ne)),Jn=eo(ne);je&1&&(Jn|=64),Sn(Bi,Jn);let ia;if(Et){let Fc=[Bi],bu=NX(Wa(M.text,ne.members.end),20),sc=t.getInternalName(ne),Jl=t.createPartiallyEmittedExpression(sc);RN(Jl,bu.end),Sn(Jl,3072);let jo=t.createReturnStatement(Jl);S6(jo,bu.pos),Sn(jo,3840),Fc.push(jo),C0(Fc,e.endLexicalEnvironment());let Eu=t.createImmediatelyInvokedArrowFunction(Fc);CR(Eu,1);let Xf=t.createVariableDeclaration(t.getLocalName(ne,!1,!1),void 0,void 0,Eu);Un(Xf,ne);let pu=t.createVariableStatement(void 0,t.createVariableDeclarationList([Xf],1));Un(pu,ne),kl(pu,ne),qa(pu,Ay(ne)),M_(pu),ia=pu}else ia=Bi;if(gr){if(je&8)return[ia,Eo(ne)];if(je&32)return[ia,t.createExportDefault(t.getLocalName(ne,!1,!0))];if(je&16)return[ia,t.createExternalModuleExport(t.getDeclarationName(ne,!1,!0))]}return ia}function or(ne){let je=Hr(ne.modifiers,kt,vc);return k1(b,ne)&&(je=rn(je,ne)),t.updateClassExpression(ne,je,ne.name,void 0,Hr(ne.heritageClauses,Q,ad),Fr(ne))}function Fr(ne){let je=Hr(ne.members,Ge(ne),Du),Et,gr=I0(ne),Dn=gr&&Fn(gr.parameters,xn=>op(xn,gr));if(Dn)for(let xn of Dn){let Zn=t.createPropertyDeclaration(void 0,xn.name,void 0,void 0,void 0);Un(Zn,xn),Et=Pr(Et,Zn)}return Et?(Et=jt(Et,je),ft(t.createNodeArray(Et),ne.members)):je}function rn(ne,je){let Et=nr(je,je);if(Tt(Et)){let gr=[];jt(gr,z5(ne,GR)),jt(gr,Fn(ne,n_)),jt(gr,Et),jt(gr,Fn(xfe(ne,GR),Ra)),ne=ft(t.createNodeArray(gr),ne)}return ne}function Tr(ne,je,Et){if(Ti(Et)&&JY(b,je,Et)){let gr=nr(je,Et);if(Tt(gr)){let Dn=[];jt(Dn,Fn(ne,n_)),jt(Dn,gr),jt(Dn,Fn(ne,Ra)),ne=ft(t.createNodeArray(Dn),ne)}}return ne}function nr(ne,je){if(b)return xMe?ki(ne,je):tr(ne,je)}function tr(ne,je){if(A){let Et;if(xs(ne)){let gr=n().createMetadataHelper("design:type",A.serializeTypeOfNode({currentLexicalScope:H,currentNameScope:je},ne));Et=Pr(Et,t.createDecorator(gr))}if(Ms(ne)){let gr=n().createMetadataHelper("design:paramtypes",A.serializeParameterTypesOfNode({currentLexicalScope:H,currentNameScope:je},ne,je));Et=Pr(Et,t.createDecorator(gr))}if(zi(ne)){let gr=n().createMetadataHelper("design:returntype",A.serializeReturnTypeOfNode({currentLexicalScope:H,currentNameScope:je},ne));Et=Pr(Et,t.createDecorator(gr))}return Et}}function ki(ne,je){if(A){let Et;if(xs(ne)){let gr=t.createPropertyAssignment("type",t.createArrowFunction(void 0,void 0,[],void 0,t.createToken(39),A.serializeTypeOfNode({currentLexicalScope:H,currentNameScope:je},ne)));Et=Pr(Et,gr)}if(Ms(ne)){let gr=t.createPropertyAssignment("paramTypes",t.createArrowFunction(void 0,void 0,[],void 0,t.createToken(39),A.serializeParameterTypesOfNode({currentLexicalScope:H,currentNameScope:je},ne,je)));Et=Pr(Et,gr)}if(zi(ne)){let gr=t.createPropertyAssignment("returnType",t.createArrowFunction(void 0,void 0,[],void 0,t.createToken(39),A.serializeReturnTypeOfNode({currentLexicalScope:H,currentNameScope:je},ne)));Et=Pr(Et,gr)}if(Et){let gr=n().createMetadataHelper("design:typeinfo",t.createObjectLiteralExpression(Et,!0));return[t.createDecorator(gr)]}}}function xs(ne){let je=ne.kind;return je===174||je===177||je===178||je===172}function zi(ne){return ne.kind===174}function Ms(ne){switch(ne.kind){case 263:case 231:return I0(ne)!==void 0;case 174:case 177:case 178:return!0}return!1}function un(ne,je){let Et=ne.name;return is(Et)?t.createIdentifier(""):uo(Et)?je&&!rh(Et.expression)?t.getGeneratedNameForNode(Et):Et.expression:ze(Et)?t.createStringLiteral(Nn(Et)):t.cloneNode(Et)}function ri(ne){let je=ne.name;if(uo(je)&&(!jl(ne)&&re||Ad(ne)&&b)){let Et=nt(je.expression,Q,bt);I.assert(Et);let gr=Mm(Et);if(!rh(gr)){let Dn=t.getGeneratedNameForNode(je);return l(Dn),t.updateComputedPropertyName(je,t.createAssignment(Dn,Et))}}return I.checkDefined(nt(je,Q,Al))}function On(ne){if(ne.token!==119)return wr(ne,Q,e)}function _r(ne){return t.updateExpressionWithTypeArguments(ne,I.checkDefined(nt(ne.expression,Q,$f)),void 0)}function rt(ne){return!sl(ne.body)}function zt(ne,je){let Et=ne.flags&33554432||ui(ne,64);if(Et&&!(b&&Ad(ne)))return;let gr=Ti(je)?Et?Hr(ne.modifiers,kt,vc):Hr(ne.modifiers,Q,vc):Hr(ne.modifiers,Ue,vc);return gr=Tr(gr,ne,je),Et?t.updatePropertyDeclaration(ne,ys(gr,t.createModifiersFromModifierFlags(128)),I.checkDefined(nt(ne.name,Q,Al)),void 0,void 0,void 0):t.updatePropertyDeclaration(ne,gr,ri(ne),void 0,void 0,nt(ne.initializer,Q,bt))}function Rr(ne){if(rt(ne))return t.updateConstructorDeclaration(ne,void 0,qc(ne.parameters,Q,e),Ni(ne.body,ne))}function vi(ne,je,Et,gr,Dn,xn){let Zn=gr[Dn],Bi=je[Zn];if(jt(ne,Hr(je,Q,ns,Et,Zn-Et)),fx(Bi)){let Jn=[];vi(Jn,Bi.tryBlock.statements,0,gr,Dn+1,xn);let ia=t.createNodeArray(Jn);ft(ia,Bi.tryBlock.statements),ne.push(t.updateTryStatement(Bi,t.updateBlock(Bi.tryBlock,Jn),nt(Bi.catchClause,Q,mE),nt(Bi.finallyBlock,Q,ra)))}else jt(ne,Hr(je,Q,ns,Zn,1)),jt(ne,xn);jt(ne,Hr(je,Q,ns,Zn+1))}function Ni(ne,je){let Et=je&&Fn(je.parameters,Jn=>op(Jn,je));if(!Tt(Et))return ld(ne,Q,e);let gr=[];s();let Dn=t.copyPrologue(ne.statements,gr,!1,Q),xn=sV(ne.statements,Dn),Zn=Wi(Et,us);xn.length?vi(gr,ne.statements,Dn,xn,0,Zn):(jt(gr,Zn),jt(gr,Hr(ne.statements,Q,ns,Dn))),gr=t.mergeLexicalEnvironment(gr,o());let Bi=t.createBlock(ft(t.createNodeArray(gr),ne.statements),!0);return ft(Bi,ne),Un(Bi,ne),Bi}function us(ne){let je=ne.name;if(!ze(je))return;let Et=io(ft(t.cloneNode(je),je),je.parent);Sn(Et,3168);let gr=io(ft(t.cloneNode(je),je),je.parent);return Sn(gr,3072),M_(xR(ft(Un(t.createExpressionStatement(t.createAssignment(ft(t.createPropertyAccessExpression(t.createThis(),Et),ne.name),gr)),ne),TT(ne,-1))))}function Fs(ne,je){if(!(ne.transformFlags&1))return ne;if(!rt(ne))return;let Et=Ti(je)?Hr(ne.modifiers,Q,vc):Hr(ne.modifiers,Ue,vc);return Et=Tr(Et,ne,je),t.updateMethodDeclaration(ne,Et,ne.asteriskToken,ri(ne),void 0,void 0,qc(ne.parameters,Q,e),void 0,ld(ne.body,Q,e))}function Ta(ne){return!(sl(ne.body)&&ui(ne,64))}function to(ne,je){if(!(ne.transformFlags&1))return ne;if(!Ta(ne))return;let Et=Ti(je)?Hr(ne.modifiers,Q,vc):Hr(ne.modifiers,Ue,vc);return Et=Tr(Et,ne,je),t.updateGetAccessorDeclaration(ne,Et,ri(ne),qc(ne.parameters,Q,e),void 0,ld(ne.body,Q,e)||t.createBlock([]))}function Nr(ne,je){if(!(ne.transformFlags&1))return ne;if(!Ta(ne))return;let Et=Ti(je)?Hr(ne.modifiers,Q,vc):Hr(ne.modifiers,Ue,vc);return Et=Tr(Et,ne,je),t.updateSetAccessorDeclaration(ne,Et,ri(ne),qc(ne.parameters,Q,e),ld(ne.body,Q,e)||t.createBlock([]))}function qr(ne){if(!rt(ne))return t.createNotEmittedStatement(ne);let je=t.updateFunctionDeclaration(ne,Hr(ne.modifiers,ke,Ra),ne.asteriskToken,ne.name,void 0,qc(ne.parameters,Q,e),void 0,ld(ne.body,Q,e)||t.createBlock([]));if(Mr(ne)){let Et=[je];return nc(Et,ne),Et}return je}function We(ne){return rt(ne)?t.updateFunctionExpression(ne,Hr(ne.modifiers,ke,Ra),ne.asteriskToken,ne.name,void 0,qc(ne.parameters,Q,e),void 0,ld(ne.body,Q,e)||t.createBlock([])):t.createOmittedExpression()}function mt(ne){return t.updateArrowFunction(ne,Hr(ne.modifiers,ke,Ra),void 0,qc(ne.parameters,Q,e),void 0,ne.equalsGreaterThanToken,ld(ne.body,Q,e))}function dt(ne){if(Zb(ne))return;let je=t.updateParameterDeclaration(ne,Hr(ne.modifiers,Et=>n_(Et)?Q(Et):void 0,vc),ne.dotDotDotToken,I.checkDefined(nt(ne.name,Q,j2)),void 0,void 0,nt(ne.initializer,Q,bt));return je!==ne&&(kl(je,ne),ft(je,Xg(ne)),qa(je,Xg(ne)),Sn(je.name,64)),je}function Ot(ne){if(Mr(ne)){let je=u6(ne.declarationList);return je.length===0?void 0:ft(t.createExpressionStatement(t.inlineExpressions(vr(je,_e))),ne)}else return wr(ne,Q,e)}function _e(ne){let je=ne.name;return la(je)?Tx(ne,Q,e,0,!1,zu):ft(t.createAssignment(ks(je),I.checkDefined(nt(ne.initializer,Q,bt))),ne)}function Ve(ne){let je=t.updateVariableDeclaration(ne,I.checkDefined(nt(ne.name,Q,j2)),void 0,void 0,nt(ne.initializer,Q,bt));return ne.type&&lge(je.name,ne.type),je}function pt(ne){let je=vl(ne.expression,-7);if(U2(je)){let Et=nt(ne.expression,Q,bt);return I.assert(Et),t.createPartiallyEmittedExpression(Et,ne)}return wr(ne,Q,e)}function W(ne){let je=nt(ne.expression,Q,bt);return I.assert(je),t.createPartiallyEmittedExpression(je,ne)}function st(ne){let je=nt(ne.expression,Q,$f);return I.assert(je),t.createPartiallyEmittedExpression(je,ne)}function Nt(ne){let je=nt(ne.expression,Q,bt);return I.assert(je),t.createPartiallyEmittedExpression(je,ne)}function Ke(ne){return t.updateCallExpression(ne,I.checkDefined(nt(ne.expression,Q,bt)),void 0,Hr(ne.arguments,Q,bt))}function ht(ne){return t.updateNewExpression(ne,I.checkDefined(nt(ne.expression,Q,bt)),void 0,Hr(ne.arguments,Q,bt))}function Wt(ne){return t.updateTaggedTemplateExpression(ne,I.checkDefined(nt(ne.tag,Q,bt)),void 0,I.checkDefined(nt(ne.template,Q,SA)))}function Cr(ne){return t.updateJsxSelfClosingElement(ne,I.checkDefined(nt(ne.tagName,Q,Fw)),void 0,I.checkDefined(nt(ne.attributes,Q,dE)))}function hr(ne){return t.updateJsxOpeningElement(ne,I.checkDefined(nt(ne.tagName,Q,Fw)),void 0,I.checkDefined(nt(ne.attributes,Q,dE)))}function Sr(ne){return!zb(ne)||aE(m)}function Y(ne){if(!Sr(ne))return t.createNotEmittedStatement(ne);let je=[],Et=4,gr=Le(je,ne);gr&&(h!==4||H!==M)&&(Et|=1024);let Dn=ya(ne),xn=$u(ne),Zn=Mr(ne)?t.getExternalModuleOrNamespaceExportName(U,ne,!1,!0):t.getDeclarationName(ne,!1,!0),Bi=t.createLogicalOr(Zn,t.createAssignment(Zn,t.createObjectLiteralExpression()));if(Mr(ne)){let ia=t.getLocalName(ne,!1,!0);Bi=t.createAssignment(ia,Bi)}let Jn=t.createExpressionStatement(t.createCallExpression(t.createFunctionExpression(void 0,void 0,void 0,void 0,[t.createParameterDeclaration(void 0,void 0,Dn)],void 0,Be(ne,xn)),void 0,[Bi]));return Un(Jn,ne),gr&&(CT(Jn,void 0),UA(Jn,void 0)),ft(Jn,ne),Kg(Jn,Et),je.push(Jn),je}function Be(ne,je){let Et=U;U=je;let gr=[];i();let Dn=vr(ne.members,Lt);return C0(gr,o()),jt(gr,Dn),U=Et,t.createBlock(ft(t.createNodeArray(gr),ne.members),!0)}function Lt(ne){let je=un(ne,!1),Et=B(ne),gr=t.createAssignment(t.createElementAccessExpression(U,je),Et),Dn=Et.kind===11?gr:t.createAssignment(t.createElementAccessExpression(U,gr),je);return ft(t.createExpressionStatement(ft(Dn,ne)),ne)}function B(ne){let je=p.getConstantValue(ne);return je!==void 0?typeof je=="string"?t.createStringLiteral(je):je<0?t.createPrefixUnaryExpression(41,t.createNumericLiteral(-je)):t.createNumericLiteral(je):(Uo(),ne.initializer?I.checkDefined(nt(ne.initializer,Q,bt)):t.createVoidZero())}function le(ne){let je=Us(ne,hl);return je?QQ(je,aE(m)):!0}function X(ne){K||(K=new Map);let je=qe(ne);K.has(je)||K.set(je,ne)}function he(ne){if(K){let je=qe(ne);return K.get(je)===ne}return!0}function qe(ne){return I.assertNode(ne.name,ze),ne.name.escapedText}function Le(ne,je){let Et=t.createVariableDeclaration(t.getLocalName(je,!1,!0)),gr=H.kind===312?0:1,Dn=t.createVariableStatement(Hr(je.modifiers,ke,Ra),t.createVariableDeclarationList([Et],gr));return Un(Et,je),CT(Et,void 0),UA(Et,void 0),Un(Dn,je),X(je),he(je)?(je.kind===266?qa(Dn.declarationList,je):qa(Dn,je),kl(Dn,je),Kg(Dn,2048),ne.push(Dn),!0):!1}function It(ne){if(!le(ne))return t.createNotEmittedStatement(ne);I.assertNode(ne.name,ze,"A TypeScript namespace should have an Identifier name."),$a();let je=[],Et=4,gr=Le(je,ne);gr&&(h!==4||H!==M)&&(Et|=1024);let Dn=ya(ne),xn=$u(ne),Zn=Mr(ne)?t.getExternalModuleOrNamespaceExportName(U,ne,!1,!0):t.getDeclarationName(ne,!1,!0),Bi=t.createLogicalOr(Zn,t.createAssignment(Zn,t.createObjectLiteralExpression()));if(Mr(ne)){let ia=t.getLocalName(ne,!1,!0);Bi=t.createAssignment(ia,Bi)}let Jn=t.createExpressionStatement(t.createCallExpression(t.createFunctionExpression(void 0,void 0,void 0,void 0,[t.createParameterDeclaration(void 0,void 0,Dn)],void 0,Rt(ne,xn)),void 0,[Bi]));return Un(Jn,ne),gr&&(CT(Jn,void 0),UA(Jn,void 0)),ft(Jn,ne),Kg(Jn,Et),je.push(Jn),je}function Rt(ne,je){let Et=U,gr=O,Dn=K;U=je,O=ne,K=void 0;let xn=[];i();let Zn,Bi;if(ne.body)if(ne.body.kind===268)xe(ne.body,ia=>jt(xn,Hr(ia.statements,Ee,ns))),Zn=ne.body.statements,Bi=ne.body;else{let ia=It(ne.body);ia&&(os(ia)?jt(xn,ia):xn.push(ia));let Fc=Zt(ne).body;Zn=TT(Fc.statements,-1)}C0(xn,o()),U=Et,O=gr,K=Dn;let Jn=t.createBlock(ft(t.createNodeArray(xn),Zn),!0);return ft(Jn,Bi),(!ne.body||ne.body.kind!==268)&&Sn(Jn,eo(Jn)|3072),Jn}function Zt(ne){if(ne.body.kind===267)return Zt(ne.body)||ne.body}function Ir(ne){if(!ne.importClause)return ne;if(ne.importClause.isTypeOnly)return;let je=nt(ne.importClause,zr,Jh);return je||m.importsNotUsedAsValues===1||m.importsNotUsedAsValues===2?t.updateImportDeclaration(ne,void 0,je,ne.moduleSpecifier,ne.attributes):void 0}function zr(ne){I.assert(!ne.isTypeOnly);let je=ge(ne)?ne.name:void 0,Et=nt(ne.namedBindings,Yr,gY);return je||Et?t.updateImportClause(ne,!1,je,Et):void 0}function Yr(ne){if(ne.kind===274)return ge(ne)?ne:void 0;{let je=m.verbatimModuleSyntax||m.preserveValueImports&&(m.importsNotUsedAsValues===1||m.importsNotUsedAsValues===2),Et=Hr(ne.elements,Pi,Gf);return je||Tt(Et)?t.updateNamedImports(ne,Et):void 0}}function Pi(ne){return!ne.isTypeOnly&&ge(ne)?ne:void 0}function Fi(ne){return m.verbatimModuleSyntax||p.isValueAliasDeclaration(ne)?wr(ne,Q,e):void 0}function fn(ne){if(ne.isTypeOnly)return;if(!ne.exportClause||qh(ne.exportClause))return ne;let je=m.verbatimModuleSyntax||!!ne.moduleSpecifier&&(m.importsNotUsedAsValues===1||m.importsNotUsedAsValues===2),Et=nt(ne.exportClause,gr=>Vi(gr,je),iY);return Et?t.updateExportDeclaration(ne,void 0,ne.isTypeOnly,Et,ne.moduleSpecifier,ne.attributes):void 0}function Qn(ne,je){let Et=Hr(ne.elements,ji,R_);return je||Tt(Et)?t.updateNamedExports(ne,Et):void 0}function Ns(ne){return t.updateNamespaceExport(ne,I.checkDefined(nt(ne.name,Q,ze)))}function Vi(ne,je){return qh(ne)?Ns(ne):Qn(ne,je)}function ji(ne){return!ne.isTypeOnly&&(m.verbatimModuleSyntax||p.isValueAliasDeclaration(ne))?ne:void 0}function ni(ne){return ge(ne)||!Pl(M)&&p.isTopLevelValueImportEqualsWithEntityName(ne)}function js(ne){if(ne.isTypeOnly)return;if(gT(ne)){let Et=ge(ne);return!Et&&m.importsNotUsedAsValues===1?Un(ft(t.createImportDeclaration(void 0,void 0,ne.moduleReference.expression,void 0),ne),ne):Et?wr(ne,Q,e):void 0}if(!ni(ne))return;let je=JR(t,ne.moduleReference);return Sn(je,7168),Sl(ne)||!Mr(ne)?Un(ft(t.createVariableStatement(Hr(ne.modifiers,ke,Ra),t.createVariableDeclarationList([Un(t.createVariableDeclaration(ne.name,void 0,void 0,je),ne)])),ne),ne):Un(Dc(ne.name,je,ne),ne)}function Mr(ne){return O!==void 0&&ui(ne,32)}function Qo(ne){return O===void 0&&ui(ne,32)}function Sl(ne){return Qo(ne)&&!ui(ne,2048)}function zs(ne){return Qo(ne)&&ui(ne,2048)}function Eo(ne){let je=t.createAssignment(t.getExternalModuleOrNamespaceExportName(U,ne,!1,!0),t.getLocalName(ne));qa(je,kd(ne.name?ne.name.pos:ne.pos,ne.end));let Et=t.createExpressionStatement(je);return qa(Et,kd(-1,ne.end)),Et}function nc(ne,je){ne.push(Eo(je))}function Dc(ne,je,Et){return ft(t.createExpressionStatement(t.createAssignment(t.getNamespaceMemberName(U,ne,!1,!0),je)),Et)}function zu(ne,je,Et){return ft(t.createAssignment(ks(ne),je),Et)}function ks(ne){return t.getNamespaceMemberName(U,ne,!1,!0)}function ya(ne){let je=t.getGeneratedNameForNode(ne);return qa(je,ne.name),je}function $u(ne){return t.getGeneratedNameForNode(ne)}function Uo(){$&8||($|=8,e.enableSubstitution(80))}function $a(){$&2||($|=2,e.enableSubstitution(80),e.enableSubstitution(304),e.enableEmitNotification(267))}function Ac(ne){return Hc(ne).kind===267}function Ld(ne){return Hc(ne).kind===266}function Nl(ne,je,Et){let gr=pe,Dn=M;ls(je)&&(M=je),$&2&&Ac(je)&&(pe|=2),$&8&&Ld(je)&&(pe|=8),k(ne,je,Et),pe=gr,M=Dn}function zc(ne,je){return je=N(ne,je),ne===1?$s(je):Hf(je)?Tc(je):je}function Tc(ne){if($&2){let je=ne.name,Et=ic(je);if(Et){if(ne.objectAssignmentInitializer){let gr=t.createAssignment(Et,ne.objectAssignmentInitializer);return ft(t.createPropertyAssignment(je,gr),ne)}return ft(t.createPropertyAssignment(je,Et),ne)}}return ne}function $s(ne){switch(ne.kind){case 80:return cr(ne);case 211:return Mu(ne);case 212:return Wu(ne)}return ne}function cr(ne){return ic(ne)||ne}function ic(ne){if($&pe&&!yc(ne)&&!Iy(ne)){let je=p.getReferencedExportContainer(ne,!1);if(je&&je.kind!==312&&(pe&2&&je.kind===267||pe&8&&je.kind===266))return ft(t.createPropertyAccessExpression(t.getGeneratedNameForNode(je),ne),ne)}}function Mu(ne){return Go(ne)}function Wu(ne){return Go(ne)}function yp(ne){return ne.replace(/\*\//g,"*_/")}function Go(ne){let je=ru(ne);if(je!==void 0){oge(ne,je);let Et=typeof je=="string"?t.createStringLiteral(je):je<0?t.createPrefixUnaryExpression(41,t.createNumericLiteral(-je)):t.createNumericLiteral(je);if(!m.removeComments){let gr=Hc(ne,Yo);bB(Et,3,` ${yp(Fl(gr))} `)}return Et}return ne}function ru(ne){if(!fm(m))return Hn(ne)||fc(ne)?p.getConstantValue(ne):void 0}function ge(ne){return m.verbatimModuleSyntax||gn(ne)||(m.preserveValueImports?p.isValueAliasDeclaration(ne):p.isReferencedAliasDeclaration(ne))}}var xMe,USt=f({"src/compiler/transformers/ts.ts"(){"use strict";fa(),xMe=!1}});function A0e(e){let{factory:t,getEmitHelperFactory:n,hoistVariableDeclaration:i,endLexicalEnvironment:s,startLexicalEnvironment:o,resumeLexicalEnvironment:l,addBlockScopedVariable:p}=e,m=e.getEmitResolver(),S=e.getCompilerOptions(),h=ho(S),b=D6(S),A=!!S.experimentalDecorators,k=!b,N=b&&h<9,M=k||N,O=h<9,U=h<99?-1:b?0:3,H=h<9,K=H&&h>=2,re=M||O||U===-1,$=e.onSubstituteNode;e.onSubstituteNode=Mu;let pe=e.onEmitNode;e.onEmitNode=ic;let z=!1,se,Se,xe,Z,Q,ce=new Map,ye=new Set,we,ve,oe=!1,Ee=!1;return qm(e,Me);function Me(ge){if(ge.isDeclarationFile||(Q=void 0,z=!!(Lm(ge)&32),!re&&!z))return ge;let ne=wr(ge,Ae,e);return Ny(ne,e.readEmitHelpers()),ne}function Ge(ge){switch(ge.kind){case 129:return zt()?void 0:ge;default:return ii(ge,Ra)}}function Ae(ge){if(!(ge.transformFlags&16777216)&&!(ge.transformFlags&134234112))return ge;switch(ge.kind){case 129:return I.fail("Use `modifierVisitor` instead.");case 263:return hr(ge);case 231:return Y(ge);case 175:case 172:return I.fail("Use `classElementVisitor` instead.");case 303:return Ze(ge);case 243:return yt(ge);case 260:return ar(ge);case 169:return or(ge);case 208:return Fr(ge);case 277:return rn(ge);case 81:return $t(ge);case 211:return Ta(ge);case 212:return to(ge);case 224:case 225:return Nr(ge,!1);case 226:return pt(ge,!1);case 217:return st(ge,!1);case 213:return dt(ge);case 244:return We(ge);case 215:return Ot(ge);case 248:return qr(ge);case 110:return B(ge);case 262:case 218:return zi(void 0,Ie,ge);case 176:case 174:case 177:case 178:return zi(ge,Ie,ge);default:return Ie(ge)}}function Ie(ge){return wr(ge,Ae,e)}function Re(ge){switch(ge.kind){case 224:case 225:return Nr(ge,!0);case 226:return pt(ge,!0);case 361:return W(ge,!0);case 217:return st(ge,!0);default:return Ae(ge)}}function Ue(ge){switch(ge.kind){case 298:return wr(ge,Ue,e);case 233:return Wt(ge);default:return Ae(ge)}}function kt(ge){switch(ge.kind){case 210:case 209:return cr(ge);default:return Ae(ge)}}function ke(ge){switch(ge.kind){case 176:return zi(ge,tr,ge);case 177:case 178:case 174:return zi(ge,xs,ge);case 172:return zi(ge,Rr,ge);case 175:return zi(ge,Lt,ge);case 167:return nr(ge);case 240:return ge;default:return vc(ge)?Ge(ge):Ae(ge)}}function $e(ge){switch(ge.kind){case 167:return nr(ge);default:return Ae(ge)}}function at(ge){switch(ge.kind){case 172:return rt(ge);case 177:case 178:return ke(ge);default:I.assertMissingNode(ge,"Expected node to either be a PropertyDeclaration, GetAccessorDeclaration, or SetAccessorDeclaration");break}}function $t(ge){return!O||ns(ge.parent)?ge:Un(t.createIdentifier(""),ge)}function St(ge){let ne=ya(ge.left);if(ne){let je=nt(ge.right,Ae,bt);return Un(n().createClassPrivateFieldInHelper(ne.brandCheckIdentifier,je),ge)}return wr(ge,Ae,e)}function Ze(ge){return lp(ge,Ve)&&(ge=mp(e,ge)),wr(ge,Ae,e)}function yt(ge){let ne=Z;Z=[];let je=wr(ge,Ae,e),Et=Tt(Z)?[je,...Z]:je;return Z=ne,Et}function ar(ge){return lp(ge,Ve)&&(ge=mp(e,ge)),wr(ge,Ae,e)}function or(ge){return lp(ge,Ve)&&(ge=mp(e,ge)),wr(ge,Ae,e)}function Fr(ge){return lp(ge,Ve)&&(ge=mp(e,ge)),wr(ge,Ae,e)}function rn(ge){return lp(ge,Ve)&&(ge=mp(e,ge,!0,ge.isExportEquals?"":"default")),wr(ge,Ae,e)}function Tr(ge){return Tt(xe)&&(Df(ge)?(xe.push(ge.expression),ge=t.updateParenthesizedExpression(ge,t.inlineExpressions(xe))):(xe.push(ge),ge=t.inlineExpressions(xe)),xe=void 0),ge}function nr(ge){let ne=nt(ge.expression,Ae,bt);return t.updateComputedPropertyName(ge,Tr(ne))}function tr(ge){return we?he(ge,we):Ie(ge)}function ki(ge){return!!(O||jl(ge)&&Lm(ge)&32)}function xs(ge){if(I.assert(!Ad(ge)),!G_(ge)||!ki(ge))return wr(ge,ke,e);let ne=ya(ge.name);if(I.assert(ne,"Undeclared private name for property declaration."),!ne.isValid)return ge;let je=Ms(ge);je&&js().push(t.createAssignment(je,t.createFunctionExpression(Fn(ge.modifiers,Et=>Ra(Et)&&!GA(Et)&&!bge(Et)),ge.asteriskToken,je,void 0,qc(ge.parameters,Ae,e),void 0,ld(ge.body,Ae,e))))}function zi(ge,ne,je){if(ge!==ve){let Et=ve;ve=ge;let gr=ne(je);return ve=Et,gr}return ne(je)}function Ms(ge){I.assert(is(ge.name));let ne=ya(ge.name);if(I.assert(ne,"Undeclared private name for property declaration."),ne.kind==="m")return ne.methodName;if(ne.kind==="a"){if(Fv(ge))return ne.getterName;if(A1(ge))return ne.setterName}}function un(){let ge=ji(),ne=ge.classThis??ge.classConstructor??we?.name;return I.checkDefined(ne)}function ri(ge){let ne=Qg(ge),je=R1(ge),Et=ge.name,gr=Et,Dn=Et;if(uo(Et)&&!rh(Et.expression)){let bu=TU(Et);if(bu)gr=t.updateComputedPropertyName(Et,nt(Et.expression,Ae,bt)),Dn=t.updateComputedPropertyName(Et,bu.left);else{let sc=t.createTempVariable(i);qa(sc,Et.expression);let Jl=nt(Et.expression,Ae,bt),jo=t.createAssignment(sc,Jl);qa(jo,Et.expression),gr=t.updateComputedPropertyName(Et,jo),Dn=t.updateComputedPropertyName(Et,sc)}}let xn=Hr(ge.modifiers,Ge,Ra),Zn=sQ(t,ge,xn,ge.initializer);Un(Zn,ge),Sn(Zn,3072),qa(Zn,je);let Bi=pa(ge)?un():t.createThis(),Jn=nhe(t,ge,xn,gr,Bi);Un(Jn,ge),kl(Jn,ne),qa(Jn,je);let ia=t.createModifiersFromModifierFlags(Yg(xn)),Fc=ihe(t,ge,ia,Dn,Bi);return Un(Fc,ge),Sn(Fc,3072),qa(Fc,je),SM([Zn,Jn,Fc],at,Du)}function On(ge){if(ki(ge)){let ne=ya(ge.name);if(I.assert(ne,"Undeclared private name for property declaration."),!ne.isValid)return ge;if(ne.isStatic&&!O){let je=Rt(ge,t.createThis());if(je)return t.createClassStaticBlockDeclaration(t.createBlock([je],!0))}return}return k&&!pa(ge)&&Q?.data&&Q.data.facts&16?t.updatePropertyDeclaration(ge,Hr(ge.modifiers,Ae,vc),ge.name,void 0,void 0,void 0):(lp(ge,Ve)&&(ge=mp(e,ge)),t.updatePropertyDeclaration(ge,Hr(ge.modifiers,Ge,Ra),nt(ge.name,$e,Al),void 0,void 0,nt(ge.initializer,Ae,bt)))}function _r(ge){if(M&&!Af(ge)){let ne=Qn(ge.name,!!ge.initializer||b);if(ne&&js().push(...she(ne)),pa(ge)&&!O){let je=Rt(ge,t.createThis());if(je){let Et=t.createClassStaticBlockDeclaration(t.createBlock([je]));return Un(Et,ge),kl(Et,ge),kl(je,{pos:-1,end:-1}),CT(je,void 0),UA(je,void 0),Et}}return}return t.updatePropertyDeclaration(ge,Hr(ge.modifiers,Ge,Ra),nt(ge.name,$e,Al),void 0,void 0,nt(ge.initializer,Ae,bt))}function rt(ge){return I.assert(!Ad(ge),"Decorators should already have been transformed and elided."),G_(ge)?On(ge):_r(ge)}function zt(){return U===-1||U===3&&!!Q?.data&&!!(Q.data.facts&16)}function Rr(ge){return Af(ge)&&(zt()||jl(ge)&&Lm(ge)&32)?ri(ge):rt(ge)}function vi(){return!!ve&&jl(ve)&&Mv(ve)&&Af(Hc(ve))}function Ni(ge){if(vi()){let ne=vl(ge);ne.kind===110&&ye.add(ne)}}function us(ge,ne){return ne=nt(ne,Ae,bt),Ni(ne),Fs(ge,ne)}function Fs(ge,ne){switch(kl(ne,TT(ne,-1)),ge.kind){case"a":return n().createClassPrivateFieldGetHelper(ne,ge.brandCheckIdentifier,ge.kind,ge.getterName);case"m":return n().createClassPrivateFieldGetHelper(ne,ge.brandCheckIdentifier,ge.kind,ge.methodName);case"f":return n().createClassPrivateFieldGetHelper(ne,ge.brandCheckIdentifier,ge.kind,ge.isStatic?ge.variableName:void 0);case"untransformed":return I.fail("Access helpers should not be created for untransformed private elements");default:I.assertNever(ge,"Unknown private element type")}}function Ta(ge){if(is(ge.name)){let ne=ya(ge.name);if(ne)return ft(Un(us(ne,ge.expression),ge),ge)}if(K&&ve&&Pf(ge)&&ze(ge.name)&&uO(ve)&&Q?.data){let{classConstructor:ne,superClassReference:je,facts:Et}=Q.data;if(Et&1)return fn(ge);if(ne&&je){let gr=t.createReflectGetCall(je,t.createStringLiteralFromNode(ge.name),ne);return Un(gr,ge.expression),ft(gr,ge.expression),gr}}return wr(ge,Ae,e)}function to(ge){if(K&&ve&&Pf(ge)&&uO(ve)&&Q?.data){let{classConstructor:ne,superClassReference:je,facts:Et}=Q.data;if(Et&1)return fn(ge);if(ne&&je){let gr=t.createReflectGetCall(je,nt(ge.argumentExpression,Ae,bt),ne);return Un(gr,ge.expression),ft(gr,ge.expression),gr}}return wr(ge,Ae,e)}function Nr(ge,ne){if(ge.operator===46||ge.operator===47){let je=Do(ge.operand);if(XP(je)){let Et;if(Et=ya(je.name)){let gr=nt(je.expression,Ae,bt);Ni(gr);let{readExpression:Dn,initializeExpression:xn}=mt(gr),Zn=us(Et,Dn),Bi=eS(ge)||ne?void 0:t.createTempVariable(i);return Zn=dU(t,ge,Zn,i,Bi),Zn=Nt(Et,xn||Dn,Zn,64),Un(Zn,ge),ft(Zn,ge),Bi&&(Zn=t.createComma(Zn,Bi),ft(Zn,ge)),Zn}}else if(K&&ve&&Pf(je)&&uO(ve)&&Q?.data){let{classConstructor:Et,superClassReference:gr,facts:Dn}=Q.data;if(Dn&1){let xn=fn(je);return eS(ge)?t.updatePrefixUnaryExpression(ge,xn):t.updatePostfixUnaryExpression(ge,xn)}if(Et&&gr){let xn,Zn;if(Hn(je)?ze(je.name)&&(Zn=xn=t.createStringLiteralFromNode(je.name)):rh(je.argumentExpression)?Zn=xn=je.argumentExpression:(Zn=t.createTempVariable(i),xn=t.createAssignment(Zn,nt(je.argumentExpression,Ae,bt))),xn&&Zn){let Bi=t.createReflectGetCall(gr,Zn,Et);ft(Bi,je);let Jn=ne?void 0:t.createTempVariable(i);return Bi=dU(t,ge,Bi,i,Jn),Bi=t.createReflectSetCall(gr,xn,Bi,Et),Un(Bi,ge),ft(Bi,ge),Jn&&(Bi=t.createComma(Bi,Jn),ft(Bi,ge)),Bi}}}}return wr(ge,Ae,e)}function qr(ge){return t.updateForStatement(ge,nt(ge.initializer,Re,Cd),nt(ge.condition,Ae,bt),nt(ge.incrementor,Re,bt),df(ge.statement,Ae,e))}function We(ge){return t.updateExpressionStatement(ge,nt(ge.expression,Re,bt))}function mt(ge){let ne=_c(ge)?ge:t.cloneNode(ge);if(ge.kind===110&&ye.has(ge)&&ye.add(ne),rh(ge))return{readExpression:ne,initializeExpression:void 0};let je=t.createTempVariable(i),Et=t.createAssignment(je,ne);return{readExpression:je,initializeExpression:Et}}function dt(ge){var ne;if(XP(ge.expression)&&ya(ge.expression.name)){let{thisArg:je,target:Et}=t.createCallBinding(ge.expression,i,h);return L2(ge)?t.updateCallChain(ge,t.createPropertyAccessChain(nt(Et,Ae,bt),ge.questionDotToken,"call"),void 0,void 0,[nt(je,Ae,bt),...Hr(ge.arguments,Ae,bt)]):t.updateCallExpression(ge,t.createPropertyAccessExpression(nt(Et,Ae,bt),"call"),void 0,[nt(je,Ae,bt),...Hr(ge.arguments,Ae,bt)])}if(K&&ve&&Pf(ge.expression)&&uO(ve)&&((ne=Q?.data)!=null&&ne.classConstructor)){let je=t.createFunctionCallCall(nt(ge.expression,Ae,bt),Q.data.classConstructor,Hr(ge.arguments,Ae,bt));return Un(je,ge),ft(je,ge),je}return wr(ge,Ae,e)}function Ot(ge){var ne;if(XP(ge.tag)&&ya(ge.tag.name)){let{thisArg:je,target:Et}=t.createCallBinding(ge.tag,i,h);return t.updateTaggedTemplateExpression(ge,t.createCallExpression(t.createPropertyAccessExpression(nt(Et,Ae,bt),"bind"),void 0,[nt(je,Ae,bt)]),void 0,nt(ge.template,Ae,SA))}if(K&&ve&&Pf(ge.tag)&&uO(ve)&&((ne=Q?.data)!=null&&ne.classConstructor)){let je=t.createFunctionBindCall(nt(ge.tag,Ae,bt),Q.data.classConstructor,[]);return Un(je,ge),ft(je,ge),t.updateTaggedTemplateExpression(ge,je,void 0,nt(ge.template,Ae,SA))}return wr(ge,Ae,e)}function _e(ge){if(Q&&ce.set(Hc(ge),Q),O){if(cO(ge)){let Et=nt(ge.body.statements[0].expression,Ae,bt);return lu(Et,!0)&&Et.left===Et.right?void 0:Et}if(dk(ge))return nt(ge.body.statements[0].expression,Ae,bt);o();let ne=zi(ge,Et=>Hr(Et,Ae,ns),ge.body.statements);ne=t.mergeLexicalEnvironment(ne,s());let je=t.createImmediatelyInvokedArrowFunction(ne);return Un(Do(je.expression),ge),Kg(Do(je.expression),4),Un(je,ge),ft(je,ge),je}}function Ve(ge){if(wu(ge)&&!ge.name){let ne=aV(ge);return Tt(ne,dk)?!1:(O||!!Lm(ge))&&Tt(ne,Et=>Jc(Et)||G_(Et)||M&&bM(Et))}return!1}function pt(ge,ne){if(I1(ge)){let je=xe;xe=void 0,ge=t.updateBinaryExpression(ge,nt(ge.left,kt,bt),ge.operatorToken,nt(ge.right,Ae,bt));let Et=Tt(xe)?t.inlineExpressions(y1([...xe,ge])):ge;return xe=je,Et}if(lu(ge)){lp(ge,Ve)&&(ge=mp(e,ge),I.assertNode(ge,lu));let je=vl(ge.left,9);if(XP(je)){let Et=ya(je.name);if(Et)return ft(Un(Nt(Et,je.expression,ge.right,ge.operatorToken.kind),ge),ge)}else if(K&&ve&&Pf(ge.left)&&uO(ve)&&Q?.data){let{classConstructor:Et,superClassReference:gr,facts:Dn}=Q.data;if(Dn&1)return t.updateBinaryExpression(ge,fn(ge.left),ge.operatorToken,nt(ge.right,Ae,bt));if(Et&&gr){let xn=fc(ge.left)?nt(ge.left.argumentExpression,Ae,bt):ze(ge.left.name)?t.createStringLiteralFromNode(ge.left.name):void 0;if(xn){let Zn=nt(ge.right,Ae,bt);if(sO(ge.operatorToken.kind)){let Jn=xn;rh(xn)||(Jn=t.createTempVariable(i),xn=t.createAssignment(Jn,xn));let ia=t.createReflectGetCall(gr,Jn,Et);Un(ia,ge.left),ft(ia,ge.left),Zn=t.createBinaryExpression(ia,aO(ge.operatorToken.kind),Zn),ft(Zn,ge)}let Bi=ne?void 0:t.createTempVariable(i);return Bi&&(Zn=t.createAssignment(Bi,Zn),ft(Bi,ge)),Zn=t.createReflectSetCall(gr,xn,Zn,Et),Un(Zn,ge),ft(Zn,ge),Bi&&(Zn=t.createComma(Zn,Bi),ft(Zn,ge)),Zn}}}}return $St(ge)?St(ge):wr(ge,Ae,e)}function W(ge,ne){let je=ne?TM(ge.elements,Re):TM(ge.elements,Ae,Re);return t.updateCommaListExpression(ge,je)}function st(ge,ne){let je=ne?Re:Ae,Et=nt(ge.expression,je,bt);return t.updateParenthesizedExpression(ge,Et)}function Nt(ge,ne,je,Et){if(ne=nt(ne,Ae,bt),je=nt(je,Ae,bt),Ni(ne),sO(Et)){let{readExpression:gr,initializeExpression:Dn}=mt(ne);ne=Dn||gr,je=t.createBinaryExpression(Fs(ge,gr),aO(Et),je)}switch(kl(ne,TT(ne,-1)),ge.kind){case"a":return n().createClassPrivateFieldSetHelper(ne,ge.brandCheckIdentifier,je,ge.kind,ge.setterName);case"m":return n().createClassPrivateFieldSetHelper(ne,ge.brandCheckIdentifier,je,ge.kind,void 0);case"f":return n().createClassPrivateFieldSetHelper(ne,ge.brandCheckIdentifier,je,ge.kind,ge.isStatic?ge.variableName:void 0);case"untransformed":return I.fail("Access helpers should not be created for untransformed private elements");default:I.assertNever(ge,"Unknown private element type")}}function Ke(ge){return Fn(ge.members,f0e)}function ht(ge){var ne;let je=0,Et=Hc(ge);eu(Et)&&k1(A,Et)&&(je|=1),O&&(mZ(ge)||cV(ge))&&(je|=2);let gr=!1,Dn=!1,xn=!1,Zn=!1;for(let Jn of ge.members)pa(Jn)?((Jn.name&&(is(Jn.name)||Af(Jn))&&O||Af(Jn)&&U===-1&&!ge.name&&!((ne=ge.emitNode)!=null&&ne.classThis))&&(je|=2),(ea(Jn)||Jc(Jn))&&(H&&Jn.transformFlags&16384&&(je|=8,je&1||(je|=2)),K&&Jn.transformFlags&134217728&&(je&1||(je|=6)))):tE(Hc(Jn))||(Af(Jn)?(Zn=!0,xn||(xn=G_(Jn))):G_(Jn)?(xn=!0,m.getNodeCheckFlags(Jn)&262144&&(je|=2)):ea(Jn)&&(gr=!0,Dn||(Dn=!!Jn.initializer)));return(N&&gr||k&&Dn||O&&xn||O&&Zn&&U===-1)&&(je|=16),je}function Wt(ge){var ne;if((((ne=Q?.data)==null?void 0:ne.facts)||0)&4){let Et=t.createTempVariable(i,!0);return ji().superClassReference=Et,t.updateExpressionWithTypeArguments(ge,t.createAssignment(Et,nt(ge.expression,Ae,bt)),void 0)}return wr(ge,Ae,e)}function Cr(ge,ne){var je;let Et=we,gr=xe,Dn=Q;we=ge,xe=void 0,Ns();let xn=Lm(ge)&32;if(O||xn){let Jn=qs(ge);if(Jn&&ze(Jn))ni().data.className=Jn;else if((je=ge.emitNode)!=null&&je.assignedName&&za(ge.emitNode.assignedName)){if(ge.emitNode.assignedName.textSourceNode&&ze(ge.emitNode.assignedName.textSourceNode))ni().data.className=ge.emitNode.assignedName.textSourceNode;else if(nd(ge.emitNode.assignedName.text,h)){let ia=t.createIdentifier(ge.emitNode.assignedName.text);ni().data.className=ia}}}if(O){let Jn=Ke(ge);Tt(Jn)&&(ni().data.weakSetName=zu("instances",Jn[0].name))}let Zn=ht(ge);Zn&&(ji().facts=Zn),Zn&8&&Pi();let Bi=ne(ge,Zn);return Vi(),I.assert(Q===Dn),we=Et,xe=gr,Bi}function hr(ge){return Cr(ge,Sr)}function Sr(ge,ne){var je,Et;let gr;if(ne&2)if(O&&((je=ge.emitNode)!=null&&je.classThis))ji().classConstructor=ge.emitNode.classThis,gr=t.createAssignment(ge.emitNode.classThis,t.getInternalName(ge));else{let jo=t.createTempVariable(i,!0);ji().classConstructor=t.cloneNode(jo),gr=t.createAssignment(jo,t.getInternalName(ge))}(Et=ge.emitNode)!=null&&Et.classThis&&(ji().classThis=ge.emitNode.classThis);let Dn=m.getNodeCheckFlags(ge)&262144,xn=ui(ge,32),Zn=ui(ge,2048),Bi=Hr(ge.modifiers,Ge,Ra),Jn=Hr(ge.heritageClauses,Ue,ad),{members:ia,prologue:Fc}=le(ge),bu=[];if(gr&&js().unshift(gr),Tt(xe)&&bu.push(t.createExpressionStatement(t.inlineExpressions(xe))),k||O||Lm(ge)&32){let jo=aV(ge);Tt(jo)&&It(bu,jo,t.getInternalName(ge))}bu.length>0&&xn&&Zn&&(Bi=Hr(Bi,jo=>GR(jo)?void 0:jo,Ra),bu.push(t.createExportAssignment(void 0,!1,t.getLocalName(ge,!1,!0))));let sc=ji().classConstructor;Dn&&sc&&(Yr(),Se[E_(ge)]=sc);let Jl=t.updateClassDeclaration(ge,Bi,ge.name,void 0,Jn,ia);return bu.unshift(Jl),Fc&&bu.unshift(t.createExpressionStatement(Fc)),bu}function Y(ge){return Cr(ge,Be)}function Be(ge,ne){var je,Et,gr;let Dn=!!(ne&1),xn=aV(ge),Zn=m.getNodeCheckFlags(ge),Bi=Zn&262144,Jn;function ia(){var pu;if(O&&((pu=ge.emitNode)!=null&&pu.classThis))return ji().classConstructor=ge.emitNode.classThis;let gm=Zn&32768,tf=t.createTempVariable(gm?p:i,!0);return ji().classConstructor=t.cloneNode(tf),tf}(je=ge.emitNode)!=null&&je.classThis&&(ji().classThis=ge.emitNode.classThis),ne&2&&(Jn??(Jn=ia()));let Fc=Hr(ge.modifiers,Ge,Ra),bu=Hr(ge.heritageClauses,Ue,ad),{members:sc,prologue:Jl}=le(ge),jo=t.updateClassExpression(ge,Fc,ge.name,void 0,bu,sc),Eu=[];if(Jl&&Eu.push(Jl),(O||Lm(ge)&32)&&Tt(xn,pu=>Jc(pu)||G_(pu)||M&&bM(pu))||Tt(xe))if(Dn)I.assertIsDefined(Z,"Decorated classes transformed by TypeScript are expected to be within a variable declaration."),Tt(xe)&&jt(Z,vr(xe,t.createExpressionStatement)),Tt(xn)&&It(Z,xn,((Et=ge.emitNode)==null?void 0:Et.classThis)??t.getInternalName(ge)),Jn?Eu.push(t.createAssignment(Jn,jo)):O&&((gr=ge.emitNode)!=null&&gr.classThis)?Eu.push(t.createAssignment(ge.emitNode.classThis,jo)):Eu.push(jo);else{if(Jn??(Jn=ia()),Bi){Yr();let pu=t.cloneNode(Jn);pu.emitNode.autoGenerate.flags&=-9,Se[E_(ge)]=pu}Eu.push(t.createAssignment(Jn,jo)),jt(Eu,xe),jt(Eu,Zt(xn,Jn)),Eu.push(t.cloneNode(Jn))}else Eu.push(jo);return Eu.length>1&&(Kg(jo,131072),Eu.forEach(M_)),t.inlineExpressions(Eu)}function Lt(ge){if(!O)return wr(ge,Ae,e)}function B(ge){if(H&&ve&&Jc(ve)&&Q?.data){let{classThis:ne,classConstructor:je}=Q.data;return ne??je??ge}return ge}function le(ge){let ne=!!(Lm(ge)&32);if(O||z){for(let xn of ge.members)if(G_(xn))if(ki(xn))Dc(xn,xn.name,Mr);else{let Zn=ni();Sx(Zn,xn.name,{kind:"untransformed"})}if(O&&Tt(Ke(ge))&&X(),zt()){for(let xn of ge.members)if(Af(xn)){let Zn=t.getGeneratedPrivateNameForNode(xn.name,void 0,"_accessor_storage");if(O||ne&&jl(xn))Dc(xn,Zn,Qo);else{let Bi=ni();Sx(Bi,Zn,{kind:"untransformed"})}}}}let je=Hr(ge.members,ke,Du),Et;Tt(je,Yc)||(Et=he(void 0,ge));let gr,Dn;if(!O&&Tt(xe)){let xn=t.createExpressionStatement(t.inlineExpressions(xe));if(xn.transformFlags&134234112){let Bi=t.createTempVariable(i),Jn=t.createArrowFunction(void 0,void 0,[],void 0,void 0,t.createBlock([xn]));gr=t.createAssignment(Bi,Jn),xn=t.createExpressionStatement(t.createCallExpression(Bi,void 0,[]))}let Zn=t.createBlock([xn]);Dn=t.createClassStaticBlockDeclaration(Zn),xe=void 0}if(Et||Dn){let xn,Zn=mr(je,cO),Bi=mr(je,dk);xn=Pr(xn,Zn),xn=Pr(xn,Bi),xn=Pr(xn,Et),xn=Pr(xn,Dn);let Jn=Zn||Bi?Fn(je,ia=>ia!==Zn&&ia!==Bi):je;xn=jt(xn,Jn),je=ft(t.createNodeArray(xn),ge.members)}return{members:je,prologue:gr}}function X(){let{weakSetName:ge}=ni().data;I.assert(ge,"weakSetName should be set in private identifier environment"),js().push(t.createAssignment(ge,t.createNewExpression(t.createIdentifier("WeakSet"),void 0,[])))}function he(ge,ne){if(ge=nt(ge,Ae,Yc),!Q?.data||!(Q.data.facts&16))return ge;let je=$g(ne),Et=!!(je&&vl(je.expression).kind!==106),gr=qc(ge?ge.parameters:void 0,Ae,e),Dn=Le(ne,ge,Et);return Dn?ge?(I.assert(gr),t.updateConstructorDeclaration(ge,void 0,gr,Dn)):M_(Un(ft(t.createConstructorDeclaration(void 0,gr??[],Dn),ge||ne),ge)):ge}function qe(ge,ne,je,Et,gr,Dn,xn){let Zn=Et[gr],Bi=ne[Zn];if(jt(ge,Hr(ne,Ae,ns,je,Zn-je)),je=Zn+1,fx(Bi)){let Jn=[];qe(Jn,Bi.tryBlock.statements,0,Et,gr+1,Dn,xn);let ia=t.createNodeArray(Jn);ft(ia,Bi.tryBlock.statements),ge.push(t.updateTryStatement(Bi,t.updateBlock(Bi.tryBlock,Jn),nt(Bi.catchClause,Ae,mE),nt(Bi.finallyBlock,Ae,ra)))}else{for(jt(ge,Hr(ne,Ae,ns,Zn,1));je<ne.length;){let Jn=ne[je];if(op(Hc(Jn),xn))je++;else break}jt(ge,Dn)}jt(ge,Hr(ne,Ae,ns,je))}function Le(ge,ne,je){let Et=uZ(ge,!1,!1),gr=Et;b||(gr=Fn(gr,sc=>!!sc.initializer||is(sc.name)||Hg(sc)));let Dn=Ke(ge),xn=Tt(gr)||Tt(Dn);if(!ne&&!xn)return ld(void 0,Ae,e);l();let Zn=!ne&&je,Bi=0,Jn=[],ia=[],Fc=t.createThis();if(Fi(ia,Dn,Fc),ne){let sc=Fn(Et,jo=>op(Hc(jo),ne)),Jl=Fn(gr,jo=>!op(Hc(jo),ne));It(ia,sc,Fc),It(ia,Jl,Fc)}else It(ia,gr,Fc);if(ne?.body){Bi=t.copyPrologue(ne.body.statements,Jn,!1,Ae);let sc=sV(ne.body.statements,Bi);if(sc.length)qe(Jn,ne.body.statements,Bi,sc,0,ia,ne);else{for(;Bi<ne.body.statements.length;){let Jl=ne.body.statements[Bi];if(op(Hc(Jl),ne))Bi++;else break}jt(Jn,ia),jt(Jn,Hr(ne.body.statements,Ae,ns,Bi))}}else Zn&&Jn.push(t.createExpressionStatement(t.createCallExpression(t.createSuper(),void 0,[t.createSpreadElement(t.createIdentifier("arguments"))]))),jt(Jn,ia);if(Jn=t.mergeLexicalEnvironment(Jn,s()),Jn.length===0&&!ne)return;let bu=ne?.body&&ne.body.statements.length>=Jn.length?ne.body.multiLine??Jn.length>0:Jn.length>0;return ft(t.createBlock(ft(t.createNodeArray(Jn),ne?ne.body.statements:ge.members),bu),ne?ne.body:void 0)}function It(ge,ne,je){for(let Et of ne){if(pa(Et)&&!O)continue;let gr=Rt(Et,je);gr&&ge.push(gr)}}function Rt(ge,ne){let je=Jc(ge)?zi(ge,_e,ge):Ir(ge,ne);if(!je)return;let Et=t.createExpressionStatement(je);Un(Et,ge),Kg(Et,eo(ge)&3072),kl(Et,ge);let gr=Hc(ge);return Ls(gr)?(qa(Et,gr),xR(Et)):qa(Et,Xg(ge)),CT(je,void 0),UA(je,void 0),Hg(gr)&&Kg(Et,3072),Et}function Zt(ge,ne){let je=[];for(let Et of ge){let gr=Jc(Et)?zi(Et,_e,Et):zi(Et,()=>Ir(Et,ne),void 0);gr&&(M_(gr),Un(gr,Et),Kg(gr,eo(Et)&3072),qa(gr,Xg(Et)),kl(gr,Et),je.push(gr))}return je}function Ir(ge,ne){var je;let Et=ve,gr=zr(ge,ne);return gr&&jl(ge)&&((je=Q?.data)!=null&&je.facts)&&(Un(gr,ge),Kg(gr,4),qa(gr,R1(ge.name)),ce.set(Hc(ge),Q)),ve=Et,gr}function zr(ge,ne){let je=!b;lp(ge,Ve)&&(ge=mp(e,ge));let Et=Hg(ge)?t.getGeneratedPrivateNameForNode(ge.name):uo(ge.name)&&!rh(ge.name.expression)?t.updateComputedPropertyName(ge.name,t.getGeneratedNameForNode(ge.name)):ge.name;if(jl(ge)&&(ve=ge),is(Et)&&ki(ge)){let xn=ya(Et);if(xn)return xn.kind==="f"?xn.isStatic?VSt(t,xn.variableName,nt(ge.initializer,Ae,bt)):JSt(t,ne,nt(ge.initializer,Ae,bt),xn.brandCheckIdentifier):void 0;I.fail("Undeclared private name for property declaration.")}if((is(Et)||jl(ge))&&!ge.initializer)return;let gr=Hc(ge);if(ui(gr,64))return;let Dn=nt(ge.initializer,Ae,bt);if(op(gr,gr.parent)&&ze(Et)){let xn=t.cloneNode(Et);Dn?(Df(Dn)&&qR(Dn.expression)&&O6(Dn.expression.left,"___runInitializers")&&ZA(Dn.expression.right)&&_p(Dn.expression.right.expression)&&(Dn=Dn.expression.left),Dn=t.inlineExpressions([Dn,xn])):Dn=xn,Sn(Et,3168),qa(xn,gr.name),Sn(xn,3072)}else Dn??(Dn=t.createVoidZero());if(je||is(Et)){let xn=hx(t,ne,Et,Et);return Kg(xn,1024),t.createAssignment(xn,Dn)}else{let xn=uo(Et)?Et.expression:ze(Et)?t.createStringLiteral(Zi(Et.escapedText)):Et,Zn=t.createPropertyDescriptor({value:Dn,configurable:!0,writable:!0,enumerable:!0});return t.createObjectDefinePropertyCall(ne,xn,Zn)}}function Yr(){se&1||(se|=1,e.enableSubstitution(80),Se=[])}function Pi(){se&2||(se|=2,e.enableSubstitution(110),e.enableEmitNotification(262),e.enableEmitNotification(218),e.enableEmitNotification(176),e.enableEmitNotification(177),e.enableEmitNotification(178),e.enableEmitNotification(174),e.enableEmitNotification(172),e.enableEmitNotification(167))}function Fi(ge,ne,je){if(!O||!Tt(ne))return;let{weakSetName:Et}=ni().data;I.assert(Et,"weakSetName should be set in private identifier environment"),ge.push(t.createExpressionStatement(qSt(t,je,Et)))}function fn(ge){return Hn(ge)?t.updatePropertyAccessExpression(ge,t.createVoidZero(),ge.name):t.updateElementAccessExpression(ge,t.createVoidZero(),nt(ge.argumentExpression,Ae,bt))}function Qn(ge,ne){if(uo(ge)){let je=TU(ge),Et=nt(ge.expression,Ae,bt),gr=Mm(Et),Dn=rh(gr);if(!(!!je||lu(gr)&&yc(gr.left))&&!Dn&&ne){let Zn=t.getGeneratedNameForNode(ge);return m.getNodeCheckFlags(ge)&32768?p(Zn):i(Zn),t.createAssignment(Zn,Et)}return Dn||ze(gr)?void 0:Et}}function Ns(){Q={previous:Q,data:void 0}}function Vi(){Q=Q?.previous}function ji(){return I.assert(Q),Q.data??(Q.data={facts:0,classConstructor:void 0,classThis:void 0,superClassReference:void 0})}function ni(){return I.assert(Q),Q.privateEnv??(Q.privateEnv=m0e({className:void 0,weakSetName:void 0}))}function js(){return xe??(xe=[])}function Mr(ge,ne,je,Et,gr,Dn,xn){Af(ge)?nc(ge,ne,je,Et,gr,Dn,xn):ea(ge)?Qo(ge,ne,je,Et,gr,Dn,xn):pl(ge)?Sl(ge,ne,je,Et,gr,Dn,xn):sd(ge)?zs(ge,ne,je,Et,gr,Dn,xn):pp(ge)&&Eo(ge,ne,je,Et,gr,Dn,xn)}function Qo(ge,ne,je,Et,gr,Dn,xn){if(gr){let Zn=I.checkDefined(je.classThis??je.classConstructor,"classConstructor should be set in private identifier environment"),Bi=ks(ne);Sx(Et,ne,{kind:"f",isStatic:!0,brandCheckIdentifier:Zn,variableName:Bi,isValid:Dn})}else{let Zn=ks(ne);Sx(Et,ne,{kind:"f",isStatic:!1,brandCheckIdentifier:Zn,isValid:Dn}),js().push(t.createAssignment(Zn,t.createNewExpression(t.createIdentifier("WeakMap"),void 0,[])))}}function Sl(ge,ne,je,Et,gr,Dn,xn){let Zn=ks(ne),Bi=gr?I.checkDefined(je.classThis??je.classConstructor,"classConstructor should be set in private identifier environment"):I.checkDefined(Et.data.weakSetName,"weakSetName should be set in private identifier environment");Sx(Et,ne,{kind:"m",methodName:Zn,brandCheckIdentifier:Bi,isStatic:gr,isValid:Dn})}function zs(ge,ne,je,Et,gr,Dn,xn){let Zn=ks(ne,"_get"),Bi=gr?I.checkDefined(je.classThis??je.classConstructor,"classConstructor should be set in private identifier environment"):I.checkDefined(Et.data.weakSetName,"weakSetName should be set in private identifier environment");xn?.kind==="a"&&xn.isStatic===gr&&!xn.getterName?xn.getterName=Zn:Sx(Et,ne,{kind:"a",getterName:Zn,setterName:void 0,brandCheckIdentifier:Bi,isStatic:gr,isValid:Dn})}function Eo(ge,ne,je,Et,gr,Dn,xn){let Zn=ks(ne,"_set"),Bi=gr?I.checkDefined(je.classThis??je.classConstructor,"classConstructor should be set in private identifier environment"):I.checkDefined(Et.data.weakSetName,"weakSetName should be set in private identifier environment");xn?.kind==="a"&&xn.isStatic===gr&&!xn.setterName?xn.setterName=Zn:Sx(Et,ne,{kind:"a",getterName:void 0,setterName:Zn,brandCheckIdentifier:Bi,isStatic:gr,isValid:Dn})}function nc(ge,ne,je,Et,gr,Dn,xn){let Zn=ks(ne,"_get"),Bi=ks(ne,"_set"),Jn=gr?I.checkDefined(je.classThis??je.classConstructor,"classConstructor should be set in private identifier environment"):I.checkDefined(Et.data.weakSetName,"weakSetName should be set in private identifier environment");Sx(Et,ne,{kind:"a",getterName:Zn,setterName:Bi,brandCheckIdentifier:Jn,isStatic:gr,isValid:Dn})}function Dc(ge,ne,je){let Et=ji(),gr=ni(),Dn=fZ(gr,ne),xn=jl(ge),Zn=!zSt(ne)&&Dn===void 0;je(ge,ne,Et,gr,xn,Zn,Dn)}function zu(ge,ne,je){let{className:Et}=ni().data,gr=Et?{prefix:"_",node:Et,suffix:"_"}:"_",Dn=typeof ge=="object"?t.getGeneratedNameForNode(ge,24,gr,je):typeof ge=="string"?t.createUniqueName(ge,16,gr,je):t.createTempVariable(void 0,!0,gr,je);return m.getNodeCheckFlags(ne)&32768?p(Dn):i(Dn),Dn}function ks(ge,ne){let je=Vw(ge);return zu(je?.substring(1)??ge,ge,ne)}function ya(ge){let ne=g0e(Q,ge);return ne?.kind==="untransformed"?void 0:ne}function $u(ge){let ne=t.getGeneratedNameForNode(ge),je=ya(ge.name);if(!je)return wr(ge,Ae,e);let Et=ge.expression;return(x8(ge)||Pf(ge)||!TE(ge.expression))&&(Et=t.createTempVariable(i,!0),js().push(t.createBinaryExpression(Et,64,nt(ge.expression,Ae,bt)))),t.createAssignmentTargetWrapper(ne,Nt(je,Et,ne,64))}function Uo(ge){if(Ha(ge)||Z_(ge))return cr(ge);if(XP(ge))return $u(ge);if(K&&ve&&Pf(ge)&&uO(ve)&&Q?.data){let{classConstructor:ne,superClassReference:je,facts:Et}=Q.data;if(Et&1)return fn(ge);if(ne&&je){let gr=fc(ge)?nt(ge.argumentExpression,Ae,bt):ze(ge.name)?t.createStringLiteralFromNode(ge.name):void 0;if(gr){let Dn=t.createTempVariable(void 0);return t.createAssignmentTargetWrapper(Dn,t.createReflectSetCall(je,gr,Dn,ne))}}}return wr(ge,Ae,e)}function $a(ge){if(lp(ge,Ve)&&(ge=mp(e,ge)),lu(ge,!0)){let ne=Uo(ge.left),je=nt(ge.right,Ae,bt);return t.updateBinaryExpression(ge,ne,ge.operatorToken,je)}return Uo(ge)}function Ac(ge){if($f(ge.expression)){let ne=Uo(ge.expression);return t.updateSpreadElement(ge,ne)}return wr(ge,Ae,e)}function Ld(ge){if(a8(ge)){if(fg(ge))return Ac(ge);if(!Su(ge))return $a(ge)}return wr(ge,Ae,e)}function Nl(ge){let ne=nt(ge.name,Ae,Al);if(lu(ge.initializer,!0)){let je=$a(ge.initializer);return t.updatePropertyAssignment(ge,ne,je)}if($f(ge.initializer)){let je=Uo(ge.initializer);return t.updatePropertyAssignment(ge,ne,je)}return wr(ge,Ae,e)}function zc(ge){return lp(ge,Ve)&&(ge=mp(e,ge)),wr(ge,Ae,e)}function Tc(ge){if($f(ge.expression)){let ne=Uo(ge.expression);return t.updateSpreadAssignment(ge,ne)}return wr(ge,Ae,e)}function $s(ge){return I.assertNode(ge,s8),F1(ge)?Tc(ge):Hf(ge)?zc(ge):Ul(ge)?Nl(ge):wr(ge,Ae,e)}function cr(ge){return Z_(ge)?t.updateArrayLiteralExpression(ge,Hr(ge.elements,Ld,bt)):t.updateObjectLiteralExpression(ge,Hr(ge.properties,$s,by))}function ic(ge,ne,je){let Et=Hc(ne),gr=ce.get(Et);if(gr){let Dn=Q,xn=Ee;Q=gr,Ee=oe,oe=!Jc(Et)||!(Lm(Et)&32),pe(ge,ne,je),oe=Ee,Ee=xn,Q=Dn;return}switch(ne.kind){case 218:if(rc(Et)||eo(ne)&524288)break;case 262:case 176:case 177:case 178:case 174:case 172:{let Dn=Q,xn=Ee;Q=void 0,Ee=oe,oe=!1,pe(ge,ne,je),oe=Ee,Ee=xn,Q=Dn;return}case 167:{let Dn=Q,xn=oe;Q=Q?.previous,oe=Ee,pe(ge,ne,je),oe=xn,Q=Dn;return}}pe(ge,ne,je)}function Mu(ge,ne){return ne=$(ge,ne),ge===1?Wu(ne):ne}function Wu(ge){switch(ge.kind){case 80:return Go(ge);case 110:return yp(ge)}return ge}function yp(ge){if(se&2&&Q?.data&&!ye.has(ge)){let{facts:ne,classConstructor:je,classThis:Et}=Q.data,gr=oe?Et??je:je;if(gr)return ft(Un(t.cloneNode(gr),ge),ge);if(ne&1&&A)return t.createParenthesizedExpression(t.createVoidZero())}return ge}function Go(ge){return ru(ge)||ge}function ru(ge){if(se&1&&m.getNodeCheckFlags(ge)&536870912){let ne=m.getReferencedValueDeclaration(ge);if(ne){let je=Se[ne.id];if(je){let Et=t.cloneNode(je);return qa(Et,ge),kl(Et,ge),Et}}}}}function VSt(e,t,n){return e.createAssignment(t,e.createObjectLiteralExpression([e.createPropertyAssignment("value",n||e.createVoidZero())]))}function JSt(e,t,n,i){return e.createCallExpression(e.createPropertyAccessExpression(i,"set"),void 0,[t,n||e.createVoidZero()])}function qSt(e,t,n){return e.createCallExpression(e.createPropertyAccessExpression(n,"add"),void 0,[t])}function zSt(e){return!F2(e)&&e.escapedText==="#constructor"}function $St(e){return is(e.left)&&e.operatorToken.kind===103}function WSt(e){return ea(e)&&jl(e)}function uO(e){return Jc(e)||WSt(e)}var GSt=f({"src/compiler/transformers/classFields.ts"(){"use strict";fa()}});function k0e(e){let{factory:t,hoistVariableDeclaration:n}=e,i=e.getEmitResolver(),s=e.getCompilerOptions(),o=ho(s),l=K_(s,"strictNullChecks"),p,m;return{serializeTypeNode:(xe,Z)=>S(xe,M,Z),serializeTypeOfNode:(xe,Z)=>S(xe,b,Z),serializeParameterTypesOfNode:(xe,Z,Q)=>S(xe,A,Z,Q),serializeReturnTypeOfNode:(xe,Z)=>S(xe,N,Z)};function S(xe,Z,Q,ce){let ye=p,we=m;p=xe.currentLexicalScope,m=xe.currentNameScope;let ve=ce===void 0?Z(Q):Z(Q,ce);return p=ye,m=we,ve}function h(xe){let Z=i.getAllAccessorDeclarations(xe);return Z.setAccessor&&Jde(Z.setAccessor)||Z.getAccessor&&lm(Z.getAccessor)}function b(xe){switch(xe.kind){case 172:case 169:return M(xe.type);case 178:case 177:return M(h(xe));case 263:case 231:case 174:return t.createIdentifier("Function");default:return t.createVoidZero()}}function A(xe,Z){let Q=Ti(xe)?I0(xe):ca(xe)&&nm(xe.body)?xe:void 0,ce=[];if(Q){let ye=k(Q,Z),we=ye.length;for(let ve=0;ve<we;ve++){let oe=ye[ve];ve===0&&ze(oe.name)&&oe.name.escapedText==="this"||(oe.dotDotDotToken?ce.push(M(UY(oe.type))):ce.push(b(oe)))}}return t.createArrayLiteralExpression(ce)}function k(xe,Z){if(Z&&xe.kind===177){let{setAccessor:Q}=tx(Z.members,xe);if(Q)return Q.parameters}return xe.parameters}function N(xe){return ca(xe)&&xe.type?M(xe.type):Kw(xe)?t.createIdentifier("Promise"):t.createVoidZero()}function M(xe){if(xe===void 0)return t.createIdentifier("Object");switch(xe=q8(xe),xe.kind){case 116:case 157:case 146:return t.createVoidZero();case 184:case 185:return t.createIdentifier("Function");case 188:case 189:return t.createIdentifier("Array");case 182:return xe.assertsModifier?t.createVoidZero():t.createIdentifier("Boolean");case 136:return t.createIdentifier("Boolean");case 203:case 154:return t.createIdentifier("String");case 151:return t.createIdentifier("Object");case 201:return O(xe.literal);case 150:return t.createIdentifier("Number");case 163:return Se("BigInt",7);case 155:return Se("Symbol",2);case 183:return K(xe);case 193:return U(xe.types,!0);case 192:return U(xe.types,!1);case 194:return U([xe.trueType,xe.falseType],!1);case 198:if(xe.operator===148)return M(xe.type);break;case 186:case 199:case 200:case 187:case 133:case 159:case 197:case 205:break;case 319:case 320:case 324:case 325:case 326:break;case 321:case 322:case 323:return M(xe.type);default:return I.failBadSyntaxKind(xe)}return t.createIdentifier("Object")}function O(xe){switch(xe.kind){case 11:case 15:return t.createIdentifier("String");case 224:{let Z=xe.operand;switch(Z.kind){case 9:case 10:return O(Z);default:return I.failBadSyntaxKind(Z)}}case 9:return t.createIdentifier("Number");case 10:return Se("BigInt",7);case 112:case 97:return t.createIdentifier("Boolean");case 106:return t.createVoidZero();default:return I.failBadSyntaxKind(xe)}}function U(xe,Z){let Q;for(let ce of xe){if(ce=q8(ce),ce.kind===146){if(Z)return t.createVoidZero();continue}if(ce.kind===159){if(!Z)return t.createIdentifier("Object");continue}if(ce.kind===133)return t.createIdentifier("Object");if(!l&&(Qv(ce)&&ce.literal.kind===106||ce.kind===157))continue;let ye=M(ce);if(ze(ye)&&ye.escapedText==="Object")return ye;if(Q){if(!H(Q,ye))return t.createIdentifier("Object")}else Q=ye}return Q??t.createVoidZero()}function H(xe,Z){return yc(xe)?yc(Z):ze(xe)?ze(Z)&&xe.escapedText===Z.escapedText:Hn(xe)?Hn(Z)&&H(xe.expression,Z.expression)&&H(xe.name,Z.name):ZA(xe)?ZA(Z)&&_p(xe.expression)&&xe.expression.text==="0"&&_p(Z.expression)&&Z.expression.text==="0":za(xe)?za(Z)&&xe.text===Z.text:zN(xe)?zN(Z)&&H(xe.expression,Z.expression):Df(xe)?Df(Z)&&H(xe.expression,Z.expression):$N(xe)?$N(Z)&&H(xe.condition,Z.condition)&&H(xe.whenTrue,Z.whenTrue)&&H(xe.whenFalse,Z.whenFalse):bn(xe)?bn(Z)&&xe.operatorToken.kind===Z.operatorToken.kind&&H(xe.left,Z.left)&&H(xe.right,Z.right):!1}function K(xe){let Z=i.getTypeReferenceSerializationKind(xe.typeName,m??p);switch(Z){case 0:if(Gr(xe,ye=>ye.parent&&QA(ye.parent)&&(ye.parent.trueType===ye||ye.parent.falseType===ye)))return t.createIdentifier("Object");let Q=$(xe.typeName),ce=t.createTempVariable(n);return t.createConditionalExpression(t.createTypeCheck(t.createAssignment(ce,Q),"function"),void 0,ce,void 0,t.createIdentifier("Object"));case 1:return pe(xe.typeName);case 2:return t.createVoidZero();case 4:return Se("BigInt",7);case 6:return t.createIdentifier("Boolean");case 3:return t.createIdentifier("Number");case 5:return t.createIdentifier("String");case 7:return t.createIdentifier("Array");case 8:return Se("Symbol",2);case 10:return t.createIdentifier("Function");case 9:return t.createIdentifier("Promise");case 11:return t.createIdentifier("Object");default:return I.assertNever(Z)}}function re(xe,Z){return t.createLogicalAnd(t.createStrictInequality(t.createTypeOfExpression(xe),t.createStringLiteral("undefined")),Z)}function $(xe){if(xe.kind===80){let ce=pe(xe);return re(ce,ce)}if(xe.left.kind===80)return re(pe(xe.left),pe(xe));let Z=$(xe.left),Q=t.createTempVariable(n);return t.createLogicalAnd(t.createLogicalAnd(Z.left,t.createStrictInequality(t.createAssignment(Q,Z.right),t.createVoidZero())),t.createPropertyAccessExpression(Q,xe.right))}function pe(xe){switch(xe.kind){case 80:let Z=io(ft($h.cloneNode(xe),xe),xe.parent);return Z.original=void 0,io(Z,Us(p)),Z;case 166:return z(xe)}}function z(xe){return t.createPropertyAccessExpression(pe(xe.left),xe.right)}function se(xe){return t.createConditionalExpression(t.createTypeCheck(t.createIdentifier(xe),"function"),void 0,t.createIdentifier(xe),void 0,t.createIdentifier("Object"))}function Se(xe,Z){return o<Z?se(xe):t.createIdentifier(xe)}}var HSt=f({"src/compiler/transformers/typeSerializer.ts"(){"use strict";fa()}});function P0e(e){let{factory:t,getEmitHelperFactory:n,hoistVariableDeclaration:i}=e,s=e.getEmitResolver(),o=e.getCompilerOptions(),l=ho(o),p=e.onSubstituteNode;e.onSubstituteNode=$e;let m;return qm(e,S);function S(Ze){let yt=wr(Ze,b,e);return Ny(yt,e.readEmitHelpers()),yt}function h(Ze){return n_(Ze)?void 0:Ze}function b(Ze){if(!(Ze.transformFlags&33554432))return Ze;switch(Ze.kind){case 170:return;case 263:return A(Ze);case 231:return K(Ze);case 176:return re(Ze);case 174:return pe(Ze);case 178:return se(Ze);case 177:return z(Ze);case 172:return Se(Ze);case 169:return xe(Ze);default:return wr(Ze,b,e)}}function A(Ze){if(!(k1(!0,Ze)||zw(!0,Ze)))return wr(Ze,b,e);let yt=k1(!0,Ze)?H(Ze,Ze.name):U(Ze,Ze.name);return Op(yt)}function k(Ze){return!!(Ze.transformFlags&536870912)}function N(Ze){return Tt(Ze,k)}function M(Ze){for(let yt of Ze.members){if(!yx(yt))continue;let ar=oV(yt,Ze,!0);if(Tt(ar?.decorators,k)||Tt(ar?.parameters,N))return!0}return!1}function O(Ze,yt){let ar=[];return ce(ar,Ze,!1),ce(ar,Ze,!0),M(Ze)&&(yt=ft(t.createNodeArray([...yt,t.createClassStaticBlockDeclaration(t.createBlock(ar,!0))]),yt),ar=void 0),{decorationStatements:ar,members:yt}}function U(Ze,yt){let ar=Hr(Ze.modifiers,h,Ra),or=Hr(Ze.heritageClauses,b,ad),Fr=Hr(Ze.members,b,Du),rn=[];({members:Fr,decorationStatements:rn}=O(Ze,Fr));let Tr=t.updateClassDeclaration(Ze,ar,yt,void 0,or,Fr);return jt([Tr],rn)}function H(Ze,yt){let ar=ui(Ze,32),or=ui(Ze,2048),Fr=Hr(Ze.modifiers,zt=>GR(zt)||n_(zt)?void 0:zt,vc),rn=Xg(Ze),Tr=Ue(Ze),nr=l<2?t.getInternalName(Ze,!1,!0):t.getLocalName(Ze,!1,!0),tr=Hr(Ze.heritageClauses,b,ad),ki=Hr(Ze.members,b,Du),xs=[];({members:ki,decorationStatements:xs}=O(Ze,ki));let zi=l>=9&&!!Tr&&Tt(ki,zt=>ea(zt)&&ui(zt,256)||Jc(zt));zi&&(ki=ft(t.createNodeArray([t.createClassStaticBlockDeclaration(t.createBlock([t.createExpressionStatement(t.createAssignment(Tr,t.createThis()))])),...ki]),ki));let Ms=t.createClassExpression(Fr,yt&&yc(yt)?void 0:yt,void 0,tr,ki);Un(Ms,Ze),ft(Ms,rn);let un=Tr&&!zi?t.createAssignment(Tr,Ms):Ms,ri=t.createVariableDeclaration(nr,void 0,void 0,un);Un(ri,Ze);let On=t.createVariableDeclarationList([ri],1),_r=t.createVariableStatement(void 0,On);Un(_r,Ze),ft(_r,rn),kl(_r,Ze);let rt=[_r];if(jt(rt,xs),Ee(rt,Ze),ar)if(or){let zt=t.createExportDefault(nr);rt.push(zt)}else{let zt=t.createExternalModuleExport(t.getDeclarationName(Ze));rt.push(zt)}return rt}function K(Ze){return t.updateClassExpression(Ze,Hr(Ze.modifiers,h,Ra),Ze.name,void 0,Hr(Ze.heritageClauses,b,ad),Hr(Ze.members,b,Du))}function re(Ze){return t.updateConstructorDeclaration(Ze,Hr(Ze.modifiers,h,Ra),Hr(Ze.parameters,b,Ls),nt(Ze.body,b,ra))}function $(Ze,yt){return Ze!==yt&&(kl(Ze,yt),qa(Ze,Xg(yt))),Ze}function pe(Ze){return $(t.updateMethodDeclaration(Ze,Hr(Ze.modifiers,h,Ra),Ze.asteriskToken,I.checkDefined(nt(Ze.name,b,Al)),void 0,void 0,Hr(Ze.parameters,b,Ls),void 0,nt(Ze.body,b,ra)),Ze)}function z(Ze){return $(t.updateGetAccessorDeclaration(Ze,Hr(Ze.modifiers,h,Ra),I.checkDefined(nt(Ze.name,b,Al)),Hr(Ze.parameters,b,Ls),void 0,nt(Ze.body,b,ra)),Ze)}function se(Ze){return $(t.updateSetAccessorDeclaration(Ze,Hr(Ze.modifiers,h,Ra),I.checkDefined(nt(Ze.name,b,Al)),Hr(Ze.parameters,b,Ls),nt(Ze.body,b,ra)),Ze)}function Se(Ze){if(!(Ze.flags&33554432||ui(Ze,128)))return $(t.updatePropertyDeclaration(Ze,Hr(Ze.modifiers,h,Ra),I.checkDefined(nt(Ze.name,b,Al)),void 0,void 0,nt(Ze.initializer,b,bt)),Ze)}function xe(Ze){let yt=t.updateParameterDeclaration(Ze,rhe(t,Ze.modifiers),Ze.dotDotDotToken,I.checkDefined(nt(Ze.name,b,j2)),void 0,void 0,nt(Ze.initializer,b,bt));return yt!==Ze&&(kl(yt,Ze),ft(yt,Xg(Ze)),qa(yt,Xg(Ze)),Sn(yt.name,64)),yt}function Z(Ze){return O6(Ze.expression,"___metadata")}function Q(Ze){if(!Ze)return;let{false:yt,true:ar}=Jf(Ze.decorators,Z),or=[];return jt(or,vr(yt,Ge)),jt(or,_a(Ze.parameters,Ae)),jt(or,vr(ar,Ge)),or}function ce(Ze,yt,ar){jt(Ze,vr(ve(yt,ar),or=>t.createExpressionStatement(or)))}function ye(Ze,yt,ar){return A8(!0,Ze,ar)&&yt===pa(Ze)}function we(Ze,yt){return Fn(Ze.members,ar=>ye(ar,yt,Ze))}function ve(Ze,yt){let ar=we(Ze,yt),or;for(let Fr of ar)or=Pr(or,oe(Ze,Fr));return or}function oe(Ze,yt){let ar=oV(yt,Ze,!0),or=Q(ar);if(!or)return;let Fr=ke(Ze,yt),rn=Ie(yt,!ui(yt,128)),Tr=l>0?ea(yt)&&!Hg(yt)?t.createVoidZero():t.createNull():void 0,nr=n().createDecorateHelper(or,Fr,rn,Tr);return Sn(nr,3072),qa(nr,Xg(yt)),nr}function Ee(Ze,yt){let ar=Me(yt);ar&&Ze.push(Un(t.createExpressionStatement(ar),yt))}function Me(Ze){let yt=_Z(Ze),ar=Q(yt);if(!ar)return;let or=m&&m[E_(Ze)],Fr=l<2?t.getInternalName(Ze,!1,!0):t.getDeclarationName(Ze,!1,!0),rn=n().createDecorateHelper(ar,Fr),Tr=t.createAssignment(Fr,or?t.createAssignment(or,rn):rn);return Sn(Tr,3072),qa(Tr,Xg(Ze)),Tr}function Ge(Ze){return I.checkDefined(nt(Ze.expression,b,bt))}function Ae(Ze,yt){let ar;if(Ze){ar=[];for(let or of Ze){let Fr=n().createParamHelper(Ge(or),yt);ft(Fr,or.expression),Sn(Fr,3072),ar.push(Fr)}}return ar}function Ie(Ze,yt){let ar=Ze.name;return is(ar)?t.createIdentifier(""):uo(ar)?yt&&!rh(ar.expression)?t.getGeneratedNameForNode(ar):ar.expression:ze(ar)?t.createStringLiteral(Nn(ar)):t.cloneNode(ar)}function Re(){m||(e.enableSubstitution(80),m=[])}function Ue(Ze){if(s.getNodeCheckFlags(Ze)&262144){Re();let yt=t.createUniqueName(Ze.name&&!yc(Ze.name)?Nn(Ze.name):"default");return m[E_(Ze)]=yt,i(yt),yt}}function kt(Ze){return t.createPropertyAccessExpression(t.getDeclarationName(Ze),"prototype")}function ke(Ze,yt){return pa(yt)?t.getDeclarationName(Ze):kt(Ze)}function $e(Ze,yt){return yt=p(Ze,yt),Ze===1?at(yt):yt}function at(Ze){switch(Ze.kind){case 80:return $t(Ze)}return Ze}function $t(Ze){return St(Ze)??Ze}function St(Ze){if(m&&s.getNodeCheckFlags(Ze)&536870912){let yt=s.getReferencedValueDeclaration(Ze);if(yt){let ar=m[yt.id];if(ar){let or=t.cloneNode(ar);return qa(or,Ze),kl(or,Ze),or}}}}}var YSt=f({"src/compiler/transformers/legacyDecorators.ts"(){"use strict";fa()}});function N0e(e){let{factory:t,getEmitHelperFactory:n,startLexicalEnvironment:i,endLexicalEnvironment:s,hoistVariableDeclaration:o}=e,l=ho(e.getCompilerOptions()),p,m,S,h,b,A;return qm(e,k);function k(B){p=void 0,A=!1;let le=wr(B,se,e);return Ny(le,e.readEmitHelpers()),A&&(BA(le,32),A=!1),le}function N(){switch(m=void 0,S=void 0,h=void 0,p?.kind){case"class":m=p.classInfo;break;case"class-element":m=p.next.classInfo,S=p.classThis,h=p.classSuper;break;case"name":let B=p.next.next.next;B?.kind==="class-element"&&(m=B.next.classInfo,S=B.classThis,h=B.classSuper);break}}function M(B){p={kind:"class",next:p,classInfo:B,savedPendingExpressions:b},b=void 0,N()}function O(){I.assert(p?.kind==="class","Incorrect value for top.kind.",()=>`Expected top.kind to be 'class' but got '${p?.kind}' instead.`),b=p.savedPendingExpressions,p=p.next,N()}function U(B){var le,X;I.assert(p?.kind==="class","Incorrect value for top.kind.",()=>`Expected top.kind to be 'class' but got '${p?.kind}' instead.`),p={kind:"class-element",next:p},(Jc(B)||ea(B)&&jl(B))&&(p.classThis=(le=p.next.classInfo)==null?void 0:le.classThis,p.classSuper=(X=p.next.classInfo)==null?void 0:X.classSuper),N()}function H(){var B;I.assert(p?.kind==="class-element","Incorrect value for top.kind.",()=>`Expected top.kind to be 'class-element' but got '${p?.kind}' instead.`),I.assert(((B=p.next)==null?void 0:B.kind)==="class","Incorrect value for top.next.kind.",()=>{var le;return`Expected top.next.kind to be 'class' but got '${(le=p.next)==null?void 0:le.kind}' instead.`}),p=p.next,N()}function K(){I.assert(p?.kind==="class-element","Incorrect value for top.kind.",()=>`Expected top.kind to be 'class-element' but got '${p?.kind}' instead.`),p={kind:"name",next:p},N()}function re(){I.assert(p?.kind==="name","Incorrect value for top.kind.",()=>`Expected top.kind to be 'name' but got '${p?.kind}' instead.`),p=p.next,N()}function $(){p?.kind==="other"?(I.assert(!b),p.depth++):(p={kind:"other",next:p,depth:0,savedPendingExpressions:b},b=void 0,N())}function pe(){I.assert(p?.kind==="other","Incorrect value for top.kind.",()=>`Expected top.kind to be 'other' but got '${p?.kind}' instead.`),p.depth>0?(I.assert(!b),p.depth--):(b=p.savedPendingExpressions,p=p.next,N())}function z(B){return!!(B.transformFlags&33554432)||!!S&&!!(B.transformFlags&16384)||!!S&&!!h&&!!(B.transformFlags&134217728)}function se(B){if(!z(B))return B;switch(B.kind){case 170:return I.fail("Use `modifierVisitor` instead.");case 263:return Me(B);case 231:return Ge(B);case 176:case 172:case 175:return I.fail("Not supported outside of a class. Use 'classElementVisitor' instead.");case 169:return rn(B);case 226:return xs(B,!1);case 303:return _r(B);case 260:return rt(B);case 208:return zt(B);case 277:return We(B);case 110:return Ze(B);case 248:return tr(B);case 244:return ki(B);case 361:return Ms(B,!1);case 217:return mt(B,!1);case 360:return dt(B,!1);case 213:return yt(B);case 215:return ar(B);case 224:case 225:return zi(B,!1);case 211:return or(B);case 212:return Fr(B);case 167:return On(B);case 174:case 178:case 177:case 218:case 262:{$();let le=wr(B,Se,e);return pe(),le}default:return wr(B,Se,e)}}function Se(B){switch(B.kind){case 170:return;default:return se(B)}}function xe(B){switch(B.kind){case 170:return;default:return B}}function Z(B){switch(B.kind){case 176:return Re(B);case 174:return ke(B);case 177:return $e(B);case 178:return at(B);case 172:return St(B);case 175:return $t(B);default:return se(B)}}function Q(B){switch(B.kind){case 224:case 225:return zi(B,!0);case 226:return xs(B,!0);case 361:return Ms(B,!0);case 217:return mt(B,!0);default:return se(B)}}function ce(B){let le=B.name&&ze(B.name)&&!yc(B.name)?Nn(B.name):B.name&&is(B.name)&&!yc(B.name)?Nn(B.name).slice(1):B.name&&za(B.name)&&nd(B.name.text,99)?B.name.text:Ti(B)?"class":"member";return Fv(B)&&(le=`get_${le}`),A1(B)&&(le=`set_${le}`),B.name&&is(B.name)&&(le=`private_${le}`),pa(B)&&(le=`static_${le}`),"_"+le}function ye(B,le){return t.createUniqueName(`${ce(B)}_${le}`,24)}function we(B,le){return t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(B,void 0,void 0,le)],1))}function ve(B){let le=t.createUniqueName("_metadata",48),X,he,qe=!1,Le=!1,It=!1,Rt,Zt,Ir;if(uN(!1,B)){let zr=Tt(B.members,Yr=>(G_(Yr)||Af(Yr))&&jl(Yr));Rt=t.createUniqueName("_classThis",zr?24:48)}for(let zr of B.members){if(vA(zr)&&A8(!1,zr,B))if(jl(zr)){if(!he){he=t.createUniqueName("_staticExtraInitializers",48);let Yr=n().createRunInitializersHelper(Rt??t.createThis(),he);qa(Yr,B.name??Ay(B)),Zt??(Zt=[]),Zt.push(Yr)}}else{if(!X){X=t.createUniqueName("_instanceExtraInitializers",48);let Yr=n().createRunInitializersHelper(t.createThis(),X);qa(Yr,B.name??Ay(B)),Ir??(Ir=[]),Ir.push(Yr)}X??(X=t.createUniqueName("_instanceExtraInitializers",48))}if(Jc(zr)?dk(zr)||(qe=!0):ea(zr)&&(jl(zr)?qe||(qe=!!zr.initializer||Ad(zr)):Le||(Le=!wY(zr))),(G_(zr)||Af(zr))&&jl(zr)&&(It=!0),he&&X&&qe&&Le&&It)break}return{class:B,classThis:Rt,metadataReference:le,instanceMethodExtraInitializersName:X,staticMethodExtraInitializersName:he,hasStaticInitializers:qe,hasNonAmbientInstanceFields:Le,hasStaticPrivateClassElements:It,pendingStaticInitializers:Zt,pendingInstanceInitializers:Ir}}function oe(B){i(),!gZ(B)&&k1(!1,B)&&(B=lV(e,B,t.createStringLiteral("")));let le=t.getLocalName(B,!1,!1,!0),X=ve(B),he=[],qe,Le,It,Rt,Zt=!1,Ir=pt(_Z(B));Ir&&(X.classDecoratorsName=t.createUniqueName("_classDecorators",48),X.classDescriptorName=t.createUniqueName("_classDescriptor",48),X.classExtraInitializersName=t.createUniqueName("_classExtraInitializers",48),I.assertIsDefined(X.classThis),he.push(we(X.classDecoratorsName,t.createArrayLiteralExpression(Ir)),we(X.classDescriptorName),we(X.classExtraInitializersName,t.createArrayLiteralExpression()),we(X.classThis)),X.hasStaticPrivateClassElements&&(Zt=!0,A=!0));let zr=W8(B.heritageClauses,96),Yr=zr&&qi(zr.types),Pi=Yr&&nt(Yr.expression,se,bt);if(Pi){X.classSuper=t.createUniqueName("_classSuper",48);let ni=vl(Pi),js=wu(ni)&&!ni.name||Xo(ni)&&!ni.name||rc(ni)?t.createComma(t.createNumericLiteral(0),Pi):Pi;he.push(we(X.classSuper,js));let Mr=t.updateExpressionWithTypeArguments(Yr,X.classSuper,void 0),Qo=t.updateHeritageClause(zr,[Mr]);Rt=t.createNodeArray([Qo])}let Fi=X.classThis??t.createThis();M(X),qe=Pr(qe,Y(X.metadataReference,X.classSuper));let fn=B.members;if(fn=Hr(fn,ni=>Yc(ni)?ni:Z(ni),Du),fn=Hr(fn,ni=>Yc(ni)?Z(ni):ni,Du),b){let ni;for(let js of b){js=nt(js,function Qo(Sl){if(!(Sl.transformFlags&16384))return Sl;switch(Sl.kind){case 110:return ni||(ni=t.createUniqueName("_outerThis",16),he.unshift(we(ni,t.createThis()))),ni;default:return wr(Sl,Qo,e)}},bt);let Mr=t.createExpressionStatement(js);qe=Pr(qe,Mr)}b=void 0}if(O(),Tt(X.pendingInstanceInitializers)&&!I0(B)){let ni=Ae(B,X);if(ni){let js=$g(B),Mr=!!(js&&vl(js.expression).kind!==106),Qo=[];if(Mr){let zs=t.createSpreadElement(t.createIdentifier("arguments")),Eo=t.createCallExpression(t.createSuper(),void 0,[zs]);Qo.push(t.createExpressionStatement(Eo))}jt(Qo,ni);let Sl=t.createBlock(Qo,!0);It=t.createConstructorDeclaration(void 0,[],Sl)}}if(X.staticMethodExtraInitializersName&&he.push(we(X.staticMethodExtraInitializersName,t.createArrayLiteralExpression())),X.instanceMethodExtraInitializersName&&he.push(we(X.instanceMethodExtraInitializersName,t.createArrayLiteralExpression())),X.memberInfos&&yu(X.memberInfos,(ni,js)=>{pa(js)&&(he.push(we(ni.memberDecoratorsName)),ni.memberInitializersName&&he.push(we(ni.memberInitializersName,t.createArrayLiteralExpression())),ni.memberExtraInitializersName&&he.push(we(ni.memberExtraInitializersName,t.createArrayLiteralExpression())),ni.memberDescriptorName&&he.push(we(ni.memberDescriptorName)))}),X.memberInfos&&yu(X.memberInfos,(ni,js)=>{pa(js)||(he.push(we(ni.memberDecoratorsName)),ni.memberInitializersName&&he.push(we(ni.memberInitializersName,t.createArrayLiteralExpression())),ni.memberExtraInitializersName&&he.push(we(ni.memberExtraInitializersName,t.createArrayLiteralExpression())),ni.memberDescriptorName&&he.push(we(ni.memberDescriptorName)))}),qe=jt(qe,X.staticNonFieldDecorationStatements),qe=jt(qe,X.nonStaticNonFieldDecorationStatements),qe=jt(qe,X.staticFieldDecorationStatements),qe=jt(qe,X.nonStaticFieldDecorationStatements),X.classDescriptorName&&X.classDecoratorsName&&X.classExtraInitializersName&&X.classThis){qe??(qe=[]);let ni=t.createPropertyAssignment("value",Fi),js=t.createObjectLiteralExpression([ni]),Mr=t.createAssignment(X.classDescriptorName,js),Qo=t.createPropertyAccessExpression(Fi,"name"),Sl=n().createESDecorateHelper(t.createNull(),Mr,X.classDecoratorsName,{kind:"class",name:Qo,metadata:X.metadataReference},t.createNull(),X.classExtraInitializersName),zs=t.createExpressionStatement(Sl);qa(zs,Ay(B)),qe.push(zs);let Eo=t.createPropertyAccessExpression(X.classDescriptorName,"value"),nc=t.createAssignment(X.classThis,Eo),Dc=t.createAssignment(le,nc);qe.push(t.createExpressionStatement(Dc))}if(qe.push(Be(Fi,X.metadataReference)),Tt(X.pendingStaticInitializers)){for(let ni of X.pendingStaticInitializers){let js=t.createExpressionStatement(ni);qa(js,R1(ni)),Le=Pr(Le,js)}X.pendingStaticInitializers=void 0}if(X.classExtraInitializersName){let ni=n().createRunInitializersHelper(Fi,X.classExtraInitializersName),js=t.createExpressionStatement(ni);qa(js,B.name??Ay(B)),Le=Pr(Le,js)}qe&&Le&&!X.hasStaticInitializers&&(jt(qe,Le),Le=void 0);let Qn=qe&&t.createClassStaticBlockDeclaration(t.createBlock(qe,!0));Qn&&Zt&&CR(Qn,32);let Ns=Le&&t.createClassStaticBlockDeclaration(t.createBlock(Le,!0));if(Qn||It||Ns){let ni=[],js=fn.findIndex(dk);Qn?(jt(ni,fn,0,js+1),ni.push(Qn),jt(ni,fn,js+1)):jt(ni,fn),It&&ni.push(It),Ns&&ni.push(Ns),fn=ft(t.createNodeArray(ni),fn)}let Vi=s(),ji;if(Ir){ji=t.createClassExpression(void 0,void 0,void 0,Rt,fn),X.classThis&&(ji=T0e(t,ji,X.classThis));let ni=t.createVariableDeclaration(le,void 0,void 0,ji),js=t.createVariableDeclarationList([ni]),Mr=X.classThis?t.createAssignment(le,X.classThis):le;he.push(t.createVariableStatement(void 0,js),t.createReturnStatement(Mr))}else ji=t.createClassExpression(void 0,B.name,void 0,Rt,fn),he.push(t.createReturnStatement(ji));if(Zt){BA(ji,32);for(let ni of ji.members)(G_(ni)||Af(ni))&&jl(ni)&&BA(ni,32)}return Un(ji,B),t.createImmediatelyInvokedArrowFunction(t.mergeLexicalEnvironment(he,Vi))}function Ee(B){return k1(!1,B)||zw(!1,B)}function Me(B){if(Ee(B)){let le=[],X=Hc(B,Ti)??B,he=X.name?t.createStringLiteralFromNode(X.name):t.createStringLiteral("default"),qe=ui(B,32),Le=ui(B,2048);if(B.name||(B=lV(e,B,he)),qe&&Le){let It=oe(B);if(B.name){let Rt=t.createVariableDeclaration(t.getLocalName(B),void 0,void 0,It);Un(Rt,B);let Zt=t.createVariableDeclarationList([Rt],1),Ir=t.createVariableStatement(void 0,Zt);le.push(Ir);let zr=t.createExportDefault(t.getDeclarationName(B));Un(zr,B),kl(zr,Qg(B)),qa(zr,Ay(B)),le.push(zr)}else{let Rt=t.createExportDefault(It);Un(Rt,B),kl(Rt,Qg(B)),qa(Rt,Ay(B)),le.push(Rt)}}else{I.assertIsDefined(B.name,"A class declaration that is not a default export must have a name.");let It=oe(B),Rt=qe?Fi=>WA(Fi)?void 0:xe(Fi):xe,Zt=Hr(B.modifiers,Rt,Ra),Ir=t.getLocalName(B,!1,!0),zr=t.createVariableDeclaration(Ir,void 0,void 0,It);Un(zr,B);let Yr=t.createVariableDeclarationList([zr],1),Pi=t.createVariableStatement(Zt,Yr);if(Un(Pi,B),kl(Pi,Qg(B)),le.push(Pi),qe){let Fi=t.createExternalModuleExport(Ir);Un(Fi,B),le.push(Fi)}}return Op(le)}else{let le=Hr(B.modifiers,xe,Ra),X=Hr(B.heritageClauses,se,ad);M(void 0);let he=Hr(B.members,Z,Du);return O(),t.updateClassDeclaration(B,le,B.name,void 0,X,he)}}function Ge(B){if(Ee(B)){let le=oe(B);return Un(le,B),le}else{let le=Hr(B.modifiers,xe,Ra),X=Hr(B.heritageClauses,se,ad);M(void 0);let he=Hr(B.members,Z,Du);return O(),t.updateClassExpression(B,le,B.name,void 0,X,he)}}function Ae(B,le){if(Tt(le.pendingInstanceInitializers)){let X=[];return X.push(t.createExpressionStatement(t.inlineExpressions(le.pendingInstanceInitializers))),le.pendingInstanceInitializers=void 0,X}}function Ie(B,le,X,he,qe,Le){let It=he[qe],Rt=le[It];if(jt(B,Hr(le,se,ns,X,It-X)),fx(Rt)){let Zt=[];Ie(Zt,Rt.tryBlock.statements,0,he,qe+1,Le);let Ir=t.createNodeArray(Zt);ft(Ir,Rt.tryBlock.statements),B.push(t.updateTryStatement(Rt,t.updateBlock(Rt.tryBlock,Zt),nt(Rt.catchClause,se,mE),nt(Rt.finallyBlock,se,ra)))}else jt(B,Hr(le,se,ns,It,1)),jt(B,Le);jt(B,Hr(le,se,ns,It+1))}function Re(B){U(B);let le=Hr(B.modifiers,xe,Ra),X=Hr(B.parameters,se,Ls),he;if(B.body&&m){let qe=Ae(m.class,m);if(qe){let Le=[],It=t.copyPrologue(B.body.statements,Le,!1,se),Rt=sV(B.body.statements,It);Rt.length>0?Ie(Le,B.body.statements,It,Rt,0,qe):(jt(Le,qe),jt(Le,Hr(B.body.statements,se,ns))),he=t.createBlock(Le,!0),Un(he,B.body),ft(he,B.body)}}return he??(he=nt(B.body,se,ra)),H(),t.updateConstructorDeclaration(B,le,X,he)}function Ue(B,le){return B!==le&&(kl(B,le),qa(B,Ay(le))),B}function kt(B,le,X){let he,qe,Le,It,Rt,Zt;if(!le){let Yr=Hr(B.modifiers,xe,Ra);return K(),qe=ri(B.name),re(),{modifiers:Yr,referencedName:he,name:qe,initializersName:Le,descriptorName:Zt,thisArg:Rt}}let Ir=pt(oV(B,le.class,!1)),zr=Hr(B.modifiers,xe,Ra);if(Ir){let Yr=ye(B,"decorators"),Pi=t.createArrayLiteralExpression(Ir),Fi=t.createAssignment(Yr,Pi),fn={memberDecoratorsName:Yr};le.memberInfos??(le.memberInfos=new Map),le.memberInfos.set(B,fn),b??(b=[]),b.push(Fi);let Qn=vA(B)||Af(B)?pa(B)?le.staticNonFieldDecorationStatements??(le.staticNonFieldDecorationStatements=[]):le.nonStaticNonFieldDecorationStatements??(le.nonStaticNonFieldDecorationStatements=[]):ea(B)&&!Af(B)?pa(B)?le.staticFieldDecorationStatements??(le.staticFieldDecorationStatements=[]):le.nonStaticFieldDecorationStatements??(le.nonStaticFieldDecorationStatements=[]):I.fail(),Ns=sd(B)?"getter":pp(B)?"setter":pl(B)?"method":Af(B)?"accessor":ea(B)?"field":I.fail(),Vi;if(ze(B.name)||is(B.name))Vi={computed:!1,name:B.name};else if(Wg(B.name))Vi={computed:!0,name:t.createStringLiteralFromNode(B.name)};else{let ni=B.name.expression;Wg(ni)&&!ze(ni)?Vi={computed:!0,name:t.createStringLiteralFromNode(ni)}:(K(),{referencedName:he,name:qe}=un(B.name),Vi={computed:!0,name:he},re())}let ji={kind:Ns,name:Vi,static:pa(B),private:is(B.name),access:{get:ea(B)||sd(B)||pl(B),set:ea(B)||pp(B)},metadata:le.metadataReference};if(vA(B)){let ni=pa(B)?le.staticMethodExtraInitializersName:le.instanceMethodExtraInitializersName;I.assertIsDefined(ni);let js;G_(B)&&X&&(js=X(B,Hr(zr,Sl=>ii(Sl,R6),Ra)),fn.memberDescriptorName=Zt=ye(B,"descriptor"),js=t.createAssignment(Zt,js));let Mr=n().createESDecorateHelper(t.createThis(),js??t.createNull(),Yr,ji,t.createNull(),ni),Qo=t.createExpressionStatement(Mr);qa(Qo,Ay(B)),Qn.push(Qo)}else if(ea(B)){Le=fn.memberInitializersName??(fn.memberInitializersName=ye(B,"initializers")),It=fn.memberExtraInitializersName??(fn.memberExtraInitializersName=ye(B,"extraInitializers")),pa(B)&&(Rt=le.classThis);let ni;G_(B)&&Hg(B)&&X&&(ni=X(B,void 0),fn.memberDescriptorName=Zt=ye(B,"descriptor"),ni=t.createAssignment(Zt,ni));let js=n().createESDecorateHelper(Af(B)?t.createThis():t.createNull(),ni??t.createNull(),Yr,ji,Le,It),Mr=t.createExpressionStatement(js);qa(Mr,Ay(B)),Qn.push(Mr)}}return qe===void 0&&(K(),qe=ri(B.name),re()),!Tt(zr)&&(pl(B)||ea(B))&&Sn(qe,1024),{modifiers:zr,referencedName:he,name:qe,initializersName:Le,extraInitializersName:It,descriptorName:Zt,thisArg:Rt}}function ke(B){U(B);let{modifiers:le,name:X,descriptorName:he}=kt(B,m,Nt);if(he)return H(),Ue(Cr(le,X,he),B);{let qe=Hr(B.parameters,se,Ls),Le=nt(B.body,se,ra);return H(),Ue(t.updateMethodDeclaration(B,le,B.asteriskToken,X,void 0,void 0,qe,void 0,Le),B)}}function $e(B){U(B);let{modifiers:le,name:X,descriptorName:he}=kt(B,m,Ke);if(he)return H(),Ue(hr(le,X,he),B);{let qe=Hr(B.parameters,se,Ls),Le=nt(B.body,se,ra);return H(),Ue(t.updateGetAccessorDeclaration(B,le,X,qe,void 0,Le),B)}}function at(B){U(B);let{modifiers:le,name:X,descriptorName:he}=kt(B,m,ht);if(he)return H(),Ue(Sr(le,X,he),B);{let qe=Hr(B.parameters,se,Ls),Le=nt(B.body,se,ra);return H(),Ue(t.updateSetAccessorDeclaration(B,le,X,qe,Le),B)}}function $t(B){U(B);let le;if(dk(B))le=wr(B,se,e);else if(cO(B)){let X=S;S=void 0,le=wr(B,se,e),S=X}else if(B=wr(B,se,e),le=B,m&&(m.hasStaticInitializers=!0,Tt(m.pendingStaticInitializers))){let X=[];for(let Le of m.pendingStaticInitializers){let It=t.createExpressionStatement(Le);qa(It,R1(Le)),X.push(It)}let he=t.createBlock(X,!0);le=[t.createClassStaticBlockDeclaration(he),le],m.pendingStaticInitializers=void 0}return H(),le}function St(B){lp(B,Tr)&&(B=mp(e,B,nr(B.initializer))),U(B),I.assert(!wY(B),"Not yet implemented.");let{modifiers:le,name:X,initializersName:he,extraInitializersName:qe,descriptorName:Le,thisArg:It}=kt(B,m,Hg(B)?Wt:void 0);i();let Rt=nt(B.initializer,se,bt);he&&(Rt=n().createRunInitializersHelper(It??t.createThis(),he,Rt??t.createVoidZero())),pa(B)&&m&&Rt&&(m.hasStaticInitializers=!0);let Zt=s();if(Tt(Zt)&&(Rt=t.createImmediatelyInvokedArrowFunction([...Zt,t.createReturnStatement(Rt)])),m&&(pa(B)?(Rt=Ve(m,!0,Rt),qe&&(m.pendingStaticInitializers??(m.pendingStaticInitializers=[]),m.pendingStaticInitializers.push(n().createRunInitializersHelper(m.classThis??t.createThis(),qe)))):(Rt=Ve(m,!1,Rt),qe&&(m.pendingInstanceInitializers??(m.pendingInstanceInitializers=[]),m.pendingInstanceInitializers.push(n().createRunInitializersHelper(t.createThis(),qe))))),H(),Hg(B)&&Le){let Ir=Qg(B),zr=R1(B),Yr=B.name,Pi=Yr,Fi=Yr;if(uo(Yr)&&!rh(Yr.expression)){let ji=TU(Yr);if(ji)Pi=t.updateComputedPropertyName(Yr,nt(Yr.expression,se,bt)),Fi=t.updateComputedPropertyName(Yr,ji.left);else{let ni=t.createTempVariable(o);qa(ni,Yr.expression);let js=nt(Yr.expression,se,bt),Mr=t.createAssignment(ni,js);qa(Mr,Yr.expression),Pi=t.updateComputedPropertyName(Yr,Mr),Fi=t.updateComputedPropertyName(Yr,ni)}}let fn=Hr(le,ji=>ji.kind!==129?ji:void 0,Ra),Qn=sQ(t,B,fn,Rt);Un(Qn,B),Sn(Qn,3072),qa(Qn,zr),qa(Qn.name,B.name);let Ns=hr(fn,Pi,Le);Un(Ns,B),kl(Ns,Ir),qa(Ns,zr);let Vi=Sr(fn,Fi,Le);return Un(Vi,B),Sn(Vi,3072),qa(Vi,zr),[Qn,Ns,Vi]}return Ue(t.updatePropertyDeclaration(B,le,X,void 0,void 0,Rt),B)}function Ze(B){return S??B}function yt(B){if(Pf(B.expression)&&S){let le=nt(B.expression,se,bt),X=Hr(B.arguments,se,bt),he=t.createFunctionCallCall(le,S,X);return Un(he,B),ft(he,B),he}return wr(B,se,e)}function ar(B){if(Pf(B.tag)&&S){let le=nt(B.tag,se,bt),X=t.createFunctionBindCall(le,S,[]);Un(X,B),ft(X,B);let he=nt(B.template,se,SA);return t.updateTaggedTemplateExpression(B,X,void 0,he)}return wr(B,se,e)}function or(B){if(Pf(B)&&ze(B.name)&&S&&h){let le=t.createStringLiteralFromNode(B.name),X=t.createReflectGetCall(h,le,S);return Un(X,B.expression),ft(X,B.expression),X}return wr(B,se,e)}function Fr(B){if(Pf(B)&&S&&h){let le=nt(B.argumentExpression,se,bt),X=t.createReflectGetCall(h,le,S);return Un(X,B.expression),ft(X,B.expression),X}return wr(B,se,e)}function rn(B){lp(B,Tr)&&(B=mp(e,B,nr(B.initializer)));let le=t.updateParameterDeclaration(B,void 0,B.dotDotDotToken,nt(B.name,se,j2),void 0,void 0,nt(B.initializer,se,bt));return le!==B&&(kl(le,B),ft(le,Xg(B)),qa(le,Xg(B)),Sn(le.name,64)),le}function Tr(B){return wu(B)&&!B.name&&Ee(B)}function nr(B){let le=vl(B);return wu(le)&&!le.name&&!k1(!1,le)}function tr(B){return t.updateForStatement(B,nt(B.initializer,Q,Cd),nt(B.condition,se,bt),nt(B.incrementor,Q,bt),df(B.statement,se,e))}function ki(B){return wr(B,Q,e)}function xs(B,le){if(I1(B)){let X=qr(B.left),he=nt(B.right,se,bt);return t.updateBinaryExpression(B,X,B.operatorToken,he)}if(lu(B)){if(lp(B,Tr))return B=mp(e,B,nr(B.right)),wr(B,se,e);if(Pf(B.left)&&S&&h){let X=fc(B.left)?nt(B.left.argumentExpression,se,bt):ze(B.left.name)?t.createStringLiteralFromNode(B.left.name):void 0;if(X){let he=nt(B.right,se,bt);if(sO(B.operatorToken.kind)){let Le=X;rh(X)||(Le=t.createTempVariable(o),X=t.createAssignment(Le,X));let It=t.createReflectGetCall(h,Le,S);Un(It,B.left),ft(It,B.left),he=t.createBinaryExpression(It,aO(B.operatorToken.kind),he),ft(he,B)}let qe=le?void 0:t.createTempVariable(o);return qe&&(he=t.createAssignment(qe,he),ft(qe,B)),he=t.createReflectSetCall(h,X,he,S),Un(he,B),ft(he,B),qe&&(he=t.createComma(he,qe),ft(he,B)),he}}}if(B.operatorToken.kind===28){let X=nt(B.left,Q,bt),he=nt(B.right,le?Q:se,bt);return t.updateBinaryExpression(B,X,B.operatorToken,he)}return wr(B,se,e)}function zi(B,le){if(B.operator===46||B.operator===47){let X=Do(B.operand);if(Pf(X)&&S&&h){let he=fc(X)?nt(X.argumentExpression,se,bt):ze(X.name)?t.createStringLiteralFromNode(X.name):void 0;if(he){let qe=he;rh(he)||(qe=t.createTempVariable(o),he=t.createAssignment(qe,he));let Le=t.createReflectGetCall(h,qe,S);Un(Le,B),ft(Le,B);let It=le?void 0:t.createTempVariable(o);return Le=dU(t,B,Le,o,It),Le=t.createReflectSetCall(h,he,Le,S),Un(Le,B),ft(Le,B),It&&(Le=t.createComma(Le,It),ft(Le,B)),Le}}}return wr(B,se,e)}function Ms(B,le){let X=le?TM(B.elements,Q):TM(B.elements,se,Q);return t.updateCommaListExpression(B,X)}function un(B){if(Wg(B)||is(B)){let Le=t.createStringLiteralFromNode(B),It=nt(B,se,Al);return{referencedName:Le,name:It}}if(Wg(B.expression)&&!ze(B.expression)){let Le=t.createStringLiteralFromNode(B.expression),It=nt(B,se,Al);return{referencedName:Le,name:It}}let le=t.getGeneratedNameForNode(B);o(le);let X=n().createPropKeyHelper(nt(B.expression,se,bt)),he=t.createAssignment(le,X),qe=t.updateComputedPropertyName(B,_e(he));return{referencedName:le,name:qe}}function ri(B){return uo(B)?On(B):nt(B,se,Al)}function On(B){let le=nt(B.expression,se,bt);return rh(le)||(le=_e(le)),t.updateComputedPropertyName(B,le)}function _r(B){return lp(B,Tr)&&(B=mp(e,B,nr(B.initializer))),wr(B,se,e)}function rt(B){return lp(B,Tr)&&(B=mp(e,B,nr(B.initializer))),wr(B,se,e)}function zt(B){return lp(B,Tr)&&(B=mp(e,B,nr(B.initializer))),wr(B,se,e)}function Rr(B){if(Ha(B)||Z_(B))return qr(B);if(Pf(B)&&S&&h){let le=fc(B)?nt(B.argumentExpression,se,bt):ze(B.name)?t.createStringLiteralFromNode(B.name):void 0;if(le){let X=t.createTempVariable(void 0),he=t.createAssignmentTargetWrapper(X,t.createReflectSetCall(h,le,X,S));return Un(he,B),ft(he,B),he}}return wr(B,se,e)}function vi(B){if(lu(B,!0)){lp(B,Tr)&&(B=mp(e,B,nr(B.right)));let le=Rr(B.left),X=nt(B.right,se,bt);return t.updateBinaryExpression(B,le,B.operatorToken,X)}else return Rr(B)}function Ni(B){if($f(B.expression)){let le=Rr(B.expression);return t.updateSpreadElement(B,le)}return wr(B,se,e)}function us(B){return I.assertNode(B,a8),fg(B)?Ni(B):Su(B)?wr(B,se,e):vi(B)}function Fs(B){let le=nt(B.name,se,Al);if(lu(B.initializer,!0)){let X=vi(B.initializer);return t.updatePropertyAssignment(B,le,X)}if($f(B.initializer)){let X=Rr(B.initializer);return t.updatePropertyAssignment(B,le,X)}return wr(B,se,e)}function Ta(B){return lp(B,Tr)&&(B=mp(e,B,nr(B.objectAssignmentInitializer))),wr(B,se,e)}function to(B){if($f(B.expression)){let le=Rr(B.expression);return t.updateSpreadAssignment(B,le)}return wr(B,se,e)}function Nr(B){return I.assertNode(B,s8),F1(B)?to(B):Hf(B)?Ta(B):Ul(B)?Fs(B):wr(B,se,e)}function qr(B){if(Z_(B)){let le=Hr(B.elements,us,bt);return t.updateArrayLiteralExpression(B,le)}else{let le=Hr(B.properties,Nr,by);return t.updateObjectLiteralExpression(B,le)}}function We(B){return lp(B,Tr)&&(B=mp(e,B,nr(B.expression))),wr(B,se,e)}function mt(B,le){let X=le?Q:se,he=nt(B.expression,X,bt);return t.updateParenthesizedExpression(B,he)}function dt(B,le){let X=le?Q:se,he=nt(B.expression,X,bt);return t.updatePartiallyEmittedExpression(B,he)}function Ot(B,le){return Tt(B)&&(le?Df(le)?(B.push(le.expression),le=t.updateParenthesizedExpression(le,t.inlineExpressions(B))):(B.push(le),le=t.inlineExpressions(B)):le=t.inlineExpressions(B)),le}function _e(B){let le=Ot(b,B);return I.assertIsDefined(le),le!==B&&(b=void 0),le}function Ve(B,le,X){let he=Ot(le?B.pendingStaticInitializers:B.pendingInstanceInitializers,X);return he!==X&&(le?B.pendingStaticInitializers=void 0:B.pendingInstanceInitializers=void 0),he}function pt(B){if(!B)return;let le=[];return jt(le,vr(B.decorators,W)),le}function W(B){let le=nt(B.expression,se,bt);Sn(le,3072);let X=vl(le);if(Yo(X)){let{target:he,thisArg:qe}=t.createCallBinding(le,o,l,!0);return t.restoreOuterExpressions(le,t.createFunctionBindCall(he,qe,[]))}return le}function st(B,le,X,he,qe,Le,It){let Rt=t.createFunctionExpression(X,he,void 0,void 0,Le,void 0,It??t.createBlock([]));Un(Rt,B),qa(Rt,Ay(B)),Sn(Rt,3072);let Zt=qe==="get"||qe==="set"?qe:void 0,Ir=t.createStringLiteralFromNode(le,void 0),zr=n().createSetFunctionNameHelper(Rt,Ir,Zt),Yr=t.createPropertyAssignment(t.createIdentifier(qe),zr);return Un(Yr,B),qa(Yr,Ay(B)),Sn(Yr,3072),Yr}function Nt(B,le){return t.createObjectLiteralExpression([st(B,B.name,le,B.asteriskToken,"value",Hr(B.parameters,se,Ls),nt(B.body,se,ra))])}function Ke(B,le){return t.createObjectLiteralExpression([st(B,B.name,le,void 0,"get",[],nt(B.body,se,ra))])}function ht(B,le){return t.createObjectLiteralExpression([st(B,B.name,le,void 0,"set",Hr(B.parameters,se,Ls),nt(B.body,se,ra))])}function Wt(B,le){return t.createObjectLiteralExpression([st(B,B.name,le,void 0,"get",[],t.createBlock([t.createReturnStatement(t.createPropertyAccessExpression(t.createThis(),t.getGeneratedPrivateNameForNode(B.name)))])),st(B,B.name,le,void 0,"set",[t.createParameterDeclaration(void 0,void 0,"value")],t.createBlock([t.createExpressionStatement(t.createAssignment(t.createPropertyAccessExpression(t.createThis(),t.getGeneratedPrivateNameForNode(B.name)),t.createIdentifier("value")))]))])}function Cr(B,le,X){return B=Hr(B,he=>GA(he)?he:void 0,Ra),t.createGetAccessorDeclaration(B,le,[],void 0,t.createBlock([t.createReturnStatement(t.createPropertyAccessExpression(X,t.createIdentifier("value")))]))}function hr(B,le,X){return B=Hr(B,he=>GA(he)?he:void 0,Ra),t.createGetAccessorDeclaration(B,le,[],void 0,t.createBlock([t.createReturnStatement(t.createFunctionCallCall(t.createPropertyAccessExpression(X,t.createIdentifier("get")),t.createThis(),[]))]))}function Sr(B,le,X){return B=Hr(B,he=>GA(he)?he:void 0,Ra),t.createSetAccessorDeclaration(B,le,[t.createParameterDeclaration(void 0,void 0,"value")],t.createBlock([t.createReturnStatement(t.createFunctionCallCall(t.createPropertyAccessExpression(X,t.createIdentifier("set")),t.createThis(),[t.createIdentifier("value")]))]))}function Y(B,le){let X=t.createVariableDeclaration(B,void 0,void 0,t.createConditionalExpression(t.createLogicalAnd(t.createTypeCheck(t.createIdentifier("Symbol"),"function"),t.createPropertyAccessExpression(t.createIdentifier("Symbol"),"metadata")),t.createToken(58),t.createCallExpression(t.createPropertyAccessExpression(t.createIdentifier("Object"),"create"),void 0,[le?Lt(le):t.createNull()]),t.createToken(59),t.createVoidZero()));return t.createVariableStatement(void 0,t.createVariableDeclarationList([X],2))}function Be(B,le){let X=t.createObjectDefinePropertyCall(B,t.createPropertyAccessExpression(t.createIdentifier("Symbol"),"metadata"),t.createPropertyDescriptor({configurable:!0,writable:!0,enumerable:!0,value:le},!0));return Sn(t.createIfStatement(le,t.createExpressionStatement(X)),1)}function Lt(B){return t.createBinaryExpression(t.createElementAccessExpression(B,t.createPropertyAccessExpression(t.createIdentifier("Symbol"),"metadata")),61,t.createNull())}}var XSt=f({"src/compiler/transformers/esDecorators.ts"(){"use strict";fa()}});function D0e(e){let{factory:t,getEmitHelperFactory:n,resumeLexicalEnvironment:i,endLexicalEnvironment:s,hoistVariableDeclaration:o}=e,l=e.getEmitResolver(),p=e.getCompilerOptions(),m=ho(p),S,h=0,b,A,k,N,M=[],O=0,U=e.onEmitNode,H=e.onSubstituteNode;return e.onEmitNode=ki,e.onSubstituteNode=xs,qm(e,K);function K(rt){if(rt.isDeclarationFile)return rt;re(1,!1),re(2,!IY(rt,p));let zt=wr(rt,Z,e);return Ny(zt,e.readEmitHelpers()),zt}function re(rt,zt){O=zt?O|rt:O&~rt}function $(rt){return(O&rt)!==0}function pe(){return!$(1)}function z(){return $(2)}function se(rt,zt,Rr){let vi=rt&~O;if(vi){re(vi,!0);let Ni=zt(Rr);return re(vi,!1),Ni}return zt(Rr)}function Se(rt){return wr(rt,Z,e)}function xe(rt){switch(rt.kind){case 218:case 262:case 174:case 177:case 178:case 176:return rt;case 169:case 208:case 260:break;case 80:if(N&&l.isArgumentsLocalBinding(rt))return N;break}return wr(rt,xe,e)}function Z(rt){if(!(rt.transformFlags&256))return N?xe(rt):rt;switch(rt.kind){case 134:return;case 223:return Ee(rt);case 174:return se(3,Ge,rt);case 262:return se(3,Re,rt);case 218:return se(3,Ue,rt);case 219:return se(1,kt,rt);case 211:return A&&Hn(rt)&&rt.expression.kind===108&&A.add(rt.name.escapedText),wr(rt,Z,e);case 212:return A&&rt.expression.kind===108&&(k=!0),wr(rt,Z,e);case 177:return se(3,Ae,rt);case 178:return se(3,Ie,rt);case 176:return se(3,Me,rt);case 263:case 231:return se(3,Se,rt);default:return wr(rt,Z,e)}}function Q(rt){if(Dde(rt))switch(rt.kind){case 243:return ye(rt);case 248:return oe(rt);case 249:return we(rt);case 250:return ve(rt);case 299:return ce(rt);case 241:case 255:case 269:case 296:case 297:case 258:case 246:case 247:case 245:case 254:case 256:return wr(rt,Q,e);default:return I.assertNever(rt,"Unhandled node.")}return Z(rt)}function ce(rt){let zt=new Set;ke(rt.variableDeclaration,zt);let Rr;if(zt.forEach((vi,Ni)=>{b.has(Ni)&&(Rr||(Rr=new Set(b)),Rr.delete(Ni))}),Rr){let vi=b;b=Rr;let Ni=wr(rt,Q,e);return b=vi,Ni}else return wr(rt,Q,e)}function ye(rt){if($e(rt.declarationList)){let zt=at(rt.declarationList,!1);return zt?t.createExpressionStatement(zt):void 0}return wr(rt,Z,e)}function we(rt){return t.updateForInStatement(rt,$e(rt.initializer)?at(rt.initializer,!0):I.checkDefined(nt(rt.initializer,Z,Cd)),I.checkDefined(nt(rt.expression,Z,bt)),df(rt.statement,Q,e))}function ve(rt){return t.updateForOfStatement(rt,nt(rt.awaitModifier,Z,OK),$e(rt.initializer)?at(rt.initializer,!0):I.checkDefined(nt(rt.initializer,Z,Cd)),I.checkDefined(nt(rt.expression,Z,bt)),df(rt.statement,Q,e))}function oe(rt){let zt=rt.initializer;return t.updateForStatement(rt,$e(zt)?at(zt,!1):nt(rt.initializer,Z,Cd),nt(rt.condition,Z,bt),nt(rt.incrementor,Z,bt),df(rt.statement,Q,e))}function Ee(rt){return pe()?wr(rt,Z,e):Un(ft(t.createYieldExpression(void 0,nt(rt.expression,Z,bt)),rt),rt)}function Me(rt){let zt=N;N=void 0;let Rr=t.updateConstructorDeclaration(rt,Hr(rt.modifiers,Z,Ra),qc(rt.parameters,Z,e),ar(rt));return N=zt,Rr}function Ge(rt){let zt,Rr=vu(rt),vi=N;N=void 0;let Ni=t.updateMethodDeclaration(rt,Hr(rt.modifiers,Z,vc),rt.asteriskToken,rt.name,void 0,void 0,zt=Rr&2?Fr(rt):qc(rt.parameters,Z,e),void 0,Rr&2?rn(rt,zt):ar(rt));return N=vi,Ni}function Ae(rt){let zt=N;N=void 0;let Rr=t.updateGetAccessorDeclaration(rt,Hr(rt.modifiers,Z,vc),rt.name,qc(rt.parameters,Z,e),void 0,ar(rt));return N=zt,Rr}function Ie(rt){let zt=N;N=void 0;let Rr=t.updateSetAccessorDeclaration(rt,Hr(rt.modifiers,Z,vc),rt.name,qc(rt.parameters,Z,e),ar(rt));return N=zt,Rr}function Re(rt){let zt,Rr=N;N=void 0;let vi=vu(rt),Ni=t.updateFunctionDeclaration(rt,Hr(rt.modifiers,Z,vc),rt.asteriskToken,rt.name,void 0,zt=vi&2?Fr(rt):qc(rt.parameters,Z,e),void 0,vi&2?rn(rt,zt):ld(rt.body,Z,e));return N=Rr,Ni}function Ue(rt){let zt,Rr=N;N=void 0;let vi=vu(rt),Ni=t.updateFunctionExpression(rt,Hr(rt.modifiers,Z,Ra),rt.asteriskToken,rt.name,void 0,zt=vi&2?Fr(rt):qc(rt.parameters,Z,e),void 0,vi&2?rn(rt,zt):ld(rt.body,Z,e));return N=Rr,Ni}function kt(rt){let zt,Rr=vu(rt);return t.updateArrowFunction(rt,Hr(rt.modifiers,Z,Ra),void 0,zt=Rr&2?Fr(rt):qc(rt.parameters,Z,e),void 0,rt.equalsGreaterThanToken,Rr&2?rn(rt,zt):ld(rt.body,Z,e))}function ke({name:rt},zt){if(ze(rt))zt.add(rt.escapedText);else for(let Rr of rt.elements)Su(Rr)||ke(Rr,zt)}function $e(rt){return!!rt&&Tu(rt)&&!(rt.flags&7)&&rt.declarations.some(yt)}function at(rt,zt){$t(rt);let Rr=u6(rt);return Rr.length===0?zt?nt(t.converters.convertToAssignmentElementTarget(rt.declarations[0].name),Z,bt):void 0:t.inlineExpressions(vr(Rr,Ze))}function $t(rt){Te(rt.declarations,St)}function St({name:rt}){if(ze(rt))o(rt);else for(let zt of rt.elements)Su(zt)||St(zt)}function Ze(rt){let zt=qa(t.createAssignment(t.converters.convertToAssignmentElementTarget(rt.name),rt.initializer),rt);return I.checkDefined(nt(zt,Z,bt))}function yt({name:rt}){if(ze(rt))return b.has(rt.escapedText);for(let zt of rt.elements)if(!Su(zt)&&yt(zt))return!0;return!1}function ar(rt){I.assertIsDefined(rt.body);let zt=A,Rr=k;A=new Set,k=!1;let vi=ld(rt.body,Z,e),Ni=Hc(rt,tc);if(m>=2&&l.getNodeCheckFlags(rt)&384&&(vu(Ni)&3)!==3){if(tr(),A.size){let Fs=uV(t,l,rt,A);M[yo(Fs)]=!0;let Ta=vi.statements.slice();C0(Ta,[Fs]),vi=t.updateBlock(vi,Ta)}k&&(l.getNodeCheckFlags(rt)&256?VA(vi,DR):l.getNodeCheckFlags(rt)&128&&VA(vi,NR))}return A=zt,k=Rr,vi}function or(){I.assert(N);let rt=t.createVariableDeclaration(N,void 0,void 0,t.createIdentifier("arguments")),zt=t.createVariableStatement(void 0,[rt]);return M_(zt),Kg(zt,2097152),zt}function Fr(rt){if(EM(rt.parameters))return qc(rt.parameters,Z,e);let zt=[];for(let vi of rt.parameters){if(vi.initializer||vi.dotDotDotToken){if(rt.kind===219){let us=t.createParameterDeclaration(void 0,t.createToken(26),t.createUniqueName("args",8));zt.push(us)}break}let Ni=t.createParameterDeclaration(void 0,void 0,t.getGeneratedNameForNode(vi.name,8));zt.push(Ni)}let Rr=t.createNodeArray(zt);return ft(Rr,rt.parameters),Rr}function rn(rt,zt){let Rr=EM(rt.parameters)?void 0:qc(rt.parameters,Z,e);i();let Ni=Hc(rt,ca).type,us=m<2?nr(Ni):void 0,Fs=rt.kind===219,Ta=N,Nr=(l.getNodeCheckFlags(rt)&512)!==0&&!N;Nr&&(N=t.createUniqueName("arguments"));let qr;if(Rr)if(Fs){let pt=[];I.assert(zt.length<=rt.parameters.length);for(let W=0;W<rt.parameters.length;W++){I.assert(W<zt.length);let st=rt.parameters[W],Nt=zt[W];if(I.assertNode(Nt.name,ze),st.initializer||st.dotDotDotToken){I.assert(W===zt.length-1),pt.push(t.createSpreadElement(Nt.name));break}pt.push(Nt.name)}qr=t.createArrayLiteralExpression(pt)}else qr=t.createIdentifier("arguments");let We=b;b=new Set;for(let pt of rt.parameters)ke(pt,b);let mt=A,dt=k;Fs||(A=new Set,k=!1);let Ot=z(),_e=Tr(rt.body);_e=t.updateBlock(_e,t.mergeLexicalEnvironment(_e.statements,s()));let Ve;if(Fs){if(Ve=n().createAwaiterHelper(Ot,qr,us,Rr,_e),Nr){let pt=t.converters.convertToFunctionBlock(Ve);Ve=t.updateBlock(pt,t.mergeLexicalEnvironment(pt.statements,[or()]))}}else{let pt=[];pt.push(t.createReturnStatement(n().createAwaiterHelper(Ot,qr,us,Rr,_e)));let W=m>=2&&l.getNodeCheckFlags(rt)&384;if(W&&(tr(),A.size)){let Nt=uV(t,l,rt,A);M[yo(Nt)]=!0,C0(pt,[Nt])}Nr&&C0(pt,[or()]);let st=t.createBlock(pt,!0);ft(st,rt.body),W&&k&&(l.getNodeCheckFlags(rt)&256?VA(st,DR):l.getNodeCheckFlags(rt)&128&&VA(st,NR)),Ve=st}return b=We,Fs||(A=mt,k=dt,N=Ta),Ve}function Tr(rt,zt){return ra(rt)?t.updateBlock(rt,Hr(rt.statements,Q,ns,zt)):t.converters.convertToFunctionBlock(I.checkDefined(nt(rt,Q,w9)))}function nr(rt){let zt=rt&&C8(rt);if(zt&&zf(zt)){let Rr=l.getTypeReferenceSerializationKind(zt);if(Rr===1||Rr===0)return zt}}function tr(){S&1||(S|=1,e.enableSubstitution(213),e.enableSubstitution(211),e.enableSubstitution(212),e.enableEmitNotification(263),e.enableEmitNotification(174),e.enableEmitNotification(177),e.enableEmitNotification(178),e.enableEmitNotification(176),e.enableEmitNotification(243))}function ki(rt,zt,Rr){if(S&1&&On(zt)){let vi=l.getNodeCheckFlags(zt)&384;if(vi!==h){let Ni=h;h=vi,U(rt,zt,Rr),h=Ni;return}}else if(S&&M[yo(zt)]){let vi=h;h=0,U(rt,zt,Rr),h=vi;return}U(rt,zt,Rr)}function xs(rt,zt){return zt=H(rt,zt),rt===1&&h?zi(zt):zt}function zi(rt){switch(rt.kind){case 211:return Ms(rt);case 212:return un(rt);case 213:return ri(rt)}return rt}function Ms(rt){return rt.expression.kind===108?ft(t.createPropertyAccessExpression(t.createUniqueName("_super",48),rt.name),rt):rt}function un(rt){return rt.expression.kind===108?_r(rt.argumentExpression,rt):rt}function ri(rt){let zt=rt.expression;if(Pf(zt)){let Rr=Hn(zt)?Ms(zt):un(zt);return t.createCallExpression(t.createPropertyAccessExpression(Rr,"call"),void 0,[t.createThis(),...rt.arguments])}return rt}function On(rt){let zt=rt.kind;return zt===263||zt===176||zt===174||zt===177||zt===178}function _r(rt,zt){return h&256?ft(t.createPropertyAccessExpression(t.createCallExpression(t.createUniqueName("_superIndex",48),void 0,[rt]),"value"),zt):ft(t.createCallExpression(t.createUniqueName("_superIndex",48),void 0,[rt]),zt)}}function uV(e,t,n,i){let s=(t.getNodeCheckFlags(n)&256)!==0,o=[];return i.forEach((l,p)=>{let m=Zi(p),S=[];S.push(e.createPropertyAssignment("get",e.createArrowFunction(void 0,void 0,[],void 0,void 0,Sn(e.createPropertyAccessExpression(Sn(e.createSuper(),8),m),8)))),s&&S.push(e.createPropertyAssignment("set",e.createArrowFunction(void 0,void 0,[e.createParameterDeclaration(void 0,void 0,"v",void 0,void 0,void 0)],void 0,void 0,e.createAssignment(Sn(e.createPropertyAccessExpression(Sn(e.createSuper(),8),m),8),e.createIdentifier("v"))))),o.push(e.createPropertyAssignment(m,e.createObjectLiteralExpression(S)))}),e.createVariableStatement(void 0,e.createVariableDeclarationList([e.createVariableDeclaration(e.createUniqueName("_super",48),void 0,void 0,e.createCallExpression(e.createPropertyAccessExpression(e.createIdentifier("Object"),"create"),void 0,[e.createNull(),e.createObjectLiteralExpression(o,!0)]))],2))}var KSt=f({"src/compiler/transformers/es2017.ts"(){"use strict";fa()}});function I0e(e){let{factory:t,getEmitHelperFactory:n,resumeLexicalEnvironment:i,endLexicalEnvironment:s,hoistVariableDeclaration:o}=e,l=e.getEmitResolver(),p=e.getCompilerOptions(),m=ho(p),S=e.onEmitNode;e.onEmitNode=Ta;let h=e.onSubstituteNode;e.onSubstituteNode=to;let b=!1,A,k,N,M=0,O=0,U,H,K,re,$=[];return qm(e,xe);function pe(_e,Ve){return O!==(O&~_e|Ve)}function z(_e,Ve){let pt=O;return O=(O&~_e|Ve)&3,pt}function se(_e){O=_e}function Se(_e){H=Pr(H,t.createVariableDeclaration(_e))}function xe(_e){if(_e.isDeclarationFile)return _e;U=_e;let Ve=kt(_e);return Ny(Ve,e.readEmitHelpers()),U=void 0,H=void 0,Ve}function Z(_e){return ve(_e,!1)}function Q(_e){return ve(_e,!0)}function ce(_e){if(_e.kind!==134)return _e}function ye(_e,Ve,pt,W){if(pe(pt,W)){let st=z(pt,W),Nt=_e(Ve);return se(st),Nt}return _e(Ve)}function we(_e){return wr(_e,Z,e)}function ve(_e,Ve){if(!(_e.transformFlags&128))return _e;switch(_e.kind){case 223:return oe(_e);case 229:return Ee(_e);case 253:return Me(_e);case 256:return Ge(_e);case 210:return Ie(_e);case 226:return $e(_e,Ve);case 361:return at(_e,Ve);case 299:return $t(_e);case 243:return St(_e);case 260:return Ze(_e);case 246:case 247:case 249:return ye(we,_e,0,2);case 250:return Fr(_e,void 0);case 248:return ye(ar,_e,0,2);case 222:return or(_e);case 176:return ye(Ms,_e,2,1);case 174:return ye(On,_e,2,1);case 177:return ye(un,_e,2,1);case 178:return ye(ri,_e,2,1);case 262:return ye(_r,_e,2,1);case 218:return ye(zt,_e,2,1);case 219:return ye(rt,_e,2,0);case 169:return xs(_e);case 244:return Re(_e);case 217:return Ue(_e,Ve);case 215:return ke(_e);case 211:return K&&Hn(_e)&&_e.expression.kind===108&&K.add(_e.name.escapedText),wr(_e,Z,e);case 212:return K&&_e.expression.kind===108&&(re=!0),wr(_e,Z,e);case 263:case 231:return ye(we,_e,2,1);default:return wr(_e,Z,e)}}function oe(_e){return k&2&&k&1?Un(ft(t.createYieldExpression(void 0,n().createAwaitHelper(nt(_e.expression,Z,bt))),_e),_e):wr(_e,Z,e)}function Ee(_e){if(k&2&&k&1){if(_e.asteriskToken){let Ve=nt(I.checkDefined(_e.expression),Z,bt);return Un(ft(t.createYieldExpression(void 0,n().createAwaitHelper(t.updateYieldExpression(_e,_e.asteriskToken,ft(n().createAsyncDelegatorHelper(ft(n().createAsyncValuesHelper(Ve),Ve)),Ve)))),_e),_e)}return Un(ft(t.createYieldExpression(void 0,nr(_e.expression?nt(_e.expression,Z,bt):t.createVoidZero())),_e),_e)}return wr(_e,Z,e)}function Me(_e){return k&2&&k&1?t.updateReturnStatement(_e,nr(_e.expression?nt(_e.expression,Z,bt):t.createVoidZero())):wr(_e,Z,e)}function Ge(_e){if(k&2){let Ve=VY(_e);return Ve.kind===250&&Ve.awaitModifier?Fr(Ve,_e):t.restoreEnclosingLabel(nt(Ve,Z,ns,t.liftToBlock),_e)}return wr(_e,Z,e)}function Ae(_e){let Ve,pt=[];for(let W of _e)if(W.kind===305){Ve&&(pt.push(t.createObjectLiteralExpression(Ve)),Ve=void 0);let st=W.expression;pt.push(nt(st,Z,bt))}else Ve=Pr(Ve,W.kind===303?t.createPropertyAssignment(W.name,nt(W.initializer,Z,bt)):nt(W,Z,by));return Ve&&pt.push(t.createObjectLiteralExpression(Ve)),pt}function Ie(_e){if(_e.transformFlags&65536){let Ve=Ae(_e.properties);Ve.length&&Ve[0].kind!==210&&Ve.unshift(t.createObjectLiteralExpression());let pt=Ve[0];if(Ve.length>1){for(let W=1;W<Ve.length;W++)pt=n().createAssignHelper([pt,Ve[W]]);return pt}else return n().createAssignHelper(Ve)}return wr(_e,Z,e)}function Re(_e){return wr(_e,Q,e)}function Ue(_e,Ve){return wr(_e,Ve?Q:Z,e)}function kt(_e){let Ve=z(2,IY(_e,p)?0:1);b=!1;let pt=wr(_e,Z,e),W=ys(pt.statements,H&&[t.createVariableStatement(void 0,t.createVariableDeclarationList(H))]),st=t.updateSourceFile(pt,ft(t.createNodeArray(W),_e.statements));return se(Ve),st}function ke(_e){return hZ(e,_e,Z,U,Se,0)}function $e(_e,Ve){return I1(_e)&&YR(_e.left)?Tx(_e,Z,e,1,!Ve):_e.operatorToken.kind===28?t.updateBinaryExpression(_e,nt(_e.left,Q,bt),_e.operatorToken,nt(_e.right,Ve?Q:Z,bt)):wr(_e,Z,e)}function at(_e,Ve){if(Ve)return wr(_e,Q,e);let pt;for(let st=0;st<_e.elements.length;st++){let Nt=_e.elements[st],Ke=nt(Nt,st<_e.elements.length-1?Q:Z,bt);(pt||Ke!==Nt)&&(pt||(pt=_e.elements.slice(0,st)),pt.push(Ke))}let W=pt?ft(t.createNodeArray(pt),_e.elements):_e.elements;return t.updateCommaListExpression(_e,W)}function $t(_e){if(_e.variableDeclaration&&la(_e.variableDeclaration.name)&&_e.variableDeclaration.name.transformFlags&65536){let Ve=t.getGeneratedNameForNode(_e.variableDeclaration.name),pt=t.updateVariableDeclaration(_e.variableDeclaration,_e.variableDeclaration.name,void 0,void 0,Ve),W=bE(pt,Z,e,1),st=nt(_e.block,Z,ra);return Tt(W)&&(st=t.updateBlock(st,[t.createVariableStatement(void 0,W),...st.statements])),t.updateCatchClause(_e,t.updateVariableDeclaration(_e.variableDeclaration,Ve,void 0,void 0,void 0),st)}return wr(_e,Z,e)}function St(_e){if(ui(_e,32)){let Ve=b;b=!0;let pt=wr(_e,Z,e);return b=Ve,pt}return wr(_e,Z,e)}function Ze(_e){if(b){let Ve=b;b=!1;let pt=yt(_e,!0);return b=Ve,pt}return yt(_e,!1)}function yt(_e,Ve){return la(_e.name)&&_e.name.transformFlags&65536?bE(_e,Z,e,1,void 0,Ve):wr(_e,Z,e)}function ar(_e){return t.updateForStatement(_e,nt(_e.initializer,Q,Cd),nt(_e.condition,Z,bt),nt(_e.incrementor,Q,bt),df(_e.statement,Z,e))}function or(_e){return wr(_e,Q,e)}function Fr(_e,Ve){let pt=z(0,2);(_e.initializer.transformFlags&65536||Lw(_e.initializer)&&YR(_e.initializer))&&(_e=rn(_e));let W=_e.awaitModifier?tr(_e,Ve,pt):t.restoreEnclosingLabel(wr(_e,Z,e),Ve);return se(pt),W}function rn(_e){let Ve=Do(_e.initializer);if(Tu(Ve)||Lw(Ve)){let pt,W,st=t.createTempVariable(void 0),Nt=[XK(t,Ve,st)];return ra(_e.statement)?(jt(Nt,_e.statement.statements),pt=_e.statement,W=_e.statement.statements):_e.statement&&(Pr(Nt,_e.statement),pt=_e.statement,W=_e.statement),t.updateForOfStatement(_e,_e.awaitModifier,ft(t.createVariableDeclarationList([ft(t.createVariableDeclaration(st),_e.initializer)],1),_e.initializer),_e.expression,ft(t.createBlock(ft(t.createNodeArray(Nt),W),!0),pt))}return _e}function Tr(_e,Ve,pt){let W=t.createTempVariable(o),st=t.createAssignment(W,Ve),Nt=t.createExpressionStatement(st);qa(Nt,_e.expression);let Ke=t.createAssignment(pt,t.createFalse()),ht=t.createExpressionStatement(Ke);qa(ht,_e.expression);let Wt=[Nt,ht],Cr=XK(t,_e.initializer,W);Wt.push(nt(Cr,Z,ns));let hr,Sr,Y=df(_e.statement,Z,e);return ra(Y)?(jt(Wt,Y.statements),hr=Y,Sr=Y.statements):Wt.push(Y),ft(t.createBlock(ft(t.createNodeArray(Wt),Sr),!0),hr)}function nr(_e){return k&1?t.createYieldExpression(void 0,n().createAwaitHelper(_e)):t.createAwaitExpression(_e)}function tr(_e,Ve,pt){let W=nt(_e.expression,Z,bt),st=ze(W)?t.getGeneratedNameForNode(W):t.createTempVariable(void 0),Nt=ze(W)?t.getGeneratedNameForNode(st):t.createTempVariable(void 0),Ke=t.createTempVariable(void 0),ht=t.createTempVariable(o),Wt=t.createUniqueName("e"),Cr=t.getGeneratedNameForNode(Wt),hr=t.createTempVariable(void 0),Sr=ft(n().createAsyncValuesHelper(W),_e.expression),Y=t.createCallExpression(t.createPropertyAccessExpression(st,"next"),void 0,[]),Be=t.createPropertyAccessExpression(Nt,"done"),Lt=t.createPropertyAccessExpression(Nt,"value"),B=t.createFunctionCallCall(hr,st,[]);o(Wt),o(hr);let le=pt&2?t.inlineExpressions([t.createAssignment(Wt,t.createVoidZero()),Sr]):Sr,X=Sn(ft(t.createForStatement(Sn(ft(t.createVariableDeclarationList([t.createVariableDeclaration(Ke,void 0,void 0,t.createTrue()),ft(t.createVariableDeclaration(st,void 0,void 0,le),_e.expression),t.createVariableDeclaration(Nt)]),_e.expression),4194304),t.inlineExpressions([t.createAssignment(Nt,nr(Y)),t.createAssignment(ht,Be),t.createLogicalNot(ht)]),t.createAssignment(Ke,t.createTrue()),Tr(_e,Lt,Ke)),_e),512);return Un(X,_e),t.createTryStatement(t.createBlock([t.restoreEnclosingLabel(X,Ve)]),t.createCatchClause(t.createVariableDeclaration(Cr),Sn(t.createBlock([t.createExpressionStatement(t.createAssignment(Wt,t.createObjectLiteralExpression([t.createPropertyAssignment("error",Cr)])))]),1)),t.createBlock([t.createTryStatement(t.createBlock([Sn(t.createIfStatement(t.createLogicalAnd(t.createLogicalAnd(t.createLogicalNot(Ke),t.createLogicalNot(ht)),t.createAssignment(hr,t.createPropertyAccessExpression(st,"return"))),t.createExpressionStatement(nr(B))),1)]),void 0,Sn(t.createBlock([Sn(t.createIfStatement(Wt,t.createThrowStatement(t.createPropertyAccessExpression(Wt,"error"))),1)]),1))]))}function ki(_e){return I.assertNode(_e,Ls),xs(_e)}function xs(_e){return N?.has(_e)?t.updateParameterDeclaration(_e,void 0,_e.dotDotDotToken,la(_e.name)?t.getGeneratedNameForNode(_e):_e.name,void 0,void 0,void 0):_e.transformFlags&65536?t.updateParameterDeclaration(_e,void 0,_e.dotDotDotToken,t.getGeneratedNameForNode(_e),void 0,void 0,nt(_e.initializer,Z,bt)):wr(_e,Z,e)}function zi(_e){let Ve;for(let pt of _e.parameters)Ve?Ve.add(pt):pt.transformFlags&65536&&(Ve=new Set);return Ve}function Ms(_e){let Ve=k,pt=N;k=vu(_e),N=zi(_e);let W=t.updateConstructorDeclaration(_e,_e.modifiers,qc(_e.parameters,ki,e),Ni(_e));return k=Ve,N=pt,W}function un(_e){let Ve=k,pt=N;k=vu(_e),N=zi(_e);let W=t.updateGetAccessorDeclaration(_e,_e.modifiers,nt(_e.name,Z,Al),qc(_e.parameters,ki,e),void 0,Ni(_e));return k=Ve,N=pt,W}function ri(_e){let Ve=k,pt=N;k=vu(_e),N=zi(_e);let W=t.updateSetAccessorDeclaration(_e,_e.modifiers,nt(_e.name,Z,Al),qc(_e.parameters,ki,e),Ni(_e));return k=Ve,N=pt,W}function On(_e){let Ve=k,pt=N;k=vu(_e),N=zi(_e);let W=t.updateMethodDeclaration(_e,k&1?Hr(_e.modifiers,ce,vc):_e.modifiers,k&2?void 0:_e.asteriskToken,nt(_e.name,Z,Al),nt(void 0,Z,Xv),void 0,k&2&&k&1?Rr(_e):qc(_e.parameters,ki,e),void 0,k&2&&k&1?vi(_e):Ni(_e));return k=Ve,N=pt,W}function _r(_e){let Ve=k,pt=N;k=vu(_e),N=zi(_e);let W=t.updateFunctionDeclaration(_e,k&1?Hr(_e.modifiers,ce,Ra):_e.modifiers,k&2?void 0:_e.asteriskToken,_e.name,void 0,k&2&&k&1?Rr(_e):qc(_e.parameters,ki,e),void 0,k&2&&k&1?vi(_e):Ni(_e));return k=Ve,N=pt,W}function rt(_e){let Ve=k,pt=N;k=vu(_e),N=zi(_e);let W=t.updateArrowFunction(_e,_e.modifiers,void 0,qc(_e.parameters,ki,e),void 0,_e.equalsGreaterThanToken,Ni(_e));return k=Ve,N=pt,W}function zt(_e){let Ve=k,pt=N;k=vu(_e),N=zi(_e);let W=t.updateFunctionExpression(_e,k&1?Hr(_e.modifiers,ce,Ra):_e.modifiers,k&2?void 0:_e.asteriskToken,_e.name,void 0,k&2&&k&1?Rr(_e):qc(_e.parameters,ki,e),void 0,k&2&&k&1?vi(_e):Ni(_e));return k=Ve,N=pt,W}function Rr(_e){if(EM(_e.parameters))return qc(_e.parameters,Z,e);let Ve=[];for(let W of _e.parameters){if(W.initializer||W.dotDotDotToken)break;let st=t.createParameterDeclaration(void 0,void 0,t.getGeneratedNameForNode(W.name,8));Ve.push(st)}let pt=t.createNodeArray(Ve);return ft(pt,_e.parameters),pt}function vi(_e){let Ve=EM(_e.parameters)?void 0:qc(_e.parameters,Z,e);i();let pt=K,W=re;K=new Set,re=!1;let st=[],Nt=t.updateBlock(_e.body,Hr(_e.body.statements,Z,ns));Nt=t.updateBlock(Nt,t.mergeLexicalEnvironment(Nt.statements,us(s(),_e)));let Ke=t.createReturnStatement(n().createAsyncGeneratorHelper(t.createFunctionExpression(void 0,t.createToken(42),_e.name&&t.getGeneratedNameForNode(_e.name),void 0,Ve??[],void 0,Nt),!!(O&1))),ht=m>=2&&l.getNodeCheckFlags(_e)&384;if(ht){Fs();let Cr=uV(t,l,_e,K);$[yo(Cr)]=!0,C0(st,[Cr])}st.push(Ke);let Wt=t.updateBlock(_e.body,st);return ht&&re&&(l.getNodeCheckFlags(_e)&256?VA(Wt,DR):l.getNodeCheckFlags(_e)&128&&VA(Wt,NR)),K=pt,re=W,Wt}function Ni(_e){i();let Ve=0,pt=[],W=nt(_e.body,Z,w9)??t.createBlock([]);ra(W)&&(Ve=t.copyPrologue(W.statements,pt,!1,Z)),jt(pt,us(void 0,_e));let st=s();if(Ve>0||Tt(pt)||Tt(st)){let Nt=t.converters.convertToFunctionBlock(W,!0);return C0(pt,st),jt(pt,Nt.statements.slice(Ve)),t.updateBlock(Nt,ft(t.createNodeArray(pt),Nt.statements))}return W}function us(_e,Ve){let pt=!1;for(let W of Ve.parameters)if(pt){if(la(W.name)){if(W.name.elements.length>0){let st=bE(W,Z,e,0,t.getGeneratedNameForNode(W));if(Tt(st)){let Nt=t.createVariableDeclarationList(st),Ke=t.createVariableStatement(void 0,Nt);Sn(Ke,2097152),_e=Pr(_e,Ke)}}else if(W.initializer){let st=t.getGeneratedNameForNode(W),Nt=nt(W.initializer,Z,bt),Ke=t.createAssignment(st,Nt),ht=t.createExpressionStatement(Ke);Sn(ht,2097152),_e=Pr(_e,ht)}}else if(W.initializer){let st=t.cloneNode(W.name);ft(st,W.name),Sn(st,96);let Nt=nt(W.initializer,Z,bt);Kg(Nt,3168);let Ke=t.createAssignment(st,Nt);ft(Ke,W),Sn(Ke,3072);let ht=t.createBlock([t.createExpressionStatement(Ke)]);ft(ht,W),Sn(ht,3905);let Wt=t.createTypeCheck(t.cloneNode(W.name),"undefined"),Cr=t.createIfStatement(Wt,ht);M_(Cr),ft(Cr,W),Sn(Cr,2101056),_e=Pr(_e,Cr)}}else if(W.transformFlags&65536){pt=!0;let st=bE(W,Z,e,1,t.getGeneratedNameForNode(W),!1,!0);if(Tt(st)){let Nt=t.createVariableDeclarationList(st),Ke=t.createVariableStatement(void 0,Nt);Sn(Ke,2097152),_e=Pr(_e,Ke)}}return _e}function Fs(){A&1||(A|=1,e.enableSubstitution(213),e.enableSubstitution(211),e.enableSubstitution(212),e.enableEmitNotification(263),e.enableEmitNotification(174),e.enableEmitNotification(177),e.enableEmitNotification(178),e.enableEmitNotification(176),e.enableEmitNotification(243))}function Ta(_e,Ve,pt){if(A&1&&dt(Ve)){let W=l.getNodeCheckFlags(Ve)&384;if(W!==M){let st=M;M=W,S(_e,Ve,pt),M=st;return}}else if(A&&$[yo(Ve)]){let W=M;M=0,S(_e,Ve,pt),M=W;return}S(_e,Ve,pt)}function to(_e,Ve){return Ve=h(_e,Ve),_e===1&&M?Nr(Ve):Ve}function Nr(_e){switch(_e.kind){case 211:return qr(_e);case 212:return We(_e);case 213:return mt(_e)}return _e}function qr(_e){return _e.expression.kind===108?ft(t.createPropertyAccessExpression(t.createUniqueName("_super",48),_e.name),_e):_e}function We(_e){return _e.expression.kind===108?Ot(_e.argumentExpression,_e):_e}function mt(_e){let Ve=_e.expression;if(Pf(Ve)){let pt=Hn(Ve)?qr(Ve):We(Ve);return t.createCallExpression(t.createPropertyAccessExpression(pt,"call"),void 0,[t.createThis(),..._e.arguments])}return _e}function dt(_e){let Ve=_e.kind;return Ve===263||Ve===176||Ve===174||Ve===177||Ve===178}function Ot(_e,Ve){return M&256?ft(t.createPropertyAccessExpression(t.createCallExpression(t.createIdentifier("_superIndex"),void 0,[_e]),"value"),Ve):ft(t.createCallExpression(t.createIdentifier("_superIndex"),void 0,[_e]),Ve)}}var QSt=f({"src/compiler/transformers/es2018.ts"(){"use strict";fa()}});function w0e(e){let t=e.factory;return qm(e,n);function n(o){return o.isDeclarationFile?o:wr(o,i,e)}function i(o){if(!(o.transformFlags&64))return o;switch(o.kind){case 299:return s(o);default:return wr(o,i,e)}}function s(o){return o.variableDeclaration?wr(o,i,e):t.updateCatchClause(o,t.createVariableDeclaration(t.createTempVariable(void 0)),nt(o.block,i,ra))}}var ZSt=f({"src/compiler/transformers/es2019.ts"(){"use strict";fa()}});function O0e(e){let{factory:t,hoistVariableDeclaration:n}=e;return qm(e,i);function i(N){return N.isDeclarationFile?N:wr(N,s,e)}function s(N){if(!(N.transformFlags&32))return N;switch(N.kind){case 213:{let M=m(N,!1);return I.assertNotNode(M,rk),M}case 211:case 212:if(w_(N)){let M=h(N,!1,!1);return I.assertNotNode(M,rk),M}return wr(N,s,e);case 226:return N.operatorToken.kind===61?A(N):wr(N,s,e);case 220:return k(N);default:return wr(N,s,e)}}function o(N){I.assertNotNode(N,k9);let M=[N];for(;!N.questionDotToken&&!uE(N);)N=ta(Mm(N.expression),w_),I.assertNotNode(N,k9),M.unshift(N);return{expression:N.expression,chain:M}}function l(N,M,O){let U=S(N.expression,M,O);return rk(U)?t.createSyntheticReferenceExpression(t.updateParenthesizedExpression(N,U.expression),U.thisArg):t.updateParenthesizedExpression(N,U)}function p(N,M,O){if(w_(N))return h(N,M,O);let U=nt(N.expression,s,bt);I.assertNotNode(U,rk);let H;return M&&(TE(U)?H=U:(H=t.createTempVariable(n),U=t.createAssignment(H,U))),U=N.kind===211?t.updatePropertyAccessExpression(N,U,nt(N.name,s,ze)):t.updateElementAccessExpression(N,U,nt(N.argumentExpression,s,bt)),H?t.createSyntheticReferenceExpression(U,H):U}function m(N,M){if(w_(N))return h(N,M,!1);if(Df(N.expression)&&w_(Do(N.expression))){let O=l(N.expression,!0,!1),U=Hr(N.arguments,s,bt);return rk(O)?ft(t.createFunctionCallCall(O.expression,O.thisArg,U),N):t.updateCallExpression(N,O,void 0,U)}return wr(N,s,e)}function S(N,M,O){switch(N.kind){case 217:return l(N,M,O);case 211:case 212:return p(N,M,O);case 213:return m(N,M);default:return nt(N,s,bt)}}function h(N,M,O){let{expression:U,chain:H}=o(N),K=S(Mm(U),L2(H[0]),!1),re=rk(K)?K.thisArg:void 0,$=rk(K)?K.expression:K,pe=t.restoreOuterExpressions(U,$,8);TE($)||($=t.createTempVariable(n),pe=t.createAssignment($,pe));let z=$,se;for(let xe=0;xe<H.length;xe++){let Z=H[xe];switch(Z.kind){case 211:case 212:xe===H.length-1&&M&&(TE(z)?se=z:(se=t.createTempVariable(n),z=t.createAssignment(se,z))),z=Z.kind===211?t.createPropertyAccessExpression(z,nt(Z.name,s,ze)):t.createElementAccessExpression(z,nt(Z.argumentExpression,s,bt));break;case 213:xe===0&&re?(yc(re)||(re=t.cloneNode(re),Kg(re,3072)),z=t.createFunctionCallCall(z,re.kind===108?t.createThis():re,Hr(Z.arguments,s,bt))):z=t.createCallExpression(z,void 0,Hr(Z.arguments,s,bt));break}Un(z,Z)}let Se=O?t.createConditionalExpression(b(pe,$,!0),void 0,t.createTrue(),void 0,t.createDeleteExpression(z)):t.createConditionalExpression(b(pe,$,!0),void 0,t.createVoidZero(),void 0,z);return ft(Se,N),se?t.createSyntheticReferenceExpression(Se,se):Se}function b(N,M,O){return t.createBinaryExpression(t.createBinaryExpression(N,t.createToken(O?37:38),t.createNull()),t.createToken(O?57:56),t.createBinaryExpression(M,t.createToken(O?37:38),t.createVoidZero()))}function A(N){let M=nt(N.left,s,bt),O=M;return TE(M)||(O=t.createTempVariable(n),M=t.createAssignment(O,M)),ft(t.createConditionalExpression(b(M,O),void 0,O,void 0,nt(N.right,s,bt)),N)}function k(N){return w_(Do(N.expression))?Un(S(N.expression,!1,!0),N):t.updateDeleteExpression(N,nt(N.expression,s,bt))}}var eTt=f({"src/compiler/transformers/es2020.ts"(){"use strict";fa()}});function R0e(e){let{hoistVariableDeclaration:t,factory:n}=e;return qm(e,i);function i(l){return l.isDeclarationFile?l:wr(l,s,e)}function s(l){return l.transformFlags&16?EX(l)?o(l):wr(l,s,e):l}function o(l){let p=l.operatorToken,m=aO(p.kind),S=Do(nt(l.left,s,$f)),h=S,b=Do(nt(l.right,s,bt));if(Yo(S)){let A=TE(S.expression),k=A?S.expression:n.createTempVariable(t),N=A?S.expression:n.createAssignment(k,S.expression);if(Hn(S))h=n.createPropertyAccessExpression(k,S.name),S=n.createPropertyAccessExpression(N,S.name);else{let M=TE(S.argumentExpression),O=M?S.argumentExpression:n.createTempVariable(t);h=n.createElementAccessExpression(k,O),S=n.createElementAccessExpression(N,M?S.argumentExpression:n.createAssignment(O,S.argumentExpression))}}return n.createBinaryExpression(S,m,n.createParenthesizedExpression(n.createAssignment(h,b)))}}var tTt=f({"src/compiler/transformers/es2021.ts"(){"use strict";fa()}});function M0e(e){let{factory:t,getEmitHelperFactory:n,hoistVariableDeclaration:i,startLexicalEnvironment:s,endLexicalEnvironment:o}=e,l,p,m,S;return qm(e,h);function h(ye){if(ye.isDeclarationFile)return ye;let we=nt(ye,b,ls);return Ny(we,e.readEmitHelpers()),p=void 0,l=void 0,m=void 0,we}function b(ye){if(!(ye.transformFlags&4))return ye;switch(ye.kind){case 312:return A(ye);case 241:return k(ye);case 248:return N(ye);case 250:return M(ye);case 255:return U(ye);default:return wr(ye,b,e)}}function A(ye){let we=vZ(ye.statements);if(we){s(),l=new fk,p=[];let ve=CMe(ye.statements),oe=[];jt(oe,SM(ye.statements,b,ns,0,ve));let Ee=ve;for(;Ee<ye.statements.length;){let Ae=ye.statements[Ee];if(j0e(Ae)!==0){Ee>ve&&jt(oe,Hr(ye.statements,b,ns,ve,Ee-ve));break}Ee++}I.assert(Ee<ye.statements.length,"Should have encountered at least one 'using' statement.");let Me=Q(),Ge=H(ye.statements,Ee,ye.statements.length,Me,oe);return l.size&&Pr(oe,t.createExportDeclaration(void 0,!1,t.createNamedExports(In(l.values())))),jt(oe,o()),p.length&&oe.push(t.createVariableStatement(t.createModifiersFromModifierFlags(32),t.createVariableDeclarationList(p,1))),jt(oe,ce(Ge,Me,we===2)),S&&oe.push(t.createExportAssignment(void 0,!0,S)),t.updateSourceFile(ye,oe)}return wr(ye,b,e)}function k(ye){let we=vZ(ye.statements);if(we){let ve=CMe(ye.statements),oe=Q();return t.updateBlock(ye,[...SM(ye.statements,b,ns,0,ve),...ce(H(ye.statements,ve,ye.statements.length,oe,void 0),oe,we===2)])}return wr(ye,b,e)}function N(ye){return ye.initializer&&L0e(ye.initializer)?nt(t.createBlock([t.createVariableStatement(void 0,ye.initializer),t.updateForStatement(ye,void 0,ye.condition,ye.incrementor,ye.statement)]),b,ns):wr(ye,b,e)}function M(ye){if(L0e(ye.initializer)){let we=ye.initializer;I.assertNode(we,L0e),I.assert(we.declarations.length===1,"ForInitializer may only have one declaration");let ve=we.declarations[0];I.assert(!ve.initializer,"ForInitializer may not have an initializer");let oe=F0e(we)===2,Ee=t.getGeneratedNameForNode(ve.name),Me=t.updateVariableDeclaration(ve,ve.name,void 0,void 0,Ee),Ge=t.createVariableDeclarationList([Me],oe?6:4),Ae=t.createVariableStatement(void 0,Ge);return nt(t.updateForOfStatement(ye,ye.awaitModifier,t.createVariableDeclarationList([t.createVariableDeclaration(Ee)],2),ye.expression,ra(ye.statement)?t.updateBlock(ye.statement,[Ae,...ye.statement.statements]):t.createBlock([Ae,ye.statement],!0)),b,ns)}return wr(ye,b,e)}function O(ye,we){return vZ(ye.statements)!==0?WN(ye)?t.updateCaseClause(ye,nt(ye.expression,b,bt),H(ye.statements,0,ye.statements.length,we,void 0)):t.updateDefaultClause(ye,H(ye.statements,0,ye.statements.length,we,void 0)):wr(ye,b,e)}function U(ye){let we=nTt(ye.caseBlock.clauses);if(we){let ve=Q();return ce([t.updateSwitchStatement(ye,nt(ye.expression,b,bt),t.updateCaseBlock(ye.caseBlock,ye.caseBlock.clauses.map(oe=>O(oe,ve))))],ve,we===2)}return wr(ye,b,e)}function H(ye,we,ve,oe,Ee){let Me=[];for(let Ie=we;Ie<ve;Ie++){let Re=ye[Ie],Ue=j0e(Re);if(Ue){I.assertNode(Re,Xc);let ke=[];for(let $e of Re.declarationList.declarations){if(!ze($e.name)){ke.length=0;break}lp($e)&&($e=mp(e,$e));let at=nt($e.initializer,b,bt)??t.createVoidZero();ke.push(t.updateVariableDeclaration($e,$e.name,void 0,void 0,n().createAddDisposableResourceHelper(oe,at,Ue===2)))}if(ke.length){let $e=t.createVariableDeclarationList(ke,2);Un($e,Re.declarationList),ft($e,Re.declarationList),Ge(t.updateVariableStatement(Re,void 0,$e));continue}}let kt=b(Re);os(kt)?kt.forEach(Ge):kt&&Ge(kt)}return Me;function Ge(Ie){I.assertNode(Ie,ns),Pr(Me,Ae(Ie))}function Ae(Ie){if(!Ee)return Ie;switch(Ie.kind){case 272:case 271:case 278:case 262:return K(Ie,Ee);case 277:return re(Ie);case 263:return z(Ie);case 243:return se(Ie)}return Ie}}function K(ye,we){we.push(ye)}function re(ye){return ye.isExportEquals?pe(ye):$(ye)}function $(ye){if(m)return ye;m=t.createUniqueName("_default",56),Z(m,!0,"default",ye);let we=ye.expression,ve=vl(we);lp(ve)&&(ve=mp(e,ve,!1,"default"),we=t.restoreOuterExpressions(we,ve));let oe=t.createAssignment(m,we);return t.createExpressionStatement(oe)}function pe(ye){if(S)return ye;S=t.createUniqueName("_default",56),i(S);let we=t.createAssignment(S,ye.expression);return t.createExpressionStatement(we)}function z(ye){if(!ye.name&&m)return ye;let we=ui(ye,32),ve=ui(ye,2048),oe=t.converters.convertToClassExpression(ye);return ye.name&&(Z(t.getLocalName(ye),we&&!ve,void 0,ye),oe=t.createAssignment(t.getDeclarationName(ye),oe),lp(oe)&&(oe=mp(e,oe,!1)),Un(oe,ye),qa(oe,ye),kl(oe,ye)),ve&&!m&&(m=t.createUniqueName("_default",56),Z(m,!0,"default",ye),oe=t.createAssignment(m,oe),lp(oe)&&(oe=mp(e,oe,!1,"default")),Un(oe,ye)),t.createExpressionStatement(oe)}function se(ye){let we,ve=ui(ye,32);for(let oe of ye.declarationList.declarations)xe(oe,ve,oe),oe.initializer&&(we=Pr(we,Se(oe)));if(we){let oe=t.createExpressionStatement(t.inlineExpressions(we));return Un(oe,ye),kl(oe,ye),qa(oe,ye),oe}}function Se(ye){I.assertIsDefined(ye.initializer);let we;ze(ye.name)?(we=t.cloneNode(ye.name),Sn(we,eo(we)&-114689)):we=t.converters.convertToAssignmentPattern(ye.name);let ve=t.createAssignment(we,ye.initializer);return Un(ve,ye),kl(ve,ye),qa(ve,ye),ve}function xe(ye,we,ve){if(la(ye.name))for(let oe of ye.name.elements)Su(oe)||xe(oe,we,ve);else Z(ye.name,we,void 0,ve)}function Z(ye,we,ve,oe){let Ee=yc(ye)?ye:t.cloneNode(ye);if(we){if(ve===void 0&&!Iy(Ee)){let Ie=t.createVariableDeclaration(Ee);oe&&Un(Ie,oe),p.push(Ie);return}let Me=ve!==void 0?Ee:void 0,Ge=ve!==void 0?ve:Ee,Ae=t.createExportSpecifier(!1,Me,Ge);oe&&Un(Ae,oe),l.set(Ee,Ae)}i(Ee)}function Q(){return t.createUniqueName("env")}function ce(ye,we,ve){let oe=[],Ee=t.createObjectLiteralExpression([t.createPropertyAssignment("stack",t.createArrayLiteralExpression()),t.createPropertyAssignment("error",t.createVoidZero()),t.createPropertyAssignment("hasError",t.createFalse())]),Me=t.createVariableDeclaration(we,void 0,void 0,Ee),Ge=t.createVariableDeclarationList([Me],2),Ae=t.createVariableStatement(void 0,Ge);oe.push(Ae);let Ie=t.createBlock(ye,!0),Re=t.createUniqueName("e"),Ue=t.createCatchClause(Re,t.createBlock([t.createExpressionStatement(t.createAssignment(t.createPropertyAccessExpression(we,"error"),Re)),t.createExpressionStatement(t.createAssignment(t.createPropertyAccessExpression(we,"hasError"),t.createTrue()))],!0)),kt;if(ve){let $e=t.createUniqueName("result");kt=t.createBlock([t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration($e,void 0,void 0,n().createDisposeResourcesHelper(we))],2)),t.createIfStatement($e,t.createExpressionStatement(t.createAwaitExpression($e)))],!0)}else kt=t.createBlock([t.createExpressionStatement(n().createDisposeResourcesHelper(we))],!0);let ke=t.createTryStatement(Ie,Ue,kt);return oe.push(ke),oe}}function CMe(e){for(let t=0;t<e.length;t++)if(!Fm(e[t])&&!T8(e[t]))return t;return 0}function L0e(e){return Tu(e)&&F0e(e)!==0}function F0e(e){return(e.flags&7)===6?2:(e.flags&7)===4?1:0}function rTt(e){return F0e(e.declarationList)}function j0e(e){return Xc(e)?rTt(e):0}function vZ(e){let t=0;for(let n of e){let i=j0e(n);if(i===2)return 2;i>t&&(t=i)}return t}function nTt(e){let t=0;for(let n of e){let i=vZ(n.statements);if(i===2)return 2;i>t&&(t=i)}return t}var iTt=f({"src/compiler/transformers/esnext.ts"(){"use strict";fa()}});function B0e(e){let{factory:t,getEmitHelperFactory:n}=e,i=e.getCompilerOptions(),s,o;return qm(e,b);function l(){if(o.filenameDeclaration)return o.filenameDeclaration.name;let ke=t.createVariableDeclaration(t.createUniqueName("_jsxFileName",48),void 0,void 0,t.createStringLiteral(s.fileName));return o.filenameDeclaration=ke,o.filenameDeclaration.name}function p(ke){return i.jsx===5?"jsxDEV":ke?"jsxs":"jsx"}function m(ke){let $e=p(ke);return h($e)}function S(){return h("Fragment")}function h(ke){var $e,at;let $t=ke==="createElement"?o.importSpecifier:Yj(o.importSpecifier,i),St=(at=($e=o.utilizedImplicitRuntimeImports)==null?void 0:$e.get($t))==null?void 0:at.get(ke);if(St)return St.name;o.utilizedImplicitRuntimeImports||(o.utilizedImplicitRuntimeImports=new Map);let Ze=o.utilizedImplicitRuntimeImports.get($t);Ze||(Ze=new Map,o.utilizedImplicitRuntimeImports.set($t,Ze));let yt=t.createUniqueName(`_${ke}`,112),ar=t.createImportSpecifier(!1,t.createIdentifier(ke),yt);return _ge(yt,ar),Ze.set(ke,ar),yt}function b(ke){if(ke.isDeclarationFile)return ke;s=ke,o={},o.importSpecifier=Hj(i,ke);let $e=wr(ke,A,e);Ny($e,e.readEmitHelpers());let at=$e.statements;if(o.filenameDeclaration&&(at=J2(at.slice(),t.createVariableStatement(void 0,t.createVariableDeclarationList([o.filenameDeclaration],2)))),o.utilizedImplicitRuntimeImports){for(let[$t,St]of In(o.utilizedImplicitRuntimeImports.entries()))if(Pl(ke)){let Ze=t.createImportDeclaration(void 0,t.createImportClause(!1,void 0,t.createNamedImports(In(St.values()))),t.createStringLiteral($t),void 0);Wv(Ze,!1),at=J2(at.slice(),Ze)}else if(Bp(ke)){let Ze=t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(t.createObjectBindingPattern(In(St.values(),yt=>t.createBindingElement(void 0,yt.propertyName,yt.name))),void 0,void 0,t.createCallExpression(t.createIdentifier("require"),void 0,[t.createStringLiteral($t)]))],2));Wv(Ze,!1),at=J2(at.slice(),Ze)}}return at!==$e.statements&&($e=t.updateSourceFile($e,at)),o=void 0,$e}function A(ke){return ke.transformFlags&2?k(ke):ke}function k(ke){switch(ke.kind){case 284:return H(ke,!1);case 285:return K(ke,!1);case 288:return re(ke,!1);case 294:return kt(ke);default:return wr(ke,A,e)}}function N(ke){switch(ke.kind){case 12:return Ee(ke);case 294:return kt(ke);case 284:return H(ke,!0);case 285:return K(ke,!0);case 288:return re(ke,!0);default:return I.failBadSyntaxKind(ke)}}function M(ke){return ke.properties.some($e=>Ul($e)&&(ze($e.name)&&Nn($e.name)==="__proto__"||za($e.name)&&$e.name.text==="__proto__"))}function O(ke){let $e=!1;for(let at of ke.attributes.properties)if(ik(at)&&(!Ha(at.expression)||at.expression.properties.some(F1)))$e=!0;else if($e&&th(at)&&ze(at.name)&&at.name.escapedText==="key")return!0;return!1}function U(ke){return o.importSpecifier===void 0||O(ke)}function H(ke,$e){return(U(ke.openingElement)?Se:z)(ke.openingElement,ke.children,$e,ke)}function K(ke,$e){return(U(ke)?Se:z)(ke,void 0,$e,ke)}function re(ke,$e){return(o.importSpecifier===void 0?Z:xe)(ke.openingFragment,ke.children,$e,ke)}function $(ke){let $e=pe(ke);return $e&&t.createObjectLiteralExpression([$e])}function pe(ke){let $e=bN(ke);if(de($e)===1&&!$e[0].dotDotDotToken){let $t=N($e[0]);return $t&&t.createPropertyAssignment("children",$t)}let at=Wi(ke,N);return de(at)?t.createPropertyAssignment("children",t.createArrayLiteralExpression(at)):void 0}function z(ke,$e,at,$t){let St=Re(ke),Ze=$e&&$e.length?pe($e):void 0,yt=mr(ke.attributes.properties,Fr=>!!Fr.name&&ze(Fr.name)&&Fr.name.escapedText==="key"),ar=yt?Fn(ke.attributes.properties,Fr=>Fr!==yt):ke.attributes.properties,or=de(ar)?ce(ar,Ze):t.createObjectLiteralExpression(Ze?[Ze]:tt);return se(St,or,yt,$e||tt,at,$t)}function se(ke,$e,at,$t,St,Ze){var yt;let ar=bN($t),or=de(ar)>1||!!((yt=ar[0])!=null&&yt.dotDotDotToken),Fr=[ke,$e];if(at&&Fr.push(oe(at.initializer)),i.jsx===5){let Tr=Hc(s);if(Tr&&ls(Tr)){at===void 0&&Fr.push(t.createVoidZero()),Fr.push(or?t.createTrue():t.createFalse());let nr=Lo(Tr,Ze.pos);Fr.push(t.createObjectLiteralExpression([t.createPropertyAssignment("fileName",l()),t.createPropertyAssignment("lineNumber",t.createNumericLiteral(nr.line+1)),t.createPropertyAssignment("columnNumber",t.createNumericLiteral(nr.character+1))])),Fr.push(t.createThis())}}let rn=ft(t.createCallExpression(m(or),void 0,Fr),Ze);return St&&M_(rn),rn}function Se(ke,$e,at,$t){let St=Re(ke),Ze=ke.attributes.properties,yt=de(Ze)?ce(Ze):t.createNull(),ar=o.importSpecifier===void 0?YK(t,e.getEmitResolver().getJsxFactoryEntity(s),i.reactNamespace,ke):h("createElement"),or=Vge(t,ar,St,yt,Wi($e,N),$t);return at&&M_(or),or}function xe(ke,$e,at,$t){let St;if($e&&$e.length){let Ze=$($e);Ze&&(St=Ze)}return se(S(),St||t.createObjectLiteralExpression([]),void 0,$e,at,$t)}function Z(ke,$e,at,$t){let St=Jge(t,e.getEmitResolver().getJsxFactoryEntity(s),e.getEmitResolver().getJsxFragmentFactoryEntity(s),i.reactNamespace,Wi($e,N),ke,$t);return at&&M_(St),St}function Q(ke){return Ha(ke.expression)&&!M(ke.expression)?ul(ke.expression.properties,$e=>I.checkDefined(nt($e,A,by))):t.createSpreadAssignment(I.checkDefined(nt(ke.expression,A,bt)))}function ce(ke,$e){let at=ho(i);return at&&at>=5?t.createObjectLiteralExpression(ye(ke,$e)):we(ke,$e)}function ye(ke,$e){let at=ip(P2(ke,ik,($t,St)=>ip(vr($t,Ze=>St?Q(Ze):ve(Ze)))));return $e&&at.push($e),at}function we(ke,$e){let at=[],$t=[];for(let Ze of ke){if(ik(Ze)){if(Ha(Ze.expression)&&!M(Ze.expression)){for(let yt of Ze.expression.properties){if(F1(yt)){St(),at.push(I.checkDefined(nt(yt.expression,A,bt)));continue}$t.push(I.checkDefined(nt(yt,A)))}continue}St(),at.push(I.checkDefined(nt(Ze.expression,A,bt)));continue}$t.push(ve(Ze))}return $e&&$t.push($e),St(),at.length&&!Ha(at[0])&&at.unshift(t.createObjectLiteralExpression()),nl(at)||n().createAssignHelper(at);function St(){$t.length&&(at.push(t.createObjectLiteralExpression($t)),$t=[])}}function ve(ke){let $e=Ue(ke),at=oe(ke.initializer);return t.createPropertyAssignment($e,at)}function oe(ke){if(ke===void 0)return t.createTrue();if(ke.kind===11){let $e=ke.singleQuote!==void 0?ke.singleQuote:!pj(ke,s),at=t.createStringLiteral(Ie(ke.text)||ke.text,$e);return ft(at,ke)}return ke.kind===294?ke.expression===void 0?t.createTrue():I.checkDefined(nt(ke.expression,A,bt)):L0(ke)?H(ke,!1):px(ke)?K(ke,!1):pE(ke)?re(ke,!1):I.failBadSyntaxKind(ke)}function Ee(ke){let $e=Me(ke.text);return $e===void 0?void 0:t.createStringLiteral($e)}function Me(ke){let $e,at=0,$t=-1;for(let St=0;St<ke.length;St++){let Ze=ke.charCodeAt(St);I_(Ze)?(at!==-1&&$t!==-1&&($e=Ge($e,ke.substr(at,$t-at+1))),at=-1):Vg(Ze)||($t=St,at===-1&&(at=St))}return at!==-1?Ge($e,ke.substr(at)):$e}function Ge(ke,$e){let at=Ae($e);return ke===void 0?at:ke+" "+at}function Ae(ke){return ke.replace(/&((#((\d+)|x([\da-fA-F]+)))|(\w+));/g,($e,at,$t,St,Ze,yt,ar)=>{if(Ze)return $P(parseInt(Ze,10));if(yt)return $P(parseInt(yt,16));{let or=AMe.get(ar);return or?$P(or):$e}})}function Ie(ke){let $e=Ae(ke);return $e===ke?void 0:$e}function Re(ke){if(ke.kind===284)return Re(ke.openingElement);{let $e=ke.tagName;return ze($e)&&xN($e.escapedText)?t.createStringLiteral(Nn($e)):pg($e)?t.createStringLiteral(Nn($e.namespace)+":"+Nn($e.name)):JR(t,$e)}}function Ue(ke){let $e=ke.name;if(ze($e)){let at=Nn($e);return/^[A-Za-z_]\w*$/.test(at)?$e:t.createStringLiteral(at)}return t.createStringLiteral(Nn($e.namespace)+":"+Nn($e.name))}function kt(ke){let $e=nt(ke.expression,A,bt);return ke.dotDotDotToken?t.createSpreadElement($e):$e}}var AMe,sTt=f({"src/compiler/transformers/jsx.ts"(){"use strict";fa(),AMe=new Map(Object.entries({quot:34,amp:38,apos:39,lt:60,gt:62,nbsp:160,iexcl:161,cent:162,pound:163,curren:164,yen:165,brvbar:166,sect:167,uml:168,copy:169,ordf:170,laquo:171,not:172,shy:173,reg:174,macr:175,deg:176,plusmn:177,sup2:178,sup3:179,acute:180,micro:181,para:182,middot:183,cedil:184,sup1:185,ordm:186,raquo:187,frac14:188,frac12:189,frac34:190,iquest:191,Agrave:192,Aacute:193,Acirc:194,Atilde:195,Auml:196,Aring:197,AElig:198,Ccedil:199,Egrave:200,Eacute:201,Ecirc:202,Euml:203,Igrave:204,Iacute:205,Icirc:206,Iuml:207,ETH:208,Ntilde:209,Ograve:210,Oacute:211,Ocirc:212,Otilde:213,Ouml:214,times:215,Oslash:216,Ugrave:217,Uacute:218,Ucirc:219,Uuml:220,Yacute:221,THORN:222,szlig:223,agrave:224,aacute:225,acirc:226,atilde:227,auml:228,aring:229,aelig:230,ccedil:231,egrave:232,eacute:233,ecirc:234,euml:235,igrave:236,iacute:237,icirc:238,iuml:239,eth:240,ntilde:241,ograve:242,oacute:243,ocirc:244,otilde:245,ouml:246,divide:247,oslash:248,ugrave:249,uacute:250,ucirc:251,uuml:252,yacute:253,thorn:254,yuml:255,OElig:338,oelig:339,Scaron:352,scaron:353,Yuml:376,fnof:402,circ:710,tilde:732,Alpha:913,Beta:914,Gamma:915,Delta:916,Epsilon:917,Zeta:918,Eta:919,Theta:920,Iota:921,Kappa:922,Lambda:923,Mu:924,Nu:925,Xi:926,Omicron:927,Pi:928,Rho:929,Sigma:931,Tau:932,Upsilon:933,Phi:934,Chi:935,Psi:936,Omega:937,alpha:945,beta:946,gamma:947,delta:948,epsilon:949,zeta:950,eta:951,theta:952,iota:953,kappa:954,lambda:955,mu:956,nu:957,xi:958,omicron:959,pi:960,rho:961,sigmaf:962,sigma:963,tau:964,upsilon:965,phi:966,chi:967,psi:968,omega:969,thetasym:977,upsih:978,piv:982,ensp:8194,emsp:8195,thinsp:8201,zwnj:8204,zwj:8205,lrm:8206,rlm:8207,ndash:8211,mdash:8212,lsquo:8216,rsquo:8217,sbquo:8218,ldquo:8220,rdquo:8221,bdquo:8222,dagger:8224,Dagger:8225,bull:8226,hellip:8230,permil:8240,prime:8242,Prime:8243,lsaquo:8249,rsaquo:8250,oline:8254,frasl:8260,euro:8364,image:8465,weierp:8472,real:8476,trade:8482,alefsym:8501,larr:8592,uarr:8593,rarr:8594,darr:8595,harr:8596,crarr:8629,lArr:8656,uArr:8657,rArr:8658,dArr:8659,hArr:8660,forall:8704,part:8706,exist:8707,empty:8709,nabla:8711,isin:8712,notin:8713,ni:8715,prod:8719,sum:8721,minus:8722,lowast:8727,radic:8730,prop:8733,infin:8734,ang:8736,and:8743,or:8744,cap:8745,cup:8746,int:8747,there4:8756,sim:8764,cong:8773,asymp:8776,ne:8800,equiv:8801,le:8804,ge:8805,sub:8834,sup:8835,nsub:8836,sube:8838,supe:8839,oplus:8853,otimes:8855,perp:8869,sdot:8901,lceil:8968,rceil:8969,lfloor:8970,rfloor:8971,lang:9001,rang:9002,loz:9674,spades:9824,clubs:9827,hearts:9829,diams:9830}))}});function U0e(e){let{factory:t,hoistVariableDeclaration:n}=e;return qm(e,i);function i(m){return m.isDeclarationFile?m:wr(m,s,e)}function s(m){if(!(m.transformFlags&512))return m;switch(m.kind){case 226:return o(m);default:return wr(m,s,e)}}function o(m){switch(m.operatorToken.kind){case 68:return l(m);case 43:return p(m);default:return wr(m,s,e)}}function l(m){let S,h,b=nt(m.left,s,bt),A=nt(m.right,s,bt);if(fc(b)){let k=t.createTempVariable(n),N=t.createTempVariable(n);S=ft(t.createElementAccessExpression(ft(t.createAssignment(k,b.expression),b.expression),ft(t.createAssignment(N,b.argumentExpression),b.argumentExpression)),b),h=ft(t.createElementAccessExpression(k,N),b)}else if(Hn(b)){let k=t.createTempVariable(n);S=ft(t.createPropertyAccessExpression(ft(t.createAssignment(k,b.expression),b.expression),b.name),b),h=ft(t.createPropertyAccessExpression(k,b.name),b)}else S=b,h=b;return ft(t.createAssignment(S,ft(t.createGlobalMethodCall("Math","pow",[h,A]),m)),m)}function p(m){let S=nt(m.left,s,bt),h=nt(m.right,s,bt);return ft(t.createGlobalMethodCall("Math","pow",[S,h]),m)}}var aTt=f({"src/compiler/transformers/es2016.ts"(){"use strict";fa()}});function kMe(e,t){return{kind:e,expression:t}}function V0e(e){let{factory:t,getEmitHelperFactory:n,startLexicalEnvironment:i,resumeLexicalEnvironment:s,endLexicalEnvironment:o,hoistVariableDeclaration:l}=e,p=e.getCompilerOptions(),m=e.getEmitResolver(),S=e.onSubstituteNode,h=e.onEmitNode;e.onEmitNode=dd,e.onSubstituteNode=Fd;let b,A,k,N;function M(ie){N=Pr(N,t.createVariableDeclaration(ie))}let O,U;return qm(e,H);function H(ie){if(ie.isDeclarationFile)return ie;b=ie,A=ie.text;let ct=ce(ie);return Ny(ct,e.readEmitHelpers()),b=void 0,A=void 0,N=void 0,k=0,ct}function K(ie,ct){let Jt=k;return k=(k&~ie|ct)&32767,Jt}function re(ie,ct,Jt){k=(k&~ct|Jt)&-32768|ie}function $(ie){return(k&8192)!==0&&ie.kind===253&&!ie.expression}function pe(ie){return ie.transformFlags&4194304&&(Um(ie)||ux(ie)||Pge(ie)||U6(ie)||V6(ie)||WN(ie)||q6(ie)||fx(ie)||mE(ie)||_E(ie)||Lv(ie,!1)||ra(ie))}function z(ie){return(ie.transformFlags&1024)!==0||O!==void 0||k&8192&&pe(ie)||Lv(ie,!1)&&ks(ie)||(Lm(ie)&1)!==0}function se(ie){return z(ie)?Q(ie,!1):ie}function Se(ie){return z(ie)?Q(ie,!0):ie}function xe(ie){if(z(ie)){let ct=Hc(ie);if(ea(ct)&&jl(ct)){let Jt=K(32670,16449),Gt=Q(ie,!1);return re(Jt,229376,0),Gt}return Q(ie,!1)}return ie}function Z(ie){return ie.kind===108?bl(ie,!0):se(ie)}function Q(ie,ct){switch(ie.kind){case 126:return;case 263:return Re(ie);case 231:return Ue(ie);case 169:return to(ie);case 262:return hr(ie);case 219:return Wt(ie);case 218:return Cr(ie);case 260:return Ir(ie);case 80:return Ae(ie);case 261:return Le(ie);case 255:return ye(ie);case 269:return we(ie);case 241:return Be(ie,!1);case 252:case 251:return Ie(ie);case 256:return Pi(ie);case 246:case 247:return Qn(ie,void 0);case 248:return Ns(ie,void 0);case 249:return ji(ie,void 0);case 250:return ni(ie,void 0);case 244:return Lt(ie);case 210:return zs(ie);case 299:return Bi(ie);case 304:return bu(ie);case 167:return sc(ie);case 209:return jo(ie);case 213:return Eu(ie);case 214:return gm(ie);case 217:return B(ie,ct);case 226:return le(ie,ct);case 361:return X(ie,ct);case 15:case 16:case 17:case 18:return ua(ie);case 11:return Tl(ie);case 9:return ql(ie);case 215:return bc(ie);case 228:return Ic(ie);case 229:return Jl(ie);case 230:return sa(ie);case 108:return bl(ie,!1);case 110:return Me(ie);case 236:return xu(ie);case 174:return ia(ie);case 177:case 178:return Fc(ie);case 243:return qe(ie);case 253:return Ee(ie);case 222:return Ge(ie);default:return wr(ie,se,e)}}function ce(ie){let ct=K(8064,64),Jt=[],Gt=[];i();let V=t.copyPrologue(ie.statements,Jt,!1,se);return jt(Gt,Hr(ie.statements,se,ns,V)),N&&Gt.push(t.createVariableStatement(void 0,t.createVariableDeclarationList(N))),t.mergeLexicalEnvironment(Jt,o()),_e(Jt,ie),re(ct,0,0),t.updateSourceFile(ie,ft(t.createNodeArray(ys(Jt,Gt)),ie.statements))}function ye(ie){if(O!==void 0){let ct=O.allowedNonLabeledJumps;O.allowedNonLabeledJumps|=2;let Jt=wr(ie,se,e);return O.allowedNonLabeledJumps=ct,Jt}return wr(ie,se,e)}function we(ie){let ct=K(7104,0),Jt=wr(ie,se,e);return re(ct,0,0),Jt}function ve(ie){return Un(t.createReturnStatement(oe()),ie)}function oe(){return t.createUniqueName("_this",48)}function Ee(ie){return O?(O.nonLocalJumps|=8,$(ie)&&(ie=ve(ie)),t.createReturnStatement(t.createObjectLiteralExpression([t.createPropertyAssignment(t.createIdentifier("value"),ie.expression?I.checkDefined(nt(ie.expression,se,bt)):t.createVoidZero())]))):$(ie)?ve(ie):wr(ie,se,e)}function Me(ie){return k|=65536,k&2&&!(k&16384)&&(k|=131072),O?k&2?(O.containsLexicalThis=!0,ie):O.thisName||(O.thisName=t.createUniqueName("this")):ie}function Ge(ie){return wr(ie,Se,e)}function Ae(ie){return O&&m.isArgumentsLocalBinding(ie)?O.argumentsName||(O.argumentsName=t.createUniqueName("arguments")):ie.flags&256?Un(ft(t.createIdentifier(Zi(ie.escapedText)),ie),ie):ie}function Ie(ie){if(O){let ct=ie.kind===252?2:4;if(!(ie.label&&O.labels&&O.labels.get(Nn(ie.label))||!ie.label&&O.allowedNonLabeledJumps&ct)){let Gt,V=ie.label;V?ie.kind===252?(Gt=`break-${V.escapedText}`,ne(O,!0,Nn(V),Gt)):(Gt=`continue-${V.escapedText}`,ne(O,!1,Nn(V),Gt)):ie.kind===252?(O.nonLocalJumps|=2,Gt="break"):(O.nonLocalJumps|=4,Gt="continue");let Pe=t.createStringLiteral(Gt);if(O.loopOutParameters.length){let ot=O.loopOutParameters,Yt;for(let _n=0;_n<ot.length;_n++){let gi=yp(ot[_n],1);_n===0?Yt=gi:Yt=t.createBinaryExpression(Yt,28,gi)}Pe=t.createBinaryExpression(Yt,28,Pe)}return t.createReturnStatement(Pe)}}return wr(ie,se,e)}function Re(ie){let ct=t.createVariableDeclaration(t.getLocalName(ie,!0),void 0,void 0,kt(ie));Un(ct,ie);let Jt=[],Gt=t.createVariableStatement(void 0,t.createVariableDeclarationList([ct]));if(Un(Gt,ie),ft(Gt,ie),M_(Gt),Jt.push(Gt),ui(ie,32)){let V=ui(ie,2048)?t.createExportDefault(t.getLocalName(ie)):t.createExternalModuleExport(t.getLocalName(ie));Un(V,Gt),Jt.push(V)}return Op(Jt)}function Ue(ie){return kt(ie)}function kt(ie){ie.name&&wf();let ct=Xb(ie),Jt=t.createFunctionExpression(void 0,void 0,void 0,void 0,ct?[t.createParameterDeclaration(void 0,void 0,cl())]:[],void 0,ke(ie,ct));Sn(Jt,eo(ie)&131072|1048576);let Gt=t.createPartiallyEmittedExpression(Jt);RN(Gt,ie.end),Sn(Gt,3072);let V=t.createPartiallyEmittedExpression(Gt);RN(V,Wa(A,ie.pos)),Sn(V,3072);let Pe=t.createParenthesizedExpression(t.createCallExpression(V,void 0,ct?[I.checkDefined(nt(ct.expression,se,bt))]:[]));return w6(Pe,3,"* @class "),Pe}function ke(ie,ct){let Jt=[],Gt=t.getInternalName(ie),V=aX(Gt)?t.getGeneratedNameForNode(Gt):Gt;i(),$e(Jt,ie,ct),at(Jt,ie,V,ct),W(Jt,ie);let Pe=NX(Wa(A,ie.members.end),20),ot=t.createPartiallyEmittedExpression(V);RN(ot,Pe.end),Sn(ot,3072);let Yt=t.createReturnStatement(ot);S6(Yt,Pe.pos),Sn(Yt,3840),Jt.push(Yt),C0(Jt,o());let _n=t.createBlock(ft(t.createNodeArray(Jt),ie.members),!0);return Sn(_n,3072),_n}function $e(ie,ct,Jt){Jt&&ie.push(ft(t.createExpressionStatement(n().createExtendsHelper(t.getInternalName(ct))),Jt))}function at(ie,ct,Jt,Gt){let V=O;O=void 0;let Pe=K(32662,73),ot=I0(ct),Yt=Of(ot,Gt!==void 0),_n=t.createFunctionDeclaration(void 0,void 0,Jt,void 0,$t(ot,Yt),void 0,ar(ot,ct,Gt,Yt));ft(_n,ot||ct),Gt&&Sn(_n,16),ie.push(_n),re(Pe,229376,0),O=V}function $t(ie,ct){return qc(ie&&!ct?ie.parameters:void 0,se,e)||[]}function St(ie,ct){let Jt=[];s(),t.mergeLexicalEnvironment(Jt,o()),ct&&Jt.push(t.createReturnStatement(Ta()));let Gt=t.createNodeArray(Jt);ft(Gt,ie.members);let V=t.createBlock(Gt,!0);return ft(V,ie),Sn(V,3072),V}function Ze(ie){return Xc(ie)&&yr(ie.declarationList.declarations,ct=>ze(ct.name)&&!ct.initializer)}function yt(ie){if($2(ie))return!0;if(!(ie.transformFlags&134217728))return!1;switch(ie.kind){case 219:case 218:case 262:case 176:case 175:return!1;case 177:case 178:case 174:case 172:{let ct=ie;return uo(ct.name)?!!Qs(ct.name,yt):!1}}return!!Qs(ie,yt)}function ar(ie,ct,Jt,Gt){let V=!!Jt&&vl(Jt.expression).kind!==106;if(!ie)return St(ct,V);let Pe=[],ot=[];s();let Yt=t.copyStandardPrologue(ie.body.statements,Pe,0);(Gt||yt(ie.body))&&(k|=8192),jt(ot,Hr(ie.body.statements,se,ns,Yt));let _n=V||k&8192;qr(Pe,ie),Ot(Pe,ie,Gt),pt(Pe,ie),_n?Ve(Pe,ie,Fs()):_e(Pe,ie),t.mergeLexicalEnvironment(Pe,o()),_n&&!us(ie.body)&&ot.push(t.createReturnStatement(oe()));let gi=t.createBlock(ft(t.createNodeArray([...Pe,...ot]),ie.body.statements),!0);return ft(gi,ie.body),Ni(gi,ie.body,Gt)}function or(ie){return yc(ie)&&Nn(ie)==="_this"}function Fr(ie){return yc(ie)&&Nn(ie)==="_super"}function rn(ie){return Xc(ie)&&ie.declarationList.declarations.length===1&&Tr(ie.declarationList.declarations[0])}function Tr(ie){return Gi(ie)&&or(ie.name)&&!!ie.initializer}function nr(ie){return lu(ie,!0)&&or(ie.left)}function tr(ie){return da(ie)&&Hn(ie.expression)&&Fr(ie.expression.expression)&&ze(ie.expression.name)&&(Nn(ie.expression.name)==="call"||Nn(ie.expression.name)==="apply")&&ie.arguments.length>=1&&ie.arguments[0].kind===110}function ki(ie){return bn(ie)&&ie.operatorToken.kind===57&&ie.right.kind===110&&tr(ie.left)}function xs(ie){return bn(ie)&&ie.operatorToken.kind===56&&bn(ie.left)&&ie.left.operatorToken.kind===38&&Fr(ie.left.left)&&ie.left.right.kind===106&&tr(ie.right)&&Nn(ie.right.expression.name)==="apply"}function zi(ie){return bn(ie)&&ie.operatorToken.kind===57&&ie.right.kind===110&&xs(ie.left)}function Ms(ie){return nr(ie)&&ki(ie.right)}function un(ie){return nr(ie)&&zi(ie.right)}function ri(ie){return tr(ie)||ki(ie)||Ms(ie)||xs(ie)||zi(ie)||un(ie)}function On(ie){for(let ct=0;ct<ie.statements.length-1;ct++){let Jt=ie.statements[ct];if(!rn(Jt))continue;let Gt=Jt.declarationList.declarations[0];if(Gt.initializer.kind!==110)continue;let V=ct,Pe=ct+1;for(;Pe<ie.statements.length;){let Ya=ie.statements[Pe];if(Ou(Ya)&&ri(vl(Ya.expression)))break;if(Ze(Ya)){Pe++;continue}return ie}let ot=ie.statements[Pe],Yt=ot.expression;nr(Yt)&&(Yt=Yt.right);let _n=t.updateVariableDeclaration(Gt,Gt.name,void 0,void 0,Yt),gi=t.updateVariableDeclarationList(Jt.declarationList,[_n]),ci=t.createVariableStatement(Jt.modifiers,gi);Un(ci,ot),ft(ci,ot);let ds=t.createNodeArray([...ie.statements.slice(0,V),...ie.statements.slice(V+1,Pe),ci,...ie.statements.slice(Pe+1)]);return ft(ds,ie.statements),t.updateBlock(ie,ds)}return ie}function _r(ie,ct){for(let Gt of ct.statements)if(Gt.transformFlags&134217728&&!iV(Gt))return ie;let Jt=!(ct.transformFlags&16384)&&!(k&65536)&&!(k&131072);for(let Gt=ie.statements.length-1;Gt>0;Gt--){let V=ie.statements[Gt];if(Um(V)&&V.expression&&or(V.expression)){let Pe=ie.statements[Gt-1],ot;if(Ou(Pe)&&Ms(vl(Pe.expression)))ot=Pe.expression;else if(Jt&&rn(Pe)){let gi=Pe.declarationList.declarations[0];ri(vl(gi.initializer))&&(ot=t.createAssignment(oe(),gi.initializer))}if(!ot)break;let Yt=t.createReturnStatement(ot);Un(Yt,Pe),ft(Yt,Pe);let _n=t.createNodeArray([...ie.statements.slice(0,Gt-1),Yt,...ie.statements.slice(Gt+1)]);return ft(_n,ie.statements),t.updateBlock(ie,_n)}}return ie}function rt(ie){if(rn(ie)){if(ie.declarationList.declarations[0].initializer.kind===110)return}else if(nr(ie))return t.createPartiallyEmittedExpression(ie.right,ie);switch(ie.kind){case 219:case 218:case 262:case 176:case 175:return ie;case 177:case 178:case 174:case 172:{let ct=ie;return uo(ct.name)?t.replacePropertyName(ct,wr(ct.name,rt,void 0)):ie}}return wr(ie,rt,void 0)}function zt(ie,ct){if(ct.transformFlags&16384||k&65536||k&131072)return ie;for(let Jt of ct.statements)if(Jt.transformFlags&134217728&&!iV(Jt))return ie;return t.updateBlock(ie,Hr(ie.statements,rt,ns))}function Rr(ie){if(tr(ie)&&ie.arguments.length===2&&ze(ie.arguments[1])&&Nn(ie.arguments[1])==="arguments")return t.createLogicalAnd(t.createStrictInequality(cl(),t.createNull()),ie);switch(ie.kind){case 219:case 218:case 262:case 176:case 175:return ie;case 177:case 178:case 174:case 172:{let ct=ie;return uo(ct.name)?t.replacePropertyName(ct,wr(ct.name,Rr,void 0)):ie}}return wr(ie,Rr,void 0)}function vi(ie){return t.updateBlock(ie,Hr(ie.statements,Rr,ns))}function Ni(ie,ct,Jt){let Gt=ie;return ie=On(ie),ie=_r(ie,ct),ie!==Gt&&(ie=zt(ie,ct)),Jt&&(ie=vi(ie)),ie}function us(ie){if(ie.kind===253)return!0;if(ie.kind===245){let ct=ie;if(ct.elseStatement)return us(ct.thenStatement)&&us(ct.elseStatement)}else if(ie.kind===241){let ct=Is(ie.statements);if(ct&&us(ct))return!0}return!1}function Fs(){return Sn(t.createThis(),8)}function Ta(){return t.createLogicalOr(t.createLogicalAnd(t.createStrictInequality(cl(),t.createNull()),t.createFunctionApplyCall(cl(),Fs(),t.createIdentifier("arguments"))),Fs())}function to(ie){if(!ie.dotDotDotToken)return la(ie.name)?Un(ft(t.createParameterDeclaration(void 0,void 0,t.getGeneratedNameForNode(ie),void 0,void 0,void 0),ie),ie):ie.initializer?Un(ft(t.createParameterDeclaration(void 0,void 0,ie.name,void 0,void 0,void 0),ie),ie):ie}function Nr(ie){return ie.initializer!==void 0||la(ie.name)}function qr(ie,ct){if(!Tt(ct.parameters,Nr))return!1;let Jt=!1;for(let Gt of ct.parameters){let{name:V,initializer:Pe,dotDotDotToken:ot}=Gt;ot||(la(V)?Jt=We(ie,Gt,V,Pe)||Jt:Pe&&(mt(ie,Gt,V,Pe),Jt=!0))}return Jt}function We(ie,ct,Jt,Gt){return Jt.elements.length>0?(J2(ie,Sn(t.createVariableStatement(void 0,t.createVariableDeclarationList(bE(ct,se,e,0,t.getGeneratedNameForNode(ct)))),2097152)),!0):Gt?(J2(ie,Sn(t.createExpressionStatement(t.createAssignment(t.getGeneratedNameForNode(ct),I.checkDefined(nt(Gt,se,bt)))),2097152)),!0):!1}function mt(ie,ct,Jt,Gt){Gt=I.checkDefined(nt(Gt,se,bt));let V=t.createIfStatement(t.createTypeCheck(t.cloneNode(Jt),"undefined"),Sn(ft(t.createBlock([t.createExpressionStatement(Sn(ft(t.createAssignment(Sn(io(ft(t.cloneNode(Jt),Jt),Jt.parent),96),Sn(Gt,96|eo(Gt)|3072)),ct),3072))]),ct),3905));M_(V),ft(V,ct),Sn(V,2101056),J2(ie,V)}function dt(ie,ct){return!!(ie&&ie.dotDotDotToken&&!ct)}function Ot(ie,ct,Jt){let Gt=[],V=Is(ct.parameters);if(!dt(V,Jt))return!1;let Pe=V.name.kind===80?io(ft(t.cloneNode(V.name),V.name),V.name.parent):t.createTempVariable(void 0);Sn(Pe,96);let ot=V.name.kind===80?t.cloneNode(V.name):Pe,Yt=ct.parameters.length-1,_n=t.createLoopVariable();Gt.push(Sn(ft(t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(Pe,void 0,void 0,t.createArrayLiteralExpression([]))])),V),2097152));let gi=t.createForStatement(ft(t.createVariableDeclarationList([t.createVariableDeclaration(_n,void 0,void 0,t.createNumericLiteral(Yt))]),V),ft(t.createLessThan(_n,t.createPropertyAccessExpression(t.createIdentifier("arguments"),"length")),V),ft(t.createPostfixIncrement(_n),V),t.createBlock([M_(ft(t.createExpressionStatement(t.createAssignment(t.createElementAccessExpression(ot,Yt===0?_n:t.createSubtract(_n,t.createNumericLiteral(Yt))),t.createElementAccessExpression(t.createIdentifier("arguments"),_n))),V))]));return Sn(gi,2097152),M_(gi),Gt.push(gi),V.name.kind!==80&&Gt.push(Sn(ft(t.createVariableStatement(void 0,t.createVariableDeclarationList(bE(V,se,e,0,ot))),V),2097152)),EY(ie,Gt),!0}function _e(ie,ct){return k&131072&&ct.kind!==219?(Ve(ie,ct,t.createThis()),!0):!1}function Ve(ie,ct,Jt){hf();let Gt=t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(oe(),void 0,void 0,Jt)]));Sn(Gt,2100224),qa(Gt,ct),J2(ie,Gt)}function pt(ie,ct){if(k&32768){let Jt;switch(ct.kind){case 219:return ie;case 174:case 177:case 178:Jt=t.createVoidZero();break;case 176:Jt=t.createPropertyAccessExpression(Sn(t.createThis(),8),"constructor");break;case 262:case 218:Jt=t.createConditionalExpression(t.createLogicalAnd(Sn(t.createThis(),8),t.createBinaryExpression(Sn(t.createThis(),8),104,t.getLocalName(ct))),void 0,t.createPropertyAccessExpression(Sn(t.createThis(),8),"constructor"),void 0,t.createVoidZero());break;default:return I.failBadSyntaxKind(ct)}let Gt=t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(t.createUniqueName("_newTarget",48),void 0,void 0,Jt)]));Sn(Gt,2100224),J2(ie,Gt)}return ie}function W(ie,ct){for(let Jt of ct.members)switch(Jt.kind){case 240:ie.push(st(Jt));break;case 174:ie.push(Nt(U0(ct,Jt),Jt,ct));break;case 177:case 178:let Gt=tx(ct.members,Jt);Jt===Gt.firstAccessor&&ie.push(Ke(U0(ct,Jt),Gt,ct));break;case 176:case 175:break;default:I.failBadSyntaxKind(Jt,b&&b.fileName);break}}function st(ie){return ft(t.createEmptyStatement(),ie)}function Nt(ie,ct,Jt){let Gt=Qg(ct),V=R1(ct),Pe=Sr(ct,ct,void 0,Jt),ot=nt(ct.name,se,Al);I.assert(ot);let Yt;if(!is(ot)&&D6(e.getCompilerOptions())){let gi=uo(ot)?ot.expression:ze(ot)?t.createStringLiteral(Zi(ot.escapedText)):ot;Yt=t.createObjectDefinePropertyCall(ie,gi,t.createPropertyDescriptor({value:Pe,enumerable:!1,writable:!0,configurable:!0}))}else{let gi=hx(t,ie,ot,ct.name);Yt=t.createAssignment(gi,Pe)}Sn(Pe,3072),qa(Pe,V);let _n=ft(t.createExpressionStatement(Yt),ct);return Un(_n,ct),kl(_n,Gt),Sn(_n,96),_n}function Ke(ie,ct,Jt){let Gt=t.createExpressionStatement(ht(ie,ct,Jt,!1));return Sn(Gt,3072),qa(Gt,R1(ct.firstAccessor)),Gt}function ht(ie,{firstAccessor:ct,getAccessor:Jt,setAccessor:Gt},V,Pe){let ot=io(ft(t.cloneNode(ie),ie),ie.parent);Sn(ot,3136),qa(ot,ct.name);let Yt=nt(ct.name,se,Al);if(I.assert(Yt),is(Yt))return I.failBadSyntaxKind(Yt,"Encountered unhandled private identifier while transforming ES2015.");let _n=KK(t,Yt);Sn(_n,3104),qa(_n,ct.name);let gi=[];if(Jt){let ds=Sr(Jt,void 0,void 0,V);qa(ds,R1(Jt)),Sn(ds,1024);let Ya=t.createPropertyAssignment("get",ds);kl(Ya,Qg(Jt)),gi.push(Ya)}if(Gt){let ds=Sr(Gt,void 0,void 0,V);qa(ds,R1(Gt)),Sn(ds,1024);let Ya=t.createPropertyAssignment("set",ds);kl(Ya,Qg(Gt)),gi.push(Ya)}gi.push(t.createPropertyAssignment("enumerable",Jt||Gt?t.createFalse():t.createTrue()),t.createPropertyAssignment("configurable",t.createTrue()));let ci=t.createCallExpression(t.createPropertyAccessExpression(t.createIdentifier("Object"),"defineProperty"),void 0,[ot,_n,t.createObjectLiteralExpression(gi,!0)]);return Pe&&M_(ci),ci}function Wt(ie){ie.transformFlags&16384&&!(k&16384)&&(k|=131072);let ct=O;O=void 0;let Jt=K(15232,66),Gt=t.createFunctionExpression(void 0,void 0,void 0,void 0,qc(ie.parameters,se,e),void 0,Y(ie));return ft(Gt,ie),Un(Gt,ie),Sn(Gt,16),re(Jt,0,0),O=ct,Gt}function Cr(ie){let ct=eo(ie)&524288?K(32662,69):K(32670,65),Jt=O;O=void 0;let Gt=qc(ie.parameters,se,e),V=Y(ie),Pe=k&32768?t.getLocalName(ie):ie.name;return re(ct,229376,0),O=Jt,t.updateFunctionExpression(ie,void 0,ie.asteriskToken,Pe,void 0,Gt,void 0,V)}function hr(ie){let ct=O;O=void 0;let Jt=K(32670,65),Gt=qc(ie.parameters,se,e),V=Y(ie),Pe=k&32768?t.getLocalName(ie):ie.name;return re(Jt,229376,0),O=ct,t.updateFunctionDeclaration(ie,Hr(ie.modifiers,se,Ra),ie.asteriskToken,Pe,void 0,Gt,void 0,V)}function Sr(ie,ct,Jt,Gt){let V=O;O=void 0;let Pe=Gt&&Ti(Gt)&&!pa(ie)?K(32670,73):K(32670,65),ot=qc(ie.parameters,se,e),Yt=Y(ie);return k&32768&&!Jt&&(ie.kind===262||ie.kind===218)&&(Jt=t.getGeneratedNameForNode(ie)),re(Pe,229376,0),O=V,Un(ft(t.createFunctionExpression(void 0,ie.asteriskToken,Jt,void 0,ot,void 0,Yt),ct),ie)}function Y(ie){let ct=!1,Jt=!1,Gt,V,Pe=[],ot=[],Yt=ie.body,_n;if(s(),ra(Yt)&&(_n=t.copyStandardPrologue(Yt.statements,Pe,0,!1),_n=t.copyCustomPrologue(Yt.statements,ot,_n,se,K9),_n=t.copyCustomPrologue(Yt.statements,ot,_n,se,Q9)),ct=qr(ot,ie)||ct,ct=Ot(ot,ie,!1)||ct,ra(Yt))_n=t.copyCustomPrologue(Yt.statements,ot,_n,se),Gt=Yt.statements,jt(ot,Hr(Yt.statements,se,ns,_n)),!ct&&Yt.multiLine&&(ct=!0);else{I.assert(ie.kind===219),Gt=Fj(Yt,-1);let ci=ie.equalsGreaterThanToken;!_c(ci)&&!_c(Yt)&&(nR(ci,Yt,b)?Jt=!0:ct=!0);let ds=nt(Yt,se,bt),Ya=t.createReturnStatement(ds);ft(Ya,Yt),sge(Ya,Yt),Sn(Ya,2880),ot.push(Ya),V=Yt}if(t.mergeLexicalEnvironment(Pe,o()),pt(Pe,ie),_e(Pe,ie),Tt(Pe)&&(ct=!0),ot.unshift(...Pe),ra(Yt)&&td(ot,Yt.statements))return Yt;let gi=t.createBlock(ft(t.createNodeArray(ot),Gt),ct);return ft(gi,ie.body),!ct&&Jt&&Sn(gi,1),V&&ige(gi,20,V),Un(gi,ie.body),gi}function Be(ie,ct){if(ct)return wr(ie,se,e);let Jt=k&256?K(7104,512):K(6976,128),Gt=wr(ie,se,e);return re(Jt,0,0),Gt}function Lt(ie){return wr(ie,Se,e)}function B(ie,ct){return wr(ie,ct?Se:se,e)}function le(ie,ct){return I1(ie)?Tx(ie,se,e,0,!ct):ie.operatorToken.kind===28?t.updateBinaryExpression(ie,I.checkDefined(nt(ie.left,Se,bt)),ie.operatorToken,I.checkDefined(nt(ie.right,ct?Se:se,bt))):wr(ie,se,e)}function X(ie,ct){if(ct)return wr(ie,Se,e);let Jt;for(let V=0;V<ie.elements.length;V++){let Pe=ie.elements[V],ot=nt(Pe,V<ie.elements.length-1?Se:se,bt);(Jt||ot!==Pe)&&(Jt||(Jt=ie.elements.slice(0,V)),I.assert(ot),Jt.push(ot))}let Gt=Jt?ft(t.createNodeArray(Jt),ie.elements):ie.elements;return t.updateCommaListExpression(ie,Gt)}function he(ie){return ie.declarationList.declarations.length===1&&!!ie.declarationList.declarations[0].initializer&&!!(Lm(ie.declarationList.declarations[0].initializer)&1)}function qe(ie){let ct=K(0,ui(ie,32)?32:0),Jt;if(O&&!(ie.declarationList.flags&7)&&!he(ie)){let Gt;for(let V of ie.declarationList.declarations)if($u(O,V),V.initializer){let Pe;la(V.name)?Pe=Tx(V,se,e,0):(Pe=t.createBinaryExpression(V.name,64,I.checkDefined(nt(V.initializer,se,bt))),ft(Pe,V)),Gt=Pr(Gt,Pe)}Gt?Jt=ft(t.createExpressionStatement(t.inlineExpressions(Gt)),ie):Jt=void 0}else Jt=wr(ie,se,e);return re(ct,0,0),Jt}function Le(ie){if(ie.flags&7||ie.transformFlags&524288){ie.flags&7&&wf();let ct=Hr(ie.declarations,ie.flags&1?Zt:Ir,Gi),Jt=t.createVariableDeclarationList(ct);return Un(Jt,ie),ft(Jt,ie),kl(Jt,ie),ie.transformFlags&524288&&(la(ie.declarations[0].name)||la(Rs(ie.declarations).name))&&qa(Jt,It(ct)),Jt}return wr(ie,se,e)}function It(ie){let ct=-1,Jt=-1;for(let Gt of ie)ct=ct===-1?Gt.pos:Gt.pos===-1?ct:Math.min(ct,Gt.pos),Jt=Math.max(Jt,Gt.end);return kd(ct,Jt)}function Rt(ie){let ct=m.getNodeCheckFlags(ie),Jt=ct&16384,Gt=ct&32768;return!((k&64)!==0||Jt&&Gt&&(k&512)!==0)&&(k&4096)===0&&(!m.isDeclarationWithCollidingName(ie)||Gt&&!Jt&&(k&6144)===0)}function Zt(ie){let ct=ie.name;return la(ct)?Ir(ie):!ie.initializer&&Rt(ie)?t.updateVariableDeclaration(ie,ie.name,void 0,void 0,t.createVoidZero()):wr(ie,se,e)}function Ir(ie){let ct=K(32,0),Jt;return la(ie.name)?Jt=bE(ie,se,e,0,void 0,(ct&32)!==0):Jt=wr(ie,se,e),re(ct,0,0),Jt}function zr(ie){O.labels.set(Nn(ie.label),!0)}function Yr(ie){O.labels.set(Nn(ie.label),!1)}function Pi(ie){O&&!O.labels&&(O.labels=new Map);let ct=VY(ie,O&&zr);return Lv(ct,!1)?Fi(ct,ie):t.restoreEnclosingLabel(I.checkDefined(nt(ct,se,ns,t.liftToBlock)),ie,O&&Yr)}function Fi(ie,ct){switch(ie.kind){case 246:case 247:return Qn(ie,ct);case 248:return Ns(ie,ct);case 249:return ji(ie,ct);case 250:return ni(ie,ct)}}function fn(ie,ct,Jt,Gt,V){let Pe=K(ie,ct),ot=Uo(Jt,Gt,Pe,V);return re(Pe,0,0),ot}function Qn(ie,ct){return fn(0,1280,ie,ct)}function Ns(ie,ct){return fn(5056,3328,ie,ct)}function Vi(ie){return t.updateForStatement(ie,nt(ie.initializer,Se,Cd),nt(ie.condition,se,bt),nt(ie.incrementor,Se,bt),I.checkDefined(nt(ie.statement,se,ns,t.liftToBlock)))}function ji(ie,ct){return fn(3008,5376,ie,ct)}function ni(ie,ct){return fn(3008,5376,ie,ct,p.downlevelIteration?Sl:Qo)}function js(ie,ct,Jt){let Gt=[],V=ie.initializer;if(Tu(V)){ie.initializer.flags&7&&wf();let Pe=qi(V.declarations);if(Pe&&la(Pe.name)){let ot=bE(Pe,se,e,0,ct),Yt=ft(t.createVariableDeclarationList(ot),ie.initializer);Un(Yt,ie.initializer),qa(Yt,kd(ot[0].pos,Rs(ot).end)),Gt.push(t.createVariableStatement(void 0,Yt))}else Gt.push(ft(t.createVariableStatement(void 0,Un(ft(t.createVariableDeclarationList([t.createVariableDeclaration(Pe?Pe.name:t.createTempVariable(void 0),void 0,void 0,ct)]),TT(V,-1)),V)),Fj(V,-1)))}else{let Pe=t.createAssignment(V,ct);I1(Pe)?Gt.push(t.createExpressionStatement(le(Pe,!0))):(RN(Pe,V.end),Gt.push(ft(t.createExpressionStatement(I.checkDefined(nt(Pe,se,bt))),Fj(V,-1))))}if(Jt)return Mr(jt(Gt,Jt));{let Pe=nt(ie.statement,se,ns,t.liftToBlock);return I.assert(Pe),ra(Pe)?t.updateBlock(Pe,ft(t.createNodeArray(ys(Gt,Pe.statements)),Pe.statements)):(Gt.push(Pe),Mr(Gt))}}function Mr(ie){return Sn(t.createBlock(t.createNodeArray(ie),!0),864)}function Qo(ie,ct,Jt){let Gt=nt(ie.expression,se,bt);I.assert(Gt);let V=t.createLoopVariable(),Pe=ze(Gt)?t.getGeneratedNameForNode(Gt):t.createTempVariable(void 0);Sn(Gt,96|eo(Gt));let ot=ft(t.createForStatement(Sn(ft(t.createVariableDeclarationList([ft(t.createVariableDeclaration(V,void 0,void 0,t.createNumericLiteral(0)),TT(ie.expression,-1)),ft(t.createVariableDeclaration(Pe,void 0,void 0,Gt),ie.expression)]),ie.expression),4194304),ft(t.createLessThan(V,t.createPropertyAccessExpression(Pe,"length")),ie.expression),ft(t.createPostfixIncrement(V),ie.expression),js(ie,t.createElementAccessExpression(Pe,V),Jt)),ie);return Sn(ot,512),ft(ot,ie),t.restoreEnclosingLabel(ot,ct,O&&Yr)}function Sl(ie,ct,Jt,Gt){let V=nt(ie.expression,se,bt);I.assert(V);let Pe=ze(V)?t.getGeneratedNameForNode(V):t.createTempVariable(void 0),ot=ze(V)?t.getGeneratedNameForNode(Pe):t.createTempVariable(void 0),Yt=t.createUniqueName("e"),_n=t.getGeneratedNameForNode(Yt),gi=t.createTempVariable(void 0),ci=ft(n().createValuesHelper(V),ie.expression),ds=t.createCallExpression(t.createPropertyAccessExpression(Pe,"next"),void 0,[]);l(Yt),l(gi);let Ya=Gt&1024?t.inlineExpressions([t.createAssignment(Yt,t.createVoidZero()),ci]):ci,Xa=Sn(ft(t.createForStatement(Sn(ft(t.createVariableDeclarationList([ft(t.createVariableDeclaration(Pe,void 0,void 0,Ya),ie.expression),t.createVariableDeclaration(ot,void 0,void 0,ds)]),ie.expression),4194304),t.createLogicalNot(t.createPropertyAccessExpression(ot,"done")),t.createAssignment(ot,ds),js(ie,t.createPropertyAccessExpression(ot,"value"),Jt)),ie),512);return t.createTryStatement(t.createBlock([t.restoreEnclosingLabel(Xa,ct,O&&Yr)]),t.createCatchClause(t.createVariableDeclaration(_n),Sn(t.createBlock([t.createExpressionStatement(t.createAssignment(Yt,t.createObjectLiteralExpression([t.createPropertyAssignment("error",_n)])))]),1)),t.createBlock([t.createTryStatement(t.createBlock([Sn(t.createIfStatement(t.createLogicalAnd(t.createLogicalAnd(ot,t.createLogicalNot(t.createPropertyAccessExpression(ot,"done"))),t.createAssignment(gi,t.createPropertyAccessExpression(Pe,"return"))),t.createExpressionStatement(t.createFunctionCallCall(gi,Pe,[]))),1)]),void 0,Sn(t.createBlock([Sn(t.createIfStatement(Yt,t.createThrowStatement(t.createPropertyAccessExpression(Yt,"error"))),1)]),1))]))}function zs(ie){let ct=ie.properties,Jt=-1,Gt=!1;for(let Yt=0;Yt<ct.length;Yt++){let _n=ct[Yt];if(_n.transformFlags&1048576&&k&4||(Gt=I.checkDefined(_n.name).kind===167)){Jt=Yt;break}}if(Jt<0)return wr(ie,se,e);let V=t.createTempVariable(l),Pe=[],ot=t.createAssignment(V,Sn(t.createObjectLiteralExpression(Hr(ct,se,by,0,Jt),ie.multiLine),Gt?131072:0));return ie.multiLine&&M_(ot),Pe.push(ot),gr(Pe,ie,V,Jt),Pe.push(ie.multiLine?M_(io(ft(t.cloneNode(V),V),V.parent)):V),t.inlineExpressions(Pe)}function Eo(ie){return(m.getNodeCheckFlags(ie)&8192)!==0}function nc(ie){return _x(ie)&&!!ie.initializer&&Eo(ie.initializer)}function Dc(ie){return _x(ie)&&!!ie.condition&&Eo(ie.condition)}function zu(ie){return _x(ie)&&!!ie.incrementor&&Eo(ie.incrementor)}function ks(ie){return ya(ie)||nc(ie)}function ya(ie){return(m.getNodeCheckFlags(ie)&4096)!==0}function $u(ie,ct){ie.hoistedLocalVariables||(ie.hoistedLocalVariables=[]),Jt(ct.name);function Jt(Gt){if(Gt.kind===80)ie.hoistedLocalVariables.push(Gt);else for(let V of Gt.elements)Su(V)||Jt(V.name)}}function Uo(ie,ct,Jt,Gt){if(!ks(ie)){let ci;O&&(ci=O.allowedNonLabeledJumps,O.allowedNonLabeledJumps=6);let ds=Gt?Gt(ie,ct,void 0,Jt):t.restoreEnclosingLabel(_x(ie)?Vi(ie):wr(ie,se,e),ct,O&&Yr);return O&&(O.allowedNonLabeledJumps=ci),ds}let V=$s(ie),Pe=[],ot=O;O=V;let Yt=nc(ie)?Mu(ie,V):void 0,_n=ya(ie)?Wu(ie,V,ot):void 0;O=ot,Yt&&Pe.push(Yt.functionDeclaration),_n&&Pe.push(_n.functionDeclaration),cr(Pe,V,ot),Yt&&Pe.push(ru(Yt.functionName,Yt.containsYield));let gi;if(_n)if(Gt)gi=Gt(ie,ct,_n.part,Jt);else{let ci=$a(ie,Yt,t.createBlock(_n.part,!0));gi=t.restoreEnclosingLabel(ci,ct,O&&Yr)}else{let ci=$a(ie,Yt,I.checkDefined(nt(ie.statement,se,ns,t.liftToBlock)));gi=t.restoreEnclosingLabel(ci,ct,O&&Yr)}return Pe.push(gi),Pe}function $a(ie,ct,Jt){switch(ie.kind){case 248:return Ac(ie,ct,Jt);case 249:return Nl(ie,Jt);case 250:return Ld(ie,Jt);case 246:return zc(ie,Jt);case 247:return Tc(ie,Jt);default:return I.failBadSyntaxKind(ie,"IterationStatement expected")}}function Ac(ie,ct,Jt){let Gt=ie.condition&&Eo(ie.condition),V=Gt||ie.incrementor&&Eo(ie.incrementor);return t.updateForStatement(ie,nt(ct?ct.part:ie.initializer,Se,Cd),nt(Gt?void 0:ie.condition,se,bt),nt(V?void 0:ie.incrementor,Se,bt),Jt)}function Ld(ie,ct){return t.updateForOfStatement(ie,void 0,I.checkDefined(nt(ie.initializer,se,Cd)),I.checkDefined(nt(ie.expression,se,bt)),ct)}function Nl(ie,ct){return t.updateForInStatement(ie,I.checkDefined(nt(ie.initializer,se,Cd)),I.checkDefined(nt(ie.expression,se,bt)),ct)}function zc(ie,ct){return t.updateDoStatement(ie,ct,I.checkDefined(nt(ie.expression,se,bt)))}function Tc(ie,ct){return t.updateWhileStatement(ie,I.checkDefined(nt(ie.expression,se,bt)),ct)}function $s(ie){let ct;switch(ie.kind){case 248:case 249:case 250:let Pe=ie.initializer;Pe&&Pe.kind===261&&(ct=Pe);break}let Jt=[],Gt=[];if(ct&&x1(ct)&7){let Pe=nc(ie)||Dc(ie)||zu(ie);for(let ot of ct.declarations)Et(ie,ot,Jt,Gt,Pe)}let V={loopParameters:Jt,loopOutParameters:Gt};return O&&(O.argumentsName&&(V.argumentsName=O.argumentsName),O.thisName&&(V.thisName=O.thisName),O.hoistedLocalVariables&&(V.hoistedLocalVariables=O.hoistedLocalVariables)),V}function cr(ie,ct,Jt){let Gt;if(ct.argumentsName&&(Jt?Jt.argumentsName=ct.argumentsName:(Gt||(Gt=[])).push(t.createVariableDeclaration(ct.argumentsName,void 0,void 0,t.createIdentifier("arguments")))),ct.thisName&&(Jt?Jt.thisName=ct.thisName:(Gt||(Gt=[])).push(t.createVariableDeclaration(ct.thisName,void 0,void 0,t.createIdentifier("this")))),ct.hoistedLocalVariables)if(Jt)Jt.hoistedLocalVariables=ct.hoistedLocalVariables;else{Gt||(Gt=[]);for(let V of ct.hoistedLocalVariables)Gt.push(t.createVariableDeclaration(V))}if(ct.loopOutParameters.length){Gt||(Gt=[]);for(let V of ct.loopOutParameters)Gt.push(t.createVariableDeclaration(V.outParamName))}ct.conditionVariable&&(Gt||(Gt=[]),Gt.push(t.createVariableDeclaration(ct.conditionVariable,void 0,void 0,t.createFalse()))),Gt&&ie.push(t.createVariableStatement(void 0,t.createVariableDeclarationList(Gt)))}function ic(ie){return t.createVariableDeclaration(ie.originalName,void 0,void 0,ie.outParamName)}function Mu(ie,ct){let Jt=t.createUniqueName("_loop_init"),Gt=(ie.initializer.transformFlags&1048576)!==0,V=0;ct.containsLexicalThis&&(V|=16),Gt&&k&4&&(V|=524288);let Pe=[];Pe.push(t.createVariableStatement(void 0,ie.initializer)),Go(ct.loopOutParameters,2,1,Pe);let ot=t.createVariableStatement(void 0,Sn(t.createVariableDeclarationList([t.createVariableDeclaration(Jt,void 0,void 0,Sn(t.createFunctionExpression(void 0,Gt?t.createToken(42):void 0,void 0,void 0,void 0,void 0,I.checkDefined(nt(t.createBlock(Pe,!0),se,ra))),V))]),4194304)),Yt=t.createVariableDeclarationList(vr(ct.loopOutParameters,ic));return{functionName:Jt,containsYield:Gt,functionDeclaration:ot,part:Yt}}function Wu(ie,ct,Jt){let Gt=t.createUniqueName("_loop");i();let V=nt(ie.statement,se,ns,t.liftToBlock),Pe=o(),ot=[];(Dc(ie)||zu(ie))&&(ct.conditionVariable=t.createUniqueName("inc"),ie.incrementor?ot.push(t.createIfStatement(ct.conditionVariable,t.createExpressionStatement(I.checkDefined(nt(ie.incrementor,se,bt))),t.createExpressionStatement(t.createAssignment(ct.conditionVariable,t.createTrue())))):ot.push(t.createIfStatement(t.createLogicalNot(ct.conditionVariable),t.createExpressionStatement(t.createAssignment(ct.conditionVariable,t.createTrue())))),Dc(ie)&&ot.push(t.createIfStatement(t.createPrefixUnaryExpression(54,I.checkDefined(nt(ie.condition,se,bt))),I.checkDefined(nt(t.createBreakStatement(),se,ns))))),I.assert(V),ra(V)?jt(ot,V.statements):ot.push(V),Go(ct.loopOutParameters,1,1,ot),C0(ot,Pe);let Yt=t.createBlock(ot,!0);ra(V)&&Un(Yt,V);let _n=(ie.statement.transformFlags&1048576)!==0,gi=1048576;ct.containsLexicalThis&&(gi|=16),_n&&k&4&&(gi|=524288);let ci=t.createVariableStatement(void 0,Sn(t.createVariableDeclarationList([t.createVariableDeclaration(Gt,void 0,void 0,Sn(t.createFunctionExpression(void 0,_n?t.createToken(42):void 0,void 0,void 0,ct.loopParameters,void 0,Yt),gi))]),4194304)),ds=ge(Gt,ct,Jt,_n);return{functionName:Gt,containsYield:_n,functionDeclaration:ci,part:ds}}function yp(ie,ct){let Jt=ct===0?ie.outParamName:ie.originalName,Gt=ct===0?ie.originalName:ie.outParamName;return t.createBinaryExpression(Gt,64,Jt)}function Go(ie,ct,Jt,Gt){for(let V of ie)V.flags&ct&&Gt.push(t.createExpressionStatement(yp(V,Jt)))}function ru(ie,ct){let Jt=t.createCallExpression(ie,void 0,[]),Gt=ct?t.createYieldExpression(t.createToken(42),Sn(Jt,8388608)):Jt;return t.createExpressionStatement(Gt)}function ge(ie,ct,Jt,Gt){let V=[],Pe=!(ct.nonLocalJumps&-5)&&!ct.labeledNonLocalBreaks&&!ct.labeledNonLocalContinues,ot=t.createCallExpression(ie,void 0,vr(ct.loopParameters,_n=>_n.name)),Yt=Gt?t.createYieldExpression(t.createToken(42),Sn(ot,8388608)):ot;if(Pe)V.push(t.createExpressionStatement(Yt)),Go(ct.loopOutParameters,1,0,V);else{let _n=t.createUniqueName("state"),gi=t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(_n,void 0,void 0,Yt)]));if(V.push(gi),Go(ct.loopOutParameters,1,0,V),ct.nonLocalJumps&8){let ci;Jt?(Jt.nonLocalJumps|=8,ci=t.createReturnStatement(_n)):ci=t.createReturnStatement(t.createPropertyAccessExpression(_n,"value")),V.push(t.createIfStatement(t.createTypeCheck(_n,"object"),ci))}if(ct.nonLocalJumps&2&&V.push(t.createIfStatement(t.createStrictEquality(_n,t.createStringLiteral("break")),t.createBreakStatement())),ct.labeledNonLocalBreaks||ct.labeledNonLocalContinues){let ci=[];je(ct.labeledNonLocalBreaks,!0,_n,Jt,ci),je(ct.labeledNonLocalContinues,!1,_n,Jt,ci),V.push(t.createSwitchStatement(_n,t.createCaseBlock(ci)))}}return V}function ne(ie,ct,Jt,Gt){ct?(ie.labeledNonLocalBreaks||(ie.labeledNonLocalBreaks=new Map),ie.labeledNonLocalBreaks.set(Jt,Gt)):(ie.labeledNonLocalContinues||(ie.labeledNonLocalContinues=new Map),ie.labeledNonLocalContinues.set(Jt,Gt))}function je(ie,ct,Jt,Gt,V){ie&&ie.forEach((Pe,ot)=>{let Yt=[];if(!Gt||Gt.labels&&Gt.labels.get(ot)){let _n=t.createIdentifier(ot);Yt.push(ct?t.createBreakStatement(_n):t.createContinueStatement(_n))}else ne(Gt,ct,ot,Pe),Yt.push(t.createReturnStatement(Jt));V.push(t.createCaseClause(t.createStringLiteral(Pe),Yt))})}function Et(ie,ct,Jt,Gt,V){let Pe=ct.name;if(la(Pe))for(let ot of Pe.elements)Su(ot)||Et(ie,ot,Jt,Gt,V);else{Jt.push(t.createParameterDeclaration(void 0,void 0,Pe));let ot=m.getNodeCheckFlags(ct);if(ot&65536||V){let Yt=t.createUniqueName("out_"+Nn(Pe)),_n=0;ot&65536&&(_n|=1),_x(ie)&&(ie.initializer&&m.isBindingCapturedByNode(ie.initializer,ct)&&(_n|=2),(ie.condition&&m.isBindingCapturedByNode(ie.condition,ct)||ie.incrementor&&m.isBindingCapturedByNode(ie.incrementor,ct))&&(_n|=1)),Gt.push({flags:_n,originalName:Pe,outParamName:Yt})}}}function gr(ie,ct,Jt,Gt){let V=ct.properties,Pe=V.length;for(let ot=Gt;ot<Pe;ot++){let Yt=V[ot];switch(Yt.kind){case 177:case 178:let _n=tx(ct.properties,Yt);Yt===_n.firstAccessor&&ie.push(ht(Jt,_n,ct,!!ct.multiLine));break;case 174:ie.push(Zn(Yt,Jt,ct,ct.multiLine));break;case 303:ie.push(Dn(Yt,Jt,ct.multiLine));break;case 304:ie.push(xn(Yt,Jt,ct.multiLine));break;default:I.failBadSyntaxKind(ct);break}}}function Dn(ie,ct,Jt){let Gt=t.createAssignment(hx(t,ct,I.checkDefined(nt(ie.name,se,Al))),I.checkDefined(nt(ie.initializer,se,bt)));return ft(Gt,ie),Jt&&M_(Gt),Gt}function xn(ie,ct,Jt){let Gt=t.createAssignment(hx(t,ct,I.checkDefined(nt(ie.name,se,Al))),t.cloneNode(ie.name));return ft(Gt,ie),Jt&&M_(Gt),Gt}function Zn(ie,ct,Jt,Gt){let V=t.createAssignment(hx(t,ct,I.checkDefined(nt(ie.name,se,Al))),Sr(ie,ie,void 0,Jt));return ft(V,ie),Gt&&M_(V),V}function Bi(ie){let ct=K(7104,0),Jt;if(I.assert(!!ie.variableDeclaration,"Catch clause variable should always be present when downleveling ES2015."),la(ie.variableDeclaration.name)){let Gt=t.createTempVariable(void 0),V=t.createVariableDeclaration(Gt);ft(V,ie.variableDeclaration);let Pe=bE(ie.variableDeclaration,se,e,0,Gt),ot=t.createVariableDeclarationList(Pe);ft(ot,ie.variableDeclaration);let Yt=t.createVariableStatement(void 0,ot);Jt=t.updateCatchClause(ie,V,Jn(ie.block,Yt))}else Jt=wr(ie,se,e);return re(ct,0,0),Jt}function Jn(ie,ct){let Jt=Hr(ie.statements,se,ns);return t.updateBlock(ie,[ct,...Jt])}function ia(ie){I.assert(!uo(ie.name));let ct=Sr(ie,TT(ie,-1),void 0,void 0);return Sn(ct,1024|eo(ct)),ft(t.createPropertyAssignment(ie.name,ct),ie)}function Fc(ie){I.assert(!uo(ie.name));let ct=O;O=void 0;let Jt=K(32670,65),Gt,V=qc(ie.parameters,se,e),Pe=Y(ie);return ie.kind===177?Gt=t.updateGetAccessorDeclaration(ie,ie.modifiers,ie.name,V,ie.type,Pe):Gt=t.updateSetAccessorDeclaration(ie,ie.modifiers,ie.name,V,Pe),re(Jt,229376,0),O=ct,Gt}function bu(ie){return ft(t.createPropertyAssignment(ie.name,Ae(t.cloneNode(ie.name))),ie)}function sc(ie){return wr(ie,se,e)}function Jl(ie){return wr(ie,se,e)}function jo(ie){return Tt(ie.elements,fg)?tf(ie.elements,!1,!!ie.multiLine,!!ie.elements.hasTrailingComma):wr(ie,se,e)}function Eu(ie){if(Lm(ie)&1)return Xf(ie);let ct=vl(ie.expression);return ct.kind===108||Pf(ct)||Tt(ie.arguments,fg)?pu(ie,!0):t.updateCallExpression(ie,I.checkDefined(nt(ie.expression,Z,bt)),void 0,Hr(ie.arguments,se,bt))}function Xf(ie){let ct=ta(ta(vl(ie.expression),rc).body,ra),Jt=Rf=>Xc(Rf)&&!!di(Rf.declarationList.declarations).initializer,Gt=O;O=void 0;let V=Hr(ct.statements,xe,ns);O=Gt;let Pe=Fn(V,Jt),ot=Fn(V,Rf=>!Jt(Rf)),_n=ta(di(Pe),Xc).declarationList.declarations[0],gi=vl(_n.initializer),ci=ii(gi,lu);!ci&&bn(gi)&&gi.operatorToken.kind===28&&(ci=ii(gi.left,lu));let ds=ta(ci?vl(ci.right):gi,da),Ya=ta(vl(ds.expression),Xo),Xa=Ya.body.statements,Zc=0,Gu=-1,nu=[];if(ci){let Rf=ii(Xa[Zc],Ou);Rf&&(nu.push(Rf),Zc++),nu.push(Xa[Zc]),Zc++,nu.push(t.createExpressionStatement(t.createAssignment(ci.left,ta(_n.name,ze))))}for(;!Um(T1(Xa,Gu));)Gu--;jt(nu,Xa,Zc,Gu),Gu<-1&&jt(nu,Xa,Gu+1);let Sp=ii(T1(Xa,Gu),Um);for(let Rf of ot)Um(Rf)&&Sp?.expression&&!ze(Sp.expression)?nu.push(Sp):nu.push(Rf);return jt(nu,Pe,1),t.restoreOuterExpressions(ie.expression,t.restoreOuterExpressions(_n.initializer,t.restoreOuterExpressions(ci&&ci.right,t.updateCallExpression(ds,t.restoreOuterExpressions(ds.expression,t.updateFunctionExpression(Ya,void 0,void 0,void 0,void 0,Ya.parameters,void 0,t.updateBlock(Ya.body,nu))),void 0,ds.arguments))))}function pu(ie,ct){if(ie.transformFlags&32768||ie.expression.kind===108||Pf(vl(ie.expression))){let{target:Jt,thisArg:Gt}=t.createCallBinding(ie.expression,l);ie.expression.kind===108&&Sn(Gt,8);let V;if(ie.transformFlags&32768?V=t.createFunctionApplyCall(I.checkDefined(nt(Jt,Z,bt)),ie.expression.kind===108?Gt:I.checkDefined(nt(Gt,se,bt)),tf(ie.arguments,!0,!1,!1)):V=ft(t.createFunctionCallCall(I.checkDefined(nt(Jt,Z,bt)),ie.expression.kind===108?Gt:I.checkDefined(nt(Gt,se,bt)),Hr(ie.arguments,se,bt)),ie),ie.expression.kind===108){let Pe=t.createLogicalOr(V,Fs());V=ct?t.createAssignment(oe(),Pe):Pe}return Un(V,ie)}return $2(ie)&&(k|=131072),wr(ie,se,e)}function gm(ie){if(Tt(ie.arguments,fg)){let{target:ct,thisArg:Jt}=t.createCallBinding(t.createPropertyAccessExpression(ie.expression,"bind"),l);return t.createNewExpression(t.createFunctionApplyCall(I.checkDefined(nt(ct,se,bt)),Jt,tf(t.createNodeArray([t.createVoidZero(),...ie.arguments]),!0,!1,!1)),void 0,[])}return wr(ie,se,e)}function tf(ie,ct,Jt,Gt){let V=ie.length,Pe=ip(P2(ie,Oe,(gi,ci,ds,Ya)=>ci(gi,Jt,Gt&&Ya===V)));if(Pe.length===1){let gi=Pe[0];if(ct&&!p.downlevelIteration||HX(gi.expression)||O6(gi.expression,"___spreadArray"))return gi.expression}let ot=n(),Yt=Pe[0].kind!==0,_n=Yt?t.createArrayLiteralExpression():Pe[0].expression;for(let gi=Yt?0:1;gi<Pe.length;gi++){let ci=Pe[gi];_n=ot.createSpreadArrayHelper(_n,ci.expression,ci.kind===1&&!ct)}return _n}function Oe(ie){return fg(ie)?Bt:Ds}function Bt(ie){return vr(ie,Zr)}function Zr(ie){I.assertNode(ie,fg);let ct=nt(ie.expression,se,bt);I.assert(ct);let Jt=O6(ct,"___read"),Gt=Jt||HX(ct)?2:1;return p.downlevelIteration&&Gt===1&&!Z_(ct)&&!Jt&&(ct=n().createReadHelper(ct,void 0),Gt=2),kMe(Gt,ct)}function Ds(ie,ct,Jt){let Gt=t.createArrayLiteralExpression(Hr(t.createNodeArray(ie,Jt),se,bt),ct);return kMe(0,Gt)}function sa(ie){return nt(ie.expression,se,bt)}function ua(ie){return ft(t.createStringLiteral(ie.text),ie)}function Tl(ie){return ie.hasExtendedUnicodeEscape?ft(t.createStringLiteral(ie.text),ie):ie}function ql(ie){return ie.numericLiteralFlags&384?ft(t.createNumericLiteral(ie.text),ie):ie}function bc(ie){return hZ(e,ie,se,b,M,1)}function Ic(ie){let ct=t.createStringLiteral(ie.head.text);for(let Jt of ie.templateSpans){let Gt=[I.checkDefined(nt(Jt.expression,se,bt))];Jt.literal.text.length>0&&Gt.push(t.createStringLiteral(Jt.literal.text)),ct=t.createCallExpression(t.createPropertyAccessExpression(ct,"concat"),void 0,Gt)}return ft(ct,ie)}function cl(){return t.createUniqueName("_super",48)}function bl(ie,ct){let Jt=k&8&&!ct?t.createPropertyAccessExpression(Un(cl(),ie),"prototype"):cl();return Un(Jt,ie),kl(Jt,ie),qa(Jt,ie),Jt}function xu(ie){return ie.keywordToken===105&&ie.name.escapedText==="target"?(k|=32768,t.createUniqueName("_newTarget",48)):ie}function dd(ie,ct,Jt){if(U&1&&ca(ct)){let Gt=K(32670,eo(ct)&16?81:65);h(ie,ct,Jt),re(Gt,0,0);return}h(ie,ct,Jt)}function wf(){U&2||(U|=2,e.enableSubstitution(80))}function hf(){U&1||(U|=1,e.enableSubstitution(110),e.enableEmitNotification(176),e.enableEmitNotification(174),e.enableEmitNotification(177),e.enableEmitNotification(178),e.enableEmitNotification(219),e.enableEmitNotification(218),e.enableEmitNotification(262))}function Fd(ie,ct){return ct=S(ie,ct),ie===1?Ly(ct):ze(ct)?ch(ct):ct}function ch(ie){if(U&2&&!QK(ie)){let ct=Us(ie,ze);if(ct&&Yh(ct))return ft(t.getGeneratedNameForNode(ct),ie)}return ie}function Yh(ie){switch(ie.parent.kind){case 208:case 263:case 266:case 260:return ie.parent.name===ie&&m.isDeclarationWithCollidingName(ie.parent)}return!1}function Ly(ie){switch(ie.kind){case 80:return A_(ie);case 110:return vp(ie)}return ie}function A_(ie){if(U&2&&!QK(ie)){let ct=m.getReferencedDeclarationWithCollidingName(ie);if(ct&&!(Ti(ct)&&Fy(ct,ie)))return ft(t.getGeneratedNameForNode(qs(ct)),ie)}return ie}function Fy(ie,ct){let Jt=Us(ct);if(!Jt||Jt===ie||Jt.end<=ie.pos||Jt.pos>=ie.end)return!1;let Gt=Lh(ie);for(;Jt;){if(Jt===Gt||Jt===ie)return!1;if(Du(Jt)&&Jt.parent===ie)return!0;Jt=Jt.parent}return!1}function vp(ie){return U&1&&k&16?ft(oe(),ie):ie}function U0(ie,ct){return pa(ct)?t.getInternalName(ie):t.createPropertyAccessExpression(t.getInternalName(ie),"prototype")}function Of(ie,ct){if(!ie||!ct||Tt(ie.parameters))return!1;let Jt=qi(ie.body.statements);if(!Jt||!_c(Jt)||Jt.kind!==244)return!1;let Gt=Jt.expression;if(!_c(Gt)||Gt.kind!==213)return!1;let V=Gt.expression;if(!_c(V)||V.kind!==108)return!1;let Pe=nl(Gt.arguments);if(!Pe||!_c(Pe)||Pe.kind!==230)return!1;let ot=Pe.expression;return ze(ot)&&ot.escapedText==="arguments"}}var oTt=f({"src/compiler/transformers/es2015.ts"(){"use strict";fa()}});function J0e(e){let{factory:t}=e,n=e.getCompilerOptions(),i,s;(n.jsx===1||n.jsx===3)&&(i=e.onEmitNode,e.onEmitNode=p,e.enableEmitNotification(286),e.enableEmitNotification(287),e.enableEmitNotification(285),s=[]);let o=e.onSubstituteNode;return e.onSubstituteNode=m,e.enableSubstitution(211),e.enableSubstitution(303),qm(e,l);function l(A){return A}function p(A,k,N){switch(k.kind){case 286:case 287:case 285:let M=k.tagName;s[E_(M)]=!0;break}i(A,k,N)}function m(A,k){return k.id&&s&&s[k.id]?o(A,k):(k=o(A,k),Hn(k)?S(k):Ul(k)?h(k):k)}function S(A){if(is(A.name))return A;let k=b(A.name);return k?ft(t.createElementAccessExpression(A.expression,k),A):A}function h(A){let k=ze(A.name)&&b(A.name);return k?t.updatePropertyAssignment(A,k,A.initializer):A}function b(A){let k=uT(A);if(k!==void 0&&k>=83&&k<=118)return ft(t.createStringLiteralFromNode(A),A)}}var cTt=f({"src/compiler/transformers/es5.ts"(){"use strict";fa()}});function lTt(e){switch(e){case 2:return"return";case 3:return"break";case 4:return"yield";case 5:return"yield*";case 7:return"endfinally";default:return}}function q0e(e){let{factory:t,getEmitHelperFactory:n,resumeLexicalEnvironment:i,endLexicalEnvironment:s,hoistFunctionDeclaration:o,hoistVariableDeclaration:l}=e,p=e.getCompilerOptions(),m=ho(p),S=e.getEmitResolver(),h=e.onSubstituteNode;e.onSubstituteNode=Lt;let b,A,k,N,M,O,U,H,K,re,$=1,pe,z,se,Se,xe=0,Z=0,Q,ce,ye,we,ve,oe,Ee,Me;return qm(e,Ge);function Ge(Oe){if(Oe.isDeclarationFile||!(Oe.transformFlags&2048))return Oe;let Bt=wr(Oe,Ae,e);return Ny(Bt,e.readEmitHelpers()),Bt}function Ae(Oe){let Bt=Oe.transformFlags;return N?Ie(Oe):k?Re(Oe):tc(Oe)&&Oe.asteriskToken?kt(Oe):Bt&2048?wr(Oe,Ae,e):Oe}function Ie(Oe){switch(Oe.kind){case 246:return Ta(Oe);case 247:return Nr(Oe);case 255:return ht(Oe);case 256:return Cr(Oe);default:return Re(Oe)}}function Re(Oe){switch(Oe.kind){case 262:return ke(Oe);case 218:return $e(Oe);case 177:case 178:return at(Oe);case 243:return St(Oe);case 248:return We(Oe);case 249:return dt(Oe);case 252:return pt(Oe);case 251:return _e(Oe);case 253:return st(Oe);default:return Oe.transformFlags&1048576?Ue(Oe):Oe.transformFlags&4196352?wr(Oe,Ae,e):Oe}}function Ue(Oe){switch(Oe.kind){case 226:return Ze(Oe);case 361:return Fr(Oe);case 227:return Tr(Oe);case 229:return nr(Oe);case 209:return tr(Oe);case 210:return xs(Oe);case 212:return zi(Oe);case 213:return Ms(Oe);case 214:return un(Oe);default:return wr(Oe,Ae,e)}}function kt(Oe){switch(Oe.kind){case 262:return ke(Oe);case 218:return $e(Oe);default:return I.failBadSyntaxKind(Oe)}}function ke(Oe){if(Oe.asteriskToken)Oe=Un(ft(t.createFunctionDeclaration(Oe.modifiers,void 0,Oe.name,void 0,qc(Oe.parameters,Ae,e),void 0,$t(Oe.body)),Oe),Oe);else{let Bt=k,Zr=N;k=!1,N=!1,Oe=wr(Oe,Ae,e),k=Bt,N=Zr}if(k){o(Oe);return}else return Oe}function $e(Oe){if(Oe.asteriskToken)Oe=Un(ft(t.createFunctionExpression(void 0,void 0,Oe.name,void 0,qc(Oe.parameters,Ae,e),void 0,$t(Oe.body)),Oe),Oe);else{let Bt=k,Zr=N;k=!1,N=!1,Oe=wr(Oe,Ae,e),k=Bt,N=Zr}return Oe}function at(Oe){let Bt=k,Zr=N;return k=!1,N=!1,Oe=wr(Oe,Ae,e),k=Bt,N=Zr,Oe}function $t(Oe){let Bt=[],Zr=k,Ds=N,sa=M,ua=O,Tl=U,ql=H,bc=K,Ic=re,cl=$,bl=pe,xu=z,dd=se,wf=Se;k=!0,N=!1,M=void 0,O=void 0,U=void 0,H=void 0,K=void 0,re=void 0,$=1,pe=void 0,z=void 0,se=void 0,Se=t.createTempVariable(void 0),i();let hf=t.copyPrologue(Oe.statements,Bt,!1,Ae);ri(Oe.statements,hf);let Fd=ne();return C0(Bt,s()),Bt.push(t.createReturnStatement(Fd)),k=Zr,N=Ds,M=sa,O=ua,U=Tl,H=ql,K=bc,re=Ic,$=cl,pe=bl,z=xu,se=dd,Se=wf,ft(t.createBlock(Bt,Oe.multiLine),Oe)}function St(Oe){if(Oe.transformFlags&1048576){vi(Oe.declarationList);return}else{if(eo(Oe)&2097152)return Oe;for(let Zr of Oe.declarationList.declarations)l(Zr.name);let Bt=u6(Oe.declarationList);return Bt.length===0?void 0:qa(t.createExpressionStatement(t.inlineExpressions(vr(Bt,Ni))),Oe)}}function Ze(Oe){let Bt=uX(Oe);switch(Bt){case 0:return ar(Oe);case 1:return yt(Oe);default:return I.assertNever(Bt)}}function yt(Oe){let{left:Bt,right:Zr}=Oe;if(Y(Zr)){let Ds;switch(Bt.kind){case 211:Ds=t.updatePropertyAccessExpression(Bt,X(I.checkDefined(nt(Bt.expression,Ae,$f))),Bt.name);break;case 212:Ds=t.updateElementAccessExpression(Bt,X(I.checkDefined(nt(Bt.expression,Ae,$f))),X(I.checkDefined(nt(Bt.argumentExpression,Ae,bt))));break;default:Ds=I.checkDefined(nt(Bt,Ae,bt));break}let sa=Oe.operatorToken.kind;return sO(sa)?ft(t.createAssignment(Ds,ft(t.createBinaryExpression(X(Ds),aO(sa),I.checkDefined(nt(Zr,Ae,bt))),Oe)),Oe):t.updateBinaryExpression(Oe,Ds,Oe.operatorToken,I.checkDefined(nt(Zr,Ae,bt)))}return wr(Oe,Ae,e)}function ar(Oe){return Y(Oe.right)?tme(Oe.operatorToken.kind)?rn(Oe):Oe.operatorToken.kind===28?or(Oe):t.updateBinaryExpression(Oe,X(I.checkDefined(nt(Oe.left,Ae,bt))),Oe.operatorToken,I.checkDefined(nt(Oe.right,Ae,bt))):wr(Oe,Ae,e)}function or(Oe){let Bt=[];return Zr(Oe.left),Zr(Oe.right),t.inlineExpressions(Bt);function Zr(Ds){bn(Ds)&&Ds.operatorToken.kind===28?(Zr(Ds.left),Zr(Ds.right)):(Y(Ds)&&Bt.length>0&&(ge(1,[t.createExpressionStatement(t.inlineExpressions(Bt))]),Bt=[]),Bt.push(I.checkDefined(nt(Ds,Ae,bt))))}}function Fr(Oe){let Bt=[];for(let Zr of Oe.elements)bn(Zr)&&Zr.operatorToken.kind===28?Bt.push(or(Zr)):(Y(Zr)&&Bt.length>0&&(ge(1,[t.createExpressionStatement(t.inlineExpressions(Bt))]),Bt=[]),Bt.push(I.checkDefined(nt(Zr,Ae,bt))));return t.inlineExpressions(Bt)}function rn(Oe){let Bt=qe(),Zr=he();return Tc(Zr,I.checkDefined(nt(Oe.left,Ae,bt)),Oe.left),Oe.operatorToken.kind===56?ic(Bt,Zr,Oe.left):cr(Bt,Zr,Oe.left),Tc(Zr,I.checkDefined(nt(Oe.right,Ae,bt)),Oe.right),Le(Bt),Zr}function Tr(Oe){if(Y(Oe.whenTrue)||Y(Oe.whenFalse)){let Bt=qe(),Zr=qe(),Ds=he();return ic(Bt,I.checkDefined(nt(Oe.condition,Ae,bt)),Oe.condition),Tc(Ds,I.checkDefined(nt(Oe.whenTrue,Ae,bt)),Oe.whenTrue),$s(Zr),Le(Bt),Tc(Ds,I.checkDefined(nt(Oe.whenFalse,Ae,bt)),Oe.whenFalse),Le(Zr),Ds}return wr(Oe,Ae,e)}function nr(Oe){let Bt=qe(),Zr=nt(Oe.expression,Ae,bt);if(Oe.asteriskToken){let Ds=eo(Oe.expression)&8388608?Zr:ft(n().createValuesHelper(Zr),Oe);Mu(Ds,Oe)}else Wu(Zr,Oe);return Le(Bt),Ld(Oe)}function tr(Oe){return ki(Oe.elements,void 0,void 0,Oe.multiLine)}function ki(Oe,Bt,Zr,Ds){let sa=Be(Oe),ua;if(sa>0){ua=he();let bc=Hr(Oe,Ae,bt,0,sa);Tc(ua,t.createArrayLiteralExpression(Bt?[Bt,...bc]:bc)),Bt=void 0}let Tl=d_(Oe,ql,[],sa);return ua?t.createArrayConcatCall(ua,[t.createArrayLiteralExpression(Tl,Ds)]):ft(t.createArrayLiteralExpression(Bt?[Bt,...Tl]:Tl,Ds),Zr);function ql(bc,Ic){if(Y(Ic)&&bc.length>0){let cl=ua!==void 0;ua||(ua=he()),Tc(ua,cl?t.createArrayConcatCall(ua,[t.createArrayLiteralExpression(bc,Ds)]):t.createArrayLiteralExpression(Bt?[Bt,...bc]:bc,Ds)),Bt=void 0,bc=[]}return bc.push(I.checkDefined(nt(Ic,Ae,bt))),bc}}function xs(Oe){let Bt=Oe.properties,Zr=Oe.multiLine,Ds=Be(Bt),sa=he();Tc(sa,t.createObjectLiteralExpression(Hr(Bt,Ae,by,0,Ds),Zr));let ua=d_(Bt,Tl,[],Ds);return ua.push(Zr?M_(io(ft(t.cloneNode(sa),sa),sa.parent)):sa),t.inlineExpressions(ua);function Tl(ql,bc){Y(bc)&&ql.length>0&&(zc(t.createExpressionStatement(t.inlineExpressions(ql))),ql=[]);let Ic=qge(t,Oe,bc,sa),cl=nt(Ic,Ae,bt);return cl&&(Zr&&M_(cl),ql.push(cl)),ql}}function zi(Oe){return Y(Oe.argumentExpression)?t.updateElementAccessExpression(Oe,X(I.checkDefined(nt(Oe.expression,Ae,$f))),I.checkDefined(nt(Oe.argumentExpression,Ae,bt))):wr(Oe,Ae,e)}function Ms(Oe){if(!Up(Oe)&&Te(Oe.arguments,Y)){let{target:Bt,thisArg:Zr}=t.createCallBinding(Oe.expression,l,m,!0);return Un(ft(t.createFunctionApplyCall(X(I.checkDefined(nt(Bt,Ae,$f))),Zr,ki(Oe.arguments)),Oe),Oe)}return wr(Oe,Ae,e)}function un(Oe){if(Te(Oe.arguments,Y)){let{target:Bt,thisArg:Zr}=t.createCallBinding(t.createPropertyAccessExpression(Oe.expression,"bind"),l);return Un(ft(t.createNewExpression(t.createFunctionApplyCall(X(I.checkDefined(nt(Bt,Ae,bt))),Zr,ki(Oe.arguments,t.createVoidZero())),void 0,[]),Oe),Oe)}return wr(Oe,Ae,e)}function ri(Oe,Bt=0){let Zr=Oe.length;for(let Ds=Bt;Ds<Zr;Ds++)_r(Oe[Ds])}function On(Oe){ra(Oe)?ri(Oe.statements):_r(Oe)}function _r(Oe){let Bt=N;N||(N=Y(Oe)),rt(Oe),N=Bt}function rt(Oe){switch(Oe.kind){case 241:return zt(Oe);case 244:return Rr(Oe);case 245:return us(Oe);case 246:return Fs(Oe);case 247:return to(Oe);case 248:return qr(Oe);case 249:return mt(Oe);case 251:return Ot(Oe);case 252:return Ve(Oe);case 253:return W(Oe);case 254:return Nt(Oe);case 255:return Ke(Oe);case 256:return Wt(Oe);case 257:return hr(Oe);case 258:return Sr(Oe);default:return zc(nt(Oe,Ae,ns))}}function zt(Oe){Y(Oe)?ri(Oe.statements):zc(nt(Oe,Ae,ns))}function Rr(Oe){zc(nt(Oe,Ae,ns))}function vi(Oe){for(let ua of Oe.declarations){let Tl=t.cloneNode(ua.name);kl(Tl,ua.name),l(Tl)}let Bt=u6(Oe),Zr=Bt.length,Ds=0,sa=[];for(;Ds<Zr;){for(let ua=Ds;ua<Zr;ua++){let Tl=Bt[ua];if(Y(Tl.initializer)&&sa.length>0)break;sa.push(Ni(Tl))}sa.length&&(zc(t.createExpressionStatement(t.inlineExpressions(sa))),Ds+=sa.length,sa=[])}}function Ni(Oe){return qa(t.createAssignment(qa(t.cloneNode(Oe.name),Oe.name),I.checkDefined(nt(Oe.initializer,Ae,bt))),Oe)}function us(Oe){if(Y(Oe))if(Y(Oe.thenStatement)||Y(Oe.elseStatement)){let Bt=qe(),Zr=Oe.elseStatement?qe():void 0;ic(Oe.elseStatement?Zr:Bt,I.checkDefined(nt(Oe.expression,Ae,bt)),Oe.expression),On(Oe.thenStatement),Oe.elseStatement&&($s(Bt),Le(Zr),On(Oe.elseStatement)),Le(Bt)}else zc(nt(Oe,Ae,ns));else zc(nt(Oe,Ae,ns))}function Fs(Oe){if(Y(Oe)){let Bt=qe(),Zr=qe();Vi(Bt),Le(Zr),On(Oe.statement),Le(Bt),cr(Zr,I.checkDefined(nt(Oe.expression,Ae,bt))),ji()}else zc(nt(Oe,Ae,ns))}function Ta(Oe){return N?(Ns(),Oe=wr(Oe,Ae,e),ji(),Oe):wr(Oe,Ae,e)}function to(Oe){if(Y(Oe)){let Bt=qe(),Zr=Vi(Bt);Le(Bt),ic(Zr,I.checkDefined(nt(Oe.expression,Ae,bt))),On(Oe.statement),$s(Bt),ji()}else zc(nt(Oe,Ae,ns))}function Nr(Oe){return N?(Ns(),Oe=wr(Oe,Ae,e),ji(),Oe):wr(Oe,Ae,e)}function qr(Oe){if(Y(Oe)){let Bt=qe(),Zr=qe(),Ds=Vi(Zr);if(Oe.initializer){let sa=Oe.initializer;Tu(sa)?vi(sa):zc(ft(t.createExpressionStatement(I.checkDefined(nt(sa,Ae,bt))),sa))}Le(Bt),Oe.condition&&ic(Ds,I.checkDefined(nt(Oe.condition,Ae,bt))),On(Oe.statement),Le(Zr),Oe.incrementor&&zc(ft(t.createExpressionStatement(I.checkDefined(nt(Oe.incrementor,Ae,bt))),Oe.incrementor)),$s(Bt),ji()}else zc(nt(Oe,Ae,ns))}function We(Oe){N&&Ns();let Bt=Oe.initializer;if(Bt&&Tu(Bt)){for(let Ds of Bt.declarations)l(Ds.name);let Zr=u6(Bt);Oe=t.updateForStatement(Oe,Zr.length>0?t.inlineExpressions(vr(Zr,Ni)):void 0,nt(Oe.condition,Ae,bt),nt(Oe.incrementor,Ae,bt),df(Oe.statement,Ae,e))}else Oe=wr(Oe,Ae,e);return N&&ji(),Oe}function mt(Oe){if(Y(Oe)){let Bt=he(),Zr=he(),Ds=he(),sa=t.createLoopVariable(),ua=Oe.initializer;l(sa),Tc(Bt,I.checkDefined(nt(Oe.expression,Ae,bt))),Tc(Zr,t.createArrayLiteralExpression()),zc(t.createForInStatement(Ds,Bt,t.createExpressionStatement(t.createCallExpression(t.createPropertyAccessExpression(Zr,"push"),void 0,[Ds])))),Tc(sa,t.createNumericLiteral(0));let Tl=qe(),ql=qe(),bc=Vi(ql);Le(Tl),ic(bc,t.createLessThan(sa,t.createPropertyAccessExpression(Zr,"length"))),Tc(Ds,t.createElementAccessExpression(Zr,sa)),ic(ql,t.createBinaryExpression(Ds,103,Bt));let Ic;if(Tu(ua)){for(let cl of ua.declarations)l(cl.name);Ic=t.cloneNode(ua.declarations[0].name)}else Ic=I.checkDefined(nt(ua,Ae,bt)),I.assert($f(Ic));Tc(Ic,Ds),On(Oe.statement),Le(ql),zc(t.createExpressionStatement(t.createPostfixIncrement(sa))),$s(Tl),ji()}else zc(nt(Oe,Ae,ns))}function dt(Oe){N&&Ns();let Bt=Oe.initializer;if(Tu(Bt)){for(let Zr of Bt.declarations)l(Zr.name);Oe=t.updateForInStatement(Oe,Bt.declarations[0].name,I.checkDefined(nt(Oe.expression,Ae,bt)),I.checkDefined(nt(Oe.statement,Ae,ns,t.liftToBlock)))}else Oe=wr(Oe,Ae,e);return N&&ji(),Oe}function Ot(Oe){let Bt=ya(Oe.label?Nn(Oe.label):void 0);Bt>0?$s(Bt,Oe):zc(Oe)}function _e(Oe){if(N){let Bt=ya(Oe.label&&Nn(Oe.label));if(Bt>0)return $a(Bt,Oe)}return wr(Oe,Ae,e)}function Ve(Oe){let Bt=ks(Oe.label?Nn(Oe.label):void 0);Bt>0?$s(Bt,Oe):zc(Oe)}function pt(Oe){if(N){let Bt=ks(Oe.label&&Nn(Oe.label));if(Bt>0)return $a(Bt,Oe)}return wr(Oe,Ae,e)}function W(Oe){yp(nt(Oe.expression,Ae,bt),Oe)}function st(Oe){return Ac(nt(Oe.expression,Ae,bt),Oe)}function Nt(Oe){Y(Oe)?(zr(X(I.checkDefined(nt(Oe.expression,Ae,bt)))),On(Oe.statement),Yr()):zc(nt(Oe,Ae,ns))}function Ke(Oe){if(Y(Oe.caseBlock)){let Bt=Oe.caseBlock,Zr=Bt.clauses.length,Ds=js(),sa=X(I.checkDefined(nt(Oe.expression,Ae,bt))),ua=[],Tl=-1;for(let Ic=0;Ic<Zr;Ic++){let cl=Bt.clauses[Ic];ua.push(qe()),cl.kind===297&&Tl===-1&&(Tl=Ic)}let ql=0,bc=[];for(;ql<Zr;){let Ic=0;for(let cl=ql;cl<Zr;cl++){let bl=Bt.clauses[cl];if(bl.kind===296){if(Y(bl.expression)&&bc.length>0)break;bc.push(t.createCaseClause(I.checkDefined(nt(bl.expression,Ae,bt)),[$a(ua[cl],bl.expression)]))}else Ic++}bc.length&&(zc(t.createSwitchStatement(sa,t.createCaseBlock(bc))),ql+=bc.length,bc=[]),Ic>0&&(ql+=Ic,Ic=0)}Tl>=0?$s(ua[Tl]):$s(Ds);for(let Ic=0;Ic<Zr;Ic++)Le(ua[Ic]),ri(Bt.clauses[Ic].statements);Mr()}else zc(nt(Oe,Ae,ns))}function ht(Oe){return N&&ni(),Oe=wr(Oe,Ae,e),N&&Mr(),Oe}function Wt(Oe){Y(Oe)?(Sl(Nn(Oe.label)),On(Oe.statement),zs()):zc(nt(Oe,Ae,ns))}function Cr(Oe){return N&&Qo(Nn(Oe.label)),Oe=wr(Oe,Ae,e),N&&zs(),Oe}function hr(Oe){Go(I.checkDefined(nt(Oe.expression??t.createVoidZero(),Ae,bt)),Oe)}function Sr(Oe){Y(Oe)?(Pi(),On(Oe.tryBlock),Oe.catchClause&&(Fi(Oe.catchClause.variableDeclaration),On(Oe.catchClause.block)),Oe.finallyBlock&&(fn(),On(Oe.finallyBlock)),Qn()):zc(wr(Oe,Ae,e))}function Y(Oe){return!!Oe&&(Oe.transformFlags&1048576)!==0}function Be(Oe){let Bt=Oe.length;for(let Zr=0;Zr<Bt;Zr++)if(Y(Oe[Zr]))return Zr;return-1}function Lt(Oe,Bt){return Bt=h(Oe,Bt),Oe===1?B(Bt):Bt}function B(Oe){return ze(Oe)?le(Oe):Oe}function le(Oe){if(!yc(Oe)&&b&&b.has(Nn(Oe))){let Bt=Hc(Oe);if(ze(Bt)&&Bt.parent){let Zr=S.getReferencedValueDeclaration(Bt);if(Zr){let Ds=A[E_(Zr)];if(Ds){let sa=io(ft(t.cloneNode(Ds),Ds),Ds.parent);return qa(sa,Oe),kl(sa,Oe),sa}}}}return Oe}function X(Oe){if(yc(Oe)||eo(Oe)&8192)return Oe;let Bt=t.createTempVariable(l);return Tc(Bt,Oe,Oe),Bt}function he(Oe){let Bt=Oe?t.createUniqueName(Oe):t.createTempVariable(void 0);return l(Bt),Bt}function qe(){K||(K=[]);let Oe=$;return $++,K[Oe]=-1,Oe}function Le(Oe){I.assert(K!==void 0,"No labels were defined."),K[Oe]=pe?pe.length:0}function It(Oe){M||(M=[],U=[],O=[],H=[]);let Bt=U.length;return U[Bt]=0,O[Bt]=pe?pe.length:0,M[Bt]=Oe,H.push(Oe),Bt}function Rt(){let Oe=Zt();if(Oe===void 0)return I.fail("beginBlock was never called.");let Bt=U.length;return U[Bt]=1,O[Bt]=pe?pe.length:0,M[Bt]=Oe,H.pop(),Oe}function Zt(){return Is(H)}function Ir(){let Oe=Zt();return Oe&&Oe.kind}function zr(Oe){let Bt=qe(),Zr=qe();Le(Bt),It({kind:1,expression:Oe,startLabel:Bt,endLabel:Zr})}function Yr(){I.assert(Ir()===1);let Oe=Rt();Le(Oe.endLabel)}function Pi(){let Oe=qe(),Bt=qe();return Le(Oe),It({kind:0,state:0,startLabel:Oe,endLabel:Bt}),Nl(),Bt}function Fi(Oe){I.assert(Ir()===0);let Bt;if(yc(Oe.name))Bt=Oe.name,l(Oe.name);else{let ua=Nn(Oe.name);Bt=he(ua),b||(b=new Map,A=[],e.enableSubstitution(80)),b.set(ua,!0),A[E_(Oe)]=Bt}let Zr=Zt();I.assert(Zr.state<1);let Ds=Zr.endLabel;$s(Ds);let sa=qe();Le(sa),Zr.state=1,Zr.catchVariable=Bt,Zr.catchLabel=sa,Tc(Bt,t.createCallExpression(t.createPropertyAccessExpression(Se,"sent"),void 0,[])),Nl()}function fn(){I.assert(Ir()===0);let Oe=Zt();I.assert(Oe.state<2);let Bt=Oe.endLabel;$s(Bt);let Zr=qe();Le(Zr),Oe.state=2,Oe.finallyLabel=Zr}function Qn(){I.assert(Ir()===0);let Oe=Rt();Oe.state<2?$s(Oe.endLabel):ru(),Le(Oe.endLabel),Nl(),Oe.state=3}function Ns(){It({kind:3,isScript:!0,breakLabel:-1,continueLabel:-1})}function Vi(Oe){let Bt=qe();return It({kind:3,isScript:!1,breakLabel:Bt,continueLabel:Oe}),Bt}function ji(){I.assert(Ir()===3);let Oe=Rt(),Bt=Oe.breakLabel;Oe.isScript||Le(Bt)}function ni(){It({kind:2,isScript:!0,breakLabel:-1})}function js(){let Oe=qe();return It({kind:2,isScript:!1,breakLabel:Oe}),Oe}function Mr(){I.assert(Ir()===2);let Oe=Rt(),Bt=Oe.breakLabel;Oe.isScript||Le(Bt)}function Qo(Oe){It({kind:4,isScript:!0,labelText:Oe,breakLabel:-1})}function Sl(Oe){let Bt=qe();It({kind:4,isScript:!1,labelText:Oe,breakLabel:Bt})}function zs(){I.assert(Ir()===4);let Oe=Rt();Oe.isScript||Le(Oe.breakLabel)}function Eo(Oe){return Oe.kind===2||Oe.kind===3}function nc(Oe){return Oe.kind===4}function Dc(Oe){return Oe.kind===3}function zu(Oe,Bt){for(let Zr=Bt;Zr>=0;Zr--){let Ds=H[Zr];if(nc(Ds)){if(Ds.labelText===Oe)return!0}else break}return!1}function ks(Oe){if(H)if(Oe)for(let Bt=H.length-1;Bt>=0;Bt--){let Zr=H[Bt];if(nc(Zr)&&Zr.labelText===Oe)return Zr.breakLabel;if(Eo(Zr)&&zu(Oe,Bt-1))return Zr.breakLabel}else for(let Bt=H.length-1;Bt>=0;Bt--){let Zr=H[Bt];if(Eo(Zr))return Zr.breakLabel}return 0}function ya(Oe){if(H)if(Oe)for(let Bt=H.length-1;Bt>=0;Bt--){let Zr=H[Bt];if(Dc(Zr)&&zu(Oe,Bt-1))return Zr.continueLabel}else for(let Bt=H.length-1;Bt>=0;Bt--){let Zr=H[Bt];if(Dc(Zr))return Zr.continueLabel}return 0}function $u(Oe){if(Oe!==void 0&&Oe>0){re===void 0&&(re=[]);let Bt=t.createNumericLiteral(Number.MAX_SAFE_INTEGER);return re[Oe]===void 0?re[Oe]=[Bt]:re[Oe].push(Bt),Bt}return t.createOmittedExpression()}function Uo(Oe){let Bt=t.createNumericLiteral(Oe);return bB(Bt,3,lTt(Oe)),Bt}function $a(Oe,Bt){return I.assertLessThan(0,Oe,"Invalid label"),ft(t.createReturnStatement(t.createArrayLiteralExpression([Uo(3),$u(Oe)])),Bt)}function Ac(Oe,Bt){return ft(t.createReturnStatement(t.createArrayLiteralExpression(Oe?[Uo(2),Oe]:[Uo(2)])),Bt)}function Ld(Oe){return ft(t.createCallExpression(t.createPropertyAccessExpression(Se,"sent"),void 0,[]),Oe)}function Nl(){ge(0)}function zc(Oe){Oe?ge(1,[Oe]):Nl()}function Tc(Oe,Bt,Zr){ge(2,[Oe,Bt],Zr)}function $s(Oe,Bt){ge(3,[Oe],Bt)}function cr(Oe,Bt,Zr){ge(4,[Oe,Bt],Zr)}function ic(Oe,Bt,Zr){ge(5,[Oe,Bt],Zr)}function Mu(Oe,Bt){ge(7,[Oe],Bt)}function Wu(Oe,Bt){ge(6,[Oe],Bt)}function yp(Oe,Bt){ge(8,[Oe],Bt)}function Go(Oe,Bt){ge(9,[Oe],Bt)}function ru(){ge(10)}function ge(Oe,Bt,Zr){pe===void 0&&(pe=[],z=[],se=[]),K===void 0&&Le(qe());let Ds=pe.length;pe[Ds]=Oe,z[Ds]=Bt,se[Ds]=Zr}function ne(){xe=0,Z=0,Q=void 0,ce=!1,ye=!1,we=void 0,ve=void 0,oe=void 0,Ee=void 0,Me=void 0;let Oe=je();return n().createGeneratorHelper(Sn(t.createFunctionExpression(void 0,void 0,void 0,void 0,[t.createParameterDeclaration(void 0,void 0,Se)],void 0,t.createBlock(Oe,Oe.length>0)),1048576))}function je(){if(pe){for(let Oe=0;Oe<pe.length;Oe++)ia(Oe);gr(pe.length)}else gr(0);if(we){let Oe=t.createPropertyAccessExpression(Se,"label"),Bt=t.createSwitchStatement(Oe,t.createCaseBlock(we));return[M_(Bt)]}return ve||[]}function Et(){ve&&(xn(!ce),ce=!1,ye=!1,Z++)}function gr(Oe){Dn(Oe)&&(Zn(Oe),Me=void 0,Jl(void 0,void 0)),ve&&we&&xn(!1),Bi()}function Dn(Oe){if(!ye)return!0;if(!K||!re)return!1;for(let Bt=0;Bt<K.length;Bt++)if(K[Bt]===Oe&&re[Bt])return!0;return!1}function xn(Oe){if(we||(we=[]),ve){if(Me)for(let Bt=Me.length-1;Bt>=0;Bt--){let Zr=Me[Bt];ve=[t.createWithStatement(Zr.expression,t.createBlock(ve))]}if(Ee){let{startLabel:Bt,catchLabel:Zr,finallyLabel:Ds,endLabel:sa}=Ee;ve.unshift(t.createExpressionStatement(t.createCallExpression(t.createPropertyAccessExpression(t.createPropertyAccessExpression(Se,"trys"),"push"),void 0,[t.createArrayLiteralExpression([$u(Bt),$u(Zr),$u(Ds),$u(sa)])]))),Ee=void 0}Oe&&ve.push(t.createExpressionStatement(t.createAssignment(t.createPropertyAccessExpression(Se,"label"),t.createNumericLiteral(Z+1))))}we.push(t.createCaseClause(t.createNumericLiteral(Z),ve||[])),ve=void 0}function Zn(Oe){if(K)for(let Bt=0;Bt<K.length;Bt++)K[Bt]===Oe&&(Et(),Q===void 0&&(Q=[]),Q[Z]===void 0?Q[Z]=[Bt]:Q[Z].push(Bt))}function Bi(){if(re!==void 0&&Q!==void 0)for(let Oe=0;Oe<Q.length;Oe++){let Bt=Q[Oe];if(Bt!==void 0)for(let Zr of Bt){let Ds=re[Zr];if(Ds!==void 0)for(let sa of Ds)sa.text=String(Oe)}}}function Jn(Oe){if(M)for(;xe<U.length&&O[xe]<=Oe;xe++){let Bt=M[xe],Zr=U[xe];switch(Bt.kind){case 0:Zr===0?(oe||(oe=[]),ve||(ve=[]),oe.push(Ee),Ee=Bt):Zr===1&&(Ee=oe.pop());break;case 1:Zr===0?(Me||(Me=[]),Me.push(Bt)):Zr===1&&Me.pop();break}}}function ia(Oe){if(Zn(Oe),Jn(Oe),ce)return;ce=!1,ye=!1;let Bt=pe[Oe];if(Bt===0)return;if(Bt===10)return tf();let Zr=z[Oe];if(Bt===1)return Fc(Zr[0]);let Ds=se[Oe];switch(Bt){case 2:return bu(Zr[0],Zr[1],Ds);case 3:return jo(Zr[0],Ds);case 4:return Eu(Zr[0],Zr[1],Ds);case 5:return Xf(Zr[0],Zr[1],Ds);case 6:return pu(Zr[0],Ds);case 7:return gm(Zr[0],Ds);case 8:return Jl(Zr[0],Ds);case 9:return sc(Zr[0],Ds)}}function Fc(Oe){Oe&&(ve?ve.push(Oe):ve=[Oe])}function bu(Oe,Bt,Zr){Fc(ft(t.createExpressionStatement(t.createAssignment(Oe,Bt)),Zr))}function sc(Oe,Bt){ce=!0,ye=!0,Fc(ft(t.createThrowStatement(Oe),Bt))}function Jl(Oe,Bt){ce=!0,ye=!0,Fc(Sn(ft(t.createReturnStatement(t.createArrayLiteralExpression(Oe?[Uo(2),Oe]:[Uo(2)])),Bt),768))}function jo(Oe,Bt){ce=!0,Fc(Sn(ft(t.createReturnStatement(t.createArrayLiteralExpression([Uo(3),$u(Oe)])),Bt),768))}function Eu(Oe,Bt,Zr){Fc(Sn(t.createIfStatement(Bt,Sn(ft(t.createReturnStatement(t.createArrayLiteralExpression([Uo(3),$u(Oe)])),Zr),768)),1))}function Xf(Oe,Bt,Zr){Fc(Sn(t.createIfStatement(t.createLogicalNot(Bt),Sn(ft(t.createReturnStatement(t.createArrayLiteralExpression([Uo(3),$u(Oe)])),Zr),768)),1))}function pu(Oe,Bt){ce=!0,Fc(Sn(ft(t.createReturnStatement(t.createArrayLiteralExpression(Oe?[Uo(4),Oe]:[Uo(4)])),Bt),768))}function gm(Oe,Bt){ce=!0,Fc(Sn(ft(t.createReturnStatement(t.createArrayLiteralExpression([Uo(5),Oe])),Bt),768))}function tf(){ce=!0,Fc(t.createReturnStatement(t.createArrayLiteralExpression([Uo(7)])))}}var uTt=f({"src/compiler/transformers/generators.ts"(){"use strict";fa()}});function SZ(e){function t(Y){switch(Y){case 2:return pe;case 3:return z;default:return $}}let{factory:n,getEmitHelperFactory:i,startLexicalEnvironment:s,endLexicalEnvironment:o,hoistVariableDeclaration:l}=e,p=e.getCompilerOptions(),m=e.getEmitResolver(),S=e.getEmitHost(),h=ho(p),b=T_(p),A=e.onSubstituteNode,k=e.onEmitNode;e.onSubstituteNode=st,e.onEmitNode=W,e.enableSubstitution(213),e.enableSubstitution(215),e.enableSubstitution(80),e.enableSubstitution(226),e.enableSubstitution(304),e.enableEmitNotification(312);let N=[],M,O,U=[],H;return qm(e,K);function K(Y){if(Y.isDeclarationFile||!(bA(Y,p)||Y.transformFlags&8388608||sm(Y)&&$j(p)&&Wo(p)))return Y;M=Y,O=lZ(e,Y),N[E_(Y)]=O;let Lt=t(b)(Y);return M=void 0,O=void 0,H=!1,Lt}function re(){return!!(!O.exportEquals&&Pl(M))}function $(Y){s();let Be=[],Lt=K_(p,"alwaysStrict")||!p.noImplicitUseStrict&&Pl(M),B=n.copyPrologue(Y.statements,Be,Lt&&!sm(Y),Q);if(re()&&Pr(Be,Ot()),de(O.exportedNames))for(let he=0;he<O.exportedNames.length;he+=50)Pr(Be,n.createExpressionStatement(d_(O.exportedNames.slice(he,he+50),(qe,Le)=>n.createAssignment(n.createPropertyAccessExpression(n.createIdentifier("exports"),n.createIdentifier(Nn(Le))),qe),n.createVoidZero())));Pr(Be,nt(O.externalHelpersImportDeclaration,Q,ns)),jt(Be,Hr(Y.statements,Q,ns,B)),Z(Be,!1),C0(Be,o());let le=n.updateSourceFile(Y,ft(n.createNodeArray(Be),Y.statements));return Ny(le,e.readEmitHelpers()),le}function pe(Y){let Be=n.createIdentifier("define"),Lt=$R(n,Y,S,p),B=sm(Y)&&Y,{aliasedModuleNames:le,unaliasedModuleNames:X,importAliasNames:he}=se(Y,!0),qe=n.updateSourceFile(Y,ft(n.createNodeArray([n.createExpressionStatement(n.createCallExpression(Be,void 0,[...Lt?[Lt]:[],n.createArrayLiteralExpression(B?tt:[n.createStringLiteral("require"),n.createStringLiteral("exports"),...le,...X]),B?B.statements.length?B.statements[0].expression:n.createObjectLiteralExpression():n.createFunctionExpression(void 0,void 0,void 0,void 0,[n.createParameterDeclaration(void 0,void 0,"require"),n.createParameterDeclaration(void 0,void 0,"exports"),...he],void 0,xe(Y))]))]),Y.statements));return Ny(qe,e.readEmitHelpers()),qe}function z(Y){let{aliasedModuleNames:Be,unaliasedModuleNames:Lt,importAliasNames:B}=se(Y,!1),le=$R(n,Y,S,p),X=n.createFunctionExpression(void 0,void 0,void 0,void 0,[n.createParameterDeclaration(void 0,void 0,"factory")],void 0,ft(n.createBlock([n.createIfStatement(n.createLogicalAnd(n.createTypeCheck(n.createIdentifier("module"),"object"),n.createTypeCheck(n.createPropertyAccessExpression(n.createIdentifier("module"),"exports"),"object")),n.createBlock([n.createVariableStatement(void 0,[n.createVariableDeclaration("v",void 0,void 0,n.createCallExpression(n.createIdentifier("factory"),void 0,[n.createIdentifier("require"),n.createIdentifier("exports")]))]),Sn(n.createIfStatement(n.createStrictInequality(n.createIdentifier("v"),n.createIdentifier("undefined")),n.createExpressionStatement(n.createAssignment(n.createPropertyAccessExpression(n.createIdentifier("module"),"exports"),n.createIdentifier("v")))),1)]),n.createIfStatement(n.createLogicalAnd(n.createTypeCheck(n.createIdentifier("define"),"function"),n.createPropertyAccessExpression(n.createIdentifier("define"),"amd")),n.createBlock([n.createExpressionStatement(n.createCallExpression(n.createIdentifier("define"),void 0,[...le?[le]:[],n.createArrayLiteralExpression([n.createStringLiteral("require"),n.createStringLiteral("exports"),...Be,...Lt]),n.createIdentifier("factory")]))])))],!0),void 0)),he=n.updateSourceFile(Y,ft(n.createNodeArray([n.createExpressionStatement(n.createCallExpression(X,void 0,[n.createFunctionExpression(void 0,void 0,void 0,void 0,[n.createParameterDeclaration(void 0,void 0,"require"),n.createParameterDeclaration(void 0,void 0,"exports"),...B],void 0,xe(Y))]))]),Y.statements));return Ny(he,e.readEmitHelpers()),he}function se(Y,Be){let Lt=[],B=[],le=[];for(let X of Y.amdDependencies)X.name?(Lt.push(n.createStringLiteral(X.path)),le.push(n.createParameterDeclaration(void 0,void 0,X.name))):B.push(n.createStringLiteral(X.path));for(let X of O.externalImports){let he=ak(n,X,M,S,m,p),qe=QN(n,X,M);he&&(Be&&qe?(Sn(qe,8),Lt.push(he),le.push(n.createParameterDeclaration(void 0,void 0,qe))):B.push(he))}return{aliasedModuleNames:Lt,unaliasedModuleNames:B,importAliasNames:le}}function Se(Y){if(Ru(Y)||yl(Y)||!ak(n,Y,M,S,m,p))return;let Be=QN(n,Y,M),Lt=Ms(Y,Be);if(Lt!==Be)return n.createExpressionStatement(n.createAssignment(Be,Lt))}function xe(Y){s();let Be=[],Lt=n.copyPrologue(Y.statements,Be,!p.noImplicitUseStrict,Q);re()&&Pr(Be,Ot()),de(O.exportedNames)&&Pr(Be,n.createExpressionStatement(d_(O.exportedNames,(le,X)=>n.createAssignment(n.createPropertyAccessExpression(n.createIdentifier("exports"),n.createIdentifier(Nn(X))),le),n.createVoidZero()))),Pr(Be,nt(O.externalHelpersImportDeclaration,Q,ns)),b===2&&jt(Be,Wi(O.externalImports,Se)),jt(Be,Hr(Y.statements,Q,ns,Lt)),Z(Be,!0),C0(Be,o());let B=n.createBlock(Be,!0);return H&&VA(B,PMe),B}function Z(Y,Be){if(O.exportEquals){let Lt=nt(O.exportEquals.expression,we,bt);if(Lt)if(Be){let B=n.createReturnStatement(Lt);ft(B,O.exportEquals),Sn(B,3840),Y.push(B)}else{let B=n.createExpressionStatement(n.createAssignment(n.createPropertyAccessExpression(n.createIdentifier("module"),"exports"),Lt));ft(B,O.exportEquals),Sn(B,3072),Y.push(B)}}}function Q(Y){switch(Y.kind){case 272:return un(Y);case 271:return On(Y);case 278:return _r(Y);case 277:return rt(Y);default:return ce(Y)}}function ce(Y){switch(Y.kind){case 243:return vi(Y);case 262:return zt(Y);case 263:return Rr(Y);case 248:return Me(Y,!0);case 249:return Ge(Y);case 250:return Ae(Y);case 246:return Ie(Y);case 247:return Re(Y);case 256:return Ue(Y);case 254:return kt(Y);case 245:return ke(Y);case 255:return $e(Y);case 269:return at(Y);case 296:return $t(Y);case 297:return St(Y);case 258:return Ze(Y);case 299:return yt(Y);case 241:return ar(Y);default:return we(Y)}}function ye(Y,Be){if(!(Y.transformFlags&276828160))return Y;switch(Y.kind){case 248:return Me(Y,!1);case 244:return or(Y);case 217:return Fr(Y,Be);case 360:return rn(Y,Be);case 213:if(Up(Y)&&M.impliedNodeFormat===void 0)return nr(Y);break;case 226:if(I1(Y))return Ee(Y,Be);break;case 224:case 225:return Tr(Y,Be)}return wr(Y,we,e)}function we(Y){return ye(Y,!1)}function ve(Y){return ye(Y,!0)}function oe(Y){if(Ha(Y))for(let Be of Y.properties)switch(Be.kind){case 303:if(oe(Be.initializer))return!0;break;case 304:if(oe(Be.name))return!0;break;case 305:if(oe(Be.expression))return!0;break;case 174:case 177:case 178:return!1;default:I.assertNever(Be,"Unhandled object member kind")}else if(Z_(Y)){for(let Be of Y.elements)if(fg(Be)){if(oe(Be.expression))return!0}else if(oe(Be))return!0}else if(ze(Y))return de(Sr(Y))>(mU(Y)?1:0);return!1}function Ee(Y,Be){return oe(Y.left)?Tx(Y,we,e,0,!Be,Ni):wr(Y,we,e)}function Me(Y,Be){if(Be&&Y.initializer&&Tu(Y.initializer)&&!(Y.initializer.flags&7)){let Lt=Nr(void 0,Y.initializer,!1);if(Lt){let B=[],le=nt(Y.initializer,ve,Tu),X=n.createVariableStatement(void 0,le);B.push(X),jt(B,Lt);let he=nt(Y.condition,we,bt),qe=nt(Y.incrementor,ve,bt),Le=df(Y.statement,Be?ce:we,e);return B.push(n.updateForStatement(Y,void 0,he,qe,Le)),B}}return n.updateForStatement(Y,nt(Y.initializer,ve,Cd),nt(Y.condition,we,bt),nt(Y.incrementor,ve,bt),df(Y.statement,Be?ce:we,e))}function Ge(Y){if(Tu(Y.initializer)&&!(Y.initializer.flags&7)){let Be=Nr(void 0,Y.initializer,!0);if(Tt(Be)){let Lt=nt(Y.initializer,ve,Cd),B=nt(Y.expression,we,bt),le=df(Y.statement,ce,e),X=ra(le)?n.updateBlock(le,[...Be,...le.statements]):n.createBlock([...Be,le],!0);return n.updateForInStatement(Y,Lt,B,X)}}return n.updateForInStatement(Y,nt(Y.initializer,ve,Cd),nt(Y.expression,we,bt),df(Y.statement,ce,e))}function Ae(Y){if(Tu(Y.initializer)&&!(Y.initializer.flags&7)){let Be=Nr(void 0,Y.initializer,!0),Lt=nt(Y.initializer,ve,Cd),B=nt(Y.expression,we,bt),le=df(Y.statement,ce,e);return Tt(Be)&&(le=ra(le)?n.updateBlock(le,[...Be,...le.statements]):n.createBlock([...Be,le],!0)),n.updateForOfStatement(Y,Y.awaitModifier,Lt,B,le)}return n.updateForOfStatement(Y,Y.awaitModifier,nt(Y.initializer,ve,Cd),nt(Y.expression,we,bt),df(Y.statement,ce,e))}function Ie(Y){return n.updateDoStatement(Y,df(Y.statement,ce,e),nt(Y.expression,we,bt))}function Re(Y){return n.updateWhileStatement(Y,nt(Y.expression,we,bt),df(Y.statement,ce,e))}function Ue(Y){return n.updateLabeledStatement(Y,Y.label,I.checkDefined(nt(Y.statement,ce,ns,n.liftToBlock)))}function kt(Y){return n.updateWithStatement(Y,nt(Y.expression,we,bt),I.checkDefined(nt(Y.statement,ce,ns,n.liftToBlock)))}function ke(Y){return n.updateIfStatement(Y,nt(Y.expression,we,bt),I.checkDefined(nt(Y.thenStatement,ce,ns,n.liftToBlock)),nt(Y.elseStatement,ce,ns,n.liftToBlock))}function $e(Y){return n.updateSwitchStatement(Y,nt(Y.expression,we,bt),I.checkDefined(nt(Y.caseBlock,ce,V6)))}function at(Y){return n.updateCaseBlock(Y,Hr(Y.clauses,ce,R9))}function $t(Y){return n.updateCaseClause(Y,nt(Y.expression,we,bt),Hr(Y.statements,ce,ns))}function St(Y){return wr(Y,ce,e)}function Ze(Y){return wr(Y,ce,e)}function yt(Y){return n.updateCatchClause(Y,Y.variableDeclaration,I.checkDefined(nt(Y.block,ce,ra)))}function ar(Y){return Y=wr(Y,ce,e),Y}function or(Y){return n.updateExpressionStatement(Y,nt(Y.expression,ve,bt))}function Fr(Y,Be){return n.updateParenthesizedExpression(Y,nt(Y.expression,Be?ve:we,bt))}function rn(Y,Be){return n.updatePartiallyEmittedExpression(Y,nt(Y.expression,Be?ve:we,bt))}function Tr(Y,Be){if((Y.operator===46||Y.operator===47)&&ze(Y.operand)&&!yc(Y.operand)&&!Iy(Y.operand)&&!IX(Y.operand)){let Lt=Sr(Y.operand);if(Lt){let B,le=nt(Y.operand,we,bt);eS(Y)?le=n.updatePrefixUnaryExpression(Y,le):(le=n.updatePostfixUnaryExpression(Y,le),Be||(B=n.createTempVariable(l),le=n.createAssignment(B,le),ft(le,Y)),le=n.createComma(le,n.cloneNode(Y.operand)),ft(le,Y));for(let X of Lt)U[yo(le)]=!0,le=Ve(X,le),ft(le,Y);return B&&(U[yo(le)]=!0,le=n.createComma(le,B),ft(le,Y)),le}}return wr(Y,we,e)}function nr(Y){if(b===0&&h>=7)return wr(Y,we,e);let Be=ak(n,Y,M,S,m,p),Lt=nt(qi(Y.arguments),we,bt),B=Be&&(!Lt||!za(Lt)||Lt.text!==Be.text)?Be:Lt,le=!!(Y.transformFlags&16384);switch(p.module){case 2:return ki(B,le);case 3:return tr(B??n.createVoidZero(),le);case 1:default:return xs(B)}}function tr(Y,Be){if(H=!0,TE(Y)){let Lt=yc(Y)?Y:za(Y)?n.createStringLiteralFromNode(Y):Sn(ft(n.cloneNode(Y),Y),3072);return n.createConditionalExpression(n.createIdentifier("__syncRequire"),void 0,xs(Y),void 0,ki(Lt,Be))}else{let Lt=n.createTempVariable(l);return n.createComma(n.createAssignment(Lt,Y),n.createConditionalExpression(n.createIdentifier("__syncRequire"),void 0,xs(Lt,!0),void 0,ki(Lt,Be)))}}function ki(Y,Be){let Lt=n.createUniqueName("resolve"),B=n.createUniqueName("reject"),le=[n.createParameterDeclaration(void 0,void 0,Lt),n.createParameterDeclaration(void 0,void 0,B)],X=n.createBlock([n.createExpressionStatement(n.createCallExpression(n.createIdentifier("require"),void 0,[n.createArrayLiteralExpression([Y||n.createOmittedExpression()]),Lt,B]))]),he;h>=2?he=n.createArrowFunction(void 0,void 0,le,void 0,void 0,X):(he=n.createFunctionExpression(void 0,void 0,void 0,void 0,le,void 0,X),Be&&Sn(he,16));let qe=n.createNewExpression(n.createIdentifier("Promise"),void 0,[he]);return Bh(p)?n.createCallExpression(n.createPropertyAccessExpression(qe,n.createIdentifier("then")),void 0,[i().createImportStarCallbackHelper()]):qe}function xs(Y,Be){let Lt=Y&&!rh(Y)&&!Be,B=n.createCallExpression(n.createPropertyAccessExpression(n.createIdentifier("Promise"),"resolve"),void 0,Lt?h>=2?[n.createTemplateExpression(n.createTemplateHead(""),[n.createTemplateSpan(Y,n.createTemplateTail(""))])]:[n.createCallExpression(n.createPropertyAccessExpression(n.createStringLiteral(""),"concat"),void 0,[Y])]:[]),le=n.createCallExpression(n.createIdentifier("require"),void 0,Lt?[n.createIdentifier("s")]:Y?[Y]:[]);Bh(p)&&(le=i().createImportStarHelper(le));let X=Lt?[n.createParameterDeclaration(void 0,void 0,"s")]:[],he;return h>=2?he=n.createArrowFunction(void 0,void 0,X,void 0,void 0,le):he=n.createFunctionExpression(void 0,void 0,void 0,void 0,X,void 0,n.createBlock([n.createReturnStatement(le)])),n.createCallExpression(n.createPropertyAccessExpression(B,"then"),void 0,[he])}function zi(Y,Be){return!Bh(p)||Lm(Y)&2?Be:_0e(Y)?i().createImportStarHelper(Be):Be}function Ms(Y,Be){return!Bh(p)||Lm(Y)&2?Be:nV(Y)?i().createImportStarHelper(Be):cZ(Y)?i().createImportDefaultHelper(Be):Be}function un(Y){let Be,Lt=gN(Y);if(b!==2)if(Y.importClause){let B=[];Lt&&!xA(Y)?B.push(n.createVariableDeclaration(n.cloneNode(Lt.name),void 0,void 0,Ms(Y,ri(Y)))):(B.push(n.createVariableDeclaration(n.getGeneratedNameForNode(Y),void 0,void 0,Ms(Y,ri(Y)))),Lt&&xA(Y)&&B.push(n.createVariableDeclaration(n.cloneNode(Lt.name),void 0,void 0,n.getGeneratedNameForNode(Y)))),Be=Pr(Be,Un(ft(n.createVariableStatement(void 0,n.createVariableDeclarationList(B,h>=2?2:0)),Y),Y))}else return Un(ft(n.createExpressionStatement(ri(Y)),Y),Y);else Lt&&xA(Y)&&(Be=Pr(Be,n.createVariableStatement(void 0,n.createVariableDeclarationList([Un(ft(n.createVariableDeclaration(n.cloneNode(Lt.name),void 0,void 0,n.getGeneratedNameForNode(Y)),Y),Y)],h>=2?2:0))));return Be=Fs(Be,Y),Op(Be)}function ri(Y){let Be=ak(n,Y,M,S,m,p),Lt=[];return Be&&Lt.push(Be),n.createCallExpression(n.createIdentifier("require"),void 0,Lt)}function On(Y){I.assert(gT(Y),"import= for internal module references should be handled in an earlier transformer.");let Be;return b!==2?ui(Y,32)?Be=Pr(Be,Un(ft(n.createExpressionStatement(Ve(Y.name,ri(Y))),Y),Y)):Be=Pr(Be,Un(ft(n.createVariableStatement(void 0,n.createVariableDeclarationList([n.createVariableDeclaration(n.cloneNode(Y.name),void 0,void 0,ri(Y))],h>=2?2:0)),Y),Y)):ui(Y,32)&&(Be=Pr(Be,Un(ft(n.createExpressionStatement(Ve(n.getExportName(Y),n.getLocalName(Y))),Y),Y))),Be=Ta(Be,Y),Op(Be)}function _r(Y){if(!Y.moduleSpecifier)return;let Be=n.getGeneratedNameForNode(Y);if(Y.exportClause&&wd(Y.exportClause)){let Lt=[];b!==2&&Lt.push(Un(ft(n.createVariableStatement(void 0,n.createVariableDeclarationList([n.createVariableDeclaration(Be,void 0,void 0,ri(Y))])),Y),Y));for(let B of Y.exportClause.elements)if(h===0)Lt.push(Un(ft(n.createExpressionStatement(i().createCreateBindingHelper(Be,n.createStringLiteralFromNode(B.propertyName||B.name),B.propertyName?n.createStringLiteralFromNode(B.name):void 0)),B),B));else{let le=!!Bh(p)&&!(Lm(Y)&2)&&Nn(B.propertyName||B.name)==="default",X=n.createPropertyAccessExpression(le?i().createImportDefaultHelper(Be):Be,B.propertyName||B.name);Lt.push(Un(ft(n.createExpressionStatement(Ve(n.getExportName(B),X,void 0,!0)),B),B))}return Op(Lt)}else if(Y.exportClause){let Lt=[];return Lt.push(Un(ft(n.createExpressionStatement(Ve(n.cloneNode(Y.exportClause.name),zi(Y,b!==2?ri(Y):$9(Y)?Be:n.createIdentifier(Nn(Y.exportClause.name))))),Y),Y)),Op(Lt)}else return Un(ft(n.createExpressionStatement(i().createExportStarHelper(b!==2?ri(Y):Be)),Y),Y)}function rt(Y){if(!Y.isExportEquals)return _e(n.createIdentifier("default"),nt(Y.expression,we,bt),Y,!0)}function zt(Y){let Be;return ui(Y,32)?Be=Pr(Be,Un(ft(n.createFunctionDeclaration(Hr(Y.modifiers,pt,Ra),Y.asteriskToken,n.getDeclarationName(Y,!0,!0),void 0,Hr(Y.parameters,we,Ls),void 0,wr(Y.body,we,e)),Y),Y)):Be=Pr(Be,wr(Y,we,e)),Be=We(Be,Y),Op(Be)}function Rr(Y){let Be;return ui(Y,32)?Be=Pr(Be,Un(ft(n.createClassDeclaration(Hr(Y.modifiers,pt,vc),n.getDeclarationName(Y,!0,!0),void 0,Hr(Y.heritageClauses,we,ad),Hr(Y.members,we,Du)),Y),Y)):Be=Pr(Be,wr(Y,we,e)),Be=We(Be,Y),Op(Be)}function vi(Y){let Be,Lt,B;if(ui(Y,32)){let le,X=!1;for(let he of Y.declarationList.declarations)if(ze(he.name)&&Iy(he.name))if(le||(le=Hr(Y.modifiers,pt,Ra)),he.initializer){let qe=n.updateVariableDeclaration(he,he.name,void 0,void 0,Ve(he.name,nt(he.initializer,we,bt)));Lt=Pr(Lt,qe)}else Lt=Pr(Lt,he);else if(he.initializer)if(!la(he.name)&&(rc(he.initializer)||Xo(he.initializer)||wu(he.initializer))){let qe=n.createAssignment(ft(n.createPropertyAccessExpression(n.createIdentifier("exports"),he.name),he.name),n.createIdentifier(om(he.name))),Le=n.createVariableDeclaration(he.name,he.exclamationToken,he.type,nt(he.initializer,we,bt));Lt=Pr(Lt,Le),B=Pr(B,qe),X=!0}else B=Pr(B,us(he));if(Lt&&(Be=Pr(Be,n.updateVariableStatement(Y,le,n.updateVariableDeclarationList(Y.declarationList,Lt)))),B){let he=Un(ft(n.createExpressionStatement(n.inlineExpressions(B)),Y),Y);X&&xR(he),Be=Pr(Be,he)}}else Be=Pr(Be,wr(Y,we,e));return Be=to(Be,Y),Op(Be)}function Ni(Y,Be,Lt){let B=Sr(Y);if(B){let le=mU(Y)?Be:n.createAssignment(Y,Be);for(let X of B)Sn(le,8),le=Ve(X,le,Lt);return le}return n.createAssignment(Y,Be)}function us(Y){return la(Y.name)?Tx(nt(Y,we,iR),we,e,0,!1,Ni):n.createAssignment(ft(n.createPropertyAccessExpression(n.createIdentifier("exports"),Y.name),Y.name),Y.initializer?nt(Y.initializer,we,bt):n.createVoidZero())}function Fs(Y,Be){if(O.exportEquals)return Y;let Lt=Be.importClause;if(!Lt)return Y;let B=new fk;Lt.name&&(Y=mt(Y,B,Lt));let le=Lt.namedBindings;if(le)switch(le.kind){case 274:Y=mt(Y,B,le);break;case 275:for(let X of le.elements)Y=mt(Y,B,X,!0);break}return Y}function Ta(Y,Be){return O.exportEquals?Y:mt(Y,new fk,Be)}function to(Y,Be){return Nr(Y,Be.declarationList,!1)}function Nr(Y,Be,Lt){if(O.exportEquals)return Y;for(let B of Be.declarations)Y=qr(Y,B,Lt);return Y}function qr(Y,Be,Lt){if(O.exportEquals)return Y;if(la(Be.name))for(let B of Be.name.elements)Su(B)||(Y=qr(Y,B,Lt));else!yc(Be.name)&&(!Gi(Be)||Be.initializer||Lt)&&(Y=mt(Y,new fk,Be));return Y}function We(Y,Be){if(O.exportEquals)return Y;let Lt=new fk;if(ui(Be,32)){let B=ui(Be,2048)?n.createIdentifier("default"):n.getDeclarationName(Be);Y=dt(Y,Lt,B,n.getLocalName(Be),Be)}return Be.name&&(Y=mt(Y,Lt,Be)),Y}function mt(Y,Be,Lt,B){let le=n.getDeclarationName(Lt),X=O.exportSpecifiers.get(le);if(X)for(let he of X)Y=dt(Y,Be,he.name,le,he.name,void 0,B);return Y}function dt(Y,Be,Lt,B,le,X,he){return Be.has(Lt)||(Be.set(Lt,!0),Y=Pr(Y,_e(Lt,B,le,X,he))),Y}function Ot(){let Y;return h===0?Y=n.createExpressionStatement(Ve(n.createIdentifier("__esModule"),n.createTrue())):Y=n.createExpressionStatement(n.createCallExpression(n.createPropertyAccessExpression(n.createIdentifier("Object"),"defineProperty"),void 0,[n.createIdentifier("exports"),n.createStringLiteral("__esModule"),n.createObjectLiteralExpression([n.createPropertyAssignment("value",n.createTrue())])])),Sn(Y,2097152),Y}function _e(Y,Be,Lt,B,le){let X=ft(n.createExpressionStatement(Ve(Y,Be,void 0,le)),Lt);return M_(X),B||Sn(X,3072),X}function Ve(Y,Be,Lt,B){return ft(B&&h!==0?n.createCallExpression(n.createPropertyAccessExpression(n.createIdentifier("Object"),"defineProperty"),void 0,[n.createIdentifier("exports"),n.createStringLiteralFromNode(Y),n.createObjectLiteralExpression([n.createPropertyAssignment("enumerable",n.createTrue()),n.createPropertyAssignment("get",n.createFunctionExpression(void 0,void 0,void 0,void 0,[],void 0,n.createBlock([n.createReturnStatement(Be)])))])]):n.createAssignment(n.createPropertyAccessExpression(n.createIdentifier("exports"),n.cloneNode(Y)),Be),Lt)}function pt(Y){switch(Y.kind){case 95:case 90:return}return Y}function W(Y,Be,Lt){Be.kind===312?(M=Be,O=N[E_(M)],k(Y,Be,Lt),M=void 0,O=void 0):k(Y,Be,Lt)}function st(Y,Be){return Be=A(Y,Be),Be.id&&U[Be.id]?Be:Y===1?Ke(Be):Hf(Be)?Nt(Be):Be}function Nt(Y){let Be=Y.name,Lt=Cr(Be);if(Lt!==Be){if(Y.objectAssignmentInitializer){let B=n.createAssignment(Lt,Y.objectAssignmentInitializer);return ft(n.createPropertyAssignment(Be,B),Y)}return ft(n.createPropertyAssignment(Be,Lt),Y)}return Y}function Ke(Y){switch(Y.kind){case 80:return Cr(Y);case 213:return ht(Y);case 215:return Wt(Y);case 226:return hr(Y)}return Y}function ht(Y){if(ze(Y.expression)){let Be=Cr(Y.expression);if(U[yo(Be)]=!0,!ze(Be)&&!(eo(Y.expression)&8192))return BA(n.updateCallExpression(Y,Be,void 0,Y.arguments),16)}return Y}function Wt(Y){if(ze(Y.tag)){let Be=Cr(Y.tag);if(U[yo(Be)]=!0,!ze(Be)&&!(eo(Y.tag)&8192))return BA(n.updateTaggedTemplateExpression(Y,Be,void 0,Y.template),16)}return Y}function Cr(Y){var Be,Lt;if(eo(Y)&8192){let B=zR(M);return B?n.createPropertyAccessExpression(B,Y):Y}else if(!(yc(Y)&&!(Y.emitNode.autoGenerate.flags&64))&&!Iy(Y)){let B=m.getReferencedExportContainer(Y,mU(Y));if(B&&B.kind===312)return ft(n.createPropertyAccessExpression(n.createIdentifier("exports"),n.cloneNode(Y)),Y);let le=m.getReferencedImportDeclaration(Y);if(le){if(Jh(le))return ft(n.createPropertyAccessExpression(n.getGeneratedNameForNode(le.parent),n.createIdentifier("default")),Y);if(Gf(le)){let X=le.propertyName||le.name;return ft(n.createPropertyAccessExpression(n.getGeneratedNameForNode(((Lt=(Be=le.parent)==null?void 0:Be.parent)==null?void 0:Lt.parent)||le),n.cloneNode(X)),Y)}}}return Y}function hr(Y){if(D1(Y.operatorToken.kind)&&ze(Y.left)&&(!yc(Y.left)||r8(Y.left))&&!Iy(Y.left)){let Be=Sr(Y.left);if(Be){let Lt=Y;for(let B of Be)U[yo(Lt)]=!0,Lt=Ve(B,Lt,Y);return Lt}}return Y}function Sr(Y){if(yc(Y)){if(r8(Y)){let Be=O?.exportSpecifiers.get(Y);if(Be){let Lt=[];for(let B of Be)Lt.push(B.name);return Lt}}}else{let Be=m.getReferencedImportDeclaration(Y);if(Be)return O?.exportedBindings[E_(Be)];let Lt=new Set,B=m.getReferencedValueDeclarations(Y);if(B){for(let le of B){let X=O?.exportedBindings[E_(le)];if(X)for(let he of X)Lt.add(he)}if(Lt.size)return In(Lt)}}}}var PMe,_Tt=f({"src/compiler/transformers/module/module.ts"(){"use strict";fa(),PMe={name:"typescript:dynamicimport-sync-require",scoped:!0,text:`
            var __syncRequire = typeof module === "object" && typeof module.exports === "object";`}}});function z0e(e){let{factory:t,startLexicalEnvironment:n,endLexicalEnvironment:i,hoistVariableDeclaration:s}=e,o=e.getCompilerOptions(),l=e.getEmitResolver(),p=e.getEmitHost(),m=e.onSubstituteNode,S=e.onEmitNode;e.onSubstituteNode=Ve,e.onEmitNode=_e,e.enableSubstitution(80),e.enableSubstitution(304),e.enableSubstitution(226),e.enableSubstitution(236),e.enableEmitNotification(312);let h=[],b=[],A=[],k=[],N,M,O,U,H,K,re;return qm(e,$);function $(Y){if(Y.isDeclarationFile||!(bA(Y,o)||Y.transformFlags&8388608))return Y;let Be=E_(Y);N=Y,K=Y,M=h[Be]=lZ(e,Y),O=t.createUniqueName("exports"),b[Be]=O,U=k[Be]=t.createUniqueName("context");let Lt=pe(M.externalImports),B=z(Y,Lt),le=t.createFunctionExpression(void 0,void 0,void 0,void 0,[t.createParameterDeclaration(void 0,void 0,O),t.createParameterDeclaration(void 0,void 0,U)],void 0,B),X=$R(t,Y,p,o),he=t.createArrayLiteralExpression(vr(Lt,Le=>Le.name)),qe=Sn(t.updateSourceFile(Y,ft(t.createNodeArray([t.createExpressionStatement(t.createCallExpression(t.createPropertyAccessExpression(t.createIdentifier("System"),"register"),void 0,X?[X,he,le]:[he,le]))]),Y.statements)),2048);return Wo(o)||cge(qe,B,Le=>!Le.scoped),re&&(A[Be]=re,re=void 0),N=void 0,M=void 0,O=void 0,U=void 0,H=void 0,K=void 0,qe}function pe(Y){let Be=new Map,Lt=[];for(let B of Y){let le=ak(t,B,N,p,l,o);if(le){let X=le.text,he=Be.get(X);he!==void 0?Lt[he].externalImports.push(B):(Be.set(X,Lt.length),Lt.push({name:le,externalImports:[B]}))}}return Lt}function z(Y,Be){let Lt=[];n();let B=K_(o,"alwaysStrict")||!o.noImplicitUseStrict&&Pl(N),le=t.copyPrologue(Y.statements,Lt,B,Z);Lt.push(t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration("__moduleName",void 0,void 0,t.createLogicalAnd(U,t.createPropertyAccessExpression(U,"id")))]))),nt(M.externalHelpersImportDeclaration,Z,ns);let X=Hr(Y.statements,Z,ns,le);jt(Lt,H),C0(Lt,i());let he=se(Lt),qe=Y.transformFlags&2097152?t.createModifiersFromModifierFlags(1024):void 0,Le=t.createObjectLiteralExpression([t.createPropertyAssignment("setters",xe(he,Be)),t.createPropertyAssignment("execute",t.createFunctionExpression(qe,void 0,void 0,void 0,[],void 0,t.createBlock(X,!0)))],!0);return Lt.push(t.createReturnStatement(Le)),t.createBlock(Lt,!0)}function se(Y){if(!M.hasExportStarsToExportValues)return;if(!M.exportedNames&&M.exportSpecifiers.size===0){let le=!1;for(let X of M.externalImports)if(X.kind===278&&X.exportClause){le=!0;break}if(!le){let X=Se(void 0);return Y.push(X),X.name}}let Be=[];if(M.exportedNames)for(let le of M.exportedNames)le.escapedText!=="default"&&Be.push(t.createPropertyAssignment(t.createStringLiteralFromNode(le),t.createTrue()));let Lt=t.createUniqueName("exportedNames");Y.push(t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(Lt,void 0,void 0,t.createObjectLiteralExpression(Be,!0))])));let B=Se(Lt);return Y.push(B),B.name}function Se(Y){let Be=t.createUniqueName("exportStar"),Lt=t.createIdentifier("m"),B=t.createIdentifier("n"),le=t.createIdentifier("exports"),X=t.createStrictInequality(B,t.createStringLiteral("default"));return Y&&(X=t.createLogicalAnd(X,t.createLogicalNot(t.createCallExpression(t.createPropertyAccessExpression(Y,"hasOwnProperty"),void 0,[B])))),t.createFunctionDeclaration(void 0,void 0,Be,void 0,[t.createParameterDeclaration(void 0,void 0,Lt)],void 0,t.createBlock([t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(le,void 0,void 0,t.createObjectLiteralExpression([]))])),t.createForInStatement(t.createVariableDeclarationList([t.createVariableDeclaration(B)]),Lt,t.createBlock([Sn(t.createIfStatement(X,t.createExpressionStatement(t.createAssignment(t.createElementAccessExpression(le,B),t.createElementAccessExpression(Lt,B)))),1)])),t.createExpressionStatement(t.createCallExpression(O,void 0,[le]))],!0))}function xe(Y,Be){let Lt=[];for(let B of Be){let le=Te(B.externalImports,qe=>QN(t,qe,N)),X=le?t.getGeneratedNameForNode(le):t.createUniqueName(""),he=[];for(let qe of B.externalImports){let Le=QN(t,qe,N);switch(qe.kind){case 272:if(!qe.importClause)break;case 271:I.assert(Le!==void 0),he.push(t.createExpressionStatement(t.createAssignment(Le,X))),ui(qe,32)&&he.push(t.createExpressionStatement(t.createCallExpression(O,void 0,[t.createStringLiteral(Nn(Le)),X])));break;case 278:if(I.assert(Le!==void 0),qe.exportClause)if(wd(qe.exportClause)){let It=[];for(let Rt of qe.exportClause.elements)It.push(t.createPropertyAssignment(t.createStringLiteral(Nn(Rt.name)),t.createElementAccessExpression(X,t.createStringLiteral(Nn(Rt.propertyName||Rt.name)))));he.push(t.createExpressionStatement(t.createCallExpression(O,void 0,[t.createObjectLiteralExpression(It,!0)])))}else he.push(t.createExpressionStatement(t.createCallExpression(O,void 0,[t.createStringLiteral(Nn(qe.exportClause.name)),X])));else he.push(t.createExpressionStatement(t.createCallExpression(Y,void 0,[X])));break}}Lt.push(t.createFunctionExpression(void 0,void 0,void 0,void 0,[t.createParameterDeclaration(void 0,void 0,X)],void 0,t.createBlock(he,!0)))}return t.createArrayLiteralExpression(Lt,!0)}function Z(Y){switch(Y.kind){case 272:return Q(Y);case 271:return ye(Y);case 278:return ce(Y);case 277:return we(Y);default:return or(Y)}}function Q(Y){let Be;return Y.importClause&&s(QN(t,Y,N)),Op(kt(Be,Y))}function ce(Y){I.assertIsDefined(Y)}function ye(Y){I.assert(gT(Y),"import= for internal module references should be handled in an earlier transformer.");let Be;return s(QN(t,Y,N)),Op(ke(Be,Y))}function we(Y){if(Y.isExportEquals)return;let Be=nt(Y.expression,us,bt);return yt(t.createIdentifier("default"),Be,!0)}function ve(Y){ui(Y,32)?H=Pr(H,t.updateFunctionDeclaration(Y,Hr(Y.modifiers,Ot,vc),Y.asteriskToken,t.getDeclarationName(Y,!0,!0),void 0,Hr(Y.parameters,us,Ls),void 0,nt(Y.body,us,ra))):H=Pr(H,wr(Y,us,e)),H=$t(H,Y)}function oe(Y){let Be,Lt=t.getLocalName(Y);return s(Lt),Be=Pr(Be,ft(t.createExpressionStatement(t.createAssignment(Lt,ft(t.createClassExpression(Hr(Y.modifiers,Ot,vc),Y.name,void 0,Hr(Y.heritageClauses,us,ad),Hr(Y.members,us,Du)),Y))),Y)),Be=$t(Be,Y),Op(Be)}function Ee(Y){if(!Ge(Y.declarationList))return nt(Y,us,ns);let Be;if(S8(Y.declarationList)||v8(Y.declarationList)){let Lt=Hr(Y.modifiers,Ot,vc),B=[];for(let X of Y.declarationList.declarations)B.push(t.updateVariableDeclaration(X,t.getGeneratedNameForNode(X.name),void 0,void 0,Ae(X,!1)));let le=t.updateVariableDeclarationList(Y.declarationList,B);Be=Pr(Be,t.updateVariableStatement(Y,Lt,le))}else{let Lt,B=ui(Y,32);for(let le of Y.declarationList.declarations)le.initializer?Lt=Pr(Lt,Ae(le,B)):Me(le);Lt&&(Be=Pr(Be,ft(t.createExpressionStatement(t.inlineExpressions(Lt)),Y)))}return Be=$e(Be,Y,!1),Op(Be)}function Me(Y){if(la(Y.name))for(let Be of Y.name.elements)Su(Be)||Me(Be);else s(t.cloneNode(Y.name))}function Ge(Y){return(eo(Y)&4194304)===0&&(K.kind===312||(Hc(Y).flags&7)===0)}function Ae(Y,Be){let Lt=Be?Ie:Re;return la(Y.name)?Tx(Y,us,e,0,!1,Lt):Y.initializer?Lt(Y.name,nt(Y.initializer,us,bt)):Y.name}function Ie(Y,Be,Lt){return Ue(Y,Be,Lt,!0)}function Re(Y,Be,Lt){return Ue(Y,Be,Lt,!1)}function Ue(Y,Be,Lt,B){return s(t.cloneNode(Y)),B?ar(Y,hr(ft(t.createAssignment(Y,Be),Lt))):hr(ft(t.createAssignment(Y,Be),Lt))}function kt(Y,Be){if(M.exportEquals)return Y;let Lt=Be.importClause;if(!Lt)return Y;Lt.name&&(Y=St(Y,Lt));let B=Lt.namedBindings;if(B)switch(B.kind){case 274:Y=St(Y,B);break;case 275:for(let le of B.elements)Y=St(Y,le);break}return Y}function ke(Y,Be){return M.exportEquals?Y:St(Y,Be)}function $e(Y,Be,Lt){if(M.exportEquals)return Y;for(let B of Be.declarationList.declarations)(B.initializer||Lt)&&(Y=at(Y,B,Lt));return Y}function at(Y,Be,Lt){if(M.exportEquals)return Y;if(la(Be.name))for(let B of Be.name.elements)Su(B)||(Y=at(Y,B,Lt));else if(!yc(Be.name)){let B;Lt&&(Y=Ze(Y,Be.name,t.getLocalName(Be)),B=Nn(Be.name)),Y=St(Y,Be,B)}return Y}function $t(Y,Be){if(M.exportEquals)return Y;let Lt;if(ui(Be,32)){let B=ui(Be,2048)?t.createStringLiteral("default"):Be.name;Y=Ze(Y,B,t.getLocalName(Be)),Lt=om(B)}return Be.name&&(Y=St(Y,Be,Lt)),Y}function St(Y,Be,Lt){if(M.exportEquals)return Y;let B=t.getDeclarationName(Be),le=M.exportSpecifiers.get(B);if(le)for(let X of le)X.name.escapedText!==Lt&&(Y=Ze(Y,X.name,B));return Y}function Ze(Y,Be,Lt,B){return Y=Pr(Y,yt(Be,Lt,B)),Y}function yt(Y,Be,Lt){let B=t.createExpressionStatement(ar(Y,Be));return M_(B),Lt||Sn(B,3072),B}function ar(Y,Be){let Lt=ze(Y)?t.createStringLiteralFromNode(Y):Y;return Sn(Be,eo(Be)|3072),kl(t.createCallExpression(O,void 0,[Lt,Be]),Be)}function or(Y){switch(Y.kind){case 243:return Ee(Y);case 262:return ve(Y);case 263:return oe(Y);case 248:return Fr(Y,!0);case 249:return rn(Y);case 250:return Tr(Y);case 246:return ki(Y);case 247:return xs(Y);case 256:return zi(Y);case 254:return Ms(Y);case 245:return un(Y);case 255:return ri(Y);case 269:return On(Y);case 296:return _r(Y);case 297:return rt(Y);case 258:return zt(Y);case 299:return Rr(Y);case 241:return vi(Y);default:return us(Y)}}function Fr(Y,Be){let Lt=K;return K=Y,Y=t.updateForStatement(Y,nt(Y.initializer,Be?tr:Fs,Cd),nt(Y.condition,us,bt),nt(Y.incrementor,Fs,bt),df(Y.statement,Be?or:us,e)),K=Lt,Y}function rn(Y){let Be=K;return K=Y,Y=t.updateForInStatement(Y,tr(Y.initializer),nt(Y.expression,us,bt),df(Y.statement,or,e)),K=Be,Y}function Tr(Y){let Be=K;return K=Y,Y=t.updateForOfStatement(Y,Y.awaitModifier,tr(Y.initializer),nt(Y.expression,us,bt),df(Y.statement,or,e)),K=Be,Y}function nr(Y){return Tu(Y)&&Ge(Y)}function tr(Y){if(nr(Y)){let Be;for(let Lt of Y.declarations)Be=Pr(Be,Ae(Lt,!1)),Lt.initializer||Me(Lt);return Be?t.inlineExpressions(Be):t.createOmittedExpression()}else return nt(Y,Fs,Cd)}function ki(Y){return t.updateDoStatement(Y,df(Y.statement,or,e),nt(Y.expression,us,bt))}function xs(Y){return t.updateWhileStatement(Y,nt(Y.expression,us,bt),df(Y.statement,or,e))}function zi(Y){return t.updateLabeledStatement(Y,Y.label,I.checkDefined(nt(Y.statement,or,ns,t.liftToBlock)))}function Ms(Y){return t.updateWithStatement(Y,nt(Y.expression,us,bt),I.checkDefined(nt(Y.statement,or,ns,t.liftToBlock)))}function un(Y){return t.updateIfStatement(Y,nt(Y.expression,us,bt),I.checkDefined(nt(Y.thenStatement,or,ns,t.liftToBlock)),nt(Y.elseStatement,or,ns,t.liftToBlock))}function ri(Y){return t.updateSwitchStatement(Y,nt(Y.expression,us,bt),I.checkDefined(nt(Y.caseBlock,or,V6)))}function On(Y){let Be=K;return K=Y,Y=t.updateCaseBlock(Y,Hr(Y.clauses,or,R9)),K=Be,Y}function _r(Y){return t.updateCaseClause(Y,nt(Y.expression,us,bt),Hr(Y.statements,or,ns))}function rt(Y){return wr(Y,or,e)}function zt(Y){return wr(Y,or,e)}function Rr(Y){let Be=K;return K=Y,Y=t.updateCatchClause(Y,Y.variableDeclaration,I.checkDefined(nt(Y.block,or,ra))),K=Be,Y}function vi(Y){let Be=K;return K=Y,Y=wr(Y,or,e),K=Be,Y}function Ni(Y,Be){if(!(Y.transformFlags&276828160))return Y;switch(Y.kind){case 248:return Fr(Y,!1);case 244:return Ta(Y);case 217:return to(Y,Be);case 360:return Nr(Y,Be);case 226:if(I1(Y))return We(Y,Be);break;case 213:if(Up(Y))return qr(Y);break;case 224:case 225:return dt(Y,Be)}return wr(Y,us,e)}function us(Y){return Ni(Y,!1)}function Fs(Y){return Ni(Y,!0)}function Ta(Y){return t.updateExpressionStatement(Y,nt(Y.expression,Fs,bt))}function to(Y,Be){return t.updateParenthesizedExpression(Y,nt(Y.expression,Be?Fs:us,bt))}function Nr(Y,Be){return t.updatePartiallyEmittedExpression(Y,nt(Y.expression,Be?Fs:us,bt))}function qr(Y){let Be=ak(t,Y,N,p,l,o),Lt=nt(qi(Y.arguments),us,bt),B=Be&&(!Lt||!za(Lt)||Lt.text!==Be.text)?Be:Lt;return t.createCallExpression(t.createPropertyAccessExpression(U,t.createIdentifier("import")),void 0,B?[B]:[])}function We(Y,Be){return mt(Y.left)?Tx(Y,us,e,0,!Be):wr(Y,us,e)}function mt(Y){if(lu(Y,!0))return mt(Y.left);if(fg(Y))return mt(Y.expression);if(Ha(Y))return Tt(Y.properties,mt);if(Z_(Y))return Tt(Y.elements,mt);if(Hf(Y))return mt(Y.name);if(Ul(Y))return mt(Y.initializer);if(ze(Y)){let Be=l.getReferencedExportContainer(Y);return Be!==void 0&&Be.kind===312}else return!1}function dt(Y,Be){if((Y.operator===46||Y.operator===47)&&ze(Y.operand)&&!yc(Y.operand)&&!Iy(Y.operand)&&!IX(Y.operand)){let Lt=Wt(Y.operand);if(Lt){let B,le=nt(Y.operand,us,bt);eS(Y)?le=t.updatePrefixUnaryExpression(Y,le):(le=t.updatePostfixUnaryExpression(Y,le),Be||(B=t.createTempVariable(s),le=t.createAssignment(B,le),ft(le,Y)),le=t.createComma(le,t.cloneNode(Y.operand)),ft(le,Y));for(let X of Lt)le=ar(X,hr(le));return B&&(le=t.createComma(le,B),ft(le,Y)),le}}return wr(Y,us,e)}function Ot(Y){switch(Y.kind){case 95:case 90:return}return Y}function _e(Y,Be,Lt){if(Be.kind===312){let B=E_(Be);N=Be,M=h[B],O=b[B],re=A[B],U=k[B],re&&delete A[B],S(Y,Be,Lt),N=void 0,M=void 0,O=void 0,U=void 0,re=void 0}else S(Y,Be,Lt)}function Ve(Y,Be){return Be=m(Y,Be),Sr(Be)?Be:Y===1?st(Be):Y===4?pt(Be):Be}function pt(Y){switch(Y.kind){case 304:return W(Y)}return Y}function W(Y){var Be,Lt;let B=Y.name;if(!yc(B)&&!Iy(B)){let le=l.getReferencedImportDeclaration(B);if(le){if(Jh(le))return ft(t.createPropertyAssignment(t.cloneNode(B),t.createPropertyAccessExpression(t.getGeneratedNameForNode(le.parent),t.createIdentifier("default"))),Y);if(Gf(le))return ft(t.createPropertyAssignment(t.cloneNode(B),t.createPropertyAccessExpression(t.getGeneratedNameForNode(((Lt=(Be=le.parent)==null?void 0:Be.parent)==null?void 0:Lt.parent)||le),t.cloneNode(le.propertyName||le.name))),Y)}}return Y}function st(Y){switch(Y.kind){case 80:return Nt(Y);case 226:return Ke(Y);case 236:return ht(Y)}return Y}function Nt(Y){var Be,Lt;if(eo(Y)&8192){let B=zR(N);return B?t.createPropertyAccessExpression(B,Y):Y}if(!yc(Y)&&!Iy(Y)){let B=l.getReferencedImportDeclaration(Y);if(B){if(Jh(B))return ft(t.createPropertyAccessExpression(t.getGeneratedNameForNode(B.parent),t.createIdentifier("default")),Y);if(Gf(B))return ft(t.createPropertyAccessExpression(t.getGeneratedNameForNode(((Lt=(Be=B.parent)==null?void 0:Be.parent)==null?void 0:Lt.parent)||B),t.cloneNode(B.propertyName||B.name)),Y)}}return Y}function Ke(Y){if(D1(Y.operatorToken.kind)&&ze(Y.left)&&(!yc(Y.left)||r8(Y.left))&&!Iy(Y.left)){let Be=Wt(Y.left);if(Be){let Lt=Y;for(let B of Be)Lt=ar(B,hr(Lt));return Lt}}return Y}function ht(Y){return oN(Y)?t.createPropertyAccessExpression(U,t.createIdentifier("meta")):Y}function Wt(Y){let Be,Lt=Cr(Y);if(Lt){let B=l.getReferencedExportContainer(Y,!1);B&&B.kind===312&&(Be=Pr(Be,t.getDeclarationName(Lt))),Be=jt(Be,M?.exportedBindings[E_(Lt)])}else if(yc(Y)&&r8(Y)){let B=M?.exportSpecifiers.get(Y);if(B){let le=[];for(let X of B)le.push(X.name);return le}}return Be}function Cr(Y){if(!yc(Y)){let Be=l.getReferencedImportDeclaration(Y);if(Be)return Be;let Lt=l.getReferencedValueDeclaration(Y);if(Lt&&M?.exportedBindings[E_(Lt)])return Lt;let B=l.getReferencedValueDeclarations(Y);if(B){for(let le of B)if(le!==Lt&&M?.exportedBindings[E_(le)])return le}return Lt}}function hr(Y){return re===void 0&&(re=[]),re[yo(Y)]=!0,Y}function Sr(Y){return re&&Y.id&&re[Y.id]}}var fTt=f({"src/compiler/transformers/module/system.ts"(){"use strict";fa()}});function TZ(e){let{factory:t,getEmitHelperFactory:n}=e,i=e.getEmitHost(),s=e.getEmitResolver(),o=e.getCompilerOptions(),l=ho(o),p=e.onEmitNode,m=e.onSubstituteNode;e.onEmitNode=re,e.onSubstituteNode=$,e.enableEmitNotification(312),e.enableSubstitution(80);let S,h,b;return qm(e,A);function A(z){if(z.isDeclarationFile)return z;if(Pl(z)||fm(o)){h=z,b=void 0;let se=k(z);return h=void 0,b&&(se=t.updateSourceFile(se,ft(t.createNodeArray(EY(se.statements.slice(),b)),se.statements))),!Pl(z)||T_(o)===200||Tt(se.statements,o8)?se:t.updateSourceFile(se,ft(t.createNodeArray([...se.statements,VR(t)]),se.statements))}return z}function k(z){let se=eQ(t,n(),z,o);if(se){let Se=[],xe=t.copyPrologue(z.statements,Se);return Pr(Se,se),jt(Se,Hr(z.statements,N,ns,xe)),t.updateSourceFile(z,ft(t.createNodeArray(Se),z.statements))}else return wr(z,N,e)}function N(z){switch(z.kind){case 271:return T_(o)>=100?O(z):void 0;case 277:return H(z);case 278:return K(z)}return z}function M(z){let se=ak(t,z,I.checkDefined(h),i,s,o),Se=[];if(se&&Se.push(se),T_(o)===200)return t.createCallExpression(t.createIdentifier("require"),void 0,Se);if(!b){let Z=t.createUniqueName("_createRequire",48),Q=t.createImportDeclaration(void 0,t.createImportClause(!1,void 0,t.createNamedImports([t.createImportSpecifier(!1,t.createIdentifier("createRequire"),Z)])),t.createStringLiteral("module"),void 0),ce=t.createUniqueName("__require",48),ye=t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(ce,void 0,void 0,t.createCallExpression(t.cloneNode(Z),void 0,[t.createPropertyAccessExpression(t.createMetaProperty(102,t.createIdentifier("meta")),t.createIdentifier("url"))]))],l>=2?2:0));b=[Q,ye]}let xe=b[1].declarationList.declarations[0].name;return I.assertNode(xe,ze),t.createCallExpression(t.cloneNode(xe),void 0,Se)}function O(z){I.assert(gT(z),"import= for internal module references should be handled in an earlier transformer.");let se;return se=Pr(se,Un(ft(t.createVariableStatement(void 0,t.createVariableDeclarationList([t.createVariableDeclaration(t.cloneNode(z.name),void 0,void 0,M(z))],l>=2?2:0)),z),z)),se=U(se,z),Op(se)}function U(z,se){return ui(se,32)&&(z=Pr(z,t.createExportDeclaration(void 0,se.isTypeOnly,t.createNamedExports([t.createExportSpecifier(!1,void 0,Nn(se.name))])))),z}function H(z){return z.isExportEquals?T_(o)===200?Un(t.createExpressionStatement(t.createAssignment(t.createPropertyAccessExpression(t.createIdentifier("module"),"exports"),z.expression)),z):void 0:z}function K(z){if(o.module!==void 0&&o.module>5||!z.exportClause||!qh(z.exportClause)||!z.moduleSpecifier)return z;let se=z.exportClause.name,Se=t.getGeneratedNameForNode(se),xe=t.createImportDeclaration(void 0,t.createImportClause(!1,void 0,t.createNamespaceImport(Se)),z.moduleSpecifier,z.attributes);Un(xe,z.exportClause);let Z=$9(z)?t.createExportDefault(Se):t.createExportDeclaration(void 0,!1,t.createNamedExports([t.createExportSpecifier(!1,Se,se)]));return Un(Z,z),[xe,Z]}function re(z,se,Se){ls(se)?((Pl(se)||fm(o))&&o.importHelpers&&(S=new Map),p(z,se,Se),S=void 0):p(z,se,Se)}function $(z,se){return se=m(z,se),S&&ze(se)&&eo(se)&8192?pe(se):se}function pe(z){let se=Nn(z),Se=S.get(se);return Se||S.set(se,Se=t.createUniqueName(se,48)),Se}}var pTt=f({"src/compiler/transformers/module/esnextAnd2015.ts"(){"use strict";fa()}});function $0e(e){let t=e.onSubstituteNode,n=e.onEmitNode,i=TZ(e),s=e.onSubstituteNode,o=e.onEmitNode;e.onSubstituteNode=t,e.onEmitNode=n;let l=SZ(e),p=e.onSubstituteNode,m=e.onEmitNode;e.onSubstituteNode=h,e.onEmitNode=b,e.enableSubstitution(312),e.enableEmitNotification(312);let S;return N;function h(O,U){return ls(U)?(S=U,t(O,U)):S?S.impliedNodeFormat===99?s(O,U):p(O,U):t(O,U)}function b(O,U,H){return ls(U)&&(S=U),S?S.impliedNodeFormat===99?o(O,U,H):m(O,U,H):n(O,U,H)}function A(O){return O.impliedNodeFormat===99?i:l}function k(O){if(O.isDeclarationFile)return O;S=O;let U=A(O)(O);return S=void 0,I.assert(ls(U)),U}function N(O){return O.kind===312?k(O):M(O)}function M(O){return e.factory.createBundle(vr(O.sourceFiles,k),O.prepends)}}var dTt=f({"src/compiler/transformers/module/node.ts"(){"use strict";fa()}});function _V(e){return Gi(e)||ea(e)||fp(e)||co(e)||A1(e)||Fv(e)||OR(e)||HA(e)||pl(e)||Uh(e)||Zl(e)||Ls(e)||Nc(e)||L1(e)||Ru(e)||Vm(e)||Yc(e)||oE(e)||Hn(e)||fc(e)||bn(e)||am(e)}function W0e(e){if(A1(e)||Fv(e))return t;return Uh(e)||pl(e)?i:j1(e);function t(o){let l=n(o);return l!==void 0?{diagnosticMessage:l,errorNode:e,typeName:e.name}:void 0}function n(o){return pa(e)?o.errorModuleName?o.accessibility===2?g.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:g.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:e.parent.kind===263?o.errorModuleName?o.accessibility===2?g.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:g.Public_property_0_of_exported_class_has_or_is_using_private_name_1:o.errorModuleName?g.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:g.Property_0_of_exported_interface_has_or_is_using_private_name_1}function i(o){let l=s(o);return l!==void 0?{diagnosticMessage:l,errorNode:e,typeName:e.name}:void 0}function s(o){return pa(e)?o.errorModuleName?o.accessibility===2?g.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:g.Public_static_method_0_of_exported_class_has_or_is_using_private_name_1:e.parent.kind===263?o.errorModuleName?o.accessibility===2?g.Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:g.Public_method_0_of_exported_class_has_or_is_using_private_name_1:o.errorModuleName?g.Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:g.Method_0_of_exported_interface_has_or_is_using_private_name_1}}function j1(e){if(Gi(e)||ea(e)||fp(e)||Hn(e)||fc(e)||bn(e)||co(e)||Yc(e))return n;return A1(e)||Fv(e)?i:OR(e)||HA(e)||pl(e)||Uh(e)||Zl(e)||oE(e)?s:Ls(e)?op(e,e.parent)&&ui(e.parent,2)?n:o:Nc(e)?p:L1(e)?m:Ru(e)?S:Vm(e)||am(e)?h:I.assertNever(e,`Attempted to set a declaration diagnostic context for unhandled node kind: ${I.formatSyntaxKind(e.kind)}`);function t(b){if(e.kind===260||e.kind===208)return b.errorModuleName?b.accessibility===2?g.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Exported_variable_0_has_or_is_using_name_1_from_private_module_2:g.Exported_variable_0_has_or_is_using_private_name_1;if(e.kind===172||e.kind===211||e.kind===212||e.kind===226||e.kind===171||e.kind===169&&ui(e.parent,2))return pa(e)?b.errorModuleName?b.accessibility===2?g.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:g.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:e.parent.kind===263||e.kind===169?b.errorModuleName?b.accessibility===2?g.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:g.Public_property_0_of_exported_class_has_or_is_using_private_name_1:b.errorModuleName?g.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:g.Property_0_of_exported_interface_has_or_is_using_private_name_1}function n(b){let A=t(b);return A!==void 0?{diagnosticMessage:A,errorNode:e,typeName:e.name}:void 0}function i(b){let A;return e.kind===178?pa(e)?A=b.errorModuleName?g.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:g.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1:A=b.errorModuleName?g.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:g.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1:pa(e)?A=b.errorModuleName?b.accessibility===2?g.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:g.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1:A=b.errorModuleName?b.accessibility===2?g.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2:g.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1,{diagnosticMessage:A,errorNode:e.name,typeName:e.name}}function s(b){let A;switch(e.kind){case 180:A=b.errorModuleName?g.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:g.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 179:A=b.errorModuleName?g.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:g.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 181:A=b.errorModuleName?g.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:g.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 174:case 173:pa(e)?A=b.errorModuleName?b.accessibility===2?g.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:g.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:g.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0:e.parent.kind===263?A=b.errorModuleName?b.accessibility===2?g.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:g.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:g.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0:A=b.errorModuleName?g.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1:g.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;break;case 262:A=b.errorModuleName?b.accessibility===2?g.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:g.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1:g.Return_type_of_exported_function_has_or_is_using_private_name_0;break;default:return I.fail("This is unknown kind for signature: "+e.kind)}return{diagnosticMessage:A,errorNode:e.name||e}}function o(b){let A=l(b);return A!==void 0?{diagnosticMessage:A,errorNode:e,typeName:e.name}:void 0}function l(b){switch(e.parent.kind){case 176:return b.errorModuleName?b.accessibility===2?g.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2:g.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;case 180:case 185:return b.errorModuleName?g.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:g.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;case 179:return b.errorModuleName?g.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:g.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;case 181:return b.errorModuleName?g.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:g.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1;case 174:case 173:return pa(e.parent)?b.errorModuleName?b.accessibility===2?g.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:g.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:e.parent.parent.kind===263?b.errorModuleName?b.accessibility===2?g.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:g.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:b.errorModuleName?g.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2:g.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;case 262:case 184:return b.errorModuleName?b.accessibility===2?g.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2:g.Parameter_0_of_exported_function_has_or_is_using_private_name_1;case 178:case 177:return b.errorModuleName?b.accessibility===2?g.Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:g.Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2:g.Parameter_0_of_accessor_has_or_is_using_private_name_1;default:return I.fail(`Unknown parent for parameter: ${I.formatSyntaxKind(e.parent.kind)}`)}}function p(){let b;switch(e.parent.kind){case 263:b=g.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;break;case 264:b=g.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;break;case 200:b=g.Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1;break;case 185:case 180:b=g.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;break;case 179:b=g.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;break;case 174:case 173:pa(e.parent)?b=g.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:e.parent.parent.kind===263?b=g.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:b=g.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;break;case 184:case 262:b=g.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;break;case 195:b=g.Extends_clause_for_inferred_type_0_has_or_is_using_private_name_1;break;case 265:b=g.Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1;break;default:return I.fail("This is unknown parent for type parameter: "+e.parent.kind)}return{diagnosticMessage:b,errorNode:e,typeName:e.name}}function m(){let b;return eu(e.parent.parent)?b=ad(e.parent)&&e.parent.token===119?g.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1:e.parent.parent.name?g.extends_clause_of_exported_class_0_has_or_is_using_private_name_1:g.extends_clause_of_exported_class_has_or_is_using_private_name_0:b=g.extends_clause_of_exported_interface_0_has_or_is_using_private_name_1,{diagnosticMessage:b,errorNode:e,typeName:qs(e.parent.parent)}}function S(){return{diagnosticMessage:g.Import_declaration_0_is_using_private_name_1,errorNode:e,typeName:e.name}}function h(b){return{diagnosticMessage:b.errorModuleName?g.Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2:g.Exported_type_alias_0_has_or_is_using_private_name_1,errorNode:am(e)?I.checkDefined(e.typeExpression):e.type,typeName:am(e)?qs(e):e.name}}}var mTt=f({"src/compiler/transformers/declarations/diagnostics.ts"(){"use strict";fa()}});function G0e(e,t,n){let i=e.getCompilerOptions();return CM(t,e,j,i,n?[n]:Fn(e.getSourceFiles(),$Y),[bZ],!1).diagnostics}function bZ(e){let t=()=>I.fail("Diagnostic emitted without context"),n=t,i=!0,s=!1,o=!1,l=!1,p=!1,m,S,h,b,A,k,{factory:N}=e,M=e.getEmitHost(),O={trackSymbol:ve,reportInaccessibleThisError:Ae,reportInaccessibleUniqueSymbolError:Me,reportCyclicStructureError:Ge,reportPrivateInBaseOfClassExpression:oe,reportLikelyUnsafeImportRequiredError:Ie,reportTruncationError:Re,moduleResolverHost:M,trackReferencedAmbientModule:Q,trackExternalModuleSymbolOfImportTypeNode:we,reportNonlocalAugmentation:Ue,reportNonSerializableProperty:kt},U,H,K,re,$,pe,z=e.getEmitResolver(),se=e.getCompilerOptions(),{noResolve:Se,stripInternal:xe}=se;return $e;function Z(W){if(W){S=S||new Set;for(let st of W)S.add(st)}}function Q(W,st){let Nt=z.getTypeReferenceDirectivesForSymbol(st,-1);if(de(Nt))return Z(Nt);let Ke=Xr(W);re.set(E_(Ke),Ke)}function ce(W){let st=dN(W),Nt=st&&z.tryFindAmbientModule(st);if(Nt?.declarations)for(let Ke of Nt.declarations)S_(Ke)&&Xr(Ke)!==K&&Q(Ke,Nt)}function ye(W){if(W.accessibility===0){if(W.aliasesToMakeVisible)if(!h)h=W.aliasesToMakeVisible;else for(let st of W.aliasesToMakeVisible)ln(h,st)}else{let st=n(W);if(st)return st.typeName?e.addDiagnostic($n(W.errorNode||st.errorNode,st.diagnosticMessage,Fl(st.typeName),W.errorSymbolName,W.errorModuleName)):e.addDiagnostic($n(W.errorNode||st.errorNode,st.diagnosticMessage,W.errorSymbolName,W.errorModuleName)),!0}return!1}function we(W){s||(k||(k=[])).push(W)}function ve(W,st,Nt){if(W.flags&262144)return!1;let Ke=ye(z.isSymbolAccessible(W,st,Nt,!0));return Z(z.getTypeReferenceDirectivesForSymbol(W,Nt)),Ke}function oe(W){(U||H)&&e.addDiagnostic($n(U||H,g.Property_0_of_exported_class_expression_may_not_be_private_or_protected,W))}function Ee(){return U?qo(U):H&&qs(H)?qo(qs(H)):H&&Kc(H)?H.isExportEquals?"export=":"default":"(Missing)"}function Me(){(U||H)&&e.addDiagnostic($n(U||H,g.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary,Ee(),"unique symbol"))}function Ge(){(U||H)&&e.addDiagnostic($n(U||H,g.The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary,Ee()))}function Ae(){(U||H)&&e.addDiagnostic($n(U||H,g.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary,Ee(),"this"))}function Ie(W){(U||H)&&e.addDiagnostic($n(U||H,g.The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary,Ee(),W))}function Re(){(U||H)&&e.addDiagnostic($n(U||H,g.The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed))}function Ue(W,st,Nt){var Ke;let ht=(Ke=st.declarations)==null?void 0:Ke.find(Cr=>Xr(Cr)===W),Wt=Fn(Nt.declarations,Cr=>Xr(Cr)!==W);if(ht&&Wt)for(let Cr of Wt)e.addDiagnostic(Ga($n(Cr,g.Declaration_augments_declaration_in_another_file_This_cannot_be_serialized),$n(ht,g.This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file)))}function kt(W){(U||H)&&e.addDiagnostic($n(U||H,g.The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized,W))}function ke(W,st){let Nt=n;n=ht=>ht.errorNode&&_V(ht.errorNode)?j1(ht.errorNode)(ht):{diagnosticMessage:ht.errorModuleName?g.Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit:g.Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit,errorNode:ht.errorNode||W};let Ke=z.getDeclarationStatementsForSourceFile(W,bx,O,st);return n=Nt,Ke}function $e(W){if(W.kind===312&&W.isDeclarationFile)return W;if(W.kind===313){s=!0,re=new Map,$=new Map;let Be=!1,Lt=N.createBundle(vr(W.sourceFiles,X=>{if(X.isDeclarationFile)return;if(Be=Be||X.hasNoDefaultLib,K=X,m=X,h=void 0,A=!1,b=new Map,n=t,l=!1,p=!1,at(X,re),$t(X,$),Bp(X)||sm(X)){o=!1,i=!1;let qe=Y_(X)?N.createNodeArray(ke(X,!0)):Hr(X.statements,vi,ns);return N.updateSourceFile(X,[N.createModuleDeclaration([N.createModifier(138)],N.createStringLiteral(xj(e.getEmitHost(),X)),N.createModuleBlock(ft(N.createNodeArray(rt(qe)),X.statements)))],!0,[],[],!1,[])}i=!0;let he=Y_(X)?N.createNodeArray(ke(X)):Hr(X.statements,vi,ns);return N.updateSourceFile(X,rt(he),!0,[],[],!1,[])}),Wi(W.prepends,X=>{if(X.kind===315){let he=yK(X,"dts",xe);return Be=Be||!!he.hasNoDefaultLib,at(he,re),Z(vr(he.typeReferenceDirectives,qe=>[qe.fileName,qe.resolutionMode])),$t(he,$),he}return X}));Lt.syntheticFileReferences=[],Lt.syntheticTypeReferences=hr(),Lt.syntheticLibReferences=Cr(),Lt.hasNoDefaultLib=Be;let B=hi(v_(dO(W,M,!0).declarationFilePath)),le=Y(Lt.syntheticFileReferences,B);return re.forEach(le),Lt}i=!0,l=!1,p=!1,m=W,K=W,n=t,s=!1,o=!1,A=!1,h=void 0,b=new Map,S=void 0,re=at(K,new Map),$=$t(K,new Map);let st=[],Nt=hi(v_(dO(W,M,!0).declarationFilePath)),Ke=Y(st,Nt),ht;if(Y_(K))ht=N.createNodeArray(ke(W)),re.forEach(Ke),pe=Fn(ht,q2);else{let Be=Hr(W.statements,vi,ns);ht=ft(N.createNodeArray(rt(Be)),W.statements),re.forEach(Ke),pe=Fn(ht,q2),Pl(W)&&(!o||l&&!p)&&(ht=ft(N.createNodeArray([...ht,VR(N)]),ht))}let Wt=N.updateSourceFile(W,ht,!0,st,hr(),W.hasNoDefaultLib,Cr());return Wt.exportedModulesFromDeclarationEmit=k,Wt;function Cr(){return In($.keys(),Be=>({fileName:Be,pos:-1,end:-1}))}function hr(){return S?Wi(In(S.keys()),Sr):[]}function Sr([Be,Lt]){if(pe){for(let B of pe)if(Ru(B)&&zh(B.moduleReference)){let le=B.moduleReference.expression;if(bo(le)&&le.text===Be)return}else if(uu(B)&&za(B.moduleSpecifier)&&B.moduleSpecifier.text===Be)return}return{fileName:Be,pos:-1,end:-1,...Lt?{resolutionMode:Lt}:void 0}}function Y(Be,Lt){return B=>{if(k?.includes(B.symbol))return;let le;if(B.isDeclarationFile)le=B.fileName;else{if(s&&hs(W.sourceFiles,B))return;let X=dO(B,M,!0);le=X.declarationFilePath||X.jsFilePath||B.fileName}if(le){let X=WU(se,K,Ps(Lt,M.getCurrentDirectory()),Ps(le,M.getCurrentDirectory()),M);if(!Fp(X)){Z([[X,void 0]]);return}let he=dA(Lt,le,M.getCurrentDirectory(),M.getCanonicalFileName,!1);if(Ss(he,"./")&&pA(he)&&(he=he.substring(2)),Ss(he,"node_modules/")||OT(he))return;Be.push({pos:-1,end:-1,fileName:he})}}}}function at(W,st){return Se||!dx(W)&&Y_(W)||Te(W.referencedFiles,Nt=>{let Ke=M.getSourceFileFromReference(W,Nt);Ke&&st.set(E_(Ke),Ke)}),st}function $t(W,st){return Te(W.libReferenceDirectives,Nt=>{M.getLibFileFromReference(Nt)&&st.set(sp(Nt.fileName),!0)}),st}function St(W){if(W.kind===80)return W;return W.kind===207?N.updateArrayBindingPattern(W,Hr(W.elements,st,D9)):N.updateObjectBindingPattern(W,Hr(W.elements,st,co));function st(Nt){return Nt.kind===232?Nt:(Nt.propertyName&&uo(Nt.propertyName)&&ol(Nt.propertyName.expression)&&zi(Nt.propertyName.expression,m),N.updateBindingElement(Nt,Nt.dotDotDotToken,Nt.propertyName,St(Nt.name),yt(Nt)?Nt.initializer:void 0))}}function Ze(W,st,Nt){let Ke;A||(Ke=n,n=j1(W));let ht=N.updateParameterDeclaration(W,hTt(N,W,st),W.dotDotDotToken,St(W.name),z.isOptionalParameter(W)?W.questionToken||N.createToken(58):void 0,or(W,Nt||W.type,!0),ar(W));return A||(n=Ke),ht}function yt(W){return yTt(W)&&z.isLiteralConstDeclaration(Us(W))}function ar(W){if(yt(W))return z.createLiteralConstValue(Us(W),O)}function or(W,st,Nt){if(!Nt&&up(W,2)||yt(W))return;let Ke=W.kind===169&&(z.isRequiredInitializedParameter(W)||z.isOptionalUninitializedParameterProperty(W));if(st&&!Ke)return nt(st,zt,es);if(!Us(W))return st?nt(st,zt,es):N.createKeywordTypeNode(133);if(W.kind===178)return N.createKeywordTypeNode(133);U=W.name;let ht;if(A||(ht=n,n=j1(W)),W.kind===260||W.kind===208)return Wt(z.createTypeOfDeclaration(W,m,bx,O));if(W.kind===169||W.kind===172||W.kind===171)return fp(W)||!W.initializer?Wt(z.createTypeOfDeclaration(W,m,bx,O,Ke)):Wt(z.createTypeOfDeclaration(W,m,bx,O,Ke)||z.createTypeOfExpression(W.initializer,m,bx,O));return Wt(z.createReturnTypeOfSignatureDeclaration(W,m,bx,O));function Wt(Cr){return U=void 0,A||(n=ht),Cr||N.createKeywordTypeNode(133)}}function Fr(W){switch(W=Us(W),W.kind){case 262:case 267:case 264:case 263:case 265:case 266:return!z.isDeclarationVisible(W);case 260:return!Tr(W);case 271:case 272:case 278:case 277:return!1;case 175:return!0}return!1}function rn(W){var st;if(W.body)return!0;let Nt=(st=W.symbol.declarations)==null?void 0:st.filter(Ke=>Zl(Ke)&&!Ke.body);return!Nt||Nt.indexOf(W)===Nt.length-1}function Tr(W){return Su(W)?!1:la(W.name)?Tt(W.name.elements,Tr):z.isDeclarationVisible(W)}function nr(W,st,Nt){if(up(W,2))return N.createNodeArray();let Ke=vr(st,ht=>Ze(ht,Nt));return Ke?N.createNodeArray(Ke,st.hasTrailingComma):N.createNodeArray()}function tr(W,st){let Nt;if(!st){let Ke=Qb(W);Ke&&(Nt=[Ze(Ke)])}if(pp(W)){let Ke;if(!st){let ht=n6(W);if(ht){let Wt=Ve(W,z.getAllAccessorDeclarations(W));Ke=Ze(ht,void 0,Wt)}}Ke||(Ke=N.createParameterDeclaration(void 0,void 0,"value")),Nt=Pr(Nt,Ke)}return N.createNodeArray(Nt||tt)}function ki(W,st){return up(W,2)?void 0:Hr(st,zt,Nc)}function xs(W){return ls(W)||Vm(W)||hl(W)||eu(W)||ef(W)||ca(W)||oE(W)||qN(W)}function zi(W,st){let Nt=z.isEntityNameVisible(W,st);ye(Nt),Z(z.getTypeReferenceDirectivesForEntityName(W))}function Ms(W,st){return jp(W)&&jp(st)&&(W.jsDoc=st.jsDoc),kl(W,Qg(st))}function un(W,st){if(st){if(o=o||W.kind!==267&&W.kind!==205,bo(st))if(s){let Nt=jde(e.getEmitHost(),z,W);if(Nt)return N.createStringLiteral(Nt)}else{let Nt=z.getSymbolOfExternalModuleSpecifier(st);Nt&&(k||(k=[])).push(Nt)}return st}}function ri(W){if(z.isDeclarationVisible(W))if(W.moduleReference.kind===283){let st=$w(W);return N.updateImportEqualsDeclaration(W,W.modifiers,W.isTypeOnly,W.name,N.updateExternalModuleReference(W.moduleReference,un(W,st)))}else{let st=n;return n=j1(W),zi(W.moduleReference,m),n=st,W}}function On(W){if(!W.importClause)return N.updateImportDeclaration(W,W.modifiers,W.importClause,un(W,W.moduleSpecifier),_r(W.attributes));let st=W.importClause&&W.importClause.name&&z.isDeclarationVisible(W.importClause)?W.importClause.name:void 0;if(!W.importClause.namedBindings)return st&&N.updateImportDeclaration(W,W.modifiers,N.updateImportClause(W.importClause,W.importClause.isTypeOnly,st,void 0),un(W,W.moduleSpecifier),_r(W.attributes));if(W.importClause.namedBindings.kind===274){let Ke=z.isDeclarationVisible(W.importClause.namedBindings)?W.importClause.namedBindings:void 0;return st||Ke?N.updateImportDeclaration(W,W.modifiers,N.updateImportClause(W.importClause,W.importClause.isTypeOnly,st,Ke),un(W,W.moduleSpecifier),_r(W.attributes)):void 0}let Nt=Wi(W.importClause.namedBindings.elements,Ke=>z.isDeclarationVisible(Ke)?Ke:void 0);if(Nt&&Nt.length||st)return N.updateImportDeclaration(W,W.modifiers,N.updateImportClause(W.importClause,W.importClause.isTypeOnly,st,Nt&&Nt.length?N.updateNamedImports(W.importClause.namedBindings,Nt):void 0),un(W,W.moduleSpecifier),_r(W.attributes));if(z.isImportRequiredByAugmentation(W))return N.updateImportDeclaration(W,W.modifiers,void 0,un(W,W.moduleSpecifier),_r(W.attributes))}function _r(W){let st=fD(W);return W&&st!==void 0?W:void 0}function rt(W){for(;de(h);){let Nt=h.shift();if(!G9(Nt))return I.fail(`Late replaced statement was found which is not handled by the declaration transformer!: ${I.formatSyntaxKind(Nt.kind)}`);let Ke=i;i=Nt.parent&&ls(Nt.parent)&&!(Pl(Nt.parent)&&s);let ht=Fs(Nt);i=Ke,b.set(E_(Nt),ht)}return Hr(W,st,ns);function st(Nt){if(G9(Nt)){let Ke=E_(Nt);if(b.has(Ke)){let ht=b.get(Ke);return b.delete(Ke),ht&&((os(ht)?Tt(ht,I9):I9(ht))&&(l=!0),ls(Nt.parent)&&(os(ht)?Tt(ht,o8):o8(ht))&&(o=!0)),ht}}return Nt}}function zt(W){if(We(W)||O_(W)&&(Fr(W)||Jv(W)&&!z.isLateBound(Us(W)))||ca(W)&&z.isImplementationOfOverload(W)||kge(W))return;let st;xs(W)&&(st=m,m=W);let Nt=n,Ke=_V(W),ht=A,Wt=(W.kind===187||W.kind===200)&&W.parent.kind!==265;if((pl(W)||Uh(W))&&up(W,2))return W.symbol&&W.symbol.declarations&&W.symbol.declarations[0]!==W?void 0:Cr(N.createPropertyDeclaration(Ot(W),W.name,void 0,void 0,void 0));if(Ke&&!A&&(n=j1(W)),YA(W)&&zi(W.exprName,m),Wt&&(A=!0),STt(W))switch(W.kind){case 233:{(zf(W.expression)||ol(W.expression))&&zi(W.expression,m);let hr=wr(W,zt,e);return Cr(N.updateExpressionWithTypeArguments(hr,hr.expression,hr.typeArguments))}case 183:{zi(W.typeName,m);let hr=wr(W,zt,e);return Cr(N.updateTypeReferenceNode(hr,hr.typeName,hr.typeArguments))}case 180:return Cr(N.updateConstructSignature(W,ki(W,W.typeParameters),nr(W,W.parameters),or(W,W.type)));case 176:{let hr=N.createConstructorDeclaration(Ot(W),nr(W,W.parameters,0),void 0);return Cr(hr)}case 174:{if(is(W.name))return Cr(void 0);let hr=N.createMethodDeclaration(Ot(W),void 0,W.name,W.questionToken,ki(W,W.typeParameters),nr(W,W.parameters),or(W,W.type),void 0);return Cr(hr)}case 177:{if(is(W.name))return Cr(void 0);let hr=Ve(W,z.getAllAccessorDeclarations(W));return Cr(N.updateGetAccessorDeclaration(W,Ot(W),W.name,tr(W,up(W,2)),or(W,hr),void 0))}case 178:return is(W.name)?Cr(void 0):Cr(N.updateSetAccessorDeclaration(W,Ot(W),W.name,tr(W,up(W,2)),void 0));case 172:return is(W.name)?Cr(void 0):Cr(N.updatePropertyDeclaration(W,Ot(W),W.name,W.questionToken,or(W,W.type),ar(W)));case 171:return is(W.name)?Cr(void 0):Cr(N.updatePropertySignature(W,Ot(W),W.name,W.questionToken,or(W,W.type)));case 173:return is(W.name)?Cr(void 0):Cr(N.updateMethodSignature(W,Ot(W),W.name,W.questionToken,ki(W,W.typeParameters),nr(W,W.parameters),or(W,W.type)));case 179:return Cr(N.updateCallSignature(W,ki(W,W.typeParameters),nr(W,W.parameters),or(W,W.type)));case 181:return Cr(N.updateIndexSignature(W,Ot(W),nr(W,W.parameters),nt(W.type,zt,es)||N.createKeywordTypeNode(133)));case 260:return la(W.name)?to(W.name):(Wt=!0,A=!0,Cr(N.updateVariableDeclaration(W,W.name,void 0,or(W,W.type),ar(W))));case 168:return Rr(W)&&(W.default||W.constraint)?Cr(N.updateTypeParameterDeclaration(W,W.modifiers,W.name,void 0,void 0)):Cr(wr(W,zt,e));case 194:{let hr=nt(W.checkType,zt,es),Sr=nt(W.extendsType,zt,es),Y=m;m=W.trueType;let Be=nt(W.trueType,zt,es);m=Y;let Lt=nt(W.falseType,zt,es);return I.assert(hr),I.assert(Sr),I.assert(Be),I.assert(Lt),Cr(N.updateConditionalTypeNode(W,hr,Sr,Be,Lt))}case 184:return Cr(N.updateFunctionTypeNode(W,Hr(W.typeParameters,zt,Nc),nr(W,W.parameters),I.checkDefined(nt(W.type,zt,es))));case 185:return Cr(N.updateConstructorTypeNode(W,Ot(W),Hr(W.typeParameters,zt,Nc),nr(W,W.parameters),I.checkDefined(nt(W.type,zt,es))));case 205:return Vv(W)?(ce(W),Cr(N.updateImportTypeNode(W,N.updateLiteralTypeNode(W.argument,un(W,W.argument.literal)),W.attributes,W.qualifier,Hr(W.typeArguments,zt,es),W.isTypeOf))):Cr(W);default:I.assertNever(W,`Attempted to process unhandled node kind: ${I.formatSyntaxKind(W.kind)}`)}return XA(W)&&Lo(K,W.pos).line===Lo(K,W.end).line&&Sn(W,1),Cr(wr(W,zt,e));function Cr(hr){return hr&&Ke&&Jv(W)&&qr(W),xs(W)&&(m=st),Ke&&!A&&(n=Nt),Wt&&(A=ht),hr===W?hr:hr&&Un(Ms(hr,W),W)}}function Rr(W){return W.parent.kind===174&&up(W.parent,2)}function vi(W){if(!vTt(W)||We(W))return;switch(W.kind){case 278:return ls(W.parent)&&(o=!0),p=!0,ce(W),N.updateExportDeclaration(W,W.modifiers,W.isTypeOnly,W.exportClause,un(W,W.moduleSpecifier),_r(W.attributes));case 277:{if(ls(W.parent)&&(o=!0),p=!0,W.expression.kind===80)return W;{let Nt=N.createUniqueName("_default",16);n=()=>({diagnosticMessage:g.Default_export_of_the_module_has_or_is_using_private_name_0,errorNode:W}),H=W;let Ke=N.createVariableDeclaration(Nt,void 0,z.createTypeOfExpression(W.expression,W,bx,O),void 0);H=void 0;let ht=N.createVariableStatement(i?[N.createModifier(138)]:[],N.createVariableDeclarationList([Ke],2));return Ms(ht,W),xR(W),[ht,N.updateExportAssignment(W,W.modifiers,Nt)]}}}let st=Fs(W);return b.set(E_(W),st),W}function Ni(W){if(Ru(W)||up(W,2048)||!Jm(W))return W;let st=N.createModifiersFromModifierFlags(X_(W)&131039);return N.replaceModifiers(W,st)}function us(W,st,Nt,Ke){let ht=N.updateModuleDeclaration(W,st,Nt,Ke);if(S_(ht)||ht.flags&32)return ht;let Wt=N.createModuleDeclaration(ht.modifiers,ht.name,ht.body,ht.flags|32);return Un(Wt,ht),ft(Wt,ht),Wt}function Fs(W){if(h)for(;lA(h,W););if(We(W))return;switch(W.kind){case 271:{let Cr=ri(W);return Cr&&ce(W),Cr}case 272:{let Cr=On(W);return Cr&&ce(W),Cr}}if(O_(W)&&Fr(W)||ca(W)&&z.isImplementationOfOverload(W))return;let st;xs(W)&&(st=m,m=W);let Nt=_V(W),Ke=n;Nt&&(n=j1(W));let ht=i;switch(W.kind){case 265:{i=!1;let Cr=Wt(N.updateTypeAliasDeclaration(W,Ot(W),W.name,Hr(W.typeParameters,zt,Nc),I.checkDefined(nt(W.type,zt,es))));return i=ht,Cr}case 264:return Wt(N.updateInterfaceDeclaration(W,Ot(W),W.name,ki(W,W.typeParameters),pt(W.heritageClauses),Hr(W.members,zt,B2)));case 262:{let Cr=Wt(N.updateFunctionDeclaration(W,Ot(W),void 0,W.name,ki(W,W.typeParameters),nr(W,W.parameters),or(W,W.type),void 0));if(Cr&&z.isExpandoFunctionDeclaration(W)&&rn(W)){let hr=z.getPropertiesOfContainerFunction(W),Sr=$h.createModuleDeclaration(void 0,Cr.name||N.createIdentifier("_default"),N.createModuleBlock([]),32);io(Sr,m),Sr.locals=ga(hr),Sr.symbol=hr[0].parent;let Y=[],Be=Wi(hr,qe=>{if(!lB(qe.valueDeclaration))return;let Le=Zi(qe.escapedName);if(!nd(Le,99))return;n=j1(qe.valueDeclaration);let It=z.createTypeOfDeclaration(qe.valueDeclaration,Sr,bx,O);n=Ke;let Rt=PA(Le),Zt=Rt?N.getGeneratedNameForNode(qe.valueDeclaration):N.createIdentifier(Le);Rt&&Y.push([Zt,Le]);let Ir=N.createVariableDeclaration(Zt,void 0,It,void 0);return N.createVariableStatement(Rt?void 0:[N.createToken(95)],N.createVariableDeclarationList([Ir]))});Y.length?Be.push(N.createExportDeclaration(void 0,!1,N.createNamedExports(vr(Y,([qe,Le])=>N.createExportSpecifier(!1,qe,Le))))):Be=Wi(Be,qe=>N.replaceModifiers(qe,0));let Lt=N.createModuleDeclaration(Ot(W),W.name,N.createModuleBlock(Be),32);if(!up(Cr,2048))return[Cr,Lt];let B=N.createModifiersFromModifierFlags(X_(Cr)&-2081|128),le=N.updateFunctionDeclaration(Cr,B,void 0,Cr.name,Cr.typeParameters,Cr.parameters,Cr.type,void 0),X=N.updateModuleDeclaration(Lt,B,Lt.name,Lt.body),he=N.createExportAssignment(void 0,!1,Lt.name);return ls(W.parent)&&(o=!0),p=!0,[le,X,he]}else return Cr}case 267:{i=!1;let Cr=W.body;if(Cr&&Cr.kind===268){let hr=l,Sr=p;p=!1,l=!1;let Y=Hr(Cr.statements,vi,ns),Be=rt(Y);W.flags&33554432&&(l=!1),!zg(W)&&!dt(Be)&&!p&&(l?Be=N.createNodeArray([...Be,VR(N)]):Be=Hr(Be,Ni,ns));let Lt=N.updateModuleBlock(Cr,Be);i=ht,l=hr,p=Sr;let B=Ot(W);return Wt(us(W,B,qb(W)?un(W,W.name):W.name,Lt))}else{i=ht;let hr=Ot(W);i=!1,nt(Cr,vi);let Sr=E_(Cr),Y=b.get(Sr);return b.delete(Sr),Wt(us(W,hr,W.name,Y))}}case 263:{U=W.name,H=W;let Cr=N.createNodeArray(Ot(W)),hr=ki(W,W.typeParameters),Sr=I0(W),Y;if(Sr){let he=n;Y=y1(_a(Sr.parameters,qe=>{if(!ui(qe,31)||We(qe))return;if(n=j1(qe),qe.name.kind===80)return Ms(N.createPropertyDeclaration(Ot(qe),qe.name,qe.questionToken,or(qe,qe.type),ar(qe)),qe);return Le(qe.name);function Le(It){let Rt;for(let Zt of It.elements)Su(Zt)||(la(Zt.name)&&(Rt=ys(Rt,Le(Zt.name))),Rt=Rt||[],Rt.push(N.createPropertyDeclaration(Ot(qe),Zt.name,void 0,or(Zt,void 0),void 0)));return Rt}})),n=he}let Lt=Tt(W.members,he=>!!he.name&&is(he.name))?[N.createPropertyDeclaration(void 0,N.createPrivateIdentifier("#private"),void 0,void 0,void 0)]:void 0,B=ys(ys(Lt,Y),Hr(W.members,zt,Du)),le=N.createNodeArray(B),X=$g(W);if(X&&!ol(X.expression)&&X.expression.kind!==106){let he=W.name?Zi(W.name.escapedText):"default",qe=N.createUniqueName(`${he}_base`,16);n=()=>({diagnosticMessage:g.extends_clause_of_exported_class_0_has_or_is_using_private_name_1,errorNode:X,typeName:W.name});let Le=N.createVariableDeclaration(qe,void 0,z.createTypeOfExpression(X.expression,W,bx,O),void 0),It=N.createVariableStatement(i?[N.createModifier(138)]:[],N.createVariableDeclarationList([Le],2)),Rt=N.createNodeArray(vr(W.heritageClauses,Zt=>{if(Zt.token===96){let Ir=n;n=j1(Zt.types[0]);let zr=N.updateHeritageClause(Zt,vr(Zt.types,Yr=>N.updateExpressionWithTypeArguments(Yr,qe,Hr(Yr.typeArguments,zt,es))));return n=Ir,zr}return N.updateHeritageClause(Zt,Hr(N.createNodeArray(Fn(Zt.types,Ir=>ol(Ir.expression)||Ir.expression.kind===106)),zt,L1))}));return[It,Wt(N.updateClassDeclaration(W,Cr,W.name,hr,Rt,le))]}else{let he=pt(W.heritageClauses);return Wt(N.updateClassDeclaration(W,Cr,W.name,hr,he,le))}}case 243:return Wt(Ta(W));case 266:return Wt(N.updateEnumDeclaration(W,N.createNodeArray(Ot(W)),W.name,N.createNodeArray(Wi(W.members,Cr=>{if(We(Cr))return;let hr=z.getConstantValue(Cr),Sr=hr===void 0?void 0:typeof hr=="string"?N.createStringLiteral(hr):hr<0?N.createPrefixUnaryExpression(41,N.createNumericLiteral(-hr)):N.createNumericLiteral(hr);return Ms(N.updateEnumMember(Cr,Cr.name,Sr),Cr)}))))}return I.assertNever(W,`Unhandled top-level node in declaration emit: ${I.formatSyntaxKind(W.kind)}`);function Wt(Cr){return xs(W)&&(m=st),Nt&&(n=Ke),W.kind===267&&(i=ht),Cr===W?Cr:(H=void 0,U=void 0,Cr&&Un(Ms(Cr,W),W))}}function Ta(W){if(!Te(W.declarationList.declarations,Tr))return;let st=Hr(W.declarationList.declarations,zt,Gi);if(!de(st))return;let Nt=N.createNodeArray(Ot(W)),Ke;return S8(W.declarationList)||v8(W.declarationList)?(Ke=N.createVariableDeclarationList(st,2),Un(Ke,W.declarationList),ft(Ke,W.declarationList),kl(Ke,W.declarationList)):Ke=N.updateVariableDeclarationList(W.declarationList,st),N.updateVariableStatement(W,Nt,Ke)}function to(W){return ip(Wi(W.elements,st=>Nr(st)))}function Nr(W){if(W.kind!==232&&W.name)return Tr(W)?la(W.name)?to(W.name):N.createVariableDeclaration(W.name,void 0,or(W,void 0),void 0):void 0}function qr(W){let st;A||(st=n,n=W0e(W)),U=W.name,I.assert(z.isLateBound(Us(W)));let Ke=W.name.expression;zi(Ke,m),A||(n=st),U=void 0}function We(W){return!!xe&&!!W&&vY(W,K)}function mt(W){return Kc(W)||yl(W)}function dt(W){return Tt(W,mt)}function Ot(W){let st=X_(W),Nt=_e(W);return st===Nt?SM(W.modifiers,Ke=>ii(Ke,Ra),Ra):N.createModifiersFromModifierFlags(Nt)}function _e(W){let st=130030,Nt=i&&!gTt(W)?128:0,Ke=W.parent.kind===312;return(!Ke||s&&Ke&&Pl(W.parent))&&(st^=128,Nt=0),NMe(W,st,Nt)}function Ve(W,st){let Nt=H0e(W);return!Nt&&W!==st.firstAccessor&&(Nt=H0e(st.firstAccessor),n=j1(st.firstAccessor)),!Nt&&st.secondAccessor&&W!==st.secondAccessor&&(Nt=H0e(st.secondAccessor),n=j1(st.secondAccessor)),Nt}function pt(W){return N.createNodeArray(Fn(vr(W,st=>N.updateHeritageClause(st,Hr(N.createNodeArray(Fn(st.types,Nt=>ol(Nt.expression)||st.token===96&&Nt.expression.kind===106)),zt,L1))),st=>st.types&&!!st.types.length))}}function gTt(e){return e.kind===264}function hTt(e,t,n,i){return e.createModifiersFromModifierFlags(NMe(t,n,i))}function NMe(e,t=131070,n=0){let i=X_(e)&t|n;return i&2048&&!(i&32)&&(i^=32),i&2048&&i&128&&(i^=128),i}function H0e(e){if(e)return e.kind===177?e.type:e.parameters.length>0?e.parameters[0].type:void 0}function yTt(e){switch(e.kind){case 172:case 171:return!up(e,2);case 169:case 260:return!0}return!1}function vTt(e){switch(e.kind){case 262:case 267:case 271:case 264:case 263:case 265:case 266:case 243:case 272:case 278:case 277:return!0}return!1}function STt(e){switch(e.kind){case 180:case 176:case 174:case 177:case 178:case 172:case 171:case 173:case 179:case 181:case 260:case 168:case 233:case 183:case 194:case 184:case 185:case 205:return!0}return!1}var bx,TTt=f({"src/compiler/transformers/declarations.ts"(){"use strict";fa(),Zhe(),bx=531469}});function bTt(e){switch(e){case 99:case 7:case 6:case 5:case 200:return TZ;case 4:return z0e;case 100:case 199:return $0e;default:return SZ}}function EZ(e,t,n){return{scriptTransformers:ETt(e,t,n),declarationTransformers:xTt(t)}}function ETt(e,t,n){if(n)return tt;let i=ho(e),s=T_(e),o=D6(e),l=[];return jt(l,t&&vr(t.before,IMe)),l.push(C0e),e.experimentalDecorators&&l.push(P0e),Gj(e)&&l.push(B0e),i<99&&l.push(M0e),!e.experimentalDecorators&&(i<99||!o)&&l.push(N0e),l.push(A0e),i<8&&l.push(R0e),i<7&&l.push(O0e),i<6&&l.push(w0e),i<5&&l.push(I0e),i<4&&l.push(D0e),i<3&&l.push(U0e),i<2&&(l.push(V0e),l.push(q0e)),l.push(bTt(s)),i<1&&l.push(J0e),jt(l,t&&vr(t.after,IMe)),l}function xTt(e){let t=[];return t.push(bZ),jt(t,e&&vr(e.afterDeclarations,ATt)),t}function CTt(e){return t=>UK(t)?e.transformBundle(t):e.transformSourceFile(t)}function DMe(e,t){return n=>{let i=e(n);return typeof i=="function"?t(n,i):CTt(i)}}function IMe(e){return DMe(e,qm)}function ATt(e){return DMe(e,(t,n)=>n)}function _O(e,t){return t}function xM(e,t,n){n(e,t)}function CM(e,t,n,i,s,o,l){var p,m;let S=new Array(363),h,b,A,k=0,N=[],M=[],O=[],U=[],H=0,K=!1,re=[],$=0,pe,z,se=_O,Se=xM,xe=0,Z=[],Q={factory:n,getCompilerOptions:()=>i,getEmitResolver:()=>e,getEmitHost:()=>t,getEmitHelperFactory:D_(()=>pge(Q)),startLexicalEnvironment:ke,suspendLexicalEnvironment:$e,resumeLexicalEnvironment:at,endLexicalEnvironment:$t,setLexicalEnvironmentFlags:St,getLexicalEnvironmentFlags:Ze,hoistVariableDeclaration:Re,hoistFunctionDeclaration:Ue,addInitializationStatement:kt,startBlockScope:yt,endBlockScope:ar,addBlockScopedVariable:or,requestEmitHelper:Fr,readEmitHelpers:rn,enableSubstitution:oe,enableEmitNotification:Ge,isSubstitutionEnabled:Ee,isEmitNotificationEnabled:Ae,get onSubstituteNode(){return se},set onSubstituteNode(nr){I.assert(xe<1,"Cannot modify transformation hooks after initialization has completed."),I.assert(nr!==void 0,"Value must not be 'undefined'"),se=nr},get onEmitNode(){return Se},set onEmitNode(nr){I.assert(xe<1,"Cannot modify transformation hooks after initialization has completed."),I.assert(nr!==void 0,"Value must not be 'undefined'"),Se=nr},addDiagnostic(nr){Z.push(nr)}};for(let nr of s)bK(Xr(Us(nr)));mc("beforeTransform");let ce=o.map(nr=>nr(Q)),ye=nr=>{for(let tr of ce)nr=tr(nr);return nr};xe=1;let we=[];for(let nr of s)(p=mn)==null||p.push(mn.Phase.Emit,"transformNodes",nr.kind===312?{path:nr.path}:{kind:nr.kind,pos:nr.pos,end:nr.end}),we.push((l?ye:ve)(nr)),(m=mn)==null||m.pop();return xe=2,mc("afterTransform"),rd("transformTime","beforeTransform","afterTransform"),{transformed:we,substituteNode:Me,emitNodeWithNotification:Ie,isEmitNotificationEnabled:Ae,dispose:Tr,diagnostics:Z};function ve(nr){return nr&&(!ls(nr)||!nr.isDeclarationFile)?ye(nr):nr}function oe(nr){I.assert(xe<2,"Cannot modify the transformation context after transformation has completed."),S[nr]|=1}function Ee(nr){return(S[nr.kind]&1)!==0&&(eo(nr)&8)===0}function Me(nr,tr){return I.assert(xe<3,"Cannot substitute a node after the result is disposed."),tr&&Ee(tr)&&se(nr,tr)||tr}function Ge(nr){I.assert(xe<2,"Cannot modify the transformation context after transformation has completed."),S[nr]|=2}function Ae(nr){return(S[nr.kind]&2)!==0||(eo(nr)&4)!==0}function Ie(nr,tr,ki){I.assert(xe<3,"Cannot invoke TransformationResult callbacks after the result is disposed."),tr&&(Ae(tr)?Se(nr,tr,ki):ki(nr,tr))}function Re(nr){I.assert(xe>0,"Cannot modify the lexical environment during initialization."),I.assert(xe<2,"Cannot modify the lexical environment after transformation has completed.");let tr=Sn(n.createVariableDeclaration(nr),128);h?h.push(tr):h=[tr],k&1&&(k|=2)}function Ue(nr){I.assert(xe>0,"Cannot modify the lexical environment during initialization."),I.assert(xe<2,"Cannot modify the lexical environment after transformation has completed."),Sn(nr,2097152),b?b.push(nr):b=[nr]}function kt(nr){I.assert(xe>0,"Cannot modify the lexical environment during initialization."),I.assert(xe<2,"Cannot modify the lexical environment after transformation has completed."),Sn(nr,2097152),A?A.push(nr):A=[nr]}function ke(){I.assert(xe>0,"Cannot modify the lexical environment during initialization."),I.assert(xe<2,"Cannot modify the lexical environment after transformation has completed."),I.assert(!K,"Lexical environment is suspended."),N[H]=h,M[H]=b,O[H]=A,U[H]=k,H++,h=void 0,b=void 0,A=void 0,k=0}function $e(){I.assert(xe>0,"Cannot modify the lexical environment during initialization."),I.assert(xe<2,"Cannot modify the lexical environment after transformation has completed."),I.assert(!K,"Lexical environment is already suspended."),K=!0}function at(){I.assert(xe>0,"Cannot modify the lexical environment during initialization."),I.assert(xe<2,"Cannot modify the lexical environment after transformation has completed."),I.assert(K,"Lexical environment is not suspended."),K=!1}function $t(){I.assert(xe>0,"Cannot modify the lexical environment during initialization."),I.assert(xe<2,"Cannot modify the lexical environment after transformation has completed."),I.assert(!K,"Lexical environment is suspended.");let nr;if(h||b||A){if(b&&(nr=[...b]),h){let tr=n.createVariableStatement(void 0,n.createVariableDeclarationList(h));Sn(tr,2097152),nr?nr.push(tr):nr=[tr]}A&&(nr?nr=[...nr,...A]:nr=[...A])}return H--,h=N[H],b=M[H],A=O[H],k=U[H],H===0&&(N=[],M=[],O=[],U=[]),nr}function St(nr,tr){k=tr?k|nr:k&~nr}function Ze(){return k}function yt(){I.assert(xe>0,"Cannot start a block scope during initialization."),I.assert(xe<2,"Cannot start a block scope after transformation has completed."),re[$]=pe,$++,pe=void 0}function ar(){I.assert(xe>0,"Cannot end a block scope during initialization."),I.assert(xe<2,"Cannot end a block scope after transformation has completed.");let nr=Tt(pe)?[n.createVariableStatement(void 0,n.createVariableDeclarationList(pe.map(tr=>n.createVariableDeclaration(tr)),1))]:void 0;return $--,pe=re[$],$===0&&(re=[]),nr}function or(nr){I.assert($>0,"Cannot add a block scoped variable outside of an iteration body."),(pe||(pe=[])).push(nr)}function Fr(nr){if(I.assert(xe>0,"Cannot modify the transformation context during initialization."),I.assert(xe<2,"Cannot modify the transformation context after transformation has completed."),I.assert(!nr.scoped,"Cannot request a scoped emit helper."),nr.dependencies)for(let tr of nr.dependencies)Fr(tr);z=Pr(z,nr)}function rn(){I.assert(xe>0,"Cannot modify the transformation context during initialization."),I.assert(xe<2,"Cannot modify the transformation context after transformation has completed.");let nr=z;return z=void 0,nr}function Tr(){if(xe<3){for(let nr of s)bK(Xr(Us(nr)));h=void 0,N=void 0,b=void 0,M=void 0,se=void 0,Se=void 0,z=void 0,xe=3}}}var xZ,fO,kTt=f({"src/compiler/transformer.ts"(){"use strict";fa(),O2(),xZ={scriptTransformers:tt,declarationTransformers:tt},fO={factory:j,getCompilerOptions:()=>({}),getEmitResolver:Ks,getEmitHost:Ks,getEmitHelperFactory:Ks,startLexicalEnvironment:ja,resumeLexicalEnvironment:ja,suspendLexicalEnvironment:ja,endLexicalEnvironment:xd,setLexicalEnvironmentFlags:ja,getLexicalEnvironmentFlags:()=>0,hoistVariableDeclaration:ja,hoistFunctionDeclaration:ja,addInitializationStatement:ja,startBlockScope:ja,endBlockScope:xd,addBlockScopedVariable:ja,requestEmitHelper:ja,readEmitHelpers:Ks,enableSubstitution:ja,enableEmitNotification:ja,isSubstitutionEnabled:Ks,isEmitNotificationEnabled:Ks,onSubstituteNode:_O,onEmitNode:xM,addDiagnostic:ja}}});function Y0e(e){return Uc(e,".tsbuildinfo")}function CZ(e,t,n,i=!1,s,o){let l=os(n)?n:yX(e,n,i),p=e.getCompilerOptions();if(Wo(p)){let m=e.getPrependNodes();if(l.length||m.length){let S=j.createBundle(l,m),h=t(dO(S,e,i),S);if(h)return h}}else{if(!s)for(let m of l){let S=t(dO(m,e,i),m);if(S)return S}if(o){let m=B1(p);if(m)return t({buildInfoPath:m},void 0)}}}function B1(e){let t=e.configFilePath;if(!N6(e))return;if(e.tsBuildInfoFile)return e.tsBuildInfoFile;let n=Wo(e),i;if(n)i=ff(n);else{if(!t)return;let s=ff(t);i=e.outDir?e.rootDir?Dv(e.outDir,Om(e.rootDir,s,!0)):li(e.outDir,Cl(s)):s}return i+".tsbuildinfo"}function pO(e,t){let n=Wo(e),i=e.emitDeclarationOnly?void 0:n,s=i&&wMe(i,e),o=t||Dd(e)?ff(n)+".d.ts":void 0,l=o&&hR(e)?o+".map":void 0,p=B1(e);return{jsFilePath:i,sourceMapFilePath:s,declarationFilePath:o,declarationMapPath:l,buildInfoPath:p}}function dO(e,t,n){let i=t.getCompilerOptions();if(e.kind===313)return pO(i,n);{let s=Bde(e.fileName,t,fV(e.fileName,i)),o=sm(e),l=o&&yy(e.fileName,s,t.getCurrentDirectory(),!t.useCaseSensitiveFileNames())===0,p=i.emitDeclarationOnly||l?void 0:s,m=!p||sm(e)?void 0:wMe(p,i),S=n||Dd(i)&&!o?Ude(e.fileName,t):void 0,h=S&&hR(i)?S+".map":void 0;return{jsFilePath:p,sourceMapFilePath:m,declarationFilePath:S,declarationMapPath:h,buildInfoPath:void 0}}}function wMe(e,t){return t.sourceMap&&!t.inlineSourceMap?e+".map":void 0}function fV(e,t){return Uc(e,".json")?".json":t.jsx===1&&Ql(e,[".jsx",".tsx"])?".jsx":Ql(e,[".mts",".mjs"])?".mjs":Ql(e,[".cts",".cjs"])?".cjs":".js"}function OMe(e,t,n,i){return n?Dv(n,Om(i(),e,t)):e}function mO(e,t,n,i=()=>_D(t,n)){return AZ(e,t.options,n,i)}function AZ(e,t,n,i){return bT(OMe(e,n,t.declarationDir||t.outDir,i),Aj(e))}function RMe(e,t,n,i=()=>_D(t,n)){if(t.options.emitDeclarationOnly)return;let s=Uc(e,".json"),o=kZ(e,t.options,n,i);return!s||yy(e,o,I.checkDefined(t.options.configFilePath),n)!==0?o:void 0}function kZ(e,t,n,i){return bT(OMe(e,n,t.outDir,i),fV(e,t))}function MMe(){let e;return{addOutput:t,getOutputs:n};function t(i){i&&(e||(e=[])).push(i)}function n(){return e||tt}}function LMe(e,t){let{jsFilePath:n,sourceMapFilePath:i,declarationFilePath:s,declarationMapPath:o,buildInfoPath:l}=pO(e.options,!1);t(n),t(i),t(s),t(o),t(l)}function FMe(e,t,n,i,s){if(i_(t))return;let o=RMe(t,e,n,s);if(i(o),!Uc(t,".json")&&(o&&e.options.sourceMap&&i(`${o}.map`),Dd(e.options))){let l=mO(t,e,n,s);i(l),e.options.declarationMap&&i(`${l}.map`)}}function gO(e,t,n,i,s){let o;return e.rootDir?(o=Ps(e.rootDir,n),s?.(e.rootDir)):e.composite&&e.configFilePath?(o=hi(v_(e.configFilePath)),s?.(o)):o=tye(t(),n,i),o&&o[o.length-1]!==hc&&(o+=hc),o}function _D({options:e,fileNames:t},n){return gO(e,()=>Fn(t,i=>!(e.noEmitForJsFiles&&Ql(i,jN))&&!i_(i)),hi(v_(I.checkDefined(e.configFilePath))),y_(!n))}function pV(e,t){let{addOutput:n,getOutputs:i}=MMe();if(Wo(e.options))LMe(e,n);else{let s=D_(()=>_D(e,t));for(let o of e.fileNames)FMe(e,o,t,n,s);n(B1(e.options))}return i()}function jMe(e,t,n){t=Ca(t),I.assert(hs(e.fileNames,t),"Expected fileName to be present in command line");let{addOutput:i,getOutputs:s}=MMe();return Wo(e.options)?LMe(e,i):FMe(e,t,n,i),s()}function PZ(e,t){if(Wo(e.options)){let{jsFilePath:s,declarationFilePath:o}=pO(e.options,!1);return I.checkDefined(s||o,`project ${e.options.configFilePath} expected to have at least one output`)}let n=D_(()=>_D(e,t));for(let s of e.fileNames){if(i_(s))continue;let o=RMe(s,e,t,n);if(o)return o;if(!Uc(s,".json")&&Dd(e.options))return mO(s,e,t,n)}let i=B1(e.options);return i||I.fail(`project ${e.options.configFilePath} expected to have at least one output`)}function dV(e,t,n,{scriptTransformers:i,declarationTransformers:s},o,l,p){var m=t.getCompilerOptions(),S=m.sourceMap||m.inlineSourceMap||hR(m)?[]:void 0,h=m.listEmittedFiles?[]:void 0,b=EN(),A=w1(m),k=Q8(A),{enter:N,exit:M}=MG("printTime","beforePrint","afterPrint"),O,U=!1;return N(),CZ(t,H,yX(t,n,p),p,l,!n),M(),{emitSkipped:U,diagnostics:b.getDiagnostics(),emittedFiles:h,sourceMaps:S};function H({jsFilePath:Q,sourceMapFilePath:ce,declarationFilePath:ye,declarationMapPath:we,buildInfoPath:ve},oe){var Ee,Me,Ge,Ae,Ie,Re;let Ue;ve&&oe&&UK(oe)&&(Ue=hi(Ps(ve,t.getCurrentDirectory())),O={commonSourceDirectory:kt(t.getCommonSourceDirectory()),sourceFiles:oe.sourceFiles.map(ke=>kt(Ps(ke.fileName,t.getCurrentDirectory())))}),(Ee=mn)==null||Ee.push(mn.Phase.Emit,"emitJsFileOrBundle",{jsFilePath:Q}),re(oe,Q,ce,kt),(Me=mn)==null||Me.pop(),(Ge=mn)==null||Ge.push(mn.Phase.Emit,"emitDeclarationFileOrBundle",{declarationFilePath:ye}),$(oe,ye,we,kt),(Ae=mn)==null||Ae.pop(),(Ie=mn)==null||Ie.push(mn.Phase.Emit,"emitBuildInfo",{buildInfoPath:ve}),K(O,ve),(Re=mn)==null||Re.pop();function kt(ke){return Lb(Om(Ue,ke,t.getCanonicalFileName))}}function K(Q,ce){if(!ce||n||U)return;if(t.isEmitBlocked(ce)){U=!0;return}let ye=t.getBuildInfo(Q)||AM(void 0,Q);t6(t,b,ce,X0e(ye),!1,void 0,{buildInfo:ye}),h?.push(ce)}function re(Q,ce,ye,we){if(!Q||o||!ce)return;if(t.isEmitBlocked(ce)||m.noEmit){U=!0;return}let ve=CM(e,t,j,m,[Q],i,!1),oe={removeComments:m.removeComments,newLine:m.newLine,noEmitHelpers:m.noEmitHelpers,module:m.module,target:m.target,sourceMap:m.sourceMap,inlineSourceMap:m.inlineSourceMap,inlineSources:m.inlineSources,extendedDiagnostics:m.extendedDiagnostics,writeBundleFileInfo:!!O,relativeToBuildInfo:we},Ee=RT(oe,{hasGlobalName:e.hasGlobalName,onEmitNode:ve.emitNodeWithNotification,isEmitNotificationEnabled:ve.isEmitNotificationEnabled,substituteNode:ve.substituteNode});I.assert(ve.transformed.length===1,"Should only see one output from the transform"),z(ce,ye,ve,Ee,m),ve.dispose(),O&&(O.js=Ee.bundleFileInfo),h&&(h.push(ce),ye&&h.push(ye))}function $(Q,ce,ye,we){if(!Q||o===0)return;if(!ce){(o||m.emitDeclarationOnly)&&(U=!0);return}let ve=ls(Q)?[Q]:Q.sourceFiles,oe=p?ve:Fn(ve,$Y),Ee=Wo(m)?[j.createBundle(oe,ls(Q)?void 0:Q.prepends)]:oe;o&&!Dd(m)&&oe.forEach(pe);let Me=CM(e,t,j,m,Ee,s,!1);if(de(Me.diagnostics))for(let Ae of Me.diagnostics)b.add(Ae);let Ge=!!Me.diagnostics&&!!Me.diagnostics.length||!!t.isEmitBlocked(ce)||!!m.noEmit;if(U=U||Ge,!Ge||p){I.assert(Me.transformed.length===1,"Should only see one output from the decl transform");let Ae={removeComments:m.removeComments,newLine:m.newLine,noEmitHelpers:!0,module:m.module,target:m.target,sourceMap:!p&&m.declarationMap,inlineSourceMap:m.inlineSourceMap,extendedDiagnostics:m.extendedDiagnostics,onlyPrintJsDocStyle:!0,omitBraceSourceMapPositions:!0,writeBundleFileInfo:!!O,recordInternalSection:!!O,relativeToBuildInfo:we},Ie=RT(Ae,{hasGlobalName:e.hasGlobalName,onEmitNode:Me.emitNodeWithNotification,isEmitNotificationEnabled:Me.isEmitNotificationEnabled,substituteNode:Me.substituteNode});z(ce,ye,Me,Ie,{sourceMap:Ae.sourceMap,sourceRoot:m.sourceRoot,mapRoot:m.mapRoot,extendedDiagnostics:m.extendedDiagnostics}),h&&(h.push(ce),ye&&h.push(ye)),O&&(O.dts=Ie.bundleFileInfo)}Me.dispose()}function pe(Q){if(Kc(Q)){Q.expression.kind===80&&e.collectLinkedAliases(Q.expression,!0);return}else if(R_(Q)){e.collectLinkedAliases(Q.propertyName||Q.name,!0);return}Qs(Q,pe)}function z(Q,ce,ye,we,ve){let oe=ye.transformed[0],Ee=oe.kind===313?oe:void 0,Me=oe.kind===312?oe:void 0,Ge=Ee?Ee.sourceFiles:[Me],Ae;se(ve,oe)&&(Ae=a0e(t,Cl(v_(Q)),Se(ve),xe(ve,Q,Me),ve)),Ee?we.writeBundle(Ee,k,Ae):we.writeFile(Me,k,Ae);let Ie;if(Ae){S&&S.push({inputSourceFileNames:Ae.getSources(),sourceMap:Ae.toJSON()});let Ue=Z(ve,Ae,Q,ce,Me);if(Ue&&(k.isAtStartOfLine()||k.rawWrite(A),Ie=k.getTextPos(),k.writeComment(`//# sourceMappingURL=${Ue}`)),ce){let kt=Ae.toString();t6(t,b,ce,kt,!1,Ge),we.bundleFileInfo&&(we.bundleFileInfo.mapHash=xx(kt,t))}}else k.writeLine();let Re=k.getText();t6(t,b,Q,Re,!!m.emitBOM,Ge,{sourceMapUrlPos:Ie,diagnostics:ye.diagnostics}),we.bundleFileInfo&&(we.bundleFileInfo.hash=xx(Re,t)),k.clear()}function se(Q,ce){return(Q.sourceMap||Q.inlineSourceMap)&&(ce.kind!==312||!Uc(ce.fileName,".json"))}function Se(Q){let ce=v_(Q.sourceRoot||"");return ce&&hu(ce)}function xe(Q,ce,ye){if(Q.sourceRoot)return t.getCommonSourceDirectory();if(Q.mapRoot){let we=v_(Q.mapRoot);return ye&&(we=hi(Pj(ye.fileName,t,we))),wh(we)===0&&(we=li(t.getCommonSourceDirectory(),we)),we}return hi(Ca(ce))}function Z(Q,ce,ye,we,ve){if(Q.inlineSourceMap){let Ee=ce.toString();return`data:application/json;base64,${ame(Zu,Ee)}`}let oe=Cl(v_(I.checkDefined(we)));if(Q.mapRoot){let Ee=v_(Q.mapRoot);return ve&&(Ee=hi(Pj(ve.fileName,t,Ee))),wh(Ee)===0?(Ee=li(t.getCommonSourceDirectory(),Ee),encodeURI(dA(hi(Ca(ye)),li(Ee,oe),t.getCurrentDirectory(),t.getCanonicalFileName,!0))):encodeURI(li(Ee,oe))}return encodeURI(oe)}}function AM(e,t){return{bundle:t,program:e,version:F}}function X0e(e){return JSON.stringify(e)}function mV(e,t){return PX(e,t)}function PTt(e,t,n){var i;let s=I.checkDefined(e.js),o=((i=s.sources)==null?void 0:i.prologues)&&il(s.sources.prologues,l=>l.file);return e.sourceFiles.map((l,p)=>{let m=o?.get(p),S=m?.directives.map(A=>{let k=ft(j.createStringLiteral(A.expression.text),A.expression),N=ft(j.createExpressionStatement(k),A);return io(k,N),N}),h=j.createToken(1),b=j.createSourceFile(S??[],h,0);return b.fileName=Om(n.getCurrentDirectory(),Ps(l,t),!n.useCaseSensitiveFileNames()),b.text=m?.text??"",T6(b,0,m?.text.length??0),MN(b.statements,b),T6(h,b.end,0),io(h,b),b})}function K0e(e,t,n,i){var s,o;(s=mn)==null||s.push(mn.Phase.Emit,"emitUsingBuildInfo",{},!0),mc("beforeEmit");let l=NTt(e,t,n,i);return mc("afterEmit"),rd("Emit","beforeEmit","afterEmit"),(o=mn)==null||o.pop(),l}function NTt(e,t,n,i){let{buildInfoPath:s,jsFilePath:o,sourceMapFilePath:l,declarationFilePath:p,declarationMapPath:m}=pO(e.options,!1),S=t.getBuildInfo(s,e.options.configFilePath);if(!S||!S.bundle||!S.bundle.js||p&&!S.bundle.dts)return s;let h=t.readFile(I.checkDefined(o));if(!h||xx(h,t)!==S.bundle.js.hash)return o;let b=l&&t.readFile(l);if(l&&!b||e.options.inlineSourceMap)return l||"inline sourcemap decoding";if(l&&xx(b,t)!==S.bundle.js.mapHash)return l;let A=p&&t.readFile(p);if(p&&!A||p&&xx(A,t)!==S.bundle.dts.hash)return p;let k=m&&t.readFile(m);if(m&&!k||e.options.inlineSourceMap)return m||"inline sourcemap decoding";if(m&&xx(k,t)!==S.bundle.dts.mapHash)return m;let N=hi(Ps(s,t.getCurrentDirectory())),M=SK(o,h,l,b,p,A,m,k,s,S,!0),O=[],U=KZ(e.projectReferences,n,pe=>t.readFile(pe),t),H=PTt(S.bundle,N,t),K,re,$={getPrependNodes:D_(()=>[...U,M]),getCanonicalFileName:t.getCanonicalFileName,getCommonSourceDirectory:()=>Ps(S.bundle.commonSourceDirectory,N),getCompilerOptions:()=>e.options,getCurrentDirectory:()=>t.getCurrentDirectory(),getSourceFile:xd,getSourceFileByPath:xd,getSourceFiles:()=>H,getLibFileFromReference:Ks,isSourceFileFromExternalLibrary:qf,getResolvedProjectReferenceToRedirect:xd,getProjectReferenceRedirect:xd,isSourceOfProjectReferenceRedirect:qf,writeFile:(pe,z,se,Se,xe,Z)=>{switch(pe){case o:if(h===z)return;break;case l:if(b===z)return;break;case s:break;case p:if(A===z)return;K=z,re=Z;break;case m:if(k===z)return;break;default:I.fail(`Unexpected path: ${pe}`)}O.push({name:pe,text:z,writeByteOrderMark:se,data:Z})},isEmitBlocked:qf,readFile:pe=>t.readFile(pe),fileExists:pe=>t.fileExists(pe),useCaseSensitiveFileNames:()=>t.useCaseSensitiveFileNames(),getBuildInfo:pe=>{let z=S.program;z&&K!==void 0&&e.options.composite&&(z.outSignature=xx(K,t,re));let{js:se,dts:Se,sourceFiles:xe}=S.bundle;return pe.js.sources=se.sources,Se&&(pe.dts.sources=Se.sources),pe.sourceFiles=xe,AM(z,pe)},getSourceFileFromReference:xd,redirectTargetsMap:g_(),getFileIncludeReasons:Ks,createHash:rs(t,t.createHash)};return dV(gV,$,void 0,EZ(e.options,i)),O}function RT(e={},t={}){var{hasGlobalName:n,onEmitNode:i=xM,isEmitNotificationEnabled:s,substituteNode:o=_O,onBeforeEmitNode:l,onAfterEmitNode:p,onBeforeEmitNodeArray:m,onAfterEmitNodeArray:S,onBeforeEmitToken:h,onAfterEmitToken:b}=t,A=!!e.extendedDiagnostics,k=!!e.omitBraceSourceMapPositions,N=w1(e),M=T_(e),O=new Map,U,H,K,re,$,pe,z,se,Se,xe,Z,Q,ce,ye,we,ve=e.preserveSourceNewlines,oe,Ee,Me,Ge=Gx,Ae,Ie=e.writeBundleFileInfo?{sections:[]}:void 0,Re=Ie?I.checkDefined(e.relativeToBuildInfo):void 0,Ue=e.recordInternalSection,kt=0,ke="text",$e=!0,at,$t,St=-1,Ze,yt=-1,ar=-1,or=-1,Fr=-1,rn,Tr,nr=!1,tr=!!e.removeComments,ki,xs,{enter:zi,exit:Ms}=hOe(A,"commentTime","beforeComment","afterComment"),un=j.parenthesizer,ri={select:D=>D===0?un.parenthesizeLeadingTypeArgument:void 0},On=Fy();return st(),{printNode:_r,printList:rt,printFile:Rr,printBundle:zt,writeNode:Ni,writeList:us,writeFile:dt,writeBundle:We,bundleFileInfo:Ie};function _r(D,ue,gt){switch(D){case 0:I.assert(ls(ue),"Expected a SourceFile node.");break;case 2:I.assert(ze(ue),"Expected an Identifier node.");break;case 1:I.assert(bt(ue),"Expected an Expression node.");break}switch(ue.kind){case 312:return Rr(ue);case 313:return zt(ue);case 314:return vi(ue)}return Ni(D,ue,gt,Ot()),_e()}function rt(D,ue,gt){return us(D,ue,gt,Ot()),_e()}function zt(D){return We(D,Ot(),void 0),_e()}function Rr(D){return dt(D,Ot(),void 0),_e()}function vi(D){return mt(D,Ot()),_e()}function Ni(D,ue,gt,lr){let Wn=Ee;W(lr,void 0),Ve(D,ue,gt),st(),Ee=Wn}function us(D,ue,gt,lr){let Wn=Ee;W(lr,void 0),gt&&pt(gt),pc(void 0,ue,D),st(),Ee=Wn}function Fs(){return Ee.getTextPosWithWriteLine?Ee.getTextPosWithWriteLine():Ee.getTextPos()}function Ta(D,ue,gt){let lr=Is(Ie.sections);lr&&lr.kind===gt?lr.end=ue:Ie.sections.push({pos:D,end:ue,kind:gt})}function to(D){if(Ue&&Ie&&U&&(O_(D)||Xc(D))&&vY(D,U)&&ke!=="internal"){let ue=ke;return qr(Ee.getTextPos()),kt=Fs(),ke="internal",ue}}function Nr(D){D&&(qr(Ee.getTextPos()),kt=Fs(),ke=D)}function qr(D){return kt<D?(Ta(kt,D,ke),!0):!1}function We(D,ue,gt){Ae=!1;let lr=Ee;W(ue,gt),gS(D),qy(D),Zt(D),Tg(D);for(let Wn of D.prepends){Cu();let $i=Ee.getTextPos(),Di=Ie&&Ie.sections;if(Di&&(Ie.sections=[]),Ve(4,Wn,void 0),Ie){let fs=Ie.sections;Ie.sections=Di,Wn.oldFileOfCurrentEmit?Ie.sections.push(...fs):(fs.forEach(Aa=>I.assert(mme(Aa))),Ie.sections.push({pos:$i,end:Ee.getTextPos(),kind:"prepend",data:Re(Wn.fileName),texts:fs}))}}kt=Fs();for(let Wn of D.sourceFiles)Ve(0,Wn,Wn);if(Ie&&D.sourceFiles.length){let Wn=Ee.getTextPos();if(qr(Wn)){let $i=QO(D);$i&&(Ie.sources||(Ie.sources={}),Ie.sources.prologues=$i);let Di=Rt(D);Di&&(Ie.sources||(Ie.sources={}),Ie.sources.helpers=Di)}}st(),Ee=lr}function mt(D,ue){let gt=Ee;W(ue,void 0),Ve(4,D,void 0),st(),Ee=gt}function dt(D,ue,gt){Ae=!0;let lr=Ee;W(ue,gt),gS(D),qy(D),Ve(0,D,D),st(),Ee=lr}function Ot(){return Me||(Me=Q8(N))}function _e(){let D=Me.getText();return Me.clear(),D}function Ve(D,ue,gt){gt&&pt(gt),Y(D,ue,void 0)}function pt(D){U=D,rn=void 0,Tr=void 0,D&&Hy(D)}function W(D,ue){D&&e.omitTrailingSemicolon&&(D=gX(D)),Ee=D,at=ue,$e=!Ee||!at}function st(){H=[],K=[],re=[],$=new Set,pe=[],z=new Map,se=[],Se=0,xe=[],Z=0,Q=[],ce=void 0,ye=[],we=void 0,U=void 0,rn=void 0,Tr=void 0,W(void 0,void 0)}function Nt(){return rn||(rn=vy(I.checkDefined(U)))}function Ke(D,ue){if(D===void 0)return;let gt=to(D);Y(4,D,ue),Nr(gt)}function ht(D){D!==void 0&&Y(2,D,void 0)}function Wt(D,ue){D!==void 0&&Y(1,D,ue)}function Cr(D){Y(za(D)?6:4,D)}function hr(D){ve&&Lm(D)&4&&(ve=!1)}function Sr(D){ve=D}function Y(D,ue,gt){xs=gt,B(0,D,ue)(D,ue),xs=void 0}function Be(D){return!tr&&!ls(D)}function Lt(D){return!$e&&!ls(D)&&!uj(D)&&!dx(D)&&!wge(D)}function B(D,ue,gt){switch(D){case 0:if(i!==xM&&(!s||s(gt)))return X;case 1:if(o!==_O&&(ki=o(ue,gt)||gt)!==gt)return xs&&(ki=xs(ki)),It;case 2:if(Be(gt))return cI;case 3:if(Lt(gt))return rb;case 4:return he;default:return I.assertNever(D)}}function le(D,ue,gt){return B(D+1,ue,gt)}function X(D,ue){let gt=le(0,D,ue);i(D,ue,gt)}function he(D,ue){if(l?.(ue),ve){let gt=ve;hr(ue),qe(D,ue),Sr(gt)}else qe(D,ue);p?.(ue),xs=void 0}function qe(D,ue,gt=!0){if(gt){let lr=EK(ue);if(lr)return Ns(D,ue,lr)}if(D===0)return $k(ta(ue,ls));if(D===2)return ni(ta(ue,ze));if(D===6)return Yr(ta(ue,za),!0);if(D===3)return Le(ta(ue,Nc));if(D===7)return jk(ta(ue,tk));if(D===5)return I.assertNode(ue,FK),ds(!0);if(D===4){switch(ue.kind){case 16:case 17:case 18:return Yr(ue,!1);case 80:return ni(ue);case 81:return js(ue);case 166:return Mr(ue);case 167:return Sl(ue);case 168:return zs(ue);case 169:return Eo(ue);case 170:return nc(ue);case 171:return Dc(ue);case 172:return zu(ue);case 173:return ks(ue);case 174:return ya(ue);case 175:return $u(ue);case 176:return Uo(ue);case 177:case 178:return $a(ue);case 179:return Ac(ue);case 180:return Ld(ue);case 181:return Nl(ue);case 182:return $s(ue);case 183:return cr(ue);case 184:return ic(ue);case 185:return ru(ue);case 186:return ge(ue);case 187:return ne(ue);case 188:return je(ue);case 189:return gr(ue);case 190:return xn(ue);case 192:return Zn(ue);case 193:return Bi(ue);case 194:return Jn(ue);case 195:return ia(ue);case 196:return Fc(ue);case 233:return Jt(ue);case 197:return bu();case 198:return sc(ue);case 199:return Jl(ue);case 200:return jo(ue);case 201:return Eu(ue);case 202:return Dn(ue);case 203:return Xf(ue);case 204:return zc(ue);case 205:return pu(ue);case 206:return gm(ue);case 207:return tf(ue);case 208:return Oe(ue);case 239:return Yt(ue);case 240:return Tc();case 241:return _n(ue);case 243:return ci(ue);case 242:return ds(!1);case 244:return Ya(ue);case 245:return Xa(ue);case 246:return Gu(ue);case 247:return nu(ue);case 248:return Sp(ue);case 249:return Rf(ue);case 250:return _S(ue);case 251:return Wm(ue);case 252:return Gm(ue);case 253:return OE(ue);case 254:return md(ue);case 255:return lh(ue);case 256:return gd(ue);case 257:return By(ue);case 258:return Je(ue);case 259:return et(ue);case 260:return Ft(ue);case 261:return Ht(ue);case 262:return Er(ue);case 263:return aa(ue);case 264:return B_(ue);case 265:return Hu(ue);case 266:return Uy(ue);case 267:return qT(ue);case 268:return Rk(ue);case 269:return zT(ue);case 270:return Uk(ue);case 271:return HD(ue);case 272:return XD(ue);case 273:return Lx(ue);case 274:return RE(ue);case 280:return ME(ue);case 275:return Mk(ue);case 276:return KD(ue);case 277:return Lk(ue);case 278:return Fk(ue);case 279:return LE(ue);case 281:return fS(ue);case 300:return Bk(ue);case 301:return Fx(ue);case 282:return;case 283:return $T(ue);case 12:return Vy(ue);case 286:case 289:return WT(ue);case 287:case 290:return Xh(ue);case 291:return Mf(ue);case 292:return jd(ue);case 293:return Tp(ue);case 294:return ZD(ue);case 295:return Vk(ue);case 296:return GT(ue);case 297:return Jk(ue);case 298:return X1(ue);case 299:return qk(ue);case 303:return yg(ue);case 304:return Ux(ue);case 305:return He(ue);case 306:return vg(ue);case 307:return Fi(ue);case 314:case 308:return Pi(ue);case 309:case 310:return fn(ue);case 311:return Qn(ue);case 312:return $k(ue);case 313:return I.fail("Bundles should be printed using printBundle");case 315:return I.fail("InputFiles should not be printed");case 316:return Jy(ue);case 317:return mS(ue);case 319:return Cn("*");case 320:return Cn("?");case 321:return Wu(ue);case 322:return yp(ue);case 323:return Go(ue);case 324:return Mu(ue);case 191:case 325:return Et(ue);case 326:return;case 327:return Yu(ue);case 329:return Jx(ue);case 330:return YT(ue);case 334:case 339:case 344:return Vx(ue);case 335:case 336:return K1(ue);case 337:case 338:return;case 340:case 341:case 342:case 343:return;case 345:return oo(ue);case 346:return Sg(ue);case 348:case 355:return qx(ue);case 347:case 349:case 350:case 351:case 356:case 357:return HT(ue);case 352:return Q1(ue);case 353:return XO(ue);case 354:return zk(ue);case 359:return}if(bt(ue)&&(D=1,o!==_O)){let lr=o(D,ue)||ue;lr!==ue&&(ue=lr,xs&&(ue=xs(ue)))}}if(D===1)switch(ue.kind){case 9:case 10:return zr(ue);case 11:case 14:case 15:return Yr(ue,!1);case 80:return ni(ue);case 81:return js(ue);case 209:return Bt(ue);case 210:return Zr(ue);case 211:return Ds(ue);case 212:return ua(ue);case 213:return Tl(ue);case 214:return ql(ue);case 215:return bc(ue);case 216:return Ic(ue);case 217:return cl(ue);case 218:return bl(ue);case 219:return xu(ue);case 220:return wf(ue);case 221:return hf(ue);case 222:return Fd(ue);case 223:return ch(ue);case 224:return Yh(ue);case 225:return A_(ue);case 226:return On(ue);case 227:return vp(ue);case 228:return U0(ue);case 229:return Of(ue);case 230:return ie(ue);case 231:return ct(ue);case 232:return;case 234:return Gt(ue);case 235:return V(ue);case 233:return Jt(ue);case 238:return Pe(ue);case 236:return ot(ue);case 237:return I.fail("SyntheticExpression should never be printed.");case 282:return;case 284:return fo(ue);case 285:return jx(ue);case 288:return QD(ue);case 358:return I.fail("SyntaxList should not be printed");case 359:return;case 360:return _i(ue);case 361:return Kh(ue);case 362:return I.fail("SyntheticReferenceExpression should not be printed")}if(Nf(ue.kind))return VE(ue,_s);if(aY(ue.kind))return VE(ue,Cn);I.fail(`Unhandled SyntaxKind: ${I.formatSyntaxKind(ue.kind)}.`)}function Le(D){Ke(D.name),yn(),_s("in"),yn(),Ke(D.constraint)}function It(D,ue){let gt=le(1,D,ue);I.assertIsDefined(ki),ue=ki,ki=void 0,gt(D,ue)}function Rt(D){let ue;if(M===0||e.noEmitHelpers)return;let gt=new Map;for(let lr of D.sourceFiles){let Wn=zR(lr)!==void 0,$i=Ir(lr);if($i)for(let Di of $i)!Di.scoped&&!Wn&&!gt.get(Di.name)&&(gt.set(Di.name,!0),(ue||(ue=[])).push(Di.name))}return ue}function Zt(D){let ue=!1,gt=D.kind===313?D:void 0;if(gt&&M===0)return;let lr=gt?gt.prepends.length:0,Wn=gt?gt.sourceFiles.length+lr:1;for(let $i=0;$i<Wn;$i++){let Di=gt?$i<lr?gt.prepends[$i]:gt.sourceFiles[$i-lr]:D,fs=ls(Di)?Di:dx(Di)?void 0:U,Aa=e.noEmitHelpers||!!fs&&Wge(fs),U_=(ls(Di)||dx(Di))&&!Ae,vf=dx(Di)?Di.helpers:Ir(Di);if(vf)for(let Vd of vf){if(Vd.scoped){if(gt)continue}else{if(Aa)continue;if(U_){if(O.get(Vd.name))continue;O.set(Vd.name,!0)}}let CS=Fs();typeof Vd.text=="string"?Yx(Vd.text):Yx(Vd.text(Yk)),Ie&&Ie.sections.push({pos:CS,end:Ee.getTextPos(),kind:"emitHelpers",data:Vd.name}),ue=!0}}return ue}function Ir(D){let ue=EB(D);return ue&&cu(ue,dge)}function zr(D){Yr(D,!1)}function Yr(D,ue){let gt=Qx(D,e.neverAsciiEscape,ue);(e.sourceMap||e.inlineSourceMap)&&(D.kind===11||Rv(D.kind))?yS(gt):iI(gt)}function Pi(D){for(let ue of D.texts)Cu(),Ke(ue)}function Fi(D){Ee.rawWrite(D.parent.text.substring(D.pos,D.end))}function fn(D){let ue=Fs();Fi(D),Ie&&Ta(ue,Ee.getTextPos(),D.kind===309?"text":"internal")}function Qn(D){let ue=Fs();if(Fi(D),Ie){let gt=q_(D.section);gt.pos=ue,gt.end=Ee.getTextPos(),Ie.sections.push(gt)}}function Ns(D,ue,gt){switch(gt.kind){case 1:Vi(D,ue,gt);break;case 0:ji(D,ue,gt);break}}function Vi(D,ue,gt){XT(`\${${gt.order}:`),qe(D,ue,!1),XT("}")}function ji(D,ue,gt){I.assert(ue.kind===242,`A tab stop cannot be attached to a node of kind ${I.formatSyntaxKind(ue.kind)}.`),I.assert(D!==5,"A tab stop cannot be attached to an embedded statement."),XT(`$${gt.order}`)}function ni(D){(D.symbol?ZO:Ge)(du(D,!1),D.symbol),pc(D,sx(D),53776)}function js(D){Ge(du(D,!1))}function Mr(D){Qo(D.left),Cn("."),Ke(D.right)}function Qo(D){D.kind===80?Wt(D):Ke(D)}function Sl(D){let ue=Se,gt=we;TS(),Cn("["),Wt(D.expression,un.parenthesizeExpressionOfComputedPropertyName),Cn("]"),Bd(ue,gt)}function zs(D){J0(D,D.modifiers),Ke(D.name),D.constraint&&(yn(),_s("extends"),yn(),Ke(D.constraint)),D.default&&(yn(),hd("="),yn(),Ke(D.default))}function Eo(D){zp(D,D.modifiers,!0),Ke(D.dotDotDotToken),wc(D.name,ev),Ke(D.questionToken),D.parent&&D.parent.kind===324&&!D.name?Ke(D.type):vm(D.type),hS(D.initializer,D.type?D.type.end:D.questionToken?D.questionToken.end:D.name?D.name.end:D.modifiers?D.modifiers.end:D.pos,D,un.parenthesizeExpressionForDisallowedComma)}function nc(D){Cn("@"),Wt(D.expression,un.parenthesizeLeftSideOfAccess)}function Dc(D){J0(D,D.modifiers),wc(D.name,Hx),Ke(D.questionToken),vm(D.type),Lu()}function zu(D){zp(D,D.modifiers,!0),Ke(D.name),Ke(D.questionToken),Ke(D.exclamationToken),vm(D.type),hS(D.initializer,D.type?D.type.end:D.questionToken?D.questionToken.end:D.name.end,D),Lu()}function ks(D){a_(D),J0(D,D.modifiers),Ke(D.name),Ke(D.questionToken),uh(D,D.typeParameters),Z1(D,D.parameters),vm(D.type),Lu(),Qf(D)}function ya(D){zp(D,D.modifiers,!0),Ke(D.asteriskToken),Ke(D.name),Ke(D.questionToken),br(D,sn)}function $u(D){_s("static"),hn(D.body)}function Uo(D){zp(D,D.modifiers,!1),_s("constructor"),br(D,sn)}function $a(D){let ue=zp(D,D.modifiers,!0),gt=D.kind===177?139:153;ts(gt,ue,_s,D),yn(),Ke(D.name),br(D,sn)}function Ac(D){a_(D),uh(D,D.typeParameters),Z1(D,D.parameters),vm(D.type),Lu(),Qf(D)}function Ld(D){a_(D),_s("new"),yn(),uh(D,D.typeParameters),Z1(D,D.parameters),vm(D.type),Lu(),Qf(D)}function Nl(D){zp(D,D.modifiers,!1),nI(D,D.parameters),vm(D.type),Lu()}function zc(D){Ke(D.type),Ke(D.literal)}function Tc(){Lu()}function $s(D){D.assertsModifier&&(Ke(D.assertsModifier),yn()),Ke(D.parameterName),D.type&&(yn(),_s("is"),yn(),Ke(D.type))}function cr(D){Ke(D.typeName),z0(D,D.typeArguments)}function ic(D){a_(D),uh(D,D.typeParameters),rI(D,D.parameters),yn(),Cn("=>"),yn(),Ke(D.type),Qf(D)}function Mu(D){_s("function"),Z1(D,D.parameters),Cn(":"),Ke(D.type)}function Wu(D){Cn("?"),Ke(D.type)}function yp(D){Cn("!"),Ke(D.type)}function Go(D){Ke(D.type),Cn("=")}function ru(D){a_(D),J0(D,D.modifiers),_s("new"),yn(),uh(D,D.typeParameters),Z1(D,D.parameters),yn(),Cn("=>"),yn(),Ke(D.type),Qf(D)}function ge(D){_s("typeof"),yn(),Ke(D.exprName),z0(D,D.typeArguments)}function ne(D){Bd(0,void 0),Cn("{");let ue=eo(D)&1?768:32897;pc(D,D.members,ue|524288),Cn("}"),TS()}function je(D){Ke(D.elementType,un.parenthesizeNonArrayTypeOfPostfixType),Cn("["),Cn("]")}function Et(D){Cn("..."),Ke(D.type)}function gr(D){ts(23,D.pos,Cn,D);let ue=eo(D)&1?528:657;pc(D,D.elements,ue|524288,un.parenthesizeElementTypeOfTupleType),ts(24,D.elements.end,Cn,D)}function Dn(D){Ke(D.dotDotDotToken),Ke(D.name),Ke(D.questionToken),ts(59,D.name.end,Cn,D),yn(),Ke(D.type)}function xn(D){Ke(D.type,un.parenthesizeTypeOfOptionalType),Cn("?")}function Zn(D){pc(D,D.types,516,un.parenthesizeConstituentTypeOfUnionType)}function Bi(D){pc(D,D.types,520,un.parenthesizeConstituentTypeOfIntersectionType)}function Jn(D){Ke(D.checkType,un.parenthesizeCheckTypeOfConditionalType),yn(),_s("extends"),yn(),Ke(D.extendsType,un.parenthesizeExtendsTypeOfConditionalType),yn(),Cn("?"),yn(),Ke(D.trueType),yn(),Cn(":"),yn(),Ke(D.falseType)}function ia(D){_s("infer"),yn(),Ke(D.typeParameter)}function Fc(D){Cn("("),Ke(D.type),Cn(")")}function bu(){_s("this")}function sc(D){vS(D.operator,_s),yn();let ue=D.operator===148?un.parenthesizeOperandOfReadonlyTypeOperator:un.parenthesizeOperandOfTypeOperator;Ke(D.type,ue)}function Jl(D){Ke(D.objectType,un.parenthesizeNonArrayTypeOfPostfixType),Cn("["),Ke(D.indexType),Cn("]")}function jo(D){let ue=eo(D);Cn("{"),ue&1?yn():(Cu(),Qh()),D.readonlyToken&&(Ke(D.readonlyToken),D.readonlyToken.kind!==148&&_s("readonly"),yn()),Cn("["),Y(3,D.typeParameter),D.nameType&&(yn(),_s("as"),yn(),Ke(D.nameType)),Cn("]"),D.questionToken&&(Ke(D.questionToken),D.questionToken.kind!==58&&Cn("?")),Cn(":"),yn(),Ke(D.type),Lu(),ue&1?yn():(Cu(),Km()),pc(D,D.members,2),Cn("}")}function Eu(D){Wt(D.literal)}function Xf(D){Ke(D.head),pc(D,D.templateSpans,262144)}function pu(D){D.isTypeOf&&(_s("typeof"),yn()),_s("import"),Cn("("),Ke(D.argument),D.attributes&&(Cn(","),yn(),Y(7,D.attributes)),Cn(")"),D.qualifier&&(Cn("."),Ke(D.qualifier)),z0(D,D.typeArguments)}function gm(D){Cn("{"),pc(D,D.elements,525136),Cn("}")}function tf(D){Cn("["),pc(D,D.elements,524880),Cn("]")}function Oe(D){Ke(D.dotDotDotToken),D.propertyName&&(Ke(D.propertyName),Cn(":"),yn()),Ke(D.name),hS(D.initializer,D.name.end,D,un.parenthesizeExpressionForDisallowedComma)}function Bt(D){let ue=D.elements,gt=D.multiLine?65536:0;BE(D,ue,8914|gt,un.parenthesizeExpressionForDisallowedComma)}function Zr(D){Bd(0,void 0),Te(D.properties,Hk);let ue=eo(D)&131072;ue&&Qh();let gt=D.multiLine?65536:0,lr=U&&U.languageVersion>=1&&!sm(U)?64:0;pc(D,D.properties,526226|lr|gt),ue&&Km(),TS()}function Ds(D){Wt(D.expression,un.parenthesizeLeftSideOfAccess);let ue=D.questionDotToken||jh(j.createToken(25),D.expression.end,D.name.pos),gt=$p(D,D.expression,ue),lr=$p(D,ue,D.name);Qm(gt,!1),ue.kind!==29&&sa(D.expression)&&!Ee.hasTrailingComment()&&!Ee.hasTrailingWhitespace()&&Cn("."),D.questionDotToken?Ke(ue):ts(ue.kind,D.expression.end,Cn,D),Qm(lr,!1),Ke(D.name),KT(gt,lr)}function sa(D){if(D=Mm(D),_p(D)){let ue=Qx(D,!0,!1);return!(D.numericLiteralFlags&448)&&!ue.includes(Sa(25))&&!ue.includes("E")&&!ue.includes("e")}else if(Yo(D)){let ue=age(D);return typeof ue=="number"&&isFinite(ue)&&ue>=0&&Math.floor(ue)===ue}}function ua(D){Wt(D.expression,un.parenthesizeLeftSideOfAccess),Ke(D.questionDotToken),ts(23,D.expression.end,Cn,D),Wt(D.argumentExpression),ts(24,D.argumentExpression.end,Cn,D)}function Tl(D){let ue=Lm(D)&16;ue&&(Cn("("),yS("0"),Cn(","),yn()),Wt(D.expression,un.parenthesizeLeftSideOfAccess),ue&&Cn(")"),Ke(D.questionDotToken),z0(D,D.typeArguments),BE(D,D.arguments,2576,un.parenthesizeExpressionForDisallowedComma)}function ql(D){ts(105,D.pos,_s,D),yn(),Wt(D.expression,un.parenthesizeExpressionOfNew),z0(D,D.typeArguments),BE(D,D.arguments,18960,un.parenthesizeExpressionForDisallowedComma)}function bc(D){let ue=Lm(D)&16;ue&&(Cn("("),yS("0"),Cn(","),yn()),Wt(D.tag,un.parenthesizeLeftSideOfAccess),ue&&Cn(")"),z0(D,D.typeArguments),yn(),Wt(D.template)}function Ic(D){Cn("<"),Ke(D.type),Cn(">"),Wt(D.expression,un.parenthesizeOperandOfPrefixUnary)}function cl(D){let ue=ts(21,D.pos,Cn,D),gt=sI(D.expression,D);Wt(D.expression,void 0),JE(D.expression,D),KT(gt),ts(22,D.expression?D.expression.end:ue,Cn,D)}function bl(D){Wp(D.name),nn(D)}function xu(D){J0(D,D.modifiers),br(D,dd)}function dd(D){uh(D,D.typeParameters),rI(D,D.parameters),vm(D.type),yn(),Ke(D.equalsGreaterThanToken)}function wf(D){ts(91,D.pos,_s,D),yn(),Wt(D.expression,un.parenthesizeOperandOfPrefixUnary)}function hf(D){ts(114,D.pos,_s,D),yn(),Wt(D.expression,un.parenthesizeOperandOfPrefixUnary)}function Fd(D){ts(116,D.pos,_s,D),yn(),Wt(D.expression,un.parenthesizeOperandOfPrefixUnary)}function ch(D){ts(135,D.pos,_s,D),yn(),Wt(D.expression,un.parenthesizeOperandOfPrefixUnary)}function Yh(D){vS(D.operator,hd),Ly(D)&&yn(),Wt(D.operand,un.parenthesizeOperandOfPrefixUnary)}function Ly(D){let ue=D.operand;return ue.kind===224&&(D.operator===40&&(ue.operator===40||ue.operator===46)||D.operator===41&&(ue.operator===41||ue.operator===47))}function A_(D){Wt(D.operand,un.parenthesizeOperandOfPostfixUnary),vS(D.operator,hd)}function Fy(){return SU(D,ue,gt,lr,Wn,void 0);function D(Di,fs){if(fs){fs.stackIndex++,fs.preserveSourceNewlinesStack[fs.stackIndex]=ve,fs.containerPosStack[fs.stackIndex]=ar,fs.containerEndStack[fs.stackIndex]=or,fs.declarationListContainerEndStack[fs.stackIndex]=Fr;let Aa=fs.shouldEmitCommentsStack[fs.stackIndex]=Be(Di),U_=fs.shouldEmitSourceMapsStack[fs.stackIndex]=Lt(Di);l?.(Di),Aa&&rC(Di),U_&&Zk(Di),hr(Di)}else fs={stackIndex:0,preserveSourceNewlinesStack:[void 0],containerPosStack:[-1],containerEndStack:[-1],declarationListContainerEndStack:[-1],shouldEmitCommentsStack:[!1],shouldEmitSourceMapsStack:[!1]};return fs}function ue(Di,fs,Aa){return $i(Di,Aa,"left")}function gt(Di,fs,Aa){let U_=Di.kind!==28,vf=$p(Aa,Aa.left,Di),Vd=$p(Aa,Di,Aa.right);Qm(vf,U_),W0(Di.pos),VE(Di,Di.kind===103?_s:hd),Zm(Di.end,!0),Qm(Vd,!0)}function lr(Di,fs,Aa){return $i(Di,Aa,"right")}function Wn(Di,fs){let Aa=$p(Di,Di.left,Di.operatorToken),U_=$p(Di,Di.operatorToken,Di.right);if(KT(Aa,U_),fs.stackIndex>0){let vf=fs.preserveSourceNewlinesStack[fs.stackIndex],Vd=fs.containerPosStack[fs.stackIndex],CS=fs.containerEndStack[fs.stackIndex],Oi=fs.declarationListContainerEndStack[fs.stackIndex],t0=fs.shouldEmitCommentsStack[fs.stackIndex],Kr=fs.shouldEmitSourceMapsStack[fs.stackIndex];Sr(vf),Kr&&sC(Di),t0&&lI(Di,Vd,CS,Oi),p?.(Di),fs.stackIndex--}}function $i(Di,fs,Aa){let U_=Aa==="left"?un.getParenthesizeLeftSideOfBinaryForOperator(fs.operatorToken.kind):un.getParenthesizeRightSideOfBinaryForOperator(fs.operatorToken.kind),vf=B(0,1,Di);if(vf===It&&(I.assertIsDefined(ki),Di=U_(ta(ki,bt)),vf=le(1,1,Di),ki=void 0),(vf===cI||vf===rb||vf===he)&&bn(Di))return Di;xs=U_,vf(1,Di)}}function vp(D){let ue=$p(D,D.condition,D.questionToken),gt=$p(D,D.questionToken,D.whenTrue),lr=$p(D,D.whenTrue,D.colonToken),Wn=$p(D,D.colonToken,D.whenFalse);Wt(D.condition,un.parenthesizeConditionOfConditionalExpression),Qm(ue,!0),Ke(D.questionToken),Qm(gt,!0),Wt(D.whenTrue,un.parenthesizeBranchOfConditionalExpression),KT(ue,gt),Qm(lr,!0),Ke(D.colonToken),Qm(Wn,!0),Wt(D.whenFalse,un.parenthesizeBranchOfConditionalExpression),KT(lr,Wn)}function U0(D){Ke(D.head),pc(D,D.templateSpans,262144)}function Of(D){ts(127,D.pos,_s,D),Ke(D.asteriskToken),jE(D.expression&&Hm(D.expression),wE)}function ie(D){ts(26,D.pos,Cn,D),Wt(D.expression,un.parenthesizeExpressionForDisallowedComma)}function ct(D){Wp(D.name),ao(D)}function Jt(D){Wt(D.expression,un.parenthesizeLeftSideOfAccess),z0(D,D.typeArguments)}function Gt(D){Wt(D.expression,void 0),D.type&&(yn(),_s("as"),yn(),Ke(D.type))}function V(D){Wt(D.expression,un.parenthesizeLeftSideOfAccess),hd("!")}function Pe(D){Wt(D.expression,void 0),D.type&&(yn(),_s("satisfies"),yn(),Ke(D.type))}function ot(D){UE(D.keywordToken,D.pos,Cn),Cn("."),Ke(D.name)}function Yt(D){Wt(D.expression),Ke(D.literal)}function _n(D){gi(D,!D.multiLine&&Kx(D))}function gi(D,ue){ts(19,D.pos,Cn,D);let gt=ue||eo(D)&1?768:129;pc(D,D.statements,gt),ts(20,D.statements.end,Cn,D,!!(gt&1))}function ci(D){zp(D,D.modifiers,!1),Ke(D.declarationList),Lu()}function ds(D){D?Cn(";"):Lu()}function Ya(D){Wt(D.expression,un.parenthesizeExpressionOfExpressionStatement),(!U||!sm(U)||_c(D.expression))&&Lu()}function Xa(D){let ue=ts(101,D.pos,_s,D);yn(),ts(21,ue,Cn,D),Wt(D.expression),ts(22,D.expression.end,Cn,D),q0(D,D.thenStatement),D.elseStatement&&($y(D,D.thenStatement,D.elseStatement),ts(93,D.thenStatement.end,_s,D),D.elseStatement.kind===245?(yn(),Ke(D.elseStatement)):q0(D,D.elseStatement))}function Zc(D,ue){let gt=ts(117,ue,_s,D);yn(),ts(21,gt,Cn,D),Wt(D.expression),ts(22,D.expression.end,Cn,D)}function Gu(D){ts(92,D.pos,_s,D),q0(D,D.statement),ra(D.statement)&&!ve?yn():$y(D,D.statement,D.expression),Zc(D,D.statement.end),Lu()}function nu(D){Zc(D,D.pos),q0(D,D.statement)}function Sp(D){let ue=ts(99,D.pos,_s,D);yn();let gt=ts(21,ue,Cn,D);xo(D.initializer),gt=ts(27,D.initializer?D.initializer.end:gt,Cn,D),jE(D.condition),gt=ts(27,D.condition?D.condition.end:gt,Cn,D),jE(D.incrementor),ts(22,D.incrementor?D.incrementor.end:gt,Cn,D),q0(D,D.statement)}function Rf(D){let ue=ts(99,D.pos,_s,D);yn(),ts(21,ue,Cn,D),xo(D.initializer),yn(),ts(103,D.initializer.end,_s,D),yn(),Wt(D.expression),ts(22,D.expression.end,Cn,D),q0(D,D.statement)}function _S(D){let ue=ts(99,D.pos,_s,D);yn(),zx(D.awaitModifier),ts(21,ue,Cn,D),xo(D.initializer),yn(),ts(165,D.initializer.end,_s,D),yn(),Wt(D.expression),ts(22,D.expression.end,Cn,D),q0(D,D.statement)}function xo(D){D!==void 0&&(D.kind===261?Ke(D):Wt(D))}function Wm(D){ts(88,D.pos,_s,D),zy(D.label),Lu()}function Gm(D){ts(83,D.pos,_s,D),zy(D.label),Lu()}function ts(D,ue,gt,lr,Wn){let $i=Us(lr),Di=$i&&$i.kind===lr.kind,fs=ue;if(Di&&U&&(ue=Wa(U.text,ue)),Di&&lr.pos!==fs){let Aa=Wn&&U&&!Pd(fs,ue,U);Aa&&Qh(),W0(fs),Aa&&Km()}if(!k&&(D===19||D===20)?ue=UE(D,ue,gt,lr):ue=vS(D,gt,ue),Di&&lr.end!==ue){let Aa=lr.kind===294;Zm(ue,!Aa,Aa)}return ue}function jy(D){return D.kind===2||!!D.hasTrailingNewLine}function H1(D){if(!U)return!1;let ue=T0(U.text,D.pos);if(ue){let gt=Us(D);if(gt&&Df(gt.parent))return!0}return Tt(ue,jy)||Tt(BN(D),jy)?!0:aU(D)?D.pos!==D.expression.pos&&Tt(aT(U.text,D.expression.pos),jy)?!0:H1(D.expression):!1}function Hm(D){if(!tr&&aU(D)&&H1(D)){let ue=Us(D);if(ue&&Df(ue)){let gt=j.createParenthesizedExpression(D.expression);return Un(gt,D),ft(gt,ue),gt}return j.createParenthesizedExpression(D)}return D}function wE(D){return Hm(un.parenthesizeExpressionForDisallowedComma(D))}function OE(D){ts(107,D.pos,_s,D),jE(D.expression&&Hm(D.expression),Hm),Lu()}function md(D){let ue=ts(118,D.pos,_s,D);yn(),ts(21,ue,Cn,D),Wt(D.expression),ts(22,D.expression.end,Cn,D),q0(D,D.statement)}function lh(D){let ue=ts(109,D.pos,_s,D);yn(),ts(21,ue,Cn,D),Wt(D.expression),ts(22,D.expression.end,Cn,D),yn(),Ke(D.caseBlock)}function gd(D){Ke(D.label),ts(59,D.label.end,Cn,D),yn(),Ke(D.statement)}function By(D){ts(111,D.pos,_s,D),jE(Hm(D.expression),Hm),Lu()}function Je(D){ts(113,D.pos,_s,D),yn(),Ke(D.tryBlock),D.catchClause&&($y(D,D.tryBlock,D.catchClause),Ke(D.catchClause)),D.finallyBlock&&($y(D,D.catchClause||D.tryBlock,D.finallyBlock),ts(98,(D.catchClause||D.tryBlock).end,_s,D),yn(),Ke(D.finallyBlock))}function et(D){UE(89,D.pos,_s),Lu()}function Ft(D){var ue,gt,lr;Ke(D.name),Ke(D.exclamationToken),vm(D.type),hS(D.initializer,((ue=D.type)==null?void 0:ue.end)??((lr=(gt=D.name.emitNode)==null?void 0:gt.typeNode)==null?void 0:lr.end)??D.name.end,D,un.parenthesizeExpressionForDisallowedComma)}function Ht(D){if(v8(D))_s("await"),yn(),_s("using");else{let ue=X9(D)?"let":aN(D)?"const":S8(D)?"using":"var";_s(ue)}yn(),pc(D,D.declarations,528)}function Er(D){nn(D)}function nn(D){zp(D,D.modifiers,!1),_s("function"),Ke(D.asteriskToken),yn(),ht(D.name),br(D,sn)}function br(D,ue){let gt=D.body;if(gt)if(ra(gt)){let lr=eo(D)&131072;lr&&Qh(),a_(D),Te(D.parameters,Fu),Fu(D.body),ue(D),hn(gt),Qf(D),lr&&Km()}else ue(D),yn(),Wt(gt,un.parenthesizeConciseBodyOfArrowFunction);else ue(D),Lu()}function sn(D){uh(D,D.typeParameters),Z1(D,D.parameters),vm(D.type)}function Ci(D){if(eo(D)&1)return!0;if(D.multiLine||!_c(D)&&U&&!rx(D,U)||$0(D,qi(D.statements),2)||Gk(D,Is(D.statements),2,D.statements))return!1;let ue;for(let gt of D.statements){if(SS(ue,gt,2)>0)return!1;ue=gt}return!0}function hn(D){l?.(D),yn(),Cn("{"),Qh();let ue=Ci(D)?mi:Tn;Rn(D,D.statements,ue),Km(),UE(20,D.statements.end,Cn,D),p?.(D)}function mi(D){Tn(D,!0)}function Tn(D,ue){let gt=Lf(D.statements),lr=Ee.getTextPos();Zt(D),gt===0&&lr===Ee.getTextPos()&&ue?(Km(),pc(D,D.statements,768),Qh()):pc(D,D.statements,1,void 0,gt)}function aa(D){ao(D)}function ao(D){Bd(0,void 0),Te(D.members,Hk),zp(D,D.modifiers,!0),ts(86,Xg(D).pos,_s,D),D.name&&(yn(),ht(D.name));let ue=eo(D)&131072;ue&&Qh(),uh(D,D.typeParameters),pc(D,D.heritageClauses,0),yn(),Cn("{"),pc(D,D.members,129),Cn("}"),ue&&Km(),TS()}function B_(D){Bd(0,void 0),zp(D,D.modifiers,!1),_s("interface"),yn(),Ke(D.name),uh(D,D.typeParameters),pc(D,D.heritageClauses,512),yn(),Cn("{"),pc(D,D.members,129),Cn("}"),TS()}function Hu(D){zp(D,D.modifiers,!1),_s("type"),yn(),Ke(D.name),uh(D,D.typeParameters),yn(),Cn("="),yn(),Ke(D.type),Lu()}function Uy(D){zp(D,D.modifiers,!1),_s("enum"),yn(),Ke(D.name),yn(),Cn("{"),pc(D,D.members,145),Cn("}")}function qT(D){zp(D,D.modifiers,!1),~D.flags&2048&&(_s(D.flags&32?"namespace":"module"),yn()),Ke(D.name);let ue=D.body;if(!ue)return Lu();for(;ue&&hl(ue);)Cn("."),Ke(ue.name),ue=ue.body;yn(),Ke(ue)}function Rk(D){a_(D),Te(D.statements,Fu),gi(D,Kx(D)),Qf(D)}function zT(D){ts(19,D.pos,Cn,D),pc(D,D.clauses,129),ts(20,D.clauses.end,Cn,D,!0)}function HD(D){zp(D,D.modifiers,!1),ts(102,D.modifiers?D.modifiers.end:D.pos,_s,D),yn(),D.isTypeOnly&&(ts(156,D.pos,_s,D),yn()),Ke(D.name),yn(),ts(64,D.name.end,Cn,D),yn(),YD(D.moduleReference),Lu()}function YD(D){D.kind===80?Wt(D):Ke(D)}function XD(D){zp(D,D.modifiers,!1),ts(102,D.modifiers?D.modifiers.end:D.pos,_s,D),yn(),D.importClause&&(Ke(D.importClause),yn(),ts(161,D.importClause.end,_s,D),yn()),Wt(D.moduleSpecifier),D.attributes&&zy(D.attributes),Lu()}function Lx(D){D.isTypeOnly&&(ts(156,D.pos,_s,D),yn()),Ke(D.name),D.name&&D.namedBindings&&(ts(28,D.name.end,Cn,D),yn()),Ke(D.namedBindings)}function RE(D){let ue=ts(42,D.pos,Cn,D);yn(),ts(130,ue,_s,D),yn(),Ke(D.name)}function Mk(D){pS(D)}function KD(D){V0(D)}function Lk(D){let ue=ts(95,D.pos,_s,D);yn(),D.isExportEquals?ts(64,ue,hd,D):ts(90,ue,_s,D),yn(),Wt(D.expression,D.isExportEquals?un.getParenthesizeRightSideOfBinaryForOperator(64):un.parenthesizeExpressionOfExportDefault),Lu()}function Fk(D){zp(D,D.modifiers,!1);let ue=ts(95,D.pos,_s,D);if(yn(),D.isTypeOnly&&(ue=ts(156,ue,_s,D),yn()),D.exportClause?Ke(D.exportClause):ue=ts(42,ue,Cn,D),D.moduleSpecifier){yn();let gt=D.exportClause?D.exportClause.end:ue;ts(161,gt,_s,D),yn(),Wt(D.moduleSpecifier)}D.attributes&&zy(D.attributes),Lu()}function jk(D){Cn("{"),yn(),_s(D.token===132?"assert":"with"),Cn(":"),yn();let ue=D.elements;pc(D,ue,526226),yn(),Cn("}")}function Bk(D){ts(D.token,D.pos,_s,D),yn();let ue=D.elements;pc(D,ue,526226)}function Fx(D){Ke(D.name),Cn(":"),yn();let ue=D.value;if(!(eo(ue)&1024)){let gt=Qg(ue);Zm(gt.pos)}Ke(ue)}function Uk(D){let ue=ts(95,D.pos,_s,D);yn(),ue=ts(130,ue,_s,D),yn(),ue=ts(145,ue,_s,D),yn(),Ke(D.name),Lu()}function ME(D){let ue=ts(42,D.pos,Cn,D);yn(),ts(130,ue,_s,D),yn(),Ke(D.name)}function LE(D){pS(D)}function fS(D){V0(D)}function pS(D){Cn("{"),pc(D,D.elements,525136),Cn("}")}function V0(D){D.isTypeOnly&&(_s("type"),yn()),D.propertyName&&(Ke(D.propertyName),yn(),ts(130,D.propertyName.end,_s,D),yn()),Ke(D.name)}function $T(D){_s("require"),Cn("("),Wt(D.expression),Cn(")")}function fo(D){Ke(D.openingElement),pc(D,D.children,262144),Ke(D.closingElement)}function jx(D){Cn("<"),dS(D.tagName),z0(D,D.typeArguments),yn(),Ke(D.attributes),Cn("/>")}function QD(D){Ke(D.openingFragment),pc(D,D.children,262144),Ke(D.closingFragment)}function WT(D){if(Cn("<"),eh(D)){let ue=sI(D.tagName,D);dS(D.tagName),z0(D,D.typeArguments),D.attributes.properties&&D.attributes.properties.length>0&&yn(),Ke(D.attributes),JE(D.attributes,D),KT(ue)}Cn(">")}function Vy(D){Ee.writeLiteral(D.text)}function Xh(D){Cn("</"),fE(D)&&dS(D.tagName),Cn(">")}function jd(D){pc(D,D.properties,262656)}function Mf(D){Ke(D.name),Ym("=",Cn,D.initializer,Cr)}function Tp(D){Cn("{..."),Wt(D.expression),Cn("}")}function Kf(D){let ue=!1;return z3(U?.text||"",D+1,()=>ue=!0),ue}function Y1(D){let ue=!1;return q3(U?.text||"",D+1,()=>ue=!0),ue}function Bx(D){return Kf(D)||Y1(D)}function ZD(D){var ue;if(D.expression||!tr&&!_c(D)&&Bx(D.pos)){let gt=U&&!_c(D)&&Lo(U,D.pos).line!==Lo(U,D.end).line;gt&&Ee.increaseIndent();let lr=ts(19,D.pos,Cn,D);Ke(D.dotDotDotToken),Wt(D.expression),ts(20,((ue=D.expression)==null?void 0:ue.end)||lr,Cn,D),gt&&Ee.decreaseIndent()}}function Vk(D){ht(D.namespace),Cn(":"),ht(D.name)}function dS(D){D.kind===80?Wt(D):Ke(D)}function GT(D){ts(84,D.pos,_s,D),yn(),Wt(D.expression,un.parenthesizeExpressionForDisallowedComma),zl(D,D.statements,D.expression.end)}function Jk(D){let ue=ts(90,D.pos,_s,D);zl(D,D.statements,ue)}function zl(D,ue,gt){let lr=ue.length===1&&(!U||_c(D)||_c(ue[0])||jj(D,ue[0],U)),Wn=163969;lr?(UE(59,gt,Cn,D),yn(),Wn&=-130):ts(59,gt,Cn,D),pc(D,ue,Wn)}function X1(D){yn(),vS(D.token,_s),yn(),pc(D,D.types,528)}function qk(D){let ue=ts(85,D.pos,_s,D);yn(),D.variableDeclaration&&(ts(21,ue,Cn,D),Ke(D.variableDeclaration),ts(22,D.variableDeclaration.end,Cn,D),yn()),Ke(D.block)}function yg(D){Ke(D.name),Cn(":"),yn();let ue=D.initializer;if(!(eo(ue)&1024)){let gt=Qg(ue);Zm(gt.pos)}Wt(ue,un.parenthesizeExpressionForDisallowedComma)}function Ux(D){Ke(D.name),D.objectAssignmentInitializer&&(yn(),Cn("="),yn(),Wt(D.objectAssignmentInitializer,un.parenthesizeExpressionForDisallowedComma))}function He(D){D.expression&&(ts(26,D.pos,Cn,D),Wt(D.expression,un.parenthesizeExpressionForDisallowedComma))}function vg(D){Ke(D.name),hS(D.initializer,D.name.end,D,un.parenthesizeExpressionForDisallowedComma)}function Yu(D){if(Ge("/**"),D.comment){let ue=Z3(D.comment);if(ue){let gt=ue.split(/\r\n?|\n/g);for(let lr of gt)Cu(),yn(),Cn("*"),yn(),Ge(lr)}}D.tags&&(D.tags.length===1&&D.tags[0].kind===351&&!D.comment?(yn(),Ke(D.tags[0])):pc(D,D.tags,33)),yn(),Ge("*/")}function HT(D){hm(D.tagName),Jy(D.typeExpression),ym(D.comment)}function zk(D){hm(D.tagName),Ke(D.name),ym(D.comment)}function mS(D){yn(),Cn("{"),Ke(D.name),Cn("}")}function K1(D){hm(D.tagName),yn(),Cn("{"),Ke(D.class),Cn("}"),ym(D.comment)}function Q1(D){hm(D.tagName),Jy(D.constraint),yn(),pc(D,D.typeParameters,528),ym(D.comment)}function XO(D){hm(D.tagName),D.typeExpression&&(D.typeExpression.kind===316?Jy(D.typeExpression):(yn(),Cn("{"),Ge("Object"),D.typeExpression.isArrayType&&(Cn("["),Cn("]")),Cn("}"))),D.fullName&&(yn(),Ke(D.fullName)),ym(D.comment),D.typeExpression&&D.typeExpression.kind===329&&Jx(D.typeExpression)}function oo(D){hm(D.tagName),D.name&&(yn(),Ke(D.name)),ym(D.comment),YT(D.typeExpression)}function Sg(D){ym(D.comment),YT(D.typeExpression)}function Vx(D){hm(D.tagName),ym(D.comment)}function Jx(D){pc(D,j.createNodeArray(D.jsDocPropertyTags),33)}function YT(D){D.typeParameters&&pc(D,j.createNodeArray(D.typeParameters),33),D.parameters&&pc(D,j.createNodeArray(D.parameters),33),D.type&&(Cu(),yn(),Cn("*"),yn(),Ke(D.type))}function qx(D){hm(D.tagName),Jy(D.typeExpression),yn(),D.isBracketed&&Cn("["),Ke(D.name),D.isBracketed&&Cn("]"),ym(D.comment)}function hm(D){Cn("@"),Ke(D)}function ym(D){let ue=Z3(D);ue&&(yn(),Ge(ue))}function Jy(D){D&&(yn(),Cn("{"),Ke(D.type),Cn("}"))}function $k(D){Cu();let ue=D.statements;if(ue.length===0||!Fm(ue[0])||_c(ue[0])){Rn(D,ue,as);return}as(D)}function Tg(D){FE(!!D.hasNoDefaultLib,D.syntheticFileReferences||[],D.syntheticTypeReferences||[],D.syntheticLibReferences||[]);for(let ue of D.prepends)if(dx(ue)&&ue.syntheticReferences)for(let gt of ue.syntheticReferences)Ke(gt),Cu()}function eI(D){D.isDeclarationFile&&FE(D.hasNoDefaultLib,D.referencedFiles,D.typeReferenceDirectives,D.libReferenceDirectives)}function FE(D,ue,gt,lr){if(D){let Wn=Ee.getTextPos();_h('/// <reference no-default-lib="true"/>'),Ie&&Ie.sections.push({pos:Wn,end:Ee.getTextPos(),kind:"no-default-lib"}),Cu()}if(U&&U.moduleName&&(_h(`/// <amd-module name="${U.moduleName}" />`),Cu()),U&&U.amdDependencies)for(let Wn of U.amdDependencies)Wn.name?_h(`/// <amd-dependency name="${Wn.name}" path="${Wn.path}" />`):_h(`/// <amd-dependency path="${Wn.path}" />`),Cu();for(let Wn of ue){let $i=Ee.getTextPos();_h(`/// <reference path="${Wn.fileName}" />`),Ie&&Ie.sections.push({pos:$i,end:Ee.getTextPos(),kind:"reference",data:Wn.fileName}),Cu()}for(let Wn of gt){let $i=Ee.getTextPos(),Di=Wn.resolutionMode&&Wn.resolutionMode!==U?.impliedNodeFormat?`resolution-mode="${Wn.resolutionMode===99?"import":"require"}"`:"";_h(`/// <reference types="${Wn.fileName}" ${Di}/>`),Ie&&Ie.sections.push({pos:$i,end:Ee.getTextPos(),kind:Wn.resolutionMode?Wn.resolutionMode===99?"type-import":"type-require":"type",data:Wn.fileName}),Cu()}for(let Wn of lr){let $i=Ee.getTextPos();_h(`/// <reference lib="${Wn.fileName}" />`),Ie&&Ie.sections.push({pos:$i,end:Ee.getTextPos(),kind:"lib",data:Wn.fileName}),Cu()}}function as(D){let ue=D.statements;a_(D),Te(D.statements,Fu),Zt(D);let gt=oa(ue,lr=>!Fm(lr));eI(D),pc(D,ue,1,void 0,gt===-1?ue.length:gt),Qf(D)}function _i(D){let ue=eo(D);!(ue&1024)&&D.pos!==D.expression.pos&&Zm(D.expression.pos),Wt(D.expression),!(ue&2048)&&D.end!==D.expression.end&&W0(D.expression.end)}function Kh(D){BE(D,D.elements,528,void 0)}function Lf(D,ue,gt,lr){let Wn=!!ue;for(let $i=0;$i<D.length;$i++){let Di=D[$i];if(Fm(Di)){if(gt?!gt.has(Di.expression.text):!0){Wn&&(Wn=!1,pt(ue)),Cu();let Aa=Ee.getTextPos();Ke(Di),lr&&Ie&&Ie.sections.push({pos:Aa,end:Ee.getTextPos(),kind:"prologue",data:Di.expression.text}),gt&&gt.add(Di.expression.text)}}else return $i}return D.length}function KO(D,ue){for(let gt of D)if(!ue.has(gt.data)){Cu();let lr=Ee.getTextPos();Ke(gt),Ie&&Ie.sections.push({pos:lr,end:Ee.getTextPos(),kind:"prologue",data:gt.data}),ue&&ue.add(gt.data)}}function qy(D){if(ls(D))Lf(D.statements,D);else{let ue=new Set;for(let gt of D.prepends)KO(gt.prologues,ue);for(let gt of D.sourceFiles)Lf(gt.statements,gt,ue,!0);pt(void 0)}}function QO(D){let ue=new Set,gt;for(let lr=0;lr<D.sourceFiles.length;lr++){let Wn=D.sourceFiles[lr],$i,Di=0;for(let fs of Wn.statements){if(!Fm(fs))break;ue.has(fs.expression.text)||(ue.add(fs.expression.text),($i||($i=[])).push({pos:fs.pos,end:fs.end,expression:{pos:fs.expression.pos,end:fs.expression.end,text:fs.expression.text}}),Di=Di<fs.end?fs.end:Di)}$i&&(gt||(gt=[])).push({file:lr,text:Wn.text.substring(0,Di),directives:$i})}return gt}function gS(D){if(ls(D)||dx(D)){let ue=h9(D.text);if(ue)return _h(ue),Cu(),!0}else{for(let ue of D.prepends)if(I.assertNode(ue,dx),gS(ue))return!0;for(let ue of D.sourceFiles)if(gS(ue))return!0}}function wc(D,ue){if(!D)return;let gt=Ge;Ge=ue,Ke(D),Ge=gt}function zp(D,ue,gt){if(ue?.length){if(yr(ue,Ra))return J0(D,ue);if(yr(ue,n_))return gt?Wk(D,ue):D.pos;m?.(ue);let lr,Wn,$i=0,Di=0,fs;for(;$i<ue.length;){for(;Di<ue.length;){if(fs=ue[Di],Wn=n_(fs)?"decorators":"modifiers",lr===void 0)lr=Wn;else if(Wn!==lr)break;Di++}let Aa={pos:-1,end:-1};$i===0&&(Aa.pos=ue.pos),Di===ue.length-1&&(Aa.end=ue.end),(lr==="modifiers"||gt)&&Xm(Ke,D,ue,lr==="modifiers"?2359808:2146305,void 0,$i,Di-$i,!1,Aa),$i=Di,lr=Wn,Di++}if(S?.(ue),fs&&!_g(fs.end))return fs.end}return D.pos}function J0(D,ue){pc(D,ue,2359808);let gt=Is(ue);return gt&&!_g(gt.end)?gt.end:D.pos}function vm(D){D&&(Cn(":"),yn(),Ke(D))}function hS(D,ue,gt,lr){D&&(yn(),ts(64,ue,hd,gt),yn(),Wt(D,lr))}function Ym(D,ue,gt,lr){gt&&(ue(D),lr(gt))}function zy(D){D&&(yn(),Ke(D))}function jE(D,ue){D&&(yn(),Wt(D,ue))}function zx(D){D&&(Ke(D),yn())}function q0(D,ue){ra(ue)||eo(D)&1||ve&&!$0(D,ue,0)?(yn(),Ke(ue)):(Cu(),Qh(),FK(ue)?Y(5,ue):Ke(ue),Km())}function Wk(D,ue){pc(D,ue,2146305);let gt=Is(ue);return gt&&!_g(gt.end)?gt.end:D.pos}function z0(D,ue){pc(D,ue,53776,ri)}function uh(D,ue){if(ca(D)&&D.typeArguments)return z0(D,D.typeArguments);pc(D,ue,53776)}function Z1(D,ue){pc(D,ue,2576)}function tI(D,ue){let gt=nl(ue);return gt&&gt.pos===D.pos&&rc(D)&&!D.type&&!Tt(D.modifiers)&&!Tt(D.typeParameters)&&!Tt(gt.modifiers)&&!gt.dotDotDotToken&&!gt.questionToken&&!gt.type&&!gt.initializer&&ze(gt.name)}function rI(D,ue){tI(D,ue)?pc(D,ue,528):Z1(D,ue)}function nI(D,ue){pc(D,ue,8848)}function $x(D){switch(D&60){case 0:break;case 16:Cn(",");break;case 4:yn(),Cn("|");break;case 32:yn(),Cn("*"),yn();break;case 8:yn(),Cn("&");break}}function pc(D,ue,gt,lr,Wn,$i){Wx(Ke,D,ue,gt|(D&&eo(D)&2?65536:0),lr,Wn,$i)}function BE(D,ue,gt,lr,Wn,$i){Wx(Wt,D,ue,gt,lr,Wn,$i)}function Wx(D,ue,gt,lr,Wn,$i=0,Di=gt?gt.length-$i:0){if(gt===void 0&&lr&16384)return;let Aa=gt===void 0||$i>=gt.length||Di===0;if(Aa&&lr&32768){m?.(gt),S?.(gt);return}lr&15360&&(Cn(ITt(lr)),Aa&&gt&&Zm(gt.pos,!0)),m?.(gt),Aa?lr&1&&!(ve&&(!ue||U&&rx(ue,U)))?Cu():lr&256&&!(lr&524288)&&yn():Xm(D,ue,gt,lr,Wn,$i,Di,gt.hasTrailingComma,gt),S?.(gt),lr&15360&&(Aa&&gt&&W0(gt.end),Cn(wTt(lr)))}function Xm(D,ue,gt,lr,Wn,$i,Di,fs,Aa){let U_=(lr&262144)===0,vf=U_,Vd=$0(ue,gt[$i],lr);Vd?(Cu(Vd),vf=!1):lr&256&&yn(),lr&128&&Qh();let CS=LTt(D,Wn),Oi,t0,Kr=!1;for(let YE=0;YE<Di;YE++){let ph=gt[$i+YE];if(lr&32)Cu(),$x(lr);else if(Oi){lr&60&&Oi.end!==(ue?ue.end:-1)&&(eo(Oi)&2048||W0(Oi.end)),$x(lr),Nr(t0);let r0=SS(Oi,ph,lr);if(r0>0){if(lr&131||(Qh(),Kr=!0),vf&&lr&60&&!_g(ph.pos)){let pI=Qg(ph);Zm(pI.pos,!!(lr&512),!0)}Cu(r0),vf=!1}else Oi&&lr&512&&yn()}if(t0=to(ph),vf){let r0=Qg(ph);Zm(r0.pos)}else vf=U_;oe=ph.pos,CS(ph,D,Wn,YE),Kr&&(Km(),Kr=!1),Oi=ph}let eP=Oi?eo(Oi):0,AS=tr||!!(eP&2048),kS=fs&&lr&64&&lr&16;kS&&(Oi&&!AS?ts(28,Oi.end,Cn,Oi):Cn(",")),Oi&&(ue?ue.end:-1)!==Oi.end&&lr&60&&!AS&&W0(kS&&Aa?.end?Aa.end:Oi.end),lr&128&&Km(),Nr(t0);let aC=Gk(ue,gt[$i+Di-1],lr,Aa);aC?Cu(aC):lr&2097408&&yn()}function yS(D){Ee.writeLiteral(D)}function iI(D){Ee.writeStringLiteral(D)}function Gx(D){Ee.write(D)}function ZO(D,ue){Ee.writeSymbol(D,ue)}function Cn(D){Ee.writePunctuation(D)}function Lu(){Ee.writeTrailingSemicolon(";")}function _s(D){Ee.writeKeyword(D)}function hd(D){Ee.writeOperator(D)}function ev(D){Ee.writeParameter(D)}function _h(D){Ee.writeComment(D)}function yn(){Ee.writeSpace(" ")}function Hx(D){Ee.writeProperty(D)}function XT(D){Ee.nonEscapingWrite?Ee.nonEscapingWrite(D):Ee.write(D)}function Cu(D=1){for(let ue=0;ue<D;ue++)Ee.writeLine(ue>0)}function Qh(){Ee.increaseIndent()}function Km(){Ee.decreaseIndent()}function UE(D,ue,gt,lr){return $e?vS(D,gt,ue):HE(lr,D,gt,ue,vS)}function VE(D,ue){h&&h(D),ue(Sa(D.kind)),b&&b(D)}function vS(D,ue,gt){let lr=Sa(D);return ue(lr),gt<0?gt:gt+lr.length}function $y(D,ue,gt){if(eo(D)&1)yn();else if(ve){let lr=$p(D,ue,gt);lr?Cu(lr):yn()}else Cu()}function Yx(D){let ue=D.split(/\r\n?|\n/g),gt=Upe(ue);for(let lr of ue){let Wn=gt?lr.slice(gt):lr;Wn.length&&(Cu(),Ge(Wn))}}function Qm(D,ue){D?(Qh(),Cu(D)):ue&&yn()}function KT(D,ue){D&&Km(),ue&&Km()}function $0(D,ue,gt){if(gt&2||ve){if(gt&65536)return 1;if(ue===void 0)return!D||U&&rx(D,U)?0:1;if(ue.pos===oe||ue.kind===12)return 0;if(U&&D&&!_g(D.pos)&&!_c(ue)&&(!ue.parent||Hc(ue.parent)===Hc(D)))return ve?QT(lr=>_me(ue.pos,D.pos,U,lr)):jj(D,ue,U)?0:1;if(Xx(ue,gt))return 1}return gt&1?1:0}function SS(D,ue,gt){if(gt&2||ve){if(D===void 0||ue===void 0||ue.kind===12)return 0;if(U&&!_c(D)&&!_c(ue))return ve&&yf(D,ue)?QT(lr=>DX(D,ue,U,lr)):!ve&&yd(D,ue)?nR(D,ue,U)?0:1:gt&65536?1:0;if(Xx(D,gt)||Xx(ue,gt))return 1}else if(I6(ue))return 1;return gt&1?1:0}function Gk(D,ue,gt,lr){if(gt&2||ve){if(gt&65536)return 1;if(ue===void 0)return!D||U&&rx(D,U)?0:1;if(U&&D&&!_g(D.pos)&&!_c(ue)&&(!ue.parent||ue.parent===D)){if(ve){let Wn=lr&&!_g(lr.end)?lr.end:ue.end;return QT($i=>fme(Wn,D.end,U,$i))}return cme(D,ue,U)?0:1}if(Xx(ue,gt))return 1}return gt&1&&!(gt&131072)?1:0}function QT(D){I.assert(!!ve);let ue=D(!0);return ue===0?D(!1):ue}function sI(D,ue){let gt=ve&&$0(ue,D,0);return gt&&Qm(gt,!1),!!gt}function JE(D,ue){let gt=ve&&Gk(ue,D,0,void 0);gt&&Cu(gt)}function Xx(D,ue){if(_c(D)){let gt=I6(D);return gt===void 0?(ue&65536)!==0:gt}return(ue&65536)!==0}function $p(D,ue,gt){return eo(D)&262144?0:(D=ll(D),ue=ll(ue),gt=ll(gt),I6(gt)?1:U&&!_c(D)&&!_c(ue)&&!_c(gt)?ve?QT(lr=>DX(ue,gt,U,lr)):nR(ue,gt,U)?0:1:0)}function Kx(D){return D.statements.length===0&&(!U||nR(D,D,U))}function ll(D){for(;D.kind===217&&_c(D);)D=D.expression;return D}function du(D,ue){if(yc(D)||F2(D))return Zx(D);if(za(D)&&D.textSourceNode)return du(D.textSourceNode,ue);let gt=U,lr=!!gt&&!!D.parent&&!_c(D);if(E0(D)){if(!lr||Xr(D)!==Hc(gt))return Nn(D)}else if(pg(D)){if(!lr||Xr(D)!==Hc(gt))return k6(D)}else if(I.assertNode(D,Ub),!lr)return D.text;return Jb(gt,D,ue)}function Qx(D,ue,gt){if(D.kind===11&&D.textSourceNode){let Wn=D.textSourceNode;if(ze(Wn)||is(Wn)||_p(Wn)||pg(Wn)){let $i=_p(Wn)?Wn.text:du(Wn);return gt?`"${mX($i)}"`:ue||eo(D)&16777216?`"${D0($i)}"`:`"${K8($i)}"`}else return Qx(Wn,ue,gt)}let lr=(ue?1:0)|(gt?2:0)|(e.terminateUnterminatedLiterals?4:0)|(e.target&&e.target>=8?8:0);return Kpe(D,U,lr)}function a_(D){D&&eo(D)&1048576||(xe.push(Z),Z=0,pe.push(z),z=void 0,Q.push(ce))}function Qf(D){D&&eo(D)&1048576||(Z=xe.pop(),z=pe.pop(),ce=Q.pop())}function ZT(D){(!ce||ce===Is(Q))&&(ce=new Set),ce.add(D)}function Bd(D,ue){se.push(Se),Se=D,ye.push(ce),we=ue}function TS(){Se=se.pop(),we=ye.pop()}function bS(D){(!we||we===Is(ye))&&(we=new Set),we.add(D)}function Fu(D){if(D)switch(D.kind){case 241:Te(D.statements,Fu);break;case 256:case 254:case 246:case 247:Fu(D.statement);break;case 245:Fu(D.thenStatement),Fu(D.elseStatement);break;case 248:case 250:case 249:Fu(D.initializer),Fu(D.statement);break;case 255:Fu(D.caseBlock);break;case 269:Te(D.clauses,Fu);break;case 296:case 297:Te(D.statements,Fu);break;case 258:Fu(D.tryBlock),Fu(D.catchClause),Fu(D.finallyBlock);break;case 299:Fu(D.variableDeclaration),Fu(D.block);break;case 243:Fu(D.declarationList);break;case 261:Te(D.declarations,Fu);break;case 260:case 169:case 208:case 263:Wp(D.name);break;case 262:Wp(D.name),eo(D)&1048576&&(Te(D.parameters,Fu),Fu(D.body));break;case 206:case 207:Te(D.elements,Fu);break;case 272:Fu(D.importClause);break;case 273:Wp(D.name),Fu(D.namedBindings);break;case 274:Wp(D.name);break;case 280:Wp(D.name);break;case 275:Te(D.elements,Fu);break;case 276:Wp(D.propertyName||D.name);break}}function Hk(D){if(D)switch(D.kind){case 303:case 304:case 172:case 174:case 177:case 178:Wp(D.name);break}}function Wp(D){D&&(yc(D)||F2(D)?Zx(D):la(D)&&Fu(D))}function Zx(D){let ue=D.emitNode.autoGenerate;if((ue.flags&7)===4)return eC(HR(D),is(D),ue.flags,ue.prefix,ue.suffix);{let gt=ue.id;return re[gt]||(re[gt]=oI(D))}}function eC(D,ue,gt,lr,Wn){let $i=yo(D),Di=ue?K:H;return Di[$i]||(Di[$i]=tC(D,ue,gt??0,eD(lr,Zx),eD(Wn)))}function ac(D,ue){return eb(D,ue)&&!aI(D,ue)&&!$.has(D)}function aI(D,ue){return ue?!!we?.has(D):!!ce?.has(D)}function eb(D,ue){return U?q9(U,D,n):!0}function qE(D,ue){for(let gt=ue;gt&&Yb(gt,ue);gt=gt.nextContainer)if(Oh(gt)&&gt.locals){let lr=gt.locals.get(Pc(D));if(lr&&lr.flags&3257279)return!1}return!0}function e4(D){switch(D){case"":return Z;case"#":return Se;default:return z?.get(D)??0}}function rf(D,ue){switch(D){case"":Z=ue;break;case"#":Se=ue;break;default:z??(z=new Map),z.set(D,ue);break}}function Wy(D,ue,gt,lr,Wn){lr.length>0&&lr.charCodeAt(0)===35&&(lr=lr.slice(1));let $i=NT(gt,lr,"",Wn),Di=e4($i);if(D&&!(Di&D)){let Aa=NT(gt,lr,D===268435456?"_i":"_n",Wn);if(ac(Aa,gt))return Di|=D,gt?bS(Aa):ue&&ZT(Aa),rf($i,Di),Aa}for(;;){let fs=Di&268435455;if(Di++,fs!==8&&fs!==13){let Aa=fs<26?"_"+String.fromCharCode(97+fs):"_"+(fs-26),U_=NT(gt,lr,Aa,Wn);if(ac(U_,gt))return gt?bS(U_):ue&&ZT(U_),rf($i,Di),U_}}}function fh(D,ue=ac,gt,lr,Wn,$i,Di){if(D.length>0&&D.charCodeAt(0)===35&&(D=D.slice(1)),$i.length>0&&$i.charCodeAt(0)===35&&($i=$i.slice(1)),gt){let Aa=NT(Wn,$i,D,Di);if(ue(Aa,Wn))return Wn?bS(Aa):lr?ZT(Aa):$.add(Aa),Aa}D.charCodeAt(D.length-1)!==95&&(D+="_");let fs=1;for(;;){let Aa=NT(Wn,$i,D+fs,Di);if(ue(Aa,Wn))return Wn?bS(Aa):lr?ZT(Aa):$.add(Aa),Aa;fs++}}function Yk(D){return fh(D,eb,!0,!1,!1,"","")}function bp(D){let ue=du(D.name);return qE(ue,ii(D,Oh))?ue:fh(ue,ac,!1,!1,!1,"","")}function Xk(D){let ue=mN(D),gt=za(ue)?Zpe(ue.text):"module";return fh(gt,ac,!1,!1,!1,"","")}function Zf(){return fh("default",ac,!1,!1,!1,"","")}function Kk(){return fh("class",ac,!1,!1,!1,"","")}function tv(D,ue,gt,lr){return ze(D.name)?eC(D.name,ue):Wy(0,!1,ue,gt,lr)}function tC(D,ue,gt,lr,Wn){switch(D.kind){case 80:case 81:return fh(du(D),ac,!!(gt&16),!!(gt&8),ue,lr,Wn);case 267:case 266:return I.assert(!lr&&!Wn&&!ue),bp(D);case 272:case 278:return I.assert(!lr&&!Wn&&!ue),Xk(D);case 262:case 263:{I.assert(!lr&&!Wn&&!ue);let $i=D.name;return $i&&!yc($i)?tC($i,!1,gt,lr,Wn):Zf()}case 277:return I.assert(!lr&&!Wn&&!ue),Zf();case 231:return I.assert(!lr&&!Wn&&!ue),Kk();case 174:case 177:case 178:return tv(D,ue,lr,Wn);case 167:return Wy(0,!0,ue,lr,Wn);default:return Wy(0,!1,ue,lr,Wn)}}function oI(D){let ue=D.emitNode.autoGenerate,gt=eD(ue.prefix,Zx),lr=eD(ue.suffix);switch(ue.flags&7){case 1:return Wy(0,!!(ue.flags&8),is(D),gt,lr);case 2:return I.assertNode(D,ze),Wy(268435456,!!(ue.flags&8),!1,gt,lr);case 3:return fh(Nn(D),ue.flags&32?eb:ac,!!(ue.flags&16),!!(ue.flags&8),is(D),gt,lr)}return I.fail(`Unsupported GeneratedIdentifierKind: ${I.formatEnum(ue.flags&7,K5,!0)}.`)}function cI(D,ue){let gt=le(2,D,ue),lr=ar,Wn=or,$i=Fr;rC(ue),gt(D,ue),lI(ue,lr,Wn,$i)}function rC(D){let ue=eo(D),gt=Qg(D);ES(D,ue,gt.pos,gt.end),ue&4096&&(tr=!0)}function lI(D,ue,gt,lr){let Wn=eo(D),$i=Qg(D);Wn&4096&&(tr=!1),Ep(D,Wn,$i.pos,$i.end,ue,gt,lr);let Di=uge(D);Di&&Ep(D,Wn,Di.pos,Di.end,ue,gt,lr)}function ES(D,ue,gt,lr){zi(),nr=!1;let Wn=gt<0||(ue&1024)!==0||D.kind===12,$i=lr<0||(ue&2048)!==0||D.kind===12;(gt>0||lr>0)&&gt!==lr&&(Wn||zE(gt,D.kind!==359),(!Wn||gt>=0&&ue&1024)&&(ar=gt),(!$i||lr>=0&&ue&2048)&&(or=lr,D.kind===261&&(Fr=lr))),Te(BN(D),Zh),Ms()}function Ep(D,ue,gt,lr,Wn,$i,Di){zi();let fs=lr<0||(ue&2048)!==0||D.kind===12;Te(AR(D),uI),(gt>0||lr>0)&&gt!==lr&&(ar=Wn,or=$i,Fr=Di,!fs&&D.kind!==359&&bg(lr)),Ms()}function Zh(D){(D.hasLeadingNewline||D.kind===2)&&Ee.writeLine(),nC(D),D.hasTrailingNewLine||D.kind===2?Ee.writeLine():Ee.writeSpace(" ")}function uI(D){Ee.isAtStartOfLine()||Ee.writeSpace(" "),nC(D),D.hasTrailingNewLine&&Ee.writeLine()}function nC(D){let ue=mo(D),gt=D.kind===3?mA(ue):void 0;kN(ue,gt,Ee,0,ue.length,N)}function mo(D){return D.kind===3?`/*${D.text}*/`:`//${D.text}`}function Rn(D,ue,gt){zi();let{pos:lr,end:Wn}=ue,$i=eo(D),Di=lr<0||($i&1024)!==0,fs=tr||Wn<0||($i&2048)!==0;Di||Ud(ue),Ms(),$i&4096&&!tr?(tr=!0,gt(D),tr=!1):gt(D),zi(),fs||(zE(ue.end,!0),nr&&!Ee.isAtStartOfLine()&&Ee.writeLine()),Ms()}function yd(D,ue){return D=Hc(D),D.parent&&D.parent===Hc(ue).parent}function yf(D,ue){if(ue.pos<D.end)return!1;D=Hc(D),ue=Hc(ue);let gt=D.parent;if(!gt||gt!==ue.parent)return!1;let lr=Vme(D),Wn=lr?.indexOf(D);return Wn!==void 0&&Wn>-1&&lr.indexOf(ue)===Wn+1}function zE(D,ue){nr=!1,ue?D===0&&U?.isDeclarationFile?H0(D,tb):H0(D,iC):D===0&&H0(D,_I)}function _I(D,ue,gt,lr,Wn){Sd(D,ue)&&iC(D,ue,gt,lr,Wn)}function tb(D,ue,gt,lr,Wn){Sd(D,ue)||iC(D,ue,gt,lr,Wn)}function $E(D,ue){return e.onlyPrintJsDocStyle?oQ(D,ue)||z9(D,ue):!0}function iC(D,ue,gt,lr,Wn){!U||!$E(U.text,D)||(nr||(Gde(Nt(),Ee,Wn,D),nr=!0),Ho(D),kN(U.text,Nt(),Ee,D,ue,N),Ho(ue),lr?Ee.writeLine():gt===3&&Ee.writeSpace(" "))}function W0(D){tr||D===-1||zE(D,!0)}function bg(D){Qk(D,vd)}function vd(D,ue,gt,lr){!U||!$E(U.text,D)||(Ee.isAtStartOfLine()||Ee.writeSpace(" "),Ho(D),kN(U.text,Nt(),Ee,D,ue,N),Ho(ue),lr&&Ee.writeLine())}function Zm(D,ue,gt){tr||(zi(),Qk(D,ue?vd:gt?Gy:G0),Ms())}function Gy(D,ue,gt){U&&(Ho(D),kN(U.text,Nt(),Ee,D,ue,N),Ho(ue),gt===2&&Ee.writeLine())}function G0(D,ue,gt,lr){U&&(Ho(D),kN(U.text,Nt(),Ee,D,ue,N),Ho(ue),lr?Ee.writeLine():Ee.writeSpace(" "))}function H0(D,ue){U&&(ar===-1||D!==ar)&&(Dl(D)?fI(ue):q3(U.text,D,ue,D))}function Qk(D,ue){U&&(or===-1||D!==or&&D!==Fr)&&z3(U.text,D,ue)}function Dl(D){return Tr!==void 0&&Rs(Tr).nodePos===D}function fI(D){if(!U)return;let ue=Rs(Tr).detachedCommentEndPos;Tr.length-1?Tr.pop():Tr=void 0,q3(U.text,ue,D,ue)}function Ud(D){let ue=U&&Yde(U.text,Nt(),Ee,e0,D,N,tr);ue&&(Tr?Tr.push(ue):Tr=[ue])}function e0(D,ue,gt,lr,Wn,$i){!U||!$E(U.text,lr)||(Ho(lr),kN(D,ue,gt,lr,Wn,$i),Ho(Wn))}function Sd(D,ue){return!!U&&xY(U.text,D,ue)}function WE(D){return D.parsedSourceMap===void 0&&D.sourceMapText!==void 0&&(D.parsedSourceMap=sZ(D.sourceMapText)||!1),D.parsedSourceMap||void 0}function rb(D,ue){let gt=le(3,D,ue);Zk(ue),gt(D,ue),sC(ue)}function Zk(D){let ue=eo(D),gt=R1(D);if(sY(D)){I.assertIsDefined(D.parent,"UnparsedNodes must have parent pointers");let lr=WE(D.parent);lr&&at&&at.appendSourceMap(Ee.getLine(),Ee.getColumn(),lr,D.parent.sourceMapPath,D.parent.getLineAndCharacterOfPosition(D.pos),D.parent.getLineAndCharacterOfPosition(D.end))}else{let lr=gt.source||$t;D.kind!==359&&!(ue&32)&&gt.pos>=0&&GE(gt.source||$t,Td(lr,gt.pos)),ue&128&&($e=!0)}}function sC(D){let ue=eo(D),gt=R1(D);sY(D)||(ue&128&&($e=!1),D.kind!==359&&!(ue&64)&&gt.end>=0&&GE(gt.source||$t,gt.end))}function Td(D,ue){return D.skipTrivia?D.skipTrivia(ue):Wa(D.text,ue)}function Ho(D){if($e||_g(D)||nb($t))return;let{line:ue,character:gt}=Lo($t,D);at.addMapping(Ee.getLine(),Ee.getColumn(),St,ue,gt,void 0)}function GE(D,ue){if(D!==$t){let gt=$t,lr=St;Hy(D),Ho(ue),xS(gt,lr)}else Ho(ue)}function HE(D,ue,gt,lr,Wn){if($e||D&&uj(D))return Wn(ue,gt,lr);let $i=D&&D.emitNode,Di=$i&&$i.flags||0,fs=$i&&$i.tokenSourceMapRanges&&$i.tokenSourceMapRanges[ue],Aa=fs&&fs.source||$t;return lr=Td(Aa,fs?fs.pos:lr),!(Di&256)&&lr>=0&&GE(Aa,lr),lr=Wn(ue,gt,lr),fs&&(lr=fs.end),!(Di&512)&&lr>=0&&GE(Aa,lr),lr}function Hy(D){if(!$e){if($t=D,D===Ze){St=yt;return}nb(D)||(St=at.addSource(D.fileName),e.inlineSources&&at.setSourceContent(St,D.text),Ze=D,yt=St)}}function xS(D,ue){$t=D,St=ue}function nb(D){return Uc(D.fileName,".json")}}function DTt(){let e=[];return e[1024]=["{","}"],e[2048]=["(",")"],e[4096]=["<",">"],e[8192]=["[","]"],e}function ITt(e){return Q0e[e&15360][0]}function wTt(e){return Q0e[e&15360][1]}function OTt(e,t,n,i){t(e)}function RTt(e,t,n,i){t(e,n.select(i))}function MTt(e,t,n,i){t(e,n)}function LTt(e,t){return e.length===1?OTt:typeof t=="object"?RTt:MTt}var Q0e,gV,NZ,EE,DZ,kM,FTt=f({"src/compiler/emitter.ts"(){"use strict";fa(),fa(),O2(),Q0e=DTt(),gV={hasGlobalName:Ks,getReferencedExportContainer:Ks,getReferencedImportDeclaration:Ks,getReferencedDeclarationWithCollidingName:Ks,isDeclarationWithCollidingName:Ks,isValueAliasDeclaration:Ks,isReferencedAliasDeclaration:Ks,isTopLevelValueImportEqualsWithEntityName:Ks,getNodeCheckFlags:Ks,isDeclarationVisible:Ks,isLateBound:e=>!1,collectLinkedAliases:Ks,isImplementationOfOverload:Ks,isRequiredInitializedParameter:Ks,isOptionalUninitializedParameterProperty:Ks,isExpandoFunctionDeclaration:Ks,getPropertiesOfContainerFunction:Ks,createTypeOfDeclaration:Ks,createReturnTypeOfSignatureDeclaration:Ks,createTypeOfExpression:Ks,createLiteralConstValue:Ks,isSymbolAccessible:Ks,isEntityNameVisible:Ks,getConstantValue:Ks,getReferencedValueDeclaration:Ks,getReferencedValueDeclarations:Ks,getTypeReferenceSerializationKind:Ks,isOptionalParameter:Ks,moduleExportsSomeValue:Ks,isArgumentsLocalBinding:Ks,getExternalModuleFileFromDeclaration:Ks,getTypeReferenceDirectivesForEntityName:Ks,getTypeReferenceDirectivesForSymbol:Ks,isLiteralConstDeclaration:Ks,getJsxFactoryEntity:Ks,getJsxFragmentFactoryEntity:Ks,getAllAccessorDeclarations:Ks,getSymbolOfExternalModuleSpecifier:Ks,isBindingCapturedByNode:Ks,getDeclarationStatementsForSourceFile:Ks,isImportRequiredByAugmentation:Ks,tryFindAmbientModule:Ks},NZ=D_(()=>RT({})),EE=D_(()=>RT({removeComments:!0})),DZ=D_(()=>RT({removeComments:!0,neverAsciiEscape:!0})),kM=D_(()=>RT({removeComments:!0,omitTrailingSemicolon:!0}))}});function hV(e,t,n){if(!e.getDirectories||!e.readDirectory)return;let i=new Map,s=y_(n);return{useCaseSensitiveFileNames:n,fileExists:k,readFile:(z,se)=>e.readFile(z,se),directoryExists:e.directoryExists&&N,getDirectories:O,readDirectory:U,createDirectory:e.createDirectory&&M,writeFile:e.writeFile&&A,addOrDeleteFileOrDirectory:K,addOrDeleteFile:re,clearCache:pe,realpath:e.realpath&&H};function o(z){return gc(z,t,s)}function l(z){return i.get(hu(z))}function p(z){let se=l(hi(z));return se&&(se.sortedAndCanonicalizedFiles||(se.sortedAndCanonicalizedFiles=se.files.map(s).sort(),se.sortedAndCanonicalizedDirectories=se.directories.map(s).sort()),se)}function m(z){return Cl(Ca(z))}function S(z,se){var Se;if(!e.realpath||hu(o(e.realpath(z)))===se){let xe={files:vr(e.readDirectory(z,void 0,void 0,["*.*"]),m)||[],directories:e.getDirectories(z)||[]};return i.set(hu(se),xe),xe}if((Se=e.directoryExists)!=null&&Se.call(e,z))return i.set(se,!1),!1}function h(z,se){se=hu(se);let Se=l(se);if(Se)return Se;try{return S(z,se)}catch{I.assert(!i.has(hu(se)));return}}function b(z,se){return Bg(z,se,Mo,h_)>=0}function A(z,se,Se){let xe=o(z),Z=p(xe);return Z&&$(Z,m(z),!0),e.writeFile(z,se,Se)}function k(z){let se=o(z),Se=p(se);return Se&&b(Se.sortedAndCanonicalizedFiles,s(m(z)))||e.fileExists(z)}function N(z){let se=o(z);return i.has(hu(se))||e.directoryExists(z)}function M(z){let se=o(z),Se=p(se);if(Se){let xe=m(z),Z=s(xe),Q=Se.sortedAndCanonicalizedDirectories;lf(Q,Z,h_)&&Se.directories.push(xe)}e.createDirectory(z)}function O(z){let se=o(z),Se=h(z,se);return Se?Se.directories.slice():e.getDirectories(z)}function U(z,se,Se,xe,Z){let Q=o(z),ce=h(z,Q),ye;if(ce!==void 0)return JX(z,se,Se,xe,n,t,Z,we,H);return e.readDirectory(z,se,Se,xe,Z);function we(oe){let Ee=o(oe);if(Ee===Q)return ce||ve(oe,Ee);let Me=h(oe,Ee);return Me!==void 0?Me||ve(oe,Ee):yB}function ve(oe,Ee){if(ye&&Ee===Q)return ye;let Me={files:vr(e.readDirectory(oe,void 0,void 0,["*.*"]),m)||tt,directories:e.getDirectories(oe)||tt};return Ee===Q&&(ye=Me),Me}}function H(z){return e.realpath?e.realpath(z):z}function K(z,se){if(l(se)!==void 0){pe();return}let xe=p(se);if(!xe)return;if(!e.directoryExists){pe();return}let Z=m(z),Q={fileExists:e.fileExists(z),directoryExists:e.directoryExists(z)};return Q.directoryExists||b(xe.sortedAndCanonicalizedDirectories,s(Z))?pe():$(xe,Z,Q.fileExists),Q}function re(z,se,Se){if(Se===1)return;let xe=p(se);xe&&$(xe,m(z),Se===0)}function $(z,se,Se){let xe=z.sortedAndCanonicalizedFiles,Z=s(se);if(Se)lf(xe,Z,h_)&&z.files.push(se);else{let Q=Bg(xe,Z,Mo,h_);if(Q>=0){xe.splice(Q,1);let ce=z.files.findIndex(ye=>s(ye)===Z);z.files.splice(ce,1)}}}function pe(){i.clear()}}function yV(e,t,n,i,s){var o;let l=il(((o=t?.configFile)==null?void 0:o.extendedSourceFiles)||tt,s);n.forEach((p,m)=>{l.has(m)||(p.projects.delete(e),p.close())}),l.forEach((p,m)=>{let S=n.get(m);S?S.projects.add(e):n.set(m,{projects:new Set([e]),watcher:i(p,m),close:()=>{let h=n.get(m);!h||h.projects.size!==0||(h.watcher.close(),n.delete(m))}})})}function IZ(e,t){t.forEach(n=>{n.projects.delete(e)&&n.close()})}function vV(e,t,n){e.delete(t)&&e.forEach(({extendedResult:i},s)=>{var o;(o=i.extendedSourceFiles)!=null&&o.some(l=>n(l)===t)&&vV(e,s,n)})}function wZ(e,t,n){f6(t,e.getMissingFilePaths(),{createNewValue:n,onDeleteValue:ug})}function PM(e,t,n){t?f6(e,new Map(Object.entries(t)),{createNewValue:i,onDeleteValue:Od,onExistingValue:s}):Wf(e,Od);function i(o,l){return{watcher:n(o,l),flags:l}}function s(o,l,p){o.flags!==l&&(o.watcher.close(),e.set(p,i(p,l)))}}function NM({watchedDirPath:e,fileOrDirectory:t,fileOrDirectoryPath:n,configFileName:i,options:s,program:o,extraFileExtensions:l,currentDirectory:p,useCaseSensitiveFileNames:m,writeLog:S,toPath:h,getScriptKind:b}){let A=IV(n);if(!A)return S(`Project: ${i} Detected ignored path: ${t}`),!0;if(n=A,n===e)return!1;if(pA(n)&&!(Ome(t,s,l)||U()))return S(`Project: ${i} Detected file add/remove of non supported extension: ${t}`),!0;if(mhe(t,s.configFile.configFileSpecs,Ps(hi(i),p),m,p))return S(`Project: ${i} Detected excluded file: ${t}`),!0;if(!o||Wo(s)||s.outDir)return!1;if(i_(n)){if(s.declarationDir)return!1}else if(!Ql(n,jN))return!1;let k=ff(n),N=os(o)?void 0:jTt(o)?o.getProgramOrUndefined():o,M=!N&&!os(o)?o:void 0;if(O(k+".ts")||O(k+".tsx"))return S(`Project: ${i} Detected output file: ${t}`),!0;return!1;function O(H){return N?!!N.getSourceFileByPath(H):M?M.getState().fileInfos.has(H):!!mr(o,K=>h(K)===H)}function U(){if(!b)return!1;switch(b(t)){case 3:case 4:case 7:case 5:return!0;case 1:case 2:return Hv(s);case 6:return xT(s);case 0:return!1}}}function jTt(e){return!!e.getState}function Z0e(e,t){return e?e.isEmittedFile(t):!1}function OZ(e,t,n,i){Ffe(t===2?n:ja);let s={watchFile:(M,O,U,H)=>e.watchFile(M,O,U,H),watchDirectory:(M,O,U,H)=>e.watchDirectory(M,O,(U&1)!==0,H)},o=t!==0?{watchFile:k("watchFile"),watchDirectory:k("watchDirectory")}:void 0,l=t===2?{watchFile:b,watchDirectory:A}:o||s,p=t===2?h:vD;return{watchFile:m("watchFile"),watchDirectory:m("watchDirectory")};function m(M){return(O,U,H,K,re,$)=>{var pe;return PU(O,M==="watchFile"?K?.excludeFiles:K?.excludeDirectories,S(),((pe=e.getCurrentDirectory)==null?void 0:pe.call(e))||"")?p(O,H,K,re,$):l[M].call(void 0,O,U,H,K,re,$)}}function S(){return typeof e.useCaseSensitiveFileNames=="boolean"?e.useCaseSensitiveFileNames:e.useCaseSensitiveFileNames()}function h(M,O,U,H,K){return n(`ExcludeWatcher:: Added:: ${N(M,O,U,H,K,i)}`),{close:()=>n(`ExcludeWatcher:: Close:: ${N(M,O,U,H,K,i)}`)}}function b(M,O,U,H,K,re){n(`FileWatcher:: Added:: ${N(M,U,H,K,re,i)}`);let $=o.watchFile(M,O,U,H,K,re);return{close:()=>{n(`FileWatcher:: Close:: ${N(M,U,H,K,re,i)}`),$.close()}}}function A(M,O,U,H,K,re){let $=`DirectoryWatcher:: Added:: ${N(M,U,H,K,re,i)}`;n($);let pe=uc(),z=o.watchDirectory(M,O,U,H,K,re),se=uc()-pe;return n(`Elapsed:: ${se}ms ${$}`),{close:()=>{let Se=`DirectoryWatcher:: Close:: ${N(M,U,H,K,re,i)}`;n(Se);let xe=uc();z.close();let Z=uc()-xe;n(`Elapsed:: ${Z}ms ${Se}`)}}}function k(M){return(O,U,H,K,re,$)=>s[M].call(void 0,O,(...pe)=>{let z=`${M==="watchFile"?"FileWatcher":"DirectoryWatcher"}:: Triggered with ${pe[0]} ${pe[1]!==void 0?pe[1]:""}:: ${N(O,H,K,re,$,i)}`;n(z);let se=uc();U.call(void 0,...pe);let Se=uc()-se;n(`Elapsed:: ${Se}ms ${z}`)},H,K,re,$)}function N(M,O,U,H,K,re){return`WatchInfo: ${M} ${O} ${JSON.stringify(U)} ${re?re(H,K):K===void 0?H:`${H} ${K}`}`}}function DM(e){let t=e?.fallbackPolling;return{watchFile:t!==void 0?t:1}}function Od(e){e.watcher.close()}var RZ,MZ,BTt=f({"src/compiler/watchUtilities.ts"(){"use strict";fa(),RZ=(e=>(e[e.Update=0]="Update",e[e.RootNamesAndUpdate=1]="RootNamesAndUpdate",e[e.Full=2]="Full",e))(RZ||{}),MZ=(e=>(e[e.None=0]="None",e[e.TriggerOnly=1]="TriggerOnly",e[e.Verbose=2]="Verbose",e))(MZ||{})}});function eye(e,t,n="tsconfig.json"){return Rm(e,i=>{let s=li(i,n);return t(s)?s:void 0})}function SV(e,t){let n=hi(t),i=ap(e)?e:li(n,e);return Ca(i)}function tye(e,t,n){let i;return Te(e,o=>{let l=L3(o,t);if(l.pop(),!i){i=l;return}let p=Math.min(i.length,l.length);for(let m=0;m<p;m++)if(n(i[m])!==n(l[m])){if(m===0)return!0;i.length=m;break}l.length<i.length&&(i.length=l.length)})?"":i?Nv(i):t}function rye(e,t){return jZ(e,t)}function LZ(e,t,n){return(i,s,o)=>{let l;try{mc("beforeIORead"),l=e(i,t().charset),mc("afterIORead"),rd("I/O Read","beforeIORead","afterIORead")}catch(p){o&&o(p.message),l=""}return l!==void 0?KR(i,l,s,n):void 0}}function FZ(e,t,n){return(i,s,o,l)=>{try{mc("beforeIOWrite"),vX(i,s,o,e,t,n),mc("afterIOWrite"),rd("I/O Write","beforeIOWrite","afterIOWrite")}catch(p){l&&l(p.message)}}}function jZ(e,t,n=Zu){let i=new Map,s=y_(n.useCaseSensitiveFileNames);function o(h){return i.has(h)?!0:(S.directoryExists||n.directoryExists)(h)?(i.set(h,!0),!0):!1}function l(){return hi(Ca(n.getExecutingFilePath()))}let p=w1(e),m=n.realpath&&(h=>n.realpath(h)),S={getSourceFile:LZ(h=>S.readFile(h),()=>e,t),getDefaultLibLocation:l,getDefaultLibFileName:h=>li(l(),W3(h)),writeFile:FZ((h,b,A)=>n.writeFile(h,b,A),h=>(S.createDirectory||n.createDirectory)(h),h=>o(h)),getCurrentDirectory:D_(()=>n.getCurrentDirectory()),useCaseSensitiveFileNames:()=>n.useCaseSensitiveFileNames,getCanonicalFileName:s,getNewLine:()=>p,fileExists:h=>n.fileExists(h),readFile:h=>n.readFile(h),trace:h=>n.write(h+p),directoryExists:h=>n.directoryExists(h),getEnvironmentVariable:h=>n.getEnvironmentVariable?n.getEnvironmentVariable(h):"",getDirectories:h=>n.getDirectories(h),realpath:m,readDirectory:(h,b,A,k,N)=>n.readDirectory(h,b,A,k,N),createDirectory:h=>n.createDirectory(h),createHash:rs(n,n.createHash)};return S}function IM(e,t,n){let i=e.readFile,s=e.fileExists,o=e.directoryExists,l=e.createDirectory,p=e.writeFile,m=new Map,S=new Map,h=new Map,b=new Map,A=M=>{let O=t(M),U=m.get(O);return U!==void 0?U!==!1?U:void 0:k(O,M)},k=(M,O)=>{let U=i.call(e,O);return m.set(M,U!==void 0?U:!1),U};e.readFile=M=>{let O=t(M),U=m.get(O);return U!==void 0?U!==!1?U:void 0:!Uc(M,".json")&&!Y0e(M)?i.call(e,M):k(O,M)};let N=n?(M,O,U,H)=>{let K=t(M),re=typeof O=="object"?O.impliedNodeFormat:void 0,$=b.get(re),pe=$?.get(K);if(pe)return pe;let z=n(M,O,U,H);return z&&(i_(M)||Uc(M,".json"))&&b.set(re,($||new Map).set(K,z)),z}:void 0;return e.fileExists=M=>{let O=t(M),U=S.get(O);if(U!==void 0)return U;let H=s.call(e,M);return S.set(O,!!H),H},p&&(e.writeFile=(M,O,...U)=>{let H=t(M);S.delete(H);let K=m.get(H);K!==void 0&&K!==O?(m.delete(H),b.forEach(re=>re.delete(H))):N&&b.forEach(re=>{let $=re.get(H);$&&$.text!==O&&re.delete(H)}),p.call(e,M,O,...U)}),o&&(e.directoryExists=M=>{let O=t(M),U=h.get(O);if(U!==void 0)return U;let H=o.call(e,M);return h.set(O,!!H),H},l&&(e.createDirectory=M=>{let O=t(M);h.delete(O),l.call(e,M)})),{originalReadFile:i,originalFileExists:s,originalDirectoryExists:o,originalCreateDirectory:l,originalWriteFile:p,getSourceFileWithCache:N,readFileWithCache:A}}function BMe(e,t,n){let i;return i=jt(i,e.getConfigFileParsingDiagnostics()),i=jt(i,e.getOptionsDiagnostics(n)),i=jt(i,e.getSyntacticDiagnostics(t,n)),i=jt(i,e.getGlobalDiagnostics(n)),i=jt(i,e.getSemanticDiagnostics(t,n)),Dd(e.getCompilerOptions())&&(i=jt(i,e.getDeclarationDiagnostics(t,n))),WP(i||tt)}function UMe(e,t){let n="";for(let i of e)n+=BZ(i,t);return n}function BZ(e,t){let n=`${R2(e)} TS${e.code}: ${nh(e.messageText,t.getNewLine())}${t.getNewLine()}`;if(e.file){let{line:i,character:s}=Lo(e.file,e.start),o=e.file.fileName;return`${bw(o,t.getCurrentDirectory(),p=>t.getCanonicalFileName(p))}(${i+1},${s+1}): `+n}return n}function VMe(e){switch(e){case 1:return"\x1B[91m";case 0:return"\x1B[93m";case 2:return I.fail("Should never get an Info diagnostic on the command line.");case 3:return"\x1B[94m"}}function xE(e,t){return t+e+aye}function JMe(e,t,n,i,s,o){let{line:l,character:p}=Lo(e,t),{line:m,character:S}=Lo(e,t+n),h=Lo(e,e.text.length).line,b=m-l>=4,A=(m+1+"").length;b&&(A=Math.max(oye.length,A));let k="";for(let N=l;N<=m;N++){k+=o.getNewLine(),b&&l+1<N&&N<m-1&&(k+=i+xE(oye.padStart(A),eee)+tee+o.getNewLine(),N=m-1);let M=V3(e,N,0),O=N<h?V3(e,N+1,0):e.text.length,U=e.text.slice(M,O);if(U=U.trimEnd(),U=U.replace(/\t/g," "),k+=i+xE((N+1+"").padStart(A),eee)+tee,k+=U+o.getNewLine(),k+=i+xE("".padStart(A),eee)+tee,k+=s,N===l){let H=N===m?S:void 0;k+=U.slice(0,p).replace(/\S/g," "),k+=U.slice(p,H).replace(/./g,"~")}else N===m?k+=U.slice(0,S).replace(/./g,"~"):k+=U.replace(/./g,"~");k+=aye}return k}function UZ(e,t,n,i=xE){let{line:s,character:o}=Lo(e,t),l=n?bw(e.fileName,n.getCurrentDirectory(),m=>n.getCanonicalFileName(m)):e.fileName,p="";return p+=i(l,"\x1B[96m"),p+=":",p+=i(`${s+1}`,"\x1B[93m"),p+=":",p+=i(`${o+1}`,"\x1B[93m"),p}function nye(e,t){let n="";for(let i of e){if(i.file){let{file:s,start:o}=i;n+=UZ(s,o,t),n+=" - "}if(n+=xE(R2(i),VMe(i.category)),n+=xE(` TS${i.code}: `,"\x1B[90m"),n+=nh(i.messageText,t.getNewLine()),i.file&&i.code!==g.File_appears_to_be_binary.code&&(n+=t.getNewLine(),n+=JMe(i.file,i.start,i.length,"",VMe(i.category),t)),i.relatedInformation){n+=t.getNewLine();for(let{file:s,start:o,length:l,messageText:p}of i.relatedInformation)s&&(n+=t.getNewLine(),n+=$Me+UZ(s,o,t),n+=JMe(s,o,l,cye,"\x1B[96m",t)),n+=t.getNewLine(),n+=cye+nh(p,t.getNewLine())}n+=t.getNewLine()}return n}function nh(e,t,n=0){if(vs(e))return e;if(e===void 0)return"";let i="";if(n){i+=t;for(let s=0;s<n;s++)i+="  "}if(i+=e.messageText,n++,e.next)for(let s of e.next)i+=nh(s,t,n);return i}function wM(e,t){return(vs(e)?t:e.resolutionMode)||t}function iye(e,t,n){return qZ(e,MM(e,t),n)}function VZ(e){var t;return yl(e)?e.isTypeOnly:!!((t=e.importClause)!=null&&t.isTypeOnly)}function JZ(e,t,n){return qZ(e,t,n)}function qZ(e,t,n){var i;if((uu(t.parent)||yl(t.parent))&&VZ(t.parent)){let l=fD(t.parent.attributes);if(l)return l}if(t.parent.parent&&M0(t.parent.parent)){let o=fD(t.parent.parent.attributes);if(o)return o}if(n&&T_(n)===200)return t.parent.parent&&Ru(t.parent.parent)||_f(t.parent,!1)?1:99;if(e.impliedNodeFormat===void 0)return;if(e.impliedNodeFormat!==99)return Up(P1(t.parent))?99:1;let s=(i=P1(t.parent))==null?void 0:i.parent;return s&&Ru(s)?1:99}function fD(e,t){if(!e)return;if(de(e.elements)!==1){t?.(e,e.token===118?g.Type_import_attributes_should_have_exactly_one_key_resolution_mode_with_value_import_or_require:g.Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require);return}let n=e.elements[0];if(bo(n.name)){if(n.name.text!=="resolution-mode"){t?.(n.name,e.token===118?g.resolution_mode_is_the_only_valid_key_for_type_import_attributes:g.resolution_mode_is_the_only_valid_key_for_type_import_assertions);return}if(bo(n.value)){if(n.value.text!=="import"&&n.value.text!=="require"){t?.(n.value,g.resolution_mode_should_be_either_require_or_import);return}return n.value.text==="import"?99:1}}}function sye(e){return e.text}function zZ(e,t,n,i,s){return{nameAndMode:kV,resolve:(o,l)=>aD(o,e,n,i,s,t,l)}}function $Z(e){return vs(e)?e:sp(e.fileName)}function TV(e,t,n,i,s){return{nameAndMode:WMe,resolve:(o,l)=>Dhe(o,e,n,i,t,s,l)}}function OM(e,t,n,i,s,o,l,p){if(e.length===0)return tt;let m=[],S=new Map,h=p(t,n,i,o,l);for(let b of e){let A=h.nameAndMode.getName(b),k=h.nameAndMode.getMode(b,s,n?.commandLine.options||i),N=rO(A,k),M=S.get(N);M||S.set(N,M=h.resolve(A,k)),m.push(M)}return m}function WZ(e,t){return bV(void 0,e,(n,i)=>n&&t(n,i))}function bV(e,t,n,i){let s;return o(e,t,void 0);function o(l,p,m){if(i){let S=i(l,m);if(S)return S}return Te(p,(S,h)=>{if(S&&s?.has(S.sourceFile.path))return;let b=n(S,m,h);return b||!S?b:((s||(s=new Set)).add(S.sourceFile.path),o(S.commandLine.projectReferences,S.references,S))})}}function EV(e,t,n){let i=e.configFilePath?hi(e.configFilePath):t;return li(i,`__lib_node_modules_lookup_${n}__.ts`)}function GZ(e){let t=e.split("."),n=t[1],i=2;for(;t[i]&&t[i]!=="d";)n+=(i===2?"/":"-")+t[i],i++;return"@typescript/lib-"+n}function qMe(e){let t=sp(e.fileName),n=NU.get(t);return{libName:t,libFileName:n}}function MT(e){switch(e?.kind){case 3:case 4:case 5:case 7:return!0;default:return!1}}function pD(e){return e.pos!==void 0}function hO(e,t){var n,i,s,o;let l=I.checkDefined(e.getSourceFileByPath(t.file)),{kind:p,index:m}=t,S,h,b,A;switch(p){case 3:let k=MM(l,m);if(b=(i=(n=e.getResolvedModule(l,k.text,e.getModeForUsageLocation(l,k)))==null?void 0:n.resolvedModule)==null?void 0:i.packageId,k.pos===-1)return{file:l,packageId:b,text:k.text};S=Wa(l.text,k.pos),h=k.end;break;case 4:({pos:S,end:h}=l.referencedFiles[m]);break;case 5:({pos:S,end:h,resolutionMode:A}=l.typeReferenceDirectives[m]),b=(o=(s=e.getResolvedTypeReferenceDirective(l,sp(l.typeReferenceDirectives[m].fileName),A||l.impliedNodeFormat))==null?void 0:s.resolvedTypeReferenceDirective)==null?void 0:o.packageId;break;case 7:({pos:S,end:h}=l.libReferenceDirectives[m]);break;default:return I.assertNever(p)}return{file:l,pos:S,end:h,packageId:b}}function HZ(e,t,n,i,s,o,l,p,m,S){if(!e||p?.()||!td(e.getRootFileNames(),t))return!1;let h;if(!td(e.getProjectReferences(),S,M)||e.getSourceFiles().some(k))return!1;let b=e.getMissingFilePaths();if(b&&yu(b,s))return!1;let A=e.getCompilerOptions();if(!wX(A,n)||e.resolvedLibReferences&&yu(e.resolvedLibReferences,(U,H)=>l(H)))return!1;if(A.configFile&&n.configFile)return A.configFile.text===n.configFile.text;return!0;function k(U){return!N(U)||o(U.path)}function N(U){return U.version===i(U.resolvedPath,U.fileName)}function M(U,H,K){return TY(U,H)&&O(e.getResolvedProjectReferences()[K],U)}function O(U,H){if(U){if(hs(h,U))return!0;let re=dD(H),$=m(re);return!$||U.commandLine.options.configFile!==$.options.configFile||!td(U.commandLine.fileNames,$.fileNames)?!1:((h||(h=[])).push(U),!Te(U.references,(pe,z)=>!O(pe,U.commandLine.projectReferences[z])))}let K=dD(H);return!m(K)}}function Ex(e){return e.options.configFile?[...e.options.configFile.parseDiagnostics,...e.errors]:e.errors}function RM(e,t,n,i){let s=YZ(e,t,n,i);return typeof s=="object"?s.impliedNodeFormat:s}function YZ(e,t,n,i){switch(Q_(i)){case 3:case 99:return Ql(e,[".d.mts",".mts",".mjs"])?99:Ql(e,[".d.cts",".cts",".cjs"])?1:Ql(e,[".d.ts",".ts",".tsx",".js",".jsx"])?s():void 0;default:return}function s(){let o=pM(t,n,i),l=[];o.failedLookupLocations=l,o.affectingLocations=l;let p=dM(e,o);return{impliedNodeFormat:p?.contents.packageJsonContent.type==="module"?99:1,packageJsonLocations:l,packageJsonScope:p}}}function UTt(e,t){return e?tN(e.getCompilerOptions(),t,IU):!1}function VTt(e,t,n,i,s,o){return{rootNames:e,options:t,host:n,oldProgram:i,configFileParsingDiagnostics:s,typeScriptVersion:o}}function xV(e,t,n,i,s){var o,l,p,m,S,h,b,A,k,N,M,O,U,H,K,re;let $=os(e)?VTt(e,t,n,i,s):e,{rootNames:pe,options:z,configFileParsingDiagnostics:se,projectReferences:Se,typeScriptVersion:xe}=$,{oldProgram:Z}=$,Q=D_(()=>Wm("ignoreDeprecations",g.Invalid_value_for_ignoreDeprecations)),ce,ye,we,ve,oe,Ee,Me,Ge=new Map,Ae=g_(),Ie={},Re={},Ue=uk(),kt,ke,$e,at,$t,St,Ze,yt,ar,or,Fr=typeof z.maxNodeModuleJsDepth=="number"?z.maxNodeModuleJsDepth:0,rn=0,Tr=new Map,nr=new Map;(o=mn)==null||o.push(mn.Phase.Program,"createProgram",{configFilePath:z.configFilePath,rootDir:z.rootDir},!0),mc("beforeProgram");let tr=$.host||rye(z),ki=AV(tr),xs=z.noLib,zi=D_(()=>tr.getDefaultLibFileName(z)),Ms=tr.getDefaultLibLocation?tr.getDefaultLibLocation():hi(zi()),un=EN(),ri=tr.getCurrentDirectory(),On=m6(z),_r=oR(z,On),rt=new Map,zt,Rr,vi,Ni=tr.hasInvalidatedResolutions||qf;tr.resolveModuleNameLiterals?(vi=tr.resolveModuleNameLiterals.bind(tr),Rr=(l=tr.getModuleResolutionCache)==null?void 0:l.call(tr)):tr.resolveModuleNames?(vi=(Je,et,Ft,Ht,Er,nn)=>tr.resolveModuleNames(Je.map(sye),et,nn?.map(sye),Ft,Ht,Er).map(br=>br?br.extension!==void 0?{resolvedModule:br}:{resolvedModule:{...br,extension:h6(br.resolvedFileName)}}:lye),Rr=(p=tr.getModuleResolutionCache)==null?void 0:p.call(tr)):(Rr=sD(ri,ie,z),vi=(Je,et,Ft,Ht,Er)=>OM(Je,et,Ft,Ht,Er,tr,Rr,zZ));let us;if(tr.resolveTypeReferenceDirectiveReferences)us=tr.resolveTypeReferenceDirectiveReferences.bind(tr);else if(tr.resolveTypeReferenceDirectives)us=(Je,et,Ft,Ht,Er)=>tr.resolveTypeReferenceDirectives(Je.map($Z),et,Ft,Ht,Er?.impliedNodeFormat).map(nn=>({resolvedTypeReferenceDirective:nn}));else{let Je=UU(ri,ie,void 0,Rr?.getPackageJsonInfoCache(),Rr?.optionsToRedirectsKey);us=(et,Ft,Ht,Er,nn)=>OM(et,Ft,Ht,Er,nn,tr,Je,TV)}let Fs=tr.hasInvalidatedLibResolutions||qf,Ta;if(tr.resolveLibrary)Ta=tr.resolveLibrary.bind(tr);else{let Je=sD(ri,ie,z,Rr?.getPackageJsonInfoCache());Ta=(et,Ft,Ht)=>VU(et,Ft,Ht,tr,Je)}let to=new Map,Nr=new Map,qr=g_(),We=!1,mt=new Map,dt=new Map,Ot=tr.useCaseSensitiveFileNames()?new Map:void 0,_e,Ve,pt,W,st=!!((m=tr.useSourceOfProjectReferenceRedirect)!=null&&m.call(tr))&&!z.disableSourceOfProjectReferenceRedirect,{onProgramCreateComplete:Nt,fileExists:Ke,directoryExists:ht}=JTt({compilerHost:tr,getSymlinkCache:lh,useSourceOfProjectReferenceRedirect:st,toPath:fn,getResolvedProjectReferences:zs,getSourceOfProjectReferenceRedirect:hf,forEachResolvedProjectReference:wf}),Wt=tr.readFile.bind(tr);(S=mn)==null||S.push(mn.Phase.Program,"shouldProgramCreateNewSourceFiles",{hasOldProgram:!!Z});let Cr=UTt(Z,z);(h=mn)==null||h.pop();let hr;if((b=mn)==null||b.push(mn.Phase.Program,"tryReuseStructureFromOldProgram",{}),hr=js(),(A=mn)==null||A.pop(),hr!==2){if(ce=[],ye=[],Se&&(_e||(_e=Se.map(Gt)),pe.length&&_e?.forEach((Je,et)=>{if(!Je)return;let Ft=Wo(Je.commandLine.options);if(st){if(Ft||T_(Je.commandLine.options)===0)for(let Ht of Je.commandLine.fileNames)Bt(Ht,{kind:1,index:et})}else if(Ft)Bt(bT(Ft,".d.ts"),{kind:2,index:et});else if(T_(Je.commandLine.options)===0){let Ht=D_(()=>_D(Je.commandLine,!tr.useCaseSensitiveFileNames()));for(let Er of Je.commandLine.fileNames)!i_(Er)&&!Uc(Er,".json")&&Bt(mO(Er,Je.commandLine,!tr.useCaseSensitiveFileNames(),Ht),{kind:2,index:et})}})),(k=mn)==null||k.push(mn.Phase.Program,"processRootFiles",{count:pe.length}),Te(pe,(Je,et)=>sc(Je,!1,!1,{kind:0,index:et})),(N=mn)==null||N.pop(),ke??(ke=pe.length?jU(z,tr):tt),$e=uk(),ke.length){(M=mn)==null||M.push(mn.Phase.Program,"processTypeReferences",{count:ke.length});let Je=z.configFilePath?hi(z.configFilePath):ri,et=li(Je,mD),Ft=ji(ke,et);for(let Ht=0;Ht<ke.length;Ht++)$e.set(ke[Ht],void 0,Ft[Ht]),A_(ke[Ht],void 0,Ft[Ht],{kind:8,typeReference:ke[Ht],packageId:(U=(O=Ft[Ht])==null?void 0:O.resolvedTypeReferenceDirective)==null?void 0:U.packageId});(H=mn)==null||H.pop()}if(pe.length&&!xs){let Je=zi();!z.lib&&Je?sc(Je,!0,!1,{kind:6}):Te(z.lib,(et,Ft)=>{sc(vp(et),!0,!1,{kind:6,index:Ft})})}we=cu(ce,Pi).concat(ye),ce=void 0,ye=void 0}if(Z&&tr.onReleaseOldSourceFile){let Je=Z.getSourceFiles();for(let et of Je){let Ft=Ac(et.resolvedPath);(Cr||!Ft||Ft.impliedNodeFormat!==et.impliedNodeFormat||et.resolvedPath===et.path&&Ft.resolvedPath!==et.path)&&tr.onReleaseOldSourceFile(et,Z.getCompilerOptions(),!!Ac(et.path))}tr.getParsedCommandLine||Z.forEachResolvedProjectReference(et=>{ch(et.sourceFile.path)||tr.onReleaseOldSourceFile(et.sourceFile,Z.getCompilerOptions(),!1)})}Z&&tr.onReleaseParsedCommandLine&&bV(Z.getProjectReferences(),Z.getResolvedProjectReferences(),(Je,et,Ft)=>{let Ht=et?.commandLine.projectReferences[Ft]||Z.getProjectReferences()[Ft],Er=dD(Ht);Ve?.has(fn(Er))||tr.onReleaseParsedCommandLine(Er,Je,Z.getCompilerOptions())}),Z=void 0,$t=void 0,Ze=void 0,ar=void 0;let Sr={getRootFileNames:()=>pe,getSourceFile:$a,getSourceFileByPath:Ac,getSourceFiles:()=>we,getMissingFilePaths:()=>dt,getModuleResolutionCache:()=>Rr,getFilesByNameMap:()=>mt,getCompilerOptions:()=>z,getSyntacticDiagnostics:Nl,getOptionsDiagnostics:Jn,getGlobalDiagnostics:Fc,getSemanticDiagnostics:zc,getCachedSemanticDiagnostics:Tc,getSuggestionDiagnostics:je,getDeclarationDiagnostics:ic,getBindAndCheckDiagnostics:$s,getProgramDiagnostics:cr,getTypeChecker:ks,getClassifiableNames:Ns,getCommonSourceDirectory:Qn,emit:ya,getCurrentDirectory:()=>ri,getNodeCount:()=>ks().getNodeCount(),getIdentifierCount:()=>ks().getIdentifierCount(),getSymbolCount:()=>ks().getSymbolCount(),getTypeCount:()=>ks().getTypeCount(),getInstantiationCount:()=>ks().getInstantiationCount(),getRelationCacheSizes:()=>ks().getRelationCacheSizes(),getFileProcessingDiagnostics:()=>kt,getResolvedTypeReferenceDirectives:()=>Ue,getAutomaticTypeDirectiveNames:()=>ke,getAutomaticTypeDirectiveResolutions:()=>$e,isSourceFileFromExternalLibrary:Dc,isSourceFileDefaultLibrary:zu,getModeForUsageLocation:gd,getModeForResolutionAtIndex:By,getSourceFileFromReference:gm,getLibFileFromReference:pu,sourceFileToPackageName:Nr,redirectTargetsMap:qr,usesUriStyleNodeCoreModules:We,resolvedModules:St,resolvedTypeReferenceDirectiveNames:yt,resolvedLibReferences:at,getResolvedModule:Y,getResolvedModuleFromModuleSpecifier:Be,getResolvedTypeReferenceDirective:Lt,forEachResolvedModule:B,forEachResolvedTypeReferenceDirective:le,getCurrentPackagesMap:()=>or,typesPackageExists:qe,packageBundlesTypes:Le,isEmittedFile:OE,getConfigFileParsingDiagnostics:bu,getProjectReferences:Eo,getResolvedProjectReferences:zs,getProjectReferenceRedirect:cl,getResolvedProjectReferenceToRedirect:dd,getResolvedProjectReferenceByPath:ch,forEachResolvedProjectReference:wf,isSourceOfProjectReferenceRedirect:Fd,emitBuildInfo:Sl,fileExists:Ke,readFile:Wt,directoryExists:ht,getSymlinkCache:lh,realpath:(K=tr.realpath)==null?void 0:K.bind(tr),useCaseSensitiveFileNames:()=>tr.useCaseSensitiveFileNames(),getCanonicalFileName:ie,getFileIncludeReasons:()=>Ae,structureIsReused:hr,writeFile:Qo};return Nt(),kt?.forEach(Je=>{switch(Je.kind){case 1:return un.add(gi(Je.file&&Ac(Je.file),Je.fileProcessingReason,Je.diagnostic,Je.args||tt));case 0:let{file:et,pos:Ft,end:Ht}=hO(Sr,Je.reason);return un.add(Iu(et,I.checkDefined(Ft),I.checkDefined(Ht)-Ft,Je.diagnostic,...Je.args||tt));case 2:return Je.diagnostics.forEach(Er=>un.add(Er));default:I.assertNever(Je)}}),V(),mc("afterProgram"),rd("Program","beforeProgram","afterProgram"),(re=mn)==null||re.pop(),Sr;function Y(Je,et,Ft){var Ht;return(Ht=St?.get(Je.path))==null?void 0:Ht.get(et,Ft)}function Be(Je){let et=Xr(Je);return I.assertIsDefined(et,"`moduleSpecifier` must have a `SourceFile` ancestor. Use `program.getResolvedModule` instead to provide the containing file and resolution mode."),Y(et,Je.text,gd(et,Je))}function Lt(Je,et,Ft){var Ht;return(Ht=yt?.get(Je.path))==null?void 0:Ht.get(et,Ft)}function B(Je,et){X(St,Je,et)}function le(Je,et){X(yt,Je,et)}function X(Je,et,Ft){var Ht;Ft?(Ht=Je?.get(Ft.path))==null||Ht.forEach((Er,nn,br)=>et(Er,nn,br,Ft.path)):Je?.forEach((Er,nn)=>Er.forEach((br,sn,Ci)=>et(br,sn,Ci,nn)))}function he(){return or||(or=new Map,B(({resolvedModule:Je})=>{Je?.packageId&&or.set(Je.packageId.name,Je.extension===".d.ts"||!!or.get(Je.packageId.name))}),or)}function qe(Je){return he().has(zU(Je))}function Le(Je){return!!he().get(Je)}function It(Je){var et;(et=Je.resolutionDiagnostics)!=null&&et.length&&(kt??(kt=[])).push({kind:2,diagnostics:Je.resolutionDiagnostics})}function Rt(Je,et,Ft,Ht){if(tr.resolveModuleNameLiterals||!tr.resolveModuleNames)return It(Ft);if(!Rr||Nu(et))return;let Er=Ps(Je.originalFileName,ri),nn=hi(Er),br=zr(Je),sn=Rr.getFromNonRelativeNameCache(et,Ht,nn,br);sn&&It(sn)}function Zt(Je,et,Ft){var Ht,Er;if(!Je.length)return tt;let nn=Ps(et.originalFileName,ri),br=zr(et);(Ht=mn)==null||Ht.push(mn.Phase.Program,"resolveModuleNamesWorker",{containingFileName:nn}),mc("beforeResolveModule");let sn=vi(Je,nn,br,z,et,Ft);return mc("afterResolveModule"),rd("ResolveModule","beforeResolveModule","afterResolveModule"),(Er=mn)==null||Er.pop(),sn}function Ir(Je,et,Ft){var Ht,Er;if(!Je.length)return[];let nn=vs(et)?void 0:et,br=vs(et)?et:Ps(et.originalFileName,ri),sn=nn&&zr(nn);(Ht=mn)==null||Ht.push(mn.Phase.Program,"resolveTypeReferenceDirectiveNamesWorker",{containingFileName:br}),mc("beforeResolveTypeReference");let Ci=us(Je,br,sn,z,nn,Ft);return mc("afterResolveTypeReference"),rd("ResolveTypeReference","beforeResolveTypeReference","afterResolveTypeReference"),(Er=mn)==null||Er.pop(),Ci}function zr(Je){let et=dd(Je.originalFileName);if(et||!i_(Je.originalFileName))return et;let Ft=Yr(Je.path);if(Ft)return Ft;if(!tr.realpath||!z.preserveSymlinks||!Je.originalFileName.includes(Wh))return;let Ht=fn(tr.realpath(Je.originalFileName));return Ht===Je.path?void 0:Yr(Ht)}function Yr(Je){let et=hf(Je);if(vs(et))return dd(et);if(et)return wf(Ft=>{let Ht=Wo(Ft.commandLine.options);if(Ht)return fn(Ht)===Je?Ft:void 0})}function Pi(Je,et){return To(Fi(Je),Fi(et))}function Fi(Je){if(wm(Ms,Je.fileName,!1)){let et=Cl(Je.fileName);if(et==="lib.d.ts"||et==="lib.es6.d.ts")return 0;let Ft=cA(hw(et,"lib."),".d.ts"),Ht=sM.indexOf(Ft);if(Ht!==-1)return Ht+1}return sM.length+2}function fn(Je){return gc(Je,ri,ie)}function Qn(){if(oe===void 0){let Je=Fn(we,et=>Q2(et,Sr));oe=gO(z,()=>Wi(Je,et=>et.isDeclarationFile?void 0:et.fileName),ri,ie,et=>Jt(Je,et))}return oe}function Ns(){var Je;if(!Me){ks(),Me=new Set;for(let et of we)(Je=et.classifiableNames)==null||Je.forEach(Ft=>Me.add(Ft))}return Me}function Vi(Je,et){if(hr===0&&!et.ambientModuleNames.length)return Zt(Je,et,void 0);let Ft,Ht,Er,nn=lye,br=Z&&Z.getSourceFile(et.fileName);for(let mi=0;mi<Je.length;mi++){let Tn=Je[mi];if(et===br&&!Ni(et.path)){let ao=Z?.getResolvedModule(et,Tn.text,gd(et,Tn));if(ao?.resolvedModule){wy(z,tr)&&ws(tr,ao.resolvedModule.packageId?g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2,Tn.text,Ps(et.originalFileName,ri),ao.resolvedModule.resolvedFileName,ao.resolvedModule.packageId&&Bv(ao.resolvedModule.packageId)),(Ht??(Ht=new Array(Je.length)))[mi]=ao,(Er??(Er=[])).push(Tn);continue}}let aa=!1;hs(et.ambientModuleNames,Tn.text)?(aa=!0,wy(z,tr)&&ws(tr,g.Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1,Tn.text,Ps(et.originalFileName,ri))):aa=hn(Tn),aa?(Ht||(Ht=new Array(Je.length)))[mi]=nn:(Ft??(Ft=[])).push(Tn)}let sn=Ft&&Ft.length?Zt(Ft,et,Er):tt;if(!Ht)return I.assert(sn.length===Je.length),sn;let Ci=0;for(let mi=0;mi<Ht.length;mi++)Ht[mi]||(Ht[mi]=sn[Ci],Ci++);return I.assert(Ci===sn.length),Ht;function hn(mi){var Tn;let aa=(Tn=Z?.getResolvedModule(et,mi.text,gd(et,mi)))==null?void 0:Tn.resolvedModule,ao=aa&&Z.getSourceFile(aa.resolvedFileName);if(aa&&ao)return!1;let B_=Ge.get(mi.text);return B_?(wy(z,tr)&&ws(tr,g.Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified,mi.text,B_),!0):!1}}function ji(Je,et){var Ft;if(hr===0)return Ir(Je,et,void 0);let Ht,Er,nn,br=vs(et)?void 0:et,sn=vs(et)?void 0:Z&&Z.getSourceFile(et.fileName),Ci=vs(et)?!Ni(fn(et)):et===sn&&!Ni(et.path);for(let Tn=0;Tn<Je.length;Tn++){let aa=Je[Tn];if(Ci){let ao=$Z(aa),B_=wM(aa,br?.impliedNodeFormat),Hu=vs(et)?(Ft=Z?.getAutomaticTypeDirectiveResolutions())==null?void 0:Ft.get(ao,B_):Z?.getResolvedTypeReferenceDirective(et,ao,B_);if(Hu?.resolvedTypeReferenceDirective){wy(z,tr)&&ws(tr,Hu.resolvedTypeReferenceDirective.packageId?g.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:g.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2,ao,vs(et)?et:Ps(et.originalFileName,ri),Hu.resolvedTypeReferenceDirective.resolvedFileName,Hu.resolvedTypeReferenceDirective.packageId&&Bv(Hu.resolvedTypeReferenceDirective.packageId)),(Er??(Er=new Array(Je.length)))[Tn]=Hu,(nn??(nn=[])).push(aa);continue}}(Ht??(Ht=[])).push(aa)}if(!Ht)return Er||tt;let hn=Ir(Ht,et,nn);if(!Er)return I.assert(hn.length===Je.length),hn;let mi=0;for(let Tn=0;Tn<Er.length;Tn++)Er[Tn]||(Er[Tn]=hn[mi],mi++);return I.assert(mi===hn.length),Er}function ni(){return!bV(Z.getProjectReferences(),Z.getResolvedProjectReferences(),(Je,et,Ft)=>{let Ht=(et?et.commandLine.projectReferences:Se)[Ft],Er=Gt(Ht);return Je?!Er||Er.sourceFile!==Je.sourceFile||!td(Je.commandLine.fileNames,Er.commandLine.fileNames):Er!==void 0},(Je,et)=>{let Ft=et?ch(et.sourceFile.path).commandLine.projectReferences:Se;return!td(Je,Ft,TY)})}function js(){var Je;if(!Z)return 0;let et=Z.getCompilerOptions();if(j9(et,z))return 0;let Ft=Z.getRootFileNames();if(!td(Ft,pe)||!ni())return 0;Se&&(_e=Se.map(Gt));let Ht=[],Er=[];if(hr=2,yu(Z.getMissingFilePaths(),hn=>tr.fileExists(hn)))return 0;let nn=Z.getSourceFiles(),br;(hn=>{hn[hn.Exists=0]="Exists",hn[hn.Modified=1]="Modified"})(br||(br={}));let sn=new Map;for(let hn of nn){let mi=ua(hn.fileName,Rr,tr,z),Tn=tr.getSourceFileByPath?tr.getSourceFileByPath(hn.fileName,hn.resolvedPath,mi,void 0,Cr):tr.getSourceFile(hn.fileName,mi,void 0,Cr);if(!Tn)return 0;Tn.packageJsonLocations=(Je=mi.packageJsonLocations)!=null&&Je.length?mi.packageJsonLocations:void 0,Tn.packageJsonScope=mi.packageJsonScope,I.assert(!Tn.redirectInfo,"Host should not return a redirect source file from `getSourceFile`");let aa;if(hn.redirectInfo){if(Tn!==hn.redirectInfo.unredirected)return 0;aa=!1,Tn=hn}else if(Z.redirectTargetsMap.has(hn.path)){if(Tn!==hn)return 0;aa=!1}else aa=Tn!==hn;Tn.path=hn.path,Tn.originalFileName=hn.originalFileName,Tn.resolvedPath=hn.resolvedPath,Tn.fileName=hn.fileName;let ao=Z.sourceFileToPackageName.get(hn.path);if(ao!==void 0){let B_=sn.get(ao),Hu=aa?1:0;if(B_!==void 0&&Hu===1||B_===1)return 0;sn.set(ao,Hu)}if(aa)hn.impliedNodeFormat!==Tn.impliedNodeFormat?hr=1:td(hn.libReferenceDirectives,Tn.libReferenceDirectives,Jl)?hn.hasNoDefaultLib!==Tn.hasNoDefaultLib?hr=1:td(hn.referencedFiles,Tn.referencedFiles,Jl)?(Xf(Tn),td(hn.imports,Tn.imports,jo)&&td(hn.moduleAugmentations,Tn.moduleAugmentations,jo)?(hn.flags&12582912)!==(Tn.flags&12582912)?hr=1:td(hn.typeReferenceDirectives,Tn.typeReferenceDirectives,Jl)||(hr=1):hr=1):hr=1:hr=1,Er.push(Tn);else if(Ni(hn.path))hr=1,Er.push(Tn);else for(let B_ of hn.ambientModuleNames)Ge.set(B_,hn.fileName);Ht.push(Tn)}if(hr!==2)return hr;for(let hn of Er){let mi=zMe(hn),Tn=Vi(mi,hn);(Ze??(Ze=new Map)).set(hn.path,Tn),bY(mi,Tn,Uy=>Z.getResolvedModule(hn,Uy.text,gd(hn,Uy)),Wpe)&&(hr=1);let ao=hn.typeReferenceDirectives,B_=ji(ao,hn);(ar??(ar=new Map)).set(hn.path,B_),bY(ao,B_,Uy=>Z.getResolvedTypeReferenceDirective(hn,$Z(Uy),wM(Uy,hn.impliedNodeFormat)),Gpe)&&(hr=1)}if(hr!==2)return hr;if(zpe(et,z)||Z.resolvedLibReferences&&yu(Z.resolvedLibReferences,(hn,mi)=>U0(mi).actual!==hn.actual))return 1;if(tr.hasChangedAutomaticTypeDirectiveNames){if(tr.hasChangedAutomaticTypeDirectiveNames())return 1}else if(ke=jU(z,tr),!td(Z.getAutomaticTypeDirectiveNames(),ke))return 1;dt=Z.getMissingFilePaths(),I.assert(Ht.length===Z.getSourceFiles().length);for(let hn of Ht)mt.set(hn.path,hn);return Z.getFilesByNameMap().forEach((hn,mi)=>{if(!hn){mt.set(mi,hn);return}if(hn.path===mi){Z.isSourceFileFromExternalLibrary(hn)&&nr.set(hn.path,!0);return}mt.set(mi,mt.get(hn.path))}),we=Ht,Ae=Z.getFileIncludeReasons(),kt=Z.getFileProcessingDiagnostics(),Ue=Z.getResolvedTypeReferenceDirectives(),ke=Z.getAutomaticTypeDirectiveNames(),$e=Z.getAutomaticTypeDirectiveResolutions(),Nr=Z.sourceFileToPackageName,qr=Z.redirectTargetsMap,We=Z.usesUriStyleNodeCoreModules,St=Z.resolvedModules,yt=Z.resolvedTypeReferenceDirectiveNames,at=Z.resolvedLibReferences,or=Z.getCurrentPackagesMap(),2}function Mr(Je){return{getPrependNodes:nc,getCanonicalFileName:ie,getCommonSourceDirectory:Sr.getCommonSourceDirectory,getCompilerOptions:Sr.getCompilerOptions,getCurrentDirectory:()=>ri,getSourceFile:Sr.getSourceFile,getSourceFileByPath:Sr.getSourceFileByPath,getSourceFiles:Sr.getSourceFiles,getLibFileFromReference:Sr.getLibFileFromReference,isSourceFileFromExternalLibrary:Dc,getResolvedProjectReferenceToRedirect:dd,getProjectReferenceRedirect:cl,isSourceOfProjectReferenceRedirect:Fd,getSymlinkCache:lh,writeFile:Je||Qo,isEmitBlocked:$u,readFile:et=>tr.readFile(et),fileExists:et=>{let Ft=fn(et);return Ac(Ft)?!0:dt.has(Ft)?!1:tr.fileExists(et)},useCaseSensitiveFileNames:()=>tr.useCaseSensitiveFileNames(),getBuildInfo:et=>{var Ft;return(Ft=Sr.getBuildInfo)==null?void 0:Ft.call(Sr,et)},getSourceFileFromReference:(et,Ft)=>Sr.getSourceFileFromReference(et,Ft),redirectTargetsMap:qr,getFileIncludeReasons:Sr.getFileIncludeReasons,createHash:rs(tr,tr.createHash)}}function Qo(Je,et,Ft,Ht,Er,nn){tr.writeFile(Je,et,Ft,Ht,Er,nn)}function Sl(Je){var et,Ft;I.assert(!Wo(z)),(et=mn)==null||et.push(mn.Phase.Emit,"emitBuildInfo",{},!0),mc("beforeEmit");let Ht=dV(gV,Mr(Je),void 0,xZ,!1,!0);return mc("afterEmit"),rd("Emit","beforeEmit","afterEmit"),(Ft=mn)==null||Ft.pop(),Ht}function zs(){return _e}function Eo(){return Se}function nc(){return KZ(Se,(Je,et)=>{var Ft;return(Ft=_e[et])==null?void 0:Ft.commandLine},Je=>{let et=fn(Je),Ft=Ac(et);return Ft?Ft.text:mt.has(et)?void 0:tr.readFile(et)},tr)}function Dc(Je){return!!nr.get(Je.path)}function zu(Je){if(!Je.isDeclarationFile)return!1;if(Je.hasNoDefaultLib)return!0;if(!z.noLib)return!1;let et=tr.useCaseSensitiveFileNames()?Av:S1;return z.lib?Tt(z.lib,Ft=>et(Je.fileName,at.get(Ft).actual)):et(Je.fileName,zi())}function ks(){return Ee||(Ee=e0e(Sr))}function ya(Je,et,Ft,Ht,Er,nn){var br,sn;(br=mn)==null||br.push(mn.Phase.Emit,"emit",{path:Je?.path},!0);let Ci=Wu(()=>Uo(Sr,Je,et,Ft,Ht,Er,nn));return(sn=mn)==null||sn.pop(),Ci}function $u(Je){return rt.has(fn(Je))}function Uo(Je,et,Ft,Ht,Er,nn,br){if(!br){let hn=XZ(Je,et,Ft,Ht);if(hn)return hn}let sn=ks().getEmitResolver(Wo(z)?void 0:et,Ht);mc("beforeEmit");let Ci=dV(sn,Mr(Ft),et,EZ(z,nn,Er),Er,!1,br);return mc("afterEmit"),rd("Emit","beforeEmit","afterEmit"),Ci}function $a(Je){return Ac(fn(Je))}function Ac(Je){return mt.get(Je)||void 0}function Ld(Je,et,Ft){return WP(Je?et(Je,Ft):_a(Sr.getSourceFiles(),Ht=>(Ft&&Ft.throwIfCancellationRequested(),et(Ht,Ft))))}function Nl(Je,et){return Ld(Je,Mu,et)}function zc(Je,et){return Ld(Je,yp,et)}function Tc(Je){var et;return Je?(et=Ie.perFile)==null?void 0:et.get(Je.path):Ie.allDiagnostics}function $s(Je,et){return Go(Je,et)}function cr(Je){var et;if(y6(Je,z,Sr))return tt;let Ft=un.getDiagnostics(Je.fileName);return(et=Je.commentDirectives)!=null&&et.length?ne(Je,Je.commentDirectives,Ft).diagnostics:Ft}function ic(Je,et){let Ft=Sr.getCompilerOptions();return!Je||Wo(Ft)?Dn(Je,et):Ld(Je,Bi,et)}function Mu(Je){return Y_(Je)?(Je.additionalSyntacticDiagnostics||(Je.additionalSyntacticDiagnostics=gr(Je)),ys(Je.additionalSyntacticDiagnostics,Je.parseDiagnostics)):Je.parseDiagnostics}function Wu(Je){try{return Je()}catch(et){throw et instanceof VP&&(Ee=void 0),et}}function yp(Je,et){return ys(CV(Go(Je,et),z),cr(Je))}function Go(Je,et){return Zn(Je,et,Ie,ru)}function ru(Je,et){return Wu(()=>{if(y6(Je,z,Sr))return tt;let Ft=ks();I.assert(!!Je.bindDiagnostics);let Er=(Je.scriptKind===1||Je.scriptKind===2)&&uR(Je,z),nn=p8(Je,z.checkJs),sn=!(!!Je.checkJsDirective&&Je.checkJsDirective.enabled===!1)&&(Je.scriptKind===3||Je.scriptKind===4||Je.scriptKind===5||nn||Er||Je.scriptKind===7),Ci=sn?Je.bindDiagnostics:tt,hn=sn?Ft.getDiagnostics(Je,et):tt;return nn&&(Ci=Fn(Ci,mi=>PV.has(mi.code)),hn=Fn(hn,mi=>PV.has(mi.code))),ge(Je,sn&&!nn,Ci,hn,Er?Je.jsDocDiagnostics:void 0)})}function ge(Je,et,...Ft){var Ht;let Er=ip(Ft);if(!et||!((Ht=Je.commentDirectives)!=null&&Ht.length))return Er;let{diagnostics:nn,directives:br}=ne(Je,Je.commentDirectives,Er);for(let sn of br.getUnusedExpectations())nn.push(cde(Je,sn.range,g.Unused_ts_expect_error_directive));return nn}function ne(Je,et,Ft){let Ht=Xpe(Je,et);return{diagnostics:Ft.filter(nn=>Et(nn,Ht)===-1),directives:Ht}}function je(Je,et){return Wu(()=>ks().getSuggestionDiagnostics(Je,et))}function Et(Je,et){let{file:Ft,start:Ht}=Je;if(!Ft)return-1;let Er=vy(Ft),nn=zP(Er,Ht).line-1;for(;nn>=0;){if(et.markUsed(nn))return nn;let br=Ft.text.slice(Er[nn],Er[nn+1]).trim();if(br!==""&&!/^(\s*)\/\/(.*)$/.test(br))return-1;nn--}return-1}function gr(Je){return Wu(()=>{let et=[];return Ft(Je,Je),Y6(Je,Ft,Ht),et;function Ft(sn,Ci){switch(Ci.kind){case 169:case 172:case 174:if(Ci.questionToken===sn)return et.push(br(sn,g.The_0_modifier_can_only_be_used_in_TypeScript_files,"?")),"skip";case 173:case 176:case 177:case 178:case 218:case 262:case 219:case 260:if(Ci.type===sn)return et.push(br(sn,g.Type_annotations_can_only_be_used_in_TypeScript_files)),"skip"}switch(sn.kind){case 273:if(sn.isTypeOnly)return et.push(br(Ci,g._0_declarations_can_only_be_used_in_TypeScript_files,"import type")),"skip";break;case 278:if(sn.isTypeOnly)return et.push(br(sn,g._0_declarations_can_only_be_used_in_TypeScript_files,"export type")),"skip";break;case 276:case 281:if(sn.isTypeOnly)return et.push(br(sn,g._0_declarations_can_only_be_used_in_TypeScript_files,Gf(sn)?"import...type":"export...type")),"skip";break;case 271:return et.push(br(sn,g.import_can_only_be_used_in_TypeScript_files)),"skip";case 277:if(sn.isExportEquals)return et.push(br(sn,g.export_can_only_be_used_in_TypeScript_files)),"skip";break;case 298:if(sn.token===119)return et.push(br(sn,g.implements_clauses_can_only_be_used_in_TypeScript_files)),"skip";break;case 264:let mi=Sa(120);return I.assertIsDefined(mi),et.push(br(sn,g._0_declarations_can_only_be_used_in_TypeScript_files,mi)),"skip";case 267:let Tn=sn.flags&32?Sa(145):Sa(144);return I.assertIsDefined(Tn),et.push(br(sn,g._0_declarations_can_only_be_used_in_TypeScript_files,Tn)),"skip";case 265:return et.push(br(sn,g.Type_aliases_can_only_be_used_in_TypeScript_files)),"skip";case 176:case 174:case 262:return sn.body?void 0:(et.push(br(sn,g.Signature_declarations_can_only_be_used_in_TypeScript_files)),"skip");case 266:let aa=I.checkDefined(Sa(94));return et.push(br(sn,g._0_declarations_can_only_be_used_in_TypeScript_files,aa)),"skip";case 235:return et.push(br(sn,g.Non_null_assertions_can_only_be_used_in_TypeScript_files)),"skip";case 234:return et.push(br(sn.type,g.Type_assertion_expressions_can_only_be_used_in_TypeScript_files)),"skip";case 238:return et.push(br(sn.type,g.Type_satisfaction_expressions_can_only_be_used_in_TypeScript_files)),"skip";case 216:I.fail()}}function Ht(sn,Ci){if(nQ(Ci)){let hn=mr(Ci.modifiers,n_);hn&&et.push(br(hn,g.Decorators_are_not_valid_here))}else if(yx(Ci)&&Ci.modifiers){let hn=oa(Ci.modifiers,n_);if(hn>=0){if(Ls(Ci)&&!z.experimentalDecorators)et.push(br(Ci.modifiers[hn],g.Decorators_are_not_valid_here));else if(eu(Ci)){let mi=oa(Ci.modifiers,WA);if(mi>=0){let Tn=oa(Ci.modifiers,tU);if(hn>mi&&Tn>=0&&hn<Tn)et.push(br(Ci.modifiers[hn],g.Decorators_are_not_valid_here));else if(mi>=0&&hn<mi){let aa=oa(Ci.modifiers,n_,mi);aa>=0&&et.push(Ga(br(Ci.modifiers[aa],g.Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export),br(Ci.modifiers[hn],g.Decorator_used_before_export_here)))}}}}}switch(Ci.kind){case 263:case 231:case 174:case 176:case 177:case 178:case 218:case 262:case 219:if(sn===Ci.typeParameters)return et.push(nn(sn,g.Type_parameter_declarations_can_only_be_used_in_TypeScript_files)),"skip";case 243:if(sn===Ci.modifiers)return Er(Ci.modifiers,Ci.kind===243),"skip";break;case 172:if(sn===Ci.modifiers){for(let hn of sn)Ra(hn)&&hn.kind!==126&&hn.kind!==129&&et.push(br(hn,g.The_0_modifier_can_only_be_used_in_TypeScript_files,Sa(hn.kind)));return"skip"}break;case 169:if(sn===Ci.modifiers&&Tt(sn,Ra))return et.push(nn(sn,g.Parameter_modifiers_can_only_be_used_in_TypeScript_files)),"skip";break;case 213:case 214:case 233:case 285:case 286:case 215:if(sn===Ci.typeArguments)return et.push(nn(sn,g.Type_arguments_can_only_be_used_in_TypeScript_files)),"skip";break}}function Er(sn,Ci){for(let hn of sn)switch(hn.kind){case 87:if(Ci)continue;case 125:case 123:case 124:case 148:case 138:case 128:case 164:case 103:case 147:et.push(br(hn,g.The_0_modifier_can_only_be_used_in_TypeScript_files,Sa(hn.kind)));break;case 126:case 95:case 90:case 129:}}function nn(sn,Ci,...hn){let mi=sn.pos;return Iu(Je,mi,sn.end-mi,Ci,...hn)}function br(sn,Ci,...hn){return im(Je,sn,Ci,...hn)}})}function Dn(Je,et){return Zn(Je,et,Re,xn)}function xn(Je,et){return Wu(()=>{let Ft=ks().getEmitResolver(Je,et);return G0e(Mr(ja),Ft,Je)||tt})}function Zn(Je,et,Ft,Ht){var Er;let nn=Je?(Er=Ft.perFile)==null?void 0:Er.get(Je.path):Ft.allDiagnostics;if(nn)return nn;let br=Ht(Je,et);return Je?(Ft.perFile||(Ft.perFile=new Map)).set(Je.path,br):Ft.allDiagnostics=br,br}function Bi(Je,et){return Je.isDeclarationFile?[]:Dn(Je,et)}function Jn(){return WP(ys(un.getGlobalDiagnostics(),ia()))}function ia(){if(!z.configFile)return tt;let Je=un.getDiagnostics(z.configFile.fileName);return wf(et=>{Je=ys(Je,un.getDiagnostics(et.sourceFile.fileName))}),Je}function Fc(){return pe.length?WP(ks().getGlobalDiagnostics().slice()):tt}function bu(){return se||tt}function sc(Je,et,Ft,Ht){Oe(Ca(Je),et,Ft,void 0,Ht)}function Jl(Je,et){return Je.fileName===et.fileName}function jo(Je,et){return Je.kind===80?et.kind===80&&Je.escapedText===et.escapedText:et.kind===11&&Je.text===et.text}function Eu(Je,et){let Ft=j.createStringLiteral(Je),Ht=j.createImportDeclaration(void 0,void 0,Ft,void 0);return BA(Ht,2),io(Ft,Ht),io(Ht,et),Ft.flags&=-17,Ht.flags&=-17,Ft}function Xf(Je){if(Je.imports)return;let et=Y_(Je),Ft=Pl(Je),Ht,Er,nn;if((fm(z)||Ft)&&!Je.isDeclarationFile){z.importHelpers&&(Ht=[Eu(Gv,Je)]);let hn=Yj(Hj(z,Je),z);hn&&(Ht||(Ht=[])).push(Eu(hn,Je))}for(let hn of Je.statements)br(hn,!1);(Je.flags&4194304||et)&&sn(Je),Je.imports=Ht||tt,Je.moduleAugmentations=Er||tt,Je.ambientModuleNames=nn||tt;return;function br(hn,mi){if(g8(hn)){let Tn=mN(hn);Tn&&za(Tn)&&Tn.text&&(!mi||!Nu(Tn.text))&&(Wv(hn,!1),Ht=Pr(Ht,Tn),!We&&rn===0&&!Je.isDeclarationFile&&(We=Ss(Tn.text,"node:")))}else if(hl(hn)&&S_(hn)&&(mi||ui(hn,128)||Je.isDeclarationFile)){hn.name.parent=hn;let Tn=om(hn.name);if(Ft||mi&&!Nu(Tn))(Er||(Er=[])).push(hn.name);else if(!mi){Je.isDeclarationFile&&(nn||(nn=[])).push(Tn);let aa=hn.body;if(aa)for(let ao of aa.statements)br(ao,!0)}}}function sn(hn){let mi=/import|require/g;for(;mi.exec(hn.text)!==null;){let Tn=Ci(hn,mi.lastIndex);et&&_f(Tn,!0)||Up(Tn)&&Tn.arguments.length>=1&&bo(Tn.arguments[0])?(Wv(Tn,!1),Ht=Pr(Ht,Tn.arguments[0])):Vv(Tn)&&(Wv(Tn,!1),Ht=Pr(Ht,Tn.argument.literal))}}function Ci(hn,mi){let Tn=hn,aa=ao=>{if(ao.pos<=mi&&(mi<ao.end||mi===ao.end&&ao.kind===1))return ao};for(;;){let ao=et&&jp(Tn)&&Te(Tn.jsDoc,aa)||Qs(Tn,aa);if(!ao)return Tn;Tn=ao}}}function pu(Je){var et;let{libFileName:Ft}=qMe(Je),Ht=Ft&&((et=at?.get(Ft))==null?void 0:et.actual);return Ht!==void 0?$a(Ht):void 0}function gm(Je,et){return tf(SV(et.fileName,Je.fileName),$a)}function tf(Je,et,Ft,Ht){if(pA(Je)){let Er=tr.getCanonicalFileName(Je);if(!z.allowNonTsExtensions&&!Te(ip(_r),br=>Uc(Er,br))){Ft&&(rE(Er)?Ft(g.File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option,Je):Ft(g.File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1,Je,"'"+ip(On).join("', '")+"'"));return}let nn=et(Je);if(Ft)if(nn)MT(Ht)&&Er===tr.getCanonicalFileName(Ac(Ht.file).fileName)&&Ft(g.A_file_cannot_have_a_reference_to_itself);else{let br=cl(Je);br?Ft(g.Output_file_0_has_not_been_built_from_source_file_1,br,Je):Ft(g.File_0_not_found,Je)}return nn}else{let Er=z.allowNonTsExtensions&&et(Je);if(Er)return Er;if(Ft&&z.allowNonTsExtensions){Ft(g.File_0_not_found,Je);return}let nn=Te(On[0],br=>et(Je+br));return Ft&&!nn&&Ft(g.Could_not_resolve_the_path_0_with_the_extensions_Colon_1,Je,"'"+ip(On).join("', '")+"'"),nn}}function Oe(Je,et,Ft,Ht,Er){tf(Je,nn=>sa(nn,et,Ft,Er,Ht),(nn,...br)=>ci(void 0,Er,nn,br),Er)}function Bt(Je,et){return Oe(Je,!1,!1,void 0,et)}function Zr(Je,et,Ft){!MT(Ft)&&Tt(Ae.get(et.path),MT)?ci(et,Ft,g.Already_included_file_name_0_differs_from_file_name_1_only_in_casing,[et.fileName,Je]):ci(et,Ft,g.File_name_0_differs_from_already_included_file_name_1_only_in_casing,[Je,et.fileName])}function Ds(Je,et,Ft,Ht,Er,nn,br){var sn;let Ci=$h.createRedirectedSourceFile({redirectTarget:Je,unredirected:et});return Ci.fileName=Ft,Ci.path=Ht,Ci.resolvedPath=Er,Ci.originalFileName=nn,Ci.packageJsonLocations=(sn=br.packageJsonLocations)!=null&&sn.length?br.packageJsonLocations:void 0,Ci.packageJsonScope=br.packageJsonScope,nr.set(Ht,rn>0),Ci}function sa(Je,et,Ft,Ht,Er){var nn,br;(nn=mn)==null||nn.push(mn.Phase.Program,"findSourceFile",{fileName:Je,isDefaultLib:et||void 0,fileIncludeKind:Q5[Ht.kind]});let sn=Tl(Je,et,Ft,Ht,Er);return(br=mn)==null||br.pop(),sn}function ua(Je,et,Ft,Ht){let Er=YZ(Ps(Je,ri),et?.getPackageJsonInfoCache(),Ft,Ht),nn=ho(Ht),br=aR(Ht);return typeof Er=="object"?{...Er,languageVersion:nn,setExternalModuleIndicator:br,jsDocParsingMode:Ft.jsDocParsingMode}:{languageVersion:nn,impliedNodeFormat:Er,setExternalModuleIndicator:br,jsDocParsingMode:Ft.jsDocParsingMode}}function Tl(Je,et,Ft,Ht,Er){var nn;let br=fn(Je);if(st){let Tn=hf(br);if(!Tn&&tr.realpath&&z.preserveSymlinks&&i_(Je)&&Je.includes(Wh)){let aa=fn(tr.realpath(Je));aa!==br&&(Tn=hf(aa))}if(Tn){let aa=vs(Tn)?sa(Tn,et,Ft,Ht,Er):void 0;return aa&&bc(aa,br,Je,void 0),aa}}let sn=Je;if(mt.has(br)){let Tn=mt.get(br);if(ql(Tn||void 0,Ht),Tn&&z.forceConsistentCasingInFileNames!==!1){let aa=Tn.fileName;fn(aa)!==fn(Je)&&(Je=cl(Je)||Je);let B_=JH(aa,ri),Hu=JH(Je,ri);B_!==Hu&&Zr(Je,Tn,Ht)}return Tn&&nr.get(Tn.path)&&rn===0?(nr.set(Tn.path,!1),z.noResolve||(Yh(Tn,et),Ly(Tn)),z.noLib||Of(Tn),Tr.set(Tn.path,!1),ct(Tn)):Tn&&Tr.get(Tn.path)&&rn<Fr&&(Tr.set(Tn.path,!1),ct(Tn)),Tn||void 0}let Ci;if(MT(Ht)&&!st){let Tn=bl(Je);if(Tn){if(Wo(Tn.commandLine.options))return;let aa=xu(Tn,Je);Je=aa,Ci=fn(aa)}}let hn=ua(Je,Rr,tr,z),mi=tr.getSourceFile(Je,hn,Tn=>ci(void 0,Ht,g.Cannot_read_file_0_Colon_1,[Je,Tn]),Cr);if(Er){let Tn=Bv(Er),aa=to.get(Tn);if(aa){let ao=Ds(aa,mi,Je,br,fn(Je),sn,hn);return qr.add(aa.path,Je),bc(ao,br,Je,Ci),ql(ao,Ht),Nr.set(br,V9(Er)),ye.push(ao),ao}else mi&&(to.set(Tn,mi),Nr.set(br,V9(Er)))}if(bc(mi,br,Je,Ci),mi){if(nr.set(br,rn>0),mi.fileName=Je,mi.path=br,mi.resolvedPath=fn(Je),mi.originalFileName=sn,mi.packageJsonLocations=(nn=hn.packageJsonLocations)!=null&&nn.length?hn.packageJsonLocations:void 0,mi.packageJsonScope=hn.packageJsonScope,ql(mi,Ht),tr.useCaseSensitiveFileNames()){let Tn=sp(br),aa=Ot.get(Tn);aa?Zr(Je,aa,Ht):Ot.set(Tn,mi)}xs=xs||mi.hasNoDefaultLib&&!Ft,z.noResolve||(Yh(mi,et),Ly(mi)),z.noLib||Of(mi),ct(mi),et?ce.push(mi):ye.push(mi)}return mi}function ql(Je,et){Je&&Ae.add(Je.path,et)}function bc(Je,et,Ft,Ht){Ht?(Ic(Ft,Ht,Je),Ic(Ft,et,Je||!1)):Ic(Ft,et,Je)}function Ic(Je,et,Ft){mt.set(et,Ft),Ft!==void 0?dt.delete(et):dt.set(et,Je)}function cl(Je){let et=bl(Je);return et&&xu(et,Je)}function bl(Je){if(!(!_e||!_e.length||i_(Je)||Uc(Je,".json")))return dd(Je)}function xu(Je,et){let Ft=Wo(Je.commandLine.options);return Ft?bT(Ft,".d.ts"):mO(et,Je.commandLine,!tr.useCaseSensitiveFileNames())}function dd(Je){pt===void 0&&(pt=new Map,wf(Ft=>{fn(z.configFilePath)!==Ft.sourceFile.path&&Ft.commandLine.fileNames.forEach(Ht=>pt.set(fn(Ht),Ft.sourceFile.path))}));let et=pt.get(fn(Je));return et&&ch(et)}function wf(Je){return WZ(_e,Je)}function hf(Je){if(i_(Je))return W===void 0&&(W=new Map,wf(et=>{let Ft=Wo(et.commandLine.options);if(Ft){let Ht=bT(Ft,".d.ts");W.set(fn(Ht),!0)}else{let Ht=D_(()=>_D(et.commandLine,!tr.useCaseSensitiveFileNames()));Te(et.commandLine.fileNames,Er=>{if(!i_(Er)&&!Uc(Er,".json")){let nn=mO(Er,et.commandLine,!tr.useCaseSensitiveFileNames(),Ht);W.set(fn(nn),Er)}})}})),W.get(Je)}function Fd(Je){return st&&!!dd(Je)}function ch(Je){if(Ve)return Ve.get(Je)||void 0}function Yh(Je,et){Te(Je.referencedFiles,(Ft,Ht)=>{Oe(SV(Ft.fileName,Je.fileName),et,!1,void 0,{kind:4,file:Je.path,index:Ht})})}function Ly(Je){let et=Je.typeReferenceDirectives;if(!et.length)return;let Ft=ar?.get(Je.path)||ji(et,Je),Ht=uk();(yt??(yt=new Map)).set(Je.path,Ht);for(let Er=0;Er<et.length;Er++){let nn=Je.typeReferenceDirectives[Er],br=Ft[Er],sn=sp(nn.fileName);Ht.set(sn,wM(nn,Je.impliedNodeFormat),br);let Ci=nn.resolutionMode||Je.impliedNodeFormat;A_(sn,Ci,br,{kind:5,file:Je.path,index:Er})}}function A_(Je,et,Ft,Ht){var Er,nn;(Er=mn)==null||Er.push(mn.Phase.Program,"processTypeReferenceDirective",{directive:Je,hasResolved:!!Ft.resolvedTypeReferenceDirective,refKind:Ht.kind,refPath:MT(Ht)?Ht.file:void 0}),Fy(Je,et,Ft,Ht),(nn=mn)==null||nn.pop()}function Fy(Je,et,Ft,Ht){var Er;It(Ft);let nn=(Er=Ue.get(Je,et))==null?void 0:Er.resolvedTypeReferenceDirective;if(nn&&nn.primary)return;let br=!0,{resolvedTypeReferenceDirective:sn}=Ft;if(sn){if(sn.isExternalLibraryImport&&rn++,sn.primary)Oe(sn.resolvedFileName,!1,!1,sn.packageId,Ht);else if(nn){if(sn.resolvedFileName!==nn.resolvedFileName){let Ci=tr.readFile(sn.resolvedFileName),hn=$a(nn.resolvedFileName);Ci!==hn.text&&ci(hn,Ht,g.Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict,[Je,sn.resolvedFileName,nn.resolvedFileName])}br=!1}else Oe(sn.resolvedFileName,!1,!1,sn.packageId,Ht);sn.isExternalLibraryImport&&rn--}else ci(void 0,Ht,g.Cannot_find_type_definition_file_for_0,[Je]);br&&Ue.set(Je,et,Ft)}function vp(Je){let et=at?.get(Je);if(et)return et.actual;let Ft=U0(Je);return(at??(at=new Map)).set(Je,Ft),Ft.actual}function U0(Je){var et,Ft,Ht,Er,nn;let br=$t?.get(Je);if(br)return br;if(hr!==0&&Z&&!Fs(Je)){let Tn=(et=Z.resolvedLibReferences)==null?void 0:et.get(Je);if(Tn){if(Tn.resolution&&wy(z,tr)){let aa=GZ(Je),ao=EV(z,ri,Je);ws(tr,Tn.resolution.resolvedModule?Tn.resolution.resolvedModule.packageId?g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2:g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved,aa,Ps(ao,ri),(Ft=Tn.resolution.resolvedModule)==null?void 0:Ft.resolvedFileName,((Ht=Tn.resolution.resolvedModule)==null?void 0:Ht.packageId)&&Bv(Tn.resolution.resolvedModule.packageId))}return($t??($t=new Map)).set(Je,Tn),Tn}}let sn=GZ(Je),Ci=EV(z,ri,Je);(Er=mn)==null||Er.push(mn.Phase.Program,"resolveLibrary",{resolveFrom:Ci}),mc("beforeResolveLibrary");let hn=Ta(sn,Ci,z,Je);mc("afterResolveLibrary"),rd("ResolveLibrary","beforeResolveLibrary","afterResolveLibrary"),(nn=mn)==null||nn.pop();let mi={resolution:hn,actual:hn.resolvedModule?hn.resolvedModule.resolvedFileName:li(Ms,Je)};return($t??($t=new Map)).set(Je,mi),mi}function Of(Je){Te(Je.libReferenceDirectives,(et,Ft)=>{let{libName:Ht,libFileName:Er}=qMe(et);if(Er)sc(vp(Er),!0,!0,{kind:7,file:Je.path,index:Ft});else{let nn=cA(hw(Ht,"lib."),".d.ts"),br=FP(nn,sM,Mo),sn=br?g.Cannot_find_lib_definition_for_0_Did_you_mean_1:g.Cannot_find_lib_definition_for_0,Ci=br?[Ht,br]:[Ht];(kt||(kt=[])).push({kind:0,reason:{kind:7,file:Je.path,index:Ft},diagnostic:sn,args:Ci})}})}function ie(Je){return tr.getCanonicalFileName(Je)}function ct(Je){var et;if(Xf(Je),Je.imports.length||Je.moduleAugmentations.length){let Ft=zMe(Je),Ht=Ze?.get(Je.path)||Vi(Ft,Je);I.assert(Ht.length===Ft.length);let Er=((et=zr(Je))==null?void 0:et.commandLine.options)||z,nn=uk();(St??(St=new Map)).set(Je.path,nn);for(let br=0;br<Ft.length;br++){let sn=Ht[br].resolvedModule,Ci=Ft[br].text,hn=qZ(Je,Ft[br],Er);if(nn.set(Ci,hn,Ht[br]),Rt(Je,Ci,Ht[br],hn),!sn)continue;let mi=sn.isExternalLibraryImport,Tn=!g6(sn.extension),aa=mi&&Tn&&(!sn.originalPath||OT(sn.resolvedFileName)),ao=sn.resolvedFileName;mi&&rn++;let B_=aa&&rn>Fr,Hu=ao&&!QZ(Er,sn,Je)&&!Er.noResolve&&br<Je.imports.length&&!B_&&!(Tn&&!Hv(Er))&&(gn(Je.imports[br])||!(Je.imports[br].flags&16777216));B_?Tr.set(Je.path,!0):Hu&&sa(ao,!1,!1,{kind:3,file:Je.path,index:br},sn.packageId),mi&&rn--}}}function Jt(Je,et){let Ft=!0,Ht=tr.getCanonicalFileName(Ps(et,ri));for(let Er of Je)Er.isDeclarationFile||tr.getCanonicalFileName(Ps(Er.fileName,ri)).indexOf(Ht)!==0&&(ds(Er,g.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files,[Er.fileName,et]),Ft=!1);return Ft}function Gt(Je){Ve||(Ve=new Map);let et=dD(Je),Ft=fn(et),Ht=Ve.get(Ft);if(Ht!==void 0)return Ht||void 0;let Er,nn;if(tr.getParsedCommandLine){if(Er=tr.getParsedCommandLine(et),!Er){bc(void 0,Ft,et,void 0),Ve.set(Ft,!1);return}nn=I.checkDefined(Er.options.configFile),I.assert(!nn.path||nn.path===Ft),bc(nn,Ft,et,void 0)}else{let sn=Ps(hi(et),ri);if(nn=tr.getSourceFile(et,100),bc(nn,Ft,et,void 0),nn===void 0){Ve.set(Ft,!1);return}Er=rM(nn,ki,sn,void 0,et)}nn.fileName=et,nn.path=Ft,nn.resolvedPath=Ft,nn.originalFileName=et;let br={commandLine:Er,sourceFile:nn};return Ve.set(Ft,br),Er.projectReferences&&(br.references=Er.projectReferences.map(Gt)),br}function V(){z.strictPropertyInitialization&&!K_(z,"strictNullChecks")&&xo(g.Option_0_cannot_be_specified_without_specifying_option_1,"strictPropertyInitialization","strictNullChecks"),z.exactOptionalPropertyTypes&&!K_(z,"strictNullChecks")&&xo(g.Option_0_cannot_be_specified_without_specifying_option_1,"exactOptionalPropertyTypes","strictNullChecks"),(z.isolatedModules||z.verbatimModuleSyntax)&&(z.out&&xo(g.Option_0_cannot_be_specified_with_option_1,"out",z.verbatimModuleSyntax?"verbatimModuleSyntax":"isolatedModules"),z.outFile&&xo(g.Option_0_cannot_be_specified_with_option_1,"outFile",z.verbatimModuleSyntax?"verbatimModuleSyntax":"isolatedModules")),z.inlineSourceMap&&(z.sourceMap&&xo(g.Option_0_cannot_be_specified_with_option_1,"sourceMap","inlineSourceMap"),z.mapRoot&&xo(g.Option_0_cannot_be_specified_with_option_1,"mapRoot","inlineSourceMap")),z.composite&&(z.declaration===!1&&xo(g.Composite_projects_may_not_disable_declaration_emit,"declaration"),z.incremental===!1&&xo(g.Composite_projects_may_not_disable_incremental_compilation,"declaration"));let Je=Wo(z);if(z.tsBuildInfoFile?N6(z)||xo(g.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"tsBuildInfoFile","incremental","composite"):z.incremental&&!Je&&!z.configFilePath&&un.add(fl(g.Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified)),Yt(),Xa(),z.composite){let br=new Set(pe.map(fn));for(let sn of we)Q2(sn,Sr)&&!br.has(sn.path)&&ds(sn,g.File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern,[sn.fileName,z.configFilePath||""])}if(z.paths){for(let br in z.paths)if(wo(z.paths,br))if(jX(br)||Gu(!0,br,g.Pattern_0_can_have_at_most_one_Asterisk_character,br),os(z.paths[br])){let sn=z.paths[br].length;sn===0&&Gu(!1,br,g.Substitutions_for_pattern_0_shouldn_t_be_an_empty_array,br);for(let Ci=0;Ci<sn;Ci++){let hn=z.paths[br][Ci],mi=typeof hn;mi==="string"?(jX(hn)||Zc(br,Ci,g.Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character,hn,br),!z.baseUrl&&!Fp(hn)&&!Tw(hn)&&Zc(br,Ci,g.Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash)):Zc(br,Ci,g.Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2,hn,br,mi)}}else Gu(!1,br,g.Substitutions_for_pattern_0_should_be_an_array,br)}!z.sourceMap&&!z.inlineSourceMap&&(z.inlineSources&&xo(g.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided,"inlineSources"),z.sourceRoot&&xo(g.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided,"sourceRoot")),z.out&&z.outFile&&xo(g.Option_0_cannot_be_specified_with_option_1,"out","outFile"),z.mapRoot&&!(z.sourceMap||z.declarationMap)&&xo(g.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"mapRoot","sourceMap","declarationMap"),z.declarationDir&&(Dd(z)||xo(g.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"declarationDir","declaration","composite"),Je&&xo(g.Option_0_cannot_be_specified_with_option_1,"declarationDir",z.out?"out":"outFile")),z.declarationMap&&!Dd(z)&&xo(g.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"declarationMap","declaration","composite"),z.lib&&z.noLib&&xo(g.Option_0_cannot_be_specified_with_option_1,"lib","noLib"),z.noImplicitUseStrict&&K_(z,"alwaysStrict")&&xo(g.Option_0_cannot_be_specified_with_option_1,"noImplicitUseStrict","alwaysStrict");let et=ho(z),Ft=mr(we,br=>Pl(br)&&!br.isDeclarationFile);if(z.isolatedModules||z.verbatimModuleSyntax)z.module===0&&et<2&&z.isolatedModules&&xo(g.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher,"isolatedModules","target"),z.preserveConstEnums===!1&&xo(g.Option_preserveConstEnums_cannot_be_disabled_when_0_is_enabled,z.verbatimModuleSyntax?"verbatimModuleSyntax":"isolatedModules","preserveConstEnums");else if(Ft&&et<2&&z.module===0){let br=z2(Ft,typeof Ft.externalModuleIndicator=="boolean"?Ft:Ft.externalModuleIndicator);un.add(Iu(Ft,br.start,br.length,g.Cannot_use_imports_exports_or_module_augmentations_when_module_is_none))}if(Je&&!z.emitDeclarationOnly){if(z.module&&!(z.module===2||z.module===4))xo(g.Only_amd_and_system_modules_are_supported_alongside_0,z.out?"out":"outFile","module");else if(z.module===void 0&&Ft){let br=z2(Ft,typeof Ft.externalModuleIndicator=="boolean"?Ft:Ft.externalModuleIndicator);un.add(Iu(Ft,br.start,br.length,g.Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system,z.out?"out":"outFile"))}}if(xT(z)&&(Q_(z)===1?xo(g.Option_resolveJsonModule_cannot_be_specified_when_moduleResolution_is_set_to_classic,"resolveJsonModule"):$j(z)||xo(g.Option_resolveJsonModule_cannot_be_specified_when_module_is_set_to_none_system_or_umd,"resolveJsonModule","module")),z.outDir||z.rootDir||z.sourceRoot||z.mapRoot){let br=Qn();z.outDir&&br===""&&we.some(sn=>wh(sn.fileName)>1)&&xo(g.Cannot_find_the_common_subdirectory_path_for_the_input_files,"outDir")}z.useDefineForClassFields&&et===0&&xo(g.Option_0_cannot_be_specified_when_option_target_is_ES3,"useDefineForClassFields"),z.checkJs&&!Hv(z)&&un.add(fl(g.Option_0_cannot_be_specified_without_specifying_option_1,"checkJs","allowJs")),z.emitDeclarationOnly&&(Dd(z)||xo(g.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2,"emitDeclarationOnly","declaration","composite"),z.noEmit&&xo(g.Option_0_cannot_be_specified_with_option_1,"emitDeclarationOnly","noEmit")),z.emitDecoratorMetadata&&!z.experimentalDecorators&&xo(g.Option_0_cannot_be_specified_without_specifying_option_1,"emitDecoratorMetadata","experimentalDecorators"),z.jsxFactory?(z.reactNamespace&&xo(g.Option_0_cannot_be_specified_with_option_1,"reactNamespace","jsxFactory"),(z.jsx===4||z.jsx===5)&&xo(g.Option_0_cannot_be_specified_when_option_jsx_is_1,"jsxFactory",Z6.get(""+z.jsx)),ok(z.jsxFactory,et)||Wm("jsxFactory",g.Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name,z.jsxFactory)):z.reactNamespace&&!nd(z.reactNamespace,et)&&Wm("reactNamespace",g.Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier,z.reactNamespace),z.jsxFragmentFactory&&(z.jsxFactory||xo(g.Option_0_cannot_be_specified_without_specifying_option_1,"jsxFragmentFactory","jsxFactory"),(z.jsx===4||z.jsx===5)&&xo(g.Option_0_cannot_be_specified_when_option_jsx_is_1,"jsxFragmentFactory",Z6.get(""+z.jsx)),ok(z.jsxFragmentFactory,et)||Wm("jsxFragmentFactory",g.Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name,z.jsxFragmentFactory)),z.reactNamespace&&(z.jsx===4||z.jsx===5)&&xo(g.Option_0_cannot_be_specified_when_option_jsx_is_1,"reactNamespace",Z6.get(""+z.jsx)),z.jsxImportSource&&z.jsx===2&&xo(g.Option_0_cannot_be_specified_when_option_jsx_is_1,"jsxImportSource",Z6.get(""+z.jsx)),z.preserveValueImports&&T_(z)<5&&xo(g.Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later,"preserveValueImports");let Ht=T_(z);z.verbatimModuleSyntax&&((Ht===2||Ht===3||Ht===4)&&xo(g.Option_verbatimModuleSyntax_cannot_be_used_when_module_is_set_to_UMD_AMD_or_System,"verbatimModuleSyntax"),z.preserveValueImports&&Hm("preserveValueImports","verbatimModuleSyntax"),z.importsNotUsedAsValues&&Hm("importsNotUsedAsValues","verbatimModuleSyntax")),z.allowImportingTsExtensions&&!(z.noEmit||z.emitDeclarationOnly)&&Wm("allowImportingTsExtensions",g.Option_allowImportingTsExtensions_can_only_be_used_when_either_noEmit_or_emitDeclarationOnly_is_set);let Er=Q_(z);if(z.resolvePackageJsonExports&&!MA(Er)&&xo(g.Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler,"resolvePackageJsonExports"),z.resolvePackageJsonImports&&!MA(Er)&&xo(g.Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler,"resolvePackageJsonImports"),z.customConditions&&!MA(Er)&&xo(g.Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler,"customConditions"),Er===100&&!zj(Ht)&&Ht!==200&&Wm("moduleResolution",g.Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later,"bundler"),vw[Ht]&&100<=Ht&&Ht<=199&&!(3<=Er&&Er<=99)){let br=vw[Ht];Wm("moduleResolution",g.Option_moduleResolution_must_be_set_to_0_or_left_unspecified_when_option_module_is_set_to_1,br,br)}else if(JP[Er]&&3<=Er&&Er<=99&&!(100<=Ht&&Ht<=199)){let br=JP[Er];Wm("module",g.Option_module_must_be_set_to_0_when_option_moduleResolution_is_set_to_1,br,br)}if(!z.noEmit&&!z.suppressOutputPathCheck){let br=Mr(),sn=new Set;CZ(br,Ci=>{z.emitDeclarationOnly||nn(Ci.jsFilePath,sn),nn(Ci.declarationFilePath,sn)})}function nn(br,sn){if(br){let Ci=fn(br);if(mt.has(Ci)){let mi;z.configFilePath||(mi=Xs(void 0,g.Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig)),mi=Xs(mi,g.Cannot_write_file_0_because_it_would_overwrite_input_file,br),wE(br,Jj(mi))}let hn=tr.useCaseSensitiveFileNames()?Ci:sp(Ci);sn.has(hn)?wE(br,fl(g.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files,br)):sn.add(hn)}}}function Pe(){let Je=z.ignoreDeprecations;if(Je){if(Je==="5.0")return new Im(Je);Q()}return Im.zero}function ot(Je,et,Ft,Ht){let Er=new Im(Je),nn=new Im(et),br=new Im(xe||w),sn=Pe(),Ci=nn.compareTo(br)!==1,hn=!Ci&&sn.compareTo(Er)===-1;(Ci||hn)&&Ht((mi,Tn,aa)=>{Ci?Tn===void 0?Ft(mi,Tn,aa,g.Option_0_has_been_removed_Please_remove_it_from_your_configuration,mi):Ft(mi,Tn,aa,g.Option_0_1_has_been_removed_Please_remove_it_from_your_configuration,mi,Tn):Tn===void 0?Ft(mi,Tn,aa,g.Option_0_is_deprecated_and_will_stop_functioning_in_TypeScript_1_Specify_compilerOption_ignoreDeprecations_Colon_2_to_silence_this_error,mi,et,Je):Ft(mi,Tn,aa,g.Option_0_1_is_deprecated_and_will_stop_functioning_in_TypeScript_2_Specify_compilerOption_ignoreDeprecations_Colon_3_to_silence_this_error,mi,Tn,et,Je)})}function Yt(){function Je(et,Ft,Ht,Er,...nn){if(Ht){let br=Xs(void 0,g.Use_0_instead,Ht),sn=Xs(br,Er,...nn);ts(!Ft,et,void 0,sn)}else ts(!Ft,et,void 0,Er,...nn)}ot("5.0","5.5",Je,et=>{z.target===0&&et("target","ES3"),z.noImplicitUseStrict&&et("noImplicitUseStrict"),z.keyofStringsOnly&&et("keyofStringsOnly"),z.suppressExcessPropertyErrors&&et("suppressExcessPropertyErrors"),z.suppressImplicitAnyIndexErrors&&et("suppressImplicitAnyIndexErrors"),z.noStrictGenericChecks&&et("noStrictGenericChecks"),z.charset&&et("charset"),z.out&&et("out",void 0,"outFile"),z.importsNotUsedAsValues&&et("importsNotUsedAsValues",void 0,"verbatimModuleSyntax"),z.preserveValueImports&&et("preserveValueImports",void 0,"verbatimModuleSyntax")})}function _n(Je,et,Ft){function Ht(Er,nn,br,sn,...Ci){Gm(et,Ft,sn,...Ci)}ot("5.0","5.5",Ht,Er=>{Je.prepend&&Er("prepend")})}function gi(Je,et,Ft,Ht){var Er;let nn,br,sn=MT(et)?et:void 0;Je&&((Er=Ae.get(Je.path))==null||Er.forEach(aa)),et&&aa(et),sn&&nn?.length===1&&(nn=void 0);let Ci=sn&&hO(Sr,sn),hn=nn&&Xs(nn,g.The_file_is_in_the_program_because_Colon),mi=Je&&mee(Je),Tn=Xs(mi?hn?[hn,...mi]:mi:hn,Ft,...Ht||tt);return Ci&&pD(Ci)?H9(Ci.file,Ci.pos,Ci.end-Ci.pos,Tn,br):Jj(Tn,br);function aa(ao){(nn||(nn=[])).push(yee(Sr,ao)),!sn&&MT(ao)?sn=ao:sn!==ao&&(br=Pr(br,Ya(ao))),ao===et&&(et=void 0)}}function ci(Je,et,Ft,Ht){(kt||(kt=[])).push({kind:1,file:Je&&Je.path,fileProcessingReason:et,diagnostic:Ft,args:Ht})}function ds(Je,et,Ft){un.add(gi(Je,void 0,et,Ft))}function Ya(Je){if(MT(Je)){let Ht=hO(Sr,Je),Er;switch(Je.kind){case 3:Er=g.File_is_included_via_import_here;break;case 4:Er=g.File_is_included_via_reference_here;break;case 5:Er=g.File_is_included_via_type_library_reference_here;break;case 7:Er=g.File_is_included_via_library_reference_here;break;default:I.assertNever(Je)}return pD(Ht)?Iu(Ht.file,Ht.pos,Ht.end-Ht.pos,Er):void 0}if(!z.configFile)return;let et,Ft;switch(Je.kind){case 0:if(!z.configFile.configFileSpecs)return;let Ht=Ps(pe[Je.index],ri),Er=gee(Sr,Ht);if(Er){et=tj(z.configFile,"files",Er),Ft=g.File_is_matched_by_files_list_specified_here;break}let nn=hee(Sr,Ht);if(!nn||!vs(nn))return;et=tj(z.configFile,"include",nn),Ft=g.File_is_matched_by_include_pattern_specified_here;break;case 1:case 2:let br=I.checkDefined(_e?.[Je.index]),sn=bV(Se,_e,(aa,ao,B_)=>aa===br?{sourceFile:ao?.sourceFile||z.configFile,index:B_}:void 0);if(!sn)return;let{sourceFile:Ci,index:hn}=sn,mi=b8(Ci,"references",aa=>Z_(aa.initializer)?aa.initializer:void 0);return mi&&mi.elements.length>hn?im(Ci,mi.elements[hn],Je.kind===2?g.File_is_output_from_referenced_project_specified_here:g.File_is_source_from_referenced_project_specified_here):void 0;case 8:if(!z.types)return;et=_S("types",Je.typeReference),Ft=g.File_is_entry_point_of_type_library_specified_here;break;case 6:if(Je.index!==void 0){et=_S("lib",z.lib[Je.index]),Ft=g.File_is_library_specified_here;break}let Tn=yu(oM.type,(aa,ao)=>aa===ho(z)?ao:void 0);et=Tn?Rf("target",Tn):void 0,Ft=g.File_is_default_library_for_target_specified_here;break;default:I.assertNever(Je)}return et&&im(z.configFile,et,Ft)}function Xa(){let Je=z.suppressOutputPathCheck?void 0:B1(z);bV(Se,_e,(et,Ft,Ht)=>{let Er=(Ft?Ft.commandLine.projectReferences:Se)[Ht],nn=Ft&&Ft.sourceFile;if(_n(Er,nn,Ht),!et){Gm(nn,Ht,g.File_0_not_found,Er.path);return}let br=et.commandLine.options;if((!br.composite||br.noEmit)&&(Ft?Ft.commandLine.fileNames:pe).length&&(br.composite||Gm(nn,Ht,g.Referenced_project_0_must_have_setting_composite_Colon_true,Er.path),br.noEmit&&Gm(nn,Ht,g.Referenced_project_0_may_not_disable_emit,Er.path)),Er.prepend){let sn=Wo(br);sn?tr.fileExists(sn)||Gm(nn,Ht,g.Output_file_0_from_project_1_does_not_exist,sn,Er.path):Gm(nn,Ht,g.Cannot_prepend_project_0_because_it_does_not_have_outFile_set,Er.path)}!Ft&&Je&&Je===B1(br)&&(Gm(nn,Ht,g.Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1,Je,Er.path),rt.set(fn(Je),!0))})}function Zc(Je,et,Ft,...Ht){let Er=!0;Sp(nn=>{Ha(nn.initializer)&&lN(nn.initializer,Je,br=>{let sn=br.initializer;Z_(sn)&&sn.elements.length>et&&(un.add(im(z.configFile,sn.elements[et],Ft,...Ht)),Er=!1)})}),Er&&un.add(fl(Ft,...Ht))}function Gu(Je,et,Ft,...Ht){let Er=!0;Sp(nn=>{Ha(nn.initializer)&&H1(nn.initializer,Je,et,void 0,Ft,...Ht)&&(Er=!1)}),Er&&un.add(fl(Ft,...Ht))}function nu(Je,et){return lN(jy(),Je,et)}function Sp(Je){return nu("paths",Je)}function Rf(Je,et){return nu(Je,Ft=>za(Ft.initializer)&&Ft.initializer.text===et?Ft.initializer:void 0)}function _S(Je,et){let Ft=jy();return Ft&&hde(Ft,Je,et)}function xo(Je,et,Ft,Ht){ts(!0,et,Ft,Je,et,Ft,Ht)}function Wm(Je,et,...Ft){ts(!1,Je,void 0,et,...Ft)}function Gm(Je,et,Ft,...Ht){let Er=b8(Je||z.configFile,"references",nn=>Z_(nn.initializer)?nn.initializer:void 0);Er&&Er.elements.length>et?un.add(im(Je||z.configFile,Er.elements[et],Ft,...Ht)):un.add(fl(Ft,...Ht))}function ts(Je,et,Ft,Ht,...Er){let nn=jy();(!nn||!H1(nn,Je,et,Ft,Ht,...Er))&&("messageText"in Ht?un.add(Jj(Ht)):un.add(fl(Ht,...Er)))}function jy(){return zt===void 0&&(zt=lN(qw(z.configFile),"compilerOptions",Je=>Ha(Je.initializer)?Je.initializer:void 0)||!1),zt||void 0}function H1(Je,et,Ft,Ht,Er,...nn){let br=!1;return lN(Je,Ft,sn=>{"messageText"in Er?un.add(Ey(z.configFile,et?sn.name:sn.initializer,Er)):un.add(im(z.configFile,et?sn.name:sn.initializer,Er,...nn)),br=!0},Ht),br}function Hm(Je,et){let Ft=jy();Ft?H1(Ft,!0,Je,void 0,g.Option_0_is_redundant_and_cannot_be_specified_with_option_1,Je,et):xo(g.Option_0_is_redundant_and_cannot_be_specified_with_option_1,Je,et)}function wE(Je,et){rt.set(fn(Je),!0),un.add(et)}function OE(Je){if(z.noEmit)return!1;let et=fn(Je);if(Ac(et))return!1;let Ft=Wo(z);if(Ft)return md(et,Ft)||md(et,ff(Ft)+".d.ts");if(z.declarationDir&&wm(z.declarationDir,et,ri,!tr.useCaseSensitiveFileNames()))return!0;if(z.outDir)return wm(z.outDir,et,ri,!tr.useCaseSensitiveFileNames());if(Ql(et,jN)||i_(et)){let Ht=ff(et);return!!Ac(Ht+".ts")||!!Ac(Ht+".tsx")}return!1}function md(Je,et){return yy(Je,et,ri,!tr.useCaseSensitiveFileNames())===0}function lh(){return tr.getSymlinkCache?tr.getSymlinkCache():(ve||(ve=BX(ri,ie)),we&&!ve.hasProcessedResolutions()&&ve.setSymlinksFromResolutions(B,le,$e),ve)}function gd(Je,et){var Ft;let Ht=((Ft=zr(Je))==null?void 0:Ft.commandLine.options)||z;return qZ(Je,et,Ht)}function By(Je,et){return gd(Je,MM(Je,et))}}function JTt(e){let t,n=e.compilerHost.fileExists,i=e.compilerHost.directoryExists,s=e.compilerHost.getDirectories,o=e.compilerHost.realpath;if(!e.useSourceOfProjectReferenceRedirect)return{onProgramCreateComplete:ja,fileExists:m};e.compilerHost.fileExists=m;let l;return i&&(l=e.compilerHost.directoryExists=k=>i.call(e.compilerHost,k)?(b(k),!0):e.getResolvedProjectReferences()?(t||(t=new Set,e.forEachResolvedProjectReference(N=>{let M=Wo(N.commandLine.options);if(M)t.add(hi(e.toPath(M)));else{let O=N.commandLine.options.declarationDir||N.commandLine.options.outDir;O&&t.add(e.toPath(O))}})),A(k,!1)):!1),s&&(e.compilerHost.getDirectories=k=>!e.getResolvedProjectReferences()||i&&i.call(e.compilerHost,k)?s.call(e.compilerHost,k):[]),o&&(e.compilerHost.realpath=k=>{var N;return((N=e.getSymlinkCache().getSymlinkedFiles())==null?void 0:N.get(e.toPath(k)))||o.call(e.compilerHost,k)}),{onProgramCreateComplete:p,fileExists:m,directoryExists:l};function p(){e.compilerHost.fileExists=n,e.compilerHost.directoryExists=i,e.compilerHost.getDirectories=s}function m(k){return n.call(e.compilerHost,k)?!0:!e.getResolvedProjectReferences()||!i_(k)?!1:A(k,!0)}function S(k){let N=e.getSourceOfProjectReferenceRedirect(e.toPath(k));return N!==void 0?vs(N)?n.call(e.compilerHost,N):!0:void 0}function h(k){let N=e.toPath(k),M=`${N}${hc}`;return Mh(t,O=>N===O||Ss(O,M)||Ss(N,`${O}/`))}function b(k){var N;if(!e.getResolvedProjectReferences()||b6(k)||!o||!k.includes(Wh))return;let M=e.getSymlinkCache(),O=hu(e.toPath(k));if((N=M.getSymlinkedDirectories())!=null&&N.has(O))return;let U=Ca(o.call(e.compilerHost,k)),H;if(U===k||(H=hu(e.toPath(U)))===O){M.setSymlinkedDirectory(O,!1);return}M.setSymlinkedDirectory(k,{real:hu(U),realPath:H})}function A(k,N){var M;let O=N?$=>S($):$=>h($),U=O(k);if(U!==void 0)return U;let H=e.getSymlinkCache(),K=H.getSymlinkedDirectories();if(!K)return!1;let re=e.toPath(k);return re.includes(Wh)?N&&((M=H.getSymlinkedFiles())!=null&&M.has(re))?!0:Kt(K.entries(),([$,pe])=>{if(!pe||!Ss(re,$))return;let z=O(re.replace($,pe.realPath));if(N&&z){let se=Ps(k,e.compilerHost.getCurrentDirectory());H.setSymlinkedFile(re,`${pe.real}${se.replace(new RegExp($,"i"),"")}`)}return z})||!1:!1}}function XZ(e,t,n,i){let s=e.getCompilerOptions();if(s.noEmit)return e.getSemanticDiagnostics(t,i),t||Wo(s)?NV:e.emitBuildInfo(n,i);if(!s.noEmitOnError)return;let o=[...e.getOptionsDiagnostics(i),...e.getSyntacticDiagnostics(t,i),...e.getGlobalDiagnostics(i),...e.getSemanticDiagnostics(t,i)];if(o.length===0&&Dd(e.getCompilerOptions())&&(o=e.getDeclarationDiagnostics(void 0,i)),!o.length)return;let l;if(!t&&!Wo(s)){let p=e.emitBuildInfo(n,i);p.diagnostics&&(o=[...o,...p.diagnostics]),l=p.emittedFiles}return{diagnostics:o,sourceMaps:void 0,emittedFiles:l,emitSkipped:!0}}function CV(e,t){return Fn(e,n=>!n.skippedOn||!t[n.skippedOn])}function AV(e,t=e){return{fileExists:n=>t.fileExists(n),readDirectory(n,i,s,o,l){return I.assertIsDefined(t.readDirectory,"'CompilerHost.readDirectory' must be implemented to correctly process 'projectReferences'"),t.readDirectory(n,i,s,o,l)},readFile:n=>t.readFile(n),directoryExists:rs(t,t.directoryExists),getDirectories:rs(t,t.getDirectories),realpath:rs(t,t.realpath),useCaseSensitiveFileNames:e.useCaseSensitiveFileNames(),getCurrentDirectory:()=>e.getCurrentDirectory(),onUnRecoverableConfigFileDiagnostic:e.onUnRecoverableConfigFileDiagnostic||xd,trace:e.trace?n=>e.trace(n):void 0}}function KZ(e,t,n,i){if(!e)return tt;let s;for(let o=0;o<e.length;o++){let l=e[o],p=t(l,o);if(l.prepend&&p&&p.options){if(!Wo(p.options))continue;let{jsFilePath:S,sourceMapFilePath:h,declarationFilePath:b,declarationMapPath:A,buildInfoPath:k}=pO(p.options,!0),N=vK(n,S,h,b,A,k,i,p.options);(s||(s=[])).push(N)}}return s||tt}function dD(e){return xee(e.path)}function QZ(e,{extension:t},{isDeclarationFile:n}){switch(t){case".ts":case".d.ts":case".mts":case".d.mts":case".cts":case".d.cts":return;case".tsx":return i();case".jsx":return i()||s();case".js":case".mjs":case".cjs":return s();case".json":return o();default:return l()}function i(){return e.jsx?void 0:g.Module_0_was_resolved_to_1_but_jsx_is_not_set}function s(){return Hv(e)||!K_(e,"noImplicitAny")?void 0:g.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type}function o(){return xT(e)?void 0:g.Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used}function l(){return n||e.allowArbitraryExtensions?void 0:g.Module_0_was_resolved_to_1_but_allowArbitraryExtensions_is_not_set}}function zMe({imports:e,moduleAugmentations:t}){let n=e.map(i=>i);for(let i of t)i.kind===11&&n.push(i);return n}function MM({imports:e,moduleAugmentations:t},n){if(n<e.length)return e[n];let i=e.length;for(let s of t)if(s.kind===11){if(n===i)return s;i++}I.fail("should never ask for module name at index higher than possible module name")}var ZZ,eee,tee,aye,oye,$Me,cye,lye,kV,WMe,mD,PV,NV,qTt=f({"src/compiler/program.ts"(){"use strict";fa(),O2(),ZZ=(e=>(e.Grey="\x1B[90m",e.Red="\x1B[91m",e.Yellow="\x1B[93m",e.Blue="\x1B[94m",e.Cyan="\x1B[96m",e))(ZZ||{}),eee="\x1B[7m",tee=" ",aye="\x1B[0m",oye="...",$Me="  ",cye="    ",lye={resolvedModule:void 0,resolvedTypeReferenceDirective:void 0},kV={getName:sye,getMode:(e,t,n)=>JZ(t,e,n)},WMe={getName:$Z,getMode:(e,t)=>wM(e,t?.impliedNodeFormat)},mD="__inferred type names__.ts",PV=new Set([g.Cannot_redeclare_block_scoped_variable_0.code,g.A_module_cannot_have_multiple_default_exports.code,g.Another_export_default_is_here.code,g.The_first_export_default_is_here.code,g.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module.code,g.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode.code,g.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here.code,g.constructor_is_a_reserved_word.code,g.delete_cannot_be_called_on_an_identifier_in_strict_mode.code,g.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode.code,g.Invalid_use_of_0_Modules_are_automatically_in_strict_mode.code,g.Invalid_use_of_0_in_strict_mode.code,g.A_label_is_not_allowed_here.code,g.with_statements_are_not_allowed_in_strict_mode.code,g.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement.code,g.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement.code,g.A_class_declaration_without_the_default_modifier_must_have_a_name.code,g.A_class_member_cannot_have_the_0_keyword.code,g.A_comma_expression_is_not_allowed_in_a_computed_property_name.code,g.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement.code,g.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code,g.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code,g.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement.code,g.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration.code,g.A_definite_assignment_assertion_is_not_permitted_in_this_context.code,g.A_destructuring_declaration_must_have_an_initializer.code,g.A_get_accessor_cannot_have_parameters.code,g.A_rest_element_cannot_contain_a_binding_pattern.code,g.A_rest_element_cannot_have_a_property_name.code,g.A_rest_element_cannot_have_an_initializer.code,g.A_rest_element_must_be_last_in_a_destructuring_pattern.code,g.A_rest_parameter_cannot_have_an_initializer.code,g.A_rest_parameter_must_be_last_in_a_parameter_list.code,g.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma.code,g.A_return_statement_cannot_be_used_inside_a_class_static_block.code,g.A_set_accessor_cannot_have_rest_parameter.code,g.A_set_accessor_must_have_exactly_one_parameter.code,g.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module.code,g.An_export_declaration_cannot_have_modifiers.code,g.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module.code,g.An_import_declaration_cannot_have_modifiers.code,g.An_object_member_cannot_be_declared_optional.code,g.Argument_of_dynamic_import_cannot_be_spread_element.code,g.Cannot_assign_to_private_method_0_Private_methods_are_not_writable.code,g.Cannot_redeclare_identifier_0_in_catch_clause.code,g.Catch_clause_variable_cannot_have_an_initializer.code,g.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator.code,g.Classes_can_only_extend_a_single_class.code,g.Classes_may_not_have_a_field_named_constructor.code,g.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code,g.Duplicate_label_0.code,g.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments.code,g.for_await_loops_cannot_be_used_inside_a_class_static_block.code,g.JSX_attributes_must_only_be_assigned_a_non_empty_expression.code,g.JSX_elements_cannot_have_multiple_attributes_with_the_same_name.code,g.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array.code,g.JSX_property_access_expressions_cannot_include_JSX_namespace_names.code,g.Jump_target_cannot_cross_function_boundary.code,g.Line_terminator_not_permitted_before_arrow.code,g.Modifiers_cannot_appear_here.code,g.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement.code,g.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement.code,g.Private_identifiers_are_not_allowed_outside_class_bodies.code,g.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code,g.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier.code,g.Tagged_template_expressions_are_not_permitted_in_an_optional_chain.code,g.The_left_hand_side_of_a_for_of_statement_may_not_be_async.code,g.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer.code,g.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer.code,g.Trailing_comma_not_allowed.code,g.Variable_declaration_list_cannot_be_empty.code,g._0_and_1_operations_cannot_be_mixed_without_parentheses.code,g._0_expected.code,g._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2.code,g._0_list_cannot_be_empty.code,g._0_modifier_already_seen.code,g._0_modifier_cannot_appear_on_a_constructor_declaration.code,g._0_modifier_cannot_appear_on_a_module_or_namespace_element.code,g._0_modifier_cannot_appear_on_a_parameter.code,g._0_modifier_cannot_appear_on_class_elements_of_this_kind.code,g._0_modifier_cannot_be_used_here.code,g._0_modifier_must_precede_1_modifier.code,g._0_declarations_can_only_be_declared_inside_a_block.code,g._0_declarations_must_be_initialized.code,g.extends_clause_already_seen.code,g.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations.code,g.Class_constructor_may_not_be_a_generator.code,g.Class_constructor_may_not_be_an_accessor.code,g.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,g.await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,g.Private_field_0_must_be_declared_in_an_enclosing_class.code,g.This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value.code]),NV={diagnostics:tt,sourceMaps:void 0,emittedFiles:void 0,emitSkipped:!0}}}),zTt=f({"src/compiler/builderStatePublic.ts"(){"use strict"}});function uye(e,t,n,i,s,o){let l=[],{emitSkipped:p,diagnostics:m}=e.emit(t,S,i,n,s,o);return{outputFiles:l,emitSkipped:p,diagnostics:m};function S(h,b,A){l.push({name:h,writeByteOrderMark:A,text:b})}}var zm,$Tt=f({"src/compiler/builderState.ts"(){"use strict";fa(),(e=>{function t(){function Z(Q,ce,ye){let we={getKeys:ve=>ce.get(ve),getValues:ve=>Q.get(ve),keys:()=>Q.keys(),deleteKey:ve=>{(ye||(ye=new Set)).add(ve);let oe=Q.get(ve);return oe?(oe.forEach(Ee=>i(ce,Ee,ve)),Q.delete(ve),!0):!1},set:(ve,oe)=>{ye?.delete(ve);let Ee=Q.get(ve);return Q.set(ve,oe),Ee?.forEach(Me=>{oe.has(Me)||i(ce,Me,ve)}),oe.forEach(Me=>{Ee?.has(Me)||n(ce,Me,ve)}),we}};return we}return Z(new Map,new Map,void 0)}e.createManyToManyPathMap=t;function n(Z,Q,ce){let ye=Z.get(Q);ye||(ye=new Set,Z.set(Q,ye)),ye.add(ce)}function i(Z,Q,ce){let ye=Z.get(Q);return ye?.delete(ce)?(ye.size||Z.delete(Q),!0):!1}function s(Z){return Wi(Z.declarations,Q=>{var ce;return(ce=Xr(Q))==null?void 0:ce.resolvedPath})}function o(Z,Q){let ce=Z.getSymbolAtLocation(Q);return ce&&s(ce)}function l(Z,Q,ce,ye){return gc(Z.getProjectReferenceRedirect(Q)||Q,ce,ye)}function p(Z,Q,ce){let ye;if(Q.imports&&Q.imports.length>0){let Ee=Z.getTypeChecker();for(let Me of Q.imports){let Ge=o(Ee,Me);Ge?.forEach(oe)}}let we=hi(Q.resolvedPath);if(Q.referencedFiles&&Q.referencedFiles.length>0)for(let Ee of Q.referencedFiles){let Me=l(Z,Ee.fileName,we,ce);oe(Me)}if(Z.forEachResolvedTypeReferenceDirective(({resolvedTypeReferenceDirective:Ee})=>{if(!Ee)return;let Me=Ee.resolvedFileName,Ge=l(Z,Me,we,ce);oe(Ge)},Q),Q.moduleAugmentations.length){let Ee=Z.getTypeChecker();for(let Me of Q.moduleAugmentations){if(!za(Me))continue;let Ge=Ee.getSymbolAtLocation(Me);Ge&&ve(Ge)}}for(let Ee of Z.getTypeChecker().getAmbientModules())Ee.declarations&&Ee.declarations.length>1&&ve(Ee);return ye;function ve(Ee){if(Ee.declarations)for(let Me of Ee.declarations){let Ge=Xr(Me);Ge&&Ge!==Q&&oe(Ge.resolvedPath)}}function oe(Ee){(ye||(ye=new Set)).add(Ee)}}function m(Z,Q){return Q&&!Q.referencedMap==!Z}e.canReuseOldState=m;function S(Z,Q,ce){var ye,we,ve;let oe=new Map,Ee=Z.getCompilerOptions(),Me=Wo(Ee),Ge=Ee.module!==0&&!Me?t():void 0,Ae=Ge?t():void 0,Ie=m(Ge,Q);Z.getTypeChecker();for(let Re of Z.getSourceFiles()){let Ue=I.checkDefined(Re.version,"Program intended to be used with Builder should have source files with versions set"),kt=Ie?(ye=Q.oldSignatures)==null?void 0:ye.get(Re.resolvedPath):void 0,ke=kt===void 0?Ie?(we=Q.fileInfos.get(Re.resolvedPath))==null?void 0:we.signature:void 0:kt||void 0;if(Ge){let $e=p(Z,Re,Z.getCanonicalFileName);if($e&&Ge.set(Re.resolvedPath,$e),Ie){let at=(ve=Q.oldExportedModulesMap)==null?void 0:ve.get(Re.resolvedPath),$t=at===void 0?Q.exportedModulesMap.getValues(Re.resolvedPath):at||void 0;$t&&Ae.set(Re.resolvedPath,$t)}}oe.set(Re.resolvedPath,{version:Ue,signature:ke,affectsGlobalScope:Me?void 0:z(Re)||void 0,impliedFormat:Re.impliedNodeFormat})}return{fileInfos:oe,referencedMap:Ge,exportedModulesMap:Ae,useFileVersionAsSignature:!ce&&!Ie}}e.create=S;function h(Z){Z.allFilesExcludingDefaultLibraryFile=void 0,Z.allFileNames=void 0}e.releaseCache=h;function b(Z,Q,ce,ye,we){var ve,oe;let Ee=A(Z,Q,ce,ye,we);return(ve=Z.oldSignatures)==null||ve.clear(),(oe=Z.oldExportedModulesMap)==null||oe.clear(),Ee}e.getFilesAffectedBy=b;function A(Z,Q,ce,ye,we){let ve=Q.getSourceFileByPath(ce);return ve?M(Z,Q,ve,ye,we)?(Z.referencedMap?xe:Se)(Z,Q,ve,ye,we):[ve]:tt}e.getFilesAffectedByWithOldState=A;function k(Z,Q,ce){Z.fileInfos.get(ce).signature=Q,(Z.hasCalledUpdateShapeSignature||(Z.hasCalledUpdateShapeSignature=new Set)).add(ce)}e.updateSignatureOfFile=k;function N(Z,Q,ce,ye,we){Z.emit(Q,(ve,oe,Ee,Me,Ge,Ae)=>{I.assert(i_(ve),`File extension for signature expected to be dts: Got:: ${ve}`),we(nee(Z,Q,oe,ye,Ae),Ge)},ce,!0,void 0,!0)}e.computeDtsSignature=N;function M(Z,Q,ce,ye,we,ve=Z.useFileVersionAsSignature){var oe;if((oe=Z.hasCalledUpdateShapeSignature)!=null&&oe.has(ce.resolvedPath))return!1;let Ee=Z.fileInfos.get(ce.resolvedPath),Me=Ee.signature,Ge;if(!ce.isDeclarationFile&&!ve&&N(Q,ce,ye,we,(Ae,Ie)=>{Ge=Ae,Ge!==Me&&O(Z,ce,Ie[0].exportedModulesFromDeclarationEmit)}),Ge===void 0&&(Ge=ce.version,Z.exportedModulesMap&&Ge!==Me)){(Z.oldExportedModulesMap||(Z.oldExportedModulesMap=new Map)).set(ce.resolvedPath,Z.exportedModulesMap.getValues(ce.resolvedPath)||!1);let Ae=Z.referencedMap?Z.referencedMap.getValues(ce.resolvedPath):void 0;Ae?Z.exportedModulesMap.set(ce.resolvedPath,Ae):Z.exportedModulesMap.deleteKey(ce.resolvedPath)}return(Z.oldSignatures||(Z.oldSignatures=new Map)).set(ce.resolvedPath,Me||!1),(Z.hasCalledUpdateShapeSignature||(Z.hasCalledUpdateShapeSignature=new Set)).add(ce.resolvedPath),Ee.signature=Ge,Ge!==Me}e.updateShapeSignature=M;function O(Z,Q,ce){if(!Z.exportedModulesMap)return;(Z.oldExportedModulesMap||(Z.oldExportedModulesMap=new Map)).set(Q.resolvedPath,Z.exportedModulesMap.getValues(Q.resolvedPath)||!1);let ye=U(ce);ye?Z.exportedModulesMap.set(Q.resolvedPath,ye):Z.exportedModulesMap.deleteKey(Q.resolvedPath)}e.updateExportedModules=O;function U(Z){let Q;return Z?.forEach(ce=>s(ce).forEach(ye=>(Q??(Q=new Set)).add(ye))),Q}e.getExportedModules=U;function H(Z,Q,ce){let ye=Q.getCompilerOptions();if(Wo(ye)||!Z.referencedMap||z(ce))return K(Z,Q);let we=new Set,ve=[ce.resolvedPath];for(;ve.length;){let oe=ve.pop();if(!we.has(oe)){we.add(oe);let Ee=Z.referencedMap.getValues(oe);if(Ee)for(let Me of Ee.keys())ve.push(Me)}}return In(S0(we.keys(),oe=>{var Ee;return((Ee=Q.getSourceFileByPath(oe))==null?void 0:Ee.fileName)??oe}))}e.getAllDependencies=H;function K(Z,Q){if(!Z.allFileNames){let ce=Q.getSourceFiles();Z.allFileNames=ce===tt?tt:ce.map(ye=>ye.fileName)}return Z.allFileNames}function re(Z,Q){let ce=Z.referencedMap.getKeys(Q);return ce?In(ce.keys()):[]}e.getReferencedByPaths=re;function $(Z){for(let Q of Z.statements)if(!W9(Q))return!1;return!0}function pe(Z){return Tt(Z.moduleAugmentations,Q=>zg(Q.parent))}function z(Z){return pe(Z)||!Bp(Z)&&!sm(Z)&&!$(Z)}function se(Z,Q,ce){if(Z.allFilesExcludingDefaultLibraryFile)return Z.allFilesExcludingDefaultLibraryFile;let ye;ce&&we(ce);for(let ve of Q.getSourceFiles())ve!==ce&&we(ve);return Z.allFilesExcludingDefaultLibraryFile=ye||tt,Z.allFilesExcludingDefaultLibraryFile;function we(ve){Q.isSourceFileDefaultLibrary(ve)||(ye||(ye=[])).push(ve)}}e.getAllFilesExcludingDefaultLibraryFile=se;function Se(Z,Q,ce){let ye=Q.getCompilerOptions();return ye&&Wo(ye)?[ce]:se(Z,Q,ce)}function xe(Z,Q,ce,ye,we){if(z(ce))return se(Z,Q,ce);let ve=Q.getCompilerOptions();if(ve&&(fm(ve)||Wo(ve)))return[ce];let oe=new Map;oe.set(ce.resolvedPath,ce);let Ee=re(Z,ce.resolvedPath);for(;Ee.length>0;){let Me=Ee.pop();if(!oe.has(Me)){let Ge=Q.getSourceFileByPath(Me);oe.set(Me,Ge),Ge&&M(Z,Q,Ge,ye,we)&&Ee.push(...re(Z,Ge.resolvedPath))}}return In(S0(oe.values(),Me=>Me))}})(zm||(zm={}))}});function sS(e){let t=1;return e.sourceMap&&(t=t|2),e.inlineSourceMap&&(t=t|4),Dd(e)&&(t=t|8),e.declarationMap&&(t=t|16),e.emitDeclarationOnly&&(t=t&24),t}function gD(e,t){let n=t&&(Mp(t)?t:sS(t)),i=Mp(e)?e:sS(e);if(n===i)return 0;if(!n||!i)return i;let s=n^i,o=0;return s&7&&(o=i&7),s&24&&(o=o|i&24),o}function WTt(e,t){return e===t||e!==void 0&&t!==void 0&&e.size===t.size&&!Mh(e,n=>!t.has(n))}function GTt(e,t){var n,i;let s=zm.create(e,t,!1);s.program=e;let o=e.getCompilerOptions();s.compilerOptions=o;let l=Wo(o);l?o.composite&&t?.outSignature&&l===Wo(t?.compilerOptions)&&(s.outSignature=t.outSignature&&HMe(o,t.compilerOptions,t.outSignature)):s.semanticDiagnosticsPerFile=new Map,s.changedFilesSet=new Set,s.latestChangedDtsFile=o.composite?t?.latestChangedDtsFile:void 0;let p=zm.canReuseOldState(s.referencedMap,t),m=p?t.compilerOptions:void 0,S=p&&t.semanticDiagnosticsPerFile&&!!s.semanticDiagnosticsPerFile&&!Ame(o,m),h=o.composite&&t?.emitSignatures&&!l&&!Pme(o,t.compilerOptions);p?((n=t.changedFilesSet)==null||n.forEach(M=>s.changedFilesSet.add(M)),!l&&((i=t.affectedFilesPendingEmit)!=null&&i.size)&&(s.affectedFilesPendingEmit=new Map(t.affectedFilesPendingEmit),s.seenAffectedFiles=new Set),s.programEmitPending=t.programEmitPending):s.buildInfoEmitPending=!0;let b=s.referencedMap,A=p?t.referencedMap:void 0,k=S&&!o.skipLibCheck==!m.skipLibCheck,N=k&&!o.skipDefaultLibCheck==!m.skipDefaultLibCheck;if(s.fileInfos.forEach((M,O)=>{var U;let H,K;if(!p||!(H=t.fileInfos.get(O))||H.version!==M.version||H.impliedFormat!==M.impliedFormat||!WTt(K=b&&b.getValues(O),A&&A.getValues(O))||K&&Mh(K,re=>!s.fileInfos.has(re)&&t.fileInfos.has(re)))GMe(s,O);else{let re=e.getSourceFileByPath(O),$=(U=t.emitDiagnosticsPerFile)==null?void 0:U.get(O);if($&&(s.emitDiagnosticsPerFile??(s.emitDiagnosticsPerFile=new Map)).set(O,t.hasReusableDiagnostic?KMe($,e):YMe($,e)),S){if(re.isDeclarationFile&&!k||re.hasNoDefaultLib&&!N)return;let pe=t.semanticDiagnosticsPerFile.get(O);pe&&(s.semanticDiagnosticsPerFile.set(O,t.hasReusableDiagnostic?KMe(pe,e):YMe(pe,e)),(s.semanticDiagnosticsFromOldState??(s.semanticDiagnosticsFromOldState=new Set)).add(O))}}if(h){let re=t.emitSignatures.get(O);re&&(s.emitSignatures??(s.emitSignatures=new Map)).set(O,HMe(o,t.compilerOptions,re))}}),p&&yu(t.fileInfos,(M,O)=>s.fileInfos.has(O)?!1:l||M.affectsGlobalScope?!0:(s.buildInfoEmitPending=!0,!1)))zm.getAllFilesExcludingDefaultLibraryFile(s,e,void 0).forEach(M=>GMe(s,M.resolvedPath));else if(m){let M=kme(o,m)?sS(o):gD(o,m);M!==0&&(l?s.programEmitPending=s.programEmitPending?s.programEmitPending|M:M:(e.getSourceFiles().forEach(O=>{s.changedFilesSet.has(O.resolvedPath)||gye(s,O.resolvedPath,M)}),I.assert(!s.seenAffectedFiles||!s.seenAffectedFiles.size),s.seenAffectedFiles=s.seenAffectedFiles||new Set,s.buildInfoEmitPending=!0))}return l&&!s.changedFilesSet.size&&(p&&(s.bundle=t.bundle),Tt(e.getProjectReferences(),M=>!!M.prepend)&&(s.programEmitPending=sS(o))),s}function GMe(e,t){e.changedFilesSet.add(t),e.buildInfoEmitPending=!0,e.programEmitPending=void 0}function HMe(e,t,n){return!!e.declarationMap==!!t.declarationMap?n:vs(n)?[n]:n[0]}function YMe(e,t){return e.length?ul(e,n=>{if(vs(n.messageText))return n;let i=_ye(n.messageText,n.file,t,s=>{var o;return(o=s.repopulateInfo)==null?void 0:o.call(s)});return i===n.messageText?n:{...n,messageText:i}}):e}function _ye(e,t,n,i){let s=i(e);if(s)return{...U9(t,n,s.moduleReference,s.mode,s.packageName||s.moduleReference),next:XMe(e.next,t,n,i)};let o=XMe(e.next,t,n,i);return o===e.next?e:{...e,next:o}}function XMe(e,t,n,i){return ul(e,s=>_ye(s,t,n,i))}function KMe(e,t){if(!e.length)return tt;let n;return e.map(s=>{let o=QMe(s,t,i);o.reportsUnnecessary=s.reportsUnnecessary,o.reportsDeprecated=s.reportDeprecated,o.source=s.source,o.skippedOn=s.skippedOn;let{relatedInformation:l}=s;return o.relatedInformation=l?l.length?l.map(p=>QMe(p,t,i)):[]:void 0,o});function i(s){return n??(n=hi(Ps(B1(t.getCompilerOptions()),t.getCurrentDirectory()))),gc(s,n,t.getCanonicalFileName)}}function QMe(e,t,n){let{file:i}=e,s=i?t.getSourceFileByPath(n(i)):void 0;return{...e,file:s,messageText:vs(e.messageText)?e.messageText:_ye(e.messageText,s,t,o=>o.info)}}function HTt(e){zm.releaseCache(e),e.program=void 0}function YTt(e){let t=Wo(e.compilerOptions);return I.assert(!e.changedFilesSet.size||t),{affectedFilesPendingEmit:e.affectedFilesPendingEmit&&new Map(e.affectedFilesPendingEmit),seenEmittedFiles:e.seenEmittedFiles&&new Map(e.seenEmittedFiles),programEmitPending:e.programEmitPending,emitSignatures:e.emitSignatures&&new Map(e.emitSignatures),outSignature:e.outSignature,latestChangedDtsFile:e.latestChangedDtsFile,hasChangedEmitSignature:e.hasChangedEmitSignature,changedFilesSet:t?new Set(e.changedFilesSet):void 0,buildInfoEmitPending:e.buildInfoEmitPending,emitDiagnosticsPerFile:e.emitDiagnosticsPerFile&&new Map(e.emitDiagnosticsPerFile)}}function XTt(e,t){e.affectedFilesPendingEmit=t.affectedFilesPendingEmit,e.seenEmittedFiles=t.seenEmittedFiles,e.programEmitPending=t.programEmitPending,e.emitSignatures=t.emitSignatures,e.outSignature=t.outSignature,e.latestChangedDtsFile=t.latestChangedDtsFile,e.hasChangedEmitSignature=t.hasChangedEmitSignature,e.buildInfoEmitPending=t.buildInfoEmitPending,e.emitDiagnosticsPerFile=t.emitDiagnosticsPerFile,t.changedFilesSet&&(e.changedFilesSet=t.changedFilesSet)}function ZMe(e,t){I.assert(!t||!e.affectedFiles||e.affectedFiles[e.affectedFilesIndex-1]!==t||!e.semanticDiagnosticsPerFile.has(t.resolvedPath))}function e7e(e,t,n){for(var i,s;;){let{affectedFiles:o}=e;if(o){let S=e.seenAffectedFiles,h=e.affectedFilesIndex;for(;h<o.length;){let b=o[h];if(!S.has(b.resolvedPath))return e.affectedFilesIndex=h,gye(e,b.resolvedPath,sS(e.compilerOptions)),ebt(e,b,t,n),b;h++}e.changedFilesSet.delete(e.currentChangedFilePath),e.currentChangedFilePath=void 0,(i=e.oldSignatures)==null||i.clear(),(s=e.oldExportedModulesMap)==null||s.clear(),e.affectedFiles=void 0}let l=e.changedFilesSet.keys().next();if(l.done)return;let p=I.checkDefined(e.program),m=p.getCompilerOptions();if(Wo(m))return I.assert(!e.semanticDiagnosticsPerFile),p;e.affectedFiles=zm.getFilesAffectedByWithOldState(e,p,l.value,t,n),e.currentChangedFilePath=l.value,e.affectedFilesIndex=0,e.seenAffectedFiles||(e.seenAffectedFiles=new Set)}}function KTt(e,t){var n;if((n=e.affectedFilesPendingEmit)!=null&&n.size){if(!t)return e.affectedFilesPendingEmit=void 0;e.affectedFilesPendingEmit.forEach((i,s)=>{let o=i&7;o?e.affectedFilesPendingEmit.set(s,o):e.affectedFilesPendingEmit.delete(s)})}}function QTt(e,t){var n;if((n=e.affectedFilesPendingEmit)!=null&&n.size)return yu(e.affectedFilesPendingEmit,(i,s)=>{var o;let l=e.program.getSourceFileByPath(s);if(!l||!Q2(l,e.program)){e.affectedFilesPendingEmit.delete(s);return}let p=(o=e.seenEmittedFiles)==null?void 0:o.get(l.resolvedPath),m=gD(i,p);if(t&&(m=m&24),m)return{affectedFile:l,emitKind:m}})}function ZTt(e){var t;if((t=e.emitDiagnosticsPerFile)!=null&&t.size)return yu(e.emitDiagnosticsPerFile,(n,i)=>{var s;let o=e.program.getSourceFileByPath(i);if(!o||!Q2(o,e.program)){e.emitDiagnosticsPerFile.delete(i);return}let l=((s=e.seenEmittedFiles)==null?void 0:s.get(o.resolvedPath))||0;if(!(l&24))return{affectedFile:o,diagnostics:n,seenKind:l}})}function t7e(e){if(!e.cleanedDiagnosticsOfLibFiles){e.cleanedDiagnosticsOfLibFiles=!0;let t=I.checkDefined(e.program),n=t.getCompilerOptions();Te(t.getSourceFiles(),i=>t.isSourceFileDefaultLibrary(i)&&!y6(i,n,t)&&fye(e,i.resolvedPath))}}function ebt(e,t,n,i){if(fye(e,t.resolvedPath),e.allFilesExcludingDefaultLibraryFile===e.affectedFiles){t7e(e),zm.updateShapeSignature(e,I.checkDefined(e.program),t,n,i);return}e.compilerOptions.assumeChangesOnlyAffectDirectDependencies||tbt(e,t,n,i)}function ree(e,t,n,i){if(fye(e,t),!e.changedFilesSet.has(t)){let s=I.checkDefined(e.program),o=s.getSourceFileByPath(t);o&&(zm.updateShapeSignature(e,s,o,n,i,!0),Dd(e.compilerOptions)&&gye(e,t,e.compilerOptions.declarationMap?24:8))}}function fye(e,t){return e.semanticDiagnosticsFromOldState?(e.semanticDiagnosticsFromOldState.delete(t),e.semanticDiagnosticsPerFile.delete(t),!e.semanticDiagnosticsFromOldState.size):!0}function r7e(e,t){let n=I.checkDefined(e.oldSignatures).get(t)||void 0;return I.checkDefined(e.fileInfos.get(t)).signature!==n}function pye(e,t,n,i){var s;return(s=e.fileInfos.get(t))!=null&&s.affectsGlobalScope?(zm.getAllFilesExcludingDefaultLibraryFile(e,e.program,void 0).forEach(o=>ree(e,o.resolvedPath,n,i)),t7e(e),!0):!1}function tbt(e,t,n,i){var s;if(!e.exportedModulesMap||!e.changedFilesSet.has(t.resolvedPath)||!r7e(e,t.resolvedPath))return;if(fm(e.compilerOptions)){let l=new Map;l.set(t.resolvedPath,!0);let p=zm.getReferencedByPaths(e,t.resolvedPath);for(;p.length>0;){let m=p.pop();if(!l.has(m)){if(l.set(m,!0),pye(e,m,n,i))return;if(ree(e,m,n,i),r7e(e,m)){let S=I.checkDefined(e.program).getSourceFileByPath(m);p.push(...zm.getReferencedByPaths(e,S.resolvedPath))}}}}let o=new Set;(s=e.exportedModulesMap.getKeys(t.resolvedPath))==null||s.forEach(l=>{if(pye(e,l,n,i))return!0;let p=e.referencedMap.getKeys(l);return p&&Mh(p,m=>n7e(e,m,o,n,i))})}function n7e(e,t,n,i,s){var o,l;if(Zd(n,t)){if(pye(e,t,i,s))return!0;ree(e,t,i,s),(o=e.exportedModulesMap.getKeys(t))==null||o.forEach(p=>n7e(e,p,n,i,s)),(l=e.referencedMap.getKeys(t))==null||l.forEach(p=>!n.has(p)&&ree(e,p,i,s))}}function dye(e,t,n){return ys(rbt(e,t,n),I.checkDefined(e.program).getProgramDiagnostics(t))}function rbt(e,t,n){let i=t.resolvedPath;if(e.semanticDiagnosticsPerFile){let o=e.semanticDiagnosticsPerFile.get(i);if(o)return CV(o,e.compilerOptions)}let s=I.checkDefined(e.program).getBindAndCheckDiagnostics(t,n);return e.semanticDiagnosticsPerFile&&e.semanticDiagnosticsPerFile.set(i,s),CV(s,e.compilerOptions)}function mye(e){return!!Wo(e.options||{})}function nbt(e,t){var n,i,s;let o=I.checkDefined(e.program).getCurrentDirectory(),l=hi(Ps(B1(e.compilerOptions),o)),p=e.latestChangedDtsFile?pe(e.latestChangedDtsFile):void 0,m=[],S=new Map,h=[];if(Wo(e.compilerOptions)){let Ee=In(e.fileInfos.entries(),([Ue,kt])=>{let ke=se(Ue);return xe(Ue,ke),kt.impliedFormat?{version:kt.version,impliedFormat:kt.impliedFormat,signature:void 0,affectsGlobalScope:void 0}:kt.version}),Me={fileNames:m,fileInfos:Ee,root:h,options:Z(e.compilerOptions),outSignature:e.outSignature,latestChangedDtsFile:p,pendingEmit:e.programEmitPending?e.programEmitPending===sS(e.compilerOptions)?!1:e.programEmitPending:void 0},{js:Ge,dts:Ae,commonSourceDirectory:Ie,sourceFiles:Re}=t;return e.bundle=t={commonSourceDirectory:Ie,sourceFiles:Re,js:Ge||(e.compilerOptions.emitDeclarationOnly||(n=e.bundle)==null?void 0:n.js),dts:Ae||(Dd(e.compilerOptions)?(i=e.bundle)==null?void 0:i.dts:void 0)},AM(Me,t)}let b,A,k,N=In(e.fileInfos.entries(),([Ee,Me])=>{var Ge,Ae;let Ie=se(Ee);xe(Ee,Ie),I.assert(m[Ie-1]===z(Ee));let Re=(Ge=e.oldSignatures)==null?void 0:Ge.get(Ee),Ue=Re!==void 0?Re||void 0:Me.signature;if(e.compilerOptions.composite){let kt=e.program.getSourceFileByPath(Ee);if(!sm(kt)&&Q2(kt,e.program)){let ke=(Ae=e.emitSignatures)==null?void 0:Ae.get(Ee);ke!==Ue&&(k||(k=[])).push(ke===void 0?Ie:[Ie,!vs(ke)&&ke[0]===Ue?tt:ke])}}return Me.version===Ue?Me.affectsGlobalScope||Me.impliedFormat?{version:Me.version,signature:void 0,affectsGlobalScope:Me.affectsGlobalScope,impliedFormat:Me.impliedFormat}:Me.version:Ue!==void 0?Re===void 0?Me:{version:Me.version,signature:Ue,affectsGlobalScope:Me.affectsGlobalScope,impliedFormat:Me.impliedFormat}:{version:Me.version,signature:!1,affectsGlobalScope:Me.affectsGlobalScope,impliedFormat:Me.impliedFormat}}),M;e.referencedMap&&(M=In(e.referencedMap.keys()).sort(h_).map(Ee=>[se(Ee),Se(e.referencedMap.getValues(Ee))]));let O;e.exportedModulesMap&&(O=Wi(In(e.exportedModulesMap.keys()).sort(h_),Ee=>{var Me;let Ge=(Me=e.oldExportedModulesMap)==null?void 0:Me.get(Ee);if(Ge===void 0)return[se(Ee),Se(e.exportedModulesMap.getValues(Ee))];if(Ge)return[se(Ee),Se(Ge)]}));let U=ce(e.semanticDiagnosticsPerFile),H;if((s=e.affectedFilesPendingEmit)!=null&&s.size){let Ee=sS(e.compilerOptions),Me=new Set;for(let Ge of In(e.affectedFilesPendingEmit.keys()).sort(h_))if(Zd(Me,Ge)){let Ae=e.program.getSourceFileByPath(Ge);if(!Ae||!Q2(Ae,e.program))continue;let Ie=se(Ge),Re=e.affectedFilesPendingEmit.get(Ge);(H||(H=[])).push(Re===Ee?Ie:Re===8?[Ie]:[Ie,Re])}}let K;if(e.changedFilesSet.size)for(let Ee of In(e.changedFilesSet.keys()).sort(h_))(K||(K=[])).push(se(Ee));let re=ce(e.emitDiagnosticsPerFile),$={fileNames:m,fileInfos:N,root:h,options:Z(e.compilerOptions),fileIdsList:b,referencedMap:M,exportedModulesMap:O,semanticDiagnosticsPerFile:U,emitDiagnosticsPerFile:re,affectedFilesPendingEmit:H,changeFileSet:K,emitSignatures:k,latestChangedDtsFile:p};return AM($,t);function pe(Ee){return z(Ps(Ee,o))}function z(Ee){return Lb(Om(l,Ee,e.program.getCanonicalFileName))}function se(Ee){let Me=S.get(Ee);return Me===void 0&&(m.push(z(Ee)),S.set(Ee,Me=m.length)),Me}function Se(Ee){let Me=In(Ee.keys(),se).sort(To),Ge=Me.join(),Ae=A?.get(Ge);return Ae===void 0&&((b||(b=[])).push(Me),(A||(A=new Map)).set(Ge,Ae=b.length)),Ae}function xe(Ee,Me){let Ge=e.program.getSourceFile(Ee);if(!e.program.getFileIncludeReasons().get(Ge.path).some(Ue=>Ue.kind===0))return;if(!h.length)return h.push(Me);let Ae=h[h.length-1],Ie=os(Ae);if(Ie&&Ae[1]===Me-1)return Ae[1]=Me;if(Ie||h.length===1||Ae!==Me-1)return h.push(Me);let Re=h[h.length-2];return!Mp(Re)||Re!==Ae-1?h.push(Me):(h[h.length-2]=[Re,Me],h.length=h.length-1)}function Z(Ee){let Me,{optionsNameMap:Ge}=rD();for(let Ae of Vt(Ee).sort(h_)){let Ie=Ge.get(Ae.toLowerCase());Ie?.affectsBuildInfo&&((Me||(Me={}))[Ae]=Q(Ie,Ee[Ae]))}return Me}function Q(Ee,Me){if(Ee){if(I.assert(Ee.type!=="listOrElement"),Ee.type==="list"){let Ge=Me;if(Ee.element.isFilePath&&Ge.length)return Ge.map(pe)}else if(Ee.isFilePath)return pe(Me)}return Me}function ce(Ee){let Me;if(Ee)for(let Ge of In(Ee.keys()).sort(h_)){let Ae=Ee.get(Ge);(Me||(Me=[])).push(Ae.length?[se(Ge),ye(Ae)]:se(Ge))}return Me}function ye(Ee){return I.assert(!!Ee.length),Ee.map(Me=>{let Ge=we(Me);Ge.reportsUnnecessary=Me.reportsUnnecessary,Ge.reportDeprecated=Me.reportsDeprecated,Ge.source=Me.source,Ge.skippedOn=Me.skippedOn;let{relatedInformation:Ae}=Me;return Ge.relatedInformation=Ae?Ae.length?Ae.map(Ie=>we(Ie)):[]:void 0,Ge})}function we(Ee){let{file:Me}=Ee;return{...Ee,file:Me?z(Me.resolvedPath):void 0,messageText:vs(Ee.messageText)?Ee.messageText:ve(Ee.messageText)}}function ve(Ee){if(Ee.repopulateInfo)return{info:Ee.repopulateInfo(),next:oe(Ee.next)};let Me=oe(Ee.next);return Me===Ee.next?Ee:{...Ee,next:Me}}function oe(Ee){return Ee&&(Te(Ee,(Me,Ge)=>{let Ae=ve(Me);if(Me===Ae)return;let Ie=Ge>0?Ee.slice(0,Ge-1):[];Ie.push(Ae);for(let Re=Ge+1;Re<Ee.length;Re++)Ie.push(ve(Ee[Re]));return Ie})||Ee)}}function DV(e,t,n,i,s,o){let l,p,m;return e===void 0?(I.assert(t===void 0),l=n,m=i,I.assert(!!m),p=m.getProgram()):os(e)?(m=i,p=xV({rootNames:e,options:t,host:n,oldProgram:m&&m.getProgramOrUndefined(),configFileParsingDiagnostics:s,projectReferences:o}),l=n):(p=e,l=t,m=n,s=i),{host:l,newProgram:p,oldProgram:m,configFileParsingDiagnostics:s||tt}}function i7e(e,t){return t?.sourceMapUrlPos!==void 0?e.substring(0,t.sourceMapUrlPos):e}function nee(e,t,n,i,s){var o;n=i7e(n,s);let l;return(o=s?.diagnostics)!=null&&o.length&&(n+=s.diagnostics.map(S=>`${m(S)}${I3[S.category]}${S.code}: ${p(S.messageText)}`).join(`
`)),(i.createHash??Sw)(n);function p(S){return vs(S)?S:S===void 0?"":S.next?S.messageText+S.next.map(p).join(`
`):S.messageText}function m(S){return S.file.resolvedPath===t.resolvedPath?`(${S.start},${S.length})`:(l===void 0&&(l=hi(t.resolvedPath)),`${Lb(Om(l,S.file.resolvedPath,e.getCanonicalFileName))}(${S.start},${S.length})`)}}function xx(e,t,n){return(t.createHash??Sw)(i7e(e,n))}function iee(e,{newProgram:t,host:n,oldProgram:i,configFileParsingDiagnostics:s}){let o=i&&i.getState();if(o&&t===o.program&&s===t.getConfigFileParsingDiagnostics())return t=void 0,o=void 0,i;let l=GTt(t,o);t.getBuildInfo=M=>nbt(l,M),t=void 0,i=void 0,o=void 0;let p=()=>l,m=aee(p,s);return m.getState=p,m.saveEmitState=()=>YTt(l),m.restoreEmitState=M=>XTt(l,M),m.hasChangedEmitSignature=()=>!!l.hasChangedEmitSignature,m.getAllDependencies=M=>zm.getAllDependencies(l,I.checkDefined(l.program),M),m.getSemanticDiagnostics=N,m.emit=A,m.releaseProgram=()=>HTt(l),e===0?m.getSemanticDiagnosticsOfNextAffectedFile=k:e===1?(m.getSemanticDiagnosticsOfNextAffectedFile=k,m.emitNextAffectedFile=h,m.emitBuildInfo=S):Ks(),m;function S(M,O){if(l.buildInfoEmitPending){let U=I.checkDefined(l.program).emitBuildInfo(M||rs(n,n.writeFile),O);return l.buildInfoEmitPending=!1,U}return NV}function h(M,O,U,H){var K,re,$;let pe=e7e(l,O,n),z=sS(l.compilerOptions),se=U?z&24:z;if(!pe)if(Wo(l.compilerOptions)){if(!l.programEmitPending||(se=l.programEmitPending,U&&(se=se&24),!se))return;pe=l.program}else{let Z=QTt(l,U);if(!Z){let Q=ZTt(l);if(Q)return(l.seenEmittedFiles??(l.seenEmittedFiles=new Map)).set(Q.affectedFile.resolvedPath,Q.seenKind|24),{result:{emitSkipped:!0,diagnostics:Q.diagnostics},affected:Q.affectedFile};if(!l.buildInfoEmitPending)return;let ce=l.program,ye=ce.emitBuildInfo(M||rs(n,n.writeFile),O);return l.buildInfoEmitPending=!1,{result:ye,affected:ce}}({affectedFile:pe,emitKind:se}=Z)}let Se;se&7&&(Se=0),se&24&&(Se=Se===void 0?1:void 0),pe===l.program&&(l.programEmitPending=l.changedFilesSet.size?gD(z,se):l.programEmitPending?gD(l.programEmitPending,se):void 0);let xe=l.program.emit(pe===l.program?void 0:pe,b(M,H),O,Se,H);if(pe!==l.program){let Z=pe;l.seenAffectedFiles.add(Z.resolvedPath),l.affectedFilesIndex!==void 0&&l.affectedFilesIndex++,l.buildInfoEmitPending=!0;let Q=((K=l.seenEmittedFiles)==null?void 0:K.get(Z.resolvedPath))||0;(l.seenEmittedFiles??(l.seenEmittedFiles=new Map)).set(Z.resolvedPath,se|Q);let ce=((re=l.affectedFilesPendingEmit)==null?void 0:re.get(Z.resolvedPath))||z,ye=gD(ce,se|Q);ye?(l.affectedFilesPendingEmit??(l.affectedFilesPendingEmit=new Map)).set(Z.resolvedPath,ye):($=l.affectedFilesPendingEmit)==null||$.delete(Z.resolvedPath),xe.diagnostics.length&&(l.emitDiagnosticsPerFile??(l.emitDiagnosticsPerFile=new Map)).set(Z.resolvedPath,xe.diagnostics)}else l.changedFilesSet.clear();return{result:xe,affected:pe}}function b(M,O){return Dd(l.compilerOptions)?(U,H,K,re,$,pe)=>{var z,se,Se,xe;if(i_(U))if(Wo(l.compilerOptions)){if(l.compilerOptions.composite){let Q=Z(l.outSignature,void 0);if(!Q)return;l.outSignature=Q}}else{I.assert($?.length===1);let Q;if(!O){let ce=$[0],ye=l.fileInfos.get(ce.resolvedPath);if(ye.signature===ce.version){let we=nee(l.program,ce,H,n,pe);(z=pe?.diagnostics)!=null&&z.length||(Q=we),we!==ce.version&&(n.storeFilesChangingSignatureDuringEmit&&(l.filesChangingSignature??(l.filesChangingSignature=new Set)).add(ce.resolvedPath),l.exportedModulesMap&&zm.updateExportedModules(l,ce,ce.exportedModulesFromDeclarationEmit),l.affectedFiles?(((se=l.oldSignatures)==null?void 0:se.get(ce.resolvedPath))===void 0&&(l.oldSignatures??(l.oldSignatures=new Map)).set(ce.resolvedPath,ye.signature||!1),ye.signature=we):(ye.signature=we,(Se=l.oldExportedModulesMap)==null||Se.clear()))}}if(l.compilerOptions.composite){let ce=$[0].resolvedPath;if(Q=Z((xe=l.emitSignatures)==null?void 0:xe.get(ce),Q),!Q)return;(l.emitSignatures??(l.emitSignatures=new Map)).set(ce,Q)}}M?M(U,H,K,re,$,pe):n.writeFile?n.writeFile(U,H,K,re,$,pe):l.program.writeFile(U,H,K,re,$,pe);function Z(Q,ce){let ye=!Q||vs(Q)?Q:Q[0];if(ce??(ce=xx(H,n,pe)),ce===ye){if(Q===ye)return;pe?pe.differsOnlyInMap=!0:pe={differsOnlyInMap:!0}}else l.hasChangedEmitSignature=!0,l.latestChangedDtsFile=U;return ce}}:M||rs(n,n.writeFile)}function A(M,O,U,H,K){e===1&&ZMe(l,M);let re=XZ(m,M,O,U);if(re)return re;if(!M)if(e===1){let $=[],pe=!1,z,se=[],Se;for(;Se=h(O,U,H,K);)pe=pe||Se.result.emitSkipped,z=jt(z,Se.result.diagnostics),se=jt(se,Se.result.emittedFiles),$=jt($,Se.result.sourceMaps);return{emitSkipped:pe,diagnostics:z||tt,emittedFiles:se,sourceMaps:$}}else KTt(l,H);return I.checkDefined(l.program).emit(M,b(O,K),U,H,K)}function k(M,O){for(;;){let U=e7e(l,M,n),H;if(U)if(U!==l.program){let K=U;if((!O||!O(K))&&(H=dye(l,K,M)),l.seenAffectedFiles.add(K.resolvedPath),l.affectedFilesIndex++,l.buildInfoEmitPending=!0,!H)continue}else H=l.program.getSemanticDiagnostics(void 0,M),l.changedFilesSet.clear(),l.programEmitPending=sS(l.compilerOptions);else return;return{result:H,affected:U}}}function N(M,O){ZMe(l,M);let U=I.checkDefined(l.program).getCompilerOptions();if(Wo(U))return I.assert(!l.semanticDiagnosticsPerFile),I.checkDefined(l.program).getSemanticDiagnostics(M,O);if(M)return dye(l,M,O);for(;k(O););let H;for(let K of I.checkDefined(l.program).getSourceFiles())H=jt(H,dye(l,K,O));return H||tt}}function gye(e,t,n){var i,s;let o=((i=e.affectedFilesPendingEmit)==null?void 0:i.get(t))||0;(e.affectedFilesPendingEmit??(e.affectedFilesPendingEmit=new Map)).set(t,o|n),(s=e.emitDiagnosticsPerFile)==null||s.delete(t)}function hye(e){return vs(e)?{version:e,signature:e,affectsGlobalScope:void 0,impliedFormat:void 0}:vs(e.signature)?e:{version:e.version,signature:e.signature===!1?void 0:e.version,affectsGlobalScope:e.affectsGlobalScope,impliedFormat:e.impliedFormat}}function yye(e,t){return Mp(e)?t:e[1]||8}function vye(e,t){return e||sS(t||{})}function Sye(e,t,n){var i,s,o,l;let p=e.program,m=hi(Ps(t,n.getCurrentDirectory())),S=y_(n.useCaseSensitiveFileNames()),h,b=(i=p.fileNames)==null?void 0:i.map(N),A,k=p.latestChangedDtsFile?M(p.latestChangedDtsFile):void 0;if(mye(p)){let re=new Map;p.fileInfos.forEach(($,pe)=>{let z=O(pe+1);re.set(z,vs($)?{version:$,signature:void 0,affectsGlobalScope:void 0,impliedFormat:void 0}:$)}),h={fileInfos:re,compilerOptions:p.options?TQ(p.options,M):{},latestChangedDtsFile:k,outSignature:p.outSignature,programEmitPending:p.pendingEmit===void 0?void 0:vye(p.pendingEmit,p.options),bundle:e.bundle}}else{A=(s=p.fileIdsList)==null?void 0:s.map(z=>new Set(z.map(O)));let re=new Map,$=(o=p.options)!=null&&o.composite&&!Wo(p.options)?new Map:void 0;p.fileInfos.forEach((z,se)=>{let Se=O(se+1),xe=hye(z);re.set(Se,xe),$&&xe.signature&&$.set(Se,xe.signature)}),(l=p.emitSignatures)==null||l.forEach(z=>{if(Mp(z))$.delete(O(z));else{let se=O(z[0]);$.set(se,!vs(z[1])&&!z[1].length?[$.get(se)]:z[1])}});let pe=p.affectedFilesPendingEmit?sS(p.options||{}):void 0;h={fileInfos:re,compilerOptions:p.options?TQ(p.options,M):{},referencedMap:H(p.referencedMap),exportedModulesMap:H(p.exportedModulesMap),semanticDiagnosticsPerFile:K(p.semanticDiagnosticsPerFile),emitDiagnosticsPerFile:K(p.emitDiagnosticsPerFile),hasReusableDiagnostic:!0,affectedFilesPendingEmit:p.affectedFilesPendingEmit&&il(p.affectedFilesPendingEmit,z=>O(Mp(z)?z:z[0]),z=>yye(z,pe)),changedFilesSet:new Set(vr(p.changeFileSet,O)),latestChangedDtsFile:k,emitSignatures:$?.size?$:void 0}}return{getState:()=>h,saveEmitState:ja,restoreEmitState:ja,getProgram:Ks,getProgramOrUndefined:xd,releaseProgram:ja,getCompilerOptions:()=>h.compilerOptions,getSourceFile:Ks,getSourceFiles:Ks,getOptionsDiagnostics:Ks,getGlobalDiagnostics:Ks,getConfigFileParsingDiagnostics:Ks,getSyntacticDiagnostics:Ks,getDeclarationDiagnostics:Ks,getSemanticDiagnostics:Ks,emit:Ks,getAllDependencies:Ks,getCurrentDirectory:Ks,emitNextAffectedFile:Ks,getSemanticDiagnosticsOfNextAffectedFile:Ks,emitBuildInfo:Ks,close:ja,hasChangedEmitSignature:qf};function N(re){return gc(re,m,S)}function M(re){return Ps(re,m)}function O(re){return b[re-1]}function U(re){return A[re-1]}function H(re){if(!re)return;let $=zm.createManyToManyPathMap();return re.forEach(([pe,z])=>$.set(O(pe),U(z))),$}function K(re){return re&&il(re,$=>O(Mp($)?$:$[0]),$=>Mp($)?tt:$[1])}}function see(e,t,n){let i=hi(Ps(t,n.getCurrentDirectory())),s=y_(n.useCaseSensitiveFileNames()),o=new Map,l=0,p=[];return e.fileInfos.forEach((m,S)=>{let h=gc(e.fileNames[S],i,s),b=vs(m)?m:m.version;if(o.set(h,b),l<e.root.length){let A=e.root[l],k=S+1;os(A)?A[0]<=k&&k<=A[1]&&(p.push(h),A[1]===k&&l++):A===k&&(p.push(h),l++)}}),{fileInfos:o,roots:p}}function aee(e,t){return{getState:Ks,saveEmitState:ja,restoreEmitState:ja,getProgram:n,getProgramOrUndefined:()=>e().program,releaseProgram:()=>e().program=void 0,getCompilerOptions:()=>e().compilerOptions,getSourceFile:i=>n().getSourceFile(i),getSourceFiles:()=>n().getSourceFiles(),getOptionsDiagnostics:i=>n().getOptionsDiagnostics(i),getGlobalDiagnostics:i=>n().getGlobalDiagnostics(i),getConfigFileParsingDiagnostics:()=>t,getSyntacticDiagnostics:(i,s)=>n().getSyntacticDiagnostics(i,s),getDeclarationDiagnostics:(i,s)=>n().getDeclarationDiagnostics(i,s),getSemanticDiagnostics:(i,s)=>n().getSemanticDiagnostics(i,s),emit:(i,s,o,l,p)=>n().emit(i,s,o,l,p),emitBuildInfo:(i,s)=>n().emitBuildInfo(i,s),getAllDependencies:Ks,getCurrentDirectory:()=>n().getCurrentDirectory(),close:ja};function n(){return I.checkDefined(e().program)}}var oee,cee,ibt=f({"src/compiler/builder.ts"(){"use strict";fa(),oee=(e=>(e[e.None=0]="None",e[e.Js=1]="Js",e[e.JsMap=2]="JsMap",e[e.JsInlineMap=4]="JsInlineMap",e[e.Dts=8]="Dts",e[e.DtsMap=16]="DtsMap",e[e.AllJs=7]="AllJs",e[e.AllDts=24]="AllDts",e[e.All=31]="All",e))(oee||{}),cee=(e=>(e[e.SemanticDiagnosticsBuilderProgram=0]="SemanticDiagnosticsBuilderProgram",e[e.EmitAndSemanticDiagnosticsBuilderProgram=1]="EmitAndSemanticDiagnosticsBuilderProgram",e))(cee||{})}});function s7e(e,t,n,i,s,o){return iee(0,DV(e,t,n,i,s,o))}function lee(e,t,n,i,s,o){return iee(1,DV(e,t,n,i,s,o))}function a7e(e,t,n,i,s,o){let{newProgram:l,configFileParsingDiagnostics:p}=DV(e,t,n,i,s,o);return aee(()=>({program:l,compilerOptions:l.getCompilerOptions()}),p)}var sbt=f({"src/compiler/builderPublic.ts"(){"use strict";fa()}});function IV(e){return Mc(e,"/node_modules/.staging")?cA(e,"/.staging"):Tt(M3,t=>e.includes(t))?void 0:e}function Tye(e,t){if(t<=1)return 1;let n=1,i=e[0].search(/[a-zA-Z]:/)===0;if(e[0]!==hc&&!i&&e[1].search(/[a-zA-Z]\$$/)===0){if(t===2)return 2;n=2,i=!0}return i&&!e[n].match(/^users$/i)?n:e[n].match(/^workspaces$/i)?n+1:n+2}function wV(e,t){if(t===void 0&&(t=e.length),t<=2)return!1;let n=Tye(e,t);return t>n+1}function bye(e){return c7e(hi(e))}function o7e(e,t){if(t.length<t.length)return!1;for(let n=0;n<e.length;n++)if(t[n]!==e[n])return!1;return!0}function c7e(e){return wV(gu(e))}function Eye(e){return c7e(e)}function uee(e,t,n,i,s,o){let l=gu(t);e=ap(e)?Ca(e):Ps(e,o());let p=gu(e),m=Tye(l,l.length);if(l.length<=m+1)return;let S=l.indexOf("node_modules");if(!(S!==-1&&S+1<=m+1))return o7e(s,l)?l.length>s.length+1?xye(p,l,Math.max(s.length+1,m+1)):{dir:n,dirPath:i,nonRecursive:!0}:l7e(p,l,l.length-1,m,S,s)}function l7e(e,t,n,i,s,o){if(s!==-1)return xye(e,t,s+1);let l=!0,p=n;for(let m=0;m<n;m++)if(t[m]!==o[m]){l=!1,p=Math.max(m+1,i+1);break}return xye(e,t,p,l)}function xye(e,t,n,i){return{dir:Nv(e,n),dirPath:Nv(t,n),nonRecursive:i}}function Cye(e,t,n,i,s,o){let l=gu(t);if(o7e(i,l))return n;e=ap(e)?Ca(e):Ps(e,s());let p=l7e(gu(e),l,l.length,Tye(l,l.length),l.indexOf("node_modules"),i);return p&&o(p.dirPath)?p.dirPath:void 0}function Aye(e,t){let n=Ps(e,t());return UH(n)?n:sT(n)}function u7e(e){return e.split(hc).length-(b1(e)?1:0)}function OV(e){var t;return((t=e.getCompilerHost)==null?void 0:t.call(e))||e}function kye(e,t,n,i,s){return{nameAndMode:kV,resolve:(o,l)=>abt(i,s,o,e,n,t,l)}}function abt(e,t,n,i,s,o,l){let p=OV(e),m=aD(n,i,s,p,t,o,l);if(!e.getGlobalCache)return m;let S=e.getGlobalCache();if(S!==void 0&&!Nu(n)&&!(m.resolvedModule&&rB(m.resolvedModule.extension))){let{resolvedModule:h,failedLookupLocations:b,affectingLocations:A,resolutionDiagnostics:k}=Jhe(I.checkDefined(e.globalCacheResolutionModuleName)(n),e.projectName,s,p,S,t);if(h)return m.resolvedModule=h,m.failedLookupLocations=iD(m.failedLookupLocations,b),m.affectingLocations=iD(m.affectingLocations,A),m.resolutionDiagnostics=iD(m.resolutionDiagnostics,k),m}return m}function _ee(e,t,n){let i,s,o,l=g_(),p=new Set,m=new Set,S=new Map,h=new Map,b=!1,A,k,N,M,O,U=!1,H=D_(()=>e.getCurrentDirectory()),K=e.getCachedDirectoryStructureHost(),re=new Map,$=sD(H(),e.getCanonicalFileName,e.getCompilationSettings()),pe=new Map,z=UU(H(),e.getCanonicalFileName,e.getCompilationSettings(),$.getPackageJsonInfoCache(),$.optionsToRedirectsKey),se=new Map,Se=sD(H(),e.getCanonicalFileName,FQ(e.getCompilationSettings()),$.getPackageJsonInfoCache()),xe=new Map,Z=new Map,Q=Aye(t,H),ce=e.toPath(Q),ye=gu(ce),we=new Map;return{rootDirForResolution:t,resolvedModuleNames:re,resolvedTypeReferenceDirectives:pe,resolvedLibraries:se,resolvedFileToResolution:S,resolutionsWithFailedLookups:p,resolutionsWithOnlyAffectingLocations:m,directoryWatchesOfFailedLookups:xe,fileWatchesOfAffectingLocations:Z,watchFailedLookupLocationsOfExternalModuleResolutions:Fr,getModuleResolutionCache:()=>$,startRecordingFilesWithChangedResolutions:Ge,finishRecordingFilesWithChangedResolutions:Ae,startCachingPerDirectoryResolution:Ue,finishCachingPerDirectoryResolution:ke,resolveModuleNameLiterals:Ze,resolveTypeReferenceDirectiveReferences:St,resolveLibrary:yt,resolveSingleModuleNameWithoutWatching:ar,removeResolutionsFromProjectReferenceRedirects:rt,removeResolutionsOfFile:zt,hasChangedAutomaticTypeDirectiveNames:()=>b,invalidateResolutionOfFile:vi,invalidateResolutionsOfFailedLookupLocations:Ta,setFilesWithInvalidatedNonRelativeUnresolvedImports:Ni,createHasInvalidatedResolutions:Re,isFileWithInvalidatedNonRelativeUnresolvedImports:Ie,updateTypeRootsWatch:dt,closeTypeRootsWatch:We,clear:Ee,onChangesAffectModuleResolution:Me};function ve(_e){return _e.resolvedModule}function oe(_e){return _e.resolvedTypeReferenceDirective}function Ee(){Wf(xe,Od),Wf(Z,Od),l.clear(),We(),re.clear(),pe.clear(),S.clear(),p.clear(),m.clear(),N=void 0,M=void 0,O=void 0,k=void 0,A=void 0,U=!1,$.clear(),z.clear(),$.update(e.getCompilationSettings()),z.update(e.getCompilationSettings()),Se.clear(),h.clear(),se.clear(),b=!1}function Me(){U=!0,$.clearAllExceptPackageJsonInfoCache(),z.clearAllExceptPackageJsonInfoCache(),$.update(e.getCompilationSettings()),z.update(e.getCompilationSettings())}function Ge(){i=[]}function Ae(){let _e=i;return i=void 0,_e}function Ie(_e){if(!o)return!1;let Ve=o.get(_e);return!!Ve&&!!Ve.length}function Re(_e,Ve){Ta();let pt=s;return s=void 0,{hasInvalidatedResolutions:W=>_e(W)||U||!!pt?.has(W)||Ie(W),hasInvalidatedLibResolutions:W=>{var st;return Ve(W)||!!((st=se?.get(W))!=null&&st.isInvalidated)}}}function Ue(){$.isReadonly=void 0,z.isReadonly=void 0,Se.isReadonly=void 0,$.getPackageJsonInfoCache().isReadonly=void 0,$.clearAllExceptPackageJsonInfoCache(),z.clearAllExceptPackageJsonInfoCache(),Se.clearAllExceptPackageJsonInfoCache(),l.forEach(xs),l.clear()}function kt(_e){se.forEach((Ve,pt)=>{var W;(W=_e?.resolvedLibReferences)!=null&&W.has(pt)||(un(Ve,e.toPath(EV(e.getCompilationSettings(),H(),pt)),ve),se.delete(pt))})}function ke(_e,Ve){o=void 0,U=!1,l.forEach(xs),l.clear(),_e!==Ve&&(kt(_e),_e?.getSourceFiles().forEach(pt=>{var W;let st=Bp(pt)?((W=pt.packageJsonLocations)==null?void 0:W.length)??0:0,Nt=h.get(pt.path)??tt;for(let Ke=Nt.length;Ke<st;Ke++)tr(pt.packageJsonLocations[Ke],!1);if(Nt.length>st)for(let Ke=st;Ke<Nt.length;Ke++)Z.get(Nt[Ke]).files--;st?h.set(pt.path,pt.packageJsonLocations):h.delete(pt.path)}),h.forEach((pt,W)=>{_e?.getSourceFileByPath(W)||(pt.forEach(st=>Z.get(st).files--),h.delete(W))})),xe.forEach($e),Z.forEach(at),b=!1,$.isReadonly=!0,z.isReadonly=!0,Se.isReadonly=!0,$.getPackageJsonInfoCache().isReadonly=!0}function $e(_e,Ve){_e.refCount===0&&(xe.delete(Ve),_e.watcher.close())}function at(_e,Ve){var pt;_e.files===0&&_e.resolutions===0&&!((pt=_e.symlinks)!=null&&pt.size)&&(Z.delete(Ve),_e.watcher.close())}function $t({entries:_e,containingFile:Ve,containingSourceFile:pt,redirectedReference:W,options:st,perFileCache:Nt,reusedNames:Ke,loader:ht,getResolutionWithResolvedFileName:Wt,deferWatchingNonRelativeResolution:Cr,shouldRetryResolution:hr,logChanges:Sr}){let Y=e.toPath(Ve),Be=Nt.get(Y)||Nt.set(Y,uk()).get(Y),Lt=[],B=Sr&&Ie(Y),le=e.getCurrentProgram(),X=le&&le.getResolvedProjectReferenceToRedirect(Ve),he=X?!W||W.sourceFile.path!==X.sourceFile.path:!!W,qe=uk();for(let It of _e){let Rt=ht.nameAndMode.getName(It),Zt=ht.nameAndMode.getMode(It,pt,W?.commandLine.options||st),Ir=Be.get(Rt,Zt);if(!qe.has(Rt,Zt)&&(U||he||!Ir||Ir.isInvalidated||B&&!Nu(Rt)&&hr(Ir))){let zr=Ir;Ir=ht.resolve(Rt,Zt),e.onDiscoveredSymlink&&obt(Ir)&&e.onDiscoveredSymlink(),Be.set(Rt,Zt,Ir),Ir!==zr&&(Fr(Rt,Ir,Y,Wt,Cr),zr&&un(zr,Y,Wt)),Sr&&i&&!Le(zr,Ir)&&(i.push(Y),Sr=!1)}else{let zr=OV(e);if(wy(st,zr)&&!qe.has(Rt,Zt)){let Yr=Wt(Ir);ws(zr,Nt===re?Yr?.resolvedFileName?Yr.packageId?g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2:g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved:Yr?.resolvedFileName?Yr.packageId?g.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:g.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2:g.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved,Rt,Ve,Yr?.resolvedFileName,Yr?.packageId&&Bv(Yr.packageId))}}I.assert(Ir!==void 0&&!Ir.isInvalidated),qe.set(Rt,Zt,!0),Lt.push(Ir)}return Ke?.forEach(It=>qe.set(ht.nameAndMode.getName(It),ht.nameAndMode.getMode(It,pt,W?.commandLine.options||st),!0)),Be.size()!==qe.size()&&Be.forEach((It,Rt,Zt)=>{qe.has(Rt,Zt)||(un(It,Y,Wt),Be.delete(Rt,Zt))}),Lt;function Le(It,Rt){if(It===Rt)return!0;if(!It||!Rt)return!1;let Zt=Wt(It),Ir=Wt(Rt);return Zt===Ir?!0:!Zt||!Ir?!1:Zt.resolvedFileName===Ir.resolvedFileName}}function St(_e,Ve,pt,W,st,Nt){return $t({entries:_e,containingFile:Ve,containingSourceFile:st,redirectedReference:pt,options:W,reusedNames:Nt,perFileCache:pe,loader:TV(Ve,pt,W,OV(e),z),getResolutionWithResolvedFileName:oe,shouldRetryResolution:Ke=>Ke.resolvedTypeReferenceDirective===void 0,deferWatchingNonRelativeResolution:!1})}function Ze(_e,Ve,pt,W,st,Nt){return $t({entries:_e,containingFile:Ve,containingSourceFile:st,redirectedReference:pt,options:W,reusedNames:Nt,perFileCache:re,loader:kye(Ve,pt,W,e,$),getResolutionWithResolvedFileName:ve,shouldRetryResolution:Ke=>!Ke.resolvedModule||!g6(Ke.resolvedModule.extension),logChanges:n,deferWatchingNonRelativeResolution:!0})}function yt(_e,Ve,pt,W){let st=OV(e),Nt=se?.get(W);if(!Nt||Nt.isInvalidated){let Ke=Nt;Nt=VU(_e,Ve,pt,st,Se);let ht=e.toPath(Ve);Fr(_e,Nt,ht,ve,!1),se.set(W,Nt),Ke&&un(Ke,ht,ve)}else if(wy(pt,st)){let Ke=ve(Nt);ws(st,Ke?.resolvedFileName?Ke.packageId?g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3:g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2:g.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved,_e,Ve,Ke?.resolvedFileName,Ke?.packageId&&Bv(Ke.packageId))}return Nt}function ar(_e,Ve){var pt,W;let st=e.toPath(Ve),Nt=re.get(st),Ke=Nt?.get(_e,void 0);if(Ke&&!Ke.isInvalidated)return Ke;let ht=(pt=e.beforeResolveSingleModuleNameWithoutWatching)==null?void 0:pt.call(e,$),Wt=OV(e),Cr=aD(_e,Ve,e.getCompilationSettings(),Wt,$);return(W=e.afterResolveSingleModuleNameWithoutWatching)==null||W.call(e,$,_e,Ve,Cr,ht),Cr}function or(_e){return Mc(_e,"/node_modules/@types")}function Fr(_e,Ve,pt,W,st){var Nt;if(Ve.refCount)Ve.refCount++,I.assertIsDefined(Ve.files);else{Ve.refCount=1,I.assert(!((Nt=Ve.files)!=null&&Nt.size)),!st||Nu(_e)?Tr(Ve):l.add(_e,Ve);let Ke=W(Ve);if(Ke&&Ke.resolvedFileName){let ht=e.toPath(Ke.resolvedFileName),Wt=S.get(ht);Wt||S.set(ht,Wt=new Set),Wt.add(Ve)}}(Ve.files??(Ve.files=new Set)).add(pt)}function rn(_e,Ve){let pt=e.toPath(_e),W=uee(_e,pt,Q,ce,ye,H);if(W){let{dir:st,dirPath:Nt,nonRecursive:Ke}=W;Nt===ce?(I.assert(Ke),Ve=!0):zi(st,Nt,Ke)}return Ve}function Tr(_e){I.assert(!!_e.refCount);let{failedLookupLocations:Ve,affectingLocations:pt,alternateResult:W}=_e;if(!Ve?.length&&!pt?.length&&!W)return;(Ve?.length||W)&&p.add(_e);let st=!1;if(Ve)for(let Nt of Ve)st=rn(Nt,st);W&&(st=rn(W,st)),st&&zi(Q,ce,!0),nr(_e,!Ve?.length&&!W)}function nr(_e,Ve){I.assert(!!_e.refCount);let{affectingLocations:pt}=_e;if(pt?.length){Ve&&m.add(_e);for(let W of pt)tr(W,!0)}}function tr(_e,Ve){let pt=Z.get(_e);if(pt){Ve?pt.resolutions++:pt.files++;return}let W=_e,st=!1,Nt;e.realpath&&(W=e.realpath(_e),_e!==W&&(st=!0,Nt=Z.get(W)));let Ke=Ve?1:0,ht=Ve?0:1;if(!st||!Nt){let Wt={watcher:Eye(e.toPath(W))?e.watchAffectingFileLocation(W,(Cr,hr)=>{K?.addOrDeleteFile(Cr,e.toPath(W),hr),ki(W,$.getPackageJsonInfoCache().getInternalMap()),e.scheduleInvalidateResolutionsOfFailedLookupLocations()}):yD,resolutions:st?0:Ke,files:st?0:ht,symlinks:void 0};Z.set(W,Wt),st&&(Nt=Wt)}if(st){I.assert(!!Nt);let Wt={watcher:{close:()=>{var Cr;let hr=Z.get(W);(Cr=hr?.symlinks)!=null&&Cr.delete(_e)&&!hr.symlinks.size&&!hr.resolutions&&!hr.files&&(Z.delete(W),hr.watcher.close())}},resolutions:Ke,files:ht,symlinks:void 0};Z.set(_e,Wt),(Nt.symlinks??(Nt.symlinks=new Set)).add(_e)}}function ki(_e,Ve){var pt;let W=Z.get(_e);W?.resolutions&&(k??(k=new Set)).add(_e),W?.files&&(A??(A=new Set)).add(_e),(pt=W?.symlinks)==null||pt.forEach(st=>ki(st,Ve)),Ve?.delete(e.toPath(_e))}function xs(_e,Ve){let pt=e.getCurrentProgram();!pt||!pt.getTypeChecker().tryFindAmbientModuleWithoutAugmentations(Ve)?_e.forEach(Tr):_e.forEach(W=>nr(W,!0))}function zi(_e,Ve,pt){let W=xe.get(Ve);W?(I.assert(!!pt==!!W.nonRecursive),W.refCount++):xe.set(Ve,{watcher:On(_e,Ve,pt),refCount:1,nonRecursive:pt})}function Ms(_e,Ve,pt){let W=e.toPath(_e),st=uee(_e,W,Q,ce,ye,H);if(st){let{dirPath:Nt}=st;Nt===ce?Ve=!0:ri(Nt,pt)}return Ve}function un(_e,Ve,pt,W){if(I.checkDefined(_e.files).delete(Ve),_e.refCount--,_e.refCount)return;let st=pt(_e);if(st&&st.resolvedFileName){let Wt=e.toPath(st.resolvedFileName),Cr=S.get(Wt);Cr?.delete(_e)&&!Cr.size&&S.delete(Wt)}let{failedLookupLocations:Nt,affectingLocations:Ke,alternateResult:ht}=_e;if(p.delete(_e)){let Wt=!1;if(Nt)for(let Cr of Nt)Wt=Ms(Cr,Wt,W);ht&&(Wt=Ms(ht,Wt,W)),Wt&&ri(ce,W)}else Ke?.length&&m.delete(_e);if(Ke)for(let Wt of Ke){let Cr=Z.get(Wt);Cr.resolutions--,W&&at(Cr,Wt)}}function ri(_e,Ve){let pt=xe.get(_e);pt.refCount--,Ve&&$e(pt,_e)}function On(_e,Ve,pt){return e.watchDirectoryOfFailedLookupLocation(_e,W=>{let st=e.toPath(W);K&&K.addOrDeleteFileOrDirectory(W,st),us(st,Ve===st)},pt?0:1)}function _r(_e,Ve,pt,W){let st=_e.get(Ve);st&&(st.forEach(Nt=>un(Nt,Ve,pt,W)),_e.delete(Ve))}function rt(_e){if(!Uc(_e,".json"))return;let Ve=e.getCurrentProgram();if(!Ve)return;let pt=Ve.getResolvedProjectReferenceByPath(_e);pt&&pt.commandLine.fileNames.forEach(W=>zt(e.toPath(W)))}function zt(_e,Ve){_r(re,_e,ve,Ve),_r(pe,_e,oe,Ve)}function Rr(_e,Ve){if(!_e)return!1;let pt=!1;return _e.forEach(W=>{if(!(W.isInvalidated||!Ve(W))){W.isInvalidated=pt=!0;for(let st of I.checkDefined(W.files))(s??(s=new Set)).add(st),b=b||Mc(st,mD)}}),pt}function vi(_e){zt(_e);let Ve=b;Rr(S.get(_e),em)&&b&&!Ve&&e.onChangedAutomaticTypeDirectiveNames()}function Ni(_e){I.assert(o===_e||o===void 0),o=_e}function us(_e,Ve){if(Ve)(O||(O=new Set)).add(_e);else{let pt=IV(_e);if(!pt||(_e=pt,e.fileIsOpen(_e)))return!1;let W=hi(_e);if(or(_e)||f9(_e)||or(W)||f9(W))(N||(N=new Set)).add(_e),(M||(M=new Set)).add(_e);else{if(Z0e(e.getCurrentProgram(),_e)||Uc(_e,".map"))return!1;(N||(N=new Set)).add(_e);let st=fM(_e,!0);st&&(M||(M=new Set)).add(st)}}e.scheduleInvalidateResolutionsOfFailedLookupLocations()}function Fs(){let _e=$.getPackageJsonInfoCache().getInternalMap();_e&&(N||M||O)&&_e.forEach((Ve,pt)=>Nr(pt)?_e.delete(pt):void 0)}function Ta(){var _e;if(U)return A=void 0,Fs(),(N||M||O||k)&&Rr(se,to),N=void 0,M=void 0,O=void 0,k=void 0,!0;let Ve=!1;return A&&((_e=e.getCurrentProgram())==null||_e.getSourceFiles().forEach(pt=>{Tt(pt.packageJsonLocations,W=>A.has(W))&&((s??(s=new Set)).add(pt.path),Ve=!0)}),A=void 0),!N&&!M&&!O&&!k||(Ve=Rr(p,to)||Ve,Fs(),N=void 0,M=void 0,O=void 0,Ve=Rr(m,qr)||Ve,k=void 0),Ve}function to(_e){var Ve;return qr(_e)?!0:!N&&!M&&!O?!1:((Ve=_e.failedLookupLocations)==null?void 0:Ve.some(pt=>Nr(e.toPath(pt))))||!!_e.alternateResult&&Nr(e.toPath(_e.alternateResult))}function Nr(_e){return N?.has(_e)||Kt(M?.keys()||[],Ve=>Ss(_e,Ve)?!0:void 0)||Kt(O?.keys()||[],Ve=>_e.length>Ve.length&&Ss(_e,Ve)&&(UH(Ve)||_e[Ve.length]===hc)?!0:void 0)}function qr(_e){var Ve;return!!k&&((Ve=_e.affectingLocations)==null?void 0:Ve.some(pt=>k.has(pt)))}function We(){Wf(we,ug)}function mt(_e){return Ot(_e)?e.watchTypeRootsDirectory(_e,Ve=>{let pt=e.toPath(Ve);K&&K.addOrDeleteFileOrDirectory(Ve,pt),b=!0,e.onChangedAutomaticTypeDirectiveNames();let W=Cye(_e,e.toPath(_e),ce,ye,H,st=>xe.has(st));W&&us(pt,W===pt)},1):yD}function dt(){let _e=e.getCompilationSettings();if(_e.types){We();return}let Ve=tO(_e,{getCurrentDirectory:H});Ve?f6(we,new Set(Ve),{createNewValue:mt,onDeleteValue:ug}):We()}function Ot(_e){return e.getCompilationSettings().typeRoots?!0:bye(e.toPath(_e))}}function obt(e){var t,n;return!!((t=e.resolvedModule)!=null&&t.originalPath||(n=e.resolvedTypeReferenceDirective)!=null&&n.originalPath)}var cbt=f({"src/compiler/resolutionCache.ts"(){"use strict";fa()}});function LM(e,t){let n=e===Zu&&Rye?Rye:{getCurrentDirectory:()=>e.getCurrentDirectory(),getNewLine:()=>e.newLine,getCanonicalFileName:y_(e.useCaseSensitiveFileNames)};if(!t)return s=>e.write(BZ(s,n));let i=new Array(1);return s=>{i[0]=s,e.write(nye(i,n)+n.getNewLine()),i[0]=void 0}}function _7e(e,t,n){return e.clearScreen&&!n.preserveWatchOutput&&!n.extendedDiagnostics&&!n.diagnostics&&hs(BV,t.code)?(e.clearScreen(),!0):!1}function lbt(e,t){return hs(BV,e.code)?t+t:t}function FM(e){return e.now?e.now().toLocaleTimeString("en-US",{timeZone:"UTC"}).replace("\u202F"," "):new Date().toLocaleTimeString()}function Pye(e,t){return t?(n,i,s)=>{_7e(e,n,s);let o=`[${xE(FM(e),"\x1B[90m")}] `;o+=`${nh(n.messageText,e.newLine)}${i+i}`,e.write(o)}:(n,i,s)=>{let o="";_7e(e,n,s)||(o+=i),o+=`${FM(e)} - `,o+=`${nh(n.messageText,e.newLine)}${lbt(n,i)}`,e.write(o)}}function f7e(e,t,n,i,s,o){let l=s;l.onUnRecoverableConfigFileDiagnostic=m=>m7e(s,o,m);let p=ZR(e,t,l,n,i);return l.onUnRecoverableConfigFileDiagnostic=void 0,p}function RV(e){return mu(e,t=>t.category===1)}function MV(e){return Fn(e,n=>n.category===1).map(n=>{if(n.file!==void 0)return`${n.file.fileName}`}).map(n=>{if(n===void 0)return;let i=mr(e,s=>s.file!==void 0&&s.file.fileName===n);if(i!==void 0){let{line:s}=Lo(i.file,i.start);return{fileName:n,line:s+1}}})}function fee(e){return e===1?g.Found_1_error_Watching_for_file_changes:g.Found_0_errors_Watching_for_file_changes}function p7e(e,t){let n=xE(":"+e.line,"\x1B[90m");return Tw(e.fileName)&&Tw(t)?Om(t,e.fileName,!1)+n:e.fileName+n}function Nye(e,t,n,i){if(e===0)return"";let s=t.filter(h=>h!==void 0),o=s.map(h=>`${h.fileName}:${h.line}`).filter((h,b,A)=>A.indexOf(h)===b),l=s[0]&&p7e(s[0],i.getCurrentDirectory()),p;e===1?p=t[0]!==void 0?[g.Found_1_error_in_0,l]:[g.Found_1_error]:p=o.length===0?[g.Found_0_errors,e]:o.length===1?[g.Found_0_errors_in_the_same_file_starting_at_Colon_1,e,l]:[g.Found_0_errors_in_1_files,e,o.length];let m=fl(...p),S=o.length>1?ubt(s,i):"";return`${n}${nh(m.messageText,n)}${n}${n}${S}`}function ubt(e,t){let n=e.filter((b,A,k)=>A===k.findIndex(N=>N?.fileName===b?.fileName));if(n.length===0)return"";let i=b=>Math.log(b)*Math.LOG10E+1,s=n.map(b=>[b,mu(e,A=>A.fileName===b.fileName)]),o=s.reduce((b,A)=>Math.max(b,A[1]||0),0),l=g.Errors_Files.message,p=l.split(" ")[0].length,m=Math.max(p,i(o)),S=Math.max(i(o)-p,0),h="";return h+=" ".repeat(S)+l+`
`,s.forEach(b=>{let[A,k]=b,N=Math.log(k)*Math.LOG10E+1|0,M=N<m?" ".repeat(m-N):"",O=p7e(A,t.getCurrentDirectory());h+=`${M}${k}  ${O}
`}),h}function Dye(e){return!!e.getState}function pee(e,t){let n=e.getCompilerOptions();n.explainFiles?dee(Dye(e)?e.getProgram():e,t):(n.listFiles||n.listFilesOnly)&&Te(e.getSourceFiles(),i=>{t(i.fileName)})}function dee(e,t){var n,i;let s=e.getFileIncludeReasons(),o=l=>bw(l,e.getCurrentDirectory(),e.getCanonicalFileName);for(let l of e.getSourceFiles())t(`${hD(l,o)}`),(n=s.get(l.path))==null||n.forEach(p=>t(`  ${yee(e,p,o).messageText}`)),(i=mee(l,o))==null||i.forEach(p=>t(`  ${p.messageText}`))}function mee(e,t){var n;let i;if(e.path!==e.resolvedPath&&(i??(i=[])).push(Xs(void 0,g.File_is_output_of_project_reference_source_0,hD(e.originalFileName,t))),e.redirectInfo&&(i??(i=[])).push(Xs(void 0,g.File_redirects_to_file_0,hD(e.redirectInfo.redirectTarget,t))),Bp(e))switch(e.impliedNodeFormat){case 99:e.packageJsonScope&&(i??(i=[])).push(Xs(void 0,g.File_is_ECMAScript_module_because_0_has_field_type_with_value_module,hD(Rs(e.packageJsonLocations),t)));break;case 1:e.packageJsonScope?(i??(i=[])).push(Xs(void 0,e.packageJsonScope.contents.packageJsonContent.type?g.File_is_CommonJS_module_because_0_has_field_type_whose_value_is_not_module:g.File_is_CommonJS_module_because_0_does_not_have_field_type,hD(Rs(e.packageJsonLocations),t))):(n=e.packageJsonLocations)!=null&&n.length&&(i??(i=[])).push(Xs(void 0,g.File_is_CommonJS_module_because_package_json_was_not_found));break}return i}function gee(e,t){var n;let i=e.getCompilerOptions().configFile;if(!((n=i?.configFileSpecs)!=null&&n.validatedFilesSpec))return;let s=e.getCanonicalFileName(t),o=hi(Ps(i.fileName,e.getCurrentDirectory()));return mr(i.configFileSpecs.validatedFilesSpec,l=>e.getCanonicalFileName(Ps(l,o))===s)}function hee(e,t){var n,i;let s=e.getCompilerOptions().configFile;if(!((n=s?.configFileSpecs)!=null&&n.validatedIncludeSpecs))return;if(s.configFileSpecs.isDefaultIncludeSpec)return!0;let o=Uc(t,".json"),l=hi(Ps(s.fileName,e.getCurrentDirectory())),p=e.useCaseSensitiveFileNames();return mr((i=s?.configFileSpecs)==null?void 0:i.validatedIncludeSpecs,m=>{if(o&&!Mc(m,".json"))return!1;let S=Nme(m,l,"files");return!!S&&$v(`(${S})$`,p).test(t)})}function yee(e,t,n){var i,s;let o=e.getCompilerOptions();if(MT(t)){let l=hO(e,t),p=pD(l)?l.file.text.substring(l.pos,l.end):`"${l.text}"`,m;switch(I.assert(pD(l)||t.kind===3,"Only synthetic references are imports"),t.kind){case 3:pD(l)?m=l.packageId?g.Imported_via_0_from_file_1_with_packageId_2:g.Imported_via_0_from_file_1:l.text===Gv?m=l.packageId?g.Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions:g.Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions:m=l.packageId?g.Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions:g.Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions;break;case 4:I.assert(!l.packageId),m=g.Referenced_via_0_from_file_1;break;case 5:m=l.packageId?g.Type_library_referenced_via_0_from_file_1_with_packageId_2:g.Type_library_referenced_via_0_from_file_1;break;case 7:I.assert(!l.packageId),m=g.Library_referenced_via_0_from_file_1;break;default:I.assertNever(t)}return Xs(void 0,m,p,hD(l.file,n),l.packageId&&Bv(l.packageId))}switch(t.kind){case 0:if(!((i=o.configFile)!=null&&i.configFileSpecs))return Xs(void 0,g.Root_file_specified_for_compilation);let l=Ps(e.getRootFileNames()[t.index],e.getCurrentDirectory());if(gee(e,l))return Xs(void 0,g.Part_of_files_list_in_tsconfig_json);let m=hee(e,l);return vs(m)?Xs(void 0,g.Matched_by_include_pattern_0_in_1,m,hD(o.configFile,n)):Xs(void 0,m?g.Matched_by_default_include_pattern_Asterisk_Asterisk_Slash_Asterisk:g.Root_file_specified_for_compilation);case 1:case 2:let S=t.kind===2,h=I.checkDefined((s=e.getResolvedProjectReferences())==null?void 0:s[t.index]);return Xs(void 0,Wo(o)?S?g.Output_from_referenced_project_0_included_because_1_specified:g.Source_from_referenced_project_0_included_because_1_specified:S?g.Output_from_referenced_project_0_included_because_module_is_specified_as_none:g.Source_from_referenced_project_0_included_because_module_is_specified_as_none,hD(h.sourceFile.fileName,n),o.outFile?"--outFile":"--out");case 8:{let b=o.types?t.packageId?[g.Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1,t.typeReference,Bv(t.packageId)]:[g.Entry_point_of_type_library_0_specified_in_compilerOptions,t.typeReference]:t.packageId?[g.Entry_point_for_implicit_type_library_0_with_packageId_1,t.typeReference,Bv(t.packageId)]:[g.Entry_point_for_implicit_type_library_0,t.typeReference];return Xs(void 0,...b)}case 6:{if(t.index!==void 0)return Xs(void 0,g.Library_0_specified_in_compilerOptions,o.lib[t.index]);let b=yu(oM.type,(k,N)=>k===ho(o)?N:void 0),A=b?[g.Default_library_for_target_0,b]:[g.Default_library];return Xs(void 0,...A)}default:I.assertNever(t)}}function hD(e,t){let n=vs(e)?e:e.fileName;return t?t(n):n}function LV(e,t,n,i,s,o,l,p){let m=!!e.getCompilerOptions().listFilesOnly,S=e.getConfigFileParsingDiagnostics().slice(),h=S.length;jt(S,e.getSyntacticDiagnostics(void 0,o)),S.length===h&&(jt(S,e.getOptionsDiagnostics(o)),m||(jt(S,e.getGlobalDiagnostics(o)),S.length===h&&jt(S,e.getSemanticDiagnostics(void 0,o))));let b=m?{emitSkipped:!0,diagnostics:tt}:e.emit(void 0,s,o,l,p),{emittedFiles:A,diagnostics:k}=b;jt(S,k);let N=WP(S);if(N.forEach(t),n){let M=e.getCurrentDirectory();Te(A,O=>{let U=Ps(O,M);n(`TSFILE: ${U}`)}),pee(e,n)}return i&&i(RV(N),MV(N)),{emitResult:b,diagnostics:N}}function Iye(e,t,n,i,s,o,l,p){let{emitResult:m,diagnostics:S}=LV(e,t,n,i,s,o,l,p);return m.emitSkipped&&S.length>0?1:S.length>0?2:0}function vee(e=Zu,t){return{onWatchStatusChange:t||Pye(e),watchFile:rs(e,e.watchFile)||vD,watchDirectory:rs(e,e.watchDirectory)||vD,setTimeout:rs(e,e.setTimeout)||ja,clearTimeout:rs(e,e.clearTimeout)||ja}}function See(e,t){let n=e.trace?t.extendedDiagnostics?2:t.diagnostics?1:0:0,i=n!==0?o=>e.trace(o):ja,s=OZ(e,n,i);return s.writeLog=i,s}function Tee(e,t,n=e){let i=e.useCaseSensitiveFileNames(),s={getSourceFile:LZ((o,l)=>l?e.readFile(o,l):s.readFile(o),t,void 0),getDefaultLibLocation:rs(e,e.getDefaultLibLocation),getDefaultLibFileName:o=>e.getDefaultLibFileName(o),writeFile:FZ((o,l,p)=>e.writeFile(o,l,p),o=>e.createDirectory(o),o=>e.directoryExists(o)),getCurrentDirectory:D_(()=>e.getCurrentDirectory()),useCaseSensitiveFileNames:()=>i,getCanonicalFileName:y_(i),getNewLine:()=>w1(t()),fileExists:o=>e.fileExists(o),readFile:o=>e.readFile(o),trace:rs(e,e.trace),directoryExists:rs(n,n.directoryExists),getDirectories:rs(n,n.getDirectories),realpath:rs(e,e.realpath),getEnvironmentVariable:rs(e,e.getEnvironmentVariable)||(()=>""),createHash:rs(e,e.createHash),readDirectory:rs(e,e.readDirectory),storeFilesChangingSignatureDuringEmit:e.storeFilesChangingSignatureDuringEmit,jsDocParsingMode:e.jsDocParsingMode};return s}function FV(e,t){if(t.match(oZ)){let n=t.length,i=n;for(let s=n-1;s>=0;s--){let o=t.charCodeAt(s);switch(o){case 10:s&&t.charCodeAt(s-1)===13&&s--;case 13:break;default:if(o<127||!I_(o)){i=s;continue}break}let l=t.substring(i,n);if(l.match(eV)){t=t.substring(0,i);break}else if(!l.match(tV))break;n=i}}return(e.createHash||Sw)(t)}function jV(e){let t=e.getSourceFile;e.getSourceFile=(...n)=>{let i=t.call(e,...n);return i&&(i.version=FV(e,i.text)),i}}function bee(e,t){let n=D_(()=>hi(Ca(e.getExecutingFilePath())));return{useCaseSensitiveFileNames:()=>e.useCaseSensitiveFileNames,getNewLine:()=>e.newLine,getCurrentDirectory:D_(()=>e.getCurrentDirectory()),getDefaultLibLocation:n,getDefaultLibFileName:i=>li(n(),W3(i)),fileExists:i=>e.fileExists(i),readFile:(i,s)=>e.readFile(i,s),directoryExists:i=>e.directoryExists(i),getDirectories:i=>e.getDirectories(i),readDirectory:(i,s,o,l,p)=>e.readDirectory(i,s,o,l,p),realpath:rs(e,e.realpath),getEnvironmentVariable:rs(e,e.getEnvironmentVariable),trace:i=>e.write(i+e.newLine),createDirectory:i=>e.createDirectory(i),writeFile:(i,s,o)=>e.writeFile(i,s,o),createHash:rs(e,e.createHash),createProgram:t||lee,storeFilesChangingSignatureDuringEmit:e.storeFilesChangingSignatureDuringEmit,now:rs(e,e.now)}}function d7e(e=Zu,t,n,i){let s=l=>e.write(l+e.newLine),o=bee(e,t);return uf(o,vee(e,i)),o.afterProgramCreate=l=>{let p=l.getCompilerOptions(),m=w1(p);LV(l,n,s,S=>o.onWatchStatusChange(fl(fee(S),S),m,p,S))},o}function m7e(e,t,n){t(n),e.exit(1)}function wye({configFileName:e,optionsToExtend:t,watchOptionsToExtend:n,extraFileExtensions:i,system:s,createProgram:o,reportDiagnostic:l,reportWatchStatus:p}){let m=l||LM(s),S=d7e(s,o,m,p);return S.onUnRecoverableConfigFileDiagnostic=h=>m7e(s,m,h),S.configFileName=e,S.optionsToExtend=t,S.watchOptionsToExtend=n,S.extraFileExtensions=i,S}function Oye({rootFiles:e,options:t,watchOptions:n,projectReferences:i,system:s,createProgram:o,reportDiagnostic:l,reportWatchStatus:p}){let m=d7e(s,o,l||LM(s),p);return m.rootFiles=e,m.options=t,m.watchOptions=n,m.projectReferences=i,m}function g7e(e){let t=e.system||Zu,n=e.host||(e.host=Eee(e.options,t)),i=Mye(e),s=Iye(i,e.reportDiagnostic||LM(t),o=>n.trace&&n.trace(o),e.reportErrorSummary||e.options.pretty?(o,l)=>t.write(Nye(o,l,t.newLine,n)):void 0);return e.afterProgramEmitAndDiagnostics&&e.afterProgramEmitAndDiagnostics(i),s}var Rye,BV,yD,vD,_u,_bt=f({"src/compiler/watch.ts"(){"use strict";fa(),Rye=Zu?{getCurrentDirectory:()=>Zu.getCurrentDirectory(),getNewLine:()=>Zu.newLine,getCanonicalFileName:y_(Zu.useCaseSensitiveFileNames)}:void 0,BV=[g.Starting_compilation_in_watch_mode.code,g.File_change_detected_Starting_incremental_compilation.code],yD={close:ja},vD=()=>yD,_u={ConfigFile:"Config file",ExtendedConfigFile:"Extended config file",SourceFile:"Source file",MissingFile:"Missing file",WildcardDirectory:"Wild card directory",FailedLookupLocations:"Failed Lookup Locations",AffectingFileLocation:"File location affecting resolution",TypeRoots:"Type roots",ConfigFileOfReferencedProject:"Config file of referened project",ExtendedConfigOfReferencedProject:"Extended config file of referenced project",WildcardDirectoryOfReferencedProject:"Wild card directory of referenced project",PackageJson:"package.json file",ClosedScriptInfo:"Closed Script info",ConfigFileForInferredRoot:"Config file for the inferred project root",NodeModules:"node_modules for closed script infos and package.jsons affecting module specifier cache",MissingSourceMapFile:"Missing source map file",NoopConfigFileForInferredRoot:"Noop Config file for the inferred project root",MissingGeneratedFile:"Missing generated file",NodeModulesForModuleSpecifierCache:"node_modules for module specifier cache invalidation",TypingInstallerLocationFile:"File location for typing installer",TypingInstallerLocationDirectory:"Directory location for typing installer"}}});function UV(e,t){let n=B1(e);if(!n)return;let i;if(t.getBuildInfo)i=t.getBuildInfo(n,e.configFilePath);else{let s=t.readFile(n);if(!s)return;i=mV(n,s)}if(!(!i||i.version!==F||!i.program))return Sye(i,n,t)}function Eee(e,t=Zu){let n=jZ(e,void 0,t);return n.createHash=rs(t,t.createHash),n.storeFilesChangingSignatureDuringEmit=t.storeFilesChangingSignatureDuringEmit,jV(n),IM(n,i=>gc(i,n.getCurrentDirectory(),n.getCanonicalFileName)),n}function Mye({rootNames:e,options:t,configFileParsingDiagnostics:n,projectReferences:i,host:s,createProgram:o}){s=s||Eee(t),o=o||lee;let l=UV(t,s);return o(e,t,s,l,n,i)}function h7e(e,t,n,i,s,o,l,p){return os(e)?Oye({rootFiles:e,options:t,watchOptions:p,projectReferences:l,system:n,createProgram:i,reportDiagnostic:s,reportWatchStatus:o}):wye({configFileName:e,optionsToExtend:t,watchOptionsToExtend:l,extraFileExtensions:p,system:n,createProgram:i,reportDiagnostic:s,reportWatchStatus:o})}function y7e(e){let t,n,i,s,o,l,p,m,S=e.extendedConfigCache,h=!1,b=new Map,A,k=!1,N=e.useCaseSensitiveFileNames(),M=e.getCurrentDirectory(),{configFileName:O,optionsToExtend:U={},watchOptionsToExtend:H,extraFileExtensions:K,createProgram:re}=e,{rootFiles:$,options:pe,watchOptions:z,projectReferences:se}=e,Se,xe,Z=!1,Q=!1,ce=O===void 0?void 0:hV(e,M,N),ye=ce||e,we=AV(e,ye),ve=Fr();O&&e.configFileParsingResult&&(to(e.configFileParsingResult),ve=Fr()),un(g.Starting_compilation_in_watch_mode),O&&!e.configFileParsingResult&&(ve=w1(U),I.assert(!$),Ta(),ve=Fr()),I.assert(pe),I.assert($);let{watchFile:oe,watchDirectory:Ee,writeLog:Me}=See(e,pe),Ge=y_(N);Me(`Current directory: ${M} CaseSensitiveFileNames: ${N}`);let Ae;O&&(Ae=oe(O,Rr,2e3,z,_u.ConfigFile));let Ie=Tee(e,()=>pe,ye);jV(Ie);let Re=Ie.getSourceFile;Ie.getSourceFile=(Ke,...ht)=>ki(Ke,rn(Ke),...ht),Ie.getSourceFileByPath=ki,Ie.getNewLine=()=>ve,Ie.fileExists=tr,Ie.onReleaseOldSourceFile=Ms,Ie.onReleaseParsedCommandLine=We,Ie.toPath=rn,Ie.getCompilationSettings=()=>pe,Ie.useSourceOfProjectReferenceRedirect=rs(e,e.useSourceOfProjectReferenceRedirect),Ie.watchDirectoryOfFailedLookupLocation=(Ke,ht,Wt)=>Ee(Ke,ht,Wt,z,_u.FailedLookupLocations),Ie.watchAffectingFileLocation=(Ke,ht)=>oe(Ke,ht,2e3,z,_u.AffectingFileLocation),Ie.watchTypeRootsDirectory=(Ke,ht,Wt)=>Ee(Ke,ht,Wt,z,_u.TypeRoots),Ie.getCachedDirectoryStructureHost=()=>ce,Ie.scheduleInvalidateResolutionsOfFailedLookupLocations=_r,Ie.onInvalidatedResolution=zt,Ie.onChangedAutomaticTypeDirectiveNames=zt,Ie.fileIsOpen=qf,Ie.getCurrentProgram=Ze,Ie.writeLog=Me,Ie.getParsedCommandLine=Nr;let Ue=_ee(Ie,O?hi(Ps(O,M)):M,!1);Ie.resolveModuleNameLiterals=rs(e,e.resolveModuleNameLiterals),Ie.resolveModuleNames=rs(e,e.resolveModuleNames),!Ie.resolveModuleNameLiterals&&!Ie.resolveModuleNames&&(Ie.resolveModuleNameLiterals=Ue.resolveModuleNameLiterals.bind(Ue)),Ie.resolveTypeReferenceDirectiveReferences=rs(e,e.resolveTypeReferenceDirectiveReferences),Ie.resolveTypeReferenceDirectives=rs(e,e.resolveTypeReferenceDirectives),!Ie.resolveTypeReferenceDirectiveReferences&&!Ie.resolveTypeReferenceDirectives&&(Ie.resolveTypeReferenceDirectiveReferences=Ue.resolveTypeReferenceDirectiveReferences.bind(Ue)),Ie.resolveLibrary=e.resolveLibrary?e.resolveLibrary.bind(e):Ue.resolveLibrary.bind(Ue),Ie.getModuleResolutionCache=e.resolveModuleNameLiterals||e.resolveModuleNames?rs(e,e.getModuleResolutionCache):()=>Ue.getModuleResolutionCache();let ke=!!e.resolveModuleNameLiterals||!!e.resolveTypeReferenceDirectiveReferences||!!e.resolveModuleNames||!!e.resolveTypeReferenceDirectives?rs(e,e.hasInvalidatedResolutions)||em:qf,$e=e.resolveLibrary?rs(e,e.hasInvalidatedLibResolutions)||em:qf;return t=UV(pe,Ie),yt(),pt(),O&&st(rn(O),pe,z,_u.ExtendedConfigFile),O?{getCurrentProgram:St,getProgram:Ni,close:at,getResolutionCache:$t}:{getCurrentProgram:St,getProgram:Ni,updateRootFileNames:or,close:at,getResolutionCache:$t};function at(){On(),Ue.clear(),Wf(b,Ke=>{Ke&&Ke.fileWatcher&&(Ke.fileWatcher.close(),Ke.fileWatcher=void 0)}),Ae&&(Ae.close(),Ae=void 0),S?.clear(),S=void 0,m&&(Wf(m,Od),m=void 0),s&&(Wf(s,Od),s=void 0),i&&(Wf(i,ug),i=void 0),p&&(Wf(p,Ke=>{var ht;(ht=Ke.watcher)==null||ht.close(),Ke.watcher=void 0,Ke.watchedDirectories&&Wf(Ke.watchedDirectories,Od),Ke.watchedDirectories=void 0}),p=void 0)}function $t(){return Ue}function St(){return t}function Ze(){return t&&t.getProgramOrUndefined()}function yt(){Me("Synchronizing program"),I.assert(pe),I.assert($),On();let Ke=St();k&&(ve=Fr(),Ke&&j9(Ke.getCompilerOptions(),pe)&&Ue.onChangesAffectModuleResolution());let{hasInvalidatedResolutions:ht,hasInvalidatedLibResolutions:Wt}=Ue.createHasInvalidatedResolutions(ke,$e),{originalReadFile:Cr,originalFileExists:hr,originalDirectoryExists:Sr,originalCreateDirectory:Y,originalWriteFile:Be,readFileWithCache:Lt}=IM(Ie,rn);return HZ(Ze(),$,pe,B=>zi(B,Lt),B=>Ie.fileExists(B),ht,Wt,ri,Nr,se)?Q&&(h&&un(g.File_change_detected_Starting_incremental_compilation),t=re(void 0,void 0,Ie,t,xe,se),Q=!1):(h&&un(g.File_change_detected_Starting_incremental_compilation),ar(ht,Wt)),h=!1,e.afterProgramCreate&&Ke!==t&&e.afterProgramCreate(t),Ie.readFile=Cr,Ie.fileExists=hr,Ie.directoryExists=Sr,Ie.createDirectory=Y,Ie.writeFile=Be,t}function ar(Ke,ht){Me("CreatingProgramWith::"),Me(`  roots: ${JSON.stringify($)}`),Me(`  options: ${JSON.stringify(pe)}`),se&&Me(`  projectReferences: ${JSON.stringify(se)}`);let Wt=k||!Ze();k=!1,Q=!1,Ue.startCachingPerDirectoryResolution(),Ie.hasInvalidatedResolutions=Ke,Ie.hasInvalidatedLibResolutions=ht,Ie.hasChangedAutomaticTypeDirectiveNames=ri;let Cr=Ze();if(t=re($,pe,Ie,t,xe,se),Ue.finishCachingPerDirectoryResolution(t.getProgram(),Cr),wZ(t.getProgram(),i||(i=new Map),_e),Wt&&Ue.updateTypeRootsWatch(),A){for(let hr of A)i.has(hr)||b.delete(hr);A=void 0}}function or(Ke){I.assert(!O,"Cannot update root file names with config file watch mode"),$=Ke,zt()}function Fr(){return w1(pe||U)}function rn(Ke){return gc(Ke,M,Ge)}function Tr(Ke){return typeof Ke=="boolean"}function nr(Ke){return typeof Ke.version=="boolean"}function tr(Ke){let ht=rn(Ke);return Tr(b.get(ht))?!1:ye.fileExists(Ke)}function ki(Ke,ht,Wt,Cr,hr){let Sr=b.get(ht);if(Tr(Sr))return;let Y=typeof Wt=="object"?Wt.impliedNodeFormat:void 0;if(Sr===void 0||hr||nr(Sr)||Sr.sourceFile.impliedNodeFormat!==Y){let Be=Re(Ke,Wt,Cr);if(Sr)Be?(Sr.sourceFile=Be,Sr.version=Be.version,Sr.fileWatcher||(Sr.fileWatcher=mt(ht,Ke,dt,250,z,_u.SourceFile))):(Sr.fileWatcher&&Sr.fileWatcher.close(),b.set(ht,!1));else if(Be){let Lt=mt(ht,Ke,dt,250,z,_u.SourceFile);b.set(ht,{sourceFile:Be,version:Be.version,fileWatcher:Lt})}else b.set(ht,!1);return Be}return Sr.sourceFile}function xs(Ke){let ht=b.get(Ke);ht!==void 0&&(Tr(ht)?b.set(Ke,{version:!1}):ht.version=!1)}function zi(Ke,ht){let Wt=b.get(Ke);if(!Wt)return;if(Wt.version)return Wt.version;let Cr=ht(Ke);return Cr!==void 0?FV(Ie,Cr):void 0}function Ms(Ke,ht,Wt){let Cr=b.get(Ke.resolvedPath);Cr!==void 0&&(Tr(Cr)?(A||(A=[])).push(Ke.path):Cr.sourceFile===Ke&&(Cr.fileWatcher&&Cr.fileWatcher.close(),b.delete(Ke.resolvedPath),Wt||Ue.removeResolutionsOfFile(Ke.path)))}function un(Ke){e.onWatchStatusChange&&e.onWatchStatusChange(fl(Ke),ve,pe||U)}function ri(){return Ue.hasChangedAutomaticTypeDirectiveNames()}function On(){return l?(e.clearTimeout(l),l=void 0,!0):!1}function _r(){if(!e.setTimeout||!e.clearTimeout)return Ue.invalidateResolutionsOfFailedLookupLocations();let Ke=On();Me(`Scheduling invalidateFailedLookup${Ke?", Cancelled earlier one":""}`),l=e.setTimeout(rt,250,"timerToInvalidateFailedLookupResolutions")}function rt(){l=void 0,Ue.invalidateResolutionsOfFailedLookupLocations()&&zt()}function zt(){!e.setTimeout||!e.clearTimeout||(o&&e.clearTimeout(o),Me("Scheduling update"),o=e.setTimeout(vi,250,"timerToUpdateProgram"))}function Rr(){I.assert(!!O),n=2,zt()}function vi(){o=void 0,h=!0,Ni()}function Ni(){var Ke,ht,Wt,Cr;switch(n){case 1:(Ke=z_)==null||Ke.logStartUpdateProgram("PartialConfigReload"),us();break;case 2:(ht=z_)==null||ht.logStartUpdateProgram("FullConfigReload"),Fs();break;default:(Wt=z_)==null||Wt.logStartUpdateProgram("SynchronizeProgram"),yt();break}return(Cr=z_)==null||Cr.logStopUpdateProgram("Done"),St()}function us(){Me("Reloading new file names and options"),I.assert(pe),I.assert(O),n=0,$=Q6(pe.configFile.configFileSpecs,Ps(hi(O),M),pe,we,K),kU($,Ps(O,M),pe.configFile.configFileSpecs,xe,Z)&&(Q=!0),yt()}function Fs(){I.assert(O),Me(`Reloading config file: ${O}`),n=0,ce&&ce.clearCache(),Ta(),k=!0,yt(),pt(),st(rn(O),pe,z,_u.ExtendedConfigFile)}function Ta(){I.assert(O),to(ZR(O,U,we,S||(S=new Map),H,K))}function to(Ke){$=Ke.fileNames,pe=Ke.options,z=Ke.watchOptions,se=Ke.projectReferences,Se=Ke.wildcardDirectories,xe=Ex(Ke).slice(),Z=K6(Ke.raw),Q=!0}function Nr(Ke){let ht=rn(Ke),Wt=p?.get(ht);if(Wt){if(!Wt.updateLevel)return Wt.parsedCommandLine;if(Wt.parsedCommandLine&&Wt.updateLevel===1&&!e.getParsedCommandLine){Me("Reloading new file names and options"),I.assert(pe);let hr=Q6(Wt.parsedCommandLine.options.configFile.configFileSpecs,Ps(hi(Ke),M),pe,we);return Wt.parsedCommandLine={...Wt.parsedCommandLine,fileNames:hr},Wt.updateLevel=void 0,Wt.parsedCommandLine}}Me(`Loading config file: ${Ke}`);let Cr=e.getParsedCommandLine?e.getParsedCommandLine(Ke):qr(Ke);return Wt?(Wt.parsedCommandLine=Cr,Wt.updateLevel=void 0):(p||(p=new Map)).set(ht,Wt={parsedCommandLine:Cr}),Nt(Ke,ht,Wt),Cr}function qr(Ke){let ht=we.onUnRecoverableConfigFileDiagnostic;we.onUnRecoverableConfigFileDiagnostic=ja;let Wt=ZR(Ke,void 0,we,S||(S=new Map),H);return we.onUnRecoverableConfigFileDiagnostic=ht,Wt}function We(Ke){var ht;let Wt=rn(Ke),Cr=p?.get(Wt);Cr&&(p.delete(Wt),Cr.watchedDirectories&&Wf(Cr.watchedDirectories,Od),(ht=Cr.watcher)==null||ht.close(),IZ(Wt,m))}function mt(Ke,ht,Wt,Cr,hr,Sr){return oe(ht,(Y,Be)=>Wt(Y,Be,Ke),Cr,hr,Sr)}function dt(Ke,ht,Wt){Ot(Ke,Wt,ht),ht===2&&b.has(Wt)&&Ue.invalidateResolutionOfFile(Wt),xs(Wt),zt()}function Ot(Ke,ht,Wt){ce&&ce.addOrDeleteFile(Ke,ht,Wt)}function _e(Ke,ht){return p?.has(Ke)?yD:mt(Ke,ht,Ve,500,z,_u.MissingFile)}function Ve(Ke,ht,Wt){Ot(Ke,Wt,ht),ht===0&&i.has(Wt)&&(i.get(Wt).close(),i.delete(Wt),xs(Wt),zt())}function pt(){PM(s||(s=new Map),Se,W)}function W(Ke,ht){return Ee(Ke,Wt=>{I.assert(O),I.assert(pe);let Cr=rn(Wt);ce&&ce.addOrDeleteFileOrDirectory(Wt,Cr),xs(Cr),!NM({watchedDirPath:rn(Ke),fileOrDirectory:Wt,fileOrDirectoryPath:Cr,configFileName:O,extraFileExtensions:K,options:pe,program:St()||$,currentDirectory:M,useCaseSensitiveFileNames:N,writeLog:Me,toPath:rn})&&n!==2&&(n=1,zt())},ht,z,_u.WildcardDirectory)}function st(Ke,ht,Wt,Cr){yV(Ke,ht,m||(m=new Map),(hr,Sr)=>oe(hr,(Y,Be)=>{var Lt;Ot(hr,Sr,Be),S&&vV(S,Sr,rn);let B=(Lt=m.get(Sr))==null?void 0:Lt.projects;B?.size&&B.forEach(le=>{if(O&&rn(O)===le)n=2;else{let X=p?.get(le);X&&(X.updateLevel=2),Ue.removeResolutionsFromProjectReferenceRedirects(le)}zt()})},2e3,Wt,Cr),rn)}function Nt(Ke,ht,Wt){var Cr,hr,Sr,Y;Wt.watcher||(Wt.watcher=oe(Ke,(Be,Lt)=>{Ot(Ke,ht,Lt);let B=p?.get(ht);B&&(B.updateLevel=2),Ue.removeResolutionsFromProjectReferenceRedirects(ht),zt()},2e3,((Cr=Wt.parsedCommandLine)==null?void 0:Cr.watchOptions)||z,_u.ConfigFileOfReferencedProject)),PM(Wt.watchedDirectories||(Wt.watchedDirectories=new Map),(hr=Wt.parsedCommandLine)==null?void 0:hr.wildcardDirectories,(Be,Lt)=>{var B;return Ee(Be,le=>{let X=rn(le);ce&&ce.addOrDeleteFileOrDirectory(le,X),xs(X);let he=p?.get(ht);he?.parsedCommandLine&&(NM({watchedDirPath:rn(Be),fileOrDirectory:le,fileOrDirectoryPath:X,configFileName:Ke,options:he.parsedCommandLine.options,program:he.parsedCommandLine.fileNames,currentDirectory:M,useCaseSensitiveFileNames:N,writeLog:Me,toPath:rn})||he.updateLevel!==2&&(he.updateLevel=1,zt()))},Lt,((B=Wt.parsedCommandLine)==null?void 0:B.watchOptions)||z,_u.WildcardDirectoryOfReferencedProject)}),st(ht,(Sr=Wt.parsedCommandLine)==null?void 0:Sr.options,((Y=Wt.parsedCommandLine)==null?void 0:Y.watchOptions)||z,_u.ExtendedConfigOfReferencedProject)}}var fbt=f({"src/compiler/watchPublic.ts"(){"use strict";fa()}});function xee(e){return Uc(e,".json")?e:li(e,"tsconfig.json")}var Cee,pbt=f({"src/compiler/tsbuild.ts"(){"use strict";fa(),Cee=(e=>(e[e.Unbuildable=0]="Unbuildable",e[e.UpToDate=1]="UpToDate",e[e.UpToDateWithUpstreamTypes=2]="UpToDateWithUpstreamTypes",e[e.OutOfDateWithPrepend=3]="OutOfDateWithPrepend",e[e.OutputMissing=4]="OutputMissing",e[e.ErrorReadingFile=5]="ErrorReadingFile",e[e.OutOfDateWithSelf=6]="OutOfDateWithSelf",e[e.OutOfDateWithUpstream=7]="OutOfDateWithUpstream",e[e.OutOfDateBuildInfo=8]="OutOfDateBuildInfo",e[e.OutOfDateOptions=9]="OutOfDateOptions",e[e.OutOfDateRoots=10]="OutOfDateRoots",e[e.UpstreamOutOfDate=11]="UpstreamOutOfDate",e[e.UpstreamBlocked=12]="UpstreamBlocked",e[e.ComputingUpstream=13]="ComputingUpstream",e[e.TsVersionOutputOfDate=14]="TsVersionOutputOfDate",e[e.UpToDateWithInputFileText=15]="UpToDateWithInputFileText",e[e.ContainerOnly=16]="ContainerOnly",e[e.ForceBuild=17]="ForceBuild",e))(Cee||{})}});function dbt(e,t,n){let i=e.get(t),s;return i||(s=n(),e.set(t,s)),i||s}function Lye(e,t){return dbt(e,t,()=>new Map)}function jM(e){return e.now?e.now():new Date}function mk(e){return!!e&&!!e.buildOrder}function VV(e){return mk(e)?e.buildOrder:e}function Fye(e,t){return n=>{let i=t?`[${xE(FM(e),"\x1B[90m")}] `:`${FM(e)} - `;i+=`${nh(n.messageText,e.newLine)}${e.newLine+e.newLine}`,e.write(i)}}function v7e(e,t,n,i){let s=bee(e,t);return s.getModifiedTime=e.getModifiedTime?o=>e.getModifiedTime(o):xd,s.setModifiedTime=e.setModifiedTime?(o,l)=>e.setModifiedTime(o,l):ja,s.deleteFile=e.deleteFile?o=>e.deleteFile(o):ja,s.reportDiagnostic=n||LM(e),s.reportSolutionBuilderStatus=i||Fye(e),s.now=rs(e,e.now),s}function S7e(e=Zu,t,n,i,s){let o=v7e(e,t,n,i);return o.reportErrorSummary=s,o}function T7e(e=Zu,t,n,i,s){let o=v7e(e,t,n,i),l=vee(e,s);return uf(o,l),o}function mbt(e){let t={};return aM.forEach(n=>{wo(e,n.name)&&(t[n.name]=e[n.name])}),t}function b7e(e,t,n){return W7e(!1,e,t,n)}function E7e(e,t,n,i){return W7e(!0,e,t,n,i)}function gbt(e,t,n,i,s){let o=t,l=t,p=mbt(i),m=Tee(o,()=>M.projectCompilerOptions);jV(m),m.getParsedCommandLine=O=>gk(M,O,ih(M,O)),m.resolveModuleNameLiterals=rs(o,o.resolveModuleNameLiterals),m.resolveTypeReferenceDirectiveReferences=rs(o,o.resolveTypeReferenceDirectiveReferences),m.resolveLibrary=rs(o,o.resolveLibrary),m.resolveModuleNames=rs(o,o.resolveModuleNames),m.resolveTypeReferenceDirectives=rs(o,o.resolveTypeReferenceDirectives),m.getModuleResolutionCache=rs(o,o.getModuleResolutionCache);let S,h;!m.resolveModuleNameLiterals&&!m.resolveModuleNames&&(S=sD(m.getCurrentDirectory(),m.getCanonicalFileName),m.resolveModuleNameLiterals=(O,U,H,K,re)=>OM(O,U,H,K,re,o,S,zZ),m.getModuleResolutionCache=()=>S),!m.resolveTypeReferenceDirectiveReferences&&!m.resolveTypeReferenceDirectives&&(h=UU(m.getCurrentDirectory(),m.getCanonicalFileName,void 0,S?.getPackageJsonInfoCache(),S?.optionsToRedirectsKey),m.resolveTypeReferenceDirectiveReferences=(O,U,H,K,re)=>OM(O,U,H,K,re,o,h,TV));let b;m.resolveLibrary||(b=sD(m.getCurrentDirectory(),m.getCanonicalFileName,void 0,S?.getPackageJsonInfoCache()),m.resolveLibrary=(O,U,H)=>VU(O,U,H,o,b)),m.getBuildInfo=(O,U)=>F7e(M,O,ih(M,U),void 0);let{watchFile:A,watchDirectory:k,writeLog:N}=See(l,i),M={host:o,hostWithWatch:l,parseConfigFileHost:AV(o),write:rs(o,o.trace),options:i,baseCompilerOptions:p,rootNames:n,baseWatchOptions:s,resolvedConfigFilePaths:new Map,configFileCache:new Map,projectStatus:new Map,extendedConfigCache:new Map,buildInfoCache:new Map,outputTimeStamps:new Map,builderPrograms:new Map,diagnostics:new Map,projectPendingBuild:new Map,projectErrorsReported:new Map,compilerHost:m,moduleResolutionCache:S,typeReferenceDirectiveResolutionCache:h,libraryResolutionCache:b,buildOrder:void 0,readFileWithCache:O=>o.readFile(O),projectCompilerOptions:p,cache:void 0,allProjectBuildPending:!0,needsSummary:!0,watchAllProjectsPending:e,watch:e,allWatchedWildcardDirectories:new Map,allWatchedInputFiles:new Map,allWatchedConfigFiles:new Map,allWatchedExtendedConfigFiles:new Map,allWatchedPackageJsonFiles:new Map,filesWatched:new Map,lastCachedPackageJsonLookups:new Map,timerToBuildInvalidatedProject:void 0,reportFileChangeDetected:!1,watchFile:A,watchDirectory:k,writeLog:N};return M}function Rd(e,t){return gc(t,e.compilerHost.getCurrentDirectory(),e.compilerHost.getCanonicalFileName)}function ih(e,t){let{resolvedConfigFilePaths:n}=e,i=n.get(t);if(i!==void 0)return i;let s=Rd(e,t);return n.set(t,s),s}function x7e(e){return!!e.options}function hbt(e,t){let n=e.configFileCache.get(t);return n&&x7e(n)?n:void 0}function gk(e,t,n){let{configFileCache:i}=e,s=i.get(n);if(s)return x7e(s)?s:void 0;mc("SolutionBuilder::beforeConfigFileParsing");let o,{parseConfigFileHost:l,baseCompilerOptions:p,baseWatchOptions:m,extendedConfigCache:S,host:h}=e,b;return h.getParsedCommandLine?(b=h.getParsedCommandLine(t),b||(o=fl(g.File_0_not_found,t))):(l.onUnRecoverableConfigFileDiagnostic=A=>o=A,b=ZR(t,p,l,S,m),l.onUnRecoverableConfigFileDiagnostic=ja),i.set(n,b||o),mc("SolutionBuilder::afterConfigFileParsing"),rd("SolutionBuilder::Config file parsing","SolutionBuilder::beforeConfigFileParsing","SolutionBuilder::afterConfigFileParsing"),b}function yO(e,t){return xee(Dv(e.compilerHost.getCurrentDirectory(),t))}function C7e(e,t){let n=new Map,i=new Map,s=[],o,l;for(let m of t)p(m);return l?{buildOrder:o||tt,circularDiagnostics:l}:o||tt;function p(m,S){let h=ih(e,m);if(i.has(h))return;if(n.has(h)){S||(l||(l=[])).push(fl(g.Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0,s.join(`\r
`)));return}n.set(h,!0),s.push(m);let b=gk(e,m,h);if(b&&b.projectReferences)for(let A of b.projectReferences){let k=yO(e,A.path);p(k,S||A.circular)}s.pop(),i.set(h,!0),(o||(o=[])).push(m)}}function JV(e){return e.buildOrder||ybt(e)}function ybt(e){let t=C7e(e,e.rootNames.map(s=>yO(e,s)));e.resolvedConfigFilePaths.clear();let n=new Set(VV(t).map(s=>ih(e,s))),i={onDeleteValue:ja};return w0(e.configFileCache,n,i),w0(e.projectStatus,n,i),w0(e.builderPrograms,n,i),w0(e.diagnostics,n,i),w0(e.projectPendingBuild,n,i),w0(e.projectErrorsReported,n,i),w0(e.buildInfoCache,n,i),w0(e.outputTimeStamps,n,i),w0(e.lastCachedPackageJsonLookups,n,i),e.watch&&(w0(e.allWatchedConfigFiles,n,{onDeleteValue:ug}),e.allWatchedExtendedConfigFiles.forEach(s=>{s.projects.forEach(o=>{n.has(o)||s.projects.delete(o)}),s.close()}),w0(e.allWatchedWildcardDirectories,n,{onDeleteValue:s=>s.forEach(Od)}),w0(e.allWatchedInputFiles,n,{onDeleteValue:s=>s.forEach(ug)}),w0(e.allWatchedPackageJsonFiles,n,{onDeleteValue:s=>s.forEach(ug)})),e.buildOrder=t}function A7e(e,t,n){let i=t&&yO(e,t),s=JV(e);if(mk(s))return s;if(i){let l=ih(e,i);if(oa(s,m=>ih(e,m)===l)===-1)return}let o=i?C7e(e,[i]):s;return I.assert(!mk(o)),I.assert(!n||i!==void 0),I.assert(!n||o[o.length-1]===i),n?o.slice(0,o.length-1):o}function k7e(e){e.cache&&jye(e);let{compilerHost:t,host:n}=e,i=e.readFileWithCache,s=t.getSourceFile,{originalReadFile:o,originalFileExists:l,originalDirectoryExists:p,originalCreateDirectory:m,originalWriteFile:S,getSourceFileWithCache:h,readFileWithCache:b}=IM(n,A=>Rd(e,A),(...A)=>s.call(t,...A));e.readFileWithCache=b,t.getSourceFile=h,e.cache={originalReadFile:o,originalFileExists:l,originalDirectoryExists:p,originalCreateDirectory:m,originalWriteFile:S,originalReadFileWithCache:i,originalGetSourceFile:s}}function jye(e){if(!e.cache)return;let{cache:t,host:n,compilerHost:i,extendedConfigCache:s,moduleResolutionCache:o,typeReferenceDirectiveResolutionCache:l,libraryResolutionCache:p}=e;n.readFile=t.originalReadFile,n.fileExists=t.originalFileExists,n.directoryExists=t.originalDirectoryExists,n.createDirectory=t.originalCreateDirectory,n.writeFile=t.originalWriteFile,i.getSourceFile=t.originalGetSourceFile,e.readFileWithCache=t.originalReadFileWithCache,s.clear(),o?.clear(),l?.clear(),p?.clear(),e.cache=void 0}function P7e(e,t){e.projectStatus.delete(t),e.diagnostics.delete(t)}function N7e({projectPendingBuild:e},t,n){let i=e.get(t);(i===void 0||i<n)&&e.set(t,n)}function D7e(e,t){if(!e.allProjectBuildPending)return;e.allProjectBuildPending=!1,e.options.watch&&Xye(e,g.Starting_compilation_in_watch_mode),k7e(e),VV(JV(e)).forEach(i=>e.projectPendingBuild.set(ih(e,i),0)),t&&t.throwIfCancellationRequested()}function I7e(e,t){return e.projectPendingBuild.delete(t),e.diagnostics.has(t)?1:0}function vbt(e,t,n,i,s){let o=!0;return{kind:2,project:t,projectPath:n,buildOrder:s,getCompilerOptions:()=>i.options,getCurrentDirectory:()=>e.compilerHost.getCurrentDirectory(),updateOutputFileStatmps:()=>{B7e(e,i,n),o=!1},done:()=>(o&&B7e(e,i,n),mc("SolutionBuilder::Timestamps only updates"),I7e(e,n))}}function w7e(e,t,n,i,s,o,l){let p=e===0?0:4,m,S,h;return e===0?{kind:e,project:n,projectPath:i,buildOrder:l,getCompilerOptions:()=>o.options,getCurrentDirectory:()=>t.compilerHost.getCurrentDirectory(),getBuilderProgram:()=>A(Mo),getProgram:()=>A(z=>z.getProgramOrUndefined()),getSourceFile:z=>A(se=>se.getSourceFile(z)),getSourceFiles:()=>k(z=>z.getSourceFiles()),getOptionsDiagnostics:z=>k(se=>se.getOptionsDiagnostics(z)),getGlobalDiagnostics:z=>k(se=>se.getGlobalDiagnostics(z)),getConfigFileParsingDiagnostics:()=>k(z=>z.getConfigFileParsingDiagnostics()),getSyntacticDiagnostics:(z,se)=>k(Se=>Se.getSyntacticDiagnostics(z,se)),getAllDependencies:z=>k(se=>se.getAllDependencies(z)),getSemanticDiagnostics:(z,se)=>k(Se=>Se.getSemanticDiagnostics(z,se)),getSemanticDiagnosticsOfNextAffectedFile:(z,se)=>A(Se=>Se.getSemanticDiagnosticsOfNextAffectedFile&&Se.getSemanticDiagnosticsOfNextAffectedFile(z,se)),emit:(z,se,Se,xe,Z)=>{if(z||xe)return A(Q=>{var ce,ye;return Q.emit(z,se,Se,xe,Z||((ye=(ce=t.host).getCustomTransformers)==null?void 0:ye.call(ce,n)))});if(pe(2,Se),p===5)return K(se,Se);if(p===3)return H(se,Se,Z)},done:b}:{kind:e,project:n,projectPath:i,buildOrder:l,getCompilerOptions:()=>o.options,getCurrentDirectory:()=>t.compilerHost.getCurrentDirectory(),emit:(z,se)=>p!==4?h:$(z,se),done:b};function b(z,se,Se){return pe(8,z,se,Se),mc(e===0?"SolutionBuilder::Projects built":"SolutionBuilder::Bundles updated"),I7e(t,i)}function A(z){return pe(0),m&&z(m)}function k(z){return A(z)||tt}function N(){var z,se,Se;if(I.assert(m===void 0),t.options.dry){mf(t,g.A_non_dry_build_would_build_project_0,n),S=1,p=7;return}if(t.options.verbose&&mf(t,g.Building_project_0,n),o.fileNames.length===0){vO(t,i,Ex(o)),S=0,p=7;return}let{host:xe,compilerHost:Z}=t;if(t.projectCompilerOptions=o.options,(z=t.moduleResolutionCache)==null||z.update(o.options),(se=t.typeReferenceDirectiveResolutionCache)==null||se.update(o.options),m=xe.createProgram(o.fileNames,o.options,Z,Tbt(t,i,o),Ex(o),o.projectReferences),t.watch){let Q=(Se=t.moduleResolutionCache)==null?void 0:Se.getPackageJsonInfoCache().getInternalMap();t.lastCachedPackageJsonLookups.set(i,Q&&new Set(In(Q.values(),ce=>t.host.realpath&&(BU(ce)||ce.directoryExists)?t.host.realpath(li(ce.packageDirectory,"package.json")):li(ce.packageDirectory,"package.json")))),t.builderPrograms.set(i,m)}p++}function M(z,se,Se){z.length?{buildResult:S,step:p}=Vye(t,i,m,o,z,se,Se):p++}function O(z){I.assertIsDefined(m),M([...m.getConfigFileParsingDiagnostics(),...m.getOptionsDiagnostics(z),...m.getGlobalDiagnostics(z),...m.getSyntacticDiagnostics(void 0,z)],8,"Syntactic")}function U(z){M(I.checkDefined(m).getSemanticDiagnostics(void 0,z),16,"Semantic")}function H(z,se,Se){var xe,Z,Q;I.assertIsDefined(m),I.assert(p===3);let ce=m.saveEmitState(),ye,we=$e=>(ye||(ye=[])).push($e),ve=[],{emitResult:oe}=LV(m,we,void 0,void 0,($e,at,$t,St,Ze,yt)=>ve.push({name:$e,text:at,writeByteOrderMark:$t,data:yt}),se,!1,Se||((Z=(xe=t.host).getCustomTransformers)==null?void 0:Z.call(xe,n)));if(ye)return m.restoreEmitState(ce),{buildResult:S,step:p}=Vye(t,i,m,o,ye,32,"Declaration file"),{emitSkipped:!0,diagnostics:oe.diagnostics};let{host:Ee,compilerHost:Me}=t,Ge=(Q=m.hasChangedEmitSignature)!=null&&Q.call(m)?0:2,Ae=EN(),Ie=new Map,Re=m.getCompilerOptions(),Ue=N6(Re),kt,ke;return ve.forEach(({name:$e,text:at,writeByteOrderMark:$t,data:St})=>{let Ze=Rd(t,$e);Ie.set(Rd(t,$e),$e),St?.buildInfo&&qye(t,St.buildInfo,i,Re,Ge);let yt=St?.differsOnlyInMap?fA(t.host,$e):void 0;t6(z?{writeFile:z}:Me,Ae,$e,at,$t),St?.differsOnlyInMap?t.host.setModifiedTime($e,yt):!Ue&&t.watch&&(kt||(kt=Jye(t,i))).set(Ze,ke||(ke=jM(t.host)))}),re(Ae,Ie,ve.length?ve[0].name:PZ(o,!Ee.useCaseSensitiveFileNames()),Ge),oe}function K(z,se){I.assertIsDefined(m),I.assert(p===5);let Se=m.emitBuildInfo((xe,Z,Q,ce,ye,we)=>{we?.buildInfo&&qye(t,we.buildInfo,i,m.getCompilerOptions(),2),z?z(xe,Z,Q,ce,ye,we):t.compilerHost.writeFile(xe,Z,Q,ce,ye,we)},se);return Se.diagnostics.length&&(zV(t,Se.diagnostics),t.diagnostics.set(i,[...t.diagnostics.get(i),...Se.diagnostics]),S=64&S),Se.emittedFiles&&t.write&&Se.emittedFiles.forEach(xe=>M7e(t,o,xe)),Uye(t,m,o),p=7,Se}function re(z,se,Se,xe){let Z=z.getDiagnostics();return Z.length?({buildResult:S,step:p}=Vye(t,i,m,o,Z,64,"Emit"),Z):(t.write&&se.forEach(Q=>M7e(t,o,Q)),j7e(t,o,i,g.Updating_unchanged_output_timestamps_of_project_0,se),t.diagnostics.delete(i),t.projectStatus.set(i,{type:1,oldestOutputFileName:Se}),Uye(t,m,o),p=7,S=xe,Z)}function $(z,se){var Se,xe,Z,Q;if(I.assert(e===1),t.options.dry){mf(t,g.A_non_dry_build_would_update_output_of_project_0,n),S=1,p=7;return}t.options.verbose&&mf(t,g.Updating_output_of_project_0,n);let{compilerHost:ce}=t;t.projectCompilerOptions=o.options,(xe=(Se=t.host).beforeEmitBundle)==null||xe.call(Se,o);let ye=K0e(o,ce,Ge=>{let Ae=yO(t,Ge.path);return gk(t,Ae,ih(t,Ae))},se||((Q=(Z=t.host).getCustomTransformers)==null?void 0:Q.call(Z,n)));if(vs(ye))return mf(t,g.Cannot_update_output_of_project_0_because_there_was_error_reading_file_1,n,qu(t,ye)),p=6,h=w7e(0,t,n,i,s,o,l);I.assert(!!ye.length);let we=EN(),ve=new Map,oe=2,Ee=t.buildInfoCache.get(i).buildInfo||void 0;return ye.forEach(({name:Ge,text:Ae,writeByteOrderMark:Ie,data:Re})=>{var Ue,kt;ve.set(Rd(t,Ge),Ge),Re?.buildInfo&&(((Ue=Re.buildInfo.program)==null?void 0:Ue.outSignature)!==((kt=Ee?.program)==null?void 0:kt.outSignature)&&(oe&=-3),qye(t,Re.buildInfo,i,o.options,oe)),t6(z?{writeFile:z}:ce,we,Ge,Ae,Ie)}),{emitSkipped:!1,diagnostics:re(we,ve,ye[0].name,oe)}}function pe(z,se,Se,xe){for(;p<=z&&p<8;){let Z=p;switch(p){case 0:N();break;case 1:O(se);break;case 2:U(se);break;case 3:H(Se,se,xe);break;case 5:K(Se,se);break;case 4:$(Se,xe);break;case 6:I.checkDefined(h).done(se,Se,xe),p=8;break;case 7:Cbt(t,n,i,s,o,l,I.checkDefined(S)),p++;break;case 8:default:}I.assert(p>Z)}}}function Sbt({options:e},t,n){return t.type!==3||e.force?!0:n.fileNames.length===0||!!Ex(n).length||!N6(n.options)}function O7e(e,t,n){if(!e.projectPendingBuild.size||mk(t))return;let{options:i,projectPendingBuild:s}=e;for(let o=0;o<t.length;o++){let l=t[o],p=ih(e,l),m=e.projectPendingBuild.get(p);if(m===void 0)continue;n&&(n=!1,Y7e(e,t));let S=gk(e,l,p);if(!S){G7e(e,p),s.delete(p);continue}m===2?(q7e(e,l,p,S),z7e(e,p,S),$7e(e,l,p,S),Hye(e,l,p,S),Yye(e,l,p,S)):m===1&&(S.fileNames=Q6(S.options.configFile.configFileSpecs,hi(l),S.options,e.parseConfigFileHost),kU(S.fileNames,l,S.options.configFile.configFileSpecs,S.errors,K6(S.raw)),Hye(e,l,p,S),Yye(e,l,p,S));let h=Wye(e,S,p);if(!i.force){if(h.type===1){Pee(e,l,h),vO(e,p,Ex(S)),s.delete(p),i.dry&&mf(e,g.Project_0_is_up_to_date,l);continue}if(h.type===2||h.type===15)return vO(e,p,Ex(S)),{kind:2,status:h,project:l,projectPath:p,projectIndex:o,config:S}}if(h.type===12){Pee(e,l,h),vO(e,p,Ex(S)),s.delete(p),i.verbose&&mf(e,h.upstreamProjectBlocked?g.Skipping_build_of_project_0_because_its_dependency_1_was_not_built:g.Skipping_build_of_project_0_because_its_dependency_1_has_errors,l,h.upstreamProjectName);continue}if(h.type===16){Pee(e,l,h),vO(e,p,Ex(S)),s.delete(p);continue}return{kind:Sbt(e,h,S)?0:1,status:h,project:l,projectPath:p,projectIndex:o,config:S}}}function R7e(e,t,n){return Pee(e,t.project,t.status),t.kind!==2?w7e(t.kind,e,t.project,t.projectPath,t.projectIndex,t.config,n):vbt(e,t.project,t.projectPath,t.config,n)}function Bye(e,t,n){let i=O7e(e,t,n);return i&&R7e(e,i,t)}function M7e({write:e},t,n){e&&t.options.listEmittedFiles&&e(`TSFILE: ${n}`)}function Tbt({options:e,builderPrograms:t,compilerHost:n},i,s){if(e.force)return;let o=t.get(i);return o||UV(s.options,n)}function Uye(e,t,n){t?(e.write&&pee(t,e.write),e.host.afterProgramEmitAndDiagnostics&&e.host.afterProgramEmitAndDiagnostics(t),t.releaseProgram()):e.host.afterEmitBundle&&e.host.afterEmitBundle(n),e.projectCompilerOptions=e.baseCompilerOptions}function Vye(e,t,n,i,s,o,l){let p=n&&!Wo(n.getCompilerOptions());return vO(e,t,s),e.projectStatus.set(t,{type:0,reason:`${l} errors`}),p?{buildResult:o,step:5}:(Uye(e,n,i),{buildResult:o,step:7})}function Aee(e){return!!e.watcher}function L7e(e,t){let n=Rd(e,t),i=e.filesWatched.get(n);if(e.watch&&i){if(!Aee(i))return i;if(i.modifiedTime)return i.modifiedTime}let s=fA(e.host,t);return e.watch&&(i?i.modifiedTime=s:e.filesWatched.set(n,s)),s}function kee(e,t,n,i,s,o,l){let p=Rd(e,t),m=e.filesWatched.get(p);if(m&&Aee(m))m.callbacks.push(n);else{let S=e.watchFile(t,(h,b,A)=>{let k=I.checkDefined(e.filesWatched.get(p));I.assert(Aee(k)),k.modifiedTime=A,k.callbacks.forEach(N=>N(h,b,A))},i,s,o,l);e.filesWatched.set(p,{callbacks:[n],watcher:S,modifiedTime:m})}return{close:()=>{let S=I.checkDefined(e.filesWatched.get(p));I.assert(Aee(S)),S.callbacks.length===1?(e.filesWatched.delete(p),Od(S)):uA(S.callbacks,n)}}}function Jye(e,t){if(!e.watch)return;let n=e.outputTimeStamps.get(t);return n||e.outputTimeStamps.set(t,n=new Map),n}function qye(e,t,n,i,s){let o=B1(i),l=zye(e,o,n),p=jM(e.host);l?(l.buildInfo=t,l.modifiedTime=p,s&2||(l.latestChangedDtsTime=p)):e.buildInfoCache.set(n,{path:Rd(e,o),buildInfo:t,modifiedTime:p,latestChangedDtsTime:s&2?void 0:p})}function zye(e,t,n){let i=Rd(e,t),s=e.buildInfoCache.get(n);return s?.path===i?s:void 0}function F7e(e,t,n,i){let s=Rd(e,t),o=e.buildInfoCache.get(n);if(o!==void 0&&o.path===s)return o.buildInfo||void 0;let l=e.readFileWithCache(t),p=l?mV(t,l):void 0;return e.buildInfoCache.set(n,{path:s,buildInfo:p||!1,modifiedTime:i||Lp}),p}function $ye(e,t,n,i){let s=L7e(e,t);if(n<s)return{type:6,outOfDateOutputFileName:i,newerInputFileName:t}}function bbt(e,t,n){var i,s,o;if(!t.fileNames.length&&!K6(t.raw))return{type:16};let l,p=!!e.options.force;if(t.projectReferences){e.projectStatus.set(n,{type:13});for(let Z of t.projectReferences){let Q=dD(Z),ce=ih(e,Q),ye=gk(e,Q,ce),we=Wye(e,ye,ce);if(!(we.type===13||we.type===16)){if(we.type===0||we.type===12)return{type:12,upstreamProjectName:Z.path,upstreamProjectBlocked:we.type===12};if(we.type!==1)return{type:11,upstreamProjectName:Z.path};p||(l||(l=[])).push({ref:Z,refStatus:we,resolvedRefPath:ce,resolvedConfig:ye})}}}if(p)return{type:17};let{host:m}=e,S=B1(t.options),h,b=K7e,A,k,N;if(S){let Z=zye(e,S,n);if(A=Z?.modifiedTime||fA(m,S),A===Lp)return Z||e.buildInfoCache.set(n,{path:Rd(e,S),buildInfo:!1,modifiedTime:A}),{type:4,missingOutputFileName:S};let Q=F7e(e,S,n,A);if(!Q)return{type:5,fileName:S};if((Q.bundle||Q.program)&&Q.version!==F)return{type:14,version:Q.version};if(Q.program){if((i=Q.program.changeFileSet)!=null&&i.length||(t.options.noEmit?Tt(Q.program.semanticDiagnosticsPerFile,os):(s=Q.program.affectedFilesPendingEmit)!=null&&s.length||(o=Q.program.emitDiagnosticsPerFile)!=null&&o.length))return{type:8,buildInfoFile:S};if(!t.options.noEmit&&gD(t.options,Q.program.options||{}))return{type:9,buildInfoFile:S};k=Q.program}b=A,h=S}let M,O=X7e,U=!1,H=new Set;for(let Z of t.fileNames){let Q=L7e(e,Z);if(Q===Lp)return{type:0,reason:`${Z} does not exist`};if(A&&A<Q){let ce,ye;if(k){N||(N=see(k,S,m)),ce=N.fileInfos.get(Rd(e,Z));let we=ce?e.readFileWithCache(Z):void 0;ye=we!==void 0?FV(m,we):void 0,ce&&ce===ye&&(U=!0)}if(!ce||ce!==ye)return{type:6,outOfDateOutputFileName:S,newerInputFileName:Z}}Q>O&&(M=Z,O=Q),k&&H.add(Rd(e,Z))}if(k){N||(N=see(k,S,m));for(let Z of N.roots)if(!H.has(Z))return{type:10,buildInfoFile:S,inputFile:Z}}if(!S){let Z=pV(t,!m.useCaseSensitiveFileNames()),Q=Jye(e,n);for(let ce of Z){let ye=Rd(e,ce),we=Q?.get(ye);if(we||(we=fA(e.host,ce),Q?.set(ye,we)),we===Lp)return{type:4,missingOutputFileName:ce};if(we<O)return{type:6,outOfDateOutputFileName:ce,newerInputFileName:M};we<b&&(b=we,h=ce)}}let K=e.buildInfoCache.get(n),re=!1,$=!1,pe;if(l)for(let{ref:Z,refStatus:Q,resolvedConfig:ce,resolvedRefPath:ye}of l){if($=$||!!Z.prepend,Q.newestInputFileTime&&Q.newestInputFileTime<=b)continue;if(K&&Ebt(e,K,ye))return{type:7,outOfDateOutputFileName:S,newerProjectName:Z.path};let we=xbt(e,ce.options,ye);if(we&&we<=b){re=!0,pe=Z.path;continue}return I.assert(h!==void 0,"Should have an oldest output filename here"),{type:7,outOfDateOutputFileName:h,newerProjectName:Z.path}}let z=$ye(e,t.options.configFilePath,b,h);if(z)return z;let se=Te(t.options.configFile.extendedSourceFiles||tt,Z=>$ye(e,Z,b,h));if(se)return se;let Se=e.lastCachedPackageJsonLookups.get(n),xe=Se&&Mh(Se,Z=>$ye(e,Z,b,h));return xe||($&&re?{type:3,outOfDateOutputFileName:h,newerProjectName:pe}:{type:re?2:U?15:1,newestInputFileTime:O,newestInputFileName:M,oldestOutputFileName:h})}function Ebt(e,t,n){return e.buildInfoCache.get(n).path===t.path}function Wye(e,t,n){if(t===void 0)return{type:0,reason:"File deleted mid-build"};let i=e.projectStatus.get(n);if(i!==void 0)return i;mc("SolutionBuilder::beforeUpToDateCheck");let s=bbt(e,t,n);return mc("SolutionBuilder::afterUpToDateCheck"),rd("SolutionBuilder::Up-to-date check","SolutionBuilder::beforeUpToDateCheck","SolutionBuilder::afterUpToDateCheck"),e.projectStatus.set(n,s),s}function j7e(e,t,n,i,s){if(t.options.noEmit)return;let o,l=B1(t.options);if(l){s?.has(Rd(e,l))||(e.options.verbose&&mf(e,i,t.options.configFilePath),e.host.setModifiedTime(l,o=jM(e.host)),zye(e,l,n).modifiedTime=o),e.outputTimeStamps.delete(n);return}let{host:p}=e,m=pV(t,!p.useCaseSensitiveFileNames()),S=Jye(e,n),h=S?new Set:void 0;if(!s||m.length!==s.size){let b=!!e.options.verbose;for(let A of m){let k=Rd(e,A);s?.has(k)||(b&&(b=!1,mf(e,i,t.options.configFilePath)),p.setModifiedTime(A,o||(o=jM(e.host))),S&&(S.set(k,o),h.add(k)))}}S?.forEach((b,A)=>{!s?.has(A)&&!h.has(A)&&S.delete(A)})}function xbt(e,t,n){if(!t.composite)return;let i=I.checkDefined(e.buildInfoCache.get(n));if(i.latestChangedDtsTime!==void 0)return i.latestChangedDtsTime||void 0;let s=i.buildInfo&&i.buildInfo.program&&i.buildInfo.program.latestChangedDtsFile?e.host.getModifiedTime(Ps(i.buildInfo.program.latestChangedDtsFile,hi(i.path))):void 0;return i.latestChangedDtsTime=s||!1,s}function B7e(e,t,n){if(e.options.dry)return mf(e,g.A_non_dry_build_would_update_timestamps_for_output_of_project_0,t.options.configFilePath);j7e(e,t,n,g.Updating_output_timestamps_of_project_0),e.projectStatus.set(n,{type:1,oldestOutputFileName:PZ(t,!e.host.useCaseSensitiveFileNames())})}function Cbt(e,t,n,i,s,o,l){if(!(l&124)&&s.options.composite)for(let p=i+1;p<o.length;p++){let m=o[p],S=ih(e,m);if(e.projectPendingBuild.has(S))continue;let h=gk(e,m,S);if(!(!h||!h.projectReferences))for(let b of h.projectReferences){let A=yO(e,b.path);if(ih(e,A)!==n)continue;let k=e.projectStatus.get(S);if(k)switch(k.type){case 1:if(l&2){b.prepend?e.projectStatus.set(S,{type:3,outOfDateOutputFileName:k.oldestOutputFileName,newerProjectName:t}):k.type=2;break}case 15:case 2:case 3:l&2||e.projectStatus.set(S,{type:7,outOfDateOutputFileName:k.type===3?k.outOfDateOutputFileName:k.oldestOutputFileName,newerProjectName:t});break;case 12:ih(e,yO(e,k.upstreamProjectName))===n&&P7e(e,S);break}N7e(e,S,0);break}}}function U7e(e,t,n,i,s,o){mc("SolutionBuilder::beforeBuild");let l=Abt(e,t,n,i,s,o);return mc("SolutionBuilder::afterBuild"),rd("SolutionBuilder::Build","SolutionBuilder::beforeBuild","SolutionBuilder::afterBuild"),l}function Abt(e,t,n,i,s,o){let l=A7e(e,t,o);if(!l)return 3;D7e(e,n);let p=!0,m=0;for(;;){let S=Bye(e,l,p);if(!S)break;p=!1,S.done(n,i,s?.(S.project)),e.diagnostics.has(S.projectPath)||m++}return jye(e),H7e(e,l),Dbt(e,l),mk(l)?4:l.some(S=>e.diagnostics.has(ih(e,S)))?m?2:1:0}function V7e(e,t,n){mc("SolutionBuilder::beforeClean");let i=kbt(e,t,n);return mc("SolutionBuilder::afterClean"),rd("SolutionBuilder::Clean","SolutionBuilder::beforeClean","SolutionBuilder::afterClean"),i}function kbt(e,t,n){let i=A7e(e,t,n);if(!i)return 3;if(mk(i))return zV(e,i.circularDiagnostics),4;let{options:s,host:o}=e,l=s.dry?[]:void 0;for(let p of i){let m=ih(e,p),S=gk(e,p,m);if(S===void 0){G7e(e,m);continue}let h=pV(S,!o.useCaseSensitiveFileNames());if(!h.length)continue;let b=new Set(S.fileNames.map(A=>Rd(e,A)));for(let A of h)b.has(Rd(e,A))||o.fileExists(A)&&(l?l.push(A):(o.deleteFile(A),Gye(e,m,0)))}return l&&mf(e,g.A_non_dry_build_would_delete_the_following_files_Colon_0,l.map(p=>`\r
 * ${p}`).join("")),0}function Gye(e,t,n){e.host.getParsedCommandLine&&n===1&&(n=2),n===2&&(e.configFileCache.delete(t),e.buildOrder=void 0),e.needsSummary=!0,P7e(e,t),N7e(e,t,n),k7e(e)}function qV(e,t,n){e.reportFileChangeDetected=!0,Gye(e,t,n),J7e(e,250,!0)}function J7e(e,t,n){let{hostWithWatch:i}=e;!i.setTimeout||!i.clearTimeout||(e.timerToBuildInvalidatedProject&&i.clearTimeout(e.timerToBuildInvalidatedProject),e.timerToBuildInvalidatedProject=i.setTimeout(Pbt,t,"timerToBuildInvalidatedProject",e,n))}function Pbt(e,t,n){mc("SolutionBuilder::beforeBuild");let i=Nbt(t,n);mc("SolutionBuilder::afterBuild"),rd("SolutionBuilder::Build","SolutionBuilder::beforeBuild","SolutionBuilder::afterBuild"),i&&H7e(t,i)}function Nbt(e,t){e.timerToBuildInvalidatedProject=void 0,e.reportFileChangeDetected&&(e.reportFileChangeDetected=!1,e.projectErrorsReported.clear(),Xye(e,g.File_change_detected_Starting_incremental_compilation));let n=0,i=JV(e),s=Bye(e,i,!1);if(s)for(s.done(),n++;e.projectPendingBuild.size;){if(e.timerToBuildInvalidatedProject)return;let o=O7e(e,i,!1);if(!o)break;if(o.kind!==2&&(t||n===5)){J7e(e,100,!1);return}R7e(e,o,i).done(),o.kind!==2&&n++}return jye(e),i}function q7e(e,t,n,i){!e.watch||e.allWatchedConfigFiles.has(n)||e.allWatchedConfigFiles.set(n,kee(e,t,()=>qV(e,n,2),2e3,i?.watchOptions,_u.ConfigFile,t))}function z7e(e,t,n){yV(t,n?.options,e.allWatchedExtendedConfigFiles,(i,s)=>kee(e,i,()=>{var o;return(o=e.allWatchedExtendedConfigFiles.get(s))==null?void 0:o.projects.forEach(l=>qV(e,l,2))},2e3,n?.watchOptions,_u.ExtendedConfigFile),i=>Rd(e,i))}function $7e(e,t,n,i){e.watch&&PM(Lye(e.allWatchedWildcardDirectories,n),i.wildcardDirectories,(s,o)=>e.watchDirectory(s,l=>{var p;NM({watchedDirPath:Rd(e,s),fileOrDirectory:l,fileOrDirectoryPath:Rd(e,l),configFileName:t,currentDirectory:e.compilerHost.getCurrentDirectory(),options:i.options,program:e.builderPrograms.get(n)||((p=hbt(e,n))==null?void 0:p.fileNames),useCaseSensitiveFileNames:e.parseConfigFileHost.useCaseSensitiveFileNames,writeLog:m=>e.writeLog(m),toPath:m=>Rd(e,m)})||qV(e,n,1)},o,i?.watchOptions,_u.WildcardDirectory,t))}function Hye(e,t,n,i){e.watch&&f6(Lye(e.allWatchedInputFiles,n),new Set(i.fileNames),{createNewValue:s=>kee(e,s,()=>qV(e,n,0),250,i?.watchOptions,_u.SourceFile,t),onDeleteValue:ug})}function Yye(e,t,n,i){!e.watch||!e.lastCachedPackageJsonLookups||f6(Lye(e.allWatchedPackageJsonFiles,n),e.lastCachedPackageJsonLookups.get(n),{createNewValue:s=>kee(e,s,()=>qV(e,n,0),2e3,i?.watchOptions,_u.PackageJson,t),onDeleteValue:ug})}function Dbt(e,t){if(e.watchAllProjectsPending){mc("SolutionBuilder::beforeWatcherCreation"),e.watchAllProjectsPending=!1;for(let n of VV(t)){let i=ih(e,n),s=gk(e,n,i);q7e(e,n,i,s),z7e(e,i,s),s&&($7e(e,n,i,s),Hye(e,n,i,s),Yye(e,n,i,s))}mc("SolutionBuilder::afterWatcherCreation"),rd("SolutionBuilder::Watcher creation","SolutionBuilder::beforeWatcherCreation","SolutionBuilder::afterWatcherCreation")}}function Ibt(e){Wf(e.allWatchedConfigFiles,ug),Wf(e.allWatchedExtendedConfigFiles,Od),Wf(e.allWatchedWildcardDirectories,t=>Wf(t,Od)),Wf(e.allWatchedInputFiles,t=>Wf(t,ug)),Wf(e.allWatchedPackageJsonFiles,t=>Wf(t,ug))}function W7e(e,t,n,i,s){let o=gbt(e,t,n,i,s);return{build:(l,p,m,S)=>U7e(o,l,p,m,S),clean:l=>V7e(o,l),buildReferences:(l,p,m,S)=>U7e(o,l,p,m,S,!0),cleanReferences:l=>V7e(o,l,!0),getNextInvalidatedProject:l=>(D7e(o,l),Bye(o,JV(o),!1)),getBuildOrder:()=>JV(o),getUpToDateStatusOfProject:l=>{let p=yO(o,l),m=ih(o,p);return Wye(o,gk(o,p,m),m)},invalidateProject:(l,p)=>Gye(o,l,p||0),close:()=>Ibt(o)}}function qu(e,t){return bw(t,e.compilerHost.getCurrentDirectory(),e.compilerHost.getCanonicalFileName)}function mf(e,t,...n){e.host.reportSolutionBuilderStatus(fl(t,...n))}function Xye(e,t,...n){var i,s;(s=(i=e.hostWithWatch).onWatchStatusChange)==null||s.call(i,fl(t,...n),e.host.getNewLine(),e.baseCompilerOptions)}function zV({host:e},t){t.forEach(n=>e.reportDiagnostic(n))}function vO(e,t,n){zV(e,n),e.projectErrorsReported.set(t,!0),n.length&&e.diagnostics.set(t,n)}function G7e(e,t){vO(e,t,[e.configFileCache.get(t)])}function H7e(e,t){if(!e.needsSummary)return;e.needsSummary=!1;let n=e.watch||!!e.host.reportErrorSummary,{diagnostics:i}=e,s=0,o=[];mk(t)?(Y7e(e,t.buildOrder),zV(e,t.circularDiagnostics),n&&(s+=RV(t.circularDiagnostics)),n&&(o=[...o,...MV(t.circularDiagnostics)])):(t.forEach(l=>{let p=ih(e,l);e.projectErrorsReported.has(p)||zV(e,i.get(p)||tt)}),n&&i.forEach(l=>s+=RV(l)),n&&i.forEach(l=>[...o,...MV(l)])),e.watch?Xye(e,fee(s),s):e.host.reportErrorSummary&&e.host.reportErrorSummary(s,o)}function Y7e(e,t){e.options.verbose&&mf(e,g.Projects_in_this_build_Colon_0,t.map(n=>`\r
    * `+qu(e,n)).join(""))}function wbt(e,t,n){switch(n.type){case 6:return mf(e,g.Project_0_is_out_of_date_because_output_1_is_older_than_input_2,qu(e,t),qu(e,n.outOfDateOutputFileName),qu(e,n.newerInputFileName));case 7:return mf(e,g.Project_0_is_out_of_date_because_output_1_is_older_than_input_2,qu(e,t),qu(e,n.outOfDateOutputFileName),qu(e,n.newerProjectName));case 4:return mf(e,g.Project_0_is_out_of_date_because_output_file_1_does_not_exist,qu(e,t),qu(e,n.missingOutputFileName));case 5:return mf(e,g.Project_0_is_out_of_date_because_there_was_error_reading_file_1,qu(e,t),qu(e,n.fileName));case 8:return mf(e,g.Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_some_of_the_changes_were_not_emitted,qu(e,t),qu(e,n.buildInfoFile));case 9:return mf(e,g.Project_0_is_out_of_date_because_buildinfo_file_1_indicates_there_is_change_in_compilerOptions,qu(e,t),qu(e,n.buildInfoFile));case 10:return mf(e,g.Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_file_2_was_root_file_of_compilation_but_not_any_more,qu(e,t),qu(e,n.buildInfoFile),qu(e,n.inputFile));case 1:if(n.newestInputFileTime!==void 0)return mf(e,g.Project_0_is_up_to_date_because_newest_input_1_is_older_than_output_2,qu(e,t),qu(e,n.newestInputFileName||""),qu(e,n.oldestOutputFileName||""));break;case 3:return mf(e,g.Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed,qu(e,t),qu(e,n.newerProjectName));case 2:return mf(e,g.Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies,qu(e,t));case 15:return mf(e,g.Project_0_is_up_to_date_but_needs_to_update_timestamps_of_output_files_that_are_older_than_input_files,qu(e,t));case 11:return mf(e,g.Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date,qu(e,t),qu(e,n.upstreamProjectName));case 12:return mf(e,n.upstreamProjectBlocked?g.Project_0_can_t_be_built_because_its_dependency_1_was_not_built:g.Project_0_can_t_be_built_because_its_dependency_1_has_errors,qu(e,t),qu(e,n.upstreamProjectName));case 0:return mf(e,g.Failed_to_parse_file_0_Colon_1,qu(e,t),n.reason);case 14:return mf(e,g.Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2,qu(e,t),n.version,F);case 17:return mf(e,g.Project_0_is_being_forcibly_rebuilt,qu(e,t));case 16:case 13:break;default:}}function Pee(e,t,n){e.options.verbose&&wbt(e,t,n)}var X7e,K7e,Nee,Obt=f({"src/compiler/tsbuildPublic.ts"(){"use strict";fa(),O2(),X7e=new Date(-864e13),K7e=new Date(864e13),Nee=(e=>(e[e.Build=0]="Build",e[e.UpdateBundle=1]="UpdateBundle",e[e.UpdateOutputFileStamps=2]="UpdateOutputFileStamps",e))(Nee||{})}}),fa=f({"src/compiler/_namespaces/ts.ts"(){"use strict";me(),zht(),$ht(),t0t(),i0t(),s0t(),g0t(),yOe(),C0t(),D0t(),I0t(),L0t(),J0t(),Uyt(),Vyt(),Jyt(),qyt(),Xyt(),Kyt(),Qyt(),Zyt(),A1t(),k1t(),F1t(),tvt(),kvt(),Ovt(),Rvt(),Hvt(),eSt(),cSt(),mSt(),PSt(),NSt(),jSt(),BSt(),USt(),GSt(),HSt(),YSt(),XSt(),KSt(),QSt(),ZSt(),eTt(),tTt(),iTt(),sTt(),aTt(),oTt(),cTt(),uTt(),_Tt(),fTt(),pTt(),dTt(),mTt(),TTt(),kTt(),FTt(),BTt(),qTt(),zTt(),$Tt(),ibt(),sbt(),cbt(),_bt(),fbt(),pbt(),Obt(),Zhe(),O2()}});function Q7e(e){return Zu.args.includes(e)}function Z7e(e){let t=Zu.args.indexOf(e);return t>=0&&t<Zu.args.length-1?Zu.args[t+1]:void 0}function eLe(){let e=new Date;return`${e.getHours().toString().padStart(2,"0")}:${e.getMinutes().toString().padStart(2,"0")}:${e.getSeconds().toString().padStart(2,"0")}.${e.getMilliseconds().toString().padStart(3,"0")}`}function SO(e){return Kye+e.replace(/\n/g,Kye)}function LT(e){return SO(JSON.stringify(e,void 0,2))}var BM,UM,VM,$V,WV,GV,Dee,TO,Iee,Kye,Rbt=f({"src/jsTyping/shared.ts"(){"use strict";JM(),BM="action::set",UM="action::invalidate",VM="action::packageInstalled",$V="event::typesRegistry",WV="event::beginInstallTypes",GV="event::endInstallTypes",Dee="event::initializationFailed",TO="action::watchTypingLocations",(e=>{e.GlobalCacheLocation="--globalTypingsCacheLocation",e.LogFile="--logFile",e.EnableTelemetry="--enableTelemetry",e.TypingSafeListLocation="--typingSafeListLocation",e.TypesMapLocation="--typesMapLocation",e.NpmLocation="--npmLocation",e.ValidateDefaultNpmLocation="--validateDefaultNpmLocation"})(Iee||(Iee={})),Kye=`
    `}}),Mbt=f({"src/jsTyping/types.ts"(){"use strict"}}),HV=f({"src/jsTyping/_namespaces/ts.server.ts"(){"use strict";Rbt(),Mbt()}});function tLe(e,t){return new Im(Ar(t,`ts${w}`)||Ar(t,"latest")).compareTo(e.version)<=0}function rLe(e){return r1e.has(e)?"node":e}function Lbt(e,t){let n=eM(t,i=>e.readFile(i));return new Map(Object.entries(n.config))}function Fbt(e,t){var n;let i=eM(t,s=>e.readFile(s));if((n=i.config)!=null&&n.simpleMap)return new Map(Object.entries(i.config.simpleMap))}function jbt(e,t,n,i,s,o,l,p,m,S){if(!l||!l.enable)return{cachedTypingPaths:[],newTypingNames:[],filesToWatch:[]};let h=new Map;n=Wi(n,re=>{let $=Ca(re);if(rE($))return $});let b=[];l.include&&U(l.include,"Explicitly included types");let A=l.exclude||[];if(!S.types){let re=new Set(n.map(hi));re.add(i),re.forEach($=>{H($,"bower.json","bower_components",b),H($,"package.json","node_modules",b)})}if(l.disableFilenameBasedTypeAcquisition||K(n),p){let re=Dh(p.map(rLe),Av,h_);U(re,"Inferred typings from unresolved imports")}for(let re of A)h.delete(re)&&t&&t(`Typing for ${re} is in exclude list, will be ignored.`);o.forEach((re,$)=>{let pe=m.get($);h.get($)===!1&&pe!==void 0&&tLe(re,pe)&&h.set($,re.typingLocation)});let k=[],N=[];h.forEach((re,$)=>{re?N.push(re):k.push($)});let M={cachedTypingPaths:N,newTypingNames:k,filesToWatch:b};return t&&t(`Finished typings discovery:${LT(M)}`),M;function O(re){h.has(re)||h.set(re,!1)}function U(re,$){t&&t(`${$}: ${JSON.stringify(re)}`),Te(re,O)}function H(re,$,pe,z){let se=li(re,$),Se,xe;e.fileExists(se)&&(z.push(se),Se=eM(se,ye=>e.readFile(ye)).config,xe=_a([Se.dependencies,Se.devDependencies,Se.optionalDependencies,Se.peerDependencies],Vt),U(xe,`Typing names in '${se}' dependencies`));let Z=li(re,pe);if(z.push(Z),!e.directoryExists(Z))return;let Q=[],ce=xe?xe.map(ye=>li(Z,ye,$)):e.readDirectory(Z,[".json"],void 0,void 0,3).filter(ye=>{if(Cl(ye)!==$)return!1;let we=gu(Ca(ye)),ve=we[we.length-3][0]==="@";return ve&&sp(we[we.length-4])===pe||!ve&&sp(we[we.length-3])===pe});t&&t(`Searching for typing names in ${Z}; all files: ${JSON.stringify(ce)}`);for(let ye of ce){let we=Ca(ye),oe=eM(we,Me=>e.readFile(Me)).config;if(!oe.name)continue;let Ee=oe.types||oe.typings;if(Ee){let Me=Ps(Ee,hi(we));e.fileExists(Me)?(t&&t(`    Package '${oe.name}' provides its own types.`),h.set(oe.name,Me)):t&&t(`    Package '${oe.name}' provides its own types but they are missing.`)}else Q.push(oe.name)}U(Q,"    Found package names")}function K(re){let $=Wi(re,z=>{if(!rE(z))return;let se=ff(sp(Cl(z))),Se=B5(se);return s.get(Se)});$.length&&U($,"Inferred typings from file names"),Tt(re,z=>Uc(z,".jsx"))&&(t&&t("Inferred 'react' typings due to presence of '.jsx' extension"),O("react"))}}function Bbt(e){return Qye(e,!0)}function Qye(e,t){if(!e)return 1;if(e.length>i1e)return 2;if(e.charCodeAt(0)===46)return 3;if(e.charCodeAt(0)===95)return 4;if(t){let n=/^@([^/]+)\/([^/]+)$/.exec(e);if(n){let i=Qye(n[1],!1);if(i!==0)return{name:n[1],isScopeName:!0,result:i};let s=Qye(n[2],!1);return s!==0?{name:n[2],isScopeName:!1,result:s}:0}}return encodeURIComponent(e)!==e?5:0}function Ubt(e,t){return typeof e=="object"?nLe(t,e.result,e.name,e.isScopeName):nLe(t,e,t,!1)}function nLe(e,t,n,i){let s=i?"Scope":"Package";switch(t){case 1:return`'${e}':: ${s} name '${n}' cannot be empty`;case 2:return`'${e}':: ${s} name '${n}' should be less than ${i1e} characters`;case 3:return`'${e}':: ${s} name '${n}' cannot start with '.'`;case 4:return`'${e}':: ${s} name '${n}' cannot start with '_'`;case 5:return`'${e}':: ${s} name '${n}' contains non URI safe characters`;case 0:return I.fail();default:I.assertNever(t)}}var Zye,e1e,t1e,r1e,n1e,i1e,Vbt=f({"src/jsTyping/jsTyping.ts"(){"use strict";JM(),HV(),Zye=["assert","assert/strict","async_hooks","buffer","child_process","cluster","console","constants","crypto","dgram","diagnostics_channel","dns","dns/promises","domain","events","fs","fs/promises","http","https","http2","inspector","module","net","os","path","perf_hooks","process","punycode","querystring","readline","repl","stream","stream/promises","string_decoder","timers","timers/promises","tls","trace_events","tty","url","util","util/types","v8","vm","wasi","worker_threads","zlib"],e1e=Zye.map(e=>`node:${e}`),t1e=[...Zye,...e1e],r1e=new Set(t1e),n1e=(e=>(e[e.Ok=0]="Ok",e[e.EmptyName=1]="EmptyName",e[e.NameTooLong=2]="NameTooLong",e[e.NameStartsWithDot=3]="NameStartsWithDot",e[e.NameStartsWithUnderscore=4]="NameStartsWithUnderscore",e[e.NameContainsNonURISafeCharacters=5]="NameContainsNonURISafeCharacters",e))(n1e||{}),i1e=214}}),sh={};x(sh,{NameValidationResult:()=>n1e,discoverTypings:()=>jbt,isTypingUpToDate:()=>tLe,loadSafeList:()=>Lbt,loadTypesMap:()=>Fbt,nodeCoreModuleList:()=>t1e,nodeCoreModules:()=>r1e,nonRelativeModuleNameForTypingCache:()=>rLe,prefixedNodeCoreModuleList:()=>e1e,renderPackageNameValidationFailure:()=>Ubt,validatePackageName:()=>Bbt});var Jbt=f({"src/jsTyping/_namespaces/ts.JsTyping.ts"(){"use strict";Vbt()}}),JM=f({"src/jsTyping/_namespaces/ts.ts"(){"use strict";fa(),Jbt(),HV()}});function YV(e){return{indentSize:4,tabSize:4,newLineCharacter:e||`
`,convertTabsToSpaces:!0,indentStyle:2,insertSpaceAfterConstructor:!1,insertSpaceAfterCommaDelimiter:!0,insertSpaceAfterSemicolonInForStatements:!0,insertSpaceBeforeAndAfterBinaryOperators:!0,insertSpaceAfterKeywordsInControlFlowStatements:!0,insertSpaceAfterFunctionKeywordForAnonymousFunctions:!1,insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis:!1,insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets:!1,insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces:!0,insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces:!1,insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces:!1,insertSpaceBeforeFunctionParenthesis:!1,placeOpenBraceOnNewLineForFunctions:!1,placeOpenBraceOnNewLineForControlBlocks:!1,semicolons:"ignore",trimTrailingWhitespace:!0,indentSwitchCase:!0}}var XV,wee,Oee,Ree,Md,Mee,Lee,Fee,jee,Bee,Uee,Vee,s1e,qM,Jee,qee,zee,$ee,Wee,Gee,Hee,Yee,Xee,qbt=f({"src/services/types.ts"(){"use strict";(e=>{class t{constructor(s){this.text=s}getText(s,o){return s===0&&o===this.text.length?this.text:this.text.substring(s,o)}getLength(){return this.text.length}getChangeRange(){}}function n(i){return new t(i)}e.fromString=n})(XV||(XV={})),wee=(e=>(e[e.Dependencies=1]="Dependencies",e[e.DevDependencies=2]="DevDependencies",e[e.PeerDependencies=4]="PeerDependencies",e[e.OptionalDependencies=8]="OptionalDependencies",e[e.All=15]="All",e))(wee||{}),Oee=(e=>(e[e.Off=0]="Off",e[e.On=1]="On",e[e.Auto=2]="Auto",e))(Oee||{}),Ree=(e=>(e[e.Semantic=0]="Semantic",e[e.PartialSemantic=1]="PartialSemantic",e[e.Syntactic=2]="Syntactic",e))(Ree||{}),Md={},Mee=(e=>(e.Original="original",e.TwentyTwenty="2020",e))(Mee||{}),Lee=(e=>(e.All="All",e.SortAndCombine="SortAndCombine",e.RemoveUnused="RemoveUnused",e))(Lee||{}),Fee=(e=>(e[e.Invoked=1]="Invoked",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=3]="TriggerForIncompleteCompletions",e))(Fee||{}),jee=(e=>(e.Type="Type",e.Parameter="Parameter",e.Enum="Enum",e))(jee||{}),Bee=(e=>(e.none="none",e.definition="definition",e.reference="reference",e.writtenReference="writtenReference",e))(Bee||{}),Uee=(e=>(e[e.None=0]="None",e[e.Block=1]="Block",e[e.Smart=2]="Smart",e))(Uee||{}),Vee=(e=>(e.Ignore="ignore",e.Insert="insert",e.Remove="remove",e))(Vee||{}),s1e=YV(`
`),qM=(e=>(e[e.aliasName=0]="aliasName",e[e.className=1]="className",e[e.enumName=2]="enumName",e[e.fieldName=3]="fieldName",e[e.interfaceName=4]="interfaceName",e[e.keyword=5]="keyword",e[e.lineBreak=6]="lineBreak",e[e.numericLiteral=7]="numericLiteral",e[e.stringLiteral=8]="stringLiteral",e[e.localName=9]="localName",e[e.methodName=10]="methodName",e[e.moduleName=11]="moduleName",e[e.operator=12]="operator",e[e.parameterName=13]="parameterName",e[e.propertyName=14]="propertyName",e[e.punctuation=15]="punctuation",e[e.space=16]="space",e[e.text=17]="text",e[e.typeParameterName=18]="typeParameterName",e[e.enumMemberName=19]="enumMemberName",e[e.functionName=20]="functionName",e[e.regularExpressionLiteral=21]="regularExpressionLiteral",e[e.link=22]="link",e[e.linkName=23]="linkName",e[e.linkText=24]="linkText",e))(qM||{}),Jee=(e=>(e[e.None=0]="None",e[e.MayIncludeAutoImports=1]="MayIncludeAutoImports",e[e.IsImportStatementCompletion=2]="IsImportStatementCompletion",e[e.IsContinuation=4]="IsContinuation",e[e.ResolvedModuleSpecifiers=8]="ResolvedModuleSpecifiers",e[e.ResolvedModuleSpecifiersBeyondLimit=16]="ResolvedModuleSpecifiersBeyondLimit",e[e.MayIncludeMethodSnippets=32]="MayIncludeMethodSnippets",e))(Jee||{}),qee=(e=>(e.Comment="comment",e.Region="region",e.Code="code",e.Imports="imports",e))(qee||{}),zee=(e=>(e[e.JavaScript=0]="JavaScript",e[e.SourceMap=1]="SourceMap",e[e.Declaration=2]="Declaration",e))(zee||{}),$ee=(e=>(e[e.None=0]="None",e[e.InMultiLineCommentTrivia=1]="InMultiLineCommentTrivia",e[e.InSingleQuoteStringLiteral=2]="InSingleQuoteStringLiteral",e[e.InDoubleQuoteStringLiteral=3]="InDoubleQuoteStringLiteral",e[e.InTemplateHeadOrNoSubstitutionTemplate=4]="InTemplateHeadOrNoSubstitutionTemplate",e[e.InTemplateMiddleOrTail=5]="InTemplateMiddleOrTail",e[e.InTemplateSubstitutionPosition=6]="InTemplateSubstitutionPosition",e))($ee||{}),Wee=(e=>(e[e.Punctuation=0]="Punctuation",e[e.Keyword=1]="Keyword",e[e.Operator=2]="Operator",e[e.Comment=3]="Comment",e[e.Whitespace=4]="Whitespace",e[e.Identifier=5]="Identifier",e[e.NumberLiteral=6]="NumberLiteral",e[e.BigIntLiteral=7]="BigIntLiteral",e[e.StringLiteral=8]="StringLiteral",e[e.RegExpLiteral=9]="RegExpLiteral",e))(Wee||{}),Gee=(e=>(e.unknown="",e.warning="warning",e.keyword="keyword",e.scriptElement="script",e.moduleElement="module",e.classElement="class",e.localClassElement="local class",e.interfaceElement="interface",e.typeElement="type",e.enumElement="enum",e.enumMemberElement="enum member",e.variableElement="var",e.localVariableElement="local var",e.variableUsingElement="using",e.variableAwaitUsingElement="await using",e.functionElement="function",e.localFunctionElement="local function",e.memberFunctionElement="method",e.memberGetAccessorElement="getter",e.memberSetAccessorElement="setter",e.memberVariableElement="property",e.memberAccessorVariableElement="accessor",e.constructorImplementationElement="constructor",e.callSignatureElement="call",e.indexSignatureElement="index",e.constructSignatureElement="construct",e.parameterElement="parameter",e.typeParameterElement="type parameter",e.primitiveType="primitive type",e.label="label",e.alias="alias",e.constElement="const",e.letElement="let",e.directory="directory",e.externalModuleName="external module name",e.jsxAttribute="JSX attribute",e.string="string",e.link="link",e.linkName="link name",e.linkText="link text",e))(Gee||{}),Hee=(e=>(e.none="",e.publicMemberModifier="public",e.privateMemberModifier="private",e.protectedMemberModifier="protected",e.exportedModifier="export",e.ambientModifier="declare",e.staticModifier="static",e.abstractModifier="abstract",e.optionalModifier="optional",e.deprecatedModifier="deprecated",e.dtsModifier=".d.ts",e.tsModifier=".ts",e.tsxModifier=".tsx",e.jsModifier=".js",e.jsxModifier=".jsx",e.jsonModifier=".json",e.dmtsModifier=".d.mts",e.mtsModifier=".mts",e.mjsModifier=".mjs",e.dctsModifier=".d.cts",e.ctsModifier=".cts",e.cjsModifier=".cjs",e))(Hee||{}),Yee=(e=>(e.comment="comment",e.identifier="identifier",e.keyword="keyword",e.numericLiteral="number",e.bigintLiteral="bigint",e.operator="operator",e.stringLiteral="string",e.whiteSpace="whitespace",e.text="text",e.punctuation="punctuation",e.className="class name",e.enumName="enum name",e.interfaceName="interface name",e.moduleName="module name",e.typeParameterName="type parameter name",e.typeAliasName="type alias name",e.parameterName="parameter name",e.docCommentTagName="doc comment tag name",e.jsxOpenTagName="jsx open tag name",e.jsxCloseTagName="jsx close tag name",e.jsxSelfClosingTagName="jsx self closing tag name",e.jsxAttribute="jsx attribute",e.jsxText="jsx text",e.jsxAttributeStringLiteralValue="jsx attribute string literal value",e))(Yee||{}),Xee=(e=>(e[e.comment=1]="comment",e[e.identifier=2]="identifier",e[e.keyword=3]="keyword",e[e.numericLiteral=4]="numericLiteral",e[e.operator=5]="operator",e[e.stringLiteral=6]="stringLiteral",e[e.regularExpressionLiteral=7]="regularExpressionLiteral",e[e.whiteSpace=8]="whiteSpace",e[e.text=9]="text",e[e.punctuation=10]="punctuation",e[e.className=11]="className",e[e.enumName=12]="enumName",e[e.interfaceName=13]="interfaceName",e[e.moduleName=14]="moduleName",e[e.typeParameterName=15]="typeParameterName",e[e.typeAliasName=16]="typeAliasName",e[e.parameterName=17]="parameterName",e[e.docCommentTagName=18]="docCommentTagName",e[e.jsxOpenTagName=19]="jsxOpenTagName",e[e.jsxCloseTagName=20]="jsxCloseTagName",e[e.jsxSelfClosingTagName=21]="jsxSelfClosingTagName",e[e.jsxAttribute=22]="jsxAttribute",e[e.jsxText=23]="jsxText",e[e.jsxAttributeStringLiteralValue=24]="jsxAttributeStringLiteralValue",e[e.bigintLiteral=25]="bigintLiteral",e))(Xee||{})}});function zM(e){switch(e.kind){case 260:return gn(e)&&eY(e)?7:1;case 169:case 208:case 172:case 171:case 303:case 304:case 174:case 173:case 176:case 177:case 178:case 262:case 218:case 219:case 299:case 291:return 1;case 168:case 264:case 265:case 187:return 2;case 353:return e.name===void 0?3:2;case 306:case 263:return 3;case 267:return S_(e)||Oy(e)===1?5:4;case 266:case 275:case 276:case 271:case 272:case 277:case 278:return 7;case 312:return 5}return 7}function Cx(e){e=lte(e);let t=e.parent;return e.kind===312?1:Kc(t)||R_(t)||zh(t)||Gf(t)||Jh(t)||Ru(t)&&e===t.name?7:KV(e)?zbt(e):Cy(e)?zM(t):zf(e)&&Gr(e,cg(z6,TA,kT))?7:Hbt(e)?2:$bt(e)?4:Nc(t)?(I.assert(dm(t.parent)),2):Qv(t)?3:1}function zbt(e){let t=e.kind===166?e:pf(e.parent)&&e.parent.right===e?e.parent:void 0;return t&&t.parent.kind===271?7:4}function KV(e){for(;e.parent.kind===166;)e=e.parent;return fN(e.parent)&&e.parent.moduleReference===e}function $bt(e){return Wbt(e)||Gbt(e)}function Wbt(e){let t=e,n=!0;if(t.parent.kind===166){for(;t.parent&&t.parent.kind===166;)t=t.parent;n=t.right===e}return t.parent.kind===183&&!n}function Gbt(e){let t=e,n=!0;if(t.parent.kind===211){for(;t.parent&&t.parent.kind===211;)t=t.parent;n=t.name===e}if(!n&&t.parent.kind===233&&t.parent.parent.kind===298){let i=t.parent.parent.parent;return i.kind===263&&t.parent.parent.token===119||i.kind===264&&t.parent.parent.token===96}return!1}function Hbt(e){switch(o6(e)&&(e=e.parent),e.kind){case 110:return!k0(e);case 197:return!0}switch(e.parent.kind){case 183:return!0;case 205:return!e.parent.isTypeOf;case 233:return A0(e.parent)}return!1}function Kee(e,t=!1,n=!1){return $M(e,da,Zee,t,n)}function bO(e,t=!1,n=!1){return $M(e,lE,Zee,t,n)}function Qee(e,t=!1,n=!1){return $M(e,Jg,Zee,t,n)}function a1e(e,t=!1,n=!1){return $M(e,uE,Ybt,t,n)}function o1e(e,t=!1,n=!1){return $M(e,n_,Zee,t,n)}function c1e(e,t=!1,n=!1){return $M(e,H_,Xbt,t,n)}function Zee(e){return e.expression}function Ybt(e){return e.tag}function Xbt(e){return e.tagName}function $M(e,t,n,i,s){let o=i?l1e(e):QV(e);return s&&(o=vl(o)),!!o&&!!o.parent&&t(o.parent)&&n(o.parent)===o}function QV(e){return SD(e)?e.parent:e}function l1e(e){return SD(e)||nte(e)?e.parent:e}function ZV(e,t){for(;e;){if(e.kind===256&&e.label.escapedText===t)return e.label;e=e.parent}}function WM(e,t){return Hn(e.expression)?e.expression.name.text===t:!1}function GM(e){var t;return ze(e)&&((t=ii(e.parent,Iw))==null?void 0:t.label)===e}function ete(e){var t;return ze(e)&&((t=ii(e.parent,_E))==null?void 0:t.label)===e}function tte(e){return ete(e)||GM(e)}function rte(e){var t;return((t=ii(e.parent,eN))==null?void 0:t.tagName)===e}function u1e(e){var t;return((t=ii(e.parent,pf))==null?void 0:t.right)===e}function SD(e){var t;return((t=ii(e.parent,Hn))==null?void 0:t.name)===e}function nte(e){var t;return((t=ii(e.parent,fc))==null?void 0:t.argumentExpression)===e}function ite(e){var t;return((t=ii(e.parent,hl))==null?void 0:t.name)===e}function ste(e){var t;return ze(e)&&((t=ii(e.parent,ca))==null?void 0:t.name)===e}function eJ(e){switch(e.parent.kind){case 172:case 171:case 303:case 306:case 174:case 173:case 177:case 178:case 267:return qs(e.parent)===e;case 212:return e.parent.argumentExpression===e;case 167:return!0;case 201:return e.parent.parent.kind===199;default:return!1}}function _1e(e){return gT(e.parent.parent)&&$w(e.parent.parent)===e}function Ax(e){for(am(e)&&(e=e.parent.parent);;){if(e=e.parent,!e)return;switch(e.kind){case 312:case 174:case 173:case 262:case 218:case 177:case 178:case 263:case 264:case 266:case 267:return e}}}function CE(e){switch(e.kind){case 312:return Pl(e)?"module":"script";case 267:return"module";case 263:case 231:return"class";case 264:return"interface";case 265:case 345:case 353:return"type";case 266:return"enum";case 260:return t(e);case 208:return t(Gg(e));case 219:case 262:case 218:return"function";case 177:return"getter";case 178:return"setter";case 174:case 173:return"method";case 303:let{initializer:n}=e;return ca(n)?"method":"property";case 172:case 171:case 304:case 305:return"property";case 181:return"index";case 180:return"construct";case 179:return"call";case 176:case 175:return"constructor";case 168:return"type parameter";case 306:return"enum member";case 169:return ui(e,31)?"property":"parameter";case 271:case 276:case 281:case 274:case 280:return"alias";case 226:let i=al(e),{right:s}=e;switch(i){case 7:case 8:case 9:case 0:return"";case 1:case 2:let l=CE(s);return l===""?"const":l;case 3:return Xo(s)?"method":"property";case 4:return"property";case 5:return Xo(s)?"method":"property";case 6:return"local class";default:return""}case 80:return Jh(e.parent)?"alias":"";case 277:let o=CE(e.expression);return o===""?"const":o;default:return""}function t(n){return aN(n)?"const":X9(n)?"let":"var"}}function TD(e){switch(e.kind){case 110:return!0;case 80:return SX(e)&&e.parent.kind===169;default:return!1}}function mm(e,t){let n=vy(t),i=t.getLineAndCharacterOfPosition(e).line;return n[i]}function ud(e,t){return ate(e.pos,e.end,t)}function f1e(e,t){return YM(e,t.pos)&&YM(e,t.end)}function HM(e,t){return e.pos<=t&&t<=e.end}function YM(e,t){return e.pos<t&&t<e.end}function ate(e,t,n){return e<=n.pos&&t>=n.end}function XM(e,t,n){return e.pos<=t&&e.end>=n}function EO(e,t,n){return rJ(e.pos,e.end,t,n)}function tJ(e,t,n,i){return rJ(e.getStart(t),e.end,n,i)}function rJ(e,t,n,i){let s=Math.max(e,n),o=Math.min(t,i);return s<o}function ote(e,t,n){return I.assert(e.pos<=t),t<e.end||!gg(e,n)}function gg(e,t){if(e===void 0||sl(e))return!1;switch(e.kind){case 263:case 264:case 266:case 210:case 206:case 187:case 241:case 268:case 269:case 275:case 279:return cte(e,20,t);case 299:return gg(e.block,t);case 214:if(!e.arguments)return!0;case 213:case 217:case 196:return cte(e,22,t);case 184:case 185:return gg(e.type,t);case 176:case 177:case 178:case 262:case 218:case 174:case 173:case 180:case 179:case 219:return e.body?gg(e.body,t):e.type?gg(e.type,t):KM(e,22,t);case 267:return!!e.body&&gg(e.body,t);case 245:return e.elseStatement?gg(e.elseStatement,t):gg(e.thenStatement,t);case 244:return gg(e.expression,t)||KM(e,27,t);case 209:case 207:case 212:case 167:case 189:return cte(e,24,t);case 181:return e.type?gg(e.type,t):KM(e,24,t);case 296:case 297:return!1;case 248:case 249:case 250:case 247:return gg(e.statement,t);case 246:return KM(e,117,t)?cte(e,22,t):gg(e.statement,t);case 186:return gg(e.exprName,t);case 221:case 220:case 222:case 229:case 230:return gg(e.expression,t);case 215:return gg(e.template,t);case 228:let i=Is(e.templateSpans);return gg(i,t);case 239:return nm(e.literal);case 278:case 272:return nm(e.moduleSpecifier);case 224:return gg(e.operand,t);case 226:return gg(e.right,t);case 227:return gg(e.whenFalse,t);default:return!0}}function cte(e,t,n){let i=e.getChildren(n);if(i.length){let s=Rs(i);if(s.kind===t)return!0;if(s.kind===27&&i.length!==1)return i[i.length-2].kind===t}return!1}function p1e(e){let t=nJ(e);if(!t)return;let n=t.getChildren();return{listItemIndex:nN(n,e),list:t}}function KM(e,t,n){return!!Oo(e,t,n)}function Oo(e,t,n){return mr(e.getChildren(n),i=>i.kind===t)}function nJ(e){let t=mr(e.parent.getChildren(),n=>XN(n)&&ud(n,e));return I.assert(!t||hs(t.getChildren(),e)),t}function iLe(e){return e.kind===90}function Kbt(e){return e.kind===86}function Qbt(e){return e.kind===100}function Zbt(e){if(W_(e))return e.name;if(eu(e)){let t=e.modifiers&&mr(e.modifiers,iLe);if(t)return t}if(wu(e)){let t=mr(e.getChildren(),Kbt);if(t)return t}}function eEt(e){if(W_(e))return e.name;if(Zl(e)){let t=mr(e.modifiers,iLe);if(t)return t}if(Xo(e)){let t=mr(e.getChildren(),Qbt);if(t)return t}}function tEt(e){let t;return Gr(e,n=>(es(n)&&(t=n),!pf(n.parent)&&!es(n.parent)&&!B2(n.parent))),t}function iJ(e,t){if(e.flags&16777216)return;let n=EJ(e,t);if(n)return n;let i=tEt(e);return i&&t.getTypeAtLocation(i)}function rEt(e,t){if(!t)switch(e.kind){case 263:case 231:return Zbt(e);case 262:case 218:return eEt(e);case 176:return e}if(W_(e))return e.name}function sLe(e,t){if(e.importClause){if(e.importClause.name&&e.importClause.namedBindings)return;if(e.importClause.name)return e.importClause.name;if(e.importClause.namedBindings){if(Dy(e.importClause.namedBindings)){let n=nl(e.importClause.namedBindings.elements);return n?n.name:void 0}else if(tS(e.importClause.namedBindings))return e.importClause.namedBindings.name}}if(!t)return e.moduleSpecifier}function aLe(e,t){if(e.exportClause){if(wd(e.exportClause))return nl(e.exportClause.elements)?e.exportClause.elements[0].name:void 0;if(qh(e.exportClause))return e.exportClause.name}if(!t)return e.moduleSpecifier}function nEt(e){if(e.types.length===1)return e.types[0].expression}function oLe(e,t){let{parent:n}=e;if(Ra(e)&&(t||e.kind!==90)?Jm(n)&&hs(n.modifiers,e):e.kind===86?eu(n)||wu(e):e.kind===100?Zl(n)||Xo(e):e.kind===120?ef(n):e.kind===94?AT(n):e.kind===156?Vm(n):e.kind===145||e.kind===144?hl(n):e.kind===102?Ru(n):e.kind===139?sd(n):e.kind===153&&pp(n)){let i=rEt(n,t);if(i)return i}if((e.kind===115||e.kind===87||e.kind===121)&&Tu(n)&&n.declarations.length===1){let i=n.declarations[0];if(ze(i.name))return i.name}if(e.kind===156){if(Jh(n)&&n.isTypeOnly){let i=sLe(n.parent,t);if(i)return i}if(yl(n)&&n.isTypeOnly){let i=aLe(n,t);if(i)return i}}if(e.kind===130){if(Gf(n)&&n.propertyName||R_(n)&&n.propertyName||tS(n)||qh(n))return n.name;if(yl(n)&&n.exportClause&&qh(n.exportClause))return n.exportClause.name}if(e.kind===102&&uu(n)){let i=sLe(n,t);if(i)return i}if(e.kind===95){if(yl(n)){let i=aLe(n,t);if(i)return i}if(Kc(n))return vl(n.expression)}if(e.kind===149&&zh(n))return n.expression;if(e.kind===161&&(uu(n)||yl(n))&&n.moduleSpecifier)return n.moduleSpecifier;if((e.kind===96||e.kind===119)&&ad(n)&&n.token===e.kind){let i=nEt(n);if(i)return i}if(e.kind===96){if(Nc(n)&&n.constraint&&Id(n.constraint))return n.constraint.typeName;if(QA(n)&&Id(n.extendsType))return n.extendsType.typeName}if(e.kind===140&&ax(n))return n.typeParameter.name;if(e.kind===103&&Nc(n)&&qN(n.parent))return n.name;if(e.kind===143&&cx(n)&&n.operator===143&&Id(n.type))return n.type.typeName;if(e.kind===148&&cx(n)&&n.operator===148&&MR(n.type)&&Id(n.type.elementType))return n.type.elementType.typeName;if(!t){if((e.kind===105&&lE(n)||e.kind===116&&ZA(n)||e.kind===114&&zN(n)||e.kind===135&&Zv(n)||e.kind===127&&sU(n)||e.kind===91&&Age(n))&&n.expression)return vl(n.expression);if((e.kind===103||e.kind===104)&&bn(n)&&n.operatorToken===e)return vl(n.right);if(e.kind===130&&FR(n)&&Id(n.type))return n.type.typeName;if(e.kind===103&&oU(n)||e.kind===165&&jR(n))return vl(n.expression)}return e}function lte(e){return oLe(e,!1)}function sJ(e){return oLe(e,!0)}function If(e,t){return bD(e,t,n=>Wg(n)||Nf(n.kind)||is(n))}function bD(e,t,n){return cLe(e,t,!1,n,!1)}function Ts(e,t){return cLe(e,t,!0,void 0,!1)}function cLe(e,t,n,i,s){let o=e,l;e:for(;;){let m=o.getChildren(e),S=nT(m,t,(h,b)=>b,(h,b)=>{let A=m[h].getEnd();if(A<t)return-1;let k=n?m[h].getFullStart():m[h].getStart(e,!0);return k>t?1:p(m[h],k,A)?m[h-1]&&p(m[h-1])?1:0:i&&k===t&&m[h-1]&&m[h-1].getEnd()===t&&p(m[h-1])?1:-1});if(l)return l;if(S>=0&&m[S]){o=m[S];continue e}return o}function p(m,S,h){if(h??(h=m.getEnd()),h<t||(S??(S=n?m.getFullStart():m.getStart(e,!0)),S>t))return!1;if(t<h||t===h&&(m.kind===1||s))return!0;if(i&&h===t){let b=tu(t,e,m);if(b&&i(b))return l=b,!0}return!1}}function d1e(e,t){let n=Ts(e,t);for(;oJ(n);){let i=AE(n,n.parent,e);if(!i)return;n=i}return n}function aJ(e,t){let n=Ts(e,t);return gA(n)&&t>n.getStart(e)&&t<n.getEnd()?n:tu(t,e)}function AE(e,t,n){return i(t);function i(s){return gA(s)&&s.pos===e.end?s:Ct(s.getChildren(n),o=>(o.pos<=e.pos&&o.end>e.end||o.pos===e.end)&&T1e(o,n)?i(o):void 0)}}function tu(e,t,n,i){let s=o(n||t);return I.assert(!(s&&oJ(s))),s;function o(l){if(lLe(l)&&l.kind!==1)return l;let p=l.getChildren(t),m=nT(p,e,(h,b)=>b,(h,b)=>e<p[h].end?!p[h-1]||e>=p[h-1].end?0:1:-1);if(m>=0&&p[m]){let h=p[m];if(e<h.end)if(h.getStart(t,!i)>=e||!T1e(h,t)||oJ(h)){let k=g1e(p,m,t,l.kind);return k?!i&&M9(k)&&k.getChildren(t).length?o(k):m1e(k,t):void 0}else return o(h)}I.assert(n!==void 0||l.kind===312||l.kind===1||M9(l));let S=g1e(p,p.length,t,l.kind);return S&&m1e(S,t)}}function lLe(e){return gA(e)&&!oJ(e)}function m1e(e,t){if(lLe(e))return e;let n=e.getChildren(t);if(n.length===0)return e;let i=g1e(n,n.length,t,e.kind);return i&&m1e(i,t)}function g1e(e,t,n,i){for(let s=t-1;s>=0;s--){let o=e[s];if(oJ(o))s===0&&(i===12||i===285)&&I.fail("`JsxText` tokens should not be the first child of `JsxElement | JsxSelfClosingElement`");else if(T1e(e[s],n))return e[s]}}function hk(e,t,n=tu(t,e)){if(n&&cY(n)){let i=n.getStart(e),s=n.getEnd();if(i<t&&t<s)return!0;if(t===s)return!!n.isUnterminated}return!1}function h1e(e,t){let n=Ts(e,t);return n?!!(n.kind===12||n.kind===30&&n.parent.kind===12||n.kind===30&&n.parent.kind===294||n&&n.kind===20&&n.parent.kind===294||n.kind===30&&n.parent.kind===287):!1}function oJ(e){return qA(e)&&e.containsOnlyTriviaWhiteSpaces}function ute(e,t){let n=Ts(e,t);return Rv(n.kind)&&t>n.getStart(e)}function y1e(e,t){let n=Ts(e,t);return!!(qA(n)||n.kind===19&&J6(n.parent)&&L0(n.parent.parent)||n.kind===30&&H_(n.parent)&&L0(n.parent.parent))}function cJ(e,t){function n(i){for(;i;)if(i.kind>=285&&i.kind<=294||i.kind===12||i.kind===30||i.kind===32||i.kind===80||i.kind===20||i.kind===19||i.kind===44)i=i.parent;else if(i.kind===284){if(t>i.getStart(e))return!0;i=i.parent}else return!1;return!1}return n(Ts(e,t))}function lJ(e,t,n){let i=Sa(e.kind),s=Sa(t),o=e.getFullStart(),l=n.text.lastIndexOf(s,o);if(l===-1)return;if(n.text.lastIndexOf(i,o-1)<l){let S=tu(l+1,n);if(S&&S.kind===t)return S}let p=e.kind,m=0;for(;;){let S=tu(e.getFullStart(),n);if(!S)return;if(e=S,e.kind===t){if(m===0)return e;m--}else e.kind===p&&m++}}function v1e(e,t,n){return t?e.getNonNullableType():n?e.getNonOptionalType():e}function QM(e,t,n){let i=fte(e,t);return i!==void 0&&(A0(i.called)||_te(i.called,i.nTypeArguments,n).length!==0||QM(i.called,t,n))}function _te(e,t,n){let i=n.getTypeAtLocation(e);return w_(e.parent)&&(i=v1e(i,Nw(e.parent),!0)),(lE(e.parent)?i.getConstructSignatures():i.getCallSignatures()).filter(o=>!!o.typeParameters&&o.typeParameters.length>=t)}function fte(e,t){if(t.text.lastIndexOf("<",e?e.pos:t.text.length)===-1)return;let n=e,i=0,s=0;for(;n;){switch(n.kind){case 30:if(n=tu(n.getFullStart(),t),n&&n.kind===29&&(n=tu(n.getFullStart(),t)),!n||!ze(n))return;if(!i)return Cy(n)?void 0:{called:n,nTypeArguments:s};i--;break;case 50:i=3;break;case 49:i=2;break;case 32:i++;break;case 20:if(n=lJ(n,19,t),!n)return;break;case 22:if(n=lJ(n,21,t),!n)return;break;case 24:if(n=lJ(n,23,t),!n)return;break;case 28:s++;break;case 39:case 80:case 11:case 9:case 10:case 112:case 97:case 114:case 96:case 143:case 25:case 52:case 58:case 59:break;default:if(es(n))break;return}n=tu(n.getFullStart(),t)}}function U1(e,t,n){return fu.getRangeOfEnclosingComment(e,t,void 0,n)}function S1e(e,t){let n=Ts(e,t);return!!Gr(n,dg)}function T1e(e,t){return e.kind===1?!!e.jsDoc:e.getWidth(t)!==0}function xO(e,t=0){let n=[],i=O_(e)?XH(e)&~t:0;return i&2&&n.push("private"),i&4&&n.push("protected"),i&1&&n.push("public"),(i&256||Jc(e))&&n.push("static"),i&64&&n.push("abstract"),i&32&&n.push("export"),i&65536&&n.push("deprecated"),e.flags&33554432&&n.push("declare"),e.kind===277&&n.push("export"),n.length>0?n.join(","):""}function b1e(e){if(e.kind===183||e.kind===213)return e.typeArguments;if(ca(e)||e.kind===263||e.kind===264)return e.typeParameters}function uJ(e){return e===2||e===3}function pte(e){return!!(e===11||e===14||Rv(e))}function uLe(e,t,n){return!!(t.flags&4)&&e.isEmptyAnonymousObjectType(n)}function E1e(e){if(!e.isIntersection())return!1;let{types:t,checker:n}=e;return t.length===2&&(uLe(n,t[0],t[1])||uLe(n,t[1],t[0]))}function ZM(e,t,n){return Rv(e.kind)&&e.getStart(n)<t&&t<e.end||!!e.isUnterminated&&t===e.end}function dte(e){switch(e){case 125:case 123:case 124:return!0}return!1}function mte(e){let t=q_(e);return bQ(t,e&&e.configFile),t}function V1(e){return!!((e.kind===209||e.kind===210)&&(e.parent.kind===226&&e.parent.left===e&&e.parent.operatorToken.kind===64||e.parent.kind===250&&e.parent.initializer===e||V1(e.parent.kind===303?e.parent.parent:e.parent)))}function x1e(e,t){return _Le(e,t,!0)}function C1e(e,t){return _Le(e,t,!1)}function _Le(e,t,n){let i=U1(e,t,void 0);return!!i&&n===vLe.test(e.text.substring(i.pos,i.end))}function gte(e){if(e)switch(e.kind){case 11:case 15:return hte(e);default:return gf(e)}}function gf(e,t,n){return Ll(e.getStart(t),(n||e).getEnd())}function hte(e){if(!e.isUnterminated)return Ll(e.getStart()+1,e.getEnd()-1)}function yte(e,t){return kd(e.getStart(t),e.end)}function aS(e){return Ll(e.pos,e.end)}function _J(e){return kd(e.start,e.start+e.length)}function fJ(e,t,n){return e7(e_(e,t),n)}function e7(e,t){return{span:e,newText:t}}function CO(e){return hs(FJ,e)}function vte(e){return e.kind===156}function pJ(e){return vte(e)||ze(e)&&e.text==="type"}function t7(e){return!!(e.flags&1536)&&e.name.charCodeAt(0)===34}function yk(){let e=[];return t=>{let n=yo(t);return!e[n]&&(e[n]=!0)}}function ED(e){return e.getText(0,e.getLength())}function r7(e,t){let n="";for(let i=0;i<t;i++)n+=e;return n}function Ste(e){return e.isTypeParameter()&&e.getConstraint()||e}function n7(e){return e.kind===167?id(e.expression)?e.expression.text:void 0:is(e)?Nn(e):om(e)}function A1e(e){return e.getSourceFiles().some(t=>!t.isDeclarationFile&&!e.isSourceFileFromExternalLibrary(t)&&!!(t.externalModuleIndicator||t.commonJsModuleIndicator))}function k1e(e){return e.getSourceFiles().some(t=>!t.isDeclarationFile&&!e.isSourceFileFromExternalLibrary(t)&&!!t.externalModuleIndicator)}function Tte(e){return!!e.module||ho(e)>=2||!!e.noEmit}function kx(e,t){return{fileExists:n=>e.fileExists(n),getCurrentDirectory:()=>t.getCurrentDirectory(),readFile:rs(t,t.readFile),useCaseSensitiveFileNames:rs(t,t.useCaseSensitiveFileNames),getSymlinkCache:rs(t,t.getSymlinkCache)||e.getSymlinkCache,getModuleSpecifierCache:rs(t,t.getModuleSpecifierCache),getPackageJsonInfoCache:()=>{var n;return(n=e.getModuleResolutionCache())==null?void 0:n.getPackageJsonInfoCache()},getGlobalTypingsCacheLocation:rs(t,t.getGlobalTypingsCacheLocation),redirectTargetsMap:e.redirectTargetsMap,getProjectReferenceRedirect:n=>e.getProjectReferenceRedirect(n),isSourceOfProjectReferenceRedirect:n=>e.isSourceOfProjectReferenceRedirect(n),getNearestAncestorDirectoryWithPackageJson:rs(t,t.getNearestAncestorDirectoryWithPackageJson),getFileIncludeReasons:()=>e.getFileIncludeReasons(),getCommonSourceDirectory:()=>e.getCommonSourceDirectory()}}function bte(e,t){return{...kx(e,t),getCommonSourceDirectory:()=>e.getCommonSourceDirectory()}}function dJ(e){return e===2||e>=3&&e<=99||e===100}function P1e(e,t,n,i){return e||t&&t.length?J1(e,t,n,i):void 0}function J1(e,t,n,i,s){return j.createImportDeclaration(void 0,e||t?j.createImportClause(!!s,e,t&&t.length?j.createNamedImports(t):void 0):void 0,typeof n=="string"?vk(n,i):n,void 0)}function vk(e,t){return j.createStringLiteral(e,t===0)}function Ete(e,t){return pj(e,t)?1:0}function _d(e,t){if(t.quotePreference&&t.quotePreference!=="auto")return t.quotePreference==="single"?0:1;{let n=e.imports&&mr(e.imports,i=>za(i)&&!_c(i.parent));return n?Ete(n,e):1}}function xte(e){switch(e){case 0:return"'";case 1:return'"';default:return I.assertNever(e)}}function mJ(e){let t=gJ(e);return t===void 0?void 0:Zi(t)}function gJ(e){return e.escapedName!=="default"?e.escapedName:Ct(e.declarations,t=>{let n=qs(t);return n&&n.kind===80?n.escapedText:void 0})}function hJ(e){return bo(e)&&(zh(e.parent)||uu(e.parent)||_f(e.parent,!1)&&e.parent.arguments[0]===e||Up(e.parent)&&e.parent.arguments[0]===e)}function i7(e){return co(e)&&pm(e.parent)&&ze(e.name)&&!e.propertyName}function yJ(e,t){let n=e.getTypeAtLocation(t.parent);return n&&e.getPropertyOfType(n,t.name.text)}function s7(e,t,n){if(e)for(;e.parent;){if(ls(e.parent)||!iEt(n,e.parent,t))return e;e=e.parent}}function iEt(e,t,n){return YH(e,t.getStart(n))&&t.getEnd()<=gl(e)}function xD(e,t){return Jm(e)?mr(e.modifiers,n=>n.kind===t):void 0}function AO(e,t,n,i,s){let l=(os(n)?n[0]:n).kind===243?WY:q2,p=Fn(t.statements,l),m=os(n)?$m.detectImportDeclarationSorting(n,s):3,S=$m.getOrganizeImportsComparer(s,m===2),h=os(n)?cu(n,(b,A)=>$m.compareImportsOrRequireStatements(b,A,S)):[n];if(!p.length)e.insertNodesAtTopOfFile(t,h,i);else if(p&&(m=$m.detectImportDeclarationSorting(p,s))){let b=$m.getOrganizeImportsComparer(s,m===2);for(let A of h){let k=$m.getImportDeclarationInsertionIndex(p,A,b);if(k===0){let N=p[0]===t.statements[0]?{leadingTriviaOption:En.LeadingTriviaOption.Exclude}:{};e.insertNodeBefore(t,p[0],A,!1,N)}else{let N=p[k-1];e.insertNodeAfter(t,N,A)}}}else{let b=Is(p);b?e.insertNodesAfter(t,b,h):e.insertNodesAtTopOfFile(t,h,i)}}function Cte(e,t){return I.assert(e.isTypeOnly),ta(e.getChildAt(0,t),vte)}function CD(e,t){return!!e&&!!t&&e.start===t.start&&e.length===t.length}function Ate(e,t,n){return(n?Av:S1)(e.fileName,t.fileName)&&CD(e.textSpan,t.textSpan)}function kte(e){return(t,n)=>Ate(t,n,e)}function Pte(e,t){if(e){for(let n=0;n<e.length;n++)if(e.indexOf(e[n])===n){let i=t(e[n],n);if(i)return i}}}function N1e(e,t,n){for(let i=t;i<n;i++)if(!Sy(e.charCodeAt(i)))return!1;return!0}function kO(e,t,n){let i=t.tryGetSourcePosition(e);return i&&(!n||n(Ca(i.fileName))?i:void 0)}function vJ(e,t,n){let{fileName:i,textSpan:s}=e,o=kO({fileName:i,pos:s.start},t,n);if(!o)return;let l=kO({fileName:i,pos:s.start+s.length},t,n),p=l?l.pos-o.pos:s.length;return{fileName:o.fileName,textSpan:{start:o.pos,length:p},originalFileName:e.fileName,originalTextSpan:e.textSpan,contextSpan:Nte(e,t,n),originalContextSpan:e.contextSpan}}function Nte(e,t,n){let i=e.contextSpan&&kO({fileName:e.fileName,pos:e.contextSpan.start},t,n),s=e.contextSpan&&kO({fileName:e.fileName,pos:e.contextSpan.start+e.contextSpan.length},t,n);return i&&s?{start:i.pos,length:s.pos-i.pos}:void 0}function Dte(e){let t=e.declarations?qi(e.declarations):void 0;return!!Gr(t,n=>Ls(n)?!0:co(n)||pm(n)||cE(n)?!1:"quit")}function sEt(){let e=mR*10,t,n,i,s;h();let o=b=>p(b,17);return{displayParts:()=>{let b=t.length&&t[t.length-1].text;return s>e&&b&&b!=="..."&&(Sy(b.charCodeAt(b.length-1))||t.push(Yf(" ",16)),t.push(Yf("...",15))),t},writeKeyword:b=>p(b,5),writeOperator:b=>p(b,12),writePunctuation:b=>p(b,15),writeTrailingSemicolon:b=>p(b,15),writeSpace:b=>p(b,16),writeStringLiteral:b=>p(b,8),writeParameter:b=>p(b,13),writeProperty:b=>p(b,14),writeLiteral:b=>p(b,8),writeSymbol:m,writeLine:S,write:o,writeComment:o,getText:()=>"",getTextPos:()=>0,getColumn:()=>0,getLine:()=>0,isAtStartOfLine:()=>!1,hasTrailingWhitespace:()=>!1,hasTrailingComment:()=>!1,rawWrite:Ks,getIndent:()=>i,increaseIndent:()=>{i++},decreaseIndent:()=>{i--},clear:h};function l(){if(!(s>e)&&n){let b=Ej(i);b&&(s+=b.length,t.push(Yf(b,16))),n=!1}}function p(b,A){s>e||(l(),s+=b.length,t.push(Yf(b,A)))}function m(b,A){s>e||(l(),s+=b.length,t.push(D1e(b,A)))}function S(){s>e||(s+=1,t.push(AD()),n=!0)}function h(){t=[],n=!0,i=0,s=0}}function D1e(e,t){return Yf(e,n(t));function n(i){let s=i.flags;return s&3?Dte(i)?13:9:s&4||s&32768||s&65536?14:s&8?19:s&16?20:s&32?1:s&64?4:s&384?2:s&1536?11:s&8192?10:s&262144?18:s&524288||s&2097152?0:17}}function Yf(e,t){return{text:e,kind:qM[t]}}function Qc(){return Yf(" ",16)}function gp(e){return Yf(Sa(e),5)}function F_(e){return Yf(Sa(e),15)}function PO(e){return Yf(Sa(e),12)}function I1e(e){return Yf(e,13)}function w1e(e){return Yf(e,14)}function Ite(e){let t=Fb(e);return t===void 0?fd(e):gp(t)}function fd(e){return Yf(e,17)}function O1e(e){return Yf(e,0)}function R1e(e){return Yf(e,18)}function SJ(e){return Yf(e,24)}function M1e(e,t){return{text:e,kind:qM[23],target:{fileName:Xr(t).fileName,textSpan:gf(t)}}}function wte(e){return Yf(e,22)}function L1e(e,t){var n;let i=Oge(e)?"link":Rge(e)?"linkcode":"linkplain",s=[wte(`{@${i} `)];if(!e.name)e.text&&s.push(SJ(e.text));else{let o=t?.getSymbolAtLocation(e.name),l=o&&t?Mte(o,t):void 0,p=oEt(e.text),m=Fl(e.name)+e.text.slice(0,p),S=aEt(e.text.slice(p)),h=l?.valueDeclaration||((n=l?.declarations)==null?void 0:n[0]);if(h)s.push(M1e(m,h)),S&&s.push(SJ(S));else{let b=p===0||e.text.charCodeAt(p)===124&&m.charCodeAt(m.length-1)!==32?" ":"";s.push(SJ(m+b+S))}}return s.push(wte("}")),s}function aEt(e){let t=0;if(e.charCodeAt(t++)===124){for(;t<e.length&&e.charCodeAt(t)===32;)t++;return e.slice(t)}return e}function oEt(e){let t=e.indexOf("://");if(t===0){for(;t<e.length&&e.charCodeAt(t)!==124;)t++;return t}if(e.indexOf("()")===0)return 2;if(e.charAt(0)==="<"){let n=0,i=0;for(;i<e.length;)if(e[i]==="<"&&n++,e[i]===">"&&n--,i++,!n)return i}return 0}function q1(e,t){var n;return t?.newLineCharacter||((n=e.getNewLine)==null?void 0:n.call(e))||SLe}function AD(){return Yf(`
`,6)}function oS(e){try{return e(Qte),Qte.displayParts()}finally{Qte.clear()}}function a7(e,t,n,i=0){return oS(s=>{e.writeType(t,n,i|1024|16384,s)})}function NO(e,t,n,i,s=0){return oS(o=>{e.writeSymbol(t,n,i,s|8,o)})}function Ote(e,t,n,i=0){return i|=25632,oS(s=>{e.writeSignature(t,n,i,void 0,s)})}function fLe(e,t){let n=t.getSourceFile();return oS(i=>{kM().writeNode(4,e,n,i)})}function F1e(e){return!!e.parent&&hA(e.parent)&&e.parent.propertyName===e}function Rte(e,t){return Zj(e,t.getScriptKind&&t.getScriptKind(e))}function Mte(e,t){let n=e;for(;cEt(n)||Rh(n)&&n.links.target;)Rh(n)&&n.links.target?n=n.links.target:n=r_(n,t);return n}function cEt(e){return(e.flags&2097152)!==0}function j1e(e,t){return Ia(r_(e,t))}function B1e(e,t){for(;Sy(e.charCodeAt(t));)t+=1;return t}function TJ(e,t){for(;t>-1&&Vg(e.charCodeAt(t));)t-=1;return t+1}function Sc(e,t=!0){let n=e&&pLe(e);return n&&!t&&hp(n),n}function o7(e,t,n){let i=n(e);return i?Un(i,e):i=pLe(e,n),i&&!t&&hp(i),i}function pLe(e,t){let n=t?o=>o7(o,!0,t):Sc,s=wr(e,n,void 0,t?o=>o&&Lte(o,!0,t):o=>o&&kE(o),n);if(s===e){let o=za(e)?Un(j.createStringLiteralFromNode(e),e):_p(e)?Un(j.createNumericLiteral(e.text,e.numericLiteralFlags),e):j.cloneNode(e);return ft(o,e)}return s.parent=void 0,s}function kE(e,t=!0){if(e){let n=j.createNodeArray(e.map(i=>Sc(i,t)),e.hasTrailingComma);return ft(n,e),n}return e}function Lte(e,t,n){return j.createNodeArray(e.map(i=>o7(i,t,n)),e.hasTrailingComma)}function hp(e){Fte(e),U1e(e)}function Fte(e){V1e(e,1024,uEt)}function U1e(e){V1e(e,2048,OX)}function Px(e,t){let n=e.getSourceFile(),i=n.text;lEt(e,i)?kD(e,t,n):l7(e,t,n),DO(e,t,n)}function lEt(e,t){let n=e.getFullStart(),i=e.getStart();for(let s=n;s<i;s++)if(t.charCodeAt(s)===10)return!0;return!1}function V1e(e,t,n){Kg(e,t);let i=n(e);i&&V1e(i,t,n)}function uEt(e){return e.forEachChild(t=>t)}function Nx(e,t){let n=e;for(let i=1;!q9(t,n);i++)n=`${e}_${i}`;return n}function c7(e,t,n,i){let s=0,o=-1;for(let{fileName:l,textChanges:p}of e){I.assert(l===t);for(let m of p){let{span:S,newText:h}=m,b=_Et(h,D0(n));if(b!==-1&&(o=S.start+s+b,!i))return o;s+=h.length-S.length}}return I.assert(i),I.assert(o>=0),o}function kD(e,t,n,i,s){q3(n.text,e.pos,J1e(t,n,i,s,w6))}function DO(e,t,n,i,s){z3(n.text,e.end,J1e(t,n,i,s,bB))}function l7(e,t,n,i,s){z3(n.text,e.pos,J1e(t,n,i,s,w6))}function J1e(e,t,n,i,s){return(o,l,p,m)=>{p===3?(o+=2,l-=2):o+=2,s(e,n||p,t.text.slice(o,l),i!==void 0?i:m)}}function _Et(e,t){if(Ss(e,t))return 0;let n=e.indexOf(" "+t);return n===-1&&(n=e.indexOf("."+t)),n===-1&&(n=e.indexOf('"'+t)),n===-1?-1:n+1}function bJ(e){return bn(e)&&e.operatorToken.kind===28||Ha(e)||(FR(e)||LK(e))&&Ha(e.expression)}function EJ(e,t,n){let i=P1(e.parent);switch(i.kind){case 214:return t.getContextualType(i,n);case 226:{let{left:s,operatorToken:o,right:l}=i;return xJ(o.kind)?t.getTypeAtLocation(e===l?s:l):t.getContextualType(e,n)}case 296:return Bte(i,t);default:return t.getContextualType(e,n)}}function IO(e,t,n){let i=_d(e,t),s=JSON.stringify(n);return i===0?`'${cm(s).replace(/'/g,()=>"\\'").replace(/\\"/g,'"')}'`:s}function xJ(e){switch(e){case 37:case 35:case 38:case 36:return!0;default:return!1}}function q1e(e){switch(e.kind){case 11:case 15:case 228:case 215:return!0;default:return!1}}function jte(e){return!!e.getStringIndexType()||!!e.getNumberIndexType()}function Bte(e,t){return t.getTypeAtLocation(e.parent.parent.expression)}function wO(e,t,n,i){let s=n.getTypeChecker(),o=!0,l=()=>o=!1,p=s.typeToTypeNode(e,t,1,{trackSymbol:(m,S,h)=>(o=o&&s.isSymbolAccessible(m,S,h,!1).accessibility===0,!o),reportInaccessibleThisError:l,reportPrivateInBaseOfClassExpression:l,reportInaccessibleUniqueSymbolError:l,moduleResolverHost:bte(n,i)});return o?p:void 0}function z1e(e){return e===179||e===180||e===181||e===171||e===173}function dLe(e){return e===262||e===176||e===174||e===177||e===178}function mLe(e){return e===267}function CJ(e){return e===243||e===244||e===246||e===251||e===252||e===253||e===257||e===259||e===172||e===265||e===272||e===271||e===278||e===270||e===277}function fEt(e,t){let n=e.getLastToken(t);if(n&&n.kind===27)return!1;if(z1e(e.kind)){if(n&&n.kind===28)return!1}else if(mLe(e.kind)){let p=Rs(e.getChildren(t));if(p&&Zg(p))return!1}else if(dLe(e.kind)){let p=Rs(e.getChildren(t));if(p&&Wb(p))return!1}else if(!CJ(e.kind))return!1;if(e.kind===246)return!0;let i=Gr(e,p=>!p.parent),s=AE(e,i,t);if(!s||s.kind===20)return!0;let o=t.getLineAndCharacterOfPosition(e.getEnd()).line,l=t.getLineAndCharacterOfPosition(s.getStart(t)).line;return o!==l}function AJ(e,t,n){let i=Gr(t,s=>s.end!==e?"quit":Zte(s.kind));return!!i&&fEt(i,n)}function u7(e){let t=0,n=0,i=5;return Qs(e,function s(o){if(CJ(o.kind)){let l=o.getLastToken(e);l?.kind===27?t++:n++}else if(z1e(o.kind)){let l=o.getLastToken(e);if(l?.kind===27)t++;else if(l&&l.kind!==28){let p=Lo(e,l.getStart(e)).line,m=Lo(e,Fh(e,l.end).start).line;p!==m&&n++}}return t+n>=i?!0:Qs(o,s)}),t===0&&n<=1?!0:t/n>1/i}function kJ(e,t){return DJ(e,e.getDirectories,t)||[]}function Ute(e,t,n,i,s){return DJ(e,e.readDirectory,t,n,i,s)||tt}function _7(e,t){return DJ(e,e.fileExists,t)}function PJ(e,t){return NJ(()=>lg(t,e))||!1}function NJ(e){try{return e()}catch{return}}function DJ(e,t,...n){return NJ(()=>t&&t.apply(e,n))}function Vte(e,t,n){let i=[];return Rm(e,s=>{if(s===n)return!0;let o=li(s,"package.json");_7(t,o)&&i.push(o)}),i}function $1e(e,t){let n;return Rm(e,i=>{if(i==="node_modules"||(n=eye(i,s=>_7(t,s),"package.json"),n))return!0}),n}function W1e(e,t){if(!t.fileExists)return[];let n=[];return Rm(hi(e),i=>{let s=li(i,"package.json");if(t.fileExists(s)){let o=Jte(s,t);o&&n.push(o)}}),n}function Jte(e,t){if(!t.readFile)return;let n=["dependencies","devDependencies","optionalDependencies","peerDependencies"],i=t.readFile(e)||"",s=Lj(i),o={};if(s)for(let m of n){let S=s[m];if(!S)continue;let h=new Map;for(let b in S)h.set(b,S[b]);o[m]=h}let l=[[1,o.dependencies],[2,o.devDependencies],[8,o.optionalDependencies],[4,o.peerDependencies]];return{...o,parseable:!!s,fileName:e,get:p,has(m,S){return!!p(m,S)}};function p(m,S=15){for(let[h,b]of l)if(b&&S&h){let A=b.get(m);if(A!==void 0)return A}}}function OO(e,t,n){let i=(n.getPackageJsonsVisibleToFile&&n.getPackageJsonsVisibleToFile(e.fileName)||W1e(e.fileName,n)).filter(N=>N.parseable),s,o,l;return{allowsImportingAmbientModule:m,allowsImportingSourceFile:S,allowsImportingSpecifier:h};function p(N){let M=k(N);for(let O of i)if(O.has(M)||O.has(zU(M)))return!0;return!1}function m(N,M){if(!i.length||!N.valueDeclaration)return!0;if(!o)o=new Map;else{let re=o.get(N);if(re!==void 0)return re}let O=cm(N.getName());if(b(O))return o.set(N,!0),!0;let U=N.valueDeclaration.getSourceFile(),H=A(U.fileName,M);if(typeof H>"u")return o.set(N,!0),!0;let K=p(H)||p(O);return o.set(N,K),K}function S(N,M){if(!i.length)return!0;if(!l)l=new Map;else{let H=l.get(N);if(H!==void 0)return H}let O=A(N.fileName,M);if(!O)return l.set(N,!0),!0;let U=p(O);return l.set(N,U),U}function h(N){return!i.length||b(N)||Fp(N)||ap(N)?!0:p(N)}function b(N){return!!(Y_(e)&&sh.nodeCoreModules.has(N)&&(s===void 0&&(s=IJ(e)),s))}function A(N,M){if(!N.includes("node_modules"))return;let O=SE.getNodeModulesPackageName(n.getCompilationSettings(),e,N,M,t);if(O&&!Fp(O)&&!ap(O))return k(O)}function k(N){let M=gu(nO(N)).slice(1);return Ss(M[0],"@")?`${M[0]}/${M[1]}`:M[0]}}function IJ(e){return Tt(e.imports,({text:t})=>sh.nodeCoreModules.has(t))}function f7(e){return hs(gu(e),"node_modules")}function qte(e){return e.file!==void 0&&e.start!==void 0&&e.length!==void 0}function G1e(e,t){let n=gf(e),i=nT(t,n,Mo,iT);if(i>=0){let s=t[i];return I.assertEqual(s.file,e.getSourceFile(),"Diagnostics proided to 'findDiagnosticForNode' must be from a single SourceFile"),ta(s,qte)}}function H1e(e,t){var n;let i=nT(t,e.start,l=>l.start,To);for(i<0&&(i=~i);((n=t[i-1])==null?void 0:n.start)===e.start;)i--;let s=[],o=gl(e);for(;;){let l=ii(t[i],qte);if(!l||l.start>o)break;Kfe(e,l)&&s.push(l),i++}return s}function Sk({startPosition:e,endPosition:t}){return Ll(e,t===void 0?e:t)}function zte(e,t){let n=Ts(e,t.start);return Gr(n,s=>s.getStart(e)<t.start||s.getEnd()>gl(t)?"quit":bt(s)&&CD(t,gf(s,e)))}function $te(e,t,n=Mo){return e?os(e)?n(vr(e,t)):t(e,0):void 0}function Wte(e){return os(e)?di(e):e}function Y1e(e,t){if(gLe(e)){let n=hLe(e);if(n)return n;let i=x_.moduleSymbolToValidIdentifier(X1e(e),t,!1),s=x_.moduleSymbolToValidIdentifier(X1e(e),t,!0);return i===s?i:[i,s]}return e.name}function wJ(e,t,n){return gLe(e)?hLe(e)||x_.moduleSymbolToValidIdentifier(X1e(e),t,!!n):e.name}function gLe(e){return!(e.flags&33554432)&&(e.escapedName==="export="||e.escapedName==="default")}function hLe(e){return Ct(e.declarations,t=>{var n,i,s;return Kc(t)?(n=ii(vl(t.expression),ze))==null?void 0:n.text:R_(t)&&t.symbol.flags===2097152?(i=ii(t.propertyName,ze))==null?void 0:i.text:(s=ii(qs(t),ze))==null?void 0:s.text})}function X1e(e){var t;return I.checkDefined(e.parent,`Symbol parent was undefined. Flags: ${I.formatSymbolFlags(e.flags)}. Declarations: ${(t=e.declarations)==null?void 0:t.map(n=>{let i=I.formatSyntaxKind(n.kind),s=gn(n),{expression:o}=n;return(s?"[JS]":"")+i+(o?` (expression: ${I.formatSyntaxKind(o.kind)})`:"")}).join(", ")}.`)}function K1e(e,t,n){let i=t.length;if(i+n>e.length)return!1;for(let s=0;s<i;s++)if(t.charCodeAt(s)!==e.charCodeAt(s+n))return!1;return!0}function Gte(e){return e.charCodeAt(0)===95}function yLe(e){return!Q1e(e)}function Q1e(e){let t=e.getSourceFile();return!t.externalModuleIndicator&&!t.commonJsModuleIndicator?!1:gn(e)||!Gr(e,n=>hl(n)&&zg(n))}function OJ(e){return!!(XH(e)&65536)}function RJ(e,t){return Ct(e.imports,i=>{if(sh.nodeCoreModules.has(i.text))return Ss(i.text,"node:")})??t.usesUriStyleNodeCoreModules}function p7(e){return e===`
`?1:0}function Dx(e){return os(e)?O0(Gs(e[0]),e.slice(1)):Gs(e)}function MJ({options:e},t){let n=!e.semicolons||e.semicolons==="ignore",i=e.semicolons==="remove"||n&&!u7(t);return{...e,semicolons:i?"remove":"ignore"}}function Hte(e){return e===2||e===3}function PD(e,t){return e.isSourceFileFromExternalLibrary(t)||e.isSourceFileDefaultLibrary(t)}function LJ(e,t){let n=new Set,i=new Set,s=new Set;for(let p of t)if(!q6(p)){let m=Do(p.expression);if(Ub(m))switch(m.kind){case 15:case 11:n.add(m.text);break;case 9:i.add(parseInt(m.text));break;case 10:let S=Lme(Mc(m.text,"n")?m.text.slice(0,-1):m.text);S&&s.add(nE(S));break}else{let S=e.getSymbolAtLocation(p.expression);if(S&&S.valueDeclaration&&gE(S.valueDeclaration)){let h=e.getConstantValue(S.valueDeclaration);h!==void 0&&o(h)}}}return{addValue:o,hasValue:l};function o(p){switch(typeof p){case"string":n.add(p);break;case"number":i.add(p)}}function l(p){switch(typeof p){case"string":return n.has(p);case"number":return i.has(p);case"object":return s.has(nE(p))}}}function Yte(e,t,n,i){var s;let o=typeof e=="string"?e:e.fileName;if(!rE(o))return!1;let l=t.getCompilerOptions(),p=T_(l),m=typeof e=="string"?RM(gc(e,n.getCurrentDirectory(),N1(n)),(s=t.getPackageJsonInfoCache)==null?void 0:s.call(t),n,l):e.impliedNodeFormat;if(m===99)return!1;if(m===1||l.verbatimModuleSyntax&&p===1)return!0;if(l.verbatimModuleSyntax&&zj(p))return!1;if(typeof e=="object"){if(e.commonJsModuleIndicator)return!0;if(e.externalModuleIndicator)return!1}return i}var j_,Xte,vLe,FJ,Kte,Qte,SLe,jJ,Zte,pEt=f({"src/services/utilities.ts"(){"use strict";yi(),j_=E1(99,!0),Xte=(e=>(e[e.None=0]="None",e[e.Value=1]="Value",e[e.Type=2]="Type",e[e.Namespace=4]="Namespace",e[e.All=7]="All",e))(Xte||{}),vLe=/^\/\/\/\s*</,FJ=[133,131,163,136,97,140,143,146,106,150,151,148,154,155,114,112,116,157,158,159],Kte=(e=>(e[e.Single=0]="Single",e[e.Double=1]="Double",e))(Kte||{}),Qte=sEt(),SLe=`
`,jJ="anonymous function",Zte=cg(z1e,dLe,mLe,CJ)}});function ere(e){let t=1,n=g_(),i=new Map,s=new Map,o,l={isUsableByFile:k=>k===o,isEmpty:()=>!n.size,clear:()=>{n.clear(),i.clear(),o=void 0},add:(k,N,M,O,U,H,K,re)=>{k!==o&&(l.clear(),o=k);let $;if(U){let ve=oB(U.fileName);if(ve){let{topLevelNodeModulesIndex:oe,topLevelPackageNameIndex:Ee,packageRootIndex:Me}=ve;if($=hM(nO(U.fileName.substring(Ee+1,Me))),Ss(k,U.path.substring(0,oe))){let Ge=s.get($),Ae=U.fileName.substring(0,Ee+1);if(Ge){let Ie=Ge.indexOf(Wh);oe>Ie&&s.set($,Ae)}else s.set($,Ae)}}}let z=H===1&&PN(N)||N,se=H===0||t7(z)?Zi(M):Y1e(z,void 0),Se=typeof se=="string"?se:se[0],xe=typeof se=="string"?void 0:se[1],Z=cm(O.name),Q=t++,ce=r_(N,re),ye=N.flags&33554432?void 0:N,we=O.flags&33554432?void 0:O;(!ye||!we)&&i.set(Q,[N,O]),n.add(m(Se,N,Nu(Z)?void 0:Z,re),{id:Q,symbolTableKey:M,symbolName:Se,capitalizedSymbolName:xe,moduleName:Z,moduleFile:U,moduleFileName:U?.fileName,packageName:$,exportKind:H,targetFlags:ce.flags,isFromPackageJson:K,symbol:ye,moduleSymbol:we})},get:(k,N)=>{if(k!==o)return;let M=n.get(N);return M?.map(p)},search:(k,N,M,O)=>{if(k===o)return yu(n,(U,H)=>{let{symbolName:K,ambientModuleName:re}=S(H),$=N&&U[0].capitalizedSymbolName||K;if(M($,U[0].targetFlags)){let z=U.map(p).filter((se,Se)=>A(se,U[Se].packageName));if(z.length){let se=O(z,$,!!re,H);if(se!==void 0)return se}}})},releaseSymbols:()=>{i.clear()},onFileChanged:(k,N,M)=>h(k)&&h(N)?!1:o&&o!==N.path||M&&IJ(k)!==IJ(N)||!td(k.moduleAugmentations,N.moduleAugmentations)||!b(k,N)?(l.clear(),!0):(o=N.path,!1)};return I.isDebugging&&Object.defineProperty(l,"__cache",{value:n}),l;function p(k){if(k.symbol&&k.moduleSymbol)return k;let{id:N,exportKind:M,targetFlags:O,isFromPackageJson:U,moduleFileName:H}=k,[K,re]=i.get(N)||tt;if(K&&re)return{symbol:K,moduleSymbol:re,moduleFileName:H,exportKind:M,targetFlags:O,isFromPackageJson:U};let $=(U?e.getPackageJsonAutoImportProvider():e.getCurrentProgram()).getTypeChecker(),pe=k.moduleSymbol||re||I.checkDefined(k.moduleFile?$.getMergedSymbol(k.moduleFile.symbol):$.tryFindAmbientModule(k.moduleName)),z=k.symbol||K||I.checkDefined(M===2?$.resolveExternalModuleSymbol(pe):$.tryGetMemberInModuleExportsAndProperties(Zi(k.symbolTableKey),pe),`Could not find symbol '${k.symbolName}' by key '${k.symbolTableKey}' in module ${pe.name}`);return i.set(N,[z,pe]),{symbol:z,moduleSymbol:pe,moduleFileName:H,exportKind:M,targetFlags:O,isFromPackageJson:U}}function m(k,N,M,O){let U=M||"";return`${k.length} ${Ia(r_(N,O))} ${k} ${U}`}function S(k){let N=k.indexOf(" "),M=k.indexOf(" ",N+1),O=parseInt(k.substring(0,N),10),U=k.substring(M+1),H=U.substring(0,O),K=U.substring(O+1);return{symbolName:H,ambientModuleName:K===""?void 0:K}}function h(k){return!k.commonJsModuleIndicator&&!k.externalModuleIndicator&&!k.moduleAugmentations&&!k.ambientModuleNames}function b(k,N){if(!td(k.ambientModuleNames,N.ambientModuleNames))return!1;let M=-1,O=-1;for(let U of N.ambientModuleNames){let H=K=>PY(K)&&K.name.text===U;if(M=oa(k.statements,H,M+1),O=oa(N.statements,H,O+1),k.statements[M]!==N.statements[O])return!1}return!0}function A(k,N){if(!N||!k.moduleFileName)return!0;let M=e.getGlobalTypingsCacheLocation();if(M&&Ss(k.moduleFileName,M))return!0;let O=s.get(N);return!O||Ss(k.moduleFileName,O)}}function tre(e,t,n,i,s,o,l){var p;if(t===n)return!1;let m=l?.get(t.path,n.path,i,{});if(m?.isBlockedByPackageJsonDependencies!==void 0)return!m.isBlockedByPackageJsonDependencies;let S=N1(o),h=(p=o.getGlobalTypingsCacheLocation)==null?void 0:p.call(o),b=!!SE.forEachFileNameOfModule(t.fileName,n.fileName,o,!1,A=>{let k=e.getSourceFile(A);return(k===n||!k)&&dEt(t.fileName,A,S,h)});if(s){let A=b&&s.allowsImportingSourceFile(n,o);return l?.setBlockedByPackageJsonDependencies(t.path,n.path,i,{},!A),A}return b}function dEt(e,t,n,i){let s=Rm(t,l=>Cl(l)==="node_modules"?l:void 0),o=s&&hi(n(s));return o===void 0||Ss(n(e),o)||!!i&&Ss(n(i),o)}function rre(e,t,n,i,s){var o,l;let p=AN(t),m=n.autoImportFileExcludePatterns&&Wi(n.autoImportFileExcludePatterns,h=>{let b=Kj(h,"","exclude");return b?$v(b,p):void 0});TLe(e.getTypeChecker(),e.getSourceFiles(),m,t,(h,b)=>s(h,b,e,!1));let S=i&&((o=t.getPackageJsonAutoImportProvider)==null?void 0:o.call(t));if(S){let h=uc(),b=e.getTypeChecker();TLe(S.getTypeChecker(),S.getSourceFiles(),m,t,(A,k)=>{(k&&!e.getSourceFile(k.fileName)||!k&&!b.resolveName(A.name,void 0,1536,!1))&&s(A,k,S,!0)}),(l=t.log)==null||l.call(t,`forEachExternalModuleToImportFrom autoImportProvider: ${uc()-h}`)}}function TLe(e,t,n,i,s){var o,l;let p=(o=i.getSymlinkCache)==null?void 0:o.call(i).getSymlinkedDirectoriesByRealpath(),m=n&&(({fileName:S,path:h})=>{if(n.some(b=>b.test(S)))return!0;if(p?.size&&OT(S)){let b=hi(S);return Rm(hi(h),A=>{let k=p.get(hu(A));if(k)return k.some(N=>n.some(M=>M.test(S.replace(b,N))));b=hi(b)})??!1}return!1});for(let S of e.getAmbientModules())!S.name.includes("*")&&!(n&&((l=S.declarations)!=null&&l.every(h=>m(h.getSourceFile()))))&&s(S,void 0);for(let S of t)Bp(S)&&!m?.(S)&&s(e.getMergedSymbol(S.symbol),S)}function d7(e,t,n,i,s){var o,l,p,m,S;let h=uc();(o=t.getPackageJsonAutoImportProvider)==null||o.call(t);let b=((l=t.getCachedExportInfoMap)==null?void 0:l.call(t))||ere({getCurrentProgram:()=>n,getPackageJsonAutoImportProvider:()=>{var N;return(N=t.getPackageJsonAutoImportProvider)==null?void 0:N.call(t)},getGlobalTypingsCacheLocation:()=>{var N;return(N=t.getGlobalTypingsCacheLocation)==null?void 0:N.call(t)}});if(b.isUsableByFile(e.path))return(p=t.log)==null||p.call(t,"getExportInfoMap: cache hit"),b;(m=t.log)==null||m.call(t,"getExportInfoMap: cache miss or empty; calculating new results");let A=n.getCompilerOptions(),k=0;try{rre(n,t,i,!0,(N,M,O,U)=>{++k%100===0&&s?.throwIfCancellationRequested();let H=new Map,K=O.getTypeChecker(),re=BJ(N,K,A);re&&bLe(re.symbol,K)&&b.add(e.path,re.symbol,re.exportKind===1?"default":"export=",N,M,re.exportKind,U,K),K.forEachExportAndPropertyOfModule(N,($,pe)=>{$!==re?.symbol&&bLe($,K)&&Bm(H,pe)&&b.add(e.path,$,pe,N,M,0,U,K)})})}catch(N){throw b.clear(),N}return(S=t.log)==null||S.call(t,`getExportInfoMap: done in ${uc()-h} ms`),b}function BJ(e,t,n){let i=mEt(e,t);if(!i)return;let{symbol:s,exportKind:o}=i,l=UJ(s,t,n);return l&&{symbol:s,exportKind:o,...l}}function bLe(e,t){return!t.isUndefinedSymbol(e)&&!t.isUnknownSymbol(e)&&!H8(e)&&!Mde(e)}function mEt(e,t){let n=t.resolveExternalModuleSymbol(e);if(n!==e)return{symbol:n,exportKind:2};let i=t.tryGetMemberInModuleExports("default",e);if(i)return{symbol:i,exportKind:1}}function UJ(e,t,n){let i=PN(e);if(i)return{resolvedSymbol:i,name:i.name};let s=gEt(e);if(s!==void 0)return{resolvedSymbol:e,name:s};if(e.flags&2097152){let o=t.getImmediateAliasedSymbol(e);if(o&&o.parent)return UJ(o,t,n)}return e.escapedName!=="default"&&e.escapedName!=="export="?{resolvedSymbol:e,name:e.getName()}:{resolvedSymbol:e,name:wJ(e,n.target)}}function gEt(e){return e.declarations&&Ct(e.declarations,t=>{var n;if(Kc(t))return(n=ii(vl(t.expression),ze))==null?void 0:n.text;if(R_(t))return I.assert(t.name.text==="default","Expected the specifier to be a default export"),t.propertyName&&t.propertyName.text})}var nre,ire,hEt=f({"src/services/exportInfoMap.ts"(){"use strict";yi(),nre=(e=>(e[e.Named=0]="Named",e[e.Default=1]="Default",e[e.Namespace=2]="Namespace",e[e.CommonJS=3]="CommonJS",e))(nre||{}),ire=(e=>(e[e.Named=0]="Named",e[e.Default=1]="Default",e[e.ExportEquals=2]="ExportEquals",e[e.UMD=3]="UMD",e))(ire||{})}});function ELe(){let e=E1(99,!1);function t(i,s,o){return SEt(n(i,s,o),i)}function n(i,s,o){let l=0,p=0,m=[],{prefix:S,pushTemplate:h}=EEt(s);i=S+i;let b=S.length;h&&m.push(16),e.setText(i);let A=0,k=[],N=0;do{l=e.scan(),TN(l)||(M(),p=l);let O=e.getTokenEnd();if(vEt(e.getTokenStart(),O,b,AEt(l),k),O>=i.length){let U=yEt(e,l,Is(m));U!==void 0&&(A=U)}}while(l!==1);function M(){switch(l){case 44:case 69:!kLe[p]&&e.reScanSlashToken()===14&&(l=14);break;case 30:p===80&&N++;break;case 32:N>0&&N--;break;case 133:case 154:case 150:case 136:case 155:N>0&&!o&&(l=80);break;case 16:m.push(l);break;case 19:m.length>0&&m.push(l);break;case 20:if(m.length>0){let O=Is(m);O===16?(l=e.reScanTemplateToken(!1),l===18?m.pop():I.assertEqual(l,17,"Should have been a template middle.")):(I.assertEqual(O,19,"Should have been an open brace"),m.pop())}break;default:if(!Nf(l))break;(p===25||Nf(p)&&Nf(l)&&!bEt(p,l))&&(l=80)}}return{endOfLineState:A,spans:k}}return{getClassificationsForLine:t,getEncodedLexicalClassifications:n}}function yEt(e,t,n){switch(t){case 11:{if(!e.isUnterminated())return;let i=e.getTokenText(),s=i.length-1,o=0;for(;i.charCodeAt(s-o)===92;)o++;return o&1?i.charCodeAt(0)===34?3:2:void 0}case 3:return e.isUnterminated()?1:void 0;default:if(Rv(t)){if(!e.isUnterminated())return;switch(t){case 18:return 5;case 15:return 4;default:return I.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #"+t)}}return n===16?6:void 0}}function vEt(e,t,n,i,s){if(i===8)return;e===0&&n>0&&(e+=n);let o=t-e;o>0&&s.push(e-n,o,i)}function SEt(e,t){let n=[],i=e.spans,s=0;for(let l=0;l<i.length;l+=3){let p=i[l],m=i[l+1],S=i[l+2];if(s>=0){let h=p-s;h>0&&n.push({length:h,classification:4})}n.push({length:m,classification:TEt(S)}),s=p+m}let o=t.length-s;return o>0&&n.push({length:o,classification:4}),{entries:n,finalLexState:e.endOfLineState}}function TEt(e){switch(e){case 1:return 3;case 3:return 1;case 4:return 6;case 25:return 7;case 5:return 2;case 6:return 8;case 8:return 4;case 10:return 0;case 2:case 11:case 12:case 13:case 14:case 15:case 16:case 9:case 17:return 5;default:return}}function bEt(e,t){if(!dte(e))return!0;switch(t){case 139:case 153:case 137:case 126:case 129:return!0;default:return!1}}function EEt(e){switch(e){case 3:return{prefix:`"\\
`};case 2:return{prefix:`'\\
`};case 1:return{prefix:`/*
`};case 4:return{prefix:"`\n"};case 5:return{prefix:`}
`,pushTemplate:!0};case 6:return{prefix:"",pushTemplate:!0};case 0:return{prefix:""};default:return I.assertNever(e)}}function xEt(e){switch(e){case 42:case 44:case 45:case 40:case 41:case 48:case 49:case 50:case 30:case 32:case 33:case 34:case 104:case 103:case 130:case 152:case 35:case 36:case 37:case 38:case 51:case 53:case 52:case 56:case 57:case 75:case 74:case 79:case 71:case 72:case 73:case 65:case 66:case 67:case 69:case 70:case 64:case 28:case 61:case 76:case 77:case 78:return!0;default:return!1}}function CEt(e){switch(e){case 40:case 41:case 55:case 54:case 46:case 47:return!0;default:return!1}}function AEt(e){if(Nf(e))return 3;if(xEt(e)||CEt(e))return 5;if(e>=19&&e<=79)return 10;switch(e){case 9:return 4;case 10:return 25;case 11:return 6;case 14:return 7;case 7:case 3:case 2:return 1;case 5:case 4:return 8;case 80:default:return Rv(e)?6:2}}function Z1e(e,t,n,i,s){return ALe(sre(e,t,n,i,s))}function xLe(e,t){switch(t){case 267:case 263:case 264:case 262:case 231:case 218:case 219:e.throwIfCancellationRequested()}}function sre(e,t,n,i,s){let o=[];return n.forEachChild(function p(m){if(!(!m||!v9(s,m.pos,m.getFullWidth()))){if(xLe(t,m.kind),ze(m)&&!sl(m)&&i.has(m.escapedText)){let S=e.getSymbolAtLocation(m),h=S&&CLe(S,Cx(m),e);h&&l(m.getStart(n),m.getEnd(),h)}m.forEachChild(p)}}),{spans:o,endOfLineState:0};function l(p,m,S){let h=m-p;I.assert(h>0,`Classification had non-positive length of ${h}`),o.push(p),o.push(h),o.push(S)}}function CLe(e,t,n){let i=e.getFlags();if(i&2885600)return i&32?11:i&384?12:i&524288?16:i&1536?t&4||t&1&&kEt(e)?14:void 0:i&2097152?CLe(n.getAliasedSymbol(e),t,n):t&2?i&64?13:i&262144?15:void 0:void 0}function kEt(e){return Tt(e.declarations,t=>hl(t)&&Oy(t)===1)}function PEt(e){switch(e){case 1:return"comment";case 2:return"identifier";case 3:return"keyword";case 4:return"number";case 25:return"bigint";case 5:return"operator";case 6:return"string";case 8:return"whitespace";case 9:return"text";case 10:return"punctuation";case 11:return"class name";case 12:return"enum name";case 13:return"interface name";case 14:return"module name";case 15:return"type parameter name";case 16:return"type alias name";case 17:return"parameter name";case 18:return"doc comment tag name";case 19:return"jsx open tag name";case 20:return"jsx close tag name";case 21:return"jsx self closing tag name";case 22:return"jsx attribute";case 23:return"jsx text";case 24:return"jsx attribute string literal value";default:return}}function ALe(e){I.assert(e.spans.length%3===0);let t=e.spans,n=[];for(let i=0;i<t.length;i+=3)n.push({textSpan:e_(t[i],t[i+1]),classificationType:PEt(t[i+2])});return n}function eve(e,t,n){return ALe(are(e,t,n))}function are(e,t,n){let i=n.start,s=n.length,o=E1(99,!1,t.languageVariant,t.text),l=E1(99,!1,t.languageVariant,t.text),p=[];return re(t),{spans:p,endOfLineState:0};function m($,pe,z){p.push($),p.push(pe),p.push(z)}function S($){for(o.resetTokenState($.pos);;){let pe=o.getTokenEnd();if(!Wfe(t.text,pe))return pe;let z=o.scan(),se=o.getTokenEnd(),Se=se-pe;if(!TN(z))return pe;switch(z){case 4:case 5:continue;case 2:case 3:h($,z,pe,Se),o.resetTokenState(se);continue;case 7:let xe=t.text,Z=xe.charCodeAt(pe);if(Z===60||Z===62){m(pe,Se,1);continue}I.assert(Z===124||Z===61),M(xe,pe,se);break;case 6:break;default:I.assertNever(z)}}}function h($,pe,z,se){if(pe===3){let Se=ohe(t.text,z,se);if(Se&&Se.jsDoc){io(Se.jsDoc,$),A(Se.jsDoc);return}}else if(pe===2&&k(z,se))return;b(z,se)}function b($,pe){m($,pe,1)}function A($){var pe,z,se,Se,xe,Z,Q,ce;let ye=$.pos;if($.tags)for(let ve of $.tags){ve.pos!==ye&&b(ye,ve.pos-ye),m(ve.pos,1,10),m(ve.tagName.pos,ve.tagName.end-ve.tagName.pos,18),ye=ve.tagName.end;let oe=ve.tagName.end;switch(ve.kind){case 348:let Ee=ve;we(Ee),oe=Ee.isNameFirst&&((pe=Ee.typeExpression)==null?void 0:pe.end)||Ee.name.end;break;case 355:let Me=ve;oe=Me.isNameFirst&&((z=Me.typeExpression)==null?void 0:z.end)||Me.name.end;break;case 352:N(ve),ye=ve.end,oe=ve.typeParameters.end;break;case 353:let Ge=ve;oe=((se=Ge.typeExpression)==null?void 0:se.kind)===316&&((Se=Ge.fullName)==null?void 0:Se.end)||((xe=Ge.typeExpression)==null?void 0:xe.end)||oe;break;case 345:oe=ve.typeExpression.end;break;case 351:re(ve.typeExpression),ye=ve.end,oe=ve.typeExpression.end;break;case 350:case 347:oe=ve.typeExpression.end;break;case 349:re(ve.typeExpression),ye=ve.end,oe=((Z=ve.typeExpression)==null?void 0:Z.end)||oe;break;case 354:oe=((Q=ve.name)==null?void 0:Q.end)||oe;break;case 335:case 336:oe=ve.class.end;break;case 356:re(ve.typeExpression),ye=ve.end,oe=((ce=ve.typeExpression)==null?void 0:ce.end)||oe;break}typeof ve.comment=="object"?b(ve.comment.pos,ve.comment.end-ve.comment.pos):typeof ve.comment=="string"&&b(oe,ve.end-oe)}ye!==$.end&&b(ye,$.end-ye);return;function we(ve){ve.isNameFirst&&(b(ye,ve.name.pos-ye),m(ve.name.pos,ve.name.end-ve.name.pos,17),ye=ve.name.end),ve.typeExpression&&(b(ye,ve.typeExpression.pos-ye),re(ve.typeExpression),ye=ve.typeExpression.end),ve.isNameFirst||(b(ye,ve.name.pos-ye),m(ve.name.pos,ve.name.end-ve.name.pos,17),ye=ve.name.end)}}function k($,pe){let z=/^(\/\/\/\s*)(<)(?:(\S+)((?:[^/]|\/[^>])*)(\/>)?)?/im,se=/(\s)(\S+)(\s*)(=)(\s*)('[^']+'|"[^"]+")/img,Se=t.text.substr($,pe),xe=z.exec(Se);if(!xe||!xe[3]||!(xe[3]in w3))return!1;let Z=$;b(Z,xe[1].length),Z+=xe[1].length,m(Z,xe[2].length,10),Z+=xe[2].length,m(Z,xe[3].length,21),Z+=xe[3].length;let Q=xe[4],ce=Z;for(;;){let we=se.exec(Q);if(!we)break;let ve=Z+we.index+we[1].length;ve>ce&&(b(ce,ve-ce),ce=ve),m(ce,we[2].length,22),ce+=we[2].length,we[3].length&&(b(ce,we[3].length),ce+=we[3].length),m(ce,we[4].length,5),ce+=we[4].length,we[5].length&&(b(ce,we[5].length),ce+=we[5].length),m(ce,we[6].length,24),ce+=we[6].length}Z+=xe[4].length,Z>ce&&b(ce,Z-ce),xe[5]&&(m(Z,xe[5].length,10),Z+=xe[5].length);let ye=$+pe;return Z<ye&&b(Z,ye-Z),!0}function N($){for(let pe of $.getChildren())re(pe)}function M($,pe,z){let se;for(se=pe;se<z&&!I_($.charCodeAt(se));se++);for(m(pe,se-pe,1),l.resetTokenState(se);l.getTokenEnd()<z;)O()}function O(){let $=l.getTokenEnd(),pe=l.scan(),z=l.getTokenEnd(),se=K(pe);se&&m($,z-$,se)}function U($){if(dg($)||sl($))return!0;let pe=H($);if(!gA($)&&$.kind!==12&&pe===void 0)return!1;let z=$.kind===12?$.pos:S($),se=$.end-z;if(I.assert(se>=0),se>0){let Se=pe||K($.kind,$);Se&&m(z,se,Se)}return!0}function H($){switch($.parent&&$.parent.kind){case 286:if($.parent.tagName===$)return 19;break;case 287:if($.parent.tagName===$)return 20;break;case 285:if($.parent.tagName===$)return 21;break;case 291:if($.parent.name===$)return 22;break}}function K($,pe){if(Nf($))return 3;if(($===30||$===32)&&pe&&b1e(pe.parent))return 10;if(iX($)){if(pe){let z=pe.parent;if($===64&&(z.kind===260||z.kind===172||z.kind===169||z.kind===291)||z.kind===226||z.kind===224||z.kind===225||z.kind===227)return 5}return 10}else{if($===9)return 4;if($===10)return 25;if($===11)return pe&&pe.parent.kind===291?24:6;if($===14)return 6;if(Rv($))return 6;if($===12)return 23;if($===80){if(pe){switch(pe.parent.kind){case 263:return pe.parent.name===pe?11:void 0;case 168:return pe.parent.name===pe?15:void 0;case 264:return pe.parent.name===pe?13:void 0;case 266:return pe.parent.name===pe?12:void 0;case 267:return pe.parent.name===pe?14:void 0;case 169:return pe.parent.name===pe?eE(pe)?3:17:void 0}if(Ty(pe.parent))return 3}return 2}}}function re($){if($&&H3(i,s,$.pos,$.getFullWidth())){xLe(e,$.kind);for(let pe of $.getChildren(t))U(pe)||re(pe)}}}var kLe,PLe=f({"src/services/classifier.ts"(){"use strict";yi(),kLe=Rp([80,11,9,10,14,110,46,47,22,24,20,112,97],e=>e,()=>!0)}}),VJ,NEt=f({"src/services/documentHighlights.ts"(){"use strict";yi(),(e=>{function t(Z,Q,ce,ye,we){let ve=If(ce,ye);if(ve.parent&&(eh(ve.parent)&&ve.parent.tagName===ve||fE(ve.parent))){let{openingElement:oe,closingElement:Ee}=ve.parent.parent,Me=[oe,Ee].map(({tagName:Ge})=>n(Ge,ce));return[{fileName:ce.fileName,highlightSpans:Me}]}return i(ye,ve,Z,Q,we)||s(ve,ce)}e.getDocumentHighlights=t;function n(Z,Q){return{fileName:Q.fileName,textSpan:gf(Z,Q),kind:"none"}}function i(Z,Q,ce,ye,we){let ve=new Set(we.map(Ge=>Ge.fileName)),oe=Ko.getReferenceEntriesForNode(Z,Q,ce,we,ye,void 0,ve);if(!oe)return;let Ee=_l(oe.map(Ko.toHighlightSpan),Ge=>Ge.fileName,Ge=>Ge.span),Me=y_(ce.useCaseSensitiveFileNames());return In(S0(Ee.entries(),([Ge,Ae])=>{if(!ve.has(Ge)){if(!ce.redirectTargetsMap.has(gc(Ge,ce.getCurrentDirectory(),Me)))return;let Ie=ce.getSourceFile(Ge);Ge=mr(we,Ue=>!!Ue.redirectInfo&&Ue.redirectInfo.redirectTarget===Ie).fileName,I.assert(ve.has(Ge))}return{fileName:Ge,highlightSpans:Ae}}))}function s(Z,Q){let ce=o(Z,Q);return ce&&[{fileName:Q.fileName,highlightSpans:ce}]}function o(Z,Q){switch(Z.kind){case 101:case 93:return ux(Z.parent)?se(Z.parent,Q):void 0;case 107:return ye(Z.parent,Um,re);case 111:return ye(Z.parent,jK,K);case 113:case 85:case 98:let ve=Z.kind===85?Z.parent.parent:Z.parent;return ye(ve,fx,H);case 109:return ye(Z.parent,U6,U);case 84:case 90:return q6(Z.parent)||WN(Z.parent)?ye(Z.parent.parent.parent,U6,U):void 0;case 83:case 88:return ye(Z.parent,Iw,O);case 99:case 117:case 92:return ye(Z.parent,oe=>Lv(oe,!0),M);case 137:return ce(Yc,[137]);case 139:case 153:return ce(Mv,[139,153]);case 135:return ye(Z.parent,Zv,$);case 134:return we($(Z));case 127:return we(pe(Z));case 103:case 147:return;default:return C1(Z.kind)&&(O_(Z.parent)||Xc(Z.parent))?we(A(Z.kind,Z.parent)):void 0}function ce(ve,oe){return ye(Z.parent,ve,Ee=>{var Me;return Wi((Me=ii(Ee,qg))==null?void 0:Me.symbol.declarations,Ge=>ve(Ge)?mr(Ge.getChildren(Q),Ae=>hs(oe,Ae.kind)):void 0)})}function ye(ve,oe,Ee){return oe(ve)?we(Ee(ve,Q)):void 0}function we(ve){return ve&&ve.map(oe=>n(oe,Q))}}function l(Z){return jK(Z)?[Z]:fx(Z)?ys(Z.catchClause?l(Z.catchClause):Z.tryBlock&&l(Z.tryBlock),Z.finallyBlock&&l(Z.finallyBlock)):ca(Z)?void 0:S(Z,l)}function p(Z){let Q=Z;for(;Q.parent;){let ce=Q.parent;if(Wb(ce)||ce.kind===312)return ce;if(fx(ce)&&ce.tryBlock===Q&&ce.catchClause)return Q;Q=ce}}function m(Z){return Iw(Z)?[Z]:ca(Z)?void 0:S(Z,m)}function S(Z,Q){let ce=[];return Z.forEachChild(ye=>{let we=Q(ye);we!==void 0&&ce.push(...Pm(we))}),ce}function h(Z,Q){let ce=b(Q);return!!ce&&ce===Z}function b(Z){return Gr(Z,Q=>{switch(Q.kind){case 255:if(Z.kind===251)return!1;case 248:case 249:case 250:case 247:case 246:return!Z.label||xe(Q,Z.label.escapedText);default:return ca(Q)&&"quit"}})}function A(Z,Q){return Wi(k(Q,IA(Z)),ce=>xD(ce,Z))}function k(Z,Q){let ce=Z.parent;switch(ce.kind){case 268:case 312:case 241:case 296:case 297:return Q&64&&eu(Z)?[...Z.members,Z]:ce.statements;case 176:case 174:case 262:return[...ce.parameters,...Ti(ce.parent)?ce.parent.members:[]];case 263:case 231:case 264:case 187:let ye=ce.members;if(Q&15){let we=mr(ce.members,Yc);if(we)return[...ye,...we.parameters]}else if(Q&64)return[...ye,ce];return ye;case 210:return;default:I.assertNever(ce,"Invalid container kind.")}}function N(Z,Q,...ce){return Q&&hs(ce,Q.kind)?(Z.push(Q),!0):!1}function M(Z){let Q=[];if(N(Q,Z.getFirstToken(),99,117,92)&&Z.kind===246){let ce=Z.getChildren();for(let ye=ce.length-1;ye>=0&&!N(Q,ce[ye],117);ye--);}return Te(m(Z.statement),ce=>{h(Z,ce)&&N(Q,ce.getFirstToken(),83,88)}),Q}function O(Z){let Q=b(Z);if(Q)switch(Q.kind){case 248:case 249:case 250:case 246:case 247:return M(Q);case 255:return U(Q)}}function U(Z){let Q=[];return N(Q,Z.getFirstToken(),109),Te(Z.caseBlock.clauses,ce=>{N(Q,ce.getFirstToken(),84,90),Te(m(ce),ye=>{h(Z,ye)&&N(Q,ye.getFirstToken(),83)})}),Q}function H(Z,Q){let ce=[];if(N(ce,Z.getFirstToken(),113),Z.catchClause&&N(ce,Z.catchClause.getFirstToken(),85),Z.finallyBlock){let ye=Oo(Z,98,Q);N(ce,ye,98)}return ce}function K(Z,Q){let ce=p(Z);if(!ce)return;let ye=[];return Te(l(ce),we=>{ye.push(Oo(we,111,Q))}),Wb(ce)&&$b(ce,we=>{ye.push(Oo(we,107,Q))}),ye}function re(Z,Q){let ce=Vp(Z);if(!ce)return;let ye=[];return $b(ta(ce.body,ra),we=>{ye.push(Oo(we,107,Q))}),Te(l(ce.body),we=>{ye.push(Oo(we,111,Q))}),ye}function $(Z){let Q=Vp(Z);if(!Q)return;let ce=[];return Q.modifiers&&Q.modifiers.forEach(ye=>{N(ce,ye,134)}),Qs(Q,ye=>{z(ye,we=>{Zv(we)&&N(ce,we.getFirstToken(),135)})}),ce}function pe(Z){let Q=Vp(Z);if(!Q)return;let ce=[];return Qs(Q,ye=>{z(ye,we=>{sU(we)&&N(ce,we.getFirstToken(),127)})}),ce}function z(Z,Q){Q(Z),!ca(Z)&&!Ti(Z)&&!ef(Z)&&!hl(Z)&&!Vm(Z)&&!es(Z)&&Qs(Z,ce=>z(ce,Q))}function se(Z,Q){let ce=Se(Z,Q),ye=[];for(let we=0;we<ce.length;we++){if(ce[we].kind===93&&we<ce.length-1){let ve=ce[we],oe=ce[we+1],Ee=!0;for(let Me=oe.getStart(Q)-1;Me>=ve.end;Me--)if(!Vg(Q.text.charCodeAt(Me))){Ee=!1;break}if(Ee){ye.push({fileName:Q.fileName,textSpan:Ll(ve.getStart(),oe.end),kind:"reference"}),we++;continue}}ye.push(n(ce[we],Q))}return ye}function Se(Z,Q){let ce=[];for(;ux(Z.parent)&&Z.parent.elseStatement===Z;)Z=Z.parent;for(;;){let ye=Z.getChildren(Q);N(ce,ye[0],101);for(let we=ye.length-1;we>=0&&!N(ce,ye[we],93);we--);if(!Z.elseStatement||!ux(Z.elseStatement))break;Z=Z.elseStatement}return ce}function xe(Z,Q){return!!Gr(Z.parent,ce=>_E(ce)?ce.label.escapedText===Q:"quit")}})(VJ||(VJ={}))}});function m7(e){return!!e.sourceFile}function tve(e,t,n){return ore(e,t,n)}function ore(e,t="",n,i){let s=new Map,o=y_(!!e);function l(){let O=In(s.keys()).filter(U=>U&&U.charAt(0)==="_").map(U=>{let H=s.get(U),K=[];return H.forEach((re,$)=>{m7(re)?K.push({name:$,scriptKind:re.sourceFile.scriptKind,refCount:re.languageServiceRefCount}):re.forEach((pe,z)=>K.push({name:$,scriptKind:z,refCount:pe.languageServiceRefCount}))}),K.sort((re,$)=>$.refCount-re.refCount),{bucket:U,sourceFiles:K}});return JSON.stringify(O,void 0,2)}function p(O){return typeof O.getCompilationSettings=="function"?O.getCompilationSettings():O}function m(O,U,H,K,re,$){let pe=gc(O,t,o),z=cre(p(U));return S(O,pe,U,z,H,K,re,$)}function S(O,U,H,K,re,$,pe,z){return k(O,U,H,K,re,$,!0,pe,z)}function h(O,U,H,K,re,$){let pe=gc(O,t,o),z=cre(p(U));return b(O,pe,U,z,H,K,re,$)}function b(O,U,H,K,re,$,pe,z){return k(O,U,p(H),K,re,$,!1,pe,z)}function A(O,U){let H=m7(O)?O:O.get(I.checkDefined(U,"If there are more than one scriptKind's for same document the scriptKind should be provided"));return I.assert(U===void 0||!H||H.sourceFile.scriptKind===U,`Script kind should match provided ScriptKind:${U} and sourceFile.scriptKind: ${H?.sourceFile.scriptKind}, !entry: ${!H}`),H}function k(O,U,H,K,re,$,pe,z,se){var Se,xe,Z,Q;z=Zj(O,z);let ce=p(H),ye=H===ce?void 0:H,we=z===6?100:ho(ce),ve=typeof se=="object"?se:{languageVersion:we,impliedNodeFormat:ye&&RM(U,(Q=(Z=(xe=(Se=ye.getCompilerHost)==null?void 0:Se.call(ye))==null?void 0:xe.getModuleResolutionCache)==null?void 0:Z.call(xe))==null?void 0:Q.getPackageJsonInfoCache(),ye,ce),setExternalModuleIndicator:aR(ce),jsDocParsingMode:n};ve.languageVersion=we,I.assertEqual(n,ve.jsDocParsingMode);let oe=s.size,Ee=rve(K,ve.impliedNodeFormat),Me=km(s,Ee,()=>new Map);if(mn){s.size>oe&&mn.instant(mn.Phase.Session,"createdDocumentRegistryBucket",{configFilePath:ce.configFilePath,key:Ee});let Re=!i_(U)&&yu(s,(Ue,kt)=>kt!==Ee&&Ue.has(U)&&kt);Re&&mn.instant(mn.Phase.Session,"documentRegistryBucketOverlap",{path:U,key1:Re,key2:Ee})}let Ge=Me.get(U),Ae=Ge&&A(Ge,z);if(!Ae&&i){let Re=i.getDocument(Ee,U);Re&&(I.assert(pe),Ae={sourceFile:Re,languageServiceRefCount:0},Ie())}if(Ae)Ae.sourceFile.version!==$&&(Ae.sourceFile=Xre(Ae.sourceFile,re,$,re.getChangeRange(Ae.sourceFile.scriptSnapshot)),i&&i.setDocument(Ee,U,Ae.sourceFile)),pe&&Ae.languageServiceRefCount++;else{let Re=fq(O,re,ve,$,!1,z);i&&i.setDocument(Ee,U,Re),Ae={sourceFile:Re,languageServiceRefCount:1},Ie()}return I.assert(Ae.languageServiceRefCount!==0),Ae.sourceFile;function Ie(){if(!Ge)Me.set(U,Ae);else if(m7(Ge)){let Re=new Map;Re.set(Ge.sourceFile.scriptKind,Ge),Re.set(z,Ae),Me.set(U,Re)}else Ge.set(z,Ae)}}function N(O,U,H,K){let re=gc(O,t,o),$=cre(U);return M(re,$,H,K)}function M(O,U,H,K){let re=I.checkDefined(s.get(rve(U,K))),$=re.get(O),pe=A($,H);pe.languageServiceRefCount--,I.assert(pe.languageServiceRefCount>=0),pe.languageServiceRefCount===0&&(m7($)?re.delete(O):($.delete(H),$.size===1&&re.set(O,Kt($.values(),Mo))))}return{acquireDocument:m,acquireDocumentWithKey:S,updateDocument:h,updateDocumentWithKey:b,releaseDocument:N,releaseDocumentWithKey:M,getKeyForCompilationSettings:cre,getDocumentRegistryBucketKeyWithMode:rve,reportStats:l,getBuckets:()=>s}}function cre(e){return MQ(e,IU)}function rve(e,t){return t?`${e}|${t}`:e}var DEt=f({"src/services/documentRegistry.ts"(){"use strict";yi()}});function nve(e,t,n,i,s,o,l){let p=AN(i),m=y_(p),S=lre(t,n,m,l),h=lre(n,t,m,l);return En.ChangeTracker.with({host:i,formatContext:s,preferences:o},b=>{wEt(e,b,S,t,n,i.getCurrentDirectory(),p),OEt(e,b,S,h,i,m)})}function lre(e,t,n,i){let s=n(e);return l=>{let p=i&&i.tryGetSourcePosition({fileName:l,pos:0}),m=o(p?p.fileName:l);return p?m===void 0?void 0:IEt(p.fileName,m,l,n):m};function o(l){if(n(l)===s)return t;let p=UX(l,s,n);return p===void 0?void 0:t+"/"+p}}function IEt(e,t,n,i){let s=j3(e,t,i);return ive(hi(n),s)}function wEt(e,t,n,i,s,o,l){let{configFile:p}=e.getCompilerOptions();if(!p)return;let m=hi(p.fileName),S=qw(p);if(!S)return;sve(S,(k,N)=>{switch(N){case"files":case"include":case"exclude":{if(h(k)||N!=="include"||!Z_(k.initializer))return;let O=Wi(k.initializer.elements,H=>za(H)?H.text:void 0);if(O.length===0)return;let U=Qj(m,[],O,l,o);$v(I.checkDefined(U.includeFilePattern),l).test(i)&&!$v(I.checkDefined(U.includeFilePattern),l).test(s)&&t.insertNodeAfter(p,Rs(k.initializer.elements),j.createStringLiteral(A(s)));return}case"compilerOptions":sve(k.initializer,(M,O)=>{let U=gQ(O);I.assert(U?.type!=="listOrElement"),U&&(U.isFilePath||U.type==="list"&&U.element.isFilePath)?h(M):O==="paths"&&sve(M.initializer,H=>{if(Z_(H.initializer))for(let K of H.initializer.elements)b(K)})});return}});function h(k){let N=Z_(k.initializer)?k.initializer.elements:[k.initializer],M=!1;for(let O of N)M=b(O)||M;return M}function b(k){if(!za(k))return!1;let N=ive(m,k.text),M=n(N);return M!==void 0?(t.replaceRangeWithText(p,DLe(k,p),A(M)),!0):!1}function A(k){return Om(m,k,!l)}}function OEt(e,t,n,i,s,o){let l=e.getSourceFiles();for(let p of l){let m=n(p.fileName),S=m??p.fileName,h=hi(S),b=i(p.fileName),A=b||p.fileName,k=hi(A),N=m!==void 0||b!==void 0;LEt(p,t,M=>{if(!Fp(M))return;let O=ive(k,M),U=n(O);return U===void 0?void 0:Lb(Om(h,U,o))},M=>{let O=e.getTypeChecker().getSymbolAtLocation(M);if(O?.declarations&&O.declarations.some(H=>S_(H)))return;let U=b!==void 0?NLe(M,aD(M.text,A,e.getCompilerOptions(),s),n,l):MEt(O,M,p,e,s,n);return U!==void 0&&(U.updated||N&&Fp(M.text))?SE.updateModuleSpecifier(e.getCompilerOptions(),p,S,U.newFileName,kx(e,s),M.text):void 0})}}function REt(e,t){return Ca(li(e,t))}function ive(e,t){return Lb(REt(e,t))}function MEt(e,t,n,i,s,o){if(e){let l=mr(e.declarations,ls).fileName,p=o(l);return p===void 0?{newFileName:l,updated:!1}:{newFileName:p,updated:!0}}else{let l=i.getModeForUsageLocation(n,t),p=s.resolveModuleNameLiterals||!s.resolveModuleNames?i.getResolvedModuleFromModuleSpecifier(t):s.getResolvedModuleWithFailedLookupLocationsFromCache&&s.getResolvedModuleWithFailedLookupLocationsFromCache(t.text,n.fileName,l);return NLe(t,p,o,i.getSourceFiles())}}function NLe(e,t,n,i){if(!t)return;if(t.resolvedModule){let m=p(t.resolvedModule.resolvedFileName);if(m)return m}let s=Te(t.failedLookupLocations,o)||Fp(e.text)&&Te(t.failedLookupLocations,l);if(s)return s;return t.resolvedModule&&{newFileName:t.resolvedModule.resolvedFileName,updated:!1};function o(m){let S=n(m);return S&&mr(i,h=>h.fileName===S)?l(m):void 0}function l(m){return Mc(m,"/package.json")?void 0:p(m)}function p(m){let S=n(m);return S&&{newFileName:S,updated:!0}}}function LEt(e,t,n,i){for(let s of e.referencedFiles||tt){let o=n(s.fileName);o!==void 0&&o!==e.text.slice(s.pos,s.end)&&t.replaceRangeWithText(e,s,o)}for(let s of e.imports){let o=i(s);o!==void 0&&o!==s.text&&t.replaceRangeWithText(e,DLe(s,e),o)}}function DLe(e,t){return kd(e.getStart(t)+1,e.end-1)}function sve(e,t){if(Ha(e))for(let n of e.properties)Ul(n)&&za(n.name)&&t(n,n.name.text)}var FEt=f({"src/services/getEditsForFileRename.ts"(){"use strict";yi()}});function RO(e,t){return{kind:e,isCaseSensitive:t}}function ave(e){let t=new Map,n=e.trim().split(".").map(i=>VEt(i.trim()));if(n.length===1&&n[0].totalTextChunk.text==="")return{getMatchForLastSegmentOfPattern:()=>RO(2,!0),getFullMatch:()=>RO(2,!0),patternContainsDots:!1};if(!n.some(i=>!i.subWordTextChunks.length))return{getFullMatch:(i,s)=>jEt(i,s,n,t),getMatchForLastSegmentOfPattern:i=>ove(i,Rs(n),t),patternContainsDots:n.length>1}}function jEt(e,t,n,i){if(!ove(t,Rs(n),i)||n.length-1>e.length)return;let o;for(let l=n.length-2,p=e.length-1;l>=0;l-=1,p-=1)o=OLe(o,ove(e[p],n[l],i));return o}function ILe(e,t){let n=t.get(e);return n||t.set(e,n=pve(e)),n}function wLe(e,t,n){let i=JEt(e,t.textLowerCase);if(i===0)return RO(t.text.length===e.length?0:1,Ss(e,t.text));if(t.isLowerCase){if(i===-1)return;let s=ILe(e,n);for(let o of s)if(cve(e,o,t.text,!0))return RO(2,cve(e,o,t.text,!1));if(t.text.length<e.length&&ND(e.charCodeAt(i)))return RO(2,!1)}else{if(e.indexOf(t.text)>0)return RO(2,!0);if(t.characterSpans.length>0){let s=ILe(e,n),o=RLe(e,s,t,!1)?!0:RLe(e,s,t,!0)?!1:void 0;if(o!==void 0)return RO(3,o)}}}function ove(e,t,n){if(ure(t.totalTextChunk.text,o=>o!==32&&o!==42)){let o=wLe(e,t.totalTextChunk,n);if(o)return o}let i=t.subWordTextChunks,s;for(let o of i)s=OLe(s,wLe(e,o,n));return s}function OLe(e,t){return MP([e,t],BEt)}function BEt(e,t){return e===void 0?1:t===void 0?-1:To(e.kind,t.kind)||hy(!e.isCaseSensitive,!t.isCaseSensitive)}function cve(e,t,n,i,s={start:0,length:n.length}){return s.length<=t.length&&jLe(0,s.length,o=>UEt(n.charCodeAt(s.start+o),e.charCodeAt(t.start+o),i))}function UEt(e,t,n){return n?lve(e)===lve(t):e===t}function RLe(e,t,n,i){let s=n.characterSpans,o=0,l=0,p,m;for(;;){if(l===s.length)return!0;if(o===t.length)return!1;let S=t[o],h=!1;for(;l<s.length;l++){let b=s[l];if(h&&(!ND(n.text.charCodeAt(s[l-1].start))||!ND(n.text.charCodeAt(s[l].start)))||!cve(e,S,n.text,i,b))break;h=!0,p=p===void 0?o:p,m=m===void 0?!0:m,S=e_(S.start+b.length,S.length-b.length)}!h&&m!==void 0&&(m=!1),o++}}function VEt(e){return{totalTextChunk:_ve(e),subWordTextChunks:zEt(e)}}function ND(e){if(e>=65&&e<=90)return!0;if(e<127||!d9(e,99))return!1;let t=String.fromCharCode(e);return t===t.toUpperCase()}function MLe(e){if(e>=97&&e<=122)return!0;if(e<127||!d9(e,99))return!1;let t=String.fromCharCode(e);return t===t.toLowerCase()}function JEt(e,t){let n=e.length-t.length;for(let i=0;i<=n;i++)if(ure(t,(s,o)=>lve(e.charCodeAt(o+i))===s))return i;return-1}function lve(e){return e>=65&&e<=90?97+(e-65):e<127?e:String.fromCharCode(e).toLowerCase().charCodeAt(0)}function uve(e){return e>=48&&e<=57}function qEt(e){return ND(e)||MLe(e)||uve(e)||e===95||e===36}function zEt(e){let t=[],n=0,i=0;for(let s=0;s<e.length;s++){let o=e.charCodeAt(s);qEt(o)?(i===0&&(n=s),i++):i>0&&(t.push(_ve(e.substr(n,i))),i=0)}return i>0&&t.push(_ve(e.substr(n,i))),t}function _ve(e){let t=e.toLowerCase();return{text:e,textLowerCase:t,isLowerCase:e===t,characterSpans:fve(e)}}function fve(e){return LLe(e,!1)}function pve(e){return LLe(e,!0)}function LLe(e,t){let n=[],i=0;for(let s=1;s<e.length;s++){let o=uve(e.charCodeAt(s-1)),l=uve(e.charCodeAt(s)),p=WEt(e,t,s),m=t&&$Et(e,s,i);(dve(e.charCodeAt(s-1))||dve(e.charCodeAt(s))||o!==l||p||m)&&(FLe(e,i,s)||n.push(e_(i,s-i)),i=s)}return FLe(e,i,e.length)||n.push(e_(i,e.length-i)),n}function dve(e){switch(e){case 33:case 34:case 35:case 37:case 38:case 39:case 40:case 41:case 42:case 44:case 45:case 46:case 47:case 58:case 59:case 63:case 64:case 91:case 92:case 93:case 95:case 123:case 125:return!0}return!1}function FLe(e,t,n){return ure(e,i=>dve(i)&&i!==95,t,n)}function $Et(e,t,n){return t!==n&&t+1<e.length&&ND(e.charCodeAt(t))&&MLe(e.charCodeAt(t+1))&&ure(e,ND,n,t)}function WEt(e,t,n){let i=ND(e.charCodeAt(n-1));return ND(e.charCodeAt(n))&&(!t||!i)}function jLe(e,t,n){for(let i=e;i<t;i++)if(!n(i))return!1;return!0}function ure(e,t,n=0,i=e.length){return jLe(n,i,s=>t(e.charCodeAt(s),s))}var JJ,GEt=f({"src/services/patternMatcher.ts"(){"use strict";yi(),JJ=(e=>(e[e.exact=0]="exact",e[e.prefix=1]="prefix",e[e.substring=2]="substring",e[e.camelCase=3]="camelCase",e))(JJ||{})}});function BLe(e,t=!0,n=!1){let i={languageVersion:1,pragmas:void 0,checkJsDirective:void 0,referencedFiles:[],typeReferenceDirectives:[],libReferenceDirectives:[],amdDependencies:[],hasNoDefaultLib:void 0,moduleName:void 0},s=[],o,l,p,m=0,S=!1;function h(){return l=p,p=j_.scan(),p===19?m++:p===20&&m--,p}function b(){let $=j_.getTokenValue(),pe=j_.getTokenStart();return{fileName:$,pos:pe,end:pe+$.length}}function A(){o||(o=[]),o.push({ref:b(),depth:m})}function k(){s.push(b()),N()}function N(){m===0&&(S=!0)}function M(){let $=j_.getToken();return $===138?($=h(),$===144&&($=h(),$===11&&A()),!0):!1}function O(){if(l===25)return!1;let $=j_.getToken();if($===102){if($=h(),$===21){if($=h(),$===11||$===15)return k(),!0}else{if($===11)return k(),!0;if($===156&&j_.lookAhead(()=>{let z=j_.scan();return z!==161&&(z===42||z===19||z===80||Nf(z))})&&($=h()),$===80||Nf($))if($=h(),$===161){if($=h(),$===11)return k(),!0}else if($===64){if(H(!0))return!0}else if($===28)$=h();else return!0;if($===19){for($=h();$!==20&&$!==1;)$=h();$===20&&($=h(),$===161&&($=h(),$===11&&k()))}else $===42&&($=h(),$===130&&($=h(),($===80||Nf($))&&($=h(),$===161&&($=h(),$===11&&k()))))}return!0}return!1}function U(){let $=j_.getToken();if($===95){if(N(),$=h(),$===156&&j_.lookAhead(()=>{let z=j_.scan();return z===42||z===19})&&($=h()),$===19){for($=h();$!==20&&$!==1;)$=h();$===20&&($=h(),$===161&&($=h(),$===11&&k()))}else if($===42)$=h(),$===161&&($=h(),$===11&&k());else if($===102&&($=h(),$===156&&j_.lookAhead(()=>{let z=j_.scan();return z===80||Nf(z)})&&($=h()),($===80||Nf($))&&($=h(),$===64&&H(!0))))return!0;return!0}return!1}function H($,pe=!1){let z=$?h():j_.getToken();return z===149?(z=h(),z===21&&(z=h(),(z===11||pe&&z===15)&&k()),!0):!1}function K(){let $=j_.getToken();if($===80&&j_.getTokenValue()==="define"){if($=h(),$!==21)return!0;if($=h(),$===11||$===15)if($=h(),$===28)$=h();else return!0;if($!==23)return!0;for($=h();$!==24&&$!==1;)($===11||$===15)&&k(),$=h();return!0}return!1}function re(){for(j_.setText(e),h();j_.getToken()!==1;){if(j_.getToken()===16){let $=[j_.getToken()];e:for(;de($);){let pe=j_.scan();switch(pe){case 1:break e;case 102:O();break;case 16:$.push(pe);break;case 19:de($)&&$.push(pe);break;case 20:de($)&&(Is($)===16?j_.reScanTemplateToken(!1)===18&&$.pop():$.pop());break}}h()}M()||O()||U()||n&&(H(!1,!0)||K())||h()}j_.setText(void 0)}if(t&&re(),uQ(i,e),_Q(i,ja),S){if(o)for(let $ of o)s.push($.ref);return{referencedFiles:i.referencedFiles,typeReferenceDirectives:i.typeReferenceDirectives,libReferenceDirectives:i.libReferenceDirectives,importedFiles:s,isLibFile:!!i.hasNoDefaultLib,ambientExternalModules:void 0}}else{let $;if(o)for(let pe of o)pe.depth===0?($||($=[]),$.push(pe.ref.fileName)):s.push(pe.ref);return{referencedFiles:i.referencedFiles,typeReferenceDirectives:i.typeReferenceDirectives,libReferenceDirectives:i.libReferenceDirectives,importedFiles:s,isLibFile:!!i.hasNoDefaultLib,ambientExternalModules:$}}}var HEt=f({"src/services/preProcess.ts"(){"use strict";yi()}});function mve(e){let t=y_(e.useCaseSensitiveFileNames()),n=e.getCurrentDirectory(),i=new Map,s=new Map;return{tryGetSourcePosition:p,tryGetGeneratedPosition:m,toLineColumnOffset:A,clearCache:k};function o(N){return gc(N,n,t)}function l(N,M){let O=o(N),U=s.get(O);if(U)return U;let H;if(e.getDocumentPositionMapper)H=e.getDocumentPositionMapper(N,M);else if(e.readFile){let K=b(N);H=K&&_re({getSourceFileLike:b,getCanonicalFileName:t,log:re=>e.log(re)},N,iZ(K.text,vy(K)),re=>!e.fileExists||e.fileExists(re)?e.readFile(re):void 0)}return s.set(O,H||rV),H||rV}function p(N){if(!i_(N.fileName)||!S(N.fileName))return;let O=l(N.fileName).getSourcePosition(N);return!O||O===N?void 0:p(O)||O}function m(N){if(i_(N.fileName))return;let M=S(N.fileName);if(!M)return;let O=e.getProgram();if(O.isSourceOfProjectReferenceRedirect(M.fileName))return;let U=O.getCompilerOptions(),H=Wo(U),K=H?ff(H)+".d.ts":Cj(N.fileName,O.getCompilerOptions(),n,O.getCommonSourceDirectory(),t);if(K===void 0)return;let re=l(K,N.fileName).getGeneratedPosition(N);return re===N?void 0:re}function S(N){let M=e.getProgram();if(!M)return;let O=o(N),U=M.getSourceFileByPath(O);return U&&U.resolvedPath===O?U:void 0}function h(N){let M=o(N),O=i.get(M);if(O!==void 0)return O||void 0;if(!e.readFile||e.fileExists&&!e.fileExists(N)){i.set(M,!1);return}let U=e.readFile(N),H=U?YEt(U):!1;return i.set(M,H),H||void 0}function b(N){return e.getSourceFileLike?e.getSourceFileLike(N):S(N)||h(N)}function A(N,M){return b(N).getLineAndCharacterOfPosition(M)}function k(){i.clear(),s.clear()}}function _re(e,t,n,i){let s=o0e(n);if(s){let p=VLe.exec(s);if(p){if(p[1]){let m=p[1];return ULe(e,ome(Zu,m),t)}s=void 0}}let o=[];s&&o.push(s),o.push(t+".map");let l=s&&Ps(s,hi(t));for(let p of o){let m=Ps(p,hi(t)),S=i(m,l);if(vs(S))return ULe(e,S,m);if(S!==void 0)return S||void 0}}function ULe(e,t,n){let i=sZ(t);if(!(!i||!i.sources||!i.file||!i.mappings)&&!(i.sourcesContent&&i.sourcesContent.some(vs)))return u0e(e,i,n)}function YEt(e,t){return{text:e,lineMap:t,getLineAndCharacterOfPosition(n){return zP(vy(this),n)}}}var VLe,XEt=f({"src/services/sourcemaps.ts"(){"use strict";yi(),VLe=/^data:(?:application\/json(?:;charset=[uU][tT][fF]-8);base64,([A-Za-z0-9+/=]+)$)?/}});function fre(e,t,n){var i;t.getSemanticDiagnostics(e,n);let s=[],o=t.getTypeChecker();!(e.impliedNodeFormat===1||Ql(e.fileName,[".cts",".cjs"]))&&e.commonJsModuleIndicator&&(k1e(t)||Tte(t.getCompilerOptions()))&&KEt(e)&&s.push($n(t2t(e.commonJsModuleIndicator),g.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module));let p=Y_(e);if(gre.clear(),m(e),ix(t.getCompilerOptions()))for(let S of e.imports){let h=Gw(S),b=QEt(h);if(!b)continue;let A=(i=t.getResolvedModuleFromModuleSpecifier(S))==null?void 0:i.resolvedModule,k=A&&t.getSourceFile(A.resolvedFileName);k&&k.externalModuleIndicator&&k.externalModuleIndicator!==!0&&Kc(k.externalModuleIndicator)&&k.externalModuleIndicator.isExportEquals&&s.push($n(b,g.Import_may_be_converted_to_a_default_import))}return jt(s,e.bindSuggestionDiagnostics),jt(s,t.getSuggestionDiagnostics(e,n)),s.sort((S,h)=>S.start-h.start);function m(S){if(p)n2t(S,o)&&s.push($n(Gi(S.parent)?S.parent.name:S,g.This_constructor_function_may_be_converted_to_a_class_declaration));else{if(Xc(S)&&S.parent===e&&S.declarationList.flags&2&&S.declarationList.declarations.length===1){let b=S.declarationList.declarations[0].initializer;b&&_f(b,!0)&&s.push($n(b,g.require_call_may_be_converted_to_an_import))}let h=x_.getJSDocTypedefNodes(S);for(let b of h)s.push($n(b,g.JSDoc_typedef_may_be_converted_to_TypeScript_type));x_.parameterShouldGetTypeFromJSDoc(S)&&s.push($n(S.name||S,g.JSDoc_types_may_be_moved_to_TypeScript_types))}mre(S)&&ZEt(S,o,s),S.forEachChild(m)}}function KEt(e){return e.statements.some(t=>{switch(t.kind){case 243:return t.declarationList.declarations.some(n=>!!n.initializer&&_f(JLe(n.initializer),!0));case 244:{let{expression:n}=t;if(!bn(n))return _f(n,!0);let i=al(n);return i===1||i===2}default:return!1}})}function JLe(e){return Hn(e)?JLe(e.expression):e}function QEt(e){switch(e.kind){case 272:let{importClause:t,moduleSpecifier:n}=e;return t&&!t.name&&t.namedBindings&&t.namedBindings.kind===274&&za(n)?t.namedBindings.name:void 0;case 271:return e.name;default:return}}function ZEt(e,t,n){e2t(e,t)&&!gre.has(WLe(e))&&n.push($n(!e.name&&Gi(e.parent)&&ze(e.parent.name)?e.parent.name:e,g.This_may_be_converted_to_an_async_function))}function e2t(e,t){return!Kw(e)&&e.body&&ra(e.body)&&r2t(e.body,t)&&pre(e,t)}function pre(e,t){let n=t.getSignatureFromDeclaration(e),i=n?t.getReturnTypeOfSignature(n):void 0;return!!i&&!!t.getPromisedTypeOfPromise(i)}function t2t(e){return bn(e)?e.left:e}function r2t(e,t){return!!$b(e,n=>qJ(n,t))}function qJ(e,t){return Um(e)&&!!e.expression&&dre(e.expression,t)}function dre(e,t){if(!qLe(e)||!zLe(e)||!e.arguments.every(i=>$Le(i,t)))return!1;let n=e.expression.expression;for(;qLe(n)||Hn(n);)if(da(n)){if(!zLe(n)||!n.arguments.every(i=>$Le(i,t)))return!1;n=n.expression.expression}else n=n.expression;return!0}function qLe(e){return da(e)&&(WM(e,"then")||WM(e,"catch")||WM(e,"finally"))}function zLe(e){let t=e.expression.name.text,n=t==="then"?2:t==="catch"||t==="finally"?1:0;return e.arguments.length>n?!1:e.arguments.length<n?!0:n===1||Tt(e.arguments,i=>i.kind===106||ze(i)&&i.text==="undefined")}function $Le(e,t){switch(e.kind){case 262:case 218:if(vu(e)&1)return!1;case 219:gre.set(WLe(e),!0);case 106:return!0;case 80:case 211:{let i=t.getSymbolAtLocation(e);return i?t.isUndefinedSymbol(i)||Tt(r_(i,t).declarations,s=>ca(s)||jv(s)&&!!s.initializer&&ca(s.initializer)):!1}default:return!1}}function WLe(e){return`${e.pos.toString()}:${e.end.toString()}`}function n2t(e,t){var n,i,s,o;if(Xo(e)){if(Gi(e.parent)&&((n=e.symbol.members)!=null&&n.size))return!0;let l=t.getSymbolOfExpando(e,!1);return!!(l&&((i=l.exports)!=null&&i.size||(s=l.members)!=null&&s.size))}return Zl(e)?!!((o=e.symbol.members)!=null&&o.size):!1}function mre(e){switch(e.kind){case 262:case 174:case 218:case 219:return!0;default:return!1}}var gre,i2t=f({"src/services/suggestionDiagnostics.ts"(){"use strict";yi(),gre=new Map}});function gve(e,t){let n=[],i=t.compilerOptions?hre(t.compilerOptions,n):{},s=_q();for(let A in s)wo(s,A)&&i[A]===void 0&&(i[A]=s[A]);for(let A of DQ)i.verbatimModuleSyntax&&HLe.has(A.name)||(i[A.name]=A.transpileOptionValue);i.suppressOutputPathCheck=!0,i.allowNonTsExtensions=!0;let o=w1(i),l={getSourceFile:A=>A===Ca(p)?m:void 0,writeFile:(A,k)=>{Uc(A,".map")?(I.assertEqual(h,void 0,"Unexpected multiple source map outputs, file:",A),h=k):(I.assertEqual(S,void 0,"Unexpected multiple outputs, file:",A),S=k)},getDefaultLibFileName:()=>"lib.d.ts",useCaseSensitiveFileNames:()=>!1,getCanonicalFileName:A=>A,getCurrentDirectory:()=>"",getNewLine:()=>o,fileExists:A=>A===p,readFile:()=>"",directoryExists:()=>!0,getDirectories:()=>[]},p=t.fileName||(t.compilerOptions&&t.compilerOptions.jsx?"module.tsx":"module.ts"),m=KR(p,e,{languageVersion:ho(i),impliedNodeFormat:RM(gc(p,"",l.getCanonicalFileName),void 0,l,i),setExternalModuleIndicator:aR(i),jsDocParsingMode:t.jsDocParsingMode??0});t.moduleName&&(m.moduleName=t.moduleName),t.renamedDependencies&&(m.renamedDependencies=new Map(Object.entries(t.renamedDependencies)));let S,h,b=xV([p],i,l);return t.reportDiagnostics&&(jt(n,b.getSyntacticDiagnostics(m)),jt(n,b.getOptionsDiagnostics())),b.emit(void 0,void 0,void 0,void 0,t.transformers),S===void 0?I.fail("Output generation failed"):{outputText:S,diagnostics:n,sourceMapText:h}}function GLe(e,t,n,i,s){let o=gve(e,{compilerOptions:t,fileName:n,reportDiagnostics:!!i,moduleName:s});return jt(i,o.diagnostics),o.outputText}function hre(e,t){hve=hve||Fn(F0,n=>typeof n.type=="object"&&!yu(n.type,i=>typeof i!="number")),e=mte(e);for(let n of hve){if(!wo(e,n.name))continue;let i=e[n.name];vs(i)?e[n.name]=xU(n,i,t):yu(n.type,s=>s===i)||t.push(che(n))}return e}var HLe,hve,s2t=f({"src/services/transpile.ts"(){"use strict";yi(),HLe=new Set(["isolatedModules","preserveValueImports","importsNotUsedAsValues"])}});function YLe(e,t,n,i,s,o,l){let p=ave(i);if(!p)return tt;let m=[],S=e.length===1?e[0]:void 0;for(let h of e)n.throwIfCancellationRequested(),!(o&&h.isDeclarationFile)&&(XLe(h,!!l,S)||h.getNamedDeclarations().forEach((b,A)=>{a2t(p,A,b,t,h.fileName,!!l,S,m)}));return m.sort(u2t),(s===void 0?m:m.slice(0,s)).map(_2t)}function XLe(e,t,n){return e!==n&&t&&(f7(e.path)||e.hasNoDefaultLib)}function a2t(e,t,n,i,s,o,l,p){let m=e.getMatchForLastSegmentOfPattern(t);if(m){for(let S of n)if(o2t(S,i,o,l))if(e.patternContainsDots){let h=e.getFullMatch(l2t(S),t);h&&p.push({name:t,fileName:s,matchKind:h.kind,isCaseSensitive:h.isCaseSensitive,declaration:S})}else p.push({name:t,fileName:s,matchKind:m.kind,isCaseSensitive:m.isCaseSensitive,declaration:S})}}function o2t(e,t,n,i){var s;switch(e.kind){case 273:case 276:case 271:let o=t.getSymbolAtLocation(e.name),l=t.getAliasedSymbol(o);return o.escapedName!==l.escapedName&&!((s=l.declarations)!=null&&s.every(p=>XLe(p.getSourceFile(),n,i)));default:return!0}}function c2t(e,t){let n=qs(e);return!!n&&(KLe(n,t)||n.kind===167&&yve(n.expression,t))}function yve(e,t){return KLe(e,t)||Hn(e)&&(t.push(e.name.text),!0)&&yve(e.expression,t)}function KLe(e,t){return Wg(e)&&(t.push(om(e)),!0)}function l2t(e){let t=[],n=qs(e);if(n&&n.kind===167&&!yve(n.expression,t))return tt;t.shift();let i=Ax(e);for(;i;){if(!c2t(i,t))return tt;i=Ax(i)}return t.reverse()}function u2t(e,t){return To(e.matchKind,t.matchKind)||LP(e.name,t.name)}function _2t(e){let t=e.declaration,n=Ax(t),i=n&&qs(n);return{name:e.name,kind:CE(t),kindModifiers:xO(t),matchKind:JJ[e.matchKind],isCaseSensitive:e.isCaseSensitive,fileName:e.fileName,textSpan:gf(t),containerName:i?i.text:"",containerKind:i?CE(n):""}}var f2t=f({"src/services/navigateTo.ts"(){"use strict";yi()}}),vve={};x(vve,{getNavigateToItems:()=>YLe});var QLe=f({"src/services/_namespaces/ts.NavigateTo.ts"(){"use strict";f2t()}});function ZLe(e,t){Tre=t,g7=e;try{return vr(h2t(nFe(e)),y2t)}finally{tFe()}}function eFe(e,t){Tre=t,g7=e;try{return fFe(nFe(e))}finally{tFe()}}function tFe(){g7=void 0,Tre=void 0,h7=[],z1=void 0,bre=[]}function zJ(e){return MO(e.getText(g7))}function yre(e){return e.node.kind}function rFe(e,t){e.children?e.children.push(t):e.children=[t]}function nFe(e){I.assert(!h7.length);let t={node:e,name:void 0,additionalNodes:void 0,parent:void 0,children:void 0,indent:0};z1=t;for(let n of e.statements)Tk(n);return FT(),I.assert(!z1&&!h7.length),t}function PE(e,t){rFe(z1,Sve(e,t))}function Sve(e,t){return{node:e,name:t||(O_(e)||bt(e)?qs(e):void 0),additionalNodes:void 0,parent:z1,children:void 0,indent:z1.indent+1}}function iFe(e){DD||(DD=new Map),DD.set(e,!0)}function sFe(e){for(let t=0;t<e;t++)FT()}function aFe(e,t){let n=[];for(;!Wg(t);){let i=O8(t),s=xy(t);t=t.expression,!(s==="prototype"||is(i))&&n.push(i)}n.push(t);for(let i=n.length-1;i>0;i--){let s=n[i];NE(e,s)}return[n.length-1,n[0]]}function NE(e,t){let n=Sve(e,t);rFe(z1,n),h7.push(z1),Pve.push(DD),DD=void 0,z1=n}function FT(){z1.children&&(vre(z1.children,z1),Eve(z1.children)),z1=h7.pop(),DD=Pve.pop()}function jT(e,t,n){NE(e,n),Tk(t),FT()}function oFe(e){e.initializer&&S2t(e.initializer)?(NE(e),Qs(e.initializer,Tk),FT()):jT(e,e.initializer)}function Tve(e){let t=qs(e);if(t===void 0)return!1;if(uo(t)){let n=t.expression;return ol(n)||_p(n)||id(n)}return!!t}function Tk(e){if(Tre.throwIfCancellationRequested(),!(!e||gA(e)))switch(e.kind){case 176:let t=e;jT(t,t.body);for(let l of t.parameters)op(l,t)&&PE(l);break;case 174:case 177:case 178:case 173:Tve(e)&&jT(e,e.body);break;case 172:Tve(e)&&oFe(e);break;case 171:Tve(e)&&PE(e);break;case 273:let n=e;n.name&&PE(n.name);let{namedBindings:i}=n;if(i)if(i.kind===274)PE(i);else for(let l of i.elements)PE(l);break;case 304:jT(e,e.name);break;case 305:let{expression:s}=e;ze(s)?PE(e,s):PE(e);break;case 208:case 303:case 260:{let l=e;la(l.name)?Tk(l.name):oFe(l);break}case 262:let o=e.name;o&&ze(o)&&iFe(o.text),jT(e,e.body);break;case 219:case 218:jT(e,e.body);break;case 266:NE(e);for(let l of e.members)v2t(l)||PE(l);FT();break;case 263:case 231:case 264:NE(e);for(let l of e.members)Tk(l);FT();break;case 267:jT(e,dFe(e).body);break;case 277:{let l=e.expression,p=Ha(l)||da(l)?l:rc(l)||Xo(l)?l.body:void 0;p?(NE(e),Tk(p),FT()):PE(e);break}case 281:case 271:case 181:case 179:case 180:case 265:PE(e);break;case 213:case 226:{let l=al(e);switch(l){case 1:case 2:jT(e,e.right);return;case 6:case 3:{let p=e,m=p.left,S=l===3?m.expression:m,h=0,b;ze(S.expression)?(iFe(S.expression.text),b=S.expression):[h,b]=aFe(p,S.expression),l===6?Ha(p.right)&&p.right.properties.length>0&&(NE(p,b),Qs(p.right,Tk),FT()):Xo(p.right)||rc(p.right)?jT(e,p.right,b):(NE(p,b),jT(e,p.right,m.name),FT()),sFe(h);return}case 7:case 9:{let p=e,m=l===7?p.arguments[0]:p.arguments[0].expression,S=p.arguments[1],[h,b]=aFe(e,m);NE(e,b),NE(e,ft(j.createIdentifier(S.text),S)),Tk(e.arguments[2]),FT(),FT(),sFe(h);return}case 5:{let p=e,m=p.left,S=m.expression;if(ze(S)&&xy(m)!=="prototype"&&DD&&DD.has(S.text)){Xo(p.right)||rc(p.right)?jT(e,p.right,S):Hb(m)&&(NE(p,S),jT(p.left,p.right,O8(m)),FT());return}break}case 4:case 0:case 8:break;default:I.assertNever(l)}}default:jp(e)&&Te(e.jsDoc,l=>{Te(l.tags,p=>{am(p)&&PE(p)})}),Qs(e,Tk)}}function vre(e,t){let n=new Map;Nh(e,(i,s)=>{let o=i.name||qs(i.node),l=o&&zJ(o);if(!l)return!0;let p=n.get(l);if(!p)return n.set(l,i),!0;if(p instanceof Array){for(let m of p)if(cFe(m,i,s,t))return!1;return p.push(i),!0}else{let m=p;return cFe(m,i,s,t)?!1:(n.set(l,[m,i]),!0)}})}function p2t(e,t,n,i){function s(p){return Xo(p)||Zl(p)||Gi(p)}let o=bn(t.node)||da(t.node)?al(t.node):0,l=bn(e.node)||da(e.node)?al(e.node):0;if(LO[o]&&LO[l]||s(e.node)&&LO[o]||s(t.node)&&LO[l]||eu(e.node)&&bve(e.node)&&LO[o]||eu(t.node)&&LO[l]||eu(e.node)&&bve(e.node)&&s(t.node)||eu(t.node)&&s(e.node)&&bve(e.node)){let p=e.additionalNodes&&Is(e.additionalNodes)||e.node;if(!eu(e.node)&&!eu(t.node)||s(e.node)||s(t.node)){let S=s(e.node)?e.node:s(t.node)?t.node:void 0;if(S!==void 0){let h=ft(j.createConstructorDeclaration(void 0,[],void 0),S),b=Sve(h);b.indent=e.indent+1,b.children=e.node===S?e.children:t.children,e.children=e.node===S?ys([b],t.children||[t]):ys(e.children||[{...e}],[b])}else(e.children||t.children)&&(e.children=ys(e.children||[{...e}],t.children||[t]),e.children&&(vre(e.children,e),Eve(e.children)));p=e.node=ft(j.createClassDeclaration(void 0,e.name||j.createIdentifier("__class__"),void 0,void 0,[]),e.node)}else e.children=ys(e.children,t.children),e.children&&vre(e.children,e);let m=t.node;return i.children[n-1].node.end===p.end?ft(p,{pos:p.pos,end:m.end}):(e.additionalNodes||(e.additionalNodes=[]),e.additionalNodes.push(ft(j.createClassDeclaration(void 0,e.name||j.createIdentifier("__class__"),void 0,void 0,[]),t.node))),!0}return o!==0}function cFe(e,t,n,i){return p2t(e,t,n,i)?!0:d2t(e.node,t.node,i)?(m2t(e,t),!0):!1}function d2t(e,t,n){if(e.kind!==t.kind||e.parent!==t.parent&&!(lFe(e,n)&&lFe(t,n)))return!1;switch(e.kind){case 172:case 174:case 177:case 178:return pa(e)===pa(t);case 267:return uFe(e,t)&&Ave(e)===Ave(t);default:return!0}}function bve(e){return!!(e.flags&16)}function lFe(e,t){let n=Zg(e.parent)?e.parent.parent:e.parent;return n===t.node||hs(t.additionalNodes,n)}function uFe(e,t){return!e.body||!t.body?e.body===t.body:e.body.kind===t.body.kind&&(e.body.kind!==267||uFe(e.body,t.body))}function m2t(e,t){e.additionalNodes=e.additionalNodes||[],e.additionalNodes.push(t.node),t.additionalNodes&&e.additionalNodes.push(...t.additionalNodes),e.children=ys(e.children,t.children),e.children&&(vre(e.children,e),Eve(e.children))}function Eve(e){e.sort(g2t)}function g2t(e,t){return LP(_Fe(e.node),_Fe(t.node))||To(yre(e),yre(t))}function _Fe(e){if(e.kind===267)return pFe(e);let t=qs(e);if(t&&Al(t)){let n=K2(t);return n&&Zi(n)}switch(e.kind){case 218:case 219:case 231:return gFe(e);default:return}}function xve(e,t){if(e.kind===267)return MO(pFe(e));if(t){let n=ze(t)?t.text:fc(t)?`[${zJ(t.argumentExpression)}]`:zJ(t);if(n.length>0)return MO(n)}switch(e.kind){case 312:let n=e;return Pl(n)?`"${D0(Cl(ff(Ca(n.fileName))))}"`:"<global>";case 277:return Kc(e)&&e.isExportEquals?"export=":"default";case 219:case 262:case 218:case 263:case 231:return qv(e)&2048?"default":gFe(e);case 176:return"constructor";case 180:return"new()";case 179:return"()";case 181:return"[]";default:return"<unknown>"}}function h2t(e){let t=[];function n(s){if(i(s)&&(t.push(s),s.children))for(let o of s.children)n(o)}return n(e),t;function i(s){if(s.children)return!0;switch(yre(s)){case 263:case 231:case 266:case 264:case 267:case 312:case 265:case 353:case 345:return!0;case 219:case 262:case 218:return o(s);default:return!1}function o(l){if(!l.node.body)return!1;switch(yre(l.parent)){case 268:case 312:case 174:case 176:return!0;default:return!1}}}}function fFe(e){return{text:xve(e.node,e.name),kind:CE(e.node),kindModifiers:mFe(e.node),spans:Cve(e),nameSpan:e.name&&kve(e.name),childItems:vr(e.children,fFe)}}function y2t(e){return{text:xve(e.node,e.name),kind:CE(e.node),kindModifiers:mFe(e.node),spans:Cve(e),childItems:vr(e.children,t)||bre,indent:e.indent,bolded:!1,grayed:!1};function t(n){return{text:xve(n.node,n.name),kind:CE(n.node),kindModifiers:xO(n.node),spans:Cve(n),childItems:bre,indent:0,bolded:!1,grayed:!1}}}function Cve(e){let t=[kve(e.node)];if(e.additionalNodes)for(let n of e.additionalNodes)t.push(kve(n));return t}function pFe(e){return S_(e)?Fl(e.name):Ave(e)}function Ave(e){let t=[om(e.name)];for(;e.body&&e.body.kind===267;)e=e.body,t.push(om(e.name));return t.join(".")}function dFe(e){return e.body&&hl(e.body)?dFe(e.body):e}function v2t(e){return!e.name||e.name.kind===167}function kve(e){return e.kind===312?aS(e):gf(e,g7)}function mFe(e){return e.parent&&e.parent.kind===260&&(e=e.parent),xO(e)}function gFe(e){let{parent:t}=e;if(e.name&&f8(e.name)>0)return MO(qo(e.name));if(Gi(t))return MO(qo(t.name));if(bn(t)&&t.operatorToken.kind===64)return zJ(t.left).replace(yFe,"");if(Ul(t))return zJ(t.name);if(qv(e)&2048)return"default";if(Ti(e))return"<class>";if(da(t)){let n=hFe(t.expression);if(n!==void 0){if(n=MO(n),n.length>Sre)return`${n} callback`;let i=MO(Wi(t.arguments,s=>bo(s)||SA(s)?s.getText(g7):void 0).join(", "));return`${n}(${i}) callback`}}return"<function>"}function hFe(e){if(ze(e))return e.text;if(Hn(e)){let t=hFe(e.expression),n=e.name.text;return t===void 0?n:`${t}.${n}`}else return}function S2t(e){switch(e.kind){case 219:case 218:case 231:return!0;default:return!1}}function MO(e){return e=e.length>Sre?e.substring(0,Sre)+"...":e,e.replace(/\\?(\r?\n|\r|\u2028|\u2029)/g,"")}var yFe,Sre,Tre,g7,h7,z1,Pve,DD,bre,LO,T2t=f({"src/services/navigationBar.ts"(){"use strict";yi(),yFe=/\s+/g,Sre=150,h7=[],Pve=[],bre=[],LO={5:!0,3:!0,7:!0,9:!0,0:!1,1:!1,2:!1,8:!1,6:!0,4:!1}}}),Nve={};x(Nve,{getNavigationBarItems:()=>ZLe,getNavigationTree:()=>eFe});var vFe=f({"src/services/_namespaces/ts.NavigationBar.ts"(){"use strict";T2t()}});function j0(e,t){Ere.set(e,t)}function b2t(e,t){return In(A2(Ere.values(),n=>{var i;return e.cancellationToken&&e.cancellationToken.isCancellationRequested()||!((i=n.kinds)!=null&&i.some(s=>BT(s,e.kind)))?void 0:n.getAvailableActions(e,t)}))}function E2t(e,t,n,i){let s=Ere.get(t);return s&&s.getEditsForAction(e,n,i)}var Ere,SFe=f({"src/services/refactorProvider.ts"(){"use strict";yi(),Gh(),Ere=new Map}});function TFe(e,t=!0){let{file:n,program:i}=e,s=Sk(e),o=Ts(n,s.start),l=o.parent&&qv(o.parent)&32&&t?o.parent:s7(o,n,s);if(!l||!ls(l.parent)&&!(Zg(l.parent)&&S_(l.parent.parent)))return{error:Gs(g.Could_not_find_export_statement)};let p=i.getTypeChecker(),m=N2t(l.parent,p),S=qv(l)||(Kc(l)&&!l.isExportEquals?2080:0),h=!!(S&2048);if(!(S&32)||!h&&m.exports.has("default"))return{error:Gs(g.This_file_already_has_a_default_export)};let b=A=>ze(A)&&p.getSymbolAtLocation(A)?void 0:{error:Gs(g.Can_only_convert_named_export)};switch(l.kind){case 262:case 263:case 264:case 266:case 265:case 267:{let A=l;return A.name?b(A.name)||{exportNode:A,exportName:A.name,wasDefault:h,exportingModuleSymbol:m}:void 0}case 243:{let A=l;if(!(A.declarationList.flags&2)||A.declarationList.declarations.length!==1)return;let k=di(A.declarationList.declarations);return k.initializer?(I.assert(!h,"Can't have a default flag here"),b(k.name)||{exportNode:A,exportName:k.name,wasDefault:h,exportingModuleSymbol:m}):void 0}case 277:{let A=l;return A.isExportEquals?void 0:b(A.expression)||{exportNode:A,exportName:A.expression,wasDefault:h,exportingModuleSymbol:m}}default:return}}function x2t(e,t,n,i,s){C2t(e,n,i,t.getTypeChecker()),A2t(t,n,i,s)}function C2t(e,{wasDefault:t,exportNode:n,exportName:i},s,o){if(t)if(Kc(n)&&!n.isExportEquals){let l=n.expression,p=bFe(l.text,l.text);s.replaceNode(e,n,j.createExportDeclaration(void 0,!1,j.createNamedExports([p])))}else s.delete(e,I.checkDefined(xD(n,90),"Should find a default keyword in modifier list"));else{let l=I.checkDefined(xD(n,95),"Should find an export keyword in modifier list");switch(n.kind){case 262:case 263:case 264:s.insertNodeAfter(e,l,j.createToken(90));break;case 243:let p=di(n.declarationList.declarations);if(!Ko.Core.isSymbolReferencedInFile(i,o,e)&&!p.type){s.replaceNode(e,n,j.createExportDefault(I.checkDefined(p.initializer,"Initializer was previously known to be present")));break}case 266:case 265:case 267:s.deleteModifier(e,l),s.insertNodeAfter(e,n,j.createExportDefault(j.createIdentifier(i.text)));break;default:I.fail(`Unexpected exportNode kind ${n.kind}`)}}}function A2t(e,{wasDefault:t,exportName:n,exportingModuleSymbol:i},s,o){let l=e.getTypeChecker(),p=I.checkDefined(l.getSymbolAtLocation(n),"Export name should resolve to a symbol");Ko.Core.eachExportReference(e.getSourceFiles(),l,o,p,i,n.text,t,m=>{if(n===m)return;let S=m.getSourceFile();t?k2t(S,m,s,n.text):P2t(S,m,s)})}function k2t(e,t,n,i){let{parent:s}=t;switch(s.kind){case 211:n.replaceNode(e,t,j.createIdentifier(i));break;case 276:case 281:{let l=s;n.replaceNode(e,l,Dve(i,l.name.text));break}case 273:{let l=s;I.assert(l.name===t,"Import clause name should match provided ref");let p=Dve(i,t.text),{namedBindings:m}=l;if(!m)n.replaceNode(e,t,j.createNamedImports([p]));else if(m.kind===274){n.deleteRange(e,{pos:t.getStart(e),end:m.getStart(e)});let S=za(l.parent.moduleSpecifier)?Ete(l.parent.moduleSpecifier,e):1,h=J1(void 0,[Dve(i,t.text)],l.parent.moduleSpecifier,S);n.insertNodeAfter(e,l.parent,h)}else n.delete(e,t),n.insertNodeAtEndOfList(e,m.elements,p);break}case 205:let o=s;n.replaceNode(e,s,j.createImportTypeNode(o.argument,o.attributes,j.createIdentifier(i),o.typeArguments,o.isTypeOf));break;default:I.failBadSyntaxKind(s)}}function P2t(e,t,n){let i=t.parent;switch(i.kind){case 211:n.replaceNode(e,t,j.createIdentifier("default"));break;case 276:{let s=j.createIdentifier(i.name.text);i.parent.elements.length===1?n.replaceNode(e,i.parent,s):(n.delete(e,i),n.insertNodeBefore(e,i.parent,s));break}case 281:{n.replaceNode(e,i,bFe("default",i.name.text));break}default:I.assertNever(i,`Unexpected parent kind ${i.kind}`)}}function Dve(e,t){return j.createImportSpecifier(!1,e===t?void 0:j.createIdentifier(e),j.createIdentifier(t))}function bFe(e,t){return j.createExportSpecifier(!1,e===t?void 0:j.createIdentifier(e),j.createIdentifier(t))}function N2t(e,t){if(ls(e))return e.symbol;let n=e.parent.symbol;return n.valueDeclaration&&qb(n.valueDeclaration)?t.getMergedSymbol(n):n}var xre,$J,WJ,D2t=f({"src/services/refactors/convertExport.ts"(){"use strict";yi(),Gh(),xre="Convert export",$J={name:"Convert default export to named export",description:Gs(g.Convert_default_export_to_named_export),kind:"refactor.rewrite.export.named"},WJ={name:"Convert named export to default export",description:Gs(g.Convert_named_export_to_default_export),kind:"refactor.rewrite.export.default"},j0(xre,{kinds:[$J.kind,WJ.kind],getAvailableActions:function(t){let n=TFe(t,t.triggerReason==="invoked");if(!n)return tt;if(!Ry(n)){let i=n.wasDefault?$J:WJ;return[{name:xre,description:i.description,actions:[i]}]}return t.preferences.provideRefactorNotApplicableReason?[{name:xre,description:Gs(g.Convert_default_export_to_named_export),actions:[{...$J,notApplicableReason:n.error},{...WJ,notApplicableReason:n.error}]}]:tt},getEditsForAction:function(t,n){I.assert(n===$J.name||n===WJ.name,"Unexpected action name");let i=TFe(t);return I.assert(i&&!Ry(i),"Expected applicable refactor info"),{edits:En.ChangeTracker.with(t,o=>x2t(t.file,t.program,i,o,t.cancellationToken)),renameFilename:void 0,renameLocation:void 0}}})}});function EFe(e,t=!0){let{file:n}=e,i=Sk(e),s=Ts(n,i.start),o=t?Gr(s,uu):s7(s,n,i);if(!o||!uu(o))return{error:"Selection is not an import declaration."};let l=i.start+i.length,p=AE(o,o.parent,n);if(p&&l>p.getStart())return;let{importClause:m}=o;return m?m.namedBindings?m.namedBindings.kind===274?{convertTo:0,import:m.namedBindings}:xFe(e.program,m)?{convertTo:1,import:m.namedBindings}:{convertTo:2,import:m.namedBindings}:{error:Gs(g.Could_not_find_namespace_import_or_named_imports)}:{error:Gs(g.Could_not_find_import_clause)}}function xFe(e,t){return ix(e.getCompilerOptions())&&R2t(t.parent.moduleSpecifier,e.getTypeChecker())}function I2t(e,t,n,i){let s=t.getTypeChecker();i.convertTo===0?w2t(e,s,n,i.import,ix(t.getCompilerOptions())):AFe(e,t,n,i.import,i.convertTo===1)}function w2t(e,t,n,i,s){let o=!1,l=[],p=new Map;Ko.Core.eachSymbolReferenceInFile(i.name,t,e,b=>{if(!Ppe(b.parent))o=!0;else{let A=CFe(b.parent).text;t.resolveName(A,b,-1,!0)&&p.set(A,!0),I.assert(O2t(b.parent)===b,"Parent expression should match id"),l.push(b.parent)}});let m=new Map;for(let b of l){let A=CFe(b).text,k=m.get(A);k===void 0&&m.set(A,k=p.has(A)?Nx(A,e):A),n.replaceNode(e,b,j.createIdentifier(k))}let S=[];m.forEach((b,A)=>{S.push(j.createImportSpecifier(!1,b===A?void 0:j.createIdentifier(A),j.createIdentifier(b)))});let h=i.parent.parent;o&&!s?n.insertNodeAfter(e,h,Ive(h,void 0,S)):n.replaceNode(e,h,Ive(h,o?j.createIdentifier(i.name.text):void 0,S))}function CFe(e){return Hn(e)?e.name:e.right}function O2t(e){return Hn(e)?e.expression:e.left}function AFe(e,t,n,i,s=xFe(t,i.parent)){let o=t.getTypeChecker(),l=i.parent.parent,{moduleSpecifier:p}=l,m=new Set;i.elements.forEach(N=>{let M=o.getSymbolAtLocation(N.name);M&&m.add(M)});let S=p&&za(p)?x_.moduleSpecifierToValidIdentifier(p.text,99):"module";function h(N){return!!Ko.Core.eachSymbolReferenceInFile(N.name,o,e,M=>{let O=o.resolveName(S,M,-1,!0);return O?m.has(O)?R_(M.parent):!0:!1})}let A=i.elements.some(h)?Nx(S,e):S,k=new Set;for(let N of i.elements){let M=(N.propertyName||N.name).text;Ko.Core.eachSymbolReferenceInFile(N.name,o,e,O=>{let U=j.createPropertyAccessExpression(j.createIdentifier(A),M);Hf(O.parent)?n.replaceNode(e,O.parent,j.createPropertyAssignment(O.text,U)):R_(O.parent)?k.add(N):n.replaceNode(e,O,U)})}if(n.replaceNode(e,i,s?j.createIdentifier(A):j.createNamespaceImport(j.createIdentifier(A))),k.size){let N=In(k.values(),M=>j.createImportSpecifier(M.isTypeOnly,M.propertyName&&j.createIdentifier(M.propertyName.text),j.createIdentifier(M.name.text)));n.insertNodeAfter(e,i.parent.parent,Ive(l,void 0,N))}}function R2t(e,t){let n=t.resolveExternalModuleName(e);if(!n)return!1;let i=t.resolveExternalModuleSymbol(n);return n!==i}function Ive(e,t,n){return j.createImportDeclaration(void 0,j.createImportClause(!1,t,n&&n.length?j.createNamedImports(n):void 0),e.moduleSpecifier,void 0)}var Cre,GJ,M2t=f({"src/services/refactors/convertImport.ts"(){"use strict";yi(),Gh(),Cre="Convert import",GJ={0:{name:"Convert namespace import to named imports",description:Gs(g.Convert_namespace_import_to_named_imports),kind:"refactor.rewrite.import.named"},2:{name:"Convert named imports to namespace import",description:Gs(g.Convert_named_imports_to_namespace_import),kind:"refactor.rewrite.import.namespace"},1:{name:"Convert named imports to default import",description:Gs(g.Convert_named_imports_to_default_import),kind:"refactor.rewrite.import.default"}},j0(Cre,{kinds:Mn(GJ).map(e=>e.kind),getAvailableActions:function(t){let n=EFe(t,t.triggerReason==="invoked");if(!n)return tt;if(!Ry(n)){let i=GJ[n.convertTo];return[{name:Cre,description:i.description,actions:[i]}]}return t.preferences.provideRefactorNotApplicableReason?Mn(GJ).map(i=>({name:Cre,description:i.description,actions:[{...i,notApplicableReason:n.error}]})):tt},getEditsForAction:function(t,n){I.assert(Tt(Mn(GJ),o=>o.name===n),"Unexpected action name");let i=EFe(t);return I.assert(i&&!Ry(i),"Expected applicable refactor info"),{edits:En.ChangeTracker.with(t,o=>I2t(t.file,t.program,o,i)),renameFilename:void 0,renameLocation:void 0}}})}});function kFe(e,t=!0){let{file:n,startPosition:i}=e,s=Y_(n),o=_J(Sk(e)),l=o.pos===o.end&&t,p=L2t(n,i,o,l);if(!p||!es(p))return{error:Gs(g.Selection_is_not_a_valid_type_node)};let m=e.program.getTypeChecker(),S=V2t(p,s);if(S===void 0)return{error:Gs(g.No_type_could_be_extracted_from_this_type_node)};let h=J2t(p,S);if(!es(h))return{error:Gs(g.Selection_is_not_a_valid_type_node)};let b=[];(Kv(h.parent)||KA(h.parent))&&o.end>p.end&&jt(b,h.parent.types.filter(M=>tJ(M,n,o.pos,o.end)));let A=b.length>1?b:h,k=F2t(m,A,S,n);if(!k)return{error:Gs(g.No_type_could_be_extracted_from_this_type_node)};let N=Are(m,A);return{isJS:s,selection:A,enclosingNode:S,typeParameters:k,typeElements:N}}function L2t(e,t,n,i){let s=[()=>Ts(e,t),()=>bD(e,t,()=>!0)];for(let o of s){let l=o(),p=tJ(l,e,n.pos,n.end),m=Gr(l,S=>S.parent&&es(S)&&!DE(n,S.parent,e)&&(i||p));if(m)return m}}function Are(e,t){if(t){if(os(t)){let n=[];for(let i of t){let s=Are(e,i);if(!s)return;jt(n,s)}return n}if(KA(t)){let n=[],i=new Map;for(let s of t.types){let o=Are(e,s);if(!o||!o.every(l=>l.name&&Bm(i,n7(l.name))))return;jt(n,o)}return n}else{if(ox(t))return Are(e,t.type);if(dp(t))return t.members}}}function DE(e,t,n){return XM(e,Wa(n.text,t.pos),t.end)}function F2t(e,t,n,i){let s=[],o=Pm(t),l={pos:o[0].pos,end:o[o.length-1].end};for(let m of o)if(p(m))return;return s;function p(m){if(Id(m)){if(ze(m.typeName)){let S=m.typeName,h=e.resolveName(S.text,S,262144,!0);for(let b of h?.declarations||tt)if(Nc(b)&&b.getSourceFile()===i){if(b.name.escapedText===S.escapedText&&DE(b,l,i))return!0;if(DE(n,b,i)&&!DE(l,b,i)){ln(s,b);break}}}}else if(ax(m)){let S=Gr(m,h=>QA(h)&&DE(h.extendsType,m,i));if(!S||!DE(l,S,i))return!0}else if(RR(m)||LR(m)){let S=Gr(m.parent,ca);if(S&&S.type&&DE(S.type,m,i)&&!DE(l,S,i))return!0}else if(YA(m)){if(ze(m.exprName)){let S=e.resolveName(m.exprName.text,m.exprName,111551,!1);if(S?.valueDeclaration&&DE(n,S.valueDeclaration,i)&&!DE(l,S.valueDeclaration,i))return!0}else if(eE(m.exprName.left)&&!DE(l,m.parent,i))return!0}return i&&XA(m)&&Lo(i,m.pos).line===Lo(i,m.end).line&&Sn(m,1),Qs(m,p)}}function j2t(e,t,n,i){let{enclosingNode:s,typeParameters:o}=i,{firstTypeNode:l,lastTypeNode:p,newTypeNode:m}=wve(i),S=j.createTypeAliasDeclaration(void 0,n,o.map(h=>j.updateTypeParameterDeclaration(h,h.modifiers,h.name,h.constraint,void 0)),m);e.insertNodeBefore(t,s,CK(S),!0),e.replaceNodeRange(t,l,p,j.createTypeReferenceNode(n,o.map(h=>j.createTypeReferenceNode(h.name,void 0))),{leadingTriviaOption:En.LeadingTriviaOption.Exclude,trailingTriviaOption:En.TrailingTriviaOption.ExcludeWhitespace})}function B2t(e,t,n,i){var s;let{enclosingNode:o,typeParameters:l,typeElements:p}=i,m=j.createInterfaceDeclaration(void 0,n,l,void 0,p);ft(m,(s=p[0])==null?void 0:s.parent),e.insertNodeBefore(t,o,CK(m),!0);let{firstTypeNode:S,lastTypeNode:h}=wve(i);e.replaceNodeRange(t,S,h,j.createTypeReferenceNode(n,l.map(b=>j.createTypeReferenceNode(b.name,void 0))),{leadingTriviaOption:En.LeadingTriviaOption.Exclude,trailingTriviaOption:En.TrailingTriviaOption.ExcludeWhitespace})}function U2t(e,t,n,i,s){var o;Pm(s.selection).forEach(N=>{Sn(N,7168)});let{enclosingNode:l,typeParameters:p}=s,{firstTypeNode:m,lastTypeNode:S,newTypeNode:h}=wve(s),b=j.createJSDocTypedefTag(j.createIdentifier("typedef"),j.createJSDocTypeExpression(h),j.createIdentifier(i)),A=[];Te(p,N=>{let M=YP(N),O=j.createTypeParameterDeclaration(void 0,N.name),U=j.createJSDocTemplateTag(j.createIdentifier("template"),M&&ta(M,hE),[O]);A.push(U)});let k=j.createJSDocComment(void 0,j.createNodeArray(ys(A,[b])));if(dg(l)){let N=l.getStart(n),M=q1(t.host,(o=t.formatContext)==null?void 0:o.options);e.insertNodeAt(n,l.getStart(n),k,{suffix:M+M+n.text.slice(TJ(n.text,N-1),N)})}else e.insertNodeBefore(n,l,k,!0);e.replaceNodeRange(n,m,S,j.createTypeReferenceNode(i,p.map(N=>j.createTypeReferenceNode(N.name,void 0))))}function wve(e){return os(e.selection)?{firstTypeNode:e.selection[0],lastTypeNode:e.selection[e.selection.length-1],newTypeNode:Kv(e.selection[0].parent)?j.createUnionTypeNode(e.selection):j.createIntersectionTypeNode(e.selection)}:{firstTypeNode:e.selection,lastTypeNode:e.selection,newTypeNode:e.selection}}function V2t(e,t){return Gr(e,ns)||(t?Gr(e,dg):void 0)}function J2t(e,t){return Gr(e,n=>n===t?"quit":!!(Kv(n.parent)||KA(n.parent)))??e}var kre,HJ,YJ,XJ,q2t=f({"src/services/refactors/extractType.ts"(){"use strict";yi(),Gh(),kre="Extract type",HJ={name:"Extract to type alias",description:Gs(g.Extract_to_type_alias),kind:"refactor.extract.type"},YJ={name:"Extract to interface",description:Gs(g.Extract_to_interface),kind:"refactor.extract.interface"},XJ={name:"Extract to typedef",description:Gs(g.Extract_to_typedef),kind:"refactor.extract.typedef"},j0(kre,{kinds:[HJ.kind,YJ.kind,XJ.kind],getAvailableActions:function(t){let n=kFe(t,t.triggerReason==="invoked");return n?Ry(n)?t.preferences.provideRefactorNotApplicableReason?[{name:kre,description:Gs(g.Extract_type),actions:[{...XJ,notApplicableReason:n.error},{...HJ,notApplicableReason:n.error},{...YJ,notApplicableReason:n.error}]}]:tt:[{name:kre,description:Gs(g.Extract_type),actions:n.isJS?[XJ]:Pr([HJ],n.typeElements&&YJ)}]:tt},getEditsForAction:function(t,n){let{file:i}=t,s=kFe(t);I.assert(s&&!Ry(s),"Expected to find a range to extract");let o=Nx("NewType",i),l=En.ChangeTracker.with(t,S=>{switch(n){case HJ.name:return I.assert(!s.isJS,"Invalid actionName/JS combo"),j2t(S,i,o,s);case XJ.name:return I.assert(s.isJS,"Invalid actionName/JS combo"),U2t(S,t,i,o,s);case YJ.name:return I.assert(!s.isJS&&!!s.typeElements,"Invalid actionName/JS combo"),B2t(S,i,o,s);default:I.fail("Unexpected action name")}}),p=i.fileName,m=c7(l,p,o,!1);return{edits:l,renameFilename:p,renameLocation:m}}})}});function Ry(e){return e.error!==void 0}function BT(e,t){return t?e.substr(0,t.length)===t:!0}var z2t=f({"src/services/refactors/helpers.ts"(){"use strict"}});function PFe(e,t,n,i){var s,o;let l=i.getTypeChecker(),p=If(e,t),m=p.parent;if(ze(p)){if(iR(m)&&Jw(m)&&ze(m.name)){if(((s=l.getMergedSymbol(m.symbol).declarations)==null?void 0:s.length)!==1)return{error:Gs(g.Variables_with_multiple_declarations_cannot_be_inlined)};if(NFe(m))return;let S=DFe(m,l,e);return S&&{references:S,declaration:m,replacement:m.initializer}}if(n){let S=l.resolveName(p.text,p,111551,!1);if(S=S&&l.getMergedSymbol(S),((o=S?.declarations)==null?void 0:o.length)!==1)return{error:Gs(g.Variables_with_multiple_declarations_cannot_be_inlined)};let h=S.declarations[0];if(!iR(h)||!Jw(h)||!ze(h.name)||NFe(h))return;let b=DFe(h,l,e);return b&&{references:b,declaration:h,replacement:h.initializer}}return{error:Gs(g.Could_not_find_variable_to_inline)}}}function NFe(e){let t=ta(e.parent.parent,Xc);return Tt(t.modifiers,WA)}function DFe(e,t,n){let i=[],s=Ko.Core.eachSymbolReferenceInFile(e.name,t,n,o=>{if(Ko.isWriteAccessForReference(o)&&!Hf(o.parent)||R_(o.parent)||Kc(o.parent)||YA(o.parent)||G3(e,o.pos))return!0;i.push(o)});return i.length===0||s?void 0:i}function $2t(e,t){t=Sc(t);let{parent:n}=e;return bt(n)&&(e6(t)<e6(n)||bJ(n))||ca(t)&&(Vb(n)||Hn(n))||Hn(n)&&(_p(t)||Ha(t))?j.createParenthesizedExpression(t):ze(e)&&Hf(n)?j.createPropertyAssignment(e,t):t}var y7,Pre,Nre,W2t=f({"src/services/refactors/inlineVariable.ts"(){"use strict";yi(),Gh(),y7="Inline variable",Pre=Gs(g.Inline_variable),Nre={name:y7,description:Pre,kind:"refactor.inline.variable"},j0(y7,{kinds:[Nre.kind],getAvailableActions(e){let{file:t,program:n,preferences:i,startPosition:s,triggerReason:o}=e,l=PFe(t,s,o==="invoked",n);return l?bk.isRefactorErrorInfo(l)?i.provideRefactorNotApplicableReason?[{name:y7,description:Pre,actions:[{...Nre,notApplicableReason:l.error}]}]:tt:[{name:y7,description:Pre,actions:[Nre]}]:tt},getEditsForAction(e,t){I.assert(t===y7,"Unexpected refactor invoked");let{file:n,program:i,startPosition:s}=e,o=PFe(n,s,!0,i);if(!o||bk.isRefactorErrorInfo(o))return;let{references:l,declaration:p,replacement:m}=o;return{edits:En.ChangeTracker.with(e,h=>{for(let b of l)h.replaceNode(n,b,$2t(b,m));h.delete(n,p)})}}})}});function G2t(e,t,n,i,s,o){let l=t.getTypeChecker(),p=ZJ(e,n.all,l),m=qve(e,t,s,n);i.createNewFile(e,m,H2t(e,p,i,n,t,s,m,o)),Ove(t,i,e.fileName,m,N1(s))}function H2t(e,t,n,i,s,o,l,p){let m=s.getTypeChecker(),S=z5(e.statements,Fm);if(e.externalModuleIndicator===void 0&&e.commonJsModuleIndicator===void 0&&t.oldImportsNeededByTargetFile.size===0)return KJ(e,i.ranges,n),[...S,...i.all];let h=!Yte(l,s,o,!!e.commonJsModuleIndicator),b=_d(e,p),A=Fve(e,t.oldFileImportsFromTargetFile,l,s,o,h,b);A&&AO(n,e,A,!0,p),Rve(e,i.all,n,t.unusedImportsFromOldFile,m),KJ(e,i.ranges,n),Mve(n,s,o,e,t.movedSymbols,l,b);let k=Y2t(e,t.oldImportsNeededByTargetFile,t.targetFileImportsFromOldFile,n,m,s,o,h,b),N=jve(e,i.all,t.oldFileImportsFromTargetFile,h);return k.length&&N.length?[...S,...k,4,...N]:[...S,...k,...N]}function Y2t(e,t,n,i,s,o,l,p,m){let S=[];for(let k of e.statements)T7(k,N=>{Pr(S,b7(N,S7(N),M=>t.has(s.getSymbolAtLocation(M))))});let h,b=[],A=yk();return n.forEach(k=>{if(k.declarations)for(let N of k.declarations){if(!eq(N))continue;let M=Vve(N);if(!M)continue;let O=wre(N);A(O)&&Jve(e,O,M,i,p),ui(N,2048)?h=M:b.push(M.text)}}),Pr(S,QJ(e,h,b,Cl(e.fileName),o,l,p,m)),S}var v7,Dre,Ire,X2t=f({"src/services/refactors/moveToNewFile.ts"(){"use strict";yi(),Gh(),v7="Move to a new file",Dre=Gs(g.Move_to_a_new_file),Ire={name:v7,description:Dre,kind:"refactor.move.newFile"},j0(v7,{kinds:[Ire.kind],getAvailableActions:function(t){let n=E7(t);return t.preferences.allowTextChangesInNewFiles&&n?[{name:v7,description:Dre,actions:[Ire]}]:t.preferences.provideRefactorNotApplicableReason?[{name:v7,description:Dre,actions:[{...Ire,notApplicableReason:Gs(g.Selection_is_not_a_valid_statement_or_statements)}]}]:tt},getEditsForAction:function(t,n){I.assert(n===v7,"Wrong refactor invoked");let i=I.checkDefined(E7(t));return{edits:En.ChangeTracker.with(t,o=>G2t(t.file,t.program,i,o,t.host,t.preferences)),renameFilename:void 0,renameLocation:void 0}}})}});function IFe(e){return{edits:[],renameFilename:void 0,renameLocation:void 0,notApplicableReason:e}}function K2t(e,t,n,i,s,o,l,p){let m=i.getTypeChecker();if(!l.fileExists(n))o.createNewFile(t,n,wFe(t,n,ZJ(t,s.all,m),o,s,i,l,p)),Ove(i,o,t.fileName,n,N1(l));else{let S=I.checkDefined(i.getSourceFile(n)),h=x_.createImportAdder(S,e.program,e.preferences,e.host);wFe(t,S,ZJ(t,s.all,m,gxt(S,s.all,m)),o,s,i,l,p,h)}}function wFe(e,t,n,i,s,o,l,p,m){let S=o.getTypeChecker(),h=z5(e.statements,Fm);if(e.externalModuleIndicator===void 0&&e.commonJsModuleIndicator===void 0&&n.oldImportsNeededByTargetFile.size===0&&n.targetFileImportsFromOldFile.size===0&&typeof t=="string")return KJ(e,s.ranges,i),[...h,...s.all];let b=typeof t=="string"?t:t.fileName,A=!Yte(b,o,l,!!e.commonJsModuleIndicator),k=_d(e,p),N=Fve(e,n.oldFileImportsFromTargetFile,b,o,l,A,k);N&&AO(i,e,N,!0,p),Rve(e,s.all,i,n.unusedImportsFromOldFile,S),KJ(e,s.ranges,i),Mve(i,o,l,e,n.movedSymbols,b,k);let M=Q2t(e,b,n.oldImportsNeededByTargetFile,n.targetFileImportsFromOldFile,i,S,o,l,A,k,m),O=jve(e,s.all,n.oldFileImportsFromTargetFile,A);return typeof t!="string"&&(t.statements.length>0?mxt(i,o,O,t,s):i.insertNodesAtEndOfFile(t,O,!1),M.length>0&&AO(i,t,M,!0,p)),m&&m.writeFixes(i,k),M.length&&O.length?[...h,...M,4,...O]:[...h,...M,...O]}function Q2t(e,t,n,i,s,o,l,p,m,S,h){let b=[];if(h)n.forEach((O,U)=>{try{h.addImportFromExportedSymbol(r_(U,o),O)}catch{for(let H of e.statements)T7(H,K=>{Pr(b,b7(K,j.createStringLiteral(S7(K).text),re=>n.has(o.getSymbolAtLocation(re))))})}});else{let O=l.getSourceFile(t);for(let U of e.statements)T7(U,H=>{var K;let re=S7(H),$=l.getCompilerOptions(),pe=l.getResolvedModuleFromModuleSpecifier(re),z=(K=pe?.resolvedModule)==null?void 0:K.resolvedFileName;if(z&&O){let se=WU($,O,O.fileName,z,kx(l,p));Pr(b,b7(H,vk(se,S),Se=>n.has(o.getSymbolAtLocation(Se))))}else Pr(b,b7(H,j.createStringLiteral(S7(H).text),se=>n.has(o.getSymbolAtLocation(se))))})}let A=l.getSourceFile(t),k,N=[],M=yk();return i.forEach(O=>{if(O.declarations)for(let U of O.declarations){if(!eq(U))continue;let H=Vve(U);if(!H)continue;let K=wre(U);M(K)&&Jve(e,K,H,s,m),h&&o.isUnknownSymbol(O)?h.addImportFromExportedSymbol(r_(O,o)):ui(U,2048)?k=H:N.push(H.text)}}),A?Pr(b,QJ(A,k,N,e.fileName,l,p,m,S)):Pr(b,QJ(e,k,N,e.fileName,l,p,m,S))}function Ove(e,t,n,i,s){let o=e.getCompilerOptions().configFile;if(!o)return;let l=Ca(li(n,"..",i)),p=j3(o.fileName,l,s),m=o.statements[0]&&ii(o.statements[0].expression,Ha),S=m&&mr(m.properties,h=>Ul(h)&&za(h.name)&&h.name.text==="files");S&&Z_(S.initializer)&&t.insertNodeInListAfter(o,Rs(S.initializer.elements),j.createStringLiteral(p),S.initializer.elements)}function KJ(e,t,n){for(let{first:i,afterLast:s}of t)n.deleteNodeRangeExcludingEnd(e,i,s)}function Rve(e,t,n,i,s){for(let o of e.statements)hs(t,o)||T7(o,l=>Bve(e,l,n,p=>i.has(s.getSymbolAtLocation(p))))}function Mve(e,t,n,i,s,o,l){let p=t.getTypeChecker();for(let m of t.getSourceFiles())if(m!==i)for(let S of m.statements)T7(S,h=>{if(p.getSymbolAtLocation(S7(h))!==i.symbol)return;let b=O=>{let U=co(O.parent)?yJ(p,O.parent):r_(p.getSymbolAtLocation(O),p);return!!U&&s.has(U)};Bve(m,h,e,b);let A=Dv(hi(i.path),o),k=WU(t.getCompilerOptions(),m,m.fileName,A,kx(t,n)),N=b7(h,vk(k,l),b);N&&e.insertNodeAfter(m,S,N);let M=Z2t(h);M&&ext(e,m,p,s,k,M,h,l)})}function Z2t(e){switch(e.kind){case 272:return e.importClause&&e.importClause.namedBindings&&e.importClause.namedBindings.kind===274?e.importClause.namedBindings.name:void 0;case 271:return e.name;case 260:return ii(e.name,ze);default:return I.assertNever(e,`Unexpected node kind ${e.kind}`)}}function ext(e,t,n,i,s,o,l,p){let m=x_.moduleSpecifierToValidIdentifier(s,99),S=!1,h=[];if(Ko.Core.eachSymbolReferenceInFile(o,n,t,b=>{Hn(b.parent)&&(S=S||!!n.resolveName(m,b,-1,!0),i.has(n.getSymbolAtLocation(b.parent.name))&&h.push(b))}),h.length){let b=S?Nx(m,t):m;for(let A of h)e.replaceNode(t,A,j.createIdentifier(b));e.insertNodeAfter(t,l,txt(l,m,s,p))}}function txt(e,t,n,i){let s=j.createIdentifier(t),o=vk(n,i);switch(e.kind){case 272:return j.createImportDeclaration(void 0,j.createImportClause(!1,void 0,j.createNamespaceImport(s)),o,void 0);case 271:return j.createImportEqualsDeclaration(void 0,!1,s,j.createExternalModuleReference(o));case 260:return j.createVariableDeclaration(s,void 0,void 0,Lve(o));default:return I.assertNever(e,`Unexpected node kind ${e.kind}`)}}function Lve(e){return j.createCallExpression(j.createIdentifier("require"),void 0,[e])}function S7(e){return e.kind===272?e.moduleSpecifier:e.kind===271?e.moduleReference.expression:e.initializer.arguments[0]}function T7(e,t){if(uu(e))za(e.moduleSpecifier)&&t(e);else if(Ru(e))zh(e.moduleReference)&&bo(e.moduleReference.expression)&&t(e);else if(Xc(e))for(let n of e.declarationList.declarations)n.initializer&&_f(n.initializer,!0)&&t(n)}function Fve(e,t,n,i,s,o,l){let p,m=[];return t.forEach(S=>{S.escapedName==="default"?p=j.createIdentifier(mJ(S)):m.push(S.name)}),QJ(e,p,m,n,i,s,o,l)}function QJ(e,t,n,i,s,o,l,p){let m=Dv(hi(e.path),i),S=WU(s.getCompilerOptions(),e,e.fileName,m,kx(s,o));if(l){let h=n.map(b=>j.createImportSpecifier(!1,void 0,j.createIdentifier(b)));return P1e(t,h,S,p)}else{I.assert(!t,"No default import should exist");let h=n.map(b=>j.createBindingElement(void 0,void 0,b));return h.length?OFe(j.createObjectBindingPattern(h),void 0,Lve(vk(S,p))):void 0}}function OFe(e,t,n,i=2){return j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(e,void 0,t,n)],i))}function jve(e,t,n,i){return _a(t,s=>{if(MFe(s)&&!RFe(e,s,i)&&Wve(s,o=>{var l;return n.has(I.checkDefined((l=ii(o,qg))==null?void 0:l.symbol))})){let o=ixt(Sc(s),i);if(o)return o}return Sc(s)})}function RFe(e,t,n,i){var s;return n?!Ou(t)&&ui(t,32)||!!(i&&e.symbol&&((s=e.symbol.exports)!=null&&s.has(i.escapedText))):!!e.symbol&&!!e.symbol.exports&&Uve(t).some(o=>e.symbol.exports.has(Pc(o)))}function Bve(e,t,n,i){switch(t.kind){case 272:rxt(e,t,n,i);break;case 271:i(t.name)&&n.delete(e,t);break;case 260:nxt(e,t,n,i);break;default:I.assertNever(t,`Unexpected import decl kind ${t.kind}`)}}function rxt(e,t,n,i){if(!t.importClause)return;let{name:s,namedBindings:o}=t.importClause,l=!s||i(s),p=!o||(o.kind===274?i(o.name):o.elements.length!==0&&o.elements.every(m=>i(m.name)));if(l&&p)n.delete(e,t);else if(s&&l&&n.delete(e,s),o){if(p)n.replaceNode(e,t.importClause,j.updateImportClause(t.importClause,t.importClause.isTypeOnly,s,void 0));else if(o.kind===275)for(let m of o.elements)i(m.name)&&n.delete(e,m)}}function nxt(e,t,n,i){let{name:s}=t;switch(s.kind){case 80:i(s)&&(t.initializer&&_f(t.initializer,!0)?n.delete(e,Tu(t.parent)&&de(t.parent.declarations)===1?t.parent.parent:t):n.delete(e,s));break;case 207:break;case 206:if(s.elements.every(o=>ze(o.name)&&i(o.name)))n.delete(e,Tu(t.parent)&&t.parent.declarations.length===1?t.parent.parent:t);else for(let o of s.elements)ze(o.name)&&i(o.name)&&n.delete(e,o.name);break}}function MFe(e){return I.assert(ls(e.parent),"Node parent should be a SourceFile"),UFe(e)||Xc(e)}function ixt(e,t){return t?[sxt(e)]:axt(e)}function sxt(e){let t=Jm(e)?ys([j.createModifier(95)],jb(e)):void 0;switch(e.kind){case 262:return j.updateFunctionDeclaration(e,t,e.asteriskToken,e.name,e.typeParameters,e.parameters,e.type,e.body);case 263:let n=yx(e)?wv(e):void 0;return j.updateClassDeclaration(e,ys(n,t),e.name,e.typeParameters,e.heritageClauses,e.members);case 243:return j.updateVariableStatement(e,t,e.declarationList);case 267:return j.updateModuleDeclaration(e,t,e.name,e.body);case 266:return j.updateEnumDeclaration(e,t,e.name,e.members);case 265:return j.updateTypeAliasDeclaration(e,t,e.name,e.typeParameters,e.type);case 264:return j.updateInterfaceDeclaration(e,t,e.name,e.typeParameters,e.heritageClauses,e.members);case 271:return j.updateImportEqualsDeclaration(e,t,e.isTypeOnly,e.name,e.moduleReference);case 244:return I.fail();default:return I.assertNever(e,`Unexpected declaration kind ${e.kind}`)}}function axt(e){return[e,...Uve(e).map(LFe)]}function LFe(e){return j.createExpressionStatement(j.createBinaryExpression(j.createPropertyAccessExpression(j.createIdentifier("exports"),j.createIdentifier(e)),64,j.createIdentifier(e)))}function Uve(e){switch(e.kind){case 262:case 263:return[e.name.text];case 243:return Wi(e.declarationList.declarations,t=>ze(t.name)?t.name.text:void 0);case 267:case 266:case 265:case 264:case 271:return tt;case 244:return I.fail("Can't export an ExpressionStatement");default:return I.assertNever(e,`Unexpected decl kind ${e.kind}`)}}function b7(e,t,n){switch(e.kind){case 272:{let i=e.importClause;if(!i)return;let s=i.name&&n(i.name)?i.name:void 0,o=i.namedBindings&&oxt(i.namedBindings,n);return s||o?j.createImportDeclaration(void 0,j.createImportClause(i.isTypeOnly,s,o),Sc(t),void 0):void 0}case 271:return n(e.name)?e:void 0;case 260:{let i=cxt(e.name,n);return i?OFe(i,e.type,Lve(t),e.parent.flags):void 0}default:return I.assertNever(e,`Unexpected import kind ${e.kind}`)}}function oxt(e,t){if(e.kind===274)return t(e.name)?e:void 0;{let n=e.elements.filter(i=>t(i.name));return n.length?j.createNamedImports(n):void 0}}function cxt(e,t){switch(e.kind){case 80:return t(e)?e:void 0;case 207:return e;case 206:{let n=e.elements.filter(i=>i.propertyName||!ze(i.name)||t(i.name));return n.length?j.createObjectBindingPattern(n):void 0}}}function Vve(e){return Ou(e)?ii(e.expression.left.name,ze):ii(e.name,ze)}function wre(e){switch(e.kind){case 260:return e.parent.parent;case 208:return wre(ta(e.parent.parent,t=>Gi(t)||co(t)));default:return e}}function Jve(e,t,n,i,s){if(!RFe(e,t,s,n))if(s)Ou(t)||i.insertExportModifier(e,t);else{let o=Uve(t);o.length!==0&&i.insertNodesAfter(e,t,o.map(LFe))}}function qve(e,t,n,i){let s=t.getTypeChecker();if(i){let o=ZJ(e,i.all,s),l=hi(e.fileName),p=h6(e.fileName);return li(l,fxt(pxt(o.oldFileImportsFromTargetFile,o.movedSymbols),p,l,n))+p}return""}function lxt(e){let{file:t}=e,n=_J(Sk(e)),{statements:i}=t,s=oa(i,S=>S.end>n.pos);if(s===-1)return;let o=i[s],l=VFe(t,o);l&&(s=l.start);let p=oa(i,S=>S.end>=n.end,s);p!==-1&&n.end<=i[p].getStart()&&p--;let m=VFe(t,i[p]);return m&&(p=m.end),{toMove:i.slice(s,p===-1?i.length:p+1),afterLast:p===-1?void 0:i[p+1]}}function E7(e){let t=lxt(e);if(t===void 0)return;let n=[],i=[],{toMove:s,afterLast:o}=t;return Ev(s,uxt,(l,p)=>{for(let m=l;m<p;m++)n.push(s[m]);i.push({first:s[l],afterLast:o})}),n.length===0?void 0:{all:n,ranges:i}}function zve(e){return mr(e,t=>!!(t.transformFlags&2))}function uxt(e){return!_xt(e)&&!Fm(e)}function _xt(e){switch(e.kind){case 272:return!0;case 271:return!ui(e,32);case 243:return e.declarationList.declarations.every(t=>!!t.initializer&&_f(t.initializer,!0));default:return!1}}function ZJ(e,t,n,i=new Set){let s=new Set,o=new Map,l=new Set,p=h(zve(t));p&&o.set(p,!1);for(let b of t)Wve(b,A=>{s.add(I.checkDefined(Ou(A)?n.getSymbolAtLocation(A.expression.left):A.symbol,"Need a symbol here"))});let m=new Set;for(let b of t)$ve(b,n,(A,k)=>{if(A.declarations){if(i.has(r_(A,n))){m.add(A);return}for(let N of A.declarations)if(FFe(N)){let M=o.get(A);o.set(A,(M===void 0||M)&&k)}else eq(N)&&dxt(N)===e&&!s.has(A)&&l.add(A)}});for(let b of o.keys())m.add(b);let S=new Set;for(let b of e.statements)hs(t,b)||(p&&b.transformFlags&2&&m.delete(p),$ve(b,n,A=>{s.has(A)&&S.add(A),m.delete(A)}));return{movedSymbols:s,targetFileImportsFromOldFile:l,oldFileImportsFromTargetFile:S,oldImportsNeededByTargetFile:o,unusedImportsFromOldFile:m};function h(b){if(b===void 0)return;let A=n.getJsxNamespace(b),k=n.resolveName(A,b,1920,!0);return k&&Tt(k.declarations,FFe)?k:void 0}}function fxt(e,t,n,i){let s=e;for(let o=1;;o++){let l=li(n,s+t);if(!i.fileExists(l))return s;s=`${e}.${o}`}}function pxt(e,t){return Mh(e,mJ)||Mh(t,mJ)||"newFile"}function $ve(e,t,n){e.forEachChild(function i(s){if(ze(s)&&!Cy(s)){let o=t.getSymbolAtLocation(s);o&&n(o,ET(s))}else s.forEachChild(i)})}function Wve(e,t){switch(e.kind){case 262:case 263:case 267:case 266:case 265:case 264:case 271:return t(e);case 243:return Ct(e.declarationList.declarations,n=>BFe(n.name,t));case 244:{let{expression:n}=e;return bn(n)&&al(n)===1?t(e):void 0}}}function FFe(e){switch(e.kind){case 271:case 276:case 273:case 274:return!0;case 260:return jFe(e);case 208:return Gi(e.parent.parent)&&jFe(e.parent.parent);default:return!1}}function jFe(e){return ls(e.parent.parent.parent)&&!!e.initializer&&_f(e.initializer,!0)}function eq(e){return UFe(e)&&ls(e.parent)||Gi(e)&&ls(e.parent.parent.parent)}function dxt(e){return Gi(e)?e.parent.parent.parent:e.parent}function BFe(e,t){switch(e.kind){case 80:return t(ta(e.parent,n=>Gi(n)||co(n)));case 207:case 206:return Ct(e.elements,n=>Su(n)?void 0:BFe(n.name,t));default:return I.assertNever(e,`Unexpected name kind ${e.kind}`)}}function UFe(e){switch(e.kind){case 262:case 263:case 267:case 266:case 265:case 264:case 271:return!0;default:return!1}}function mxt(e,t,n,i,s){var o;let l=new Set,p=(o=i.symbol)==null?void 0:o.exports;if(p){let S=t.getTypeChecker(),h=new Map;for(let b of s.all)MFe(b)&&ui(b,32)&&Wve(b,A=>{var k;let N=qg(A)?(k=p.get(A.symbol.escapedName))==null?void 0:k.declarations:void 0,M=Ct(N,O=>yl(O)?O:R_(O)?ii(O.parent.parent,yl):void 0);M&&M.moduleSpecifier&&h.set(M,(h.get(M)||new Set).add(A))});for(let[b,A]of In(h))if(b.exportClause&&wd(b.exportClause)&&de(b.exportClause.elements)){let k=b.exportClause.elements,N=Fn(k,M=>mr(r_(M.symbol,S).declarations,O=>eq(O)&&A.has(O))===void 0);if(de(N)===0){e.deleteNode(i,b),l.add(b);continue}de(N)<de(k)&&e.replaceNode(i,b,j.updateExportDeclaration(b,b.modifiers,b.isTypeOnly,j.updateNamedExports(b.exportClause,j.createNodeArray(N,k.hasTrailingComma)),b.moduleSpecifier,b.attributes))}}let m=Da(i.statements,S=>yl(S)&&!!S.moduleSpecifier&&!l.has(S));m?e.insertNodesBefore(i,m,n,!0):e.insertNodesAfter(i,i.statements[i.statements.length-1],n)}function VFe(e,t){if(tc(t)){let n=t.symbol.declarations;if(n===void 0||de(n)<=1||!hs(n,t))return;let i=n[0],s=n[de(n)-1],o=Wi(n,m=>Xr(m)===e&&ns(m)?m:void 0),l=oa(e.statements,m=>m.end>=s.end),p=oa(e.statements,m=>m.end>=i.end);return{toMove:o,start:p,end:l}}}function gxt(e,t,n){let i=new Set;for(let s of e.imports){let o=Gw(s);if(uu(o)&&o.importClause&&o.importClause.namedBindings&&Dy(o.importClause.namedBindings))for(let l of o.importClause.namedBindings.elements){let p=n.getSymbolAtLocation(l.propertyName||l.name);p&&i.add(r_(p,n))}if(fj(o.parent)&&pm(o.parent.name))for(let l of o.parent.name.elements){let p=n.getSymbolAtLocation(l.propertyName||l.name);p&&i.add(r_(p,n))}}for(let s of t)$ve(s,n,o=>{let l=r_(o,n);l.valueDeclaration&&Xr(l.valueDeclaration)===e&&i.add(l)});return i}var tq,Ore,Rre,hxt=f({"src/services/refactors/moveToFile.ts"(){"use strict";Qhe(),yi(),SFe(),tq="Move to file",Ore=Gs(g.Move_to_file),Rre={name:"Move to file",description:Ore,kind:"refactor.move.file"},j0(tq,{kinds:[Rre.kind],getAvailableActions:function(t,n){let i=E7(t);return n?t.preferences.allowTextChangesInNewFiles&&i?[{name:tq,description:Ore,actions:[Rre]}]:t.preferences.provideRefactorNotApplicableReason?[{name:tq,description:Ore,actions:[{...Rre,notApplicableReason:Gs(g.Selection_is_not_a_valid_statement_or_statements)}]}]:tt:tt},getEditsForAction:function(t,n,i){I.assert(n===tq,"Wrong refactor invoked");let s=I.checkDefined(E7(t)),{host:o,program:l}=t;I.assert(i,"No interactive refactor arguments available");let p=i.targetFile;return rE(p)||LA(p)?o.fileExists(p)&&l.getSourceFile(p)===void 0?IFe(Gs(g.Cannot_move_statements_to_the_selected_file)):{edits:En.ChangeTracker.with(t,S=>K2t(t,t.file,i.targetFile,t.program,s,S,t.host,t.preferences)),renameFilename:void 0,renameLocation:void 0}:IFe(Gs(g.Cannot_move_to_file_selected_file_is_invalid))}})}});function yxt(e){let{file:t,startPosition:n,program:i}=e;return qFe(t,n,i)?[{name:Mre,description:Gve,actions:[Hve]}]:tt}function vxt(e){let{file:t,startPosition:n,program:i}=e,s=qFe(t,n,i);if(!s)return;let o=i.getTypeChecker(),l=s[s.length-1],p=l;switch(l.kind){case 173:{p=j.updateMethodSignature(l,l.modifiers,l.name,l.questionToken,l.typeParameters,S(s),l.type);break}case 174:{p=j.updateMethodDeclaration(l,l.modifiers,l.asteriskToken,l.name,l.questionToken,l.typeParameters,S(s),l.type,l.body);break}case 179:{p=j.updateCallSignature(l,l.typeParameters,S(s),l.type);break}case 176:{p=j.updateConstructorDeclaration(l,l.modifiers,S(s),l.body);break}case 180:{p=j.updateConstructSignature(l,l.typeParameters,S(s),l.type);break}case 262:{p=j.updateFunctionDeclaration(l,l.modifiers,l.asteriskToken,l.name,l.typeParameters,S(s),l.type,l.body);break}default:return I.failBadSyntaxKind(l,"Unhandled signature kind in overload list conversion refactoring")}if(p===l)return;return{renameFilename:void 0,renameLocation:void 0,edits:En.ChangeTracker.with(e,A=>{A.replaceNodeRange(t,s[0],s[s.length-1],p)})};function S(A){let k=A[A.length-1];return tc(k)&&k.body&&(A=A.slice(0,A.length-1)),j.createNodeArray([j.createParameterDeclaration(void 0,j.createToken(26),"args",void 0,j.createUnionTypeNode(vr(A,h)))])}function h(A){let k=vr(A.parameters,b);return Sn(j.createTupleTypeNode(k),Tt(k,N=>!!de(BN(N)))?0:1)}function b(A){I.assert(ze(A.name));let k=ft(j.createNamedTupleMember(A.dotDotDotToken,A.name,A.questionToken,A.type||j.createKeywordTypeNode(133)),A),N=A.symbol&&A.symbol.getDocumentationComment(o);if(N){let M=D7(N);M.length&&CT(k,[{text:`*
${M.split(`
`).map(O=>` * ${O}`).join(`
`)}
 `,kind:3,pos:-1,end:-1,hasTrailingNewLine:!0,hasLeadingNewline:!0}])}return k}}function JFe(e){switch(e.kind){case 173:case 174:case 179:case 176:case 180:case 262:return!0}return!1}function qFe(e,t,n){let i=Ts(e,t),s=Gr(i,JFe);if(!s||tc(s)&&s.body&&HM(s.body,t))return;let o=n.getTypeChecker(),l=s.symbol;if(!l)return;let p=l.declarations;if(de(p)<=1||!yr(p,A=>Xr(A)===e)||!JFe(p[0]))return;let m=p[0].kind;if(!yr(p,A=>A.kind===m))return;let S=p;if(Tt(S,A=>!!A.typeParameters||Tt(A.parameters,k=>!!k.modifiers||!ze(k.name))))return;let h=Wi(S,A=>o.getSignatureFromDeclaration(A));if(de(h)!==de(p))return;let b=o.getReturnTypeOfSignature(h[0]);if(yr(h,A=>o.getReturnTypeOfSignature(A)===b))return S}var Mre,Gve,Hve,Sxt=f({"src/services/refactors/convertOverloadListToSingleSignature.ts"(){"use strict";yi(),Gh(),Mre="Convert overload list to single signature",Gve=Gs(g.Convert_overload_list_to_single_signature),Hve={name:Mre,description:Gve,kind:"refactor.rewrite.function.overloadList"},j0(Mre,{kinds:[Hve.kind],getEditsForAction:vxt,getAvailableActions:yxt})}});function Txt(e){let{file:t,startPosition:n,triggerReason:i}=e,s=zFe(t,n,i==="invoked");return s?Ry(s)?e.preferences.provideRefactorNotApplicableReason?[{name:Lre,description:Yve,actions:[{...rq,notApplicableReason:s.error},{...x7,notApplicableReason:s.error}]}]:tt:[{name:Lre,description:Yve,actions:[s.addBraces?rq:x7]}]:tt}function bxt(e,t){let{file:n,startPosition:i}=e,s=zFe(n,i);I.assert(s&&!Ry(s),"Expected applicable refactor info");let{expression:o,returnStatement:l,func:p}=s,m;if(t===rq.name){let h=j.createReturnStatement(o);m=j.createBlock([h],!0),kD(o,h,n,3,!0)}else if(t===x7.name&&l){let h=o||j.createVoidZero();m=bJ(h)?j.createParenthesizedExpression(h):h,l7(l,m,n,3,!1),kD(l,m,n,3,!1),DO(l,m,n,3,!1)}else I.fail("invalid action");return{renameFilename:void 0,renameLocation:void 0,edits:En.ChangeTracker.with(e,h=>{h.replaceNode(n,p.body,m)})}}function zFe(e,t,n=!0,i){let s=Ts(e,t),o=Vp(s);if(!o)return{error:Gs(g.Could_not_find_a_containing_arrow_function)};if(!rc(o))return{error:Gs(g.Containing_function_is_not_an_arrow_function)};if(!(!ud(o,s)||ud(o.body,s)&&!n)){if(BT(rq.kind,i)&&bt(o.body))return{func:o,addBraces:!0,expression:o.body};if(BT(x7.kind,i)&&ra(o.body)&&o.body.statements.length===1){let l=di(o.body.statements);if(Um(l)){let p=l.expression&&Ha(IN(l.expression,!1))?j.createParenthesizedExpression(l.expression):l.expression;return{func:o,addBraces:!1,expression:p,returnStatement:l}}}}}var Lre,Yve,rq,x7,Ext=f({"src/services/refactors/addOrRemoveBracesToArrowFunction.ts"(){"use strict";yi(),Gh(),Lre="Add or remove braces in an arrow function",Yve=Gs(g.Add_or_remove_braces_in_an_arrow_function),rq={name:"Add braces to arrow function",description:Gs(g.Add_braces_to_arrow_function),kind:"refactor.rewrite.arrow.braces.add"},x7={name:"Remove braces from arrow function",description:Gs(g.Remove_braces_from_arrow_function),kind:"refactor.rewrite.arrow.braces.remove"},j0(Lre,{kinds:[x7.kind],getEditsForAction:bxt,getAvailableActions:Txt})}}),xxt={},Cxt=f({"src/services/_namespaces/ts.refactor.addOrRemoveBracesToArrowFunction.ts"(){"use strict";Sxt(),Ext()}});function Axt(e){let{file:t,startPosition:n,program:i,kind:s}=e,o=WFe(t,n,i);if(!o)return tt;let{selectedVariableDeclaration:l,func:p}=o,m=[],S=[];if(BT(A7.kind,s)){let h=l||rc(p)&&Gi(p.parent)?void 0:Gs(g.Could_not_convert_to_named_function);h?S.push({...A7,notApplicableReason:h}):m.push(A7)}if(BT(C7.kind,s)){let h=!l&&rc(p)?void 0:Gs(g.Could_not_convert_to_anonymous_function);h?S.push({...C7,notApplicableReason:h}):m.push(C7)}if(BT(k7.kind,s)){let h=Xo(p)?void 0:Gs(g.Could_not_convert_to_arrow_function);h?S.push({...k7,notApplicableReason:h}):m.push(k7)}return[{name:Xve,description:YFe,actions:m.length===0&&e.preferences.provideRefactorNotApplicableReason?S:m}]}function kxt(e,t){let{file:n,startPosition:i,program:s}=e,o=WFe(n,i,s);if(!o)return;let{func:l}=o,p=[];switch(t){case C7.name:p.push(...Ixt(e,l));break;case A7.name:let m=Dxt(l);if(!m)return;p.push(...wxt(e,l,m));break;case k7.name:if(!Xo(l))return;p.push(...Oxt(e,l));break;default:return I.fail("invalid action")}return{renameFilename:void 0,renameLocation:void 0,edits:p}}function $Fe(e){let t=!1;return e.forEachChild(function n(i){if(TD(i)){t=!0;return}!Ti(i)&&!Zl(i)&&!Xo(i)&&Qs(i,n)}),t}function WFe(e,t,n){let i=Ts(e,t),s=n.getTypeChecker(),o=Nxt(e,s,i.parent);if(o&&!$Fe(o.body)&&!s.containsArgumentsReference(o))return{selectedVariableDeclaration:!0,func:o};let l=Vp(i);if(l&&(Xo(l)||rc(l))&&!ud(l.body,i)&&!$Fe(l.body)&&!s.containsArgumentsReference(l))return Xo(l)&&HFe(e,s,l)?void 0:{selectedVariableDeclaration:!1,func:l}}function Pxt(e){return Gi(e)||Tu(e)&&e.declarations.length===1}function Nxt(e,t,n){if(!Pxt(n))return;let s=(Gi(n)?n:di(n.declarations)).initializer;if(s&&(rc(s)||Xo(s)&&!HFe(e,t,s)))return s}function GFe(e){if(bt(e)){let t=j.createReturnStatement(e),n=e.getSourceFile();return ft(t,e),hp(t),l7(e,t,n,void 0,!0),j.createBlock([t],!0)}else return e}function Dxt(e){let t=e.parent;if(!Gi(t)||!Jw(t))return;let n=t.parent,i=n.parent;if(!(!Tu(n)||!Xc(i)||!ze(t.name)))return{variableDeclaration:t,variableDeclarationList:n,statement:i,name:t.name}}function Ixt(e,t){let{file:n}=e,i=GFe(t.body),s=j.createFunctionExpression(t.modifiers,t.asteriskToken,void 0,t.typeParameters,t.parameters,t.type,i);return En.ChangeTracker.with(e,o=>o.replaceNode(n,t,s))}function wxt(e,t,n){let{file:i}=e,s=GFe(t.body),{variableDeclaration:o,variableDeclarationList:l,statement:p,name:m}=n;Fte(p);let S=lT(o)&32|X_(t),h=j.createModifiersFromModifierFlags(S),b=j.createFunctionDeclaration(de(h)?h:void 0,t.asteriskToken,m,t.typeParameters,t.parameters,t.type,s);return l.declarations.length===1?En.ChangeTracker.with(e,A=>A.replaceNode(i,p,b)):En.ChangeTracker.with(e,A=>{A.delete(i,o),A.insertNodeAfter(i,p,b)})}function Oxt(e,t){let{file:n}=e,s=t.body.statements[0],o;Rxt(t.body,s)?(o=s.expression,hp(o),Px(s,o)):o=t.body;let l=j.createArrowFunction(t.modifiers,t.typeParameters,t.parameters,t.type,j.createToken(39),o);return En.ChangeTracker.with(e,p=>p.replaceNode(n,t,l))}function Rxt(e,t){return e.statements.length===1&&Um(t)&&!!t.expression}function HFe(e,t,n){return!!n.name&&Ko.Core.isSymbolReferencedInFile(n.name,t,e)}var Xve,YFe,C7,A7,k7,Mxt=f({"src/services/refactors/convertArrowFunctionOrFunctionExpression.ts"(){"use strict";yi(),Gh(),Xve="Convert arrow function or function expression",YFe=Gs(g.Convert_arrow_function_or_function_expression),C7={name:"Convert to anonymous function",description:Gs(g.Convert_to_anonymous_function),kind:"refactor.rewrite.function.anonymous"},A7={name:"Convert to named function",description:Gs(g.Convert_to_named_function),kind:"refactor.rewrite.function.named"},k7={name:"Convert to arrow function",description:Gs(g.Convert_to_arrow_function),kind:"refactor.rewrite.function.arrow"},j0(Xve,{kinds:[C7.kind,A7.kind,k7.kind],getEditsForAction:kxt,getAvailableActions:Axt})}}),Lxt={},Fxt=f({"src/services/_namespaces/ts.refactor.convertArrowFunctionOrFunctionExpression.ts"(){"use strict";Mxt()}});function jxt(e){let{file:t,startPosition:n}=e;return Y_(t)||!QFe(t,n,e.program.getTypeChecker())?tt:[{name:iq,description:eSe,actions:[tSe]}]}function Bxt(e,t){I.assert(t===iq,"Unexpected action name");let{file:n,startPosition:i,program:s,cancellationToken:o,host:l}=e,p=QFe(n,i,s.getTypeChecker());if(!p||!o)return;let m=Vxt(p,s,o);return m.valid?{renameFilename:void 0,renameLocation:void 0,edits:En.ChangeTracker.with(e,h=>Uxt(n,s,l,h,p,m))}:{edits:[]}}function Uxt(e,t,n,i,s,o){let l=o.signature,p=vr(r5e(s,t,n),h=>Sc(h));if(l){let h=vr(r5e(l,t,n),b=>Sc(b));S(l,h)}S(s,p);let m=rT(o.functionCalls,(h,b)=>To(h.pos,b.pos));for(let h of m)if(h.arguments&&h.arguments.length){let b=Sc(Kxt(s,h.arguments),!0);i.replaceNodeRange(Xr(h),di(h.arguments),Rs(h.arguments),b,{leadingTriviaOption:En.LeadingTriviaOption.IncludeAll,trailingTriviaOption:En.TrailingTriviaOption.Include})}function S(h,b){i.replaceNodeRangeWithNodes(e,di(h.parameters),Rs(h.parameters),b,{joiner:", ",indentation:0,leadingTriviaOption:En.LeadingTriviaOption.IncludeAll,trailingTriviaOption:En.TrailingTriviaOption.Include})}}function Vxt(e,t,n){let i=Zxt(e),s=Yc(e)?Qxt(e):[],o=Dh([...i,...s],Dm),l=t.getTypeChecker(),p=_a(o,b=>Ko.getReferenceEntriesForNode(-1,b,t,t.getSourceFiles(),n)),m=S(p);return yr(m.declarations,b=>hs(o,b))||(m.valid=!1),m;function S(b){let A={accessExpressions:[],typeUsages:[]},k={functionCalls:[],declarations:[],classReferences:A,valid:!0},N=vr(i,h),M=vr(s,h),O=Yc(e),U=vr(i,H=>Kve(H,l));for(let H of b){if(H.kind===Ko.EntryKind.Span){k.valid=!1;continue}if(hs(U,h(H.node))){if($xt(H.node.parent)){k.signature=H.node.parent;continue}let re=KFe(H);if(re){k.functionCalls.push(re);continue}}let K=Kve(H.node,l);if(K&&hs(U,K)){let re=Qve(H);if(re){k.declarations.push(re);continue}}if(hs(N,h(H.node))||bO(H.node)){if(XFe(H))continue;let $=Qve(H);if($){k.declarations.push($);continue}let pe=KFe(H);if(pe){k.functionCalls.push(pe);continue}}if(O&&hs(M,h(H.node))){if(XFe(H))continue;let $=Qve(H);if($){k.declarations.push($);continue}let pe=Jxt(H);if(pe){A.accessExpressions.push(pe);continue}if(eu(e.parent)){let z=qxt(H);if(z){A.typeUsages.push(z);continue}}}k.valid=!1}return k}function h(b){let A=l.getSymbolAtLocation(b);return A&&Mte(A,l)}}function Kve(e,t){let n=I7(e);if(n){let i=t.getContextualTypeForObjectLiteralElement(n),s=i?.getSymbol();if(s&&!(Vc(s)&6))return s}}function XFe(e){let t=e.node;if(Gf(t.parent)||Jh(t.parent)||Ru(t.parent)||tS(t.parent)||R_(t.parent)||Kc(t.parent))return t}function Qve(e){if(O_(e.node.parent))return e.node}function KFe(e){if(e.node.parent){let t=e.node,n=t.parent;switch(n.kind){case 213:case 214:let i=ii(n,Jg);if(i&&i.expression===t)return i;break;case 211:let s=ii(n,Hn);if(s&&s.parent&&s.name===t){let l=ii(s.parent,Jg);if(l&&l.expression===s)return l}break;case 212:let o=ii(n,fc);if(o&&o.parent&&o.argumentExpression===t){let l=ii(o.parent,Jg);if(l&&l.expression===o)return l}break}}}function Jxt(e){if(e.node.parent){let t=e.node,n=t.parent;switch(n.kind){case 211:let i=ii(n,Hn);if(i&&i.expression===t)return i;break;case 212:let s=ii(n,fc);if(s&&s.expression===t)return s;break}}}function qxt(e){let t=e.node;if(Cx(t)===2||Oj(t.parent))return t}function QFe(e,t,n){let i=bD(e,t),s=yde(i);if(!zxt(i)&&s&&Wxt(s,n)&&ud(s,i)&&!(s.body&&ud(s.body,i)))return s}function zxt(e){let t=Gr(e,ZP);if(t){let n=Gr(t,i=>!ZP(i));return!!n&&tc(n)}return!1}function $xt(e){return Uh(e)&&(ef(e.parent)||dp(e.parent))}function Wxt(e,t){var n;if(!Gxt(e.parameters,t))return!1;switch(e.kind){case 262:return ZFe(e)&&nq(e,t);case 174:if(Ha(e.parent)){let i=Kve(e.name,t);return((n=i?.declarations)==null?void 0:n.length)===1&&nq(e,t)}return nq(e,t);case 176:return eu(e.parent)?ZFe(e.parent)&&nq(e,t):e5e(e.parent.parent)&&nq(e,t);case 218:case 219:return e5e(e.parent)}return!1}function nq(e,t){return!!e.body&&!t.isImplementationOfOverload(e)}function ZFe(e){return e.name?!0:!!xD(e,90)}function Gxt(e,t){return Yxt(e)>=n5e&&yr(e,n=>Hxt(n,t))}function Hxt(e,t){if(x0(e)){let n=t.getTypeAtLocation(e);if(!t.isArrayType(n)&&!t.isTupleType(n))return!1}return!e.modifiers&&ze(e.name)}function e5e(e){return Gi(e)&&aN(e)&&ze(e.name)&&!e.type}function Zve(e){return e.length>0&&TD(e[0].name)}function Yxt(e){return Zve(e)?e.length-1:e.length}function t5e(e){return Zve(e)&&(e=j.createNodeArray(e.slice(1),e.hasTrailingComma)),e}function Xxt(e,t){return ze(t)&&om(t)===e?j.createShorthandPropertyAssignment(e):j.createPropertyAssignment(e,t)}function Kxt(e,t){let n=t5e(e.parameters),i=x0(Rs(n)),s=i?t.slice(0,n.length-1):t,o=vr(s,(p,m)=>{let S=Fre(n[m]),h=Xxt(S,p);return hp(h.name),Ul(h)&&hp(h.initializer),Px(p,h),h});if(i&&t.length>=n.length){let p=t.slice(n.length-1),m=j.createPropertyAssignment(Fre(Rs(n)),j.createArrayLiteralExpression(p));o.push(m)}return j.createObjectLiteralExpression(o,!1)}function r5e(e,t,n){let i=t.getTypeChecker(),s=t5e(e.parameters),o=vr(s,h),l=j.createObjectBindingPattern(o),p=b(s),m;yr(s,N)&&(m=j.createObjectLiteralExpression());let S=j.createParameterDeclaration(void 0,void 0,l,void 0,p,m);if(Zve(e.parameters)){let M=e.parameters[0],O=j.createParameterDeclaration(void 0,void 0,M.name,void 0,M.type);return hp(O.name),Px(M.name,O.name),M.type&&(hp(O.type),Px(M.type,O.type)),j.createNodeArray([O,S])}return j.createNodeArray([S]);function h(M){let O=j.createBindingElement(void 0,void 0,Fre(M),x0(M)&&N(M)?j.createArrayLiteralExpression():M.initializer);return hp(O),M.initializer&&O.initializer&&Px(M.initializer,O.initializer),O}function b(M){let O=vr(M,A);return Kg(j.createTypeLiteralNode(O),1)}function A(M){let O=M.type;!O&&(M.initializer||x0(M))&&(O=k(M));let U=j.createPropertySignature(void 0,Fre(M),N(M)?j.createToken(58):M.questionToken,O);return hp(U),Px(M.name,U.name),M.type&&U.type&&Px(M.type,U.type),U}function k(M){let O=i.getTypeAtLocation(M);return wO(O,M,t,n)}function N(M){if(x0(M)){let O=i.getTypeAtLocation(M);return!i.isTupleType(O)}return i.isOptionalParameter(M)}}function Fre(e){return om(e.name)}function Qxt(e){switch(e.parent.kind){case 263:let t=e.parent;return t.name?[t.name]:[I.checkDefined(xD(t,90),"Nameless class declaration should be a default export")];case 231:let i=e.parent,s=e.parent.parent,o=i.name;return o?[o,s.name]:[s.name]}}function Zxt(e){switch(e.kind){case 262:return e.name?[e.name]:[I.checkDefined(xD(e,90),"Nameless function declaration should be a default export")];case 174:return[e.name];case 176:let n=I.checkDefined(Oo(e,137,e.getSourceFile()),"Constructor declaration should have constructor keyword");return e.parent.kind===231?[e.parent.parent.name,n]:[n];case 219:return[e.parent.name];case 218:return e.name?[e.name,e.parent.name]:[e.parent.name];default:return I.assertNever(e,`Unexpected function declaration kind ${e.kind}`)}}var iq,n5e,eSe,tSe,eCt=f({"src/services/refactors/convertParamsToDestructuredObject.ts"(){"use strict";yi(),Gh(),iq="Convert parameters to destructured object",n5e=1,eSe=Gs(g.Convert_parameters_to_destructured_object),tSe={name:iq,description:eSe,kind:"refactor.rewrite.parameters.toDestructured"},j0(iq,{kinds:[tSe.kind],getEditsForAction:Bxt,getAvailableActions:jxt})}}),tCt={},rCt=f({"src/services/_namespaces/ts.refactor.convertParamsToDestructuredObject.ts"(){"use strict";eCt()}});function nCt(e){let{file:t,startPosition:n}=e,i=i5e(t,n),s=rSe(i),o=za(s),l={name:jre,description:Bre,actions:[]};return o&&e.triggerReason!=="invoked"?tt:k0(s)&&(o||bn(s)&&nSe(s).isValidConcatenation)?(l.actions.push(Ure),[l]):e.preferences.provideRefactorNotApplicableReason?(l.actions.push({...Ure,notApplicableReason:Gs(g.Can_only_convert_string_concatenations_and_string_literals)}),[l]):tt}function i5e(e,t){let n=Ts(e,t),i=rSe(n);return!nSe(i).isValidConcatenation&&Df(i.parent)&&bn(i.parent.parent)?i.parent.parent:n}function iCt(e,t){let{file:n,startPosition:i}=e,s=i5e(n,i);switch(t){case Bre:return{edits:sCt(e,s)};default:return I.fail("invalid action")}}function sCt(e,t){let n=rSe(t),i=e.file,s=cCt(nSe(n),i),o=aT(i.text,n.end);if(o){let l=o[o.length-1],p={pos:o[0].pos,end:l.end};return En.ChangeTracker.with(e,m=>{m.deleteRange(i,p),m.replaceNode(i,n,s)})}else return En.ChangeTracker.with(e,l=>l.replaceNode(i,n,s))}function aCt(e){return!(e.operatorToken.kind===64||e.operatorToken.kind===65)}function rSe(e){return Gr(e.parent,n=>{switch(n.kind){case 211:case 212:return!1;case 228:case 226:return!(bn(n.parent)&&aCt(n.parent));default:return"quit"}})||e}function nSe(e){let t=l=>{if(!bn(l))return{nodes:[l],operators:[],validOperators:!0,hasString:za(l)||zA(l)};let{nodes:p,operators:m,hasString:S,validOperators:h}=t(l.left);if(!(S||za(l.right)||iU(l.right)))return{nodes:[l],operators:[],hasString:!1,validOperators:!0};let b=l.operatorToken.kind===40,A=h&&b;return p.push(l.right),m.push(l.operatorToken),{nodes:p,operators:m,hasString:!0,validOperators:A}},{nodes:n,operators:i,validOperators:s,hasString:o}=t(e);return{nodes:n,operators:i,isValidConcatenation:s&&o}}function oCt(e){return e.replace(/\\.|[$`]/g,t=>t[0]==="\\"?t:"\\"+t)}function s5e(e){let t=$A(e)||DK(e)?-2:-1;return Fl(e).slice(1,t)}function a5e(e,t){let n=[],i="",s="";for(;e<t.length;){let o=t[e];if(bo(o))i+=o.text,s+=oCt(Fl(o).slice(1,-1)),n.push(e),e++;else if(iU(o)){i+=o.head.text,s+=s5e(o.head);break}else break}return[e,i,s,n]}function cCt({nodes:e,operators:t},n){let i=c5e(t,n),s=l5e(e,n,i),[o,l,p,m]=a5e(0,e);if(o===e.length){let b=j.createNoSubstitutionTemplateLiteral(l,p);return s(m,b),b}let S=[],h=j.createTemplateHead(l,p);s(m,h);for(let b=o;b<e.length;b++){let A=lCt(e[b]);i(b,A);let[k,N,M,O]=a5e(b+1,e);b=k-1;let U=b===e.length-1;if(iU(A)){let H=vr(A.templateSpans,(K,re)=>{o5e(K);let $=re===A.templateSpans.length-1,pe=K.literal.text+($?N:""),z=s5e(K.literal)+($?M:"");return j.createTemplateSpan(K.expression,U&&$?j.createTemplateTail(pe,z):j.createTemplateMiddle(pe,z))});S.push(...H)}else{let H=U?j.createTemplateTail(N,M):j.createTemplateMiddle(N,M);s(O,H),S.push(j.createTemplateSpan(A,H))}}return j.createTemplateExpression(h,S)}function o5e(e){let t=e.getSourceFile();DO(e,e.expression,t,3,!1),l7(e.expression,e.expression,t,3,!1)}function lCt(e){return Df(e)&&(o5e(e),e=e.expression),e}var jre,Bre,Ure,c5e,l5e,uCt=f({"src/services/refactors/convertStringOrTemplateLiteral.ts"(){"use strict";yi(),Gh(),jre="Convert to template string",Bre=Gs(g.Convert_to_template_string),Ure={name:jre,description:Bre,kind:"refactor.rewrite.string"},j0(jre,{kinds:[Ure.kind],getEditsForAction:iCt,getAvailableActions:nCt}),c5e=(e,t)=>(n,i)=>{n<e.length&&DO(e[n],i,t,3,!1)},l5e=(e,t,n)=>(i,s)=>{for(;i.length>0;){let o=i.shift();DO(e[o],s,t,3,!1),n(o,s)}}}}),_Ct={},fCt=f({"src/services/_namespaces/ts.refactor.convertStringOrTemplateLiteral.ts"(){"use strict";uCt()}});function pCt(e){let t=u5e(e,e.triggerReason==="invoked");return t?Ry(t)?e.preferences.provideRefactorNotApplicableReason?[{name:sq,description:qre,actions:[{...zre,notApplicableReason:t.error}]}]:tt:[{name:sq,description:qre,actions:[zre]}]:tt}function dCt(e,t){let n=u5e(e);return I.assert(n&&!Ry(n),"Expected applicable refactor info"),{edits:En.ChangeTracker.with(e,s=>bCt(e.file,e.program.getTypeChecker(),s,n,t)),renameFilename:void 0,renameLocation:void 0}}function Vre(e){return bn(e)||$N(e)}function mCt(e){return Ou(e)||Um(e)||Xc(e)}function Jre(e){return Vre(e)||mCt(e)}function u5e(e,t=!0){let{file:n,program:i}=e,s=Sk(e),o=s.length===0;if(o&&!t)return;let l=Ts(n,s.start),p=aJ(n,s.start+s.length),m=Ll(l.pos,p&&p.end>=l.pos?p.getEnd():l.getEnd()),S=o?SCt(l):vCt(l,m),h=S&&Jre(S)?TCt(S):void 0;if(!h)return{error:Gs(g.Could_not_find_convertible_access_expression)};let b=i.getTypeChecker();return $N(h)?gCt(h,b):hCt(h)}function gCt(e,t){let n=e.condition,i=sSe(e.whenTrue);if(!i||t.isNullableType(t.getTypeAtLocation(i)))return{error:Gs(g.Could_not_find_convertible_access_expression)};if((Hn(n)||ze(n))&&iSe(n,i.expression))return{finalExpression:i,occurrences:[n],expression:e};if(bn(n)){let s=_5e(i.expression,n);return s?{finalExpression:i,occurrences:s,expression:e}:{error:Gs(g.Could_not_find_matching_access_expressions)}}}function hCt(e){if(e.operatorToken.kind!==56)return{error:Gs(g.Can_only_convert_logical_AND_access_chains)};let t=sSe(e.right);if(!t)return{error:Gs(g.Could_not_find_convertible_access_expression)};let n=_5e(t.expression,e.left);return n?{finalExpression:t,occurrences:n,expression:e}:{error:Gs(g.Could_not_find_matching_access_expressions)}}function _5e(e,t){let n=[];for(;bn(t)&&t.operatorToken.kind===56;){let s=iSe(Do(e),Do(t.right));if(!s)break;n.push(s),e=s,t=t.left}let i=iSe(e,t);return i&&n.push(i),n.length>0?n:void 0}function iSe(e,t){if(!(!ze(t)&&!Hn(t)&&!fc(t)))return yCt(e,t)?t:void 0}function yCt(e,t){for(;(da(e)||Hn(e)||fc(e))&&P7(e)!==P7(t);)e=e.expression;for(;Hn(e)&&Hn(t)||fc(e)&&fc(t);){if(P7(e)!==P7(t))return!1;e=e.expression,t=t.expression}return ze(e)&&ze(t)&&e.getText()===t.getText()}function P7(e){if(ze(e)||id(e))return e.getText();if(Hn(e))return P7(e.name);if(fc(e))return P7(e.argumentExpression)}function vCt(e,t){for(;e.parent;){if(Jre(e)&&t.length!==0&&e.end>=t.start+t.length)return e;e=e.parent}}function SCt(e){for(;e.parent;){if(Jre(e)&&!Jre(e.parent))return e;e=e.parent}}function TCt(e){if(Vre(e))return e;if(Xc(e)){let t=AA(e),n=t?.initializer;return n&&Vre(n)?n:void 0}return e.expression&&Vre(e.expression)?e.expression:void 0}function sSe(e){if(e=Do(e),bn(e))return sSe(e.left);if((Hn(e)||fc(e)||da(e))&&!w_(e))return e}function f5e(e,t,n){if(Hn(t)||fc(t)||da(t)){let i=f5e(e,t.expression,n),s=n.length>0?n[n.length-1]:void 0,o=s?.getText()===t.expression.getText();if(o&&n.pop(),da(t))return o?j.createCallChain(i,j.createToken(29),t.typeArguments,t.arguments):j.createCallChain(i,t.questionDotToken,t.typeArguments,t.arguments);if(Hn(t))return o?j.createPropertyAccessChain(i,j.createToken(29),t.name):j.createPropertyAccessChain(i,t.questionDotToken,t.name);if(fc(t))return o?j.createElementAccessChain(i,j.createToken(29),t.argumentExpression):j.createElementAccessChain(i,t.questionDotToken,t.argumentExpression)}return t}function bCt(e,t,n,i,s){let{finalExpression:o,occurrences:l,expression:p}=i,m=l[l.length-1],S=f5e(t,o,l);S&&(Hn(S)||fc(S)||da(S))&&(bn(p)?n.replaceNodeRange(e,m,o,S):$N(p)&&n.replaceNode(e,p,j.createBinaryExpression(S,j.createToken(61),p.whenFalse)))}var sq,qre,zre,ECt=f({"src/services/refactors/convertToOptionalChainExpression.ts"(){"use strict";yi(),Gh(),sq="Convert to optional chain expression",qre=Gs(g.Convert_to_optional_chain_expression),zre={name:sq,description:qre,kind:"refactor.rewrite.expression.optionalChain"},j0(sq,{kinds:[zre.kind],getEditsForAction:dCt,getAvailableActions:pCt})}}),xCt={},CCt=f({"src/services/_namespaces/ts.refactor.convertToOptionalChainExpression.ts"(){"use strict";ECt()}});function p5e(e){let t=e.kind,n=aSe(e.file,Sk(e),e.triggerReason==="invoked"),i=n.targetRange;if(i===void 0){if(!n.errors||n.errors.length===0||!e.preferences.provideRefactorNotApplicableReason)return tt;let N=[];return BT(OD.kind,t)&&N.push({name:ID,description:OD.description,actions:[{...OD,notApplicableReason:k(n.errors)}]}),BT(wD.kind,t)&&N.push({name:ID,description:wD.description,actions:[{...wD,notApplicableReason:k(n.errors)}]}),N}let s=ICt(i,e);if(s===void 0)return tt;let o=[],l=new Map,p,m=[],S=new Map,h,b=0;for(let{functionExtraction:N,constantExtraction:M}of s){if(BT(OD.kind,t)){let O=N.description;N.errors.length===0?l.has(O)||(l.set(O,!0),o.push({description:O,name:`function_scope_${b}`,kind:OD.kind})):p||(p={description:O,name:`function_scope_${b}`,notApplicableReason:k(N.errors),kind:OD.kind})}if(BT(wD.kind,t)){let O=M.description;M.errors.length===0?S.has(O)||(S.set(O,!0),m.push({description:O,name:`constant_scope_${b}`,kind:wD.kind})):h||(h={description:O,name:`constant_scope_${b}`,notApplicableReason:k(M.errors),kind:wD.kind})}b++}let A=[];return o.length?A.push({name:ID,description:Gs(g.Extract_function),actions:o}):e.preferences.provideRefactorNotApplicableReason&&p&&A.push({name:ID,description:Gs(g.Extract_function),actions:[p]}),m.length?A.push({name:ID,description:Gs(g.Extract_constant),actions:m}):e.preferences.provideRefactorNotApplicableReason&&h&&A.push({name:ID,description:Gs(g.Extract_constant),actions:[h]}),A.length?A:tt;function k(N){let M=N[0].messageText;return typeof M!="string"&&(M=M.messageText),M}}function d5e(e,t){let i=aSe(e.file,Sk(e)).targetRange,s=/^function_scope_(\d+)$/.exec(t);if(s){let l=+s[1];return I.assert(isFinite(l),"Expected to parse a finite number from the function scope index"),NCt(i,e,l)}let o=/^constant_scope_(\d+)$/.exec(t);if(o){let l=+o[1];return I.assert(isFinite(l),"Expected to parse a finite number from the constant scope index"),DCt(i,e,l)}I.fail("Unrecognized action name")}function aSe(e,t,n=!0){let{length:i}=t;if(i===0&&!n)return{errors:[Iu(e,t.start,i,s_.cannotExtractEmpty)]};let s=i===0&&n,o=d1e(e,t.start),l=aJ(e,gl(t)),p=o&&l&&n?ACt(o,l,e):t,m=s?KCt(o):s7(o,e,p),S=s?m:s7(l,e,p),h=0,b;if(!m||!S)return{errors:[Iu(e,t.start,i,s_.cannotExtractRange)]};if(m.flags&16777216)return{errors:[Iu(e,t.start,i,s_.cannotExtractJSDoc)]};if(m.parent!==S.parent)return{errors:[Iu(e,t.start,i,s_.cannotExtractRange)]};if(m!==S){if(!g5e(m.parent))return{errors:[Iu(e,t.start,i,s_.cannotExtractRange)]};let H=[];for(let K of m.parent.statements){if(K===m||H.length){let re=U(K);if(re)return{errors:re};H.push(K)}if(K===S)break}return H.length?{targetRange:{range:H,facts:h,thisNode:b}}:{errors:[Iu(e,t.start,i,s_.cannotExtractRange)]}}if(Um(m)&&!m.expression)return{errors:[Iu(e,t.start,i,s_.cannotExtractRange)]};let A=N(m),k=M(A)||U(A);if(k)return{errors:k};return{targetRange:{range:kCt(A),facts:h,thisNode:b}};function N(H){if(Um(H)){if(H.expression)return H.expression}else if(Xc(H)||Tu(H)){let K=Xc(H)?H.declarationList.declarations:H.declarations,re=0,$;for(let pe of K)pe.initializer&&(re++,$=pe.initializer);if(re===1)return $}else if(Gi(H)&&H.initializer)return H.initializer;return H}function M(H){if(ze(Ou(H)?H.expression:H))return[$n(H,s_.cannotExtractIdentifier)]}function O(H,K){let re=H;for(;re!==K;){if(re.kind===172){pa(re)&&(h|=32);break}else if(re.kind===169){Vp(re).kind===176&&(h|=32);break}else re.kind===174&&pa(re)&&(h|=32);re=re.parent}}function U(H){let K;if((Se=>{Se[Se.None=0]="None",Se[Se.Break=1]="Break",Se[Se.Continue=2]="Continue",Se[Se.Return=4]="Return"})(K||(K={})),I.assert(H.pos<=H.end,"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (1)"),I.assert(!_g(H.pos),"This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (2)"),!ns(H)&&!(k0(H)&&m5e(H))&&!_Se(H))return[$n(H,s_.statementOrExpressionExpected)];if(H.flags&33554432)return[$n(H,s_.cannotExtractAmbientBlock)];let re=Vu(H);re&&O(H,re);let $,pe=4,z;if(se(H),h&8){let Se=kf(H,!1,!1);(Se.kind===262||Se.kind===174&&Se.parent.kind===210||Se.kind===218)&&(h|=16)}return $;function se(Se){if($)return!0;if(O_(Se)){let Z=Se.kind===260?Se.parent.parent:Se;if(ui(Z,32))return($||($=[])).push($n(Se,s_.cannotExtractExportedEntity)),!0}switch(Se.kind){case 272:return($||($=[])).push($n(Se,s_.cannotExtractImport)),!0;case 277:return($||($=[])).push($n(Se,s_.cannotExtractExportedEntity)),!0;case 108:if(Se.parent.kind===213){let Z=Vu(Se);if(Z===void 0||Z.pos<t.start||Z.end>=t.start+t.length)return($||($=[])).push($n(Se,s_.cannotExtractSuper)),!0}else h|=8,b=Se;break;case 219:Qs(Se,function Z(Q){if(TD(Q))h|=8,b=Se;else{if(Ti(Q)||ca(Q)&&!rc(Q))return!1;Qs(Q,Z)}});case 263:case 262:ls(Se.parent)&&Se.parent.externalModuleIndicator===void 0&&($||($=[])).push($n(Se,s_.functionWillNotBeVisibleInTheNewScope));case 231:case 218:case 174:case 176:case 177:case 178:return!1}let xe=pe;switch(Se.kind){case 245:pe&=-5;break;case 258:pe=0;break;case 241:Se.parent&&Se.parent.kind===258&&Se.parent.finallyBlock===Se&&(pe=4);break;case 297:case 296:pe|=1;break;default:Lv(Se,!1)&&(pe|=3);break}switch(Se.kind){case 197:case 110:h|=8,b=Se;break;case 256:{let Z=Se.label;(z||(z=[])).push(Z.escapedText),Qs(Se,se),z.pop();break}case 252:case 251:{let Z=Se.label;Z?hs(z,Z.escapedText)||($||($=[])).push($n(Se,s_.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange)):pe&(Se.kind===252?1:2)||($||($=[])).push($n(Se,s_.cannotExtractRangeContainingConditionalBreakOrContinueStatements));break}case 223:h|=4;break;case 229:h|=2;break;case 253:pe&4?h|=1:($||($=[])).push($n(Se,s_.cannotExtractRangeContainingConditionalReturnStatement));break;default:Qs(Se,se);break}pe=xe}}}function ACt(e,t,n){let i=e.getStart(n),s=t.getEnd();return n.text.charCodeAt(s)===59&&s++,{start:i,length:s-i}}function kCt(e){if(ns(e))return[e];if(k0(e))return Ou(e.parent)?[e.parent]:e;if(_Se(e))return e}function oSe(e){return rc(e)?mY(e.body):tc(e)||ls(e)||Zg(e)||Ti(e)}function PCt(e){let t=$1(e.range)?di(e.range):e.range;if(e.facts&8&&!(e.facts&16)){let i=Vu(t);if(i){let s=Gr(t,tc);return s?[s,i]:[i]}}let n=[];for(;;)if(t=t.parent,t.kind===169&&(t=Gr(t,i=>tc(i)).parent),oSe(t)&&(n.push(t),t.kind===312))return n}function NCt(e,t,n){let{scopes:i,readsAndWrites:{target:s,usagesPerScope:o,functionErrorsPerScope:l,exposedVariableDeclarations:p}}=cSe(e,t);return I.assert(!l[n].length,"The extraction went missing? How?"),t.cancellationToken.throwIfCancellationRequested(),FCt(s,i[n],o[n],p,e,t)}function DCt(e,t,n){let{scopes:i,readsAndWrites:{target:s,usagesPerScope:o,constantErrorsPerScope:l,exposedVariableDeclarations:p}}=cSe(e,t);I.assert(!l[n].length,"The extraction went missing? How?"),I.assert(p.length===0,"Extract constant accepted a range containing a variable declaration?"),t.cancellationToken.throwIfCancellationRequested();let m=bt(s)?s:s.statements[0].expression;return jCt(m,i[n],o[n],e.facts,t)}function ICt(e,t){let{scopes:n,readsAndWrites:{functionErrorsPerScope:i,constantErrorsPerScope:s}}=cSe(e,t);return n.map((l,p)=>{let m=wCt(l),S=OCt(l),h=tc(l)?RCt(l):Ti(l)?MCt(l):LCt(l),b,A;return h===1?(b=O0(Gs(g.Extract_to_0_in_1_scope),[m,"global"]),A=O0(Gs(g.Extract_to_0_in_1_scope),[S,"global"])):h===0?(b=O0(Gs(g.Extract_to_0_in_1_scope),[m,"module"]),A=O0(Gs(g.Extract_to_0_in_1_scope),[S,"module"])):(b=O0(Gs(g.Extract_to_0_in_1),[m,h]),A=O0(Gs(g.Extract_to_0_in_1),[S,h])),p===0&&!Ti(l)&&(A=O0(Gs(g.Extract_to_0_in_enclosing_scope),[S])),{functionExtraction:{description:b,errors:i[p]},constantExtraction:{description:A,errors:s[p]}}})}function cSe(e,t){let{file:n}=t,i=PCt(e),s=YCt(e,n),o=XCt(e,i,s,n,t.program.getTypeChecker(),t.cancellationToken);return{scopes:i,readsAndWrites:o}}function wCt(e){return tc(e)?"inner function":Ti(e)?"method":"function"}function OCt(e){return Ti(e)?"readonly field":"constant"}function RCt(e){switch(e.kind){case 176:return"constructor";case 218:case 262:return e.name?`function '${e.name.text}'`:jJ;case 219:return"arrow function";case 174:return`method '${e.name.getText()}'`;case 177:return`'get ${e.name.getText()}'`;case 178:return`'set ${e.name.getText()}'`;default:I.assertNever(e,`Unexpected scope kind ${e.kind}`)}}function MCt(e){return e.kind===263?e.name?`class '${e.name.text}'`:"anonymous class declaration":e.name?`class expression '${e.name.text}'`:"anonymous class expression"}function LCt(e){return e.kind===268?`namespace '${e.parent.name.getText()}'`:e.externalModuleIndicator?0:1}function FCt(e,t,{usages:n,typeParameterUsages:i,substitutions:s},o,l,p){let m=p.program.getTypeChecker(),S=ho(p.program.getCompilerOptions()),h=x_.createImportAdder(p.file,p.program,p.preferences,p.host),b=t.getSourceFile(),A=Nx(Ti(t)?"newMethod":"newFunction",b),k=gn(t),N=j.createIdentifier(A),M,O=[],U=[],H;n.forEach((Ie,Re)=>{let Ue;if(!k){let ke=m.getTypeOfSymbolAtLocation(Ie.symbol,Ie.node);ke=m.getBaseTypeOfLiteralType(ke),Ue=x_.typeToAutoImportableTypeNode(m,h,ke,t,S,1)}let kt=j.createParameterDeclaration(void 0,void 0,Re,void 0,Ue);O.push(kt),Ie.usage===2&&(H||(H=[])).push(Ie),U.push(j.createIdentifier(Re))});let re=In(i.values(),Ie=>({type:Ie,declaration:UCt(Ie,p.startPosition)})).sort(VCt),$=re.length===0?void 0:Wi(re,({declaration:Ie})=>Ie),pe=$!==void 0?$.map(Ie=>j.createTypeReferenceNode(Ie.name,void 0)):void 0;if(bt(e)&&!k){let Ie=m.getContextualType(e);M=m.typeToTypeNode(Ie,t,1)}let{body:z,returnValueProperty:se}=qCt(e,o,H,s,!!(l.facts&1));hp(z);let Se,xe=!!(l.facts&16);if(Ti(t)){let Ie=k?[]:[j.createModifier(123)];l.facts&32&&Ie.push(j.createModifier(126)),l.facts&4&&Ie.push(j.createModifier(134)),Se=j.createMethodDeclaration(Ie.length?Ie:void 0,l.facts&2?j.createToken(42):void 0,N,void 0,$,O,M,z)}else xe&&O.unshift(j.createParameterDeclaration(void 0,void 0,"this",void 0,m.typeToTypeNode(m.getTypeAtLocation(l.thisNode),t,1),void 0)),Se=j.createFunctionDeclaration(l.facts&4?[j.createToken(134)]:void 0,l.facts&2?j.createToken(42):void 0,N,$,O,M,z);let Z=En.ChangeTracker.fromContext(p),Q=($1(l.range)?Rs(l.range):l.range).end,ce=WCt(Q,t);ce?Z.insertNodeBefore(p.file,ce,Se,!0):Z.insertNodeAtEndOfScope(p.file,t,Se),h.writeFixes(Z);let ye=[],we=JCt(t,l,A);xe&&U.unshift(j.createIdentifier("this"));let ve=j.createCallExpression(xe?j.createPropertyAccessExpression(we,"call"):we,pe,U);if(l.facts&2&&(ve=j.createYieldExpression(j.createToken(42),ve)),l.facts&4&&(ve=j.createAwaitExpression(ve)),uSe(e)&&(ve=j.createJsxExpression(void 0,ve)),o.length&&!H)if(I.assert(!se,"Expected no returnValueProperty"),I.assert(!(l.facts&1),"Expected RangeFacts.HasReturn flag to be unset"),o.length===1){let Ie=o[0];ye.push(j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(Sc(Ie.name),void 0,Sc(Ie.type),ve)],Ie.parent.flags)))}else{let Ie=[],Re=[],Ue=o[0].parent.flags,kt=!1;for(let $e of o){Ie.push(j.createBindingElement(void 0,void 0,Sc($e.name)));let at=m.typeToTypeNode(m.getBaseTypeOfLiteralType(m.getTypeAtLocation($e)),t,1);Re.push(j.createPropertySignature(void 0,$e.symbol.name,void 0,at)),kt=kt||$e.type!==void 0,Ue=Ue&$e.parent.flags}let ke=kt?j.createTypeLiteralNode(Re):void 0;ke&&Sn(ke,1),ye.push(j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(j.createObjectBindingPattern(Ie),void 0,ke,ve)],Ue)))}else if(o.length||H){if(o.length)for(let Re of o){let Ue=Re.parent.flags;Ue&2&&(Ue=Ue&-3|1),ye.push(j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(Re.symbol.name,void 0,Ae(Re.type))],Ue)))}se&&ye.push(j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(se,void 0,Ae(M))],1)));let Ie=lSe(o,H);se&&Ie.unshift(j.createShorthandPropertyAssignment(se)),Ie.length===1?(I.assert(!se,"Shouldn't have returnValueProperty here"),ye.push(j.createExpressionStatement(j.createAssignment(Ie[0].name,ve))),l.facts&1&&ye.push(j.createReturnStatement())):(ye.push(j.createExpressionStatement(j.createAssignment(j.createObjectLiteralExpression(Ie),ve))),se&&ye.push(j.createReturnStatement(j.createIdentifier(se))))}else l.facts&1?ye.push(j.createReturnStatement(ve)):$1(l.range)?ye.push(j.createExpressionStatement(ve)):ye.push(ve);$1(l.range)?Z.replaceNodeRangeWithNodes(p.file,di(l.range),Rs(l.range),ye):Z.replaceNodeWithNodes(p.file,l.range,ye);let oe=Z.getChanges(),Me=($1(l.range)?di(l.range):l.range).getSourceFile().fileName,Ge=c7(oe,Me,A,!1);return{renameFilename:Me,renameLocation:Ge,edits:oe};function Ae(Ie){if(Ie===void 0)return;let Re=Sc(Ie),Ue=Re;for(;ox(Ue);)Ue=Ue.type;return Kv(Ue)&&mr(Ue.types,kt=>kt.kind===157)?Re:j.createUnionTypeNode([Re,j.createKeywordTypeNode(157)])}}function jCt(e,t,{substitutions:n},i,s){let o=s.program.getTypeChecker(),l=t.getSourceFile(),p=Hn(e)&&!Ti(t)&&!o.resolveName(e.name.text,e,111551,!1)&&!is(e.name)&&!uT(e.name)?e.name.text:Nx(Ti(t)?"newProperty":"newLocal",l),m=gn(t),S=m||!o.isContextSensitive(e)?void 0:o.typeToTypeNode(o.getContextualType(e),t,1),h=zCt(Do(e),n);({variableType:S,initializer:h}=M(S,h)),hp(h);let b=En.ChangeTracker.fromContext(s);if(Ti(t)){I.assert(!m,"Cannot extract to a JS class");let O=[];O.push(j.createModifier(123)),i&32&&O.push(j.createModifier(126)),O.push(j.createModifier(148));let U=j.createPropertyDeclaration(O,p,void 0,S,h),H=j.createPropertyAccessExpression(i&32?j.createIdentifier(t.name.getText()):j.createThis(),j.createIdentifier(p));uSe(e)&&(H=j.createJsxExpression(void 0,H));let K=e.pos,re=GCt(K,t);b.insertNodeBefore(s.file,re,U,!0),b.replaceNode(s.file,e,H)}else{let O=j.createVariableDeclaration(p,void 0,S,h),U=BCt(e,t);if(U){b.insertNodeBefore(s.file,U,O);let H=j.createIdentifier(p);b.replaceNode(s.file,e,H)}else if(e.parent.kind===244&&t===Gr(e,oSe)){let H=j.createVariableStatement(void 0,j.createVariableDeclarationList([O],2));b.replaceNode(s.file,e.parent,H)}else{let H=j.createVariableStatement(void 0,j.createVariableDeclarationList([O],2)),K=HCt(e,t);if(K.pos===0?b.insertNodeAtTopOfFile(s.file,H,!1):b.insertNodeBefore(s.file,K,H,!1),e.parent.kind===244)b.delete(s.file,e.parent);else{let re=j.createIdentifier(p);uSe(e)&&(re=j.createJsxExpression(void 0,re)),b.replaceNode(s.file,e,re)}}}let A=b.getChanges(),k=e.getSourceFile().fileName,N=c7(A,k,p,!0);return{renameFilename:k,renameLocation:N,edits:A};function M(O,U){if(O===void 0)return{variableType:O,initializer:U};if(!Xo(U)&&!rc(U)||U.typeParameters)return{variableType:O,initializer:U};let H=o.getTypeAtLocation(e),K=nl(o.getSignaturesOfType(H,0));if(!K)return{variableType:O,initializer:U};if(K.getTypeParameters())return{variableType:O,initializer:U};let re=[],$=!1;for(let pe of U.parameters)if(pe.type)re.push(pe);else{let z=o.getTypeAtLocation(pe);z===o.getAnyType()&&($=!0),re.push(j.updateParameterDeclaration(pe,pe.modifiers,pe.dotDotDotToken,pe.name,pe.questionToken,pe.type||o.typeToTypeNode(z,t,1),pe.initializer))}if($)return{variableType:O,initializer:U};if(O=void 0,rc(U))U=j.updateArrowFunction(U,Jm(e)?jb(e):void 0,U.typeParameters,re,U.type||o.typeToTypeNode(K.getReturnType(),t,1),U.equalsGreaterThanToken,U.body);else{if(K&&K.thisParameter){let pe=qi(re);if(!pe||ze(pe.name)&&pe.name.escapedText!=="this"){let z=o.getTypeOfSymbolAtLocation(K.thisParameter,e);re.splice(0,0,j.createParameterDeclaration(void 0,void 0,"this",void 0,o.typeToTypeNode(z,t,1)))}}U=j.updateFunctionExpression(U,Jm(e)?jb(e):void 0,U.asteriskToken,U.name,U.typeParameters,re,U.type||o.typeToTypeNode(K.getReturnType(),t,1),U.body)}return{variableType:O,initializer:U}}}function BCt(e,t){let n;for(;e!==void 0&&e!==t;){if(Gi(e)&&e.initializer===n&&Tu(e.parent)&&e.parent.declarations.length>1)return e;n=e,e=e.parent}}function UCt(e,t){let n,i=e.symbol;if(i&&i.declarations)for(let s of i.declarations)(n===void 0||s.pos<n.pos)&&s.pos<t&&(n=s);return n}function VCt({type:e,declaration:t},{type:n,declaration:i}){return j5(t,i,"pos",To)||h_(e.symbol?e.symbol.getName():"",n.symbol?n.symbol.getName():"")||To(e.id,n.id)}function JCt(e,t,n){let i=j.createIdentifier(n);if(Ti(e)){let s=t.facts&32?j.createIdentifier(e.name.text):j.createThis();return j.createPropertyAccessExpression(s,i)}else return i}function qCt(e,t,n,i,s){let o=n!==void 0||t.length>0;if(ra(e)&&!o&&i.size===0)return{body:j.createBlock(e.statements,!0),returnValueProperty:void 0};let l,p=!1,m=j.createNodeArray(ra(e)?e.statements.slice(0):[ns(e)?e:j.createReturnStatement(Do(e))]);if(o||i.size){let h=Hr(m,S,ns).slice();if(o&&!s&&ns(e)){let b=lSe(t,n);b.length===1?h.push(j.createReturnStatement(b[0].name)):h.push(j.createReturnStatement(j.createObjectLiteralExpression(b)))}return{body:j.createBlock(h,!0),returnValueProperty:l}}else return{body:j.createBlock(m,!0),returnValueProperty:void 0};function S(h){if(!p&&Um(h)&&o){let b=lSe(t,n);return h.expression&&(l||(l="__return"),b.unshift(j.createPropertyAssignment(l,nt(h.expression,S,bt)))),b.length===1?j.createReturnStatement(b[0].name):j.createReturnStatement(j.createObjectLiteralExpression(b))}else{let b=p;p=p||tc(h)||Ti(h);let A=i.get(yo(h).toString()),k=A?Sc(A):wr(h,S,void 0);return p=b,k}}}function zCt(e,t){return t.size?n(e):e;function n(i){let s=t.get(yo(i).toString());return s?Sc(s):wr(i,n,void 0)}}function $Ct(e){if(tc(e)){let t=e.body;if(ra(t))return t.statements}else{if(Zg(e)||ls(e))return e.statements;if(Ti(e))return e.members;}return tt}function WCt(e,t){return mr($Ct(t),n=>n.pos>=e&&tc(n)&&!Yc(n))}function GCt(e,t){let n=t.members;I.assert(n.length>0,"Found no members");let i,s=!0;for(let o of n){if(o.pos>e)return i||n[0];if(s&&!ea(o)){if(i!==void 0)return o;s=!1}i=o}return i===void 0?I.fail():i}function HCt(e,t){I.assert(!Ti(t));let n;for(let i=e;i!==t;i=i.parent)oSe(i)&&(n=i);for(let i=(n||e).parent;;i=i.parent){if(g5e(i)){let s;for(let o of i.statements){if(o.pos>e.pos)break;s=o}return!s&&WN(i)?(I.assert(U6(i.parent.parent),"Grandparent isn't a switch statement"),i.parent.parent):I.checkDefined(s,"prevStatement failed to get set")}I.assert(i!==t,"Didn't encounter a block-like before encountering scope")}}function lSe(e,t){let n=vr(e,s=>j.createShorthandPropertyAssignment(s.symbol.name)),i=vr(t,s=>j.createShorthandPropertyAssignment(s.symbol.name));return n===void 0?i:i===void 0?n:n.concat(i)}function $1(e){return os(e)}function YCt(e,t){return $1(e.range)?{pos:di(e.range).getStart(t),end:Rs(e.range).getEnd()}:e.range}function XCt(e,t,n,i,s,o){let l=new Map,p=[],m=[],S=[],h=[],b=[],A=new Map,k=[],N,M=$1(e.range)?e.range.length===1&&Ou(e.range[0])?e.range[0].expression:void 0:e.range,O;if(M===void 0){let ce=e.range,ye=di(ce).getStart(),we=Rs(ce).end;O=Iu(i,ye,we-ye,s_.expressionExpected)}else s.getTypeAtLocation(M).flags&147456&&(O=$n(M,s_.uselessConstantType));for(let ce of t){p.push({usages:new Map,typeParameterUsages:new Map,substitutions:new Map}),m.push(new Map),S.push([]);let ye=[];O&&ye.push(O),Ti(ce)&&gn(ce)&&ye.push($n(ce,s_.cannotExtractToJSClass)),rc(ce)&&!ra(ce.body)&&ye.push($n(ce,s_.cannotExtractToExpressionArrowFunction)),h.push(ye)}let U=new Map,H=$1(e.range)?j.createBlock(e.range):e.range,K=$1(e.range)?di(e.range):e.range,re=$(K);if(z(H),re&&!$1(e.range)&&!th(e.range)){let ce=s.getContextualType(e.range);pe(ce)}if(l.size>0){let ce=new Map,ye=0;for(let we=K;we!==void 0&&ye<t.length;we=we.parent)if(we===t[ye]&&(ce.forEach((ve,oe)=>{p[ye].typeParameterUsages.set(oe,ve)}),ye++),RY(we))for(let ve of Ov(we)){let oe=s.getTypeAtLocation(ve);l.has(oe.id.toString())&&ce.set(oe.id.toString(),oe)}I.assert(ye===t.length,"Should have iterated all scopes")}if(b.length){let ce=OY(t[0],t[0].parent)?t[0]:Lh(t[0]);Qs(ce,xe)}for(let ce=0;ce<t.length;ce++){let ye=p[ce];if(ce>0&&(ye.usages.size>0||ye.typeParameterUsages.size>0)){let oe=$1(e.range)?e.range[0]:e.range;h[ce].push($n(oe,s_.cannotAccessVariablesFromNestedScopes))}e.facts&16&&Ti(t[ce])&&S[ce].push($n(e.thisNode,s_.cannotExtractFunctionsContainingThisToMethod));let we=!1,ve;if(p[ce].usages.forEach(oe=>{oe.usage===2&&(we=!0,oe.symbol.flags&106500&&oe.symbol.valueDeclaration&&up(oe.symbol.valueDeclaration,8)&&(ve=oe.symbol.valueDeclaration))}),I.assert($1(e.range)||k.length===0,"No variable declarations expected if something was extracted"),we&&!$1(e.range)){let oe=$n(e.range,s_.cannotWriteInExpression);S[ce].push(oe),h[ce].push(oe)}else if(ve&&ce>0){let oe=$n(ve,s_.cannotExtractReadonlyPropertyInitializerOutsideConstructor);S[ce].push(oe),h[ce].push(oe)}else if(N){let oe=$n(N,s_.cannotExtractExportedEntity);S[ce].push(oe),h[ce].push(oe)}}return{target:H,usagesPerScope:p,functionErrorsPerScope:S,constantErrorsPerScope:h,exposedVariableDeclarations:k};function $(ce){return!!Gr(ce,ye=>RY(ye)&&Ov(ye).length!==0)}function pe(ce){let ye=s.getSymbolWalker(()=>(o.throwIfCancellationRequested(),!0)),{visitedTypes:we}=ye.walkType(ce);for(let ve of we)ve.isTypeParameter()&&l.set(ve.id.toString(),ve)}function z(ce,ye=1){if(re){let we=s.getTypeAtLocation(ce);pe(we)}if(O_(ce)&&ce.symbol&&b.push(ce),lu(ce))z(ce.left,2),z(ce.right);else if(Npe(ce))z(ce.operand,2);else if(Hn(ce)||fc(ce))Qs(ce,z);else if(ze(ce)){if(!ce.parent||pf(ce.parent)&&ce!==ce.parent.left||Hn(ce.parent)&&ce!==ce.parent.expression)return;se(ce,ye,A0(ce))}else Qs(ce,z)}function se(ce,ye,we){let ve=Se(ce,ye,we);if(ve)for(let oe=0;oe<t.length;oe++){let Ee=m[oe].get(ve);Ee&&p[oe].substitutions.set(yo(ce).toString(),Ee)}}function Se(ce,ye,we){let ve=Z(ce);if(!ve)return;let oe=Ia(ve).toString(),Ee=U.get(oe);if(Ee&&Ee>=ye)return oe;if(U.set(oe,ye),Ee){for(let Ae of p)Ae.usages.get(ce.text)&&Ae.usages.set(ce.text,{usage:ye,symbol:ve,node:ce});return oe}let Me=ve.getDeclarations(),Ge=Me&&mr(Me,Ae=>Ae.getSourceFile()===i);if(Ge&&!XM(n,Ge.getStart(),Ge.end)){if(e.facts&2&&ye===2){let Ae=$n(ce,s_.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators);for(let Ie of S)Ie.push(Ae);for(let Ie of h)Ie.push(Ae)}for(let Ae=0;Ae<t.length;Ae++){let Ie=t[Ae];if(s.resolveName(ve.name,Ie,ve.flags,!1)!==ve&&!m[Ae].has(oe)){let Ue=Q(ve.exportSymbol||ve,Ie,we);if(Ue)m[Ae].set(oe,Ue);else if(we){if(!(ve.flags&262144)){let kt=$n(ce,s_.typeWillNotBeVisibleInTheNewScope);S[Ae].push(kt),h[Ae].push(kt)}}else p[Ae].usages.set(ce.text,{usage:ye,symbol:ve,node:ce})}}return oe}}function xe(ce){if(ce===e.range||$1(e.range)&&e.range.includes(ce))return;let ye=ze(ce)?Z(ce):s.getSymbolAtLocation(ce);if(ye){let we=mr(b,ve=>ve.symbol===ye);if(we)if(Gi(we)){let ve=we.symbol.id.toString();A.has(ve)||(k.push(we),A.set(ve,!0))}else N=N||we}Qs(ce,xe)}function Z(ce){return ce.parent&&Hf(ce.parent)&&ce.parent.name===ce?s.getShorthandAssignmentValueSymbol(ce.parent):s.getSymbolAtLocation(ce)}function Q(ce,ye,we){if(!ce)return;let ve=ce.getDeclarations();if(ve&&ve.some(Ee=>Ee.parent===ye))return j.createIdentifier(ce.name);let oe=Q(ce.parent,ye,we);if(oe!==void 0)return we?j.createQualifiedName(oe,j.createIdentifier(ce.name)):j.createPropertyAccessExpression(oe,ce.name)}}function KCt(e){return Gr(e,t=>t.parent&&m5e(t)&&!bn(t.parent))}function m5e(e){let{parent:t}=e;switch(t.kind){case 306:return!1}switch(e.kind){case 11:return t.kind!==272&&t.kind!==276;case 230:case 206:case 208:return!1;case 80:return t.kind!==208&&t.kind!==276&&t.kind!==281}return!0}function g5e(e){switch(e.kind){case 241:case 312:case 268:case 296:return!0;default:return!1}}function uSe(e){return _Se(e)||(L0(e)||px(e)||pE(e))&&(L0(e.parent)||pE(e.parent))}function _Se(e){return za(e)&&e.parent&&th(e.parent)}var ID,wD,OD,s_,fSe,QCt=f({"src/services/refactors/extractSymbol.ts"(){"use strict";yi(),Gh(),ID="Extract Symbol",wD={name:"Extract Constant",description:Gs(g.Extract_constant),kind:"refactor.extract.constant"},OD={name:"Extract Function",description:Gs(g.Extract_function),kind:"refactor.extract.function"},j0(ID,{kinds:[wD.kind,OD.kind],getEditsForAction:d5e,getAvailableActions:p5e}),(e=>{function t(n){return{message:n,code:0,category:3,key:n}}e.cannotExtractRange=t("Cannot extract range."),e.cannotExtractImport=t("Cannot extract import statement."),e.cannotExtractSuper=t("Cannot extract super call."),e.cannotExtractJSDoc=t("Cannot extract JSDoc."),e.cannotExtractEmpty=t("Cannot extract empty range."),e.expressionExpected=t("expression expected."),e.uselessConstantType=t("No reason to extract constant of type."),e.statementOrExpressionExpected=t("Statement or expression expected."),e.cannotExtractRangeContainingConditionalBreakOrContinueStatements=t("Cannot extract range containing conditional break or continue statements."),e.cannotExtractRangeContainingConditionalReturnStatement=t("Cannot extract range containing conditional return statement."),e.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange=t("Cannot extract range containing labeled break or continue with target outside of the range."),e.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators=t("Cannot extract range containing writes to references located outside of the target range in generators."),e.typeWillNotBeVisibleInTheNewScope=t("Type will not visible in the new scope."),e.functionWillNotBeVisibleInTheNewScope=t("Function will not visible in the new scope."),e.cannotExtractIdentifier=t("Select more than a single identifier."),e.cannotExtractExportedEntity=t("Cannot extract exported declaration"),e.cannotWriteInExpression=t("Cannot write back side-effects when extracting an expression"),e.cannotExtractReadonlyPropertyInitializerOutsideConstructor=t("Cannot move initialization of read-only class property outside of the constructor"),e.cannotExtractAmbientBlock=t("Cannot extract code from ambient contexts"),e.cannotAccessVariablesFromNestedScopes=t("Cannot access variables from nested scopes"),e.cannotExtractToJSClass=t("Cannot extract constant to a class scope in JS"),e.cannotExtractToExpressionArrowFunction=t("Cannot extract constant to an arrow function without a block"),e.cannotExtractFunctionsContainingThisToMethod=t("Cannot extract functions containing this to method")})(s_||(s_={})),fSe=(e=>(e[e.None=0]="None",e[e.HasReturn=1]="HasReturn",e[e.IsGenerator=2]="IsGenerator",e[e.IsAsyncFunction=4]="IsAsyncFunction",e[e.UsesThis=8]="UsesThis",e[e.UsesThisInFunction=16]="UsesThisInFunction",e[e.InStaticRegion=32]="InStaticRegion",e))(fSe||{})}}),h5e={};x(h5e,{Messages:()=>s_,RangeFacts:()=>fSe,getRangeToExtract:()=>aSe,getRefactorActionsToExtractSymbol:()=>p5e,getRefactorEditsToExtractSymbol:()=>d5e});var ZCt=f({"src/services/_namespaces/ts.refactor.extractSymbol.ts"(){"use strict";QCt()}}),aq,$re,Wre,eAt=f({"src/services/refactors/generateGetAccessorAndSetAccessor.ts"(){"use strict";yi(),Gh(),aq="Generate 'get' and 'set' accessors",$re=Gs(g.Generate_get_and_set_accessors),Wre={name:aq,description:$re,kind:"refactor.rewrite.property.generateAccessors"},j0(aq,{kinds:[Wre.kind],getEditsForAction:function(t,n){if(!t.endPosition)return;let i=x_.getAccessorConvertiblePropertyAtPosition(t.file,t.program,t.startPosition,t.endPosition);I.assert(i&&!Ry(i),"Expected applicable refactor info");let s=x_.generateAccessorFromProperty(t.file,t.program,t.startPosition,t.endPosition,t,n);if(!s)return;let o=t.file.fileName,l=i.renameAccessor?i.accessorName:i.fieldName,m=(ze(l)?0:-1)+c7(s,o,l.text,Ls(i.declaration));return{renameFilename:o,renameLocation:m,edits:s}},getAvailableActions(e){if(!e.endPosition)return tt;let t=x_.getAccessorConvertiblePropertyAtPosition(e.file,e.program,e.startPosition,e.endPosition,e.triggerReason==="invoked");return t?Ry(t)?e.preferences.provideRefactorNotApplicableReason?[{name:aq,description:$re,actions:[{...Wre,notApplicableReason:t.error}]}]:tt:[{name:aq,description:$re,actions:[Wre]}]:tt}})}}),tAt={},rAt=f({"src/services/_namespaces/ts.refactor.generateGetAccessorAndSetAccessor.ts"(){"use strict";eAt()}});function nAt(e){let t=y5e(e);if(t&&!Ry(t))return{renameFilename:void 0,renameLocation:void 0,edits:En.ChangeTracker.with(e,i=>sAt(e.file,i,t.declaration,t.returnTypeNode))}}function iAt(e){let t=y5e(e);return t?Ry(t)?e.preferences.provideRefactorNotApplicableReason?[{name:oq,description:Gre,actions:[{...cq,notApplicableReason:t.error}]}]:tt:[{name:oq,description:Gre,actions:[cq]}]:tt}function sAt(e,t,n,i){let s=Oo(n,22,e),o=rc(n)&&s===void 0,l=o?di(n.parameters):s;l&&(o&&(t.insertNodeBefore(e,l,j.createToken(21)),t.insertNodeAfter(e,l,j.createToken(22))),t.insertNodeAt(e,l.end,i,{prefix:": "}))}function y5e(e){if(gn(e.file)||!BT(cq.kind,e.kind))return;let t=If(e.file,e.startPosition),n=Gr(t,l=>ra(l)||l.parent&&rc(l.parent)&&(l.kind===39||l.parent.body===l)?"quit":aAt(l));if(!n||!n.body||n.type)return{error:Gs(g.Return_type_must_be_inferred_from_a_function)};let i=e.program.getTypeChecker(),s=oAt(i,n);if(!s)return{error:Gs(g.Could_not_determine_function_return_type)};let o=i.typeToTypeNode(s,n,1);if(o)return{declaration:n,returnTypeNode:o}}function aAt(e){switch(e.kind){case 262:case 218:case 219:case 174:return!0;default:return!1}}function oAt(e,t){if(e.isImplementationOfOverload(t)){let i=e.getTypeAtLocation(t).getCallSignatures();if(i.length>1)return e.getUnionType(Wi(i,s=>s.getReturnType()))}let n=e.getSignatureFromDeclaration(t);if(n)return e.getReturnTypeOfSignature(n)}var oq,Gre,cq,cAt=f({"src/services/refactors/inferFunctionReturnType.ts"(){"use strict";yi(),Gh(),oq="Infer function return type",Gre=Gs(g.Infer_function_return_type),cq={name:oq,description:Gre,kind:"refactor.rewrite.function.returnType"},j0(oq,{kinds:[cq.kind],getEditsForAction:nAt,getAvailableActions:iAt})}}),lAt={},uAt=f({"src/services/_namespaces/ts.refactor.inferFunctionReturnType.ts"(){"use strict";cAt()}}),bk={};x(bk,{addExportToChanges:()=>Jve,addExports:()=>jve,addNewFileToTsconfig:()=>Ove,addOrRemoveBracesToArrowFunction:()=>xxt,containsJsx:()=>zve,convertArrowFunctionOrFunctionExpression:()=>Lxt,convertParamsToDestructuredObject:()=>tCt,convertStringOrTemplateLiteral:()=>_Ct,convertToOptionalChainExpression:()=>xCt,createNewFileName:()=>qve,createOldFileImportsFromTargetFile:()=>Fve,deleteMovedStatements:()=>KJ,deleteUnusedImports:()=>Bve,deleteUnusedOldImports:()=>Rve,doChangeNamedToNamespaceOrDefault:()=>AFe,extractSymbol:()=>h5e,filterImport:()=>b7,forEachImportInStatement:()=>T7,generateGetAccessorAndSetAccessor:()=>tAt,getApplicableRefactors:()=>b2t,getEditsForRefactor:()=>E2t,getStatementsToMove:()=>E7,getTopLevelDeclarationStatement:()=>wre,getUsageInfo:()=>ZJ,inferFunctionReturnType:()=>lAt,isRefactorErrorInfo:()=>Ry,isTopLevelDeclaration:()=>eq,makeImportOrRequire:()=>QJ,moduleSpecifierFromImport:()=>S7,nameOfTopLevelDeclaration:()=>Vve,refactorKindBeginsWith:()=>BT,registerRefactor:()=>j0,updateImportsInOtherFiles:()=>Mve});var Gh=f({"src/services/_namespaces/ts.refactor.ts"(){"use strict";SFe(),D2t(),M2t(),q2t(),z2t(),W2t(),X2t(),hxt(),Cxt(),Fxt(),rCt(),fCt(),CCt(),ZCt(),rAt(),uAt()}});function v5e(e,t,n,i){let s=pSe(e,t,n,i);I.assert(s.spans.length%3===0);let o=s.spans,l=[];for(let p=0;p<o.length;p+=3)l.push({textSpan:e_(o[p],o[p+1]),classificationType:o[p+2]});return l}function pSe(e,t,n,i){return{spans:_At(e,n,i,t),endOfLineState:0}}function _At(e,t,n,i){let s=[];return e&&t&&fAt(e,t,n,(l,p,m)=>{s.push(l.getStart(t),l.getWidth(t),(p+1<<8)+m)},i),s}function fAt(e,t,n,i,s){let o=e.getTypeChecker(),l=!1;function p(m){switch(m.kind){case 267:case 263:case 264:case 262:case 231:case 218:case 219:s.throwIfCancellationRequested()}if(!m||!v9(n,m.pos,m.getFullWidth())||m.getFullWidth()===0)return;let S=l;if((L0(m)||px(m))&&(l=!0),J6(m)&&(l=!1),ze(m)&&!l&&!gAt(m)&&!E6(m.escapedText)){let h=o.getSymbolAtLocation(m);if(h){h.flags&2097152&&(h=o.getAliasedSymbol(h));let b=pAt(h,Cx(m));if(b!==void 0){let A=0;m.parent&&(co(m.parent)||hSe.get(m.parent.kind)===b)&&m.parent.name===m&&(A=1),b===6&&T5e(m)&&(b=9),b=dAt(o,m,b);let k=h.valueDeclaration;if(k){let N=lT(k),M=x1(k);N&256&&(A|=2),N&1024&&(A|=4),b!==0&&b!==2&&(N&8||M&2||h.getFlags()&8)&&(A|=8),(b===7||b===10)&&mAt(k,t)&&(A|=32),e.isSourceFileDefaultLibrary(k.getSourceFile())&&(A|=16)}else h.declarations&&h.declarations.some(N=>e.isSourceFileDefaultLibrary(N.getSourceFile()))&&(A|=16);i(m,b,A)}}}Qs(m,p),l=S}p(t)}function pAt(e,t){let n=e.getFlags();if(n&32)return 0;if(n&384)return 1;if(n&524288)return 5;if(n&64){if(t&2)return 2}else if(n&262144)return 4;let i=e.valueDeclaration||e.declarations&&e.declarations[0];return i&&co(i)&&(i=S5e(i)),i&&hSe.get(i.kind)}function dAt(e,t,n){if(n===7||n===9||n===6){let i=e.getTypeAtLocation(t);if(i){let s=o=>o(i)||i.isUnion()&&i.types.some(o);if(n!==6&&s(o=>o.getConstructSignatures().length>0))return 0;if(s(o=>o.getCallSignatures().length>0)&&!s(o=>o.getProperties().length>0)||hAt(t))return n===9?11:10}}return n}function mAt(e,t){return co(e)&&(e=S5e(e)),Gi(e)?(!ls(e.parent.parent.parent)||mE(e.parent))&&e.getSourceFile()===t:Zl(e)?!ls(e.parent)&&e.getSourceFile()===t:!1}function S5e(e){for(;;)if(co(e.parent.parent))e=e.parent.parent;else return e.parent.parent}function gAt(e){let t=e.parent;return t&&(Jh(t)||Gf(t)||tS(t))}function hAt(e){for(;T5e(e);)e=e.parent;return da(e.parent)&&e.parent.expression===e}function T5e(e){return pf(e.parent)&&e.parent.right===e||Hn(e.parent)&&e.parent.name===e}var dSe,mSe,gSe,hSe,b5e=f({"src/services/classifier2020.ts"(){"use strict";yi(),dSe=(e=>(e[e.typeOffset=8]="typeOffset",e[e.modifierMask=255]="modifierMask",e))(dSe||{}),mSe=(e=>(e[e.class=0]="class",e[e.enum=1]="enum",e[e.interface=2]="interface",e[e.namespace=3]="namespace",e[e.typeParameter=4]="typeParameter",e[e.type=5]="type",e[e.parameter=6]="parameter",e[e.variable=7]="variable",e[e.enumMember=8]="enumMember",e[e.property=9]="property",e[e.function=10]="function",e[e.member=11]="member",e))(mSe||{}),gSe=(e=>(e[e.declaration=0]="declaration",e[e.static=1]="static",e[e.async=2]="async",e[e.readonly=3]="readonly",e[e.defaultLibrary=4]="defaultLibrary",e[e.local=5]="local",e))(gSe||{}),hSe=new Map([[260,7],[169,6],[172,9],[267,3],[266,1],[306,8],[263,0],[174,11],[262,10],[218,10],[173,11],[177,9],[178,9],[171,9],[264,2],[265,5],[168,4],[303,9],[304,9]])}});function E5e(e,t,n,i){let s=e8(e)?new Qre(e,t,n):e===80?new ene(80,t,n):e===81?new tne(81,t,n):new TSe(e,t,n);return s.parent=i,s.flags=i.flags&101441536,s}function yAt(e,t){if(!e8(e.kind))return tt;let n=[];if(M9(e))return e.forEachChild(l=>{n.push(l)}),n;j_.setText((t||e.getSourceFile()).text);let i=e.pos,s=l=>{lq(n,i,l.pos,e),n.push(l),i=l.end},o=l=>{lq(n,i,l.pos,e),n.push(vAt(l,e)),i=l.end};return Te(e.jsDoc,s),i=e.pos,e.forEachChild(s,o),lq(n,i,e.end,e),j_.setText(void 0),n}function lq(e,t,n,i){for(j_.resetTokenState(t);t<n;){let s=j_.scan(),o=j_.getTokenEnd();if(o<=n){if(s===80){if(qme(i))continue;I.fail(`Did not expect ${I.formatSyntaxKind(i.kind)} to have an Identifier in its trivia`)}e.push(E5e(s,t,o,i))}if(t=o,s===1)break}}function vAt(e,t){let n=E5e(358,e.pos,e.end,t);n._children=[];let i=e.pos;for(let s of e)lq(n._children,i,s.pos,t),n._children.push(s),i=s.end;return lq(n._children,i,e.end,t),n}function x5e(e){return pT(e).some(t=>t.tagName.text==="inheritDoc"||t.tagName.text==="inheritdoc")}function Hre(e,t){if(!e)return tt;let n=VT.getJsDocTagsFromDeclarations(e,t);if(t&&(n.length===0||e.some(x5e))){let i=new Set;for(let s of e){let o=C5e(t,s,l=>{var p;if(!i.has(l))return i.add(l),s.kind===177||s.kind===178?l.getContextualJsDocTags(s,t):((p=l.declarations)==null?void 0:p.length)===1?l.getJsDocTags():void 0});o&&(n=[...o,...n])}}return n}function uq(e,t){if(!e)return tt;let n=VT.getJsDocCommentsFromDeclarations(e,t);if(t&&(n.length===0||e.some(x5e))){let i=new Set;for(let s of e){let o=C5e(t,s,l=>{if(!i.has(l))return i.add(l),s.kind===177||s.kind===178?l.getContextualDocumentationComment(s,t):l.getDocumentationComment(t)});o&&(n=n.length===0?o.slice():o.concat(AD(),n))}}return n}function C5e(e,t,n){var i;let s=((i=t.parent)==null?void 0:i.kind)===176?t.parent.parent:t.parent;if(!s)return;let o=jl(t);return Ct(Yw(s),l=>{let p=e.getTypeAtLocation(l),m=o&&p.symbol?e.getTypeOfSymbol(p.symbol):p,S=e.getPropertyOfType(m,t.symbol.name);return S?n(S):void 0})}function SAt(){return{getNodeConstructor:()=>Qre,getTokenConstructor:()=>TSe,getIdentifierConstructor:()=>ene,getPrivateIdentifierConstructor:()=>tne,getSourceFileConstructor:()=>I5e,getSymbolConstructor:()=>P5e,getTypeConstructor:()=>N5e,getSignatureConstructor:()=>D5e,getSourceMapSourceConstructor:()=>w5e}}function N7(e){let t=!0;for(let i in e)if(wo(e,i)&&!A5e(i)){t=!1;break}if(t)return e;let n={};for(let i in e)if(wo(e,i)){let s=A5e(i)?i:i.charAt(0).toLowerCase()+i.substr(1);n[s]=e[i]}return n}function A5e(e){return!e.length||e.charAt(0)===e.charAt(0).toLowerCase()}function D7(e){return e?vr(e,t=>t.text).join(""):""}function _q(){return{target:1,jsx:1}}function Yre(){return x_.getSupportedErrorCodes()}function k5e(e,t,n){e.version=n,e.scriptSnapshot=t}function fq(e,t,n,i,s,o){let l=KR(e,ED(t),n,s,o);return k5e(l,t,i),l}function Xre(e,t,n,i,s){if(i&&n!==e.version){let l,p=i.span.start!==0?e.text.substr(0,i.span.start):"",m=gl(i.span)!==e.text.length?e.text.substr(gl(i.span)):"";if(i.newLength===0)l=p&&m?p+m:p||m;else{let h=t.getText(i.span.start,i.span.start+i.newLength);l=p&&m?p+h+m:p?p+h:h+m}let S=cQ(e,l,i,s);return k5e(S,t,n),S.nameTable=void 0,e!==S&&e.scriptSnapshot&&(e.scriptSnapshot.dispose&&e.scriptSnapshot.dispose(),e.scriptSnapshot=void 0),S}let o={languageVersion:e.languageVersion,impliedNodeFormat:e.impliedNodeFormat,setExternalModuleIndicator:e.setExternalModuleIndicator,jsDocParsingMode:e.jsDocParsingMode};return fq(e.fileName,t,o,n,!0,e.scriptKind)}function ySe(e,t=tve(e.useCaseSensitiveFileNames&&e.useCaseSensitiveFileNames(),e.getCurrentDirectory()),n){var i;let s;n===void 0?s=0:typeof n=="boolean"?s=n?2:0:s=n;let o=new O5e(e),l,p,m=0,S=e.getCancellationToken?new M5e(e.getCancellationToken()):R5e,h=e.getCurrentDirectory();Tme((i=e.getLocalizedDiagnosticMessages)==null?void 0:i.bind(e));function b(B){e.log&&e.log(B)}let A=AN(e),k=y_(A),N=mve({useCaseSensitiveFileNames:()=>A,getCurrentDirectory:()=>h,getProgram:H,fileExists:rs(e,e.fileExists),readFile:rs(e,e.readFile),getDocumentPositionMapper:rs(e,e.getDocumentPositionMapper),getSourceFileLike:rs(e,e.getSourceFileLike),log:b});function M(B){let le=l.getSourceFile(B);if(!le){let X=new Error(`Could not find source file: '${B}'.`);throw X.ProgramFiles=l.getSourceFiles().map(he=>he.fileName),X}return le}function O(){e.updateFromProject&&!e.updateFromProjectInProgress?e.updateFromProject():U()}function U(){var B,le,X;if(I.assert(s!==2),e.getProjectVersion){let zs=e.getProjectVersion();if(zs){if(p===zs&&!((B=e.hasChangedAutomaticTypeDirectiveNames)!=null&&B.call(e)))return;p=zs}}let he=e.getTypeRootsVersion?e.getTypeRootsVersion():0;m!==he&&(b("TypeRoots version has changed; provide new program"),l=void 0,m=he);let qe=e.getScriptFileNames().slice(),Le=e.getCompilationSettings()||_q(),It=e.hasInvalidatedResolutions||qf,Rt=rs(e,e.hasInvalidatedLibResolutions)||qf,Zt=rs(e,e.hasChangedAutomaticTypeDirectiveNames),Ir=(le=e.getProjectReferences)==null?void 0:le.call(e),zr,Yr={getSourceFile:Qo,getSourceFileByPath:Sl,getCancellationToken:()=>S,getCanonicalFileName:k,useCaseSensitiveFileNames:()=>A,getNewLine:()=>w1(Le),getDefaultLibFileName:zs=>e.getDefaultLibFileName(zs),writeFile:ja,getCurrentDirectory:()=>h,fileExists:zs=>e.fileExists(zs),readFile:zs=>e.readFile&&e.readFile(zs),getSymlinkCache:rs(e,e.getSymlinkCache),realpath:rs(e,e.realpath),directoryExists:zs=>lg(zs,e),getDirectories:zs=>e.getDirectories?e.getDirectories(zs):[],readDirectory:(zs,Eo,nc,Dc,zu)=>(I.checkDefined(e.readDirectory,"'LanguageServiceHost.readDirectory' must be implemented to correctly process 'projectReferences'"),e.readDirectory(zs,Eo,nc,Dc,zu)),onReleaseOldSourceFile:Mr,onReleaseParsedCommandLine:js,hasInvalidatedResolutions:It,hasInvalidatedLibResolutions:Rt,hasChangedAutomaticTypeDirectiveNames:Zt,trace:rs(e,e.trace),resolveModuleNames:rs(e,e.resolveModuleNames),getModuleResolutionCache:rs(e,e.getModuleResolutionCache),createHash:rs(e,e.createHash),resolveTypeReferenceDirectives:rs(e,e.resolveTypeReferenceDirectives),resolveModuleNameLiterals:rs(e,e.resolveModuleNameLiterals),resolveTypeReferenceDirectiveReferences:rs(e,e.resolveTypeReferenceDirectiveReferences),resolveLibrary:rs(e,e.resolveLibrary),useSourceOfProjectReferenceRedirect:rs(e,e.useSourceOfProjectReferenceRedirect),getParsedCommandLine:ji,jsDocParsingMode:e.jsDocParsingMode},Pi=Yr.getSourceFile,{getSourceFileWithCache:Fi}=IM(Yr,zs=>gc(zs,h,k),(...zs)=>Pi.call(Yr,...zs));Yr.getSourceFile=Fi,(X=e.setCompilerHost)==null||X.call(e,Yr);let fn={useCaseSensitiveFileNames:A,fileExists:zs=>Yr.fileExists(zs),readFile:zs=>Yr.readFile(zs),directoryExists:zs=>Yr.directoryExists(zs),getDirectories:zs=>Yr.getDirectories(zs),realpath:Yr.realpath,readDirectory:(...zs)=>Yr.readDirectory(...zs),trace:Yr.trace,getCurrentDirectory:Yr.getCurrentDirectory,onUnRecoverableConfigFileDiagnostic:ja},Qn=t.getKeyForCompilationSettings(Le),Ns=new Set;if(HZ(l,qe,Le,(zs,Eo)=>e.getScriptVersion(Eo),zs=>Yr.fileExists(zs),It,Rt,Zt,ji,Ir)){Yr=void 0,zr=void 0,Ns=void 0;return}l=xV({rootNames:qe,options:Le,host:Yr,oldProgram:l,projectReferences:Ir}),Yr=void 0,zr=void 0,Ns=void 0,N.clearCache(),l.getTypeChecker();return;function ji(zs){let Eo=gc(zs,h,k),nc=zr?.get(Eo);if(nc!==void 0)return nc||void 0;let Dc=e.getParsedCommandLine?e.getParsedCommandLine(zs):ni(zs);return(zr||(zr=new Map)).set(Eo,Dc||!1),Dc}function ni(zs){let Eo=Qo(zs,100);if(Eo)return Eo.path=gc(zs,h,k),Eo.resolvedPath=Eo.path,Eo.originalFileName=Eo.fileName,rM(Eo,fn,Ps(hi(zs),h),void 0,Ps(zs,h))}function js(zs,Eo,nc){var Dc;e.getParsedCommandLine?(Dc=e.onReleaseParsedCommandLine)==null||Dc.call(e,zs,Eo,nc):Eo&&Mr(Eo.sourceFile,nc)}function Mr(zs,Eo){let nc=t.getKeyForCompilationSettings(Eo);t.releaseDocumentWithKey(zs.resolvedPath,nc,zs.scriptKind,zs.impliedNodeFormat)}function Qo(zs,Eo,nc,Dc){return Sl(zs,gc(zs,h,k),Eo,nc,Dc)}function Sl(zs,Eo,nc,Dc,zu){I.assert(Yr,"getOrCreateSourceFileByPath called after typical CompilerHost lifetime, check the callstack something with a reference to an old host.");let ks=e.getScriptSnapshot(zs);if(!ks)return;let ya=Rte(zs,e),$u=e.getScriptVersion(zs);if(!zu){let Uo=l&&l.getSourceFileByPath(Eo);if(Uo){if(ya===Uo.scriptKind||Ns.has(Uo.resolvedPath))return t.updateDocumentWithKey(zs,Eo,e,Qn,ks,$u,ya,nc);t.releaseDocumentWithKey(Uo.resolvedPath,t.getKeyForCompilationSettings(l.getCompilerOptions()),Uo.scriptKind,Uo.impliedNodeFormat),Ns.add(Uo.resolvedPath)}}return t.acquireDocumentWithKey(zs,Eo,e,Qn,ks,$u,ya,nc)}}function H(){if(s===2){I.assert(l===void 0);return}return O(),l}function K(){var B;return(B=e.getPackageJsonAutoImportProvider)==null?void 0:B.call(e)}function re(B,le){let X=l.getTypeChecker(),he=qe();if(!he)return!1;for(let It of B)for(let Rt of It.references){let Zt=Le(Rt);if(I.assertIsDefined(Zt),le.has(Rt)||Ko.isDeclarationOfSymbol(Zt,he)){le.add(Rt),Rt.isDefinition=!0;let Ir=vJ(Rt,N,rs(e,e.fileExists));Ir&&le.add(Ir)}else Rt.isDefinition=!1}return!0;function qe(){for(let It of B)for(let Rt of It.references){if(le.has(Rt)){let Ir=Le(Rt);return I.assertIsDefined(Ir),X.getSymbolAtLocation(Ir)}let Zt=vJ(Rt,N,rs(e,e.fileExists));if(Zt&&le.has(Zt)){let Ir=Le(Zt);if(Ir)return X.getSymbolAtLocation(Ir)}}}function Le(It){let Rt=l.getSourceFile(It.fileName);if(!Rt)return;let Zt=If(Rt,It.textSpan.start);return Ko.Core.getAdjustedNode(Zt,{use:Ko.FindReferencesUse.References})}}function $(){if(l){let B=t.getKeyForCompilationSettings(l.getCompilerOptions());Te(l.getSourceFiles(),le=>t.releaseDocumentWithKey(le.resolvedPath,B,le.scriptKind,le.impliedNodeFormat)),l=void 0}}function pe(){$(),e=void 0}function z(B){return O(),l.getSyntacticDiagnostics(M(B),S).slice()}function se(B){O();let le=M(B),X=l.getSemanticDiagnostics(le,S);if(!Dd(l.getCompilerOptions()))return X.slice();let he=l.getDeclarationDiagnostics(le,S);return[...X,...he]}function Se(B){return O(),fre(M(B),l,S)}function xe(){return O(),[...l.getOptionsDiagnostics(S),...l.getGlobalDiagnostics(S)]}function Z(B,le,X=Md,he){let qe={...X,includeCompletionsForModuleExports:X.includeCompletionsForModuleExports||X.includeExternalModuleExports,includeCompletionsWithInsertText:X.includeCompletionsWithInsertText||X.includeInsertTextCompletions};return O(),Pk.getCompletionsAtPosition(e,l,b,M(B),le,qe,X.triggerCharacter,X.triggerKind,S,he&&fu.getFormatContext(he,e),X.includeSymbol)}function Q(B,le,X,he,qe,Le=Md,It){return O(),Pk.getCompletionEntryDetails(l,b,M(B),le,{name:X,source:qe,data:It},e,he&&fu.getFormatContext(he,e),Le,S)}function ce(B,le,X,he,qe=Md){return O(),Pk.getCompletionEntrySymbol(l,b,M(B),le,{name:X,source:he},e,qe)}function ye(B,le){O();let X=M(B),he=If(X,le);if(he===X)return;let qe=l.getTypeChecker(),Le=we(he),It=xAt(Le,qe);if(!It||qe.isUnknownSymbol(It)){let Yr=ve(X,Le,le)?qe.getTypeAtLocation(Le):void 0;return Yr&&{kind:"",kindModifiers:"",textSpan:gf(Le,X),displayParts:qe.runWithCancellationToken(S,Pi=>a7(Pi,Yr,Ax(Le))),documentation:Yr.symbol?Yr.symbol.getDocumentationComment(qe):void 0,tags:Yr.symbol?Yr.symbol.getJsDocTags(qe):void 0}}let{symbolKind:Rt,displayParts:Zt,documentation:Ir,tags:zr}=qe.runWithCancellationToken(S,Yr=>W1.getSymbolDisplayPartsDocumentationAndSymbolKind(Yr,It,X,Ax(Le),Le));return{kind:Rt,kindModifiers:W1.getSymbolModifiers(qe,It),textSpan:gf(Le,X),displayParts:Zt,documentation:Ir,tags:zr}}function we(B){return lE(B.parent)&&B.pos===B.parent.pos?B.parent.expression:JN(B.parent)&&B.pos===B.parent.pos||oN(B.parent)&&B.parent.name===B||pg(B.parent)?B.parent:B}function ve(B,le,X){switch(le.kind){case 80:return!tte(le)&&!rte(le)&&!Ty(le.parent);case 211:case 166:return!U1(B,X);case 110:case 197:case 108:case 202:return!0;case 236:return oN(le);default:return!1}}function oe(B,le,X,he){return O(),UD.getDefinitionAtPosition(l,M(B),le,X,he)}function Ee(B,le){return O(),UD.getDefinitionAndBoundSpan(l,M(B),le)}function Me(B,le){return O(),UD.getTypeDefinitionAtPosition(l.getTypeChecker(),M(B),le)}function Ge(B,le){return O(),Ko.getImplementationsAtPosition(l,S,l.getSourceFiles(),M(B),le)}function Ae(B,le,X){let he=Ca(B);I.assert(X.some(It=>Ca(It)===he)),O();let qe=Wi(X,It=>l.getSourceFile(It)),Le=M(B);return VJ.getDocumentHighlights(l,S,Le,le,qe)}function Ie(B,le,X,he,qe){O();let Le=M(B),It=sJ(If(Le,le));if(Bq.nodeIsEligibleForRename(It))if(ze(It)&&(eh(It.parent)||fE(It.parent))&&xN(It.escapedText)){let{openingElement:Rt,closingElement:Zt}=It.parent.parent;return[Rt,Zt].map(Ir=>{let zr=gf(Ir.tagName,Le);return{fileName:Le.fileName,textSpan:zr,...Ko.toContextSpan(zr,Le,Ir.parent)}})}else{let Rt=_d(Le,qe??Md),Zt=typeof qe=="boolean"?qe:qe?.providePrefixAndSuffixTextForRename;return Ue(It,le,{findInStrings:X,findInComments:he,providePrefixAndSuffixTextForRename:Zt,use:Ko.FindReferencesUse.Rename},(Ir,zr,Yr)=>Ko.toRenameLocation(Ir,zr,Yr,Zt||!1,Rt))}}function Re(B,le){return O(),Ue(If(M(B),le),le,{use:Ko.FindReferencesUse.References},Ko.toReferenceEntry)}function Ue(B,le,X,he){O();let qe=X&&X.use===Ko.FindReferencesUse.Rename?l.getSourceFiles().filter(Le=>!l.isSourceFileDefaultLibrary(Le)):l.getSourceFiles();return Ko.findReferenceOrRenameEntries(l,S,qe,B,le,X,he)}function kt(B,le){return O(),Ko.findReferencedSymbols(l,S,l.getSourceFiles(),M(B),le)}function ke(B){return O(),Ko.Core.getReferencesForFileName(B,l,l.getSourceFiles()).map(Ko.toReferenceEntry)}function $e(B,le,X,he=!1,qe=!1){O();let Le=X?[M(X)]:l.getSourceFiles();return YLe(Le,l.getTypeChecker(),S,B,le,he,qe)}function at(B,le,X){O();let he=M(B),qe=e.getCustomTransformers&&e.getCustomTransformers();return uye(l,he,!!le,S,qe,X)}function $t(B,le,{triggerReason:X}=Md){O();let he=M(B);return W7.getSignatureHelpItems(l,he,le,X,S)}function St(B){return o.getCurrentSourceFile(B)}function Ze(B,le,X){let he=o.getCurrentSourceFile(B),qe=If(he,le);if(qe===he)return;switch(qe.kind){case 211:case 166:case 11:case 97:case 112:case 106:case 108:case 110:case 197:case 80:break;default:return}let Le=qe;for(;;)if(SD(Le)||u1e(Le))Le=Le.parent;else if(ite(Le))if(Le.parent.parent.kind===267&&Le.parent.parent.body===Le.parent)Le=Le.parent.parent.name;else break;else break;return Ll(Le.getStart(),qe.getEnd())}function yt(B,le){let X=o.getCurrentSourceFile(B);return nne.spanInSourceFileAtLocation(X,le)}function ar(B){return ZLe(o.getCurrentSourceFile(B),S)}function or(B){return eFe(o.getCurrentSourceFile(B),S)}function Fr(B,le,X){return O(),(X||"original")==="2020"?v5e(l,S,M(B),le):Z1e(l.getTypeChecker(),S,M(B),l.getClassifiableNames(),le)}function rn(B,le,X){return O(),(X||"original")==="original"?sre(l.getTypeChecker(),S,M(B),l.getClassifiableNames(),le):pSe(l,S,M(B),le)}function Tr(B,le){return eve(S,o.getCurrentSourceFile(B),le)}function nr(B,le){return are(S,o.getCurrentSourceFile(B),le)}function tr(B){let le=o.getCurrentSourceFile(B);return Zie.collectElements(le,S)}let ki=new Map(Object.entries({19:20,21:22,23:24,32:30}));ki.forEach((B,le)=>ki.set(B.toString(),Number(le)));function xs(B,le){let X=o.getCurrentSourceFile(B),he=bD(X,le),qe=he.getStart(X)===le?ki.get(he.kind.toString()):void 0,Le=qe&&Oo(he.parent,qe,X);return Le?[gf(he,X),gf(Le,X)].sort((It,Rt)=>It.start-Rt.start):tt}function zi(B,le,X){let he=uc(),qe=N7(X),Le=o.getCurrentSourceFile(B);b("getIndentationAtPosition: getCurrentSourceFile: "+(uc()-he)),he=uc();let It=fu.SmartIndenter.getIndentation(le,Le,qe);return b("getIndentationAtPosition: computeIndentation  : "+(uc()-he)),It}function Ms(B,le,X,he){let qe=o.getCurrentSourceFile(B);return fu.formatSelection(le,X,qe,fu.getFormatContext(N7(he),e))}function un(B,le){return fu.formatDocument(o.getCurrentSourceFile(B),fu.getFormatContext(N7(le),e))}function ri(B,le,X,he){let qe=o.getCurrentSourceFile(B),Le=fu.getFormatContext(N7(he),e);if(!U1(qe,le))switch(X){case"{":return fu.formatOnOpeningCurly(le,qe,Le);case"}":return fu.formatOnClosingCurly(le,qe,Le);case";":return fu.formatOnSemicolon(le,qe,Le);case`
`:return fu.formatOnEnter(le,qe,Le)}return[]}function On(B,le,X,he,qe,Le=Md){O();let It=M(B),Rt=Ll(le,X),Zt=fu.getFormatContext(qe,e);return _a(Dh(he,Dm,To),Ir=>(S.throwIfCancellationRequested(),x_.getFixes({errorCode:Ir,sourceFile:It,span:Rt,program:l,host:e,cancellationToken:S,formatContext:Zt,preferences:Le})))}function _r(B,le,X,he=Md){O(),I.assert(B.type==="file");let qe=M(B.fileName),Le=fu.getFormatContext(X,e);return x_.getAllFixes({fixId:le,sourceFile:qe,program:l,host:e,cancellationToken:S,formatContext:Le,preferences:he})}function rt(B,le,X=Md){O(),I.assert(B.type==="file");let he=M(B.fileName),qe=fu.getFormatContext(le,e),Le=B.mode??(B.skipDestructiveCodeActions?"SortAndCombine":"All");return $m.organizeImports(he,qe,e,l,X,Le)}function zt(B,le,X,he=Md){return nve(H(),B,le,e,fu.getFormatContext(X,e),he,N)}function Rr(B,le){let X=typeof B=="string"?le:B;return os(X)?Promise.all(X.map(he=>vi(he))):vi(X)}function vi(B){let le=X=>gc(X,h,k);return I.assertEqual(B.type,"install package"),e.installPackage?e.installPackage({fileName:le(B.file),packageName:B.packageName}):Promise.reject("Host does not implement `installPackage`")}function Ni(B,le,X,he){let qe=he?fu.getFormatContext(he,e).options:void 0;return VT.getDocCommentTemplateAtPosition(q1(e,qe),o.getCurrentSourceFile(B),le,X)}function us(B,le,X){if(X===60)return!1;let he=o.getCurrentSourceFile(B);if(hk(he,le))return!1;if(h1e(he,le))return X===123;if(ute(he,le))return!1;switch(X){case 39:case 34:case 96:return!U1(he,le)}return!0}function Fs(B,le){let X=o.getCurrentSourceFile(B),he=tu(le,X);if(!he)return;let qe=he.kind===32&&eh(he.parent)?he.parent.parent:qA(he)&&L0(he.parent)?he.parent:void 0;if(qe&&dt(qe))return{newText:`</${qe.openingElement.tagName.getText(X)}>`};let Le=he.kind===32&&nk(he.parent)?he.parent.parent:qA(he)&&pE(he.parent)?he.parent:void 0;if(Le&&Ot(Le))return{newText:"</>"}}function Ta(B,le){let X=o.getCurrentSourceFile(B),he=tu(le,X);if(!he||he.parent.kind===312)return;let qe="[a-zA-Z0-9:\\-\\._$]*";if(pE(he.parent.parent)){let Le=he.parent.parent.openingFragment,It=he.parent.parent.closingFragment;if(rN(Le)||rN(It))return;let Rt=Le.getStart(X)+1,Zt=It.getStart(X)+2;return le!==Rt&&le!==Zt?void 0:{ranges:[{start:Rt,length:0},{start:Zt,length:0}],wordPattern:qe}}else{let Le=Gr(he.parent,Fi=>!!(eh(Fi)||fE(Fi)));if(!Le)return;I.assert(eh(Le)||fE(Le),"tag should be opening or closing element");let It=Le.parent.openingElement,Rt=Le.parent.closingElement,Zt=It.tagName.getStart(X),Ir=It.tagName.end,zr=Rt.tagName.getStart(X),Yr=Rt.tagName.end;return Zt===It.getStart(X)||zr===Rt.getStart(X)||Ir===It.getEnd()||Yr===Rt.getEnd()||!(Zt<=le&&le<=Ir||zr<=le&&le<=Yr)||It.tagName.getText(X)!==Rt.tagName.getText(X)?void 0:{ranges:[{start:Zt,length:Ir-Zt},{start:zr,length:Yr-zr}],wordPattern:qe}}}function to(B,le){return{lineStarts:B.getLineStarts(),firstLine:B.getLineAndCharacterOfPosition(le.pos).line,lastLine:B.getLineAndCharacterOfPosition(le.end).line}}function Nr(B,le,X){let he=o.getCurrentSourceFile(B),qe=[],{lineStarts:Le,firstLine:It,lastLine:Rt}=to(he,le),Zt=X||!1,Ir=Number.MAX_VALUE,zr=new Map,Yr=new RegExp(/\S/),Pi=cJ(he,Le[It]),Fi=Pi?"{/*":"//";for(let fn=It;fn<=Rt;fn++){let Qn=he.text.substring(Le[fn],he.getLineEndOfPosition(Le[fn])),Ns=Yr.exec(Qn);Ns&&(Ir=Math.min(Ir,Ns.index),zr.set(fn.toString(),Ns.index),Qn.substr(Ns.index,Fi.length)!==Fi&&(Zt=X===void 0||X))}for(let fn=It;fn<=Rt;fn++){if(It!==Rt&&Le[fn]===le.end)continue;let Qn=zr.get(fn.toString());Qn!==void 0&&(Pi?qe.push(...qr(B,{pos:Le[fn]+Ir,end:he.getLineEndOfPosition(Le[fn])},Zt,Pi)):Zt?qe.push({newText:Fi,span:{length:0,start:Le[fn]+Ir}}):he.text.substr(Le[fn]+Qn,Fi.length)===Fi&&qe.push({newText:"",span:{length:Fi.length,start:Le[fn]+Qn}}))}return qe}function qr(B,le,X,he){var qe;let Le=o.getCurrentSourceFile(B),It=[],{text:Rt}=Le,Zt=!1,Ir=X||!1,zr=[],{pos:Yr}=le,Pi=he!==void 0?he:cJ(Le,Yr),Fi=Pi?"{/*":"/*",fn=Pi?"*/}":"*/",Qn=Pi?"\\{\\/\\*":"\\/\\*",Ns=Pi?"\\*\\/\\}":"\\*\\/";for(;Yr<=le.end;){let Vi=Rt.substr(Yr,Fi.length)===Fi?Fi.length:0,ji=U1(Le,Yr+Vi);if(ji)Pi&&(ji.pos--,ji.end++),zr.push(ji.pos),ji.kind===3&&zr.push(ji.end),Zt=!0,Yr=ji.end+1;else{let ni=Rt.substring(Yr,le.end).search(`(${Qn})|(${Ns})`);Ir=X!==void 0?X:Ir||!N1e(Rt,Yr,ni===-1?le.end:Yr+ni),Yr=ni===-1?le.end+1:Yr+ni+fn.length}}if(Ir||!Zt){((qe=U1(Le,le.pos))==null?void 0:qe.kind)!==2&&lf(zr,le.pos,To),lf(zr,le.end,To);let Vi=zr[0];Rt.substr(Vi,Fi.length)!==Fi&&It.push({newText:Fi,span:{length:0,start:Vi}});for(let ji=1;ji<zr.length-1;ji++)Rt.substr(zr[ji]-fn.length,fn.length)!==fn&&It.push({newText:fn,span:{length:0,start:zr[ji]}}),Rt.substr(zr[ji],Fi.length)!==Fi&&It.push({newText:Fi,span:{length:0,start:zr[ji]}});It.length%2!==0&&It.push({newText:fn,span:{length:0,start:zr[zr.length-1]}})}else for(let Vi of zr){let ji=Vi-fn.length>0?Vi-fn.length:0,ni=Rt.substr(ji,fn.length)===fn?fn.length:0;It.push({newText:"",span:{length:Fi.length,start:Vi-ni}})}return It}function We(B,le){let X=o.getCurrentSourceFile(B),{firstLine:he,lastLine:qe}=to(X,le);return he===qe&&le.pos!==le.end?qr(B,le,!0):Nr(B,le,!0)}function mt(B,le){let X=o.getCurrentSourceFile(B),he=[],{pos:qe}=le,{end:Le}=le;qe===Le&&(Le+=cJ(X,qe)?2:1);for(let It=qe;It<=Le;It++){let Rt=U1(X,It);if(Rt){switch(Rt.kind){case 2:he.push(...Nr(B,{end:Rt.end,pos:Rt.pos+1},!1));break;case 3:he.push(...qr(B,{end:Rt.end,pos:Rt.pos+1},!1))}It=Rt.end+1}}return he}function dt({openingElement:B,closingElement:le,parent:X}){return!DT(B.tagName,le.tagName)||L0(X)&&DT(B.tagName,X.openingElement.tagName)&&dt(X)}function Ot({closingFragment:B,parent:le}){return!!(B.flags&262144)||pE(le)&&Ot(le)}function _e(B,le,X){let he=o.getCurrentSourceFile(B),qe=fu.getRangeOfEnclosingComment(he,le);return qe&&(!X||qe.kind===3)?aS(qe):void 0}function Ve(B,le){O();let X=M(B);S.throwIfCancellationRequested();let he=X.text,qe=[];if(le.length>0&&!Zt(X.fileName)){let Ir=It(),zr;for(;zr=Ir.exec(he);){S.throwIfCancellationRequested();let Yr=3;I.assert(zr.length===le.length+Yr);let Pi=zr[1],Fi=zr.index+Pi.length;if(!U1(X,Fi))continue;let fn;for(let Ns=0;Ns<le.length;Ns++)zr[Ns+Yr]&&(fn=le[Ns]);if(fn===void 0)return I.fail();if(Rt(he.charCodeAt(Fi+fn.text.length)))continue;let Qn=zr[2];qe.push({descriptor:fn,message:Qn,position:Fi})}}return qe;function Le(Ir){return Ir.replace(/[-[\]/{}()*+?.\\^$|]/g,"\\$&")}function It(){let Ir=/(?:\/\/+\s*)/.source,zr=/(?:\/\*+\s*)/.source,Pi="("+/(?:^(?:\s|\*)*)/.source+"|"+Ir+"|"+zr+")",Fi="(?:"+vr(le,ji=>"("+Le(ji.text)+")").join("|")+")",fn=/(?:$|\*\/)/.source,Qn=/(?:.*?)/.source,Ns="("+Fi+Qn+")",Vi=Pi+Ns+fn;return new RegExp(Vi,"gim")}function Rt(Ir){return Ir>=97&&Ir<=122||Ir>=65&&Ir<=90||Ir>=48&&Ir<=57}function Zt(Ir){return Ir.includes("/node_modules/")}}function pt(B,le,X){return O(),Bq.getRenameInfo(l,M(B),le,X||{})}function W(B,le,X,he,qe,Le){let[It,Rt]=typeof le=="number"?[le,void 0]:[le.pos,le.end];return{file:B,startPosition:It,endPosition:Rt,program:H(),host:e,formatContext:fu.getFormatContext(he,e),cancellationToken:S,preferences:X,triggerReason:qe,kind:Le}}function st(B,le,X){return{file:B,program:H(),host:e,span:le,preferences:X,cancellationToken:S}}function Nt(B,le){return rse.getSmartSelectionRange(le,o.getCurrentSourceFile(B))}function Ke(B,le,X=Md,he,qe,Le){O();let It=M(B);return bk.getApplicableRefactors(W(It,le,X,Md,he,qe),Le)}function ht(B,le,X=Md){O();let he=M(B),qe=I.checkDefined(l.getSourceFiles()),Le=h6(B),It=E7(W(he,le,X,Md)),Rt=zve(It?.all),Zt=Wi(qe,Ir=>{let zr=h6(Ir.fileName);return!l?.isSourceFileFromExternalLibrary(he)&&!(he===M(Ir.fileName)||Le===".ts"&&zr===".d.ts"||Le===".d.ts"&&Ss(Cl(Ir.fileName),"lib.")&&zr===".d.ts")&&(Le===zr||(Le===".tsx"&&zr===".ts"||Le===".jsx"&&zr===".js")&&!Rt)?Ir.fileName:void 0});return{newFileName:qve(he,l,e,It),files:Zt}}function Wt(B,le,X,he,qe,Le=Md,It){O();let Rt=M(B);return bk.getEditsForRefactor(W(Rt,X,Le,le),he,qe,It)}function Cr(B,le){return le===0?{line:0,character:0}:N.toLineColumnOffset(B,le)}function hr(B,le){O();let X=Ek.resolveCallHierarchyDeclaration(l,If(M(B),le));return X&&$te(X,he=>Ek.createCallHierarchyItem(l,he))}function Sr(B,le){O();let X=M(B),he=Wte(Ek.resolveCallHierarchyDeclaration(l,le===0?X:If(X,le)));return he?Ek.getIncomingCalls(l,he,S):[]}function Y(B,le){O();let X=M(B),he=Wte(Ek.resolveCallHierarchyDeclaration(l,le===0?X:If(X,le)));return he?Ek.getOutgoingCalls(l,he):[]}function Be(B,le,X=Md){O();let he=M(B);return Yie.provideInlayHints(st(he,le,X))}let Lt={dispose:pe,cleanupSemanticCache:$,getSyntacticDiagnostics:z,getSemanticDiagnostics:se,getSuggestionDiagnostics:Se,getCompilerOptionsDiagnostics:xe,getSyntacticClassifications:Tr,getSemanticClassifications:Fr,getEncodedSyntacticClassifications:nr,getEncodedSemanticClassifications:rn,getCompletionsAtPosition:Z,getCompletionEntryDetails:Q,getCompletionEntrySymbol:ce,getSignatureHelpItems:$t,getQuickInfoAtPosition:ye,getDefinitionAtPosition:oe,getDefinitionAndBoundSpan:Ee,getImplementationAtPosition:Ge,getTypeDefinitionAtPosition:Me,getReferencesAtPosition:Re,findReferences:kt,getFileReferences:ke,getDocumentHighlights:Ae,getNameOrDottedNameSpan:Ze,getBreakpointStatementAtPosition:yt,getNavigateToItems:$e,getRenameInfo:pt,getSmartSelectionRange:Nt,findRenameLocations:Ie,getNavigationBarItems:ar,getNavigationTree:or,getOutliningSpans:tr,getTodoComments:Ve,getBraceMatchingAtPosition:xs,getIndentationAtPosition:zi,getFormattingEditsForRange:Ms,getFormattingEditsForDocument:un,getFormattingEditsAfterKeystroke:ri,getDocCommentTemplateAtPosition:Ni,isValidBraceCompletionAtPosition:us,getJsxClosingTagAtPosition:Fs,getLinkedEditingRangeAtPosition:Ta,getSpanOfEnclosingComment:_e,getCodeFixesAtPosition:On,getCombinedCodeFix:_r,applyCodeActionCommand:Rr,organizeImports:rt,getEditsForFileRename:zt,getEmitOutput:at,getNonBoundSourceFile:St,getProgram:H,getCurrentProgram:()=>l,getAutoImportProvider:K,updateIsDefinitionOfReferencedSymbols:re,getApplicableRefactors:Ke,getEditsForRefactor:Wt,getMoveToRefactoringFileSuggestions:ht,toLineColumnOffset:Cr,getSourceMapper:()=>N,clearSourceMapperCache:()=>N.clearCache(),prepareCallHierarchy:hr,provideCallHierarchyIncomingCalls:Sr,provideCallHierarchyOutgoingCalls:Y,toggleLineComment:Nr,toggleMultilineComment:qr,commentSelection:We,uncommentSelection:mt,provideInlayHints:Be,getSupportedCodeFixes:Yre};switch(s){case 0:break;case 1:bSe.forEach(B=>Lt[B]=()=>{throw new Error(`LanguageService Operation: ${B} not allowed in LanguageServiceMode.PartialSemantic`)});break;case 2:L5e.forEach(B=>Lt[B]=()=>{throw new Error(`LanguageService Operation: ${B} not allowed in LanguageServiceMode.Syntactic`)});break;default:I.assertNever(s)}return Lt}function Kre(e){return e.nameTable||TAt(e),e.nameTable}function TAt(e){let t=e.nameTable=new Map;e.forEachChild(function n(i){if(ze(i)&&!rte(i)&&i.escapedText||id(i)&&bAt(i)){let s=Qw(i);t.set(s,t.get(s)===void 0?i.pos:-1)}else if(is(i)){let s=i.escapedText;t.set(s,t.get(s)===void 0?i.pos:-1)}if(Qs(i,n),jp(i))for(let s of i.jsDoc)Qs(s,n)})}function bAt(e){return Cy(e)||e.parent.kind===283||CAt(e)||z8(e)}function I7(e){let t=EAt(e);return t&&(Ha(t.parent)||dE(t.parent))?t:void 0}function EAt(e){switch(e.kind){case 11:case 15:case 9:if(e.parent.kind===167)return hY(e.parent.parent)?e.parent.parent:void 0;case 80:return hY(e.parent)&&(e.parent.parent.kind===210||e.parent.parent.kind===292)&&e.parent.name===e?e.parent:void 0}}function xAt(e,t){let n=I7(e);if(n){let i=t.getContextualType(n.parent),s=i&&pq(n,t,i,!1);if(s&&s.length===1)return di(s)}return t.getSymbolAtLocation(e)}function pq(e,t,n,i){let s=n7(e.name);if(!s)return tt;if(!n.isUnion()){let p=n.getProperty(s);return p?[p]:tt}let o=Ha(e.parent)||dE(e.parent)?Fn(n.types,p=>!t.isTypeInvalidDueToUnionDiscriminant(p,e.parent)):n.types,l=Wi(o,p=>p.getProperty(s));if(i&&(l.length===0||l.length===n.types.length)){let p=n.getProperty(s);if(p)return[p]}return!o.length&&!l.length?Wi(n.types,p=>p.getProperty(s)):Dh(l,Dm)}function CAt(e){return e&&e.parent&&e.parent.kind===212&&e.parent.argumentExpression===e}function vSe(e){if(Zu)return li(hi(Ca(Zu.getExecutingFilePath())),W3(e));throw new Error("getDefaultLibFilePath is only supported when consumed as a node module. ")}var SSe,Qre,Zre,P5e,TSe,ene,tne,N5e,D5e,I5e,w5e,O5e,R5e,M5e,rne,bSe,L5e,AAt=f({"src/services/services.ts"(){"use strict";yi(),QLe(),vFe(),Gh(),PLe(),b5e(),SSe="0.8",Qre=class{constructor(e,t,n){this.pos=t,this.end=n,this.flags=0,this.modifierFlagsCache=0,this.transformFlags=0,this.parent=void 0,this.kind=e}assertHasRealPosition(e){I.assert(!_g(this.pos)&&!_g(this.end),e||"Node must have a real position for this operation")}getSourceFile(){return Xr(this)}getStart(e,t){return this.assertHasRealPosition(),mT(this,e,t)}getFullStart(){return this.assertHasRealPosition(),this.pos}getEnd(){return this.assertHasRealPosition(),this.end}getWidth(e){return this.assertHasRealPosition(),this.getEnd()-this.getStart(e)}getFullWidth(){return this.assertHasRealPosition(),this.end-this.pos}getLeadingTriviaWidth(e){return this.assertHasRealPosition(),this.getStart(e)-this.pos}getFullText(e){return this.assertHasRealPosition(),(e||this.getSourceFile()).text.substring(this.pos,this.end)}getText(e){return this.assertHasRealPosition(),e||(e=this.getSourceFile()),e.text.substring(this.getStart(e),this.getEnd())}getChildCount(e){return this.getChildren(e).length}getChildAt(e,t){return this.getChildren(t)[e]}getChildren(e){return this.assertHasRealPosition("Node without a real position cannot be scanned and thus has no token nodes - use forEachChild and collect the result if that's fine"),this._children||(this._children=yAt(this,e))}getFirstToken(e){this.assertHasRealPosition();let t=this.getChildren(e);if(!t.length)return;let n=mr(t,i=>i.kind<316||i.kind>357);return n.kind<166?n:n.getFirstToken(e)}getLastToken(e){this.assertHasRealPosition();let t=this.getChildren(e),n=Is(t);if(n)return n.kind<166?n:n.getLastToken(e)}forEachChild(e,t){return Qs(this,e,t)}},Zre=class{constructor(e,t){this.pos=e,this.end=t,this.flags=0,this.modifierFlagsCache=0,this.transformFlags=0,this.parent=void 0}getSourceFile(){return Xr(this)}getStart(e,t){return mT(this,e,t)}getFullStart(){return this.pos}getEnd(){return this.end}getWidth(e){return this.getEnd()-this.getStart(e)}getFullWidth(){return this.end-this.pos}getLeadingTriviaWidth(e){return this.getStart(e)-this.pos}getFullText(e){return(e||this.getSourceFile()).text.substring(this.pos,this.end)}getText(e){return e||(e=this.getSourceFile()),e.text.substring(this.getStart(e),this.getEnd())}getChildCount(){return this.getChildren().length}getChildAt(e){return this.getChildren()[e]}getChildren(){return this.kind===1&&this.jsDoc||tt}getFirstToken(){}getLastToken(){}forEachChild(){}},P5e=class{constructor(e,t){this.id=0,this.mergeId=0,this.flags=e,this.escapedName=t}getFlags(){return this.flags}get name(){return Lc(this)}getEscapedName(){return this.escapedName}getName(){return this.name}getDeclarations(){return this.declarations}getDocumentationComment(e){if(!this.documentationComment)if(this.documentationComment=tt,!this.declarations&&Rh(this)&&this.links.target&&Rh(this.links.target)&&this.links.target.links.tupleLabelDeclaration){let t=this.links.target.links.tupleLabelDeclaration;this.documentationComment=uq([t],e)}else this.documentationComment=uq(this.declarations,e);return this.documentationComment}getContextualDocumentationComment(e,t){if(e){if(Fv(e)&&(this.contextualGetAccessorDocumentationComment||(this.contextualGetAccessorDocumentationComment=uq(Fn(this.declarations,Fv),t)),de(this.contextualGetAccessorDocumentationComment)))return this.contextualGetAccessorDocumentationComment;if(A1(e)&&(this.contextualSetAccessorDocumentationComment||(this.contextualSetAccessorDocumentationComment=uq(Fn(this.declarations,A1),t)),de(this.contextualSetAccessorDocumentationComment)))return this.contextualSetAccessorDocumentationComment}return this.getDocumentationComment(t)}getJsDocTags(e){return this.tags===void 0&&(this.tags=Hre(this.declarations,e)),this.tags}getContextualJsDocTags(e,t){if(e){if(Fv(e)&&(this.contextualGetAccessorTags||(this.contextualGetAccessorTags=Hre(Fn(this.declarations,Fv),t)),de(this.contextualGetAccessorTags)))return this.contextualGetAccessorTags;if(A1(e)&&(this.contextualSetAccessorTags||(this.contextualSetAccessorTags=Hre(Fn(this.declarations,A1),t)),de(this.contextualSetAccessorTags)))return this.contextualSetAccessorTags}return this.getJsDocTags(t)}},TSe=class extends Zre{constructor(e,t,n){super(t,n),this.kind=e}},ene=class extends Zre{constructor(e,t,n){super(t,n),this.kind=80}get text(){return Nn(this)}},ene.prototype.kind=80,tne=class extends Zre{constructor(e,t,n){super(t,n),this.kind=81}get text(){return Nn(this)}},tne.prototype.kind=81,N5e=class{constructor(e,t){this.checker=e,this.flags=t}getFlags(){return this.flags}getSymbol(){return this.symbol}getProperties(){return this.checker.getPropertiesOfType(this)}getProperty(e){return this.checker.getPropertyOfType(this,e)}getApparentProperties(){return this.checker.getAugmentedPropertiesOfType(this)}getCallSignatures(){return this.checker.getSignaturesOfType(this,0)}getConstructSignatures(){return this.checker.getSignaturesOfType(this,1)}getStringIndexType(){return this.checker.getIndexTypeOfType(this,0)}getNumberIndexType(){return this.checker.getIndexTypeOfType(this,1)}getBaseTypes(){return this.isClassOrInterface()?this.checker.getBaseTypes(this):void 0}isNullableType(){return this.checker.isNullableType(this)}getNonNullableType(){return this.checker.getNonNullableType(this)}getNonOptionalType(){return this.checker.getNonOptionalType(this)}getConstraint(){return this.checker.getBaseConstraintOfType(this)}getDefault(){return this.checker.getDefaultFromTypeParameter(this)}isUnion(){return!!(this.flags&1048576)}isIntersection(){return!!(this.flags&2097152)}isUnionOrIntersection(){return!!(this.flags&3145728)}isLiteral(){return!!(this.flags&2432)}isStringLiteral(){return!!(this.flags&128)}isNumberLiteral(){return!!(this.flags&256)}isTypeParameter(){return!!(this.flags&262144)}isClassOrInterface(){return!!(Gn(this)&3)}isClass(){return!!(Gn(this)&1)}isIndexType(){return!!(this.flags&4194304)}get typeArguments(){if(Gn(this)&4)return this.checker.getTypeArguments(this)}},D5e=class{constructor(e,t){this.checker=e,this.flags=t}getDeclaration(){return this.declaration}getTypeParameters(){return this.typeParameters}getParameters(){return this.parameters}getReturnType(){return this.checker.getReturnTypeOfSignature(this)}getTypeParameterAtPosition(e){let t=this.checker.getParameterType(this,e);if(t.isIndexType()&&x6(t.type)){let n=t.type.getConstraint();if(n)return this.checker.getIndexType(n)}return t}getDocumentationComment(){return this.documentationComment||(this.documentationComment=uq(_A(this.declaration),this.checker))}getJsDocTags(){return this.jsDocTags||(this.jsDocTags=Hre(_A(this.declaration),this.checker))}},I5e=class extends Qre{constructor(e,t,n){super(e,t,n),this.kind=312}update(e,t){return cQ(this,e,t)}getLineAndCharacterOfPosition(e){return Lo(this,e)}getLineStarts(){return vy(this)}getPositionOfLineAndCharacter(e,t,n){return m9(vy(this),e,t,this.text,n)}getLineEndOfPosition(e){let{line:t}=this.getLineAndCharacterOfPosition(e),n=this.getLineStarts(),i;t+1>=n.length&&(i=this.getEnd()),i||(i=n[t+1]-1);let s=this.getFullText();return s[i]===`
`&&s[i-1]==="\r"?i-1:i}getNamedDeclarations(){return this.namedDeclarations||(this.namedDeclarations=this.computeNamedDeclarations()),this.namedDeclarations}computeNamedDeclarations(){let e=g_();return this.forEachChild(s),e;function t(o){let l=i(o);l&&e.add(l,o)}function n(o){let l=e.get(o);return l||e.set(o,l=[]),l}function i(o){let l=S9(o);return l&&(uo(l)&&Hn(l.expression)?l.expression.name.text:Al(l)?n7(l):void 0)}function s(o){switch(o.kind){case 262:case 218:case 174:case 173:let l=o,p=i(l);if(p){let h=n(p),b=Is(h);b&&l.parent===b.parent&&l.symbol===b.symbol?l.body&&!b.body&&(h[h.length-1]=l):h.push(l)}Qs(o,s);break;case 263:case 231:case 264:case 265:case 266:case 267:case 271:case 281:case 276:case 273:case 274:case 177:case 178:case 187:t(o),Qs(o,s);break;case 169:if(!ui(o,31))break;case 260:case 208:{let h=o;if(la(h.name)){Qs(h.name,s);break}h.initializer&&s(h.initializer)}case 306:case 172:case 171:t(o);break;case 278:let m=o;m.exportClause&&(wd(m.exportClause)?Te(m.exportClause.elements,s):s(m.exportClause.name));break;case 272:let S=o.importClause;S&&(S.name&&t(S.name),S.namedBindings&&(S.namedBindings.kind===274?t(S.namedBindings):Te(S.namedBindings.elements,s)));break;case 226:al(o)!==0&&t(o);default:Qs(o,s)}}}},w5e=class{constructor(e,t,n){this.fileName=e,this.text=t,this.skipTrivia=n}getLineAndCharacterOfPosition(e){return Lo(this,e)}},O5e=class{constructor(e){this.host=e}getCurrentSourceFile(e){var t,n,i,s,o,l,p,m;let S=this.host.getScriptSnapshot(e);if(!S)throw new Error("Could not find file: '"+e+"'.");let h=Rte(e,this.host),b=this.host.getScriptVersion(e),A;if(this.currentFileName!==e){let k={languageVersion:99,impliedNodeFormat:RM(gc(e,this.host.getCurrentDirectory(),((i=(n=(t=this.host).getCompilerHost)==null?void 0:n.call(t))==null?void 0:i.getCanonicalFileName)||N1(this.host)),(m=(p=(l=(o=(s=this.host).getCompilerHost)==null?void 0:o.call(s))==null?void 0:l.getModuleResolutionCache)==null?void 0:p.call(l))==null?void 0:m.getPackageJsonInfoCache(),this.host,this.host.getCompilationSettings()),setExternalModuleIndicator:aR(this.host.getCompilationSettings()),jsDocParsingMode:0};A=fq(e,S,k,b,!0,h)}else if(this.currentFileVersion!==b){let k=S.getChangeRange(this.currentFileScriptSnapshot);A=Xre(this.currentSourceFile,S,b,k)}return A&&(this.currentFileVersion=b,this.currentFileName=e,this.currentFileScriptSnapshot=S,this.currentSourceFile=A),this.currentSourceFile}},R5e={isCancellationRequested:qf,throwIfCancellationRequested:ja},M5e=class{constructor(e){this.cancellationToken=e}isCancellationRequested(){return this.cancellationToken.isCancellationRequested()}throwIfCancellationRequested(){var e;if(this.isCancellationRequested())throw(e=mn)==null||e.instant(mn.Phase.Session,"cancellationThrown",{kind:"CancellationTokenObject"}),new VP}},rne=class{constructor(e,t=20){this.hostCancellationToken=e,this.throttleWaitMilliseconds=t,this.lastCancellationCheckTime=0}isCancellationRequested(){let e=uc();return Math.abs(e-this.lastCancellationCheckTime)>=this.throttleWaitMilliseconds?(this.lastCancellationCheckTime=e,this.hostCancellationToken.isCancellationRequested()):!1}throwIfCancellationRequested(){var e;if(this.isCancellationRequested())throw(e=mn)==null||e.instant(mn.Phase.Session,"cancellationThrown",{kind:"ThrottledCancellationToken"}),new VP}},bSe=["getSemanticDiagnostics","getSuggestionDiagnostics","getCompilerOptionsDiagnostics","getSemanticClassifications","getEncodedSemanticClassifications","getCodeFixesAtPosition","getCombinedCodeFix","applyCodeActionCommand","organizeImports","getEditsForFileRename","getEmitOutput","getApplicableRefactors","getEditsForRefactor","prepareCallHierarchy","provideCallHierarchyIncomingCalls","provideCallHierarchyOutgoingCalls","provideInlayHints","getSupportedCodeFixes"],L5e=[...bSe,"getCompletionsAtPosition","getCompletionEntryDetails","getCompletionEntrySymbol","getSignatureHelpItems","getQuickInfoAtPosition","getDefinitionAtPosition","getDefinitionAndBoundSpan","getImplementationAtPosition","getTypeDefinitionAtPosition","getReferencesAtPosition","findReferences","getDocumentHighlights","getNavigateToItems","getRenameInfo","findRenameLocations","getApplicableRefactors"],vme(SAt())}});function F5e(e,t,n){let i=[];n=hre(n,i);let s=os(e)?e:[e],o=CM(void 0,void 0,j,n,s,t,!0);return o.diagnostics=ys(o.diagnostics,i),o}var kAt=f({"src/services/transform.ts"(){"use strict";yi()}});function PAt(e,t){if(e.isDeclarationFile)return;let n=Ts(e,t),i=e.getLineAndCharacterOfPosition(t).line;if(e.getLineAndCharacterOfPosition(n.getStart(e)).line>i){let b=tu(n.pos,e);if(!b||e.getLineAndCharacterOfPosition(b.getEnd()).line!==i)return;n=b}if(n.flags&33554432)return;return h(n);function s(b,A){let k=yx(b)?Da(b.modifiers,n_):void 0,N=k?Wa(e.text,k.end):b.getStart(e);return Ll(N,(A||b).getEnd())}function o(b,A){return s(b,AE(A,A.parent,e))}function l(b,A){return b&&i===e.getLineAndCharacterOfPosition(b.getStart(e)).line?h(b):h(A)}function p(b,A,k){if(b){let N=b.indexOf(A);if(N>=0){let M=N,O=N+1;for(;M>0&&k(b[M-1]);)M--;for(;O<b.length&&k(b[O]);)O++;return Ll(Wa(e.text,b[M].pos),b[O-1].end)}}return s(A)}function m(b){return h(tu(b.pos,e))}function S(b){return h(AE(b,b.parent,e))}function h(b){if(b){let{parent:oe}=b;switch(b.kind){case 243:return k(b.declarationList.declarations[0]);case 260:case 172:case 171:return k(b);case 169:return M(b);case 262:case 174:case 173:case 177:case 178:case 176:case 218:case 219:return U(b);case 241:if(Wb(b))return H(b);case 268:return K(b);case 299:return K(b.block);case 244:return s(b.expression);case 253:return s(b.getChildAt(0),b.expression);case 247:return o(b,b.expression);case 246:return h(b.statement);case 259:return s(b.getChildAt(0));case 245:return o(b,b.expression);case 256:return h(b.statement);case 252:case 251:return s(b.getChildAt(0),b.label);case 248:return $(b);case 249:return o(b,b.expression);case 250:return re(b);case 255:return o(b,b.expression);case 296:case 297:return h(b.statements[0]);case 258:return K(b.tryBlock);case 257:return s(b,b.expression);case 277:return s(b,b.expression);case 271:return s(b,b.moduleReference);case 272:return s(b,b.moduleSpecifier);case 278:return s(b,b.moduleSpecifier);case 267:if(Oy(b)!==1)return;case 263:case 266:case 306:case 208:return s(b);case 254:return h(b.statement);case 170:return p(oe.modifiers,b,n_);case 206:case 207:return pe(b);case 264:case 265:return;case 27:case 1:return l(tu(b.pos,e));case 28:return m(b);case 19:return se(b);case 20:return Se(b);case 24:return xe(b);case 21:return Z(b);case 22:return Q(b);case 59:return ce(b);case 32:case 30:return ye(b);case 117:return we(b);case 93:case 85:case 98:return S(b);case 165:return ve(b);default:if(V1(b))return z(b);if((b.kind===80||b.kind===230||b.kind===303||b.kind===304)&&V1(oe))return s(b);if(b.kind===226){let{left:Ee,operatorToken:Me}=b;if(V1(Ee))return z(Ee);if(Me.kind===64&&V1(b.parent))return s(b);if(Me.kind===28)return h(Ee)}if(k0(b))switch(oe.kind){case 246:return m(b);case 170:return h(b.parent);case 248:case 250:return s(b);case 226:if(b.parent.operatorToken.kind===28)return s(b);break;case 219:if(b.parent.body===b)return s(b);break}switch(b.parent.kind){case 303:if(b.parent.name===b&&!V1(b.parent.parent))return h(b.parent.initializer);break;case 216:if(b.parent.type===b)return S(b.parent.type);break;case 260:case 169:{let{initializer:Ee,type:Me}=b.parent;if(Ee===b||Me===b||D1(b.kind))return m(b);break}case 226:{let{left:Ee}=b.parent;if(V1(Ee)&&b!==Ee)return m(b);break}default:if(ca(b.parent)&&b.parent.type===b)return m(b)}return h(b.parent)}}function A(oe){return Tu(oe.parent)&&oe.parent.declarations[0]===oe?s(tu(oe.pos,e,oe.parent),oe):s(oe)}function k(oe){if(oe.parent.parent.kind===249)return h(oe.parent.parent);let Ee=oe.parent;if(la(oe.name))return pe(oe.name);if(V2(oe)&&oe.initializer||ui(oe,32)||Ee.parent.kind===250)return A(oe);if(Tu(oe.parent)&&oe.parent.declarations[0]!==oe)return h(tu(oe.pos,e,oe.parent))}function N(oe){return!!oe.initializer||oe.dotDotDotToken!==void 0||ui(oe,3)}function M(oe){if(la(oe.name))return pe(oe.name);if(N(oe))return s(oe);{let Ee=oe.parent,Me=Ee.parameters.indexOf(oe);return I.assert(Me!==-1),Me!==0?M(Ee.parameters[Me-1]):h(Ee.body)}}function O(oe){return ui(oe,32)||oe.parent.kind===263&&oe.kind!==176}function U(oe){if(oe.body)return O(oe)?s(oe):h(oe.body)}function H(oe){let Ee=oe.statements.length?oe.statements[0]:oe.getLastToken();return O(oe.parent)?l(oe.parent,Ee):h(Ee)}function K(oe){switch(oe.parent.kind){case 267:if(Oy(oe.parent)!==1)return;case 247:case 245:case 249:return l(oe.parent,oe.statements[0]);case 248:case 250:return l(tu(oe.pos,e,oe.parent),oe.statements[0])}return h(oe.statements[0])}function re(oe){if(oe.initializer.kind===261){let Ee=oe.initializer;if(Ee.declarations.length>0)return h(Ee.declarations[0])}else return h(oe.initializer)}function $(oe){if(oe.initializer)return re(oe);if(oe.condition)return s(oe.condition);if(oe.incrementor)return s(oe.incrementor)}function pe(oe){let Ee=Te(oe.elements,Me=>Me.kind!==232?Me:void 0);return Ee?h(Ee):oe.parent.kind===208?s(oe.parent):A(oe.parent)}function z(oe){I.assert(oe.kind!==207&&oe.kind!==206);let Ee=oe.kind===209?oe.elements:oe.properties,Me=Te(Ee,Ge=>Ge.kind!==232?Ge:void 0);return Me?h(Me):s(oe.parent.kind===226?oe.parent:oe)}function se(oe){switch(oe.parent.kind){case 266:let Ee=oe.parent;return l(tu(oe.pos,e,oe.parent),Ee.members.length?Ee.members[0]:Ee.getLastToken(e));case 263:let Me=oe.parent;return l(tu(oe.pos,e,oe.parent),Me.members.length?Me.members[0]:Me.getLastToken(e));case 269:return l(oe.parent.parent,oe.parent.clauses[0])}return h(oe.parent)}function Se(oe){switch(oe.parent.kind){case 268:if(Oy(oe.parent.parent)!==1)return;case 266:case 263:return s(oe);case 241:if(Wb(oe.parent))return s(oe);case 299:return h(Is(oe.parent.statements));case 269:let Ee=oe.parent,Me=Is(Ee.clauses);return Me?h(Is(Me.statements)):void 0;case 206:let Ge=oe.parent;return h(Is(Ge.elements)||Ge);default:if(V1(oe.parent)){let Ae=oe.parent;return s(Is(Ae.properties)||Ae)}return h(oe.parent)}}function xe(oe){switch(oe.parent.kind){case 207:let Ee=oe.parent;return s(Is(Ee.elements)||Ee);default:if(V1(oe.parent)){let Me=oe.parent;return s(Is(Me.elements)||Me)}return h(oe.parent)}}function Z(oe){return oe.parent.kind===246||oe.parent.kind===213||oe.parent.kind===214?m(oe):oe.parent.kind===217?S(oe):h(oe.parent)}function Q(oe){switch(oe.parent.kind){case 218:case 262:case 219:case 174:case 173:case 177:case 178:case 176:case 247:case 246:case 248:case 250:case 213:case 214:case 217:return m(oe);default:return h(oe.parent)}}function ce(oe){return ca(oe.parent)||oe.parent.kind===303||oe.parent.kind===169?m(oe):h(oe.parent)}function ye(oe){return oe.parent.kind===216?S(oe):h(oe.parent)}function we(oe){return oe.parent.kind===246?o(oe,oe.parent.expression):h(oe.parent)}function ve(oe){return oe.parent.kind===250?S(oe):h(oe.parent)}}}var NAt=f({"src/services/breakpoints.ts"(){"use strict";yi()}}),nne={};x(nne,{spanInSourceFileAtLocation:()=>PAt});var DAt=f({"src/services/_namespaces/ts.BreakpointResolver.ts"(){"use strict";NAt()}});function IAt(e){return(Xo(e)||wu(e))&&W_(e)}function j5e(e){return ea(e)||Gi(e)}function w7(e){return(Xo(e)||rc(e)||wu(e))&&j5e(e.parent)&&e===e.parent.initializer&&ze(e.parent.name)&&(!!(x1(e.parent)&2)||ea(e.parent))}function B5e(e){return ls(e)||hl(e)||Zl(e)||Xo(e)||eu(e)||wu(e)||Jc(e)||pl(e)||Uh(e)||sd(e)||pp(e)}function RD(e){return ls(e)||hl(e)&&ze(e.name)||Zl(e)||eu(e)||Jc(e)||pl(e)||Uh(e)||sd(e)||pp(e)||IAt(e)||w7(e)}function U5e(e){return ls(e)?e:W_(e)?e.name:w7(e)?e.parent.name:I.checkDefined(e.modifiers&&mr(e.modifiers,V5e))}function V5e(e){return e.kind===90}function J5e(e,t){let n=U5e(t);return n&&e.getSymbolAtLocation(n)}function wAt(e,t){if(ls(t))return{text:t.fileName,pos:0,end:0};if((Zl(t)||eu(t))&&!W_(t)){let s=t.modifiers&&mr(t.modifiers,V5e);if(s)return{text:"default",pos:s.getStart(),end:s.getEnd()}}if(Jc(t)){let s=t.getSourceFile(),o=Wa(s.text,Xg(t).pos),l=o+6,p=e.getTypeChecker(),m=p.getSymbolAtLocation(t.parent);return{text:`${m?`${p.symbolToString(m,t.parent)} `:""}static {}`,pos:o,end:l}}let n=w7(t)?t.parent.name:I.checkDefined(qs(t),"Expected call hierarchy item to have a name"),i=ze(n)?Nn(n):id(n)?n.text:uo(n)&&id(n.expression)?n.expression.text:void 0;if(i===void 0){let s=e.getTypeChecker(),o=s.getSymbolAtLocation(n);o&&(i=s.symbolToString(o,t))}if(i===void 0){let s=kM();i=jw(o=>s.writeNode(4,t,t.getSourceFile(),o))}return{text:i,pos:n.getStart(),end:n.getEnd()}}function OAt(e){var t,n,i,s;if(w7(e))return ea(e.parent)&&Ti(e.parent.parent)?wu(e.parent.parent)?(t=T9(e.parent.parent))==null?void 0:t.getText():(n=e.parent.parent.name)==null?void 0:n.getText():Zg(e.parent.parent.parent.parent)&&ze(e.parent.parent.parent.parent.parent.name)?e.parent.parent.parent.parent.parent.name.getText():void 0;switch(e.kind){case 177:case 178:case 174:return e.parent.kind===210?(i=T9(e.parent))==null?void 0:i.getText():(s=qs(e.parent))==null?void 0:s.getText();case 262:case 263:case 267:if(Zg(e.parent)&&ze(e.parent.parent.name))return e.parent.parent.name.getText()}}function q5e(e,t){if(t.body)return t;if(Yc(t))return I0(t.parent);if(Zl(t)||pl(t)){let n=J5e(e,t);return n&&n.valueDeclaration&&tc(n.valueDeclaration)&&n.valueDeclaration.body?n.valueDeclaration:void 0}return t}function z5e(e,t){let n=J5e(e,t),i;if(n&&n.declarations){let s=tT(n.declarations),o=vr(n.declarations,m=>({file:m.getSourceFile().fileName,pos:m.pos}));s.sort((m,S)=>h_(o[m].file,o[S].file)||o[m].pos-o[S].pos);let l=vr(s,m=>n.declarations[m]),p;for(let m of l)RD(m)&&((!p||p.parent!==m.parent||p.end!==m.pos)&&(i=Pr(i,m)),p=m)}return i}function ine(e,t){return Jc(t)?t:tc(t)?q5e(e,t)??z5e(e,t)??t:z5e(e,t)??t}function $5e(e,t){let n=e.getTypeChecker(),i=!1;for(;;){if(RD(t))return ine(n,t);if(B5e(t)){let s=Gr(t,RD);return s&&ine(n,s)}if(Cy(t)){if(RD(t.parent))return ine(n,t.parent);if(B5e(t.parent)){let s=Gr(t.parent,RD);return s&&ine(n,s)}return j5e(t.parent)&&t.parent.initializer&&w7(t.parent.initializer)?t.parent.initializer:void 0}if(Yc(t))return RD(t.parent)?t.parent:void 0;if(t.kind===126&&Jc(t.parent)){t=t.parent;continue}if(Gi(t)&&t.initializer&&w7(t.initializer))return t.initializer;if(!i){let s=n.getSymbolAtLocation(t);if(s&&(s.flags&2097152&&(s=n.getAliasedSymbol(s)),s.valueDeclaration)){i=!0,t=s.valueDeclaration;continue}}return}}function ESe(e,t){let n=t.getSourceFile(),i=wAt(e,t),s=OAt(t),o=CE(t),l=xO(t),p=Ll(Wa(n.text,t.getFullStart(),!1,!0),t.getEnd()),m=Ll(i.pos,i.end);return{file:n.fileName,kind:o,kindModifiers:l,name:i.text,containerName:s,span:p,selectionSpan:m}}function RAt(e){return e!==void 0}function MAt(e){if(e.kind===Ko.EntryKind.Node){let{node:t}=e;if(Qee(t,!0,!0)||a1e(t,!0,!0)||o1e(t,!0,!0)||c1e(t,!0,!0)||SD(t)||nte(t)){let n=t.getSourceFile();return{declaration:Gr(t,RD)||n,range:yte(t,n)}}}}function W5e(e){return yo(e.declaration)}function LAt(e,t){return{from:e,fromSpans:t}}function FAt(e,t){return LAt(ESe(e,t[0].declaration),vr(t,n=>aS(n.range)))}function jAt(e,t,n){if(ls(t)||hl(t)||Jc(t))return[];let i=U5e(t),s=Fn(Ko.findReferenceOrRenameEntries(e,n,e.getSourceFiles(),i,0,{use:Ko.FindReferencesUse.References},MAt),RAt);return s?m_(s,W5e,o=>FAt(e,o)):[]}function BAt(e,t){function n(s){let o=uE(s)?s.tag:H_(s)?s.tagName:Yo(s)||Jc(s)?s:s.expression,l=$5e(e,o);if(l){let p=yte(o,s.getSourceFile());if(os(l))for(let m of l)t.push({declaration:m,range:p});else t.push({declaration:l,range:p})}}function i(s){if(s&&!(s.flags&33554432)){if(RD(s)){if(Ti(s))for(let o of s.members)o.name&&uo(o.name)&&i(o.name.expression);return}switch(s.kind){case 80:case 271:case 272:case 278:case 264:case 265:return;case 175:n(s);return;case 216:case 234:i(s.expression);return;case 260:case 169:i(s.name),i(s.initializer);return;case 213:n(s),i(s.expression),Te(s.arguments,i);return;case 214:n(s),i(s.expression),Te(s.arguments,i);return;case 215:n(s),i(s.tag),i(s.template);return;case 286:case 285:n(s),i(s.tagName),i(s.attributes);return;case 170:n(s),i(s.expression);return;case 211:case 212:n(s),Qs(s,i);break;case 238:i(s.expression);return}A0(s)||Qs(s,i)}}return i}function UAt(e,t){Te(e.statements,t)}function VAt(e,t){!ui(e,128)&&e.body&&Zg(e.body)&&Te(e.body.statements,t)}function JAt(e,t,n){let i=q5e(e,t);i&&(Te(i.parameters,n),n(i.body))}function qAt(e,t){t(e.body)}function zAt(e,t){Te(e.modifiers,t);let n=Xb(e);n&&t(n.expression);for(let i of e.members)Jm(i)&&Te(i.modifiers,t),ea(i)?t(i.initializer):Yc(i)&&i.body?(Te(i.parameters,t),t(i.body)):Jc(i)&&t(i)}function $At(e,t){let n=[],i=BAt(e,n);switch(t.kind){case 312:UAt(t,i);break;case 267:VAt(t,i);break;case 262:case 218:case 219:case 174:case 177:case 178:JAt(e.getTypeChecker(),t,i);break;case 263:case 231:zAt(t,i);break;case 175:qAt(t,i);break;default:I.assertNever(t)}return n}function WAt(e,t){return{to:e,fromSpans:t}}function GAt(e,t){return WAt(ESe(e,t[0].declaration),vr(t,n=>aS(n.range)))}function HAt(e,t){return t.flags&33554432||Uh(t)?[]:m_($At(e,t),W5e,n=>GAt(e,n))}var YAt=f({"src/services/callHierarchy.ts"(){"use strict";yi()}}),Ek={};x(Ek,{createCallHierarchyItem:()=>ESe,getIncomingCalls:()=>jAt,getOutgoingCalls:()=>HAt,resolveCallHierarchyDeclaration:()=>$5e});var XAt=f({"src/services/_namespaces/ts.CallHierarchy.ts"(){"use strict";YAt()}}),G5e={};x(G5e,{TokenEncodingConsts:()=>dSe,TokenModifier:()=>gSe,TokenType:()=>mSe,getEncodedSemanticClassifications:()=>pSe,getSemanticClassifications:()=>v5e});var KAt=f({"src/services/_namespaces/ts.classifier.v2020.ts"(){"use strict";b5e()}}),xSe={};x(xSe,{v2020:()=>G5e});var QAt=f({"src/services/_namespaces/ts.classifier.ts"(){"use strict";KAt()}});function hg(e,t,n){return ASe(e,Dx(n),t,void 0,void 0)}function ma(e,t,n,i,s,o){return ASe(e,Dx(n),t,i,Dx(s),o)}function CSe(e,t,n,i,s,o){return ASe(e,Dx(n),t,i,s&&Dx(s),o)}function ASe(e,t,n,i,s,o){return{fixName:e,description:t,changes:n,fixId:i,fixAllDescription:s,commands:o?[o]:void 0}}function wa(e){for(let t of e.errorCodes)kSe=void 0,sne.add(String(t),e);if(e.fixIds)for(let t of e.fixIds)I.assert(!ane.has(t)),ane.set(t,e)}function ZAt(){return kSe??(kSe=In(sne.keys()))}function ekt(e,t){let{errorCodes:n}=e,i=0;for(let o of t)if(hs(n,o.code)&&i++,i>1)break;let s=i<2;return({fixId:o,fixAllDescription:l,...p})=>s?p:{...p,fixId:o,fixAllDescription:l}}function tkt(e){let t=Y5e(e),n=sne.get(String(e.errorCode));return _a(n,i=>vr(i.getCodeActions(e),ekt(i,t)))}function rkt(e){return ane.get(ta(e.fixId,vs)).getAllCodeActions(e)}function MD(e,t){return{changes:e,commands:t}}function H5e(e,t){return{fileName:e,textChanges:t}}function Fo(e,t,n){let i=[],s=En.ChangeTracker.with(e,o=>LD(e,t,l=>n(o,l,i)));return MD(s,i.length===0?void 0:i)}function LD(e,t,n){for(let i of Y5e(e))hs(t,i.code)&&n(i)}function Y5e({program:e,sourceFile:t,cancellationToken:n}){return[...e.getSemanticDiagnostics(t,n),...e.getSyntacticDiagnostics(t,n),...fre(t,e,n)]}var sne,ane,kSe,nkt=f({"src/services/codeFixProvider.ts"(){"use strict";yi(),sne=g_(),ane=new Map}});function X5e(e,t,n){let i=FR(n)?j.createAsExpression(n.expression,j.createKeywordTypeNode(159)):j.createTypeAssertion(j.createKeywordTypeNode(159),n.expression);e.replaceNode(t,n.expression,i)}function K5e(e,t){if(!gn(e))return Gr(Ts(e,t),n=>FR(n)||Cge(n))}var one,PSe,ikt=f({"src/services/codefixes/addConvertToUnknownForNonOverlappingTypes.ts"(){"use strict";yi(),Ma(),one="addConvertToUnknownForNonOverlappingTypes",PSe=[g.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first.code],wa({errorCodes:PSe,getCodeActions:function(t){let n=K5e(t.sourceFile,t.span.start);if(n===void 0)return;let i=En.ChangeTracker.with(t,s=>X5e(s,t.sourceFile,n));return[ma(one,i,g.Add_unknown_conversion_for_non_overlapping_types,one,g.Add_unknown_to_all_conversions_of_non_overlapping_types)]},fixIds:[one],getAllCodeActions:e=>Fo(e,PSe,(t,n)=>{let i=K5e(n.file,n.start);i&&X5e(t,n.file,i)})})}}),skt=f({"src/services/codefixes/addEmptyExportDeclaration.ts"(){"use strict";yi(),Ma(),wa({errorCodes:[g.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code,g.await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code,g.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code],getCodeActions:function(t){let{sourceFile:n}=t,i=En.ChangeTracker.with(t,s=>{let o=j.createExportDeclaration(void 0,!1,j.createNamedExports([]),void 0);s.insertNodeAtEndOfScope(n,n,o)});return[hg("addEmptyExportDeclaration",i,g.Add_export_to_make_this_file_into_a_module)]}})}});function Q5e(e,t,n,i){let s=n(o=>akt(o,e.sourceFile,t,i));return ma(cne,s,g.Add_async_modifier_to_containing_function,cne,g.Add_all_missing_async_modifiers)}function akt(e,t,n,i){if(i&&i.has(yo(n)))return;i?.add(yo(n));let s=j.replaceModifiers(Sc(n,!0),j.createNodeArray(j.createModifiersFromModifierFlags(qv(n)|1024)));e.replaceNode(t,n,s)}function Z5e(e,t){if(!t)return;let n=Ts(e,t.start);return Gr(n,s=>s.getStart(e)<t.start||s.getEnd()>gl(t)?"quit":(rc(s)||pl(s)||Xo(s)||Zl(s))&&CD(t,gf(s,e)))}function okt(e,t){return({start:n,length:i,relatedInformation:s,code:o})=>Mp(n)&&Mp(i)&&CD({start:n,length:i},e)&&o===t&&!!s&&Tt(s,l=>l.code===g.Did_you_mean_to_mark_this_function_as_async.code)}var cne,NSe,ckt=f({"src/services/codefixes/addMissingAsync.ts"(){"use strict";yi(),Ma(),cne="addMissingAsync",NSe=[g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,g.Type_0_is_not_assignable_to_type_1.code,g.Type_0_is_not_comparable_to_type_1.code],wa({fixIds:[cne],errorCodes:NSe,getCodeActions:function(t){let{sourceFile:n,errorCode:i,cancellationToken:s,program:o,span:l}=t,p=mr(o.getTypeChecker().getDiagnostics(n,s),okt(l,i)),m=p&&p.relatedInformation&&mr(p.relatedInformation,b=>b.code===g.Did_you_mean_to_mark_this_function_as_async.code),S=Z5e(n,m);return S?[Q5e(t,S,b=>En.ChangeTracker.with(t,b))]:void 0},getAllCodeActions:e=>{let{sourceFile:t}=e,n=new Set;return Fo(e,NSe,(i,s)=>{let o=s.relatedInformation&&mr(s.relatedInformation,m=>m.code===g.Did_you_mean_to_mark_this_function_as_async.code),l=Z5e(t,o);return l?Q5e(e,l,m=>(m(i),[]),n):void 0})}})}});function e9e(e,t,n,i,s){let o=zte(e,n);return o&&lkt(e,t,n,i,s)&&n9e(o)?o:void 0}function t9e(e,t,n,i,s,o){let{sourceFile:l,program:p,cancellationToken:m}=e,S=ukt(t,l,m,p,i);if(S){let h=s(b=>{Te(S.initializers,({expression:A})=>DSe(b,n,l,i,A,o)),o&&S.needsSecondPassForFixAll&&DSe(b,n,l,i,t,o)});return hg("addMissingAwaitToInitializer",h,S.initializers.length===1?[g.Add_await_to_initializer_for_0,S.initializers[0].declarationSymbol.name]:g.Add_await_to_initializers)}}function r9e(e,t,n,i,s,o){let l=s(p=>DSe(p,n,e.sourceFile,i,t,o));return ma(lne,l,g.Add_await,lne,g.Fix_all_expressions_possibly_missing_await)}function lkt(e,t,n,i,s){let l=s.getTypeChecker().getDiagnostics(e,i);return Tt(l,({start:p,length:m,relatedInformation:S,code:h})=>Mp(p)&&Mp(m)&&CD({start:p,length:m},n)&&h===t&&!!S&&Tt(S,b=>b.code===g.Did_you_forget_to_use_await.code))}function ukt(e,t,n,i,s){let o=_kt(e,s);if(!o)return;let l=o.isCompleteFix,p;for(let m of o.identifiers){let S=s.getSymbolAtLocation(m);if(!S)continue;let h=ii(S.valueDeclaration,Gi),b=h&&ii(h.name,ze),A=ST(h,243);if(!h||!A||h.type||!h.initializer||A.getSourceFile()!==t||ui(A,32)||!b||!n9e(h.initializer)){l=!1;continue}let k=i.getSemanticDiagnostics(t,n);if(Ko.Core.eachSymbolReferenceInFile(b,s,t,M=>m!==M&&!fkt(M,k,t,s))){l=!1;continue}(p||(p=[])).push({expression:h.initializer,declarationSymbol:S})}return p&&{initializers:p,needsSecondPassForFixAll:!l}}function _kt(e,t){if(Hn(e.parent)&&ze(e.parent.expression))return{identifiers:[e.parent.expression],isCompleteFix:!0};if(ze(e))return{identifiers:[e],isCompleteFix:!0};if(bn(e)){let n,i=!0;for(let s of[e.left,e.right]){let o=t.getTypeAtLocation(s);if(t.getPromisedTypeOfPromise(o)){if(!ze(s)){i=!1;continue}(n||(n=[])).push(s)}}return n&&{identifiers:n,isCompleteFix:i}}}function fkt(e,t,n,i){let s=Hn(e.parent)?e.parent.name:bn(e.parent)?e.parent:e,o=mr(t,l=>l.start===s.getStart(n)&&l.start+l.length===s.getEnd());return o&&hs(une,o.code)||i.getTypeAtLocation(s).flags&1}function n9e(e){return e.flags&65536||!!Gr(e,t=>t.parent&&rc(t.parent)&&t.parent.body===t||ra(t)&&(t.parent.kind===262||t.parent.kind===218||t.parent.kind===219||t.parent.kind===174))}function DSe(e,t,n,i,s,o){if(jR(s.parent)&&!s.parent.awaitModifier){let l=i.getTypeAtLocation(s),p=i.getAsyncIterableType();if(p&&i.isTypeAssignableTo(l,p)){let m=s.parent;e.replaceNode(n,m,j.updateForOfStatement(m,j.createToken(135),m.initializer,m.expression,m.statement));return}}if(bn(s))for(let l of[s.left,s.right]){if(o&&ze(l)){let S=i.getSymbolAtLocation(l);if(S&&o.has(Ia(S)))continue}let p=i.getTypeAtLocation(l),m=i.getPromisedTypeOfPromise(p)?j.createAwaitExpression(l):l;e.replaceNode(n,l,m)}else if(t===ISe&&Hn(s.parent)){if(o&&ze(s.parent.expression)){let l=i.getSymbolAtLocation(s.parent.expression);if(l&&o.has(Ia(l)))return}e.replaceNode(n,s.parent.expression,j.createParenthesizedExpression(j.createAwaitExpression(s.parent.expression))),i9e(e,s.parent.expression,n)}else if(hs(wSe,t)&&Jg(s.parent)){if(o&&ze(s)){let l=i.getSymbolAtLocation(s);if(l&&o.has(Ia(l)))return}e.replaceNode(n,s,j.createParenthesizedExpression(j.createAwaitExpression(s))),i9e(e,s,n)}else{if(o&&Gi(s.parent)&&ze(s.parent.name)){let l=i.getSymbolAtLocation(s.parent.name);if(l&&!Zd(o,Ia(l)))return}e.replaceNode(n,s,j.createAwaitExpression(s))}}function i9e(e,t,n){let i=tu(t.pos,n);i&&AJ(i.end,i.parent,n)&&e.insertText(n,t.getStart(n),";")}var lne,ISe,wSe,une,pkt=f({"src/services/codefixes/addMissingAwait.ts"(){"use strict";yi(),Ma(),lne="addMissingAwait",ISe=g.Property_0_does_not_exist_on_type_1.code,wSe=[g.This_expression_is_not_callable.code,g.This_expression_is_not_constructable.code],une=[g.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type.code,g.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,g.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,g.Operator_0_cannot_be_applied_to_type_1.code,g.Operator_0_cannot_be_applied_to_types_1_and_2.code,g.This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap.code,g.This_condition_will_always_return_true_since_this_0_is_always_defined.code,g.Type_0_is_not_an_array_type.code,g.Type_0_is_not_an_array_type_or_a_string_type.code,g.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher.code,g.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,g.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,g.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator.code,g.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator.code,g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,ISe,...wSe],wa({fixIds:[lne],errorCodes:une,getCodeActions:function(t){let{sourceFile:n,errorCode:i,span:s,cancellationToken:o,program:l}=t,p=e9e(n,i,s,o,l);if(!p)return;let m=t.program.getTypeChecker(),S=h=>En.ChangeTracker.with(t,h);return y1([t9e(t,p,i,m,S),r9e(t,p,i,m,S)])},getAllCodeActions:e=>{let{sourceFile:t,program:n,cancellationToken:i}=e,s=e.program.getTypeChecker(),o=new Set;return Fo(e,une,(l,p)=>{let m=e9e(t,p.code,p,i,n);if(!m)return;let S=h=>(h(l),[]);return t9e(e,m,p.code,s,S,o)||r9e(e,m,p.code,s,S,o)})}})}});function s9e(e,t,n,i,s){let o=Ts(t,n),l=Gr(o,S=>QP(S.parent)?S.parent.initializer===S:dkt(S)?!1:"quit");if(l)return _ne(e,l,t,s);let p=o.parent;if(bn(p)&&p.operatorToken.kind===64&&Ou(p.parent))return _ne(e,o,t,s);if(Z_(p)){let S=i.getTypeChecker();return yr(p.elements,h=>mkt(h,S))?_ne(e,p,t,s):void 0}let m=Gr(o,S=>Ou(S.parent)?!0:gkt(S)?!1:"quit");if(m){let S=i.getTypeChecker();return a9e(m,S)?_ne(e,m,t,s):void 0}}function _ne(e,t,n,i){(!i||Zd(i,t))&&e.insertModifierBefore(n,87,t)}function dkt(e){switch(e.kind){case 80:case 209:case 210:case 303:case 304:return!0;default:return!1}}function mkt(e,t){let n=ze(e)?e:lu(e,!0)&&ze(e.left)?e.left:void 0;return!!n&&!t.getSymbolAtLocation(n)}function gkt(e){switch(e.kind){case 80:case 226:case 28:return!0;default:return!1}}function a9e(e,t){return bn(e)?e.operatorToken.kind===28?yr([e.left,e.right],n=>a9e(n,t)):e.operatorToken.kind===64&&ze(e.left)&&!t.getSymbolAtLocation(e.left):!1}var fne,OSe,hkt=f({"src/services/codefixes/addMissingConst.ts"(){"use strict";yi(),Ma(),fne="addMissingConst",OSe=[g.Cannot_find_name_0.code,g.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code],wa({errorCodes:OSe,getCodeActions:function(t){let n=En.ChangeTracker.with(t,i=>s9e(i,t.sourceFile,t.span.start,t.program));if(n.length>0)return[ma(fne,n,g.Add_const_to_unresolved_variable,fne,g.Add_const_to_all_unresolved_variables)]},fixIds:[fne],getAllCodeActions:e=>{let t=new Set;return Fo(e,OSe,(n,i)=>s9e(n,i.file,i.start,e.program,t))}})}});function o9e(e,t,n,i){let s=Ts(t,n);if(!ze(s))return;let o=s.parent;o.kind===172&&(!i||Zd(i,o))&&e.insertModifierBefore(t,138,o)}var pne,RSe,ykt=f({"src/services/codefixes/addMissingDeclareProperty.ts"(){"use strict";yi(),Ma(),pne="addMissingDeclareProperty",RSe=[g.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration.code],wa({errorCodes:RSe,getCodeActions:function(t){let n=En.ChangeTracker.with(t,i=>o9e(i,t.sourceFile,t.span.start));if(n.length>0)return[ma(pne,n,g.Prefix_with_declare,pne,g.Prefix_all_incorrect_property_declarations_with_declare)]},fixIds:[pne],getAllCodeActions:e=>{let t=new Set;return Fo(e,RSe,(n,i)=>o9e(n,i.file,i.start,t))}})}});function c9e(e,t,n){let i=Ts(t,n),s=Gr(i,n_);I.assert(!!s,"Expected position to be owned by a decorator.");let o=j.createCallExpression(s.expression,void 0,void 0);e.replaceNode(t,s.expression,o)}var dne,MSe,vkt=f({"src/services/codefixes/addMissingInvocationForDecorator.ts"(){"use strict";yi(),Ma(),dne="addMissingInvocationForDecorator",MSe=[g._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0.code],wa({errorCodes:MSe,getCodeActions:function(t){let n=En.ChangeTracker.with(t,i=>c9e(i,t.sourceFile,t.span.start));return[ma(dne,n,g.Call_decorator_expression,dne,g.Add_to_all_uncalled_decorators)]},fixIds:[dne],getAllCodeActions:e=>Fo(e,MSe,(t,n)=>c9e(t,n.file,n.start))})}});function l9e(e,t,n){let i=Ts(t,n),s=i.parent;if(!Ls(s))return I.fail("Tried to add a parameter name to a non-parameter: "+I.formatSyntaxKind(i.kind));let o=s.parent.parameters.indexOf(s);I.assert(!s.type,"Tried to add a parameter name to a parameter that already had one."),I.assert(o>-1,"Parameter not found in parent parameter list.");let l=s.name.getEnd(),p=j.createTypeReferenceNode(s.name,void 0),m=u9e(t,s);for(;m;)p=j.createArrayTypeNode(p),l=m.getEnd(),m=u9e(t,m);let S=j.createParameterDeclaration(s.modifiers,s.dotDotDotToken,"arg"+o,s.questionToken,s.dotDotDotToken&&!MR(p)?j.createArrayTypeNode(p):p,s.initializer);e.replaceRange(t,kd(s.getStart(t),l),S)}function u9e(e,t){let n=AE(t.name,t.parent,e);if(n&&n.kind===23&&cE(n.parent)&&Ls(n.parent.parent))return n.parent.parent}var mne,LSe,Skt=f({"src/services/codefixes/addNameToNamelessParameter.ts"(){"use strict";yi(),Ma(),mne="addNameToNamelessParameter",LSe=[g.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1.code],wa({errorCodes:LSe,getCodeActions:function(t){let n=En.ChangeTracker.with(t,i=>l9e(i,t.sourceFile,t.span.start));return[ma(mne,n,g.Add_parameter_name,mne,g.Add_names_to_all_parameters_without_names)]},fixIds:[mne],getAllCodeActions:e=>Fo(e,LSe,(t,n)=>l9e(t,n.file,n.start))})}});function Tkt(e,t,n){var i,s;let o=_9e(zte(e,t),n);if(!o)return tt;let{source:l,target:p}=o,m=bkt(l,p,n)?n.getTypeAtLocation(p.expression):n.getTypeAtLocation(p);return(s=(i=m.symbol)==null?void 0:i.declarations)!=null&&s.some(S=>Xr(S).fileName.match(/\.d\.ts$/))?tt:n.getExactOptionalProperties(m)}function bkt(e,t,n){return Hn(t)&&!!n.getExactOptionalProperties(n.getTypeAtLocation(t.expression)).length&&n.getTypeAtLocation(e)===n.getUndefinedType()}function _9e(e,t){var n;if(e){if(bn(e.parent)&&e.parent.operatorToken.kind===64)return{source:e.parent.right,target:e.parent.left};if(Gi(e.parent)&&e.parent.initializer)return{source:e.parent.initializer,target:e.parent.name};if(da(e.parent)){let i=t.getSymbolAtLocation(e.parent.expression);if(!i?.valueDeclaration||!yA(i.valueDeclaration.kind)||!bt(e))return;let s=e.parent.arguments.indexOf(e);if(s===-1)return;let o=i.valueDeclaration.parameters[s].name;if(ze(o))return{source:e,target:o}}else if(Ul(e.parent)&&ze(e.parent.name)||Hf(e.parent)){let i=_9e(e.parent.parent,t);if(!i)return;let s=t.getPropertyOfType(t.getTypeAtLocation(i.target),e.parent.name.text),o=(n=s?.declarations)==null?void 0:n[0];return o?{source:Ul(e.parent)?e.parent.initializer:e.parent.name,target:o}:void 0}}else return}function Ekt(e,t){for(let n of t){let i=n.valueDeclaration;if(i&&(fp(i)||ea(i))&&i.type){let s=j.createUnionTypeNode([...i.type.kind===192?i.type.types:[i.type],j.createTypeReferenceNode("undefined")]);e.replaceNode(i.getSourceFile(),i.type,s)}}}var FSe,f9e,xkt=f({"src/services/codefixes/addOptionalPropertyUndefined.ts"(){"use strict";yi(),Ma(),FSe="addOptionalPropertyUndefined",f9e=[g.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target.code,g.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code,g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code],wa({errorCodes:f9e,getCodeActions(e){let t=e.program.getTypeChecker(),n=Tkt(e.sourceFile,e.span,t);if(!n.length)return;let i=En.ChangeTracker.with(e,s=>Ekt(s,n));return[hg(FSe,i,g.Add_undefined_to_optional_property_type)]},fixIds:[FSe]})}});function p9e(e,t){let n=Ts(e,t);return ii(Ls(n.parent)?n.parent.parent:n.parent,d9e)}function d9e(e){return Ckt(e)&&m9e(e)}function m9e(e){return tc(e)?e.parameters.some(m9e)||!e.type&&!!K3(e):!e.type&&!!fT(e)}function g9e(e,t,n){if(tc(n)&&(K3(n)||n.parameters.some(i=>!!fT(i)))){if(!n.typeParameters){let s=Dj(n);s.length&&e.insertTypeParameters(t,n,s)}let i=rc(n)&&!Oo(n,21,t);i&&e.insertNodeBefore(t,di(n.parameters),j.createToken(21));for(let s of n.parameters)if(!s.type){let o=fT(s);o&&e.tryInsertTypeAnnotation(t,s,nt(o,IE,es))}if(i&&e.insertNodeAfter(t,Rs(n.parameters),j.createToken(22)),!n.type){let s=K3(n);s&&e.tryInsertTypeAnnotation(t,n,nt(s,IE,es))}}else{let i=I.checkDefined(fT(n),"A JSDocType for this declaration should exist");I.assert(!n.type,"The JSDocType decl should have a type"),e.tryInsertTypeAnnotation(t,n,nt(i,IE,es))}}function Ckt(e){return tc(e)||e.kind===260||e.kind===171||e.kind===172}function IE(e){switch(e.kind){case 319:case 320:return j.createTypeReferenceNode("any",tt);case 323:return kkt(e);case 322:return IE(e.type);case 321:return Pkt(e);case 325:return Nkt(e);case 324:return Dkt(e);case 183:return wkt(e);case 329:return Akt(e);default:let t=wr(e,IE,void 0);return Sn(t,1),t}}function Akt(e){let t=j.createTypeLiteralNode(vr(e.jsDocPropertyTags,n=>j.createPropertySignature(void 0,ze(n.name)?n.name:n.name.right,fR(n)?j.createToken(58):void 0,n.typeExpression&&nt(n.typeExpression.type,IE,es)||j.createKeywordTypeNode(133))));return Sn(t,1),t}function kkt(e){return j.createUnionTypeNode([nt(e.type,IE,es),j.createTypeReferenceNode("undefined",tt)])}function Pkt(e){return j.createUnionTypeNode([nt(e.type,IE,es),j.createTypeReferenceNode("null",tt)])}function Nkt(e){return j.createArrayTypeNode(nt(e.type,IE,es))}function Dkt(e){return j.createFunctionTypeNode(tt,e.parameters.map(Ikt),e.type??j.createKeywordTypeNode(133))}function Ikt(e){let t=e.parent.parameters.indexOf(e),n=e.type.kind===325&&t===e.parent.parameters.length-1,i=e.name||(n?"rest":"arg"+t),s=n?j.createToken(26):e.dotDotDotToken;return j.createParameterDeclaration(e.modifiers,s,i,e.questionToken,nt(e.type,IE,es),e.initializer)}function wkt(e){let t=e.typeName,n=e.typeArguments;if(ze(e.typeName)){if(_j(e))return Okt(e);let i=e.typeName.text;switch(e.typeName.text){case"String":case"Boolean":case"Object":case"Number":i=i.toLowerCase();break;case"array":case"date":case"promise":i=i[0].toUpperCase()+i.slice(1);break}t=j.createIdentifier(i),(i==="Array"||i==="Promise")&&!e.typeArguments?n=j.createNodeArray([j.createTypeReferenceNode("any",tt)]):n=Hr(e.typeArguments,IE,es)}return j.createTypeReferenceNode(t,n)}function Okt(e){let t=j.createParameterDeclaration(void 0,void 0,e.typeArguments[0].kind===150?"n":"s",void 0,j.createTypeReferenceNode(e.typeArguments[0].kind===150?"number":"string",[]),void 0),n=j.createTypeLiteralNode([j.createIndexSignature(void 0,[t],e.typeArguments[1])]);return Sn(n,1),n}var gne,jSe,Rkt=f({"src/services/codefixes/annotateWithTypeFromJSDoc.ts"(){"use strict";yi(),Ma(),gne="annotateWithTypeFromJSDoc",jSe=[g.JSDoc_types_may_be_moved_to_TypeScript_types.code],wa({errorCodes:jSe,getCodeActions(e){let t=p9e(e.sourceFile,e.span.start);if(!t)return;let n=En.ChangeTracker.with(e,i=>g9e(i,e.sourceFile,t));return[ma(gne,n,g.Annotate_with_type_from_JSDoc,gne,g.Annotate_everything_with_types_from_JSDoc)]},fixIds:[gne],getAllCodeActions:e=>Fo(e,jSe,(t,n)=>{let i=p9e(n.file,n.start);i&&g9e(t,n.file,i)})})}});function h9e(e,t,n,i,s,o){let l=i.getSymbolAtLocation(Ts(t,n));if(!l||!l.valueDeclaration||!(l.flags&19))return;let p=l.valueDeclaration;if(Zl(p)||Xo(p))e.replaceNode(t,p,h(p));else if(Gi(p)){let b=S(p);if(!b)return;let A=p.parent.parent;Tu(p.parent)&&p.parent.declarations.length>1?(e.delete(t,p),e.insertNodeAfter(t,A,b)):e.replaceNode(t,A,b)}function m(b){let A=[];return b.exports&&b.exports.forEach(M=>{if(M.name==="prototype"&&M.declarations){let O=M.declarations[0];if(M.declarations.length===1&&Hn(O)&&bn(O.parent)&&O.parent.operatorToken.kind===64&&Ha(O.parent.right)){let U=O.parent.right;N(U.symbol,void 0,A)}}else N(M,[j.createToken(126)],A)}),b.members&&b.members.forEach((M,O)=>{var U,H,K,re;if(O==="constructor"&&M.valueDeclaration){let $=(re=(K=(H=(U=b.exports)==null?void 0:U.get("prototype"))==null?void 0:H.declarations)==null?void 0:K[0])==null?void 0:re.parent;$&&bn($)&&Ha($.right)&&Tt($.right.properties,yne)||e.delete(t,M.valueDeclaration.parent);return}N(M,void 0,A)}),A;function k(M,O){return Yo(M)?Hn(M)&&yne(M)?!0:ca(O):yr(M.properties,U=>!!(pl(U)||x9(U)||Ul(U)&&Xo(U.initializer)&&U.name||yne(U)))}function N(M,O,U){if(!(M.flags&8192)&&!(M.flags&4096))return;let H=M.valueDeclaration,K=H.parent,re=K.right;if(!k(H,re)||Tt(U,Se=>{let xe=qs(Se);return!!(xe&&ze(xe)&&Nn(xe)===Lc(M))}))return;let $=K.parent&&K.parent.kind===244?K.parent:K;if(e.delete(t,$),!re){U.push(j.createPropertyDeclaration(O,M.name,void 0,void 0,void 0));return}if(Yo(H)&&(Xo(re)||rc(re))){let Se=_d(t,s),xe=Mkt(H,o,Se);xe&&pe(U,re,xe);return}else if(Ha(re)){Te(re.properties,Se=>{(pl(Se)||x9(Se))&&U.push(Se),Ul(Se)&&Xo(Se.initializer)&&pe(U,Se.initializer,Se.name),yne(Se)});return}else{if(Y_(t)||!Hn(H))return;let Se=j.createPropertyDeclaration(O,H.name,void 0,void 0,re);kD(K.parent,Se,t),U.push(Se);return}function pe(Se,xe,Z){return Xo(xe)?z(Se,xe,Z):se(Se,xe,Z)}function z(Se,xe,Z){let Q=ys(O,hne(xe,134)),ce=j.createMethodDeclaration(Q,void 0,Z,void 0,void 0,xe.parameters,void 0,xe.body);kD(K,ce,t),Se.push(ce)}function se(Se,xe,Z){let Q=xe.body,ce;Q.kind===241?ce=Q:ce=j.createBlock([j.createReturnStatement(Q)]);let ye=ys(O,hne(xe,134)),we=j.createMethodDeclaration(ye,void 0,Z,void 0,void 0,xe.parameters,void 0,ce);kD(K,we,t),Se.push(we)}}}function S(b){let A=b.initializer;if(!A||!Xo(A)||!ze(b.name))return;let k=m(b.symbol);A.body&&k.unshift(j.createConstructorDeclaration(void 0,A.parameters,A.body));let N=hne(b.parent.parent,95);return j.createClassDeclaration(N,b.name,void 0,void 0,k)}function h(b){let A=m(l);b.body&&A.unshift(j.createConstructorDeclaration(void 0,b.parameters,b.body));let k=hne(b,95);return j.createClassDeclaration(k,b.name,void 0,void 0,A)}}function hne(e,t){return Jm(e)?Fn(e.modifiers,n=>n.kind===t):void 0}function yne(e){return e.name?!!(ze(e.name)&&e.name.text==="constructor"):!1}function Mkt(e,t,n){if(Hn(e))return e.name;let i=e.argumentExpression;if(_p(i))return i;if(bo(i))return nd(i.text,ho(t))?j.createIdentifier(i.text):zA(i)?j.createStringLiteral(i.text,n===0):i}var vne,BSe,Lkt=f({"src/services/codefixes/convertFunctionToEs6Class.ts"(){"use strict";yi(),Ma(),vne="convertFunctionToEs6Class",BSe=[g.This_constructor_function_may_be_converted_to_a_class_declaration.code],wa({errorCodes:BSe,getCodeActions(e){let t=En.ChangeTracker.with(e,n=>h9e(n,e.sourceFile,e.span.start,e.program.getTypeChecker(),e.preferences,e.program.getCompilerOptions()));return[ma(vne,t,g.Convert_function_to_an_ES2015_class,vne,g.Convert_all_constructor_functions_to_classes)]},fixIds:[vne],getAllCodeActions:e=>Fo(e,BSe,(t,n)=>h9e(t,n.file,n.start,e.program.getTypeChecker(),e.preferences,e.program.getCompilerOptions()))})}});function y9e(e,t,n,i){let s=Ts(t,n),o;if(ze(s)&&Gi(s.parent)&&s.parent.initializer&&tc(s.parent.initializer)?o=s.parent.initializer:o=ii(Vp(Ts(t,n)),mre),!o)return;let l=new Map,p=gn(o),m=jkt(o,i),S=Bkt(o,i,l);if(!pre(S,i))return;let h=S.body&&ra(S.body)?Fkt(S.body,i):tt,b={checker:i,synthNamesMap:l,setOfExpressionsToReturn:m,isInJSFile:p};if(!h.length)return;let A=Wa(t.text,Xg(o).pos);e.insertModifierAt(t,A,134,{suffix:" "});for(let k of h)if(Qs(k,function N(M){if(da(M)){let O=FD(M,M,b,!1);if(xk())return!0;e.replaceNodeWithNodes(t,k,O)}else if(!ca(M)&&(Qs(M,N),xk()))return!0}),xk())return}function Fkt(e,t){let n=[];return $b(e,i=>{qJ(i,t)&&n.push(i)}),n}function jkt(e,t){if(!e.body)return new Set;let n=new Set;return Qs(e.body,function i(s){O7(s,t,"then")?(n.add(yo(s)),Te(s.arguments,i)):O7(s,t,"catch")||O7(s,t,"finally")?(n.add(yo(s)),Qs(s,i)):S9e(s,t)?n.add(yo(s)):Qs(s,i)}),n}function O7(e,t,n){if(!da(e))return!1;let s=WM(e,n)&&t.getTypeAtLocation(e);return!!(s&&t.getPromisedTypeOfPromise(s))}function v9e(e,t){return(Gn(e)&4)!==0&&e.target===t}function Sne(e,t,n){if(e.expression.name.escapedText==="finally")return;let i=n.getTypeAtLocation(e.expression.expression);if(v9e(i,n.getPromiseType())||v9e(i,n.getPromiseLikeType()))if(e.expression.name.escapedText==="then"){if(t===T1(e.arguments,0))return T1(e.typeArguments,0);if(t===T1(e.arguments,1))return T1(e.typeArguments,1)}else return T1(e.typeArguments,0)}function S9e(e,t){return bt(e)?!!t.getPromisedTypeOfPromise(t.getTypeAtLocation(e)):!1}function Bkt(e,t,n){let i=new Map,s=g_();return Qs(e,function o(l){if(!ze(l)){Qs(l,o);return}let p=t.getSymbolAtLocation(l);if(p){let m=t.getTypeAtLocation(l),S=A9e(m,t),h=Ia(p).toString();if(S&&!Ls(l.parent)&&!tc(l.parent)&&!n.has(h)){let b=qi(S.parameters),A=b?.valueDeclaration&&Ls(b.valueDeclaration)&&ii(b.valueDeclaration.name,ze)||j.createUniqueName("result",16),k=T9e(A,s);n.set(h,k),s.add(A.text,p)}else if(l.parent&&(Ls(l.parent)||Gi(l.parent)||co(l.parent))){let b=l.text,A=s.get(b);if(A&&A.some(k=>k!==p)){let k=T9e(l,s);i.set(h,k.identifier),n.set(h,k),s.add(b,p)}else{let k=Sc(l);n.set(h,FO(k)),s.add(b,p)}}}}),o7(e,!0,o=>{if(co(o)&&ze(o.name)&&pm(o.parent)){let l=t.getSymbolAtLocation(o.name),p=l&&i.get(String(Ia(l)));if(p&&p.text!==(o.name||o.propertyName).getText())return j.createBindingElement(o.dotDotDotToken,o.propertyName||o.name,p,o.initializer)}else if(ze(o)){let l=t.getSymbolAtLocation(o),p=l&&i.get(String(Ia(l)));if(p)return j.createIdentifier(p.text)}})}function T9e(e,t){let n=(t.get(e.text)||tt).length,i=n===0?e:j.createIdentifier(e.text+"_"+n);return FO(i)}function xk(){return!mq}function UT(){return mq=!1,tt}function FD(e,t,n,i,s){if(O7(t,n.checker,"then"))return Jkt(t,T1(t.arguments,0),T1(t.arguments,1),n,i,s);if(O7(t,n.checker,"catch"))return x9e(t,T1(t.arguments,0),n,i,s);if(O7(t,n.checker,"finally"))return Vkt(t,T1(t.arguments,0),n,i,s);if(Hn(t))return FD(e,t.expression,n,i,s);let o=n.checker.getTypeAtLocation(t);return o&&n.checker.getPromisedTypeOfPromise(o)?(I.assertNode(Hc(t).parent,Hn),qkt(e,t,n,i,s)):UT()}function Tne({checker:e},t){if(t.kind===106)return!0;if(ze(t)&&!yc(t)&&Nn(t)==="undefined"){let n=e.getSymbolAtLocation(t);return!n||e.isUndefinedSymbol(n)}return!1}function Ukt(e){let t=j.createUniqueName(e.identifier.text,16);return FO(t)}function b9e(e,t,n){let i;return n&&!M7(e,t)&&(R7(n)?(i=n,t.synthNamesMap.forEach((s,o)=>{if(s.identifier.text===n.identifier.text){let l=Ukt(n);t.synthNamesMap.set(o,l)}})):i=FO(j.createUniqueName("result",16),n.types),qSe(i)),i}function E9e(e,t,n,i,s){let o=[],l;if(i&&!M7(e,t)){l=Sc(qSe(i));let p=i.types,m=t.checker.getUnionType(p,2),S=t.isInJSFile?void 0:t.checker.typeToTypeNode(m,void 0,void 0),h=[j.createVariableDeclaration(l,void 0,S)],b=j.createVariableStatement(void 0,j.createVariableDeclarationList(h,1));o.push(b)}return o.push(n),s&&l&&Wkt(s)&&o.push(j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(Sc(D9e(s)),void 0,void 0,l)],2))),o}function Vkt(e,t,n,i,s){if(!t||Tne(n,t))return FD(e,e.expression.expression,n,i,s);let o=b9e(e,n,s),l=FD(e,e.expression.expression,n,!0,o);if(xk())return UT();let p=VSe(t,i,void 0,void 0,e,n);if(xk())return UT();let m=j.createBlock(l),S=j.createBlock(p),h=j.createTryStatement(m,void 0,S);return E9e(e,n,h,o,s)}function x9e(e,t,n,i,s){if(!t||Tne(n,t))return FD(e,e.expression.expression,n,i,s);let o=P9e(t,n),l=b9e(e,n,s),p=FD(e,e.expression.expression,n,!0,l);if(xk())return UT();let m=VSe(t,i,l,o,e,n);if(xk())return UT();let S=j.createBlock(p),h=j.createCatchClause(o&&Sc(dq(o)),j.createBlock(m)),b=j.createTryStatement(S,h,void 0);return E9e(e,n,b,l,s)}function Jkt(e,t,n,i,s,o){if(!t||Tne(i,t))return x9e(e,n,i,s,o);if(n&&!Tne(i,n))return UT();let l=P9e(t,i),p=FD(e.expression.expression,e.expression.expression,i,!0,l);if(xk())return UT();let m=VSe(t,s,o,l,e,i);return xk()?UT():ys(p,m)}function qkt(e,t,n,i,s){if(M7(e,n)){let o=Sc(t);return i&&(o=j.createAwaitExpression(o)),[j.createReturnStatement(o)]}return bne(s,j.createAwaitExpression(t),void 0)}function bne(e,t,n){return!e||N9e(e)?[j.createExpressionStatement(t)]:R7(e)&&e.hasBeenDeclared?[j.createExpressionStatement(j.createAssignment(Sc(JSe(e)),t))]:[j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(Sc(dq(e)),void 0,n,t)],2))]}function USe(e,t){if(t&&e){let n=j.createUniqueName("result",16);return[...bne(FO(n),e,t),j.createReturnStatement(n)]}return[j.createReturnStatement(e)]}function VSe(e,t,n,i,s,o){var l;switch(e.kind){case 106:break;case 211:case 80:if(!i)break;let p=j.createCallExpression(Sc(e),void 0,R7(i)?[JSe(i)]:[]);if(M7(s,o))return USe(p,Sne(s,e,o.checker));let m=o.checker.getTypeAtLocation(e),S=o.checker.getSignaturesOfType(m,0);if(!S.length)return UT();let h=S[0].getReturnType(),b=bne(n,j.createAwaitExpression(p),Sne(s,e,o.checker));return n&&n.types.push(o.checker.getAwaitedType(h)||h),b;case 218:case 219:{let A=e.body,k=(l=A9e(o.checker.getTypeAtLocation(e),o.checker))==null?void 0:l.getReturnType();if(ra(A)){let N=[],M=!1;for(let O of A.statements)if(Um(O))if(M=!0,qJ(O,o.checker))N=N.concat(k9e(o,O,t,n));else{let U=k&&O.expression?C9e(o.checker,k,O.expression):O.expression;N.push(...USe(U,Sne(s,e,o.checker)))}else{if(t&&$b(O,em))return UT();N.push(O)}return M7(s,o)?N.map(O=>Sc(O)):zkt(N,n,o,M)}else{let N=dre(A,o.checker)?k9e(o,j.createReturnStatement(A),t,n):tt;if(N.length>0)return N;if(k){let M=C9e(o.checker,k,A);if(M7(s,o))return USe(M,Sne(s,e,o.checker));{let O=bne(n,M,void 0);return n&&n.types.push(o.checker.getAwaitedType(k)||k),O}}else return UT()}}default:return UT()}return tt}function C9e(e,t,n){let i=Sc(n);return e.getPromisedTypeOfPromise(t)?j.createAwaitExpression(i):i}function A9e(e,t){let n=t.getSignaturesOfType(e,0);return Is(n)}function zkt(e,t,n,i){let s=[];for(let o of e)if(Um(o)){if(o.expression){let l=S9e(o.expression,n.checker)?j.createAwaitExpression(o.expression):o.expression;t===void 0?s.push(j.createExpressionStatement(l)):R7(t)&&t.hasBeenDeclared?s.push(j.createExpressionStatement(j.createAssignment(JSe(t),l))):s.push(j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(dq(t),void 0,void 0,l)],2)))}}else s.push(Sc(o));return!i&&t!==void 0&&s.push(j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(dq(t),void 0,void 0,j.createIdentifier("undefined"))],2))),s}function k9e(e,t,n,i){let s=[];return Qs(t,function o(l){if(da(l)){let p=FD(l,l,e,n,i);if(s=s.concat(p),s.length>0)return}else ca(l)||Qs(l,o)}),s}function P9e(e,t){let n=[],i;if(tc(e)){if(e.parameters.length>0){let m=e.parameters[0].name;i=s(m)}}else ze(e)?i=o(e):Hn(e)&&ze(e.name)&&(i=o(e.name));if(!i||"identifier"in i&&i.identifier.text==="undefined")return;return i;function s(m){if(ze(m))return o(m);let S=_a(m.elements,h=>Su(h)?[]:[s(h.name)]);return $kt(m,S)}function o(m){let S=p(m),h=l(S);return h&&t.synthNamesMap.get(Ia(h).toString())||FO(m,n)}function l(m){var S;return((S=ii(m,qg))==null?void 0:S.symbol)??t.checker.getSymbolAtLocation(m)}function p(m){return m.original?m.original:m}}function N9e(e){return e?R7(e)?!e.identifier.text:yr(e.elements,N9e):!0}function FO(e,t=[]){return{kind:0,identifier:e,types:t,hasBeenDeclared:!1,hasBeenReferenced:!1}}function $kt(e,t=tt,n=[]){return{kind:1,bindingPattern:e,elements:t,types:n}}function JSe(e){return e.hasBeenReferenced=!0,e.identifier}function dq(e){return R7(e)?qSe(e):D9e(e)}function D9e(e){for(let t of e.elements)dq(t);return e.bindingPattern}function qSe(e){return e.hasBeenDeclared=!0,e.identifier}function R7(e){return e.kind===0}function Wkt(e){return e.kind===1}function M7(e,t){return!!e.original&&t.setOfExpressionsToReturn.has(yo(e.original))}var Ene,zSe,mq,Gkt=f({"src/services/codefixes/convertToAsyncFunction.ts"(){"use strict";yi(),Ma(),Ene="convertToAsyncFunction",zSe=[g.This_may_be_converted_to_an_async_function.code],mq=!0,wa({errorCodes:zSe,getCodeActions(e){mq=!0;let t=En.ChangeTracker.with(e,n=>y9e(n,e.sourceFile,e.span.start,e.program.getTypeChecker()));return mq?[ma(Ene,t,g.Convert_to_async_function,Ene,g.Convert_all_to_async_functions)]:[]},fixIds:[Ene],getAllCodeActions:e=>Fo(e,zSe,(t,n)=>y9e(t,n.file,n.start,e.program.getTypeChecker()))})}});function Hkt(e,t,n,i,s){var o;for(let l of e.imports){let p=(o=n.getResolvedModuleFromModuleSpecifier(l))==null?void 0:o.resolvedModule;if(!p||p.resolvedFileName!==t.fileName)continue;let m=Gw(l);switch(m.kind){case 271:i.replaceNode(e,m,J1(m.name,void 0,l,s));break;case 213:_f(m,!1)&&i.replaceNode(e,m,j.createPropertyAccessExpression(Sc(m),"default"));break}}}function Ykt(e,t,n,i,s){let o={original:cPt(e),additional:new Set},l=Xkt(e,t,o);Kkt(e,l,n);let p=!1,m;for(let S of Fn(e.statements,Xc)){let h=w9e(e,S,n,t,o,i,s);h&&B9(h,m??(m=new Map))}for(let S of Fn(e.statements,h=>!Xc(h))){let h=Qkt(e,S,t,n,o,i,l,m,s);p=p||h}return m?.forEach((S,h)=>{n.replaceNode(e,h,S)}),p}function Xkt(e,t,n){let i=new Map;return I9e(e,s=>{let{text:o}=s.name;!i.has(o)&&(aX(s.name)||t.resolveName(o,s,111551,!0))&&i.set(o,xne(`_${o}`,n))}),i}function Kkt(e,t,n){I9e(e,(i,s)=>{if(s)return;let{text:o}=i.name;n.replaceNode(e,i,j.createIdentifier(t.get(o)||o))})}function I9e(e,t){e.forEachChild(function n(i){if(Hn(i)&&vE(e,i.expression)&&ze(i.name)){let{parent:s}=i;t(i,bn(s)&&s.left===i&&s.operatorToken.kind===64)}i.forEachChild(n)})}function Qkt(e,t,n,i,s,o,l,p,m){switch(t.kind){case 243:return w9e(e,t,i,n,s,o,m),!1;case 244:{let{expression:S}=t;switch(S.kind){case 213:return _f(S,!0)&&i.replaceNode(e,t,J1(void 0,void 0,S.arguments[0],m)),!1;case 226:{let{operatorToken:h}=S;return h.kind===64&&ePt(e,n,S,i,l,p)}}}default:return!1}}function w9e(e,t,n,i,s,o,l){let{declarationList:p}=t,m=!1,S=vr(p.declarations,h=>{let{name:b,initializer:A}=h;if(A){if(vE(e,A))return m=!0,jO([]);if(_f(A,!0))return m=!0,aPt(b,A.arguments[0],i,s,o,l);if(Hn(A)&&_f(A.expression,!0))return m=!0,Zkt(b,A.name.text,A.expression.arguments[0],s,l)}return jO([j.createVariableStatement(void 0,j.createVariableDeclarationList([h],p.flags))])});if(m){n.replaceNodeWithNodes(e,t,_a(S,b=>b.newImports));let h;return Te(S,b=>{b.useSitesToUnqualify&&B9(b.useSitesToUnqualify,h??(h=new Map))}),h}}function Zkt(e,t,n,i,s){switch(e.kind){case 206:case 207:{let o=xne(t,i);return jO([L9e(o,t,n,s),Cne(void 0,e,j.createIdentifier(o))])}case 80:return jO([L9e(e.text,t,n,s)]);default:return I.assertNever(e,`Convert to ES module got invalid syntax form ${e.kind}`)}}function ePt(e,t,n,i,s,o){let{left:l,right:p}=n;if(!Hn(l))return!1;if(vE(e,l))if(vE(e,p))i.delete(e,n.parent);else{let m=Ha(p)?tPt(p,o):_f(p,!0)?nPt(p.arguments[0],t):void 0;return m?(i.replaceNodeWithNodes(e,n.parent,m[0]),m[1]):(i.replaceRangeWithText(e,kd(l.getStart(e),p.pos),"export default"),!0)}else vE(e,l.expression)&&rPt(e,n,i,s);return!1}function tPt(e,t){let n=Jo(e.properties,i=>{switch(i.kind){case 177:case 178:case 304:case 305:return;case 303:return ze(i.name)?sPt(i.name.text,i.initializer,t):void 0;case 174:return ze(i.name)?M9e(i.name.text,[j.createToken(95)],i,t):void 0;default:I.assertNever(i,`Convert to ES6 got invalid prop kind ${i.kind}`)}});return n&&[n,!1]}function rPt(e,t,n,i){let{text:s}=t.left.name,o=i.get(s);if(o!==void 0){let l=[Cne(void 0,o,t.right),GSe([j.createExportSpecifier(!1,o,s)])];n.replaceNodeWithNodes(e,t.parent,l)}else iPt(t,e,n)}function nPt(e,t){let n=e.text,i=t.getSymbolAtLocation(e),s=i?i.exports:$5;return s.has("export=")?[[$Se(n)],!0]:s.has("default")?s.size>1?[[O9e(n),$Se(n)],!0]:[[$Se(n)],!0]:[[O9e(n)],!1]}function O9e(e){return GSe(void 0,e)}function $Se(e){return GSe([j.createExportSpecifier(!1,void 0,"default")],e)}function iPt({left:e,right:t,parent:n},i,s){let o=e.name.text;if((Xo(t)||rc(t)||wu(t))&&(!t.name||t.name.text===o)){s.replaceRange(i,{pos:e.getStart(i),end:t.getStart(i)},j.createToken(95),{suffix:" "}),t.name||s.insertName(i,t,o);let l=Oo(n,27,i);l&&s.delete(i,l)}else s.replaceNodeRangeWithNodes(i,e.expression,Oo(e,25,i),[j.createToken(95),j.createToken(87)],{joiner:" ",suffix:" "})}function sPt(e,t,n){let i=[j.createToken(95)];switch(t.kind){case 218:{let{name:o}=t;if(o&&o.text!==e)return s()}case 219:return M9e(e,i,t,n);case 231:return uPt(e,i,t,n);default:return s()}function s(){return Cne(i,j.createIdentifier(e),WSe(t,n))}}function WSe(e,t){if(!t||!Tt(In(t.keys()),i=>ud(e,i)))return e;return os(e)?Lte(e,!0,n):o7(e,!0,n);function n(i){if(i.kind===211){let s=t.get(i);return t.delete(i),s}}}function aPt(e,t,n,i,s,o){switch(e.kind){case 206:{let l=Jo(e.elements,p=>p.dotDotDotToken||p.initializer||p.propertyName&&!ze(p.propertyName)||!ze(p.name)?void 0:F9e(p.propertyName&&p.propertyName.text,p.name.text));if(l)return jO([J1(void 0,l,t,o)])}case 207:{let l=xne(aTe(t.text,s),i);return jO([J1(j.createIdentifier(l),void 0,t,o),Cne(void 0,Sc(e),j.createIdentifier(l))])}case 80:return oPt(e,t,n,i,o);default:return I.assertNever(e,`Convert to ES module got invalid name kind ${e.kind}`)}}function oPt(e,t,n,i,s){let o=n.getSymbolAtLocation(e),l=new Map,p=!1,m;for(let h of i.original.get(e.text)){if(n.getSymbolAtLocation(h)!==o||h===e)continue;let{parent:b}=h;if(Hn(b)){let{name:{text:A}}=b;if(A==="default"){p=!0;let k=h.getText();(m??(m=new Map)).set(b,j.createIdentifier(k))}else{I.assert(b.expression===h,"Didn't expect expression === use");let k=l.get(A);k===void 0&&(k=xne(A,i),l.set(A,k)),(m??(m=new Map)).set(b,j.createIdentifier(k))}}else p=!0}let S=l.size===0?void 0:In(g1(l.entries(),([h,b])=>j.createImportSpecifier(!1,h===b?void 0:j.createIdentifier(h),j.createIdentifier(b))));return S||(p=!0),jO([J1(p?Sc(e):void 0,S,t,s)],m)}function xne(e,t){for(;t.original.has(e)||t.additional.has(e);)e=`_${e}`;return t.additional.add(e),e}function cPt(e){let t=g_();return R9e(e,n=>t.add(n.text,n)),t}function R9e(e,t){ze(e)&&lPt(e)&&t(e),e.forEachChild(n=>R9e(n,t))}function lPt(e){let{parent:t}=e;switch(t.kind){case 211:return t.name!==e;case 208:return t.propertyName!==e;case 276:return t.propertyName!==e;default:return!0}}function M9e(e,t,n,i){return j.createFunctionDeclaration(ys(t,kE(n.modifiers)),Sc(n.asteriskToken),e,kE(n.typeParameters),kE(n.parameters),Sc(n.type),j.converters.convertToFunctionBlock(WSe(n.body,i)))}function uPt(e,t,n,i){return j.createClassDeclaration(ys(t,kE(n.modifiers)),e,kE(n.typeParameters),kE(n.heritageClauses),WSe(n.members,i))}function L9e(e,t,n,i){return t==="default"?J1(j.createIdentifier(e),void 0,n,i):J1(void 0,[F9e(t,e)],n,i)}function F9e(e,t){return j.createImportSpecifier(!1,e!==void 0&&e!==t?j.createIdentifier(e):void 0,j.createIdentifier(t))}function Cne(e,t,n){return j.createVariableStatement(e,j.createVariableDeclarationList([j.createVariableDeclaration(t,void 0,void 0,n)],2))}function GSe(e,t){return j.createExportDeclaration(void 0,!1,e&&j.createNamedExports(e),t===void 0?void 0:j.createStringLiteral(t))}function jO(e,t){return{newImports:e,useSitesToUnqualify:t}}var _Pt=f({"src/services/codefixes/convertToEsModule.ts"(){"use strict";yi(),Ma(),wa({errorCodes:[g.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module.code],getCodeActions(e){let{sourceFile:t,program:n,preferences:i}=e,s=En.ChangeTracker.with(e,o=>{if(Ykt(t,n.getTypeChecker(),o,ho(n.getCompilerOptions()),_d(t,i)))for(let p of n.getSourceFiles())Hkt(p,t,n,o,_d(p,i))});return[hg("convertToEsModule",s,g.Convert_to_ES_module)]}})}});function j9e(e,t){let n=Gr(Ts(e,t),pf);return I.assert(!!n,"Expected position to be owned by a qualified name."),ze(n.left)?n:void 0}function B9e(e,t,n){let i=n.right.text,s=j.createIndexedAccessTypeNode(j.createTypeReferenceNode(n.left,void 0),j.createLiteralTypeNode(j.createStringLiteral(i)));e.replaceNode(t,n,s)}var Ane,HSe,fPt=f({"src/services/codefixes/correctQualifiedNameToIndexedAccessType.ts"(){"use strict";yi(),Ma(),Ane="correctQualifiedNameToIndexedAccessType",HSe=[g.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1.code],wa({errorCodes:HSe,getCodeActions(e){let t=j9e(e.sourceFile,e.span.start);if(!t)return;let n=En.ChangeTracker.with(e,s=>B9e(s,e.sourceFile,t)),i=`${t.left.text}["${t.right.text}"]`;return[ma(Ane,n,[g.Rewrite_as_the_indexed_access_type_0,i],Ane,g.Rewrite_all_as_indexed_access_types)]},fixIds:[Ane],getAllCodeActions:e=>Fo(e,HSe,(t,n)=>{let i=j9e(n.file,n.start);i&&B9e(t,n.file,i)})})}});function U9e(e,t){return ii(Ts(t,e.start).parent,R_)}function V9e(e,t,n){if(!t)return;let i=t.parent,s=i.parent,o=pPt(t,n);if(o.length===i.elements.length)e.insertModifierBefore(n.sourceFile,156,i);else{let l=j.updateExportDeclaration(s,s.modifiers,!1,j.updateNamedExports(i,Fn(i.elements,m=>!hs(o,m))),s.moduleSpecifier,void 0),p=j.createExportDeclaration(void 0,!0,j.createNamedExports(o),s.moduleSpecifier,void 0);e.replaceNode(n.sourceFile,s,l,{leadingTriviaOption:En.LeadingTriviaOption.IncludeAll,trailingTriviaOption:En.TrailingTriviaOption.Exclude}),e.insertNodeAfter(n.sourceFile,s,p)}}function pPt(e,t){let n=e.parent;if(n.elements.length===1)return n.elements;let i=H1e(gf(n),t.program.getSemanticDiagnostics(t.sourceFile,t.cancellationToken));return Fn(n.elements,s=>{var o;return s===e||((o=G1e(s,i))==null?void 0:o.code)===kne[0]})}var kne,Pne,dPt=f({"src/services/codefixes/convertToTypeOnlyExport.ts"(){"use strict";yi(),Ma(),kne=[g.Re_exporting_a_type_when_0_is_enabled_requires_using_export_type.code],Pne="convertToTypeOnlyExport",wa({errorCodes:kne,getCodeActions:function(t){let n=En.ChangeTracker.with(t,i=>V9e(i,U9e(t.span,t.sourceFile),t));if(n.length)return[ma(Pne,n,g.Convert_to_type_only_export,Pne,g.Convert_all_re_exported_types_to_type_only_exports)]},fixIds:[Pne],getAllCodeActions:function(t){let n=new Map;return Fo(t,kne,(i,s)=>{let o=U9e(s,t.sourceFile);o&&Bm(n,yo(o.parent.parent))&&V9e(i,o,t)})}})}});function J9e(e,t){let{parent:n}=Ts(e,t);return Gf(n)||uu(n)&&n.importClause?n:void 0}function q9e(e,t,n){if(e.parent.parent.name)return!1;let i=e.parent.elements.filter(o=>!o.isTypeOnly);if(i.length===1)return!0;let s=n.getTypeChecker();for(let o of i)if(Ko.Core.eachSymbolReferenceInFile(o.name,s,t,p=>!ET(p)))return!1;return!0}function gq(e,t,n){var i;if(Gf(n))e.replaceNode(t,n,j.updateImportSpecifier(n,!0,n.propertyName,n.name));else{let s=n.importClause;if(s.name&&s.namedBindings)e.replaceNodeWithNodes(t,n,[j.createImportDeclaration(kE(n.modifiers,!0),j.createImportClause(!0,Sc(s.name,!0),void 0),Sc(n.moduleSpecifier,!0),Sc(n.attributes,!0)),j.createImportDeclaration(kE(n.modifiers,!0),j.createImportClause(!0,void 0,Sc(s.namedBindings,!0)),Sc(n.moduleSpecifier,!0),Sc(n.attributes,!0))]);else{let o=((i=s.namedBindings)==null?void 0:i.kind)===275?j.updateNamedImports(s.namedBindings,ul(s.namedBindings.elements,p=>j.updateImportSpecifier(p,!1,p.propertyName,p.name))):s.namedBindings,l=j.updateImportDeclaration(n,n.modifiers,j.updateImportClause(s,!0,s.name,o),n.moduleSpecifier,n.attributes);e.replaceNode(t,n,l)}}}var YSe,hq,mPt=f({"src/services/codefixes/convertToTypeOnlyImport.ts"(){"use strict";yi(),Ma(),YSe=[g.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error.code,g._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled.code,g._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled.code],hq="convertToTypeOnlyImport",wa({errorCodes:YSe,getCodeActions:function(t){var n;let i=J9e(t.sourceFile,t.span.start);if(i){let s=En.ChangeTracker.with(t,p=>gq(p,t.sourceFile,i)),o=i.kind===276&&q9e(i,t.sourceFile,t.program)?En.ChangeTracker.with(t,p=>gq(p,t.sourceFile,i.parent.parent.parent)):void 0,l=ma(hq,s,i.kind===276?[g.Use_type_0,((n=i.propertyName)==null?void 0:n.text)??i.name.text]:g.Use_import_type,hq,g.Fix_all_with_type_only_imports);return Tt(o)?[hg(hq,o,g.Use_import_type),l]:[l]}},fixIds:[hq],getAllCodeActions:function(t){let n=new Set;return Fo(t,YSe,(i,s)=>{let o=J9e(s.file,s.start);o?.kind===272&&!n.has(o)?(gq(i,s.file,o),n.add(o)):o?.kind===276&&!n.has(o.parent.parent.parent)&&q9e(o,s.file,t.program)?(gq(i,s.file,o.parent.parent.parent),n.add(o.parent.parent.parent)):o?.kind===276&&gq(i,s.file,o)})}})}});function z9e(e,t,n,i,s=!1){if(!gx(t))return;let o=hPt(t);if(!o)return;let l=t.parent,{leftSibling:p,rightSibling:m}=gPt(t),S=l.getStart(),h="";!p&&l.comment&&(S=$9e(l,l.getStart(),t.getStart()),h=`${i} */${i}`),p&&(s&&gx(p)?(S=t.getStart(),h=""):(S=$9e(l,p.getStart(),t.getStart()),h=`${i} */${i}`));let b=l.getEnd(),A="";m&&(s&&gx(m)?(b=m.getStart(),A=`${i}${i}`):(b=m.getStart(),A=`${i}/**${i} * `)),e.replaceRange(n,{pos:S,end:b},o,{prefix:h,suffix:A})}function gPt(e){let t=e.parent,n=t.getChildCount()-1,i=t.getChildren().findIndex(l=>l.getStart()===e.getStart()&&l.getEnd()===e.getEnd()),s=i>0?t.getChildAt(i-1):void 0,o=i<n?t.getChildAt(i+1):void 0;return{leftSibling:s,rightSibling:o}}function $9e(e,t,n){let i=e.getText().substring(t-e.getStart(),n-e.getStart());for(let s=i.length;s>0;s--)if(!/[*/\s]/g.test(i.substring(s-1,s)))return t+s;return n}function hPt(e){var t;let{typeExpression:n}=e;if(!n)return;let i=(t=e.name)==null?void 0:t.getText();if(i){if(n.kind===329)return yPt(i,n);if(n.kind===316)return vPt(i,n)}}function yPt(e,t){let n=W9e(t);if(Tt(n))return j.createInterfaceDeclaration(void 0,e,void 0,void 0,n)}function vPt(e,t){let n=Sc(t.type);if(n)return j.createTypeAliasDeclaration(void 0,j.createIdentifier(e),void 0,n)}function W9e(e){let t=e.jsDocPropertyTags;return Tt(t)?Wi(t,i=>{var s;let o=SPt(i),l=(s=i.typeExpression)==null?void 0:s.type,p=i.isBracketed,m;if(l&&mx(l)){let S=W9e(l);m=j.createTypeLiteralNode(S)}else l&&(m=Sc(l));if(m&&o){let S=p?j.createToken(58):void 0;return j.createPropertySignature(void 0,o,S,m)}}):void 0}function SPt(e){return e.name.kind===80?e.name.text:e.name.right.text}function TPt(e){return jp(e)?_a(e.jsDoc,t=>{var n;return(n=t.tags)==null?void 0:n.filter(i=>gx(i))}):[]}var Nne,XSe,bPt=f({"src/services/codefixes/convertTypedefToType.ts"(){"use strict";yi(),Ma(),Nne="convertTypedefToType",XSe=[g.JSDoc_typedef_may_be_converted_to_TypeScript_type.code],wa({fixIds:[Nne],errorCodes:XSe,getCodeActions(e){let t=q1(e.host,e.formatContext.options),n=Ts(e.sourceFile,e.span.start);if(!n)return;let i=En.ChangeTracker.with(e,s=>z9e(s,n,e.sourceFile,t));if(i.length>0)return[ma(Nne,i,g.Convert_typedef_to_TypeScript_type,Nne,g.Convert_all_typedef_to_TypeScript_types)]},getAllCodeActions:e=>Fo(e,XSe,(t,n)=>{let i=q1(e.host,e.formatContext.options),s=Ts(n.file,n.start);s&&z9e(t,s,n.file,i,!0)})})}});function G9e(e,t){let n=Ts(e,t);if(ze(n)){let i=ta(n.parent.parent,fp),s=n.getText(e);return{container:ta(i.parent,dp),typeNode:i.type,constraint:s,name:s==="K"?"P":"K"}}}function H9e(e,t,{container:n,typeNode:i,constraint:s,name:o}){e.replaceNode(t,n,j.createMappedTypeNode(void 0,j.createTypeParameterDeclaration(void 0,o,j.createTypeReferenceNode(s)),void 0,void 0,i,void 0))}var Dne,KSe,EPt=f({"src/services/codefixes/convertLiteralTypeToMappedType.ts"(){"use strict";yi(),Ma(),Dne="convertLiteralTypeToMappedType",KSe=[g._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0.code],wa({errorCodes:KSe,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=G9e(n,i.start);if(!s)return;let{name:o,constraint:l}=s,p=En.ChangeTracker.with(t,m=>H9e(m,n,s));return[ma(Dne,p,[g.Convert_0_to_1_in_0,l,o],Dne,g.Convert_all_type_literals_to_mapped_type)]},fixIds:[Dne],getAllCodeActions:e=>Fo(e,KSe,(t,n)=>{let i=G9e(n.file,n.start);i&&H9e(t,n.file,i)})})}});function Y9e(e,t){return I.checkDefined(Vu(Ts(e,t)),"There should be a containing class")}function X9e(e){return!e.valueDeclaration||!(X_(e.valueDeclaration)&2)}function K9e(e,t,n,i,s,o){let l=e.program.getTypeChecker(),p=xPt(i,l),m=l.getTypeAtLocation(t),h=l.getPropertiesOfType(m).filter(V5(X9e,O=>!p.has(O.escapedName))),b=l.getTypeAtLocation(i),A=mr(i.members,O=>Yc(O));b.getNumberIndexType()||N(m,1),b.getStringIndexType()||N(m,0);let k=Ck(n,e.program,o,e.host);sbe(i,h,n,e,o,k,O=>M(n,i,O)),k.writeFixes(s);function N(O,U){let H=l.getIndexInfoOfType(O,U);H&&M(n,i,l.indexInfoToIndexSignatureDeclaration(H,i,void 0,jD(e)))}function M(O,U,H){A?s.insertNodeAfter(O,A,H):s.insertMemberAtStart(O,U,H)}}function xPt(e,t){let n=$g(e);if(!n)return ga();let i=t.getTypeAtLocation(n),s=t.getPropertiesOfType(i);return ga(s.filter(X9e))}var QSe,Ine,CPt=f({"src/services/codefixes/fixClassIncorrectlyImplementsInterface.ts"(){"use strict";yi(),Ma(),QSe=[g.Class_0_incorrectly_implements_interface_1.code,g.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code],Ine="fixClassIncorrectlyImplementsInterface",wa({errorCodes:QSe,getCodeActions(e){let{sourceFile:t,span:n}=e,i=Y9e(t,n.start);return Wi(SN(i),s=>{let o=En.ChangeTracker.with(e,l=>K9e(e,s,t,i,l,e.preferences));return o.length===0?void 0:ma(Ine,o,[g.Implement_interface_0,s.getText(t)],Ine,g.Implement_all_unimplemented_interfaces)})},fixIds:[Ine],getAllCodeActions(e){let t=new Map;return Fo(e,QSe,(n,i)=>{let s=Y9e(i.file,i.start);if(Bm(t,yo(s)))for(let o of SN(s))K9e(e,o,i.file,s,n,e.preferences)})}})}});function Ck(e,t,n,i,s){return Q9e(e,t,!1,n,i,s)}function Q9e(e,t,n,i,s,o){let l=t.getCompilerOptions(),p=[],m=[],S=new Map,h=new Map;return{addImportFromDiagnostic:b,addImportFromExportedSymbol:A,writeFixes:N,hasFixes:M};function b(O,U){let H=ije(U,O.code,O.start,n);!H||!H.length||k(di(H))}function A(O,U){let H=I.checkDefined(O.parent),K=wJ(O,ho(l)),re=t.getTypeChecker(),$=re.getMergedSymbol(r_(O,re)),pe=tje(e,$,K,H,!1,t,s,i,o),z=One(e,t),se=Z9e(e,I.checkDefined(pe),t,void 0,!!U,z,s,i);se&&k({fix:se,symbolName:K,errorIdentifierText:void 0})}function k(O){var U,H;let{fix:K,symbolName:re}=O;switch(K.kind){case 0:p.push(K);break;case 1:m.push(K);break;case 2:{let{importClauseOrBindingPattern:se,importKind:Se,addAsTypeOnly:xe}=K,Z=String(yo(se)),Q=S.get(Z);if(Q||S.set(Z,Q={importClauseOrBindingPattern:se,defaultImport:void 0,namedImports:new Map}),Se===0){let ce=Q?.namedImports.get(re);Q.namedImports.set(re,$(ce,xe))}else I.assert(Q.defaultImport===void 0||Q.defaultImport.name===re,"(Add to Existing) Default import should be missing or match symbolName"),Q.defaultImport={name:re,addAsTypeOnly:$((U=Q.defaultImport)==null?void 0:U.addAsTypeOnly,xe)};break}case 3:{let{moduleSpecifier:se,importKind:Se,useRequire:xe,addAsTypeOnly:Z}=K,Q=pe(se,Se,xe,Z);switch(I.assert(Q.useRequire===xe,"(Add new) Tried to add an `import` and a `require` for the same module"),Se){case 1:I.assert(Q.defaultImport===void 0||Q.defaultImport.name===re,"(Add new) Default import should be missing or match symbolName"),Q.defaultImport={name:re,addAsTypeOnly:$((H=Q.defaultImport)==null?void 0:H.addAsTypeOnly,Z)};break;case 0:let ce=(Q.namedImports||(Q.namedImports=new Map)).get(re);Q.namedImports.set(re,$(ce,Z));break;case 3:case 2:I.assert(Q.namespaceLikeImport===void 0||Q.namespaceLikeImport.name===re,"Namespacelike import shoudl be missing or match symbolName"),Q.namespaceLikeImport={importKind:Se,name:re,addAsTypeOnly:Z};break}break}case 4:break;default:I.assertNever(K,`fix wasn't never - got kind ${K.kind}`)}function $(se,Se){return Math.max(se??0,Se)}function pe(se,Se,xe,Z){let Q=z(se,!0),ce=z(se,!1),ye=h.get(Q),we=h.get(ce),ve={defaultImport:void 0,namedImports:void 0,namespaceLikeImport:void 0,useRequire:xe};return Se===1&&Z===2?ye||(h.set(Q,ve),ve):Z===1&&(ye||we)?ye||we:we||(h.set(ce,ve),ve)}function z(se,Se){return`${Se?1:0}|${se}`}}function N(O,U){let H;e.imports.length===0&&U!==void 0?H=U:H=_d(e,i);for(let re of p)nTe(O,e,re);for(let re of m)_je(O,e,re,H);S.forEach(({importClauseOrBindingPattern:re,defaultImport:$,namedImports:pe})=>{uje(O,e,re,$,In(pe.entries(),([z,se])=>({addAsTypeOnly:se,name:z})),i)});let K;h.forEach(({useRequire:re,defaultImport:$,namedImports:pe,namespaceLikeImport:z},se)=>{let Se=se.slice(2),Z=(re?dje:pje)(Se,H,$,pe&&In(pe.entries(),([Q,ce])=>({addAsTypeOnly:ce,name:Q})),z,l,i);K=Cv(K,Z)}),K&&AO(O,e,K,!0,i)}function M(){return p.length>0||m.length>0||S.size>0||h.size>0}}function APt(e,t,n,i){let s=OO(e,i,n),o=rje(t.getTypeChecker(),e,t.getCompilerOptions());return{getModuleSpecifierForBestExportInfo:l};function l(p,m,S,h){let{fixes:b,computedWithoutCacheCount:A}=wne(p,m,S,!1,t,e,n,i,o,h),k=sje(b,e,t,s,n);return k&&{...k,computedWithoutCacheCount:A}}}function kPt(e,t,n,i,s,o,l,p,m,S,h,b){let A;n?(A=d7(i,l,p,h,b).get(i.path,n),I.assertIsDefined(A,"Some exportInfo should match the specified exportMapKey")):(A=VH(cm(t.name))?[NPt(e,s,t,p,l)]:tje(i,e,s,t,o,p,l,h,b),I.assertIsDefined(A,"Some exportInfo should match the specified symbol / moduleSymbol"));let k=One(i,p),N=ET(Ts(i,S)),M=I.checkDefined(Z9e(i,A,p,S,N,k,l,h));return{moduleSpecifier:M.moduleSpecifier,codeAction:eje(rTe({host:l,formatContext:m,preferences:h},i,s,M,!1,p,h))}}function PPt(e,t,n,i,s,o){let l=n.getCompilerOptions(),p=jg(tTe(e,n.getTypeChecker(),t,l)),m=cje(e,t,p,n),S=p!==t.text;return m&&eje(rTe({host:i,formatContext:s,preferences:o},e,p,m,S,n,o))}function Z9e(e,t,n,i,s,o,l,p){let m=OO(e,p,l);return sje(wne(t,i,s,o,n,e,l,p).fixes,e,n,m,l)}function eje({description:e,changes:t,commands:n}){return{description:e,changes:t,commands:n}}function tje(e,t,n,i,s,o,l,p,m){let S=nje(o,l);return d7(e,l,o,p,m).search(e.path,s,h=>h===n,h=>{if(r_(h[0].symbol,S(h[0].isFromPackageJson))===t&&h.some(b=>b.moduleSymbol===i||b.symbol.parent===i))return h})}function NPt(e,t,n,i,s){var o,l;let p=i.getCompilerOptions(),m=h(i.getTypeChecker(),!1);if(m)return m;let S=(l=(o=s.getPackageJsonAutoImportProvider)==null?void 0:o.call(s))==null?void 0:l.getTypeChecker();return I.checkDefined(S&&h(S,!0),"Could not find symbol in specified module for code actions");function h(b,A){let k=BJ(n,b,p);if(k&&r_(k.symbol,b)===e)return{symbol:k.symbol,moduleSymbol:n,moduleFileName:void 0,exportKind:k.exportKind,targetFlags:r_(e,b).flags,isFromPackageJson:A};let N=b.tryGetMemberInModuleExportsAndProperties(t,n);if(N&&r_(N,b)===e)return{symbol:N,moduleSymbol:n,moduleFileName:void 0,exportKind:0,targetFlags:r_(e,b).flags,isFromPackageJson:A}}}function wne(e,t,n,i,s,o,l,p,m=rje(s.getTypeChecker(),o,s.getCompilerOptions()),S){let h=s.getTypeChecker(),b=_a(e,m.getImportsForExportInfo),A=t!==void 0&&DPt(b,t),k=wPt(b,n,h,s.getCompilerOptions());if(k)return{computedWithoutCacheCount:0,fixes:[...A?[A]:tt,k]};let{fixes:N,computedWithoutCacheCount:M=0}=RPt(e,b,s,o,t,n,i,l,p,S);return{computedWithoutCacheCount:M,fixes:[...A?[A]:tt,...N]}}function DPt(e,t){return Ct(e,({declaration:n,importKind:i})=>{var s;if(i!==0)return;let o=IPt(n),l=o&&((s=dN(n))==null?void 0:s.text);if(l)return{kind:0,namespacePrefix:o,usagePosition:t,moduleSpecifier:l}})}function IPt(e){var t,n,i;switch(e.kind){case 260:return(t=ii(e.name,ze))==null?void 0:t.text;case 271:return e.name.text;case 272:return(i=ii((n=e.importClause)==null?void 0:n.namedBindings,tS))==null?void 0:i.name.text;default:return I.assertNever(e)}}function ZSe(e,t,n,i,s,o){return e?t&&o.importsNotUsedAsValues===2||FX(o)&&(!(i&111551)||s.getTypeOnlyAliasDeclaration(n))?2:1:4}function wPt(e,t,n,i){let s;for(let l of e){let p=o(l);if(!p)continue;let m=t8(p.importClauseOrBindingPattern);if(p.addAsTypeOnly!==4&&m||p.addAsTypeOnly===4&&!m)return p;s??(s=p)}return s;function o({declaration:l,importKind:p,symbol:m,targetFlags:S}){if(p===3||p===2||l.kind===271)return;if(l.kind===260)return(p===0||p===1)&&l.name.kind===206?{kind:2,importClauseOrBindingPattern:l.name,importKind:p,moduleSpecifier:l.initializer.arguments[0].text,addAsTypeOnly:4}:void 0;let{importClause:h}=l;if(!h||!bo(l.moduleSpecifier))return;let{name:b,namedBindings:A}=h;if(h.isTypeOnly&&!(p===0&&A))return;let k=ZSe(t,!1,m,S,n,i);if(!(p===1&&(b||k===2&&A))&&!(p===0&&A?.kind===274))return{kind:2,importClauseOrBindingPattern:h,importKind:p,moduleSpecifier:l.moduleSpecifier.text,addAsTypeOnly:k}}}function rje(e,t,n){let i;for(let s of t.imports){let o=Gw(s);if(fj(o.parent)){let l=e.resolveExternalModuleName(s);l&&(i||(i=g_())).add(Ia(l),o.parent)}else if(o.kind===272||o.kind===271){let l=e.getSymbolAtLocation(s);l&&(i||(i=g_())).add(Ia(l),o)}}return{getImportsForExportInfo:({moduleSymbol:s,exportKind:o,targetFlags:l,symbol:p})=>{if(!(l&111551)&&Y_(t))return tt;let m=i?.get(Ia(s));if(!m)return tt;let S=eTe(t,o,n);return m.map(h=>({declaration:h,importKind:S,symbol:p,targetFlags:l}))}}}function One(e,t){if(!Y_(e))return!1;if(e.commonJsModuleIndicator&&!e.externalModuleIndicator)return!0;if(e.externalModuleIndicator&&!e.commonJsModuleIndicator)return!1;let n=t.getCompilerOptions();if(n.configFile)return T_(n)<5;if(e.impliedNodeFormat===1)return!0;if(e.impliedNodeFormat===99)return!1;for(let i of t.getSourceFiles())if(!(i===e||!Y_(i)||t.isSourceFileFromExternalLibrary(i))){if(i.commonJsModuleIndicator&&!i.externalModuleIndicator)return!0;if(i.externalModuleIndicator&&!i.commonJsModuleIndicator)return!1}return!0}function nje(e,t){return Nm(n=>n?t.getPackageJsonAutoImportProvider().getTypeChecker():e.getTypeChecker())}function OPt(e,t,n,i,s,o,l,p,m){let S=Y_(t),h=e.getCompilerOptions(),b=kx(e,l),A=nje(e,l),k=Q_(h),N=dJ(k),M=m?H=>({moduleSpecifiers:SE.tryGetModuleSpecifiersFromCache(H,t,b,p),computedWithoutCache:!1}):(H,K)=>SE.getModuleSpecifiersWithCacheInfo(H,K,h,t,b,p,void 0,!0),O=0,U=_a(o,(H,K)=>{let re=A(H.isFromPackageJson),{computedWithoutCache:$,moduleSpecifiers:pe}=M(H.moduleSymbol,re),z=!!(H.targetFlags&111551),se=ZSe(i,!0,H.symbol,H.targetFlags,re,h);return O+=$?1:0,Wi(pe,Se=>{var xe;if(N&&OT(Se))return;if(!z&&S&&n!==void 0)return{kind:1,moduleSpecifier:Se,usagePosition:n,exportInfo:H,isReExport:K>0};let Z=eTe(t,H.exportKind,h),Q;if(n!==void 0&&Z===3&&H.exportKind===0){let ce=re.resolveExternalModuleSymbol(H.moduleSymbol),ye;ce!==H.moduleSymbol&&(ye=(xe=UJ(ce,re,h))==null?void 0:xe.name),ye||(ye=sTe(H.moduleSymbol,ho(h),!1)),Q={namespacePrefix:ye,usagePosition:n}}return{kind:3,moduleSpecifier:Se,importKind:Z,useRequire:s,addAsTypeOnly:se,exportInfo:H,isReExport:K>0,qualification:Q}})});return{computedWithoutCacheCount:O,fixes:U}}function RPt(e,t,n,i,s,o,l,p,m,S){let h=Ct(t,b=>MPt(b,o,l,n.getTypeChecker(),n.getCompilerOptions()));return h?{fixes:[h]}:OPt(n,i,s,o,l,e,p,m,S)}function MPt({declaration:e,importKind:t,symbol:n,targetFlags:i},s,o,l,p){var m;let S=(m=dN(e))==null?void 0:m.text;if(S){let h=o?4:ZSe(s,!0,n,i,l,p);return{kind:3,moduleSpecifier:S,importKind:t,addAsTypeOnly:h,useRequire:o}}}function ije(e,t,n,i){let s=Ts(e.sourceFile,n),o;if(t===g._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code)o=BPt(e,s);else if(ze(s))if(t===g._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code){let p=jg(tTe(e.sourceFile,e.program.getTypeChecker(),s,e.program.getCompilerOptions())),m=cje(e.sourceFile,s,p,e.program);return m&&[{fix:m,symbolName:p,errorIdentifierText:s.text}]}else o=JPt(e,s,i);else return;let l=OO(e.sourceFile,e.preferences,e.host);return o&&LPt(o,e.sourceFile,e.program,l,e.host)}function LPt(e,t,n,i,s){let o=l=>gc(l,s.getCurrentDirectory(),N1(s));return Fa(e,(l,p)=>hy(!!l.isJsxNamespaceFix,!!p.isJsxNamespaceFix)||To(l.fix.kind,p.fix.kind)||aje(l.fix,p.fix,t,n,i.allowsImportingSpecifier,o))}function sje(e,t,n,i,s){if(Tt(e))return e[0].kind===0||e[0].kind===2?e[0]:e.reduce((o,l)=>aje(l,o,t,n,i.allowsImportingSpecifier,p=>gc(p,s.getCurrentDirectory(),N1(s)))===-1?l:o)}function aje(e,t,n,i,s,o){return e.kind!==0&&t.kind!==0?hy(s(t.moduleSpecifier),s(e.moduleSpecifier))||jPt(e.moduleSpecifier,t.moduleSpecifier,n,i)||hy(oje(e,n,i.getCompilerOptions(),o),oje(t,n,i.getCompilerOptions(),o))||cR(e.moduleSpecifier,t.moduleSpecifier):0}function oje(e,t,n,i){var s;if(e.isReExport&&((s=e.exportInfo)!=null&&s.moduleFileName)&&FPt(e.exportInfo.moduleFileName)){let o=i(hi(e.exportInfo.moduleFileName));return Ss(t.path,o)}return!1}function FPt(e){return Cl(e,[".js",".jsx",".d.ts",".ts",".tsx"],!0)==="index"}function jPt(e,t,n,i){return Ss(e,"node:")&&!Ss(t,"node:")?RJ(n,i)?-1:1:Ss(t,"node:")&&!Ss(e,"node:")?RJ(n,i)?1:-1:0}function BPt({sourceFile:e,program:t,host:n,preferences:i},s){let o=t.getTypeChecker(),l=UPt(s,o);if(!l)return;let p=o.getAliasedSymbol(l),m=l.name,S=[{symbol:l,moduleSymbol:p,moduleFileName:void 0,exportKind:3,targetFlags:p.flags,isFromPackageJson:!1}],h=One(e,t);return wne(S,void 0,!1,h,t,e,n,i).fixes.map(A=>{var k;return{fix:A,symbolName:m,errorIdentifierText:(k=ii(s,ze))==null?void 0:k.text}})}function UPt(e,t){let n=ze(e)?t.getSymbolAtLocation(e):void 0;if(Uj(n))return n;let{parent:i}=e;if(H_(i)&&i.tagName===e||nk(i)){let s=t.resolveName(t.getJsxNamespace(i),H_(i)?e:i,111551,!1);if(Uj(s))return s}}function eTe(e,t,n,i){if(n.verbatimModuleSyntax&&(T_(n)===1||e.impliedNodeFormat===1))return 3;switch(t){case 0:return 0;case 1:return 1;case 2:return $Pt(e,n,!!i);case 3:return VPt(e,n,!!i);default:return I.assertNever(t)}}function VPt(e,t,n){if(ix(t))return 1;let i=T_(t);switch(i){case 2:case 1:case 3:return gn(e)&&(Pl(e)||n)?2:3;case 4:case 5:case 6:case 7:case 99:case 0:case 200:return 2;case 100:case 199:return e.impliedNodeFormat===99?2:3;default:return I.assertNever(i,`Unexpected moduleKind ${i}`)}}function JPt({sourceFile:e,program:t,cancellationToken:n,host:i,preferences:s},o,l){let p=t.getTypeChecker(),m=t.getCompilerOptions();return _a(tTe(e,p,o,m),S=>{if(S==="default")return;let h=ET(o),b=One(e,t),A=zPt(S,_N(o),Cx(o),n,e,t,l,i,s);return In(A2(A.values(),k=>wne(k,o.getStart(e),h,b,t,e,i,s).fixes),k=>({fix:k,symbolName:S,errorIdentifierText:o.text,isJsxNamespaceFix:S!==o.text}))})}function cje(e,t,n,i){let s=i.getTypeChecker(),o=s.resolveName(n,t,111551,!0);if(!o)return;let l=s.getTypeOnlyAliasDeclaration(o);if(!(!l||Xr(l)!==e))return{kind:4,typeOnlyAliasDeclaration:l}}function tTe(e,t,n,i){let s=n.parent;if((H_(s)||fE(s))&&s.tagName===n&&Hte(i.jsx)){let o=t.getJsxNamespace(e);if(qPt(o,n,t))return!xN(n.text)&&!t.resolveName(n.text,n,111551,!1)?[n.text,o]:[o]}return[n.text]}function qPt(e,t,n){if(xN(t.text))return!0;let i=n.resolveName(e,t,111551,!0);return!i||Tt(i.declarations,dT)&&!(i.flags&111551)}function zPt(e,t,n,i,s,o,l,p,m){var S;let h=g_(),b=OO(s,m,p),A=(S=p.getModuleSpecifierCache)==null?void 0:S.call(p),k=Nm(M=>kx(M?p.getPackageJsonAutoImportProvider():o,p));function N(M,O,U,H,K,re){let $=k(re);if(O&&tre(K,s,O,m,b,$,A)||!O&&b.allowsImportingAmbientModule(M,$)){let pe=K.getTypeChecker();h.add(j1e(U,pe).toString(),{symbol:U,moduleSymbol:M,moduleFileName:O?.fileName,exportKind:H,targetFlags:r_(U,pe).flags,isFromPackageJson:re})}}return rre(o,p,m,l,(M,O,U,H)=>{let K=U.getTypeChecker();i.throwIfCancellationRequested();let re=U.getCompilerOptions(),$=BJ(M,K,re);$&&($.name===e||sTe(M,ho(re),t)===e)&&gje($.resolvedSymbol,n)&&N(M,O,$.symbol,$.exportKind,U,H);let pe=K.tryGetMemberInModuleExportsAndProperties(e,M);pe&&gje(pe,n)&&N(M,O,pe,0,U,H)}),h}function $Pt(e,t,n){let i=ix(t),s=gn(e);if(!s&&T_(t)>=5)return i?1:2;if(s)return Pl(e)||n?i?1:2:3;for(let o of e.statements)if(Ru(o)&&!sl(o.moduleReference))return 3;return i?1:3}function rTe(e,t,n,i,s,o,l){let p,m=En.ChangeTracker.with(e,S=>{p=WPt(S,t,n,i,s,o,l)});return ma(oTe,m,p,cTe,g.Add_all_missing_imports)}function WPt(e,t,n,i,s,o,l){let p=_d(t,l);switch(i.kind){case 0:return nTe(e,t,i),[g.Change_0_to_1,n,`${i.namespacePrefix}.${n}`];case 1:return _je(e,t,i,p),[g.Change_0_to_1,n,fje(i.moduleSpecifier,p)+n];case 2:{let{importClauseOrBindingPattern:m,importKind:S,addAsTypeOnly:h,moduleSpecifier:b}=i;uje(e,t,m,S===1?{name:n,addAsTypeOnly:h}:void 0,S===0?[{name:n,addAsTypeOnly:h}]:tt,l);let A=cm(b);return s?[g.Import_0_from_1,n,A]:[g.Update_import_from_0,A]}case 3:{let{importKind:m,moduleSpecifier:S,addAsTypeOnly:h,useRequire:b,qualification:A}=i,k=b?dje:pje,N=m===1?{name:n,addAsTypeOnly:h}:void 0,M=m===0?[{name:n,addAsTypeOnly:h}]:void 0,O=m===2||m===3?{importKind:m,name:A?.namespacePrefix||n,addAsTypeOnly:h}:void 0;return AO(e,t,k(S,p,N,M,O,o.getCompilerOptions(),l),!0,l),A&&nTe(e,t,A),s?[g.Import_0_from_1,n,S]:[g.Add_import_from_0,S]}case 4:{let{typeOnlyAliasDeclaration:m}=i,S=GPt(e,m,o,t,l);return S.kind===276?[g.Remove_type_from_import_of_0_from_1,n,lje(S.parent.parent)]:[g.Remove_type_from_import_declaration_from_0,lje(S)]}default:return I.assertNever(i,`Unexpected fix kind ${i.kind}`)}}function lje(e){var t,n;return e.kind===271?((n=ii((t=ii(e.moduleReference,zh))==null?void 0:t.expression,bo))==null?void 0:n.text)||e.moduleReference.getText():ta(e.parent.moduleSpecifier,za).text}function GPt(e,t,n,i,s){let o=n.getCompilerOptions(),l=FX(o);switch(t.kind){case 276:if(t.isTypeOnly){let m=$m.detectImportSpecifierSorting(t.parent.elements,s);if(t.parent.elements.length>1&&m){let S=j.updateImportSpecifier(t,!1,t.propertyName,t.name),h=$m.getOrganizeImportsComparer(s,m===2),b=$m.getImportSpecifierInsertionIndex(t.parent.elements,S,h,s);if(b!==t.parent.elements.indexOf(t))return e.delete(i,t),e.insertImportSpecifierAtIndex(i,S,t.parent,b),t}return e.deleteRange(i,{pos:mT(t.getFirstToken()),end:mT(t.propertyName??t.name)}),t}else return I.assert(t.parent.parent.isTypeOnly),p(t.parent.parent),t.parent.parent;case 273:return p(t),t;case 274:return p(t.parent),t.parent;case 271:return e.deleteRange(i,t.getChildAt(1)),t;default:I.failBadSyntaxKind(t)}function p(m){var S;if(e.delete(i,Cte(m,i)),!o.allowImportingTsExtensions){let h=dN(m.parent),b=h&&((S=n.getResolvedModuleFromModuleSpecifier(h))==null?void 0:S.resolvedModule);if(b?.resolvedUsingTsExtension){let A=F3(h.text,fV(h.text,o));e.replaceNode(i,h,j.createStringLiteral(A))}}if(l){let h=ii(m.namedBindings,Dy);if(h&&h.elements.length>1){$m.detectImportSpecifierSorting(h.elements,s)&&t.kind===276&&h.elements.indexOf(t)!==0&&(e.delete(i,t),e.insertImportSpecifierAtIndex(i,t,h,0));for(let b of h.elements)b!==t&&!b.isTypeOnly&&e.insertModifierBefore(i,156,b)}}}}function uje(e,t,n,i,s,o){var l;if(n.kind===206){i&&S(n,i.name,"default");for(let h of s)S(n,h.name,void 0);return}let p=n.isTypeOnly&&Tt([i,...s],h=>h?.addAsTypeOnly===4),m=n.namedBindings&&((l=ii(n.namedBindings,Dy))==null?void 0:l.elements);if(i&&(I.assert(!n.name,"Cannot add a default import to an import clause that already has one"),e.insertNodeAt(t,n.getStart(t),j.createIdentifier(i.name),{suffix:", "})),s.length){let h;if(typeof o.organizeImportsIgnoreCase=="boolean")h=o.organizeImportsIgnoreCase;else if(m){let N=$m.detectImportSpecifierSorting(m,o);N!==3&&(h=N===2)}h===void 0&&(h=$m.detectSorting(t,o)===2);let b=$m.getOrganizeImportsComparer(o,h),A=cu(s.map(N=>j.createImportSpecifier((!n.isTypeOnly||p)&&Rne(N,o),void 0,j.createIdentifier(N.name))),(N,M)=>$m.compareImportOrExportSpecifiers(N,M,b)),k=m?.length&&$m.detectImportSpecifierSorting(m,o);if(k&&!(h&&k===1))for(let N of A){let M=p&&!N.isTypeOnly?0:$m.getImportSpecifierInsertionIndex(m,N,b,o);e.insertImportSpecifierAtIndex(t,N,n.namedBindings,M)}else if(m?.length)for(let N of A)e.insertNodeInListAfter(t,Rs(m),N,m);else if(A.length){let N=j.createNamedImports(A);n.namedBindings?e.replaceNode(t,n.namedBindings,N):e.insertNodeAfter(t,I.checkDefined(n.name,"Import clause must have either named imports or a default import"),N)}}if(p&&(e.delete(t,Cte(n,t)),m))for(let h of m)e.insertModifierBefore(t,156,h);function S(h,b,A){let k=j.createBindingElement(void 0,A,b);h.elements.length?e.insertNodeInListAfter(t,Rs(h.elements),k):e.replaceNode(t,h,j.createObjectBindingPattern([k]))}}function nTe(e,t,{namespacePrefix:n,usagePosition:i}){e.insertText(t,i,n+".")}function _je(e,t,{moduleSpecifier:n,usagePosition:i},s){e.insertText(t,i,fje(n,s))}function fje(e,t){let n=xte(t);return`import(${n}${e}${n}).`}function iTe({addAsTypeOnly:e}){return e===2}function Rne(e,t){return iTe(e)||!!t.preferTypeOnlyAutoImports&&e.addAsTypeOnly!==4}function pje(e,t,n,i,s,o,l){let p=vk(e,t),m;if(n!==void 0||i?.length){let S=(!n||iTe(n))&&yr(i,iTe)||(o.verbatimModuleSyntax||l.preferTypeOnlyAutoImports)&&n?.addAsTypeOnly!==4&&!Tt(i,h=>h.addAsTypeOnly===4);m=Cv(m,J1(n&&j.createIdentifier(n.name),i?.map(h=>j.createImportSpecifier(!S&&Rne(h,l),void 0,j.createIdentifier(h.name))),e,t,S))}if(s){let S=s.importKind===3?j.createImportEqualsDeclaration(void 0,Rne(s,l),j.createIdentifier(s.name),j.createExternalModuleReference(p)):j.createImportDeclaration(void 0,j.createImportClause(Rne(s,l),void 0,j.createNamespaceImport(j.createIdentifier(s.name))),p,void 0);m=Cv(m,S)}return I.checkDefined(m)}function dje(e,t,n,i,s){let o=vk(e,t),l;if(n||i?.length){let p=i?.map(({name:S})=>j.createBindingElement(void 0,void 0,S))||[];n&&p.unshift(j.createBindingElement(void 0,"default",n.name));let m=mje(j.createObjectBindingPattern(p),o);l=Cv(l,m)}if(s){let p=mje(s.name,o);l=Cv(l,p)}return I.checkDefined(l)}function mje(e,t){return j.createVariableStatement(void 0,j.createVariableDeclarationList([j.createVariableDeclaration(typeof e=="string"?j.createIdentifier(e):e,void 0,void 0,j.createCallExpression(j.createIdentifier("require"),void 0,[t]))],2))}function gje({declarations:e},t){return Tt(e,n=>!!(zM(n)&t))}function sTe(e,t,n){return aTe(ff(cm(e.name)),t,n)}function aTe(e,t,n){let i=Cl(cA(e,"/index")),s="",o=!0,l=i.charCodeAt(0);b0(l,t)?(s+=String.fromCharCode(l),n&&(s=s.toUpperCase())):o=!1;for(let p=1;p<i.length;p++){let m=i.charCodeAt(p),S=oT(m,t);if(S){let h=String.fromCharCode(m);o||(h=h.toUpperCase()),s+=h}o=S}return PA(s)?`_${s}`:s||"_"}var oTe,cTe,lTe,HPt=f({"src/services/codefixes/importFixes.ts"(){"use strict";yi(),Ma(),oTe="import",cTe="fixMissingImport",lTe=[g.Cannot_find_name_0.code,g.Cannot_find_name_0_Did_you_mean_1.code,g.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,g.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,g.Cannot_find_namespace_0.code,g._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code,g._0_only_refers_to_a_type_but_is_being_used_as_a_value_here.code,g.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code,g._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code,g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery.code,g.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later.code,g.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom.code,g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig.code,g.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function.code,g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig.code,g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha.code,g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode.code,g.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig.code,g.Cannot_find_namespace_0_Did_you_mean_1.code],wa({errorCodes:lTe,getCodeActions(e){let{errorCode:t,preferences:n,sourceFile:i,span:s,program:o}=e,l=ije(e,t,s.start,!0);if(l)return l.map(({fix:p,symbolName:m,errorIdentifierText:S})=>rTe(e,i,m,p,m!==S,o,n))},fixIds:[cTe],getAllCodeActions:e=>{let{sourceFile:t,program:n,preferences:i,host:s,cancellationToken:o}=e,l=Q9e(t,n,!0,i,s,o);return LD(e,lTe,p=>l.addImportFromDiagnostic(p,e)),MD(En.ChangeTracker.with(e,l.writeFixes))}})}});function hje(e,t,n){let i=mr(e.getSemanticDiagnostics(t),l=>l.start===n.start&&l.length===n.length);if(i===void 0||i.relatedInformation===void 0)return;let s=mr(i.relatedInformation,l=>l.code===g.This_type_parameter_might_need_an_extends_0_constraint.code);if(s===void 0||s.file===void 0||s.start===void 0||s.length===void 0)return;let o=fbe(s.file,e_(s.start,s.length));if(o!==void 0&&(ze(o)&&Nc(o.parent)&&(o=o.parent),Nc(o))){if(qN(o.parent))return;let l=Ts(t,n.start),p=e.getTypeChecker();return{constraint:XPt(p,l)||YPt(s.messageText),declaration:o,token:l}}}function yje(e,t,n,i,s,o){let{declaration:l,constraint:p}=o,m=t.getTypeChecker();if(vs(p))e.insertText(s,l.name.end,` extends ${p}`);else{let S=ho(t.getCompilerOptions()),h=jD({program:t,host:i}),b=Ck(s,t,n,i),A=yie(m,b,p,void 0,S,void 0,h);A&&(e.replaceNode(s,l,j.updateTypeParameterDeclaration(l,void 0,l.name,A,l.default)),b.writeFixes(e))}}function YPt(e){let[,t]=nh(e,`
`,0).match(/`extends (.*)`/)||[];return t}function XPt(e,t){return es(t.parent)?e.getTypeArgumentConstraint(t.parent):(bt(t)?e.getContextualType(t):void 0)||e.getTypeAtLocation(t)}var Mne,uTe,KPt=f({"src/services/codefixes/fixAddMissingConstraint.ts"(){"use strict";yi(),Ma(),Mne="addMissingConstraint",uTe=[g.Type_0_is_not_comparable_to_type_1.code,g.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code,g.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code,g.Type_0_is_not_assignable_to_type_1.code,g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code,g.Property_0_is_incompatible_with_index_signature.code,g.Property_0_in_type_1_is_not_assignable_to_type_2.code,g.Type_0_does_not_satisfy_the_constraint_1.code],wa({errorCodes:uTe,getCodeActions(e){let{sourceFile:t,span:n,program:i,preferences:s,host:o}=e,l=hje(i,t,n);if(l===void 0)return;let p=En.ChangeTracker.with(e,m=>yje(m,i,s,o,t,l));return[ma(Mne,p,g.Add_extends_constraint,Mne,g.Add_extends_constraint_to_all_type_parameters)]},fixIds:[Mne],getAllCodeActions:e=>{let{program:t,preferences:n,host:i}=e,s=new Map;return MD(En.ChangeTracker.with(e,o=>{LD(e,uTe,l=>{let p=hje(t,l.file,e_(l.start,l.length));if(p&&Bm(s,yo(p.declaration)))return yje(o,t,n,i,l.file,p)})}))}})}});function vje(e,t,n,i){switch(n){case g.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code:case g.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:case g.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code:case g.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code:case g.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:return QPt(e,t.sourceFile,i);case g.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code:case g.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code:case g.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code:case g.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code:return ZPt(e,t.sourceFile,i);default:I.fail("Unexpected error code: "+n)}}function QPt(e,t,n){let i=Tje(t,n);if(Y_(t)){e.addJSDocTags(t,i,[j.createJSDocOverrideTag(j.createIdentifier("override"))]);return}let s=i.modifiers||tt,o=mr(s,GA),l=mr(s,Sge),p=mr(s,b=>dte(b.kind)),m=Da(s,n_),S=l?l.end:o?o.end:p?p.end:m?Wa(t.text,m.end):i.getStart(t),h=p||o||l?{prefix:" "}:{suffix:" "};e.insertModifierAt(t,S,164,h)}function ZPt(e,t,n){let i=Tje(t,n);if(Y_(t)){e.filterJSDocTags(t,i,J5(uU));return}let s=mr(i.modifiers,Tge);I.assertIsDefined(s),e.deleteModifier(t,s)}function Sje(e){switch(e.kind){case 176:case 172:case 174:case 177:case 178:return!0;case 169:return op(e,e.parent);default:return!1}}function Tje(e,t){let n=Ts(e,t),i=Gr(n,s=>Ti(s)?"quit":Sje(s));return I.assert(i&&Sje(i)),i}var _Te,BO,L7,fTe,pTe,eNt=f({"src/services/codefixes/fixOverrideModifier.ts"(){"use strict";yi(),Ma(),_Te="fixOverrideModifier",BO="fixAddOverrideModifier",L7="fixRemoveOverrideModifier",fTe=[g.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code,g.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code,g.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code,g.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code,g.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code,g.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code,g.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code,g.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code,g.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code],pTe={[g.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code]:{descriptions:g.Add_override_modifier,fixId:BO,fixAllDescriptions:g.Add_all_missing_override_modifiers},[g.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code]:{descriptions:g.Add_override_modifier,fixId:BO,fixAllDescriptions:g.Add_all_missing_override_modifiers},[g.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code]:{descriptions:g.Remove_override_modifier,fixId:L7,fixAllDescriptions:g.Remove_all_unnecessary_override_modifiers},[g.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code]:{descriptions:g.Remove_override_modifier,fixId:L7,fixAllDescriptions:g.Remove_override_modifier},[g.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code]:{descriptions:g.Add_override_modifier,fixId:BO,fixAllDescriptions:g.Add_all_missing_override_modifiers},[g.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code]:{descriptions:g.Add_override_modifier,fixId:BO,fixAllDescriptions:g.Add_all_missing_override_modifiers},[g.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code]:{descriptions:g.Add_override_modifier,fixId:BO,fixAllDescriptions:g.Remove_all_unnecessary_override_modifiers},[g.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code]:{descriptions:g.Remove_override_modifier,fixId:L7,fixAllDescriptions:g.Remove_all_unnecessary_override_modifiers},[g.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code]:{descriptions:g.Remove_override_modifier,fixId:L7,fixAllDescriptions:g.Remove_all_unnecessary_override_modifiers}},wa({errorCodes:fTe,getCodeActions:function(t){let{errorCode:n,span:i}=t,s=pTe[n];if(!s)return tt;let{descriptions:o,fixId:l,fixAllDescriptions:p}=s,m=En.ChangeTracker.with(t,S=>vje(S,t,n,i.start));return[CSe(_Te,m,o,l,p)]},fixIds:[_Te,BO,L7],getAllCodeActions:e=>Fo(e,fTe,(t,n)=>{let{code:i,start:s}=n,o=pTe[i];!o||o.fixId!==e.fixId||vje(t,e,i,s)})})}});function bje(e,t,n,i){let s=_d(t,i),o=j.createStringLiteral(n.name.text,s===0);e.replaceNode(t,n,C9(n)?j.createElementAccessChain(n.expression,n.questionDotToken,o):j.createElementAccessExpression(n.expression,o))}function Eje(e,t){return ta(Ts(e,t).parent,Hn)}var Lne,dTe,tNt=f({"src/services/codefixes/fixNoPropertyAccessFromIndexSignature.ts"(){"use strict";yi(),Ma(),Lne="fixNoPropertyAccessFromIndexSignature",dTe=[g.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0.code],wa({errorCodes:dTe,fixIds:[Lne],getCodeActions(e){let{sourceFile:t,span:n,preferences:i}=e,s=Eje(t,n.start),o=En.ChangeTracker.with(e,l=>bje(l,e.sourceFile,s,i));return[ma(Lne,o,[g.Use_element_access_for_0,s.name.text],Lne,g.Use_element_access_for_all_undeclared_properties)]},getAllCodeActions:e=>Fo(e,dTe,(t,n)=>bje(t,n.file,Eje(n.file,n.start),e.preferences))})}});function xje(e,t,n,i){let s=Ts(t,n);if(!TD(s))return;let o=kf(s,!1,!1);if(!(!Zl(o)&&!Xo(o))&&!ls(kf(o,!1,!1))){let l=I.checkDefined(Oo(o,100,t)),{name:p}=o,m=I.checkDefined(o.body);return Xo(o)?p&&Ko.Core.isSymbolReferencedInFile(p,i,t,m)?void 0:(e.delete(t,l),p&&e.delete(t,p),e.insertText(t,m.pos," =>"),[g.Convert_function_expression_0_to_arrow_function,p?p.text:jJ]):(e.replaceNode(t,l,j.createToken(87)),e.insertText(t,p.end," = "),e.insertText(t,m.pos," =>"),[g.Convert_function_declaration_0_to_arrow_function,p.text])}}var Fne,mTe,rNt=f({"src/services/codefixes/fixImplicitThis.ts"(){"use strict";yi(),Ma(),Fne="fixImplicitThis",mTe=[g.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code],wa({errorCodes:mTe,getCodeActions:function(t){let{sourceFile:n,program:i,span:s}=t,o,l=En.ChangeTracker.with(t,p=>{o=xje(p,n,s.start,i.getTypeChecker())});return o?[ma(Fne,l,o,Fne,g.Fix_all_implicit_this_errors)]:tt},fixIds:[Fne],getAllCodeActions:e=>Fo(e,mTe,(t,n)=>{xje(t,n.file,n.start,e.program.getTypeChecker())})})}});function Cje(e,t,n){var i,s;let o=Ts(e,t);if(ze(o)){let l=Gr(o,uu);if(l===void 0)return;let p=za(l.moduleSpecifier)?l.moduleSpecifier:void 0;if(p===void 0)return;let m=(i=n.getResolvedModuleFromModuleSpecifier(p))==null?void 0:i.resolvedModule;if(m===void 0)return;let S=n.getSourceFile(m.resolvedFileName);if(S===void 0||PD(n,S))return;let h=S.symbol,b=(s=ii(h.valueDeclaration,Oh))==null?void 0:s.locals;if(b===void 0)return;let A=b.get(o.escapedText);if(A===void 0)return;let k=iNt(A);return k===void 0?void 0:{exportName:{node:o,isTypeOnly:LN(k)},node:k,moduleSourceFile:S,moduleSpecifier:p.text}}}function nNt(e,t,{exportName:n,node:i,moduleSourceFile:s}){let o=jne(s,n.isTypeOnly);o?Aje(e,t,s,o,[n]):_R(i)?e.insertExportModifier(s,i):kje(e,t,s,[n])}function gTe(e,t,n,i,s){de(i)&&(s?Aje(e,t,n,s,i):kje(e,t,n,i))}function jne(e,t){let n=i=>yl(i)&&(t&&i.isTypeOnly||!i.isTypeOnly);return Da(e.statements,n)}function Aje(e,t,n,i,s){let o=i.exportClause&&wd(i.exportClause)?i.exportClause.elements:j.createNodeArray([]),l=!i.isTypeOnly&&!!(fm(t.getCompilerOptions())||mr(o,p=>p.isTypeOnly));e.replaceNode(n,i,j.updateExportDeclaration(i,i.modifiers,i.isTypeOnly,j.createNamedExports(j.createNodeArray([...o,...Pje(s,l)],o.hasTrailingComma)),i.moduleSpecifier,i.attributes))}function kje(e,t,n,i){e.insertNodeAtEndOfScope(n,n,j.createExportDeclaration(void 0,!1,j.createNamedExports(Pje(i,fm(t.getCompilerOptions()))),void 0,void 0))}function Pje(e,t){return j.createNodeArray(vr(e,n=>j.createExportSpecifier(t&&n.isTypeOnly,void 0,n.node)))}function iNt(e){if(e.valueDeclaration===void 0)return qi(e.declarations);let t=e.valueDeclaration,n=Gi(t)?ii(t.parent.parent,Xc):void 0;return n&&de(n.declarationList.declarations)===1?n:t}var Bne,hTe,sNt=f({"src/services/codefixes/fixImportNonExportedMember.ts"(){"use strict";yi(),Ma(),Bne="fixImportNonExportedMember",hTe=[g.Module_0_declares_1_locally_but_it_is_not_exported.code],wa({errorCodes:hTe,fixIds:[Bne],getCodeActions(e){let{sourceFile:t,span:n,program:i}=e,s=Cje(t,n.start,i);if(s===void 0)return;let o=En.ChangeTracker.with(e,l=>nNt(l,i,s));return[ma(Bne,o,[g.Export_0_from_module_1,s.exportName.node.text,s.moduleSpecifier],Bne,g.Export_all_referenced_locals)]},getAllCodeActions(e){let{program:t}=e;return MD(En.ChangeTracker.with(e,n=>{let i=new Map;LD(e,hTe,s=>{let o=Cje(s.file,s.start,t);if(o===void 0)return;let{exportName:l,node:p,moduleSourceFile:m}=o;if(jne(m,l.isTypeOnly)===void 0&&_R(p))n.insertExportModifier(m,p);else{let S=i.get(m)||{typeOnlyExports:[],exports:[]};l.isTypeOnly?S.typeOnlyExports.push(l):S.exports.push(l),i.set(m,S)}}),i.forEach((s,o)=>{let l=jne(o,!0);l&&l.isTypeOnly?(gTe(n,t,o,s.typeOnlyExports,l),gTe(n,t,o,s.exports,jne(o,!1))):gTe(n,t,o,[...s.exports,...s.typeOnlyExports],l)})}))}})}});function aNt(e,t){let n=Ts(e,t);return Gr(n,i=>i.kind===202)}function oNt(e,t,n){if(!n)return;let i=n.type,s=!1,o=!1;for(;i.kind===190||i.kind===191||i.kind===196;)i.kind===190?s=!0:i.kind===191&&(o=!0),i=i.type;let l=j.updateNamedTupleMember(n,n.dotDotDotToken||(o?j.createToken(26):void 0),n.name,n.questionToken||(s?j.createToken(58):void 0),i);l!==n&&e.replaceNode(t,n,l)}var Une,Nje,cNt=f({"src/services/codefixes/fixIncorrectNamedTupleSyntax.ts"(){"use strict";yi(),Ma(),Une="fixIncorrectNamedTupleSyntax",Nje=[g.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type.code,g.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type.code],wa({errorCodes:Nje,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=aNt(n,i.start),o=En.ChangeTracker.with(t,l=>oNt(l,n,s));return[ma(Une,o,g.Move_labeled_tuple_element_modifiers_to_labels,Une,g.Move_labeled_tuple_element_modifiers_to_labels)]},fixIds:[Une]})}});function Dje(e,t,n,i){let s=Ts(e,t),o=s.parent;if((i===g.No_overload_matches_this_call.code||i===g.Type_0_is_not_assignable_to_type_1.code)&&!th(o))return;let l=n.program.getTypeChecker(),p;if(Hn(o)&&o.name===s){I.assert(E0(s),"Expected an identifier for spelling (property access)");let m=l.getTypeAtLocation(o.expression);o.flags&64&&(m=l.getNonNullableType(m)),p=l.getSuggestedSymbolForNonexistentProperty(s,m)}else if(bn(o)&&o.operatorToken.kind===103&&o.left===s&&is(s)){let m=l.getTypeAtLocation(o.right);p=l.getSuggestedSymbolForNonexistentProperty(s,m)}else if(pf(o)&&o.right===s){let m=l.getSymbolAtLocation(o.left);m&&m.flags&1536&&(p=l.getSuggestedSymbolForNonexistentModule(o.right,m))}else if(Gf(o)&&o.name===s){I.assertNode(s,ze,"Expected an identifier for spelling (import)");let m=Gr(s,uu),S=uNt(n,m);S&&S.symbol&&(p=l.getSuggestedSymbolForNonexistentModule(s,S.symbol))}else if(th(o)&&o.name===s){I.assertNode(s,ze,"Expected an identifier for JSX attribute");let m=Gr(s,H_),S=l.getContextualTypeForArgumentAtIndex(m,0);p=l.getSuggestedSymbolForNonexistentJSXAttribute(s,S)}else if(wj(o)&&Du(o)&&o.name===s){let m=Gr(s,Ti),S=m?$g(m):void 0,h=S?l.getTypeAtLocation(S):void 0;h&&(p=l.getSuggestedSymbolForNonexistentClassMember(Fl(s),h))}else{let m=Cx(s),S=Fl(s);I.assert(S!==void 0,"name should be defined"),p=l.getSuggestedSymbolForNonexistentSymbol(s,S,lNt(m))}return p===void 0?void 0:{node:s,suggestedSymbol:p}}function Ije(e,t,n,i,s){let o=Lc(i);if(!nd(o,s)&&Hn(n.parent)){let l=i.valueDeclaration;l&&W_(l)&&is(l.name)?e.replaceNode(t,n,j.createIdentifier(o)):e.replaceNode(t,n.parent,j.createElementAccessExpression(n.parent.expression,j.createStringLiteral(o)))}else e.replaceNode(t,n,j.createIdentifier(o))}function lNt(e){let t=0;return e&4&&(t|=1920),e&2&&(t|=788968),e&1&&(t|=111551),t}function uNt(e,t){var n;if(!t||!bo(t.moduleSpecifier))return;let i=(n=e.program.getResolvedModuleFromModuleSpecifier(t.moduleSpecifier))==null?void 0:n.resolvedModule;if(i)return e.program.getSourceFile(i.resolvedFileName)}var yTe,vTe,_Nt=f({"src/services/codefixes/fixSpelling.ts"(){"use strict";yi(),Ma(),yTe="fixSpelling",vTe=[g.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,g.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code,g.Cannot_find_name_0_Did_you_mean_1.code,g.Could_not_find_name_0_Did_you_mean_1.code,g.Cannot_find_namespace_0_Did_you_mean_1.code,g.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,g.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,g._0_has_no_exported_member_named_1_Did_you_mean_2.code,g.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code,g.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code,g.No_overload_matches_this_call.code,g.Type_0_is_not_assignable_to_type_1.code],wa({errorCodes:vTe,getCodeActions(e){let{sourceFile:t,errorCode:n}=e,i=Dje(t,e.span.start,e,n);if(!i)return;let{node:s,suggestedSymbol:o}=i,l=ho(e.host.getCompilationSettings()),p=En.ChangeTracker.with(e,m=>Ije(m,t,s,o,l));return[ma("spelling",p,[g.Change_spelling_to_0,Lc(o)],yTe,g.Fix_all_detected_spelling_errors)]},fixIds:[yTe],getAllCodeActions:e=>Fo(e,vTe,(t,n)=>{let i=Dje(n.file,n.start,e,n.code),s=ho(e.host.getCompilationSettings());i&&Ije(t,e.sourceFile,i.node,i.suggestedSymbol,s)})})}});function wje(e,t,n){let i=e.createSymbol(4,t.escapedText);i.links.type=e.getTypeAtLocation(n);let s=ga([i]);return e.createAnonymousType(void 0,s,[],[],[])}function STe(e,t,n,i){if(!t.body||!ra(t.body)||de(t.body.statements)!==1)return;let s=di(t.body.statements);if(Ou(s)&&TTe(e,t,e.getTypeAtLocation(s.expression),n,i))return{declaration:t,kind:0,expression:s.expression,statement:s,commentSource:s.expression};if(_E(s)&&Ou(s.statement)){let o=j.createObjectLiteralExpression([j.createPropertyAssignment(s.label,s.statement.expression)]),l=wje(e,s.label,s.statement.expression);if(TTe(e,t,l,n,i))return rc(t)?{declaration:t,kind:1,expression:o,statement:s,commentSource:s.statement.expression}:{declaration:t,kind:0,expression:o,statement:s,commentSource:s.statement.expression}}else if(ra(s)&&de(s.statements)===1){let o=di(s.statements);if(_E(o)&&Ou(o.statement)){let l=j.createObjectLiteralExpression([j.createPropertyAssignment(o.label,o.statement.expression)]),p=wje(e,o.label,o.statement.expression);if(TTe(e,t,p,n,i))return{declaration:t,kind:0,expression:l,statement:s,commentSource:o}}}}function TTe(e,t,n,i,s){if(s){let o=e.getSignatureFromDeclaration(t);if(o){ui(t,1024)&&(n=e.createPromiseType(n));let l=e.createSignature(t,o.typeParameters,o.thisParameter,o.parameters,n,void 0,o.minArgumentCount,o.flags);n=e.createAnonymousType(void 0,ga(),[l],[],[])}else n=e.getAnyType()}return e.isTypeAssignableTo(n,i)}function Oje(e,t,n,i){let s=Ts(t,n);if(!s.parent)return;let o=Gr(s.parent,tc);switch(i){case g.A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value.code:return!o||!o.body||!o.type||!ud(o.type,s)?void 0:STe(e,o,e.getTypeFromTypeNode(o.type),!1);case g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code:if(!o||!da(o.parent)||!o.body)return;let l=o.parent.arguments.indexOf(o);if(l===-1)return;let p=e.getContextualTypeForArgumentAtIndex(o.parent,l);return p?STe(e,o,p,!0):void 0;case g.Type_0_is_not_assignable_to_type_1.code:if(!Cy(s)||!cN(s.parent)&&!th(s.parent))return;let m=fNt(s.parent);return!m||!tc(m)||!m.body?void 0:STe(e,m,e.getTypeAtLocation(s.parent),!0)}}function fNt(e){switch(e.kind){case 260:case 169:case 208:case 172:case 303:return e.initializer;case 291:return e.initializer&&(J6(e.initializer)?e.initializer.expression:void 0);case 304:case 171:case 306:case 355:case 348:return}}function Rje(e,t,n,i){hp(n);let s=u7(t);e.replaceNode(t,i,j.createReturnStatement(n),{leadingTriviaOption:En.LeadingTriviaOption.Exclude,trailingTriviaOption:En.TrailingTriviaOption.Exclude,suffix:s?";":void 0})}function Mje(e,t,n,i,s,o){let l=o||bJ(i)?j.createParenthesizedExpression(i):i;hp(s),Px(s,l),e.replaceNode(t,n.body,l)}function Lje(e,t,n,i){e.replaceNode(t,n.body,j.createParenthesizedExpression(i))}function pNt(e,t,n){let i=En.ChangeTracker.with(e,s=>Rje(s,e.sourceFile,t,n));return ma(Vne,i,g.Add_a_return_statement,Jne,g.Add_all_missing_return_statement)}function dNt(e,t,n,i){let s=En.ChangeTracker.with(e,o=>Mje(o,e.sourceFile,t,n,i,!1));return ma(Vne,s,g.Remove_braces_from_arrow_function_body,qne,g.Remove_braces_from_all_arrow_function_bodies_with_relevant_issues)}function mNt(e,t,n){let i=En.ChangeTracker.with(e,s=>Lje(s,e.sourceFile,t,n));return ma(Vne,i,g.Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal,zne,g.Wrap_all_object_literal_with_parentheses)}var Vne,Jne,qne,zne,bTe,gNt=f({"src/services/codefixes/returnValueCorrect.ts"(){"use strict";yi(),Ma(),Vne="returnValueCorrect",Jne="fixAddReturnStatement",qne="fixRemoveBracesFromArrowFunctionBody",zne="fixWrapTheBlockWithParen",bTe=[g.A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value.code,g.Type_0_is_not_assignable_to_type_1.code,g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code],wa({errorCodes:bTe,fixIds:[Jne,qne,zne],getCodeActions:function(t){let{program:n,sourceFile:i,span:{start:s},errorCode:o}=t,l=Oje(n.getTypeChecker(),i,s,o);if(l)return l.kind===0?Pr([pNt(t,l.expression,l.statement)],rc(l.declaration)?dNt(t,l.declaration,l.expression,l.commentSource):void 0):[mNt(t,l.declaration,l.expression)]},getAllCodeActions:e=>Fo(e,bTe,(t,n)=>{let i=Oje(e.program.getTypeChecker(),n.file,n.start,n.code);if(i)switch(e.fixId){case Jne:Rje(t,n.file,i.expression,i.statement);break;case qne:if(!rc(i.declaration))return;Mje(t,n.file,i.declaration,i.expression,i.commentSource,!1);break;case zne:if(!rc(i.declaration))return;Lje(t,n.file,i.declaration,i.expression);break;default:I.fail(JSON.stringify(e.fixId))}})})}});function Fje(e,t,n,i,s){var o;let l=Ts(e,t),p=l.parent;if(n===g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code){if(!(l.kind===19&&Ha(p)&&da(p.parent)))return;let k=oa(p.parent.arguments,U=>U===p);if(k<0)return;let N=i.getResolvedSignature(p.parent);if(!(N&&N.declaration&&N.parameters[k]))return;let M=N.parameters[k].valueDeclaration;if(!(M&&Ls(M)&&ze(M.name)))return;let O=In(i.getUnmatchedProperties(i.getTypeAtLocation(p),i.getParameterType(N,k),!1,!1));return de(O)?{kind:3,token:M.name,identifier:M.name.text,properties:O,parentDeclaration:p}:void 0}if(l.kind===19&&Ha(p)){let k=i.getContextualType(p)||i.getTypeAtLocation(p),N=In(i.getUnmatchedProperties(i.getTypeAtLocation(p),k,!1,!1));return de(N)?{kind:3,token:p,identifier:"",properties:N,parentDeclaration:p}:void 0}if(!E0(l))return;if(ze(l)&&jv(p)&&p.initializer&&Ha(p.initializer)){let k=i.getContextualType(l)||i.getTypeAtLocation(l),N=In(i.getUnmatchedProperties(i.getTypeAtLocation(p.initializer),k,!1,!1));return de(N)?{kind:3,token:l,identifier:l.text,properties:N,parentDeclaration:p.initializer}:void 0}if(ze(l)&&H_(l.parent)){let k=ho(s.getCompilerOptions()),N=ENt(i,k,l.parent);return de(N)?{kind:4,token:l,attributes:N,parentDeclaration:l.parent}:void 0}if(ze(l)){let k=(o=i.getContextualType(l))==null?void 0:o.getNonNullableType();if(k&&Gn(k)&16){let N=qi(i.getSignaturesOfType(k,0));return N===void 0?void 0:{kind:5,token:l,signature:N,sourceFile:e,parentDeclaration:Hje(l)}}if(da(p)&&p.expression===l)return{kind:2,token:l,call:p,sourceFile:e,modifierFlags:0,parentDeclaration:Hje(l)}}if(!Hn(p))return;let m=Ste(i.getTypeAtLocation(p.expression)),S=m.symbol;if(!S||!S.declarations)return;if(ze(l)&&da(p.parent)){let k=mr(S.declarations,hl),N=k?.getSourceFile();if(k&&N&&!PD(s,N))return{kind:2,token:l,call:p.parent,sourceFile:e,modifierFlags:32,parentDeclaration:k};let M=mr(S.declarations,ls);if(e.commonJsModuleIndicator)return;if(M&&!PD(s,M))return{kind:2,token:l,call:p.parent,sourceFile:M,modifierFlags:32,parentDeclaration:M}}let h=mr(S.declarations,Ti);if(!h&&is(l))return;let b=h||mr(S.declarations,k=>ef(k)||dp(k));if(b&&!PD(s,b.getSourceFile())){let k=!dp(b)&&(m.target||m)!==i.getDeclaredTypeOfSymbol(S);if(k&&(is(l)||ef(b)))return;let N=b.getSourceFile(),M=dp(b)?0:(k?256:0)|(Gte(l.text)?2:0),O=Y_(N),U=ii(p.parent,da);return{kind:0,token:l,call:U,modifierFlags:M,parentDeclaration:b,declSourceFile:N,isJSFile:O}}let A=mr(S.declarations,AT);if(A&&!(m.flags&1056)&&!is(l)&&!PD(s,A.getSourceFile()))return{kind:1,token:l,parentDeclaration:A}}function hNt(e,t){return t.isJSFile?_A(yNt(e,t)):vNt(e,t)}function yNt(e,{parentDeclaration:t,declSourceFile:n,modifierFlags:i,token:s}){if(ef(t)||dp(t))return;let o=En.ChangeTracker.with(e,p=>jje(p,n,t,s,!!(i&256)));if(o.length===0)return;let l=i&256?g.Initialize_static_property_0:is(s)?g.Declare_a_private_field_named_0:g.Initialize_property_0_in_the_constructor;return ma(cS,o,[l,s.text],cS,g.Add_all_missing_members)}function jje(e,t,n,i,s){let o=i.text;if(s){if(n.kind===231)return;let l=n.name.getText(),p=Bje(j.createIdentifier(l),o);e.insertNodeAfter(t,n,p)}else if(is(i)){let l=j.createPropertyDeclaration(void 0,o,void 0,void 0,void 0),p=Jje(n);p?e.insertNodeAfter(t,p,l):e.insertMemberAtStart(t,n,l)}else{let l=I0(n);if(!l)return;let p=Bje(j.createThis(),o);e.insertNodeAtConstructorEnd(t,l,p)}}function Bje(e,t){return j.createExpressionStatement(j.createAssignment(j.createPropertyAccessExpression(e,t),Ak()))}function vNt(e,{parentDeclaration:t,declSourceFile:n,modifierFlags:i,token:s}){let o=s.text,l=i&256,p=Uje(e.program.getTypeChecker(),t,s),m=h=>En.ChangeTracker.with(e,b=>Vje(b,n,t,o,p,h)),S=[ma(cS,m(i&256),[l?g.Declare_static_property_0:g.Declare_property_0,o],cS,g.Add_all_missing_members)];return l||is(s)||(i&2&&S.unshift(hg(cS,m(2),[g.Declare_private_property_0,o])),S.push(SNt(e,n,t,s.text,p))),S}function Uje(e,t,n){let i;if(n.parent.parent.kind===226){let s=n.parent.parent,o=n.parent===s.left?s.right:s.left,l=e.getWidenedType(e.getBaseTypeOfLiteralType(e.getTypeAtLocation(o)));i=e.typeToTypeNode(l,t,1)}else{let s=e.getContextualType(n.parent);i=s?e.typeToTypeNode(s,void 0,1):void 0}return i||j.createKeywordTypeNode(133)}function Vje(e,t,n,i,s,o){let l=o?j.createNodeArray(j.createModifiersFromModifierFlags(o)):void 0,p=Ti(n)?j.createPropertyDeclaration(l,i,void 0,s,void 0):j.createPropertySignature(void 0,i,void 0,s),m=Jje(n);m?e.insertNodeAfter(t,m,p):e.insertMemberAtStart(t,n,p)}function Jje(e){let t;for(let n of e.members){if(!ea(n))break;t=n}return t}function SNt(e,t,n,i,s){let o=j.createKeywordTypeNode(154),l=j.createParameterDeclaration(void 0,void 0,"x",void 0,o,void 0),p=j.createIndexSignature(void 0,[l],s),m=En.ChangeTracker.with(e,S=>S.insertMemberAtStart(t,n,p));return hg(cS,m,[g.Add_index_signature_for_property_0,i])}function TNt(e,t){let{parentDeclaration:n,declSourceFile:i,modifierFlags:s,token:o,call:l}=t;if(l===void 0)return;let p=o.text,m=h=>En.ChangeTracker.with(e,b=>qje(e,b,l,o,h,n,i)),S=[ma(cS,m(s&256),[s&256?g.Declare_static_method_0:g.Declare_method_0,p],cS,g.Add_all_missing_members)];return s&2&&S.unshift(hg(cS,m(2),[g.Declare_private_method_0,p])),S}function qje(e,t,n,i,s,o,l){let p=Ck(l,e.program,e.preferences,e.host),m=Ti(o)?174:173,S=abe(m,e,p,n,i,s,o),h=xNt(o,n);h?t.insertNodeAfter(l,h,S):t.insertMemberAtStart(l,o,S),p.writeFixes(t)}function zje(e,t,{token:n,parentDeclaration:i}){let s=Tt(i.members,m=>{let S=t.getTypeAtLocation(m);return!!(S&&S.flags&402653316)}),o=i.getSourceFile(),l=j.createEnumMember(n,s?j.createStringLiteral(n.text):void 0),p=Is(i.members);p?e.insertNodeInListAfter(o,p,l,i.members):e.insertMemberAtStart(o,i,l)}function $je(e,t,n){let i=_d(t.sourceFile,t.preferences),s=Ck(t.sourceFile,t.program,t.preferences,t.host),o=n.kind===2?abe(262,t,s,n.call,Nn(n.token),n.modifierFlags,n.parentDeclaration):hie(262,t,i,n.signature,Aq(g.Function_not_implemented.message,i),n.token,void 0,void 0,void 0,s);o===void 0&&I.fail("fixMissingFunctionDeclaration codefix got unexpected error."),Um(n.parentDeclaration)?e.insertNodeBefore(n.sourceFile,n.parentDeclaration,o,!0):e.insertNodeAtEndOfScope(n.sourceFile,n.parentDeclaration,o),s.writeFixes(e)}function Wje(e,t,n){let i=Ck(t.sourceFile,t.program,t.preferences,t.host),s=_d(t.sourceFile,t.preferences),o=t.program.getTypeChecker(),l=n.parentDeclaration.attributes,p=Tt(l.properties,ik),m=vr(n.attributes,b=>{let A=$ne(t,o,i,s,o.getTypeOfSymbol(b),n.parentDeclaration),k=j.createIdentifier(b.name),N=j.createJsxAttribute(k,j.createJsxExpression(void 0,A));return io(k,N),N}),S=j.createJsxAttributes(p?[...m,...l.properties]:[...l.properties,...m]),h={prefix:l.pos===l.end?" ":void 0};e.replaceNode(t.sourceFile,l,S,h),i.writeFixes(e)}function Gje(e,t,n){let i=Ck(t.sourceFile,t.program,t.preferences,t.host),s=_d(t.sourceFile,t.preferences),o=ho(t.program.getCompilerOptions()),l=t.program.getTypeChecker(),p=vr(n.properties,S=>{let h=$ne(t,l,i,s,l.getTypeOfSymbol(S),n.parentDeclaration);return j.createPropertyAssignment(CNt(S,o,s,l),h)}),m={leadingTriviaOption:En.LeadingTriviaOption.Exclude,trailingTriviaOption:En.TrailingTriviaOption.Exclude,indentation:n.indentation};e.replaceNode(t.sourceFile,n.parentDeclaration,j.createObjectLiteralExpression([...n.parentDeclaration.properties,...p],!0),m),i.writeFixes(e)}function $ne(e,t,n,i,s,o){if(s.flags&3)return Ak();if(s.flags&134217732)return j.createStringLiteral("",i===0);if(s.flags&8)return j.createNumericLiteral(0);if(s.flags&64)return j.createBigIntLiteral("0n");if(s.flags&16)return j.createFalse();if(s.flags&1056){let l=s.symbol.exports?Oa(s.symbol.exports.values()):s.symbol,p=t.symbolToExpression(s.symbol.parent?s.symbol.parent:s.symbol,111551,void 0,64);return l===void 0||p===void 0?j.createNumericLiteral(0):j.createPropertyAccessExpression(p,t.symbolToString(l))}if(s.flags&256)return j.createNumericLiteral(s.value);if(s.flags&2048)return j.createBigIntLiteral(s.value);if(s.flags&128)return j.createStringLiteral(s.value,i===0);if(s.flags&512)return s===t.getFalseType()||s===t.getFalseType(!0)?j.createFalse():j.createTrue();if(s.flags&65536)return j.createNull();if(s.flags&1048576)return Ct(s.types,p=>$ne(e,t,n,i,p,o))??Ak();if(t.isArrayLikeType(s))return j.createArrayLiteralExpression();if(bNt(s)){let l=vr(t.getPropertiesOfType(s),p=>{let m=$ne(e,t,n,i,t.getTypeOfSymbol(p),o);return j.createPropertyAssignment(p.name,m)});return j.createObjectLiteralExpression(l,!0)}if(Gn(s)&16){if(mr(s.symbol.declarations||tt,cg(Vh,Uh,pl))===void 0)return Ak();let p=t.getSignaturesOfType(s,0);return p===void 0?Ak():hie(218,e,i,p[0],Aq(g.Function_not_implemented.message,i),void 0,void 0,void 0,o,n)??Ak()}if(Gn(s)&1){let l=ky(s.symbol);if(l===void 0||tE(l))return Ak();let p=I0(l);return p&&de(p.parameters)?Ak():j.createNewExpression(j.createIdentifier(s.symbol.name),void 0,void 0)}return Ak()}function Ak(){return j.createIdentifier("undefined")}function bNt(e){return e.flags&524288&&(Gn(e)&128||e.symbol&&ii(nl(e.symbol.declarations),dp))}function ENt(e,t,n){let i=e.getContextualType(n.attributes);if(i===void 0)return tt;let s=i.getProperties();if(!de(s))return tt;let o=new Set;for(let l of n.attributes.properties)if(th(l)&&o.add(A6(l.name)),ik(l)){let p=e.getTypeAtLocation(l.expression);for(let m of p.getProperties())o.add(m.escapedName)}return Fn(s,l=>nd(l.name,t,1)&&!(l.flags&16777216||Vc(l)&48||o.has(l.escapedName)))}function xNt(e,t){if(dp(e))return;let n=Gr(t,i=>pl(i)||Yc(i));return n&&n.parent===e?n:void 0}function CNt(e,t,n,i){if(Rh(e)){let s=i.symbolToNode(e,111551,void 0,1073741824);if(s&&uo(s))return s}return aB(e.name,t,n===0,!1,!1)}function Hje(e){if(Gr(e,J6)){let t=Gr(e.parent,Um);if(t)return t}return Xr(e)}var cS,yq,vq,Sq,ETe,ANt=f({"src/services/codefixes/fixAddMissingMember.ts"(){"use strict";yi(),Ma(),cS="fixMissingMember",yq="fixMissingProperties",vq="fixMissingAttributes",Sq="fixMissingFunctionDeclaration",ETe=[g.Property_0_does_not_exist_on_type_1.code,g.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,g.Property_0_is_missing_in_type_1_but_required_in_type_2.code,g.Type_0_is_missing_the_following_properties_from_type_1_Colon_2.code,g.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more.code,g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,g.Cannot_find_name_0.code],wa({errorCodes:ETe,getCodeActions(e){let t=e.program.getTypeChecker(),n=Fje(e.sourceFile,e.span.start,e.errorCode,t,e.program);if(n){if(n.kind===3){let i=En.ChangeTracker.with(e,s=>Gje(s,e,n));return[ma(yq,i,g.Add_missing_properties,yq,g.Add_all_missing_properties)]}if(n.kind===4){let i=En.ChangeTracker.with(e,s=>Wje(s,e,n));return[ma(vq,i,g.Add_missing_attributes,vq,g.Add_all_missing_attributes)]}if(n.kind===2||n.kind===5){let i=En.ChangeTracker.with(e,s=>$je(s,e,n));return[ma(Sq,i,[g.Add_missing_function_declaration_0,n.token.text],Sq,g.Add_all_missing_function_declarations)]}if(n.kind===1){let i=En.ChangeTracker.with(e,s=>zje(s,e.program.getTypeChecker(),n));return[ma(cS,i,[g.Add_missing_enum_member_0,n.token.text],cS,g.Add_all_missing_members)]}return ys(TNt(e,n),hNt(e,n))}},fixIds:[cS,Sq,yq,vq],getAllCodeActions:e=>{let{program:t,fixId:n}=e,i=t.getTypeChecker(),s=new Map,o=new Map;return MD(En.ChangeTracker.with(e,l=>{LD(e,ETe,p=>{let m=Fje(p.file,p.start,p.code,i,e.program);if(!(!m||!Bm(s,yo(m.parentDeclaration)+"#"+(m.kind===3?m.identifier:m.token.text)))){if(n===Sq&&(m.kind===2||m.kind===5))$je(l,e,m);else if(n===yq&&m.kind===3)Gje(l,e,m);else if(n===vq&&m.kind===4)Wje(l,e,m);else if(m.kind===1&&zje(l,i,m),m.kind===0){let{parentDeclaration:S,token:h}=m,b=km(o,S,()=>[]);b.some(A=>A.token.text===h.text)||b.push(m)}}}),o.forEach((p,m)=>{let S=dp(m)?void 0:dbe(m,i);for(let h of p){if(S?.some(U=>{let H=o.get(U);return!!H&&H.some(({token:K})=>K.text===h.token.text)}))continue;let{parentDeclaration:b,declSourceFile:A,modifierFlags:k,token:N,call:M,isJSFile:O}=h;if(M&&!is(N))qje(e,l,M,N,k&256,b,A);else if(O&&!ef(b)&&!dp(b))jje(l,A,b,N,!!(k&256));else{let U=Uje(i,b,N);Vje(l,A,b,N.text,U,k&256)}}})}))}})}});function Yje(e,t,n){let i=ta(kNt(t,n),da),s=j.createNewExpression(i.expression,i.typeArguments,i.arguments);e.replaceNode(t,i,s)}function kNt(e,t){let n=Ts(e,t.start),i=gl(t);for(;n.end<i;)n=n.parent;return n}var Wne,xTe,PNt=f({"src/services/codefixes/fixAddMissingNewOperator.ts"(){"use strict";yi(),Ma(),Wne="addMissingNewOperator",xTe=[g.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new.code],wa({errorCodes:xTe,getCodeActions(e){let{sourceFile:t,span:n}=e,i=En.ChangeTracker.with(e,s=>Yje(s,t,n));return[ma(Wne,i,g.Add_missing_new_operator_to_call,Wne,g.Add_missing_new_operator_to_all_calls)]},fixIds:[Wne],getAllCodeActions:e=>Fo(e,xTe,(t,n)=>Yje(t,e.sourceFile,n))})}});function Xje(e,t,n){let i=Ts(e,n),s=Gr(i,da);if(s===void 0||de(s.arguments)===0)return;let o=t.getTypeChecker(),l=o.getTypeAtLocation(s.expression),p=Fn(l.symbol.declarations,Kje);if(p===void 0)return;let m=Is(p);if(m===void 0||m.body===void 0||PD(t,m.getSourceFile()))return;let S=NNt(m);if(S===void 0)return;let h=[],b=[],A=de(m.parameters),k=de(s.arguments);if(A>k)return;let N=[m,...INt(m,p)];for(let M=0,O=0,U=0;M<k;M++){let H=s.arguments[M],K=Yo(H)?MX(H):H,re=o.getWidenedType(o.getBaseTypeOfLiteralType(o.getTypeAtLocation(H))),$=O<A?m.parameters[O]:void 0;if($&&o.isTypeAssignableTo(re,o.getTypeAtLocation($))){O++;continue}let pe=K&&ze(K)?K.text:`p${U++}`,z=DNt(o,re,m);Pr(h,{pos:M,declaration:Zje(pe,z,void 0)}),!ONt(N,O)&&Pr(b,{pos:M,declaration:Zje(pe,z,j.createToken(58))})}return{newParameters:h,newOptionalParameters:b,name:qo(S),declarations:N}}function NNt(e){let t=qs(e);if(t)return t;if(Gi(e.parent)&&ze(e.parent.name)||ea(e.parent)||Ls(e.parent))return e.parent.name}function DNt(e,t,n){return e.typeToTypeNode(e.getWidenedType(t),n,1)??j.createKeywordTypeNode(159)}function Gne(e,t,n,i){Te(n,s=>{de(s.parameters)?e.replaceNodeRangeWithNodes(t,di(s.parameters),Rs(s.parameters),Qje(s,i),{joiner:", ",indentation:0,leadingTriviaOption:En.LeadingTriviaOption.IncludeAll,trailingTriviaOption:En.TrailingTriviaOption.Include}):Te(Qje(s,i),(o,l)=>{de(s.parameters)===0&&l===0?e.insertNodeAt(t,s.parameters.end,o):e.insertNodeAtEndOfList(t,s.parameters,o)})})}function Kje(e){switch(e.kind){case 262:case 218:case 174:case 219:return!0;default:return!1}}function Qje(e,t){let n=vr(e.parameters,i=>j.createParameterDeclaration(i.modifiers,i.dotDotDotToken,i.name,i.questionToken,i.type,i.initializer));for(let{pos:i,declaration:s}of t){let o=i>0?n[i-1]:void 0;n.splice(i,0,j.updateParameterDeclaration(s,s.modifiers,s.dotDotDotToken,s.name,o&&o.questionToken?j.createToken(58):s.questionToken,s.type,s.initializer))}return n}function INt(e,t){let n=[];for(let i of t)if(wNt(i)){if(de(i.parameters)===de(e.parameters)){n.push(i);continue}if(de(i.parameters)>de(e.parameters))return[]}return n}function wNt(e){return Kje(e)&&e.body===void 0}function Zje(e,t,n){return j.createParameterDeclaration(void 0,void 0,e,n,t,void 0)}function ONt(e,t){return de(e)&&Tt(e,n=>t<de(n.parameters)&&!!n.parameters[t]&&n.parameters[t].questionToken===void 0)}var Tq,bq,CTe,RNt=f({"src/services/codefixes/fixAddMissingParam.ts"(){"use strict";yi(),Ma(),Tq="addMissingParam",bq="addOptionalParam",CTe=[g.Expected_0_arguments_but_got_1.code],wa({errorCodes:CTe,fixIds:[Tq,bq],getCodeActions(e){let t=Xje(e.sourceFile,e.program,e.span.start);if(t===void 0)return;let{name:n,declarations:i,newParameters:s,newOptionalParameters:o}=t,l=[];return de(s)&&Pr(l,ma(Tq,En.ChangeTracker.with(e,p=>Gne(p,e.sourceFile,i,s)),[de(s)>1?g.Add_missing_parameters_to_0:g.Add_missing_parameter_to_0,n],Tq,g.Add_all_missing_parameters)),de(o)&&Pr(l,ma(bq,En.ChangeTracker.with(e,p=>Gne(p,e.sourceFile,i,o)),[de(o)>1?g.Add_optional_parameters_to_0:g.Add_optional_parameter_to_0,n],bq,g.Add_all_optional_parameters)),l},getAllCodeActions:e=>Fo(e,CTe,(t,n)=>{let i=Xje(e.sourceFile,e.program,n.start);if(i){let{declarations:s,newParameters:o,newOptionalParameters:l}=i;e.fixId===Tq&&Gne(t,e.sourceFile,s,o),e.fixId===bq&&Gne(t,e.sourceFile,s,l)}})})}});function eBe(e,t){return{type:"install package",file:e,packageName:t}}function tBe(e,t){let n=ii(Ts(e,t),za);if(!n)return;let i=n.text,{packageName:s}=mM(i);return Nu(s)?void 0:s}function rBe(e,t,n){var i;return n===ATe?sh.nodeCoreModules.has(e)?"@types/node":void 0:(i=t.isKnownTypesPackageName)!=null&&i.call(t,e)?zU(e):void 0}var nBe,Hne,ATe,kTe,MNt=f({"src/services/codefixes/fixCannotFindModule.ts"(){"use strict";yi(),Ma(),nBe="fixCannotFindModule",Hne="installTypesPackage",ATe=g.Cannot_find_module_0_or_its_corresponding_type_declarations.code,kTe=[ATe,g.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type.code],wa({errorCodes:kTe,getCodeActions:function(t){let{host:n,sourceFile:i,span:{start:s}}=t,o=tBe(i,s);if(o===void 0)return;let l=rBe(o,n,t.errorCode);return l===void 0?[]:[ma(nBe,[],[g.Install_0,l],Hne,g.Install_all_missing_types_packages,eBe(i.fileName,l))]},fixIds:[Hne],getAllCodeActions:e=>Fo(e,kTe,(t,n,i)=>{let s=tBe(n.file,n.start);if(s!==void 0)switch(e.fixId){case Hne:{let o=rBe(s,e.host,n.code);o&&i.push(eBe(n.file.fileName,o));break}default:I.fail(`Bad fixId: ${e.fixId}`)}})})}});function iBe(e,t){let n=Ts(e,t);return ta(n.parent,Ti)}function sBe(e,t,n,i,s){let o=$g(e),l=n.program.getTypeChecker(),p=l.getTypeAtLocation(o),m=l.getPropertiesOfType(p).filter(LNt),S=Ck(t,n.program,s,n.host);sbe(e,m,t,n,s,S,h=>i.insertMemberAtStart(t,e,h)),S.writeFixes(i)}function LNt(e){let t=qv(di(e.getDeclarations()));return!(t&2)&&!!(t&64)}var PTe,Yne,FNt=f({"src/services/codefixes/fixClassDoesntImplementInheritedAbstractMember.ts"(){"use strict";yi(),Ma(),PTe=[g.Non_abstract_class_0_does_not_implement_all_abstract_members_of_1.code],Yne="fixClassDoesntImplementInheritedAbstractMember",wa({errorCodes:PTe,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=En.ChangeTracker.with(t,o=>sBe(iBe(n,i.start),n,t,o,t.preferences));return s.length===0?void 0:[ma(Yne,s,g.Implement_inherited_abstract_class,Yne,g.Implement_all_inherited_abstract_classes)]},fixIds:[Yne],getAllCodeActions:function(t){let n=new Map;return Fo(t,PTe,(i,s)=>{let o=iBe(s.file,s.start);Bm(n,yo(o))&&sBe(o,t.sourceFile,t,i,t.preferences)})}})}});function aBe(e,t,n,i){e.insertNodeAtConstructorStart(t,n,i),e.delete(t,i)}function oBe(e,t){let n=Ts(e,t);if(n.kind!==110)return;let i=Vp(n),s=cBe(i.body);return s&&!s.expression.arguments.some(o=>Hn(o)&&o.expression===n)?{constructor:i,superCall:s}:void 0}function cBe(e){return Ou(e)&&$2(e.expression)?e:ca(e)?void 0:Qs(e,cBe)}var Xne,NTe,jNt=f({"src/services/codefixes/fixClassSuperMustPrecedeThisAccess.ts"(){"use strict";yi(),Ma(),Xne="classSuperMustPrecedeThisAccess",NTe=[g.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class.code],wa({errorCodes:NTe,getCodeActions(e){let{sourceFile:t,span:n}=e,i=oBe(t,n.start);if(!i)return;let{constructor:s,superCall:o}=i,l=En.ChangeTracker.with(e,p=>aBe(p,t,s,o));return[ma(Xne,l,g.Make_super_call_the_first_statement_in_the_constructor,Xne,g.Make_all_super_calls_the_first_statement_in_their_constructor)]},fixIds:[Xne],getAllCodeActions(e){let{sourceFile:t}=e,n=new Map;return Fo(e,NTe,(i,s)=>{let o=oBe(s.file,s.start);if(!o)return;let{constructor:l,superCall:p}=o;Bm(n,yo(l.parent))&&aBe(i,t,l,p)})}})}});function lBe(e,t){let n=Ts(e,t);return I.assert(Yc(n.parent),"token should be at the constructor declaration"),n.parent}function uBe(e,t,n){let i=j.createExpressionStatement(j.createCallExpression(j.createSuper(),void 0,tt));e.insertNodeAtConstructorStart(t,n,i)}var Kne,DTe,BNt=f({"src/services/codefixes/fixConstructorForDerivedNeedSuperCall.ts"(){"use strict";yi(),Ma(),Kne="constructorForDerivedNeedSuperCall",DTe=[g.Constructors_for_derived_classes_must_contain_a_super_call.code],wa({errorCodes:DTe,getCodeActions(e){let{sourceFile:t,span:n}=e,i=lBe(t,n.start),s=En.ChangeTracker.with(e,o=>uBe(o,t,i));return[ma(Kne,s,g.Add_missing_super_call,Kne,g.Add_all_missing_super_calls)]},fixIds:[Kne],getAllCodeActions:e=>Fo(e,DTe,(t,n)=>uBe(t,e.sourceFile,lBe(n.file,n.start)))})}});function _Be(e,t){ube(e,t,"jsx",j.createStringLiteral("react"))}var ITe,wTe,UNt=f({"src/services/codefixes/fixEnableJsxFlag.ts"(){"use strict";yi(),Ma(),ITe="fixEnableJsxFlag",wTe=[g.Cannot_use_JSX_unless_the_jsx_flag_is_provided.code],wa({errorCodes:wTe,getCodeActions:function(t){let{configFile:n}=t.program.getCompilerOptions();if(n===void 0)return;let i=En.ChangeTracker.with(t,s=>_Be(s,n));return[hg(ITe,i,g.Enable_the_jsx_flag_in_your_configuration_file)]},fixIds:[ITe],getAllCodeActions:e=>Fo(e,wTe,t=>{let{configFile:n}=e.program.getCompilerOptions();n!==void 0&&_Be(t,n)})})}});function fBe(e,t,n){let i=mr(e.getSemanticDiagnostics(t),l=>l.start===n.start&&l.length===n.length);if(i===void 0||i.relatedInformation===void 0)return;let s=mr(i.relatedInformation,l=>l.code===g.Did_you_mean_0.code);if(s===void 0||s.file===void 0||s.start===void 0||s.length===void 0)return;let o=fbe(s.file,e_(s.start,s.length));if(o!==void 0&&bt(o)&&bn(o.parent))return{suggestion:VNt(s.messageText),expression:o.parent,arg:o}}function pBe(e,t,n,i){let s=j.createCallExpression(j.createPropertyAccessExpression(j.createIdentifier("Number"),j.createIdentifier("isNaN")),void 0,[n]),o=i.operatorToken.kind;e.replaceNode(t,i,o===38||o===36?j.createPrefixUnaryExpression(54,s):s)}function VNt(e){let[,t]=nh(e,`
`,0).match(/'(.*)'/)||[];return t}var Qne,OTe,JNt=f({"src/services/codefixes/fixNaNEquality.ts"(){"use strict";yi(),Ma(),Qne="fixNaNEquality",OTe=[g.This_condition_will_always_return_0.code],wa({errorCodes:OTe,getCodeActions(e){let{sourceFile:t,span:n,program:i}=e,s=fBe(i,t,n);if(s===void 0)return;let{suggestion:o,expression:l,arg:p}=s,m=En.ChangeTracker.with(e,S=>pBe(S,t,p,l));return[ma(Qne,m,[g.Use_0,o],Qne,g.Use_Number_isNaN_in_all_conditions)]},fixIds:[Qne],getAllCodeActions:e=>Fo(e,OTe,(t,n)=>{let i=fBe(e.program,n.file,e_(n.start,n.length));i&&pBe(t,n.file,i.arg,i.expression)})})}}),qNt=f({"src/services/codefixes/fixModuleAndTargetOptions.ts"(){"use strict";yi(),Ma(),wa({errorCodes:[g.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher.code,g.Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher.code,g.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher.code],getCodeActions:function(t){let n=t.program.getCompilerOptions(),{configFile:i}=n;if(i===void 0)return;let s=[],o=T_(n);if(o>=5&&o<99){let S=En.ChangeTracker.with(t,h=>{ube(h,i,"module",j.createStringLiteral("esnext"))});s.push(hg("fixModuleOption",S,[g.Set_the_module_option_in_your_configuration_file_to_0,"esnext"]))}let p=ho(n);if(p<4||p>99){let S=En.ChangeTracker.with(t,h=>{if(!qw(i))return;let A=[["target",j.createStringLiteral("es2017")]];o===1&&A.push(["module",j.createStringLiteral("commonjs")]),lbe(h,i,A)});s.push(hg("fixTargetOption",S,[g.Set_the_target_option_in_your_configuration_file_to_0,"es2017"]))}return s.length?s:void 0}})}});function dBe(e,t,n){e.replaceNode(t,n,j.createPropertyAssignment(n.name,n.objectAssignmentInitializer))}function mBe(e,t){return ta(Ts(e,t).parent,Hf)}var Zne,RTe,zNt=f({"src/services/codefixes/fixPropertyAssignment.ts"(){"use strict";yi(),Ma(),Zne="fixPropertyAssignment",RTe=[g.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code],wa({errorCodes:RTe,fixIds:[Zne],getCodeActions(e){let{sourceFile:t,span:n}=e,i=mBe(t,n.start),s=En.ChangeTracker.with(e,o=>dBe(o,e.sourceFile,i));return[ma(Zne,s,[g.Change_0_to_1,"=",":"],Zne,[g.Switch_each_misused_0_to_1,"=",":"])]},getAllCodeActions:e=>Fo(e,RTe,(t,n)=>dBe(t,n.file,mBe(n.file,n.start)))})}});function gBe(e,t){let n=Ts(e,t),i=Vu(n).heritageClauses,s=i[0].getFirstToken();return s.kind===96?{extendsToken:s,heritageClauses:i}:void 0}function hBe(e,t,n,i){if(e.replaceNode(t,n,j.createToken(119)),i.length===2&&i[0].token===96&&i[1].token===119){let s=i[1].getFirstToken(),o=s.getFullStart();e.replaceRange(t,{pos:o,end:o},j.createToken(28));let l=t.text,p=s.end;for(;p<l.length&&Vg(l.charCodeAt(p));)p++;e.deleteRange(t,{pos:s.getStart(),end:p})}}var eie,MTe,$Nt=f({"src/services/codefixes/fixExtendsInterfaceBecomesImplements.ts"(){"use strict";yi(),Ma(),eie="extendsInterfaceBecomesImplements",MTe=[g.Cannot_extend_an_interface_0_Did_you_mean_implements.code],wa({errorCodes:MTe,getCodeActions(e){let{sourceFile:t}=e,n=gBe(t,e.span.start);if(!n)return;let{extendsToken:i,heritageClauses:s}=n,o=En.ChangeTracker.with(e,l=>hBe(l,t,i,s));return[ma(eie,o,g.Change_extends_to_implements,eie,g.Change_all_extended_interfaces_to_implements)]},fixIds:[eie],getAllCodeActions:e=>Fo(e,MTe,(t,n)=>{let i=gBe(n.file,n.start);i&&hBe(t,n.file,i.extendsToken,i.heritageClauses)})})}});function yBe(e,t,n){let i=Ts(e,t);if(ze(i)||is(i))return{node:i,className:n===LTe?Vu(i).name.text:void 0}}function vBe(e,t,{node:n,className:i}){hp(n),e.replaceNode(t,n,j.createPropertyAccessExpression(i?j.createIdentifier(i):j.createThis(),n))}var tie,LTe,FTe,WNt=f({"src/services/codefixes/fixForgottenThisPropertyAccess.ts"(){"use strict";yi(),Ma(),tie="forgottenThisPropertyAccess",LTe=g.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,FTe=[g.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,g.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code,LTe],wa({errorCodes:FTe,getCodeActions(e){let{sourceFile:t}=e,n=yBe(t,e.span.start,e.errorCode);if(!n)return;let i=En.ChangeTracker.with(e,s=>vBe(s,t,n));return[ma(tie,i,[g.Add_0_to_unresolved_variable,n.className||"this"],tie,g.Add_qualifier_to_all_unresolved_variables_matching_a_member_name)]},fixIds:[tie],getAllCodeActions:e=>Fo(e,FTe,(t,n)=>{let i=yBe(n.file,n.start,n.code);i&&vBe(t,e.sourceFile,i)})})}});function GNt(e){return wo(UTe,e)}function jTe(e,t,n,i,s){let o=n.getText()[i];if(!GNt(o))return;let l=s?UTe[o]:`{${IO(n,t,o)}}`;e.replaceRangeWithText(n,{pos:i,end:i+1},l)}var rie,Eq,BTe,UTe,HNt=f({"src/services/codefixes/fixInvalidJsxCharacters.ts"(){"use strict";yi(),Ma(),rie="fixInvalidJsxCharacters_expression",Eq="fixInvalidJsxCharacters_htmlEntity",BTe=[g.Unexpected_token_Did_you_mean_or_gt.code,g.Unexpected_token_Did_you_mean_or_rbrace.code],wa({errorCodes:BTe,fixIds:[rie,Eq],getCodeActions(e){let{sourceFile:t,preferences:n,span:i}=e,s=En.ChangeTracker.with(e,l=>jTe(l,n,t,i.start,!1)),o=En.ChangeTracker.with(e,l=>jTe(l,n,t,i.start,!0));return[ma(rie,s,g.Wrap_invalid_character_in_an_expression_container,rie,g.Wrap_all_invalid_characters_in_an_expression_container),ma(Eq,o,g.Convert_invalid_character_to_its_html_entity_code,Eq,g.Convert_all_invalid_characters_to_HTML_entity_code)]},getAllCodeActions(e){return Fo(e,BTe,(t,n)=>jTe(t,e.preferences,n.file,n.start,e.fixId===Eq))}}),UTe={">":"&gt;","}":"&rbrace;"}}});function YNt(e,{name:t,jsDocHost:n,jsDocParameterTag:i}){let s=En.ChangeTracker.with(e,o=>o.filterJSDocTags(e.sourceFile,n,l=>l!==i));return ma(xq,s,[g.Delete_unused_param_tag_0,t.getText(e.sourceFile)],xq,g.Delete_all_unused_param_tags)}function XNt(e,{name:t,jsDocHost:n,signature:i,jsDocParameterTag:s}){if(!de(i.parameters))return;let o=e.sourceFile,l=pT(i),p=new Set;for(let b of l)mg(b)&&ze(b.name)&&p.add(b.name.escapedText);let m=Ct(i.parameters,b=>ze(b.name)&&!p.has(b.name.escapedText)?b.name.getText(o):void 0);if(m===void 0)return;let S=j.updateJSDocParameterTag(s,s.tagName,j.createIdentifier(m),s.isBracketed,s.typeExpression,s.isNameFirst,s.comment),h=En.ChangeTracker.with(e,b=>b.replaceJSDocComment(o,n,vr(l,A=>A===s?S:A)));return hg(VTe,h,[g.Rename_param_tag_name_0_to_1,t.getText(o),m])}function SBe(e,t){let n=Ts(e,t);if(n.parent&&mg(n.parent)&&ze(n.parent.name)){let i=n.parent,s=X2(i),o=yT(i);if(s&&o)return{jsDocHost:s,signature:o,name:n.parent.name,jsDocParameterTag:i}}}var xq,VTe,JTe,KNt=f({"src/services/codefixes/fixUnmatchedParameter.ts"(){"use strict";yi(),Ma(),xq="deleteUnmatchedParameter",VTe="renameUnmatchedParameter",JTe=[g.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name.code],wa({fixIds:[xq,VTe],errorCodes:JTe,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=[],o=SBe(n,i.start);if(o)return Pr(s,YNt(t,o)),Pr(s,XNt(t,o)),s},getAllCodeActions:function(t){let n=new Map;return MD(En.ChangeTracker.with(t,i=>{LD(t,JTe,({file:s,start:o})=>{let l=SBe(s,o);l&&n.set(l.signature,Pr(n.get(l.signature),l.jsDocParameterTag))}),n.forEach((s,o)=>{if(t.fixId===xq){let l=new Set(s);i.filterJSDocTags(o.getSourceFile(),o,p=>!l.has(p))}})}))}})}});function QNt(e,t,n){let i=ii(Ts(e,n),ze);if(!i||i.parent.kind!==183)return;let o=t.getTypeChecker().getSymbolAtLocation(i);return mr(o?.declarations||tt,cg(Jh,Gf,Ru))}function ZNt(e,t,n,i){if(n.kind===271){e.insertModifierBefore(t,156,n.name);return}let s=n.kind===273?n:n.parent.parent;if(s.name&&s.namedBindings)return;let o=i.getTypeChecker();hj(s,p=>{if(r_(p.symbol,o).flags&111551)return!0})||e.insertModifierBefore(t,156,s)}function eDt(e,t,n,i){bk.doChangeNamedToNamespaceOrDefault(t,i,e,n.parent)}var nie,TBe,tDt=f({"src/services/codefixes/fixUnreferenceableDecoratorMetadata.ts"(){"use strict";yi(),Ma(),nie="fixUnreferenceableDecoratorMetadata",TBe=[g.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled.code],wa({errorCodes:TBe,getCodeActions:e=>{let t=QNt(e.sourceFile,e.program,e.span.start);if(!t)return;let n=En.ChangeTracker.with(e,o=>t.kind===276&&eDt(o,e.sourceFile,t,e.program)),i=En.ChangeTracker.with(e,o=>ZNt(o,e.sourceFile,t,e.program)),s;return n.length&&(s=Pr(s,hg(nie,n,g.Convert_named_imports_to_namespace_import))),i.length&&(s=Pr(s,hg(nie,i,g.Use_import_type))),s},fixIds:[nie]})}});function bBe(e,t,n){e.replaceNode(t,n.parent,j.createKeywordTypeNode(159))}function F7(e,t){return ma(j7,e,t,aie,g.Delete_all_unused_declarations)}function EBe(e,t,n){e.delete(t,I.checkDefined(ta(n.parent,MY).typeParameters,"The type parameter to delete should exist"))}function qTe(e){return e.kind===102||e.kind===80&&(e.parent.kind===276||e.parent.kind===273)}function xBe(e){return e.kind===102?ii(e.parent,uu):void 0}function CBe(e,t){return Tu(t.parent)&&di(t.parent.getChildren(e))===t}function ABe(e,t,n){e.delete(t,n.parent.kind===243?n.parent:n)}function rDt(e,t,n){Te(n.elements,i=>e.delete(t,i))}function nDt(e,t,n,{parent:i}){if(Gi(i)&&i.initializer&&Vb(i.initializer))if(Tu(i.parent)&&de(i.parent.declarations)>1){let s=i.parent.parent,o=s.getStart(n),l=s.end;t.delete(n,i),t.insertNodeAt(n,l,i.initializer,{prefix:q1(e.host,e.formatContext.options)+n.text.slice(TJ(n.text,o-1),o),suffix:u7(n)?";":""})}else t.replaceNode(n,i.parent,i.initializer);else t.delete(n,i)}function kBe(e,t,n,i){t!==g.Property_0_is_declared_but_its_value_is_never_read.code&&(i.kind===140&&(i=ta(i.parent,ax).typeParameter.name),ze(i)&&iDt(i)&&(e.replaceNode(n,i,j.createIdentifier(`_${i.text}`)),Ls(i.parent)&&HP(i.parent).forEach(s=>{ze(s.name)&&e.replaceNode(n,s.name,j.createIdentifier(`_${s.name.text}`))})))}function iDt(e){switch(e.parent.kind){case 169:case 168:return!0;case 260:switch(e.parent.parent.parent.kind){case 250:case 249:return!0}}return!1}function iie(e,t,n,i,s,o,l,p){sDt(t,n,e,i,s,o,l,p),ze(t)&&Ko.Core.eachSymbolReferenceInFile(t,i,e,m=>{Hn(m.parent)&&m.parent.name===m&&(m=m.parent),!p&&lDt(m)&&n.delete(e,m.parent.parent)})}function sDt(e,t,n,i,s,o,l,p){let{parent:m}=e;if(Ls(m))aDt(t,n,m,i,s,o,l,p);else if(!(p&&ze(e)&&Ko.Core.isSymbolReferencedInFile(e,i,n))){let S=Jh(m)?e:uo(m)?m.parent:m;I.assert(S!==n,"should not delete whole source file"),t.delete(n,S)}}function aDt(e,t,n,i,s,o,l,p=!1){if(oDt(i,t,n,s,o,l,p))if(n.modifiers&&n.modifiers.length>0&&(!ze(n.name)||Ko.Core.isSymbolReferencedInFile(n.name,i,t)))for(let m of n.modifiers)Ra(m)&&e.deleteModifier(t,m);else!n.initializer&&PBe(n,i,s)&&e.delete(t,n)}function PBe(e,t,n){let i=e.parent.parameters.indexOf(e);return!Ko.Core.someSignatureUsage(e.parent,n,t,(s,o)=>!o||o.arguments.length>i)}function oDt(e,t,n,i,s,o,l){let{parent:p}=n;switch(p.kind){case 174:case 176:let m=p.parameters.indexOf(n),S=pl(p)?p.name:p,h=Ko.Core.getReferencedSymbolsForNode(p.pos,S,s,i,o);if(h){for(let b of h)for(let A of b.references)if(A.kind===Ko.EntryKind.Node){let k=M6(A.node)&&da(A.node.parent)&&A.node.parent.arguments.length>m,N=Hn(A.node.parent)&&M6(A.node.parent.expression)&&da(A.node.parent.parent)&&A.node.parent.parent.arguments.length>m,M=(pl(A.node.parent)||Uh(A.node.parent))&&A.node.parent!==n.parent&&A.node.parent.parameters.length>m;if(k||N||M)return!1}}return!0;case 262:return p.name&&cDt(e,t,p.name)?NBe(p,n,l):!0;case 218:case 219:return NBe(p,n,l);case 178:return!1;case 177:return!0;default:return I.failBadSyntaxKind(p)}}function cDt(e,t,n){return!!Ko.Core.eachSymbolReferenceInFile(n,e,t,i=>ze(i)&&da(i.parent)&&i.parent.arguments.includes(i))}function NBe(e,t,n){let i=e.parameters,s=i.indexOf(t);return I.assert(s!==-1,"The parameter should already be in the list"),n?i.slice(s+1).every(o=>ze(o.name)&&!o.symbol.isReferenced):s===i.length-1}function lDt(e){return(bn(e.parent)&&e.parent.left===e||(MK(e.parent)||eS(e.parent))&&e.parent.operand===e)&&Ou(e.parent.parent)}var j7,sie,aie,Cq,oie,zTe,uDt=f({"src/services/codefixes/fixUnusedIdentifier.ts"(){"use strict";yi(),Ma(),j7="unusedIdentifier",sie="unusedIdentifier_prefix",aie="unusedIdentifier_delete",Cq="unusedIdentifier_deleteImports",oie="unusedIdentifier_infer",zTe=[g._0_is_declared_but_its_value_is_never_read.code,g._0_is_declared_but_never_used.code,g.Property_0_is_declared_but_its_value_is_never_read.code,g.All_imports_in_import_declaration_are_unused.code,g.All_destructured_elements_are_unused.code,g.All_variables_are_unused.code,g.All_type_parameters_are_unused.code],wa({errorCodes:zTe,getCodeActions(e){let{errorCode:t,sourceFile:n,program:i,cancellationToken:s}=e,o=i.getTypeChecker(),l=i.getSourceFiles(),p=Ts(n,e.span.start);if(dm(p))return[F7(En.ChangeTracker.with(e,b=>b.delete(n,p)),g.Remove_template_tag)];if(p.kind===30){let b=En.ChangeTracker.with(e,A=>EBe(A,n,p));return[F7(b,g.Remove_type_parameters)]}let m=xBe(p);if(m){let b=En.ChangeTracker.with(e,A=>A.delete(n,m));return[ma(j7,b,[g.Remove_import_from_0,dme(m)],Cq,g.Delete_all_unused_imports)]}else if(qTe(p)){let b=En.ChangeTracker.with(e,A=>iie(n,p,A,o,l,i,s,!1));if(b.length)return[ma(j7,b,[g.Remove_unused_declaration_for_Colon_0,p.getText(n)],Cq,g.Delete_all_unused_imports)]}if(pm(p.parent)||cE(p.parent)){if(Ls(p.parent.parent)){let b=p.parent.elements,A=[b.length>1?g.Remove_unused_declarations_for_Colon_0:g.Remove_unused_declaration_for_Colon_0,vr(b,k=>k.getText(n)).join(", ")];return[F7(En.ChangeTracker.with(e,k=>rDt(k,n,p.parent)),A)]}return[F7(En.ChangeTracker.with(e,b=>nDt(e,b,n,p.parent)),g.Remove_unused_destructuring_declaration)]}if(CBe(n,p))return[F7(En.ChangeTracker.with(e,b=>ABe(b,n,p.parent)),g.Remove_variable_statement)];let S=[];if(p.kind===140){let b=En.ChangeTracker.with(e,k=>bBe(k,n,p)),A=ta(p.parent,ax).typeParameter.name.text;S.push(ma(j7,b,[g.Replace_infer_0_with_unknown,A],oie,g.Replace_all_unused_infer_with_unknown))}else{let b=En.ChangeTracker.with(e,A=>iie(n,p,A,o,l,i,s,!1));if(b.length){let A=uo(p.parent)?p.parent:p;S.push(F7(b,[g.Remove_unused_declaration_for_Colon_0,A.getText(n)]))}}let h=En.ChangeTracker.with(e,b=>kBe(b,t,n,p));return h.length&&S.push(ma(j7,h,[g.Prefix_0_with_an_underscore,p.getText(n)],sie,g.Prefix_all_unused_declarations_with_where_possible)),S},fixIds:[sie,aie,Cq,oie],getAllCodeActions:e=>{let{sourceFile:t,program:n,cancellationToken:i}=e,s=n.getTypeChecker(),o=n.getSourceFiles();return Fo(e,zTe,(l,p)=>{let m=Ts(t,p.start);switch(e.fixId){case sie:kBe(l,p.code,t,m);break;case Cq:{let S=xBe(m);S?l.delete(t,S):qTe(m)&&iie(t,m,l,s,o,n,i,!0);break}case aie:{if(m.kind===140||qTe(m))break;if(dm(m))l.delete(t,m);else if(m.kind===30)EBe(l,t,m);else if(pm(m.parent)){if(m.parent.parent.initializer)break;(!Ls(m.parent.parent)||PBe(m.parent.parent,s,o))&&l.delete(t,m.parent.parent)}else{if(cE(m.parent.parent)&&m.parent.parent.parent.initializer)break;CBe(t,m)?ABe(l,t,m.parent):iie(t,m,l,s,o,n,i,!0)}break}case oie:m.kind===140&&bBe(l,t,m);break;default:I.fail(JSON.stringify(e.fixId))}})}})}});function DBe(e,t,n,i,s){let o=Ts(t,n),l=Gr(o,ns);if(l.getStart(t)!==o.getStart(t)){let m=JSON.stringify({statementKind:I.formatSyntaxKind(l.kind),tokenKind:I.formatSyntaxKind(o.kind),errorCode:s,start:n,length:i});I.fail("Token and statement should start at the same point. "+m)}let p=(ra(l.parent)?l.parent:l).parent;if(!ra(l.parent)||l===di(l.parent.statements))switch(p.kind){case 245:if(p.elseStatement){if(ra(l.parent))break;e.replaceNode(t,l,j.createBlock(tt));return}case 247:case 248:e.delete(t,p);return}if(ra(l.parent)){let m=n+i,S=I.checkDefined(_Dt(zX(l.parent.statements,l),h=>h.pos<m),"Some statement should be last");e.deleteNodeRange(t,l,S)}else e.delete(t,l)}function _Dt(e,t){let n;for(let i of e){if(!t(i))break;n=i}return n}var cie,$Te,fDt=f({"src/services/codefixes/fixUnreachableCode.ts"(){"use strict";yi(),Ma(),cie="fixUnreachableCode",$Te=[g.Unreachable_code_detected.code],wa({errorCodes:$Te,getCodeActions(e){if(e.program.getSyntacticDiagnostics(e.sourceFile,e.cancellationToken).length)return;let n=En.ChangeTracker.with(e,i=>DBe(i,e.sourceFile,e.span.start,e.span.length,e.errorCode));return[ma(cie,n,g.Remove_unreachable_code,cie,g.Remove_all_unreachable_code)]},fixIds:[cie],getAllCodeActions:e=>Fo(e,$Te,(t,n)=>DBe(t,n.file,n.start,n.length,n.code))})}});function IBe(e,t,n){let i=Ts(t,n),s=ta(i.parent,_E),o=i.getStart(t),l=s.statement.getStart(t),p=Pd(o,l,t)?l:Wa(t.text,Oo(s,59,t).end,!0);e.deleteRange(t,{pos:o,end:p})}var lie,WTe,pDt=f({"src/services/codefixes/fixUnusedLabel.ts"(){"use strict";yi(),Ma(),lie="fixUnusedLabel",WTe=[g.Unused_label.code],wa({errorCodes:WTe,getCodeActions(e){let t=En.ChangeTracker.with(e,n=>IBe(n,e.sourceFile,e.span.start));return[ma(lie,t,g.Remove_unused_label,lie,g.Remove_all_unused_labels)]},fixIds:[lie],getAllCodeActions:e=>Fo(e,WTe,(t,n)=>IBe(t,n.file,n.start))})}});function wBe(e,t,n,i,s){e.replaceNode(t,n,s.typeToTypeNode(i,n,void 0))}function OBe(e,t,n){let i=Gr(Ts(e,t),dDt),s=i&&i.type;return s&&{typeNode:s,type:mDt(n,s)}}function dDt(e){switch(e.kind){case 234:case 179:case 180:case 262:case 177:case 181:case 200:case 174:case 173:case 169:case 172:case 171:case 178:case 265:case 216:case 260:return!0;default:return!1}}function mDt(e,t){if(GN(t)){let n=e.getTypeFromTypeNode(t.type);return n===e.getNeverType()||n===e.getVoidType()?n:e.getUnionType(Pr([n,e.getUndefinedType()],t.postfix?void 0:e.getNullType()))}return e.getTypeFromTypeNode(t)}var GTe,uie,HTe,gDt=f({"src/services/codefixes/fixJSDocTypes.ts"(){"use strict";yi(),Ma(),GTe="fixJSDocTypes_plain",uie="fixJSDocTypes_nullable",HTe=[g.JSDoc_types_can_only_be_used_inside_documentation_comments.code,g._0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1.code,g._0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1.code],wa({errorCodes:HTe,getCodeActions(e){let{sourceFile:t}=e,n=e.program.getTypeChecker(),i=OBe(t,e.span.start,n);if(!i)return;let{typeNode:s,type:o}=i,l=s.getText(t),p=[m(o,GTe,g.Change_all_jsdoc_style_types_to_TypeScript)];return s.kind===321&&p.push(m(o,uie,g.Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types)),p;function m(S,h,b){let A=En.ChangeTracker.with(e,k=>wBe(k,t,s,S,n));return ma("jdocTypes",A,[g.Change_0_to_1,l,n.typeToString(S)],h,b)}},fixIds:[GTe,uie],getAllCodeActions(e){let{fixId:t,program:n,sourceFile:i}=e,s=n.getTypeChecker();return Fo(e,HTe,(o,l)=>{let p=OBe(l.file,l.start,s);if(!p)return;let{typeNode:m,type:S}=p,h=m.kind===321&&t===uie?s.getNullableType(S,32768):S;wBe(o,i,m,h,s)})}})}});function RBe(e,t,n){e.replaceNodeWithText(t,n,`${n.text}()`)}function MBe(e,t){let n=Ts(e,t);if(Hn(n.parent)){let i=n.parent;for(;Hn(i.parent);)i=i.parent;return i.name}if(ze(n))return n}var _ie,YTe,hDt=f({"src/services/codefixes/fixMissingCallParentheses.ts"(){"use strict";yi(),Ma(),_ie="fixMissingCallParentheses",YTe=[g.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead.code],wa({errorCodes:YTe,fixIds:[_ie],getCodeActions(e){let{sourceFile:t,span:n}=e,i=MBe(t,n.start);if(!i)return;let s=En.ChangeTracker.with(e,o=>RBe(o,e.sourceFile,i));return[ma(_ie,s,g.Add_missing_call_parentheses,_ie,g.Add_all_missing_call_parentheses)]},getAllCodeActions:e=>Fo(e,YTe,(t,n)=>{let i=MBe(n.file,n.start);i&&RBe(t,n.file,i)})})}});function yDt(e){if(e.type)return e.type;if(Gi(e.parent)&&e.parent.type&&Vh(e.parent.type))return e.parent.type.type}function LBe(e,t){let n=Ts(e,t),i=Vp(n);if(!i)return;let s;switch(i.kind){case 174:s=i.name;break;case 262:case 218:s=Oo(i,100,e);break;case 219:let o=i.typeParameters?30:21;s=Oo(i,o,e)||di(i.parameters);break;default:return}return s&&{insertBefore:s,returnType:yDt(i)}}function FBe(e,t,{insertBefore:n,returnType:i}){if(i){let s=C8(i);(!s||s.kind!==80||s.text!=="Promise")&&e.replaceNode(t,i,j.createTypeReferenceNode("Promise",j.createNodeArray([i])))}e.insertModifierBefore(t,134,n)}var fie,XTe,vDt=f({"src/services/codefixes/fixAwaitInSyncFunction.ts"(){"use strict";yi(),Ma(),fie="fixAwaitInSyncFunction",XTe=[g.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,g.await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,g.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,g.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function.code],wa({errorCodes:XTe,getCodeActions(e){let{sourceFile:t,span:n}=e,i=LBe(t,n.start);if(!i)return;let s=En.ChangeTracker.with(e,o=>FBe(o,t,i));return[ma(fie,s,g.Add_async_modifier_to_containing_function,fie,g.Add_all_missing_async_modifiers)]},fixIds:[fie],getAllCodeActions:function(t){let n=new Map;return Fo(t,XTe,(i,s)=>{let o=LBe(s.file,s.start);!o||!Bm(n,yo(o.insertBefore))||FBe(i,t.sourceFile,o)})}})}});function jBe(e,t,n,i,s){let o,l;if(i===g._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code)o=t,l=t+n;else if(i===g._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code){let p=s.program.getTypeChecker(),m=Ts(e,t).parent;I.assert(Mv(m),"error span of fixPropertyOverrideAccessor should only be on an accessor");let S=m.parent;I.assert(Ti(S),"erroneous accessors should only be inside classes");let h=nl(dbe(S,p));if(!h)return[];let b=Zi(iN(m.name)),A=p.getPropertyOfType(p.getTypeAtLocation(h),b);if(!A||!A.valueDeclaration)return[];o=A.valueDeclaration.pos,l=A.valueDeclaration.end,e=Xr(A.valueDeclaration)}else I.fail("fixPropertyOverrideAccessor codefix got unexpected error code "+i);return ZBe(e,s.program,o,l,s,g.Generate_get_and_set_accessors.message)}var KTe,pie,SDt=f({"src/services/codefixes/fixPropertyOverrideAccessor.ts"(){"use strict";yi(),Ma(),KTe=[g._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code,g._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code],pie="fixPropertyOverrideAccessor",wa({errorCodes:KTe,getCodeActions(e){let t=jBe(e.sourceFile,e.span.start,e.span.length,e.errorCode,e);if(t)return[ma(pie,t,g.Generate_get_and_set_accessors,pie,g.Generate_get_and_set_accessors_for_all_overriding_properties)]},fixIds:[pie],getAllCodeActions:e=>Fo(e,KTe,(t,n)=>{let i=jBe(n.file,n.start,n.length,n.code,e);if(i)for(let s of i)t.pushRaw(e.sourceFile,s)})})}});function TDt(e,t){switch(e){case g.Parameter_0_implicitly_has_an_1_type.code:case g.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return pp(Vp(t))?g.Infer_type_of_0_from_usage:g.Infer_parameter_types_from_usage;case g.Rest_parameter_0_implicitly_has_an_any_type.code:case g.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:return g.Infer_parameter_types_from_usage;case g.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:return g.Infer_this_type_of_0_from_usage;default:return g.Infer_type_of_0_from_usage}}function bDt(e){switch(e){case g.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code:return g.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code;case g.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return g.Variable_0_implicitly_has_an_1_type.code;case g.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return g.Parameter_0_implicitly_has_an_1_type.code;case g.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:return g.Rest_parameter_0_implicitly_has_an_any_type.code;case g.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code:return g.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code;case g._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code:return g._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code;case g.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code:return g.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code;case g.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:return g.Member_0_implicitly_has_an_1_type.code}return e}function BBe(e,t,n,i,s,o,l,p,m){if(!Rw(n.kind)&&n.kind!==80&&n.kind!==26&&n.kind!==110)return;let{parent:S}=n,h=Ck(t,s,m,p);switch(i=bDt(i),i){case g.Member_0_implicitly_has_an_1_type.code:case g.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code:if(Gi(S)&&l(S)||ea(S)||fp(S))return UBe(e,h,t,S,s,p,o),h.writeFixes(e),S;if(Hn(S)){let k=B7(S.name,s,o),N=wO(k,S,s,p);if(N){let M=j.createJSDocTypeTag(void 0,j.createJSDocTypeExpression(N),void 0);e.addJSDocTags(t,ta(S.parent.parent,Ou),[M])}return h.writeFixes(e),S}return;case g.Variable_0_implicitly_has_an_1_type.code:{let k=s.getTypeChecker().getSymbolAtLocation(n);return k&&k.valueDeclaration&&Gi(k.valueDeclaration)&&l(k.valueDeclaration)?(UBe(e,h,Xr(k.valueDeclaration),k.valueDeclaration,s,p,o),h.writeFixes(e),k.valueDeclaration):void 0}}let b=Vp(n);if(b===void 0)return;let A;switch(i){case g.Parameter_0_implicitly_has_an_1_type.code:if(pp(b)){VBe(e,h,t,b,s,p,o),A=b;break}case g.Rest_parameter_0_implicitly_has_an_any_type.code:if(l(b)){let k=ta(S,Ls);EDt(e,h,t,k,b,s,p,o),A=k}break;case g.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code:case g._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code:sd(b)&&ze(b.name)&&(die(e,h,t,b,B7(b.name,s,o),s,p),A=b);break;case g.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code:pp(b)&&(VBe(e,h,t,b,s,p,o),A=b);break;case g.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:En.isThisTypeAnnotatable(b)&&l(b)&&(xDt(e,t,b,s,p,o),A=b);break;default:return I.fail(String(i))}return h.writeFixes(e),A}function UBe(e,t,n,i,s,o,l){ze(i.name)&&die(e,t,n,i,B7(i.name,s,l),s,o)}function EDt(e,t,n,i,s,o,l,p){if(!ze(i.name))return;let m=kDt(s,n,o,p);if(I.assert(s.parameters.length===m.length,"Parameter count and inference count should match"),gn(s))JBe(e,n,m,o,l);else{let S=rc(s)&&!Oo(s,21,n);S&&e.insertNodeBefore(n,di(s.parameters),j.createToken(21));for(let{declaration:h,type:b}of m)h&&!h.type&&!h.initializer&&die(e,t,n,h,b,o,l);S&&e.insertNodeAfter(n,Rs(s.parameters),j.createToken(22))}}function xDt(e,t,n,i,s,o){let l=qBe(n,t,i,o);if(!l||!l.length)return;let p=ZTe(i,l,o).thisParameter(),m=wO(p,n,i,s);m&&(gn(n)?CDt(e,t,n,m):e.tryInsertThisTypeAnnotation(t,n,m))}function CDt(e,t,n,i){e.addJSDocTags(t,n,[j.createJSDocThisTag(void 0,j.createJSDocTypeExpression(i))])}function VBe(e,t,n,i,s,o,l){let p=qi(i.parameters);if(p&&ze(i.name)&&ze(p.name)){let m=B7(i.name,s,l);m===s.getTypeChecker().getAnyType()&&(m=B7(p.name,s,l)),gn(i)?JBe(e,n,[{declaration:p,type:m}],s,o):die(e,t,n,p,m,s,o)}}function die(e,t,n,i,s,o,l){let p=wO(s,i,o,l);if(p)if(gn(n)&&i.kind!==171){let m=Gi(i)?ii(i.parent.parent,Xc):i;if(!m)return;let S=j.createJSDocTypeExpression(p),h=sd(i)?j.createJSDocReturnTag(void 0,S,void 0):j.createJSDocTypeTag(void 0,S,void 0);e.addJSDocTags(n,m,[h])}else ADt(p,i,n,e,t,ho(o.getCompilerOptions()))||e.tryInsertTypeAnnotation(n,i,p)}function ADt(e,t,n,i,s,o){let l=kk(e,o);return l&&i.tryInsertTypeAnnotation(n,t,l.typeNode)?(Te(l.symbols,p=>s.addImportFromExportedSymbol(p,!0)),!0):!1}function JBe(e,t,n,i,s){let o=n.length&&n[0].declaration.parent;if(!o)return;let l=Wi(n,p=>{let m=p.declaration;if(m.initializer||fT(m)||!ze(m.name))return;let S=p.type&&wO(p.type,m,i,s);if(S){let h=j.cloneNode(m.name);return Sn(h,7168),{name:j.cloneNode(m.name),param:m,isOptional:!!p.isOptional,typeNode:S}}});if(l.length)if(rc(o)||Xo(o)){let p=rc(o)&&!Oo(o,21,t);p&&e.insertNodeBefore(t,di(o.parameters),j.createToken(21)),Te(l,({typeNode:m,param:S})=>{let h=j.createJSDocTypeTag(void 0,j.createJSDocTypeExpression(m)),b=j.createJSDocComment(void 0,[h]);e.insertNodeAt(t,S.getStart(t),b,{suffix:" "})}),p&&e.insertNodeAfter(t,Rs(o.parameters),j.createToken(22))}else{let p=vr(l,({name:m,typeNode:S,isOptional:h})=>j.createJSDocParameterTag(void 0,m,!!h,j.createJSDocTypeExpression(S),!1,void 0));e.addJSDocTags(t,o,p)}}function QTe(e,t,n){return Wi(Ko.getReferenceEntriesForNode(-1,e,t,t.getSourceFiles(),n),i=>i.kind!==Ko.EntryKind.Span?ii(i.node,ze):void 0)}function B7(e,t,n){let i=QTe(e,t,n);return ZTe(t,i,n).single()}function kDt(e,t,n,i){let s=qBe(e,t,n,i);return s&&ZTe(n,s,i).parameters(e)||e.parameters.map(o=>({declaration:o,type:ze(o.name)?B7(o.name,n,i):n.getTypeChecker().getAnyType()}))}function qBe(e,t,n,i){let s;switch(e.kind){case 176:s=Oo(e,137,t);break;case 219:case 218:let o=e.parent;s=(Gi(o)||ea(o))&&ze(o.name)?o.name:e.name;break;case 262:case 174:case 173:s=e.name;break}if(s)return QTe(s,n,i)}function ZTe(e,t,n){let i=e.getTypeChecker(),s={string:()=>i.getStringType(),number:()=>i.getNumberType(),Array:Ie=>i.createArrayType(Ie),Promise:Ie=>i.createPromiseType(Ie)},o=[i.getStringType(),i.getNumberType(),i.createArrayType(i.getAnyType()),i.createPromiseType(i.getAnyType())];return{single:m,parameters:S,thisParameter:h};function l(){return{isNumber:void 0,isString:void 0,isNumberOrString:void 0,candidateTypes:void 0,properties:void 0,calls:void 0,constructs:void 0,numberIndex:void 0,stringIndex:void 0,candidateThisTypes:void 0,inferredTypes:void 0}}function p(Ie){let Re=new Map;for(let kt of Ie)kt.properties&&kt.properties.forEach((ke,$e)=>{Re.has($e)||Re.set($e,[]),Re.get($e).push(ke)});let Ue=new Map;return Re.forEach((kt,ke)=>{Ue.set(ke,p(kt))}),{isNumber:Ie.some(kt=>kt.isNumber),isString:Ie.some(kt=>kt.isString),isNumberOrString:Ie.some(kt=>kt.isNumberOrString),candidateTypes:_a(Ie,kt=>kt.candidateTypes),properties:Ue,calls:_a(Ie,kt=>kt.calls),constructs:_a(Ie,kt=>kt.constructs),numberIndex:Te(Ie,kt=>kt.numberIndex),stringIndex:Te(Ie,kt=>kt.stringIndex),candidateThisTypes:_a(Ie,kt=>kt.candidateThisTypes),inferredTypes:void 0}}function m(){return Se(b(t))}function S(Ie){if(t.length===0||!Ie.parameters)return;let Re=l();for(let kt of t)n.throwIfCancellationRequested(),A(kt,Re);let Ue=[...Re.constructs||[],...Re.calls||[]];return Ie.parameters.map((kt,ke)=>{let $e=[],at=x0(kt),$t=!1;for(let Ze of Ue)if(Ze.argumentTypes.length<=ke)$t=gn(Ie),$e.push(i.getUndefinedType());else if(at)for(let yt=ke;yt<Ze.argumentTypes.length;yt++)$e.push(i.getBaseTypeOfLiteralType(Ze.argumentTypes[yt]));else $e.push(i.getBaseTypeOfLiteralType(Ze.argumentTypes[ke]));if(ze(kt.name)){let Ze=b(QTe(kt.name,e,n));$e.push(...at?Wi(Ze,i.getElementTypeOfArrayType):Ze)}let St=Se($e);return{type:at?i.createArrayType(St):St,isOptional:$t&&!at,declaration:kt}})}function h(){let Ie=l();for(let Re of t)n.throwIfCancellationRequested(),A(Re,Ie);return Se(Ie.candidateThisTypes||tt)}function b(Ie){let Re=l();for(let Ue of Ie)n.throwIfCancellationRequested(),A(Ue,Re);return Z(Re)}function A(Ie,Re){for(;o6(Ie);)Ie=Ie.parent;switch(Ie.parent.kind){case 244:N(Ie,Re);break;case 225:Re.isNumber=!0;break;case 224:M(Ie.parent,Re);break;case 226:O(Ie,Ie.parent,Re);break;case 296:case 297:U(Ie.parent,Re);break;case 213:case 214:Ie.parent.expression===Ie?H(Ie.parent,Re):k(Ie,Re);break;case 211:K(Ie.parent,Re);break;case 212:re(Ie.parent,Ie,Re);break;case 303:case 304:$(Ie.parent,Re);break;case 172:pe(Ie.parent,Re);break;case 260:{let{name:Ue,initializer:kt}=Ie.parent;if(Ie===Ue){kt&&Ge(Re,i.getTypeAtLocation(kt));break}}default:return k(Ie,Re)}}function k(Ie,Re){k0(Ie)&&Ge(Re,i.getContextualType(Ie))}function N(Ie,Re){Ge(Re,da(Ie)?i.getVoidType():i.getAnyType())}function M(Ie,Re){switch(Ie.operator){case 46:case 47:case 41:case 55:Re.isNumber=!0;break;case 40:Re.isNumberOrString=!0;break}}function O(Ie,Re,Ue){switch(Re.operatorToken.kind){case 43:case 42:case 44:case 45:case 48:case 49:case 50:case 51:case 52:case 53:case 66:case 68:case 67:case 69:case 70:case 74:case 75:case 79:case 71:case 73:case 72:case 41:case 30:case 33:case 32:case 34:let kt=i.getTypeAtLocation(Re.left===Ie?Re.right:Re.left);kt.flags&1056?Ge(Ue,kt):Ue.isNumber=!0;break;case 65:case 40:let ke=i.getTypeAtLocation(Re.left===Ie?Re.right:Re.left);ke.flags&1056?Ge(Ue,ke):ke.flags&296?Ue.isNumber=!0:ke.flags&402653316?Ue.isString=!0:ke.flags&1||(Ue.isNumberOrString=!0);break;case 64:case 35:case 37:case 38:case 36:case 77:case 78:case 76:Ge(Ue,i.getTypeAtLocation(Re.left===Ie?Re.right:Re.left));break;case 103:Ie===Re.left&&(Ue.isString=!0);break;case 57:case 61:Ie===Re.left&&(Ie.parent.parent.kind===260||lu(Ie.parent.parent,!0))&&Ge(Ue,i.getTypeAtLocation(Re.right));break;case 56:case 28:case 104:break}}function U(Ie,Re){Ge(Re,i.getTypeAtLocation(Ie.parent.parent.expression))}function H(Ie,Re){let Ue={argumentTypes:[],return_:l()};if(Ie.arguments)for(let kt of Ie.arguments)Ue.argumentTypes.push(i.getTypeAtLocation(kt));A(Ie,Ue.return_),Ie.kind===213?(Re.calls||(Re.calls=[])).push(Ue):(Re.constructs||(Re.constructs=[])).push(Ue)}function K(Ie,Re){let Ue=Pc(Ie.name.text);Re.properties||(Re.properties=new Map);let kt=Re.properties.get(Ue)||l();A(Ie,kt),Re.properties.set(Ue,kt)}function re(Ie,Re,Ue){if(Re===Ie.argumentExpression){Ue.isNumberOrString=!0;return}else{let kt=i.getTypeAtLocation(Ie.argumentExpression),ke=l();A(Ie,ke),kt.flags&296?Ue.numberIndex=ke:Ue.stringIndex=ke}}function $(Ie,Re){let Ue=Gi(Ie.parent.parent)?Ie.parent.parent:Ie.parent;Ae(Re,i.getTypeAtLocation(Ue))}function pe(Ie,Re){Ae(Re,i.getTypeAtLocation(Ie.parent))}function z(Ie,Re){let Ue=[];for(let kt of Ie)for(let{high:ke,low:$e}of Re)ke(kt)&&(I.assert(!$e(kt),"Priority can't have both low and high"),Ue.push($e));return Ie.filter(kt=>Ue.every(ke=>!ke(kt)))}function se(Ie){return Se(Z(Ie))}function Se(Ie){if(!Ie.length)return i.getAnyType();let Re=i.getUnionType([i.getStringType(),i.getNumberType()]),kt=z(Ie,[{high:$e=>$e===i.getStringType()||$e===i.getNumberType(),low:$e=>$e===Re},{high:$e=>!($e.flags&16385),low:$e=>!!($e.flags&16385)},{high:$e=>!($e.flags&114689)&&!(Gn($e)&16),low:$e=>!!(Gn($e)&16)}]),ke=kt.filter($e=>Gn($e)&16);return ke.length&&(kt=kt.filter($e=>!(Gn($e)&16)),kt.push(xe(ke))),i.getWidenedType(i.getUnionType(kt.map(i.getBaseTypeOfLiteralType),2))}function xe(Ie){if(Ie.length===1)return Ie[0];let Re=[],Ue=[],kt=[],ke=[],$e=!1,at=!1,$t=g_();for(let yt of Ie){for(let Fr of i.getPropertiesOfType(yt))$t.add(Fr.escapedName,Fr.valueDeclaration?i.getTypeOfSymbolAtLocation(Fr,Fr.valueDeclaration):i.getAnyType());Re.push(...i.getSignaturesOfType(yt,0)),Ue.push(...i.getSignaturesOfType(yt,1));let ar=i.getIndexInfoOfType(yt,0);ar&&(kt.push(ar.type),$e=$e||ar.isReadonly);let or=i.getIndexInfoOfType(yt,1);or&&(ke.push(or.type),at=at||or.isReadonly)}let St=Fg($t,(yt,ar)=>{let or=ar.length<Ie.length?16777216:0,Fr=i.createSymbol(4|or,yt);return Fr.links.type=i.getUnionType(ar),[yt,Fr]}),Ze=[];return kt.length&&Ze.push(i.createIndexInfo(i.getStringType(),i.getUnionType(kt),$e)),ke.length&&Ze.push(i.createIndexInfo(i.getNumberType(),i.getUnionType(ke),at)),i.createAnonymousType(Ie[0].symbol,St,Re,Ue,Ze)}function Z(Ie){var Re,Ue,kt;let ke=[];Ie.isNumber&&ke.push(i.getNumberType()),Ie.isString&&ke.push(i.getStringType()),Ie.isNumberOrString&&ke.push(i.getUnionType([i.getStringType(),i.getNumberType()])),Ie.numberIndex&&ke.push(i.createArrayType(se(Ie.numberIndex))),((Re=Ie.properties)!=null&&Re.size||(Ue=Ie.constructs)!=null&&Ue.length||Ie.stringIndex)&&ke.push(Q(Ie));let $e=(Ie.candidateTypes||[]).map($t=>i.getBaseTypeOfLiteralType($t)),at=(kt=Ie.calls)!=null&&kt.length?Q(Ie):void 0;return at&&$e?ke.push(i.getUnionType([at,...$e],2)):(at&&ke.push(at),de($e)&&ke.push(...$e)),ke.push(...ce(Ie)),ke}function Q(Ie){let Re=new Map;Ie.properties&&Ie.properties.forEach(($e,at)=>{let $t=i.createSymbol(4,at);$t.links.type=se($e),Re.set(at,$t)});let Ue=Ie.calls?[Me(Ie.calls)]:[],kt=Ie.constructs?[Me(Ie.constructs)]:[],ke=Ie.stringIndex?[i.createIndexInfo(i.getStringType(),se(Ie.stringIndex),!1)]:[];return i.createAnonymousType(void 0,Re,Ue,kt,ke)}function ce(Ie){if(!Ie.properties||!Ie.properties.size)return[];let Re=o.filter(Ue=>ye(Ue,Ie));return 0<Re.length&&Re.length<3?Re.map(Ue=>we(Ue,Ie)):[]}function ye(Ie,Re){return Re.properties?!yu(Re.properties,(Ue,kt)=>{let ke=i.getTypeOfPropertyOfType(Ie,kt);return ke?Ue.calls?!i.getSignaturesOfType(ke,0).length||!i.isTypeAssignableTo(ke,Ee(Ue.calls)):!i.isTypeAssignableTo(ke,se(Ue)):!0}):!1}function we(Ie,Re){if(!(Gn(Ie)&4)||!Re.properties)return Ie;let Ue=Ie.target,kt=nl(Ue.typeParameters);if(!kt)return Ie;let ke=[];return Re.properties.forEach(($e,at)=>{let $t=i.getTypeOfPropertyOfType(Ue,at);I.assert(!!$t,"generic should have all the properties of its reference."),ke.push(...ve($t,se($e),kt))}),s[Ie.symbol.escapedName](Se(ke))}function ve(Ie,Re,Ue){if(Ie===Ue)return[Re];if(Ie.flags&3145728)return _a(Ie.types,$e=>ve($e,Re,Ue));if(Gn(Ie)&4&&Gn(Re)&4){let $e=i.getTypeArguments(Ie),at=i.getTypeArguments(Re),$t=[];if($e&&at)for(let St=0;St<$e.length;St++)at[St]&&$t.push(...ve($e[St],at[St],Ue));return $t}let kt=i.getSignaturesOfType(Ie,0),ke=i.getSignaturesOfType(Re,0);return kt.length===1&&ke.length===1?oe(kt[0],ke[0],Ue):[]}function oe(Ie,Re,Ue){var kt;let ke=[];for(let $t=0;$t<Ie.parameters.length;$t++){let St=Ie.parameters[$t],Ze=Re.parameters[$t],yt=Ie.declaration&&x0(Ie.declaration.parameters[$t]);if(!Ze)break;let ar=St.valueDeclaration?i.getTypeOfSymbolAtLocation(St,St.valueDeclaration):i.getAnyType(),or=yt&&i.getElementTypeOfArrayType(ar);or&&(ar=or);let Fr=((kt=ii(Ze,Rh))==null?void 0:kt.links.type)||(Ze.valueDeclaration?i.getTypeOfSymbolAtLocation(Ze,Ze.valueDeclaration):i.getAnyType());ke.push(...ve(ar,Fr,Ue))}let $e=i.getReturnTypeOfSignature(Ie),at=i.getReturnTypeOfSignature(Re);return ke.push(...ve($e,at,Ue)),ke}function Ee(Ie){return i.createAnonymousType(void 0,ga(),[Me(Ie)],tt,tt)}function Me(Ie){let Re=[],Ue=Math.max(...Ie.map(ke=>ke.argumentTypes.length));for(let ke=0;ke<Ue;ke++){let $e=i.createSymbol(1,Pc(`arg${ke}`));$e.links.type=Se(Ie.map(at=>at.argumentTypes[ke]||i.getUndefinedType())),Ie.some(at=>at.argumentTypes[ke]===void 0)&&($e.flags|=16777216),Re.push($e)}let kt=se(p(Ie.map(ke=>ke.return_)));return i.createSignature(void 0,void 0,void 0,Re,kt,void 0,Ue,0)}function Ge(Ie,Re){Re&&!(Re.flags&1)&&!(Re.flags&131072)&&(Ie.candidateTypes||(Ie.candidateTypes=[])).push(Re)}function Ae(Ie,Re){Re&&!(Re.flags&1)&&!(Re.flags&131072)&&(Ie.candidateThisTypes||(Ie.candidateThisTypes=[])).push(Re)}}var mie,ebe,PDt=f({"src/services/codefixes/inferFromUsage.ts"(){"use strict";yi(),Ma(),mie="inferFromUsage",ebe=[g.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code,g.Variable_0_implicitly_has_an_1_type.code,g.Parameter_0_implicitly_has_an_1_type.code,g.Rest_parameter_0_implicitly_has_an_any_type.code,g.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code,g._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code,g.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code,g.Member_0_implicitly_has_an_1_type.code,g.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code,g.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,g.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,g.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code,g.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code,g._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code,g.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code,g.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,g.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code],wa({errorCodes:ebe,getCodeActions(e){let{sourceFile:t,program:n,span:{start:i},errorCode:s,cancellationToken:o,host:l,preferences:p}=e,m=Ts(t,i),S,h=En.ChangeTracker.with(e,A=>{S=BBe(A,t,m,s,n,o,em,l,p)}),b=S&&qs(S);return!b||h.length===0?void 0:[ma(mie,h,[TDt(s,m),Fl(b)],mie,g.Infer_all_types_from_usage)]},fixIds:[mie],getAllCodeActions(e){let{sourceFile:t,program:n,cancellationToken:i,host:s,preferences:o}=e,l=yk();return Fo(e,ebe,(p,m)=>{BBe(p,t,Ts(m.file,m.start),m.code,n,i,l,s,o)})}})}});function zBe(e,t,n){if(gn(e))return;let i=Ts(e,n),s=Gr(i,tc),o=s?.type;if(!o)return;let l=t.getTypeFromTypeNode(o),p=t.getAwaitedType(l)||t.getVoidType(),m=t.typeToTypeNode(p,o,void 0);if(m)return{returnTypeNode:o,returnType:l,promisedTypeNode:m,promisedType:p}}function $Be(e,t,n,i){e.replaceNode(t,n,j.createTypeReferenceNode("Promise",[i]))}var gie,tbe,NDt=f({"src/services/codefixes/fixReturnTypeInAsyncFunction.ts"(){"use strict";yi(),Ma(),gie="fixReturnTypeInAsyncFunction",tbe=[g.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0.code],wa({errorCodes:tbe,fixIds:[gie],getCodeActions:function(t){let{sourceFile:n,program:i,span:s}=t,o=i.getTypeChecker(),l=zBe(n,i.getTypeChecker(),s.start);if(!l)return;let{returnTypeNode:p,returnType:m,promisedTypeNode:S,promisedType:h}=l,b=En.ChangeTracker.with(t,A=>$Be(A,n,p,S));return[ma(gie,b,[g.Replace_0_with_Promise_1,o.typeToString(m),o.typeToString(h)],gie,g.Fix_all_incorrect_return_type_of_an_async_functions)]},getAllCodeActions:e=>Fo(e,tbe,(t,n)=>{let i=zBe(n.file,e.program.getTypeChecker(),n.start);i&&$Be(t,n.file,i.returnTypeNode,i.promisedTypeNode)})})}});function WBe(e,t,n,i){let{line:s}=Lo(t,n);(!i||Zd(i,s))&&e.insertCommentBeforeLine(t,s,n," @ts-ignore")}var rbe,nbe,ibe,DDt=f({"src/services/codefixes/disableJsDiagnostics.ts"(){"use strict";yi(),Ma(),rbe="disableJsDiagnostics",nbe="disableJsDiagnostics",ibe=Wi(Object.keys(g),e=>{let t=g[e];return t.category===1?t.code:void 0}),wa({errorCodes:ibe,getCodeActions:function(t){let{sourceFile:n,program:i,span:s,host:o,formatContext:l}=t;if(!gn(n)||!uR(n,i.getCompilerOptions()))return;let p=n.checkJsDirective?"":q1(o,l.options),m=[hg(rbe,[H5e(n.fileName,[e7(n.checkJsDirective?Ll(n.checkJsDirective.pos,n.checkJsDirective.end):e_(0,0),`// @ts-nocheck${p}`)])],g.Disable_checking_for_this_file)];return En.isValidLocationToAddComment(n,s.start)&&m.unshift(ma(rbe,En.ChangeTracker.with(t,S=>WBe(S,n,s.start)),g.Ignore_this_error_message,nbe,g.Add_ts_ignore_to_all_error_messages)),m},fixIds:[nbe],getAllCodeActions:e=>{let t=new Set;return Fo(e,ibe,(n,i)=>{En.isValidLocationToAddComment(i.file,i.start)&&WBe(n,i.file,i.start,t)})}})}});function sbe(e,t,n,i,s,o,l){let p=e.symbol.members;for(let m of t)p.has(m.escapedName)||GBe(m,e,n,i,s,o,l,void 0)}function jD(e){return{trackSymbol:()=>!1,moduleResolverHost:bte(e.program,e.host)}}function GBe(e,t,n,i,s,o,l,p,m=3,S=!1){let h=e.getDeclarations(),b=qi(h),A=i.program.getTypeChecker(),k=ho(i.program.getCompilerOptions()),N=b?.kind??171,M=ce(e,b),O=b?X_(b):0,U=O&256;U|=O&1?1:O&4?4:0,b&&Af(b)&&(U|=512);let H=se(),K=A.getWidenedType(A.getTypeOfSymbolAtLocation(e,t)),re=!!(e.flags&16777216),$=!!(t.flags&33554432)||S,pe=_d(n,s);switch(N){case 171:case 172:let ye=pe===0?268435456:void 0,we=A.typeToTypeNode(K,t,ye,jD(i));if(o){let oe=kk(we,k);oe&&(we=oe.typeNode,BD(o,oe.symbols))}l(j.createPropertyDeclaration(H,b?xe(M):e.getName(),re&&m&2?j.createToken(58):void 0,we,void 0));break;case 177:case 178:{I.assertIsDefined(h);let oe=A.typeToTypeNode(K,t,void 0,jD(i)),Ee=tx(h,b),Me=Ee.secondAccessor?[Ee.firstAccessor,Ee.secondAccessor]:[Ee.firstAccessor];if(o){let Ge=kk(oe,k);Ge&&(oe=Ge.typeNode,BD(o,Ge.symbols))}for(let Ge of Me)if(sd(Ge))l(j.createGetAccessorDeclaration(H,xe(M),tt,Q(oe),Z(p,pe,$)));else{I.assertNode(Ge,pp,"The counterpart to a getter should be a setter");let Ae=n6(Ge),Ie=Ae&&ze(Ae.name)?Nn(Ae.name):void 0;l(j.createSetAccessorDeclaration(H,xe(M),obe(1,[Ie],[Q(oe)],1,!1),Z(p,pe,$)))}break}case 173:case 174:I.assertIsDefined(h);let ve=K.isUnion()?_a(K.types,oe=>oe.getCallSignatures()):K.getCallSignatures();if(!Tt(ve))break;if(h.length===1){I.assert(ve.length===1,"One declaration implies one signature");let oe=ve[0];z(pe,oe,H,xe(M),Z(p,pe,$));break}for(let oe of ve)z(pe,oe,H,xe(M));if(!$)if(h.length>ve.length){let oe=A.getSignatureFromDeclaration(h[h.length-1]);z(pe,oe,H,xe(M),Z(p,pe))}else I.assert(h.length===ve.length,"Declarations and signatures should match count"),l(ODt(A,i,t,ve,xe(M),re&&!!(m&1),H,pe,p));break}function z(ye,we,ve,oe,Ee){let Me=hie(174,i,ye,we,Ee,oe,ve,re&&!!(m&1),t,o);Me&&l(Me)}function se(){let ye;return U&&(ye=Cv(ye,j.createModifiersFromModifierFlags(U))),Se()&&(ye=Pr(ye,j.createToken(164))),ye&&j.createNodeArray(ye)}function Se(){return!!(i.program.getCompilerOptions().noImplicitOverride&&b&&tE(b))}function xe(ye){return ze(ye)&&ye.escapedText==="constructor"?j.createComputedPropertyName(j.createStringLiteral(Nn(ye),pe===0)):Sc(ye,!1)}function Z(ye,we,ve){return ve?void 0:Sc(ye,!1)||cbe(we)}function Q(ye){return Sc(ye,!1)}function ce(ye,we){if(Vc(ye)&262144){let ve=ye.links.nameType;if(ve&&um(ve))return j.createIdentifier(Zi(_m(ve)))}return Sc(qs(we),!1)}}function hie(e,t,n,i,s,o,l,p,m,S){let h=t.program,b=h.getTypeChecker(),A=ho(h.getCompilerOptions()),k=gn(m),N=524545|(n===0?268435456:0),M=b.signatureToSignatureDeclaration(i,e,m,N,jD(t));if(!M)return;let O=k?void 0:M.typeParameters,U=M.parameters,H=k?void 0:M.type;if(S){if(O){let pe=ul(O,z=>{let se=z.constraint,Se=z.default;if(se){let xe=kk(se,A);xe&&(se=xe.typeNode,BD(S,xe.symbols))}if(Se){let xe=kk(Se,A);xe&&(Se=xe.typeNode,BD(S,xe.symbols))}return j.updateTypeParameterDeclaration(z,z.modifiers,z.name,se,Se)});O!==pe&&(O=ft(j.createNodeArray(pe,O.hasTrailingComma),O))}let $=ul(U,pe=>{let z=k?void 0:pe.type;if(z){let se=kk(z,A);se&&(z=se.typeNode,BD(S,se.symbols))}return j.updateParameterDeclaration(pe,pe.modifiers,pe.dotDotDotToken,pe.name,k?void 0:pe.questionToken,z,pe.initializer)});if(U!==$&&(U=ft(j.createNodeArray($,U.hasTrailingComma),U)),H){let pe=kk(H,A);pe&&(H=pe.typeNode,BD(S,pe.symbols))}}let K=p?j.createToken(58):void 0,re=M.asteriskToken;if(Xo(M))return j.updateFunctionExpression(M,l,M.asteriskToken,ii(o,ze),O,U,H,s??M.body);if(rc(M))return j.updateArrowFunction(M,l,O,U,H,M.equalsGreaterThanToken,s??M.body);if(pl(M))return j.updateMethodDeclaration(M,l,re,o??j.createIdentifier(""),K,O,U,H,s);if(Zl(M))return j.updateFunctionDeclaration(M,l,M.asteriskToken,ii(o,ze),O,U,H,s??M.body)}function abe(e,t,n,i,s,o,l){let p=_d(t.sourceFile,t.preferences),m=ho(t.program.getCompilerOptions()),S=jD(t),h=t.program.getTypeChecker(),b=gn(l),{typeArguments:A,arguments:k,parent:N}=i,M=b?void 0:h.getContextualType(i),O=vr(k,Se=>ze(Se)?Se.text:Hn(Se)&&ze(Se.name)?Se.name.text:void 0),U=b?[]:vr(k,Se=>h.getTypeAtLocation(Se)),{argumentTypeNodes:H,argumentTypeParameters:K}=XBe(h,n,U,l,m,1,S),re=o?j.createNodeArray(j.createModifiersFromModifierFlags(o)):void 0,$=sU(N)?j.createToken(42):void 0,pe=b?void 0:IDt(h,K,A),z=obe(k.length,O,H,void 0,b),se=b||M===void 0?void 0:h.typeToTypeNode(M,l,void 0,S);switch(e){case 174:return j.createMethodDeclaration(re,$,s,void 0,pe,z,se,cbe(p));case 173:return j.createMethodSignature(re,s,void 0,pe,z,se===void 0?j.createKeywordTypeNode(159):se);case 262:return I.assert(typeof s=="string"||ze(s),"Unexpected name"),j.createFunctionDeclaration(re,$,s,pe,z,se,Aq(g.Function_not_implemented.message,p));default:I.fail("Unexpected kind")}}function IDt(e,t,n){let i=new Set(t.map(o=>o[0])),s=new Map(t);if(n){let o=n.filter(p=>!t.some(m=>{var S;return e.getTypeAtLocation(p)===((S=m[1])==null?void 0:S.argumentType)})),l=i.size+o.length;for(let p=0;i.size<l;p+=1)i.add(HBe(p))}return In(i.values(),o=>{var l;return j.createTypeParameterDeclaration(void 0,o,(l=s.get(o))==null?void 0:l.constraint)})}function HBe(e){return 84+e<=90?String.fromCharCode(84+e):`T${e}`}function yie(e,t,n,i,s,o,l){let p=e.typeToTypeNode(n,i,o,l);if(p&&M0(p)){let m=kk(p,s);m&&(BD(t,m.symbols),p=m.typeNode)}return Sc(p)}function YBe(e){return e.isUnionOrIntersection()?e.types.some(YBe):e.flags&262144}function XBe(e,t,n,i,s,o,l){let p=[],m=new Map;for(let S=0;S<n.length;S+=1){let h=n[S];if(h.isUnionOrIntersection()&&h.types.some(YBe)){let M=HBe(S);p.push(j.createTypeReferenceNode(M)),m.set(M,void 0);continue}let b=e.getBaseTypeOfLiteralType(h),A=yie(e,t,b,i,s,o,l);if(!A)continue;p.push(A);let k=KBe(h),N=h.isTypeParameter()&&h.constraint&&!wDt(h.constraint)?yie(e,t,h.constraint,i,s,o,l):void 0;k&&m.set(k,{argumentType:h,constraint:N})}return{argumentTypeNodes:p,argumentTypeParameters:In(m.entries())}}function wDt(e){return e.flags&524288&&e.objectFlags===16}function KBe(e){var t;if(e.flags&3145728)for(let n of e.types){let i=KBe(n);if(i)return i}return e.flags&262144?(t=e.getSymbol())==null?void 0:t.getName():void 0}function obe(e,t,n,i,s){let o=[],l=new Map;for(let p=0;p<e;p++){let m=t?.[p]||`arg${p}`,S=l.get(m);l.set(m,(S||0)+1);let h=j.createParameterDeclaration(void 0,void 0,m+(S||""),i!==void 0&&p>=i?j.createToken(58):void 0,s?void 0:n?.[p]||j.createKeywordTypeNode(159),void 0);o.push(h)}return o}function ODt(e,t,n,i,s,o,l,p,m){let S=i[0],h=i[0].minArgumentCount,b=!1;for(let M of i)h=Math.min(M.minArgumentCount,h),L_(M)&&(b=!0),M.parameters.length>=S.parameters.length&&(!L_(M)||L_(S))&&(S=M);let A=S.parameters.length-(L_(S)?1:0),k=S.parameters.map(M=>M.name),N=obe(A,k,void 0,h,!1);if(b){let M=j.createParameterDeclaration(void 0,j.createToken(26),k[A]||"rest",A>=h?j.createToken(58):void 0,j.createArrayTypeNode(j.createKeywordTypeNode(159)),void 0);N.push(M)}return MDt(l,s,o,void 0,N,RDt(i,e,t,n),p,m)}function RDt(e,t,n,i){if(de(e)){let s=t.getUnionType(vr(e,t.getReturnTypeOfSignature));return t.typeToTypeNode(s,i,1,jD(n))}}function MDt(e,t,n,i,s,o,l,p){return j.createMethodDeclaration(e,void 0,t,n?j.createToken(58):void 0,i,s,o,p||cbe(l))}function cbe(e){return Aq(g.Method_not_implemented.message,e)}function Aq(e,t){return j.createBlock([j.createThrowStatement(j.createNewExpression(j.createIdentifier("Error"),void 0,[j.createStringLiteral(e,t===0)]))],!0)}function lbe(e,t,n){let i=qw(t);if(!i)return;let s=_be(i,"compilerOptions");if(s===void 0){e.insertNodeAtObjectStart(t,i,vie("compilerOptions",j.createObjectLiteralExpression(n.map(([l,p])=>vie(l,p)),!0)));return}let o=s.initializer;if(Ha(o))for(let[l,p]of n){let m=_be(o,l);m===void 0?e.insertNodeAtObjectStart(t,o,vie(l,p)):e.replaceNode(t,m.initializer,p)}}function ube(e,t,n,i){lbe(e,t,[[n,i]])}function vie(e,t){return j.createPropertyAssignment(j.createStringLiteral(e),t)}function _be(e,t){return mr(e.properties,n=>Ul(n)&&!!n.name&&za(n.name)&&n.name.text===t)}function kk(e,t){let n,i=nt(e,s,es);if(n&&i)return{typeNode:i,symbols:n};function s(o){if(Vv(o)&&o.qualifier){let l=Jp(o.qualifier),p=wJ(l.symbol,t),m=p!==l.text?QBe(o.qualifier,j.createIdentifier(p)):o.qualifier;n=Pr(n,l.symbol);let S=Hr(o.typeArguments,s,es);return j.createTypeReferenceNode(m,S)}return wr(o,s,void 0)}}function QBe(e,t){return e.kind===80?t:j.createQualifiedName(QBe(e.left,t),e.right)}function BD(e,t){t.forEach(n=>e.addImportFromExportedSymbol(n,!0))}function fbe(e,t){let n=gl(t),i=Ts(e,t.start);for(;i.end<n;)i=i.parent;return i}var pbe,LDt=f({"src/services/codefixes/helpers.ts"(){"use strict";yi(),pbe=(e=>(e[e.Method=1]="Method",e[e.Property=2]="Property",e[e.All=3]="All",e))(pbe||{})}});function ZBe(e,t,n,i,s,o){let l=rUe(e,t,n,i);if(!l||bk.isRefactorErrorInfo(l))return;let p=En.ChangeTracker.fromContext(s),{isStatic:m,isReadonly:S,fieldName:h,accessorName:b,originalName:A,type:k,container:N,declaration:M}=l;hp(h),hp(b),hp(M),hp(N);let O,U;if(Ti(N)){let K=X_(M);if(Y_(e)){let re=j.createModifiersFromModifierFlags(K);O=re,U=re}else O=j.createModifiersFromModifierFlags(BDt(K)),U=j.createModifiersFromModifierFlags(UDt(K));yx(M)&&(U=ys(wv(M),U))}$Dt(p,e,M,k,h,U);let H=VDt(h,b,k,O,m,N);if(hp(H),nUe(p,e,H,M,N),S){let K=I0(N);K&&WDt(p,e,K,h.text,A)}else{let K=JDt(h,b,k,O,m,N);hp(K),nUe(p,e,K,M,N)}return p.getChanges()}function FDt(e){return ze(e)||za(e)}function jDt(e){return op(e,e.parent)||ea(e)||Ul(e)}function eUe(e,t){return ze(t)?j.createIdentifier(e):j.createStringLiteral(e)}function tUe(e,t,n){let i=t?n.name:j.createThis();return ze(e)?j.createPropertyAccessExpression(i,e):j.createElementAccessExpression(i,j.createStringLiteralFromNode(e))}function BDt(e){return e&=-9,e&=-3,e&4||(e|=1),e}function UDt(e){return e&=-2,e&=-5,e|=2,e}function rUe(e,t,n,i,s=!0){let o=Ts(e,n),l=n===i&&s,p=Gr(o.parent,jDt),m=271;if(!p||!(tJ(p.name,e,n,i)||l))return{error:Gs(g.Could_not_find_property_for_which_to_generate_accessor)};if(!FDt(p.name))return{error:Gs(g.Name_is_not_valid)};if((X_(p)&98303|m)!==m)return{error:Gs(g.Can_only_convert_property_with_modifier)};let S=p.name.text,h=Gte(S),b=eUe(h?S:Nx(`_${S}`,e),p.name),A=eUe(h?Nx(S.substring(1),e):S,p.name);return{isStatic:jl(p),isReadonly:i6(p),type:GDt(p,t),container:p.kind===169?p.parent.parent:p.parent,originalName:p.name.text,declaration:p,fieldName:b,accessorName:A,renameAccessor:h}}function VDt(e,t,n,i,s,o){return j.createGetAccessorDeclaration(i,t,[],n,j.createBlock([j.createReturnStatement(tUe(e,s,o))],!0))}function JDt(e,t,n,i,s,o){return j.createSetAccessorDeclaration(i,t,[j.createParameterDeclaration(void 0,void 0,j.createIdentifier("value"),void 0,n)],j.createBlock([j.createExpressionStatement(j.createAssignment(tUe(e,s,o),j.createIdentifier("value")))],!0))}function qDt(e,t,n,i,s,o){let l=j.updatePropertyDeclaration(n,o,s,n.questionToken||n.exclamationToken,i,n.initializer);e.replaceNode(t,n,l)}function zDt(e,t,n,i){let s=j.updatePropertyAssignment(n,i,n.initializer);(s.modifiers||s.questionToken||s.exclamationToken)&&(s===n&&(s=j.cloneNode(s)),s.modifiers=void 0,s.questionToken=void 0,s.exclamationToken=void 0),e.replacePropertyAssignment(t,n,s)}function $Dt(e,t,n,i,s,o){ea(n)?qDt(e,t,n,i,s,o):Ul(n)?zDt(e,t,n,s):e.replaceNode(t,n,j.updateParameterDeclaration(n,o,n.dotDotDotToken,ta(s,ze),n.questionToken,n.type,n.initializer))}function nUe(e,t,n,i,s){op(i,i.parent)?e.insertMemberAtStart(t,s,n):Ul(i)?e.insertNodeAfterComma(t,i,n):e.insertNodeAfter(t,i,n)}function WDt(e,t,n,i,s){n.body&&n.body.forEachChild(function o(l){fc(l)&&l.expression.kind===110&&za(l.argumentExpression)&&l.argumentExpression.text===s&&wA(l)&&e.replaceNode(t,l.argumentExpression,j.createStringLiteral(i)),Hn(l)&&l.expression.kind===110&&l.name.text===s&&wA(l)&&e.replaceNode(t,l.name,j.createIdentifier(i)),!ca(l)&&!Ti(l)&&l.forEachChild(o)})}function GDt(e,t){let n=qde(e);if(ea(e)&&n&&e.questionToken){let i=t.getTypeChecker(),s=i.getTypeFromTypeNode(n);if(!i.isTypeAssignableTo(i.getUndefinedType(),s)){let o=Kv(n)?n.types:[n];return j.createUnionTypeNode([...o,j.createKeywordTypeNode(157)])}}return n}function dbe(e,t){let n=[];for(;e;){let i=Xb(e),s=i&&t.getSymbolAtLocation(i.expression);if(!s)break;let o=s.flags&2097152?t.getAliasedSymbol(s):s,l=o.declarations&&mr(o.declarations,Ti);if(!l)break;n.push(l),e=l}return n}var HDt=f({"src/services/codefixes/generateAccessors.ts"(){"use strict";yi()}});function YDt(e,t){let n=Xr(t),i=gN(t),s=e.program.getCompilerOptions(),o=[];return o.push(iUe(e,n,t,J1(i.name,void 0,t.moduleSpecifier,_d(n,e.preferences)))),T_(s)===1&&o.push(iUe(e,n,t,j.createImportEqualsDeclaration(void 0,!1,i.name,j.createExternalModuleReference(t.moduleSpecifier)))),o}function iUe(e,t,n,i){let s=En.ChangeTracker.with(e,o=>o.replaceNode(t,n,i));return hg(mbe,s,[g.Replace_import_with_0,s[0].textChanges[0].newText])}function XDt(e){let t=e.sourceFile,n=g.This_expression_is_not_callable.code===e.errorCode?213:214,i=Gr(Ts(t,e.span.start),o=>o.kind===n);if(!i)return[];let s=i.expression;return sUe(e,s)}function KDt(e){let t=e.sourceFile,n=Gr(Ts(t,e.span.start),i=>i.getStart()===e.span.start&&i.getEnd()===e.span.start+e.span.length);return n?sUe(e,n):[]}function sUe(e,t){let n=e.program.getTypeChecker().getTypeAtLocation(t);if(!(n.symbol&&Rh(n.symbol)&&n.symbol.links.originatingImport))return[];let i=[],s=n.symbol.links.originatingImport;if(Up(s)||jt(i,YDt(e,s)),bt(t)&&!(W_(t.parent)&&t.parent.name===t)){let o=e.sourceFile,l=En.ChangeTracker.with(e,p=>p.replaceNode(o,t,j.createPropertyAccessExpression(t,"default"),{}));i.push(hg(mbe,l,g.Use_synthetic_default_member))}return i}var mbe,QDt=f({"src/services/codefixes/fixInvalidImportSyntax.ts"(){"use strict";yi(),Ma(),mbe="invalidImportSyntax",wa({errorCodes:[g.This_expression_is_not_callable.code,g.This_expression_is_not_constructable.code],getCodeActions:XDt}),wa({errorCodes:[g.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,g.Type_0_does_not_satisfy_the_constraint_1.code,g.Type_0_is_not_assignable_to_type_1.code,g.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code,g.Type_predicate_0_is_not_assignable_to_1.code,g.Property_0_of_type_1_is_not_assignable_to_2_index_type_3.code,g._0_index_type_1_is_not_assignable_to_2_index_type_3.code,g.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2.code,g.Property_0_in_type_1_is_not_assignable_to_type_2.code,g.Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property.code,g.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1.code],getCodeActions:KDt})}});function aUe(e,t){let n=Ts(e,t);if(ze(n)&&ea(n.parent)){let i=t_(n.parent);if(i)return{type:i,prop:n.parent,isJs:gn(n.parent)}}}function ZDt(e,t){if(t.isJs)return;let n=En.ChangeTracker.with(e,i=>oUe(i,e.sourceFile,t.prop));return ma(Sie,n,[g.Add_definite_assignment_assertion_to_property_0,t.prop.getText()],Tie,g.Add_definite_assignment_assertions_to_all_uninitialized_properties)}function oUe(e,t,n){hp(n);let i=j.updatePropertyDeclaration(n,n.modifiers,n.name,j.createToken(54),n.type,n.initializer);e.replaceNode(t,n,i)}function eIt(e,t){let n=En.ChangeTracker.with(e,i=>cUe(i,e.sourceFile,t));return ma(Sie,n,[g.Add_undefined_type_to_property_0,t.prop.name.getText()],bie,g.Add_undefined_type_to_all_uninitialized_properties)}function cUe(e,t,n){let i=j.createKeywordTypeNode(157),s=Kv(n.type)?n.type.types.concat(i):[n.type,i],o=j.createUnionTypeNode(s);n.isJs?e.addJSDocTags(t,n.prop,[j.createJSDocTypeTag(void 0,j.createJSDocTypeExpression(o))]):e.replaceNode(t,n.type,o)}function tIt(e,t){if(t.isJs)return;let n=e.program.getTypeChecker(),i=uUe(n,t.prop);if(!i)return;let s=En.ChangeTracker.with(e,o=>lUe(o,e.sourceFile,t.prop,i));return ma(Sie,s,[g.Add_initializer_to_property_0,t.prop.name.getText()],Eie,g.Add_initializers_to_all_uninitialized_properties)}function lUe(e,t,n,i){hp(n);let s=j.updatePropertyDeclaration(n,n.modifiers,n.name,n.questionToken,n.type,i);e.replaceNode(t,n,s)}function uUe(e,t){return _Ue(e,e.getTypeFromTypeNode(t.type))}function _Ue(e,t){if(t.flags&512)return t===e.getFalseType()||t===e.getFalseType(!0)?j.createFalse():j.createTrue();if(t.isStringLiteral())return j.createStringLiteral(t.value);if(t.isNumberLiteral())return j.createNumericLiteral(t.value);if(t.flags&2048)return j.createBigIntLiteral(t.value);if(t.isUnion())return Ct(t.types,n=>_Ue(e,n));if(t.isClass()){let n=ky(t.symbol);if(!n||ui(n,64))return;let i=I0(n);return i&&i.parameters.length?void 0:j.createNewExpression(j.createIdentifier(t.symbol.name),void 0,void 0)}else if(e.isArrayLikeType(t))return j.createArrayLiteralExpression()}var Sie,Tie,bie,Eie,gbe,rIt=f({"src/services/codefixes/fixStrictClassInitialization.ts"(){"use strict";yi(),Ma(),Sie="strictClassInitialization",Tie="addMissingPropertyDefiniteAssignmentAssertions",bie="addMissingPropertyUndefinedType",Eie="addMissingPropertyInitializer",gbe=[g.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor.code],wa({errorCodes:gbe,getCodeActions:function(t){let n=aUe(t.sourceFile,t.span.start);if(!n)return;let i=[];return Pr(i,eIt(t,n)),Pr(i,ZDt(t,n)),Pr(i,tIt(t,n)),i},fixIds:[Tie,bie,Eie],getAllCodeActions:e=>Fo(e,gbe,(t,n)=>{let i=aUe(n.file,n.start);if(i)switch(e.fixId){case Tie:oUe(t,n.file,i.prop);break;case bie:cUe(t,n.file,i);break;case Eie:let s=e.program.getTypeChecker(),o=uUe(s,i.prop);if(!o)return;lUe(t,n.file,i.prop,o);break;default:I.fail(JSON.stringify(e.fixId))}})})}});function fUe(e,t,n){let{allowSyntheticDefaults:i,defaultImportName:s,namedImports:o,statement:l,required:p}=n;e.replaceNode(t,l,s&&!i?j.createImportEqualsDeclaration(void 0,!1,s,j.createExternalModuleReference(p)):j.createImportDeclaration(void 0,j.createImportClause(!1,s,o),p,void 0))}function pUe(e,t,n){let{parent:i}=Ts(e,n);_f(i,!0)||I.failBadSyntaxKind(i);let s=ta(i.parent,Gi),o=ii(s.name,ze),l=pm(s.name)?nIt(s.name):void 0;if(o||l)return{allowSyntheticDefaults:ix(t.getCompilerOptions()),defaultImportName:o,namedImports:l,statement:ta(s.parent.parent,Xc),required:di(i.arguments)}}function nIt(e){let t=[];for(let n of e.elements){if(!ze(n.name)||n.initializer)return;t.push(j.createImportSpecifier(!1,ii(n.propertyName,ze),n.name))}if(t.length)return j.createNamedImports(t)}var xie,hbe,iIt=f({"src/services/codefixes/requireInTs.ts"(){"use strict";yi(),Ma(),xie="requireInTs",hbe=[g.require_call_may_be_converted_to_an_import.code],wa({errorCodes:hbe,getCodeActions(e){let t=pUe(e.sourceFile,e.program,e.span.start);if(!t)return;let n=En.ChangeTracker.with(e,i=>fUe(i,e.sourceFile,t));return[ma(xie,n,g.Convert_require_to_import,xie,g.Convert_all_require_to_import)]},fixIds:[xie],getAllCodeActions:e=>Fo(e,hbe,(t,n)=>{let i=pUe(n.file,e.program,n.start);i&&fUe(t,e.sourceFile,i)})})}});function dUe(e,t){let n=Ts(e,t);if(!ze(n))return;let{parent:i}=n;if(Ru(i)&&zh(i.moduleReference))return{importNode:i,name:n,moduleSpecifier:i.moduleReference.expression};if(tS(i)){let s=i.parent.parent;return{importNode:s,name:n,moduleSpecifier:s.moduleSpecifier}}}function mUe(e,t,n,i){e.replaceNode(t,n.importNode,J1(n.name,void 0,n.moduleSpecifier,_d(t,i)))}var Cie,ybe,sIt=f({"src/services/codefixes/useDefaultImport.ts"(){"use strict";yi(),Ma(),Cie="useDefaultImport",ybe=[g.Import_may_be_converted_to_a_default_import.code],wa({errorCodes:ybe,getCodeActions(e){let{sourceFile:t,span:{start:n}}=e,i=dUe(t,n);if(!i)return;let s=En.ChangeTracker.with(e,o=>mUe(o,t,i,e.preferences));return[ma(Cie,s,g.Convert_to_default_import,Cie,g.Convert_all_to_default_imports)]},fixIds:[Cie],getAllCodeActions:e=>Fo(e,ybe,(t,n)=>{let i=dUe(n.file,n.start);i&&mUe(t,n.file,i,e.preferences)})})}});function gUe(e,t,n){let i=ii(Ts(t,n.start),_p);if(!i)return;let s=i.getText(t)+"n";e.replaceNode(t,i,j.createBigIntLiteral(s))}var Aie,vbe,aIt=f({"src/services/codefixes/useBigintLiteral.ts"(){"use strict";yi(),Ma(),Aie="useBigintLiteral",vbe=[g.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers.code],wa({errorCodes:vbe,getCodeActions:function(t){let n=En.ChangeTracker.with(t,i=>gUe(i,t.sourceFile,t.span));if(n.length>0)return[ma(Aie,n,g.Convert_to_a_bigint_numeric_literal,Aie,g.Convert_all_to_bigint_numeric_literals)]},fixIds:[Aie],getAllCodeActions:e=>Fo(e,vbe,(t,n)=>gUe(t,n.file,n))})}});function hUe(e,t){let n=Ts(e,t);return I.assert(n.kind===102,"This token should be an ImportKeyword"),I.assert(n.parent.kind===205,"Token parent should be an ImportType"),n.parent}function yUe(e,t,n){let i=j.updateImportTypeNode(n,n.argument,n.attributes,n.qualifier,n.typeArguments,!0);e.replaceNode(t,n,i)}var vUe,kie,Sbe,oIt=f({"src/services/codefixes/fixAddModuleReferTypeMissingTypeof.ts"(){"use strict";yi(),Ma(),vUe="fixAddModuleReferTypeMissingTypeof",kie=vUe,Sbe=[g.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0.code],wa({errorCodes:Sbe,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=hUe(n,i.start),o=En.ChangeTracker.with(t,l=>yUe(l,n,s));return[ma(kie,o,g.Add_missing_typeof,kie,g.Add_missing_typeof)]},fixIds:[kie],getAllCodeActions:e=>Fo(e,Sbe,(t,n)=>yUe(t,e.sourceFile,hUe(n.file,n.start)))})}});function SUe(e,t){let s=Ts(e,t).parent.parent;if(!(!bn(s)&&(s=s.parent,!bn(s)))&&sl(s.operatorToken))return s}function TUe(e,t,n){let i=cIt(n);i&&e.replaceNode(t,n,j.createJsxFragment(j.createJsxOpeningFragment(),i,j.createJsxJsxClosingFragment()))}function cIt(e){let t=[],n=e;for(;;)if(bn(n)&&sl(n.operatorToken)&&n.operatorToken.kind===28){if(t.push(n.left),u8(n.right))return t.push(n.right),t;if(bn(n.right)){n=n.right;continue}else return}else return}var Pie,Tbe,lIt=f({"src/services/codefixes/wrapJsxInFragment.ts"(){"use strict";yi(),Ma(),Pie="wrapJsxInFragment",Tbe=[g.JSX_expressions_must_have_one_parent_element.code],wa({errorCodes:Tbe,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=SUe(n,i.start);if(!s)return;let o=En.ChangeTracker.with(t,l=>TUe(l,n,s));return[ma(Pie,o,g.Wrap_in_JSX_fragment,Pie,g.Wrap_all_unparented_JSX_in_JSX_fragment)]},fixIds:[Pie],getAllCodeActions:e=>Fo(e,Tbe,(t,n)=>{let i=SUe(e.sourceFile,n.start);i&&TUe(t,e.sourceFile,i)})})}});function bUe(e,t){let n=Ts(e,t),i=ii(n.parent.parent,oE);if(!i)return;let s=ef(i.parent)?i.parent:ii(i.parent.parent,Vm);if(s)return{indexSignature:i,container:s}}function uIt(e,t){return j.createTypeAliasDeclaration(e.modifiers,e.name,e.typeParameters,t)}function EUe(e,t,{indexSignature:n,container:i}){let o=(ef(i)?i.members:i.type.members).filter(h=>!oE(h)),l=di(n.parameters),p=j.createTypeParameterDeclaration(void 0,ta(l.name,ze),l.type),m=j.createMappedTypeNode(i6(n)?j.createModifier(148):void 0,p,void 0,n.questionToken,n.type,void 0),S=j.createIntersectionTypeNode([...Yw(i),m,...o.length?[j.createTypeLiteralNode(o)]:tt]);e.replaceNode(t,i,uIt(i,S))}var Nie,bbe,_It=f({"src/services/codefixes/convertToMappedObjectType.ts"(){"use strict";yi(),Ma(),Nie="fixConvertToMappedObjectType",bbe=[g.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead.code],wa({errorCodes:bbe,getCodeActions:function(t){let{sourceFile:n,span:i}=t,s=bUe(n,i.start);if(!s)return;let o=En.ChangeTracker.with(t,p=>EUe(p,n,s)),l=Nn(s.container.name);return[ma(Nie,o,[g.Convert_0_to_mapped_object_type,l],Nie,[g.Convert_0_to_mapped_object_type,l])]},fixIds:[Nie],getAllCodeActions:e=>Fo(e,bbe,(t,n)=>{let i=bUe(n.file,n.start);i&&EUe(t,n.file,i)})})}}),Ebe,xUe,fIt=f({"src/services/codefixes/removeAccidentalCallParentheses.ts"(){"use strict";yi(),Ma(),Ebe="removeAccidentalCallParentheses",xUe=[g.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without.code],wa({errorCodes:xUe,getCodeActions(e){let t=Gr(Ts(e.sourceFile,e.span.start),da);if(!t)return;let n=En.ChangeTracker.with(e,i=>{i.deleteRange(e.sourceFile,{pos:t.expression.end,end:t.end})});return[hg(Ebe,n,g.Remove_parentheses)]},fixIds:[Ebe]})}});function CUe(e,t,n){let i=ii(Ts(t,n.start),p=>p.kind===135),s=i&&ii(i.parent,Zv);if(!s)return;let o=s;if(Df(s.parent)){let p=IN(s.expression,!1);if(ze(p)){let m=tu(s.parent.pos,t);m&&m.kind!==105&&(o=s.parent)}}e.replaceNode(t,o,s.expression)}var Die,xbe,pIt=f({"src/services/codefixes/removeUnnecessaryAwait.ts"(){"use strict";yi(),Ma(),Die="removeUnnecessaryAwait",xbe=[g.await_has_no_effect_on_the_type_of_this_expression.code],wa({errorCodes:xbe,getCodeActions:function(t){let n=En.ChangeTracker.with(t,i=>CUe(i,t.sourceFile,t.span));if(n.length>0)return[ma(Die,n,g.Remove_unnecessary_await,Die,g.Remove_all_unnecessary_uses_of_await)]},fixIds:[Die],getAllCodeActions:e=>Fo(e,xbe,(t,n)=>CUe(t,n.file,n))})}});function AUe(e,t){return Gr(Ts(e,t.start),uu)}function kUe(e,t,n){if(!t)return;let i=I.checkDefined(t.importClause);e.replaceNode(n.sourceFile,t,j.updateImportDeclaration(t,t.modifiers,j.updateImportClause(i,i.isTypeOnly,i.name,void 0),t.moduleSpecifier,t.attributes)),e.insertNodeAfter(n.sourceFile,t,j.createImportDeclaration(void 0,j.updateImportClause(i,i.isTypeOnly,void 0,i.namedBindings),t.moduleSpecifier,t.attributes))}var Cbe,Iie,dIt=f({"src/services/codefixes/splitTypeOnlyImport.ts"(){"use strict";yi(),Ma(),Cbe=[g.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both.code],Iie="splitTypeOnlyImport",wa({errorCodes:Cbe,fixIds:[Iie],getCodeActions:function(t){let n=En.ChangeTracker.with(t,i=>kUe(i,AUe(t.sourceFile,t.span),t));if(n.length)return[ma(Iie,n,g.Split_into_two_separate_import_declarations,Iie,g.Split_all_invalid_type_only_imports)]},getAllCodeActions:e=>Fo(e,Cbe,(t,n)=>{kUe(t,AUe(e.sourceFile,n),e)})})}});function PUe(e,t,n){var i;let o=n.getTypeChecker().getSymbolAtLocation(Ts(e,t));if(o===void 0)return;let l=ii((i=o?.valueDeclaration)==null?void 0:i.parent,Tu);if(l===void 0)return;let p=Oo(l,87,e);if(p!==void 0)return{symbol:o,token:p}}function NUe(e,t,n){e.replaceNode(t,n,j.createToken(121))}var wie,Abe,mIt=f({"src/services/codefixes/convertConstToLet.ts"(){"use strict";yi(),Ma(),wie="fixConvertConstToLet",Abe=[g.Cannot_assign_to_0_because_it_is_a_constant.code],wa({errorCodes:Abe,getCodeActions:function(t){let{sourceFile:n,span:i,program:s}=t,o=PUe(n,i.start,s);if(o===void 0)return;let l=En.ChangeTracker.with(t,p=>NUe(p,n,o.token));return[CSe(wie,l,g.Convert_const_to_let,wie,g.Convert_all_const_to_let)]},getAllCodeActions:e=>{let{program:t}=e,n=new Map;return MD(En.ChangeTracker.with(e,i=>{LD(e,Abe,s=>{let o=PUe(s.file,s.start,t);if(o&&Bm(n,Ia(o.symbol)))return NUe(i,s.file,o.token)})}))},fixIds:[wie]})}});function DUe(e,t,n){let i=Ts(e,t);return i.kind===27&&i.parent&&(Ha(i.parent)||Z_(i.parent))?{node:i}:void 0}function IUe(e,t,{node:n}){let i=j.createToken(28);e.replaceNode(t,n,i)}var Oie,wUe,kbe,gIt=f({"src/services/codefixes/fixExpectedComma.ts"(){"use strict";yi(),Ma(),Oie="fixExpectedComma",wUe=g._0_expected.code,kbe=[wUe],wa({errorCodes:kbe,getCodeActions(e){let{sourceFile:t}=e,n=DUe(t,e.span.start,e.errorCode);if(!n)return;let i=En.ChangeTracker.with(e,s=>IUe(s,t,n));return[ma(Oie,i,[g.Change_0_to_1,";",","],Oie,[g.Change_0_to_1,";",","])]},fixIds:[Oie],getAllCodeActions:e=>Fo(e,kbe,(t,n)=>{let i=DUe(n.file,n.start,n.code);i&&IUe(t,e.sourceFile,i)})})}});function OUe(e,t,n,i,s){let o=Ts(t,n.start);if(!ze(o)||!da(o.parent)||o.parent.expression!==o||o.parent.arguments.length!==0)return;let l=i.getTypeChecker(),p=l.getSymbolAtLocation(o),m=p?.valueDeclaration;if(!m||!Ls(m)||!lE(m.parent.parent)||s?.has(m))return;s?.add(m);let S=hIt(m.parent.parent);if(Tt(S)){let h=S[0],b=!Kv(h)&&!ox(h)&&ox(j.createUnionTypeNode([h,j.createKeywordTypeNode(116)]).types[0]);b&&e.insertText(t,h.pos,"("),e.insertText(t,h.end,b?") | void":" | void")}else{let h=l.getResolvedSignature(o.parent),b=h?.parameters[0],A=b&&l.getTypeOfSymbolAtLocation(b,m.parent.parent);gn(m)?(!A||A.flags&3)&&(e.insertText(t,m.parent.parent.end,")"),e.insertText(t,Wa(t.text,m.parent.parent.pos),"/** @type {Promise<void>} */(")):(!A||A.flags&2)&&e.insertText(t,m.parent.parent.expression.end,"<void>")}}function hIt(e){var t;if(gn(e)){if(Df(e.parent)){let n=(t=_T(e.parent))==null?void 0:t.typeExpression.type;if(n&&Id(n)&&ze(n.typeName)&&Nn(n.typeName)==="Promise")return n.typeArguments}}else return e.typeArguments}var RUe,Pbe,Nbe,yIt=f({"src/services/codefixes/fixAddVoidToPromise.ts"(){"use strict";yi(),Ma(),RUe="addVoidToPromise",Pbe="addVoidToPromise",Nbe=[g.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments.code,g.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise.code],wa({errorCodes:Nbe,fixIds:[Pbe],getCodeActions(e){let t=En.ChangeTracker.with(e,n=>OUe(n,e.sourceFile,e.span,e.program));if(t.length>0)return[ma(RUe,t,g.Add_void_to_Promise_resolved_without_a_value,Pbe,g.Add_void_to_all_Promises_resolved_without_a_value)]},getAllCodeActions(e){return Fo(e,Nbe,(t,n)=>OUe(t,n.file,n,e.program,new Set))}})}}),x_={};x(x_,{PreserveOptionalFlags:()=>pbe,addNewNodeForMemberSymbol:()=>GBe,codeFixAll:()=>Fo,createCodeFixAction:()=>ma,createCodeFixActionMaybeFixAll:()=>CSe,createCodeFixActionWithoutFixAll:()=>hg,createCombinedCodeActions:()=>MD,createFileTextChanges:()=>H5e,createImportAdder:()=>Ck,createImportSpecifierResolver:()=>APt,createJsonPropertyAssignment:()=>vie,createMissingMemberNodes:()=>sbe,createSignatureDeclarationFromCallExpression:()=>abe,createSignatureDeclarationFromSignature:()=>hie,createStubbedBody:()=>Aq,eachDiagnostic:()=>LD,findAncestorMatchingSpan:()=>fbe,findJsonProperty:()=>_be,generateAccessorFromProperty:()=>ZBe,getAccessorConvertiblePropertyAtPosition:()=>rUe,getAllFixes:()=>rkt,getAllSupers:()=>dbe,getArgumentTypesAndTypeParameters:()=>XBe,getFixes:()=>tkt,getImportCompletionAction:()=>kPt,getImportKind:()=>eTe,getJSDocTypedefNodes:()=>TPt,getNoopSymbolTrackerWithResolver:()=>jD,getPromoteTypeOnlyCompletionAction:()=>PPt,getSupportedErrorCodes:()=>ZAt,importFixName:()=>oTe,importSymbols:()=>BD,moduleSpecifierToValidIdentifier:()=>aTe,moduleSymbolToValidIdentifier:()=>sTe,parameterShouldGetTypeFromJSDoc:()=>d9e,registerCodeFix:()=>wa,setJsonCompilerOptionValue:()=>ube,setJsonCompilerOptionValues:()=>lbe,tryGetAutoImportableReferenceFromTypeNode:()=>kk,typeToAutoImportableTypeNode:()=>yie});var Ma=f({"src/services/_namespaces/ts.codefix.ts"(){"use strict";nkt(),ikt(),skt(),ckt(),pkt(),hkt(),ykt(),vkt(),Skt(),xkt(),Rkt(),Lkt(),Gkt(),_Pt(),fPt(),dPt(),mPt(),bPt(),EPt(),CPt(),HPt(),KPt(),eNt(),tNt(),rNt(),sNt(),cNt(),_Nt(),gNt(),ANt(),PNt(),RNt(),MNt(),FNt(),jNt(),BNt(),UNt(),JNt(),qNt(),zNt(),$Nt(),WNt(),HNt(),KNt(),tDt(),uDt(),fDt(),pDt(),gDt(),hDt(),vDt(),SDt(),PDt(),NDt(),DDt(),LDt(),HDt(),QDt(),rIt(),iIt(),sIt(),aIt(),oIt(),lIt(),_It(),fIt(),pIt(),dIt(),mIt(),gIt(),yIt()}});function vIt(e){return!!(e.kind&1)}function SIt(e){return!!(e.kind&2)}function kq(e){return!!(e&&e.kind&4)}function UO(e){return!!(e&&e.kind===32)}function TIt(e){return kq(e)||UO(e)||Dbe(e)}function bIt(e){return(kq(e)||UO(e))&&!!e.isFromPackageJson}function EIt(e){return!!(e.kind&8)}function xIt(e){return!!(e.kind&16)}function MUe(e){return!!(e&&e.kind&64)}function LUe(e){return!!(e&&e.kind&128)}function CIt(e){return!!(e&&e.kind&256)}function Dbe(e){return!!(e&&e.kind&512)}function FUe(e,t,n,i,s,o,l,p,m){var S,h,b;let A=uc(),k=l||MA(Q_(i.getCompilerOptions())),N=!1,M=0,O=0,U=0,H=0,K=m({tryResolve:$,skippedAny:()=>N,resolvedAny:()=>O>0,resolvedBeyondLimit:()=>O>qie}),re=H?` (${(U/H*100).toFixed(1)}% hit rate)`:"";return(S=t.log)==null||S.call(t,`${e}: resolved ${O} module specifiers, plus ${M} ambient and ${U} from cache${re}`),(h=t.log)==null||h.call(t,`${e}: response is ${N?"incomplete":"complete"}`),(b=t.log)==null||b.call(t,`${e}: ${uc()-A}`),K;function $(pe,z){if(z){let Z=n.getModuleSpecifierForBestExportInfo(pe,s,p);return Z&&M++,Z||"failed"}let se=k||o.allowIncompleteCompletions&&O<qie,Se=!se&&o.allowIncompleteCompletions&&H<Ube,xe=se||Se?n.getModuleSpecifierForBestExportInfo(pe,s,p,Se):void 0;return(!se&&!Se||Se&&!xe)&&(N=!0),O+=xe?.computedWithoutCacheCount||0,U+=pe.length-(xe?.computedWithoutCacheCount||0),Se&&H++,xe||(k?"failed":"skipped")}}function AIt(e,t,n,i,s,o,l,p,m,S,h=!1){var b;let{previousToken:A}=Fie(s,i);if(l&&!hk(i,s,A)&&!owt(i,l,A,s))return;if(l===" ")return o.includeCompletionsForImportStatements&&o.includeCompletionsWithInsertText?{isGlobalCompletion:!0,isMemberCompletion:!1,isNewIdentifierLocation:!0,isIncomplete:!0,entries:[]}:void 0;let k=t.getCompilerOptions(),N=t.getTypeChecker(),M=o.allowIncompleteCompletions?(b=e.getIncompleteCompletionsCache)==null?void 0:b.call(e):void 0;if(M&&p===3&&A&&ze(A)){let H=kIt(M,i,A,t,e,o,m,s);if(H)return H}else M?.clear();let O=$ie.getStringLiteralCompletions(i,s,A,k,e,t,n,o,h);if(O)return O;if(A&&Iw(A.parent)&&(A.kind===83||A.kind===88||A.kind===80))return WIt(A.parent);let U=YUe(t,n,i,k,s,o,void 0,e,S,m);if(U)switch(U.kind){case 0:let H=wIt(i,e,t,k,n,U,o,S,s,h);return H?.isIncomplete&&M?.set(H),H;case 1:return Ibe([...VT.getJSDocTagNameCompletions(),...BUe(i,s,N,k,o,!0)]);case 2:return Ibe([...VT.getJSDocTagCompletions(),...BUe(i,s,N,k,o,!1)]);case 3:return Ibe(VT.getJSDocParameterNameCompletions(U.tag));case 4:return DIt(U.keywordCompletions,U.isNewIdentifierLocation);default:return I.assertNever(U)}}function Pq(e,t){var n,i;let s=LP(e.sortText,t.sortText);return s===0&&(s=LP(e.name,t.name)),s===0&&((n=e.data)!=null&&n.moduleSpecifier)&&((i=t.data)!=null&&i.moduleSpecifier)&&(s=cR(e.data.moduleSpecifier,t.data.moduleSpecifier)),s===0?-1:s}function jUe(e){return!!e?.moduleSpecifier}function kIt(e,t,n,i,s,o,l,p){let m=e.get();if(!m)return;let S=If(t,p),h=n.text.toLowerCase(),b=d7(t,s,i,o,l),A=FUe("continuePreviousIncompleteResponse",s,x_.createImportSpecifierResolver(t,i,s,o),i,n.getStart(),o,!1,ET(n),k=>{let N=Wi(m.entries,M=>{var O;if(!M.hasAction||!M.source||!M.data||jUe(M.data))return M;if(!lVe(M.name,h))return;let{origin:U}=I.checkDefined(XUe(M.name,M.data,i,s)),H=b.get(t.path,M.data.exportMapKey),K=H&&k.tryResolve(H,!Nu(cm(U.moduleSymbol.name)));if(K==="skipped")return M;if(!K||K==="failed"){(O=s.log)==null||O.call(s,`Unexpected failure resolving auto import for '${M.name}' from '${M.source}'`);return}let re={...U,kind:32,moduleSpecifier:K.moduleSpecifier};return M.data=WUe(re),M.source=Obe(re),M.sourceDisplay=[fd(re.moduleSpecifier)],M});return k.skippedAny()||(m.isIncomplete=void 0),N});return m.entries=A,m.flags=(m.flags||0)|4,m.optionalReplacementSpan=JUe(S),m}function Ibe(e){return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!1,entries:e}}function BUe(e,t,n,i,s,o){let l=Ts(e,t);if(!eN(l)&&!dg(l))return[];let p=dg(l)?l:l.parent;if(!dg(p))return[];let m=p.parent;if(!ca(m))return[];let S=Y_(e),h=s.includeCompletionsWithSnippetText||void 0,b=mu(p.tags,A=>mg(A)&&A.getEnd()<=t);return Wi(m.parameters,A=>{if(!HP(A).length){if(ze(A.name)){let k={tabstop:1},N=A.name.text,M=U7(N,A.initializer,A.dotDotDotToken,S,!1,!1,n,i,s),O=h?U7(N,A.initializer,A.dotDotDotToken,S,!1,!0,n,i,s,k):void 0;return o&&(M=M.slice(1),O&&(O=O.slice(1))),{name:M,kind:"parameter",sortText:C_.LocationPriority,insertText:h?O:void 0,isSnippet:h}}else if(A.parent.parameters.indexOf(A)===b){let k=`param${b}`,N=UUe(k,A.name,A.initializer,A.dotDotDotToken,S,!1,n,i,s),M=h?UUe(k,A.name,A.initializer,A.dotDotDotToken,S,!0,n,i,s):void 0,O=N.join(w1(i)+"* "),U=M?.join(w1(i)+"* ");return o&&(O=O.slice(1),U&&(U=U.slice(1))),{name:O,kind:"parameter",sortText:C_.LocationPriority,insertText:h?U:void 0,isSnippet:h}}}})}function UUe(e,t,n,i,s,o,l,p,m){if(!s)return[U7(e,n,i,s,!1,o,l,p,m,{tabstop:1})];return S(e,t,n,i,{tabstop:1});function S(b,A,k,N,M){if(pm(A)&&!N){let U={tabstop:M.tabstop},H=U7(b,k,N,s,!0,o,l,p,m,U),K=[];for(let re of A.elements){let $=h(b,re,U);if($)K.push(...$);else{K=void 0;break}}if(K)return M.tabstop=U.tabstop,[H,...K]}return[U7(b,k,N,s,!1,o,l,p,m,M)]}function h(b,A,k){if(!A.propertyName&&ze(A.name)||ze(A.name)){let N=A.propertyName?Vw(A.propertyName):A.name.text;if(!N)return;let M=`${b}.${N}`;return[U7(M,A.initializer,A.dotDotDotToken,s,!1,o,l,p,m,k)]}else if(A.propertyName){let N=Vw(A.propertyName);return N&&S(`${b}.${N}`,A.name,A.initializer,A.dotDotDotToken,k)}}}function U7(e,t,n,i,s,o,l,p,m,S){if(o&&I.assertIsDefined(S),t&&(e=PIt(e,t)),o&&(e=sE(e)),i){let h="*";if(s)I.assert(!n,"Cannot annotate a rest parameter with type 'Object'."),h="Object";else{if(t){let k=l.getTypeAtLocation(t.parent);if(!(k.flags&16385)){let N=t.getSourceFile(),O=_d(N,m)===0?268435456:0,U=l.typeToTypeNode(k,Gr(t,ca),O);if(U){let H=o?Lie({removeComments:!0,module:p.module,target:p.target}):RT({removeComments:!0,module:p.module,target:p.target});Sn(U,1),h=H.printNode(4,U,N)}}}o&&h==="*"&&(h=`\${${S.tabstop++}:${h}}`)}let b=!s&&n?"...":"",A=o?`\${${S.tabstop++}}`:"";return`@param {${b}${h}} ${e} ${A}`}else{let h=o?`\${${S.tabstop++}}`:"";return`@param ${e} ${h}`}}function PIt(e,t){let n=t.getText().trim();return n.includes(`
`)||n.length>80?`[${e}]`:`[${e}=${n}]`}function NIt(e){return{name:Sa(e),kind:"keyword",kindModifiers:"",sortText:C_.GlobalsOrKeywords}}function DIt(e,t){return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:t,entries:e.slice()}}function VUe(e,t,n){return{kind:4,keywordCompletions:KUe(e,t),isNewIdentifierLocation:n}}function IIt(e){switch(e){case 156:return 8;default:I.fail("Unknown mapping from SyntaxKind to KeywordCompletionFilters")}}function JUe(e){return e?.kind===80?gf(e):void 0}function wIt(e,t,n,i,s,o,l,p,m,S){let{symbols:h,contextToken:b,completionKind:A,isInSnippetScope:k,isNewIdentifierLocation:N,location:M,propertyAccessToConvert:O,keywordFilters:U,symbolToOriginInfoMap:H,recommendedCompletion:K,isJsxInitializer:re,isTypeOnlyLocation:$,isJsxIdentifierExpected:pe,isRightOfOpenTag:z,isRightOfDotOrQuestionDot:se,importStatementCompletion:Se,insideJsDocTagTypeExpression:xe,symbolToSortTextMap:Z,hasUnresolvedAutoImports:Q}=o,ce=o.literals,ye=n.getTypeChecker();if(sR(e.scriptKind)===1){let Ge=RIt(M,e);if(Ge)return Ge}let we=Gr(b,WN);if(we&&(Ege(b)||Yb(b,we.expression))){let Ge=LJ(ye,we.parent.clauses);ce=ce.filter(Ae=>!Ge.hasValue(Ae)),h.forEach((Ae,Ie)=>{if(Ae.valueDeclaration&&gE(Ae.valueDeclaration)){let Re=ye.getConstantValue(Ae.valueDeclaration);Re!==void 0&&Ge.hasValue(Re)&&(H[Ie]={kind:256})}})}let ve=h1(),oe=qUe(e,i);if(oe&&!N&&(!h||h.length===0)&&U===0)return;let Ee=Rbe(h,ve,void 0,b,M,m,e,t,n,ho(i),s,A,l,i,p,$,O,pe,re,Se,K,H,Z,pe,z,S);if(U!==0)for(let Ge of KUe(U,!xe&&Y_(e)))($&&CO(Fb(Ge.name))||!$&&mwt(Ge.name)||!Ee.has(Ge.name))&&(Ee.add(Ge.name),lf(ve,Ge,Pq,!0));for(let Ge of rwt(b,m))Ee.has(Ge.name)||(Ee.add(Ge.name),lf(ve,Ge,Pq,!0));for(let Ge of ce){let Ae=LIt(e,l,Ge);Ee.add(Ae.name),lf(ve,Ae,Pq,!0)}oe||MIt(e,M.pos,Ee,ho(i),ve);let Me;if(l.includeCompletionsWithInsertText&&b&&!z&&!se&&(Me=Gr(b,V6))){let Ge=zUe(Me,e,l,i,t,n,p);Ge&&ve.push(Ge.entry)}return{flags:o.flags,isGlobalCompletion:k,isIncomplete:l.allowIncompleteCompletions&&Q?!0:void 0,isMemberCompletion:OIt(A),isNewIdentifierLocation:N,optionalReplacementSpan:JUe(M),entries:ve}}function qUe(e,t){return!Y_(e)||!!uR(e,t)}function zUe(e,t,n,i,s,o,l){let p=e.clauses,m=o.getTypeChecker(),S=m.getTypeAtLocation(e.parent.expression);if(S&&S.isUnion()&&yr(S.types,h=>h.isLiteral())){let h=LJ(m,p),b=ho(i),A=_d(t,n),k=x_.createImportAdder(t,o,n,s),N=[];for(let $ of S.types)if($.flags&1024){I.assert($.symbol,"An enum member type should have a symbol"),I.assert($.symbol.parent,"An enum member type should have a parent symbol (the enum symbol)");let pe=$.symbol.valueDeclaration&&m.getConstantValue($.symbol.valueDeclaration);if(pe!==void 0){if(h.hasValue(pe))continue;h.addValue(pe)}let z=x_.typeToAutoImportableTypeNode(m,k,$,e,b);if(!z)return;let se=Rie(z,b,A);if(!se)return;N.push(se)}else if(!h.hasValue($.value))switch(typeof $.value){case"object":N.push($.value.negative?j.createPrefixUnaryExpression(41,j.createBigIntLiteral({negative:!1,base10Value:$.value.base10Value})):j.createBigIntLiteral($.value));break;case"number":N.push($.value<0?j.createPrefixUnaryExpression(41,j.createNumericLiteral(-$.value)):j.createNumericLiteral($.value));break;case"string":N.push(j.createStringLiteral($.value,A===0));break}if(N.length===0)return;let M=vr(N,$=>j.createCaseClause($,[])),O=q1(s,l?.options),U=Lie({removeComments:!0,module:i.module,target:i.target,newLine:p7(O)}),H=l?$=>U.printAndFormatNode(4,$,t,l):$=>U.printNode(4,$,t),K=vr(M,($,pe)=>n.includeCompletionsWithSnippetText?`${H($)}$${pe+1}`:`${H($)}`).join(O);return{entry:{name:`${U.printNode(4,M[0],t)} ...`,kind:"",sortText:C_.GlobalsOrKeywords,insertText:K,hasAction:k.hasFixes()||void 0,source:"SwitchCases/",isSnippet:n.includeCompletionsWithSnippetText?!0:void 0},importAdder:k}}}function Rie(e,t,n){switch(e.kind){case 183:let i=e.typeName;return Mie(i,t,n);case 199:let s=Rie(e.objectType,t,n),o=Rie(e.indexType,t,n);return s&&o&&j.createElementAccessExpression(s,o);case 201:let l=e.literal;switch(l.kind){case 11:return j.createStringLiteral(l.text,n===0);case 9:return j.createNumericLiteral(l.text,l.numericLiteralFlags)}return;case 196:let p=Rie(e.type,t,n);return p&&(ze(p)?p:j.createParenthesizedExpression(p));case 186:return Mie(e.exprName,t,n);case 205:I.fail("We should not get an import type after calling 'codefix.typeToAutoImportableTypeNode'.")}}function Mie(e,t,n){if(ze(e))return e;let i=Zi(e.right.escapedText);return YX(i,t)?j.createPropertyAccessExpression(Mie(e.left,t,n),i):j.createElementAccessExpression(Mie(e.left,t,n),j.createStringLiteral(i,n===0))}function OIt(e){switch(e){case 0:case 3:case 2:return!0;default:return!1}}function RIt(e,t){let n=Gr(e,i=>{switch(i.kind){case 287:return!0;case 44:case 32:case 80:case 211:return!1;default:return"quit"}});if(n){let i=!!Oo(n,32,t),l=n.parent.openingElement.tagName.getText(t)+(i?"":">"),p=gf(n.tagName),m={name:l,kind:"class",kindModifiers:void 0,sortText:C_.LocationPriority};return{isGlobalCompletion:!1,isMemberCompletion:!0,isNewIdentifierLocation:!1,optionalReplacementSpan:p,entries:[m]}}}function MIt(e,t,n,i,s){Kre(e).forEach((o,l)=>{if(o===t)return;let p=Zi(l);!n.has(p)&&nd(p,i)&&(n.add(p),lf(s,{name:p,kind:"warning",kindModifiers:"",sortText:C_.JavascriptIdentifiers,isFromUncheckedFile:!0},Pq))})}function wbe(e,t,n){return typeof n=="object"?nE(n)+"n":vs(n)?IO(e,t,n):JSON.stringify(n)}function LIt(e,t,n){return{name:wbe(e,t,n),kind:"string",kindModifiers:"",sortText:C_.LocationPriority}}function FIt(e,t,n,i,s,o,l,p,m,S,h,b,A,k,N,M,O,U,H,K,re,$,pe,z){var se,Se;let xe,Z,Q=gte(n),ce,ye,we=Obe(b),ve,oe,Ee,Me=m.getTypeChecker(),Ge=b&&xIt(b),Ae=b&&SIt(b)||h;if(b&&vIt(b))xe=h?`this${Ge?"?.":""}[${GUe(l,H,S)}]`:`this${Ge?"?.":"."}${S}`;else if((Ae||Ge)&&k){xe=Ae?h?`[${GUe(l,H,S)}]`:`[${S}]`:S,(Ge||k.questionDotToken)&&(xe=`?.${xe}`);let Re=Oo(k,25,l)||Oo(k,29,l);if(!Re)return;let Ue=Ss(S,k.name.text)?k.name.end:Re.end;Q=Ll(Re.getStart(l),Ue)}if(N&&(xe===void 0&&(xe=S),xe=`{${xe}}`,typeof N!="boolean"&&(Q=gf(N,l))),b&&EIt(b)&&k){xe===void 0&&(xe=S);let Re=tu(k.pos,l),Ue="";Re&&AJ(Re.end,Re.parent,l)&&(Ue=";"),Ue+=`(await ${k.expression.getText()})`,xe=h?`${Ue}${xe}`:`${Ue}${Ge?"?.":"."}${xe}`;let ke=ii(k.parent,Zv)?k.parent:k.expression;Q=Ll(ke.getStart(l),k.end)}if(UO(b)&&(ve=[fd(b.moduleSpecifier)],M&&({insertText:xe,replacementSpan:Q}=zIt(S,M,b,O,l,U,H),ye=H.includeCompletionsWithSnippetText?!0:void 0)),b?.kind===64&&(oe=!0),K===0&&i&&((se=tu(i.pos,l,i))==null?void 0:se.kind)!==28&&(pl(i.parent.parent)||sd(i.parent.parent)||pp(i.parent.parent)||F1(i.parent)||((Se=Gr(i.parent,Ul))==null?void 0:Se.getLastToken(l))===i||Hf(i.parent)&&Lo(l,i.getEnd()).line!==Lo(l,o).line)&&(we="ObjectLiteralMemberWithComma/",oe=!0),H.includeCompletionsWithClassMemberSnippets&&H.includeCompletionsWithInsertText&&K===3&&jIt(e,s,l)){let Re,Ue=$Ue(p,m,U,H,S,e,s,o,i,re);if(Ue)({insertText:xe,filterText:Z,isSnippet:ye,importAdder:Re}=Ue),Re?.hasFixes()&&(oe=!0,we="ClassMemberSnippet/");else return}if(b&&LUe(b)&&({insertText:xe,isSnippet:ye,labelDetails:Ee}=b,H.useLabelDetailsInCompletionEntries||(S=S+Ee.detail,Ee=void 0),we="ObjectLiteralMethodSnippet/",t=C_.SortBelow(t)),$&&!pe&&H.includeCompletionsWithSnippetText&&H.jsxAttributeCompletionStyle&&H.jsxAttributeCompletionStyle!=="none"&&!(th(s.parent)&&s.parent.initializer)){let Re=H.jsxAttributeCompletionStyle==="braces",Ue=Me.getTypeOfSymbolAtLocation(e,s);H.jsxAttributeCompletionStyle==="auto"&&!(Ue.flags&528)&&!(Ue.flags&1048576&&mr(Ue.types,kt=>!!(kt.flags&528)))&&(Ue.flags&402653316||Ue.flags&1048576&&yr(Ue.types,kt=>!!(kt.flags&402686084||E1e(kt)))?(xe=`${sE(S)}=${IO(l,H,"$1")}`,ye=!0):Re=!0),Re&&(xe=`${sE(S)}={$1}`,ye=!0)}if(xe!==void 0&&!H.includeCompletionsWithInsertText)return;(kq(b)||UO(b))&&(ce=WUe(b),oe=!M);let Ie=Gr(s,Vj);if(Ie?.kind===275){let Re=Fb(S);Ie&&Re&&(Re===135||sX(Re))&&(xe=`${S} as ${S}_`)}return{name:S,kind:W1.getSymbolKind(Me,e,s),kindModifiers:W1.getSymbolModifiers(Me,e),sortText:t,source:we,hasAction:oe?!0:void 0,isRecommended:$It(e,A,Me)||void 0,insertText:xe,filterText:Z,replacementSpan:Q,sourceDisplay:ve,labelDetails:Ee,isSnippet:ye,isPackageJsonImport:bIt(b)||void 0,isImportStatementCompletion:!!M||void 0,data:ce,...z?{symbol:e}:void 0}}function jIt(e,t,n){return gn(t)?!1:!!(e.flags&106500)&&(Ti(t)||t.parent&&t.parent.parent&&Du(t.parent)&&t===t.parent.name&&t.parent.getLastToken(n)===t.parent.name&&Ti(t.parent.parent)||t.parent&&XN(t)&&Ti(t.parent))}function $Ue(e,t,n,i,s,o,l,p,m,S){let h=Gr(l,Ti);if(!h)return;let b,A=s,k=s,N=t.getTypeChecker(),M=l.getSourceFile(),O=Lie({removeComments:!0,module:n.module,target:n.target,omitTrailingSemicolon:!1,newLine:p7(q1(e,S?.options))}),U=x_.createImportAdder(M,t,i,e),H;if(i.includeCompletionsWithSnippetText){b=!0;let Se=j.createEmptyStatement();H=j.createBlock([Se],!0),xK(Se,{kind:0,order:0})}else H=j.createBlock([],!0);let K=0,{modifiers:re,range:$,decorators:pe}=BIt(m,M,p),z=re&64&&h.modifierFlagsCache&64,se=[];if(x_.addNewNodeForMemberSymbol(o,h,M,{program:t,host:e},i,U,Se=>{let xe=0;z&&(xe|=64),Du(Se)&&N.getMemberOverrideModifierStatus(h,Se,o)===1&&(xe|=16),se.length||(K=Se.modifierFlagsCache|xe),Se=j.replaceModifiers(Se,K),se.push(Se)},H,x_.PreserveOptionalFlags.Property,!!z),se.length){let Se=o.flags&8192,xe=K|16|1;Se?xe|=1024:xe|=136;let Z=re&xe;if(re&~xe)return;if(K&4&&Z&1&&(K&=-5),Z!==0&&!(Z&1)&&(K&=-2),K|=Z,se=se.map(ce=>j.replaceModifiers(ce,K)),pe?.length){let ce=se[se.length-1];yx(ce)&&(se[se.length-1]=j.replaceDecoratorsAndModifiers(ce,pe.concat(jb(ce)||[])))}let Q=131073;S?A=O.printAndFormatSnippetList(Q,j.createNodeArray(se),M,S):A=O.printSnippetList(Q,j.createNodeArray(se),M)}return{insertText:A,filterText:k,isSnippet:b,importAdder:U,eraseRange:$}}function BIt(e,t,n){if(!e||Lo(t,n).line>Lo(t,e.getEnd()).line)return{modifiers:0};let i=0,s,o,l={pos:n,end:n};if(ea(e.parent)&&e.parent.modifiers&&(i|=Yg(e.parent.modifiers)&98303,s=e.parent.modifiers.filter(n_)||[],l.pos=Math.min(l.pos,e.parent.modifiers.pos)),o=UIt(e)){let p=IA(o);i&p||(i|=p,l.pos=Math.min(l.pos,e.pos))}return{modifiers:i,decorators:s,range:l.pos!==n?l:void 0}}function UIt(e){if(Ra(e))return e.kind;if(ze(e)){let t=uT(e);if(t&&C1(t))return t}}function VIt(e,t,n,i,s,o,l,p){let m=l.includeCompletionsWithSnippetText||void 0,S=t,h=n.getSourceFile(),b=JIt(e,n,h,i,s,l);if(!b)return;let A=Lie({removeComments:!0,module:o.module,target:o.target,omitTrailingSemicolon:!1,newLine:p7(q1(s,p?.options))});p?S=A.printAndFormatSnippetList(80,j.createNodeArray([b],!0),h,p):S=A.printSnippetList(80,j.createNodeArray([b],!0),h);let k=RT({removeComments:!0,module:o.module,target:o.target,omitTrailingSemicolon:!0}),N=j.createMethodSignature(void 0,"",b.questionToken,b.typeParameters,b.parameters,b.type),M={detail:k.printNode(4,N,h)};return{isSnippet:m,insertText:S,labelDetails:M}}function JIt(e,t,n,i,s,o){let l=e.getDeclarations();if(!(l&&l.length))return;let p=i.getTypeChecker(),m=l[0],S=Sc(qs(m),!1),h=p.getWidenedType(p.getTypeOfSymbolAtLocation(e,t)),A=33554432|(_d(n,o)===0?268435456:0);switch(m.kind){case 171:case 172:case 173:case 174:{let k=h.flags&1048576&&h.types.length<10?p.getUnionType(h.types,2):h;if(k.flags&1048576){let H=Fn(k.types,K=>p.getSignaturesOfType(K,0).length>0);if(H.length===1)k=H[0];else return}if(p.getSignaturesOfType(k,0).length!==1)return;let M=p.typeToTypeNode(k,t,A,x_.getNoopSymbolTrackerWithResolver({program:i,host:s}));if(!M||!Vh(M))return;let O;if(o.includeCompletionsWithSnippetText){let H=j.createEmptyStatement();O=j.createBlock([H],!0),xK(H,{kind:0,order:0})}else O=j.createBlock([],!0);let U=M.parameters.map(H=>j.createParameterDeclaration(void 0,H.dotDotDotToken,H.name,void 0,void 0,H.initializer));return j.createMethodDeclaration(void 0,void 0,S,void 0,void 0,U,void 0,O)}default:return}}function Lie(e){let t,n=En.createWriter(w1(e)),i=RT(e,n),s={...n,write:A=>o(A,()=>n.write(A)),nonEscapingWrite:n.write,writeLiteral:A=>o(A,()=>n.writeLiteral(A)),writeStringLiteral:A=>o(A,()=>n.writeStringLiteral(A)),writeSymbol:(A,k)=>o(A,()=>n.writeSymbol(A,k)),writeParameter:A=>o(A,()=>n.writeParameter(A)),writeComment:A=>o(A,()=>n.writeComment(A)),writeProperty:A=>o(A,()=>n.writeProperty(A))};return{printSnippetList:l,printAndFormatSnippetList:m,printNode:S,printAndFormatNode:b};function o(A,k){let N=sE(A);if(N!==A){let M=n.getTextPos();k();let O=n.getTextPos();t=Pr(t||(t=[]),{newText:N,span:{start:M,length:O-M}})}else k()}function l(A,k,N){let M=p(A,k,N);return t?En.applyChanges(M,t):M}function p(A,k,N){return t=void 0,s.clear(),i.writeList(A,k,N,s),s.getText()}function m(A,k,N,M){let O={text:p(A,k,N),getLineAndCharacterOfPosition(re){return Lo(this,re)}},U=MJ(M,N),H=_a(k,re=>{let $=En.assignPositionsToNode(re);return fu.formatNodeGivenIndentation($,O,N.languageVariant,0,0,{...M,options:U})}),K=t?cu(ys(H,t),(re,$)=>iT(re.span,$.span)):H;return En.applyChanges(O.text,K)}function S(A,k,N){let M=h(A,k,N);return t?En.applyChanges(M,t):M}function h(A,k,N){return t=void 0,s.clear(),i.writeNode(A,k,N,s),s.getText()}function b(A,k,N,M){let O={text:h(A,k,N),getLineAndCharacterOfPosition($){return Lo(this,$)}},U=MJ(M,N),H=En.assignPositionsToNode(k),K=fu.formatNodeGivenIndentation(H,O,N.languageVariant,0,0,{...M,options:U}),re=t?cu(ys(K,t),($,pe)=>iT($.span,pe.span)):K;return En.applyChanges(O.text,re)}}function WUe(e){let t=e.fileName?void 0:cm(e.moduleSymbol.name),n=e.isFromPackageJson?!0:void 0;return UO(e)?{exportName:e.exportName,exportMapKey:e.exportMapKey,moduleSpecifier:e.moduleSpecifier,ambientModuleName:t,fileName:e.fileName,isPackageJsonImport:n}:{exportName:e.exportName,exportMapKey:e.exportMapKey,fileName:e.fileName,ambientModuleName:e.fileName?void 0:cm(e.moduleSymbol.name),isPackageJsonImport:e.isFromPackageJson?!0:void 0}}function qIt(e,t,n){let i=e.exportName==="default",s=!!e.isPackageJsonImport;return jUe(e)?{kind:32,exportName:e.exportName,exportMapKey:e.exportMapKey,moduleSpecifier:e.moduleSpecifier,symbolName:t,fileName:e.fileName,moduleSymbol:n,isDefaultExport:i,isFromPackageJson:s}:{kind:4,exportName:e.exportName,exportMapKey:e.exportMapKey,symbolName:t,fileName:e.fileName,moduleSymbol:n,isDefaultExport:i,isFromPackageJson:s}}function zIt(e,t,n,i,s,o,l){let p=t.replacementSpan,m=sE(IO(s,l,n.moduleSpecifier)),S=n.isDefaultExport?1:n.exportName==="export="?2:0,h=l.includeCompletionsWithSnippetText?"$1":"",b=x_.getImportKind(s,S,o,!0),A=t.couldBeTypeOnlyImportSpecifier,k=t.isTopLevelTypeOnly?` ${Sa(156)} `:" ",N=A?`${Sa(156)} `:"",M=i?";":"";switch(b){case 3:return{replacementSpan:p,insertText:`import${k}${sE(e)}${h} = require(${m})${M}`};case 1:return{replacementSpan:p,insertText:`import${k}${sE(e)}${h} from ${m}${M}`};case 2:return{replacementSpan:p,insertText:`import${k}* as ${sE(e)} from ${m}${M}`};case 0:return{replacementSpan:p,insertText:`import${k}{ ${N}${sE(e)}${h} } from ${m}${M}`}}}function GUe(e,t,n){return/^\d+$/.test(n)?n:IO(e,t,n)}function $It(e,t,n){return e===t||!!(e.flags&1048576)&&n.getExportSymbolOfSymbol(e)===t}function Obe(e){if(kq(e))return cm(e.moduleSymbol.name);if(UO(e))return e.moduleSpecifier;if(e?.kind===1)return"ThisProperty/";if(e?.kind===64)return"TypeOnlyAlias/"}function Rbe(e,t,n,i,s,o,l,p,m,S,h,b,A,k,N,M,O,U,H,K,re,$,pe,z,se,Se=!1){let xe=uc(),Z=fwt(i,s),Q=u7(l),ce=m.getTypeChecker(),ye=new Map;for(let oe=0;oe<e.length;oe++){let Ee=e[oe],Me=$?.[oe],Ge=jie(Ee,S,Me,b,!!U);if(!Ge||ye.get(Ge.name)&&(!Me||!LUe(Me))||b===1&&pe&&!we(Ee,pe)||!M&&gn(l)&&ve(Ee))continue;let{name:Ae,needsConvertPropertyAccess:Ie}=Ge,Re=pe?.[Ia(Ee)]??C_.LocationPriority,Ue=pwt(Ee,ce)?C_.Deprecated(Re):Re,kt=FIt(Ee,Ue,n,i,s,o,l,p,m,Ae,Ie,Me,re,O,H,K,Q,k,A,b,N,z,se,Se);if(!kt)continue;let ke=(!Me||MUe(Me))&&!(Ee.parent===void 0&&!Tt(Ee.declarations,$e=>$e.getSourceFile()===s.getSourceFile()));ye.set(Ae,ke),lf(t,kt,Pq,!0)}return h("getCompletionsAtPosition: getCompletionEntriesFromSymbols: "+(uc()-xe)),{has:oe=>ye.has(oe),add:oe=>ye.set(oe,!0)};function we(oe,Ee){var Me;let Ge=oe.flags;if(!ls(s)){if(Kc(s.parent))return!0;if(ii(Z,Gi)&&oe.valueDeclaration===Z)return!1;let Ae=oe.valueDeclaration??((Me=oe.declarations)==null?void 0:Me[0]);if(Z&&Ae&&(Nc(Z)&&Nc(Ae)||Ls(Z)&&Ls(Ae))){let Re=Ae.pos,Ue=Ls(Z)?Z.parent.parameters:ax(Z.parent)?void 0:Z.parent.typeParameters;if(Re>=Z.pos&&Ue&&Re<Ue.end)return!1}let Ie=r_(oe,ce);if(l.externalModuleIndicator&&!k.allowUmdGlobalAccess&&Ee[Ia(oe)]===C_.GlobalsOrKeywords&&(Ee[Ia(Ie)]===C_.AutoImportSuggestions||Ee[Ia(Ie)]===C_.LocationPriority))return!1;if(Ge|=NN(Ie),KV(s))return!!(Ge&1920);if(M)return Bbe(oe,ce)}return!!(Ge&111551)}function ve(oe){var Ee;let Me=NN(r_(oe,ce));return!(Me&111551)&&(!gn((Ee=oe.declarations)==null?void 0:Ee[0])||!!(Me&788968))}}function WIt(e){let t=GIt(e);if(t.length)return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!1,entries:t}}function GIt(e){let t=[],n=new Map,i=e;for(;i&&!ca(i);){if(_E(i)){let s=i.label.text;n.has(s)||(n.set(s,!0),t.push({name:s,kindModifiers:"",kind:"label",sortText:C_.LocationPriority}))}i=i.parent}return t}function HUe(e,t,n,i,s,o,l){if(s.source==="SwitchCases/")return{type:"cases"};if(s.data){let K=XUe(s.name,s.data,e,o);if(K){let{contextToken:re,previousToken:$}=Fie(i,n);return{type:"symbol",symbol:K.symbol,location:If(n,i),previousToken:$,contextToken:re,isJsxInitializer:!1,isTypeOnlyLocation:!1,origin:K.origin}}}let p=e.getCompilerOptions(),m=YUe(e,t,n,p,i,{includeCompletionsForModuleExports:!0,includeCompletionsWithInsertText:!0},s,o,void 0);if(!m)return{type:"none"};if(m.kind!==0)return{type:"request",request:m};let{symbols:S,literals:h,location:b,completionKind:A,symbolToOriginInfoMap:k,contextToken:N,previousToken:M,isJsxInitializer:O,isTypeOnlyLocation:U}=m,H=mr(h,K=>wbe(n,l,K)===s.name);return H!==void 0?{type:"literal",literal:H}:Ct(S,(K,re)=>{let $=k[re],pe=jie(K,ho(p),$,A,m.isJsxIdentifierExpected);return pe&&pe.name===s.name&&(s.source==="ClassMemberSnippet/"&&K.flags&106500||s.source==="ObjectLiteralMethodSnippet/"&&K.flags&8196||Obe($)===s.source||s.source==="ObjectLiteralMemberWithComma/")?{type:"symbol",symbol:K,location:b,origin:$,contextToken:N,previousToken:M,isJsxInitializer:O,isTypeOnlyLocation:U}:void 0})||{type:"none"}}function HIt(e,t,n,i,s,o,l,p,m){let S=e.getTypeChecker(),h=e.getCompilerOptions(),{name:b,source:A,data:k}=s,{previousToken:N,contextToken:M}=Fie(i,n);if(hk(n,i,N))return $ie.getStringLiteralCompletionDetails(b,n,i,N,e,o,m,p);let O=HUe(e,t,n,i,s,o,p);switch(O.type){case"request":{let{request:U}=O;switch(U.kind){case 1:return VT.getJSDocTagNameCompletionDetails(b);case 2:return VT.getJSDocTagCompletionDetails(b);case 3:return VT.getJSDocParameterNameCompletionDetails(b);case 4:return Tt(U.keywordCompletions,H=>H.name===b)?Mbe(b,"keyword",5):void 0;default:return I.assertNever(U)}}case"symbol":{let{symbol:U,location:H,contextToken:K,origin:re,previousToken:$}=O,{codeActions:pe,sourceDisplay:z}=YIt(b,H,K,re,U,e,o,h,n,i,$,l,p,k,A,m),se=Dbe(re)?re.symbolName:U.name;return Lbe(U,se,S,n,H,m,pe,z)}case"literal":{let{literal:U}=O;return Mbe(wbe(n,p,U),"string",typeof U=="string"?8:7)}case"cases":{let U=zUe(M.parent,n,p,e.getCompilerOptions(),o,e,void 0);if(U?.importAdder.hasFixes()){let{entry:H,importAdder:K}=U,re=En.ChangeTracker.with({host:o,formatContext:l,preferences:p},K.writeFixes);return{name:H.name,kind:"",kindModifiers:"",displayParts:[],sourceDisplay:void 0,codeActions:[{changes:re,description:Dx([g.Includes_imports_of_types_referenced_by_0,b])}]}}return{name:b,kind:"",kindModifiers:"",displayParts:[],sourceDisplay:void 0}}case"none":return zbe().some(U=>U.name===b)?Mbe(b,"keyword",5):void 0;default:I.assertNever(O)}}function Mbe(e,t,n){return Nq(e,"",t,[Yf(e,n)])}function Lbe(e,t,n,i,s,o,l,p){let{displayParts:m,documentation:S,symbolKind:h,tags:b}=n.runWithCancellationToken(o,A=>W1.getSymbolDisplayPartsDocumentationAndSymbolKind(A,e,i,s,s,7));return Nq(t,W1.getSymbolModifiers(n,e),h,m,S,b,l,p)}function Nq(e,t,n,i,s,o,l,p){return{name:e,kindModifiers:t,kind:n,displayParts:i,documentation:s,tags:o,codeActions:l,source:p,sourceDisplay:p}}function YIt(e,t,n,i,s,o,l,p,m,S,h,b,A,k,N,M){if(k?.moduleSpecifier&&h&&iVe(n||h,m).replacementSpan)return{codeActions:void 0,sourceDisplay:[fd(k.moduleSpecifier)]};if(N==="ClassMemberSnippet/"){let{importAdder:pe,eraseRange:z}=$Ue(l,o,p,A,e,s,t,S,n,b);if(pe||z)return{sourceDisplay:void 0,codeActions:[{changes:En.ChangeTracker.with({host:l,formatContext:b,preferences:A},Se=>{pe&&pe.writeFixes(Se),z&&Se.deleteRange(m,z)}),description:Dx([g.Includes_imports_of_types_referenced_by_0,e])}]}}if(MUe(i)){let pe=x_.getPromoteTypeOnlyCompletionAction(m,i.declaration.name,o,l,b,A);return I.assertIsDefined(pe,"Expected to have a code action for promoting type-only alias"),{codeActions:[pe],sourceDisplay:void 0}}if(N==="ObjectLiteralMemberWithComma/"&&n){let pe=En.ChangeTracker.with({host:l,formatContext:b,preferences:A},z=>z.insertText(m,n.end,","));if(pe)return{sourceDisplay:void 0,codeActions:[{changes:pe,description:Dx([g.Add_missing_comma_for_object_member_completion_0,e])}]}}if(!i||!(kq(i)||UO(i)))return{codeActions:void 0,sourceDisplay:void 0};let O=i.isFromPackageJson?l.getPackageJsonAutoImportProvider().getTypeChecker():o.getTypeChecker(),{moduleSymbol:U}=i,H=O.getMergedSymbol(r_(s.exportSymbol||s,O)),K=n?.kind===30&&H_(n.parent),{moduleSpecifier:re,codeAction:$}=x_.getImportCompletionAction(H,U,k?.exportMapKey,m,e,K,l,o,b,h&&ze(h)?h.getStart(m):S,A,M);return I.assert(!k?.moduleSpecifier||re===k.moduleSpecifier),{sourceDisplay:[fd(re)],codeActions:[$]}}function XIt(e,t,n,i,s,o,l){let p=HUe(e,t,n,i,s,o,l);return p.type==="symbol"?p.symbol:void 0}function KIt(e,t,n){return Ct(t&&(t.isUnion()?t.types:[t]),i=>{let s=i&&i.symbol;return s&&s.flags&424&&!pme(s)?Fbe(s,e,n):void 0})}function QIt(e,t,n,i){let{parent:s}=e;switch(e.kind){case 80:return EJ(e,i);case 64:switch(s.kind){case 260:return i.getContextualType(s.initializer);case 226:return i.getTypeAtLocation(s.left);case 291:return i.getContextualTypeForJsxAttribute(s);default:return}case 105:return i.getContextualType(s);case 84:let o=ii(s,WN);return o?Bte(o,i):void 0;case 19:return J6(s)&&!L0(s.parent)&&!pE(s.parent)?i.getContextualTypeForJsxAttribute(s.parent):void 0;default:let l=W7.getArgumentInfoForCompletions(e,t,n,i);return l?i.getContextualTypeForArgumentAtIndex(l.invocation,l.argumentIndex):xJ(e.kind)&&bn(s)&&xJ(s.operatorToken.kind)?i.getTypeAtLocation(s.left):i.getContextualType(e,4)||i.getContextualType(e)}}function Fbe(e,t,n){let i=n.getAccessibleSymbolChain(e,t,-1,!1);return i?di(i):e.parent&&(ZIt(e.parent)?e:Fbe(e.parent,t,n))}function ZIt(e){var t;return!!((t=e.declarations)!=null&&t.some(n=>n.kind===312))}function YUe(e,t,n,i,s,o,l,p,m,S){let h=e.getTypeChecker(),b=qUe(n,i),A=uc(),k=Ts(n,s);t("getCompletionData: Get current token: "+(uc()-A)),A=uc();let N=U1(n,s,k);t("getCompletionData: Is inside comment: "+(uc()-A));let M=!1,O=!1;if(N){if(S1e(n,s)){if(n.text.charCodeAt(s-1)===64)return{kind:1};{let qe=mm(s,n);if(!/[^*|\s(/)]/.test(n.text.substring(qe,s)))return{kind:2}}}let he=nwt(k,s);if(he){if(he.tagName.pos<=s&&s<=he.tagName.end)return{kind:1};let qe=ar(he);if(qe&&(k=Ts(n,s),(!k||!Cy(k)&&(k.parent.kind!==355||k.parent.name!==k))&&(M=X(qe))),!M&&mg(he)&&(sl(he.name)||he.name.pos<=s&&s<=he.name.end))return{kind:3,tag:he}}if(!M){t("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.");return}}A=uc();let U=!M&&Y_(n),H=Fie(s,n),K=H.previousToken,re=H.contextToken;t("getCompletionData: Get previous token: "+(uc()-A));let $=k,pe,z=!1,se=!1,Se=!1,xe=!1,Z=!1,Q=!1,ce,ye=If(n,s),we=0,ve=!1,oe=0;if(re){let he=iVe(re,n);if(he.keywordCompletion){if(he.isKeywordOnlyCompletion)return{kind:4,keywordCompletions:[NIt(he.keywordCompletion)],isNewIdentifierLocation:he.isNewIdentifierLocation};we=IIt(he.keywordCompletion)}if(he.replacementSpan&&o.includeCompletionsForImportStatements&&o.includeCompletionsWithInsertText&&(oe|=2,ce=he,ve=he.isNewIdentifierLocation),!he.replacementSpan&&us(re))return t("Returning an empty list because completion was requested in an invalid position."),we?VUe(we,U,Ta()):void 0;let qe=re.parent;if(re.kind===25||re.kind===29)switch(z=re.kind===25,se=re.kind===29,qe.kind){case 211:pe=qe,$=pe.expression;let Le=DN(pe);if(sl(Le)||(da($)||ca($))&&$.end===re.pos&&$.getChildCount(n)&&Rs($.getChildren(n)).kind!==22)return;break;case 166:$=qe.left;break;case 267:$=qe.name;break;case 205:$=qe;break;case 236:$=qe.getFirstToken(n),I.assert($.kind===102||$.kind===105);break;default:return}else if(!ce){if(qe&&qe.kind===211&&(re=qe,qe=qe.parent),k.parent===ye)switch(k.kind){case 32:(k.parent.kind===284||k.parent.kind===286)&&(ye=k);break;case 44:k.parent.kind===285&&(ye=k);break}switch(qe.kind){case 287:re.kind===44&&(xe=!0,ye=re);break;case 226:if(!nVe(qe))break;case 285:case 284:case 286:Q=!0,re.kind===30&&(Se=!0,ye=re);break;case 294:case 293:(K.kind===20||K.kind===80&&K.parent.kind===291)&&(Q=!0);break;case 291:if(qe.initializer===K&&K.end<s){Q=!0;break}switch(K.kind){case 64:Z=!0;break;case 80:Q=!0,qe!==K.parent&&!qe.initializer&&Oo(qe,64,n)&&(Z=K)}break}}}let Ee=uc(),Me=5,Ge=!1,Ae=[],Ie,Re=[],Ue=[],kt=new Map,ke=ri(),$e=Nm(he=>kx(he?p.getPackageJsonAutoImportProvider():e,p));if(z||se)or();else if(Se)Ae=h.getJsxIntrinsicTagNamesAt(ye),I.assertEachIsDefined(Ae,"getJsxIntrinsicTagNames() should all be defined"),nr(),Me=1,we=0;else if(xe){let he=re.parent.parent.openingElement.tagName,qe=h.getSymbolAtLocation(he);qe&&(Ae=[qe]),Me=1,we=0}else if(!nr())return we?VUe(we,U,ve):void 0;t("getCompletionData: Semantic work: "+(uc()-Ee));let at=K&&QIt(K,s,n,h),St=!ii(K,bo)&&!Q?Wi(at&&(at.isUnion()?at.types:[at]),he=>he.isLiteral()&&!(he.flags&1024)?he.value:void 0):[],Ze=K&&at&&KIt(K,at,h);return{kind:0,symbols:Ae,completionKind:Me,isInSnippetScope:O,propertyAccessToConvert:pe,isNewIdentifierLocation:ve,location:ye,keywordFilters:we,literals:St,symbolToOriginInfoMap:Re,recommendedCompletion:Ze,previousToken:K,contextToken:re,isJsxInitializer:Z,insideJsDocTagTypeExpression:M,symbolToSortTextMap:Ue,isTypeOnlyLocation:ke,isJsxIdentifierExpected:Q,isRightOfOpenTag:Se,isRightOfDotOrQuestionDot:z||se,importStatementCompletion:ce,hasUnresolvedAutoImports:Ge,flags:oe};function yt(he){switch(he.kind){case 348:case 355:case 349:case 351:case 353:case 356:case 357:return!0;case 352:return!!he.constraint;default:return!1}}function ar(he){if(yt(he)){let qe=dm(he)?he.constraint:he.typeExpression;return qe&&qe.kind===316?qe:void 0}if(sk(he)||fU(he))return he.class}function or(){Me=2;let he=Vv($),qe=he&&!$.isTypeOf||A0($.parent)||QM(re,n,h),Le=KV($);if(zf($)||he||Hn($)){let It=hl($.parent);It&&(ve=!0);let Rt=h.getSymbolAtLocation($);if(Rt&&(Rt=r_(Rt,h),Rt.flags&1920)){let Zt=h.getExportsOfModule(Rt);I.assertEachIsDefined(Zt,"getExportsOfModule() should all be defined");let Ir=Pi=>h.isValidPropertyAccess(he?$:$.parent,Pi.name),zr=Pi=>Bbe(Pi,h),Yr=It?Pi=>{var Fi;return!!(Pi.flags&1920)&&!((Fi=Pi.declarations)!=null&&Fi.every(fn=>fn.parent===$.parent))}:Le?Pi=>zr(Pi)||Ir(Pi):qe||M?zr:Ir;for(let Pi of Zt)Yr(Pi)&&Ae.push(Pi);if(!qe&&!M&&Rt.declarations&&Rt.declarations.some(Pi=>Pi.kind!==312&&Pi.kind!==267&&Pi.kind!==266)){let Pi=h.getTypeOfSymbolAtLocation(Rt,$).getNonOptionalType(),Fi=!1;if(Pi.isNullableType()){let fn=z&&!se&&o.includeAutomaticOptionalChainCompletions!==!1;(fn||se)&&(Pi=Pi.getNonNullableType(),fn&&(Fi=!0))}Fr(Pi,!!($.flags&65536),Fi)}return}}if(!qe||ex($)){h.tryGetThisTypeAt($,!1);let It=h.getTypeAtLocation($).getNonOptionalType();if(qe)Fr(It.getNonNullableType(),!1,!1);else{let Rt=!1;if(It.isNullableType()){let Zt=z&&!se&&o.includeAutomaticOptionalChainCompletions!==!1;(Zt||se)&&(It=It.getNonNullableType(),Zt&&(Rt=!0))}Fr(It,!!($.flags&65536),Rt)}}}function Fr(he,qe,Le){ve=!!he.getStringIndexType(),se&&Tt(he.getCallSignatures())&&(ve=!0);let It=$.kind===205?$:$.parent;if(b)for(let Rt of he.getApparentProperties())h.isValidPropertyAccessForCompletions(It,he,Rt)&&rn(Rt,!1,Le);else Ae.push(...Fn(Vie(he,h),Rt=>h.isValidPropertyAccessForCompletions(It,he,Rt)));if(qe&&o.includeCompletionsWithInsertText){let Rt=h.getPromisedTypeOfPromise(he);if(Rt)for(let Zt of Rt.getApparentProperties())h.isValidPropertyAccessForCompletions(It,Rt,Zt)&&rn(Zt,!0,Le)}}function rn(he,qe,Le){var It;let Rt=Ct(he.declarations,Yr=>ii(qs(Yr),uo));if(Rt){let Yr=Tr(Rt.expression),Pi=Yr&&h.getSymbolAtLocation(Yr),Fi=Pi&&Fbe(Pi,re,h),fn=Fi&&Ia(Fi);if(fn&&Bm(kt,fn)){let Qn=Ae.length;Ae.push(Fi);let Ns=Fi.parent;if(!Ns||!t7(Ns)||h.tryGetMemberInModuleExportsAndProperties(Fi.name,Ns)!==Fi)Re[Qn]={kind:zr(2)};else{let Vi=Nu(cm(Ns.name))?(It=J9(Ns))==null?void 0:It.fileName:void 0,{moduleSpecifier:ji}=(Ie||(Ie=x_.createImportSpecifierResolver(n,e,p,o))).getModuleSpecifierForBestExportInfo([{exportKind:0,moduleFileName:Vi,isFromPackageJson:!1,moduleSymbol:Ns,symbol:Fi,targetFlags:r_(Fi,h).flags}],s,ET(ye))||{};if(ji){let ni={kind:zr(6),moduleSymbol:Ns,isDefaultExport:!1,symbolName:Fi.name,exportName:Fi.name,fileName:Vi,moduleSpecifier:ji};Re[Qn]=ni}}}else if(o.includeCompletionsWithInsertText){if(fn&&kt.has(fn))return;Ir(he),Zt(he),Ae.push(he)}}else Ir(he),Zt(he),Ae.push(he);function Zt(Yr){lwt(Yr)&&(Ue[Ia(Yr)]=C_.LocalDeclarationPriority)}function Ir(Yr){o.includeCompletionsWithInsertText&&(qe&&Bm(kt,Ia(Yr))?Re[Ae.length]={kind:zr(8)}:Le&&(Re[Ae.length]={kind:16}))}function zr(Yr){return Le?Yr|16:Yr}}function Tr(he){return ze(he)?he:Hn(he)?Tr(he.expression):void 0}function nr(){return(Nr()||qr()||xs()||We()||mt()||dt()||tr()||Ot()||ki()||(zi(),1))===1}function tr(){return Ve(re)?(Me=5,ve=!0,we=4,1):0}function ki(){let he=W(re),qe=he&&h.getContextualType(he.attributes);if(!qe)return 0;let Le=he&&h.getContextualType(he.attributes,4);return Ae=ys(Ae,le(Uie(qe,Le,he.attributes,h),he.attributes.properties)),Y(),Me=3,ve=!1,1}function xs(){return ce?(ve=!0,rt(),1):0}function zi(){we=pt(re)?5:1,Me=1,ve=Ta(),K!==re&&I.assert(!!K,"Expected 'contextToken' to be defined when different from 'previousToken'.");let he=K!==re?K.getStart():s,qe=Ni(re,he,n)||n;O=un(qe);let Le=(ke?0:111551)|788968|1920|2097152,It=K&&!ET(K);Ae=ys(Ae,h.getSymbolsInScope(qe,Le)),I.assertEachIsDefined(Ae,"getSymbolsInScope() should all be defined");for(let Rt=0;Rt<Ae.length;Rt++){let Zt=Ae[Rt];if(!h.isArgumentsSymbol(Zt)&&!Tt(Zt.declarations,Ir=>Ir.getSourceFile()===n)&&(Ue[Ia(Zt)]=C_.GlobalsOrKeywords),It&&!(Zt.flags&111551)){let Ir=Zt.declarations&&mr(Zt.declarations,t8);if(Ir){let zr={kind:64,declaration:Ir};Re[Rt]=zr}}}if(o.includeCompletionsWithInsertText&&qe.kind!==312){let Rt=h.tryGetThisTypeAt(qe,!1,Ti(qe.parent)?qe:void 0);if(Rt&&!cwt(Rt,n,h))for(let Zt of Vie(Rt,h))Re[Ae.length]={kind:1},Ae.push(Zt),Ue[Ia(Zt)]=C_.SuggestedClassMembers}rt(),ke&&(we=re&&U2(re.parent)?6:7)}function Ms(){return ce?!0:o.includeCompletionsForModuleExports?n.externalModuleIndicator||n.commonJsModuleIndicator||Tte(e.getCompilerOptions())?!0:A1e(e):!1}function un(he){switch(he.kind){case 312:case 228:case 294:case 241:return!0;default:return ns(he)}}function ri(){return M||!!ce&&dT(ye.parent)||!On(re)&&(QM(re,n,h)||A0(ye)||_r(re))}function On(he){return he&&(he.kind===114&&(he.parent.kind===186||zN(he.parent))||he.kind===131&&he.parent.kind===182)}function _r(he){if(he){let qe=he.parent.kind;switch(he.kind){case 59:return qe===172||qe===171||qe===169||qe===260||yA(qe);case 64:return qe===265||qe===168;case 130:return qe===234;case 30:return qe===183||qe===216;case 96:return qe===168;case 152:return qe===238}}return!1}function rt(){var he,qe;if(!Ms()||(I.assert(!l?.data,"Should not run 'collectAutoImports' when faster path is available via `data`"),l&&!l.source))return;oe|=1;let It=K===re&&ce?"":K&&ze(K)?K.text.toLowerCase():"",Rt=(he=p.getModuleSpecifierCache)==null?void 0:he.call(p),Zt=d7(n,p,e,o,S),Ir=(qe=p.getPackageJsonAutoImportProvider)==null?void 0:qe.call(p),zr=l?void 0:OO(n,o,p);FUe("collectAutoImports",p,Ie||(Ie=x_.createImportSpecifierResolver(n,e,p,o)),e,s,o,!!ce,ET(ye),Pi=>{Zt.search(n.path,Se,(Fi,fn)=>{if(!nd(Fi,ho(p.getCompilationSettings()))||!l&&PA(Fi)||!ke&&!ce&&!(fn&111551)||ke&&!(fn&790504))return!1;let Qn=Fi.charCodeAt(0);return Se&&(Qn<65||Qn>90)?!1:l?!0:lVe(Fi,It)},(Fi,fn,Qn,Ns)=>{if(l&&!Tt(Fi,Qo=>l.source===cm(Qo.moduleSymbol.name))||(Fi=Fn(Fi,Yr),!Fi.length))return;let Vi=Pi.tryResolve(Fi,Qn)||{};if(Vi==="failed")return;let ji=Fi[0],ni;Vi!=="skipped"&&({exportInfo:ji=Fi[0],moduleSpecifier:ni}=Vi);let js=ji.exportKind===1,Mr=js&&PN(ji.symbol)||ji.symbol;zt(Mr,{kind:ni?32:4,moduleSpecifier:ni,symbolName:fn,exportMapKey:Ns,exportName:ji.exportKind===2?"export=":ji.symbol.name,fileName:ji.moduleFileName,isDefaultExport:js,moduleSymbol:ji.moduleSymbol,isFromPackageJson:ji.isFromPackageJson})}),Ge=Pi.skippedAny(),oe|=Pi.resolvedAny()?8:0,oe|=Pi.resolvedBeyondLimit()?16:0});function Yr(Pi){let Fi=ii(Pi.moduleSymbol.valueDeclaration,ls);if(!Fi){let fn=cm(Pi.moduleSymbol.name);return sh.nodeCoreModules.has(fn)&&Ss(fn,"node:")!==RJ(n,e)?!1:zr?zr.allowsImportingAmbientModule(Pi.moduleSymbol,$e(Pi.isFromPackageJson)):!0}return tre(Pi.isFromPackageJson?Ir:e,n,Fi,o,zr,$e(Pi.isFromPackageJson),Rt)}}function zt(he,qe){let Le=Ia(he);Ue[Le]!==C_.GlobalsOrKeywords&&(Re[Ae.length]=qe,Ue[Le]=ce?C_.LocationPriority:C_.AutoImportSuggestions,Ae.push(he))}function Rr(he,qe){gn(ye)||he.forEach(Le=>{if(!vi(Le))return;let It=jie(Le,ho(i),void 0,0,!1);if(!It)return;let{name:Rt}=It,Zt=VIt(Le,Rt,qe,e,p,i,o,m);if(!Zt)return;let Ir={kind:128,...Zt};oe|=32,Re[Ae.length]=Ir,Ae.push(Le)})}function vi(he){return!!(he.flags&8196)}function Ni(he,qe,Le){let It=he;for(;It&&!ote(It,qe,Le);)It=It.parent;return It}function us(he){let qe=uc(),Le=to(he)||Nt(he)||Wt(he)||Fs(he)||KB(he);return t("getCompletionsAtPosition: isCompletionListBlocker: "+(uc()-qe)),Le}function Fs(he){if(he.kind===12)return!0;if(he.kind===32&&he.parent){if(ye===he.parent&&(ye.kind===286||ye.kind===285))return!1;if(he.parent.kind===286)return ye.parent.kind!==286;if(he.parent.kind===287||he.parent.kind===285)return!!he.parent.parent&&he.parent.parent.kind===284}return!1}function Ta(){if(re){let he=re.parent.kind,qe=Bie(re);switch(qe){case 28:return he===213||he===176||he===214||he===209||he===226||he===184||he===210;case 21:return he===213||he===176||he===214||he===217||he===196;case 23:return he===209||he===181||he===167;case 144:case 145:case 102:return!0;case 25:return he===267;case 19:return he===263||he===210;case 64:return he===260||he===226;case 16:return he===228;case 17:return he===239;case 134:return he===174||he===304;case 42:return he===174}if(Dq(qe))return!0}return!1}function to(he){return(NK(he)||cY(he))&&(YM(he,s)||s===he.end&&(!!he.isUnterminated||NK(he)))}function Nr(){let he=awt(re);if(!he)return 0;let Le=(KA(he.parent)?he.parent:void 0)||he,It=rVe(Le,h);if(!It)return 0;let Rt=h.getTypeFromTypeNode(Le),Zt=Vie(It,h),Ir=Vie(Rt,h),zr=new Set;return Ir.forEach(Yr=>zr.add(Yr.escapedName)),Ae=ys(Ae,Fn(Zt,Yr=>!zr.has(Yr.escapedName))),Me=0,ve=!0,1}function qr(){let he=Ae.length,qe=ewt(re,s,n);if(!qe)return 0;Me=0;let Le,It;if(qe.kind===210){let Rt=uwt(qe,h);if(Rt===void 0)return qe.flags&67108864?2:0;let Zt=h.getContextualType(qe,4),Ir=(Zt||Rt).getStringIndexType(),zr=(Zt||Rt).getNumberIndexType();if(ve=!!Ir||!!zr,Le=Uie(Rt,Zt,qe,h),It=qe.properties,Le.length===0&&!zr)return 0}else{I.assert(qe.kind===206),ve=!1;let Rt=Gg(qe.parent);if(!cN(Rt))return I.fail("Root declaration is not variable-like.");let Zt=jv(Rt)||!!t_(Rt)||Rt.parent.parent.kind===250;if(!Zt&&Rt.kind===169&&(bt(Rt.parent)?Zt=!!h.getContextualType(Rt.parent):(Rt.parent.kind===174||Rt.parent.kind===178)&&(Zt=bt(Rt.parent.parent)&&!!h.getContextualType(Rt.parent.parent))),Zt){let Ir=h.getTypeAtLocation(qe);if(!Ir)return 2;Le=h.getPropertiesOfType(Ir).filter(zr=>h.isPropertyAccessible(qe,!1,!1,Ir,zr)),It=qe.elements}}if(Le&&Le.length>0){let Rt=hr(Le,I.checkDefined(It));Ae=ys(Ae,Rt),Y(),qe.kind===210&&o.includeCompletionsWithObjectLiteralMethodSnippets&&o.includeCompletionsWithInsertText&&(Lt(he),Rr(Rt,qe))}return 1}function We(){if(!re)return 0;let he=re.kind===19||re.kind===28?ii(re.parent,Vj):pJ(re)?ii(re.parent.parent,Vj):void 0;if(!he)return 0;pJ(re)||(we=8);let{moduleSpecifier:qe}=he.kind===275?he.parent.parent:he.parent;if(!qe)return ve=!0,he.kind===275?2:0;let Le=h.getSymbolAtLocation(qe);if(!Le)return ve=!0,2;Me=3,ve=!1;let It=h.getExportsAndPropertiesOfModule(Le),Rt=new Set(he.elements.filter(Ir=>!X(Ir)).map(Ir=>(Ir.propertyName||Ir.name).escapedText)),Zt=It.filter(Ir=>Ir.escapedName!=="default"&&!Rt.has(Ir.escapedName));return Ae=ys(Ae,Zt),Zt.length||(we=0),1}function mt(){if(re===void 0)return 0;let he=re.kind===19||re.kind===28?ii(re.parent,tk):re.kind===59?ii(re.parent.parent,tk):void 0;if(he===void 0)return 0;let qe=new Set(he.elements.map(uB));return Ae=Fn(h.getTypeAtLocation(he).getApparentProperties(),Le=>!qe.has(Le.escapedName)),1}function dt(){var he;let qe=re&&(re.kind===19||re.kind===28)?ii(re.parent,wd):void 0;if(!qe)return 0;let Le=Gr(qe,cg(ls,hl));return Me=5,ve=!1,(he=Le.locals)==null||he.forEach((It,Rt)=>{var Zt,Ir;Ae.push(It),(Ir=(Zt=Le.symbol)==null?void 0:Zt.exports)!=null&&Ir.has(Rt)&&(Ue[Ia(It)]=C_.OptionalMember)}),1}function Ot(){let he=swt(n,re,ye,s);if(!he)return 0;if(Me=3,ve=!0,we=re.kind===42?0:Ti(he)?2:3,!Ti(he))return 1;let qe=re.kind===27?re.parent.parent:re.parent,Le=Du(qe)?X_(qe):0;if(re.kind===80&&!X(re))switch(re.getText()){case"private":Le=Le|2;break;case"static":Le=Le|256;break;case"override":Le=Le|16;break}if(Jc(qe)&&(Le|=256),!(Le&2)){let It=Ti(he)&&Le&16?_A($g(he)):Yw(he),Rt=_a(It,Zt=>{let Ir=h.getTypeAtLocation(Zt);return Le&256?Ir?.symbol&&h.getPropertiesOfType(h.getTypeOfSymbolAtLocation(Ir.symbol,he)):Ir&&h.getPropertiesOfType(Ir)});Ae=ys(Ae,B(Rt,he.members,Le)),Te(Ae,(Zt,Ir)=>{let zr=Zt?.valueDeclaration;if(zr&&Du(zr)&&zr.name&&uo(zr.name)){let Yr={kind:512,symbolName:h.symbolToString(Zt)};Re[Ir]=Yr}})}return 1}function _e(he){return!!he.parent&&Ls(he.parent)&&Yc(he.parent.parent)&&(Rw(he.kind)||Cy(he))}function Ve(he){if(he){let qe=he.parent;switch(he.kind){case 21:case 28:return Yc(he.parent)?he.parent:void 0;default:if(_e(he))return qe.parent}}}function pt(he){if(he){let qe,Le=Gr(he.parent,It=>Ti(It)?"quit":tc(It)&&qe===It.body?!0:(qe=It,!1));return Le&&Le}}function W(he){if(he){let qe=he.parent;switch(he.kind){case 32:case 31:case 44:case 80:case 211:case 292:case 291:case 293:if(qe&&(qe.kind===285||qe.kind===286)){if(he.kind===32){let Le=tu(he.pos,n,void 0);if(!qe.typeArguments||Le&&Le.kind===44)break}return qe}else if(qe.kind===291)return qe.parent.parent;break;case 11:if(qe&&(qe.kind===291||qe.kind===293))return qe.parent.parent;break;case 20:if(qe&&qe.kind===294&&qe.parent&&qe.parent.kind===291)return qe.parent.parent.parent;if(qe&&qe.kind===293)return qe.parent.parent;break}}}function st(he,qe){return n.getLineEndOfPosition(he.getEnd())<qe}function Nt(he){let qe=he.parent,Le=qe.kind;switch(he.kind){case 28:return Le===260||Cr(he)||Le===243||Le===266||ht(Le)||Le===264||Le===207||Le===265||Ti(qe)&&!!qe.typeParameters&&qe.typeParameters.end>=he.pos;case 25:return Le===207;case 59:return Le===208;case 23:return Le===207;case 21:return Le===299||ht(Le);case 19:return Le===266;case 30:return Le===263||Le===231||Le===264||Le===265||yA(Le);case 126:return Le===172&&!Ti(qe.parent);case 26:return Le===169||!!qe.parent&&qe.parent.kind===207;case 125:case 123:case 124:return Le===169&&!Yc(qe.parent);case 130:return Le===276||Le===281||Le===274;case 139:case 153:return!Jie(he);case 80:{if(Le===276&&he===qe.name&&he.text==="type"||Gr(he.parent,Gi)&&st(he,s))return!1;break}case 86:case 94:case 120:case 100:case 115:case 102:case 121:case 87:case 140:return!0;case 156:return Le!==276;case 42:return ca(he.parent)&&!pl(he.parent)}if(Dq(Bie(he))&&Jie(he)||_e(he)&&(!ze(he)||Rw(Bie(he))||X(he)))return!1;switch(Bie(he)){case 128:case 86:case 87:case 138:case 94:case 100:case 120:case 121:case 123:case 124:case 125:case 126:case 115:return!0;case 134:return ea(he.parent)}if(Gr(he.parent,Ti)&&he===K&&Ke(he,s))return!1;let Rt=ST(he.parent,172);if(Rt&&he!==K&&Ti(K.parent.parent)&&s<=K.end){if(Ke(he,K.end))return!1;if(he.kind!==64&&(bM(Rt)||L9(Rt)))return!0}return Cy(he)&&!Hf(he.parent)&&!th(he.parent)&&!((Ti(he.parent)||ef(he.parent)||Nc(he.parent))&&(he!==K||s>K.end))}function Ke(he,qe){return he.kind!==64&&(he.kind===27||!Pd(he.end,qe,n))}function ht(he){return yA(he)&&he!==176}function Wt(he){if(he.kind===9){let qe=he.getFullText();return qe.charAt(qe.length-1)==="."}return!1}function Cr(he){return he.parent.kind===261&&!QM(he,n,h)}function hr(he,qe){if(qe.length===0)return he;let Le=new Set,It=new Set;for(let Zt of qe){if(Zt.kind!==303&&Zt.kind!==304&&Zt.kind!==208&&Zt.kind!==174&&Zt.kind!==177&&Zt.kind!==178&&Zt.kind!==305||X(Zt))continue;let Ir;if(F1(Zt))Sr(Zt,Le);else if(co(Zt)&&Zt.propertyName)Zt.propertyName.kind===80&&(Ir=Zt.propertyName.escapedText);else{let zr=qs(Zt);Ir=zr&&Wg(zr)?Qw(zr):void 0}Ir!==void 0&&It.add(Ir)}let Rt=he.filter(Zt=>!It.has(Zt.escapedName));return Be(Le,Rt),Rt}function Sr(he,qe){let Le=he.expression,It=h.getSymbolAtLocation(Le),Rt=It&&h.getTypeOfSymbolAtLocation(It,Le),Zt=Rt&&Rt.properties;Zt&&Zt.forEach(Ir=>{qe.add(Ir.name)})}function Y(){Ae.forEach(he=>{if(he.flags&16777216){let qe=Ia(he);Ue[qe]=Ue[qe]??C_.OptionalMember}})}function Be(he,qe){if(he.size!==0)for(let Le of qe)he.has(Le.name)&&(Ue[Ia(Le)]=C_.MemberDeclaredBySpreadAssignment)}function Lt(he){for(let qe=he;qe<Ae.length;qe++){let Le=Ae[qe],It=Ia(Le),Rt=Re?.[qe],Zt=ho(i),Ir=jie(Le,Zt,Rt,0,!1);if(Ir){let zr=Ue[It]??C_.LocationPriority,{name:Yr}=Ir;Ue[It]=C_.ObjectLiteralProperty(zr,Yr)}}}function B(he,qe,Le){let It=new Set;for(let Rt of qe){if(Rt.kind!==172&&Rt.kind!==174&&Rt.kind!==177&&Rt.kind!==178||X(Rt)||up(Rt,2)||pa(Rt)!==!!(Le&256))continue;let Zt=K2(Rt.name);Zt&&It.add(Zt)}return he.filter(Rt=>!It.has(Rt.escapedName)&&!!Rt.declarations&&!(Nd(Rt)&2)&&!(Rt.valueDeclaration&&G_(Rt.valueDeclaration)))}function le(he,qe){let Le=new Set,It=new Set;for(let Zt of qe)X(Zt)||(Zt.kind===291?Le.add(A6(Zt.name)):ik(Zt)&&Sr(Zt,It));let Rt=he.filter(Zt=>!Le.has(Zt.escapedName));return Be(It,Rt),Rt}function X(he){return he.getStart(n)<=s&&s<=he.getEnd()}}function ewt(e,t,n){var i;if(e){let{parent:s}=e;switch(e.kind){case 19:case 28:if(Ha(s)||pm(s))return s;break;case 42:return pl(s)?ii(s.parent,Ha):void 0;case 134:return ii(s.parent,Ha);case 80:if(e.text==="async"&&Hf(e.parent))return e.parent.parent;{if(Ha(e.parent.parent)&&(F1(e.parent)||Hf(e.parent)&&Lo(n,e.getEnd()).line!==Lo(n,t).line))return e.parent.parent;let l=Gr(s,Ul);if(l?.getLastToken(n)===e&&Ha(l.parent))return l.parent}break;default:if((i=s.parent)!=null&&i.parent&&(pl(s.parent)||sd(s.parent)||pp(s.parent))&&Ha(s.parent.parent))return s.parent.parent;if(F1(s)&&Ha(s.parent))return s.parent;let o=Gr(s,Ul);if(e.kind!==59&&o?.getLastToken(n)===e&&Ha(o.parent))return o.parent}}}function Fie(e,t){let n=tu(e,t);return n&&e<=n.end&&(E0(n)||Nf(n.kind))?{contextToken:tu(n.getFullStart(),t,void 0),previousToken:n}:{contextToken:n,previousToken:n}}function XUe(e,t,n,i){let s=t.isPackageJsonImport?i.getPackageJsonAutoImportProvider():n,o=s.getTypeChecker(),l=t.ambientModuleName?o.tryFindAmbientModule(t.ambientModuleName):t.fileName?o.getMergedSymbol(I.checkDefined(s.getSourceFile(t.fileName)).symbol):void 0;if(!l)return;let p=t.exportName==="export="?o.resolveExternalModuleSymbol(l):o.tryGetMemberInModuleExportsAndProperties(t.exportName,l);return p?(p=t.exportName==="default"&&PN(p)||p,{symbol:p,origin:qIt(t,e,l)}):void 0}function jie(e,t,n,i,s){if(CIt(n))return;let o=TIt(n)?n.symbolName:e.name;if(o===void 0||e.flags&1536&&P8(o.charCodeAt(0))||H8(e))return;let l={name:o,needsConvertPropertyAccess:!1};if(nd(o,t,s?1:0)||e.valueDeclaration&&G_(e.valueDeclaration))return l;switch(i){case 3:return Dbe(n)?{name:n.symbolName,needsConvertPropertyAccess:!1}:void 0;case 0:return{name:JSON.stringify(o),needsConvertPropertyAccess:!1};case 2:case 1:return o.charCodeAt(0)===32?void 0:{name:o,needsConvertPropertyAccess:!0};case 5:case 4:return l;default:I.assertNever(i)}}function KUe(e,t){if(!t)return QUe(e);let n=e+8+1;return Iq[n]||(Iq[n]=QUe(e).filter(i=>!twt(Fb(i.name))))}function QUe(e){return Iq[e]||(Iq[e]=zbe().filter(t=>{let n=Fb(t.name);switch(e){case 0:return!1;case 1:return eVe(n)||n===138||n===144||n===156||n===145||n===128||CO(n)&&n!==157;case 5:return eVe(n);case 2:return Dq(n);case 3:return ZUe(n);case 4:return Rw(n);case 6:return CO(n)||n===87;case 7:return CO(n);case 8:return n===156;default:return I.assertNever(e)}}))}function twt(e){switch(e){case 128:case 133:case 163:case 136:case 138:case 94:case 162:case 119:case 140:case 120:case 142:case 143:case 144:case 145:case 146:case 150:case 151:case 164:case 123:case 124:case 125:case 148:case 154:case 155:case 156:case 158:case 159:return!0;default:return!1}}function ZUe(e){return e===148}function Dq(e){switch(e){case 128:case 129:case 137:case 139:case 153:case 134:case 138:case 164:return!0;default:return lY(e)}}function eVe(e){return e===134||e===135||e===160||e===130||e===152||e===156||!Sj(e)&&!Dq(e)}function Bie(e){return ze(e)?uT(e)??0:e.kind}function rwt(e,t){let n=[];if(e){let i=e.getSourceFile(),s=e.parent,o=i.getLineAndCharacterOfPosition(e.end).line,l=i.getLineAndCharacterOfPosition(t).line;(uu(s)||yl(s)&&s.moduleSpecifier)&&e===s.moduleSpecifier&&o===l&&n.push({name:Sa(132),kind:"keyword",kindModifiers:"",sortText:C_.GlobalsOrKeywords})}return n}function nwt(e,t){return Gr(e,n=>eN(n)&&HM(n,t)?!0:dg(n)?"quit":!1)}function Uie(e,t,n,i){let s=t&&t!==e,o=s&&!(t.flags&3)?i.getUnionType([e,t]):e,l=iwt(o,n,i);return o.isClass()&&tVe(l)?[]:s?Fn(l,p):l;function p(m){return de(m.declarations)?Tt(m.declarations,S=>S.parent!==n):!0}}function iwt(e,t,n){return e.isUnion()?n.getAllPossiblePropertiesOfTypes(Fn(e.types,i=>!(i.flags&402784252||n.isArrayLikeType(i)||n.isTypeInvalidDueToUnionDiscriminant(i,t)||n.typeHasCallOrConstructSignatures(i)||i.isClass()&&tVe(i.getApparentProperties())))):e.getApparentProperties()}function tVe(e){return Tt(e,t=>!!(Nd(t)&6))}function Vie(e,t){return e.isUnion()?I.checkEachDefined(t.getAllPossiblePropertiesOfTypes(e.types),"getAllPossiblePropertiesOfTypes() should all be defined"):I.checkEachDefined(e.getApparentProperties(),"getApparentProperties() should all be defined")}function swt(e,t,n,i){switch(n.kind){case 358:return ii(n.parent,OA);case 1:let s=ii(Is(ta(n.parent,ls).statements),OA);if(s&&!Oo(s,20,e))return s;break;case 81:if(ii(n.parent,ea))return Gr(n,Ti);break;case 80:{if(uT(n)||ea(n.parent)&&n.parent.initializer===n)return;if(Jie(n))return Gr(n,OA)}}if(t){if(n.kind===137||ze(t)&&ea(t.parent)&&Ti(n))return Gr(t,Ti);switch(t.kind){case 64:return;case 27:case 20:return Jie(n)&&n.parent.name===n?n.parent.parent:ii(n,OA);case 19:case 28:return ii(t.parent,OA);default:if(OA(n)){if(Lo(e,t.getEnd()).line!==Lo(e,i).line)return n;let s=Ti(t.parent.parent)?Dq:ZUe;return s(t.kind)||t.kind===42||ze(t)&&s(uT(t)??0)?t.parent.parent:void 0}return}}}function awt(e){if(!e)return;let t=e.parent;switch(e.kind){case 19:if(dp(t))return t;break;case 27:case 28:case 80:if(t.kind===171&&dp(t.parent))return t.parent;break}}function rVe(e,t){if(!e)return;if(es(e)&&F9(e.parent))return t.getTypeArgumentConstraint(e);let n=rVe(e.parent,t);if(n)switch(e.kind){case 171:return t.getTypeOfPropertyOfContextualType(n,e.symbol.escapedName);case 193:case 187:case 192:return n}}function Jie(e){return e.parent&&N9(e.parent)&&OA(e.parent.parent)}function owt(e,t,n,i){switch(t){case".":case"@":return!0;case'"':case"'":case"`":return!!n&&q1e(n)&&i===n.getStart(e)+1;case"#":return!!n&&is(n)&&!!Vu(n);case"<":return!!n&&n.kind===30&&(!bn(n.parent)||nVe(n.parent));case"/":return!!n&&(bo(n)?!!F8(n):n.kind===44&&fE(n.parent));case" ":return!!n&&L6(n)&&n.parent.kind===312;default:return I.assertNever(t)}}function nVe({left:e}){return sl(e)}function cwt(e,t,n){let i=n.resolveName("self",void 0,111551,!1);if(i&&n.getTypeOfSymbolAtLocation(i,t)===e)return!0;let s=n.resolveName("global",void 0,111551,!1);if(s&&n.getTypeOfSymbolAtLocation(s,t)===e)return!0;let o=n.resolveName("globalThis",void 0,111551,!1);return!!(o&&n.getTypeOfSymbolAtLocation(o,t)===e)}function lwt(e){return!!(e.valueDeclaration&&X_(e.valueDeclaration)&256&&Ti(e.valueDeclaration.parent))}function uwt(e,t){let n=t.getContextualType(e);if(n)return n;let i=P1(e.parent);if(bn(i)&&i.operatorToken.kind===64&&e===i.left)return t.getTypeAtLocation(i);if(bt(i))return t.getContextualType(i)}function iVe(e,t){var n,i,s;let o,l=!1,p=m();return{isKeywordOnlyCompletion:l,keywordCompletion:o,isNewIdentifierLocation:!!(p||o===156),isTopLevelTypeOnly:!!((i=(n=ii(p,uu))==null?void 0:n.importClause)!=null&&i.isTypeOnly)||!!((s=ii(p,Ru))!=null&&s.isTypeOnly),couldBeTypeOnlyImportSpecifier:!!p&&aVe(p,e),replacementSpan:_wt(p)};function m(){let S=e.parent;if(Ru(S)){let h=S.getLastToken(t);if(ze(e)&&h!==e){o=161,l=!0;return}return o=e.kind===156?void 0:156,jbe(S.moduleReference)?S:void 0}if(aVe(S,e)&&oVe(S.parent))return S;if(Dy(S)||tS(S)){if(!S.parent.isTypeOnly&&(e.kind===19||e.kind===102||e.kind===28)&&(o=156),oVe(S))if(e.kind===20||e.kind===80)l=!0,o=161;else return S.parent.parent;return}if(yl(S)&&e.kind===42||wd(S)&&e.kind===20){l=!0,o=161;return}if(L6(e)&&ls(S))return o=156,e;if(L6(e)&&uu(S))return o=156,jbe(S.moduleSpecifier)?S:void 0}}function _wt(e){var t;if(!e)return;let n=Gr(e,cg(uu,Ru))??e,i=n.getSourceFile();if(rx(n,i))return gf(n,i);I.assert(n.kind!==102&&n.kind!==276);let s=n.kind===272?sVe((t=n.importClause)==null?void 0:t.namedBindings)??n.moduleSpecifier:n.moduleReference,o={pos:n.getFirstToken().getStart(),end:s.pos};if(rx(o,i))return aS(o)}function sVe(e){var t;return mr((t=ii(e,Dy))==null?void 0:t.elements,n=>{var i;return!n.propertyName&&PA(n.name.text)&&((i=tu(n.name.pos,e.getSourceFile(),e))==null?void 0:i.kind)!==28})}function aVe(e,t){return Gf(e)&&(e.isTypeOnly||t===e.name&&pJ(t))}function oVe(e){if(!jbe(e.parent.parent.moduleSpecifier)||e.parent.name)return!1;if(Dy(e)){let t=sVe(e);return(t?e.elements.indexOf(t):e.elements.length)<2}return!0}function jbe(e){var t;return sl(e)?!0:!((t=ii(zh(e)?e.expression:e,bo))!=null&&t.text)}function fwt(e,t){if(!e)return;let n=Gr(e,s=>Wb(s)||cVe(s)||la(s)?"quit":(Ls(s)||Nc(s))&&!oE(s.parent)),i=Gr(t,s=>Wb(s)||cVe(s)||la(s)?"quit":Gi(s));return n||i}function cVe(e){return e.parent&&rc(e.parent)&&(e.parent.body===e||e.kind===39)}function Bbe(e,t,n=new Map){return i(e)||i(r_(e.exportSymbol||e,t));function i(s){return!!(s.flags&788968)||t.isUnknownSymbol(s)||!!(s.flags&1536)&&Bm(n,Ia(s))&&t.getExportsOfModule(s).some(o=>Bbe(o,t,n))}}function pwt(e,t){let n=r_(e,t).declarations;return!!de(n)&&yr(n,OJ)}function lVe(e,t){if(t.length===0)return!0;let n=!1,i,s=0,o=e.length;for(let l=0;l<o;l++){let p=e.charCodeAt(l),m=t.charCodeAt(s);if((p===m||p===dwt(m))&&(n||(n=i===void 0||97<=i&&i<=122&&65<=p&&p<=90||i===95&&p!==95),n&&s++,s===t.length))return!0;i=p}return!1}function dwt(e){return 97<=e&&e<=122?e-32:e}function mwt(e){return e==="abstract"||e==="async"||e==="await"||e==="declare"||e==="module"||e==="namespace"||e==="type"}var qie,Ube,C_,Vbe,Jbe,qbe,Iq,zbe,gwt=f({"src/services/completions.ts"(){"use strict";yi(),Kbe(),qie=100,Ube=1e3,C_={LocalDeclarationPriority:"10",LocationPriority:"11",OptionalMember:"12",MemberDeclaredBySpreadAssignment:"13",SuggestedClassMembers:"14",GlobalsOrKeywords:"15",AutoImportSuggestions:"16",ClassMemberSnippets:"17",JavascriptIdentifiers:"18",Deprecated(e){return"z"+e},ObjectLiteralProperty(e,t){return`${e}\0${t}\0`},SortBelow(e){return e+"1"}},Vbe=(e=>(e.ThisProperty="ThisProperty/",e.ClassMemberSnippet="ClassMemberSnippet/",e.TypeOnlyAlias="TypeOnlyAlias/",e.ObjectLiteralMethodSnippet="ObjectLiteralMethodSnippet/",e.SwitchCases="SwitchCases/",e.ObjectLiteralMemberWithComma="ObjectLiteralMemberWithComma/",e))(Vbe||{}),Jbe=(e=>(e[e.ThisType=1]="ThisType",e[e.SymbolMember=2]="SymbolMember",e[e.Export=4]="Export",e[e.Promise=8]="Promise",e[e.Nullable=16]="Nullable",e[e.ResolvedExport=32]="ResolvedExport",e[e.TypeOnlyAlias=64]="TypeOnlyAlias",e[e.ObjectLiteralMethod=128]="ObjectLiteralMethod",e[e.Ignore=256]="Ignore",e[e.ComputedPropertyName=512]="ComputedPropertyName",e[e.SymbolMemberNoExport=2]="SymbolMemberNoExport",e[e.SymbolMemberExport=6]="SymbolMemberExport",e))(Jbe||{}),qbe=(e=>(e[e.ObjectPropertyDeclaration=0]="ObjectPropertyDeclaration",e[e.Global=1]="Global",e[e.PropertyAccess=2]="PropertyAccess",e[e.MemberLike=3]="MemberLike",e[e.String=4]="String",e[e.None=5]="None",e))(qbe||{}),Iq=[],zbe=D_(()=>{let e=[];for(let t=83;t<=165;t++)e.push({name:Sa(t),kind:"keyword",kindModifiers:"",sortText:C_.GlobalsOrKeywords});return e})}});function $be(){let e=new Map;function t(n){let i=e.get(n.name);(!i||Xbe[i.kind]<Xbe[n.kind])&&e.set(n.name,n)}return{add:t,has:e.has.bind(e),values:e.values.bind(e)}}function hwt(e,t,n,i,s,o,l,p,m){if(x1e(e,t)){let S=Owt(e,t,i,s);return S&&uVe(S)}if(hk(e,t,n)){if(!n||!bo(n))return;let S=fVe(e,n,t,o,s,p);return ywt(S,n,e,s,o,l,i,p,t,m)}}function ywt(e,t,n,i,s,o,l,p,m,S){if(e===void 0)return;let h=hte(t);switch(e.kind){case 0:return uVe(e.paths);case 1:{let b=h1();return Rbe(e.symbols,b,t,t,n,m,n,i,s,99,o,4,p,l,void 0,void 0,void 0,void 0,void 0,void 0,void 0,void 0,void 0,void 0,void 0,S),{isGlobalCompletion:!1,isMemberCompletion:!0,isNewIdentifierLocation:e.hasIndexSignature,optionalReplacementSpan:h,entries:b}}case 2:{let b=t.kind===15?96:Ss(Fl(t),"'")?39:34,A=e.types.map(k=>({name:D0(k.value,b),kindModifiers:"",kind:"string",sortText:C_.LocationPriority,replacementSpan:gte(t)}));return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:e.isNewIdentifier,optionalReplacementSpan:h,entries:A}}default:return I.assertNever(e)}}function vwt(e,t,n,i,s,o,l,p){if(!i||!bo(i))return;let m=fVe(t,i,n,s,o,p);return m&&Swt(e,i,m,t,s.getTypeChecker(),l)}function Swt(e,t,n,i,s,o){switch(n.kind){case 0:{let l=mr(n.paths,p=>p.name===e);return l&&Nq(e,_Ve(l.extension),l.kind,[fd(e)])}case 1:{let l=mr(n.symbols,p=>p.name===e);return l&&Lbe(l,l.name,s,i,t,o)}case 2:return mr(n.types,l=>l.value===e)?Nq(e,"","string",[fd(e)]):void 0;default:return I.assertNever(n)}}function uVe(e){return{isGlobalCompletion:!1,isMemberCompletion:!1,isNewIdentifierLocation:!0,entries:e.map(({name:s,kind:o,span:l,extension:p})=>({name:s,kind:o,kindModifiers:_Ve(p),sortText:C_.LocationPriority,replacementSpan:l}))}}function _Ve(e){switch(e){case".d.ts":return".d.ts";case".js":return".js";case".json":return".json";case".jsx":return".jsx";case".ts":return".ts";case".tsx":return".tsx";case".d.mts":return".d.mts";case".mjs":return".mjs";case".mts":return".mts";case".d.cts":return".d.cts";case".cjs":return".cjs";case".cts":return".cts";case".tsbuildinfo":return I.fail("Extension .tsbuildinfo is unsupported.");case void 0:return"";default:return I.assertNever(e)}}function fVe(e,t,n,i,s,o){let l=i.getTypeChecker(),p=Wbe(t.parent);switch(p.kind){case 201:{let k=Wbe(p.parent);return k.kind===205?{kind:0,paths:mVe(e,t,i,s,o)}:m(k)}case 303:return Ha(p.parent)&&p.name===t?Ewt(l,p.parent):S()||S(0);case 212:{let{expression:k,argumentExpression:N}=p;return t===Do(N)?pVe(l.getTypeAtLocation(k)):void 0}case 213:case 214:case 291:if(!Fwt(t)&&!Up(p)){let k=W7.getArgumentInfoForCompletions(p.kind===291?p.parent:t,n,e,l);return k&&bwt(k.invocation,t,k,l)||S(0)}case 272:case 278:case 283:return{kind:0,paths:mVe(e,t,i,s,o)};case 296:let h=LJ(l,p.parent.clauses),b=S();return b?{kind:2,types:b.types.filter(k=>!h.hasValue(k.value)),isNewIdentifier:!1}:void 0;default:return S()||S(0)}function m(h){switch(h.kind){case 233:case 183:{let k=Gr(p,N=>N.parent===h);return k?{kind:2,types:zie(l.getTypeArgumentConstraint(k)),isNewIdentifier:!1}:void 0}case 199:let{indexType:b,objectType:A}=h;return HM(b,n)?pVe(l.getTypeFromTypeNode(A)):void 0;case 192:{let k=m(Wbe(h.parent));if(!k)return;let N=Twt(h,p);return k.kind===1?{kind:1,symbols:k.symbols.filter(M=>!hs(N,M.name)),hasIndexSignature:k.hasIndexSignature}:{kind:2,types:k.types.filter(M=>!hs(N,M.value)),isNewIdentifier:!1}}default:return}}function S(h=4){let b=zie(EJ(t,l,h));if(b.length)return{kind:2,types:b,isNewIdentifier:!1}}}function Wbe(e){switch(e.kind){case 196:return J8(e);case 217:return P1(e);default:return e}}function Twt(e,t){return Wi(e.types,n=>n!==t&&Qv(n)&&za(n.literal)?n.literal.text:void 0)}function bwt(e,t,n,i){let s=!1,o=new Map,l=H_(e)?I.checkDefined(Gr(t.parent,th)):t,p=i.getCandidateSignaturesForStringLiteralCompletions(e,l),m=_a(p,S=>{if(!L_(S)&&n.argumentCount>S.parameters.length)return;let h=S.getTypeParameterAtPosition(n.argumentIndex);if(H_(e)){let b=i.getTypeOfPropertyOfType(h,dR(l.name));b&&(h=b)}return s=s||!!(h.flags&4),zie(h,o)});return de(m)?{kind:2,types:m,isNewIdentifier:s}:void 0}function pVe(e){return e&&{kind:1,symbols:Fn(e.getApparentProperties(),t=>!(t.valueDeclaration&&G_(t.valueDeclaration))),hasIndexSignature:jte(e)}}function Ewt(e,t){let n=e.getContextualType(t);if(!n)return;let i=e.getContextualType(t,4);return{kind:1,symbols:Uie(n,i,t,e),hasIndexSignature:jte(n)}}function zie(e,t=new Map){return e?(e=Ste(e),e.isUnion()?_a(e.types,n=>zie(n,t)):e.isStringLiteral()&&!(e.flags&1024)&&Bm(t,e.value)?[e]:tt):tt}function VO(e,t,n){return{name:e,kind:t,extension:n}}function Gbe(e){return VO(e,"directory",void 0)}function dVe(e,t,n){let i=Mwt(e,t),s=e.length===0?void 0:e_(t,e.length);return n.map(({name:o,kind:l,extension:p})=>o.includes(hc)||o.includes(B3)?{name:o,kind:l,extension:p,span:s}:{name:o,kind:l,extension:p,span:i})}function mVe(e,t,n,i,s){return dVe(t.text,t.getStart(e)+1,xwt(e,t,n,i,s))}function xwt(e,t,n,i,s){let o=v_(t.text),l=bo(t)?n.getModeForUsageLocation(e,t):void 0,p=e.path,m=hi(p),S=n.getCompilerOptions(),h=n.getTypeChecker(),b=Hbe(S,1,e,h,s,l);return Lwt(o)||!S.baseUrl&&!S.paths&&(ap(o)||Vfe(o))?Cwt(o,m,S,i,p,b):Nwt(o,m,l,S,i,b,h)}function Hbe(e,t,n,i,s,o){return{extensionsToSearch:ip(Awt(e,i)),referenceKind:t,importingSourceFile:n,endingPreference:s?.importModuleSpecifierEnding,resolutionMode:o}}function Cwt(e,t,n,i,s,o){return n.rootDirs?Pwt(n.rootDirs,e,t,o,n,i,s):In(V7(e,t,o,i,!0,s).values())}function Awt(e,t){let n=t?Wi(t.getAmbientModules(),o=>{let l=o.name.slice(1,-1);if(!(!l.startsWith("*.")||l.includes("/")))return l.slice(1)}):[],i=[...m6(e),n],s=Q_(e);return dJ(s)?oR(e,i):i}function kwt(e,t,n,i){e=e.map(o=>hu(Ca(ap(o)?o:li(t,o))));let s=Ct(e,o=>wm(o,n,t,i)?n.substr(o.length):void 0);return Dh([...e.map(o=>li(o,s)),n].map(o=>sT(o)),Av,h_)}function Pwt(e,t,n,i,s,o,l){let p=s.project||o.getCurrentDirectory(),m=!(o.useCaseSensitiveFileNames&&o.useCaseSensitiveFileNames()),S=kwt(e,p,n,m);return Dh(_a(S,h=>In(V7(t,h,i,o,!0,l).values())),(h,b)=>h.name===b.name&&h.kind===b.kind&&h.extension===b.extension)}function V7(e,t,n,i,s,o,l=$be()){var p;e===void 0&&(e=""),e=v_(e),b1(e)||(e=hi(e)),e===""&&(e="."+hc),e=hu(e);let m=Dv(t,e),S=b1(m)?m:hi(m);if(!s){let k=$1e(S,i);if(k){let M=c6(k,i).typesVersions;if(typeof M=="object"){let O=(p=FU(M))==null?void 0:p.paths;if(O){let U=hi(k),H=m.slice(hu(U).length);if(hVe(l,H,U,n,i,O))return l}}}}let h=!(i.useCaseSensitiveFileNames&&i.useCaseSensitiveFileNames());if(!PJ(i,S))return l;let b=Ute(i,S,n.extensionsToSearch,void 0,["./*"]);if(b)for(let k of b){if(k=Ca(k),o&&yy(k,o,t,h)===0)continue;let{name:N,extension:M}=gVe(Cl(k),i.getCompilationSettings(),n,!1);l.add(VO(N,"script",M))}let A=kJ(i,S);if(A)for(let k of A){let N=Cl(Ca(k));N!=="@types"&&l.add(Gbe(N))}return l}function gVe(e,t,n,i){let s=SE.tryGetRealFileNameForNonJsDeclarationFileName(e);if(s)return{name:s,extension:Py(s)};if(n.referenceKind===0)return{name:e,extension:Py(e)};let o=yM({importModuleSpecifierEnding:n.endingPreference},t,n.importingSourceFile).getAllowedEndingsInPreferredOrder(n.resolutionMode);if(i&&(o=o.filter(p=>p!==0&&p!==1)),o[0]===3){if(Ql(e,vR))return{name:e,extension:Py(e)};let p=SE.tryGetJSExtensionForFile(e,t);return p?{name:bT(e,p),extension:p}:{name:e,extension:Py(e)}}if(!i&&(o[0]===0||o[0]===1)&&Ql(e,[".js",".jsx",".ts",".tsx",".d.ts"]))return{name:ff(e),extension:Py(e)};let l=SE.tryGetJSExtensionForFile(e,t);return l?{name:bT(e,l),extension:l}:{name:e,extension:Py(e)}}function hVe(e,t,n,i,s,o){let l=m=>o[m],p=(m,S)=>{let h=ON(m),b=ON(S),A=typeof h=="object"?h.prefix.length:m.length,k=typeof b=="object"?b.prefix.length:S.length;return To(k,A)};return yVe(e,!1,t,n,i,s,Vt(o),l,p)}function yVe(e,t,n,i,s,o,l,p,m){let S=[],h;for(let b of l){if(b===".")continue;let A=b.replace(/^\.\//,""),k=p(b);if(k){let N=ON(A);if(!N)continue;let M=typeof N=="object"&&U5(N,n);M&&(h===void 0||m(b,h)===-1)&&(h=b,S=S.filter(U=>!U.matchedPattern)),(typeof N=="string"||h===void 0||m(b,h)!==1)&&S.push({matchedPattern:M,results:Dwt(A,k,n,i,s,t&&M,o).map(({name:U,kind:H,extension:K})=>VO(U,H,K))})}}return S.forEach(b=>b.results.forEach(A=>e.add(A))),h!==void 0}function Nwt(e,t,n,i,s,o,l){let{baseUrl:p,paths:m}=i,S=$be(),h=Q_(i);if(p){let A=Ca(li(s.getCurrentDirectory(),p));V7(e,A,o,s,!1,void 0,S)}if(m){let A=kj(i,s);hVe(S,e,A,o,s,m)}let b=SVe(e);for(let A of wwt(e,b,l))S.add(VO(A,"external module name",void 0));if(EVe(s,i,t,b,o,S),dJ(h)){let A=!1;if(b===void 0)for(let k of Rwt(s,t)){let N=VO(k,"external module name",void 0);S.has(N.name)||(A=!0,S.add(N))}if(!A){let k=N=>{let M=li(N,"node_modules");PJ(s,M)&&V7(e,M,o,s,!1,void 0,S)};if(b&&mB(i)){let N=k;k=M=>{let O=gu(e);O.shift();let U=O.shift();if(!U)return N(M);if(Ss(U,"@")){let re=O.shift();if(!re)return N(M);U=li(U,re)}let H=li(M,"node_modules",U),K=li(H,"package.json");if(_7(s,K)){let $=c6(K,s).exports;if($){if(typeof $!="object"||$===null)return;let pe=Vt($),z=O.join("/")+(O.length&&b1(e)?"/":""),se=nS(i,n);yVe(S,!0,z,H,o,s,pe,Se=>_A(vVe($[Se],se)),zQ);return}}return N(M)}}Rm(t,k)}}return In(S.values())}function vVe(e,t){if(typeof e=="string")return e;if(e&&typeof e=="object"&&!os(e)){for(let n in e)if(n==="default"||t.includes(n)||gM(t,n)){let i=e[n];return vVe(i,t)}}}function SVe(e){return Ybe(e)?b1(e)?e:hi(e):void 0}function Dwt(e,t,n,i,s,o,l){if(!Mc(e,"*"))return e.includes("*")?tt:S(e,"script");let p=e.slice(0,e.length-1),m=kG(n,p);if(m===void 0)return e[e.length-2]==="/"?S(p,"directory"):_a(t,b=>{var A;return(A=TVe("",i,b,s,o,l))==null?void 0:A.map(({name:k,...N})=>({name:p+k,...N}))});return _a(t,h=>TVe(m,i,h,s,o,l));function S(h,b){return Ss(h,n)?[{name:sT(h),kind:b,extension:void 0}]:tt}}function TVe(e,t,n,i,s,o){if(!o.readDirectory)return;let l=ON(n);if(l===void 0||vs(l))return;let p=Dv(l.prefix),m=b1(l.prefix)?p:hi(p),S=b1(l.prefix)?"":Cl(p),h=Ybe(e),b=h?b1(e)?e:hi(e):void 0,A=h?li(m,S+b):m,k=Ca(l.suffix),N=k&&Aj("_"+k),M=N?[bT(k,N),k]:[k],O=Ca(li(t,A)),U=h?O:hu(O)+S,H=k?M.map(pe=>"**/*"+pe):["./*"],K=Wi(Ute(o,O,i.extensionsToSearch,void 0,H),pe=>{let z=$(pe);if(z){if(Ybe(z))return Gbe(gu(bVe(z))[1]);let{name:se,extension:Se}=gVe(z,o.getCompilationSettings(),i,s);return VO(se,"script",Se)}}),re=k?tt:Wi(kJ(o,O),pe=>pe==="node_modules"?void 0:Gbe(pe));return[...K,...re];function $(pe){return Ct(M,z=>{let se=Iwt(Ca(pe),U,z);return se===void 0?void 0:bVe(se)})}}function Iwt(e,t,n){return Ss(e,t)&&Mc(e,n)?e.slice(t.length,e.length-n.length):void 0}function bVe(e){return e[0]===hc?e.slice(1):e}function wwt(e,t,n){let s=n.getAmbientModules().map(o=>cm(o.name)).filter(o=>Ss(o,e)&&!o.includes("*"));if(t!==void 0){let o=hu(t);return s.map(l=>hw(l,o))}return s}function Owt(e,t,n,i){let s=Ts(e,t),o=T0(e.text,s.pos),l=o&&mr(o,N=>t>=N.pos&&t<=N.end);if(!l)return;let p=e.text.slice(l.pos,t),m=xVe.exec(p);if(!m)return;let[,S,h,b]=m,A=hi(e.path),k=h==="path"?V7(b,A,Hbe(n,0,e),i,!0,e.path):h==="types"?EVe(i,n,A,SVe(b),Hbe(n,1,e)):I.fail();return dVe(b,l.pos+S.length,In(k.values()))}function EVe(e,t,n,i,s,o=$be()){let l=new Map,p=NJ(()=>tO(t,e))||tt;for(let S of p)m(S);for(let S of Vte(n,e)){let h=li(hi(S),"node_modules/@types");m(h)}return o;function m(S){if(PJ(e,S))for(let h of kJ(e,S)){let b=hM(h);if(!(t.types&&!hs(t.types,b)))if(i===void 0)l.has(b)||(o.add(VO(b,"external module name",void 0)),l.set(b,!0));else{let A=li(S,h),k=UX(i,b,N1(e));k!==void 0&&V7(k,A,s,e,!1,void 0,o)}}}}function Rwt(e,t){if(!e.readFile||!e.fileExists)return tt;let n=[];for(let i of Vte(t,e)){let s=c6(i,e);for(let o of CVe){let l=s[o];if(l)for(let p in l)wo(l,p)&&!Ss(p,"@types/")&&n.push(p)}}return n}function Mwt(e,t){let n=Math.max(e.lastIndexOf(hc),e.lastIndexOf(B3)),i=n!==-1?n+1:0,s=e.length-i;return s===0||nd(e.substr(i,s),99)?void 0:e_(t+i,s)}function Lwt(e){if(e&&e.length>=2&&e.charCodeAt(0)===46){let t=e.length>=3&&e.charCodeAt(1)===46?2:1,n=e.charCodeAt(t);return n===47||n===92}return!1}function Ybe(e){return e.includes(hc)}function Fwt(e){return da(e.parent)&&qi(e.parent.arguments)===e&&ze(e.parent.expression)&&e.parent.expression.escapedText==="require"}var Xbe,xVe,CVe,jwt=f({"src/services/stringCompletions.ts"(){"use strict";Qhe(),yi(),Kbe(),Xbe={directory:0,script:1,"external module name":2},xVe=/^(\/\/\/\s*<reference\s+(path|types)\s*=\s*(?:'|"))([^\3"]*)$/,CVe=["dependencies","devDependencies","peerDependencies","optionalDependencies"]}}),$ie={};x($ie,{getStringLiteralCompletionDetails:()=>vwt,getStringLiteralCompletions:()=>hwt});var Bwt=f({"src/services/_namespaces/ts.Completions.StringCompletions.ts"(){"use strict";jwt()}}),Pk={};x(Pk,{CompletionKind:()=>qbe,CompletionSource:()=>Vbe,SortText:()=>C_,StringCompletions:()=>$ie,SymbolOriginInfoKind:()=>Jbe,createCompletionDetails:()=>Nq,createCompletionDetailsForSymbol:()=>Lbe,getCompletionEntriesFromSymbols:()=>Rbe,getCompletionEntryDetails:()=>HIt,getCompletionEntrySymbol:()=>XIt,getCompletionsAtPosition:()=>AIt,getPropertiesForObjectExpression:()=>Uie,moduleSpecifierResolutionCacheAttemptLimit:()=>Ube,moduleSpecifierResolutionLimit:()=>qie});var Kbe=f({"src/services/_namespaces/ts.Completions.ts"(){"use strict";gwt(),Bwt()}});function Qbe(e,t,n,i){let s=qwt(e,n,i);return(o,l,p)=>{let{directImports:m,indirectUsers:S}=Uwt(e,t,s,l,n,i);return{indirectUsers:S,...Vwt(m,o,l.exportKind,n,p)}}}function Uwt(e,t,n,{exportingModuleSymbol:i,exportKind:s},o,l){let p=yk(),m=yk(),S=[],h=!!i.globalExports,b=h?void 0:[];return k(i),{directImports:S,indirectUsers:A()};function A(){if(h)return e;if(i.declarations)for(let K of i.declarations)qb(K)&&t.has(K.getSourceFile().fileName)&&U(K);return b.map(Xr)}function k(K){let re=H(K);if(re){for(let $ of re)if(p($))switch(l&&l.throwIfCancellationRequested(),$.kind){case 213:if(Up($)){N($);break}if(!h){let z=$.parent;if(s===2&&z.kind===260){let{name:se}=z;if(se.kind===80){S.push(se);break}}}break;case 80:break;case 271:O($,$.name,ui($,32),!1);break;case 272:S.push($);let pe=$.importClause&&$.importClause.namedBindings;pe&&pe.kind===274?O($,pe.name,!1,!0):!h&&xA($)&&U(wq($));break;case 278:$.exportClause?$.exportClause.kind===280?U(wq($),!0):S.push($):k(Hwt($,o));break;case 205:!h&&$.isTypeOf&&!$.qualifier&&M($)&&U($.getSourceFile(),!0),S.push($);break;default:I.failBadSyntaxKind($,"Unexpected import kind.")}}}function N(K){let re=Gr(K,Wie)||K.getSourceFile();U(re,!!M(K,!0))}function M(K,re=!1){return Gr(K,$=>re&&Wie($)?"quit":Jm($)&&Tt($.modifiers,WA))}function O(K,re,$,pe){if(s===2)pe||S.push(K);else if(!h){let z=wq(K);I.assert(z.kind===312||z.kind===267),$||Jwt(z,re,o)?U(z,!0):U(z)}}function U(K,re=!1){if(I.assert(!h),!m(K)||(b.push(K),!re))return;let pe=o.getMergedSymbol(K.symbol);if(!pe)return;I.assert(!!(pe.flags&1536));let z=H(pe);if(z)for(let se of z)M0(se)||U(wq(se),!0)}function H(K){return n.get(Ia(K).toString())}}function Vwt(e,t,n,i,s){let o=[],l=[];function p(A,k){o.push([A,k])}if(e)for(let A of e)m(A);return{importSearches:o,singleReferences:l};function m(A){if(A.kind===271){eEe(A)&&S(A.name);return}if(A.kind===80){S(A);return}if(A.kind===205){if(A.qualifier){let M=Jp(A.qualifier);M.escapedText===Lc(t)&&l.push(M)}else n===2&&l.push(A.argument.literal);return}if(A.moduleSpecifier.kind!==11)return;if(A.kind===278){A.exportClause&&wd(A.exportClause)&&h(A.exportClause);return}let{name:k,namedBindings:N}=A.importClause||{name:void 0,namedBindings:void 0};if(N)switch(N.kind){case 274:S(N.name);break;case 275:(n===0||n===1)&&h(N);break;default:I.assertNever(N)}if(k&&(n===1||n===2)&&(!s||k.escapedText===gJ(t))){let M=i.getSymbolAtLocation(k);p(k,M)}}function S(A){n===2&&(!s||b(A.escapedText))&&p(A,i.getSymbolAtLocation(A))}function h(A){if(A)for(let k of A.elements){let{name:N,propertyName:M}=k;if(b((M||N).escapedText))if(M)l.push(M),(!s||N.escapedText===t.escapedName)&&p(N,i.getSymbolAtLocation(N));else{let O=k.kind===281&&k.propertyName?i.getExportSpecifierLocalTargetSymbol(k):i.getSymbolAtLocation(N);p(N,O)}}}function b(A){return A===t.escapedName||n!==0&&A==="default"}}function Jwt(e,t,n){let i=n.getSymbolAtLocation(t);return!!kVe(e,s=>{if(!yl(s))return;let{exportClause:o,moduleSpecifier:l}=s;return!l&&o&&wd(o)&&o.elements.some(p=>n.getExportSpecifierLocalTargetSymbol(p)===i)})}function AVe(e,t,n){var i;let s=[],o=e.getTypeChecker();for(let l of t){let p=n.valueDeclaration;if(p?.kind===312){for(let m of l.referencedFiles)e.getSourceFileFromReference(l,m)===p&&s.push({kind:"reference",referencingFile:l,ref:m});for(let m of l.typeReferenceDirectives){let S=(i=e.getResolvedTypeReferenceDirectives().get(m.fileName,m.resolutionMode||l.impliedNodeFormat))==null?void 0:i.resolvedTypeReferenceDirective;S!==void 0&&S.resolvedFileName===p.fileName&&s.push({kind:"reference",referencingFile:l,ref:m})}}PVe(l,(m,S)=>{o.getSymbolAtLocation(S)===n&&s.push(_c(m)?{kind:"implicit",literal:S,referencingFile:l}:{kind:"import",literal:S})})}return s}function qwt(e,t,n){let i=new Map;for(let s of e)n&&n.throwIfCancellationRequested(),PVe(s,(o,l)=>{let p=t.getSymbolAtLocation(l);if(p){let m=Ia(p).toString(),S=i.get(m);S||i.set(m,S=[]),S.push(o)}});return i}function kVe(e,t){return Te(e.kind===312?e.statements:e.body.statements,n=>t(n)||Wie(n)&&Te(n.body&&n.body.statements,t))}function PVe(e,t){if(e.externalModuleIndicator||e.imports!==void 0)for(let n of e.imports)t(Gw(n),n);else kVe(e,n=>{switch(n.kind){case 278:case 272:{let i=n;i.moduleSpecifier&&za(i.moduleSpecifier)&&t(i,i.moduleSpecifier);break}case 271:{let i=n;eEe(i)&&t(i,i.moduleReference.expression);break}}})}function NVe(e,t,n,i){return i?s():s()||o();function s(){var m;let{parent:S}=e,h=S.parent;if(t.exportSymbol)return S.kind===211?(m=t.declarations)!=null&&m.some(k=>k===S)&&bn(h)?A(h,!1):void 0:l(t.exportSymbol,p(S));{let k=$wt(S,e);if(k&&ui(k,32))return Ru(k)&&k.moduleReference===e?i?void 0:{kind:0,symbol:n.getSymbolAtLocation(k.name)}:l(t,p(k));if(qh(S))return l(t,0);if(Kc(S))return b(S);if(Kc(h))return b(h);if(bn(S))return A(S,!0);if(bn(h))return A(h,!0);if(gx(S)||JK(S))return l(t,0)}function b(k){if(!k.symbol.parent)return;let N=k.isExportEquals?2:1;return{kind:1,symbol:t,exportInfo:{exportingModuleSymbol:k.symbol.parent,exportKind:N}}}function A(k,N){let M;switch(al(k)){case 1:M=0;break;case 2:M=2;break;default:return}let O=N?n.getSymbolAtLocation(MX(ta(k.left,Yo))):t;return O&&l(O,M)}}function o(){if(!Wwt(e))return;let S=n.getImmediateAliasedSymbol(t);if(!S||(S=Gwt(S,n),S.escapedName==="export="&&(S=zwt(S,n),S===void 0)))return;let h=gJ(S);if(h===void 0||h==="default"||h===t.escapedName)return{kind:0,symbol:S}}function l(m,S){let h=Zbe(m,S,n);return h&&{kind:1,symbol:m,exportInfo:h}}function p(m){return ui(m,2048)?1:0}}function zwt(e,t){var n,i;if(e.flags&2097152)return t.getImmediateAliasedSymbol(e);let s=I.checkDefined(e.valueDeclaration);if(Kc(s))return(n=ii(s.expression,qg))==null?void 0:n.symbol;if(bn(s))return(i=ii(s.right,qg))==null?void 0:i.symbol;if(ls(s))return s.symbol}function $wt(e,t){let n=Gi(e)?e:co(e)?GP(e):void 0;return n?e.name!==t||mE(n.parent)?void 0:Xc(n.parent.parent)?n.parent.parent:void 0:e}function Wwt(e){let{parent:t}=e;switch(t.kind){case 271:return t.name===e&&eEe(t);case 276:return!t.propertyName;case 273:case 274:return I.assert(t.name===e),!0;case 208:return gn(e)&&Gb(t.parent.parent);default:return!1}}function Zbe(e,t,n){let i=e.parent;if(!i)return;let s=n.getMergedSymbol(i);return t7(s)?{exportingModuleSymbol:s,exportKind:t}:void 0}function Gwt(e,t){if(e.declarations)for(let n of e.declarations){if(R_(n)&&!n.propertyName&&!n.parent.parent.moduleSpecifier)return t.getExportSpecifierLocalTargetSymbol(n)||e;if(Hn(n)&&P0(n.expression)&&!is(n.name))return t.getSymbolAtLocation(n);if(Hf(n)&&bn(n.parent.parent)&&al(n.parent.parent)===2)return t.getExportSpecifierLocalTargetSymbol(n.name)}return e}function Hwt(e,t){return t.getMergedSymbol(wq(e).symbol)}function wq(e){if(e.kind===213)return e.getSourceFile();let{parent:t}=e;return t.kind===312?t:(I.assert(t.kind===268),ta(t.parent,Wie))}function Wie(e){return e.kind===267&&e.name.kind===11}function eEe(e){return e.moduleReference.kind===283&&e.moduleReference.expression.kind===11}var tEe,rEe,Ywt=f({"src/services/importTracker.ts"(){"use strict";yi(),tEe=(e=>(e[e.Named=0]="Named",e[e.Default=1]="Default",e[e.ExportEquals=2]="ExportEquals",e))(tEe||{}),rEe=(e=>(e[e.Import=0]="Import",e[e.Export=1]="Export",e))(rEe||{})}});function B0(e,t=1){return{kind:t,node:e.name||e,context:Xwt(e)}}function nEe(e){return e&&e.kind===void 0}function Xwt(e){if(O_(e))return Ix(e);if(e.parent){if(!O_(e.parent)&&!Kc(e.parent)){if(gn(e)){let n=bn(e.parent)?e.parent:Yo(e.parent)&&bn(e.parent.parent)&&e.parent.parent.left===e.parent?e.parent.parent:void 0;if(n&&al(n)!==0)return Ix(n)}if(eh(e.parent)||fE(e.parent))return e.parent.parent;if(px(e.parent)||_E(e.parent)||Iw(e.parent))return e.parent;if(bo(e)){let n=F8(e);if(n){let i=Gr(n,s=>O_(s)||ns(s)||eN(s));return O_(i)?Ix(i):i}}let t=Gr(e,uo);return t?Ix(t.parent):void 0}if(e.parent.name===e||Yc(e.parent)||Kc(e.parent)||(hA(e.parent)||co(e.parent))&&e.parent.propertyName===e||e.kind===90&&ui(e.parent,2080))return Ix(e.parent)}}function Ix(e){if(e)switch(e.kind){case 260:return!Tu(e.parent)||e.parent.declarations.length!==1?e:Xc(e.parent.parent)?e.parent.parent:QP(e.parent.parent)?Ix(e.parent.parent):e.parent;case 208:return Ix(e.parent.parent);case 276:return e.parent.parent.parent;case 281:case 274:return e.parent.parent;case 273:case 280:return e.parent;case 226:return Ou(e.parent)?e.parent:e;case 250:case 249:return{start:e.initializer,end:e.expression};case 303:case 304:return V1(e.parent)?Ix(Gr(e.parent,t=>bn(t)||QP(t))):e;case 255:return{start:mr(e.getChildren(e.getSourceFile()),t=>t.kind===109),end:e.caseBlock};default:return e}}function iEe(e,t,n){if(!n)return;let i=nEe(n)?Rq(n.start,t,n.end):Rq(n,t);return i.start!==e.start||i.length!==e.length?{contextSpan:i}:void 0}function Kwt(e,t,n,i,s){let o=If(i,s),l={use:1},p=Nk.getReferencedSymbolsForNode(s,o,e,n,t,l),m=e.getTypeChecker(),S=Nk.getAdjustedNode(o,l),h=Qwt(S)?m.getSymbolAtLocation(S):void 0;return!p||!p.length?void 0:Wi(p,({definition:b,references:A})=>b&&{definition:m.runWithCancellationToken(t,k=>t6t(b,k,o)),references:A.map(k=>n6t(k,h))})}function Qwt(e){return e.kind===90||!!Hw(e)||z8(e)||e.kind===137&&Yc(e.parent)}function Zwt(e,t,n,i,s){let o=If(i,s),l,p=DVe(e,t,n,o,s);if(o.parent.kind===211||o.parent.kind===208||o.parent.kind===212||o.kind===108)l=p&&[...p];else if(p){let S=Pu(p),h=new Map;for(;!S.isEmpty();){let b=S.dequeue();if(!Bm(h,yo(b.node)))continue;l=Pr(l,b);let A=DVe(e,t,n,b.node,b.node.pos);A&&S.enqueue(...A)}}let m=e.getTypeChecker();return vr(l,S=>s6t(S,m))}function DVe(e,t,n,i,s){if(i.kind===312)return;let o=e.getTypeChecker();if(i.parent.kind===304){let l=[];return Nk.getReferenceEntriesForShorthandPropertyAssignment(i,o,p=>l.push(B0(p))),l}else if(i.kind===108||Pf(i.parent)){let l=o.getSymbolAtLocation(i);return l.valueDeclaration&&[B0(l.valueDeclaration)]}else return IVe(s,i,e,n,t,{implementations:!0,use:1})}function e6t(e,t,n,i,s,o,l){return vr(wVe(Nk.getReferencedSymbolsForNode(s,i,e,n,t,o)),p=>l(p,i,e.getTypeChecker()))}function IVe(e,t,n,i,s,o={},l=new Set(i.map(p=>p.fileName))){return wVe(Nk.getReferencedSymbolsForNode(e,t,n,i,s,o,l))}function wVe(e){return e&&_a(e,t=>t.references)}function t6t(e,t,n){let i=(()=>{switch(e.type){case 0:{let{symbol:h}=e,{displayParts:b,kind:A}=OVe(h,t,n),k=b.map(O=>O.text).join(""),N=h.declarations&&qi(h.declarations),M=N?qs(N)||N:n;return{...Oq(M),name:k,kind:A,displayParts:b,context:Ix(N)}}case 1:{let{node:h}=e;return{...Oq(h),name:h.text,kind:"label",displayParts:[Yf(h.text,17)]}}case 2:{let{node:h}=e,b=Sa(h.kind);return{...Oq(h),name:b,kind:"keyword",displayParts:[{text:b,kind:"keyword"}]}}case 3:{let{node:h}=e,b=t.getSymbolAtLocation(h),A=b&&W1.getSymbolDisplayPartsDocumentationAndSymbolKind(t,b,h.getSourceFile(),Ax(h),h).displayParts||[fd("this")];return{...Oq(h),name:"this",kind:"var",displayParts:A}}case 4:{let{node:h}=e;return{...Oq(h),name:h.text,kind:"var",displayParts:[Yf(Fl(h),8)]}}case 5:return{textSpan:aS(e.reference),sourceFile:e.file,name:e.reference.fileName,kind:"string",displayParts:[Yf(`"${e.reference.fileName}"`,8)]};default:return I.assertNever(e)}})(),{sourceFile:s,textSpan:o,name:l,kind:p,displayParts:m,context:S}=i;return{containerKind:"",containerName:"",fileName:s.fileName,kind:p,name:l,textSpan:o,displayParts:m,...iEe(o,s,S)}}function Oq(e){let t=e.getSourceFile();return{sourceFile:t,textSpan:Rq(uo(e)?e.expression:e,t)}}function OVe(e,t,n){let i=Nk.getIntersectingMeaningFromDeclarations(n,e),s=e.declarations&&qi(e.declarations)||n,{displayParts:o,symbolKind:l}=W1.getSymbolDisplayPartsDocumentationAndSymbolKind(t,e,s.getSourceFile(),s,s,i);return{displayParts:o,kind:l}}function r6t(e,t,n,i,s){return{...Gie(e),...i&&i6t(e,t,n,s)}}function n6t(e,t){let n=RVe(e);return t?{...n,isDefinition:e.kind!==0&&MVe(e.node,t)}:n}function RVe(e){let t=Gie(e);if(e.kind===0)return{...t,isWriteAccess:!1};let{kind:n,node:i}=e;return{...t,isWriteAccess:aEe(i),isInString:n===2?!0:void 0}}function Gie(e){if(e.kind===0)return{textSpan:e.textSpan,fileName:e.fileName};{let t=e.node.getSourceFile(),n=Rq(e.node,t);return{textSpan:n,fileName:t.fileName,...iEe(n,t,e.context)}}}function i6t(e,t,n,i){if(e.kind!==0&&ze(t)){let{node:s,kind:o}=e,l=s.parent,p=t.text,m=Hf(l);if(m||i7(l)&&l.name===s&&l.dotDotDotToken===void 0){let S={prefixText:p+": "},h={suffixText:": "+p};if(o===3)return S;if(o===4)return h;if(m){let b=l.parent;return Ha(b)&&bn(b.parent)&&P0(b.parent.left)?S:h}else return S}else if(Gf(l)&&!l.propertyName){let S=R_(t.parent)?n.getExportSpecifierLocalTargetSymbol(t.parent):n.getSymbolAtLocation(t);return hs(S.declarations,l)?{prefixText:p+" as "}:Md}else if(R_(l)&&!l.propertyName)return t===e.node||n.getSymbolAtLocation(t)===n.getSymbolAtLocation(e.node)?{prefixText:p+" as "}:{suffixText:" as "+p}}if(e.kind!==0&&_p(e.node)&&Yo(e.node.parent)){let s=xte(i);return{prefixText:s,suffixText:s}}return Md}function s6t(e,t){let n=Gie(e);if(e.kind!==0){let{node:i}=e;return{...n,...a6t(i,t)}}else return{...n,kind:"",displayParts:[]}}function a6t(e,t){let n=t.getSymbolAtLocation(O_(e)&&e.name?e.name:e);return n?OVe(n,t,e):e.kind===210?{kind:"interface",displayParts:[F_(21),fd("object literal"),F_(22)]}:e.kind===231?{kind:"local class",displayParts:[F_(21),fd("anonymous local class"),F_(22)]}:{kind:CE(e),displayParts:[]}}function o6t(e){let t=Gie(e);if(e.kind===0)return{fileName:t.fileName,span:{textSpan:t.textSpan,kind:"reference"}};let n=aEe(e.node),i={textSpan:t.textSpan,kind:n?"writtenReference":"reference",isInString:e.kind===2?!0:void 0,...t.contextSpan&&{contextSpan:t.contextSpan}};return{fileName:t.fileName,span:i}}function Rq(e,t,n){let i=e.getStart(t),s=(n||e).getEnd();return bo(e)&&s-i>2&&(I.assert(n===void 0),i+=1,s-=1),n?.kind===269&&(s=n.getFullStart()),Ll(i,s)}function sEe(e){return e.kind===0?e.textSpan:Rq(e.node,e.node.getSourceFile())}function aEe(e){let t=Hw(e);return!!t&&c6t(t)||e.kind===90||wA(e)}function MVe(e,t){var n;if(!t)return!1;let i=Hw(e)||(e.kind===90?e.parent:z8(e)||e.kind===137&&Yc(e.parent)?e.parent.parent:void 0),s=i&&bn(i)?i.left:void 0;return!!(i&&((n=t.declarations)!=null&&n.some(o=>o===i||o===s)))}function c6t(e){if(e.flags&33554432)return!0;switch(e.kind){case 226:case 208:case 263:case 231:case 90:case 266:case 306:case 281:case 273:case 271:case 276:case 264:case 345:case 353:case 291:case 267:case 270:case 274:case 280:case 169:case 304:case 265:case 168:return!0;case 303:return!V1(e.parent);case 262:case 218:case 176:case 174:case 177:case 178:return!!e.body;case 260:case 172:return!!e.initializer||mE(e.parent);case 173:case 171:case 355:case 348:return!1;default:return I.failBadSyntaxKind(e)}}var oEe,cEe,lEe,Nk,l6t=f({"src/services/findAllReferences.ts"(){"use strict";yi(),uEe(),oEe=(e=>(e[e.Symbol=0]="Symbol",e[e.Label=1]="Label",e[e.Keyword=2]="Keyword",e[e.This=3]="This",e[e.String=4]="String",e[e.TripleSlashReference=5]="TripleSlashReference",e))(oEe||{}),cEe=(e=>(e[e.Span=0]="Span",e[e.Node=1]="Node",e[e.StringLiteral=2]="StringLiteral",e[e.SearchedLocalFoundProperty=3]="SearchedLocalFoundProperty",e[e.SearchedPropertyFoundLocal=4]="SearchedPropertyFoundLocal",e))(cEe||{}),lEe=(e=>(e[e.Other=0]="Other",e[e.References=1]="References",e[e.Rename=2]="Rename",e))(lEe||{}),(e=>{function t(We,mt,dt,Ot,_e,Ve={},pt=new Set(Ot.map(W=>W.fileName))){var W,st;if(mt=n(mt,Ve),ls(mt)){let Sr=UD.getReferenceAtPosition(mt,We,dt);if(!Sr?.file)return;let Y=dt.getTypeChecker().getMergedSymbol(Sr.file.symbol);if(Y)return S(dt,Y,!1,Ot,pt);let Be=dt.getFileIncludeReasons();return Be?[{definition:{type:5,reference:Sr.reference,file:mt},references:s(Sr.file,Be,dt)||tt}]:void 0}if(!Ve.implementations){let Sr=b(mt,Ot,_e);if(Sr)return Sr}let Nt=dt.getTypeChecker(),Ke=Nt.getSymbolAtLocation(Yc(mt)&&mt.parent.name||mt);if(!Ke){if(!Ve.implementations&&bo(mt)){if(hJ(mt)){let Sr=dt.getFileIncludeReasons(),Y=(st=(W=dt.getResolvedModuleFromModuleSpecifier(mt))==null?void 0:W.resolvedModule)==null?void 0:st.resolvedFileName,Be=Y?dt.getSourceFile(Y):void 0;if(Be)return[{definition:{type:4,node:mt},references:s(Be,Sr,dt)||tt}]}return ri(mt,Ot,Nt,_e)}return}if(Ke.escapedName==="export=")return S(dt,Ke.parent,!1,Ot,pt);let ht=l(Ke,dt,Ot,_e,Ve,pt);if(ht&&!(Ke.flags&33554432))return ht;let Wt=o(mt,Ke,Nt),Cr=Wt&&l(Wt,dt,Ot,_e,Ve,pt),hr=A(Ke,mt,Ot,pt,Nt,_e,Ve);return p(dt,ht,hr,Cr)}e.getReferencedSymbolsForNode=t;function n(We,mt){return mt.use===1?We=lte(We):mt.use===2&&(We=sJ(We)),We}e.getAdjustedNode=n;function i(We,mt,dt,Ot=new Set(dt.map(_e=>_e.fileName))){var _e,Ve;let pt=(_e=mt.getSourceFile(We))==null?void 0:_e.symbol;if(pt)return((Ve=S(mt,pt,!1,dt,Ot)[0])==null?void 0:Ve.references)||tt;let W=mt.getFileIncludeReasons(),st=mt.getSourceFile(We);return st&&W&&s(st,W,mt)||tt}e.getReferencesForFileName=i;function s(We,mt,dt){let Ot,_e=mt.get(We.path)||tt;for(let Ve of _e)if(MT(Ve)){let pt=dt.getSourceFileByPath(Ve.file),W=hO(dt,Ve);pD(W)&&(Ot=Pr(Ot,{kind:0,fileName:pt.fileName,textSpan:aS(W)}))}return Ot}function o(We,mt,dt){if(We.parent&&BR(We.parent)){let Ot=dt.getAliasedSymbol(mt),_e=dt.getMergedSymbol(Ot);if(Ot!==_e)return _e}}function l(We,mt,dt,Ot,_e,Ve){let pt=We.flags&1536&&We.declarations&&mr(We.declarations,ls);if(!pt)return;let W=We.exports.get("export="),st=S(mt,We,!!W,dt,Ve);if(!W||!Ve.has(pt.fileName))return st;let Nt=mt.getTypeChecker();return We=r_(W,Nt),p(mt,st,A(We,void 0,dt,Ve,Nt,Ot,_e))}function p(We,...mt){let dt;for(let Ot of mt)if(!(!Ot||!Ot.length)){if(!dt){dt=Ot;continue}for(let _e of Ot){if(!_e.definition||_e.definition.type!==0){dt.push(_e);continue}let Ve=_e.definition.symbol,pt=oa(dt,st=>!!st.definition&&st.definition.type===0&&st.definition.symbol===Ve);if(pt===-1){dt.push(_e);continue}let W=dt[pt];dt[pt]={definition:W.definition,references:W.references.concat(_e.references).sort((st,Nt)=>{let Ke=m(We,st),ht=m(We,Nt);if(Ke!==ht)return To(Ke,ht);let Wt=sEe(st),Cr=sEe(Nt);return Wt.start!==Cr.start?To(Wt.start,Cr.start):To(Wt.length,Cr.length)})}}}return dt}function m(We,mt){let dt=mt.kind===0?We.getSourceFile(mt.fileName):mt.node.getSourceFile();return We.getSourceFiles().indexOf(dt)}function S(We,mt,dt,Ot,_e){I.assert(!!mt.valueDeclaration);let Ve=Wi(AVe(We,Ot,mt),W=>{if(W.kind==="import"){let st=W.literal.parent;if(Qv(st)){let Nt=ta(st.parent,M0);if(dt&&!Nt.qualifier)return}return B0(W.literal)}else if(W.kind==="implicit"){let st=W.literal.text!==Gv&&Y6(W.referencingFile,Nt=>Nt.transformFlags&2?L0(Nt)||px(Nt)||pE(Nt)?Nt:void 0:"skip")||W.referencingFile.statements[0]||W.referencingFile;return B0(st)}else return{kind:0,fileName:W.referencingFile.fileName,textSpan:aS(W.ref)}});if(mt.declarations)for(let W of mt.declarations)switch(W.kind){case 312:break;case 267:_e.has(W.getSourceFile().fileName)&&Ve.push(B0(W.name));break;default:I.assert(!!(mt.flags&33554432),"Expected a module symbol to be declared by a SourceFile or ModuleDeclaration.")}let pt=mt.exports.get("export=");if(pt?.declarations)for(let W of pt.declarations){let st=W.getSourceFile();if(_e.has(st.fileName)){let Nt=bn(W)&&Hn(W.left)?W.left.expression:Kc(W)?I.checkDefined(Oo(W,95,st)):qs(W)||W;Ve.push(B0(Nt))}}return Ve.length?[{definition:{type:0,symbol:mt},references:Ve}]:tt}function h(We){return We.kind===148&&cx(We.parent)&&We.parent.operator===148}function b(We,mt,dt){if(CO(We.kind))return We.kind===116&&ZA(We.parent)||We.kind===148&&!h(We)?void 0:Me(mt,We.kind,dt,We.kind===148?h:void 0);if(oN(We.parent)&&We.parent.name===We)return Ee(mt,dt);if(GA(We)&&Jc(We.parent))return[{definition:{type:2,node:We},references:[B0(We)]}];if(GM(We)){let Ot=ZV(We.parent,We.text);return Ot&&ve(Ot.parent,Ot)}else if(ete(We))return ve(We.parent,We);if(TD(We))return un(We,mt,dt);if(We.kind===108)return zi(We)}function A(We,mt,dt,Ot,_e,Ve,pt){let W=mt&&M(We,mt,_e,!qr(pt))||We,st=mt?Ni(mt,W):7,Nt=[],Ke=new H(dt,Ot,mt?N(mt):0,_e,Ve,st,pt,Nt),ht=!qr(pt)||!W.declarations?void 0:mr(W.declarations,R_);if(ht)kt(ht.name,W,ht,Ke.createSearch(mt,We,void 0),Ke,!0,!0);else if(mt&&mt.kind===90&&W.escapedName==="default"&&W.parent)St(mt,W,Ke),K(mt,W,{exportingModuleSymbol:W.parent,exportKind:1},Ke);else{let Wt=Ke.createSearch(mt,W,void 0,{allSearchSymbols:mt?_r(W,mt,_e,pt.use===2,!!pt.providePrefixAndSuffixTextForRename,!!pt.implementations):[W]});k(W,Ke,Wt)}return Nt}function k(We,mt,dt){let Ot=Se(We);if(Ot)Ae(Ot,Ot.getSourceFile(),dt,mt,!(ls(Ot)&&!hs(mt.sourceFiles,Ot)));else for(let _e of mt.sourceFiles)mt.cancellationToken.throwIfCancellationRequested(),z(_e,dt,mt)}function N(We){switch(We.kind){case 176:case 137:return 1;case 80:if(Ti(We.parent))return I.assert(We.parent.name===We),2;default:return 0}}function M(We,mt,dt,Ot){let{parent:_e}=mt;return R_(_e)&&Ot?ke(mt,We,_e,dt):Ct(We.declarations,Ve=>{if(!Ve.parent){if(We.flags&33554432)return;I.fail(`Unexpected symbol at ${I.formatSyntaxKind(mt.kind)}: ${I.formatSymbol(We)}`)}return dp(Ve.parent)&&Kv(Ve.parent.parent)?dt.getPropertyOfType(dt.getTypeFromTypeNode(Ve.parent.parent),We.name):void 0})}let O;(We=>{We[We.None=0]="None",We[We.Constructor=1]="Constructor",We[We.Class=2]="Class"})(O||(O={}));function U(We){if(!(We.flags&33555968))return;let mt=We.declarations&&mr(We.declarations,dt=>!ls(dt)&&!hl(dt));return mt&&mt.symbol}class H{constructor(mt,dt,Ot,_e,Ve,pt,W,st){this.sourceFiles=mt,this.sourceFilesSet=dt,this.specialSearchKind=Ot,this.checker=_e,this.cancellationToken=Ve,this.searchMeaning=pt,this.options=W,this.result=st,this.inheritsFromCache=new Map,this.markSeenContainingTypeReference=yk(),this.markSeenReExportRHS=yk(),this.symbolIdToReferences=[],this.sourceFileToSeenSymbols=[]}includesSourceFile(mt){return this.sourceFilesSet.has(mt.fileName)}getImportSearches(mt,dt){return this.importTracker||(this.importTracker=Qbe(this.sourceFiles,this.sourceFilesSet,this.checker,this.cancellationToken)),this.importTracker(mt,dt,this.options.use===2)}createSearch(mt,dt,Ot,_e={}){let{text:Ve=cm(Lc(PN(dt)||U(dt)||dt)),allSearchSymbols:pt=[dt]}=_e,W=Pc(Ve),st=this.options.implementations&&mt?Nr(mt,dt,this.checker):void 0;return{symbol:dt,comingFrom:Ot,text:Ve,escapedText:W,parents:st,allSearchSymbols:pt,includes:Nt=>hs(pt,Nt)}}referenceAdder(mt){let dt=Ia(mt),Ot=this.symbolIdToReferences[dt];return Ot||(Ot=this.symbolIdToReferences[dt]=[],this.result.push({definition:{type:0,symbol:mt},references:Ot})),(_e,Ve)=>Ot.push(B0(_e,Ve))}addStringOrCommentReference(mt,dt){this.result.push({definition:void 0,references:[{kind:0,fileName:mt,textSpan:dt}]})}markSearchedSymbols(mt,dt){let Ot=yo(mt),_e=this.sourceFileToSeenSymbols[Ot]||(this.sourceFileToSeenSymbols[Ot]=new Set),Ve=!1;for(let pt of dt)Ve=Zd(_e,Ia(pt))||Ve;return Ve}}function K(We,mt,dt,Ot){let{importSearches:_e,singleReferences:Ve,indirectUsers:pt}=Ot.getImportSearches(mt,dt);if(Ve.length){let W=Ot.referenceAdder(mt);for(let st of Ve)$(st,Ot)&&W(st)}for(let[W,st]of _e)Ge(W.getSourceFile(),Ot.createSearch(W,st,1),Ot);if(pt.length){let W;switch(dt.exportKind){case 0:W=Ot.createSearch(We,mt,1);break;case 1:W=Ot.options.use===2?void 0:Ot.createSearch(We,mt,1,{text:"default"});break;case 2:break}if(W)for(let st of pt)z(st,W,Ot)}}function re(We,mt,dt,Ot,_e,Ve,pt,W){let st=Qbe(We,new Set(We.map(Wt=>Wt.fileName)),mt,dt),{importSearches:Nt,indirectUsers:Ke,singleReferences:ht}=st(Ot,{exportKind:pt?1:0,exportingModuleSymbol:_e},!1);for(let[Wt]of Nt)W(Wt);for(let Wt of ht)ze(Wt)&&M0(Wt.parent)&&W(Wt);for(let Wt of Ke)for(let Cr of ye(Wt,pt?"default":Ve)){let hr=mt.getSymbolAtLocation(Cr),Sr=Tt(hr?.declarations,Y=>!!ii(Y,Kc));ze(Cr)&&!hA(Cr.parent)&&(hr===Ot||Sr)&&W(Cr)}}e.eachExportReference=re;function $(We,mt){return Ie(We,mt)?mt.options.use!==2?!0:ze(We)?!(hA(We.parent)&&We.escapedText==="default"):!1:!1}function pe(We,mt){if(We.declarations)for(let dt of We.declarations){let Ot=dt.getSourceFile();Ge(Ot,mt.createSearch(dt,We,0),mt,mt.includesSourceFile(Ot))}}function z(We,mt,dt){Kre(We).get(mt.escapedText)!==void 0&&Ge(We,mt,dt)}function se(We,mt){return V1(We.parent.parent)?mt.getPropertySymbolOfDestructuringAssignment(We):void 0}function Se(We){let{declarations:mt,flags:dt,parent:Ot,valueDeclaration:_e}=We;if(_e&&(_e.kind===218||_e.kind===231))return _e;if(!mt)return;if(dt&8196){let W=mr(mt,st=>up(st,2)||G_(st));return W?ST(W,263):void 0}if(mt.some(i7))return;let Ve=Ot&&!(We.flags&262144);if(Ve&&!(t7(Ot)&&!Ot.globalExports))return;let pt;for(let W of mt){let st=Ax(W);if(pt&&pt!==st||!st||st.kind===312&&!Bp(st))return;if(pt=st,Xo(pt)){let Nt;for(;Nt=QY(pt);)pt=Nt}}return Ve?pt.getSourceFile():pt}function xe(We,mt,dt,Ot=dt){return Z(We,mt,dt,()=>!0,Ot)||!1}e.isSymbolReferencedInFile=xe;function Z(We,mt,dt,Ot,_e=dt){let Ve=op(We.parent,We.parent.parent)?di(mt.getSymbolsOfParameterPropertyDeclaration(We.parent,We.text)):mt.getSymbolAtLocation(We);if(Ve)for(let pt of ye(dt,Ve.name,_e)){if(!ze(pt)||pt===We||pt.escapedText!==We.escapedText)continue;let W=mt.getSymbolAtLocation(pt);if(W===Ve||mt.getShorthandAssignmentValueSymbol(pt.parent)===Ve||R_(pt.parent)&&ke(pt,W,pt.parent,mt)===Ve){let st=Ot(pt);if(st)return st}}}e.eachSymbolReferenceInFile=Z;function Q(We,mt){return Fn(ye(mt,We),_e=>!!Hw(_e)).reduce((_e,Ve)=>{let pt=Ot(Ve);return!Tt(_e.declarationNames)||pt===_e.depth?(_e.declarationNames.push(Ve),_e.depth=pt):pt<_e.depth&&(_e.declarationNames=[Ve],_e.depth=pt),_e},{depth:1/0,declarationNames:[]}).declarationNames;function Ot(_e){let Ve=0;for(;_e;)_e=Ax(_e),Ve++;return Ve}}e.getTopMostDeclarationNamesInFile=Q;function ce(We,mt,dt,Ot){if(!We.name||!ze(We.name))return!1;let _e=I.checkDefined(dt.getSymbolAtLocation(We.name));for(let Ve of mt)for(let pt of ye(Ve,_e.name)){if(!ze(pt)||pt===We.name||pt.escapedText!==We.name.escapedText)continue;let W=QV(pt),st=da(W.parent)&&W.parent.expression===W?W.parent:void 0,Nt=dt.getSymbolAtLocation(pt);if(Nt&&dt.getRootSymbols(Nt).some(Ke=>Ke===_e)&&Ot(pt,st))return!0}return!1}e.someSignatureUsage=ce;function ye(We,mt,dt=We){return Wi(we(We,mt,dt),Ot=>{let _e=If(We,Ot);return _e===We?void 0:_e})}function we(We,mt,dt=We){let Ot=[];if(!mt||!mt.length)return Ot;let _e=We.text,Ve=_e.length,pt=mt.length,W=_e.indexOf(mt,dt.pos);for(;W>=0&&!(W>dt.end);){let st=W+pt;(W===0||!oT(_e.charCodeAt(W-1),99))&&(st===Ve||!oT(_e.charCodeAt(st),99))&&Ot.push(W),W=_e.indexOf(mt,W+pt+1)}return Ot}function ve(We,mt){let dt=We.getSourceFile(),Ot=mt.text,_e=Wi(ye(dt,Ot,We),Ve=>Ve===mt||GM(Ve)&&ZV(Ve,Ot)===mt?B0(Ve):void 0);return[{definition:{type:1,node:mt},references:_e}]}function oe(We,mt){switch(We.kind){case 81:if(kT(We.parent))return!0;case 80:return We.text.length===mt.length;case 15:case 11:{let dt=We;return(eJ(dt)||ite(We)||_1e(We)||da(We.parent)&&H2(We.parent)&&We.parent.arguments[1]===We)&&dt.text.length===mt.length}case 9:return eJ(We)&&We.text.length===mt.length;case 90:return mt.length===7;default:return!1}}function Ee(We,mt){let dt=_a(We,Ot=>(mt.throwIfCancellationRequested(),Wi(ye(Ot,"meta",Ot),_e=>{let Ve=_e.parent;if(oN(Ve))return B0(Ve)})));return dt.length?[{definition:{type:2,node:dt[0].node},references:dt}]:void 0}function Me(We,mt,dt,Ot){let _e=_a(We,Ve=>(dt.throwIfCancellationRequested(),Wi(ye(Ve,Sa(mt),Ve),pt=>{if(pt.kind===mt&&(!Ot||Ot(pt)))return B0(pt)})));return _e.length?[{definition:{type:2,node:_e[0].node},references:_e}]:void 0}function Ge(We,mt,dt,Ot=!0){return dt.cancellationToken.throwIfCancellationRequested(),Ae(We,We,mt,dt,Ot)}function Ae(We,mt,dt,Ot,_e){if(Ot.markSearchedSymbols(mt,dt.allSearchSymbols))for(let Ve of we(mt,dt.text,We))Re(mt,Ve,dt,Ot,_e)}function Ie(We,mt){return!!(Cx(We)&mt.searchMeaning)}function Re(We,mt,dt,Ot,_e){let Ve=If(We,mt);if(!oe(Ve,dt.text)){!Ot.options.implementations&&(Ot.options.findInStrings&&hk(We,mt)||Ot.options.findInComments&&C1e(We,mt))&&Ot.addStringOrCommentReference(We.fileName,e_(mt,dt.text.length));return}if(!Ie(Ve,Ot))return;let pt=Ot.checker.getSymbolAtLocation(Ve);if(!pt)return;let W=Ve.parent;if(Gf(W)&&W.propertyName===Ve)return;if(R_(W)){I.assert(Ve.kind===80),kt(Ve,pt,W,dt,Ot,_e);return}if(ww(W)&&W.isNameFirst&&W.typeExpression&&mx(W.typeExpression.type)&&W.typeExpression.type.jsDocPropertyTags&&de(W.typeExpression.type.jsDocPropertyTags)){Ue(W.typeExpression.type.jsDocPropertyTags,Ve,dt,Ot);return}let st=vi(dt,pt,Ve,Ot);if(!st){$t(pt,dt,Ot);return}switch(Ot.specialSearchKind){case 0:_e&&St(Ve,st,Ot);break;case 1:Ze(Ve,We,dt,Ot);break;case 2:yt(Ve,dt,Ot);break;default:I.assertNever(Ot.specialSearchKind)}gn(Ve)&&co(Ve.parent)&&Gb(Ve.parent.parent.parent)&&(pt=Ve.parent.symbol,!pt)||at(Ve,pt,dt,Ot)}function Ue(We,mt,dt,Ot){let _e=Ot.referenceAdder(dt.symbol);St(mt,dt.symbol,Ot),Te(We,Ve=>{pf(Ve.name)&&_e(Ve.name.left)})}function kt(We,mt,dt,Ot,_e,Ve,pt){I.assert(!pt||!!_e.options.providePrefixAndSuffixTextForRename,"If alwaysGetReferences is true, then prefix/suffix text must be enabled");let{parent:W,propertyName:st,name:Nt}=dt,Ke=W.parent,ht=ke(We,mt,dt,_e.checker);if(!pt&&!Ot.includes(ht))return;if(st?We===st?(Ke.moduleSpecifier||Wt(),Ve&&_e.options.use!==2&&_e.markSeenReExportRHS(Nt)&&St(Nt,I.checkDefined(dt.symbol),_e)):_e.markSeenReExportRHS(We)&&Wt():_e.options.use===2&&Nt.escapedText==="default"||Wt(),!qr(_e.options)||pt){let hr=We.escapedText==="default"||dt.name.escapedText==="default"?1:0,Sr=I.checkDefined(dt.symbol),Y=Zbe(Sr,hr,_e.checker);Y&&K(We,Sr,Y,_e)}if(Ot.comingFrom!==1&&Ke.moduleSpecifier&&!st&&!qr(_e.options)){let Cr=_e.checker.getExportSpecifierLocalTargetSymbol(dt);Cr&&pe(Cr,_e)}function Wt(){Ve&&St(We,ht,_e)}}function ke(We,mt,dt,Ot){return $e(We,dt)&&Ot.getExportSpecifierLocalTargetSymbol(dt)||mt}function $e(We,mt){let{parent:dt,propertyName:Ot,name:_e}=mt;return I.assert(Ot===We||_e===We),Ot?Ot===We:!dt.parent.moduleSpecifier}function at(We,mt,dt,Ot){let _e=NVe(We,mt,Ot.checker,dt.comingFrom===1);if(!_e)return;let{symbol:Ve}=_e;_e.kind===0?qr(Ot.options)||pe(Ve,Ot):K(We,Ve,_e.exportInfo,Ot)}function $t({flags:We,valueDeclaration:mt},dt,Ot){let _e=Ot.checker.getShorthandAssignmentValueSymbol(mt),Ve=mt&&qs(mt);!(We&33554432)&&Ve&&dt.includes(_e)&&St(Ve,_e,Ot)}function St(We,mt,dt){let{kind:Ot,symbol:_e}="kind"in mt?mt:{kind:void 0,symbol:mt};if(dt.options.use===2&&We.kind===90)return;let Ve=dt.referenceAdder(_e);dt.options.implementations?nr(We,Ve,dt):Ve(We,Ot)}function Ze(We,mt,dt,Ot){bO(We)&&St(We,dt.symbol,Ot);let _e=()=>Ot.referenceAdder(dt.symbol);if(Ti(We.parent))I.assert(We.kind===90||We.parent.name===We),ar(dt.symbol,mt,_e());else{let Ve=to(We);Ve&&(Fr(Ve,_e()),Tr(Ve,Ot))}}function yt(We,mt,dt){St(We,mt.symbol,dt);let Ot=We.parent;if(dt.options.use===2||!Ti(Ot))return;I.assert(Ot.name===We);let _e=dt.referenceAdder(mt.symbol);for(let Ve of Ot.members)vA(Ve)&&pa(Ve)&&Ve.body&&Ve.body.forEachChild(function pt(W){W.kind===110?_e(W):!ca(W)&&!Ti(W)&&W.forEachChild(pt)})}function ar(We,mt,dt){let Ot=or(We);if(Ot&&Ot.declarations)for(let _e of Ot.declarations){let Ve=Oo(_e,137,mt);I.assert(_e.kind===176&&!!Ve),dt(Ve)}We.exports&&We.exports.forEach(_e=>{let Ve=_e.valueDeclaration;if(Ve&&Ve.kind===174){let pt=Ve.body;pt&&Ta(pt,110,W=>{bO(W)&&dt(W)})}})}function or(We){return We.members&&We.members.get("__constructor")}function Fr(We,mt){let dt=or(We.symbol);if(dt&&dt.declarations)for(let Ot of dt.declarations){I.assert(Ot.kind===176);let _e=Ot.body;_e&&Ta(_e,108,Ve=>{Kee(Ve)&&mt(Ve)})}}function rn(We){return!!or(We.symbol)}function Tr(We,mt){if(rn(We))return;let dt=We.symbol,Ot=mt.createSearch(void 0,dt,void 0);k(dt,mt,Ot)}function nr(We,mt,dt){if(Cy(We)&&us(We.parent)){mt(We);return}if(We.kind!==80)return;We.parent.kind===304&&Fs(We,dt.checker,mt);let Ot=tr(We);if(Ot){mt(Ot);return}let _e=Gr(We,W=>!pf(W.parent)&&!es(W.parent)&&!B2(W.parent)),Ve=_e.parent;if(L9(Ve)&&Ve.type===_e&&dt.markSeenContainingTypeReference(Ve))if(jv(Ve))pt(Ve.initializer);else if(ca(Ve)&&Ve.body){let W=Ve.body;W.kind===241?$b(W,st=>{st.expression&&pt(st.expression)}):pt(W)}else U2(Ve)&&pt(Ve.expression);function pt(W){ki(W)&&mt(W)}}function tr(We){return ze(We)||Hn(We)?tr(We.parent):L1(We)?ii(We.parent.parent,cg(Ti,ef)):void 0}function ki(We){switch(We.kind){case 217:return ki(We.expression);case 219:case 218:case 210:case 231:case 209:return!0;default:return!1}}function xs(We,mt,dt,Ot){if(We===mt)return!0;let _e=Ia(We)+","+Ia(mt),Ve=dt.get(_e);if(Ve!==void 0)return Ve;dt.set(_e,!1);let pt=!!We.declarations&&We.declarations.some(W=>Yw(W).some(st=>{let Nt=Ot.getTypeAtLocation(st);return!!Nt&&!!Nt.symbol&&xs(Nt.symbol,mt,dt,Ot)}));return dt.set(_e,pt),pt}function zi(We){let mt=E8(We,!1);if(!mt)return;let dt=256;switch(mt.kind){case 172:case 171:case 174:case 173:case 176:case 177:case 178:dt&=qv(mt),mt=mt.parent;break;default:return}let Ot=mt.getSourceFile(),_e=Wi(ye(Ot,"super",mt),Ve=>{if(Ve.kind!==108)return;let pt=E8(Ve,!1);return pt&&pa(pt)===!!dt&&pt.parent.symbol===mt.symbol?B0(Ve):void 0});return[{definition:{type:0,symbol:mt.symbol},references:_e}]}function Ms(We){return We.kind===80&&We.parent.kind===169&&We.parent.name===We}function un(We,mt,dt){let Ot=kf(We,!1,!1),_e=256;switch(Ot.kind){case 174:case 173:if(jm(Ot)){_e&=qv(Ot),Ot=Ot.parent;break}case 172:case 171:case 176:case 177:case 178:_e&=qv(Ot),Ot=Ot.parent;break;case 312:if(Pl(Ot)||Ms(We))return;case 262:case 218:break;default:return}let Ve=_a(Ot.kind===312?mt:[Ot.getSourceFile()],W=>(dt.throwIfCancellationRequested(),ye(W,"this",ls(Ot)?W:Ot).filter(st=>{if(!TD(st))return!1;let Nt=kf(st,!1,!1);if(!qg(Nt))return!1;switch(Ot.kind){case 218:case 262:return Ot.symbol===Nt.symbol;case 174:case 173:return jm(Ot)&&Ot.symbol===Nt.symbol;case 231:case 263:case 210:return Nt.parent&&qg(Nt.parent)&&Ot.symbol===Nt.parent.symbol&&pa(Nt)===!!_e;case 312:return Nt.kind===312&&!Pl(Nt)&&!Ms(st)}}))).map(W=>B0(W));return[{definition:{type:3,node:Ct(Ve,W=>Ls(W.node.parent)?W.node:void 0)||We},references:Ve}]}function ri(We,mt,dt,Ot){let _e=iJ(We,dt),Ve=_a(mt,pt=>(Ot.throwIfCancellationRequested(),Wi(ye(pt,We.text),W=>{if(bo(W)&&W.text===We.text)if(_e){let st=iJ(W,dt);if(_e!==dt.getStringType()&&(_e===st||On(W,dt)))return B0(W,2)}else return zA(W)&&!rx(W,pt)?void 0:B0(W,2)})));return[{definition:{type:4,node:We},references:Ve}]}function On(We,mt){if(fp(We.parent))return mt.getPropertyOfType(mt.getTypeAtLocation(We.parent.parent),We.text)}function _r(We,mt,dt,Ot,_e,Ve){let pt=[];return rt(We,mt,dt,Ot,!(Ot&&_e),(W,st,Nt)=>{Nt&&Rr(We)!==Rr(Nt)&&(Nt=void 0),pt.push(Nt||st||W)},()=>!Ve),pt}function rt(We,mt,dt,Ot,_e,Ve,pt){let W=I7(mt);if(W){let hr=dt.getShorthandAssignmentValueSymbol(mt.parent);if(hr&&Ot)return Ve(hr,void 0,void 0,3);let Sr=dt.getContextualType(W.parent),Y=Sr&&Ct(pq(W,dt,Sr,!0),le=>Wt(le,4));if(Y)return Y;let Be=se(mt,dt),Lt=Be&&Ve(Be,void 0,void 0,4);if(Lt)return Lt;let B=hr&&Ve(hr,void 0,void 0,3);if(B)return B}let st=o(mt,We,dt);if(st){let hr=Ve(st,void 0,void 0,1);if(hr)return hr}let Nt=Wt(We);if(Nt)return Nt;if(We.valueDeclaration&&op(We.valueDeclaration,We.valueDeclaration.parent)){let hr=dt.getSymbolsOfParameterPropertyDeclaration(ta(We.valueDeclaration,Ls),We.name);return I.assert(hr.length===2&&!!(hr[0].flags&1)&&!!(hr[1].flags&4)),Wt(We.flags&1?hr[1]:hr[0])}let Ke=xc(We,281);if(!Ot||Ke&&!Ke.propertyName){let hr=Ke&&dt.getExportSpecifierLocalTargetSymbol(Ke);if(hr){let Sr=Ve(hr,void 0,void 0,1);if(Sr)return Sr}}if(!Ot){let hr;return _e?hr=i7(mt.parent)?yJ(dt,mt.parent):void 0:hr=Cr(We,dt),hr&&Wt(hr,4)}if(I.assert(Ot),_e){let hr=Cr(We,dt);return hr&&Wt(hr,4)}function Wt(hr,Sr){return Ct(dt.getRootSymbols(hr),Y=>Ve(hr,Y,void 0,Sr)||(Y.parent&&Y.parent.flags&96&&pt(Y)?zt(Y.parent,Y.name,dt,Be=>Ve(hr,Y,Be,Sr)):void 0))}function Cr(hr,Sr){let Y=xc(hr,208);if(Y&&i7(Y))return yJ(Sr,Y)}}function zt(We,mt,dt,Ot){let _e=new Map;return Ve(We);function Ve(pt){if(!(!(pt.flags&96)||!Bm(_e,Ia(pt))))return Ct(pt.declarations,W=>Ct(Yw(W),st=>{let Nt=dt.getTypeAtLocation(st),Ke=Nt&&Nt.symbol&&dt.getPropertyOfType(Nt,mt);return Nt&&Ke&&(Ct(dt.getRootSymbols(Ke),Ot)||Ve(Nt.symbol))}))}}function Rr(We){return We.valueDeclaration?!!(X_(We.valueDeclaration)&256):!1}function vi(We,mt,dt,Ot){let{checker:_e}=Ot;return rt(mt,dt,_e,!1,Ot.options.use!==2||!!Ot.options.providePrefixAndSuffixTextForRename,(Ve,pt,W,st)=>(W&&Rr(mt)!==Rr(W)&&(W=void 0),We.includes(W||pt||Ve)?{symbol:pt&&!(Vc(Ve)&6)?pt:Ve,kind:st}:void 0),Ve=>!(We.parents&&!We.parents.some(pt=>xs(Ve.parent,pt,Ot.inheritsFromCache,_e))))}function Ni(We,mt){let dt=Cx(We),{declarations:Ot}=mt;if(Ot){let _e;do{_e=dt;for(let Ve of Ot){let pt=zM(Ve);pt&dt&&(dt|=pt)}}while(dt!==_e)}return dt}e.getIntersectingMeaningFromDeclarations=Ni;function us(We){return We.flags&33554432?!(ef(We)||Vm(We)):cN(We)?jv(We):tc(We)?!!We.body:Ti(We)||c8(We)}function Fs(We,mt,dt){let Ot=mt.getSymbolAtLocation(We),_e=mt.getShorthandAssignmentValueSymbol(Ot.valueDeclaration);if(_e)for(let Ve of _e.getDeclarations())zM(Ve)&1&&dt(Ve)}e.getReferenceEntriesForShorthandPropertyAssignment=Fs;function Ta(We,mt,dt){Qs(We,Ot=>{Ot.kind===mt&&dt(Ot),Ta(Ot,mt,dt)})}function to(We){return xX(QV(We).parent)}function Nr(We,mt,dt){let Ot=SD(We)?We.parent:void 0,_e=Ot&&dt.getTypeAtLocation(Ot.expression),Ve=Wi(_e&&(_e.isUnionOrIntersection()?_e.types:_e.symbol===mt.parent?void 0:[_e]),pt=>pt.symbol&&pt.symbol.flags&96?pt.symbol:void 0);return Ve.length===0?void 0:Ve}function qr(We){return We.use===2&&We.providePrefixAndSuffixTextForRename}})(Nk||(Nk={}))}}),Ko={};x(Ko,{Core:()=>Nk,DefinitionKind:()=>oEe,EntryKind:()=>cEe,ExportKind:()=>tEe,FindReferencesUse:()=>lEe,ImportExport:()=>rEe,createImportTracker:()=>Qbe,findModuleReferences:()=>AVe,findReferenceOrRenameEntries:()=>e6t,findReferencedSymbols:()=>Kwt,getContextNode:()=>Ix,getExportInfo:()=>Zbe,getImplementationsAtPosition:()=>Zwt,getImportOrExportSymbol:()=>NVe,getReferenceEntriesForNode:()=>IVe,getTextSpanOfEntry:()=>sEe,isContextWithStartAndEndNode:()=>nEe,isDeclarationOfSymbol:()=>MVe,isWriteAccessForReference:()=>aEe,nodeEntry:()=>B0,toContextSpan:()=>iEe,toHighlightSpan:()=>o6t,toReferenceEntry:()=>RVe,toRenameLocation:()=>r6t});var uEe=f({"src/services/_namespaces/ts.FindAllReferences.ts"(){"use strict";Ywt(),l6t()}});function LVe(e,t,n,i,s){var o;let l=jVe(t,n,e),p=l&&[T6t(l.reference.fileName,l.fileName,l.unverified)]||tt;if(l?.file)return p;let m=If(t,n);if(m===t)return;let{parent:S}=m,h=e.getTypeChecker();if(m.kind===164||ze(m)&&uU(S)&&S.tagName===m)return _6t(h,m)||tt;if(GM(m)){let O=ZV(m.parent,m.text);return O?[_Ee(h,O,"label",m.text,void 0)]:void 0}switch(m.kind){case 107:let O=Gr(m.parent,H=>Jc(H)?"quit":tc(H));return O?[Mq(h,O)]:void 0;case 90:if(!q6(m.parent))break;case 84:let U=Gr(m.parent,U6);if(U)return[S6t(U,t)];break}if(m.kind===135){let O=Gr(m,H=>tc(H));return O&&Tt(O.modifiers,H=>H.kind===134)?[Mq(h,O)]:void 0}if(m.kind===127){let O=Gr(m,H=>tc(H));return O&&O.asteriskToken?[Mq(h,O)]:void 0}if(GA(m)&&Jc(m.parent)){let O=m.parent.parent,{symbol:U,failedAliasResolution:H}=Hie(O,h,s),K=Fn(O.members,Jc),re=U?h.symbolToString(U,O):"",$=m.getSourceFile();return vr(K,pe=>{let{pos:z}=Xg(pe);return z=Wa($.text,z),_Ee(h,pe,"constructor","static {}",re,!1,H,{start:z,length:6})})}let{symbol:b,failedAliasResolution:A}=Hie(m,h,s),k=m;if(i&&A){let O=Te([m,...b?.declarations||tt],H=>Gr(H,rde)),U=O&&dN(O);U&&({symbol:b,failedAliasResolution:A}=Hie(U,h,s),k=U)}if(!b&&hJ(k)){let O=(o=e.getResolvedModuleFromModuleSpecifier(k))==null?void 0:o.resolvedModule;if(O)return[{name:k.text,fileName:O.resolvedFileName,containerName:void 0,containerKind:void 0,kind:"script",textSpan:e_(0,0),failedAliasResolution:A,isAmbient:i_(O.resolvedFileName),unverified:k!==m}]}if(!b)return ys(p,h6t(m,h));if(i&&yr(b.declarations,O=>O.getSourceFile().fileName===t.fileName))return;let N=E6t(h,m);if(N&&!(H_(m.parent)&&x6t(N))){let O=Mq(h,N,A);if(h.getRootSymbols(b).some(U=>u6t(U,N)))return[O];{let U=JO(h,b,m,A,N)||tt;return m.kind===108?[O,...U]:[...U,O]}}if(m.parent.kind===304){let O=h.getShorthandAssignmentValueSymbol(b.valueDeclaration),U=O?.declarations?O.declarations.map(H=>q7(H,h,O,m,!1,A)):tt;return ys(U,FVe(h,m))}if(Al(m)&&co(S)&&pm(S.parent)&&m===(S.propertyName||S.name)){let O=n7(m),U=h.getTypeAtLocation(S.parent);return O===void 0?tt:_a(U.isUnion()?U.types:[U],H=>{let K=H.getProperty(O);return K&&JO(h,K,m)})}let M=FVe(h,m);return ys(p,M.length?M:JO(h,b,m,A))}function u6t(e,t){var n;return e===t.symbol||e===t.symbol.parent||lu(t.parent)||!Vb(t.parent)&&e===((n=ii(t.parent,qg))==null?void 0:n.symbol)}function FVe(e,t){let n=I7(t);if(n){let i=n&&e.getContextualType(n.parent);if(i)return _a(pq(n,e,i,!1),s=>JO(e,s,t))}return tt}function _6t(e,t){let n=Gr(t,Du);if(!(n&&n.name))return;let i=Gr(n,Ti);if(!i)return;let s=$g(i);if(!s)return;let o=Do(s.expression),l=wu(o)?o.symbol:e.getSymbolAtLocation(o);if(!l)return;let p=Zi(iN(n.name)),m=jl(n)?e.getPropertyOfType(e.getTypeOfSymbol(l),p):e.getPropertyOfType(e.getDeclaredTypeOfSymbol(l),p);if(m)return JO(e,m,t)}function jVe(e,t,n){var i,s;let o=qO(e.referencedFiles,t);if(o){let m=n.getSourceFileFromReference(e,o);return m&&{reference:o,fileName:m.fileName,file:m,unverified:!1}}let l=qO(e.typeReferenceDirectives,t);if(l){let m=(i=n.getResolvedTypeReferenceDirectives().get(l.fileName,l.resolutionMode||e.impliedNodeFormat))==null?void 0:i.resolvedTypeReferenceDirective,S=m&&n.getSourceFile(m.resolvedFileName);return S&&{reference:l,fileName:S.fileName,file:S,unverified:!1}}let p=qO(e.libReferenceDirectives,t);if(p){let m=n.getLibFileFromReference(p);return m&&{reference:p,fileName:m.fileName,file:m,unverified:!1}}if(e.imports.length||e.moduleAugmentations.length){let m=bD(e,t),S;if(hJ(m)&&Nu(m.text)&&(S=n.getResolvedModuleFromModuleSpecifier(m))){let h=(s=S.resolvedModule)==null?void 0:s.resolvedFileName,b=h||Dv(hi(e.fileName),m.text);return{file:n.getSourceFile(b),fileName:b,reference:{pos:m.getStart(),end:m.getEnd(),fileName:m.text},unverified:!h}}}}function f6t(e,t){let n=t.symbol.name;if(!pEe.has(n))return!1;let i=e.resolveName(n,void 0,788968,!1);return!!i&&i===t.target.symbol}function BVe(e,t){if(!t.aliasSymbol)return!1;let n=t.aliasSymbol.name;if(!pEe.has(n))return!1;let i=e.resolveName(n,void 0,788968,!1);return!!i&&i===t.aliasSymbol}function p6t(e,t,n,i){var s,o;if(Gn(t)&4&&f6t(e,t))return J7(e.getTypeArguments(t)[0],e,n,i);if(BVe(e,t)&&t.aliasTypeArguments)return J7(t.aliasTypeArguments[0],e,n,i);if(Gn(t)&32&&t.target&&BVe(e,t.target)){let l=(o=(s=t.aliasSymbol)==null?void 0:s.declarations)==null?void 0:o[0];if(l&&Vm(l)&&Id(l.type)&&l.type.typeArguments)return J7(e.getTypeAtLocation(l.type.typeArguments[0]),e,n,i)}return[]}function d6t(e,t,n){let i=If(t,n);if(i===t)return;if(oN(i.parent)&&i.parent.name===i)return J7(e.getTypeAtLocation(i.parent),e,i.parent,!1);let{symbol:s,failedAliasResolution:o}=Hie(i,e,!1);if(!s)return;let l=e.getTypeOfSymbolAtLocation(s,i),p=m6t(s,l,e),m=p&&J7(p,e,i,o),[S,h]=m&&m.length!==0?[p,m]:[l,J7(l,e,i,o)];return h.length?[...p6t(e,S,i,o),...h]:!(s.flags&111551)&&s.flags&788968?JO(e,r_(s,e),i,o):void 0}function J7(e,t,n,i){return _a(e.isUnion()&&!(e.flags&32)?e.types:[e],s=>s.symbol&&JO(t,s.symbol,n,i))}function m6t(e,t,n){if(t.symbol===e||e.valueDeclaration&&t.symbol&&Gi(e.valueDeclaration)&&e.valueDeclaration.initializer===t.symbol.valueDeclaration){let i=t.getCallSignatures();if(i.length===1)return n.getReturnTypeOfSignature(di(i))}}function g6t(e,t,n){let i=LVe(e,t,n);if(!i||i.length===0)return;let s=qO(t.referencedFiles,n)||qO(t.typeReferenceDirectives,n)||qO(t.libReferenceDirectives,n);if(s)return{definitions:i,textSpan:aS(s)};let o=If(t,n),l=e_(o.getStart(),o.getWidth());return{definitions:i,textSpan:l}}function h6t(e,t){return Wi(t.getIndexInfosAtLocation(e),n=>n.declaration&&Mq(t,n.declaration))}function Hie(e,t,n){let i=t.getSymbolAtLocation(e),s=!1;if(i?.declarations&&i.flags&2097152&&!n&&y6t(e,i.declarations[0])){let o=t.getAliasedSymbol(i);if(o.declarations)return{symbol:o};s=!0}return{symbol:i,failedAliasResolution:s}}function y6t(e,t){return e.kind!==80?!1:e.parent===t?!0:t.kind!==274}function v6t(e){if(!Ww(e))return!1;let t=Gr(e,n=>lu(n)?!0:Ww(n)?!1:"quit");return!!t&&al(t)===5}function JO(e,t,n,i,s){let o=Fn(t.declarations,b=>b!==s),l=Fn(o,b=>!v6t(b)),p=Tt(l)?l:o;return m()||S()||vr(p,b=>q7(b,e,t,n,!1,i));function m(){if(t.flags&32&&!(t.flags&19)&&(bO(n)||n.kind===137)){let b=mr(o,Ti)||I.fail("Expected declaration to have at least one class-like declaration");return h(b.members,!0)}}function S(){return Qee(n)||ste(n)?h(o,!1):void 0}function h(b,A){if(!b)return;let k=b.filter(A?Yc:ca),N=k.filter(M=>!!M.body);return k.length?N.length!==0?N.map(M=>q7(M,e,t,n)):[q7(Rs(k),e,t,n,!1,i)]:void 0}}function q7(e,t,n,i,s,o){let l=t.symbolToString(n),p=W1.getSymbolKind(t,n,i),m=n.parent?t.symbolToString(n.parent,i):"";return _Ee(t,e,p,l,m,s,o)}function _Ee(e,t,n,i,s,o,l,p){let m=t.getSourceFile();if(!p){let S=qs(t)||t;p=gf(S,m)}return{fileName:m.fileName,textSpan:p,kind:n,name:i,containerKind:void 0,containerName:s,...Ko.toContextSpan(p,m,Ko.getContextNode(t)),isLocal:!fEe(e,t),isAmbient:!!(t.flags&33554432),unverified:o,failedAliasResolution:l}}function S6t(e,t){let n=Ko.getContextNode(e),i=gf(nEe(n)?n.start:n,t);return{fileName:t.fileName,textSpan:i,kind:"keyword",name:"switch",containerKind:void 0,containerName:"",...Ko.toContextSpan(i,t,n),isLocal:!0,isAmbient:!1,unverified:!1,failedAliasResolution:void 0}}function fEe(e,t){if(e.isDeclarationVisible(t))return!0;if(!t.parent)return!1;if(jv(t.parent)&&t.parent.initializer===t)return fEe(e,t.parent);switch(t.kind){case 172:case 177:case 178:case 174:if(up(t,2))return!1;case 176:case 303:case 304:case 210:case 231:case 219:case 218:return fEe(e,t.parent);default:return!1}}function Mq(e,t,n){return q7(t,e,t.symbol,t,!1,n)}function qO(e,t){return mr(e,n=>G3(n,t))}function T6t(e,t,n){return{fileName:t,textSpan:Ll(0,0),kind:"script",name:e,containerName:void 0,containerKind:void 0,unverified:n}}function b6t(e){let t=Gr(e,i=>!SD(i)),n=t?.parent;return n&&Vb(n)&&aj(n)===t?n:void 0}function E6t(e,t){let n=b6t(t),i=n&&e.getResolvedSignature(n);return ii(i&&i.declaration,s=>ca(s)&&!Vh(s))}function x6t(e){switch(e.kind){case 176:case 185:case 180:return!0;default:return!1}}var pEe,C6t=f({"src/services/goToDefinition.ts"(){"use strict";yi(),uEe(),pEe=new Set(["Array","ArrayLike","ReadonlyArray","Promise","PromiseLike","Iterable","IterableIterator","AsyncIterable","Set","WeakSet","ReadonlySet","Map","WeakMap","ReadonlyMap","Partial","Required","Readonly","Pick","Omit"])}}),UD={};x(UD,{createDefinitionInfo:()=>q7,findReferenceInPosition:()=>qO,getDefinitionAndBoundSpan:()=>g6t,getDefinitionAtPosition:()=>LVe,getReferenceAtPosition:()=>jVe,getTypeDefinitionAtPosition:()=>d6t});var A6t=f({"src/services/_namespaces/ts.GoToDefinition.ts"(){"use strict";C6t()}});function k6t(e){return e.includeInlayParameterNameHints==="literals"||e.includeInlayParameterNameHints==="all"}function P6t(e){return e.includeInlayParameterNameHints==="literals"}function UVe(e){return e.interactiveInlayHints===!0}function N6t(e){let{file:t,program:n,span:i,cancellationToken:s,preferences:o}=e,l=t.text,p=n.getCompilerOptions(),m=_d(t,o),S=n.getTypeChecker(),h=[];return b(t),h;function b(ve){if(!(!ve||ve.getFullWidth()===0)){switch(ve.kind){case 267:case 263:case 264:case 262:case 231:case 218:case 174:case 219:s.throwIfCancellationRequested()}if(v9(i,ve.pos,ve.getFullWidth())&&!(es(ve)&&!L1(ve)))return o.includeInlayVariableTypeHints&&Gi(ve)||o.includeInlayPropertyDeclarationTypeHints&&ea(ve)?H(ve):o.includeInlayEnumMemberValueHints&&gE(ve)?O(ve):k6t(o)&&(da(ve)||lE(ve))?K(ve):(o.includeInlayFunctionParameterTypeHints&&tc(ve)&&sB(ve)&&Se(ve),o.includeInlayFunctionLikeReturnTypeHints&&A(ve)&&z(ve)),Qs(ve,b)}}function A(ve){return rc(ve)||Xo(ve)||Zl(ve)||pl(ve)||sd(ve)}function k(ve,oe,Ee,Me){let Ge=`${Me?"...":""}${ve}`,Ae;UVe(o)?(Ae=[we(Ge,oe),{text:":"}],Ge=""):Ge+=":",h.push({text:Ge,position:Ee,kind:"Parameter",whitespaceAfter:!0,displayParts:Ae})}function N(ve,oe){h.push({text:typeof ve=="string"?`: ${ve}`:"",displayParts:typeof ve=="string"?void 0:[{text:": "},...ve],position:oe,kind:"Type",whitespaceBefore:!0})}function M(ve,oe){h.push({text:`= ${ve}`,position:oe,kind:"Enum",whitespaceBefore:!0})}function O(ve){if(ve.initializer)return;let oe=S.getConstantValue(ve);oe!==void 0&&M(oe.toString(),ve.end)}function U(ve){return ve.symbol&&ve.symbol.flags&1536}function H(ve){if(!ve.initializer||la(ve.name)||Gi(ve)&&!ye(ve)||t_(ve))return;let Ee=S.getTypeAtLocation(ve);if(U(Ee))return;let Me=Q(Ee);if(Me){let Ge=typeof Me=="string"?Me:Me.map(Ie=>Ie.text).join("");if(o.includeInlayVariableTypeHintsWhenTypeMatchesName===!1&&S1(ve.name.getText(),Ge))return;N(Me,ve.name.end)}}function K(ve){let oe=ve.arguments;if(!oe||!oe.length)return;let Ee=[],Me=S.getResolvedSignatureForSignatureHelp(ve,Ee);if(!Me||!Ee.length)return;let Ge=0;for(let Ae of oe){let Ie=Do(Ae);if(P6t(o)&&!pe(Ie)){Ge++;continue}let Re=0;if(fg(Ie)){let kt=S.getTypeAtLocation(Ie.expression);if(S.isTupleType(kt)){let{elementFlags:ke,fixedLength:$e}=kt.target;if($e===0)continue;let at=oa(ke,St=>!(St&1));(at<0?$e:at)>0&&(Re=at<0?$e:at)}}let Ue=S.getParameterIdentifierInfoAtPosition(Me,Ge);if(Ge=Ge+(Re||1),Ue){let{parameter:kt,parameterName:ke,isRestParameter:$e}=Ue;if(!(o.includeInlayParameterNameHintsWhenArgumentMatchesName||!re(Ie,ke))&&!$e)continue;let $t=Zi(ke);if($(Ie,$t))continue;k($t,kt,Ae.getStart(),$e)}}}function re(ve,oe){return ze(ve)?ve.text===oe:Hn(ve)?ve.name.text===oe:!1}function $(ve,oe){if(!nd(oe,p.target,sR(t.scriptKind)))return!1;let Ee=T0(l,ve.pos);if(!Ee?.length)return!1;let Me=VVe(oe);return Tt(Ee,Ge=>Me.test(l.substring(Ge.pos,Ge.end)))}function pe(ve){switch(ve.kind){case 224:{let oe=ve.operand;return Ub(oe)||ze(oe)&&E6(oe.escapedText)}case 112:case 97:case 106:case 15:case 228:return!0;case 80:{let oe=ve.escapedText;return ce(oe)||E6(oe)}}return Ub(ve)}function z(ve){if(rc(ve)&&!Oo(ve,21,t)||lm(ve)||!ve.body)return;let Ee=S.getSignatureFromDeclaration(ve);if(!Ee)return;let Me=S.getReturnTypeOfSignature(Ee);if(U(Me))return;let Ge=Q(Me);Ge&&N(Ge,se(ve))}function se(ve){let oe=Oo(ve,22,t);return oe?oe.end:ve.parameters.end}function Se(ve){let oe=S.getSignatureFromDeclaration(ve);if(oe)for(let Ee=0;Ee<ve.parameters.length&&Ee<oe.parameters.length;++Ee){let Me=ve.parameters[Ee];if(!ye(Me)||t_(Me))continue;let Ae=xe(oe.parameters[Ee]);Ae&&N(Ae,Me.questionToken?Me.questionToken.end:Me.name.end)}}function xe(ve){let oe=ve.valueDeclaration;if(!oe||!Ls(oe))return;let Ee=S.getTypeOfSymbolAtLocation(ve,oe);if(!U(Ee))return Q(Ee)}function Z(ve){let Ee=EE();return jw(Me=>{let Ge=S.typeToTypeNode(ve,void 0,71286784);I.assertIsDefined(Ge,"should always get typenode"),Ee.writeNode(4,Ge,t,Me)})}function Q(ve){if(!UVe(o))return Z(ve);let Ee=S.typeToTypeNode(ve,void 0,71286784);I.assertIsDefined(Ee,"should always get typenode");let Me=[];return Ge(Ee),Me;function Ge(Ue){var kt,ke;if(!Ue)return;let $e=Sa(Ue.kind);if($e){Me.push({text:$e});return}if(Ub(Ue)){Me.push({text:Re(Ue)});return}switch(Ue.kind){case 80:I.assertNode(Ue,ze);let at=Nn(Ue),$t=Ue.symbol&&Ue.symbol.declarations&&Ue.symbol.declarations.length&&qs(Ue.symbol.declarations[0]);$t?Me.push(we(at,$t)):Me.push({text:at});break;case 166:I.assertNode(Ue,pf),Ge(Ue.left),Me.push({text:"."}),Ge(Ue.right);break;case 182:I.assertNode(Ue,RR),Ue.assertsModifier&&Me.push({text:"asserts "}),Ge(Ue.parameterName),Ue.type&&(Me.push({text:" is "}),Ge(Ue.type));break;case 183:I.assertNode(Ue,Id),Ge(Ue.typeName),Ue.typeArguments&&(Me.push({text:"<"}),Ie(Ue.typeArguments,", "),Me.push({text:">"}));break;case 168:I.assertNode(Ue,Nc),Ue.modifiers&&Ie(Ue.modifiers," "),Ge(Ue.name),Ue.constraint&&(Me.push({text:" extends "}),Ge(Ue.constraint)),Ue.default&&(Me.push({text:" = "}),Ge(Ue.default));break;case 169:I.assertNode(Ue,Ls),Ue.modifiers&&Ie(Ue.modifiers," "),Ue.dotDotDotToken&&Me.push({text:"..."}),Ge(Ue.name),Ue.questionToken&&Me.push({text:"?"}),Ue.type&&(Me.push({text:": "}),Ge(Ue.type));break;case 185:I.assertNode(Ue,VN),Me.push({text:"new "}),Ae(Ue),Me.push({text:" => "}),Ge(Ue.type);break;case 186:I.assertNode(Ue,YA),Me.push({text:"typeof "}),Ge(Ue.exprName),Ue.typeArguments&&(Me.push({text:"<"}),Ie(Ue.typeArguments,", "),Me.push({text:">"}));break;case 187:I.assertNode(Ue,dp),Me.push({text:"{"}),Ue.members.length&&(Me.push({text:" "}),Ie(Ue.members,"; "),Me.push({text:" "})),Me.push({text:"}"});break;case 188:I.assertNode(Ue,MR),Ge(Ue.elementType),Me.push({text:"[]"});break;case 189:I.assertNode(Ue,XA),Me.push({text:"["}),Ie(Ue.elements,", "),Me.push({text:"]"});break;case 202:I.assertNode(Ue,JN),Ue.dotDotDotToken&&Me.push({text:"..."}),Ge(Ue.name),Ue.questionToken&&Me.push({text:"?"}),Me.push({text:": "}),Ge(Ue.type);break;case 190:I.assertNode(Ue,rU),Ge(Ue.type),Me.push({text:"?"});break;case 191:I.assertNode(Ue,nU),Me.push({text:"..."}),Ge(Ue.type);break;case 192:I.assertNode(Ue,Kv),Ie(Ue.types," | ");break;case 193:I.assertNode(Ue,KA),Ie(Ue.types," & ");break;case 194:I.assertNode(Ue,QA),Ge(Ue.checkType),Me.push({text:" extends "}),Ge(Ue.extendsType),Me.push({text:" ? "}),Ge(Ue.trueType),Me.push({text:" : "}),Ge(Ue.falseType);break;case 195:I.assertNode(Ue,ax),Me.push({text:"infer "}),Ge(Ue.typeParameter);break;case 196:I.assertNode(Ue,ox),Me.push({text:"("}),Ge(Ue.type),Me.push({text:")"});break;case 198:I.assertNode(Ue,cx),Me.push({text:`${Sa(Ue.operator)} `}),Ge(Ue.type);break;case 199:I.assertNode(Ue,lx),Ge(Ue.objectType),Me.push({text:"["}),Ge(Ue.indexType),Me.push({text:"]"});break;case 200:I.assertNode(Ue,qN),Me.push({text:"{ "}),Ue.readonlyToken&&(Ue.readonlyToken.kind===40?Me.push({text:"+"}):Ue.readonlyToken.kind===41&&Me.push({text:"-"}),Me.push({text:"readonly "})),Me.push({text:"["}),Ge(Ue.typeParameter),Ue.nameType&&(Me.push({text:" as "}),Ge(Ue.nameType)),Me.push({text:"]"}),Ue.questionToken&&(Ue.questionToken.kind===40?Me.push({text:"+"}):Ue.questionToken.kind===41&&Me.push({text:"-"}),Me.push({text:"?"})),Me.push({text:": "}),Ue.type&&Ge(Ue.type),Me.push({text:"; }"});break;case 201:I.assertNode(Ue,Qv),Ge(Ue.literal);break;case 184:I.assertNode(Ue,Vh),Ae(Ue),Me.push({text:" => "}),Ge(Ue.type);break;case 205:I.assertNode(Ue,M0),Ue.isTypeOf&&Me.push({text:"typeof "}),Me.push({text:"import("}),Ge(Ue.argument),Ue.assertions&&(Me.push({text:", { assert: "}),Ie(Ue.assertions.assertClause.elements,", "),Me.push({text:" }"})),Me.push({text:")"}),Ue.qualifier&&(Me.push({text:"."}),Ge(Ue.qualifier)),Ue.typeArguments&&(Me.push({text:"<"}),Ie(Ue.typeArguments,", "),Me.push({text:">"}));break;case 171:I.assertNode(Ue,fp),(kt=Ue.modifiers)!=null&&kt.length&&(Ie(Ue.modifiers," "),Me.push({text:" "})),Ge(Ue.name),Ue.questionToken&&Me.push({text:"?"}),Ue.type&&(Me.push({text:": "}),Ge(Ue.type));break;case 181:I.assertNode(Ue,oE),Me.push({text:"["}),Ie(Ue.parameters,", "),Me.push({text:"]"}),Ue.type&&(Me.push({text:": "}),Ge(Ue.type));break;case 173:I.assertNode(Ue,Uh),(ke=Ue.modifiers)!=null&&ke.length&&(Ie(Ue.modifiers," "),Me.push({text:" "})),Ge(Ue.name),Ue.questionToken&&Me.push({text:"?"}),Ae(Ue),Ue.type&&(Me.push({text:": "}),Ge(Ue.type));break;case 179:I.assertNode(Ue,HA),Ae(Ue),Ue.type&&(Me.push({text:": "}),Ge(Ue.type));break;case 207:I.assertNode(Ue,cE),Me.push({text:"["}),Ie(Ue.elements,", "),Me.push({text:"]"});break;case 206:I.assertNode(Ue,pm),Me.push({text:"{"}),Ue.elements.length&&(Me.push({text:" "}),Ie(Ue.elements,", "),Me.push({text:" "})),Me.push({text:"}"});break;case 208:I.assertNode(Ue,co),Ge(Ue.name);break;case 224:I.assertNode(Ue,eS),Me.push({text:Sa(Ue.operator)}),Ge(Ue.operand);break;case 203:I.assertNode(Ue,xge),Ge(Ue.head),Ue.templateSpans.forEach(Ge);break;case 16:I.assertNode(Ue,$A),Me.push({text:Re(Ue)});break;case 204:I.assertNode(Ue,RK),Ge(Ue.type),Ge(Ue.literal);break;case 17:I.assertNode(Ue,DK),Me.push({text:Re(Ue)});break;case 18:I.assertNode(Ue,QB),Me.push({text:Re(Ue)});break;case 197:I.assertNode(Ue,LR),Me.push({text:"this"});break;default:I.failBadSyntaxKind(Ue)}}function Ae(Ue){Ue.typeParameters&&(Me.push({text:"<"}),Ie(Ue.typeParameters,", "),Me.push({text:">"})),Me.push({text:"("}),Ie(Ue.parameters,", "),Me.push({text:")"})}function Ie(Ue,kt){Ue.forEach((ke,$e)=>{$e>0&&Me.push({text:kt}),Ge(ke)})}function Re(Ue){switch(Ue.kind){case 11:return m===0?`'${D0(Ue.text,39)}'`:`"${D0(Ue.text,34)}"`;case 16:case 17:case 18:{let kt=Ue.rawText??pX(D0(Ue.text,96));switch(Ue.kind){case 16:return"`"+kt+"${";case 17:return"}"+kt+"${";case 18:return"}"+kt+"`"}}}return Ue.text}}function ce(ve){return ve==="undefined"}function ye(ve){if((Kb(ve)||Gi(ve)&&aN(ve))&&ve.initializer){let oe=Do(ve.initializer);return!(pe(oe)||lE(oe)||Ha(oe)||U2(oe))}return!0}function we(ve,oe){let Ee=oe.getSourceFile();return{text:ve,span:gf(oe,Ee),file:Ee.fileName}}}var VVe,D6t=f({"src/services/inlayHints.ts"(){"use strict";yi(),VVe=e=>new RegExp(`^\\s?/\\*\\*?\\s?${e}\\s?\\*\\/\\s?$`)}}),Yie={};x(Yie,{provideInlayHints:()=>N6t});var I6t=f({"src/services/_namespaces/ts.InlayHints.ts"(){"use strict";D6t()}});function w6t(e,t){let n=[];return Pte(e,i=>{for(let s of R6t(i)){let o=dg(s)&&s.tags&&mr(s.tags,p=>p.kind===334&&(p.tagName.escapedText==="inheritDoc"||p.tagName.escapedText==="inheritdoc"));if(s.comment===void 0&&!o||dg(s)&&i.kind!==353&&i.kind!==345&&s.tags&&s.tags.some(p=>p.kind===353||p.kind===345)&&!s.tags.some(p=>p.kind===348||p.kind===349))continue;let l=s.comment?VD(s.comment,t):[];o&&o.comment&&(l=l.concat(VD(o.comment,t))),hs(n,l,O6t)||n.push(l)}}),ip(zn(n,[AD()]))}function O6t(e,t){return Am(e,t,(n,i)=>n.kind===i.kind&&n.text===i.text)}function R6t(e){switch(e.kind){case 348:case 355:return[e];case 345:case 353:return[e,e.parent];case 330:if(YN(e.parent))return[e.parent.parent];default:return KY(e)}}function M6t(e,t){let n=[];return Pte(e,i=>{let s=pT(i);if(!(s.some(o=>o.kind===353||o.kind===345)&&!s.some(o=>o.kind===348||o.kind===349)))for(let o of s)n.push({name:o.tagName.text,text:zVe(o,t)}),n.push(...JVe(qVe(o),t))}),n}function JVe(e,t){return _a(e,n=>ys([{name:n.tagName.text,text:zVe(n,t)}],JVe(qVe(n),t)))}function qVe(e){return ww(e)&&e.isNameFirst&&e.typeExpression&&mx(e.typeExpression.type)?e.typeExpression.type.jsDocPropertyTags:void 0}function VD(e,t){return typeof e=="string"?[fd(e)]:_a(e,n=>n.kind===328?[fd(n.text)]:L1e(n,t))}function zVe(e,t){let{comment:n,kind:i}=e,s=L6t(i);switch(i){case 356:let p=e.typeExpression;return p?o(p):n===void 0?void 0:VD(n,t);case 336:return o(e.class);case 335:return o(e.class);case 352:let m=e,S=[];if(m.constraint&&S.push(fd(m.constraint.getText())),de(m.typeParameters)){de(S)&&S.push(Qc());let b=m.typeParameters[m.typeParameters.length-1];Te(m.typeParameters,A=>{S.push(s(A.getText())),b!==A&&S.push(F_(28),Qc())})}return n&&S.push(Qc(),...VD(n,t)),S;case 351:case 357:return o(e.typeExpression);case 353:case 345:case 355:case 348:case 354:let{name:h}=e;return h?o(h):n===void 0?void 0:VD(n,t);default:return n===void 0?void 0:VD(n,t)}function o(p){return l(p.getText())}function l(p){return n?p.match(/^https?$/)?[fd(p),...VD(n,t)]:[s(p),Qc(),...VD(n,t)]:[fd(p)]}}function L6t(e){switch(e){case 348:return I1e;case 355:return w1e;case 352:return R1e;case 353:case 345:return O1e;default:return fd}}function F6t(){return WVe||(WVe=vr(mEe,e=>({name:e,kind:"keyword",kindModifiers:"",sortText:Pk.SortText.LocationPriority})))}function j6t(){return GVe||(GVe=vr(mEe,e=>({name:`@${e}`,kind:"keyword",kindModifiers:"",sortText:Pk.SortText.LocationPriority})))}function $Ve(e){return{name:e,kind:"",kindModifiers:"",displayParts:[fd(e)],documentation:tt,tags:void 0,codeActions:void 0}}function B6t(e){if(!ze(e.name))return tt;let t=e.name.text,n=e.parent,i=n.parent;return ca(i)?Wi(i.parameters,s=>{if(!ze(s.name))return;let o=s.name.text;if(!(n.tags.some(l=>l!==e&&mg(l)&&ze(l.name)&&l.name.escapedText===o)||t!==void 0&&!Ss(o,t)))return{name:o,kind:"parameter",kindModifiers:"",sortText:Pk.SortText.LocationPriority}}):[]}function U6t(e){return{name:e,kind:"parameter",kindModifiers:"",displayParts:[fd(e)],documentation:tt,tags:void 0,codeActions:void 0}}function V6t(e,t,n,i){let s=Ts(t,n),o=Gr(s,dg);if(o&&(o.comment!==void 0||de(o.tags)))return;let l=s.getStart(t);if(!o&&l<n)return;let p=$6t(s,i);if(!p)return;let{commentOwner:m,parameters:S,hasReturn:h}=p,b=jp(m)&&m.jsDoc?m.jsDoc:void 0,A=Is(b);if(m.getStart(t)<n||A&&o&&A!==o)return;let k=J6t(t,n),N=rE(t.fileName),M=(S?q6t(S||[],N,k,e):"")+(h?z6t(k,e):""),O="/**",U=" */",H=de(pT(m))>0;if(M&&!H){let K=O+e+k+" * ",re=l===n?e+k:"";return{newText:K+e+M+k+U+re,caretOffset:K.length}}return{newText:O+U,caretOffset:3}}function J6t(e,t){let{text:n}=e,i=mm(t,e),s=i;for(;s<=t&&Vg(n.charCodeAt(s));s++);return n.slice(i,s)}function q6t(e,t,n,i){return e.map(({name:s,dotDotDotToken:o},l)=>{let p=s.kind===80?s.text:"param"+l;return`${n} * @param ${t?o?"{...any} ":"{any} ":""}${p}${i}`}).join("")}function z6t(e,t){return`${e} * @returns${t}`}function $6t(e,t){return $pe(e,n=>dEe(n,t))}function dEe(e,t){switch(e.kind){case 262:case 218:case 174:case 176:case 173:case 219:let n=e;return{commentOwner:e,parameters:n.parameters,hasReturn:Lq(n,t)};case 303:return dEe(e.initializer,t);case 263:case 264:case 266:case 306:case 265:return{commentOwner:e};case 171:{let s=e;return s.type&&Vh(s.type)?{commentOwner:e,parameters:s.type.parameters,hasReturn:Lq(s.type,t)}:{commentOwner:e}}case 243:{let o=e.declarationList.declarations,l=o.length===1&&o[0].initializer?W6t(o[0].initializer):void 0;return l?{commentOwner:e,parameters:l.parameters,hasReturn:Lq(l,t)}:{commentOwner:e}}case 312:return"quit";case 267:return e.parent.kind===267?void 0:{commentOwner:e};case 244:return dEe(e.expression,t);case 226:{let s=e;return al(s)===0?"quit":ca(s.right)?{commentOwner:e,parameters:s.right.parameters,hasReturn:Lq(s.right,t)}:{commentOwner:e}}case 172:let i=e.initializer;if(i&&(Xo(i)||rc(i)))return{commentOwner:e,parameters:i.parameters,hasReturn:Lq(i,t)}}}function Lq(e,t){return!!t?.generateReturnInDocTemplate&&(Vh(e)||rc(e)&&bt(e.body)||tc(e)&&e.body&&ra(e.body)&&!!$b(e.body,n=>n))}function W6t(e){for(;e.kind===217;)e=e.expression;switch(e.kind){case 218:case 219:return e;case 231:return mr(e.members,Yc)}}var mEe,WVe,GVe,HVe,G6t=f({"src/services/jsDoc.ts"(){"use strict";yi(),mEe=["abstract","access","alias","argument","async","augments","author","borrows","callback","class","classdesc","constant","constructor","constructs","copyright","default","deprecated","description","emits","enum","event","example","exports","extends","external","field","file","fileoverview","fires","function","generator","global","hideconstructor","host","ignore","implements","inheritdoc","inner","instance","interface","kind","lends","license","link","linkcode","linkplain","listens","member","memberof","method","mixes","module","name","namespace","overload","override","package","param","private","prop","property","protected","public","readonly","requires","returns","satisfies","see","since","static","summary","template","this","throws","todo","tutorial","type","typedef","var","variation","version","virtual","yields"],HVe=$Ve}}),VT={};x(VT,{getDocCommentTemplateAtPosition:()=>V6t,getJSDocParameterNameCompletionDetails:()=>U6t,getJSDocParameterNameCompletions:()=>B6t,getJSDocTagCompletionDetails:()=>$Ve,getJSDocTagCompletions:()=>j6t,getJSDocTagNameCompletionDetails:()=>HVe,getJSDocTagNameCompletions:()=>F6t,getJsDocCommentsFromDeclarations:()=>w6t,getJsDocTagsFromDeclarations:()=>M6t});var H6t=f({"src/services/_namespaces/ts.JsDoc.ts"(){"use strict";G6t()}});function Y6t(e,t,n,i,s,o){let l=En.ChangeTracker.fromContext({host:n,formatContext:t,preferences:s}),p=o==="SortAndCombine"||o==="All",m=p,S=o==="RemoveUnused"||o==="All",h=Xie(e,e.statements.filter(uu)),b=fOt(s,p?()=>KVe(h,s)===2:void 0),A=N=>(S&&(N=K6t(N,e,i)),m&&(N=YVe(N,b,e,s)),p&&(N=cu(N,(M,O)=>SEe(M,O,b))),N);h.forEach(N=>k(N,A)),o!=="RemoveUnused"&&pOt(e).forEach(N=>k(N,M=>gEe(M,b,s)));for(let N of e.statements.filter(S_)){if(!N.body)continue;if(Xie(e,N.body.statements.filter(uu)).forEach(O=>k(O,A)),o!=="RemoveUnused"){let O=N.body.statements.filter(yl);k(O,U=>gEe(U,b,s))}}return l.getChanges();function k(N,M){if(de(N)===0)return;Sn(N[0],1024);let O=m?m_(N,K=>Fq(K.moduleSpecifier)):[N],U=p?cu(O,(K,re)=>yEe(K[0].moduleSpecifier,re[0].moduleSpecifier,b)):O,H=_a(U,K=>Fq(K[0].moduleSpecifier)||K[0].moduleSpecifier===void 0?M(K):K);if(H.length===0)l.deleteNodes(e,N,{leadingTriviaOption:En.LeadingTriviaOption.Exclude,trailingTriviaOption:En.TrailingTriviaOption.Include},!0);else{let K={leadingTriviaOption:En.LeadingTriviaOption.Exclude,trailingTriviaOption:En.TrailingTriviaOption.Include,suffix:q1(n,t.options)};l.replaceNodeWithNodes(e,N[0],H,K);let re=l.nodeHasTrailingComment(e,N[0],K);l.deleteNodes(e,N.slice(1),{trailingTriviaOption:En.TrailingTriviaOption.Include},re)}}}function Xie(e,t){let n=E1(e.languageVersion,!1,e.languageVariant),i=[],s=0;for(let o of t)i[s]&&X6t(e,o,n)&&s++,i[s]||(i[s]=[]),i[s].push(o);return i}function X6t(e,t,n){let i=t.getFullStart(),s=t.getStart();n.setText(e.text,i,s-i);let o=0;for(;n.getTokenStart()<s;)if(n.scan()===4&&(o++,o>=2))return!0;return!1}function K6t(e,t,n){let i=n.getTypeChecker(),s=n.getCompilerOptions(),o=i.getJsxNamespace(t),l=i.getJsxFragmentFactory(t),p=!!(t.transformFlags&2),m=[];for(let h of e){let{importClause:b,moduleSpecifier:A}=h;if(!b){m.push(h);continue}let{name:k,namedBindings:N}=b;if(k&&!S(k)&&(k=void 0),N)if(tS(N))S(N.name)||(N=void 0);else{let M=N.elements.filter(O=>S(O.name));M.length<N.elements.length&&(N=M.length?j.updateNamedImports(N,M):void 0)}k||N?m.push(z7(h,k,N)):Q6t(t,A)&&(t.isDeclarationFile?m.push(j.createImportDeclaration(h.modifiers,void 0,A,void 0)):m.push(h))}return m;function S(h){return p&&(h.text===o||l&&h.text===l)&&Hte(s.jsx)||Ko.Core.isSymbolReferencedInFile(h,i,t)}}function Q6t(e,t){let n=za(t)&&t.text;return vs(n)&&Tt(e.moduleAugmentations,i=>za(i)&&i.text===n)}function Fq(e){return e!==void 0&&bo(e)?e.text:void 0}function Z6t(e,t,n,i){let s=Kie(t);return YVe(e,s,n,i)}function YVe(e,t,n,i){if(e.length===0)return e;let s=Jf(e,l=>{if(l.attributes){let p=l.attributes.token+" ";for(let m of Fa(l.attributes.elements,(S,h)=>h_(S.name.text,h.name.text)))p+=m.name.text+":",p+=bo(m.value)?`"${m.value.text}"`:m.value.getText()+" ";return p}return""}),o=[];for(let l in s){let p=s[l],{importWithoutClause:m,typeOnlyImports:S,regularImports:h}=eOt(p);m&&o.push(m);for(let b of[h,S]){let A=b===S,{defaultImports:k,namespaceImports:N,namedImports:M}=b;if(!A&&k.length===1&&N.length===1&&M.length===0){let se=k[0];o.push(z7(se,se.importClause.name,N[0].importClause.namedBindings));continue}let O=cu(N,(se,Se)=>t(se.importClause.namedBindings.name.text,Se.importClause.namedBindings.name.text));for(let se of O)o.push(z7(se,void 0,se.importClause.namedBindings));let U=qi(k),H=qi(M),K=U??H;if(!K)continue;let re,$=[];if(k.length===1)re=k[0].importClause.name;else for(let se of k)$.push(j.createImportSpecifier(!1,j.createIdentifier("default"),se.importClause.name));$.push(...cOt(M));let pe=j.createNodeArray(XVe($,t,i),H?.importClause.namedBindings.elements.hasTrailingComma),z=pe.length===0?re?void 0:j.createNamedImports(tt):H?j.updateNamedImports(H.importClause.namedBindings,pe):j.createNamedImports(pe);n&&z&&H?.importClause.namedBindings&&!rx(H.importClause.namedBindings,n)&&Sn(z,2),A&&re&&z?(o.push(z7(K,re,void 0)),o.push(z7(H??K,void 0,z))):o.push(z7(K,re,z))}}return o}function eOt(e){let t,n={defaultImports:[],namespaceImports:[],namedImports:[]},i={defaultImports:[],namespaceImports:[],namedImports:[]};for(let s of e){if(s.importClause===void 0){t=t||s;continue}let o=s.importClause.isTypeOnly?n:i,{name:l,namedBindings:p}=s.importClause;l&&o.defaultImports.push(s),p&&(tS(p)?o.namespaceImports.push(s):o.namedImports.push(s))}return{importWithoutClause:t,typeOnlyImports:n,regularImports:i}}function tOt(e,t,n){let i=Kie(t);return gEe(e,i,n)}function gEe(e,t,n){if(e.length===0)return e;let{exportWithoutClause:i,namedExports:s,typeOnlyExports:o}=p(e),l=[];i&&l.push(i);for(let m of[s,o]){if(m.length===0)continue;let S=[];S.push(..._a(m,A=>A.exportClause&&wd(A.exportClause)?A.exportClause.elements:tt));let h=XVe(S,t,n),b=m[0];l.push(j.updateExportDeclaration(b,b.modifiers,b.isTypeOnly,b.exportClause&&(wd(b.exportClause)?j.updateNamedExports(b.exportClause,h):j.updateNamespaceExport(b.exportClause,b.exportClause.name)),b.moduleSpecifier,b.attributes))}return l;function p(m){let S,h=[],b=[];for(let A of m)A.exportClause===void 0?S=S||A:A.isTypeOnly?b.push(A):h.push(A);return{exportWithoutClause:S,namedExports:h,typeOnlyExports:b}}}function z7(e,t,n){return j.updateImportDeclaration(e,e.modifiers,j.updateImportClause(e.importClause,e.importClause.isTypeOnly,t,n),e.moduleSpecifier,e.attributes)}function XVe(e,t,n){return cu(e,(i,s)=>hEe(i,s,t,n))}function hEe(e,t,n,i){switch(i?.organizeImportsTypeOrder){case"first":return hy(t.isTypeOnly,e.isTypeOnly)||n(e.name.text,t.name.text);case"inline":return n(e.name.text,t.name.text);default:return hy(e.isTypeOnly,t.isTypeOnly)||n(e.name.text,t.name.text)}}function rOt(e,t,n){let i=Kie(!!n);return yEe(e,t,i)}function yEe(e,t,n){let i=e===void 0?void 0:Fq(e),s=t===void 0?void 0:Fq(t);return hy(i===void 0,s===void 0)||hy(Nu(i),Nu(s))||n(i,s)}function vEe(e){var t;switch(e.kind){case 271:return(t=ii(e.moduleReference,zh))==null?void 0:t.expression;case 272:return e.moduleSpecifier;case 243:return e.declarationList.declarations[0].initializer.arguments[0]}}function nOt(e,t){return KVe(Xie(e,e.statements.filter(uu)),t)}function KVe(e,t){let n=JD(t,!1),i=JD(t,!0),s=3,o=!1;for(let l of e){if(l.length>1){let m=Mb(l,S=>{var h;return((h=ii(S.moduleSpecifier,za))==null?void 0:h.text)??""},n,i);if(m&&(s&=m,o=!0),!s)return s}let p=mr(l,m=>{var S,h;return((h=ii((S=m.importClause)==null?void 0:S.namedBindings,Dy))==null?void 0:h.elements.length)>1});if(p){let m=TEe(p.importClause.namedBindings.elements,t);if(m&&(s&=m,o=!0),!s)return s}if(s!==3)return s}return o?0:s}function iOt(e,t){let n=JD(t,!1),i=JD(t,!0);return Mb(e,s=>Fq(vEe(s))||"",n,i)}function sOt(e,t,n){let i=Bg(e,t,Mo,(s,o)=>SEe(s,o,n));return i<0?~i:i}function aOt(e,t,n,i){let s=Bg(e,t,Mo,(o,l)=>hEe(o,l,n,i));return s<0?~s:s}function SEe(e,t,n){return yEe(vEe(e),vEe(t),n)||oOt(e,t)}function oOt(e,t){return To(QVe(e),QVe(t))}function QVe(e){var t;switch(e.kind){case 272:return e.importClause?e.importClause.isTypeOnly?1:((t=e.importClause.namedBindings)==null?void 0:t.kind)===274?2:e.importClause.name?3:4:0;case 271:return 5;case 243:return 6}}function cOt(e){return _a(e,t=>vr(lOt(t),n=>n.name&&n.propertyName&&n.name.escapedText===n.propertyName.escapedText?j.updateImportSpecifier(n,n.isTypeOnly,void 0,n.name):n))}function lOt(e){var t;return(t=e.importClause)!=null&&t.namedBindings&&Dy(e.importClause.namedBindings)?e.importClause.namedBindings.elements:void 0}function Kie(e){return e?I2:h_}function uOt(e,t){let n=_Ot(t),i=t.organizeImportsCaseFirst??!1,s=t.organizeImportsNumericCollation??!1,o=t.organizeImportsAccentCollation??!0,l=e?o?"accent":"base":o?"variant":"case";return new Intl.Collator(n,{usage:"sort",caseFirst:i||"false",sensitivity:l,numeric:s}).compare}function _Ot(e){let t=e.organizeImportsLocale;t==="auto"&&(t=oA()),t===void 0&&(t="en");let n=Intl.Collator.supportedLocalesOf(t);return n.length?n[0]:"en"}function JD(e,t){return(e.organizeImportsCollation??"ordinal")==="unicode"?uOt(t,e):Kie(t)}function fOt(e,t){let n=typeof e.organizeImportsIgnoreCase=="boolean"?e.organizeImportsIgnoreCase:t?.()??!1;return JD(e,n)}function pOt(e){let t=[],n=e.statements,i=de(n),s=0,o=0;for(;s<i;)if(yl(n[s])){t[o]===void 0&&(t[o]=[]);let l=n[s];if(l.moduleSpecifier)t[o].push(l),s++;else{for(;s<i&&yl(n[s]);)t[o].push(n[s++]);o++}}else s++;return _a(t,l=>Xie(e,l))}var ZVe,TEe,dOt=f({"src/services/organizeImports.ts"(){"use strict";yi(),ZVe=class{has([e,t]){return this._lastPreferences!==t||!this._cache?!1:this._cache.has(e)}get([e,t]){if(!(this._lastPreferences!==t||!this._cache))return this._cache.get(e)}set([e,t],n){this._lastPreferences!==t&&(this._lastPreferences=t,this._cache=void 0),this._cache??(this._cache=new WeakMap),this._cache.set(e,n)}},TEe=aA((e,t)=>{switch(t.organizeImportsTypeOrder){case"first":if(!iA(e,(s,o)=>hy(o.isTypeOnly,s.isTypeOnly)))return 0;break;case"inline":if(!iA(e,(s,o)=>gy(!0)(s.name.text,o.name.text)))return 0;break;default:if(!iA(e,(s,o)=>hy(s.isTypeOnly,o.isTypeOnly)))return 0;break}let n=JD(t,!1),i=JD(t,!0);if(t.organizeImportsTypeOrder!=="inline"){let{type:s,regular:o}=Jf(e,m=>m.isTypeOnly?"type":"regular"),l=s?.length?Mb(s,m=>m.name.text,n,i):void 0,p=o?.length?Mb(o,m=>m.name.text??"",n,i):void 0;return l===void 0?p??0:p===void 0?l:l===0||p===0?0:p&l}return Mb(e,s=>s.name.text,n,i)},new ZVe)}}),$m={};x($m,{coalesceExports:()=>tOt,coalesceImports:()=>Z6t,compareImportOrExportSpecifiers:()=>hEe,compareImportsOrRequireStatements:()=>SEe,compareModuleSpecifiers:()=>rOt,detectImportDeclarationSorting:()=>iOt,detectImportSpecifierSorting:()=>TEe,detectSorting:()=>nOt,getImportDeclarationInsertionIndex:()=>sOt,getImportSpecifierInsertionIndex:()=>aOt,getOrganizeImportsComparer:()=>JD,organizeImports:()=>Y6t});var mOt=f({"src/services/_namespaces/ts.OrganizeImports.ts"(){"use strict";dOt()}});function gOt(e,t){let n=[];return hOt(e,t,n),yOt(e,n),n.sort((i,s)=>i.textSpan.start-s.textSpan.start)}function hOt(e,t,n){let i=40,s=0,o=[...e.statements,e.endOfFileToken],l=o.length;for(;s<l;){for(;s<l&&!q2(o[s]);)p(o[s]),s++;if(s===l)break;let m=s;for(;s<l&&q2(o[s]);)p(o[s]),s++;let S=s-1;S!==m&&n.push(jq(Oo(o[m],102,e).getStart(e),o[S].getEnd(),"imports"))}function p(m){var S;if(i===0)return;t.throwIfCancellationRequested(),(O_(m)||Xc(m)||Um(m)||Jg(m)||m.kind===1)&&tJe(m,e,t,n),ca(m)&&bn(m.parent)&&Hn(m.parent.left)&&tJe(m.parent.left,e,t,n),(ra(m)||Zg(m))&&bEe(m.statements.end,e,t,n),(Ti(m)||ef(m))&&bEe(m.members.end,e,t,n);let h=vOt(m,e);h&&n.push(h),i--,da(m)?(i++,p(m.expression),i--,m.arguments.forEach(p),(S=m.typeArguments)==null||S.forEach(p)):ux(m)&&m.elseStatement&&ux(m.elseStatement)?(p(m.expression),p(m.thenStatement),i++,p(m.elseStatement),i--):m.forEachChild(p),i++}}function yOt(e,t){let n=[],i=e.getLineStarts();for(let s of i){let o=e.getLineEndOfPosition(s),l=e.text.substring(s,o),p=eJe(l);if(!(!p||U1(e,s)))if(p[1]){let m=n.pop();m&&(m.textSpan.length=o-m.textSpan.start,m.hintSpan.length=o-m.textSpan.start,t.push(m))}else{let m=Ll(e.text.indexOf("//",s),o);n.push(Dk(m,"region",m,!1,p[2]||"#region"))}}}function eJe(e){return e=e.trimStart(),Ss(e,"//")?(e=e.slice(2).trim(),rJe.exec(e)):null}function bEe(e,t,n,i){let s=T0(t.text,e);if(!s)return;let o=-1,l=-1,p=0,m=t.getFullText();for(let{kind:h,pos:b,end:A}of s)switch(n.throwIfCancellationRequested(),h){case 2:let k=m.slice(b,A);if(eJe(k)){S(),p=0;break}p===0&&(o=b),l=A,p++;break;case 3:S(),i.push(jq(b,A,"comment")),p=0;break;default:I.assertNever(h)}S();function S(){p>1&&i.push(jq(o,l,"comment"))}}function tJe(e,t,n,i){qA(e)||bEe(e.pos,t,n,i)}function jq(e,t,n){return Dk(Ll(e,t),n)}function vOt(e,t){switch(e.kind){case 241:if(ca(e.parent))return SOt(e.parent,e,t);switch(e.parent.kind){case 246:case 249:case 250:case 248:case 245:case 247:case 254:case 299:return h(e.parent);case 258:let k=e.parent;if(k.tryBlock===e)return h(e.parent);if(k.finallyBlock===e){let N=Oo(k,98,t);if(N)return h(N)}default:return Dk(gf(e,t),"code")}case 268:return h(e.parent);case 263:case 231:case 264:case 266:case 269:case 187:case 206:return h(e);case 189:return h(e,!1,!XA(e.parent),23);case 296:case 297:return b(e.statements);case 210:return S(e);case 209:return S(e,23);case 284:return o(e);case 288:return l(e);case 285:case 286:return p(e.attributes);case 228:case 15:return m(e);case 207:return h(e,!1,!co(e.parent),23);case 219:return s(e);case 213:return i(e);case 217:return A(e);case 275:case 279:case 300:return n(e)}function n(k){if(!k.elements.length)return;let N=Oo(k,19,t),M=Oo(k,20,t);if(!(!N||!M||Pd(N.pos,M.pos,t)))return Qie(N,M,k,t,!1,!1)}function i(k){if(!k.arguments.length)return;let N=Oo(k,21,t),M=Oo(k,22,t);if(!(!N||!M||Pd(N.pos,M.pos,t)))return Qie(N,M,k,t,!1,!0)}function s(k){if(ra(k.body)||Df(k.body)||Pd(k.body.getFullStart(),k.body.getEnd(),t))return;let N=Ll(k.body.getFullStart(),k.body.getEnd());return Dk(N,"code",gf(k))}function o(k){let N=Ll(k.openingElement.getStart(t),k.closingElement.getEnd()),M=k.openingElement.tagName.getText(t),O="<"+M+">...</"+M+">";return Dk(N,"code",N,!1,O)}function l(k){let N=Ll(k.openingFragment.getStart(t),k.closingFragment.getEnd());return Dk(N,"code",N,!1,"<>...</>")}function p(k){if(k.properties.length!==0)return jq(k.getStart(t),k.getEnd(),"code")}function m(k){if(!(k.kind===15&&k.text.length===0))return jq(k.getStart(t),k.getEnd(),"code")}function S(k,N=19){return h(k,!1,!Z_(k.parent)&&!da(k.parent),N)}function h(k,N=!1,M=!0,O=19,U=O===19?20:24){let H=Oo(e,O,t),K=Oo(e,U,t);return H&&K&&Qie(H,K,k,t,N,M)}function b(k){return k.length?Dk(aS(k),"code"):void 0}function A(k){if(Pd(k.getStart(),k.getEnd(),t))return;let N=Ll(k.getStart(),k.getEnd());return Dk(N,"code",gf(k))}}function SOt(e,t,n){let i=TOt(e,t,n),s=Oo(t,20,n);return i&&s&&Qie(i,s,e,n,e.kind!==219)}function Qie(e,t,n,i,s=!1,o=!0){let l=Ll(o?e.getFullStart():e.getStart(i),t.getEnd());return Dk(l,"code",gf(n,i),s)}function Dk(e,t,n=e,i=!1,s="..."){return{textSpan:e,kind:t,hintSpan:n,bannerText:s,autoCollapse:i}}function TOt(e,t,n){if(ume(e.parameters,n)){let i=Oo(e,21,n);if(i)return i}return Oo(t,19,n)}var rJe,bOt=f({"src/services/outliningElementsCollector.ts"(){"use strict";yi(),rJe=/^#(end)?region(?:\s+(.*))?(?:\r)?$/}}),Zie={};x(Zie,{collectElements:()=>gOt});var EOt=f({"src/services/_namespaces/ts.OutliningElementsCollector.ts"(){"use strict";bOt()}});function xOt(e,t,n,i){let s=sJ(If(t,n));if(iJe(s)){let o=COt(s,e.getTypeChecker(),t,e,i);if(o)return o}return ese(g.You_cannot_rename_this_element)}function COt(e,t,n,i,s){let o=t.getSymbolAtLocation(e);if(!o){if(bo(e)){let A=iJ(e,t);if(A&&(A.flags&128||A.flags&1048576&&yr(A.types,k=>!!(k.flags&128))))return EEe(e.text,e.text,"string","",e,n)}else if(tte(e)){let A=Fl(e);return EEe(A,A,"label","",e,n)}return}let{declarations:l}=o;if(!l||l.length===0)return;if(l.some(A=>AOt(i,A)))return ese(g.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library);if(ze(e)&&e.escapedText==="default"&&o.parent&&o.parent.flags&1536)return;if(bo(e)&&F8(e))return s.allowRenameOfImportPath?POt(e,n,o):void 0;let p=kOt(n,o,t,s);if(p)return ese(p);let m=W1.getSymbolKind(t,o,e),S=F1e(e)||id(e)&&e.parent.kind===167?cm(om(e)):void 0,h=S||t.symbolToString(o),b=S||t.getFullyQualifiedName(o);return EEe(h,b,m,W1.getSymbolModifiers(t,o),e,n)}function AOt(e,t){let n=t.getSourceFile();return e.isSourceFileDefaultLibrary(n)&&Uc(n.fileName,".d.ts")}function kOt(e,t,n,i){if(!i.providePrefixAndSuffixTextForRename&&t.flags&2097152){let l=t.declarations&&mr(t.declarations,p=>Gf(p));l&&!l.propertyName&&(t=n.getAliasedSymbol(t))}let{declarations:s}=t;if(!s)return;let o=nJe(e.path);if(o===void 0)return Tt(s,l=>f7(l.getSourceFile().path))?g.You_cannot_rename_elements_that_are_defined_in_a_node_modules_folder:void 0;for(let l of s){let p=nJe(l.getSourceFile().path);if(p){let m=Math.min(o.length,p.length);for(let S=0;S<=m;S++)if(h_(o[S],p[S])!==0)return g.You_cannot_rename_elements_that_are_defined_in_another_node_modules_folder}}}function nJe(e){let t=gu(e),n=t.lastIndexOf("node_modules");if(n!==-1)return t.slice(0,n+2)}function POt(e,t,n){if(!Nu(e.text))return ese(g.You_cannot_rename_a_module_via_a_global_import);let i=n.declarations&&mr(n.declarations,ls);if(!i)return;let s=Mc(e.text,"/index")||Mc(e.text,"/index.js")?void 0:xG(ff(i.fileName),"/index"),o=s===void 0?i.fileName:s,l=s===void 0?"module":"directory",p=e.text.lastIndexOf("/")+1,m=e_(e.getStart(t)+1+p,e.text.length-p);return{canRename:!0,fileToRename:o,kind:l,displayName:o,fullDisplayName:e.text,kindModifiers:"",triggerSpan:m}}function EEe(e,t,n,i,s,o){return{canRename:!0,fileToRename:void 0,kind:n,displayName:e,fullDisplayName:t,kindModifiers:i,triggerSpan:NOt(s,o)}}function ese(e){return{canRename:!1,localizedErrorMessage:Gs(e)}}function NOt(e,t){let n=e.getStart(t),i=e.getWidth(t);return bo(e)&&(n+=1,i-=2),e_(n,i)}function iJe(e){switch(e.kind){case 80:case 81:case 11:case 15:case 110:return!0;case 9:return eJ(e);default:return!1}}var DOt=f({"src/services/rename.ts"(){"use strict";yi()}}),Bq={};x(Bq,{getRenameInfo:()=>xOt,nodeIsEligibleForRename:()=>iJe});var IOt=f({"src/services/_namespaces/ts.Rename.ts"(){"use strict";DOt()}});function wOt(e,t,n,i,s){let o=e.getTypeChecker(),l=aJ(t,n);if(!l)return;let p=!!i&&i.kind==="characterTyped";if(p&&(hk(t,n,l)||U1(t,n)))return;let m=!!i&&i.kind==="invoked",S=YOt(l,n,t,o,m);if(!S)return;s.throwIfCancellationRequested();let h=OOt(S,o,t,l,p);return s.throwIfCancellationRequested(),h?o.runWithCancellationToken(s,b=>h.kind===0?fJe(h.candidates,h.resolvedSignature,S,t,b):KOt(h.symbol,S,t,b)):Y_(t)?MOt(S,e,s):void 0}function OOt({invocation:e,argumentCount:t},n,i,s,o){switch(e.kind){case 0:{if(o&&!ROt(s,e.node,i))return;let l=[],p=n.getResolvedSignatureForSignatureHelp(e.node,l,t);return l.length===0?void 0:{kind:0,candidates:l,resolvedSignature:p}}case 1:{let{called:l}=e;if(o&&!sJe(s,i,ze(l)?l.parent:l))return;let p=_te(l,t,n);if(p.length!==0)return{kind:0,candidates:p,resolvedSignature:di(p)};let m=n.getSymbolAtLocation(l);return m&&{kind:1,symbol:m}}case 2:return{kind:0,candidates:[e.signature],resolvedSignature:e.signature};default:return I.assertNever(e)}}function ROt(e,t,n){if(!Jg(t))return!1;let i=t.getChildren(n);switch(e.kind){case 21:return hs(i,e);case 28:{let s=nJ(e);return!!s&&hs(i,s)}case 30:return sJe(e,n,t.expression);default:return!1}}function MOt(e,t,n){if(e.invocation.kind===2)return;let i=uJe(e.invocation),s=Hn(i)?i.name.text:void 0,o=t.getTypeChecker();return s===void 0?void 0:Ct(t.getSourceFiles(),l=>Ct(l.getNamedDeclarations().get(s),p=>{let m=p.symbol&&o.getTypeOfSymbolAtLocation(p.symbol,p),S=m&&m.getCallSignatures();if(S&&S.length)return o.runWithCancellationToken(n,h=>fJe(S,S[0],e,l,h,!0))}))}function sJe(e,t,n){let i=e.getFullStart(),s=e.parent;for(;s;){let o=tu(i,t,s,!0);if(o)return ud(n,o);s=s.parent}return I.fail("Could not find preceding token")}function LOt(e,t,n,i){let s=oJe(e,t,n,i);return!s||s.isTypeParameterList||s.invocation.kind!==0?void 0:{invocation:s.invocation.node,argumentCount:s.argumentCount,argumentIndex:s.argumentIndex}}function aJe(e,t,n,i){let s=FOt(e,n,i);if(!s)return;let{list:o,argumentIndex:l}=s,p=$Ot(i,o);l!==0&&I.assertLessThan(l,p);let m=GOt(o,n);return{list:o,argumentIndex:l,argumentCount:p,argumentsSpan:m}}function FOt(e,t,n){if(e.kind===30||e.kind===21)return{list:XOt(e.parent,e,t),argumentIndex:0};{let i=nJ(e);return i&&{list:i,argumentIndex:zOt(n,i,e)}}}function oJe(e,t,n,i){let{parent:s}=e;if(Jg(s)){let o=s,l=aJe(e,t,n,i);if(!l)return;let{list:p,argumentIndex:m,argumentCount:S,argumentsSpan:h}=l;return{isTypeParameterList:!!s.typeArguments&&s.typeArguments.pos===p.pos,invocation:{kind:0,node:o},argumentsSpan:h,argumentIndex:m,argumentCount:S}}else{if(zA(e)&&uE(s))return ZM(e,t,n)?CEe(s,0,n):void 0;if($A(e)&&s.parent.kind===215){let o=s,l=o.parent;I.assert(o.kind===228);let p=ZM(e,t,n)?0:1;return CEe(l,p,n)}else if(B6(s)&&uE(s.parent.parent)){let o=s,l=s.parent.parent;if(QB(e)&&!ZM(e,t,n))return;let p=o.parent.templateSpans.indexOf(o),m=WOt(p,e,t,n);return CEe(l,m,n)}else if(H_(s)){let o=s.attributes.pos,l=Wa(n.text,s.attributes.end,!1);return{isTypeParameterList:!1,invocation:{kind:0,node:s},argumentsSpan:e_(o,l-o),argumentIndex:0,argumentCount:1}}else{let o=fte(e,n);if(o){let{called:l,nTypeArguments:p}=o,m={kind:1,called:l},S=Ll(l.getStart(n),e.end);return{isTypeParameterList:!0,invocation:m,argumentsSpan:S,argumentIndex:p,argumentCount:p+1}}return}}}function jOt(e,t,n,i){return BOt(e,t,n,i)||oJe(e,t,n,i)}function cJe(e){return bn(e.parent)?cJe(e.parent):e}function xEe(e){return bn(e.left)?xEe(e.left)+1:2}function BOt(e,t,n,i){let s=UOt(e);if(s===void 0)return;let o=VOt(s,n,t,i);if(o===void 0)return;let{contextualType:l,argumentIndex:p,argumentCount:m,argumentsSpan:S}=o,h=l.getNonNullableType(),b=h.symbol;if(b===void 0)return;let A=Is(h.getCallSignatures());return A===void 0?void 0:{isTypeParameterList:!1,invocation:{kind:2,signature:A,node:e,symbol:JOt(b)},argumentsSpan:S,argumentIndex:p,argumentCount:m}}function UOt(e){switch(e.kind){case 21:case 28:return e;default:return Gr(e.parent,t=>Ls(t)?!0:co(t)||pm(t)||cE(t)?!1:"quit")}}function VOt(e,t,n,i){let{parent:s}=e;switch(s.kind){case 217:case 174:case 218:case 219:let o=aJe(e,n,t,i);if(!o)return;let{argumentIndex:l,argumentCount:p,argumentsSpan:m}=o,S=pl(s)?i.getContextualTypeForObjectLiteralElement(s):i.getContextualType(s);return S&&{contextualType:S,argumentIndex:l,argumentCount:p,argumentsSpan:m};case 226:{let h=cJe(s),b=i.getContextualType(h),A=e.kind===21?0:xEe(s)-1,k=xEe(h);return b&&{contextualType:b,argumentIndex:A,argumentCount:k,argumentsSpan:gf(s)}}default:return}}function JOt(e){return e.name==="__type"&&Ct(e.declarations,t=>{var n;return Vh(t)?(n=ii(t.parent,qg))==null?void 0:n.symbol:void 0})||e}function qOt(e,t){let n=t.getTypeAtLocation(e.expression);if(t.isTupleType(n)){let{elementFlags:i,fixedLength:s}=n.target;if(s===0)return 0;let o=oa(i,l=>!(l&1));return o<0?s:o}return 0}function zOt(e,t,n){return lJe(e,t,n)}function $Ot(e,t){return lJe(e,t,void 0)}function lJe(e,t,n){let i=t.getChildren(),s=0,o=!1;for(let l of i){if(n&&l===n)return!o&&l.kind===28&&s++,s;if(fg(l)){s+=qOt(l,e),o=!0;continue}if(l.kind!==28){s++,o=!0;continue}if(o){o=!1;continue}s++}return n?s:i.length&&Rs(i).kind===28?s+1:s}function WOt(e,t,n,i){return I.assert(n>=t.getStart(),"Assumed 'position' could not occur before node."),Tpe(t)?ZM(t,n,i)?0:e+2:e+1}function CEe(e,t,n){let i=zA(e.template)?1:e.template.templateSpans.length+1;return t!==0&&I.assertLessThan(t,i),{isTypeParameterList:!1,invocation:{kind:0,node:e},argumentsSpan:HOt(e,n),argumentIndex:t,argumentCount:i}}function GOt(e,t){let n=e.getFullStart(),i=Wa(t.text,e.getEnd(),!1);return e_(n,i-n)}function HOt(e,t){let n=e.template,i=n.getStart(),s=n.getEnd();return n.kind===228&&Rs(n.templateSpans).literal.getFullWidth()===0&&(s=Wa(t.text,s,!1)),e_(i,s-i)}function YOt(e,t,n,i,s){for(let o=e;!ls(o)&&(s||!ra(o));o=o.parent){I.assert(ud(o.parent,o),"Not a subspan",()=>`Child: ${I.formatSyntaxKind(o.kind)}, parent: ${I.formatSyntaxKind(o.parent.kind)}`);let l=jOt(o,t,n,i);if(l)return l}}function XOt(e,t,n){let i=e.getChildren(n),s=i.indexOf(t);return I.assert(s>=0&&i.length>s+1),i[s+1]}function uJe(e){return e.kind===0?aj(e.node):e.called}function _Je(e){return e.kind===0?e.node:e.kind===1?e.called:e.node}function fJe(e,t,{isTypeParameterList:n,argumentCount:i,argumentsSpan:s,invocation:o,argumentIndex:l},p,m,S){var h;let b=_Je(o),A=o.kind===2?o.symbol:m.getSymbolAtLocation(uJe(o))||S&&((h=t.declaration)==null?void 0:h.symbol),k=A?NO(m,A,S?p:void 0,void 0):tt,N=vr(e,K=>ZOt(K,k,n,m,b,p));l!==0&&I.assertLessThan(l,i);let M=0,O=0;for(let K=0;K<N.length;K++){let re=N[K];if(e[K]===t&&(M=O,re.length>1)){let $=0;for(let pe of re){if(pe.isVariadic||pe.parameters.length>=i){M=O+$;break}$++}}O+=re.length}I.assert(M!==-1);let U={items:bv(N,Mo),applicableSpan:s,selectedItemIndex:M,argumentIndex:l,argumentCount:i},H=U.items[M];if(H.isVariadic){let K=oa(H.parameters,re=>!!re.isRest);-1<K&&K<H.parameters.length-1?U.argumentIndex=H.parameters.length:U.argumentIndex=Math.min(U.argumentIndex,H.parameters.length-1)}return U}function KOt(e,{argumentCount:t,argumentsSpan:n,invocation:i,argumentIndex:s},o,l){let p=l.getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(e);return p?{items:[QOt(e,p,l,_Je(i),o)],applicableSpan:n,selectedItemIndex:0,argumentIndex:s,argumentCount:t}:void 0}function QOt(e,t,n,i,s){let o=NO(n,e),l=EE(),p=t.map(b=>pJe(b,n,i,s,l)),m=e.getDocumentationComment(n),S=e.getJsDocTags(n);return{isVariadic:!1,prefixDisplayParts:[...o,F_(30)],suffixDisplayParts:[F_(32)],separatorDisplayParts:AEe,parameters:p,documentation:m,tags:S}}function ZOt(e,t,n,i,s,o){let l=(n?t4t:r4t)(e,i,s,o);return vr(l,({isVariadic:p,parameters:m,prefix:S,suffix:h})=>{let b=[...t,...S],A=[...h,...e4t(e,s,i)],k=e.getDocumentationComment(i),N=e.getJsDocTags();return{isVariadic:p,prefixDisplayParts:b,suffixDisplayParts:A,separatorDisplayParts:AEe,parameters:m,documentation:k,tags:N}})}function e4t(e,t,n){return oS(i=>{i.writePunctuation(":"),i.writeSpace(" ");let s=n.getTypePredicateOfSignature(e);s?n.writeTypePredicate(s,t,void 0,i):n.writeType(n.getReturnTypeOfSignature(e),t,void 0,i)})}function t4t(e,t,n,i){let s=(e.target||e).typeParameters,o=EE(),l=(s||tt).map(m=>pJe(m,t,n,i,o)),p=e.thisParameter?[t.symbolToParameterDeclaration(e.thisParameter,n,$7)]:[];return t.getExpandedParameters(e).map(m=>{let S=j.createNodeArray([...p,...vr(m,b=>t.symbolToParameterDeclaration(b,n,$7))]),h=oS(b=>{o.writeList(2576,S,i,b)});return{isVariadic:!1,parameters:l,prefix:[F_(30)],suffix:[F_(32),...h]}})}function r4t(e,t,n,i){let s=EE(),o=oS(m=>{if(e.typeParameters&&e.typeParameters.length){let S=j.createNodeArray(e.typeParameters.map(h=>t.typeParameterToDeclaration(h,n,$7)));s.writeList(53776,S,i,m)}}),l=t.getExpandedParameters(e),p=t.hasEffectiveRestParameter(e)?l.length===1?m=>!0:m=>{var S;return!!(m.length&&((S=ii(m[m.length-1],Rh))==null?void 0:S.links.checkFlags)&32768)}:m=>!1;return l.map(m=>({isVariadic:p(m),parameters:m.map(S=>n4t(S,t,n,i,s)),prefix:[...o,F_(21)],suffix:[F_(22)]}))}function n4t(e,t,n,i,s){let o=oS(m=>{let S=t.symbolToParameterDeclaration(e,n,$7);s.writeNode(4,S,i,m)}),l=t.isOptionalParameter(e.valueDeclaration),p=Rh(e)&&!!(e.links.checkFlags&32768);return{name:e.name,documentation:e.getDocumentationComment(t),displayParts:o,isOptional:l,isRest:p}}function pJe(e,t,n,i,s){let o=oS(l=>{let p=t.typeParameterToDeclaration(e,n,$7);s.writeNode(4,p,i,l)});return{name:e.symbol.name,documentation:e.symbol.getDocumentationComment(t),displayParts:o,isOptional:!1,isRest:!1}}var $7,AEe,i4t=f({"src/services/signatureHelp.ts"(){"use strict";yi(),$7=70246400,AEe=[F_(28),Qc()]}}),W7={};x(W7,{getArgumentInfoForCompletions:()=>LOt,getSignatureHelpItems:()=>wOt});var s4t=f({"src/services/_namespaces/ts.SignatureHelp.ts"(){"use strict";i4t()}});function a4t(e,t){var n,i;let s={textSpan:Ll(t.getFullStart(),t.getEnd())},o=t;e:for(;;){let m=c4t(o);if(!m.length)break;for(let S=0;S<m.length;S++){let h=m[S-1],b=m[S],A=m[S+1];if(mT(b,t,!0)>e)break e;let k=nl(aT(t.text,b.end));if(k&&k.kind===2&&p(k.pos,k.end),o4t(t,e,b)){if(mY(b)&&tc(o)&&!Pd(b.getStart(t),b.getEnd(),t)&&l(b.getStart(t),b.getEnd()),ra(b)||B6(b)||$A(b)||QB(b)||h&&$A(h)||Tu(b)&&Xc(o)||XN(b)&&Tu(o)||Gi(b)&&XN(o)&&m.length===1||hE(b)||PT(b)||mx(b)){o=b;break}if(B6(o)&&A&&P9(A)){let U=b.getFullStart()-2,H=A.getStart()+1;l(U,H)}let N=XN(b)&&l4t(h)&&u4t(A)&&!Pd(h.getStart(),A.getStart(),t),M=N?h.getEnd():b.getStart(),O=N?A.getStart():_4t(t,b);if(jp(b)&&((n=b.jsDoc)!=null&&n.length)&&l(di(b.jsDoc).getStart(),O),XN(b)){let U=b.getChildren()[0];U&&jp(U)&&((i=U.jsDoc)!=null&&i.length)&&U.getStart()!==b.pos&&(M=Math.min(M,di(U.jsDoc).getStart()))}l(M,O),(za(b)||SA(b))&&l(M+1,O-1),o=b;break}if(S===m.length-1)break e}}return s;function l(m,S){if(m!==S){let h=Ll(m,S);(!s||!CD(h,s.textSpan)&&Zfe(h,e))&&(s={textSpan:h,...s&&{parent:s}})}}function p(m,S){l(m,S);let h=m;for(;t.text.charCodeAt(h)===47;)h++;l(h,S)}}function o4t(e,t,n){return I.assert(n.pos<=t),t<n.end?!0:n.getEnd()===t?If(e,t).pos<n.end:!1}function c4t(e){var t;if(ls(e))return G7(e.getChildAt(0).getChildren(),dJe);if(qN(e)){let[n,...i]=e.getChildren(),s=I.checkDefined(i.pop());I.assertEqual(n.kind,19),I.assertEqual(s.kind,20);let o=G7(i,p=>p===e.readonlyToken||p.kind===148||p===e.questionToken||p.kind===58),l=G7(o,({kind:p})=>p===23||p===168||p===24);return[n,H7(tse(l,({kind:p})=>p===59)),s]}if(fp(e)){let n=G7(e.getChildren(),l=>l===e.name||hs(e.modifiers,l)),i=((t=n[0])==null?void 0:t.kind)===327?n[0]:void 0,s=i?n.slice(1):n,o=tse(s,({kind:l})=>l===59);return i?[i,H7(o)]:o}if(Ls(e)){let n=G7(e.getChildren(),s=>s===e.dotDotDotToken||s===e.name),i=G7(n,s=>s===n[0]||s===e.questionToken);return tse(i,({kind:s})=>s===64)}return co(e)?tse(e.getChildren(),({kind:n})=>n===64):e.getChildren()}function G7(e,t){let n=[],i;for(let s of e)t(s)?(i=i||[],i.push(s)):(i&&(n.push(H7(i)),i=void 0),n.push(s));return i&&n.push(H7(i)),n}function tse(e,t,n=!0){if(e.length<2)return e;let i=oa(e,t);if(i===-1)return e;let s=e.slice(0,i),o=e[i],l=Rs(e),p=n&&l.kind===27,m=e.slice(i+1,p?e.length-1:void 0),S=y1([s.length?H7(s):void 0,o,m.length?H7(m):void 0]);return p?S.concat(l):S}function H7(e){return I.assertGreaterThanOrEqual(e.length,1),jh($h.createSyntaxList(e),e[0].pos,Rs(e).end)}function l4t(e){let t=e&&e.kind;return t===19||t===23||t===21||t===286}function u4t(e){let t=e&&e.kind;return t===20||t===24||t===22||t===287}function _4t(e,t){switch(t.kind){case 348:case 345:case 355:case 353:case 350:return e.getLineEndOfPosition(t.getStart());default:return t.getEnd()}}var dJe,f4t=f({"src/services/smartSelection.ts"(){"use strict";yi(),dJe=cg(uu,Ru)}}),rse={};x(rse,{getSmartSelectionRange:()=>a4t});var p4t=f({"src/services/_namespaces/ts.SmartSelectionRange.ts"(){"use strict";f4t()}});function mJe(e,t,n){let i=gJe(e,t,n);if(i!=="")return i;let s=NN(t);return s&32?xc(t,231)?"local class":"class":s&384?"enum":s&524288?"type":s&64?"interface":s&262144?"type parameter":s&8?"enum member":s&2097152?"alias":s&1536?"module":i}function gJe(e,t,n){let i=e.getRootSymbols(t);if(i.length===1&&di(i).flags&8192&&e.getTypeOfSymbolAtLocation(t,n).getNonNullableType().getCallSignatures().length!==0)return"method";if(e.isUndefinedSymbol(t))return"var";if(e.isArgumentsSymbol(t))return"local var";if(n.kind===110&&bt(n)||NA(n))return"parameter";let s=NN(t);if(s&3)return Dte(t)?"parameter":t.valueDeclaration&&aN(t.valueDeclaration)?"const":t.valueDeclaration&&S8(t.valueDeclaration)?"using":t.valueDeclaration&&v8(t.valueDeclaration)?"await using":Te(t.declarations,X9)?"let":vJe(t)?"local var":"var";if(s&16)return vJe(t)?"local function":"function";if(s&32768)return"getter";if(s&65536)return"setter";if(s&8192)return"method";if(s&16384)return"constructor";if(s&131072)return"index";if(s&4){if(s&33554432&&t.links.checkFlags&6){let o=Te(e.getRootSymbols(t),l=>{if(l.getFlags()&98311)return"property"});return o||(e.getTypeOfSymbolAtLocation(t,n).getCallSignatures().length?"method":"property")}return"property"}return""}function hJe(e){if(e.declarations&&e.declarations.length){let[t,...n]=e.declarations,i=de(n)&&OJ(t)&&Tt(n,o=>!OJ(o))?65536:0,s=xO(t,i);if(s)return s.split(",")}return[]}function d4t(e,t){if(!t)return"";let n=new Set(hJe(t));if(t.flags&2097152){let i=e.getAliasedSymbol(t);i!==t&&Te(hJe(i),s=>{n.add(s)})}return t.flags&16777216&&n.add("optional"),n.size>0?In(n.values()).join(","):""}function yJe(e,t,n,i,s,o,l,p){var m;let S=[],h=[],b=[],A=NN(t),k=l&1?gJe(e,t,s):"",N=!1,M=s.kind===110&&cj(s)||NA(s),O,U,H=!1;if(s.kind===110&&!M)return{displayParts:[gp(110)],documentation:[],symbolKind:"primitive type",tags:void 0};if(k!==""||A&32||A&2097152){if(k==="getter"||k==="setter"){let ye=mr(t.declarations,we=>we.name===s);if(ye)switch(ye.kind){case 177:k="getter";break;case 178:k="setter";break;case 172:k="accessor";break;default:I.assertNever(ye)}else k="property"}let Q;if(o??(o=M?e.getTypeAtLocation(s):e.getTypeOfSymbolAtLocation(t,s)),s.parent&&s.parent.kind===211){let ye=s.parent.name;(ye===s||ye&&ye.getFullWidth()===0)&&(s=s.parent)}let ce;if(Jg(s)?ce=s:(Kee(s)||bO(s)||s.parent&&(H_(s.parent)||uE(s.parent))&&ca(t.valueDeclaration))&&(ce=s.parent),ce){Q=e.getResolvedSignature(ce);let ye=ce.kind===214||da(ce)&&ce.expression.kind===108,we=ye?o.getConstructSignatures():o.getCallSignatures();if(Q&&!hs(we,Q.target)&&!hs(we,Q)&&(Q=we.length?we[0]:void 0),Q){switch(ye&&A&32?(k="constructor",se(o.symbol,k)):A&2097152?(k="alias",Se(k),S.push(Qc()),ye&&(Q.flags&4&&(S.push(gp(128)),S.push(Qc())),S.push(gp(105)),S.push(Qc())),z(t)):se(t,k),k){case"JSX attribute":case"property":case"var":case"const":case"let":case"parameter":case"local var":S.push(F_(59)),S.push(Qc()),!(Gn(o)&16)&&o.symbol&&(jt(S,NO(e,o.symbol,i,void 0,5)),S.push(AD())),ye&&(Q.flags&4&&(S.push(gp(128)),S.push(Qc())),S.push(gp(105)),S.push(Qc())),xe(Q,we,262144);break;default:xe(Q,we)}N=!0,H=we.length>1}}else if(ste(s)&&!(A&98304)||s.kind===137&&s.parent.kind===176){let ye=s.parent;if(t.declarations&&mr(t.declarations,ve=>ve===(s.kind===137?ye.parent:ye))){let ve=ye.kind===176?o.getNonNullableType().getConstructSignatures():o.getNonNullableType().getCallSignatures();e.isImplementationOfOverload(ye)?Q=ve[0]:Q=e.getSignatureFromDeclaration(ye),ye.kind===176?(k="constructor",se(o.symbol,k)):se(ye.kind===179&&!(o.symbol.flags&2048||o.symbol.flags&4096)?o.symbol:t,k),Q&&xe(Q,ve),N=!0,H=ve.length>1}}}if(A&32&&!N&&!M&&($(),xc(t,231)?Se("local class"):S.push(gp(86)),S.push(Qc()),z(t),Z(t,n)),A&64&&l&2&&(re(),S.push(gp(120)),S.push(Qc()),z(t),Z(t,n)),A&524288&&l&2&&(re(),S.push(gp(156)),S.push(Qc()),z(t),Z(t,n),S.push(Qc()),S.push(PO(64)),S.push(Qc()),jt(S,a7(e,s.parent&&Ty(s.parent)?e.getTypeAtLocation(s.parent):e.getDeclaredTypeOfSymbol(t),i,8388608))),A&384&&(re(),Tt(t.declarations,Q=>AT(Q)&&zb(Q))&&(S.push(gp(87)),S.push(Qc())),S.push(gp(94)),S.push(Qc()),z(t)),A&1536&&!M){re();let Q=xc(t,267),ce=Q&&Q.name&&Q.name.kind===80;S.push(gp(ce?145:144)),S.push(Qc()),z(t)}if(A&262144&&l&2)if(re(),S.push(F_(21)),S.push(fd("type parameter")),S.push(F_(22)),S.push(Qc()),z(t),t.parent)pe(),z(t.parent,i),Z(t.parent,i);else{let Q=xc(t,168);if(Q===void 0)return I.fail();let ce=Q.parent;if(ce)if(ca(ce)){pe();let ye=e.getSignatureFromDeclaration(ce);ce.kind===180?(S.push(gp(105)),S.push(Qc())):ce.kind!==179&&ce.name&&z(ce.symbol),jt(S,Ote(e,ye,n,32))}else Vm(ce)&&(pe(),S.push(gp(156)),S.push(Qc()),z(ce.symbol),Z(ce.symbol,n))}if(A&8){k="enum member",se(t,"enum member");let Q=(m=t.declarations)==null?void 0:m[0];if(Q?.kind===306){let ce=e.getConstantValue(Q);ce!==void 0&&(S.push(Qc()),S.push(PO(64)),S.push(Qc()),S.push(Yf(Qpe(ce),typeof ce=="number"?7:8)))}}if(t.flags&2097152){if(re(),!N||h.length===0&&b.length===0){let Q=e.getAliasedSymbol(t);if(Q!==t&&Q.declarations&&Q.declarations.length>0){let ce=Q.declarations[0],ye=qs(ce);if(ye&&!N){let we=W9(ce)&&ui(ce,128),ve=t.name!=="default"&&!we,oe=yJe(e,Q,Xr(ce),ce,ye,o,l,ve?t:Q);S.push(...oe.displayParts),S.push(AD()),O=oe.documentation,U=oe.tags}else O=Q.getContextualDocumentationComment(ce,e),U=Q.getJsDocTags(e)}}if(t.declarations)switch(t.declarations[0].kind){case 270:S.push(gp(95)),S.push(Qc()),S.push(gp(145));break;case 277:S.push(gp(95)),S.push(Qc()),S.push(gp(t.declarations[0].isExportEquals?64:90));break;case 281:S.push(gp(95));break;default:S.push(gp(102))}S.push(Qc()),z(t),Te(t.declarations,Q=>{if(Q.kind===271){let ce=Q;if(gT(ce))S.push(Qc()),S.push(PO(64)),S.push(Qc()),S.push(gp(149)),S.push(F_(21)),S.push(Yf(Fl($w(ce)),8)),S.push(F_(22));else{let ye=e.getSymbolAtLocation(ce.moduleReference);ye&&(S.push(Qc()),S.push(PO(64)),S.push(Qc()),z(ye,i))}return!0}})}if(!N)if(k!==""){if(o){if(M?(re(),S.push(gp(110))):se(t,k),k==="property"||k==="accessor"||k==="getter"||k==="setter"||k==="JSX attribute"||A&3||k==="local var"||k==="index"||k==="using"||k==="await using"||M){if(S.push(F_(59)),S.push(Qc()),o.symbol&&o.symbol.flags&262144&&k!=="index"){let Q=oS(ce=>{let ye=e.typeParameterToDeclaration(o,i,kEe);K().writeNode(4,ye,Xr(Us(i)),ce)});jt(S,Q)}else jt(S,a7(e,o,i));if(Rh(t)&&t.links.target&&Rh(t.links.target)&&t.links.target.links.tupleLabelDeclaration){let Q=t.links.target.links.tupleLabelDeclaration;I.assertNode(Q.name,ze),S.push(Qc()),S.push(F_(21)),S.push(fd(Nn(Q.name))),S.push(F_(22))}}else if(A&16||A&8192||A&16384||A&131072||A&98304||k==="method"){let Q=o.getNonNullableType().getCallSignatures();Q.length&&(xe(Q[0],Q),H=Q.length>1)}}}else k=mJe(e,t,s);if(h.length===0&&!H&&(h=t.getContextualDocumentationComment(i,e)),h.length===0&&A&4&&t.parent&&t.declarations&&Te(t.parent.declarations,Q=>Q.kind===312))for(let Q of t.declarations){if(!Q.parent||Q.parent.kind!==226)continue;let ce=e.getSymbolAtLocation(Q.parent.right);if(ce&&(h=ce.getDocumentationComment(e),b=ce.getJsDocTags(e),h.length>0))break}if(h.length===0&&ze(s)&&t.valueDeclaration&&co(t.valueDeclaration)){let Q=t.valueDeclaration,ce=Q.parent,ye=Q.propertyName||Q.name;if(ze(ye)&&pm(ce)){let we=om(ye),ve=e.getTypeAtLocation(ce);h=Ct(ve.isUnion()?ve.types:[ve],oe=>{let Ee=oe.getProperty(we);return Ee?Ee.getDocumentationComment(e):void 0})||tt}}return b.length===0&&!H&&(b=t.getContextualJsDocTags(i,e)),h.length===0&&O&&(h=O),b.length===0&&U&&(b=U),{displayParts:S,documentation:h,symbolKind:k,tags:b.length===0?void 0:b};function K(){return EE()}function re(){S.length&&S.push(AD()),$()}function $(){p&&(Se("alias"),S.push(Qc()))}function pe(){S.push(Qc()),S.push(gp(103)),S.push(Qc())}function z(Q,ce){let ye;p&&Q===t&&(Q=p),k==="index"&&(ye=e.getIndexInfosOfIndexSymbol(Q));let we=[];Q.flags&131072&&ye?(Q.parent&&(we=NO(e,Q.parent)),we.push(F_(23)),ye.forEach((ve,oe)=>{we.push(...a7(e,ve.keyType)),oe!==ye.length-1&&(we.push(Qc()),we.push(F_(52)),we.push(Qc()))}),we.push(F_(24))):we=NO(e,Q,ce||n,void 0,7),jt(S,we),t.flags&16777216&&S.push(F_(58))}function se(Q,ce){re(),ce&&(Se(ce),Q&&!Tt(Q.declarations,ye=>rc(ye)||(Xo(ye)||wu(ye))&&!ye.name)&&(S.push(Qc()),z(Q)))}function Se(Q){switch(Q){case"var":case"function":case"let":case"const":case"constructor":case"using":case"await using":S.push(Ite(Q));return;default:S.push(F_(21)),S.push(Ite(Q)),S.push(F_(22));return}}function xe(Q,ce,ye=0){jt(S,Ote(e,Q,i,ye|32)),ce.length>1&&(S.push(Qc()),S.push(F_(21)),S.push(PO(40)),S.push(Yf((ce.length-1).toString(),7)),S.push(Qc()),S.push(fd(ce.length===2?"overload":"overloads")),S.push(F_(22))),h=Q.getDocumentationComment(e),b=Q.getJsDocTags(),ce.length>1&&h.length===0&&b.length===0&&(h=ce[0].getDocumentationComment(e),b=ce[0].getJsDocTags().filter(we=>we.name!=="deprecated"))}function Z(Q,ce){let ye=oS(we=>{let ve=e.symbolToTypeParameterDeclarations(Q,ce,kEe);K().writeList(53776,ve,Xr(Us(ce)),we)});jt(S,ye)}}function m4t(e,t,n,i,s,o=Cx(s),l){return yJe(e,t,n,i,s,void 0,o,l)}function vJe(e){return e.parent?!1:Te(e.declarations,t=>{if(t.kind===218)return!0;if(t.kind!==260&&t.kind!==262)return!1;for(let n=t.parent;!Wb(n);n=n.parent)if(n.kind===312||n.kind===268)return!1;return!0})}var kEe,g4t=f({"src/services/symbolDisplay.ts"(){"use strict";yi(),kEe=70246400}}),W1={};x(W1,{getSymbolDisplayPartsDocumentationAndSymbolKind:()=>m4t,getSymbolKind:()=>mJe,getSymbolModifiers:()=>d4t});var h4t=f({"src/services/_namespaces/ts.SymbolDisplay.ts"(){"use strict";g4t()}});function SJe(e){let t=e.__pos;return I.assert(typeof t=="number"),t}function PEe(e,t){I.assert(typeof t=="number"),e.__pos=t}function TJe(e){let t=e.__end;return I.assert(typeof t=="number"),t}function NEe(e,t){I.assert(typeof t=="number"),e.__end=t}function bJe(e,t){return Wa(e,t,!1,!0)}function y4t(e,t){let n=t;for(;n<e.length;){let i=e.charCodeAt(n);if(Vg(i)){n++;continue}return i===47}return!1}function Y7(e,t,n,i){return{pos:wx(e,t,i),end:qD(e,n,i)}}function wx(e,t,n,i=!1){var s,o;let{leadingTriviaOption:l}=n;if(l===0)return t.getStart(e);if(l===3){let k=t.getStart(e),N=mm(k,e);return HM(t,N)?N:k}if(l===2){let k=BY(t,e.text);if(k?.length)return mm(k[0].pos,e)}let p=t.getFullStart(),m=t.getStart(e);if(p===m)return m;let S=mm(p,e);if(mm(m,e)===S)return l===1?p:m;if(i){let k=((s=T0(e.text,p))==null?void 0:s[0])||((o=aT(e.text,p))==null?void 0:o[0]);if(k)return Wa(e.text,k.end,!0,!0)}let b=p>0?1:0,A=Uv(r6(e,S)+b,e);return A=bJe(e.text,A),Uv(r6(e,A),e)}function DEe(e,t,n){let{end:i}=t,{trailingTriviaOption:s}=n;if(s===2){let o=aT(e.text,i);if(o){let l=r6(e,t.end);for(let p of o){if(p.kind===2||r6(e,p.pos)>l)break;if(r6(e,p.end)>l)return Wa(e.text,p.end,!0,!0)}}}}function qD(e,t,n){var i;let{end:s}=t,{trailingTriviaOption:o}=n;if(o===0)return s;if(o===1){let m=ys(aT(e.text,s),T0(e.text,s)),S=(i=m?.[m.length-1])==null?void 0:i.end;return S||s}let l=DEe(e,t,n);if(l)return l;let p=Wa(e.text,s,!0);return p!==s&&(o===2||I_(e.text.charCodeAt(p-1)))?p:s}function nse(e,t){return!!t&&!!e.parent&&(t.kind===28||t.kind===27&&e.parent.kind===210)}function v4t(e){return Xo(e)||Zl(e)}function S4t(e){if(e.kind!==219)return e;let t=e.parent.kind===172?e.parent:e.parent.parent;return t.jsDoc=e.jsDoc,t}function T4t(e,t){if(e.kind===t.kind)switch(e.kind){case 348:{let n=e,i=t;return ze(n.name)&&ze(i.name)&&n.name.escapedText===i.name.escapedText?j.createJSDocParameterTag(void 0,i.name,!1,i.typeExpression,i.isNameFirst,n.comment):void 0}case 349:return j.createJSDocReturnTag(void 0,t.typeExpression,e.comment);case 351:return j.createJSDocTypeTag(void 0,t.typeExpression,e.comment)}}function IEe(e,t){return Wa(e.text,wx(e,t,{leadingTriviaOption:1}),!1,!0)}function b4t(e,t,n,i){let s=IEe(e,i);if(n===void 0||Pd(qD(e,t,{}),s,e))return s;let o=tu(i.getStart(e),e);if(nse(t,o)){let l=tu(t.getStart(e),e);if(nse(n,l)){let p=Wa(e.text,o.getEnd(),!0,!0);if(Pd(l.getStart(e),o.getStart(e),e))return I_(e.text.charCodeAt(p-1))?p-1:p;if(I_(e.text.charCodeAt(p)))return p}}return s}function E4t(e,t){let n=Oo(e,19,t),i=Oo(e,20,t);return[n?.end,i?.end]}function ise(e){return Ha(e)?e.properties:e.members}function wEe(e,t){for(let n=t.length-1;n>=0;n--){let{span:i,newText:s}=t[n];e=`${e.substring(0,i.start)}${s}${e.substring(gl(i))}`}return e}function x4t(e){return Wa(e,0)===e.length}function sse(e){let t=wr(e,sse,AJe,C4t,sse),n=_c(t)?t:Object.create(t);return jh(n,SJe(e),TJe(e)),n}function C4t(e,t,n,i,s){let o=Hr(e,t,n,i,s);if(!o)return o;I.assert(e);let l=o===e?j.createNodeArray(o.slice(0)):o;return jh(l,SJe(e),TJe(e)),l}function EJe(e){let t=0,n=Q8(e),i=oe=>{oe&&PEe(oe,t)},s=oe=>{oe&&NEe(oe,t)},o=oe=>{oe&&PEe(oe,t)},l=oe=>{oe&&NEe(oe,t)},p=oe=>{oe&&PEe(oe,t)},m=oe=>{oe&&NEe(oe,t)};function S(oe,Ee){if(Ee||!x4t(oe)){t=n.getTextPos();let Me=0;for(;Sy(oe.charCodeAt(oe.length-Me-1));)Me++;t-=Me}}function h(oe){n.write(oe),S(oe,!1)}function b(oe){n.writeComment(oe)}function A(oe){n.writeKeyword(oe),S(oe,!1)}function k(oe){n.writeOperator(oe),S(oe,!1)}function N(oe){n.writePunctuation(oe),S(oe,!1)}function M(oe){n.writeTrailingSemicolon(oe),S(oe,!1)}function O(oe){n.writeParameter(oe),S(oe,!1)}function U(oe){n.writeProperty(oe),S(oe,!1)}function H(oe){n.writeSpace(oe),S(oe,!1)}function K(oe){n.writeStringLiteral(oe),S(oe,!1)}function re(oe,Ee){n.writeSymbol(oe,Ee),S(oe,!1)}function $(oe){n.writeLine(oe)}function pe(){n.increaseIndent()}function z(){n.decreaseIndent()}function se(){return n.getText()}function Se(oe){n.rawWrite(oe),S(oe,!1)}function xe(oe){n.writeLiteral(oe),S(oe,!0)}function Z(){return n.getTextPos()}function Q(){return n.getLine()}function ce(){return n.getColumn()}function ye(){return n.getIndent()}function we(){return n.isAtStartOfLine()}function ve(){n.clear(),t=0}return{onBeforeEmitNode:i,onAfterEmitNode:s,onBeforeEmitNodeArray:o,onAfterEmitNodeArray:l,onBeforeEmitToken:p,onAfterEmitToken:m,write:h,writeComment:b,writeKeyword:A,writeOperator:k,writePunctuation:N,writeTrailingSemicolon:M,writeParameter:O,writeProperty:U,writeSpace:H,writeStringLiteral:K,writeSymbol:re,writeLine:$,increaseIndent:pe,decreaseIndent:z,getText:se,rawWrite:Se,writeLiteral:xe,getTextPos:Z,getLine:Q,getColumn:ce,getIndent:ye,isAtStartOfLine:we,hasTrailingComment:()=>n.hasTrailingComment(),hasTrailingWhitespace:()=>n.hasTrailingWhitespace(),clear:ve}}function A4t(e){let t;for(let S of e.statements)if(Fm(S))t=S;else break;let n=0,i=e.text;if(t)return n=t.end,m(),n;let s=h9(i);s!==void 0&&(n=s.length,m());let o=T0(i,n);if(!o)return n;let l,p;for(let S of o){if(S.kind===3){if(z9(i,S.pos)){l={range:S,pinnedOrTripleSlash:!0};continue}}else if(xY(i,S.pos,S.end)){l={range:S,pinnedOrTripleSlash:!0};continue}if(l){if(l.pinnedOrTripleSlash)break;let h=e.getLineAndCharacterOfPosition(S.pos).line,b=e.getLineAndCharacterOfPosition(l.range.end).line;if(h>=b+2)break}if(e.statements.length){p===void 0&&(p=e.getLineAndCharacterOfPosition(e.statements[0].getStart()).line);let h=e.getLineAndCharacterOfPosition(S.end).line;if(p<h+2)break}l={range:S,pinnedOrTripleSlash:!1}}return l&&(n=l.range.end,m()),n;function m(){if(n<i.length){let S=i.charCodeAt(n);I_(S)&&(n++,n<i.length&&S===13&&i.charCodeAt(n)===10&&n++)}}}function xJe(e,t){return!U1(e,t)&&!hk(e,t)&&!ute(e,t)&&!y1e(e,t)}function k4t(e,t){return(fp(e)||ea(e))&&N9(t)&&t.name.kind===167||l8(e)&&l8(t)}function My(e,t,n,i={leadingTriviaOption:1}){let s=wx(t,n,i),o=qD(t,n,i);e.deleteRange(t,{pos:s,end:o})}function X7(e,t,n,i){let s=I.checkDefined(fu.SmartIndenter.getContainingList(i,n)),o=nN(s,i);if(I.assert(o!==-1),s.length===1){My(e,n,i);return}I.assert(!t.has(i),"Deleting a node twice"),t.add(i),e.deleteRange(n,{pos:IEe(n,i),end:o===s.length-1?qD(n,i,{}):b4t(n,i,s[o-1],s[o+1])})}var OEe,REe,zO,CJe,ase,AJe,MEe,P4t=f({"src/services/textChanges.ts"(){"use strict";yi(),OEe=(e=>(e[e.Exclude=0]="Exclude",e[e.IncludeAll=1]="IncludeAll",e[e.JSDoc=2]="JSDoc",e[e.StartLine=3]="StartLine",e))(OEe||{}),REe=(e=>(e[e.Exclude=0]="Exclude",e[e.ExcludeWhitespace=1]="ExcludeWhitespace",e[e.Include=2]="Include",e))(REe||{}),zO={leadingTriviaOption:0,trailingTriviaOption:0},CJe=class T6e{constructor(t,n){this.newLineCharacter=t,this.formatContext=n,this.changes=[],this.classesWithNodesInsertedAtStart=new Map,this.deletedNodes=[]}static fromContext(t){return new T6e(q1(t.host,t.formatContext.options),t.formatContext)}static with(t,n){let i=T6e.fromContext(t);return n(i),i.getChanges()}pushRaw(t,n){I.assertEqual(t.fileName,n.fileName);for(let i of n.textChanges)this.changes.push({kind:3,sourceFile:t,text:i.newText,range:_J(i.span)})}deleteRange(t,n){this.changes.push({kind:0,sourceFile:t,range:n})}delete(t,n){this.deletedNodes.push({sourceFile:t,node:n})}deleteNode(t,n,i={leadingTriviaOption:1}){this.deleteRange(t,Y7(t,n,n,i))}deleteNodes(t,n,i={leadingTriviaOption:1},s){for(let o of n){let l=wx(t,o,i,s),p=qD(t,o,i);this.deleteRange(t,{pos:l,end:p}),s=!!DEe(t,o,i)}}deleteModifier(t,n){this.deleteRange(t,{pos:n.getStart(t),end:Wa(t.text,n.end,!0)})}deleteNodeRange(t,n,i,s={leadingTriviaOption:1}){let o=wx(t,n,s),l=qD(t,i,s);this.deleteRange(t,{pos:o,end:l})}deleteNodeRangeExcludingEnd(t,n,i,s={leadingTriviaOption:1}){let o=wx(t,n,s),l=i===void 0?t.text.length:wx(t,i,s);this.deleteRange(t,{pos:o,end:l})}replaceRange(t,n,i,s={}){this.changes.push({kind:1,sourceFile:t,range:n,options:s,node:i})}replaceNode(t,n,i,s=zO){this.replaceRange(t,Y7(t,n,n,s),i,s)}replaceNodeRange(t,n,i,s,o=zO){this.replaceRange(t,Y7(t,n,i,o),s,o)}replaceRangeWithNodes(t,n,i,s={}){this.changes.push({kind:2,sourceFile:t,range:n,options:s,nodes:i})}replaceNodeWithNodes(t,n,i,s=zO){this.replaceRangeWithNodes(t,Y7(t,n,n,s),i,s)}replaceNodeWithText(t,n,i){this.replaceRangeWithText(t,Y7(t,n,n,zO),i)}replaceNodeRangeWithNodes(t,n,i,s,o=zO){this.replaceRangeWithNodes(t,Y7(t,n,i,o),s,o)}nodeHasTrailingComment(t,n,i=zO){return!!DEe(t,n,i)}nextCommaToken(t,n){let i=AE(n,n.parent,t);return i&&i.kind===28?i:void 0}replacePropertyAssignment(t,n,i){let s=this.nextCommaToken(t,n)?"":","+this.newLineCharacter;this.replaceNode(t,n,i,{suffix:s})}insertNodeAt(t,n,i,s={}){this.replaceRange(t,kd(n),i,s)}insertNodesAt(t,n,i,s={}){this.replaceRangeWithNodes(t,kd(n),i,s)}insertNodeAtTopOfFile(t,n,i){this.insertAtTopOfFile(t,n,i)}insertNodesAtTopOfFile(t,n,i){this.insertAtTopOfFile(t,n,i)}insertAtTopOfFile(t,n,i){let s=A4t(t),o={prefix:s===0?void 0:this.newLineCharacter,suffix:(I_(t.text.charCodeAt(s))?"":this.newLineCharacter)+(i?this.newLineCharacter:"")};os(n)?this.insertNodesAt(t,s,n,o):this.insertNodeAt(t,s,n,o)}insertNodesAtEndOfFile(t,n,i){this.insertAtEndOfFile(t,n,i)}insertAtEndOfFile(t,n,i){let s=t.end+1,o={prefix:this.newLineCharacter,suffix:this.newLineCharacter+(i?this.newLineCharacter:"")};this.insertNodesAt(t,s,n,o)}insertStatementsInNewFile(t,n,i){this.newFileChanges||(this.newFileChanges=g_()),this.newFileChanges.add(t,{oldFile:i,statements:n})}insertFirstParameter(t,n,i){let s=qi(n);s?this.insertNodeBefore(t,s,i):this.insertNodeAt(t,n.pos,i)}insertNodeBefore(t,n,i,s=!1,o={}){this.insertNodeAt(t,wx(t,n,o),i,this.getOptionsForInsertNodeBefore(n,i,s))}insertNodesBefore(t,n,i,s=!1,o={}){this.insertNodesAt(t,wx(t,n,o),i,this.getOptionsForInsertNodeBefore(n,di(i),s))}insertModifierAt(t,n,i,s={}){this.insertNodeAt(t,n,j.createToken(i),s)}insertModifierBefore(t,n,i){return this.insertModifierAt(t,i.getStart(t),n,{suffix:" "})}insertCommentBeforeLine(t,n,i,s){let o=Uv(n,t),l=B1e(t.text,o),p=xJe(t,l),m=bD(t,p?l:i),S=t.text.slice(o,l),h=`${p?"":this.newLineCharacter}//${s}${this.newLineCharacter}${S}`;this.insertText(t,m.getStart(t),h)}insertJsdocCommentBefore(t,n,i){let s=n.getStart(t);if(n.jsDoc)for(let p of n.jsDoc)this.deleteRange(t,{pos:mm(p.getStart(t),t),end:qD(t,p,{})});let o=TJ(t.text,s-1),l=t.text.slice(o,s);this.insertNodeAt(t,s,i,{suffix:this.newLineCharacter+l})}createJSDocText(t,n){let i=_a(n.jsDoc,o=>vs(o.comment)?j.createJSDocText(o.comment):o.comment),s=nl(n.jsDoc);return s&&Pd(s.pos,s.end,t)&&de(i)===0?void 0:j.createNodeArray(zn(i,j.createJSDocText(`
`)))}replaceJSDocComment(t,n,i){this.insertJsdocCommentBefore(t,S4t(n),j.createJSDocComment(this.createJSDocText(t,n),j.createNodeArray(i)))}addJSDocTags(t,n,i){let s=bv(n.jsDoc,l=>l.tags),o=i.filter(l=>!s.some((p,m)=>{let S=T4t(p,l);return S&&(s[m]=S),!!S}));this.replaceJSDocComment(t,n,[...s,...o])}filterJSDocTags(t,n,i){this.replaceJSDocComment(t,n,Fn(bv(n.jsDoc,s=>s.tags),i))}replaceRangeWithText(t,n,i){this.changes.push({kind:3,sourceFile:t,range:n,text:i})}insertText(t,n,i){this.replaceRangeWithText(t,kd(n),i)}tryInsertTypeAnnotation(t,n,i){let s;if(ca(n)){if(s=Oo(n,22,t),!s){if(!rc(n))return!1;s=di(n.parameters)}}else s=(n.kind===260?n.exclamationToken:n.questionToken)??n.name;return this.insertNodeAt(t,s.end,i,{prefix:": "}),!0}tryInsertThisTypeAnnotation(t,n,i){let s=Oo(n,21,t).getStart(t)+1,o=n.parameters.length?", ":"";this.insertNodeAt(t,s,i,{prefix:"this: ",suffix:o})}insertTypeParameters(t,n,i){let s=(Oo(n,21,t)||di(n.parameters)).getStart(t);this.insertNodesAt(t,s,i,{prefix:"<",suffix:">",joiner:", "})}getOptionsForInsertNodeBefore(t,n,i){return ns(t)||Du(t)?{suffix:i?this.newLineCharacter+this.newLineCharacter:this.newLineCharacter}:Gi(t)?{suffix:", "}:Ls(t)?Ls(n)?{suffix:", "}:{}:za(t)&&uu(t.parent)||Dy(t)?{suffix:", "}:Gf(t)?{suffix:","+(i?this.newLineCharacter:" ")}:I.failBadSyntaxKind(t)}insertNodeAtConstructorStart(t,n,i){let s=qi(n.body.statements);!s||!n.body.multiLine?this.replaceConstructorBody(t,n,[i,...n.body.statements]):this.insertNodeBefore(t,s,i)}insertNodeAtConstructorStartAfterSuperCall(t,n,i){let s=mr(n.body.statements,o=>Ou(o)&&$2(o.expression));!s||!n.body.multiLine?this.replaceConstructorBody(t,n,[...n.body.statements,i]):this.insertNodeAfter(t,s,i)}insertNodeAtConstructorEnd(t,n,i){let s=Is(n.body.statements);!s||!n.body.multiLine?this.replaceConstructorBody(t,n,[...n.body.statements,i]):this.insertNodeAfter(t,s,i)}replaceConstructorBody(t,n,i){this.replaceNode(t,n.body,j.createBlock(i,!0))}insertNodeAtEndOfScope(t,n,i){let s=wx(t,n.getLastToken(),{});this.insertNodeAt(t,s,i,{prefix:I_(t.text.charCodeAt(n.getLastToken().pos))?this.newLineCharacter:this.newLineCharacter+this.newLineCharacter,suffix:this.newLineCharacter})}insertMemberAtStart(t,n,i){this.insertNodeAtStartWorker(t,n,i)}insertNodeAtObjectStart(t,n,i){this.insertNodeAtStartWorker(t,n,i)}insertNodeAtStartWorker(t,n,i){let s=this.guessIndentationFromExistingMembers(t,n)??this.computeIndentationForNewMember(t,n);this.insertNodeAt(t,ise(n).pos,i,this.getInsertNodeAtStartInsertOptions(t,n,s))}guessIndentationFromExistingMembers(t,n){let i,s=n;for(let o of ise(n)){if(jj(s,o,t))return;let l=o.getStart(t),p=fu.SmartIndenter.findFirstNonWhitespaceColumn(mm(l,t),l,t,this.formatContext.options);if(i===void 0)i=p;else if(p!==i)return;s=o}return i}computeIndentationForNewMember(t,n){let i=n.getStart(t);return fu.SmartIndenter.findFirstNonWhitespaceColumn(mm(i,t),i,t,this.formatContext.options)+(this.formatContext.options.indentSize??4)}getInsertNodeAtStartInsertOptions(t,n,i){let o=ise(n).length===0,l=Bm(this.classesWithNodesInsertedAtStart,yo(n),{node:n,sourceFile:t}),p=Ha(n)&&(!sm(t)||!o),m=Ha(n)&&sm(t)&&o&&!l;return{indentation:i,prefix:(m?",":"")+this.newLineCharacter,suffix:p?",":ef(n)&&o?";":""}}insertNodeAfterComma(t,n,i){let s=this.insertNodeAfterWorker(t,this.nextCommaToken(t,n)||n,i);this.insertNodeAt(t,s,i,this.getInsertNodeAfterOptions(t,n))}insertNodeAfter(t,n,i){let s=this.insertNodeAfterWorker(t,n,i);this.insertNodeAt(t,s,i,this.getInsertNodeAfterOptions(t,n))}insertNodeAtEndOfList(t,n,i){this.insertNodeAt(t,n.end,i,{prefix:", "})}insertNodesAfter(t,n,i){let s=this.insertNodeAfterWorker(t,n,di(i));this.insertNodesAt(t,s,i,this.getInsertNodeAfterOptions(t,n))}insertNodeAfterWorker(t,n,i){return k4t(n,i)&&t.text.charCodeAt(n.end-1)!==59&&this.replaceRange(t,kd(n.end),j.createToken(27)),qD(t,n,{})}getInsertNodeAfterOptions(t,n){let i=this.getInsertNodeAfterOptionsWorker(n);return{...i,prefix:n.end===t.end&&ns(n)?i.prefix?`
${i.prefix}`:`
`:i.prefix}}getInsertNodeAfterOptionsWorker(t){switch(t.kind){case 263:case 267:return{prefix:this.newLineCharacter,suffix:this.newLineCharacter};case 260:case 11:case 80:return{prefix:", "};case 303:return{suffix:","+this.newLineCharacter};case 95:return{prefix:" "};case 169:return{};default:return I.assert(ns(t)||N9(t)),{suffix:this.newLineCharacter}}}insertName(t,n,i){if(I.assert(!n.name),n.kind===219){let s=Oo(n,39,t),o=Oo(n,21,t);o?(this.insertNodesAt(t,o.getStart(t),[j.createToken(100),j.createIdentifier(i)],{joiner:" "}),My(this,t,s)):(this.insertText(t,di(n.parameters).getStart(t),`function ${i}(`),this.replaceRange(t,s,j.createToken(22))),n.body.kind!==241&&(this.insertNodesAt(t,n.body.getStart(t),[j.createToken(19),j.createToken(107)],{joiner:" ",suffix:" "}),this.insertNodesAt(t,n.body.end,[j.createToken(27),j.createToken(20)],{joiner:" "}))}else{let s=Oo(n,n.kind===218?100:86,t).end;this.insertNodeAt(t,s,j.createIdentifier(i),{prefix:" "})}}insertExportModifier(t,n){this.insertText(t,n.getStart(t),"export ")}insertImportSpecifierAtIndex(t,n,i,s){let o=i.elements[s-1];o?this.insertNodeInListAfter(t,o,n):this.insertNodeBefore(t,i.elements[0],n,!Pd(i.elements[0].getStart(),i.parent.parent.getStart(),t))}insertNodeInListAfter(t,n,i,s=fu.SmartIndenter.getContainingList(n,t)){if(!s){I.fail("node is not a list element");return}let o=nN(s,n);if(o<0)return;let l=n.getEnd();if(o!==s.length-1){let p=Ts(t,n.end);if(p&&nse(n,p)){let m=s[o+1],S=bJe(t.text,m.getFullStart()),h=`${Sa(p.kind)}${t.text.substring(p.end,S)}`;this.insertNodesAt(t,S,[i],{suffix:h})}}else{let p=n.getStart(t),m=mm(p,t),S,h=!1;if(s.length===1)S=28;else{let b=tu(n.pos,t);S=nse(n,b)?b.kind:28,h=mm(s[o-1].getStart(t),t)!==m}if((y4t(t.text,n.end)||!Pd(s.pos,s.end,t))&&(h=!0),h){this.replaceRange(t,kd(l),j.createToken(S));let b=fu.SmartIndenter.findFirstNonWhitespaceColumn(m,p,t,this.formatContext.options),A=Wa(t.text,l,!0,!1);for(;A!==l&&I_(t.text.charCodeAt(A-1));)A--;this.replaceRange(t,kd(A),i,{indentation:b,prefix:this.newLineCharacter})}else this.replaceRange(t,kd(l),i,{prefix:`${Sa(S)} `})}}parenthesizeExpression(t,n){this.replaceRange(t,$X(n),j.createParenthesizedExpression(n))}finishClassesWithNodesInsertedAtStart(){this.classesWithNodesInsertedAtStart.forEach(({node:t,sourceFile:n})=>{let[i,s]=E4t(t,n);if(i!==void 0&&s!==void 0){let o=ise(t).length===0,l=Pd(i,s,n);o&&l&&i!==s-1&&this.deleteRange(n,kd(i,s-1)),l&&this.insertText(n,s-1,this.newLineCharacter)}})}finishDeleteDeclarations(){let t=new Set;for(let{sourceFile:n,node:i}of this.deletedNodes)this.deletedNodes.some(s=>s.sourceFile===n&&f1e(s.node,i))||(os(i)?this.deleteRange(n,WX(n,i)):MEe.deleteDeclaration(this,t,n,i));t.forEach(n=>{let i=n.getSourceFile(),s=fu.SmartIndenter.getContainingList(n,i);if(n!==Rs(s))return;let o=no(s,l=>!t.has(l),s.length-2);o!==-1&&this.deleteRange(i,{pos:s[o].end,end:IEe(i,s[o+1])})})}getChanges(t){this.finishDeleteDeclarations(),this.finishClassesWithNodesInsertedAtStart();let n=ase.getTextChangesFromChanges(this.changes,this.newLineCharacter,this.formatContext,t);return this.newFileChanges&&this.newFileChanges.forEach((i,s)=>{n.push(ase.newFileChanges(s,i,this.newLineCharacter,this.formatContext))}),n}createNewFile(t,n,i){this.insertStatementsInNewFile(n,i,t)}},(e=>{function t(p,m,S,h){return Wi(m_(p,b=>b.sourceFile.path),b=>{let A=b[0].sourceFile,k=cu(b,(M,O)=>M.range.pos-O.range.pos||M.range.end-O.range.end);for(let M=0;M<k.length-1;M++)I.assert(k[M].range.end<=k[M+1].range.pos,"Changes overlap",()=>`${JSON.stringify(k[M].range)} and ${JSON.stringify(k[M+1].range)}`);let N=Wi(k,M=>{let O=aS(M.range),U=M.kind===1?Xr(Hc(M.node))??M.sourceFile:M.kind===2?Xr(Hc(M.nodes[0]))??M.sourceFile:M.sourceFile,H=s(M,U,A,m,S,h);if(!(O.length===H.length&&K1e(U.text,H,O.start)))return e7(O,H)});return N.length>0?{fileName:A.fileName,textChanges:N}:void 0})}e.getTextChangesFromChanges=t;function n(p,m,S,h){let b=i(eB(p),m,S,h);return{fileName:p,textChanges:[e7(e_(0,0),b)],isNewFile:!0}}e.newFileChanges=n;function i(p,m,S,h){let b=_a(m,N=>N.statements.map(M=>M===4?"":l(M,N.oldFile,S).text)).join(S),A=KR("any file name",b,{languageVersion:99,jsDocParsingMode:1},!0,p),k=fu.formatDocument(A,h);return wEe(b,k)+S}e.newFileChangesWorker=i;function s(p,m,S,h,b,A){var k;if(p.kind===0)return"";if(p.kind===3)return p.text;let{options:N={},range:{pos:M}}=p,O=K=>o(K,m,S,M,N,h,b,A),U=p.kind===2?p.nodes.map(K=>cA(O(K),h)).join(((k=p.options)==null?void 0:k.joiner)||h):O(p.node),H=N.indentation!==void 0||mm(M,m)===M?U:U.replace(/^\s+/,"");return(N.prefix||"")+H+(!N.suffix||Mc(H,N.suffix)?"":N.suffix)}function o(p,m,S,h,{indentation:b,prefix:A,delta:k},N,M,O){let{node:U,text:H}=l(p,m,N);O&&O(U,H);let K=MJ(M,m),re=b!==void 0?b:fu.SmartIndenter.getIndentation(h,S,K,A===N||mm(h,m)===h);k===void 0&&(k=fu.SmartIndenter.shouldIndentChildNode(K,p)&&K.indentSize||0);let $={text:H,getLineAndCharacterOfPosition(z){return Lo(this,z)}},pe=fu.formatNodeGivenIndentation(U,$,m.languageVariant,re,k,{...M,options:K});return wEe(H,pe)}function l(p,m,S){let h=EJe(S),b=p7(S);return RT({newLine:b,neverAsciiEscape:!0,preserveSourceNewlines:!0,terminateUnterminatedLiterals:!0},h).writeNode(4,p,m,h),{text:h.getText(),node:sse(p)}}e.getNonformattedText=l})(ase||(ase={})),AJe={...fO,factory:TR(fO.factory.flags|1,fO.factory.baseFactory)},(e=>{function t(o,l,p,m){switch(m.kind){case 169:{let k=m.parent;rc(k)&&k.parameters.length===1&&!Oo(k,21,p)?o.replaceNodeWithText(p,m,"()"):X7(o,l,p,m);break}case 272:case 271:let S=p.imports.length&&m===di(p.imports).parent||m===mr(p.statements,q2);My(o,p,m,{leadingTriviaOption:S?0:jp(m)?2:3});break;case 208:let h=m.parent;h.kind===207&&m!==Rs(h.elements)?My(o,p,m):X7(o,l,p,m);break;case 260:s(o,l,p,m);break;case 168:X7(o,l,p,m);break;case 276:let A=m.parent;A.elements.length===1?i(o,p,A):X7(o,l,p,m);break;case 274:i(o,p,m);break;case 27:My(o,p,m,{trailingTriviaOption:0});break;case 100:My(o,p,m,{leadingTriviaOption:0});break;case 263:case 262:My(o,p,m,{leadingTriviaOption:jp(m)?2:3});break;default:m.parent?Jh(m.parent)&&m.parent.name===m?n(o,p,m.parent):da(m.parent)&&hs(m.parent.arguments,m)?X7(o,l,p,m):My(o,p,m):My(o,p,m)}}e.deleteDeclaration=t;function n(o,l,p){if(!p.namedBindings)My(o,l,p.parent);else{let m=p.name.getStart(l),S=Ts(l,p.name.end);if(S&&S.kind===28){let h=Wa(l.text,S.end,!1,!0);o.deleteRange(l,{pos:m,end:h})}else My(o,l,p.name)}}function i(o,l,p){if(p.parent.name){let m=I.checkDefined(Ts(l,p.pos-1));o.deleteRange(l,{pos:m.getStart(l),end:p.end})}else{let m=ST(p,272);My(o,l,m)}}function s(o,l,p,m){let{parent:S}=m;if(S.kind===299){o.deleteNodeRange(p,Oo(S,21,p),Oo(S,22,p));return}if(S.declarations.length!==1){X7(o,l,p,m);return}let h=S.parent;switch(h.kind){case 250:case 249:o.replaceNode(p,m,j.createObjectLiteralExpression());break;case 248:My(o,p,S);break;case 243:My(o,p,h,{leadingTriviaOption:jp(h)?2:3});break;default:I.assertNever(h)}}})(MEe||(MEe={}))}}),En={};x(En,{ChangeTracker:()=>CJe,LeadingTriviaOption:()=>OEe,TrailingTriviaOption:()=>REe,applyChanges:()=>wEe,assignPositionsToNode:()=>sse,createWriter:()=>EJe,deleteNode:()=>My,isThisTypeAnnotatable:()=>v4t,isValidLocationToAddComment:()=>xJe});var N4t=f({"src/services/_namespaces/ts.textChanges.ts"(){"use strict";P4t()}}),LEe,FEe,D4t=f({"src/services/formatting/formattingContext.ts"(){"use strict";yi(),LEe=(e=>(e[e.FormatDocument=0]="FormatDocument",e[e.FormatSelection=1]="FormatSelection",e[e.FormatOnEnter=2]="FormatOnEnter",e[e.FormatOnSemicolon=3]="FormatOnSemicolon",e[e.FormatOnOpeningCurlyBrace=4]="FormatOnOpeningCurlyBrace",e[e.FormatOnClosingCurlyBrace=5]="FormatOnClosingCurlyBrace",e))(LEe||{}),FEe=class{constructor(e,t,n){this.sourceFile=e,this.formattingRequestKind=t,this.options=n}updateContext(e,t,n,i,s){this.currentTokenSpan=I.checkDefined(e),this.currentTokenParent=I.checkDefined(t),this.nextTokenSpan=I.checkDefined(n),this.nextTokenParent=I.checkDefined(i),this.contextNode=I.checkDefined(s),this.contextNodeAllOnSameLine=void 0,this.nextNodeAllOnSameLine=void 0,this.tokensAreOnSameLine=void 0,this.contextNodeBlockIsOnOneLine=void 0,this.nextNodeBlockIsOnOneLine=void 0}ContextNodeAllOnSameLine(){return this.contextNodeAllOnSameLine===void 0&&(this.contextNodeAllOnSameLine=this.NodeIsOnOneLine(this.contextNode)),this.contextNodeAllOnSameLine}NextNodeAllOnSameLine(){return this.nextNodeAllOnSameLine===void 0&&(this.nextNodeAllOnSameLine=this.NodeIsOnOneLine(this.nextTokenParent)),this.nextNodeAllOnSameLine}TokensAreOnSameLine(){if(this.tokensAreOnSameLine===void 0){let e=this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line,t=this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;this.tokensAreOnSameLine=e===t}return this.tokensAreOnSameLine}ContextNodeBlockIsOnOneLine(){return this.contextNodeBlockIsOnOneLine===void 0&&(this.contextNodeBlockIsOnOneLine=this.BlockIsOnOneLine(this.contextNode)),this.contextNodeBlockIsOnOneLine}NextNodeBlockIsOnOneLine(){return this.nextNodeBlockIsOnOneLine===void 0&&(this.nextNodeBlockIsOnOneLine=this.BlockIsOnOneLine(this.nextTokenParent)),this.nextNodeBlockIsOnOneLine}NodeIsOnOneLine(e){let t=this.sourceFile.getLineAndCharacterOfPosition(e.getStart(this.sourceFile)).line,n=this.sourceFile.getLineAndCharacterOfPosition(e.getEnd()).line;return t===n}BlockIsOnOneLine(e){let t=Oo(e,19,this.sourceFile),n=Oo(e,20,this.sourceFile);if(t&&n){let i=this.sourceFile.getLineAndCharacterOfPosition(t.getEnd()).line,s=this.sourceFile.getLineAndCharacterOfPosition(n.getStart(this.sourceFile)).line;return i===s}return!1}}}});function jEe(e,t,n,i,s){let o=t===1?PJe:kJe;o.setText(e),o.resetTokenState(n);let l=!0,p,m,S,h,b,A=s({advance:k,readTokenInfo:$,readEOFTokenRange:z,isOnToken:se,isOnEOF:Se,getCurrentLeadingTrivia:()=>p,lastTrailingTriviaWasNewLine:()=>l,skipToEndOf:Z,skipToStartOf:Q,getTokenFullStart:()=>b?.token.pos??o.getTokenStart(),getStartPos:()=>b?.token.pos??o.getTokenStart()});return b=void 0,o.setText(void 0),A;function k(){b=void 0,o.getTokenFullStart()!==n?l=!!m&&Rs(m).kind===4:o.scan(),p=void 0,m=void 0;let ye=o.getTokenFullStart();for(;ye<i;){let we=o.getToken();if(!TN(we))break;o.scan();let ve={pos:ye,end:o.getTokenFullStart(),kind:we};ye=o.getTokenFullStart(),p=Pr(p,ve)}S=o.getTokenFullStart()}function N(ce){switch(ce.kind){case 34:case 72:case 73:case 50:case 49:return!0}return!1}function M(ce){if(ce.parent)switch(ce.parent.kind){case 291:case 286:case 287:case 285:return Nf(ce.kind)||ce.kind===80}return!1}function O(ce){return qA(ce)||L0(ce)&&b?.token.kind===12}function U(ce){return ce.kind===14}function H(ce){return ce.kind===17||ce.kind===18}function K(ce){return ce.parent&&th(ce.parent)&&ce.parent.initializer===ce}function re(ce){return ce===44||ce===69}function $(ce){I.assert(se());let ye=N(ce)?1:U(ce)?2:H(ce)?3:M(ce)?4:O(ce)?5:K(ce)?6:0;if(b&&ye===h)return xe(b,ce);o.getTokenFullStart()!==S&&(I.assert(b!==void 0),o.resetTokenState(S),o.scan());let we=pe(ce,ye),ve=use(o.getTokenFullStart(),o.getTokenEnd(),we);for(m&&(m=void 0);o.getTokenFullStart()<i&&(we=o.scan(),!!TN(we));){let oe=use(o.getTokenFullStart(),o.getTokenEnd(),we);if(m||(m=[]),m.push(oe),we===4){o.scan();break}}return b={leadingTrivia:p,trailingTrivia:m,token:ve},xe(b,ce)}function pe(ce,ye){let we=o.getToken();switch(h=0,ye){case 1:if(we===32){h=1;let ve=o.reScanGreaterToken();return I.assert(ce.kind===ve),ve}break;case 2:if(re(we)){h=2;let ve=o.reScanSlashToken();return I.assert(ce.kind===ve),ve}break;case 3:if(we===20)return h=3,o.reScanTemplateToken(!1);break;case 4:return h=4,o.scanJsxIdentifier();case 5:return h=5,o.reScanJsxToken(!1);case 6:return h=6,o.reScanJsxAttributeValue();case 0:break;default:I.assertNever(ye)}return we}function z(){return I.assert(Se()),use(o.getTokenFullStart(),o.getTokenEnd(),1)}function se(){let ce=b?b.token.kind:o.getToken();return ce!==1&&!TN(ce)}function Se(){return(b?b.token.kind:o.getToken())===1}function xe(ce,ye){return gA(ye)&&ce.token.kind!==ye.kind&&(ce.token.kind=ye.kind),ce}function Z(ce){o.resetTokenState(ce.end),S=o.getTokenFullStart(),h=void 0,b=void 0,l=!1,p=void 0,m=void 0}function Q(ce){o.resetTokenState(ce.pos),S=o.getTokenFullStart(),h=void 0,b=void 0,l=!1,p=void 0,m=void 0}}var kJe,PJe,I4t=f({"src/services/formatting/formattingScanner.ts"(){"use strict";yi(),Z7(),kJe=E1(99,!1,0),PJe=E1(99,!1,1)}}),Uq,BEe,UEe,w4t=f({"src/services/formatting/rule.ts"(){"use strict";yi(),Uq=tt,BEe=(e=>(e[e.None=0]="None",e[e.StopProcessingSpaceActions=1]="StopProcessingSpaceActions",e[e.StopProcessingTokenActions=2]="StopProcessingTokenActions",e[e.InsertSpace=4]="InsertSpace",e[e.InsertNewLine=8]="InsertNewLine",e[e.DeleteSpace=16]="DeleteSpace",e[e.DeleteToken=32]="DeleteToken",e[e.InsertTrailingSemicolon=64]="InsertTrailingSemicolon",e[e.StopAction=3]="StopAction",e[e.ModifySpaceAction=28]="ModifySpaceAction",e[e.ModifyTokenAction=96]="ModifyTokenAction",e))(BEe||{}),UEe=(e=>(e[e.None=0]="None",e[e.CanDeleteNewLines=1]="CanDeleteNewLines",e))(UEe||{})}});function NJe(){let e=[];for(let pe=0;pe<=165;pe++)pe!==1&&e.push(pe);function t(...pe){return{tokens:e.filter(z=>!pe.some(se=>se===z)),isSpecific:!1}}let n={tokens:e,isSpecific:!1},i=$O([...e,3]),s=$O([...e,1]),o=IJe(83,165),l=IJe(30,79),p=[103,104,165,130,142,152],m=[46,47,55,54],S=[9,10,80,21,23,19,110,105],h=[80,21,110,105],b=[80,22,24,105],A=[80,21,110,105],k=[80,22,24,105],N=[2,3],M=[80,...FJ],O=i,U=$O([80,32,3,86,95,102]),H=$O([22,3,92,113,98,93,85]),K=[oi("IgnoreBeforeComment",n,N,Uq,1),oi("IgnoreAfterLineComment",2,n,Uq,1),oi("NotSpaceBeforeColon",n,59,[ss,Vq,RJe],16),oi("SpaceAfterColon",59,n,[ss,Vq,Y4t],4),oi("NoSpaceBeforeQuestionMark",n,58,[ss,Vq,RJe],16),oi("SpaceAfterQuestionMarkInConditionalOperator",58,n,[ss,L4t],4),oi("NoSpaceAfterQuestionMark",58,n,[ss,M4t],16),oi("NoSpaceBeforeDot",n,[25,29],[ss,c3t],16),oi("NoSpaceAfterDot",[25,29],n,[ss],16),oi("NoSpaceBetweenImportParenInImportType",102,21,[ss,G4t],16),oi("NoSpaceAfterUnaryPrefixOperator",m,S,[ss,Vq],16),oi("NoSpaceAfterUnaryPreincrementOperator",46,h,[ss],16),oi("NoSpaceAfterUnaryPredecrementOperator",47,A,[ss],16),oi("NoSpaceBeforeUnaryPostincrementOperator",b,46,[ss,XJe],16),oi("NoSpaceBeforeUnaryPostdecrementOperator",k,47,[ss,XJe],16),oi("SpaceAfterPostincrementWhenFollowedByAdd",46,40,[ss,lS],4),oi("SpaceAfterAddWhenFollowedByUnaryPlus",40,40,[ss,lS],4),oi("SpaceAfterAddWhenFollowedByPreincrement",40,46,[ss,lS],4),oi("SpaceAfterPostdecrementWhenFollowedBySubtract",47,41,[ss,lS],4),oi("SpaceAfterSubtractWhenFollowedByUnaryMinus",41,41,[ss,lS],4),oi("SpaceAfterSubtractWhenFollowedByPredecrement",41,47,[ss,lS],4),oi("NoSpaceAfterCloseBrace",20,[28,27],[ss],16),oi("NewLineBeforeCloseBraceInBlockContext",i,20,[LJe],8),oi("SpaceAfterCloseBrace",20,t(22),[ss,B4t],4),oi("SpaceBetweenCloseBraceAndElse",20,93,[ss],4),oi("SpaceBetweenCloseBraceAndWhile",20,117,[ss],4),oi("NoSpaceBetweenEmptyBraceBrackets",19,20,[ss,JJe],16),oi("SpaceAfterConditionalClosingParen",22,23,[Jq],4),oi("NoSpaceBetweenFunctionKeywordAndStar",100,42,[BJe],16),oi("SpaceAfterStarInGeneratorDeclaration",42,80,[BJe],4),oi("SpaceAfterFunctionInFuncDecl",100,n,[Ox],4),oi("NewLineAfterOpenBraceInBlockContext",19,n,[LJe],8),oi("SpaceAfterGetSetInMember",[139,153],80,[Ox],4),oi("NoSpaceBetweenYieldKeywordAndStar",127,42,[ss,YJe],16),oi("SpaceBetweenYieldOrYieldStarAndOperand",[127,42],n,[ss,YJe],4),oi("NoSpaceBetweenReturnAndSemicolon",107,27,[ss],16),oi("SpaceAfterCertainKeywords",[115,111,105,91,107,114,135],n,[ss],4),oi("SpaceAfterLetConstInVariableDeclaration",[121,87],n,[ss,Q4t],4),oi("NoSpaceBeforeOpenParenInFuncCall",n,21,[ss,J4t,q4t],16),oi("SpaceBeforeBinaryKeywordOperator",n,p,[ss,lS],4),oi("SpaceAfterBinaryKeywordOperator",p,n,[ss,lS],4),oi("SpaceAfterVoidOperator",116,n,[ss,n3t],4),oi("SpaceBetweenAsyncAndOpenParen",134,21,[W4t,ss],4),oi("SpaceBetweenAsyncAndFunctionKeyword",134,[100,80],[ss],4),oi("NoSpaceBetweenTagAndTemplateString",[80,22],[15,16],[ss],16),oi("SpaceBeforeJsxAttribute",n,80,[H4t,ss],4),oi("SpaceBeforeSlashInJsxOpeningElement",n,44,[WJe,ss],4),oi("NoSpaceBeforeGreaterThanTokenInJsxOpeningElement",44,32,[WJe,ss],16),oi("NoSpaceBeforeEqualInJsxAttribute",n,64,[zJe,ss],16),oi("NoSpaceAfterEqualInJsxAttribute",64,n,[zJe,ss],16),oi("NoSpaceBeforeJsxNamespaceColon",80,59,[$Je],16),oi("NoSpaceAfterJsxNamespaceColon",59,80,[$Je],16),oi("NoSpaceAfterModuleImport",[144,149],21,[ss],16),oi("SpaceAfterCertainTypeScriptKeywords",[128,129,86,138,90,94,95,96,139,119,102,120,144,145,123,125,124,148,153,126,156,161,143,140],n,[ss],4),oi("SpaceBeforeCertainTypeScriptKeywords",n,[96,119,161],[ss],4),oi("SpaceAfterModuleName",11,19,[Z4t],4),oi("SpaceBeforeArrow",n,39,[ss],4),oi("SpaceAfterArrow",39,n,[ss],4),oi("NoSpaceAfterEllipsis",26,80,[ss],16),oi("NoSpaceAfterOptionalParameters",58,[22,28],[ss,Vq],16),oi("NoSpaceBetweenEmptyInterfaceBraceBrackets",19,20,[ss,e3t],16),oi("NoSpaceBeforeOpenAngularBracket",M,30,[ss,qq],16),oi("NoSpaceBetweenCloseParenAndAngularBracket",22,30,[ss,qq],16),oi("NoSpaceAfterOpenAngularBracket",30,n,[ss,qq],16),oi("NoSpaceBeforeCloseAngularBracket",n,32,[ss,qq],16),oi("NoSpaceAfterCloseAngularBracket",32,[21,23,32,28],[ss,qq,j4t,r3t],16),oi("SpaceBeforeAt",[22,80],60,[ss],4),oi("NoSpaceAfterAt",60,n,[ss],16),oi("SpaceAfterDecorator",n,[128,80,95,90,86,126,125,123,124,139,153,23,42],[K4t],4),oi("NoSpaceBeforeNonNullAssertionOperator",n,54,[ss,i3t],16),oi("NoSpaceAfterNewKeywordOnConstructorSignature",105,21,[ss,t3t],16),oi("SpaceLessThanAndNonJSXTypeAnnotation",30,30,[ss],4)],re=[oi("SpaceAfterConstructor",137,21,[pd("insertSpaceAfterConstructor"),ss],4),oi("NoSpaceAfterConstructor",137,21,[ah("insertSpaceAfterConstructor"),ss],16),oi("SpaceAfterComma",28,n,[pd("insertSpaceAfterCommaDelimiter"),ss,GEe,z4t,$4t],4),oi("NoSpaceAfterComma",28,n,[ah("insertSpaceAfterCommaDelimiter"),ss,GEe],16),oi("SpaceAfterAnonymousFunctionKeyword",[100,42],21,[pd("insertSpaceAfterFunctionKeywordForAnonymousFunctions"),Ox],4),oi("NoSpaceAfterAnonymousFunctionKeyword",[100,42],21,[ah("insertSpaceAfterFunctionKeywordForAnonymousFunctions"),Ox],16),oi("SpaceAfterKeywordInControl",o,21,[pd("insertSpaceAfterKeywordsInControlFlowStatements"),Jq],4),oi("NoSpaceAfterKeywordInControl",o,21,[ah("insertSpaceAfterKeywordsInControlFlowStatements"),Jq],16),oi("SpaceAfterOpenParen",21,n,[pd("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),ss],4),oi("SpaceBeforeCloseParen",n,22,[pd("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),ss],4),oi("SpaceBetweenOpenParens",21,21,[pd("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),ss],4),oi("NoSpaceBetweenParens",21,22,[ss],16),oi("NoSpaceAfterOpenParen",21,n,[ah("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),ss],16),oi("NoSpaceBeforeCloseParen",n,22,[ah("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"),ss],16),oi("SpaceAfterOpenBracket",23,n,[pd("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),ss],4),oi("SpaceBeforeCloseBracket",n,24,[pd("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),ss],4),oi("NoSpaceBetweenBrackets",23,24,[ss],16),oi("NoSpaceAfterOpenBracket",23,n,[ah("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),ss],16),oi("NoSpaceBeforeCloseBracket",n,24,[ah("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"),ss],16),oi("SpaceAfterOpenBrace",19,n,[OJe("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),MJe],4),oi("SpaceBeforeCloseBrace",n,20,[OJe("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),MJe],4),oi("NoSpaceBetweenEmptyBraceBrackets",19,20,[ss,JJe],16),oi("NoSpaceAfterOpenBrace",19,n,[VEe("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),ss],16),oi("NoSpaceBeforeCloseBrace",n,20,[VEe("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"),ss],16),oi("SpaceBetweenEmptyBraceBrackets",19,20,[pd("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces")],4),oi("NoSpaceBetweenEmptyBraceBrackets",19,20,[VEe("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces"),ss],16),oi("SpaceAfterTemplateHeadAndMiddle",[16,17],n,[pd("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),qJe],4,1),oi("SpaceBeforeTemplateMiddleAndTail",n,[17,18],[pd("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),ss],4),oi("NoSpaceAfterTemplateHeadAndMiddle",[16,17],n,[ah("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),qJe],16,1),oi("NoSpaceBeforeTemplateMiddleAndTail",n,[17,18],[ah("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"),ss],16),oi("SpaceAfterOpenBraceInJsxExpression",19,n,[pd("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),ss,cse],4),oi("SpaceBeforeCloseBraceInJsxExpression",n,20,[pd("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),ss,cse],4),oi("NoSpaceAfterOpenBraceInJsxExpression",19,n,[ah("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),ss,cse],16),oi("NoSpaceBeforeCloseBraceInJsxExpression",n,20,[ah("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"),ss,cse],16),oi("SpaceAfterSemicolonInFor",27,n,[pd("insertSpaceAfterSemicolonInForStatements"),ss,qEe],4),oi("NoSpaceAfterSemicolonInFor",27,n,[ah("insertSpaceAfterSemicolonInForStatements"),ss,qEe],16),oi("SpaceBeforeBinaryOperator",n,l,[pd("insertSpaceBeforeAndAfterBinaryOperators"),ss,lS],4),oi("SpaceAfterBinaryOperator",l,n,[pd("insertSpaceBeforeAndAfterBinaryOperators"),ss,lS],4),oi("NoSpaceBeforeBinaryOperator",n,l,[ah("insertSpaceBeforeAndAfterBinaryOperators"),ss,lS],16),oi("NoSpaceAfterBinaryOperator",l,n,[ah("insertSpaceBeforeAndAfterBinaryOperators"),ss,lS],16),oi("SpaceBeforeOpenParenInFuncDecl",n,21,[pd("insertSpaceBeforeFunctionParenthesis"),ss,Ox],4),oi("NoSpaceBeforeOpenParenInFuncDecl",n,21,[ah("insertSpaceBeforeFunctionParenthesis"),ss,Ox],16),oi("NewLineBeforeOpenBraceInControl",H,19,[pd("placeOpenBraceOnNewLineForControlBlocks"),Jq,WEe],8,1),oi("NewLineBeforeOpenBraceInFunction",O,19,[pd("placeOpenBraceOnNewLineForFunctions"),Ox,WEe],8,1),oi("NewLineBeforeOpenBraceInTypeScriptDeclWithBlock",U,19,[pd("placeOpenBraceOnNewLineForFunctions"),UJe,WEe],8,1),oi("SpaceAfterTypeAssertion",32,n,[pd("insertSpaceAfterTypeAssertion"),ss,YEe],4),oi("NoSpaceAfterTypeAssertion",32,n,[ah("insertSpaceAfterTypeAssertion"),ss,YEe],16),oi("SpaceBeforeTypeAnnotation",n,[58,59],[pd("insertSpaceBeforeTypeAnnotation"),ss,zEe],4),oi("NoSpaceBeforeTypeAnnotation",n,[58,59],[ah("insertSpaceBeforeTypeAnnotation"),ss,zEe],16),oi("NoOptionalSemicolon",27,s,[wJe("semicolons","remove"),a3t],32),oi("OptionalSemicolon",n,s,[wJe("semicolons","insert"),o3t],64)],$=[oi("NoSpaceBeforeSemicolon",n,27,[ss],16),oi("SpaceBeforeOpenBraceInControl",H,19,[JEe("placeOpenBraceOnNewLineForControlBlocks"),Jq,HEe,$Ee],4,1),oi("SpaceBeforeOpenBraceInFunction",O,19,[JEe("placeOpenBraceOnNewLineForFunctions"),Ox,ose,HEe,$Ee],4,1),oi("SpaceBeforeOpenBraceInTypeScriptDeclWithBlock",U,19,[JEe("placeOpenBraceOnNewLineForFunctions"),UJe,HEe,$Ee],4,1),oi("NoSpaceBeforeComma",n,28,[ss],16),oi("NoSpaceBeforeOpenBracket",t(134,84),23,[ss],16),oi("NoSpaceAfterCloseBracket",24,n,[ss,X4t],16),oi("SpaceAfterSemicolon",27,n,[ss],4),oi("SpaceBetweenForAndAwaitKeyword",99,135,[ss],4),oi("SpaceBetweenStatements",[22,92,93,84],n,[ss,GEe,O4t],4),oi("SpaceAfterTryCatchFinally",[113,85,98],19,[ss],4)];return[...K,...re,...$]}function oi(e,t,n,i,s,o=0){return{leftTokenRange:DJe(t),rightTokenRange:DJe(n),rule:{debugName:e,context:i,action:s,flags:o}}}function $O(e){return{tokens:e,isSpecific:!0}}function DJe(e){return typeof e=="number"?$O([e]):os(e)?$O(e):e}function IJe(e,t,n=[]){let i=[];for(let s=e;s<=t;s++)hs(n,s)||i.push(s);return $O(i)}function wJe(e,t){return n=>n.options&&n.options[e]===t}function pd(e){return t=>t.options&&wo(t.options,e)&&!!t.options[e]}function VEe(e){return t=>t.options&&wo(t.options,e)&&!t.options[e]}function ah(e){return t=>!t.options||!wo(t.options,e)||!t.options[e]}function JEe(e){return t=>!t.options||!wo(t.options,e)||!t.options[e]||t.TokensAreOnSameLine()}function OJe(e){return t=>!t.options||!wo(t.options,e)||!!t.options[e]}function qEe(e){return e.contextNode.kind===248}function O4t(e){return!qEe(e)}function lS(e){switch(e.contextNode.kind){case 226:return e.contextNode.operatorToken.kind!==28;case 227:case 194:case 234:case 281:case 276:case 182:case 192:case 193:case 238:return!0;case 208:case 265:case 271:case 277:case 260:case 169:case 306:case 172:case 171:return e.currentTokenSpan.kind===64||e.nextTokenSpan.kind===64;case 249:case 168:return e.currentTokenSpan.kind===103||e.nextTokenSpan.kind===103||e.currentTokenSpan.kind===64||e.nextTokenSpan.kind===64;case 250:return e.currentTokenSpan.kind===165||e.nextTokenSpan.kind===165}return!1}function Vq(e){return!lS(e)}function RJe(e){return!zEe(e)}function zEe(e){let t=e.contextNode.kind;return t===172||t===171||t===169||t===260||yA(t)}function R4t(e){return ea(e.contextNode)&&e.contextNode.questionToken}function M4t(e){return!R4t(e)}function L4t(e){return e.contextNode.kind===227||e.contextNode.kind===194}function $Ee(e){return e.TokensAreOnSameLine()||ose(e)}function MJe(e){return e.contextNode.kind===206||e.contextNode.kind===200||F4t(e)}function WEe(e){return ose(e)&&!(e.NextNodeAllOnSameLine()||e.NextNodeBlockIsOnOneLine())}function LJe(e){return FJe(e)&&!(e.ContextNodeAllOnSameLine()||e.ContextNodeBlockIsOnOneLine())}function F4t(e){return FJe(e)&&(e.ContextNodeAllOnSameLine()||e.ContextNodeBlockIsOnOneLine())}function FJe(e){return jJe(e.contextNode)}function ose(e){return jJe(e.nextTokenParent)}function jJe(e){if(VJe(e))return!0;switch(e.kind){case 241:case 269:case 210:case 268:return!0}return!1}function Ox(e){switch(e.contextNode.kind){case 262:case 174:case 173:case 177:case 178:case 179:case 218:case 176:case 219:case 264:return!0}return!1}function j4t(e){return!Ox(e)}function BJe(e){return e.contextNode.kind===262||e.contextNode.kind===218}function UJe(e){return VJe(e.contextNode)}function VJe(e){switch(e.kind){case 263:case 231:case 264:case 266:case 187:case 267:case 278:case 279:case 272:case 275:return!0}return!1}function B4t(e){switch(e.currentTokenParent.kind){case 263:case 267:case 266:case 299:case 268:case 255:return!0;case 241:{let t=e.currentTokenParent.parent;if(!t||t.kind!==219&&t.kind!==218)return!0}}return!1}function Jq(e){switch(e.contextNode.kind){case 245:case 255:case 248:case 249:case 250:case 247:case 258:case 246:case 254:case 299:return!0;default:return!1}}function JJe(e){return e.contextNode.kind===210}function U4t(e){return e.contextNode.kind===213}function V4t(e){return e.contextNode.kind===214}function J4t(e){return U4t(e)||V4t(e)}function q4t(e){return e.currentTokenSpan.kind!==28}function z4t(e){return e.nextTokenSpan.kind!==24}function $4t(e){return e.nextTokenSpan.kind!==22}function W4t(e){return e.contextNode.kind===219}function G4t(e){return e.contextNode.kind===205}function ss(e){return e.TokensAreOnSameLine()&&e.contextNode.kind!==12}function qJe(e){return e.contextNode.kind!==12}function GEe(e){return e.contextNode.kind!==284&&e.contextNode.kind!==288}function cse(e){return e.contextNode.kind===294||e.contextNode.kind===293}function H4t(e){return e.nextTokenParent.kind===291||e.nextTokenParent.kind===295&&e.nextTokenParent.parent.kind===291}function zJe(e){return e.contextNode.kind===291}function Y4t(e){return e.nextTokenParent.kind!==295}function $Je(e){return e.nextTokenParent.kind===295}function WJe(e){return e.contextNode.kind===285}function X4t(e){return!Ox(e)&&!ose(e)}function K4t(e){return e.TokensAreOnSameLine()&&Ad(e.contextNode)&&GJe(e.currentTokenParent)&&!GJe(e.nextTokenParent)}function GJe(e){for(;e&&bt(e);)e=e.parent;return e&&e.kind===170}function Q4t(e){return e.currentTokenParent.kind===261&&e.currentTokenParent.getStart(e.sourceFile)===e.currentTokenSpan.pos}function HEe(e){return e.formattingRequestKind!==2}function Z4t(e){return e.contextNode.kind===267}function e3t(e){return e.contextNode.kind===187}function t3t(e){return e.contextNode.kind===180}function HJe(e,t){if(e.kind!==30&&e.kind!==32)return!1;switch(t.kind){case 183:case 216:case 265:case 263:case 231:case 264:case 262:case 218:case 219:case 174:case 173:case 179:case 180:case 213:case 214:case 233:return!0;default:return!1}}function qq(e){return HJe(e.currentTokenSpan,e.currentTokenParent)||HJe(e.nextTokenSpan,e.nextTokenParent)}function YEe(e){return e.contextNode.kind===216}function r3t(e){return!YEe(e)}function n3t(e){return e.currentTokenSpan.kind===116&&e.currentTokenParent.kind===222}function YJe(e){return e.contextNode.kind===229&&e.contextNode.expression!==void 0}function i3t(e){return e.contextNode.kind===235}function XJe(e){return!s3t(e)}function s3t(e){switch(e.contextNode.kind){case 245:case 248:case 249:case 250:case 246:case 247:return!0;default:return!1}}function a3t(e){let t=e.nextTokenSpan.kind,n=e.nextTokenSpan.pos;if(TN(t)){let o=e.nextTokenParent===e.currentTokenParent?AE(e.currentTokenParent,Gr(e.currentTokenParent,l=>!l.parent),e.sourceFile):e.nextTokenParent.getFirstToken(e.sourceFile);if(!o)return!0;t=o.kind,n=o.getStart(e.sourceFile)}let i=e.sourceFile.getLineAndCharacterOfPosition(e.currentTokenSpan.pos).line,s=e.sourceFile.getLineAndCharacterOfPosition(n).line;return i===s?t===20||t===1:t===240||t===27?!1:e.contextNode.kind===264||e.contextNode.kind===265?!fp(e.currentTokenParent)||!!e.currentTokenParent.type||t!==21:ea(e.currentTokenParent)?!e.currentTokenParent.initializer:e.currentTokenParent.kind!==248&&e.currentTokenParent.kind!==242&&e.currentTokenParent.kind!==240&&t!==23&&t!==21&&t!==40&&t!==41&&t!==44&&t!==14&&t!==28&&t!==228&&t!==16&&t!==15&&t!==25}function o3t(e){return AJ(e.currentTokenSpan.end,e.currentTokenParent,e.sourceFile)}function c3t(e){return!Hn(e.contextNode)||!_p(e.contextNode.expression)||e.contextNode.expression.getText().includes(".")}var l3t=f({"src/services/formatting/rules.ts"(){"use strict";yi(),Z7()}});function u3t(e,t){return{options:e,getRules:_3t(),host:t}}function _3t(){return XEe===void 0&&(XEe=p3t(NJe())),XEe}function f3t(e){let t=0;return e&1&&(t|=28),e&2&&(t|=96),e&28&&(t|=28),e&96&&(t|=96),t}function p3t(e){let t=d3t(e);return n=>{let i=t[KJe(n.currentTokenSpan.kind,n.nextTokenSpan.kind)];if(i){let s=[],o=0;for(let l of i){let p=~f3t(o);l.action&p&&yr(l.context,m=>m(n))&&(s.push(l),o|=l.action)}if(s.length)return s}}}function d3t(e){let t=new Array(lse*lse),n=new Array(t.length);for(let i of e){let s=i.leftTokenRange.isSpecific&&i.rightTokenRange.isSpecific;for(let o of i.leftTokenRange.tokens)for(let l of i.rightTokenRange.tokens){let p=KJe(o,l),m=t[p];m===void 0&&(m=t[p]=[]),m3t(m,i.rule,s,n,p)}}return t}function KJe(e,t){return I.assert(e<=165&&t<=165,"Must compute formatting context from tokens"),e*lse+t}function m3t(e,t,n,i,s){let o=t.action&3?n?0:WO.StopRulesAny:t.context!==Uq?n?WO.ContextRulesSpecific:WO.ContextRulesAny:n?WO.NoContextRulesSpecific:WO.NoContextRulesAny,l=i[s]||0;e.splice(g3t(l,o),0,t),i[s]=h3t(l,o)}function g3t(e,t){let n=0;for(let i=0;i<=t;i+=zD)n+=e&zq,e>>=zD;return n}function h3t(e,t){let n=(e>>t&zq)+1;return I.assert((n&zq)===n,"Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules."),e&~(zq<<t)|n<<t}var XEe,zD,zq,lse,WO,y3t=f({"src/services/formatting/rulesMap.ts"(){"use strict";yi(),Z7(),zD=5,zq=31,lse=166,WO=(e=>(e[e.StopRulesSpecific=0]="StopRulesSpecific",e[e.StopRulesAny=zD*1]="StopRulesAny",e[e.ContextRulesSpecific=zD*2]="ContextRulesSpecific",e[e.ContextRulesAny=zD*3]="ContextRulesAny",e[e.NoContextRulesSpecific=zD*4]="NoContextRulesSpecific",e[e.NoContextRulesAny=zD*5]="NoContextRulesAny",e))(WO||{})}});function use(e,t,n){let i={pos:e,end:t,kind:n};return I.isDebugging&&Object.defineProperty(i,"__debugKind",{get:()=>I.formatSyntaxKind(n)}),i}function v3t(e,t,n){let i=t.getLineAndCharacterOfPosition(e).line;if(i===0)return[];let s=d8(i,t);for(;Vg(t.text.charCodeAt(s));)s--;I_(t.text.charCodeAt(s))&&s--;let o={pos:Uv(i-1,t),end:s+1};return $q(o,t,n,2)}function S3t(e,t,n){let i=KEe(e,27,t);return QJe(QEe(i),t,n,3)}function T3t(e,t,n){let i=KEe(e,19,t);if(!i)return[];let s=i.parent,o=QEe(s),l={pos:mm(o.getStart(t),t),end:e};return $q(l,t,n,4)}function b3t(e,t,n){let i=KEe(e,20,t);return QJe(QEe(i),t,n,5)}function E3t(e,t){let n={pos:0,end:e.text.length};return $q(n,e,t,0)}function x3t(e,t,n,i){let s={pos:mm(e,n),end:t};return $q(s,n,i,1)}function KEe(e,t,n){let i=tu(e,n);return i&&i.kind===t&&e===i.getEnd()?i:void 0}function QEe(e){let t=e;for(;t&&t.parent&&t.parent.end===e.end&&!C3t(t.parent,t);)t=t.parent;return t}function C3t(e,t){switch(e.kind){case 263:case 264:return ud(e.members,t);case 267:let n=e.body;return!!n&&n.kind===268&&ud(n.statements,t);case 312:case 241:case 268:return ud(e.statements,t);case 299:return ud(e.block.statements,t)}return!1}function A3t(e,t){return n(t);function n(i){let s=Qs(i,o=>ate(o.getStart(t),o.end,e)&&o);if(s){let o=n(s);if(o)return o}return i}}function k3t(e,t){if(!e.length)return s;let n=e.filter(o=>EO(t,o.start,o.start+o.length)).sort((o,l)=>o.start-l.start);if(!n.length)return s;let i=0;return o=>{for(;;){if(i>=n.length)return!1;let l=n[i];if(o.end<=l.start)return!1;if(rJ(o.pos,o.end,l.start,l.start+l.length))return!0;i++}};function s(){return!1}}function P3t(e,t,n){let i=e.getStart(n);if(i===t.pos&&e.end===t.end)return i;let s=tu(t.pos,n);return!s||s.end>=t.pos?e.pos:s.end}function N3t(e,t,n){let i=-1,s;for(;e;){let o=n.getLineAndCharacterOfPosition(e.getStart(n)).line;if(i!==-1&&o!==i)break;if(oh.shouldIndentChildNode(t,e,s,n))return t.indentSize;i=o,s=e,e=e.parent}return 0}function D3t(e,t,n,i,s,o){let l={pos:e.pos,end:e.end};return jEe(t.text,n,l.pos,l.end,p=>ZJe(l,e,i,s,p,o,1,m=>!1,t))}function QJe(e,t,n,i){if(!e)return[];let s={pos:mm(e.getStart(t),t),end:e.end};return $q(s,t,n,i)}function $q(e,t,n,i){let s=A3t(e,t);return jEe(t.text,t.languageVariant,P3t(s,e,t),e.end,o=>ZJe(e,s,oh.getIndentationForNode(s,e,t,n.options),N3t(s,n.options,t),o,n,i,k3t(t.parseDiagnostics,e),t))}function ZJe(e,t,n,i,s,{options:o,getRules:l,host:p},m,S,h){var b;let A=new FEe(h,m,o),k,N,M,O,U,H=-1,K=[];if(s.advance(),s.isOnToken()){let ke=h.getLineAndCharacterOfPosition(t.getStart(h)).line,$e=ke;Ad(t)&&($e=h.getLineAndCharacterOfPosition(CY(t,h)).line),Se(t,t,ke,$e,n,i)}let re=s.getCurrentLeadingTrivia();if(re){let ke=oh.nodeWillIndentChild(o,t,void 0,h,!1)?n+o.indentSize:n;xe(re,ke,!0,$e=>{Q($e,h.getLineAndCharacterOfPosition($e.pos),t,t,void 0),ye($e.pos,ke,!1)}),o.trimTrailingWhitespace!==!1&&Ge(re)}if(N&&s.getTokenFullStart()>=e.end){let ke=s.isOnEOF()?s.readEOFTokenRange():s.isOnToken()?s.readTokenInfo(t).token:void 0;if(ke&&ke.pos===k){let $e=((b=tu(ke.end,h,t))==null?void 0:b.parent)||M;ce(ke,h.getLineAndCharacterOfPosition(ke.pos).line,$e,N,O,M,$e,void 0)}}return K;function $(ke,$e,at,$t,St){if(EO($t,ke,$e)||XM($t,ke,$e)){if(St!==-1)return St}else{let Ze=h.getLineAndCharacterOfPosition(ke).line,yt=mm(ke,h),ar=oh.findFirstNonWhitespaceColumn(yt,ke,h,o);if(Ze!==at||ke===ar){let or=oh.getBaseIndentation(o);return or>ar?or:ar}}return-1}function pe(ke,$e,at,$t,St,Ze){let yt=oh.shouldIndentChildNode(o,ke)?o.indentSize:0;return Ze===$e?{indentation:$e===U?H:St.getIndentation(),delta:Math.min(o.indentSize,St.getDelta(ke)+yt)}:at===-1?ke.kind===21&&$e===U?{indentation:H,delta:St.getDelta(ke)}:oh.childStartsOnTheSameLineWithElseInIfStatement($t,ke,$e,h)||oh.childIsUnindentedBranchOfConditionalExpression($t,ke,$e,h)||oh.argumentStartsOnSameLineAsPreviousArgument($t,ke,$e,h)?{indentation:St.getIndentation(),delta:yt}:{indentation:St.getIndentation()+St.getDelta(ke),delta:yt}:{indentation:at,delta:yt}}function z(ke){if(Jm(ke)){let $e=mr(ke.modifiers,Ra,oa(ke.modifiers,n_));if($e)return $e.kind}switch(ke.kind){case 263:return 86;case 264:return 120;case 262:return 100;case 266:return 266;case 177:return 139;case 178:return 153;case 174:if(ke.asteriskToken)return 42;case 172:case 169:let $e=qs(ke);if($e)return $e.kind}}function se(ke,$e,at,$t){return{getIndentationForComment:(yt,ar,or)=>{switch(yt){case 20:case 24:case 22:return at+Ze(or)}return ar!==-1?ar:at},getIndentationForToken:(yt,ar,or,Fr)=>!Fr&&St(yt,ar,or)?at+Ze(or):at,getIndentation:()=>at,getDelta:Ze,recomputeIndentation:(yt,ar)=>{oh.shouldIndentChildNode(o,ar,ke,h)&&(at+=yt?o.indentSize:-o.indentSize,$t=oh.shouldIndentChildNode(o,ke)?o.indentSize:0)}};function St(yt,ar,or){switch(ar){case 19:case 20:case 22:case 93:case 117:case 60:return!1;case 44:case 32:switch(or.kind){case 286:case 287:case 285:return!1}break;case 23:case 24:if(or.kind!==200)return!1;break}return $e!==yt&&!(Ad(ke)&&ar===z(ke))}function Ze(yt){return oh.nodeWillIndentChild(o,ke,yt,h,!0)?$t:0}}function Se(ke,$e,at,$t,St,Ze){if(!EO(e,ke.getStart(h),ke.getEnd()))return;let yt=se(ke,at,St,Ze),ar=$e;for(Qs(ke,Tr=>{or(Tr,-1,ke,yt,at,$t,!1)},Tr=>{Fr(Tr,ke,at,yt)});s.isOnToken()&&s.getTokenFullStart()<e.end;){let Tr=s.readTokenInfo(ke);if(Tr.token.end>Math.min(ke.end,e.end))break;rn(Tr,ke,yt,ke)}function or(Tr,nr,tr,ki,xs,zi,Ms,un){if(I.assert(!_c(Tr)),sl(Tr)||Ype(tr,Tr))return nr;let ri=Tr.getStart(h),On=h.getLineAndCharacterOfPosition(ri).line,_r=On;Ad(Tr)&&(_r=h.getLineAndCharacterOfPosition(CY(Tr,h)).line);let rt=-1;if(Ms&&ud(e,tr)&&(rt=$(ri,Tr.end,xs,e,nr),rt!==-1&&(nr=rt)),!EO(e,Tr.pos,Tr.end))return Tr.end<e.pos&&s.skipToEndOf(Tr),nr;if(Tr.getFullWidth()===0)return nr;for(;s.isOnToken()&&s.getTokenFullStart()<e.end;){let vi=s.readTokenInfo(ke);if(vi.token.end>e.end)return nr;if(vi.token.end>ri){vi.token.pos>ri&&s.skipToStartOf(Tr);break}rn(vi,ke,ki,ke)}if(!s.isOnToken()||s.getTokenFullStart()>=e.end)return nr;if(gA(Tr)){let vi=s.readTokenInfo(Tr);if(Tr.kind!==12)return I.assert(vi.token.end===Tr.end,"Token end is child end"),rn(vi,ke,ki,Tr),nr}let zt=Tr.kind===170?On:zi,Rr=pe(Tr,On,rt,ke,ki,zt);return Se(Tr,ar,On,_r,Rr.indentation,Rr.delta),ar=ke,un&&tr.kind===209&&nr===-1&&(nr=Rr.indentation),nr}function Fr(Tr,nr,tr,ki){I.assert(Bb(Tr)),I.assert(!_c(Tr));let xs=I3t(nr,Tr),zi=ki,Ms=tr;if(!EO(e,Tr.pos,Tr.end)){Tr.end<e.pos&&s.skipToEndOf(Tr);return}if(xs!==0)for(;s.isOnToken()&&s.getTokenFullStart()<e.end;){let On=s.readTokenInfo(nr);if(On.token.end>Tr.pos)break;if(On.token.kind===xs){Ms=h.getLineAndCharacterOfPosition(On.token.pos).line,rn(On,nr,ki,nr);let _r;if(H!==-1)_r=H;else{let rt=mm(On.token.pos,h);_r=oh.findFirstNonWhitespaceColumn(rt,On.token.pos,h,o)}zi=se(nr,tr,_r,o.indentSize)}else rn(On,nr,ki,nr)}let un=-1;for(let On=0;On<Tr.length;On++){let _r=Tr[On];un=or(_r,un,ke,zi,Ms,Ms,!0,On===0)}let ri=w3t(xs);if(ri!==0&&s.isOnToken()&&s.getTokenFullStart()<e.end){let On=s.readTokenInfo(nr);On.token.kind===28&&(rn(On,nr,zi,nr),On=s.isOnToken()?s.readTokenInfo(nr):void 0),On&&On.token.kind===ri&&ud(nr,On.token)&&rn(On,nr,zi,nr,!0)}}function rn(Tr,nr,tr,ki,xs){I.assert(ud(nr,Tr.token));let zi=s.lastTrailingTriviaWasNewLine(),Ms=!1;Tr.leadingTrivia&&Z(Tr.leadingTrivia,nr,ar,tr);let un=0,ri=ud(e,Tr.token),On=h.getLineAndCharacterOfPosition(Tr.token.pos);if(ri){let _r=S(Tr.token),rt=N;if(un=Q(Tr.token,On,nr,ar,tr),!_r)if(un===0){let zt=rt&&h.getLineAndCharacterOfPosition(rt.end).line;Ms=zi&&On.line!==zt}else Ms=un===1}if(Tr.trailingTrivia&&(k=Rs(Tr.trailingTrivia).end,Z(Tr.trailingTrivia,nr,ar,tr)),Ms){let _r=ri&&!S(Tr.token)?tr.getIndentationForToken(On.line,Tr.token.kind,ki,!!xs):-1,rt=!0;if(Tr.leadingTrivia){let zt=tr.getIndentationForComment(Tr.token.kind,_r,ki);rt=xe(Tr.leadingTrivia,zt,rt,Rr=>ye(Rr.pos,zt,!1))}_r!==-1&&rt&&(ye(Tr.token.pos,_r,un===1),U=On.line,H=_r)}s.advance(),ar=nr}}function xe(ke,$e,at,$t){for(let St of ke){let Ze=ud(e,St);switch(St.kind){case 3:Ze&&oe(St,$e,!at),at=!1;break;case 2:at&&Ze&&$t(St),at=!1;break;case 4:at=!0;break}}return at}function Z(ke,$e,at,$t){for(let St of ke)if(uJ(St.kind)&&ud(e,St)){let Ze=h.getLineAndCharacterOfPosition(St.pos);Q(St,Ze,$e,at,$t)}}function Q(ke,$e,at,$t,St){let Ze=S(ke),yt=0;if(!Ze)if(N)yt=ce(ke,$e.line,at,N,O,M,$t,St);else{let ar=h.getLineAndCharacterOfPosition(e.pos);Ee(ar.line,$e.line)}return N=ke,k=ke.end,M=at,O=$e.line,yt}function ce(ke,$e,at,$t,St,Ze,yt,ar){A.updateContext($t,Ze,ke,at,yt);let or=l(A),Fr=A.options.trimTrailingWhitespace!==!1,rn=0;return or?ut(or,Tr=>{if(rn=kt(Tr,$t,St,ke,$e),ar)switch(rn){case 2:at.getStart(h)===ke.pos&&ar.recomputeIndentation(!1,yt);break;case 1:at.getStart(h)===ke.pos&&ar.recomputeIndentation(!0,yt);break;default:I.assert(rn===0)}Fr=Fr&&!(Tr.action&16)&&Tr.flags!==1}):Fr=Fr&&ke.kind!==1,$e!==St&&Fr&&Ee(St,$e,$t),rn}function ye(ke,$e,at){let $t=ZEe($e,o);if(at)Re(ke,0,$t);else{let St=h.getLineAndCharacterOfPosition(ke),Ze=Uv(St.line,h);($e!==we(Ze,St.character)||ve($t,Ze))&&Re(Ze,St.character,$t)}}function we(ke,$e){let at=0;for(let $t=0;$t<$e;$t++)h.text.charCodeAt(ke+$t)===9?at+=o.tabSize-at%o.tabSize:at++;return at}function ve(ke,$e){return ke!==h.text.substr($e,ke.length)}function oe(ke,$e,at,$t=!0){let St=h.getLineAndCharacterOfPosition(ke.pos).line,Ze=h.getLineAndCharacterOfPosition(ke.end).line;if(St===Ze){at||ye(ke.pos,$e,!1);return}let yt=[],ar=ke.pos;for(let nr=St;nr<Ze;nr++){let tr=d8(nr,h);yt.push({pos:ar,end:tr}),ar=Uv(nr+1,h)}if($t&&yt.push({pos:ar,end:ke.end}),yt.length===0)return;let or=Uv(St,h),Fr=oh.findFirstNonWhitespaceCharacterAndColumn(or,yt[0].pos,h,o),rn=0;at&&(rn=1,St++);let Tr=$e-Fr.column;for(let nr=rn;nr<yt.length;nr++,St++){let tr=Uv(St,h),ki=nr===0?Fr:oh.findFirstNonWhitespaceCharacterAndColumn(yt[nr].pos,yt[nr].end,h,o),xs=ki.column+Tr;if(xs>0){let zi=ZEe(xs,o);Re(tr,ki.character,zi)}else Ie(tr,ki.character)}}function Ee(ke,$e,at){for(let $t=ke;$t<$e;$t++){let St=Uv($t,h),Ze=d8($t,h);if(at&&(uJ(at.kind)||pte(at.kind))&&at.pos<=Ze&&at.end>Ze)continue;let yt=Me(St,Ze);yt!==-1&&(I.assert(yt===St||!Vg(h.text.charCodeAt(yt-1))),Ie(yt,Ze+1-yt))}}function Me(ke,$e){let at=$e;for(;at>=ke&&Vg(h.text.charCodeAt(at));)at--;return at!==$e?at+1:-1}function Ge(ke){let $e=N?N.end:e.pos;for(let at of ke)uJ(at.kind)&&($e<at.pos&&Ae($e,at.pos-1,N),$e=at.end+1);$e<e.end&&Ae($e,e.end,N)}function Ae(ke,$e,at){let $t=h.getLineAndCharacterOfPosition(ke).line,St=h.getLineAndCharacterOfPosition($e).line;Ee($t,St+1,at)}function Ie(ke,$e){$e&&K.push(fJ(ke,$e,""))}function Re(ke,$e,at){($e||at)&&K.push(fJ(ke,$e,at))}function Ue(ke,$e){$e&&K.push(fJ(ke,0,$e))}function kt(ke,$e,at,$t,St){let Ze=St!==at;switch(ke.action){case 1:return 0;case 16:if($e.end!==$t.pos)return Ie($e.end,$t.pos-$e.end),Ze?2:0;break;case 32:Ie($e.pos,$e.end-$e.pos);break;case 8:if(ke.flags!==1&&at!==St)return 0;if(St-at!==1)return Re($e.end,$t.pos-$e.end,q1(p,o)),Ze?0:1;break;case 4:if(ke.flags!==1&&at!==St)return 0;if($t.pos-$e.end!==1||h.text.charCodeAt($e.end)!==32)return Re($e.end,$t.pos-$e.end," "),Ze?2:0;break;case 64:Ue($e.end,";")}return 0}}function eqe(e,t,n,i=Ts(e,t)){let s=Gr(i,dg);if(s&&(i=s.parent),i.getStart(e)<=t&&t<i.getEnd())return;n=n===null?void 0:n===void 0?tu(t,e):n;let l=n&&aT(e.text,n.end),p=jY(i,e),m=ys(l,p);return m&&mr(m,S=>YM(S,t)||t===S.end&&(S.kind===2||t===e.getFullWidth()))}function I3t(e,t){switch(e.kind){case 176:case 262:case 218:case 174:case 173:case 219:case 179:case 180:case 184:case 185:case 177:case 178:if(e.typeParameters===t)return 30;if(e.parameters===t)return 21;break;case 213:case 214:if(e.typeArguments===t)return 30;if(e.arguments===t)return 21;break;case 263:case 231:case 264:case 265:if(e.typeParameters===t)return 30;break;case 183:case 215:case 186:case 233:case 205:if(e.typeArguments===t)return 30;break;case 187:return 19}return 0}function w3t(e){switch(e){case 21:return 22;case 30:return 32;case 19:return 20}return 0}function ZEe(e,t){if((!_se||_se.tabSize!==t.tabSize||_se.indentSize!==t.indentSize)&&(_se={tabSize:t.tabSize,indentSize:t.indentSize},K7=Q7=void 0),t.convertTabsToSpaces){let i,s=Math.floor(e/t.indentSize),o=e%t.indentSize;return Q7||(Q7=[]),Q7[s]===void 0?(i=r7(" ",t.indentSize*s),Q7[s]=i):i=Q7[s],o?i+r7(" ",o):i}else{let i=Math.floor(e/t.tabSize),s=e-i*t.tabSize,o;return K7||(K7=[]),K7[i]===void 0?K7[i]=o=r7("	",i):o=K7[i],s?o+r7(" ",s):o}}var _se,K7,Q7,O3t=f({"src/services/formatting/formatting.ts"(){"use strict";yi(),Z7()}}),oh,R3t=f({"src/services/formatting/smartIndenter.ts"(){"use strict";yi(),Z7(),(e=>{let t;(oe=>{oe[oe.Unknown=-1]="Unknown"})(t||(t={}));function n(oe,Ee,Me,Ge=!1){if(oe>Ee.text.length)return p(Me);if(Me.indentStyle===0)return 0;let Ae=tu(oe,Ee,void 0,!0),Ie=eqe(Ee,oe,Ae||null);if(Ie&&Ie.kind===3)return i(Ee,oe,Me,Ie);if(!Ae)return p(Me);if(pte(Ae.kind)&&Ae.getStart(Ee)<=oe&&oe<Ae.end)return 0;let Ue=Ee.getLineAndCharacterOfPosition(oe).line,kt=Ts(Ee,oe),ke=kt.kind===19&&kt.parent.kind===210;if(Me.indentStyle===1||ke)return s(Ee,oe,Me);if(Ae.kind===28&&Ae.parent.kind!==226){let at=h(Ae,Ee,Me);if(at!==-1)return at}let $e=re(oe,Ae.parent,Ee);if($e&&!ud($e,Ae)){let $t=[218,219].includes(kt.parent.kind)?0:Me.indentSize;return z($e,Ee,Me)+$t}return o(Ee,oe,Ae,Ue,Ge,Me)}e.getIndentation=n;function i(oe,Ee,Me,Ge){let Ae=Lo(oe,Ee).line-1,Ie=Lo(oe,Ge.pos).line;if(I.assert(Ie>=0),Ae<=Ie)return Q(Uv(Ie,oe),Ee,oe,Me);let Re=Uv(Ae,oe),{column:Ue,character:kt}=Z(Re,Ee,oe,Me);return Ue===0?Ue:oe.text.charCodeAt(Re+kt)===42?Ue-1:Ue}function s(oe,Ee,Me){let Ge=Ee;for(;Ge>0;){let Ie=oe.text.charCodeAt(Ge);if(!Sy(Ie))break;Ge--}let Ae=mm(Ge,oe);return Q(Ae,Ge,oe,Me)}function o(oe,Ee,Me,Ge,Ae,Ie){let Re,Ue=Me;for(;Ue;){if(ote(Ue,Ee,oe)&&we(Ie,Ue,Re,oe,!0)){let ke=N(Ue,oe),$e=k(Me,Ue,Ge,oe),at=$e!==0?Ae&&$e===2?Ie.indentSize:0:Ge!==ke.line?Ie.indentSize:0;return m(Ue,ke,void 0,at,oe,!0,Ie)}let kt=se(Ue,oe,Ie,!0);if(kt!==-1)return kt;Re=Ue,Ue=Ue.parent}return p(Ie)}function l(oe,Ee,Me,Ge){let Ae=Me.getLineAndCharacterOfPosition(oe.getStart(Me));return m(oe,Ae,Ee,0,Me,!1,Ge)}e.getIndentationForNode=l;function p(oe){return oe.baseIndentSize||0}e.getBaseIndentation=p;function m(oe,Ee,Me,Ge,Ae,Ie,Re){var Ue;let kt=oe.parent;for(;kt;){let ke=!0;if(Me){let St=oe.getStart(Ae);ke=St<Me.pos||St>Me.end}let $e=S(kt,oe,Ae),at=$e.line===Ee.line||O(kt,oe,Ee.line,Ae);if(ke){let St=(Ue=K(oe,Ae))==null?void 0:Ue[0],Ze=!!St&&N(St,Ae).line>$e.line,yt=se(oe,Ae,Re,Ze);if(yt!==-1||(yt=b(oe,kt,Ee,at,Ae,Re),yt!==-1))return yt+Ge}we(Re,kt,oe,Ae,Ie)&&!at&&(Ge+=Re.indentSize);let $t=M(kt,oe,Ee.line,Ae);oe=kt,kt=oe.parent,Ee=$t?Ae.getLineAndCharacterOfPosition(oe.getStart(Ae)):$e}return Ge+p(Re)}function S(oe,Ee,Me){let Ge=K(Ee,Me),Ae=Ge?Ge.pos:oe.getStart(Me);return Me.getLineAndCharacterOfPosition(Ae)}function h(oe,Ee,Me){let Ge=p1e(oe);return Ge&&Ge.listItemIndex>0?Se(Ge.list.getChildren(),Ge.listItemIndex-1,Ee,Me):-1}function b(oe,Ee,Me,Ge,Ae,Ie){return(O_(oe)||l8(oe))&&(Ee.kind===312||!Ge)?xe(Me,Ae,Ie):-1}let A;(oe=>{oe[oe.Unknown=0]="Unknown",oe[oe.OpenBrace=1]="OpenBrace",oe[oe.CloseBrace=2]="CloseBrace"})(A||(A={}));function k(oe,Ee,Me,Ge){let Ae=AE(oe,Ee,Ge);if(!Ae)return 0;if(Ae.kind===19)return 1;if(Ae.kind===20){let Ie=N(Ae,Ge).line;return Me===Ie?2:0}return 0}function N(oe,Ee){return Ee.getLineAndCharacterOfPosition(oe.getStart(Ee))}function M(oe,Ee,Me,Ge){if(!(da(oe)&&hs(oe.arguments,Ee)))return!1;let Ae=oe.expression.getEnd();return Lo(Ge,Ae).line===Me}e.isArgumentAndStartLineOverlapsExpressionBeingCalled=M;function O(oe,Ee,Me,Ge){if(oe.kind===245&&oe.elseStatement===Ee){let Ae=Oo(oe,93,Ge);return I.assert(Ae!==void 0),N(Ae,Ge).line===Me}return!1}e.childStartsOnTheSameLineWithElseInIfStatement=O;function U(oe,Ee,Me,Ge){if($N(oe)&&(Ee===oe.whenTrue||Ee===oe.whenFalse)){let Ae=Lo(Ge,oe.condition.end).line;if(Ee===oe.whenTrue)return Me===Ae;{let Ie=N(oe.whenTrue,Ge).line,Re=Lo(Ge,oe.whenTrue.end).line;return Ae===Ie&&Re===Me}}return!1}e.childIsUnindentedBranchOfConditionalExpression=U;function H(oe,Ee,Me,Ge){if(Jg(oe)){if(!oe.arguments)return!1;let Ae=mr(oe.arguments,kt=>kt.pos===Ee.pos);if(!Ae)return!1;let Ie=oe.arguments.indexOf(Ae);if(Ie===0)return!1;let Re=oe.arguments[Ie-1],Ue=Lo(Ge,Re.getEnd()).line;if(Me===Ue)return!0}return!1}e.argumentStartsOnSameLineAsPreviousArgument=H;function K(oe,Ee){return oe.parent&&$(oe.getStart(Ee),oe.getEnd(),oe.parent,Ee)}e.getContainingList=K;function re(oe,Ee,Me){return Ee&&$(oe,oe,Ee,Me)}function $(oe,Ee,Me,Ge){switch(Me.kind){case 183:return Ae(Me.typeArguments);case 210:return Ae(Me.properties);case 209:return Ae(Me.elements);case 187:return Ae(Me.members);case 262:case 218:case 219:case 174:case 173:case 179:case 176:case 185:case 180:return Ae(Me.typeParameters)||Ae(Me.parameters);case 177:return Ae(Me.parameters);case 263:case 231:case 264:case 265:case 352:return Ae(Me.typeParameters);case 214:case 213:return Ae(Me.typeArguments)||Ae(Me.arguments);case 261:return Ae(Me.declarations);case 275:case 279:return Ae(Me.elements);case 206:case 207:return Ae(Me.elements)}function Ae(Ie){return Ie&&XM(pe(Me,Ie,Ge),oe,Ee)?Ie:void 0}}function pe(oe,Ee,Me){let Ge=oe.getChildren(Me);for(let Ae=1;Ae<Ge.length-1;Ae++)if(Ge[Ae].pos===Ee.pos&&Ge[Ae].end===Ee.end)return{pos:Ge[Ae-1].end,end:Ge[Ae+1].getStart(Me)};return Ee}function z(oe,Ee,Me){return oe?xe(Ee.getLineAndCharacterOfPosition(oe.pos),Ee,Me):-1}function se(oe,Ee,Me,Ge){if(oe.parent&&oe.parent.kind===261)return-1;let Ae=K(oe,Ee);if(Ae){let Ie=Ae.indexOf(oe);if(Ie!==-1){let Re=Se(Ae,Ie,Ee,Me);if(Re!==-1)return Re}return z(Ae,Ee,Me)+(Ge?Me.indentSize:0)}return-1}function Se(oe,Ee,Me,Ge){I.assert(Ee>=0&&Ee<oe.length);let Ae=oe[Ee],Ie=N(Ae,Me);for(let Re=Ee-1;Re>=0;Re--){if(oe[Re].kind===28)continue;if(Me.getLineAndCharacterOfPosition(oe[Re].end).line!==Ie.line)return xe(Ie,Me,Ge);Ie=N(oe[Re],Me)}return-1}function xe(oe,Ee,Me){let Ge=Ee.getPositionOfLineAndCharacter(oe.line,0);return Q(Ge,Ge+oe.character,Ee,Me)}function Z(oe,Ee,Me,Ge){let Ae=0,Ie=0;for(let Re=oe;Re<Ee;Re++){let Ue=Me.text.charCodeAt(Re);if(!Vg(Ue))break;Ue===9?Ie+=Ge.tabSize+Ie%Ge.tabSize:Ie++,Ae++}return{column:Ie,character:Ae}}e.findFirstNonWhitespaceCharacterAndColumn=Z;function Q(oe,Ee,Me,Ge){return Z(oe,Ee,Me,Ge).column}e.findFirstNonWhitespaceColumn=Q;function ce(oe,Ee,Me,Ge,Ae){let Ie=Me?Me.kind:0;switch(Ee.kind){case 244:case 263:case 231:case 264:case 266:case 265:case 209:case 241:case 268:case 210:case 187:case 200:case 189:case 217:case 211:case 213:case 214:case 243:case 277:case 253:case 227:case 207:case 206:case 286:case 289:case 285:case 294:case 173:case 179:case 180:case 169:case 184:case 185:case 196:case 215:case 223:case 279:case 275:case 281:case 276:case 172:case 296:case 297:return!0;case 269:return oe.indentSwitchCase??!0;case 260:case 303:case 226:if(!oe.indentMultiLineObjectLiteralBeginningOnBlankLine&&Ge&&Ie===210)return ve(Ge,Me);if(Ee.kind===226&&Ge&&Me&&Ie===284){let Re=Ge.getLineAndCharacterOfPosition(Wa(Ge.text,Ee.pos)).line,Ue=Ge.getLineAndCharacterOfPosition(Wa(Ge.text,Me.pos)).line;return Re!==Ue}if(Ee.kind!==226)return!0;break;case 246:case 247:case 249:case 250:case 248:case 245:case 262:case 218:case 174:case 176:case 177:case 178:return Ie!==241;case 219:return Ge&&Ie===217?ve(Ge,Me):Ie!==241;case 278:return Ie!==279;case 272:return Ie!==273||!!Me.namedBindings&&Me.namedBindings.kind!==275;case 284:return Ie!==287;case 288:return Ie!==290;case 193:case 192:if(Ie===187||Ie===189)return!1;break}return Ae}e.nodeWillIndentChild=ce;function ye(oe,Ee){switch(oe){case 253:case 257:case 251:case 252:return Ee.kind!==241;default:return!1}}function we(oe,Ee,Me,Ge,Ae=!1){return ce(oe,Ee,Me,Ge,!1)&&!(Ae&&Me&&ye(Me.kind,Ee))}e.shouldIndentChildNode=we;function ve(oe,Ee){let Me=Wa(oe.text,Ee.pos),Ge=oe.getLineAndCharacterOfPosition(Me).line,Ae=oe.getLineAndCharacterOfPosition(Ee.end).line;return Ge===Ae}})(oh||(oh={}))}}),fu={};x(fu,{FormattingContext:()=>FEe,FormattingRequestKind:()=>LEe,RuleAction:()=>BEe,RuleFlags:()=>UEe,SmartIndenter:()=>oh,anyContext:()=>Uq,createTextRangeWithKind:()=>use,formatDocument:()=>E3t,formatNodeGivenIndentation:()=>D3t,formatOnClosingCurly:()=>b3t,formatOnEnter:()=>v3t,formatOnOpeningCurly:()=>T3t,formatOnSemicolon:()=>S3t,formatSelection:()=>x3t,getAllRules:()=>NJe,getFormatContext:()=>u3t,getFormattingScanner:()=>jEe,getIndentationString:()=>ZEe,getRangeOfEnclosingComment:()=>eqe});var Z7=f({"src/services/_namespaces/ts.formatting.ts"(){"use strict";D4t(),I4t(),w4t(),l3t(),y3t(),O3t(),R3t()}}),yi=f({"src/services/_namespaces/ts.ts"(){"use strict";fa(),JM(),qbt(),pEt(),hEt(),PLe(),NEt(),DEt(),FEt(),GEt(),HEt(),XEt(),i2t(),s2t(),AAt(),kAt(),DAt(),XAt(),QAt(),Ma(),Kbe(),uEe(),A6t(),I6t(),H6t(),QLe(),vFe(),mOt(),EOt(),Gh(),IOt(),s4t(),p4t(),h4t(),N4t(),Z7()}});function M3t(){return nqe??(nqe=new Im(F))}function tqe(e,t,n,i,s){let o=t?"DeprecationError: ":"DeprecationWarning: ";return o+=`'${e}' `,o+=i?`has been deprecated since v${i}`:"is deprecated",o+=t?" and can no longer be used.":n?` and will no longer be usable after v${n}.`:".",o+=s?` ${O0(s,[e])}`:"",o}function L3t(e,t,n,i){let s=tqe(e,!0,t,n,i);return()=>{throw new TypeError(s)}}function F3t(e,t,n,i){let s=!1;return()=>{rqe&&!s&&(I.log.warn(tqe(e,!1,t,n,i)),s=!0)}}function j3t(e,t={}){let n=typeof t.typeScriptVersion=="string"?new Im(t.typeScriptVersion):t.typeScriptVersion??M3t(),i=typeof t.errorAfter=="string"?new Im(t.errorAfter):t.errorAfter,s=typeof t.warnAfter=="string"?new Im(t.warnAfter):t.warnAfter,o=typeof t.since=="string"?new Im(t.since):t.since??s,l=t.error||i&&n.compareTo(i)>=0,p=!s||n.compareTo(s)>=0;return l?L3t(e,i,o,t.message):p?F3t(e,i,o,t.message):ja}function B3t(e,t){return function(){return e(),t.apply(this,arguments)}}function e2e(e,t){let n=j3t(t?.name??I.getFunctionName(e),t);return B3t(n,e)}var rqe,nqe,iqe=f({"src/deprecatedCompat/deprecate.ts"(){"use strict";pse(),rqe=!0}});function fse(e,t,n,i){if(Object.defineProperty(o,"name",{...Object.getOwnPropertyDescriptor(o,"name"),value:e}),i)for(let l of Object.keys(i)){let p=+l;!isNaN(p)&&wo(t,`${p}`)&&(t[p]=e2e(t[p],{...i[p],name:e}))}let s=U3t(t,n);return o;function o(...l){let p=s(l),m=p!==void 0?t[p]:void 0;if(typeof m=="function")return m(...l);throw new TypeError("Invalid arguments")}}function U3t(e,t){return n=>{for(let i=0;wo(e,`${i}`)&&wo(t,`${i}`);i++){let s=t[i];if(s(n))return i}}}function sqe(e){return{overload:t=>({bind:n=>({finish:()=>fse(e,t,n),deprecate:i=>({finish:()=>fse(e,t,n,i)})})})}}var V3t=f({"src/deprecatedCompat/deprecations.ts"(){"use strict";pse(),iqe()}}),J3t=f({"src/deprecatedCompat/5.0/identifierProperties.ts"(){"use strict";pse(),iqe(),yme(e=>{let t=e.getIdentifierConstructor();wo(t.prototype,"originalKeywordKind")||Object.defineProperty(t.prototype,"originalKeywordKind",{get:e2e(function(){return uT(this)},{name:"originalKeywordKind",since:"5.0",warnAfter:"5.1",errorAfter:"5.2",message:"Use 'identifierToKeywordKind(identifier)' instead."})}),wo(t.prototype,"isInJSDocNamespace")||Object.defineProperty(t.prototype,"isInJSDocNamespace",{get:e2e(function(){return this.flags&4096?!0:void 0},{name:"isInJSDocNamespace",since:"5.0",warnAfter:"5.1",errorAfter:"5.2",message:"Use '.parent' or the surrounding context to determine this instead."})})})}}),pse=f({"src/deprecatedCompat/_namespaces/ts.ts"(){"use strict";fa(),V3t(),J3t()}}),q3t=f({"src/typingsInstallerCore/_namespaces/ts.ts"(){"use strict";fa(),JM(),r2e()}});function aqe(e,t,n,i){try{let s=aD(t,li(e,"index.d.ts"),{moduleResolution:2},n);return s.resolvedModule&&s.resolvedModule.resolvedFileName}catch(s){i.isEnabled()&&i.writeLine(`Failed to resolve ${t} in folder '${e}': ${s.message}`);return}}function z3t(e,t,n,i){let s=!1;for(let o=n.length;o>0;){let l=oqe(e,t,n,o);o=l.remaining,s=i(l.command)||s}return s}function oqe(e,t,n,i){let s=n.length-i,o,l=i;for(;o=`${e} install --ignore-scripts ${(l===n.length?n:n.slice(s,s+l)).join(" ")} --save-dev --user-agent="typesInstaller/${t}"`,!(o.length<8e3);)l=l-Math.floor(l/2);return{command:o,remaining:i-l}}function cqe(e){return`@types/${e}@ts${w}`}var lqe,uqe,$3t=f({"src/typingsInstallerCore/typingsInstaller.ts"(){"use strict";q3t(),r2e(),lqe={isEnabled:()=>!1,writeLine:ja},uqe=class{constructor(e,t,n,i,s,o=lqe){this.installTypingHost=e,this.globalCachePath=t,this.safeListPath=n,this.typesMapLocation=i,this.throttleLimit=s,this.log=o,this.packageNameToTypingLocation=new Map,this.missingTypingsSet=new Set,this.knownCachesSet=new Set,this.projectWatchers=new Map,this.pendingRunRequests=[],this.installRunCount=1,this.inFlightRequestCount=0,this.latestDistTag="latest",this.log.isEnabled()&&this.log.writeLine(`Global cache location '${t}', safe file path '${n}', types map path ${i}`),this.processCacheLocation(this.globalCachePath)}handleRequest(e){switch(e.kind){case"discover":this.install(e);break;case"closeProject":this.closeProject(e);break;case"typesRegistry":{let t={};this.typesRegistry.forEach((i,s)=>{t[s]=i});let n={kind:$V,typesRegistry:t};this.sendResponse(n);break}case"installPackage":{this.installPackage(e);break}default:I.assertNever(e)}}closeProject(e){this.closeWatchers(e.projectName)}closeWatchers(e){if(this.log.isEnabled()&&this.log.writeLine(`Closing file watchers for project '${e}'`),!this.projectWatchers.get(e)){this.log.isEnabled()&&this.log.writeLine(`No watchers are registered for project '${e}'`);return}this.projectWatchers.delete(e),this.sendResponse({kind:TO,projectName:e,files:[]}),this.log.isEnabled()&&this.log.writeLine(`Closing file watchers for project '${e}' - done.`)}install(e){this.log.isEnabled()&&this.log.writeLine(`Got install request${LT(e)}`),e.cachePath&&(this.log.isEnabled()&&this.log.writeLine(`Request specifies cache path '${e.cachePath}', loading cached information...`),this.processCacheLocation(e.cachePath)),this.safeList===void 0&&this.initializeSafeList();let t=sh.discoverTypings(this.installTypingHost,this.log.isEnabled()?n=>this.log.writeLine(n):void 0,e.fileNames,e.projectRootPath,this.safeList,this.packageNameToTypingLocation,e.typeAcquisition,e.unresolvedImports,this.typesRegistry,e.compilerOptions);this.watchFiles(e.projectName,t.filesToWatch),t.newTypingNames.length?this.installTypings(e,e.cachePath||this.globalCachePath,t.cachedTypingPaths,t.newTypingNames):(this.sendResponse(this.createSetTypings(e,t.cachedTypingPaths)),this.log.isEnabled()&&this.log.writeLine("No new typings were requested as a result of typings discovery"))}installPackage(e){let{fileName:t,packageName:n,projectName:i,projectRootPath:s,id:o}=e,l=Rm(hi(t),p=>{if(this.installTypingHost.fileExists(li(p,"package.json")))return p})||s;if(l)this.installWorker(-1,[n],l,p=>{let m=p?`Package ${n} installed.`:`There was an error installing ${n}.`,S={kind:VM,projectName:i,id:o,success:p,message:m};this.sendResponse(S)});else{let p={kind:VM,projectName:i,id:o,success:!1,message:"Could not determine a project root path."};this.sendResponse(p)}}initializeSafeList(){if(this.typesMapLocation){let e=sh.loadTypesMap(this.installTypingHost,this.typesMapLocation);if(e){this.log.writeLine(`Loaded safelist from types map file '${this.typesMapLocation}'`),this.safeList=e;return}this.log.writeLine(`Failed to load safelist from types map file '${this.typesMapLocation}'`)}this.safeList=sh.loadSafeList(this.installTypingHost,this.safeListPath)}processCacheLocation(e){if(this.log.isEnabled()&&this.log.writeLine(`Processing cache location '${e}'`),this.knownCachesSet.has(e)){this.log.isEnabled()&&this.log.writeLine("Cache location was already processed...");return}let t=li(e,"package.json"),n=li(e,"package-lock.json");if(this.log.isEnabled()&&this.log.writeLine(`Trying to find '${t}'...`),this.installTypingHost.fileExists(t)&&this.installTypingHost.fileExists(n)){let i=JSON.parse(this.installTypingHost.readFile(t)),s=JSON.parse(this.installTypingHost.readFile(n));if(this.log.isEnabled()&&(this.log.writeLine(`Loaded content of '${t}':${LT(i)}`),this.log.writeLine(`Loaded content of '${n}':${LT(s)}`)),i.devDependencies&&s.dependencies)for(let o in i.devDependencies){if(!wo(s.dependencies,o))continue;let l=Cl(o);if(!l)continue;let p=aqe(e,l,this.installTypingHost,this.log);if(!p){this.missingTypingsSet.add(l);continue}let m=this.packageNameToTypingLocation.get(l);if(m){if(m.typingLocation===p)continue;this.log.isEnabled()&&this.log.writeLine(`New typing for package ${l} from '${p}' conflicts with existing typing file '${m}'`)}this.log.isEnabled()&&this.log.writeLine(`Adding entry into typings cache: '${l}' => '${p}'`);let S=Ar(s.dependencies,o),h=S&&S.version;if(!h)continue;let b={typingLocation:p,version:new Im(h)};this.packageNameToTypingLocation.set(l,b)}}this.log.isEnabled()&&this.log.writeLine(`Finished processing cache location '${e}'`),this.knownCachesSet.add(e)}filterTypings(e){return Wi(e,t=>{let n=cD(t);if(this.missingTypingsSet.has(n)){this.log.isEnabled()&&this.log.writeLine(`'${t}':: '${n}' is in missingTypingsSet - skipping...`);return}let i=sh.validatePackageName(t);if(i!==sh.NameValidationResult.Ok){this.missingTypingsSet.add(n),this.log.isEnabled()&&this.log.writeLine(sh.renderPackageNameValidationFailure(i,t));return}if(!this.typesRegistry.has(n)){this.log.isEnabled()&&this.log.writeLine(`'${t}':: Entry for package '${n}' does not exist in local types registry - skipping...`);return}if(this.packageNameToTypingLocation.get(n)&&sh.isTypingUpToDate(this.packageNameToTypingLocation.get(n),this.typesRegistry.get(n))){this.log.isEnabled()&&this.log.writeLine(`'${t}':: '${n}' already has an up-to-date typing - skipping...`);return}return n})}ensurePackageDirectoryExists(e){let t=li(e,"package.json");this.log.isEnabled()&&this.log.writeLine(`Npm config file: ${t}`),this.installTypingHost.fileExists(t)||(this.log.isEnabled()&&this.log.writeLine(`Npm config file: '${t}' is missing, creating new one...`),this.ensureDirectoryExists(e,this.installTypingHost),this.installTypingHost.writeFile(t,'{ "private": true }'))}installTypings(e,t,n,i){this.log.isEnabled()&&this.log.writeLine(`Installing typings ${JSON.stringify(i)}`);let s=this.filterTypings(i);if(s.length===0){this.log.isEnabled()&&this.log.writeLine("All typings are known to be missing or invalid - no need to install more typings"),this.sendResponse(this.createSetTypings(e,n));return}this.ensurePackageDirectoryExists(t);let o=this.installRunCount;this.installRunCount++,this.sendResponse({kind:WV,eventId:o,typingsInstallerVersion:F,projectName:e.projectName});let l=s.map(cqe);this.installTypingsAsync(o,l,t,p=>{try{if(!p){this.log.isEnabled()&&this.log.writeLine(`install request failed, marking packages as missing to prevent repeated requests: ${JSON.stringify(s)}`);for(let S of s)this.missingTypingsSet.add(S);return}this.log.isEnabled()&&this.log.writeLine(`Installed typings ${JSON.stringify(l)}`);let m=[];for(let S of s){let h=aqe(t,S,this.installTypingHost,this.log);if(!h){this.missingTypingsSet.add(S);continue}let b=this.typesRegistry.get(S),A=new Im(b[`ts${w}`]||b[this.latestDistTag]),k={typingLocation:h,version:A};this.packageNameToTypingLocation.set(S,k),m.push(h)}this.log.isEnabled()&&this.log.writeLine(`Installed typing files ${JSON.stringify(m)}`),this.sendResponse(this.createSetTypings(e,n.concat(m)))}finally{let m={kind:GV,eventId:o,projectName:e.projectName,packagesToInstall:l,installSuccess:p,typingsInstallerVersion:F};this.sendResponse(m)}})}ensureDirectoryExists(e,t){let n=hi(e);t.directoryExists(n)||this.ensureDirectoryExists(n,t),t.directoryExists(e)||t.createDirectory(e)}watchFiles(e,t){if(!t.length){this.closeWatchers(e);return}let n=this.projectWatchers.get(e),i=new Set(t);!n||Mh(i,s=>!n.has(s))||Mh(n,s=>!i.has(s))?(this.projectWatchers.set(e,i),this.sendResponse({kind:TO,projectName:e,files:t})):this.sendResponse({kind:TO,projectName:e,files:void 0})}createSetTypings(e,t){return{projectName:e.projectName,typeAcquisition:e.typeAcquisition,compilerOptions:e.compilerOptions,typings:t,unresolvedImports:e.unresolvedImports,kind:BM}}installTypingsAsync(e,t,n,i){this.pendingRunRequests.unshift({requestId:e,packageNames:t,cwd:n,onRequestCompleted:i}),this.executeWithThrottling()}executeWithThrottling(){for(;this.inFlightRequestCount<this.throttleLimit&&this.pendingRunRequests.length;){this.inFlightRequestCount++;let e=this.pendingRunRequests.pop();this.installWorker(e.requestId,e.packageNames,e.cwd,t=>{this.inFlightRequestCount--,e.onRequestCompleted(t),this.executeWithThrottling()})}}}}}),t2e={};x(t2e,{TypingsInstaller:()=>uqe,getNpmCommandForInstallation:()=>oqe,installNpmPackages:()=>z3t,typingsName:()=>cqe});var W3t=f({"src/typingsInstallerCore/_namespaces/ts.server.typingsInstaller.ts"(){"use strict";$3t()}}),r2e=f({"src/typingsInstallerCore/_namespaces/ts.server.ts"(){"use strict";HV(),W3t()}}),G3t=f({"src/server/types.ts"(){"use strict"}});function n2e(e,t,n,i){return{projectName:e.getProjectName(),fileNames:e.getFileNames(!0,!0).concat(e.getExcludedFiles()),compilerOptions:e.getCompilationSettings(),typeAcquisition:t,unresolvedImports:n,projectRootPath:e.getCurrentDirectory(),cachePath:i,kind:"discover"}}function Cc(e){return Ca(e)}function eL(e,t,n){let i=ap(e)?e:Ps(e,t);return n(i)}function _qe(e){return e}function fqe(){let e=new Map;return{get(t){return e.get(t)},set(t,n){e.set(t,n)},contains(t){return e.has(t)},remove(t){e.delete(t)}}}function i2e(e){return/dev\/null\/inferredProject\d+\*/.test(e)}function s2e(e){return`/dev/null/inferredProject${e}*`}function a2e(e){return`/dev/null/autoImportProviderProject${e}*`}function o2e(e){return`/dev/null/auxiliaryProject${e}*`}function c2e(){return[]}var dse,Vl,mse,G1,H3t=f({"src/server/utilitiesPublic.ts"(){"use strict";uS(),dse=(e=>(e[e.terse=0]="terse",e[e.normal=1]="normal",e[e.requestTime=2]="requestTime",e[e.verbose=3]="verbose",e))(dse||{}),Vl=c2e(),mse=(e=>(e.Err="Err",e.Info="Info",e.Perf="Perf",e))(mse||{}),(e=>{function t(){throw new Error("No Project.")}e.ThrowNoProject=t;function n(){throw new Error("The project's language service is disabled.")}e.ThrowProjectLanguageServiceDisabled=n;function i(s,o){throw new Error(`Project '${o.getProjectName()}' does not contain document '${s}'`)}e.ThrowProjectDoesNotContainDocument=i})(G1||(G1={}))}});function gse(e){let t=Cl(e);return t==="tsconfig.json"||t==="jsconfig.json"?t:void 0}function pqe(e,t,n){if(!e||e.length===0)return;if(e[0]===t){e.splice(0,1);return}let i=Bg(e,t,Mo,n);i>=0&&e.splice(i,1)}var hse,yse,Y3t=f({"src/server/utilities.ts"(){"use strict";uS(),Mx(),hse=class zdt{constructor(t,n){this.host=t,this.pendingTimeouts=new Map,this.logger=n.hasLevel(3)?n:void 0}schedule(t,n,i){let s=this.pendingTimeouts.get(t);s&&this.host.clearTimeout(s),this.pendingTimeouts.set(t,this.host.setTimeout(zdt.run,n,t,this,i)),this.logger&&this.logger.info(`Scheduled: ${t}${s?", Cancelled earlier one":""}`)}cancel(t){let n=this.pendingTimeouts.get(t);return n?(this.host.clearTimeout(n),this.pendingTimeouts.delete(t)):!1}static run(t,n,i){var s,o;(s=z_)==null||s.logStartScheduledOperation(t),n.pendingTimeouts.delete(t),n.logger&&n.logger.info(`Running: ${t}`),i(),(o=z_)==null||o.logStopScheduledOperation()}},yse=class $dt{constructor(t,n,i){this.host=t,this.delay=n,this.logger=i}scheduleCollect(){!this.host.gc||this.timerId!==void 0||(this.timerId=this.host.setTimeout($dt.run,this.delay,this))}static run(t){var n,i;t.timerId=void 0,(n=z_)==null||n.logStartScheduledOperation("GC collect");let s=t.logger.hasLevel(2),o=s&&t.host.getMemoryUsage();if(t.host.gc(),s){let l=t.host.getMemoryUsage();t.logger.perftrc(`GC::before ${o}, after ${l}`)}(i=z_)==null||i.logStopScheduledOperation()}}}}),vse,l2e,u2e,_2e,f2e,p2e,d2e,m2e,g2e,h2e,y2e,v2e,S2e,T2e,b2e=f({"src/server/protocol.ts"(){"use strict";vse=(e=>(e.JsxClosingTag="jsxClosingTag",e.LinkedEditingRange="linkedEditingRange",e.Brace="brace",e.BraceFull="brace-full",e.BraceCompletion="braceCompletion",e.GetSpanOfEnclosingComment="getSpanOfEnclosingComment",e.Change="change",e.Close="close",e.Completions="completions",e.CompletionInfo="completionInfo",e.CompletionsFull="completions-full",e.CompletionDetails="completionEntryDetails",e.CompletionDetailsFull="completionEntryDetails-full",e.CompileOnSaveAffectedFileList="compileOnSaveAffectedFileList",e.CompileOnSaveEmitFile="compileOnSaveEmitFile",e.Configure="configure",e.Definition="definition",e.DefinitionFull="definition-full",e.DefinitionAndBoundSpan="definitionAndBoundSpan",e.DefinitionAndBoundSpanFull="definitionAndBoundSpan-full",e.Implementation="implementation",e.ImplementationFull="implementation-full",e.EmitOutput="emit-output",e.Exit="exit",e.FileReferences="fileReferences",e.FileReferencesFull="fileReferences-full",e.Format="format",e.Formatonkey="formatonkey",e.FormatFull="format-full",e.FormatonkeyFull="formatonkey-full",e.FormatRangeFull="formatRange-full",e.Geterr="geterr",e.GeterrForProject="geterrForProject",e.SemanticDiagnosticsSync="semanticDiagnosticsSync",e.SyntacticDiagnosticsSync="syntacticDiagnosticsSync",e.SuggestionDiagnosticsSync="suggestionDiagnosticsSync",e.NavBar="navbar",e.NavBarFull="navbar-full",e.Navto="navto",e.NavtoFull="navto-full",e.NavTree="navtree",e.NavTreeFull="navtree-full",e.DocumentHighlights="documentHighlights",e.DocumentHighlightsFull="documentHighlights-full",e.Open="open",e.Quickinfo="quickinfo",e.QuickinfoFull="quickinfo-full",e.References="references",e.ReferencesFull="references-full",e.Reload="reload",e.Rename="rename",e.RenameInfoFull="rename-full",e.RenameLocationsFull="renameLocations-full",e.Saveto="saveto",e.SignatureHelp="signatureHelp",e.SignatureHelpFull="signatureHelp-full",e.FindSourceDefinition="findSourceDefinition",e.Status="status",e.TypeDefinition="typeDefinition",e.ProjectInfo="projectInfo",e.ReloadProjects="reloadProjects",e.Unknown="unknown",e.OpenExternalProject="openExternalProject",e.OpenExternalProjects="openExternalProjects",e.CloseExternalProject="closeExternalProject",e.SynchronizeProjectList="synchronizeProjectList",e.ApplyChangedToOpenFiles="applyChangedToOpenFiles",e.UpdateOpen="updateOpen",e.EncodedSyntacticClassificationsFull="encodedSyntacticClassifications-full",e.EncodedSemanticClassificationsFull="encodedSemanticClassifications-full",e.Cleanup="cleanup",e.GetOutliningSpans="getOutliningSpans",e.GetOutliningSpansFull="outliningSpans",e.TodoComments="todoComments",e.Indentation="indentation",e.DocCommentTemplate="docCommentTemplate",e.CompilerOptionsDiagnosticsFull="compilerOptionsDiagnostics-full",e.NameOrDottedNameSpan="nameOrDottedNameSpan",e.BreakpointStatement="breakpointStatement",e.CompilerOptionsForInferredProjects="compilerOptionsForInferredProjects",e.GetCodeFixes="getCodeFixes",e.GetCodeFixesFull="getCodeFixes-full",e.GetCombinedCodeFix="getCombinedCodeFix",e.GetCombinedCodeFixFull="getCombinedCodeFix-full",e.ApplyCodeActionCommand="applyCodeActionCommand",e.GetSupportedCodeFixes="getSupportedCodeFixes",e.GetApplicableRefactors="getApplicableRefactors",e.GetEditsForRefactor="getEditsForRefactor",e.GetMoveToRefactoringFileSuggestions="getMoveToRefactoringFileSuggestions",e.GetEditsForRefactorFull="getEditsForRefactor-full",e.OrganizeImports="organizeImports",e.OrganizeImportsFull="organizeImports-full",e.GetEditsForFileRename="getEditsForFileRename",e.GetEditsForFileRenameFull="getEditsForFileRename-full",e.ConfigurePlugin="configurePlugin",e.SelectionRange="selectionRange",e.SelectionRangeFull="selectionRange-full",e.ToggleLineComment="toggleLineComment",e.ToggleLineCommentFull="toggleLineComment-full",e.ToggleMultilineComment="toggleMultilineComment",e.ToggleMultilineCommentFull="toggleMultilineComment-full",e.CommentSelection="commentSelection",e.CommentSelectionFull="commentSelection-full",e.UncommentSelection="uncommentSelection",e.UncommentSelectionFull="uncommentSelection-full",e.PrepareCallHierarchy="prepareCallHierarchy",e.ProvideCallHierarchyIncomingCalls="provideCallHierarchyIncomingCalls",e.ProvideCallHierarchyOutgoingCalls="provideCallHierarchyOutgoingCalls",e.ProvideInlayHints="provideInlayHints",e.WatchChange="watchChange",e))(vse||{}),l2e=(e=>(e.All="All",e.SortAndCombine="SortAndCombine",e.RemoveUnused="RemoveUnused",e))(l2e||{}),u2e=(e=>(e.FixedPollingInterval="FixedPollingInterval",e.PriorityPollingInterval="PriorityPollingInterval",e.DynamicPriorityPolling="DynamicPriorityPolling",e.FixedChunkSizePolling="FixedChunkSizePolling",e.UseFsEvents="UseFsEvents",e.UseFsEventsOnParentDirectory="UseFsEventsOnParentDirectory",e))(u2e||{}),_2e=(e=>(e.UseFsEvents="UseFsEvents",e.FixedPollingInterval="FixedPollingInterval",e.DynamicPriorityPolling="DynamicPriorityPolling",e.FixedChunkSizePolling="FixedChunkSizePolling",e))(_2e||{}),f2e=(e=>(e.FixedInterval="FixedInterval",e.PriorityInterval="PriorityInterval",e.DynamicPriority="DynamicPriority",e.FixedChunkSize="FixedChunkSize",e))(f2e||{}),p2e=(e=>(e[e.Invoked=1]="Invoked",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=3]="TriggerForIncompleteCompletions",e))(p2e||{}),d2e=(e=>(e.None="None",e.Block="Block",e.Smart="Smart",e))(d2e||{}),m2e=(e=>(e.Ignore="ignore",e.Insert="insert",e.Remove="remove",e))(m2e||{}),g2e=(e=>(e.None="None",e.Preserve="Preserve",e.ReactNative="ReactNative",e.React="React",e))(g2e||{}),h2e=(e=>(e.None="None",e.CommonJS="CommonJS",e.AMD="AMD",e.UMD="UMD",e.System="System",e.ES6="ES6",e.ES2015="ES2015",e.ESNext="ESNext",e.Node16="Node16",e.NodeNext="NodeNext",e.Preserve="Preserve",e))(h2e||{}),y2e=(e=>(e.Classic="Classic",e.Node="Node",e.Node10="Node10",e.Node16="Node16",e.NodeNext="NodeNext",e.Bundler="Bundler",e))(y2e||{}),v2e=(e=>(e.Crlf="Crlf",e.Lf="Lf",e))(v2e||{}),S2e=(e=>(e.ES3="ES3",e.ES5="ES5",e.ES6="ES6",e.ES2015="ES2015",e.ES2016="ES2016",e.ES2017="ES2017",e.ES2018="ES2018",e.ES2019="ES2019",e.ES2020="ES2020",e.ES2021="ES2021",e.ES2022="ES2022",e.ESNext="ESNext",e))(S2e||{}),T2e=(e=>(e[e.comment=1]="comment",e[e.identifier=2]="identifier",e[e.keyword=3]="keyword",e[e.numericLiteral=4]="numericLiteral",e[e.operator=5]="operator",e[e.stringLiteral=6]="stringLiteral",e[e.regularExpressionLiteral=7]="regularExpressionLiteral",e[e.whiteSpace=8]="whiteSpace",e[e.text=9]="text",e[e.punctuation=10]="punctuation",e[e.className=11]="className",e[e.enumName=12]="enumName",e[e.interfaceName=13]="interfaceName",e[e.moduleName=14]="moduleName",e[e.typeParameterName=15]="typeParameterName",e[e.typeAliasName=16]="typeAliasName",e[e.parameterName=17]="parameterName",e[e.docCommentTagName=18]="docCommentTagName",e[e.jsxOpenTagName=19]="jsxOpenTagName",e[e.jsxCloseTagName=20]="jsxCloseTagName",e[e.jsxSelfClosingTagName=21]="jsxSelfClosingTagName",e[e.jsxAttribute=22]="jsxAttribute",e[e.jsxText=23]="jsxText",e[e.jsxAttributeStringLiteralValue=24]="jsxAttributeStringLiteralValue",e[e.bigintLiteral=25]="bigintLiteral",e))(T2e||{})}}),E2e={};x(E2e,{ClassificationType:()=>T2e,CommandTypes:()=>vse,CompletionTriggerKind:()=>p2e,IndentStyle:()=>d2e,JsxEmit:()=>g2e,ModuleKind:()=>h2e,ModuleResolutionKind:()=>y2e,NewLineKind:()=>v2e,OrganizeImportsMode:()=>l2e,PollingWatchKind:()=>f2e,ScriptTarget:()=>S2e,SemicolonPreference:()=>m2e,WatchDirectoryKind:()=>_2e,WatchFileKind:()=>u2e});var X3t=f({"src/server/_namespaces/ts.server.protocol.ts"(){"use strict";b2e()}});function tL(e){return e[0]==="^"||(e.includes("walkThroughSnippet:/")||e.includes("untitled:/"))&&Cl(e)[0]==="^"||e.includes(":^")&&!e.includes(hc)}function dqe(e){return!e||nL(e)?G1.ThrowNoProject():e}function K3t(e){I.assert(typeof e=="number",`Expected position ${e} to be a number.`),I.assert(e>=0,"Expected position to be non-negative.")}function Q3t(e){I.assert(typeof e.line=="number",`Expected line ${e.line} to be a number.`),I.assert(typeof e.offset=="number",`Expected offset ${e.offset} to be a number.`),I.assert(e.line>0,`Expected line to be non-${e.line===0?"zero":"negative"}`),I.assert(e.offset>0,`Expected offset to be non-${e.offset===0?"zero":"negative"}`)}var Sse,Tse,Z3t=f({"src/server/scriptInfo.ts"(){"use strict";uS(),Mx(),Sse=class{constructor(e,t,n){this.host=e,this.info=t,this.isOpen=!1,this.ownFileText=!1,this.pendingReloadFromDisk=!1,this.version=n||0}getVersion(){return this.svc?`SVC-${this.version}-${this.svc.getSnapshotVersion()}`:`Text-${this.version}`}hasScriptVersionCache_TestOnly(){return this.svc!==void 0}resetSourceMapInfo(){this.info.sourceFileLike=void 0,this.info.closeSourceMapFileWatcher(),this.info.sourceMapFilePath=void 0,this.info.declarationInfoPath=void 0,this.info.sourceInfos=void 0,this.info.documentPositionMapper=void 0}useText(e){this.svc=void 0,this.text=e,this.textSnapshot=void 0,this.lineMap=void 0,this.fileSize=void 0,this.resetSourceMapInfo(),this.version++}edit(e,t,n){this.switchToScriptVersionCache().edit(e,t-e,n),this.ownFileText=!1,this.text=void 0,this.textSnapshot=void 0,this.lineMap=void 0,this.fileSize=void 0,this.resetSourceMapInfo()}reload(e){return I.assert(e!==void 0),this.pendingReloadFromDisk=!1,!this.text&&this.svc&&(this.text=ED(this.svc.getSnapshot())),this.text!==e?(this.useText(e),this.ownFileText=!1,!0):!1}reloadWithFileText(e){let{text:t,fileSize:n}=e||!this.info.isDynamicOrHasMixedContent()?this.getFileTextAndSize(e):{text:"",fileSize:void 0},i=this.reload(t);return this.fileSize=n,this.ownFileText=!e||e===this.info.fileName,i}scheduleReloadIfNeeded(){return!this.pendingReloadFromDisk&&!this.ownFileText?this.pendingReloadFromDisk=!0:!1}delayReloadFromFileIntoText(){this.pendingReloadFromDisk=!0}getTelemetryFileSize(){return this.fileSize?this.fileSize:this.text?this.text.length:this.svc?this.svc.getSnapshot().getLength():this.getSnapshot().getLength()}getSnapshot(){var e;return((e=this.tryUseScriptVersionCache())==null?void 0:e.getSnapshot())||(this.textSnapshot??(this.textSnapshot=XV.fromString(I.checkDefined(this.text))))}getAbsolutePositionAndLineText(e){let t=this.tryUseScriptVersionCache();if(t)return t.getAbsolutePositionAndLineText(e);let n=this.getLineMap();return e<=n.length?{absolutePosition:n[e-1],lineText:this.text.substring(n[e-1],n[e])}:{absolutePosition:this.text.length,lineText:void 0}}lineToTextSpan(e){let t=this.tryUseScriptVersionCache();if(t)return t.lineToTextSpan(e);let n=this.getLineMap(),i=n[e],s=e+1<n.length?n[e+1]:this.text.length;return Ll(i,s)}lineOffsetToPosition(e,t,n){let i=this.tryUseScriptVersionCache();return i?i.lineOffsetToPosition(e,t):m9(this.getLineMap(),e-1,t-1,this.text,n)}positionToLineOffset(e){let t=this.tryUseScriptVersionCache();if(t)return t.positionToLineOffset(e);let{line:n,character:i}=zP(this.getLineMap(),e);return{line:n+1,offset:i+1}}getFileTextAndSize(e){let t,n=e||this.info.fileName,i=()=>t===void 0?t=this.host.readFile(n)||"":t;if(!LA(this.info.fileName)){let s=this.host.getFileSize?this.host.getFileSize(n):i().length;if(s>Xq)return I.assert(!!this.info.containingProjects.length),this.info.containingProjects[0].projectService.logger.info(`Skipped loading contents of large file ${n} for info ${this.info.fileName}: fileSize: ${s}`),this.info.containingProjects[0].projectService.sendLargeFileReferencedEvent(n,s),{text:"",fileSize:s}}return{text:i()}}switchToScriptVersionCache(){return(!this.svc||this.pendingReloadFromDisk)&&(this.svc=lz.fromString(this.getOrLoadText()),this.textSnapshot=void 0,this.version++),this.svc}tryUseScriptVersionCache(){return(!this.svc||this.pendingReloadFromDisk)&&this.getOrLoadText(),this.isOpen?(!this.svc&&!this.textSnapshot&&(this.svc=lz.fromString(I.checkDefined(this.text)),this.textSnapshot=void 0),this.svc):this.svc}getOrLoadText(){return(this.text===void 0||this.pendingReloadFromDisk)&&(I.assert(!this.svc||this.pendingReloadFromDisk,"ScriptVersionCache should not be set when reloading from disk"),this.reloadWithFileText()),this.text}getLineMap(){return I.assert(!this.svc,"ScriptVersionCache should not be set"),this.lineMap||(this.lineMap=mA(I.checkDefined(this.text)))}getLineInfo(){let e=this.tryUseScriptVersionCache();if(e)return{getLineCount:()=>e.getLineCount(),getLineText:n=>e.getAbsolutePositionAndLineText(n+1).lineText};let t=this.getLineMap();return iZ(this.text,t)}},Tse=class{constructor(e,t,n,i,s,o){this.host=e,this.fileName=t,this.scriptKind=n,this.hasMixedContent=i,this.path=s,this.containingProjects=[],this.isDynamic=tL(t),this.textStorage=new Sse(e,this,o),(i||this.isDynamic)&&(this.realpath=this.path),this.scriptKind=n||eB(t)}isDynamicOrHasMixedContent(){return this.hasMixedContent||this.isDynamic}isScriptOpen(){return this.textStorage.isOpen}open(e){this.textStorage.isOpen=!0,e!==void 0&&this.textStorage.reload(e)&&this.markContainingProjectsAsDirty()}close(e=!0){this.textStorage.isOpen=!1,e&&this.textStorage.scheduleReloadIfNeeded()&&this.markContainingProjectsAsDirty()}getSnapshot(){return this.textStorage.getSnapshot()}ensureRealPath(){if(this.realpath===void 0&&(this.realpath=this.path,this.host.realpath)){I.assert(!!this.containingProjects.length);let e=this.containingProjects[0],t=this.host.realpath(this.path);t&&(this.realpath=e.toPath(t),this.realpath!==this.path&&e.projectService.realpathToScriptInfos.add(this.realpath,this))}}getRealpathIfDifferent(){return this.realpath&&this.realpath!==this.path?this.realpath:void 0}isSymlink(){return this.realpath&&this.realpath!==this.path}getFormatCodeSettings(){return this.formatSettings}getPreferences(){return this.preferences}attachToProject(e){let t=!this.isAttached(e);return t&&(this.containingProjects.push(e),e.getCompilerOptions().preserveSymlinks||this.ensureRealPath(),e.onFileAddedOrRemoved(this.isSymlink())),t}isAttached(e){switch(this.containingProjects.length){case 0:return!1;case 1:return this.containingProjects[0]===e;case 2:return this.containingProjects[0]===e||this.containingProjects[1]===e;default:return hs(this.containingProjects,e)}}detachFromProject(e){switch(this.containingProjects.length){case 0:return;case 1:this.containingProjects[0]===e&&(e.onFileAddedOrRemoved(this.isSymlink()),this.containingProjects.pop());break;case 2:this.containingProjects[0]===e?(e.onFileAddedOrRemoved(this.isSymlink()),this.containingProjects[0]=this.containingProjects.pop()):this.containingProjects[1]===e&&(e.onFileAddedOrRemoved(this.isSymlink()),this.containingProjects.pop());break;default:lA(this.containingProjects,e)&&e.onFileAddedOrRemoved(this.isSymlink());break}}detachAllProjects(){for(let e of this.containingProjects){JT(e)&&e.getCachedDirectoryStructureHost().addOrDeleteFile(this.fileName,this.path,2);let t=e.getRootFilesMap().get(this.path);e.removeFile(this,!1,!1),e.onFileAddedOrRemoved(this.isSymlink()),t&&!$D(e)&&e.addMissingFileRoot(t.fileName)}ed(this.containingProjects)}getDefaultProject(){switch(this.containingProjects.length){case 0:return G1.ThrowNoProject();case 1:return dqe(this.containingProjects[0]);default:let e,t,n,i,s;for(let o=0;o<this.containingProjects.length;o++){let l=this.containingProjects[o];if(JT(l)){if(!l.isSourceOfProjectReferenceRedirect(this.fileName)){if(s===void 0&&o!==this.containingProjects.length-1&&(s=l.projectService.findDefaultConfiguredProject(this)||!1),s===l)return l;i||(i=l)}t||(t=l)}else!e&&Ese(l)?e=l:!n&&$D(l)&&(n=l)}return dqe(s||i||t||e||n)}}registerFileUpdate(){for(let e of this.containingProjects)e.registerFileUpdate(this.path)}setOptions(e,t){e&&(this.formatSettings?this.formatSettings={...this.formatSettings,...e}:(this.formatSettings=YV(this.host.newLine),ec(this.formatSettings,e))),t&&(this.preferences||(this.preferences=Md),this.preferences={...this.preferences,...t})}getLatestVersion(){return this.textStorage.getSnapshot(),this.textStorage.getVersion()}saveTo(e){this.host.writeFile(e,ED(this.textStorage.getSnapshot()))}delayReloadNonMixedContentFile(){I.assert(!this.isDynamicOrHasMixedContent()),this.textStorage.delayReloadFromFileIntoText(),this.markContainingProjectsAsDirty()}reloadFromFile(e){return this.textStorage.reloadWithFileText(e)?(this.markContainingProjectsAsDirty(),!0):!1}editContent(e,t,n){this.textStorage.edit(e,t,n),this.markContainingProjectsAsDirty()}markContainingProjectsAsDirty(){for(let e of this.containingProjects)e.markFileAsDirty(this.path)}isOrphan(){return!Te(this.containingProjects,e=>!e.isOrphan())}isContainedByBackgroundProject(){return Tt(this.containingProjects,nL)}lineToTextSpan(e){return this.textStorage.lineToTextSpan(e)}lineOffsetToPosition(e,t,n){return this.textStorage.lineOffsetToPosition(e,t,n)}positionToLineOffset(e){K3t(e);let t=this.textStorage.positionToLineOffset(e);return Q3t(t),t}isJavaScript(){return this.scriptKind===1||this.scriptKind===2}closeSourceMapFileWatcher(){this.sourceMapFilePath&&!vs(this.sourceMapFilePath)&&(Od(this.sourceMapFilePath),this.sourceMapFilePath=void 0)}}}});function mqe(e,t){if(e===t||(e||Vl).length===0&&(t||Vl).length===0)return!0;let n=new Map,i=0;for(let s of e)n.get(s)!==!0&&(n.set(s,!0),i++);for(let s of t){let o=n.get(s);if(o===void 0)return!1;o===!0&&(n.set(s,!1),i--)}return i===0}function e8t(e,t){return e.enable!==t.enable||!mqe(e.include,t.include)||!mqe(e.exclude,t.exclude)}function t8t(e,t){return Hv(e)!==Hv(t)}function r8t(e,t){return e===t?!1:!td(e,t)}var Wq,bse,n8t=f({"src/server/typingsCache.ts"(){"use strict";uS(),Mx(),Wq={isKnownTypesPackageName:qf,installPackage:Ks,enqueueInstallTypingsRequest:ja,attach:ja,onProjectClosed:ja,globalTypingsCacheLocation:void 0},bse=class{constructor(e){this.installer=e,this.perProjectCache=new Map}isKnownTypesPackageName(e){return this.installer.isKnownTypesPackageName(e)}installPackage(e){return this.installer.installPackage(e)}enqueueInstallTypingsForProject(e,t,n){let i=e.getTypeAcquisition();if(!i||!i.enable)return;let s=this.perProjectCache.get(e.getProjectName());(n||!s||e8t(i,s.typeAcquisition)||t8t(e.getCompilationSettings(),s.compilerOptions)||r8t(t,s.unresolvedImports))&&(this.perProjectCache.set(e.getProjectName(),{compilerOptions:e.getCompilationSettings(),typeAcquisition:i,typings:s?s.typings:Vl,unresolvedImports:t,poisoned:!0}),this.installer.enqueueInstallTypingsRequest(e,i,t))}updateTypingsForProject(e,t,n,i,s){let o=Fa(s);return this.perProjectCache.set(e,{compilerOptions:t,typeAcquisition:n,typings:o,unresolvedImports:i,poisoned:!1}),!n||!n.enable?Vl:o}onProjectClosed(e){this.perProjectCache.delete(e.getProjectName())&&this.installer.onProjectClosed(e)}}}});function rL(e,t=!1){let n={js:0,jsSize:0,jsx:0,jsxSize:0,ts:0,tsSize:0,tsx:0,tsxSize:0,dts:0,dtsSize:0,deferred:0,deferredSize:0};for(let i of e){let s=t?i.textStorage.getTelemetryFileSize():0;switch(i.scriptKind){case 1:n.js+=1,n.jsSize+=s;break;case 2:n.jsx+=1,n.jsxSize+=s;break;case 3:i_(i.fileName)?(n.dts+=1,n.dtsSize+=s):(n.ts+=1,n.tsSize+=s);break;case 4:n.tsx+=1,n.tsxSize+=s;break;case 7:n.deferred+=1,n.deferredSize+=s;break}}return n}function i8t(e){let t=rL(e.getScriptInfos());return t.js>0&&t.ts===0&&t.tsx===0}function x2e(e){let t=rL(e.getRootScriptInfos());return t.ts===0&&t.tsx===0}function C2e(e){let t=rL(e.getScriptInfos());return t.ts===0&&t.tsx===0}function A2e(e){return!e.some(t=>Uc(t,".ts")&&!i_(t)||Uc(t,".tsx"))}function k2e(e){return e.generatedFilePath!==void 0}function s8t(e,t){var n,i;let s=e.getSourceFiles();(n=mn)==null||n.push(mn.Phase.Session,"getUnresolvedImports",{count:s.length});let o=e.getTypeChecker().getAmbientModules().map(p=>cm(p.getName())),l=rT(_a(s,p=>a8t(e,p,o,t)));return(i=mn)==null||i.pop(),l}function a8t(e,t,n,i){return km(i,t.path,()=>{let s;return e.forEachResolvedModule(({resolvedModule:o},l)=>{(!o||!g6(o.extension))&&!Nu(l)&&!n.some(p=>p===l)&&(s=Pr(s,mM(l).packageName))},t),s||Vl})}function $D(e){return e.projectKind===0}function JT(e){return e.projectKind===1}function Ese(e){return e.projectKind===2}function nL(e){return e.projectKind===3||e.projectKind===4}var GO,Rx,xse,Cse,Ase,kse,Pse,Gq,o8t=f({"src/server/project.ts"(){"use strict";uS(),uS(),Mx(),GO=(e=>(e[e.Inferred=0]="Inferred",e[e.Configured=1]="Configured",e[e.External=2]="External",e[e.AutoImportProvider=3]="AutoImportProvider",e[e.Auxiliary=4]="Auxiliary",e))(GO||{}),Rx=class Wdt{constructor(t,n,i,s,o,l,p,m,S,h,b){switch(this.projectKind=n,this.projectService=i,this.documentRegistry=s,this.compilerOptions=p,this.compileOnSaveEnabled=m,this.watchOptions=S,this.rootFiles=[],this.rootFilesMap=new Map,this.plugins=[],this.cachedUnresolvedImportsPerFile=new Map,this.hasAddedorRemovedFiles=!1,this.hasAddedOrRemovedSymlinks=!1,this.lastReportedVersion=0,this.projectProgramVersion=0,this.projectStateVersion=0,this.isInitialLoadPending=qf,this.dirty=!1,this.typingFiles=Vl,this.moduleSpecifierCache=B2e(this),this.createHash=rs(this.projectService.host,this.projectService.host.createHash),this.globalCacheResolutionModuleName=sh.nonRelativeModuleNameForTypingCache,this.updateFromProjectInProgress=!1,this.projectName=t,this.directoryStructureHost=h,this.currentDirectory=this.projectService.getNormalizedAbsolutePath(b),this.getCanonicalFileName=this.projectService.toCanonicalFileName,this.jsDocParsingMode=this.projectService.jsDocParsingMode,this.cancellationToken=new rne(this.projectService.cancellationToken,this.projectService.throttleWaitMilliseconds),this.compilerOptions?(o||Hv(this.compilerOptions)||this.projectService.hasDeferredExtension())&&(this.compilerOptions.allowNonTsExtensions=!0):(this.compilerOptions=_q(),this.compilerOptions.allowNonTsExtensions=!0,this.compilerOptions.allowJs=!0),i.serverMode){case 0:this.languageServiceEnabled=!0;break;case 1:this.languageServiceEnabled=!0,this.compilerOptions.noResolve=!0,this.compilerOptions.types=[];break;case 2:this.languageServiceEnabled=!1,this.compilerOptions.noResolve=!0,this.compilerOptions.types=[];break;default:I.assertNever(i.serverMode)}this.setInternalCompilerOptionsForEmittingJsFiles();let A=this.projectService.host;this.projectService.logger.loggingEnabled()?this.trace=k=>this.writeLog(k):A.trace&&(this.trace=k=>A.trace(k)),this.realpath=rs(A,A.realpath),this.resolutionCache=_ee(this,this.currentDirectory,!0),this.languageService=ySe(this,this.documentRegistry,this.projectService.serverMode),l&&this.disableLanguageService(l),this.markAsDirty(),nL(this)||(this.projectService.pendingEnsureProjectForOpenFiles=!0),this.projectService.onProjectCreation(this)}getResolvedProjectReferenceToRedirect(t){}isNonTsProject(){return qp(this),C2e(this)}isJsOnlyProject(){return qp(this),i8t(this)}static resolveModule(t,n,i,s){return Wdt.importServicePluginSync({name:t},[n],i,s).resolvedModule}static importServicePluginSync(t,n,i,s){I.assertIsDefined(i.require);let o,l;for(let p of n){let m=v_(i.resolvePath(li(p,"node_modules")));s(`Loading ${t.name} from ${p} (resolved to ${m})`);let S=i.require(m,t.name);if(!S.error){l=S.module;break}let h=S.error.stack||S.error.message||JSON.stringify(S.error);(o??(o=[])).push(`Failed to load module '${t.name}' from ${m}: ${h}`)}return{pluginConfigEntry:t,resolvedModule:l,errorLogs:o}}static async importServicePluginAsync(t,n,i,s){I.assertIsDefined(i.importPlugin);let o,l;for(let p of n){let m=li(p,"node_modules");s(`Dynamically importing ${t.name} from ${p} (resolved to ${m})`);let S;try{S=await i.importPlugin(m,t.name)}catch(b){S={module:void 0,error:b}}if(!S.error){l=S.module;break}let h=S.error.stack||S.error.message||JSON.stringify(S.error);(o??(o=[])).push(`Failed to dynamically import module '${t.name}' from ${m}: ${h}`)}return{pluginConfigEntry:t,resolvedModule:l,errorLogs:o}}isKnownTypesPackageName(t){return this.typingsCache.isKnownTypesPackageName(t)}installPackage(t){return this.typingsCache.installPackage({...t,projectName:this.projectName,projectRootPath:this.toPath(this.currentDirectory)})}getGlobalTypingsCacheLocation(){return this.getGlobalCache()}get typingsCache(){return this.projectService.typingsCache}getSymlinkCache(){return this.symlinks||(this.symlinks=BX(this.getCurrentDirectory(),this.getCanonicalFileName)),this.program&&!this.symlinks.hasProcessedResolutions()&&this.symlinks.setSymlinksFromResolutions(this.program.forEachResolvedModule,this.program.forEachResolvedTypeReferenceDirective,this.program.getAutomaticTypeDirectiveResolutions()),this.symlinks}getCompilationSettings(){return this.compilerOptions}getCompilerOptions(){return this.getCompilationSettings()}getNewLine(){return this.projectService.host.newLine}getProjectVersion(){return this.projectStateVersion.toString()}getProjectReferences(){}getScriptFileNames(){if(!this.rootFiles)return tt;let t;return this.rootFilesMap.forEach(n=>{(this.languageServiceEnabled||n.info&&n.info.isScriptOpen())&&(t||(t=[])).push(n.fileName)}),jt(t,this.typingFiles)||tt}getOrCreateScriptInfoAndAttachToProject(t){let n=this.projectService.getOrCreateScriptInfoNotOpenedByClient(t,this.currentDirectory,this.directoryStructureHost);if(n){let i=this.rootFilesMap.get(n.path);i&&i.info!==n&&(this.rootFiles.push(n),i.info=n),n.attachToProject(this)}return n}getScriptKind(t){let n=this.projectService.getScriptInfoForPath(this.toPath(t));return n&&n.scriptKind}getScriptVersion(t){let n=this.projectService.getOrCreateScriptInfoNotOpenedByClient(t,this.currentDirectory,this.directoryStructureHost);return n&&n.getLatestVersion()}getScriptSnapshot(t){let n=this.getOrCreateScriptInfoAndAttachToProject(t);if(n)return n.getSnapshot()}getCancellationToken(){return this.cancellationToken}getCurrentDirectory(){return this.currentDirectory}getDefaultLibFileName(){let t=hi(Ca(this.projectService.getExecutingFilePath()));return li(t,W3(this.compilerOptions))}useCaseSensitiveFileNames(){return this.projectService.host.useCaseSensitiveFileNames}readDirectory(t,n,i,s,o){return this.directoryStructureHost.readDirectory(t,n,i,s,o)}readFile(t){return this.projectService.host.readFile(t)}writeFile(t,n){return this.projectService.host.writeFile(t,n)}fileExists(t){let n=this.toPath(t);return!this.isWatchedMissingFile(n)&&this.directoryStructureHost.fileExists(t)}resolveModuleNameLiterals(t,n,i,s,o,l){return this.resolutionCache.resolveModuleNameLiterals(t,n,i,s,o,l)}getModuleResolutionCache(){return this.resolutionCache.getModuleResolutionCache()}resolveTypeReferenceDirectiveReferences(t,n,i,s,o,l){return this.resolutionCache.resolveTypeReferenceDirectiveReferences(t,n,i,s,o,l)}resolveLibrary(t,n,i,s){return this.resolutionCache.resolveLibrary(t,n,i,s)}directoryExists(t){return this.directoryStructureHost.directoryExists(t)}getDirectories(t){return this.directoryStructureHost.getDirectories(t)}getCachedDirectoryStructureHost(){}toPath(t){return gc(t,this.currentDirectory,this.projectService.toCanonicalFileName)}watchDirectoryOfFailedLookupLocation(t,n,i){return this.projectService.watchFactory.watchDirectory(t,n,i,this.projectService.getWatchOptions(this),_u.FailedLookupLocations,this)}watchAffectingFileLocation(t,n){return this.projectService.watchFactory.watchFile(t,n,2e3,this.projectService.getWatchOptions(this),_u.AffectingFileLocation,this)}clearInvalidateResolutionOfFailedLookupTimer(){return this.projectService.throttledOperations.cancel(`${this.getProjectName()}FailedLookupInvalidation`)}scheduleInvalidateResolutionsOfFailedLookupLocations(){this.projectService.throttledOperations.schedule(`${this.getProjectName()}FailedLookupInvalidation`,1e3,()=>{this.resolutionCache.invalidateResolutionsOfFailedLookupLocations()&&this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this)})}invalidateResolutionsOfFailedLookupLocations(){this.clearInvalidateResolutionOfFailedLookupTimer()&&this.resolutionCache.invalidateResolutionsOfFailedLookupLocations()&&(this.markAsDirty(),this.projectService.delayEnsureProjectForOpenFiles())}onInvalidatedResolution(){this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this)}watchTypeRootsDirectory(t,n,i){return this.projectService.watchFactory.watchDirectory(t,n,i,this.projectService.getWatchOptions(this),_u.TypeRoots,this)}hasChangedAutomaticTypeDirectiveNames(){return this.resolutionCache.hasChangedAutomaticTypeDirectiveNames()}onChangedAutomaticTypeDirectiveNames(){this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this)}getGlobalCache(){return this.getTypeAcquisition().enable?this.projectService.typingsInstaller.globalTypingsCacheLocation:void 0}fileIsOpen(t){return this.projectService.openFiles.has(t)}writeLog(t){this.projectService.logger.info(t)}log(t){this.writeLog(t)}error(t){this.projectService.logger.msg(t,"Err")}setInternalCompilerOptionsForEmittingJsFiles(){(this.projectKind===0||this.projectKind===2)&&(this.compilerOptions.noEmitForJsFiles=!0)}getGlobalProjectErrors(){return Fn(this.projectErrors,t=>!t.file)||Vl}getAllProjectErrors(){return this.projectErrors||Vl}setProjectErrors(t){this.projectErrors=t}getLanguageService(t=!0){return t&&qp(this),this.languageService}getSourceMapper(){return this.getLanguageService().getSourceMapper()}clearSourceMapperCache(){this.languageService.clearSourceMapperCache()}getDocumentPositionMapper(t,n){return this.projectService.getDocumentPositionMapper(this,t,n)}getSourceFileLike(t){return this.projectService.getSourceFileLike(t,this)}shouldEmitFile(t){return t&&!t.isDynamicOrHasMixedContent()&&!this.program.isSourceOfProjectReferenceRedirect(t.path)}getCompileOnSaveAffectedFileList(t){return this.languageServiceEnabled?(qp(this),this.builderState=zm.create(this.program,this.builderState,!0),Wi(zm.getFilesAffectedBy(this.builderState,this.program,t.path,this.cancellationToken,this.projectService.host),n=>this.shouldEmitFile(this.projectService.getScriptInfoForPath(n.path))?n.fileName:void 0)):[]}emitFile(t,n){if(!this.languageServiceEnabled||!this.shouldEmitFile(t))return{emitSkipped:!0,diagnostics:Vl};let{emitSkipped:i,diagnostics:s,outputFiles:o}=this.getLanguageService().getEmitOutput(t.fileName);if(!i){for(let l of o){let p=Ps(l.name,this.currentDirectory);n(p,l.text,l.writeByteOrderMark)}if(this.builderState&&Dd(this.compilerOptions)){let l=o.filter(p=>i_(p.name));if(l.length===1){let p=this.program.getSourceFile(t.fileName),m=this.projectService.host.createHash?this.projectService.host.createHash(l[0].text):Sw(l[0].text);zm.updateSignatureOfFile(this.builderState,m,p.resolvedPath)}}}return{emitSkipped:i,diagnostics:s}}enableLanguageService(){this.languageServiceEnabled||this.projectService.serverMode===2||(this.languageServiceEnabled=!0,this.lastFileExceededProgramSize=void 0,this.projectService.onUpdateLanguageServiceStateForProject(this,!0))}cleanupProgram(){if(this.program){for(let t of this.program.getSourceFiles())this.detachScriptInfoIfNotRoot(t.fileName);this.program.forEachResolvedProjectReference(t=>this.detachScriptInfoFromProject(t.sourceFile.fileName)),this.program=void 0}}disableLanguageService(t){this.languageServiceEnabled&&(I.assert(this.projectService.serverMode!==2),this.languageService.cleanupSemanticCache(),this.languageServiceEnabled=!1,this.cleanupProgram(),this.lastFileExceededProgramSize=t,this.builderState=void 0,this.autoImportProviderHost&&this.autoImportProviderHost.close(),this.autoImportProviderHost=void 0,this.resolutionCache.closeTypeRootsWatch(),this.clearGeneratedFileWatch(),this.projectService.verifyDocumentRegistry(),this.projectService.onUpdateLanguageServiceStateForProject(this,!1))}getProjectName(){return this.projectName}removeLocalTypingsFromTypeAcquisition(t){return!t||!t.include?t:{...t,include:this.removeExistingTypings(t.include)}}getExternalFiles(t){return Fa(_a(this.plugins,n=>{if(typeof n.module.getExternalFiles=="function")try{return n.module.getExternalFiles(this,t||0)}catch(i){this.projectService.logger.info(`A plugin threw an exception in getExternalFiles: ${i}`),i.stack&&this.projectService.logger.info(i.stack)}}))}getSourceFile(t){if(this.program)return this.program.getSourceFileByPath(t)}getSourceFileOrConfigFile(t){let n=this.program.getCompilerOptions();return t===n.configFilePath?n.configFile:this.getSourceFile(t)}close(){var t;this.projectService.typingsCache.onProjectClosed(this),this.closeWatchingTypingLocations(),this.cleanupProgram(),Te(this.externalFiles,n=>this.detachScriptInfoIfNotRoot(n));for(let n of this.rootFiles)n.detachFromProject(this);this.projectService.pendingEnsureProjectForOpenFiles=!0,this.rootFiles=void 0,this.rootFilesMap=void 0,this.externalFiles=void 0,this.program=void 0,this.builderState=void 0,this.resolutionCache.clear(),this.resolutionCache=void 0,this.cachedUnresolvedImportsPerFile=void 0,(t=this.packageJsonWatches)==null||t.forEach(n=>{n.projects.delete(this),n.close()}),this.packageJsonWatches=void 0,this.moduleSpecifierCache.clear(),this.moduleSpecifierCache=void 0,this.directoryStructureHost=void 0,this.exportMapCache=void 0,this.projectErrors=void 0,this.plugins.length=0,this.missingFilesMap&&(Wf(this.missingFilesMap,ug),this.missingFilesMap=void 0),this.clearGeneratedFileWatch(),this.clearInvalidateResolutionOfFailedLookupTimer(),this.autoImportProviderHost&&this.autoImportProviderHost.close(),this.autoImportProviderHost=void 0,this.noDtsResolutionProject&&this.noDtsResolutionProject.close(),this.noDtsResolutionProject=void 0,this.languageService.dispose(),this.languageService=void 0}detachScriptInfoIfNotRoot(t){let n=this.projectService.getScriptInfo(t);n&&!this.isRoot(n)&&n.detachFromProject(this)}isClosed(){return this.rootFiles===void 0}hasRoots(){return this.rootFiles&&this.rootFiles.length>0}isOrphan(){return!1}getRootFiles(){return this.rootFiles&&this.rootFiles.map(t=>t.fileName)}getRootFilesMap(){return this.rootFilesMap}getRootScriptInfos(){return this.rootFiles}getScriptInfos(){return this.languageServiceEnabled?vr(this.program.getSourceFiles(),t=>{let n=this.projectService.getScriptInfoForPath(t.resolvedPath);return I.assert(!!n,"getScriptInfo",()=>`scriptInfo for a file '${t.fileName}' Path: '${t.path}' / '${t.resolvedPath}' is missing.`),n}):this.rootFiles}getExcludedFiles(){return Vl}getFileNames(t,n){if(!this.program)return[];if(!this.languageServiceEnabled){let s=this.getRootFiles();if(this.compilerOptions){let o=vSe(this.compilerOptions);o&&(s||(s=[])).push(o)}return s}let i=[];for(let s of this.program.getSourceFiles())t&&this.program.isSourceFileFromExternalLibrary(s)||i.push(s.fileName);if(!n){let s=this.program.getCompilerOptions().configFile;if(s&&(i.push(s.fileName),s.extendedSourceFiles))for(let o of s.extendedSourceFiles)i.push(o)}return i}getFileNamesWithRedirectInfo(t){return this.getFileNames().map(n=>({fileName:n,isSourceOfProjectReferenceRedirect:t&&this.isSourceOfProjectReferenceRedirect(n)}))}hasConfigFile(t){if(this.program&&this.languageServiceEnabled){let n=this.program.getCompilerOptions().configFile;if(n){if(t===n.fileName)return!0;if(n.extendedSourceFiles){for(let i of n.extendedSourceFiles)if(t===i)return!0}}}return!1}containsScriptInfo(t){if(this.isRoot(t))return!0;if(!this.program)return!1;let n=this.program.getSourceFileByPath(t.path);return!!n&&n.resolvedPath===t.path}containsFile(t,n){let i=this.projectService.getScriptInfoForNormalizedPath(t);return i&&(i.isScriptOpen()||!n)?this.containsScriptInfo(i):!1}isRoot(t){var n;return this.rootFilesMap&&((n=this.rootFilesMap.get(t.path))==null?void 0:n.info)===t}addRoot(t,n){I.assert(!this.isRoot(t)),this.rootFiles.push(t),this.rootFilesMap.set(t.path,{fileName:n||t.fileName,info:t}),t.attachToProject(this),this.markAsDirty()}addMissingFileRoot(t){let n=this.projectService.toPath(t);this.rootFilesMap.set(n,{fileName:t}),this.markAsDirty()}removeFile(t,n,i){this.isRoot(t)&&this.removeRoot(t),n?this.resolutionCache.removeResolutionsOfFile(t.path):this.resolutionCache.invalidateResolutionOfFile(t.path),this.cachedUnresolvedImportsPerFile.delete(t.path),i&&t.detachFromProject(this),this.markAsDirty()}registerFileUpdate(t){(this.updatedFileNames||(this.updatedFileNames=new Set)).add(t)}markFileAsDirty(t){this.markAsDirty(),this.exportMapCache&&!this.exportMapCache.isEmpty()&&(this.changedFilesForExportMapCache||(this.changedFilesForExportMapCache=new Set)).add(t)}markAsDirty(){this.dirty||(this.projectStateVersion++,this.dirty=!0)}onAutoImportProviderSettingsChanged(){var t;this.autoImportProviderHost===!1?this.autoImportProviderHost=void 0:(t=this.autoImportProviderHost)==null||t.markAsDirty()}onPackageJsonChange(){this.moduleSpecifierCache.clear(),this.autoImportProviderHost&&this.autoImportProviderHost.markAsDirty()}onFileAddedOrRemoved(t){this.hasAddedorRemovedFiles=!0,t&&(this.hasAddedOrRemovedSymlinks=!0)}onDiscoveredSymlink(){this.hasAddedOrRemovedSymlinks=!0}updateFromProject(){qp(this)}updateGraph(){var t,n,i,s,o;(t=mn)==null||t.push(mn.Phase.Session,"updateGraph",{name:this.projectName,kind:GO[this.projectKind]}),(n=z_)==null||n.logStartUpdateGraph(),this.resolutionCache.startRecordingFilesWithChangedResolutions();let l=this.updateGraphWorker(),p=this.hasAddedorRemovedFiles;this.hasAddedorRemovedFiles=!1,this.hasAddedOrRemovedSymlinks=!1;let m=this.resolutionCache.finishRecordingFilesWithChangedResolutions()||Vl;for(let h of m)this.cachedUnresolvedImportsPerFile.delete(h);this.languageServiceEnabled&&this.projectService.serverMode===0&&!this.isOrphan()?((l||m.length)&&(this.lastCachedUnresolvedImportsList=s8t(this.program,this.cachedUnresolvedImportsPerFile)),this.projectService.typingsCache.enqueueInstallTypingsForProject(this,this.lastCachedUnresolvedImportsList,p)):this.lastCachedUnresolvedImportsList=void 0;let S=this.projectProgramVersion===0&&l;return l&&this.projectProgramVersion++,p&&(this.autoImportProviderHost||(this.autoImportProviderHost=void 0),(i=this.autoImportProviderHost)==null||i.markAsDirty()),S&&this.getPackageJsonAutoImportProvider(),(s=z_)==null||s.logStopUpdateGraph(),(o=mn)==null||o.pop(),!l}updateTypingFiles(t){q5(t,this.typingFiles,gy(!this.useCaseSensitiveFileNames()),ja,n=>this.detachScriptInfoFromProject(n))&&(this.typingFiles=t,this.resolutionCache.setFilesWithInvalidatedNonRelativeUnresolvedImports(this.cachedUnresolvedImportsPerFile),this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this))}closeWatchingTypingLocations(){this.typingWatchers&&Wf(this.typingWatchers,ug),this.typingWatchers=void 0}onTypingInstallerWatchInvoke(){this.typingWatchers.isInvoked=!0,this.projectService.updateTypingsForProject({projectName:this.getProjectName(),kind:UM})}watchTypingLocations(t){if(!t){this.typingWatchers.isInvoked=!1;return}if(!t.length){this.closeWatchingTypingLocations();return}let n=new Map(this.typingWatchers);this.typingWatchers||(this.typingWatchers=new Map),this.typingWatchers.isInvoked=!1;let i=(s,o)=>{let l=this.toPath(s);n.delete(l),this.typingWatchers.has(l)||this.typingWatchers.set(l,o==="FileWatcher"?this.projectService.watchFactory.watchFile(s,()=>this.typingWatchers.isInvoked?this.writeLog("TypingWatchers already invoked"):this.onTypingInstallerWatchInvoke(),2e3,this.projectService.getWatchOptions(this),_u.TypingInstallerLocationFile,this):this.projectService.watchFactory.watchDirectory(s,p=>{if(this.typingWatchers.isInvoked)return this.writeLog("TypingWatchers already invoked");if(!Uc(p,".json"))return this.writeLog("Ignoring files that are not *.json");if(yy(p,li(this.projectService.typingsInstaller.globalTypingsCacheLocation,"package.json"),!this.useCaseSensitiveFileNames()))return this.writeLog("Ignoring package.json change at global typings location");this.onTypingInstallerWatchInvoke()},1,this.projectService.getWatchOptions(this),_u.TypingInstallerLocationDirectory,this))};for(let s of t){let o=Cl(s);if(o==="package.json"||o==="bower.json"){i(s,"FileWatcher");continue}if(wm(this.currentDirectory,s,this.currentDirectory,!this.useCaseSensitiveFileNames())){let l=s.indexOf(hc,this.currentDirectory.length+1);i(l!==-1?s.substr(0,l):s,"DirectoryWatcher");continue}if(wm(this.projectService.typingsInstaller.globalTypingsCacheLocation,s,this.currentDirectory,!this.useCaseSensitiveFileNames())){i(this.projectService.typingsInstaller.globalTypingsCacheLocation,"DirectoryWatcher");continue}i(s,"DirectoryWatcher")}n.forEach((s,o)=>{s.close(),this.typingWatchers.delete(o)})}getCurrentProgram(){return this.program}removeExistingTypings(t){let n=jU(this.getCompilerOptions(),this.directoryStructureHost);return t.filter(i=>!n.includes(i))}updateGraphWorker(){var t,n;let i=this.languageService.getCurrentProgram();I.assert(i===this.program),I.assert(!this.isClosed(),"Called update graph worker of closed project"),this.writeLog(`Starting updateGraphWorker: Project: ${this.getProjectName()}`);let s=uc(),{hasInvalidatedResolutions:o,hasInvalidatedLibResolutions:l}=this.resolutionCache.createHasInvalidatedResolutions(qf,qf);this.hasInvalidatedResolutions=o,this.hasInvalidatedLibResolutions=l,this.resolutionCache.startCachingPerDirectoryResolution(),this.dirty=!1,this.updateFromProjectInProgress=!0,this.program=this.languageService.getProgram(),this.updateFromProjectInProgress=!1,(t=mn)==null||t.push(mn.Phase.Session,"finishCachingPerDirectoryResolution"),this.resolutionCache.finishCachingPerDirectoryResolution(this.program,i),(n=mn)==null||n.pop(),I.assert(i===void 0||this.program!==void 0);let p=!1;if(this.program&&(!i||this.program!==i&&this.program.structureIsReused!==2)){if(p=!0,i){for(let h of i.getSourceFiles()){let b=this.program.getSourceFileByPath(h.resolvedPath);(!b||h.resolvedPath===h.path&&b.resolvedPath!==h.path)&&this.detachScriptInfoFromProject(h.fileName,!!this.program.getSourceFileByPath(h.path),!0)}i.forEachResolvedProjectReference(h=>{this.program.getResolvedProjectReferenceByPath(h.sourceFile.path)||this.detachScriptInfoFromProject(h.sourceFile.fileName,void 0,!0)})}if(wZ(this.program,this.missingFilesMap||(this.missingFilesMap=new Map),(h,b)=>this.addMissingFileWatcher(h,b)),this.generatedFilesMap){let h=Wo(this.compilerOptions);k2e(this.generatedFilesMap)?(!h||!this.isValidGeneratedFileWatcher(ff(h)+".d.ts",this.generatedFilesMap))&&this.clearGeneratedFileWatch():h?this.clearGeneratedFileWatch():this.generatedFilesMap.forEach((b,A)=>{let k=this.program.getSourceFileByPath(A);(!k||k.resolvedPath!==A||!this.isValidGeneratedFileWatcher(Cj(k.fileName,this.compilerOptions,this.currentDirectory,this.program.getCommonSourceDirectory(),this.getCanonicalFileName),b))&&(Od(b),this.generatedFilesMap.delete(A))})}this.languageServiceEnabled&&this.projectService.serverMode===0&&this.resolutionCache.updateTypeRootsWatch()}this.projectService.verifyProgram(this),this.exportMapCache&&!this.exportMapCache.isEmpty()&&(this.exportMapCache.releaseSymbols(),this.hasAddedorRemovedFiles||i&&!this.program.structureIsReused?this.exportMapCache.clear():this.changedFilesForExportMapCache&&i&&this.program&&Mh(this.changedFilesForExportMapCache,h=>{let b=i.getSourceFileByPath(h),A=this.program.getSourceFileByPath(h);return!b||!A?(this.exportMapCache.clear(),!0):this.exportMapCache.onFileChanged(b,A,!!this.getTypeAcquisition().enable)})),this.changedFilesForExportMapCache&&this.changedFilesForExportMapCache.clear(),(this.hasAddedOrRemovedSymlinks||this.program&&!this.program.structureIsReused&&this.getCompilerOptions().preserveSymlinks)&&(this.symlinks=void 0,this.moduleSpecifierCache.clear());let m=this.externalFiles||Vl;this.externalFiles=this.getExternalFiles(),q5(this.externalFiles,m,gy(!this.useCaseSensitiveFileNames()),h=>{let b=this.projectService.getOrCreateScriptInfoNotOpenedByClient(h,this.currentDirectory,this.directoryStructureHost);b?.attachToProject(this)},h=>this.detachScriptInfoFromProject(h));let S=uc()-s;return this.sendPerformanceEvent("UpdateGraph",S),this.writeLog(`Finishing updateGraphWorker: Project: ${this.getProjectName()} projectStateVersion: ${this.projectStateVersion} projectProgramVersion: ${this.projectProgramVersion} structureChanged: ${p}${this.program?` structureIsReused:: ${Z5[this.program.structureIsReused]}`:""} Elapsed: ${S}ms`),this.projectService.logger.isTestLogger?this.program!==i?this.print(!0,this.hasAddedorRemovedFiles,!0):this.writeLog("Same program as before"):this.hasAddedorRemovedFiles?this.print(!0,!0,!1):this.program!==i&&this.writeLog("Different program with same set of files"),this.projectService.verifyDocumentRegistry(),p}sendPerformanceEvent(t,n){this.projectService.sendPerformanceEvent(t,n)}detachScriptInfoFromProject(t,n,i){let s=this.projectService.getScriptInfo(t);s&&(s.detachFromProject(this),n||this.resolutionCache.removeResolutionsOfFile(s.path,i))}addMissingFileWatcher(t,n){var i;if(JT(this)){let o=this.projectService.configFileExistenceInfoCache.get(t);if((i=o?.config)!=null&&i.projects.has(this.canonicalConfigFilePath))return yD}let s=this.projectService.watchFactory.watchFile(Ps(n,this.currentDirectory),(o,l)=>{JT(this)&&this.getCachedDirectoryStructureHost().addOrDeleteFile(o,t,l),l===0&&this.missingFilesMap.has(t)&&(this.missingFilesMap.delete(t),s.close(),this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this))},500,this.projectService.getWatchOptions(this),_u.MissingFile,this);return s}isWatchedMissingFile(t){return!!this.missingFilesMap&&this.missingFilesMap.has(t)}addGeneratedFileWatch(t,n){if(Wo(this.compilerOptions))this.generatedFilesMap||(this.generatedFilesMap=this.createGeneratedFileWatcher(t));else{let i=this.toPath(n);if(this.generatedFilesMap){if(k2e(this.generatedFilesMap)){I.fail(`${this.projectName} Expected to not have --out watcher for generated file with options: ${JSON.stringify(this.compilerOptions)}`);return}if(this.generatedFilesMap.has(i))return}else this.generatedFilesMap=new Map;this.generatedFilesMap.set(i,this.createGeneratedFileWatcher(t))}}createGeneratedFileWatcher(t){return{generatedFilePath:this.toPath(t),watcher:this.projectService.watchFactory.watchFile(t,()=>{this.clearSourceMapperCache(),this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this)},2e3,this.projectService.getWatchOptions(this),_u.MissingGeneratedFile,this)}}isValidGeneratedFileWatcher(t,n){return this.toPath(t)===n.generatedFilePath}clearGeneratedFileWatch(){this.generatedFilesMap&&(k2e(this.generatedFilesMap)?Od(this.generatedFilesMap):Wf(this.generatedFilesMap,Od),this.generatedFilesMap=void 0)}getScriptInfoForNormalizedPath(t){let n=this.projectService.getScriptInfoForPath(this.toPath(t));return n&&!n.isAttached(this)?G1.ThrowProjectDoesNotContainDocument(t,this):n}getScriptInfo(t){return this.projectService.getScriptInfo(t)}filesToString(t){return this.filesToStringWorker(t,!0,!1)}filesToStringWorker(t,n,i){if(this.isInitialLoadPending())return`	Files (0) InitialLoadPending
`;if(!this.program)return`	Files (0) NoProgram
`;let s=this.program.getSourceFiles(),o=`	Files (${s.length})
`;if(t){for(let l of s)o+=`	${l.fileName}${i?` ${l.version} ${JSON.stringify(l.text)}`:""}
`;n&&(o+=`

`,dee(this.program,l=>o+=`	${l}
`))}return o}print(t,n,i){var s;this.writeLog(`Project '${this.projectName}' (${GO[this.projectKind]})`),this.writeLog(this.filesToStringWorker(t&&this.projectService.logger.hasLevel(3),n&&this.projectService.logger.hasLevel(3),i&&this.projectService.logger.hasLevel(3))),this.writeLog("-----------------------------------------------"),this.autoImportProviderHost&&this.autoImportProviderHost.print(!1,!1,!1),(s=this.noDtsResolutionProject)==null||s.print(!1,!1,!1)}setCompilerOptions(t){var n;if(t){t.allowNonTsExtensions=!0;let i=this.compilerOptions;this.compilerOptions=t,this.setInternalCompilerOptionsForEmittingJsFiles(),(n=this.noDtsResolutionProject)==null||n.setCompilerOptions(this.getCompilerOptionsForNoDtsResolutionProject()),j9(i,t)&&(this.cachedUnresolvedImportsPerFile.clear(),this.lastCachedUnresolvedImportsList=void 0,this.resolutionCache.onChangesAffectModuleResolution(),this.moduleSpecifierCache.clear()),this.markAsDirty()}}setWatchOptions(t){this.watchOptions=t}getWatchOptions(){return this.watchOptions}setTypeAcquisition(t){t&&(this.typeAcquisition=this.removeLocalTypingsFromTypeAcquisition(t))}getTypeAcquisition(){return this.typeAcquisition||{}}getChangesSinceVersion(t,n){var i,s;let o=n?m=>In(m.entries(),([S,h])=>({fileName:S,isSourceOfProjectReferenceRedirect:h})):m=>In(m.keys());this.isInitialLoadPending()||qp(this);let l={projectName:this.getProjectName(),version:this.projectProgramVersion,isInferred:$D(this),options:this.getCompilationSettings(),languageServiceDisabled:!this.languageServiceEnabled,lastFileExceededProgramSize:this.lastFileExceededProgramSize},p=this.updatedFileNames;if(this.updatedFileNames=void 0,this.lastReportedFileNames&&t===this.lastReportedVersion){if(this.projectProgramVersion===this.lastReportedVersion&&!p)return{info:l,projectErrors:this.getGlobalProjectErrors()};let m=this.lastReportedFileNames,S=((i=this.externalFiles)==null?void 0:i.map(M=>({fileName:Cc(M),isSourceOfProjectReferenceRedirect:!1})))||Vl,h=il(this.getFileNamesWithRedirectInfo(!!n).concat(S),M=>M.fileName,M=>M.isSourceOfProjectReferenceRedirect),b=new Map,A=new Map,k=p?In(p.keys()):[],N=[];return yu(h,(M,O)=>{m.has(O)?n&&M!==m.get(O)&&N.push({fileName:O,isSourceOfProjectReferenceRedirect:M}):b.set(O,M)}),yu(m,(M,O)=>{h.has(O)||A.set(O,M)}),this.lastReportedFileNames=h,this.lastReportedVersion=this.projectProgramVersion,{info:l,changes:{added:o(b),removed:o(A),updated:n?k.map(M=>({fileName:M,isSourceOfProjectReferenceRedirect:this.isSourceOfProjectReferenceRedirect(M)})):k,updatedRedirects:n?N:void 0},projectErrors:this.getGlobalProjectErrors()}}else{let m=this.getFileNamesWithRedirectInfo(!!n),S=((s=this.externalFiles)==null?void 0:s.map(b=>({fileName:Cc(b),isSourceOfProjectReferenceRedirect:!1})))||Vl,h=m.concat(S);return this.lastReportedFileNames=il(h,b=>b.fileName,b=>b.isSourceOfProjectReferenceRedirect),this.lastReportedVersion=this.projectProgramVersion,{info:l,files:n?h:h.map(b=>b.fileName),projectErrors:this.getGlobalProjectErrors()}}}removeRoot(t){lA(this.rootFiles,t),this.rootFilesMap.delete(t.path)}isSourceOfProjectReferenceRedirect(t){return!!this.program&&this.program.isSourceOfProjectReferenceRedirect(t)}getGlobalPluginSearchPaths(){return[...this.projectService.pluginProbeLocations,li(this.projectService.getExecutingFilePath(),"../../..")]}enableGlobalPlugins(t){if(!this.projectService.globalPlugins.length)return;let n=this.projectService.host;if(!n.require&&!n.importPlugin){this.projectService.logger.info("Plugins were requested but not running in environment that supports 'require'. Nothing will be loaded");return}let i=this.getGlobalPluginSearchPaths();for(let s of this.projectService.globalPlugins)s&&(t.plugins&&t.plugins.some(o=>o.name===s)||(this.projectService.logger.info(`Loading global plugin ${s}`),this.enablePlugin({name:s,global:!0},i)))}enablePlugin(t,n){this.projectService.requestEnablePlugin(this,t,n)}enableProxy(t,n){try{if(typeof t!="function"){this.projectService.logger.info(`Skipped loading plugin ${n.name} because it did not expose a proper factory function`);return}let i={config:n,project:this,languageService:this.languageService,languageServiceHost:this,serverHost:this.projectService.host,session:this.projectService.session},s=t({typescript:Fqe}),o=s.create(i);for(let l of Object.keys(this.languageService))l in o||(this.projectService.logger.info(`Plugin activation warning: Missing proxied method ${l} in created LS. Patching.`),o[l]=this.languageService[l]);this.projectService.logger.info("Plugin validation succeeded"),this.languageService=o,this.plugins.push({name:n.name,module:s})}catch(i){this.projectService.logger.info(`Plugin activation failed: ${i}`)}}onPluginConfigurationChanged(t,n){this.plugins.filter(i=>i.name===t).forEach(i=>{i.module.onConfigurationChanged&&i.module.onConfigurationChanged(n)})}refreshDiagnostics(){this.projectService.sendProjectsUpdatedInBackgroundEvent()}getPackageJsonsVisibleToFile(t,n){return this.projectService.serverMode!==0?Vl:this.projectService.getPackageJsonsVisibleToFile(t,this,n)}getNearestAncestorDirectoryWithPackageJson(t){return this.projectService.getNearestAncestorDirectoryWithPackageJson(t)}getPackageJsonsForAutoImport(t){return this.getPackageJsonsVisibleToFile(li(this.currentDirectory,mD),t)}getPackageJsonCache(){return this.projectService.packageJsonCache}getCachedExportInfoMap(){return this.exportMapCache||(this.exportMapCache=ere(this))}clearCachedExportInfoMap(){var t;(t=this.exportMapCache)==null||t.clear()}getModuleSpecifierCache(){return this.moduleSpecifierCache}includePackageJsonAutoImports(){return this.projectService.includePackageJsonAutoImports()===0||!this.languageServiceEnabled||f7(this.currentDirectory)||!this.isDefaultProjectForOpenFiles()?0:this.projectService.includePackageJsonAutoImports()}getHostForAutoImportProvider(){var t,n;return this.program?{fileExists:this.program.fileExists,directoryExists:this.program.directoryExists,realpath:this.program.realpath||((t=this.projectService.host.realpath)==null?void 0:t.bind(this.projectService.host)),getCurrentDirectory:this.getCurrentDirectory.bind(this),readFile:this.projectService.host.readFile.bind(this.projectService.host),getDirectories:this.projectService.host.getDirectories.bind(this.projectService.host),trace:(n=this.projectService.host.trace)==null?void 0:n.bind(this.projectService.host),useCaseSensitiveFileNames:this.program.useCaseSensitiveFileNames(),readDirectory:this.projectService.host.readDirectory.bind(this.projectService.host)}:this.projectService.host}getPackageJsonAutoImportProvider(){var t,n,i;if(this.autoImportProviderHost===!1)return;if(this.projectService.serverMode!==0){this.autoImportProviderHost=!1;return}if(this.autoImportProviderHost){if(qp(this.autoImportProviderHost),this.autoImportProviderHost.isEmpty()){this.autoImportProviderHost.close(),this.autoImportProviderHost=void 0;return}return this.autoImportProviderHost.getCurrentProgram()}let s=this.includePackageJsonAutoImports();if(s){(t=mn)==null||t.push(mn.Phase.Session,"getPackageJsonAutoImportProvider");let o=uc();if(this.autoImportProviderHost=kse.create(s,this,this.getHostForAutoImportProvider(),this.documentRegistry),this.autoImportProviderHost)return qp(this.autoImportProviderHost),this.sendPerformanceEvent("CreatePackageJsonAutoImportProvider",uc()-o),(n=mn)==null||n.pop(),this.autoImportProviderHost.getCurrentProgram();(i=mn)==null||i.pop()}}isDefaultProjectForOpenFiles(){return!!yu(this.projectService.openFiles,(t,n)=>this.projectService.tryGetDefaultProjectForFile(Cc(n))===this)}watchNodeModulesForPackageJsonChanges(t){return this.projectService.watchPackageJsonsInNodeModules(t,this)}getIncompleteCompletionsCache(){return this.projectService.getIncompleteCompletionsCache()}getNoDtsResolutionProject(t){return I.assert(this.projectService.serverMode===0),this.noDtsResolutionProject||(this.noDtsResolutionProject=new Cse(this.projectService,this.documentRegistry,this.getCompilerOptionsForNoDtsResolutionProject(),this.currentDirectory)),this.noDtsResolutionProject.rootFile!==t&&(this.projectService.setFileNamesOfAutpImportProviderOrAuxillaryProject(this.noDtsResolutionProject,[t]),this.noDtsResolutionProject.rootFile=t),this.noDtsResolutionProject}getCompilerOptionsForNoDtsResolutionProject(){return{...this.getCompilerOptions(),noDtsResolution:!0,allowJs:!0,maxNodeModuleJsDepth:3,diagnostics:!1,skipLibCheck:!0,sourceMap:!1,types:tt,lib:tt,noLib:!0}}},xse=class extends Rx{constructor(e,t,n,i,s,o,l){super(e.newInferredProjectName(),0,e,t,void 0,void 0,n,!1,i,e.host,o),this._isJsInferredProject=!1,this.typeAcquisition=l,this.projectRootPath=s&&e.toCanonicalFileName(s),!s&&!e.useSingleInferredProject&&(this.canonicalCurrentDirectory=e.toCanonicalFileName(this.currentDirectory)),this.enableGlobalPlugins(this.getCompilerOptions())}toggleJsInferredProject(e){e!==this._isJsInferredProject&&(this._isJsInferredProject=e,this.setCompilerOptions())}setCompilerOptions(e){if(!e&&!this.getCompilationSettings())return;let t=mte(e||this.getCompilationSettings());this._isJsInferredProject&&typeof t.maxNodeModuleJsDepth!="number"?t.maxNodeModuleJsDepth=2:this._isJsInferredProject||(t.maxNodeModuleJsDepth=void 0),t.allowJs=!0,super.setCompilerOptions(t)}addRoot(e){I.assert(e.isScriptOpen()),this.projectService.startWatchingConfigFilesForInferredProjectRoot(e),!this._isJsInferredProject&&e.isJavaScript()?this.toggleJsInferredProject(!0):this.isOrphan()&&this._isJsInferredProject&&!e.isJavaScript()&&this.toggleJsInferredProject(!1),super.addRoot(e)}removeRoot(e){this.projectService.stopWatchingConfigFilesForInferredProjectRoot(e),super.removeRoot(e),!this.isOrphan()&&this._isJsInferredProject&&e.isJavaScript()&&yr(this.getRootScriptInfos(),t=>!t.isJavaScript())&&this.toggleJsInferredProject(!1)}isOrphan(){return!this.hasRoots()}isProjectWithSingleRoot(){return!this.projectRootPath&&!this.projectService.useSingleInferredProject||this.getRootScriptInfos().length===1}close(){Te(this.getRootScriptInfos(),e=>this.projectService.stopWatchingConfigFilesForInferredProjectRoot(e)),super.close()}getTypeAcquisition(){return this.typeAcquisition||{enable:x2e(this),include:tt,exclude:tt}}},Cse=class extends Rx{constructor(e,t,n,i){super(e.newAuxiliaryProjectName(),4,e,t,!1,void 0,n,!1,void 0,e.host,i)}isOrphan(){return!0}scheduleInvalidateResolutionsOfFailedLookupLocations(){}},Ase=class b6e extends Rx{constructor(t,n,i,s){super(t.projectService.newAutoImportProviderProjectName(),3,t.projectService,i,!1,void 0,s,!1,t.getWatchOptions(),t.projectService.host,t.currentDirectory),this.hostProject=t,this.rootFileNames=n,this.useSourceOfProjectReferenceRedirect=rs(this.hostProject,this.hostProject.useSourceOfProjectReferenceRedirect),this.getParsedCommandLine=rs(this.hostProject,this.hostProject.getParsedCommandLine)}static getRootFileNames(t,n,i,s){var o,l;if(!t)return tt;let p=n.getCurrentProgram();if(!p)return tt;let m=uc(),S,h,b=li(n.currentDirectory,mD),A=n.getPackageJsonsForAutoImport(li(n.currentDirectory,b));for(let O of A)(o=O.dependencies)==null||o.forEach((U,H)=>N(H)),(l=O.peerDependencies)==null||l.forEach((U,H)=>N(H));let k=0;if(S){let O=n.getSymlinkCache();for(let U of In(S.keys())){if(t===2&&k>this.maxDependencies)return n.log(`AutoImportProviderProject: attempted to add more than ${this.maxDependencies} dependencies. Aborting.`),tt;let H=RQ(U,n.currentDirectory,s,i,p.getModuleResolutionCache());if(H){let re=M(H,p,O);if(re){h=ys(h,re),k+=re.length?1:0;continue}}if(!Te([n.currentDirectory,n.getGlobalTypingsCacheLocation()],re=>{if(re){let $=RQ(`@types/${U}`,re,s,i,p.getModuleResolutionCache());if($){let pe=M($,p,O);return h=ys(h,pe),k+=pe?.length?1:0,!0}}})&&H&&s.allowJs&&s.maxNodeModuleJsDepth){let re=M(H,p,O,!0);h=ys(h,re),k+=re?.length?1:0}}}return h?.length&&n.log(`AutoImportProviderProject: found ${h.length} root files in ${k} dependencies in ${uc()-m} ms`),h||tt;function N(O){Ss(O,"@types/")||(S||(S=new Set)).add(O)}function M(O,U,H,K){var re;let $=VQ(O,s,i,U.getModuleResolutionCache(),K);if($){let pe=(re=i.realpath)==null?void 0:re.call(i,O.packageDirectory),z=pe?n.toPath(pe):void 0,se=z&&z!==n.toPath(O.packageDirectory);return se&&H.setSymlinkedDirectory(O.packageDirectory,{real:hu(pe),realPath:hu(z)}),Wi($,Se=>{let xe=se?Se.replace(O.packageDirectory,pe):Se;if(!U.getSourceFile(xe)&&!(se&&U.getSourceFile(Se)))return xe})}}}static create(t,n,i,s){if(t===0)return;let o={...n.getCompilerOptions(),...this.compilerOptionsOverrides},l=this.getRootFileNames(t,n,i,o);if(l.length)return new b6e(n,l,s,o)}isEmpty(){return!Tt(this.rootFileNames)}isOrphan(){return!0}updateGraph(){let t=this.rootFileNames;t||(t=b6e.getRootFileNames(this.hostProject.includePackageJsonAutoImports(),this.hostProject,this.hostProject.getHostForAutoImportProvider(),this.getCompilationSettings())),this.projectService.setFileNamesOfAutpImportProviderOrAuxillaryProject(this,t),this.rootFileNames=t;let n=this.getCurrentProgram(),i=super.updateGraph();return n&&n!==this.getCurrentProgram()&&this.hostProject.clearCachedExportInfoMap(),i}scheduleInvalidateResolutionsOfFailedLookupLocations(){}hasRoots(){var t;return!!((t=this.rootFileNames)!=null&&t.length)}markAsDirty(){this.rootFileNames=void 0,super.markAsDirty()}getScriptFileNames(){return this.rootFileNames||tt}getLanguageService(){throw new Error("AutoImportProviderProject language service should never be used. To get the program, use `project.getCurrentProgram()`.")}onAutoImportProviderSettingsChanged(){throw new Error("AutoImportProviderProject is an auto import provider; use `markAsDirty()` instead.")}onPackageJsonChange(){throw new Error("package.json changes should be notified on an AutoImportProvider's host project")}getHostForAutoImportProvider(){throw new Error("AutoImportProviderProject cannot provide its own host; use `hostProject.getModuleResolutionHostForAutomImportProvider()` instead.")}getProjectReferences(){return this.hostProject.getProjectReferences()}includePackageJsonAutoImports(){return 0}getSymlinkCache(){return this.hostProject.getSymlinkCache()}getModuleResolutionCache(){var t;return(t=this.hostProject.getCurrentProgram())==null?void 0:t.getModuleResolutionCache()}},Ase.maxDependencies=10,Ase.compilerOptionsOverrides={diagnostics:!1,skipLibCheck:!0,sourceMap:!1,types:tt,lib:tt,noLib:!0},kse=Ase,Pse=class extends Rx{constructor(e,t,n,i,s){super(e,1,n,i,!1,void 0,{},!1,void 0,s,hi(e)),this.canonicalConfigFilePath=t,this.openFileWatchTriggered=new Map,this.canConfigFileJsonReportNoInputFiles=!1,this.externalProjectRefCount=0,this.isInitialLoadPending=em,this.sendLoadingProjectFinish=!1}setCompilerHost(e){this.compilerHost=e}getCompilerHost(){return this.compilerHost}useSourceOfProjectReferenceRedirect(){return this.languageServiceEnabled}getParsedCommandLine(e){let t=Ca(e),n=this.projectService.toCanonicalFileName(t),i=this.projectService.configFileExistenceInfoCache.get(n);return i||this.projectService.configFileExistenceInfoCache.set(n,i={exists:this.projectService.host.fileExists(t)}),this.projectService.ensureParsedConfigUptoDate(t,n,i,this),this.languageServiceEnabled&&this.projectService.serverMode===0&&this.projectService.watchWildcards(t,i,this),i.exists?i.config.parsedCommandLine:void 0}onReleaseParsedCommandLine(e){this.releaseParsedConfig(this.projectService.toCanonicalFileName(Ca(e)))}releaseParsedConfig(e){this.projectService.stopWatchingWildCards(e,this),this.projectService.releaseParsedConfig(e,this)}updateGraph(){let e=this.isInitialLoadPending();this.isInitialLoadPending=qf;let t=this.pendingUpdateLevel;this.pendingUpdateLevel=0;let n;switch(t){case 1:this.openFileWatchTriggered.clear(),n=this.projectService.reloadFileNamesOfConfiguredProject(this);break;case 2:this.openFileWatchTriggered.clear();let i=I.checkDefined(this.pendingUpdateReason);this.pendingUpdateReason=void 0,this.projectService.reloadConfiguredProject(this,i,e,!1),n=!0;break;default:n=super.updateGraph()}return this.compilerHost=void 0,this.projectService.sendProjectLoadingFinishEvent(this),this.projectService.sendProjectTelemetry(this),n}getCachedDirectoryStructureHost(){return this.directoryStructureHost}getConfigFilePath(){return this.getProjectName()}getProjectReferences(){return this.projectReferences}updateReferences(e){this.projectReferences=e,this.potentialProjectReferences=void 0}setPotentialProjectReference(e){I.assert(this.isInitialLoadPending()),(this.potentialProjectReferences||(this.potentialProjectReferences=new Set)).add(e)}getResolvedProjectReferenceToRedirect(e){let t=this.getCurrentProgram();return t&&t.getResolvedProjectReferenceToRedirect(e)}forEachResolvedProjectReference(e){var t;return(t=this.getCurrentProgram())==null?void 0:t.forEachResolvedProjectReference(e)}enablePluginsWithOptions(e){var t;if(this.plugins.length=0,!((t=e.plugins)!=null&&t.length)&&!this.projectService.globalPlugins.length)return;let n=this.projectService.host;if(!n.require&&!n.importPlugin){this.projectService.logger.info("Plugins were requested but not running in environment that supports 'require'. Nothing will be loaded");return}let i=this.getGlobalPluginSearchPaths();if(this.projectService.allowLocalPluginLoads){let s=hi(this.canonicalConfigFilePath);this.projectService.logger.info(`Local plugin loading enabled; adding ${s} to search paths`),i.unshift(s)}if(e.plugins)for(let s of e.plugins)this.enablePlugin(s,i);return this.enableGlobalPlugins(e)}getGlobalProjectErrors(){return Fn(this.projectErrors,e=>!e.file)||Vl}getAllProjectErrors(){return this.projectErrors||Vl}setProjectErrors(e){this.projectErrors=e}close(){this.projectService.configFileExistenceInfoCache.forEach((e,t)=>this.releaseParsedConfig(t)),this.projectErrors=void 0,this.openFileWatchTriggered.clear(),this.compilerHost=void 0,super.close()}addExternalProjectReference(){this.externalProjectRefCount++}deleteExternalProjectReference(){this.externalProjectRefCount--}isSolution(){return this.getRootFilesMap().size===0&&!this.canConfigFileJsonReportNoInputFiles}getDefaultChildProjectFromProjectWithReferences(e){return GD(this,e.path,t=>Ik(t,e)?t:void 0,0)}hasOpenRef(){var e;if(this.externalProjectRefCount)return!0;if(this.isClosed())return!1;let t=this.projectService.configFileExistenceInfoCache.get(this.canonicalConfigFilePath);return this.projectService.hasPendingProjectUpdate(this)?!!((e=t.openFilesImpactedByConfigFile)!=null&&e.size):!!t.openFilesImpactedByConfigFile&&yu(t.openFilesImpactedByConfigFile,(n,i)=>{let s=this.projectService.getScriptInfoForPath(i);return this.containsScriptInfo(s)||!!GD(this,s.path,o=>o.containsScriptInfo(s),0)})||!1}hasExternalProjectRef(){return!!this.externalProjectRefCount}getEffectiveTypeRoots(){return tO(this.getCompilationSettings(),this)||[]}updateErrorOnNoInputFiles(e){kU(e,this.getConfigFilePath(),this.getCompilerOptions().configFile.configFileSpecs,this.projectErrors,this.canConfigFileJsonReportNoInputFiles)}},Gq=class extends Rx{constructor(e,t,n,i,s,o,l,p){super(e,2,t,n,!0,s,i,o,p,t.host,hi(l||v_(e))),this.externalProjectName=e,this.compileOnSaveEnabled=o,this.excludedFiles=[],this.enableGlobalPlugins(this.getCompilerOptions())}updateGraph(){let e=super.updateGraph();return this.projectService.sendProjectTelemetry(this),e}getExcludedFiles(){return this.excludedFiles}}}});function gqe(e){let t=new Map;for(let n of e)if(typeof n.type=="object"){let i=n.type;i.forEach(s=>{I.assert(typeof s=="number")}),t.set(n.name,i)}return t}function WD(e){return vs(e.indentStyle)&&(e.indentStyle=xqe.get(e.indentStyle.toLowerCase()),I.assert(e.indentStyle!==void 0)),e}function Hq(e){return bqe.forEach((t,n)=>{let i=e[n];vs(i)&&(e[n]=t.get(i.toLowerCase()))}),e}function iL(e,t){let n,i;return nD.forEach(s=>{let o=e[s.name];if(o===void 0)return;let l=Eqe.get(s.name);(n||(n={}))[s.name]=l?vs(o)?l.get(o.toLowerCase()):o:vx(s,o,t||"",i||(i=[]))}),n&&{watchOptions:n,errors:i}}function P2e(e){let t;return cM.forEach(n=>{let i=e[n.name];i!==void 0&&((t||(t={}))[n.name]=i)}),t}function Nse(e){return vs(e)?Dse(e):e}function Dse(e){switch(e){case"JS":return 1;case"JSX":return 2;case"TS":return 3;case"TSX":return 4;default:return 0}}function N2e(e){let{lazyConfiguredProjectsFromExternalProject:t,...n}=e;return n}function hqe(e,t){for(let n of t)if(n.getProjectName()===e)return n}function Ise(e){return!!e.containingProjects}function yqe(e){return!!e.configFileInfo}function GD(e,t,n,i,s){var o;let l=(o=e.getCurrentProgram())==null?void 0:o.getResolvedProjectReferences();if(!l)return;let p,m=t?e.getResolvedProjectReferenceToRedirect(t):void 0;if(m){let h=Cc(m.sourceFile.fileName),b=e.projectService.findConfiguredProjectByProjectName(h);if(b){let A=n(b);if(A)return A}else if(i!==0){p=new Map;let A=D2e(l,e.getCompilerOptions(),(k,N)=>m===k?S(k,N):void 0,i,e.projectService,p);if(A)return A;p.clear()}}return D2e(l,e.getCompilerOptions(),(h,b)=>m!==h?S(h,b):void 0,i,e.projectService,p);function S(h,b){let A=Cc(h.sourceFile.fileName),k=e.projectService.findConfiguredProjectByProjectName(A)||(b===0?void 0:b===1?e.projectService.createConfiguredProject(A):b===2?e.projectService.createAndLoadConfiguredProject(A,s):I.assertNever(b));return k&&n(k)}}function D2e(e,t,n,i,s,o){let l=t.disableReferencedProjectLoad?0:i;return Te(e,p=>{if(!p)return;let m=Cc(p.sourceFile.fileName),S=s.toCanonicalFileName(m),h=o?.get(S);if(h!==void 0&&h>=l)return;let b=n(p,l);return b||((o||(o=new Map)).set(S,l),p.references&&D2e(p.references,p.commandLine.options,n,l,s,o))})}function vqe(e,t){return e.potentialProjectReferences&&Mh(e.potentialProjectReferences,t)}function c8t(e,t,n,i){return e.getCurrentProgram()?e.forEachResolvedProjectReference(t):e.isInitialLoadPending()?vqe(e,i):Te(e.getProjectReferences(),n)}function I2e(e,t,n){let i=n&&e.projectService.configuredProjects.get(n);return i&&t(i)}function Sqe(e,t){return c8t(e,n=>I2e(e,t,n.sourceFile.path),n=>I2e(e,t,e.toPath(dD(n))),n=>I2e(e,t,n))}function l8t(e,t){return`${vs(t)?`Config: ${t} `:t?`Project: ${t.getProjectName()} `:""}WatchType: ${e}`}function Tqe(e){return!e.isScriptOpen()&&e.mTime!==void 0}function Ik(e,t){return e.containsScriptInfo(t)&&!e.isSourceOfProjectReferenceRedirect(t.path)}function qp(e){return e.invalidateResolutionsOfFailedLookupLocations(),e.dirty&&e.updateGraph()}function w2e(e){JT(e)&&(e.projectOptions=!0)}function O2e(e){let t=1;return()=>e(t++)}function R2e(){return{idToCallbacks:new Map,pathToId:new Map}}function u8t(e,t){if(!t||!e.eventHandler||!e.session)return;let n=R2e(),i=R2e(),s=R2e(),o=1;return e.session.addProtocolHandler("watchChange",k=>(S(k.arguments),{responseRequired:!1})),{watchFile:l,watchDirectory:p,getCurrentDirectory:()=>e.host.getCurrentDirectory(),useCaseSensitiveFileNames:e.host.useCaseSensitiveFileNames};function l(k,N){return m(n,k,N,M=>({eventName:nz,data:{id:M,path:k}}))}function p(k,N,M){return m(M?s:i,k,N,O=>({eventName:iz,data:{id:O,path:k,recursive:!!M,ignoreUpdate:k.endsWith("/node_modules")?void 0:!0}}))}function m({pathToId:k,idToCallbacks:N},M,O,U){let H=e.toPath(M),K=k.get(H);K||k.set(H,K=o++);let re=N.get(K);return re||(N.set(K,re=new Set),e.eventHandler(U(K))),re.add(O),{close(){let $=N.get(K);$?.delete(O)&&($.size||(N.delete(K),k.delete(H),e.eventHandler({eventName:sz,data:{id:K}})))}}}function S(k){os(k)?k.forEach(h):h(k)}function h({id:k,created:N,deleted:M,updated:O}){b(k,N,0),b(k,M,2),b(k,O,1)}function b(k,N,M){N?.length&&(A(n,k,N,(O,U)=>O(U,M)),A(i,k,N,(O,U)=>O(U)),A(s,k,N,(O,U)=>O(U)))}function A(k,N,M,O){var U;(U=k.idToCallbacks.get(N))==null||U.forEach(H=>{M.forEach(K=>O(H,v_(K)))})}}function _8t(){let e;return{get(){return e},set(t){e=t},clear(){e=void 0}}}function M2e(e){return e.kind!==void 0}function L2e(e){e.print(!1,!1,!1)}var Yq,Xq,sL,Kq,Qq,Zq,ez,tz,rz,wse,nz,iz,sz,F2e,bqe,Eqe,xqe,Ose,az,oz,Rse,Mse,j2e,Lse,f8t=f({"src/server/editorServices.ts"(){"use strict";uS(),Mx(),b2e(),Yq=20*1024*1024,Xq=4*1024*1024,sL="projectsUpdatedInBackground",Kq="projectLoadingStart",Qq="projectLoadingFinish",Zq="largeFileReferenced",ez="configFileDiag",tz="projectLanguageServiceState",rz="projectInfo",wse="openFileInfo",nz="createFileWatcher",iz="createDirectoryWatcher",sz="closeFileWatcher",F2e="*ensureProjectForOpenFiles*",bqe=gqe(F0),Eqe=gqe(nD),xqe=new Map(Object.entries({none:0,block:1,smart:2})),Ose={jquery:{match:/jquery(-[\d.]+)?(\.intellisense)?(\.min)?\.js$/i,types:["jquery"]},WinJS:{match:/^(.*\/winjs-[.\d]+)\/js\/base\.js$/i,exclude:[["^",1,"/.*"]],types:["winjs"]},Kendo:{match:/^(.*\/kendo(-ui)?)\/kendo\.all(\.min)?\.js$/i,exclude:[["^",1,"/.*"]],types:["kendo-ui"]},"Office Nuget":{match:/^(.*\/office\/1)\/excel-\d+\.debug\.js$/i,exclude:[["^",1,"/.*"]],types:["office"]},References:{match:/^(.*\/_references\.js)$/i,exclude:[["^",1,"$"]]}},az={getFileName:e=>e,getScriptKind:(e,t)=>{let n;if(t){let i=qP(e);i&&Tt(t,s=>s.extension===i?(n=s.scriptKind,!0):!1)}return n},hasMixedContent:(e,t)=>Tt(t,n=>n.isMixedContent&&Uc(e,n.extension))},oz={getFileName:e=>e.fileName,getScriptKind:e=>Nse(e.scriptKind),hasMixedContent:e=>!!e.hasMixedContent},Rse={close:ja},Mse=(e=>(e[e.Find=0]="Find",e[e.FindCreate=1]="FindCreate",e[e.FindCreateLoad=2]="FindCreateLoad",e))(Mse||{}),j2e=class E6e{constructor(t){this.filenameToScriptInfo=new Map,this.nodeModulesWatchers=new Map,this.filenameToScriptInfoVersion=new Map,this.allJsFilesForOpenFileTelemetry=new Map,this.externalProjectToConfiguredProjectMap=new Map,this.externalProjects=[],this.inferredProjects=[],this.configuredProjects=new Map,this.newInferredProjectName=O2e(s2e),this.newAutoImportProviderProjectName=O2e(a2e),this.newAuxiliaryProjectName=O2e(o2e),this.openFiles=new Map,this.configFileForOpenFiles=new Map,this.openFilesWithNonRootedDiskPath=new Map,this.compilerOptionsForInferredProjectsPerProjectRoot=new Map,this.watchOptionsForInferredProjectsPerProjectRoot=new Map,this.typeAcquisitionForInferredProjectsPerProjectRoot=new Map,this.projectToSizeMap=new Map,this.configFileExistenceInfoCache=new Map,this.safelist=Ose,this.legacySafelist=new Map,this.pendingProjectUpdates=new Map,this.pendingEnsureProjectForOpenFiles=!1,this.seenProjects=new Map,this.sharedExtendedConfigFileWatchers=new Map,this.extendedConfigCache=new Map,this.baseline=ja,this.verifyDocumentRegistry=ja,this.verifyProgram=ja,this.onProjectCreation=ja;var n;this.host=t.host,this.logger=t.logger,this.cancellationToken=t.cancellationToken,this.useSingleInferredProject=t.useSingleInferredProject,this.useInferredProjectPerProjectRoot=t.useInferredProjectPerProjectRoot,this.typingsInstaller=t.typingsInstaller||Wq,this.throttleWaitMilliseconds=t.throttleWaitMilliseconds,this.eventHandler=t.eventHandler,this.suppressDiagnosticEvents=t.suppressDiagnosticEvents,this.globalPlugins=t.globalPlugins||Vl,this.pluginProbeLocations=t.pluginProbeLocations||Vl,this.allowLocalPluginLoads=!!t.allowLocalPluginLoads,this.typesMapLocation=t.typesMapLocation===void 0?li(hi(this.getExecutingFilePath()),"typesMap.json"):t.typesMapLocation,this.session=t.session,this.jsDocParsingMode=t.jsDocParsingMode,t.serverMode!==void 0?this.serverMode=t.serverMode:this.serverMode=0,this.host.realpath&&(this.realpathToScriptInfos=g_()),this.currentDirectory=Cc(this.host.getCurrentDirectory()),this.toCanonicalFileName=y_(this.host.useCaseSensitiveFileNames),this.globalCacheLocationDirectoryPath=this.typingsInstaller.globalTypingsCacheLocation?hu(this.toPath(this.typingsInstaller.globalTypingsCacheLocation)):void 0,this.throttledOperations=new hse(this.host,this.logger),this.typesMapLocation?this.loadTypesMap():this.logger.info("No types map provided; using the default"),this.typingsInstaller.attach(this),this.typingsCache=new bse(this.typingsInstaller),this.hostConfiguration={formatCodeOptions:YV(this.host.newLine),preferences:Md,hostInfo:"Unknown host",extraFileExtensions:[]},this.documentRegistry=ore(this.host.useCaseSensitiveFileNames,this.currentDirectory,this.jsDocParsingMode,this);let i=this.logger.hasLevel(3)?2:this.logger.loggingEnabled()?1:0,s=i!==0?o=>this.logger.info(o):ja;this.packageJsonCache=U2e(this),this.watchFactory=this.serverMode!==0?{watchFile:vD,watchDirectory:vD}:OZ(u8t(this,t.canUseWatchEvents)||this.host,i,s,l8t),(n=t.incrementalVerifier)==null||n.call(t,this)}toPath(t){return gc(t,this.currentDirectory,this.toCanonicalFileName)}getExecutingFilePath(){return this.getNormalizedAbsolutePath(this.host.getExecutingFilePath())}getNormalizedAbsolutePath(t){return Ps(t,this.host.getCurrentDirectory())}setDocument(t,n,i){let s=I.checkDefined(this.getScriptInfoForPath(n));s.cacheSourceFile={key:t,sourceFile:i}}getDocument(t,n){let i=this.getScriptInfoForPath(n);return i&&i.cacheSourceFile&&i.cacheSourceFile.key===t?i.cacheSourceFile.sourceFile:void 0}ensureInferredProjectsUpToDate_TestOnly(){this.ensureProjectStructuresUptoDate()}getCompilerOptionsForInferredProjects(){return this.compilerOptionsForInferredProjects}onUpdateLanguageServiceStateForProject(t,n){if(!this.eventHandler)return;let i={eventName:tz,data:{project:t,languageServiceEnabled:n}};this.eventHandler(i)}loadTypesMap(){try{let t=this.host.readFile(this.typesMapLocation);if(t===void 0){this.logger.info(`Provided types map file "${this.typesMapLocation}" doesn't exist`);return}let n=JSON.parse(t);for(let i of Object.keys(n.typesMap))n.typesMap[i].match=new RegExp(n.typesMap[i].match,"i");this.safelist=n.typesMap;for(let i in n.simpleMap)wo(n.simpleMap,i)&&this.legacySafelist.set(i,n.simpleMap[i].toLowerCase())}catch(t){this.logger.info(`Error loading types map: ${t}`),this.safelist=Ose,this.legacySafelist.clear()}}updateTypingsForProject(t){let n=this.findProject(t.projectName);if(n)switch(t.kind){case BM:n.updateTypingFiles(this.typingsCache.updateTypingsForProject(t.projectName,t.compilerOptions,t.typeAcquisition,t.unresolvedImports,t.typings));return;case UM:this.typingsCache.enqueueInstallTypingsForProject(n,n.lastCachedUnresolvedImportsList,!0);return}}watchTypingLocations(t){var n;(n=this.findProject(t.projectName))==null||n.watchTypingLocations(t.files)}delayEnsureProjectForOpenFiles(){this.openFiles.size&&(this.pendingEnsureProjectForOpenFiles=!0,this.throttledOperations.schedule(F2e,2500,()=>{this.pendingProjectUpdates.size!==0?this.delayEnsureProjectForOpenFiles():this.pendingEnsureProjectForOpenFiles&&(this.ensureProjectForOpenFiles(),this.sendProjectsUpdatedInBackgroundEvent())}))}delayUpdateProjectGraph(t){if(t.markAsDirty(),nL(t))return;let n=t.getProjectName();this.pendingProjectUpdates.set(n,t),this.throttledOperations.schedule(n,250,()=>{this.pendingProjectUpdates.delete(n)&&qp(t)})}hasPendingProjectUpdate(t){return this.pendingProjectUpdates.has(t.getProjectName())}sendProjectsUpdatedInBackgroundEvent(){if(!this.eventHandler)return;let t={eventName:sL,data:{openFiles:In(this.openFiles.keys(),n=>this.getScriptInfoForPath(n).fileName)}};this.eventHandler(t)}sendLargeFileReferencedEvent(t,n){if(!this.eventHandler)return;let i={eventName:Zq,data:{file:t,fileSize:n,maxFileSize:Xq}};this.eventHandler(i)}sendProjectLoadingStartEvent(t,n){if(!this.eventHandler)return;t.sendLoadingProjectFinish=!0;let i={eventName:Kq,data:{project:t,reason:n}};this.eventHandler(i)}sendProjectLoadingFinishEvent(t){if(!this.eventHandler||!t.sendLoadingProjectFinish)return;t.sendLoadingProjectFinish=!1;let n={eventName:Qq,data:{project:t}};this.eventHandler(n)}sendPerformanceEvent(t,n){this.performanceEventHandler&&this.performanceEventHandler({kind:t,durationMs:n})}delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(t){this.delayUpdateProjectGraph(t),this.delayEnsureProjectForOpenFiles()}delayUpdateProjectGraphs(t,n){if(t.length){for(let i of t)n&&i.clearSourceMapperCache(),this.delayUpdateProjectGraph(i);this.delayEnsureProjectForOpenFiles()}}setCompilerOptionsForInferredProjects(t,n){I.assert(n===void 0||this.useInferredProjectPerProjectRoot,"Setting compiler options per project root path is only supported when useInferredProjectPerProjectRoot is enabled");let i=Hq(t),s=iL(t,n),o=P2e(t);i.allowNonTsExtensions=!0;let l=n&&this.toCanonicalFileName(n);l?(this.compilerOptionsForInferredProjectsPerProjectRoot.set(l,i),this.watchOptionsForInferredProjectsPerProjectRoot.set(l,s||!1),this.typeAcquisitionForInferredProjectsPerProjectRoot.set(l,o)):(this.compilerOptionsForInferredProjects=i,this.watchOptionsForInferredProjects=s,this.typeAcquisitionForInferredProjects=o);for(let p of this.inferredProjects)(l?p.projectRootPath===l:!p.projectRootPath||!this.compilerOptionsForInferredProjectsPerProjectRoot.has(p.projectRootPath))&&(p.setCompilerOptions(i),p.setTypeAcquisition(o),p.setWatchOptions(s?.watchOptions),p.setProjectErrors(s?.errors),p.compileOnSaveEnabled=i.compileOnSave,p.markAsDirty(),this.delayUpdateProjectGraph(p));this.delayEnsureProjectForOpenFiles()}findProject(t){if(t!==void 0)return i2e(t)?hqe(t,this.inferredProjects):this.findExternalProjectByProjectName(t)||this.findConfiguredProjectByProjectName(Cc(t))}forEachProject(t){this.externalProjects.forEach(t),this.configuredProjects.forEach(t),this.inferredProjects.forEach(t)}forEachEnabledProject(t){this.forEachProject(n=>{!n.isOrphan()&&n.languageServiceEnabled&&t(n)})}getDefaultProjectForFile(t,n){return n?this.ensureDefaultProjectForFile(t):this.tryGetDefaultProjectForFile(t)}tryGetDefaultProjectForFile(t){let n=vs(t)?this.getScriptInfoForNormalizedPath(t):t;return n&&!n.isOrphan()?n.getDefaultProject():void 0}ensureDefaultProjectForFile(t){return this.tryGetDefaultProjectForFile(t)||this.doEnsureDefaultProjectForFile(t)}doEnsureDefaultProjectForFile(t){this.ensureProjectStructuresUptoDate();let n=vs(t)?this.getScriptInfoForNormalizedPath(t):t;return n?n.getDefaultProject():(this.logErrorForScriptInfoNotFound(vs(t)?t:t.fileName),G1.ThrowNoProject())}getScriptInfoEnsuringProjectsUptoDate(t){return this.ensureProjectStructuresUptoDate(),this.getScriptInfo(t)}ensureProjectStructuresUptoDate(){let t=this.pendingEnsureProjectForOpenFiles;this.pendingProjectUpdates.clear();let n=i=>{t=qp(i)||t};this.externalProjects.forEach(n),this.configuredProjects.forEach(n),this.inferredProjects.forEach(n),t&&this.ensureProjectForOpenFiles()}getFormatCodeOptions(t){let n=this.getScriptInfoForNormalizedPath(t);return n&&n.getFormatCodeSettings()||this.hostConfiguration.formatCodeOptions}getPreferences(t){let n=this.getScriptInfoForNormalizedPath(t);return{...this.hostConfiguration.preferences,...n&&n.getPreferences()}}getHostFormatCodeOptions(){return this.hostConfiguration.formatCodeOptions}getHostPreferences(){return this.hostConfiguration.preferences}onSourceFileChanged(t,n){n===2?this.handleDeletedFile(t):t.isScriptOpen()||(t.delayReloadNonMixedContentFile(),this.delayUpdateProjectGraphs(t.containingProjects,!1),this.handleSourceMapProjects(t))}handleSourceMapProjects(t){if(t.sourceMapFilePath)if(vs(t.sourceMapFilePath)){let n=this.getScriptInfoForPath(t.sourceMapFilePath);this.delayUpdateSourceInfoProjects(n&&n.sourceInfos)}else this.delayUpdateSourceInfoProjects(t.sourceMapFilePath.sourceInfos);this.delayUpdateSourceInfoProjects(t.sourceInfos),t.declarationInfoPath&&this.delayUpdateProjectsOfScriptInfoPath(t.declarationInfoPath)}delayUpdateSourceInfoProjects(t){t&&t.forEach((n,i)=>this.delayUpdateProjectsOfScriptInfoPath(i))}delayUpdateProjectsOfScriptInfoPath(t){let n=this.getScriptInfoForPath(t);n&&this.delayUpdateProjectGraphs(n.containingProjects,!0)}handleDeletedFile(t){if(this.stopWatchingScriptInfo(t),!t.isScriptOpen()){this.deleteScriptInfo(t);let n=t.containingProjects.slice();if(t.detachAllProjects(),this.delayUpdateProjectGraphs(n,!1),this.handleSourceMapProjects(t),t.closeSourceMapFileWatcher(),t.declarationInfoPath){let i=this.getScriptInfoForPath(t.declarationInfoPath);i&&(i.sourceMapFilePath=void 0)}}}watchWildcardDirectory(t,n,i,s){let o=this.watchFactory.watchDirectory(t,p=>{let m=this.toPath(p),S=s.cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(p,m);if(Cl(m)==="package.json"&&!f7(m)&&(S&&S.fileExists||!S&&this.host.fileExists(p))){let b=this.getNormalizedAbsolutePath(p);this.logger.info(`Config: ${i} Detected new package.json: ${b}`),this.packageJsonCache.addOrUpdate(b,m),this.watchPackageJsonFile(b,m,l)}let h=this.findConfiguredProjectByProjectName(i);NM({watchedDirPath:this.toPath(t),fileOrDirectory:p,fileOrDirectoryPath:m,configFileName:i,extraFileExtensions:this.hostConfiguration.extraFileExtensions,currentDirectory:this.currentDirectory,options:s.parsedCommandLine.options,program:h?.getCurrentProgram()||s.parsedCommandLine.fileNames,useCaseSensitiveFileNames:this.host.useCaseSensitiveFileNames,writeLog:b=>this.logger.info(b),toPath:b=>this.toPath(b),getScriptKind:h?b=>h.getScriptKind(b):void 0})||(s.updateLevel!==2&&(s.updateLevel=1),s.projects.forEach((b,A)=>{if(!b)return;let k=this.getConfiguredProjectByCanonicalConfigFilePath(A);if(!k)return;let N=h===k?1:0;if(!(k.pendingUpdateLevel!==void 0&&k.pendingUpdateLevel>N))if(this.openFiles.has(m))if(I.checkDefined(this.getScriptInfoForPath(m)).isAttached(k)){let O=Math.max(N,k.openFileWatchTriggered.get(m)||0);k.openFileWatchTriggered.set(m,O)}else k.pendingUpdateLevel=N,this.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(k);else k.pendingUpdateLevel=N,this.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(k)}))},n,this.getWatchOptionsFromProjectWatchOptions(s.parsedCommandLine.watchOptions),_u.WildcardDirectory,i),l={packageJsonWatches:void 0,close(){var p;o&&(o.close(),o=void 0,(p=l.packageJsonWatches)==null||p.forEach(m=>{m.projects.delete(l),m.close()}),l.packageJsonWatches=void 0)}};return l}delayUpdateProjectsFromParsedConfigOnConfigFileChange(t,n){let i=this.configFileExistenceInfoCache.get(t);if(!i?.config)return!1;let s=!1;return i.config.updateLevel=2,i.config.projects.forEach((o,l)=>{let p=this.getConfiguredProjectByCanonicalConfigFilePath(l);if(p)if(s=!0,l===t){if(p.isInitialLoadPending())return;p.pendingUpdateLevel=2,p.pendingUpdateReason=n,this.delayUpdateProjectGraph(p)}else p.resolutionCache.removeResolutionsFromProjectReferenceRedirects(this.toPath(t)),this.delayUpdateProjectGraph(p)}),s}onConfigFileChanged(t,n){var i;let s=this.configFileExistenceInfoCache.get(t);if(n===2){s.exists=!1;let o=(i=s.config)!=null&&i.projects.has(t)?this.getConfiguredProjectByCanonicalConfigFilePath(t):void 0;o&&this.removeProject(o)}else s.exists=!0;this.delayUpdateProjectsFromParsedConfigOnConfigFileChange(t,"Change in config file detected"),this.reloadConfiguredProjectForFiles(s.openFilesImpactedByConfigFile,!1,!0,n!==2?Mo:em,"Change in config file detected"),this.delayEnsureProjectForOpenFiles()}removeProject(t){switch(this.logger.info("`remove Project::"),t.print(!0,!0,!1),t.close(),I.shouldAssert(1)&&this.filenameToScriptInfo.forEach(n=>I.assert(!n.isAttached(t),"Found script Info still attached to project",()=>`${t.projectName}: ScriptInfos still attached: ${JSON.stringify(In(S0(this.filenameToScriptInfo.values(),i=>i.isAttached(t)?{fileName:i.fileName,projects:i.containingProjects.map(s=>s.projectName),hasMixedContent:i.hasMixedContent}:void 0)),void 0," ")}`)),this.pendingProjectUpdates.delete(t.getProjectName()),t.projectKind){case 2:uA(this.externalProjects,t),this.projectToSizeMap.delete(t.getProjectName());break;case 1:this.configuredProjects.delete(t.canonicalConfigFilePath),this.projectToSizeMap.delete(t.canonicalConfigFilePath);break;case 0:uA(this.inferredProjects,t);break}}assignOrphanScriptInfoToInferredProject(t,n){I.assert(t.isOrphan());let i=this.getOrCreateInferredProjectForProjectRootPathIfEnabled(t,n)||this.getOrCreateSingleInferredProjectIfEnabled()||this.getOrCreateSingleInferredWithoutProjectRoot(t.isDynamic?n||this.currentDirectory:hi(ap(t.fileName)?t.fileName:Ps(t.fileName,n?this.getNormalizedAbsolutePath(n):this.currentDirectory)));if(i.addRoot(t),t.containingProjects[0]!==i&&(lA(t.containingProjects,i),t.containingProjects.unshift(i)),i.updateGraph(),!this.useSingleInferredProject&&!i.projectRootPath)for(let s of this.inferredProjects){if(s===i||s.isOrphan())continue;let o=s.getRootScriptInfos();I.assert(o.length===1||!!s.projectRootPath),o.length===1&&Te(o[0].containingProjects,l=>l!==o[0].containingProjects[0]&&!l.isOrphan())&&s.removeFile(o[0],!0,!0)}return i}assignOrphanScriptInfosToInferredProject(){this.openFiles.forEach((t,n)=>{let i=this.getScriptInfoForPath(n);i.isOrphan()&&this.assignOrphanScriptInfoToInferredProject(i,t)})}closeOpenFile(t,n){let i=t.isDynamic?!1:this.host.fileExists(t.fileName);t.close(i),this.stopWatchingConfigFilesForClosedScriptInfo(t);let s=this.toCanonicalFileName(t.fileName);this.openFilesWithNonRootedDiskPath.get(s)===t&&this.openFilesWithNonRootedDiskPath.delete(s);let o=!1;for(let l of t.containingProjects){if(JT(l)){t.hasMixedContent&&t.registerFileUpdate();let p=l.openFileWatchTriggered.get(t.path);p!==void 0&&(l.openFileWatchTriggered.delete(t.path),l.pendingUpdateLevel!==void 0&&l.pendingUpdateLevel<p&&(l.pendingUpdateLevel=p,l.markFileAsDirty(t.path)))}else $D(l)&&l.isRoot(t)&&(l.isProjectWithSingleRoot()&&(o=!0),l.removeFile(t,i,!0));l.languageServiceEnabled||l.markAsDirty()}return this.openFiles.delete(t.path),this.configFileForOpenFiles.delete(t.path),!n&&o&&this.assignOrphanScriptInfosToInferredProject(),i?this.watchClosedScriptInfo(t):this.handleDeletedFile(t),o}deleteScriptInfo(t){this.filenameToScriptInfo.delete(t.path),this.filenameToScriptInfoVersion.set(t.path,t.textStorage.version);let n=t.getRealpathIfDifferent();n&&this.realpathToScriptInfos.remove(n,t)}configFileExists(t,n,i){var s;let o=this.configFileExistenceInfoCache.get(n);if(o)return Ise(i)&&!((s=o.openFilesImpactedByConfigFile)!=null&&s.has(i.path))&&(o.openFilesImpactedByConfigFile||(o.openFilesImpactedByConfigFile=new Map)).set(i.path,!1),o.exists;let l=this.host.fileExists(t),p;return Ise(i)&&(p||(p=new Map)).set(i.path,!1),o={exists:l,openFilesImpactedByConfigFile:p},this.configFileExistenceInfoCache.set(n,o),l}createConfigFileWatcherForParsedConfig(t,n,i){var s,o;let l=this.configFileExistenceInfoCache.get(n);(!l.watcher||l.watcher===Rse)&&(l.watcher=this.watchFactory.watchFile(t,(m,S)=>this.onConfigFileChanged(n,S),2e3,this.getWatchOptionsFromProjectWatchOptions((o=(s=l?.config)==null?void 0:s.parsedCommandLine)==null?void 0:o.watchOptions),_u.ConfigFile,i));let p=l.config.projects;p.set(i.canonicalConfigFilePath,p.get(i.canonicalConfigFilePath)||!1)}configFileExistenceImpactsRootOfInferredProject(t){return t.openFilesImpactedByConfigFile&&yu(t.openFilesImpactedByConfigFile,Mo)}releaseParsedConfig(t,n){var i,s,o;let l=this.configFileExistenceInfoCache.get(t);(i=l.config)!=null&&i.projects.delete(n.canonicalConfigFilePath)&&((s=l.config)!=null&&s.projects.size||(l.config=void 0,IZ(t,this.sharedExtendedConfigFileWatchers),I.checkDefined(l.watcher),(o=l.openFilesImpactedByConfigFile)!=null&&o.size?this.configFileExistenceImpactsRootOfInferredProject(l)?wV(gu(hi(t)))||(l.watcher.close(),l.watcher=Rse):(l.watcher.close(),l.watcher=void 0):(l.watcher.close(),this.configFileExistenceInfoCache.delete(t))))}closeConfigFileWatcherOnReleaseOfOpenFile(t){t.watcher&&!t.config&&!this.configFileExistenceImpactsRootOfInferredProject(t)&&(t.watcher.close(),t.watcher=void 0)}stopWatchingConfigFilesForClosedScriptInfo(t){I.assert(!t.isScriptOpen()),this.forEachConfigFileLocation(t,n=>{var i,s,o;let l=this.configFileExistenceInfoCache.get(n);if(l){let p=(i=l.openFilesImpactedByConfigFile)==null?void 0:i.get(t.path);(s=l.openFilesImpactedByConfigFile)==null||s.delete(t.path),p&&this.closeConfigFileWatcherOnReleaseOfOpenFile(l),!((o=l.openFilesImpactedByConfigFile)!=null&&o.size)&&!l.config&&(I.assert(!l.watcher),this.configFileExistenceInfoCache.delete(n))}})}startWatchingConfigFilesForInferredProjectRoot(t){I.assert(t.isScriptOpen()),this.forEachConfigFileLocation(t,(n,i)=>{let s=this.configFileExistenceInfoCache.get(n);s||(s={exists:this.host.fileExists(i)},this.configFileExistenceInfoCache.set(n,s)),(s.openFilesImpactedByConfigFile||(s.openFilesImpactedByConfigFile=new Map)).set(t.path,!0),s.watcher||(s.watcher=wV(gu(hi(n)))?this.watchFactory.watchFile(i,(o,l)=>this.onConfigFileChanged(n,l),2e3,this.hostConfiguration.watchOptions,_u.ConfigFileForInferredRoot):Rse)})}stopWatchingConfigFilesForInferredProjectRoot(t){this.forEachConfigFileLocation(t,n=>{var i;let s=this.configFileExistenceInfoCache.get(n);(i=s?.openFilesImpactedByConfigFile)!=null&&i.has(t.path)&&(I.assert(t.isScriptOpen()),s.openFilesImpactedByConfigFile.set(t.path,!1),this.closeConfigFileWatcherOnReleaseOfOpenFile(s))})}forEachConfigFileLocation(t,n){if(this.serverMode!==0)return;I.assert(!Ise(t)||this.openFiles.has(t.path));let i=this.openFiles.get(t.path);if(I.checkDefined(this.getScriptInfo(t.path)).isDynamic)return;let o=hi(t.fileName),l=()=>wm(i,o,this.currentDirectory,!this.host.useCaseSensitiveFileNames),p=!i||!l(),m=!yqe(t);do{if(m){let h=eL(o,this.currentDirectory,this.toCanonicalFileName),b=li(o,"tsconfig.json"),A=n(li(h,"tsconfig.json"),b);if(A)return b;let k=li(o,"jsconfig.json");if(A=n(li(h,"jsconfig.json"),k),A)return k;if(f9(h))break}let S=hi(o);if(S===o)break;o=S,m=!0}while(p||l())}findDefaultConfiguredProject(t){if(!t.isScriptOpen())return;let n=this.getConfigFileNameForFile(t),i=n&&this.findConfiguredProjectByProjectName(n);return i&&Ik(i,t)?i:i?.getDefaultChildProjectFromProjectWithReferences(t)}getConfigFileNameForFile(t){if(!yqe(t)){let i=this.configFileForOpenFiles.get(t.path);if(i!==void 0)return i||void 0}this.logger.info(`Search path: ${hi(t.fileName)}`);let n=this.forEachConfigFileLocation(t,(i,s)=>this.configFileExists(s,i,t));return n?this.logger.info(`For info: ${t.fileName} :: Config file name: ${n}`):this.logger.info(`For info: ${t.fileName} :: No config files found.`),Ise(t)&&this.configFileForOpenFiles.set(t.path,n||!1),n}printProjects(){this.logger.hasLevel(1)&&(this.logger.startGroup(),this.externalProjects.forEach(L2e),this.configuredProjects.forEach(L2e),this.inferredProjects.forEach(L2e),this.logger.info("Open files: "),this.openFiles.forEach((t,n)=>{let i=this.getScriptInfoForPath(n);this.logger.info(`	FileName: ${i.fileName} ProjectRootPath: ${t}`),this.logger.info(`		Projects: ${i.containingProjects.map(s=>s.getProjectName())}`)}),this.logger.endGroup())}findConfiguredProjectByProjectName(t){let n=this.toCanonicalFileName(t);return this.getConfiguredProjectByCanonicalConfigFilePath(n)}getConfiguredProjectByCanonicalConfigFilePath(t){return this.configuredProjects.get(t)}findExternalProjectByProjectName(t){return hqe(t,this.externalProjects)}getFilenameForExceededTotalSizeLimitForNonTsFiles(t,n,i,s){if(n&&n.disableSizeLimit||!this.host.getFileSize)return;let o=Yq;this.projectToSizeMap.set(t,0),this.projectToSizeMap.forEach(p=>o-=p||0);let l=0;for(let p of i){let m=s.getFileName(p);if(!LA(m)&&(l+=this.host.getFileSize(m),l>Yq||l>o)){let S=i.map(h=>s.getFileName(h)).filter(h=>!LA(h)).map(h=>({name:h,size:this.host.getFileSize(h)})).sort((h,b)=>b.size-h.size).slice(0,5);return this.logger.info(`Non TS file size exceeded limit (${l}). Largest files: ${S.map(h=>`${h.name}:${h.size}`).join(", ")}`),m}}this.projectToSizeMap.set(t,l)}createExternalProject(t,n,i,s,o){let l=Hq(i),p=iL(i,hi(v_(t))),m=new Gq(t,this,this.documentRegistry,l,this.getFilenameForExceededTotalSizeLimitForNonTsFiles(t,l,n,oz),i.compileOnSave===void 0?!0:i.compileOnSave,void 0,p?.watchOptions);return m.setProjectErrors(p?.errors),m.excludedFiles=o,this.addFilesToNonInferredProject(m,n,oz,s),this.externalProjects.push(m),m}sendProjectTelemetry(t){if(this.seenProjects.has(t.projectName)){w2e(t);return}if(this.seenProjects.set(t.projectName,!0),!this.eventHandler||!this.host.createSHA256Hash){w2e(t);return}let n=JT(t)?t.projectOptions:void 0;w2e(t);let i={projectId:this.host.createSHA256Hash(t.projectName),fileStats:rL(t.getScriptInfos(),!0),compilerOptions:yhe(t.getCompilationSettings()),typeAcquisition:o(t.getTypeAcquisition()),extends:n&&n.configHasExtendsProperty,files:n&&n.configHasFilesProperty,include:n&&n.configHasIncludeProperty,exclude:n&&n.configHasExcludeProperty,compileOnSave:t.compileOnSaveEnabled,configFileName:s(),projectType:t instanceof Gq?"external":"configured",languageServiceEnabled:t.languageServiceEnabled,version:F};this.eventHandler({eventName:rz,data:i});function s(){return JT(t)&&gse(t.getConfigFilePath())||"other"}function o({enable:l,include:p,exclude:m}){return{enable:l,include:p!==void 0&&p.length!==0,exclude:m!==void 0&&m.length!==0}}}addFilesToNonInferredProject(t,n,i,s){this.updateNonInferredProjectFiles(t,n,i),t.setTypeAcquisition(s),t.markAsDirty()}createConfiguredProject(t){var n;(n=mn)==null||n.instant(mn.Phase.Session,"createConfiguredProject",{configFilePath:t}),this.logger.info(`Creating configuration project ${t}`);let i=this.toCanonicalFileName(t),s=this.configFileExistenceInfoCache.get(i);s?s.exists=!0:this.configFileExistenceInfoCache.set(i,s={exists:!0}),s.config||(s.config={cachedDirectoryStructureHost:hV(this.host,this.host.getCurrentDirectory(),this.host.useCaseSensitiveFileNames),projects:new Map,updateLevel:2});let o=new Pse(t,i,this,this.documentRegistry,s.config.cachedDirectoryStructureHost);return this.configuredProjects.set(i,o),this.createConfigFileWatcherForParsedConfig(t,i,o),o}createConfiguredProjectWithDelayLoad(t,n){let i=this.createConfiguredProject(t);return i.pendingUpdateLevel=2,i.pendingUpdateReason=n,i}createAndLoadConfiguredProject(t,n){let i=this.createConfiguredProject(t);return this.loadConfiguredProject(i,n),i}createLoadAndUpdateConfiguredProject(t,n){let i=this.createAndLoadConfiguredProject(t,n);return i.updateGraph(),i}loadConfiguredProject(t,n){var i,s;(i=mn)==null||i.push(mn.Phase.Session,"loadConfiguredProject",{configFilePath:t.canonicalConfigFilePath}),this.sendProjectLoadingStartEvent(t,n);let o=Ca(t.getConfigFilePath()),l=this.ensureParsedConfigUptoDate(o,t.canonicalConfigFilePath,this.configFileExistenceInfoCache.get(t.canonicalConfigFilePath),t),p=l.config.parsedCommandLine;I.assert(!!p.fileNames);let m=p.options;t.projectOptions||(t.projectOptions={configHasExtendsProperty:p.raw.extends!==void 0,configHasFilesProperty:p.raw.files!==void 0,configHasIncludeProperty:p.raw.include!==void 0,configHasExcludeProperty:p.raw.exclude!==void 0}),t.canConfigFileJsonReportNoInputFiles=K6(p.raw),t.setProjectErrors(p.options.configFile.parseDiagnostics),t.updateReferences(p.projectReferences);let S=this.getFilenameForExceededTotalSizeLimitForNonTsFiles(t.canonicalConfigFilePath,m,p.fileNames,az);S?(t.disableLanguageService(S),this.configFileExistenceInfoCache.forEach((b,A)=>this.stopWatchingWildCards(A,t))):(t.setCompilerOptions(m),t.setWatchOptions(p.watchOptions),t.enableLanguageService(),this.watchWildcards(o,l,t)),t.enablePluginsWithOptions(m);let h=p.fileNames.concat(t.getExternalFiles(2));this.updateRootAndOptionsOfNonInferredProject(t,h,az,m,p.typeAcquisition,p.compileOnSave,p.watchOptions),(s=mn)==null||s.pop()}ensureParsedConfigUptoDate(t,n,i,s){var o,l,p;if(i.config){if(!i.config.updateLevel)return i;if(i.config.updateLevel===1)return this.reloadFileNamesOfParsedConfig(t,i.config),i}let m=((o=i.config)==null?void 0:o.cachedDirectoryStructureHost)||hV(this.host,this.host.getCurrentDirectory(),this.host.useCaseSensitiveFileNames),S=X6(t,N=>this.host.readFile(N)),h=QR(t,vs(S)?S:""),b=h.parseDiagnostics;vs(S)||b.push(S);let A=rM(h,m,hi(t),{},t,[],this.hostConfiguration.extraFileExtensions,this.extendedConfigCache);A.errors.length&&b.push(...A.errors),this.logger.info(`Config: ${t} : ${JSON.stringify({rootNames:A.fileNames,options:A.options,watchOptions:A.watchOptions,projectReferences:A.projectReferences},void 0," ")}`);let k=(l=i.config)==null?void 0:l.parsedCommandLine;return i.config?(i.config.parsedCommandLine=A,i.config.watchedDirectoriesStale=!0,i.config.updateLevel=void 0):i.config={parsedCommandLine:A,cachedDirectoryStructureHost:m,projects:new Map},!k&&!nB(this.getWatchOptionsFromProjectWatchOptions(void 0),this.getWatchOptionsFromProjectWatchOptions(A.watchOptions))&&((p=i.watcher)==null||p.close(),i.watcher=void 0),this.createConfigFileWatcherForParsedConfig(t,n,s),yV(n,A.options,this.sharedExtendedConfigFileWatchers,(N,M)=>this.watchFactory.watchFile(N,()=>{var O;vV(this.extendedConfigCache,M,H=>this.toPath(H));let U=!1;(O=this.sharedExtendedConfigFileWatchers.get(M))==null||O.projects.forEach(H=>{U=this.delayUpdateProjectsFromParsedConfigOnConfigFileChange(H,`Change in extended config file ${N} detected`)||U}),U&&this.delayEnsureProjectForOpenFiles()},2e3,this.hostConfiguration.watchOptions,_u.ExtendedConfigFile,t),N=>this.toPath(N)),i}watchWildcards(t,{exists:n,config:i},s){if(i.projects.set(s.canonicalConfigFilePath,!0),n){if(i.watchedDirectories&&!i.watchedDirectoriesStale)return;i.watchedDirectoriesStale=!1,PM(i.watchedDirectories||(i.watchedDirectories=new Map),i.parsedCommandLine.wildcardDirectories,(o,l)=>this.watchWildcardDirectory(o,l,t,i))}else{if(i.watchedDirectoriesStale=!1,!i.watchedDirectories)return;Wf(i.watchedDirectories,Od),i.watchedDirectories=void 0}}stopWatchingWildCards(t,n){let i=this.configFileExistenceInfoCache.get(t);!i.config||!i.config.projects.get(n.canonicalConfigFilePath)||(i.config.projects.set(n.canonicalConfigFilePath,!1),!yu(i.config.projects,Mo)&&(i.config.watchedDirectories&&(Wf(i.config.watchedDirectories,Od),i.config.watchedDirectories=void 0),i.config.watchedDirectoriesStale=void 0))}updateNonInferredProjectFiles(t,n,i){let s=t.getRootFilesMap(),o=new Map;for(let l of n){let p=i.getFileName(l),m=Cc(p),S=tL(m),h;if(!S&&!t.fileExists(p)){h=eL(m,this.currentDirectory,this.toCanonicalFileName);let b=s.get(h);b?(b.info&&(t.removeFile(b.info,!1,!0),b.info=void 0),b.fileName=m):s.set(h,{fileName:m})}else{let b=i.getScriptKind(l,this.hostConfiguration.extraFileExtensions),A=i.hasMixedContent(l,this.hostConfiguration.extraFileExtensions),k=I.checkDefined(this.getOrCreateScriptInfoNotOpenedByClientForNormalizedPath(m,t.currentDirectory,b,A,t.directoryStructureHost));h=k.path;let N=s.get(h);!N||N.info!==k?(t.addRoot(k,m),k.isScriptOpen()&&this.removeRootOfInferredProjectIfNowPartOfOtherProject(k)):N.fileName=m}o.set(h,!0)}s.size>o.size&&s.forEach((l,p)=>{o.has(p)||(l.info?t.removeFile(l.info,t.fileExists(l.info.fileName),!0):s.delete(p))})}updateRootAndOptionsOfNonInferredProject(t,n,i,s,o,l,p){t.setCompilerOptions(s),t.setWatchOptions(p),l!==void 0&&(t.compileOnSaveEnabled=l),this.addFilesToNonInferredProject(t,n,i,o)}reloadFileNamesOfConfiguredProject(t){let n=this.reloadFileNamesOfParsedConfig(t.getConfigFilePath(),this.configFileExistenceInfoCache.get(t.canonicalConfigFilePath).config);return t.updateErrorOnNoInputFiles(n),this.updateNonInferredProjectFiles(t,n.concat(t.getExternalFiles(1)),az),t.markAsDirty(),t.updateGraph()}reloadFileNamesOfParsedConfig(t,n){if(n.updateLevel===void 0)return n.parsedCommandLine.fileNames;I.assert(n.updateLevel===1);let i=n.parsedCommandLine.options.configFile.configFileSpecs,s=Q6(i,hi(t),n.parsedCommandLine.options,n.cachedDirectoryStructureHost,this.hostConfiguration.extraFileExtensions);return n.parsedCommandLine={...n.parsedCommandLine,fileNames:s},s}setFileNamesOfAutpImportProviderOrAuxillaryProject(t,n){this.updateNonInferredProjectFiles(t,n,az)}reloadConfiguredProject(t,n,i,s){let o=t.getCachedDirectoryStructureHost();s&&this.clearSemanticCache(t),o.clearCache();let l=t.getConfigFilePath();this.logger.info(`${i?"Loading":"Reloading"} configured project ${l}`),this.loadConfiguredProject(t,n),t.updateGraph(),this.sendConfigFileDiagEvent(t,l)}clearSemanticCache(t){t.resolutionCache.clear(),t.getLanguageService(!1).cleanupSemanticCache(),t.cleanupProgram(),t.markAsDirty()}sendConfigFileDiagEvent(t,n){if(!this.eventHandler||this.suppressDiagnosticEvents)return;let i=t.getLanguageService().getCompilerOptionsDiagnostics();i.push(...t.getAllProjectErrors()),this.eventHandler({eventName:ez,data:{configFileName:t.getConfigFilePath(),diagnostics:i,triggerFile:n}})}getOrCreateInferredProjectForProjectRootPathIfEnabled(t,n){if(!this.useInferredProjectPerProjectRoot||t.isDynamic&&n===void 0)return;if(n){let s=this.toCanonicalFileName(n);for(let o of this.inferredProjects)if(o.projectRootPath===s)return o;return this.createInferredProject(n,!1,n)}let i;for(let s of this.inferredProjects)s.projectRootPath&&wm(s.projectRootPath,t.path,this.host.getCurrentDirectory(),!this.host.useCaseSensitiveFileNames)&&(i&&i.projectRootPath.length>s.projectRootPath.length||(i=s));return i}getOrCreateSingleInferredProjectIfEnabled(){if(this.useSingleInferredProject)return this.inferredProjects.length>0&&this.inferredProjects[0].projectRootPath===void 0?this.inferredProjects[0]:this.createInferredProject("",!0)}getOrCreateSingleInferredWithoutProjectRoot(t){I.assert(!this.useSingleInferredProject);let n=this.toCanonicalFileName(this.getNormalizedAbsolutePath(t));for(let i of this.inferredProjects)if(!i.projectRootPath&&i.isOrphan()&&i.canonicalCurrentDirectory===n)return i;return this.createInferredProject(t)}createInferredProject(t,n,i){let s=i&&this.compilerOptionsForInferredProjectsPerProjectRoot.get(i)||this.compilerOptionsForInferredProjects,o,l;i&&(o=this.watchOptionsForInferredProjectsPerProjectRoot.get(i),l=this.typeAcquisitionForInferredProjectsPerProjectRoot.get(i)),o===void 0&&(o=this.watchOptionsForInferredProjects),l===void 0&&(l=this.typeAcquisitionForInferredProjects),o=o||void 0;let p=new xse(this,this.documentRegistry,s,o?.watchOptions,i,t,l);return p.setProjectErrors(o?.errors),n?this.inferredProjects.unshift(p):this.inferredProjects.push(p),p}getOrCreateScriptInfoNotOpenedByClient(t,n,i){return this.getOrCreateScriptInfoNotOpenedByClientForNormalizedPath(Cc(t),n,void 0,void 0,i)}getScriptInfo(t){return this.getScriptInfoForNormalizedPath(Cc(t))}getScriptInfoOrConfig(t){let n=Cc(t),i=this.getScriptInfoForNormalizedPath(n);if(i)return i;let s=this.configuredProjects.get(this.toPath(t));return s&&s.getCompilerOptions().configFile}logErrorForScriptInfoNotFound(t){let n=In(this.filenameToScriptInfo.entries(),([i,s])=>({path:i,fileName:s.fileName}));this.logger.msg(`Could not find file ${JSON.stringify(t)}.
All files are: ${JSON.stringify(n)}`,"Err")}getSymlinkedProjects(t){let n;if(this.realpathToScriptInfos){let s=t.getRealpathIfDifferent();s&&Te(this.realpathToScriptInfos.get(s),i),Te(this.realpathToScriptInfos.get(t.path),i)}return n;function i(s){if(s!==t)for(let o of s.containingProjects)o.languageServiceEnabled&&!o.isOrphan()&&!o.getCompilerOptions().preserveSymlinks&&!t.isAttached(o)&&(n?yu(n,(l,p)=>p===s.path?!1:hs(l,o))||n.add(s.path,o):(n=g_(),n.add(s.path,o)))}}watchClosedScriptInfo(t){if(I.assert(!t.fileWatcher),!t.isDynamicOrHasMixedContent()&&(!this.globalCacheLocationDirectoryPath||!Ss(t.path,this.globalCacheLocationDirectoryPath))){let n=t.fileName.indexOf("/node_modules/");!this.host.getModifiedTime||n===-1?t.fileWatcher=this.watchFactory.watchFile(t.fileName,(i,s)=>this.onSourceFileChanged(t,s),500,this.hostConfiguration.watchOptions,_u.ClosedScriptInfo):(t.mTime=this.getModifiedTime(t),t.fileWatcher=this.watchClosedScriptInfoInNodeModules(t.fileName.substring(0,n)))}}createNodeModulesWatcher(t,n){let i=this.watchFactory.watchDirectory(t,o=>{var l;let p=IV(this.toPath(o));if(!p)return;let m=Cl(p);if((l=s.affectedModuleSpecifierCacheProjects)!=null&&l.size&&(m==="package.json"||m==="node_modules")&&s.affectedModuleSpecifierCacheProjects.forEach(S=>{var h;(h=S.getModuleSpecifierCache())==null||h.clear()}),s.refreshScriptInfoRefCount)if(n===p)this.refreshScriptInfosInDirectory(n);else{let S=this.getScriptInfoForPath(p);S?Tqe(S)&&this.refreshScriptInfo(S):pA(p)||this.refreshScriptInfosInDirectory(p)}},1,this.hostConfiguration.watchOptions,_u.NodeModules),s={refreshScriptInfoRefCount:0,affectedModuleSpecifierCacheProjects:void 0,close:()=>{var o;i&&!s.refreshScriptInfoRefCount&&!((o=s.affectedModuleSpecifierCacheProjects)!=null&&o.size)&&(i.close(),i=void 0,this.nodeModulesWatchers.delete(n))}};return this.nodeModulesWatchers.set(n,s),s}watchPackageJsonsInNodeModules(t,n){var i;let s=this.toPath(t),o=this.nodeModulesWatchers.get(s)||this.createNodeModulesWatcher(t,s);return I.assert(!((i=o.affectedModuleSpecifierCacheProjects)!=null&&i.has(n))),(o.affectedModuleSpecifierCacheProjects||(o.affectedModuleSpecifierCacheProjects=new Set)).add(n),{close:()=>{var l;(l=o.affectedModuleSpecifierCacheProjects)==null||l.delete(n),o.close()}}}watchClosedScriptInfoInNodeModules(t){let n=t+"/node_modules",i=this.toPath(n),s=this.nodeModulesWatchers.get(i)||this.createNodeModulesWatcher(n,i);return s.refreshScriptInfoRefCount++,{close:()=>{s.refreshScriptInfoRefCount--,s.close()}}}getModifiedTime(t){return(this.host.getModifiedTime(t.fileName)||Lp).getTime()}refreshScriptInfo(t){let n=this.getModifiedTime(t);if(n!==t.mTime){let i=LH(t.mTime,n);t.mTime=n,this.onSourceFileChanged(t,i)}}refreshScriptInfosInDirectory(t){t=t+hc,this.filenameToScriptInfo.forEach(n=>{Tqe(n)&&Ss(n.path,t)&&this.refreshScriptInfo(n)})}stopWatchingScriptInfo(t){t.fileWatcher&&(t.fileWatcher.close(),t.fileWatcher=void 0)}getOrCreateScriptInfoNotOpenedByClientForNormalizedPath(t,n,i,s,o){if(ap(t)||tL(t))return this.getOrCreateScriptInfoWorker(t,n,!1,void 0,i,s,o);let l=this.openFilesWithNonRootedDiskPath.get(this.toCanonicalFileName(t));if(l)return l}getOrCreateScriptInfoOpenedByClientForNormalizedPath(t,n,i,s,o){return this.getOrCreateScriptInfoWorker(t,n,!0,i,s,o)}getOrCreateScriptInfoForNormalizedPath(t,n,i,s,o,l){return this.getOrCreateScriptInfoWorker(t,this.currentDirectory,n,i,s,o,l)}getOrCreateScriptInfoWorker(t,n,i,s,o,l,p){I.assert(s===void 0||i,"ScriptInfo needs to be opened by client to be able to set its user defined content");let m=eL(t,n,this.toCanonicalFileName),S=this.getScriptInfoForPath(m);if(!S){let h=tL(t);if(I.assert(ap(t)||h||i,"",()=>`${JSON.stringify({fileName:t,currentDirectory:n,hostCurrentDirectory:this.currentDirectory,openKeys:In(this.openFilesWithNonRootedDiskPath.keys())})}
Script info with non-dynamic relative file name can only be open script info or in context of host currentDirectory`),I.assert(!ap(t)||this.currentDirectory===n||!this.openFilesWithNonRootedDiskPath.has(this.toCanonicalFileName(t)),"",()=>`${JSON.stringify({fileName:t,currentDirectory:n,hostCurrentDirectory:this.currentDirectory,openKeys:In(this.openFilesWithNonRootedDiskPath.keys())})}
Open script files with non rooted disk path opened with current directory context cannot have same canonical names`),I.assert(!h||this.currentDirectory===n||this.useInferredProjectPerProjectRoot,"",()=>`${JSON.stringify({fileName:t,currentDirectory:n,hostCurrentDirectory:this.currentDirectory,openKeys:In(this.openFilesWithNonRootedDiskPath.keys())})}
Dynamic files must always be opened with service's current directory or service should support inferred project per projectRootPath.`),!i&&!h&&!(p||this.host).fileExists(t))return;S=new Tse(this.host,t,o,!!l,m,this.filenameToScriptInfoVersion.get(m)),this.filenameToScriptInfo.set(S.path,S),this.filenameToScriptInfoVersion.delete(S.path),i?!ap(t)&&(!h||this.currentDirectory!==n)&&this.openFilesWithNonRootedDiskPath.set(this.toCanonicalFileName(t),S):this.watchClosedScriptInfo(S)}return i&&(this.stopWatchingScriptInfo(S),S.open(s),l&&S.registerFileUpdate()),S}getScriptInfoForNormalizedPath(t){return!ap(t)&&this.openFilesWithNonRootedDiskPath.get(this.toCanonicalFileName(t))||this.getScriptInfoForPath(eL(t,this.currentDirectory,this.toCanonicalFileName))}getScriptInfoForPath(t){return this.filenameToScriptInfo.get(t)}getDocumentPositionMapper(t,n,i){let s=this.getOrCreateScriptInfoNotOpenedByClient(n,t.currentDirectory,this.host);if(!s){i&&t.addGeneratedFileWatch(n,i);return}if(s.getSnapshot(),vs(s.sourceMapFilePath)){let h=this.getScriptInfoForPath(s.sourceMapFilePath);if(h&&(h.getSnapshot(),h.documentPositionMapper!==void 0))return h.sourceInfos=this.addSourceInfoToSourceMap(i,t,h.sourceInfos),h.documentPositionMapper?h.documentPositionMapper:void 0;s.sourceMapFilePath=void 0}else if(s.sourceMapFilePath){s.sourceMapFilePath.sourceInfos=this.addSourceInfoToSourceMap(i,t,s.sourceMapFilePath.sourceInfos);return}else if(s.sourceMapFilePath!==void 0)return;let o,l,p=(h,b)=>{let A=this.getOrCreateScriptInfoNotOpenedByClient(h,t.currentDirectory,this.host);if(!A){l=b;return}o=A;let k=A.getSnapshot();return A.documentPositionMapper!==void 0?A.documentPositionMapper:ED(k)},m=t.projectName,S=_re({getCanonicalFileName:this.toCanonicalFileName,log:h=>this.logger.info(h),getSourceFileLike:h=>this.getSourceFileLike(h,m,s)},s.fileName,s.textStorage.getLineInfo(),p);return p=void 0,o?(s.sourceMapFilePath=o.path,o.declarationInfoPath=s.path,o.documentPositionMapper=S||!1,o.sourceInfos=this.addSourceInfoToSourceMap(i,t,o.sourceInfos)):l?s.sourceMapFilePath={watcher:this.addMissingSourceMapFile(t.currentDirectory===this.currentDirectory?l:Ps(l,t.currentDirectory),s.path),sourceInfos:this.addSourceInfoToSourceMap(i,t)}:s.sourceMapFilePath=!1,S}addSourceInfoToSourceMap(t,n,i){if(t){let s=this.getOrCreateScriptInfoNotOpenedByClient(t,n.currentDirectory,n.directoryStructureHost);(i||(i=new Set)).add(s.path)}return i}addMissingSourceMapFile(t,n){return this.watchFactory.watchFile(t,()=>{let s=this.getScriptInfoForPath(n);s&&s.sourceMapFilePath&&!vs(s.sourceMapFilePath)&&(this.delayUpdateProjectGraphs(s.containingProjects,!0),this.delayUpdateSourceInfoProjects(s.sourceMapFilePath.sourceInfos),s.closeSourceMapFileWatcher())},2e3,this.hostConfiguration.watchOptions,_u.MissingSourceMapFile)}getSourceFileLike(t,n,i){let s=n.projectName?n:this.findProject(n);if(s){let l=s.toPath(t),p=s.getSourceFile(l);if(p&&p.resolvedPath===l)return p}let o=this.getOrCreateScriptInfoNotOpenedByClient(t,(s||this).currentDirectory,s?s.directoryStructureHost:this.host);if(o){if(i&&vs(i.sourceMapFilePath)&&o!==i){let l=this.getScriptInfoForPath(i.sourceMapFilePath);l&&(l.sourceInfos||(l.sourceInfos=new Set)).add(o.path)}return o.cacheSourceFile?o.cacheSourceFile.sourceFile:(o.sourceFileLike||(o.sourceFileLike={get text(){return I.fail("shouldnt need text"),""},getLineAndCharacterOfPosition:l=>{let p=o.positionToLineOffset(l);return{line:p.line-1,character:p.offset-1}},getPositionOfLineAndCharacter:(l,p,m)=>o.lineOffsetToPosition(l+1,p+1,m)}),o.sourceFileLike)}}setPerformanceEventHandler(t){this.performanceEventHandler=t}setHostConfiguration(t){var n;if(t.file){let i=this.getScriptInfoForNormalizedPath(Cc(t.file));i&&(i.setOptions(WD(t.formatOptions),t.preferences),this.logger.info(`Host configuration update for file ${t.file}`))}else{if(t.hostInfo!==void 0&&(this.hostConfiguration.hostInfo=t.hostInfo,this.logger.info(`Host information ${t.hostInfo}`)),t.formatOptions&&(this.hostConfiguration.formatCodeOptions={...this.hostConfiguration.formatCodeOptions,...WD(t.formatOptions)},this.logger.info("Format host information updated")),t.preferences){let{lazyConfiguredProjectsFromExternalProject:i,includePackageJsonAutoImports:s}=this.hostConfiguration.preferences;this.hostConfiguration.preferences={...this.hostConfiguration.preferences,...t.preferences},i&&!this.hostConfiguration.preferences.lazyConfiguredProjectsFromExternalProject&&this.externalProjectToConfiguredProjectMap.forEach(o=>o.forEach(l=>{!l.isClosed()&&l.hasExternalProjectRef()&&l.pendingUpdateLevel===2&&!this.pendingProjectUpdates.has(l.getProjectName())&&l.updateGraph()})),s!==t.preferences.includePackageJsonAutoImports&&this.forEachProject(o=>{o.onAutoImportProviderSettingsChanged()})}t.extraFileExtensions&&(this.hostConfiguration.extraFileExtensions=t.extraFileExtensions,this.reloadProjects(),this.logger.info("Host file extension mappings updated")),t.watchOptions&&(this.hostConfiguration.watchOptions=(n=iL(t.watchOptions))==null?void 0:n.watchOptions,this.logger.info(`Host watch options changed to ${JSON.stringify(this.hostConfiguration.watchOptions)}, it will be take effect for next watches.`))}}getWatchOptions(t){return this.getWatchOptionsFromProjectWatchOptions(t.getWatchOptions())}getWatchOptionsFromProjectWatchOptions(t){return t&&this.hostConfiguration.watchOptions?{...this.hostConfiguration.watchOptions,...t}:t||this.hostConfiguration.watchOptions}closeLog(){this.logger.close()}reloadProjects(){this.logger.info("reload projects."),this.filenameToScriptInfo.forEach(t=>{this.openFiles.has(t.path)||t.fileWatcher&&this.onSourceFileChanged(t,this.host.fileExists(t.fileName)?1:2)}),this.pendingProjectUpdates.forEach((t,n)=>{this.throttledOperations.cancel(n),this.pendingProjectUpdates.delete(n)}),this.throttledOperations.cancel(F2e),this.pendingEnsureProjectForOpenFiles=!1,this.configFileExistenceInfoCache.forEach(t=>{t.config&&(t.config.updateLevel=2)}),this.reloadConfiguredProjectForFiles(this.openFiles,!0,!1,em,"User requested reload projects"),this.externalProjects.forEach(t=>{this.clearSemanticCache(t),t.updateGraph()}),this.inferredProjects.forEach(t=>this.clearSemanticCache(t)),this.ensureProjectForOpenFiles(),this.logger.info("After reloading projects.."),this.printProjects()}reloadConfiguredProjectForFiles(t,n,i,s,o){let l=new Map,p=m=>{l.has(m.canonicalConfigFilePath)||(l.set(m.canonicalConfigFilePath,!0),this.reloadConfiguredProject(m,o,!1,n))};t?.forEach((m,S)=>{if(this.configFileForOpenFiles.delete(S),!s(m))return;let h=this.getScriptInfoForPath(S);I.assert(h.isScriptOpen());let b=this.getConfigFileNameForFile(h);if(b){let A=this.findConfiguredProjectByProjectName(b)||this.createConfiguredProject(b);l.has(A.canonicalConfigFilePath)||(l.set(A.canonicalConfigFilePath,!0),i?(A.pendingUpdateLevel=2,A.pendingUpdateReason=o,n&&this.clearSemanticCache(A),this.delayUpdateProjectGraph(A)):(this.reloadConfiguredProject(A,o,!1,n),Ik(A,h)||GD(A,h.path,N=>(p(N),Ik(N,h)),1)&&GD(A,void 0,p,0)))}})}removeRootOfInferredProjectIfNowPartOfOtherProject(t){I.assert(t.containingProjects.length>0);let n=t.containingProjects[0];!n.isOrphan()&&$D(n)&&n.isRoot(t)&&Te(t.containingProjects,i=>i!==n&&!i.isOrphan())&&n.removeFile(t,!0,!0)}ensureProjectForOpenFiles(){this.logger.info("Before ensureProjectForOpenFiles:"),this.printProjects(),this.openFiles.forEach((t,n)=>{let i=this.getScriptInfoForPath(n);i.isOrphan()?this.assignOrphanScriptInfoToInferredProject(i,t):this.removeRootOfInferredProjectIfNowPartOfOtherProject(i)}),this.pendingEnsureProjectForOpenFiles=!1,this.inferredProjects.forEach(qp),this.logger.info("After ensureProjectForOpenFiles:"),this.printProjects()}openClientFile(t,n,i,s){return this.openClientFileWithNormalizedPath(Cc(t),n,i,!1,s?Cc(s):void 0)}getOriginalLocationEnsuringConfiguredProject(t,n){let i=t.isSourceOfProjectReferenceRedirect(n.fileName),s=i?n:t.getSourceMapper().tryGetSourcePosition(n);if(!s)return;let{fileName:o}=s,l=this.getScriptInfo(o);if(!l&&!this.host.fileExists(o))return;let p={fileName:Cc(o),path:this.toPath(o)},m=this.getConfigFileNameForFile(p);if(!m)return;let S=this.findConfiguredProjectByProjectName(m);if(!S){if(t.getCompilerOptions().disableReferencedProjectLoad)return i?n:l?.containingProjects.length?s:n;S=this.createAndLoadConfiguredProject(m,`Creating project for original file: ${p.fileName}${n!==s?" for location: "+n.fileName:""}`)}qp(S);let h=k=>{let N=this.getScriptInfo(o);return N&&Ik(k,N)};if(S.isSolution()||!h(S)){if(S=GD(S,o,k=>(qp(k),h(k)?k:void 0),2,`Creating project referenced in solution ${S.projectName} to find possible configured project for original file: ${p.fileName}${n!==s?" for location: "+n.fileName:""}`),!S)return;if(S===t)return s}A(S);let b=this.getScriptInfo(o);if(!b||!b.containingProjects.length)return;return b.containingProjects.forEach(k=>{JT(k)&&A(k)}),s;function A(k){t.originalConfiguredProjects||(t.originalConfiguredProjects=new Set),t.originalConfiguredProjects.add(k.canonicalConfigFilePath)}}fileExists(t){return!!this.getScriptInfoForNormalizedPath(t)||this.host.fileExists(t)}findExternalProjectContainingOpenScriptInfo(t){return mr(this.externalProjects,n=>(qp(n),n.containsScriptInfo(t)))}getOrCreateOpenScriptInfo(t,n,i,s,o){let l=this.getOrCreateScriptInfoOpenedByClientForNormalizedPath(t,o?this.getNormalizedAbsolutePath(o):this.currentDirectory,n,i,s);return this.openFiles.set(l.path,o),l}assignProjectToOpenedScriptInfo(t){let n,i,s=this.findExternalProjectContainingOpenScriptInfo(t),o,l,p=!1;return!s&&this.serverMode===0&&(n=this.getConfigFileNameForFile(t),n&&(s=this.findConfiguredProjectByProjectName(n),s?qp(s):(s=this.createLoadAndUpdateConfiguredProject(n,`Creating possible configured project for ${t.fileName} to open`),p=!0),l=s.containsScriptInfo(t)?s:void 0,o=s,Ik(s,t)||GD(s,t.path,m=>{if(qp(m),os(o)?o.push(m):o=[s,m],Ik(m,t))return l=m,m;!l&&m.containsScriptInfo(t)&&(l=m)},2,`Creating project referenced in solution ${s.projectName} to find possible configured project for ${t.fileName} to open`),l?(n=l.getConfigFilePath(),(l!==s||p)&&(i=l.getAllProjectErrors(),this.sendConfigFileDiagEvent(l,t.fileName))):n=void 0,this.createAncestorProjects(t,s))),t.containingProjects.forEach(qp),t.isOrphan()&&(os(o)?o.forEach(m=>this.sendConfigFileDiagEvent(m,t.fileName)):o&&this.sendConfigFileDiagEvent(o,t.fileName),I.assert(this.openFiles.has(t.path)),this.assignOrphanScriptInfoToInferredProject(t,this.openFiles.get(t.path))),I.assert(!t.isOrphan()),{configFileName:n,configFileErrors:i,retainProjects:o}}createAncestorProjects(t,n){if(t.isAttached(n))for(;;){if(!n.isInitialLoadPending()&&(!n.getCompilerOptions().composite||n.getCompilerOptions().disableSolutionSearching))return;let i=this.getConfigFileNameForFile({fileName:n.getConfigFilePath(),path:t.path,configFileInfo:!0});if(!i)return;let s=this.findConfiguredProjectByProjectName(i)||this.createConfiguredProjectWithDelayLoad(i,`Creating project possibly referencing default composite project ${n.getProjectName()} of open file ${t.fileName}`);s.isInitialLoadPending()&&s.setPotentialProjectReference(n.canonicalConfigFilePath),n=s}}loadAncestorProjectTree(t){t=t||Rl(this.configuredProjects,(i,s)=>s.isInitialLoadPending()?void 0:[i,!0]);let n=new Set;for(let i of In(this.configuredProjects.values()))vqe(i,s=>t.has(s))&&qp(i),this.ensureProjectChildren(i,t,n)}ensureProjectChildren(t,n,i){var s;if(!Zd(i,t.canonicalConfigFilePath)||t.getCompilerOptions().disableReferencedProjectLoad)return;let o=(s=t.getCurrentProgram())==null?void 0:s.getResolvedProjectReferences();if(o)for(let l of o){if(!l)continue;let p=WZ(l.references,h=>n.has(h.sourceFile.path)?h:void 0);if(!p)continue;let m=Cc(l.sourceFile.fileName),S=t.projectService.findConfiguredProjectByProjectName(m)||t.projectService.createAndLoadConfiguredProject(m,`Creating project referenced by : ${t.projectName} as it references project ${p.sourceFile.fileName}`);qp(S),this.ensureProjectChildren(S,n,i)}}cleanupAfterOpeningFile(t){this.removeOrphanConfiguredProjects(t);for(let n of this.inferredProjects.slice())n.isOrphan()&&this.removeProject(n);this.removeOrphanScriptInfos()}openClientFileWithNormalizedPath(t,n,i,s,o){let l=this.getOrCreateOpenScriptInfo(t,n,i,s,o),{retainProjects:p,...m}=this.assignProjectToOpenedScriptInfo(l);return this.cleanupAfterOpeningFile(p),this.telemetryOnOpenFile(l),this.printProjects(),m}removeOrphanConfiguredProjects(t){let n=new Map(this.configuredProjects),i=l=>{!l.isOrphan()&&l.originalConfiguredProjects&&l.originalConfiguredProjects.forEach((p,m)=>{let S=this.getConfiguredProjectByCanonicalConfigFilePath(m);return S&&o(S)})};t&&(os(t)?t.forEach(o):o(t)),this.inferredProjects.forEach(i),this.externalProjects.forEach(i),this.configuredProjects.forEach(l=>{l.hasOpenRef()?o(l):n.has(l.canonicalConfigFilePath)&&Sqe(l,p=>s(p)&&o(l))}),n.forEach(l=>this.removeProject(l));function s(l){return l.hasOpenRef()||!n.has(l.canonicalConfigFilePath)}function o(l){n.delete(l.canonicalConfigFilePath)&&(i(l),Sqe(l,o))}}removeOrphanScriptInfos(){let t=new Map(this.filenameToScriptInfo);this.filenameToScriptInfo.forEach(n=>{if(!n.isScriptOpen()&&n.isOrphan()&&!n.isContainedByBackgroundProject()){if(!n.sourceMapFilePath)return;let i;if(vs(n.sourceMapFilePath)){let s=this.getScriptInfoForPath(n.sourceMapFilePath);i=s&&s.sourceInfos}else i=n.sourceMapFilePath.sourceInfos;if(!i||!Mh(i,s=>{let o=this.getScriptInfoForPath(s);return!!o&&(o.isScriptOpen()||!o.isOrphan())}))return}if(t.delete(n.path),n.sourceMapFilePath){let i;if(vs(n.sourceMapFilePath)){t.delete(n.sourceMapFilePath);let s=this.getScriptInfoForPath(n.sourceMapFilePath);i=s&&s.sourceInfos}else i=n.sourceMapFilePath.sourceInfos;i&&i.forEach((s,o)=>t.delete(o))}}),t.forEach(n=>{this.stopWatchingScriptInfo(n),this.deleteScriptInfo(n),n.closeSourceMapFileWatcher()})}telemetryOnOpenFile(t){if(this.serverMode!==0||!this.eventHandler||!t.isJavaScript()||!Bm(this.allJsFilesForOpenFileTelemetry,t.path))return;let n=this.ensureDefaultProjectForFile(t);if(!n.languageServiceEnabled)return;let i=n.getSourceFile(t.path),s=!!i&&!!i.checkJsDirective;this.eventHandler({eventName:wse,data:{info:{checkJs:s}}})}closeClientFile(t,n){let i=this.getScriptInfoForNormalizedPath(Cc(t)),s=i?this.closeOpenFile(i,n):!1;return n||this.printProjects(),s}collectChanges(t,n,i,s){for(let o of n){let l=mr(t,p=>p.projectName===o.getProjectName());s.push(o.getChangesSinceVersion(l&&l.version,i))}}synchronizeProjectList(t,n){let i=[];return this.collectChanges(t,this.externalProjects,n,i),this.collectChanges(t,this.configuredProjects.values(),n,i),this.collectChanges(t,this.inferredProjects,n,i),i}applyChangesInOpenFiles(t,n,i){let s,o=!1;if(t)for(let p of t){let m=this.getOrCreateOpenScriptInfo(Cc(p.fileName),p.content,Nse(p.scriptKind),p.hasMixedContent,p.projectRootPath?Cc(p.projectRootPath):void 0);(s||(s=[])).push(m)}if(n)for(let p of n){let m=this.getScriptInfo(p.fileName);I.assert(!!m),this.applyChangesToFile(m,p.changes)}if(i)for(let p of i)o=this.closeClientFile(p,!0)||o;let l;s&&(l=_a(s,p=>this.assignProjectToOpenedScriptInfo(p).retainProjects)),o&&this.assignOrphanScriptInfosToInferredProject(),s?(this.cleanupAfterOpeningFile(l),s.forEach(p=>this.telemetryOnOpenFile(p)),this.printProjects()):de(i)&&this.printProjects()}applyChangesToFile(t,n){for(let i of n)t.editContent(i.span.start,i.span.start+i.span.length,i.newText)}closeConfiguredProjectReferencedFromExternalProject(t){t?.forEach(n=>{n.isClosed()||(n.deleteExternalProjectReference(),n.hasOpenRef()||this.removeProject(n))})}closeExternalProject(t,n){let i=Cc(t),s=this.externalProjectToConfiguredProjectMap.get(i);if(s)this.closeConfiguredProjectReferencedFromExternalProject(s),this.externalProjectToConfiguredProjectMap.delete(i);else{let o=this.findExternalProjectByProjectName(t);o&&this.removeProject(o)}n&&this.printProjects()}openExternalProjects(t){let n=il(this.externalProjects,i=>i.getProjectName(),i=>!0);Mh(this.externalProjectToConfiguredProjectMap,i=>{n.set(i,!0)});for(let i of t)this.openExternalProject(i,!1),n.delete(i.projectFileName);Mh(n,i=>{this.closeExternalProject(i,!1)}),this.printProjects()}static escapeFilenameForRegex(t){return t.replace(this.filenameEscapeRegexp,"\\$&")}resetSafeList(){this.safelist=Ose}applySafeList(t){let n=t.typeAcquisition;I.assert(!!n,"proj.typeAcquisition should be set by now");let i=this.applySafeListWorker(t,t.rootFiles,n);return i?.excludedFiles??[]}applySafeListWorker(t,n,i){if(i.enable===!1||i.disableFilenameBasedTypeAcquisition)return;let s=i.include||(i.include=[]),o=[],l=n.map(b=>v_(b.fileName));for(let b of Object.keys(this.safelist)){let A=this.safelist[b];for(let k of l)if(A.match.test(k)){if(this.logger.info(`Excluding files based on rule ${b} matching file '${k}'`),A.types)for(let N of A.types)s.includes(N)||s.push(N);if(A.exclude)for(let N of A.exclude){let M=k.replace(A.match,(...O)=>N.map(U=>typeof U=="number"?vs(O[U])?E6e.escapeFilenameForRegex(O[U]):(this.logger.info(`Incorrect RegExp specification in safelist rule ${b} - not enough groups`),"\\*"):U).join(""));o.includes(M)||o.push(M)}else{let N=E6e.escapeFilenameForRegex(k);o.includes(N)||o.push(N)}}}let p=o.map(b=>new RegExp(b,"i")),m,S;for(let b=0;b<n.length;b++)if(p.some(A=>A.test(l[b])))h(b);else{if(i.enable){let A=Cl(sp(l[b]));if(Uc(A,"js")){let k=ff(A),N=B5(k),M=this.legacySafelist.get(N);if(M!==void 0){this.logger.info(`Excluded '${l[b]}' because it matched ${N} from the legacy safelist`),h(b),s.includes(M)||s.push(M);continue}}}/^.+[.-]min\.js$/.test(l[b])?h(b):m?.push(n[b])}return S?{rootFiles:m,excludedFiles:S}:void 0;function h(b){S||(I.assert(!m),m=n.slice(0,b),S=[]),S.push(l[b])}}openExternalProject(t,n){let i=this.findExternalProjectByProjectName(t.projectFileName),s=this.externalProjectToConfiguredProjectMap.get(t.projectFileName),o,l=[];for(let p of t.rootFiles){let m=Cc(p.fileName);if(gse(m)){if(this.serverMode===0&&this.host.fileExists(m)){let S=this.findConfiguredProjectByProjectName(m);S||(S=this.getHostPreferences().lazyConfiguredProjectsFromExternalProject?this.createConfiguredProjectWithDelayLoad(m,`Creating configured project in external project: ${t.projectFileName}`):this.createLoadAndUpdateConfiguredProject(m,`Creating configured project in external project: ${t.projectFileName}`)),s?.has(S)||S.addExternalProjectReference(),(o??(o=new Set)).add(S),s?.delete(S)}}else l.push(p)}if(o)this.externalProjectToConfiguredProjectMap.set(t.projectFileName,o),i&&this.removeProject(i);else{this.externalProjectToConfiguredProjectMap.delete(t.projectFileName);let p=t.typeAcquisition||{};p.include=p.include||[],p.exclude=p.exclude||[],p.enable===void 0&&(p.enable=A2e(l.map(h=>h.fileName)));let m=this.applySafeListWorker(t,l,p),S=m?.excludedFiles??[];if(l=m?.rootFiles??l,i){i.excludedFiles=S;let h=Hq(t.options),b=iL(t.options,i.getCurrentDirectory()),A=this.getFilenameForExceededTotalSizeLimitForNonTsFiles(t.projectFileName,h,l,oz);A?i.disableLanguageService(A):i.enableLanguageService(),i.setProjectErrors(b?.errors),this.updateRootAndOptionsOfNonInferredProject(i,l,oz,h,p,t.options.compileOnSave,b?.watchOptions),i.updateGraph()}else this.createExternalProject(t.projectFileName,l,t.options,p,S).updateGraph()}this.closeConfiguredProjectReferencedFromExternalProject(s),n&&this.printProjects()}hasDeferredExtension(){for(let t of this.hostConfiguration.extraFileExtensions)if(t.scriptKind===7)return!0;return!1}requestEnablePlugin(t,n,i){if(!this.host.importPlugin&&!this.host.require){this.logger.info("Plugins were requested but not running in environment that supports 'require'. Nothing will be loaded");return}if(this.logger.info(`Enabling plugin ${n.name} from candidate paths: ${i.join(",")}`),!n.name||mM(n.name).rest){this.logger.info(`Skipped loading plugin ${n.name||JSON.stringify(n)} because only package name is allowed plugin name`);return}if(this.host.importPlugin){let s=Rx.importServicePluginAsync(n,i,this.host,l=>this.logger.info(l));this.pendingPluginEnablements??(this.pendingPluginEnablements=new Map);let o=this.pendingPluginEnablements.get(t);o||this.pendingPluginEnablements.set(t,o=[]),o.push(s);return}this.endEnablePlugin(t,Rx.importServicePluginSync(n,i,this.host,s=>this.logger.info(s)))}endEnablePlugin(t,{pluginConfigEntry:n,resolvedModule:i,errorLogs:s}){var o;if(i){let l=(o=this.currentPluginConfigOverrides)==null?void 0:o.get(n.name);if(l){let p=n.name;n=l,n.name=p}t.enableProxy(i,n)}else Te(s,l=>this.logger.info(l)),this.logger.info(`Couldn't find ${n.name}`)}hasNewPluginEnablementRequests(){return!!this.pendingPluginEnablements}hasPendingPluginEnablements(){return!!this.currentPluginEnablementPromise}async waitForPendingPlugins(){for(;this.currentPluginEnablementPromise;)await this.currentPluginEnablementPromise}enableRequestedPlugins(){this.pendingPluginEnablements&&this.enableRequestedPluginsAsync()}async enableRequestedPluginsAsync(){if(this.currentPluginEnablementPromise&&await this.waitForPendingPlugins(),!this.pendingPluginEnablements)return;let t=In(this.pendingPluginEnablements.entries());this.pendingPluginEnablements=void 0,this.currentPluginEnablementPromise=this.enableRequestedPluginsWorker(t),await this.currentPluginEnablementPromise}async enableRequestedPluginsWorker(t){I.assert(this.currentPluginEnablementPromise===void 0),await Promise.all(vr(t,([n,i])=>this.enableRequestedPluginsForProjectAsync(n,i))),this.currentPluginEnablementPromise=void 0,this.sendProjectsUpdatedInBackgroundEvent()}async enableRequestedPluginsForProjectAsync(t,n){let i=await Promise.all(n);if(!t.isClosed()){for(let s of i)this.endEnablePlugin(t,s);this.delayUpdateProjectGraph(t)}}configurePlugin(t){this.forEachEnabledProject(n=>n.onPluginConfigurationChanged(t.pluginName,t.configuration)),this.currentPluginConfigOverrides=this.currentPluginConfigOverrides||new Map,this.currentPluginConfigOverrides.set(t.pluginName,t.configuration)}getPackageJsonsVisibleToFile(t,n,i){let s=this.packageJsonCache,o=i&&this.toPath(i),l=[],p=m=>{switch(s.directoryHasPackageJson(m)){case 3:return s.searchDirectoryAndAncestors(m),p(m);case-1:let S=li(m,"package.json");this.watchPackageJsonFile(S,this.toPath(S),n);let h=s.getInDirectory(m);h&&l.push(h)}if(o&&o===m)return!0};return Rm(hi(t),p),l}getNearestAncestorDirectoryWithPackageJson(t){return Rm(t,n=>{switch(this.packageJsonCache.directoryHasPackageJson(n)){case-1:return n;case 0:return;case 3:return this.host.fileExists(li(n,"package.json"))?n:void 0}})}watchPackageJsonFile(t,n,i){I.assert(i!==void 0);let s=(this.packageJsonFilesMap??(this.packageJsonFilesMap=new Map)).get(n);if(!s){let o=this.watchFactory.watchFile(t,(l,p)=>{switch(p){case 0:return I.fail();case 1:this.packageJsonCache.addOrUpdate(l,n),this.onPackageJsonChange(s);break;case 2:this.packageJsonCache.delete(n),this.onPackageJsonChange(s),s.projects.clear(),s.close()}},250,this.hostConfiguration.watchOptions,_u.PackageJson);s={projects:new Set,close:()=>{var l;s.projects.size||!o||(o.close(),o=void 0,(l=this.packageJsonFilesMap)==null||l.delete(n),this.packageJsonCache.invalidate(n))}},this.packageJsonFilesMap.set(n,s)}s.projects.add(i),(i.packageJsonWatches??(i.packageJsonWatches=new Set)).add(s)}onPackageJsonChange(t){t.projects.forEach(n=>{var i;return(i=n.onPackageJsonChange)==null?void 0:i.call(n)})}includePackageJsonAutoImports(){switch(this.hostConfiguration.preferences.includePackageJsonAutoImports){case"on":return 1;case"off":return 0;default:return 2}}getIncompleteCompletionsCache(){return this.incompleteCompletionsCache||(this.incompleteCompletionsCache=_8t())}},j2e.filenameEscapeRegexp=/[-/\\^$*+?.()|[\]{}]/g,Lse=j2e}});function B2e(e){let t,n,i,s={get(m,S,h,b){if(!(!n||i!==l(m,h,b)))return n.get(S)},set(m,S,h,b,A,k){if(o(m,h,b).set(S,p(A,k,!1)),k){for(let N of A)if(N.isInNodeModules){let M=N.path.substring(0,N.path.indexOf(Wh)+Wh.length-1),O=e.toPath(M);t?.has(O)||(t||(t=new Map)).set(O,e.watchNodeModulesForPackageJsonChanges(M))}}},setModulePaths(m,S,h,b,A){let k=o(m,h,b),N=k.get(S);N?N.modulePaths=A:k.set(S,p(A,void 0,void 0))},setBlockedByPackageJsonDependencies(m,S,h,b,A){let k=o(m,h,b),N=k.get(S);N?N.isBlockedByPackageJsonDependencies=A:k.set(S,p(void 0,void 0,A))},clear(){t?.forEach(ug),n?.clear(),t?.clear(),i=void 0},count(){return n?n.size:0}};return I.isDebugging&&Object.defineProperty(s,"__cache",{get:()=>n}),s;function o(m,S,h){let b=l(m,S,h);return n&&i!==b&&s.clear(),i=b,n||(n=new Map)}function l(m,S,h){return`${m},${S.importModuleSpecifierEnding},${S.importModuleSpecifierPreference},${h.overrideImportMode}`}function p(m,S,h){return{modulePaths:m,moduleSpecifiers:S,isBlockedByPackageJsonDependencies:h}}}var p8t=f({"src/server/moduleSpecifierCache.ts"(){"use strict";uS()}});function U2e(e){let t=new Map,n=new Map;return{addOrUpdate:i,invalidate:s,delete:l=>{t.delete(l),n.set(hi(l),!0)},getInDirectory:l=>t.get(e.toPath(li(l,"package.json")))||void 0,directoryHasPackageJson:l=>o(e.toPath(l)),searchDirectoryAndAncestors:l=>{Rm(l,p=>{let m=e.toPath(p);if(o(m)!==3)return!0;let S=li(p,"package.json");_7(e,S)?i(S,li(m,"package.json")):n.set(m,!0)})}};function i(l,p){let m=I.checkDefined(Jte(l,e.host));t.set(p,m),n.delete(hi(p))}function s(l){t.delete(l),n.delete(hi(l))}function o(l){return t.has(li(l,"package.json"))?-1:n.has(l)?0:3}}var d8t=f({"src/server/packageJsonCache.ts"(){"use strict";uS()}});function m8t(e){let t=e[0],n=e[1];return(1e9*t+n)/1e6}function Cqe(e,t){if(($D(e)||Ese(e))&&e.isJsOnlyProject()){let n=e.getScriptInfoForNormalizedPath(t);return n&&!n.isJavaScript()}return!1}function g8t(e){return Dd(e)||!!e.emitDecoratorMetadata}function Aqe(e,t,n){let i=t.getScriptInfoForNormalizedPath(e);return{start:i.positionToLineOffset(n.start),end:i.positionToLineOffset(n.start+n.length),text:nh(n.messageText,`
`),code:n.code,category:R2(n),reportsUnnecessary:n.reportsUnnecessary,reportsDeprecated:n.reportsDeprecated,source:n.source,relatedInformation:vr(n.relatedInformation,Fse)}}function Fse(e){return e.file?{span:{start:aL(Lo(e.file,e.start)),end:aL(Lo(e.file,e.start+e.length)),file:e.file.fileName},message:nh(e.messageText,`
`),category:R2(e),code:e.code}:{message:nh(e.messageText,`
`),category:R2(e),code:e.code}}function aL(e){return{line:e.line+1,offset:e.character+1}}function oL(e,t){let n=e.file&&aL(Lo(e.file,e.start)),i=e.file&&aL(Lo(e.file,e.start+e.length)),s=nh(e.messageText,`
`),{code:o,source:l}=e,p=R2(e),m={start:n,end:i,text:s,code:o,category:p,reportsUnnecessary:e.reportsUnnecessary,reportsDeprecated:e.reportsDeprecated,source:l,relatedInformation:vr(e.relatedInformation,Fse)};return t?{...m,fileName:e.file&&e.file.fileName}:m}function h8t(e,t){return e.every(n=>gl(n.span)<t)}function V2e(e,t,n,i){let s=t.hasLevel(3),o=JSON.stringify(e);return s&&t.info(`${e.type}:${LT(e)}`),`Content-Length: ${1+n(o,"utf8")}\r
\r
${o}${i}`}function J2e(e,t){return{seq:0,type:"event",event:e,body:t}}function y8t(e,t,n,i){let s=bv(os(n)?n:n.projects,o=>i(o,e));return!os(n)&&n.symLinkedProjects&&n.symLinkedProjects.forEach((o,l)=>{let p=t(l);s.push(..._a(o,m=>i(m,p)))}),Dh(s,Dm)}function jse(e){return Ug(({textSpan:t})=>t.start+100003*t.length,kte(e))}function v8t(e,t,n,i,s,o,l){let p=kqe(e,t,n,!0,(h,b)=>h.getLanguageService().findRenameLocations(b.fileName,b.pos,i,s,o),(h,b)=>b(HO(h)));if(os(p))return p;let m=[],S=jse(l);return p.forEach((h,b)=>{for(let A of h)!S.has(A)&&!Bse(HO(A),b)&&(m.push(A),S.add(A))}),m}function S8t(e,t,n){let i=e.getLanguageService().getDefinitionAtPosition(t.fileName,t.pos,!1,n),s=i&&qi(i);return s&&!s.isLocal?{fileName:s.fileName,pos:s.textSpan.start}:void 0}function T8t(e,t,n,i,s){var o,l;let p=kqe(e,t,n,!1,(b,A)=>(s.info(`Finding references to ${A.fileName} position ${A.pos} in project ${b.getProjectName()}`),b.getLanguageService().findReferences(A.fileName,A.pos)),(b,A)=>{A(HO(b.definition));for(let k of b.references)A(HO(k))});if(os(p))return p;let m=p.get(t);if(((l=(o=m?.[0])==null?void 0:o.references[0])==null?void 0:l.isDefinition)===void 0)p.forEach(b=>{for(let A of b)for(let k of A.references)delete k.isDefinition});else{let b=jse(i);for(let k of m)for(let N of k.references)if(N.isDefinition){b.add(N);break}let A=new Set;for(;;){let k=!1;if(p.forEach((N,M)=>{if(A.has(M))return;M.getLanguageService().updateIsDefinitionOfReferencedSymbols(N,b)&&(A.add(M),k=!0)}),!k)break}p.forEach((k,N)=>{if(!A.has(N))for(let M of k)for(let O of M.references)O.isDefinition=!1})}let S=[],h=jse(i);return p.forEach((b,A)=>{for(let k of b){let N=Bse(HO(k.definition),A),M=N===void 0?k.definition:{...k.definition,textSpan:e_(N.pos,k.definition.textSpan.length),fileName:N.fileName,contextSpan:x8t(k.definition,A)},O=mr(S,U=>Ate(U.definition,M,i));O||(O={definition:M,references:[]},S.push(O));for(let U of k.references)!h.has(U)&&!Bse(HO(U),A)&&(h.add(U),O.references.push(U))}}),S.filter(b=>b.references.length!==0)}function q2e(e,t,n){for(let i of os(e)?e:e.projects)n(i,t);!os(e)&&e.symLinkedProjects&&e.symLinkedProjects.forEach((i,s)=>{for(let o of i)n(o,s)})}function kqe(e,t,n,i,s,o){let l=new Map,p=Pu();p.enqueue({project:t,location:n}),q2e(e,n.fileName,(M,O)=>{let U={fileName:O,pos:n.pos};p.enqueue({project:M,location:U})});let m=t.projectService,S=t.getCancellationToken(),h=S8t(t,n,i),b=D_(()=>t.isSourceOfProjectReferenceRedirect(h.fileName)?h:t.getLanguageService().getSourceMapper().tryGetGeneratedPosition(h)),A=D_(()=>t.isSourceOfProjectReferenceRedirect(h.fileName)?h:t.getLanguageService().getSourceMapper().tryGetSourcePosition(h)),k=new Set;e:for(;!p.isEmpty();){for(;!p.isEmpty();){if(S.isCancellationRequested())break e;let{project:M,location:O}=p.dequeue();if(l.has(M)||Pqe(M,O)||(qp(M),!M.containsFile(Cc(O.fileName))))continue;let U=N(M,O);l.set(M,U??Vl),k.add(E8t(M))}h&&(m.loadAncestorProjectTree(k),m.forEachEnabledProject(M=>{if(S.isCancellationRequested()||l.has(M))return;let O=b8t(h,M,b,A);O&&p.enqueue({project:M,location:O})}))}if(l.size===1)return Ja(l.values());return l;function N(M,O){let U=s(M,O);if(U){for(let H of U)o(H,K=>{let re=m.getOriginalLocationEnsuringConfiguredProject(M,K);if(!re)return;let $=m.getScriptInfo(re.fileName);for(let z of $.containingProjects)!z.isOrphan()&&!l.has(z)&&p.enqueue({project:z,location:re});let pe=m.getSymlinkedProjects($);pe&&pe.forEach((z,se)=>{for(let Se of z)!Se.isOrphan()&&!l.has(Se)&&p.enqueue({project:Se,location:{fileName:se,pos:re.pos}})})});return U}}}function b8t(e,t,n,i){if(t.containsFile(Cc(e.fileName))&&!Pqe(t,e))return e;let s=n();if(s&&t.containsFile(Cc(s.fileName)))return s;let o=i();return o&&t.containsFile(Cc(o.fileName))?o:void 0}function Pqe(e,t){if(!t)return!1;let n=e.getLanguageService().getProgram();if(!n)return!1;let i=n.getSourceFile(t.fileName);return!!i&&i.resolvedPath!==i.path&&i.resolvedPath!==e.toPath(t.fileName)}function E8t(e){return JT(e)?e.canonicalConfigFilePath:e.getProjectName()}function HO({fileName:e,textSpan:t}){return{fileName:e,pos:t.start}}function Bse(e,t){return kO(e,t.getSourceMapper(),n=>t.projectService.fileExists(n))}function Nqe(e,t){return vJ(e,t.getSourceMapper(),n=>t.projectService.fileExists(n))}function x8t(e,t){return Nte(e,t.getSourceMapper(),n=>t.projectService.fileExists(n))}function Hh(e,t){return{start:t.positionToLineOffset(e.start),end:t.positionToLineOffset(gl(e))}}function z2e(e,t,n){let i=Hh(e,n),s=t&&Hh(t,n);return s?{...i,contextStart:s.start,contextEnd:s.end}:i}function C8t(e,t){return{start:Dqe(t,e.span.start),end:Dqe(t,gl(e.span)),newText:e.newText}}function Dqe(e,t){return M2e(e)?k8t(e.getLineAndCharacterOfPosition(t)):e.positionToLineOffset(t)}function A8t(e,t){let n=e.ranges.map(i=>({start:t.positionToLineOffset(i.start),end:t.positionToLineOffset(i.start+i.length)}));return e.wordPattern?{ranges:n,wordPattern:e.wordPattern}:{ranges:n}}function k8t(e){return{line:e.line+1,offset:e.character+1}}function P8t(e){I.assert(e.textChanges.length===1);let t=di(e.textChanges);return I.assert(t.span.start===0&&t.span.length===0),{fileName:e.fileName,textChanges:[{start:{line:0,offset:0},end:{line:0,offset:0},newText:t.newText}]}}function $2e(e,t,n,i){let s=N8t(e,t,i),{line:o,character:l}=zP(mA(s),n);return{line:o+1,offset:l+1}}function N8t(e,t,n){for(let{fileName:i,textChanges:s}of n)if(i===t)for(let o=s.length-1;o>=0;o--){let{newText:l,span:{start:p,length:m}}=s[o];e=e.slice(0,p)+l+e.slice(p+m)}return e}function Iqe(e,{fileName:t,textSpan:n,contextSpan:i,isWriteAccess:s,isDefinition:o},{disableLineTextInReferences:l}){let p=I.checkDefined(e.getScriptInfo(t)),m=z2e(n,i,p),S=l?void 0:D8t(p,m);return{file:t,...m,lineText:S,isWriteAccess:s,isDefinition:o}}function D8t(e,t){let n=e.lineToTextSpan(t.start.line-1);return e.getSnapshot().getText(n.start,gl(n)).replace(/\r|\n/g,"")}function I8t(e){return e===void 0||e&&typeof e=="object"&&typeof e.exportName=="string"&&(e.fileName===void 0||typeof e.fileName=="string")&&(e.ambientModuleName===void 0||typeof e.ambientModuleName=="string"&&(e.isPackageJsonImport===void 0||typeof e.isPackageJsonImport=="boolean"))}var W2e,G2e,wqe,H2e,Oqe,Y2e,w8t=f({"src/server/session.ts"(){"use strict";uS(),Mx(),b2e(),W2e={isCancellationRequested:()=>!1,setRequest:()=>{},resetRequest:()=>{}},G2e=vse,wqe=class{constructor(e){this.operationHost=e}startNew(e){this.complete(),this.requestId=this.operationHost.getCurrentRequestId(),this.executeAction(e)}complete(){this.requestId!==void 0&&(this.operationHost.sendRequestCompletedEvent(this.requestId),this.requestId=void 0),this.setTimerHandle(void 0),this.setImmediateId(void 0)}immediate(e,t){let n=this.requestId;I.assert(n===this.operationHost.getCurrentRequestId(),"immediate: incorrect request id"),this.setImmediateId(this.operationHost.getServerHost().setImmediate(()=>{this.immediateId=void 0,this.operationHost.executeWithRequestId(n,()=>this.executeAction(t))},e))}delay(e,t,n){let i=this.requestId;I.assert(i===this.operationHost.getCurrentRequestId(),"delay: incorrect request id"),this.setTimerHandle(this.operationHost.getServerHost().setTimeout(()=>{this.timerHandle=void 0,this.operationHost.executeWithRequestId(i,()=>this.executeAction(n))},t,e))}executeAction(e){var t,n,i,s,o,l;let p=!1;try{this.operationHost.isCancellationRequested()?(p=!0,(t=mn)==null||t.instant(mn.Phase.Session,"stepCanceled",{seq:this.requestId,early:!0})):((n=mn)==null||n.push(mn.Phase.Session,"stepAction",{seq:this.requestId}),e(this),(i=mn)==null||i.pop())}catch(m){(s=mn)==null||s.popAll(),p=!0,m instanceof VP?(o=mn)==null||o.instant(mn.Phase.Session,"stepCanceled",{seq:this.requestId}):((l=mn)==null||l.instant(mn.Phase.Session,"stepError",{seq:this.requestId,message:m.message}),this.operationHost.logError(m,`delayed processing of request ${this.requestId}`))}(p||!this.hasPendingWork())&&this.complete()}setTimerHandle(e){this.timerHandle!==void 0&&this.operationHost.getServerHost().clearTimeout(this.timerHandle),this.timerHandle=e}setImmediateId(e){this.immediateId!==void 0&&this.operationHost.getServerHost().clearImmediate(this.immediateId),this.immediateId=e}hasPendingWork(){return!!this.timerHandle||!!this.immediateId}},H2e=["openExternalProject","openExternalProjects","closeExternalProject","synchronizeProjectList","emit-output","compileOnSaveAffectedFileList","compileOnSaveEmitFile","compilerOptionsDiagnostics-full","encodedSemanticClassifications-full","semanticDiagnosticsSync","suggestionDiagnosticsSync","geterrForProject","reload","reloadProjects","getCodeFixes","getCodeFixes-full","getCombinedCodeFix","getCombinedCodeFix-full","applyCodeActionCommand","getSupportedCodeFixes","getApplicableRefactors","getMoveToRefactoringFileSuggestions","getEditsForRefactor","getEditsForRefactor-full","organizeImports","organizeImports-full","getEditsForFileRename","getEditsForFileRename-full","prepareCallHierarchy","provideCallHierarchyIncomingCalls","provideCallHierarchyOutgoingCalls"],Oqe=[...H2e,"definition","definition-full","definitionAndBoundSpan","definitionAndBoundSpan-full","typeDefinition","implementation","implementation-full","references","references-full","rename","renameLocations-full","rename-full","quickinfo","quickinfo-full","completionInfo","completions","completions-full","completionEntryDetails","completionEntryDetails-full","signatureHelp","signatureHelp-full","navto","navto-full","documentHighlights","documentHighlights-full"],Y2e=class v_e{constructor(t){this.changeSeq=0,this.handlers=new Map(Object.entries({status:()=>{let o={version:F};return this.requiredResponse(o)},openExternalProject:o=>(this.projectService.openExternalProject(o.arguments,!0),this.requiredResponse(!0)),openExternalProjects:o=>(this.projectService.openExternalProjects(o.arguments.projects),this.requiredResponse(!0)),closeExternalProject:o=>(this.projectService.closeExternalProject(o.arguments.projectFileName,!0),this.requiredResponse(!0)),synchronizeProjectList:o=>{let l=this.projectService.synchronizeProjectList(o.arguments.knownProjects,o.arguments.includeProjectReferenceRedirectInfo);if(!l.some(m=>m.projectErrors&&m.projectErrors.length!==0))return this.requiredResponse(l);let p=vr(l,m=>!m.projectErrors||m.projectErrors.length===0?m:{info:m.info,changes:m.changes,files:m.files,projectErrors:this.convertToDiagnosticsWithLinePosition(m.projectErrors,void 0)});return this.requiredResponse(p)},updateOpen:o=>(this.changeSeq++,this.projectService.applyChangesInOpenFiles(o.arguments.openFiles&&g1(o.arguments.openFiles,l=>({fileName:l.file,content:l.fileContent,scriptKind:l.scriptKindName,projectRootPath:l.projectRootPath})),o.arguments.changedFiles&&g1(o.arguments.changedFiles,l=>({fileName:l.fileName,changes:S0(Xl(l.textChanges),p=>{let m=I.checkDefined(this.projectService.getScriptInfo(l.fileName)),S=m.lineOffsetToPosition(p.start.line,p.start.offset),h=m.lineOffsetToPosition(p.end.line,p.end.offset);return S>=0?{span:{start:S,length:h-S},newText:p.newText}:void 0})})),o.arguments.closedFiles),this.requiredResponse(!0)),applyChangedToOpenFiles:o=>(this.changeSeq++,this.projectService.applyChangesInOpenFiles(o.arguments.openFiles,o.arguments.changedFiles&&g1(o.arguments.changedFiles,l=>({fileName:l.fileName,changes:Xl(l.changes)})),o.arguments.closedFiles),this.requiredResponse(!0)),exit:()=>(this.exit(),this.notRequired()),definition:o=>this.requiredResponse(this.getDefinition(o.arguments,!0)),"definition-full":o=>this.requiredResponse(this.getDefinition(o.arguments,!1)),definitionAndBoundSpan:o=>this.requiredResponse(this.getDefinitionAndBoundSpan(o.arguments,!0)),"definitionAndBoundSpan-full":o=>this.requiredResponse(this.getDefinitionAndBoundSpan(o.arguments,!1)),findSourceDefinition:o=>this.requiredResponse(this.findSourceDefinition(o.arguments)),"emit-output":o=>this.requiredResponse(this.getEmitOutput(o.arguments)),typeDefinition:o=>this.requiredResponse(this.getTypeDefinition(o.arguments)),implementation:o=>this.requiredResponse(this.getImplementation(o.arguments,!0)),"implementation-full":o=>this.requiredResponse(this.getImplementation(o.arguments,!1)),references:o=>this.requiredResponse(this.getReferences(o.arguments,!0)),"references-full":o=>this.requiredResponse(this.getReferences(o.arguments,!1)),rename:o=>this.requiredResponse(this.getRenameLocations(o.arguments,!0)),"renameLocations-full":o=>this.requiredResponse(this.getRenameLocations(o.arguments,!1)),"rename-full":o=>this.requiredResponse(this.getRenameInfo(o.arguments)),open:o=>(this.openClientFile(Cc(o.arguments.file),o.arguments.fileContent,Dse(o.arguments.scriptKindName),o.arguments.projectRootPath?Cc(o.arguments.projectRootPath):void 0),this.notRequired()),quickinfo:o=>this.requiredResponse(this.getQuickInfoWorker(o.arguments,!0)),"quickinfo-full":o=>this.requiredResponse(this.getQuickInfoWorker(o.arguments,!1)),getOutliningSpans:o=>this.requiredResponse(this.getOutliningSpans(o.arguments,!0)),outliningSpans:o=>this.requiredResponse(this.getOutliningSpans(o.arguments,!1)),todoComments:o=>this.requiredResponse(this.getTodoComments(o.arguments)),indentation:o=>this.requiredResponse(this.getIndentation(o.arguments)),nameOrDottedNameSpan:o=>this.requiredResponse(this.getNameOrDottedNameSpan(o.arguments)),breakpointStatement:o=>this.requiredResponse(this.getBreakpointStatement(o.arguments)),braceCompletion:o=>this.requiredResponse(this.isValidBraceCompletion(o.arguments)),docCommentTemplate:o=>this.requiredResponse(this.getDocCommentTemplate(o.arguments)),getSpanOfEnclosingComment:o=>this.requiredResponse(this.getSpanOfEnclosingComment(o.arguments)),fileReferences:o=>this.requiredResponse(this.getFileReferences(o.arguments,!0)),"fileReferences-full":o=>this.requiredResponse(this.getFileReferences(o.arguments,!1)),format:o=>this.requiredResponse(this.getFormattingEditsForRange(o.arguments)),formatonkey:o=>this.requiredResponse(this.getFormattingEditsAfterKeystroke(o.arguments)),"format-full":o=>this.requiredResponse(this.getFormattingEditsForDocumentFull(o.arguments)),"formatonkey-full":o=>this.requiredResponse(this.getFormattingEditsAfterKeystrokeFull(o.arguments)),"formatRange-full":o=>this.requiredResponse(this.getFormattingEditsForRangeFull(o.arguments)),completionInfo:o=>this.requiredResponse(this.getCompletions(o.arguments,"completionInfo")),completions:o=>this.requiredResponse(this.getCompletions(o.arguments,"completions")),"completions-full":o=>this.requiredResponse(this.getCompletions(o.arguments,"completions-full")),completionEntryDetails:o=>this.requiredResponse(this.getCompletionEntryDetails(o.arguments,!1)),"completionEntryDetails-full":o=>this.requiredResponse(this.getCompletionEntryDetails(o.arguments,!0)),compileOnSaveAffectedFileList:o=>this.requiredResponse(this.getCompileOnSaveAffectedFileList(o.arguments)),compileOnSaveEmitFile:o=>this.requiredResponse(this.emitFile(o.arguments)),signatureHelp:o=>this.requiredResponse(this.getSignatureHelpItems(o.arguments,!0)),"signatureHelp-full":o=>this.requiredResponse(this.getSignatureHelpItems(o.arguments,!1)),"compilerOptionsDiagnostics-full":o=>this.requiredResponse(this.getCompilerOptionsDiagnostics(o.arguments)),"encodedSyntacticClassifications-full":o=>this.requiredResponse(this.getEncodedSyntacticClassifications(o.arguments)),"encodedSemanticClassifications-full":o=>this.requiredResponse(this.getEncodedSemanticClassifications(o.arguments)),cleanup:()=>(this.cleanup(),this.requiredResponse(!0)),semanticDiagnosticsSync:o=>this.requiredResponse(this.getSemanticDiagnosticsSync(o.arguments)),syntacticDiagnosticsSync:o=>this.requiredResponse(this.getSyntacticDiagnosticsSync(o.arguments)),suggestionDiagnosticsSync:o=>this.requiredResponse(this.getSuggestionDiagnosticsSync(o.arguments)),geterr:o=>(this.errorCheck.startNew(l=>this.getDiagnostics(l,o.arguments.delay,o.arguments.files)),this.notRequired()),geterrForProject:o=>(this.errorCheck.startNew(l=>this.getDiagnosticsForProject(l,o.arguments.delay,o.arguments.file)),this.notRequired()),change:o=>(this.change(o.arguments),this.notRequired()),configure:o=>(this.projectService.setHostConfiguration(o.arguments),this.doOutput(void 0,"configure",o.seq,!0),this.notRequired()),reload:o=>(this.reload(o.arguments,o.seq),this.requiredResponse({reloadFinished:!0})),saveto:o=>{let l=o.arguments;return this.saveToTmp(l.file,l.tmpfile),this.notRequired()},close:o=>{let l=o.arguments;return this.closeClientFile(l.file),this.notRequired()},navto:o=>this.requiredResponse(this.getNavigateToItems(o.arguments,!0)),"navto-full":o=>this.requiredResponse(this.getNavigateToItems(o.arguments,!1)),brace:o=>this.requiredResponse(this.getBraceMatching(o.arguments,!0)),"brace-full":o=>this.requiredResponse(this.getBraceMatching(o.arguments,!1)),navbar:o=>this.requiredResponse(this.getNavigationBarItems(o.arguments,!0)),"navbar-full":o=>this.requiredResponse(this.getNavigationBarItems(o.arguments,!1)),navtree:o=>this.requiredResponse(this.getNavigationTree(o.arguments,!0)),"navtree-full":o=>this.requiredResponse(this.getNavigationTree(o.arguments,!1)),documentHighlights:o=>this.requiredResponse(this.getDocumentHighlights(o.arguments,!0)),"documentHighlights-full":o=>this.requiredResponse(this.getDocumentHighlights(o.arguments,!1)),compilerOptionsForInferredProjects:o=>(this.setCompilerOptionsForInferredProjects(o.arguments),this.requiredResponse(!0)),projectInfo:o=>this.requiredResponse(this.getProjectInfo(o.arguments)),reloadProjects:()=>(this.projectService.reloadProjects(),this.notRequired()),jsxClosingTag:o=>this.requiredResponse(this.getJsxClosingTag(o.arguments)),linkedEditingRange:o=>this.requiredResponse(this.getLinkedEditingRange(o.arguments)),getCodeFixes:o=>this.requiredResponse(this.getCodeFixes(o.arguments,!0)),"getCodeFixes-full":o=>this.requiredResponse(this.getCodeFixes(o.arguments,!1)),getCombinedCodeFix:o=>this.requiredResponse(this.getCombinedCodeFix(o.arguments,!0)),"getCombinedCodeFix-full":o=>this.requiredResponse(this.getCombinedCodeFix(o.arguments,!1)),applyCodeActionCommand:o=>this.requiredResponse(this.applyCodeActionCommand(o.arguments)),getSupportedCodeFixes:o=>this.requiredResponse(this.getSupportedCodeFixes(o.arguments)),getApplicableRefactors:o=>this.requiredResponse(this.getApplicableRefactors(o.arguments)),getEditsForRefactor:o=>this.requiredResponse(this.getEditsForRefactor(o.arguments,!0)),getMoveToRefactoringFileSuggestions:o=>this.requiredResponse(this.getMoveToRefactoringFileSuggestions(o.arguments)),"getEditsForRefactor-full":o=>this.requiredResponse(this.getEditsForRefactor(o.arguments,!1)),organizeImports:o=>this.requiredResponse(this.organizeImports(o.arguments,!0)),"organizeImports-full":o=>this.requiredResponse(this.organizeImports(o.arguments,!1)),getEditsForFileRename:o=>this.requiredResponse(this.getEditsForFileRename(o.arguments,!0)),"getEditsForFileRename-full":o=>this.requiredResponse(this.getEditsForFileRename(o.arguments,!1)),configurePlugin:o=>(this.configurePlugin(o.arguments),this.doOutput(void 0,"configurePlugin",o.seq,!0),this.notRequired()),selectionRange:o=>this.requiredResponse(this.getSmartSelectionRange(o.arguments,!0)),"selectionRange-full":o=>this.requiredResponse(this.getSmartSelectionRange(o.arguments,!1)),prepareCallHierarchy:o=>this.requiredResponse(this.prepareCallHierarchy(o.arguments)),provideCallHierarchyIncomingCalls:o=>this.requiredResponse(this.provideCallHierarchyIncomingCalls(o.arguments)),provideCallHierarchyOutgoingCalls:o=>this.requiredResponse(this.provideCallHierarchyOutgoingCalls(o.arguments)),toggleLineComment:o=>this.requiredResponse(this.toggleLineComment(o.arguments,!0)),"toggleLineComment-full":o=>this.requiredResponse(this.toggleLineComment(o.arguments,!1)),toggleMultilineComment:o=>this.requiredResponse(this.toggleMultilineComment(o.arguments,!0)),"toggleMultilineComment-full":o=>this.requiredResponse(this.toggleMultilineComment(o.arguments,!1)),commentSelection:o=>this.requiredResponse(this.commentSelection(o.arguments,!0)),"commentSelection-full":o=>this.requiredResponse(this.commentSelection(o.arguments,!1)),uncommentSelection:o=>this.requiredResponse(this.uncommentSelection(o.arguments,!0)),"uncommentSelection-full":o=>this.requiredResponse(this.uncommentSelection(o.arguments,!1)),provideInlayHints:o=>this.requiredResponse(this.provideInlayHints(o.arguments))})),this.host=t.host,this.cancellationToken=t.cancellationToken,this.typingsInstaller=t.typingsInstaller||Wq,this.byteLength=t.byteLength,this.hrtime=t.hrtime,this.logger=t.logger,this.canUseEvents=t.canUseEvents,this.suppressDiagnosticEvents=t.suppressDiagnosticEvents,this.noGetErrOnBackgroundUpdate=t.noGetErrOnBackgroundUpdate;let{throttleWaitMilliseconds:n}=t;this.eventHandler=this.canUseEvents?t.eventHandler||(o=>this.defaultEventHandler(o)):void 0;let i={executeWithRequestId:(o,l)=>this.executeWithRequestId(o,l),getCurrentRequestId:()=>this.currentRequestId,getServerHost:()=>this.host,logError:(o,l)=>this.logError(o,l),sendRequestCompletedEvent:o=>this.sendRequestCompletedEvent(o),isCancellationRequested:()=>this.cancellationToken.isCancellationRequested()};this.errorCheck=new wqe(i);let s={host:this.host,logger:this.logger,cancellationToken:this.cancellationToken,useSingleInferredProject:t.useSingleInferredProject,useInferredProjectPerProjectRoot:t.useInferredProjectPerProjectRoot,typingsInstaller:this.typingsInstaller,throttleWaitMilliseconds:n,eventHandler:this.eventHandler,suppressDiagnosticEvents:this.suppressDiagnosticEvents,globalPlugins:t.globalPlugins,pluginProbeLocations:t.pluginProbeLocations,allowLocalPluginLoads:t.allowLocalPluginLoads,typesMapLocation:t.typesMapLocation,serverMode:t.serverMode,session:this,canUseWatchEvents:t.canUseWatchEvents,incrementalVerifier:t.incrementalVerifier};switch(this.projectService=new Lse(s),this.projectService.setPerformanceEventHandler(this.performanceEventHandler.bind(this)),this.gcTimer=new yse(this.host,7e3,this.logger),this.projectService.serverMode){case 0:break;case 1:H2e.forEach(o=>this.handlers.set(o,l=>{throw new Error(`Request: ${l.command} not allowed in LanguageServiceMode.PartialSemantic`)}));break;case 2:Oqe.forEach(o=>this.handlers.set(o,l=>{throw new Error(`Request: ${l.command} not allowed in LanguageServiceMode.Syntactic`)}));break;default:I.assertNever(this.projectService.serverMode)}}sendRequestCompletedEvent(t){this.event({request_seq:t},"requestCompleted")}addPerformanceData(t,n){this.performanceData||(this.performanceData={}),this.performanceData[t]=(this.performanceData[t]??0)+n}performanceEventHandler(t){switch(t.kind){case"UpdateGraph":this.addPerformanceData("updateGraphDurationMs",t.durationMs);break;case"CreatePackageJsonAutoImportProvider":this.addPerformanceData("createAutoImportProviderProgramDurationMs",t.durationMs);break}}defaultEventHandler(t){switch(t.eventName){case sL:this.projectsUpdatedInBackgroundEvent(t.data.openFiles);break;case Kq:this.event({projectName:t.data.project.getProjectName(),reason:t.data.reason},t.eventName);break;case Qq:this.event({projectName:t.data.project.getProjectName()},t.eventName);break;case Zq:case nz:case iz:case sz:this.event(t.data,t.eventName);break;case ez:this.event({triggerFile:t.data.triggerFile,configFile:t.data.configFileName,diagnostics:vr(t.data.diagnostics,n=>oL(n,!0))},t.eventName);break;case tz:{this.event({projectName:t.data.project.getProjectName(),languageServiceEnabled:t.data.languageServiceEnabled},t.eventName);break}case rz:{this.event({telemetryEventName:t.eventName,payload:t.data},"telemetry");break}}}projectsUpdatedInBackgroundEvent(t){this.projectService.logger.info(`got projects updated in background ${t}`),t.length&&(!this.suppressDiagnosticEvents&&!this.noGetErrOnBackgroundUpdate&&(this.projectService.logger.info(`Queueing diagnostics update for ${t}`),this.errorCheck.startNew(n=>this.updateErrorCheck(n,t,100,!0))),this.event({openFiles:t},sL))}logError(t,n){this.logErrorWorker(t,n)}logErrorWorker(t,n,i){let s="Exception on executing command "+n;if(t.message&&(s+=`:
`+SO(t.message),t.stack&&(s+=`
`+SO(t.stack))),this.logger.hasLevel(3)){if(i)try{let{file:o,project:l}=this.getFileAndProject(i),p=l.getScriptInfoForNormalizedPath(o);if(p){let m=ED(p.getSnapshot());s+=`

File text of ${i.file}:${SO(m)}
`}}catch{}if(t.ProgramFiles){s+=`

Program files: ${JSON.stringify(t.ProgramFiles)}
`,s+=`

Projects::
`;let o=0,l=p=>{s+=`
Project '${p.projectName}' (${GO[p.projectKind]}) ${o}
`,s+=p.filesToString(!0),s+=`
-----------------------------------------------
`,o++};this.projectService.externalProjects.forEach(l),this.projectService.configuredProjects.forEach(l),this.projectService.inferredProjects.forEach(l)}}this.logger.msg(s,"Err")}send(t){if(t.type==="event"&&!this.canUseEvents){this.logger.hasLevel(3)&&this.logger.info(`Session does not support events: ignored event: ${LT(t)}`);return}this.writeMessage(t)}writeMessage(t){var n;let i=V2e(t,this.logger,this.byteLength,this.host.newLine);(n=z_)==null||n.logEvent(`Response message size: ${i.length}`),this.host.write(i)}event(t,n){this.send(J2e(n,t))}doOutput(t,n,i,s,o){let l={seq:0,type:"response",command:n,request_seq:i,success:s,performanceData:this.performanceData};if(s){let p;if(os(t))l.body=t,p=t.metadata,delete t.metadata;else if(typeof t=="object")if(t.metadata){let{metadata:m,...S}=t;l.body=S,p=m}else l.body=t;else l.body=t;p&&(l.metadata=p)}else I.assert(t===void 0);o&&(l.message=o),this.send(l)}semanticCheck(t,n){var i,s;(i=mn)==null||i.push(mn.Phase.Session,"semanticCheck",{file:t,configFilePath:n.canonicalConfigFilePath});let o=Cqe(n,t)?Vl:n.getLanguageService().getSemanticDiagnostics(t).filter(l=>!!l.file);this.sendDiagnosticsEvent(t,n,o,"semanticDiag"),(s=mn)==null||s.pop()}syntacticCheck(t,n){var i,s;(i=mn)==null||i.push(mn.Phase.Session,"syntacticCheck",{file:t,configFilePath:n.canonicalConfigFilePath}),this.sendDiagnosticsEvent(t,n,n.getLanguageService().getSyntacticDiagnostics(t),"syntaxDiag"),(s=mn)==null||s.pop()}suggestionCheck(t,n){var i,s;(i=mn)==null||i.push(mn.Phase.Session,"suggestionCheck",{file:t,configFilePath:n.canonicalConfigFilePath}),this.sendDiagnosticsEvent(t,n,n.getLanguageService().getSuggestionDiagnostics(t),"suggestionDiag"),(s=mn)==null||s.pop()}sendDiagnosticsEvent(t,n,i,s){try{this.event({file:t,diagnostics:i.map(o=>Aqe(t,n,o))},s)}catch(o){this.logError(o,s)}}updateErrorCheck(t,n,i,s=!0){I.assert(!this.suppressDiagnosticEvents);let o=this.changeSeq,l=Math.min(i,200),p=0,m=()=>{p++,n.length>p&&t.delay("checkOne",l,S)},S=()=>{if(this.changeSeq!==o)return;let h=n[p];if(vs(h)&&(h=this.toPendingErrorCheck(h),!h)){m();return}let{fileName:b,project:A}=h;if(qp(A),!!A.containsFile(b,s)&&(this.syntacticCheck(b,A),this.changeSeq===o)){if(A.projectService.serverMode!==0){m();return}t.immediate("semanticCheck",()=>{if(this.semanticCheck(b,A),this.changeSeq===o){if(this.getPreferences(b).disableSuggestions){m();return}t.immediate("suggestionCheck",()=>{this.suggestionCheck(b,A),m()})}})}};n.length>p&&this.changeSeq===o&&t.delay("checkOne",i,S)}cleanProjects(t,n){if(n){this.logger.info(`cleaning ${t}`);for(let i of n)i.getLanguageService(!1).cleanupSemanticCache(),i.cleanupProgram()}}cleanup(){this.cleanProjects("inferred projects",this.projectService.inferredProjects),this.cleanProjects("configured projects",In(this.projectService.configuredProjects.values())),this.cleanProjects("external projects",this.projectService.externalProjects),this.host.gc&&(this.logger.info("host.gc()"),this.host.gc())}getEncodedSyntacticClassifications(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t);return i.getEncodedSyntacticClassifications(n,t)}getEncodedSemanticClassifications(t){let{file:n,project:i}=this.getFileAndProject(t),s=t.format==="2020"?"2020":"original";return i.getLanguageService().getEncodedSemanticClassifications(n,t,s)}getProject(t){return t===void 0?void 0:this.projectService.findProject(t)}getConfigFileAndProject(t){let n=this.getProject(t.projectFileName),i=Cc(t.file);return{configFile:n&&n.hasConfigFile(i)?i:void 0,project:n}}getConfigFileDiagnostics(t,n,i){let s=n.getAllProjectErrors(),o=n.getLanguageService().getCompilerOptionsDiagnostics(),l=Fn(ys(s,o),p=>!!p.file&&p.file.fileName===t);return i?this.convertToDiagnosticsWithLinePositionFromDiagnosticFile(l):vr(l,p=>oL(p,!1))}convertToDiagnosticsWithLinePositionFromDiagnosticFile(t){return t.map(n=>({message:nh(n.messageText,this.host.newLine),start:n.start,length:n.length,category:R2(n),code:n.code,source:n.source,startLocation:n.file&&aL(Lo(n.file,n.start)),endLocation:n.file&&aL(Lo(n.file,n.start+n.length)),reportsUnnecessary:n.reportsUnnecessary,reportsDeprecated:n.reportsDeprecated,relatedInformation:vr(n.relatedInformation,Fse)}))}getCompilerOptionsDiagnostics(t){let n=this.getProject(t.projectFileName);return this.convertToDiagnosticsWithLinePosition(Fn(n.getLanguageService().getCompilerOptionsDiagnostics(),i=>!i.file),void 0)}convertToDiagnosticsWithLinePosition(t,n){return t.map(i=>({message:nh(i.messageText,this.host.newLine),start:i.start,length:i.length,category:R2(i),code:i.code,source:i.source,startLocation:n&&n.positionToLineOffset(i.start),endLocation:n&&n.positionToLineOffset(i.start+i.length),reportsUnnecessary:i.reportsUnnecessary,reportsDeprecated:i.reportsDeprecated,relatedInformation:vr(i.relatedInformation,Fse)}))}getDiagnosticsWorker(t,n,i,s){let{project:o,file:l}=this.getFileAndProject(t);if(n&&Cqe(o,l))return Vl;let p=o.getScriptInfoForNormalizedPath(l),m=i(o,l);return s?this.convertToDiagnosticsWithLinePosition(m,p):m.map(S=>Aqe(l,o,S))}getDefinition(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.getPositionInFile(t,i),l=this.mapDefinitionInfoLocations(s.getLanguageService().getDefinitionAtPosition(i,o)||Vl,s);return n?this.mapDefinitionInfo(l,s):l.map(v_e.mapToOriginalLocation)}mapDefinitionInfoLocations(t,n){return t.map(i=>{let s=Nqe(i,n);return s?{...s,containerKind:i.containerKind,containerName:i.containerName,kind:i.kind,name:i.name,failedAliasResolution:i.failedAliasResolution,...i.unverified&&{unverified:i.unverified}}:i})}getDefinitionAndBoundSpan(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.getPositionInFile(t,i),l=I.checkDefined(s.getScriptInfo(i)),p=s.getLanguageService().getDefinitionAndBoundSpan(i,o);if(!p||!p.definitions)return{definitions:Vl,textSpan:void 0};let m=this.mapDefinitionInfoLocations(p.definitions,s),{textSpan:S}=p;return n?{definitions:this.mapDefinitionInfo(m,s),textSpan:Hh(S,l)}:{definitions:m.map(v_e.mapToOriginalLocation),textSpan:S}}findSourceDefinition(t){var n;let{file:i,project:s}=this.getFileAndProject(t),o=this.getPositionInFile(t,i),l=s.getLanguageService().getDefinitionAtPosition(i,o),p=this.mapDefinitionInfoLocations(l||Vl,s).slice();if(this.projectService.serverMode===0&&(!Tt(p,k=>Cc(k.fileName)!==i&&!k.isAmbient)||Tt(p,k=>!!k.failedAliasResolution))){let k=Ug(U=>U.textSpan.start,kte(this.host.useCaseSensitiveFileNames));p?.forEach(U=>k.add(U));let N=s.getNoDtsResolutionProject(i),M=N.getLanguageService(),O=(n=M.getDefinitionAtPosition(i,o,!0,!1))==null?void 0:n.filter(U=>Cc(U.fileName)!==i);if(Tt(O))for(let U of O){if(U.unverified){let H=b(U,s.getLanguageService().getProgram(),M.getProgram());if(Tt(H)){for(let K of H)k.add(K);continue}}k.add(U)}else{let U=p.filter(H=>Cc(H.fileName)!==i&&H.isAmbient);for(let H of Tt(U)?U:h()){let K=S(H.fileName,i,N);if(!K)continue;let re=this.projectService.getOrCreateScriptInfoNotOpenedByClient(K,N.currentDirectory,N.directoryStructureHost);if(!re)continue;N.containsScriptInfo(re)||(N.addRoot(re),N.updateGraph());let $=M.getProgram(),pe=I.checkDefined($.getSourceFile(K));for(let z of A(H.name,pe,$))k.add(z)}}p=In(k.values())}return p=p.filter(k=>!k.isAmbient&&!k.failedAliasResolution),this.mapDefinitionInfo(p,s);function S(k,N,M){var O,U,H;let K=oB(k);if(K&&k.lastIndexOf(Wh)===K.topLevelNodeModulesIndex){let re=k.substring(0,K.packageRootIndex),$=(O=s.getModuleResolutionCache())==null?void 0:O.getPackageJsonInfoCache(),pe=s.getCompilationSettings(),z=dM(Ps(re+"/package.json",s.getCurrentDirectory()),pM($,s,pe));if(!z)return;let se=VQ(z,{moduleResolution:2},s,s.getModuleResolutionCache()),Se=k.substring(K.topLevelPackageNameIndex+1,K.packageRootIndex),xe=nO(hM(Se)),Z=s.toPath(k);if(se&&Tt(se,Q=>s.toPath(Q)===Z))return(U=M.resolutionCache.resolveSingleModuleNameWithoutWatching(xe,N).resolvedModule)==null?void 0:U.resolvedFileName;{let Q=k.substring(K.packageRootIndex+1),ce=`${xe}/${ff(Q)}`;return(H=M.resolutionCache.resolveSingleModuleNameWithoutWatching(ce,N).resolvedModule)==null?void 0:H.resolvedFileName}}}function h(){let k=s.getLanguageService(),N=k.getProgram(),M=If(N.getSourceFile(i),o);return(bo(M)||ze(M))&&Yo(M.parent)&&gme(M,O=>{var U;if(O===M)return;let H=(U=k.getDefinitionAtPosition(i,O.getStart(),!0,!1))==null?void 0:U.filter(K=>Cc(K.fileName)!==i&&K.isAmbient).map(K=>({fileName:K.fileName,name:om(M)}));if(Tt(H))return H})||Vl}function b(k,N,M){var O;let U=M.getSourceFile(k.fileName);if(!U)return;let H=If(N.getSourceFile(i),o),K=N.getTypeChecker().getSymbolAtLocation(H),re=K&&xc(K,276);if(!re)return;let $=((O=re.propertyName)==null?void 0:O.text)||re.name.text;return A($,U,M)}function A(k,N,M){let O=Ko.Core.getTopMostDeclarationNamesInFile(k,N);return Wi(O,U=>{let H=M.getTypeChecker().getSymbolAtLocation(U),K=Hw(U);if(H&&K)return UD.createDefinitionInfo(K,M.getTypeChecker(),H,K,!0)})}}getEmitOutput(t){let{file:n,project:i}=this.getFileAndProject(t);if(!i.shouldEmitFile(i.getScriptInfo(n)))return{emitSkipped:!0,outputFiles:[],diagnostics:[]};let s=i.getLanguageService().getEmitOutput(n);return t.richResponse?{...s,diagnostics:t.includeLinePosition?this.convertToDiagnosticsWithLinePositionFromDiagnosticFile(s.diagnostics):s.diagnostics.map(o=>oL(o,!0))}:s}mapJSDocTagInfo(t,n,i){return t?t.map(s=>{var o;return{...s,text:i?this.mapDisplayParts(s.text,n):(o=s.text)==null?void 0:o.map(l=>l.text).join("")}}):[]}mapDisplayParts(t,n){return t?t.map(i=>i.kind!=="linkName"?i:{...i,target:this.toFileSpan(i.target.fileName,i.target.textSpan,n)}):[]}mapSignatureHelpItems(t,n,i){return t.map(s=>({...s,documentation:this.mapDisplayParts(s.documentation,n),parameters:s.parameters.map(o=>({...o,documentation:this.mapDisplayParts(o.documentation,n)})),tags:this.mapJSDocTagInfo(s.tags,n,i)}))}mapDefinitionInfo(t,n){return t.map(i=>({...this.toFileSpanWithContext(i.fileName,i.textSpan,i.contextSpan,n),...i.unverified&&{unverified:i.unverified}}))}static mapToOriginalLocation(t){return t.originalFileName?(I.assert(t.originalTextSpan!==void 0,"originalTextSpan should be present if originalFileName is"),{...t,fileName:t.originalFileName,textSpan:t.originalTextSpan,targetFileName:t.fileName,targetTextSpan:t.textSpan,contextSpan:t.originalContextSpan,targetContextSpan:t.contextSpan}):t}toFileSpan(t,n,i){let s=i.getLanguageService(),o=s.toLineColumnOffset(t,n.start),l=s.toLineColumnOffset(t,gl(n));return{file:t,start:{line:o.line+1,offset:o.character+1},end:{line:l.line+1,offset:l.character+1}}}toFileSpanWithContext(t,n,i,s){let o=this.toFileSpan(t,n,s),l=i&&this.toFileSpan(t,i,s);return l?{...o,contextStart:l.start,contextEnd:l.end}:o}getTypeDefinition(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.getPositionInFile(t,n),o=this.mapDefinitionInfoLocations(i.getLanguageService().getTypeDefinitionAtPosition(n,s)||Vl,i);return this.mapDefinitionInfo(o,i)}mapImplementationLocations(t,n){return t.map(i=>{let s=Nqe(i,n);return s?{...s,kind:i.kind,displayParts:i.displayParts}:i})}getImplementation(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.getPositionInFile(t,i),l=this.mapImplementationLocations(s.getLanguageService().getImplementationAtPosition(i,o)||Vl,s);return n?l.map(({fileName:p,textSpan:m,contextSpan:S})=>this.toFileSpanWithContext(p,m,S,s)):l.map(v_e.mapToOriginalLocation)}getSyntacticDiagnosticsSync(t){let{configFile:n}=this.getConfigFileAndProject(t);return n?Vl:this.getDiagnosticsWorker(t,!1,(i,s)=>i.getLanguageService().getSyntacticDiagnostics(s),!!t.includeLinePosition)}getSemanticDiagnosticsSync(t){let{configFile:n,project:i}=this.getConfigFileAndProject(t);return n?this.getConfigFileDiagnostics(n,i,!!t.includeLinePosition):this.getDiagnosticsWorker(t,!0,(s,o)=>s.getLanguageService().getSemanticDiagnostics(o).filter(l=>!!l.file),!!t.includeLinePosition)}getSuggestionDiagnosticsSync(t){let{configFile:n}=this.getConfigFileAndProject(t);return n?Vl:this.getDiagnosticsWorker(t,!0,(i,s)=>i.getLanguageService().getSuggestionDiagnostics(s),!!t.includeLinePosition)}getJsxClosingTag(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n),o=i.getJsxClosingTagAtPosition(n,s);return o===void 0?void 0:{newText:o.newText,caretOffset:0}}getLinkedEditingRange(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n),o=i.getLinkedEditingRangeAtPosition(n,s),l=this.projectService.getScriptInfoForNormalizedPath(n);if(!(l===void 0||o===void 0))return A8t(o,l)}getDocumentHighlights(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.getPositionInFile(t,i),l=s.getLanguageService().getDocumentHighlights(i,o,t.filesToSearch);return l?n?l.map(({fileName:p,highlightSpans:m})=>{let S=s.getScriptInfo(p);return{file:p,highlightSpans:m.map(({textSpan:h,kind:b,contextSpan:A})=>({...z2e(h,A,S),kind:b}))}}):l:Vl}provideInlayHints(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.projectService.getScriptInfoForNormalizedPath(n);return i.getLanguageService().provideInlayHints(n,t,this.getPreferences(n)).map(l=>{let{position:p,displayParts:m}=l;return{...l,position:s.positionToLineOffset(p),displayParts:m?.map(({text:S,span:h,file:b})=>{if(h){I.assertIsDefined(b,"Target file should be defined together with its span.");let A=this.projectService.getScriptInfo(b);return{text:S,span:{start:A.positionToLineOffset(h.start),end:A.positionToLineOffset(h.start+h.length),file:b}}}else return{text:S}})}})}setCompilerOptionsForInferredProjects(t){this.projectService.setCompilerOptionsForInferredProjects(t.options,t.projectRootPath)}getProjectInfo(t){return this.getProjectInfoWorker(t.file,t.projectFileName,t.needFileNameList,!1)}getProjectInfoWorker(t,n,i,s){let{project:o}=this.getFileAndProjectWorker(t,n);return qp(o),{configFileName:o.getProjectName(),languageServiceDisabled:!o.languageServiceEnabled,fileNames:i?o.getFileNames(!1,s):void 0}}getRenameInfo(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.getPositionInFile(t,n),o=this.getPreferences(n);return i.getLanguageService().getRenameInfo(n,s,o)}getProjects(t,n,i){let s,o;if(t.projectFileName){let l=this.getProject(t.projectFileName);l&&(s=[l])}else{let l=n?this.projectService.getScriptInfoEnsuringProjectsUptoDate(t.file):this.projectService.getScriptInfo(t.file);if(l)n||this.projectService.ensureDefaultProjectForFile(l);else return i?Vl:(this.projectService.logErrorForScriptInfoNotFound(t.file),G1.ThrowNoProject());s=l.containingProjects,o=this.projectService.getSymlinkedProjects(l)}return s=Fn(s,l=>l.languageServiceEnabled&&!l.isOrphan()),!i&&(!s||!s.length)&&!o?(this.projectService.logErrorForScriptInfoNotFound(t.file??t.projectFileName),G1.ThrowNoProject()):o?{projects:s,symLinkedProjects:o}:s}getDefaultProject(t){if(t.projectFileName){let i=this.getProject(t.projectFileName);if(i)return i;if(!t.file)return G1.ThrowNoProject()}return this.projectService.getScriptInfo(t.file).getDefaultProject()}getRenameLocations(t,n){let i=Cc(t.file),s=this.getPositionInFile(t,i),o=this.getProjects(t),l=this.getDefaultProject(t),p=this.getPreferences(i),m=this.mapRenameInfo(l.getLanguageService().getRenameInfo(i,s,p),I.checkDefined(this.projectService.getScriptInfo(i)));if(!m.canRename)return n?{info:m,locs:[]}:[];let S=v8t(o,l,{fileName:t.file,pos:s},!!t.findInStrings,!!t.findInComments,p,this.host.useCaseSensitiveFileNames);return n?{info:m,locs:this.toSpanGroups(S)}:S}mapRenameInfo(t,n){if(t.canRename){let{canRename:i,fileToRename:s,displayName:o,fullDisplayName:l,kind:p,kindModifiers:m,triggerSpan:S}=t;return{canRename:i,fileToRename:s,displayName:o,fullDisplayName:l,kind:p,kindModifiers:m,triggerSpan:Hh(S,n)}}else return t}toSpanGroups(t){let n=new Map;for(let{fileName:i,textSpan:s,contextSpan:o,originalContextSpan:l,originalTextSpan:p,originalFileName:m,...S}of t){let h=n.get(i);h||n.set(i,h={file:i,locs:[]});let b=I.checkDefined(this.projectService.getScriptInfo(i));h.locs.push({...z2e(s,o,b),...S})}return In(n.values())}getReferences(t,n){let i=Cc(t.file),s=this.getProjects(t),o=this.getPositionInFile(t,i),l=T8t(s,this.getDefaultProject(t),{fileName:t.file,pos:o},this.host.useCaseSensitiveFileNames,this.logger);if(!n)return l;let p=this.getPreferences(i),m=this.getDefaultProject(t),S=m.getScriptInfoForNormalizedPath(i),h=m.getLanguageService().getQuickInfoAtPosition(i,o),b=h?D7(h.displayParts):"",A=h&&h.textSpan,k=A?S.positionToLineOffset(A.start).offset:0,N=A?S.getSnapshot().getText(A.start,gl(A)):"";return{refs:_a(l,O=>O.references.map(U=>Iqe(this.projectService,U,p))),symbolName:N,symbolStartOffset:k,symbolDisplayString:b}}getFileReferences(t,n){let i=this.getProjects(t),s=t.file,o=this.getPreferences(Cc(s)),l=[],p=jse(this.host.useCaseSensitiveFileNames);return q2e(i,void 0,S=>{if(S.getCancellationToken().isCancellationRequested())return;let h=S.getLanguageService().getFileReferences(s);if(h)for(let b of h)p.has(b)||(l.push(b),p.add(b))}),n?{refs:l.map(S=>Iqe(this.projectService,S,o)),symbolName:`"${t.file}"`}:l}openClientFile(t,n,i,s){this.projectService.openClientFileWithNormalizedPath(t,n,i,!1,s)}getPosition(t,n){return t.position!==void 0?t.position:n.lineOffsetToPosition(t.line,t.offset)}getPositionInFile(t,n){let i=this.projectService.getScriptInfoForNormalizedPath(n);return this.getPosition(t,i)}getFileAndProject(t){return this.getFileAndProjectWorker(t.file,t.projectFileName)}getFileAndLanguageServiceForSyntacticOperation(t){let{file:n,project:i}=this.getFileAndProject(t);return{file:n,languageService:i.getLanguageService(!1)}}getFileAndProjectWorker(t,n){let i=Cc(t),s=this.getProject(n)||this.projectService.ensureDefaultProjectForFile(i);return{file:i,project:s}}getOutliningSpans(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=s.getOutliningSpans(i);if(n){let l=this.projectService.getScriptInfoForNormalizedPath(i);return o.map(p=>({textSpan:Hh(p.textSpan,l),hintSpan:Hh(p.hintSpan,l),bannerText:p.bannerText,autoCollapse:p.autoCollapse,kind:p.kind}))}else return o}getTodoComments(t){let{file:n,project:i}=this.getFileAndProject(t);return i.getLanguageService().getTodoComments(n,t.descriptors)}getDocCommentTemplate(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n);return i.getDocCommentTemplateAtPosition(n,s,this.getPreferences(n),this.getFormatOptions(n))}getSpanOfEnclosingComment(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=t.onlyMultiLine,o=this.getPositionInFile(t,n);return i.getSpanOfEnclosingComment(n,o,s)}getIndentation(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n),o=t.options?WD(t.options):this.getFormatOptions(n),l=i.getIndentationAtPosition(n,s,o);return{position:s,indentation:l}}getBreakpointStatement(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n);return i.getBreakpointStatementAtPosition(n,s)}getNameOrDottedNameSpan(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n);return i.getNameOrDottedNameSpan(n,s,s)}isValidBraceCompletion(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.getPositionInFile(t,n);return i.isValidBraceCompletionAtPosition(n,s,t.openingBrace.charCodeAt(0))}getQuickInfoWorker(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.projectService.getScriptInfoForNormalizedPath(i),l=s.getLanguageService().getQuickInfoAtPosition(i,this.getPosition(t,o));if(!l)return;let p=!!this.getPreferences(i).displayPartsForJSDoc;if(n){let m=D7(l.displayParts);return{kind:l.kind,kindModifiers:l.kindModifiers,start:o.positionToLineOffset(l.textSpan.start),end:o.positionToLineOffset(gl(l.textSpan)),displayString:m,documentation:p?this.mapDisplayParts(l.documentation,s):D7(l.documentation),tags:this.mapJSDocTagInfo(l.tags,s,p)}}else return p?l:{...l,tags:this.mapJSDocTagInfo(l.tags,s,!1)}}getFormattingEditsForRange(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.projectService.getScriptInfoForNormalizedPath(n),o=s.lineOffsetToPosition(t.line,t.offset),l=s.lineOffsetToPosition(t.endLine,t.endOffset),p=i.getFormattingEditsForRange(n,o,l,this.getFormatOptions(n));if(p)return p.map(m=>this.convertTextChangeToCodeEdit(m,s))}getFormattingEditsForRangeFull(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=t.options?WD(t.options):this.getFormatOptions(n);return i.getFormattingEditsForRange(n,t.position,t.endPosition,s)}getFormattingEditsForDocumentFull(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=t.options?WD(t.options):this.getFormatOptions(n);return i.getFormattingEditsForDocument(n,s)}getFormattingEditsAfterKeystrokeFull(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=t.options?WD(t.options):this.getFormatOptions(n);return i.getFormattingEditsAfterKeystroke(n,t.position,t.key,s)}getFormattingEditsAfterKeystroke(t){let{file:n,languageService:i}=this.getFileAndLanguageServiceForSyntacticOperation(t),s=this.projectService.getScriptInfoForNormalizedPath(n),o=s.lineOffsetToPosition(t.line,t.offset),l=this.getFormatOptions(n),p=i.getFormattingEditsAfterKeystroke(n,o,t.key,l);if(t.key===`
`&&(!p||p.length===0||h8t(p,o))){let{lineText:m,absolutePosition:S}=s.textStorage.getAbsolutePositionAndLineText(t.line);if(m&&m.search("\\S")<0){let h=i.getIndentationAtPosition(n,o,l),b=0,A,k;for(A=0,k=m.length;A<k;A++)if(m.charAt(A)===" ")b++;else if(m.charAt(A)==="	")b+=l.tabSize;else break;if(h!==b){let N=S+A;p.push({span:Ll(S,N),newText:fu.getIndentationString(h,l)})}}}if(p)return p.map(m=>({start:s.positionToLineOffset(m.span.start),end:s.positionToLineOffset(gl(m.span)),newText:m.newText?m.newText:""}))}getCompletions(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.projectService.getScriptInfoForNormalizedPath(i),l=this.getPosition(t,o),p=s.getLanguageService().getCompletionsAtPosition(i,l,{...N2e(this.getPreferences(i)),triggerCharacter:t.triggerCharacter,triggerKind:t.triggerKind,includeExternalModuleExports:t.includeExternalModuleExports,includeInsertTextCompletions:t.includeInsertTextCompletions},s.projectService.getFormatCodeOptions(i));if(p===void 0)return;if(n==="completions-full")return p;let m=t.prefix||"",S=Wi(p.entries,b=>{if(p.isMemberCompletion||Ss(b.name.toLowerCase(),m.toLowerCase())){let{name:A,kind:k,kindModifiers:N,sortText:M,insertText:O,filterText:U,replacementSpan:H,hasAction:K,source:re,sourceDisplay:$,labelDetails:pe,isSnippet:z,isRecommended:se,isPackageJsonImport:Se,isImportStatementCompletion:xe,data:Z}=b,Q=H?Hh(H,o):void 0;return{name:A,kind:k,kindModifiers:N,sortText:M,insertText:O,filterText:U,replacementSpan:Q,isSnippet:z,hasAction:K||void 0,source:re,sourceDisplay:$,labelDetails:pe,isRecommended:se,isPackageJsonImport:Se,isImportStatementCompletion:xe,data:Z}}});return n==="completions"?(p.metadata&&(S.metadata=p.metadata),S):{...p,optionalReplacementSpan:p.optionalReplacementSpan&&Hh(p.optionalReplacementSpan,o),entries:S}}getCompletionEntryDetails(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.projectService.getScriptInfoForNormalizedPath(i),l=this.getPosition(t,o),p=s.projectService.getFormatCodeOptions(i),m=!!this.getPreferences(i).displayPartsForJSDoc,S=Wi(t.entryNames,h=>{let{name:b,source:A,data:k}=typeof h=="string"?{name:h,source:void 0,data:void 0}:h;return s.getLanguageService().getCompletionEntryDetails(i,l,b,p,A,this.getPreferences(i),k?ta(k,I8t):void 0)});return n?m?S:S.map(h=>({...h,tags:this.mapJSDocTagInfo(h.tags,s,!1)})):S.map(h=>({...h,codeActions:vr(h.codeActions,b=>this.mapCodeAction(b)),documentation:this.mapDisplayParts(h.documentation,s),tags:this.mapJSDocTagInfo(h.tags,s,m)}))}getCompileOnSaveAffectedFileList(t){let n=this.getProjects(t,!0,!0),i=this.projectService.getScriptInfo(t.file);return i?y8t(i,s=>this.projectService.getScriptInfoForPath(s),n,(s,o)=>{if(!s.compileOnSaveEnabled||!s.languageServiceEnabled||s.isOrphan())return;let l=s.getCompilationSettings();if(!(l.noEmit||i_(o.fileName)&&!g8t(l)))return{projectFileName:s.getProjectName(),fileNames:s.getCompileOnSaveAffectedFileList(o),projectUsesOutFile:!!Wo(l)}}):Vl}emitFile(t){let{file:n,project:i}=this.getFileAndProject(t);if(i||G1.ThrowNoProject(),!i.languageServiceEnabled)return t.richResponse?{emitSkipped:!0,diagnostics:[]}:!1;let s=i.getScriptInfo(n),{emitSkipped:o,diagnostics:l}=i.emitFile(s,(p,m,S)=>this.host.writeFile(p,m,S));return t.richResponse?{emitSkipped:o,diagnostics:t.includeLinePosition?this.convertToDiagnosticsWithLinePositionFromDiagnosticFile(l):l.map(p=>oL(p,!0))}:!o}getSignatureHelpItems(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=this.projectService.getScriptInfoForNormalizedPath(i),l=this.getPosition(t,o),p=s.getLanguageService().getSignatureHelpItems(i,l,t),m=!!this.getPreferences(i).displayPartsForJSDoc;if(p&&n){let S=p.applicableSpan;return{...p,applicableSpan:{start:o.positionToLineOffset(S.start),end:o.positionToLineOffset(S.start+S.length)},items:this.mapSignatureHelpItems(p.items,s,m)}}else return m||!p?p:{...p,items:p.items.map(S=>({...S,tags:this.mapJSDocTagInfo(S.tags,s,!1)}))}}toPendingErrorCheck(t){let n=Cc(t),i=this.projectService.tryGetDefaultProjectForFile(n);return i&&{fileName:n,project:i}}getDiagnostics(t,n,i){this.suppressDiagnosticEvents||i.length>0&&this.updateErrorCheck(t,i,n)}change(t){let n=this.projectService.getScriptInfo(t.file);I.assert(!!n),n.textStorage.switchToScriptVersionCache();let i=n.lineOffsetToPosition(t.line,t.offset),s=n.lineOffsetToPosition(t.endLine,t.endOffset);i>=0&&(this.changeSeq++,this.projectService.applyChangesToFile(n,k2({span:{start:i,length:s-i},newText:t.insertString})))}reload(t,n){let i=Cc(t.file),s=t.tmpfile===void 0?void 0:Cc(t.tmpfile),o=this.projectService.getScriptInfoForNormalizedPath(i);o&&(this.changeSeq++,o.reloadFromFile(s)&&this.doOutput(void 0,"reload",n,!0))}saveToTmp(t,n){let i=this.projectService.getScriptInfo(t);i&&i.saveTo(n)}closeClientFile(t){if(!t)return;let n=Ca(t);this.projectService.closeClientFile(n)}mapLocationNavigationBarItems(t,n){return vr(t,i=>({text:i.text,kind:i.kind,kindModifiers:i.kindModifiers,spans:i.spans.map(s=>Hh(s,n)),childItems:this.mapLocationNavigationBarItems(i.childItems,n),indent:i.indent}))}getNavigationBarItems(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=s.getNavigationBarItems(i);return o?n?this.mapLocationNavigationBarItems(o,this.projectService.getScriptInfoForNormalizedPath(i)):o:void 0}toLocationNavigationTree(t,n){return{text:t.text,kind:t.kind,kindModifiers:t.kindModifiers,spans:t.spans.map(i=>Hh(i,n)),nameSpan:t.nameSpan&&Hh(t.nameSpan,n),childItems:vr(t.childItems,i=>this.toLocationNavigationTree(i,n))}}getNavigationTree(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=s.getNavigationTree(i);return o?n?this.toLocationNavigationTree(o,this.projectService.getScriptInfoForNormalizedPath(i)):o:void 0}getNavigateToItems(t,n){let i=this.getFullNavigateToItems(t);return n?_a(i,({project:s,navigateToItems:o})=>o.map(l=>{let p=s.getScriptInfo(l.fileName),m={name:l.name,kind:l.kind,kindModifiers:l.kindModifiers,isCaseSensitive:l.isCaseSensitive,matchKind:l.matchKind,file:l.fileName,start:p.positionToLineOffset(l.textSpan.start),end:p.positionToLineOffset(gl(l.textSpan))};return l.kindModifiers&&l.kindModifiers!==""&&(m.kindModifiers=l.kindModifiers),l.containerName&&l.containerName.length>0&&(m.containerName=l.containerName),l.containerKind&&l.containerKind.length>0&&(m.containerKind=l.containerKind),m})):_a(i,({navigateToItems:s})=>s)}getFullNavigateToItems(t){let{currentFileOnly:n,searchValue:i,maxResultCount:s,projectFileName:o}=t;if(n){I.assertIsDefined(t.file);let{file:A,project:k}=this.getFileAndProject(t);return[{project:k,navigateToItems:k.getLanguageService().getNavigateToItems(i,s,A)}]}let l=this.getHostPreferences(),p=[],m=new Map;if(!t.file&&!o)this.projectService.loadAncestorProjectTree(),this.projectService.forEachEnabledProject(A=>S(A));else{let A=this.getProjects(t);q2e(A,void 0,k=>S(k))}return p;function S(A){let k=A.getLanguageService().getNavigateToItems(i,s,void 0,A.isNonTsProject(),l.excludeLibrarySymbolsInNavTo),N=Fn(k,M=>h(M)&&!Bse(HO(M),A));N.length&&p.push({project:A,navigateToItems:N})}function h(A){let k=A.name;if(!m.has(k))return m.set(k,[A]),!0;let N=m.get(k);for(let M of N)if(b(M,A))return!1;return N.push(A),!0}function b(A,k){return A===k?!0:!A||!k?!1:A.containerKind===k.containerKind&&A.containerName===k.containerName&&A.fileName===k.fileName&&A.isCaseSensitive===k.isCaseSensitive&&A.kind===k.kind&&A.kindModifiers===k.kindModifiers&&A.matchKind===k.matchKind&&A.name===k.name&&A.textSpan.start===k.textSpan.start&&A.textSpan.length===k.textSpan.length}}getSupportedCodeFixes(t){if(!t)return Yre();if(t.file){let{file:i,project:s}=this.getFileAndProject(t);return s.getLanguageService().getSupportedCodeFixes(i)}let n=this.getProject(t.projectFileName);return n||G1.ThrowNoProject(),n.getLanguageService().getSupportedCodeFixes()}isLocation(t){return t.line!==void 0}extractPositionOrRange(t,n){let i,s;return this.isLocation(t)?i=o(t):s=this.getRange(t,n),I.checkDefined(i===void 0?s:i);function o(l){return l.position!==void 0?l.position:n.lineOffsetToPosition(l.line,l.offset)}}getRange(t,n){let{startPosition:i,endPosition:s}=this.getStartAndEndPosition(t,n);return{pos:i,end:s}}getApplicableRefactors(t){let{file:n,project:i}=this.getFileAndProject(t),s=i.getScriptInfoForNormalizedPath(n);return i.getLanguageService().getApplicableRefactors(n,this.extractPositionOrRange(t,s),this.getPreferences(n),t.triggerReason,t.kind,t.includeInteractiveActions)}getEditsForRefactor(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=s.getScriptInfoForNormalizedPath(i),l=s.getLanguageService().getEditsForRefactor(i,this.getFormatOptions(i),this.extractPositionOrRange(t,o),t.refactor,t.action,this.getPreferences(i),t.interactiveRefactorArguments);if(l===void 0)return{edits:[]};if(n){let{renameFilename:p,renameLocation:m,edits:S}=l,h;if(p!==void 0&&m!==void 0){let b=s.getScriptInfoForNormalizedPath(Cc(p));h=$2e(ED(b.getSnapshot()),p,m,S)}return{renameLocation:h,renameFilename:p,edits:this.mapTextChangesToCodeEdits(S),notApplicableReason:l.notApplicableReason}}return l}getMoveToRefactoringFileSuggestions(t){let{file:n,project:i}=this.getFileAndProject(t),s=i.getScriptInfoForNormalizedPath(n);return i.getLanguageService().getMoveToRefactoringFileSuggestions(n,this.extractPositionOrRange(t,s),this.getPreferences(n))}organizeImports(t,n){I.assert(t.scope.type==="file");let{file:i,project:s}=this.getFileAndProject(t.scope.args),o=s.getLanguageService().organizeImports({fileName:i,mode:t.mode??(t.skipDestructiveCodeActions?"SortAndCombine":void 0),type:"file"},this.getFormatOptions(i),this.getPreferences(i));return n?this.mapTextChangesToCodeEdits(o):o}getEditsForFileRename(t,n){let i=Cc(t.oldFilePath),s=Cc(t.newFilePath),o=this.getHostFormatOptions(),l=this.getHostPreferences(),p=new Set,m=[];return this.projectService.loadAncestorProjectTree(),this.projectService.forEachEnabledProject(S=>{let h=S.getLanguageService().getEditsForFileRename(i,s,o,l),b=[];for(let A of h)p.has(A.fileName)||(m.push(A),b.push(A.fileName));for(let A of b)p.add(A)}),n?m.map(S=>this.mapTextChangeToCodeEdit(S)):m}getCodeFixes(t,n){let{file:i,project:s}=this.getFileAndProject(t),o=s.getScriptInfoForNormalizedPath(i),{startPosition:l,endPosition:p}=this.getStartAndEndPosition(t,o),m;try{m=s.getLanguageService().getCodeFixesAtPosition(i,l,p,t.errorCodes,this.getFormatOptions(i),this.getPreferences(i))}catch(S){let h=s.getLanguageService(),b=[...h.getSyntacticDiagnostics(i),...h.getSemanticDiagnostics(i),...h.getSuggestionDiagnostics(i)].map(k=>H3(l,p-l,k.start,k.length)&&k.code),A=t.errorCodes.find(k=>!b.includes(k));throw A!==void 0&&(S.message=`BADCLIENT: Bad error code, ${A} not found in range ${l}..${p} (found: ${b.join(", ")}); could have caused this error:
${S.message}`),S}return n?m.map(S=>this.mapCodeFixAction(S)):m}getCombinedCodeFix({scope:t,fixId:n},i){I.assert(t.type==="file");let{file:s,project:o}=this.getFileAndProject(t.args),l=o.getLanguageService().getCombinedCodeFix({type:"file",fileName:s},n,this.getFormatOptions(s),this.getPreferences(s));return i?{changes:this.mapTextChangesToCodeEdits(l.changes),commands:l.commands}:l}applyCodeActionCommand(t){let n=t.command;for(let i of Pm(n)){let{file:s,project:o}=this.getFileAndProject(i);o.getLanguageService().applyCodeActionCommand(i,this.getFormatOptions(s)).then(l=>{},l=>{})}return{}}getStartAndEndPosition(t,n){let i,s;return t.startPosition!==void 0?i=t.startPosition:(i=n.lineOffsetToPosition(t.startLine,t.startOffset),t.startPosition=i),t.endPosition!==void 0?s=t.endPosition:(s=n.lineOffsetToPosition(t.endLine,t.endOffset),t.endPosition=s),{startPosition:i,endPosition:s}}mapCodeAction({description:t,changes:n,commands:i}){return{description:t,changes:this.mapTextChangesToCodeEdits(n),commands:i}}mapCodeFixAction({fixName:t,description:n,changes:i,commands:s,fixId:o,fixAllDescription:l}){return{fixName:t,description:n,changes:this.mapTextChangesToCodeEdits(i),commands:s,fixId:o,fixAllDescription:l}}mapTextChangesToCodeEdits(t){return t.map(n=>this.mapTextChangeToCodeEdit(n))}mapTextChangeToCodeEdit(t){let n=this.projectService.getScriptInfoOrConfig(t.fileName);return!!t.isNewFile==!!n&&(n||this.projectService.logErrorForScriptInfoNotFound(t.fileName),I.fail("Expected isNewFile for (only) new files. "+JSON.stringify({isNewFile:!!t.isNewFile,hasScriptInfo:!!n}))),n?{fileName:t.fileName,textChanges:t.textChanges.map(i=>C8t(i,n))}:P8t(t)}convertTextChangeToCodeEdit(t,n){return{start:n.positionToLineOffset(t.span.start),end:n.positionToLineOffset(t.span.start+t.span.length),newText:t.newText?t.newText:""}}getBraceMatching(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=this.projectService.getScriptInfoForNormalizedPath(i),l=this.getPosition(t,o),p=s.getBraceMatchingAtPosition(i,l);return p?n?p.map(m=>Hh(m,o)):p:void 0}getDiagnosticsForProject(t,n,i){if(this.suppressDiagnosticEvents)return;let{fileNames:s,languageServiceDisabled:o}=this.getProjectInfoWorker(i,void 0,!0,!0);if(o)return;let l=s.filter(M=>!M.includes("lib.d.ts"));if(l.length===0)return;let p=[],m=[],S=[],h=[],b=Cc(i),A=this.projectService.ensureDefaultProjectForFile(b);for(let M of l)this.getCanonicalFileName(M)===this.getCanonicalFileName(i)?p.push(M):this.projectService.getScriptInfo(M).isScriptOpen()?m.push(M):i_(M)?h.push(M):S.push(M);let N=[...p,...m,...S,...h].map(M=>({fileName:M,project:A}));this.updateErrorCheck(t,N,n,!1)}configurePlugin(t){this.projectService.configurePlugin(t)}getSmartSelectionRange(t,n){let{locations:i}=t,{file:s,languageService:o}=this.getFileAndLanguageServiceForSyntacticOperation(t),l=I.checkDefined(this.projectService.getScriptInfo(s));return vr(i,p=>{let m=this.getPosition(p,l),S=o.getSmartSelectionRange(s,m);return n?this.mapSelectionRange(S,l):S})}toggleLineComment(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=this.projectService.getScriptInfo(i),l=this.getRange(t,o),p=s.toggleLineComment(i,l);if(n){let m=this.projectService.getScriptInfoForNormalizedPath(i);return p.map(S=>this.convertTextChangeToCodeEdit(S,m))}return p}toggleMultilineComment(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=this.projectService.getScriptInfoForNormalizedPath(i),l=this.getRange(t,o),p=s.toggleMultilineComment(i,l);if(n){let m=this.projectService.getScriptInfoForNormalizedPath(i);return p.map(S=>this.convertTextChangeToCodeEdit(S,m))}return p}commentSelection(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=this.projectService.getScriptInfoForNormalizedPath(i),l=this.getRange(t,o),p=s.commentSelection(i,l);if(n){let m=this.projectService.getScriptInfoForNormalizedPath(i);return p.map(S=>this.convertTextChangeToCodeEdit(S,m))}return p}uncommentSelection(t,n){let{file:i,languageService:s}=this.getFileAndLanguageServiceForSyntacticOperation(t),o=this.projectService.getScriptInfoForNormalizedPath(i),l=this.getRange(t,o),p=s.uncommentSelection(i,l);if(n){let m=this.projectService.getScriptInfoForNormalizedPath(i);return p.map(S=>this.convertTextChangeToCodeEdit(S,m))}return p}mapSelectionRange(t,n){let i={textSpan:Hh(t.textSpan,n)};return t.parent&&(i.parent=this.mapSelectionRange(t.parent,n)),i}getScriptInfoFromProjectService(t){let n=Cc(t),i=this.projectService.getScriptInfoForNormalizedPath(n);return i||(this.projectService.logErrorForScriptInfoNotFound(n),G1.ThrowNoProject())}toProtocolCallHierarchyItem(t){let n=this.getScriptInfoFromProjectService(t.file);return{name:t.name,kind:t.kind,kindModifiers:t.kindModifiers,file:t.file,containerName:t.containerName,span:Hh(t.span,n),selectionSpan:Hh(t.selectionSpan,n)}}toProtocolCallHierarchyIncomingCall(t){let n=this.getScriptInfoFromProjectService(t.from.file);return{from:this.toProtocolCallHierarchyItem(t.from),fromSpans:t.fromSpans.map(i=>Hh(i,n))}}toProtocolCallHierarchyOutgoingCall(t,n){return{to:this.toProtocolCallHierarchyItem(t.to),fromSpans:t.fromSpans.map(i=>Hh(i,n))}}prepareCallHierarchy(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.projectService.getScriptInfoForNormalizedPath(n);if(s){let o=this.getPosition(t,s),l=i.getLanguageService().prepareCallHierarchy(n,o);return l&&$te(l,p=>this.toProtocolCallHierarchyItem(p))}}provideCallHierarchyIncomingCalls(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.getScriptInfoFromProjectService(n);return i.getLanguageService().provideCallHierarchyIncomingCalls(n,this.getPosition(t,s)).map(l=>this.toProtocolCallHierarchyIncomingCall(l))}provideCallHierarchyOutgoingCalls(t){let{file:n,project:i}=this.getFileAndProject(t),s=this.getScriptInfoFromProjectService(n);return i.getLanguageService().provideCallHierarchyOutgoingCalls(n,this.getPosition(t,s)).map(l=>this.toProtocolCallHierarchyOutgoingCall(l,s))}getCanonicalFileName(t){let n=this.host.useCaseSensitiveFileNames?t:sp(t);return Ca(n)}exit(){}notRequired(){return{responseRequired:!1}}requiredResponse(t){return{response:t,responseRequired:!0}}addProtocolHandler(t,n){if(this.handlers.has(t))throw new Error(`Protocol handler already exists for command "${t}"`);this.handlers.set(t,n)}setCurrentRequest(t){I.assert(this.currentRequestId===void 0),this.currentRequestId=t,this.cancellationToken.setRequest(t)}resetCurrentRequest(t){I.assert(this.currentRequestId===t),this.currentRequestId=void 0,this.cancellationToken.resetRequest(t)}executeWithRequestId(t,n){try{return this.setCurrentRequest(t),n()}finally{this.resetCurrentRequest(t)}}executeCommand(t){let n=this.handlers.get(t.command);if(n){let i=this.executeWithRequestId(t.seq,()=>n(t));return this.projectService.enableRequestedPlugins(),i}else return this.logger.msg(`Unrecognized JSON command:${LT(t)}`,"Err"),this.doOutput(void 0,"unknown",t.seq,!1,`Unrecognized JSON command: ${t.command}`),{responseRequired:!1}}onMessage(t){var n,i,s,o,l,p,m,S,h,b,A;this.gcTimer.scheduleCollect(),this.performanceData=void 0;let k;this.logger.hasLevel(2)&&(k=this.hrtime(),this.logger.hasLevel(3)&&this.logger.info(`request:${SO(this.toStringMessage(t))}`));let N,M;try{N=this.parseMessage(t),M=N.arguments&&N.arguments.file?N.arguments:void 0,(n=mn)==null||n.instant(mn.Phase.Session,"request",{seq:N.seq,command:N.command}),(i=z_)==null||i.logStartCommand(""+N.command,this.toStringMessage(t).substring(0,100)),(s=mn)==null||s.push(mn.Phase.Session,"executeCommand",{seq:N.seq,command:N.command},!0);let{response:O,responseRequired:U}=this.executeCommand(N);if((o=mn)==null||o.pop(),this.logger.hasLevel(2)){let H=m8t(this.hrtime(k)).toFixed(4);U?this.logger.perftrc(`${N.seq}::${N.command}: elapsed time (in milliseconds) ${H}`):this.logger.perftrc(`${N.seq}::${N.command}: async elapsed time (in milliseconds) ${H}`)}(l=z_)==null||l.logStopCommand(""+N.command,"Success"),(p=mn)==null||p.instant(mn.Phase.Session,"response",{seq:N.seq,command:N.command,success:!!O}),O?this.doOutput(O,N.command,N.seq,!0):U&&this.doOutput(void 0,N.command,N.seq,!1,"No content available.")}catch(O){if((m=mn)==null||m.popAll(),O instanceof VP){(S=z_)==null||S.logStopCommand(""+(N&&N.command),"Canceled: "+O),(h=mn)==null||h.instant(mn.Phase.Session,"commandCanceled",{seq:N?.seq,command:N?.command}),this.doOutput({canceled:!0},N.command,N.seq,!0);return}this.logErrorWorker(O,this.toStringMessage(t),M),(b=z_)==null||b.logStopCommand(""+(N&&N.command),"Error: "+O),(A=mn)==null||A.instant(mn.Phase.Session,"commandError",{seq:N?.seq,command:N?.command,message:O.message}),this.doOutput(void 0,N?N.command:"unknown",N?N.seq:0,!1,"Error processing request. "+O.message+`
`+O.stack)}}parseMessage(t){return JSON.parse(t)}toStringMessage(t){return t}getFormatOptions(t){return this.projectService.getFormatCodeOptions(t)}getPreferences(t){return this.projectService.getPreferences(t)}getHostFormatOptions(){return this.projectService.getHostFormatCodeOptions()}getHostPreferences(){return this.projectService.getHostPreferences()}}}}),wk,Use,Rqe,Mqe,cz,lz,X2e,YO,Ok,cL,O8t=f({"src/server/scriptVersionCache.ts"(){"use strict";uS(),Mx(),wk=4,Use=(e=>(e[e.PreStart=0]="PreStart",e[e.Start=1]="Start",e[e.Entire=2]="Entire",e[e.Mid=3]="Mid",e[e.End=4]="End",e[e.PostEnd=5]="PostEnd",e))(Use||{}),Rqe=class{constructor(){this.goSubtree=!0,this.lineIndex=new YO,this.endBranch=[],this.state=2,this.initialText="",this.trailingText="",this.lineIndex.root=new Ok,this.startPath=[this.lineIndex.root],this.stack=[this.lineIndex.root]}get done(){return!1}insertLines(e,t){t&&(this.trailingText=""),e?e=this.initialText+e+this.trailingText:e=this.initialText+this.trailingText;let i=YO.linesFromText(e).lines;i.length>1&&i[i.length-1]===""&&i.pop();let s,o;for(let p=this.endBranch.length-1;p>=0;p--)this.endBranch[p].updateCounts(),this.endBranch[p].charCount()===0&&(o=this.endBranch[p],p>0?s=this.endBranch[p-1]:s=this.branchNode);o&&s.remove(o);let l=this.startPath[this.startPath.length-1];if(i.length>0)if(l.text=i[0],i.length>1){let p=new Array(i.length-1),m=l;for(let b=1;b<i.length;b++)p[b-1]=new cL(i[b]);let S=this.startPath.length-2;for(;S>=0;){let b=this.startPath[S];p=b.insertAt(m,p),S--,m=b}let h=p.length;for(;h>0;){let b=new Ok;b.add(this.lineIndex.root),p=b.insertAt(this.lineIndex.root,p),h=p.length,this.lineIndex.root=b}this.lineIndex.root.updateCounts()}else for(let p=this.startPath.length-2;p>=0;p--)this.startPath[p].updateCounts();else{this.startPath[this.startPath.length-2].remove(l);for(let m=this.startPath.length-2;m>=0;m--)this.startPath[m].updateCounts()}return this.lineIndex}post(e,t,n){n===this.lineCollectionAtBranch&&(this.state=4),this.stack.pop()}pre(e,t,n,i,s){let o=this.stack[this.stack.length-1];this.state===2&&s===1&&(this.state=1,this.branchNode=o,this.lineCollectionAtBranch=n);let l;function p(m){return m.isLeaf()?new cL(""):new Ok}switch(s){case 0:this.goSubtree=!1,this.state!==4&&o.add(n);break;case 1:this.state===4?this.goSubtree=!1:(l=p(n),o.add(l),this.startPath.push(l));break;case 2:this.state!==4?(l=p(n),o.add(l),this.startPath.push(l)):n.isLeaf()||(l=p(n),o.add(l),this.endBranch.push(l));break;case 3:this.goSubtree=!1;break;case 4:this.state!==4?this.goSubtree=!1:n.isLeaf()||(l=p(n),o.add(l),this.endBranch.push(l));break;case 5:this.goSubtree=!1,this.state!==1&&o.add(n);break}this.goSubtree&&this.stack.push(l)}leaf(e,t,n){this.state===1?this.initialText=n.text.substring(0,e):this.state===2?(this.initialText=n.text.substring(0,e),this.trailingText=n.text.substring(e+t)):this.trailingText=n.text.substring(e+t)}},Mqe=class{constructor(e,t,n){this.pos=e,this.deleteLen=t,this.insertedText=n}getTextChangeRange(){return Y3(e_(this.pos,this.deleteLen),this.insertedText?this.insertedText.length:0)}},cz=class YC{constructor(){this.changes=[],this.versions=new Array(YC.maxVersions),this.minVersion=0,this.currentVersion=0}versionToIndex(t){if(!(t<this.minVersion||t>this.currentVersion))return t%YC.maxVersions}currentVersionToIndex(){return this.currentVersion%YC.maxVersions}edit(t,n,i){this.changes.push(new Mqe(t,n,i)),(this.changes.length>YC.changeNumberThreshold||n>YC.changeLengthThreshold||i&&i.length>YC.changeLengthThreshold)&&this.getSnapshot()}getSnapshot(){return this._getSnapshot()}_getSnapshot(){let t=this.versions[this.currentVersionToIndex()];if(this.changes.length>0){let n=t.index;for(let i of this.changes)n=n.edit(i.pos,i.deleteLen,i.insertedText);t=new X2e(this.currentVersion+1,this,n,this.changes),this.currentVersion=t.version,this.versions[this.currentVersionToIndex()]=t,this.changes=[],this.currentVersion-this.minVersion>=YC.maxVersions&&(this.minVersion=this.currentVersion-YC.maxVersions+1)}return t}getSnapshotVersion(){return this._getSnapshot().version}getAbsolutePositionAndLineText(t){return this._getSnapshot().index.lineNumberToInfo(t)}lineOffsetToPosition(t,n){return this._getSnapshot().index.absolutePositionOfStartOfLine(t)+(n-1)}positionToLineOffset(t){return this._getSnapshot().index.positionToLineOffset(t)}lineToTextSpan(t){let n=this._getSnapshot().index,{lineText:i,absolutePosition:s}=n.lineNumberToInfo(t+1),o=i!==void 0?i.length:n.absolutePositionOfStartOfLine(t+2)-s;return e_(s,o)}getTextChangesBetweenVersions(t,n){if(t<n)if(t>=this.minVersion){let i=[];for(let s=t+1;s<=n;s++){let o=this.versions[this.versionToIndex(s)];for(let l of o.changesSincePreviousVersion)i.push(l.getTextChangeRange())}return rpe(i)}else return;else return _8}getLineCount(){return this._getSnapshot().index.getLineCount()}static fromString(t){let n=new YC,i=new X2e(0,n,new YO);n.versions[n.currentVersion]=i;let s=YO.linesFromText(t);return i.index.load(s.lines),n}},cz.changeNumberThreshold=8,cz.changeLengthThreshold=256,cz.maxVersions=8,lz=cz,X2e=class Gdt{constructor(t,n,i,s=Vl){this.version=t,this.cache=n,this.index=i,this.changesSincePreviousVersion=s}getText(t,n){return this.index.getText(t,n-t)}getLength(){return this.index.getLength()}getChangeRange(t){if(t instanceof Gdt&&this.cache===t.cache)return this.version<=t.version?_8:this.cache.getTextChangesBetweenVersions(t.version,this.version)}},YO=class x6e{constructor(){this.checkEdits=!1}absolutePositionOfStartOfLine(t){return this.lineNumberToInfo(t).absolutePosition}positionToLineOffset(t){let{oneBasedLine:n,zeroBasedColumn:i}=this.root.charOffsetToLineInfo(1,t);return{line:n,offset:i+1}}positionToColumnAndLineText(t){return this.root.charOffsetToLineInfo(1,t)}getLineCount(){return this.root.lineCount()}lineNumberToInfo(t){let n=this.getLineCount();if(t<=n){let{position:i,leaf:s}=this.root.lineNumberToInfo(t,0);return{absolutePosition:i,lineText:s&&s.text}}else return{absolutePosition:this.root.charCount(),lineText:void 0}}load(t){if(t.length>0){let n=[];for(let i=0;i<t.length;i++)n[i]=new cL(t[i]);this.root=x6e.buildTreeFromBottom(n)}else this.root=new Ok}walk(t,n,i){this.root.walk(t,n,i)}getText(t,n){let i="";return n>0&&t<this.root.charCount()&&this.walk(t,n,{goSubtree:!0,done:!1,leaf:(s,o,l)=>{i=i.concat(l.text.substring(s,s+o))}}),i}getLength(){return this.root.charCount()}every(t,n,i){i||(i=this.root.charCount());let s={goSubtree:!0,done:!1,leaf(o,l,p){t(p,o,l)||(this.done=!0)}};return this.walk(n,i-n,s),!s.done}edit(t,n,i){if(this.root.charCount()===0)return I.assert(n===0),i!==void 0?(this.load(x6e.linesFromText(i).lines),this):void 0;{let s;if(this.checkEdits){let p=this.getText(0,this.root.charCount());s=p.slice(0,t)+i+p.slice(t+n)}let o=new Rqe,l=!1;if(t>=this.root.charCount()){t=this.root.charCount()-1;let p=this.getText(t,1);i?i=p+i:i=p,n=0,l=!0}else if(n>0){let p=t+n,{zeroBasedColumn:m,lineText:S}=this.positionToColumnAndLineText(p);m===0&&(n+=S.length,i=i?i+S:S)}if(this.root.walk(t,n,o),o.insertLines(i,l),this.checkEdits){let p=o.lineIndex.getText(0,o.lineIndex.getLength());I.assert(s===p,"buffer edit mismatch")}return o.lineIndex}}static buildTreeFromBottom(t){if(t.length<wk)return new Ok(t);let n=new Array(Math.ceil(t.length/wk)),i=0;for(let s=0;s<n.length;s++){let o=Math.min(i+wk,t.length);n[s]=new Ok(t.slice(i,o)),i=o}return this.buildTreeFromBottom(n)}static linesFromText(t){let n=mA(t);if(n.length===0)return{lines:[],lineMap:n};let i=new Array(n.length),s=n.length-1;for(let l=0;l<s;l++)i[l]=t.substring(n[l],n[l+1]);let o=t.substring(n[s]);return o.length>0?i[s]=o:i.pop(),{lines:i,lineMap:n}}},Ok=class C6e{constructor(t=[]){this.children=t,this.totalChars=0,this.totalLines=0,t.length&&this.updateCounts()}isLeaf(){return!1}updateCounts(){this.totalChars=0,this.totalLines=0;for(let t of this.children)this.totalChars+=t.charCount(),this.totalLines+=t.lineCount()}execWalk(t,n,i,s,o){return i.pre&&i.pre(t,n,this.children[s],this,o),i.goSubtree?(this.children[s].walk(t,n,i),i.post&&i.post(t,n,this.children[s],this,o)):i.goSubtree=!0,i.done}skipChild(t,n,i,s,o){s.pre&&!s.done&&(s.pre(t,n,this.children[i],this,o),s.goSubtree=!0)}walk(t,n,i){let s=0,o=this.children[s].charCount(),l=t;for(;l>=o;)this.skipChild(l,n,s,i,0),l-=o,s++,o=this.children[s].charCount();if(l+n<=o){if(this.execWalk(l,n,i,s,2))return}else{if(this.execWalk(l,o-l,i,s,1))return;let p=n-(o-l);for(s++,o=this.children[s].charCount();p>o;){if(this.execWalk(0,o,i,s,3))return;p-=o,s++,o=this.children[s].charCount()}if(p>0&&this.execWalk(0,p,i,s,4))return}if(i.pre){let p=this.children.length;if(s<p-1)for(let m=s+1;m<p;m++)this.skipChild(0,0,m,i,5)}}charOffsetToLineInfo(t,n){if(this.children.length===0)return{oneBasedLine:t,zeroBasedColumn:n,lineText:void 0};for(let o of this.children){if(o.charCount()>n)return o.isLeaf()?{oneBasedLine:t,zeroBasedColumn:n,lineText:o.text}:o.charOffsetToLineInfo(t,n);n-=o.charCount(),t+=o.lineCount()}let i=this.lineCount();if(i===0)return{oneBasedLine:1,zeroBasedColumn:0,lineText:void 0};let s=I.checkDefined(this.lineNumberToInfo(i,0).leaf);return{oneBasedLine:i,zeroBasedColumn:s.charCount(),lineText:void 0}}lineNumberToInfo(t,n){for(let i of this.children){let s=i.lineCount();if(s>=t)return i.isLeaf()?{position:n,leaf:i}:i.lineNumberToInfo(t,n);t-=s,n+=i.charCount()}return{position:n,leaf:void 0}}splitAfter(t){let n,i=this.children.length;t++;let s=t;if(t<i){for(n=new C6e;t<i;)n.add(this.children[t]),t++;n.updateCounts()}return this.children.length=s,n}remove(t){let n=this.findChildIndex(t),i=this.children.length;if(n<i-1)for(let s=n;s<i-1;s++)this.children[s]=this.children[s+1];this.children.pop()}findChildIndex(t){let n=this.children.indexOf(t);return I.assert(n!==-1),n}insertAt(t,n){let i=this.findChildIndex(t),s=this.children.length,o=n.length;if(s<wk&&i===s-1&&o===1)return this.add(n[0]),this.updateCounts(),[];{let l=this.splitAfter(i),p=0;for(i++;i<wk&&p<o;)this.children[i]=n[p],i++,p++;let m=[],S=0;if(p<o){S=Math.ceil((o-p)/wk),m=new Array(S);let h=0;for(let A=0;A<S;A++)m[A]=new C6e;let b=m[0];for(;p<o;)b.add(n[p]),p++,b.children.length===wk&&(h++,b=m[h]);for(let A=m.length-1;A>=0;A--)m[A].children.length===0&&m.pop()}l&&m.push(l),this.updateCounts();for(let h=0;h<S;h++)m[h].updateCounts();return m}}add(t){this.children.push(t),I.assert(this.children.length<=wk)}charCount(){return this.totalChars}lineCount(){return this.totalLines}},cL=class{constructor(e){this.text=e}isLeaf(){return!0}walk(e,t,n){n.leaf(e,t,this)}charCount(){return this.text.length}lineCount(){return 1}}}}),K2e,Q2e,R8t=f({"src/server/typingInstallerAdapter.ts"(){"use strict";uS(),Mx(),K2e=class Hdt{constructor(t,n,i,s,o,l){this.telemetryEnabled=t,this.logger=n,this.host=i,this.globalTypingsCacheLocation=s,this.event=o,this.maxActiveRequestCount=l,this.activeRequestCount=0,this.requestQueue=Pu(),this.requestMap=new Map,this.requestedRegistry=!1,this.packageInstallId=0}isKnownTypesPackageName(t){var n;return sh.validatePackageName(t)!==sh.NameValidationResult.Ok?!1:(this.requestedRegistry||(this.requestedRegistry=!0,this.installer.send({kind:"typesRegistry"})),!!((n=this.typesRegistryCache)!=null&&n.has(t)))}installPackage(t){this.packageInstallId++;let n={kind:"installPackage",...t,id:this.packageInstallId},i=new Promise((s,o)=>{(this.packageInstalledPromise??(this.packageInstalledPromise=new Map)).set(this.packageInstallId,{resolve:s,reject:o})});return this.installer.send(n),i}attach(t){this.projectService=t,this.installer=this.createInstallerProcess()}onProjectClosed(t){this.installer.send({projectName:t.getProjectName(),kind:"closeProject"})}enqueueInstallTypingsRequest(t,n,i){let s=n2e(t,n,i);this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Scheduling throttled operation:${LT(s)}`),this.activeRequestCount<this.maxActiveRequestCount?this.scheduleRequest(s):(this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Deferring request for: ${s.projectName}`),this.requestQueue.enqueue(s),this.requestMap.set(s.projectName,s))}handleMessage(t){var n,i;switch(this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Received response:${LT(t)}`),t.kind){case $V:this.typesRegistryCache=new Map(Object.entries(t.typesRegistry));break;case VM:{let s=(n=this.packageInstalledPromise)==null?void 0:n.get(t.id);I.assertIsDefined(s,"Should find the promise for package install"),(i=this.packageInstalledPromise)==null||i.delete(t.id),t.success?s.resolve({successMessage:t.message}):s.reject(t.message),this.projectService.updateTypingsForProject(t),this.event(t,"setTypings");break}case Dee:{let s={message:t.message};this.event(s,"typesInstallerInitializationFailed");break}case WV:{let s={eventId:t.eventId,packages:t.packagesToInstall};this.event(s,"beginInstallTypes");break}case GV:{if(this.telemetryEnabled){let l={telemetryEventName:"typingsInstalled",payload:{installedPackages:t.packagesToInstall.join(","),installSuccess:t.installSuccess,typingsInstallerVersion:t.typingsInstallerVersion}};this.event(l,"telemetry")}let s={eventId:t.eventId,packages:t.packagesToInstall,success:t.installSuccess};this.event(s,"endInstallTypes");break}case UM:{this.projectService.updateTypingsForProject(t);break}case BM:{for(this.activeRequestCount>0?this.activeRequestCount--:I.fail("TIAdapter:: Received too many responses");!this.requestQueue.isEmpty();){let s=this.requestQueue.dequeue();if(this.requestMap.get(s.projectName)===s){this.requestMap.delete(s.projectName),this.scheduleRequest(s);break}this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Skipping defunct request for: ${s.projectName}`)}this.projectService.updateTypingsForProject(t),this.event(t,"setTypings");break}case TO:this.projectService.watchTypingLocations(t);break;default:}}scheduleRequest(t){this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Scheduling request for: ${t.projectName}`),this.activeRequestCount++,this.host.setTimeout(()=>{this.logger.hasLevel(3)&&this.logger.info(`TIAdapter:: Sending request:${LT(t)}`),this.installer.send(t)},Hdt.requestDelayMillis,`${t.projectName}::${t.kind}`)}},K2e.requestDelayMillis=100,Q2e=K2e}}),Lqe={};x(Lqe,{ActionInvalidate:()=>UM,ActionPackageInstalled:()=>VM,ActionSet:()=>BM,ActionWatchTypingLocations:()=>TO,Arguments:()=>Iee,AutoImportProviderProject:()=>kse,AuxiliaryProject:()=>Cse,CharRangeSection:()=>Use,CloseFileWatcherEvent:()=>sz,CommandNames:()=>G2e,ConfigFileDiagEvent:()=>ez,ConfiguredProject:()=>Pse,CreateDirectoryWatcherEvent:()=>iz,CreateFileWatcherEvent:()=>nz,Errors:()=>G1,EventBeginInstallTypes:()=>WV,EventEndInstallTypes:()=>GV,EventInitializationFailed:()=>Dee,EventTypesRegistry:()=>$V,ExternalProject:()=>Gq,GcTimer:()=>yse,InferredProject:()=>xse,LargeFileReferencedEvent:()=>Zq,LineIndex:()=>YO,LineLeaf:()=>cL,LineNode:()=>Ok,LogLevel:()=>dse,Msg:()=>mse,OpenFileInfoTelemetryEvent:()=>wse,Project:()=>Rx,ProjectInfoTelemetryEvent:()=>rz,ProjectKind:()=>GO,ProjectLanguageServiceStateEvent:()=>tz,ProjectLoadingFinishEvent:()=>Qq,ProjectLoadingStartEvent:()=>Kq,ProjectReferenceProjectLoadKind:()=>Mse,ProjectService:()=>Lse,ProjectsUpdatedInBackgroundEvent:()=>sL,ScriptInfo:()=>Tse,ScriptVersionCache:()=>lz,Session:()=>Y2e,TextStorage:()=>Sse,ThrottledOperations:()=>hse,TypingsCache:()=>bse,TypingsInstallerAdapter:()=>Q2e,allFilesAreJsOrDts:()=>C2e,allRootFilesAreJsOrDts:()=>x2e,asNormalizedPath:()=>_qe,convertCompilerOptions:()=>Hq,convertFormatOptions:()=>WD,convertScriptKindName:()=>Dse,convertTypeAcquisition:()=>P2e,convertUserPreferences:()=>N2e,convertWatchOptions:()=>iL,countEachFileTypes:()=>rL,createInstallTypingsRequest:()=>n2e,createModuleSpecifierCache:()=>B2e,createNormalizedPathMap:()=>fqe,createPackageJsonCache:()=>U2e,createSortedArray:()=>c2e,emptyArray:()=>Vl,findArgument:()=>Z7e,forEachResolvedProjectReferenceProject:()=>GD,formatDiagnosticToProtocol:()=>oL,formatMessage:()=>V2e,getBaseConfigFileName:()=>gse,getLocationInNewDocument:()=>$2e,hasArgument:()=>Q7e,hasNoTypeScriptSource:()=>A2e,indent:()=>SO,isBackgroundProject:()=>nL,isConfigFile:()=>M2e,isConfiguredProject:()=>JT,isDynamicFileName:()=>tL,isExternalProject:()=>Ese,isInferredProject:()=>$D,isInferredProjectName:()=>i2e,makeAutoImportProviderProjectName:()=>a2e,makeAuxiliaryProjectName:()=>o2e,makeInferredProjectName:()=>s2e,maxFileSize:()=>Xq,maxProgramSizeForNonTsFiles:()=>Yq,normalizedPathToPath:()=>eL,nowString:()=>eLe,nullCancellationToken:()=>W2e,nullTypingsInstaller:()=>Wq,projectContainsInfoDirectly:()=>Ik,protocol:()=>E2e,removeSorted:()=>pqe,stringifyIndented:()=>LT,toEvent:()=>J2e,toNormalizedPath:()=>Cc,tryConvertScriptKindName:()=>Nse,typingsInstaller:()=>t2e,updateProjectIfDirty:()=>qp});var Mx=f({"src/server/_namespaces/ts.server.ts"(){"use strict";HV(),r2e(),G3t(),H3t(),Y3t(),X3t(),Z3t(),n8t(),o8t(),f8t(),p8t(),d8t(),w8t(),O8t(),R8t()}}),Fqe={};x(Fqe,{ANONYMOUS:()=>jJ,AccessFlags:()=>sH,AssertionLevel:()=>DG,AssignmentDeclarationKind:()=>dH,AssignmentKind:()=>rK,Associativity:()=>iK,BreakpointResolver:()=>nne,BuilderFileEmit:()=>oee,BuilderProgramKind:()=>cee,BuilderState:()=>zm,BundleFileSectionKind:()=>wH,CallHierarchy:()=>Ek,CharacterCodes:()=>CH,CheckFlags:()=>eH,CheckMode:()=>KU,ClassificationType:()=>Xee,ClassificationTypeNames:()=>Yee,CommentDirectiveType:()=>BG,Comparison:()=>ee,CompletionInfoFlags:()=>Jee,CompletionTriggerKind:()=>Fee,Completions:()=>Pk,ContainerFlags:()=>XQ,ContextFlags:()=>$G,Debug:()=>I,DiagnosticCategory:()=>I3,Diagnostics:()=>g,DocumentHighlights:()=>VJ,ElementFlags:()=>iH,EmitFlags:()=>o9,EmitHint:()=>NH,EmitOnly:()=>VG,EndOfLineState:()=>$ee,EnumKind:()=>ZG,ExitStatus:()=>JG,ExportKind:()=>ire,Extension:()=>AH,ExternalEmitHelpers:()=>PH,FileIncludeKind:()=>Q5,FilePreprocessingDiagnosticsKind:()=>UG,FileSystemEntryKind:()=>jH,FileWatcherEventKind:()=>FH,FindAllReferences:()=>Ko,FlattenLevel:()=>dZ,FlowFlags:()=>D3,ForegroundColorEscapeSequences:()=>ZZ,FunctionFlags:()=>nK,GeneratedIdentifierFlags:()=>K5,GetLiteralTextFlags:()=>ZX,GoToDefinition:()=>UD,HighlightSpanKind:()=>Bee,IdentifierNameMap:()=>fk,IdentifierNameMultiMap:()=>pZ,ImportKind:()=>nre,ImportsNotUsedAsValues:()=>SH,IndentStyle:()=>Uee,IndexFlags:()=>aH,IndexKind:()=>lH,InferenceFlags:()=>fH,InferencePriority:()=>_H,InlayHintKind:()=>jee,InlayHints:()=>Yie,InternalEmitFlags:()=>kH,InternalSymbolName:()=>tH,InvalidatedProjectKind:()=>Nee,JSDocParsingMode:()=>MH,JsDoc:()=>VT,JsTyping:()=>sh,JsxEmit:()=>vH,JsxFlags:()=>FG,JsxReferenceKind:()=>oH,LanguageServiceMode:()=>Ree,LanguageVariant:()=>EH,LexicalEnvironmentFlags:()=>IH,ListFormat:()=>OH,LogLevel:()=>wG,MemberOverrideStatus:()=>qG,ModifierFlags:()=>Y5,ModuleDetectionKind:()=>mH,ModuleInstanceState:()=>YQ,ModuleKind:()=>vw,ModuleResolutionKind:()=>JP,ModuleSpecifierEnding:()=>pK,NavigateTo:()=>vve,NavigationBar:()=>Nve,NewLineKind:()=>TH,NodeBuilderFlags:()=>WG,NodeCheckFlags:()=>rH,NodeFactoryFlags:()=>TK,NodeFlags:()=>H5,NodeResolutionFeatures:()=>WQ,ObjectFlags:()=>r9,OperationCanceledException:()=>VP,OperatorPrecedence:()=>sK,OrganizeImports:()=>$m,OrganizeImportsMode:()=>Lee,OuterExpressionKinds:()=>DH,OutliningElementsCollector:()=>Zie,OutliningSpanKind:()=>qee,OutputFileType:()=>zee,PackageJsonAutoImportPreference:()=>Oee,PackageJsonDependencyGroup:()=>wee,PatternMatchKind:()=>JJ,PollingInterval:()=>c9,PollingWatchKind:()=>yH,PragmaKindFlags:()=>RH,PrivateIdentifierKind:()=>PK,ProcessLevel:()=>yZ,ProgramUpdateLevel:()=>RZ,QuotePreference:()=>Kte,RelationComparisonResult:()=>X5,Rename:()=>Bq,ScriptElementKind:()=>Gee,ScriptElementKindModifier:()=>Hee,ScriptKind:()=>i9,ScriptSnapshot:()=>XV,ScriptTarget:()=>bH,SemanticClassificationFormat:()=>Mee,SemanticMeaning:()=>Xte,SemicolonPreference:()=>Vee,SignatureCheckMode:()=>QU,SignatureFlags:()=>n9,SignatureHelp:()=>W7,SignatureKind:()=>cH,SmartSelectionRange:()=>rse,SnippetKind:()=>a9,SortKind:()=>NG,StructureIsReused:()=>Z5,SymbolAccessibility:()=>YG,SymbolDisplay:()=>W1,SymbolDisplayPartKind:()=>qM,SymbolFlags:()=>e9,SymbolFormatFlags:()=>HG,SyntaxKind:()=>G5,SyntheticSymbolKind:()=>XG,Ternary:()=>pH,ThrottledCancellationToken:()=>rne,TokenClass:()=>Wee,TokenFlags:()=>jG,TransformFlags:()=>s9,TypeFacts:()=>XU,TypeFlags:()=>t9,TypeFormatFlags:()=>GG,TypeMapKind:()=>uH,TypePredicateKind:()=>KG,TypeReferenceSerializationKind:()=>QG,UnionReduction:()=>zG,UpToDateStatusType:()=>Cee,VarianceFlags:()=>nH,Version:()=>Im,VersionRange:()=>k3,WatchDirectoryFlags:()=>xH,WatchDirectoryKind:()=>hH,WatchFileKind:()=>gH,WatchLogLevel:()=>MZ,WatchType:()=>_u,accessPrivateIdentifier:()=>g0e,addDisposableResourceHelper:()=>YB,addEmitFlags:()=>Kg,addEmitHelper:()=>VA,addEmitHelpers:()=>Ny,addInternalEmitFlags:()=>BA,addNodeFactoryPatcher:()=>T3e,addObjectAllocatorPatcher:()=>yme,addRange:()=>jt,addRelatedInfo:()=>Ga,addSyntheticLeadingComment:()=>w6,addSyntheticTrailingComment:()=>bB,addToSeen:()=>Bm,advancedAsyncSuperHelper:()=>DR,affectsDeclarationPathOptionDeclarations:()=>PQ,affectsEmitOptionDeclarations:()=>kQ,allKeysStartWithDot:()=>qU,altDirectorySeparator:()=>B3,and:()=>V5,append:()=>Pr,appendIfUnique:()=>ai,arrayFrom:()=>In,arrayIsEqualTo:()=>td,arrayIsHomogeneous:()=>jme,arrayIsSorted:()=>iA,arrayOf:()=>Xn,arrayReverseIterator:()=>Xl,arrayToMap:()=>il,arrayToMultiMap:()=>_l,arrayToNumericMap:()=>Rp,arraysEqual:()=>Am,assertType:()=>tOe,assign:()=>ec,assignHelper:()=>NB,asyncDelegator:()=>IB,asyncGeneratorHelper:()=>DB,asyncSuperHelper:()=>NR,asyncValues:()=>wB,attachFileToDiagnostics:()=>RA,awaitHelper:()=>JA,awaiterHelper:()=>RB,base64decode:()=>ome,base64encode:()=>ame,binarySearch:()=>Bg,binarySearchKey:()=>nT,bindSourceFile:()=>$he,breakIntoCharacterSpans:()=>fve,breakIntoWordSpans:()=>pve,buildLinkParts:()=>L1e,buildOpts:()=>wU,buildOverload:()=>sqe,bundlerModuleNameResolver:()=>Mhe,canBeConvertedToAsync:()=>mre,canHaveDecorators:()=>yx,canHaveExportModifier:()=>_R,canHaveFlowNode:()=>B8,canHaveIllegalDecorators:()=>nQ,canHaveIllegalModifiers:()=>Yge,canHaveIllegalType:()=>X3e,canHaveIllegalTypeParameters:()=>Hge,canHaveJSDoc:()=>U8,canHaveLocals:()=>Oh,canHaveModifiers:()=>Jm,canHaveSymbol:()=>qg,canJsonReportNoInputFiles:()=>K6,canProduceDiagnostics:()=>_V,canUsePropertyAccess:()=>YX,canWatchAffectingLocation:()=>Eye,canWatchAtTypes:()=>bye,canWatchDirectoryOrFile:()=>wV,cartesianProduct:()=>Efe,cast:()=>ta,chainBundle:()=>qm,chainDiagnosticMessages:()=>Xs,changeAnyExtension:()=>F3,changeCompilerHostLikeToUseCache:()=>IM,changeExtension:()=>bT,changeFullExtension:()=>Jfe,changesAffectModuleResolution:()=>j9,changesAffectingProgramStructure:()=>zpe,childIsDecorated:()=>zw,classElementOrClassElementParameterIsDecorated:()=>JY,classHasClassThisAssignment:()=>mZ,classHasDeclaredOrExplicitlyAssignedName:()=>gZ,classHasExplicitlyAssignedName:()=>cV,classOrConstructorParameterIsDecorated:()=>k1,classPrivateFieldGetHelper:()=>WB,classPrivateFieldInHelper:()=>HB,classPrivateFieldSetHelper:()=>GB,classicNameResolver:()=>Vhe,classifier:()=>xSe,cleanExtendedConfigCache:()=>vV,clear:()=>ed,clearMap:()=>Wf,clearSharedExtendedConfigFileWatcher:()=>IZ,climbPastPropertyAccess:()=>QV,climbPastPropertyOrElementAccess:()=>l1e,clone:()=>q_,cloneCompilerOptions:()=>mte,closeFileWatcher:()=>ug,closeFileWatcherOf:()=>Od,codefix:()=>x_,collapseTextChangeRangesAcrossMultipleVersions:()=>rpe,collectExternalModuleInfo:()=>lZ,combine:()=>Cv,combinePaths:()=>li,commentPragmas:()=>w3,commonOptionsWithBuild:()=>aM,commonPackageFolders:()=>cK,compact:()=>y1,compareBooleans:()=>hy,compareDataObjects:()=>wX,compareDiagnostics:()=>p6,compareDiagnosticsSkipRelatedInformation:()=>qj,compareEmitHelpers:()=>dge,compareNumberOfDirectorySeparators:()=>cR,comparePaths:()=>yy,comparePathsCaseInsensitive:()=>POe,comparePathsCaseSensitive:()=>kOe,comparePatternKeys:()=>zQ,compareProperties:()=>j5,compareStringsCaseInsensitive:()=>D2,compareStringsCaseInsensitiveEslintCompatible:()=>I2,compareStringsCaseSensitive:()=>h_,compareStringsCaseSensitiveUI:()=>LP,compareTextSpans:()=>iT,compareValues:()=>To,compileOnSaveCommandLineOption:()=>iM,compilerOptionsAffectDeclarationPath:()=>Pme,compilerOptionsAffectEmit:()=>kme,compilerOptionsAffectSemanticDiagnostics:()=>Ame,compilerOptionsDidYouMeanDiagnostics:()=>lM,compilerOptionsIndicateEsModules:()=>Tte,compose:()=>F5,computeCommonSourceDirectoryOfFilenames:()=>tye,computeLineAndCharacterOfPosition:()=>zP,computeLineOfPosition:()=>Ew,computeLineStarts:()=>mA,computePositionOfLineAndCharacter:()=>m9,computeSignature:()=>xx,computeSignatureWithDiagnostics:()=>nee,computeSuggestionDiagnostics:()=>fre,computedOptions:()=>Bl,concatenate:()=>ys,concatenateDiagnosticMessageChains:()=>bme,consumesNodeCoreModules:()=>IJ,contains:()=>hs,containsIgnoredPath:()=>b6,containsObjectRestOrSpread:()=>YR,containsParseError:()=>rN,containsPath:()=>wm,convertCompilerOptionsForTelemetry:()=>yhe,convertCompilerOptionsFromJson:()=>Z8e,convertJsonOption:()=>vx,convertToBase64:()=>sme,convertToJson:()=>tM,convertToObject:()=>phe,convertToOptionsWithAbsolutePaths:()=>TQ,convertToRelativePath:()=>bw,convertToTSConfig:()=>B8e,convertTypeAcquisitionFromJson:()=>eRe,copyComments:()=>Px,copyEntries:()=>B9,copyLeadingComments:()=>kD,copyProperties:()=>uf,copyTrailingAsLeadingComments:()=>l7,copyTrailingComments:()=>DO,couldStartTrivia:()=>Wfe,countWhere:()=>mu,createAbstractBuilder:()=>a7e,createAccessorPropertyBackingField:()=>sQ,createAccessorPropertyGetRedirector:()=>nhe,createAccessorPropertySetRedirector:()=>ihe,createBaseNodeFactory:()=>Qme,createBinaryExpressionTrampoline:()=>SU,createBindingHelper:()=>UN,createBuildInfo:()=>AM,createBuilderProgram:()=>iee,createBuilderProgramUsingProgramBuildInfo:()=>Sye,createBuilderStatusReporter:()=>Fye,createCacheWithRedirects:()=>LQ,createCacheableExportInfoMap:()=>ere,createCachedDirectoryStructureHost:()=>hV,createClassNamedEvaluationHelperBlock:()=>b0e,createClassThisAssignmentBlock:()=>S0e,createClassifier:()=>ELe,createCommentDirectivesMap:()=>Xpe,createCompilerDiagnostic:()=>fl,createCompilerDiagnosticForInvalidCustomType:()=>che,createCompilerDiagnosticFromMessageChain:()=>Jj,createCompilerHost:()=>rye,createCompilerHostFromProgramHost:()=>Tee,createCompilerHostWorker:()=>jZ,createDetachedDiagnostic:()=>wN,createDiagnosticCollection:()=>EN,createDiagnosticForFileFromMessageChain:()=>FY,createDiagnosticForNode:()=>$n,createDiagnosticForNodeArray:()=>sN,createDiagnosticForNodeArrayFromMessageChain:()=>y8,createDiagnosticForNodeFromMessageChain:()=>Ey,createDiagnosticForNodeInSourceFile:()=>im,createDiagnosticForRange:()=>cde,createDiagnosticMessageChainFromDiagnostic:()=>ode,createDiagnosticReporter:()=>LM,createDocumentPositionMapper:()=>u0e,createDocumentRegistry:()=>tve,createDocumentRegistryInternal:()=>ore,createEmitAndSemanticDiagnosticsBuilderProgram:()=>lee,createEmitHelperFactory:()=>pge,createEmptyExports:()=>VR,createExpressionForJsxElement:()=>Vge,createExpressionForJsxFragment:()=>Jge,createExpressionForObjectLiteralElementLike:()=>qge,createExpressionForPropertyName:()=>KK,createExpressionFromEntityName:()=>JR,createExternalHelpersImportDeclarationIfNeeded:()=>eQ,createFileDiagnostic:()=>Iu,createFileDiagnosticFromMessageChain:()=>H9,createForOfBindingStatement:()=>XK,createGetCanonicalFileName:()=>y_,createGetSourceFile:()=>LZ,createGetSymbolAccessibilityDiagnosticForNode:()=>j1,createGetSymbolAccessibilityDiagnosticForNodeName:()=>W0e,createGetSymbolWalker:()=>Whe,createIncrementalCompilerHost:()=>Eee,createIncrementalProgram:()=>Mye,createInputFiles:()=>E3e,createInputFilesWithFilePaths:()=>vK,createInputFilesWithFileTexts:()=>SK,createJsxFactoryExpression:()=>YK,createLanguageService:()=>ySe,createLanguageServiceSourceFile:()=>fq,createMemberAccessForPropertyName:()=>hx,createModeAwareCache:()=>uk,createModeAwareCacheKey:()=>rO,createModuleNotFoundChain:()=>U9,createModuleResolutionCache:()=>sD,createModuleResolutionLoader:()=>zZ,createModuleResolutionLoaderUsingGlobalCache:()=>kye,createModuleSpecifierResolutionHost:()=>kx,createMultiMap:()=>g_,createNodeConverters:()=>ege,createNodeFactory:()=>TR,createOptionNameMap:()=>EU,createOverload:()=>fse,createPackageJsonImportFilter:()=>OO,createPackageJsonInfo:()=>Jte,createParenthesizerRules:()=>Zme,createPatternMatcher:()=>ave,createPrependNodes:()=>KZ,createPrinter:()=>RT,createPrinterWithDefaults:()=>NZ,createPrinterWithRemoveComments:()=>EE,createPrinterWithRemoveCommentsNeverAsciiEscape:()=>DZ,createPrinterWithRemoveCommentsOmitTrailingSemicolon:()=>kM,createProgram:()=>xV,createProgramHost:()=>bee,createPropertyNameNodeForIdentifierOrLiteral:()=>aB,createQueue:()=>Pu,createRange:()=>kd,createRedirectedBuilderProgram:()=>aee,createResolutionCache:()=>_ee,createRuntimeTypeSerializer:()=>k0e,createScanner:()=>E1,createSemanticDiagnosticsBuilderProgram:()=>s7e,createSet:()=>Ug,createSolutionBuilder:()=>b7e,createSolutionBuilderHost:()=>S7e,createSolutionBuilderWithWatch:()=>E7e,createSolutionBuilderWithWatchHost:()=>T7e,createSortedArray:()=>h1,createSourceFile:()=>KR,createSourceMapGenerator:()=>a0e,createSourceMapSource:()=>x3e,createSuperAccessVariableStatement:()=>uV,createSymbolTable:()=>ga,createSymlinkCache:()=>BX,createSystemWatchFunctions:()=>jfe,createTextChange:()=>e7,createTextChangeFromStartLength:()=>fJ,createTextChangeRange:()=>Y3,createTextRangeFromNode:()=>yte,createTextRangeFromSpan:()=>_J,createTextSpan:()=>e_,createTextSpanFromBounds:()=>Ll,createTextSpanFromNode:()=>gf,createTextSpanFromRange:()=>aS,createTextSpanFromStringLiteralLikeContent:()=>hte,createTextWriter:()=>Q8,createTokenRange:()=>NX,createTypeChecker:()=>e0e,createTypeReferenceDirectiveResolutionCache:()=>UU,createTypeReferenceResolutionLoader:()=>TV,createUnparsedSourceFile:()=>yK,createWatchCompilerHost:()=>h7e,createWatchCompilerHostOfConfigFile:()=>wye,createWatchCompilerHostOfFilesAndCompilerOptions:()=>Oye,createWatchFactory:()=>See,createWatchHost:()=>vee,createWatchProgram:()=>y7e,createWatchStatusReporter:()=>Pye,createWriteFileMeasuringIO:()=>FZ,declarationNameToString:()=>qo,decodeMappings:()=>aZ,decodedTextSpanIntersectsWith:()=>H3,decorateHelper:()=>xB,deduplicate:()=>Dh,defaultIncludeSpec:()=>MU,defaultInitCompilerOptions:()=>OU,defaultMaximumTruncationLength:()=>mR,detectSortCaseSensitivity:()=>Mb,diagnosticCategoryName:()=>R2,diagnosticToString:()=>Dx,directoryProbablyExists:()=>lg,directorySeparator:()=>hc,displayPart:()=>Yf,displayPartsToString:()=>D7,disposeEmitNodes:()=>bK,disposeResourcesHelper:()=>XB,documentSpansEqual:()=>Ate,dumpTracingLegend:()=>Mfe,elementAt:()=>T1,elideNodes:()=>rhe,emitComments:()=>Hde,emitDetachedComments:()=>Yde,emitFiles:()=>dV,emitFilesAndReportErrors:()=>LV,emitFilesAndReportErrorsAndGetExitStatus:()=>Iye,emitModuleKindIsNonNodeESM:()=>zj,emitNewLineBeforeLeadingCommentOfPosition:()=>Gde,emitNewLineBeforeLeadingComments:()=>$de,emitNewLineBeforeLeadingCommentsOfPosition:()=>Wde,emitSkippedWithNoDiagnostics:()=>NV,emitUsingBuildInfo:()=>K0e,emptyArray:()=>tt,emptyFileSystemEntries:()=>yB,emptyMap:()=>$5,emptyOptions:()=>Md,emptySet:()=>Cfe,endsWith:()=>Mc,ensurePathIsNonModuleName:()=>Lb,ensureScriptKind:()=>Zj,ensureTrailingDirectorySeparator:()=>hu,entityNameToString:()=>cp,enumerateInsertsAndDeletes:()=>q5,equalOwnProperties:()=>Kl,equateStringsCaseInsensitive:()=>S1,equateStringsCaseSensitive:()=>Av,equateValues:()=>Dm,esDecorateHelper:()=>kB,escapeJsxAttributeString:()=>mX,escapeLeadingUnderscores:()=>Pc,escapeNonAsciiString:()=>K8,escapeSnippetText:()=>sE,escapeString:()=>D0,escapeTemplateSubstitution:()=>pX,every:()=>yr,expandPreOrPostfixIncrementOrDecrementExpression:()=>dU,explainFiles:()=>dee,explainIfFileIsRedirectAndImpliedFormat:()=>mee,exportAssignmentIsAlias:()=>vN,exportStarHelper:()=>$B,expressionResultIsUnused:()=>Ume,extend:()=>Ml,extendsHelper:()=>MB,extensionFromPath:()=>h6,extensionIsTS:()=>rB,extensionsNotSupportingExtensionlessResolution:()=>SR,externalHelpersModuleNameText:()=>Gv,factory:()=>j,fileExtensionIs:()=>Uc,fileExtensionIsOneOf:()=>Ql,fileIncludeReasonToDiagnostics:()=>yee,fileShouldUseJavaScriptRequire:()=>Yte,filter:()=>Fn,filterMutate:()=>Nh,filterSemanticDiagnostics:()=>CV,find:()=>mr,findAncestor:()=>Gr,findBestPatternMatch:()=>AG,findChildOfKind:()=>Oo,findComputedPropertyNameCacheAssignment:()=>TU,findConfigFile:()=>eye,findContainingList:()=>nJ,findDiagnosticForNode:()=>G1e,findFirstNonJsxWhitespaceToken:()=>d1e,findIndex:()=>oa,findLast:()=>Da,findLastIndex:()=>no,findListItemInfo:()=>p1e,findMap:()=>Cf,findModifier:()=>xD,findNextToken:()=>AE,findPackageJson:()=>$1e,findPackageJsons:()=>Vte,findPrecedingMatchingToken:()=>lJ,findPrecedingToken:()=>tu,findSuperStatementIndexPath:()=>sV,findTokenOnLeftOfPosition:()=>aJ,findUseStrictPrologue:()=>ZK,first:()=>di,firstDefined:()=>Ct,firstDefinedIterator:()=>Kt,firstIterator:()=>Ja,firstOrOnly:()=>Wte,firstOrUndefined:()=>qi,firstOrUndefinedIterator:()=>Oa,fixupCompilerOptions:()=>hre,flatMap:()=>_a,flatMapIterator:()=>A2,flatMapToMutable:()=>bv,flatten:()=>ip,flattenCommaList:()=>she,flattenDestructuringAssignment:()=>Tx,flattenDestructuringBinding:()=>bE,flattenDiagnosticMessageText:()=>nh,forEach:()=>Te,forEachAncestor:()=>$pe,forEachAncestorDirectory:()=>Rm,forEachChild:()=>Qs,forEachChildRecursively:()=>Y6,forEachEmittedFile:()=>CZ,forEachEnclosingBlockScopeContainer:()=>ide,forEachEntry:()=>yu,forEachExternalModuleToImportFrom:()=>rre,forEachImportClauseDeclaration:()=>hj,forEachKey:()=>Mh,forEachLeadingCommentRange:()=>q3,forEachNameInAccessChainWalkingLeft:()=>gme,forEachPropertyAssignment:()=>lN,forEachResolvedProjectReference:()=>WZ,forEachReturnStatement:()=>$b,forEachRight:()=>ut,forEachTrailingCommentRange:()=>z3,forEachTsConfigPropArray:()=>b8,forEachUnique:()=>Pte,forEachYieldExpression:()=>ude,forSomeAncestorDirectory:()=>W4e,formatColorAndReset:()=>xE,formatDiagnostic:()=>BZ,formatDiagnostics:()=>UMe,formatDiagnosticsWithColorAndContext:()=>nye,formatGeneratedName:()=>NT,formatGeneratedNamePart:()=>eD,formatLocation:()=>UZ,formatMessage:()=>LX,formatStringFromArgs:()=>O0,formatting:()=>fu,fullTripleSlashAMDReferencePathRegEx:()=>tK,fullTripleSlashReferencePathRegEx:()=>eK,generateDjb2Hash:()=>Sw,generateTSConfig:()=>z8e,generatorHelper:()=>JB,getAdjustedReferenceLocation:()=>lte,getAdjustedRenameLocation:()=>sJ,getAliasDeclarationFromName:()=>rX,getAllAccessorDeclarations:()=>tx,getAllDecoratorsOfClass:()=>_Z,getAllDecoratorsOfClassElement:()=>oV,getAllJSDocTags:()=>E9,getAllJSDocTagsOfKind:()=>n4e,getAllKeys:()=>Vr,getAllProjectOutputs:()=>pV,getAllSuperTypeNodes:()=>Yw,getAllUnscopedEmitHelpers:()=>kK,getAllowJSCompilerOption:()=>Hv,getAllowSyntheticDefaultImports:()=>ix,getAncestor:()=>ST,getAnyExtensionFromPath:()=>qP,getAreDeclarationMapsEnabled:()=>hR,getAssignedExpandoInitializer:()=>EA,getAssignedName:()=>T9,getAssignedNameOfIdentifier:()=>lO,getAssignmentDeclarationKind:()=>al,getAssignmentDeclarationPropertyAccessKind:()=>R8,getAssignmentTargetKind:()=>kA,getAutomaticTypeDirectiveNames:()=>jU,getBaseFileName:()=>Cl,getBinaryOperatorPrecedence:()=>X8,getBuildInfo:()=>mV,getBuildInfoFileVersionMap:()=>see,getBuildInfoText:()=>X0e,getBuildOrderFromAnyBuildOrder:()=>VV,getBuilderCreationParameters:()=>DV,getBuilderFileEmit:()=>sS,getCheckFlags:()=>Vc,getClassExtendsHeritageElement:()=>Xb,getClassLikeDeclarationOfSymbol:()=>ky,getCombinedLocalAndExportSymbolFlags:()=>NN,getCombinedModifierFlags:()=>lT,getCombinedNodeFlags:()=>x1,getCombinedNodeFlagsAlwaysIncludeJSDoc:()=>XH,getCommentRange:()=>Qg,getCommonSourceDirectory:()=>gO,getCommonSourceDirectoryOfConfig:()=>_D,getCompilerOptionValue:()=>Wj,getCompilerOptionsDiffValue:()=>J8e,getConditions:()=>nS,getConfigFileParsingDiagnostics:()=>Ex,getConstantValue:()=>age,getContainerFlags:()=>HQ,getContainerNode:()=>Ax,getContainingClass:()=>Vu,getContainingClassExcludingClassDecorators:()=>nj,getContainingClassStaticBlock:()=>vde,getContainingFunction:()=>Vp,getContainingFunctionDeclaration:()=>yde,getContainingFunctionOrClassStaticBlock:()=>rj,getContainingNodeArray:()=>Vme,getContainingObjectLiteralElement:()=>I7,getContextualTypeFromParent:()=>EJ,getContextualTypeFromParentOrAncestorTypeNode:()=>iJ,getCurrentTime:()=>jM,getDeclarationDiagnostics:()=>G0e,getDeclarationEmitExtensionForPath:()=>Aj,getDeclarationEmitOutputFilePath:()=>Ude,getDeclarationEmitOutputFilePathWorker:()=>Cj,getDeclarationFileExtension:()=>lQ,getDeclarationFromName:()=>Hw,getDeclarationModifierFlagsFromSymbol:()=>Nd,getDeclarationOfKind:()=>xc,getDeclarationsOfKind:()=>Jpe,getDeclaredExpandoInitializer:()=>D8,getDecorators:()=>wv,getDefaultCompilerOptions:()=>_q,getDefaultExportInfoWorker:()=>UJ,getDefaultFormatCodeSettings:()=>YV,getDefaultLibFileName:()=>W3,getDefaultLibFilePath:()=>vSe,getDefaultLikeExportInfo:()=>BJ,getDiagnosticText:()=>w8e,getDiagnosticsWithinSpan:()=>H1e,getDirectoryPath:()=>hi,getDirectoryToWatchFailedLookupLocation:()=>uee,getDirectoryToWatchFailedLookupLocationFromTypeRoot:()=>Cye,getDocumentPositionMapper:()=>_re,getDocumentSpansEqualityComparer:()=>kte,getESModuleInterop:()=>Bh,getEditsForFileRename:()=>nve,getEffectiveBaseTypeNode:()=>$g,getEffectiveConstraintOfTypeParameter:()=>YP,getEffectiveContainerForJSDocTemplateTag:()=>yj,getEffectiveImplementsTypeNodes:()=>SN,getEffectiveInitializer:()=>N8,getEffectiveJSDocHost:()=>vT,getEffectiveModifierFlags:()=>X_,getEffectiveModifierFlagsAlwaysIncludeJSDoc:()=>Zde,getEffectiveModifierFlagsNoCache:()=>eme,getEffectiveReturnTypeNode:()=>lm,getEffectiveSetAccessorTypeAnnotationNode:()=>zde,getEffectiveTypeAnnotationNode:()=>t_,getEffectiveTypeParameterDeclarations:()=>Ov,getEffectiveTypeRoots:()=>tO,getElementOrPropertyAccessArgumentExpressionOrName:()=>gj,getElementOrPropertyAccessName:()=>xy,getElementsOfBindingOrAssignmentPattern:()=>ZN,getEmitDeclarations:()=>Dd,getEmitFlags:()=>eo,getEmitHelpers:()=>EB,getEmitModuleDetectionKind:()=>aK,getEmitModuleKind:()=>T_,getEmitModuleResolutionKind:()=>Q_,getEmitScriptTarget:()=>ho,getEmitStandardClassFields:()=>Cme,getEnclosingBlockScopeContainer:()=>Lh,getEnclosingContainer:()=>LY,getEncodedSemanticClassifications:()=>sre,getEncodedSyntacticClassifications:()=>are,getEndLinePosition:()=>d8,getEntityNameFromTypeNode:()=>C8,getEntrypointsFromPackageJsonInfo:()=>VQ,getErrorCountForSummary:()=>RV,getErrorSpanForNode:()=>z2,getErrorSummaryText:()=>Nye,getEscapedTextOfIdentifierOrLiteral:()=>Qw,getEscapedTextOfJsxAttributeName:()=>A6,getEscapedTextOfJsxNamespacedName:()=>FA,getExpandoInitializer:()=>hT,getExportAssignmentExpression:()=>nX,getExportInfoMap:()=>d7,getExportNeedsImportStarHelper:()=>_0e,getExpressionAssociativity:()=>uX,getExpressionPrecedence:()=>e6,getExternalHelpersModuleName:()=>zR,getExternalModuleImportEqualsDeclarationExpression:()=>$w,getExternalModuleName:()=>mN,getExternalModuleNameFromDeclaration:()=>jde,getExternalModuleNameFromPath:()=>hX,getExternalModuleNameLiteral:()=>ak,getExternalModuleRequireArgument:()=>zY,getFallbackOptions:()=>DM,getFileEmitOutput:()=>uye,getFileMatcherPatterns:()=>Qj,getFileNamesFromConfigSpecs:()=>Q6,getFileWatcherEventKind:()=>LH,getFilesInErrorForSummary:()=>MV,getFirstConstructorWithBody:()=>I0,getFirstIdentifier:()=>Jp,getFirstNonSpaceCharacterPosition:()=>B1e,getFirstProjectOutput:()=>PZ,getFixableErrorSpanExpression:()=>zte,getFormatCodeSettingsForWriting:()=>MJ,getFullWidth:()=>f8,getFunctionFlags:()=>vu,getHeritageClause:()=>W8,getHostSignatureFromJSDoc:()=>yT,getIdentifierAutoGenerate:()=>N3e,getIdentifierGeneratedImportReference:()=>fge,getIdentifierTypeArguments:()=>sx,getImmediatelyInvokedFunctionExpression:()=>W2,getImpliedNodeFormatForFile:()=>RM,getImpliedNodeFormatForFileWorker:()=>YZ,getImportNeedsImportDefaultHelper:()=>cZ,getImportNeedsImportStarHelper:()=>nV,getIndentSize:()=>CN,getIndentString:()=>Ej,getInferredLibraryNameResolveFrom:()=>EV,getInitializedVariables:()=>u6,getInitializerOfBinaryExpression:()=>YY,getInitializerOfBindingOrAssignmentElement:()=>WR,getInterfaceBaseTypeNodes:()=>Xw,getInternalEmitFlags:()=>Lm,getInvokedExpression:()=>aj,getIsolatedModules:()=>fm,getJSDocAugmentsTag:()=>_pe,getJSDocClassTag:()=>QH,getJSDocCommentRanges:()=>BY,getJSDocCommentsAndTags:()=>KY,getJSDocDeprecatedTag:()=>ZH,getJSDocDeprecatedTagNoCache:()=>ype,getJSDocEnumTag:()=>eY,getJSDocHost:()=>X2,getJSDocImplementsTags:()=>fpe,getJSDocOverloadTags:()=>ZY,getJSDocOverrideTagNoCache:()=>hpe,getJSDocParameterTags:()=>HP,getJSDocParameterTagsNoCache:()=>ope,getJSDocPrivateTag:()=>QOe,getJSDocPrivateTagNoCache:()=>dpe,getJSDocProtectedTag:()=>ZOe,getJSDocProtectedTagNoCache:()=>mpe,getJSDocPublicTag:()=>KOe,getJSDocPublicTagNoCache:()=>ppe,getJSDocReadonlyTag:()=>e4e,getJSDocReadonlyTagNoCache:()=>gpe,getJSDocReturnTag:()=>vpe,getJSDocReturnType:()=>K3,getJSDocRoot:()=>yN,getJSDocSatisfiesExpressionType:()=>KX,getJSDocSatisfiesTag:()=>tY,getJSDocTags:()=>pT,getJSDocTagsNoCache:()=>r4e,getJSDocTemplateTag:()=>t4e,getJSDocThisTag:()=>b9,getJSDocType:()=>fT,getJSDocTypeAliasName:()=>rQ,getJSDocTypeAssertionType:()=>gU,getJSDocTypeParameterDeclarations:()=>Dj,getJSDocTypeParameterTags:()=>cpe,getJSDocTypeParameterTagsNoCache:()=>lpe,getJSDocTypeTag:()=>_T,getJSXImplicitImportBase:()=>Hj,getJSXRuntimeImport:()=>Yj,getJSXTransformEnabled:()=>Gj,getKeyForCompilerOptions:()=>MQ,getLanguageVariant:()=>sR,getLastChild:()=>OX,getLeadingCommentRanges:()=>T0,getLeadingCommentRangesOfNode:()=>jY,getLeftmostAccessExpression:()=>DN,getLeftmostExpression:()=>IN,getLibraryNameFromLibFileName:()=>GZ,getLineAndCharacterOfPosition:()=>Lo,getLineInfo:()=>iZ,getLineOfLocalPosition:()=>r6,getLineOfLocalPositionFromLineMap:()=>Z2,getLineStartPositionForPosition:()=>mm,getLineStarts:()=>vy,getLinesBetweenPositionAndNextNonWhitespaceCharacter:()=>fme,getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter:()=>_me,getLinesBetweenPositions:()=>xw,getLinesBetweenRangeEndAndRangeStart:()=>DX,getLinesBetweenRangeEndPositions:()=>z4e,getLiteralText:()=>Kpe,getLocalNameForExternalImport:()=>QN,getLocalSymbolForExportDefault:()=>PN,getLocaleSpecificMessage:()=>Gs,getLocaleTimeString:()=>FM,getMappedContextSpan:()=>Nte,getMappedDocumentSpan:()=>vJ,getMappedLocation:()=>kO,getMatchedFileSpec:()=>gee,getMatchedIncludeSpec:()=>hee,getMeaningFromDeclaration:()=>zM,getMeaningFromLocation:()=>Cx,getMembersOfDeclaration:()=>_de,getModeForFileReference:()=>wM,getModeForResolutionAtIndex:()=>iye,getModeForUsageLocation:()=>JZ,getModifiedTime:()=>fA,getModifiers:()=>jb,getModuleInstanceState:()=>Oy,getModuleNameStringLiteralAt:()=>MM,getModuleSpecifierEndingPreference:()=>wme,getModuleSpecifierResolverHost:()=>bte,getNameForExportedSymbol:()=>wJ,getNameFromImportAttribute:()=>uB,getNameFromIndexInfo:()=>sde,getNameFromPropertyName:()=>n7,getNameOfAccessExpression:()=>MX,getNameOfCompilerOptionValue:()=>SQ,getNameOfDeclaration:()=>qs,getNameOfExpando:()=>GY,getNameOfJSDocTypedef:()=>ape,getNameOrArgument:()=>O8,getNameTable:()=>Kre,getNamesForExportedSymbol:()=>Y1e,getNamespaceDeclarationNode:()=>gN,getNewLineCharacter:()=>w1,getNewLineKind:()=>p7,getNewLineOrDefaultFromHost:()=>q1,getNewTargetContainer:()=>Tde,getNextJSDocCommentLocation:()=>QY,getNodeForGeneratedName:()=>HR,getNodeId:()=>yo,getNodeKind:()=>CE,getNodeModifiers:()=>xO,getNodeModulePathParts:()=>oB,getNonAssignedNameOfDeclaration:()=>S9,getNonAssignmentOperatorForCompoundAssignment:()=>aO,getNonAugmentationDeclaration:()=>DY,getNonDecoratorTokenPosOfNode:()=>CY,getNormalizedAbsolutePath:()=>Ps,getNormalizedAbsolutePathWithoutRoot:()=>JH,getNormalizedPathComponents:()=>L3,getObjectFlags:()=>Gn,getOperator:()=>fX,getOperatorAssociativity:()=>_X,getOperatorPrecedence:()=>Y8,getOptionFromName:()=>gQ,getOptionsForLibraryResolution:()=>FQ,getOptionsNameMap:()=>rD,getOrCreateEmitNode:()=>b_,getOrCreateExternalHelpersModuleNameIfNeeded:()=>Gge,getOrUpdate:()=>km,getOriginalNode:()=>Hc,getOriginalNodeId:()=>E_,getOriginalSourceFile:()=>R4e,getOutputDeclarationFileName:()=>mO,getOutputDeclarationFileNameWorker:()=>AZ,getOutputExtension:()=>fV,getOutputFileNames:()=>jMe,getOutputJSFileNameWorker:()=>kZ,getOutputPathsFor:()=>dO,getOutputPathsForBundle:()=>pO,getOwnEmitOutputFilePath:()=>Bde,getOwnKeys:()=>Vt,getOwnValues:()=>Mn,getPackageJsonInfo:()=>yE,getPackageJsonTypesVersionsPaths:()=>FU,getPackageJsonsVisibleToFile:()=>W1e,getPackageNameFromTypesPackageName:()=>nO,getPackageScopeForPath:()=>dM,getParameterSymbolFromJSDoc:()=>V8,getParameterTypeNode:()=>t3e,getParentNodeInSpan:()=>s7,getParseTreeNode:()=>Us,getParsedCommandLineOfConfigFile:()=>ZR,getPathComponents:()=>gu,getPathComponentsRelativeTo:()=>zH,getPathFromPathComponents:()=>Nv,getPathUpdater:()=>lre,getPathsBasePath:()=>kj,getPatternFromSpec:()=>Nme,getPendingEmitKind:()=>gD,getPositionOfLineAndCharacter:()=>V3,getPossibleGenericSignatures:()=>_te,getPossibleOriginalInputExtensionForExtension:()=>Vde,getPossibleTypeArgumentsInfo:()=>fte,getPreEmitDiagnostics:()=>BMe,getPrecedingNonSpaceCharacterPosition:()=>TJ,getPrivateIdentifier:()=>fZ,getProperties:()=>uZ,getProperty:()=>Ar,getPropertyArrayElementValue:()=>hde,getPropertyAssignmentAliasLikeExpression:()=>Rde,getPropertyNameForPropertyNameNode:()=>K2,getPropertyNameForUniqueESSymbol:()=>w4e,getPropertyNameFromType:()=>_m,getPropertyNameOfBindingOrAssignmentElement:()=>tQ,getPropertySymbolFromBindingElement:()=>yJ,getPropertySymbolsFromContextualType:()=>pq,getQuoteFromPreference:()=>xte,getQuotePreference:()=>_d,getRangesWhere:()=>Ev,getRefactorContextSpan:()=>Sk,getReferencedFileLocation:()=>hO,getRegexFromPattern:()=>$v,getRegularExpressionForWildcard:()=>d6,getRegularExpressionsForWildcards:()=>Xj,getRelativePathFromDirectory:()=>Om,getRelativePathFromFile:()=>j3,getRelativePathToDirectoryOrUrl:()=>dA,getRenameLocation:()=>c7,getReplacementSpanForContextToken:()=>gte,getResolutionDiagnostic:()=>QZ,getResolutionModeOverride:()=>fD,getResolveJsonModule:()=>xT,getResolvePackageJsonExports:()=>mB,getResolvePackageJsonImports:()=>gB,getResolvedExternalModuleName:()=>xj,getRestIndicatorOfBindingOrAssignmentElement:()=>yU,getRestParameterElementType:()=>UY,getRightMostAssignedExpression:()=>I8,getRootDeclaration:()=>Gg,getRootDirectoryOfResolutionCache:()=>Aye,getRootLength:()=>wh,getRootPathSplitLength:()=>u7e,getScriptKind:()=>Rte,getScriptKindFromFileName:()=>eB,getScriptTargetFeatures:()=>pB,getSelectedEffectiveModifierFlags:()=>DA,getSelectedSyntacticModifierFlags:()=>Kde,getSemanticClassifications:()=>Z1e,getSemanticJsxChildren:()=>bN,getSetAccessorTypeAnnotationNode:()=>Jde,getSetAccessorValueParameter:()=>n6,getSetExternalModuleIndicator:()=>aR,getShebang:()=>h9,getSingleInitializerOfVariableStatementOrPropertyDeclaration:()=>XY,getSingleVariableOfVariableStatement:()=>AA,getSnapshotText:()=>ED,getSnippetElement:()=>EK,getSourceFileOfModule:()=>J9,getSourceFileOfNode:()=>Xr,getSourceFilePathInNewDir:()=>Pj,getSourceFilePathInNewDirWorker:()=>Nj,getSourceFileVersionAsHashFromText:()=>FV,getSourceFilesToEmit:()=>yX,getSourceMapRange:()=>R1,getSourceMapper:()=>mve,getSourceTextOfNodeFromSourceFile:()=>Jb,getSpanOfTokenAtPosition:()=>Fh,getSpellingSuggestion:()=>FP,getStartPositionOfLine:()=>Uv,getStartPositionOfRange:()=>l6,getStartsOnNewLine:()=>I6,getStaticPropertiesAndClassStaticBlock:()=>aV,getStrictOptionValue:()=>K_,getStringComparer:()=>gy,getSubPatternFromSpec:()=>Kj,getSuperCallFromStatement:()=>iV,getSuperContainer:()=>E8,getSupportedCodeFixes:()=>Yre,getSupportedExtensions:()=>m6,getSupportedExtensionsWithJsonIfResolveJsonModule:()=>oR,getSwitchedType:()=>Bte,getSymbolId:()=>Ia,getSymbolNameForPrivateIdentifier:()=>G8,getSymbolTarget:()=>Mte,getSyntacticClassifications:()=>eve,getSyntacticModifierFlags:()=>qv,getSyntacticModifierFlagsNoCache:()=>bX,getSynthesizedDeepClone:()=>Sc,getSynthesizedDeepCloneWithReplacements:()=>o7,getSynthesizedDeepClones:()=>kE,getSynthesizedDeepClonesWithReplacements:()=>Lte,getSyntheticLeadingComments:()=>BN,getSyntheticTrailingComments:()=>AR,getTargetLabel:()=>ZV,getTargetOfBindingOrAssignmentElement:()=>rS,getTemporaryModuleResolutionState:()=>pM,getTextOfConstantValue:()=>Qpe,getTextOfIdentifierOrLiteral:()=>om,getTextOfJSDocComment:()=>Z3,getTextOfJsxAttributeName:()=>dR,getTextOfJsxNamespacedName:()=>k6,getTextOfNode:()=>Fl,getTextOfNodeFromSourceText:()=>Bw,getTextOfPropertyName:()=>iN,getThisContainer:()=>kf,getThisParameter:()=>Qb,getTokenAtPosition:()=>Ts,getTokenPosOfNode:()=>mT,getTokenSourceMapRange:()=>k3e,getTouchingPropertyName:()=>If,getTouchingToken:()=>bD,getTrailingCommentRanges:()=>aT,getTrailingSemicolonDeferringWriter:()=>gX,getTransformFlagsSubtreeExclusions:()=>tge,getTransformers:()=>EZ,getTsBuildInfoEmitOutputFilePath:()=>B1,getTsConfigObjectLiteralExpression:()=>qw,getTsConfigPropArrayElementValue:()=>tj,getTypeAnnotationNode:()=>qde,getTypeArgumentOrTypeParameterList:()=>b1e,getTypeKeywordOfTypeOnlyImport:()=>Cte,getTypeNode:()=>uge,getTypeNodeIfAccessible:()=>wO,getTypeParameterFromJsDoc:()=>Pde,getTypeParameterOwner:()=>WOe,getTypesPackageName:()=>zU,getUILocale:()=>oA,getUniqueName:()=>Nx,getUniqueSymbolId:()=>j1e,getUseDefineForClassFields:()=>D6,getWatchErrorSummaryDiagnosticMessage:()=>fee,getWatchFactory:()=>OZ,group:()=>m_,groupBy:()=>Jf,guessIndentation:()=>Upe,handleNoEmitOptions:()=>XZ,hasAbstractModifier:()=>tE,hasAccessorModifier:()=>Hg,hasAmbientModifier:()=>TX,hasChangesInResolutions:()=>bY,hasChildOfKind:()=>KM,hasContextSensitiveParameters:()=>sB,hasDecorators:()=>Ad,hasDocComment:()=>S1e,hasDynamicName:()=>Jv,hasEffectiveModifier:()=>up,hasEffectiveModifiers:()=>Ij,hasEffectiveReadonlyModifier:()=>i6,hasExtension:()=>pA,hasIndexSignature:()=>jte,hasInitializer:()=>jv,hasInvalidEscape:()=>dX,hasJSDocNodes:()=>jp,hasJSDocParameterTags:()=>upe,hasJSFileExtension:()=>rE,hasJsonModuleEmitEnabled:()=>$j,hasOnlyExpressionInitializer:()=>V2,hasOverrideModifier:()=>wj,hasPossibleExternalModuleReference:()=>nde,hasProperty:()=>wo,hasPropertyAccessExpressionWithName:()=>WM,hasQuestionToken:()=>CA,hasRecordedExternalHelpers:()=>Wge,hasResolutionModeOverride:()=>Wme,hasRestParameter:()=>yY,hasScopeMarker:()=>wpe,hasStaticModifier:()=>jl,hasSyntacticModifier:()=>ui,hasSyntacticModifiers:()=>Xde,hasTSFileExtension:()=>LA,hasTabstop:()=>qme,hasTrailingDirectorySeparator:()=>b1,hasType:()=>L9,hasTypeArguments:()=>k4e,hasZeroOrOneAsteriskCharacter:()=>jX,helperString:()=>AK,hostGetCanonicalFileName:()=>N1,hostUsesCaseSensitiveFileNames:()=>AN,idText:()=>Nn,identifierIsThisKeyword:()=>SX,identifierToKeywordKind:()=>uT,identity:()=>Mo,identitySourceMapConsumer:()=>rV,ignoreSourceNewlines:()=>CK,ignoredPaths:()=>M3,importDefaultHelper:()=>zB,importFromModuleSpecifier:()=>Gw,importNameElisionDisabled:()=>FX,importStarHelper:()=>PR,indexOfAnyCharCode:()=>v0,indexOfNode:()=>nN,indicesOf:()=>tT,inferredTypesContainingFile:()=>mD,injectClassNamedEvaluationHelperBlockIfMissing:()=>lV,injectClassThisAssignmentIfMissing:()=>T0e,insertImports:()=>AO,insertLeadingStatement:()=>W3e,insertSorted:()=>lf,insertStatementAfterCustomPrologue:()=>J2,insertStatementAfterStandardPrologue:()=>h4e,insertStatementsAfterCustomPrologue:()=>EY,insertStatementsAfterStandardPrologue:()=>C0,intersperse:()=>zn,intrinsicTagNameToString:()=>QX,introducesArgumentsExoticObject:()=>mde,inverseJsxOptionMap:()=>Z6,isAbstractConstructorSymbol:()=>pme,isAbstractModifier:()=>Sge,isAccessExpression:()=>Yo,isAccessibilityModifier:()=>dte,isAccessor:()=>Mv,isAccessorModifier:()=>bge,isAliasSymbolDeclaration:()=>N4e,isAliasableExpression:()=>$8,isAmbientModule:()=>S_,isAmbientPropertyDeclaration:()=>wY,isAnonymousFunctionDefinition:()=>Zw,isAnyDirectorySeparator:()=>BH,isAnyImportOrBareOrAccessedRequire:()=>rde,isAnyImportOrReExport:()=>g8,isAnyImportSyntax:()=>q2,isAnySupportedFileExtension:()=>e3e,isApplicableVersionedTypesKey:()=>gM,isArgumentExpressionOfElementAccess:()=>nte,isArray:()=>os,isArrayBindingElement:()=>D9,isArrayBindingOrAssignmentElement:()=>a8,isArrayBindingOrAssignmentPattern:()=>fY,isArrayBindingPattern:()=>cE,isArrayLiteralExpression:()=>Z_,isArrayLiteralOrObjectLiteralDestructuringPattern:()=>V1,isArrayTypeNode:()=>MR,isArrowFunction:()=>rc,isAsExpression:()=>FR,isAssertClause:()=>Nge,isAssertEntry:()=>j3e,isAssertionExpression:()=>U2,isAssertsKeyword:()=>yge,isAssignmentDeclaration:()=>Ww,isAssignmentExpression:()=>lu,isAssignmentOperator:()=>D1,isAssignmentPattern:()=>Lw,isAssignmentTarget:()=>N0,isAsteriskToken:()=>IR,isAsyncFunction:()=>Kw,isAsyncModifier:()=>R6,isAutoAccessorPropertyDeclaration:()=>Af,isAwaitExpression:()=>Zv,isAwaitKeyword:()=>OK,isBigIntLiteral:()=>KB,isBinaryExpression:()=>bn,isBinaryOperatorToken:()=>the,isBindableObjectDefinePropertyCall:()=>H2,isBindableStaticAccessExpression:()=>Hb,isBindableStaticElementAccessExpression:()=>mj,isBindableStaticNameExpression:()=>Y2,isBindingElement:()=>co,isBindingElementOfBareOrAccessedRequire:()=>xde,isBindingName:()=>j2,isBindingOrAssignmentElement:()=>Ape,isBindingOrAssignmentPattern:()=>i8,isBindingPattern:()=>la,isBlock:()=>ra,isBlockOrCatchScoped:()=>AY,isBlockScope:()=>OY,isBlockScopedContainerTopLevel:()=>tde,isBooleanLiteral:()=>Mw,isBreakOrContinueStatement:()=>Iw,isBreakStatement:()=>M3e,isBuildInfoFile:()=>Y0e,isBuilderProgram:()=>Dye,isBundle:()=>UK,isBundleFileTextLike:()=>mme,isCallChain:()=>L2,isCallExpression:()=>da,isCallExpressionTarget:()=>Kee,isCallLikeExpression:()=>Vb,isCallLikeOrFunctionLikeExpression:()=>pY,isCallOrNewExpression:()=>Jg,isCallOrNewExpressionTarget:()=>Qee,isCallSignatureDeclaration:()=>HA,isCallToHelper:()=>O6,isCaseBlock:()=>V6,isCaseClause:()=>WN,isCaseKeyword:()=>Ege,isCaseOrDefaultClause:()=>R9,isCatchClause:()=>mE,isCatchClauseVariableDeclaration:()=>Jme,isCatchClauseVariableDeclarationOrBindingElement:()=>kY,isCheckJsEnabledForFile:()=>uR,isChildOfNodeWithKind:()=>v4e,isCircularBuildOrder:()=>mk,isClassDeclaration:()=>eu,isClassElement:()=>Du,isClassExpression:()=>wu,isClassInstanceProperty:()=>xpe,isClassLike:()=>Ti,isClassMemberModifier:()=>lY,isClassNamedEvaluationHelperBlock:()=>dk,isClassOrTypeElement:()=>N9,isClassStaticBlockDeclaration:()=>Jc,isClassThisAssignmentBlock:()=>cO,isCollapsedRange:()=>q4e,isColonToken:()=>gge,isCommaExpression:()=>qR,isCommaListExpression:()=>j6,isCommaSequence:()=>W6,isCommaToken:()=>mge,isComment:()=>uJ,isCommonJsExportPropertyAssignment:()=>Z9,isCommonJsExportedExpression:()=>pde,isCompoundAssignment:()=>sO,isComputedNonLiteralName:()=>h8,isComputedPropertyName:()=>uo,isConciseBody:()=>w9,isConditionalExpression:()=>$N,isConditionalTypeNode:()=>QA,isConstTypeReference:()=>Ty,isConstructSignatureDeclaration:()=>OR,isConstructorDeclaration:()=>Yc,isConstructorTypeNode:()=>VN,isContextualKeyword:()=>Sj,isContinueStatement:()=>R3e,isCustomPrologue:()=>T8,isDebuggerStatement:()=>L3e,isDeclaration:()=>O_,isDeclarationBindingElement:()=>n8,isDeclarationFileName:()=>i_,isDeclarationName:()=>Cy,isDeclarationNameOfEnumOrNamespace:()=>IX,isDeclarationReadonly:()=>Y9,isDeclarationStatement:()=>Lpe,isDeclarationWithTypeParameterChildren:()=>MY,isDeclarationWithTypeParameters:()=>RY,isDecorator:()=>n_,isDecoratorTarget:()=>o1e,isDefaultClause:()=>q6,isDefaultImport:()=>xA,isDefaultModifier:()=>tU,isDefaultedExpandoInitializer:()=>Cde,isDeleteExpression:()=>Age,isDeleteTarget:()=>tX,isDeprecatedDeclaration:()=>OJ,isDestructuringAssignment:()=>I1,isDiagnosticWithLocation:()=>qte,isDiskPathRoot:()=>UH,isDoStatement:()=>w3e,isDocumentRegistryEntry:()=>m7,isDotDotDotToken:()=>ZB,isDottedName:()=>a6,isDynamicName:()=>bj,isESSymbolIdentifier:()=>O4e,isEffectiveExternalModule:()=>bA,isEffectiveModuleDeclaration:()=>ede,isEffectiveStrictModeSourceFile:()=>IY,isElementAccessChain:()=>rY,isElementAccessExpression:()=>fc,isEmittedFileOfProgram:()=>Z0e,isEmptyArrayLiteral:()=>ime,isEmptyBindingElement:()=>ipe,isEmptyBindingPattern:()=>npe,isEmptyObjectLiteral:()=>kX,isEmptyStatement:()=>FK,isEmptyStringLiteral:()=>qY,isEntityName:()=>zf,isEntityNameExpression:()=>ol,isEnumConst:()=>zb,isEnumDeclaration:()=>AT,isEnumMember:()=>gE,isEqualityOperatorKind:()=>xJ,isEqualsGreaterThanToken:()=>hge,isExclamationToken:()=>wR,isExcludedFile:()=>mhe,isExclusivelyTypeOnlyImportOrExport:()=>VZ,isExpandoPropertyDeclaration:()=>lB,isExportAssignment:()=>Kc,isExportDeclaration:()=>yl,isExportModifier:()=>WA,isExportName:()=>mU,isExportNamespaceAsDefaultDeclaration:()=>$9,isExportOrDefaultModifier:()=>GR,isExportSpecifier:()=>R_,isExportsIdentifier:()=>G2,isExportsOrModuleExportsOrAlias:()=>vE,isExpression:()=>bt,isExpressionNode:()=>k0,isExpressionOfExternalModuleImportEqualsDeclaration:()=>_1e,isExpressionOfOptionalChainRoot:()=>A9,isExpressionStatement:()=>Ou,isExpressionWithTypeArguments:()=>L1,isExpressionWithTypeArgumentsInClassExtendsClause:()=>Oj,isExternalModule:()=>Pl,isExternalModuleAugmentation:()=>qb,isExternalModuleImportEqualsDeclaration:()=>gT,isExternalModuleIndicator:()=>o8,isExternalModuleNameRelative:()=>Nu,isExternalModuleReference:()=>zh,isExternalModuleSymbol:()=>t7,isExternalOrCommonJsModule:()=>Bp,isFileLevelReservedGeneratedIdentifier:()=>r8,isFileLevelUniqueName:()=>q9,isFileProbablyExternalModule:()=>XR,isFirstDeclarationOfSymbolParameter:()=>Dte,isFixablePromiseHandler:()=>dre,isForInOrOfStatement:()=>QP,isForInStatement:()=>oU,isForInitializer:()=>Cd,isForOfStatement:()=>jR,isForStatement:()=>_x,isFunctionBlock:()=>Wb,isFunctionBody:()=>mY,isFunctionDeclaration:()=>Zl,isFunctionExpression:()=>Xo,isFunctionExpressionOrArrowFunction:()=>iE,isFunctionLike:()=>ca,isFunctionLikeDeclaration:()=>tc,isFunctionLikeKind:()=>yA,isFunctionLikeOrClassStaticBlockDeclaration:()=>KP,isFunctionOrConstructorTypeNode:()=>Cpe,isFunctionOrModuleBlock:()=>uY,isFunctionSymbol:()=>kde,isFunctionTypeNode:()=>Vh,isFutureReservedKeyword:()=>D4e,isGeneratedIdentifier:()=>yc,isGeneratedPrivateIdentifier:()=>F2,isGetAccessor:()=>Fv,isGetAccessorDeclaration:()=>sd,isGetOrSetAccessorDeclaration:()=>x9,isGlobalDeclaration:()=>yLe,isGlobalScopeAugmentation:()=>zg,isGrammarError:()=>Ype,isHeritageClause:()=>ad,isHoistedFunction:()=>K9,isHoistedVariableStatement:()=>Q9,isIdentifier:()=>ze,isIdentifierANonContextualKeyword:()=>aX,isIdentifierName:()=>Ode,isIdentifierOrThisTypeNode:()=>Kge,isIdentifierPart:()=>oT,isIdentifierStart:()=>b0,isIdentifierText:()=>nd,isIdentifierTypePredicate:()=>gde,isIdentifierTypeReference:()=>Fme,isIfStatement:()=>ux,isIgnoredFileFromWildCardWatching:()=>NM,isImplicitGlob:()=>VX,isImportAttribute:()=>Dge,isImportAttributeName:()=>Epe,isImportAttributes:()=>tk,isImportCall:()=>Up,isImportClause:()=>Jh,isImportDeclaration:()=>uu,isImportEqualsDeclaration:()=>Ru,isImportKeyword:()=>L6,isImportMeta:()=>oN,isImportOrExportSpecifier:()=>hA,isImportOrExportSpecifierName:()=>F1e,isImportSpecifier:()=>Gf,isImportTypeAssertionContainer:()=>F3e,isImportTypeNode:()=>M0,isImportableFile:()=>tre,isInComment:()=>U1,isInCompoundLikeAssignment:()=>eX,isInExpressionContext:()=>cj,isInJSDoc:()=>k8,isInJSFile:()=>gn,isInJSXText:()=>y1e,isInJsonFile:()=>uj,isInNonReferenceComment:()=>C1e,isInReferenceComment:()=>x1e,isInRightSideOfInternalImportEqualsDeclaration:()=>KV,isInString:()=>hk,isInTemplateString:()=>ute,isInTopLevelContext:()=>ij,isInTypeQuery:()=>ex,isIncrementalCompilation:()=>N6,isIndexSignatureDeclaration:()=>oE,isIndexedAccessTypeNode:()=>lx,isInferTypeNode:()=>ax,isInfinityOrNaNString:()=>E6,isInitializedProperty:()=>bM,isInitializedVariable:()=>iR,isInsideJsxElement:()=>cJ,isInsideJsxElementOrAttribute:()=>h1e,isInsideNodeModules:()=>f7,isInsideTemplateLiteral:()=>ZM,isInstanceOfExpression:()=>Rj,isInstantiatedModule:()=>QQ,isInterfaceDeclaration:()=>ef,isInternalDeclaration:()=>vY,isInternalModuleImportEqualsDeclaration:()=>fN,isInternalName:()=>QK,isIntersectionTypeNode:()=>KA,isIntrinsicJsxName:()=>xN,isIterationStatement:()=>Lv,isJSDoc:()=>dg,isJSDocAllType:()=>Mge,isJSDocAugmentsTag:()=>sk,isJSDocAuthorTag:()=>J3e,isJSDocCallbackTag:()=>JK,isJSDocClassTag:()=>Fge,isJSDocCommentContainingNode:()=>M9,isJSDocConstructSignature:()=>hN,isJSDocDeprecatedTag:()=>GK,isJSDocEnumTag:()=>UR,isJSDocFunctionType:()=>HN,isJSDocImplementsTag:()=>fU,isJSDocIndexSignature:()=>_j,isJSDocLikeText:()=>oQ,isJSDocLink:()=>Oge,isJSDocLinkCode:()=>Rge,isJSDocLinkLike:()=>TA,isJSDocLinkPlain:()=>U3e,isJSDocMemberName:()=>kT,isJSDocNameReference:()=>z6,isJSDocNamepathType:()=>V3e,isJSDocNamespaceBody:()=>_4e,isJSDocNode:()=>ZP,isJSDocNonNullableType:()=>cU,isJSDocNullableType:()=>GN,isJSDocOptionalParameter:()=>pR,isJSDocOptionalType:()=>VK,isJSDocOverloadTag:()=>YN,isJSDocOverrideTag:()=>uU,isJSDocParameterTag:()=>mg,isJSDocPrivateTag:()=>zK,isJSDocPropertyLikeTag:()=>ww,isJSDocPropertyTag:()=>jge,isJSDocProtectedTag:()=>$K,isJSDocPublicTag:()=>qK,isJSDocReadonlyTag:()=>WK,isJSDocReturnTag:()=>_U,isJSDocSatisfiesExpression:()=>XX,isJSDocSatisfiesTag:()=>pU,isJSDocSeeTag:()=>q3e,isJSDocSignature:()=>PT,isJSDocTag:()=>eN,isJSDocTemplateTag:()=>dm,isJSDocThisTag:()=>HK,isJSDocThrowsTag:()=>$3e,isJSDocTypeAlias:()=>am,isJSDocTypeAssertion:()=>KN,isJSDocTypeExpression:()=>hE,isJSDocTypeLiteral:()=>mx,isJSDocTypeTag:()=>$6,isJSDocTypedefTag:()=>gx,isJSDocUnknownTag:()=>z3e,isJSDocUnknownType:()=>Lge,isJSDocVariadicType:()=>lU,isJSXTagName:()=>_N,isJsonEqual:()=>nB,isJsonSourceFile:()=>sm,isJsxAttribute:()=>th,isJsxAttributeLike:()=>O9,isJsxAttributeName:()=>$me,isJsxAttributes:()=>dE,isJsxChild:()=>u8,isJsxClosingElement:()=>fE,isJsxClosingFragment:()=>Ige,isJsxElement:()=>L0,isJsxExpression:()=>J6,isJsxFragment:()=>pE,isJsxNamespacedName:()=>pg,isJsxOpeningElement:()=>eh,isJsxOpeningFragment:()=>nk,isJsxOpeningLikeElement:()=>H_,isJsxOpeningLikeElementTagName:()=>c1e,isJsxSelfClosingElement:()=>px,isJsxSpreadAttribute:()=>ik,isJsxTagNameExpression:()=>Fw,isJsxText:()=>qA,isJumpStatementTarget:()=>GM,isKeyword:()=>Nf,isKeywordOrPunctuation:()=>vj,isKnownSymbol:()=>H8,isLabelName:()=>tte,isLabelOfLabeledStatement:()=>ete,isLabeledStatement:()=>_E,isLateVisibilityPaintedStatement:()=>G9,isLeftHandSideExpression:()=>$f,isLeftHandSideOfAssignment:()=>J4e,isLet:()=>X9,isLineBreak:()=>I_,isLiteralComputedPropertyDeclarationName:()=>z8,isLiteralExpression:()=>Ub,isLiteralExpressionOfObject:()=>oY,isLiteralImportTypeNode:()=>Vv,isLiteralKind:()=>Ow,isLiteralLikeAccess:()=>dj,isLiteralLikeElementAccess:()=>w8,isLiteralNameOfPropertyDeclarationOrIndexAccess:()=>eJ,isLiteralTypeLikeExpression:()=>K3e,isLiteralTypeLiteral:()=>Dpe,isLiteralTypeNode:()=>Qv,isLocalName:()=>Iy,isLogicalOperator:()=>tme,isLogicalOrCoalescingAssignmentExpression:()=>EX,isLogicalOrCoalescingAssignmentOperator:()=>s6,isLogicalOrCoalescingBinaryExpression:()=>eR,isLogicalOrCoalescingBinaryOperator:()=>Z8,isMappedTypeNode:()=>qN,isMemberName:()=>E0,isMetaProperty:()=>F6,isMethodDeclaration:()=>pl,isMethodOrAccessor:()=>vA,isMethodSignature:()=>Uh,isMinusToken:()=>wK,isMissingDeclaration:()=>B3e,isMissingPackageJsonInfo:()=>whe,isModifier:()=>Ra,isModifierKind:()=>C1,isModifierLike:()=>vc,isModuleAugmentationExternal:()=>NY,isModuleBlock:()=>Zg,isModuleBody:()=>Ope,isModuleDeclaration:()=>hl,isModuleExportsAccessExpression:()=>P0,isModuleIdentifier:()=>HY,isModuleName:()=>ehe,isModuleOrEnumDeclaration:()=>c8,isModuleReference:()=>jpe,isModuleSpecifierLike:()=>hJ,isModuleWithStringLiteralName:()=>W9,isNameOfFunctionDeclaration:()=>ste,isNameOfModuleDeclaration:()=>ite,isNamedClassElement:()=>a4e,isNamedDeclaration:()=>W_,isNamedEvaluation:()=>lp,isNamedEvaluationSource:()=>oX,isNamedExportBindings:()=>iY,isNamedExports:()=>wd,isNamedImportBindings:()=>gY,isNamedImports:()=>Dy,isNamedImportsOrExports:()=>Vj,isNamedTupleMember:()=>JN,isNamespaceBody:()=>u4e,isNamespaceExport:()=>qh,isNamespaceExportDeclaration:()=>BR,isNamespaceImport:()=>tS,isNamespaceReexportDeclaration:()=>Ede,isNewExpression:()=>lE,isNewExpressionTarget:()=>bO,isNoSubstitutionTemplateLiteral:()=>zA,isNode:()=>i4e,isNodeArray:()=>Bb,isNodeArrayMultiLine:()=>ume,isNodeDescendantOf:()=>Yb,isNodeKind:()=>e8,isNodeLikeSystem:()=>PG,isNodeModulesDirectory:()=>f9,isNodeWithPossibleHoistedDeclaration:()=>Dde,isNonContextualKeyword:()=>sX,isNonExportDefaultModifier:()=>Z3e,isNonGlobalAmbientModule:()=>PY,isNonGlobalDeclaration:()=>Q1e,isNonNullAccess:()=>zme,isNonNullChain:()=>k9,isNonNullExpression:()=>ek,isNonStaticMethodOrAccessorWithPrivateName:()=>f0e,isNotEmittedOrPartiallyEmittedNode:()=>l4e,isNotEmittedStatement:()=>BK,isNullishCoalesce:()=>nY,isNumber:()=>Mp,isNumericLiteral:()=>_p,isNumericLiteralName:()=>R0,isObjectBindingElementWithoutPropertyName:()=>i7,isObjectBindingOrAssignmentElement:()=>s8,isObjectBindingOrAssignmentPattern:()=>_Y,isObjectBindingPattern:()=>pm,isObjectLiteralElement:()=>hY,isObjectLiteralElementLike:()=>by,isObjectLiteralExpression:()=>Ha,isObjectLiteralMethod:()=>jm,isObjectLiteralOrClassExpressionMethodOrAccessor:()=>ej,isObjectTypeDeclaration:()=>OA,isOctalDigit:()=>g9,isOmittedExpression:()=>Su,isOptionalChain:()=>w_,isOptionalChainRoot:()=>Nw,isOptionalDeclaration:()=>C6,isOptionalJSDocPropertyLikeTag:()=>fR,isOptionalTypeNode:()=>rU,isOuterExpression:()=>hU,isOutermostOptionalChain:()=>Dw,isOverrideModifier:()=>Tge,isPackageJsonInfo:()=>BU,isPackedArrayLiteral:()=>HX,isParameter:()=>Ls,isParameterDeclaration:()=>Kb,isParameterPropertyDeclaration:()=>op,isParameterPropertyModifier:()=>Rw,isParenthesizedExpression:()=>Df,isParenthesizedTypeNode:()=>ox,isParseTreeNode:()=>Pw,isPartOfTypeNode:()=>A0,isPartOfTypeQuery:()=>lj,isPartiallyEmittedExpression:()=>aU,isPatternMatch:()=>U5,isPinnedComment:()=>z9,isPlainJsFile:()=>p8,isPlusToken:()=>IK,isPossiblyTypeArgumentPosition:()=>QM,isPostfixUnaryExpression:()=>MK,isPrefixUnaryExpression:()=>eS,isPrivateIdentifier:()=>is,isPrivateIdentifierClassElementDeclaration:()=>G_,isPrivateIdentifierPropertyAccessExpression:()=>XP,isPrivateIdentifierSymbol:()=>Mde,isProgramBundleEmitBuildInfo:()=>mye,isProgramUptoDate:()=>HZ,isPrologueDirective:()=>Fm,isPropertyAccessChain:()=>C9,isPropertyAccessEntityNameExpression:()=>tR,isPropertyAccessExpression:()=>Hn,isPropertyAccessOrQualifiedName:()=>Ppe,isPropertyAccessOrQualifiedNameOrImportTypeNode:()=>kpe,isPropertyAssignment:()=>Ul,isPropertyDeclaration:()=>ea,isPropertyName:()=>Al,isPropertyNameLiteral:()=>Wg,isPropertySignature:()=>fp,isProtoSetter:()=>Lde,isPrototypeAccess:()=>zv,isPrototypePropertyAssignment:()=>M8,isPunctuation:()=>iX,isPushOrUnshiftIdentifier:()=>cX,isQualifiedName:()=>pf,isQuestionDotToken:()=>eU,isQuestionOrExclamationToken:()=>Xge,isQuestionOrPlusOrMinusToken:()=>Zge,isQuestionToken:()=>Xv,isRawSourceMap:()=>c0e,isReadonlyKeyword:()=>vge,isReadonlyKeywordOrPlusOrMinusToken:()=>Qge,isRecognizedTripleSlashComment:()=>xY,isReferenceFileLocation:()=>pD,isReferencedFile:()=>MT,isRegularExpressionLiteral:()=>NK,isRequireCall:()=>_f,isRequireVariableStatement:()=>WY,isRestParameter:()=>x0,isRestTypeNode:()=>nU,isReturnStatement:()=>Um,isReturnStatementWithFixablePromiseHandler:()=>qJ,isRightSideOfAccessExpression:()=>AX,isRightSideOfInstanceofExpression:()=>nme,isRightSideOfPropertyAccess:()=>SD,isRightSideOfQualifiedName:()=>u1e,isRightSideOfQualifiedNameOrPropertyAccess:()=>o6,isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName:()=>rme,isRootedDiskPath:()=>ap,isSameEntityName:()=>pN,isSatisfiesExpression:()=>LK,isScopeMarker:()=>Ipe,isSemicolonClassElement:()=>kge,isSetAccessor:()=>A1,isSetAccessorDeclaration:()=>pp,isShebangTrivia:()=>$H,isShiftOperatorOrHigher:()=>iQ,isShorthandAmbientModuleSymbol:()=>Uw,isShorthandPropertyAssignment:()=>Hf,isSignedNumericLiteral:()=>Tj,isSimpleCopiableExpression:()=>TE,isSimpleInlineableExpression:()=>rh,isSimpleParameter:()=>h0e,isSimpleParameterList:()=>EM,isSingleOrDoubleQuote:()=>P8,isSourceFile:()=>ls,isSourceFileFromLibrary:()=>PD,isSourceFileJS:()=>Y_,isSourceFileNotJS:()=>b4e,isSourceFileNotJson:()=>$Y,isSourceMapping:()=>l0e,isSpecialPropertyDeclaration:()=>Ade,isSpreadAssignment:()=>F1,isSpreadElement:()=>fg,isStatement:()=>ns,isStatementButNotDeclaration:()=>l8,isStatementOrBlock:()=>Fpe,isStatementWithLocals:()=>Hpe,isStatic:()=>pa,isStaticModifier:()=>GA,isString:()=>vs,isStringAKeyword:()=>I4e,isStringANonContextualKeyword:()=>PA,isStringAndEmptyAnonymousObjectIntersection:()=>E1e,isStringDoubleQuoted:()=>pj,isStringLiteral:()=>za,isStringLiteralLike:()=>bo,isStringLiteralOrJsxExpression:()=>Bpe,isStringLiteralOrTemplate:()=>q1e,isStringOrNumericLiteralLike:()=>id,isStringOrRegularExpressionOrTemplateLiteral:()=>pte,isStringTextContainingNode:()=>cY,isSuperCall:()=>$2,isSuperKeyword:()=>M6,isSuperOrSuperProperty:()=>T4e,isSuperProperty:()=>Pf,isSupportedSourceFileName:()=>Ome,isSwitchStatement:()=>U6,isSyntaxList:()=>XN,isSyntheticExpression:()=>I3e,isSyntheticReference:()=>rk,isTagName:()=>rte,isTaggedTemplateExpression:()=>uE,isTaggedTemplateTag:()=>a1e,isTemplateExpression:()=>iU,isTemplateHead:()=>$A,isTemplateLiteral:()=>SA,isTemplateLiteralKind:()=>Rv,isTemplateLiteralToken:()=>Tpe,isTemplateLiteralTypeNode:()=>xge,isTemplateLiteralTypeSpan:()=>RK,isTemplateMiddle:()=>DK,isTemplateMiddleOrTemplateTail:()=>P9,isTemplateSpan:()=>B6,isTemplateTail:()=>QB,isTextWhiteSpaceLike:()=>N1e,isThis:()=>TD,isThisContainerOrFunctionBlock:()=>Sde,isThisIdentifier:()=>eE,isThisInTypeQuery:()=>NA,isThisInitializedDeclaration:()=>sj,isThisInitializedObjectBindingExpression:()=>bde,isThisProperty:()=>x8,isThisTypeNode:()=>LR,isThisTypeParameter:()=>x6,isThisTypePredicate:()=>S4e,isThrowStatement:()=>jK,isToken:()=>gA,isTokenKind:()=>aY,isTraceEnabled:()=>wy,isTransientSymbol:()=>Rh,isTrivia:()=>TN,isTryStatement:()=>fx,isTupleTypeNode:()=>XA,isTypeAlias:()=>j8,isTypeAliasDeclaration:()=>Vm,isTypeAssertionExpression:()=>Cge,isTypeDeclaration:()=>LN,isTypeElement:()=>B2,isTypeKeyword:()=>CO,isTypeKeywordToken:()=>vte,isTypeKeywordTokenOrIdentifier:()=>pJ,isTypeLiteralNode:()=>dp,isTypeNode:()=>es,isTypeNodeKind:()=>RX,isTypeOfExpression:()=>zN,isTypeOnlyExportDeclaration:()=>bpe,isTypeOnlyImportDeclaration:()=>t8,isTypeOnlyImportOrExportDeclaration:()=>dT,isTypeOperatorNode:()=>cx,isTypeParameterDeclaration:()=>Nc,isTypePredicateNode:()=>RR,isTypeQueryNode:()=>YA,isTypeReferenceNode:()=>Id,isTypeReferenceType:()=>F9,isTypeUsableAsPropertyName:()=>um,isUMDExportSymbol:()=>Uj,isUnaryExpression:()=>dY,isUnaryExpressionWithWrite:()=>Npe,isUnicodeIdentifierStart:()=>d9,isUnionTypeNode:()=>Kv,isUnparsedNode:()=>sY,isUnparsedPrepend:()=>wge,isUnparsedSource:()=>dx,isUnparsedTextLike:()=>Spe,isUrl:()=>Vfe,isValidBigIntString:()=>iB,isValidESSymbolDeclaration:()=>dde,isValidTypeOnlyAliasUseSite:()=>ET,isValueSignatureDeclaration:()=>Ide,isVarAwaitUsing:()=>v8,isVarConst:()=>aN,isVarUsing:()=>S8,isVariableDeclaration:()=>Gi,isVariableDeclarationInVariableStatement:()=>Jw,isVariableDeclarationInitializedToBareOrAccessedRequire:()=>Gb,isVariableDeclarationInitializedToRequire:()=>fj,isVariableDeclarationList:()=>Tu,isVariableLike:()=>cN,isVariableLikeOrAccessor:()=>fde,isVariableStatement:()=>Xc,isVoidExpression:()=>ZA,isWatchSet:()=>$4e,isWhileStatement:()=>O3e,isWhiteSpaceLike:()=>Sy,isWhiteSpaceSingleLine:()=>Vg,isWithStatement:()=>Pge,isWriteAccess:()=>wA,isWriteOnlyAccess:()=>Bj,isYieldExpression:()=>sU,jsxModeNeedsExplicitImport:()=>Hte,keywordPart:()=>gp,last:()=>Rs,lastOrUndefined:()=>Is,length:()=>de,libMap:()=>NU,libs:()=>sM,lineBreakPart:()=>AD,linkNamePart:()=>M1e,linkPart:()=>wte,linkTextPart:()=>SJ,listFiles:()=>pee,loadModuleFromGlobalCache:()=>Jhe,loadWithModeAwareCache:()=>OM,makeIdentifierFromModuleName:()=>Zpe,makeImport:()=>J1,makeImportIfNecessary:()=>P1e,makeStringLiteral:()=>vk,mangleScopedPackageName:()=>cD,map:()=>vr,mapAllOrFail:()=>Jo,mapDefined:()=>Wi,mapDefinedEntries:()=>Rl,mapDefinedIterator:()=>S0,mapEntries:()=>Fg,mapIterator:()=>g1,mapOneOrMany:()=>$te,mapToDisplayParts:()=>oS,matchFiles:()=>JX,matchPatternOrExact:()=>qX,matchedText:()=>bfe,matchesExclude:()=>PU,maybeBind:()=>rs,maybeSetLocalizedDiagnosticMessages:()=>Tme,memoize:()=>D_,memoizeCached:()=>aA,memoizeOne:()=>Nm,memoizeWeak:()=>RP,metadataHelper:()=>CB,min:()=>MP,minAndMax:()=>Mme,missingFileModifiedTime:()=>Lp,modifierToFlag:()=>IA,modifiersToFlags:()=>Yg,moduleOptionDeclaration:()=>xQ,moduleResolutionIsEqualTo:()=>Wpe,moduleResolutionNameAndModeGetter:()=>kV,moduleResolutionOptionDeclarations:()=>DU,moduleResolutionSupportsPackageJsonExportsAndImports:()=>MA,moduleResolutionUsesNodeModules:()=>dJ,moduleSpecifiers:()=>SE,moveEmitHelpers:()=>cge,moveRangeEnd:()=>Fj,moveRangePastDecorators:()=>Ay,moveRangePastModifiers:()=>Xg,moveRangePos:()=>TT,moveSyntheticComments:()=>sge,mutateMap:()=>f6,mutateMapSkippingNewValues:()=>w0,needsParentheses:()=>bJ,needsScopeMarker:()=>I9,newCaseClauseTracker:()=>LJ,newPrivateEnvironment:()=>m0e,noEmitNotification:()=>xM,noEmitSubstitution:()=>_O,noTransformers:()=>xZ,noTruncationMaximumTruncationLength:()=>fB,nodeCanBeDecorated:()=>oj,nodeHasName:()=>X3,nodeIsDecorated:()=>uN,nodeIsMissing:()=>sl,nodeIsPresent:()=>nm,nodeIsSynthesized:()=>_c,nodeModuleNameResolver:()=>Lhe,nodeModulesPathPart:()=>Wh,nodeNextJsonConfigResolver:()=>Fhe,nodeOrChildIsDecorated:()=>A8,nodeOverlapsWithStartEnd:()=>tJ,nodePosToString:()=>p4e,nodeSeenTracker:()=>yk,nodeStartsNewLexicalEnvironment:()=>lX,nodeToDisplayParts:()=>fLe,noop:()=>ja,noopFileWatcher:()=>yD,normalizePath:()=>Ca,normalizeSlashes:()=>v_,not:()=>J5,notImplemented:()=>Ks,notImplementedResolver:()=>gV,nullNodeConverters:()=>gK,nullParenthesizerRules:()=>mK,nullTransformationContext:()=>fO,objectAllocator:()=>Ju,operatorPart:()=>PO,optionDeclarations:()=>F0,optionMapToObject:()=>CU,optionsAffectingProgramStructure:()=>NQ,optionsForBuild:()=>IQ,optionsForWatch:()=>nD,optionsHaveChanges:()=>tN,optionsHaveModuleResolutionChanges:()=>qpe,or:()=>cg,orderedRemoveItem:()=>lA,orderedRemoveItemAt:()=>kv,outFile:()=>Wo,packageIdToPackageName:()=>V9,packageIdToString:()=>Bv,paramHelper:()=>AB,parameterIsThisKeyword:()=>Zb,parameterNamePart:()=>I1e,parseBaseNodeFactory:()=>fQ,parseBigInt:()=>Lme,parseBuildCommand:()=>I8e,parseCommandLine:()=>N8e,parseCommandLineWorker:()=>mQ,parseConfigFileTextToJson:()=>hQ,parseConfigFileWithSystem:()=>f7e,parseConfigHostFromCompilerHostLike:()=>AV,parseCustomTypeOption:()=>xU,parseIsolatedEntityName:()=>ok,parseIsolatedJSDocComment:()=>ohe,parseJSDocTypeExpressionForTests:()=>g8e,parseJsonConfigFileContent:()=>$8e,parseJsonSourceFileConfigFileContent:()=>rM,parseJsonText:()=>QR,parseListTypeOption:()=>lhe,parseNodeFactory:()=>$h,parseNodeModuleFromPath:()=>fM,parsePackageName:()=>mM,parsePseudoBigInt:()=>v6,parseValidBigInt:()=>GX,patchWriteFileEnsuringDirectory:()=>Bfe,pathContainsNodeModules:()=>OT,pathIsAbsolute:()=>Tw,pathIsBareSpecifier:()=>VH,pathIsRelative:()=>Fp,patternText:()=>Tfe,perfLogger:()=>z_,performIncrementalCompilation:()=>g7e,performance:()=>Ofe,plainJSErrors:()=>PV,positionBelongsToNode:()=>ote,positionIsASICandidate:()=>AJ,positionIsSynthesized:()=>_g,positionsAreOnSameLine:()=>Pd,preProcessFile:()=>BLe,probablyUsesSemicolons:()=>u7,processCommentPragmas:()=>uQ,processPragmasIntoFields:()=>_Q,processTaggedTemplateExpression:()=>hZ,programContainsEsModules:()=>k1e,programContainsModules:()=>A1e,projectReferenceIsEqualTo:()=>TY,propKeyHelper:()=>BB,propertyNamePart:()=>w1e,pseudoBigIntToString:()=>nE,punctuationPart:()=>F_,pushIfUnique:()=>ln,quote:()=>IO,quotePreferenceFromString:()=>Ete,rangeContainsPosition:()=>HM,rangeContainsPositionExclusive:()=>YM,rangeContainsRange:()=>ud,rangeContainsRangeExclusive:()=>f1e,rangeContainsStartEnd:()=>XM,rangeEndIsOnSameLineAsRangeStart:()=>nR,rangeEndPositionsAreOnSameLine:()=>cme,rangeEquals:()=>Bc,rangeIsOnSingleLine:()=>rx,rangeOfNode:()=>$X,rangeOfTypeParameters:()=>WX,rangeOverlapsWithStartEnd:()=>EO,rangeStartIsOnSameLineAsRangeEnd:()=>lme,rangeStartPositionsAreOnSameLine:()=>jj,readBuilderProgram:()=>UV,readConfigFile:()=>eM,readHelper:()=>FB,readJson:()=>c6,readJsonConfigFile:()=>fhe,readJsonOrUndefined:()=>PX,reduceEachLeadingCommentRange:()=>Gfe,reduceEachTrailingCommentRange:()=>Hfe,reduceLeft:()=>d_,reduceLeftIterator:()=>xr,reducePathComponents:()=>M2,refactor:()=>bk,regExpEscape:()=>Q4e,relativeComplement:()=>dy,removeAllComments:()=>xR,removeEmitHelper:()=>P3e,removeExtension:()=>lR,removeFileExtension:()=>ff,removeIgnoredPath:()=>IV,removeMinAndVersionNumbers:()=>B5,removeOptionality:()=>v1e,removePrefix:()=>hw,removeSuffix:()=>cA,removeTrailingDirectorySeparator:()=>sT,repeatString:()=>r7,replaceElement:()=>sA,replaceFirstStar:()=>jA,resolutionExtensionIsTSOrJson:()=>g6,resolveConfigFileProjectName:()=>xee,resolveJSModule:()=>Rhe,resolveLibrary:()=>VU,resolveModuleName:()=>aD,resolveModuleNameFromCache:()=>PRe,resolvePackageNameToPackageJson:()=>RQ,resolvePath:()=>Dv,resolveProjectReferencePath:()=>dD,resolveTripleslashReference:()=>SV,resolveTypeReferenceDirective:()=>Dhe,resolvingEmptyArray:()=>_B,restHelper:()=>OB,returnFalse:()=>qf,returnNoopFileWatcher:()=>vD,returnTrue:()=>em,returnUndefined:()=>xd,returnsPromise:()=>pre,runInitializersHelper:()=>PB,sameFlatMap:()=>nA,sameMap:()=>ul,sameMapping:()=>mMe,scanShebangTrivia:()=>WH,scanTokenAtPosition:()=>lde,scanner:()=>j_,screenStartingMessageCodes:()=>BV,semanticDiagnosticsOptionDeclarations:()=>AQ,serializeCompilerOptions:()=>AU,server:()=>Lqe,servicesVersion:()=>SSe,setCommentRange:()=>kl,setConfigFileInOptions:()=>bQ,setConstantValue:()=>oge,setEachParent:()=>MN,setEmitFlags:()=>Sn,setFunctionNameHelper:()=>UB,setGetSourceFileAsHashVersioned:()=>jV,setIdentifierAutoGenerate:()=>kR,setIdentifierGeneratedImportReference:()=>_ge,setIdentifierTypeArguments:()=>M1,setInternalEmitFlags:()=>CR,setLocalizedDiagnosticMessages:()=>Sme,setModuleDefaultHelper:()=>qB,setNodeFlags:()=>Bme,setObjectAllocator:()=>vme,setOriginalNode:()=>Un,setParent:()=>io,setParentRecursive:()=>Wv,setPrivateIdentifier:()=>Sx,setSnippetElement:()=>xK,setSourceMapRange:()=>qa,setStackTraceLimit:()=>vOe,setStartsOnNewLine:()=>TB,setSyntheticLeadingComments:()=>CT,setSyntheticTrailingComments:()=>UA,setSys:()=>xOe,setSysLog:()=>Ffe,setTextRange:()=>ft,setTextRangeEnd:()=>RN,setTextRangePos:()=>S6,setTextRangePosEnd:()=>jh,setTextRangePosWidth:()=>T6,setTokenSourceMapRange:()=>ige,setTypeNode:()=>lge,setUILocale:()=>A3,setValueDeclaration:()=>L8,shouldAllowImportingTsExtension:()=>lD,shouldPreserveConstEnums:()=>aE,shouldUseUriStyleNodeCoreModules:()=>RJ,showModuleSpecifier:()=>dme,signatureHasLiteralTypes:()=>ZQ,signatureHasRestParameter:()=>L_,signatureToDisplayParts:()=>Ote,single:()=>jg,singleElementArray:()=>_A,singleIterator:()=>k2,singleOrMany:()=>Op,singleOrUndefined:()=>nl,skipAlias:()=>r_,skipAssertions:()=>H3e,skipConstraint:()=>Ste,skipOuterExpressions:()=>vl,skipParentheses:()=>Do,skipPartiallyEmittedExpressions:()=>Mm,skipTrivia:()=>Wa,skipTypeChecking:()=>y6,skipTypeParentheses:()=>q8,skipWhile:()=>xfe,sliceAfter:()=>zX,some:()=>Tt,sort:()=>Fa,sortAndDeduplicate:()=>rT,sortAndDeduplicateDiagnostics:()=>WP,sourceFileAffectingCompilerOptions:()=>IU,sourceFileMayBeEmitted:()=>Q2,sourceMapCommentRegExp:()=>eV,sourceMapCommentRegExpDontCareLineStart:()=>oZ,spacePart:()=>Qc,spanMap:()=>P2,spreadArrayHelper:()=>jB,stableSort:()=>cu,startEndContainsRange:()=>ate,startEndOverlapsWithStartEnd:()=>rJ,startOnNewLine:()=>M_,startTracing:()=>Rfe,startsWith:()=>Ss,startsWithDirectory:()=>qH,startsWithUnderscore:()=>Gte,startsWithUseStrict:()=>zge,stringContainsAt:()=>K1e,stringToToken:()=>Fb,stripQuotes:()=>cm,supportedDeclarationExtensions:()=>yR,supportedJSExtensions:()=>fK,supportedJSExtensionsFlat:()=>jN,supportedLocaleDirectories:()=>SY,supportedTSExtensions:()=>FN,supportedTSExtensionsFlat:()=>_K,supportedTSImplementationExtensions:()=>vR,suppressLeadingAndTrailingTrivia:()=>hp,suppressLeadingTrivia:()=>Fte,suppressTrailingTrivia:()=>U1e,symbolEscapedNameNoDefault:()=>gJ,symbolName:()=>Lc,symbolNameNoDefault:()=>mJ,symbolPart:()=>D1e,symbolToDisplayParts:()=>NO,syntaxMayBeASICandidate:()=>Zte,syntaxRequiresTrailingSemicolonOrASI:()=>CJ,sys:()=>Zu,sysLog:()=>O3,tagNamesAreEquivalent:()=>DT,takeWhile:()=>z5,targetOptionDeclaration:()=>oM,templateObjectHelper:()=>LB,testFormatSettings:()=>s1e,textChangeRangeIsUnchanged:()=>tpe,textChangeRangeNewSpan:()=>kw,textChanges:()=>En,textOrKeywordPart:()=>Ite,textPart:()=>fd,textRangeContainsPositionInclusive:()=>G3,textSpanContainsPosition:()=>YH,textSpanContainsTextSpan:()=>Kfe,textSpanEnd:()=>gl,textSpanIntersection:()=>epe,textSpanIntersectsWith:()=>v9,textSpanIntersectsWithPosition:()=>Zfe,textSpanIntersectsWithTextSpan:()=>$Oe,textSpanIsEmpty:()=>Xfe,textSpanOverlap:()=>Qfe,textSpanOverlapsWith:()=>zOe,textSpansEqual:()=>CD,textToKeywordObj:()=>$3,timestamp:()=>uc,toArray:()=>Pm,toBuilderFileEmit:()=>yye,toBuilderStateFileInfoForMultiEmit:()=>hye,toEditorSettings:()=>N7,toFileNameLowerCase:()=>sp,toLowerCase:()=>gw,toPath:()=>gc,toProgramEmitPending:()=>vye,tokenIsIdentifierOrKeyword:()=>$_,tokenIsIdentifierOrKeywordOrGreaterThan:()=>$fe,tokenToString:()=>Sa,trace:()=>ws,tracing:()=>mn,tracingEnabled:()=>N3,transform:()=>F5e,transformClassFields:()=>A0e,transformDeclarations:()=>bZ,transformECMAScriptModule:()=>TZ,transformES2015:()=>V0e,transformES2016:()=>U0e,transformES2017:()=>D0e,transformES2018:()=>I0e,transformES2019:()=>w0e,transformES2020:()=>O0e,transformES2021:()=>R0e,transformES5:()=>J0e,transformESDecorators:()=>N0e,transformESNext:()=>M0e,transformGenerators:()=>q0e,transformJsx:()=>B0e,transformLegacyDecorators:()=>P0e,transformModule:()=>SZ,transformNamedEvaluation:()=>mp,transformNodeModule:()=>$0e,transformNodes:()=>CM,transformSystemModule:()=>z0e,transformTypeScript:()=>C0e,transpile:()=>GLe,transpileModule:()=>gve,transpileOptionValueCompilerOptions:()=>DQ,tryAddToSet:()=>Zd,tryAndIgnoreErrors:()=>NJ,tryCast:()=>ii,tryDirectoryExists:()=>PJ,tryExtractTSExtension:()=>Mj,tryFileExists:()=>_7,tryGetClassExtendingExpressionWithTypeArguments:()=>xX,tryGetClassImplementingOrExtendingExpressionWithTypeArguments:()=>CX,tryGetDirectories:()=>kJ,tryGetExtensionFromPath:()=>Py,tryGetImportFromModuleSpecifier:()=>F8,tryGetJSDocSatisfiesTypeNode:()=>cB,tryGetModuleNameFromFile:()=>$R,tryGetModuleSpecifierFromDeclaration:()=>dN,tryGetNativePerformanceHooks:()=>Dfe,tryGetPropertyAccessOrIdentifierToString:()=>rR,tryGetPropertyNameOfBindingOrAssignmentElement:()=>vU,tryGetSourceMappingURL:()=>o0e,tryGetTextOfPropertyName:()=>Vw,tryIOAndConsumeErrors:()=>DJ,tryParseJson:()=>Lj,tryParsePattern:()=>ON,tryParsePatterns:()=>tB,tryParseRawSourceMap:()=>sZ,tryReadDirectory:()=>Ute,tryReadFile:()=>X6,tryRemoveDirectoryPrefix:()=>UX,tryRemoveExtension:()=>Rme,tryRemovePrefix:()=>kG,tryRemoveSuffix:()=>xG,typeAcquisitionDeclarations:()=>cM,typeAliasNamePart:()=>O1e,typeDirectiveIsEqualTo:()=>Gpe,typeKeywords:()=>FJ,typeParameterNamePart:()=>R1e,typeToDisplayParts:()=>a7,unchangedPollThresholds:()=>R3,unchangedTextChangeRange:()=>_8,unescapeLeadingUnderscores:()=>Zi,unmangleScopedPackageName:()=>hM,unorderedRemoveItem:()=>uA,unorderedRemoveItemAt:()=>CG,unreachableCodeIsError:()=>Eme,unusedLabelIsError:()=>xme,unwrapInnermostStatementOfLabel:()=>VY,updateErrorForNoInputFiles:()=>kU,updateLanguageServiceSourceFile:()=>Xre,updateMissingFilePathsWatch:()=>wZ,updateResolutionField:()=>iD,updateSharedExtendedConfigFileWatcher:()=>yV,updateSourceFile:()=>cQ,updateWatchingWildcardDirectories:()=>PM,usesExtensionsOnImports:()=>Ime,usingSingleLineStringWriter:()=>jw,utf16EncodeAsString:()=>$P,validateLocaleAndSetLanguage:()=>GOe,valuesHelper:()=>VB,version:()=>F,versionMajorMinor:()=>w,visitArray:()=>SM,visitCommaListElements:()=>TM,visitEachChild:()=>wr,visitFunctionBody:()=>ld,visitIterationBody:()=>df,visitLexicalEnvironment:()=>nZ,visitNode:()=>nt,visitNodes:()=>Hr,visitParameterList:()=>qc,walkUpBindingElementsAndPatterns:()=>GP,walkUpLexicalEnvironments:()=>d0e,walkUpOuterExpressions:()=>$ge,walkUpParenthesizedExpressions:()=>P1,walkUpParenthesizedTypes:()=>J8,walkUpParenthesizedTypesAndGetParentAndChild:()=>wde,whitespaceOrMapCommentRegExp:()=>tV,writeCommentRange:()=>kN,writeFile:()=>t6,writeFileEnsuringDirectories:()=>vX,zipWith:()=>en});var uS=f({"src/server/_namespaces/ts.ts"(){"use strict";fa(),JM(),yi(),pse(),Mx()}}),jqe={};x(jqe,{ActionInvalidate:()=>UM,ActionPackageInstalled:()=>VM,ActionSet:()=>BM,ActionWatchTypingLocations:()=>TO,Arguments:()=>Iee,AutoImportProviderProject:()=>kse,AuxiliaryProject:()=>Cse,CharRangeSection:()=>Use,CloseFileWatcherEvent:()=>sz,CommandNames:()=>G2e,ConfigFileDiagEvent:()=>ez,ConfiguredProject:()=>Pse,CreateDirectoryWatcherEvent:()=>iz,CreateFileWatcherEvent:()=>nz,Errors:()=>G1,EventBeginInstallTypes:()=>WV,EventEndInstallTypes:()=>GV,EventInitializationFailed:()=>Dee,EventTypesRegistry:()=>$V,ExternalProject:()=>Gq,GcTimer:()=>yse,InferredProject:()=>xse,LargeFileReferencedEvent:()=>Zq,LineIndex:()=>YO,LineLeaf:()=>cL,LineNode:()=>Ok,LogLevel:()=>dse,Msg:()=>mse,OpenFileInfoTelemetryEvent:()=>wse,Project:()=>Rx,ProjectInfoTelemetryEvent:()=>rz,ProjectKind:()=>GO,ProjectLanguageServiceStateEvent:()=>tz,ProjectLoadingFinishEvent:()=>Qq,ProjectLoadingStartEvent:()=>Kq,ProjectReferenceProjectLoadKind:()=>Mse,ProjectService:()=>Lse,ProjectsUpdatedInBackgroundEvent:()=>sL,ScriptInfo:()=>Tse,ScriptVersionCache:()=>lz,Session:()=>Y2e,TextStorage:()=>Sse,ThrottledOperations:()=>hse,TypingsCache:()=>bse,TypingsInstallerAdapter:()=>Q2e,allFilesAreJsOrDts:()=>C2e,allRootFilesAreJsOrDts:()=>x2e,asNormalizedPath:()=>_qe,convertCompilerOptions:()=>Hq,convertFormatOptions:()=>WD,convertScriptKindName:()=>Dse,convertTypeAcquisition:()=>P2e,convertUserPreferences:()=>N2e,convertWatchOptions:()=>iL,countEachFileTypes:()=>rL,createInstallTypingsRequest:()=>n2e,createModuleSpecifierCache:()=>B2e,createNormalizedPathMap:()=>fqe,createPackageJsonCache:()=>U2e,createSortedArray:()=>c2e,emptyArray:()=>Vl,findArgument:()=>Z7e,forEachResolvedProjectReferenceProject:()=>GD,formatDiagnosticToProtocol:()=>oL,formatMessage:()=>V2e,getBaseConfigFileName:()=>gse,getLocationInNewDocument:()=>$2e,hasArgument:()=>Q7e,hasNoTypeScriptSource:()=>A2e,indent:()=>SO,isBackgroundProject:()=>nL,isConfigFile:()=>M2e,isConfiguredProject:()=>JT,isDynamicFileName:()=>tL,isExternalProject:()=>Ese,isInferredProject:()=>$D,isInferredProjectName:()=>i2e,makeAutoImportProviderProjectName:()=>a2e,makeAuxiliaryProjectName:()=>o2e,makeInferredProjectName:()=>s2e,maxFileSize:()=>Xq,maxProgramSizeForNonTsFiles:()=>Yq,normalizedPathToPath:()=>eL,nowString:()=>eLe,nullCancellationToken:()=>W2e,nullTypingsInstaller:()=>Wq,projectContainsInfoDirectly:()=>Ik,protocol:()=>E2e,removeSorted:()=>pqe,stringifyIndented:()=>LT,toEvent:()=>J2e,toNormalizedPath:()=>Cc,tryConvertScriptKindName:()=>Nse,typingsInstaller:()=>t2e,updateProjectIfDirty:()=>qp});var M8t=f({"src/typescript/_namespaces/ts.server.ts"(){"use strict";HV(),Mx()}}),Bqe={};x(Bqe,{ANONYMOUS:()=>jJ,AccessFlags:()=>sH,AssertionLevel:()=>DG,AssignmentDeclarationKind:()=>dH,AssignmentKind:()=>rK,Associativity:()=>iK,BreakpointResolver:()=>nne,BuilderFileEmit:()=>oee,BuilderProgramKind:()=>cee,BuilderState:()=>zm,BundleFileSectionKind:()=>wH,CallHierarchy:()=>Ek,CharacterCodes:()=>CH,CheckFlags:()=>eH,CheckMode:()=>KU,ClassificationType:()=>Xee,ClassificationTypeNames:()=>Yee,CommentDirectiveType:()=>BG,Comparison:()=>ee,CompletionInfoFlags:()=>Jee,CompletionTriggerKind:()=>Fee,Completions:()=>Pk,ContainerFlags:()=>XQ,ContextFlags:()=>$G,Debug:()=>I,DiagnosticCategory:()=>I3,Diagnostics:()=>g,DocumentHighlights:()=>VJ,ElementFlags:()=>iH,EmitFlags:()=>o9,EmitHint:()=>NH,EmitOnly:()=>VG,EndOfLineState:()=>$ee,EnumKind:()=>ZG,ExitStatus:()=>JG,ExportKind:()=>ire,Extension:()=>AH,ExternalEmitHelpers:()=>PH,FileIncludeKind:()=>Q5,FilePreprocessingDiagnosticsKind:()=>UG,FileSystemEntryKind:()=>jH,FileWatcherEventKind:()=>FH,FindAllReferences:()=>Ko,FlattenLevel:()=>dZ,FlowFlags:()=>D3,ForegroundColorEscapeSequences:()=>ZZ,FunctionFlags:()=>nK,GeneratedIdentifierFlags:()=>K5,GetLiteralTextFlags:()=>ZX,GoToDefinition:()=>UD,HighlightSpanKind:()=>Bee,IdentifierNameMap:()=>fk,IdentifierNameMultiMap:()=>pZ,ImportKind:()=>nre,ImportsNotUsedAsValues:()=>SH,IndentStyle:()=>Uee,IndexFlags:()=>aH,IndexKind:()=>lH,InferenceFlags:()=>fH,InferencePriority:()=>_H,InlayHintKind:()=>jee,InlayHints:()=>Yie,InternalEmitFlags:()=>kH,InternalSymbolName:()=>tH,InvalidatedProjectKind:()=>Nee,JSDocParsingMode:()=>MH,JsDoc:()=>VT,JsTyping:()=>sh,JsxEmit:()=>vH,JsxFlags:()=>FG,JsxReferenceKind:()=>oH,LanguageServiceMode:()=>Ree,LanguageVariant:()=>EH,LexicalEnvironmentFlags:()=>IH,ListFormat:()=>OH,LogLevel:()=>wG,MemberOverrideStatus:()=>qG,ModifierFlags:()=>Y5,ModuleDetectionKind:()=>mH,ModuleInstanceState:()=>YQ,ModuleKind:()=>vw,ModuleResolutionKind:()=>JP,ModuleSpecifierEnding:()=>pK,NavigateTo:()=>vve,NavigationBar:()=>Nve,NewLineKind:()=>TH,NodeBuilderFlags:()=>WG,NodeCheckFlags:()=>rH,NodeFactoryFlags:()=>TK,NodeFlags:()=>H5,NodeResolutionFeatures:()=>WQ,ObjectFlags:()=>r9,OperationCanceledException:()=>VP,OperatorPrecedence:()=>sK,OrganizeImports:()=>$m,OrganizeImportsMode:()=>Lee,OuterExpressionKinds:()=>DH,OutliningElementsCollector:()=>Zie,OutliningSpanKind:()=>qee,OutputFileType:()=>zee,PackageJsonAutoImportPreference:()=>Oee,PackageJsonDependencyGroup:()=>wee,PatternMatchKind:()=>JJ,PollingInterval:()=>c9,PollingWatchKind:()=>yH,PragmaKindFlags:()=>RH,PrivateIdentifierKind:()=>PK,ProcessLevel:()=>yZ,ProgramUpdateLevel:()=>RZ,QuotePreference:()=>Kte,RelationComparisonResult:()=>X5,Rename:()=>Bq,ScriptElementKind:()=>Gee,ScriptElementKindModifier:()=>Hee,ScriptKind:()=>i9,ScriptSnapshot:()=>XV,ScriptTarget:()=>bH,SemanticClassificationFormat:()=>Mee,SemanticMeaning:()=>Xte,SemicolonPreference:()=>Vee,SignatureCheckMode:()=>QU,SignatureFlags:()=>n9,SignatureHelp:()=>W7,SignatureKind:()=>cH,SmartSelectionRange:()=>rse,SnippetKind:()=>a9,SortKind:()=>NG,StructureIsReused:()=>Z5,SymbolAccessibility:()=>YG,SymbolDisplay:()=>W1,SymbolDisplayPartKind:()=>qM,SymbolFlags:()=>e9,SymbolFormatFlags:()=>HG,SyntaxKind:()=>G5,SyntheticSymbolKind:()=>XG,Ternary:()=>pH,ThrottledCancellationToken:()=>rne,TokenClass:()=>Wee,TokenFlags:()=>jG,TransformFlags:()=>s9,TypeFacts:()=>XU,TypeFlags:()=>t9,TypeFormatFlags:()=>GG,TypeMapKind:()=>uH,TypePredicateKind:()=>KG,TypeReferenceSerializationKind:()=>QG,UnionReduction:()=>zG,UpToDateStatusType:()=>Cee,VarianceFlags:()=>nH,Version:()=>Im,VersionRange:()=>k3,WatchDirectoryFlags:()=>xH,WatchDirectoryKind:()=>hH,WatchFileKind:()=>gH,WatchLogLevel:()=>MZ,WatchType:()=>_u,accessPrivateIdentifier:()=>g0e,addDisposableResourceHelper:()=>YB,addEmitFlags:()=>Kg,addEmitHelper:()=>VA,addEmitHelpers:()=>Ny,addInternalEmitFlags:()=>BA,addNodeFactoryPatcher:()=>T3e,addObjectAllocatorPatcher:()=>yme,addRange:()=>jt,addRelatedInfo:()=>Ga,addSyntheticLeadingComment:()=>w6,addSyntheticTrailingComment:()=>bB,addToSeen:()=>Bm,advancedAsyncSuperHelper:()=>DR,affectsDeclarationPathOptionDeclarations:()=>PQ,affectsEmitOptionDeclarations:()=>kQ,allKeysStartWithDot:()=>qU,altDirectorySeparator:()=>B3,and:()=>V5,append:()=>Pr,appendIfUnique:()=>ai,arrayFrom:()=>In,arrayIsEqualTo:()=>td,arrayIsHomogeneous:()=>jme,arrayIsSorted:()=>iA,arrayOf:()=>Xn,arrayReverseIterator:()=>Xl,arrayToMap:()=>il,arrayToMultiMap:()=>_l,arrayToNumericMap:()=>Rp,arraysEqual:()=>Am,assertType:()=>tOe,assign:()=>ec,assignHelper:()=>NB,asyncDelegator:()=>IB,asyncGeneratorHelper:()=>DB,asyncSuperHelper:()=>NR,asyncValues:()=>wB,attachFileToDiagnostics:()=>RA,awaitHelper:()=>JA,awaiterHelper:()=>RB,base64decode:()=>ome,base64encode:()=>ame,binarySearch:()=>Bg,binarySearchKey:()=>nT,bindSourceFile:()=>$he,breakIntoCharacterSpans:()=>fve,breakIntoWordSpans:()=>pve,buildLinkParts:()=>L1e,buildOpts:()=>wU,buildOverload:()=>sqe,bundlerModuleNameResolver:()=>Mhe,canBeConvertedToAsync:()=>mre,canHaveDecorators:()=>yx,canHaveExportModifier:()=>_R,canHaveFlowNode:()=>B8,canHaveIllegalDecorators:()=>nQ,canHaveIllegalModifiers:()=>Yge,canHaveIllegalType:()=>X3e,canHaveIllegalTypeParameters:()=>Hge,canHaveJSDoc:()=>U8,canHaveLocals:()=>Oh,canHaveModifiers:()=>Jm,canHaveSymbol:()=>qg,canJsonReportNoInputFiles:()=>K6,canProduceDiagnostics:()=>_V,canUsePropertyAccess:()=>YX,canWatchAffectingLocation:()=>Eye,canWatchAtTypes:()=>bye,canWatchDirectoryOrFile:()=>wV,cartesianProduct:()=>Efe,cast:()=>ta,chainBundle:()=>qm,chainDiagnosticMessages:()=>Xs,changeAnyExtension:()=>F3,changeCompilerHostLikeToUseCache:()=>IM,changeExtension:()=>bT,changeFullExtension:()=>Jfe,changesAffectModuleResolution:()=>j9,changesAffectingProgramStructure:()=>zpe,childIsDecorated:()=>zw,classElementOrClassElementParameterIsDecorated:()=>JY,classHasClassThisAssignment:()=>mZ,classHasDeclaredOrExplicitlyAssignedName:()=>gZ,classHasExplicitlyAssignedName:()=>cV,classOrConstructorParameterIsDecorated:()=>k1,classPrivateFieldGetHelper:()=>WB,classPrivateFieldInHelper:()=>HB,classPrivateFieldSetHelper:()=>GB,classicNameResolver:()=>Vhe,classifier:()=>xSe,cleanExtendedConfigCache:()=>vV,clear:()=>ed,clearMap:()=>Wf,clearSharedExtendedConfigFileWatcher:()=>IZ,climbPastPropertyAccess:()=>QV,climbPastPropertyOrElementAccess:()=>l1e,clone:()=>q_,cloneCompilerOptions:()=>mte,closeFileWatcher:()=>ug,closeFileWatcherOf:()=>Od,codefix:()=>x_,collapseTextChangeRangesAcrossMultipleVersions:()=>rpe,collectExternalModuleInfo:()=>lZ,combine:()=>Cv,combinePaths:()=>li,commentPragmas:()=>w3,commonOptionsWithBuild:()=>aM,commonPackageFolders:()=>cK,compact:()=>y1,compareBooleans:()=>hy,compareDataObjects:()=>wX,compareDiagnostics:()=>p6,compareDiagnosticsSkipRelatedInformation:()=>qj,compareEmitHelpers:()=>dge,compareNumberOfDirectorySeparators:()=>cR,comparePaths:()=>yy,comparePathsCaseInsensitive:()=>POe,comparePathsCaseSensitive:()=>kOe,comparePatternKeys:()=>zQ,compareProperties:()=>j5,compareStringsCaseInsensitive:()=>D2,compareStringsCaseInsensitiveEslintCompatible:()=>I2,compareStringsCaseSensitive:()=>h_,compareStringsCaseSensitiveUI:()=>LP,compareTextSpans:()=>iT,compareValues:()=>To,compileOnSaveCommandLineOption:()=>iM,compilerOptionsAffectDeclarationPath:()=>Pme,compilerOptionsAffectEmit:()=>kme,compilerOptionsAffectSemanticDiagnostics:()=>Ame,compilerOptionsDidYouMeanDiagnostics:()=>lM,compilerOptionsIndicateEsModules:()=>Tte,compose:()=>F5,computeCommonSourceDirectoryOfFilenames:()=>tye,computeLineAndCharacterOfPosition:()=>zP,computeLineOfPosition:()=>Ew,computeLineStarts:()=>mA,computePositionOfLineAndCharacter:()=>m9,computeSignature:()=>xx,computeSignatureWithDiagnostics:()=>nee,computeSuggestionDiagnostics:()=>fre,computedOptions:()=>Bl,concatenate:()=>ys,concatenateDiagnosticMessageChains:()=>bme,consumesNodeCoreModules:()=>IJ,contains:()=>hs,containsIgnoredPath:()=>b6,containsObjectRestOrSpread:()=>YR,containsParseError:()=>rN,containsPath:()=>wm,convertCompilerOptionsForTelemetry:()=>yhe,convertCompilerOptionsFromJson:()=>Z8e,convertJsonOption:()=>vx,convertToBase64:()=>sme,convertToJson:()=>tM,convertToObject:()=>phe,convertToOptionsWithAbsolutePaths:()=>TQ,convertToRelativePath:()=>bw,convertToTSConfig:()=>B8e,convertTypeAcquisitionFromJson:()=>eRe,copyComments:()=>Px,copyEntries:()=>B9,copyLeadingComments:()=>kD,copyProperties:()=>uf,copyTrailingAsLeadingComments:()=>l7,copyTrailingComments:()=>DO,couldStartTrivia:()=>Wfe,countWhere:()=>mu,createAbstractBuilder:()=>a7e,createAccessorPropertyBackingField:()=>sQ,createAccessorPropertyGetRedirector:()=>nhe,createAccessorPropertySetRedirector:()=>ihe,createBaseNodeFactory:()=>Qme,createBinaryExpressionTrampoline:()=>SU,createBindingHelper:()=>UN,createBuildInfo:()=>AM,createBuilderProgram:()=>iee,createBuilderProgramUsingProgramBuildInfo:()=>Sye,createBuilderStatusReporter:()=>Fye,createCacheWithRedirects:()=>LQ,createCacheableExportInfoMap:()=>ere,createCachedDirectoryStructureHost:()=>hV,createClassNamedEvaluationHelperBlock:()=>b0e,createClassThisAssignmentBlock:()=>S0e,createClassifier:()=>ELe,createCommentDirectivesMap:()=>Xpe,createCompilerDiagnostic:()=>fl,createCompilerDiagnosticForInvalidCustomType:()=>che,createCompilerDiagnosticFromMessageChain:()=>Jj,createCompilerHost:()=>rye,createCompilerHostFromProgramHost:()=>Tee,createCompilerHostWorker:()=>jZ,createDetachedDiagnostic:()=>wN,createDiagnosticCollection:()=>EN,createDiagnosticForFileFromMessageChain:()=>FY,createDiagnosticForNode:()=>$n,createDiagnosticForNodeArray:()=>sN,createDiagnosticForNodeArrayFromMessageChain:()=>y8,createDiagnosticForNodeFromMessageChain:()=>Ey,createDiagnosticForNodeInSourceFile:()=>im,createDiagnosticForRange:()=>cde,createDiagnosticMessageChainFromDiagnostic:()=>ode,createDiagnosticReporter:()=>LM,createDocumentPositionMapper:()=>u0e,createDocumentRegistry:()=>tve,createDocumentRegistryInternal:()=>ore,createEmitAndSemanticDiagnosticsBuilderProgram:()=>lee,createEmitHelperFactory:()=>pge,createEmptyExports:()=>VR,createExpressionForJsxElement:()=>Vge,createExpressionForJsxFragment:()=>Jge,createExpressionForObjectLiteralElementLike:()=>qge,createExpressionForPropertyName:()=>KK,createExpressionFromEntityName:()=>JR,createExternalHelpersImportDeclarationIfNeeded:()=>eQ,createFileDiagnostic:()=>Iu,createFileDiagnosticFromMessageChain:()=>H9,createForOfBindingStatement:()=>XK,createGetCanonicalFileName:()=>y_,createGetSourceFile:()=>LZ,createGetSymbolAccessibilityDiagnosticForNode:()=>j1,createGetSymbolAccessibilityDiagnosticForNodeName:()=>W0e,createGetSymbolWalker:()=>Whe,createIncrementalCompilerHost:()=>Eee,createIncrementalProgram:()=>Mye,createInputFiles:()=>E3e,createInputFilesWithFilePaths:()=>vK,createInputFilesWithFileTexts:()=>SK,createJsxFactoryExpression:()=>YK,createLanguageService:()=>ySe,createLanguageServiceSourceFile:()=>fq,createMemberAccessForPropertyName:()=>hx,createModeAwareCache:()=>uk,createModeAwareCacheKey:()=>rO,createModuleNotFoundChain:()=>U9,createModuleResolutionCache:()=>sD,createModuleResolutionLoader:()=>zZ,createModuleResolutionLoaderUsingGlobalCache:()=>kye,createModuleSpecifierResolutionHost:()=>kx,createMultiMap:()=>g_,createNodeConverters:()=>ege,createNodeFactory:()=>TR,createOptionNameMap:()=>EU,createOverload:()=>fse,createPackageJsonImportFilter:()=>OO,createPackageJsonInfo:()=>Jte,createParenthesizerRules:()=>Zme,createPatternMatcher:()=>ave,createPrependNodes:()=>KZ,createPrinter:()=>RT,createPrinterWithDefaults:()=>NZ,createPrinterWithRemoveComments:()=>EE,createPrinterWithRemoveCommentsNeverAsciiEscape:()=>DZ,createPrinterWithRemoveCommentsOmitTrailingSemicolon:()=>kM,createProgram:()=>xV,createProgramHost:()=>bee,createPropertyNameNodeForIdentifierOrLiteral:()=>aB,createQueue:()=>Pu,createRange:()=>kd,createRedirectedBuilderProgram:()=>aee,createResolutionCache:()=>_ee,createRuntimeTypeSerializer:()=>k0e,createScanner:()=>E1,createSemanticDiagnosticsBuilderProgram:()=>s7e,createSet:()=>Ug,createSolutionBuilder:()=>b7e,createSolutionBuilderHost:()=>S7e,createSolutionBuilderWithWatch:()=>E7e,createSolutionBuilderWithWatchHost:()=>T7e,createSortedArray:()=>h1,createSourceFile:()=>KR,createSourceMapGenerator:()=>a0e,createSourceMapSource:()=>x3e,createSuperAccessVariableStatement:()=>uV,createSymbolTable:()=>ga,createSymlinkCache:()=>BX,createSystemWatchFunctions:()=>jfe,createTextChange:()=>e7,createTextChangeFromStartLength:()=>fJ,createTextChangeRange:()=>Y3,createTextRangeFromNode:()=>yte,createTextRangeFromSpan:()=>_J,createTextSpan:()=>e_,createTextSpanFromBounds:()=>Ll,createTextSpanFromNode:()=>gf,createTextSpanFromRange:()=>aS,createTextSpanFromStringLiteralLikeContent:()=>hte,createTextWriter:()=>Q8,createTokenRange:()=>NX,createTypeChecker:()=>e0e,createTypeReferenceDirectiveResolutionCache:()=>UU,createTypeReferenceResolutionLoader:()=>TV,createUnparsedSourceFile:()=>yK,createWatchCompilerHost:()=>h7e,createWatchCompilerHostOfConfigFile:()=>wye,createWatchCompilerHostOfFilesAndCompilerOptions:()=>Oye,createWatchFactory:()=>See,createWatchHost:()=>vee,createWatchProgram:()=>y7e,createWatchStatusReporter:()=>Pye,createWriteFileMeasuringIO:()=>FZ,declarationNameToString:()=>qo,decodeMappings:()=>aZ,decodedTextSpanIntersectsWith:()=>H3,decorateHelper:()=>xB,deduplicate:()=>Dh,defaultIncludeSpec:()=>MU,defaultInitCompilerOptions:()=>OU,defaultMaximumTruncationLength:()=>mR,detectSortCaseSensitivity:()=>Mb,diagnosticCategoryName:()=>R2,diagnosticToString:()=>Dx,directoryProbablyExists:()=>lg,directorySeparator:()=>hc,displayPart:()=>Yf,displayPartsToString:()=>D7,disposeEmitNodes:()=>bK,disposeResourcesHelper:()=>XB,documentSpansEqual:()=>Ate,dumpTracingLegend:()=>Mfe,elementAt:()=>T1,elideNodes:()=>rhe,emitComments:()=>Hde,emitDetachedComments:()=>Yde,emitFiles:()=>dV,emitFilesAndReportErrors:()=>LV,emitFilesAndReportErrorsAndGetExitStatus:()=>Iye,emitModuleKindIsNonNodeESM:()=>zj,emitNewLineBeforeLeadingCommentOfPosition:()=>Gde,emitNewLineBeforeLeadingComments:()=>$de,emitNewLineBeforeLeadingCommentsOfPosition:()=>Wde,emitSkippedWithNoDiagnostics:()=>NV,emitUsingBuildInfo:()=>K0e,emptyArray:()=>tt,emptyFileSystemEntries:()=>yB,emptyMap:()=>$5,emptyOptions:()=>Md,emptySet:()=>Cfe,endsWith:()=>Mc,ensurePathIsNonModuleName:()=>Lb,ensureScriptKind:()=>Zj,ensureTrailingDirectorySeparator:()=>hu,entityNameToString:()=>cp,enumerateInsertsAndDeletes:()=>q5,equalOwnProperties:()=>Kl,equateStringsCaseInsensitive:()=>S1,equateStringsCaseSensitive:()=>Av,equateValues:()=>Dm,esDecorateHelper:()=>kB,escapeJsxAttributeString:()=>mX,escapeLeadingUnderscores:()=>Pc,escapeNonAsciiString:()=>K8,escapeSnippetText:()=>sE,escapeString:()=>D0,escapeTemplateSubstitution:()=>pX,every:()=>yr,expandPreOrPostfixIncrementOrDecrementExpression:()=>dU,explainFiles:()=>dee,explainIfFileIsRedirectAndImpliedFormat:()=>mee,exportAssignmentIsAlias:()=>vN,exportStarHelper:()=>$B,expressionResultIsUnused:()=>Ume,extend:()=>Ml,extendsHelper:()=>MB,extensionFromPath:()=>h6,extensionIsTS:()=>rB,extensionsNotSupportingExtensionlessResolution:()=>SR,externalHelpersModuleNameText:()=>Gv,factory:()=>j,fileExtensionIs:()=>Uc,fileExtensionIsOneOf:()=>Ql,fileIncludeReasonToDiagnostics:()=>yee,fileShouldUseJavaScriptRequire:()=>Yte,filter:()=>Fn,filterMutate:()=>Nh,filterSemanticDiagnostics:()=>CV,find:()=>mr,findAncestor:()=>Gr,findBestPatternMatch:()=>AG,findChildOfKind:()=>Oo,findComputedPropertyNameCacheAssignment:()=>TU,findConfigFile:()=>eye,findContainingList:()=>nJ,findDiagnosticForNode:()=>G1e,findFirstNonJsxWhitespaceToken:()=>d1e,findIndex:()=>oa,findLast:()=>Da,findLastIndex:()=>no,findListItemInfo:()=>p1e,findMap:()=>Cf,findModifier:()=>xD,findNextToken:()=>AE,findPackageJson:()=>$1e,findPackageJsons:()=>Vte,findPrecedingMatchingToken:()=>lJ,findPrecedingToken:()=>tu,findSuperStatementIndexPath:()=>sV,findTokenOnLeftOfPosition:()=>aJ,findUseStrictPrologue:()=>ZK,first:()=>di,firstDefined:()=>Ct,firstDefinedIterator:()=>Kt,firstIterator:()=>Ja,firstOrOnly:()=>Wte,firstOrUndefined:()=>qi,firstOrUndefinedIterator:()=>Oa,fixupCompilerOptions:()=>hre,flatMap:()=>_a,flatMapIterator:()=>A2,flatMapToMutable:()=>bv,flatten:()=>ip,flattenCommaList:()=>she,flattenDestructuringAssignment:()=>Tx,flattenDestructuringBinding:()=>bE,flattenDiagnosticMessageText:()=>nh,forEach:()=>Te,forEachAncestor:()=>$pe,forEachAncestorDirectory:()=>Rm,forEachChild:()=>Qs,forEachChildRecursively:()=>Y6,forEachEmittedFile:()=>CZ,forEachEnclosingBlockScopeContainer:()=>ide,forEachEntry:()=>yu,forEachExternalModuleToImportFrom:()=>rre,forEachImportClauseDeclaration:()=>hj,forEachKey:()=>Mh,forEachLeadingCommentRange:()=>q3,forEachNameInAccessChainWalkingLeft:()=>gme,forEachPropertyAssignment:()=>lN,forEachResolvedProjectReference:()=>WZ,forEachReturnStatement:()=>$b,forEachRight:()=>ut,forEachTrailingCommentRange:()=>z3,forEachTsConfigPropArray:()=>b8,forEachUnique:()=>Pte,forEachYieldExpression:()=>ude,forSomeAncestorDirectory:()=>W4e,formatColorAndReset:()=>xE,formatDiagnostic:()=>BZ,formatDiagnostics:()=>UMe,formatDiagnosticsWithColorAndContext:()=>nye,formatGeneratedName:()=>NT,formatGeneratedNamePart:()=>eD,formatLocation:()=>UZ,formatMessage:()=>LX,formatStringFromArgs:()=>O0,formatting:()=>fu,fullTripleSlashAMDReferencePathRegEx:()=>tK,fullTripleSlashReferencePathRegEx:()=>eK,generateDjb2Hash:()=>Sw,generateTSConfig:()=>z8e,generatorHelper:()=>JB,getAdjustedReferenceLocation:()=>lte,getAdjustedRenameLocation:()=>sJ,getAliasDeclarationFromName:()=>rX,getAllAccessorDeclarations:()=>tx,getAllDecoratorsOfClass:()=>_Z,getAllDecoratorsOfClassElement:()=>oV,getAllJSDocTags:()=>E9,getAllJSDocTagsOfKind:()=>n4e,getAllKeys:()=>Vr,getAllProjectOutputs:()=>pV,getAllSuperTypeNodes:()=>Yw,getAllUnscopedEmitHelpers:()=>kK,getAllowJSCompilerOption:()=>Hv,getAllowSyntheticDefaultImports:()=>ix,getAncestor:()=>ST,getAnyExtensionFromPath:()=>qP,getAreDeclarationMapsEnabled:()=>hR,getAssignedExpandoInitializer:()=>EA,getAssignedName:()=>T9,getAssignedNameOfIdentifier:()=>lO,getAssignmentDeclarationKind:()=>al,getAssignmentDeclarationPropertyAccessKind:()=>R8,getAssignmentTargetKind:()=>kA,getAutomaticTypeDirectiveNames:()=>jU,getBaseFileName:()=>Cl,getBinaryOperatorPrecedence:()=>X8,getBuildInfo:()=>mV,getBuildInfoFileVersionMap:()=>see,getBuildInfoText:()=>X0e,getBuildOrderFromAnyBuildOrder:()=>VV,getBuilderCreationParameters:()=>DV,getBuilderFileEmit:()=>sS,getCheckFlags:()=>Vc,getClassExtendsHeritageElement:()=>Xb,getClassLikeDeclarationOfSymbol:()=>ky,getCombinedLocalAndExportSymbolFlags:()=>NN,getCombinedModifierFlags:()=>lT,getCombinedNodeFlags:()=>x1,getCombinedNodeFlagsAlwaysIncludeJSDoc:()=>XH,getCommentRange:()=>Qg,getCommonSourceDirectory:()=>gO,getCommonSourceDirectoryOfConfig:()=>_D,getCompilerOptionValue:()=>Wj,getCompilerOptionsDiffValue:()=>J8e,getConditions:()=>nS,getConfigFileParsingDiagnostics:()=>Ex,getConstantValue:()=>age,getContainerFlags:()=>HQ,getContainerNode:()=>Ax,getContainingClass:()=>Vu,getContainingClassExcludingClassDecorators:()=>nj,getContainingClassStaticBlock:()=>vde,getContainingFunction:()=>Vp,getContainingFunctionDeclaration:()=>yde,getContainingFunctionOrClassStaticBlock:()=>rj,getContainingNodeArray:()=>Vme,getContainingObjectLiteralElement:()=>I7,getContextualTypeFromParent:()=>EJ,getContextualTypeFromParentOrAncestorTypeNode:()=>iJ,getCurrentTime:()=>jM,getDeclarationDiagnostics:()=>G0e,getDeclarationEmitExtensionForPath:()=>Aj,getDeclarationEmitOutputFilePath:()=>Ude,getDeclarationEmitOutputFilePathWorker:()=>Cj,getDeclarationFileExtension:()=>lQ,getDeclarationFromName:()=>Hw,getDeclarationModifierFlagsFromSymbol:()=>Nd,getDeclarationOfKind:()=>xc,getDeclarationsOfKind:()=>Jpe,getDeclaredExpandoInitializer:()=>D8,getDecorators:()=>wv,getDefaultCompilerOptions:()=>_q,getDefaultExportInfoWorker:()=>UJ,getDefaultFormatCodeSettings:()=>YV,getDefaultLibFileName:()=>W3,getDefaultLibFilePath:()=>vSe,getDefaultLikeExportInfo:()=>BJ,getDiagnosticText:()=>w8e,getDiagnosticsWithinSpan:()=>H1e,getDirectoryPath:()=>hi,getDirectoryToWatchFailedLookupLocation:()=>uee,getDirectoryToWatchFailedLookupLocationFromTypeRoot:()=>Cye,getDocumentPositionMapper:()=>_re,getDocumentSpansEqualityComparer:()=>kte,getESModuleInterop:()=>Bh,getEditsForFileRename:()=>nve,getEffectiveBaseTypeNode:()=>$g,getEffectiveConstraintOfTypeParameter:()=>YP,getEffectiveContainerForJSDocTemplateTag:()=>yj,getEffectiveImplementsTypeNodes:()=>SN,getEffectiveInitializer:()=>N8,getEffectiveJSDocHost:()=>vT,getEffectiveModifierFlags:()=>X_,getEffectiveModifierFlagsAlwaysIncludeJSDoc:()=>Zde,getEffectiveModifierFlagsNoCache:()=>eme,getEffectiveReturnTypeNode:()=>lm,getEffectiveSetAccessorTypeAnnotationNode:()=>zde,getEffectiveTypeAnnotationNode:()=>t_,getEffectiveTypeParameterDeclarations:()=>Ov,getEffectiveTypeRoots:()=>tO,getElementOrPropertyAccessArgumentExpressionOrName:()=>gj,getElementOrPropertyAccessName:()=>xy,getElementsOfBindingOrAssignmentPattern:()=>ZN,getEmitDeclarations:()=>Dd,getEmitFlags:()=>eo,getEmitHelpers:()=>EB,getEmitModuleDetectionKind:()=>aK,getEmitModuleKind:()=>T_,getEmitModuleResolutionKind:()=>Q_,getEmitScriptTarget:()=>ho,getEmitStandardClassFields:()=>Cme,getEnclosingBlockScopeContainer:()=>Lh,getEnclosingContainer:()=>LY,getEncodedSemanticClassifications:()=>sre,getEncodedSyntacticClassifications:()=>are,getEndLinePosition:()=>d8,getEntityNameFromTypeNode:()=>C8,getEntrypointsFromPackageJsonInfo:()=>VQ,getErrorCountForSummary:()=>RV,getErrorSpanForNode:()=>z2,getErrorSummaryText:()=>Nye,getEscapedTextOfIdentifierOrLiteral:()=>Qw,getEscapedTextOfJsxAttributeName:()=>A6,getEscapedTextOfJsxNamespacedName:()=>FA,getExpandoInitializer:()=>hT,getExportAssignmentExpression:()=>nX,getExportInfoMap:()=>d7,getExportNeedsImportStarHelper:()=>_0e,getExpressionAssociativity:()=>uX,getExpressionPrecedence:()=>e6,getExternalHelpersModuleName:()=>zR,getExternalModuleImportEqualsDeclarationExpression:()=>$w,getExternalModuleName:()=>mN,getExternalModuleNameFromDeclaration:()=>jde,getExternalModuleNameFromPath:()=>hX,getExternalModuleNameLiteral:()=>ak,getExternalModuleRequireArgument:()=>zY,getFallbackOptions:()=>DM,getFileEmitOutput:()=>uye,getFileMatcherPatterns:()=>Qj,getFileNamesFromConfigSpecs:()=>Q6,getFileWatcherEventKind:()=>LH,getFilesInErrorForSummary:()=>MV,getFirstConstructorWithBody:()=>I0,getFirstIdentifier:()=>Jp,getFirstNonSpaceCharacterPosition:()=>B1e,getFirstProjectOutput:()=>PZ,getFixableErrorSpanExpression:()=>zte,getFormatCodeSettingsForWriting:()=>MJ,getFullWidth:()=>f8,getFunctionFlags:()=>vu,getHeritageClause:()=>W8,getHostSignatureFromJSDoc:()=>yT,getIdentifierAutoGenerate:()=>N3e,getIdentifierGeneratedImportReference:()=>fge,getIdentifierTypeArguments:()=>sx,getImmediatelyInvokedFunctionExpression:()=>W2,getImpliedNodeFormatForFile:()=>RM,getImpliedNodeFormatForFileWorker:()=>YZ,getImportNeedsImportDefaultHelper:()=>cZ,getImportNeedsImportStarHelper:()=>nV,getIndentSize:()=>CN,getIndentString:()=>Ej,getInferredLibraryNameResolveFrom:()=>EV,getInitializedVariables:()=>u6,getInitializerOfBinaryExpression:()=>YY,getInitializerOfBindingOrAssignmentElement:()=>WR,getInterfaceBaseTypeNodes:()=>Xw,getInternalEmitFlags:()=>Lm,getInvokedExpression:()=>aj,getIsolatedModules:()=>fm,getJSDocAugmentsTag:()=>_pe,getJSDocClassTag:()=>QH,getJSDocCommentRanges:()=>BY,getJSDocCommentsAndTags:()=>KY,getJSDocDeprecatedTag:()=>ZH,getJSDocDeprecatedTagNoCache:()=>ype,getJSDocEnumTag:()=>eY,getJSDocHost:()=>X2,getJSDocImplementsTags:()=>fpe,getJSDocOverloadTags:()=>ZY,getJSDocOverrideTagNoCache:()=>hpe,getJSDocParameterTags:()=>HP,getJSDocParameterTagsNoCache:()=>ope,getJSDocPrivateTag:()=>QOe,getJSDocPrivateTagNoCache:()=>dpe,getJSDocProtectedTag:()=>ZOe,getJSDocProtectedTagNoCache:()=>mpe,getJSDocPublicTag:()=>KOe,getJSDocPublicTagNoCache:()=>ppe,getJSDocReadonlyTag:()=>e4e,getJSDocReadonlyTagNoCache:()=>gpe,getJSDocReturnTag:()=>vpe,getJSDocReturnType:()=>K3,getJSDocRoot:()=>yN,getJSDocSatisfiesExpressionType:()=>KX,getJSDocSatisfiesTag:()=>tY,getJSDocTags:()=>pT,getJSDocTagsNoCache:()=>r4e,getJSDocTemplateTag:()=>t4e,getJSDocThisTag:()=>b9,getJSDocType:()=>fT,getJSDocTypeAliasName:()=>rQ,getJSDocTypeAssertionType:()=>gU,getJSDocTypeParameterDeclarations:()=>Dj,getJSDocTypeParameterTags:()=>cpe,getJSDocTypeParameterTagsNoCache:()=>lpe,getJSDocTypeTag:()=>_T,getJSXImplicitImportBase:()=>Hj,getJSXRuntimeImport:()=>Yj,getJSXTransformEnabled:()=>Gj,getKeyForCompilerOptions:()=>MQ,getLanguageVariant:()=>sR,getLastChild:()=>OX,getLeadingCommentRanges:()=>T0,getLeadingCommentRangesOfNode:()=>jY,getLeftmostAccessExpression:()=>DN,getLeftmostExpression:()=>IN,getLibraryNameFromLibFileName:()=>GZ,getLineAndCharacterOfPosition:()=>Lo,getLineInfo:()=>iZ,getLineOfLocalPosition:()=>r6,getLineOfLocalPositionFromLineMap:()=>Z2,getLineStartPositionForPosition:()=>mm,getLineStarts:()=>vy,getLinesBetweenPositionAndNextNonWhitespaceCharacter:()=>fme,getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter:()=>_me,getLinesBetweenPositions:()=>xw,getLinesBetweenRangeEndAndRangeStart:()=>DX,getLinesBetweenRangeEndPositions:()=>z4e,getLiteralText:()=>Kpe,getLocalNameForExternalImport:()=>QN,getLocalSymbolForExportDefault:()=>PN,getLocaleSpecificMessage:()=>Gs,getLocaleTimeString:()=>FM,getMappedContextSpan:()=>Nte,getMappedDocumentSpan:()=>vJ,getMappedLocation:()=>kO,getMatchedFileSpec:()=>gee,getMatchedIncludeSpec:()=>hee,getMeaningFromDeclaration:()=>zM,getMeaningFromLocation:()=>Cx,getMembersOfDeclaration:()=>_de,getModeForFileReference:()=>wM,getModeForResolutionAtIndex:()=>iye,getModeForUsageLocation:()=>JZ,getModifiedTime:()=>fA,getModifiers:()=>jb,getModuleInstanceState:()=>Oy,getModuleNameStringLiteralAt:()=>MM,getModuleSpecifierEndingPreference:()=>wme,getModuleSpecifierResolverHost:()=>bte,getNameForExportedSymbol:()=>wJ,getNameFromImportAttribute:()=>uB,getNameFromIndexInfo:()=>sde,getNameFromPropertyName:()=>n7,getNameOfAccessExpression:()=>MX,getNameOfCompilerOptionValue:()=>SQ,getNameOfDeclaration:()=>qs,getNameOfExpando:()=>GY,getNameOfJSDocTypedef:()=>ape,getNameOrArgument:()=>O8,getNameTable:()=>Kre,getNamesForExportedSymbol:()=>Y1e,getNamespaceDeclarationNode:()=>gN,getNewLineCharacter:()=>w1,getNewLineKind:()=>p7,getNewLineOrDefaultFromHost:()=>q1,getNewTargetContainer:()=>Tde,getNextJSDocCommentLocation:()=>QY,getNodeForGeneratedName:()=>HR,getNodeId:()=>yo,getNodeKind:()=>CE,getNodeModifiers:()=>xO,getNodeModulePathParts:()=>oB,getNonAssignedNameOfDeclaration:()=>S9,getNonAssignmentOperatorForCompoundAssignment:()=>aO,getNonAugmentationDeclaration:()=>DY,getNonDecoratorTokenPosOfNode:()=>CY,getNormalizedAbsolutePath:()=>Ps,getNormalizedAbsolutePathWithoutRoot:()=>JH,getNormalizedPathComponents:()=>L3,getObjectFlags:()=>Gn,getOperator:()=>fX,getOperatorAssociativity:()=>_X,getOperatorPrecedence:()=>Y8,getOptionFromName:()=>gQ,getOptionsForLibraryResolution:()=>FQ,getOptionsNameMap:()=>rD,getOrCreateEmitNode:()=>b_,getOrCreateExternalHelpersModuleNameIfNeeded:()=>Gge,getOrUpdate:()=>km,getOriginalNode:()=>Hc,getOriginalNodeId:()=>E_,getOriginalSourceFile:()=>R4e,getOutputDeclarationFileName:()=>mO,getOutputDeclarationFileNameWorker:()=>AZ,getOutputExtension:()=>fV,getOutputFileNames:()=>jMe,getOutputJSFileNameWorker:()=>kZ,getOutputPathsFor:()=>dO,getOutputPathsForBundle:()=>pO,getOwnEmitOutputFilePath:()=>Bde,getOwnKeys:()=>Vt,getOwnValues:()=>Mn,getPackageJsonInfo:()=>yE,getPackageJsonTypesVersionsPaths:()=>FU,getPackageJsonsVisibleToFile:()=>W1e,getPackageNameFromTypesPackageName:()=>nO,getPackageScopeForPath:()=>dM,getParameterSymbolFromJSDoc:()=>V8,getParameterTypeNode:()=>t3e,getParentNodeInSpan:()=>s7,getParseTreeNode:()=>Us,getParsedCommandLineOfConfigFile:()=>ZR,getPathComponents:()=>gu,getPathComponentsRelativeTo:()=>zH,getPathFromPathComponents:()=>Nv,getPathUpdater:()=>lre,getPathsBasePath:()=>kj,getPatternFromSpec:()=>Nme,getPendingEmitKind:()=>gD,getPositionOfLineAndCharacter:()=>V3,getPossibleGenericSignatures:()=>_te,getPossibleOriginalInputExtensionForExtension:()=>Vde,getPossibleTypeArgumentsInfo:()=>fte,getPreEmitDiagnostics:()=>BMe,getPrecedingNonSpaceCharacterPosition:()=>TJ,getPrivateIdentifier:()=>fZ,getProperties:()=>uZ,getProperty:()=>Ar,getPropertyArrayElementValue:()=>hde,getPropertyAssignmentAliasLikeExpression:()=>Rde,getPropertyNameForPropertyNameNode:()=>K2,getPropertyNameForUniqueESSymbol:()=>w4e,getPropertyNameFromType:()=>_m,getPropertyNameOfBindingOrAssignmentElement:()=>tQ,getPropertySymbolFromBindingElement:()=>yJ,getPropertySymbolsFromContextualType:()=>pq,getQuoteFromPreference:()=>xte,getQuotePreference:()=>_d,getRangesWhere:()=>Ev,getRefactorContextSpan:()=>Sk,getReferencedFileLocation:()=>hO,getRegexFromPattern:()=>$v,getRegularExpressionForWildcard:()=>d6,getRegularExpressionsForWildcards:()=>Xj,getRelativePathFromDirectory:()=>Om,getRelativePathFromFile:()=>j3,getRelativePathToDirectoryOrUrl:()=>dA,getRenameLocation:()=>c7,getReplacementSpanForContextToken:()=>gte,getResolutionDiagnostic:()=>QZ,getResolutionModeOverride:()=>fD,getResolveJsonModule:()=>xT,getResolvePackageJsonExports:()=>mB,getResolvePackageJsonImports:()=>gB,getResolvedExternalModuleName:()=>xj,getRestIndicatorOfBindingOrAssignmentElement:()=>yU,getRestParameterElementType:()=>UY,getRightMostAssignedExpression:()=>I8,getRootDeclaration:()=>Gg,getRootDirectoryOfResolutionCache:()=>Aye,getRootLength:()=>wh,getRootPathSplitLength:()=>u7e,getScriptKind:()=>Rte,getScriptKindFromFileName:()=>eB,getScriptTargetFeatures:()=>pB,getSelectedEffectiveModifierFlags:()=>DA,getSelectedSyntacticModifierFlags:()=>Kde,getSemanticClassifications:()=>Z1e,getSemanticJsxChildren:()=>bN,getSetAccessorTypeAnnotationNode:()=>Jde,getSetAccessorValueParameter:()=>n6,getSetExternalModuleIndicator:()=>aR,getShebang:()=>h9,getSingleInitializerOfVariableStatementOrPropertyDeclaration:()=>XY,getSingleVariableOfVariableStatement:()=>AA,getSnapshotText:()=>ED,getSnippetElement:()=>EK,getSourceFileOfModule:()=>J9,getSourceFileOfNode:()=>Xr,getSourceFilePathInNewDir:()=>Pj,getSourceFilePathInNewDirWorker:()=>Nj,getSourceFileVersionAsHashFromText:()=>FV,getSourceFilesToEmit:()=>yX,getSourceMapRange:()=>R1,getSourceMapper:()=>mve,getSourceTextOfNodeFromSourceFile:()=>Jb,getSpanOfTokenAtPosition:()=>Fh,getSpellingSuggestion:()=>FP,getStartPositionOfLine:()=>Uv,getStartPositionOfRange:()=>l6,getStartsOnNewLine:()=>I6,getStaticPropertiesAndClassStaticBlock:()=>aV,getStrictOptionValue:()=>K_,getStringComparer:()=>gy,getSubPatternFromSpec:()=>Kj,getSuperCallFromStatement:()=>iV,getSuperContainer:()=>E8,getSupportedCodeFixes:()=>Yre,getSupportedExtensions:()=>m6,getSupportedExtensionsWithJsonIfResolveJsonModule:()=>oR,getSwitchedType:()=>Bte,getSymbolId:()=>Ia,getSymbolNameForPrivateIdentifier:()=>G8,getSymbolTarget:()=>Mte,getSyntacticClassifications:()=>eve,getSyntacticModifierFlags:()=>qv,getSyntacticModifierFlagsNoCache:()=>bX,getSynthesizedDeepClone:()=>Sc,getSynthesizedDeepCloneWithReplacements:()=>o7,getSynthesizedDeepClones:()=>kE,getSynthesizedDeepClonesWithReplacements:()=>Lte,getSyntheticLeadingComments:()=>BN,getSyntheticTrailingComments:()=>AR,getTargetLabel:()=>ZV,getTargetOfBindingOrAssignmentElement:()=>rS,getTemporaryModuleResolutionState:()=>pM,getTextOfConstantValue:()=>Qpe,getTextOfIdentifierOrLiteral:()=>om,getTextOfJSDocComment:()=>Z3,getTextOfJsxAttributeName:()=>dR,getTextOfJsxNamespacedName:()=>k6,getTextOfNode:()=>Fl,getTextOfNodeFromSourceText:()=>Bw,getTextOfPropertyName:()=>iN,getThisContainer:()=>kf,getThisParameter:()=>Qb,getTokenAtPosition:()=>Ts,getTokenPosOfNode:()=>mT,getTokenSourceMapRange:()=>k3e,getTouchingPropertyName:()=>If,getTouchingToken:()=>bD,getTrailingCommentRanges:()=>aT,getTrailingSemicolonDeferringWriter:()=>gX,getTransformFlagsSubtreeExclusions:()=>tge,getTransformers:()=>EZ,getTsBuildInfoEmitOutputFilePath:()=>B1,getTsConfigObjectLiteralExpression:()=>qw,getTsConfigPropArrayElementValue:()=>tj,getTypeAnnotationNode:()=>qde,getTypeArgumentOrTypeParameterList:()=>b1e,getTypeKeywordOfTypeOnlyImport:()=>Cte,getTypeNode:()=>uge,getTypeNodeIfAccessible:()=>wO,getTypeParameterFromJsDoc:()=>Pde,getTypeParameterOwner:()=>WOe,getTypesPackageName:()=>zU,getUILocale:()=>oA,getUniqueName:()=>Nx,getUniqueSymbolId:()=>j1e,getUseDefineForClassFields:()=>D6,getWatchErrorSummaryDiagnosticMessage:()=>fee,getWatchFactory:()=>OZ,group:()=>m_,groupBy:()=>Jf,guessIndentation:()=>Upe,handleNoEmitOptions:()=>XZ,hasAbstractModifier:()=>tE,hasAccessorModifier:()=>Hg,hasAmbientModifier:()=>TX,hasChangesInResolutions:()=>bY,hasChildOfKind:()=>KM,hasContextSensitiveParameters:()=>sB,hasDecorators:()=>Ad,hasDocComment:()=>S1e,hasDynamicName:()=>Jv,hasEffectiveModifier:()=>up,hasEffectiveModifiers:()=>Ij,hasEffectiveReadonlyModifier:()=>i6,hasExtension:()=>pA,hasIndexSignature:()=>jte,hasInitializer:()=>jv,hasInvalidEscape:()=>dX,hasJSDocNodes:()=>jp,hasJSDocParameterTags:()=>upe,hasJSFileExtension:()=>rE,hasJsonModuleEmitEnabled:()=>$j,hasOnlyExpressionInitializer:()=>V2,hasOverrideModifier:()=>wj,hasPossibleExternalModuleReference:()=>nde,hasProperty:()=>wo,hasPropertyAccessExpressionWithName:()=>WM,hasQuestionToken:()=>CA,hasRecordedExternalHelpers:()=>Wge,hasResolutionModeOverride:()=>Wme,hasRestParameter:()=>yY,hasScopeMarker:()=>wpe,hasStaticModifier:()=>jl,hasSyntacticModifier:()=>ui,hasSyntacticModifiers:()=>Xde,hasTSFileExtension:()=>LA,hasTabstop:()=>qme,hasTrailingDirectorySeparator:()=>b1,hasType:()=>L9,hasTypeArguments:()=>k4e,hasZeroOrOneAsteriskCharacter:()=>jX,helperString:()=>AK,hostGetCanonicalFileName:()=>N1,hostUsesCaseSensitiveFileNames:()=>AN,idText:()=>Nn,identifierIsThisKeyword:()=>SX,identifierToKeywordKind:()=>uT,identity:()=>Mo,identitySourceMapConsumer:()=>rV,ignoreSourceNewlines:()=>CK,ignoredPaths:()=>M3,importDefaultHelper:()=>zB,importFromModuleSpecifier:()=>Gw,importNameElisionDisabled:()=>FX,importStarHelper:()=>PR,indexOfAnyCharCode:()=>v0,indexOfNode:()=>nN,indicesOf:()=>tT,inferredTypesContainingFile:()=>mD,injectClassNamedEvaluationHelperBlockIfMissing:()=>lV,injectClassThisAssignmentIfMissing:()=>T0e,insertImports:()=>AO,insertLeadingStatement:()=>W3e,insertSorted:()=>lf,insertStatementAfterCustomPrologue:()=>J2,insertStatementAfterStandardPrologue:()=>h4e,insertStatementsAfterCustomPrologue:()=>EY,insertStatementsAfterStandardPrologue:()=>C0,intersperse:()=>zn,intrinsicTagNameToString:()=>QX,introducesArgumentsExoticObject:()=>mde,inverseJsxOptionMap:()=>Z6,isAbstractConstructorSymbol:()=>pme,isAbstractModifier:()=>Sge,isAccessExpression:()=>Yo,isAccessibilityModifier:()=>dte,isAccessor:()=>Mv,isAccessorModifier:()=>bge,isAliasSymbolDeclaration:()=>N4e,isAliasableExpression:()=>$8,isAmbientModule:()=>S_,isAmbientPropertyDeclaration:()=>wY,isAnonymousFunctionDefinition:()=>Zw,isAnyDirectorySeparator:()=>BH,isAnyImportOrBareOrAccessedRequire:()=>rde,isAnyImportOrReExport:()=>g8,isAnyImportSyntax:()=>q2,isAnySupportedFileExtension:()=>e3e,isApplicableVersionedTypesKey:()=>gM,isArgumentExpressionOfElementAccess:()=>nte,isArray:()=>os,isArrayBindingElement:()=>D9,isArrayBindingOrAssignmentElement:()=>a8,isArrayBindingOrAssignmentPattern:()=>fY,isArrayBindingPattern:()=>cE,isArrayLiteralExpression:()=>Z_,isArrayLiteralOrObjectLiteralDestructuringPattern:()=>V1,isArrayTypeNode:()=>MR,isArrowFunction:()=>rc,isAsExpression:()=>FR,isAssertClause:()=>Nge,isAssertEntry:()=>j3e,isAssertionExpression:()=>U2,isAssertsKeyword:()=>yge,isAssignmentDeclaration:()=>Ww,isAssignmentExpression:()=>lu,isAssignmentOperator:()=>D1,isAssignmentPattern:()=>Lw,isAssignmentTarget:()=>N0,isAsteriskToken:()=>IR,isAsyncFunction:()=>Kw,isAsyncModifier:()=>R6,isAutoAccessorPropertyDeclaration:()=>Af,isAwaitExpression:()=>Zv,isAwaitKeyword:()=>OK,isBigIntLiteral:()=>KB,isBinaryExpression:()=>bn,isBinaryOperatorToken:()=>the,isBindableObjectDefinePropertyCall:()=>H2,isBindableStaticAccessExpression:()=>Hb,isBindableStaticElementAccessExpression:()=>mj,isBindableStaticNameExpression:()=>Y2,isBindingElement:()=>co,isBindingElementOfBareOrAccessedRequire:()=>xde,isBindingName:()=>j2,isBindingOrAssignmentElement:()=>Ape,isBindingOrAssignmentPattern:()=>i8,isBindingPattern:()=>la,isBlock:()=>ra,isBlockOrCatchScoped:()=>AY,isBlockScope:()=>OY,isBlockScopedContainerTopLevel:()=>tde,isBooleanLiteral:()=>Mw,isBreakOrContinueStatement:()=>Iw,isBreakStatement:()=>M3e,isBuildInfoFile:()=>Y0e,isBuilderProgram:()=>Dye,isBundle:()=>UK,isBundleFileTextLike:()=>mme,isCallChain:()=>L2,isCallExpression:()=>da,isCallExpressionTarget:()=>Kee,isCallLikeExpression:()=>Vb,isCallLikeOrFunctionLikeExpression:()=>pY,isCallOrNewExpression:()=>Jg,isCallOrNewExpressionTarget:()=>Qee,isCallSignatureDeclaration:()=>HA,isCallToHelper:()=>O6,isCaseBlock:()=>V6,isCaseClause:()=>WN,isCaseKeyword:()=>Ege,isCaseOrDefaultClause:()=>R9,isCatchClause:()=>mE,isCatchClauseVariableDeclaration:()=>Jme,isCatchClauseVariableDeclarationOrBindingElement:()=>kY,isCheckJsEnabledForFile:()=>uR,isChildOfNodeWithKind:()=>v4e,isCircularBuildOrder:()=>mk,isClassDeclaration:()=>eu,isClassElement:()=>Du,isClassExpression:()=>wu,isClassInstanceProperty:()=>xpe,isClassLike:()=>Ti,isClassMemberModifier:()=>lY,isClassNamedEvaluationHelperBlock:()=>dk,isClassOrTypeElement:()=>N9,isClassStaticBlockDeclaration:()=>Jc,isClassThisAssignmentBlock:()=>cO,isCollapsedRange:()=>q4e,isColonToken:()=>gge,isCommaExpression:()=>qR,isCommaListExpression:()=>j6,isCommaSequence:()=>W6,isCommaToken:()=>mge,isComment:()=>uJ,isCommonJsExportPropertyAssignment:()=>Z9,isCommonJsExportedExpression:()=>pde,isCompoundAssignment:()=>sO,isComputedNonLiteralName:()=>h8,isComputedPropertyName:()=>uo,isConciseBody:()=>w9,isConditionalExpression:()=>$N,isConditionalTypeNode:()=>QA,isConstTypeReference:()=>Ty,isConstructSignatureDeclaration:()=>OR,isConstructorDeclaration:()=>Yc,isConstructorTypeNode:()=>VN,isContextualKeyword:()=>Sj,isContinueStatement:()=>R3e,isCustomPrologue:()=>T8,isDebuggerStatement:()=>L3e,isDeclaration:()=>O_,isDeclarationBindingElement:()=>n8,isDeclarationFileName:()=>i_,isDeclarationName:()=>Cy,isDeclarationNameOfEnumOrNamespace:()=>IX,isDeclarationReadonly:()=>Y9,isDeclarationStatement:()=>Lpe,isDeclarationWithTypeParameterChildren:()=>MY,isDeclarationWithTypeParameters:()=>RY,isDecorator:()=>n_,isDecoratorTarget:()=>o1e,isDefaultClause:()=>q6,isDefaultImport:()=>xA,isDefaultModifier:()=>tU,isDefaultedExpandoInitializer:()=>Cde,isDeleteExpression:()=>Age,isDeleteTarget:()=>tX,isDeprecatedDeclaration:()=>OJ,isDestructuringAssignment:()=>I1,isDiagnosticWithLocation:()=>qte,isDiskPathRoot:()=>UH,isDoStatement:()=>w3e,isDocumentRegistryEntry:()=>m7,isDotDotDotToken:()=>ZB,isDottedName:()=>a6,isDynamicName:()=>bj,isESSymbolIdentifier:()=>O4e,isEffectiveExternalModule:()=>bA,isEffectiveModuleDeclaration:()=>ede,isEffectiveStrictModeSourceFile:()=>IY,isElementAccessChain:()=>rY,isElementAccessExpression:()=>fc,isEmittedFileOfProgram:()=>Z0e,isEmptyArrayLiteral:()=>ime,isEmptyBindingElement:()=>ipe,isEmptyBindingPattern:()=>npe,isEmptyObjectLiteral:()=>kX,isEmptyStatement:()=>FK,isEmptyStringLiteral:()=>qY,isEntityName:()=>zf,isEntityNameExpression:()=>ol,isEnumConst:()=>zb,isEnumDeclaration:()=>AT,isEnumMember:()=>gE,isEqualityOperatorKind:()=>xJ,isEqualsGreaterThanToken:()=>hge,isExclamationToken:()=>wR,isExcludedFile:()=>mhe,isExclusivelyTypeOnlyImportOrExport:()=>VZ,isExpandoPropertyDeclaration:()=>lB,isExportAssignment:()=>Kc,isExportDeclaration:()=>yl,isExportModifier:()=>WA,isExportName:()=>mU,isExportNamespaceAsDefaultDeclaration:()=>$9,isExportOrDefaultModifier:()=>GR,isExportSpecifier:()=>R_,isExportsIdentifier:()=>G2,isExportsOrModuleExportsOrAlias:()=>vE,isExpression:()=>bt,isExpressionNode:()=>k0,isExpressionOfExternalModuleImportEqualsDeclaration:()=>_1e,isExpressionOfOptionalChainRoot:()=>A9,isExpressionStatement:()=>Ou,isExpressionWithTypeArguments:()=>L1,isExpressionWithTypeArgumentsInClassExtendsClause:()=>Oj,isExternalModule:()=>Pl,isExternalModuleAugmentation:()=>qb,isExternalModuleImportEqualsDeclaration:()=>gT,isExternalModuleIndicator:()=>o8,isExternalModuleNameRelative:()=>Nu,isExternalModuleReference:()=>zh,isExternalModuleSymbol:()=>t7,isExternalOrCommonJsModule:()=>Bp,isFileLevelReservedGeneratedIdentifier:()=>r8,isFileLevelUniqueName:()=>q9,isFileProbablyExternalModule:()=>XR,isFirstDeclarationOfSymbolParameter:()=>Dte,isFixablePromiseHandler:()=>dre,isForInOrOfStatement:()=>QP,isForInStatement:()=>oU,isForInitializer:()=>Cd,isForOfStatement:()=>jR,isForStatement:()=>_x,isFunctionBlock:()=>Wb,isFunctionBody:()=>mY,isFunctionDeclaration:()=>Zl,isFunctionExpression:()=>Xo,isFunctionExpressionOrArrowFunction:()=>iE,isFunctionLike:()=>ca,isFunctionLikeDeclaration:()=>tc,isFunctionLikeKind:()=>yA,isFunctionLikeOrClassStaticBlockDeclaration:()=>KP,isFunctionOrConstructorTypeNode:()=>Cpe,isFunctionOrModuleBlock:()=>uY,isFunctionSymbol:()=>kde,isFunctionTypeNode:()=>Vh,isFutureReservedKeyword:()=>D4e,isGeneratedIdentifier:()=>yc,isGeneratedPrivateIdentifier:()=>F2,isGetAccessor:()=>Fv,isGetAccessorDeclaration:()=>sd,isGetOrSetAccessorDeclaration:()=>x9,isGlobalDeclaration:()=>yLe,isGlobalScopeAugmentation:()=>zg,isGrammarError:()=>Ype,isHeritageClause:()=>ad,isHoistedFunction:()=>K9,isHoistedVariableStatement:()=>Q9,isIdentifier:()=>ze,isIdentifierANonContextualKeyword:()=>aX,isIdentifierName:()=>Ode,isIdentifierOrThisTypeNode:()=>Kge,isIdentifierPart:()=>oT,isIdentifierStart:()=>b0,isIdentifierText:()=>nd,isIdentifierTypePredicate:()=>gde,isIdentifierTypeReference:()=>Fme,isIfStatement:()=>ux,isIgnoredFileFromWildCardWatching:()=>NM,isImplicitGlob:()=>VX,isImportAttribute:()=>Dge,isImportAttributeName:()=>Epe,isImportAttributes:()=>tk,isImportCall:()=>Up,isImportClause:()=>Jh,isImportDeclaration:()=>uu,isImportEqualsDeclaration:()=>Ru,isImportKeyword:()=>L6,isImportMeta:()=>oN,isImportOrExportSpecifier:()=>hA,isImportOrExportSpecifierName:()=>F1e,isImportSpecifier:()=>Gf,isImportTypeAssertionContainer:()=>F3e,isImportTypeNode:()=>M0,isImportableFile:()=>tre,isInComment:()=>U1,isInCompoundLikeAssignment:()=>eX,isInExpressionContext:()=>cj,isInJSDoc:()=>k8,isInJSFile:()=>gn,isInJSXText:()=>y1e,isInJsonFile:()=>uj,isInNonReferenceComment:()=>C1e,isInReferenceComment:()=>x1e,isInRightSideOfInternalImportEqualsDeclaration:()=>KV,isInString:()=>hk,isInTemplateString:()=>ute,isInTopLevelContext:()=>ij,isInTypeQuery:()=>ex,isIncrementalCompilation:()=>N6,isIndexSignatureDeclaration:()=>oE,isIndexedAccessTypeNode:()=>lx,isInferTypeNode:()=>ax,isInfinityOrNaNString:()=>E6,isInitializedProperty:()=>bM,isInitializedVariable:()=>iR,isInsideJsxElement:()=>cJ,isInsideJsxElementOrAttribute:()=>h1e,isInsideNodeModules:()=>f7,isInsideTemplateLiteral:()=>ZM,isInstanceOfExpression:()=>Rj,isInstantiatedModule:()=>QQ,isInterfaceDeclaration:()=>ef,isInternalDeclaration:()=>vY,isInternalModuleImportEqualsDeclaration:()=>fN,isInternalName:()=>QK,isIntersectionTypeNode:()=>KA,isIntrinsicJsxName:()=>xN,isIterationStatement:()=>Lv,isJSDoc:()=>dg,isJSDocAllType:()=>Mge,isJSDocAugmentsTag:()=>sk,isJSDocAuthorTag:()=>J3e,isJSDocCallbackTag:()=>JK,isJSDocClassTag:()=>Fge,isJSDocCommentContainingNode:()=>M9,isJSDocConstructSignature:()=>hN,isJSDocDeprecatedTag:()=>GK,isJSDocEnumTag:()=>UR,isJSDocFunctionType:()=>HN,isJSDocImplementsTag:()=>fU,isJSDocIndexSignature:()=>_j,isJSDocLikeText:()=>oQ,isJSDocLink:()=>Oge,isJSDocLinkCode:()=>Rge,isJSDocLinkLike:()=>TA,isJSDocLinkPlain:()=>U3e,isJSDocMemberName:()=>kT,isJSDocNameReference:()=>z6,isJSDocNamepathType:()=>V3e,isJSDocNamespaceBody:()=>_4e,isJSDocNode:()=>ZP,isJSDocNonNullableType:()=>cU,isJSDocNullableType:()=>GN,isJSDocOptionalParameter:()=>pR,isJSDocOptionalType:()=>VK,isJSDocOverloadTag:()=>YN,isJSDocOverrideTag:()=>uU,isJSDocParameterTag:()=>mg,isJSDocPrivateTag:()=>zK,isJSDocPropertyLikeTag:()=>ww,isJSDocPropertyTag:()=>jge,isJSDocProtectedTag:()=>$K,isJSDocPublicTag:()=>qK,isJSDocReadonlyTag:()=>WK,isJSDocReturnTag:()=>_U,isJSDocSatisfiesExpression:()=>XX,isJSDocSatisfiesTag:()=>pU,isJSDocSeeTag:()=>q3e,isJSDocSignature:()=>PT,isJSDocTag:()=>eN,isJSDocTemplateTag:()=>dm,isJSDocThisTag:()=>HK,isJSDocThrowsTag:()=>$3e,isJSDocTypeAlias:()=>am,isJSDocTypeAssertion:()=>KN,isJSDocTypeExpression:()=>hE,isJSDocTypeLiteral:()=>mx,isJSDocTypeTag:()=>$6,isJSDocTypedefTag:()=>gx,isJSDocUnknownTag:()=>z3e,isJSDocUnknownType:()=>Lge,isJSDocVariadicType:()=>lU,isJSXTagName:()=>_N,isJsonEqual:()=>nB,isJsonSourceFile:()=>sm,isJsxAttribute:()=>th,isJsxAttributeLike:()=>O9,isJsxAttributeName:()=>$me,isJsxAttributes:()=>dE,isJsxChild:()=>u8,isJsxClosingElement:()=>fE,isJsxClosingFragment:()=>Ige,isJsxElement:()=>L0,isJsxExpression:()=>J6,isJsxFragment:()=>pE,isJsxNamespacedName:()=>pg,isJsxOpeningElement:()=>eh,isJsxOpeningFragment:()=>nk,isJsxOpeningLikeElement:()=>H_,isJsxOpeningLikeElementTagName:()=>c1e,isJsxSelfClosingElement:()=>px,isJsxSpreadAttribute:()=>ik,isJsxTagNameExpression:()=>Fw,isJsxText:()=>qA,isJumpStatementTarget:()=>GM,isKeyword:()=>Nf,isKeywordOrPunctuation:()=>vj,isKnownSymbol:()=>H8,isLabelName:()=>tte,isLabelOfLabeledStatement:()=>ete,isLabeledStatement:()=>_E,isLateVisibilityPaintedStatement:()=>G9,isLeftHandSideExpression:()=>$f,isLeftHandSideOfAssignment:()=>J4e,isLet:()=>X9,isLineBreak:()=>I_,isLiteralComputedPropertyDeclarationName:()=>z8,isLiteralExpression:()=>Ub,isLiteralExpressionOfObject:()=>oY,isLiteralImportTypeNode:()=>Vv,isLiteralKind:()=>Ow,isLiteralLikeAccess:()=>dj,isLiteralLikeElementAccess:()=>w8,isLiteralNameOfPropertyDeclarationOrIndexAccess:()=>eJ,isLiteralTypeLikeExpression:()=>K3e,isLiteralTypeLiteral:()=>Dpe,isLiteralTypeNode:()=>Qv,isLocalName:()=>Iy,isLogicalOperator:()=>tme,isLogicalOrCoalescingAssignmentExpression:()=>EX,isLogicalOrCoalescingAssignmentOperator:()=>s6,isLogicalOrCoalescingBinaryExpression:()=>eR,isLogicalOrCoalescingBinaryOperator:()=>Z8,isMappedTypeNode:()=>qN,isMemberName:()=>E0,isMetaProperty:()=>F6,isMethodDeclaration:()=>pl,isMethodOrAccessor:()=>vA,isMethodSignature:()=>Uh,isMinusToken:()=>wK,isMissingDeclaration:()=>B3e,isMissingPackageJsonInfo:()=>whe,isModifier:()=>Ra,isModifierKind:()=>C1,isModifierLike:()=>vc,isModuleAugmentationExternal:()=>NY,isModuleBlock:()=>Zg,isModuleBody:()=>Ope,isModuleDeclaration:()=>hl,isModuleExportsAccessExpression:()=>P0,isModuleIdentifier:()=>HY,isModuleName:()=>ehe,isModuleOrEnumDeclaration:()=>c8,isModuleReference:()=>jpe,isModuleSpecifierLike:()=>hJ,isModuleWithStringLiteralName:()=>W9,isNameOfFunctionDeclaration:()=>ste,isNameOfModuleDeclaration:()=>ite,isNamedClassElement:()=>a4e,isNamedDeclaration:()=>W_,isNamedEvaluation:()=>lp,isNamedEvaluationSource:()=>oX,isNamedExportBindings:()=>iY,isNamedExports:()=>wd,isNamedImportBindings:()=>gY,isNamedImports:()=>Dy,isNamedImportsOrExports:()=>Vj,isNamedTupleMember:()=>JN,isNamespaceBody:()=>u4e,isNamespaceExport:()=>qh,isNamespaceExportDeclaration:()=>BR,isNamespaceImport:()=>tS,isNamespaceReexportDeclaration:()=>Ede,isNewExpression:()=>lE,isNewExpressionTarget:()=>bO,isNoSubstitutionTemplateLiteral:()=>zA,isNode:()=>i4e,isNodeArray:()=>Bb,isNodeArrayMultiLine:()=>ume,isNodeDescendantOf:()=>Yb,isNodeKind:()=>e8,isNodeLikeSystem:()=>PG,isNodeModulesDirectory:()=>f9,isNodeWithPossibleHoistedDeclaration:()=>Dde,isNonContextualKeyword:()=>sX,isNonExportDefaultModifier:()=>Z3e,isNonGlobalAmbientModule:()=>PY,isNonGlobalDeclaration:()=>Q1e,isNonNullAccess:()=>zme,isNonNullChain:()=>k9,isNonNullExpression:()=>ek,isNonStaticMethodOrAccessorWithPrivateName:()=>f0e,isNotEmittedOrPartiallyEmittedNode:()=>l4e,isNotEmittedStatement:()=>BK,isNullishCoalesce:()=>nY,isNumber:()=>Mp,isNumericLiteral:()=>_p,isNumericLiteralName:()=>R0,isObjectBindingElementWithoutPropertyName:()=>i7,isObjectBindingOrAssignmentElement:()=>s8,isObjectBindingOrAssignmentPattern:()=>_Y,isObjectBindingPattern:()=>pm,isObjectLiteralElement:()=>hY,isObjectLiteralElementLike:()=>by,isObjectLiteralExpression:()=>Ha,isObjectLiteralMethod:()=>jm,isObjectLiteralOrClassExpressionMethodOrAccessor:()=>ej,isObjectTypeDeclaration:()=>OA,isOctalDigit:()=>g9,isOmittedExpression:()=>Su,isOptionalChain:()=>w_,isOptionalChainRoot:()=>Nw,isOptionalDeclaration:()=>C6,isOptionalJSDocPropertyLikeTag:()=>fR,isOptionalTypeNode:()=>rU,isOuterExpression:()=>hU,isOutermostOptionalChain:()=>Dw,isOverrideModifier:()=>Tge,isPackageJsonInfo:()=>BU,isPackedArrayLiteral:()=>HX,isParameter:()=>Ls,isParameterDeclaration:()=>Kb,isParameterPropertyDeclaration:()=>op,isParameterPropertyModifier:()=>Rw,isParenthesizedExpression:()=>Df,isParenthesizedTypeNode:()=>ox,isParseTreeNode:()=>Pw,isPartOfTypeNode:()=>A0,isPartOfTypeQuery:()=>lj,isPartiallyEmittedExpression:()=>aU,isPatternMatch:()=>U5,isPinnedComment:()=>z9,isPlainJsFile:()=>p8,isPlusToken:()=>IK,isPossiblyTypeArgumentPosition:()=>QM,isPostfixUnaryExpression:()=>MK,isPrefixUnaryExpression:()=>eS,isPrivateIdentifier:()=>is,isPrivateIdentifierClassElementDeclaration:()=>G_,isPrivateIdentifierPropertyAccessExpression:()=>XP,isPrivateIdentifierSymbol:()=>Mde,isProgramBundleEmitBuildInfo:()=>mye,isProgramUptoDate:()=>HZ,isPrologueDirective:()=>Fm,isPropertyAccessChain:()=>C9,isPropertyAccessEntityNameExpression:()=>tR,isPropertyAccessExpression:()=>Hn,isPropertyAccessOrQualifiedName:()=>Ppe,isPropertyAccessOrQualifiedNameOrImportTypeNode:()=>kpe,isPropertyAssignment:()=>Ul,isPropertyDeclaration:()=>ea,isPropertyName:()=>Al,isPropertyNameLiteral:()=>Wg,isPropertySignature:()=>fp,isProtoSetter:()=>Lde,isPrototypeAccess:()=>zv,isPrototypePropertyAssignment:()=>M8,isPunctuation:()=>iX,isPushOrUnshiftIdentifier:()=>cX,isQualifiedName:()=>pf,isQuestionDotToken:()=>eU,isQuestionOrExclamationToken:()=>Xge,isQuestionOrPlusOrMinusToken:()=>Zge,isQuestionToken:()=>Xv,isRawSourceMap:()=>c0e,isReadonlyKeyword:()=>vge,isReadonlyKeywordOrPlusOrMinusToken:()=>Qge,isRecognizedTripleSlashComment:()=>xY,isReferenceFileLocation:()=>pD,isReferencedFile:()=>MT,isRegularExpressionLiteral:()=>NK,isRequireCall:()=>_f,isRequireVariableStatement:()=>WY,isRestParameter:()=>x0,isRestTypeNode:()=>nU,isReturnStatement:()=>Um,isReturnStatementWithFixablePromiseHandler:()=>qJ,isRightSideOfAccessExpression:()=>AX,isRightSideOfInstanceofExpression:()=>nme,isRightSideOfPropertyAccess:()=>SD,isRightSideOfQualifiedName:()=>u1e,isRightSideOfQualifiedNameOrPropertyAccess:()=>o6,isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName:()=>rme,isRootedDiskPath:()=>ap,isSameEntityName:()=>pN,isSatisfiesExpression:()=>LK,isScopeMarker:()=>Ipe,isSemicolonClassElement:()=>kge,isSetAccessor:()=>A1,isSetAccessorDeclaration:()=>pp,isShebangTrivia:()=>$H,isShiftOperatorOrHigher:()=>iQ,isShorthandAmbientModuleSymbol:()=>Uw,isShorthandPropertyAssignment:()=>Hf,isSignedNumericLiteral:()=>Tj,isSimpleCopiableExpression:()=>TE,isSimpleInlineableExpression:()=>rh,isSimpleParameter:()=>h0e,isSimpleParameterList:()=>EM,isSingleOrDoubleQuote:()=>P8,isSourceFile:()=>ls,isSourceFileFromLibrary:()=>PD,isSourceFileJS:()=>Y_,isSourceFileNotJS:()=>b4e,isSourceFileNotJson:()=>$Y,isSourceMapping:()=>l0e,isSpecialPropertyDeclaration:()=>Ade,isSpreadAssignment:()=>F1,isSpreadElement:()=>fg,isStatement:()=>ns,isStatementButNotDeclaration:()=>l8,isStatementOrBlock:()=>Fpe,isStatementWithLocals:()=>Hpe,isStatic:()=>pa,isStaticModifier:()=>GA,isString:()=>vs,isStringAKeyword:()=>I4e,isStringANonContextualKeyword:()=>PA,isStringAndEmptyAnonymousObjectIntersection:()=>E1e,isStringDoubleQuoted:()=>pj,isStringLiteral:()=>za,isStringLiteralLike:()=>bo,isStringLiteralOrJsxExpression:()=>Bpe,isStringLiteralOrTemplate:()=>q1e,isStringOrNumericLiteralLike:()=>id,isStringOrRegularExpressionOrTemplateLiteral:()=>pte,isStringTextContainingNode:()=>cY,isSuperCall:()=>$2,isSuperKeyword:()=>M6,isSuperOrSuperProperty:()=>T4e,isSuperProperty:()=>Pf,isSupportedSourceFileName:()=>Ome,isSwitchStatement:()=>U6,isSyntaxList:()=>XN,isSyntheticExpression:()=>I3e,isSyntheticReference:()=>rk,isTagName:()=>rte,isTaggedTemplateExpression:()=>uE,isTaggedTemplateTag:()=>a1e,isTemplateExpression:()=>iU,isTemplateHead:()=>$A,isTemplateLiteral:()=>SA,isTemplateLiteralKind:()=>Rv,isTemplateLiteralToken:()=>Tpe,isTemplateLiteralTypeNode:()=>xge,isTemplateLiteralTypeSpan:()=>RK,isTemplateMiddle:()=>DK,isTemplateMiddleOrTemplateTail:()=>P9,isTemplateSpan:()=>B6,isTemplateTail:()=>QB,isTextWhiteSpaceLike:()=>N1e,isThis:()=>TD,isThisContainerOrFunctionBlock:()=>Sde,isThisIdentifier:()=>eE,isThisInTypeQuery:()=>NA,isThisInitializedDeclaration:()=>sj,isThisInitializedObjectBindingExpression:()=>bde,isThisProperty:()=>x8,isThisTypeNode:()=>LR,isThisTypeParameter:()=>x6,isThisTypePredicate:()=>S4e,isThrowStatement:()=>jK,isToken:()=>gA,isTokenKind:()=>aY,isTraceEnabled:()=>wy,isTransientSymbol:()=>Rh,isTrivia:()=>TN,isTryStatement:()=>fx,isTupleTypeNode:()=>XA,isTypeAlias:()=>j8,isTypeAliasDeclaration:()=>Vm,isTypeAssertionExpression:()=>Cge,isTypeDeclaration:()=>LN,isTypeElement:()=>B2,isTypeKeyword:()=>CO,isTypeKeywordToken:()=>vte,isTypeKeywordTokenOrIdentifier:()=>pJ,isTypeLiteralNode:()=>dp,isTypeNode:()=>es,isTypeNodeKind:()=>RX,isTypeOfExpression:()=>zN,isTypeOnlyExportDeclaration:()=>bpe,isTypeOnlyImportDeclaration:()=>t8,isTypeOnlyImportOrExportDeclaration:()=>dT,isTypeOperatorNode:()=>cx,isTypeParameterDeclaration:()=>Nc,isTypePredicateNode:()=>RR,isTypeQueryNode:()=>YA,isTypeReferenceNode:()=>Id,isTypeReferenceType:()=>F9,isTypeUsableAsPropertyName:()=>um,isUMDExportSymbol:()=>Uj,isUnaryExpression:()=>dY,isUnaryExpressionWithWrite:()=>Npe,isUnicodeIdentifierStart:()=>d9,isUnionTypeNode:()=>Kv,isUnparsedNode:()=>sY,isUnparsedPrepend:()=>wge,isUnparsedSource:()=>dx,isUnparsedTextLike:()=>Spe,isUrl:()=>Vfe,isValidBigIntString:()=>iB,isValidESSymbolDeclaration:()=>dde,isValidTypeOnlyAliasUseSite:()=>ET,isValueSignatureDeclaration:()=>Ide,isVarAwaitUsing:()=>v8,isVarConst:()=>aN,isVarUsing:()=>S8,isVariableDeclaration:()=>Gi,isVariableDeclarationInVariableStatement:()=>Jw,isVariableDeclarationInitializedToBareOrAccessedRequire:()=>Gb,isVariableDeclarationInitializedToRequire:()=>fj,isVariableDeclarationList:()=>Tu,isVariableLike:()=>cN,isVariableLikeOrAccessor:()=>fde,isVariableStatement:()=>Xc,isVoidExpression:()=>ZA,isWatchSet:()=>$4e,isWhileStatement:()=>O3e,isWhiteSpaceLike:()=>Sy,isWhiteSpaceSingleLine:()=>Vg,isWithStatement:()=>Pge,isWriteAccess:()=>wA,isWriteOnlyAccess:()=>Bj,isYieldExpression:()=>sU,jsxModeNeedsExplicitImport:()=>Hte,keywordPart:()=>gp,last:()=>Rs,lastOrUndefined:()=>Is,length:()=>de,libMap:()=>NU,libs:()=>sM,lineBreakPart:()=>AD,linkNamePart:()=>M1e,linkPart:()=>wte,linkTextPart:()=>SJ,listFiles:()=>pee,loadModuleFromGlobalCache:()=>Jhe,loadWithModeAwareCache:()=>OM,makeIdentifierFromModuleName:()=>Zpe,makeImport:()=>J1,makeImportIfNecessary:()=>P1e,makeStringLiteral:()=>vk,mangleScopedPackageName:()=>cD,map:()=>vr,mapAllOrFail:()=>Jo,mapDefined:()=>Wi,mapDefinedEntries:()=>Rl,mapDefinedIterator:()=>S0,mapEntries:()=>Fg,mapIterator:()=>g1,mapOneOrMany:()=>$te,mapToDisplayParts:()=>oS,matchFiles:()=>JX,matchPatternOrExact:()=>qX,matchedText:()=>bfe,matchesExclude:()=>PU,maybeBind:()=>rs,maybeSetLocalizedDiagnosticMessages:()=>Tme,memoize:()=>D_,memoizeCached:()=>aA,memoizeOne:()=>Nm,memoizeWeak:()=>RP,metadataHelper:()=>CB,min:()=>MP,minAndMax:()=>Mme,missingFileModifiedTime:()=>Lp,modifierToFlag:()=>IA,modifiersToFlags:()=>Yg,moduleOptionDeclaration:()=>xQ,moduleResolutionIsEqualTo:()=>Wpe,moduleResolutionNameAndModeGetter:()=>kV,moduleResolutionOptionDeclarations:()=>DU,moduleResolutionSupportsPackageJsonExportsAndImports:()=>MA,moduleResolutionUsesNodeModules:()=>dJ,moduleSpecifiers:()=>SE,moveEmitHelpers:()=>cge,moveRangeEnd:()=>Fj,moveRangePastDecorators:()=>Ay,moveRangePastModifiers:()=>Xg,moveRangePos:()=>TT,moveSyntheticComments:()=>sge,mutateMap:()=>f6,mutateMapSkippingNewValues:()=>w0,needsParentheses:()=>bJ,needsScopeMarker:()=>I9,newCaseClauseTracker:()=>LJ,newPrivateEnvironment:()=>m0e,noEmitNotification:()=>xM,noEmitSubstitution:()=>_O,noTransformers:()=>xZ,noTruncationMaximumTruncationLength:()=>fB,nodeCanBeDecorated:()=>oj,nodeHasName:()=>X3,nodeIsDecorated:()=>uN,nodeIsMissing:()=>sl,nodeIsPresent:()=>nm,nodeIsSynthesized:()=>_c,nodeModuleNameResolver:()=>Lhe,nodeModulesPathPart:()=>Wh,nodeNextJsonConfigResolver:()=>Fhe,nodeOrChildIsDecorated:()=>A8,nodeOverlapsWithStartEnd:()=>tJ,nodePosToString:()=>p4e,nodeSeenTracker:()=>yk,nodeStartsNewLexicalEnvironment:()=>lX,nodeToDisplayParts:()=>fLe,noop:()=>ja,noopFileWatcher:()=>yD,normalizePath:()=>Ca,normalizeSlashes:()=>v_,not:()=>J5,notImplemented:()=>Ks,notImplementedResolver:()=>gV,nullNodeConverters:()=>gK,nullParenthesizerRules:()=>mK,nullTransformationContext:()=>fO,objectAllocator:()=>Ju,operatorPart:()=>PO,optionDeclarations:()=>F0,optionMapToObject:()=>CU,optionsAffectingProgramStructure:()=>NQ,optionsForBuild:()=>IQ,optionsForWatch:()=>nD,optionsHaveChanges:()=>tN,optionsHaveModuleResolutionChanges:()=>qpe,or:()=>cg,orderedRemoveItem:()=>lA,orderedRemoveItemAt:()=>kv,outFile:()=>Wo,packageIdToPackageName:()=>V9,packageIdToString:()=>Bv,paramHelper:()=>AB,parameterIsThisKeyword:()=>Zb,parameterNamePart:()=>I1e,parseBaseNodeFactory:()=>fQ,parseBigInt:()=>Lme,parseBuildCommand:()=>I8e,parseCommandLine:()=>N8e,parseCommandLineWorker:()=>mQ,parseConfigFileTextToJson:()=>hQ,parseConfigFileWithSystem:()=>f7e,parseConfigHostFromCompilerHostLike:()=>AV,parseCustomTypeOption:()=>xU,parseIsolatedEntityName:()=>ok,parseIsolatedJSDocComment:()=>ohe,parseJSDocTypeExpressionForTests:()=>g8e,parseJsonConfigFileContent:()=>$8e,parseJsonSourceFileConfigFileContent:()=>rM,parseJsonText:()=>QR,parseListTypeOption:()=>lhe,parseNodeFactory:()=>$h,parseNodeModuleFromPath:()=>fM,parsePackageName:()=>mM,parsePseudoBigInt:()=>v6,parseValidBigInt:()=>GX,patchWriteFileEnsuringDirectory:()=>Bfe,pathContainsNodeModules:()=>OT,pathIsAbsolute:()=>Tw,pathIsBareSpecifier:()=>VH,pathIsRelative:()=>Fp,patternText:()=>Tfe,perfLogger:()=>z_,performIncrementalCompilation:()=>g7e,performance:()=>Ofe,plainJSErrors:()=>PV,positionBelongsToNode:()=>ote,positionIsASICandidate:()=>AJ,positionIsSynthesized:()=>_g,positionsAreOnSameLine:()=>Pd,preProcessFile:()=>BLe,probablyUsesSemicolons:()=>u7,processCommentPragmas:()=>uQ,processPragmasIntoFields:()=>_Q,processTaggedTemplateExpression:()=>hZ,programContainsEsModules:()=>k1e,programContainsModules:()=>A1e,projectReferenceIsEqualTo:()=>TY,propKeyHelper:()=>BB,propertyNamePart:()=>w1e,pseudoBigIntToString:()=>nE,punctuationPart:()=>F_,pushIfUnique:()=>ln,quote:()=>IO,quotePreferenceFromString:()=>Ete,rangeContainsPosition:()=>HM,rangeContainsPositionExclusive:()=>YM,rangeContainsRange:()=>ud,rangeContainsRangeExclusive:()=>f1e,rangeContainsStartEnd:()=>XM,rangeEndIsOnSameLineAsRangeStart:()=>nR,rangeEndPositionsAreOnSameLine:()=>cme,rangeEquals:()=>Bc,rangeIsOnSingleLine:()=>rx,rangeOfNode:()=>$X,rangeOfTypeParameters:()=>WX,rangeOverlapsWithStartEnd:()=>EO,rangeStartIsOnSameLineAsRangeEnd:()=>lme,rangeStartPositionsAreOnSameLine:()=>jj,readBuilderProgram:()=>UV,readConfigFile:()=>eM,readHelper:()=>FB,readJson:()=>c6,readJsonConfigFile:()=>fhe,readJsonOrUndefined:()=>PX,reduceEachLeadingCommentRange:()=>Gfe,reduceEachTrailingCommentRange:()=>Hfe,reduceLeft:()=>d_,reduceLeftIterator:()=>xr,reducePathComponents:()=>M2,refactor:()=>bk,regExpEscape:()=>Q4e,relativeComplement:()=>dy,removeAllComments:()=>xR,removeEmitHelper:()=>P3e,removeExtension:()=>lR,removeFileExtension:()=>ff,removeIgnoredPath:()=>IV,removeMinAndVersionNumbers:()=>B5,removeOptionality:()=>v1e,removePrefix:()=>hw,removeSuffix:()=>cA,removeTrailingDirectorySeparator:()=>sT,repeatString:()=>r7,replaceElement:()=>sA,replaceFirstStar:()=>jA,resolutionExtensionIsTSOrJson:()=>g6,resolveConfigFileProjectName:()=>xee,resolveJSModule:()=>Rhe,resolveLibrary:()=>VU,resolveModuleName:()=>aD,resolveModuleNameFromCache:()=>PRe,resolvePackageNameToPackageJson:()=>RQ,resolvePath:()=>Dv,resolveProjectReferencePath:()=>dD,resolveTripleslashReference:()=>SV,resolveTypeReferenceDirective:()=>Dhe,resolvingEmptyArray:()=>_B,restHelper:()=>OB,returnFalse:()=>qf,returnNoopFileWatcher:()=>vD,returnTrue:()=>em,returnUndefined:()=>xd,returnsPromise:()=>pre,runInitializersHelper:()=>PB,sameFlatMap:()=>nA,sameMap:()=>ul,sameMapping:()=>mMe,scanShebangTrivia:()=>WH,scanTokenAtPosition:()=>lde,scanner:()=>j_,screenStartingMessageCodes:()=>BV,semanticDiagnosticsOptionDeclarations:()=>AQ,serializeCompilerOptions:()=>AU,server:()=>jqe,servicesVersion:()=>SSe,setCommentRange:()=>kl,setConfigFileInOptions:()=>bQ,setConstantValue:()=>oge,setEachParent:()=>MN,setEmitFlags:()=>Sn,setFunctionNameHelper:()=>UB,setGetSourceFileAsHashVersioned:()=>jV,setIdentifierAutoGenerate:()=>kR,setIdentifierGeneratedImportReference:()=>_ge,setIdentifierTypeArguments:()=>M1,setInternalEmitFlags:()=>CR,setLocalizedDiagnosticMessages:()=>Sme,setModuleDefaultHelper:()=>qB,setNodeFlags:()=>Bme,setObjectAllocator:()=>vme,setOriginalNode:()=>Un,setParent:()=>io,setParentRecursive:()=>Wv,setPrivateIdentifier:()=>Sx,setSnippetElement:()=>xK,setSourceMapRange:()=>qa,setStackTraceLimit:()=>vOe,setStartsOnNewLine:()=>TB,setSyntheticLeadingComments:()=>CT,setSyntheticTrailingComments:()=>UA,setSys:()=>xOe,setSysLog:()=>Ffe,setTextRange:()=>ft,setTextRangeEnd:()=>RN,setTextRangePos:()=>S6,setTextRangePosEnd:()=>jh,setTextRangePosWidth:()=>T6,setTokenSourceMapRange:()=>ige,setTypeNode:()=>lge,setUILocale:()=>A3,setValueDeclaration:()=>L8,shouldAllowImportingTsExtension:()=>lD,shouldPreserveConstEnums:()=>aE,shouldUseUriStyleNodeCoreModules:()=>RJ,showModuleSpecifier:()=>dme,signatureHasLiteralTypes:()=>ZQ,signatureHasRestParameter:()=>L_,signatureToDisplayParts:()=>Ote,single:()=>jg,singleElementArray:()=>_A,singleIterator:()=>k2,singleOrMany:()=>Op,singleOrUndefined:()=>nl,skipAlias:()=>r_,skipAssertions:()=>H3e,skipConstraint:()=>Ste,skipOuterExpressions:()=>vl,skipParentheses:()=>Do,skipPartiallyEmittedExpressions:()=>Mm,skipTrivia:()=>Wa,skipTypeChecking:()=>y6,skipTypeParentheses:()=>q8,skipWhile:()=>xfe,sliceAfter:()=>zX,some:()=>Tt,sort:()=>Fa,sortAndDeduplicate:()=>rT,sortAndDeduplicateDiagnostics:()=>WP,sourceFileAffectingCompilerOptions:()=>IU,sourceFileMayBeEmitted:()=>Q2,sourceMapCommentRegExp:()=>eV,sourceMapCommentRegExpDontCareLineStart:()=>oZ,spacePart:()=>Qc,spanMap:()=>P2,spreadArrayHelper:()=>jB,stableSort:()=>cu,startEndContainsRange:()=>ate,startEndOverlapsWithStartEnd:()=>rJ,startOnNewLine:()=>M_,startTracing:()=>Rfe,startsWith:()=>Ss,startsWithDirectory:()=>qH,startsWithUnderscore:()=>Gte,startsWithUseStrict:()=>zge,stringContainsAt:()=>K1e,stringToToken:()=>Fb,stripQuotes:()=>cm,supportedDeclarationExtensions:()=>yR,supportedJSExtensions:()=>fK,supportedJSExtensionsFlat:()=>jN,supportedLocaleDirectories:()=>SY,supportedTSExtensions:()=>FN,supportedTSExtensionsFlat:()=>_K,supportedTSImplementationExtensions:()=>vR,suppressLeadingAndTrailingTrivia:()=>hp,suppressLeadingTrivia:()=>Fte,suppressTrailingTrivia:()=>U1e,symbolEscapedNameNoDefault:()=>gJ,symbolName:()=>Lc,symbolNameNoDefault:()=>mJ,symbolPart:()=>D1e,symbolToDisplayParts:()=>NO,syntaxMayBeASICandidate:()=>Zte,syntaxRequiresTrailingSemicolonOrASI:()=>CJ,sys:()=>Zu,sysLog:()=>O3,tagNamesAreEquivalent:()=>DT,takeWhile:()=>z5,targetOptionDeclaration:()=>oM,templateObjectHelper:()=>LB,testFormatSettings:()=>s1e,textChangeRangeIsUnchanged:()=>tpe,textChangeRangeNewSpan:()=>kw,textChanges:()=>En,textOrKeywordPart:()=>Ite,textPart:()=>fd,textRangeContainsPositionInclusive:()=>G3,textSpanContainsPosition:()=>YH,textSpanContainsTextSpan:()=>Kfe,textSpanEnd:()=>gl,textSpanIntersection:()=>epe,textSpanIntersectsWith:()=>v9,textSpanIntersectsWithPosition:()=>Zfe,textSpanIntersectsWithTextSpan:()=>$Oe,textSpanIsEmpty:()=>Xfe,textSpanOverlap:()=>Qfe,textSpanOverlapsWith:()=>zOe,textSpansEqual:()=>CD,textToKeywordObj:()=>$3,timestamp:()=>uc,toArray:()=>Pm,toBuilderFileEmit:()=>yye,toBuilderStateFileInfoForMultiEmit:()=>hye,toEditorSettings:()=>N7,toFileNameLowerCase:()=>sp,toLowerCase:()=>gw,toPath:()=>gc,toProgramEmitPending:()=>vye,tokenIsIdentifierOrKeyword:()=>$_,tokenIsIdentifierOrKeywordOrGreaterThan:()=>$fe,tokenToString:()=>Sa,trace:()=>ws,tracing:()=>mn,tracingEnabled:()=>N3,transform:()=>F5e,transformClassFields:()=>A0e,transformDeclarations:()=>bZ,transformECMAScriptModule:()=>TZ,transformES2015:()=>V0e,transformES2016:()=>U0e,transformES2017:()=>D0e,transformES2018:()=>I0e,transformES2019:()=>w0e,transformES2020:()=>O0e,transformES2021:()=>R0e,transformES5:()=>J0e,transformESDecorators:()=>N0e,transformESNext:()=>M0e,transformGenerators:()=>q0e,transformJsx:()=>B0e,transformLegacyDecorators:()=>P0e,transformModule:()=>SZ,transformNamedEvaluation:()=>mp,transformNodeModule:()=>$0e,transformNodes:()=>CM,transformSystemModule:()=>z0e,transformTypeScript:()=>C0e,transpile:()=>GLe,transpileModule:()=>gve,transpileOptionValueCompilerOptions:()=>DQ,tryAddToSet:()=>Zd,tryAndIgnoreErrors:()=>NJ,tryCast:()=>ii,tryDirectoryExists:()=>PJ,tryExtractTSExtension:()=>Mj,tryFileExists:()=>_7,tryGetClassExtendingExpressionWithTypeArguments:()=>xX,tryGetClassImplementingOrExtendingExpressionWithTypeArguments:()=>CX,tryGetDirectories:()=>kJ,tryGetExtensionFromPath:()=>Py,tryGetImportFromModuleSpecifier:()=>F8,tryGetJSDocSatisfiesTypeNode:()=>cB,tryGetModuleNameFromFile:()=>$R,tryGetModuleSpecifierFromDeclaration:()=>dN,tryGetNativePerformanceHooks:()=>Dfe,tryGetPropertyAccessOrIdentifierToString:()=>rR,tryGetPropertyNameOfBindingOrAssignmentElement:()=>vU,tryGetSourceMappingURL:()=>o0e,tryGetTextOfPropertyName:()=>Vw,tryIOAndConsumeErrors:()=>DJ,tryParseJson:()=>Lj,tryParsePattern:()=>ON,tryParsePatterns:()=>tB,tryParseRawSourceMap:()=>sZ,tryReadDirectory:()=>Ute,tryReadFile:()=>X6,tryRemoveDirectoryPrefix:()=>UX,tryRemoveExtension:()=>Rme,tryRemovePrefix:()=>kG,tryRemoveSuffix:()=>xG,typeAcquisitionDeclarations:()=>cM,typeAliasNamePart:()=>O1e,typeDirectiveIsEqualTo:()=>Gpe,typeKeywords:()=>FJ,typeParameterNamePart:()=>R1e,typeToDisplayParts:()=>a7,unchangedPollThresholds:()=>R3,unchangedTextChangeRange:()=>_8,unescapeLeadingUnderscores:()=>Zi,unmangleScopedPackageName:()=>hM,unorderedRemoveItem:()=>uA,unorderedRemoveItemAt:()=>CG,unreachableCodeIsError:()=>Eme,unusedLabelIsError:()=>xme,unwrapInnermostStatementOfLabel:()=>VY,updateErrorForNoInputFiles:()=>kU,updateLanguageServiceSourceFile:()=>Xre,updateMissingFilePathsWatch:()=>wZ,updateResolutionField:()=>iD,updateSharedExtendedConfigFileWatcher:()=>yV,updateSourceFile:()=>cQ,updateWatchingWildcardDirectories:()=>PM,usesExtensionsOnImports:()=>Ime,usingSingleLineStringWriter:()=>jw,utf16EncodeAsString:()=>$P,validateLocaleAndSetLanguage:()=>GOe,valuesHelper:()=>VB,version:()=>F,versionMajorMinor:()=>w,visitArray:()=>SM,visitCommaListElements:()=>TM,visitEachChild:()=>wr,visitFunctionBody:()=>ld,visitIterationBody:()=>df,visitLexicalEnvironment:()=>nZ,visitNode:()=>nt,visitNodes:()=>Hr,visitParameterList:()=>qc,walkUpBindingElementsAndPatterns:()=>GP,walkUpLexicalEnvironments:()=>d0e,walkUpOuterExpressions:()=>$ge,walkUpParenthesizedExpressions:()=>P1,walkUpParenthesizedTypes:()=>J8,walkUpParenthesizedTypesAndGetParentAndChild:()=>wde,whitespaceOrMapCommentRegExp:()=>tV,writeCommentRange:()=>kN,writeFile:()=>t6,writeFileEnsuringDirectories:()=>vX,zipWith:()=>en});var Uqe=f({"src/typescript/_namespaces/ts.ts"(){"use strict";fa(),JM(),yi(),uS(),M8t()}}),L8t=v({"src/typescript/typescript.ts"(e,t){Uqe(),Uqe(),typeof console<"u"&&(I.loggingHost={log(n,i){switch(n){case 1:return console.error(i);case 2:return console.warn(i);case 3:return console.log(i);case 4:return console.log(i)}}}),t.exports=Bqe}});return L8t()})();typeof lG<"u"&&lG.exports&&(lG.exports=ncr)});var gG=At((dbr,Dmt)=>{var vcr="2.0.0",Scr=Number.MAX_SAFE_INTEGER||9007199254740991,Tcr=16,bcr=250,Ecr=["major","premajor","minor","preminor","patch","prepatch","prerelease"];Dmt.exports={MAX_LENGTH:256,MAX_SAFE_COMPONENT_LENGTH:Tcr,MAX_SAFE_BUILD_LENGTH:bcr,MAX_SAFE_INTEGER:Scr,RELEASE_TYPES:Ecr,SEMVER_SPEC_VERSION:vcr,FLAG_INCLUDE_PRERELEASE:1,FLAG_LOOSE:2}});var hG=At((mbr,Imt)=>{var xcr=typeof process=="object"&&process.env&&process.env.NODE_DEBUG&&/\bsemver\b/i.test(process.env.NODE_DEBUG)?(...u)=>console.error("SEMVER",...u):()=>{};Imt.exports=xcr});var N5=At((wP,wmt)=>{var{MAX_SAFE_COMPONENT_LENGTH:R6e,MAX_SAFE_BUILD_LENGTH:Ccr,MAX_LENGTH:Acr}=gG(),kcr=hG();wP=wmt.exports={};var Pcr=wP.re=[],Ncr=wP.safeRe=[],Ua=wP.src=[],Va=wP.t={},Dcr=0,M6e="[a-zA-Z0-9-]",Icr=[["\\s",1],["\\d",Acr],[M6e,Ccr]],wcr=u=>{for(let[c,f]of Icr)u=u.split(`${c}*`).join(`${c}{0,${f}}`).split(`${c}+`).join(`${c}{1,${f}}`);return u},rl=(u,c,f)=>{let v=wcr(c),x=Dcr++;kcr(u,x,c),Va[u]=x,Ua[x]=c,Pcr[x]=new RegExp(c,f?"g":void 0),Ncr[x]=new RegExp(v,f?"g":void 0)};rl("NUMERICIDENTIFIER","0|[1-9]\\d*");rl("NUMERICIDENTIFIERLOOSE","\\d+");rl("NONNUMERICIDENTIFIER",`\\d*[a-zA-Z-]${M6e}*`);rl("MAINVERSION",`(${Ua[Va.NUMERICIDENTIFIER]})\\.(${Ua[Va.NUMERICIDENTIFIER]})\\.(${Ua[Va.NUMERICIDENTIFIER]})`);rl("MAINVERSIONLOOSE",`(${Ua[Va.NUMERICIDENTIFIERLOOSE]})\\.(${Ua[Va.NUMERICIDENTIFIERLOOSE]})\\.(${Ua[Va.NUMERICIDENTIFIERLOOSE]})`);rl("PRERELEASEIDENTIFIER",`(?:${Ua[Va.NUMERICIDENTIFIER]}|${Ua[Va.NONNUMERICIDENTIFIER]})`);rl("PRERELEASEIDENTIFIERLOOSE",`(?:${Ua[Va.NUMERICIDENTIFIERLOOSE]}|${Ua[Va.NONNUMERICIDENTIFIER]})`);rl("PRERELEASE",`(?:-(${Ua[Va.PRERELEASEIDENTIFIER]}(?:\\.${Ua[Va.PRERELEASEIDENTIFIER]})*))`);rl("PRERELEASELOOSE",`(?:-?(${Ua[Va.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${Ua[Va.PRERELEASEIDENTIFIERLOOSE]})*))`);rl("BUILDIDENTIFIER",`${M6e}+`);rl("BUILD",`(?:\\+(${Ua[Va.BUILDIDENTIFIER]}(?:\\.${Ua[Va.BUILDIDENTIFIER]})*))`);rl("FULLPLAIN",`v?${Ua[Va.MAINVERSION]}${Ua[Va.PRERELEASE]}?${Ua[Va.BUILD]}?`);rl("FULL",`^${Ua[Va.FULLPLAIN]}$`);rl("LOOSEPLAIN",`[v=\\s]*${Ua[Va.MAINVERSIONLOOSE]}${Ua[Va.PRERELEASELOOSE]}?${Ua[Va.BUILD]}?`);rl("LOOSE",`^${Ua[Va.LOOSEPLAIN]}$`);rl("GTLT","((?:<|>)?=?)");rl("XRANGEIDENTIFIERLOOSE",`${Ua[Va.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);rl("XRANGEIDENTIFIER",`${Ua[Va.NUMERICIDENTIFIER]}|x|X|\\*`);rl("XRANGEPLAIN",`[v=\\s]*(${Ua[Va.XRANGEIDENTIFIER]})(?:\\.(${Ua[Va.XRANGEIDENTIFIER]})(?:\\.(${Ua[Va.XRANGEIDENTIFIER]})(?:${Ua[Va.PRERELEASE]})?${Ua[Va.BUILD]}?)?)?`);rl("XRANGEPLAINLOOSE",`[v=\\s]*(${Ua[Va.XRANGEIDENTIFIERLOOSE]})(?:\\.(${Ua[Va.XRANGEIDENTIFIERLOOSE]})(?:\\.(${Ua[Va.XRANGEIDENTIFIERLOOSE]})(?:${Ua[Va.PRERELEASELOOSE]})?${Ua[Va.BUILD]}?)?)?`);rl("XRANGE",`^${Ua[Va.GTLT]}\\s*${Ua[Va.XRANGEPLAIN]}$`);rl("XRANGELOOSE",`^${Ua[Va.GTLT]}\\s*${Ua[Va.XRANGEPLAINLOOSE]}$`);rl("COERCEPLAIN",`(^|[^\\d])(\\d{1,${R6e}})(?:\\.(\\d{1,${R6e}}))?(?:\\.(\\d{1,${R6e}}))?`);rl("COERCE",`${Ua[Va.COERCEPLAIN]}(?:$|[^\\d])`);rl("COERCEFULL",Ua[Va.COERCEPLAIN]+`(?:${Ua[Va.PRERELEASE]})?(?:${Ua[Va.BUILD]})?(?:$|[^\\d])`);rl("COERCERTL",Ua[Va.COERCE],!0);rl("COERCERTLFULL",Ua[Va.COERCEFULL],!0);rl("LONETILDE","(?:~>?)");rl("TILDETRIM",`(\\s*)${Ua[Va.LONETILDE]}\\s+`,!0);wP.tildeTrimReplace="$1~";rl("TILDE",`^${Ua[Va.LONETILDE]}${Ua[Va.XRANGEPLAIN]}$`);rl("TILDELOOSE",`^${Ua[Va.LONETILDE]}${Ua[Va.XRANGEPLAINLOOSE]}$`);rl("LONECARET","(?:\\^)");rl("CARETTRIM",`(\\s*)${Ua[Va.LONECARET]}\\s+`,!0);wP.caretTrimReplace="$1^";rl("CARET",`^${Ua[Va.LONECARET]}${Ua[Va.XRANGEPLAIN]}$`);rl("CARETLOOSE",`^${Ua[Va.LONECARET]}${Ua[Va.XRANGEPLAINLOOSE]}$`);rl("COMPARATORLOOSE",`^${Ua[Va.GTLT]}\\s*(${Ua[Va.LOOSEPLAIN]})$|^$`);rl("COMPARATOR",`^${Ua[Va.GTLT]}\\s*(${Ua[Va.FULLPLAIN]})$|^$`);rl("COMPARATORTRIM",`(\\s*)${Ua[Va.GTLT]}\\s*(${Ua[Va.LOOSEPLAIN]}|${Ua[Va.XRANGEPLAIN]})`,!0);wP.comparatorTrimReplace="$1$2$3";rl("HYPHENRANGE",`^\\s*(${Ua[Va.XRANGEPLAIN]})\\s+-\\s+(${Ua[Va.XRANGEPLAIN]})\\s*$`);rl("HYPHENRANGELOOSE",`^\\s*(${Ua[Va.XRANGEPLAINLOOSE]})\\s+-\\s+(${Ua[Va.XRANGEPLAINLOOSE]})\\s*$`);rl("STAR","(<|>)?=?\\s*\\*");rl("GTE0","^\\s*>=\\s*0\\.0\\.0\\s*$");rl("GTE0PRE","^\\s*>=\\s*0\\.0\\.0-0\\s*$")});var Q_e=At((gbr,Omt)=>{var Ocr=Object.freeze({loose:!0}),Rcr=Object.freeze({}),Mcr=u=>u?typeof u!="object"?Ocr:u:Rcr;Omt.exports=Mcr});var L6e=At((hbr,Lmt)=>{var Rmt=/^[0-9]+$/,Mmt=(u,c)=>{let f=Rmt.test(u),v=Rmt.test(c);return f&&v&&(u=+u,c=+c),u===c?0:f&&!v?-1:v&&!f?1:u<c?-1:1},Lcr=(u,c)=>Mmt(c,u);Lmt.exports={compareIdentifiers:Mmt,rcompareIdentifiers:Lcr}});var py=At((ybr,Umt)=>{var Z_e=hG(),{MAX_LENGTH:Fmt,MAX_SAFE_INTEGER:efe}=gG(),{safeRe:jmt,t:Bmt}=N5(),Fcr=Q_e(),{compareIdentifiers:D5}=L6e(),F6e=class u{constructor(c,f){if(f=Fcr(f),c instanceof u){if(c.loose===!!f.loose&&c.includePrerelease===!!f.includePrerelease)return c;c=c.version}else if(typeof c!="string")throw new TypeError(`Invalid version. Must be a string. Got type "${typeof c}".`);if(c.length>Fmt)throw new TypeError(`version is longer than ${Fmt} characters`);Z_e("SemVer",c,f),this.options=f,this.loose=!!f.loose,this.includePrerelease=!!f.includePrerelease;let v=c.trim().match(f.loose?jmt[Bmt.LOOSE]:jmt[Bmt.FULL]);if(!v)throw new TypeError(`Invalid Version: ${c}`);if(this.raw=c,this.major=+v[1],this.minor=+v[2],this.patch=+v[3],this.major>efe||this.major<0)throw new TypeError("Invalid major version");if(this.minor>efe||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>efe||this.patch<0)throw new TypeError("Invalid patch version");v[4]?this.prerelease=v[4].split(".").map(x=>{if(/^[0-9]+$/.test(x)){let w=+x;if(w>=0&&w<efe)return w}return x}):this.prerelease=[],this.build=v[5]?v[5].split("."):[],this.format()}format(){return this.version=`${this.major}.${this.minor}.${this.patch}`,this.prerelease.length&&(this.version+=`-${this.prerelease.join(".")}`),this.version}toString(){return this.version}compare(c){if(Z_e("SemVer.compare",this.version,this.options,c),!(c instanceof u)){if(typeof c=="string"&&c===this.version)return 0;c=new u(c,this.options)}return c.version===this.version?0:this.compareMain(c)||this.comparePre(c)}compareMain(c){return c instanceof u||(c=new u(c,this.options)),D5(this.major,c.major)||D5(this.minor,c.minor)||D5(this.patch,c.patch)}comparePre(c){if(c instanceof u||(c=new u(c,this.options)),this.prerelease.length&&!c.prerelease.length)return-1;if(!this.prerelease.length&&c.prerelease.length)return 1;if(!this.prerelease.length&&!c.prerelease.length)return 0;let f=0;do{let v=this.prerelease[f],x=c.prerelease[f];if(Z_e("prerelease compare",f,v,x),v===void 0&&x===void 0)return 0;if(x===void 0)return 1;if(v===void 0)return-1;if(v===x)continue;return D5(v,x)}while(++f)}compareBuild(c){c instanceof u||(c=new u(c,this.options));let f=0;do{let v=this.build[f],x=c.build[f];if(Z_e("build compare",f,v,x),v===void 0&&x===void 0)return 0;if(x===void 0)return 1;if(v===void 0)return-1;if(v===x)continue;return D5(v,x)}while(++f)}inc(c,f,v){switch(c){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",f,v);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",f,v);break;case"prepatch":this.prerelease.length=0,this.inc("patch",f,v),this.inc("pre",f,v);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",f,v),this.inc("pre",f,v);break;case"major":(this.minor!==0||this.patch!==0||this.prerelease.length===0)&&this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":(this.patch!==0||this.prerelease.length===0)&&this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":{let x=Number(v)?1:0;if(!f&&v===!1)throw new Error("invalid increment argument: identifier is empty");if(this.prerelease.length===0)this.prerelease=[x];else{let w=this.prerelease.length;for(;--w>=0;)typeof this.prerelease[w]=="number"&&(this.prerelease[w]++,w=-2);if(w===-1){if(f===this.prerelease.join(".")&&v===!1)throw new Error("invalid increment argument: identifier already exists");this.prerelease.push(x)}}if(f){let w=[f,x];v===!1&&(w=[f]),D5(this.prerelease[0],f)===0?isNaN(this.prerelease[1])&&(this.prerelease=w):this.prerelease=w}break}default:throw new Error(`invalid increment argument: ${c}`)}return this.raw=this.format(),this.build.length&&(this.raw+=`+${this.build.join(".")}`),this}};Umt.exports=F6e});var S3=At((vbr,Jmt)=>{var Vmt=py(),jcr=(u,c,f=!1)=>{if(u instanceof Vmt)return u;try{return new Vmt(u,c)}catch(v){if(!f)return null;throw v}};Jmt.exports=jcr});var zmt=At((Sbr,qmt)=>{var Bcr=S3(),Ucr=(u,c)=>{let f=Bcr(u,c);return f?f.version:null};qmt.exports=Ucr});var Wmt=At((Tbr,$mt)=>{var Vcr=S3(),Jcr=(u,c)=>{let f=Vcr(u.trim().replace(/^[=v]+/,""),c);return f?f.version:null};$mt.exports=Jcr});var Ymt=At((bbr,Hmt)=>{var Gmt=py(),qcr=(u,c,f,v,x)=>{typeof f=="string"&&(x=v,v=f,f=void 0);try{return new Gmt(u instanceof Gmt?u.version:u,f).inc(c,v,x).version}catch{return null}};Hmt.exports=qcr});var Qmt=At((Ebr,Kmt)=>{var Xmt=S3(),zcr=(u,c)=>{let f=Xmt(u,null,!0),v=Xmt(c,null,!0),x=f.compare(v);if(x===0)return null;let w=x>0,F=w?f:v,ee=w?v:f,me=!!F.prerelease.length;if(!!ee.prerelease.length&&!me)return!ee.patch&&!ee.minor?"major":F.patch?"patch":F.minor?"minor":"major";let Te=me?"pre":"";return f.major!==v.major?Te+"major":f.minor!==v.minor?Te+"minor":f.patch!==v.patch?Te+"patch":"prerelease"};Kmt.exports=zcr});var egt=At((xbr,Zmt)=>{var $cr=py(),Wcr=(u,c)=>new $cr(u,c).major;Zmt.exports=Wcr});var rgt=At((Cbr,tgt)=>{var Gcr=py(),Hcr=(u,c)=>new Gcr(u,c).minor;tgt.exports=Hcr});var igt=At((Abr,ngt)=>{var Ycr=py(),Xcr=(u,c)=>new Ycr(u,c).patch;ngt.exports=Xcr});var agt=At((kbr,sgt)=>{var Kcr=S3(),Qcr=(u,c)=>{let f=Kcr(u,c);return f&&f.prerelease.length?f.prerelease:null};sgt.exports=Qcr});var Ob=At((Pbr,cgt)=>{var ogt=py(),Zcr=(u,c,f)=>new ogt(u,f).compare(new ogt(c,f));cgt.exports=Zcr});var ugt=At((Nbr,lgt)=>{var elr=Ob(),tlr=(u,c,f)=>elr(c,u,f);lgt.exports=tlr});var fgt=At((Dbr,_gt)=>{var rlr=Ob(),nlr=(u,c)=>rlr(u,c,!0);_gt.exports=nlr});var tfe=At((Ibr,dgt)=>{var pgt=py(),ilr=(u,c,f)=>{let v=new pgt(u,f),x=new pgt(c,f);return v.compare(x)||v.compareBuild(x)};dgt.exports=ilr});var ggt=At((wbr,mgt)=>{var slr=tfe(),alr=(u,c)=>u.sort((f,v)=>slr(f,v,c));mgt.exports=alr});var ygt=At((Obr,hgt)=>{var olr=tfe(),clr=(u,c)=>u.sort((f,v)=>olr(v,f,c));hgt.exports=clr});var yG=At((Rbr,vgt)=>{var llr=Ob(),ulr=(u,c,f)=>llr(u,c,f)>0;vgt.exports=ulr});var rfe=At((Mbr,Sgt)=>{var _lr=Ob(),flr=(u,c,f)=>_lr(u,c,f)<0;Sgt.exports=flr});var j6e=At((Lbr,Tgt)=>{var plr=Ob(),dlr=(u,c,f)=>plr(u,c,f)===0;Tgt.exports=dlr});var B6e=At((Fbr,bgt)=>{var mlr=Ob(),glr=(u,c,f)=>mlr(u,c,f)!==0;bgt.exports=glr});var nfe=At((jbr,Egt)=>{var hlr=Ob(),ylr=(u,c,f)=>hlr(u,c,f)>=0;Egt.exports=ylr});var ife=At((Bbr,xgt)=>{var vlr=Ob(),Slr=(u,c,f)=>vlr(u,c,f)<=0;xgt.exports=Slr});var U6e=At((Ubr,Cgt)=>{var Tlr=j6e(),blr=B6e(),Elr=yG(),xlr=nfe(),Clr=rfe(),Alr=ife(),klr=(u,c,f,v)=>{switch(c){case"===":return typeof u=="object"&&(u=u.version),typeof f=="object"&&(f=f.version),u===f;case"!==":return typeof u=="object"&&(u=u.version),typeof f=="object"&&(f=f.version),u!==f;case"":case"=":case"==":return Tlr(u,f,v);case"!=":return blr(u,f,v);case">":return Elr(u,f,v);case">=":return xlr(u,f,v);case"<":return Clr(u,f,v);case"<=":return Alr(u,f,v);default:throw new TypeError(`Invalid operator: ${c}`)}};Cgt.exports=klr});var kgt=At((Vbr,Agt)=>{var Plr=py(),Nlr=S3(),{safeRe:sfe,t:afe}=N5(),Dlr=(u,c)=>{if(u instanceof Plr)return u;if(typeof u=="number"&&(u=String(u)),typeof u!="string")return null;c=c||{};let f=null;if(!c.rtl)f=u.match(c.includePrerelease?sfe[afe.COERCEFULL]:sfe[afe.COERCE]);else{let me=c.includePrerelease?sfe[afe.COERCERTLFULL]:sfe[afe.COERCERTL],de;for(;(de=me.exec(u))&&(!f||f.index+f[0].length!==u.length);)(!f||de.index+de[0].length!==f.index+f[0].length)&&(f=de),me.lastIndex=de.index+de[1].length+de[2].length;me.lastIndex=-1}if(f===null)return null;let v=f[2],x=f[3]||"0",w=f[4]||"0",F=c.includePrerelease&&f[5]?`-${f[5]}`:"",ee=c.includePrerelease&&f[6]?`+${f[6]}`:"";return Nlr(`${v}.${x}.${w}${F}${ee}`,c)};Agt.exports=Dlr});var Ngt=At((Jbr,Pgt)=>{var V6e=class{constructor(){this.max=1e3,this.map=new Map}get(c){let f=this.map.get(c);if(f!==void 0)return this.map.delete(c),this.map.set(c,f),f}delete(c){return this.map.delete(c)}set(c,f){if(!this.delete(c)&&f!==void 0){if(this.map.size>=this.max){let x=this.map.keys().next().value;this.delete(x)}this.map.set(c,f)}return this}};Pgt.exports=V6e});var Rb=At((qbr,Ogt)=>{var J6e=class u{constructor(c,f){if(f=wlr(f),c instanceof u)return c.loose===!!f.loose&&c.includePrerelease===!!f.includePrerelease?c:new u(c.raw,f);if(c instanceof q6e)return this.raw=c.value,this.set=[[c]],this.format(),this;if(this.options=f,this.loose=!!f.loose,this.includePrerelease=!!f.includePrerelease,this.raw=c.trim().split(/\s+/).join(" "),this.set=this.raw.split("||").map(v=>this.parseRange(v.trim())).filter(v=>v.length),!this.set.length)throw new TypeError(`Invalid SemVer Range: ${this.raw}`);if(this.set.length>1){let v=this.set[0];if(this.set=this.set.filter(x=>!Igt(x[0])),this.set.length===0)this.set=[v];else if(this.set.length>1){for(let x of this.set)if(x.length===1&&Blr(x[0])){this.set=[x];break}}}this.format()}format(){return this.range=this.set.map(c=>c.join(" ").trim()).join("||").trim(),this.range}toString(){return this.range}parseRange(c){let v=((this.options.includePrerelease&&Flr)|(this.options.loose&&jlr))+":"+c,x=Dgt.get(v);if(x)return x;let w=this.options.loose,F=w?Tv[d1.HYPHENRANGELOOSE]:Tv[d1.HYPHENRANGE];c=c.replace(F,Ylr(this.options.includePrerelease)),wp("hyphen replace",c),c=c.replace(Tv[d1.COMPARATORTRIM],Rlr),wp("comparator trim",c),c=c.replace(Tv[d1.TILDETRIM],Mlr),wp("tilde trim",c),c=c.replace(Tv[d1.CARETTRIM],Llr),wp("caret trim",c);let ee=c.split(" ").map(ut=>Ulr(ut,this.options)).join(" ").split(/\s+/).map(ut=>Hlr(ut,this.options));w&&(ee=ee.filter(ut=>(wp("loose invalid filter",ut,this.options),!!ut.match(Tv[d1.COMPARATORLOOSE])))),wp("range list",ee);let me=new Map,de=ee.map(ut=>new q6e(ut,this.options));for(let ut of de){if(Igt(ut))return[ut];me.set(ut.value,ut)}me.size>1&&me.has("")&&me.delete("");let Te=[...me.values()];return Dgt.set(v,Te),Te}intersects(c,f){if(!(c instanceof u))throw new TypeError("a Range is required");return this.set.some(v=>wgt(v,f)&&c.set.some(x=>wgt(x,f)&&v.every(w=>x.every(F=>w.intersects(F,f)))))}test(c){if(!c)return!1;if(typeof c=="string")try{c=new Olr(c,this.options)}catch{return!1}for(let f=0;f<this.set.length;f++)if(Xlr(this.set[f],c,this.options))return!0;return!1}};Ogt.exports=J6e;var Ilr=Ngt(),Dgt=new Ilr,wlr=Q_e(),q6e=vG(),wp=hG(),Olr=py(),{safeRe:Tv,t:d1,comparatorTrimReplace:Rlr,tildeTrimReplace:Mlr,caretTrimReplace:Llr}=N5(),{FLAG_INCLUDE_PRERELEASE:Flr,FLAG_LOOSE:jlr}=gG(),Igt=u=>u.value==="<0.0.0-0",Blr=u=>u.value==="",wgt=(u,c)=>{let f=!0,v=u.slice(),x=v.pop();for(;f&&v.length;)f=v.every(w=>x.intersects(w,c)),x=v.pop();return f},Ulr=(u,c)=>(wp("comp",u,c),u=qlr(u,c),wp("caret",u),u=Vlr(u,c),wp("tildes",u),u=$lr(u,c),wp("xrange",u),u=Glr(u,c),wp("stars",u),u),m1=u=>!u||u.toLowerCase()==="x"||u==="*",Vlr=(u,c)=>u.trim().split(/\s+/).map(f=>Jlr(f,c)).join(" "),Jlr=(u,c)=>{let f=c.loose?Tv[d1.TILDELOOSE]:Tv[d1.TILDE];return u.replace(f,(v,x,w,F,ee)=>{wp("tilde",u,v,x,w,F,ee);let me;return m1(x)?me="":m1(w)?me=`>=${x}.0.0 <${+x+1}.0.0-0`:m1(F)?me=`>=${x}.${w}.0 <${x}.${+w+1}.0-0`:ee?(wp("replaceTilde pr",ee),me=`>=${x}.${w}.${F}-${ee} <${x}.${+w+1}.0-0`):me=`>=${x}.${w}.${F} <${x}.${+w+1}.0-0`,wp("tilde return",me),me})},qlr=(u,c)=>u.trim().split(/\s+/).map(f=>zlr(f,c)).join(" "),zlr=(u,c)=>{wp("caret",u,c);let f=c.loose?Tv[d1.CARETLOOSE]:Tv[d1.CARET],v=c.includePrerelease?"-0":"";return u.replace(f,(x,w,F,ee,me)=>{wp("caret",u,x,w,F,ee,me);let de;return m1(w)?de="":m1(F)?de=`>=${w}.0.0${v} <${+w+1}.0.0-0`:m1(ee)?w==="0"?de=`>=${w}.${F}.0${v} <${w}.${+F+1}.0-0`:de=`>=${w}.${F}.0${v} <${+w+1}.0.0-0`:me?(wp("replaceCaret pr",me),w==="0"?F==="0"?de=`>=${w}.${F}.${ee}-${me} <${w}.${F}.${+ee+1}-0`:de=`>=${w}.${F}.${ee}-${me} <${w}.${+F+1}.0-0`:de=`>=${w}.${F}.${ee}-${me} <${+w+1}.0.0-0`):(wp("no pr"),w==="0"?F==="0"?de=`>=${w}.${F}.${ee}${v} <${w}.${F}.${+ee+1}-0`:de=`>=${w}.${F}.${ee}${v} <${w}.${+F+1}.0-0`:de=`>=${w}.${F}.${ee} <${+w+1}.0.0-0`),wp("caret return",de),de})},$lr=(u,c)=>(wp("replaceXRanges",u,c),u.split(/\s+/).map(f=>Wlr(f,c)).join(" ")),Wlr=(u,c)=>{u=u.trim();let f=c.loose?Tv[d1.XRANGELOOSE]:Tv[d1.XRANGE];return u.replace(f,(v,x,w,F,ee,me)=>{wp("xRange",u,v,x,w,F,ee,me);let de=m1(w),Te=de||m1(F),ut=Te||m1(ee),Ct=ut;return x==="="&&Ct&&(x=""),me=c.includePrerelease?"-0":"",de?x===">"||x==="<"?v="<0.0.0-0":v="*":x&&Ct?(Te&&(F=0),ee=0,x===">"?(x=">=",Te?(w=+w+1,F=0,ee=0):(F=+F+1,ee=0)):x==="<="&&(x="<",Te?w=+w+1:F=+F+1),x==="<"&&(me="-0"),v=`${x+w}.${F}.${ee}${me}`):Te?v=`>=${w}.0.0${me} <${+w+1}.0.0-0`:ut&&(v=`>=${w}.${F}.0${me} <${w}.${+F+1}.0-0`),wp("xRange return",v),v})},Glr=(u,c)=>(wp("replaceStars",u,c),u.trim().replace(Tv[d1.STAR],"")),Hlr=(u,c)=>(wp("replaceGTE0",u,c),u.trim().replace(Tv[c.includePrerelease?d1.GTE0PRE:d1.GTE0],"")),Ylr=u=>(c,f,v,x,w,F,ee,me,de,Te,ut,Ct)=>(m1(v)?f="":m1(x)?f=`>=${v}.0.0${u?"-0":""}`:m1(w)?f=`>=${v}.${x}.0${u?"-0":""}`:F?f=`>=${f}`:f=`>=${f}${u?"-0":""}`,m1(de)?me="":m1(Te)?me=`<${+de+1}.0.0-0`:m1(ut)?me=`<${de}.${+Te+1}.0-0`:Ct?me=`<=${de}.${Te}.${ut}-${Ct}`:u?me=`<${de}.${Te}.${+ut+1}-0`:me=`<=${me}`,`${f} ${me}`.trim()),Xlr=(u,c,f)=>{for(let v=0;v<u.length;v++)if(!u[v].test(c))return!1;if(c.prerelease.length&&!f.includePrerelease){for(let v=0;v<u.length;v++)if(wp(u[v].semver),u[v].semver!==q6e.ANY&&u[v].semver.prerelease.length>0){let x=u[v].semver;if(x.major===c.major&&x.minor===c.minor&&x.patch===c.patch)return!0}return!1}return!0}});var vG=At((zbr,Bgt)=>{var SG=Symbol("SemVer ANY"),W6e=class u{static get ANY(){return SG}constructor(c,f){if(f=Rgt(f),c instanceof u){if(c.loose===!!f.loose)return c;c=c.value}c=c.trim().split(/\s+/).join(" "),$6e("comparator",c,f),this.options=f,this.loose=!!f.loose,this.parse(c),this.semver===SG?this.value="":this.value=this.operator+this.semver.version,$6e("comp",this)}parse(c){let f=this.options.loose?Mgt[Lgt.COMPARATORLOOSE]:Mgt[Lgt.COMPARATOR],v=c.match(f);if(!v)throw new TypeError(`Invalid comparator: ${c}`);this.operator=v[1]!==void 0?v[1]:"",this.operator==="="&&(this.operator=""),v[2]?this.semver=new Fgt(v[2],this.options.loose):this.semver=SG}toString(){return this.value}test(c){if($6e("Comparator.test",c,this.options.loose),this.semver===SG||c===SG)return!0;if(typeof c=="string")try{c=new Fgt(c,this.options)}catch{return!1}return z6e(c,this.operator,this.semver,this.options)}intersects(c,f){if(!(c instanceof u))throw new TypeError("a Comparator is required");return this.operator===""?this.value===""?!0:new jgt(c.value,f).test(this.value):c.operator===""?c.value===""?!0:new jgt(this.value,f).test(c.semver):(f=Rgt(f),f.includePrerelease&&(this.value==="<0.0.0-0"||c.value==="<0.0.0-0")||!f.includePrerelease&&(this.value.startsWith("<0.0.0")||c.value.startsWith("<0.0.0"))?!1:!!(this.operator.startsWith(">")&&c.operator.startsWith(">")||this.operator.startsWith("<")&&c.operator.startsWith("<")||this.semver.version===c.semver.version&&this.operator.includes("=")&&c.operator.includes("=")||z6e(this.semver,"<",c.semver,f)&&this.operator.startsWith(">")&&c.operator.startsWith("<")||z6e(this.semver,">",c.semver,f)&&this.operator.startsWith("<")&&c.operator.startsWith(">")))}};Bgt.exports=W6e;var Rgt=Q_e(),{safeRe:Mgt,t:Lgt}=N5(),z6e=U6e(),$6e=hG(),Fgt=py(),jgt=Rb()});var TG=At(($br,Ugt)=>{var Klr=Rb(),Qlr=(u,c,f)=>{try{c=new Klr(c,f)}catch{return!1}return c.test(u)};Ugt.exports=Qlr});var Jgt=At((Wbr,Vgt)=>{var Zlr=Rb(),eur=(u,c)=>new Zlr(u,c).set.map(f=>f.map(v=>v.value).join(" ").trim().split(" "));Vgt.exports=eur});var zgt=At((Gbr,qgt)=>{var tur=py(),rur=Rb(),nur=(u,c,f)=>{let v=null,x=null,w=null;try{w=new rur(c,f)}catch{return null}return u.forEach(F=>{w.test(F)&&(!v||x.compare(F)===-1)&&(v=F,x=new tur(v,f))}),v};qgt.exports=nur});var Wgt=At((Hbr,$gt)=>{var iur=py(),sur=Rb(),aur=(u,c,f)=>{let v=null,x=null,w=null;try{w=new sur(c,f)}catch{return null}return u.forEach(F=>{w.test(F)&&(!v||x.compare(F)===1)&&(v=F,x=new iur(v,f))}),v};$gt.exports=aur});var Ygt=At((Ybr,Hgt)=>{var G6e=py(),our=Rb(),Ggt=yG(),cur=(u,c)=>{u=new our(u,c);let f=new G6e("0.0.0");if(u.test(f)||(f=new G6e("0.0.0-0"),u.test(f)))return f;f=null;for(let v=0;v<u.set.length;++v){let x=u.set[v],w=null;x.forEach(F=>{let ee=new G6e(F.semver.version);switch(F.operator){case">":ee.prerelease.length===0?ee.patch++:ee.prerelease.push(0),ee.raw=ee.format();case"":case">=":(!w||Ggt(ee,w))&&(w=ee);break;case"<":case"<=":break;default:throw new Error(`Unexpected operation: ${F.operator}`)}}),w&&(!f||Ggt(f,w))&&(f=w)}return f&&u.test(f)?f:null};Hgt.exports=cur});var Kgt=At((Xbr,Xgt)=>{var lur=Rb(),uur=(u,c)=>{try{return new lur(u,c).range||"*"}catch{return null}};Xgt.exports=uur});var ofe=At((Kbr,tht)=>{var _ur=py(),eht=vG(),{ANY:fur}=eht,pur=Rb(),dur=TG(),Qgt=yG(),Zgt=rfe(),mur=ife(),gur=nfe(),hur=(u,c,f,v)=>{u=new _ur(u,v),c=new pur(c,v);let x,w,F,ee,me;switch(f){case">":x=Qgt,w=mur,F=Zgt,ee=">",me=">=";break;case"<":x=Zgt,w=gur,F=Qgt,ee="<",me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(dur(u,c,v))return!1;for(let de=0;de<c.set.length;++de){let Te=c.set[de],ut=null,Ct=null;if(Te.forEach(Kt=>{Kt.semver===fur&&(Kt=new eht(">=0.0.0")),ut=ut||Kt,Ct=Ct||Kt,x(Kt.semver,ut.semver,v)?ut=Kt:F(Kt.semver,Ct.semver,v)&&(Ct=Kt)}),ut.operator===ee||ut.operator===me||(!Ct.operator||Ct.operator===ee)&&w(u,Ct.semver))return!1;if(Ct.operator===me&&F(u,Ct.semver))return!1}return!0};tht.exports=hur});var nht=At((Qbr,rht)=>{var yur=ofe(),vur=(u,c,f)=>yur(u,c,">",f);rht.exports=vur});var sht=At((Zbr,iht)=>{var Sur=ofe(),Tur=(u,c,f)=>Sur(u,c,"<",f);iht.exports=Tur});var cht=At((eEr,oht)=>{var aht=Rb(),bur=(u,c,f)=>(u=new aht(u,f),c=new aht(c,f),u.intersects(c,f));oht.exports=bur});var uht=At((tEr,lht)=>{var Eur=TG(),xur=Ob();lht.exports=(u,c,f)=>{let v=[],x=null,w=null,F=u.sort((Te,ut)=>xur(Te,ut,f));for(let Te of F)Eur(Te,c,f)?(w=Te,x||(x=Te)):(w&&v.push([x,w]),w=null,x=null);x&&v.push([x,null]);let ee=[];for(let[Te,ut]of v)Te===ut?ee.push(Te):!ut&&Te===F[0]?ee.push("*"):ut?Te===F[0]?ee.push(`<=${ut}`):ee.push(`${Te} - ${ut}`):ee.push(`>=${Te}`);let me=ee.join(" || "),de=typeof c.raw=="string"?c.raw:String(c);return me.length<de.length?me:c}});var ght=At((rEr,mht)=>{var _ht=Rb(),Y6e=vG(),{ANY:H6e}=Y6e,bG=TG(),X6e=Ob(),Cur=(u,c,f={})=>{if(u===c)return!0;u=new _ht(u,f),c=new _ht(c,f);let v=!1;e:for(let x of u.set){for(let w of c.set){let F=kur(x,w,f);if(v=v||F!==null,F)continue e}if(v)return!1}return!0},Aur=[new Y6e(">=0.0.0-0")],fht=[new Y6e(">=0.0.0")],kur=(u,c,f)=>{if(u===c)return!0;if(u.length===1&&u[0].semver===H6e){if(c.length===1&&c[0].semver===H6e)return!0;f.includePrerelease?u=Aur:u=fht}if(c.length===1&&c[0].semver===H6e){if(f.includePrerelease)return!0;c=fht}let v=new Set,x,w;for(let Kt of u)Kt.operator===">"||Kt.operator===">="?x=pht(x,Kt,f):Kt.operator==="<"||Kt.operator==="<="?w=dht(w,Kt,f):v.add(Kt.semver);if(v.size>1)return null;let F;if(x&&w){if(F=X6e(x.semver,w.semver,f),F>0)return null;if(F===0&&(x.operator!==">="||w.operator!=="<="))return null}for(let Kt of v){if(x&&!bG(Kt,String(x),f)||w&&!bG(Kt,String(w),f))return null;for(let xr of c)if(!bG(Kt,String(xr),f))return!1;return!0}let ee,me,de,Te,ut=w&&!f.includePrerelease&&w.semver.prerelease.length?w.semver:!1,Ct=x&&!f.includePrerelease&&x.semver.prerelease.length?x.semver:!1;ut&&ut.prerelease.length===1&&w.operator==="<"&&ut.prerelease[0]===0&&(ut=!1);for(let Kt of c){if(Te=Te||Kt.operator===">"||Kt.operator===">=",de=de||Kt.operator==="<"||Kt.operator==="<=",x){if(Ct&&Kt.semver.prerelease&&Kt.semver.prerelease.length&&Kt.semver.major===Ct.major&&Kt.semver.minor===Ct.minor&&Kt.semver.patch===Ct.patch&&(Ct=!1),Kt.operator===">"||Kt.operator===">="){if(ee=pht(x,Kt,f),ee===Kt&&ee!==x)return!1}else if(x.operator===">="&&!bG(x.semver,String(Kt),f))return!1}if(w){if(ut&&Kt.semver.prerelease&&Kt.semver.prerelease.length&&Kt.semver.major===ut.major&&Kt.semver.minor===ut.minor&&Kt.semver.patch===ut.patch&&(ut=!1),Kt.operator==="<"||Kt.operator==="<="){if(me=dht(w,Kt,f),me===Kt&&me!==w)return!1}else if(w.operator==="<="&&!bG(w.semver,String(Kt),f))return!1}if(!Kt.operator&&(w||x)&&F!==0)return!1}return!(x&&de&&!w&&F!==0||w&&Te&&!x&&F!==0||Ct||ut)},pht=(u,c,f)=>{if(!u)return c;let v=X6e(u.semver,c.semver,f);return v>0?u:v<0||c.operator===">"&&u.operator===">="?c:u},dht=(u,c,f)=>{if(!u)return c;let v=X6e(u.semver,c.semver,f);return v<0?u:v>0||c.operator==="<"&&u.operator==="<="?c:u};mht.exports=Cur});var Sht=At((nEr,vht)=>{var K6e=N5(),hht=gG(),Pur=py(),yht=L6e(),Nur=S3(),Dur=zmt(),Iur=Wmt(),wur=Ymt(),Our=Qmt(),Rur=egt(),Mur=rgt(),Lur=igt(),Fur=agt(),jur=Ob(),Bur=ugt(),Uur=fgt(),Vur=tfe(),Jur=ggt(),qur=ygt(),zur=yG(),$ur=rfe(),Wur=j6e(),Gur=B6e(),Hur=nfe(),Yur=ife(),Xur=U6e(),Kur=kgt(),Qur=vG(),Zur=Rb(),e_r=TG(),t_r=Jgt(),r_r=zgt(),n_r=Wgt(),i_r=Ygt(),s_r=Kgt(),a_r=ofe(),o_r=nht(),c_r=sht(),l_r=cht(),u_r=uht(),__r=ght();vht.exports={parse:Nur,valid:Dur,clean:Iur,inc:wur,diff:Our,major:Rur,minor:Mur,patch:Lur,prerelease:Fur,compare:jur,rcompare:Bur,compareLoose:Uur,compareBuild:Vur,sort:Jur,rsort:qur,gt:zur,lt:$ur,eq:Wur,neq:Gur,gte:Hur,lte:Yur,cmp:Xur,coerce:Kur,Comparator:Qur,Range:Zur,satisfies:e_r,toComparators:t_r,maxSatisfying:r_r,minSatisfying:n_r,minVersion:i_r,validRange:s_r,outside:a_r,gtr:o_r,ltr:c_r,intersects:l_r,simplifyRange:u_r,subset:__r,SemVer:Pur,re:K6e.re,src:K6e.src,tokens:K6e.t,SEMVER_SPEC_VERSION:hht.SEMVER_SPEC_VERSION,RELEASE_TYPES:hht.RELEASE_TYPES,compareIdentifiers:yht.compareIdentifiers,rcompareIdentifiers:yht.rcompareIdentifiers}});var Lht=At((dxr,p_r)=>{p_r.exports=[{name:"Agola CI",constant:"AGOLA",env:"AGOLA_GIT_REF",pr:"AGOLA_PULL_REQUEST_ID"},{name:"Appcircle",constant:"APPCIRCLE",env:"AC_APPCIRCLE"},{name:"AppVeyor",constant:"APPVEYOR",env:"APPVEYOR",pr:"APPVEYOR_PULL_REQUEST_NUMBER"},{name:"AWS CodeBuild",constant:"CODEBUILD",env:"CODEBUILD_BUILD_ARN"},{name:"Azure Pipelines",constant:"AZURE_PIPELINES",env:"TF_BUILD",pr:{BUILD_REASON:"PullRequest"}},{name:"Bamboo",constant:"BAMBOO",env:"bamboo_planKey"},{name:"Bitbucket Pipelines",constant:"BITBUCKET",env:"BITBUCKET_COMMIT",pr:"BITBUCKET_PR_ID"},{name:"Bitrise",constant:"BITRISE",env:"BITRISE_IO",pr:"BITRISE_PULL_REQUEST"},{name:"Buddy",constant:"BUDDY",env:"BUDDY_WORKSPACE_ID",pr:"BUDDY_EXECUTION_PULL_REQUEST_ID"},{name:"Buildkite",constant:"BUILDKITE",env:"BUILDKITE",pr:{env:"BUILDKITE_PULL_REQUEST",ne:"false"}},{name:"CircleCI",constant:"CIRCLE",env:"CIRCLECI",pr:"CIRCLE_PULL_REQUEST"},{name:"Cirrus CI",constant:"CIRRUS",env:"CIRRUS_CI",pr:"CIRRUS_PR"},{name:"Codefresh",constant:"CODEFRESH",env:"CF_BUILD_ID",pr:{any:["CF_PULL_REQUEST_NUMBER","CF_PULL_REQUEST_ID"]}},{name:"Codemagic",constant:"CODEMAGIC",env:"CM_BUILD_ID",pr:"CM_PULL_REQUEST"},{name:"Codeship",constant:"CODESHIP",env:{CI_NAME:"codeship"}},{name:"Drone",constant:"DRONE",env:"DRONE",pr:{DRONE_BUILD_EVENT:"pull_request"}},{name:"dsari",constant:"DSARI",env:"DSARI"},{name:"Earthly",constant:"EARTHLY",env:"EARTHLY_CI"},{name:"Expo Application Services",constant:"EAS",env:"EAS_BUILD"},{name:"Gerrit",constant:"GERRIT",env:"GERRIT_PROJECT"},{name:"Gitea Actions",constant:"GITEA_ACTIONS",env:"GITEA_ACTIONS"},{name:"GitHub Actions",constant:"GITHUB_ACTIONS",env:"GITHUB_ACTIONS",pr:{GITHUB_EVENT_NAME:"pull_request"}},{name:"GitLab CI",constant:"GITLAB",env:"GITLAB_CI",pr:"CI_MERGE_REQUEST_ID"},{name:"GoCD",constant:"GOCD",env:"GO_PIPELINE_LABEL"},{name:"Google Cloud Build",constant:"GOOGLE_CLOUD_BUILD",env:"BUILDER_OUTPUT"},{name:"Harness CI",constant:"HARNESS",env:"HARNESS_BUILD_ID"},{name:"Heroku",constant:"HEROKU",env:{env:"NODE",includes:"/app/.heroku/node/bin/node"}},{name:"Hudson",constant:"HUDSON",env:"HUDSON_URL"},{name:"Jenkins",constant:"JENKINS",env:["JENKINS_URL","BUILD_ID"],pr:{any:["ghprbPullId","CHANGE_ID"]}},{name:"LayerCI",constant:"LAYERCI",env:"LAYERCI",pr:"LAYERCI_PULL_REQUEST"},{name:"Magnum CI",constant:"MAGNUM",env:"MAGNUM"},{name:"Netlify CI",constant:"NETLIFY",env:"NETLIFY",pr:{env:"PULL_REQUEST",ne:"false"}},{name:"Nevercode",constant:"NEVERCODE",env:"NEVERCODE",pr:{env:"NEVERCODE_PULL_REQUEST",ne:"false"}},{name:"Prow",constant:"PROW",env:"PROW_JOB_ID"},{name:"ReleaseHub",constant:"RELEASEHUB",env:"RELEASE_BUILD_ID"},{name:"Render",constant:"RENDER",env:"RENDER",pr:{IS_PULL_REQUEST:"true"}},{name:"Sail CI",constant:"SAIL",env:"SAILCI",pr:"SAIL_PULL_REQUEST_NUMBER"},{name:"Screwdriver",constant:"SCREWDRIVER",env:"SCREWDRIVER",pr:{env:"SD_PULL_REQUEST",ne:"false"}},{name:"Semaphore",constant:"SEMAPHORE",env:"SEMAPHORE",pr:"PULL_REQUEST_NUMBER"},{name:"Sourcehut",constant:"SOURCEHUT",env:{CI_NAME:"sourcehut"}},{name:"Strider CD",constant:"STRIDER",env:"STRIDER"},{name:"TaskCluster",constant:"TASKCLUSTER",env:["TASK_ID","RUN_ID"]},{name:"TeamCity",constant:"TEAMCITY",env:"TEAMCITY_VERSION"},{name:"Travis CI",constant:"TRAVIS",env:"TRAVIS",pr:{env:"TRAVIS_PULL_REQUEST",ne:"false"}},{name:"Vela",constant:"VELA",env:"VELA",pr:{VELA_PULL_REQUEST:"1"}},{name:"Vercel",constant:"VERCEL",env:{any:["NOW_BUILDER","VERCEL"]},pr:"VERCEL_GIT_PULL_REQUEST_ID"},{name:"Visual Studio App Center",constant:"APPCENTER",env:"APPCENTER_BUILD_ID"},{name:"Woodpecker",constant:"WOODPECKER",env:{CI:"woodpecker"},pr:{CI_BUILD_EVENT:"pull_request"}},{name:"Xcode Cloud",constant:"XCODE_CLOUD",env:"CI_XCODE_PROJECT",pr:"CI_PULL_REQUEST_NUMBER"},{name:"Xcode Server",constant:"XCODE_SERVER",env:"XCS"}]});var Bht=At(eT=>{"use strict";var jht=Lht(),Lg=process.env;Object.defineProperty(eT,"_vendors",{value:jht.map(function(u){return u.constant})});eT.name=null;eT.isPR=null;jht.forEach(function(u){let f=(Array.isArray(u.env)?u.env:[u.env]).every(function(v){return Fht(v)});if(eT[u.constant]=f,!!f)switch(eT.name=u.name,typeof u.pr){case"string":eT.isPR=!!Lg[u.pr];break;case"object":"env"in u.pr?eT.isPR=u.pr.env in Lg&&Lg[u.pr.env]!==u.pr.ne:"any"in u.pr?eT.isPR=u.pr.any.some(function(v){return!!Lg[v]}):eT.isPR=Fht(u.pr);break;default:eT.isPR=null}});eT.isCI=!!(Lg.CI!=="false"&&(Lg.BUILD_ID||Lg.BUILD_NUMBER||Lg.CI||Lg.CI_APP_ID||Lg.CI_BUILD_ID||Lg.CI_BUILD_NUMBER||Lg.CI_NAME||Lg.CONTINUOUS_INTEGRATION||Lg.RUN_ID||eT.name));function Fht(u){return typeof u=="string"?!!Lg[u]:"env"in u?Lg[u.env]&&Lg[u.env].includes(u.includes):"any"in u?u.any.some(function(c){return!!Lg[c]}):Object.keys(u).every(function(c){return Lg[c]===u[c]})}});import*as Jht from"os";import*as Sfe from"path";var Jke={};iXe(Jke,{Argument:()=>kqt,Command:()=>Aqt,CommanderError:()=>Eqt,Help:()=>Nqt,InvalidArgumentError:()=>xqt,InvalidOptionArgumentError:()=>Cqt,Option:()=>Pqt,createArgument:()=>Tqt,createCommand:()=>Sqt,createOption:()=>bqt,program:()=>vqt});var yXe=cf(hXe(),1),{program:vqt,createCommand:Sqt,createArgument:Tqt,createOption:bqt,CommanderError:Eqt,InvalidArgumentError:xqt,InvalidOptionArgumentError:Cqt,Command:Aqt,Argument:kqt,Option:Pqt,Help:Nqt}=yXe.default;import*as rA from"net";var vXe={$ref:"#/definitions/ConfigSchema",$schema:"http://json-schema.org/draft-07/schema#",definitions:{ConfigSchema:{$id:"https://unpkg.com/@ibm/telemetry-config-schema/dist/config.schema.json",additionalProperties:!1,description:"Configuration outline for metrics collection using IBM telemetry.",properties:{collect:{additionalProperties:!1,description:"The keys under `collect` represent the various types of data that Telemetry is capable of collecting (i.e. `scopes`).",minProperties:1,properties:{js:{additionalProperties:!1,description:"Configuration for collecting telemetry data from JS files.",minProperties:1,properties:{functions:{anyOf:[{type:"null"},{additionalProperties:!1,properties:{allowedArgumentStringValues:{description:"Enable telemetry data collection for specific string function argument values. These are collected for all included functions. Boolean and numeric values are collected by default.",items:{type:"string"},minItems:1,type:"array"}},type:"object"}],description:"Enable telemetry data collection for JS functions. The set of included functions is determined by looking at import/require statements across analyzed source files."},tokens:{description:"Enable telemetry data collection for JS tokens. The set of included tokens is determined by looking at import/require statements across analyzed source files.",type:"null"}},type:"object"},jsx:{additionalProperties:!1,description:"Configuration for collecting telemetry data from JSX files.",minProperties:1,properties:{elements:{anyOf:[{type:"null"},{additionalProperties:!1,properties:{allowedAttributeNames:{description:"Enable telemetry data collection for specific JSX attributes. These are collected for all included JSX elements. Specifying an `attributeName` here will turn on data collection for boolean and numeric attribute values. String value data collection is handled separately via the `allowedAttributeStringValues` key.",items:{type:"string"},minItems:1,type:"array"},allowedAttributeStringValues:{description:"Enable telemetry data collection for specific string attribute values. These are collected for all defined attributes in the `allowedAttributeNames` key.",items:{type:"string"},minItems:1,type:"array"}},type:"object"}],description:"Enable telemetry data collection for JSX elements. The set of included elements is determined by looking at import/require statements across analyzed source files."}},type:"object"},npm:{additionalProperties:!1,description:"Configuration for collecting telemetry data from an npm environment.",minProperties:1,properties:{dependencies:{description:"Enable telemetry data collection for `dependencies`, `devDependencies`, and `peerDependencies` that are siblings of the instrumented package.",type:"null"}},type:"object"}},type:"object"},endpoint:{description:"URL of the telemetry data collection endpoint.",type:"string"},projectId:{description:"Unique identifier assigned on a per-project basis.",type:"string"},version:{const:1,description:"Current schema version.",type:"number"}},required:["version","projectId","endpoint","collect"],title:"Telemetry Config Schema",type:"object"}}};var xh=Object.freeze({PROJECT_ID:"project.id",DATE:"date",TELEMETRY_EMITTER_NAME:"telemetry.emitter.name",TELEMETRY_EMITTER_VERSION:"telemetry.emitter.version",ANALYZED_PATH:"analyzed.path",ANALYZED_HOST:"analyzed.host",ANALYZED_OWNER:"analyzed.owner",ANALYZED_REPOSITORY:"analyzed.repository",ANALYZED_COMMIT:"analyzed.commit",ANALYZED_REFS:"analyzed.refs"});var p2=Object.freeze({SCOPE_NAME:"js",JS_TOKEN_METRIC:"js.token",JS_FUNCTION_METRIC:"js.function",TOKEN_NAME:"js.token.name",TOKEN_ACCESS_PATH:"js.token.accessPath",TOKEN_MODULE_SPECIFIER:"js.token.module.specifier",FUNCTION_NAME:"js.function.name",FUNCTION_ACCESS_PATH:"js.function.accessPath",FUNCTION_ARGUMENT_VALUES:"js.function.arguments.values",FUNCTION_MODULE_SPECIFIER:"js.function.module.specifier"});var UI=Object.freeze({SCOPE_NAME:"jsx",JSX_ELEMENT_METRIC:"jsx.element",NAME:"jsx.element.name",MODULE_SPECIFIER:"jsx.element.module.specifier",ATTRIBUTE_NAMES:"jsx.element.attributes.names",ATTRIBUTE_VALUES:"jsx.element.attributes.values",ATTRIBUTE_MAP:"jsx.element.attributes.map"});var xa=Object.freeze({SCOPE_NAME:"npm",NPM_DEPENDENCY_METRIC:"npm.dependency",RAW:"npm.dependency.raw",OWNER:"npm.dependency.owner",NAME:"npm.dependency.name",IS_INSTRUMENTED:"npm.dependency.isInstrumented",INSTRUMENTED_RAW:"npm.dependency.instrumented.raw",INSTRUMENTED_OWNER:"npm.dependency.instrumented.owner",INSTRUMENTED_NAME:"npm.dependency.instrumented.name",INSTRUMENTED_VERSION_RAW:"npm.dependency.instrumented.version.raw",INSTRUMENTED_VERSION_MAJOR:"npm.dependency.instrumented.version.major",INSTRUMENTED_VERSION_MINOR:"npm.dependency.instrumented.version.minor",INSTRUMENTED_VERSION_PATCH:"npm.dependency.instrumented.version.patch",INSTRUMENTED_VERSION_PRE_RELEASE:"npm.dependency.instrumented.version.preRelease",VERSION_RAW:"npm.dependency.version.raw",VERSION_MAJOR:"npm.dependency.version.major",VERSION_MINOR:"npm.dependency.version.minor",VERSION_PATCH:"npm.dependency.version.patch",VERSION_PRE_RELEASE:"npm.dependency.version.preRelease"});var U_r=[p2.SCOPE_NAME,UI.SCOPE_NAME,xa.SCOPE_NAME];var Oht=cf(Pct(),1),Rht=cf(BDe(),1),Mht=cf(RF(),1);import{createHash as Nct}from"crypto";function JC(u,c){let f=Object.entries(u).map(([v,x])=>{if(!c.includes(v))return[v,x];if(Array.isArray(x)){let F=x.map(ee=>{if(typeof ee!="string")return ee;let me=Nct("sha256");return me.update(ee),me.digest("hex")});return[v,F]}if(typeof x!="string")return[v,x];let w=Nct("sha256");return w.update(x),[v,w.digest("hex")]});return Object.fromEntries(f)}var Xut=cf(Wut(),1);var $ue=class extends Error{constructor(c){super(JSON.stringify(c,void 0,2)),this.errors=c}};var Xtr=function(u,c,f,v){if(f==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof c=="function"?u!==c||!v:!c.has(u))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?v:f==="a"?v.call(u):v?v.value:c.get(u)},Ktr=function(u,c,f,v,x){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!x)throw new TypeError("Private accessor was defined without a setter");if(typeof c=="function"?u!==c||!x:!c.has(u))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?x.call(u,f):x?x.value=f:c.set(u,f),f},Wue,Kd=class{get logger(){return Xtr(this,Wue,"f")}constructor(c){Wue.set(this,void 0),Ktr(this,Wue,c,"f")}};Wue=new WeakMap;var E0r=cf(Hut(),1);var Gue=class extends Error{constructor(){super("Attempt to trace method without a defined Logger instance")}};import{appendFile as Qtr}from"fs/promises";import*as Yut from"util";function kh(u){return typeof u=="string"?u:Yut.inspect(u,{compact:!0,breakLength:1/0,depth:10,showHidden:!1,maxArrayLength:1e4,maxStringLength:1e4})}var Pwe=function(u,c,f,v,x){if(v==="m")throw new TypeError("Private method is not writable");if(v==="a"&&!x)throw new TypeError("Private accessor was defined without a setter");if(typeof c=="function"?u!==c||!x:!c.has(u))throw new TypeError("Cannot write private member to an object whose class did not declare it");return v==="a"?x.call(u,f):x?x.value=f:c.set(u,f),f},qW=function(u,c,f,v){if(f==="a"&&!v)throw new TypeError("Private accessor was defined without a getter");if(typeof c=="function"?u!==c||!v:!c.has(u))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?v:f==="a"?v.call(u):v?v.value:c.get(u)},Hue,i5,Yue,Ztr=250,err=1,s5=class{constructor(c){Hue.set(this,void 0),i5.set(this,void 0),Yue.set(this,void 0),Pwe(this,Hue,c,"f"),Pwe(this,i5,[],"f"),Pwe(this,Yue,setInterval(()=>{this.flush()},Ztr),"f"),console.log("Log file:",c)}async flush(){let c=qW(this,i5,"f").join("");await Qtr(qW(this,Hue,"f"),c),qW(this,i5,"f").splice(0)}async close(){clearInterval(qW(this,Yue,"f")),await this.flush()}debug(c,...f){this.log("debug",[c,...f])}error(c){let f;c instanceof Error?f=c.constructor.name+" "+c.stack:f=c,this.log("error",[f])}traceEnter(c,f,v){let x=v.map(kh).join(", ");this.debug(`--> ${c}::${f}(${x})`)}traceExit(c,f,v){if(v instanceof Promise){let x=err++;this.debug(`-?- ${c}::${f}(...): awaiting [Promise${x}]`),v.then(w=>{this.debug(`<-- ${c}::${f}(...): resolved [Promise${x}]: ${kh(w)}`)},w=>{this.error(`-x- ${c}::${f}(...): ${kh(w)}`),w instanceof Error&&this.error(w)})}else v instanceof Error?(this.error(`-x- ${c}::${f}(...): ${kh(v)}`),this.error(v)):this.debug(`<-- ${c}::${f}(...): ${kh(v)}`)}log(c,f){let v=new Date().toISOString();qW(this,i5,"f").push(c+" "+process.pid+" "+v+" "+f.join(" ")+`
`)}};Hue=new WeakMap,i5=new WeakMap,Yue=new WeakMap;function ku(u){return function(f,v,x){if(x.value===null||x.value===void 0||!(x.value instanceof Function))return;let w=f.constructor.name,F=x,ee=x.value;x.value=function(...me){let de=this.logger;if(!(de instanceof s5))throw new Gue;de.traceEnter(w,String(v),u?.argFormatter!==void 0?me.map(u.argFormatter):me);let Te;try{Te=ee.apply(this,me)}catch(ut){throw de.traceExit(w,String(v),ut),ut}return de.traceExit(w,String(v),Te),Te},Object.defineProperty(x.value,"name",{value:ee.name}),Reflect.getMetadataKeys(ee).forEach(me=>{Reflect.defineMetadata(me,Reflect.getMetadata(me,ee),F.value)})}}var trr=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},Nwe=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},rrr=Xut.default.default,zW=class extends Kd{constructor(c,f){super(f),this.ajvValidate=new rrr({allErrors:!0,verbose:!0}).compile(c)}validate(c){if(!this.ajvValidate(c))throw new $ue(this.ajvValidate.errors?.map(f=>{let{instancePath:v,keyword:x,message:w,params:F}=f;return{instancePath:v,keyword:x,message:w,params:F}})??[])}};trr([ku(),Nwe("design:type",Function),Nwe("design:paramtypes",[Object]),Nwe("design:returntype",void 0)],zW.prototype,"validate",null);import*as Qut from"child_process";var $W=class extends Error{constructor(c){super(JSON.stringify(c,void 0,2))}};var Xue=class extends Error{};function Kut(u){if(/[\\$;`]/.exec(u)!=null)throw new Xue("Command contained forbidden characters: "+u)}var nrr=5,WW=new Set;async function f1(u,c,f={},v=!0){for(c.traceEnter("","runCommand",[u,f,v]),Kut(u);WW.size>=nrr;)await Promise.any(WW);let x,w,F="",ee="",me=!1,de={env:process.env,shell:!0,...f},Te=new Promise((Ct,Kt)=>{x=Ct,w=Kt});WW.add(Te);let ut=Qut.spawn(u,de);return ut.stdout?.on("data",Ct=>{F+=Ct.toString()}),ut.stderr?.on("data",Ct=>{ee+=Ct.toString()}),ut.on("error",Ct=>{if(me)return;let Kt;WW.delete(Te),v?(Kt=new $W({exitCode:"errno"in Ct&&typeof Ct.errno=="number"?Ct.errno:-1,stderr:ee.trim(),stdout:F.trim(),exception:Ct,spawnOptions:de}),w(Kt)):(Kt={exitCode:"errno"in Ct&&typeof Ct.errno=="number"?Ct.errno:-1,stderr:ee,stdout:F},x(Kt)),me=!0,c.traceExit("","runCommand",Kt)}),ut.on("close",Ct=>{if(me)return;WW.delete(Te);let Kt;Ct!==0&&v?(Kt=new $W({exitCode:Ct??999,stderr:ee.trim(),stdout:F.trim(),spawnOptions:de}),w(Kt)):(Kt={exitCode:Ct??999,stderr:ee.trim(),stdout:F.trim()},x(Kt)),me=!0,c.traceExit("","runCommand",Kt)}),await Te}async function Zut(u,c){return(await f1("git rev-parse --show-toplevel",c,{cwd:u},!0)).stdout}function e_t(u){let c={host:void 0,owner:void 0,repository:void 0};return u.startsWith("http")?c=irr(u):u.startsWith("git@")&&(c=srr(u)),c.repository?.endsWith(".git")===!0&&(c.repository=c.repository.slice(0,-4)),c}function irr(u){let c=/^https?:\/\/([^/]+)\/([^/]+)\/([^/]+)/.exec(u)??[],[f,v,x,w]=c;return{host:v,owner:x,repository:w}}function srr(u){let c=/^([^@]+)@([^:]+):([^/]+)\/([^/]+)/.exec(u)??[],[f,v,x,w,F]=c;return{host:x,owner:w,repository:F}}var arr=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},Dwe=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},GW=class{constructor(c,f){this.cwd=c,this.logger=f}async getGitInfo(){let c=(await f1("git remote get-url origin",this.logger)).stdout,f=(await f1("git rev-parse HEAD",this.logger)).stdout,v=await this.getCommitBranches(f,this.cwd,this.logger),x=await this.getCommitTags(f,this.cwd,this.logger),w=e_t(c);return{gitOrigin:c,commitHash:f,commitBranches:v,commitTags:x,repository:w}}async getCommitBranches(c,f,v){return(await f1(`git branch --points-at=${c} --format='%(refname:short)'`,v,{cwd:f},!0)).stdout.split(/\r?\n/g).filter(w=>w!=="")}async getCommitTags(c,f,v){return(await f1(`git tag --points-at=${c} --format='%(refname:short)'`,v,{cwd:f},!0)).stdout.split(/\r?\n/g).filter(w=>w!=="")}};arr([ku(),Dwe("design:type",Function),Dwe("design:paramtypes",[]),Dwe("design:returntype",Promise)],GW.prototype,"getGitInfo",null);var Iwe=cf(VNe(),1),r_t=cf(RF(),1),n_t=cf(FC(),1);var t_t=cf(RF(),1),Kue=class extends t_t.MetricReader{async collect(c){return await super.collect(c)}async onShutdown(){throw new Error("Method not implemented.")}async onForceFlush(){throw new Error("Method not implemented.")}};var a5=class u{static getInstance(c=!1){return(c||u.instance===void 0)&&(u.instance=new u),u.instance}constructor(){this.isInitialized=!1}initialize(){if(this.isInitialized)return;let c=Iwe.Resource.default().merge(new Iwe.Resource({[n_t.SEMRESATTRS_SERVICE_NAME]:"IBM Telemetry",...this.attributes}));this.metricReader=new Kue,this.meterProvider=new r_t.MeterProvider({resource:c,readers:[this.metricReader]}),this.isInitialized=!0}setAttributes(c){this.attributes=c}getMetricReader(){return this.initialize(),this.metricReader}getMeterProvider(){return this.initialize(),this.meterProvider}};import{readFile as kir}from"fs/promises";function v_t(u){return typeof u>"u"||u===null}function orr(u){return typeof u=="object"&&u!==null}function crr(u){return Array.isArray(u)?u:v_t(u)?[]:[u]}function lrr(u,c){var f,v,x,w;if(c)for(w=Object.keys(c),f=0,v=w.length;f<v;f+=1)x=w[f],u[x]=c[x];return u}function urr(u,c){var f="",v;for(v=0;v<c;v+=1)f+=u;return f}function _rr(u){return u===0&&Number.NEGATIVE_INFINITY===1/u}var frr=v_t,prr=orr,drr=crr,mrr=urr,grr=_rr,hrr=lrr,Mg={isNothing:frr,isObject:prr,toArray:drr,repeat:mrr,isNegativeZero:grr,extend:hrr};function S_t(u,c){var f="",v=u.reason||"(unknown reason)";return u.mark?(u.mark.name&&(f+='in "'+u.mark.name+'" '),f+="("+(u.mark.line+1)+":"+(u.mark.column+1)+")",!c&&u.mark.snippet&&(f+=`

`+u.mark.snippet),v+" "+f):v}function YW(u,c){Error.call(this),this.name="YAMLException",this.reason=u,this.mark=c,this.message=S_t(this,!1),Error.captureStackTrace?Error.captureStackTrace(this,this.constructor):this.stack=new Error().stack||""}YW.prototype=Object.create(Error.prototype);YW.prototype.constructor=YW;YW.prototype.toString=function(c){return this.name+": "+S_t(this,c)};var p1=YW;function wwe(u,c,f,v,x){var w="",F="",ee=Math.floor(x/2)-1;return v-c>ee&&(w=" ... ",c=v-ee+w.length),f-v>ee&&(F=" ...",f=v+ee-F.length),{str:w+u.slice(c,f).replace(/\t/g,"\u2192")+F,pos:v-c+w.length}}function Owe(u,c){return Mg.repeat(" ",c-u.length)+u}function yrr(u,c){if(c=Object.create(c||null),!u.buffer)return null;c.maxLength||(c.maxLength=79),typeof c.indent!="number"&&(c.indent=1),typeof c.linesBefore!="number"&&(c.linesBefore=3),typeof c.linesAfter!="number"&&(c.linesAfter=2);for(var f=/\r?\n|\r|\0/g,v=[0],x=[],w,F=-1;w=f.exec(u.buffer);)x.push(w.index),v.push(w.index+w[0].length),u.position<=w.index&&F<0&&(F=v.length-2);F<0&&(F=v.length-1);var ee="",me,de,Te=Math.min(u.line+c.linesAfter,x.length).toString().length,ut=c.maxLength-(c.indent+Te+3);for(me=1;me<=c.linesBefore&&!(F-me<0);me++)de=wwe(u.buffer,v[F-me],x[F-me],u.position-(v[F]-v[F-me]),ut),ee=Mg.repeat(" ",c.indent)+Owe((u.line-me+1).toString(),Te)+" | "+de.str+`
`+ee;for(de=wwe(u.buffer,v[F],x[F],u.position,ut),ee+=Mg.repeat(" ",c.indent)+Owe((u.line+1).toString(),Te)+" | "+de.str+`
`,ee+=Mg.repeat("-",c.indent+Te+3+de.pos)+`^
`,me=1;me<=c.linesAfter&&!(F+me>=x.length);me++)de=wwe(u.buffer,v[F+me],x[F+me],u.position-(v[F]-v[F+me]),ut),ee+=Mg.repeat(" ",c.indent)+Owe((u.line+me+1).toString(),Te)+" | "+de.str+`
`;return ee.replace(/\n$/,"")}var vrr=yrr,Srr=["kind","multi","resolve","construct","instanceOf","predicate","represent","representName","defaultStyle","styleAliases"],Trr=["scalar","sequence","mapping"];function brr(u){var c={};return u!==null&&Object.keys(u).forEach(function(f){u[f].forEach(function(v){c[String(v)]=f})}),c}function Err(u,c){if(c=c||{},Object.keys(c).forEach(function(f){if(Srr.indexOf(f)===-1)throw new p1('Unknown option "'+f+'" is met in definition of "'+u+'" YAML type.')}),this.options=c,this.tag=u,this.kind=c.kind||null,this.resolve=c.resolve||function(){return!0},this.construct=c.construct||function(f){return f},this.instanceOf=c.instanceOf||null,this.predicate=c.predicate||null,this.represent=c.represent||null,this.representName=c.representName||null,this.defaultStyle=c.defaultStyle||null,this.multi=c.multi||!1,this.styleAliases=brr(c.styleAliases||null),Trr.indexOf(this.kind)===-1)throw new p1('Unknown kind "'+this.kind+'" is specified for "'+u+'" YAML type.')}var h0=Err;function i_t(u,c){var f=[];return u[c].forEach(function(v){var x=f.length;f.forEach(function(w,F){w.tag===v.tag&&w.kind===v.kind&&w.multi===v.multi&&(x=F)}),f[x]=v}),f}function xrr(){var u={scalar:{},sequence:{},mapping:{},fallback:{},multi:{scalar:[],sequence:[],mapping:[],fallback:[]}},c,f;function v(x){x.multi?(u.multi[x.kind].push(x),u.multi.fallback.push(x)):u[x.kind][x.tag]=u.fallback[x.tag]=x}for(c=0,f=arguments.length;c<f;c+=1)arguments[c].forEach(v);return u}function Mwe(u){return this.extend(u)}Mwe.prototype.extend=function(c){var f=[],v=[];if(c instanceof h0)v.push(c);else if(Array.isArray(c))v=v.concat(c);else if(c&&(Array.isArray(c.implicit)||Array.isArray(c.explicit)))c.implicit&&(f=f.concat(c.implicit)),c.explicit&&(v=v.concat(c.explicit));else throw new p1("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");f.forEach(function(w){if(!(w instanceof h0))throw new p1("Specified list of YAML types (or a single Type object) contains a non-Type object.");if(w.loadKind&&w.loadKind!=="scalar")throw new p1("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");if(w.multi)throw new p1("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.")}),v.forEach(function(w){if(!(w instanceof h0))throw new p1("Specified list of YAML types (or a single Type object) contains a non-Type object.")});var x=Object.create(Mwe.prototype);return x.implicit=(this.implicit||[]).concat(f),x.explicit=(this.explicit||[]).concat(v),x.compiledImplicit=i_t(x,"implicit"),x.compiledExplicit=i_t(x,"explicit"),x.compiledTypeMap=xrr(x.compiledImplicit,x.compiledExplicit),x};var T_t=Mwe,b_t=new h0("tag:yaml.org,2002:str",{kind:"scalar",construct:function(u){return u!==null?u:""}}),E_t=new h0("tag:yaml.org,2002:seq",{kind:"sequence",construct:function(u){return u!==null?u:[]}}),x_t=new h0("tag:yaml.org,2002:map",{kind:"mapping",construct:function(u){return u!==null?u:{}}}),C_t=new T_t({explicit:[b_t,E_t,x_t]});function Crr(u){if(u===null)return!0;var c=u.length;return c===1&&u==="~"||c===4&&(u==="null"||u==="Null"||u==="NULL")}function Arr(){return null}function krr(u){return u===null}var A_t=new h0("tag:yaml.org,2002:null",{kind:"scalar",resolve:Crr,construct:Arr,predicate:krr,represent:{canonical:function(){return"~"},lowercase:function(){return"null"},uppercase:function(){return"NULL"},camelcase:function(){return"Null"},empty:function(){return""}},defaultStyle:"lowercase"});function Prr(u){if(u===null)return!1;var c=u.length;return c===4&&(u==="true"||u==="True"||u==="TRUE")||c===5&&(u==="false"||u==="False"||u==="FALSE")}function Nrr(u){return u==="true"||u==="True"||u==="TRUE"}function Drr(u){return Object.prototype.toString.call(u)==="[object Boolean]"}var k_t=new h0("tag:yaml.org,2002:bool",{kind:"scalar",resolve:Prr,construct:Nrr,predicate:Drr,represent:{lowercase:function(u){return u?"true":"false"},uppercase:function(u){return u?"TRUE":"FALSE"},camelcase:function(u){return u?"True":"False"}},defaultStyle:"lowercase"});function Irr(u){return 48<=u&&u<=57||65<=u&&u<=70||97<=u&&u<=102}function wrr(u){return 48<=u&&u<=55}function Orr(u){return 48<=u&&u<=57}function Rrr(u){if(u===null)return!1;var c=u.length,f=0,v=!1,x;if(!c)return!1;if(x=u[f],(x==="-"||x==="+")&&(x=u[++f]),x==="0"){if(f+1===c)return!0;if(x=u[++f],x==="b"){for(f++;f<c;f++)if(x=u[f],x!=="_"){if(x!=="0"&&x!=="1")return!1;v=!0}return v&&x!=="_"}if(x==="x"){for(f++;f<c;f++)if(x=u[f],x!=="_"){if(!Irr(u.charCodeAt(f)))return!1;v=!0}return v&&x!=="_"}if(x==="o"){for(f++;f<c;f++)if(x=u[f],x!=="_"){if(!wrr(u.charCodeAt(f)))return!1;v=!0}return v&&x!=="_"}}if(x==="_")return!1;for(;f<c;f++)if(x=u[f],x!=="_"){if(!Orr(u.charCodeAt(f)))return!1;v=!0}return!(!v||x==="_")}function Mrr(u){var c=u,f=1,v;if(c.indexOf("_")!==-1&&(c=c.replace(/_/g,"")),v=c[0],(v==="-"||v==="+")&&(v==="-"&&(f=-1),c=c.slice(1),v=c[0]),c==="0")return 0;if(v==="0"){if(c[1]==="b")return f*parseInt(c.slice(2),2);if(c[1]==="x")return f*parseInt(c.slice(2),16);if(c[1]==="o")return f*parseInt(c.slice(2),8)}return f*parseInt(c,10)}function Lrr(u){return Object.prototype.toString.call(u)==="[object Number]"&&u%1===0&&!Mg.isNegativeZero(u)}var P_t=new h0("tag:yaml.org,2002:int",{kind:"scalar",resolve:Rrr,construct:Mrr,predicate:Lrr,represent:{binary:function(u){return u>=0?"0b"+u.toString(2):"-0b"+u.toString(2).slice(1)},octal:function(u){return u>=0?"0o"+u.toString(8):"-0o"+u.toString(8).slice(1)},decimal:function(u){return u.toString(10)},hexadecimal:function(u){return u>=0?"0x"+u.toString(16).toUpperCase():"-0x"+u.toString(16).toUpperCase().slice(1)}},defaultStyle:"decimal",styleAliases:{binary:[2,"bin"],octal:[8,"oct"],decimal:[10,"dec"],hexadecimal:[16,"hex"]}}),Frr=new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");function jrr(u){return!(u===null||!Frr.test(u)||u[u.length-1]==="_")}function Brr(u){var c,f;return c=u.replace(/_/g,"").toLowerCase(),f=c[0]==="-"?-1:1,"+-".indexOf(c[0])>=0&&(c=c.slice(1)),c===".inf"?f===1?Number.POSITIVE_INFINITY:Number.NEGATIVE_INFINITY:c===".nan"?NaN:f*parseFloat(c,10)}var Urr=/^[-+]?[0-9]+e/;function Vrr(u,c){var f;if(isNaN(u))switch(c){case"lowercase":return".nan";case"uppercase":return".NAN";case"camelcase":return".NaN"}else if(Number.POSITIVE_INFINITY===u)switch(c){case"lowercase":return".inf";case"uppercase":return".INF";case"camelcase":return".Inf"}else if(Number.NEGATIVE_INFINITY===u)switch(c){case"lowercase":return"-.inf";case"uppercase":return"-.INF";case"camelcase":return"-.Inf"}else if(Mg.isNegativeZero(u))return"-0.0";return f=u.toString(10),Urr.test(f)?f.replace("e",".e"):f}function Jrr(u){return Object.prototype.toString.call(u)==="[object Number]"&&(u%1!==0||Mg.isNegativeZero(u))}var N_t=new h0("tag:yaml.org,2002:float",{kind:"scalar",resolve:jrr,construct:Brr,predicate:Jrr,represent:Vrr,defaultStyle:"lowercase"}),D_t=C_t.extend({implicit:[A_t,k_t,P_t,N_t]}),I_t=D_t,w_t=new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$"),O_t=new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$");function qrr(u){return u===null?!1:w_t.exec(u)!==null||O_t.exec(u)!==null}function zrr(u){var c,f,v,x,w,F,ee,me=0,de=null,Te,ut,Ct;if(c=w_t.exec(u),c===null&&(c=O_t.exec(u)),c===null)throw new Error("Date resolve error");if(f=+c[1],v=+c[2]-1,x=+c[3],!c[4])return new Date(Date.UTC(f,v,x));if(w=+c[4],F=+c[5],ee=+c[6],c[7]){for(me=c[7].slice(0,3);me.length<3;)me+="0";me=+me}return c[9]&&(Te=+c[10],ut=+(c[11]||0),de=(Te*60+ut)*6e4,c[9]==="-"&&(de=-de)),Ct=new Date(Date.UTC(f,v,x,w,F,ee,me)),de&&Ct.setTime(Ct.getTime()-de),Ct}function $rr(u){return u.toISOString()}var R_t=new h0("tag:yaml.org,2002:timestamp",{kind:"scalar",resolve:qrr,construct:zrr,instanceOf:Date,represent:$rr});function Wrr(u){return u==="<<"||u===null}var M_t=new h0("tag:yaml.org,2002:merge",{kind:"scalar",resolve:Wrr}),Uwe=`ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=
\r`;function Grr(u){if(u===null)return!1;var c,f,v=0,x=u.length,w=Uwe;for(f=0;f<x;f++)if(c=w.indexOf(u.charAt(f)),!(c>64)){if(c<0)return!1;v+=6}return v%8===0}function Hrr(u){var c,f,v=u.replace(/[\r\n=]/g,""),x=v.length,w=Uwe,F=0,ee=[];for(c=0;c<x;c++)c%4===0&&c&&(ee.push(F>>16&255),ee.push(F>>8&255),ee.push(F&255)),F=F<<6|w.indexOf(v.charAt(c));return f=x%4*6,f===0?(ee.push(F>>16&255),ee.push(F>>8&255),ee.push(F&255)):f===18?(ee.push(F>>10&255),ee.push(F>>2&255)):f===12&&ee.push(F>>4&255),new Uint8Array(ee)}function Yrr(u){var c="",f=0,v,x,w=u.length,F=Uwe;for(v=0;v<w;v++)v%3===0&&v&&(c+=F[f>>18&63],c+=F[f>>12&63],c+=F[f>>6&63],c+=F[f&63]),f=(f<<8)+u[v];return x=w%3,x===0?(c+=F[f>>18&63],c+=F[f>>12&63],c+=F[f>>6&63],c+=F[f&63]):x===2?(c+=F[f>>10&63],c+=F[f>>4&63],c+=F[f<<2&63],c+=F[64]):x===1&&(c+=F[f>>2&63],c+=F[f<<4&63],c+=F[64],c+=F[64]),c}function Xrr(u){return Object.prototype.toString.call(u)==="[object Uint8Array]"}var L_t=new h0("tag:yaml.org,2002:binary",{kind:"scalar",resolve:Grr,construct:Hrr,predicate:Xrr,represent:Yrr}),Krr=Object.prototype.hasOwnProperty,Qrr=Object.prototype.toString;function Zrr(u){if(u===null)return!0;var c=[],f,v,x,w,F,ee=u;for(f=0,v=ee.length;f<v;f+=1){if(x=ee[f],F=!1,Qrr.call(x)!=="[object Object]")return!1;for(w in x)if(Krr.call(x,w))if(!F)F=!0;else return!1;if(!F)return!1;if(c.indexOf(w)===-1)c.push(w);else return!1}return!0}function enr(u){return u!==null?u:[]}var F_t=new h0("tag:yaml.org,2002:omap",{kind:"sequence",resolve:Zrr,construct:enr}),tnr=Object.prototype.toString;function rnr(u){if(u===null)return!0;var c,f,v,x,w,F=u;for(w=new Array(F.length),c=0,f=F.length;c<f;c+=1){if(v=F[c],tnr.call(v)!=="[object Object]"||(x=Object.keys(v),x.length!==1))return!1;w[c]=[x[0],v[x[0]]]}return!0}function nnr(u){if(u===null)return[];var c,f,v,x,w,F=u;for(w=new Array(F.length),c=0,f=F.length;c<f;c+=1)v=F[c],x=Object.keys(v),w[c]=[x[0],v[x[0]]];return w}var j_t=new h0("tag:yaml.org,2002:pairs",{kind:"sequence",resolve:rnr,construct:nnr}),inr=Object.prototype.hasOwnProperty;function snr(u){if(u===null)return!0;var c,f=u;for(c in f)if(inr.call(f,c)&&f[c]!==null)return!1;return!0}function anr(u){return u!==null?u:{}}var B_t=new h0("tag:yaml.org,2002:set",{kind:"mapping",resolve:snr,construct:anr}),Vwe=I_t.extend({implicit:[R_t,M_t],explicit:[L_t,F_t,j_t,B_t]}),ow=Object.prototype.hasOwnProperty,Que=1,U_t=2,V_t=3,Zue=4,Rwe=1,onr=2,s_t=3,cnr=/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/,lnr=/[\x85\u2028\u2029]/,unr=/[,\[\]\{\}]/,J_t=/^(?:!|!!|![a-z\-]+!)$/i,q_t=/^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;function a_t(u){return Object.prototype.toString.call(u)}function WC(u){return u===10||u===13}function p3(u){return u===9||u===32}function vv(u){return u===9||u===32||u===10||u===13}function c5(u){return u===44||u===91||u===93||u===123||u===125}function _nr(u){var c;return 48<=u&&u<=57?u-48:(c=u|32,97<=c&&c<=102?c-97+10:-1)}function fnr(u){return u===120?2:u===117?4:u===85?8:0}function pnr(u){return 48<=u&&u<=57?u-48:-1}function o_t(u){return u===48?"\0":u===97?"\x07":u===98?"\b":u===116||u===9?"	":u===110?`
`:u===118?"\v":u===102?"\f":u===114?"\r":u===101?"\x1B":u===32?" ":u===34?'"':u===47?"/":u===92?"\\":u===78?"\x85":u===95?"\xA0":u===76?"\u2028":u===80?"\u2029":""}function dnr(u){return u<=65535?String.fromCharCode(u):String.fromCharCode((u-65536>>10)+55296,(u-65536&1023)+56320)}var z_t=new Array(256),$_t=new Array(256);for(f3=0;f3<256;f3++)z_t[f3]=o_t(f3)?1:0,$_t[f3]=o_t(f3);var f3;function mnr(u,c){this.input=u,this.filename=c.filename||null,this.schema=c.schema||Vwe,this.onWarning=c.onWarning||null,this.legacy=c.legacy||!1,this.json=c.json||!1,this.listener=c.listener||null,this.implicitTypes=this.schema.compiledImplicit,this.typeMap=this.schema.compiledTypeMap,this.length=u.length,this.position=0,this.line=0,this.lineStart=0,this.lineIndent=0,this.firstTabInLine=-1,this.documents=[]}function W_t(u,c){var f={name:u.filename,buffer:u.input.slice(0,-1),position:u.position,line:u.line,column:u.position-u.lineStart};return f.snippet=vrr(f),new p1(c,f)}function Ro(u,c){throw W_t(u,c)}function e_e(u,c){u.onWarning&&u.onWarning.call(null,W_t(u,c))}var c_t={YAML:function(c,f,v){var x,w,F;c.version!==null&&Ro(c,"duplication of %YAML directive"),v.length!==1&&Ro(c,"YAML directive accepts exactly one argument"),x=/^([0-9]+)\.([0-9]+)$/.exec(v[0]),x===null&&Ro(c,"ill-formed argument of the YAML directive"),w=parseInt(x[1],10),F=parseInt(x[2],10),w!==1&&Ro(c,"unacceptable YAML version of the document"),c.version=v[0],c.checkLineBreaks=F<2,F!==1&&F!==2&&e_e(c,"unsupported YAML version of the document")},TAG:function(c,f,v){var x,w;v.length!==2&&Ro(c,"TAG directive accepts exactly two arguments"),x=v[0],w=v[1],J_t.test(x)||Ro(c,"ill-formed tag handle (first argument) of the TAG directive"),ow.call(c.tagMap,x)&&Ro(c,'there is a previously declared suffix for "'+x+'" tag handle'),q_t.test(w)||Ro(c,"ill-formed tag prefix (second argument) of the TAG directive");try{w=decodeURIComponent(w)}catch{Ro(c,"tag prefix is malformed: "+w)}c.tagMap[x]=w}};function aw(u,c,f,v){var x,w,F,ee;if(c<f){if(ee=u.input.slice(c,f),v)for(x=0,w=ee.length;x<w;x+=1)F=ee.charCodeAt(x),F===9||32<=F&&F<=1114111||Ro(u,"expected valid JSON character");else cnr.test(ee)&&Ro(u,"the stream contains non-printable characters");u.result+=ee}}function l_t(u,c,f,v){var x,w,F,ee;for(Mg.isObject(f)||Ro(u,"cannot merge mappings; the provided source object is unacceptable"),x=Object.keys(f),F=0,ee=x.length;F<ee;F+=1)w=x[F],ow.call(c,w)||(c[w]=f[w],v[w]=!0)}function l5(u,c,f,v,x,w,F,ee,me){var de,Te;if(Array.isArray(x))for(x=Array.prototype.slice.call(x),de=0,Te=x.length;de<Te;de+=1)Array.isArray(x[de])&&Ro(u,"nested arrays are not supported inside keys"),typeof x=="object"&&a_t(x[de])==="[object Object]"&&(x[de]="[object Object]");if(typeof x=="object"&&a_t(x)==="[object Object]"&&(x="[object Object]"),x=String(x),c===null&&(c={}),v==="tag:yaml.org,2002:merge")if(Array.isArray(w))for(de=0,Te=w.length;de<Te;de+=1)l_t(u,c,w[de],f);else l_t(u,c,w,f);else!u.json&&!ow.call(f,x)&&ow.call(c,x)&&(u.line=F||u.line,u.lineStart=ee||u.lineStart,u.position=me||u.position,Ro(u,"duplicated mapping key")),x==="__proto__"?Object.defineProperty(c,x,{configurable:!0,enumerable:!0,writable:!0,value:w}):c[x]=w,delete f[x];return c}function Jwe(u){var c;c=u.input.charCodeAt(u.position),c===10?u.position++:c===13?(u.position++,u.input.charCodeAt(u.position)===10&&u.position++):Ro(u,"a line break is expected"),u.line+=1,u.lineStart=u.position,u.firstTabInLine=-1}function ag(u,c,f){for(var v=0,x=u.input.charCodeAt(u.position);x!==0;){for(;p3(x);)x===9&&u.firstTabInLine===-1&&(u.firstTabInLine=u.position),x=u.input.charCodeAt(++u.position);if(c&&x===35)do x=u.input.charCodeAt(++u.position);while(x!==10&&x!==13&&x!==0);if(WC(x))for(Jwe(u),x=u.input.charCodeAt(u.position),v++,u.lineIndent=0;x===32;)u.lineIndent++,x=u.input.charCodeAt(++u.position);else break}return f!==-1&&v!==0&&u.lineIndent<f&&e_e(u,"deficient indentation"),v}function n_e(u){var c=u.position,f;return f=u.input.charCodeAt(c),!!((f===45||f===46)&&f===u.input.charCodeAt(c+1)&&f===u.input.charCodeAt(c+2)&&(c+=3,f=u.input.charCodeAt(c),f===0||vv(f)))}function qwe(u,c){c===1?u.result+=" ":c>1&&(u.result+=Mg.repeat(`
`,c-1))}function gnr(u,c,f){var v,x,w,F,ee,me,de,Te,ut=u.kind,Ct=u.result,Kt;if(Kt=u.input.charCodeAt(u.position),vv(Kt)||c5(Kt)||Kt===35||Kt===38||Kt===42||Kt===33||Kt===124||Kt===62||Kt===39||Kt===34||Kt===37||Kt===64||Kt===96||(Kt===63||Kt===45)&&(x=u.input.charCodeAt(u.position+1),vv(x)||f&&c5(x)))return!1;for(u.kind="scalar",u.result="",w=F=u.position,ee=!1;Kt!==0;){if(Kt===58){if(x=u.input.charCodeAt(u.position+1),vv(x)||f&&c5(x))break}else if(Kt===35){if(v=u.input.charCodeAt(u.position-1),vv(v))break}else{if(u.position===u.lineStart&&n_e(u)||f&&c5(Kt))break;if(WC(Kt))if(me=u.line,de=u.lineStart,Te=u.lineIndent,ag(u,!1,-1),u.lineIndent>=c){ee=!0,Kt=u.input.charCodeAt(u.position);continue}else{u.position=F,u.line=me,u.lineStart=de,u.lineIndent=Te;break}}ee&&(aw(u,w,F,!1),qwe(u,u.line-me),w=F=u.position,ee=!1),p3(Kt)||(F=u.position+1),Kt=u.input.charCodeAt(++u.position)}return aw(u,w,F,!1),u.result?!0:(u.kind=ut,u.result=Ct,!1)}function hnr(u,c){var f,v,x;if(f=u.input.charCodeAt(u.position),f!==39)return!1;for(u.kind="scalar",u.result="",u.position++,v=x=u.position;(f=u.input.charCodeAt(u.position))!==0;)if(f===39)if(aw(u,v,u.position,!0),f=u.input.charCodeAt(++u.position),f===39)v=u.position,u.position++,x=u.position;else return!0;else WC(f)?(aw(u,v,x,!0),qwe(u,ag(u,!1,c)),v=x=u.position):u.position===u.lineStart&&n_e(u)?Ro(u,"unexpected end of the document within a single quoted scalar"):(u.position++,x=u.position);Ro(u,"unexpected end of the stream within a single quoted scalar")}function ynr(u,c){var f,v,x,w,F,ee;if(ee=u.input.charCodeAt(u.position),ee!==34)return!1;for(u.kind="scalar",u.result="",u.position++,f=v=u.position;(ee=u.input.charCodeAt(u.position))!==0;){if(ee===34)return aw(u,f,u.position,!0),u.position++,!0;if(ee===92){if(aw(u,f,u.position,!0),ee=u.input.charCodeAt(++u.position),WC(ee))ag(u,!1,c);else if(ee<256&&z_t[ee])u.result+=$_t[ee],u.position++;else if((F=fnr(ee))>0){for(x=F,w=0;x>0;x--)ee=u.input.charCodeAt(++u.position),(F=_nr(ee))>=0?w=(w<<4)+F:Ro(u,"expected hexadecimal character");u.result+=dnr(w),u.position++}else Ro(u,"unknown escape sequence");f=v=u.position}else WC(ee)?(aw(u,f,v,!0),qwe(u,ag(u,!1,c)),f=v=u.position):u.position===u.lineStart&&n_e(u)?Ro(u,"unexpected end of the document within a double quoted scalar"):(u.position++,v=u.position)}Ro(u,"unexpected end of the stream within a double quoted scalar")}function vnr(u,c){var f=!0,v,x,w,F=u.tag,ee,me=u.anchor,de,Te,ut,Ct,Kt,xr=Object.create(null),en,zn,yr,mr;if(mr=u.input.charCodeAt(u.position),mr===91)Te=93,Kt=!1,ee=[];else if(mr===123)Te=125,Kt=!0,ee={};else return!1;for(u.anchor!==null&&(u.anchorMap[u.anchor]=ee),mr=u.input.charCodeAt(++u.position);mr!==0;){if(ag(u,!0,c),mr=u.input.charCodeAt(u.position),mr===Te)return u.position++,u.tag=F,u.anchor=me,u.kind=Kt?"mapping":"sequence",u.result=ee,!0;f?mr===44&&Ro(u,"expected the node content, but found ','"):Ro(u,"missed comma between flow collection entries"),zn=en=yr=null,ut=Ct=!1,mr===63&&(de=u.input.charCodeAt(u.position+1),vv(de)&&(ut=Ct=!0,u.position++,ag(u,!0,c))),v=u.line,x=u.lineStart,w=u.position,u5(u,c,Que,!1,!0),zn=u.tag,en=u.result,ag(u,!0,c),mr=u.input.charCodeAt(u.position),(Ct||u.line===v)&&mr===58&&(ut=!0,mr=u.input.charCodeAt(++u.position),ag(u,!0,c),u5(u,c,Que,!1,!0),yr=u.result),Kt?l5(u,ee,xr,zn,en,yr,v,x,w):ut?ee.push(l5(u,null,xr,zn,en,yr,v,x,w)):ee.push(en),ag(u,!0,c),mr=u.input.charCodeAt(u.position),mr===44?(f=!0,mr=u.input.charCodeAt(++u.position)):f=!1}Ro(u,"unexpected end of the stream within a flow collection")}function Snr(u,c){var f,v,x=Rwe,w=!1,F=!1,ee=c,me=0,de=!1,Te,ut;if(ut=u.input.charCodeAt(u.position),ut===124)v=!1;else if(ut===62)v=!0;else return!1;for(u.kind="scalar",u.result="";ut!==0;)if(ut=u.input.charCodeAt(++u.position),ut===43||ut===45)Rwe===x?x=ut===43?s_t:onr:Ro(u,"repeat of a chomping mode identifier");else if((Te=pnr(ut))>=0)Te===0?Ro(u,"bad explicit indentation width of a block scalar; it cannot be less than one"):F?Ro(u,"repeat of an indentation width identifier"):(ee=c+Te-1,F=!0);else break;if(p3(ut)){do ut=u.input.charCodeAt(++u.position);while(p3(ut));if(ut===35)do ut=u.input.charCodeAt(++u.position);while(!WC(ut)&&ut!==0)}for(;ut!==0;){for(Jwe(u),u.lineIndent=0,ut=u.input.charCodeAt(u.position);(!F||u.lineIndent<ee)&&ut===32;)u.lineIndent++,ut=u.input.charCodeAt(++u.position);if(!F&&u.lineIndent>ee&&(ee=u.lineIndent),WC(ut)){me++;continue}if(u.lineIndent<ee){x===s_t?u.result+=Mg.repeat(`
`,w?1+me:me):x===Rwe&&w&&(u.result+=`
`);break}for(v?p3(ut)?(de=!0,u.result+=Mg.repeat(`
`,w?1+me:me)):de?(de=!1,u.result+=Mg.repeat(`
`,me+1)):me===0?w&&(u.result+=" "):u.result+=Mg.repeat(`
`,me):u.result+=Mg.repeat(`
`,w?1+me:me),w=!0,F=!0,me=0,f=u.position;!WC(ut)&&ut!==0;)ut=u.input.charCodeAt(++u.position);aw(u,f,u.position,!1)}return!0}function u_t(u,c){var f,v=u.tag,x=u.anchor,w=[],F,ee=!1,me;if(u.firstTabInLine!==-1)return!1;for(u.anchor!==null&&(u.anchorMap[u.anchor]=w),me=u.input.charCodeAt(u.position);me!==0&&(u.firstTabInLine!==-1&&(u.position=u.firstTabInLine,Ro(u,"tab characters must not be used in indentation")),!(me!==45||(F=u.input.charCodeAt(u.position+1),!vv(F))));){if(ee=!0,u.position++,ag(u,!0,-1)&&u.lineIndent<=c){w.push(null),me=u.input.charCodeAt(u.position);continue}if(f=u.line,u5(u,c,V_t,!1,!0),w.push(u.result),ag(u,!0,-1),me=u.input.charCodeAt(u.position),(u.line===f||u.lineIndent>c)&&me!==0)Ro(u,"bad indentation of a sequence entry");else if(u.lineIndent<c)break}return ee?(u.tag=v,u.anchor=x,u.kind="sequence",u.result=w,!0):!1}function Tnr(u,c,f){var v,x,w,F,ee,me,de=u.tag,Te=u.anchor,ut={},Ct=Object.create(null),Kt=null,xr=null,en=null,zn=!1,yr=!1,mr;if(u.firstTabInLine!==-1)return!1;for(u.anchor!==null&&(u.anchorMap[u.anchor]=ut),mr=u.input.charCodeAt(u.position);mr!==0;){if(!zn&&u.firstTabInLine!==-1&&(u.position=u.firstTabInLine,Ro(u,"tab characters must not be used in indentation")),v=u.input.charCodeAt(u.position+1),w=u.line,(mr===63||mr===58)&&vv(v))mr===63?(zn&&(l5(u,ut,Ct,Kt,xr,null,F,ee,me),Kt=xr=en=null),yr=!0,zn=!0,x=!0):zn?(zn=!1,x=!0):Ro(u,"incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line"),u.position+=1,mr=v;else{if(F=u.line,ee=u.lineStart,me=u.position,!u5(u,f,U_t,!1,!0))break;if(u.line===w){for(mr=u.input.charCodeAt(u.position);p3(mr);)mr=u.input.charCodeAt(++u.position);if(mr===58)mr=u.input.charCodeAt(++u.position),vv(mr)||Ro(u,"a whitespace character is expected after the key-value separator within a block mapping"),zn&&(l5(u,ut,Ct,Kt,xr,null,F,ee,me),Kt=xr=en=null),yr=!0,zn=!1,x=!1,Kt=u.tag,xr=u.result;else if(yr)Ro(u,"can not read an implicit mapping pair; a colon is missed");else return u.tag=de,u.anchor=Te,!0}else if(yr)Ro(u,"can not read a block mapping entry; a multiline key may not be an implicit key");else return u.tag=de,u.anchor=Te,!0}if((u.line===w||u.lineIndent>c)&&(zn&&(F=u.line,ee=u.lineStart,me=u.position),u5(u,c,Zue,!0,x)&&(zn?xr=u.result:en=u.result),zn||(l5(u,ut,Ct,Kt,xr,en,F,ee,me),Kt=xr=en=null),ag(u,!0,-1),mr=u.input.charCodeAt(u.position)),(u.line===w||u.lineIndent>c)&&mr!==0)Ro(u,"bad indentation of a mapping entry");else if(u.lineIndent<c)break}return zn&&l5(u,ut,Ct,Kt,xr,null,F,ee,me),yr&&(u.tag=de,u.anchor=Te,u.kind="mapping",u.result=ut),yr}function bnr(u){var c,f=!1,v=!1,x,w,F;if(F=u.input.charCodeAt(u.position),F!==33)return!1;if(u.tag!==null&&Ro(u,"duplication of a tag property"),F=u.input.charCodeAt(++u.position),F===60?(f=!0,F=u.input.charCodeAt(++u.position)):F===33?(v=!0,x="!!",F=u.input.charCodeAt(++u.position)):x="!",c=u.position,f){do F=u.input.charCodeAt(++u.position);while(F!==0&&F!==62);u.position<u.length?(w=u.input.slice(c,u.position),F=u.input.charCodeAt(++u.position)):Ro(u,"unexpected end of the stream within a verbatim tag")}else{for(;F!==0&&!vv(F);)F===33&&(v?Ro(u,"tag suffix cannot contain exclamation marks"):(x=u.input.slice(c-1,u.position+1),J_t.test(x)||Ro(u,"named tag handle cannot contain such characters"),v=!0,c=u.position+1)),F=u.input.charCodeAt(++u.position);w=u.input.slice(c,u.position),unr.test(w)&&Ro(u,"tag suffix cannot contain flow indicator characters")}w&&!q_t.test(w)&&Ro(u,"tag name cannot contain such characters: "+w);try{w=decodeURIComponent(w)}catch{Ro(u,"tag name is malformed: "+w)}return f?u.tag=w:ow.call(u.tagMap,x)?u.tag=u.tagMap[x]+w:x==="!"?u.tag="!"+w:x==="!!"?u.tag="tag:yaml.org,2002:"+w:Ro(u,'undeclared tag handle "'+x+'"'),!0}function Enr(u){var c,f;if(f=u.input.charCodeAt(u.position),f!==38)return!1;for(u.anchor!==null&&Ro(u,"duplication of an anchor property"),f=u.input.charCodeAt(++u.position),c=u.position;f!==0&&!vv(f)&&!c5(f);)f=u.input.charCodeAt(++u.position);return u.position===c&&Ro(u,"name of an anchor node must contain at least one character"),u.anchor=u.input.slice(c,u.position),!0}function xnr(u){var c,f,v;if(v=u.input.charCodeAt(u.position),v!==42)return!1;for(v=u.input.charCodeAt(++u.position),c=u.position;v!==0&&!vv(v)&&!c5(v);)v=u.input.charCodeAt(++u.position);return u.position===c&&Ro(u,"name of an alias node must contain at least one character"),f=u.input.slice(c,u.position),ow.call(u.anchorMap,f)||Ro(u,'unidentified alias "'+f+'"'),u.result=u.anchorMap[f],ag(u,!0,-1),!0}function u5(u,c,f,v,x){var w,F,ee,me=1,de=!1,Te=!1,ut,Ct,Kt,xr,en,zn;if(u.listener!==null&&u.listener("open",u),u.tag=null,u.anchor=null,u.kind=null,u.result=null,w=F=ee=Zue===f||V_t===f,v&&ag(u,!0,-1)&&(de=!0,u.lineIndent>c?me=1:u.lineIndent===c?me=0:u.lineIndent<c&&(me=-1)),me===1)for(;bnr(u)||Enr(u);)ag(u,!0,-1)?(de=!0,ee=w,u.lineIndent>c?me=1:u.lineIndent===c?me=0:u.lineIndent<c&&(me=-1)):ee=!1;if(ee&&(ee=de||x),(me===1||Zue===f)&&(Que===f||U_t===f?en=c:en=c+1,zn=u.position-u.lineStart,me===1?ee&&(u_t(u,zn)||Tnr(u,zn,en))||vnr(u,en)?Te=!0:(F&&Snr(u,en)||hnr(u,en)||ynr(u,en)?Te=!0:xnr(u)?(Te=!0,(u.tag!==null||u.anchor!==null)&&Ro(u,"alias node should not have any properties")):gnr(u,en,Que===f)&&(Te=!0,u.tag===null&&(u.tag="?")),u.anchor!==null&&(u.anchorMap[u.anchor]=u.result)):me===0&&(Te=ee&&u_t(u,zn))),u.tag===null)u.anchor!==null&&(u.anchorMap[u.anchor]=u.result);else if(u.tag==="?"){for(u.result!==null&&u.kind!=="scalar"&&Ro(u,'unacceptable node kind for !<?> tag; it should be "scalar", not "'+u.kind+'"'),ut=0,Ct=u.implicitTypes.length;ut<Ct;ut+=1)if(xr=u.implicitTypes[ut],xr.resolve(u.result)){u.result=xr.construct(u.result),u.tag=xr.tag,u.anchor!==null&&(u.anchorMap[u.anchor]=u.result);break}}else if(u.tag!=="!"){if(ow.call(u.typeMap[u.kind||"fallback"],u.tag))xr=u.typeMap[u.kind||"fallback"][u.tag];else for(xr=null,Kt=u.typeMap.multi[u.kind||"fallback"],ut=0,Ct=Kt.length;ut<Ct;ut+=1)if(u.tag.slice(0,Kt[ut].tag.length)===Kt[ut].tag){xr=Kt[ut];break}xr||Ro(u,"unknown tag !<"+u.tag+">"),u.result!==null&&xr.kind!==u.kind&&Ro(u,"unacceptable node kind for !<"+u.tag+'> tag; it should be "'+xr.kind+'", not "'+u.kind+'"'),xr.resolve(u.result,u.tag)?(u.result=xr.construct(u.result,u.tag),u.anchor!==null&&(u.anchorMap[u.anchor]=u.result)):Ro(u,"cannot resolve a node with !<"+u.tag+"> explicit tag")}return u.listener!==null&&u.listener("close",u),u.tag!==null||u.anchor!==null||Te}function Cnr(u){var c=u.position,f,v,x,w=!1,F;for(u.version=null,u.checkLineBreaks=u.legacy,u.tagMap=Object.create(null),u.anchorMap=Object.create(null);(F=u.input.charCodeAt(u.position))!==0&&(ag(u,!0,-1),F=u.input.charCodeAt(u.position),!(u.lineIndent>0||F!==37));){for(w=!0,F=u.input.charCodeAt(++u.position),f=u.position;F!==0&&!vv(F);)F=u.input.charCodeAt(++u.position);for(v=u.input.slice(f,u.position),x=[],v.length<1&&Ro(u,"directive name must not be less than one character in length");F!==0;){for(;p3(F);)F=u.input.charCodeAt(++u.position);if(F===35){do F=u.input.charCodeAt(++u.position);while(F!==0&&!WC(F));break}if(WC(F))break;for(f=u.position;F!==0&&!vv(F);)F=u.input.charCodeAt(++u.position);x.push(u.input.slice(f,u.position))}F!==0&&Jwe(u),ow.call(c_t,v)?c_t[v](u,v,x):e_e(u,'unknown document directive "'+v+'"')}if(ag(u,!0,-1),u.lineIndent===0&&u.input.charCodeAt(u.position)===45&&u.input.charCodeAt(u.position+1)===45&&u.input.charCodeAt(u.position+2)===45?(u.position+=3,ag(u,!0,-1)):w&&Ro(u,"directives end mark is expected"),u5(u,u.lineIndent-1,Zue,!1,!0),ag(u,!0,-1),u.checkLineBreaks&&lnr.test(u.input.slice(c,u.position))&&e_e(u,"non-ASCII line breaks are interpreted as content"),u.documents.push(u.result),u.position===u.lineStart&&n_e(u)){u.input.charCodeAt(u.position)===46&&(u.position+=3,ag(u,!0,-1));return}if(u.position<u.length-1)Ro(u,"end of the stream or a document separator is expected");else return}function G_t(u,c){u=String(u),c=c||{},u.length!==0&&(u.charCodeAt(u.length-1)!==10&&u.charCodeAt(u.length-1)!==13&&(u+=`
`),u.charCodeAt(0)===65279&&(u=u.slice(1)));var f=new mnr(u,c),v=u.indexOf("\0");for(v!==-1&&(f.position=v,Ro(f,"null byte is not allowed in input")),f.input+="\0";f.input.charCodeAt(f.position)===32;)f.lineIndent+=1,f.position+=1;for(;f.position<f.length-1;)Cnr(f);return f.documents}function Anr(u,c,f){c!==null&&typeof c=="object"&&typeof f>"u"&&(f=c,c=null);var v=G_t(u,f);if(typeof c!="function")return v;for(var x=0,w=v.length;x<w;x+=1)c(v[x])}function knr(u,c){var f=G_t(u,c);if(f.length!==0){if(f.length===1)return f[0];throw new p1("expected a single document in the stream, but found more")}}var Pnr=Anr,Nnr=knr,H_t={loadAll:Pnr,load:Nnr},Y_t=Object.prototype.toString,X_t=Object.prototype.hasOwnProperty,zwe=65279,Dnr=9,XW=10,Inr=13,wnr=32,Onr=33,Rnr=34,Lwe=35,Mnr=37,Lnr=38,Fnr=39,jnr=42,K_t=44,Bnr=45,t_e=58,Unr=61,Vnr=62,Jnr=63,qnr=64,Q_t=91,Z_t=93,znr=96,eft=123,$nr=124,tft=125,_y={};_y[0]="\\0";_y[7]="\\a";_y[8]="\\b";_y[9]="\\t";_y[10]="\\n";_y[11]="\\v";_y[12]="\\f";_y[13]="\\r";_y[27]="\\e";_y[34]='\\"';_y[92]="\\\\";_y[133]="\\N";_y[160]="\\_";_y[8232]="\\L";_y[8233]="\\P";var Wnr=["y","Y","yes","Yes","YES","on","On","ON","n","N","no","No","NO","off","Off","OFF"],Gnr=/^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;function Hnr(u,c){var f,v,x,w,F,ee,me;if(c===null)return{};for(f={},v=Object.keys(c),x=0,w=v.length;x<w;x+=1)F=v[x],ee=String(c[F]),F.slice(0,2)==="!!"&&(F="tag:yaml.org,2002:"+F.slice(2)),me=u.compiledTypeMap.fallback[F],me&&X_t.call(me.styleAliases,ee)&&(ee=me.styleAliases[ee]),f[F]=ee;return f}function Ynr(u){var c,f,v;if(c=u.toString(16).toUpperCase(),u<=255)f="x",v=2;else if(u<=65535)f="u",v=4;else if(u<=4294967295)f="U",v=8;else throw new p1("code point within a string may not be greater than 0xFFFFFFFF");return"\\"+f+Mg.repeat("0",v-c.length)+c}var Xnr=1,KW=2;function Knr(u){this.schema=u.schema||Vwe,this.indent=Math.max(1,u.indent||2),this.noArrayIndent=u.noArrayIndent||!1,this.skipInvalid=u.skipInvalid||!1,this.flowLevel=Mg.isNothing(u.flowLevel)?-1:u.flowLevel,this.styleMap=Hnr(this.schema,u.styles||null),this.sortKeys=u.sortKeys||!1,this.lineWidth=u.lineWidth||80,this.noRefs=u.noRefs||!1,this.noCompatMode=u.noCompatMode||!1,this.condenseFlow=u.condenseFlow||!1,this.quotingType=u.quotingType==='"'?KW:Xnr,this.forceQuotes=u.forceQuotes||!1,this.replacer=typeof u.replacer=="function"?u.replacer:null,this.implicitTypes=this.schema.compiledImplicit,this.explicitTypes=this.schema.compiledExplicit,this.tag=null,this.result="",this.duplicates=[],this.usedDuplicates=null}function __t(u,c){for(var f=Mg.repeat(" ",c),v=0,x=-1,w="",F,ee=u.length;v<ee;)x=u.indexOf(`
`,v),x===-1?(F=u.slice(v),v=ee):(F=u.slice(v,x+1),v=x+1),F.length&&F!==`
`&&(w+=f),w+=F;return w}function Fwe(u,c){return`
`+Mg.repeat(" ",u.indent*c)}function Qnr(u,c){var f,v,x;for(f=0,v=u.implicitTypes.length;f<v;f+=1)if(x=u.implicitTypes[f],x.resolve(c))return!0;return!1}function r_e(u){return u===wnr||u===Dnr}function QW(u){return 32<=u&&u<=126||161<=u&&u<=55295&&u!==8232&&u!==8233||57344<=u&&u<=65533&&u!==zwe||65536<=u&&u<=1114111}function f_t(u){return QW(u)&&u!==zwe&&u!==Inr&&u!==XW}function p_t(u,c,f){var v=f_t(u),x=v&&!r_e(u);return(f?v:v&&u!==K_t&&u!==Q_t&&u!==Z_t&&u!==eft&&u!==tft)&&u!==Lwe&&!(c===t_e&&!x)||f_t(c)&&!r_e(c)&&u===Lwe||c===t_e&&x}function Znr(u){return QW(u)&&u!==zwe&&!r_e(u)&&u!==Bnr&&u!==Jnr&&u!==t_e&&u!==K_t&&u!==Q_t&&u!==Z_t&&u!==eft&&u!==tft&&u!==Lwe&&u!==Lnr&&u!==jnr&&u!==Onr&&u!==$nr&&u!==Unr&&u!==Vnr&&u!==Fnr&&u!==Rnr&&u!==Mnr&&u!==qnr&&u!==znr}function eir(u){return!r_e(u)&&u!==t_e}function HW(u,c){var f=u.charCodeAt(c),v;return f>=55296&&f<=56319&&c+1<u.length&&(v=u.charCodeAt(c+1),v>=56320&&v<=57343)?(f-55296)*1024+v-56320+65536:f}function rft(u){var c=/^\n* /;return c.test(u)}var nft=1,jwe=2,ift=3,sft=4,o5=5;function tir(u,c,f,v,x,w,F,ee){var me,de=0,Te=null,ut=!1,Ct=!1,Kt=v!==-1,xr=-1,en=Znr(HW(u,0))&&eir(HW(u,u.length-1));if(c||F)for(me=0;me<u.length;de>=65536?me+=2:me++){if(de=HW(u,me),!QW(de))return o5;en=en&&p_t(de,Te,ee),Te=de}else{for(me=0;me<u.length;de>=65536?me+=2:me++){if(de=HW(u,me),de===XW)ut=!0,Kt&&(Ct=Ct||me-xr-1>v&&u[xr+1]!==" ",xr=me);else if(!QW(de))return o5;en=en&&p_t(de,Te,ee),Te=de}Ct=Ct||Kt&&me-xr-1>v&&u[xr+1]!==" "}return!ut&&!Ct?en&&!F&&!x(u)?nft:w===KW?o5:jwe:f>9&&rft(u)?o5:F?w===KW?o5:jwe:Ct?sft:ift}function rir(u,c,f,v,x){u.dump=function(){if(c.length===0)return u.quotingType===KW?'""':"''";if(!u.noCompatMode&&(Wnr.indexOf(c)!==-1||Gnr.test(c)))return u.quotingType===KW?'"'+c+'"':"'"+c+"'";var w=u.indent*Math.max(1,f),F=u.lineWidth===-1?-1:Math.max(Math.min(u.lineWidth,40),u.lineWidth-w),ee=v||u.flowLevel>-1&&f>=u.flowLevel;function me(de){return Qnr(u,de)}switch(tir(c,ee,u.indent,F,me,u.quotingType,u.forceQuotes&&!v,x)){case nft:return c;case jwe:return"'"+c.replace(/'/g,"''")+"'";case ift:return"|"+d_t(c,u.indent)+m_t(__t(c,w));case sft:return">"+d_t(c,u.indent)+m_t(__t(nir(c,F),w));case o5:return'"'+iir(c)+'"';default:throw new p1("impossible error: invalid scalar style")}}()}function d_t(u,c){var f=rft(u)?String(c):"",v=u[u.length-1]===`
`,x=v&&(u[u.length-2]===`
`||u===`
`),w=x?"+":v?"":"-";return f+w+`
`}function m_t(u){return u[u.length-1]===`
`?u.slice(0,-1):u}function nir(u,c){for(var f=/(\n+)([^\n]*)/g,v=function(){var de=u.indexOf(`
`);return de=de!==-1?de:u.length,f.lastIndex=de,g_t(u.slice(0,de),c)}(),x=u[0]===`
`||u[0]===" ",w,F;F=f.exec(u);){var ee=F[1],me=F[2];w=me[0]===" ",v+=ee+(!x&&!w&&me!==""?`
`:"")+g_t(me,c),x=w}return v}function g_t(u,c){if(u===""||u[0]===" ")return u;for(var f=/ [^ ]/g,v,x=0,w,F=0,ee=0,me="";v=f.exec(u);)ee=v.index,ee-x>c&&(w=F>x?F:ee,me+=`
`+u.slice(x,w),x=w+1),F=ee;return me+=`
`,u.length-x>c&&F>x?me+=u.slice(x,F)+`
`+u.slice(F+1):me+=u.slice(x),me.slice(1)}function iir(u){for(var c="",f=0,v,x=0;x<u.length;f>=65536?x+=2:x++)f=HW(u,x),v=_y[f],!v&&QW(f)?(c+=u[x],f>=65536&&(c+=u[x+1])):c+=v||Ynr(f);return c}function sir(u,c,f){var v="",x=u.tag,w,F,ee;for(w=0,F=f.length;w<F;w+=1)ee=f[w],u.replacer&&(ee=u.replacer.call(f,String(w),ee)),(kP(u,c,ee,!1,!1)||typeof ee>"u"&&kP(u,c,null,!1,!1))&&(v!==""&&(v+=","+(u.condenseFlow?"":" ")),v+=u.dump);u.tag=x,u.dump="["+v+"]"}function h_t(u,c,f,v){var x="",w=u.tag,F,ee,me;for(F=0,ee=f.length;F<ee;F+=1)me=f[F],u.replacer&&(me=u.replacer.call(f,String(F),me)),(kP(u,c+1,me,!0,!0,!1,!0)||typeof me>"u"&&kP(u,c+1,null,!0,!0,!1,!0))&&((!v||x!=="")&&(x+=Fwe(u,c)),u.dump&&XW===u.dump.charCodeAt(0)?x+="-":x+="- ",x+=u.dump);u.tag=w,u.dump=x||"[]"}function air(u,c,f){var v="",x=u.tag,w=Object.keys(f),F,ee,me,de,Te;for(F=0,ee=w.length;F<ee;F+=1)Te="",v!==""&&(Te+=", "),u.condenseFlow&&(Te+='"'),me=w[F],de=f[me],u.replacer&&(de=u.replacer.call(f,me,de)),kP(u,c,me,!1,!1)&&(u.dump.length>1024&&(Te+="? "),Te+=u.dump+(u.condenseFlow?'"':"")+":"+(u.condenseFlow?"":" "),kP(u,c,de,!1,!1)&&(Te+=u.dump,v+=Te));u.tag=x,u.dump="{"+v+"}"}function oir(u,c,f,v){var x="",w=u.tag,F=Object.keys(f),ee,me,de,Te,ut,Ct;if(u.sortKeys===!0)F.sort();else if(typeof u.sortKeys=="function")F.sort(u.sortKeys);else if(u.sortKeys)throw new p1("sortKeys must be a boolean or a function");for(ee=0,me=F.length;ee<me;ee+=1)Ct="",(!v||x!=="")&&(Ct+=Fwe(u,c)),de=F[ee],Te=f[de],u.replacer&&(Te=u.replacer.call(f,de,Te)),kP(u,c+1,de,!0,!0,!0)&&(ut=u.tag!==null&&u.tag!=="?"||u.dump&&u.dump.length>1024,ut&&(u.dump&&XW===u.dump.charCodeAt(0)?Ct+="?":Ct+="? "),Ct+=u.dump,ut&&(Ct+=Fwe(u,c)),kP(u,c+1,Te,!0,ut)&&(u.dump&&XW===u.dump.charCodeAt(0)?Ct+=":":Ct+=": ",Ct+=u.dump,x+=Ct));u.tag=w,u.dump=x||"{}"}function y_t(u,c,f){var v,x,w,F,ee,me;for(x=f?u.explicitTypes:u.implicitTypes,w=0,F=x.length;w<F;w+=1)if(ee=x[w],(ee.instanceOf||ee.predicate)&&(!ee.instanceOf||typeof c=="object"&&c instanceof ee.instanceOf)&&(!ee.predicate||ee.predicate(c))){if(f?ee.multi&&ee.representName?u.tag=ee.representName(c):u.tag=ee.tag:u.tag="?",ee.represent){if(me=u.styleMap[ee.tag]||ee.defaultStyle,Y_t.call(ee.represent)==="[object Function]")v=ee.represent(c,me);else if(X_t.call(ee.represent,me))v=ee.represent[me](c,me);else throw new p1("!<"+ee.tag+'> tag resolver accepts not "'+me+'" style');u.dump=v}return!0}return!1}function kP(u,c,f,v,x,w,F){u.tag=null,u.dump=f,y_t(u,f,!1)||y_t(u,f,!0);var ee=Y_t.call(u.dump),me=v,de;v&&(v=u.flowLevel<0||u.flowLevel>c);var Te=ee==="[object Object]"||ee==="[object Array]",ut,Ct;if(Te&&(ut=u.duplicates.indexOf(f),Ct=ut!==-1),(u.tag!==null&&u.tag!=="?"||Ct||u.indent!==2&&c>0)&&(x=!1),Ct&&u.usedDuplicates[ut])u.dump="*ref_"+ut;else{if(Te&&Ct&&!u.usedDuplicates[ut]&&(u.usedDuplicates[ut]=!0),ee==="[object Object]")v&&Object.keys(u.dump).length!==0?(oir(u,c,u.dump,x),Ct&&(u.dump="&ref_"+ut+u.dump)):(air(u,c,u.dump),Ct&&(u.dump="&ref_"+ut+" "+u.dump));else if(ee==="[object Array]")v&&u.dump.length!==0?(u.noArrayIndent&&!F&&c>0?h_t(u,c-1,u.dump,x):h_t(u,c,u.dump,x),Ct&&(u.dump="&ref_"+ut+u.dump)):(sir(u,c,u.dump),Ct&&(u.dump="&ref_"+ut+" "+u.dump));else if(ee==="[object String]")u.tag!=="?"&&rir(u,u.dump,c,w,me);else{if(ee==="[object Undefined]")return!1;if(u.skipInvalid)return!1;throw new p1("unacceptable kind of an object to dump "+ee)}u.tag!==null&&u.tag!=="?"&&(de=encodeURI(u.tag[0]==="!"?u.tag.slice(1):u.tag).replace(/!/g,"%21"),u.tag[0]==="!"?de="!"+de:de.slice(0,18)==="tag:yaml.org,2002:"?de="!!"+de.slice(18):de="!<"+de+">",u.dump=de+" "+u.dump)}return!0}function cir(u,c){var f=[],v=[],x,w;for(Bwe(u,f,v),x=0,w=v.length;x<w;x+=1)c.duplicates.push(f[v[x]]);c.usedDuplicates=new Array(w)}function Bwe(u,c,f){var v,x,w;if(u!==null&&typeof u=="object")if(x=c.indexOf(u),x!==-1)f.indexOf(x)===-1&&f.push(x);else if(c.push(u),Array.isArray(u))for(x=0,w=u.length;x<w;x+=1)Bwe(u[x],c,f);else for(v=Object.keys(u),x=0,w=v.length;x<w;x+=1)Bwe(u[v[x]],c,f)}function lir(u,c){c=c||{};var f=new Knr(c);f.noRefs||cir(u,f);var v=u;return f.replacer&&(v=f.replacer.call({"":v},"",v)),kP(f,0,v,!0,!0)?f.dump+`
`:""}var uir=lir,_ir={dump:uir};function $we(u,c){return function(){throw new Error("Function yaml."+u+" is removed in js-yaml 4. Use yaml."+c+" instead, which is now safe by default.")}}var fir=h0,pir=T_t,dir=C_t,mir=D_t,gir=I_t,hir=Vwe,yir=H_t.load,vir=H_t.loadAll,Sir=_ir.dump,Tir=p1,bir={binary:L_t,float:N_t,map:x_t,null:A_t,pairs:j_t,set:B_t,timestamp:R_t,bool:k_t,int:P_t,merge:M_t,omap:F_t,seq:E_t,str:b_t},Eir=$we("safeLoad","load"),xir=$we("safeLoadAll","loadAll"),Cir=$we("safeDump","dump"),Air={Type:fir,Schema:pir,FAILSAFE_SCHEMA:dir,JSON_SCHEMA:mir,CORE_SCHEMA:gir,DEFAULT_SCHEMA:hir,load:yir,loadAll:vir,dump:Sir,YAMLException:Tir,types:bir,safeLoad:Eir,safeLoadAll:xir,safeDump:Cir},aft=Air;async function oft(u){let c;try{c=await kir(u,"utf8")}catch(f){throw new Error(String(f))}return aft.load(c)}var i_e=class extends Error{constructor(c){super("Unknown scope: "+c)}};import*as cft from"path";import*as lft from"url";import*as s_e from"path";var _5=class extends Error{constructor(c,f){super(`${c} is not a subpath of ${f}`)}};var Pir=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},Wwe=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},d3=class extends Kd{async find(c,f,v){if(s_e.relative(f,c).startsWith(".."))throw new _5(c,f);let x=[];for(let F=c;F!==f;F=s_e.resolve(F,".."))x.push(F);x.push(f);let w=await Promise.all(x.map(v));return x.filter((F,ee)=>w[ee]===!0)}};Pir([ku(),Wwe("design:type",Function),Wwe("design:paramtypes",[String,String,Function]),Wwe("design:returntype",Promise)],d3.prototype,"find",null);var a_e=class extends Error{constructor(c){super(`No package data available for directory ${c}`)}};var o_e=new Map;async function GC(u,c,f){f.traceEnter("","getPackageData",[u]);let v=await new d3(f).find(u,c,()=>!0),x;for(let w of v){try{x=await Nir(w,f)}catch(F){f.debug(String(F))}if(x?.name!==void 0&&x?.version!==void 0)break}if(x===void 0)throw new a_e(u);return f.traceExit("","getPackageData",x),x}async function Nir(u,c){if(o_e.has(u))return c.debug("getImmediatePackageData cache hit for "+u),await o_e.get(u);let f=f1("npm pkg get name version",c,{cwd:u}),v=async()=>{let x=await f,[w]=/{[^{]*?}/.exec(x.stdout)??[];if(w===void 0)throw new SyntaxError("Invalid JSON response from package get: "+x.stdout);return JSON.parse(w)};return o_e.set(u,v()),await o_e.get(u)}async function uft(u){let c=cft.dirname(lft.fileURLToPath(import.meta.url));return u.debug("getTelemetryPackageData: Current file directory discovered as: "+c),await GC(c,c,u)}jc();function c_e(u){return Object.entries(u).reduce((c,[f,v])=>v==null?c:{...c,[f]:v},{})}var Dir=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},Gwe=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},PP=class extends Kd{constructor(c,f,v,x){super(x),this.cwd=c,this.root=f,this.config=v,this.metrics={}}capture(c){this.scopeMeter===void 0&&(this.scopeMeter=a5.getInstance().getMeterProvider().getMeter(this.name)),this.metrics[c.name]===void 0&&(this.metrics[c.name]=this.scopeMeter.createCounter(c.name,{valueType:rF.INT})),this.metrics[c.name]?.add(1,{...c_e(c.attributes)})}};Dir([ku(),Gwe("design:type",Function),Gwe("design:paramtypes",[Function]),Gwe("design:returntype",void 0)],PP.prototype,"capture",null);var cw=class extends Error{constructor(c){super(`No configuration defined for ${c} scope`)}};var Tmt=cf(nG(),1);import*as Smt from"path";var S_e=cf(Sv(),1);import{readFile as acr}from"fs/promises";import*as k6e from"path";import{access as scr}from"fs/promises";import*as fw from"path";var icr=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},A6e=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},uG=class extends Kd{async find(c,f,v){let x=(await f1(`git ls-tree --full-tree --name-only -r HEAD ${f}`,this.logger,{cwd:c})).stdout.split(/\r?\n/g).filter(F=>F!==""),w=await Promise.all(x.map(v));return await Promise.all(x.filter((F,ee)=>w[ee]===!0).map(async F=>await this.findAbsolutePath(F,f)))}async findAbsolutePath(c,f){c=fw.normalize(c),f=fw.normalize(f);let v=c.split(fw.sep),x=[];for(;v.length>0&&!f.endsWith(v.join(fw.sep));)x.unshift(v.pop()??"");let w=fw.join(f,...x);try{await scr(w)}catch{throw new _5(c,f)}return w}};icr([ku(),A6e("design:type",Function),A6e("design:paramtypes",[String,String,Function]),A6e("design:returntype",Promise)],uG.prototype,"find",null);async function Ydt(u,c,f,v){f.traceEnter("","getTrackedSourceFiles",[c,v]);let x=new uG(f),w=[];v.includes(k6e.extname(c))?w.push(c):w.push(...await x.find(u,c,me=>v.includes(k6e.extname(me))));let F=w.map(async me=>({fileName:me,async createSourceFile(){return S_e.createSourceFile(me,(await acr(me)).toString(),S_e.ScriptTarget.ES2021,!0)}})),ee=await Promise.all(F);return f.traceExit("","getTrackedSourceFiles",ee.map(me=>me.fileName)),ee}var T_e=class extends Error{constructor(c){super(`No package installation found for ${c}`)}};var b_e=class extends Error{constructor(c,f){super(`No node_modules folders found between ${f} and ${c}`)}};import{access as ocr}from"fs/promises";import*as Xdt from"path";async function Kdt(u){let c;try{await ocr(Xdt.join(u,"node_modules"))}catch(f){c=f}return c===void 0}var E_e=new Map;async function x_e(u,c,f){let v=`${u} ${c}`;if(E_e.has(v)){f.debug("getDependencyTree cache hit for "+v);let F=await E_e.get(v);return f.traceExit("","getDependencyTree",F),F}let x=async()=>{let ee=(await new d3(f).find(u,c,Kdt)).pop();if(ee===void 0)throw new b_e(u,c);let me=await f1("npm ls --all --json",f,{cwd:ee},!1),de=JSON.parse(me.stdout);return f.traceExit("","getDependencyTree inner promise",de),de};return E_e.set(v,x()),await E_e.get(v)}var C_e=new Map;async function Qdt(u,c){if(c.traceEnter("","getDirectoryPrefix",[u]),C_e.has(u)){c.debug("getDirectoryPrefix cache hit for "+u);let x=await C_e.get(u);return c.traceExit("","getDirectoryPrefix",x),x}let f=async()=>(await f1("npm prefix --no-workspaces",c,{cwd:u})).stdout;C_e.set(u,f());let v=await C_e.get(u);return c.traceExit("","getDirectoryPrefix",v),v}var b2=(u,c="Internal Logic Error")=>{if(!u)throw new Error(typeof c=="function"?c():c)};var DP=class{constructor(c,f){this.value=c,this.excluded=f,this.isSimpleStarRec=c==="**",this.isRegexStarRec=c.startsWith("**(")&&c.endsWith(")"),this.isStarRec=this.isSimpleStarRec||this.isRegexStarRec}};var v3=class u{constructor(c,f=null){this.left=f===null,this.link=f===null?new u(c,this):f,this.type=c,this.isStarRec=this.type==="**",this.node=null,this.pointer=null}setPointer(c){this.pointer=c,this.link.pointer=c}setNode(c){this.node=c,this.link.node=c}};var IP=(u,c,f={})=>{throw new Error(Object.entries(f).reduce((v,[x,w])=>`${v}, ${x} ${w}`,`${u}: ${c}`))},Zdt=u=>u.length===1?u[0]:u,ccr=/^[?*+\d]+$/,emt=u=>{let c=[];c.or=!0;let f=!1,v=!1,x=0,w=[],F=me=>{c.excluded===!0&&(b2(v===!1),v=!0),w.push(c),c=[],c.or=me},ee=()=>{let me=w.pop(),de=Zdt(c);me.or===!0&&de.or===!0?me.push(...de):me.push(de),c=me};return F(!1),{setInArray:(me,de)=>{f===me&&IP(f?"Bad Array Start":"Bad Array Terminator",u,{char:de}),f=me},finishElement:(me,de,Te,{finReq:ut=!1,group:Ct=!1}={})=>{if(x===me)Te.includes(u[me-1]||null)||IP(de,u,{char:me}),x+=1;else{ut&&IP(de,u,{char:me});let xr=u.slice(x,me);Ct&&!["**","++"].includes(xr)&&IP("Bad Group Start",u,{char:me}),f&&!(ccr.test(xr)||xr.startsWith("(")&&xr.endsWith(")"))&&IP("Bad Array Selector",u,{selector:xr}),Ct?c.push(new v3(xr)):(c.push(new DP(f?`[${xr}]`:xr,v)),v=!1),x=me+1}},startExclusion:me=>{v!==!1&&IP("Redundant Exclusion",u,{char:me}),v=!0},startGroup:()=>{F(!0),v&&(c.excluded=!0,v=!1),F(!1)},newGroupElement:()=>{ee(),F(!1)},finishGroup:me=>{w.length<2&&IP("Unexpected Group Terminator",u,{char:me}),ee(),ee(),b2(Array.isArray(c));let de=c[c.length-2];de instanceof v3&&de.left===!0&&c.push(de.link)},finalizeResult:()=>(ee(),b2(v===!1),w.length!==0&&IP("Non Terminated Group",u),f&&IP("Non Terminated Array",u),Zdt(c))}};var _G=(u,c,f={})=>{throw new Error(Object.entries(f).reduce((v,[x,w])=>`${v}, ${x} ${w}`,`${u}: ${c}`))},lcr=(u,c)=>{if(u==="")return new DP("",!1);if(Array.isArray(u))return u.length===0?new DP("",!1):u.map((F,ee)=>typeof F=="number"?(c.useArraySelector||_G("Forbidden Array Selector",JSON.stringify(u),{idx:ee}),new DP(`[${F}]`,!1)):new DP(F.replaceAll("\\","\\\\"),!1));let f=emt(u),v=u.length,x=!1,w=0;for(let F=0;F<v;F+=1){let ee=u[F];if(x===!1){if(w===0)switch(ee){case".":f.finishElement(F,"Bad Path Separator",["]","}"]);break;case"[":c.useArraySelector||_G("Forbidden Array Selector",u,{char:F}),f.finishElement(F,"Bad Array Start",[null,"!","{",",","}","]"]),f.setInArray(!0,F);break;case"]":f.finishElement(F,"Bad Array Terminator",["}"]),f.setInArray(!1,F);break;case"{":f.finishElement(F,"Bad Group Start",[null,"!",".","[","{",","],{group:!0}),f.startGroup();break;case",":f.finishElement(F,"Bad Group Separator",["]","}"]),f.newGroupElement();break;case"}":f.finishElement(F,"Bad Group Terminator",["]","}"]),f.finishGroup(F);break;case"!":f.finishElement(F,"Bad Exclusion",[null,".",",","{","["],{finReq:!0}),f.startExclusion(F);break;default:break}switch(ee){case"(":w+=1;break;case")":w===0&&_G("Unexpected Parentheses",u,{char:F}),w-=1;break;default:break}}x=ee==="\\"?!x:!1}return x!==!1&&_G("Dangling Escape",u,{char:v-1}),w!==0&&_G("Unterminated Parentheses",u),f.finishElement(v,"Bad Terminator",["]","}"]),f.finalizeResult()},tmt={parse:lcr};var rmt=(u,c)=>{let f=[u],v=[null],x=[],w=[],F=0,ee=!0;for(;F!==-1;){let me=f[F];Array.isArray(me)?me.or!==!0?(f.splice(F,1,...me),v.splice(F,1,...new Array(me.length).fill(v[F])),v[F]!==null&&(w[v[F]]+=me.length-1)):(x[F]===void 0?(x[F]=0,w[F]=0):w[F]!==0&&(f.splice(F+1,w[F]),v.splice(F+1,w[F]),w[F]=0),x[F]<me.length?(f.splice(F+1,0,me[x[F]]),v.splice(F+1,0,F),x[F]=(x[F]||0)+1,w[F]+=1,ee=!0,F+=1):(x[F]=0,F-=1)):ee===!0?(c("ADD",me),F===f.length-1?(c("FIN",me),ee=!1):F+=1):(c("RM",me),F-=1)}};var nmt=(u,c,f,{onAdd:v,onFin:x})=>{let w=[[[u,null]]],F=!1;rmt(f,(ee,me)=>{if(ee==="RM")me.excluded===!0&&(F=!1),w.length-=2;else if(ee==="ADD"){if(me.excluded===!0){if(F)throw new Error(`Redundant Exclusion: "${c}"`);F=!0}let de=[],Te=w[w.length-2];w[w.length-1].forEach(([ut,Ct])=>v(ut,Ct,me,Te,Kt=>de.push([Kt,ut]))),w.push(me,de)}else w[w.length-1].filter(([de])=>de!==u).forEach(([de,Te])=>x(de,Te,me,F))})};var ucr=/[?!,.*+[\](){}\\]/g,_cr=u=>u.replace(ucr,"\\$&"),fcr=/^\^?[^-/\\^$*+?.()|[\]{}]*\$?$/g,A_e=u=>{if(fcr.test(u)){let c=u.startsWith("^"),f=u.endsWith("$");if(c&&f){let v=u.slice(1,-1);return{test:x=>String(x)===v}}if(c){let v=u.slice(1);return{test:x=>String(x).startsWith(v)}}if(f){let v=u.slice(0,-1);return{test:x=>String(x).endsWith(v)}}return{test:v=>String(v).includes(u)}}try{return new RegExp(u)}catch{throw new Error(`Invalid Regex: "${u}"`)}},P6e=u=>u.reduce((c,f)=>`${c}${typeof f=="number"?`[${f}]`:`${c?".":""}${_cr(f)}`}`,""),N6e=u=>Array.isArray(u)?P6e(u):u;var pcr=["-","/","\\","^","$","*","+","?",".","(",")","|","[","]","{","}"],imt=u=>{let c="",f=!1,v=!0;for(let x=0;x<u.length;x+=1){let w=u[x];!f&&w==="\\"?f=!0:!f&&w==="*"?(v=!1,c+=".*"):!f&&w==="+"?(v=!1,c+=".+"):!f&&w==="?"?(v=!1,c+="."):(pcr.includes(w)&&(v=!1,c+="\\"),c+=w,f=!1)}return v?{test:x=>String(x)===c}:c===".+"?{test:x=>x!==""}:new RegExp(`^${c}$`)},smt=u=>(u.startsWith("**(")||u.startsWith("++("))&&u.endsWith(")")?A_e(u.slice(3,-1)):u.startsWith("[(")&&u.endsWith(")]")?A_e(u.slice(2,-2)):u.startsWith("(")&&u.endsWith(")")?A_e(u.slice(1,-1)):u.startsWith("[")&&u.endsWith("]")?imt(u.slice(1,-1)):imt(u);var T5=class{constructor(c,f){if(f.nodes.push(this),this.value=c,this.ctx=f,this.order=f.counter,this.children=[],this.match=!1,this.matches=!1,this.needles=[],this.leafNeedles=[],this.leafNeedlesExclude=[],this.leafNeedlesMatch=[],this.isArrayTarget=c.startsWith("[")&&c.endsWith("]"),this.isSimpleStarRec=c==="**",this.isSimplePlusRec=c==="++",this.isSimpleRec=this.isSimpleStarRec||this.isSimplePlusRec,this.isRegexStarRec=c.startsWith("**(")&&c.endsWith(")"),this.isRegexPlusRec=c.startsWith("++(")&&c.endsWith(")"),this.isStarRec=this.isSimpleStarRec||this.isRegexStarRec,this.isPlusRec=this.isSimplePlusRec||this.isRegexPlusRec,this.isRec=this.isStarRec||this.isPlusRec,this.isAnyArrayTarget=c==="[*]",this.isAnyObjTarget=c==="*",this.isSimpleRec||this.isAnyObjTarget||this.isAnyArrayTarget)this.regex=null;else{let{regex:v}=f;c in v||(v[c]=smt(c)),this.regex=v[c]}}recMatch(c){return this.isRec?this.isSimpleRec?!0:this.regex.test(c):!1}typeMatch(c,f){return this.isSimpleRec?!0:this.isAnyArrayTarget?f:this.isAnyObjTarget?!f:f!==this.isArrayTarget&&!this.isRec?!1:this.regex.test(c)}add(c){this.children.push(c)}get(c){return this.children.find(({value:f})=>f===c)}markMatches(){this.matches=!0}addNeedle(c){this.needles.includes(c)||this.needles.push(c)}setRoots(c){this.roots=c}finish(c,f,v){this.addNeedle(c),this.leafNeedles.includes(c)||this.leafNeedles.push(c);let x=f?this.leafNeedlesExclude:this.leafNeedlesMatch;x.includes(c)||x.push(c),this.match=!f,this.matches=this.match,this.index=v}};var dcr=(u,c,f,v)=>{nmt(u,c,f,{onAdd:(x,w,F,ee,me)=>{if(x.addNeedle(c),F instanceof v3){F.left===!0?(F.isStarRec&&F.setPointer(x),F.setNode(new T5("*",v)),v.links.push(x,F.node),me(F.node)):(F.target="target"in ee?ee.target:w.get(ee.value),v.links.push(F.target,F.node),F.pointer!==null&&(me(F.pointer),F.setPointer(null)),me(x));return}let de=F.isStarRec&&F.value===ee?.value;if(de&&v.strict)throw new Error(`Redundant Recursion: "${c}"`);if(de)F.target=x;else{let Te=x.get(F.value);Te===void 0&&(Te=new T5(F.value,v),x.add(Te)),me(Te)}F.isStarRec&&me(x)},onFin:(x,w,F,ee)=>{if(v.strict&&F.isSimpleStarRec){let me=w.children.filter(({value:de})=>!["","**"].includes(de));if(me.length!==0)throw new Error(`Needle Target Invalidated: "${me[0].needles[0]}" by "${c}"`)}if(v.strict&&x.leafNeedles.length!==0){let me=N6e(x.leafNeedles[0]),de=N6e(c);throw new Error(`Redundant Needle Target: "${me}" vs "${de}"`)}x.finish(c,ee,v.counter),v.counter+=1}})},mcr=(u,c)=>{let{links:f}=c;for(;f.length!==0;){let x=f.pop(),w=f.pop(),{children:F}=w;w.children=[...x.children.filter(ee=>!F.includes(ee)),...F]}c.useArraySelector===!1&&u.setRoots(u.children.filter(({isStarRec:x,value:w})=>x||w===""));let{nodes:v}=c;for(;v.length!==0;){let x=v.pop(),{children:w}=x;w.reverse(),w.some(({matches:F})=>F)&&x.markMatches()}},amt=(u,c)=>{c.counter=0,c.links=[],c.nodes=[],c.regex=Object.create(null);let f=new T5("*",c);for(let v=0;v<u.length;v+=1){let x=u[v],w=[tmt.parse(x,c)];dcr(f,x,w,c)}return mcr(f,c),f};var D6e=(u,c)=>{let f=[];for(let v=0,x=u.length;v<x;v+=1){let w=u[v][c];for(let F=0,ee=w.length;F<ee;F+=1){let me=w[F];f.includes(me)||f.push(me)}}return f},omt=u=>D6e(u,"leafNeedlesMatch"),cmt=u=>D6e(u,"leafNeedlesExclude"),lmt=u=>D6e(u,"needles"),umt=u=>{let c=-1,f=!1,v=u.length;for(;v--;){let{index:x,match:w}=u[v];x>c&&(c=x,f=w)}return f},I6e=(u,c)=>c?P6e(u):[...u];var _mt=(u,c)=>{if(c.rtn==="context")return{onMatch:()=>{},get:()=>u.context};if(c.rtn==="bool"){let v=!1;return{onMatch:()=>{v=!0},get:()=>v}}if(c.rtn==="count"){let v=0;return{onMatch:()=>{v+=1},get:()=>v}}if(c.rtn==="sum"){let v=0;return{onMatch:({value:x})=>{v+=x},get:()=>v}}let f=[];return{onMatch:typeof c.rtn=="function"?()=>f.push(c.rtn(u)):Array.isArray(c.rtn)?()=>f.push(c.rtn.map(v=>u[v])):()=>f.push(u[c.rtn]),get:()=>c.abort?f[0]:f}};var fmt=(u,c,f)=>{let v={haystack:u,context:f.context};if(f.beforeFn!==void 0){let xr=f.beforeFn(v);xr!==void 0&&(v.haystack=xr)}let x=[!1,[c],null,0],w=[],F=[],ee,me,de,Te,ut=v.haystack,Ct={getKey:(xr=f.joined)=>I6e(w,xr),get key(){return Ct.getKey()},getValue:()=>ut,get value(){return Ct.getValue()},getEntry:(xr=f.joined)=>[I6e(w,xr),ut],get entry(){return Ct.getEntry()},getIsMatch:()=>Te,get isMatch(){return Ct.getIsMatch()},getMatchedBy:()=>omt(de),get matchedBy(){return Ct.getMatchedBy()},getExcludedBy:()=>cmt(de),get excludedBy(){return Ct.getExcludedBy()},getTraversedBy:()=>lmt(de),get traversedBy(){return Ct.getTraversedBy()},getGproperty:()=>w[w.length-2],get gproperty(){return Ct.getGproperty()},getProperty:()=>w[w.length-1],get property(){return Ct.getProperty()},getGparent:()=>F[F.length-2],get gparent(){return Ct.getGparent()},getParent:()=>F[F.length-1],get parent(){return Ct.getParent()},getParents:()=>[...F].reverse(),get parents(){return Ct.getParents()},getIsCircular:()=>F.includes(ut),get isCircular(){return Ct.getIsCircular()},getIsLeaf:()=>!(ut instanceof Object),get isLeaf(){return Ct.getIsLeaf()},getDepth:()=>w.length,get depth(){return Ct.getDepth()},get result(){return Ct.getResult()},context:v.context},Kt=_mt(Ct,f);if(Ct.getResult=()=>Kt.get(),f.useArraySelector||!Array.isArray(v.haystack)){let xr=c.get("");xr!==void 0&&x[1].push(xr)}do{ee=x.pop(),me=x.pop(),de=x.pop(),Te=x.pop();let xr=w.length-ee;for(let zn=0;zn<xr;zn+=1)F.pop(),w.pop();if(xr===-1?(F.push(ut),w.push(me),ut=ut[me]):me!==null?(w[w.length-1]=me,ut=F[F.length-1][me]):ut=v.haystack,Te){(f.filterFn===void 0||f.filterFn(Ct)!==!1)&&(Kt.onMatch(Ct),f.abort&&(x.length=0));continue}if(!de.some(({matches:zn})=>zn))continue;let en=f.useArraySelector===!1&&Array.isArray(ut);if(!en&&umt(de)&&(x.push(!0,de,me,ee),Te=!0),(f.breakFn===void 0||f.breakFn(Ct)!==!0)&&ut instanceof Object){let zn=Array.isArray(ut),yr=zn?ut.map((mr,Da)=>Da).filter(()=>!0):Object.keys(ut);!zn&&f.compareFn&&yr.sort(f.compareFn(Ct)),f.reverse||yr.reverse();for(let mr=0,Da=yr.length;mr<Da;mr+=1){let oa=yr[mr],no=[];if(en)no.push(...de),ee===0&&no.push(...c.roots);else for(let Cf=0,hs=de.length;Cf!==hs;Cf+=1){let Am=de[Cf];Am.recMatch(oa)&&no.push(Am);let{children:v0}=Am,mu=v0.length;for(;mu--;){let Fn=v0[mu];Fn.typeMatch(oa,zn)&&no.push(Fn)}}if(f.orderByNeedles){no.index=Buffer.from(no.map(({order:Am})=>Am).sort());let Cf=x.length-3,hs=Cf-mr*4;for(;Cf!==hs&&Buffer.compare(no.index,x[Cf].index)===1;)Cf-=4;x.splice(Cf+3,0,!1,no,oa,ee+1)}else x.push(!1,no,oa,ee+1)}}}while(x.length!==0);if(v.result=Kt.get(),f.afterFn!==void 0){let xr=f.afterFn(v);xr!==void 0&&(v.result=xr)}return v.result};var E2=(u,c,f)=>{b2(f.includes(typeof u[c]),()=>`Option "${c}" not one of [${f.join(", ")}]`)},pmt=u=>{let c={filterFn:void 0,breakFn:void 0,beforeFn:void 0,afterFn:void 0,compareFn:void 0,reverse:!0,orderByNeedles:!1,abort:!1,rtn:void 0,joined:!1,useArraySelector:!0,strict:!0,...u};return b2(Object.keys(c).length===12,"Unexpected Option provided"),E2(c,"filterFn",["function","undefined"]),E2(c,"breakFn",["function","undefined"]),E2(c,"beforeFn",["function","undefined"]),E2(c,"afterFn",["function","undefined"]),E2(c,"compareFn",["function","undefined"]),E2(c,"reverse",["boolean"]),E2(c,"orderByNeedles",["boolean"]),E2(c,"abort",["boolean"]),b2(typeof c.rtn=="function"&&c.rtn.length===1||[void 0,"context","key","value","entry","property","gproperty","parent","gparent","parents","isMatch","matchedBy","excludedBy","traversedBy","isCircular","isLeaf","depth","bool","count","sum"].includes(c.rtn)||Array.isArray(c.rtn)&&c.rtn.every(f=>["key","value","entry","property","gproperty","parent","gparent","parents","isMatch","matchedBy","excludedBy","traversedBy","isCircular","isLeaf","depth"].includes(f)),'Option "rtn" is malformed'),E2(c,"joined",["boolean"]),E2(c,"useArraySelector",["boolean"]),E2(c,"strict",["boolean"]),c};var dmt=(u,c={})=>{if(b2(Array.isArray(u),'Argument "needles" expected to be Array'),b2(c instanceof Object&&!Array.isArray(c),'Argument "opts" expected to be Object'),u.length===0)return(x,w)=>w===void 0?[]:w;let f=pmt(c),v=amt(u,f);return(x,w)=>fmt(x,v,{context:w,...f,rtn:f.rtn||(w===void 0?"key":"context")})};function b5(u,c,f){return dmt([`**.dependencies.${c}`],{filterFn:f})(u)}function mmt(u,c){let f=b5(u,c,()=>!0).sort((v,x)=>v.length-x.length);return f.length>0?f.filter(v=>v.length===f[0]?.length):[]}var gmt=cf(nG(),1);function hmt(u,c){if(u.name===c.name&&u.version===c.version)return u.path=[],[u];let f=b5(u,c.name,({value:v})=>v.version===c.version);return f.length>0?f.map(v=>({path:v,...(0,gmt.default)(u,v)})):[]}var ymt=cf(nG(),1);function vmt(u,c){if(c.length!==0)return c.length===2?{path:[],...u}:{path:c.slice(0,-2),...(0,ymt.default)(u,c.slice(0,-2))}}async function k_e(u,c,f,v,x){x.traceEnter("","findRelevantSourceFiles",[u,c,f,v]);let w=await Ydt(c,f,x,v),F=await x_e(c,f,x),ee=w.map(async Te=>{let ut=await Qdt(Smt.dirname(Te.fileName),x),Ct=await GC(ut,f,x),Kt=hmt(F,Ct),xr,en;do{for(let zn of Kt){let yr=mmt(zn,u.name);if(yr.length>0){let mr=yr[0]?.length??0;(en===void 0||mr<en)&&(xr=yr.map(Da=>(0,Tmt.default)(zn,Da).version),en=mr)}}Kt=Kt.map(zn=>vmt(F,zn.path)).filter(zn=>zn!==void 0)}while(en===void 0&&Kt.length>0);return xr===void 0?(x.error(new T_e(u.name)),!1):xr.some(zn=>zn===u.version)}),me=await Promise.all(ee),de=w.filter((Te,ut)=>me[ut]);return x.traceExit("","findRelevantSourceFiles",de),de}var bmt=cf(Sv(),1);var P_e=class extends Kd{constructor(c,f,v){super(v),this.accumulator=c,this.nodeHandlerMap=f}handle(c,f){let v=this.nodeHandlerMap[c.kind];v!==void 0&&new v(f,this.logger).handle(c,this.accumulator),bmt.forEachChild(c,x=>{this.handle(x,f)})}};function N_e(u,c,f,v){v.traceEnter("","processFile",[c.fileName]),new P_e(u,f,v).handle(c,c),v.traceExit("","processFile",void 0)}function D_e(u,c){u.imports=u.imports.filter(f=>f.path===c||f.path.startsWith(`${c}/`))}var I_e=class{findMatch(c,f){return c.accessPath.length>=2?f.find(v=>v.isAll&&v.name===c.accessPath[0]):void 0}};var w_e=class{findMatch(c,f){return f.find(v=>!v.isDefault&&!v.isAll&&v.rename===void 0&&v.name===c.accessPath[0])}};var O_e=class{findMatch(c,f){return f.find(v=>v.rename!==void 0&&v.rename===c.accessPath[0])}};var E5=class{constructor(){this.imports=[]}};var R_e=class extends E5{constructor(){super(),this.tokens=[],this.functions=[],this.functionImports=new Map,this.tokenImports=new Map}};var P5=cf(Sv(),1);var Emt=cf(Sv(),1);var XC=class{};var M_e=class extends XC{parse(c,f){let v=[];return c.namedBindings?.kind===Emt.SyntaxKind.NamespaceImport&&v.push({name:c.namedBindings.name.escapedText.toString(),path:f,isDefault:!1,isAll:!0}),v}};var Cmt=cf(Sv(),1);var w6e="[Default]",xmt="default";var L_e=class extends XC{parse(c,f){let v=[];return c.namedBindings?.kind===Cmt.SyntaxKind.NamedImports&&c.namedBindings.elements.forEach(x=>{x.propertyName?.escapedText===xmt&&v.push({name:w6e,path:f,rename:x.name.escapedText.toString(),isDefault:!0,isAll:!1})}),c.name&&v.push({name:w6e,path:f,rename:c.name.escapedText.toString(),isDefault:!0,isAll:!1}),v}};var Amt=cf(Sv(),1);var F_e=class extends XC{parse(c,f){let v=[];return c.namedBindings?.kind===Amt.SyntaxKind.NamedImports&&c.namedBindings.elements.forEach(x=>{x.propertyName||v.push({name:x.name.escapedText.toString(),path:f,isDefault:!1,isAll:!1})}),v}};var kmt=cf(Sv(),1);var j_e=class extends XC{parse(c,f){let v=[];return c.namedBindings?.kind===kmt.SyntaxKind.NamedImports&&c.namedBindings.elements.forEach(x=>{x.propertyName&&x.propertyName.escapedText!=="default"&&v.push({name:x.propertyName.escapedText.toString(),path:f,rename:x.name.escapedText.toString(),isDefault:!1,isAll:!1})}),v}};var Ib=class extends Kd{constructor(c,f){super(f),this.sourceFile=c}};var x5=class extends Ib{handle(c,f){f.imports.push(...this.getData(c))}getData(c){let f=[new M_e,new L_e,new F_e,new j_e],v=[],x=c.importClause,w=c.moduleSpecifier.getText(this.sourceFile).slice(1,-1);return x&&f.forEach(F=>v.push(...F.parse(x,w))),v}};var H_e=cf(Sv(),1);var G_e=cf(Sv(),1);var wb=class{constructor(c){this.complexValue=c}};var QC=cf(Sv(),1);var Qd=class extends Kd{constructor(c,f){super(f),this.sourceFile=c}};var C5=class extends Qd{getData(c){return new wb(this.sourceFile.text.substring(c.pos,c.end).trim())}};var B_e=class extends Qd{getData(c){return!1}};var U_e=class extends Qd{getData(c){if(c.escapedText.toString()!=="undefined")return new C5(this.sourceFile,this.logger).getData(c)}};var A5=class extends Qd{getData(c){return!0}};var V_e=class extends Qd{getData(c){return c.initializer===void 0?new A5(this.sourceFile,this.logger).getData(c):KC(c.initializer.kind,this.sourceFile,this.logger).getData(c.initializer)}};var k5=class extends Error{constructor(c){super("No expression found in attribute "+c)}};var J_e=class extends Qd{getData(c){if(c.expression===void 0)throw new k5(c.getText(this.sourceFile));return KC(c.expression.kind,this.sourceFile,this.logger).getData(c.expression)}};var q_e=class extends Qd{getData(c){return new wb(c.getText(this.sourceFile))}};var z_e=class extends Qd{getData(c){return null}};var $_e=class extends Qd{getData(c){return Number(c.text)}};var W_e=class extends Qd{getData(c){return c.text}};var gcr={[QC.SyntaxKind.StringLiteral]:W_e,[QC.SyntaxKind.FalseKeyword]:B_e,[QC.SyntaxKind.NullKeyword]:z_e,[QC.SyntaxKind.NumericLiteral]:$_e,[QC.SyntaxKind.TrueKeyword]:A5,[QC.SyntaxKind.JsxExpression]:J_e,[QC.SyntaxKind.JsxAttribute]:V_e,[QC.SyntaxKind.JsxSpreadAttribute]:q_e,[QC.SyntaxKind.Identifier]:U_e},KC=(u,c,f)=>{let v=gcr[u]??C5;return new v(c,f)};function fG(u,c,f){return Pmt(u,c,[],!0,f)}function Pmt(u,c,f,v,x){switch(u.kind){case G_e.SyntaxKind.Identifier:return[...f,u.escapedText.toString()];case G_e.SyntaxKind.PropertyAccessExpression:f.push(u.name.escapedText.toString());break;case G_e.SyntaxKind.ElementAccessExpression:{let F=u.argumentExpression,ee=KC(F.kind,c,x).getData(F);ee!=null&&f.push(ee instanceof wb?ee:ee.toString());break}}let w=f;return"expression"in u&&(w=Pmt(u.expression,c,f,!1,x)),v?w.reverse():w}var pG=class extends Ib{handle(c,f){c.parent.kind===H_e.SyntaxKind.ElementAccessExpression&&c.parent.argumentExpression!==c||[H_e.SyntaxKind.PropertyAccessExpression,H_e.SyntaxKind.CallExpression].includes(c.parent.kind)||f.tokens.push(this.getData(c))}getData(c){return{name:c.getText(this.sourceFile),accessPath:fG(c,this.sourceFile,this.logger),startPos:c.pos,endPos:c.end}}};var Y_e=class extends Ib{handle(c,f){let v=this.getData(c);f.functions.push(v)}getData(c){let f=c.arguments.end-c.arguments.pos,v=c.getText(this.sourceFile),x=v.substring(0,v.length-f-1).replace(/\s/g,"");x=x.substring(0,x.length-1);let w={name:x,accessPath:[],arguments:[],startPos:c.pos,endPos:c.end};return w.arguments=c.arguments.map(F=>KC(F.kind,this.sourceFile,this.logger).getData(F)),w.accessPath=fG(c,this.sourceFile,this.logger),w}};var x2=cf(Sv(),1);var X_e=class extends Ib{handle(c,f){c.parent.kind===x2.SyntaxKind.ElementAccessExpression&&c.parent.argumentExpression!==c||[x2.SyntaxKind.JsxOpeningElement,x2.SyntaxKind.JsxSelfClosingElement,x2.SyntaxKind.JsxClosingElement,x2.SyntaxKind.PropertyAccessExpression,x2.SyntaxKind.CallExpression,x2.SyntaxKind.ImportClause,x2.SyntaxKind.ImportDeclaration,x2.SyntaxKind.ImportSpecifier].includes(c.parent.kind)||c.parent.kind===x2.SyntaxKind.VariableDeclaration&&c.parent.name===c||f.tokens.push(this.getData(c))}getData(c){return{name:c.escapedText.toString(),accessPath:[c.escapedText.toString()],startPos:c.pos,endPos:c.end}}};var Nmt={[P5.SyntaxKind.ImportDeclaration]:x5,[P5.SyntaxKind.CallExpression]:Y_e,[P5.SyntaxKind.PropertyAccessExpression]:pG,[P5.SyntaxKind.ElementAccessExpression]:pG,[P5.SyntaxKind.Identifier]:X_e};var K_e=class extends Map{has(c){let f=new dG(typeof c,c);return super.has(kh(f))}get(c){let f=new dG(typeof c,c);return super.get(kh(f))}set(c,f){let v=new dG(typeof c,c);return super.set(kh(v),f)}},dG=class{constructor(c,f){this.type=c,this.val=f}};var O6e=new K_e,hcr=1;function ycr(){return`[redacted${hcr++}]`}var ZC=class{put(c){if(O6e.has(c))return O6e.get(c);let f=ycr();return O6e.set(c,f),f}};function mG(u,c){let f=new ZC;return u.map(v=>typeof v=="string"&&!c.includes(v)||typeof v=="object"&&v!==null&&!c.includes(v)?f.put(v):v)}var Tht=cf(Sht(),1);var f_r=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},Q6e=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},C2=class extends Kd{getPackageDetails(c,f){let[,v,x]=/^(@[^/]+)\/(.+)/.exec(c)??[];if(f!==void 0){let{major:w,minor:F,patch:ee,prerelease:me}=new Tht.SemVer(f);return{owner:v,name:x??c,major:w,minor:F,patch:ee,preRelease:me.length===0?void 0:me}}return{owner:v,name:x??c}}};f_r([ku(),Q6e("design:type",Function),Q6e("design:paramtypes",[String,String]),Q6e("design:returntype",Object)],C2.prototype,"getPackageDetails",null);var eA=class extends Kd{};var cfe=class extends eA{constructor(c,f,v,x,w){super(w),this.name="js.function",this.jsFunction=c,this.matchingImport=f,this.instrumentedPackage=v,this.allowedArgumentStringValues=x.collect.js?.functions?.allowedArgumentStringValues??[]}get attributes(){let c=new C2(this.logger),{owner:f,name:v,major:x,minor:w,patch:F,preRelease:ee}=c.getPackageDetails(this.instrumentedPackage.name,this.instrumentedPackage.version),me=kh(this.jsFunction.name),de=[...this.jsFunction.accessPath];this.matchingImport.rename!==void 0&&(me=me.replace(this.matchingImport.rename,this.matchingImport.name),de[0]=this.matchingImport.name);let Te=new ZC;de.forEach(Ct=>{Ct instanceof wb&&(me=me.replace(kh(Ct.complexValue),Te.put(Ct)))}),this.matchingImport.isAll&&(de[0]=Te.put(this.matchingImport.name),me=me.replace(this.matchingImport.name,Te.put(this.matchingImport.name)));let ut={[p2.FUNCTION_NAME]:me,[p2.FUNCTION_MODULE_SPECIFIER]:this.matchingImport.path,[p2.FUNCTION_ACCESS_PATH]:mG(de,de.filter(Ct=>typeof Ct=="string")).join(" "),[p2.FUNCTION_ARGUMENT_VALUES]:mG(this.jsFunction.arguments,this.allowedArgumentStringValues).map(Ct=>String(Ct)),[xa.INSTRUMENTED_RAW]:this.instrumentedPackage.name,[xa.INSTRUMENTED_OWNER]:f,[xa.INSTRUMENTED_NAME]:v,[xa.INSTRUMENTED_VERSION_RAW]:this.instrumentedPackage.version,[xa.INSTRUMENTED_VERSION_MAJOR]:x?.toString(),[xa.INSTRUMENTED_VERSION_MINOR]:w?.toString(),[xa.INSTRUMENTED_VERSION_PATCH]:F?.toString(),[xa.INSTRUMENTED_VERSION_PRE_RELEASE]:ee?.join(".")};return ut=JC(ut,[xa.INSTRUMENTED_RAW,xa.INSTRUMENTED_OWNER,xa.INSTRUMENTED_NAME,xa.INSTRUMENTED_VERSION_RAW,xa.INSTRUMENTED_VERSION_PRE_RELEASE]),ut}};var lfe=class extends eA{constructor(c,f,v,x){super(x),this.name="js.token",this.jsToken=c,this.matchingImport=f,this.instrumentedPackage=v}get attributes(){let c=new C2(this.logger),{owner:f,name:v,major:x,minor:w,patch:F,preRelease:ee}=c.getPackageDetails(this.instrumentedPackage.name,this.instrumentedPackage.version),me=kh(this.jsToken.name),de=[...this.jsToken.accessPath];this.matchingImport.rename!==void 0&&(me=me.replace(this.matchingImport.rename,this.matchingImport.name),de[0]=this.matchingImport.name);let Te=new ZC;de.forEach(Ct=>{Ct instanceof wb&&(me=me.replace(kh(Ct.complexValue),Te.put(Ct)))}),this.matchingImport.isAll&&(de[0]=Te.put(this.matchingImport.name),me=me.replace(this.matchingImport.name,Te.put(this.matchingImport.name)));let ut={[p2.TOKEN_NAME]:me,[p2.TOKEN_MODULE_SPECIFIER]:this.matchingImport.path,[p2.TOKEN_ACCESS_PATH]:mG(de,de.filter(Ct=>typeof Ct=="string")).join(" "),[xa.INSTRUMENTED_RAW]:this.instrumentedPackage.name,[xa.INSTRUMENTED_OWNER]:f,[xa.INSTRUMENTED_NAME]:v,[xa.INSTRUMENTED_VERSION_RAW]:this.instrumentedPackage.version,[xa.INSTRUMENTED_VERSION_MAJOR]:x?.toString(),[xa.INSTRUMENTED_VERSION_MINOR]:w?.toString(),[xa.INSTRUMENTED_VERSION_PATCH]:F?.toString(),[xa.INSTRUMENTED_VERSION_PRE_RELEASE]:ee?.join(".")};return ut=JC(ut,[xa.INSTRUMENTED_RAW,xa.INSTRUMENTED_OWNER,xa.INSTRUMENTED_NAME,xa.INSTRUMENTED_VERSION_RAW,xa.INSTRUMENTED_VERSION_PRE_RELEASE]),ut}};var bht=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},I5=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},T3=class u extends PP{constructor(){super(...arguments),this.name="js",this.runSync=!1}async run(){let c=this.config.collect[this.name];if(c===void 0||Object.keys(c).length===0)throw new cw(this.name);await this.captureAllMetrics(c)}async captureAllMetrics(c){let f=[new I_e,new w_e,new O_e],v=await GC(this.cwd,this.cwd,this.logger),x=await k_e(v,this.cwd,this.root,u.fileExtensions,this.logger);this.logger.debug("Filtered source files: "+x.map(F=>F.fileName));let w=[];for(let F of x){let ee=this.captureFileMetrics(await F.createSourceFile(),v,f,c);this.runSync?await ee:w.push(ee)}await Promise.allSettled(w)}async captureFileMetrics(c,f,v,x){let w=new R_e;N_e(w,c,Nmt,this.logger),this.deduplicateFunctions(w),this.deduplicateTokens(w),D_e(w,f.name);let F=[];Object.keys(x).forEach(ee=>{switch(ee){case"tokens":F.push(this.captureTokenFileMetrics(w,f,v));break;case"functions":F.push(this.captureFunctionFileMetrics(w,f,v));break}}),await Promise.allSettled(F)}async captureTokenFileMetrics(c,f,v){this.resolveTokenImports(c,v),c.tokens.forEach(x=>{let w=c.tokenImports.get(x);w!==void 0&&this.capture(new lfe(x,w,f,this.logger))})}async captureFunctionFileMetrics(c,f,v){this.resolveFunctionImports(c,v),c.functions.forEach(x=>{let w=c.functionImports.get(x);w!==void 0&&this.capture(new cfe(x,w,f,this.config,this.logger))})}resolveTokenImports(c,f){c.tokens.forEach(v=>{let x=f.map(w=>w.findMatch(v,c.imports)).find(w=>w!==void 0);x!==void 0&&c.tokenImports.set(v,x)})}resolveFunctionImports(c,f){c.functions.forEach(v=>{let x=f.map(w=>w.findMatch(v,c.imports)).find(w=>w!==void 0);x!==void 0&&c.functionImports.set(v,x)})}deduplicateFunctions(c){c.functions=c.functions.filter(f=>!c.functions.some(v=>v.startPos>=f.startPos&&v.endPos<=f.endPos&&v!==f))}deduplicateTokens(c){c.tokens=c.tokens.filter(f=>!c.functions.some(v=>v.startPos>=f.startPos&&v.endPos<=f.endPos))}setRunSync(c){this.runSync=c}};T3.fileExtensions=[".jsx",".mjs",".js",".cjs",".tsx",".mts",".ts",".cts",".mjsx",".cjsx",".mtsx",".ctsx"];bht([ku(),I5("design:type",Function),I5("design:paramtypes",[]),I5("design:returntype",Promise)],T3.prototype,"run",null);bht([ku(),I5("design:type",Function),I5("design:paramtypes",[Object]),I5("design:returntype",Promise)],T3.prototype,"captureAllMetrics",null);var ufe=class{findMatch(c,f){return c.prefix!==void 0?f.find(v=>v.isAll&&v.name===c.prefix):void 0}};var _fe=class{findMatch(c,f){return c.prefix!==void 0?f.find(v=>!v.isDefault&&!v.isAll&&v.name===c.prefix):f.find(v=>!v.isDefault&&!v.isAll&&v.name===c.name)}};var ffe=class{findMatch(c,f){return c.prefix!==void 0?f.find(v=>v.rename===c.prefix):f.find(v=>v.rename===c.name)}};var pfe=class extends E5{constructor(){super(),this.elements=[],this.elementImports=new Map}};var gfe=cf(Sv(),1);var GEr=cf(Sv(),1);var Eht=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},w5=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},pw=class extends Ib{getElementNameAndPrefix(c){let f=c.getText(this.sourceFile).split("."),[v,...x]=f.length===1?[void 0,f]:f;return{name:x.join("."),prefix:v}}getElementAttributes(c){let f=[];return c.properties.forEach(v=>{if(v.name&&"escapedText"in v.name)try{f.push({name:v.name.escapedText.toString(),value:KC(v.kind,this.sourceFile,this.logger).getData(v)})}catch(x){if(x instanceof k5)this.logger.error(x);else throw x}}),f}};Eht([ku({argFormatter:u=>u.getText()}),w5("design:type",Function),w5("design:paramtypes",[Object]),w5("design:returntype",void 0)],pw.prototype,"getElementNameAndPrefix",null);Eht([ku({argFormatter:u=>u.getText()}),w5("design:type",Function),w5("design:paramtypes",[Object]),w5("design:returntype",void 0)],pw.prototype,"getElementAttributes",null);var dfe=class extends pw{handle(c,f){f.elements.push(this.getData(c))}getData(c){let{name:f,prefix:v}=this.getElementNameAndPrefix(c.openingElement.tagName),x=this.getElementAttributes(c.openingElement.attributes);return{name:f,prefix:v,attributes:x}}};var mfe=class extends pw{handle(c,f){f.elements.push(this.getData(c))}getData(c){let{name:f,prefix:v}=this.getElementNameAndPrefix(c.tagName);return{name:f,prefix:v,attributes:this.getElementAttributes(c.attributes)}}};var xht={[gfe.SyntaxKind.ImportDeclaration]:x5,[gfe.SyntaxKind.JsxElement]:dfe,[gfe.SyntaxKind.JsxSelfClosingElement]:mfe};function Cht(u,c,f){let v=new ZC,x=Object.entries(u).map(([w,F])=>{if(!c.includes(w)){let ee=v.put(w),me=v.put(F);return[ee,me]}return typeof F=="string"&&!f.includes(F)?[w,v.put(F)]:typeof F=="object"&&F!==null&&!f.includes(F)?[w,v.put(F)]:[w,F]});return Object.fromEntries(x)}var hfe=class extends eA{constructor(c,f,v,x,w){super(w),this.name="jsx.element",this.jsxElement=c,this.matchingImport=f,this.instrumentedPackage=v,this.allowedAttributeNames=x.collect.jsx?.elements?.allowedAttributeNames??[],this.allowedAttributeStringValues=x.collect.jsx?.elements?.allowedAttributeStringValues??[]}get attributes(){let c=c_e(this.jsxElement.attributes.reduce((ut,Ct)=>({...ut,[Ct.name]:Ct.value}),{})),f=Cht(c,this.allowedAttributeNames,this.allowedAttributeStringValues),v=new C2(this.logger),{owner:x,name:w,major:F,minor:ee,patch:me,preRelease:de}=v.getPackageDetails(this.instrumentedPackage.name,this.instrumentedPackage.version),Te={[UI.NAME]:this.jsxElement.name,[UI.MODULE_SPECIFIER]:this.matchingImport.path,[UI.ATTRIBUTE_NAMES]:Object.keys(f),[UI.ATTRIBUTE_VALUES]:Object.values(f).map(ut=>String(ut)),[xa.INSTRUMENTED_RAW]:this.instrumentedPackage.name,[xa.INSTRUMENTED_OWNER]:x,[xa.INSTRUMENTED_NAME]:w,[xa.INSTRUMENTED_VERSION_RAW]:this.instrumentedPackage.version,[xa.INSTRUMENTED_VERSION_MAJOR]:F?.toString(),[xa.INSTRUMENTED_VERSION_MINOR]:ee?.toString(),[xa.INSTRUMENTED_VERSION_PATCH]:me?.toString(),[xa.INSTRUMENTED_VERSION_PRE_RELEASE]:de?.join(".")};return this.matchingImport.rename!==void 0&&(Te[UI.NAME]=this.jsxElement.name.replace(this.matchingImport.rename,this.matchingImport.name)),Te=JC(Te,[xa.INSTRUMENTED_RAW,xa.INSTRUMENTED_OWNER,xa.INSTRUMENTED_NAME,xa.INSTRUMENTED_VERSION_RAW,xa.INSTRUMENTED_VERSION_PRE_RELEASE]),Te}};var Aht=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},O5=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},b3=class u extends PP{constructor(){super(...arguments),this.name="jsx",this.runSync=!1}async run(){let c=this.config.collect[this.name];if(c===void 0||Object.keys(c).length===0)throw new cw(this.name);let f=[];Object.keys(c).forEach(v=>{switch(v){case"elements":f.push(this.captureAllMetrics());break}}),await Promise.allSettled(f)}async captureAllMetrics(){let c=[new ufe,new _fe,new ffe],f=await GC(this.cwd,this.cwd,this.logger),v=await k_e(f,this.cwd,this.root,u.fileExtensions,this.logger);this.logger.debug("Filtered source files: "+v.map(w=>w.fileName));let x=[];for(let w of v){let F=this.captureFileMetrics(await w.createSourceFile(),f,c);this.runSync?await F:x.push(F)}await Promise.allSettled(x)}async captureFileMetrics(c,f,v){let x=new pfe;N_e(x,c,xht,this.logger),D_e(x,f.name),this.resolveElementImports(x,v),x.elements.forEach(w=>{let F=x.elementImports.get(w);F!==void 0&&this.capture(new hfe(w,F,f,this.config,this.logger))})}resolveElementImports(c,f){c.elements.forEach(v=>{let x=f.map(w=>w.findMatch(v,c.imports)).find(w=>w!==void 0);x!==void 0&&c.elementImports.set(v,x)})}setRunSync(c){this.runSync=c}};b3.fileExtensions=[".js",".mjs",".cjs",".jsx",".tsx",".mjsx",".cjsx",".mtsx",".ctsx"];Aht([ku(),O5("design:type",Function),O5("design:paramtypes",[]),O5("design:returntype",Promise)],b3.prototype,"run",null);Aht([ku(),O5("design:type",Function),O5("design:paramtypes",[]),O5("design:returntype",Promise)],b3.prototype,"captureAllMetrics",null);var kht=cf(nG(),1);var yfe=class extends Error{};function Pht(u,c){let f=c.length===0?u:(0,kht.default)(u,c);if(f===void 0)throw new yfe;return f.name===void 0&&(f.name=c[c.length-1]),{name:f.name,version:f.version,dependencies:Object.entries(f.dependencies).map(([v,x])=>({name:v,version:x.version}))}}function Nht(u,c,f,v){v.traceEnter("","findInstallersFromTree",[u,c,f]);let x=[],w=b5(u,c,f);return w.length>=1&&(x=w.map(F=>Pht(u,F.slice(0,-2)))),v.traceExit("","findInstallersFromTree",x),x}async function Dht(u,c,f,v,x){x.traceEnter("","findInstallingPackages",[f,v,u,c]);let w=await x_e(u,c,x),F=Nht(w,f,v,x);return x.traceExit("","findInstallingPackages",F),F}var vfe=class extends eA{constructor(c,f,v){super(v),this.name="npm.dependency",this.data=c,this.instrumentedPackage=f}get attributes(){let c=new C2(this.logger),{owner:f,name:v,major:x,minor:w,patch:F,preRelease:ee}=c.getPackageDetails(this.data.rawName,this.data.rawVersion),{owner:me,name:de,major:Te,minor:ut,patch:Ct,preRelease:Kt}=c.getPackageDetails(this.instrumentedPackage.name,this.instrumentedPackage.version),xr={[xa.RAW]:this.data.rawName,[xa.OWNER]:f,[xa.NAME]:v,[xa.IS_INSTRUMENTED]:this.data.isInstrumented,[xa.VERSION_RAW]:this.data.rawVersion,[xa.VERSION_MAJOR]:x?.toString(),[xa.VERSION_MINOR]:w?.toString(),[xa.VERSION_PATCH]:F?.toString(),[xa.VERSION_PRE_RELEASE]:ee?.join("."),[xa.INSTRUMENTED_RAW]:this.instrumentedPackage.name,[xa.INSTRUMENTED_OWNER]:me,[xa.INSTRUMENTED_NAME]:de,[xa.INSTRUMENTED_VERSION_RAW]:this.instrumentedPackage.version,[xa.INSTRUMENTED_VERSION_MAJOR]:Te?.toString(),[xa.INSTRUMENTED_VERSION_MINOR]:ut?.toString(),[xa.INSTRUMENTED_VERSION_PATCH]:Ct?.toString(),[xa.INSTRUMENTED_VERSION_PRE_RELEASE]:Kt?.join(".")};return JC(xr,[xa.RAW,xa.OWNER,xa.NAME,xa.VERSION_RAW,xa.VERSION_PRE_RELEASE,xa.INSTRUMENTED_RAW,xa.INSTRUMENTED_OWNER,xa.INSTRUMENTED_NAME,xa.INSTRUMENTED_VERSION_RAW,xa.INSTRUMENTED_VERSION_PRE_RELEASE])}};var Iht=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},R5=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},M5=class extends PP{constructor(){super(...arguments),this.name="npm"}async collectDependencies(){let c=await GC(this.cwd,this.cwd,this.logger);(await Dht(this.cwd,this.root,c.name,({value:v})=>v.version===c.version,this.logger)).forEach(v=>{v.dependencies.forEach(x=>{this.capture(new vfe({rawName:x.name,rawVersion:x.version,isInstrumented:x.name===c.name&&x.version===c.version?"true":"false"},c,this.logger))})})}async run(){let c=this.config.collect[this.name];if(c===void 0||Object.keys(c).length===0)throw new cw(this.name);let f=[];Object.keys(c).forEach(v=>{switch(v){case"dependencies":f.push(this.collectDependencies());break}}),await Promise.allSettled(f)}};Iht([ku(),R5("design:type",Function),R5("design:paramtypes",[]),R5("design:returntype",Promise)],M5.prototype,"collectDependencies",null);Iht([ku(),R5("design:type",Function),R5("design:paramtypes",[]),R5("design:returntype",Promise)],M5.prototype,"run",null);var wht={js:T3,jsx:b3,npm:M5};var Z6e=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},OP=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},E3=class{constructor(c,f,v,x){this.configPath=c,this.configSchemaJson=f,this.environment=v,this.logger=x}async run(){if(this.logger.debug("Environment: "+JSON.stringify(this.environment)),!this.environment.isTelemetryEnabled){this.logger.debug("Telemetry disabled via environment variable");return}if(!this.environment.isCI){this.logger.debug("Telemetry disabled because not running in CI");return}let c=new Date().toISOString();this.logger.debug("Date: "+c),this.logger.debug("Schema: "+JSON.stringify(this.configSchemaJson));let f=new zW(this.configSchemaJson,this.logger),v=await oft(this.configPath);this.logger.debug("Config: "+JSON.stringify(v,void 0,2));let x=this.environment.cwd;this.logger.debug("cwd: "+x);let w=await Zut(x,this.logger);this.logger.debug("projectRoot: "+w),f.validate(v);let{repository:F,commitHash:ee,commitTags:me,commitBranches:de}=await new GW(x,this.logger).getGitInfo(),Te=await uft(this.logger),ut=a5.getInstance(!0);ut.setAttributes(JC({[xh.TELEMETRY_EMITTER_NAME]:Te.name,[xh.TELEMETRY_EMITTER_VERSION]:Te.version,[xh.PROJECT_ID]:v.projectId,[xh.ANALYZED_COMMIT]:ee,[xh.ANALYZED_HOST]:F.host,[xh.ANALYZED_OWNER]:F.owner,[xh.ANALYZED_PATH]:`${F.host??""}/${F.owner??""}/${F.repository??""}`,[xh.ANALYZED_REPOSITORY]:F.repository,[xh.ANALYZED_REFS]:[...me,...de],[xh.DATE]:c},[xh.ANALYZED_COMMIT,xh.ANALYZED_HOST,xh.ANALYZED_OWNER,xh.ANALYZED_PATH,xh.ANALYZED_REPOSITORY,xh.ANALYZED_REFS]));let Ct=this.runScopes(x,w,v);await Promise.allSettled(Ct);let Kt=await ut.getMetricReader().collect();this.logger.debug("Collection results:"),this.logger.debug(JSON.stringify(Kt,void 0,2)),this.environment.isExportEnabled&&await this.emitMetrics(Kt.resourceMetrics,v)}runScopes(c,f,v){let x=[];for(let w of Object.keys(v.collect)){let F=wht[w];if(F===void 0)throw new i_e(w);let ee=Reflect.construct(F,[c,f,v,this.logger]);x.push(ee.run().then(()=>{this.logger.debug("Scope succeeded: "+w)}).catch(me=>{this.logger.error("Scope failed: "+w),me instanceof Error?this.logger.error(me):this.logger.error(String(me))}))}return x}async emitMetrics(c,f){if(c.scopeMetrics.length<=0)return;let v=new Oht.OTLPMetricExporter({url:f.endpoint,temporalityPreference:Mht.AggregationTemporality.DELTA,compression:Rht.CompressionAlgorithm.GZIP});return await new Promise(x=>{v.export(c,w=>{this.logger.debug("Metrics exporter finished"),this.logger.debug(kh(w)),x(void 0)})})}};Z6e([ku(),OP("design:type",Function),OP("design:paramtypes",[]),OP("design:returntype",Promise)],E3.prototype,"run",null);Z6e([ku(),OP("design:type",Function),OP("design:paramtypes",[String,String,Object]),OP("design:returntype",void 0)],E3.prototype,"runScopes",null);Z6e([ku(),OP("design:type",Function),OP("design:paramtypes",[Object,Object]),OP("design:returntype",Promise)],E3.prototype,"emitMetrics",null);var Uht=cf(Bht(),1),x3=class{constructor(c){this.isCI=Uht.isCI,this.isExportEnabled=process.env.IBM_TELEMETRY_EXPORT_DISABLED!=="true",this.isTelemetryEnabled=process.env.IBM_TELEMETRY_DISABLED!=="true",this.cwd=process.cwd(),c?.isCI!==void 0&&(this.isCI=c.isCI),c?.isExportEnabled!==void 0&&(this.isExportEnabled=c.isExportEnabled),c?.isTelemetryEnabled!==void 0&&(this.isTelemetryEnabled=c.isTelemetryEnabled),c?.cwd!==void 0&&(this.cwd=c.cwd)}};var L5=function(u,c,f,v){var x=arguments.length,w=x<3?c:v===null?v=Object.getOwnPropertyDescriptor(c,f):v,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(u,c,f,v);else for(var ee=u.length-1;ee>=0;ee--)(F=u[ee])&&(w=(x<3?F(w):x>3?F(c,f,w):F(c,f))||w);return x>3&&w&&Object.defineProperty(c,f,w),w},Ph=function(u,c){if(typeof Reflect=="object"&&typeof Reflect.metadata=="function")return Reflect.metadata(u,c)},d_r=3,m_r=64,tA=class extends Kd{constructor(c,f,v,x){super(x),this.workQueue=[],this.ipcAddr=c,this.workQueue.push({cwd:f.cwd,configFilePath:v})}async run(){let c;for(let f=0;f<d_r&&!c;f++){try{c=await this.createServerSocket(this.handleServerConnection.bind(this))}catch{}if(!c)try{c=await this.createClientSocket()}catch{}}if(!c){this.logger.debug("Could not establish server or client connection. Exiting");return}try{c instanceof rA.Server?await this.doWork(c):await this.sendWorkToConductor(c)}finally{await this.logger.close()}}async createServerSocket(c){return new Promise((f,v)=>{let x=rA.createServer({});x.on("connection",c),x.on("listening",()=>{f(x)}),x.on("error",v),process.on("SIGINT",x.close),process.on("SIGTERM",x.close),x.listen(this.ipcAddr,m_r)})}createClientSocket(){return new Promise((c,f)=>{let v=rA.connect(this.ipcAddr);v.on("connect",()=>c(v)),v.on("error",f)})}handleServerConnection(c){let f="";c.on("data",v=>{f+=v.toString()}),c.on("close",()=>{let v=JSON.parse(f);this.workQueue.push(v)})}sendWorkToConductor(c){return new Promise((f,v)=>{let x=this.workQueue.shift();this.logger.debug("Sending work through IPC: ",JSON.stringify(x)),c.on("close",f),c.on("error",v),c.on("timeout",v),c.write(Buffer.from(JSON.stringify(x))),c.end()})}async doWork(c){for(this.logger.debug("We are the conductor of the choo-choo train. Running all available work in queue");this.workQueue.length>0;){this.logger.debug("Queue length",this.workQueue.length);let f=this.workQueue.shift();if(!f)return;await this.collect(new x3({cwd:f.cwd}),f.configFilePath)}c.close()}async collect(c,f){let v=new E3(f,vXe,c,this.logger);try{await v.run()}catch(x){x instanceof Error?this.logger.error(x):this.logger.error(String(x))}}};L5([ku({argFormatter:()=>"[onConnect]"}),Ph("design:type",Function),Ph("design:paramtypes",[Function]),Ph("design:returntype",Promise)],tA.prototype,"createServerSocket",null);L5([ku(),Ph("design:type",Function),Ph("design:paramtypes",[]),Ph("design:returntype",Promise)],tA.prototype,"createClientSocket",null);L5([ku({argFormatter:()=>"[socket]"}),Ph("design:type",Function),Ph("design:paramtypes",[rA.Socket]),Ph("design:returntype",void 0)],tA.prototype,"handleServerConnection",null);L5([ku({argFormatter:()=>"[socket]"}),Ph("design:type",Function),Ph("design:paramtypes",[rA.Socket]),Ph("design:returntype",void 0)],tA.prototype,"sendWorkToConductor",null);L5([ku({argFormatter:()=>"[server]"}),Ph("design:type",Function),Ph("design:paramtypes",[rA.Server]),Ph("design:returntype",Promise)],tA.prototype,"doWork",null);L5([ku(),Ph("design:type",Function),Ph("design:paramtypes",[x3,String]),Ph("design:returntype",Promise)],tA.prototype,"collect",null);import{tmpdir as g_r}from"os";import{join as h_r}from"path";function Vht(u){let c=Math.round(Math.random()*999999).toString().padStart(6,"0");return h_r(g_r(),`ibmtelemetry-${u.replace(/[:.-]/g,"")}-${c}.log`)}var y_r=Sfe.join(Jht.tmpdir(),"ibmtelemetry-ipc"),{Command:v_r}=Jke;function S_r(){try{new v_r().description("Collect telemetry data for a package.").requiredOption("--config <config-path>","Path to a telemetry configuration file").option("--log <log-path>","Path to temp log file").action(T_r).parseAsync().catch(c=>{console.error(c)})}catch(u){console.error(u)}}async function T_r(u){let c=new Date().toISOString(),f=u.log??Vht(c),v=new s5(f),x=Sfe.resolve(u.config);v.traceEnter("","runBackgroundProcess",[u]);let w=new tA(y_r,new x3,x,v);try{await w.run()}catch(F){F instanceof Error?v.error(F):v.error(String(F))}v.traceExit("","runBackgroundProcess",void 0),await v.close()}S_r();
/*! Bundled license information:

uri-js/dist/es5/uri.all.js:
  (** @license URI.js v4.4.1 (c) 2011 Gary Court. License: http://github.com/garycourt/uri-js *)

reflect-metadata/Reflect.js:
  (*! *****************************************************************************
  Copyright (C) Microsoft. All rights reserved.
  Licensed under the Apache License, Version 2.0 (the "License"); you may not use
  this file except in compliance with the License. You may obtain a copy of the
  License at http://www.apache.org/licenses/LICENSE-2.0
  
  THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
  WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
  MERCHANTABLITY OR NON-INFRINGEMENT.
  
  See the Apache Version 2.0 License for specific language governing permissions
  and limitations under the License.
  ***************************************************************************** *)

typescript/lib/typescript.js:
  (*! *****************************************************************************
  Copyright (c) Microsoft Corporation. All rights reserved.
  Licensed under the Apache License, Version 2.0 (the "License"); you may not use
  this file except in compliance with the License. You may obtain a copy of the
  License at http://www.apache.org/licenses/LICENSE-2.0
  
  THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
  WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
  MERCHANTABLITY OR NON-INFRINGEMENT.
  
  See the Apache Version 2.0 License for specific language governing permissions
  and limitations under the License.
  ***************************************************************************** *)

js-yaml/dist/js-yaml.mjs:
  (*! js-yaml 4.1.0 https://github.com/nodeca/js-yaml @license MIT *)
*/
